%------------------------------------------------------------------------------
% File     : ANA100^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : SUM_RMUL
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : SUM_RMUL_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :    6 (   0 unit;   3 type;   0 defn)
%            Number of atoms       :   35 (   3 equality;  22 variable)
%            Maximal formula depth :   11 (   6 average)
%            Number of connectives :   26 (   0   ~;   0   |;   0   &;  26   @)
%                                         (   0 <=>;   0  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   10 (  10   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    5 (   3   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   13 (   0 sgn;  10   !;   0   ?;   2   ^)
%                                         (  13   :;   1  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_type_type/realax/real',type,(
    'type/realax/real': $tType )).

thf('thf_const_const/realax/real_mul',type,(
    'const/realax/real_mul': 'type/realax/real' > 'type/realax/real' > 'type/realax/real' )).

thf('thf_const_const/iterate/sum',type,(
    'const/iterate/sum': 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > 'type/realax/real' ) > 'type/realax/real' ) )).

thf('thm/iterate/SUM_LMUL_',axiom,(
    ! [A: $tType,A0: A > 'type/realax/real',A1: 'type/realax/real',A2: A > $o] :
      ( ( 'const/iterate/sum' @ A @ A2
        @ ^ [A3: A] :
            ( 'const/realax/real_mul' @ A1 @ ( A0 @ A3 ) ) )
      = ( 'const/realax/real_mul' @ A1 @ ( 'const/iterate/sum' @ A @ A2 @ A0 ) ) ) )).

thf('thm/realax/REAL_MUL_SYM_',axiom,(
    ! [A: 'type/realax/real',A0: 'type/realax/real'] :
      ( ( 'const/realax/real_mul' @ A @ A0 )
      = ( 'const/realax/real_mul' @ A0 @ A ) ) )).

thf('thm/iterate/SUM_RMUL_',conjecture,(
    ! [A: $tType,A0: A > 'type/realax/real',A1: 'type/realax/real',A2: A > $o] :
      ( ( 'const/iterate/sum' @ A @ A2
        @ ^ [A3: A] :
            ( 'const/realax/real_mul' @ ( A0 @ A3 ) @ A1 ) )
      = ( 'const/realax/real_mul' @ ( 'const/iterate/sum' @ A @ A2 @ A0 ) @ A1 ) ) )).

%------------------------------------------------------------------------------
