%------------------------------------------------------------------------------
% File     : ANA121^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : REAL_POLYFUN_EQ_0
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : REAL_POLYFUN_EQ_0_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :   28 (   0 unit;  17 type;   0 defn)
%            Number of atoms       :  186 (  16 equality;  76 variable)
%            Maximal formula depth :   19 (   6 average)
%            Number of connectives :  145 (   2   ~;   0   |;   2   &; 136   @)
%                                         (   0 <=>;   5  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   41 (  41   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   19 (  17   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   47 (   1 sgn;  29   !;   3   ?;   7   ^)
%                                         (  47   :;   8  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_type_type/realax/real',type,(
    'type/realax/real': $tType )).

thf('thf_type_type/nums/num',type,(
    'type/nums/num': $tType )).

thf('thf_const_const/sets/UNIV',type,(
    'const/sets/UNIV': 
      !>[A: $tType] :
        ( A > $o ) )).

thf('thf_const_const/sets/SETSPEC',type,(
    'const/sets/SETSPEC': 
      !>[A: $tType] :
        ( A > $o > A > $o ) )).

thf('thf_const_const/sets/INFINITE',type,(
    'const/sets/INFINITE': 
      !>[A: $tType] :
        ( ( A > $o ) > $o ) )).

thf('thf_const_const/sets/IN',type,(
    'const/sets/IN': 
      !>[A: $tType] :
        ( A > ( A > $o ) > $o ) )).

thf('thf_const_const/sets/GSPEC',type,(
    'const/sets/GSPEC': 
      !>[A: $tType] :
        ( ( A > $o ) > A > $o ) )).

thf('thf_const_const/sets/FINITE',type,(
    'const/sets/FINITE': 
      !>[A: $tType] :
        ( ( A > $o ) > $o ) )).

thf('thf_const_const/sets/CARD',type,(
    'const/sets/CARD': 
      !>[A: $tType] :
        ( ( A > $o ) > 'type/nums/num' ) )).

thf('thf_const_const/realax/real_pow',type,(
    'const/realax/real_pow': 'type/realax/real' > 'type/nums/num' > 'type/realax/real' )).

thf('thf_const_const/realax/real_of_num',type,(
    'const/realax/real_of_num': 'type/nums/num' > 'type/realax/real' )).

thf('thf_const_const/realax/real_mul',type,(
    'const/realax/real_mul': 'type/realax/real' > 'type/realax/real' > 'type/realax/real' )).

thf('thf_const_const/nums/NUMERAL',type,(
    'const/nums/NUMERAL': 'type/nums/num' > 'type/nums/num' )).

thf('thf_const_const/nums/_0',type,(
    'const/nums/_0': 'type/nums/num' )).

thf('thf_const_const/iterate/sum',type,(
    'const/iterate/sum': 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > 'type/realax/real' ) > 'type/realax/real' ) )).

thf('thf_const_const/iterate/..',type,(
    'const/iterate/..': 'type/nums/num' > 'type/nums/num' > 'type/nums/num' > $o )).

thf('thf_const_const/arith/<=',type,(
    'const/arith/<=': 'type/nums/num' > 'type/nums/num' > $o )).

thf('thm/iterate/SUM_0_',axiom,(
    ! [A: $tType,A0: A > $o] :
      ( ( 'const/iterate/sum' @ A @ A0
        @ ^ [A1: A] :
            ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) )
      = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) ) )).

thf('thm/iterate/SUM_EQ_',axiom,(
    ! [A: $tType,A0: A > 'type/realax/real',A1: A > 'type/realax/real',A2: A > $o] :
      ( ! [A3: A] :
          ( ( 'const/sets/IN' @ A @ A3 @ A2 )
         => ( ( A0 @ A3 )
            = ( A1 @ A3 ) ) )
     => ( ( 'const/iterate/sum' @ A @ A2 @ A0 )
        = ( 'const/iterate/sum' @ A @ A2 @ A1 ) ) ) )).

thf('thm/sets/IN_ELIM_THM_1',axiom,(
    ! [A: $tType,A0: A > $o,A1: A] :
      ( ( 'const/sets/IN' @ A @ A1
        @ ( 'const/sets/GSPEC' @ A
          @ ^ [A2: A] :
            ? [A3: A] :
              ( 'const/sets/SETSPEC' @ A @ A2 @ ( A0 @ A3 ) @ A3 ) ) )
      = ( A0 @ A1 ) ) )).

thf('thm/iterate/IN_NUMSEG_',axiom,(
    ! [A: 'type/nums/num',A0: 'type/nums/num',A1: 'type/nums/num'] :
      ( ( 'const/sets/IN' @ 'type/nums/num' @ A1 @ ( 'const/iterate/..' @ A @ A0 ) )
      = ( ( 'const/arith/<=' @ A @ A1 )
        & ( 'const/arith/<=' @ A1 @ A0 ) ) ) )).

thf('thm/calc_int/REAL_MUL_LZERO_',axiom,(
    ! [A: 'type/realax/real'] :
      ( ( 'const/realax/real_mul' @ ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) @ A )
      = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) ) )).

thf('thm/sets/IN_UNIV_',axiom,(
    ! [A: $tType,A0: A] :
      ( 'const/sets/IN' @ A @ A0 @ ( 'const/sets/UNIV' @ A ) ) )).

thf('thm/sets/EXTENSION_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o] :
      ( ( A0 = A1 )
      = ( ! [A2: A] :
            ( ( 'const/sets/IN' @ A @ A2 @ A0 )
            = ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) ) )).

thf('thm/sets/real_INFINITE_',axiom,
    ( 'const/sets/INFINITE' @ 'type/realax/real' @ ( 'const/sets/UNIV' @ 'type/realax/real' ) )).

thf('thm/sets/INFINITE_',axiom,(
    ! [A: $tType,A0: A > $o] :
      ( ( 'const/sets/INFINITE' @ A @ A0 )
      = ( ~ ( 'const/sets/FINITE' @ A @ A0 ) ) ) )).

thf('thm/iterate/REAL_POLYFUN_ROOTBOUND_',axiom,(
    ! [A: 'type/nums/num',A0: 'type/nums/num' > 'type/realax/real'] :
      ( ~ ( ! [A1: 'type/nums/num'] :
              ( ( 'const/sets/IN' @ 'type/nums/num' @ A1 @ ( 'const/iterate/..' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) @ A ) )
             => ( ( A0 @ A1 )
                = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) ) ) )
     => ( ( 'const/sets/FINITE' @ 'type/realax/real'
          @ ( 'const/sets/GSPEC' @ 'type/realax/real'
            @ ^ [A1: 'type/realax/real'] :
              ? [A2: 'type/realax/real'] :
                ( 'const/sets/SETSPEC' @ 'type/realax/real' @ A1
                @ ( ( 'const/iterate/sum' @ 'type/nums/num' @ ( 'const/iterate/..' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) @ A )
                    @ ^ [A3: 'type/nums/num'] :
                        ( 'const/realax/real_mul' @ ( A0 @ A3 ) @ ( 'const/realax/real_pow' @ A2 @ A3 ) ) )
                  = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) )
                @ A2 ) ) )
        & ( 'const/arith/<='
          @ ( 'const/sets/CARD' @ 'type/realax/real'
            @ ( 'const/sets/GSPEC' @ 'type/realax/real'
              @ ^ [A1: 'type/realax/real'] :
                ? [A2: 'type/realax/real'] :
                  ( 'const/sets/SETSPEC' @ 'type/realax/real' @ A1
                  @ ( ( 'const/iterate/sum' @ 'type/nums/num' @ ( 'const/iterate/..' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) @ A )
                      @ ^ [A3: 'type/nums/num'] :
                          ( 'const/realax/real_mul' @ ( A0 @ A3 ) @ ( 'const/realax/real_pow' @ A2 @ A3 ) ) )
                    = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) )
                  @ A2 ) ) )
          @ A ) ) ) )).

thf('thm/iterate/REAL_POLYFUN_EQ_0_',conjecture,(
    ! [A: 'type/nums/num',A0: 'type/nums/num' > 'type/realax/real'] :
      ( ( ! [A1: 'type/realax/real'] :
            ( ( 'const/iterate/sum' @ 'type/nums/num' @ ( 'const/iterate/..' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) @ A )
              @ ^ [A2: 'type/nums/num'] :
                  ( 'const/realax/real_mul' @ ( A0 @ A2 ) @ ( 'const/realax/real_pow' @ A1 @ A2 ) ) )
            = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) ) )
      = ( ! [A1: 'type/nums/num'] :
            ( ( 'const/sets/IN' @ 'type/nums/num' @ A1 @ ( 'const/iterate/..' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) @ A ) )
           => ( ( A0 @ A1 )
              = ( 'const/realax/real_of_num' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) ) ) ) ) ) )).

%------------------------------------------------------------------------------
