%------------------------------------------------------------------------------
% File     : COM153^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Abstract completeness 90
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BPT14] Blanchette et al. (2014), Abstract Completeness
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : abstract_completeness__90.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  350 (   0 unit;  74 type;   0 defn)
%            Number of atoms       : 5373 ( 317 equality;3157 variable)
%            Maximal formula depth :   28 (  11 average)
%            Number of connectives : 5252 (  85   ~;   8   |;  74   &;4840   @)
%                                         (   0 <=>; 245  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  480 ( 480   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   79 (  74   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1336 (   2 sgn;1121   !;  42   ?;  74   ^)
%                                         (1336   :;  99  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:53:23.018
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree,type,(
    abstra2103299360e_tree: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_FSet_Ofset,type,(
    fset: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_tf_state,type,(
    state: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_rule,type,(
    rule: $tType )).

%----Explicit typings (65)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable_Ocountable,type,(
    countable: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OSaturated,type,(
    abstra1209608345urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oenabled,type,(
    abstra1874422341nabled: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oepath,type,(
    abstra523868654_epath: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OpickEff,type,(
    abstra1276541928ickEff: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > ( fset @ State ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Osaturated,type,(
    abstra726722745urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Owf,type,(
    abstra1874736267tem_wf: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Oipath,type,(
    abstra313004635_ipath: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Okonig,type,(
    abstra1918223989_konig: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otfinite,type,(
    abstra668420080finite: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_ONode,type,(
    abstra388494275e_Node: 
      !>[A: $tType] :
        ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > ( abstra2103299360e_tree @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Ocase__tree,type,(
    abstra457966479e_tree: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ) > ( abstra2103299360e_tree @ A ) > B ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Ocont,type,(
    abstra1749095923e_cont: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( fset @ ( abstra2103299360e_tree @ A ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Oroot,type,(
    abstra573067619e_root: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > A ) )).

thf(sy_c_BNF__Def_Ocsquare,type,(
    bNF_csquare: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( set @ A ) > ( B > C ) > ( D > C ) > ( A > B ) > ( A > D ) > $o ) )).

thf(sy_c_BNF__Def_OfstOp,type,(
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > ( product_prod @ A @ C ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Def_Opick__middlep,type,(
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] :
        ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) )).

thf(sy_c_BNF__Def_OsndOp,type,(
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( C > A > $o ) > ( A > B > $o ) > ( product_prod @ C @ B ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_Countable__Set_Ocountable,type,(
    countable_countable: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Countable__Set_Ofrom__nat__into,type,(
    counta609264050t_into: 
      !>[A: $tType] :
        ( ( set @ A ) > nat > A ) )).

thf(sy_c_Countable__Set_Oto__nat__on,type,(
    countable_to_nat_on: 
      !>[A: $tType] :
        ( ( set @ A ) > A > nat ) )).

thf(sy_c_FSet_Ofimage,type,(
    fimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( fset @ A ) > ( fset @ B ) ) )).

thf(sy_c_FSet_Ofmember,type,(
    fmember: 
      !>[A: $tType] :
        ( A > ( fset @ A ) > $o ) )).

thf(sy_c_FSet_Ofset_OFSet_Opred__fset,type,(
    pred_fset: 
      !>[A: $tType] :
        ( ( A > $o ) > ( fset @ A ) > $o ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Ooverride__on,type,(
    override_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Onxt,type,(
    linear1494993505on_nxt: 
      !>[A: $tType,B: $tType] :
        ( ( ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oapfst,type,(
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) )).

thf(sy_c_Product__Type_Oapsnd,type,(
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Osnd,type,(
    product_snd: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > B ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Stream_Osdrop__while,type,(
    sdrop_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osfilter,type,(
    sfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osinterleave,type,(
    sinterleave: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osmap2,type,(
    smap2: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( stream @ A ) > ( stream @ B ) > ( stream @ C ) ) )).

thf(sy_c_Stream_Osmember,type,(
    smember: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Ostream_OSCons,type,(
    sCons: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Ocase__stream,type,(
    case_stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Stream_Ostream_Oshd,type,(
    shd: 
      !>[A: $tType] :
        ( ( stream @ A ) > A ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream_Ostream_Ostl,type,(
    stl: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Oszip,type,(
    szip: 
      !>[A: $tType,B: $tType] :
        ( ( stream @ A ) > ( stream @ B ) > ( stream @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_eff,type,(
    eff: rule > state > ( fset @ state ) > $o )).

thf(sy_v_rules,type,(
    rules: ( stream @ rule ) )).

thf(sy_v_steps,type,(
    steps: ( stream @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_stepsa____,type,(
    stepsa: ( stream @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_t,type,(
    t: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_ta____,type,(
    ta: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) )).

%----Relevant facts (256)
thf(fact_0_local_Oepath_I1_J,axiom,
    ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ ta )).

% local.epath(1)
thf(fact_1_local_Oepath_I2_J,axiom,
    ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ta @ stepsa )).

% local.epath(2)
thf(fact_2_assms_I2_J,axiom,
    ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ t @ steps )).

% assms(2)
thf(fact_3_assms_I1_J,axiom,
    ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ t )).

% assms(1)
thf(fact_4_epath_Ocases,axiom,(
    ! [A2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ A2 )
     => ~ ( ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( sset @ rule @ rules ) )
         => ! [Sl: ( fset @ state )] :
              ( ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ A2 ) ) ) @ Sl )
             => ( ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ A2 ) ) @ Sl )
               => ~ ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ A2 ) ) ) ) ) ) )).

% epath.cases
thf(fact_5_epath_Ocoinduct,axiom,(
    ! [X: ( ( stream @ ( product_prod @ state @ rule ) ) > $o ),X2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( X @ X2 )
     => ( ! [X3: ( stream @ ( product_prod @ state @ rule ) )] :
            ( ( X @ X3 )
           => ? [Steps: ( stream @ ( product_prod @ state @ rule ) ),Sl2: ( fset @ state )] :
                ( ( X3 = Steps )
                & ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ ( sset @ rule @ rules ) )
                & ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) ) ) @ Sl2 )
                & ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ Sl2 )
                & ( ( X @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) )
                  | ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) ) ) ) )
       => ( abstra523868654_epath @ rule @ state @ eff @ rules @ X2 ) ) ) )).

% epath.coinduct
thf(fact_6_epath_Ointros,axiom,(
    ! [Steps2: ( stream @ ( product_prod @ state @ rule ) ),Sl3: ( fset @ state )] :
      ( ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps2 ) ) @ ( sset @ rule @ rules ) )
     => ( ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps2 ) ) ) @ Sl3 )
       => ( ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps2 ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps2 ) ) @ Sl3 )
         => ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps2 ) )
           => ( abstra523868654_epath @ rule @ state @ eff @ rules @ Steps2 ) ) ) ) ) )).

% epath.intros
thf(fact_7_epath_Osimps,axiom,(
    ! [A2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ A2 )
      = ( ? [Steps3: ( stream @ ( product_prod @ state @ rule ) ),Sl4: ( fset @ state )] :
            ( ( A2 = Steps3 )
            & ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps3 ) ) @ ( sset @ rule @ rules ) )
            & ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps3 ) ) ) @ Sl4 )
            & ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps3 ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps3 ) ) @ Sl4 )
            & ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps3 ) ) ) ) ) )).

% epath.simps
thf(fact_8_enabled__def,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
      = ( ^ [P: ( ( fset @ state ) > $o )] :
          ? [X4: ( fset @ state )] :
            ( P @ X4 )
        @ ( eff @ R @ S ) ) ) )).

% enabled_def
thf(fact_9_RuleSystem__Defs_Oepath_Ocases,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),A2: ( stream @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ A2 )
     => ~ ( ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( sset @ Rule @ Rules ) )
         => ! [Sl: ( fset @ State )] :
              ( ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ A2 ) ) ) @ Sl )
             => ( ( Eff @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ A2 ) ) @ Sl )
               => ~ ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ ( stl @ ( product_prod @ State @ Rule ) @ A2 ) ) ) ) ) ) )).

% RuleSystem_Defs.epath.cases
thf(fact_10_RuleSystem__Defs_Oepath_Osimps,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra523868654_epath @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),A3: ( stream @ ( product_prod @ State @ Rule ) )] :
          ? [Steps3: ( stream @ ( product_prod @ State @ Rule ) ),Sl4: ( fset @ State )] :
            ( ( A3 = Steps3 )
            & ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps3 ) ) @ ( sset @ Rule @ Rules2 ) )
            & ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ Steps3 ) ) ) @ Sl4 )
            & ( Eff2 @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps3 ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps3 ) ) @ Sl4 )
            & ( abstra523868654_epath @ Rule @ State @ Eff2 @ Rules2 @ ( stl @ ( product_prod @ State @ Rule ) @ Steps3 ) ) ) ) ) )).

% RuleSystem_Defs.epath.simps
thf(fact_11_RuleSystem__Defs_Oepath_Ointros,axiom,(
    ! [Rule: $tType,State: $tType,Steps2: ( stream @ ( product_prod @ State @ Rule ) ),Rules: ( stream @ Rule ),Sl3: ( fset @ State ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps2 ) ) @ ( sset @ Rule @ Rules ) )
     => ( ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ Steps2 ) ) ) @ Sl3 )
       => ( ( Eff @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps2 ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps2 ) ) @ Sl3 )
         => ( ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ ( stl @ ( product_prod @ State @ Rule ) @ Steps2 ) )
           => ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ Steps2 ) ) ) ) ) )).

% RuleSystem_Defs.epath.intros
thf(fact_12_RuleSystem__Defs_Oepath_Ocoinduct,axiom,(
    ! [Rule: $tType,State: $tType,X: ( ( stream @ ( product_prod @ State @ Rule ) ) > $o ),X2: ( stream @ ( product_prod @ State @ Rule ) ),Rules: ( stream @ Rule ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ( X @ X2 )
     => ( ! [X3: ( stream @ ( product_prod @ State @ Rule ) )] :
            ( ( X @ X3 )
           => ? [Steps: ( stream @ ( product_prod @ State @ Rule ) ),Sl2: ( fset @ State )] :
                ( ( X3 = Steps )
                & ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps ) ) @ ( sset @ Rule @ Rules ) )
                & ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ Steps ) ) ) @ Sl2 )
                & ( Eff @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps ) ) @ Sl2 )
                & ( ( X @ ( stl @ ( product_prod @ State @ Rule ) @ Steps ) )
                  | ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ ( stl @ ( product_prod @ State @ Rule ) @ Steps ) ) ) ) )
       => ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ X2 ) ) ) )).

% RuleSystem_Defs.epath.coinduct
thf(fact_13_Saturated__def,axiom,(
    ! [Steps2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1209608345urated @ rule @ state @ eff @ rules @ Steps2 )
      = ( ! [X5: rule] :
            ( ( member @ rule @ X5 @ ( sset @ rule @ rules ) )
           => ( abstra726722745urated @ rule @ state @ eff @ X5 @ Steps2 ) ) ) ) )).

% Saturated_def
thf(fact_14__C_K_C,axiom,(
    ! [A4: $tType,T2: ( abstra2103299360e_tree @ A4 ),St: ( stream @ A4 )] :
      ( ( abstra313004635_ipath @ A4 @ T2 @ St )
     => ( ( abstra573067619e_root @ A4 @ T2 )
        = ( shd @ A4 @ St ) ) ) )).

% "*"
thf(fact_15_sset__induct,axiom,(
    ! [A: $tType,Y: A,S: ( stream @ A ),P2: ( A > ( stream @ A ) > $o )] :
      ( ( member @ A @ Y @ ( sset @ A @ S ) )
     => ( ! [S2: ( stream @ A )] :
            ( P2 @ ( shd @ A @ S2 ) @ S2 )
       => ( ! [S2: ( stream @ A ),Y2: A] :
              ( ( member @ A @ Y2 @ ( sset @ A @ ( stl @ A @ S2 ) ) )
             => ( ( P2 @ Y2 @ ( stl @ A @ S2 ) )
               => ( P2 @ Y2 @ S2 ) ) )
         => ( P2 @ Y @ S ) ) ) ) )).

% sset_induct
thf(fact_16_NE__R,axiom,(
    ( sset @ rule @ rules )
 != ( bot_bot @ ( set @ rule ) ) )).

% NE_R
thf(fact_17_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream @ A )] :
      ( member @ A @ ( shd @ A @ A2 ) @ ( sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_18_stl__sset,axiom,(
    ! [A: $tType,X2: A,A2: ( stream @ A )] :
      ( ( member @ A @ X2 @ ( sset @ A @ ( stl @ A @ A2 ) ) )
     => ( member @ A @ X2 @ ( sset @ A @ A2 ) ) ) )).

% stl_sset
thf(fact_19_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( ( ( shd @ A @ Stream )
          = ( shd @ A @ Stream2 ) )
        & ( ( stl @ A @ Stream )
          = ( stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_20_stream_Ocoinduct,axiom,(
    ! [A: $tType,R2: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R2 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R2 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( R2 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_21_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R2: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R2 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R2 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( ( R2 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) )
                | ( ( stl @ A @ Stream3 )
                  = ( stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_22_countable__R,axiom,
    ( countable_countable @ rule @ ( sset @ rule @ rules ) )).

% countable_R
thf(fact_23_prod__eqI,axiom,(
    ! [B: $tType,A: $tType,P3: ( product_prod @ A @ B ),Q: ( product_prod @ A @ B )] :
      ( ( ( product_fst @ A @ B @ P3 )
        = ( product_fst @ A @ B @ Q ) )
     => ( ( ( product_snd @ A @ B @ P3 )
          = ( product_snd @ A @ B @ Q ) )
       => ( P3 = Q ) ) ) )).

% prod_eqI
thf(fact_24_exE__realizer_H,axiom,(
    ! [A: $tType,B: $tType,P2: ( A > B > $o ),P3: ( product_prod @ B @ A )] :
      ( ( P2 @ ( product_snd @ B @ A @ P3 ) @ ( product_fst @ B @ A @ P3 ) )
     => ~ ( ! [X3: B,Y2: A] :
              ~ ( P2 @ Y2 @ X3 ) ) ) )).

% exE_realizer'
thf(fact_25_pickEff,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
     => ( eff @ R @ S @ ( abstra1276541928ickEff @ rule @ state @ eff @ R @ S ) ) ) )).

% pickEff
thf(fact_26_RuleSystem__Defs_Oenabled__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1874422341nabled @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),R3: Rule,S3: State] :
            ( ^ [P: ( ( fset @ State ) > $o )] :
              ? [X4: ( fset @ State )] :
                ( P @ X4 )
            @ ( Eff2 @ R3 @ S3 ) ) ) ) )).

% RuleSystem_Defs.enabled_def
thf(fact_27_RuleSystem__Defs_Ocountable__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( countable_countable @ Rule @ ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.countable_R
thf(fact_28_RuleSystem__Defs_ONE__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ Rules )
     != ( bot_bot @ ( set @ Rule ) ) ) )).

% RuleSystem_Defs.NE_R
thf(fact_29_RuleSystem__Defs_OSaturated__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1209608345urated @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),Steps3: ( stream @ ( product_prod @ State @ Rule ) )] :
          ! [X5: Rule] :
            ( ( member @ Rule @ X5 @ ( sset @ Rule @ Rules2 ) )
           => ( abstra726722745urated @ Rule @ State @ Eff2 @ X5 @ Steps3 ) ) ) ) )).

% RuleSystem_Defs.Saturated_def
thf(fact_30_prod__eq__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [Y3: ( product_prod @ A @ B ),Z: ( product_prod @ A @ B )] : ( Y3 = Z ) )
      = ( ^ [S3: ( product_prod @ A @ B ),T3: ( product_prod @ A @ B )] :
            ( ( ( product_fst @ A @ B @ S3 )
              = ( product_fst @ A @ B @ T3 ) )
            & ( ( product_snd @ A @ B @ S3 )
              = ( product_snd @ A @ B @ T3 ) ) ) ) ) )).

% prod_eq_iff
thf(fact_31_prod_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B ),Prod2: ( product_prod @ A @ B )] :
      ( ( ( ( product_fst @ A @ B @ Prod )
          = ( product_fst @ A @ B @ Prod2 ) )
        & ( ( product_snd @ A @ B @ Prod )
          = ( product_snd @ A @ B @ Prod2 ) ) )
     => ( Prod = Prod2 ) ) )).

% prod.expand
thf(fact_32_countable__empty,axiom,(
    ! [A: $tType] :
      ( countable_countable @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% countable_empty
thf(fact_33_countableI__type,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ! [A5: ( set @ A )] :
          ( countable_countable @ A @ A5 ) ) )).

% countableI_type
thf(fact_34_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_35_all__not__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ! [X5: A] :
            ~ ( member @ A @ X5 @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_36_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X5: A] :
            ~ ( P2 @ X5 ) ) ) )).

% Collect_empty_eq
thf(fact_37_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X5: A] :
            ~ ( P2 @ X5 ) ) ) )).

% empty_Collect_eq
thf(fact_38_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X5: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_39_RuleSystem__Defs_OpickEff,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),R: Rule,S: State] :
      ( ( abstra1874422341nabled @ Rule @ State @ Eff @ R @ S )
     => ( Eff @ R @ S @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ R @ S ) ) ) )).

% RuleSystem_Defs.pickEff
thf(fact_40_ipath_Ocoinduct,axiom,(
    ! [A: $tType,X: ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ),X2: ( abstra2103299360e_tree @ A ),Xa: ( stream @ A )] :
      ( ( X @ X2 @ Xa )
     => ( ! [X3: ( abstra2103299360e_tree @ A ),Xa2: ( stream @ A )] :
            ( ( X @ X3 @ Xa2 )
           => ? [T4: ( abstra2103299360e_tree @ A ),Steps: ( stream @ A ),T5: ( abstra2103299360e_tree @ A )] :
                ( ( X3 = T4 )
                & ( Xa2 = Steps )
                & ( ( abstra573067619e_root @ A @ T4 )
                  = ( shd @ A @ Steps ) )
                & ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ T4 ) )
                & ( ( X @ T5 @ ( stl @ A @ Steps ) )
                  | ( abstra313004635_ipath @ A @ T5 @ ( stl @ A @ Steps ) ) ) ) )
       => ( abstra313004635_ipath @ A @ X2 @ Xa ) ) ) )).

% ipath.coinduct
thf(fact_41_ipath_Ointros,axiom,(
    ! [A: $tType,T6: ( abstra2103299360e_tree @ A ),Steps2: ( stream @ A ),T7: ( abstra2103299360e_tree @ A )] :
      ( ( ( abstra573067619e_root @ A @ T6 )
        = ( shd @ A @ Steps2 ) )
     => ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ T6 ) )
       => ( ( abstra313004635_ipath @ A @ T7 @ ( stl @ A @ Steps2 ) )
         => ( abstra313004635_ipath @ A @ T6 @ Steps2 ) ) ) ) )).

% ipath.intros
thf(fact_42_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_43_tree_Oexpand,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A ),Tree2: ( abstra2103299360e_tree @ A )] :
      ( ( ( ( abstra573067619e_root @ A @ Tree )
          = ( abstra573067619e_root @ A @ Tree2 ) )
        & ( ( abstra1749095923e_cont @ A @ Tree )
          = ( abstra1749095923e_cont @ A @ Tree2 ) ) )
     => ( Tree = Tree2 ) ) )).

% tree.expand
thf(fact_44_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X5: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X5: A] :
            ( member @ A @ X5 @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P2 @ X3 )
          = ( Q2 @ X3 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q2 ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_ex__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ? [X5: A] :
            ( member @ A @ X5 @ A5 ) )
      = ( A5
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_50_equals0I,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A5 )
     => ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_51_equals0D,axiom,(
    ! [A: $tType,A5: ( set @ A ),A2: A] :
      ( ( A5
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A5 ) ) )).

% equals0D
thf(fact_52_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_53_ipath_Ocases,axiom,(
    ! [A: $tType,A1: ( abstra2103299360e_tree @ A ),A22: ( stream @ A )] :
      ( ( abstra313004635_ipath @ A @ A1 @ A22 )
     => ~ ( ( ( abstra573067619e_root @ A @ A1 )
            = ( shd @ A @ A22 ) )
         => ! [T8: ( abstra2103299360e_tree @ A )] :
              ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T8 @ ( abstra1749095923e_cont @ A @ A1 ) )
             => ~ ( abstra313004635_ipath @ A @ T8 @ ( stl @ A @ A22 ) ) ) ) ) )).

% ipath.cases
thf(fact_54_ipath_Osimps,axiom,(
    ! [A: $tType] :
      ( ( abstra313004635_ipath @ A )
      = ( ^ [A12: ( abstra2103299360e_tree @ A ),A23: ( stream @ A )] :
          ? [T3: ( abstra2103299360e_tree @ A ),Steps3: ( stream @ A ),T9: ( abstra2103299360e_tree @ A )] :
            ( ( A12 = T3 )
            & ( A23 = Steps3 )
            & ( ( abstra573067619e_root @ A @ T3 )
              = ( shd @ A @ Steps3 ) )
            & ( fmember @ ( abstra2103299360e_tree @ A ) @ T9 @ ( abstra1749095923e_cont @ A @ T3 ) )
            & ( abstra313004635_ipath @ A @ T9 @ ( stl @ A @ Steps3 ) ) ) ) ) )).

% ipath.simps
thf(fact_55_fempty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( fmember @ A @ C2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% fempty_iff
thf(fact_56_all__not__fin__conv,axiom,(
    ! [A: $tType,A5: ( fset @ A )] :
      ( ( ! [X5: A] :
            ~ ( fmember @ A @ X5 @ A5 ) )
      = ( A5
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% all_not_fin_conv
thf(fact_57_wf_Ocases,axiom,(
    ! [A2: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ A2 )
     => ~ ( ( member @ rule @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( sset @ rule @ rules ) )
         => ( ( eff @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( product_fst @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ state @ ( comp @ ( product_prod @ state @ rule ) @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( product_fst @ state @ rule ) @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ A2 ) ) )
           => ~ ( ! [T5: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
                    ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ T5 @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ A2 ) )
                   => ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ T5 ) ) ) ) ) ) )).

% wf.cases
thf(fact_58_wf_Ocoinduct,axiom,(
    ! [X: ( ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) > $o ),X2: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
      ( ( X @ X2 )
     => ( ! [X3: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
            ( ( X @ X3 )
           => ? [T4: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
                ( ( X3 = T4 )
                & ( member @ rule @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T4 ) ) @ ( sset @ rule @ rules ) )
                & ( eff @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T4 ) ) @ ( product_fst @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T4 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ state @ ( comp @ ( product_prod @ state @ rule ) @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( product_fst @ state @ rule ) @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ T4 ) ) )
                & ! [Xa2: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
                    ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ Xa2 @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ T4 ) )
                   => ( ( X @ Xa2 )
                      | ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ Xa2 ) ) ) ) )
       => ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ X2 ) ) ) )).

% wf.coinduct
thf(fact_59_wf_Osimps,axiom,(
    ! [A2: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ A2 )
      = ( ? [T3: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
            ( ( A2 = T3 )
            & ( member @ rule @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T3 ) ) @ ( sset @ rule @ rules ) )
            & ( eff @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T3 ) ) @ ( product_fst @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T3 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ state @ ( comp @ ( product_prod @ state @ rule ) @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( product_fst @ state @ rule ) @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ T3 ) ) )
            & ! [X5: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
                ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ X5 @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ T3 ) )
               => ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ X5 ) ) ) ) ) )).

% wf.simps
thf(fact_60_wf_Owf,axiom,(
    ! [T6: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
      ( ( member @ rule @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T6 ) ) @ ( sset @ rule @ rules ) )
     => ( ( eff @ ( product_snd @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T6 ) ) @ ( product_fst @ state @ rule @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ T6 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ state @ ( comp @ ( product_prod @ state @ rule ) @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( product_fst @ state @ rule ) @ ( abstra573067619e_root @ ( product_prod @ state @ rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ T6 ) ) )
       => ( ! [T8: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
              ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ T8 @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ T6 ) )
             => ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ T8 ) )
         => ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ T6 ) ) ) ) )).

% wf.wf
thf(fact_61_konig_Osimps_I1_J,axiom,(
    ! [A: $tType,T6: ( abstra2103299360e_tree @ A )] :
      ( ( shd @ A @ ( abstra1918223989_konig @ A @ T6 ) )
      = ( abstra573067619e_root @ A @ T6 ) ) )).

% konig.simps(1)
thf(fact_62_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A6: ( set @ A )] :
            ( A6
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_63_fset_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( B > C ),F: ( A > B ),V: ( fset @ A )] :
      ( ( fimage @ B @ C @ G @ ( fimage @ A @ B @ F @ V ) )
      = ( fimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fset.map_comp
thf(fact_64_fimage__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X2: B,A5: ( fset @ B )] :
      ( ( B2
        = ( F @ X2 ) )
     => ( ( fmember @ B @ X2 @ A5 )
       => ( fmember @ A @ B2 @ ( fimage @ B @ A @ F @ A5 ) ) ) ) )).

% fimage_eqI
thf(fact_65_fimage__fempty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( fimage @ B @ A @ F @ ( bot_bot @ ( fset @ B ) ) )
      = ( bot_bot @ ( fset @ A ) ) ) )).

% fimage_fempty
thf(fact_66_fempty__is__fimage,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: ( fset @ B )] :
      ( ( ( bot_bot @ ( fset @ A ) )
        = ( fimage @ B @ A @ F @ A5 ) )
      = ( A5
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fempty_is_fimage
thf(fact_67_fimage__is__fempty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: ( fset @ B )] :
      ( ( ( fimage @ B @ A @ F @ A5 )
        = ( bot_bot @ ( fset @ A ) ) )
      = ( A5
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fimage_is_fempty
thf(fact_68_fimageE,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),A5: ( fset @ B )] :
      ( ( fmember @ A @ B2 @ ( fimage @ B @ A @ F @ A5 ) )
     => ~ ( ! [X3: B] :
              ( ( B2
                = ( F @ X3 ) )
             => ~ ( fmember @ B @ X3 @ A5 ) ) ) ) )).

% fimageE
thf(fact_69_fimageI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( fset @ A ),F: ( A > B )] :
      ( ( fmember @ A @ X2 @ A5 )
     => ( fmember @ B @ ( F @ X2 ) @ ( fimage @ A @ B @ F @ A5 ) ) ) )).

% fimageI
thf(fact_70_fimage__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( fset @ A ),N: ( fset @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( fmember @ A @ X3 @ N )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( fimage @ A @ B @ F @ M )
          = ( fimage @ A @ B @ G @ N ) ) ) ) )).

% fimage_cong
thf(fact_71_rev__fimage__eqI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( fset @ A ),B2: B,F: ( A > B )] :
      ( ( fmember @ A @ X2 @ A5 )
     => ( ( B2
          = ( F @ X2 ) )
       => ( fmember @ B @ B2 @ ( fimage @ A @ B @ F @ A5 ) ) ) ) )).

% rev_fimage_eqI
thf(fact_72_RuleSystem__Defs_Owf_Ocoinduct,axiom,(
    ! [Rule: $tType,State: $tType,X: ( ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) > $o ),X2: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ),Rules: ( stream @ Rule ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ( X @ X2 )
     => ( ! [X3: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
            ( ( X @ X3 )
           => ? [T4: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
                ( ( X3 = T4 )
                & ( member @ Rule @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T4 ) ) @ ( sset @ Rule @ Rules ) )
                & ( Eff @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T4 ) ) @ ( product_fst @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T4 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ State @ ( comp @ ( product_prod @ State @ Rule ) @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( product_fst @ State @ Rule ) @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ T4 ) ) )
                & ! [Xa2: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
                    ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ Xa2 @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ T4 ) )
                   => ( ( X @ Xa2 )
                      | ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ Xa2 ) ) ) ) )
       => ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ X2 ) ) ) )).

% RuleSystem_Defs.wf.coinduct
thf(fact_73_RuleSystem__Defs_Owf_Ointros,axiom,(
    ! [Rule: $tType,State: $tType,T6: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ),Rules: ( stream @ Rule ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ( member @ Rule @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T6 ) ) @ ( sset @ Rule @ Rules ) )
     => ( ( Eff @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T6 ) ) @ ( product_fst @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T6 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ State @ ( comp @ ( product_prod @ State @ Rule ) @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( product_fst @ State @ Rule ) @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ T6 ) ) )
       => ( ! [T8: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
              ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ T8 @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ T6 ) )
             => ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ T8 ) )
         => ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ T6 ) ) ) ) )).

% RuleSystem_Defs.wf.intros
thf(fact_74_RuleSystem__Defs_Owf_Osimps,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1874736267tem_wf @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),A3: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
          ? [T3: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
            ( ( A3 = T3 )
            & ( member @ Rule @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T3 ) ) @ ( sset @ Rule @ Rules2 ) )
            & ( Eff2 @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T3 ) ) @ ( product_fst @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ T3 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ State @ ( comp @ ( product_prod @ State @ Rule ) @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( product_fst @ State @ Rule ) @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ T3 ) ) )
            & ! [X5: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
                ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ X5 @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ T3 ) )
               => ( abstra1874736267tem_wf @ Rule @ State @ Eff2 @ Rules2 @ X5 ) ) ) ) ) )).

% RuleSystem_Defs.wf.simps
thf(fact_75_RuleSystem__Defs_Owf_Ocases,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),A2: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ A2 )
     => ~ ( ( member @ Rule @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( sset @ Rule @ Rules ) )
         => ( ( Eff @ ( product_snd @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( product_fst @ State @ Rule @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( fimage @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ State @ ( comp @ ( product_prod @ State @ Rule ) @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( product_fst @ State @ Rule ) @ ( abstra573067619e_root @ ( product_prod @ State @ Rule ) ) ) @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ A2 ) ) )
           => ~ ( ! [T5: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
                    ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ T5 @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ A2 ) )
                   => ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ T5 ) ) ) ) ) ) )).

% RuleSystem_Defs.wf.cases
thf(fact_76_eqfelem__imp__iff,axiom,(
    ! [A: $tType,X2: A,Y: A,A5: ( fset @ A )] :
      ( ( X2 = Y )
     => ( ( fmember @ A @ X2 @ A5 )
        = ( fmember @ A @ Y @ A5 ) ) ) )).

% eqfelem_imp_iff
thf(fact_77_if__split__fmem2,axiom,(
    ! [A: $tType,A2: A,Q2: $o,X2: ( fset @ A ),Y: ( fset @ A )] :
      ( ( fmember @ A @ A2 @ ( if @ ( fset @ A ) @ Q2 @ X2 @ Y ) )
      = ( ( Q2
         => ( fmember @ A @ A2 @ X2 ) )
        & ( ~ ( Q2 )
         => ( fmember @ A @ A2 @ Y ) ) ) ) )).

% if_split_fmem2
thf(fact_78_if__split__fmem1,axiom,(
    ! [A: $tType,Q2: $o,X2: A,Y: A,B2: ( fset @ A )] :
      ( ( fmember @ A @ ( if @ A @ Q2 @ X2 @ Y ) @ B2 )
      = ( ( Q2
         => ( fmember @ A @ X2 @ B2 ) )
        & ( ~ ( Q2 )
         => ( fmember @ A @ Y @ B2 ) ) ) ) )).

% if_split_fmem1
thf(fact_79_eqfset__imp__iff,axiom,(
    ! [A: $tType,A5: ( fset @ A ),B3: ( fset @ A ),X2: A] :
      ( ( A5 = B3 )
     => ( ( fmember @ A @ X2 @ A5 )
        = ( fmember @ A @ X2 @ B3 ) ) ) )).

% eqfset_imp_iff
thf(fact_80_eq__fmem__trans,axiom,(
    ! [A: $tType,A2: A,B2: A,A5: ( fset @ A )] :
      ( ( A2 = B2 )
     => ( ( fmember @ A @ B2 @ A5 )
       => ( fmember @ A @ A2 @ A5 ) ) ) )).

% eq_fmem_trans
thf(fact_81_fset__choice,axiom,(
    ! [B: $tType,A: $tType,A5: ( fset @ A ),P2: ( A > B > $o )] :
      ( ! [X3: A] :
          ( ( fmember @ A @ X3 @ A5 )
         => ? [X1: B] :
              ( P2 @ X3 @ X1 ) )
     => ? [F2: ( A > B )] :
        ! [X6: A] :
          ( ( fmember @ A @ X6 @ A5 )
         => ( P2 @ X6 @ ( F2 @ X6 ) ) ) ) )).

% fset_choice
thf(fact_82_fequalityCE,axiom,(
    ! [A: $tType,A5: ( fset @ A ),B3: ( fset @ A ),C2: A] :
      ( ( A5 = B3 )
     => ( ( ( fmember @ A @ C2 @ A5 )
         => ~ ( fmember @ A @ C2 @ B3 ) )
       => ~ ( ~ ( fmember @ A @ C2 @ A5 )
           => ( fmember @ A @ C2 @ B3 ) ) ) ) )).

% fequalityCE
thf(fact_83_fset__eqI,axiom,(
    ! [A: $tType,A5: ( fset @ A ),B3: ( fset @ A )] :
      ( ! [X3: A] :
          ( ( fmember @ A @ X3 @ A5 )
          = ( fmember @ A @ X3 @ B3 ) )
     => ( A5 = B3 ) ) )).

% fset_eqI
thf(fact_84_equalsffemptyI,axiom,(
    ! [A: $tType,A5: ( fset @ A )] :
      ( ! [Y2: A] :
          ~ ( fmember @ A @ Y2 @ A5 )
     => ( A5
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% equalsffemptyI
thf(fact_85_equalsffemptyD,axiom,(
    ! [A: $tType,A5: ( fset @ A ),A2: A] :
      ( ( A5
        = ( bot_bot @ ( fset @ A ) ) )
     => ~ ( fmember @ A @ A2 @ A5 ) ) )).

% equalsffemptyD
thf(fact_86_ex__fin__conv,axiom,(
    ! [A: $tType,A5: ( fset @ A )] :
      ( ( ? [X5: A] :
            ( fmember @ A @ X5 @ A5 ) )
      = ( A5
       != ( bot_bot @ ( fset @ A ) ) ) ) )).

% ex_fin_conv
thf(fact_87_femptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( fmember @ A @ A2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% femptyE
thf(fact_88_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F3: ( B > A ),G2: ( C > B ),X5: C] :
            ( F3 @ ( G2 @ X5 ) ) ) ) )).

% comp_apply
thf(fact_89_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P2
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_90_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X5: A] :
            ( member @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_91_Konig,axiom,(
    ! [A: $tType,T6: ( abstra2103299360e_tree @ A )] :
      ( ~ ( abstra668420080finite @ A @ T6 )
     => ( abstra313004635_ipath @ A @ T6 @ ( abstra1918223989_konig @ A @ T6 ) ) ) )).

% Konig
thf(fact_92_snd__swap,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B )] :
      ( ( product_snd @ B @ A @ ( product_swap @ A @ B @ X2 ) )
      = ( product_fst @ A @ B @ X2 ) ) )).

% snd_swap
thf(fact_93_fst__swap,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ B @ A )] :
      ( ( product_fst @ A @ B @ ( product_swap @ B @ A @ X2 ) )
      = ( product_snd @ B @ A @ X2 ) ) )).

% fst_swap
thf(fact_94_tree_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( abstra457966479e_tree @ A @ B )
      = ( ^ [F3: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree3: ( abstra2103299360e_tree @ A )] :
            ( F3 @ ( abstra573067619e_root @ A @ Tree3 ) @ ( abstra1749095923e_cont @ A @ Tree3 ) ) ) ) )).

% tree.case_eq_if
thf(fact_95_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P3: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P3 ) )
      = P3 ) )).

% swap_swap
thf(fact_96_ftree__no__ipath,axiom,(
    ! [A: $tType,T6: ( abstra2103299360e_tree @ A ),Steps2: ( stream @ A )] :
      ( ( abstra668420080finite @ A @ T6 )
     => ~ ( abstra313004635_ipath @ A @ T6 @ Steps2 ) ) )).

% ftree_no_ipath
thf(fact_97_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C2 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_98_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_99_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_100_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_101_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F3: ( B > C ),G2: ( A > B ),X5: A] :
            ( F3 @ ( G2 @ X5 ) ) ) ) )).

% comp_def
thf(fact_102_tfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( abstra2103299360e_tree @ A )] :
      ( ( abstra668420080finite @ A @ A2 )
     => ! [T5: ( abstra2103299360e_tree @ A )] :
          ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ A2 ) )
         => ( abstra668420080finite @ A @ T5 ) ) ) )).

% tfinite.cases
thf(fact_103_tfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( abstra668420080finite @ A )
      = ( ^ [A3: ( abstra2103299360e_tree @ A )] :
          ? [T3: ( abstra2103299360e_tree @ A )] :
            ( ( A3 = T3 )
            & ! [X5: ( abstra2103299360e_tree @ A )] :
                ( ( fmember @ ( abstra2103299360e_tree @ A ) @ X5 @ ( abstra1749095923e_cont @ A @ T3 ) )
               => ( abstra668420080finite @ A @ X5 ) ) ) ) ) )).

% tfinite.simps
thf(fact_104_tfinite_Oinducts,axiom,(
    ! [A: $tType,X2: ( abstra2103299360e_tree @ A ),P2: ( ( abstra2103299360e_tree @ A ) > $o )] :
      ( ( abstra668420080finite @ A @ X2 )
     => ( ! [T10: ( abstra2103299360e_tree @ A )] :
            ( ! [T5: ( abstra2103299360e_tree @ A )] :
                ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ T10 ) )
               => ( abstra668420080finite @ A @ T5 ) )
           => ( ! [T5: ( abstra2103299360e_tree @ A )] :
                  ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ T10 ) )
                 => ( P2 @ T5 ) )
             => ( P2 @ T10 ) ) )
       => ( P2 @ X2 ) ) ) )).

% tfinite.inducts
thf(fact_105_tfinite,axiom,(
    ! [A: $tType,T6: ( abstra2103299360e_tree @ A )] :
      ( ! [T8: ( abstra2103299360e_tree @ A )] :
          ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T8 @ ( abstra1749095923e_cont @ A @ T6 ) )
         => ( abstra668420080finite @ A @ T8 ) )
     => ( abstra668420080finite @ A @ T6 ) ) )).

% tfinite
thf(fact_106_override__on__emptyset,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ( override_on @ A @ B @ F @ G @ ( bot_bot @ ( set @ A ) ) )
      = F ) )).

% override_on_emptyset
thf(fact_107_tree_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree: ( abstra2103299360e_tree @ A )] :
      ( ( P2 @ ( abstra457966479e_tree @ A @ B @ F @ Tree ) )
      = ( ( Tree
          = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) )
       => ( P2 @ ( F @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) ) ) )).

% tree.split_sel
thf(fact_108_tree_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree: ( abstra2103299360e_tree @ A )] :
      ( ( P2 @ ( abstra457966479e_tree @ A @ B @ F @ Tree ) )
      = ( ~ ( ( Tree
              = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) )
            & ~ ( P2 @ ( F @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) ) ) ) )).

% tree.split_sel_asm
thf(fact_109_Stream_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( smember @ A )
      = ( ^ [X5: A,S3: ( stream @ A )] :
            ( member @ A @ X5 @ ( sset @ A @ S3 ) ) ) ) )).

% Stream.smember_def
thf(fact_110_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( case_stream @ A @ B )
      = ( ^ [F3: ( A > ( stream @ A ) > B ),Stream5: ( stream @ A )] :
            ( F3 @ ( shd @ A @ Stream5 ) @ ( stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_111_tree_Oinject,axiom,(
    ! [A: $tType,X12: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) ),Y1: A,Y22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( ( abstra388494275e_Node @ A @ X12 @ X22 )
        = ( abstra388494275e_Node @ A @ Y1 @ Y22 ) )
      = ( ( X12 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% tree.inject
thf(fact_112_override__on__apply__in,axiom,(
    ! [B: $tType,A: $tType,A2: A,A5: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( member @ A @ A2 @ A5 )
     => ( ( override_on @ A @ B @ F @ G @ A5 @ A2 )
        = ( G @ A2 ) ) ) )).

% override_on_apply_in
thf(fact_113_override__on__apply__notin,axiom,(
    ! [B: $tType,A: $tType,A2: A,A5: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ~ ( member @ A @ A2 @ A5 )
     => ( ( override_on @ A @ B @ F @ G @ A5 @ A2 )
        = ( F @ A2 ) ) ) )).

% override_on_apply_notin
thf(fact_114_tree_Ocollapse,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) )
      = Tree ) )).

% tree.collapse
thf(fact_115_override__on__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( override_on @ A @ B )
      = ( ^ [F3: ( A > B ),G2: ( A > B ),A6: ( set @ A ),A3: A] :
            ( if @ B @ ( member @ A @ A3 @ A6 ) @ ( G2 @ A3 ) @ ( F3 @ A3 ) ) ) ) )).

% override_on_def
thf(fact_116_tree_Oexhaust,axiom,(
    ! [A: $tType,Y: ( abstra2103299360e_tree @ A )] :
      ~ ( ! [X13: A,X23: ( fset @ ( abstra2103299360e_tree @ A ) )] :
            ( Y
           != ( abstra388494275e_Node @ A @ X13 @ X23 ) ) ) )).

% tree.exhaust
thf(fact_117_tree_Osel_I1_J,axiom,(
    ! [A: $tType,X12: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra573067619e_root @ A @ ( abstra388494275e_Node @ A @ X12 @ X22 ) )
      = X12 ) )).

% tree.sel(1)
thf(fact_118_tree_Osel_I2_J,axiom,(
    ! [A: $tType,X12: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra1749095923e_cont @ A @ ( abstra388494275e_Node @ A @ X12 @ X22 ) )
      = X22 ) )).

% tree.sel(2)
thf(fact_119_tree_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),X12: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra457966479e_tree @ A @ B @ F @ ( abstra388494275e_Node @ A @ X12 @ X22 ) )
      = ( F @ X12 @ X22 ) ) )).

% tree.case
thf(fact_120_tree_Oexhaust__sel,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( Tree
      = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) )).

% tree.exhaust_sel
thf(fact_121_from__nat__into__inject,axiom,(
    ! [A: $tType,A5: ( set @ A ),B3: ( set @ A )] :
      ( ( A5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( countable_countable @ A @ A5 )
       => ( ( B3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( countable_countable @ A @ B3 )
           => ( ( ( counta609264050t_into @ A @ A5 )
                = ( counta609264050t_into @ A @ B3 ) )
              = ( A5 = B3 ) ) ) ) ) ) )).

% from_nat_into_inject
thf(fact_122_szip_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( stl @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( szip @ A @ B @ ( stl @ A @ S1 ) @ ( stl @ B @ S22 ) ) ) )).

% szip.simps(2)
thf(fact_123_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( sdrop_while @ A )
      = ( ^ [P4: ( A > $o ),S3: ( stream @ A )] :
            ( if @ ( stream @ A ) @ ( P4 @ ( shd @ A @ S3 ) ) @ ( sdrop_while @ A @ P4 @ ( stl @ A @ S3 ) ) @ S3 ) ) ) )).

% sdrop_while.simps
thf(fact_124_stream_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > ( stream @ A ) > B ),Stream: ( stream @ A )] :
      ( ( P2 @ ( case_stream @ A @ B @ F @ Stream ) )
      = ( ~ ( ( Stream
              = ( sCons @ A @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) ) )
            & ~ ( P2 @ ( F @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) ) ) ) ) ) )).

% stream.split_sel_asm
thf(fact_125_stream_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > ( stream @ A ) > B ),Stream: ( stream @ A )] :
      ( ( P2 @ ( case_stream @ A @ B @ F @ Stream ) )
      = ( ( Stream
          = ( sCons @ A @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) ) )
       => ( P2 @ ( F @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) ) ) ) ) )).

% stream.split_sel
thf(fact_126_stream_Oinject,axiom,(
    ! [A: $tType,X12: A,X22: ( stream @ A ),Y1: A,Y22: ( stream @ A )] :
      ( ( ( sCons @ A @ X12 @ X22 )
        = ( sCons @ A @ Y1 @ Y22 ) )
      = ( ( X12 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% stream.inject
thf(fact_127_smember__code,axiom,(
    ! [A: $tType,X2: A,Y: A,S: ( stream @ A )] :
      ( ( smember @ A @ X2 @ ( sCons @ A @ Y @ S ) )
      = ( ( X2 != Y )
       => ( smember @ A @ X2 @ S ) ) ) )).

% smember_code
thf(fact_128_stream_Ocollapse,axiom,(
    ! [A: $tType,Stream: ( stream @ A )] :
      ( ( sCons @ A @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) )
      = Stream ) )).

% stream.collapse
thf(fact_129_stream_Osel_I2_J,axiom,(
    ! [A: $tType,X12: A,X22: ( stream @ A )] :
      ( ( stl @ A @ ( sCons @ A @ X12 @ X22 ) )
      = X22 ) )).

% stream.sel(2)
thf(fact_130_stream_Osel_I1_J,axiom,(
    ! [A: $tType,X12: A,X22: ( stream @ A )] :
      ( ( shd @ A @ ( sCons @ A @ X12 @ X22 ) )
      = X12 ) )).

% stream.sel(1)
thf(fact_131_stream_Oset__induct,axiom,(
    ! [A: $tType,X2: A,A2: ( stream @ A ),P2: ( A > ( stream @ A ) > $o )] :
      ( ( member @ A @ X2 @ ( sset @ A @ A2 ) )
     => ( ! [Z1: A,Z2: ( stream @ A )] :
            ( P2 @ Z1 @ ( sCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( stream @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( sset @ A @ Z2 ) )
             => ( ( P2 @ Xa2 @ Z2 )
               => ( P2 @ Xa2 @ ( sCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P2 @ X2 @ A2 ) ) ) ) )).

% stream.set_induct
thf(fact_132_stream_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( stream @ A )] :
      ( ( member @ A @ E @ ( sset @ A @ A2 ) )
     => ( ! [Z2: ( stream @ A )] :
            ( A2
           != ( sCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( stream @ A )] :
                ( ( A2
                  = ( sCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( sset @ A @ Z2 ) ) ) ) ) ) )).

% stream.set_cases
thf(fact_133_stream_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( stream @ A )] :
      ( member @ A @ A1 @ ( sset @ A @ ( sCons @ A @ A1 @ A22 ) ) ) )).

% stream.set_intros(1)
thf(fact_134_stream_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,A22: ( stream @ A ),A1: A] :
      ( ( member @ A @ X2 @ ( sset @ A @ A22 ) )
     => ( member @ A @ X2 @ ( sset @ A @ ( sCons @ A @ A1 @ A22 ) ) ) ) )).

% stream.set_intros(2)
thf(fact_135_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream @ A )] :
      ~ ( ! [X13: A,X23: ( stream @ A )] :
            ( Y
           != ( sCons @ A @ X13 @ X23 ) ) ) )).

% stream.exhaust
thf(fact_136_sdrop__while__SCons,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A,S: ( stream @ A )] :
      ( ( ( P2 @ A2 )
       => ( ( sdrop_while @ A @ P2 @ ( sCons @ A @ A2 @ S ) )
          = ( sdrop_while @ A @ P2 @ S ) ) )
      & ( ~ ( P2 @ A2 )
       => ( ( sdrop_while @ A @ P2 @ ( sCons @ A @ A2 @ S ) )
          = ( sCons @ A @ A2 @ S ) ) ) ) )).

% sdrop_while_SCons
thf(fact_137_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( stream @ A ) > B ),X12: A,X22: ( stream @ A )] :
      ( ( case_stream @ A @ B @ F @ ( sCons @ A @ X12 @ X22 ) )
      = ( F @ X12 @ X22 ) ) )).

% stream.case
thf(fact_138_from__nat__into,axiom,(
    ! [A: $tType,A5: ( set @ A ),N2: nat] :
      ( ( A5
       != ( bot_bot @ ( set @ A ) ) )
     => ( member @ A @ ( counta609264050t_into @ A @ A5 @ N2 ) @ A5 ) ) )).

% from_nat_into
thf(fact_139_from__nat__into__surj,axiom,(
    ! [A: $tType,A5: ( set @ A ),A2: A] :
      ( ( countable_countable @ A @ A5 )
     => ( ( member @ A @ A2 @ A5 )
       => ? [N3: nat] :
            ( ( counta609264050t_into @ A @ A5 @ N3 )
            = A2 ) ) ) )).

% from_nat_into_surj
thf(fact_140_countable__all,axiom,(
    ! [A: $tType,S4: ( set @ A ),P2: ( A > $o )] :
      ( ( countable_countable @ A @ S4 )
     => ( ( ! [X5: A] :
              ( ( member @ A @ X5 @ S4 )
             => ( P2 @ X5 ) ) )
        = ( ! [N4: nat] :
              ( ( member @ A @ ( counta609264050t_into @ A @ S4 @ N4 ) @ S4 )
             => ( P2 @ ( counta609264050t_into @ A @ S4 @ N4 ) ) ) ) ) ) )).

% countable_all
thf(fact_141_stream_Oexhaust__sel,axiom,(
    ! [A: $tType,Stream: ( stream @ A )] :
      ( Stream
      = ( sCons @ A @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) ) ) )).

% stream.exhaust_sel
thf(fact_142_sfilter_Ocode,axiom,(
    ! [A: $tType] :
      ( ( sfilter @ A )
      = ( ^ [P4: ( A > $o ),S3: ( stream @ A )] :
            ( sCons @ A @ ( shd @ A @ ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P4 ) @ S3 ) ) @ ( sfilter @ A @ P4 @ ( stl @ A @ ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P4 ) @ S3 ) ) ) ) ) ) )).

% sfilter.code
thf(fact_143_sinterleave_Ocode,axiom,(
    ! [A: $tType] :
      ( ( sinterleave @ A )
      = ( ^ [S12: ( stream @ A ),S23: ( stream @ A )] :
            ( sCons @ A @ ( shd @ A @ S12 ) @ ( sinterleave @ A @ S23 @ ( stl @ A @ S12 ) ) ) ) ) )).

% sinterleave.code
thf(fact_144_smap2_Ocode,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( smap2 @ A @ B @ C )
      = ( ^ [F3: ( A > B > C ),S12: ( stream @ A ),S23: ( stream @ B )] :
            ( sCons @ C @ ( F3 @ ( shd @ A @ S12 ) @ ( shd @ B @ S23 ) ) @ ( smap2 @ A @ B @ C @ F3 @ ( stl @ A @ S12 ) @ ( stl @ B @ S23 ) ) ) ) ) )).

% smap2.code
thf(fact_145_from__nat__into__to__nat__on,axiom,(
    ! [A: $tType,A5: ( set @ A ),A2: A] :
      ( ( countable_countable @ A @ A5 )
     => ( ( member @ A @ A2 @ A5 )
       => ( ( counta609264050t_into @ A @ A5 @ ( countable_to_nat_on @ A @ A5 @ A2 ) )
          = A2 ) ) ) )).

% from_nat_into_to_nat_on
thf(fact_146_to__nat__on__inj,axiom,(
    ! [A: $tType,A5: ( set @ A ),A2: A,B2: A] :
      ( ( countable_countable @ A @ A5 )
     => ( ( member @ A @ A2 @ A5 )
       => ( ( member @ A @ B2 @ A5 )
         => ( ( ( countable_to_nat_on @ A @ A5 @ A2 )
              = ( countable_to_nat_on @ A @ A5 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ) )).

% to_nat_on_inj
thf(fact_147_sfilter__Stream,axiom,(
    ! [A: $tType,P2: ( A > $o ),X2: A,S: ( stream @ A )] :
      ( ( ( P2 @ X2 )
       => ( ( sfilter @ A @ P2 @ ( sCons @ A @ X2 @ S ) )
          = ( sCons @ A @ X2 @ ( sfilter @ A @ P2 @ S ) ) ) )
      & ( ~ ( P2 @ X2 )
       => ( ( sfilter @ A @ P2 @ ( sCons @ A @ X2 @ S ) )
          = ( sfilter @ A @ P2 @ S ) ) ) ) )).

% sfilter_Stream
thf(fact_148_smap2_Osimps_I2_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( stl @ C @ ( smap2 @ A @ B @ C @ F @ S1 @ S22 ) )
      = ( smap2 @ A @ B @ C @ F @ ( stl @ A @ S1 ) @ ( stl @ B @ S22 ) ) ) )).

% smap2.simps(2)
thf(fact_149_smap2_Osimps_I1_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( shd @ C @ ( smap2 @ A @ B @ C @ F @ S1 @ S22 ) )
      = ( F @ ( shd @ A @ S1 ) @ ( shd @ B @ S22 ) ) ) )).

% smap2.simps(1)
thf(fact_150_smap2__unfold,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A2: B,S1: ( stream @ B ),B2: C,S22: ( stream @ C )] :
      ( ( smap2 @ B @ C @ A @ F @ ( sCons @ B @ A2 @ S1 ) @ ( sCons @ C @ B2 @ S22 ) )
      = ( sCons @ A @ ( F @ A2 @ B2 ) @ ( smap2 @ B @ C @ A @ F @ S1 @ S22 ) ) ) )).

% smap2_unfold
thf(fact_151_sinterleave_Osimps_I2_J,axiom,(
    ! [A: $tType,S1: ( stream @ A ),S22: ( stream @ A )] :
      ( ( stl @ A @ ( sinterleave @ A @ S1 @ S22 ) )
      = ( sinterleave @ A @ S22 @ ( stl @ A @ S1 ) ) ) )).

% sinterleave.simps(2)
thf(fact_152_sinterleave_Osimps_I1_J,axiom,(
    ! [A: $tType,S1: ( stream @ A ),S22: ( stream @ A )] :
      ( ( shd @ A @ ( sinterleave @ A @ S1 @ S22 ) )
      = ( shd @ A @ S1 ) ) )).

% sinterleave.simps(1)
thf(fact_153_sinterleave__code,axiom,(
    ! [A: $tType,X2: A,S1: ( stream @ A ),S22: ( stream @ A )] :
      ( ( sinterleave @ A @ ( sCons @ A @ X2 @ S1 ) @ S22 )
      = ( sCons @ A @ X2 @ ( sinterleave @ A @ S22 @ S1 ) ) ) )).

% sinterleave_code
thf(fact_154_sfilter_Osimps_I2_J,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ( stl @ A @ ( sfilter @ A @ P2 @ S ) )
      = ( sfilter @ A @ P2 @ ( stl @ A @ ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P2 ) @ S ) ) ) ) )).

% sfilter.simps(2)
thf(fact_155_sfilter_Osimps_I1_J,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ( shd @ A @ ( sfilter @ A @ P2 @ S ) )
      = ( shd @ A @ ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P2 ) @ S ) ) ) )).

% sfilter.simps(1)
thf(fact_156_sfilter__P,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ( P2 @ ( shd @ A @ S ) )
     => ( ( sfilter @ A @ P2 @ S )
        = ( sCons @ A @ ( shd @ A @ S ) @ ( sfilter @ A @ P2 @ ( stl @ A @ S ) ) ) ) ) )).

% sfilter_P
thf(fact_157_sfilter__not__P,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ~ ( P2 @ ( shd @ A @ S ) )
     => ( ( sfilter @ A @ P2 @ S )
        = ( sfilter @ A @ P2 @ ( stl @ A @ S ) ) ) ) )).

% sfilter_not_P
thf(fact_158_to__nat__on__from__nat__into__infinite,axiom,(
    ! [A: $tType,A5: ( set @ A ),N2: nat] :
      ( ( countable_countable @ A @ A5 )
     => ( ~ ( finite_finite2 @ A @ A5 )
       => ( ( countable_to_nat_on @ A @ A5 @ ( counta609264050t_into @ A @ A5 @ N2 ) )
          = N2 ) ) ) )).

% to_nat_on_from_nat_into_infinite
thf(fact_159_from__nat__into__inj__infinite,axiom,(
    ! [A: $tType,A5: ( set @ A ),M2: nat,N2: nat] :
      ( ( countable_countable @ A @ A5 )
     => ( ~ ( finite_finite2 @ A @ A5 )
       => ( ( ( counta609264050t_into @ A @ A5 @ M2 )
            = ( counta609264050t_into @ A @ A5 @ N2 ) )
          = ( M2 = N2 ) ) ) ) )).

% from_nat_into_inj_infinite
thf(fact_160_countable__finite,axiom,(
    ! [A: $tType,S4: ( set @ A )] :
      ( ( finite_finite2 @ A @ S4 )
     => ( countable_countable @ A @ S4 ) ) )).

% countable_finite
thf(fact_161_uncountable__infinite,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ~ ( countable_countable @ A @ A5 )
     => ~ ( finite_finite2 @ A @ A5 ) ) )).

% uncountable_infinite
thf(fact_162_countable__Collect__finite,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ( countable_countable @ ( set @ A ) @ ( collect @ ( set @ A ) @ ( finite_finite2 @ A ) ) ) ) )).

% countable_Collect_finite
thf(fact_163_to__nat__on__surj,axiom,(
    ! [A: $tType,A5: ( set @ A ),N2: nat] :
      ( ( countable_countable @ A @ A5 )
     => ( ~ ( finite_finite2 @ A @ A5 )
       => ? [X3: A] :
            ( ( member @ A @ X3 @ A5 )
            & ( ( countable_to_nat_on @ A @ A5 @ X3 )
              = N2 ) ) ) ) )).

% to_nat_on_surj
thf(fact_164_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S4: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S4 )
     => ( S4
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_165_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_166_nxt_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( linear1494993505on_nxt @ A @ B )
      = ( ^ [Phi: ( ( stream @ A ) > B ),Xs: ( stream @ A )] :
            ( Phi @ ( stl @ A @ Xs ) ) ) ) )).

% nxt.simps
thf(fact_167_nxt_Oelims,axiom,(
    ! [B: $tType,A: $tType,X2: ( ( stream @ A ) > B ),Xa: ( stream @ A ),Y: B] :
      ( ( ( linear1494993505on_nxt @ A @ B @ X2 @ Xa )
        = Y )
     => ( Y
        = ( X2 @ ( stl @ A @ Xa ) ) ) ) )).

% nxt.elims
thf(fact_168_szip_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( shd @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( product_Pair @ A @ B @ ( shd @ A @ S1 ) @ ( shd @ B @ S22 ) ) ) )).

% szip.simps(1)
thf(fact_169_fset_Opred__map,axiom,(
    ! [B: $tType,A: $tType,Q2: ( B > $o ),F: ( A > B ),X2: ( fset @ A )] :
      ( ( pred_fset @ B @ Q2 @ ( fimage @ A @ B @ F @ X2 ) )
      = ( pred_fset @ A @ ( comp @ B @ $o @ A @ Q2 @ F ) @ X2 ) ) )).

% fset.pred_map
thf(fact_170_szip_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( szip @ A @ B )
      = ( ^ [S12: ( stream @ A ),S23: ( stream @ B )] :
            ( sCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( shd @ A @ S12 ) @ ( shd @ B @ S23 ) ) @ ( szip @ A @ B @ ( stl @ A @ S12 ) @ ( stl @ B @ S23 ) ) ) ) ) )).

% szip.code
thf(fact_171_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X12: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X12 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X12 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_172_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A7: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A7 @ B4 ) )
      = ( ( A2 = A7 )
        & ( B2 = B4 ) ) ) )).

% old.prod.inject
thf(fact_173_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X2 ) ) )).

% swap_simp
thf(fact_174_prod_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) )).

% prod.collapse
thf(fact_175_snd__conv,axiom,(
    ! [Aa: $tType,A: $tType,X12: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X12 @ X22 ) )
      = X22 ) )).

% snd_conv
thf(fact_176_fst__conv,axiom,(
    ! [B: $tType,A: $tType,X12: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X12 @ X22 ) )
      = X12 ) )).

% fst_conv
thf(fact_177_snd__eqD,axiom,(
    ! [B: $tType,A: $tType,X2: B,Y: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) )
        = A2 )
     => ( Y = A2 ) ) )).

% snd_eqD
thf(fact_178_fst__eqD,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X2 @ Y ) )
        = A2 )
     => ( X2 = A2 ) ) )).

% fst_eqD
thf(fact_179_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P3: ( product_prod @ A @ B )] :
    ? [X3: A,Y2: B] :
      ( P3
      = ( product_Pair @ A @ B @ X3 @ Y2 ) ) )).

% surj_pair
thf(fact_180_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),P3: ( product_prod @ A @ B )] :
      ( ! [A8: A,B5: B] :
          ( P2 @ ( product_Pair @ A @ B @ A8 @ B5 ) )
     => ( P2 @ P3 ) ) )).

% prod_cases
thf(fact_181_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A7: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A7 @ B4 ) )
     => ~ ( ( A2 = A7 )
         => ( B2 != B4 ) ) ) )).

% Pair_inject
thf(fact_182_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A8: A,B5: B,C3: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A8 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_183_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A8: A,B5: B,C3: C,D3: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D3 ) ) ) ) ) )).

% prod_cases4
thf(fact_184_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) )] :
      ~ ( ! [A8: A,B5: B,C3: C,D3: D,E3: E2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E2 ) @ C3 @ ( product_Pair @ D @ E2 @ D3 @ E3 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_185_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E2: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) ) )] :
      ~ ( ! [A8: A,B5: B,C3: C,D3: D,E3: E2,F2: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E2 @ F4 ) @ D3 @ ( product_Pair @ E2 @ F4 @ E3 @ F2 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_186_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E2: $tType,F4: $tType,G3: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) ) )] :
      ~ ( ! [A8: A,B5: B,C3: C,D3: D,E3: E2,F2: F4,G4: G3] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) @ D3 @ ( product_Pair @ E2 @ ( product_prod @ F4 @ G3 ) @ E3 @ ( product_Pair @ F4 @ G3 @ F2 @ G4 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_187_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A8: A,B5: B,C3: C] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A8 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct3
thf(fact_188_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A8: A,B5: B,C3: C,D3: D] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D3 ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct4
thf(fact_189_prod__induct5,axiom,(
    ! [E2: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) )] :
      ( ! [A8: A,B5: B,C3: C,D3: D,E3: E2] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E2 ) @ C3 @ ( product_Pair @ D @ E2 @ D3 @ E3 ) ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct5
thf(fact_190_prod__induct6,axiom,(
    ! [F4: $tType,E2: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) ) )] :
      ( ! [A8: A,B5: B,C3: C,D3: D,E3: E2,F2: F4] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F4 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E2 @ F4 ) @ D3 @ ( product_Pair @ E2 @ F4 @ E3 @ F2 ) ) ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct6
thf(fact_191_prod__induct7,axiom,(
    ! [G3: $tType,F4: $tType,E2: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) ) )] :
      ( ! [A8: A,B5: B,C3: C,D3: D,E3: E2,F2: F4,G4: G3] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) ) @ A8 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E2 @ ( product_prod @ F4 @ G3 ) ) @ D3 @ ( product_Pair @ E2 @ ( product_prod @ F4 @ G3 ) @ E3 @ ( product_Pair @ F4 @ G3 @ F2 @ G4 ) ) ) ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct7
thf(fact_192_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A8: A,B5: B] :
            ( Y
           != ( product_Pair @ A @ B @ A8 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_193_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A8: A,B5: B] :
          ( P2 @ ( product_Pair @ A @ B @ A8 @ B5 ) )
     => ( P2 @ Prod ) ) )).

% old.prod.inducts
thf(fact_194_exI__realizer,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o ),Y: A,X2: B] :
      ( ( P2 @ Y @ X2 )
     => ( P2 @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) ) ) ) )).

% exI_realizer
thf(fact_195_conjI__realizer,axiom,(
    ! [A: $tType,B: $tType,P2: ( A > $o ),P3: A,Q2: ( B > $o ),Q: B] :
      ( ( P2 @ P3 )
     => ( ( Q2 @ Q )
       => ( ( P2 @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P3 @ Q ) ) )
          & ( Q2 @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P3 @ Q ) ) ) ) ) ) )).

% conjI_realizer
thf(fact_196_prod_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) )).

% prod.exhaust_sel
thf(fact_197_surjective__pairing,axiom,(
    ! [B: $tType,A: $tType,T6: ( product_prod @ A @ B )] :
      ( T6
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T6 ) @ ( product_snd @ A @ B @ T6 ) ) ) )).

% surjective_pairing
thf(fact_198_szip__unfold,axiom,(
    ! [A: $tType,B: $tType,A2: A,S1: ( stream @ A ),B2: B,S22: ( stream @ B )] :
      ( ( szip @ A @ B @ ( sCons @ A @ A2 @ S1 ) @ ( sCons @ B @ B2 @ S22 ) )
      = ( sCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( szip @ A @ B @ S1 @ S22 ) ) ) )).

% szip_unfold
thf(fact_199_prod_Oswap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_swap @ A @ B )
      = ( ^ [P5: ( product_prod @ A @ B )] :
            ( product_Pair @ B @ A @ ( product_snd @ A @ B @ P5 ) @ ( product_fst @ A @ B @ P5 ) ) ) ) )).

% prod.swap_def
thf(fact_200_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_201_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o ),X2: A,Y: B,A2: ( product_prod @ A @ B )] :
      ( ( P2 @ X2 @ Y )
     => ( ( A2
          = ( product_Pair @ A @ B @ X2 @ Y ) )
       => ( P2 @ ( product_fst @ A @ B @ A2 ) @ ( product_snd @ A @ B @ A2 ) ) ) ) )).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_202_eq__snd__iff,axiom,(
    ! [A: $tType,B: $tType,B2: A,P3: ( product_prod @ B @ A )] :
      ( ( B2
        = ( product_snd @ B @ A @ P3 ) )
      = ( ? [A3: B] :
            ( P3
            = ( product_Pair @ B @ A @ A3 @ B2 ) ) ) ) )).

% eq_snd_iff
thf(fact_203_eq__fst__iff,axiom,(
    ! [A: $tType,B: $tType,A2: A,P3: ( product_prod @ A @ B )] :
      ( ( A2
        = ( product_fst @ A @ B @ P3 ) )
      = ( ? [B6: B] :
            ( P3
            = ( product_Pair @ A @ B @ A2 @ B6 ) ) ) ) )).

% eq_fst_iff
thf(fact_204_fstI,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B ),Y: A,Z3: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y @ Z3 ) )
     => ( ( product_fst @ A @ B @ X2 )
        = Y ) ) )).

% fstI
thf(fact_205_sndI,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ A @ B ),Y: A,Z3: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y @ Z3 ) )
     => ( ( product_snd @ A @ B @ X2 )
        = Z3 ) ) )).

% sndI
thf(fact_206_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X2: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X2 ) )
        = ( H @ ( K @ X2 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ C @ H @ K @ X2 ) ) ) )).

% comp_apply_eq
thf(fact_207_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C2 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_208_sdrop__while_Oraw__induct,axiom,(
    ! [A: $tType,Pa: ( ( product_prod @ ( A > $o ) @ ( stream @ A ) ) > ( stream @ A ) > $o ),P2: ( A > $o ),S: ( stream @ A ),Y: ( stream @ A )] :
      ( ! [Sdrop_while: ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) )] :
          ( ! [S5: ( A > $o ),B7: ( stream @ A )] :
              ( ( ( Sdrop_while @ S5 @ B7 )
               != ( undefined @ ( stream @ A ) ) )
             => ( Pa @ ( product_Pair @ ( A > $o ) @ ( stream @ A ) @ S5 @ B7 ) @ ( Sdrop_while @ S5 @ B7 ) ) )
         => ! [P6: ( A > $o ),S2: ( stream @ A ),Pa2: ( stream @ A )] :
              ( ( ( ( P6 @ ( shd @ A @ S2 ) )
                 => ( ( Sdrop_while @ P6 @ ( stl @ A @ S2 ) )
                    = Pa2 ) )
                & ( ~ ( P6 @ ( shd @ A @ S2 ) )
                 => ( S2 = Pa2 ) ) )
             => ( ( Pa2
                 != ( undefined @ ( stream @ A ) ) )
               => ( Pa @ ( product_Pair @ ( A > $o ) @ ( stream @ A ) @ P6 @ S2 ) @ Pa2 ) ) ) )
     => ( ( ( sdrop_while @ A @ P2 @ S )
          = Y )
       => ( ( Y
           != ( undefined @ ( stream @ A ) ) )
         => ( Pa @ ( product_Pair @ ( A > $o ) @ ( stream @ A ) @ P2 @ S ) @ Y ) ) ) ) )).

% sdrop_while.raw_induct
thf(fact_209_sndOp__def,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( bNF_sndOp @ C @ A @ B )
      = ( ^ [P4: ( C > A > $o ),Q3: ( A > B > $o ),Ac: ( product_prod @ C @ B )] :
            ( product_Pair @ A @ B @ ( bNF_pick_middlep @ C @ A @ B @ P4 @ Q3 @ ( product_fst @ C @ B @ Ac ) @ ( product_snd @ C @ B @ Ac ) ) @ ( product_snd @ C @ B @ Ac ) ) ) ) )).

% sndOp_def
thf(fact_210_fstOp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_fstOp @ A @ B @ C )
      = ( ^ [P4: ( A > B > $o ),Q3: ( B > C > $o ),Ac: ( product_prod @ A @ C )] :
            ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Ac ) @ ( bNF_pick_middlep @ A @ B @ C @ P4 @ Q3 @ ( product_fst @ A @ C @ Ac ) @ ( product_snd @ A @ C @ Ac ) ) ) ) ) )).

% fstOp_def
thf(fact_211_snd__sndOp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: ( B > C > $o ),Q2: ( C > A > $o )] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ C @ A ) @ A @ ( product_prod @ B @ A ) @ ( product_snd @ C @ A ) @ ( bNF_sndOp @ B @ C @ A @ P2 @ Q2 ) ) ) )).

% snd_sndOp
thf(fact_212_fst__fstOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P2: ( A > C > $o ),Q2: ( C > B > $o )] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q2 ) ) ) )).

% fst_fstOp
thf(fact_213_csquare__fstOp__sndOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( ( A > B > $o ) > ( product_prod @ A @ B ) > $o ),P2: ( A > C > $o ),Q2: ( C > B > $o )] :
      ( bNF_csquare @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) @ C @ ( product_prod @ C @ B ) @ ( collect @ ( product_prod @ A @ B ) @ ( F @ ( relcompp @ A @ C @ B @ P2 @ Q2 ) ) ) @ ( product_snd @ A @ C ) @ ( product_fst @ C @ B ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q2 ) @ ( bNF_sndOp @ A @ C @ B @ P2 @ Q2 ) ) )).

% csquare_fstOp_sndOp
thf(fact_214_from__nat__into__inj,axiom,(
    ! [A: $tType,A5: ( set @ A ),M2: nat,N2: nat] :
      ( ( countable_countable @ A @ A5 )
     => ( ( member @ nat @ M2 @ ( image @ A @ nat @ ( countable_to_nat_on @ A @ A5 ) @ A5 ) )
       => ( ( member @ nat @ N2 @ ( image @ A @ nat @ ( countable_to_nat_on @ A @ A5 ) @ A5 ) )
         => ( ( ( counta609264050t_into @ A @ A5 @ M2 )
              = ( counta609264050t_into @ A @ A5 @ N2 ) )
            = ( M2 = N2 ) ) ) ) ) )).

% from_nat_into_inj
thf(fact_215_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X2: B,A5: ( set @ B )] :
      ( ( B2
        = ( F @ X2 ) )
     => ( ( member @ B @ X2 @ A5 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A5 ) ) ) ) )).

% image_eqI
thf(fact_216_relcompp__bot1,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R2: ( C > B > $o )] :
      ( ( relcompp @ A @ C @ B @ ( bot_bot @ ( A > C > $o ) ) @ R2 )
      = ( bot_bot @ ( A > B > $o ) ) ) )).

% relcompp_bot1
thf(fact_217_relcompp__bot2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R2: ( A > C > $o )] :
      ( ( relcompp @ A @ C @ B @ R2 @ ( bot_bot @ ( C > B > $o ) ) )
      = ( bot_bot @ ( A > B > $o ) ) ) )).

% relcompp_bot2
thf(fact_218_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A5 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A5
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_219_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_220_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_221_countable__image,axiom,(
    ! [B: $tType,A: $tType,A5: ( set @ A ),F: ( A > B )] :
      ( ( countable_countable @ A @ A5 )
     => ( countable_countable @ B @ ( image @ A @ B @ F @ A5 ) ) ) )).

% countable_image
thf(fact_222_to__nat__on__from__nat__into,axiom,(
    ! [A: $tType,N2: nat,A5: ( set @ A )] :
      ( ( member @ nat @ N2 @ ( image @ A @ nat @ ( countable_to_nat_on @ A @ A5 ) @ A5 ) )
     => ( ( countable_to_nat_on @ A @ A5 @ ( counta609264050t_into @ A @ A5 @ N2 ) )
        = N2 ) ) )).

% to_nat_on_from_nat_into
thf(fact_223_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),R: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G @ R ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F @ G ) @ R ) ) )).

% image_comp
thf(fact_224_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( B > A ),A5: ( set @ B ),G: ( C > A ),B3: ( set @ C ),H: ( A > D )] :
      ( ( ( image @ B @ A @ F @ A5 )
        = ( image @ C @ A @ G @ B3 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H @ F ) @ A5 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H @ G ) @ B3 ) ) ) )).

% image_eq_imp_comp
thf(fact_225_relcompp_OrelcompI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R: ( A > B > $o ),A2: A,B2: B,S: ( B > C > $o ),C2: C] :
      ( ( R @ A2 @ B2 )
     => ( ( S @ B2 @ C2 )
       => ( relcompp @ A @ B @ C @ R @ S @ A2 @ C2 ) ) ) )).

% relcompp.relcompI
thf(fact_226_relcompp_Oinducts,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R: ( A > B > $o ),S: ( B > C > $o ),X12: A,X22: C,P2: ( A > C > $o )] :
      ( ( relcompp @ A @ B @ C @ R @ S @ X12 @ X22 )
     => ( ! [A8: A,B5: B,C3: C] :
            ( ( R @ A8 @ B5 )
           => ( ( S @ B5 @ C3 )
             => ( P2 @ A8 @ C3 ) ) )
       => ( P2 @ X12 @ X22 ) ) ) )).

% relcompp.inducts
thf(fact_227_relcompp__assoc,axiom,(
    ! [A: $tType,D: $tType,B: $tType,C: $tType,R: ( A > D > $o ),S: ( D > C > $o ),T6: ( C > B > $o )] :
      ( ( relcompp @ A @ C @ B @ ( relcompp @ A @ D @ C @ R @ S ) @ T6 )
      = ( relcompp @ A @ D @ B @ R @ ( relcompp @ D @ C @ B @ S @ T6 ) ) ) )).

% relcompp_assoc
thf(fact_228_relcompp__apply,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcompp @ A @ B @ C )
      = ( ^ [R4: ( A > B > $o ),S6: ( B > C > $o ),A3: A,C4: C] :
          ? [B6: B] :
            ( ( R4 @ A3 @ B6 )
            & ( S6 @ B6 @ C4 ) ) ) ) )).

% relcompp_apply
thf(fact_229_relcompp_Osimps,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcompp @ A @ B @ C )
      = ( ^ [R3: ( A > B > $o ),S3: ( B > C > $o ),A12: A,A23: C] :
          ? [A3: A,B6: B,C4: C] :
            ( ( A12 = A3 )
            & ( A23 = C4 )
            & ( R3 @ A3 @ B6 )
            & ( S3 @ B6 @ C4 ) ) ) ) )).

% relcompp.simps
thf(fact_230_relcompp_Ocases,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R: ( A > B > $o ),S: ( B > C > $o ),A1: A,A22: C] :
      ( ( relcompp @ A @ B @ C @ R @ S @ A1 @ A22 )
     => ~ ( ! [B5: B] :
              ( ( R @ A1 @ B5 )
             => ~ ( S @ B5 @ A22 ) ) ) ) )).

% relcompp.cases
thf(fact_231_relcomppE,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R: ( A > B > $o ),S: ( B > C > $o ),A2: A,C2: C] :
      ( ( relcompp @ A @ B @ C @ R @ S @ A2 @ C2 )
     => ~ ( ! [B5: B] :
              ( ( R @ A2 @ B5 )
             => ~ ( S @ B5 @ C2 ) ) ) ) )).

% relcomppE
thf(fact_232_eq__OO,axiom,(
    ! [B: $tType,A: $tType,R2: ( A > B > $o )] :
      ( ( relcompp @ A @ A @ B
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R2 )
      = R2 ) )).

% eq_OO
thf(fact_233_OO__eq,axiom,(
    ! [B: $tType,A: $tType,R2: ( A > B > $o )] :
      ( ( relcompp @ A @ B @ B @ R2
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) )
      = R2 ) )).

% OO_eq
thf(fact_234_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X2 @ A5 )
     => ( ( B2
          = ( F @ X2 ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A5 ) ) ) ) )).

% rev_image_eqI
thf(fact_235_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: ( set @ B ),P2: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A5 ) )
         => ( P2 @ X3 ) )
     => ! [X6: B] :
          ( ( member @ B @ X6 @ A5 )
         => ( P2 @ ( F @ X6 ) ) ) ) )).

% ball_imageD
thf(fact_236_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G @ N ) ) ) ) )).

% image_cong
thf(fact_237_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: ( set @ B ),P2: ( A > $o )] :
      ( ? [X6: A] :
          ( ( member @ A @ X6 @ ( image @ B @ A @ F @ A5 ) )
          & ( P2 @ X6 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A5 )
          & ( P2 @ ( F @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_238_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z3: A,F: ( B > A ),A5: ( set @ B )] :
      ( ( member @ A @ Z3 @ ( image @ B @ A @ F @ A5 ) )
      = ( ? [X5: B] :
            ( ( member @ B @ X5 @ A5 )
            & ( Z3
              = ( F @ X5 ) ) ) ) ) )).

% image_iff
thf(fact_239_imageI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X2 @ A5 )
     => ( member @ B @ ( F @ X2 ) @ ( image @ A @ B @ F @ A5 ) ) ) )).

% imageI
thf(fact_240_eq__from__nat__into__iff,axiom,(
    ! [A: $tType,A5: ( set @ A ),X2: A,I: nat] :
      ( ( countable_countable @ A @ A5 )
     => ( ( member @ A @ X2 @ A5 )
       => ( ( member @ nat @ I @ ( image @ A @ nat @ ( countable_to_nat_on @ A @ A5 ) @ A5 ) )
         => ( ( X2
              = ( counta609264050t_into @ A @ A5 @ I ) )
            = ( I
              = ( countable_to_nat_on @ A @ A5 @ X2 ) ) ) ) ) ) )).

% eq_from_nat_into_iff
thf(fact_241_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A5: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A5 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A5 ) ) ) )).

% Inf.INF_image
thf(fact_242_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A5: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A5 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A5 ) ) ) )).

% Sup.SUP_image
thf(fact_243_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y: A,X2: B,A5: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X2 ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A5 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y ) @ A5 ) ) )).

% pair_in_swap_image
thf(fact_244_Stream__image,axiom,(
    ! [A: $tType,X2: A,Y: ( stream @ A ),X7: A,Y4: ( set @ ( stream @ A ) )] :
      ( ( member @ ( stream @ A ) @ ( sCons @ A @ X2 @ Y ) @ ( image @ ( stream @ A ) @ ( stream @ A ) @ ( sCons @ A @ X7 ) @ Y4 ) )
      = ( ( X2 = X7 )
        & ( member @ ( stream @ A ) @ Y @ Y4 ) ) ) )).

% Stream_image
thf(fact_245_snd__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ F @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_apsnd
thf(fact_246_fst__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_apfst
thf(fact_247_apfst__conv,axiom,(
    ! [C: $tType,A: $tType,B: $tType,F: ( C > A ),X2: C,Y: B] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_Pair @ C @ B @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ ( F @ X2 ) @ Y ) ) )).

% apfst_conv
thf(fact_248_apsnd__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),X2: A,Y: C] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_Pair @ A @ C @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ X2 @ ( F @ Y ) ) ) )).

% apsnd_conv
thf(fact_249_fst__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > A ),X2: ( product_prod @ C @ B )] :
      ( ( product_fst @ A @ B @ ( product_apfst @ C @ A @ B @ F @ X2 ) )
      = ( F @ ( product_fst @ C @ B @ X2 ) ) ) )).

% fst_apfst
thf(fact_250_snd__apfst,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > B ),X2: ( product_prod @ C @ A )] :
      ( ( product_snd @ B @ A @ ( product_apfst @ C @ B @ A @ F @ X2 ) )
      = ( product_snd @ C @ A @ X2 ) ) )).

% snd_apfst
thf(fact_251_apfst__eq__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > A ),X2: ( product_prod @ C @ B ),G: ( C > A )] :
      ( ( ( product_apfst @ C @ A @ B @ F @ X2 )
        = ( product_apfst @ C @ A @ B @ G @ X2 ) )
      = ( ( F @ ( product_fst @ C @ B @ X2 ) )
        = ( G @ ( product_fst @ C @ B @ X2 ) ) ) ) )).

% apfst_eq_conv
thf(fact_252_fst__apsnd,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),X2: ( product_prod @ A @ C )] :
      ( ( product_fst @ A @ B @ ( product_apsnd @ C @ B @ A @ F @ X2 ) )
      = ( product_fst @ A @ C @ X2 ) ) )).

% fst_apsnd
thf(fact_253_snd__apsnd,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),X2: ( product_prod @ B @ C )] :
      ( ( product_snd @ B @ A @ ( product_apsnd @ C @ A @ B @ F @ X2 ) )
      = ( F @ ( product_snd @ B @ C @ X2 ) ) ) )).

% snd_apsnd
thf(fact_254_apsnd__eq__conv,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),X2: ( product_prod @ A @ C ),G: ( C > B )] :
      ( ( ( product_apsnd @ C @ B @ A @ F @ X2 )
        = ( product_apsnd @ C @ B @ A @ G @ X2 ) )
      = ( ( F @ ( product_snd @ A @ C @ X2 ) )
        = ( G @ ( product_snd @ A @ C @ X2 ) ) ) ) )).

% apsnd_eq_conv
thf(fact_255_snd__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( product_snd @ A @ B ) ) )).

% snd_comp_apfst

%----Type constructors (16)
thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite,axiom,(
    ! [A9: $tType,A4: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A4 @ ( type2 @ A4 ) ) )
     => ( finite_finite @ ( product_prod @ A9 @ A4 ) @ ( type2 @ ( product_prod @ A9 @ A4 ) ) ) ) )).

thf(tcon_FSet_Ofset___Finite__Set_Ofinite_1,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( fset @ A9 ) @ ( type2 @ ( fset @ A9 ) ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_2,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_3,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite_4,axiom,(
    ! [A9: $tType,A4: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A4 @ ( type2 @ A4 ) ) )
     => ( finite_finite @ ( A9 > A4 ) @ ( type2 @ ( A9 > A4 ) ) ) ) )).

thf(tcon_fun___Countable_Ocountable,axiom,(
    ! [A9: $tType,A4: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( countable @ A4 @ ( type2 @ A4 ) ) )
     => ( countable @ ( A9 > A4 ) @ ( type2 @ ( A9 > A4 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A9: $tType,A4: $tType] :
      ( ( bot @ A4 @ ( type2 @ A4 ) )
     => ( bot @ ( A9 > A4 ) @ ( type2 @ ( A9 > A4 ) ) ) ) )).

thf(tcon_Nat_Onat___Countable_Ocountable_5,axiom,
    ( countable @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_6,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Countable_Ocountable_7,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( countable @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_8,axiom,(
    ! [A9: $tType] :
      ( bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_HOL_Obool___Countable_Ocountable_9,axiom,
    ( countable @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_10,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_FSet_Ofset___Countable_Ocountable_11,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( countable @ ( fset @ A9 ) @ ( type2 @ ( fset @ A9 ) ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Obot_12,axiom,(
    ! [A9: $tType] :
      ( bot @ ( fset @ A9 ) @ ( type2 @ ( fset @ A9 ) ) ) )).

thf(tcon_Product__Type_Oprod___Countable_Ocountable_13,axiom,(
    ! [A9: $tType,A4: $tType] :
      ( ( ( countable @ A9 @ ( type2 @ A9 ) )
        & ( countable @ A4 @ ( type2 @ A4 ) ) )
     => ( countable @ ( product_prod @ A9 @ A4 ) @ ( type2 @ ( product_prod @ A9 @ A4 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ? [Steps: ( stream @ ( product_prod @ state @ rule ) ),Sl2: ( fset @ state )] :
      ( ( stepsa = Steps )
      & ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ ( sset @ rule @ rules ) )
      & ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) ) ) @ Sl2 )
      & ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ Sl2 )
      & ( ? [T4: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ),Stepsa: ( stream @ ( product_prod @ state @ rule ) )] :
            ( ( ( stl @ ( product_prod @ state @ rule ) @ Steps )
              = Stepsa )
            & ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ T4 )
            & ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ T4 @ Stepsa ) )
        | ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) ) ) ) )).

%------------------------------------------------------------------------------
