%------------------------------------------------------------------------------
% File     : COM154^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Abstract completeness 131
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BPT14] Blanchette et al. (2014), Abstract Completeness
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : abstract_completeness__131.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  373 (   0 unit;  71 type;   0 defn)
%            Number of atoms       : 3487 ( 257 equality;1798 variable)
%            Maximal formula depth :   17 (   8 average)
%            Number of connectives : 2912 ( 108   ~;   9   |;  26   &;2479   @)
%                                         (   0 <=>; 290  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  181 ( 181   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   75 (  71   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  823 (   7 sgn; 688   !;  22   ?;  53   ^)
%                                         ( 823   :;  60  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:53:38.952
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_rule,type,(
    rule: $tType )).

%----Explicit typings (65)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Transcendental_Oln,type,(
    ln: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__neq__one,type,(
    zero_neq_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable_Ocountable,type,(
    countable: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__less__one,type,(
    zero_less_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,(
    comm_monoid_diff: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,(
    linord1659791738miring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofenum,type,(
    abstra1774373515_fenum: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) ) )).

thf(sy_c_Countable__Set_Ocountable,type,(
    countable_countable: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_Omap,type,(
    map: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) )).

thf(sy_c_List_Omap__tailrec,type,(
    map_tailrec: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Nat_Onat_Ocase__nat,type,(
    case_nat: 
      !>[A: $tType] :
        ( A > ( nat > A ) > nat > A ) )).

thf(sy_c_Nat_Onat_Opred,type,(
    pred: nat > nat )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,(
    neg_numeral_dbl_inc: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OBex,type,(
    bex: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Stream_Oflat,type,(
    flat: 
      !>[A: $tType] :
        ( ( stream @ ( list @ A ) ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Oshift,type,(
    shift: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Ositerate,type,(
    siterate: 
      !>[A: $tType] :
        ( ( A > A ) > A > ( stream @ A ) ) )).

thf(sy_c_Stream_Osmerge,type,(
    smerge: 
      !>[A: $tType] :
        ( ( stream @ ( stream @ A ) ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osnth,type,(
    snth: 
      !>[A: $tType] :
        ( ( stream @ A ) > nat > A ) )).

thf(sy_c_Stream_Ostake,type,(
    stake: 
      !>[A: $tType] :
        ( nat > ( stream @ A ) > ( list @ A ) ) )).

thf(sy_c_Stream_Ostream_Osmap,type,(
    smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream @ A ) > ( stream @ Aa ) ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Transcendental_Oln__class_Oln,type,(
    ln_ln: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Transcendental_Opowr,type,(
    powr: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_m____,type,(
    m: nat )).

thf(sy_v_n____,type,(
    n: nat )).

thf(sy_v_na____,type,(
    na: nat )).

thf(sy_v_r____,type,(
    r: rule )).

thf(sy_v_rsa____,type,(
    rsa: ( list @ rule ) )).

thf(sy_v_rules,type,(
    rules: ( stream @ rule ) )).

%----Relevant facts (252)
thf(fact_0__092_060open_0620_A_060_An_____092_060close_062,axiom,
    ( ord_less @ nat @ ( zero_zero @ nat ) @ n )).

% \<open>0 < n__\<close>
thf(fact_1_r,axiom,
    ( r
    = ( snth @ rule @ rules @ m ) )).

% r
thf(fact_2_local_Oalw,axiom,
    ( ord_less @ nat @ ( zero_zero @ nat ) @ na )).

% local.alw
thf(fact_3__092_060open_062r_A_092_060in_062_AR_092_060close_062,axiom,
    ( member @ rule @ r @ ( sset @ rule @ rules ) )).

% \<open>r \<in> R\<close>
thf(fact_4__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062m_O_Ar_A_061_Arules_A_B_B_Am_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [M: nat] :
          ( r
         != ( snth @ rule @ rules @ M ) ) ) )).

% \<open>\<And>thesis. (\<And>m. r = rules !! m \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_5_sset__fenum,axiom,
    ( ( sset @ rule @ ( abstra1774373515_fenum @ rule @ rules ) )
    = ( sset @ rule @ rules ) )).

% sset_fenum
thf(fact_6_fenum__def,axiom,
    ( ( abstra1774373515_fenum @ rule @ rules )
    = ( flat @ rule
      @ ( smap @ nat @ ( list @ rule )
        @ ^ [N: nat] :
            ( stake @ rule @ N @ rules )
        @ ( siterate @ nat @ suc @ ( one_one @ nat ) ) ) ) )).

% fenum_def
thf(fact_7_shift__left__inj,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S1: ( stream @ A ),S2: ( stream @ A )] :
      ( ( ( shift @ A @ Xs @ S1 )
        = ( shift @ A @ Xs @ S2 ) )
      = ( S1 = S2 ) ) )).

% shift_left_inj
thf(fact_8_NE__R,axiom,(
    ( sset @ rule @ rules )
 != ( bot_bot @ ( set @ rule ) ) )).

% NE_R
thf(fact_9_nat_Oinject,axiom,(
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% nat.inject
thf(fact_10_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_11_smap__siterate,axiom,(
    ! [A: $tType,F: ( A > A ),X: A] :
      ( ( smap @ A @ A @ F @ ( siterate @ A @ F @ X ) )
      = ( siterate @ A @ F @ ( F @ X ) ) ) )).

% smap_siterate
thf(fact_12_stream_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,X: ( stream @ A ),Ya: ( stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( X = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( sset @ A @ Ya ) )
           => ( ( F @ Z )
              = ( G @ Z ) ) )
       => ( ( smap @ A @ B @ F @ X )
          = ( smap @ A @ B @ G @ Ya ) ) ) ) )).

% stream.map_cong
thf(fact_13_stream_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,X: ( stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z: A] :
          ( ( member @ A @ Z @ ( sset @ A @ X ) )
         => ( ( F @ Z )
            = ( G @ Z ) ) )
     => ( ( smap @ A @ B @ F @ X )
        = ( smap @ A @ B @ G @ X ) ) ) )).

% stream.map_cong0
thf(fact_14_stream_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,X: ( stream @ A ),Xa: ( stream @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z: A,Za: A] :
          ( ( member @ A @ Z @ ( sset @ A @ X ) )
         => ( ( member @ A @ Za @ ( sset @ A @ Xa ) )
           => ( ( ( F @ Z )
                = ( Fa @ Za ) )
             => ( Z = Za ) ) ) )
     => ( ( ( smap @ A @ B @ F @ X )
          = ( smap @ A @ B @ Fa @ Xa ) )
       => ( X = Xa ) ) ) )).

% stream.inj_map_strong
thf(fact_15_countable__R,axiom,
    ( countable_countable @ rule @ ( sset @ rule @ rules ) )).

% countable_R
thf(fact_16_RuleSystem__Defs_Ofenum__def,axiom,(
    ! [Rule: $tType] :
      ( ( abstra1774373515_fenum @ Rule )
      = ( ^ [Rules: ( stream @ Rule )] :
            ( flat @ Rule
            @ ( smap @ nat @ ( list @ Rule )
              @ ^ [N: nat] :
                  ( stake @ Rule @ N @ Rules )
              @ ( siterate @ nat @ suc @ ( one_one @ nat ) ) ) ) ) ) )).

% RuleSystem_Defs.fenum_def
thf(fact_17_neq0__conv,axiom,(
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) )).

% neq0_conv
thf(fact_18_Suc__less__eq,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ M2 @ N2 ) ) )).

% Suc_less_eq
thf(fact_19_Suc__mono,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ord_less @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) ) ) )).

% Suc_mono
thf(fact_20_lessI,axiom,(
    ! [N2: nat] :
      ( ord_less @ nat @ N2 @ ( suc @ N2 ) ) )).

% lessI
thf(fact_21_snth__smap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S: ( stream @ B ),N2: nat] :
      ( ( snth @ A @ ( smap @ B @ A @ F @ S ) @ N2 )
      = ( F @ ( snth @ B @ S @ N2 ) ) ) )).

% snth_smap
thf(fact_22_zero__less__Suc,axiom,(
    ! [N2: nat] :
      ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )).

% zero_less_Suc
thf(fact_23_less__Suc0,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) )).

% less_Suc0
thf(fact_24_less__one,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( one_one @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) )).

% less_one
thf(fact_25_gr0I,axiom,(
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) )).

% gr0I
thf(fact_26_not__gr0,axiom,(
    ! [N2: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) )).

% not_gr0
thf(fact_27_not__less0,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) )).

% not_less0
thf(fact_28_less__zeroE,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) )).

% less_zeroE
thf(fact_29_nat__neq__iff,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( M2 != N2 )
      = ( ( ord_less @ nat @ M2 @ N2 )
        | ( ord_less @ nat @ N2 @ M2 ) ) ) )).

% nat_neq_iff
thf(fact_30_less__not__refl,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) )).

% less_not_refl
thf(fact_31_less__not__refl2,axiom,(
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ N2 @ M2 )
     => ( M2 != N2 ) ) )).

% less_not_refl2
thf(fact_32_less__not__refl3,axiom,(
    ! [S: nat,T: nat] :
      ( ( ord_less @ nat @ S @ T )
     => ( S != T ) ) )).

% less_not_refl3
thf(fact_33_measure__induct,axiom,(
    ! [A: $tType,F: ( A > nat ),P: ( A > $o ),A2: A] :
      ( ! [X3: A] :
          ( ! [Y: A] :
              ( ( ord_less @ nat @ ( F @ Y ) @ ( F @ X3 ) )
             => ( P @ Y ) )
         => ( P @ X3 ) )
     => ( P @ A2 ) ) )).

% measure_induct
thf(fact_34_gr__implies__not0,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( N2
       != ( zero_zero @ nat ) ) ) )).

% gr_implies_not0
thf(fact_35_less__irrefl__nat,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) )).

% less_irrefl_nat
thf(fact_36_nat__less__induct,axiom,(
    ! [P: ( nat > $o ),N2: nat] :
      ( ! [N3: nat] :
          ( ! [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N3 )
             => ( P @ M3 ) )
         => ( P @ N3 ) )
     => ( P @ N2 ) ) )).

% nat_less_induct
thf(fact_37_infinite__descent,axiom,(
    ! [P: ( nat > $o ),N2: nat] :
      ( ! [N3: nat] :
          ( ~ ( P @ N3 )
         => ? [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N3 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N2 ) ) )).

% infinite_descent
thf(fact_38_infinite__descent0,axiom,(
    ! [P: ( nat > $o ),N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
           => ( ~ ( P @ N3 )
             => ? [M3: nat] :
                  ( ( ord_less @ nat @ M3 @ N3 )
                  & ~ ( P @ M3 ) ) ) )
       => ( P @ N2 ) ) ) )).

% infinite_descent0
thf(fact_39_linorder__neqE__nat,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( X != Y3 )
     => ( ~ ( ord_less @ nat @ X @ Y3 )
       => ( ord_less @ nat @ Y3 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_40_less__nat__zero__code,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) )).

% less_nat_zero_code
thf(fact_41_measure__induct__rule,axiom,(
    ! [A: $tType,F: ( A > nat ),P: ( A > $o ),A2: A] :
      ( ! [X3: A] :
          ( ! [Y: A] :
              ( ( ord_less @ nat @ ( F @ Y ) @ ( F @ X3 ) )
             => ( P @ Y ) )
         => ( P @ X3 ) )
     => ( P @ A2 ) ) )).

% measure_induct_rule
thf(fact_42_infinite__descent__measure,axiom,(
    ! [A: $tType,P: ( A > $o ),V: ( A > nat ),X: A] :
      ( ! [X3: A] :
          ( ~ ( P @ X3 )
         => ? [Y: A] :
              ( ( ord_less @ nat @ ( V @ Y ) @ ( V @ X3 ) )
              & ~ ( P @ Y ) ) )
     => ( P @ X ) ) )).

% infinite_descent_measure
thf(fact_43_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_46_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_47_infinite__descent0__measure,axiom,(
    ! [A: $tType,V: ( A > nat ),P: ( A > $o ),X: A] :
      ( ! [X3: A] :
          ( ( ( V @ X3 )
            = ( zero_zero @ nat ) )
         => ( P @ X3 ) )
     => ( ! [X3: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V @ X3 ) )
           => ( ~ ( P @ X3 )
             => ? [Y: A] :
                  ( ( ord_less @ nat @ ( V @ Y ) @ ( V @ X3 ) )
                  & ~ ( P @ Y ) ) ) )
       => ( P @ X ) ) ) )).

% infinite_descent0_measure
thf(fact_48_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) )).

% One_nat_def
thf(fact_49_lift__Suc__mono__less__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [F: ( nat > A ),N2: nat,M2: nat] :
          ( ! [N3: nat] :
              ( ord_less @ A @ ( F @ N3 ) @ ( F @ ( suc @ N3 ) ) )
         => ( ( ord_less @ A @ ( F @ N2 ) @ ( F @ M2 ) )
            = ( ord_less @ nat @ N2 @ M2 ) ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_50_lift__Suc__mono__less,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [F: ( nat > A ),N2: nat,N4: nat] :
          ( ! [N3: nat] :
              ( ord_less @ A @ ( F @ N3 ) @ ( F @ ( suc @ N3 ) ) )
         => ( ( ord_less @ nat @ N2 @ N4 )
           => ( ord_less @ A @ ( F @ N2 ) @ ( F @ N4 ) ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_51_less__Suc__eq__0__disj,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
      = ( ( M2
          = ( zero_zero @ nat ) )
        | ? [J: nat] :
            ( ( M2
              = ( suc @ J ) )
            & ( ord_less @ nat @ J @ N2 ) ) ) ) )).

% less_Suc_eq_0_disj
thf(fact_52_gr0__implies__Suc,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ? [M: nat] :
          ( N2
          = ( suc @ M ) ) ) )).

% gr0_implies_Suc
thf(fact_53_gr0__conv__Suc,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( ? [M4: nat] :
            ( N2
            = ( suc @ M4 ) ) ) ) )).

% gr0_conv_Suc
thf(fact_54_RuleSystem__Defs_Ocountable__R,axiom,(
    ! [Rule: $tType,Rules2: ( stream @ Rule )] :
      ( countable_countable @ Rule @ ( sset @ Rule @ Rules2 ) ) )).

% RuleSystem_Defs.countable_R
thf(fact_55_RuleSystem__Defs_ONE__R,axiom,(
    ! [Rule: $tType,Rules2: ( stream @ Rule )] :
      ( ( sset @ Rule @ Rules2 )
     != ( bot_bot @ ( set @ Rule ) ) ) )).

% RuleSystem_Defs.NE_R
thf(fact_56_not__less__less__Suc__eq,axiom,(
    ! [N2: nat,M2: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M2 ) )
        = ( N2 = M2 ) ) ) )).

% not_less_less_Suc_eq
thf(fact_57_strict__inc__induct,axiom,(
    ! [I: nat,J2: nat,P: ( nat > $o )] :
      ( ( ord_less @ nat @ I @ J2 )
     => ( ! [I2: nat] :
            ( ( J2
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I ) ) ) ) )).

% strict_inc_induct
thf(fact_58_less__Suc__induct,axiom,(
    ! [I: nat,J2: nat,P: ( nat > nat > $o )] :
      ( ( ord_less @ nat @ I @ J2 )
     => ( ! [I2: nat] :
            ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J3: nat,K: nat] :
              ( ( ord_less @ nat @ I2 @ J3 )
             => ( ( ord_less @ nat @ J3 @ K )
               => ( ( P @ I2 @ J3 )
                 => ( ( P @ J3 @ K )
                   => ( P @ I2 @ K ) ) ) ) )
         => ( P @ I @ J2 ) ) ) ) )).

% less_Suc_induct
thf(fact_59_less__trans__Suc,axiom,(
    ! [I: nat,J2: nat,K2: nat] :
      ( ( ord_less @ nat @ I @ J2 )
     => ( ( ord_less @ nat @ J2 @ K2 )
       => ( ord_less @ nat @ ( suc @ I ) @ K2 ) ) ) )).

% less_trans_Suc
thf(fact_60_Suc__less__SucD,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
     => ( ord_less @ nat @ M2 @ N2 ) ) )).

% Suc_less_SucD
thf(fact_61_less__antisym,axiom,(
    ! [N2: nat,M2: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M2 ) )
       => ( M2 = N2 ) ) ) )).

% less_antisym
thf(fact_62_Suc__less__eq2,axiom,(
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ M2 )
      = ( ? [M5: nat] :
            ( ( M2
              = ( suc @ M5 ) )
            & ( ord_less @ nat @ N2 @ M5 ) ) ) ) )).

% Suc_less_eq2
thf(fact_63_not__less__eq,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ~ ( ord_less @ nat @ M2 @ N2 ) )
      = ( ord_less @ nat @ N2 @ ( suc @ M2 ) ) ) )).

% not_less_eq
thf(fact_64_less__Suc__eq,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
      = ( ( ord_less @ nat @ M2 @ N2 )
        | ( M2 = N2 ) ) ) )).

% less_Suc_eq
thf(fact_65_less__SucI,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ord_less @ nat @ M2 @ ( suc @ N2 ) ) ) )).

% less_SucI
thf(fact_66_less__SucE,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ ( suc @ N2 ) )
     => ( ~ ( ord_less @ nat @ M2 @ N2 )
       => ( M2 = N2 ) ) ) )).

% less_SucE
thf(fact_67_Suc__lessI,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ( ( suc @ M2 )
         != N2 )
       => ( ord_less @ nat @ ( suc @ M2 ) @ N2 ) ) ) )).

% Suc_lessI
thf(fact_68_Suc__lessE,axiom,(
    ! [I: nat,K2: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ K2 )
     => ~ ( ! [J3: nat] :
              ( ( ord_less @ nat @ I @ J3 )
             => ( K2
               != ( suc @ J3 ) ) ) ) ) )).

% Suc_lessE
thf(fact_69_Suc__lessD,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M2 ) @ N2 )
     => ( ord_less @ nat @ M2 @ N2 ) ) )).

% Suc_lessD
thf(fact_70_lessE,axiom,(
    ! [I: nat,K2: nat] :
      ( ( ord_less @ nat @ I @ K2 )
     => ( ( K2
         != ( suc @ I ) )
       => ~ ( ! [J3: nat] :
                ( ( ord_less @ nat @ I @ J3 )
               => ( K2
                 != ( suc @ J3 ) ) ) ) ) ) )).

% lessE
thf(fact_71_not0__implies__Suc,axiom,(
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ? [M: nat] :
          ( N2
          = ( suc @ M ) ) ) )).

% not0_implies_Suc
thf(fact_72_old_Onat_Oinducts,axiom,(
    ! [P: ( nat > $o ),Nat: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [Nat3: nat] :
            ( ( P @ Nat3 )
           => ( P @ ( suc @ Nat3 ) ) )
       => ( P @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_73_old_Onat_Oexhaust,axiom,(
    ! [Y3: nat] :
      ( ( Y3
       != ( zero_zero @ nat ) )
     => ~ ( ! [Nat3: nat] :
              ( Y3
             != ( suc @ Nat3 ) ) ) ) )).

% old.nat.exhaust
thf(fact_74_Zero__not__Suc,axiom,(
    ! [M2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M2 ) ) )).

% Zero_not_Suc
thf(fact_75_Zero__neq__Suc,axiom,(
    ! [M2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M2 ) ) )).

% Zero_neq_Suc
thf(fact_76_Suc__neq__Zero,axiom,(
    ! [M2: nat] :
      ( ( suc @ M2 )
     != ( zero_zero @ nat ) ) )).

% Suc_neq_Zero
thf(fact_77_zero__induct,axiom,(
    ! [P: ( nat > $o ),K2: nat] :
      ( ( P @ K2 )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) )).

% zero_induct
thf(fact_78_diff__induct,axiom,(
    ! [P: ( nat > nat > $o ),M2: nat,N2: nat] :
      ( ! [X3: nat] :
          ( P @ X3 @ ( zero_zero @ nat ) )
     => ( ! [Y4: nat] :
            ( P @ ( zero_zero @ nat ) @ ( suc @ Y4 ) )
       => ( ! [X3: nat,Y4: nat] :
              ( ( P @ X3 @ Y4 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y4 ) ) )
         => ( P @ M2 @ N2 ) ) ) ) )).

% diff_induct
thf(fact_79_nat__induct,axiom,(
    ! [P: ( nat > $o ),N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N3: nat] :
            ( ( P @ N3 )
           => ( P @ ( suc @ N3 ) ) )
       => ( P @ N2 ) ) ) )).

% nat_induct
thf(fact_80_nat_OdiscI,axiom,(
    ! [Nat: nat,X2: nat] :
      ( ( Nat
        = ( suc @ X2 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) )).

% nat.discI
thf(fact_81_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_82_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) )).

% old.nat.distinct(2)
thf(fact_83_nat_Odistinct_I1_J,axiom,(
    ! [X2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X2 ) ) )).

% nat.distinct(1)
thf(fact_84_snth__sset,axiom,(
    ! [A: $tType,S: ( stream @ A ),N2: nat] :
      ( member @ A @ ( snth @ A @ S @ N2 ) @ ( sset @ A @ S ) ) )).

% snth_sset
thf(fact_85_smap__alt,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S: ( stream @ B ),S3: ( stream @ A )] :
      ( ( ( smap @ B @ A @ F @ S )
        = S3 )
      = ( ! [N: nat] :
            ( ( F @ ( snth @ B @ S @ N ) )
            = ( snth @ A @ S3 @ N ) ) ) ) )).

% smap_alt
thf(fact_86_n__not__Suc__n,axiom,(
    ! [N2: nat] :
      ( N2
     != ( suc @ N2 ) ) )).

% n_not_Suc_n
thf(fact_87_Suc__inject,axiom,(
    ! [X: nat,Y3: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y3 ) )
     => ( X = Y3 ) ) )).

% Suc_inject
thf(fact_88_stream_Omap__ident,axiom,(
    ! [A: $tType,T: ( stream @ A )] :
      ( ( smap @ A @ A
        @ ^ [X4: A] : X4
        @ T )
      = T ) )).

% stream.map_ident
thf(fact_89_stream__smap__nats,axiom,(
    ! [A: $tType,S: ( stream @ A )] :
      ( S
      = ( smap @ nat @ A @ ( snth @ A @ S ) @ ( siterate @ nat @ suc @ ( zero_zero @ nat ) ) ) ) )).

% stream_smap_nats
thf(fact_90_RuleSystem__Defs_Osset__fenum,axiom,(
    ! [Rule: $tType,Rules2: ( stream @ Rule )] :
      ( ( sset @ Rule @ ( abstra1774373515_fenum @ Rule @ Rules2 ) )
      = ( sset @ Rule @ Rules2 ) ) )).

% RuleSystem_Defs.sset_fenum
thf(fact_91_countable__empty,axiom,(
    ! [A: $tType] :
      ( countable_countable @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% countable_empty
thf(fact_92_bex__empty,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( bot_bot @ ( set @ A ) ) )
            & ( P @ X5 ) ) ) )).

% bex_empty
thf(fact_93_not__gr__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) )).

% not_gr_zero
thf(fact_94_less__numeral__extra_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) )).

% less_numeral_extra(2)
thf(fact_95_less__numeral__extra_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) )).

% less_numeral_extra(1)
thf(fact_96_zero__less__one,axiom,(
    ! [A: $tType] :
      ( ( zero_less_one @ A @ ( type2 @ A ) )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) )).

% zero_less_one
thf(fact_97_not__one__less__zero,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) )).

% not_one_less_zero
thf(fact_98_countableI__type,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ A )] :
          ( countable_countable @ A @ A3 ) ) )).

% countableI_type
thf(fact_99_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_100_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_101_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_102_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_103_not__psubset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_104_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_105_linorder__neqE__linordered__idom,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( X != Y3 )
         => ( ~ ( ord_less @ A @ X @ Y3 )
           => ( ord_less @ A @ Y3 @ X ) ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_106_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_107_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_108_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y4: A] :
          ~ ( member @ A @ Y4 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_109_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_110_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_111_Bex__def,axiom,(
    ! [A: $tType] :
      ( ( bex @ A )
      = ( ^ [A4: ( set @ A ),P2: ( A > $o )] :
          ? [X4: A] :
            ( ( member @ A @ X4 @ A4 )
            & ( P2 @ X4 ) ) ) ) )).

% Bex_def
thf(fact_112_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X4: A] : $false ) ) )).

% empty_def
thf(fact_113_countable__Collect,axiom,(
    ! [A: $tType,A3: ( set @ A ),Phi: ( A > $o )] :
      ( ( countable_countable @ A @ A3 )
     => ( countable_countable @ A
        @ ( collect @ A
          @ ^ [A5: A] :
              ( ( member @ A @ A5 @ A3 )
              & ( Phi @ A5 ) ) ) ) ) )).

% countable_Collect
thf(fact_114_zero__less__iff__neq__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N2 )
          = ( N2
           != ( zero_zero @ A ) ) ) ) )).

% zero_less_iff_neq_zero
thf(fact_115_gr__implies__not__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [M2: A,N2: A] :
          ( ( ord_less @ A @ M2 @ N2 )
         => ( N2
           != ( zero_zero @ A ) ) ) ) )).

% gr_implies_not_zero
thf(fact_116_not__less__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ~ ( ord_less @ A @ N2 @ ( zero_zero @ A ) ) ) )).

% not_less_zero
thf(fact_117_gr__zeroI,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( N2
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) ) ) )).

% gr_zeroI
thf(fact_118_less__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% less_numeral_extra(3)
thf(fact_119_zero__neq__one,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) )).

% zero_neq_one
thf(fact_120_less__numeral__extra_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) )).

% less_numeral_extra(4)
thf(fact_121_bot__apply,axiom,(
    ! [C2: $tType,D: $tType] :
      ( ( bot @ C2 @ ( type2 @ C2 ) )
     => ( ( bot_bot @ ( D > C2 ) )
        = ( ^ [X4: D] :
              ( bot_bot @ C2 ) ) ) ) )).

% bot_apply
thf(fact_122_snth__sset__smerge,axiom,(
    ! [A: $tType,Ss: ( stream @ ( stream @ A ) ),N2: nat,M2: nat] :
      ( member @ A @ ( snth @ A @ ( snth @ ( stream @ A ) @ Ss @ N2 ) @ M2 ) @ ( sset @ A @ ( smerge @ A @ Ss ) ) ) )).

% snth_sset_smerge
thf(fact_123_list__decode_Ocases,axiom,(
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ~ ( ! [N3: nat] :
              ( X
             != ( suc @ N3 ) ) ) ) )).

% list_decode.cases
thf(fact_124_dependent__nat__choice,axiom,(
    ! [A: $tType,P: ( nat > A > $o ),Q: ( nat > A > A > $o )] :
      ( ? [X1: A] :
          ( P @ ( zero_zero @ nat ) @ X1 )
     => ( ! [X3: A,N3: nat] :
            ( ( P @ N3 @ X3 )
           => ? [Y: A] :
                ( ( P @ ( suc @ N3 ) @ Y )
                & ( Q @ N3 @ X3 @ Y ) ) )
       => ? [F2: ( nat > A )] :
          ! [N5: nat] :
            ( ( P @ N5 @ ( F2 @ N5 ) )
            & ( Q @ N5 @ ( F2 @ N5 ) @ ( F2 @ ( suc @ N5 ) ) ) ) ) ) )).

% dependent_nat_choice
thf(fact_125_exists__least__lemma,axiom,(
    ! [P: ( nat > $o )] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X1: nat] :
            ( P @ X1 )
       => ? [N3: nat] :
            ( ~ ( P @ N3 )
            & ( P @ ( suc @ N3 ) ) ) ) ) )).

% exists_least_lemma
thf(fact_126_psubsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ C @ A3 )
       => ( member @ A @ C @ B2 ) ) ) )).

% psubsetD
thf(fact_127_less__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B3: ( set @ A )] :
            ( ord_less @ ( A > $o )
            @ ^ [X4: A] :
                ( member @ A @ X4 @ A4 )
            @ ^ [X4: A] :
                ( member @ A @ X4 @ B3 ) ) ) ) )).

% less_set_def
thf(fact_128_psubset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B2 )
     => ( ( ord_less @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% psubset_trans
thf(fact_129_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_130_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) )).

% bot_nat_def
thf(fact_131_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B4: B,C: B] :
          ( ( A2
            = ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_132_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B4: A,F: ( A > B ),C: B] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ( F @ B4 )
              = C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ B @ ( F @ A2 ) @ C ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_133_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B4: B,C: B] :
          ( ( ord_less @ A @ A2 @ ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_134_order__less__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B4: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ord_less @ C2 @ ( F @ B4 ) @ C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ C2 @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ C2 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% order_less_subst2
thf(fact_135_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y4: A] :
          ( ord_less @ A @ Y4 @ X ) ) )).

% lt_ex
thf(fact_136_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X12: A] :
          ( ord_less @ A @ X @ X12 ) ) )).

% gt_ex
thf(fact_137_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( X != Y3 )
         => ( ~ ( ord_less @ A @ X @ Y3 )
           => ( ord_less @ A @ Y3 @ X ) ) ) ) )).

% neqE
thf(fact_138_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( X != Y3 )
          = ( ( ord_less @ A @ X @ Y3 )
            | ( ord_less @ A @ Y3 @ X ) ) ) ) )).

% neq_iff
thf(fact_139_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A2 ) ) ) )).

% order.asym
thf(fact_140_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ? [Z: A] :
              ( ( ord_less @ A @ X @ Z )
              & ( ord_less @ A @ Z @ Y3 ) ) ) ) )).

% dense
thf(fact_141_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( X != Y3 ) ) ) )).

% less_imp_neq
thf(fact_142_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ~ ( ord_less @ A @ Y3 @ X ) ) ) )).

% less_asym
thf(fact_143_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A2 ) ) ) )).

% less_asym'
thf(fact_144_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( ord_less @ A @ Y3 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) )).

% less_trans
thf(fact_145_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
          | ( X = Y3 )
          | ( ord_less @ A @ Y3 @ X ) ) ) )).

% less_linear
thf(fact_146_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) )).

% less_irrefl
thf(fact_147_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C: A] :
          ( ( A2 = B4 )
         => ( ( ord_less @ A @ B4 @ C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% ord_eq_less_trans
thf(fact_148_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( B4 = C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% ord_less_eq_trans
thf(fact_149_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B4 ) ) ) )).

% dual_order.asym
thf(fact_150_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( X != Y3 ) ) ) )).

% less_imp_not_eq
thf(fact_151_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ~ ( ord_less @ A @ Y3 @ X ) ) ) )).

% less_not_sym
thf(fact_152_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),A2: A] :
          ( ! [X3: A] :
              ( ! [Y: A] :
                  ( ( ord_less @ A @ Y @ X3 )
                 => ( P @ Y ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) )).

% less_induct
thf(fact_153_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y3: A,X: A] :
          ( ~ ( ord_less @ A @ Y3 @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y3 ) )
            = ( X = Y3 ) ) ) ) )).

% antisym_conv3
thf(fact_154_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( Y3 != X ) ) ) )).

% less_imp_not_eq2
thf(fact_155_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A,P: $o] :
          ( ( ord_less @ A @ X @ Y3 )
         => ( ( ord_less @ A @ Y3 @ X )
           => P ) ) ) )).

% less_imp_triv
thf(fact_156_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ~ ( ord_less @ A @ X @ Y3 )
         => ( ( X != Y3 )
           => ( ord_less @ A @ Y3 @ X ) ) ) ) )).

% linorder_cases
thf(fact_157_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) )).

% dual_order.irrefl
thf(fact_158_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ord_less @ A @ B4 @ C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% order.strict_trans
thf(fact_159_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ord_less @ A @ X @ Y3 )
         => ~ ( ord_less @ A @ Y3 @ X ) ) ) )).

% less_imp_not_less
thf(fact_160_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A,C: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ( ( ord_less @ A @ C @ B4 )
           => ( ord_less @ A @ C @ A2 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_161_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y3: A] :
          ( ( ~ ( ord_less @ A @ X @ Y3 ) )
          = ( ( ord_less @ A @ Y3 @ X )
            | ( X = Y3 ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_162_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( A2 != B4 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_163_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ( A2 != B4 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_164_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_165_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_166_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) )).

% bot.not_eq_extremum
thf(fact_167_dbl__inc__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) )).

% dbl_inc_simps(2)
thf(fact_168_smerge__def,axiom,(
    ! [A: $tType] :
      ( ( smerge @ A )
      = ( ^ [Ss2: ( stream @ ( stream @ A ) )] :
            ( flat @ A
            @ ( smap @ nat @ ( list @ A )
              @ ^ [N: nat] :
                  ( append @ A
                  @ ( map @ ( stream @ A ) @ A
                    @ ^ [S4: ( stream @ A )] :
                        ( snth @ A @ S4 @ N )
                    @ ( stake @ ( stream @ A ) @ ( suc @ N ) @ Ss2 ) )
                  @ ( stake @ A @ N @ ( snth @ ( stream @ A ) @ Ss2 @ N ) ) )
              @ ( siterate @ nat @ suc @ ( zero_zero @ nat ) ) ) ) ) ) )).

% smerge_def
thf(fact_169_stream__smap__fromN,axiom,(
    ! [A: $tType,S: ( stream @ A ),N2: nat] :
      ( S
      = ( smap @ nat @ A
        @ ^ [J: nat] :
            ( snth @ A @ S @ ( minus_minus @ nat @ J @ N2 ) )
        @ ( siterate @ nat @ suc @ N2 ) ) ) )).

% stream_smap_fromN
thf(fact_170_Suc__diff__1,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
        = N2 ) ) )).

% Suc_diff_1
thf(fact_171_diff__self,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) )).

% diff_self
thf(fact_172_diff__0__right,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% diff_0_right
thf(fact_173_zero__diff,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% zero_diff
thf(fact_174_diff__zero,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% diff_zero
thf(fact_175_cancel__comm__monoid__add__class_Odiff__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) )).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_176_diff__0__eq__0,axiom,(
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) )).

% diff_0_eq_0
thf(fact_177_diff__self__eq__0,axiom,(
    ! [M2: nat] :
      ( ( minus_minus @ nat @ M2 @ M2 )
      = ( zero_zero @ nat ) ) )).

% diff_self_eq_0
thf(fact_178_Suc__diff__diff,axiom,(
    ! [M2: nat,N2: nat,K2: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M2 ) @ N2 ) @ ( suc @ K2 ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ K2 ) ) )).

% Suc_diff_diff
thf(fact_179_diff__Suc__Suc,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ M2 ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ M2 @ N2 ) ) )).

% diff_Suc_Suc
thf(fact_180_shift__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),S: ( stream @ A )] :
      ( ( shift @ A @ ( append @ A @ Xs @ Ys ) @ S )
      = ( shift @ A @ Xs @ ( shift @ A @ Ys @ S ) ) ) )).

% shift_append
thf(fact_181_diff__gt__0__iff__gt,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B4 ) )
          = ( ord_less @ A @ B4 @ A2 ) ) ) )).

% diff_gt_0_iff_gt
thf(fact_182_diff__numeral__special_I9_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) )).

% diff_numeral_special(9)
thf(fact_183_zero__less__diff,axiom,(
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M2 ) )
      = ( ord_less @ nat @ M2 @ N2 ) ) )).

% zero_less_diff
thf(fact_184_diff__Suc__1,axiom,(
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( one_one @ nat ) )
      = N2 ) )).

% diff_Suc_1
thf(fact_185_smap__shift,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),S: ( stream @ B )] :
      ( ( smap @ B @ A @ F @ ( shift @ B @ Xs @ S ) )
      = ( shift @ A @ ( map @ B @ A @ F @ Xs ) @ ( smap @ B @ A @ F @ S ) ) ) )).

% smap_shift
thf(fact_186_stake__smap,axiom,(
    ! [A: $tType,B: $tType,N2: nat,F: ( B > A ),S: ( stream @ B )] :
      ( ( stake @ A @ N2 @ ( smap @ B @ A @ F @ S ) )
      = ( map @ B @ A @ F @ ( stake @ B @ N2 @ S ) ) ) )).

% stake_smap
thf(fact_187_Suc__pred,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) )).

% Suc_pred
thf(fact_188_diff__strict__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C ) @ ( minus_minus @ A @ B4 @ C ) ) ) ) )).

% diff_strict_right_mono
thf(fact_189_diff__strict__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A,C: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C @ A2 ) @ ( minus_minus @ A @ C @ B4 ) ) ) ) )).

% diff_strict_left_mono
thf(fact_190_diff__eq__diff__less,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B4 )
            = ( minus_minus @ A @ C @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B4 )
            = ( ord_less @ A @ C @ D2 ) ) ) ) )).

% diff_eq_diff_less
thf(fact_191_diff__strict__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,D2: A,C: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ord_less @ A @ D2 @ C )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C ) @ ( minus_minus @ A @ B4 @ D2 ) ) ) ) ) )).

% diff_strict_mono
thf(fact_192_diff__less__mono2,axiom,(
    ! [M2: nat,N2: nat,L: nat] :
      ( ( ord_less @ nat @ M2 @ N2 )
     => ( ( ord_less @ nat @ M2 @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N2 ) @ ( minus_minus @ nat @ L @ M2 ) ) ) ) )).

% diff_less_mono2
thf(fact_193_less__imp__diff__less,axiom,(
    ! [J2: nat,K2: nat,N2: nat] :
      ( ( ord_less @ nat @ J2 @ K2 )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J2 @ N2 ) @ K2 ) ) )).

% less_imp_diff_less
thf(fact_194_diff__commute,axiom,(
    ! [I: nat,J2: nat,K2: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J2 ) @ K2 )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I @ K2 ) @ J2 ) ) )).

% diff_commute
thf(fact_195_zero__induct__lemma,axiom,(
    ! [P: ( nat > $o ),K2: nat,I: nat] :
      ( ( P @ K2 )
     => ( ! [N3: nat] :
            ( ( P @ ( suc @ N3 ) )
           => ( P @ N3 ) )
       => ( P @ ( minus_minus @ nat @ K2 @ I ) ) ) ) )).

% zero_induct_lemma
thf(fact_196_diffs0__imp__equal,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M2 @ N2 )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N2 @ M2 )
          = ( zero_zero @ nat ) )
       => ( M2 = N2 ) ) ) )).

% diffs0_imp_equal
thf(fact_197_minus__nat_Odiff__0,axiom,(
    ! [M2: nat] :
      ( ( minus_minus @ nat @ M2 @ ( zero_zero @ nat ) )
      = M2 ) )).

% minus_nat.diff_0
thf(fact_198_eq__iff__diff__eq__0,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ( ( ^ [Y5: A,Z3: A] : ( Y5 = Z3 ) )
        = ( ^ [A5: A,B5: A] :
              ( ( minus_minus @ A @ A5 @ B5 )
              = ( zero_zero @ A ) ) ) ) ) )).

% eq_iff_diff_eq_0
thf(fact_199_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B4 )
            = ( minus_minus @ A @ C @ D2 ) )
         => ( ( A2 = B4 )
            = ( C = D2 ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_200_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B4: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C ) @ B4 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B4 ) @ C ) ) ) )).

% diff_right_commute
thf(fact_201_less__iff__diff__less__0,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B5: A] :
              ( ord_less @ A @ ( minus_minus @ A @ A5 @ B5 ) @ ( zero_zero @ A ) ) ) ) ) )).

% less_iff_diff_less_0
thf(fact_202_diff__less,axiom,(
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ M2 ) ) ) )).

% diff_less
thf(fact_203_Suc__diff__Suc,axiom,(
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ N2 @ M2 )
     => ( ( suc @ ( minus_minus @ nat @ M2 @ ( suc @ N2 ) ) )
        = ( minus_minus @ nat @ M2 @ N2 ) ) ) )).

% Suc_diff_Suc
thf(fact_204_diff__less__Suc,axiom,(
    ! [M2: nat,N2: nat] :
      ( ord_less @ nat @ ( minus_minus @ nat @ M2 @ N2 ) @ ( suc @ M2 ) ) )).

% diff_less_Suc
thf(fact_205_diff__Suc__eq__diff__pred,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ M2 @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M2 @ ( one_one @ nat ) ) @ N2 ) ) )).

% diff_Suc_eq_diff_pred
thf(fact_206_diff__Suc__less,axiom,(
    ! [N2: nat,I: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ I ) ) @ N2 ) ) )).

% diff_Suc_less
thf(fact_207_Suc__diff__eq__diff__pred,axiom,(
    ! [N2: nat,M2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( minus_minus @ nat @ ( suc @ M2 ) @ N2 )
        = ( minus_minus @ nat @ M2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) )).

% Suc_diff_eq_diff_pred
thf(fact_208_Suc__pred_H,axiom,(
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( N2
        = ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) )).

% Suc_pred'
thf(fact_209_map__append,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),Ys: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F @ Xs ) @ ( map @ B @ A @ F @ Ys ) ) ) )).

% map_append
thf(fact_210_Suc__if__eq,axiom,(
    ! [A: $tType,F: ( nat > A ),H: ( nat > A ),G: A,N2: nat] :
      ( ! [N3: nat] :
          ( ( F @ ( suc @ N3 ) )
          = ( H @ N3 ) )
     => ( ( ( F @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( F @ N2 )
              = G ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( F @ N2 )
              = ( H @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% Suc_if_eq
thf(fact_211_map__ident,axiom,(
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4 )
      = ( ^ [Xs2: ( list @ A )] : Xs2 ) ) )).

% map_ident
thf(fact_212_Diff__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) )).

% Diff_empty
thf(fact_213_empty__Diff,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_214_Diff__cancel,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_215_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_216_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_217_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_218_countable__Diff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( countable_countable @ A @ A3 )
     => ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% countable_Diff
thf(fact_219_psubset__imp__ex__mem,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B2 )
     => ? [B6: A] :
          ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B2 @ A3 ) ) ) )).

% psubset_imp_ex_mem
thf(fact_220_uncountable__minus__countable,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( countable_countable @ A @ A3 )
     => ( ( countable_countable @ A @ B2 )
       => ~ ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) ) ) )).

% uncountable_minus_countable
thf(fact_221_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_222_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_223_list_Omap__ident,axiom,(
    ! [A: $tType,T: ( list @ A )] :
      ( ( map @ A @ A
        @ ^ [X4: A] : X4
        @ T )
      = T ) )).

% list.map_ident
thf(fact_224_minus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A4: ( A > B ),B3: ( A > B ),X4: A] :
              ( minus_minus @ B @ ( A4 @ X4 ) @ ( B3 @ X4 ) ) ) ) ) )).

% minus_apply
thf(fact_225_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_226_DiffI,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ A3 )
     => ( ~ ( member @ A @ C @ B2 )
       => ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) ) ) )).

% DiffI
thf(fact_227_Diff__iff,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( member @ A @ C @ A3 )
        & ~ ( member @ A @ C @ B2 ) ) ) )).

% Diff_iff
thf(fact_228_Diff__idemp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) @ B2 )
      = ( minus_minus @ ( set @ A ) @ A3 @ B2 ) ) )).

% Diff_idemp
thf(fact_229_DiffE,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
     => ~ ( ( member @ A @ C @ A3 )
         => ( member @ A @ C @ B2 ) ) ) )).

% DiffE
thf(fact_230_DiffD1,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
     => ( member @ A @ C @ A3 ) ) )).

% DiffD1
thf(fact_231_DiffD2,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B2 ) )
     => ~ ( member @ A @ C @ B2 ) ) )).

% DiffD2
thf(fact_232_set__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B3: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ A4 )
                & ~ ( member @ A @ X4 @ B3 ) ) ) ) ) )).

% set_diff_eq
thf(fact_233_minus__set__def,axiom,(
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B3: ( set @ A )] :
            ( collect @ A
            @ ( minus_minus @ ( A > $o )
              @ ^ [X4: A] :
                  ( member @ A @ X4 @ A4 )
              @ ^ [X4: A] :
                  ( member @ A @ X4 @ B3 ) ) ) ) ) )).

% minus_set_def
thf(fact_234_fun__diff__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A4: ( A > B ),B3: ( A > B ),X4: A] :
              ( minus_minus @ B @ ( A4 @ X4 ) @ ( B3 @ X4 ) ) ) ) ) )).

% fun_diff_def
thf(fact_235_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_236_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_237_ln__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) )).

% ln_one
thf(fact_238_map__eq__map__tailrec,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) )).

% map_eq_map_tailrec
thf(fact_239_powr__zero__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) )).

% powr_zero_eq_one
thf(fact_240_powr__one__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) )).

% powr_one_eq_one
thf(fact_241_powr__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [W: A,Z2: A] :
          ( ( ( powr @ A @ W @ Z2 )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) )).

% powr_eq_0_iff
thf(fact_242_powr__0,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [Z2: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z2 )
          = ( zero_zero @ A ) ) ) )).

% powr_0
thf(fact_243_diff__Suc,axiom,(
    ! [M2: nat,N2: nat] :
      ( ( minus_minus @ nat @ M2 @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M2 @ N2 ) ) ) )).

% diff_Suc
thf(fact_244_fun__cong__unused__0,axiom,(
    ! [A: $tType,B: $tType,C2: $tType] :
      ( ( zero @ B @ ( type2 @ B ) )
     => ! [F: ( ( A > B ) > C2 ),G: C2] :
          ( ( F
            = ( ^ [X4: ( A > B )] : G ) )
         => ( ( F
              @ ^ [X4: A] :
                  ( zero_zero @ B ) )
            = G ) ) ) )).

% fun_cong_unused_0
thf(fact_245_nat_Ocase__distrib,axiom,(
    ! [B: $tType,A: $tType,H: ( A > B ),F1: A,F22: ( nat > A ),Nat: nat] :
      ( ( H @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H @ F1 )
        @ ^ [X4: nat] :
            ( H @ ( F22 @ X4 ) )
        @ Nat ) ) )).

% nat.case_distrib
thf(fact_246_old_Onat_Osimps_I5_J,axiom,(
    ! [A: $tType,F1: A,F22: ( nat > A ),X2: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X2 ) )
      = ( F22 @ X2 ) ) )).

% old.nat.simps(5)
thf(fact_247_old_Onat_Osimps_I4_J,axiom,(
    ! [A: $tType,F1: A,F22: ( nat > A )] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) )).

% old.nat.simps(4)
thf(fact_248_Nitpick_Ocase__nat__unfold,axiom,(
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X4: A,F3: ( nat > A ),N: nat] :
            ( if @ A
            @ ( N
              = ( zero_zero @ nat ) )
            @ X4
            @ ( F3 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) )).

% Nitpick.case_nat_unfold
thf(fact_249_nat_Osplit__sels_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o ),F1: A,F22: ( nat > A ),Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) )).

% nat.split_sels(1)
thf(fact_250_nat_Odisc__eq__case_I2_J,axiom,(
    ! [Nat: nat] :
      ( ( Nat
       != ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu: nat] : $true
        @ Nat ) ) )).

% nat.disc_eq_case(2)
thf(fact_251_nat_Odisc__eq__case_I1_J,axiom,(
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu: nat] : $false
        @ Nat ) ) )).

% nat.disc_eq_case(1)

%----Type constructors (46)
thf(tcon_HOL_Obool___Finite__Set_Ofinite,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_1,axiom,(
    ! [A6: $tType] :
      ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
     => ( finite_finite @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite_2,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
        & ( finite_finite @ A7 @ ( type2 @ A7 ) ) )
     => ( finite_finite @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order_bot @ A7 @ ( type2 @ A7 ) )
     => ( order_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Countable_Ocountable,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
        & ( countable @ A7 @ ( type2 @ A7 ) ) )
     => ( countable @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( preorder @ A7 @ ( type2 @ A7 ) )
     => ( preorder @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bot @ A7 @ ( type2 @ A7 ) )
     => ( bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( minus @ A7 @ ( type2 @ A7 ) )
     => ( minus @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring,axiom,
    ( linord1659791738miring @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add,axiom,
    ( cancel146912293up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    ( comm_monoid_diff @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ozero__less__one,axiom,
    ( zero_less_one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_3,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Countable_Ocountable_4,axiom,
    ( countable @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one,axiom,
    ( zero_neq_one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_5,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Ono__top,axiom,
    ( no_top @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_6,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_7,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_8,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ominus_9,axiom,
    ( minus @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oone,axiom,
    ( one @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_10,axiom,(
    ! [A6: $tType] :
      ( order_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Countable_Ocountable_11,axiom,(
    ! [A6: $tType] :
      ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
     => ( countable @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_12,axiom,(
    ! [A6: $tType] :
      ( preorder @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_13,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_14,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_15,axiom,(
    ! [A6: $tType] :
      ( bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_16,axiom,(
    ! [A6: $tType] :
      ( minus @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_17,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Countable_Ocountable_18,axiom,
    ( countable @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_19,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_20,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_21,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_22,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_23,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_24,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

thf(tcon_List_Olist___Countable_Ocountable_25,axiom,(
    ! [A6: $tType] :
      ( ( countable @ A6 @ ( type2 @ A6 ) )
     => ( countable @ ( list @ A6 ) @ ( type2 @ ( list @ A6 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y3: A] :
      ( ( if @ A @ $false @ X @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y3: A] :
      ( ( if @ A @ $true @ X @ Y3 )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( member @ rule @ r
    @ ( sset @ rule
      @ ( shift @ rule @ rsa
        @ ( flat @ rule
          @ ( smap @ nat @ ( list @ rule )
            @ ^ [N: nat] :
                ( stake @ rule @ N @ rules )
            @ ( siterate @ nat @ suc @ na ) ) ) ) ) )).

%------------------------------------------------------------------------------
