%------------------------------------------------------------------------------
% File     : COM155^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Abstract completeness 181
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BPT14] Blanchette et al. (2014), Abstract Completeness
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : abstract_completeness__181.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  362 (   1 unit;  76 type;   0 defn)
%            Number of atoms       : 4242 ( 297 equality;2515 variable)
%            Maximal formula depth :   28 (   9 average)
%            Number of connectives : 3994 (  85   ~;   6   |;  49   &;3650   @)
%                                         (   0 <=>; 204  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  338 ( 338   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   81 (  76   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1163 (   7 sgn; 945   !;  29   ?; 106   ^)
%                                         (1163   :;  80  !>;   0  ?*)
%                                         (   0  @-;   3  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:53:50.994
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree,type,(
    abstra2103299360e_tree: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_FSet_Ofset,type,(
    fset: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_tf_state,type,(
    state: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_rule,type,(
    rule: $tType )).

%----Explicit typings (67)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable_Ocountable,type,(
    countable: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem,type,(
    abstra1326562878System: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( set @ State ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem_OminWait,type,(
    abstra1332369113inWait: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > nat ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OSaturated,type,(
    abstra1209608345urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oenabled,type,(
    abstra1874422341nabled: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofair,type,(
    abstra928354080m_fair: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofenum,type,(
    abstra1774373515_fenum: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OmkTree,type,(
    abstra1225283448mkTree: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OpickEff,type,(
    abstra1276541928ickEff: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > ( fset @ State ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Osaturated,type,(
    abstra726722745urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Otrim,type,(
    abstra1259602206m_trim: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > ( stream @ Rule ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Oipath,type,(
    abstra313004635_ipath: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Okonig,type,(
    abstra1918223989_konig: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otfinite,type,(
    abstra668420080finite: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_ONode,type,(
    abstra388494275e_Node: 
      !>[A: $tType] :
        ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > ( abstra2103299360e_tree @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Ocase__tree,type,(
    abstra457966479e_tree: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ) > ( abstra2103299360e_tree @ A ) > B ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Ocont,type,(
    abstra1749095923e_cont: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( fset @ ( abstra2103299360e_tree @ A ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Oroot,type,(
    abstra573067619e_root: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > A ) )).

thf(sy_c_Countable__Set_Ocountable,type,(
    countable_countable: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_FSet_Ofimage,type,(
    fimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( fset @ A ) > ( fset @ B ) ) )).

thf(sy_c_FSet_Ofmember,type,(
    fmember: 
      !>[A: $tType] :
        ( A > ( fset @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_OHLD,type,(
    linear1178169911on_HLD: 
      !>[A: $tType] :
        ( ( set @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Oev__at,type,(
    linear2074238637_ev_at: 
      !>[A: $tType] :
        ( ( ( stream @ A ) > $o ) > nat > ( stream @ A ) > $o ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Oholds,type,(
    linear1707521579_holds: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > $o ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_OLeast,type,(
    ord_Least: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Stream_Osdrop,type,(
    sdrop: 
      !>[A: $tType] :
        ( nat > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osdrop__while,type,(
    sdrop_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osfilter,type,(
    sfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osinterleave,type,(
    sinterleave: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osmap2,type,(
    smap2: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( stream @ A ) > ( stream @ B ) > ( stream @ C ) ) )).

thf(sy_c_Stream_Osmember,type,(
    smember: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Osmerge,type,(
    smerge: 
      !>[A: $tType] :
        ( ( stream @ ( stream @ A ) ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osnth,type,(
    snth: 
      !>[A: $tType] :
        ( ( stream @ A ) > nat > A ) )).

thf(sy_c_Stream_Ostream_OSCons,type,(
    sCons: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Ocase__stream,type,(
    case_stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Stream_Ostream_Ocorec__stream,type,(
    corec_stream: 
      !>[C: $tType,A: $tType] :
        ( ( C > A ) > ( C > $o ) > ( C > ( stream @ A ) ) > ( C > C ) > C > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Oshd,type,(
    shd: 
      !>[A: $tType] :
        ( ( stream @ A ) > A ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream_Ostream_Ostl,type,(
    stl: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Oszip,type,(
    szip: 
      !>[A: $tType,B: $tType] :
        ( ( stream @ A ) > ( stream @ B ) > ( stream @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_S,type,(
    s: ( set @ state ) )).

thf(sy_v_eff,type,(
    eff: rule > state > ( fset @ state ) > $o )).

thf(sy_v_r____,type,(
    r: rule )).

thf(sy_v_rs,type,(
    rs: ( stream @ rule ) )).

thf(sy_v_rules,type,(
    rules: ( stream @ rule ) )).

thf(sy_v_s,type,(
    s2: state )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

%----Relevant facts (256)
thf(fact_0_s,axiom,
    ( member @ state @ s2 @ s )).

% s
thf(fact_1_r,axiom,
    ( member @ rule @ r @ ( sset @ rule @ rules ) )).

% r
thf(fact_2_e,axiom,
    ( abstra1874422341nabled @ rule @ state @ eff @ r @ s2 )).

% e
thf(fact_3__092_060open_062_092_060And_062m_O_Afair_A_Isdrop_Am_Ars_J_092_060close_062,axiom,(
    ! [M: nat] :
      ( abstra928354080m_fair @ rule @ rules @ ( sdrop @ rule @ M @ rs ) ) )).

% \<open>\<And>m. fair (sdrop m rs)\<close>
thf(fact_4_rs,axiom,
    ( abstra928354080m_fair @ rule @ rules @ rs )).

% rs
thf(fact_5_enabled__def,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
      = ( ^ [P: ( ( fset @ state ) > $o )] :
          ? [X: ( fset @ state )] :
            ( P @ X )
        @ ( eff @ R @ S ) ) ) )).

% enabled_def
thf(fact_6_sdrop__fair,axiom,(
    ! [Rs: ( stream @ rule ),M: nat] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( abstra928354080m_fair @ rule @ rules @ ( sdrop @ rule @ M @ Rs ) ) ) )).

% sdrop_fair
thf(fact_7_RuleSystem__Defs_Osdrop__fair,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule ),Rs: ( stream @ Rule ),M: nat] :
      ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
     => ( abstra928354080m_fair @ Rule @ Rules @ ( sdrop @ Rule @ M @ Rs ) ) ) )).

% RuleSystem_Defs.sdrop_fair
thf(fact_8_RuleSystem__Defs_Oenabled__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1874422341nabled @ Rule @ State )
      = ( ^ [Eff: ( Rule > State > ( fset @ State ) > $o ),R2: Rule,S2: State] :
            ( ^ [P: ( ( fset @ State ) > $o )] :
              ? [X: ( fset @ State )] :
                ( P @ X )
            @ ( Eff @ R2 @ S2 ) ) ) ) )).

% RuleSystem_Defs.enabled_def
thf(fact_9_sdrop__simps_I1_J,axiom,(
    ! [A: $tType,N: nat,S: ( stream @ A )] :
      ( ( shd @ A @ ( sdrop @ A @ N @ S ) )
      = ( snth @ A @ S @ N ) ) )).

% sdrop_simps(1)
thf(fact_10_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream @ A )] :
      ( member @ A @ ( shd @ A @ A2 ) @ ( sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_11_sdrop__szip,axiom,(
    ! [A: $tType,B: $tType,N: nat,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( sdrop @ ( product_prod @ A @ B ) @ N @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( szip @ A @ B @ ( sdrop @ A @ N @ S1 ) @ ( sdrop @ B @ N @ S22 ) ) ) )).

% sdrop_szip
thf(fact_12_sdrop__smap2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,N: nat,F: ( B > C > A ),S1: ( stream @ B ),S22: ( stream @ C )] :
      ( ( sdrop @ A @ N @ ( smap2 @ B @ C @ A @ F @ S1 @ S22 ) )
      = ( smap2 @ B @ C @ A @ F @ ( sdrop @ B @ N @ S1 ) @ ( sdrop @ C @ N @ S22 ) ) ) )).

% sdrop_smap2
thf(fact_13_sinterleave_Osimps_I1_J,axiom,(
    ! [A: $tType,S1: ( stream @ A ),S22: ( stream @ A )] :
      ( ( shd @ A @ ( sinterleave @ A @ S1 @ S22 ) )
      = ( shd @ A @ S1 ) ) )).

% sinterleave.simps(1)
thf(fact_14_stream_Ocorec__sel_I1_J,axiom,(
    ! [A: $tType,C: $tType,G1: ( C > A ),Q2: ( C > $o ),G21: ( C > ( stream @ A ) ),G22: ( C > C ),A2: C] :
      ( ( shd @ A @ ( corec_stream @ C @ A @ G1 @ Q2 @ G21 @ G22 @ A2 ) )
      = ( G1 @ A2 ) ) )).

% stream.corec_sel(1)
thf(fact_15_konig_Osimps_I1_J,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ( shd @ A @ ( abstra1918223989_konig @ A @ T2 ) )
      = ( abstra573067619e_root @ A @ T2 ) ) )).

% konig.simps(1)
thf(fact_16_HLD__iff,axiom,(
    ! [A: $tType] :
      ( ( linear1178169911on_HLD @ A )
      = ( ^ [S2: ( set @ A ),Omega: ( stream @ A )] :
            ( member @ A @ ( shd @ A @ Omega ) @ S2 ) ) ) )).

% HLD_iff
thf(fact_17_smap2_Osimps_I1_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( shd @ C @ ( smap2 @ A @ B @ C @ F @ S1 @ S22 ) )
      = ( F @ ( shd @ A @ S1 ) @ ( shd @ B @ S22 ) ) ) )).

% smap2.simps(1)
thf(fact_18_ev__at__imp__snth,axiom,(
    ! [A: $tType,P2: ( ( stream @ A ) > $o ),N: nat,Omega2: ( stream @ A )] :
      ( ( linear2074238637_ev_at @ A @ P2 @ N @ Omega2 )
     => ( P2 @ ( sdrop @ A @ N @ Omega2 ) ) ) )).

% ev_at_imp_snth
thf(fact_19_RuleSystem__axioms,axiom,
    ( abstra1326562878System @ rule @ state @ eff @ rules @ s )).

% RuleSystem_axioms
thf(fact_20_enabled__R,axiom,(
    ! [S: state] :
      ( ( member @ state @ S @ s )
     => ? [X2: rule] :
          ( ( member @ rule @ X2 @ ( sset @ rule @ rules ) )
          & ? [X1: ( fset @ state )] :
              ( eff @ X2 @ S @ X1 ) ) ) )).

% enabled_R
thf(fact_21__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062r_O_A_092_060lbrakk_062r_A_092_060in_062_AR_059_Aenabled_Ar_As_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [R3: rule] :
          ( ( member @ rule @ R3 @ ( sset @ rule @ rules ) )
         => ~ ( abstra1874422341nabled @ rule @ state @ eff @ R3 @ s2 ) ) ) )).

% \<open>\<And>thesis. (\<And>r. \<lbrakk>r \<in> R; enabled r s\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_22_snth__smap2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),S1: ( stream @ B ),S22: ( stream @ C ),N: nat] :
      ( ( snth @ A @ ( smap2 @ B @ C @ A @ F @ S1 @ S22 ) @ N )
      = ( F @ ( snth @ B @ S1 @ N ) @ ( snth @ C @ S22 @ N ) ) ) )).

% snth_smap2
thf(fact_23_sset__fenum,axiom,
    ( ( sset @ rule @ ( abstra1774373515_fenum @ rule @ rules ) )
    = ( sset @ rule @ rules ) )).

% sset_fenum
thf(fact_24_fair__fenum,axiom,
    ( abstra928354080m_fair @ rule @ rules @ ( abstra1774373515_fenum @ rule @ rules ) )).

% fair_fenum
thf(fact_25_pickEff,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
     => ( eff @ R @ S @ ( abstra1276541928ickEff @ rule @ state @ eff @ R @ S ) ) ) )).

% pickEff
thf(fact_26_smap2__alt,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > C > A ),S1: ( stream @ B ),S22: ( stream @ C ),S: ( stream @ A )] :
      ( ( ( smap2 @ B @ C @ A @ F @ S1 @ S22 )
        = S )
      = ( ! [N2: nat] :
            ( ( F @ ( snth @ B @ S1 @ N2 ) @ ( snth @ C @ S22 @ N2 ) )
            = ( snth @ A @ S @ N2 ) ) ) ) )).

% smap2_alt
thf(fact_27_snth__sset,axiom,(
    ! [A: $tType,S: ( stream @ A ),N: nat] :
      ( member @ A @ ( snth @ A @ S @ N ) @ ( sset @ A @ S ) ) )).

% snth_sset
thf(fact_28_stream_Ocorec__disc,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( corec_stream @ C @ A )
      = ( corec_stream @ C @ A ) ) )).

% stream.corec_disc
thf(fact_29_ev__at__unique,axiom,(
    ! [A: $tType,P2: ( ( stream @ A ) > $o ),N: nat,Omega2: ( stream @ A ),M: nat] :
      ( ( linear2074238637_ev_at @ A @ P2 @ N @ Omega2 )
     => ( ( linear2074238637_ev_at @ A @ P2 @ M @ Omega2 )
       => ( N = M ) ) ) )).

% ev_at_unique
thf(fact_30_ev__at__HLD__imp__snth,axiom,(
    ! [A: $tType,X3: ( set @ A ),N: nat,Omega2: ( stream @ A )] :
      ( ( linear2074238637_ev_at @ A @ ( linear1178169911on_HLD @ A @ X3 ) @ N @ Omega2 )
     => ( member @ A @ ( snth @ A @ Omega2 @ N ) @ X3 ) ) )).

% ev_at_HLD_imp_snth
thf(fact_31_Saturated__def,axiom,(
    ! [Steps: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1209608345urated @ rule @ state @ eff @ rules @ Steps )
      = ( ! [X4: rule] :
            ( ( member @ rule @ X4 @ ( sset @ rule @ rules ) )
           => ( abstra726722745urated @ rule @ state @ eff @ X4 @ Steps ) ) ) ) )).

% Saturated_def
thf(fact_32_trim__alt,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S )
          = ( sdrop @ rule @ ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S ) @ Rs ) ) ) ) )).

% trim_alt
thf(fact_33_eff__S,axiom,(
    ! [S: state,R: rule,Sl: ( fset @ state ),S3: state] :
      ( ( member @ state @ S @ s )
     => ( ( member @ rule @ R @ ( sset @ rule @ rules ) )
       => ( ( eff @ R @ S @ Sl )
         => ( ( fmember @ state @ S3 @ Sl )
           => ( member @ state @ S3 @ s ) ) ) ) ) )).

% eff_S
thf(fact_34_NE__R,axiom,(
    ( sset @ rule @ rules )
 != ( bot_bot @ ( set @ rule ) ) )).

% NE_R
thf(fact_35_snth__sset__smerge,axiom,(
    ! [A: $tType,Ss: ( stream @ ( stream @ A ) ),N: nat,M: nat] :
      ( member @ A @ ( snth @ A @ ( snth @ ( stream @ A ) @ Ss @ N ) @ M ) @ ( sset @ A @ ( smerge @ A @ Ss ) ) ) )).

% snth_sset_smerge
thf(fact_36_fair__stl,axiom,(
    ! [Rs: ( stream @ rule )] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( abstra928354080m_fair @ rule @ rules @ ( stl @ rule @ Rs ) ) ) )).

% fair_stl
thf(fact_37_countable__R,axiom,
    ( countable_countable @ rule @ ( sset @ rule @ rules ) )).

% countable_R
thf(fact_38_RuleSystem__Defs_Ofair__fenum,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( abstra928354080m_fair @ Rule @ Rules @ ( abstra1774373515_fenum @ Rule @ Rules ) ) )).

% RuleSystem_Defs.fair_fenum
thf(fact_39_Stream_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( smember @ A )
      = ( ^ [X4: A,S2: ( stream @ A )] :
            ( member @ A @ X4 @ ( sset @ A @ S2 ) ) ) ) )).

% Stream.smember_def
thf(fact_40_RuleSystem__Defs_Osset__fenum,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ ( abstra1774373515_fenum @ Rule @ Rules ) )
      = ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.sset_fenum
thf(fact_41_szip_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( stl @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( szip @ A @ B @ ( stl @ A @ S1 ) @ ( stl @ B @ S22 ) ) ) )).

% szip.simps(2)
thf(fact_42_RuleSystem_Ointro,axiom,(
    ! [Rule: $tType,State: $tType,S4: ( set @ State ),Rules: ( stream @ Rule ),Eff2: ( Rule > State > ( fset @ State ) > $o )] :
      ( ! [S5: State] :
          ( ( member @ State @ S5 @ S4 )
         => ! [R3: Rule] :
              ( ( member @ Rule @ R3 @ ( sset @ Rule @ Rules ) )
             => ! [Sl2: ( fset @ State )] :
                  ( ( Eff2 @ R3 @ S5 @ Sl2 )
                 => ! [S6: State] :
                      ( ( fmember @ State @ S6 @ Sl2 )
                     => ( member @ State @ S6 @ S4 ) ) ) ) )
     => ( ! [S5: State] :
            ( ( member @ State @ S5 @ S4 )
           => ? [X5: Rule] :
                ( ( member @ Rule @ X5 @ ( sset @ Rule @ Rules ) )
                & ? [X12: ( fset @ State )] :
                    ( Eff2 @ X5 @ S5 @ X12 ) ) )
       => ( abstra1326562878System @ Rule @ State @ Eff2 @ Rules @ S4 ) ) ) )).

% RuleSystem.intro
thf(fact_43_RuleSystem_Oeff__S,axiom,(
    ! [Rule: $tType,State: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S4: ( set @ State ),S: State,R: Rule,Sl: ( fset @ State ),S3: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff2 @ Rules @ S4 )
     => ( ( member @ State @ S @ S4 )
       => ( ( member @ Rule @ R @ ( sset @ Rule @ Rules ) )
         => ( ( Eff2 @ R @ S @ Sl )
           => ( ( fmember @ State @ S3 @ Sl )
             => ( member @ State @ S3 @ S4 ) ) ) ) ) ) )).

% RuleSystem.eff_S
thf(fact_44_RuleSystem__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1326562878System @ Rule @ State )
      = ( ^ [Eff: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),S7: ( set @ State )] :
            ( ! [S2: State] :
                ( ( member @ State @ S2 @ S7 )
               => ! [R2: Rule] :
                    ( ( member @ Rule @ R2 @ ( sset @ Rule @ Rules2 ) )
                   => ! [Sl3: ( fset @ State )] :
                        ( ( Eff @ R2 @ S2 @ Sl3 )
                       => ! [S8: State] :
                            ( ( fmember @ State @ S8 @ Sl3 )
                           => ( member @ State @ S8 @ S7 ) ) ) ) )
            & ! [S2: State] :
                ( ( member @ State @ S2 @ S7 )
               => ? [X4: Rule] :
                    ( ( member @ Rule @ X4 @ ( sset @ Rule @ Rules2 ) )
                    & ( ^ [P: ( ( fset @ State ) > $o )] :
                        ? [X: ( fset @ State )] :
                          ( P @ X )
                      @ ( Eff @ X4 @ S2 ) ) ) ) ) ) ) )).

% RuleSystem_def
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P2 @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( ( ( shd @ A @ Stream )
          = ( shd @ A @ Stream2 ) )
        & ( ( stl @ A @ Stream )
          = ( stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_50_stream_Ocoinduct,axiom,(
    ! [A: $tType,R4: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R4 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R4 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( R4 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_51_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R4: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R4 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R4 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( ( R4 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) )
                | ( ( stl @ A @ Stream3 )
                  = ( stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_52_stl__sset,axiom,(
    ! [A: $tType,X6: A,A2: ( stream @ A )] :
      ( ( member @ A @ X6 @ ( sset @ A @ ( stl @ A @ A2 ) ) )
     => ( member @ A @ X6 @ ( sset @ A @ A2 ) ) ) )).

% stl_sset
thf(fact_53_RuleSystem__Defs_Ocountable__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( countable_countable @ Rule @ ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.countable_R
thf(fact_54_sdrop__stl,axiom,(
    ! [A: $tType,N: nat,S: ( stream @ A )] :
      ( ( sdrop @ A @ N @ ( stl @ A @ S ) )
      = ( stl @ A @ ( sdrop @ A @ N @ S ) ) ) )).

% sdrop_stl
thf(fact_55_RuleSystem__Defs_Ofair__stl,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule ),Rs: ( stream @ Rule )] :
      ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
     => ( abstra928354080m_fair @ Rule @ Rules @ ( stl @ Rule @ Rs ) ) ) )).

% RuleSystem_Defs.fair_stl
thf(fact_56_smap2_Osimps_I2_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( stl @ C @ ( smap2 @ A @ B @ C @ F @ S1 @ S22 ) )
      = ( smap2 @ A @ B @ C @ F @ ( stl @ A @ S1 ) @ ( stl @ B @ S22 ) ) ) )).

% smap2.simps(2)
thf(fact_57_RuleSystem__Defs_ONE__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ Rules )
     != ( bot_bot @ ( set @ Rule ) ) ) )).

% RuleSystem_Defs.NE_R
thf(fact_58_stream_Ocorec__sel_I2_J,axiom,(
    ! [A: $tType,C: $tType,Q2: ( C > $o ),A2: C,G1: ( C > A ),G21: ( C > ( stream @ A ) ),G22: ( C > C )] :
      ( ( ( Q2 @ A2 )
       => ( ( stl @ A @ ( corec_stream @ C @ A @ G1 @ Q2 @ G21 @ G22 @ A2 ) )
          = ( G21 @ A2 ) ) )
      & ( ~ ( Q2 @ A2 )
       => ( ( stl @ A @ ( corec_stream @ C @ A @ G1 @ Q2 @ G21 @ G22 @ A2 ) )
          = ( corec_stream @ C @ A @ G1 @ Q2 @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) ) )).

% stream.corec_sel(2)
thf(fact_59_sinterleave_Osimps_I2_J,axiom,(
    ! [A: $tType,S1: ( stream @ A ),S22: ( stream @ A )] :
      ( ( stl @ A @ ( sinterleave @ A @ S1 @ S22 ) )
      = ( sinterleave @ A @ S22 @ ( stl @ A @ S1 ) ) ) )).

% sinterleave.simps(2)
thf(fact_60_RuleSystem_Otrim__alt,axiom,(
    ! [State: $tType,Rule: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S4: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff2 @ Rules @ S4 )
     => ( ( member @ State @ S @ S4 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs @ S )
            = ( sdrop @ Rule @ ( abstra1332369113inWait @ Rule @ State @ Eff2 @ Rs @ S ) @ Rs ) ) ) ) ) )).

% RuleSystem.trim_alt
thf(fact_61_sset__induct,axiom,(
    ! [A: $tType,Y: A,S: ( stream @ A ),P2: ( A > ( stream @ A ) > $o )] :
      ( ( member @ A @ Y @ ( sset @ A @ S ) )
     => ( ! [S5: ( stream @ A )] :
            ( P2 @ ( shd @ A @ S5 ) @ S5 )
       => ( ! [S5: ( stream @ A ),Y2: A] :
              ( ( member @ A @ Y2 @ ( sset @ A @ ( stl @ A @ S5 ) ) )
             => ( ( P2 @ Y2 @ ( stl @ A @ S5 ) )
               => ( P2 @ Y2 @ S5 ) ) )
         => ( P2 @ Y @ S ) ) ) ) )).

% sset_induct
thf(fact_62_RuleSystem_Oenabled__R,axiom,(
    ! [Rule: $tType,State: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S4: ( set @ State ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff2 @ Rules @ S4 )
     => ( ( member @ State @ S @ S4 )
       => ? [X2: Rule] :
            ( ( member @ Rule @ X2 @ ( sset @ Rule @ Rules ) )
            & ? [X1: ( fset @ State )] :
                ( Eff2 @ X2 @ S @ X1 ) ) ) ) )).

% RuleSystem.enabled_R
thf(fact_63_RuleSystem__Defs_OSaturated__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1209608345urated @ Rule @ State )
      = ( ^ [Eff: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),Steps2: ( stream @ ( product_prod @ State @ Rule ) )] :
          ! [X4: Rule] :
            ( ( member @ Rule @ X4 @ ( sset @ Rule @ Rules2 ) )
           => ( abstra726722745urated @ Rule @ State @ Eff @ X4 @ Steps2 ) ) ) ) )).

% RuleSystem_Defs.Saturated_def
thf(fact_64_RuleSystem__Defs_OpickEff,axiom,(
    ! [Rule: $tType,State: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),R: Rule,S: State] :
      ( ( abstra1874422341nabled @ Rule @ State @ Eff2 @ R @ S )
     => ( Eff2 @ R @ S @ ( abstra1276541928ickEff @ Rule @ State @ Eff2 @ R @ S ) ) ) )).

% RuleSystem_Defs.pickEff
thf(fact_65_countable__empty,axiom,(
    ! [A: $tType] :
      ( countable_countable @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% countable_empty
thf(fact_66_countableI__type,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ A )] :
          ( countable_countable @ A @ A3 ) ) )).

% countableI_type
thf(fact_67_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X4: A] :
            ~ ( P2 @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_68_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P2 @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_69_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_70_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_71_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X4: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_72_ev__at__HLD__single__imp__snth,axiom,(
    ! [A: $tType,X6: A,N: nat,Omega2: ( stream @ A )] :
      ( ( linear2074238637_ev_at @ A @ ( linear1178169911on_HLD @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) @ N @ Omega2 )
     => ( ( snth @ A @ Omega2 @ N )
        = X6 ) ) )).

% ev_at_HLD_single_imp_snth
thf(fact_73_insertCI,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A2 @ B2 )
       => ( A2 = B3 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertCI
thf(fact_74_insert__iff,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B3 @ A3 ) )
      = ( ( A2 = B3 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_75_insert__absorb2,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A )] :
      ( ( insert @ A @ X6 @ ( insert @ A @ X6 @ A3 ) )
      = ( insert @ A @ X6 @ A3 ) ) )).

% insert_absorb2
thf(fact_76_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_77_countable__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( countable_countable @ A @ A3 )
     => ( countable_countable @ A @ ( insert @ A @ A2 @ A3 ) ) ) )).

% countable_insert
thf(fact_78_countable__insert__eq,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A )] :
      ( ( countable_countable @ A @ ( insert @ A @ X6 @ A3 ) )
      = ( countable_countable @ A @ A3 ) ) )).

% countable_insert_eq
thf(fact_79_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B3: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B3 ) ) )).

% singleton_inject
thf(fact_80_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( insert @ A @ A2 @ A3 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_81_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B3: A,C2: A,D2: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C2 )
          & ( B3 = D2 ) )
        | ( ( A2 = D2 )
          & ( B3 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_82_singleton__iff,axiom,(
    ! [A: $tType,B3: A,A2: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A2 ) ) )).

% singleton_iff
thf(fact_83_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_84_singletonD,axiom,(
    ! [A: $tType,B3: A,A2: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A2 ) ) )).

% singletonD
thf(fact_85_insertE,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B3 @ A3 ) )
     => ( ( A2 != B3 )
       => ( member @ A @ A2 @ A3 ) ) ) )).

% insertE
thf(fact_86_insertI1,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B2 ) ) )).

% insertI1
thf(fact_87_insertI2,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),B3: A] :
      ( ( member @ A @ A2 @ B2 )
     => ( member @ A @ A2 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertI2
thf(fact_88_Set_Oset__insert,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A )] :
      ( ( member @ A @ X6 @ A3 )
     => ~ ( ! [B4: ( set @ A )] :
              ( ( A3
                = ( insert @ A @ X6 @ B4 ) )
             => ( member @ A @ X6 @ B4 ) ) ) ) )).

% Set.set_insert
thf(fact_89_insert__ident,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X6 @ A3 )
     => ( ~ ( member @ A @ X6 @ B2 )
       => ( ( ( insert @ A @ X6 @ A3 )
            = ( insert @ A @ X6 @ B2 ) )
          = ( A3 = B2 ) ) ) ) )).

% insert_ident
thf(fact_90_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ A3 )
        = A3 ) ) )).

% insert_absorb
thf(fact_91_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B3: A,B2: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ B3 @ B2 )
       => ( ( ( insert @ A @ A2 @ A3 )
            = ( insert @ A @ B3 @ B2 ) )
          = ( ( ( A2 = B3 )
             => ( A3 = B2 ) )
            & ( ( A2 != B3 )
             => ? [C3: ( set @ A )] :
                  ( ( A3
                    = ( insert @ A @ B3 @ C3 ) )
                  & ~ ( member @ A @ B3 @ C3 )
                  & ( B2
                    = ( insert @ A @ A2 @ C3 ) )
                  & ~ ( member @ A @ A2 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_92_insert__commute,axiom,(
    ! [A: $tType,X6: A,Y: A,A3: ( set @ A )] :
      ( ( insert @ A @ X6 @ ( insert @ A @ Y @ A3 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X6 @ A3 ) ) ) )).

% insert_commute
thf(fact_93_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ? [B4: ( set @ A )] :
          ( ( A3
            = ( insert @ A @ A2 @ B4 ) )
          & ~ ( member @ A @ A2 @ B4 ) ) ) )).

% mk_disjoint_insert
thf(fact_94_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_95_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_96_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_97_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_98_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_99_fempty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( fmember @ A @ C2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% fempty_iff
thf(fact_100_all__not__fin__conv,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ( ! [X4: A] :
            ~ ( fmember @ A @ X4 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% all_not_fin_conv
thf(fact_101_is__singletonI,axiom,(
    ! [A: $tType,X6: A] :
      ( is_singleton @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_102_the__elem__eq,axiom,(
    ! [A: $tType,X6: A] :
      ( ( the_elem @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) )
      = X6 ) )).

% the_elem_eq
thf(fact_103_holds__eq1,axiom,(
    ! [A: $tType,X6: A] :
      ( ( linear1707521579_holds @ A
        @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ X6 ) )
      = ( linear1178169911on_HLD @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% holds_eq1
thf(fact_104_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_105_holds__mono,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( stream @ A ),Q: ( A > $o )] :
      ( ( linear1707521579_holds @ A @ P2 @ Xs )
     => ( ! [X2: A] :
            ( ( P2 @ X2 )
           => ( Q @ X2 ) )
       => ( linear1707521579_holds @ A @ Q @ Xs ) ) ) )).

% holds_mono
thf(fact_106_holds_Oelims_I3_J,axiom,(
    ! [A: $tType,X6: ( A > $o ),Xa: ( stream @ A )] :
      ( ~ ( linear1707521579_holds @ A @ X6 @ Xa )
     => ~ ( X6 @ ( shd @ A @ Xa ) ) ) )).

% holds.elims(3)
thf(fact_107_holds_Oelims_I2_J,axiom,(
    ! [A: $tType,X6: ( A > $o ),Xa: ( stream @ A )] :
      ( ( linear1707521579_holds @ A @ X6 @ Xa )
     => ( X6 @ ( shd @ A @ Xa ) ) ) )).

% holds.elims(2)
thf(fact_108_holds_Oelims_I1_J,axiom,(
    ! [A: $tType,X6: ( A > $o ),Xa: ( stream @ A ),Y: $o] :
      ( ( ( linear1707521579_holds @ A @ X6 @ Xa )
        = Y )
     => ( Y
        = ( X6 @ ( shd @ A @ Xa ) ) ) ) )).

% holds.elims(1)
thf(fact_109_holds_Osimps,axiom,(
    ! [A: $tType] :
      ( ( linear1707521579_holds @ A )
      = ( ^ [P3: ( A > $o ),Xs2: ( stream @ A )] :
            ( P3 @ ( shd @ A @ Xs2 ) ) ) ) )).

% holds.simps
thf(fact_110_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( insert @ A @ ( the_elem @ A @ A4 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_111_is__singletonI_H,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X2: A,Y2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ( ( member @ A @ Y2 @ A3 )
             => ( X2 = Y2 ) ) )
       => ( is_singleton @ A @ A3 ) ) ) )).

% is_singletonI'
thf(fact_112_eqfelem__imp__iff,axiom,(
    ! [A: $tType,X6: A,Y: A,A3: ( fset @ A )] :
      ( ( X6 = Y )
     => ( ( fmember @ A @ X6 @ A3 )
        = ( fmember @ A @ Y @ A3 ) ) ) )).

% eqfelem_imp_iff
thf(fact_113_if__split__fmem2,axiom,(
    ! [A: $tType,A2: A,Q: $o,X6: ( fset @ A ),Y: ( fset @ A )] :
      ( ( fmember @ A @ A2 @ ( if @ ( fset @ A ) @ Q @ X6 @ Y ) )
      = ( ( Q
         => ( fmember @ A @ A2 @ X6 ) )
        & ( ~ ( Q )
         => ( fmember @ A @ A2 @ Y ) ) ) ) )).

% if_split_fmem2
thf(fact_114_if__split__fmem1,axiom,(
    ! [A: $tType,Q: $o,X6: A,Y: A,B3: ( fset @ A )] :
      ( ( fmember @ A @ ( if @ A @ Q @ X6 @ Y ) @ B3 )
      = ( ( Q
         => ( fmember @ A @ X6 @ B3 ) )
        & ( ~ ( Q )
         => ( fmember @ A @ Y @ B3 ) ) ) ) )).

% if_split_fmem1
thf(fact_115_eqfset__imp__iff,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),X6: A] :
      ( ( A3 = B2 )
     => ( ( fmember @ A @ X6 @ A3 )
        = ( fmember @ A @ X6 @ B2 ) ) ) )).

% eqfset_imp_iff
thf(fact_116_eq__fmem__trans,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( fset @ A )] :
      ( ( A2 = B3 )
     => ( ( fmember @ A @ B3 @ A3 )
       => ( fmember @ A @ A2 @ A3 ) ) ) )).

% eq_fmem_trans
thf(fact_117_fset__choice,axiom,(
    ! [B: $tType,A: $tType,A3: ( fset @ A ),P2: ( A > B > $o )] :
      ( ! [X2: A] :
          ( ( fmember @ A @ X2 @ A3 )
         => ? [X12: B] :
              ( P2 @ X2 @ X12 ) )
     => ? [F2: ( A > B )] :
        ! [X5: A] :
          ( ( fmember @ A @ X5 @ A3 )
         => ( P2 @ X5 @ ( F2 @ X5 ) ) ) ) )).

% fset_choice
thf(fact_118_fequalityCE,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),C2: A] :
      ( ( A3 = B2 )
     => ( ( ( fmember @ A @ C2 @ A3 )
         => ~ ( fmember @ A @ C2 @ B2 ) )
       => ~ ( ~ ( fmember @ A @ C2 @ A3 )
           => ( fmember @ A @ C2 @ B2 ) ) ) ) )).

% fequalityCE
thf(fact_119_fset__eqI,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ! [X2: A] :
          ( ( fmember @ A @ X2 @ A3 )
          = ( fmember @ A @ X2 @ B2 ) )
     => ( A3 = B2 ) ) )).

% fset_eqI
thf(fact_120_femptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( fmember @ A @ A2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% femptyE
thf(fact_121_ex__fin__conv,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ( ? [X4: A] :
            ( fmember @ A @ X4 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( fset @ A ) ) ) ) )).

% ex_fin_conv
thf(fact_122_equalsffemptyD,axiom,(
    ! [A: $tType,A3: ( fset @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( fset @ A ) ) )
     => ~ ( fmember @ A @ A2 @ A3 ) ) )).

% equalsffemptyD
thf(fact_123_equalsffemptyI,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ! [Y2: A] :
          ~ ( fmember @ A @ Y2 @ A3 )
     => ( A3
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% equalsffemptyI
thf(fact_124_is__singletonE,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( is_singleton @ A @ A3 )
     => ~ ( ! [X2: A] :
              ( A3
             != ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_125_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
          ? [X4: A] :
            ( A4
            = ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_126_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_127_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P2
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_128_not__holds__eq,axiom,(
    ! [A: $tType,X6: A] :
      ( ( linear1707521579_holds @ A
        @ ( uminus_uminus @ ( A > $o )
          @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
            @ X6 ) ) )
      = ( ^ [Xs2: ( stream @ A )] :
            ~ ( linear1178169911on_HLD @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) @ Xs2 ) ) ) )).

% not_holds_eq
thf(fact_129_mkTree_Osimps_I1_J,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) )
      = ( product_Pair @ state @ rule @ S @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) ) )).

% mkTree.simps(1)
thf(fact_130_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( case_stream @ A @ B )
      = ( ^ [F3: ( A > ( stream @ A ) > B ),Stream5: ( stream @ A )] :
            ( F3 @ ( shd @ A @ Stream5 ) @ ( stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_131_snth__szip,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B ),N: nat] :
      ( ( snth @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) @ N )
      = ( product_Pair @ A @ B @ ( snth @ A @ S1 @ N ) @ ( snth @ B @ S22 @ N ) ) ) )).

% snth_szip
thf(fact_132_RuleSystem__Defs_OmkTree_Osimps_I1_J,axiom,(
    ! [Rule: $tType,State: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff2 @ Rs @ S ) )
      = ( product_Pair @ State @ Rule @ S @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs @ S ) ) ) ) )).

% RuleSystem_Defs.mkTree.simps(1)
thf(fact_133_szip_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( shd @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( product_Pair @ A @ B @ ( shd @ A @ S1 ) @ ( shd @ B @ S22 ) ) ) )).

% szip.simps(1)
thf(fact_134_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A4: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A4 @ X4 ) ) ) ) ) )).

% uminus_apply
thf(fact_135_fun__Compl__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A4: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A4 @ X4 ) ) ) ) ) )).

% fun_Compl_def
thf(fact_136_mkTree_Octr,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S )
      = ( abstra388494275e_Node @ ( product_prod @ state @ rule ) @ ( product_Pair @ state @ rule @ S @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) ) )).

% mkTree.ctr
thf(fact_137_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) )).

% add.inverse_inverse
thf(fact_138_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X6: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X6 )
            = ( uminus_uminus @ A @ Y ) )
          = ( X6 = Y ) ) ) )).

% compl_eq_compl_iff
thf(fact_139_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X6: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X6 ) )
          = X6 ) ) )).

% double_compl
thf(fact_140_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B3 ) )
          = ( A2 = B3 ) ) ) )).

% neg_equal_iff_equal
thf(fact_141_tree_Oinject,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) ),Y1: A,Y22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( ( abstra388494275e_Node @ A @ X13 @ X22 )
        = ( abstra388494275e_Node @ A @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% tree.inject
thf(fact_142_fimage__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),X6: B,A3: ( fset @ B )] :
      ( ( B3
        = ( F @ X6 ) )
     => ( ( fmember @ B @ X6 @ A3 )
       => ( fmember @ A @ B3 @ ( fimage @ B @ A @ F @ A3 ) ) ) ) )).

% fimage_eqI
thf(fact_143_fimage__fempty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( fimage @ B @ A @ F @ ( bot_bot @ ( fset @ B ) ) )
      = ( bot_bot @ ( fset @ A ) ) ) )).

% fimage_fempty
thf(fact_144_fempty__is__fimage,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( fset @ B )] :
      ( ( ( bot_bot @ ( fset @ A ) )
        = ( fimage @ B @ A @ F @ A3 ) )
      = ( A3
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fempty_is_fimage
thf(fact_145_fimage__is__fempty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( fset @ B )] :
      ( ( ( fimage @ B @ A @ F @ A3 )
        = ( bot_bot @ ( fset @ A ) ) )
      = ( A3
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fimage_is_fempty
thf(fact_146_tree_Oexhaust,axiom,(
    ! [A: $tType,Y: ( abstra2103299360e_tree @ A )] :
      ~ ( ! [X1: A,X23: ( fset @ ( abstra2103299360e_tree @ A ) )] :
            ( Y
           != ( abstra388494275e_Node @ A @ X1 @ X23 ) ) ) )).

% tree.exhaust
thf(fact_147_fimageE,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),A3: ( fset @ B )] :
      ( ( fmember @ A @ B3 @ ( fimage @ B @ A @ F @ A3 ) )
     => ~ ( ! [X2: B] :
              ( ( B3
                = ( F @ X2 ) )
             => ~ ( fmember @ B @ X2 @ A3 ) ) ) ) )).

% fimageE
thf(fact_148_fimageI,axiom,(
    ! [B: $tType,A: $tType,X6: A,A3: ( fset @ A ),F: ( A > B )] :
      ( ( fmember @ A @ X6 @ A3 )
     => ( fmember @ B @ ( F @ X6 ) @ ( fimage @ A @ B @ F @ A3 ) ) ) )).

% fimageI
thf(fact_149_fimage__cong,axiom,(
    ! [B: $tType,A: $tType,M2: ( fset @ A ),N3: ( fset @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M2 = N3 )
     => ( ! [X2: A] :
            ( ( fmember @ A @ X2 @ N3 )
           => ( ( F @ X2 )
              = ( G @ X2 ) ) )
       => ( ( fimage @ A @ B @ F @ M2 )
          = ( fimage @ A @ B @ G @ N3 ) ) ) ) )).

% fimage_cong
thf(fact_150_rev__fimage__eqI,axiom,(
    ! [B: $tType,A: $tType,X6: A,A3: ( fset @ A ),B3: B,F: ( A > B )] :
      ( ( fmember @ A @ X6 @ A3 )
     => ( ( B3
          = ( F @ X6 ) )
       => ( fmember @ B @ B3 @ ( fimage @ A @ B @ F @ A3 ) ) ) ) )).

% rev_fimage_eqI
thf(fact_151_tree_Osel_I1_J,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra573067619e_root @ A @ ( abstra388494275e_Node @ A @ X13 @ X22 ) )
      = X13 ) )).

% tree.sel(1)
thf(fact_152_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B3 )
          = ( ( uminus_uminus @ A @ B3 )
            = A2 ) ) ) )).

% minus_equation_iff
thf(fact_153_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B3 ) )
          = ( B3
            = ( uminus_uminus @ A @ A2 ) ) ) ) )).

% equation_minus_iff
thf(fact_154_RuleSystem__Defs_OmkTree_Ocode,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1225283448mkTree @ Rule @ State )
      = ( ^ [Eff: ( Rule > State > ( fset @ State ) > $o ),Rs2: ( stream @ Rule ),S2: State] :
            ( abstra388494275e_Node @ ( product_prod @ State @ Rule ) @ ( product_Pair @ State @ Rule @ S2 @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs2 @ S2 ) ) ) @ ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs2 @ S2 ) ) ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs2 @ S2 ) ) @ S2 ) ) ) ) ) )).

% RuleSystem_Defs.mkTree.code
thf(fact_155_mkTree_Osimps_I2_J,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) )
      = ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) )).

% mkTree.simps(2)
thf(fact_156_RuleSystem__Defs_OmkTree_Osimps_I2_J,axiom,(
    ! [Rule: $tType,State: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff2 @ Rs @ S ) )
      = ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff2 @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff2 @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs @ S ) ) @ S ) ) ) )).

% RuleSystem_Defs.mkTree.simps(2)
thf(fact_157_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B3: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B3 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
      = ( ( A2 = A5 )
        & ( B3 = B5 ) ) ) )).

% old.prod.inject
thf(fact_158_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X13: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X13 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_159_tree_Ocollapse,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) )
      = Tree ) )).

% tree.collapse
thf(fact_160_tree_Oexpand,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A ),Tree2: ( abstra2103299360e_tree @ A )] :
      ( ( ( ( abstra573067619e_root @ A @ Tree )
          = ( abstra573067619e_root @ A @ Tree2 ) )
        & ( ( abstra1749095923e_cont @ A @ Tree )
          = ( abstra1749095923e_cont @ A @ Tree2 ) ) )
     => ( Tree = Tree2 ) ) )).

% tree.expand
thf(fact_161_tree_Osel_I2_J,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra1749095923e_cont @ A @ ( abstra388494275e_Node @ A @ X13 @ X22 ) )
      = X22 ) )).

% tree.sel(2)
thf(fact_162_tree_Oexhaust__sel,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( Tree
      = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) )).

% tree.exhaust_sel
thf(fact_163_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P4: ( product_prod @ A @ B )] :
    ? [X2: A,Y2: B] :
      ( P4
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) )).

% surj_pair
thf(fact_164_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),P4: ( product_prod @ A @ B )] :
      ( ! [A6: A,B6: B] :
          ( P2 @ ( product_Pair @ A @ B @ A6 @ B6 ) )
     => ( P2 @ P4 ) ) )).

% prod_cases
thf(fact_165_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B3: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B3 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ~ ( ( A2 = A5 )
         => ( B3 != B5 ) ) ) )).

% Pair_inject
thf(fact_166_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A6: A,B6: B,C4: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) ) ) )).

% prod_cases3
thf(fact_167_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A6: A,B6: B,C4: C,D3: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D3 ) ) ) ) ) )).

% prod_cases4
thf(fact_168_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A6: A,B6: B,C4: C,D3: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D3 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_169_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A6: A,B6: B,C4: C,D3: D,E2: E,F2: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D3 @ ( product_Pair @ E @ F4 @ E2 @ F2 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_170_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A6: A,B6: B,C4: C,D3: D,E2: E,F2: F4,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F2 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_171_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A6: A,B6: B,C4: C] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) )
     => ( P2 @ X6 ) ) )).

% prod_induct3
thf(fact_172_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D3: D] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D3 ) ) ) )
     => ( P2 @ X6 ) ) )).

% prod_induct4
thf(fact_173_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D3: D,E2: E] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D3 @ E2 ) ) ) ) )
     => ( P2 @ X6 ) ) )).

% prod_induct5
thf(fact_174_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D3: D,E2: E,F2: F4] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D3 @ ( product_Pair @ E @ F4 @ E2 @ F2 ) ) ) ) ) )
     => ( P2 @ X6 ) ) )).

% prod_induct6
thf(fact_175_prod__induct7,axiom,(
    ! [G2: $tType,F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ( ! [A6: A,B6: B,C4: C,D3: D,E2: E,F2: F4,G3: G2] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F2 @ G3 ) ) ) ) ) ) )
     => ( P2 @ X6 ) ) )).

% prod_induct7
thf(fact_176_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A6: A,B6: B] :
            ( Y
           != ( product_Pair @ A @ B @ A6 @ B6 ) ) ) )).

% old.prod.exhaust
thf(fact_177_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A6: A,B6: B] :
          ( P2 @ ( product_Pair @ A @ B @ A6 @ B6 ) )
     => ( P2 @ Prod ) ) )).

% old.prod.inducts
thf(fact_178_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B3 ) )
      = ( F1 @ A2 @ B3 ) ) )).

% old.prod.rec
thf(fact_179_ipath_Ocases,axiom,(
    ! [A: $tType,A1: ( abstra2103299360e_tree @ A ),A22: ( stream @ A )] :
      ( ( abstra313004635_ipath @ A @ A1 @ A22 )
     => ~ ( ( ( abstra573067619e_root @ A @ A1 )
            = ( shd @ A @ A22 ) )
         => ! [T3: ( abstra2103299360e_tree @ A )] :
              ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T3 @ ( abstra1749095923e_cont @ A @ A1 ) )
             => ~ ( abstra313004635_ipath @ A @ T3 @ ( stl @ A @ A22 ) ) ) ) ) )).

% ipath.cases
thf(fact_180_ipath_Osimps,axiom,(
    ! [A: $tType] :
      ( ( abstra313004635_ipath @ A )
      = ( ^ [A12: ( abstra2103299360e_tree @ A ),A23: ( stream @ A )] :
          ? [T4: ( abstra2103299360e_tree @ A ),Steps2: ( stream @ A ),T5: ( abstra2103299360e_tree @ A )] :
            ( ( A12 = T4 )
            & ( A23 = Steps2 )
            & ( ( abstra573067619e_root @ A @ T4 )
              = ( shd @ A @ Steps2 ) )
            & ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ T4 ) )
            & ( abstra313004635_ipath @ A @ T5 @ ( stl @ A @ Steps2 ) ) ) ) ) )).

% ipath.simps
thf(fact_181_ipath_Ocoinduct,axiom,(
    ! [A: $tType,X3: ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ),X6: ( abstra2103299360e_tree @ A ),Xa: ( stream @ A )] :
      ( ( X3 @ X6 @ Xa )
     => ( ! [X2: ( abstra2103299360e_tree @ A ),Xa2: ( stream @ A )] :
            ( ( X3 @ X2 @ Xa2 )
           => ? [T6: ( abstra2103299360e_tree @ A ),Steps3: ( stream @ A ),T7: ( abstra2103299360e_tree @ A )] :
                ( ( X2 = T6 )
                & ( Xa2 = Steps3 )
                & ( ( abstra573067619e_root @ A @ T6 )
                  = ( shd @ A @ Steps3 ) )
                & ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ T6 ) )
                & ( ( X3 @ T7 @ ( stl @ A @ Steps3 ) )
                  | ( abstra313004635_ipath @ A @ T7 @ ( stl @ A @ Steps3 ) ) ) ) )
       => ( abstra313004635_ipath @ A @ X6 @ Xa ) ) ) )).

% ipath.coinduct
thf(fact_182_ipath_Ointros,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A ),Steps: ( stream @ A ),T8: ( abstra2103299360e_tree @ A )] :
      ( ( ( abstra573067619e_root @ A @ T2 )
        = ( shd @ A @ Steps ) )
     => ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T8 @ ( abstra1749095923e_cont @ A @ T2 ) )
       => ( ( abstra313004635_ipath @ A @ T8 @ ( stl @ A @ Steps ) )
         => ( abstra313004635_ipath @ A @ T2 @ Steps ) ) ) ) )).

% ipath.intros
thf(fact_183_mkTree__unfold,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S )
      = ( case_stream @ rule @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )
        @ ^ [R2: rule,S8: ( stream @ rule )] :
            ( abstra388494275e_Node @ ( product_prod @ state @ rule ) @ ( product_Pair @ state @ rule @ S @ R2 ) @ ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ S8 ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ R2 @ S ) ) )
        @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) )).

% mkTree_unfold
thf(fact_184_tree_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree: ( abstra2103299360e_tree @ A )] :
      ( ( P2 @ ( abstra457966479e_tree @ A @ B @ F @ Tree ) )
      = ( ~ ( ( Tree
              = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) )
            & ~ ( P2 @ ( F @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) ) ) ) )).

% tree.split_sel_asm
thf(fact_185_tree_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree: ( abstra2103299360e_tree @ A )] :
      ( ( P2 @ ( abstra457966479e_tree @ A @ B @ F @ Tree ) )
      = ( ( Tree
          = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) )
       => ( P2 @ ( F @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) ) ) )).

% tree.split_sel
thf(fact_186_fset_Omap__ident,axiom,(
    ! [A: $tType,T2: ( fset @ A )] :
      ( ( fimage @ A @ A
        @ ^ [X4: A] : X4
        @ T2 )
      = T2 ) )).

% fset.map_ident
thf(fact_187_fimage__ident,axiom,(
    ! [A: $tType,Y4: ( fset @ A )] :
      ( ( fimage @ A @ A
        @ ^ [X4: A] : X4
        @ Y4 )
      = Y4 ) )).

% fimage_ident
thf(fact_188_singleton__conv,axiom,(
    ! [A: $tType,A2: A] :
      ( ( collect @ A
        @ ^ [X4: A] : ( X4 = A2 ) )
      = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv
thf(fact_189_singleton__conv2,axiom,(
    ! [A: $tType,A2: A] :
      ( ( collect @ A
        @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ A2 ) )
      = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv2
thf(fact_190_holds__eq2,axiom,(
    ! [A: $tType,X6: A] :
      ( ( linear1707521579_holds @ A
        @ ^ [Y5: A] : ( Y5 = X6 ) )
      = ( linear1178169911on_HLD @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% holds_eq2
thf(fact_191_cont__def,axiom,(
    ! [A: $tType] :
      ( ( abstra1749095923e_cont @ A )
      = ( abstra457966479e_tree @ A @ ( fset @ ( abstra2103299360e_tree @ A ) )
        @ ^ [X14: A,X24: ( fset @ ( abstra2103299360e_tree @ A ) )] : X24 ) ) )).

% cont_def
thf(fact_192_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R4: ( set @ ( product_prod @ A @ B ) ),S4: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X4: A,Y5: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y5 ) @ R4 ) )
        = ( ^ [X4: A,Y5: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y5 ) @ S4 ) ) )
      = ( R4 = S4 ) ) )).

% pred_equals_eq2
thf(fact_193_bot__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X4: A,Y5: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y5 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% bot_empty_eq2
thf(fact_194_tree_Oroot__def,axiom,(
    ! [A: $tType] :
      ( ( abstra573067619e_root @ A )
      = ( abstra457966479e_tree @ A @ A
        @ ^ [X14: A,X24: ( fset @ ( abstra2103299360e_tree @ A ) )] : X14 ) ) )).

% tree.root_def
thf(fact_195_not__HLD,axiom,(
    ! [A: $tType,X3: ( set @ A )] :
      ( ( ^ [Xs2: ( stream @ A )] :
            ~ ( linear1178169911on_HLD @ A @ X3 @ Xs2 ) )
      = ( linear1178169911on_HLD @ A @ ( uminus_uminus @ ( set @ A ) @ X3 ) ) ) )).

% not_HLD
thf(fact_196_shd__def,axiom,(
    ! [A: $tType] :
      ( ( shd @ A )
      = ( case_stream @ A @ A
        @ ^ [X14: A,X24: ( stream @ A )] : X14 ) ) )).

% shd_def
thf(fact_197_uminus__set__def,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A4: ( set @ A )] :
            ( collect @ A
            @ ( uminus_uminus @ ( A > $o )
              @ ^ [X4: A] :
                  ( member @ A @ X4 @ A4 ) ) ) ) ) )).

% uminus_set_def
thf(fact_198_Collect__conv__if2,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( ( P2 @ A2 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( A2 = X4 )
                & ( P2 @ X4 ) ) )
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P2 @ A2 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( A2 = X4 )
                & ( P2 @ X4 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if2
thf(fact_199_Collect__conv__if,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( ( P2 @ A2 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A2 )
                & ( P2 @ X4 ) ) )
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P2 @ A2 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A2 )
                & ( P2 @ X4 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if
thf(fact_200_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X4: A] : $false ) ) )).

% empty_def
thf(fact_201_HLD__def,axiom,(
    ! [A: $tType] :
      ( ( linear1178169911on_HLD @ A )
      = ( ^ [S2: ( set @ A )] :
            ( linear1707521579_holds @ A
            @ ^ [X4: A] :
                ( member @ A @ X4 @ S2 ) ) ) ) )).

% HLD_def
thf(fact_202_holds__aand,axiom,(
    ! [A: $tType,P2: ( A > $o ),Steps: ( stream @ A ),Q: ( A > $o )] :
      ( ( ( linear1707521579_holds @ A @ P2 @ Steps )
        & ( linear1707521579_holds @ A @ Q @ Steps ) )
      = ( linear1707521579_holds @ A
        @ ^ [Step: A] :
            ( ( P2 @ Step )
            & ( Q @ Step ) )
        @ Steps ) ) )).

% holds_aand
thf(fact_203_tree_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H: ( B > C ),F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree: ( abstra2103299360e_tree @ A )] :
      ( ( H @ ( abstra457966479e_tree @ A @ B @ F @ Tree ) )
      = ( abstra457966479e_tree @ A @ C
        @ ^ [X14: A,X24: ( fset @ ( abstra2103299360e_tree @ A ) )] :
            ( H @ ( F @ X14 @ X24 ) )
        @ Tree ) ) )).

% tree.case_distrib
thf(fact_204_insert__Collect,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( insert @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( collect @ A
        @ ^ [U: A] :
            ( ( U != A2 )
           => ( P2 @ U ) ) ) ) )).

% insert_Collect
thf(fact_205_insert__compr,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A7: A,B7: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A7 )
                | ( member @ A @ X4 @ B7 ) ) ) ) ) )).

% insert_compr
thf(fact_206_countable__Collect,axiom,(
    ! [A: $tType,A3: ( set @ A ),Phi: ( A > $o )] :
      ( ( countable_countable @ A @ A3 )
     => ( countable_countable @ A
        @ ( collect @ A
          @ ^ [A7: A] :
              ( ( member @ A @ A7 @ A3 )
              & ( Phi @ A7 ) ) ) ) ) )).

% countable_Collect
thf(fact_207_stl__def,axiom,(
    ! [A: $tType] :
      ( ( stl @ A )
      = ( case_stream @ A @ ( stream @ A )
        @ ^ [X14: A,X24: ( stream @ A )] : X24 ) ) )).

% stl_def
thf(fact_208_stream_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H: ( B > C ),F: ( A > ( stream @ A ) > B ),Stream: ( stream @ A )] :
      ( ( H @ ( case_stream @ A @ B @ F @ Stream ) )
      = ( case_stream @ A @ C
        @ ^ [X14: A,X24: ( stream @ A )] :
            ( H @ ( F @ X14 @ X24 ) )
        @ Stream ) ) )).

% stream.case_distrib
thf(fact_209_fimage__fimage,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G: ( C > B ),A3: ( fset @ C )] :
      ( ( fimage @ B @ A @ F @ ( fimage @ C @ B @ G @ A3 ) )
      = ( fimage @ C @ A
        @ ^ [X4: C] :
            ( F @ ( G @ X4 ) )
        @ A3 ) ) )).

% fimage_fimage
thf(fact_210_tree_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra457966479e_tree @ A @ B @ F @ ( abstra388494275e_Node @ A @ X13 @ X22 ) )
      = ( F @ X13 @ X22 ) ) )).

% tree.case
thf(fact_211_RuleSystem__Defs_OmkTree__unfold,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1225283448mkTree @ Rule @ State )
      = ( ^ [Eff: ( Rule > State > ( fset @ State ) > $o ),Rs2: ( stream @ Rule ),S2: State] :
            ( case_stream @ Rule @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )
            @ ^ [R2: Rule,S8: ( stream @ Rule )] :
                ( abstra388494275e_Node @ ( product_prod @ State @ Rule ) @ ( product_Pair @ State @ Rule @ S2 @ R2 ) @ ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ S8 ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ R2 @ S2 ) ) )
            @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs2 @ S2 ) ) ) ) )).

% RuleSystem_Defs.mkTree_unfold
thf(fact_212_tree_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( abstra457966479e_tree @ A @ B )
      = ( ^ [F3: ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > B ),Tree3: ( abstra2103299360e_tree @ A )] :
            ( F3 @ ( abstra573067619e_root @ A @ Tree3 ) @ ( abstra1749095923e_cont @ A @ Tree3 ) ) ) ) )).

% tree.case_eq_if
thf(fact_213_trim__def,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S )
      = ( sdrop_while @ rule
        @ ^ [R2: rule] :
            ~ ( abstra1874422341nabled @ rule @ state @ eff @ R2 @ S )
        @ Rs ) ) )).

% trim_def
thf(fact_214_minWait__def,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S )
      = ( ord_Least @ nat
        @ ^ [N2: nat] :
            ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N2 @ Rs ) ) @ S ) ) ) )).

% minWait_def
thf(fact_215_RuleSystem_OminWait__def,axiom,(
    ! [State: $tType,Rule: $tType,Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S4: ( set @ State ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff2 @ Rules @ S4 )
     => ( ( abstra1332369113inWait @ Rule @ State @ Eff2 @ Rs @ S )
        = ( ord_Least @ nat
          @ ^ [N2: nat] :
              ( abstra1874422341nabled @ Rule @ State @ Eff2 @ ( shd @ Rule @ ( sdrop @ Rule @ N2 @ Rs ) ) @ S ) ) ) ) )).

% RuleSystem.minWait_def
thf(fact_216_ComplI,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A )] :
      ( ~ ( member @ A @ C2 @ A3 )
     => ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) )).

% ComplI
thf(fact_217_Compl__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( ~ ( member @ A @ C2 @ A3 ) ) ) )).

% Compl_iff
thf(fact_218_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A3 )
        = ( uminus_uminus @ ( set @ A ) @ B2 ) )
      = ( A3 = B2 ) ) )).

% Compl_eq_Compl_iff
thf(fact_219_Collect__neg__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ~ ( P2 @ X4 ) )
      = ( uminus_uminus @ ( set @ A ) @ ( collect @ A @ P2 ) ) ) )).

% Collect_neg_eq
thf(fact_220_Compl__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A4: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ~ ( member @ A @ X4 @ A4 ) ) ) ) )).

% Compl_eq
thf(fact_221_LeastI,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),K: A] :
          ( ( P2 @ K )
         => ( P2 @ ( ord_Least @ A @ P2 ) ) ) ) )).

% LeastI
thf(fact_222_LeastI2,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),A2: A,Q: ( A > $o )] :
          ( ( P2 @ A2 )
         => ( ! [X2: A] :
                ( ( P2 @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P2 ) ) ) ) ) )).

% LeastI2
thf(fact_223_LeastI__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o )] :
          ( ? [X12: A] :
              ( P2 @ X12 )
         => ( P2 @ ( ord_Least @ A @ P2 ) ) ) ) )).

% LeastI_ex
thf(fact_224_LeastI2__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),Q: ( A > $o )] :
          ( ? [X12: A] :
              ( P2 @ X12 )
         => ( ! [X2: A] :
                ( ( P2 @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P2 ) ) ) ) ) )).

% LeastI2_ex
thf(fact_225_ComplD,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
     => ~ ( member @ A @ C2 @ A3 ) ) )).

% ComplD
thf(fact_226_double__complement,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = A3 ) )).

% double_complement
thf(fact_227_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( sdrop_while @ A )
      = ( ^ [P3: ( A > $o ),S2: ( stream @ A )] :
            ( if @ ( stream @ A ) @ ( P3 @ ( shd @ A @ S2 ) ) @ ( sdrop_while @ A @ P3 @ ( stl @ A @ S2 ) ) @ S2 ) ) ) )).

% sdrop_while.simps
thf(fact_228_RuleSystem__Defs_Otrim__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1259602206m_trim @ Rule @ State )
      = ( ^ [Eff: ( Rule > State > ( fset @ State ) > $o ),Rs2: ( stream @ Rule ),S2: State] :
            ( sdrop_while @ Rule
            @ ^ [R2: Rule] :
                ~ ( abstra1874422341nabled @ Rule @ State @ Eff @ R2 @ S2 )
            @ Rs2 ) ) ) )).

% RuleSystem_Defs.trim_def
thf(fact_229_Konig,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ~ ( abstra668420080finite @ A @ T2 )
     => ( abstra313004635_ipath @ A @ T2 @ ( abstra1918223989_konig @ A @ T2 ) ) ) )).

% Konig
thf(fact_230_sdrop__while__sdrop__LEAST,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ? [N4: nat] :
          ( P2 @ ( snth @ A @ S @ N4 ) )
     => ( ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P2 ) @ S )
        = ( sdrop @ A
          @ ( ord_Least @ nat
            @ ^ [N2: nat] :
                ( P2 @ ( snth @ A @ S @ N2 ) ) )
          @ S ) ) ) )).

% sdrop_while_sdrop_LEAST
thf(fact_231_fset_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( B > C ),F: ( A > B ),V: ( fset @ A )] :
      ( ( fimage @ B @ C @ G @ ( fimage @ A @ B @ F @ V ) )
      = ( fimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fset.map_comp
thf(fact_232_ftree__no__ipath,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A ),Steps: ( stream @ A )] :
      ( ( abstra668420080finite @ A @ T2 )
     => ~ ( abstra313004635_ipath @ A @ T2 @ Steps ) ) )).

% ftree_no_ipath
thf(fact_233_tfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( abstra2103299360e_tree @ A )] :
      ( ( abstra668420080finite @ A @ A2 )
     => ! [T7: ( abstra2103299360e_tree @ A )] :
          ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ A2 ) )
         => ( abstra668420080finite @ A @ T7 ) ) ) )).

% tfinite.cases
thf(fact_234_tfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( abstra668420080finite @ A )
      = ( ^ [A7: ( abstra2103299360e_tree @ A )] :
          ? [T4: ( abstra2103299360e_tree @ A )] :
            ( ( A7 = T4 )
            & ! [X4: ( abstra2103299360e_tree @ A )] :
                ( ( fmember @ ( abstra2103299360e_tree @ A ) @ X4 @ ( abstra1749095923e_cont @ A @ T4 ) )
               => ( abstra668420080finite @ A @ X4 ) ) ) ) ) )).

% tfinite.simps
thf(fact_235_tfinite_Oinducts,axiom,(
    ! [A: $tType,X6: ( abstra2103299360e_tree @ A ),P2: ( ( abstra2103299360e_tree @ A ) > $o )] :
      ( ( abstra668420080finite @ A @ X6 )
     => ( ! [T9: ( abstra2103299360e_tree @ A )] :
            ( ! [T7: ( abstra2103299360e_tree @ A )] :
                ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ T9 ) )
               => ( abstra668420080finite @ A @ T7 ) )
           => ( ! [T7: ( abstra2103299360e_tree @ A )] :
                  ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ T9 ) )
                 => ( P2 @ T7 ) )
             => ( P2 @ T9 ) ) )
       => ( P2 @ X6 ) ) ) )).

% tfinite.inducts
thf(fact_236_tfinite,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ! [T3: ( abstra2103299360e_tree @ A )] :
          ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T3 @ ( abstra1749095923e_cont @ A @ T2 ) )
         => ( abstra668420080finite @ A @ T3 ) )
     => ( abstra668420080finite @ A @ T2 ) ) )).

% tfinite
thf(fact_237_konig_Osimps_I2_J,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ( stl @ A @ ( abstra1918223989_konig @ A @ T2 ) )
      = ( abstra1918223989_konig @ A
        @ @+[T5: ( abstra2103299360e_tree @ A )] :
            ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ T2 ) )
            & ~ ( abstra668420080finite @ A @ T5 ) ) ) ) )).

% konig.simps(2)
thf(fact_238_sfilter_Osimps_I1_J,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ( shd @ A @ ( sfilter @ A @ P2 @ S ) )
      = ( shd @ A @ ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P2 ) @ S ) ) ) )).

% sfilter.simps(1)
thf(fact_239_sfilter__not__P,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ~ ( P2 @ ( shd @ A @ S ) )
     => ( ( sfilter @ A @ P2 @ S )
        = ( sfilter @ A @ P2 @ ( stl @ A @ S ) ) ) ) )).

% sfilter_not_P
thf(fact_240_sfilter_Osimps_I2_J,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ( stl @ A @ ( sfilter @ A @ P2 @ S ) )
      = ( sfilter @ A @ P2 @ ( stl @ A @ ( sdrop_while @ A @ ( comp @ $o @ $o @ A @ ~ @ P2 ) @ S ) ) ) ) )).

% sfilter.simps(2)
thf(fact_241_some__in__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( member @ A
        @ @+[X4: A] :
            ( member @ A @ X4 @ A3 )
        @ A3 )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% some_in_eq
thf(fact_242_konig_Ocode,axiom,(
    ! [A: $tType] :
      ( ( abstra1918223989_konig @ A )
      = ( ^ [T4: ( abstra2103299360e_tree @ A )] :
            ( sCons @ A @ ( abstra573067619e_root @ A @ T4 )
            @ ( abstra1918223989_konig @ A
              @ @+[T5: ( abstra2103299360e_tree @ A )] :
                  ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T5 @ ( abstra1749095923e_cont @ A @ T4 ) )
                  & ~ ( abstra668420080finite @ A @ T5 ) ) ) ) ) ) )).

% konig.code
thf(fact_243_stream_Oinject,axiom,(
    ! [A: $tType,X13: A,X22: ( stream @ A ),Y1: A,Y22: ( stream @ A )] :
      ( ( ( sCons @ A @ X13 @ X22 )
        = ( sCons @ A @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% stream.inject
thf(fact_244_HLD__Stream,axiom,(
    ! [A: $tType,X3: ( set @ A ),X6: A,Omega2: ( stream @ A )] :
      ( ( linear1178169911on_HLD @ A @ X3 @ ( sCons @ A @ X6 @ Omega2 ) )
      = ( member @ A @ X6 @ X3 ) ) )).

% HLD_Stream
thf(fact_245_smember__code,axiom,(
    ! [A: $tType,X6: A,Y: A,S: ( stream @ A )] :
      ( ( smember @ A @ X6 @ ( sCons @ A @ Y @ S ) )
      = ( ( X6 != Y )
       => ( smember @ A @ X6 @ S ) ) ) )).

% smember_code
thf(fact_246_stream_Oset,axiom,(
    ! [A: $tType,X13: A,X22: ( stream @ A )] :
      ( ( sset @ A @ ( sCons @ A @ X13 @ X22 ) )
      = ( insert @ A @ X13 @ ( sset @ A @ X22 ) ) ) )).

% stream.set
thf(fact_247_stream_Ocollapse,axiom,(
    ! [A: $tType,Stream: ( stream @ A )] :
      ( ( sCons @ A @ ( shd @ A @ Stream ) @ ( stl @ A @ Stream ) )
      = Stream ) )).

% stream.collapse
thf(fact_248_sfilter__P,axiom,(
    ! [A: $tType,P2: ( A > $o ),S: ( stream @ A )] :
      ( ( P2 @ ( shd @ A @ S ) )
     => ( ( sfilter @ A @ P2 @ S )
        = ( sCons @ A @ ( shd @ A @ S ) @ ( sfilter @ A @ P2 @ ( stl @ A @ S ) ) ) ) ) )).

% sfilter_P
thf(fact_249_sfilter__Stream,axiom,(
    ! [A: $tType,P2: ( A > $o ),X6: A,S: ( stream @ A )] :
      ( ( ( P2 @ X6 )
       => ( ( sfilter @ A @ P2 @ ( sCons @ A @ X6 @ S ) )
          = ( sCons @ A @ X6 @ ( sfilter @ A @ P2 @ S ) ) ) )
      & ( ~ ( P2 @ X6 )
       => ( ( sfilter @ A @ P2 @ ( sCons @ A @ X6 @ S ) )
          = ( sfilter @ A @ P2 @ S ) ) ) ) )).

% sfilter_Stream
thf(fact_250_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( stream @ A ) > B ),X13: A,X22: ( stream @ A )] :
      ( ( case_stream @ A @ B @ F @ ( sCons @ A @ X13 @ X22 ) )
      = ( F @ X13 @ X22 ) ) )).

% stream.case
thf(fact_251_szip__unfold,axiom,(
    ! [A: $tType,B: $tType,A2: A,S1: ( stream @ A ),B3: B,S22: ( stream @ B )] :
      ( ( szip @ A @ B @ ( sCons @ A @ A2 @ S1 ) @ ( sCons @ B @ B3 @ S22 ) )
      = ( sCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B3 ) @ ( szip @ A @ B @ S1 @ S22 ) ) ) )).

% szip_unfold
thf(fact_252_stream_Osel_I1_J,axiom,(
    ! [A: $tType,X13: A,X22: ( stream @ A )] :
      ( ( shd @ A @ ( sCons @ A @ X13 @ X22 ) )
      = X13 ) )).

% stream.sel(1)
thf(fact_253_sinterleave__code,axiom,(
    ! [A: $tType,X6: A,S1: ( stream @ A ),S22: ( stream @ A )] :
      ( ( sinterleave @ A @ ( sCons @ A @ X6 @ S1 ) @ S22 )
      = ( sCons @ A @ X6 @ ( sinterleave @ A @ S22 @ S1 ) ) ) )).

% sinterleave_code
thf(fact_254_stream_Osel_I2_J,axiom,(
    ! [A: $tType,X13: A,X22: ( stream @ A )] :
      ( ( stl @ A @ ( sCons @ A @ X13 @ X22 ) )
      = X22 ) )).

% stream.sel(2)
thf(fact_255_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream @ A )] :
      ~ ( ! [X1: A,X23: ( stream @ A )] :
            ( Y
           != ( sCons @ A @ X1 @ X23 ) ) ) )).

% stream.exhaust

%----Type constructors (25)
thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_FSet_Ofset___Finite__Set_Ofinite_1,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_2,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_3,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite_4,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( boolean_algebra @ A9 @ ( type2 @ A9 ) )
     => ( boolean_algebra @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Countable_Ocountable,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( countable @ A9 @ ( type2 @ A9 ) ) )
     => ( countable @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( uminus @ A9 @ ( type2 @ A9 ) )
     => ( uminus @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Countable_Ocountable_5,axiom,
    ( countable @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_6,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_7,axiom,(
    ! [A8: $tType] :
      ( boolean_algebra @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Countable_Ocountable_8,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( countable @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_9,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_10,axiom,(
    ! [A8: $tType] :
      ( uminus @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_11,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Countable_Ocountable_12,axiom,
    ( countable @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_13,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_14,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_FSet_Ofset___Lattices_Oboolean__algebra_15,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( boolean_algebra @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_FSet_Ofset___Countable_Ocountable_16,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( countable @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Obot_17,axiom,(
    ! [A8: $tType] :
      ( bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Groups_Ouminus_18,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( uminus @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Countable_Ocountable_19,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( countable @ A8 @ ( type2 @ A8 ) )
        & ( countable @ A9 @ ( type2 @ A9 ) ) )
     => ( countable @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X6: A,Y: A] :
      ( ( if @ A @ $false @ X6 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X6: A,Y: A] :
      ( ( if @ A @ $true @ X6 @ Y )
      = X6 ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ! [N4: nat] :
      ( ( ( shd @ rule @ ( sdrop @ rule @ N4 @ rs ) )
        = r )
     => thesis ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
