%------------------------------------------------------------------------------
% File     : COM156^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Abstract completeness 215
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BPT14] Blanchette et al. (2014), Abstract Completeness
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : abstract_completeness__215.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  366 (   1 unit;  66 type;   0 defn)
%            Number of atoms       : 4543 ( 199 equality;2673 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 4458 (  62   ~;   4   |;  47   &;3974   @)
%                                         (   0 <=>; 371  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  344 ( 344   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   70 (  66   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1219 (   5 sgn;1023   !;  36   ?;  92   ^)
%                                         (1219   :;  63  !>;   0  ?*)
%                                         (   0  @-;   5  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:54:09.500
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree,type,(
    abstra2103299360e_tree: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_FSet_Ofset,type,(
    fset: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_tf_state,type,(
    state: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_rule,type,(
    rule: $tType )).

%----Explicit typings (57)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable_Ocountable,type,(
    countable: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem,type,(
    abstra1326562878System: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( set @ State ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem_OminWait,type,(
    abstra1332369113inWait: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > nat ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OSaturated,type,(
    abstra1209608345urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oenabled,type,(
    abstra1874422341nabled: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oepath,type,(
    abstra523868654_epath: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofair,type,(
    abstra928354080m_fair: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofenum,type,(
    abstra1774373515_fenum: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OmkTree,type,(
    abstra1225283448mkTree: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OpickEff,type,(
    abstra1276541928ickEff: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > ( fset @ State ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Osaturated,type,(
    abstra726722745urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Otrim,type,(
    abstra1259602206m_trim: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > ( stream @ Rule ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Owf,type,(
    abstra1874736267tem_wf: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Oipath,type,(
    abstra313004635_ipath: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Okonig,type,(
    abstra1918223989_konig: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otfinite,type,(
    abstra668420080finite: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_ONode,type,(
    abstra388494275e_Node: 
      !>[A: $tType] :
        ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > ( abstra2103299360e_tree @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Ocont,type,(
    abstra1749095923e_cont: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( fset @ ( abstra2103299360e_tree @ A ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Oroot,type,(
    abstra573067619e_root: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > A ) )).

thf(sy_c_Countable__Set_Ocountable,type,(
    countable_countable: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_FSet_Ofimage,type,(
    fimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( fset @ A ) > ( fset @ B ) ) )).

thf(sy_c_FSet_Ofmember,type,(
    fmember: 
      !>[A: $tType] :
        ( A > ( fset @ A ) > $o ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_OLeast,type,(
    ord_Least: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Stream_Osdrop,type,(
    sdrop: 
      !>[A: $tType] :
        ( nat > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osdrop__while,type,(
    sdrop_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Ocase__stream,type,(
    case_stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Stream_Ostream_Oshd,type,(
    shd: 
      !>[A: $tType] :
        ( ( stream @ A ) > A ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream_Ostream_Ostl,type,(
    stl: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Oszip,type,(
    szip: 
      !>[A: $tType,B: $tType] :
        ( ( stream @ A ) > ( stream @ B ) > ( stream @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_S,type,(
    s: ( set @ state ) )).

thf(sy_v_eff,type,(
    eff: rule > state > ( fset @ state ) > $o )).

thf(sy_v_ma____,type,(
    ma: nat )).

thf(sy_v_rs,type,(
    rs: ( stream @ rule ) )).

thf(sy_v_rsa____,type,(
    rsa: ( stream @ rule ) )).

thf(sy_v_rules,type,(
    rules: ( stream @ rule ) )).

thf(sy_v_s,type,(
    s2: state )).

thf(sy_v_steps,type,(
    steps: ( stream @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_stepsa____,type,(
    stepsa: ( stream @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

%----Relevant facts (256)
thf(fact_0_s,axiom,
    ( member @ state @ s2 @ s )).

% s
thf(fact_1_rs,axiom,
    ( abstra928354080m_fair @ rule @ rules @ rs )).

% rs
thf(fact_2_Suc_Oprems_I2_J,axiom,
    ( abstra928354080m_fair @ rule @ rules @ rsa )).

% Suc.prems(2)
thf(fact_3_i,axiom,
    ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ rs @ s2 ) @ steps )).

% i
thf(fact_4_RuleSystem__axioms,axiom,
    ( abstra1326562878System @ rule @ state @ eff @ rules @ s )).

% RuleSystem_axioms
thf(fact_5_sdrop__fair,axiom,(
    ! [Rs: ( stream @ rule ),M: nat] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( abstra928354080m_fair @ rule @ rules @ ( sdrop @ rule @ M @ Rs ) ) ) )).

% sdrop_fair
thf(fact_6_Suc_Oprems_I3_J,axiom,
    ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ rsa @ s2 ) @ stepsa )).

% Suc.prems(3)
thf(fact_7_enabled__def,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
      = ( ^ [P: ( ( fset @ state ) > $o )] :
          ? [X: ( fset @ state )] :
            ( P @ X )
        @ ( eff @ R @ S ) ) ) )).

% enabled_def
thf(fact_8_Suc_Ohyps,axiom,(
    ! [Rs2: ( stream @ rule ),Steps: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( member @ state @ s2 @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs2 )
       => ( ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs2 @ s2 ) @ Steps )
         => ? [N: nat,S2: state] :
              ( ( member @ state @ S2 @ s )
              & ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( sdrop @ rule @ N @ Rs2 ) @ S2 ) @ ( sdrop @ ( product_prod @ state @ rule ) @ ma @ Steps ) ) ) ) ) ) )).

% Suc.hyps
thf(fact_9_RuleSystem__Defs_Osdrop__fair,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule ),Rs: ( stream @ Rule ),M: nat] :
      ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
     => ( abstra928354080m_fair @ Rule @ Rules @ ( sdrop @ Rule @ M @ Rs ) ) ) )).

% RuleSystem_Defs.sdrop_fair
thf(fact_10_trim__fair,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( abstra928354080m_fair @ rule @ rules @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) ) )).

% trim_fair
thf(fact_11_enabled__R,axiom,(
    ! [S: state] :
      ( ( member @ state @ S @ s )
     => ? [X2: rule] :
          ( ( member @ rule @ X2 @ ( sset @ rule @ rules ) )
          & ? [X1: ( fset @ state )] :
              ( eff @ X2 @ S @ X1 ) ) ) )).

% enabled_R
thf(fact_12_trim__alt,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S )
          = ( sdrop @ rule @ ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S ) @ Rs ) ) ) ) )).

% trim_alt
thf(fact_13_sdrop__szip,axiom,(
    ! [A: $tType,B: $tType,N2: nat,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( sdrop @ ( product_prod @ A @ B ) @ N2 @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( szip @ A @ B @ ( sdrop @ A @ N2 @ S1 ) @ ( sdrop @ B @ N2 @ S22 ) ) ) )).

% sdrop_szip
thf(fact_14_minWait__ex,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ? [N: nat] :
            ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N @ Rs ) ) @ S ) ) ) )).

% minWait_ex
thf(fact_15_wf__ipath__epath,axiom,(
    ! [T2: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ),Steps2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ T2 )
     => ( ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ T2 @ Steps2 )
       => ( abstra523868654_epath @ rule @ state @ eff @ rules @ Steps2 ) ) ) )).

% wf_ipath_epath
thf(fact_16_pickEff,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
     => ( eff @ R @ S @ ( abstra1276541928ickEff @ rule @ state @ eff @ R @ S ) ) ) )).

% pickEff
thf(fact_17_ftree__no__ipath,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A ),Steps2: ( stream @ A )] :
      ( ( abstra668420080finite @ A @ T2 )
     => ~ ( abstra313004635_ipath @ A @ T2 @ Steps2 ) ) )).

% ftree_no_ipath
thf(fact_18_trim__in__R,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( member @ rule @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ ( sset @ rule @ rules ) ) ) ) )).

% trim_in_R
thf(fact_19_trim__enabled,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) )).

% trim_enabled
thf(fact_20_sset__fenum,axiom,
    ( ( sset @ rule @ ( abstra1774373515_fenum @ rule @ rules ) )
    = ( sset @ rule @ rules ) )).

% sset_fenum
thf(fact_21_fair__fenum,axiom,
    ( abstra928354080m_fair @ rule @ rules @ ( abstra1774373515_fenum @ rule @ rules ) )).

% fair_fenum
thf(fact_22_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream @ A )] :
      ( member @ A @ ( shd @ A @ A2 ) @ ( sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_23_RuleSystem_Oenabled__R,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ? [X2: Rule] :
            ( ( member @ Rule @ X2 @ ( sset @ Rule @ Rules ) )
            & ? [X1: ( fset @ State )] :
                ( Eff @ X2 @ S @ X1 ) ) ) ) )).

% RuleSystem.enabled_R
thf(fact_24_RuleSystem_Otrim__fair,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( abstra928354080m_fair @ Rule @ Rules @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) ) ) ) )).

% RuleSystem.trim_fair
thf(fact_25_RuleSystem_Otrim__in__R,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( member @ Rule @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ ( sset @ Rule @ Rules ) ) ) ) ) )).

% RuleSystem.trim_in_R
thf(fact_26_RuleSystem_Otrim__enabled,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S ) ) ) ) )).

% RuleSystem.trim_enabled
thf(fact_27_RuleSystem__Defs_OpickEff,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),R: Rule,S: State] :
      ( ( abstra1874422341nabled @ Rule @ State @ Eff @ R @ S )
     => ( Eff @ R @ S @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ R @ S ) ) ) )).

% RuleSystem_Defs.pickEff
thf(fact_28_RuleSystem_OminWait__ex,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ? [N: nat] :
              ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( sdrop @ Rule @ N @ Rs ) ) @ S ) ) ) ) )).

% RuleSystem.minWait_ex
thf(fact_29_RuleSystem__Defs_Oenabled__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1874422341nabled @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),R2: Rule,S4: State] :
            ( ^ [P: ( ( fset @ State ) > $o )] :
              ? [X: ( fset @ State )] :
                ( P @ X )
            @ ( Eff2 @ R2 @ S4 ) ) ) ) )).

% RuleSystem_Defs.enabled_def
thf(fact_30_RuleSystem_Otrim__alt,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S )
            = ( sdrop @ Rule @ ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S ) @ Rs ) ) ) ) ) )).

% RuleSystem.trim_alt
thf(fact_31_RuleSystem__Defs_Owf__ipath__epath,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),T2: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ),Steps2: ( stream @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ T2 )
     => ( ( abstra313004635_ipath @ ( product_prod @ State @ Rule ) @ T2 @ Steps2 )
       => ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ Steps2 ) ) ) )).

% RuleSystem_Defs.wf_ipath_epath
thf(fact_32_trim__def,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S )
      = ( sdrop_while @ rule
        @ ^ [R2: rule] :
            ~ ( abstra1874422341nabled @ rule @ state @ eff @ R2 @ S )
        @ Rs ) ) )).

% trim_def
thf(fact_33_Saturated__def,axiom,(
    ! [Steps2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1209608345urated @ rule @ state @ eff @ rules @ Steps2 )
      = ( ! [X3: rule] :
            ( ( member @ rule @ X3 @ ( sset @ rule @ rules ) )
           => ( abstra726722745urated @ rule @ state @ eff @ X3 @ Steps2 ) ) ) ) )).

% Saturated_def
thf(fact_34_minWait__def,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S )
      = ( ord_Least @ nat
        @ ^ [N3: nat] :
            ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N3 @ Rs ) ) @ S ) ) ) )).

% minWait_def
thf(fact_35_minWait__least,axiom,(
    ! [N2: nat,Rs: ( stream @ rule ),S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N2 @ Rs ) ) @ S )
     => ( ord_less_eq @ nat @ ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S ) @ N2 ) ) )).

% minWait_least
thf(fact_36_eff__S,axiom,(
    ! [S: state,R: rule,Sl: ( fset @ state ),S5: state] :
      ( ( member @ state @ S @ s )
     => ( ( member @ rule @ R @ ( sset @ rule @ rules ) )
       => ( ( eff @ R @ S @ Sl )
         => ( ( fmember @ state @ S5 @ Sl )
           => ( member @ state @ S5 @ s ) ) ) ) ) )).

% eff_S
thf(fact_37_NE__R,axiom,(
    ( sset @ rule @ rules )
 != ( bot_bot @ ( set @ rule ) ) )).

% NE_R
thf(fact_38_RuleSystem_OminWait__def,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S )
        = ( ord_Least @ nat
          @ ^ [N3: nat] :
              ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( sdrop @ Rule @ N3 @ Rs ) ) @ S ) ) ) ) )).

% RuleSystem.minWait_def
thf(fact_39_countable__R,axiom,
    ( countable_countable @ rule @ ( sset @ rule @ rules ) )).

% countable_R
thf(fact_40_fair__stl,axiom,(
    ! [Rs: ( stream @ rule )] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( abstra928354080m_fair @ rule @ rules @ ( stl @ rule @ Rs ) ) ) )).

% fair_stl
thf(fact_41_RuleSystem_OminWait__least,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),N2: nat,Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( sdrop @ Rule @ N2 @ Rs ) ) @ S )
       => ( ord_less_eq @ nat @ ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S ) @ N2 ) ) ) )).

% RuleSystem.minWait_least
thf(fact_42_szip_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( stl @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( szip @ A @ B @ ( stl @ A @ S1 ) @ ( stl @ B @ S22 ) ) ) )).

% szip.simps(2)
thf(fact_43_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( sdrop_while @ A )
      = ( ^ [P2: ( A > $o ),S4: ( stream @ A )] :
            ( if @ ( stream @ A ) @ ( P2 @ ( shd @ A @ S4 ) ) @ ( sdrop_while @ A @ P2 @ ( stl @ A @ S4 ) ) @ S4 ) ) ) )).

% sdrop_while.simps
thf(fact_44_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R3: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R3 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R3 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( ( R3 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) )
                | ( ( stl @ A @ Stream3 )
                  = ( stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P3: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P3 ) )
      = ( P3 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P3 @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P3 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_stream_Ocoinduct,axiom,(
    ! [A: $tType,R3: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R3 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R3 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( R3 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_50_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( ( ( shd @ A @ Stream )
          = ( shd @ A @ Stream2 ) )
        & ( ( stl @ A @ Stream )
          = ( stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_51_stl__sset,axiom,(
    ! [A: $tType,X4: A,A2: ( stream @ A )] :
      ( ( member @ A @ X4 @ ( sset @ A @ ( stl @ A @ A2 ) ) )
     => ( member @ A @ X4 @ ( sset @ A @ A2 ) ) ) )).

% stl_sset
thf(fact_52_RuleSystem__Defs_Ocountable__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( countable_countable @ Rule @ ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.countable_R
thf(fact_53_sdrop__stl,axiom,(
    ! [A: $tType,N2: nat,S: ( stream @ A )] :
      ( ( sdrop @ A @ N2 @ ( stl @ A @ S ) )
      = ( stl @ A @ ( sdrop @ A @ N2 @ S ) ) ) )).

% sdrop_stl
thf(fact_54_RuleSystem__Defs_Ofair__stl,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule ),Rs: ( stream @ Rule )] :
      ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
     => ( abstra928354080m_fair @ Rule @ Rules @ ( stl @ Rule @ Rs ) ) ) )).

% RuleSystem_Defs.fair_stl
thf(fact_55_RuleSystem__Defs_ONE__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ Rules )
     != ( bot_bot @ ( set @ Rule ) ) ) )).

% RuleSystem_Defs.NE_R
thf(fact_56_sset__induct,axiom,(
    ! [A: $tType,Y: A,S: ( stream @ A ),P3: ( A > ( stream @ A ) > $o )] :
      ( ( member @ A @ Y @ ( sset @ A @ S ) )
     => ( ! [S6: ( stream @ A )] :
            ( P3 @ ( shd @ A @ S6 ) @ S6 )
       => ( ! [S6: ( stream @ A ),Y2: A] :
              ( ( member @ A @ Y2 @ ( sset @ A @ ( stl @ A @ S6 ) ) )
             => ( ( P3 @ Y2 @ ( stl @ A @ S6 ) )
               => ( P3 @ Y2 @ S6 ) ) )
         => ( P3 @ Y @ S ) ) ) ) )).

% sset_induct
thf(fact_57_RuleSystem_Ointro,axiom,(
    ! [Rule: $tType,State: $tType,S3: ( set @ State ),Rules: ( stream @ Rule ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ! [S6: State] :
          ( ( member @ State @ S6 @ S3 )
         => ! [R4: Rule] :
              ( ( member @ Rule @ R4 @ ( sset @ Rule @ Rules ) )
             => ! [Sl2: ( fset @ State )] :
                  ( ( Eff @ R4 @ S6 @ Sl2 )
                 => ! [S2: State] :
                      ( ( fmember @ State @ S2 @ Sl2 )
                     => ( member @ State @ S2 @ S3 ) ) ) ) )
     => ( ! [S6: State] :
            ( ( member @ State @ S6 @ S3 )
           => ? [X5: Rule] :
                ( ( member @ Rule @ X5 @ ( sset @ Rule @ Rules ) )
                & ? [X12: ( fset @ State )] :
                    ( Eff @ X5 @ S6 @ X12 ) ) )
       => ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 ) ) ) )).

% RuleSystem.intro
thf(fact_58_RuleSystem_Oeff__S,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,R: Rule,Sl: ( fset @ State ),S5: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( member @ Rule @ R @ ( sset @ Rule @ Rules ) )
         => ( ( Eff @ R @ S @ Sl )
           => ( ( fmember @ State @ S5 @ Sl )
             => ( member @ State @ S5 @ S3 ) ) ) ) ) ) )).

% RuleSystem.eff_S
thf(fact_59_RuleSystem__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1326562878System @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),S7: ( set @ State )] :
            ( ! [S4: State] :
                ( ( member @ State @ S4 @ S7 )
               => ! [R2: Rule] :
                    ( ( member @ Rule @ R2 @ ( sset @ Rule @ Rules2 ) )
                   => ! [Sl3: ( fset @ State )] :
                        ( ( Eff2 @ R2 @ S4 @ Sl3 )
                       => ! [S8: State] :
                            ( ( fmember @ State @ S8 @ Sl3 )
                           => ( member @ State @ S8 @ S7 ) ) ) ) )
            & ! [S4: State] :
                ( ( member @ State @ S4 @ S7 )
               => ? [X3: Rule] :
                    ( ( member @ Rule @ X3 @ ( sset @ Rule @ Rules2 ) )
                    & ( ^ [P: ( ( fset @ State ) > $o )] :
                        ? [X: ( fset @ State )] :
                          ( P @ X )
                      @ ( Eff2 @ X3 @ S4 ) ) ) ) ) ) ) )).

% RuleSystem_def
thf(fact_60_RuleSystem__Defs_OSaturated__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1209608345urated @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),Steps3: ( stream @ ( product_prod @ State @ Rule ) )] :
          ! [X3: Rule] :
            ( ( member @ Rule @ X3 @ ( sset @ Rule @ Rules2 ) )
           => ( abstra726722745urated @ Rule @ State @ Eff2 @ X3 @ Steps3 ) ) ) ) )).

% RuleSystem_Defs.Saturated_def
thf(fact_61_RuleSystem__Defs_Osset__fenum,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ ( abstra1774373515_fenum @ Rule @ Rules ) )
      = ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.sset_fenum
thf(fact_62_RuleSystem__Defs_Ofair__fenum,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( abstra928354080m_fair @ Rule @ Rules @ ( abstra1774373515_fenum @ Rule @ Rules ) ) )).

% RuleSystem_Defs.fair_fenum
thf(fact_63_RuleSystem__Defs_Otrim__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1259602206m_trim @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs3: ( stream @ Rule ),S4: State] :
            ( sdrop_while @ Rule
            @ ^ [R2: Rule] :
                ~ ( abstra1874422341nabled @ Rule @ State @ Eff2 @ R2 @ S4 )
            @ Rs3 ) ) ) )).

% RuleSystem_Defs.trim_def
thf(fact_64_countable__empty,axiom,(
    ! [A: $tType] :
      ( countable_countable @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% countable_empty
thf(fact_65_in__cont__mkTree,axiom,(
    ! [S: state,Rs: ( stream @ rule ),T3: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ T3 @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) ) )
         => ? [Sl4: ( fset @ state ),S2: state] :
              ( ( member @ state @ S2 @ s )
              & ( eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S @ Sl4 )
              & ( fmember @ state @ S2 @ Sl4 )
              & ( T3
                = ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S2 ) ) ) ) ) ) )).

% in_cont_mkTree
thf(fact_66_countableI__type,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ A )] :
          ( countable_countable @ A @ A3 ) ) )).

% countableI_type
thf(fact_67_RuleSystem_Oin__cont__mkTree,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule ),T3: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ T3 @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) ) )
           => ? [Sl4: ( fset @ State ),S2: State] :
                ( ( member @ State @ S2 @ S3 )
                & ( Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S @ Sl4 )
                & ( fmember @ State @ S2 @ Sl4 )
                & ( T3
                  = ( abstra1225283448mkTree @ Rule @ State @ Eff @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S2 ) ) ) ) ) ) ) )).

% RuleSystem.in_cont_mkTree
thf(fact_68_Least__le,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),K: A] :
          ( ( P3 @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P3 ) @ K ) ) ) )).

% Least_le
thf(fact_69_empty__Collect__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P3 ) )
      = ( ! [X3: A] :
            ~ ( P3 @ X3 ) ) ) )).

% empty_Collect_eq
thf(fact_70_Collect__empty__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( collect @ A @ P3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ~ ( P3 @ X3 ) ) ) )).

% Collect_empty_eq
thf(fact_71_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X3: A] :
            ~ ( member @ A @ X3 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_72_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X4: A] :
          ( ord_less_eq @ A @ X4 @ X4 ) ) )).

% order_refl
thf(fact_73_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X3: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_74_subset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_75_empty__subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) )).

% empty_subsetI
thf(fact_76_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_77_countable__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( countable_countable @ A @ B2 )
       => ( countable_countable @ A @ A3 ) ) ) )).

% countable_subset
thf(fact_78_tfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( abstra2103299360e_tree @ A )] :
      ( ( abstra668420080finite @ A @ A2 )
     => ! [T4: ( abstra2103299360e_tree @ A )] :
          ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T4 @ ( abstra1749095923e_cont @ A @ A2 ) )
         => ( abstra668420080finite @ A @ T4 ) ) ) )).

% tfinite.cases
thf(fact_79_tfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( abstra668420080finite @ A )
      = ( ^ [A4: ( abstra2103299360e_tree @ A )] :
          ? [T5: ( abstra2103299360e_tree @ A )] :
            ( ( A4 = T5 )
            & ! [X3: ( abstra2103299360e_tree @ A )] :
                ( ( fmember @ ( abstra2103299360e_tree @ A ) @ X3 @ ( abstra1749095923e_cont @ A @ T5 ) )
               => ( abstra668420080finite @ A @ X3 ) ) ) ) ) )).

% tfinite.simps
thf(fact_80_tfinite_Oinducts,axiom,(
    ! [A: $tType,X4: ( abstra2103299360e_tree @ A ),P3: ( ( abstra2103299360e_tree @ A ) > $o )] :
      ( ( abstra668420080finite @ A @ X4 )
     => ( ! [T6: ( abstra2103299360e_tree @ A )] :
            ( ! [T4: ( abstra2103299360e_tree @ A )] :
                ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T4 @ ( abstra1749095923e_cont @ A @ T6 ) )
               => ( abstra668420080finite @ A @ T4 ) )
           => ( ! [T4: ( abstra2103299360e_tree @ A )] :
                  ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T4 @ ( abstra1749095923e_cont @ A @ T6 ) )
                 => ( P3 @ T4 ) )
             => ( P3 @ T6 ) ) )
       => ( P3 @ X4 ) ) ) )).

% tfinite.inducts
thf(fact_81_tfinite,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ! [T7: ( abstra2103299360e_tree @ A )] :
          ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ T2 ) )
         => ( abstra668420080finite @ A @ T7 ) )
     => ( abstra668420080finite @ A @ T2 ) ) )).

% tfinite
thf(fact_82_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X4: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X4 ) @ ( G @ X4 ) ) ) ) )).

% le_funD
thf(fact_83_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X4: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X4 ) @ ( G @ X4 ) ) ) ) )).

% le_funE
thf(fact_84_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X2: A] :
              ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_85_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B )] :
            ! [X3: A] :
              ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) )).

% le_fun_def
thf(fact_86_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_87_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ C @ ( F @ B3 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_88_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C2: B] :
          ( ( A2
            = ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_89_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ( F @ B3 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_90_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X3 ) ) ) ) ) )).

% eq_iff
thf(fact_91_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( ord_less_eq @ A @ X4 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X4 )
           => ( X4 = Y ) ) ) ) )).

% antisym
thf(fact_92_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( ord_less_eq @ A @ X4 @ Y )
          | ( ord_less_eq @ A @ Y @ X4 ) ) ) )).

% linear
thf(fact_93_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( X4 = Y )
         => ( ord_less_eq @ A @ X4 @ Y ) ) ) )).

% eq_refl
thf(fact_94_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X4 @ Y )
         => ( ord_less_eq @ A @ Y @ X4 ) ) ) )).

% le_cases
thf(fact_95_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% order.trans
thf(fact_96_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X4 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X4 )
             => ~ ( ord_less_eq @ A @ X4 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X4 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X4 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X4 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X4 )
                     => ~ ( ord_less_eq @ A @ X4 @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_97_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X4: A] :
          ( ( ord_less_eq @ A @ Y @ X4 )
         => ( ( ord_less_eq @ A @ X4 @ Y )
            = ( X4 = Y ) ) ) ) )).

% antisym_conv
thf(fact_98_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( A2 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_99_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_100_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A2 )
           => ( A2 = B3 ) ) ) ) )).

% order_class.order.antisym
thf(fact_101_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X4 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X4 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_102_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_103_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > A > $o ),A2: A,B3: A] :
          ( ! [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
             => ( P3 @ A5 @ B4 ) )
         => ( ! [A5: A,B4: A] :
                ( ( P3 @ B4 @ A5 )
               => ( P3 @ A5 @ B4 ) )
           => ( P3 @ A2 @ B3 ) ) ) ) )).

% linorder_wlog
thf(fact_104_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_105_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B3 )
           => ( A2 = B3 ) ) ) ) )).

% dual_order.antisym
thf(fact_106_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X3: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_107_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_108_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_109_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_110_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_111_LeastI2,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),A2: A,Q: ( A > $o )] :
          ( ( P3 @ A2 )
         => ( ! [X2: A] :
                ( ( P3 @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2
thf(fact_112_LeastI__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o )] :
          ( ? [X12: A] :
              ( P3 @ X12 )
         => ( P3 @ ( ord_Least @ A @ P3 ) ) ) ) )).

% LeastI_ex
thf(fact_113_LeastI2__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),Q: ( A > $o )] :
          ( ? [X12: A] :
              ( P3 @ X12 )
         => ( ! [X2: A] :
                ( ( P3 @ X2 )
               => ( Q @ X2 ) )
           => ( Q @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2_ex
thf(fact_114_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X3: A] : $false ) ) )).

% empty_def
thf(fact_115_countable__Collect,axiom,(
    ! [A: $tType,A3: ( set @ A ),Phi: ( A > $o )] :
      ( ( countable_countable @ A @ A3 )
     => ( countable_countable @ A
        @ ( collect @ A
          @ ^ [A4: A] :
              ( ( member @ A @ A4 @ A3 )
              & ( Phi @ A4 ) ) ) ) ) )).

% countable_Collect
thf(fact_116_LeastI,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),K: A] :
          ( ( P3 @ K )
         => ( P3 @ ( ord_Least @ A @ P3 ) ) ) ) )).

% LeastI
thf(fact_117_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) )).

% bot.extremum
thf(fact_118_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_119_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_120_LeastI2__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),X4: A,Q: ( A > $o )] :
          ( ( P3 @ X4 )
         => ( ! [Y2: A] :
                ( ( P3 @ Y2 )
               => ( ord_less_eq @ A @ X4 @ Y2 ) )
           => ( ! [X2: A] :
                  ( ( P3 @ X2 )
                 => ( ! [Y5: A] :
                        ( ( P3 @ Y5 )
                       => ( ord_less_eq @ A @ X2 @ Y5 ) )
                   => ( Q @ X2 ) ) )
             => ( Q @ ( ord_Least @ A @ P3 ) ) ) ) ) ) )).

% LeastI2_order
thf(fact_121_Least__equality,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),X4: A] :
          ( ( P3 @ X4 )
         => ( ! [Y2: A] :
                ( ( P3 @ Y2 )
               => ( ord_less_eq @ A @ X4 @ Y2 ) )
           => ( ( ord_Least @ A @ P3 )
              = X4 ) ) ) ) )).

% Least_equality
thf(fact_122_LeastI2__wellorder,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),A2: A,Q: ( A > $o )] :
          ( ( P3 @ A2 )
         => ( ! [A5: A] :
                ( ( P3 @ A5 )
               => ( ! [B5: A] :
                      ( ( P3 @ B5 )
                     => ( ord_less_eq @ A @ A5 @ B5 ) )
                 => ( Q @ A5 ) ) )
           => ( Q @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2_wellorder
thf(fact_123_LeastI2__wellorder__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),Q: ( A > $o )] :
          ( ? [X12: A] :
              ( P3 @ X12 )
         => ( ! [A5: A] :
                ( ( P3 @ A5 )
               => ( ! [B5: A] :
                      ( ( P3 @ B5 )
                     => ( ord_less_eq @ A @ A5 @ B5 ) )
                 => ( Q @ A5 ) ) )
           => ( Q @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2_wellorder_ex
thf(fact_124_mkTree_Osimps_I2_J,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) )
      = ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) )).

% mkTree.simps(2)
thf(fact_125_fsubsetI,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ! [X2: A] :
          ( ( fmember @ A @ X2 @ A3 )
         => ( fmember @ A @ X2 @ B2 ) )
     => ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 ) ) )).

% fsubsetI
thf(fact_126_ipath_Ocases,axiom,(
    ! [A: $tType,A1: ( abstra2103299360e_tree @ A ),A22: ( stream @ A )] :
      ( ( abstra313004635_ipath @ A @ A1 @ A22 )
     => ~ ( ( ( abstra573067619e_root @ A @ A1 )
            = ( shd @ A @ A22 ) )
         => ! [T7: ( abstra2103299360e_tree @ A )] :
              ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T7 @ ( abstra1749095923e_cont @ A @ A1 ) )
             => ~ ( abstra313004635_ipath @ A @ T7 @ ( stl @ A @ A22 ) ) ) ) ) )).

% ipath.cases
thf(fact_127_ipath_Osimps,axiom,(
    ! [A: $tType] :
      ( ( abstra313004635_ipath @ A )
      = ( ^ [A12: ( abstra2103299360e_tree @ A ),A23: ( stream @ A )] :
          ? [T5: ( abstra2103299360e_tree @ A ),Steps3: ( stream @ A ),T8: ( abstra2103299360e_tree @ A )] :
            ( ( A12 = T5 )
            & ( A23 = Steps3 )
            & ( ( abstra573067619e_root @ A @ T5 )
              = ( shd @ A @ Steps3 ) )
            & ( fmember @ ( abstra2103299360e_tree @ A ) @ T8 @ ( abstra1749095923e_cont @ A @ T5 ) )
            & ( abstra313004635_ipath @ A @ T8 @ ( stl @ A @ Steps3 ) ) ) ) ) )).

% ipath.simps
thf(fact_128_ipath_Ointros,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A ),Steps2: ( stream @ A ),T3: ( abstra2103299360e_tree @ A )] :
      ( ( ( abstra573067619e_root @ A @ T2 )
        = ( shd @ A @ Steps2 ) )
     => ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T3 @ ( abstra1749095923e_cont @ A @ T2 ) )
       => ( ( abstra313004635_ipath @ A @ T3 @ ( stl @ A @ Steps2 ) )
         => ( abstra313004635_ipath @ A @ T2 @ Steps2 ) ) ) ) )).

% ipath.intros
thf(fact_129_ipath_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ),X4: ( abstra2103299360e_tree @ A ),Xa: ( stream @ A )] :
      ( ( X6 @ X4 @ Xa )
     => ( ! [X2: ( abstra2103299360e_tree @ A ),Xa2: ( stream @ A )] :
            ( ( X6 @ X2 @ Xa2 )
           => ? [T9: ( abstra2103299360e_tree @ A ),Steps4: ( stream @ A ),T4: ( abstra2103299360e_tree @ A )] :
                ( ( X2 = T9 )
                & ( Xa2 = Steps4 )
                & ( ( abstra573067619e_root @ A @ T9 )
                  = ( shd @ A @ Steps4 ) )
                & ( fmember @ ( abstra2103299360e_tree @ A ) @ T4 @ ( abstra1749095923e_cont @ A @ T9 ) )
                & ( ( X6 @ T4 @ ( stl @ A @ Steps4 ) )
                  | ( abstra313004635_ipath @ A @ T4 @ ( stl @ A @ Steps4 ) ) ) ) )
       => ( abstra313004635_ipath @ A @ X4 @ Xa ) ) ) )).

% ipath.coinduct
thf(fact_130_RuleSystem__Defs_OmkTree_Osimps_I2_J,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) )
      = ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S ) ) ) )).

% RuleSystem_Defs.mkTree.simps(2)
thf(fact_131_subset__antisym,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
       => ( A3 = B2 ) ) ) )).

% subset_antisym
thf(fact_132_subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A3 )
         => ( member @ A @ X2 @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) )).

% subsetI
thf(fact_133_fempty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( fmember @ A @ C2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% fempty_iff
thf(fact_134_all__not__fin__conv,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ( ! [X3: A] :
            ~ ( fmember @ A @ X3 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% all_not_fin_conv
thf(fact_135_fimage__is__fempty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( fset @ B )] :
      ( ( ( fimage @ B @ A @ F @ A3 )
        = ( bot_bot @ ( fset @ A ) ) )
      = ( A3
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fimage_is_fempty
thf(fact_136_fempty__is__fimage,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( fset @ B )] :
      ( ( ( bot_bot @ ( fset @ A ) )
        = ( fimage @ B @ A @ F @ A3 ) )
      = ( A3
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fempty_is_fimage
thf(fact_137_fsubset__antisym,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
     => ( ( ord_less_eq @ ( fset @ A ) @ B2 @ A3 )
       => ( A3 = B2 ) ) ) )).

% fsubset_antisym
thf(fact_138_fempty__fsubsetI,axiom,(
    ! [A: $tType,X4: ( fset @ A )] :
      ( ord_less_eq @ ( fset @ A ) @ ( bot_bot @ ( fset @ A ) ) @ X4 ) )).

% fempty_fsubsetI
thf(fact_139_fsubset__fempty,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ ( bot_bot @ ( fset @ A ) ) )
      = ( A3
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% fsubset_fempty
thf(fact_140_fimage__fempty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( fimage @ B @ A @ F @ ( bot_bot @ ( fset @ B ) ) )
      = ( bot_bot @ ( fset @ A ) ) ) )).

% fimage_fempty
thf(fact_141_fimage__ident,axiom,(
    ! [A: $tType,Y6: ( fset @ A )] :
      ( ( fimage @ A @ A
        @ ^ [X3: A] : X3
        @ Y6 )
      = Y6 ) )).

% fimage_ident
thf(fact_142_fset_Omap__ident,axiom,(
    ! [A: $tType,T2: ( fset @ A )] :
      ( ( fimage @ A @ A
        @ ^ [X3: A] : X3
        @ T2 )
      = T2 ) )).

% fset.map_ident
thf(fact_143_fimage__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),X4: B,A3: ( fset @ B )] :
      ( ( B3
        = ( F @ X4 ) )
     => ( ( fmember @ B @ X4 @ A3 )
       => ( fmember @ A @ B3 @ ( fimage @ B @ A @ F @ A3 ) ) ) ) )).

% fimage_eqI
thf(fact_144_less__eq__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ A6 )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ B6 ) ) ) ) )).

% less_eq_set_def
thf(fact_145_subset__fimage__iff,axiom,(
    ! [A: $tType,B: $tType,B2: ( fset @ A ),F: ( B > A ),A3: ( fset @ B )] :
      ( ( ord_less_eq @ ( fset @ A ) @ B2 @ ( fimage @ B @ A @ F @ A3 ) )
      = ( ? [AA: ( fset @ B )] :
            ( ( ord_less_eq @ ( fset @ B ) @ AA @ A3 )
            & ( B2
              = ( fimage @ B @ A @ F @ AA ) ) ) ) ) )).

% subset_fimage_iff
thf(fact_146_Collect__mono__iff,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) )
      = ( ! [X3: A] :
            ( ( P3 @ X3 )
           => ( Q @ X3 ) ) ) ) )).

% Collect_mono_iff
thf(fact_147_fset__eq__fsubset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( fset @ A ),Z: ( fset @ A )] : ( Y3 = Z ) )
      = ( ^ [A6: ( fset @ A ),B6: ( fset @ A )] :
            ( ( ord_less_eq @ ( fset @ A ) @ A6 @ B6 )
            & ( ord_less_eq @ ( fset @ A ) @ B6 @ A6 ) ) ) ) )).

% fset_eq_fsubset
thf(fact_148_fimage__fsubsetI,axiom,(
    ! [A: $tType,B: $tType,A3: ( fset @ A ),F: ( A > B ),B2: ( fset @ B )] :
      ( ! [X2: A] :
          ( ( fmember @ A @ X2 @ A3 )
         => ( fmember @ B @ ( F @ X2 ) @ B2 ) )
     => ( ord_less_eq @ ( fset @ B ) @ ( fimage @ A @ B @ F @ A3 ) @ B2 ) ) )).

% fimage_fsubsetI
thf(fact_149_rev__fimage__eqI,axiom,(
    ! [B: $tType,A: $tType,X4: A,A3: ( fset @ A ),B3: B,F: ( A > B )] :
      ( ( fmember @ A @ X4 @ A3 )
     => ( ( B3
          = ( F @ X4 ) )
       => ( fmember @ B @ B3 @ ( fimage @ A @ B @ F @ A3 ) ) ) ) )).

% rev_fimage_eqI
thf(fact_150_equalsffemptyI,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ! [Y2: A] :
          ~ ( fmember @ A @ Y2 @ A3 )
     => ( A3
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% equalsffemptyI
thf(fact_151_equalsffemptyD,axiom,(
    ! [A: $tType,A3: ( fset @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( fset @ A ) ) )
     => ~ ( fmember @ A @ A2 @ A3 ) ) )).

% equalsffemptyD
thf(fact_152_contra__subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ~ ( member @ A @ C2 @ B2 )
       => ~ ( member @ A @ C2 @ A3 ) ) ) )).

% contra_subsetD
thf(fact_153_fsubset__trans,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),C3: ( fset @ A )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
     => ( ( ord_less_eq @ ( fset @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( fset @ A ) @ A3 @ C3 ) ) ) )).

% fsubset_trans
thf(fact_154_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( set @ A ),Z: ( set @ A )] : ( Y3 = Z ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) ) )).

% set_eq_subset
thf(fact_155_fsubset__refl,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ord_less_eq @ ( fset @ A ) @ A3 @ A3 ) )).

% fsubset_refl
thf(fact_156_subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% subset_trans
thf(fact_157_Collect__mono,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P3 @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_158_fimage__mono,axiom,(
    ! [B: $tType,A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),F: ( A > B )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
     => ( ord_less_eq @ ( fset @ B ) @ ( fimage @ A @ B @ F @ A3 ) @ ( fimage @ A @ B @ F @ B2 ) ) ) )).

% fimage_mono
thf(fact_159_fimage__cong,axiom,(
    ! [B: $tType,A: $tType,M2: ( fset @ A ),N4: ( fset @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M2 = N4 )
     => ( ! [X2: A] :
            ( ( fmember @ A @ X2 @ N4 )
           => ( ( F @ X2 )
              = ( G @ X2 ) ) )
       => ( ( fimage @ A @ B @ F @ M2 )
          = ( fimage @ A @ B @ G @ N4 ) ) ) ) )).

% fimage_cong
thf(fact_160_fequalityD2,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ( A3 = B2 )
     => ( ord_less_eq @ ( fset @ A ) @ B2 @ A3 ) ) )).

% fequalityD2
thf(fact_161_fequalityD1,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ( A3 = B2 )
     => ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 ) ) )).

% fequalityD1
thf(fact_162_ex__fin__conv,axiom,(
    ! [A: $tType,A3: ( fset @ A )] :
      ( ( ? [X3: A] :
            ( fmember @ A @ X3 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( fset @ A ) ) ) ) )).

% ex_fin_conv
thf(fact_163_subset__refl,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) )).

% subset_refl
thf(fact_164_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% rev_subsetD
thf(fact_165_fequalityE,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ( A3 = B2 )
     => ~ ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
         => ~ ( ord_less_eq @ ( fset @ A ) @ B2 @ A3 ) ) ) )).

% fequalityE
thf(fact_166_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
          ! [T5: A] :
            ( ( member @ A @ T5 @ A6 )
           => ( member @ A @ T5 @ B6 ) ) ) ) )).

% subset_iff
thf(fact_167_set__rev__mp,axiom,(
    ! [A: $tType,X4: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ X4 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
       => ( member @ A @ X4 @ B2 ) ) ) )).

% set_rev_mp
thf(fact_168_equalityD2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( A3 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A3 ) ) )).

% equalityD2
thf(fact_169_equalityD1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( A3 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) )).

% equalityD1
thf(fact_170_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( member @ A @ X3 @ B6 ) ) ) ) )).

% subset_eq
thf(fact_171_equalityE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( A3 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A3 ) ) ) )).

% equalityE
thf(fact_172_subsetCE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetCE
thf(fact_173_fimageI,axiom,(
    ! [B: $tType,A: $tType,X4: A,A3: ( fset @ A ),F: ( A > B )] :
      ( ( fmember @ A @ X4 @ A3 )
     => ( fmember @ B @ ( F @ X4 ) @ ( fimage @ A @ B @ F @ A3 ) ) ) )).

% fimageI
thf(fact_174_fimageE,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),A3: ( fset @ B )] :
      ( ( fmember @ A @ B3 @ ( fimage @ B @ A @ F @ A3 ) )
     => ~ ( ! [X2: B] :
              ( ( B3
                = ( F @ X2 ) )
             => ~ ( fmember @ B @ X2 @ A3 ) ) ) ) )).

% fimageE
thf(fact_175_femptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( fmember @ A @ A2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% femptyE
thf(fact_176_subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetD
thf(fact_177_in__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),X4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ X4 @ A3 )
       => ( member @ A @ X4 @ B2 ) ) ) )).

% in_mono
thf(fact_178_set__mp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),X4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ X4 @ A3 )
       => ( member @ A @ X4 @ B2 ) ) ) )).

% set_mp
thf(fact_179_fimage__fimage,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G: ( C > B ),A3: ( fset @ C )] :
      ( ( fimage @ B @ A @ F @ ( fimage @ C @ B @ G @ A3 ) )
      = ( fimage @ C @ A
        @ ^ [X3: C] :
            ( F @ ( G @ X3 ) )
        @ A3 ) ) )).

% fimage_fimage
thf(fact_180_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_181_tree_Oexpand,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A ),Tree2: ( abstra2103299360e_tree @ A )] :
      ( ( ( ( abstra573067619e_root @ A @ Tree )
          = ( abstra573067619e_root @ A @ Tree2 ) )
        & ( ( abstra1749095923e_cont @ A @ Tree )
          = ( abstra1749095923e_cont @ A @ Tree2 ) ) )
     => ( Tree = Tree2 ) ) )).

% tree.expand
thf(fact_182_eqfelem__imp__iff,axiom,(
    ! [A: $tType,X4: A,Y: A,A3: ( fset @ A )] :
      ( ( X4 = Y )
     => ( ( fmember @ A @ X4 @ A3 )
        = ( fmember @ A @ Y @ A3 ) ) ) )).

% eqfelem_imp_iff
thf(fact_183_if__split__fmem2,axiom,(
    ! [A: $tType,A2: A,Q: $o,X4: ( fset @ A ),Y: ( fset @ A )] :
      ( ( fmember @ A @ A2 @ ( if @ ( fset @ A ) @ Q @ X4 @ Y ) )
      = ( ( Q
         => ( fmember @ A @ A2 @ X4 ) )
        & ( ~ ( Q )
         => ( fmember @ A @ A2 @ Y ) ) ) ) )).

% if_split_fmem2
thf(fact_184_if__split__fmem1,axiom,(
    ! [A: $tType,Q: $o,X4: A,Y: A,B3: ( fset @ A )] :
      ( ( fmember @ A @ ( if @ A @ Q @ X4 @ Y ) @ B3 )
      = ( ( Q
         => ( fmember @ A @ X4 @ B3 ) )
        & ( ~ ( Q )
         => ( fmember @ A @ Y @ B3 ) ) ) ) )).

% if_split_fmem1
thf(fact_185_eqfset__imp__iff,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),X4: A] :
      ( ( A3 = B2 )
     => ( ( fmember @ A @ X4 @ A3 )
        = ( fmember @ A @ X4 @ B2 ) ) ) )).

% eqfset_imp_iff
thf(fact_186_eq__fmem__trans,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( fset @ A )] :
      ( ( A2 = B3 )
     => ( ( fmember @ A @ B3 @ A3 )
       => ( fmember @ A @ A2 @ A3 ) ) ) )).

% eq_fmem_trans
thf(fact_187_fset__choice,axiom,(
    ! [B: $tType,A: $tType,A3: ( fset @ A ),P3: ( A > B > $o )] :
      ( ! [X2: A] :
          ( ( fmember @ A @ X2 @ A3 )
         => ? [X12: B] :
              ( P3 @ X2 @ X12 ) )
     => ? [F3: ( A > B )] :
        ! [X5: A] :
          ( ( fmember @ A @ X5 @ A3 )
         => ( P3 @ X5 @ ( F3 @ X5 ) ) ) ) )).

% fset_choice
thf(fact_188_fequalityCE,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),C2: A] :
      ( ( A3 = B2 )
     => ( ( ( fmember @ A @ C2 @ A3 )
         => ~ ( fmember @ A @ C2 @ B2 ) )
       => ~ ( ~ ( fmember @ A @ C2 @ A3 )
           => ( fmember @ A @ C2 @ B2 ) ) ) ) )).

% fequalityCE
thf(fact_189_fset__eqI,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ! [X2: A] :
          ( ( fmember @ A @ X2 @ A3 )
          = ( fmember @ A @ X2 @ B2 ) )
     => ( A3 = B2 ) ) )).

% fset_eqI
thf(fact_190_fset__mp,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),X4: A] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
     => ( ( fmember @ A @ X4 @ A3 )
       => ( fmember @ A @ X4 @ B2 ) ) ) )).

% fset_mp
thf(fact_191_fin__mono,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),X4: A] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
     => ( ( fmember @ A @ X4 @ A3 )
       => ( fmember @ A @ X4 @ B2 ) ) ) )).

% fin_mono
thf(fact_192_fsubsetD,axiom,(
    ! [A: $tType,A3: ( fset @ A ),B2: ( fset @ A ),C2: A] :
      ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
     => ( ( fmember @ A @ C2 @ A3 )
       => ( fmember @ A @ C2 @ B2 ) ) ) )).

% fsubsetD
thf(fact_193_fset__rev__mp,axiom,(
    ! [A: $tType,X4: A,A3: ( fset @ A ),B2: ( fset @ A )] :
      ( ( fmember @ A @ X4 @ A3 )
     => ( ( ord_less_eq @ ( fset @ A ) @ A3 @ B2 )
       => ( fmember @ A @ X4 @ B2 ) ) ) )).

% fset_rev_mp
thf(fact_194_mkTree_Osimps_I1_J,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) )
      = ( product_Pair @ state @ rule @ S @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) ) )).

% mkTree.simps(1)
thf(fact_195_mkTree_Octr,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S )
      = ( abstra388494275e_Node @ ( product_prod @ state @ rule ) @ ( product_Pair @ state @ rule @ S @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) ) )).

% mkTree.ctr
thf(fact_196_subset__emptyI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X2: A] :
          ~ ( member @ A @ X2 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_197_Konig,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ~ ( abstra668420080finite @ A @ T2 )
     => ( abstra313004635_ipath @ A @ T2 @ ( abstra1918223989_konig @ A @ T2 ) ) ) )).

% Konig
thf(fact_198_tree_Oinject,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) ),Y1: A,Y22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( ( abstra388494275e_Node @ A @ X13 @ X22 )
        = ( abstra388494275e_Node @ A @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% tree.inject
thf(fact_199_predicate1I,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P3 @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( A > $o ) @ P3 @ Q ) ) )).

% predicate1I
thf(fact_200_tree_Ocollapse,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) )
      = Tree ) )).

% tree.collapse
thf(fact_201_rev__predicate1D,axiom,(
    ! [A: $tType,P3: ( A > $o ),X4: A,Q: ( A > $o )] :
      ( ( P3 @ X4 )
     => ( ( ord_less_eq @ ( A > $o ) @ P3 @ Q )
       => ( Q @ X4 ) ) ) )).

% rev_predicate1D
thf(fact_202_predicate1D,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o ),X4: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P3 @ Q )
     => ( ( P3 @ X4 )
       => ( Q @ X4 ) ) ) )).

% predicate1D
thf(fact_203_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R3: ( set @ ( product_prod @ A @ B ) ),S5: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R3 )
     => ( ( S5 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S5 ) @ R3 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_204_tree_Oexhaust,axiom,(
    ! [A: $tType,Y: ( abstra2103299360e_tree @ A )] :
      ~ ( ! [X1: A,X23: ( fset @ ( abstra2103299360e_tree @ A ) )] :
            ( Y
           != ( abstra388494275e_Node @ A @ X1 @ X23 ) ) ) )).

% tree.exhaust
thf(fact_205_tree_Osel_I1_J,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra573067619e_root @ A @ ( abstra388494275e_Node @ A @ X13 @ X22 ) )
      = X13 ) )).

% tree.sel(1)
thf(fact_206_tree_Osel_I2_J,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra1749095923e_cont @ A @ ( abstra388494275e_Node @ A @ X13 @ X22 ) )
      = X22 ) )).

% tree.sel(2)
thf(fact_207_szip_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,S1: ( stream @ A ),S22: ( stream @ B )] :
      ( ( shd @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S1 @ S22 ) )
      = ( product_Pair @ A @ B @ ( shd @ A @ S1 ) @ ( shd @ B @ S22 ) ) ) )).

% szip.simps(1)
thf(fact_208_tree_Oexhaust__sel,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( Tree
      = ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) ) ) )).

% tree.exhaust_sel
thf(fact_209_RuleSystem__Defs_OmkTree_Osimps_I1_J,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra573067619e_root @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) )
      = ( product_Pair @ State @ Rule @ S @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) ) ) )).

% RuleSystem_Defs.mkTree.simps(1)
thf(fact_210_RuleSystem__Defs_OmkTree_Ocode,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1225283448mkTree @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs3: ( stream @ Rule ),S4: State] :
            ( abstra388494275e_Node @ ( product_prod @ State @ Rule ) @ ( product_Pair @ State @ Rule @ S4 @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs3 @ S4 ) ) ) @ ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff2 @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs3 @ S4 ) ) ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff2 @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs3 @ S4 ) ) @ S4 ) ) ) ) ) )).

% RuleSystem_Defs.mkTree.code
thf(fact_211_Collect__restrict,axiom,(
    ! [A: $tType,X6: ( set @ A ),P3: ( A > $o )] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ X6 )
            & ( P3 @ X3 ) ) )
      @ X6 ) )).

% Collect_restrict
thf(fact_212_prop__restrict,axiom,(
    ! [A: $tType,X4: A,Z3: ( set @ A ),X6: ( set @ A ),P3: ( A > $o )] :
      ( ( member @ A @ X4 @ Z3 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z3
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ X6 )
                & ( P3 @ X3 ) ) ) )
       => ( P3 @ X4 ) ) ) )).

% prop_restrict
thf(fact_213_konig_Osimps_I1_J,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ( shd @ A @ ( abstra1918223989_konig @ A @ T2 ) )
      = ( abstra573067619e_root @ A @ T2 ) ) )).

% konig.simps(1)
thf(fact_214_mkTree__unfold,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S )
      = ( case_stream @ rule @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )
        @ ^ [R2: rule,S8: ( stream @ rule )] :
            ( abstra388494275e_Node @ ( product_prod @ state @ rule ) @ ( product_Pair @ state @ rule @ S @ R2 ) @ ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ S8 ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ R2 @ S ) ) )
        @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) )).

% mkTree_unfold
thf(fact_215_RuleSystem__Defs_OmkTree__unfold,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1225283448mkTree @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs3: ( stream @ Rule ),S4: State] :
            ( case_stream @ Rule @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )
            @ ^ [R2: Rule,S8: ( stream @ Rule )] :
                ( abstra388494275e_Node @ ( product_prod @ State @ Rule ) @ ( product_Pair @ State @ Rule @ S4 @ R2 ) @ ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff2 @ S8 ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff2 @ R2 @ S4 ) ) )
            @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs3 @ S4 ) ) ) ) )).

% RuleSystem_Defs.mkTree_unfold
thf(fact_216_stream_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H: ( B > C ),F: ( A > ( stream @ A ) > B ),Stream: ( stream @ A )] :
      ( ( H @ ( case_stream @ A @ B @ F @ Stream ) )
      = ( case_stream @ A @ C
        @ ^ [X14: A,X24: ( stream @ A )] :
            ( H @ ( F @ X14 @ X24 ) )
        @ Stream ) ) )).

% stream.case_distrib
thf(fact_217_shd__def,axiom,(
    ! [A: $tType] :
      ( ( shd @ A )
      = ( case_stream @ A @ A
        @ ^ [X14: A,X24: ( stream @ A )] : X14 ) ) )).

% shd_def
thf(fact_218_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( case_stream @ A @ B )
      = ( ^ [F2: ( A > ( stream @ A ) > B ),Stream5: ( stream @ A )] :
            ( F2 @ ( shd @ A @ Stream5 ) @ ( stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_219_pred__subset__eq,axiom,(
    ! [A: $tType,R3: ( set @ A ),S3: ( set @ A )] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X3: A] :
            ( member @ A @ X3 @ R3 )
        @ ^ [X3: A] :
            ( member @ A @ X3 @ S3 ) )
      = ( ord_less_eq @ ( set @ A ) @ R3 @ S3 ) ) )).

% pred_subset_eq
thf(fact_220_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B3: B,A7: A,B7: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B3 )
        = ( product_Pair @ A @ B @ A7 @ B7 ) )
      = ( ( A2 = A7 )
        & ( B3 = B7 ) ) ) )).

% old.prod.inject
thf(fact_221_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X13: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X13 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_222_stl__def,axiom,(
    ! [A: $tType] :
      ( ( stl @ A )
      = ( case_stream @ A @ ( stream @ A )
        @ ^ [X14: A,X24: ( stream @ A )] : X24 ) ) )).

% stl_def
thf(fact_223_subrelI,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ! [X2: A,Y2: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) )).

% subrelI
thf(fact_224_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P4: ( product_prod @ A @ B )] :
    ? [X2: A,Y2: B] :
      ( P4
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) )).

% surj_pair
thf(fact_225_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P3: ( ( product_prod @ A @ B ) > $o ),P4: ( product_prod @ A @ B )] :
      ( ! [A5: A,B4: B] :
          ( P3 @ ( product_Pair @ A @ B @ A5 @ B4 ) )
     => ( P3 @ P4 ) ) )).

% prod_cases
thf(fact_226_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B3: B,A7: A,B7: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B3 )
        = ( product_Pair @ A @ B @ A7 @ B7 ) )
     => ~ ( ( A2 = A7 )
         => ( B3 != B7 ) ) ) )).

% Pair_inject
thf(fact_227_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B4: B,C4: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B4 @ C4 ) ) ) ) )).

% prod_cases3
thf(fact_228_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A5: A,B4: B,C4: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C4 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_229_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A5: A,B4: B,C4: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_230_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A5: A,B4: B,C4: C,D2: D,E2: E,F3: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D2 @ ( product_Pair @ E @ F4 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_231_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,G3: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) ) )] :
      ~ ( ! [A5: A,B4: B,C4: C,D2: D,E2: E,F3: F4,G4: G3] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F4 @ G3 ) @ E2 @ ( product_Pair @ F4 @ G3 @ F3 @ G4 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_232_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X4: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B4: B,C4: C] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B4 @ C4 ) ) )
     => ( P3 @ X4 ) ) )).

% prod_induct3
thf(fact_233_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A5: A,B4: B,C4: C,D2: D] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C4 @ D2 ) ) ) )
     => ( P3 @ X4 ) ) )).

% prod_induct4
thf(fact_234_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A5: A,B4: B,C4: C,D2: D,E2: E] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P3 @ X4 ) ) )).

% prod_induct5
thf(fact_235_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A5: A,B4: B,C4: C,D2: D,E2: E,F3: F4] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D2 @ ( product_Pair @ E @ F4 @ E2 @ F3 ) ) ) ) ) )
     => ( P3 @ X4 ) ) )).

% prod_induct6
thf(fact_236_prod__induct7,axiom,(
    ! [G3: $tType,F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) ) ) > $o ),X4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) ) )] :
      ( ! [A5: A,B4: B,C4: C,D2: D,E2: E,F3: F4,G4: G3] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G3 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F4 @ G3 ) @ E2 @ ( product_Pair @ F4 @ G3 @ F3 @ G4 ) ) ) ) ) ) )
     => ( P3 @ X4 ) ) )).

% prod_induct7
thf(fact_237_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B4: B] :
            ( Y
           != ( product_Pair @ A @ B @ A5 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_238_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P3: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B4: B] :
          ( P3 @ ( product_Pair @ A @ B @ A5 @ B4 ) )
     => ( P3 @ Prod ) ) )).

% old.prod.inducts
thf(fact_239_bot__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X3: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% bot_empty_eq2
thf(fact_240_pred__subset__eq2,axiom,(
    ! [B: $tType,A: $tType,R3: ( set @ ( product_prod @ A @ B ) ),S3: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X3: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R3 )
        @ ^ [X3: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ S3 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S3 ) ) )).

% pred_subset_eq2
thf(fact_241_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R3: ( set @ ( product_prod @ A @ B ) ),S3: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X3: A,Y4: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R3 ) )
        = ( ^ [X3: A,Y4: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ S3 ) ) )
      = ( R3 = S3 ) ) )).

% pred_equals_eq2
thf(fact_242_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X3: A] :
            ( member @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_243_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B3 ) )
      = ( F1 @ A2 @ B3 ) ) )).

% old.prod.rec
thf(fact_244_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( collect @ A @ P3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P3
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_245_predicate2I,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > B > $o ),Q: ( A > B > $o )] :
      ( ! [X2: A,Y2: B] :
          ( ( P3 @ X2 @ Y2 )
         => ( Q @ X2 @ Y2 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P3 @ Q ) ) )).

% predicate2I
thf(fact_246_rev__predicate2D,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > B > $o ),X4: A,Y: B,Q: ( A > B > $o )] :
      ( ( P3 @ X4 @ Y )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P3 @ Q )
       => ( Q @ X4 @ Y ) ) ) )).

% rev_predicate2D
thf(fact_247_predicate2D,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > B > $o ),Q: ( A > B > $o ),X4: A,Y: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P3 @ Q )
     => ( ( P3 @ X4 @ Y )
       => ( Q @ X4 @ Y ) ) ) )).

% predicate2D
thf(fact_248_bot2E,axiom,(
    ! [A: $tType,B: $tType,X4: A,Y: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X4 @ Y ) )).

% bot2E
thf(fact_249_konig_Osimps_I2_J,axiom,(
    ! [A: $tType,T2: ( abstra2103299360e_tree @ A )] :
      ( ( stl @ A @ ( abstra1918223989_konig @ A @ T2 ) )
      = ( abstra1918223989_konig @ A
        @ @+[T8: ( abstra2103299360e_tree @ A )] :
            ( ( fmember @ ( abstra2103299360e_tree @ A ) @ T8 @ ( abstra1749095923e_cont @ A @ T2 ) )
            & ~ ( abstra668420080finite @ A @ T8 ) ) ) ) )).

% konig.simps(2)
thf(fact_250_less__by__empty,axiom,(
    ! [A: $tType,A3: ( set @ ( product_prod @ A @ A ) ),B2: ( set @ ( product_prod @ A @ A ) )] :
      ( ( A3
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A3 @ B2 ) ) )).

% less_by_empty
thf(fact_251_some__sym__eq__trivial,axiom,(
    ! [A: $tType,X4: A] :
      ( ( ^ [P: ( A > $o )] :
          @+[X: A] :
            ( P @ X )
        @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ X4 ) )
      = X4 ) )).

% some_sym_eq_trivial
thf(fact_252_some__eq__trivial,axiom,(
    ! [A: $tType,X4: A] :
      ( ( @+[Y4: A] : ( Y4 = X4 ) )
      = X4 ) )).

% some_eq_trivial
thf(fact_253_some__equality,axiom,(
    ! [A: $tType,P3: ( A > $o ),A2: A] :
      ( ( P3 @ A2 )
     => ( ! [X2: A] :
            ( ( P3 @ X2 )
           => ( X2 = A2 ) )
       => ( ( ^ [P: ( A > $o )] :
              @+[X: A] :
                ( P @ X )
            @ P3 )
          = A2 ) ) ) )).

% some_equality
thf(fact_254_ex__has__least__nat,axiom,(
    ! [A: $tType,P3: ( A > $o ),K: A,M: ( A > nat )] :
      ( ( P3 @ K )
     => ? [X2: A] :
          ( ( P3 @ X2 )
          & ! [Y5: A] :
              ( ( P3 @ Y5 )
             => ( ord_less_eq @ nat @ ( M @ X2 ) @ ( M @ Y5 ) ) ) ) ) )).

% ex_has_least_nat
thf(fact_255_someI2,axiom,(
    ! [A: $tType,P3: ( A > $o ),A2: A,Q: ( A > $o )] :
      ( ( P3 @ A2 )
     => ( ! [X2: A] :
            ( ( P3 @ X2 )
           => ( Q @ X2 ) )
       => ( Q
          @ ( ^ [P: ( A > $o )] :
              @+[X: A] :
                ( P @ X )
            @ P3 ) ) ) ) )).

% someI2

%----Type constructors (39)
thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_FSet_Ofset___Finite__Set_Ofinite_1,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_2,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_3,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite_4,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_bot @ A9 @ ( type2 @ A9 ) )
     => ( order_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Countable_Ocountable,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( countable @ A9 @ ( type2 @ A9 ) ) )
     => ( countable @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_5,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Countable_Ocountable_6,axiom,
    ( countable @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_7,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_8,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_9,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_10,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_11,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Countable_Ocountable_12,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( countable @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_13,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_14,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_15,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_16,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_17,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Countable_Ocountable_18,axiom,
    ( countable @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_19,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_20,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_21,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_22,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_23,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_FSet_Ofset___Orderings_Oorder__bot_24,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Countable_Ocountable_25,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( countable @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Opreorder_26,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Oorder_27,axiom,(
    ! [A8: $tType] :
      ( order @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Oord_28,axiom,(
    ! [A8: $tType] :
      ( ord @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Obot_29,axiom,(
    ! [A8: $tType] :
      ( bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_Product__Type_Oprod___Countable_Ocountable_30,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( countable @ A8 @ ( type2 @ A8 ) )
        & ( countable @ A9 @ ( type2 @ A9 ) ) )
     => ( countable @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P3: $o] :
      ( ( P3 = $true )
      | ( P3 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X4: A,Y: A] :
      ( ( if @ A @ $false @ X4 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X4: A,Y: A] :
      ( ( if @ A @ $true @ X4 @ Y )
      = X4 ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ! [S9: state,N5: nat] :
      ( ( member @ state @ S9 @ s )
     => ( ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( sdrop @ rule @ N5 @ rsa ) @ S9 ) @ ( sdrop @ ( product_prod @ state @ rule ) @ ma @ stepsa ) )
       => thesis ) ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
