%------------------------------------------------------------------------------
% File     : COM160^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Abstract completeness 317
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BPT14] Blanchette et al. (2014), Abstract Completeness
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : abstract_completeness__317.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  365 (   1 unit;  65 type;   0 defn)
%            Number of atoms       : 5176 ( 205 equality;2881 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 5149 (  60   ~;   6   |;  68   &;4631   @)
%                                         (   0 <=>; 384  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  327 ( 327   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   69 (  65   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1224 (   2 sgn;1058   !;  36   ?;  65   ^)
%                                         (1224   :;  65  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:54:49.610
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree,type,(
    abstra2103299360e_tree: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_FSet_Ofset,type,(
    fset: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_tf_state,type,(
    state: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_rule,type,(
    rule: $tType )).

%----Explicit typings (56)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable_Ocountable,type,(
    countable: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem,type,(
    abstra1326562878System: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( set @ State ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem_OminWait,type,(
    abstra1332369113inWait: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > nat ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem_Oper,type,(
    abstra2096684367le_per: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( set @ State ) > Rule > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem_Opos,type,(
    abstra2097340358le_pos: 
      !>[A: $tType] :
        ( ( stream @ A ) > A > nat ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OSaturated,type,(
    abstra1209608345urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oenabled,type,(
    abstra1874422341nabled: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Oepath,type,(
    abstra523868654_epath: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofair,type,(
    abstra928354080m_fair: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Ofenum,type,(
    abstra1774373515_fenum: 
      !>[Rule: $tType] :
        ( ( stream @ Rule ) > ( stream @ Rule ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OmkTree,type,(
    abstra1225283448mkTree: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_OpickEff,type,(
    abstra1276541928ickEff: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > State > ( fset @ State ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Osaturated,type,(
    abstra726722745urated: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > Rule > ( stream @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Otrim,type,(
    abstra1259602206m_trim: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > State > ( stream @ Rule ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_ORuleSystem__Defs_Owf,type,(
    abstra1874736267tem_wf: 
      !>[Rule: $tType,State: $tType] :
        ( ( Rule > State > ( fset @ State ) > $o ) > ( stream @ Rule ) > ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Oipath,type,(
    abstra313004635_ipath: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_ONode,type,(
    abstra388494275e_Node: 
      !>[A: $tType] :
        ( A > ( fset @ ( abstra2103299360e_tree @ A ) ) > ( abstra2103299360e_tree @ A ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Ocont,type,(
    abstra1749095923e_cont: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > ( fset @ ( abstra2103299360e_tree @ A ) ) ) )).

thf(sy_c_Abstract__Completeness__Mirabelle__wdxnrclvrt_Otree_Oroot,type,(
    abstra573067619e_root: 
      !>[A: $tType] :
        ( ( abstra2103299360e_tree @ A ) > A ) )).

thf(sy_c_Countable__Set_Ocountable,type,(
    countable_countable: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_FSet_Ofimage,type,(
    fimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( fset @ A ) > ( fset @ B ) ) )).

thf(sy_c_FSet_Ofmember,type,(
    fmember: 
      !>[A: $tType] :
        ( A > ( fset @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_OLeast,type,(
    ord_Least: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Osnd,type,(
    product_snd: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > B ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream_Osdrop,type,(
    sdrop: 
      !>[A: $tType] :
        ( nat > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osdrop__while,type,(
    sdrop_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Ocase__stream,type,(
    case_stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Stream_Ostream_Oshd,type,(
    shd: 
      !>[A: $tType] :
        ( ( stream @ A ) > A ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream_Ostream_Ostl,type,(
    stl: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_S,type,(
    s: ( set @ state ) )).

thf(sy_v_eff,type,(
    eff: rule > state > ( fset @ state ) > $o )).

thf(sy_v_r,type,(
    r: rule )).

thf(sy_v_rules,type,(
    rules: ( stream @ rule ) )).

thf(sy_v_steps,type,(
    steps: ( stream @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_stepsa____,type,(
    stepsa: ( stream @ ( product_prod @ state @ rule ) ) )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

%----Relevant facts (256)
thf(fact_0_calculation_I1_J,axiom,
    ( member @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) ) @ s )).

% calculation(1)
thf(fact_1_calculation_I3_J,axiom,(
    ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) )
 != r )).

% calculation(3)
thf(fact_2_e,axiom,
    ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ steps )
    & ( member @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ steps ) ) @ s ) )).

% e
thf(fact_3_calculation_I2_J,axiom,
    ( abstra1874422341nabled @ rule @ state @ eff @ r @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) ) )).

% calculation(2)
thf(fact_4_enabled__def,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
      = ( ^ [P: ( ( fset @ state ) > $o )] :
          ? [X: ( fset @ state )] :
            ( P @ X )
        @ ( eff @ R @ S ) ) ) )).

% enabled_def
thf(fact_5_epath_Ocases,axiom,(
    ! [A2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ A2 )
     => ~ ( ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( sset @ rule @ rules ) )
         => ! [Sl: ( fset @ state )] :
              ( ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ A2 ) ) ) @ Sl )
             => ( ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ A2 ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ A2 ) ) @ Sl )
               => ~ ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ A2 ) ) ) ) ) ) )).

% epath.cases
thf(fact_6_epath_Ocoinduct,axiom,(
    ! [X2: ( ( stream @ ( product_prod @ state @ rule ) ) > $o ),X3: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( X2 @ X3 )
     => ( ! [X4: ( stream @ ( product_prod @ state @ rule ) )] :
            ( ( X2 @ X4 )
           => ? [Steps: ( stream @ ( product_prod @ state @ rule ) ),Sl2: ( fset @ state )] :
                ( ( X4 = Steps )
                & ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ ( sset @ rule @ rules ) )
                & ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) ) ) @ Sl2 )
                & ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps ) ) @ Sl2 )
                & ( ( X2 @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) )
                  | ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps ) ) ) ) )
       => ( abstra523868654_epath @ rule @ state @ eff @ rules @ X3 ) ) ) )).

% epath.coinduct
thf(fact_7_epath_Ointros,axiom,(
    ! [Steps2: ( stream @ ( product_prod @ state @ rule ) ),Sl3: ( fset @ state )] :
      ( ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps2 ) ) @ ( sset @ rule @ rules ) )
     => ( ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps2 ) ) ) @ Sl3 )
       => ( ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps2 ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps2 ) ) @ Sl3 )
         => ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps2 ) )
           => ( abstra523868654_epath @ rule @ state @ eff @ rules @ Steps2 ) ) ) ) ) )).

% epath.intros
thf(fact_8_epath_Osimps,axiom,(
    ! [A2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ A2 )
      = ( ? [Steps3: ( stream @ ( product_prod @ state @ rule ) ),Sl4: ( fset @ state )] :
            ( ( A2 = Steps3 )
            & ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps3 ) ) @ ( sset @ rule @ rules ) )
            & ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ Steps3 ) ) ) @ Sl4 )
            & ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps3 ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ Steps3 ) ) @ Sl4 )
            & ( abstra523868654_epath @ rule @ state @ eff @ rules @ ( stl @ ( product_prod @ state @ rule ) @ Steps3 ) ) ) ) ) )).

% epath.simps
thf(fact_9_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( ( ( shd @ A @ Stream )
          = ( shd @ A @ Stream2 ) )
        & ( ( stl @ A @ Stream )
          = ( stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_10_stream_Ocoinduct,axiom,(
    ! [A: $tType,R2: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R2 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R2 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( R2 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_11_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R2: ( ( stream @ A ) > ( stream @ A ) > $o ),Stream: ( stream @ A ),Stream2: ( stream @ A )] :
      ( ( R2 @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream @ A ),Stream4: ( stream @ A )] :
            ( ( R2 @ Stream3 @ Stream4 )
           => ( ( ( shd @ A @ Stream3 )
                = ( shd @ A @ Stream4 ) )
              & ( ( R2 @ ( stl @ A @ Stream3 ) @ ( stl @ A @ Stream4 ) )
                | ( ( stl @ A @ Stream3 )
                  = ( stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_12_RuleSystem__axioms,axiom,
    ( abstra1326562878System @ rule @ state @ eff @ rules @ s )).

% RuleSystem_axioms
thf(fact_13_prod__eqI,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B ),Q: ( product_prod @ A @ B )] :
      ( ( ( product_fst @ A @ B @ P2 )
        = ( product_fst @ A @ B @ Q ) )
     => ( ( ( product_snd @ A @ B @ P2 )
          = ( product_snd @ A @ B @ Q ) )
       => ( P2 = Q ) ) ) )).

% prod_eqI
thf(fact_14_p,axiom,
    ( abstra2096684367le_per @ rule @ state @ eff @ rules @ s @ r )).

% p
thf(fact_15_enabled__R,axiom,(
    ! [S: state] :
      ( ( member @ state @ S @ s )
     => ? [X4: rule] :
          ( ( member @ rule @ X4 @ ( sset @ rule @ rules ) )
          & ? [X1: ( fset @ state )] :
              ( eff @ X4 @ S @ X1 ) ) ) )).

% enabled_R
thf(fact_16_calculation_I4_J,axiom,
    ( member @ rule @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) ) @ ( sset @ rule @ rules ) )).

% calculation(4)
thf(fact_17_eff__S,axiom,(
    ! [S: state,R: rule,Sl3: ( fset @ state ),S2: state] :
      ( ( member @ state @ S @ s )
     => ( ( member @ rule @ R @ ( sset @ rule @ rules ) )
       => ( ( eff @ R @ S @ Sl3 )
         => ( ( fmember @ state @ S2 @ Sl3 )
           => ( member @ state @ S2 @ s ) ) ) ) ) )).

% eff_S
thf(fact_18_sset__fenum,axiom,
    ( ( sset @ rule @ ( abstra1774373515_fenum @ rule @ rules ) )
    = ( sset @ rule @ rules ) )).

% sset_fenum
thf(fact_19_pickEff,axiom,(
    ! [R: rule,S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
     => ( eff @ R @ S @ ( abstra1276541928ickEff @ rule @ state @ eff @ R @ S ) ) ) )).

% pickEff
thf(fact_20_RuleSystem_Oenabled__R,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ? [X4: Rule] :
            ( ( member @ Rule @ X4 @ ( sset @ Rule @ Rules ) )
            & ? [X1: ( fset @ State )] :
                ( Eff @ X4 @ S @ X1 ) ) ) ) )).

% RuleSystem.enabled_R
thf(fact_21_RuleSystem__Defs_Oenabled__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1874422341nabled @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),R3: Rule,S4: State] :
            ( ^ [P: ( ( fset @ State ) > $o )] :
              ? [X: ( fset @ State )] :
                ( P @ X )
            @ ( Eff2 @ R3 @ S4 ) ) ) ) )).

% RuleSystem_Defs.enabled_def
thf(fact_22_RuleSystem_Ointro,axiom,(
    ! [Rule: $tType,State: $tType,S3: ( set @ State ),Rules: ( stream @ Rule ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ! [S5: State] :
          ( ( member @ State @ S5 @ S3 )
         => ! [R4: Rule] :
              ( ( member @ Rule @ R4 @ ( sset @ Rule @ Rules ) )
             => ! [Sl: ( fset @ State )] :
                  ( ( Eff @ R4 @ S5 @ Sl )
                 => ! [S6: State] :
                      ( ( fmember @ State @ S6 @ Sl )
                     => ( member @ State @ S6 @ S3 ) ) ) ) )
     => ( ! [S5: State] :
            ( ( member @ State @ S5 @ S3 )
           => ? [X5: Rule] :
                ( ( member @ Rule @ X5 @ ( sset @ Rule @ Rules ) )
                & ? [X12: ( fset @ State )] :
                    ( Eff @ X5 @ S5 @ X12 ) ) )
       => ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 ) ) ) )).

% RuleSystem.intro
thf(fact_23_RuleSystem_Oeff__S,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,R: Rule,Sl3: ( fset @ State ),S2: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( member @ Rule @ R @ ( sset @ Rule @ Rules ) )
         => ( ( Eff @ R @ S @ Sl3 )
           => ( ( fmember @ State @ S2 @ Sl3 )
             => ( member @ State @ S2 @ S3 ) ) ) ) ) ) )).

% RuleSystem.eff_S
thf(fact_24_RuleSystem__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1326562878System @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),S7: ( set @ State )] :
            ( ! [S4: State] :
                ( ( member @ State @ S4 @ S7 )
               => ! [R3: Rule] :
                    ( ( member @ Rule @ R3 @ ( sset @ Rule @ Rules2 ) )
                   => ! [Sl4: ( fset @ State )] :
                        ( ( Eff2 @ R3 @ S4 @ Sl4 )
                       => ! [S8: State] :
                            ( ( fmember @ State @ S8 @ Sl4 )
                           => ( member @ State @ S8 @ S7 ) ) ) ) )
            & ! [S4: State] :
                ( ( member @ State @ S4 @ S7 )
               => ? [X6: Rule] :
                    ( ( member @ Rule @ X6 @ ( sset @ Rule @ Rules2 ) )
                    & ( ^ [P: ( ( fset @ State ) > $o )] :
                        ? [X: ( fset @ State )] :
                          ( P @ X )
                      @ ( Eff2 @ X6 @ S4 ) ) ) ) ) ) ) )).

% RuleSystem_def
thf(fact_25_stl__sset,axiom,(
    ! [A: $tType,X3: A,A2: ( stream @ A )] :
      ( ( member @ A @ X3 @ ( sset @ A @ ( stl @ A @ A2 ) ) )
     => ( member @ A @ X3 @ ( sset @ A @ A2 ) ) ) )).

% stl_sset
thf(fact_26_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream @ A )] :
      ( member @ A @ ( shd @ A @ A2 ) @ ( sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_27_sset__induct,axiom,(
    ! [A: $tType,Y: A,S: ( stream @ A ),P3: ( A > ( stream @ A ) > $o )] :
      ( ( member @ A @ Y @ ( sset @ A @ S ) )
     => ( ! [S5: ( stream @ A )] :
            ( P3 @ ( shd @ A @ S5 ) @ S5 )
       => ( ! [S5: ( stream @ A ),Y2: A] :
              ( ( member @ A @ Y2 @ ( sset @ A @ ( stl @ A @ S5 ) ) )
             => ( ( P3 @ Y2 @ ( stl @ A @ S5 ) )
               => ( P3 @ Y2 @ S5 ) ) )
         => ( P3 @ Y @ S ) ) ) ) )).

% sset_induct
thf(fact_28_RuleSystem__Defs_Oepath_Ocoinduct,axiom,(
    ! [Rule: $tType,State: $tType,X2: ( ( stream @ ( product_prod @ State @ Rule ) ) > $o ),X3: ( stream @ ( product_prod @ State @ Rule ) ),Rules: ( stream @ Rule ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ( X2 @ X3 )
     => ( ! [X4: ( stream @ ( product_prod @ State @ Rule ) )] :
            ( ( X2 @ X4 )
           => ? [Steps: ( stream @ ( product_prod @ State @ Rule ) ),Sl2: ( fset @ State )] :
                ( ( X4 = Steps )
                & ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps ) ) @ ( sset @ Rule @ Rules ) )
                & ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ Steps ) ) ) @ Sl2 )
                & ( Eff @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps ) ) @ Sl2 )
                & ( ( X2 @ ( stl @ ( product_prod @ State @ Rule ) @ Steps ) )
                  | ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ ( stl @ ( product_prod @ State @ Rule ) @ Steps ) ) ) ) )
       => ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ X3 ) ) ) )).

% RuleSystem_Defs.epath.coinduct
thf(fact_29_RuleSystem__Defs_Oepath_Ointros,axiom,(
    ! [Rule: $tType,State: $tType,Steps2: ( stream @ ( product_prod @ State @ Rule ) ),Rules: ( stream @ Rule ),Sl3: ( fset @ State ),Eff: ( Rule > State > ( fset @ State ) > $o )] :
      ( ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps2 ) ) @ ( sset @ Rule @ Rules ) )
     => ( ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ Steps2 ) ) ) @ Sl3 )
       => ( ( Eff @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps2 ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps2 ) ) @ Sl3 )
         => ( ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ ( stl @ ( product_prod @ State @ Rule ) @ Steps2 ) )
           => ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ Steps2 ) ) ) ) ) )).

% RuleSystem_Defs.epath.intros
thf(fact_30_RuleSystem__Defs_Oepath_Osimps,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra523868654_epath @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),A3: ( stream @ ( product_prod @ State @ Rule ) )] :
          ? [Steps3: ( stream @ ( product_prod @ State @ Rule ) ),Sl4: ( fset @ State )] :
            ( ( A3 = Steps3 )
            & ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps3 ) ) @ ( sset @ Rule @ Rules2 ) )
            & ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ Steps3 ) ) ) @ Sl4 )
            & ( Eff2 @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps3 ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ Steps3 ) ) @ Sl4 )
            & ( abstra523868654_epath @ Rule @ State @ Eff2 @ Rules2 @ ( stl @ ( product_prod @ State @ Rule ) @ Steps3 ) ) ) ) ) )).

% RuleSystem_Defs.epath.simps
thf(fact_31_RuleSystem__Defs_Oepath_Ocases,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),A2: ( stream @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ A2 )
     => ~ ( ( member @ Rule @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( sset @ Rule @ Rules ) )
         => ! [Sl: ( fset @ State )] :
              ( ( fmember @ State @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ ( stl @ ( product_prod @ State @ Rule ) @ A2 ) ) ) @ Sl )
             => ( ( Eff @ ( product_snd @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ A2 ) ) @ ( product_fst @ State @ Rule @ ( shd @ ( product_prod @ State @ Rule ) @ A2 ) ) @ Sl )
               => ~ ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ ( stl @ ( product_prod @ State @ Rule ) @ A2 ) ) ) ) ) ) )).

% RuleSystem_Defs.epath.cases
thf(fact_32_prod__eq__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [Y3: ( product_prod @ A @ B ),Z: ( product_prod @ A @ B )] : ( Y3 = Z ) )
      = ( ^ [S4: ( product_prod @ A @ B ),T: ( product_prod @ A @ B )] :
            ( ( ( product_fst @ A @ B @ S4 )
              = ( product_fst @ A @ B @ T ) )
            & ( ( product_snd @ A @ B @ S4 )
              = ( product_snd @ A @ B @ T ) ) ) ) ) )).

% prod_eq_iff
thf(fact_33_prod_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B ),Prod2: ( product_prod @ A @ B )] :
      ( ( ( ( product_fst @ A @ B @ Prod )
          = ( product_fst @ A @ B @ Prod2 ) )
        & ( ( product_snd @ A @ B @ Prod )
          = ( product_snd @ A @ B @ Prod2 ) ) )
     => ( Prod = Prod2 ) ) )).

% prod.expand
thf(fact_34_Saturated__def,axiom,(
    ! [Steps2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1209608345urated @ rule @ state @ eff @ rules @ Steps2 )
      = ( ! [X6: rule] :
            ( ( member @ rule @ X6 @ ( sset @ rule @ rules ) )
           => ( abstra726722745urated @ rule @ state @ eff @ X6 @ Steps2 ) ) ) ) )).

% Saturated_def
thf(fact_35_local_Oalw,axiom,
    ( ( abstra523868654_epath @ rule @ state @ eff @ rules @ stepsa )
    & ( member @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) ) @ s ) )).

% local.alw
thf(fact_36_NE__R,axiom,(
    ( sset @ rule @ rules )
 != ( bot_bot @ ( set @ rule ) ) )).

% NE_R
thf(fact_37_fair__stl,axiom,(
    ! [Rs: ( stream @ rule )] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( abstra928354080m_fair @ rule @ rules @ ( stl @ rule @ Rs ) ) ) )).

% fair_stl
thf(fact_38_exE__realizer_H,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > B > $o ),P2: ( product_prod @ B @ A )] :
      ( ( P3 @ ( product_snd @ B @ A @ P2 ) @ ( product_fst @ B @ A @ P2 ) )
     => ~ ( ! [X4: B,Y2: A] :
              ~ ( P3 @ Y2 @ X4 ) ) ) )).

% exE_realizer'
thf(fact_39_countable__R,axiom,
    ( countable_countable @ rule @ ( sset @ rule @ rules ) )).

% countable_R
thf(fact_40_trim__enabled,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) )).

% trim_enabled
thf(fact_41_trim__in__R,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( member @ rule @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ ( sset @ rule @ rules ) ) ) ) )).

% trim_in_R
thf(fact_42_wf__ipath__epath,axiom,(
    ! [T2: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ),Steps2: ( stream @ ( product_prod @ state @ rule ) )] :
      ( ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ T2 )
     => ( ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ T2 @ Steps2 )
       => ( abstra523868654_epath @ rule @ state @ eff @ rules @ Steps2 ) ) ) )).

% wf_ipath_epath
thf(fact_43_minWait__ex,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ? [N: nat] :
            ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N @ Rs ) ) @ S ) ) ) )).

% minWait_ex
thf(fact_44_trim__fair,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( abstra928354080m_fair @ rule @ rules @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) ) )).

% trim_fair
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P3: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P3 ) )
      = ( P3 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X6: A] :
            ( member @ A @ X6 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P3 @ X4 )
          = ( Q2 @ X4 ) )
     => ( ( collect @ A @ P3 )
        = ( collect @ A @ Q2 ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_sdrop__fair,axiom,(
    ! [Rs: ( stream @ rule ),M: nat] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( abstra928354080m_fair @ rule @ rules @ ( sdrop @ rule @ M @ Rs ) ) ) )).

% sdrop_fair
thf(fact_50_fair__fenum,axiom,
    ( abstra928354080m_fair @ rule @ rules @ ( abstra1774373515_fenum @ rule @ rules ) )).

% fair_fenum
thf(fact_51_RuleSystem__Defs_Osdrop__fair,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule ),Rs: ( stream @ Rule ),M: nat] :
      ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
     => ( abstra928354080m_fair @ Rule @ Rules @ ( sdrop @ Rule @ M @ Rs ) ) ) )).

% RuleSystem_Defs.sdrop_fair
thf(fact_52_RuleSystem__Defs_Ofair__fenum,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( abstra928354080m_fair @ Rule @ Rules @ ( abstra1774373515_fenum @ Rule @ Rules ) ) )).

% RuleSystem_Defs.fair_fenum
thf(fact_53_RuleSystem_Otrim__fair,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( abstra928354080m_fair @ Rule @ Rules @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) ) ) ) )).

% RuleSystem.trim_fair
thf(fact_54_RuleSystem__Defs_Owf__ipath__epath,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),T2: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ),Steps2: ( stream @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ T2 )
     => ( ( abstra313004635_ipath @ ( product_prod @ State @ Rule ) @ T2 @ Steps2 )
       => ( abstra523868654_epath @ Rule @ State @ Eff @ Rules @ Steps2 ) ) ) )).

% RuleSystem_Defs.wf_ipath_epath
thf(fact_55_RuleSystem__Defs_Ocountable__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( countable_countable @ Rule @ ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.countable_R
thf(fact_56_sdrop__stl,axiom,(
    ! [A: $tType,N2: nat,S: ( stream @ A )] :
      ( ( sdrop @ A @ N2 @ ( stl @ A @ S ) )
      = ( stl @ A @ ( sdrop @ A @ N2 @ S ) ) ) )).

% sdrop_stl
thf(fact_57_RuleSystem__Defs_ONE__R,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ Rules )
     != ( bot_bot @ ( set @ Rule ) ) ) )).

% RuleSystem_Defs.NE_R
thf(fact_58_RuleSystem__Defs_Ofair__stl,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule ),Rs: ( stream @ Rule )] :
      ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
     => ( abstra928354080m_fair @ Rule @ Rules @ ( stl @ Rule @ Rs ) ) ) )).

% RuleSystem_Defs.fair_stl
thf(fact_59_RuleSystem_OminWait__ex,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ? [N: nat] :
              ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( sdrop @ Rule @ N @ Rs ) ) @ S ) ) ) ) )).

% RuleSystem.minWait_ex
thf(fact_60_RuleSystem_Otrim__in__R,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( member @ Rule @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ ( sset @ Rule @ Rules ) ) ) ) ) )).

% RuleSystem.trim_in_R
thf(fact_61_RuleSystem_Otrim__enabled,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S ) ) ) ) )).

% RuleSystem.trim_enabled
thf(fact_62_RuleSystem__Defs_OSaturated__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1209608345urated @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rules2: ( stream @ Rule ),Steps3: ( stream @ ( product_prod @ State @ Rule ) )] :
          ! [X6: Rule] :
            ( ( member @ Rule @ X6 @ ( sset @ Rule @ Rules2 ) )
           => ( abstra726722745urated @ Rule @ State @ Eff2 @ X6 @ Steps3 ) ) ) ) )).

% RuleSystem_Defs.Saturated_def
thf(fact_63_RuleSystem__Defs_OpickEff,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),R: Rule,S: State] :
      ( ( abstra1874422341nabled @ Rule @ State @ Eff @ R @ S )
     => ( Eff @ R @ S @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ R @ S ) ) ) )).

% RuleSystem_Defs.pickEff
thf(fact_64_RuleSystem__Defs_Osset__fenum,axiom,(
    ! [Rule: $tType,Rules: ( stream @ Rule )] :
      ( ( sset @ Rule @ ( abstra1774373515_fenum @ Rule @ Rules ) )
      = ( sset @ Rule @ Rules ) ) )).

% RuleSystem_Defs.sset_fenum
thf(fact_65_trim__alt,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S )
          = ( sdrop @ rule @ ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S ) @ Rs ) ) ) ) )).

% trim_alt
thf(fact_66_pos,axiom,(
    ! [Rs: ( stream @ rule ),R: rule] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( ( member @ rule @ R @ ( sset @ rule @ rules ) )
       => ( ( shd @ rule @ ( sdrop @ rule @ ( abstra2097340358le_pos @ rule @ Rs @ R ) @ Rs ) )
          = R ) ) ) )).

% pos
thf(fact_67_trim__def,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S )
      = ( sdrop_while @ rule
        @ ^ [R3: rule] :
            ~ ( abstra1874422341nabled @ rule @ state @ eff @ R3 @ S )
        @ Rs ) ) )).

% trim_def
thf(fact_68_wf__mkTree,axiom,(
    ! [S: state,Rs: ( stream @ rule )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( abstra1874736267tem_wf @ rule @ state @ eff @ rules @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) ) ) ) )).

% wf_mkTree
thf(fact_69_countable__empty,axiom,(
    ! [A: $tType] :
      ( countable_countable @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% countable_empty
thf(fact_70_RuleSystem_Opos,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),Rs: ( stream @ Rule ),R: Rule] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
       => ( ( member @ Rule @ R @ ( sset @ Rule @ Rules ) )
         => ( ( shd @ Rule @ ( sdrop @ Rule @ ( abstra2097340358le_pos @ Rule @ Rs @ R ) @ Rs ) )
            = R ) ) ) ) )).

% RuleSystem.pos
thf(fact_71_in__cont__mkTree,axiom,(
    ! [S: state,Rs: ( stream @ rule ),T3: ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ T3 @ ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) ) )
         => ? [Sl5: ( fset @ state ),S6: state] :
              ( ( member @ state @ S6 @ s )
              & ( eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S @ Sl5 )
              & ( fmember @ state @ S6 @ Sl5 )
              & ( T3
                = ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S6 ) ) ) ) ) ) )).

% in_cont_mkTree
thf(fact_72_RuleSystem_Otrim__alt,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S )
            = ( sdrop @ Rule @ ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S ) @ Rs ) ) ) ) ) )).

% RuleSystem.trim_alt
thf(fact_73_countableI__type,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ! [A4: ( set @ A )] :
          ( countable_countable @ A @ A4 ) ) )).

% countableI_type
thf(fact_74_ipath__mkTree__sdrop,axiom,(
    ! [S: state,Rs: ( stream @ rule ),Steps2: ( stream @ ( product_prod @ state @ rule ) ),M: nat] :
      ( ( member @ state @ S @ s )
     => ( ( abstra928354080m_fair @ rule @ rules @ Rs )
       => ( ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) @ Steps2 )
         => ? [N: nat,S6: state] :
              ( ( member @ state @ S6 @ s )
              & ( abstra313004635_ipath @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( sdrop @ rule @ N @ Rs ) @ S6 ) @ ( sdrop @ ( product_prod @ state @ rule ) @ M @ Steps2 ) ) ) ) ) ) )).

% ipath_mkTree_sdrop
thf(fact_75_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( sdrop_while @ A )
      = ( ^ [P4: ( A > $o ),S4: ( stream @ A )] :
            ( if @ ( stream @ A ) @ ( P4 @ ( shd @ A @ S4 ) ) @ ( sdrop_while @ A @ P4 @ ( stl @ A @ S4 ) ) @ S4 ) ) ) )).

% sdrop_while.simps
thf(fact_76_RuleSystem_Oin__cont__mkTree,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule ),T3: ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( ( fmember @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ T3 @ ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) ) )
           => ? [Sl5: ( fset @ State ),S6: State] :
                ( ( member @ State @ S6 @ S3 )
                & ( Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S @ Sl5 )
                & ( fmember @ State @ S6 @ Sl5 )
                & ( T3
                  = ( abstra1225283448mkTree @ Rule @ State @ Eff @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S6 ) ) ) ) ) ) ) )).

% RuleSystem.in_cont_mkTree
thf(fact_77_RuleSystem__Defs_Otrim__def,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1259602206m_trim @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs2: ( stream @ Rule ),S4: State] :
            ( sdrop_while @ Rule
            @ ^ [R3: Rule] :
                ~ ( abstra1874422341nabled @ Rule @ State @ Eff2 @ R3 @ S4 )
            @ Rs2 ) ) ) )).

% RuleSystem_Defs.trim_def
thf(fact_78_countable__Collect,axiom,(
    ! [A: $tType,A4: ( set @ A ),Phi: ( A > $o )] :
      ( ( countable_countable @ A @ A4 )
     => ( countable_countable @ A
        @ ( collect @ A
          @ ^ [A3: A] :
              ( ( member @ A @ A3 @ A4 )
              & ( Phi @ A3 ) ) ) ) ) )).

% countable_Collect
thf(fact_79_RuleSystem_Owf__mkTree,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule )] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( abstra1874736267tem_wf @ Rule @ State @ Eff @ Rules @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) ) ) ) ) )).

% RuleSystem.wf_mkTree
thf(fact_80_RuleSystem_Oipath__mkTree__sdrop,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),S: State,Rs: ( stream @ Rule ),Steps2: ( stream @ ( product_prod @ State @ Rule ) ),M: nat] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( member @ State @ S @ S3 )
       => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
         => ( ( abstra313004635_ipath @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) @ Steps2 )
           => ? [N: nat,S6: State] :
                ( ( member @ State @ S6 @ S3 )
                & ( abstra313004635_ipath @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ ( sdrop @ Rule @ N @ Rs ) @ S6 ) @ ( sdrop @ ( product_prod @ State @ Rule ) @ M @ Steps2 ) ) ) ) ) ) ) )).

% RuleSystem.ipath_mkTree_sdrop
thf(fact_81_minWait__le__pos,axiom,(
    ! [Rs: ( stream @ rule ),R: rule,S: state] :
      ( ( abstra928354080m_fair @ rule @ rules @ Rs )
     => ( ( member @ rule @ R @ ( sset @ rule @ rules ) )
       => ( ( abstra1874422341nabled @ rule @ state @ eff @ R @ S )
         => ( ord_less_eq @ nat @ ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S ) @ ( abstra2097340358le_pos @ rule @ Rs @ R ) ) ) ) ) )).

% minWait_le_pos
thf(fact_82_minWait__def,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S )
      = ( ord_Least @ nat
        @ ^ [N3: nat] :
            ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N3 @ Rs ) ) @ S ) ) ) )).

% minWait_def
thf(fact_83_mkTree_Osimps_I2_J,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1749095923e_cont @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) )
      = ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) )).

% mkTree.simps(2)
thf(fact_84_minWait__least,axiom,(
    ! [N2: nat,Rs: ( stream @ rule ),S: state] :
      ( ( abstra1874422341nabled @ rule @ state @ eff @ ( shd @ rule @ ( sdrop @ rule @ N2 @ Rs ) ) @ S )
     => ( ord_less_eq @ nat @ ( abstra1332369113inWait @ rule @ state @ eff @ Rs @ S ) @ N2 ) ) )).

% minWait_least
thf(fact_85_pos__def,axiom,(
    ! [A: $tType] :
      ( ( abstra2097340358le_pos @ A )
      = ( ^ [Rs2: ( stream @ A ),R3: A] :
            ( ord_Least @ nat
            @ ^ [N3: nat] :
                ( ( shd @ A @ ( sdrop @ A @ N3 @ Rs2 ) )
                = R3 ) ) ) ) )).

% pos_def
thf(fact_86_pos__least,axiom,(
    ! [A: $tType,N2: nat,Rs: ( stream @ A ),R: A] :
      ( ( ( shd @ A @ ( sdrop @ A @ N2 @ Rs ) )
        = R )
     => ( ord_less_eq @ nat @ ( abstra2097340358le_pos @ A @ Rs @ R ) @ N2 ) ) )).

% pos_least
thf(fact_87_RuleSystem_Opos__least,axiom,(
    ! [Rule: $tType,State: $tType,A: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),N2: nat,Rs: ( stream @ A ),R: A] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( ( shd @ A @ ( sdrop @ A @ N2 @ Rs ) )
          = R )
       => ( ord_less_eq @ nat @ ( abstra2097340358le_pos @ A @ Rs @ R ) @ N2 ) ) ) )).

% RuleSystem.pos_least
thf(fact_88_RuleSystem_Opos__def,axiom,(
    ! [State: $tType,Rule: $tType,A: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),Rs: ( stream @ A ),R: A] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra2097340358le_pos @ A @ Rs @ R )
        = ( ord_Least @ nat
          @ ^ [N3: nat] :
              ( ( shd @ A @ ( sdrop @ A @ N3 @ Rs ) )
              = R ) ) ) ) )).

% RuleSystem.pos_def
thf(fact_89_RuleSystem_OminWait__least,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),N2: nat,Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( sdrop @ Rule @ N2 @ Rs ) ) @ S )
       => ( ord_less_eq @ nat @ ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S ) @ N2 ) ) ) )).

% RuleSystem.minWait_least
thf(fact_90_RuleSystem__Defs_OmkTree_Osimps_I2_J,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1749095923e_cont @ ( product_prod @ State @ Rule ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ Rs @ S ) )
      = ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff @ Rs @ S ) ) @ S ) ) ) )).

% RuleSystem_Defs.mkTree.simps(2)
thf(fact_91_RuleSystem_OminWait__def,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),Rs: ( stream @ Rule ),S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S )
        = ( ord_Least @ nat
          @ ^ [N3: nat] :
              ( abstra1874422341nabled @ Rule @ State @ Eff @ ( shd @ Rule @ ( sdrop @ Rule @ N3 @ Rs ) ) @ S ) ) ) ) )).

% RuleSystem.minWait_def
thf(fact_92_RuleSystem_OminWait__le__pos,axiom,(
    ! [State: $tType,Rule: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),Rs: ( stream @ Rule ),R: Rule,S: State] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra928354080m_fair @ Rule @ Rules @ Rs )
       => ( ( member @ Rule @ R @ ( sset @ Rule @ Rules ) )
         => ( ( abstra1874422341nabled @ Rule @ State @ Eff @ R @ S )
           => ( ord_less_eq @ nat @ ( abstra1332369113inWait @ Rule @ State @ Eff @ Rs @ S ) @ ( abstra2097340358le_pos @ Rule @ Rs @ R ) ) ) ) ) ) )).

% RuleSystem.minWait_le_pos
thf(fact_93_fimage__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X3: B,A4: ( fset @ B )] :
      ( ( B2
        = ( F @ X3 ) )
     => ( ( fmember @ B @ X3 @ A4 )
       => ( fmember @ A @ B2 @ ( fimage @ B @ A @ F @ A4 ) ) ) ) )).

% fimage_eqI
thf(fact_94_fimage__ident,axiom,(
    ! [A: $tType,Y4: ( fset @ A )] :
      ( ( fimage @ A @ A
        @ ^ [X6: A] : X6
        @ Y4 )
      = Y4 ) )).

% fimage_ident
thf(fact_95_fset_Omap__ident,axiom,(
    ! [A: $tType,T2: ( fset @ A )] :
      ( ( fimage @ A @ A
        @ ^ [X6: A] : X6
        @ T2 )
      = T2 ) )).

% fset.map_ident
thf(fact_96_per__def,axiom,(
    ! [R: rule] :
      ( ( abstra2096684367le_per @ rule @ state @ eff @ rules @ s @ R )
      = ( ! [S4: state,R1: rule,Sl6: ( fset @ state ),S8: state] :
            ( ( ( member @ state @ S4 @ s )
              & ( abstra1874422341nabled @ rule @ state @ eff @ R @ S4 )
              & ( member @ rule @ R1 @ ( minus_minus @ ( set @ rule ) @ ( sset @ rule @ rules ) @ ( insert @ rule @ R @ ( bot_bot @ ( set @ rule ) ) ) ) )
              & ( eff @ R1 @ S4 @ Sl6 )
              & ( fmember @ state @ S8 @ Sl6 ) )
           => ( abstra1874422341nabled @ rule @ state @ eff @ R @ S8 ) ) ) ) )).

% per_def
thf(fact_97_Least__le,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),K: A] :
          ( ( P3 @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P3 ) @ K ) ) ) )).

% Least_le
thf(fact_98_mkTree_Octr,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S )
      = ( abstra388494275e_Node @ ( product_prod @ state @ rule ) @ ( product_Pair @ state @ rule @ S @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ ( stl @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) @ S ) ) ) ) )).

% mkTree.ctr
thf(fact_99_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ord_less_eq @ A @ X3 @ X3 ) ) )).

% order_refl
thf(fact_100_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B3 ) )
      = ( ( A2 = A5 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_101_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X13: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X13 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_102_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X6: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_103_fsubsetI,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ! [X4: A] :
          ( ( fmember @ A @ X4 @ A4 )
         => ( fmember @ A @ X4 @ B4 ) )
     => ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 ) ) )).

% fsubsetI
thf(fact_104_tree_Oinject,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) ),Y1: A,Y22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( ( abstra388494275e_Node @ A @ X13 @ X22 )
        = ( abstra388494275e_Node @ A @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% tree.inject
thf(fact_105_countable__insert,axiom,(
    ! [A: $tType,A4: ( set @ A ),A2: A] :
      ( ( countable_countable @ A @ A4 )
     => ( countable_countable @ A @ ( insert @ A @ A2 @ A4 ) ) ) )).

% countable_insert
thf(fact_106_countable__insert__eq,axiom,(
    ! [A: $tType,X3: A,A4: ( set @ A )] :
      ( ( countable_countable @ A @ ( insert @ A @ X3 @ A4 ) )
      = ( countable_countable @ A @ A4 ) ) )).

% countable_insert_eq
thf(fact_107_countable__Diff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( countable_countable @ A @ A4 )
     => ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% countable_Diff
thf(fact_108_prod_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) )).

% prod.collapse
thf(fact_109_countable__Diff__eq,axiom,(
    ! [A: $tType,A4: ( set @ A ),X3: A] :
      ( ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( countable_countable @ A @ A4 ) ) )).

% countable_Diff_eq
thf(fact_110_fset__mp,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),X3: A] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
     => ( ( fmember @ A @ X3 @ A4 )
       => ( fmember @ A @ X3 @ B4 ) ) ) )).

% fset_mp
thf(fact_111_fin__mono,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),X3: A] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
     => ( ( fmember @ A @ X3 @ A4 )
       => ( fmember @ A @ X3 @ B4 ) ) ) )).

% fin_mono
thf(fact_112_fsubsetD,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),C2: A] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
     => ( ( fmember @ A @ C2 @ A4 )
       => ( fmember @ A @ C2 @ B4 ) ) ) )).

% fsubsetD
thf(fact_113_fset__rev__mp,axiom,(
    ! [A: $tType,X3: A,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ( fmember @ A @ X3 @ A4 )
     => ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
       => ( fmember @ A @ X3 @ B4 ) ) ) )).

% fset_rev_mp
thf(fact_114_subset__fimage__iff,axiom,(
    ! [A: $tType,B: $tType,B4: ( fset @ A ),F: ( B > A ),A4: ( fset @ B )] :
      ( ( ord_less_eq @ ( fset @ A ) @ B4 @ ( fimage @ B @ A @ F @ A4 ) )
      = ( ? [AA: ( fset @ B )] :
            ( ( ord_less_eq @ ( fset @ B ) @ AA @ A4 )
            & ( B4
              = ( fimage @ B @ A @ F @ AA ) ) ) ) ) )).

% subset_fimage_iff
thf(fact_115_fimage__mono,axiom,(
    ! [B: $tType,A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),F: ( A > B )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
     => ( ord_less_eq @ ( fset @ B ) @ ( fimage @ A @ B @ F @ A4 ) @ ( fimage @ A @ B @ F @ B4 ) ) ) )).

% fimage_mono
thf(fact_116_tree_Oexhaust,axiom,(
    ! [A: $tType,Y: ( abstra2103299360e_tree @ A )] :
      ~ ( ! [X1: A,X23: ( fset @ ( abstra2103299360e_tree @ A ) )] :
            ( Y
           != ( abstra388494275e_Node @ A @ X1 @ X23 ) ) ) )).

% tree.exhaust
thf(fact_117_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P3: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A6: A,B5: B] :
          ( P3 @ ( product_Pair @ A @ B @ A6 @ B5 ) )
     => ( P3 @ Prod ) ) )).

% old.prod.inducts
thf(fact_118_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A6: A,B5: B] :
            ( Y
           != ( product_Pair @ A @ B @ A6 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_119_prod__induct7,axiom,(
    ! [G2: $tType,F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D2: D,E2: E,F3: F2,G3: G2] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G2 ) @ E2 @ ( product_Pair @ F2 @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P3 @ X3 ) ) )).

% prod_induct7
thf(fact_120_prod__induct6,axiom,(
    ! [F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D2: D,E2: E,F3: F2] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) )
     => ( P3 @ X3 ) ) )).

% prod_induct6
thf(fact_121_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D2: D,E2: E] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P3 @ X3 ) ) )).

% prod_induct5
thf(fact_122_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D2: D] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P3 @ X3 ) ) )).

% prod_induct4
thf(fact_123_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A6: A,B5: B,C3: C] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P3 @ X3 ) ) )).

% prod_induct3
thf(fact_124_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D2: D,E2: E,F3: F2,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G2 ) @ E2 @ ( product_Pair @ F2 @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_125_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D2: D,E2: E,F3: F2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_126_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_127_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_128_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A6: A,B5: B,C3: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_129_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B3 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_130_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P3: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A6: A,B5: B] :
          ( P3 @ ( product_Pair @ A @ B @ A6 @ B5 ) )
     => ( P3 @ P2 ) ) )).

% prod_cases
thf(fact_131_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X4: A,Y2: B] :
      ( P2
      = ( product_Pair @ A @ B @ X4 @ Y2 ) ) )).

% surj_pair
thf(fact_132_fst__conv,axiom,(
    ! [B: $tType,A: $tType,X13: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X13 @ X22 ) )
      = X13 ) )).

% fst_conv
thf(fact_133_fst__eqD,axiom,(
    ! [B: $tType,A: $tType,X3: A,Y: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X3 @ Y ) )
        = A2 )
     => ( X3 = A2 ) ) )).

% fst_eqD
thf(fact_134_snd__conv,axiom,(
    ! [Aa: $tType,A: $tType,X13: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X13 @ X22 ) )
      = X22 ) )).

% snd_conv
thf(fact_135_snd__eqD,axiom,(
    ! [B: $tType,A: $tType,X3: B,Y: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X3 @ Y ) )
        = A2 )
     => ( Y = A2 ) ) )).

% snd_eqD
thf(fact_136_uncountable__minus__countable,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( countable_countable @ A @ A4 )
     => ( ( countable_countable @ A @ B4 )
       => ~ ( countable_countable @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B4 ) ) ) ) )).

% uncountable_minus_countable
thf(fact_137_countable__subset,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( countable_countable @ A @ B4 )
       => ( countable_countable @ A @ A4 ) ) ) )).

% countable_subset
thf(fact_138_fimage__fsubsetI,axiom,(
    ! [A: $tType,B: $tType,A4: ( fset @ A ),F: ( A > B ),B4: ( fset @ B )] :
      ( ! [X4: A] :
          ( ( fmember @ A @ X4 @ A4 )
         => ( fmember @ B @ ( F @ X4 ) @ B4 ) )
     => ( ord_less_eq @ ( fset @ B ) @ ( fimage @ A @ B @ F @ A4 ) @ B4 ) ) )).

% fimage_fsubsetI
thf(fact_139_tree_Osel_I2_J,axiom,(
    ! [A: $tType,X13: A,X22: ( fset @ ( abstra2103299360e_tree @ A ) )] :
      ( ( abstra1749095923e_cont @ A @ ( abstra388494275e_Node @ A @ X13 @ X22 ) )
      = X22 ) )).

% tree.sel(2)
thf(fact_140_surjective__pairing,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) )).

% surjective_pairing
thf(fact_141_prod_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) )).

% prod.exhaust_sel
thf(fact_142_conjI__realizer,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > $o ),P2: A,Q2: ( B > $o ),Q: B] :
      ( ( P3 @ P2 )
     => ( ( Q2 @ Q )
       => ( ( P3 @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q ) ) )
          & ( Q2 @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q ) ) ) ) ) ) )).

% conjI_realizer
thf(fact_143_exI__realizer,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > B > $o ),Y: A,X3: B] :
      ( ( P3 @ Y @ X3 )
     => ( P3 @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X3 @ Y ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X3 @ Y ) ) ) ) )).

% exI_realizer
thf(fact_144_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X3 ) @ ( G @ X3 ) ) ) ) )).

% le_funD
thf(fact_145_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X3 ) @ ( G @ X3 ) ) ) ) )).

% le_funE
thf(fact_146_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X4: A] :
              ( ord_less_eq @ B @ ( F @ X4 ) @ ( G @ X4 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_147_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B )] :
            ! [X6: A] :
              ( ord_less_eq @ B @ ( F4 @ X6 ) @ ( G4 @ X6 ) ) ) ) ) )).

% le_fun_def
thf(fact_148_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X4: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_149_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F @ B2 ) @ C2 )
           => ( ! [X4: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y2 )
                 => ( ord_less_eq @ C @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_150_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B2: B,C2: B] :
          ( ( A2
            = ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X4: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_151_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F @ B2 )
              = C2 )
           => ( ! [X4: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y2 )
                 => ( ord_less_eq @ B @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_152_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X6: A,Y5: A] :
              ( ( ord_less_eq @ A @ X6 @ Y5 )
              & ( ord_less_eq @ A @ Y5 @ X6 ) ) ) ) ) )).

% eq_iff
thf(fact_153_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X3 )
           => ( X3 = Y ) ) ) ) )).

% antisym
thf(fact_154_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
          | ( ord_less_eq @ A @ Y @ X3 ) ) ) )).

% linear
thf(fact_155_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A] :
          ( ( X3 = Y )
         => ( ord_less_eq @ A @ X3 @ Y ) ) ) )).

% eq_refl
thf(fact_156_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X3 @ Y )
         => ( ord_less_eq @ A @ Y @ X3 ) ) ) )).

% le_cases
thf(fact_157_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% order.trans
thf(fact_158_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X3 )
             => ~ ( ord_less_eq @ A @ X3 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X3 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X3 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X3 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X3 )
                     => ~ ( ord_less_eq @ A @ X3 @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_159_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X3: A] :
          ( ( ord_less_eq @ A @ Y @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y )
            = ( X3 = Y ) ) ) ) )).

% antisym_conv
thf(fact_160_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_161_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_162_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) )).

% order_class.order.antisym
thf(fact_163_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_164_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_165_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > A > $o ),A2: A,B2: A] :
          ( ! [A6: A,B5: A] :
              ( ( ord_less_eq @ A @ A6 @ B5 )
             => ( P3 @ A6 @ B5 ) )
         => ( ! [A6: A,B5: A] :
                ( ( P3 @ B5 @ A6 )
               => ( P3 @ A6 @ B5 ) )
           => ( P3 @ A2 @ B2 ) ) ) ) )).

% linorder_wlog
thf(fact_166_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_167_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) )).

% dual_order.antisym
thf(fact_168_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X6: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_169_eqfelem__imp__iff,axiom,(
    ! [A: $tType,X3: A,Y: A,A4: ( fset @ A )] :
      ( ( X3 = Y )
     => ( ( fmember @ A @ X3 @ A4 )
        = ( fmember @ A @ Y @ A4 ) ) ) )).

% eqfelem_imp_iff
thf(fact_170_if__split__fmem2,axiom,(
    ! [A: $tType,A2: A,Q2: $o,X3: ( fset @ A ),Y: ( fset @ A )] :
      ( ( fmember @ A @ A2 @ ( if @ ( fset @ A ) @ Q2 @ X3 @ Y ) )
      = ( ( Q2
         => ( fmember @ A @ A2 @ X3 ) )
        & ( ~ ( Q2 )
         => ( fmember @ A @ A2 @ Y ) ) ) ) )).

% if_split_fmem2
thf(fact_171_if__split__fmem1,axiom,(
    ! [A: $tType,Q2: $o,X3: A,Y: A,B2: ( fset @ A )] :
      ( ( fmember @ A @ ( if @ A @ Q2 @ X3 @ Y ) @ B2 )
      = ( ( Q2
         => ( fmember @ A @ X3 @ B2 ) )
        & ( ~ ( Q2 )
         => ( fmember @ A @ Y @ B2 ) ) ) ) )).

% if_split_fmem1
thf(fact_172_eqfset__imp__iff,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),X3: A] :
      ( ( A4 = B4 )
     => ( ( fmember @ A @ X3 @ A4 )
        = ( fmember @ A @ X3 @ B4 ) ) ) )).

% eqfset_imp_iff
thf(fact_173_eq__fmem__trans,axiom,(
    ! [A: $tType,A2: A,B2: A,A4: ( fset @ A )] :
      ( ( A2 = B2 )
     => ( ( fmember @ A @ B2 @ A4 )
       => ( fmember @ A @ A2 @ A4 ) ) ) )).

% eq_fmem_trans
thf(fact_174_fset__choice,axiom,(
    ! [B: $tType,A: $tType,A4: ( fset @ A ),P3: ( A > B > $o )] :
      ( ! [X4: A] :
          ( ( fmember @ A @ X4 @ A4 )
         => ? [X12: B] :
              ( P3 @ X4 @ X12 ) )
     => ? [F3: ( A > B )] :
        ! [X5: A] :
          ( ( fmember @ A @ X5 @ A4 )
         => ( P3 @ X5 @ ( F3 @ X5 ) ) ) ) )).

% fset_choice
thf(fact_175_fequalityCE,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),C2: A] :
      ( ( A4 = B4 )
     => ( ( ( fmember @ A @ C2 @ A4 )
         => ~ ( fmember @ A @ C2 @ B4 ) )
       => ~ ( ~ ( fmember @ A @ C2 @ A4 )
           => ( fmember @ A @ C2 @ B4 ) ) ) ) )).

% fequalityCE
thf(fact_176_fset__eqI,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ! [X4: A] :
          ( ( fmember @ A @ X4 @ A4 )
          = ( fmember @ A @ X4 @ B4 ) )
     => ( A4 = B4 ) ) )).

% fset_eqI
thf(fact_177_RuleSystem_Oper__def,axiom,(
    ! [Rule: $tType,State: $tType,Eff: ( Rule > State > ( fset @ State ) > $o ),Rules: ( stream @ Rule ),S3: ( set @ State ),R: Rule] :
      ( ( abstra1326562878System @ Rule @ State @ Eff @ Rules @ S3 )
     => ( ( abstra2096684367le_per @ Rule @ State @ Eff @ Rules @ S3 @ R )
        = ( ! [S4: State,R1: Rule,Sl6: ( fset @ State ),S8: State] :
              ( ( ( member @ State @ S4 @ S3 )
                & ( abstra1874422341nabled @ Rule @ State @ Eff @ R @ S4 )
                & ( member @ Rule @ R1 @ ( minus_minus @ ( set @ Rule ) @ ( sset @ Rule @ Rules ) @ ( insert @ Rule @ R @ ( bot_bot @ ( set @ Rule ) ) ) ) )
                & ( Eff @ R1 @ S4 @ Sl6 )
                & ( fmember @ State @ S8 @ Sl6 ) )
             => ( abstra1874422341nabled @ Rule @ State @ Eff @ R @ S8 ) ) ) ) ) )).

% RuleSystem.per_def
thf(fact_178_LeastI2,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),A2: A,Q2: ( A > $o )] :
          ( ( P3 @ A2 )
         => ( ! [X4: A] :
                ( ( P3 @ X4 )
               => ( Q2 @ X4 ) )
           => ( Q2 @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2
thf(fact_179_LeastI__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o )] :
          ( ? [X12: A] :
              ( P3 @ X12 )
         => ( P3 @ ( ord_Least @ A @ P3 ) ) ) ) )).

% LeastI_ex
thf(fact_180_LeastI2__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),Q2: ( A > $o )] :
          ( ? [X12: A] :
              ( P3 @ X12 )
         => ( ! [X4: A] :
                ( ( P3 @ X4 )
               => ( Q2 @ X4 ) )
           => ( Q2 @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2_ex
thf(fact_181_RuleSystem__Defs_OmkTree_Ocode,axiom,(
    ! [State: $tType,Rule: $tType] :
      ( ( abstra1225283448mkTree @ Rule @ State )
      = ( ^ [Eff2: ( Rule > State > ( fset @ State ) > $o ),Rs2: ( stream @ Rule ),S4: State] :
            ( abstra388494275e_Node @ ( product_prod @ State @ Rule ) @ ( product_Pair @ State @ Rule @ S4 @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs2 @ S4 ) ) ) @ ( fimage @ State @ ( abstra2103299360e_tree @ ( product_prod @ State @ Rule ) ) @ ( abstra1225283448mkTree @ Rule @ State @ Eff2 @ ( stl @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs2 @ S4 ) ) ) @ ( abstra1276541928ickEff @ Rule @ State @ Eff2 @ ( shd @ Rule @ ( abstra1259602206m_trim @ Rule @ State @ Eff2 @ Rs2 @ S4 ) ) @ S4 ) ) ) ) ) )).

% RuleSystem_Defs.mkTree.code
thf(fact_182_fimage__fimage,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G: ( C > B ),A4: ( fset @ C )] :
      ( ( fimage @ B @ A @ F @ ( fimage @ C @ B @ G @ A4 ) )
      = ( fimage @ C @ A
        @ ^ [X6: C] :
            ( F @ ( G @ X6 ) )
        @ A4 ) ) )).

% fimage_fimage
thf(fact_183_LeastI,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),K: A] :
          ( ( P3 @ K )
         => ( P3 @ ( ord_Least @ A @ P3 ) ) ) ) )).

% LeastI
thf(fact_184_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) )).

% bot.extremum
thf(fact_185_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_186_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_187_LeastI2__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),X3: A,Q2: ( A > $o )] :
          ( ( P3 @ X3 )
         => ( ! [Y2: A] :
                ( ( P3 @ Y2 )
               => ( ord_less_eq @ A @ X3 @ Y2 ) )
           => ( ! [X4: A] :
                  ( ( P3 @ X4 )
                 => ( ! [Y6: A] :
                        ( ( P3 @ Y6 )
                       => ( ord_less_eq @ A @ X4 @ Y6 ) )
                   => ( Q2 @ X4 ) ) )
             => ( Q2 @ ( ord_Least @ A @ P3 ) ) ) ) ) ) )).

% LeastI2_order
thf(fact_188_Least__equality,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),X3: A] :
          ( ( P3 @ X3 )
         => ( ! [Y2: A] :
                ( ( P3 @ Y2 )
               => ( ord_less_eq @ A @ X3 @ Y2 ) )
           => ( ( ord_Least @ A @ P3 )
              = X3 ) ) ) ) )).

% Least_equality
thf(fact_189_LeastI2__wellorder,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),A2: A,Q2: ( A > $o )] :
          ( ( P3 @ A2 )
         => ( ! [A6: A] :
                ( ( P3 @ A6 )
               => ( ! [B6: A] :
                      ( ( P3 @ B6 )
                     => ( ord_less_eq @ A @ A6 @ B6 ) )
                 => ( Q2 @ A6 ) ) )
           => ( Q2 @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2_wellorder
thf(fact_190_LeastI2__wellorder__ex,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > $o ),Q2: ( A > $o )] :
          ( ? [X12: A] :
              ( P3 @ X12 )
         => ( ! [A6: A] :
                ( ( P3 @ A6 )
               => ( ! [B6: A] :
                      ( ( P3 @ B6 )
                     => ( ord_less_eq @ A @ A6 @ B6 ) )
                 => ( Q2 @ A6 ) ) )
           => ( Q2 @ ( ord_Least @ A @ P3 ) ) ) ) ) )).

% LeastI2_wellorder_ex
thf(fact_191_rev__fimage__eqI,axiom,(
    ! [B: $tType,A: $tType,X3: A,A4: ( fset @ A ),B2: B,F: ( A > B )] :
      ( ( fmember @ A @ X3 @ A4 )
     => ( ( B2
          = ( F @ X3 ) )
       => ( fmember @ B @ B2 @ ( fimage @ A @ B @ F @ A4 ) ) ) ) )).

% rev_fimage_eqI
thf(fact_192_fimage__cong,axiom,(
    ! [B: $tType,A: $tType,M2: ( fset @ A ),N4: ( fset @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M2 = N4 )
     => ( ! [X4: A] :
            ( ( fmember @ A @ X4 @ N4 )
           => ( ( F @ X4 )
              = ( G @ X4 ) ) )
       => ( ( fimage @ A @ B @ F @ M2 )
          = ( fimage @ A @ B @ G @ N4 ) ) ) ) )).

% fimage_cong
thf(fact_193_fimageI,axiom,(
    ! [B: $tType,A: $tType,X3: A,A4: ( fset @ A ),F: ( A > B )] :
      ( ( fmember @ A @ X3 @ A4 )
     => ( fmember @ B @ ( F @ X3 ) @ ( fimage @ A @ B @ F @ A4 ) ) ) )).

% fimageI
thf(fact_194_fimageE,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),A4: ( fset @ B )] :
      ( ( fmember @ A @ B2 @ ( fimage @ B @ A @ F @ A4 ) )
     => ~ ( ! [X4: B] :
              ( ( B2
                = ( F @ X4 ) )
             => ~ ( fmember @ B @ X4 @ A4 ) ) ) ) )).

% fimageE
thf(fact_195_mkTree__unfold,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S )
      = ( case_stream @ rule @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) )
        @ ^ [R3: rule,S8: ( stream @ rule )] :
            ( abstra388494275e_Node @ ( product_prod @ state @ rule ) @ ( product_Pair @ state @ rule @ S @ R3 ) @ ( fimage @ state @ ( abstra2103299360e_tree @ ( product_prod @ state @ rule ) ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ S8 ) @ ( abstra1276541928ickEff @ rule @ state @ eff @ R3 @ S ) ) )
        @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) )).

% mkTree_unfold
thf(fact_196_insert__Diff__single,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A4 ) ) )).

% insert_Diff_single
thf(fact_197_singleton__conv2,axiom,(
    ! [A: $tType,A2: A] :
      ( ( collect @ A
        @ ( ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ A2 ) )
      = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv2
thf(fact_198_singleton__conv,axiom,(
    ! [A: $tType,A2: A] :
      ( ( collect @ A
        @ ^ [X6: A] : ( X6 = A2 ) )
      = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv
thf(fact_199_mkTree_Osimps_I1_J,axiom,(
    ! [Rs: ( stream @ rule ),S: state] :
      ( ( abstra573067619e_root @ ( product_prod @ state @ rule ) @ ( abstra1225283448mkTree @ rule @ state @ eff @ Rs @ S ) )
      = ( product_Pair @ state @ rule @ S @ ( shd @ rule @ ( abstra1259602206m_trim @ rule @ state @ eff @ Rs @ S ) ) ) ) )).

% mkTree.simps(1)
thf(fact_200_empty__Collect__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P3 ) )
      = ( ! [X6: A] :
            ~ ( P3 @ X6 ) ) ) )).

% empty_Collect_eq
thf(fact_201_Collect__empty__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( collect @ A @ P3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X6: A] :
            ~ ( P3 @ X6 ) ) ) )).

% Collect_empty_eq
thf(fact_202_all__not__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ! [X6: A] :
            ~ ( member @ A @ X6 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_203_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_204_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_205_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A4 )
         => ( member @ A @ X4 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% subsetI
thf(fact_206_insert__absorb2,axiom,(
    ! [A: $tType,X3: A,A4: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ X3 @ A4 ) )
      = ( insert @ A @ X3 @ A4 ) ) )).

% insert_absorb2
thf(fact_207_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A4 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A4 ) ) ) )).

% insert_iff
thf(fact_208_insertCI,axiom,(
    ! [A: $tType,A2: A,B4: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B4 )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B4 ) ) ) )).

% insertCI
thf(fact_209_Diff__idemp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B4 ) @ B4 )
      = ( minus_minus @ ( set @ A ) @ A4 @ B4 ) ) )).

% Diff_idemp
thf(fact_210_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( member @ A @ C2 @ A4 )
        & ~ ( member @ A @ C2 @ B4 ) ) ) )).

% Diff_iff
thf(fact_211_DiffI,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B4 ) ) ) ) )).

% DiffI
thf(fact_212_fempty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( fmember @ A @ C2 @ ( bot_bot @ ( fset @ A ) ) ) )).

% fempty_iff
thf(fact_213_all__not__fin__conv,axiom,(
    ! [A: $tType,A4: ( fset @ A )] :
      ( ( ! [X6: A] :
            ~ ( fmember @ A @ X6 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% all_not_fin_conv
thf(fact_214_fempty__fsubsetI,axiom,(
    ! [A: $tType,X3: ( fset @ A )] :
      ( ord_less_eq @ ( fset @ A ) @ ( bot_bot @ ( fset @ A ) ) @ X3 ) )).

% fempty_fsubsetI
thf(fact_215_fsubset__fempty,axiom,(
    ! [A: $tType,A4: ( fset @ A )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ ( bot_bot @ ( fset @ A ) ) )
      = ( A4
        = ( bot_bot @ ( fset @ A ) ) ) ) )).

% fsubset_fempty
thf(fact_216_fsubset__antisym,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( fset @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% fsubset_antisym
thf(fact_217_fimage__fempty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( fimage @ B @ A @ F @ ( bot_bot @ ( fset @ B ) ) )
      = ( bot_bot @ ( fset @ A ) ) ) )).

% fimage_fempty
thf(fact_218_fempty__is__fimage,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( fset @ B )] :
      ( ( ( bot_bot @ ( fset @ A ) )
        = ( fimage @ B @ A @ F @ A4 ) )
      = ( A4
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fempty_is_fimage
thf(fact_219_fimage__is__fempty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( fset @ B )] :
      ( ( ( fimage @ B @ A @ F @ A4 )
        = ( bot_bot @ ( fset @ A ) ) )
      = ( A4
        = ( bot_bot @ ( fset @ B ) ) ) ) )).

% fimage_is_fempty
thf(fact_220_empty__subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 ) )).

% empty_subsetI
thf(fact_221_subset__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_222_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_223_insert__subset,axiom,(
    ! [A: $tType,X3: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ A4 ) @ B4 )
      = ( ( member @ A @ X3 @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% insert_subset
thf(fact_224_Diff__cancel,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_225_empty__Diff,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_226_Diff__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = A4 ) )).

% Diff_empty
thf(fact_227_insert__Diff1,axiom,(
    ! [A: $tType,X3: A,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( member @ A @ X3 @ B4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A4 ) @ B4 )
        = ( minus_minus @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% insert_Diff1
thf(fact_228_Diff__insert0,axiom,(
    ! [A: $tType,X3: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A4 )
     => ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X3 @ B4 ) )
        = ( minus_minus @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% Diff_insert0
thf(fact_229_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A2: A,A4: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A4 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_230_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A2 @ A4 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_231_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A4 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% Diff_eq_empty_iff
thf(fact_232_tree_Ocollapse,axiom,(
    ! [A: $tType,Tree: ( abstra2103299360e_tree @ A )] :
      ( ( abstra388494275e_Node @ A @ ( abstra573067619e_root @ A @ Tree ) @ ( abstra1749095923e_cont @ A @ Tree ) )
      = Tree ) )).

% tree.collapse
thf(fact_233_Collect__mono__iff,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q2: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q2 ) )
      = ( ! [X6: A] :
            ( ( P3 @ X6 )
           => ( Q2 @ X6 ) ) ) ) )).

% Collect_mono_iff
thf(fact_234_fset__eq__fsubset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( fset @ A ),Z: ( fset @ A )] : ( Y3 = Z ) )
      = ( ^ [A7: ( fset @ A ),B7: ( fset @ A )] :
            ( ( ord_less_eq @ ( fset @ A ) @ A7 @ B7 )
            & ( ord_less_eq @ ( fset @ A ) @ B7 @ A7 ) ) ) ) )).

% fset_eq_fsubset
thf(fact_235_contra__subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ~ ( member @ A @ C2 @ A4 ) ) ) )).

% contra_subsetD
thf(fact_236_fsubset__trans,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A ),C4: ( fset @ A )] :
      ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( fset @ A ) @ B4 @ C4 )
       => ( ord_less_eq @ ( fset @ A ) @ A4 @ C4 ) ) ) )).

% fsubset_trans
thf(fact_237_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( set @ A ),Z: ( set @ A )] : ( Y3 = Z ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) )).

% set_eq_subset
thf(fact_238_fsubset__refl,axiom,(
    ! [A: $tType,A4: ( fset @ A )] :
      ( ord_less_eq @ ( fset @ A ) @ A4 @ A4 ) )).

% fsubset_refl
thf(fact_239_subset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A4 @ C4 ) ) ) )).

% subset_trans
thf(fact_240_Collect__mono,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P3 @ X4 )
         => ( Q2 @ X4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q2 ) ) ) )).

% Collect_mono
thf(fact_241_fequalityD2,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( fset @ A ) @ B4 @ A4 ) ) )).

% fequalityD2
thf(fact_242_fequalityD1,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 ) ) )).

% fequalityD1
thf(fact_243_subset__refl,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ A4 ) )).

% subset_refl
thf(fact_244_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% rev_subsetD
thf(fact_245_fequalityE,axiom,(
    ! [A: $tType,A4: ( fset @ A ),B4: ( fset @ A )] :
      ( ( A4 = B4 )
     => ~ ( ( ord_less_eq @ ( fset @ A ) @ A4 @ B4 )
         => ~ ( ord_less_eq @ ( fset @ A ) @ B4 @ A4 ) ) ) )).

% fequalityE
thf(fact_246_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
          ! [T: A] :
            ( ( member @ A @ T @ A7 )
           => ( member @ A @ T @ B7 ) ) ) ) )).

% subset_iff
thf(fact_247_set__rev__mp,axiom,(
    ! [A: $tType,X3: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ X3 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ X3 @ B4 ) ) ) )).

% set_rev_mp
thf(fact_248_equalityD2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) )).

% equalityD2
thf(fact_249_equalityD1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% equalityD1
thf(fact_250_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
          ! [X6: A] :
            ( ( member @ A @ X6 @ A7 )
           => ( member @ A @ X6 @ B7 ) ) ) ) )).

% subset_eq
thf(fact_251_equalityE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) )).

% equalityE
thf(fact_252_subsetCE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetCE
thf(fact_253_subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetD
thf(fact_254_in__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X3 @ A4 )
       => ( member @ A @ X3 @ B4 ) ) ) )).

% in_mono
thf(fact_255_set__mp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X3 @ A4 )
       => ( member @ A @ X3 @ B4 ) ) ) )).

% set_mp

%----Type constructors (39)
thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_FSet_Ofset___Finite__Set_Ofinite_1,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_2,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_3,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite_4,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_bot @ A9 @ ( type2 @ A9 ) )
     => ( order_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Countable_Ocountable,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( countable @ A9 @ ( type2 @ A9 ) ) )
     => ( countable @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_5,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Countable_Ocountable_6,axiom,
    ( countable @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_7,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_8,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_9,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_10,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_11,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Countable_Ocountable_12,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( countable @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_13,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_14,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_15,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_16,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_17,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Countable_Ocountable_18,axiom,
    ( countable @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_19,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_20,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_21,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_22,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_23,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_FSet_Ofset___Orderings_Oorder__bot_24,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Countable_Ocountable_25,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( countable @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Opreorder_26,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Oorder_27,axiom,(
    ! [A8: $tType] :
      ( order @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Oord_28,axiom,(
    ! [A8: $tType] :
      ( ord @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Orderings_Obot_29,axiom,(
    ! [A8: $tType] :
      ( bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_Product__Type_Oprod___Countable_Ocountable_30,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( countable @ A8 @ ( type2 @ A8 ) )
        & ( countable @ A9 @ ( type2 @ A9 ) ) )
     => ( countable @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P3: $o] :
      ( ( P3 = $true )
      | ( P3 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X3: A,Y: A] :
      ( ( if @ A @ $false @ X3 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X3: A,Y: A] :
      ( ( if @ A @ $true @ X3 @ Y )
      = X3 ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ! [Sl7: ( fset @ state )] :
      ( ( ( eff @ ( product_snd @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) ) @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ stepsa ) ) @ Sl7 )
        & ( fmember @ state @ ( product_fst @ state @ rule @ ( shd @ ( product_prod @ state @ rule ) @ ( stl @ ( product_prod @ state @ rule ) @ stepsa ) ) ) @ Sl7 ) )
     => thesis ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
