%------------------------------------------------------------------------------
% File     : COM162^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Binary decision diagram 38
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [OS08]  Ortner & Schirmer (2008), BDD Normalisation
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : bindag__38.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  473 (   0 unit; 103 type;   0 defn)
%            Number of atoms       : 3911 ( 385 equality;1708 variable)
%            Maximal formula depth :   18 (   7 average)
%            Number of connectives : 2965 (  61   ~;   8   |;  44   &;2665   @)
%                                         (   0 <=>; 187  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  246 ( 246   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  107 ( 103   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  802 (  12 sgn; 673   !;  11   ?;  43   ^)
%                                         ( 802   :;  75  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:44:49.360
%------------------------------------------------------------------------------
%----Could-be-implicit typings (16)
thf(ty_t_BinDag__Mirabelle__rybootvolr_Odag,type,(
    binDag_Mirabelle_dag: $tType )).

thf(ty_t_Record_Otuple__isomorphism,type,(
    tuple_isomorphism: $tType > $tType > $tType > $tType )).

thf(ty_t_Code__Numeral_Onatural,type,(
    code_natural: $tType )).

thf(ty_t_Code__Evaluation_Oterm,type,(
    code_term: $tType )).

thf(ty_t_Product__Type_Ounit,type,(
    product_unit: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Typerep_Otyperep,type,(
    typerep: $tType )).

thf(ty_t_Simpl__Heap_Oref,type,(
    simpl_ref: $tType )).

thf(ty_t_String_Oliteral,type,(
    literal: $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Num_Onum,type,(
    num: $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (87)
thf(sy_cl_Enum_Oenum,type,(
    enum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Typerep_Otyperep,type,(
    typerep2: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Oequal,type,(
    cl_HOL_Oequal: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Code__Evaluation_Oterm__of,type,(
    code_term_of: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osize,type,(
    size: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Onumeral,type,(
    numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Ofield,type,(
    field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__neq__one,type,(
    zero_neq_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Divides_Osemiring__div,type,(
    semiring_div: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Odivision__ring,type,(
    division_ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemidom__divide,type,(
    semidom_divide: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring__1,type,(
    comm_semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__add,type,(
    comm_monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Quickcheck__Random_Orandom,type,(
    quickcheck_random: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Divides_Osemiring__div__parity,type,(
    semiring_div_parity: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,(
    linord219039673up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,(
    semiri456707255roduct: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,(
    bNF_Greatest_Shift: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) )).

thf(sy_c_Basic__BNF__LFPs_Osum_Osize__sum,type,(
    basic_BNF_size_sum: 
      !>[A: $tType,B: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( sum_sum @ A @ B ) > nat ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_ONode,type,(
    binDag476092410e_Node: binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_OTip,type,(
    binDag_Mirabelle_Tip: binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Ocase__dag,type,(
    binDag1297733282se_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Orec__dag,type,(
    binDag1442713106ec_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Osize__dag,type,(
    binDag1924123185ze_dag: binDag_Mirabelle_dag > nat )).

thf(sy_c_Code__Numeral_OSuc,type,(
    code_Suc: code_natural > code_natural )).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,(
    code_case_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,(
    code_rec_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Osize__natural,type,(
    code_size_natural: code_natural > nat )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_Obool_Osize__bool,type,(
    size_bool: $o > nat )).

thf(sy_c_HOL_Odefault__class_Odefault,type,(
    default_default: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_List_Ogen__length,type,(
    gen_length: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > nat ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_Osize__list,type,(
    size_list: 
      !>[A: $tType] :
        ( ( A > nat ) > ( list @ A ) > nat ) )).

thf(sy_c_List_Osplice,type,(
    splice: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Num_Oinc,type,(
    inc: num > num )).

thf(sy_c_Num_Onat__of__num,type,(
    nat_of_num: num > nat )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,(
    neg_numeral_dbl_inc: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Num_Onum_OBit0,type,(
    bit0: num > num )).

thf(sy_c_Num_Onum_OBit1,type,(
    bit1: num > num )).

thf(sy_c_Num_Onum_OOne,type,(
    one2: num )).

thf(sy_c_Num_Onum_Osize__num,type,(
    size_num: num > nat )).

thf(sy_c_Num_Onumeral__class_Onumeral,type,(
    numeral_numeral: 
      !>[A: $tType] :
        ( num > A ) )).

thf(sy_c_Option_Ooption_ONone,type,(
    none: 
      !>[A: $tType] :
        ( option @ A ) )).

thf(sy_c_Option_Ooption_OSome,type,(
    some: 
      !>[A: $tType] :
        ( A > ( option @ A ) ) )).

thf(sy_c_Option_Ooption_Ocase__option,type,(
    case_option: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > B ) > ( option @ A ) > B ) )).

thf(sy_c_Option_Ooption_Osize__option,type,(
    size_option: 
      !>[A: $tType] :
        ( ( A > nat ) > ( option @ A ) > nat ) )).

thf(sy_c_Option_Ooption_Othe,type,(
    the: 
      !>[A: $tType] :
        ( ( option @ A ) > A ) )).

thf(sy_c_Product__Type_OUnity,type,(
    product_Unity: product_unit )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,(
    product_rec_unit: 
      !>[T: $tType] :
        ( T > product_unit > T ) )).

thf(sy_c_Product__Type_Ounit_Ocase__unit,type,(
    product_case_unit: 
      !>[A: $tType] :
        ( A > product_unit > A ) )).

thf(sy_c_Product__Type_Ounit_Osize__unit,type,(
    product_size_unit: product_unit > nat )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Record_Otuple__isomorphism_OTuple__Isomorphism,type,(
    tuple_742722141rphism: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > ( product_prod @ B @ C ) ) > ( ( product_prod @ B @ C ) > A ) > ( tuple_isomorphism @ A @ B @ C ) ) )).

thf(sy_c_Record_Otuple__isomorphism_Osize__tuple__isomorphism,type,(
    tuple_1907371454rphism: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( C > nat ) > ( tuple_isomorphism @ A @ B @ C ) > nat ) )).

thf(sy_c_Rings_Odivide__class_Odivide,type,(
    divide_divide: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Transitive__Closure_Ontrancl,type,(
    transitive_ntrancl: 
      !>[A: $tType] :
        ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Typerep_Otyperep_OTyperep,type,(
    typerep3: literal > ( list @ typerep ) > typerep )).

thf(sy_c_Typerep_Otyperep_Osize__typerep,type,(
    size_typerep: typerep > nat )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_a,type,(
    a: simpl_ref )).

thf(sy_v_lt,type,(
    lt: binDag_Mirabelle_dag )).

thf(sy_v_rt,type,(
    rt: binDag_Mirabelle_dag )).

%----Relevant facts (251)
thf(fact_0_dag_Oinject,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag,Y21: binDag_Mirabelle_dag,Y22: simpl_ref,Y23: binDag_Mirabelle_dag] :
      ( ( ( binDag476092410e_Node @ X21 @ X22 @ X23 )
        = ( binDag476092410e_Node @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% dag.inject
thf(fact_1_dag_Odistinct_I1_J,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( binDag_Mirabelle_Tip
     != ( binDag476092410e_Node @ X21 @ X22 @ X23 ) ) )).

% dag.distinct(1)
thf(fact_2_dag_Oinduct,axiom,(
    ! [P: ( binDag_Mirabelle_dag > $o ),Dag: binDag_Mirabelle_dag] :
      ( ( P @ binDag_Mirabelle_Tip )
     => ( ! [X1: binDag_Mirabelle_dag,X2: simpl_ref,X3: binDag_Mirabelle_dag] :
            ( ( P @ X1 )
           => ( ( P @ X3 )
             => ( P @ ( binDag476092410e_Node @ X1 @ X2 @ X3 ) ) ) )
       => ( P @ Dag ) ) ) )).

% dag.induct
thf(fact_3_dag_Oexhaust,axiom,(
    ! [Y: binDag_Mirabelle_dag] :
      ( ( Y != binDag_Mirabelle_Tip )
     => ~ ( ! [X212: binDag_Mirabelle_dag,X222: simpl_ref,X232: binDag_Mirabelle_dag] :
              ( Y
             != ( binDag476092410e_Node @ X212 @ X222 @ X232 ) ) ) ) )).

% dag.exhaust
thf(fact_4_dag_Osimps_I7_J,axiom,(
    ! [A: $tType,F1: A,F2: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ),X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1442713106ec_dag @ A @ F1 @ F2 @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( F2 @ X21 @ X22 @ X23 @ ( binDag1442713106ec_dag @ A @ F1 @ F2 @ X21 ) @ ( binDag1442713106ec_dag @ A @ F1 @ F2 @ X23 ) ) ) )).

% dag.simps(7)
thf(fact_5_dag_Osimps_I5_J,axiom,(
    ! [A: $tType,F1: A,F2: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ),X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1297733282se_dag @ A @ F1 @ F2 @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( F2 @ X21 @ X22 @ X23 ) ) )).

% dag.simps(5)
thf(fact_6_dag_Osimps_I6_J,axiom,(
    ! [A: $tType,F1: A,F2: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A )] :
      ( ( binDag1442713106ec_dag @ A @ F1 @ F2 @ binDag_Mirabelle_Tip )
      = F1 ) )).

% dag.simps(6)
thf(fact_7_dag_Osimps_I4_J,axiom,(
    ! [A: $tType,F1: A,F2: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A )] :
      ( ( binDag1297733282se_dag @ A @ F1 @ F2 @ binDag_Mirabelle_Tip )
      = F1 ) )).

% dag.simps(4)
thf(fact_8_dag_Osize__gen_I1_J,axiom,
    ( ( binDag1924123185ze_dag @ binDag_Mirabelle_Tip )
    = ( zero_zero @ nat ) )).

% dag.size_gen(1)
thf(fact_9_dag_Osize_I3_J,axiom,
    ( ( size_size @ binDag_Mirabelle_dag @ binDag_Mirabelle_Tip )
    = ( zero_zero @ nat ) )).

% dag.size(3)
thf(fact_10_dag_Ocase__distrib,axiom,(
    ! [B: $tType,A: $tType,H: ( A > B ),F1: A,F2: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ),Dag: binDag_Mirabelle_dag] :
      ( ( H @ ( binDag1297733282se_dag @ A @ F1 @ F2 @ Dag ) )
      = ( binDag1297733282se_dag @ B @ ( H @ F1 )
        @ ^ [X12: binDag_Mirabelle_dag,X24: simpl_ref,X32: binDag_Mirabelle_dag] :
            ( H @ ( F2 @ X12 @ X24 @ X32 ) )
        @ Dag ) ) )).

% dag.case_distrib
thf(fact_11_fun__cong__unused__0,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( zero @ B @ ( type2 @ B ) )
     => ! [F: ( ( A > B ) > C ),G: C] :
          ( ( F
            = ( ^ [X: ( A > B )] : G ) )
         => ( ( F
              @ ^ [X: A] :
                  ( zero_zero @ B ) )
            = G ) ) ) )).

% fun_cong_unused_0
thf(fact_12_size__ne__size__imp__ne,axiom,(
    ! [A: $tType] :
      ( ( size @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( ( size_size @ A @ X4 )
           != ( size_size @ A @ Y ) )
         => ( X4 != Y ) ) ) )).

% size_ne_size_imp_ne
thf(fact_13_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) )).

% zero_natural.rsp
thf(fact_14_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X4: A] :
          ( ( ( zero_zero @ A )
            = X4 )
          = ( X4
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_15_bool_Osize_I1_J,axiom,
    ( ( size_bool @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(1)
thf(fact_16_bool_Osize_I2_J,axiom,
    ( ( size_bool @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(2)
thf(fact_17_dag_Osize__gen_I2_J,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1924123185ze_dag @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( binDag1924123185ze_dag @ X21 ) @ ( binDag1924123185ze_dag @ X23 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% dag.size_gen(2)
thf(fact_18_dag_Osize_I4_J,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( size_size @ binDag_Mirabelle_dag @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_size @ binDag_Mirabelle_dag @ X21 ) @ ( size_size @ binDag_Mirabelle_dag @ X23 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% dag.size(4)
thf(fact_19_ntrancl__Zero,axiom,(
    ! [A: $tType,R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R )
      = R ) )).

% ntrancl_Zero
thf(fact_20_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) )).

% add_left_cancel
thf(fact_21_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) )).

% add_right_cancel
thf(fact_22_natural_Osize_I3_J,axiom,
    ( ( size_size @ code_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(3)
thf(fact_23_bool_Osize_I4_J,axiom,
    ( ( size_size @ $o @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(4)
thf(fact_24_bool_Osize_I3_J,axiom,
    ( ( size_size @ $o @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(3)
thf(fact_25_nat_Oinject,axiom,(
    ! [X25: nat,Y2: nat] :
      ( ( ( suc @ X25 )
        = ( suc @ Y2 ) )
      = ( X25 = Y2 ) ) )).

% nat.inject
thf(fact_26_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_27_add_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.left_neutral
thf(fact_28_add_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.right_neutral
thf(fact_29_double__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero
thf(fact_30_double__zero__sym,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero_sym
thf(fact_31_add__cancel__left__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_left
thf(fact_32_add__cancel__left__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_right
thf(fact_33_add__cancel__right__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_left
thf(fact_34_add__cancel__right__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_right
thf(fact_35_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) )).

% add_is_0
thf(fact_36_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) )).

% Nat.add_0_right
thf(fact_37_add__Suc__right,axiom,(
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) )).

% add_Suc_right
thf(fact_38_one__is__add,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )).

% one_is_add
thf(fact_39_add__is__1,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )).

% add_is_1
thf(fact_40_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_41_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_42_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_43_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_44_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
          = ( Q @ X5 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_45_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X5: A] :
          ( ( F @ X5 )
          = ( G @ X5 ) )
     => ( F = G ) ) )).

% ext
thf(fact_46_Suc__inject,axiom,(
    ! [X4: nat,Y: nat] :
      ( ( ( suc @ X4 )
        = ( suc @ Y ) )
     => ( X4 = Y ) ) )).

% Suc_inject
thf(fact_47_n__not__Suc__n,axiom,(
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) )).

% n_not_Suc_n
thf(fact_48_add__Suc__shift,axiom,(
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) )).

% add_Suc_shift
thf(fact_49_add__Suc,axiom,(
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) )).

% add_Suc
thf(fact_50_nat__add__left__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ K @ M )
        = ( plus_plus @ nat @ K @ N ) )
      = ( M = N ) ) )).

% nat_add_left_cancel
thf(fact_51_nat__add__right__cancel,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ K )
        = ( plus_plus @ nat @ N @ K ) )
      = ( M = N ) ) )).

% nat_add_right_cancel
thf(fact_52_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% add.assoc
thf(fact_53_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) )).

% add.left_cancel
thf(fact_54_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) )).

% add.right_cancel
thf(fact_55_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B3: A] :
              ( plus_plus @ A @ B3 @ A4 ) ) ) ) )).

% add.commute
thf(fact_56_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% add.left_commute
thf(fact_57_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) )).

% add_left_imp_eq
thf(fact_58_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) )).

% add_right_imp_eq
thf(fact_59_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_add_class.add_0
thf(fact_60_add_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.comm_neutral
thf(fact_61_add_Ogroup__left__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.group_left_neutral
thf(fact_62_add__eq__0__iff__both__eq__0,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( ( plus_plus @ A @ X4 @ Y )
            = ( zero_zero @ A ) )
          = ( ( X4
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_63_nat_Odistinct_I1_J,axiom,(
    ! [X25: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X25 ) ) )).

% nat.distinct(1)
thf(fact_64_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat3: nat] :
      ( ( suc @ Nat3 )
     != ( zero_zero @ nat ) ) )).

% old.nat.distinct(2)
thf(fact_65_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_66_nat_OdiscI,axiom,(
    ! [Nat: nat,X25: nat] :
      ( ( Nat
        = ( suc @ X25 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) )).

% nat.discI
thf(fact_67_nat__induct,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( P @ ( suc @ N2 ) ) )
       => ( P @ N ) ) ) )).

% nat_induct
thf(fact_68_diff__induct,axiom,(
    ! [P: ( nat > nat > $o ),M: nat,N: nat] :
      ( ! [X5: nat] :
          ( P @ X5 @ ( zero_zero @ nat ) )
     => ( ! [Y3: nat] :
            ( P @ ( zero_zero @ nat ) @ ( suc @ Y3 ) )
       => ( ! [X5: nat,Y3: nat] :
              ( ( P @ X5 @ Y3 )
             => ( P @ ( suc @ X5 ) @ ( suc @ Y3 ) ) )
         => ( P @ M @ N ) ) ) ) )).

% diff_induct
thf(fact_69_zero__induct,axiom,(
    ! [P: ( nat > $o ),K: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) )).

% zero_induct
thf(fact_70_Suc__neq__Zero,axiom,(
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) )).

% Suc_neq_Zero
thf(fact_71_Zero__neq__Suc,axiom,(
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) )).

% Zero_neq_Suc
thf(fact_72_Zero__not__Suc,axiom,(
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) )).

% Zero_not_Suc
thf(fact_73_old_Onat_Oexhaust,axiom,(
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ( ! [Nat4: nat] :
              ( Y
             != ( suc @ Nat4 ) ) ) ) )).

% old.nat.exhaust
thf(fact_74_old_Onat_Oinducts,axiom,(
    ! [P: ( nat > $o ),Nat: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [Nat4: nat] :
            ( ( P @ Nat4 )
           => ( P @ ( suc @ Nat4 ) ) )
       => ( P @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_75_not0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M2: nat] :
          ( N
          = ( suc @ M2 ) ) ) )).

% not0_implies_Suc
thf(fact_76_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_77_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) )).

% add_eq_self_zero
thf(fact_78_size__bool,axiom,
    ( ( size_size @ $o )
    = ( ^ [B3: $o] :
          ( zero_zero @ nat ) ) )).

% size_bool
thf(fact_79_sum_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,X4: ( sum_sum @ A @ B )] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ X4 )
     != ( zero_zero @ nat ) ) )).

% sum.size_neq
thf(fact_80_prod_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,X4: ( product_prod @ A @ B )] :
      ( ( size_size @ ( product_prod @ A @ B ) @ X4 )
     != ( zero_zero @ nat ) ) )).

% prod.size_neq
thf(fact_81_size__bool__def,axiom,
    ( size_bool
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_def
thf(fact_82_dependent__nat__choice,axiom,(
    ! [A: $tType,P: ( nat > A > $o ),Q: ( nat > A > A > $o )] :
      ( ? [X13: A] :
          ( P @ ( zero_zero @ nat ) @ X13 )
     => ( ! [X5: A,N2: nat] :
            ( ( P @ N2 @ X5 )
           => ? [Y4: A] :
                ( ( P @ ( suc @ N2 ) @ Y4 )
                & ( Q @ N2 @ X5 @ Y4 ) ) )
       => ? [F3: ( nat > A )] :
          ! [N3: nat] :
            ( ( P @ N3 @ ( F3 @ N3 ) )
            & ( Q @ N3 @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) ) ) ) ) )).

% dependent_nat_choice
thf(fact_83_size__natural__overloaded__def,axiom,
    ( ( size_size @ code_natural )
    = ( code_rec_natural @ nat @ ( zero_zero @ nat )
      @ ^ [X: code_natural,Y5: nat] :
          ( plus_plus @ nat @ Y5 @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% size_natural_overloaded_def
thf(fact_84_semiring__normalization__rules_I6_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% semiring_normalization_rules(6)
thf(fact_85_semiring__normalization__rules_I5_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% semiring_normalization_rules(5)
thf(fact_86_add__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% add_0_iff
thf(fact_87_natural_Osize_I1_J,axiom,
    ( ( code_size_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(1)
thf(fact_88_natural_Osize_I4_J,axiom,(
    ! [Natural: code_natural] :
      ( ( size_size @ code_natural @ ( code_Suc @ Natural ) )
      = ( plus_plus @ nat @ ( size_size @ code_natural @ Natural ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% natural.size(4)
thf(fact_89_size__natural__def,axiom,
    ( code_size_natural
    = ( code_rec_natural @ nat @ ( zero_zero @ nat )
      @ ^ [X: code_natural,Y5: nat] :
          ( plus_plus @ nat @ Y5 @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% size_natural_def
thf(fact_90_option_Osize__neq,axiom,(
    ! [A: $tType,X4: ( option @ A )] :
      ( ( size_size @ ( option @ A ) @ X4 )
     != ( zero_zero @ nat ) ) )).

% option.size_neq
thf(fact_91_natural_Oinject,axiom,(
    ! [Natural: code_natural,Natural2: code_natural] :
      ( ( ( code_Suc @ Natural )
        = ( code_Suc @ Natural2 ) )
      = ( Natural = Natural2 ) ) )).

% natural.inject
thf(fact_92_natural_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T > T )] :
      ( ( code_rec_natural @ T @ F1 @ F2 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(6)
thf(fact_93_natural_Osimps_I7_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T > T ),Natural: code_natural] :
      ( ( code_rec_natural @ T @ F1 @ F2 @ ( code_Suc @ Natural ) )
      = ( F2 @ Natural @ ( code_rec_natural @ T @ F1 @ F2 @ Natural ) ) ) )).

% natural.simps(7)
thf(fact_94_natural_Osize_I2_J,axiom,(
    ! [Natural: code_natural] :
      ( ( code_size_natural @ ( code_Suc @ Natural ) )
      = ( plus_plus @ nat @ ( code_size_natural @ Natural ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% natural.size(2)
thf(fact_95_natural_Oinducts,axiom,(
    ! [P: ( code_natural > $o ),Natural: code_natural] :
      ( ( P @ ( zero_zero @ code_natural ) )
     => ( ! [Natural3: code_natural] :
            ( ( P @ Natural3 )
           => ( P @ ( code_Suc @ Natural3 ) ) )
       => ( P @ Natural ) ) ) )).

% natural.inducts
thf(fact_96_natural_Oexhaust,axiom,(
    ! [Y: code_natural] :
      ( ( Y
       != ( zero_zero @ code_natural ) )
     => ~ ( ! [Natural3: code_natural] :
              ( Y
             != ( code_Suc @ Natural3 ) ) ) ) )).

% natural.exhaust
thf(fact_97_natural_Odistinct_I1_J,axiom,(
    ! [Natural2: code_natural] :
      ( ( zero_zero @ code_natural )
     != ( code_Suc @ Natural2 ) ) )).

% natural.distinct(1)
thf(fact_98_natural_Odistinct_I2_J,axiom,(
    ! [Natural4: code_natural] :
      ( ( code_Suc @ Natural4 )
     != ( zero_zero @ code_natural ) ) )).

% natural.distinct(2)
thf(fact_99_size__bool__overloaded__def,axiom,
    ( ( size_size @ $o )
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_overloaded_def
thf(fact_100_semiring__normalization__rules_I20_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A,D: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D ) ) ) ) )).

% semiring_normalization_rules(20)
thf(fact_101_semiring__normalization__rules_I21_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% semiring_normalization_rules(21)
thf(fact_102_semiring__normalization__rules_I22_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C2 @ D ) )
          = ( plus_plus @ A @ C2 @ ( plus_plus @ A @ A2 @ D ) ) ) ) )).

% semiring_normalization_rules(22)
thf(fact_103_semiring__normalization__rules_I23_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) )).

% semiring_normalization_rules(23)
thf(fact_104_semiring__normalization__rules_I24_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,C3: A] :
              ( plus_plus @ A @ C3 @ A4 ) ) ) ) )).

% semiring_normalization_rules(24)
thf(fact_105_semiring__normalization__rules_I25_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C2 @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ D ) ) ) )).

% semiring_normalization_rules(25)
thf(fact_106_old_Obool_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F2: T] :
      ( ( product_rec_bool @ T @ F1 @ F2 @ $true )
      = F1 ) )).

% old.bool.simps(5)
thf(fact_107_old_Obool_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F2: T] :
      ( ( product_rec_bool @ T @ F1 @ F2 @ $false )
      = F2 ) )).

% old.bool.simps(6)
thf(fact_108_natural_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T ),Natural: code_natural] :
      ( ( code_case_natural @ T @ F1 @ F2 @ ( code_Suc @ Natural ) )
      = ( F2 @ Natural ) ) )).

% natural.simps(5)
thf(fact_109_random__aux__set_Oinduct,axiom,(
    ! [B: $tType] :
      ( ( quickcheck_random @ B @ ( type2 @ B ) )
     => ! [P: ( code_natural > code_natural > $o ),A0: code_natural,A1: code_natural] :
          ( ! [X1: code_natural] :
              ( P @ ( zero_zero @ code_natural ) @ X1 )
         => ( ! [I2: code_natural,J2: code_natural] :
                ( ! [X6: ( product_prod @ B @ ( product_unit > code_term ) )] :
                    ( P @ I2 @ J2 )
               => ( P @ ( code_Suc @ I2 ) @ J2 ) )
           => ( P @ A0 @ A1 ) ) ) ) )).

% random_aux_set.induct
thf(fact_110_random__aux__rec,axiom,(
    ! [A: $tType,Random_aux: ( code_natural > A ),Rhs: ( code_natural > A ),K: code_natural] :
      ( ( ( Random_aux @ ( zero_zero @ code_natural ) )
        = ( Rhs @ ( zero_zero @ code_natural ) ) )
     => ( ! [K2: code_natural] :
            ( ( Random_aux @ ( code_Suc @ K2 ) )
            = ( Rhs @ ( code_Suc @ K2 ) ) )
       => ( ( Random_aux @ K )
          = ( Rhs @ K ) ) ) ) )).

% random_aux_rec
thf(fact_111_natural_Osimps_I4_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T )] :
      ( ( code_case_natural @ T @ F1 @ F2 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(4)
thf(fact_112_case__natural__def,axiom,(
    ! [T: $tType] :
      ( ( code_case_natural @ T )
      = ( ^ [F12: T,F22: ( code_natural > T )] :
            ( code_rec_natural @ T @ F12
            @ ^ [X12: code_natural,X24: T] :
                ( F22 @ X12 ) ) ) ) )).

% case_natural_def
thf(fact_113_option_Osize_I3_J,axiom,(
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% option.size(3)
thf(fact_114_option_Osize_I4_J,axiom,(
    ! [A: $tType,X25: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X25 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% option.size(4)
thf(fact_115_sum_Osize_I3_J,axiom,(
    ! [A: $tType,B: $tType,X14: A] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ X14 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% sum.size(3)
thf(fact_116_sum_Osize_I4_J,axiom,(
    ! [B: $tType,A: $tType,X25: B] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A @ X25 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% sum.size(4)
thf(fact_117_typerep_Osize__neq,axiom,(
    ! [X4: typerep] :
      ( ( size_size @ typerep @ X4 )
     != ( zero_zero @ nat ) ) )).

% typerep.size_neq
thf(fact_118_option_Oinject,axiom,(
    ! [A: $tType,X25: A,Y2: A] :
      ( ( ( some @ A @ X25 )
        = ( some @ A @ Y2 ) )
      = ( X25 = Y2 ) ) )).

% option.inject
thf(fact_119_not__None__eq,axiom,(
    ! [A: $tType,X4: ( option @ A )] :
      ( ( X4
       != ( none @ A ) )
      = ( ? [Y5: A] :
            ( X4
            = ( some @ A @ Y5 ) ) ) ) )).

% not_None_eq
thf(fact_120_not__Some__eq,axiom,(
    ! [A: $tType,X4: ( option @ A )] :
      ( ( ! [Y5: A] :
            ( X4
           != ( some @ A @ Y5 ) ) )
      = ( X4
        = ( none @ A ) ) ) )).

% not_Some_eq
thf(fact_121_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X4: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X4 )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_122_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X4: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X4 )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_123_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X5: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X5 ) ) )
         => P )
     => ( ! [X5: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X5 ) ) )
           => P )
       => ! [X6: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X6 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_124_option_Odistinct_I1_J,axiom,(
    ! [A: $tType,X25: A] :
      ( ( none @ A )
     != ( some @ A @ X25 ) ) )).

% option.distinct(1)
thf(fact_125_option_OdiscI,axiom,(
    ! [A: $tType,Option: ( option @ A ),X25: A] :
      ( ( Option
        = ( some @ A @ X25 ) )
     => ( Option
       != ( none @ A ) ) ) )).

% option.discI
thf(fact_126_option_Oexhaust,axiom,(
    ! [A: $tType,Y: ( option @ A )] :
      ( ( Y
       != ( none @ A ) )
     => ~ ( ! [X2: A] :
              ( Y
             != ( some @ A @ X2 ) ) ) ) )).

% option.exhaust
thf(fact_127_option_Oinducts,axiom,(
    ! [A: $tType,P: ( ( option @ A ) > $o ),Option: ( option @ A )] :
      ( ( P @ ( none @ A ) )
     => ( ! [X5: A] :
            ( P @ ( some @ A @ X5 ) )
       => ( P @ Option ) ) ) )).

% option.inducts
thf(fact_128_split__option__ex,axiom,(
    ! [A: $tType] :
      ( ( ^ [P2: ( ( option @ A ) > $o )] :
          ? [X7: ( option @ A )] :
            ( P2 @ X7 ) )
      = ( ^ [P3: ( ( option @ A ) > $o )] :
            ( ( P3 @ ( none @ A ) )
            | ? [X: A] :
                ( P3 @ ( some @ A @ X ) ) ) ) ) )).

% split_option_ex
thf(fact_129_split__option__all,axiom,(
    ! [A: $tType] :
      ( ( ^ [P2: ( ( option @ A ) > $o )] :
          ! [X7: ( option @ A )] :
            ( P2 @ X7 ) )
      = ( ^ [P3: ( ( option @ A ) > $o )] :
            ( ( P3 @ ( none @ A ) )
            & ! [X: A] :
                ( P3 @ ( some @ A @ X ) ) ) ) ) )).

% split_option_all
thf(fact_130_combine__options__cases,axiom,(
    ! [A: $tType,B: $tType,X4: ( option @ A ),P: ( ( option @ A ) > ( option @ B ) > $o ),Y: ( option @ B )] :
      ( ( ( X4
          = ( none @ A ) )
       => ( P @ X4 @ Y ) )
     => ( ( ( Y
            = ( none @ B ) )
         => ( P @ X4 @ Y ) )
       => ( ! [A5: A,B4: B] :
              ( ( X4
                = ( some @ A @ A5 ) )
             => ( ( Y
                  = ( some @ B @ B4 ) )
               => ( P @ X4 @ Y ) ) )
         => ( P @ X4 @ Y ) ) ) ) )).

% combine_options_cases
thf(fact_131_sum_Osize__gen_I1_J,axiom,(
    ! [B: $tType,A: $tType,Xa: ( A > nat ),X4: ( B > nat ),X14: A] :
      ( ( basic_BNF_size_sum @ A @ B @ Xa @ X4 @ ( sum_Inl @ A @ B @ X14 ) )
      = ( plus_plus @ nat @ ( Xa @ X14 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% sum.size_gen(1)
thf(fact_132_sum_Osize__gen_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xa: ( A > nat ),X4: ( B > nat ),X25: B] :
      ( ( basic_BNF_size_sum @ A @ B @ Xa @ X4 @ ( sum_Inr @ B @ A @ X25 ) )
      = ( plus_plus @ nat @ ( X4 @ X25 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% sum.size_gen(2)
thf(fact_133_option_Osize__gen_I2_J,axiom,(
    ! [A: $tType,X4: ( A > nat ),X25: A] :
      ( ( size_option @ A @ X4 @ ( some @ A @ X25 ) )
      = ( plus_plus @ nat @ ( X4 @ X25 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% option.size_gen(2)
thf(fact_134_option_Osize__gen_I1_J,axiom,(
    ! [A: $tType,X4: ( A > nat )] :
      ( ( size_option @ A @ X4 @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% option.size_gen(1)
thf(fact_135_typerep_Osize_I2_J,axiom,(
    ! [X14: literal,X25: ( list @ typerep )] :
      ( ( size_size @ typerep @ ( typerep3 @ X14 @ X25 ) )
      = ( plus_plus @ nat @ ( size_list @ typerep @ ( size_size @ typerep ) @ X25 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% typerep.size(2)
thf(fact_136_tuple__isomorphism_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X4: ( tuple_isomorphism @ A @ B @ C )] :
      ( ( size_size @ ( tuple_isomorphism @ A @ B @ C ) @ X4 )
     != ( zero_zero @ nat ) ) )).

% tuple_isomorphism.size_neq
thf(fact_137_size__literal__def,axiom,
    ( ( size_size @ literal )
    = ( ^ [S2: literal] :
          ( zero_zero @ nat ) ) )).

% size_literal_def
thf(fact_138_size__unit__overloaded__def,axiom,
    ( ( size_size @ product_unit )
    = ( product_rec_unit @ nat @ ( zero_zero @ nat ) ) )).

% size_unit_overloaded_def
thf(fact_139_typerep_Osize__gen,axiom,(
    ! [X14: literal,X25: ( list @ typerep )] :
      ( ( size_typerep @ ( typerep3 @ X14 @ X25 ) )
      = ( plus_plus @ nat @ ( size_list @ typerep @ size_typerep @ X25 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% typerep.size_gen
thf(fact_140_size__unit__def,axiom,
    ( product_size_unit
    = ( product_rec_unit @ nat @ ( zero_zero @ nat ) ) )).

% size_unit_def
thf(fact_141_tuple__isomorphism_Osize_I2_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,X14: ( A > ( product_prod @ B @ C ) ),X25: ( ( product_prod @ B @ C ) > A )] :
      ( ( size_size @ ( tuple_isomorphism @ A @ B @ C ) @ ( tuple_742722141rphism @ A @ B @ C @ X14 @ X25 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% tuple_isomorphism.size(2)
thf(fact_142_unit_Osize_I2_J,axiom,
    ( ( size_size @ product_unit @ product_Unity )
    = ( zero_zero @ nat ) )).

% unit.size(2)
thf(fact_143_unit__abs__eta__conv,axiom,(
    ! [A: $tType,F: ( product_unit > A )] :
      ( ( ^ [U: product_unit] :
            ( F @ product_Unity ) )
      = F ) )).

% unit_abs_eta_conv
thf(fact_144_old_Ounit_Orec,axiom,(
    ! [T: $tType,F1: T] :
      ( ( product_rec_unit @ T @ F1 @ product_Unity )
      = F1 ) )).

% old.unit.rec
thf(fact_145_unit_Osize_I1_J,axiom,
    ( ( product_size_unit @ product_Unity )
    = ( zero_zero @ nat ) )).

% unit.size(1)
thf(fact_146_eq__sym__Unity__conv,axiom,(
    ! [X4: $o] :
      ( ( X4
        = ( product_Unity = product_Unity ) )
      = X4 ) )).

% eq_sym_Unity_conv
thf(fact_147_unit__all__impI,axiom,(
    ! [P: ( product_unit > $o ),Q: ( product_unit > $o )] :
      ( ( ( P @ product_Unity )
       => ( Q @ product_Unity ) )
     => ! [X6: product_unit] :
          ( ( P @ X6 )
         => ( Q @ X6 ) ) ) )).

% unit_all_impI
thf(fact_148_old_Ounit_Oinducts,axiom,(
    ! [P: ( product_unit > $o ),Unit: product_unit] :
      ( ( P @ product_Unity )
     => ( P @ Unit ) ) )).

% old.unit.inducts
thf(fact_149_old_Ounit_Oexhaust,axiom,(
    ! [Y: product_unit] : ( Y = product_Unity ) )).

% old.unit.exhaust
thf(fact_150_tuple__isomorphism_Osize__gen,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Xb: ( A > nat ),Xa: ( B > nat ),X4: ( C > nat ),X14: ( A > ( product_prod @ B @ C ) ),X25: ( ( product_prod @ B @ C ) > A )] :
      ( ( tuple_1907371454rphism @ A @ B @ C @ Xb @ Xa @ X4 @ ( tuple_742722141rphism @ A @ B @ C @ X14 @ X25 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% tuple_isomorphism.size_gen
thf(fact_151_default__unit__def,axiom,
    ( ( default_default @ product_unit )
    = product_Unity )).

% default_unit_def
thf(fact_152_list_Osize__gen_I2_J,axiom,(
    ! [A: $tType,X4: ( A > nat ),X21: A,X22: ( list @ A )] :
      ( ( size_list @ A @ X4 @ ( cons @ A @ X21 @ X22 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X4 @ X21 ) @ ( size_list @ A @ X4 @ X22 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% list.size_gen(2)
thf(fact_153_length__Suc__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y5: A,Ys: ( list @ A )] :
            ( ( Xs
              = ( cons @ A @ Y5 @ Ys ) )
            & ( ( size_size @ ( list @ A ) @ Ys )
              = N ) ) ) ) )).

% length_Suc_conv
thf(fact_154_Suc__length__conv,axiom,(
    ! [A: $tType,N: nat,Xs: ( list @ A )] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y5: A,Ys: ( list @ A )] :
            ( ( Xs
              = ( cons @ A @ Y5 @ Ys ) )
            & ( ( size_size @ ( list @ A ) @ Ys )
              = N ) ) ) ) )).

% Suc_length_conv
thf(fact_155_list_Osize_I4_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% list.size(4)
thf(fact_156_length__Cons,axiom,(
    ! [A: $tType,X4: A,Xs: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X4 @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) )).

% length_Cons
thf(fact_157_gen__length__code_I2_J,axiom,(
    ! [B: $tType,N: nat,X4: B,Xs: ( list @ B )] :
      ( ( gen_length @ B @ N @ ( cons @ B @ X4 @ Xs ) )
      = ( gen_length @ B @ ( suc @ N ) @ Xs ) ) )).

% gen_length_code(2)
thf(fact_158_linordered__field__class_Osign__simps_I26_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(26)
thf(fact_159_length__code,axiom,(
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( gen_length @ A @ ( zero_zero @ nat ) ) ) )).

% length_code
thf(fact_160_gen__length__def,axiom,(
    ! [A: $tType] :
      ( ( gen_length @ A )
      = ( ^ [N4: nat,Xs2: ( list @ A )] :
            ( plus_plus @ nat @ N4 @ ( size_size @ ( list @ A ) @ Xs2 ) ) ) ) )).

% gen_length_def
thf(fact_161_linordered__field__class_Osign__simps_I28_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(28)
thf(fact_162_linordered__field__class_Osign__simps_I27_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B3: A] :
              ( plus_plus @ A @ B3 @ A4 ) ) ) ) )).

% linordered_field_class.sign_simps(27)
thf(fact_163_length__splice,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs @ Ys2 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) )).

% length_splice
thf(fact_164_Shift__def,axiom,(
    ! [A: $tType] :
      ( ( bNF_Greatest_Shift @ A )
      = ( ^ [Kl: ( set @ ( list @ A ) ),K3: A] :
            ( collect @ ( list @ A )
            @ ^ [Kl2: ( list @ A )] :
                ( member @ ( list @ A ) @ ( cons @ A @ K3 @ Kl2 ) @ Kl ) ) ) ) )).

% Shift_def
thf(fact_165_is__num__normalize_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% is_num_normalize(1)
thf(fact_166_option_Ocollapse,axiom,(
    ! [A: $tType,Option: ( option @ A )] :
      ( ( Option
       != ( none @ A ) )
     => ( ( some @ A @ ( the @ A @ Option ) )
        = Option ) ) )).

% option.collapse
thf(fact_167_old_Ounit_Ocase,axiom,(
    ! [A: $tType,F: A] :
      ( ( product_case_unit @ A @ F @ product_Unity )
      = F ) )).

% old.unit.case
thf(fact_168_case__optionE,axiom,(
    ! [A: $tType,P: $o,Q: ( A > $o ),X4: ( option @ A )] :
      ( ( case_option @ $o @ A @ P @ Q @ X4 )
     => ( ( ( X4
            = ( none @ A ) )
         => ~ ( P ) )
       => ~ ( ! [Y3: A] :
                ( ( X4
                  = ( some @ A @ Y3 ) )
               => ~ ( Q @ Y3 ) ) ) ) ) )).

% case_optionE
thf(fact_169_option_Odisc__eq__case_I1_J,axiom,(
    ! [A: $tType,Option: ( option @ A )] :
      ( ( Option
        = ( none @ A ) )
      = ( case_option @ $o @ A @ $true
        @ ^ [Uu: A] : $false
        @ Option ) ) )).

% option.disc_eq_case(1)
thf(fact_170_option_Odisc__eq__case_I2_J,axiom,(
    ! [A: $tType,Option: ( option @ A )] :
      ( ( Option
       != ( none @ A ) )
      = ( case_option @ $o @ A @ $false
        @ ^ [Uu: A] : $true
        @ Option ) ) )).

% option.disc_eq_case(2)
thf(fact_171_option_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F1: B,F2: ( A > B )] :
      ( ( case_option @ B @ A @ F1 @ F2 @ ( none @ A ) )
      = F1 ) )).

% option.simps(4)
thf(fact_172_option_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F2: ( A > B ),X25: A] :
      ( ( case_option @ B @ A @ F1 @ F2 @ ( some @ A @ X25 ) )
      = ( F2 @ X25 ) ) )).

% option.simps(5)
thf(fact_173_option_Ocase__distrib,axiom,(
    ! [C: $tType,B: $tType,A: $tType,H: ( B > C ),F1: B,F2: ( A > B ),Option: ( option @ A )] :
      ( ( H @ ( case_option @ B @ A @ F1 @ F2 @ Option ) )
      = ( case_option @ C @ A @ ( H @ F1 )
        @ ^ [X: A] :
            ( H @ ( F2 @ X ) )
        @ Option ) ) )).

% option.case_distrib
thf(fact_174_option_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F2: ( A > B ),Option: ( option @ A )] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F2 @ Option ) )
      = ( ( ( Option
            = ( none @ A ) )
         => ( P @ F1 ) )
        & ( ( Option
            = ( some @ A @ ( the @ A @ Option ) ) )
         => ( P @ ( F2 @ ( the @ A @ Option ) ) ) ) ) ) )).

% option.split_sel
thf(fact_175_option_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( case_option @ B @ A )
      = ( ^ [F12: B,F22: ( A > B ),Option2: ( option @ A )] :
            ( if @ B
            @ ( Option2
              = ( none @ A ) )
            @ F12
            @ ( F22 @ ( the @ A @ Option2 ) ) ) ) ) )).

% option.case_eq_if
thf(fact_176_option_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F2: ( A > B ),Option: ( option @ A )] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F2 @ Option ) )
      = ( ~ ( ( ( Option
                = ( none @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Option
                = ( some @ A @ ( the @ A @ Option ) ) )
              & ~ ( P @ ( F2 @ ( the @ A @ Option ) ) ) ) ) ) ) )).

% option.split_sel_asm
thf(fact_177_case__unit__Unity,axiom,(
    ! [A: $tType] :
      ( ( product_case_unit @ A )
      = ( ^ [F4: A,U: product_unit] : F4 ) ) )).

% case_unit_Unity
thf(fact_178_unit_Ocase__distrib,axiom,(
    ! [A: $tType,B: $tType,H: ( A > B ),F: A,Unit: product_unit] :
      ( ( H @ ( product_case_unit @ A @ F @ Unit ) )
      = ( product_case_unit @ B @ ( H @ F ) @ Unit ) ) )).

% unit.case_distrib
thf(fact_179_option_Osel,axiom,(
    ! [A: $tType,X25: A] :
      ( ( the @ A @ ( some @ A @ X25 ) )
      = X25 ) )).

% option.sel
thf(fact_180_option_Oexpand,axiom,(
    ! [A: $tType,Option: ( option @ A ),Option3: ( option @ A )] :
      ( ( ( Option
          = ( none @ A ) )
        = ( Option3
          = ( none @ A ) ) )
     => ( ( ( Option
           != ( none @ A ) )
         => ( ( Option3
             != ( none @ A ) )
           => ( ( the @ A @ Option )
              = ( the @ A @ Option3 ) ) ) )
       => ( Option = Option3 ) ) ) )).

% option.expand
thf(fact_181_option_Oexhaust__sel,axiom,(
    ! [A: $tType,Option: ( option @ A )] :
      ( ( Option
       != ( none @ A ) )
     => ( Option
        = ( some @ A @ ( the @ A @ Option ) ) ) ) )).

% option.exhaust_sel
thf(fact_182_disjE__realizer2,axiom,(
    ! [B: $tType,A: $tType,P: $o,Q: ( A > $o ),X4: ( option @ A ),R: ( B > $o ),F: B,G: ( A > B )] :
      ( ( case_option @ $o @ A @ P @ Q @ X4 )
     => ( ( P
         => ( R @ F ) )
       => ( ! [Q2: A] :
              ( ( Q @ Q2 )
             => ( R @ ( G @ Q2 ) ) )
         => ( R @ ( case_option @ B @ A @ F @ G @ X4 ) ) ) ) ) )).

% disjE_realizer2
thf(fact_183_option_Othe__def,axiom,(
    ! [A: $tType] :
      ( ( the @ A )
      = ( case_option @ A @ A @ ( undefined @ A )
        @ ^ [X24: A] : X24 ) ) )).

% option.the_def
thf(fact_184_num_Osize_I5_J,axiom,(
    ! [X25: num] :
      ( ( size_size @ num @ ( bit0 @ X25 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X25 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% num.size(5)
thf(fact_185_num_Osize__gen_I2_J,axiom,(
    ! [X25: num] :
      ( ( size_num @ ( bit0 @ X25 ) )
      = ( plus_plus @ nat @ ( size_num @ X25 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% num.size_gen(2)
thf(fact_186_num_Osize_I6_J,axiom,(
    ! [X33: num] :
      ( ( size_size @ num @ ( bit1 @ X33 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X33 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% num.size(6)
thf(fact_187_num_Osize__gen_I3_J,axiom,(
    ! [X33: num] :
      ( ( size_num @ ( bit1 @ X33 ) )
      = ( plus_plus @ nat @ ( size_num @ X33 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% num.size_gen(3)
thf(fact_188_nat__of__num__code_I3_J,axiom,(
    ! [N: num] :
      ( ( nat_of_num @ ( bit1 @ N ) )
      = ( suc @ ( plus_plus @ nat @ ( nat_of_num @ N ) @ ( nat_of_num @ N ) ) ) ) )).

% nat_of_num_code(3)
thf(fact_189_nat__of__num_Osimps_I3_J,axiom,(
    ! [X4: num] :
      ( ( nat_of_num @ ( bit1 @ X4 ) )
      = ( suc @ ( plus_plus @ nat @ ( nat_of_num @ X4 ) @ ( nat_of_num @ X4 ) ) ) ) )).

% nat_of_num.simps(3)
thf(fact_190_nat__of__num__add,axiom,(
    ! [X4: num,Y: num] :
      ( ( nat_of_num @ ( plus_plus @ num @ X4 @ Y ) )
      = ( plus_plus @ nat @ ( nat_of_num @ X4 ) @ ( nat_of_num @ Y ) ) ) )).

% nat_of_num_add
thf(fact_191_nat__of__num__neq__0,axiom,(
    ! [X4: num] :
      ( ( nat_of_num @ X4 )
     != ( zero_zero @ nat ) ) )).

% nat_of_num_neq_0
thf(fact_192_nat__of__num_Osimps_I2_J,axiom,(
    ! [X4: num] :
      ( ( nat_of_num @ ( bit0 @ X4 ) )
      = ( plus_plus @ nat @ ( nat_of_num @ X4 ) @ ( nat_of_num @ X4 ) ) ) )).

% nat_of_num.simps(2)
thf(fact_193_nat__of__num__code_I2_J,axiom,(
    ! [N: num] :
      ( ( nat_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ nat @ ( nat_of_num @ N ) @ ( nat_of_num @ N ) ) ) )).

% nat_of_num_code(2)
thf(fact_194_nat__of__num__inc,axiom,(
    ! [X4: num] :
      ( ( nat_of_num @ ( inc @ X4 ) )
      = ( suc @ ( nat_of_num @ X4 ) ) ) )).

% nat_of_num_inc
thf(fact_195_nat__of__num_Osimps_I1_J,axiom,
    ( ( nat_of_num @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) )).

% nat_of_num.simps(1)
thf(fact_196_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) )).

% num.size_gen(1)
thf(fact_197_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) )).

% num.size(4)
thf(fact_198_add__2__eq__Suc,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) )).

% add_2_eq_Suc
thf(fact_199_add__2__eq__Suc_H,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) )).

% add_2_eq_Suc'
thf(fact_200_numeral__plus__numeral,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) )).

% numeral_plus_numeral
thf(fact_201_add__numeral__left,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) )).

% add_numeral_left
thf(fact_202_Suc__numeral,axiom,(
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) )).

% Suc_numeral
thf(fact_203_numeral__Bit0,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) )).

% numeral_Bit0
thf(fact_204_numeral__code_I2_J,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) )).

% numeral_code(2)
thf(fact_205_zero__neq__numeral,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) )).

% zero_neq_numeral
thf(fact_206_eval__nat__numeral_I3_J,axiom,(
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) )).

% eval_nat_numeral(3)
thf(fact_207_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) )).

% numeral_1_eq_Suc_0
thf(fact_208_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) )).

% numeral_2_eq_2
thf(fact_209_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% numeral_3_eq_3
thf(fact_210_Suc3__eq__add__3,axiom,(
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) )).

% Suc3_eq_add_3
thf(fact_211_Suc__nat__number__of__add,axiom,(
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) )).

% Suc_nat_number_of_add
thf(fact_212_zero__not__eq__two,axiom,(
    ! [A: $tType] :
      ( ( semiring_div_parity @ A @ ( type2 @ A ) )
     => ( ( zero_zero @ A )
       != ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )).

% zero_not_eq_two
thf(fact_213_one__plus__numeral,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) )).

% one_plus_numeral
thf(fact_214_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )).

% Suc_1
thf(fact_215_one__add__one,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )).

% one_add_one
thf(fact_216_numeral__plus__one,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) )).

% numeral_plus_one
thf(fact_217_one__plus__numeral__commute,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [X4: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X4 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X4 ) @ ( one_one @ A ) ) ) ) )).

% one_plus_numeral_commute
thf(fact_218_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) )).

% One_nat_def
thf(fact_219_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type2 @ A ) )
     => ! [X4: A] :
          ( ( ( one_one @ A )
            = X4 )
          = ( X4
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_220_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N4: nat] :
          ( plus_plus @ nat @ N4 @ ( one_one @ nat ) ) ) )).

% Suc_eq_plus1
thf(fact_221_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) )).

% Suc_eq_plus1_left
thf(fact_222_numeral__Bit1,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) )).

% numeral_Bit1
thf(fact_223_numeral__inc,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [X4: num] :
          ( ( numeral_numeral @ A @ ( inc @ X4 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X4 ) @ ( one_one @ A ) ) ) ) )).

% numeral_inc
thf(fact_224_numeral__code_I3_J,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) )).

% numeral_code(3)
thf(fact_225_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )).

% nat_1_add_1
thf(fact_226_zero__neq__one,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) )).

% zero_neq_one
thf(fact_227_dbl__inc__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) )).

% dbl_inc_simps(2)
thf(fact_228_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) )).

% one_natural.rsp
thf(fact_229_dbl__inc__def,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ X @ X ) @ ( one_one @ A ) ) ) ) ) )).

% dbl_inc_def
thf(fact_230_Suc__div__eq__add3__div__numeral,axiom,(
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) )).

% Suc_div_eq_add3_div_numeral
thf(fact_231_div__Suc__eq__div__add3,axiom,(
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) )).

% div_Suc_eq_div_add3
thf(fact_232_divide__zero,axiom,(
    ! [A: $tType] :
      ( ( semidom_divide @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% divide_zero
thf(fact_233_divide__zero__left,axiom,(
    ! [A: $tType] :
      ( ( semidom_divide @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% divide_zero_left
thf(fact_234_divide__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) )).

% divide_eq_0_iff
thf(fact_235_divide__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( field @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) )).

% divide_cancel_left
thf(fact_236_divide__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( field @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) )).

% divide_cancel_right
thf(fact_237_division__ring__divide__zero,axiom,(
    ! [A: $tType] :
      ( ( division_ring @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% division_ring_divide_zero
thf(fact_238_div__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_div @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% div_0
thf(fact_239_div__by__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_div @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% div_by_0
thf(fact_240_div__self,axiom,(
    ! [A: $tType] :
      ( ( semidom_divide @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) )).

% div_self
thf(fact_241_divide__eq__1__iff,axiom,(
    ! [A: $tType] :
      ( ( field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) )).

% divide_eq_1_iff
thf(fact_242_one__eq__divide__iff,axiom,(
    ! [A: $tType] :
      ( ( field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) )).

% one_eq_divide_iff
thf(fact_243_divide__self,axiom,(
    ! [A: $tType] :
      ( ( division_ring @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) )).

% divide_self
thf(fact_244_divide__self__if,axiom,(
    ! [A: $tType] :
      ( ( division_ring @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) )).

% divide_self_if
thf(fact_245_divide__eq__eq__1,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) )).

% divide_eq_eq_1
thf(fact_246_eq__divide__eq__1,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) )).

% eq_divide_eq_1
thf(fact_247_one__divide__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% one_divide_eq_0_iff
thf(fact_248_zero__eq__1__divide__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% zero_eq_1_divide_iff
thf(fact_249_div__1,axiom,(
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) )).

% div_1
thf(fact_250_div__add__self2,axiom,(
    ! [A: $tType] :
      ( ( semiring_div @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) )).

% div_add_self2

%----Type constructors (115)
thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Code__Evaluation_Oterm__of,axiom,
    ( code_term_of @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___HOL_Oequal,axiom,
    ( cl_HOL_Oequal @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_Record_Otuple__isomorphism___Code__Evaluation_Oterm__of_1,axiom,(
    ! [A6: $tType,A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) @ ( type2 @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___HOL_Oequal_2,axiom,(
    ! [A6: $tType,A7: $tType,A8: $tType] :
      ( cl_HOL_Oequal @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) @ ( type2 @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) ) ) )).

thf(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_3,axiom,
    ( code_term_of @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___HOL_Oequal_4,axiom,
    ( cl_HOL_Oequal @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_5,axiom,
    ( code_term_of @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Evaluation_Oterm___HOL_Oequal_6,axiom,
    ( cl_HOL_Oequal @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_7,axiom,
    ( code_term_of @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___HOL_Oequal_8,axiom,
    ( cl_HOL_Oequal @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_9,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) ) )
     => ( code_term_of @ ( product_prod @ A6 @ A7 ) @ ( type2 @ ( product_prod @ A6 @ A7 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___HOL_Oequal_10,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( cl_HOL_Oequal @ ( product_prod @ A6 @ A7 ) @ ( type2 @ ( product_prod @ A6 @ A7 ) ) ) )).

thf(tcon_Typerep_Otyperep___Code__Evaluation_Oterm__of_11,axiom,
    ( code_term_of @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Typerep_Otyperep___HOL_Oequal_12,axiom,
    ( cl_HOL_Oequal @ typerep @ ( type2 @ typerep ) )).

thf(tcon_String_Oliteral___Code__Evaluation_Oterm__of_13,axiom,
    ( code_term_of @ literal @ ( type2 @ literal ) )).

thf(tcon_String_Oliteral___HOL_Oequal_14,axiom,
    ( cl_HOL_Oequal @ literal @ ( type2 @ literal ) )).

thf(tcon_Simpl__Heap_Oref___Code__Evaluation_Oterm__of_15,axiom,
    ( code_term_of @ simpl_ref @ ( type2 @ simpl_ref ) )).

thf(tcon_Option_Ooption___Code__Evaluation_Oterm__of_16,axiom,(
    ! [A6: $tType] :
      ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
     => ( code_term_of @ ( option @ A6 ) @ ( type2 @ ( option @ A6 ) ) ) ) )).

thf(tcon_Option_Ooption___HOL_Oequal_17,axiom,(
    ! [A6: $tType] :
      ( cl_HOL_Oequal @ ( option @ A6 ) @ ( type2 @ ( option @ A6 ) ) ) )).

thf(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_18,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) ) )
     => ( code_term_of @ ( sum_sum @ A6 @ A7 ) @ ( type2 @ ( sum_sum @ A6 @ A7 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___HOL_Oequal_19,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( cl_HOL_Oequal @ ( sum_sum @ A6 @ A7 ) @ ( type2 @ ( sum_sum @ A6 @ A7 ) ) ) )).

thf(tcon_List_Olist___Code__Evaluation_Oterm__of_20,axiom,(
    ! [A6: $tType] :
      ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
     => ( code_term_of @ ( list @ A6 ) @ ( type2 @ ( list @ A6 ) ) ) ) )).

thf(tcon_List_Olist___HOL_Oequal_21,axiom,(
    ! [A6: $tType] :
      ( cl_HOL_Oequal @ ( list @ A6 ) @ ( type2 @ ( list @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Code__Evaluation_Oterm__of_22,axiom,
    ( code_term_of @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___HOL_Oequal_23,axiom,
    ( cl_HOL_Oequal @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Code__Evaluation_Oterm__of_24,axiom,(
    ! [A6: $tType] :
      ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
     => ( code_term_of @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_Set_Oset___HOL_Oequal_25,axiom,(
    ! [A6: $tType] :
      ( ( cl_HOL_Oequal @ A6 @ ( type2 @ A6 ) )
     => ( cl_HOL_Oequal @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_Num_Onum___Code__Evaluation_Oterm__of_26,axiom,
    ( code_term_of @ num @ ( type2 @ num ) )).

thf(tcon_Num_Onum___HOL_Oequal_27,axiom,
    ( cl_HOL_Oequal @ num @ ( type2 @ num ) )).

thf(tcon_Nat_Onat___Code__Evaluation_Oterm__of_28,axiom,
    ( code_term_of @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___HOL_Oequal_29,axiom,
    ( cl_HOL_Oequal @ nat @ ( type2 @ nat ) )).

thf(tcon_fun___Code__Evaluation_Oterm__of_30,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) ) )
     => ( code_term_of @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___HOL_Oequal_31,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( enum @ A6 @ ( type2 @ A6 ) )
        & ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) ) )
     => ( cl_HOL_Oequal @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Typerep_Otyperep,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) ) )
     => ( typerep2 @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Enum_Oenum,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( enum @ A6 @ ( type2 @ A6 ) )
        & ( enum @ A7 @ ( type2 @ A7 ) ) )
     => ( enum @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Typerep_Otyperep_32,axiom,
    ( typerep2 @ nat @ ( type2 @ nat ) )).

thf(tcon_Num_Onum___Typerep_Otyperep_33,axiom,
    ( typerep2 @ num @ ( type2 @ num ) )).

thf(tcon_Set_Oset___Typerep_Otyperep_34,axiom,(
    ! [A6: $tType] :
      ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
     => ( typerep2 @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_Set_Oset___Enum_Oenum_35,axiom,(
    ! [A6: $tType] :
      ( ( enum @ A6 @ ( type2 @ A6 ) )
     => ( enum @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_HOL_Obool___Typerep_Otyperep_36,axiom,
    ( typerep2 @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Enum_Oenum_37,axiom,
    ( enum @ $o @ ( type2 @ $o ) )).

thf(tcon_List_Olist___Typerep_Otyperep_38,axiom,(
    ! [A6: $tType] :
      ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
     => ( typerep2 @ ( list @ A6 ) @ ( type2 @ ( list @ A6 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Typerep_Otyperep_39,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) ) )
     => ( typerep2 @ ( sum_sum @ A6 @ A7 ) @ ( type2 @ ( sum_sum @ A6 @ A7 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Enum_Oenum_40,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( enum @ A6 @ ( type2 @ A6 ) )
        & ( enum @ A7 @ ( type2 @ A7 ) ) )
     => ( enum @ ( sum_sum @ A6 @ A7 ) @ ( type2 @ ( sum_sum @ A6 @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___Typerep_Otyperep_41,axiom,(
    ! [A6: $tType] :
      ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
     => ( typerep2 @ ( option @ A6 ) @ ( type2 @ ( option @ A6 ) ) ) ) )).

thf(tcon_Option_Ooption___Enum_Oenum_42,axiom,(
    ! [A6: $tType] :
      ( ( enum @ A6 @ ( type2 @ A6 ) )
     => ( enum @ ( option @ A6 ) @ ( type2 @ ( option @ A6 ) ) ) ) )).

thf(tcon_Simpl__Heap_Oref___Typerep_Otyperep_43,axiom,
    ( typerep2 @ simpl_ref @ ( type2 @ simpl_ref ) )).

thf(tcon_String_Oliteral___Typerep_Otyperep_44,axiom,
    ( typerep2 @ literal @ ( type2 @ literal ) )).

thf(tcon_Typerep_Otyperep___Typerep_Otyperep_45,axiom,
    ( typerep2 @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Product__Type_Oprod___Typerep_Otyperep_46,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) ) )
     => ( typerep2 @ ( product_prod @ A6 @ A7 ) @ ( type2 @ ( product_prod @ A6 @ A7 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Enum_Oenum_47,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( enum @ A6 @ ( type2 @ A6 ) )
        & ( enum @ A7 @ ( type2 @ A7 ) ) )
     => ( enum @ ( product_prod @ A6 @ A7 ) @ ( type2 @ ( product_prod @ A6 @ A7 ) ) ) ) )).

thf(tcon_Product__Type_Ounit___Typerep_Otyperep_48,axiom,
    ( typerep2 @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Enum_Oenum_49,axiom,
    ( enum @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_50,axiom,
    ( typerep2 @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Numeral_Onatural___Typerep_Otyperep_51,axiom,
    ( typerep2 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Record_Otuple__isomorphism___Typerep_Otyperep_52,axiom,(
    ! [A6: $tType,A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A6 @ ( type2 @ A6 ) )
        & ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) @ ( type2 @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) ) ) ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Typerep_Otyperep_53,axiom,
    ( typerep2 @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_fun___Quickcheck__Random_Orandom,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( code_term_of @ A6 @ ( type2 @ A6 ) )
        & ( cl_HOL_Oequal @ A6 @ ( type2 @ A6 ) )
        & ( quickcheck_random @ A7 @ ( type2 @ A7 ) ) )
     => ( quickcheck_random @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    ( semiri456707255roduct @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Divides_Osemiring__div__parity,axiom,
    ( semiring_div_parity @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Quickcheck__Random_Orandom_54,axiom,
    ( quickcheck_random @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add,axiom,
    ( comm_monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1,axiom,
    ( comm_semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemidom__divide,axiom,
    ( semidom_divide @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Divides_Osemiring__div,axiom,
    ( semiring_div @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0,axiom,
    ( semiring_char_0 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one,axiom,
    ( zero_neq_one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add,axiom,
    ( monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Num_Onumeral,axiom,
    ( numeral @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oone,axiom,
    ( one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    ( size @ nat @ ( type2 @ nat ) )).

thf(tcon_Num_Onum___Quickcheck__Random_Orandom_55,axiom,
    ( quickcheck_random @ num @ ( type2 @ num ) )).

thf(tcon_Num_Onum___Nat_Osize_56,axiom,
    ( size @ num @ ( type2 @ num ) )).

thf(tcon_Set_Oset___Quickcheck__Random_Orandom_57,axiom,(
    ! [A6: $tType] :
      ( ( quickcheck_random @ A6 @ ( type2 @ A6 ) )
     => ( quickcheck_random @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_HOL_Obool___Quickcheck__Random_Orandom_58,axiom,
    ( quickcheck_random @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Nat_Osize_59,axiom,
    ( size @ $o @ ( type2 @ $o ) )).

thf(tcon_List_Olist___Quickcheck__Random_Orandom_60,axiom,(
    ! [A6: $tType] :
      ( ( quickcheck_random @ A6 @ ( type2 @ A6 ) )
     => ( quickcheck_random @ ( list @ A6 ) @ ( type2 @ ( list @ A6 ) ) ) ) )).

thf(tcon_List_Olist___Nat_Osize_61,axiom,(
    ! [A6: $tType] :
      ( size @ ( list @ A6 ) @ ( type2 @ ( list @ A6 ) ) ) )).

thf(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_62,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( quickcheck_random @ A6 @ ( type2 @ A6 ) )
        & ( quickcheck_random @ A7 @ ( type2 @ A7 ) ) )
     => ( quickcheck_random @ ( sum_sum @ A6 @ A7 ) @ ( type2 @ ( sum_sum @ A6 @ A7 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Nat_Osize_63,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( size @ ( sum_sum @ A6 @ A7 ) @ ( type2 @ ( sum_sum @ A6 @ A7 ) ) ) )).

thf(tcon_Option_Ooption___Quickcheck__Random_Orandom_64,axiom,(
    ! [A6: $tType] :
      ( ( quickcheck_random @ A6 @ ( type2 @ A6 ) )
     => ( quickcheck_random @ ( option @ A6 ) @ ( type2 @ ( option @ A6 ) ) ) ) )).

thf(tcon_Option_Ooption___Nat_Osize_65,axiom,(
    ! [A6: $tType] :
      ( size @ ( option @ A6 ) @ ( type2 @ ( option @ A6 ) ) ) )).

thf(tcon_String_Oliteral___Quickcheck__Random_Orandom_66,axiom,
    ( quickcheck_random @ literal @ ( type2 @ literal ) )).

thf(tcon_String_Oliteral___Nat_Osize_67,axiom,
    ( size @ literal @ ( type2 @ literal ) )).

thf(tcon_Typerep_Otyperep___Nat_Osize_68,axiom,
    ( size @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_69,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( quickcheck_random @ A6 @ ( type2 @ A6 ) )
        & ( quickcheck_random @ A7 @ ( type2 @ A7 ) ) )
     => ( quickcheck_random @ ( product_prod @ A6 @ A7 ) @ ( type2 @ ( product_prod @ A6 @ A7 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Nat_Osize_70,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( size @ ( product_prod @ A6 @ A7 ) @ ( type2 @ ( product_prod @ A6 @ A7 ) ) ) )).

thf(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_71,axiom,
    ( quickcheck_random @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Nat_Osize_72,axiom,
    ( size @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_73,axiom,
    ( ordere779506340up_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_74,axiom,
    ( cancel1352612707id_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_75,axiom,
    ( cancel_semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_76,axiom,
    ( quickcheck_random @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_77,axiom,
    ( ab_semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_78,axiom,
    ( comm_monoid_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_79,axiom,
    ( comm_semiring_1 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_80,axiom,
    ( semidom_divide @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_81,axiom,
    ( semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Divides_Osemiring__div_82,axiom,
    ( semiring_div @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_83,axiom,
    ( zero_neq_one @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_84,axiom,
    ( monoid_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Num_Onumeral_85,axiom,
    ( numeral @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_86,axiom,
    ( zero @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oone_87,axiom,
    ( one @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Nat_Osize_88,axiom,
    ( size @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Record_Otuple__isomorphism___Quickcheck__Random_Orandom_89,axiom,(
    ! [A6: $tType,A7: $tType,A8: $tType] :
      ( ( ( code_term_of @ A6 @ ( type2 @ A6 ) )
        & ( cl_HOL_Oequal @ A6 @ ( type2 @ A6 ) )
        & ( quickcheck_random @ A6 @ ( type2 @ A6 ) )
        & ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) @ ( type2 @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___Nat_Osize_90,axiom,(
    ! [A6: $tType,A7: $tType,A8: $tType] :
      ( size @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) @ ( type2 @ ( tuple_isomorphism @ A6 @ A7 @ A8 ) ) ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Nat_Osize_91,axiom,
    ( size @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X4: A,Y: A] :
      ( ( if @ A @ $false @ X4 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X4: A,Y: A] :
      ( ( if @ A @ $true @ X4 @ Y )
      = X4 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ( binDag476092410e_Node @ lt @ a @ rt )
 != lt )).

%------------------------------------------------------------------------------
