%------------------------------------------------------------------------------
% File     : COM167^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Binary decision diagram 250
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [OS08]  Ortner & Schirmer (2008), BDD Normalisation
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : bindag__250.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  353 (   0 unit;  59 type;   0 defn)
%            Number of atoms       : 4166 ( 290 equality;2484 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 3553 (  95   ~;  30   |;  63   &;3042   @)
%                                         (   0 <=>; 323  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  312 ( 312   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   63 (  59   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1079 (   2 sgn; 900   !;  50   ?;  81   ^)
%                                         (1079   :;  48  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:45:46.829
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_BinDag__Mirabelle__rybootvolr_Odag,type,(
    binDag_Mirabelle_dag: $tType )).

thf(ty_t_Simpl__Heap_Oref,type,(
    simpl_ref: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (55)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,(
    condit1656338222tinuum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_ODAG,type,(
    binDag_Mirabelle_DAG: binDag_Mirabelle_dag > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_ODag,type,(
    binDag_Mirabelle_Dag: simpl_ref > ( simpl_ref > simpl_ref ) > ( simpl_ref > simpl_ref ) > binDag_Mirabelle_dag > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_ONode,type,(
    binDag476092410e_Node: binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_OTip,type,(
    binDag_Mirabelle_Tip: binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Ocase__dag,type,(
    binDag1297733282se_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Orec__dag,type,(
    binDag1442713106ec_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Oset__of,type,(
    binDag1380252983set_of: binDag_Mirabelle_dag > ( set @ simpl_ref ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Osubdag,type,(
    binDag786255756subdag: binDag_Mirabelle_dag > binDag_Mirabelle_dag > $o )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_Fun_Ooverride__on,type,(
    override_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) )).

thf(sy_c_Groups_Ocomm__monoid,type,(
    comm_monoid: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Groups_Omonoid,type,(
    monoid: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Osemilattice__neutr,type,(
    semilattice_neutr: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Oinv__imagep,type,(
    inv_imagep: 
      !>[B: $tType,A: $tType] :
        ( ( B > B > $o ) > ( A > B ) > A > A > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_OPow,type,(
    pow: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( set @ A ) ) ) )).

thf(sy_c_Set_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ B ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Simpl__Heap_ONull,type,(
    simpl_Null: simpl_ref )).

thf(sy_c_Zorn_Opred__on_Ochain,type,(
    pred_chain: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Zorn_Opred__on_Omaxchain,type,(
    pred_maxchain: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_l,type,(
    l: simpl_ref > simpl_ref )).

thf(sy_v_p,type,(
    p: simpl_ref )).

thf(sy_v_r,type,(
    r: simpl_ref > simpl_ref )).

thf(sy_v_t,type,(
    t: binDag_Mirabelle_dag )).

%----Relevant facts (256)
thf(fact_0_Dag__Null,axiom,(
    ! [L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ simpl_Null @ L @ R @ T )
      = ( T = binDag_Mirabelle_Tip ) ) )).

% Dag_Null
thf(fact_1_Dag_Osimps_I1_J,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ binDag_Mirabelle_Tip )
      = ( P = simpl_Null ) ) )).

% Dag.simps(1)
thf(fact_2_Dag__upd__same__l__lemma,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ~ ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ P @ P ) @ R @ T ) ) )).

% Dag_upd_same_l_lemma
thf(fact_3_fun__upd__upd,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X: A,Y: B,Z: B] :
      ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F @ X @ Y ) @ X @ Z )
      = ( fun_upd @ A @ B @ F @ X @ Z ) ) )).

% fun_upd_upd
thf(fact_4_fun__upd__triv,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X: A] :
      ( ( fun_upd @ A @ B @ F @ X @ ( F @ X ) )
      = F ) )).

% fun_upd_triv
thf(fact_5_fun__upd__apply,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( fun_upd @ B @ A )
      = ( ^ [F2: ( B > A ),X2: B,Y2: A,Z2: B] :
            ( if @ A @ ( Z2 = X2 ) @ Y2 @ ( F2 @ Z2 ) ) ) ) )).

% fun_upd_apply
thf(fact_6_notin__Dag__update__l,axiom,(
    ! [Q: simpl_ref,T: binDag_Mirabelle_dag,P: simpl_ref,L: ( simpl_ref > simpl_ref ),Y: simpl_ref,R: ( simpl_ref > simpl_ref )] :
      ( ~ ( member @ simpl_ref @ Q @ ( binDag1380252983set_of @ T ) )
     => ( ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ Q @ Y ) @ R @ T )
        = ( binDag_Mirabelle_Dag @ P @ L @ R @ T ) ) ) )).

% notin_Dag_update_l
thf(fact_7_notin__Dag__update__r,axiom,(
    ! [Q: simpl_ref,T: binDag_Mirabelle_dag,P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),Y: simpl_ref] :
      ( ~ ( member @ simpl_ref @ Q @ ( binDag1380252983set_of @ T ) )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ Q @ Y ) @ T )
        = ( binDag_Mirabelle_Dag @ P @ L @ R @ T ) ) ) )).

% notin_Dag_update_r
thf(fact_8_Null__notin__Dag,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T )
     => ~ ( member @ simpl_ref @ simpl_Null @ ( binDag1380252983set_of @ T ) ) ) )).

% Null_notin_Dag
thf(fact_9_Dag__Ref,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T )
        = ( ? [Lt: binDag_Mirabelle_dag,Rt: binDag_Mirabelle_dag] :
              ( ( T
                = ( binDag476092410e_Node @ Lt @ P @ Rt ) )
              & ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ Lt )
              & ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ Rt ) ) ) ) ) )).

% Dag_Ref
thf(fact_10_Dag_Osimps_I2_J,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),Lt2: binDag_Mirabelle_dag,A2: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ ( binDag476092410e_Node @ Lt2 @ A2 @ Rt2 ) )
      = ( ( P = A2 )
        & ( P != simpl_Null )
        & ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ Lt2 )
        & ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ Rt2 ) ) ) )).

% Dag.simps(2)
thf(fact_11_fun__upd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_upd @ A @ B )
      = ( ^ [F2: ( A > B ),A3: A,B2: B,X2: A] :
            ( if @ B @ ( X2 = A3 ) @ B2 @ ( F2 @ X2 ) ) ) ) )).

% fun_upd_def
thf(fact_12_fun__upd__eqD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X: A,Y: B,G: ( A > B ),Z: B] :
      ( ( ( fun_upd @ A @ B @ F @ X @ Y )
        = ( fun_upd @ A @ B @ G @ X @ Z ) )
     => ( Y = Z ) ) )).

% fun_upd_eqD
thf(fact_13_fun__upd__idem,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X: B,Y: A] :
      ( ( ( F @ X )
        = Y )
     => ( ( fun_upd @ B @ A @ F @ X @ Y )
        = F ) ) )).

% fun_upd_idem
thf(fact_14_fun__upd__same,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),X: B,Y: A] :
      ( ( fun_upd @ B @ A @ F @ X @ Y @ X )
      = Y ) )).

% fun_upd_same
thf(fact_15_dag_Oinject,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag,Y21: binDag_Mirabelle_dag,Y22: simpl_ref,Y23: binDag_Mirabelle_dag] :
      ( ( ( binDag476092410e_Node @ X21 @ X22 @ X23 )
        = ( binDag476092410e_Node @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% dag.inject
thf(fact_16_dag_Oexhaust,axiom,(
    ! [Y: binDag_Mirabelle_dag] :
      ( ( Y != binDag_Mirabelle_Tip )
     => ~ ( ! [X212: binDag_Mirabelle_dag,X222: simpl_ref,X232: binDag_Mirabelle_dag] :
              ( Y
             != ( binDag476092410e_Node @ X212 @ X222 @ X232 ) ) ) ) )).

% dag.exhaust
thf(fact_17_dag_Oinduct,axiom,(
    ! [P2: ( binDag_Mirabelle_dag > $o ),Dag: binDag_Mirabelle_dag] :
      ( ( P2 @ binDag_Mirabelle_Tip )
     => ( ! [X1: binDag_Mirabelle_dag,X24: simpl_ref,X3: binDag_Mirabelle_dag] :
            ( ( P2 @ X1 )
           => ( ( P2 @ X3 )
             => ( P2 @ ( binDag476092410e_Node @ X1 @ X24 @ X3 ) ) ) )
       => ( P2 @ Dag ) ) ) )).

% dag.induct
thf(fact_18_dag_Odistinct_I1_J,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( binDag_Mirabelle_Tip
     != ( binDag476092410e_Node @ X21 @ X22 @ X23 ) ) )).

% dag.distinct(1)
thf(fact_19_fun__upd__idem__iff,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X: A,Y: B] :
      ( ( ( fun_upd @ A @ B @ F @ X @ Y )
        = F )
      = ( ( F @ X )
        = Y ) ) )).

% fun_upd_idem_iff
thf(fact_20_fun__upd__twist,axiom,(
    ! [A: $tType,B: $tType,A2: A,C: A,M: ( A > B ),B3: B,D: B] :
      ( ( A2 != C )
     => ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M @ A2 @ B3 ) @ C @ D )
        = ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M @ C @ D ) @ A2 @ B3 ) ) ) )).

% fun_upd_twist
thf(fact_21_fun__upd__other,axiom,(
    ! [B: $tType,A: $tType,Z: A,X: A,F: ( A > B ),Y: B] :
      ( ( Z != X )
     => ( ( fun_upd @ A @ B @ F @ X @ Y @ Z )
        = ( F @ Z ) ) ) )).

% fun_upd_other
thf(fact_22_DAG_Osimps_I2_J,axiom,(
    ! [L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_DAG @ ( binDag476092410e_Node @ L @ A2 @ R ) )
      = ( ~ ( member @ simpl_ref @ A2 @ ( binDag1380252983set_of @ L ) )
        & ~ ( member @ simpl_ref @ A2 @ ( binDag1380252983set_of @ R ) )
        & ( binDag_Mirabelle_DAG @ L )
        & ( binDag_Mirabelle_DAG @ R ) ) ) )).

% DAG.simps(2)
thf(fact_23_in__set__of__decomp,axiom,(
    ! [P: simpl_ref,T: binDag_Mirabelle_dag] :
      ( ( member @ simpl_ref @ P @ ( binDag1380252983set_of @ T ) )
      = ( ? [L2: binDag_Mirabelle_dag,R2: binDag_Mirabelle_dag] :
            ( ( T
              = ( binDag476092410e_Node @ L2 @ P @ R2 ) )
            | ( binDag786255756subdag @ T @ ( binDag476092410e_Node @ L2 @ P @ R2 ) ) ) ) ) )).

% in_set_of_decomp
thf(fact_24_dag_Osimps_I4_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A )] :
      ( ( binDag1297733282se_dag @ A @ F1 @ F22 @ binDag_Mirabelle_Tip )
      = F1 ) )).

% dag.simps(4)
thf(fact_25_dag_Osimps_I6_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A )] :
      ( ( binDag1442713106ec_dag @ A @ F1 @ F22 @ binDag_Mirabelle_Tip )
      = F1 ) )).

% dag.simps(6)
thf(fact_26_DAG_Osimps_I1_J,axiom,
    ( binDag_Mirabelle_DAG @ binDag_Mirabelle_Tip )).

% DAG.simps(1)
thf(fact_27_dag_Osimps_I7_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ),X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1442713106ec_dag @ A @ F1 @ F22 @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( F22 @ X21 @ X22 @ X23 @ ( binDag1442713106ec_dag @ A @ F1 @ F22 @ X21 ) @ ( binDag1442713106ec_dag @ A @ F1 @ F22 @ X23 ) ) ) )).

% dag.simps(7)
thf(fact_28_dag_Osimps_I5_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ),X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1297733282se_dag @ A @ F1 @ F22 @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( F22 @ X21 @ X22 @ X23 ) ) )).

% dag.simps(5)
thf(fact_29_set__of__Tip,axiom,
    ( ( binDag1380252983set_of @ binDag_Mirabelle_Tip )
    = ( bot_bot @ ( set @ simpl_ref ) ) )).

% set_of_Tip
thf(fact_30_subdag_Osimps_I1_J,axiom,(
    ! [T: binDag_Mirabelle_dag] :
      ~ ( binDag786255756subdag @ binDag_Mirabelle_Tip @ T ) )).

% subdag.simps(1)
thf(fact_31_subdag_Osimps_I2_J,axiom,(
    ! [L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag,T: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ ( binDag476092410e_Node @ L @ A2 @ R ) @ T )
      = ( ( T = L )
        | ( T = R )
        | ( binDag786255756subdag @ L @ T )
        | ( binDag786255756subdag @ R @ T ) ) ) )).

% subdag.simps(2)
thf(fact_32_subdag__not__sym,axiom,(
    ! [S: binDag_Mirabelle_dag,T: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ S @ T )
     => ~ ( binDag786255756subdag @ T @ S ) ) )).

% subdag_not_sym
thf(fact_33_subdag__trans,axiom,(
    ! [T: binDag_Mirabelle_dag,S: binDag_Mirabelle_dag,R: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T @ S )
     => ( ( binDag786255756subdag @ S @ R )
       => ( binDag786255756subdag @ T @ R ) ) ) )).

% subdag_trans
thf(fact_34_subdag__neq,axiom,(
    ! [T: binDag_Mirabelle_dag,S: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T @ S )
     => ( T != S ) ) )).

% subdag_neq
thf(fact_35_subdag__NodeD,axiom,(
    ! [T: binDag_Mirabelle_dag,Lt2: binDag_Mirabelle_dag,A2: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T @ ( binDag476092410e_Node @ Lt2 @ A2 @ Rt2 ) )
     => ( ( binDag786255756subdag @ T @ Lt2 )
        & ( binDag786255756subdag @ T @ Rt2 ) ) ) )).

% subdag_NodeD
thf(fact_36_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X2: A] :
            ~ ( P2 @ X2 ) ) ) )).

% empty_Collect_eq
thf(fact_37_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P2 @ X2 ) ) ) )).

% Collect_empty_eq
thf(fact_38_all__not__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ! [X2: A] :
            ~ ( member @ A @ X2 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_39_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_40_bot__apply,axiom,(
    ! [C2: $tType,D2: $tType] :
      ( ( bot @ C2 @ ( type2 @ C2 ) )
     => ( ( bot_bot @ ( D2 > C2 ) )
        = ( ^ [X2: D2] :
              ( bot_bot @ C2 ) ) ) ) )).

% bot_apply
thf(fact_41_override__on__emptyset,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ( override_on @ A @ B @ F @ G @ ( bot_bot @ ( set @ A ) ) )
      = F ) )).

% override_on_emptyset
thf(fact_42_ex__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ? [X2: A] :
            ( member @ A @ X2 @ A4 ) )
      = ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_43_equals0I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A4 )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_44_equals0D,axiom,(
    ! [A: $tType,A4: ( set @ A ),A2: A] :
      ( ( A4
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A4 ) ) )).

% equals0D
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P2 @ X4 )
          = ( Q2 @ X4 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q2 ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_override__on__apply__in,axiom,(
    ! [B: $tType,A: $tType,A2: A,A4: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( member @ A @ A2 @ A4 )
     => ( ( override_on @ A @ B @ F @ G @ A4 @ A2 )
        = ( G @ A2 ) ) ) )).

% override_on_apply_in
thf(fact_50_override__on__apply__notin,axiom,(
    ! [B: $tType,A: $tType,A2: A,A4: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ~ ( member @ A @ A2 @ A4 )
     => ( ( override_on @ A @ B @ F @ G @ A4 @ A2 )
        = ( F @ A2 ) ) ) )).

% override_on_apply_notin
thf(fact_51_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_52_override__on__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( override_on @ A @ B )
      = ( ^ [F2: ( A > B ),G2: ( A > B ),A5: ( set @ A ),A3: A] :
            ( if @ B @ ( member @ A @ A3 @ A5 ) @ ( G2 @ A3 ) @ ( F2 @ A3 ) ) ) ) )).

% override_on_def
thf(fact_53_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X2: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_54_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_55_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A5: ( set @ A )] :
            ( A5
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_56_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P2
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_57_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_58_is__singletonI_H,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X4: A,Y3: A] :
            ( ( member @ A @ X4 @ A4 )
           => ( ( member @ A @ Y3 @ A4 )
             => ( X4 = Y3 ) ) )
       => ( is_singleton @ A @ A4 ) ) ) )).

% is_singletonI'
thf(fact_59_empty__bind,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( set @ A ) )] :
      ( ( bind @ B @ A @ ( bot_bot @ ( set @ B ) ) @ F )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_bind
thf(fact_60_set__of__Node,axiom,(
    ! [Lt2: binDag_Mirabelle_dag,A2: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag1380252983set_of @ ( binDag476092410e_Node @ Lt2 @ A2 @ Rt2 ) )
      = ( sup_sup @ ( set @ simpl_ref ) @ ( sup_sup @ ( set @ simpl_ref ) @ ( insert @ simpl_ref @ A2 @ ( bot_bot @ ( set @ simpl_ref ) ) ) @ ( binDag1380252983set_of @ Lt2 ) ) @ ( binDag1380252983set_of @ Rt2 ) ) ) )).

% set_of_Node
thf(fact_61_pairwise__empty,axiom,(
    ! [A: $tType,P2: ( A > A > $o )] :
      ( pairwise @ A @ P2 @ ( bot_bot @ ( set @ A ) ) ) )).

% pairwise_empty
thf(fact_62_DAG__less,axiom,(
    ! [Y: binDag_Mirabelle_dag,X: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_DAG @ Y )
     => ( ( ord_less @ binDag_Mirabelle_dag @ X @ Y )
       => ( binDag_Mirabelle_DAG @ X ) ) ) )).

% DAG_less
thf(fact_63_insertCI,axiom,(
    ! [A: $tType,A2: A,B4: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A2 @ B4 )
       => ( A2 = B3 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% insertCI
thf(fact_64_insert__iff,axiom,(
    ! [A: $tType,A2: A,B3: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B3 @ A4 ) )
      = ( ( A2 = B3 )
        | ( member @ A @ A2 @ A4 ) ) ) )).

% insert_iff
thf(fact_65_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A4 ) )
      = ( insert @ A @ X @ A4 ) ) )).

% insert_absorb2
thf(fact_66_UnCI,axiom,(
    ! [A: $tType,C: A,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( ~ ( member @ A @ C @ B4 )
       => ( member @ A @ C @ A4 ) )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% UnCI
thf(fact_67_Un__iff,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( member @ A @ C @ A4 )
        | ( member @ A @ C @ B4 ) ) ) )).

% Un_iff
thf(fact_68_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_69_Un__empty,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A4 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        & ( B4
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_70_Un__insert__left,axiom,(
    ! [A: $tType,A2: A,B4: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ A2 @ B4 ) @ C3 )
      = ( insert @ A @ A2 @ ( sup_sup @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Un_insert_left
thf(fact_71_Un__insert__right,axiom,(
    ! [A: $tType,A4: ( set @ A ),A2: A,B4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( insert @ A @ A2 @ B4 ) )
      = ( insert @ A @ A2 @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% Un_insert_right
thf(fact_72_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_73_pairwise__singleton,axiom,(
    ! [A: $tType,P2: ( A > A > $o ),A4: A] :
      ( pairwise @ A @ P2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_74_singleton__Un__iff,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) )
        = ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( ( A4
            = ( bot_bot @ ( set @ A ) ) )
          & ( B4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B4
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% singleton_Un_iff
thf(fact_75_Un__singleton__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ( sup_sup @ ( set @ A ) @ A4 @ B4 )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( ( A4
            = ( bot_bot @ ( set @ A ) ) )
          & ( B4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B4
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% Un_singleton_iff
thf(fact_76_insert__is__Un,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A3: A] :
            ( sup_sup @ ( set @ A ) @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% insert_is_Un
thf(fact_77_UnE,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
     => ( ~ ( member @ A @ C @ A4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% UnE
thf(fact_78_UnI1,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ A4 )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% UnI1
thf(fact_79_UnI2,axiom,(
    ! [A: $tType,C: A,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( member @ A @ C @ B4 )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% UnI2
thf(fact_80_bex__Un,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),P2: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
            & ( P2 @ X2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ A4 )
            & ( P2 @ X2 ) )
        | ? [X2: A] :
            ( ( member @ A @ X2 @ B4 )
            & ( P2 @ X2 ) ) ) ) )).

% bex_Un
thf(fact_81_ball__Un,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),P2: ( A > $o )] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
           => ( P2 @ X2 ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A4 )
           => ( P2 @ X2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ B4 )
           => ( P2 @ X2 ) ) ) ) )).

% ball_Un
thf(fact_82_insertE,axiom,(
    ! [A: $tType,A2: A,B3: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B3 @ A4 ) )
     => ( ( A2 != B3 )
       => ( member @ A @ A2 @ A4 ) ) ) )).

% insertE
thf(fact_83_Un__assoc,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Un_assoc
thf(fact_84_insertI1,axiom,(
    ! [A: $tType,A2: A,B4: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B4 ) ) )).

% insertI1
thf(fact_85_insertI2,axiom,(
    ! [A: $tType,A2: A,B4: ( set @ A ),B3: A] :
      ( ( member @ A @ A2 @ B4 )
     => ( member @ A @ A2 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% insertI2
thf(fact_86_Un__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ A4 )
      = A4 ) )).

% Un_absorb
thf(fact_87_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Un_commute
thf(fact_88_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A )] :
      ( ( member @ A @ X @ A4 )
     => ~ ( ! [B6: ( set @ A )] :
              ( ( A4
                = ( insert @ A @ X @ B6 ) )
             => ( member @ A @ X @ B6 ) ) ) ) )).

% Set.set_insert
thf(fact_89_insert__ident,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ~ ( member @ A @ X @ B4 )
       => ( ( ( insert @ A @ X @ A4 )
            = ( insert @ A @ X @ B4 ) )
          = ( A4 = B4 ) ) ) ) )).

% insert_ident
thf(fact_90_pairwise__def,axiom,(
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R3: ( A > A > $o ),S2: ( set @ A )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ S2 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ S2 )
               => ( ( X2 != Y2 )
                 => ( R3 @ X2 @ Y2 ) ) ) ) ) ) )).

% pairwise_def
thf(fact_91_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ A4 )
     => ( ( insert @ A @ A2 @ A4 )
        = A4 ) ) )).

% insert_absorb
thf(fact_92_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A ),B3: A,B4: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A4 )
     => ( ~ ( member @ A @ B3 @ B4 )
       => ( ( ( insert @ A @ A2 @ A4 )
            = ( insert @ A @ B3 @ B4 ) )
          = ( ( ( A2 = B3 )
             => ( A4 = B4 ) )
            & ( ( A2 != B3 )
             => ? [C4: ( set @ A )] :
                  ( ( A4
                    = ( insert @ A @ B3 @ C4 ) )
                  & ~ ( member @ A @ B3 @ C4 )
                  & ( B4
                    = ( insert @ A @ A2 @ C4 ) )
                  & ~ ( member @ A @ A2 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_93_Un__left__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
      = ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) )).

% Un_left_absorb
thf(fact_94_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A4: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A4 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A4 ) ) ) )).

% insert_commute
thf(fact_95_Un__left__commute,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B4 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B4 @ ( sup_sup @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_96_pairwise__insert,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,S: ( set @ A )] :
      ( ( pairwise @ A @ R @ ( insert @ A @ X @ S ) )
      = ( ! [Y2: A] :
            ( ( ( member @ A @ Y2 @ S )
              & ( Y2 != X ) )
           => ( ( R @ X @ Y2 )
              & ( R @ Y2 @ X ) ) )
        & ( pairwise @ A @ R @ S ) ) ) )).

% pairwise_insert
thf(fact_97_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ A4 )
     => ? [B6: ( set @ A )] :
          ( ( A4
            = ( insert @ A @ A2 @ B6 ) )
          & ~ ( member @ A @ A2 @ B6 ) ) ) )).

% mk_disjoint_insert
thf(fact_98_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C: B] :
          ( ( A2
            = ( F @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C )
           => ( ! [X4: B,Y3: B] :
                  ( ( ord_less @ B @ X4 @ Y3 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_99_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > B ),C: B] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ( F @ B3 )
              = C )
           => ( ! [X4: A,Y3: A] :
                  ( ( ord_less @ A @ X4 @ Y3 )
                 => ( ord_less @ B @ ( F @ X4 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ B @ ( F @ A2 ) @ C ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_100_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C: B] :
          ( ( ord_less @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C )
           => ( ! [X4: B,Y3: B] :
                  ( ( ord_less @ B @ X4 @ Y3 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_101_order__less__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less @ C2 @ ( F @ B3 ) @ C )
           => ( ! [X4: A,Y3: A] :
                  ( ( ord_less @ A @ X4 @ Y3 )
                 => ( ord_less @ C2 @ ( F @ X4 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C2 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% order_less_subst2
thf(fact_102_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y3: A] :
          ( ord_less @ A @ Y3 @ X ) ) )).

% lt_ex
thf(fact_103_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X1: A] :
          ( ord_less @ A @ X @ X1 ) ) )).

% gt_ex
thf(fact_104_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% neqE
thf(fact_105_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) )).

% neq_iff
thf(fact_106_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A2 ) ) ) )).

% order.asym
thf(fact_107_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X @ Z3 )
              & ( ord_less @ A @ Z3 @ Y ) ) ) ) )).

% dense
thf(fact_108_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) )).

% less_imp_neq
thf(fact_109_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_asym
thf(fact_110_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A2 ) ) ) )).

% less_asym'
thf(fact_111_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) )).

% less_trans
thf(fact_112_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) )).

% less_linear
thf(fact_113_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) )).

% less_irrefl
thf(fact_114_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C: A] :
          ( ( A2 = B3 )
         => ( ( ord_less @ A @ B3 @ C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% ord_eq_less_trans
thf(fact_115_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( B3 = C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% ord_less_eq_trans
thf(fact_116_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B3 ) ) ) )).

% dual_order.asym
thf(fact_117_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) )).

% less_imp_not_eq
thf(fact_118_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_not_sym
thf(fact_119_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),A2: A] :
          ( ! [X4: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ A @ Y4 @ X4 )
                 => ( P2 @ Y4 ) )
             => ( P2 @ X4 ) )
         => ( P2 @ A2 ) ) ) )).

% less_induct
thf(fact_120_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) )).

% antisym_conv3
thf(fact_121_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) )).

% less_imp_not_eq2
thf(fact_122_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,P2: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P2 ) ) ) )).

% less_imp_triv
thf(fact_123_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% linorder_cases
thf(fact_124_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) )).

% dual_order.irrefl
thf(fact_125_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less @ A @ B3 @ C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% order.strict_trans
thf(fact_126_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_imp_not_less
thf(fact_127_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( ord_less @ A @ C @ B3 )
           => ( ord_less @ A @ C @ A2 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_128_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_129_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( A2 != B3 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_130_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( A2 != B3 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_131_is__singletonE,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( is_singleton @ A @ A4 )
     => ~ ( ! [X4: A] :
              ( A4
             != ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_132_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A5: ( set @ A )] :
          ? [X2: A] :
            ( A5
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_133_Un__empty__left,axiom,(
    ! [A: $tType,B4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B4 )
      = B4 ) )).

% Un_empty_left
thf(fact_134_Un__empty__right,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = A4 ) )).

% Un_empty_right
thf(fact_135_singletonD,axiom,(
    ! [A: $tType,B3: A,A2: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A2 ) ) )).

% singletonD
thf(fact_136_singleton__iff,axiom,(
    ! [A: $tType,B3: A,A2: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A2 ) ) )).

% singleton_iff
thf(fact_137_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B3: A,C: A,D: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C @ ( insert @ A @ D @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C )
          & ( B3 = D ) )
        | ( ( A2 = D )
          & ( B3 = C ) ) ) ) )).

% doubleton_eq_iff
thf(fact_138_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( insert @ A @ A2 @ A4 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_139_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B3: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B3 ) ) )).

% singleton_inject
thf(fact_140_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_141_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) )).

% bot.not_eq_extremum
thf(fact_142_less__dag__Node_H,axiom,(
    ! [X: binDag_Mirabelle_dag,L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X @ ( binDag476092410e_Node @ L @ A2 @ R ) )
      = ( ( X = L )
        | ( X = R )
        | ( ord_less @ binDag_Mirabelle_dag @ X @ L )
        | ( ord_less @ binDag_Mirabelle_dag @ X @ R ) ) ) )).

% less_dag_Node'
thf(fact_143_less__Node__dag,axiom,(
    ! [L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag,X: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ ( binDag476092410e_Node @ L @ A2 @ R ) @ X )
     => ( ( ord_less @ binDag_Mirabelle_dag @ L @ X )
        & ( ord_less @ binDag_Mirabelle_dag @ R @ X ) ) ) )).

% less_Node_dag
thf(fact_144_less__dag__def,axiom,
    ( ( ord_less @ binDag_Mirabelle_dag )
    = ( ^ [S3: binDag_Mirabelle_dag,T2: binDag_Mirabelle_dag] :
          ( binDag786255756subdag @ T2 @ S3 ) ) )).

% less_dag_def
thf(fact_145_less__dag__Tip,axiom,(
    ! [X: binDag_Mirabelle_dag] :
      ~ ( ord_less @ binDag_Mirabelle_dag @ X @ binDag_Mirabelle_Tip ) )).

% less_dag_Tip
thf(fact_146_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_147_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_148_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A2 )
          = A2 ) ) )).

% sup_bot.left_neutral
thf(fact_149_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ ( bot_bot @ A ) )
          = A2 ) ) )).

% sup_bot.right_neutral
thf(fact_150_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A5: ( set @ A )] :
            ( A5
            = ( insert @ A @ ( the_elem @ A @ A5 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_151_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.right_idem
thf(fact_152_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_153_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% sup_apply
thf(fact_154_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_155_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_156_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B3 ) )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.left_idem
thf(fact_157_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_158_not__psubset__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_159_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_160_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_161_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_162_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y2: A] :
              ( sup_sup @ A @ Y2 @ X2 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_163_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% sup_fun_def
thf(fact_164_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B3 ) @ C )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B3 @ C ) ) ) ) )).

% sup.assoc
thf(fact_165_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% sup_assoc
thf(fact_166_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A3: A,B2: A] :
              ( sup_sup @ A @ B2 @ A3 ) ) ) ) )).

% sup.commute
thf(fact_167_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y2: A] :
              ( sup_sup @ A @ Y2 @ X2 ) ) ) ) )).

% sup_commute
thf(fact_168_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A2 @ C ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B3 @ C ) ) ) ) )).

% sup.left_commute
thf(fact_169_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_left_commute
thf(fact_170_less__DAG__set__of,axiom,(
    ! [X: binDag_Mirabelle_dag,Y: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X @ Y )
     => ( ( binDag_Mirabelle_DAG @ Y )
       => ( ord_less @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ X ) @ ( binDag1380252983set_of @ Y ) ) ) ) )).

% less_DAG_set_of
thf(fact_171_less__supI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,A2: A,B3: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% less_supI1
thf(fact_172_less__supI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,B3: A,A2: A] :
          ( ( ord_less @ A @ X @ B3 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% less_supI2
thf(fact_173_sup_Ostrict__boundedE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B3 @ C ) @ A2 )
         => ~ ( ( ord_less @ A @ B3 @ A2 )
             => ~ ( ord_less @ A @ C @ A2 ) ) ) ) )).

% sup.strict_boundedE
thf(fact_174_sup_Ostrict__order__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B2: A,A3: A] :
              ( ( A3
                = ( sup_sup @ A @ A3 @ B2 ) )
              & ( A3 != B2 ) ) ) ) ) )).

% sup.strict_order_iff
thf(fact_175_sup_Ostrict__coboundedI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C: A,A2: A,B3: A] :
          ( ( ord_less @ A @ C @ A2 )
         => ( ord_less @ A @ C @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% sup.strict_coboundedI1
thf(fact_176_sup_Ostrict__coboundedI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C: A,B3: A,A2: A] :
          ( ( ord_less @ A @ C @ B3 )
         => ( ord_less @ A @ C @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% sup.strict_coboundedI2
thf(fact_177_sup__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) )).

% sup_bot_left
thf(fact_178_sup__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) )).

% sup_bot_right
thf(fact_179_sup__bot_Osemilattice__neutr__axioms,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ( semilattice_neutr @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) )).

% sup_bot.semilattice_neutr_axioms
thf(fact_180_sup__bot_Omonoid__axioms,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ( monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) )).

% sup_bot.monoid_axioms
thf(fact_181_minf_I11_J,axiom,(
    ! [C2: $tType,D2: $tType] :
      ( ( ord @ C2 @ ( type2 @ C2 ) )
     => ! [F3: D2] :
        ? [Z3: C2] :
        ! [X5: C2] :
          ( ( ord_less @ C2 @ X5 @ Z3 )
         => ( F3 = F3 ) ) ) )).

% minf(11)
thf(fact_182_psubsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C: A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C @ A4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% psubsetD
thf(fact_183_psubset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less @ ( set @ A ) @ B4 @ C3 )
       => ( ord_less @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% psubset_trans
thf(fact_184_pinf_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z4: A] :
            ! [X4: A] :
              ( ( ord_less @ A @ Z4 @ X4 )
             => ( ( P2 @ X4 )
                = ( P3 @ X4 ) ) )
         => ( ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ Z4 @ X4 )
               => ( ( Q2 @ X4 )
                  = ( Q3 @ X4 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( ( P2 @ X5 )
                    & ( Q2 @ X5 ) )
                  = ( ( P3 @ X5 )
                    & ( Q3 @ X5 ) ) ) ) ) ) ) )).

% pinf(1)
thf(fact_185_pinf_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z4: A] :
            ! [X4: A] :
              ( ( ord_less @ A @ Z4 @ X4 )
             => ( ( P2 @ X4 )
                = ( P3 @ X4 ) ) )
         => ( ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ Z4 @ X4 )
               => ( ( Q2 @ X4 )
                  = ( Q3 @ X4 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( ( P2 @ X5 )
                    | ( Q2 @ X5 ) )
                  = ( ( P3 @ X5 )
                    | ( Q3 @ X5 ) ) ) ) ) ) ) )).

% pinf(2)
thf(fact_186_pinf_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( X5 != T ) ) ) )).

% pinf(3)
thf(fact_187_pinf_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( X5 != T ) ) ) )).

% pinf(4)
thf(fact_188_pinf_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ~ ( ord_less @ A @ X5 @ T ) ) ) )).

% pinf(5)
thf(fact_189_pinf_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( ord_less @ A @ T @ X5 ) ) ) )).

% pinf(7)
thf(fact_190_pinf_I11_J,axiom,(
    ! [C2: $tType,D2: $tType] :
      ( ( ord @ C2 @ ( type2 @ C2 ) )
     => ! [F3: D2] :
        ? [Z3: C2] :
        ! [X5: C2] :
          ( ( ord_less @ C2 @ Z3 @ X5 )
         => ( F3 = F3 ) ) ) )).

% pinf(11)
thf(fact_191_minf_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z4: A] :
            ! [X4: A] :
              ( ( ord_less @ A @ X4 @ Z4 )
             => ( ( P2 @ X4 )
                = ( P3 @ X4 ) ) )
         => ( ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ X4 @ Z4 )
               => ( ( Q2 @ X4 )
                  = ( Q3 @ X4 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( ( P2 @ X5 )
                    & ( Q2 @ X5 ) )
                  = ( ( P3 @ X5 )
                    & ( Q3 @ X5 ) ) ) ) ) ) ) )).

% minf(1)
thf(fact_192_minf_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z4: A] :
            ! [X4: A] :
              ( ( ord_less @ A @ X4 @ Z4 )
             => ( ( P2 @ X4 )
                = ( P3 @ X4 ) ) )
         => ( ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ X4 @ Z4 )
               => ( ( Q2 @ X4 )
                  = ( Q3 @ X4 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( ( P2 @ X5 )
                    | ( Q2 @ X5 ) )
                  = ( ( P3 @ X5 )
                    | ( Q3 @ X5 ) ) ) ) ) ) ) )).

% minf(2)
thf(fact_193_minf_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( X5 != T ) ) ) )).

% minf(3)
thf(fact_194_minf_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( X5 != T ) ) ) )).

% minf(4)
thf(fact_195_minf_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( ord_less @ A @ X5 @ T ) ) ) )).

% minf(5)
thf(fact_196_minf_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ~ ( ord_less @ A @ T @ X5 ) ) ) )).

% minf(7)
thf(fact_197_ex__gt__or__lt,axiom,(
    ! [A: $tType] :
      ( ( condit1656338222tinuum @ A @ ( type2 @ A ) )
     => ! [A2: A] :
        ? [B7: A] :
          ( ( ord_less @ A @ A2 @ B7 )
          | ( ord_less @ A @ B7 @ A2 ) ) ) )).

% ex_gt_or_lt
thf(fact_198_linorder__neqE__linordered__idom,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_199_linordered__field__no__ub,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X5: A] :
        ? [X1: A] :
          ( ord_less @ A @ X5 @ X1 ) ) )).

% linordered_field_no_ub
thf(fact_200_linordered__field__no__lb,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X5: A] :
        ? [Y3: A] :
          ( ord_less @ A @ Y3 @ X5 ) ) )).

% linordered_field_no_lb
thf(fact_201_dependent__wellorder__choice,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( ( A > B ) > A > B > $o )] :
          ( ! [R4: B,F4: ( A > B ),G3: ( A > B ),X4: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ A @ Y4 @ X4 )
                 => ( ( F4 @ Y4 )
                    = ( G3 @ Y4 ) ) )
             => ( ( P2 @ F4 @ X4 @ R4 )
                = ( P2 @ G3 @ X4 @ R4 ) ) )
         => ( ! [X4: A,F4: ( A > B )] :
                ( ! [Y4: A] :
                    ( ( ord_less @ A @ Y4 @ X4 )
                   => ( P2 @ F4 @ Y4 @ ( F4 @ Y4 ) ) )
               => ? [X12: B] :
                    ( P2 @ F4 @ X4 @ X12 ) )
           => ? [F4: ( A > B )] :
              ! [X5: A] :
                ( P2 @ F4 @ X5 @ ( F4 @ X5 ) ) ) ) ) )).

% dependent_wellorder_choice
thf(fact_202_in__inv__imagep,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( inv_imagep @ A @ B )
      = ( ^ [R2: ( A > A > $o ),F2: ( B > A ),X2: B,Y2: B] :
            ( R2 @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) )).

% in_inv_imagep
thf(fact_203_pred__on_Ochain__extend,axiom,(
    ! [A: $tType,A4: ( set @ A ),P2: ( A > A > $o ),C3: ( set @ A ),Z: A] :
      ( ( pred_chain @ A @ A4 @ P2 @ C3 )
     => ( ( member @ A @ Z @ A4 )
       => ( ! [X4: A] :
              ( ( member @ A @ X4 @ C3 )
             => ( sup_sup @ ( A > A > $o ) @ P2
                @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
                @ X4
                @ Z ) )
         => ( pred_chain @ A @ A4 @ P2 @ ( sup_sup @ ( set @ A ) @ ( insert @ A @ Z @ ( bot_bot @ ( set @ A ) ) ) @ C3 ) ) ) ) ) )).

% pred_on.chain_extend
thf(fact_204_sup__bot_Ocomm__monoid__axioms,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ( comm_monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) )).

% sup_bot.comm_monoid_axioms
thf(fact_205_sup2CI,axiom,(
    ! [A: $tType,B: $tType,B4: ( A > B > $o ),X: A,Y: B,A4: ( A > B > $o )] :
      ( ( ~ ( B4 @ X @ Y )
       => ( A4 @ X @ Y ) )
     => ( sup_sup @ ( A > B > $o ) @ A4 @ B4 @ X @ Y ) ) )).

% sup2CI
thf(fact_206_pred__on_Ochain__empty,axiom,(
    ! [A: $tType,A4: ( set @ A ),P2: ( A > A > $o )] :
      ( pred_chain @ A @ A4 @ P2 @ ( bot_bot @ ( set @ A ) ) ) )).

% pred_on.chain_empty
thf(fact_207_subset_Ochain__total,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) ),C3: ( set @ ( set @ A ) ),X: ( set @ A ),Y: ( set @ A )] :
      ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
     => ( ( member @ ( set @ A ) @ X @ C3 )
       => ( ( member @ ( set @ A ) @ Y @ C3 )
         => ( ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
              @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
              @ X
              @ Y )
            | ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
              @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
              @ Y
              @ X ) ) ) ) ) )).

% subset.chain_total
thf(fact_208_pred__on_Ochain__total,axiom,(
    ! [A: $tType,A4: ( set @ A ),P2: ( A > A > $o ),C3: ( set @ A ),X: A,Y: A] :
      ( ( pred_chain @ A @ A4 @ P2 @ C3 )
     => ( ( member @ A @ X @ C3 )
       => ( ( member @ A @ Y @ C3 )
         => ( ( sup_sup @ ( A > A > $o ) @ P2
              @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
              @ X
              @ Y )
            | ( sup_sup @ ( A > A > $o ) @ P2
              @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 )
              @ Y
              @ X ) ) ) ) ) )).

% pred_on.chain_total
thf(fact_209_subset_Ochain__empty,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) )] :
      ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) )).

% subset.chain_empty
thf(fact_210_subset_Ochain__extend,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) ),C3: ( set @ ( set @ A ) ),Z: ( set @ A )] :
      ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
     => ( ( member @ ( set @ A ) @ Z @ A4 )
       => ( ! [X4: ( set @ A )] :
              ( ( member @ ( set @ A ) @ X4 @ C3 )
             => ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
                @ X4
                @ Z ) )
         => ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( insert @ ( set @ A ) @ Z @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) @ C3 ) ) ) ) ) )).

% subset.chain_extend
thf(fact_211_sup2I2,axiom,(
    ! [A: $tType,B: $tType,B4: ( A > B > $o ),X: A,Y: B,A4: ( A > B > $o )] :
      ( ( B4 @ X @ Y )
     => ( sup_sup @ ( A > B > $o ) @ A4 @ B4 @ X @ Y ) ) )).

% sup2I2
thf(fact_212_sup2I1,axiom,(
    ! [A: $tType,B: $tType,A4: ( A > B > $o ),X: A,Y: B,B4: ( A > B > $o )] :
      ( ( A4 @ X @ Y )
     => ( sup_sup @ ( A > B > $o ) @ A4 @ B4 @ X @ Y ) ) )).

% sup2I1
thf(fact_213_sup2E,axiom,(
    ! [A: $tType,B: $tType,A4: ( A > B > $o ),B4: ( A > B > $o ),X: A,Y: B] :
      ( ( sup_sup @ ( A > B > $o ) @ A4 @ B4 @ X @ Y )
     => ( ~ ( A4 @ X @ Y )
       => ( B4 @ X @ Y ) ) ) )).

% sup2E
thf(fact_214_semilattice__neutr_Oaxioms_I2_J,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z: A] :
      ( ( semilattice_neutr @ A @ F @ Z )
     => ( comm_monoid @ A @ F @ Z ) ) )).

% semilattice_neutr.axioms(2)
thf(fact_215_reflclp__idemp,axiom,(
    ! [A: $tType,P2: ( A > A > $o )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ( sup_sup @ ( A > A > $o ) @ P2
          @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) )
      = ( sup_sup @ ( A > A > $o ) @ P2
        @ ^ [Y5: A,Z5: A] : ( Y5 = Z5 ) ) ) )).

% reflclp_idemp
thf(fact_216_pred__on_Omaxchain__def,axiom,(
    ! [A: $tType] :
      ( ( pred_maxchain @ A )
      = ( ^ [A5: ( set @ A ),P4: ( A > A > $o ),C4: ( set @ A )] :
            ( ( pred_chain @ A @ A5 @ P4 @ C4 )
            & ~ ( ? [S2: ( set @ A )] :
                    ( ( pred_chain @ A @ A5 @ P4 @ S2 )
                    & ( ord_less @ ( set @ A ) @ C4 @ S2 ) ) ) ) ) ) )).

% pred_on.maxchain_def
thf(fact_217_subset_Omaxchain__def,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) ),C3: ( set @ ( set @ A ) )] :
      ( ( pred_maxchain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
      = ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
        & ~ ( ? [S2: ( set @ ( set @ A ) )] :
                ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ S2 )
                & ( ord_less @ ( set @ ( set @ A ) ) @ C3 @ S2 ) ) ) ) ) )).

% subset.maxchain_def
thf(fact_218_subset_Omaxchain__imp__chain,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) ),C3: ( set @ ( set @ A ) )] :
      ( ( pred_maxchain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
     => ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 ) ) )).

% subset.maxchain_imp_chain
thf(fact_219_subset_OHausdorff,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) )] :
    ? [X1: ( set @ ( set @ A ) )] :
      ( pred_maxchain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ X1 ) )).

% subset.Hausdorff
thf(fact_220_Pow__singleton__iff,axiom,(
    ! [A: $tType,X6: ( set @ A ),Y6: ( set @ A )] :
      ( ( ( pow @ A @ X6 )
        = ( insert @ ( set @ A ) @ Y6 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) )
      = ( ( X6
          = ( bot_bot @ ( set @ A ) ) )
        & ( Y6
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Pow_singleton_iff
thf(fact_221_Pow__empty,axiom,(
    ! [A: $tType] :
      ( ( pow @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) )).

% Pow_empty
thf(fact_222_Pow__bottom,axiom,(
    ! [A: $tType,B4: ( set @ A )] :
      ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( pow @ A @ B4 ) ) )).

% Pow_bottom
thf(fact_223_Pow__not__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( pow @ A @ A4 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) )).

% Pow_not_empty
thf(fact_224_Pow__top,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( member @ ( set @ A ) @ A4 @ ( pow @ A @ A4 ) ) )).

% Pow_top
thf(fact_225_subset_Ochain__def,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) ),C3: ( set @ ( set @ A ) )] :
      ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 )
      = ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C3 @ A4 )
        & ! [X2: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X2 @ C3 )
           => ! [Y2: ( set @ A )] :
                ( ( member @ ( set @ A ) @ Y2 @ C3 )
               => ( ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                    @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
                    @ X2
                    @ Y2 )
                  | ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                    @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
                    @ Y2
                    @ X2 ) ) ) ) ) ) )).

% subset.chain_def
thf(fact_226_subset_OchainI,axiom,(
    ! [A: $tType,C3: ( set @ ( set @ A ) ),A4: ( set @ ( set @ A ) )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C3 @ A4 )
     => ( ! [X4: ( set @ A ),Y3: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X4 @ C3 )
           => ( ( member @ ( set @ A ) @ Y3 @ C3 )
             => ( ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                  @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
                  @ X4
                  @ Y3 )
                | ( sup_sup @ ( ( set @ A ) > ( set @ A ) > $o ) @ ( ord_less @ ( set @ A ) )
                  @ ^ [Y5: ( set @ A ),Z5: ( set @ A )] : ( Y5 = Z5 )
                  @ Y3
                  @ X4 ) ) ) )
       => ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C3 ) ) ) )).

% subset.chainI
thf(fact_227_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_228_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A4 )
         => ( member @ A @ X4 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% subsetI
thf(fact_229_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_230_le__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            & ( ord_less_eq @ A @ Y @ Z ) ) ) ) )).

% le_sup_iff
thf(fact_231_sup_Obounded__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C ) @ A2 )
          = ( ( ord_less_eq @ A @ B3 @ A2 )
            & ( ord_less_eq @ A @ C @ A2 ) ) ) ) )).

% sup.bounded_iff
thf(fact_232_empty__subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 ) )).

% empty_subsetI
thf(fact_233_subset__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_234_insert__subset,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ B4 )
      = ( ( member @ A @ X @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% insert_subset
thf(fact_235_Un__subset__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) @ C3 )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
        & ( ord_less_eq @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Un_subset_iff
thf(fact_236_psubsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( A4 != B4 )
       => ( ord_less @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% psubsetI
thf(fact_237_Pow__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A4 @ ( pow @ A @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% Pow_iff
thf(fact_238_PowI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( member @ ( set @ A ) @ A4 @ ( pow @ A @ B4 ) ) ) )).

% PowI
thf(fact_239_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B3: A,A2: A,A4: ( set @ A )] :
      ( ( ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A4 ) )
      = ( ( A2 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_240_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A ),B3: A] :
      ( ( ( insert @ A @ A2 @ A4 )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_241_subset__Zorn,axiom,(
    ! [A: $tType,A4: ( set @ ( set @ A ) )] :
      ( ! [C5: ( set @ ( set @ A ) )] :
          ( ( pred_chain @ ( set @ A ) @ A4 @ ( ord_less @ ( set @ A ) ) @ C5 )
         => ? [X5: ( set @ A )] :
              ( ( member @ ( set @ A ) @ X5 @ A4 )
              & ! [Xa: ( set @ A )] :
                  ( ( member @ ( set @ A ) @ Xa @ C5 )
                 => ( ord_less_eq @ ( set @ A ) @ Xa @ X5 ) ) ) )
     => ? [X4: ( set @ A )] :
          ( ( member @ ( set @ A ) @ X4 @ A4 )
          & ! [Xa2: ( set @ A )] :
              ( ( member @ ( set @ A ) @ Xa2 @ A4 )
             => ( ( ord_less_eq @ ( set @ A ) @ X4 @ Xa2 )
               => ( Xa2 = X4 ) ) ) ) ) )).

% subset_Zorn
thf(fact_242_psubsetE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
         => ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) )).

% psubsetE
thf(fact_243_psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
            & ( A5 != B5 ) ) ) ) )).

% psubset_eq
thf(fact_244_psubset__imp__subset,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% psubset_imp_subset
thf(fact_245_psubset__subset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C3 )
       => ( ord_less @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% psubset_subset_trans
thf(fact_246_subset__not__subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ) )).

% subset_not_subset_eq
thf(fact_247_subset__psubset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less @ ( set @ A ) @ B4 @ C3 )
       => ( ord_less @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% subset_psubset_trans
thf(fact_248_subset__iff__psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less @ ( set @ A ) @ A5 @ B5 )
            | ( A5 = B5 ) ) ) ) )).

% subset_iff_psubset_eq
thf(fact_249_pinf_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ~ ( ord_less_eq @ A @ X5 @ T ) ) ) )).

% pinf(6)
thf(fact_250_pinf_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( ord_less_eq @ A @ T @ X5 ) ) ) )).

% pinf(8)
thf(fact_251_minf_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( ord_less_eq @ A @ X5 @ T ) ) ) )).

% minf(6)
thf(fact_252_minf_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ~ ( ord_less_eq @ A @ T @ X5 ) ) ) )).

% minf(8)
thf(fact_253_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( A2 != B3 )
         => ( ( ord_less_eq @ A @ A2 @ B3 )
           => ( ord_less @ A @ A2 @ B3 ) ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_254_dual__order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ord_less_eq @ A @ B3 @ A2 ) ) ) )).

% dual_order.strict_implies_order
thf(fact_255_dual__order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B2: A,A3: A] :
              ( ( ord_less_eq @ A @ B2 @ A3 )
              & ( A3 != B2 ) ) ) ) ) )).

% dual_order.strict_iff_order

%----Type constructors (34)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A6: $tType] :
      ( bounded_lattice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounded_lattice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounde1808546759up_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounded_lattice_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( semilattice_sup @ A7 @ ( type2 @ A7 ) )
     => ( semilattice_sup @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order_bot @ A7 @ ( type2 @ A7 ) )
     => ( order_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( preorder @ A7 @ ( type2 @ A7 ) )
     => ( preorder @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( lattice @ A7 @ ( type2 @ A7 ) )
     => ( lattice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bot @ A7 @ ( type2 @ A7 ) )
     => ( bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_3,axiom,(
    ! [A6: $tType] :
      ( bounde1808546759up_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_4,axiom,(
    ! [A6: $tType] :
      ( bounded_lattice_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_5,axiom,(
    ! [A6: $tType] :
      ( semilattice_sup @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_6,axiom,(
    ! [A6: $tType] :
      ( order_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_7,axiom,(
    ! [A6: $tType] :
      ( preorder @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_8,axiom,(
    ! [A6: $tType] :
      ( lattice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_9,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_10,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_11,axiom,(
    ! [A6: $tType] :
      ( bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_12,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_13,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_14,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_15,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_16,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_17,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_18,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_19,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_20,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Orderings_Opreorder_21,axiom,
    ( preorder @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Orderings_Oorder_22,axiom,
    ( order @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Orderings_Oord_23,axiom,
    ( ord @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( binDag_Mirabelle_Dag @ p @ ( fun_upd @ simpl_ref @ simpl_ref @ l @ p @ p ) @ r @ t )
    = ( ( p = simpl_Null )
      & ( t = binDag_Mirabelle_Tip ) ) )).

%------------------------------------------------------------------------------
