%------------------------------------------------------------------------------
% File     : COM168^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Binary decision diagram 276
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [OS08]  Ortner & Schirmer (2008), BDD Normalisation
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : bindag__276.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  347 (   0 unit;  59 type;   0 defn)
%            Number of atoms       : 3913 ( 227 equality;2456 variable)
%            Maximal formula depth :   21 (   9 average)
%            Number of connectives : 3414 ( 105   ~;  29   |;  54   &;2799   @)
%                                         (   0 <=>; 427  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  226 ( 226   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   63 (  59   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1058 (   2 sgn; 915   !;  42   ?;  60   ^)
%                                         (1058   :;  41  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:45:57.605
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_BinDag__Mirabelle__rybootvolr_Odag,type,(
    binDag_Mirabelle_dag: $tType )).

thf(ty_t_Simpl__Heap_Oref,type,(
    simpl_ref: $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (53)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__linorder,type,(
    dense_linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,(
    condit1656338222tinuum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,(
    condit1037483654norder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_ODAG,type,(
    binDag_Mirabelle_DAG: binDag_Mirabelle_dag > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_ODag,type,(
    binDag_Mirabelle_Dag: simpl_ref > ( simpl_ref > simpl_ref ) > ( simpl_ref > simpl_ref ) > binDag_Mirabelle_dag > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_ONode,type,(
    binDag476092410e_Node: binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_OTip,type,(
    binDag_Mirabelle_Tip: binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Ocase__dag,type,(
    binDag1297733282se_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Orec__dag,type,(
    binDag1442713106ec_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Oset__of,type,(
    binDag1380252983set_of: binDag_Mirabelle_dag > ( set @ simpl_ref ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Osubdag,type,(
    binDag786255756subdag: binDag_Mirabelle_dag > binDag_Mirabelle_dag > $o )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Ocan__select,type,(
    can_select: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_List_Ocoset,type,(
    coset: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Omember,type,(
    member: 
      !>[A: $tType] :
        ( ( list @ A ) > A > $o ) )).

thf(sy_c_List_OremoveAll,type,(
    removeAll: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublist,type,(
    sublist: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Simpl__Heap_ONull,type,(
    simpl_Null: simpl_ref )).

thf(sy_c_Simpl__Heap_Onew,type,(
    simpl_new: ( set @ simpl_ref ) > simpl_ref )).

thf(sy_c_Zorn_Ochain__subset,type,(
    chain_subset: 
      !>[A: $tType] :
        ( ( set @ ( set @ A ) ) > $o ) )).

thf(sy_c_member,type,(
    member2: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_alloc,type,(
    alloc: ( list @ simpl_ref ) )).

thf(sy_v_l,type,(
    l: simpl_ref > simpl_ref )).

thf(sy_v_p,type,(
    p: simpl_ref )).

thf(sy_v_r,type,(
    r: simpl_ref > simpl_ref )).

thf(sy_v_t,type,(
    t: binDag_Mirabelle_dag )).

thf(sy_v_x,type,(
    x: simpl_ref )).

%----Relevant facts (255)
thf(fact_0_notin__Dag__update__l,axiom,(
    ! [Q: simpl_ref,T: binDag_Mirabelle_dag,P: simpl_ref,L: ( simpl_ref > simpl_ref ),Y: simpl_ref,R: ( simpl_ref > simpl_ref )] :
      ( ~ ( member2 @ simpl_ref @ Q @ ( binDag1380252983set_of @ T ) )
     => ( ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ Q @ Y ) @ R @ T )
        = ( binDag_Mirabelle_Dag @ P @ L @ R @ T ) ) ) )).

% notin_Dag_update_l
thf(fact_1_notin__Dag__update__r,axiom,(
    ! [Q: simpl_ref,T: binDag_Mirabelle_dag,P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),Y: simpl_ref] :
      ( ~ ( member2 @ simpl_ref @ Q @ ( binDag1380252983set_of @ T ) )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ Q @ Y ) @ T )
        = ( binDag_Mirabelle_Dag @ P @ L @ R @ T ) ) ) )).

% notin_Dag_update_r
thf(fact_2_fun__upd__upd,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X: A,Y: B,Z: B] :
      ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F @ X @ Y ) @ X @ Z )
      = ( fun_upd @ A @ B @ F @ X @ Z ) ) )).

% fun_upd_upd
thf(fact_3_fun__upd__triv,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X: A] :
      ( ( fun_upd @ A @ B @ F @ X @ ( F @ X ) )
      = F ) )).

% fun_upd_triv
thf(fact_4_fun__upd__apply,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( fun_upd @ B @ A )
      = ( ^ [F2: ( B > A ),X2: B,Y2: A,Z2: B] :
            ( if @ A @ ( Z2 = X2 ) @ Y2 @ ( F2 @ Z2 ) ) ) ) )).

% fun_upd_apply
thf(fact_5_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member2 @ A @ X3 @ A2 )
         => ( member2 @ A @ X3 @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% subsetI
thf(fact_6_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A2 )
       => ( A2 = B2 ) ) ) )).

% subset_antisym
thf(fact_7_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_8_Null__notin__Dag,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T )
     => ~ ( member2 @ simpl_ref @ simpl_Null @ ( binDag1380252983set_of @ T ) ) ) )).

% Null_notin_Dag
thf(fact_9_subset__code_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B2 )
      = ( ! [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( member2 @ A @ X2 @ B2 ) ) ) ) )).

% subset_code(1)
thf(fact_10_Dag__upd__same__l__lemma,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ~ ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ P @ P ) @ R @ T ) ) )).

% Dag_upd_same_l_lemma
thf(fact_11_Dag__upd__same__r__lemma,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ~ ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ P @ P ) @ T ) ) )).

% Dag_upd_same_r_lemma
thf(fact_12_fun__upd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_upd @ A @ B )
      = ( ^ [F2: ( A > B ),A3: A,B3: B,X2: A] :
            ( if @ B @ ( X2 = A3 ) @ B3 @ ( F2 @ X2 ) ) ) ) )).

% fun_upd_def
thf(fact_13_fun__upd__eqD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X: A,Y: B,G: ( A > B ),Z: B] :
      ( ( ( fun_upd @ A @ B @ F @ X @ Y )
        = ( fun_upd @ A @ B @ G @ X @ Z ) )
     => ( Y = Z ) ) )).

% fun_upd_eqD
thf(fact_14_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less_eq @ A @ B4 @ A4 )
         => ( ( ord_less_eq @ A @ A4 @ B4 )
           => ( A4 = B4 ) ) ) ) )).

% dual_order.antisym
thf(fact_15_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C: A] :
          ( ( ord_less_eq @ A @ B4 @ A4 )
         => ( ( ord_less_eq @ A @ C @ B4 )
           => ( ord_less_eq @ A @ C @ A4 ) ) ) ) )).

% dual_order.trans
thf(fact_16_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > A > $o ),A4: A,B4: A] :
          ( ! [A5: A,B5: A] :
              ( ( ord_less_eq @ A @ A5 @ B5 )
             => ( P2 @ A5 @ B5 ) )
         => ( ! [A5: A,B5: A] :
                ( ( P2 @ B5 @ A5 )
               => ( P2 @ A5 @ B5 ) )
           => ( P2 @ A4 @ B4 ) ) ) ) )).

% linorder_wlog
thf(fact_17_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ord_less_eq @ A @ A4 @ A4 ) ) )).

% dual_order.refl
thf(fact_18_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) )).

% order_trans
thf(fact_19_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ A4 )
           => ( A4 = B4 ) ) ) ) )).

% order_class.order.antisym
thf(fact_20_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( B4 = C )
           => ( ord_less_eq @ A @ A4 @ C ) ) ) ) )).

% ord_le_eq_trans
thf(fact_21_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( A4 = B4 )
         => ( ( ord_less_eq @ A @ B4 @ C )
           => ( ord_less_eq @ A @ A4 @ C ) ) ) ) )).

% ord_eq_le_trans
thf(fact_22_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) )).

% antisym_conv
thf(fact_23_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_24_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ C )
           => ( ord_less_eq @ A @ A4 @ C ) ) ) ) )).

% order.trans
thf(fact_25_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) )).

% le_cases
thf(fact_26_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) )).

% eq_refl
thf(fact_27_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) )).

% linear
thf(fact_28_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) )).

% antisym
thf(fact_29_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y3: A,Z3: A] : ( Y3 = Z3 ) )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
              & ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) )).

% eq_iff
thf(fact_30_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > B ),C: B] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ( F @ B4 )
              = C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ B @ ( F @ A4 ) @ C ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_31_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( A4
            = ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_32_order__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ C2 @ ( F @ B4 ) @ C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ C2 @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ C2 @ ( F @ A4 ) @ C ) ) ) ) ) )).

% order_subst2
thf(fact_33_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( ord_less_eq @ A @ A4 @ ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% order_subst1
thf(fact_34_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B )] :
            ! [X2: A] :
              ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% le_fun_def
thf(fact_35_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X3: A] :
              ( ord_less_eq @ B @ ( F @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_36_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funE
thf(fact_37_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funD
thf(fact_38_Collect__mono__iff,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P2 ) @ ( collect @ A @ Q2 ) )
      = ( ! [X2: A] :
            ( ( P2 @ X2 )
           => ( Q2 @ X2 ) ) ) ) )).

% Collect_mono_iff
thf(fact_39_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ~ ( member2 @ A @ C @ B2 )
       => ~ ( member2 @ A @ C @ A2 ) ) ) )).

% contra_subsetD
thf(fact_40_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( set @ A ),Z3: ( set @ A )] : ( Y3 = Z3 ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) ) )).

% set_eq_subset
thf(fact_41_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% subset_trans
thf(fact_42_Collect__mono,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P2 @ X3 )
         => ( Q2 @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P2 ) @ ( collect @ A @ Q2 ) ) ) )).

% Collect_mono
thf(fact_43_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_44_rev__subsetD,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member2 @ A @ C @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% rev_subsetD
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P2: ( A > $o )] :
      ( ( member2 @ A @ A4 @ ( collect @ A @ P2 ) )
      = ( P2 @ A4 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member2 @ A @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P2 @ X3 )
          = ( Q2 @ X3 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q2 ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
          ! [T2: A] :
            ( ( member2 @ A @ T2 @ A6 )
           => ( member2 @ A @ T2 @ B6 ) ) ) ) )).

% subset_iff
thf(fact_50_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member2 @ A @ X @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member2 @ A @ X @ B2 ) ) ) )).

% set_rev_mp
thf(fact_51_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) )).

% equalityD2
thf(fact_52_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% equalityD1
thf(fact_53_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
          ! [X2: A] :
            ( ( member2 @ A @ X2 @ A6 )
           => ( member2 @ A @ X2 @ B6 ) ) ) ) )).

% subset_eq
thf(fact_54_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) ) )).

% equalityE
thf(fact_55_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ C @ A2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% subsetCE
thf(fact_56_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ C @ A2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% subsetD
thf(fact_57_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ X @ A2 )
       => ( member2 @ A @ X @ B2 ) ) ) )).

% in_mono
thf(fact_58_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ X @ A2 )
       => ( member2 @ A @ X @ B2 ) ) ) )).

% set_mp
thf(fact_59_le__dag__set__of,axiom,(
    ! [X: binDag_Mirabelle_dag,Y: binDag_Mirabelle_dag] :
      ( ( ord_less_eq @ binDag_Mirabelle_dag @ X @ Y )
     => ( ord_less_eq @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ X ) @ ( binDag1380252983set_of @ Y ) ) ) )).

% le_dag_set_of
thf(fact_60_fun__upd__idem__iff,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X: A,Y: B] :
      ( ( ( fun_upd @ A @ B @ F @ X @ Y )
        = F )
      = ( ( F @ X )
        = Y ) ) )).

% fun_upd_idem_iff
thf(fact_61_fun__upd__twist,axiom,(
    ! [A: $tType,B: $tType,A4: A,C: A,M: ( A > B ),B4: B,D: B] :
      ( ( A4 != C )
     => ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M @ A4 @ B4 ) @ C @ D )
        = ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M @ C @ D ) @ A4 @ B4 ) ) ) )).

% fun_upd_twist
thf(fact_62_fun__upd__other,axiom,(
    ! [B: $tType,A: $tType,Z: A,X: A,F: ( A > B ),Y: B] :
      ( ( Z != X )
     => ( ( fun_upd @ A @ B @ F @ X @ Y @ Z )
        = ( F @ Z ) ) ) )).

% fun_upd_other
thf(fact_63_fun__upd__same,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),X: B,Y: A] :
      ( ( fun_upd @ B @ A @ F @ X @ Y @ X )
      = Y ) )).

% fun_upd_same
thf(fact_64_fun__upd__idem,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X: B,Y: A] :
      ( ( ( F @ X )
        = Y )
     => ( ( fun_upd @ B @ A @ F @ X @ Y )
        = F ) ) )).

% fun_upd_idem
thf(fact_65_Dag__upd__same__r,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ P @ P ) @ T )
      = ( ( P = simpl_Null )
        & ( T = binDag_Mirabelle_Tip ) ) ) )).

% Dag_upd_same_r
thf(fact_66_Dag__upd__same__l,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ P @ P ) @ R @ T )
      = ( ( P = simpl_Null )
        & ( T = binDag_Mirabelle_Tip ) ) ) )).

% Dag_upd_same_l
thf(fact_67_Dag__Null,axiom,(
    ! [L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ simpl_Null @ L @ R @ T )
      = ( T = binDag_Mirabelle_Tip ) ) )).

% Dag_Null
thf(fact_68_Dag__Ref,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T )
        = ( ? [Lt: binDag_Mirabelle_dag,Rt: binDag_Mirabelle_dag] :
              ( ( T
                = ( binDag476092410e_Node @ Lt @ P @ Rt ) )
              & ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ Lt )
              & ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ Rt ) ) ) ) ) )).

% Dag_Ref
thf(fact_69_Dag_Osimps_I1_J,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ binDag_Mirabelle_Tip )
      = ( P = simpl_Null ) ) )).

% Dag.simps(1)
thf(fact_70_Dag_Osimps_I2_J,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),Lt2: binDag_Mirabelle_dag,A4: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ ( binDag476092410e_Node @ Lt2 @ A4 @ Rt2 ) )
      = ( ( P = A4 )
        & ( P != simpl_Null )
        & ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ Lt2 )
        & ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ Rt2 ) ) ) )).

% Dag.simps(2)
thf(fact_71_less__dag__set__of,axiom,(
    ! [X: binDag_Mirabelle_dag,Y: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X @ Y )
     => ( ord_less_eq @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ X ) @ ( binDag1380252983set_of @ Y ) ) ) )).

% less_dag_set_of
thf(fact_72_subset__code_I2_J,axiom,(
    ! [B: $tType,A2: ( set @ B ),Ys: ( list @ B )] :
      ( ( ord_less_eq @ ( set @ B ) @ A2 @ ( coset @ B @ Ys ) )
      = ( ! [X2: B] :
            ( ( member2 @ B @ X2 @ ( set2 @ B @ Ys ) )
           => ~ ( member2 @ B @ X2 @ A2 ) ) ) ) )).

% subset_code(2)
thf(fact_73_in__set__member,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
      = ( member @ A @ Xs @ X ) ) )).

% in_set_member
thf(fact_74_set__sublist__subset,axiom,(
    ! [A: $tType,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( sublist @ A @ Xs @ I ) ) @ ( set2 @ A @ Xs ) ) )).

% set_sublist_subset
thf(fact_75_in__set__insert,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = Xs ) ) )).

% in_set_insert
thf(fact_76_dag_Oinject,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag,Y21: binDag_Mirabelle_dag,Y22: simpl_ref,Y23: binDag_Mirabelle_dag] :
      ( ( ( binDag476092410e_Node @ X21 @ X22 @ X23 )
        = ( binDag476092410e_Node @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% dag.inject
thf(fact_77_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( A4
            = ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_78_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > B ),C: B] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ( F @ B4 )
              = C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ B @ ( F @ A4 ) @ C ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_79_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( ord_less @ A @ A4 @ ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_80_order__less__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less @ C2 @ ( F @ B4 ) @ C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ C2 @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ C2 @ ( F @ A4 ) @ C ) ) ) ) ) )).

% order_less_subst2
thf(fact_81_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y4: A] :
          ( ord_less @ A @ Y4 @ X ) ) )).

% lt_ex
thf(fact_82_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X1: A] :
          ( ord_less @ A @ X @ X1 ) ) )).

% gt_ex
thf(fact_83_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% neqE
thf(fact_84_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) )).

% neq_iff
thf(fact_85_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A4 ) ) ) )).

% order.asym
thf(fact_86_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z4: A] :
              ( ( ord_less @ A @ X @ Z4 )
              & ( ord_less @ A @ Z4 @ Y ) ) ) ) )).

% dense
thf(fact_87_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) )).

% less_imp_neq
thf(fact_88_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_asym
thf(fact_89_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A4 ) ) ) )).

% less_asym'
thf(fact_90_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) )).

% less_trans
thf(fact_91_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) )).

% less_linear
thf(fact_92_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) )).

% less_irrefl
thf(fact_93_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( A4 = B4 )
         => ( ( ord_less @ A @ B4 @ C )
           => ( ord_less @ A @ A4 @ C ) ) ) ) )).

% ord_eq_less_trans
thf(fact_94_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( B4 = C )
           => ( ord_less @ A @ A4 @ C ) ) ) ) )).

% ord_less_eq_trans
thf(fact_95_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ~ ( ord_less @ A @ A4 @ B4 ) ) ) )).

% dual_order.asym
thf(fact_96_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) )).

% less_imp_not_eq
thf(fact_97_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_not_sym
thf(fact_98_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),A4: A] :
          ( ! [X3: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X3 )
                 => ( P2 @ Y5 ) )
             => ( P2 @ X3 ) )
         => ( P2 @ A4 ) ) ) )).

% less_induct
thf(fact_99_le__dag__def,axiom,
    ( ( ord_less_eq @ binDag_Mirabelle_dag )
    = ( ^ [S: binDag_Mirabelle_dag,T2: binDag_Mirabelle_dag] :
          ( ( S = T2 )
          | ( ord_less @ binDag_Mirabelle_dag @ S @ T2 ) ) ) )).

% le_dag_def
thf(fact_100_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) )).

% antisym_conv3
thf(fact_101_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) )).

% less_imp_not_eq2
thf(fact_102_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,P2: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P2 ) ) ) )).

% less_imp_triv
thf(fact_103_dag__less__le,axiom,
    ( ( ord_less @ binDag_Mirabelle_dag )
    = ( ^ [X2: binDag_Mirabelle_dag,Y2: binDag_Mirabelle_dag] :
          ( ( ord_less_eq @ binDag_Mirabelle_dag @ X2 @ Y2 )
          & ( X2 != Y2 ) ) ) )).

% dag_less_le
thf(fact_104_le__dag__refl,axiom,(
    ! [X: binDag_Mirabelle_dag] :
      ( ord_less_eq @ binDag_Mirabelle_dag @ X @ X ) )).

% le_dag_refl
thf(fact_105_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% linorder_cases
thf(fact_106_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ~ ( ord_less @ A @ A4 @ A4 ) ) )).

% dual_order.irrefl
thf(fact_107_le__dag__trans,axiom,(
    ! [X: binDag_Mirabelle_dag,Y: binDag_Mirabelle_dag,Z: binDag_Mirabelle_dag] :
      ( ( ord_less_eq @ binDag_Mirabelle_dag @ X @ Y )
     => ( ( ord_less_eq @ binDag_Mirabelle_dag @ Y @ Z )
       => ( ord_less_eq @ binDag_Mirabelle_dag @ X @ Z ) ) ) )).

% le_dag_trans
thf(fact_108_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less @ A @ B4 @ C )
           => ( ord_less @ A @ A4 @ C ) ) ) ) )).

% order.strict_trans
thf(fact_109_less__dag__Node,axiom,(
    ! [X: binDag_Mirabelle_dag,L: binDag_Mirabelle_dag,A4: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X @ ( binDag476092410e_Node @ L @ A4 @ R ) )
      = ( ( ord_less_eq @ binDag_Mirabelle_dag @ X @ L )
        | ( ord_less_eq @ binDag_Mirabelle_dag @ X @ R ) ) ) )).

% less_dag_Node
thf(fact_110_le__dag__antisym,axiom,(
    ! [X: binDag_Mirabelle_dag,Y: binDag_Mirabelle_dag] :
      ( ( ord_less_eq @ binDag_Mirabelle_dag @ X @ Y )
     => ( ( ord_less_eq @ binDag_Mirabelle_dag @ Y @ X )
       => ( X = Y ) ) ) )).

% le_dag_antisym
thf(fact_111_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_imp_not_less
thf(fact_112_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( ( ord_less @ A @ C @ B4 )
           => ( ord_less @ A @ C @ A4 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_113_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_114_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( A4 != B4 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_115_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( A4 != B4 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_116_less__dag__Node_H,axiom,(
    ! [X: binDag_Mirabelle_dag,L: binDag_Mirabelle_dag,A4: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X @ ( binDag476092410e_Node @ L @ A4 @ R ) )
      = ( ( X = L )
        | ( X = R )
        | ( ord_less @ binDag_Mirabelle_dag @ X @ L )
        | ( ord_less @ binDag_Mirabelle_dag @ X @ R ) ) ) )).

% less_dag_Node'
thf(fact_117_less__Node__dag,axiom,(
    ! [L: binDag_Mirabelle_dag,A4: simpl_ref,R: binDag_Mirabelle_dag,X: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ ( binDag476092410e_Node @ L @ A4 @ R ) @ X )
     => ( ( ord_less @ binDag_Mirabelle_dag @ L @ X )
        & ( ord_less @ binDag_Mirabelle_dag @ R @ X ) ) ) )).

% less_Node_dag
thf(fact_118_less__dag__Tip,axiom,(
    ! [X: binDag_Mirabelle_dag] :
      ~ ( ord_less @ binDag_Mirabelle_dag @ X @ binDag_Mirabelle_Tip ) )).

% less_dag_Tip
thf(fact_119_dag_Oexhaust,axiom,(
    ! [Y: binDag_Mirabelle_dag] :
      ( ( Y != binDag_Mirabelle_Tip )
     => ~ ( ! [X212: binDag_Mirabelle_dag,X222: simpl_ref,X232: binDag_Mirabelle_dag] :
              ( Y
             != ( binDag476092410e_Node @ X212 @ X222 @ X232 ) ) ) ) )).

% dag.exhaust
thf(fact_120_dag_Oinduct,axiom,(
    ! [P2: ( binDag_Mirabelle_dag > $o ),Dag: binDag_Mirabelle_dag] :
      ( ( P2 @ binDag_Mirabelle_Tip )
     => ( ! [X1: binDag_Mirabelle_dag,X24: simpl_ref,X32: binDag_Mirabelle_dag] :
            ( ( P2 @ X1 )
           => ( ( P2 @ X32 )
             => ( P2 @ ( binDag476092410e_Node @ X1 @ X24 @ X32 ) ) ) )
       => ( P2 @ Dag ) ) ) )).

% dag.induct
thf(fact_121_dag_Odistinct_I1_J,axiom,(
    ! [X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( binDag_Mirabelle_Tip
     != ( binDag476092410e_Node @ X21 @ X22 @ X23 ) ) )).

% dag.distinct(1)
thf(fact_122_leD,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) )).

% leD
thf(fact_123_leI,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) )).

% leI
thf(fact_124_le__less,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less @ A @ X2 @ Y2 )
              | ( X2 = Y2 ) ) ) ) ) )).

% le_less
thf(fact_125_less__le,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
              & ( X2 != Y2 ) ) ) ) ) )).

% less_le
thf(fact_126_order__le__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( ord_less_eq @ A @ A4 @ ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_127_order__le__less__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less @ C2 @ ( F @ B4 ) @ C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ C2 @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ C2 @ ( F @ A4 ) @ C ) ) ) ) ) )).

% order_le_less_subst2
thf(fact_128_order__less__le__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( ord_less @ A @ A4 @ ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_129_order__less__le__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ C2 @ ( F @ B4 ) @ C )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ C2 @ ( F @ X3 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ C2 @ ( F @ A4 ) @ C ) ) ) ) ) )).

% order_less_le_subst2
thf(fact_130_not__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) )).

% not_le
thf(fact_131_not__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) )).

% not_less
thf(fact_132_le__neq__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( A4 != B4 )
           => ( ord_less @ A @ A4 @ B4 ) ) ) ) )).

% le_neq_trans
thf(fact_133_less__imp__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) )).

% less_imp_le
thf(fact_134_antisym__conv1,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) )).

% antisym_conv1
thf(fact_135_antisym__conv2,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) )).

% antisym_conv2
thf(fact_136_le__less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) )).

% le_less_trans
thf(fact_137_less__le__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) )).

% less_le_trans
thf(fact_138_dense__ge,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z: A,Y: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z @ X3 )
             => ( ord_less_eq @ A @ Y @ X3 ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) )).

% dense_ge
thf(fact_139_dense__le,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) )).

% dense_le
thf(fact_140_le__less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) )).

% le_less_linear
thf(fact_141_le__imp__less__or__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) )).

% le_imp_less_or_eq
thf(fact_142_less__le__not__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y2: A] :
              ( ( ord_less_eq @ A @ X2 @ Y2 )
              & ~ ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) )).

% less_le_not_le
thf(fact_143_not__le__imp__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) )).

% not_le_imp_less
thf(fact_144_order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less @ A @ B4 @ C )
           => ( ord_less @ A @ A4 @ C ) ) ) ) )).

% order.strict_trans1
thf(fact_145_order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ C )
           => ( ord_less @ A @ A4 @ C ) ) ) ) )).

% order.strict_trans2
thf(fact_146_order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less @ A @ A3 @ B3 )
              | ( A3 = B3 ) ) ) ) ) )).

% order.order_iff_strict
thf(fact_147_order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( A3 != B3 ) ) ) ) ) )).

% order.strict_iff_order
thf(fact_148_dual__order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C: A] :
          ( ( ord_less_eq @ A @ B4 @ A4 )
         => ( ( ord_less @ A @ C @ B4 )
           => ( ord_less @ A @ C @ A4 ) ) ) ) )).

% dual_order.strict_trans1
thf(fact_149_dual__order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( ( ord_less_eq @ A @ C @ B4 )
           => ( ord_less @ A @ C @ A4 ) ) ) ) )).

% dual_order.strict_trans2
thf(fact_150_dense__ge__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y @ W ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) )).

% dense_ge_bounded
thf(fact_151_dense__le__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y )
                 => ( ord_less_eq @ A @ W @ Z ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) )).

% dense_le_bounded
thf(fact_152_order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ord_less_eq @ A @ A4 @ B4 ) ) ) )).

% order.strict_implies_order
thf(fact_153_dual__order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less @ A @ B3 @ A3 )
              | ( A3 = B3 ) ) ) ) ) )).

% dual_order.order_iff_strict
thf(fact_154_dual__order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( A3 != B3 ) ) ) ) ) )).

% dual_order.strict_iff_order
thf(fact_155_dual__order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( ord_less_eq @ A @ B4 @ A4 ) ) ) )).

% dual_order.strict_implies_order
thf(fact_156_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( A4 != B4 )
         => ( ( ord_less_eq @ A @ A4 @ B4 )
           => ( ord_less @ A @ A4 @ B4 ) ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_157_in__set__sublistD,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ( member2 @ A @ X @ ( set2 @ A @ ( sublist @ A @ Xs @ I ) ) )
     => ( member2 @ A @ X @ ( set2 @ A @ Xs ) ) ) )).

% in_set_sublistD
thf(fact_158_notin__set__sublistI,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ~ ( member2 @ A @ X @ ( set2 @ A @ ( sublist @ A @ Xs @ I ) ) ) ) )).

% notin_set_sublistI
thf(fact_159_minf_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z4 )
         => ~ ( ord_less_eq @ A @ T @ X4 ) ) ) )).

% minf(8)
thf(fact_160_minf_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z4 )
         => ( ord_less_eq @ A @ X4 @ T ) ) ) )).

% minf(6)
thf(fact_161_pinf_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z4 @ X4 )
         => ( ord_less_eq @ A @ T @ X4 ) ) ) )).

% pinf(8)
thf(fact_162_pinf_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z4 @ X4 )
         => ~ ( ord_less_eq @ A @ X4 @ T ) ) ) )).

% pinf(6)
thf(fact_163_complete__interval,axiom,(
    ! [A: $tType] :
      ( ( condit1037483654norder @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,P2: ( A > $o )] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( P2 @ A4 )
           => ( ~ ( P2 @ B4 )
             => ? [C4: A] :
                  ( ( ord_less_eq @ A @ A4 @ C4 )
                  & ( ord_less_eq @ A @ C4 @ B4 )
                  & ! [X4: A] :
                      ( ( ( ord_less_eq @ A @ A4 @ X4 )
                        & ( ord_less @ A @ X4 @ C4 ) )
                     => ( P2 @ X4 ) )
                  & ! [D2: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A4 @ X3 )
                            & ( ord_less @ A @ X3 @ D2 ) )
                         => ( P2 @ X3 ) )
                     => ( ord_less_eq @ A @ D2 @ C4 ) ) ) ) ) ) ) )).

% complete_interval
thf(fact_164_DAG_Osimps_I2_J,axiom,(
    ! [L: binDag_Mirabelle_dag,A4: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_DAG @ ( binDag476092410e_Node @ L @ A4 @ R ) )
      = ( ~ ( member2 @ simpl_ref @ A4 @ ( binDag1380252983set_of @ L ) )
        & ~ ( member2 @ simpl_ref @ A4 @ ( binDag1380252983set_of @ R ) )
        & ( binDag_Mirabelle_DAG @ L )
        & ( binDag_Mirabelle_DAG @ R ) ) ) )).

% DAG.simps(2)
thf(fact_165_psubsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( A2 != B2 )
       => ( ord_less @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% psubsetI
thf(fact_166_subset__iff__psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( ( ord_less @ ( set @ A ) @ A6 @ B6 )
            | ( A6 = B6 ) ) ) ) )).

% subset_iff_psubset_eq
thf(fact_167_subset__psubset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% subset_psubset_trans
thf(fact_168_subset__not__subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) ) )).

% subset_not_subset_eq
thf(fact_169_psubset__subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% psubset_subset_trans
thf(fact_170_psubset__imp__subset,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% psubset_imp_subset
thf(fact_171_psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
            & ( A6 != B6 ) ) ) ) )).

% psubset_eq
thf(fact_172_psubsetE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
         => ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) ) )).

% psubsetE
thf(fact_173_less__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B )] :
              ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F2 ) ) ) ) ) )).

% less_fun_def
thf(fact_174_less__DAG__set__of,axiom,(
    ! [X: binDag_Mirabelle_dag,Y: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X @ Y )
     => ( ( binDag_Mirabelle_DAG @ Y )
       => ( ord_less @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ X ) @ ( binDag1380252983set_of @ Y ) ) ) ) )).

% less_DAG_set_of
thf(fact_175_DAG_Osimps_I1_J,axiom,
    ( binDag_Mirabelle_DAG @ binDag_Mirabelle_Tip )).

% DAG.simps(1)
thf(fact_176_DAG__less,axiom,(
    ! [Y: binDag_Mirabelle_dag,X: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_DAG @ Y )
     => ( ( ord_less @ binDag_Mirabelle_dag @ X @ Y )
       => ( binDag_Mirabelle_DAG @ X ) ) ) )).

% DAG_less
thf(fact_177_minf_I11_J,axiom,(
    ! [C2: $tType,D3: $tType] :
      ( ( ord @ C2 @ ( type2 @ C2 ) )
     => ! [F3: D3] :
        ? [Z4: C2] :
        ! [X4: C2] :
          ( ( ord_less @ C2 @ X4 @ Z4 )
         => ( F3 = F3 ) ) ) )).

% minf(11)
thf(fact_178_minf_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z4 )
         => ~ ( ord_less @ A @ T @ X4 ) ) ) )).

% minf(7)
thf(fact_179_minf_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z4 )
         => ( ord_less @ A @ X4 @ T ) ) ) )).

% minf(5)
thf(fact_180_minf_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z4 )
         => ( X4 != T ) ) ) )).

% minf(4)
thf(fact_181_minf_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z4 )
         => ( X4 != T ) ) ) )).

% minf(3)
thf(fact_182_minf_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z5: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z5 )
             => ( ( P2 @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z5 )
               => ( ( Q2 @ X3 )
                  = ( Q3 @ X3 ) ) )
           => ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ X4 @ Z4 )
               => ( ( ( P2 @ X4 )
                    | ( Q2 @ X4 ) )
                  = ( ( P3 @ X4 )
                    | ( Q3 @ X4 ) ) ) ) ) ) ) )).

% minf(2)
thf(fact_183_minf_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z5: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z5 )
             => ( ( P2 @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z5 )
               => ( ( Q2 @ X3 )
                  = ( Q3 @ X3 ) ) )
           => ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ X4 @ Z4 )
               => ( ( ( P2 @ X4 )
                    & ( Q2 @ X4 ) )
                  = ( ( P3 @ X4 )
                    & ( Q3 @ X4 ) ) ) ) ) ) ) )).

% minf(1)
thf(fact_184_pinf_I11_J,axiom,(
    ! [C2: $tType,D3: $tType] :
      ( ( ord @ C2 @ ( type2 @ C2 ) )
     => ! [F3: D3] :
        ? [Z4: C2] :
        ! [X4: C2] :
          ( ( ord_less @ C2 @ Z4 @ X4 )
         => ( F3 = F3 ) ) ) )).

% pinf(11)
thf(fact_185_pinf_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z4 @ X4 )
         => ( ord_less @ A @ T @ X4 ) ) ) )).

% pinf(7)
thf(fact_186_pinf_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z4 @ X4 )
         => ~ ( ord_less @ A @ X4 @ T ) ) ) )).

% pinf(5)
thf(fact_187_pinf_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z4 @ X4 )
         => ( X4 != T ) ) ) )).

% pinf(4)
thf(fact_188_pinf_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z4: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z4 @ X4 )
         => ( X4 != T ) ) ) )).

% pinf(3)
thf(fact_189_pinf_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z5: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z5 @ X3 )
             => ( ( P2 @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z5 @ X3 )
               => ( ( Q2 @ X3 )
                  = ( Q3 @ X3 ) ) )
           => ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ Z4 @ X4 )
               => ( ( ( P2 @ X4 )
                    | ( Q2 @ X4 ) )
                  = ( ( P3 @ X4 )
                    | ( Q3 @ X4 ) ) ) ) ) ) ) )).

% pinf(2)
thf(fact_190_pinf_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P2: ( A > $o ),P3: ( A > $o ),Q2: ( A > $o ),Q3: ( A > $o )] :
          ( ? [Z5: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z5 @ X3 )
             => ( ( P2 @ X3 )
                = ( P3 @ X3 ) ) )
         => ( ? [Z5: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z5 @ X3 )
               => ( ( Q2 @ X3 )
                  = ( Q3 @ X3 ) ) )
           => ? [Z4: A] :
              ! [X4: A] :
                ( ( ord_less @ A @ Z4 @ X4 )
               => ( ( ( P2 @ X4 )
                    & ( Q2 @ X4 ) )
                  = ( ( P3 @ X4 )
                    & ( Q3 @ X4 ) ) ) ) ) ) ) )).

% pinf(1)
thf(fact_191_ex__gt__or__lt,axiom,(
    ! [A: $tType] :
      ( ( condit1656338222tinuum @ A @ ( type2 @ A ) )
     => ! [A4: A] :
        ? [B5: A] :
          ( ( ord_less @ A @ A4 @ B5 )
          | ( ord_less @ A @ B5 @ A4 ) ) ) )).

% ex_gt_or_lt
thf(fact_192_remove__code_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( remove @ A @ X @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( insert @ A @ X @ Xs ) ) ) )).

% remove_code(2)
thf(fact_193_in__set__of__decomp,axiom,(
    ! [P: simpl_ref,T: binDag_Mirabelle_dag] :
      ( ( member2 @ simpl_ref @ P @ ( binDag1380252983set_of @ T ) )
      = ( ? [L2: binDag_Mirabelle_dag,R2: binDag_Mirabelle_dag] :
            ( ( T
              = ( binDag476092410e_Node @ L2 @ P @ R2 ) )
            | ( binDag786255756subdag @ T @ ( binDag476092410e_Node @ L2 @ P @ R2 ) ) ) ) ) )).

% in_set_of_decomp
thf(fact_194_subset__code_I3_J,axiom,(
    ! [C2: $tType] :
      ~ ( ord_less_eq @ ( set @ C2 ) @ ( coset @ C2 @ ( nil @ C2 ) ) @ ( set2 @ C2 @ ( nil @ C2 ) ) ) )).

% subset_code(3)
thf(fact_195_member__remove,axiom,(
    ! [A: $tType,X: A,Y: A,A2: ( set @ A )] :
      ( ( member2 @ A @ X @ ( remove @ A @ Y @ A2 ) )
      = ( ( member2 @ A @ X @ A2 )
        & ( X != Y ) ) ) )).

% member_remove
thf(fact_196_sublist__nil,axiom,(
    ! [A: $tType,A2: ( set @ nat )] :
      ( ( sublist @ A @ ( nil @ A ) @ A2 )
      = ( nil @ A ) ) )).

% sublist_nil
thf(fact_197_psubsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ C @ A2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% psubsetD
thf(fact_198_psubset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% psubset_trans
thf(fact_199_subdag__not__sym,axiom,(
    ! [S2: binDag_Mirabelle_dag,T: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ S2 @ T )
     => ~ ( binDag786255756subdag @ T @ S2 ) ) )).

% subdag_not_sym
thf(fact_200_subdag__trans,axiom,(
    ! [T: binDag_Mirabelle_dag,S2: binDag_Mirabelle_dag,R: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T @ S2 )
     => ( ( binDag786255756subdag @ S2 @ R )
       => ( binDag786255756subdag @ T @ R ) ) ) )).

% subdag_trans
thf(fact_201_subdag__neq,axiom,(
    ! [T: binDag_Mirabelle_dag,S2: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T @ S2 )
     => ( T != S2 ) ) )).

% subdag_neq
thf(fact_202_member__rec_I2_J,axiom,(
    ! [A: $tType,Y: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y ) )).

% member_rec(2)
thf(fact_203_subdag__NodeD,axiom,(
    ! [T: binDag_Mirabelle_dag,Lt2: binDag_Mirabelle_dag,A4: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T @ ( binDag476092410e_Node @ Lt2 @ A4 @ Rt2 ) )
     => ( ( binDag786255756subdag @ T @ Lt2 )
        & ( binDag786255756subdag @ T @ Rt2 ) ) ) )).

% subdag_NodeD
thf(fact_204_subdag_Osimps_I2_J,axiom,(
    ! [L: binDag_Mirabelle_dag,A4: simpl_ref,R: binDag_Mirabelle_dag,T: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ ( binDag476092410e_Node @ L @ A4 @ R ) @ T )
      = ( ( T = L )
        | ( T = R )
        | ( binDag786255756subdag @ L @ T )
        | ( binDag786255756subdag @ R @ T ) ) ) )).

% subdag.simps(2)
thf(fact_205_subdag_Osimps_I1_J,axiom,(
    ! [T: binDag_Mirabelle_dag] :
      ~ ( binDag786255756subdag @ binDag_Mirabelle_Tip @ T ) )).

% subdag.simps(1)
thf(fact_206_less__dag__def,axiom,
    ( ( ord_less @ binDag_Mirabelle_dag )
    = ( ^ [S: binDag_Mirabelle_dag,T2: binDag_Mirabelle_dag] :
          ( binDag786255756subdag @ T2 @ S ) ) )).

% less_dag_def
thf(fact_207_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ~ ( list_ex1 @ A @ P2 @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_208_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_209_list__bind__cong,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),F: ( A > ( list @ B ) ),G: ( A > ( list @ B ) )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( bind @ A @ B @ Xs @ F )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) )).

% list_bind_cong
thf(fact_210_list__ex1__iff,axiom,(
    ! [A: $tType] :
      ( ( list_ex1 @ A )
      = ( ^ [P4: ( A > $o ),Xs2: ( list @ A )] :
          ? [X2: A] :
            ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs2 ) )
            & ( P4 @ X2 )
            & ! [Y2: A] :
                ( ( ( member2 @ A @ Y2 @ ( set2 @ A @ Xs2 ) )
                  & ( P4 @ Y2 ) )
               => ( Y2 = X2 ) ) ) ) ) )).

% list_ex1_iff
thf(fact_211_can__select__set__list__ex1,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: ( list @ A )] :
      ( ( can_select @ A @ P2 @ ( set2 @ A @ A2 ) )
      = ( list_ex1 @ A @ P2 @ A2 ) ) )).

% can_select_set_list_ex1
thf(fact_212_remove__code_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( remove @ A @ X @ ( set2 @ A @ Xs ) )
      = ( set2 @ A @ ( removeAll @ A @ X @ Xs ) ) ) )).

% remove_code(1)
thf(fact_213_removeAll__id,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X @ Xs )
        = Xs ) ) )).

% removeAll_id
thf(fact_214_can__select__def,axiom,(
    ! [A: $tType] :
      ( ( can_select @ A )
      = ( ^ [P4: ( A > $o ),A6: ( set @ A )] :
          ? [X2: A] :
            ( ( member2 @ A @ X2 @ A6 )
            & ( P4 @ X2 )
            & ! [Y2: A] :
                ( ( ( member2 @ A @ Y2 @ A6 )
                  & ( P4 @ Y2 ) )
               => ( Y2 = X2 ) ) ) ) ) )).

% can_select_def
thf(fact_215_removeAll_Osimps_I1_J,axiom,(
    ! [A: $tType,X: A] :
      ( ( removeAll @ A @ X @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% removeAll.simps(1)
thf(fact_216_linorder__neqE__linordered__idom,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_217_linordered__field__no__ub,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X4: A] :
        ? [X1: A] :
          ( ord_less @ A @ X4 @ X1 ) ) )).

% linordered_field_no_ub
thf(fact_218_linordered__field__no__lb,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X4: A] :
        ? [Y4: A] :
          ( ord_less @ A @ Y4 @ X4 ) ) )).

% linordered_field_no_lb
thf(fact_219_dependent__wellorder__choice,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P2: ( ( A > B ) > A > B > $o )] :
          ( ! [R3: B,F4: ( A > B ),G3: ( A > B ),X3: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X3 )
                 => ( ( F4 @ Y5 )
                    = ( G3 @ Y5 ) ) )
             => ( ( P2 @ F4 @ X3 @ R3 )
                = ( P2 @ G3 @ X3 @ R3 ) ) )
         => ( ! [X3: A,F4: ( A > B )] :
                ( ! [Y5: A] :
                    ( ( ord_less @ A @ Y5 @ X3 )
                   => ( P2 @ F4 @ Y5 @ ( F4 @ Y5 ) ) )
               => ? [X12: B] :
                    ( P2 @ F4 @ X3 @ X12 ) )
           => ? [F4: ( A > B )] :
              ! [X4: A] :
                ( P2 @ F4 @ X4 @ ( F4 @ X4 ) ) ) ) ) )).

% dependent_wellorder_choice
thf(fact_220_dag_Osimps_I6_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A )] :
      ( ( binDag1442713106ec_dag @ A @ F1 @ F22 @ binDag_Mirabelle_Tip )
      = F1 ) )).

% dag.simps(6)
thf(fact_221_dag_Osimps_I7_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ),X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1442713106ec_dag @ A @ F1 @ F22 @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( F22 @ X21 @ X22 @ X23 @ ( binDag1442713106ec_dag @ A @ F1 @ F22 @ X21 ) @ ( binDag1442713106ec_dag @ A @ F1 @ F22 @ X23 ) ) ) )).

% dag.simps(7)
thf(fact_222_chain__subset__def,axiom,(
    ! [A: $tType] :
      ( ( chain_subset @ A )
      = ( ^ [C5: ( set @ ( set @ A ) )] :
          ! [X2: ( set @ A )] :
            ( ( member2 @ ( set @ A ) @ X2 @ C5 )
           => ! [Y2: ( set @ A )] :
                ( ( member2 @ ( set @ A ) @ Y2 @ C5 )
               => ( ( ord_less_eq @ ( set @ A ) @ X2 @ Y2 )
                  | ( ord_less_eq @ ( set @ A ) @ Y2 @ X2 ) ) ) ) ) ) )).

% chain_subset_def
thf(fact_223_dag_Osimps_I4_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A )] :
      ( ( binDag1297733282se_dag @ A @ F1 @ F22 @ binDag_Mirabelle_Tip )
      = F1 ) )).

% dag.simps(4)
thf(fact_224_dag_Osimps_I5_J,axiom,(
    ! [A: $tType,F1: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ),X21: binDag_Mirabelle_dag,X22: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1297733282se_dag @ A @ F1 @ F22 @ ( binDag476092410e_Node @ X21 @ X22 @ X23 ) )
      = ( F22 @ X21 @ X22 @ X23 ) ) )).

% dag.simps(5)
thf(fact_225_sublist__empty,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( sublist @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) )).

% sublist_empty
thf(fact_226_not__in__set__insert,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ~ ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = ( cons @ A @ X @ Xs ) ) ) )).

% not_in_set_insert
thf(fact_227_bot__apply,axiom,(
    ! [C2: $tType,D3: $tType] :
      ( ( bot @ C2 @ ( type2 @ C2 ) )
     => ( ( bot_bot @ ( D3 > C2 ) )
        = ( ^ [X2: D3] :
              ( bot_bot @ C2 ) ) ) ) )).

% bot_apply
thf(fact_228_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member2 @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_229_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X2: A] :
            ~ ( member2 @ A @ X2 @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_230_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P2 @ X2 ) ) ) )).

% Collect_empty_eq
thf(fact_231_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X2: A] :
            ~ ( P2 @ X2 ) ) ) )).

% empty_Collect_eq
thf(fact_232_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_233_empty__subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) )).

% empty_subsetI
thf(fact_234_subset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_235_set__empty2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% set_empty2
thf(fact_236_set__empty,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% set_empty
thf(fact_237_insert__Nil,axiom,(
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_238_List_Oinsert__def,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X2: A,Xs2: ( list @ A )] :
            ( if @ ( list @ A ) @ ( member2 @ A @ X2 @ ( set2 @ A @ Xs2 ) ) @ Xs2 @ ( cons @ A @ X2 @ Xs2 ) ) ) ) )).

% List.insert_def
thf(fact_239_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( bot_bot @ A ) )
         => ( A4
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_240_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( bot_bot @ A ) )
          = ( A4
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_241_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A4 ) ) )).

% bot.extremum
thf(fact_242_list_Oset__cases,axiom,(
    ! [A: $tType,E: A,A4: ( list @ A )] :
      ( ( member2 @ A @ E @ ( set2 @ A @ A4 ) )
     => ( ! [Z22: ( list @ A )] :
            ( A4
           != ( cons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( list @ A )] :
                ( ( A4
                  = ( cons @ A @ Z1 @ Z22 ) )
               => ~ ( member2 @ A @ E @ ( set2 @ A @ Z22 ) ) ) ) ) ) )).

% list.set_cases
thf(fact_243_set__ConsD,axiom,(
    ! [A: $tType,Y: A,X: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ Y @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
     => ( ( Y = X )
        | ( member2 @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) )).

% set_ConsD
thf(fact_244_list_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( list @ A )] :
      ( member2 @ A @ A1 @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) )).

% list.set_intros(1)
thf(fact_245_list_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( list @ A ),A1: A] :
      ( ( member2 @ A @ X @ ( set2 @ A @ A22 ) )
     => ( member2 @ A @ X @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) ) )).

% list.set_intros(2)
thf(fact_246_member__rec_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A] :
      ( ( member @ A @ ( cons @ A @ X @ Xs ) @ Y )
      = ( ( X = Y )
        | ( member @ A @ Xs @ Y ) ) ) )).

% member_rec(1)
thf(fact_247_emptyE,axiom,(
    ! [A: $tType,A4: A] :
      ~ ( member2 @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_248_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A4: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member2 @ A @ A4 @ A2 ) ) )).

% equals0D
thf(fact_249_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y4: A] :
          ~ ( member2 @ A @ Y4 @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_250_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X2: A] :
            ( member2 @ A @ X2 @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_251_not__Cons__self2,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_252_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X2: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_253_set__subset__Cons,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) ) )).

% set_subset_Cons
thf(fact_254_empty__set,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) )).

% empty_set

%----Type constructors (28)
thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order_bot @ A8 @ ( type2 @ A8 ) )
     => ( order_bot @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( preorder @ A8 @ ( type2 @ A8 ) )
     => ( preorder @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order @ A8 @ ( type2 @ A8 ) )
     => ( order @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( bot @ A8 @ ( type2 @ A8 ) )
     => ( bot @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    ( condit1037483654norder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_1,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_2,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Ono__top,axiom,
    ( no_top @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_3,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_4,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_5,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_6,axiom,(
    ! [A7: $tType] :
      ( order_bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_7,axiom,(
    ! [A7: $tType] :
      ( preorder @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_8,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_9,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_10,axiom,(
    ! [A7: $tType] :
      ( bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_11,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_12,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_13,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_14,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_15,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_16,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Orderings_Opreorder_17,axiom,
    ( preorder @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Orderings_Oorder_18,axiom,
    ( order @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Orderings_Oord_19,axiom,
    ( ord @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,
    ( ord_less_eq @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ t ) @ ( set2 @ simpl_ref @ alloc ) )).

thf(conj_1,conjecture,
    ( ( binDag_Mirabelle_Dag @ p @ ( fun_upd @ simpl_ref @ simpl_ref @ l @ ( simpl_new @ ( set2 @ simpl_ref @ alloc ) ) @ x ) @ r @ t )
    = ( binDag_Mirabelle_Dag @ p @ l @ r @ t ) )).

%------------------------------------------------------------------------------
