%------------------------------------------------------------------------------
% File     : COM171^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Binary decision diagram 424
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [OS08]  Ortner & Schirmer (2008), BDD Normalisation
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : bindag__424.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  457 (   1 unit;  95 type;   0 defn)
%            Number of atoms       : 4420 ( 290 equality;2346 variable)
%            Maximal formula depth :   28 (   8 average)
%            Number of connectives : 3958 ( 108   ~;  11   |;  64   &;3540   @)
%                                         (   0 <=>; 235  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  421 ( 421   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   99 (  95   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1172 (  11 sgn; 972   !;  26   ?;  91   ^)
%                                         (1172   :;  83  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:46:49.021
%------------------------------------------------------------------------------
%----Could-be-implicit typings (13)
thf(ty_t_BinDag__Mirabelle__rybootvolr_Odag,type,(
    binDag_Mirabelle_dag: $tType )).

thf(ty_t_Code__Numeral_Onatural,type,(
    code_natural: $tType )).

thf(ty_t_Code__Evaluation_Oterm,type,(
    code_term: $tType )).

thf(ty_t_Product__Type_Ounit,type,(
    product_unit: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Simpl__Heap_Oref,type,(
    simpl_ref: $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_Int_Oint,type,(
    int: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (82)
thf(sy_cl_Typerep_Otyperep,type,(
    typerep: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Enum_Oenum,type,(
    enum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Code__Evaluation_Oterm__of,type,(
    code_term_of: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Oequal,type,(
    cl_HOL_Oequal: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__1,type,(
    semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Quickcheck__Random_Orandom,type,(
    quickcheck_random: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Divides_Osemiring__numeral__div,type,(
    semiring_numeral_div: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Quickcheck__Exhaustive_Oexhaustive,type,(
    quickc1261659869ustive: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,(
    semiri134348788visors: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Quickcheck__Exhaustive_Ofull__exhaustive,type,(
    quickc2099533868ustive: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_ODAG,type,(
    binDag_Mirabelle_DAG: binDag_Mirabelle_dag > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_ODag,type,(
    binDag_Mirabelle_Dag: simpl_ref > ( simpl_ref > simpl_ref ) > ( simpl_ref > simpl_ref ) > binDag_Mirabelle_dag > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag,type,(
    binDag_Mirabelle_dag2: simpl_ref > ( simpl_ref > simpl_ref ) > ( simpl_ref > simpl_ref ) > binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_ONode,type,(
    binDag476092410e_Node: binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_OTip,type,(
    binDag_Mirabelle_Tip: binDag_Mirabelle_dag )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Ocase__dag,type,(
    binDag1297733282se_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Orec__dag,type,(
    binDag1442713106ec_dag: 
      !>[A: $tType] :
        ( A > ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ) > binDag_Mirabelle_dag > A ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Odag_Osize__dag,type,(
    binDag1924123185ze_dag: binDag_Mirabelle_dag > nat )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_OisDag,type,(
    binDag1049718334_isDag: simpl_ref > ( simpl_ref > simpl_ref ) > ( simpl_ref > simpl_ref ) > $o )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Oset__of,type,(
    binDag1380252983set_of: binDag_Mirabelle_dag > ( set @ simpl_ref ) )).

thf(sy_c_BinDag__Mirabelle__rybootvolr_Osubdag,type,(
    binDag786255756subdag: binDag_Mirabelle_dag > binDag_Mirabelle_dag > $o )).

thf(sy_c_Code__Numeral_OSuc,type,(
    code_Suc: code_natural > code_natural )).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,(
    code_case_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,(
    code_rec_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__set__natural,type,(
    code_rec_set_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T > $o ) )).

thf(sy_c_Code__Numeral_Onatural_Osize__natural,type,(
    code_size_natural: code_natural > nat )).

thf(sy_c_Divides_Odivmod__nat,type,(
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) )).

thf(sy_c_Divides_Osemiring__numeral__div__class_Odivides__aux,type,(
    semiri577515795es_aux: 
      !>[A: $tType] :
        ( ( product_prod @ A @ A ) > $o ) )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_Fun_Ooverride__on,type,(
    override_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_OThe,type,(
    the: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_HOL_Oinduct__equal,type,(
    induct_equal: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_HOL_Oinduct__false,type,(
    induct_false: $o )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,(
    semiring_1_of_nat: 
      !>[A: $tType] :
        ( nat > A ) )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,(
    semiri532925092at_aux: 
      !>[A: $tType] :
        ( ( A > A ) > nat > A > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Nat__Transfer_Otransfer__morphism,type,(
    nat_tr1645093318rphism: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( B > $o ) > $o ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Power_Opower__class_Opower,type,(
    power_power: 
      !>[A: $tType] :
        ( A > nat > A ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__set__bool,type,(
    product_rec_set_bool: 
      !>[T: $tType] :
        ( T > T > $o > T > $o ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,(
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T > $o ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__set__unit,type,(
    product_rec_set_unit: 
      !>[T: $tType] :
        ( T > product_unit > T > $o ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,(
    product_rec_unit: 
      !>[T: $tType] :
        ( T > product_unit > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_ODomain,type,(
    domain: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) ) )).

thf(sy_c_Relation_OId__on,type,(
    id_on: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Relation_ORange,type,(
    range: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ B ) ) )).

thf(sy_c_Relation_ORangep,type,(
    rangep: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > B > $o ) )).

thf(sy_c_Relation_Oinv__image,type,(
    inv_image: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Simpl__Heap_ONull,type,(
    simpl_Null: simpl_ref )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__set__sum,type,(
    sum_rec_set_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T > $o ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Wellfounded_Oless__than,type,(
    less_than: ( set @ ( product_prod @ nat @ nat ) ) )).

thf(sy_c_Wellfounded_Olex__prod,type,(
    lex_prod: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_Wellfounded_Omeasure,type,(
    measure: 
      !>[A: $tType] :
        ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Wellfounded_Omlex__prod,type,(
    mlex_prod: 
      !>[A: $tType] :
        ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_a__19_058ATP,type,(
    a_19_ATP: binDag_Mirabelle_dag > binDag_Mirabelle_dag )).

thf(sy_v_l,type,(
    l: simpl_ref > simpl_ref )).

thf(sy_v_p,type,(
    p: simpl_ref )).

thf(sy_v_r,type,(
    r: simpl_ref > simpl_ref )).

thf(sy_v_t,type,(
    t: binDag_Mirabelle_dag )).

thf(sy_v_ta,type,(
    ta: binDag_Mirabelle_dag )).

%----Relevant facts (254)
thf(fact_0_Dag__unique__ex__conj__simp,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,P2: ( binDag_Mirabelle_dag > $o )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ( ? [T3: binDag_Mirabelle_dag] :
              ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T3 )
              & ( P2 @ T3 ) ) )
        = ( P2 @ T2 ) ) ) )).

% Dag_unique_ex_conj_simp
thf(fact_1_Dag__unique__all__impl__simp,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,P2: ( binDag_Mirabelle_dag > $o )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ( ! [T3: binDag_Mirabelle_dag] :
              ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T3 )
             => ( P2 @ T3 ) ) )
        = ( P2 @ T2 ) ) ) )).

% Dag_unique_all_impl_simp
thf(fact_2_Dag__unique,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T1: binDag_Mirabelle_dag,T22: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T1 )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T22 )
       => ( T1 = T22 ) ) ) )).

% Dag_unique
thf(fact_3_Dag__unique1,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ? [X: binDag_Mirabelle_dag] :
          ( ( binDag_Mirabelle_Dag @ P @ L @ R @ X )
          & ! [Y: binDag_Mirabelle_dag] :
              ( ( binDag_Mirabelle_Dag @ P @ L @ R @ Y )
             => ( Y = X ) ) ) ) )).

% Dag_unique1
thf(fact_4_dag__def,axiom,
    ( binDag_Mirabelle_dag2
    = ( ^ [P3: simpl_ref,L2: ( simpl_ref > simpl_ref ),R2: ( simpl_ref > simpl_ref )] :
          ( the @ binDag_Mirabelle_dag @ ( binDag_Mirabelle_Dag @ P3 @ L2 @ R2 ) ) ) )).

% dag_def
thf(fact_5_the__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( P2 @ A2 )
     => ( ! [X: A] :
            ( ( P2 @ X )
           => ( X = A2 ) )
       => ( ( the @ A @ P2 )
          = A2 ) ) ) )).

% the_equality
thf(fact_6_the__eq__trivial,axiom,(
    ! [A: $tType,A2: A] :
      ( ( the @ A
        @ ^ [X2: A] : ( X2 = A2 ) )
      = A2 ) )).

% the_eq_trivial
thf(fact_7_the__sym__eq__trivial,axiom,(
    ! [A: $tType,X3: A] :
      ( ( the @ A
        @ ( ^ [Y2: A,Z: A] : ( Y2 = Z )
          @ X3 ) )
      = X3 ) )).

% the_sym_eq_trivial
thf(fact_8_isDag__def,axiom,
    ( binDag1049718334_isDag
    = ( ^ [P3: simpl_ref,L2: ( simpl_ref > simpl_ref ),R2: ( simpl_ref > simpl_ref )] :
          ( ^ [P4: ( binDag_Mirabelle_dag > $o )] :
            ? [X4: binDag_Mirabelle_dag] :
              ( P4 @ X4 )
          @ ( binDag_Mirabelle_Dag @ P3 @ L2 @ R2 ) ) ) )).

% isDag_def
thf(fact_9_theI,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( P2 @ A2 )
     => ( ! [X: A] :
            ( ( P2 @ X )
           => ( X = A2 ) )
       => ( P2 @ ( the @ A @ P2 ) ) ) ) )).

% theI
thf(fact_10_theI_H,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X5 ) ) )
     => ( P2 @ ( the @ A @ P2 ) ) ) )).

% theI'
thf(fact_11_theI2,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A,Q: ( A > $o )] :
      ( ( P2 @ A2 )
     => ( ! [X: A] :
            ( ( P2 @ X )
           => ( X = A2 ) )
       => ( ! [X: A] :
              ( ( P2 @ X )
             => ( Q @ X ) )
         => ( Q @ ( the @ A @ P2 ) ) ) ) ) )).

% theI2
thf(fact_12_If__def,axiom,(
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P5: $o,X2: A,Y4: A] :
            ( the @ A
            @ ^ [Z2: A] :
                ( ( P5
                 => ( Z2 = X2 ) )
                & ( ~ ( P5 )
                 => ( Z2 = Y4 ) ) ) ) ) ) )).

% If_def
thf(fact_13_the1I2,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X5 ) ) )
     => ( ! [X: A] :
            ( ( P2 @ X )
           => ( Q @ X ) )
       => ( Q @ ( the @ A @ P2 ) ) ) ) )).

% the1I2
thf(fact_14_the1__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X5 ) ) )
     => ( ( P2 @ A2 )
       => ( ( the @ A @ P2 )
          = A2 ) ) ) )).

% the1_equality
thf(fact_15_Nitpick_OThe__psimp,axiom,(
    ! [A: $tType,P2: ( A > $o ),X3: A] :
      ( ( P2
        = ( ^ [Y2: A,Z: A] : ( Y2 = Z )
          @ X3 ) )
     => ( ( the @ A @ P2 )
        = X3 ) ) )).

% Nitpick.The_psimp
thf(fact_16_theI__unique,axiom,(
    ! [A: $tType,P2: ( A > $o ),X3: A] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X5 ) ) )
     => ( ( P2 @ X3 )
        = ( X3
          = ( the @ A @ P2 ) ) ) ) )).

% theI_unique
thf(fact_17_Dag__is__DAG,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( binDag_Mirabelle_DAG @ T2 ) ) )).

% Dag_is_DAG
thf(fact_18_Dag__root__not__in__subdag__r,axiom,(
    ! [R: ( simpl_ref > simpl_ref ),P: simpl_ref,L: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ T2 )
     => ~ ( member @ simpl_ref @ P @ ( binDag1380252983set_of @ T2 ) ) ) )).

% Dag_root_not_in_subdag_r
thf(fact_19_Dag__root__not__in__subdag__l,axiom,(
    ! [L: ( simpl_ref > simpl_ref ),P: simpl_ref,R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ T2 )
     => ~ ( member @ simpl_ref @ P @ ( binDag1380252983set_of @ T2 ) ) ) )).

% Dag_root_not_in_subdag_l
thf(fact_20_old_Orec__sum__def,axiom,(
    ! [B: $tType,T: $tType,A: $tType] :
      ( ( sum_rec_sum @ A @ T @ B )
      = ( ^ [F1: ( A > T ),F2: ( B > T ),X2: ( sum_sum @ A @ B )] :
            ( the @ T @ ( sum_rec_set_sum @ A @ T @ B @ F1 @ F2 @ X2 ) ) ) ) )).

% old.rec_sum_def
thf(fact_21_HOL_Oinduct__false__def,axiom,(
    ~ ( induct_false ) )).

% HOL.induct_false_def
thf(fact_22_HOL_Oinduct__equal__def,axiom,(
    ! [A: $tType] :
      ( ( induct_equal @ A )
      = ( ^ [Y2: A,Z: A] : ( Y2 = Z ) ) ) )).

% HOL.induct_equal_def
thf(fact_23_Dag__subdag,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,S: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ( binDag786255756subdag @ T2 @ S )
       => ? [Q2: simpl_ref] :
            ( binDag_Mirabelle_Dag @ Q2 @ L @ R @ S ) ) ) )).

% Dag_subdag
thf(fact_24_old_Orec__unit__def,axiom,(
    ! [T: $tType] :
      ( ( product_rec_unit @ T )
      = ( ^ [F1: T,X2: product_unit] :
            ( the @ T @ ( product_rec_set_unit @ T @ F1 @ X2 ) ) ) ) )).

% old.rec_unit_def
thf(fact_25_rec__natural__def,axiom,(
    ! [T: $tType] :
      ( ( code_rec_natural @ T )
      = ( ^ [F1: T,F2: ( code_natural > T > T ),X2: code_natural] :
            ( the @ T @ ( code_rec_set_natural @ T @ F1 @ F2 @ X2 ) ) ) ) )).

% rec_natural_def
thf(fact_26_subdag__not__sym,axiom,(
    ! [S: binDag_Mirabelle_dag,T2: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ S @ T2 )
     => ~ ( binDag786255756subdag @ T2 @ S ) ) )).

% subdag_not_sym
thf(fact_27_subdag__trans,axiom,(
    ! [T2: binDag_Mirabelle_dag,S: binDag_Mirabelle_dag,R: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T2 @ S )
     => ( ( binDag786255756subdag @ S @ R )
       => ( binDag786255756subdag @ T2 @ R ) ) ) )).

% subdag_trans
thf(fact_28_subdag__neq,axiom,(
    ! [T2: binDag_Mirabelle_dag,S: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T2 @ S )
     => ( T2 != S ) ) )).

% subdag_neq
thf(fact_29_Dags__eq__hp__eq,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,P6: simpl_ref,L3: ( simpl_ref > simpl_ref ),R3: ( simpl_ref > simpl_ref )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ( binDag_Mirabelle_Dag @ P6 @ L3 @ R3 @ T2 )
       => ( ( P6 = P )
          & ! [X5: simpl_ref] :
              ( ( member @ simpl_ref @ X5 @ ( binDag1380252983set_of @ T2 ) )
             => ( ( ( L3 @ X5 )
                  = ( L @ X5 ) )
                & ( ( R3 @ X5 )
                  = ( R @ X5 ) ) ) ) ) ) ) )).

% Dags_eq_hp_eq
thf(fact_30_heaps__eq__DagI1,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,L3: ( simpl_ref > simpl_ref ),R3: ( simpl_ref > simpl_ref )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ! [X: simpl_ref] :
            ( ( member @ simpl_ref @ X @ ( binDag1380252983set_of @ T2 ) )
           => ( ( ( L @ X )
                = ( L3 @ X ) )
              & ( ( R @ X )
                = ( R3 @ X ) ) ) )
       => ( binDag_Mirabelle_Dag @ P @ L3 @ R3 @ T2 ) ) ) )).

% heaps_eq_DagI1
thf(fact_31_heaps__eq__DagI2,axiom,(
    ! [P: simpl_ref,L3: ( simpl_ref > simpl_ref ),R3: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref )] :
      ( ( binDag_Mirabelle_Dag @ P @ L3 @ R3 @ T2 )
     => ( ! [X: simpl_ref] :
            ( ( member @ simpl_ref @ X @ ( binDag1380252983set_of @ T2 ) )
           => ( ( ( L @ X )
                = ( L3 @ X ) )
              & ( ( R @ X )
                = ( R3 @ X ) ) ) )
       => ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 ) ) ) )).

% heaps_eq_DagI2
thf(fact_32_heaps__eq__Dag__eq,axiom,(
    ! [T2: binDag_Mirabelle_dag,L: ( simpl_ref > simpl_ref ),L3: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),R3: ( simpl_ref > simpl_ref ),P: simpl_ref] :
      ( ! [X: simpl_ref] :
          ( ( member @ simpl_ref @ X @ ( binDag1380252983set_of @ T2 ) )
         => ( ( ( L @ X )
              = ( L3 @ X ) )
            & ( ( R @ X )
              = ( R3 @ X ) ) ) )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
        = ( binDag_Mirabelle_Dag @ P @ L3 @ R3 @ T2 ) ) ) )).

% heaps_eq_Dag_eq
thf(fact_33_case__natural__def,axiom,(
    ! [T: $tType] :
      ( ( code_case_natural @ T )
      = ( ^ [F1: T,F2: ( code_natural > T )] :
            ( code_rec_natural @ T @ F1
            @ ^ [X1: code_natural,X22: T] :
                ( F2 @ X1 ) ) ) ) )).

% case_natural_def
thf(fact_34_Null__notin__Dag,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ~ ( member @ simpl_ref @ simpl_Null @ ( binDag1380252983set_of @ T2 ) ) ) )).

% Null_notin_Dag
thf(fact_35_old_Orec__prod__def,axiom,(
    ! [T: $tType,B: $tType,A: $tType] :
      ( ( product_rec_prod @ A @ B @ T )
      = ( ^ [F1: ( A > B > T ),X2: ( product_prod @ A @ B )] :
            ( the @ T @ ( product_rec_set_prod @ A @ B @ T @ F1 @ X2 ) ) ) ) )).

% old.rec_prod_def
thf(fact_36_DAG_Osimps_I2_J,axiom,(
    ! [L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_DAG @ ( binDag476092410e_Node @ L @ A2 @ R ) )
      = ( ~ ( member @ simpl_ref @ A2 @ ( binDag1380252983set_of @ L ) )
        & ~ ( member @ simpl_ref @ A2 @ ( binDag1380252983set_of @ R ) )
        & ( binDag_Mirabelle_DAG @ L )
        & ( binDag_Mirabelle_DAG @ R ) ) ) )).

% DAG.simps(2)
thf(fact_37_in__set__of__decomp,axiom,(
    ! [P: simpl_ref,T2: binDag_Mirabelle_dag] :
      ( ( member @ simpl_ref @ P @ ( binDag1380252983set_of @ T2 ) )
      = ( ? [L2: binDag_Mirabelle_dag,R2: binDag_Mirabelle_dag] :
            ( ( T2
              = ( binDag476092410e_Node @ L2 @ P @ R2 ) )
            | ( binDag786255756subdag @ T2 @ ( binDag476092410e_Node @ L2 @ P @ R2 ) ) ) ) ) )).

% in_set_of_decomp
thf(fact_38_old_Orec__bool__def,axiom,(
    ! [T: $tType] :
      ( ( product_rec_bool @ T )
      = ( ^ [F1: T,F2: T,X2: $o] :
            ( the @ T @ ( product_rec_set_bool @ T @ F1 @ F2 @ X2 ) ) ) ) )).

% old.rec_bool_def
thf(fact_39_Dag__update__lI,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,Q3: simpl_ref,Y5: simpl_ref] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ~ ( member @ simpl_ref @ Q3 @ ( binDag1380252983set_of @ T2 ) )
       => ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ Q3 @ Y5 ) @ R @ T2 ) ) ) )).

% Dag_update_lI
thf(fact_40_Dag__update__rI,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag,Q3: simpl_ref,Y5: simpl_ref] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
     => ( ~ ( member @ simpl_ref @ Q3 @ ( binDag1380252983set_of @ T2 ) )
       => ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ Q3 @ Y5 ) @ T2 ) ) ) )).

% Dag_update_rI
thf(fact_41_notin__Dag__update__l,axiom,(
    ! [Q3: simpl_ref,T2: binDag_Mirabelle_dag,P: simpl_ref,L: ( simpl_ref > simpl_ref ),Y5: simpl_ref,R: ( simpl_ref > simpl_ref )] :
      ( ~ ( member @ simpl_ref @ Q3 @ ( binDag1380252983set_of @ T2 ) )
     => ( ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ Q3 @ Y5 ) @ R @ T2 )
        = ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 ) ) ) )).

% notin_Dag_update_l
thf(fact_42_dag_Oinject,axiom,(
    ! [X21: binDag_Mirabelle_dag,X222: simpl_ref,X23: binDag_Mirabelle_dag,Y21: binDag_Mirabelle_dag,Y22: simpl_ref,Y23: binDag_Mirabelle_dag] :
      ( ( ( binDag476092410e_Node @ X21 @ X222 @ X23 )
        = ( binDag476092410e_Node @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% dag.inject
thf(fact_43_old_Obool_Osimps_I6_J,axiom,(
    ! [T: $tType,F12: T,F22: T] :
      ( ( product_rec_bool @ T @ F12 @ F22 @ $false )
      = F22 ) )).

% old.bool.simps(6)
thf(fact_44_old_Obool_Osimps_I5_J,axiom,(
    ! [T: $tType,F12: T,F22: T] :
      ( ( product_rec_bool @ T @ F12 @ F22 @ $true )
      = F12 ) )).

% old.bool.simps(5)
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P2 @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X: A] :
          ( ( F @ X )
          = ( G @ X ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_notin__Dag__update__r,axiom,(
    ! [Q3: simpl_ref,T2: binDag_Mirabelle_dag,P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),Y5: simpl_ref] :
      ( ~ ( member @ simpl_ref @ Q3 @ ( binDag1380252983set_of @ T2 ) )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ Q3 @ Y5 ) @ T2 )
        = ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 ) ) ) )).

% notin_Dag_update_r
thf(fact_50_Dag__Ref,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ( ( binDag_Mirabelle_Dag @ P @ L @ R @ T2 )
        = ( ? [Lt: binDag_Mirabelle_dag,Rt: binDag_Mirabelle_dag] :
              ( ( T2
                = ( binDag476092410e_Node @ Lt @ P @ Rt ) )
              & ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ Lt )
              & ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ Rt ) ) ) ) ) )).

% Dag_Ref
thf(fact_51_Dag__upd__same__r__lemma,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ~ ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ P @ P ) @ T2 ) ) )).

% Dag_upd_same_r_lemma
thf(fact_52_Dag__upd__same__l__lemma,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( P != simpl_Null )
     => ~ ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ P @ P ) @ R @ T2 ) ) )).

% Dag_upd_same_l_lemma
thf(fact_53_Dag_Osimps_I2_J,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),Lt2: binDag_Mirabelle_dag,A2: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ ( binDag476092410e_Node @ Lt2 @ A2 @ Rt2 ) )
      = ( ( P = A2 )
        & ( P != simpl_Null )
        & ( binDag_Mirabelle_Dag @ ( L @ P ) @ L @ R @ Lt2 )
        & ( binDag_Mirabelle_Dag @ ( R @ P ) @ L @ R @ Rt2 ) ) ) )).

% Dag.simps(2)
thf(fact_54_subdag_Osimps_I2_J,axiom,(
    ! [L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag,T2: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ ( binDag476092410e_Node @ L @ A2 @ R ) @ T2 )
      = ( ( T2 = L )
        | ( T2 = R )
        | ( binDag786255756subdag @ L @ T2 )
        | ( binDag786255756subdag @ R @ T2 ) ) ) )).

% subdag.simps(2)
thf(fact_55_subdag__NodeD,axiom,(
    ! [T2: binDag_Mirabelle_dag,Lt2: binDag_Mirabelle_dag,A2: simpl_ref,Rt2: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T2 @ ( binDag476092410e_Node @ Lt2 @ A2 @ Rt2 ) )
     => ( ( binDag786255756subdag @ T2 @ Lt2 )
        & ( binDag786255756subdag @ T2 @ Rt2 ) ) ) )).

% subdag_NodeD
thf(fact_56_fun__upd__upd,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X3: A,Y5: B,Z3: B] :
      ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F @ X3 @ Y5 ) @ X3 @ Z3 )
      = ( fun_upd @ A @ B @ F @ X3 @ Z3 ) ) )).

% fun_upd_upd
thf(fact_57_fun__upd__triv,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X3: A] :
      ( ( fun_upd @ A @ B @ F @ X3 @ ( F @ X3 ) )
      = F ) )).

% fun_upd_triv
thf(fact_58_fun__upd__apply,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( fun_upd @ B @ A )
      = ( ^ [F3: ( B > A ),X2: B,Y4: A,Z2: B] :
            ( if @ A @ ( Z2 = X2 ) @ Y4 @ ( F3 @ Z2 ) ) ) ) )).

% fun_upd_apply
thf(fact_59_Dag__upd__same__r,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ ( fun_upd @ simpl_ref @ simpl_ref @ R @ P @ P ) @ T2 )
      = ( ( P = simpl_Null )
        & ( T2 = binDag_Mirabelle_Tip ) ) ) )).

% Dag_upd_same_r
thf(fact_60_Dag__upd__same__l,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ P @ ( fun_upd @ simpl_ref @ simpl_ref @ L @ P @ P ) @ R @ T2 )
      = ( ( P = simpl_Null )
        & ( T2 = binDag_Mirabelle_Tip ) ) ) )).

% Dag_upd_same_l
thf(fact_61_Dag__Null,axiom,(
    ! [L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref ),T2: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_Dag @ simpl_Null @ L @ R @ T2 )
      = ( T2 = binDag_Mirabelle_Tip ) ) )).

% Dag_Null
thf(fact_62_Dag_Osimps_I1_J,axiom,(
    ! [P: simpl_ref,L: ( simpl_ref > simpl_ref ),R: ( simpl_ref > simpl_ref )] :
      ( ( binDag_Mirabelle_Dag @ P @ L @ R @ binDag_Mirabelle_Tip )
      = ( P = simpl_Null ) ) )).

% Dag.simps(1)
thf(fact_63_natural_Osimps_I5_J,axiom,(
    ! [T: $tType,F12: T,F22: ( code_natural > T ),Natural: code_natural] :
      ( ( code_case_natural @ T @ F12 @ F22 @ ( code_Suc @ Natural ) )
      = ( F22 @ Natural ) ) )).

% natural.simps(5)
thf(fact_64_natural_Oinject,axiom,(
    ! [Natural: code_natural,Natural2: code_natural] :
      ( ( ( code_Suc @ Natural )
        = ( code_Suc @ Natural2 ) )
      = ( Natural = Natural2 ) ) )).

% natural.inject
thf(fact_65_natural_Osimps_I7_J,axiom,(
    ! [T: $tType,F12: T,F22: ( code_natural > T > T ),Natural: code_natural] :
      ( ( code_rec_natural @ T @ F12 @ F22 @ ( code_Suc @ Natural ) )
      = ( F22 @ Natural @ ( code_rec_natural @ T @ F12 @ F22 @ Natural ) ) ) )).

% natural.simps(7)
thf(fact_66_dag_Oexhaust,axiom,(
    ! [Y5: binDag_Mirabelle_dag] :
      ( ( Y5 != binDag_Mirabelle_Tip )
     => ~ ( ! [X212: binDag_Mirabelle_dag,X223: simpl_ref,X232: binDag_Mirabelle_dag] :
              ( Y5
             != ( binDag476092410e_Node @ X212 @ X223 @ X232 ) ) ) ) )).

% dag.exhaust
thf(fact_67_dag_Oinduct,axiom,(
    ! [P2: ( binDag_Mirabelle_dag > $o ),Dag: binDag_Mirabelle_dag] :
      ( ( P2 @ binDag_Mirabelle_Tip )
     => ( ! [X12: binDag_Mirabelle_dag,X24: simpl_ref,X32: binDag_Mirabelle_dag] :
            ( ( P2 @ X12 )
           => ( ( P2 @ X32 )
             => ( P2 @ ( binDag476092410e_Node @ X12 @ X24 @ X32 ) ) ) )
       => ( P2 @ Dag ) ) ) )).

% dag.induct
thf(fact_68_dag_Odistinct_I1_J,axiom,(
    ! [X21: binDag_Mirabelle_dag,X222: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( binDag_Mirabelle_Tip
     != ( binDag476092410e_Node @ X21 @ X222 @ X23 ) ) )).

% dag.distinct(1)
thf(fact_69_subdag_Osimps_I1_J,axiom,(
    ! [T2: binDag_Mirabelle_dag] :
      ~ ( binDag786255756subdag @ binDag_Mirabelle_Tip @ T2 ) )).

% subdag.simps(1)
thf(fact_70_DAG_Osimps_I1_J,axiom,
    ( binDag_Mirabelle_DAG @ binDag_Mirabelle_Tip )).

% DAG.simps(1)
thf(fact_71_fun__upd__idem__iff,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X3: A,Y5: B] :
      ( ( ( fun_upd @ A @ B @ F @ X3 @ Y5 )
        = F )
      = ( ( F @ X3 )
        = Y5 ) ) )).

% fun_upd_idem_iff
thf(fact_72_fun__upd__twist,axiom,(
    ! [A: $tType,B: $tType,A2: A,C2: A,M: ( A > B ),B2: B,D: B] :
      ( ( A2 != C2 )
     => ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M @ A2 @ B2 ) @ C2 @ D )
        = ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M @ C2 @ D ) @ A2 @ B2 ) ) ) )).

% fun_upd_twist
thf(fact_73_fun__upd__other,axiom,(
    ! [B: $tType,A: $tType,Z3: A,X3: A,F: ( A > B ),Y5: B] :
      ( ( Z3 != X3 )
     => ( ( fun_upd @ A @ B @ F @ X3 @ Y5 @ Z3 )
        = ( F @ Z3 ) ) ) )).

% fun_upd_other
thf(fact_74_fun__upd__same,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),X3: B,Y5: A] :
      ( ( fun_upd @ B @ A @ F @ X3 @ Y5 @ X3 )
      = Y5 ) )).

% fun_upd_same
thf(fact_75_fun__upd__idem,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X3: B,Y5: A] :
      ( ( ( F @ X3 )
        = Y5 )
     => ( ( fun_upd @ B @ A @ F @ X3 @ Y5 )
        = F ) ) )).

% fun_upd_idem
thf(fact_76_fun__upd__eqD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X3: A,Y5: B,G: ( A > B ),Z3: B] :
      ( ( ( fun_upd @ A @ B @ F @ X3 @ Y5 )
        = ( fun_upd @ A @ B @ G @ X3 @ Z3 ) )
     => ( Y5 = Z3 ) ) )).

% fun_upd_eqD
thf(fact_77_fun__upd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_upd @ A @ B )
      = ( ^ [F3: ( A > B ),A4: A,B3: B,X2: A] :
            ( if @ B @ ( X2 = A4 ) @ B3 @ ( F3 @ X2 ) ) ) ) )).

% fun_upd_def
thf(fact_78_dag_Osimps_I4_J,axiom,(
    ! [A: $tType,F12: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A )] :
      ( ( binDag1297733282se_dag @ A @ F12 @ F22 @ binDag_Mirabelle_Tip )
      = F12 ) )).

% dag.simps(4)
thf(fact_79_dag_Osimps_I6_J,axiom,(
    ! [A: $tType,F12: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A )] :
      ( ( binDag1442713106ec_dag @ A @ F12 @ F22 @ binDag_Mirabelle_Tip )
      = F12 ) )).

% dag.simps(6)
thf(fact_80_dag_Osimps_I5_J,axiom,(
    ! [A: $tType,F12: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ),X21: binDag_Mirabelle_dag,X222: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1297733282se_dag @ A @ F12 @ F22 @ ( binDag476092410e_Node @ X21 @ X222 @ X23 ) )
      = ( F22 @ X21 @ X222 @ X23 ) ) )).

% dag.simps(5)
thf(fact_81_dag_Osimps_I7_J,axiom,(
    ! [A: $tType,F12: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A > A > A ),X21: binDag_Mirabelle_dag,X222: simpl_ref,X23: binDag_Mirabelle_dag] :
      ( ( binDag1442713106ec_dag @ A @ F12 @ F22 @ ( binDag476092410e_Node @ X21 @ X222 @ X23 ) )
      = ( F22 @ X21 @ X222 @ X23 @ ( binDag1442713106ec_dag @ A @ F12 @ F22 @ X21 ) @ ( binDag1442713106ec_dag @ A @ F12 @ F22 @ X23 ) ) ) )).

% dag.simps(7)
thf(fact_82_set__of__Tip,axiom,
    ( ( binDag1380252983set_of @ binDag_Mirabelle_Tip )
    = ( bot_bot @ ( set @ simpl_ref ) ) )).

% set_of_Tip
thf(fact_83_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F12: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F12 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F12 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_84_natural_Osimps_I4_J,axiom,(
    ! [T: $tType,F12: T,F22: ( code_natural > T )] :
      ( ( code_case_natural @ T @ F12 @ F22 @ ( zero_zero @ code_natural ) )
      = F12 ) )).

% natural.simps(4)
thf(fact_85_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B4 ) )
      = ( ( A2 = A5 )
        & ( B2 = B4 ) ) ) )).

% old.prod.inject
thf(fact_86_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X13: A,X25: B,Y1: A,Y24: B] :
      ( ( ( product_Pair @ A @ B @ X13 @ X25 )
        = ( product_Pair @ A @ B @ Y1 @ Y24 ) )
      = ( ( X13 = Y1 )
        & ( X25 = Y24 ) ) ) )).

% prod.inject
thf(fact_87_natural_Osimps_I6_J,axiom,(
    ! [T: $tType,F12: T,F22: ( code_natural > T > T )] :
      ( ( code_rec_natural @ T @ F12 @ F22 @ ( zero_zero @ code_natural ) )
      = F12 ) )).

% natural.simps(6)
thf(fact_88_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A6: A,B5: B] :
          ( P2 @ ( product_Pair @ A @ B @ A6 @ B5 ) )
     => ( P2 @ Prod ) ) )).

% old.prod.inducts
thf(fact_89_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y5: ( product_prod @ A @ B )] :
      ~ ( ! [A6: A,B5: B] :
            ( Y5
           != ( product_Pair @ A @ B @ A6 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_90_prod__induct7,axiom,(
    ! [G2: $tType,F4: $tType,E: $tType,D2: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D3: D2,E2: E,F5: F4,G3: G2] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F5 @ G3 ) ) ) ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct7
thf(fact_91_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D2: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D3: D2,E2: E,F5: F4] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ F4 ) @ D3 @ ( product_Pair @ E @ F4 @ E2 @ F5 ) ) ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct6
thf(fact_92_prod__induct5,axiom,(
    ! [E: $tType,D2: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D3: D2,E2: E] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D2 @ E ) @ C3 @ ( product_Pair @ D2 @ E @ D3 @ E2 ) ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct5
thf(fact_93_prod__induct4,axiom,(
    ! [D2: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) )] :
      ( ! [A6: A,B5: B,C3: C,D3: D2] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D2 ) @ B5 @ ( product_Pair @ C @ D2 @ C3 @ D3 ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct4
thf(fact_94_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A6: A,B5: B,C3: C] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct3
thf(fact_95_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,E: $tType,F4: $tType,G2: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D3: D2,E2: E,F5: F4,G3: G2] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F5 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_96_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,E: $tType,F4: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D3: D2,E2: E,F5: F4] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ F4 ) @ D3 @ ( product_Pair @ E @ F4 @ E2 @ F5 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_97_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,E: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D3: D2,E2: E] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D2 @ E ) @ C3 @ ( product_Pair @ D2 @ E @ D3 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_98_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) )] :
      ~ ( ! [A6: A,B5: B,C3: C,D3: D2] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D2 ) @ B5 @ ( product_Pair @ C @ D2 @ C3 @ D3 ) ) ) ) ) )).

% prod_cases4
thf(fact_99_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A6: A,B5: B,C3: C] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_100_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B4 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B4 ) ) ) )).

% Pair_inject
thf(fact_101_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),P: ( product_prod @ A @ B )] :
      ( ! [A6: A,B5: B] :
          ( P2 @ ( product_Pair @ A @ B @ A6 @ B5 ) )
     => ( P2 @ P ) ) )).

% prod_cases
thf(fact_102_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P: ( product_prod @ A @ B )] :
    ? [X: A,Y3: B] :
      ( P
      = ( product_Pair @ A @ B @ X @ Y3 ) ) )).

% surj_pair
thf(fact_103_dag_Ocase__distrib,axiom,(
    ! [B: $tType,A: $tType,H: ( A > B ),F12: A,F22: ( binDag_Mirabelle_dag > simpl_ref > binDag_Mirabelle_dag > A ),Dag: binDag_Mirabelle_dag] :
      ( ( H @ ( binDag1297733282se_dag @ A @ F12 @ F22 @ Dag ) )
      = ( binDag1297733282se_dag @ B @ ( H @ F12 )
        @ ^ [X1: binDag_Mirabelle_dag,X22: simpl_ref,X33: binDag_Mirabelle_dag] :
            ( H @ ( F22 @ X1 @ X22 @ X33 ) )
        @ Dag ) ) )).

% dag.case_distrib
thf(fact_104_natural_Oinducts,axiom,(
    ! [P2: ( code_natural > $o ),Natural: code_natural] :
      ( ( P2 @ ( zero_zero @ code_natural ) )
     => ( ! [Natural3: code_natural] :
            ( ( P2 @ Natural3 )
           => ( P2 @ ( code_Suc @ Natural3 ) ) )
       => ( P2 @ Natural ) ) ) )).

% natural.inducts
thf(fact_105_natural_Oexhaust,axiom,(
    ! [Y5: code_natural] :
      ( ( Y5
       != ( zero_zero @ code_natural ) )
     => ~ ( ! [Natural3: code_natural] :
              ( Y5
             != ( code_Suc @ Natural3 ) ) ) ) )).

% natural.exhaust
thf(fact_106_natural_Odistinct_I1_J,axiom,(
    ! [Natural2: code_natural] :
      ( ( zero_zero @ code_natural )
     != ( code_Suc @ Natural2 ) ) )).

% natural.distinct(1)
thf(fact_107_natural_Odistinct_I2_J,axiom,(
    ! [Natural4: code_natural] :
      ( ( code_Suc @ Natural4 )
     != ( zero_zero @ code_natural ) ) )).

% natural.distinct(2)
thf(fact_108_random__aux__set_Ocases,axiom,(
    ! [X3: ( product_prod @ code_natural @ code_natural )] :
      ( ! [J: code_natural] :
          ( X3
         != ( product_Pair @ code_natural @ code_natural @ ( zero_zero @ code_natural ) @ J ) )
     => ~ ( ! [I: code_natural,J: code_natural] :
              ( X3
             != ( product_Pair @ code_natural @ code_natural @ ( code_Suc @ I ) @ J ) ) ) ) )).

% random_aux_set.cases
thf(fact_109_random__aux__rec,axiom,(
    ! [A: $tType,Random_aux: ( code_natural > A ),Rhs: ( code_natural > A ),K: code_natural] :
      ( ( ( Random_aux @ ( zero_zero @ code_natural ) )
        = ( Rhs @ ( zero_zero @ code_natural ) ) )
     => ( ! [K2: code_natural] :
            ( ( Random_aux @ ( code_Suc @ K2 ) )
            = ( Rhs @ ( code_Suc @ K2 ) ) )
       => ( ( Random_aux @ K )
          = ( Rhs @ K ) ) ) ) )).

% random_aux_rec
thf(fact_110_random__aux__set_Oinduct,axiom,(
    ! [B: $tType] :
      ( ( quickcheck_random @ B @ ( type2 @ B ) )
     => ! [P2: ( code_natural > code_natural > $o ),A0: code_natural,A1: code_natural] :
          ( ! [X12: code_natural] :
              ( P2 @ ( zero_zero @ code_natural ) @ X12 )
         => ( ! [I: code_natural,J: code_natural] :
                ( ! [X5: ( product_prod @ B @ ( product_unit > code_term ) )] :
                    ( P2 @ I @ J )
               => ( P2 @ ( code_Suc @ I ) @ J ) )
           => ( P2 @ A0 @ A1 ) ) ) ) )).

% random_aux_set.induct
thf(fact_111_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_112_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X2: A] :
            ~ ( member @ A @ X2 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_113_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P2 @ X2 ) ) ) )).

% Collect_empty_eq
thf(fact_114_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X2: A] :
            ~ ( P2 @ X2 ) ) ) )).

% empty_Collect_eq
thf(fact_115_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_116_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_117_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_118_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_119_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X2: A] : $false ) ) )).

% empty_def
thf(fact_120_bot__apply,axiom,(
    ! [C: $tType,D2: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D2 > C ) )
        = ( ^ [X2: D2] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_121_same__fstI,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),X3: A,Y6: B,Y5: B,R4: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ( P2 @ X3 )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y5 ) @ ( R4 @ X3 ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y6 ) @ ( product_Pair @ A @ B @ X3 @ Y5 ) ) @ ( same_fst @ A @ B @ P2 @ R4 ) ) ) ) )).

% same_fstI
thf(fact_122_override__on__emptyset,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ( override_on @ A @ B @ F @ G @ ( bot_bot @ ( set @ A ) ) )
      = F ) )).

% override_on_emptyset
thf(fact_123_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_124_override__on__apply__in,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( override_on @ A @ B @ F @ G @ A3 @ A2 )
        = ( G @ A2 ) ) ) )).

% override_on_apply_in
thf(fact_125_override__on__apply__notin,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ( override_on @ A @ B @ F @ G @ A3 @ A2 )
        = ( F @ A2 ) ) ) )).

% override_on_apply_notin
thf(fact_126_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_127_override__on__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( override_on @ A @ B )
      = ( ^ [F3: ( A > B ),G4: ( A > B ),A7: ( set @ A ),A4: A] :
            ( if @ B @ ( member @ A @ A4 @ A7 ) @ ( G4 @ A4 ) @ ( F3 @ A4 ) ) ) ) )).

% override_on_def
thf(fact_128_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ( ( zero_zero @ A )
            = X3 )
          = ( X3
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_129_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X2: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_130_natural_Osize_I1_J,axiom,
    ( ( code_size_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(1)
thf(fact_131_bot__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X2: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% bot_empty_eq2
thf(fact_132_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R4: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X2: A,Y4: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ R4 ) )
        = ( ^ [X2: A,Y4: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ S2 ) ) )
      = ( R4 = S2 ) ) )).

% pred_equals_eq2
thf(fact_133_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C2 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_134_bot2E,axiom,(
    ! [A: $tType,B: $tType,X3: A,Y5: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X3 @ Y5 ) )).

% bot2E
thf(fact_135_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) )).

% zero_natural.rsp
thf(fact_136_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_137_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P2
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_138_natural_Osize_I3_J,axiom,
    ( ( size_size @ code_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(3)
thf(fact_139_dag_Osize__gen_I1_J,axiom,
    ( ( binDag1924123185ze_dag @ binDag_Mirabelle_Tip )
    = ( zero_zero @ nat ) )).

% dag.size_gen(1)
thf(fact_140_dag_Osize_I3_J,axiom,
    ( ( size_size @ binDag_Mirabelle_dag @ binDag_Mirabelle_Tip )
    = ( zero_zero @ nat ) )).

% dag.size(3)
thf(fact_141_fun__cong__unused__0,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( zero @ B @ ( type2 @ B ) )
     => ! [F: ( ( A > B ) > C ),G: C] :
          ( ( F
            = ( ^ [X2: ( A > B )] : G ) )
         => ( ( F
              @ ^ [X2: A] :
                  ( zero_zero @ B ) )
            = G ) ) ) )).

% fun_cong_unused_0
thf(fact_142_full__exhaustive__natural_H_Ocases,axiom,(
    ! [X3: ( product_prod @ ( ( product_prod @ code_natural @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) )] :
      ~ ( ! [F5: ( ( product_prod @ code_natural @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ),D3: code_natural,I: code_natural] :
            ( X3
           != ( product_Pair @ ( ( product_prod @ code_natural @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F5 @ ( product_Pair @ code_natural @ code_natural @ D3 @ I ) ) ) ) )).

% full_exhaustive_natural'.cases
thf(fact_143_full__exhaustive__fun_H_Ocases,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( quickc2099533868ustive @ B @ ( type2 @ B ) )
        & ( cl_HOL_Oequal @ A @ ( type2 @ A ) )
        & ( quickc2099533868ustive @ A @ ( type2 @ A ) ) )
     => ! [X3: ( product_prod @ ( ( product_prod @ ( A > B ) @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) )] :
          ~ ( ! [F5: ( ( product_prod @ ( A > B ) @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ),I: code_natural,D3: code_natural] :
                ( X3
               != ( product_Pair @ ( ( product_prod @ ( A > B ) @ ( product_unit > code_term ) ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F5 @ ( product_Pair @ code_natural @ code_natural @ I @ D3 ) ) ) ) ) )).

% full_exhaustive_fun'.cases
thf(fact_144_exhaustive__natural_H_Ocases,axiom,(
    ! [X3: ( product_prod @ ( code_natural > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) )] :
      ~ ( ! [F5: ( code_natural > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ),D3: code_natural,I: code_natural] :
            ( X3
           != ( product_Pair @ ( code_natural > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F5 @ ( product_Pair @ code_natural @ code_natural @ D3 @ I ) ) ) ) )).

% exhaustive_natural'.cases
thf(fact_145_exhaustive__fun_H_Ocases,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( quickc1261659869ustive @ B @ ( type2 @ B ) )
        & ( cl_HOL_Oequal @ A @ ( type2 @ A ) )
        & ( quickc1261659869ustive @ A @ ( type2 @ A ) ) )
     => ! [X3: ( product_prod @ ( ( A > B ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) )] :
          ~ ( ! [F5: ( ( A > B ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ),I: code_natural,D3: code_natural] :
                ( X3
               != ( product_Pair @ ( ( A > B ) > ( option @ ( product_prod @ $o @ ( list @ code_term ) ) ) ) @ ( product_prod @ code_natural @ code_natural ) @ F5 @ ( product_Pair @ code_natural @ code_natural @ I @ D3 ) ) ) ) ) )).

% exhaustive_fun'.cases
thf(fact_146_Lazy__Sequence_Oiterate__upto_Ocases,axiom,(
    ! [A: $tType,X3: ( product_prod @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) )] :
      ~ ( ! [F5: ( code_natural > A ),N: code_natural,M2: code_natural] :
            ( X3
           != ( product_Pair @ ( code_natural > A ) @ ( product_prod @ code_natural @ code_natural ) @ F5 @ ( product_Pair @ code_natural @ code_natural @ N @ M2 ) ) ) ) )).

% Lazy_Sequence.iterate_upto.cases
thf(fact_147_log_Ocases,axiom,(
    ! [X3: ( product_prod @ code_natural @ code_natural )] :
      ~ ( ! [B5: code_natural,I: code_natural] :
            ( X3
           != ( product_Pair @ code_natural @ code_natural @ B5 @ I ) ) ) )).

% log.cases
thf(fact_148_in__lex__prod,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B,R: ( set @ ( product_prod @ A @ A ) ),S: ( set @ ( product_prod @ B @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Pair @ A @ B @ A5 @ B4 ) ) @ ( lex_prod @ A @ B @ R @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A5 ) @ R )
        | ( ( A2 = A5 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B4 ) @ S ) ) ) ) )).

% in_lex_prod
thf(fact_149_divides__aux__eq,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral_div @ A @ ( type2 @ A ) )
     => ! [Q3: A,R: A] :
          ( ( semiri577515795es_aux @ A @ ( product_Pair @ A @ A @ Q3 @ R ) )
          = ( R
            = ( zero_zero @ A ) ) ) ) )).

% divides_aux_eq
thf(fact_150_Id__on__empty,axiom,(
    ! [A: $tType] :
      ( ( id_on @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) )).

% Id_on_empty
thf(fact_151_Id__onI,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( id_on @ A @ A3 ) ) ) )).

% Id_onI
thf(fact_152_Id__on__iff,axiom,(
    ! [A: $tType,X3: A,Y5: A,A3: ( set @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( id_on @ A @ A3 ) )
      = ( ( X3 = Y5 )
        & ( member @ A @ X3 @ A3 ) ) ) )).

% Id_on_iff
thf(fact_153_Id__on__eqI,axiom,(
    ! [A: $tType,A2: A,B2: A,A3: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ( member @ A @ A2 @ A3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id_on @ A @ A3 ) ) ) ) )).

% Id_on_eqI
thf(fact_154_Id__onE,axiom,(
    ! [A: $tType,C2: ( product_prod @ A @ A ),A3: ( set @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ C2 @ ( id_on @ A @ A3 ) )
     => ~ ( ! [X: A] :
              ( ( member @ A @ X @ A3 )
             => ( C2
               != ( product_Pair @ A @ A @ X @ X ) ) ) ) ) )).

% Id_onE
thf(fact_155_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) )).

% bot_nat_def
thf(fact_156_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R4: ( set @ ( product_prod @ A @ B ) ),S3: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R4 )
     => ( ( S3 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S3 ) @ R4 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_157_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F3: ( ( product_prod @ B @ C ) > A ),A4: B,B3: C] :
            ( F3 @ ( product_Pair @ B @ C @ A4 @ B3 ) ) ) ) )).

% curry_conv
thf(fact_158_Range__empty,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( range @ B @ A @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Range_empty
thf(fact_159_curryI,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( product_curry @ A @ B @ $o @ F @ A2 @ B2 ) ) )).

% curryI
thf(fact_160_curry__K,axiom,(
    ! [B: $tType,C: $tType,A: $tType,C2: C] :
      ( ( product_curry @ A @ B @ C
        @ ^ [X2: ( product_prod @ A @ B )] : C2 )
      = ( ^ [X2: A,Y4: B] : C2 ) ) )).

% curry_K
thf(fact_161_RangeE,axiom,(
    ! [A: $tType,B: $tType,B2: A,R: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ A @ B2 @ ( range @ B @ A @ R ) )
     => ~ ( ! [A6: B] :
              ~ ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A6 @ B2 ) @ R ) ) ) )).

% RangeE
thf(fact_162_Range__iff,axiom,(
    ! [A: $tType,B: $tType,A2: A,R: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ A @ A2 @ ( range @ B @ A @ R ) )
      = ( ? [Y4: B] :
            ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ Y4 @ A2 ) @ R ) ) ) )).

% Range_iff
thf(fact_163_Range_Ocases,axiom,(
    ! [B: $tType,A: $tType,A2: B,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ B @ A2 @ ( range @ A @ B @ R ) )
     => ~ ( ! [A6: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ A2 ) @ R ) ) ) )).

% Range.cases
thf(fact_164_Range_Osimps,axiom,(
    ! [B: $tType,A: $tType,A2: B,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ B @ A2 @ ( range @ A @ B @ R ) )
      = ( ? [A4: A,B3: B] :
            ( ( A2 = B3 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ R ) ) ) ) )).

% Range.simps
thf(fact_165_Range_Ointros,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: B,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R )
     => ( member @ B @ B2 @ ( range @ A @ B @ R ) ) ) )).

% Range.intros
thf(fact_166_Range_Oinducts,axiom,(
    ! [A: $tType,B: $tType,X3: B,R: ( set @ ( product_prod @ A @ B ) ),P2: ( B > $o )] :
      ( ( member @ B @ X3 @ ( range @ A @ B @ R ) )
     => ( ! [A6: A,B5: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ R )
           => ( P2 @ B5 ) )
       => ( P2 @ X3 ) ) ) )).

% Range.inducts
thf(fact_167_curryE,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryE
thf(fact_168_curryD,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryD
thf(fact_169_Range__empty__iff,axiom,(
    ! [A: $tType,B: $tType,R: ( set @ ( product_prod @ B @ A ) )] :
      ( ( ( range @ B @ A @ R )
        = ( bot_bot @ ( set @ A ) ) )
      = ( R
        = ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) ) ) )).

% Range_empty_iff
thf(fact_170_curry__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_curry @ A @ B @ C )
      = ( ^ [C4: ( ( product_prod @ A @ B ) > C ),X2: A,Y4: B] :
            ( C4 @ ( product_Pair @ A @ B @ X2 @ Y4 ) ) ) ) )).

% curry_def
thf(fact_171_Rangep__Range__eq,axiom,(
    ! [A: $tType,B: $tType,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( rangep @ A @ B
        @ ^ [X2: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ R ) )
      = ( ^ [X2: B] :
            ( member @ B @ X2 @ ( range @ A @ B @ R ) ) ) ) )).

% Rangep_Range_eq
thf(fact_172_Range__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( range @ A @ B )
      = ( ^ [R2: ( set @ ( product_prod @ A @ B ) )] :
            ( collect @ B
            @ ( rangep @ A @ B
              @ ^ [X2: A,Y4: B] :
                  ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ R2 ) ) ) ) ) )).

% Range_def
thf(fact_173_of__nat__aux_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [Inc: ( A > A ),I2: A] :
          ( ( semiri532925092at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I2 )
          = I2 ) ) )).

% of_nat_aux.simps(1)
thf(fact_174_Domain__empty,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Domain_empty
thf(fact_175_subdag__size,axiom,(
    ! [T2: binDag_Mirabelle_dag,S: binDag_Mirabelle_dag] :
      ( ( binDag786255756subdag @ T2 @ S )
     => ( ord_less @ nat @ ( size_size @ binDag_Mirabelle_dag @ S ) @ ( size_size @ binDag_Mirabelle_dag @ T2 ) ) ) )).

% subdag_size
thf(fact_176_in__inv__image,axiom,(
    ! [A: $tType,B: $tType,X3: A,Y5: A,R: ( set @ ( product_prod @ B @ B ) ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( inv_image @ B @ A @ R @ F ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X3 ) @ ( F @ Y5 ) ) @ R ) ) )).

% in_inv_image
thf(fact_177_not__gr__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) )).

% not_gr_zero
thf(fact_178_neq0__conv,axiom,(
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) )).

% neq0_conv
thf(fact_179_gr0I,axiom,(
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) )).

% gr0I
thf(fact_180_not__gr0,axiom,(
    ! [N2: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) )).

% not_gr0
thf(fact_181_not__less0,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) )).

% not_less0
thf(fact_182_less__zeroE,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) )).

% less_zeroE
thf(fact_183_gr__implies__not0,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( N2
       != ( zero_zero @ nat ) ) ) )).

% gr_implies_not0
thf(fact_184_infinite__descent0,axiom,(
    ! [P2: ( nat > $o ),N2: nat] :
      ( ( P2 @ ( zero_zero @ nat ) )
     => ( ! [N: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ~ ( P2 @ N )
             => ? [M3: nat] :
                  ( ( ord_less @ nat @ M3 @ N )
                  & ~ ( P2 @ M3 ) ) ) )
       => ( P2 @ N2 ) ) ) )).

% infinite_descent0
thf(fact_185_less__nat__zero__code,axiom,(
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) )).

% less_nat_zero_code
thf(fact_186_infinite__descent0__measure,axiom,(
    ! [A: $tType,V: ( A > nat ),P2: ( A > $o ),X3: A] :
      ( ! [X: A] :
          ( ( ( V @ X )
            = ( zero_zero @ nat ) )
         => ( P2 @ X ) )
     => ( ! [X: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V @ X ) )
           => ( ~ ( P2 @ X )
             => ? [Y: A] :
                  ( ( ord_less @ nat @ ( V @ Y ) @ ( V @ X ) )
                  & ~ ( P2 @ Y ) ) ) )
       => ( P2 @ X3 ) ) ) )).

% infinite_descent0_measure
thf(fact_187_zero__less__iff__neq__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N2 )
          = ( N2
           != ( zero_zero @ A ) ) ) ) )).

% zero_less_iff_neq_zero
thf(fact_188_gr__implies__not__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ M @ N2 )
         => ( N2
           != ( zero_zero @ A ) ) ) ) )).

% gr_implies_not_zero
thf(fact_189_not__less__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ~ ( ord_less @ A @ N2 @ ( zero_zero @ A ) ) ) )).

% not_less_zero
thf(fact_190_gr__zeroI,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( N2
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) ) ) )).

% gr_zeroI
thf(fact_191_DomainE,axiom,(
    ! [B: $tType,A: $tType,A2: A,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A2 @ ( domain @ A @ B @ R ) )
     => ~ ( ! [B5: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B5 ) @ R ) ) ) )).

% DomainE
thf(fact_192_Domain__iff,axiom,(
    ! [A: $tType,B: $tType,A2: A,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A2 @ ( domain @ A @ B @ R ) )
      = ( ? [Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ Y4 ) @ R ) ) ) )).

% Domain_iff
thf(fact_193_Domain_Ocases,axiom,(
    ! [B: $tType,A: $tType,A2: A,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A2 @ ( domain @ A @ B @ R ) )
     => ~ ( ! [B5: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B5 ) @ R ) ) ) )).

% Domain.cases
thf(fact_194_Domain_Osimps,axiom,(
    ! [B: $tType,A: $tType,A2: A,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A2 @ ( domain @ A @ B @ R ) )
      = ( ? [A4: A,B3: B] :
            ( ( A2 = A4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ R ) ) ) ) )).

% Domain.simps
thf(fact_195_Domain_ODomainI,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: B,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R )
     => ( member @ A @ A2 @ ( domain @ A @ B @ R ) ) ) )).

% Domain.DomainI
thf(fact_196_Domain_Oinducts,axiom,(
    ! [B: $tType,A: $tType,X3: A,R: ( set @ ( product_prod @ A @ B ) ),P2: ( A > $o )] :
      ( ( member @ A @ X3 @ ( domain @ A @ B @ R ) )
     => ( ! [A6: A,B5: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ R )
           => ( P2 @ A6 ) )
       => ( P2 @ X3 ) ) ) )).

% Domain.inducts
thf(fact_197_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) )).

% bot.not_eq_extremum
thf(fact_198_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_199_Domain__empty__iff,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( domain @ A @ B @ R )
        = ( bot_bot @ ( set @ A ) ) )
      = ( R
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) )).

% Domain_empty_iff
thf(fact_200_in__measure,axiom,(
    ! [A: $tType,X3: A,Y5: A,F: ( A > nat )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( measure @ A @ F ) )
      = ( ord_less @ nat @ ( F @ X3 ) @ ( F @ Y5 ) ) ) )).

% in_measure
thf(fact_201_less__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% less_numeral_extra(3)
thf(fact_202_mlex__less,axiom,(
    ! [A: $tType,F: ( A > nat ),X3: A,Y5: A,R4: ( set @ ( product_prod @ A @ A ) )] :
      ( ( ord_less @ nat @ ( F @ X3 ) @ ( F @ Y5 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( mlex_prod @ A @ F @ R4 ) ) ) )).

% mlex_less
thf(fact_203_DAG__less,axiom,(
    ! [Y5: binDag_Mirabelle_dag,X3: binDag_Mirabelle_dag] :
      ( ( binDag_Mirabelle_DAG @ Y5 )
     => ( ( ord_less @ binDag_Mirabelle_dag @ X3 @ Y5 )
       => ( binDag_Mirabelle_DAG @ X3 ) ) ) )).

% DAG_less
thf(fact_204_less__dag__Node_H,axiom,(
    ! [X3: binDag_Mirabelle_dag,L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X3 @ ( binDag476092410e_Node @ L @ A2 @ R ) )
      = ( ( X3 = L )
        | ( X3 = R )
        | ( ord_less @ binDag_Mirabelle_dag @ X3 @ L )
        | ( ord_less @ binDag_Mirabelle_dag @ X3 @ R ) ) ) )).

% less_dag_Node'
thf(fact_205_less__Node__dag,axiom,(
    ! [L: binDag_Mirabelle_dag,A2: simpl_ref,R: binDag_Mirabelle_dag,X3: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ ( binDag476092410e_Node @ L @ A2 @ R ) @ X3 )
     => ( ( ord_less @ binDag_Mirabelle_dag @ L @ X3 )
        & ( ord_less @ binDag_Mirabelle_dag @ R @ X3 ) ) ) )).

% less_Node_dag
thf(fact_206_less__dag__def,axiom,
    ( ( ord_less @ binDag_Mirabelle_dag )
    = ( ^ [S4: binDag_Mirabelle_dag,T3: binDag_Mirabelle_dag] :
          ( binDag786255756subdag @ T3 @ S4 ) ) )).

% less_dag_def
thf(fact_207_less__dag__Tip,axiom,(
    ! [X3: binDag_Mirabelle_dag] :
      ~ ( ord_less @ binDag_Mirabelle_dag @ X3 @ binDag_Mirabelle_Tip ) )).

% less_dag_Tip
thf(fact_208_less__DAG__set__of,axiom,(
    ! [X3: binDag_Mirabelle_dag,Y5: binDag_Mirabelle_dag] :
      ( ( ord_less @ binDag_Mirabelle_dag @ X3 @ Y5 )
     => ( ( binDag_Mirabelle_DAG @ Y5 )
       => ( ord_less @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ X3 ) @ ( binDag1380252983set_of @ Y5 ) ) ) ) )).

% less_DAG_set_of
thf(fact_209_not__psubset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_210_of__nat__0__less__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) )).

% of_nat_0_less_iff
thf(fact_211_mlex__prod__def,axiom,(
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: ( A > nat ),R5: ( set @ ( product_prod @ A @ A ) )] :
            ( inv_image @ ( product_prod @ nat @ A ) @ A @ ( lex_prod @ nat @ A @ less_than @ R5 )
            @ ^ [X2: A] :
                ( product_Pair @ nat @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) )).

% mlex_prod_def
thf(fact_212_less__than__iff,axiom,(
    ! [X3: nat,Y5: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X3 @ Y5 ) @ less_than )
      = ( ord_less @ nat @ X3 @ Y5 ) ) )).

% less_than_iff
thf(fact_213_of__nat__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) )).

% of_nat_0
thf(fact_214_of__nat__0__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [N2: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( ( zero_zero @ nat )
            = N2 ) ) ) )).

% of_nat_0_eq_iff
thf(fact_215_of__nat__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) )).

% of_nat_eq_0_iff
thf(fact_216_of__nat__less__0__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) )).

% of_nat_less_0_iff
thf(fact_217_less__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B6: ( set @ A )] :
            ( ord_less @ ( A > $o )
            @ ^ [X2: A] :
                ( member @ A @ X2 @ A7 )
            @ ^ [X2: A] :
                ( member @ A @ X2 @ B6 ) ) ) ) )).

% less_set_def
thf(fact_218_zero__less__imp__eq__int,axiom,(
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
          & ( K
            = ( semiring_1_of_nat @ int @ N ) ) ) ) )).

% zero_less_imp_eq_int
thf(fact_219_of__nat__zero__less__power__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [X3: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X3 ) @ N2 ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) )).

% of_nat_zero_less_power_iff
thf(fact_220_nat__zero__less__power__iff,axiom,(
    ! [X3: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X3 @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) )).

% nat_zero_less_power_iff
thf(fact_221_power__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri134348788visors @ A @ ( type2 @ A ) )
     => ! [A2: A,N2: nat] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) )).

% power_eq_0_iff
thf(fact_222_zero__less__power,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) )).

% zero_less_power
thf(fact_223_zero__power,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
            = ( zero_zero @ A ) ) ) ) )).

% zero_power
thf(fact_224_nat__power__less__imp__less,axiom,(
    ! [I2: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I2 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I2 @ M ) @ ( power_power @ nat @ I2 @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) )).

% nat_power_less_imp_less
thf(fact_225_less__int__code_I1_J,axiom,(
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) )).

% less_int_code(1)
thf(fact_226_nat__gcd_Ocases,axiom,(
    ! [X3: ( product_prod @ nat @ nat )] :
      ~ ( ! [X: nat,Y3: nat] :
            ( X3
           != ( product_Pair @ nat @ nat @ X @ Y3 ) ) ) )).

% nat_gcd.cases
thf(fact_227_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) )).

% zero_integer.rsp
thf(fact_228_power__not__zero,axiom,(
    ! [A: $tType] :
      ( ( semiri134348788visors @ A @ ( type2 @ A ) )
     => ! [A2: A,N2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N2 )
           != ( zero_zero @ A ) ) ) ) )).

% power_not_zero
thf(fact_229_transfer__int__nat__numerals_I1_J,axiom,
    ( ( zero_zero @ int )
    = ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) ) )).

% transfer_int_nat_numerals(1)
thf(fact_230_Divides_Odivmod__nat__base,axiom,(
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( divmod_nat @ M @ N2 )
        = ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M ) ) ) )).

% Divides.divmod_nat_base
thf(fact_231_Divides_Odivmod__nat__zero,axiom,(
    ! [M: nat] :
      ( ( divmod_nat @ M @ ( zero_zero @ nat ) )
      = ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M ) ) )).

% Divides.divmod_nat_zero
thf(fact_232_Divides_Odivmod__nat__zero__left,axiom,(
    ! [N2: nat] :
      ( ( divmod_nat @ ( zero_zero @ nat ) @ N2 )
      = ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) )).

% Divides.divmod_nat_zero_left
thf(fact_233_power__strict__mono,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ) )).

% power_strict_mono
thf(fact_234_transfer__morphism__int__nat,axiom,
    ( nat_tr1645093318rphism @ nat @ int @ ( semiring_1_of_nat @ int )
    @ ^ [N3: nat] : $true )).

% transfer_morphism_int_nat
thf(fact_235_subset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_236_empty__subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) )).

% empty_subsetI
thf(fact_237_le0,axiom,(
    ! [N2: nat] :
      ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) )).

% le0
thf(fact_238_le__zero__eq,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N2: A] :
          ( ( ord_less_eq @ A @ N2 @ ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) )).

% le_zero_eq
thf(fact_239_of__nat__le__0__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) )).

% of_nat_le_0_iff
thf(fact_240_Nat__Transfer_Otransfer__nat__int__function__closures_I9_J,axiom,(
    ! [Z3: nat] :
      ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( semiring_1_of_nat @ int @ Z3 ) ) )).

% Nat_Transfer.transfer_nat_int_function_closures(9)
thf(fact_241_transfer__int__nat__quantifiers_I1_J,axiom,(
    ! [P2: ( int > $o )] :
      ( ( ! [X2: int] :
            ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
           => ( P2 @ X2 ) ) )
      = ( ! [X2: nat] :
            ( P2 @ ( semiring_1_of_nat @ int @ X2 ) ) ) ) )).

% transfer_int_nat_quantifiers(1)
thf(fact_242_transfer__int__nat__quantifiers_I2_J,axiom,(
    ! [P2: ( int > $o )] :
      ( ( ? [X2: int] :
            ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
            & ( P2 @ X2 ) ) )
      = ( ? [X2: nat] :
            ( P2 @ ( semiring_1_of_nat @ int @ X2 ) ) ) ) )).

% transfer_int_nat_quantifiers(2)
thf(fact_243_transfer__nat__int__set__cong,axiom,(
    ! [P2: ( int > $o ),P7: ( int > $o )] :
      ( ! [X: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( P2 @ X )
            = ( P7 @ X ) ) )
     => ( ( collect @ int
          @ ^ [X2: int] :
              ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
              & ( P2 @ X2 ) ) )
        = ( collect @ int
          @ ^ [X2: int] :
              ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
              & ( P7 @ X2 ) ) ) ) ) )).

% transfer_nat_int_set_cong
thf(fact_244_Nat__Transfer_Otransfer__nat__int__function__closures_I5_J,axiom,
    ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) )).

% Nat_Transfer.transfer_nat_int_function_closures(5)
thf(fact_245_Nat__Transfer_Otransfer__nat__int__function__closures_I4_J,axiom,(
    ! [X3: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X3 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( power_power @ int @ X3 @ N2 ) ) ) )).

% Nat_Transfer.transfer_nat_int_function_closures(4)
thf(fact_246_power__mono,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) )).

% power_mono
thf(fact_247_zero__le__power,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) )).

% zero_le_power
thf(fact_248_subset__emptyI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X: A] :
          ~ ( member @ A @ X @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_249_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) )).

% bot.extremum
thf(fact_250_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_251_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_252_le__dag__set__of,axiom,(
    ! [X3: binDag_Mirabelle_dag,Y5: binDag_Mirabelle_dag] :
      ( ( ord_less_eq @ binDag_Mirabelle_dag @ X3 @ Y5 )
     => ( ord_less_eq @ ( set @ simpl_ref ) @ ( binDag1380252983set_of @ X3 ) @ ( binDag1380252983set_of @ Y5 ) ) ) )).

% le_dag_set_of
thf(fact_253_mlex__leq,axiom,(
    ! [A: $tType,F: ( A > nat ),X3: A,Y5: A,R4: ( set @ ( product_prod @ A @ A ) )] :
      ( ( ord_less_eq @ nat @ ( F @ X3 ) @ ( F @ Y5 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( mlex_prod @ A @ F @ R4 ) ) ) ) )).

% mlex_leq

%----Type constructors (102)
thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Code__Evaluation_Oterm__of,axiom,
    ( code_term_of @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_1,axiom,
    ( code_term_of @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_2,axiom,
    ( code_term_of @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_3,axiom,
    ( code_term_of @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Enum_Oenum,axiom,
    ( enum @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_4,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( typerep @ A8 @ ( type2 @ A8 ) )
        & ( typerep @ A9 @ ( type2 @ A9 ) ) )
     => ( code_term_of @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Enum_Oenum_5,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( enum @ A8 @ ( type2 @ A8 ) )
        & ( enum @ A9 @ ( type2 @ A9 ) ) )
     => ( enum @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_Simpl__Heap_Oref___Code__Evaluation_Oterm__of_6,axiom,
    ( code_term_of @ simpl_ref @ ( type2 @ simpl_ref ) )).

thf(tcon_Option_Ooption___Code__Evaluation_Oterm__of_7,axiom,(
    ! [A8: $tType] :
      ( ( typerep @ A8 @ ( type2 @ A8 ) )
     => ( code_term_of @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Option_Ooption___Enum_Oenum_8,axiom,(
    ! [A8: $tType] :
      ( ( enum @ A8 @ ( type2 @ A8 ) )
     => ( enum @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_9,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( typerep @ A8 @ ( type2 @ A8 ) )
        & ( typerep @ A9 @ ( type2 @ A9 ) ) )
     => ( code_term_of @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Enum_Oenum_10,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( enum @ A8 @ ( type2 @ A8 ) )
        & ( enum @ A9 @ ( type2 @ A9 ) ) )
     => ( enum @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) ) )).

thf(tcon_List_Olist___Code__Evaluation_Oterm__of_11,axiom,(
    ! [A8: $tType] :
      ( ( typerep @ A8 @ ( type2 @ A8 ) )
     => ( code_term_of @ ( list @ A8 ) @ ( type2 @ ( list @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Code__Evaluation_Oterm__of_12,axiom,
    ( code_term_of @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Enum_Oenum_13,axiom,
    ( enum @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Code__Evaluation_Oterm__of_14,axiom,(
    ! [A8: $tType] :
      ( ( typerep @ A8 @ ( type2 @ A8 ) )
     => ( code_term_of @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Enum_Oenum_15,axiom,(
    ! [A8: $tType] :
      ( ( enum @ A8 @ ( type2 @ A8 ) )
     => ( enum @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Code__Evaluation_Oterm__of_16,axiom,
    ( code_term_of @ nat @ ( type2 @ nat ) )).

thf(tcon_Int_Oint___Code__Evaluation_Oterm__of_17,axiom,
    ( code_term_of @ int @ ( type2 @ int ) )).

thf(tcon_fun___Code__Evaluation_Oterm__of_18,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( typerep @ A8 @ ( type2 @ A8 ) )
        & ( typerep @ A9 @ ( type2 @ A9 ) ) )
     => ( code_term_of @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Enum_Oenum_19,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( enum @ A8 @ ( type2 @ A8 ) )
        & ( enum @ A9 @ ( type2 @ A9 ) ) )
     => ( enum @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Typerep_Otyperep,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( typerep @ A8 @ ( type2 @ A8 ) )
        & ( typerep @ A9 @ ( type2 @ A9 ) ) )
     => ( typerep @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Int_Oint___Typerep_Otyperep_20,axiom,
    ( typerep @ int @ ( type2 @ int ) )).

thf(tcon_Nat_Onat___Typerep_Otyperep_21,axiom,
    ( typerep @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Typerep_Otyperep_22,axiom,(
    ! [A8: $tType] :
      ( ( typerep @ A8 @ ( type2 @ A8 ) )
     => ( typerep @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Typerep_Otyperep_23,axiom,
    ( typerep @ $o @ ( type2 @ $o ) )).

thf(tcon_List_Olist___Typerep_Otyperep_24,axiom,(
    ! [A8: $tType] :
      ( ( typerep @ A8 @ ( type2 @ A8 ) )
     => ( typerep @ ( list @ A8 ) @ ( type2 @ ( list @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Typerep_Otyperep_25,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( typerep @ A8 @ ( type2 @ A8 ) )
        & ( typerep @ A9 @ ( type2 @ A9 ) ) )
     => ( typerep @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) ) )).

thf(tcon_Option_Ooption___Typerep_Otyperep_26,axiom,(
    ! [A8: $tType] :
      ( ( typerep @ A8 @ ( type2 @ A8 ) )
     => ( typerep @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Simpl__Heap_Oref___Typerep_Otyperep_27,axiom,
    ( typerep @ simpl_ref @ ( type2 @ simpl_ref ) )).

thf(tcon_Product__Type_Oprod___Typerep_Otyperep_28,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( typerep @ A8 @ ( type2 @ A8 ) )
        & ( typerep @ A9 @ ( type2 @ A9 ) ) )
     => ( typerep @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Ounit___Typerep_Otyperep_29,axiom,
    ( typerep @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_30,axiom,
    ( typerep @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Numeral_Onatural___Typerep_Otyperep_31,axiom,
    ( typerep @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___Typerep_Otyperep_32,axiom,
    ( typerep @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

thf(tcon_fun___Quickcheck__Exhaustive_Ofull__exhaustive,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( cl_HOL_Oequal @ A8 @ ( type2 @ A8 ) )
        & ( quickc2099533868ustive @ A8 @ ( type2 @ A8 ) )
        & ( quickc2099533868ustive @ A9 @ ( type2 @ A9 ) ) )
     => ( quickc2099533868ustive @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Quickcheck__Exhaustive_Oexhaustive,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( cl_HOL_Oequal @ A8 @ ( type2 @ A8 ) )
        & ( quickc1261659869ustive @ A8 @ ( type2 @ A8 ) )
        & ( quickc1261659869ustive @ A9 @ ( type2 @ A9 ) ) )
     => ( quickc1261659869ustive @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Quickcheck__Random_Orandom,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( code_term_of @ A8 @ ( type2 @ A8 ) )
        & ( cl_HOL_Oequal @ A8 @ ( type2 @ A8 ) )
        & ( quickcheck_random @ A9 @ ( type2 @ A9 ) ) )
     => ( quickcheck_random @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_bot @ A9 @ ( type2 @ A9 ) )
     => ( order_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___HOL_Oequal,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( enum @ A8 @ ( type2 @ A8 ) )
        & ( cl_HOL_Oequal @ A9 @ ( type2 @ A9 ) ) )
     => ( cl_HOL_Oequal @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Int_Oint___Quickcheck__Exhaustive_Ofull__exhaustive_33,axiom,
    ( quickc2099533868ustive @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    ( semiri134348788visors @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Quickcheck__Exhaustive_Oexhaustive_34,axiom,
    ( quickc1261659869ustive @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Divides_Osemiring__numeral__div,axiom,
    ( semiring_numeral_div @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Quickcheck__Random_Orandom_35,axiom,
    ( quickcheck_random @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    ( semiring_char_0 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    ( semiring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    ( zero @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___HOL_Oequal_36,axiom,
    ( cl_HOL_Oequal @ int @ ( type2 @ int ) )).

thf(tcon_Nat_Onat___Quickcheck__Exhaustive_Ofull__exhaustive_37,axiom,
    ( quickc2099533868ustive @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_38,axiom,
    ( semiri134348788visors @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Quickcheck__Exhaustive_Oexhaustive_39,axiom,
    ( quickc1261659869ustive @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Divides_Osemiring__numeral__div_40,axiom,
    ( semiring_numeral_div @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_41,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Quickcheck__Random_Orandom_42,axiom,
    ( quickcheck_random @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_43,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_44,axiom,
    ( semiring_char_0 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__1_45,axiom,
    ( semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_46,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero_47,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___HOL_Oequal_48,axiom,
    ( cl_HOL_Oequal @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Quickcheck__Exhaustive_Ofull__exhaustive_49,axiom,(
    ! [A8: $tType] :
      ( ( quickc2099533868ustive @ A8 @ ( type2 @ A8 ) )
     => ( quickc2099533868ustive @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Quickcheck__Exhaustive_Oexhaustive_50,axiom,(
    ! [A8: $tType] :
      ( ( quickc1261659869ustive @ A8 @ ( type2 @ A8 ) )
     => ( quickc1261659869ustive @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Quickcheck__Random_Orandom_51,axiom,(
    ! [A8: $tType] :
      ( ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
     => ( quickcheck_random @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_52,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_53,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___HOL_Oequal_54,axiom,(
    ! [A8: $tType] :
      ( ( cl_HOL_Oequal @ A8 @ ( type2 @ A8 ) )
     => ( cl_HOL_Oequal @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Quickcheck__Exhaustive_Ofull__exhaustive_55,axiom,
    ( quickc2099533868ustive @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Quickcheck__Random_Orandom_56,axiom,
    ( quickcheck_random @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_57,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_58,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___HOL_Oequal_59,axiom,
    ( cl_HOL_Oequal @ $o @ ( type2 @ $o ) )).

thf(tcon_List_Olist___Quickcheck__Exhaustive_Ofull__exhaustive_60,axiom,(
    ! [A8: $tType] :
      ( ( quickc2099533868ustive @ A8 @ ( type2 @ A8 ) )
     => ( quickc2099533868ustive @ ( list @ A8 ) @ ( type2 @ ( list @ A8 ) ) ) ) )).

thf(tcon_List_Olist___Quickcheck__Random_Orandom_61,axiom,(
    ! [A8: $tType] :
      ( ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
     => ( quickcheck_random @ ( list @ A8 ) @ ( type2 @ ( list @ A8 ) ) ) ) )).

thf(tcon_List_Olist___HOL_Oequal_62,axiom,(
    ! [A8: $tType] :
      ( cl_HOL_Oequal @ ( list @ A8 ) @ ( type2 @ ( list @ A8 ) ) ) )).

thf(tcon_Sum__Type_Osum___Quickcheck__Exhaustive_Ofull__exhaustive_63,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( quickc2099533868ustive @ A8 @ ( type2 @ A8 ) )
        & ( quickc2099533868ustive @ A9 @ ( type2 @ A9 ) ) )
     => ( quickc2099533868ustive @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_64,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
        & ( quickcheck_random @ A9 @ ( type2 @ A9 ) ) )
     => ( quickcheck_random @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___HOL_Oequal_65,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( cl_HOL_Oequal @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) )).

thf(tcon_Option_Ooption___Quickcheck__Exhaustive_Ofull__exhaustive_66,axiom,(
    ! [A8: $tType] :
      ( ( quickc2099533868ustive @ A8 @ ( type2 @ A8 ) )
     => ( quickc2099533868ustive @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Option_Ooption___Quickcheck__Random_Orandom_67,axiom,(
    ! [A8: $tType] :
      ( ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
     => ( quickcheck_random @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Option_Ooption___HOL_Oequal_68,axiom,(
    ! [A8: $tType] :
      ( cl_HOL_Oequal @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) )).

thf(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Ofull__exhaustive_69,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( quickc2099533868ustive @ A8 @ ( type2 @ A8 ) )
        & ( quickc2099533868ustive @ A9 @ ( type2 @ A9 ) ) )
     => ( quickc2099533868ustive @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Quickcheck__Exhaustive_Oexhaustive_70,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( quickc1261659869ustive @ A8 @ ( type2 @ A8 ) )
        & ( quickc1261659869ustive @ A9 @ ( type2 @ A9 ) ) )
     => ( quickc1261659869ustive @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_71,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
        & ( quickcheck_random @ A9 @ ( type2 @ A9 ) ) )
     => ( quickcheck_random @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___HOL_Oequal_72,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( cl_HOL_Oequal @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) )).

thf(tcon_Product__Type_Ounit___Quickcheck__Exhaustive_Ofull__exhaustive_73,axiom,
    ( quickc2099533868ustive @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_74,axiom,
    ( quickcheck_random @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_75,axiom,
    ( order_bot @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Orderings_Obot_76,axiom,
    ( bot @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___HOL_Oequal_77,axiom,
    ( cl_HOL_Oequal @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Evaluation_Oterm___HOL_Oequal_78,axiom,
    ( cl_HOL_Oequal @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Ofull__exhaustive_79,axiom,
    ( quickc2099533868ustive @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1__no__zero__divisors_80,axiom,
    ( semiri134348788visors @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Exhaustive_Oexhaustive_81,axiom,
    ( quickc1261659869ustive @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_82,axiom,
    ( quickcheck_random @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_83,axiom,
    ( semiring_1 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_84,axiom,
    ( zero @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___HOL_Oequal_85,axiom,
    ( cl_HOL_Oequal @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_BinDag__Mirabelle__rybootvolr_Odag___HOL_Oequal_86,axiom,
    ( cl_HOL_Oequal @ binDag_Mirabelle_dag @ ( type2 @ binDag_Mirabelle_dag ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X3: A,Y5: A] :
      ( ( if @ A @ $false @ X3 @ Y5 )
      = Y5 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X3: A,Y5: A] :
      ( ( if @ A @ $true @ X3 @ Y5 )
      = X3 ) )).

%----Conjectures (3)
thf(conj_0,hypothesis,
    ( t
    = ( the @ binDag_Mirabelle_dag @ ( binDag_Mirabelle_Dag @ p @ l @ r ) ) )).

thf(conj_1,hypothesis,
    ( binDag_Mirabelle_Dag @ p @ l @ r @ ta )).

thf(conj_2,conjecture,
    ( binDag_Mirabelle_Dag @ p @ l @ r @ ( a_19_ATP @ ta ) )).

%------------------------------------------------------------------------------
