%------------------------------------------------------------------------------
% File     : COM172^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 47
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__47.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  317 (   0 unit;  47 type;   0 defn)
%            Number of atoms       : 4369 ( 252 equality;2824 variable)
%            Maximal formula depth :   22 (  10 average)
%            Number of connectives : 4075 ( 107   ~;  32   |;  78   &;3519   @)
%                                         (   0 <=>; 339  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  329 ( 329   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   51 (  47   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1137 (  14 sgn; 952   !;  54   ?;  92   ^)
%                                         (1137   :;  39  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:45:38.000
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (43)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_OldropWhile,type,(
    coindu218763757pWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfilter,type,(
    coinductive_lfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Ocorec__llist,type,(
    coindu1259883913_llist: 
      !>[C: $tType,A: $tType] :
        ( ( C > $o ) > ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OltakeWhile,type,(
    coindu501562517eWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oord__class_Olsorted,type,(
    coindu63249387sorted: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Opaths,type,(
    koenig916195507_paths: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ ( coinductive_llist @ Node ) ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Opathsp,type,(
    koenig2031690877pathsp: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( coinductive_llist @ Node ) > $o ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__via,type,(
    koenig317145564le_via: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > ( set @ Node ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__viap,type,(
    koenig1757754772e_viap: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > Node > $o ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_OPowp,type,(
    powp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_graph,type,(
    graph: a > a > $o )).

thf(sy_v_x,type,(
    x: ( coinductive_llist @ a ) )).

thf(sy_v_x21,type,(
    x21: a )).

thf(sy_v_x22,type,(
    x22: ( coinductive_llist @ a ) )).

thf(sy_v_xa,type,(
    xa: a )).

thf(sy_v_xs,type,(
    xs: ( coinductive_llist @ a ) )).

thf(sy_v_ys,type,(
    ys: ( coinductive_llist @ a ) )).

%----Relevant facts (254)
thf(fact_0_assms,axiom,
    ( member @ ( coinductive_llist @ a ) @ ( coinductive_lappend @ a @ xs @ ys ) @ ( koenig916195507_paths @ a @ graph ) )).

% assms
thf(fact_1_paths_OEmpty,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o )] :
      ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LNil @ Node ) @ ( koenig916195507_paths @ Node @ Graph ) ) )).

% paths.Empty
thf(fact_2_paths_OLCons,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node,Y: Node,Xs: ( coinductive_llist @ Node )] :
      ( ( Graph @ X @ Y )
     => ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y @ Xs ) @ ( koenig916195507_paths @ Node @ Graph ) )
       => ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ X @ ( coinductive_LCons @ Node @ Y @ Xs ) ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) )).

% paths.LCons
thf(fact_3_paths_Ocases,axiom,(
    ! [Node: $tType,A2: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( member @ ( coinductive_llist @ Node ) @ A2 @ ( koenig916195507_paths @ Node @ Graph ) )
     => ( ( A2
         != ( coinductive_LNil @ Node ) )
       => ( ! [X2: Node] :
              ( A2
             != ( coinductive_LCons @ Node @ X2 @ ( coinductive_LNil @ Node ) ) )
         => ~ ( ! [X2: Node,Y2: Node,Xs2: ( coinductive_llist @ Node )] :
                  ( ( A2
                    = ( coinductive_LCons @ Node @ X2 @ ( coinductive_LCons @ Node @ Y2 @ Xs2 ) ) )
                 => ( ( Graph @ X2 @ Y2 )
                   => ~ ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y2 @ Xs2 ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) ) ) ) ) )).

% paths.cases
thf(fact_4_paths_Osimps,axiom,(
    ! [Node: $tType,A2: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( member @ ( coinductive_llist @ Node ) @ A2 @ ( koenig916195507_paths @ Node @ Graph ) )
      = ( ( A2
          = ( coinductive_LNil @ Node ) )
        | ? [X3: Node] :
            ( A2
            = ( coinductive_LCons @ Node @ X3 @ ( coinductive_LNil @ Node ) ) )
        | ? [X3: Node,Y3: Node,Xs3: ( coinductive_llist @ Node )] :
            ( ( A2
              = ( coinductive_LCons @ Node @ X3 @ ( coinductive_LCons @ Node @ Y3 @ Xs3 ) ) )
            & ( Graph @ X3 @ Y3 )
            & ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y3 @ Xs3 ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) ) )).

% paths.simps
thf(fact_5_paths_OSingle,axiom,(
    ! [Node: $tType,X: Node,Graph: ( Node > Node > $o )] :
      ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ X @ ( coinductive_LNil @ Node ) ) @ ( koenig916195507_paths @ Node @ Graph ) ) )).

% paths.Single
thf(fact_6_paths__LConsD,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),Graph: ( A > A > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X @ Xs ) @ ( koenig916195507_paths @ A @ Graph ) )
     => ( member @ ( coinductive_llist @ A ) @ Xs @ ( koenig916195507_paths @ A @ Graph ) ) ) )).

% paths_LConsD
thf(fact_7_paths_Ocoinduct,axiom,(
    ! [Node: $tType,X4: ( ( coinductive_llist @ Node ) > $o ),X: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( X4 @ X )
     => ( ! [X2: ( coinductive_llist @ Node )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ Node ) )
              | ? [Xa: Node] :
                  ( X2
                  = ( coinductive_LCons @ Node @ Xa @ ( coinductive_LNil @ Node ) ) )
              | ? [Xa: Node,Y4: Node,Xs4: ( coinductive_llist @ Node )] :
                  ( ( X2
                    = ( coinductive_LCons @ Node @ Xa @ ( coinductive_LCons @ Node @ Y4 @ Xs4 ) ) )
                  & ( Graph @ Xa @ Y4 )
                  & ( ( X4 @ ( coinductive_LCons @ Node @ Y4 @ Xs4 ) )
                    | ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y4 @ Xs4 ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) ) )
       => ( member @ ( coinductive_llist @ Node ) @ X @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) )).

% paths.coinduct
thf(fact_8_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_9_lappend__LNil2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ Xs @ ( coinductive_LNil @ A ) )
      = Xs ) )).

% lappend_LNil2
thf(fact_10_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa2: A,X: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa2 @ X ) @ Ys )
      = ( coinductive_LCons @ A @ Xa2 @ ( coinductive_lappend @ A @ X @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_11_lappend__snocL1__conv__LCons2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ ( coinductive_LNil @ A ) ) ) @ Ys )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) )).

% lappend_snocL1_conv_LCons2
thf(fact_12_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_13_lappend__LNil__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lappend_LNil_LNil
thf(fact_14_LNil__eq__lappend__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_eq_lappend_iff
thf(fact_15_lappend__eq__LNil__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ Xs @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_eq_LNil_iff
thf(fact_16_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_17_llist_Oexhaust,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( Y
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_18_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X3: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs5 ) ) ) ) )).

% neq_LNil_conv
thf(fact_19_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_20_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs5: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y @ Xs5 ) )
            & ( coindu328551480prefix @ A @ Xs5 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_21_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_22_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_23_llast__singleton,axiom,(
    ! [A: $tType,X: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) )
      = X ) )).

% llast_singleton
thf(fact_24_lmember__code_I1_J,axiom,(
    ! [A: $tType,X: A] :
      ~ ( coinductive_lmember @ A @ X @ ( coinductive_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_25_lmember__code_I2_J,axiom,(
    ! [A: $tType,X: A,Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( X = Y )
        | ( coinductive_lmember @ A @ X @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_26_pathsp_Ocoinduct,axiom,(
    ! [Node: $tType,X4: ( ( coinductive_llist @ Node ) > $o ),X: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( X4 @ X )
     => ( ! [X2: ( coinductive_llist @ Node )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ Node ) )
              | ? [Xa: Node] :
                  ( X2
                  = ( coinductive_LCons @ Node @ Xa @ ( coinductive_LNil @ Node ) ) )
              | ? [Xa: Node,Y4: Node,Xs4: ( coinductive_llist @ Node )] :
                  ( ( X2
                    = ( coinductive_LCons @ Node @ Xa @ ( coinductive_LCons @ Node @ Y4 @ Xs4 ) ) )
                  & ( Graph @ Xa @ Y4 )
                  & ( ( X4 @ ( coinductive_LCons @ Node @ Y4 @ Xs4 ) )
                    | ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ Y4 @ Xs4 ) ) ) ) ) )
       => ( koenig2031690877pathsp @ Node @ Graph @ X ) ) ) )).

% pathsp.coinduct
thf(fact_27_pathsp_OSingle,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node] :
      ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ X @ ( coinductive_LNil @ Node ) ) ) )).

% pathsp.Single
thf(fact_28_pathsp_Osimps,axiom,(
    ! [Node: $tType] :
      ( ( koenig2031690877pathsp @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),A3: ( coinductive_llist @ Node )] :
            ( ( A3
              = ( coinductive_LNil @ Node ) )
            | ? [X3: Node] :
                ( A3
                = ( coinductive_LCons @ Node @ X3 @ ( coinductive_LNil @ Node ) ) )
            | ? [X3: Node,Y3: Node,Xs3: ( coinductive_llist @ Node )] :
                ( ( A3
                  = ( coinductive_LCons @ Node @ X3 @ ( coinductive_LCons @ Node @ Y3 @ Xs3 ) ) )
                & ( Graph2 @ X3 @ Y3 )
                & ( koenig2031690877pathsp @ Node @ Graph2 @ ( coinductive_LCons @ Node @ Y3 @ Xs3 ) ) ) ) ) ) )).

% pathsp.simps
thf(fact_29_pathsp_Ocases,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),A2: ( coinductive_llist @ Node )] :
      ( ( koenig2031690877pathsp @ Node @ Graph @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ Node ) )
       => ( ! [X2: Node] :
              ( A2
             != ( coinductive_LCons @ Node @ X2 @ ( coinductive_LNil @ Node ) ) )
         => ~ ( ! [X2: Node,Y2: Node,Xs2: ( coinductive_llist @ Node )] :
                  ( ( A2
                    = ( coinductive_LCons @ Node @ X2 @ ( coinductive_LCons @ Node @ Y2 @ Xs2 ) ) )
                 => ( ( Graph @ X2 @ Y2 )
                   => ~ ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ Y2 @ Xs2 ) ) ) ) ) ) ) ) )).

% pathsp.cases
thf(fact_30_llast__LCons2,axiom,(
    ! [A: $tType,X: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) )).

% llast_LCons2
thf(fact_31_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B ),Y: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs ) @ ( coinductive_LCons @ B @ Y @ Ys ) )
      = ( ( X = Y )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_32_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_33_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs2: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs2 )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) )).

% llist_less_induct
thf(fact_34_pathsp_OLCons,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node,Y: Node,Xs: ( coinductive_llist @ Node )] :
      ( ( Graph @ X @ Y )
     => ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ Y @ Xs ) )
       => ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ X @ ( coinductive_LCons @ Node @ Y @ Xs ) ) ) ) ) )).

% pathsp.LCons
thf(fact_35_pathsp_OEmpty,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o )] :
      ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LNil @ Node ) ) )).

% pathsp.Empty
thf(fact_36_pathsp__paths__eq,axiom,(
    ! [Node: $tType] :
      ( ( koenig2031690877pathsp @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),X3: ( coinductive_llist @ Node )] :
            ( member @ ( coinductive_llist @ Node ) @ X3 @ ( koenig916195507_paths @ Node @ Graph2 ) ) ) ) )).

% pathsp_paths_eq
thf(fact_37_paths__def,axiom,(
    ! [Node: $tType] :
      ( ( koenig916195507_paths @ Node )
      = ( ^ [Graph2: ( Node > Node > $o )] :
            ( collect @ ( coinductive_llist @ Node ) @ ( koenig2031690877pathsp @ Node @ Graph2 ) ) ) ) )).

% paths_def
thf(fact_38_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_39_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( Xs
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_40_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_41_llimit__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( P @ ( coinductive_LNil @ A ) )
     => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lfinite @ A @ Xs2 )
           => ( ( P @ Xs2 )
             => ( P @ ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) )
       => ( ( ! [Ys2: ( coinductive_llist @ A )] :
                ( ( coindu1478340336prefix @ A @ Ys2 @ Xs )
               => ( P @ Ys2 ) )
           => ( P @ Xs ) )
         => ( P @ Xs ) ) ) ) )).

% llimit_induct
thf(fact_42_gen__lset__code_I1_J,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( coinductive_gen_lset @ A @ A4 @ ( coinductive_LNil @ A ) )
      = A4 ) )).

% gen_lset_code(1)
thf(fact_43_lsorted__code_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) ) )).

% lsorted_code(2)
thf(fact_44_lfinite__rev__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_lappend @ A @ Xs2 @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lfinite_rev_induct
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_llist_Ocorec__code,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( coindu1259883913_llist @ C @ A )
      = ( ^ [P2: ( C > $o ),G21: ( C > A ),Q22: ( C > $o ),G221: ( C > ( coinductive_llist @ A ) ),G222: ( C > C ),A3: C] :
            ( if @ ( coinductive_llist @ A ) @ ( P2 @ A3 ) @ ( coinductive_LNil @ A ) @ ( coinductive_LCons @ A @ ( G21 @ A3 ) @ ( if @ ( coinductive_llist @ A ) @ ( Q22 @ A3 ) @ ( G221 @ A3 ) @ ( coindu1259883913_llist @ C @ A @ P2 @ G21 @ Q22 @ G221 @ G222 @ ( G222 @ A3 ) ) ) ) ) ) ) )).

% llist.corec_code
thf(fact_50_unfold__llist_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu1441602521_llist @ A @ B )
      = ( ^ [P2: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A3: A] :
            ( if @ ( coinductive_llist @ B ) @ ( P2 @ A3 ) @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ ( G21 @ A3 ) @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ ( G22 @ A3 ) ) ) ) ) ) )).

% unfold_llist.code
thf(fact_51_lappend_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lappend @ A )
      = ( ^ [Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ Ys3
            @ ^ [X3: A,Xs5: ( coinductive_llist @ A )] :
                ( coinductive_LCons @ A @ X3 @ ( coinductive_lappend @ A @ Xs5 @ Ys3 ) )
            @ Xs3 ) ) ) )).

% lappend.code
thf(fact_52_ltakeWhile__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LCons @ A @ X @ ( coindu501562517eWhile @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LNil @ A ) ) ) ) )).

% ltakeWhile_LCons
thf(fact_53_ltakeWhile__K__True,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu501562517eWhile @ A
        @ ^ [Uu: A] : $true
        @ Xs )
      = Xs ) )).

% ltakeWhile_K_True
thf(fact_54_lfinite__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_55_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_56_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_57_lfinite__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ( coinductive_lfinite @ A @ Ys ) ) ) )).

% lfinite_lappend
thf(fact_58_ltakeWhile__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coindu501562517eWhile @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltakeWhile_LNil
thf(fact_59_lsorted__code_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( coindu63249387sorted @ A @ ( coinductive_LNil @ A ) ) ) )).

% lsorted_code(1)
thf(fact_60_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B2: B,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B2 )
        = ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( IS_LNIL @ B2 )
        & ( X
          = ( LHD @ B2 ) )
        & ( Xs
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B2 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_61_ltakeWhile__K__False,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu501562517eWhile @ A
        @ ^ [Uu: A] : $false
        @ Xs )
      = ( coinductive_LNil @ A ) ) )).

% ltakeWhile_K_False
thf(fact_62_corec__llist__never__stop,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),MORE: ( B > ( coinductive_llist @ A ) ),LTL: ( B > B ),X: B] :
      ( ( coindu1259883913_llist @ B @ A @ IS_LNIL @ LHD
        @ ^ [Uu: B] : $false
        @ MORE
        @ LTL
        @ X )
      = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ X ) ) )).

% corec_llist_never_stop
thf(fact_63_llist_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H: ( B > C ),F1: B,F2: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( H @ ( coindu1381640503_llist @ B @ A @ F1 @ F2 @ Llist ) )
      = ( coindu1381640503_llist @ C @ A @ ( H @ F1 )
        @ ^ [X1: A,X23: ( coinductive_llist @ A )] :
            ( H @ ( F2 @ X1 @ X23 ) )
        @ Llist ) ) )).

% llist.case_distrib
thf(fact_64_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_65_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_66_lappend__inf,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_inf
thf(fact_67_LNil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( coindu63249387sorted @ A @ ( coinductive_LNil @ A ) ) ) )).

% LNil
thf(fact_68_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ Ys )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lstrict_prefix_lfinite1
thf(fact_69_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G212: ( A > B ),G223: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 )
        = ( coinductive_LCons @ B @ ( G212 @ A2 ) @ ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ ( G223 @ A2 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_70_unfold__llist_Octr_I1_J,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > $o ),A2: A,G212: ( A > B ),G223: ( A > A )] :
      ( ( P3 @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 )
        = ( coinductive_LNil @ B ) ) ) )).

% unfold_llist.ctr(1)
thf(fact_71_llist_Ocorec_I2_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),A2: C,G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 )
        = ( coinductive_LCons @ A @ ( G212 @ A2 ) @ ( if @ ( coinductive_llist @ A ) @ ( Q222 @ A2 ) @ ( G2212 @ A2 ) @ ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ ( G2222 @ A2 ) ) ) ) ) ) )).

% llist.corec(2)
thf(fact_72_llist_Ocorec_I1_J,axiom,(
    ! [C: $tType,A: $tType,P3: ( C > $o ),A2: C,G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C )] :
      ( ( P3 @ A2 )
     => ( ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 )
        = ( coinductive_LNil @ A ) ) ) )).

% llist.corec(1)
thf(fact_73_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F2: ( A > ( coinductive_llist @ A ) > B ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F2 @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = ( F2 @ X21 @ X22 ) ) )).

% llist.simps(5)
thf(fact_74_llist_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F1: B,F2: ( A > ( coinductive_llist @ A ) > B )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F2 @ ( coinductive_LNil @ A ) )
      = F1 ) )).

% llist.simps(4)
thf(fact_75_lfinite_Oinducts,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),X2: A] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) )
         => ( P @ X ) ) ) ) )).

% lfinite.inducts
thf(fact_76_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A3: ( coinductive_llist @ A )] :
            ( ( A3
              = ( coinductive_LNil @ A ) )
            | ? [Xs3: ( coinductive_llist @ A ),X3: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ X3 @ Xs3 ) )
                & ( coinductive_lfinite @ A @ Xs3 ) ) ) ) ) )).

% lfinite.simps
thf(fact_77_lfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X2: A] :
                    ( A2
                    = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
               => ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% lfinite.cases
thf(fact_78_Singleton,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) ) )).

% Singleton
thf(fact_79_lfilter_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfilter @ A )
      = ( ^ [P4: ( A > $o )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
            @ ^ [X3: A,Xs5: ( coinductive_llist @ A )] :
                ( if @ ( coinductive_llist @ A ) @ ( P4 @ X3 ) @ ( coinductive_LCons @ A @ X3 @ ( coinductive_lfilter @ A @ P4 @ Xs5 ) ) @ ( coinductive_lfilter @ A @ P4 @ Xs5 ) ) ) ) ) )).

% lfilter.simps
thf(fact_80_lsorted_Ocoinduct,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X4: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A )] :
          ( ( X4 @ X )
         => ( ! [X2: ( coinductive_llist @ A )] :
                ( ( X4 @ X2 )
               => ( ( X2
                    = ( coinductive_LNil @ A ) )
                  | ? [Xa: A] :
                      ( X2
                      = ( coinductive_LCons @ A @ Xa @ ( coinductive_LNil @ A ) ) )
                  | ? [Xa: A,Y4: A,Xs4: ( coinductive_llist @ A )] :
                      ( ( X2
                        = ( coinductive_LCons @ A @ Xa @ ( coinductive_LCons @ A @ Y4 @ Xs4 ) ) )
                      & ( ord_less_eq @ A @ Xa @ Y4 )
                      & ( ( X4 @ ( coinductive_LCons @ A @ Y4 @ Xs4 ) )
                        | ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y4 @ Xs4 ) ) ) ) ) )
           => ( coindu63249387sorted @ A @ X ) ) ) ) )).

% lsorted.coinduct
thf(fact_81_lsorted_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( coindu63249387sorted @ A )
        = ( ^ [A3: ( coinductive_llist @ A )] :
              ( ( A3
                = ( coinductive_LNil @ A ) )
              | ? [X3: A] :
                  ( A3
                  = ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) )
              | ? [X3: A,Y3: A,Xs3: ( coinductive_llist @ A )] :
                  ( ( A3
                    = ( coinductive_LCons @ A @ X3 @ ( coinductive_LCons @ A @ Y3 @ Xs3 ) ) )
                  & ( ord_less_eq @ A @ X3 @ Y3 )
                  & ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y3 @ Xs3 ) ) ) ) ) ) ) )).

% lsorted.simps
thf(fact_82_lsorted_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ A2 )
         => ( ( A2
             != ( coinductive_LNil @ A ) )
           => ( ! [X2: A] :
                  ( A2
                 != ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) )
             => ~ ( ! [X2: A,Y2: A,Xs2: ( coinductive_llist @ A )] :
                      ( ( A2
                        = ( coinductive_LCons @ A @ X2 @ ( coinductive_LCons @ A @ Y2 @ Xs2 ) ) )
                     => ( ( ord_less_eq @ A @ X2 @ Y2 )
                       => ~ ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y2 @ Xs2 ) ) ) ) ) ) ) ) ) )).

% lsorted.cases
thf(fact_83_lstrict__prefix__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lstrict_prefix_lappend_conv
thf(fact_84_split__llist__first,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys4: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys4 @ ( coinductive_LCons @ A @ X @ Zs2 ) ) )
          & ( coinductive_lfinite @ A @ Ys4 )
          & ~ ( member @ A @ X @ ( coinductive_lset @ A @ Ys4 ) ) ) ) )).

% split_llist_first
thf(fact_85_split__llist,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys4: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys4 @ ( coinductive_LCons @ A @ X @ Zs2 ) ) )
          & ( coinductive_lfinite @ A @ Ys4 ) ) ) )).

% split_llist
thf(fact_86_lappend__ltakeWhile__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = Xs ) )).

% lappend_ltakeWhile_ldropWhile
thf(fact_87_lfilter__idem,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( coinductive_lfilter @ A @ P @ Xs ) ) )).

% lfilter_idem
thf(fact_88_lfilter__K__True,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A
        @ ^ [Uu: A] : $true
        @ Xs )
      = Xs ) )).

% lfilter_K_True
thf(fact_89_lappend_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.disc_iff(2)
thf(fact_90_lnull__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        & ( coinductive_lnull @ A @ Ys ) ) ) )).

% lnull_lappend
thf(fact_91_lfilter__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons
thf(fact_92_lfilter__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lfilter_LNil
thf(fact_93_ldropWhile__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coindu218763757pWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LCons @ A @ X @ Xs ) ) ) ) )).

% ldropWhile_LCons
thf(fact_94_ldropWhile__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ldropWhile_LNil
thf(fact_95_unfold__llist_Odisc__iff_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),G212: ( A > B ),G223: ( A > A ),A2: A] :
      ( ( ~ ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 ) ) )
      = ( ~ ( P3 @ A2 ) ) ) )).

% unfold_llist.disc_iff(2)
thf(fact_96_unfold__llist_Odisc__iff_I1_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),G212: ( A > B ),G223: ( A > A ),A2: A] :
      ( ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 ) )
      = ( P3 @ A2 ) ) )).

% unfold_llist.disc_iff(1)
thf(fact_97_llist_Ocorec__disc__iff_I2_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C ),A2: C] :
      ( ( ~ ( coinductive_lnull @ A @ ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 ) ) )
      = ( ~ ( P3 @ A2 ) ) ) )).

% llist.corec_disc_iff(2)
thf(fact_98_llist_Ocorec__disc__iff_I1_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C ),A2: C] :
      ( ( coinductive_lnull @ A @ ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 ) )
      = ( P3 @ A2 ) ) )).

% llist.corec_disc_iff(1)
thf(fact_99_lfitler__K__False,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A
        @ ^ [Uu: A] : $false
        @ Xs )
      = ( coinductive_LNil @ A ) ) )).

% lfitler_K_False
thf(fact_100_lset__lfilter,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lset @ A @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
            & ( P @ X3 ) ) ) ) )).

% lset_lfilter
thf(fact_101_ldropWhile__K__True,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu218763757pWhile @ A
        @ ^ [Uu: A] : $true
        @ Xs )
      = ( coinductive_LNil @ A ) ) )).

% ldropWhile_K_True
thf(fact_102_lsorted__LCons__LCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) ) ) )).

% lsorted_LCons_LCons
thf(fact_103_diverge__lfilter__LNil,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
         => ~ ( P @ X2 ) )
     => ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_LNil @ A ) ) ) )).

% diverge_lfilter_LNil
thf(fact_104_lnull__lfilter,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ~ ( P @ X3 ) ) ) ) )).

% lnull_lfilter
thf(fact_105_lnull__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) )).

% lnull_ldropWhile
thf(fact_106_lfilter__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( coinductive_lappend @ A @ ( coinductive_lfilter @ A @ P @ Xs ) @ ( coinductive_lfilter @ A @ P @ Ys ) ) ) ) )).

% lfilter_lappend_lfinite
thf(fact_107_lfinite__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X3 ) )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lfinite_ldropWhile
thf(fact_108_llist_Odisc__eq__case_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( coindu1381640503_llist @ $o @ A @ $true
        @ ^ [Uu: A,Uv: ( coinductive_llist @ A )] : $false ) ) )).

% llist.disc_eq_case(1)
thf(fact_109_llist_Odisc__eq__case_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Llist ) )
      = ( coindu1381640503_llist @ $o @ A @ $false
        @ ^ [Uu: A,Uv: ( coinductive_llist @ A )] : $true
        @ Llist ) ) )).

% llist.disc_eq_case(2)
thf(fact_110_lfilter__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( coinductive_lfilter @ A @ P @ Xs )
          = ( coinductive_lfilter @ A @ Q @ Ys ) ) ) ) )).

% lfilter_cong
thf(fact_111_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_112_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_113_ldropWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( coindu218763757pWhile @ A @ P @ Xs )
          = ( coindu218763757pWhile @ A @ Q @ Ys ) ) ) ) )).

% ldropWhile_cong
thf(fact_114_lfilter__id__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) )).

% lfilter_id_conv
thf(fact_115_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B2: A,A2: A] :
          ( ! [A5: A,B3: A] :
              ( ( ord_less_eq @ A @ A5 @ B3 )
             => ( P @ A5 @ B3 ) )
         => ( ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
           => ( P @ A2 @ B2 ) ) ) ) )).

% wlog_linorder_le
thf(fact_116_lfilter__empty__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_LNil @ A ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ~ ( P @ X3 ) ) ) ) )).

% lfilter_empty_conv
thf(fact_117_in__lset__ldropWhileD,axiom,(
    ! [A: $tType,X: A,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ldropWhileD
thf(fact_118_lset__ldropWhile__subset,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) ) @ ( coinductive_lset @ A @ Xs ) ) )).

% lset_ldropWhile_subset
thf(fact_119_lset__lappend1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) )).

% lset_lappend1
thf(fact_120_lfilter__lfilter,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ Q @ Xs ) )
      = ( coinductive_lfilter @ A
        @ ^ [X3: A] :
            ( ( P @ X3 )
            & ( Q @ X3 ) )
        @ Xs ) ) )).

% lfilter_lfilter
thf(fact_121_ldropWhile__eq__LNil__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu218763757pWhile @ A @ P @ Xs )
        = ( coinductive_LNil @ A ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) )).

% ldropWhile_eq_LNil_iff
thf(fact_122_ltakeWhile__all__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu501562517eWhile @ A @ P @ Xs )
        = Xs )
      = ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( collect @ A @ P ) ) ) )).

% ltakeWhile_all_conv
thf(fact_123_lsorted__LCons,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( ( coindu63249387sorted @ A @ Xs )
            & ! [X3: A] :
                ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
               => ( ord_less_eq @ A @ X @ X3 ) ) ) ) ) )).

% lsorted_LCons
thf(fact_124_lfilter__LCons__seek,axiom,(
    ! [A: $tType,P3: ( A > $o ),X: A,L: ( coinductive_llist @ A )] :
      ( ~ ( P3 @ X )
     => ( ( coinductive_lfilter @ A @ P3 @ ( coinductive_LCons @ A @ X @ L ) )
        = ( coinductive_lfilter @ A @ P3 @ L ) ) ) )).

% lfilter_LCons_seek
thf(fact_125_lfilter__LCons__found,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( P @ X )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
        = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons_found
thf(fact_126_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),X5: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X5 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_127_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_128_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_129_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_130_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs6: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X @ Xs6 ) )
       => ~ ( ! [X6: A,Xs6: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X6 @ Xs6 ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs6 ) ) ) ) ) ) )).

% lset_cases
thf(fact_131_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( X != X6 )
               => ( ( P @ Xs2 )
                 => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_132_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_133_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z2: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z2 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_134_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( coinductive_llist @ A ),Xa3: A] :
              ( ( member @ A @ Xa3 @ ( coinductive_lset @ A @ Z2 ) )
             => ( ( P @ Xa3 @ Z2 )
               => ( P @ Xa3 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_135_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_136_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X21 @ X22 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_137_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X3: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs5 ) ) ) ) )).

% not_lnull_conv
thf(fact_138_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_139_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_140_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist )
     => ( Llist
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_141_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist2: ( coinductive_llist @ A )] :
            ( Llist2
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_142_lfinite__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )).

% lfinite_lfilterI
thf(fact_143_lappend_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) )
     => ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) )).

% lappend.disc(2)
thf(fact_144_lappend_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) ) )).

% lappend.disc(1)
thf(fact_145_lappend__lnull1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Ys ) ) )).

% lappend_lnull1
thf(fact_146_lappend__lnull2,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_lnull2
thf(fact_147_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_148_ltakeWhile__all,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
         => ( P @ X2 ) )
     => ( ( coindu501562517eWhile @ A @ P @ Xs )
        = Xs ) ) )).

% ltakeWhile_all
thf(fact_149_ltakeWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( coindu501562517eWhile @ A @ P @ Xs )
          = ( coindu501562517eWhile @ A @ Q @ Ys ) ) ) ) )).

% ltakeWhile_cong
thf(fact_150_lset__ltakeWhileD,axiom,(
    ! [A: $tType,X: A,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        & ( P @ X ) ) ) )).

% lset_ltakeWhileD
thf(fact_151_lsorted__lfilterI,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
          ( ( coindu63249387sorted @ A @ Xs )
         => ( coindu63249387sorted @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lsorted_lfilterI
thf(fact_152_ltakeWhile__lappend2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( collect @ A @ P ) )
     => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( coinductive_lappend @ A @ Xs @ ( coindu501562517eWhile @ A @ P @ Ys ) ) ) ) )).

% ltakeWhile_lappend2
thf(fact_153_unfold__llist_Odisc_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G212: ( A > B ),G223: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ~ ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 ) ) ) )).

% unfold_llist.disc(2)
thf(fact_154_unfold__llist_Odisc_I1_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G212: ( A > B ),G223: ( A > A )] :
      ( ( P3 @ A2 )
     => ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 ) ) ) )).

% unfold_llist.disc(1)
thf(fact_155_llist_Ocorec__disc_I2_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),A2: C,G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C )] :
      ( ~ ( P3 @ A2 )
     => ~ ( coinductive_lnull @ A @ ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 ) ) ) )).

% llist.corec_disc(2)
thf(fact_156_llist_Ocorec__disc_I1_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),A2: C,G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C )] :
      ( ( P3 @ A2 )
     => ( coinductive_lnull @ A @ ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 ) ) ) )).

% llist.corec_disc(1)
thf(fact_157_lfilter__eq__LConsD,axiom,(
    ! [A: $tType,P: ( A > $o ),Ys: ( coinductive_llist @ A ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Ys )
        = ( coinductive_LCons @ A @ X @ Xs ) )
     => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
          ( ( Ys
            = ( coinductive_lappend @ A @ Us @ ( coinductive_LCons @ A @ X @ Vs ) ) )
          & ( coinductive_lfinite @ A @ Us )
          & ! [X7: A] :
              ( ( member @ A @ X7 @ ( coinductive_lset @ A @ Us ) )
             => ~ ( P @ X7 ) )
          & ( P @ X )
          & ( Xs
            = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) )).

% lfilter_eq_LConsD
thf(fact_158_lsorted__lfilter__same,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [C2: A,Xs: ( coinductive_llist @ A )] :
          ( coindu63249387sorted @ A
          @ ( coinductive_lfilter @ A
            @ ^ [X3: A] : ( X3 = C2 )
            @ Xs ) ) ) )).

% lsorted_lfilter_same
thf(fact_159_lset__lmember,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
      = ( coinductive_lmember @ A @ X @ Xs ) ) )).

% lset_lmember
thf(fact_160_lfilter__eq__lappend__lfiniteD,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_lappend @ A @ Ys @ Zs ) )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_lappend @ A @ Us @ Vs ) )
            & ( coinductive_lfinite @ A @ Us )
            & ( Ys
              = ( coinductive_lfilter @ A @ P @ Us ) )
            & ( Zs
              = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) ) )).

% lfilter_eq_lappend_lfiniteD
thf(fact_161_in__lset__lappend__iff,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        | ( ( coinductive_lfinite @ A @ Xs )
          & ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) ) ) ) ) )).

% in_lset_lappend_iff
thf(fact_162_lappend_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_lappend @ A @ Xs @ Ys )
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend.ctr(1)
thf(fact_163_ltakeWhile__lappend1,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coindu501562517eWhile @ A @ P @ Xs ) ) ) ) )).

% ltakeWhile_lappend1
thf(fact_164_lfinite__ltakeWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        | ? [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X3 ) ) ) ) )).

% lfinite_ltakeWhile
thf(fact_165_llast__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
          = X ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_llast @ A @ Xs ) ) ) ) )).

% llast_LCons
thf(fact_166_LCons__LCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( coinductive_llist @ A )] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y @ Xs ) )
           => ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) ) ) ) )).

% LCons_LCons
thf(fact_167_ldropWhile_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu218763757pWhile @ A )
      = ( ^ [P4: ( A > $o ),Xs3: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
            @ ^ [X3: A,Xs5: ( coinductive_llist @ A )] :
                ( if @ ( coinductive_llist @ A ) @ ( P4 @ X3 ) @ ( coindu218763757pWhile @ A @ P4 @ Xs5 ) @ Xs3 )
            @ Xs3 ) ) ) )).

% ldropWhile.simps
thf(fact_168_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_169_reachable__viap_Ocases,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N: Node,A2: Node] :
      ( ( koenig1757754772e_viap @ Node @ Graph @ Ns @ N @ A2 )
     => ~ ( ! [Xs2: ( coinductive_llist @ Node )] :
              ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ N @ Xs2 ) )
             => ( ( member @ Node @ A2 @ ( coinductive_lset @ Node @ Xs2 ) )
               => ~ ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns ) ) ) ) ) )).

% reachable_viap.cases
thf(fact_170_reachable__viap_Osimps,axiom,(
    ! [Node: $tType] :
      ( ( koenig1757754772e_viap @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),Ns2: ( set @ Node ),N2: Node,A3: Node] :
          ? [Xs3: ( coinductive_llist @ Node ),N3: Node] :
            ( ( A3 = N3 )
            & ( koenig2031690877pathsp @ Node @ Graph2 @ ( coinductive_LCons @ Node @ N2 @ Xs3 ) )
            & ( member @ Node @ N3 @ ( coinductive_lset @ Node @ Xs3 ) )
            & ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs3 ) @ Ns2 ) ) ) ) )).

% reachable_viap.simps
thf(fact_171_reachable__viap_Ointros,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),N: Node,Xs: ( coinductive_llist @ Node ),N4: Node,Ns: ( set @ Node )] :
      ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ N @ Xs ) )
     => ( ( member @ Node @ N4 @ ( coinductive_lset @ Node @ Xs ) )
       => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs ) @ Ns )
         => ( koenig1757754772e_viap @ Node @ Graph @ Ns @ N @ N4 ) ) ) ) )).

% reachable_viap.intros
thf(fact_172_reachable__viap_Oinducts,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N: Node,X: Node,P: ( Node > $o )] :
      ( ( koenig1757754772e_viap @ Node @ Graph @ Ns @ N @ X )
     => ( ! [Xs2: ( coinductive_llist @ Node ),N5: Node] :
            ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ N @ Xs2 ) )
           => ( ( member @ Node @ N5 @ ( coinductive_lset @ Node @ Xs2 ) )
             => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns )
               => ( P @ N5 ) ) ) )
       => ( P @ X ) ) ) )).

% reachable_viap.inducts
thf(fact_173_reachable__via_Ocases,axiom,(
    ! [Node: $tType,A2: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N: Node] :
      ( ( member @ Node @ A2 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N ) )
     => ~ ( ! [Xs2: ( coinductive_llist @ Node )] :
              ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N @ Xs2 ) @ ( koenig916195507_paths @ Node @ Graph ) )
             => ( ( member @ Node @ A2 @ ( coinductive_lset @ Node @ Xs2 ) )
               => ~ ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns ) ) ) ) ) )).

% reachable_via.cases
thf(fact_174_reachable__viap__reachable__via__eq,axiom,(
    ! [Node: $tType] :
      ( ( koenig1757754772e_viap @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),Ns2: ( set @ Node ),N2: Node,X3: Node] :
            ( member @ Node @ X3 @ ( koenig317145564le_via @ Node @ Graph2 @ Ns2 @ N2 ) ) ) ) )).

% reachable_viap_reachable_via_eq
thf(fact_175_reachable__via__def,axiom,(
    ! [Node: $tType] :
      ( ( koenig317145564le_via @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),Ns2: ( set @ Node ),N2: Node] :
            ( collect @ Node @ ( koenig1757754772e_viap @ Node @ Graph2 @ Ns2 @ N2 ) ) ) ) )).

% reachable_via_def
thf(fact_176_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funD
thf(fact_177_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funE
thf(fact_178_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X2: A] :
              ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_179_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B )] :
            ! [X3: A] :
              ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) )).

% le_fun_def
thf(fact_180_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_181_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F @ B2 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_182_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B2: B,C2: B] :
          ( ( A2
            = ( F @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_183_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F @ B2 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_184_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y5: A,Z: A] : ( Y5 = Z ) )
        = ( ^ [X3: A,Y3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y3 )
              & ( ord_less_eq @ A @ Y3 @ X3 ) ) ) ) ) )).

% eq_iff
thf(fact_185_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) )).

% antisym
thf(fact_186_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) )).

% linear
thf(fact_187_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) )).

% eq_refl
thf(fact_188_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) )).

% le_cases
thf(fact_189_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% order.trans
thf(fact_190_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z3 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z3 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z3 )
               => ~ ( ord_less_eq @ A @ Z3 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z3 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z3 )
                   => ~ ( ord_less_eq @ A @ Z3 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z3 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_191_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) )).

% antisym_conv
thf(fact_192_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_193_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_194_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) )).

% order_class.order.antisym
thf(fact_195_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z3 )
           => ( ord_less_eq @ A @ X @ Z3 ) ) ) ) )).

% order_trans
thf(fact_196_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_197_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B2: A] :
          ( ! [A5: A,B3: A] :
              ( ( ord_less_eq @ A @ A5 @ B3 )
             => ( P @ A5 @ B3 ) )
         => ( ! [A5: A,B3: A] :
                ( ( P @ B3 @ A5 )
               => ( P @ A5 @ B3 ) )
           => ( P @ A2 @ B2 ) ) ) ) )).

% linorder_wlog
thf(fact_198_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_199_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) )).

% dual_order.antisym
thf(fact_200_reachable__via_Oinducts,axiom,(
    ! [Node: $tType,X: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N: Node,P: ( Node > $o )] :
      ( ( member @ Node @ X @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N ) )
     => ( ! [Xs2: ( coinductive_llist @ Node ),N5: Node] :
            ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N @ Xs2 ) @ ( koenig916195507_paths @ Node @ Graph ) )
           => ( ( member @ Node @ N5 @ ( coinductive_lset @ Node @ Xs2 ) )
             => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns )
               => ( P @ N5 ) ) ) )
       => ( P @ X ) ) ) )).

% reachable_via.inducts
thf(fact_201_reachable__via_Ointros,axiom,(
    ! [Node: $tType,N: Node,Xs: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o ),N4: Node,Ns: ( set @ Node )] :
      ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N @ Xs ) @ ( koenig916195507_paths @ Node @ Graph ) )
     => ( ( member @ Node @ N4 @ ( coinductive_lset @ Node @ Xs ) )
       => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs ) @ Ns )
         => ( member @ Node @ N4 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N ) ) ) ) ) )).

% reachable_via.intros
thf(fact_202_reachable__via_Osimps,axiom,(
    ! [Node: $tType,A2: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N: Node] :
      ( ( member @ Node @ A2 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N ) )
      = ( ? [Xs3: ( coinductive_llist @ Node ),N3: Node] :
            ( ( A2 = N3 )
            & ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N @ Xs3 ) @ ( koenig916195507_paths @ Node @ Graph ) )
            & ( member @ Node @ N3 @ ( coinductive_lset @ Node @ Xs3 ) )
            & ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs3 ) @ Ns ) ) ) ) )).

% reachable_via.simps
thf(fact_203_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_204_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A4 )
         => ( member @ A @ X2 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% subsetI
thf(fact_205_ldropWhile__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( ? [X7: A] :
            ( ( member @ A @ X7 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X7 ) )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lappend @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) @ Ys ) ) )
      & ( ~ ( ? [X2: A] :
                ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
                & ~ ( P @ X2 ) ) )
       => ( ( ( coinductive_lfinite @ A @ Xs )
           => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( coindu218763757pWhile @ A @ P @ Ys ) ) )
          & ( ~ ( coinductive_lfinite @ A @ Xs )
           => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( coinductive_LNil @ A ) ) ) ) ) ) )).

% ldropWhile_lappend
thf(fact_206_set__mp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% set_mp
thf(fact_207_in__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% in_mono
thf(fact_208_subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetD
thf(fact_209_subsetCE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetCE
thf(fact_210_equalityE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) )).

% equalityE
thf(fact_211_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( member @ A @ X3 @ B5 ) ) ) ) )).

% subset_eq
thf(fact_212_equalityD1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% equalityD1
thf(fact_213_equalityD2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) )).

% equalityD2
thf(fact_214_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% set_rev_mp
thf(fact_215_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
          ! [T: A] :
            ( ( member @ A @ T @ A6 )
           => ( member @ A @ T @ B5 ) ) ) ) )).

% subset_iff
thf(fact_216_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% rev_subsetD
thf(fact_217_subset__refl,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ A4 ) )).

% subset_refl
thf(fact_218_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_219_subset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% subset_trans
thf(fact_220_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y5: ( set @ A ),Z: ( set @ A )] : ( Y5 = Z ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A6 ) ) ) ) )).

% set_eq_subset
thf(fact_221_contra__subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ~ ( member @ A @ C2 @ A4 ) ) ) )).

% contra_subsetD
thf(fact_222_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q @ X3 ) ) ) ) )).

% Collect_mono_iff
thf(fact_223_ltakeWhile__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( ? [X7: A] :
            ( ( member @ A @ X7 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X7 ) )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coindu501562517eWhile @ A @ P @ Xs ) ) )
      & ( ~ ( ? [X2: A] :
                ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
                & ~ ( P @ X2 ) ) )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lappend @ A @ Xs @ ( coindu501562517eWhile @ A @ P @ Ys ) ) ) ) ) )).

% ltakeWhile_lappend
thf(fact_224_less__eq__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ A6 )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ B5 ) ) ) ) )).

% less_eq_set_def
thf(fact_225_pred__subset__eq,axiom,(
    ! [A: $tType,R: ( set @ A ),S: ( set @ A )] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X3: A] :
            ( member @ A @ X3 @ R )
        @ ^ [X3: A] :
            ( member @ A @ X3 @ S ) )
      = ( ord_less_eq @ ( set @ A ) @ R @ S ) ) )).

% pred_subset_eq
thf(fact_226_conj__subset__def,axiom,(
    ! [A: $tType,A4: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( P @ X3 )
              & ( Q @ X3 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( collect @ A @ Q ) ) ) ) )).

% conj_subset_def
thf(fact_227_predicate1I,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) )).

% predicate1I
thf(fact_228_rev__predicate1D,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Q: ( A > $o )] :
      ( ( P @ X )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X ) ) ) )).

% rev_predicate1D
thf(fact_229_predicate1D,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o ),X: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X )
       => ( Q @ X ) ) ) )).

% predicate1D
thf(fact_230_subset__Collect__iff,axiom,(
    ! [A: $tType,B4: ( set @ A ),A4: ( set @ A ),P: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( P @ X3 ) ) ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ B4 )
             => ( P @ X3 ) ) ) ) ) )).

% subset_Collect_iff
thf(fact_231_subset__CollectI,axiom,(
    ! [A: $tType,B4: ( set @ A ),A4: ( set @ A ),Q: ( A > $o ),P: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ B4 )
           => ( ( Q @ X2 )
             => ( P @ X2 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ B4 )
                & ( Q @ X3 ) ) )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( P @ X3 ) ) ) ) ) ) )).

% subset_CollectI
thf(fact_232_prop__restrict,axiom,(
    ! [A: $tType,X: A,Z4: ( set @ A ),X4: ( set @ A ),P: ( A > $o )] :
      ( ( member @ A @ X @ Z4 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z4
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ X4 )
                & ( P @ X3 ) ) ) )
       => ( P @ X ) ) ) )).

% prop_restrict
thf(fact_233_Collect__restrict,axiom,(
    ! [A: $tType,X4: ( set @ A ),P: ( A > $o )] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ X4 )
            & ( P @ X3 ) ) )
      @ X4 ) )).

% Collect_restrict
thf(fact_234_llast__lappend,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_llast @ A @ Xs ) ) )
      & ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( coinductive_lfinite @ A @ Xs )
           => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( coinductive_llast @ A @ Ys ) ) )
          & ( ~ ( coinductive_lfinite @ A @ Xs )
           => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( undefined @ A ) ) ) ) ) ) )).

% llast_lappend
thf(fact_235_Powp__mono,axiom,(
    ! [A: $tType,A4: ( A > $o ),B4: ( A > $o )] :
      ( ( ord_less_eq @ ( A > $o ) @ A4 @ B4 )
     => ( ord_less_eq @ ( ( set @ A ) > $o ) @ ( powp @ A @ A4 ) @ ( powp @ A @ B4 ) ) ) )).

% Powp_mono
thf(fact_236_llast__linfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ Xs )
        = ( undefined @ A ) ) ) )).

% llast_linfinite
thf(fact_237_llast__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llast @ A @ ( coinductive_LNil @ A ) )
      = ( undefined @ A ) ) )).

% llast_LNil
thf(fact_238_lappend_Octr_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = ( coinductive_LCons @ A
          @ ( coindu1381640503_llist @ A @ A @ ( coinductive_lhd @ A @ Ys )
            @ ^ [X3: A,Xs5: ( coinductive_llist @ A )] : X3
            @ Xs )
          @ ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A
            @ ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
              @ ^ [Uu2: A,Uv2: ( coinductive_llist @ A )] : Uv2
              @ Ys )
            @ ^ [X3: A,Xs5: ( coinductive_llist @ A )] :
                ( coinductive_lappend @ A @ Xs5 @ Ys )
            @ Xs ) ) ) ) )).

% lappend.ctr(2)
thf(fact_239_lset__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% lset_lappend_lfinite
thf(fact_240_Un__subset__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) @ C3 )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
        & ( ord_less_eq @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Un_subset_iff
thf(fact_241_lhd__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_lhd @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lhd @ A @ Ys ) ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_lhd @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lhd_lappend
thf(fact_242_lnull__ltakeWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lnull_ltakeWhile
thf(fact_243_ltakeWhile_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(1)
thf(fact_244_ltakeWhile_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(2)
thf(fact_245_subset__Un__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( ( sup_sup @ ( set @ A ) @ A6 @ B5 )
            = B5 ) ) ) )).

% subset_Un_eq
thf(fact_246_Un__absorb2,axiom,(
    ! [A: $tType,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
     => ( ( sup_sup @ ( set @ A ) @ A4 @ B4 )
        = A4 ) ) )).

% Un_absorb2
thf(fact_247_Un__absorb1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( sup_sup @ ( set @ A ) @ A4 @ B4 )
        = B4 ) ) )).

% Un_absorb1
thf(fact_248_Un__upper2,axiom,(
    ! [A: $tType,B4: ( set @ A ),A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ B4 @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) )).

% Un_upper2
thf(fact_249_Un__upper1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) )).

% Un_upper1
thf(fact_250_Un__least,axiom,(
    ! [A: $tType,A4: ( set @ A ),C3: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) @ C3 ) ) ) )).

% Un_least
thf(fact_251_Un__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),C3: ( set @ A ),B4: ( set @ A ),D: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ D )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) @ ( sup_sup @ ( set @ A ) @ C3 @ D ) ) ) ) )).

% Un_mono
thf(fact_252_lhd__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lhd @ A )
      = ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X223: ( coinductive_llist @ A )] : X213 ) ) )).

% lhd_def
thf(fact_253_ltakeWhile_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) )
     => ( ( coindu501562517eWhile @ A @ P @ Xs )
        = ( coinductive_LNil @ A ) ) ) )).

% ltakeWhile.ctr(1)

%----Type constructors (10)
thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( preorder @ A8 @ ( type2 @ A8 ) )
     => ( preorder @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order @ A8 @ ( type2 @ A8 ) )
     => ( order @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_1,axiom,(
    ! [A7: $tType] :
      ( preorder @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_2,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_3,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_4,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_5,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_6,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (3)
thf(conj_0,hypothesis,
    ( ( coinductive_lappend @ a @ x @ ys )
    = ( coinductive_LCons @ a @ xa @ ( coinductive_LNil @ a ) ) )).

thf(conj_1,hypothesis,
    ( x
    = ( coinductive_LCons @ a @ x21 @ x22 ) )).

thf(conj_2,conjecture,
    ( ( x
      = ( coinductive_LNil @ a ) )
    | ? [X7: a] :
        ( x
        = ( coinductive_LCons @ a @ X7 @ ( coinductive_LNil @ a ) ) )
    | ? [X7: a,Y4: a,Xs4: ( coinductive_llist @ a )] :
        ( ( x
          = ( coinductive_LCons @ a @ X7 @ ( coinductive_LCons @ a @ Y4 @ Xs4 ) ) )
        & ( graph @ X7 @ Y4 )
        & ( ( member @ ( coinductive_llist @ a ) @ ( coinductive_lappend @ a @ ( coinductive_LCons @ a @ Y4 @ Xs4 ) @ ys ) @ ( koenig916195507_paths @ a @ graph ) )
          | ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ Y4 @ Xs4 ) @ ( koenig916195507_paths @ a @ graph ) ) ) ) )).

%------------------------------------------------------------------------------
