%------------------------------------------------------------------------------
% File     : COM175^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 115
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__115.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  326 (   0 unit;  47 type;   0 defn)
%            Number of atoms       : 4581 ( 241 equality;2967 variable)
%            Maximal formula depth :   23 (  10 average)
%            Number of connectives : 4283 (  86   ~;  39   |;  81   &;3671   @)
%                                         (   0 <=>; 406  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  283 ( 283   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   51 (  47   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1143 (   0 sgn; 971   !;  74   ?;  60   ^)
%                                         (1143   :;  38  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:46:24.599
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (43)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,(
    comple187826305attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oldistinct,type,(
    coindu351974385stinct: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olfilter,type,(
    coinductive_lfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollexord,type,(
    coinductive_llexord: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Ocorec__llist,type,(
    coindu1259883913_llist: 
      !>[C: $tType,A: $tType] :
        ( ( C > $o ) > ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Oord__class_Olsorted,type,(
    coindu63249387sorted: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Opaths,type,(
    koenig916195507_paths: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ ( coinductive_llist @ Node ) ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Opathsp,type,(
    koenig2031690877pathsp: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( coinductive_llist @ Node ) > $o ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__via,type,(
    koenig317145564le_via: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > ( set @ Node ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__viap,type,(
    koenig1757754772e_viap: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > Node > $o ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_graph,type,(
    graph: a > a > $o )).

thf(sy_v_n,type,(
    n: a )).

thf(sy_v_n_H____,type,(
    n2: a )).

thf(sy_v_ns,type,(
    ns: ( set @ a ) )).

thf(sy_v_x____,type,(
    x: a )).

thf(sy_v_xs_H____,type,(
    xs: ( coinductive_llist @ a ) )).

thf(sy_v_xs____,type,(
    xs2: ( coinductive_llist @ a ) )).

%----Relevant facts (256)
thf(fact_0__092_060open_062x_A_092_060in_062_Alset_Axs_092_060close_062,axiom,
    ( member @ a @ x @ ( coinductive_lset @ a @ xs2 ) )).

% \<open>x \<in> lset xs\<close>
thf(fact_1__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062n_H_Axs_H_O_Axs_A_061_ALCons_An_H_Axs_H_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [N: a,Xs: ( coinductive_llist @ a )] :
          ( xs2
         != ( coinductive_LCons @ a @ N @ Xs ) ) ) )).

% \<open>\<And>thesis. (\<And>n' xs'. xs = LCons n' xs' \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_2_xs,axiom,
    ( xs2
    = ( coinductive_LCons @ a @ n2 @ xs ) )).

% xs
thf(fact_3__092_060open_062lset_Axs_A_092_060subseteq_062_Ans_092_060close_062,axiom,
    ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ xs2 ) @ ns )).

% \<open>lset xs \<subseteq> ns\<close>
thf(fact_4_calculation,axiom,
    ( graph @ n @ n2 )).

% calculation
thf(fact_5__092_060open_062x_A_092_060in_062_Areachable__via_Agraph_Ans_An_092_060close_062,axiom,
    ( member @ a @ x @ ( koenig317145564le_via @ a @ graph @ ns @ n ) )).

% \<open>x \<in> reachable_via graph ns n\<close>
thf(fact_6__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062xs_O_A_092_060lbrakk_062LCons_An_Axs_A_092_060in_062_Apaths_Agraph_059_Ax_A_092_060in_062_Alset_Axs_059_Alset_Axs_A_092_060subseteq_062_Ans_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [Xs2: ( coinductive_llist @ a )] :
          ( ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n @ Xs2 ) @ ( koenig916195507_paths @ a @ graph ) )
         => ( ( member @ a @ x @ ( coinductive_lset @ a @ Xs2 ) )
           => ~ ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ Xs2 ) @ ns ) ) ) ) )).

% \<open>\<And>thesis. (\<And>xs. \<lbrakk>LCons n xs \<in> paths graph; x \<in> lset xs; lset xs \<subseteq> ns\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_7_path,axiom,
    ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n @ xs2 ) @ ( koenig916195507_paths @ a @ graph ) )).

% path
thf(fact_8_paths_OLCons,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node,Y: Node,Xs3: ( coinductive_llist @ Node )] :
      ( ( Graph @ X @ Y )
     => ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y @ Xs3 ) @ ( koenig916195507_paths @ Node @ Graph ) )
       => ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ X @ ( coinductive_LCons @ Node @ Y @ Xs3 ) ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) )).

% paths.LCons
thf(fact_9_paths__LConsD,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A ),Graph: ( A > A > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X @ Xs3 ) @ ( koenig916195507_paths @ A @ Graph ) )
     => ( member @ ( coinductive_llist @ A ) @ Xs3 @ ( koenig916195507_paths @ A @ Graph ) ) ) )).

% paths_LConsD
thf(fact_10_path__avoid__node,axiom,(
    ! [A: $tType,N2: A,Xs3: ( coinductive_llist @ A ),Graph: ( A > A > $o ),X: A] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ N2 @ Xs3 ) @ ( koenig916195507_paths @ A @ Graph ) )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
       => ( ( N2 != X )
         => ? [Xs: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ N2 @ Xs ) @ ( koenig916195507_paths @ A @ Graph ) )
              & ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Xs3 ) )
              & ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
              & ~ ( member @ A @ N2 @ ( coinductive_lset @ A @ Xs ) ) ) ) ) ) )).

% path_avoid_node
thf(fact_11_reachable__via_Ocases,axiom,(
    ! [Node: $tType,A2: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node] :
      ( ( member @ Node @ A2 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) )
     => ~ ( ! [Xs2: ( coinductive_llist @ Node )] :
              ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs2 ) @ ( koenig916195507_paths @ Node @ Graph ) )
             => ( ( member @ Node @ A2 @ ( coinductive_lset @ Node @ Xs2 ) )
               => ~ ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns ) ) ) ) ) )).

% reachable_via.cases
thf(fact_12_reachable__via_Osimps,axiom,(
    ! [Node: $tType,A2: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node] :
      ( ( member @ Node @ A2 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) )
      = ( ? [Xs4: ( coinductive_llist @ Node ),N3: Node] :
            ( ( A2 = N3 )
            & ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs4 ) @ ( koenig916195507_paths @ Node @ Graph ) )
            & ( member @ Node @ N3 @ ( coinductive_lset @ Node @ Xs4 ) )
            & ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs4 ) @ Ns ) ) ) ) )).

% reachable_via.simps
thf(fact_13_reachable__via_Ointros,axiom,(
    ! [Node: $tType,N2: Node,Xs3: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o ),N4: Node,Ns: ( set @ Node )] :
      ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs3 ) @ ( koenig916195507_paths @ Node @ Graph ) )
     => ( ( member @ Node @ N4 @ ( coinductive_lset @ Node @ Xs3 ) )
       => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs3 ) @ Ns )
         => ( member @ Node @ N4 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) ) ) ) ) )).

% reachable_via.intros
thf(fact_14_reachable__via_Oinducts,axiom,(
    ! [Node: $tType,X: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node,P: ( Node > $o )] :
      ( ( member @ Node @ X @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) )
     => ( ! [Xs2: ( coinductive_llist @ Node ),N: Node] :
            ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs2 ) @ ( koenig916195507_paths @ Node @ Graph ) )
           => ( ( member @ Node @ N @ ( coinductive_lset @ Node @ Xs2 ) )
             => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns )
               => ( P @ N ) ) ) )
       => ( P @ X ) ) ) )).

% reachable_via.inducts
thf(fact_15_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_16_subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A3 )
         => ( member @ A @ X2 @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) )).

% subsetI
thf(fact_17_subset__antisym,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
       => ( A3 = B2 ) ) ) )).

% subset_antisym
thf(fact_18_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_19_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A ),X3: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X3 @ Xs3 ) ) ) ) )).

% lset_intros(2)
thf(fact_20_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs3 ) ) ) )).

% lset_intros(1)
thf(fact_21_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_22_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_23_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ( ! [Xs: ( coinductive_llist @ A )] :
            ( Xs3
           != ( coinductive_LCons @ A @ X @ Xs ) )
       => ~ ( ! [X4: A,Xs: ( coinductive_llist @ A )] :
                ( ( Xs3
                  = ( coinductive_LCons @ A @ X4 @ Xs ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) ) ) ) )).

% lset_cases
thf(fact_24_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X4: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( X != X4 )
               => ( ( P @ Xs2 )
                 => ( P @ ( coinductive_LCons @ A @ X4 @ Xs2 ) ) ) ) )
         => ( P @ Xs3 ) ) ) ) )).

% lset_induct
thf(fact_25_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X4: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X4 @ Xs2 ) ) ) )
         => ( P @ Xs3 ) ) ) ) )).

% lset_induct'
thf(fact_26_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B3 )
           => ( A2 = B3 ) ) ) ) )).

% dual_order.antisym
thf(fact_27_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_28_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B3: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ! [A4: A,B4: A] :
                ( ( P @ B4 @ A4 )
               => ( P @ A4 @ B4 ) )
           => ( P @ A2 @ B3 ) ) ) ) )).

% linorder_wlog
thf(fact_29_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_30_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) )).

% order_trans
thf(fact_31_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A2 )
           => ( A2 = B3 ) ) ) ) )).

% order_class.order.antisym
thf(fact_32_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_33_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( A2 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_34_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) )).

% antisym_conv
thf(fact_35_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_36_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% order.trans
thf(fact_37_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) )).

% le_cases
thf(fact_38_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B3: A,A2: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ( ( P @ B3 @ A2 )
             => ( P @ A2 @ B3 ) )
           => ( P @ A2 @ B3 ) ) ) ) )).

% wlog_linorder_le
thf(fact_39_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) )).

% eq_refl
thf(fact_40_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) )).

% linear
thf(fact_41_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) )).

% antisym
thf(fact_42_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y2: A,Z2: A] : ( Y2 = Z2 ) )
        = ( ^ [X5: A,Y3: A] :
              ( ( ord_less_eq @ A @ X5 @ Y3 )
              & ( ord_less_eq @ A @ Y3 @ X5 ) ) ) ) ) )).

% eq_iff
thf(fact_43_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ( F @ B3 )
              = C2 )
           => ( ! [X2: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y4 )
                 => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ B @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_44_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C2: B] :
          ( ( A2
            = ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X2: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X5: A] :
            ( member @ A @ X5 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ C @ ( F @ B3 ) @ C2 )
           => ( ! [X2: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y4 )
                 => ( ord_less_eq @ C @ ( F @ X2 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ C @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_50_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X2: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X2 ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_51_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B )] :
            ! [X5: A] :
              ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G2 @ X5 ) ) ) ) ) )).

% le_fun_def
thf(fact_52_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X2: A] :
              ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_53_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funE
thf(fact_54_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funD
thf(fact_55_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X5: A] :
            ( ( P @ X5 )
           => ( Q @ X5 ) ) ) ) )).

% Collect_mono_iff
thf(fact_56_contra__subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ~ ( member @ A @ C2 @ B2 )
       => ~ ( member @ A @ C2 @ A3 ) ) ) )).

% contra_subsetD
thf(fact_57_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y2: ( set @ A ),Z2: ( set @ A )] : ( Y2 = Z2 ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ) )).

% set_eq_subset
thf(fact_58_subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% subset_trans
thf(fact_59_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_60_subset__refl,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) )).

% subset_refl
thf(fact_61_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% rev_subsetD
thf(fact_62_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [T: A] :
            ( ( member @ A @ T @ A5 )
           => ( member @ A @ T @ B5 ) ) ) ) )).

% subset_iff
thf(fact_63_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
       => ( member @ A @ X @ B2 ) ) ) )).

% set_rev_mp
thf(fact_64_equalityD2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( A3 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A3 ) ) )).

% equalityD2
thf(fact_65_equalityD1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( A3 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B2 ) ) )).

% equalityD1
thf(fact_66_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A5 )
           => ( member @ A @ X5 @ B5 ) ) ) ) )).

% subset_eq
thf(fact_67_equalityE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( A3 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A3 ) ) ) )).

% equalityE
thf(fact_68_subsetCE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetCE
thf(fact_69_subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetD
thf(fact_70_in__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B2 ) ) ) )).

% in_mono
thf(fact_71_set__mp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B2 ) ) ) )).

% set_mp
thf(fact_72_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) )
       => ( ! [Z1: A,Z22: ( coinductive_llist @ A ),Xa: A] :
              ( ( member @ A @ Xa @ ( coinductive_lset @ A @ Z22 ) )
             => ( ( P @ Xa @ Z22 )
               => ( P @ Xa @ ( coinductive_LCons @ A @ Z1 @ Z22 ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_73_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z22: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z22 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z22 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_74_reachable__viap__reachable__via__eq,axiom,(
    ! [Node: $tType] :
      ( ( koenig1757754772e_viap @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),Ns2: ( set @ Node ),N5: Node,X5: Node] :
            ( member @ Node @ X5 @ ( koenig317145564le_via @ Node @ Graph2 @ Ns2 @ N5 ) ) ) ) )).

% reachable_viap_reachable_via_eq
thf(fact_75_lset__lmember,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
      = ( coinductive_lmember @ A @ X @ Xs3 ) ) )).

% lset_lmember
thf(fact_76_lsorted__LCons,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Xs3: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ Xs3 ) )
          = ( ( coindu63249387sorted @ A @ Xs3 )
            & ! [X5: A] :
                ( ( member @ A @ X5 @ ( coinductive_lset @ A @ Xs3 ) )
               => ( ord_less_eq @ A @ X @ X5 ) ) ) ) ) )).

% lsorted_LCons
thf(fact_77_lmember__code_I2_J,axiom,(
    ! [A: $tType,X: A,Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( X = Y )
        | ( coinductive_lmember @ A @ X @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_78_lfp_Oleq__antisym,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) )).

% lfp.leq_antisym
thf(fact_79_gfp_Oleq__antisym,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( X = Y ) ) ) ) )).

% gfp.leq_antisym
thf(fact_80_lfp_Oleq__trans,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) )).

% lfp.leq_trans
thf(fact_81_gfp_Oleq__trans,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z @ Y )
           => ( ord_less_eq @ A @ Z @ X ) ) ) ) )).

% gfp.leq_trans
thf(fact_82_lfp_Oleq__refl,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% lfp.leq_refl
thf(fact_83_lsorted__LCons__LCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs3: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs3 ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y @ Xs3 ) ) ) ) ) )).

% lsorted_LCons_LCons
thf(fact_84_LCons__LCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs3: ( coinductive_llist @ A )] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y @ Xs3 ) )
           => ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs3 ) ) ) ) ) ) )).

% LCons_LCons
thf(fact_85_reachable__viap_Ocases,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node,A2: Node] :
      ( ( koenig1757754772e_viap @ Node @ Graph @ Ns @ N2 @ A2 )
     => ~ ( ! [Xs2: ( coinductive_llist @ Node )] :
              ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ N2 @ Xs2 ) )
             => ( ( member @ Node @ A2 @ ( coinductive_lset @ Node @ Xs2 ) )
               => ~ ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns ) ) ) ) ) )).

% reachable_viap.cases
thf(fact_86_reachable__viap_Osimps,axiom,(
    ! [Node: $tType] :
      ( ( koenig1757754772e_viap @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),Ns2: ( set @ Node ),N5: Node,A6: Node] :
          ? [Xs4: ( coinductive_llist @ Node ),N3: Node] :
            ( ( A6 = N3 )
            & ( koenig2031690877pathsp @ Node @ Graph2 @ ( coinductive_LCons @ Node @ N5 @ Xs4 ) )
            & ( member @ Node @ N3 @ ( coinductive_lset @ Node @ Xs4 ) )
            & ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs4 ) @ Ns2 ) ) ) ) )).

% reachable_viap.simps
thf(fact_87_reachable__viap_Ointros,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),N2: Node,Xs3: ( coinductive_llist @ Node ),N4: Node,Ns: ( set @ Node )] :
      ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ N2 @ Xs3 ) )
     => ( ( member @ Node @ N4 @ ( coinductive_lset @ Node @ Xs3 ) )
       => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs3 ) @ Ns )
         => ( koenig1757754772e_viap @ Node @ Graph @ Ns @ N2 @ N4 ) ) ) ) )).

% reachable_viap.intros
thf(fact_88_reachable__viap_Oinducts,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node,X: Node,P: ( Node > $o )] :
      ( ( koenig1757754772e_viap @ Node @ Graph @ Ns @ N2 @ X )
     => ( ! [Xs2: ( coinductive_llist @ Node ),N: Node] :
            ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ N2 @ Xs2 ) )
           => ( ( member @ Node @ N @ ( coinductive_lset @ Node @ Xs2 ) )
             => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs2 ) @ Ns )
               => ( P @ N ) ) ) )
       => ( P @ X ) ) ) )).

% reachable_viap.inducts
thf(fact_89_lsorted_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ A2 )
         => ( ( A2
             != ( coinductive_LNil @ A ) )
           => ( ! [X2: A] :
                  ( A2
                 != ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) )
             => ~ ( ! [X2: A,Y4: A,Xs2: ( coinductive_llist @ A )] :
                      ( ( A2
                        = ( coinductive_LCons @ A @ X2 @ ( coinductive_LCons @ A @ Y4 @ Xs2 ) ) )
                     => ( ( ord_less_eq @ A @ X2 @ Y4 )
                       => ~ ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y4 @ Xs2 ) ) ) ) ) ) ) ) ) )).

% lsorted.cases
thf(fact_90_lsorted_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( coindu63249387sorted @ A )
        = ( ^ [A6: ( coinductive_llist @ A )] :
              ( ( A6
                = ( coinductive_LNil @ A ) )
              | ? [X5: A] :
                  ( A6
                  = ( coinductive_LCons @ A @ X5 @ ( coinductive_LNil @ A ) ) )
              | ? [X5: A,Y3: A,Xs4: ( coinductive_llist @ A )] :
                  ( ( A6
                    = ( coinductive_LCons @ A @ X5 @ ( coinductive_LCons @ A @ Y3 @ Xs4 ) ) )
                  & ( ord_less_eq @ A @ X5 @ Y3 )
                  & ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y3 @ Xs4 ) ) ) ) ) ) ) )).

% lsorted.simps
thf(fact_91_lsorted__code_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( coindu63249387sorted @ A @ ( coinductive_LNil @ A ) ) ) )).

% lsorted_code(1)
thf(fact_92_lsorted__code_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) ) )).

% lsorted_code(2)
thf(fact_93_pathsp_Ocases,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),A2: ( coinductive_llist @ Node )] :
      ( ( koenig2031690877pathsp @ Node @ Graph @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ Node ) )
       => ( ! [X2: Node] :
              ( A2
             != ( coinductive_LCons @ Node @ X2 @ ( coinductive_LNil @ Node ) ) )
         => ~ ( ! [X2: Node,Y4: Node,Xs2: ( coinductive_llist @ Node )] :
                  ( ( A2
                    = ( coinductive_LCons @ Node @ X2 @ ( coinductive_LCons @ Node @ Y4 @ Xs2 ) ) )
                 => ( ( Graph @ X2 @ Y4 )
                   => ~ ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ Y4 @ Xs2 ) ) ) ) ) ) ) ) )).

% pathsp.cases
thf(fact_94_pathsp_Osimps,axiom,(
    ! [Node: $tType] :
      ( ( koenig2031690877pathsp @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),A6: ( coinductive_llist @ Node )] :
            ( ( A6
              = ( coinductive_LNil @ Node ) )
            | ? [X5: Node] :
                ( A6
                = ( coinductive_LCons @ Node @ X5 @ ( coinductive_LNil @ Node ) ) )
            | ? [X5: Node,Y3: Node,Xs4: ( coinductive_llist @ Node )] :
                ( ( A6
                  = ( coinductive_LCons @ Node @ X5 @ ( coinductive_LCons @ Node @ Y3 @ Xs4 ) ) )
                & ( Graph2 @ X5 @ Y3 )
                & ( koenig2031690877pathsp @ Node @ Graph2 @ ( coinductive_LCons @ Node @ Y3 @ Xs4 ) ) ) ) ) ) )).

% pathsp.simps
thf(fact_95_pathsp_OSingle,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node] :
      ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ X @ ( coinductive_LNil @ Node ) ) ) )).

% pathsp.Single
thf(fact_96_pathsp_Ocoinduct,axiom,(
    ! [Node: $tType,X6: ( ( coinductive_llist @ Node ) > $o ),X: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( X6 @ X )
     => ( ! [X2: ( coinductive_llist @ Node )] :
            ( ( X6 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ Node ) )
              | ? [Xa2: Node] :
                  ( X2
                  = ( coinductive_LCons @ Node @ Xa2 @ ( coinductive_LNil @ Node ) ) )
              | ? [Xa2: Node,Y5: Node,Xs5: ( coinductive_llist @ Node )] :
                  ( ( X2
                    = ( coinductive_LCons @ Node @ Xa2 @ ( coinductive_LCons @ Node @ Y5 @ Xs5 ) ) )
                  & ( Graph @ Xa2 @ Y5 )
                  & ( ( X6 @ ( coinductive_LCons @ Node @ Y5 @ Xs5 ) )
                    | ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ Y5 @ Xs5 ) ) ) ) ) )
       => ( koenig2031690877pathsp @ Node @ Graph @ X ) ) ) )).

% pathsp.coinduct
thf(fact_97_pathsp_OEmpty,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o )] :
      ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LNil @ Node ) ) )).

% pathsp.Empty
thf(fact_98_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( Xs3
       != ( coinductive_LNil @ A ) )
      = ( ? [X5: A,Xs6: ( coinductive_llist @ A )] :
            ( Xs3
            = ( coinductive_LCons @ A @ X5 @ Xs6 ) ) ) ) )).

% neq_LNil_conv
thf(fact_99_llist_Oexhaust,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( Y
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_100_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_101_LNil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( coindu63249387sorted @ A @ ( coinductive_LNil @ A ) ) ) )).

% LNil
thf(fact_102_paths_OEmpty,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o )] :
      ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LNil @ Node ) @ ( koenig916195507_paths @ Node @ Graph ) ) )).

% paths.Empty
thf(fact_103_pathsp_OLCons,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node,Y: Node,Xs3: ( coinductive_llist @ Node )] :
      ( ( Graph @ X @ Y )
     => ( ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ Y @ Xs3 ) )
       => ( koenig2031690877pathsp @ Node @ Graph @ ( coinductive_LCons @ Node @ X @ ( coinductive_LCons @ Node @ Y @ Xs3 ) ) ) ) ) )).

% pathsp.LCons
thf(fact_104_lmember__code_I1_J,axiom,(
    ! [A: $tType,X: A] :
      ~ ( coinductive_lmember @ A @ X @ ( coinductive_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_105_pathsp__paths__eq,axiom,(
    ! [Node: $tType] :
      ( ( koenig2031690877pathsp @ Node )
      = ( ^ [Graph2: ( Node > Node > $o ),X5: ( coinductive_llist @ Node )] :
            ( member @ ( coinductive_llist @ Node ) @ X5 @ ( koenig916195507_paths @ Node @ Graph2 ) ) ) ) )).

% pathsp_paths_eq
thf(fact_106_Singleton,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) ) )).

% Singleton
thf(fact_107_paths_Ocoinduct,axiom,(
    ! [Node: $tType,X6: ( ( coinductive_llist @ Node ) > $o ),X: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( X6 @ X )
     => ( ! [X2: ( coinductive_llist @ Node )] :
            ( ( X6 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ Node ) )
              | ? [Xa2: Node] :
                  ( X2
                  = ( coinductive_LCons @ Node @ Xa2 @ ( coinductive_LNil @ Node ) ) )
              | ? [Xa2: Node,Y5: Node,Xs5: ( coinductive_llist @ Node )] :
                  ( ( X2
                    = ( coinductive_LCons @ Node @ Xa2 @ ( coinductive_LCons @ Node @ Y5 @ Xs5 ) ) )
                  & ( Graph @ Xa2 @ Y5 )
                  & ( ( X6 @ ( coinductive_LCons @ Node @ Y5 @ Xs5 ) )
                    | ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y5 @ Xs5 ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) ) )
       => ( member @ ( coinductive_llist @ Node ) @ X @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) )).

% paths.coinduct
thf(fact_108_paths_OSingle,axiom,(
    ! [Node: $tType,X: Node,Graph: ( Node > Node > $o )] :
      ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ X @ ( coinductive_LNil @ Node ) ) @ ( koenig916195507_paths @ Node @ Graph ) ) )).

% paths.Single
thf(fact_109_paths_Osimps,axiom,(
    ! [Node: $tType,A2: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( member @ ( coinductive_llist @ Node ) @ A2 @ ( koenig916195507_paths @ Node @ Graph ) )
      = ( ( A2
          = ( coinductive_LNil @ Node ) )
        | ? [X5: Node] :
            ( A2
            = ( coinductive_LCons @ Node @ X5 @ ( coinductive_LNil @ Node ) ) )
        | ? [X5: Node,Y3: Node,Xs4: ( coinductive_llist @ Node )] :
            ( ( A2
              = ( coinductive_LCons @ Node @ X5 @ ( coinductive_LCons @ Node @ Y3 @ Xs4 ) ) )
            & ( Graph @ X5 @ Y3 )
            & ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y3 @ Xs4 ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) ) )).

% paths.simps
thf(fact_110_paths_Ocases,axiom,(
    ! [Node: $tType,A2: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o )] :
      ( ( member @ ( coinductive_llist @ Node ) @ A2 @ ( koenig916195507_paths @ Node @ Graph ) )
     => ( ( A2
         != ( coinductive_LNil @ Node ) )
       => ( ! [X2: Node] :
              ( A2
             != ( coinductive_LCons @ Node @ X2 @ ( coinductive_LNil @ Node ) ) )
         => ~ ( ! [X2: Node,Y4: Node,Xs2: ( coinductive_llist @ Node )] :
                  ( ( A2
                    = ( coinductive_LCons @ Node @ X2 @ ( coinductive_LCons @ Node @ Y4 @ Xs2 ) ) )
                 => ( ( Graph @ X2 @ Y4 )
                   => ~ ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y4 @ Xs2 ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) ) ) ) ) )).

% paths.cases
thf(fact_111_lsorted_Ocoinduct,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X6: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A )] :
          ( ( X6 @ X )
         => ( ! [X2: ( coinductive_llist @ A )] :
                ( ( X6 @ X2 )
               => ( ( X2
                    = ( coinductive_LNil @ A ) )
                  | ? [Xa2: A] :
                      ( X2
                      = ( coinductive_LCons @ A @ Xa2 @ ( coinductive_LNil @ A ) ) )
                  | ? [Xa2: A,Y5: A,Xs5: ( coinductive_llist @ A )] :
                      ( ( X2
                        = ( coinductive_LCons @ A @ Xa2 @ ( coinductive_LCons @ A @ Y5 @ Xs5 ) ) )
                      & ( ord_less_eq @ A @ Xa2 @ Y5 )
                      & ( ( X6 @ ( coinductive_LCons @ A @ Y5 @ Xs5 ) )
                        | ( coindu63249387sorted @ A @ ( coinductive_LCons @ A @ Y5 @ Xs5 ) ) ) ) ) )
           => ( coindu63249387sorted @ A @ X ) ) ) ) )).

% lsorted.coinduct
thf(fact_112_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs3 @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( Xs3
          = ( coinductive_LNil @ A ) )
        | ? [Xs6: ( coinductive_llist @ A )] :
            ( ( Xs3
              = ( coinductive_LCons @ A @ Y @ Xs6 ) )
            & ( coindu328551480prefix @ A @ Xs6 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_113_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_114_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X: B,Xs3: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs3 ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_115_llast__singleton,axiom,(
    ! [A: $tType,X: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) )
      = X ) )).

% llast_singleton
thf(fact_116_ldistinct_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A )] :
      ( ( X6 @ X )
     => ( ! [X2: ( coinductive_llist @ A )] :
            ( ( X6 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ A ) )
              | ? [Xa2: A,Xs5: ( coinductive_llist @ A )] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ Xa2 @ Xs5 ) )
                  & ~ ( member @ A @ Xa2 @ ( coinductive_lset @ A @ Xs5 ) )
                  & ( ( X6 @ Xs5 )
                    | ( coindu351974385stinct @ A @ Xs5 ) ) ) ) )
       => ( coindu351974385stinct @ A @ X ) ) ) )).

% ldistinct.coinduct
thf(fact_117_ldistinct_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu351974385stinct @ A )
      = ( ^ [A6: ( coinductive_llist @ A )] :
            ( ( A6
              = ( coinductive_LNil @ A ) )
            | ? [X5: A,Xs4: ( coinductive_llist @ A )] :
                ( ( A6
                  = ( coinductive_LCons @ A @ X5 @ Xs4 ) )
                & ~ ( member @ A @ X5 @ ( coinductive_lset @ A @ Xs4 ) )
                & ( coindu351974385stinct @ A @ Xs4 ) ) ) ) ) )).

% ldistinct.simps
thf(fact_118_ldistinct__LNil__code,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct_LNil_code
thf(fact_119_llast__LCons2,axiom,(
    ! [A: $tType,X: A,Y: A,Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs3 ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Xs3 ) ) ) )).

% llast_LCons2
thf(fact_120_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X: B,Xs3: ( coinductive_llist @ B ),Y: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs3 ) @ ( coinductive_LCons @ B @ Y @ Ys ) )
      = ( ( X = Y )
        & ( coindu1478340336prefix @ B @ Xs3 @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_121_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_122_ldistinct__LCons,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs3 ) )
      = ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
        & ( coindu351974385stinct @ A @ Xs3 ) ) ) )).

% ldistinct_LCons
thf(fact_123_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs3: ( coinductive_llist @ A )] :
      ( ! [Xs2: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs2 )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs3 ) ) )).

% llist_less_induct
thf(fact_124_ldistinct_OLNil,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct.LNil
thf(fact_125_ldistinct_OLCons,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ( ( coindu351974385stinct @ A @ Xs3 )
       => ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs3 ) ) ) ) )).

% ldistinct.LCons
thf(fact_126_lsorted__ldistinct__lset__unique,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( coindu63249387sorted @ A @ Xs3 )
         => ( ( coindu351974385stinct @ A @ Xs3 )
           => ( ( coindu63249387sorted @ A @ Ys )
             => ( ( coindu351974385stinct @ A @ Ys )
               => ( ( ( coinductive_lset @ A @ Xs3 )
                    = ( coinductive_lset @ A @ Ys ) )
                 => ( Xs3 = Ys ) ) ) ) ) ) ) )).

% lsorted_ldistinct_lset_unique
thf(fact_127_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs3 @ ( coinductive_LNil @ A ) )
      = ( Xs3
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_128_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs3 ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_129_ldistinct_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
               => ( ~ ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs2 ) )
                 => ~ ( coindu351974385stinct @ A @ Xs2 ) ) ) ) ) ) )).

% ldistinct.cases
thf(fact_130_llimit__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs3: ( coinductive_llist @ A )] :
      ( ( P @ ( coinductive_LNil @ A ) )
     => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lfinite @ A @ Xs2 )
           => ( ( P @ Xs2 )
             => ( P @ ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) )
       => ( ( ! [Ys2: ( coinductive_llist @ A )] :
                ( ( coindu1478340336prefix @ A @ Ys2 @ Xs3 )
               => ( P @ Ys2 ) )
           => ( P @ Xs3 ) )
         => ( P @ Xs3 ) ) ) ) )).

% llimit_induct
thf(fact_131_gen__lset__code_I1_J,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( coinductive_gen_lset @ A @ A3 @ ( coinductive_LNil @ A ) )
      = A3 ) )).

% gen_lset_code(1)
thf(fact_132_llist_Ocorec__code,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( coindu1259883913_llist @ C @ A )
      = ( ^ [P2: ( C > $o ),G21: ( C > A ),Q22: ( C > $o ),G221: ( C > ( coinductive_llist @ A ) ),G222: ( C > C ),A6: C] :
            ( if @ ( coinductive_llist @ A ) @ ( P2 @ A6 ) @ ( coinductive_LNil @ A ) @ ( coinductive_LCons @ A @ ( G21 @ A6 ) @ ( if @ ( coinductive_llist @ A ) @ ( Q22 @ A6 ) @ ( G221 @ A6 ) @ ( coindu1259883913_llist @ C @ A @ P2 @ G21 @ Q22 @ G221 @ G222 @ ( G222 @ A6 ) ) ) ) ) ) ) )).

% llist.corec_code
thf(fact_133_unfold__llist_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu1441602521_llist @ A @ B )
      = ( ^ [P2: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A6: A] :
            ( if @ ( coinductive_llist @ B ) @ ( P2 @ A6 ) @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ ( G21 @ A6 ) @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ ( G22 @ A6 ) ) ) ) ) ) )).

% unfold_llist.code
thf(fact_134_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X: B,Xs3: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X @ Xs3 ) )
      = ( coinductive_lfinite @ B @ Xs3 ) ) )).

% lfinite_code(2)
thf(fact_135_lfinite__LCons,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs3 ) )
      = ( coinductive_lfinite @ A @ Xs3 ) ) )).

% lfinite_LCons
thf(fact_136_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_137_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B3: B,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B3 )
        = ( coinductive_LCons @ A @ X @ Xs3 ) )
      = ( ~ ( IS_LNIL @ B3 )
        & ( X
          = ( LHD @ B3 ) )
        & ( Xs3
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B3 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_138_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs3 ) ) ) )).

% lfinite_LConsI
thf(fact_139_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_140_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs3 @ Ys )
     => ( coinductive_lfinite @ A @ Xs3 ) ) )).

% lstrict_prefix_lfinite1
thf(fact_141_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G212: ( A > B ),G223: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 )
        = ( coinductive_LCons @ B @ ( G212 @ A2 ) @ ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ ( G223 @ A2 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_142_unfold__llist_Octr_I1_J,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > $o ),A2: A,G212: ( A > B ),G223: ( A > A )] :
      ( ( P3 @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P3 @ G212 @ G223 @ A2 )
        = ( coinductive_LNil @ B ) ) ) )).

% unfold_llist.ctr(1)
thf(fact_143_llist_Ocorec_I2_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),A2: C,G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 )
        = ( coinductive_LCons @ A @ ( G212 @ A2 ) @ ( if @ ( coinductive_llist @ A ) @ ( Q222 @ A2 ) @ ( G2212 @ A2 ) @ ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ ( G2222 @ A2 ) ) ) ) ) ) )).

% llist.corec(2)
thf(fact_144_llist_Ocorec_I1_J,axiom,(
    ! [C: $tType,A: $tType,P3: ( C > $o ),A2: C,G212: ( C > A ),Q222: ( C > $o ),G2212: ( C > ( coinductive_llist @ A ) ),G2222: ( C > C )] :
      ( ( P3 @ A2 )
     => ( ( coindu1259883913_llist @ C @ A @ P3 @ G212 @ Q222 @ G2212 @ G2222 @ A2 )
        = ( coinductive_LNil @ A ) ) ) )).

% llist.corec(1)
thf(fact_145_lfinite_Oinducts,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),X2: A] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) )
         => ( P @ X ) ) ) ) )).

% lfinite.inducts
thf(fact_146_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A6: ( coinductive_llist @ A )] :
            ( ( A6
              = ( coinductive_LNil @ A ) )
            | ? [Xs4: ( coinductive_llist @ A ),X5: A] :
                ( ( A6
                  = ( coinductive_LCons @ A @ X5 @ Xs4 ) )
                & ( coinductive_lfinite @ A @ Xs4 ) ) ) ) ) )).

% lfinite.simps
thf(fact_147_lfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X2: A] :
                    ( A2
                    = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
               => ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% lfinite.cases
thf(fact_148_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LCons @ A @ Y @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_149_split__llist,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ? [Ys3: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
          ( ( Xs3
            = ( coinductive_lappend @ A @ Ys3 @ ( coinductive_LCons @ A @ X @ Zs ) ) )
          & ( coinductive_lfinite @ A @ Ys3 ) ) ) )).

% split_llist
thf(fact_150_split__llist__first,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
     => ? [Ys3: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
          ( ( Xs3
            = ( coinductive_lappend @ A @ Ys3 @ ( coinductive_LCons @ A @ X @ Zs ) ) )
          & ( coinductive_lfinite @ A @ Ys3 )
          & ~ ( member @ A @ X @ ( coinductive_lset @ A @ Ys3 ) ) ) ) )).

% split_llist_first
thf(fact_151_lfinite__rev__induct,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_lappend @ A @ Xs2 @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) ) ) ) )
         => ( P @ Xs3 ) ) ) ) )).

% lfinite_rev_induct
thf(fact_152_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa3: A,X: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa3 @ X ) @ Ys )
      = ( coinductive_LCons @ A @ Xa3 @ ( coinductive_lappend @ A @ X @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_153_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_154_lappend__LNil2,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LNil @ A ) )
      = Xs3 ) )).

% lappend_LNil2
thf(fact_155_lfinite__lappend,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs3 )
        & ( coinductive_lfinite @ A @ Ys ) ) ) )).

% lfinite_lappend
thf(fact_156_lappend__inf,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs3 )
     => ( ( coinductive_lappend @ A @ Xs3 @ Ys )
        = Xs3 ) ) )).

% lappend_inf
thf(fact_157_lappend__assoc,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) @ Zs2 )
      = ( coinductive_lappend @ A @ Xs3 @ ( coinductive_lappend @ A @ Ys @ Zs2 ) ) ) )).

% lappend_assoc
thf(fact_158_paths__lappendD1,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Graph: ( A > A > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Xs3 @ Ys ) @ ( koenig916195507_paths @ A @ Graph ) )
     => ( member @ ( coinductive_llist @ A ) @ Xs3 @ ( koenig916195507_paths @ A @ Graph ) ) ) )).

% paths_lappendD1
thf(fact_159_lappend__LNil__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lappend_LNil_LNil
thf(fact_160_LNil__eq__lappend__iff,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ Xs3 @ Ys ) )
      = ( ( Xs3
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_eq_lappend_iff
thf(fact_161_lappend__eq__LNil__iff,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ Xs3 @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs3
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_eq_LNil_iff
thf(fact_162_lset__lappend1,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ Xs3 ) @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) ) ) )).

% lset_lappend1
thf(fact_163_lappend__snocL1__conv__LCons2,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LCons @ A @ Y @ ( coinductive_LNil @ A ) ) ) @ Ys )
      = ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) )).

% lappend_snocL1_conv_LCons2
thf(fact_164_in__lset__lappend__iff,axiom,(
    ! [A: $tType,X: A,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) ) )
      = ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
        | ( ( coinductive_lfinite @ A @ Xs3 )
          & ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) ) ) ) ) )).

% in_lset_lappend_iff
thf(fact_165_paths__lappendD2,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Graph: ( A > A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Xs3 @ Ys ) @ ( koenig916195507_paths @ A @ Graph ) )
       => ( member @ ( coinductive_llist @ A ) @ Ys @ ( koenig916195507_paths @ A @ Graph ) ) ) ) )).

% paths_lappendD2
thf(fact_166_lfilter__eq__LConsD,axiom,(
    ! [A: $tType,P: ( A > $o ),Ys: ( coinductive_llist @ A ),X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Ys )
        = ( coinductive_LCons @ A @ X @ Xs3 ) )
     => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
          ( ( Ys
            = ( coinductive_lappend @ A @ Us @ ( coinductive_LCons @ A @ X @ Vs ) ) )
          & ( coinductive_lfinite @ A @ Us )
          & ! [X7: A] :
              ( ( member @ A @ X7 @ ( coinductive_lset @ A @ Us ) )
             => ~ ( P @ X7 ) )
          & ( P @ X )
          & ( Xs3
            = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) )).

% lfilter_eq_LConsD
thf(fact_167_lset__lappend__lfinite,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) )
        = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs3 ) @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% lset_lappend_lfinite
thf(fact_168_llexord__lappend__leftD,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_lappend @ A @ Xs3 @ Ys ) @ ( coinductive_lappend @ A @ Xs3 @ Zs2 ) )
     => ( ( coinductive_lfinite @ A @ Xs3 )
       => ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs3 ) )
             => ~ ( R @ X2 @ X2 ) )
         => ( coinductive_llexord @ A @ R @ Ys @ Zs2 ) ) ) ) )).

% llexord_lappend_leftD
thf(fact_169_UnCI,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ A3 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnCI
thf(fact_170_Un__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( member @ A @ C2 @ A3 )
        | ( member @ A @ C2 @ B2 ) ) ) )).

% Un_iff
thf(fact_171_lfilter__idem,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ P @ Xs3 ) )
      = ( coinductive_lfilter @ A @ P @ Xs3 ) ) )).

% lfilter_idem
thf(fact_172_llexord__refl,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ Xs3 @ Xs3 ) )).

% llexord_refl
thf(fact_173_Un__subset__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ C3 )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ C3 )
        & ( ord_less_eq @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_subset_iff
thf(fact_174_lfilter__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
          = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs3 ) ) ) )
      & ( ~ ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
          = ( coinductive_lfilter @ A @ P @ Xs3 ) ) ) ) )).

% lfilter_LCons
thf(fact_175_lfilter__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lfilter_LNil
thf(fact_176_llexord__LCons__LCons,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,Xs3: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs3 ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( ( X = Y )
          & ( coinductive_llexord @ A @ R @ Xs3 @ Ys ) )
        | ( R @ X @ Y ) ) ) )).

% llexord_LCons_LCons
thf(fact_177_llexord__code_I1_J,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ ( coinductive_LNil @ A ) @ Ys ) )).

% llexord_code(1)
thf(fact_178_diverge__lfilter__LNil,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs3 ) )
         => ~ ( P @ X2 ) )
     => ( ( coinductive_lfilter @ A @ P @ Xs3 )
        = ( coinductive_LNil @ A ) ) ) )).

% diverge_lfilter_LNil
thf(fact_179_lfilter__lappend__lfinite,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_lappend @ A @ Xs3 @ Ys ) )
        = ( coinductive_lappend @ A @ ( coinductive_lfilter @ A @ P @ Xs3 ) @ ( coinductive_lfilter @ A @ P @ Ys ) ) ) ) )).

% lfilter_lappend_lfinite
thf(fact_180_llexord__lappend__leftI,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Ys: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A ),Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ Ys @ Zs2 )
     => ( coinductive_llexord @ A @ R @ ( coinductive_lappend @ A @ Xs3 @ Ys ) @ ( coinductive_lappend @ A @ Xs3 @ Zs2 ) ) ) )).

% llexord_lappend_leftI
thf(fact_181_llexord__append__right,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ Xs3 @ ( coinductive_lappend @ A @ Xs3 @ Ys ) ) )).

% llexord_append_right
thf(fact_182_ldistinct__lfilterI,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coindu351974385stinct @ A @ Xs3 )
     => ( coindu351974385stinct @ A @ ( coinductive_lfilter @ A @ P @ Xs3 ) ) ) )).

% ldistinct_lfilterI
thf(fact_183_lfilter__LCons__seek,axiom,(
    ! [A: $tType,P3: ( A > $o ),X: A,L: ( coinductive_llist @ A )] :
      ( ~ ( P3 @ X )
     => ( ( coinductive_lfilter @ A @ P3 @ ( coinductive_LCons @ A @ X @ L ) )
        = ( coinductive_lfilter @ A @ P3 @ L ) ) ) )).

% lfilter_LCons_seek
thf(fact_184_lfilter__LCons__found,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs3: ( coinductive_llist @ A )] :
      ( ( P @ X )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
        = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs3 ) ) ) ) )).

% lfilter_LCons_found
thf(fact_185_lfilter__cong,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs3 = Ys )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( coinductive_lfilter @ A @ P @ Xs3 )
          = ( coinductive_lfilter @ A @ Q @ Ys ) ) ) ) )).

% lfilter_cong
thf(fact_186_lfilter__id__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs3 )
        = Xs3 )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( coinductive_lset @ A @ Xs3 ) )
           => ( P @ X5 ) ) ) ) )).

% lfilter_id_conv
thf(fact_187_Un__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),C3: ( set @ A ),B2: ( set @ A ),D: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ D )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ ( sup_sup @ ( set @ A ) @ C3 @ D ) ) ) ) )).

% Un_mono
thf(fact_188_Un__least,axiom,(
    ! [A: $tType,A3: ( set @ A ),C3: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ C3 ) ) ) )).

% Un_least
thf(fact_189_Un__upper1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) )).

% Un_upper1
thf(fact_190_Un__upper2,axiom,(
    ! [A: $tType,B2: ( set @ A ),A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ B2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) )).

% Un_upper2
thf(fact_191_Un__absorb1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B2 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B2 )
        = B2 ) ) )).

% Un_absorb1
thf(fact_192_Un__absorb2,axiom,(
    ! [A: $tType,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ A3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B2 )
        = A3 ) ) )).

% Un_absorb2
thf(fact_193_subset__Un__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( sup_sup @ ( set @ A ) @ A5 @ B5 )
            = B5 ) ) ) )).

% subset_Un_eq
thf(fact_194_lsorted__lfilterI,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [Xs3: ( coinductive_llist @ A ),P: ( A > $o )] :
          ( ( coindu63249387sorted @ A @ Xs3 )
         => ( coindu63249387sorted @ A @ ( coinductive_lfilter @ A @ P @ Xs3 ) ) ) ) )).

% lsorted_lfilterI
thf(fact_195_llexord__code_I3_J,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,Xs3: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs3 ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( R @ X @ Y )
        | ( ( X = Y )
          & ( coinductive_llexord @ A @ R @ Xs3 @ Ys ) ) ) ) )).

% llexord_code(3)
thf(fact_196_llexord__LCons__left,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs3 ) @ Ys )
      = ( ? [Y3: A,Ys4: ( coinductive_llist @ A )] :
            ( ( Ys
              = ( coinductive_LCons @ A @ Y3 @ Ys4 ) )
            & ( ( ( X = Y3 )
                & ( coinductive_llexord @ A @ R @ Xs3 @ Ys4 ) )
              | ( R @ X @ Y3 ) ) ) ) ) )).

% llexord_LCons_left
thf(fact_197_llexord__LCons__eq,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_llexord @ A @ R @ Xs3 @ Ys )
     => ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs3 ) @ ( coinductive_LCons @ A @ X @ Ys ) ) ) )).

% llexord_LCons_eq
thf(fact_198_llexord__LCons__less,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,Y: A,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( R @ X @ Y )
     => ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs3 ) @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) )).

% llexord_LCons_less
thf(fact_199_llexord__LNil,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ ( coinductive_LNil @ A ) @ Ys ) )).

% llexord_LNil
thf(fact_200_UnE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
     => ( ~ ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% UnE
thf(fact_201_UnI1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnI1
thf(fact_202_UnI2,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ C2 @ B2 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnI2
thf(fact_203_bex__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
            & ( P @ X5 ) ) )
      = ( ? [X5: A] :
            ( ( member @ A @ X5 @ A3 )
            & ( P @ X5 ) )
        | ? [X5: A] :
            ( ( member @ A @ X5 @ B2 )
            & ( P @ X5 ) ) ) ) )).

% bex_Un
thf(fact_204_ball__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
           => ( P @ X5 ) ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( P @ X5 ) )
        & ! [X5: A] :
            ( ( member @ A @ X5 @ B2 )
           => ( P @ X5 ) ) ) ) )).

% ball_Un
thf(fact_205_Un__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_assoc
thf(fact_206_Un__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Un_absorb
thf(fact_207_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Un_commute
thf(fact_208_Un__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) )).

% Un_left_absorb
thf(fact_209_Un__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B2 @ ( sup_sup @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_210_llexord__trans,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ Xs3 @ Ys )
     => ( ( coinductive_llexord @ A @ R @ Ys @ Zs2 )
       => ( ! [A4: A,B4: A,C4: A] :
              ( ( R @ A4 @ B4 )
             => ( ( R @ B4 @ C4 )
               => ( R @ A4 @ C4 ) ) )
         => ( coinductive_llexord @ A @ R @ Xs3 @ Zs2 ) ) ) ) )).

% llexord_trans
thf(fact_211_llexord__linear,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ! [X2: A,Y4: A] :
          ( ( R @ X2 @ Y4 )
          | ( X2 = Y4 )
          | ( R @ Y4 @ X2 ) )
     => ( ( coinductive_llexord @ A @ R @ Xs3 @ Ys )
        | ( coinductive_llexord @ A @ R @ Ys @ Xs3 ) ) ) )).

% llexord_linear
thf(fact_212_llexord__antisym,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ Xs3 @ Ys )
     => ( ( coinductive_llexord @ A @ R @ Ys @ Xs3 )
       => ( ! [A4: A,B4: A] :
              ( ( R @ A4 @ B4 )
             => ~ ( R @ B4 @ A4 ) )
         => ( Xs3 = Ys ) ) ) ) )).

% llexord_antisym
thf(fact_213_lfinite__lfilterI,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( coinductive_lfinite @ A @ ( coinductive_lfilter @ A @ P @ Xs3 ) ) ) )).

% lfinite_lfilterI
thf(fact_214_lfilter__empty__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs3 )
        = ( coinductive_LNil @ A ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( coinductive_lset @ A @ Xs3 ) )
           => ~ ( P @ X5 ) ) ) ) )).

% lfilter_empty_conv
thf(fact_215_lfilter__eq__lappend__lfiniteD,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs3 )
        = ( coinductive_lappend @ A @ Ys @ Zs2 ) )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
            ( ( Xs3
              = ( coinductive_lappend @ A @ Us @ Vs ) )
            & ( coinductive_lfinite @ A @ Us )
            & ( Ys
              = ( coinductive_lfilter @ A @ P @ Us ) )
            & ( Zs2
              = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) ) )).

% lfilter_eq_lappend_lfiniteD
thf(fact_216_llexord_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A ),Xa3: ( coinductive_llist @ A ),R: ( A > A > $o )] :
      ( ( X6 @ X @ Xa3 )
     => ( ! [X2: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A )] :
            ( ( X6 @ X2 @ Xa )
           => ( ? [Xs5: ( coinductive_llist @ A ),Ys2: ( coinductive_llist @ A ),Xb: A] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ Xb @ Xs5 ) )
                  & ( Xa
                    = ( coinductive_LCons @ A @ Xb @ Ys2 ) )
                  & ( ( X6 @ Xs5 @ Ys2 )
                    | ( coinductive_llexord @ A @ R @ Xs5 @ Ys2 ) ) )
              | ? [Xb: A,Y5: A,Xs5: ( coinductive_llist @ A ),Ys2: ( coinductive_llist @ A )] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ Xb @ Xs5 ) )
                  & ( Xa
                    = ( coinductive_LCons @ A @ Y5 @ Ys2 ) )
                  & ( R @ Xb @ Y5 ) )
              | ? [Ys2: ( coinductive_llist @ A )] :
                  ( ( X2
                    = ( coinductive_LNil @ A ) )
                  & ( Xa = Ys2 ) ) ) )
       => ( coinductive_llexord @ A @ R @ X @ Xa3 ) ) ) )).

% llexord.coinduct
thf(fact_217_llexord_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llexord @ A )
      = ( ^ [R2: ( A > A > $o ),A12: ( coinductive_llist @ A ),A23: ( coinductive_llist @ A )] :
            ( ? [Xs4: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A ),X5: A] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X5 @ Xs4 ) )
                & ( A23
                  = ( coinductive_LCons @ A @ X5 @ Ys5 ) )
                & ( coinductive_llexord @ A @ R2 @ Xs4 @ Ys5 ) )
            | ? [X5: A,Y3: A,Xs4: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X5 @ Xs4 ) )
                & ( A23
                  = ( coinductive_LCons @ A @ Y3 @ Ys5 ) )
                & ( R2 @ X5 @ Y3 ) )
            | ? [Ys5: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LNil @ A ) )
                & ( A23 = Ys5 ) ) ) ) ) )).

% llexord.simps
thf(fact_218_llexord_Ocases,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A1: ( coinductive_llist @ A ),A22: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ A1 @ A22 )
     => ( ! [Xs2: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),X2: A] :
            ( ( A1
              = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
           => ( ( A22
                = ( coinductive_LCons @ A @ X2 @ Ys3 ) )
             => ~ ( coinductive_llexord @ A @ R @ Xs2 @ Ys3 ) ) )
       => ( ! [X2: A] :
              ( ? [Xs2: ( coinductive_llist @ A )] :
                  ( A1
                  = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
             => ! [Y4: A] :
                  ( ? [Ys3: ( coinductive_llist @ A )] :
                      ( A22
                      = ( coinductive_LCons @ A @ Y4 @ Ys3 ) )
                 => ~ ( R @ X2 @ Y4 ) ) )
         => ~ ( ( A1
                = ( coinductive_LNil @ A ) )
             => ! [Ys3: ( coinductive_llist @ A )] : ( A22 != Ys3 ) ) ) ) ) )).

% llexord.cases
thf(fact_219_llexord__code_I2_J,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,Xs3: ( coinductive_llist @ A )] :
      ~ ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs3 ) @ ( coinductive_LNil @ A ) ) )).

% llexord_code(2)
thf(fact_220_gen__lset__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_gen_lset @ A )
      = ( ^ [A5: ( set @ A ),Xs4: ( coinductive_llist @ A )] :
            ( sup_sup @ ( set @ A ) @ A5 @ ( coinductive_lset @ A @ Xs4 ) ) ) ) )).

% gen_lset_def
thf(fact_221_lset__lappend,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) ) @ ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs3 ) @ ( coinductive_lset @ A @ Ys ) ) ) )).

% lset_lappend
thf(fact_222_lset__lappend__conv,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfinite @ A @ Xs3 )
       => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) )
          = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs3 ) @ ( coinductive_lset @ A @ Ys ) ) ) )
      & ( ~ ( coinductive_lfinite @ A @ Xs3 )
       => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs3 @ Ys ) )
          = ( coinductive_lset @ A @ Xs3 ) ) ) ) )).

% lset_lappend_conv
thf(fact_223_llexord__lappend__left,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),R: ( A > A > $o ),Ys: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs3 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs3 ) )
           => ~ ( R @ X2 @ X2 ) )
       => ( ( coinductive_llexord @ A @ R @ ( coinductive_lappend @ A @ Xs3 @ Ys ) @ ( coinductive_lappend @ A @ Xs3 @ Zs2 ) )
          = ( coinductive_llexord @ A @ R @ Ys @ Zs2 ) ) ) ) )).

% llexord_lappend_left
thf(fact_224_le__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            & ( ord_less_eq @ A @ Y @ Z ) ) ) ) )).

% le_sup_iff
thf(fact_225_sup_Obounded__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B3 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% sup.bounded_iff
thf(fact_226_sup_OcoboundedI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,B3: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B3 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% sup.coboundedI2
thf(fact_227_inf__sup__ord_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_ord(4)
thf(fact_228_inf__sup__ord_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_ord(3)
thf(fact_229_le__supE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B3 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B3 @ X ) ) ) ) )).

% le_supE
thf(fact_230_le__supI,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,B3: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B3 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B3 ) @ X ) ) ) ) )).

% le_supI
thf(fact_231_sup__ge1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_ge1
thf(fact_232_sup__ge2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_ge2
thf(fact_233_le__supI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,A2: A,B3: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% le_supI1
thf(fact_234_le__supI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,B3: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B3 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% le_supI2
thf(fact_235_sup_Omono,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A,D2: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) ) )).

% sup.mono
thf(fact_236_sup__mono,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,B3: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B3 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B3 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) )).

% sup_mono
thf(fact_237_sup__least,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z ) @ X ) ) ) ) )).

% sup_least
thf(fact_238_le__iff__sup,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y3: A] :
              ( ( sup_sup @ A @ X5 @ Y3 )
              = Y3 ) ) ) ) )).

% le_iff_sup
thf(fact_239_sup_OorderE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% sup.orderE
thf(fact_240_sup_OorderI,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B3 ) )
         => ( ord_less_eq @ A @ B3 @ A2 ) ) ) )).

% sup.orderI
thf(fact_241_sup__unique,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [F: ( A > A > A ),X: A,Y: A] :
          ( ! [X2: A,Y4: A] :
              ( ord_less_eq @ A @ X2 @ ( F @ X2 @ Y4 ) )
         => ( ! [X2: A,Y4: A] :
                ( ord_less_eq @ A @ Y4 @ ( F @ X2 @ Y4 ) )
           => ( ! [X2: A,Y4: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y4 @ X2 )
                 => ( ( ord_less_eq @ A @ Z3 @ X2 )
                   => ( ord_less_eq @ A @ ( F @ Y4 @ Z3 ) @ X2 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F @ X @ Y ) ) ) ) ) ) )).

% sup_unique
thf(fact_242_sup_Oabsorb1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B3 )
            = A2 ) ) ) )).

% sup.absorb1
thf(fact_243_sup_Oabsorb2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( sup_sup @ A @ A2 @ B3 )
            = B3 ) ) ) )).

% sup.absorb2
thf(fact_244_sup__absorb1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) )).

% sup_absorb1
thf(fact_245_sup__absorb2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) )).

% sup_absorb2
thf(fact_246_sup_OboundedE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B3 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% sup.boundedE
thf(fact_247_sup_OboundedI,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A2 ) ) ) ) )).

% sup.boundedI
thf(fact_248_sup_Oorder__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B6: A,A6: A] :
              ( A6
              = ( sup_sup @ A @ A6 @ B6 ) ) ) ) ) )).

% sup.order_iff
thf(fact_249_sup_Ocobounded1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.cobounded1
thf(fact_250_sup_Ocobounded2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ord_less_eq @ A @ B3 @ ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.cobounded2
thf(fact_251_sup_Oabsorb__iff1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B6: A,A6: A] :
              ( ( sup_sup @ A @ A6 @ B6 )
              = A6 ) ) ) ) )).

% sup.absorb_iff1
thf(fact_252_sup_Oabsorb__iff2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A6: A,B6: A] :
              ( ( sup_sup @ A @ A6 @ B6 )
              = B6 ) ) ) ) )).

% sup.absorb_iff2
thf(fact_253_sup_OcoboundedI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B3 ) ) ) ) )).

% sup.coboundedI1
thf(fact_254_llexord__conv,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llexord @ A )
      = ( ^ [R2: ( A > A > $o ),Xs4: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A )] :
            ( ( Xs4 = Ys5 )
            | ? [Zs3: ( coinductive_llist @ A ),Xs6: ( coinductive_llist @ A ),Y3: A,Ys4: ( coinductive_llist @ A )] :
                ( ( coinductive_lfinite @ A @ Zs3 )
                & ( Xs4
                  = ( coinductive_lappend @ A @ Zs3 @ Xs6 ) )
                & ( Ys5
                  = ( coinductive_lappend @ A @ Zs3 @ ( coinductive_LCons @ A @ Y3 @ Ys4 ) ) )
                & ( ( Xs6
                    = ( coinductive_LNil @ A ) )
                  | ( R2 @ ( coinductive_lhd @ A @ Xs6 ) @ Y3 ) ) ) ) ) ) )).

% llexord_conv
thf(fact_255_lstrict__prefix__lappend__conv,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs3 @ ( coinductive_lappend @ A @ Xs3 @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs3 )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lstrict_prefix_lappend_conv

%----Type constructors (19)
thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( comple187826305attice @ A8 @ ( type2 @ A8 ) )
     => ( comple187826305attice @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( semilattice_sup @ A8 @ ( type2 @ A8 ) )
     => ( semilattice_sup @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( preorder @ A8 @ ( type2 @ A8 ) )
     => ( preorder @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( lattice @ A8 @ ( type2 @ A8 ) )
     => ( lattice @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order @ A8 @ ( type2 @ A8 ) )
     => ( order @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_1,axiom,(
    ! [A7: $tType] :
      ( comple187826305attice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_2,axiom,(
    ! [A7: $tType] :
      ( semilattice_sup @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_3,axiom,(
    ! [A7: $tType] :
      ( preorder @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_4,axiom,(
    ! [A7: $tType] :
      ( lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_5,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_6,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_7,axiom,
    ( comple187826305attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_8,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_9,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_10,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_11,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_12,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( member @ a @ n2 @ ns )).

%------------------------------------------------------------------------------
