%------------------------------------------------------------------------------
% File     : COM176^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 131
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__131.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  327 (   0 unit;  45 type;   0 defn)
%            Number of atoms       : 4229 ( 217 equality;2478 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 3825 (  93   ~;  11   |;  43   &;3299   @)
%                                         (   0 <=>; 379  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  140 ( 140   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   47 (  45   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  947 (   2 sgn; 855   !;   8   ?;  51   ^)
%                                         ( 947   :;  33  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:46:41.177
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (41)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__linorder,type,(
    dense_linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Opaths,type,(
    koenig916195507_paths: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ ( coinductive_llist @ Node ) ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__via,type,(
    koenig317145564le_via: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > ( set @ Node ) ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_graph,type,(
    graph: a > a > $o )).

thf(sy_v_n,type,(
    n: a )).

thf(sy_v_n_H____,type,(
    n2: a )).

thf(sy_v_ns,type,(
    ns: ( set @ a ) )).

thf(sy_v_x____,type,(
    x: a )).

thf(sy_v_xs_H_H____,type,(
    xs: ( coinductive_llist @ a ) )).

thf(sy_v_xs_H____,type,(
    xs2: ( coinductive_llist @ a ) )).

thf(sy_v_xs____,type,(
    xs3: ( coinductive_llist @ a ) )).

%----Relevant facts (256)
thf(fact_0__092_060open_062n_H_A_092_060notin_062_Alset_Axs_H_H_092_060close_062,axiom,(
    ~ ( member @ a @ n2 @ ( coinductive_lset @ a @ xs ) ) )).

% \<open>n' \<notin> lset xs''\<close>
thf(fact_1__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062n_H_Axs_H_O_Axs_A_061_ALCons_An_H_Axs_H_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [N: a,Xs: ( coinductive_llist @ a )] :
          ( xs3
         != ( coinductive_LCons @ a @ N @ Xs ) ) ) )).

% \<open>\<And>thesis. (\<And>n' xs'. xs = LCons n' xs' \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_2__092_060open_062x_A_092_060in_062_Alset_Axs_H_H_092_060close_062,axiom,
    ( member @ a @ x @ ( coinductive_lset @ a @ xs ) )).

% \<open>x \<in> lset xs''\<close>
thf(fact_3_xs,axiom,
    ( xs3
    = ( coinductive_LCons @ a @ n2 @ xs2 ) )).

% xs
thf(fact_4__092_060open_062lset_Axs_A_092_060subseteq_062_Ans_092_060close_062,axiom,
    ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ xs3 ) @ ns )).

% \<open>lset xs \<subseteq> ns\<close>
thf(fact_5_False,axiom,(
    x != n2 )).

% False
thf(fact_6__092_060open_062x_A_092_060in_062_Alset_Axs_092_060close_062,axiom,
    ( member @ a @ x @ ( coinductive_lset @ a @ xs3 ) )).

% \<open>x \<in> lset xs\<close>
thf(fact_7_path_H_H,axiom,
    ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n2 @ xs ) @ ( koenig916195507_paths @ a @ graph ) )).

% path''
thf(fact_8__092_060open_062n_H_A_092_060in_062_Ans_092_060close_062,axiom,
    ( member @ a @ n2 @ ns )).

% \<open>n' \<in> ns\<close>
thf(fact_9__092_060open_062x_A_092_060in_062_Alset_Axs_H_092_060close_062,axiom,
    ( member @ a @ x @ ( coinductive_lset @ a @ xs2 ) )).

% \<open>x \<in> lset xs'\<close>
thf(fact_10__092_060open_062x_A_092_060in_062_Areachable__via_Agraph_Ans_An_092_060close_062,axiom,
    ( member @ a @ x @ ( koenig317145564le_via @ a @ graph @ ns @ n ) )).

% \<open>x \<in> reachable_via graph ns n\<close>
thf(fact_11__092_060open_062graph_An_An_H_092_060close_062,axiom,
    ( graph @ n @ n2 )).

% \<open>graph n n'\<close>
thf(fact_12_path_H,axiom,
    ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n2 @ xs2 ) @ ( koenig916195507_paths @ a @ graph ) )).

% path'
thf(fact_13__092_060open_062lset_Axs_H_A_092_060subseteq_062_Ans_092_060close_062,axiom,
    ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ xs2 ) @ ns )).

% \<open>lset xs' \<subseteq> ns\<close>
thf(fact_14_path,axiom,
    ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n @ xs3 ) @ ( koenig916195507_paths @ a @ graph ) )).

% path
thf(fact_15_insert__Diff__single,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A3 ) ) )).

% insert_Diff_single
thf(fact_16_Diff__insert0,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B ) )
        = ( minus_minus @ ( set @ A ) @ A3 @ B ) ) ) )).

% Diff_insert0
thf(fact_17_insert__Diff1,axiom,(
    ! [A: $tType,X: A,B: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ X @ B )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B )
        = ( minus_minus @ ( set @ A ) @ A3 @ B ) ) ) )).

% insert_Diff1
thf(fact_18_Diff__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) )).

% Diff_empty
thf(fact_19_empty__Diff,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_20_Diff__cancel,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_21_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_22__092_060open_062n_H_A_092_060noteq_062_Ax_A_092_060Longrightarrow_062_A_092_060exists_062xs_Ha_O_ALCons_An_H_Axs_Ha_A_092_060in_062_Apaths_Agraph_A_092_060and_062_Alset_Axs_Ha_A_092_060subseteq_062_Alset_Axs_H_A_092_060and_062_Ax_A_092_060in_062_Alset_Axs_Ha_A_092_060and_062_An_H_A_092_060notin_062_Alset_Axs_Ha_092_060close_062,axiom,
    ( ( n2 != x )
   => ? [Xs: ( coinductive_llist @ a )] :
        ( ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n2 @ Xs ) @ ( koenig916195507_paths @ a @ graph ) )
        & ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ Xs ) @ ( coinductive_lset @ a @ xs2 ) )
        & ( member @ a @ x @ ( coinductive_lset @ a @ Xs ) )
        & ~ ( member @ a @ n2 @ ( coinductive_lset @ a @ Xs ) ) ) )).

% \<open>n' \<noteq> x \<Longrightarrow> \<exists>xs'a. LCons n' xs'a \<in> paths graph \<and> lset xs'a \<subseteq> lset xs' \<and> x \<in> lset xs'a \<and> n' \<notin> lset xs'a\<close>
thf(fact_23__092_060open_062lset_Axs_H_H_A_092_060subseteq_062_Alset_Axs_H_092_060close_062,axiom,
    ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ xs ) @ ( coinductive_lset @ a @ xs2 ) )).

% \<open>lset xs'' \<subseteq> lset xs'\<close>
thf(fact_24_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) )).

% empty_Collect_eq
thf(fact_25_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) )).

% Collect_empty_eq
thf(fact_26_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X2: A] :
            ~ ( member @ A @ X2 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_27_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_28_subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( member @ A @ X3 @ B ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) )).

% subsetI
thf(fact_29_subset__antisym,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( ord_less_eq @ ( set @ A ) @ B @ A3 )
       => ( A3 = B ) ) ) )).

% subset_antisym
thf(fact_30_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A3 ) )
      = ( insert @ A @ X @ A3 ) ) )).

% insert_absorb2
thf(fact_31_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A3 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_32_insertCI,axiom,(
    ! [A: $tType,A2: A,B: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B ) ) ) )).

% insertCI
thf(fact_33_Diff__idemp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B ) @ B )
      = ( minus_minus @ ( set @ A ) @ A3 @ B ) ) )).

% Diff_idemp
thf(fact_34_Diff__iff,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B ) )
      = ( ( member @ A @ C @ A3 )
        & ~ ( member @ A @ C @ B ) ) ) )).

% Diff_iff
thf(fact_35_DiffI,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ C @ A3 )
     => ( ~ ( member @ A @ C @ B )
       => ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B ) ) ) ) )).

% DiffI
thf(fact_36_empty__subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) )).

% empty_subsetI
thf(fact_37_subset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_38_insert__subset,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B )
      = ( ( member @ A @ X @ B )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) ) )).

% insert_subset
thf(fact_39_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A2 @ A3 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_40_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A2: A,A3: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A3 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_41_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) )).

% Diff_eq_empty_iff
thf(fact_42__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062xs_H_H_O_A_092_060lbrakk_062LCons_An_H_Axs_H_H_A_092_060in_062_Apaths_Agraph_059_Alset_Axs_H_H_A_092_060subseteq_062_Alset_Axs_H_059_Ax_A_092_060in_062_Alset_Axs_H_H_059_An_H_A_092_060notin_062_Alset_Axs_H_H_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [Xs2: ( coinductive_llist @ a )] :
          ( ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n2 @ Xs2 ) @ ( koenig916195507_paths @ a @ graph ) )
         => ( ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ Xs2 ) @ ( coinductive_lset @ a @ xs2 ) )
           => ( ( member @ a @ x @ ( coinductive_lset @ a @ Xs2 ) )
             => ( member @ a @ n2 @ ( coinductive_lset @ a @ Xs2 ) ) ) ) ) ) )).

% \<open>\<And>thesis. (\<And>xs''. \<lbrakk>LCons n' xs'' \<in> paths graph; lset xs'' \<subseteq> lset xs'; x \<in> lset xs''; n' \<notin> lset xs''\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_43__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062xs_O_A_092_060lbrakk_062LCons_An_Axs_A_092_060in_062_Apaths_Agraph_059_Ax_A_092_060in_062_Alset_Axs_059_Alset_Axs_A_092_060subseteq_062_Ans_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [Xs3: ( coinductive_llist @ a )] :
          ( ( member @ ( coinductive_llist @ a ) @ ( coinductive_LCons @ a @ n @ Xs3 ) @ ( koenig916195507_paths @ a @ graph ) )
         => ( ( member @ a @ x @ ( coinductive_lset @ a @ Xs3 ) )
           => ~ ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ Xs3 ) @ ns ) ) ) ) )).

% \<open>\<And>thesis. (\<And>xs. \<lbrakk>LCons n xs \<in> paths graph; x \<in> lset xs; lset xs \<subseteq> ns\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_44_set__mp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B ) ) ) )).

% set_mp
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B3: $tType,A: $tType,F: ( A > B3 ),G: ( A > B3 )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_in__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B ) ) ) )).

% in_mono
thf(fact_50_subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( member @ A @ C @ A3 )
       => ( member @ A @ C @ B ) ) ) )).

% subsetD
thf(fact_51_subsetCE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( member @ A @ C @ A3 )
       => ( member @ A @ C @ B ) ) ) )).

% subsetCE
thf(fact_52_equalityE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( A3 = B )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
         => ~ ( ord_less_eq @ ( set @ A ) @ B @ A3 ) ) ) )).

% equalityE
thf(fact_53_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A4 )
           => ( member @ A @ X2 @ B4 ) ) ) ) )).

% subset_eq
thf(fact_54_equalityD1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( A3 = B )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) )).

% equalityD1
thf(fact_55_equalityD2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( A3 = B )
     => ( ord_less_eq @ ( set @ A ) @ B @ A3 ) ) )).

% equalityD2
thf(fact_56_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
       => ( member @ A @ X @ B ) ) ) )).

% set_rev_mp
thf(fact_57_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
          ! [T: A] :
            ( ( member @ A @ T @ A4 )
           => ( member @ A @ T @ B4 ) ) ) ) )).

% subset_iff
thf(fact_58_rev__subsetD,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ C @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
       => ( member @ A @ C @ B ) ) ) )).

% rev_subsetD
thf(fact_59_subset__refl,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) )).

% subset_refl
thf(fact_60_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_61_subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( ord_less_eq @ ( set @ A ) @ B @ C2 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% subset_trans
thf(fact_62_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y: ( set @ A ),Z: ( set @ A )] : ( Y = Z ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
            & ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) ) )).

% set_eq_subset
thf(fact_63_contra__subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ~ ( member @ A @ C @ B )
       => ~ ( member @ A @ C @ A3 ) ) ) )).

% contra_subsetD
thf(fact_64_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) ) ) ) )).

% Collect_mono_iff
thf(fact_65_path__avoid__node,axiom,(
    ! [A: $tType,N2: A,Xs4: ( coinductive_llist @ A ),Graph: ( A > A > $o ),X: A] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ N2 @ Xs4 ) @ ( koenig916195507_paths @ A @ Graph ) )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs4 ) )
       => ( ( N2 != X )
         => ? [Xs: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ N2 @ Xs ) @ ( koenig916195507_paths @ A @ Graph ) )
              & ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Xs4 ) )
              & ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
              & ~ ( member @ A @ N2 @ ( coinductive_lset @ A @ Xs ) ) ) ) ) ) )).

% path_avoid_node
thf(fact_66_paths__LConsD,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A ),Graph: ( A > A > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X @ Xs4 ) @ ( koenig916195507_paths @ A @ Graph ) )
     => ( member @ ( coinductive_llist @ A ) @ Xs4 @ ( koenig916195507_paths @ A @ Graph ) ) ) )).

% paths_LConsD
thf(fact_67_paths_OLCons,axiom,(
    ! [Node: $tType,Graph: ( Node > Node > $o ),X: Node,Y2: Node,Xs4: ( coinductive_llist @ Node )] :
      ( ( Graph @ X @ Y2 )
     => ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ Y2 @ Xs4 ) @ ( koenig916195507_paths @ Node @ Graph ) )
       => ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ X @ ( coinductive_LCons @ Node @ Y2 @ Xs4 ) ) @ ( koenig916195507_paths @ Node @ Graph ) ) ) ) )).

% paths.LCons
thf(fact_68_subset__insertI2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ B ) ) ) )).

% subset_insertI2
thf(fact_69_subset__insertI,axiom,(
    ! [A: $tType,B: ( set @ A ),A2: A] :
      ( ord_less_eq @ ( set @ A ) @ B @ ( insert @ A @ A2 @ B ) ) )).

% subset_insertI
thf(fact_70_subset__insert,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) ) )).

% subset_insert
thf(fact_71_Set_Oinsert__mono,axiom,(
    ! [A: $tType,C2: ( set @ A ),D: ( set @ A ),A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C2 @ D )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C2 ) @ ( insert @ A @ A2 @ D ) ) ) )).

% Set.insert_mono
thf(fact_72_reachable__via_Oinducts,axiom,(
    ! [Node: $tType,X: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node,P: ( Node > $o )] :
      ( ( member @ Node @ X @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) )
     => ( ! [Xs3: ( coinductive_llist @ Node ),N: Node] :
            ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs3 ) @ ( koenig916195507_paths @ Node @ Graph ) )
           => ( ( member @ Node @ N @ ( coinductive_lset @ Node @ Xs3 ) )
             => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs3 ) @ Ns )
               => ( P @ N ) ) ) )
       => ( P @ X ) ) ) )).

% reachable_via.inducts
thf(fact_73_reachable__via_Ointros,axiom,(
    ! [Node: $tType,N2: Node,Xs4: ( coinductive_llist @ Node ),Graph: ( Node > Node > $o ),N3: Node,Ns: ( set @ Node )] :
      ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs4 ) @ ( koenig916195507_paths @ Node @ Graph ) )
     => ( ( member @ Node @ N3 @ ( coinductive_lset @ Node @ Xs4 ) )
       => ( ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs4 ) @ Ns )
         => ( member @ Node @ N3 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) ) ) ) ) )).

% reachable_via.intros
thf(fact_74_reachable__via_Osimps,axiom,(
    ! [Node: $tType,A2: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node] :
      ( ( member @ Node @ A2 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) )
      = ( ? [Xs5: ( coinductive_llist @ Node ),N4: Node] :
            ( ( A2 = N4 )
            & ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs5 ) @ ( koenig916195507_paths @ Node @ Graph ) )
            & ( member @ Node @ N4 @ ( coinductive_lset @ Node @ Xs5 ) )
            & ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs5 ) @ Ns ) ) ) ) )).

% reachable_via.simps
thf(fact_75_reachable__via_Ocases,axiom,(
    ! [Node: $tType,A2: Node,Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N2: Node] :
      ( ( member @ Node @ A2 @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N2 ) )
     => ~ ( ! [Xs3: ( coinductive_llist @ Node )] :
              ( ( member @ ( coinductive_llist @ Node ) @ ( coinductive_LCons @ Node @ N2 @ Xs3 ) @ ( koenig916195507_paths @ Node @ Graph ) )
             => ( ( member @ Node @ A2 @ ( coinductive_lset @ Node @ Xs3 ) )
               => ~ ( ord_less_eq @ ( set @ Node ) @ ( coinductive_lset @ Node @ Xs3 ) @ Ns ) ) ) ) ) )).

% reachable_via.cases
thf(fact_76_double__diff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( ord_less_eq @ ( set @ A ) @ B @ C2 )
       => ( ( minus_minus @ ( set @ A ) @ B @ ( minus_minus @ ( set @ A ) @ C2 @ A3 ) )
          = A3 ) ) ) )).

% double_diff
thf(fact_77_Diff__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B ) @ A3 ) )).

% Diff_subset
thf(fact_78_Diff__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),C2: ( set @ A ),D: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C2 )
     => ( ( ord_less_eq @ ( set @ A ) @ D @ B )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B ) @ ( minus_minus @ ( set @ A ) @ C2 @ D ) ) ) ) )).

% Diff_mono
thf(fact_79_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_80_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_81_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_82_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_83_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ? [B5: ( set @ A )] :
          ( ( A3
            = ( insert @ A @ A2 @ B5 ) )
          & ~ ( member @ A @ A2 @ B5 ) ) ) )).

% mk_disjoint_insert
thf(fact_84_insert__commute,axiom,(
    ! [A: $tType,X: A,Y2: A,A3: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y2 @ A3 ) )
      = ( insert @ A @ Y2 @ ( insert @ A @ X @ A3 ) ) ) )).

% insert_commute
thf(fact_85_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B2: A,B: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ B2 @ B )
       => ( ( ( insert @ A @ A2 @ A3 )
            = ( insert @ A @ B2 @ B ) )
          = ( ( ( A2 = B2 )
             => ( A3 = B ) )
            & ( ( A2 != B2 )
             => ? [C3: ( set @ A )] :
                  ( ( A3
                    = ( insert @ A @ B2 @ C3 ) )
                  & ~ ( member @ A @ B2 @ C3 )
                  & ( B
                    = ( insert @ A @ A2 @ C3 ) )
                  & ~ ( member @ A @ A2 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_86_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ A3 )
        = A3 ) ) )).

% insert_absorb
thf(fact_87_insert__ident,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ~ ( member @ A @ X @ B )
       => ( ( ( insert @ A @ X @ A3 )
            = ( insert @ A @ X @ B ) )
          = ( A3 = B ) ) ) ) )).

% insert_ident
thf(fact_88_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A )] :
      ( ( member @ A @ X @ A3 )
     => ~ ( ! [B5: ( set @ A )] :
              ( ( A3
                = ( insert @ A @ X @ B5 ) )
             => ( member @ A @ X @ B5 ) ) ) ) )).

% Set.set_insert
thf(fact_89_insertI2,axiom,(
    ! [A: $tType,A2: A,B: ( set @ A ),B2: A] :
      ( ( member @ A @ A2 @ B )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B ) ) ) )).

% insertI2
thf(fact_90_insertI1,axiom,(
    ! [A: $tType,A2: A,B: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B ) ) )).

% insertI1
thf(fact_91_insertE,axiom,(
    ! [A: $tType,A2: A,B2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A3 ) )
     => ( ( A2 != B2 )
       => ( member @ A @ A2 @ A3 ) ) ) )).

% insertE
thf(fact_92_DiffD2,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B ) )
     => ~ ( member @ A @ C @ B ) ) )).

% DiffD2
thf(fact_93_DiffD1,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B ) )
     => ( member @ A @ C @ A3 ) ) )).

% DiffD1
thf(fact_94_DiffE,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A3 @ B ) )
     => ~ ( ( member @ A @ C @ A3 )
         => ( member @ A @ C @ B ) ) ) )).

% DiffE
thf(fact_95_subset__singleton__iff,axiom,(
    ! [A: $tType,X4: ( set @ A ),A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X4 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X4
          = ( bot_bot @ ( set @ A ) ) )
        | ( X4
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_96_subset__singletonD,axiom,(
    ! [A: $tType,A3: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_97_subset__Diff__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),X: A,C2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B @ ( insert @ A @ X @ C2 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B @ C2 ) )
        & ~ ( member @ A @ X @ A3 ) ) ) )).

% subset_Diff_insert
thf(fact_98_Diff__single__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),X: A,B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B ) ) ) )).

% Diff_single_insert
thf(fact_99_subset__insert__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),X: A,B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B ) )
      = ( ( ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B ) )
        & ( ~ ( member @ A @ X @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) ) ) )).

% subset_insert_iff
thf(fact_100_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B2 ) ) )).

% singleton_inject
thf(fact_101_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( insert @ A @ A2 @ A3 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_102_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,C: A,D2: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C )
          & ( B2 = D2 ) )
        | ( ( A2 = D2 )
          & ( B2 = C ) ) ) ) )).

% doubleton_eq_iff
thf(fact_103_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A2 ) ) )).

% singleton_iff
thf(fact_104_singletonD,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A2 ) ) )).

% singletonD
thf(fact_105_insert__Diff__if,axiom,(
    ! [A: $tType,X: A,B: ( set @ A ),A3: ( set @ A )] :
      ( ( ( member @ A @ X @ B )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B )
          = ( minus_minus @ ( set @ A ) @ A3 @ B ) ) )
      & ( ~ ( member @ A @ X @ B )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ B )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A3 @ B ) ) ) ) ) )).

% insert_Diff_if
thf(fact_106_Diff__insert__absorb,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A )] :
      ( ~ ( member @ A @ X @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A3 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A3 ) ) )).

% Diff_insert_absorb
thf(fact_107_Diff__insert2,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B ) ) )).

% Diff_insert2
thf(fact_108_insert__Diff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A3 ) ) )).

% insert_Diff
thf(fact_109_Diff__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B ) @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert
thf(fact_110_lset__LCons,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A )] :
      ( ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs4 ) )
      = ( insert @ A @ X @ ( coinductive_lset @ A @ Xs4 ) ) ) )).

% lset_LCons
thf(fact_111_llist_Osimps_I19_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = ( insert @ A @ X21 @ ( coinductive_lset @ A @ X22 ) ) ) )).

% llist.simps(19)
thf(fact_112_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_113_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_114_bot__apply,axiom,(
    ! [C4: $tType,D3: $tType] :
      ( ( bot @ C4 @ ( type2 @ C4 ) )
     => ( ( bot_bot @ ( D3 > C4 ) )
        = ( ^ [X2: D3] :
              ( bot_bot @ C4 ) ) ) ) )).

% bot_apply
thf(fact_115_minus__apply,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( minus @ B3 @ ( type2 @ B3 ) )
     => ( ( minus_minus @ ( A > B3 ) )
        = ( ^ [A4: ( A > B3 ),B4: ( A > B3 ),X2: A] :
              ( minus_minus @ B3 @ ( A4 @ X2 ) @ ( B4 @ X2 ) ) ) ) ) )).

% minus_apply
thf(fact_116_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_117_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_118_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A ),X5: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs4 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X5 @ Xs4 ) ) ) ) )).

% lset_intros(2)
thf(fact_119_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs4 ) ) ) )).

% lset_intros(1)
thf(fact_120_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_121_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( insert @ A @ ( the_elem @ A @ A4 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_122_is__singletonI_H,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X3: A,Y3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( ( member @ A @ Y3 @ A3 )
             => ( X3 = Y3 ) ) )
       => ( is_singleton @ A @ A3 ) ) ) )).

% is_singletonI'
thf(fact_123_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) )).

% dual_order.antisym
thf(fact_124_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C @ B2 )
           => ( ord_less_eq @ A @ C @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_125_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B2: A] :
          ( ! [A5: A,B6: A] :
              ( ( ord_less_eq @ A @ A5 @ B6 )
             => ( P @ A5 @ B6 ) )
         => ( ! [A5: A,B6: A] :
                ( ( P @ B6 @ A5 )
               => ( P @ A5 @ B6 ) )
           => ( P @ A2 @ B2 ) ) ) ) )).

% linorder_wlog
thf(fact_126_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_127_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z2 )
           => ( ord_less_eq @ A @ X @ Z2 ) ) ) ) )).

% order_trans
thf(fact_128_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) )).

% order_class.order.antisym
thf(fact_129_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C )
           => ( ord_less_eq @ A @ A2 @ C ) ) ) ) )).

% ord_le_eq_trans
thf(fact_130_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C )
           => ( ord_less_eq @ A @ A2 @ C ) ) ) ) )).

% ord_eq_le_trans
thf(fact_131_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv
thf(fact_132_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X )
             => ~ ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_133_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C )
           => ( ord_less_eq @ A @ A2 @ C ) ) ) ) )).

% order.trans
thf(fact_134_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% le_cases
thf(fact_135_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B2: A,A2: A] :
          ( ! [A5: A,B6: A] :
              ( ( ord_less_eq @ A @ A5 @ B6 )
             => ( P @ A5 @ B6 ) )
         => ( ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
           => ( P @ A2 @ B2 ) ) ) ) )).

% wlog_linorder_le
thf(fact_136_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X = Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) )).

% eq_refl
thf(fact_137_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% linear
thf(fact_138_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X )
           => ( X = Y2 ) ) ) ) )).

% antisym
thf(fact_139_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y: A,Z: A] : ( Y = Z ) )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ) )).

% eq_iff
thf(fact_140_ord__le__eq__subst,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( ord @ B3 @ ( type2 @ B3 ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > B3 ),C: B3] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F @ B2 )
              = C )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B3 @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ B3 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_141_ord__eq__le__subst,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( ord @ B3 @ ( type2 @ B3 ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B3 > A ),B2: B3,C: B3] :
          ( ( A2
            = ( F @ B2 ) )
         => ( ( ord_less_eq @ B3 @ B2 @ C )
           => ( ! [X3: B3,Y3: B3] :
                  ( ( ord_less_eq @ B3 @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_142_order__subst2,axiom,(
    ! [A: $tType,C4: $tType] :
      ( ( ( order @ C4 @ ( type2 @ C4 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > C4 ),C: C4] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C4 @ ( F @ B2 ) @ C )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C4 @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ C4 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% order_subst2
thf(fact_143_order__subst1,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( order @ B3 @ ( type2 @ B3 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B3 > A ),B2: B3,C: B3] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B2 ) )
         => ( ( ord_less_eq @ B3 @ B2 @ C )
           => ( ! [X3: B3,Y3: B3] :
                  ( ( ord_less_eq @ B3 @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% order_subst1
thf(fact_144_le__fun__def,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ( ( ord_less_eq @ ( A > B3 ) )
        = ( ^ [F2: ( A > B3 ),G2: ( A > B3 )] :
            ! [X2: A] :
              ( ord_less_eq @ B3 @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% le_fun_def
thf(fact_145_le__funI,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ! [F: ( A > B3 ),G: ( A > B3 )] :
          ( ! [X3: A] :
              ( ord_less_eq @ B3 @ ( F @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B3 ) @ F @ G ) ) ) )).

% le_funI
thf(fact_146_le__funE,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ! [F: ( A > B3 ),G: ( A > B3 ),X: A] :
          ( ( ord_less_eq @ ( A > B3 ) @ F @ G )
         => ( ord_less_eq @ B3 @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funE
thf(fact_147_le__funD,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ! [F: ( A > B3 ),G: ( A > B3 ),X: A] :
          ( ( ord_less_eq @ ( A > B3 ) @ F @ G )
         => ( ord_less_eq @ B3 @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funD
thf(fact_148_fun__diff__def,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( minus @ B3 @ ( type2 @ B3 ) )
     => ( ( minus_minus @ ( A > B3 ) )
        = ( ^ [A4: ( A > B3 ),B4: ( A > B3 ),X2: A] :
              ( minus_minus @ B3 @ ( A4 @ X2 ) @ ( B4 @ X2 ) ) ) ) ) )).

% fun_diff_def
thf(fact_149_bot__fun__def,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( bot @ B3 @ ( type2 @ B3 ) )
     => ( ( bot_bot @ ( A > B3 ) )
        = ( ^ [X2: A] :
              ( bot_bot @ B3 ) ) ) ) )).

% bot_fun_def
thf(fact_150_is__singletonE,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( is_singleton @ A @ A3 )
     => ~ ( ! [X3: A] :
              ( A3
             != ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_151_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
          ? [X2: A] :
            ( A4
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_152_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) )).

% bot.extremum
thf(fact_153_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_154_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_155_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) )
       => ( ! [Z1: A,Z22: ( coinductive_llist @ A ),Xa: A] :
              ( ( member @ A @ Xa @ ( coinductive_lset @ A @ Z22 ) )
             => ( ( P @ Xa @ Z22 )
               => ( P @ Xa @ ( coinductive_LCons @ A @ Z1 @ Z22 ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_156_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z22: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z22 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z22 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_157_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs4 ) )
     => ( ! [Xs3: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
       => ( ! [X6: A,Xs3: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
             => ( ( P @ Xs3 )
               => ( P @ ( coinductive_LCons @ A @ X6 @ Xs3 ) ) ) )
         => ( P @ Xs4 ) ) ) ) )).

% lset_induct'
thf(fact_158_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs4 ) )
     => ( ! [Xs3: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
       => ( ! [X6: A,Xs3: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
             => ( ( X != X6 )
               => ( ( P @ Xs3 )
                 => ( P @ ( coinductive_LCons @ A @ X6 @ Xs3 ) ) ) ) )
         => ( P @ Xs4 ) ) ) ) )).

% lset_induct
thf(fact_159_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs4: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs4 ) )
     => ( ! [Xs: ( coinductive_llist @ A )] :
            ( Xs4
           != ( coinductive_LCons @ A @ X @ Xs ) )
       => ~ ( ! [X6: A,Xs: ( coinductive_llist @ A )] :
                ( ( Xs4
                  = ( coinductive_LCons @ A @ X6 @ Xs ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) ) ) ) )).

% lset_cases
thf(fact_160_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_161_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_162_insert__subsetI,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),X4: ( set @ A )] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ X4 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X4 ) @ A3 ) ) ) )).

% insert_subsetI
thf(fact_163_subset__emptyI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X3: A] :
          ~ ( member @ A @ X3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_164_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,D2: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) )).

% diff_mono
thf(fact_165_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C @ A2 ) @ ( minus_minus @ A @ C @ B2 ) ) ) ) )).

% diff_left_mono
thf(fact_166_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C ) ) ) )).

% diff_right_commute
thf(fact_167_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C @ D2 ) )
         => ( ( A2 = B2 )
            = ( C = D2 ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_168_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C @ D2 ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_169_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C ) @ ( minus_minus @ A @ B2 @ C ) ) ) ) )).

% diff_right_mono
thf(fact_170_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_171_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_172_remove__def,axiom,(
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X2: A,A4: ( set @ A )] :
            ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% remove_def
thf(fact_173_member__remove,axiom,(
    ! [A: $tType,X: A,Y2: A,A3: ( set @ A )] :
      ( ( member @ A @ X @ ( remove @ A @ Y2 @ A3 ) )
      = ( ( member @ A @ X @ A3 )
        & ( X != Y2 ) ) ) )).

% member_remove
thf(fact_174_lset__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A )
      = ( coinductive_gen_lset @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_code
thf(fact_175_gen__lset__code_I2_J,axiom,(
    ! [A: $tType,A3: ( set @ A ),X: A,Xs4: ( coinductive_llist @ A )] :
      ( ( coinductive_gen_lset @ A @ A3 @ ( coinductive_LCons @ A @ X @ Xs4 ) )
      = ( coinductive_gen_lset @ A @ ( insert @ A @ X @ A3 ) @ Xs4 ) ) )).

% gen_lset_code(2)
thf(fact_176_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_177_psubset__insert__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),X: A,B: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X @ B ) )
      = ( ( ( member @ A @ X @ B )
         => ( ord_less @ ( set @ A ) @ A3 @ B ) )
        & ( ~ ( member @ A @ X @ B )
         => ( ( ( member @ A @ X @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B ) )
            & ( ~ ( member @ A @ X @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) ) ) ) ) )).

% psubset_insert_iff
thf(fact_178_pairwise__singleton,axiom,(
    ! [A: $tType,P: ( A > A > $o ),A3: A] :
      ( pairwise @ A @ P @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_179_subset__Compl__singleton,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A3 ) ) ) )).

% subset_Compl_singleton
thf(fact_180_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) )).

% add.inverse_inverse
thf(fact_181_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) )).

% neg_equal_iff_equal
thf(fact_182_uminus__apply,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( uminus @ B3 @ ( type2 @ B3 ) )
     => ( ( uminus_uminus @ ( A > B3 ) )
        = ( ^ [A4: ( A > B3 ),X2: A] :
              ( uminus_uminus @ B3 @ ( A4 @ X2 ) ) ) ) ) )).

% uminus_apply
thf(fact_183_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X ) )
          = X ) ) )).

% double_compl
thf(fact_184_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ( uminus_uminus @ A @ X )
            = ( uminus_uminus @ A @ Y2 ) )
          = ( X = Y2 ) ) ) )).

% compl_eq_compl_iff
thf(fact_185_ComplI,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A )] :
      ( ~ ( member @ A @ C @ A3 )
     => ( member @ A @ C @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) )).

% ComplI
thf(fact_186_Compl__iff,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A )] :
      ( ( member @ A @ C @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( ~ ( member @ A @ C @ A3 ) ) ) )).

% Compl_iff
thf(fact_187_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A3 )
        = ( uminus_uminus @ ( set @ A ) @ B ) )
      = ( A3 = B ) ) )).

% Compl_eq_Compl_iff
thf(fact_188_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) )).

% neg_le_iff_le
thf(fact_189_compl__le__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% compl_le_compl_iff
thf(fact_190_neg__less__iff__less,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) )).

% neg_less_iff_less
thf(fact_191_minus__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) )).

% minus_diff_eq
thf(fact_192_psubsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( A3 != B )
       => ( ord_less @ ( set @ A ) @ A3 @ B ) ) ) )).

% psubsetI
thf(fact_193_Compl__anti__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) )).

% Compl_anti_mono
thf(fact_194_Compl__subset__Compl__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B ) )
      = ( ord_less_eq @ ( set @ A ) @ B @ A3 ) ) )).

% Compl_subset_Compl_iff
thf(fact_195_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% le_imp_neg_le
thf(fact_196_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) )).

% minus_le_iff
thf(fact_197_le__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% le_minus_iff
thf(fact_198_compl__le__swap2,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y2 ) ) ) )).

% compl_le_swap2
thf(fact_199_compl__le__swap1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y2 ) ) ) ) )).

% compl_le_swap1
thf(fact_200_compl__mono,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ ( uminus_uminus @ A @ X ) ) ) ) )).

% compl_mono
thf(fact_201_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_202_dual__order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) )).

% dual_order.strict_implies_order
thf(fact_203_dual__order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B7: A,A6: A] :
              ( ( ord_less_eq @ A @ B7 @ A6 )
              & ( A6 != B7 ) ) ) ) ) )).

% dual_order.strict_iff_order
thf(fact_204_dual__order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B7: A,A6: A] :
              ( ( ord_less @ A @ B7 @ A6 )
              | ( A6 = B7 ) ) ) ) ) )).

% dual_order.order_iff_strict
thf(fact_205_order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) )).

% order.strict_implies_order
thf(fact_206_dense__le__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y2 )
                 => ( ord_less_eq @ A @ W @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) )).

% dense_le_bounded
thf(fact_207_dense__ge__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z2 @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y2 @ W ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) )).

% dense_ge_bounded
thf(fact_208_dual__order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C @ B2 )
           => ( ord_less @ A @ C @ A2 ) ) ) ) )).

% dual_order.strict_trans2
thf(fact_209_dual__order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C @ B2 )
           => ( ord_less @ A @ C @ A2 ) ) ) ) )).

% dual_order.strict_trans1
thf(fact_210_order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [A6: A,B7: A] :
              ( ( ord_less_eq @ A @ A6 @ B7 )
              & ( A6 != B7 ) ) ) ) ) )).

% order.strict_iff_order
thf(fact_211_order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A6: A,B7: A] :
              ( ( ord_less @ A @ A6 @ B7 )
              | ( A6 = B7 ) ) ) ) ) )).

% order.order_iff_strict
thf(fact_212_order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% order.strict_trans2
thf(fact_213_order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C )
           => ( ord_less @ A @ A2 @ C ) ) ) ) )).

% order.strict_trans1
thf(fact_214_not__le__imp__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X )
         => ( ord_less @ A @ X @ Y2 ) ) ) )).

% not_le_imp_less
thf(fact_215_less__le__not__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
              & ~ ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ) )).

% less_le_not_le
thf(fact_216_le__imp__less__or__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ X @ Y2 )
            | ( X = Y2 ) ) ) ) )).

% le_imp_less_or_eq
thf(fact_217_le__less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) )).

% le_less_linear
thf(fact_218_dense__le,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,Z2: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ord_less_eq @ A @ X3 @ Z2 ) )
         => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) )).

% dense_le
thf(fact_219_dense__ge,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z2: A,Y2: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z2 @ X3 )
             => ( ord_less_eq @ A @ Y2 @ X3 ) )
         => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) )).

% dense_ge
thf(fact_220_less__le__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) )).

% less_le_trans
thf(fact_221_le__less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) )).

% le_less_trans
thf(fact_222_antisym__conv2,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv2
thf(fact_223_antisym__conv1,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv1
thf(fact_224_less__imp__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) )).

% less_imp_le
thf(fact_225_le__neq__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) )).

% le_neq_trans
thf(fact_226_not__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% not_less
thf(fact_227_not__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X ) ) ) )).

% not_le
thf(fact_228_order__less__le__subst2,axiom,(
    ! [A: $tType,C4: $tType] :
      ( ( ( order @ C4 @ ( type2 @ C4 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > C4 ),C: C4] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C4 @ ( F @ B2 ) @ C )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ C4 @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C4 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% order_less_le_subst2
thf(fact_229_order__less__le__subst1,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( order @ B3 @ ( type2 @ B3 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B3 > A ),B2: B3,C: B3] :
          ( ( ord_less @ A @ A2 @ ( F @ B2 ) )
         => ( ( ord_less_eq @ B3 @ B2 @ C )
           => ( ! [X3: B3,Y3: B3] :
                  ( ( ord_less_eq @ B3 @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_230_order__le__less__subst2,axiom,(
    ! [A: $tType,C4: $tType] :
      ( ( ( order @ C4 @ ( type2 @ C4 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B2: A,F: ( A > C4 ),C: C4] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C4 @ ( F @ B2 ) @ C )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C4 @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C4 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% order_le_less_subst2
thf(fact_231_order__le__less__subst1,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( order @ B3 @ ( type2 @ B3 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B3 > A ),B2: B3,C: B3] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B2 ) )
         => ( ( ord_less @ B3 @ B2 @ C )
           => ( ! [X3: B3,Y3: B3] :
                  ( ( ord_less @ B3 @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_232_less__le,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
              & ( X2 != Y4 ) ) ) ) ) )).

% less_le
thf(fact_233_le__less,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less @ A @ X2 @ Y4 )
              | ( X2 = Y4 ) ) ) ) ) )).

% le_less
thf(fact_234_leI,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% leI
thf(fact_235_leD,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ~ ( ord_less @ A @ X @ Y2 ) ) ) )).

% leD
thf(fact_236_diff__strict__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,D2: A,C: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) )).

% diff_strict_mono
thf(fact_237_diff__eq__diff__less,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C @ D2 ) ) ) ) )).

% diff_eq_diff_less
thf(fact_238_diff__strict__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C @ A2 ) @ ( minus_minus @ A @ C @ B2 ) ) ) ) )).

% diff_strict_left_mono
thf(fact_239_diff__strict__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C ) @ ( minus_minus @ A @ B2 @ C ) ) ) ) )).

% diff_strict_right_mono
thf(fact_240_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_241_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) )).

% bot.not_eq_extremum
thf(fact_242_not__psubset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_243_subset__iff__psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( ( ord_less @ ( set @ A ) @ A4 @ B4 )
            | ( A4 = B4 ) ) ) ) )).

% subset_iff_psubset_eq
thf(fact_244_subset__psubset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
     => ( ( ord_less @ ( set @ A ) @ B @ C2 )
       => ( ord_less @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% subset_psubset_trans
thf(fact_245_subset__not__subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) ) )).

% subset_not_subset_eq
thf(fact_246_psubset__subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B )
     => ( ( ord_less_eq @ ( set @ A ) @ B @ C2 )
       => ( ord_less @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% psubset_subset_trans
thf(fact_247_psubset__imp__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B ) ) )).

% psubset_imp_subset
thf(fact_248_psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
            & ( A4 != B4 ) ) ) ) )).

% psubset_eq
thf(fact_249_psubsetE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B )
         => ( ord_less_eq @ ( set @ A ) @ B @ A3 ) ) ) )).

% psubsetE
thf(fact_250_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) )).

% equation_minus_iff
thf(fact_251_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) )).

% minus_equation_iff
thf(fact_252_less__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% less_minus_iff
thf(fact_253_minus__less__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) )).

% minus_less_iff
thf(fact_254_ComplD,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A )] :
      ( ( member @ A @ C @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
     => ~ ( member @ A @ C @ A3 ) ) )).

% ComplD
thf(fact_255_psubsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B: ( set @ A ),C: A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B )
     => ( ( member @ A @ C @ A3 )
       => ( member @ A @ C @ B ) ) ) )).

% psubsetD

%----Type constructors (25)
thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( boolean_algebra @ A8 @ ( type2 @ A8 ) )
     => ( boolean_algebra @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order_bot @ A8 @ ( type2 @ A8 ) )
     => ( order_bot @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( preorder @ A8 @ ( type2 @ A8 ) )
     => ( preorder @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order @ A8 @ ( type2 @ A8 ) )
     => ( order @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( bot @ A8 @ ( type2 @ A8 ) )
     => ( bot @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( uminus @ A8 @ ( type2 @ A8 ) )
     => ( uminus @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( minus @ A8 @ ( type2 @ A8 ) )
     => ( minus @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_1,axiom,(
    ! [A7: $tType] :
      ( boolean_algebra @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_2,axiom,(
    ! [A7: $tType] :
      ( order_bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_3,axiom,(
    ! [A7: $tType] :
      ( preorder @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_4,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_5,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_6,axiom,(
    ! [A7: $tType] :
      ( bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_7,axiom,(
    ! [A7: $tType] :
      ( uminus @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_8,axiom,(
    ! [A7: $tType] :
      ( minus @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_9,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_10,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_11,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_12,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_13,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_14,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_15,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_16,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( member @ a @ x @ ( insert @ a @ n2 @ ( koenig317145564le_via @ a @ graph @ ( minus_minus @ ( set @ a ) @ ns @ ( insert @ a @ n2 @ ( bot_bot @ ( set @ a ) ) ) ) @ n2 ) ) )).

%------------------------------------------------------------------------------
