%------------------------------------------------------------------------------
% File     : COM177^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 184
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__184.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  351 (   0 unit;  59 type;   0 defn)
%            Number of atoms       : 4051 ( 225 equality;2369 variable)
%            Maximal formula depth :   28 (   9 average)
%            Number of connectives : 3758 ( 102   ~;   9   |;  31   &;3282   @)
%                                         (   0 <=>; 334  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  192 ( 192   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   62 (  59   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1011 (   4 sgn; 904   !;  13   ?;  41   ^)
%                                         (1011   :;  53  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:46:59.098
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_node,type,(
    node: $tType )).

%----Explicit typings (52)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Topological__Spaces_Operfect__space,type,(
    topolo890362671_space: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,(
    topolo47006728_space: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Basic__BNFs_Ofsts,type,(
    basic_fsts: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_Basic__BNFs_Osnds,type,(
    basic_snds: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oconnected,type,(
    koenig793108494nected: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > $o ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__via,type,(
    koenig317145564le_via: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > ( set @ Node ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__viap,type,(
    koenig1757754772e_viap: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > Node > $o ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,(
    topolo406746546ounded: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f____,type,(
    f: ( product_prod @ node @ ( set @ node ) ) > ( coinductive_llist @ node ) )).

thf(sy_v_graph,type,(
    graph: node > node > $o )).

thf(sy_v_na____,type,(
    na: node )).

thf(sy_v_ns____,type,(
    ns: ( set @ node ) )).

thf(sy_v_nsa____,type,(
    nsa: ( set @ node ) )).

thf(sy_v_x____,type,(
    x: node )).

%----Relevant facts (254)
thf(fact_0__092_060open_062n_A_092_060notin_062_Ans_092_060close_062,axiom,(
    ~ ( member @ node @ na @ nsa ) )).

% \<open>n \<notin> ns\<close>
thf(fact_1__092_060open_062finite_Ans_092_060close_062,axiom,
    ( finite_finite2 @ node @ nsa )).

% \<open>finite ns\<close>
thf(fact_2__092_060open_062infinite_A_Ireachable__via_Agraph_A_I_N_Ainsert_An_Ans_J_An_J_092_060close_062,axiom,(
    ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ na @ nsa ) ) @ na ) ) )).

% \<open>infinite (reachable_via graph (- insert n ns) n)\<close>
thf(fact_3__092_060open_062x_A_092_060in_062_Alset_A_If_A_In_M_Ans_J_J_092_060close_062,axiom,
    ( member @ node @ x @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ na @ nsa ) ) ) )).

% \<open>x \<in> lset (f (n, ns))\<close>
thf(fact_4_ns__def,axiom,
    ( ns
    = ( bot_bot @ ( set @ node ) ) )).

% ns_def
thf(fact_5_infinite,axiom,(
    ~ ( finite_finite2 @ node @ ( top_top @ ( set @ node ) ) ) )).

% infinite
thf(fact_6_reachable__viap__reachable__via__eq,axiom,(
    ! [Node: $tType] :
      ( ( koenig1757754772e_viap @ Node )
      = ( ^ [Graph: ( Node > Node > $o ),Ns: ( set @ Node ),N: Node,X: Node] :
            ( member @ Node @ X @ ( koenig317145564le_via @ Node @ Graph @ Ns @ N ) ) ) ) )).

% reachable_viap_reachable_via_eq
thf(fact_7_connected,axiom,
    ( koenig793108494nected @ node @ graph )).

% connected
thf(fact_8_finite__compl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ( finite_finite2 @ A @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
        = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finite_compl
thf(fact_9_compl__bot__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( bot_bot @ A ) )
        = ( top_top @ A ) ) ) )).

% compl_bot_eq
thf(fact_10_compl__top__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( top_top @ A ) )
        = ( bot_bot @ A ) ) ) )).

% compl_top_eq
thf(fact_11_finite__insert,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A3 @ A2 ) )
      = ( finite_finite2 @ A @ A2 ) ) )).

% finite_insert
thf(fact_12_singletonI,axiom,(
    ! [A: $tType,A3: A] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_13_finite__option__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_option_UNIV
thf(fact_14_finite__Plus__UNIV__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_Plus_UNIV_iff
thf(fact_15_Compl__UNIV__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_UNIV_eq
thf(fact_16_Compl__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Compl_empty_eq
thf(fact_17_finite_Ocases,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A4: ( set @ A )] :
                ( ? [A5: A] :
                    ( A3
                    = ( insert @ A @ A5 @ A4 ) )
               => ~ ( finite_finite2 @ A @ A4 ) ) ) ) ) )).

% finite.cases
thf(fact_18_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A6: ( set @ A )] :
            ( ( A6
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A7: ( set @ A ),B2: A] :
                ( ( A6
                  = ( insert @ A @ B2 @ A7 ) )
                & ( finite_finite2 @ A @ A7 ) ) ) ) ) )).

% finite.simps
thf(fact_19_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X2 )
            = ( uminus_uminus @ A @ Y ) )
          = ( X2 = Y ) ) ) )).

% compl_eq_compl_iff
thf(fact_20_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X2 ) )
          = X2 ) ) )).

% double_compl
thf(fact_21_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),X: A] :
              ( uminus_uminus @ B @ ( A7 @ X ) ) ) ) ) )).

% uminus_apply
thf(fact_22_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% empty_Collect_eq
thf(fact_23_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% Collect_empty_eq
thf(fact_24_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X: A] :
            ~ ( member @ A @ X @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_25_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_26_UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_27_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A7: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_28_insert__absorb2,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ X2 @ A2 ) )
      = ( insert @ A @ X2 @ A2 ) ) )).

% insert_absorb2
thf(fact_29_insert__iff,axiom,(
    ! [A: $tType,A3: A,B3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B3 @ A2 ) )
      = ( ( A3 = B3 )
        | ( member @ A @ A3 @ A2 ) ) ) )).

% insert_iff
thf(fact_30_insertCI,axiom,(
    ! [A: $tType,A3: A,B4: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A3 @ B4 )
       => ( A3 = B3 ) )
     => ( member @ A @ A3 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% insertCI
thf(fact_31_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A2 )
        = ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( A2 = B4 ) ) )).

% Compl_eq_Compl_iff
thf(fact_32_Compl__iff,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = ( ~ ( member @ A @ C2 @ A2 ) ) ) )).

% Compl_iff
thf(fact_33_ComplI,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A )] :
      ( ~ ( member @ A @ C2 @ A2 )
     => ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) ) ) )).

% ComplI
thf(fact_34_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_35_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_36_fun__Compl__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),X: A] :
              ( uminus_uminus @ B @ ( A7 @ X ) ) ) ) ) )).

% fun_Compl_def
thf(fact_37_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X: A] :
            ( member @ A @ X @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_38_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_39_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A3 @ A2 ) ) )).

% equals0D
thf(fact_40_emptyE,axiom,(
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_41_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_42_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_43_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( finite_finite2 @ A @ A2 ) ) )).

% finite
thf(fact_44_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A2 )
           => ? [X1: B] :
                ( P @ X3 @ X1 ) )
       => ? [F: ( A > B )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A2 )
           => ( P @ X4 @ ( F @ X4 ) ) ) ) ) )).

% finite_set_choice
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) )).

% ext
thf(fact_49_mk__disjoint__insert,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ? [B5: ( set @ A )] :
          ( ( A2
            = ( insert @ A @ A3 @ B5 ) )
          & ~ ( member @ A @ A3 @ B5 ) ) ) )).

% mk_disjoint_insert
thf(fact_50_insert__commute,axiom,(
    ! [A: $tType,X2: A,Y: A,A2: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ Y @ A2 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X2 @ A2 ) ) ) )).

% insert_commute
thf(fact_51_insert__eq__iff,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),B3: A,B4: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ A2 )
     => ( ~ ( member @ A @ B3 @ B4 )
       => ( ( ( insert @ A @ A3 @ A2 )
            = ( insert @ A @ B3 @ B4 ) )
          = ( ( ( A3 = B3 )
             => ( A2 = B4 ) )
            & ( ( A3 != B3 )
             => ? [C3: ( set @ A )] :
                  ( ( A2
                    = ( insert @ A @ B3 @ C3 ) )
                  & ~ ( member @ A @ B3 @ C3 )
                  & ( B4
                    = ( insert @ A @ A3 @ C3 ) )
                  & ~ ( member @ A @ A3 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_52_insert__absorb,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ( ( insert @ A @ A3 @ A2 )
        = A2 ) ) )).

% insert_absorb
thf(fact_53_insert__ident,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A2 )
     => ( ~ ( member @ A @ X2 @ B4 )
       => ( ( ( insert @ A @ X2 @ A2 )
            = ( insert @ A @ X2 @ B4 ) )
          = ( A2 = B4 ) ) ) ) )).

% insert_ident
thf(fact_54_Set_Oset__insert,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A )] :
      ( ( member @ A @ X2 @ A2 )
     => ~ ( ! [B5: ( set @ A )] :
              ( ( A2
                = ( insert @ A @ X2 @ B5 ) )
             => ( member @ A @ X2 @ B5 ) ) ) ) )).

% Set.set_insert
thf(fact_55_insertI2,axiom,(
    ! [A: $tType,A3: A,B4: ( set @ A ),B3: A] :
      ( ( member @ A @ A3 @ B4 )
     => ( member @ A @ A3 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% insertI2
thf(fact_56_insertI1,axiom,(
    ! [A: $tType,A3: A,B4: ( set @ A )] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ B4 ) ) )).

% insertI1
thf(fact_57_insertE,axiom,(
    ! [A: $tType,A3: A,B3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B3 @ A2 ) )
     => ( ( A3 != B3 )
       => ( member @ A @ A3 @ A2 ) ) ) )).

% insertE
thf(fact_58_double__complement,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = A2 ) )).

% double_complement
thf(fact_59_ComplD,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
     => ~ ( member @ A @ C2 @ A2 ) ) )).

% ComplD
thf(fact_60_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_61_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_62_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_63_finite__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_UNIV
thf(fact_64_infinite__UNIV__char__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% infinite_UNIV_char_0
thf(fact_65_finite__fun__UNIVD2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) )).

% finite_fun_UNIVD2
thf(fact_66_finite__Prod__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% finite_Prod_UNIV
thf(fact_67_ex__new__if__finite,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A @ A2 )
       => ? [A5: A] :
            ~ ( member @ A @ A5 @ A2 ) ) ) )).

% ex_new_if_finite
thf(fact_68_finite__prod,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_prod
thf(fact_69_Finite__Set_Ofinite__set,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% Finite_Set.finite_set
thf(fact_70_singleton__inject,axiom,(
    ! [A: $tType,A3: A,B3: A] :
      ( ( ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A3 = B3 ) ) )).

% singleton_inject
thf(fact_71_insert__not__empty,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( insert @ A @ A3 @ A2 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_72_doubleton__eq__iff,axiom,(
    ! [A: $tType,A3: A,B3: A,C2: A,D: A] :
      ( ( ( insert @ A @ A3 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A3 = C2 )
          & ( B3 = D ) )
        | ( ( A3 = D )
          & ( B3 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_73_singleton__iff,axiom,(
    ! [A: $tType,B3: A,A3: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A3 ) ) )).

% singleton_iff
thf(fact_74_singletonD,axiom,(
    ! [A: $tType,B3: A,A3: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A3 ) ) )).

% singletonD
thf(fact_75_insert__UNIV,axiom,(
    ! [A: $tType,X2: A] :
      ( ( insert @ A @ X2 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% insert_UNIV
thf(fact_76_finite_OinsertI,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A] :
      ( ( finite_finite2 @ A @ A2 )
     => ( finite_finite2 @ A @ ( insert @ A @ A3 @ A2 ) ) ) )).

% finite.insertI
thf(fact_77_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A2: ( set @ A )] :
      ( ! [A4: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A4 )
         => ( P @ A4 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F3: ( set @ A )] :
              ( ( finite_finite2 @ A @ F3 )
             => ( ~ ( member @ A @ X3 @ F3 )
               => ( ( P @ F3 )
                 => ( P @ ( insert @ A @ X3 @ F3 ) ) ) ) )
         => ( P @ A2 ) ) ) ) )).

% infinite_finite_induct
thf(fact_78_finite__ne__induct,axiom,(
    ! [A: $tType,F4: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( ( F4
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A] :
              ( P @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X3: A,F3: ( set @ A )] :
                ( ( finite_finite2 @ A @ F3 )
               => ( ( F3
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X3 @ F3 )
                   => ( ( P @ F3 )
                     => ( P @ ( insert @ A @ X3 @ F3 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_79_finite_Oinducts,axiom,(
    ! [A: $tType,X2: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A4: ( set @ A ),A5: A] :
              ( ( finite_finite2 @ A @ A4 )
             => ( ( P @ A4 )
               => ( P @ ( insert @ A @ A5 @ A4 ) ) ) )
         => ( P @ X2 ) ) ) ) )).

% finite.inducts
thf(fact_80_finite__induct,axiom,(
    ! [A: $tType,F4: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F3: ( set @ A )] :
              ( ( finite_finite2 @ A @ F3 )
             => ( ~ ( member @ A @ X3 @ F3 )
               => ( ( P @ F3 )
                 => ( P @ ( insert @ A @ X3 @ F3 ) ) ) ) )
         => ( P @ F4 ) ) ) ) )).

% finite_induct
thf(fact_81_Topological__Spaces_OUNIV__not__singleton,axiom,(
    ! [A: $tType] :
      ( ( topolo890362671_space @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( top_top @ ( set @ A ) )
         != ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Topological_Spaces.UNIV_not_singleton
thf(fact_82_f__simps_I1_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ~ ( coinductive_lnull @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) ) )).

% f_simps(1)
thf(fact_83_the__elem__eq,axiom,(
    ! [A: $tType,X2: A] :
      ( ( the_elem @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
      = X2 ) )).

% the_elem_eq
thf(fact_84_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_85_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B3 ) )
          = ( A3 = B3 ) ) ) )).

% neg_equal_iff_equal
thf(fact_86_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A3 ) )
          = A3 ) ) )).

% add.inverse_inverse
thf(fact_87_top__apply,axiom,(
    ! [C: $tType,D2: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D2 > C ) )
        = ( ^ [X: D2] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_88_bot__apply,axiom,(
    ! [C: $tType,D2: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D2 > C ) )
        = ( ^ [X: D2] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_89_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A8: A,B6: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A8 @ B6 ) )
      = ( ( A3 = A8 )
        & ( B3 = B6 ) ) ) )).

% old.prod.inject
thf(fact_90_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X12: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X12 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X12 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_91_top1I,axiom,(
    ! [A: $tType,X2: A] :
      ( top_top @ ( A > $o ) @ X2 ) )).

% top1I
thf(fact_92_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y2: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y2 ) ) )).

% surj_pair
thf(fact_93_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A5: A,B7: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B7 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_94_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A8: A,B6: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A8 @ B6 ) )
     => ~ ( ( A3 = A8 )
         => ( B3 != B6 ) ) ) )).

% Pair_inject
thf(fact_95_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B7: B,C4: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B7 @ C4 ) ) ) ) )).

% prod_cases3
thf(fact_96_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) )] :
      ~ ( ! [A5: A,B7: B,C4: C,D3: D2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D2 ) @ B7 @ ( product_Pair @ C @ D2 @ C4 @ D3 ) ) ) ) ) )).

% prod_cases4
thf(fact_97_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) )] :
      ~ ( ! [A5: A,B7: B,C4: C,D3: D2,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D2 @ E ) @ C4 @ ( product_Pair @ D2 @ E @ D3 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_98_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,E: $tType,F5: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) ) )] :
      ~ ( ! [A5: A,B7: B,C4: C,D3: D2,E2: E,F: F5] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) @ C4 @ ( product_Pair @ D2 @ ( product_prod @ E @ F5 ) @ D3 @ ( product_Pair @ E @ F5 @ E2 @ F ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_99_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D2: $tType,E: $tType,F5: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A5: A,B7: B,C4: C,D3: D2,E2: E,F: F5,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) @ C4 @ ( product_Pair @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F5 @ G2 ) @ E2 @ ( product_Pair @ F5 @ G2 @ F @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_100_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B7: B,C4: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B7 @ C4 ) ) )
     => ( P @ X2 ) ) )).

% prod_induct3
thf(fact_101_prod__induct4,axiom,(
    ! [D2: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) )] :
      ( ! [A5: A,B7: B,C4: C,D3: D2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D2 ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D2 ) @ B7 @ ( product_Pair @ C @ D2 @ C4 @ D3 ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct4
thf(fact_102_prod__induct5,axiom,(
    ! [E: $tType,D2: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) )] :
      ( ! [A5: A,B7: B,C4: C,D3: D2,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ E ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D2 @ E ) @ C4 @ ( product_Pair @ D2 @ E @ D3 @ E2 ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct5
thf(fact_103_prod__induct6,axiom,(
    ! [F5: $tType,E: $tType,D2: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) ) )] :
      ( ! [A5: A,B7: B,C4: C,D3: D2,E2: E,F: F5] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ F5 ) ) @ C4 @ ( product_Pair @ D2 @ ( product_prod @ E @ F5 ) @ D3 @ ( product_Pair @ E @ F5 @ E2 @ F ) ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct6
thf(fact_104_prod__induct7,axiom,(
    ! [G2: $tType,F5: $tType,E: $tType,D2: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) ) )] :
      ( ! [A5: A,B7: B,C4: C,D3: D2,E2: E,F: F5,G3: G2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) ) @ C4 @ ( product_Pair @ D2 @ ( product_prod @ E @ ( product_prod @ F5 @ G2 ) ) @ D3 @ ( product_Pair @ E @ ( product_prod @ F5 @ G2 ) @ E2 @ ( product_Pair @ F5 @ G2 @ F @ G3 ) ) ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct7
thf(fact_105_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B7: B] :
            ( Y
           != ( product_Pair @ A @ B @ A5 @ B7 ) ) ) )).

% old.prod.exhaust
thf(fact_106_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B7: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B7 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_107_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_108_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B3 ) )
          = ( B3
            = ( uminus_uminus @ A @ A3 ) ) ) ) )).

% equation_minus_iff
thf(fact_109_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B3 )
          = ( ( uminus_uminus @ A @ B3 )
            = A3 ) ) ) )).

% minus_equation_iff
thf(fact_110_lset__eq__empty,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lset_eq_empty
thf(fact_111_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A3: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( F1 @ A3 @ B3 ) ) )).

% old.prod.rec
thf(fact_112_lset__lnull,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_lnull
thf(fact_113_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_114_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_115_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_116_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_117_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_118_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( insert @ A @ ( the_elem @ A @ A7 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_119_is__singletonI,axiom,(
    ! [A: $tType,X2: A] :
      ( is_singleton @ A @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_120_lset__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A )
      = ( coinductive_gen_lset @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_code
thf(fact_121_top__conj_I1_J,axiom,(
    ! [A: $tType,X2: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X2 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_122_is__singletonI_H,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( A2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X3: A,Y2: A] :
            ( ( member @ A @ X3 @ A2 )
           => ( ( member @ A @ Y2 @ A2 )
             => ( X3 = Y2 ) ) )
       => ( is_singleton @ A @ A2 ) ) ) )).

% is_singletonI'
thf(fact_123_is__singletonE,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( is_singleton @ A @ A2 )
     => ~ ( ! [X3: A] :
              ( A2
             != ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_124_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A7: ( set @ A )] :
          ? [X: A] :
            ( A7
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_125_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X2: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X2 ) )
      = P ) )).

% top_conj(2)
thf(fact_126_prod__set__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y: B] :
      ( ( basic_snds @ A @ B @ ( product_Pair @ A @ B @ X2 @ Y ) )
      = ( insert @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) ) )).

% prod_set_simps(2)
thf(fact_127_prod__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: B] :
      ( ( basic_fsts @ A @ B @ ( product_Pair @ A @ B @ X2 @ Y ) )
      = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% prod_set_simps(1)
thf(fact_128_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_129_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A3: B,B3: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A3 @ B3 ) )
      = ( C2 @ A3 @ B3 ) ) )).

% internal_case_prod_conv
thf(fact_130_f__simps_I2_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ( ( coinductive_lhd @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) )
      = Na ) )).

% f_simps(2)
thf(fact_131_subset__Compl__singleton,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B3 @ A2 ) ) ) )).

% subset_Compl_singleton
thf(fact_132_totally__bounded__empty,axiom,(
    ! [A: $tType] :
      ( ( topolo47006728_space @ A @ ( type2 @ A ) )
     => ( topolo406746546ounded @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% totally_bounded_empty
thf(fact_133_pairwise__singleton,axiom,(
    ! [A: $tType,P: ( A > A > $o ),A2: A] :
      ( pairwise @ A @ P @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_134_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ X2 @ X2 ) ) )).

% order_refl
thf(fact_135_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A2 )
       => ( A2 = B4 ) ) ) )).

% subset_antisym
thf(fact_136_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A2 )
         => ( member @ A @ X3 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B4 ) ) )).

% subsetI
thf(fact_137_compl__le__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% compl_le_compl_iff
thf(fact_138_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B3 ) ) ) )).

% neg_le_iff_le
thf(fact_139_empty__subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) )).

% empty_subsetI
thf(fact_140_subset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_141_insert__subset,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A2 ) @ B4 )
      = ( ( member @ A @ X2 @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ B4 ) ) ) )).

% insert_subset
thf(fact_142_Compl__anti__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) ) ) )).

% Compl_anti_mono
thf(fact_143_Compl__subset__Compl__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ B4 @ A2 ) ) )).

% Compl_subset_Compl_iff
thf(fact_144_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B3: A,A3: A,A2: ( set @ A )] :
      ( ( ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A3 @ A2 ) )
      = ( ( A3 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_145_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),B3: A] :
      ( ( ( insert @ A @ A3 @ A2 )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_146_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_147_subrelI,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ! [X3: A,Y2: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y2 ) @ S2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) )).

% subrelI
thf(fact_148_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B3: A,A3: A] :
          ( ! [A5: A,B7: A] :
              ( ( ord_less_eq @ A @ A5 @ B7 )
             => ( P @ A5 @ B7 ) )
         => ( ( ( P @ B3 @ A3 )
             => ( P @ A3 @ B3 ) )
           => ( P @ A3 @ B3 ) ) ) ) )).

% wlog_linorder_le
thf(fact_149_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_150_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_151_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) )).

% bot.extremum
thf(fact_152_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_153_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_154_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_155_compl__le__swap2,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ Y ) ) ) )).

% compl_le_swap2
thf(fact_156_compl__le__swap1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X2 ) )
         => ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ Y ) ) ) ) )).

% compl_le_swap1
thf(fact_157_compl__mono,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X2 ) ) ) ) )).

% compl_mono
thf(fact_158_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_imp_neg_le
thf(fact_159_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B3 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ A3 ) ) ) )).

% minus_le_iff
thf(fact_160_le__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ B3 ) )
          = ( ord_less_eq @ A @ B3 @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_minus_iff
thf(fact_161_subset__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_162_rev__finite__subset,axiom,(
    ! [A: $tType,B4: ( set @ A ),A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
       => ( finite_finite2 @ A @ A2 ) ) ) )).

% rev_finite_subset
thf(fact_163_infinite__super,axiom,(
    ! [A: $tType,S: ( set @ A ),T2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
     => ( ~ ( finite_finite2 @ A @ S )
       => ~ ( finite_finite2 @ A @ T2 ) ) ) )).

% infinite_super
thf(fact_164_finite__subset,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( finite_finite2 @ A @ B4 )
       => ( finite_finite2 @ A @ A2 ) ) ) )).

% finite_subset
thf(fact_165_subset__insertI2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),B3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% subset_insertI2
thf(fact_166_subset__insertI,axiom,(
    ! [A: $tType,B4: ( set @ A ),A3: A] :
      ( ord_less_eq @ ( set @ A ) @ B4 @ ( insert @ A @ A3 @ B4 ) ) )).

% subset_insertI
thf(fact_167_subset__insert,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X2 @ B4 ) )
        = ( ord_less_eq @ ( set @ A ) @ A2 @ B4 ) ) ) )).

% subset_insert
thf(fact_168_Set_Oinsert__mono,axiom,(
    ! [A: $tType,C5: ( set @ A ),D4: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ D4 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A3 @ C5 ) @ ( insert @ A @ A3 @ D4 ) ) ) )).

% Set.insert_mono
thf(fact_169_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) ) ) ) )).

% Collect_mono_iff
thf(fact_170_pairwise__subset,axiom,(
    ! [A: $tType,P: ( A > A > $o ),S: ( set @ A ),T2: ( set @ A )] :
      ( ( pairwise @ A @ P @ S )
     => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
       => ( pairwise @ A @ P @ T2 ) ) ) )).

% pairwise_subset
thf(fact_171_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ~ ( member @ A @ C2 @ A2 ) ) ) )).

% contra_subsetD
thf(fact_172_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( set @ A ),Z: ( set @ A )] : ( Y3 = Z ) )
      = ( ^ [A7: ( set @ A ),B8: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) )).

% set_eq_subset
thf(fact_173_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),C5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C5 ) ) ) )).

% subset_trans
thf(fact_174_pairwise__def,axiom,(
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R2: ( A > A > $o ),S3: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ S3 )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ S3 )
               => ( ( X != Y4 )
                 => ( R2 @ X @ Y4 ) ) ) ) ) ) )).

% pairwise_def
thf(fact_175_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_176_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_177_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% rev_subsetD
thf(fact_178_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B8: ( set @ A )] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A7 )
           => ( member @ A @ T3 @ B8 ) ) ) ) )).

% subset_iff
thf(fact_179_set__rev__mp,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ X2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% set_rev_mp
thf(fact_180_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( A2 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A2 ) ) )).

% equalityD2
thf(fact_181_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( A2 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B4 ) ) )).

% equalityD1
thf(fact_182_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B8: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ A7 )
           => ( member @ A @ X @ B8 ) ) ) ) )).

% subset_eq
thf(fact_183_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( A2 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A2 ) ) ) )).

% equalityE
thf(fact_184_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetCE
thf(fact_185_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetD
thf(fact_186_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( member @ A @ X2 @ A2 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% in_mono
thf(fact_187_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( member @ A @ X2 @ A2 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% set_mp
thf(fact_188_totally__bounded__subset,axiom,(
    ! [A: $tType] :
      ( ( topolo47006728_space @ A @ ( type2 @ A ) )
     => ! [S: ( set @ A ),T2: ( set @ A )] :
          ( ( topolo406746546ounded @ A @ S )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S )
           => ( topolo406746546ounded @ A @ T2 ) ) ) ) )).

% totally_bounded_subset
thf(fact_189_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B3 )
           => ( A3 = B3 ) ) ) ) )).

% dual_order.antisym
thf(fact_190_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_191_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A3: A,B3: A] :
          ( ! [A5: A,B7: A] :
              ( ( ord_less_eq @ A @ A5 @ B7 )
             => ( P @ A5 @ B7 ) )
         => ( ! [A5: A,B7: A] :
                ( ( P @ B7 @ A5 )
               => ( P @ A5 @ B7 ) )
           => ( P @ A3 @ B3 ) ) ) ) )).

% linorder_wlog
thf(fact_192_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_193_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z2 )
           => ( ord_less_eq @ A @ X2 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_194_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A3 )
           => ( A3 = B3 ) ) ) ) )).

% order_class.order.antisym
thf(fact_195_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_196_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( A3 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_197_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A] :
          ( ( ord_less_eq @ A @ Y @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y )
            = ( X2 = Y ) ) ) ) )).

% antisym_conv
thf(fact_198_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_199_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% order.trans
thf(fact_200_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y )
         => ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% le_cases
thf(fact_201_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( X2 = Y )
         => ( ord_less_eq @ A @ X2 @ Y ) ) ) )).

% eq_refl
thf(fact_202_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
          | ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% linear
thf(fact_203_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X2 )
           => ( X2 = Y ) ) ) ) )).

% antisym
thf(fact_204_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y3: A,Z: A] : ( Y3 = Z ) )
        = ( ^ [X: A,Y4: A] :
              ( ( ord_less_eq @ A @ X @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X ) ) ) ) ) )).

% eq_iff
thf(fact_205_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B3: A,F2: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ( F2 @ B3 )
              = C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A3 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_206_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B3: B,C2: B] :
          ( ( A3
            = ( F2 @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_207_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B3: A,F2: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ C @ ( F2 @ B3 ) @ C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y2 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A3 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_208_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B3: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F2 @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y2 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_209_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F6: ( A > B ),G4: ( A > B )] :
            ! [X: A] :
              ( ord_less_eq @ B @ ( F6 @ X ) @ ( G4 @ X ) ) ) ) ) )).

% le_fun_def
thf(fact_210_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G: ( A > B )] :
          ( ! [X3: A] :
              ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) )).

% le_funI
thf(fact_211_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funE
thf(fact_212_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funD
thf(fact_213_llist_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ A3 )
     => ( member @ A @ ( coinductive_lhd @ A @ A3 ) @ ( coinductive_lset @ A @ A3 ) ) ) )).

% llist.set_sel(1)
thf(fact_214_pairwise__empty,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) )).

% pairwise_empty
thf(fact_215_pairwise__insert,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X2: A,S2: ( set @ A )] :
      ( ( pairwise @ A @ R @ ( insert @ A @ X2 @ S2 ) )
      = ( ! [Y4: A] :
            ( ( ( member @ A @ Y4 @ S2 )
              & ( Y4 != X2 ) )
           => ( ( R @ X2 @ Y4 )
              & ( R @ Y4 @ X2 ) ) )
        & ( pairwise @ A @ R @ S2 ) ) ) )).

% pairwise_insert
thf(fact_216_subset__singletonD,axiom,(
    ! [A: $tType,A2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ( A2
          = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_217_subset__singleton__iff,axiom,(
    ! [A: $tType,X5: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X5 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X5
          = ( bot_bot @ ( set @ A ) ) )
        | ( X5
          = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_218_subset__Compl__self__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_Compl_self_eq
thf(fact_219_finite__subset__induct,axiom,(
    ! [A: $tType,F4: ( set @ A ),A2: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( ( ord_less_eq @ ( set @ A ) @ F4 @ A2 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A,F3: ( set @ A )] :
                ( ( finite_finite2 @ A @ F3 )
               => ( ( member @ A @ A5 @ A2 )
                 => ( ~ ( member @ A @ A5 @ F3 )
                   => ( ( P @ F3 )
                     => ( P @ ( insert @ A @ A5 @ F3 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) )).

% finite_subset_induct
thf(fact_220_insert__subsetI,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),X5: ( set @ A )] :
      ( ( member @ A @ X2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ X5 @ A2 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ X5 ) @ A2 ) ) ) )).

% insert_subsetI
thf(fact_221_subset__emptyI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X3: A] :
          ~ ( member @ A @ X3 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_222_finite__remove__induct,axiom,(
    ! [A: $tType,B4: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ B4 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A4: ( set @ A )] :
              ( ( finite_finite2 @ A @ A4 )
             => ( ( A4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A4 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A4 ) ) ) ) )
         => ( P @ B4 ) ) ) ) )).

% finite_remove_induct
thf(fact_223_remove__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),B4: ( set @ A )] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite2 @ A @ B4 )
         => ( P @ B4 ) )
       => ( ! [A4: ( set @ A )] :
              ( ( finite_finite2 @ A @ A4 )
             => ( ( A4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
                 => ( ! [X4: A] :
                        ( ( member @ A @ X4 @ A4 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A4 ) ) ) ) )
         => ( P @ B4 ) ) ) ) )).

% remove_induct
thf(fact_224_minus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),B8: ( A > B ),X: A] :
              ( minus_minus @ B @ ( A7 @ X ) @ ( B8 @ X ) ) ) ) ) )).

% minus_apply
thf(fact_225_DiffI,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) ) ) )).

% DiffI
thf(fact_226_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) )
      = ( ( member @ A @ C2 @ A2 )
        & ~ ( member @ A @ C2 @ B4 ) ) ) )).

% Diff_iff
thf(fact_227_Diff__idemp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) @ B4 )
      = ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) )).

% Diff_idemp
thf(fact_228_minus__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A3 @ B3 ) )
          = ( minus_minus @ A @ B3 @ A3 ) ) ) )).

% minus_diff_eq
thf(fact_229_Diff__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = A2 ) )).

% Diff_empty
thf(fact_230_empty__Diff,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_231_Diff__cancel,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ A2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_232_finite__Diff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) ) )).

% finite_Diff
thf(fact_233_finite__Diff2,axiom,(
    ! [A: $tType,B4: ( set @ A ),A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ B4 )
     => ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) )
        = ( finite_finite2 @ A @ A2 ) ) ) )).

% finite_Diff2
thf(fact_234_Diff__insert0,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A2 )
     => ( ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ X2 @ B4 ) )
        = ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) ) )).

% Diff_insert0
thf(fact_235_insert__Diff1,axiom,(
    ! [A: $tType,X2: A,B4: ( set @ A ),A2: ( set @ A )] :
      ( ( member @ A @ X2 @ B4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A2 ) @ B4 )
        = ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) ) )).

% insert_Diff1
thf(fact_236_Diff__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_UNIV
thf(fact_237_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A2 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B4 ) ) )).

% Diff_eq_empty_iff
thf(fact_238_insert__Diff__single,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( insert @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A3 @ A2 ) ) )).

% insert_Diff_single
thf(fact_239_finite__Diff__insert,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A,B4: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ B4 ) ) )
      = ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) ) )).

% finite_Diff_insert
thf(fact_240_double__diff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A ),C5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ( minus_minus @ ( set @ A ) @ B4 @ ( minus_minus @ ( set @ A ) @ C5 @ A2 ) )
          = A2 ) ) ) )).

% double_diff
thf(fact_241_Diff__subset,axiom,(
    ! [A: $tType,A2: ( set @ A ),B4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) @ A2 ) )).

% Diff_subset
thf(fact_242_Diff__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),C5: ( set @ A ),D4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C5 )
     => ( ( ord_less_eq @ ( set @ A ) @ D4 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) @ ( minus_minus @ ( set @ A ) @ C5 @ D4 ) ) ) ) )).

% Diff_mono
thf(fact_243_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A,D: A] :
          ( ( ( minus_minus @ A @ A3 @ B3 )
            = ( minus_minus @ A @ C2 @ D ) )
         => ( ( ord_less_eq @ A @ A3 @ B3 )
            = ( ord_less_eq @ A @ C2 @ D ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_244_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B3 @ C2 ) ) ) ) )).

% diff_right_mono
thf(fact_245_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B3 ) ) ) ) )).

% diff_left_mono
thf(fact_246_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,D: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ D @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B3 @ D ) ) ) ) ) )).

% diff_mono
thf(fact_247_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A,D: A] :
          ( ( ( minus_minus @ A @ A3 @ B3 )
            = ( minus_minus @ A @ C2 @ D ) )
         => ( ( A3 = B3 )
            = ( C2 = D ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_248_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A3: A,C2: A,B3: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A3 @ C2 ) @ B3 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A3 @ B3 ) @ C2 ) ) ) )).

% diff_right_commute
thf(fact_249_DiffE,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) )
     => ~ ( ( member @ A @ C2 @ A2 )
         => ( member @ A @ C2 @ B4 ) ) ) )).

% DiffE
thf(fact_250_DiffD1,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) )
     => ( member @ A @ C2 @ A2 ) ) )).

% DiffD1
thf(fact_251_DiffD2,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) )
     => ~ ( member @ A @ C2 @ B4 ) ) )).

% DiffD2
thf(fact_252_fun__diff__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),B8: ( A > B ),X: A] :
              ( minus_minus @ B @ ( A7 @ X ) @ ( B8 @ X ) ) ) ) ) )).

% fun_diff_def
thf(fact_253_insert__Diff__if,axiom,(
    ! [A: $tType,X2: A,B4: ( set @ A ),A2: ( set @ A )] :
      ( ( ( member @ A @ X2 @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A2 ) @ B4 )
          = ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) )
      & ( ~ ( member @ A @ X2 @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X2 @ A2 ) @ B4 )
          = ( insert @ A @ X2 @ ( minus_minus @ ( set @ A ) @ A2 @ B4 ) ) ) ) ) )).

% insert_Diff_if

%----Type constructors (37)
thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( boolean_algebra @ A10 @ ( type2 @ A10 ) )
     => ( boolean_algebra @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order_top @ A10 @ ( type2 @ A10 ) )
     => ( order_top @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order_bot @ A10 @ ( type2 @ A10 ) )
     => ( order_bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( preorder @ A10 @ ( type2 @ A10 ) )
     => ( preorder @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order @ A10 @ ( type2 @ A10 ) )
     => ( order @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( top @ A10 @ ( type2 @ A10 ) )
     => ( top @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ord @ A10 @ ( type2 @ A10 ) )
     => ( ord @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( bot @ A10 @ ( type2 @ A10 ) )
     => ( bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( uminus @ A10 @ ( type2 @ A10 ) )
     => ( uminus @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( minus @ A10 @ ( type2 @ A10 ) )
     => ( minus @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_1,axiom,(
    ! [A9: $tType] :
      ( boolean_algebra @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_2,axiom,(
    ! [A9: $tType] :
      ( order_top @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_3,axiom,(
    ! [A9: $tType] :
      ( order_bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_4,axiom,(
    ! [A9: $tType] :
      ( preorder @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_5,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_6,axiom,(
    ! [A9: $tType] :
      ( order @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_7,axiom,(
    ! [A9: $tType] :
      ( top @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_8,axiom,(
    ! [A9: $tType] :
      ( ord @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_9,axiom,(
    ! [A9: $tType] :
      ( bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_10,axiom,(
    ! [A9: $tType] :
      ( uminus @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_11,axiom,(
    ! [A9: $tType] :
      ( minus @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_12,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_13,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_14,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_15,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_16,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_17,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_18,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_19,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_20,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_21,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_22,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_23,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( sum_sum @ A9 @ A10 ) @ ( type2 @ ( sum_sum @ A9 @ A10 ) ) ) ) )).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_24,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( option @ A9 ) @ ( type2 @ ( option @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_25,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( product_prod @ A9 @ A10 ) @ ( type2 @ ( product_prod @ A9 @ A10 ) ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ~ ( member @ node @ x @ nsa ) )).

%------------------------------------------------------------------------------
