%------------------------------------------------------------------------------
% File     : COM178^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 206
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__206.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  305 (   0 unit;  44 type;   0 defn)
%            Number of atoms       : 4286 ( 290 equality;2816 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 4179 ( 161   ~;  53   |;  82   &;3599   @)
%                                         (   0 <=>; 284  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  287 ( 287   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   48 (  44   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1150 (   2 sgn;1001   !;  68   ?;  37   ^)
%                                         (1150   :;  44  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:47:17.094
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_node,type,(
    node: $tType )).

%----Explicit typings (39)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oldistinct,type,(
    coindu351974385stinct: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OldropWhile,type,(
    coindu218763757pWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollexord,type,(
    coinductive_llexord: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olprefix,type,(
    coinductive_lprefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OltakeWhile,type,(
    coindu501562517eWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olzip,type,(
    coinductive_lzip: 
      !>[A: $tType,B: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > ( coinductive_llist @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Coinductive__List_Oord_Olsorted,type,(
    coinductive_lsorted: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oconnected,type,(
    koenig793108494nected: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > $o ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Oinv__imagep,type,(
    inv_imagep: 
      !>[B: $tType,A: $tType] :
        ( ( B > B > $o ) > ( A > B ) > A > A > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f____,type,(
    f: ( product_prod @ node @ ( set @ node ) ) > ( coinductive_llist @ node ) )).

thf(sy_v_graph,type,(
    graph: node > node > $o )).

thf(sy_v_n,type,(
    n: node )).

thf(sy_v_ns____,type,(
    ns: ( set @ node ) )).

%----Relevant facts (254)
thf(fact_0__092_060open_062lhd_A_If_A_In_M_Ans_J_J_A_092_060in_062_Alset_A_If_A_In_M_Ans_J_J_092_060close_062,axiom,
    ( member @ node @ ( coinductive_lhd @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) )).

% \<open>lhd (f (n, ns)) \<in> lset (f (n, ns))\<close>
thf(fact_1_ns__def,axiom,
    ( ns
    = ( bot_bot @ ( set @ node ) ) )).

% ns_def
thf(fact_2_f__simps_I2_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ( ( coinductive_lhd @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) )
      = Na ) )).

% f_simps(2)
thf(fact_3_f__simps_I1_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ~ ( coinductive_lnull @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) ) )).

% f_simps(1)
thf(fact_4_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X2 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% prod.inject
thf(fact_5_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( ( A2 = A3 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_6_connected,axiom,
    ( koenig793108494nected @ node @ graph )).

% connected
thf(fact_7_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P: ( product_prod @ A @ B )] :
    ? [X: A,Y: B] :
      ( P
      = ( product_Pair @ A @ B @ X @ Y ) ) )).

% surj_pair
thf(fact_8_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),P: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P2 @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P2 @ P ) ) )).

% prod_cases
thf(fact_9_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ~ ( ( A2 = A3 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_10_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A4: A,B4: B,C2: C] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) ) ) )).

% prod_cases3
thf(fact_11_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_12_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E2: E] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_13_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F ) @ D2 @ ( product_Pair @ E @ F @ E2 @ F2 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_14_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P2 @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P2 @ Prod ) ) )).

% old.prod.inducts
thf(fact_15_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y3: ( product_prod @ A @ B )] :
      ~ ( ! [A4: A,B4: B] :
            ( Y3
           != ( product_Pair @ A @ B @ A4 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_16_prod__induct7,axiom,(
    ! [G: $tType,F: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F,G2: G] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F @ G ) @ E2 @ ( product_Pair @ F @ G @ F2 @ G2 ) ) ) ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct7
thf(fact_17_prod__induct6,axiom,(
    ! [F: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F ) @ D2 @ ( product_Pair @ E @ F @ E2 @ F2 ) ) ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct6
thf(fact_18_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E2: E] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct5
thf(fact_19_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct4
thf(fact_20_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A4: A,B4: B,C2: C] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) )
     => ( P2 @ X3 ) ) )).

% prod_induct3
thf(fact_21_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F: $tType,G: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F,G2: G] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F @ G ) @ E2 @ ( product_Pair @ F @ G @ F2 @ G2 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_22_lset__eq__empty,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lset_eq_empty
thf(fact_23_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_24_llist_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( member @ A @ ( coinductive_lhd @ A @ A2 ) @ ( coinductive_lset @ A @ A2 ) ) ) )).

% llist.set_sel(1)
thf(fact_25_lset__lnull,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_lnull
thf(fact_26_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_27_all__not__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_28_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P2 @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_29_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X4: A] :
            ~ ( P2 @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_30_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X4: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_31_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_32_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C3: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C3 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C3 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_33_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_34_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_35_ex__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A5 ) )
      = ( A5
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_36_equals0I,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ! [Y: A] :
          ~ ( member @ A @ Y @ A5 )
     => ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_37_equals0D,axiom,(
    ! [A: $tType,A5: ( set @ A ),A2: A] :
      ( ( A5
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A5 ) ) )).

% equals0D
thf(fact_38_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_39_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_40_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_41_lset__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A )
      = ( coinductive_gen_lset @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_code
thf(fact_42_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A6: ( set @ A )] :
            ( A6
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_43_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P2 @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_46_ext,axiom,(
    ! [B: $tType,A: $tType,F3: ( A > B ),G3: ( A > B )] :
      ( ! [X: A] :
          ( ( F3 @ X )
          = ( G3 @ X ) )
     => ( F3 = G3 ) ) )).

% ext
thf(fact_47_lset__lmember,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
      = ( coinductive_lmember @ A @ X3 @ Xs ) ) )).

% lset_lmember
thf(fact_48_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P2
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_49_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_50_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R2: ( set @ ( product_prod @ A @ B ) ),S2: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R2 )
     => ( ( S2 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R2 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_51_lhd__lzip,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ B @ Ys )
       => ( ( coinductive_lhd @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) )
          = ( product_Pair @ A @ B @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ B @ Ys ) ) ) ) ) )).

% lhd_lzip
thf(fact_52_llist__set__induct,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),P2: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ~ ( coinductive_lnull @ A @ Xs2 )
           => ( P2 @ ( coinductive_lhd @ A @ Xs2 ) @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),Y: A] :
              ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ( member @ A @ Y @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
               => ( ( P2 @ Y @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P2 @ Y @ Xs2 ) ) ) )
         => ( P2 @ X3 @ Xs ) ) ) ) )).

% llist_set_induct
thf(fact_53_lnull__ldropWhile,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu218763757pWhile @ A @ P2 @ Xs ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
           => ( P2 @ X4 ) ) ) ) )).

% lnull_ldropWhile
thf(fact_54_lzip_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( ~ ( coinductive_lnull @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ~ ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.disc_iff(2)
thf(fact_55_lnull__lzip,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coinductive_lnull @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ B @ Ys ) ) ) )).

% lnull_lzip
thf(fact_56_ltl__lzip,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ B @ Ys )
       => ( ( coinductive_ltl @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) )
          = ( coinductive_lzip @ A @ B @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ B @ Ys ) ) ) ) ) )).

% ltl_lzip
thf(fact_57_lnull__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% lnull_ltlI
thf(fact_58_in__lset__ltlD,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ltlD
thf(fact_59_lzip_Odisc_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ B @ Ys )
       => ~ ( coinductive_lnull @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) ) ) ) )).

% lzip.disc(2)
thf(fact_60_lzip_Odisc_I1_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ B @ Ys ) )
     => ( coinductive_lnull @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) ) ) )).

% lzip.disc(1)
thf(fact_61_in__lset__ldropWhileD,axiom,(
    ! [A: $tType,X3: A,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coindu218763757pWhile @ A @ P2 @ Xs ) ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ldropWhileD
thf(fact_62_ldropWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P2: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P2 @ X )
              = ( Q @ X ) ) )
       => ( ( coindu218763757pWhile @ A @ P2 @ Xs )
          = ( coindu218763757pWhile @ A @ Q @ Ys ) ) ) ) )).

% ldropWhile_cong
thf(fact_63_llist_Oset__sel_I2_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),X3: A] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ A2 ) ) )
       => ( member @ A @ X3 @ ( coinductive_lset @ A @ A2 ) ) ) ) )).

% llist.set_sel(2)
thf(fact_64_lset__lzipD2,axiom,(
    ! [A: $tType,B: $tType,X3: A,Y3: B,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ ( coinductive_lset @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ B @ Y3 @ ( coinductive_lset @ B @ Ys ) ) ) )).

% lset_lzipD2
thf(fact_65_lset__lzipD1,axiom,(
    ! [B: $tType,A: $tType,X3: A,Y3: B,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ ( coinductive_lset @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) ) ) )).

% lset_lzipD1
thf(fact_66_llist_Oexpand,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),Llist2: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Llist )
        = ( coinductive_lnull @ A @ Llist2 ) )
     => ( ( ~ ( coinductive_lnull @ A @ Llist )
         => ( ~ ( coinductive_lnull @ A @ Llist2 )
           => ( ( ( coinductive_lhd @ A @ Llist )
                = ( coinductive_lhd @ A @ Llist2 ) )
              & ( ( coinductive_ltl @ A @ Llist )
                = ( coinductive_ltl @ A @ Llist2 ) ) ) ) )
       => ( Llist = Llist2 ) ) ) )).

% llist.expand
thf(fact_67_llist_Ocoinduct,axiom,(
    ! [A: $tType,R2: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist2: ( coinductive_llist @ A )] :
      ( ( R2 @ Llist @ Llist2 )
     => ( ! [Llist3: ( coinductive_llist @ A ),Llist4: ( coinductive_llist @ A )] :
            ( ( R2 @ Llist3 @ Llist4 )
           => ( ( ( coinductive_lnull @ A @ Llist3 )
                = ( coinductive_lnull @ A @ Llist4 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist3 )
               => ( ~ ( coinductive_lnull @ A @ Llist4 )
                 => ( ( ( coinductive_lhd @ A @ Llist3 )
                      = ( coinductive_lhd @ A @ Llist4 ) )
                    & ( R2 @ ( coinductive_ltl @ A @ Llist3 ) @ ( coinductive_ltl @ A @ Llist4 ) ) ) ) ) ) )
       => ( Llist = Llist2 ) ) ) )).

% llist.coinduct
thf(fact_68_llist_Ocoinduct__strong,axiom,(
    ! [A: $tType,R2: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist2: ( coinductive_llist @ A )] :
      ( ( R2 @ Llist @ Llist2 )
     => ( ! [Llist3: ( coinductive_llist @ A ),Llist4: ( coinductive_llist @ A )] :
            ( ( R2 @ Llist3 @ Llist4 )
           => ( ( ( coinductive_lnull @ A @ Llist3 )
                = ( coinductive_lnull @ A @ Llist4 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist3 )
               => ( ~ ( coinductive_lnull @ A @ Llist4 )
                 => ( ( ( coinductive_lhd @ A @ Llist3 )
                      = ( coinductive_lhd @ A @ Llist4 ) )
                    & ( ( R2 @ ( coinductive_ltl @ A @ Llist3 ) @ ( coinductive_ltl @ A @ Llist4 ) )
                      | ( ( coinductive_ltl @ A @ Llist3 )
                        = ( coinductive_ltl @ A @ Llist4 ) ) ) ) ) ) ) )
       => ( Llist = Llist2 ) ) ) )).

% llist.coinduct_strong
thf(fact_69_lhd__ldropWhile__in__lset,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( coinductive_lset @ A @ Xs ) )
          & ~ ( P2 @ X5 ) )
     => ( member @ A @ ( coinductive_lhd @ A @ ( coindu218763757pWhile @ A @ P2 @ Xs ) ) @ ( coinductive_lset @ A @ Xs ) ) ) )).

% lhd_ldropWhile_in_lset
thf(fact_70_lhd__ldropWhile,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( coinductive_lset @ A @ Xs ) )
          & ~ ( P2 @ X5 ) )
     => ~ ( P2 @ ( coinductive_lhd @ A @ ( coindu218763757pWhile @ A @ P2 @ Xs ) ) ) ) )).

% lhd_ldropWhile
thf(fact_71_lzip_Octr_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ B @ Ys )
       => ( ( coinductive_lzip @ A @ B @ Xs @ Ys )
          = ( coinductive_LCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ B @ Ys ) ) @ ( coinductive_lzip @ A @ B @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ B @ Ys ) ) ) ) ) ) )).

% lzip.ctr(2)
thf(fact_72_unfold__llist__id,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu1441602521_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_lnull @ A ) @ ( coinductive_lhd @ A ) @ ( coinductive_ltl @ A ) @ Xs )
      = Xs ) )).

% unfold_llist_id
thf(fact_73_ldistinct__lhdD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( member @ A @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) )).

% ldistinct_lhdD
thf(fact_74_ldistinct__coinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( X6 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( X6 @ Xs2 )
           => ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ~ ( member @ A @ ( coinductive_lhd @ A @ Xs2 ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
                & ( ( X6 @ ( coinductive_ltl @ A @ Xs2 ) )
                  | ( coindu351974385stinct @ A @ ( coinductive_ltl @ A @ Xs2 ) ) ) ) ) )
       => ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_coinduct
thf(fact_75_llist_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( coindu1381640503_llist @ B @ A )
      = ( ^ [F12: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist5: ( coinductive_llist @ A )] :
            ( if @ B @ ( coinductive_lnull @ A @ Llist5 ) @ F12 @ ( F22 @ ( coinductive_lhd @ A @ Llist5 ) @ ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) )).

% llist.case_eq_if
thf(fact_76_lhd__LCons__ltl,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ Llist )
     => ( ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) )
        = Llist ) ) )).

% lhd_LCons_ltl
thf(fact_77_ord_Olsorted__lhdD,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ~ ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs ) )
         => ( Less_eq @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) ) )).

% ord.lsorted_lhdD
thf(fact_78_ord_Olsorted__coinduct_H,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A ),Less_eq: ( A > A > $o )] :
      ( ( X6 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( X6 @ Xs2 )
           => ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs2 ) )
               => ( ( Less_eq @ ( coinductive_lhd @ A @ Xs2 ) @ ( coinductive_lhd @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
                  & ( ( X6 @ ( coinductive_ltl @ A @ Xs2 ) )
                    | ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_ltl @ A @ Xs2 ) ) ) ) ) ) )
       => ( coinductive_lsorted @ A @ Less_eq @ Xs ) ) ) )).

% ord.lsorted_coinduct'
thf(fact_79_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_80_ldropWhile__LCons,axiom,(
    ! [A: $tType,P2: ( A > $o ),X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P2 @ X3 )
       => ( ( coindu218763757pWhile @ A @ P2 @ ( coinductive_LCons @ A @ X3 @ Xs ) )
          = ( coindu218763757pWhile @ A @ P2 @ Xs ) ) )
      & ( ~ ( P2 @ X3 )
       => ( ( coindu218763757pWhile @ A @ P2 @ ( coinductive_LCons @ A @ X3 @ Xs ) )
          = ( coinductive_LCons @ A @ X3 @ Xs ) ) ) ) )).

% ldropWhile_LCons
thf(fact_81_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B2: B,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B2 )
        = ( coinductive_LCons @ A @ X3 @ Xs ) )
      = ( ~ ( IS_LNIL @ B2 )
        & ( X3
          = ( LHD @ B2 ) )
        & ( Xs
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B2 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_82_unfold__llist_Odisc__iff_I1_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A2: A] :
      ( ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 ) )
      = ( P @ A2 ) ) )).

% unfold_llist.disc_iff(1)
thf(fact_83_unfold__llist_Odisc__iff_I2_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A2: A] :
      ( ( ~ ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 ) ) )
      = ( ~ ( P @ A2 ) ) ) )).

% unfold_llist.disc_iff(2)
thf(fact_84_ldistinct__LCons,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) )
      = ( ~ ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
        & ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_LCons
thf(fact_85_lzip__simps_I3_J,axiom,(
    ! [C: $tType,B: $tType,X3: C,Xs: ( coinductive_llist @ C ),Y3: B,Ys: ( coinductive_llist @ B )] :
      ( ( coinductive_lzip @ C @ B @ ( coinductive_LCons @ C @ X3 @ Xs ) @ ( coinductive_LCons @ B @ Y3 @ Ys ) )
      = ( coinductive_LCons @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X3 @ Y3 ) @ ( coinductive_lzip @ C @ B @ Xs @ Ys ) ) ) )).

% lzip_simps(3)
thf(fact_86_ldistinct__lzipI2,axiom,(
    ! [B: $tType,A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ B )] :
      ( ( coindu351974385stinct @ A @ Ys )
     => ( coindu351974385stinct @ ( product_prod @ B @ A ) @ ( coinductive_lzip @ B @ A @ Xs @ Ys ) ) ) )).

% ldistinct_lzipI2
thf(fact_87_ldistinct__lzipI1,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( coindu351974385stinct @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) ) ) )).

% ldistinct_lzipI1
thf(fact_88_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F23: ( A > ( coinductive_llist @ A ) > B ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F23 @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = ( F23 @ X21 @ X22 ) ) )).

% llist.simps(5)
thf(fact_89_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 )
        = ( coinductive_LCons @ B @ ( G21 @ A2 ) @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_90_ldistinct_OLCons,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ~ ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ( coindu351974385stinct @ A @ Xs )
       => ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) ) ) ) )).

% ldistinct.LCons
thf(fact_91_ord_OLCons__LCons,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X3: A,Y3: A,Xs: ( coinductive_llist @ A )] :
      ( ( Less_eq @ X3 @ Y3 )
     => ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y3 @ Xs ) )
       => ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) ) ) ) )).

% ord.LCons_LCons
thf(fact_92_ord_Olsorted__LCons__LCons,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X3: A,Y3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) )
      = ( ( Less_eq @ X3 @ Y3 )
        & ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) ) ) )).

% ord.lsorted_LCons_LCons
thf(fact_93_lzip__eq__LCons__conv,axiom,(
    ! [B: $tType,A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Z: ( product_prod @ A @ B ),Zs: ( coinductive_llist @ ( product_prod @ A @ B ) )] :
      ( ( ( coinductive_lzip @ A @ B @ Xs @ Ys )
        = ( coinductive_LCons @ ( product_prod @ A @ B ) @ Z @ Zs ) )
      = ( ? [X4: A,Xs3: ( coinductive_llist @ A ),Y4: B,Ys2: ( coinductive_llist @ B )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ X4 @ Xs3 ) )
            & ( Ys
              = ( coinductive_LCons @ B @ Y4 @ Ys2 ) )
            & ( Z
              = ( product_Pair @ A @ B @ X4 @ Y4 ) )
            & ( Zs
              = ( coinductive_lzip @ A @ B @ Xs3 @ Ys2 ) ) ) ) ) )).

% lzip_eq_LCons_conv
thf(fact_94_ord_Olsorted__LCons_H,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X3 @ Xs ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( Less_eq @ X3 @ ( coinductive_lhd @ A @ Xs ) )
          & ( coinductive_lsorted @ A @ Less_eq @ Xs ) ) ) ) )).

% ord.lsorted_LCons'
thf(fact_95_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X4: A,Xs3: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X4 @ Xs3 ) ) ) ) )).

% not_lnull_conv
thf(fact_96_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X21 @ X22 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_97_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_98_lset__intros_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),X7: A] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X7 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_99_lset__intros_I1_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_100_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X3: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_101_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_102_lset__cases,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs4: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X3 @ Xs4 ) )
       => ~ ( ! [X8: A,Xs4: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X8 @ Xs4 ) )
               => ~ ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs4 ) ) ) ) ) ) )).

% lset_cases
thf(fact_103_lset__induct,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),P2: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P2 @ ( coinductive_LCons @ A @ X3 @ Xs2 ) )
       => ( ! [X8: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( X3 != X8 )
               => ( ( P2 @ Xs2 )
                 => ( P2 @ ( coinductive_LCons @ A @ X8 @ Xs2 ) ) ) ) )
         => ( P2 @ Xs ) ) ) ) )).

% lset_induct
thf(fact_104_lset__induct_H,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),P2: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P2 @ ( coinductive_LCons @ A @ X3 @ Xs2 ) )
       => ( ! [X8: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( P2 @ Xs2 )
               => ( P2 @ ( coinductive_LCons @ A @ X8 @ Xs2 ) ) ) )
         => ( P2 @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_105_llist_Oset__cases,axiom,(
    ! [A: $tType,E3: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E3 @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z2: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E3 @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E3 @ ( coinductive_lset @ A @ Z2 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_106_llist_Oset__induct,axiom,(
    ! [A: $tType,X3: A,A2: ( coinductive_llist @ A ),P2: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
            ( P2 @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( coinductive_llist @ A ),Xa: A] :
              ( ( member @ A @ Xa @ ( coinductive_lset @ A @ Z2 ) )
             => ( ( P2 @ Xa @ Z2 )
               => ( P2 @ Xa @ ( coinductive_LCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P2 @ X3 @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_107_ltl__simps_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_ltl @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X22 ) )).

% ltl_simps(2)
thf(fact_108_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_109_ldistinct__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( coindu351974385stinct @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% ldistinct_ltlI
thf(fact_110_ord_Olsorted__ltlI,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ Xs )
     => ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% ord.lsorted_ltlI
thf(fact_111_unfold__llist_Odisc_I1_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ( P @ A2 )
     => ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 ) ) ) )).

% unfold_llist.disc(1)
thf(fact_112_unfold__llist_Odisc_I2_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P @ A2 )
     => ~ ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 ) ) ) )).

% unfold_llist.disc(2)
thf(fact_113_unfold__llist_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P @ A2 )
     => ( ( coinductive_ltl @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 ) )
        = ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) )).

% unfold_llist.simps(4)
thf(fact_114_unfold__llist_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P @ A2 )
     => ( ( coinductive_lhd @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 ) )
        = ( G21 @ A2 ) ) ) )).

% unfold_llist.simps(3)
thf(fact_115_lmember__code_I2_J,axiom,(
    ! [A: $tType,X3: A,Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X3 @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( X3 = Y3 )
        | ( coinductive_lmember @ A @ X3 @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_116_lzip_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coinductive_lzip @ A @ B )
      = ( ^ [Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ B )] :
            ( if @ ( coinductive_llist @ ( product_prod @ A @ B ) )
            @ ( ( coinductive_lnull @ A @ Xs5 )
              | ( coinductive_lnull @ B @ Ys3 ) )
            @ ( coinductive_LNil @ ( product_prod @ A @ B ) )
            @ ( coinductive_LCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( coinductive_lhd @ A @ Xs5 ) @ ( coinductive_lhd @ B @ Ys3 ) ) @ ( coinductive_lzip @ A @ B @ ( coinductive_ltl @ A @ Xs5 ) @ ( coinductive_ltl @ B @ Ys3 ) ) ) ) ) ) )).

% lzip.code
thf(fact_117_llist_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F1: B,F23: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( P2 @ ( coindu1381640503_llist @ B @ A @ F1 @ F23 @ Llist ) )
      = ( ( ( Llist
            = ( coinductive_LNil @ A ) )
         => ( P2 @ F1 ) )
        & ( ( Llist
            = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) )
         => ( P2 @ ( F23 @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) ) ) )).

% llist.split_sel
thf(fact_118_llist_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F1: B,F23: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( P2 @ ( coindu1381640503_llist @ B @ A @ F1 @ F23 @ Llist ) )
      = ( ~ ( ( ( Llist
                = ( coinductive_LNil @ A ) )
              & ~ ( P2 @ F1 ) )
            | ( ( Llist
                = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) )
              & ~ ( P2 @ ( F23 @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) ) ) ) )).

% llist.split_sel_asm
thf(fact_119_ltakeWhile_Octr_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P2 @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coindu501562517eWhile @ A @ P2 @ Xs )
          = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Xs ) @ ( coindu501562517eWhile @ A @ P2 @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) ) )).

% ltakeWhile.ctr(2)
thf(fact_120_llexord__coinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),R: ( A > A > $o )] :
      ( ( X6 @ Xs @ Ys )
     => ( ! [Xs2: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A )] :
            ( ( X6 @ Xs2 @ Ys4 )
           => ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ Ys4 )
                & ( ~ ( coinductive_lnull @ A @ Ys4 )
                 => ( ( R @ ( coinductive_lhd @ A @ Xs2 ) @ ( coinductive_lhd @ A @ Ys4 ) )
                    | ( ( ( coinductive_lhd @ A @ Xs2 )
                        = ( coinductive_lhd @ A @ Ys4 ) )
                      & ( ( X6 @ ( coinductive_ltl @ A @ Xs2 ) @ ( coinductive_ltl @ A @ Ys4 ) )
                        | ( coinductive_llexord @ A @ R @ ( coinductive_ltl @ A @ Xs2 ) @ ( coinductive_ltl @ A @ Ys4 ) ) ) ) ) ) ) ) )
       => ( coinductive_llexord @ A @ R @ Xs @ Ys ) ) ) )).

% llexord_coinduct
thf(fact_121_ldistinct_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [X: A,Xs2: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ X @ Xs2 ) )
               => ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
                 => ~ ( coindu351974385stinct @ A @ Xs2 ) ) ) ) ) ) )).

% ldistinct.cases
thf(fact_122_llexord__refl,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ Xs @ Xs ) )).

% llexord_refl
thf(fact_123_ltakeWhile__LNil,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( coindu501562517eWhile @ A @ P2 @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltakeWhile_LNil
thf(fact_124_llexord__LCons__LCons,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X3: A,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( ( X3 = Y3 )
          & ( coinductive_llexord @ A @ R @ Xs @ Ys ) )
        | ( R @ X3 @ Y3 ) ) ) )).

% llexord_LCons_LCons
thf(fact_125_ldistinct__LNil__code,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct_LNil_code
thf(fact_126_llexord__code_I1_J,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ ( coinductive_LNil @ A ) @ Ys ) )).

% llexord_code(1)
thf(fact_127_llexord__LNil__right,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),R: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_llexord @ A @ R @ Xs @ Ys )
        = ( coinductive_lnull @ A @ Xs ) ) ) )).

% llexord_LNil_right
thf(fact_128_ldropWhile__LNil,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( coindu218763757pWhile @ A @ P2 @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ldropWhile_LNil
thf(fact_129_ltakeWhile__LCons,axiom,(
    ! [A: $tType,P2: ( A > $o ),X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P2 @ X3 )
       => ( ( coindu501562517eWhile @ A @ P2 @ ( coinductive_LCons @ A @ X3 @ Xs ) )
          = ( coinductive_LCons @ A @ X3 @ ( coindu501562517eWhile @ A @ P2 @ Xs ) ) ) )
      & ( ~ ( P2 @ X3 )
       => ( ( coindu501562517eWhile @ A @ P2 @ ( coinductive_LCons @ A @ X3 @ Xs ) )
          = ( coinductive_LNil @ A ) ) ) ) )).

% ltakeWhile_LCons
thf(fact_130_ltakeWhile_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ( P2 @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(2)
thf(fact_131_ltakeWhile_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(1)
thf(fact_132_lnull__ltakeWhile,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lnull_ltakeWhile
thf(fact_133_lzip__simps_I2_J,axiom,(
    ! [D: $tType,C: $tType,Xs: ( coinductive_llist @ C )] :
      ( ( coinductive_lzip @ C @ D @ Xs @ ( coinductive_LNil @ D ) )
      = ( coinductive_LNil @ ( product_prod @ C @ D ) ) ) )).

% lzip_simps(2)
thf(fact_134_lzip__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Ys: ( coinductive_llist @ B )] :
      ( ( coinductive_lzip @ A @ B @ ( coinductive_LNil @ A ) @ Ys )
      = ( coinductive_LNil @ ( product_prod @ A @ B ) ) ) )).

% lzip_simps(1)
thf(fact_135_llexord__code_I2_J,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X3: A,Xs: ( coinductive_llist @ A )] :
      ~ ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LNil @ A ) ) )).

% llexord_code(2)
thf(fact_136_llexord_Ocases,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A1: ( coinductive_llist @ A ),A22: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ A1 @ A22 )
     => ( ! [Xs2: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A ),X: A] :
            ( ( A1
              = ( coinductive_LCons @ A @ X @ Xs2 ) )
           => ( ( A22
                = ( coinductive_LCons @ A @ X @ Ys4 ) )
             => ~ ( coinductive_llexord @ A @ R @ Xs2 @ Ys4 ) ) )
       => ( ! [X: A] :
              ( ? [Xs2: ( coinductive_llist @ A )] :
                  ( A1
                  = ( coinductive_LCons @ A @ X @ Xs2 ) )
             => ! [Y: A] :
                  ( ? [Ys4: ( coinductive_llist @ A )] :
                      ( A22
                      = ( coinductive_LCons @ A @ Y @ Ys4 ) )
                 => ~ ( R @ X @ Y ) ) )
         => ~ ( ( A1
                = ( coinductive_LNil @ A ) )
             => ! [Ys4: ( coinductive_llist @ A )] : ( A22 != Ys4 ) ) ) ) ) )).

% llexord.cases
thf(fact_137_llexord_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llexord @ A )
      = ( ^ [R3: ( A > A > $o ),A12: ( coinductive_llist @ A ),A23: ( coinductive_llist @ A )] :
            ( ? [Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),X4: A] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X4 @ Xs5 ) )
                & ( A23
                  = ( coinductive_LCons @ A @ X4 @ Ys3 ) )
                & ( coinductive_llexord @ A @ R3 @ Xs5 @ Ys3 ) )
            | ? [X4: A,Y4: A,Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X4 @ Xs5 ) )
                & ( A23
                  = ( coinductive_LCons @ A @ Y4 @ Ys3 ) )
                & ( R3 @ X4 @ Y4 ) )
            | ? [Ys3: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LNil @ A ) )
                & ( A23 = Ys3 ) ) ) ) ) )).

% llexord.simps
thf(fact_138_llexord_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),X3: ( coinductive_llist @ A ),Xa2: ( coinductive_llist @ A ),R: ( A > A > $o )] :
      ( ( X6 @ X3 @ Xa2 )
     => ( ! [X: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A )] :
            ( ( X6 @ X @ Xa )
           => ( ? [Xs6: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A ),Xb: A] :
                  ( ( X
                    = ( coinductive_LCons @ A @ Xb @ Xs6 ) )
                  & ( Xa
                    = ( coinductive_LCons @ A @ Xb @ Ys5 ) )
                  & ( ( X6 @ Xs6 @ Ys5 )
                    | ( coinductive_llexord @ A @ R @ Xs6 @ Ys5 ) ) )
              | ? [Xb: A,Y5: A,Xs6: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A )] :
                  ( ( X
                    = ( coinductive_LCons @ A @ Xb @ Xs6 ) )
                  & ( Xa
                    = ( coinductive_LCons @ A @ Y5 @ Ys5 ) )
                  & ( R @ Xb @ Y5 ) )
              | ? [Ys5: ( coinductive_llist @ A )] :
                  ( ( X
                    = ( coinductive_LNil @ A ) )
                  & ( Xa = Ys5 ) ) ) )
       => ( coinductive_llexord @ A @ R @ X3 @ Xa2 ) ) ) )).

% llexord.coinduct
thf(fact_139_llexord__LNil,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ ( coinductive_LNil @ A ) @ Ys ) )).

% llexord_LNil
thf(fact_140_llexord__antisym,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ Xs @ Ys )
     => ( ( coinductive_llexord @ A @ R @ Ys @ Xs )
       => ( ! [A4: A,B4: A] :
              ( ( R @ A4 @ B4 )
             => ~ ( R @ B4 @ A4 ) )
         => ( Xs = Ys ) ) ) ) )).

% llexord_antisym
thf(fact_141_llexord__linear,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ! [X: A,Y: A] :
          ( ( R @ X @ Y )
          | ( X = Y )
          | ( R @ Y @ X ) )
     => ( ( coinductive_llexord @ A @ R @ Xs @ Ys )
        | ( coinductive_llexord @ A @ R @ Ys @ Xs ) ) ) )).

% llexord_linear
thf(fact_142_llexord__trans,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ Xs @ Ys )
     => ( ( coinductive_llexord @ A @ R @ Ys @ Zs )
       => ( ! [A4: A,B4: A,C2: A] :
              ( ( R @ A4 @ B4 )
             => ( ( R @ B4 @ C2 )
               => ( R @ A4 @ C2 ) ) )
         => ( coinductive_llexord @ A @ R @ Xs @ Zs ) ) ) ) )).

% llexord_trans
thf(fact_143_lzip__eq__LNil__conv,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( ( coinductive_lzip @ A @ B @ Xs @ Ys )
        = ( coinductive_LNil @ ( product_prod @ A @ B ) ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ( Ys
          = ( coinductive_LNil @ B ) ) ) ) )).

% lzip_eq_LNil_conv
thf(fact_144_ltakeWhile__eq__LNil__iff,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu501562517eWhile @ A @ P2 @ Xs )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
         != ( coinductive_LNil @ A ) )
       => ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile_eq_LNil_iff
thf(fact_145_ltakeWhile_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) )
     => ( ( coindu501562517eWhile @ A @ P2 @ Xs )
        = ( coinductive_LNil @ A ) ) ) )).

% ltakeWhile.ctr(1)
thf(fact_146_ltl__ltakeWhile,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( P2 @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coinductive_ltl @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
          = ( coindu501562517eWhile @ A @ P2 @ ( coinductive_ltl @ A @ Xs ) ) ) )
      & ( ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coinductive_ltl @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
          = ( coinductive_LNil @ A ) ) ) ) )).

% ltl_ltakeWhile
thf(fact_147_lset__ltakeWhileD,axiom,(
    ! [A: $tType,X3: A,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) ) )
     => ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
        & ( P2 @ X3 ) ) ) )).

% lset_ltakeWhileD
thf(fact_148_ltakeWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P2: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P2 @ X )
              = ( Q @ X ) ) )
       => ( ( coindu501562517eWhile @ A @ P2 @ Xs )
          = ( coindu501562517eWhile @ A @ Q @ Ys ) ) ) ) )).

% ltakeWhile_cong
thf(fact_149_ltakeWhile__all,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ! [X: A] :
          ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
         => ( P2 @ X ) )
     => ( ( coindu501562517eWhile @ A @ P2 @ Xs )
        = Xs ) ) )).

% ltakeWhile_all
thf(fact_150_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X4: A,Xs3: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X4 @ Xs3 ) ) ) ) )).

% neq_LNil_conv
thf(fact_151_llist_Oexhaust,axiom,(
    ! [A: $tType,Y3: ( coinductive_llist @ A )] :
      ( ( Y3
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y3
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_152_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_153_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_154_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_155_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist )
     => ( Llist
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_156_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist5: ( coinductive_llist @ A )] :
            ( Llist5
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_157_ltl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltl_simps(1)
thf(fact_158_llexord__LCons__less,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X3: A,Y3: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( R @ X3 @ Y3 )
     => ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y3 @ Ys ) ) ) )).

% llexord_LCons_less
thf(fact_159_llexord__LCons__eq,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X3: A] :
      ( ( coinductive_llexord @ A @ R @ Xs @ Ys )
     => ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ X3 @ Ys ) ) ) )).

% llexord_LCons_eq
thf(fact_160_llexord__LCons__left,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X3: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X3 @ Xs ) @ Ys )
      = ( ? [Y4: A,Ys2: ( coinductive_llist @ A )] :
            ( ( Ys
              = ( coinductive_LCons @ A @ Y4 @ Ys2 ) )
            & ( ( ( X3 = Y4 )
                & ( coinductive_llexord @ A @ R @ Xs @ Ys2 ) )
              | ( R @ X3 @ Y4 ) ) ) ) ) )).

% llexord_LCons_left
thf(fact_161_llexord__code_I3_J,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X3: A,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( R @ X3 @ Y3 )
        | ( ( X3 = Y3 )
          & ( coinductive_llexord @ A @ R @ Xs @ Ys ) ) ) ) )).

% llexord_code(3)
thf(fact_162_lnull__llexord,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),R: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_llexord @ A @ R @ Xs @ Ys ) ) )).

% lnull_llexord
thf(fact_163_ord_OLNil,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o )] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LNil @ A ) ) )).

% ord.LNil
thf(fact_164_ord_Olsorted__code_I1_J,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o )] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LNil @ A ) ) )).

% ord.lsorted_code(1)
thf(fact_165_llist_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F1: B,F23: ( A > ( coinductive_llist @ A ) > B )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F23 @ ( coinductive_LNil @ A ) )
      = F1 ) )).

% llist.simps(4)
thf(fact_166_ldistinct_OLNil,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct.LNil
thf(fact_167_unfold__llist_Octr_I1_J,axiom,(
    ! [A: $tType,B: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ( P @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P @ G21 @ G22 @ A2 )
        = ( coinductive_LNil @ B ) ) ) )).

% unfold_llist.ctr(1)
thf(fact_168_gen__lset__code_I1_J,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( coinductive_gen_lset @ A @ A5 @ ( coinductive_LNil @ A ) )
      = A5 ) )).

% gen_lset_code(1)
thf(fact_169_lmember__code_I1_J,axiom,(
    ! [A: $tType,X3: A] :
      ~ ( coinductive_lmember @ A @ X3 @ ( coinductive_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_170_ltakeWhile_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coindu501562517eWhile @ A )
      = ( ^ [P3: ( A > $o ),Xs5: ( coinductive_llist @ A )] :
            ( if @ ( coinductive_llist @ A )
            @ ( ( coinductive_lnull @ A @ Xs5 )
              | ~ ( P3 @ ( coinductive_lhd @ A @ Xs5 ) ) )
            @ ( coinductive_LNil @ A )
            @ ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Xs5 ) @ ( coindu501562517eWhile @ A @ P3 @ ( coinductive_ltl @ A @ Xs5 ) ) ) ) ) ) )).

% ltakeWhile.code
thf(fact_171_ltakeWhile_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P2 @ ( coinductive_lhd @ A @ Xs ) )
       => ~ ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) ) ) ) )).

% ltakeWhile.disc(2)
thf(fact_172_ltakeWhile_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P2 @ ( coinductive_lhd @ A @ Xs ) ) )
     => ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) ) ) )).

% ltakeWhile.disc(1)
thf(fact_173_lhd__ltakeWhile,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P2 @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coinductive_lhd @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
          = ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lhd_ltakeWhile
thf(fact_174_lset__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A @ ( coinductive_LNil @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% lset_LNil
thf(fact_175_ord_OSingleton,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X3: A] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) ) )).

% ord.Singleton
thf(fact_176_ord_Olsorted_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > $o ),X3: ( coinductive_llist @ A ),Less_eq: ( A > A > $o )] :
      ( ( X6 @ X3 )
     => ( ! [X: ( coinductive_llist @ A )] :
            ( ( X6 @ X )
           => ( ( X
                = ( coinductive_LNil @ A ) )
              | ? [Xa3: A] :
                  ( X
                  = ( coinductive_LCons @ A @ Xa3 @ ( coinductive_LNil @ A ) ) )
              | ? [Xa3: A,Y5: A,Xs6: ( coinductive_llist @ A )] :
                  ( ( X
                    = ( coinductive_LCons @ A @ Xa3 @ ( coinductive_LCons @ A @ Y5 @ Xs6 ) ) )
                  & ( Less_eq @ Xa3 @ Y5 )
                  & ( ( X6 @ ( coinductive_LCons @ A @ Y5 @ Xs6 ) )
                    | ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y5 @ Xs6 ) ) ) ) ) )
       => ( coinductive_lsorted @ A @ Less_eq @ X3 ) ) ) )).

% ord.lsorted.coinduct
thf(fact_177_ord_Olsorted_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lsorted @ A )
      = ( ^ [Less_eq2: ( A > A > $o ),A7: ( coinductive_llist @ A )] :
            ( ( A7
              = ( coinductive_LNil @ A ) )
            | ? [X4: A] :
                ( A7
                = ( coinductive_LCons @ A @ X4 @ ( coinductive_LNil @ A ) ) )
            | ? [X4: A,Y4: A,Xs5: ( coinductive_llist @ A )] :
                ( ( A7
                  = ( coinductive_LCons @ A @ X4 @ ( coinductive_LCons @ A @ Y4 @ Xs5 ) ) )
                & ( Less_eq2 @ X4 @ Y4 )
                & ( coinductive_lsorted @ A @ Less_eq2 @ ( coinductive_LCons @ A @ Y4 @ Xs5 ) ) ) ) ) ) )).

% ord.lsorted.simps
thf(fact_178_ord_Olsorted_Ocases,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ( ! [X: A] :
              ( A2
             != ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) )
         => ~ ( ! [X: A,Y: A,Xs2: ( coinductive_llist @ A )] :
                  ( ( A2
                    = ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs2 ) ) )
                 => ( ( Less_eq @ X @ Y )
                   => ~ ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y @ Xs2 ) ) ) ) ) ) ) ) )).

% ord.lsorted.cases
thf(fact_179_ord_Olsorted__code_I2_J,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X3: A] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) ) )).

% ord.lsorted_code(2)
thf(fact_180_lzip_Octr_I1_J,axiom,(
    ! [B: $tType,A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ B @ Ys ) )
     => ( ( coinductive_lzip @ A @ B @ Xs @ Ys )
        = ( coinductive_LNil @ ( product_prod @ A @ B ) ) ) ) )).

% lzip.ctr(1)
thf(fact_181_ldropWhile__eq__LNil__iff,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu218763757pWhile @ A @ P2 @ Xs )
        = ( coinductive_LNil @ A ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
           => ( P2 @ X4 ) ) ) ) )).

% ldropWhile_eq_LNil_iff
thf(fact_182_unfold__llist_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu1441602521_llist @ A @ B )
      = ( ^ [P4: ( A > $o ),G212: ( A > B ),G222: ( A > A ),A7: A] :
            ( if @ ( coinductive_llist @ B ) @ ( P4 @ A7 ) @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ ( G212 @ A7 ) @ ( coindu1441602521_llist @ A @ B @ P4 @ G212 @ G222 @ ( G222 @ A7 ) ) ) ) ) ) )).

% unfold_llist.code
thf(fact_183_ltl__unfold__llist,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),A2: B,LHD: ( B > A ),LTL: ( B > B )] :
      ( ( ( IS_LNIL @ A2 )
       => ( ( coinductive_ltl @ A @ ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ A2 ) )
          = ( coinductive_LNil @ A ) ) )
      & ( ~ ( IS_LNIL @ A2 )
       => ( ( coinductive_ltl @ A @ ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ A2 ) )
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ A2 ) ) ) ) ) )).

% ltl_unfold_llist
thf(fact_184_ltakeWhile_Osimps_I4_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P2 @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coinductive_ltl @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
          = ( coindu501562517eWhile @ A @ P2 @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) )).

% ltakeWhile.simps(4)
thf(fact_185_eq__LConsD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( Xs
        = ( coinductive_LCons @ A @ Y3 @ Ys ) )
     => ( ( Xs
         != ( coinductive_LNil @ A ) )
        & ( ( coinductive_lhd @ A @ Xs )
          = Y3 )
        & ( ( coinductive_ltl @ A @ Xs )
          = Ys ) ) ) )).

% eq_LConsD
thf(fact_186_llist_Oexhaust__sel,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
       != ( coinductive_LNil @ A ) )
     => ( Llist
        = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) )).

% llist.exhaust_sel
thf(fact_187_ldistinct_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > $o ),X3: ( coinductive_llist @ A )] :
      ( ( X6 @ X3 )
     => ( ! [X: ( coinductive_llist @ A )] :
            ( ( X6 @ X )
           => ( ( X
                = ( coinductive_LNil @ A ) )
              | ? [Xa3: A,Xs6: ( coinductive_llist @ A )] :
                  ( ( X
                    = ( coinductive_LCons @ A @ Xa3 @ Xs6 ) )
                  & ~ ( member @ A @ Xa3 @ ( coinductive_lset @ A @ Xs6 ) )
                  & ( ( X6 @ Xs6 )
                    | ( coindu351974385stinct @ A @ Xs6 ) ) ) ) )
       => ( coindu351974385stinct @ A @ X3 ) ) ) )).

% ldistinct.coinduct
thf(fact_188_ldistinct_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu351974385stinct @ A )
      = ( ^ [A7: ( coinductive_llist @ A )] :
            ( ( A7
              = ( coinductive_LNil @ A ) )
            | ? [X4: A,Xs5: ( coinductive_llist @ A )] :
                ( ( A7
                  = ( coinductive_LCons @ A @ X4 @ Xs5 ) )
                & ~ ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs5 ) )
                & ( coindu351974385stinct @ A @ Xs5 ) ) ) ) ) )).

% ldistinct.simps
thf(fact_189_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs3: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y3 @ Xs3 ) )
            & ( coindu328551480prefix @ A @ Xs3 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_190_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X3: B,Xs: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X3 @ Xs ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_191_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y3: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y3 @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_192_llast__singleton,axiom,(
    ! [A: $tType,X3: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) )
      = X3 ) )).

% llast_singleton
thf(fact_193_llast__LCons2,axiom,(
    ! [A: $tType,X3: A,Y3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) ) )).

% llast_LCons2
thf(fact_194_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X3: B,Xs: ( coinductive_llist @ B ),Y3: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X3 @ Xs ) @ ( coinductive_LCons @ B @ Y3 @ Ys ) )
      = ( ( X3 = Y3 )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_195_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_196_llist__less__induct,axiom,(
    ! [A: $tType,P2: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs2: ( coinductive_llist @ A )] :
          ( ! [Ys5: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys5 @ Xs2 )
             => ( P2 @ Ys5 ) )
         => ( P2 @ Xs2 ) )
     => ( P2 @ Xs ) ) )).

% llist_less_induct
thf(fact_197_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_198_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( Xs
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_199_llast__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X3: A] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) )
          = X3 ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) )
          = ( coinductive_llast @ A @ Xs ) ) ) ) )).

% llast_LCons
thf(fact_200_lprefix__coinduct,axiom,(
    ! [A: $tType,P2: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( P2 @ Xs @ Ys )
     => ( ! [Xs2: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A )] :
            ( ( P2 @ Xs2 @ Ys4 )
           => ( ( ( coinductive_lnull @ A @ Ys4 )
               => ( coinductive_lnull @ A @ Xs2 ) )
              & ( ~ ( coinductive_lnull @ A @ Xs2 )
               => ( ~ ( coinductive_lnull @ A @ Ys4 )
                 => ( ( ( coinductive_lhd @ A @ Xs2 )
                      = ( coinductive_lhd @ A @ Ys4 ) )
                    & ( ( P2 @ ( coinductive_ltl @ A @ Xs2 ) @ ( coinductive_ltl @ A @ Ys4 ) )
                      | ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs2 ) @ ( coinductive_ltl @ A @ Ys4 ) ) ) ) ) ) ) )
       => ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) )).

% lprefix_coinduct
thf(fact_201_lprefix__expand,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ~ ( coinductive_lnull @ A @ Ys )
          & ( ( coinductive_lhd @ A @ Xs )
            = ( coinductive_lhd @ A @ Ys ) )
          & ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ A @ Ys ) ) ) )
     => ( coinductive_lprefix @ A @ Xs @ Ys ) ) )).

% lprefix_expand
thf(fact_202_llist_Oleq__refl,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ X3 @ X3 ) )).

% llist.leq_refl
thf(fact_203_lprefix__refl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ Xs @ Xs ) )).

% lprefix_refl
thf(fact_204_LCons__lprefix__LCons,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( X3 = Y3 )
        & ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) )).

% LCons_lprefix_LCons
thf(fact_205_lprefix__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_LNil @ A ) @ Ys ) )).

% lprefix_code(1)
thf(fact_206_lprefix__LNil,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lprefix_LNil
thf(fact_207_Coinductive__List_Ofinite__lprefix__def,axiom,(
    ! [A: $tType] :
      ( ( coindu328551480prefix @ A )
      = ( coinductive_lprefix @ A ) ) )).

% Coinductive_List.finite_lprefix_def
thf(fact_208_lstrict__prefix__def,axiom,(
    ! [A: $tType] :
      ( ( coindu1478340336prefix @ A )
      = ( ^ [Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
            ( ( coinductive_lprefix @ A @ Xs5 @ Ys3 )
            & ( Xs5 != Ys3 ) ) ) ) )).

% lstrict_prefix_def
thf(fact_209_lprefix__LCons__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs3: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y3 @ Xs3 ) )
            & ( coinductive_lprefix @ A @ Xs3 @ Ys ) ) ) ) )).

% lprefix_LCons_conv
thf(fact_210_lprefix_Ocoinduct,axiom,(
    ! [A: $tType,X6: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),X3: ( coinductive_llist @ A ),Xa2: ( coinductive_llist @ A )] :
      ( ( X6 @ X3 @ Xa2 )
     => ( ! [X: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A )] :
            ( ( X6 @ X @ Xa )
           => ( ? [Xs6: ( coinductive_llist @ A )] :
                  ( ( X
                    = ( coinductive_LNil @ A ) )
                  & ( Xa = Xs6 ) )
              | ? [Xs6: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A ),Xb: A] :
                  ( ( X
                    = ( coinductive_LCons @ A @ Xb @ Xs6 ) )
                  & ( Xa
                    = ( coinductive_LCons @ A @ Xb @ Ys5 ) )
                  & ( ( X6 @ Xs6 @ Ys5 )
                    | ( coinductive_lprefix @ A @ Xs6 @ Ys5 ) ) ) ) )
       => ( coinductive_lprefix @ A @ X3 @ Xa2 ) ) ) )).

% lprefix.coinduct
thf(fact_211_lprefix_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lprefix @ A )
      = ( ^ [A12: ( coinductive_llist @ A ),A23: ( coinductive_llist @ A )] :
            ( ? [Xs5: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LNil @ A ) )
                & ( A23 = Xs5 ) )
            | ? [Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),X4: A] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X4 @ Xs5 ) )
                & ( A23
                  = ( coinductive_LCons @ A @ X4 @ Ys3 ) )
                & ( coinductive_lprefix @ A @ Xs5 @ Ys3 ) ) ) ) ) )).

% lprefix.simps
thf(fact_212_lprefix_Ocases,axiom,(
    ! [A: $tType,A1: ( coinductive_llist @ A ),A22: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ A1 @ A22 )
     => ( ( ( A1
            = ( coinductive_LNil @ A ) )
         => ! [Xs2: ( coinductive_llist @ A )] : ( A22 != Xs2 ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A ),X: A] :
                ( ( A1
                  = ( coinductive_LCons @ A @ X @ Xs2 ) )
               => ( ( A22
                    = ( coinductive_LCons @ A @ X @ Ys4 ) )
                 => ~ ( coinductive_lprefix @ A @ Xs2 @ Ys4 ) ) ) ) ) ) )).

% lprefix.cases
thf(fact_213_lprefix__code_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ~ ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LNil @ A ) ) )).

% lprefix_code(2)
thf(fact_214_lprefixI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X6: ( set @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) )] :
      ( ( member @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) @ ( product_Pair @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Xs @ Ys ) @ X6 )
     => ( ! [Xs2: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A )] :
            ( ( member @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) @ ( product_Pair @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Xs2 @ Ys4 ) @ X6 )
           => ( ( coinductive_lnull @ A @ Xs2 )
              | ? [X5: A,Xs7: ( coinductive_llist @ A ),Ys6: ( coinductive_llist @ A )] :
                  ( ( Xs2
                    = ( coinductive_LCons @ A @ X5 @ Xs7 ) )
                  & ( Ys4
                    = ( coinductive_LCons @ A @ X5 @ Ys6 ) )
                  & ( ( member @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) @ ( product_Pair @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Xs7 @ Ys6 ) @ X6 )
                    | ( coinductive_lprefix @ A @ Xs7 @ Ys6 ) ) ) ) )
       => ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) )).

% lprefixI
thf(fact_215_lprefix__lhdD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_lhd @ A @ Xs )
          = ( coinductive_lhd @ A @ Ys ) ) ) ) )).

% lprefix_lhdD
thf(fact_216_lprefix__down__linear,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Zs )
     => ( ( coinductive_lprefix @ A @ Ys @ Zs )
       => ( ( coinductive_lprefix @ A @ Xs @ Ys )
          | ( coinductive_lprefix @ A @ Ys @ Xs ) ) ) ) )).

% lprefix_down_linear
thf(fact_217_llist_Oleq__antisym,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X3 @ Y3 )
     => ( ( coinductive_lprefix @ A @ Y3 @ X3 )
       => ( X3 = Y3 ) ) ) )).

% llist.leq_antisym
thf(fact_218_lprefix__antisym,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lprefix @ A @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% lprefix_antisym
thf(fact_219_llist_Oleq__trans,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ A ),Z: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X3 @ Y3 )
     => ( ( coinductive_lprefix @ A @ Y3 @ Z )
       => ( coinductive_lprefix @ A @ X3 @ Z ) ) ) )).

% llist.leq_trans
thf(fact_220_lprefix__trans,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lprefix @ A @ Ys @ Zs )
       => ( coinductive_lprefix @ A @ Xs @ Zs ) ) ) )).

% lprefix_trans
thf(fact_221_ldistinct__lprefix,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( ( coinductive_lprefix @ A @ Ys @ Xs )
       => ( coindu351974385stinct @ A @ Ys ) ) ) )).

% ldistinct_lprefix
thf(fact_222_ord_Olsorted__lprefixD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less_eq: ( A > A > $o )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lsorted @ A @ Less_eq @ Ys )
       => ( coinductive_lsorted @ A @ Less_eq @ Xs ) ) ) )).

% ord.lsorted_lprefixD
thf(fact_223_lprefix__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ A @ Ys ) ) ) )).

% lprefix_ltlI
thf(fact_224_lprefix__not__lnullD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lprefix_not_lnullD
thf(fact_225_lprefix__lnullD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( coinductive_lnull @ A @ Xs ) ) ) )).

% lprefix_lnullD
thf(fact_226_lprefix__lnull,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_lprefix @ A @ Xs @ Ys )
        = ( coinductive_lnull @ A @ Xs ) ) ) )).

% lprefix_lnull
thf(fact_227_lnull__lprefix,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lprefix @ A @ Xs @ Ys ) ) )).

% lnull_lprefix
thf(fact_228_Le__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X3: A] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ X3 @ Ys ) ) ) )).

% Le_LCons
thf(fact_229_LCons__lprefix__conv,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ Ys )
      = ( ? [Ys2: ( coinductive_llist @ A )] :
            ( ( Ys
              = ( coinductive_LCons @ A @ X3 @ Ys2 ) )
            & ( coinductive_lprefix @ A @ Xs @ Ys2 ) ) ) ) )).

% LCons_lprefix_conv
thf(fact_230_lprefix__ltakeWhile,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) @ Xs ) )).

% lprefix_ltakeWhile
thf(fact_231_lprefix__imp__llexord,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),R: ( A > A > $o )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_llexord @ A @ R @ Xs @ Ys ) ) )).

% lprefix_imp_llexord
thf(fact_232_LNil__lprefix,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% LNil_lprefix
thf(fact_233_llimit__induct,axiom,(
    ! [A: $tType,P2: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( P2 @ ( coinductive_LNil @ A ) )
     => ( ! [X: A,Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lfinite @ A @ Xs2 )
           => ( ( P2 @ Xs2 )
             => ( P2 @ ( coinductive_LCons @ A @ X @ Xs2 ) ) ) )
       => ( ( ! [Ys5: ( coinductive_llist @ A )] :
                ( ( coindu1478340336prefix @ A @ Ys5 @ Xs )
               => ( P2 @ Ys5 ) )
           => ( P2 @ Xs ) )
         => ( P2 @ Xs ) ) ) ) )).

% llimit_induct
thf(fact_234_in__inv__imagep,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( inv_imagep @ A @ B )
      = ( ^ [R3: ( A > A > $o ),F4: ( B > A ),X4: B,Y4: B] :
            ( R3 @ ( F4 @ X4 ) @ ( F4 @ Y4 ) ) ) ) )).

% in_inv_imagep
thf(fact_235_lfinite__LCons,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_236_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X3: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X3 @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_237_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_238_lfinite__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_ltl @ A @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_ltl
thf(fact_239_lfinite__lzip,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ ( product_prod @ A @ B ) @ ( coinductive_lzip @ A @ B @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        | ( coinductive_lfinite @ B @ Ys ) ) ) )).

% lfinite_lzip
thf(fact_240_Coinductive__List_Olprefix__nitpick__simps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lprefix @ A )
      = ( ^ [Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
            ( ( ( coinductive_lfinite @ A @ Xs5 )
             => ( coindu328551480prefix @ A @ Xs5 @ Ys3 ) )
            & ( ~ ( coinductive_lfinite @ A @ Xs5 )
             => ( Xs5 = Ys3 ) ) ) ) ) )).

% Coinductive_List.lprefix_nitpick_simps
thf(fact_241_not__lfinite__lprefix__conv__eq,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lprefix @ A @ Xs @ Ys )
        = ( Xs = Ys ) ) ) )).

% not_lfinite_lprefix_conv_eq
thf(fact_242_lprefix__lfiniteD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lprefix_lfiniteD
thf(fact_243_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_244_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X3: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_245_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_246_lfinite__ldropWhile,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu218763757pWhile @ A @ P2 @ Xs ) )
      = ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P2 @ X4 ) )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lfinite_ldropWhile
thf(fact_247_lfinite__ltakeWhile,axiom,(
    ! [A: $tType,P2: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu501562517eWhile @ A @ P2 @ Xs ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        | ? [X4: A] :
            ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P2 @ X4 ) ) ) ) )).

% lfinite_ltakeWhile
thf(fact_248_lfinite__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P2: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lnull @ A @ Xs2 )
           => ( P2 @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ Xs2 )
               => ( ( P2 @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P2 @ Xs2 ) ) ) )
         => ( P2 @ Xs ) ) ) ) )).

% lfinite_induct
thf(fact_249_lfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X: A] :
                    ( A2
                    = ( coinductive_LCons @ A @ X @ Xs2 ) )
               => ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% lfinite.cases
thf(fact_250_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A7: ( coinductive_llist @ A )] :
            ( ( A7
              = ( coinductive_LNil @ A ) )
            | ? [Xs5: ( coinductive_llist @ A ),X4: A] :
                ( ( A7
                  = ( coinductive_LCons @ A @ X4 @ Xs5 ) )
                & ( coinductive_lfinite @ A @ Xs5 ) ) ) ) ) )).

% lfinite.simps
thf(fact_251_lfinite_Oinducts,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),P2: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X3 )
     => ( ( P2 @ ( coinductive_LNil @ A ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),X: A] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P2 @ Xs2 )
               => ( P2 @ ( coinductive_LCons @ A @ X @ Xs2 ) ) ) )
         => ( P2 @ X3 ) ) ) ) )).

% lfinite.inducts
thf(fact_252_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ Ys )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lstrict_prefix_lfinite1
thf(fact_253_llexord__conv,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llexord @ A )
      = ( ^ [R3: ( A > A > $o ),Xs5: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
            ( ( Xs5 = Ys3 )
            | ? [Zs2: ( coinductive_llist @ A ),Xs3: ( coinductive_llist @ A ),Y4: A,Ys2: ( coinductive_llist @ A )] :
                ( ( coinductive_lfinite @ A @ Zs2 )
                & ( Xs5
                  = ( coinductive_lappend @ A @ Zs2 @ Xs3 ) )
                & ( Ys3
                  = ( coinductive_lappend @ A @ Zs2 @ ( coinductive_LCons @ A @ Y4 @ Ys2 ) ) )
                & ( ( Xs3
                    = ( coinductive_LNil @ A ) )
                  | ( R3 @ ( coinductive_lhd @ A @ Xs3 ) @ Y4 ) ) ) ) ) ) )).

% llexord_conv

%----Type constructors (3)
thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_1,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Obot_2,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X3: A,Y3: A] :
      ( ( if @ A @ $false @ X3 @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X3: A,Y3: A] :
      ( ( if @ A @ $true @ X3 @ Y3 )
      = X3 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( member @ node @ n @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) )).

%------------------------------------------------------------------------------
