%------------------------------------------------------------------------------
% File     : COM179^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 231
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__231.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  345 (   0 unit;  53 type;   0 defn)
%            Number of atoms       : 4174 ( 227 equality;2395 variable)
%            Maximal formula depth :   28 (   9 average)
%            Number of connectives : 3879 ( 101   ~;   8   |;  31   &;3406   @)
%                                         (   0 <=>; 333  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  167 ( 167   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   56 (  53   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1010 (   4 sgn; 911   !;  15   ?;  35   ^)
%                                         (1010   :;  49  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:47:31.744
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_node,type,(
    node: $tType )).

%----Explicit typings (46)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Topological__Spaces_Operfect__space,type,(
    topolo890362671_space: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Basic__BNFs_Ofsts,type,(
    basic_fsts: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_Basic__BNFs_Osnds,type,(
    basic_snds: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oconnected,type,(
    koenig793108494nected: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > $o ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__via,type,(
    koenig317145564le_via: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > ( set @ Node ) ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f____,type,(
    f: ( product_prod @ node @ ( set @ node ) ) > ( coinductive_llist @ node ) )).

thf(sy_v_graph,type,(
    graph: node > node > $o )).

thf(sy_v_n,type,(
    n: node )).

thf(sy_v_ns____,type,(
    ns: ( set @ node ) )).

%----Relevant facts (254)
thf(fact_0_connected,axiom,
    ( koenig793108494nected @ node @ graph )).

% connected
thf(fact_1_ns__def,axiom,
    ( ns
    = ( bot_bot @ ( set @ node ) ) )).

% ns_def
thf(fact_2__092_060open_062infinite_A_Ireachable__via_Agraph_A_I_N_A_123n_125_J_An_J_092_060close_062,axiom,(
    ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ n ) ) )).

% \<open>infinite (reachable_via graph (- {n}) n)\<close>
thf(fact_3_infinite,axiom,(
    ~ ( finite_finite2 @ node @ ( top_top @ ( set @ node ) ) ) )).

% infinite
thf(fact_4__092_060open_062_N_A_123n_125_A_092_060subseteq_062_Areachable__via_Agraph_A_I_N_A_123n_125_J_An_092_060close_062,axiom,
    ( ord_less_eq @ ( set @ node ) @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ n ) )).

% \<open>- {n} \<subseteq> reachable_via graph (- {n}) n\<close>
thf(fact_5_lset,axiom,(
    ! [X: node,Na: node,Nsa: ( set @ node )] :
      ( ( member @ node @ X @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) ) )
     => ( ~ ( member @ node @ Na @ Nsa )
       => ( ( finite_finite2 @ node @ Nsa )
         => ( ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ Na @ Nsa ) ) @ Na ) )
           => ~ ( member @ node @ X @ Nsa ) ) ) ) ) )).

% lset
thf(fact_6_finite__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A2 @ A3 ) )
      = ( finite_finite2 @ A @ A3 ) ) )).

% finite_insert
thf(fact_7_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_8_finite_Ocases,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ( A2
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A4: ( set @ A )] :
                ( ? [A5: A] :
                    ( A2
                    = ( insert @ A @ A5 @ A4 ) )
               => ~ ( finite_finite2 @ A @ A4 ) ) ) ) ) )).

% finite.cases
thf(fact_9_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A6: ( set @ A )] :
            ( ( A6
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A7: ( set @ A ),B2: A] :
                ( ( A6
                  = ( insert @ A @ B2 @ A7 ) )
                & ( finite_finite2 @ A @ A7 ) ) ) ) ) )).

% finite.simps
thf(fact_10_finite__induct,axiom,(
    ! [A: $tType,F: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X2: A,F2: ( set @ A )] :
              ( ( finite_finite2 @ A @ F2 )
             => ( ~ ( member @ A @ X2 @ F2 )
               => ( ( P @ F2 )
                 => ( P @ ( insert @ A @ X2 @ F2 ) ) ) ) )
         => ( P @ F ) ) ) ) )).

% finite_induct
thf(fact_11_finite_Oinducts,axiom,(
    ! [A: $tType,X3: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A4: ( set @ A ),A5: A] :
              ( ( finite_finite2 @ A @ A4 )
             => ( ( P @ A4 )
               => ( P @ ( insert @ A @ A5 @ A4 ) ) ) )
         => ( P @ X3 ) ) ) ) )).

% finite.inducts
thf(fact_12_finite__ne__induct,axiom,(
    ! [A: $tType,F: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F )
     => ( ( F
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X2: A] :
              ( P @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X2: A,F2: ( set @ A )] :
                ( ( finite_finite2 @ A @ F2 )
               => ( ( F2
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X2 @ F2 )
                   => ( ( P @ F2 )
                     => ( P @ ( insert @ A @ X2 @ F2 ) ) ) ) ) )
           => ( P @ F ) ) ) ) ) )).

% finite_ne_induct
thf(fact_13_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A3: ( set @ A )] :
      ( ! [A4: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A4 )
         => ( P @ A4 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X2: A,F2: ( set @ A )] :
              ( ( finite_finite2 @ A @ F2 )
             => ( ~ ( member @ A @ X2 @ F2 )
               => ( ( P @ F2 )
                 => ( P @ ( insert @ A @ X2 @ F2 ) ) ) ) )
         => ( P @ A3 ) ) ) ) )).

% infinite_finite_induct
thf(fact_14_ComplI,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A )] :
      ( ~ ( member @ A @ C2 @ A3 )
     => ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) )).

% ComplI
thf(fact_15_Compl__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( ~ ( member @ A @ C2 @ A3 ) ) ) )).

% Compl_iff
thf(fact_16_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_17_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_18_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_19_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_20_UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_21_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A7: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_22_subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A3 )
         => ( member @ A @ X2 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) )).

% subsetI
thf(fact_23_subset__antisym,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( A3 = B3 ) ) ) )).

% subset_antisym
thf(fact_24_insert__absorb2,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ X3 @ A3 ) )
      = ( insert @ A @ X3 @ A3 ) ) )).

% insert_absorb2
thf(fact_25_insert__iff,axiom,(
    ! [A: $tType,A2: A,B4: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B4 @ A3 ) )
      = ( ( A2 = B4 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_26_insertCI,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B4: A] :
      ( ( ~ ( member @ A @ A2 @ B3 )
       => ( A2 = B4 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B4 @ B3 ) ) ) )).

% insertCI
thf(fact_27_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A3 )
        = ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( A3 = B3 ) ) )).

% Compl_eq_Compl_iff
thf(fact_28_finite__Plus__UNIV__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_Plus_UNIV_iff
thf(fact_29_empty__subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) )).

% empty_subsetI
thf(fact_30_subset__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_31_insert__subset,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ B3 )
      = ( ( member @ A @ X3 @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% insert_subset
thf(fact_32_Compl__subset__Compl__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) )).

% Compl_subset_Compl_iff
thf(fact_33_Compl__anti__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) )).

% Compl_anti_mono
thf(fact_34__092_060open_062n_A_092_060in_062_Alset_A_If_A_In_M_Ans_J_J_092_060close_062,axiom,
    ( member @ node @ n @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) )).

% \<open>n \<in> lset (f (n, ns))\<close>
thf(fact_35_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B4: A] :
      ( ( ( insert @ A @ A2 @ A3 )
        = ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B4 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_36_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B4: A,A2: A,A3: ( set @ A )] :
      ( ( ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A3 ) )
      = ( ( A2 = B4 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_37_finite__compl,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ A @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
        = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finite_compl
thf(fact_38_subset__Compl__singleton,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B4 @ A3 ) ) ) )).

% subset_Compl_singleton
thf(fact_39_set__mp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% set_mp
thf(fact_40_in__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ X3 @ A3 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% in_mono
thf(fact_41_subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetD
thf(fact_42_subsetCE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetCE
thf(fact_43_UNIV__eq__I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X2: A] :
          ( member @ A @ X2 @ A3 )
     => ( ( top_top @ ( set @ A ) )
        = A3 ) ) )).

% UNIV_eq_I
thf(fact_44_equalityE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( A3 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) )).

% equalityE
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F3: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F3 @ X2 )
          = ( G @ X2 ) )
     => ( F3 = G ) ) )).

% ext
thf(fact_49_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B5: ( set @ A )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A7 )
           => ( member @ A @ X4 @ B5 ) ) ) ) )).

% subset_eq
thf(fact_50_equalityD1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) )).

% equalityD1
thf(fact_51_equalityD2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) )).

% equalityD2
thf(fact_52_set__rev__mp,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ X3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% set_rev_mp
thf(fact_53_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B5: ( set @ A )] :
          ! [T2: A] :
            ( ( member @ A @ T2 @ A7 )
           => ( member @ A @ T2 @ B5 ) ) ) ) )).

% subset_iff
thf(fact_54_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% rev_subsetD
thf(fact_55_subset__UNIV,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_56_subset__refl,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) )).

% subset_refl
thf(fact_57_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_58_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_59_subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% subset_trans
thf(fact_60_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y: ( set @ A ),Z: ( set @ A )] : ( Y = Z ) )
      = ( ^ [A7: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A7 ) ) ) ) )).

% set_eq_subset
thf(fact_61_contra__subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ~ ( member @ A @ C2 @ B3 )
       => ~ ( member @ A @ C2 @ A3 ) ) ) )).

% contra_subsetD
thf(fact_62_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) ) ) ) )).

% Collect_mono_iff
thf(fact_63_Finite__Set_Ofinite__set,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% Finite_Set.finite_set
thf(fact_64_finite__prod,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_prod
thf(fact_65_finite__Prod__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% finite_Prod_UNIV
thf(fact_66_finite__fun__UNIVD2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) )).

% finite_fun_UNIVD2
thf(fact_67_rev__finite__subset,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( finite_finite2 @ A @ A3 ) ) ) )).

% rev_finite_subset
thf(fact_68_infinite__super,axiom,(
    ! [A: $tType,S: ( set @ A ),T3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S @ T3 )
     => ( ~ ( finite_finite2 @ A @ S )
       => ~ ( finite_finite2 @ A @ T3 ) ) ) )).

% infinite_super
thf(fact_69_finite__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( finite_finite2 @ A @ B3 )
       => ( finite_finite2 @ A @ A3 ) ) ) )).

% finite_subset
thf(fact_70_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_71_finite__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_UNIV
thf(fact_72_infinite__UNIV__char__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% infinite_UNIV_char_0
thf(fact_73_ex__new__if__finite,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A @ A3 )
       => ? [A5: A] :
            ~ ( member @ A @ A5 @ A3 ) ) ) )).

% ex_new_if_finite
thf(fact_74_subset__insertI2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),B4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B4 @ B3 ) ) ) )).

% subset_insertI2
thf(fact_75_subset__insertI,axiom,(
    ! [A: $tType,B3: ( set @ A ),A2: A] :
      ( ord_less_eq @ ( set @ A ) @ B3 @ ( insert @ A @ A2 @ B3 ) ) )).

% subset_insertI
thf(fact_76_subset__insert,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% subset_insert
thf(fact_77_Set_Oinsert__mono,axiom,(
    ! [A: $tType,C3: ( set @ A ),D: ( set @ A ),A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ D )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C3 ) @ ( insert @ A @ A2 @ D ) ) ) )).

% Set.insert_mono
thf(fact_78_insert__UNIV,axiom,(
    ! [A: $tType,X3: A] :
      ( ( insert @ A @ X3 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% insert_UNIV
thf(fact_79_subset__singleton__iff,axiom,(
    ! [A: $tType,X5: ( set @ A ),A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X5 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X5
          = ( bot_bot @ ( set @ A ) ) )
        | ( X5
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_80_subset__singletonD,axiom,(
    ! [A: $tType,A3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_81_subset__Compl__self__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_Compl_self_eq
thf(fact_82_Compl__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Compl_empty_eq
thf(fact_83_Compl__UNIV__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_UNIV_eq
thf(fact_84_finite__subset__induct,axiom,(
    ! [A: $tType,F: ( set @ A ),A3: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F )
     => ( ( ord_less_eq @ ( set @ A ) @ F @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A,F2: ( set @ A )] :
                ( ( finite_finite2 @ A @ F2 )
               => ( ( member @ A @ A5 @ A3 )
                 => ( ~ ( member @ A @ A5 @ F2 )
                   => ( ( P @ F2 )
                     => ( P @ ( insert @ A @ A5 @ F2 ) ) ) ) ) )
           => ( P @ F ) ) ) ) ) )).

% finite_subset_induct
thf(fact_85_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_86_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_87_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_88_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_89_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ A )] :
          ( finite_finite2 @ A @ A3 ) ) )).

% finite
thf(fact_90_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ? [X1: B] :
                ( P @ X2 @ X1 ) )
       => ? [F4: ( A > B )] :
          ! [X6: A] :
            ( ( member @ A @ X6 @ A3 )
           => ( P @ X6 @ ( F4 @ X6 ) ) ) ) ) )).

% finite_set_choice
thf(fact_91_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ? [B6: ( set @ A )] :
          ( ( A3
            = ( insert @ A @ A2 @ B6 ) )
          & ~ ( member @ A @ A2 @ B6 ) ) ) )).

% mk_disjoint_insert
thf(fact_92_insert__commute,axiom,(
    ! [A: $tType,X3: A,Y3: A,A3: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ Y3 @ A3 ) )
      = ( insert @ A @ Y3 @ ( insert @ A @ X3 @ A3 ) ) ) )).

% insert_commute
thf(fact_93_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B4: A,B3: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ B4 @ B3 )
       => ( ( ( insert @ A @ A2 @ A3 )
            = ( insert @ A @ B4 @ B3 ) )
          = ( ( ( A2 = B4 )
             => ( A3 = B3 ) )
            & ( ( A2 != B4 )
             => ? [C4: ( set @ A )] :
                  ( ( A3
                    = ( insert @ A @ B4 @ C4 ) )
                  & ~ ( member @ A @ B4 @ C4 )
                  & ( B3
                    = ( insert @ A @ A2 @ C4 ) )
                  & ~ ( member @ A @ A2 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_94_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ A3 )
        = A3 ) ) )).

% insert_absorb
thf(fact_95_insert__ident,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A3 )
     => ( ~ ( member @ A @ X3 @ B3 )
       => ( ( ( insert @ A @ X3 @ A3 )
            = ( insert @ A @ X3 @ B3 ) )
          = ( A3 = B3 ) ) ) ) )).

% insert_ident
thf(fact_96_Set_Oset__insert,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A )] :
      ( ( member @ A @ X3 @ A3 )
     => ~ ( ! [B6: ( set @ A )] :
              ( ( A3
                = ( insert @ A @ X3 @ B6 ) )
             => ( member @ A @ X3 @ B6 ) ) ) ) )).

% Set.set_insert
thf(fact_97_insertI2,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B4: A] :
      ( ( member @ A @ A2 @ B3 )
     => ( member @ A @ A2 @ ( insert @ A @ B4 @ B3 ) ) ) )).

% insertI2
thf(fact_98_insertI1,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B3 ) ) )).

% insertI1
thf(fact_99_insertE,axiom,(
    ! [A: $tType,A2: A,B4: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B4 @ A3 ) )
     => ( ( A2 != B4 )
       => ( member @ A @ A2 @ A3 ) ) ) )).

% insertE
thf(fact_100_double__complement,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = A3 ) )).

% double_complement
thf(fact_101_ComplD,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
     => ~ ( member @ A @ C2 @ A3 ) ) )).

% ComplD
thf(fact_102_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_103_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_104_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B4: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B4 ) ) )).

% singleton_inject
thf(fact_105_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( insert @ A @ A2 @ A3 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_106_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B4: A,C2: A,D2: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C2 )
          & ( B4 = D2 ) )
        | ( ( A2 = D2 )
          & ( B4 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_107_singleton__iff,axiom,(
    ! [A: $tType,B4: A,A2: A] :
      ( ( member @ A @ B4 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B4 = A2 ) ) )).

% singleton_iff
thf(fact_108_singletonD,axiom,(
    ! [A: $tType,B4: A,A2: A] :
      ( ( member @ A @ B4 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B4 = A2 ) ) )).

% singletonD
thf(fact_109_finite_OinsertI,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ A @ ( insert @ A @ A2 @ A3 ) ) ) )).

% finite.insertI
thf(fact_110_compl__top__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( top_top @ A ) )
        = ( bot_bot @ A ) ) ) )).

% compl_top_eq
thf(fact_111_compl__bot__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( bot_bot @ A ) )
        = ( top_top @ A ) ) ) )).

% compl_bot_eq
thf(fact_112__092_060open_062_092_060not_062_Alfinite_A_If_A_In_M_Ans_J_J_092_060close_062,axiom,(
    ~ ( coinductive_lfinite @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) )).

% \<open>\<not> lfinite (f (n, ns))\<close>
thf(fact_113_finite__option__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_option_UNIV
thf(fact_114_compl__le__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% compl_le_compl_iff
thf(fact_115_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B4 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B4 ) ) ) )).

% neg_le_iff_le
thf(fact_116_Topological__Spaces_OUNIV__not__singleton,axiom,(
    ! [A: $tType] :
      ( ( topolo890362671_space @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ( top_top @ ( set @ A ) )
         != ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Topological_Spaces.UNIV_not_singleton
thf(fact_117_f__simps_I1_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ~ ( coinductive_lnull @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) ) )).

% f_simps(1)
thf(fact_118_the__elem__eq,axiom,(
    ! [A: $tType,X3: A] :
      ( ( the_elem @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
      = X3 ) )).

% the_elem_eq
thf(fact_119_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_120_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A7 @ X4 ) ) ) ) ) )).

% uminus_apply
thf(fact_121_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) )).

% add.inverse_inverse
thf(fact_122_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B4 ) )
          = ( A2 = B4 ) ) ) )).

% neg_equal_iff_equal
thf(fact_123_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X3 ) )
          = X3 ) ) )).

% double_compl
thf(fact_124_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ( uminus_uminus @ A @ X3 )
            = ( uminus_uminus @ A @ Y3 ) )
          = ( X3 = Y3 ) ) ) )).

% compl_eq_compl_iff
thf(fact_125_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_126_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_127_fun__Compl__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A7 @ X4 ) ) ) ) ) )).

% fun_Compl_def
thf(fact_128_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B4 ) )
          = ( B4
            = ( uminus_uminus @ A @ A2 ) ) ) ) )).

% equation_minus_iff
thf(fact_129_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B4 )
          = ( ( uminus_uminus @ A @ B4 )
            = A2 ) ) ) )).

% minus_equation_iff
thf(fact_130_compl__mono,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y3 ) @ ( uminus_uminus @ A @ X3 ) ) ) ) )).

% compl_mono
thf(fact_131_compl__le__swap1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ Y3 @ ( uminus_uminus @ A @ X3 ) )
         => ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ Y3 ) ) ) ) )).

% compl_le_swap1
thf(fact_132_compl__le__swap2,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y3 ) @ X3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ Y3 ) ) ) )).

% compl_le_swap2
thf(fact_133_le__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B4 ) )
          = ( ord_less_eq @ A @ B4 @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% le_minus_iff
thf(fact_134_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B4 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B4 ) @ A2 ) ) ) )).

% minus_le_iff
thf(fact_135_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B4 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% le_imp_neg_le
thf(fact_136_lset__eq__empty,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lset_eq_empty
thf(fact_137_lfinite__imp__finite__lset,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( finite_finite2 @ A @ ( coinductive_lset @ A @ Xs ) ) ) )).

% lfinite_imp_finite_lset
thf(fact_138_lset__lnull,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_lnull
thf(fact_139_top__apply,axiom,(
    ! [C: $tType,D3: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D3 > C ) )
        = ( ^ [X4: D3] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_140_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ord_less_eq @ A @ X3 @ X3 ) ) )).

% order_refl
thf(fact_141_top1I,axiom,(
    ! [A: $tType,X3: A] :
      ( top_top @ ( A > $o ) @ X3 ) )).

% top1I
thf(fact_142_bot__apply,axiom,(
    ! [C: $tType,D3: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D3 > C ) )
        = ( ^ [X4: D3] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_143_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F3: ( A > B ),G: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F3 @ G )
         => ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) )).

% le_funD
thf(fact_144_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F3: ( A > B ),G: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F3 @ G )
         => ( ord_less_eq @ B @ ( F3 @ X3 ) @ ( G @ X3 ) ) ) ) )).

% le_funE
thf(fact_145_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F3: ( A > B ),G: ( A > B )] :
          ( ! [X2: A] :
              ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F3 @ G ) ) ) )).

% le_funI
thf(fact_146_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F5: ( A > B ),G2: ( A > B )] :
            ! [X4: A] :
              ( ord_less_eq @ B @ ( F5 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) )).

% le_fun_def
thf(fact_147_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F3: ( B > A ),B4: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F3 @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_148_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B4: A,F3: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ( ord_less_eq @ C @ ( F3 @ B4 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ C @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F3 @ A2 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_149_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F3: ( B > A ),B4: B,C2: B] :
          ( ( A2
            = ( F3 @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y2 )
                 => ( ord_less_eq @ A @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F3 @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_150_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B4: A,F3: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ( ( F3 @ B4 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y2 )
                 => ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( F3 @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F3 @ A2 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_151_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y: A,Z: A] : ( Y = Z ) )
        = ( ^ [X4: A,Y4: A] :
              ( ( ord_less_eq @ A @ X4 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X4 ) ) ) ) ) )).

% eq_iff
thf(fact_152_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ X3 )
           => ( X3 = Y3 ) ) ) ) )).

% antisym
thf(fact_153_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
          | ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% linear
thf(fact_154_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( X3 = Y3 )
         => ( ord_less_eq @ A @ X3 @ Y3 ) ) ) )).

% eq_refl
thf(fact_155_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B4: A,A2: A] :
          ( ! [A5: A,B7: A] :
              ( ( ord_less_eq @ A @ A5 @ B7 )
             => ( P @ A5 @ B7 ) )
         => ( ( ( P @ B4 @ A2 )
             => ( P @ A2 @ B4 ) )
           => ( P @ A2 @ B4 ) ) ) ) )).

% wlog_linorder_le
thf(fact_156_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ~ ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% le_cases
thf(fact_157_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% order.trans
thf(fact_158_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y3 )
           => ~ ( ord_less_eq @ A @ Y3 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y3 @ X3 )
             => ~ ( ord_less_eq @ A @ X3 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X3 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y3 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y3 )
                 => ~ ( ord_less_eq @ A @ Y3 @ X3 ) )
               => ( ( ( ord_less_eq @ A @ Y3 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X3 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X3 )
                     => ~ ( ord_less_eq @ A @ X3 @ Y3 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_159_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ Y3 @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y3 )
            = ( X3 = Y3 ) ) ) ) )).

% antisym_conv
thf(fact_160_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( A2 = B4 )
         => ( ( ord_less_eq @ A @ B4 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_161_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ( B4 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_162_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ A2 )
           => ( A2 = B4 ) ) ) ) )).

% order_class.order.antisym
thf(fact_163_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ Z2 )
           => ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_164_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_165_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B4: A] :
          ( ! [A5: A,B7: A] :
              ( ( ord_less_eq @ A @ A5 @ B7 )
             => ( P @ A5 @ B7 ) )
         => ( ! [A5: A,B7: A] :
                ( ( P @ B7 @ A5 )
               => ( P @ A5 @ B7 ) )
           => ( P @ A2 @ B4 ) ) ) ) )).

% linorder_wlog
thf(fact_166_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B4 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B4 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_167_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A] :
          ( ( ord_less_eq @ A @ B4 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B4 )
           => ( A2 = B4 ) ) ) ) )).

% dual_order.antisym
thf(fact_168_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_169_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_170_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_171_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_172_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_173_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) )).

% bot.extremum
thf(fact_174_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_175_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_176_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_177_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_178_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B4: B,A8: A,B8: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B4 )
        = ( product_Pair @ A @ B @ A8 @ B8 ) )
      = ( ( A2 = A8 )
        & ( B4 = B8 ) ) ) )).

% old.prod.inject
thf(fact_179_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X12: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X12 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X12 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_180_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_181_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_182_subrelI,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ! [X2: A,Y2: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ S2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) )).

% subrelI
thf(fact_183_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X2: A,Y2: B] :
      ( P2
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) )).

% surj_pair
thf(fact_184_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A5: A,B7: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B7 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_185_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B4: B,A8: A,B8: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B4 )
        = ( product_Pair @ A @ B @ A8 @ B8 ) )
     => ~ ( ( A2 = A8 )
         => ( B4 != B8 ) ) ) )).

% Pair_inject
thf(fact_186_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B7: B,C5: C] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B7 @ C5 ) ) ) ) )).

% prod_cases3
thf(fact_187_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D3: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D3 ) ) )] :
      ~ ( ! [A5: A,B7: B,C5: C,D4: D3] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D3 ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D3 ) @ B7 @ ( product_Pair @ C @ D3 @ C5 @ D4 ) ) ) ) ) )).

% prod_cases4
thf(fact_188_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D3: $tType,E: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) ) )] :
      ~ ( ! [A5: A,B7: B,C5: C,D4: D3,E2: E] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D3 @ E ) @ C5 @ ( product_Pair @ D3 @ E @ D4 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_189_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D3: $tType,E: $tType,F6: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) ) )] :
      ~ ( ! [A5: A,B7: B,C5: C,D4: D3,E2: E,F4: F6] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) @ C5 @ ( product_Pair @ D3 @ ( product_prod @ E @ F6 ) @ D4 @ ( product_Pair @ E @ F6 @ E2 @ F4 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_190_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D3: $tType,E: $tType,F6: $tType,G3: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) ) )] :
      ~ ( ! [A5: A,B7: B,C5: C,D4: D3,E2: E,F4: F6,G4: G3] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) @ C5 @ ( product_Pair @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) @ D4 @ ( product_Pair @ E @ ( product_prod @ F6 @ G3 ) @ E2 @ ( product_Pair @ F6 @ G3 @ F4 @ G4 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_191_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B7: B,C5: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B7 @ C5 ) ) )
     => ( P @ X3 ) ) )).

% prod_induct3
thf(fact_192_prod__induct4,axiom,(
    ! [D3: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D3 ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D3 ) ) )] :
      ( ! [A5: A,B7: B,C5: C,D4: D3] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D3 ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D3 ) @ B7 @ ( product_Pair @ C @ D3 @ C5 @ D4 ) ) ) )
     => ( P @ X3 ) ) )).

% prod_induct4
thf(fact_193_prod__induct5,axiom,(
    ! [E: $tType,D3: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) ) )] :
      ( ! [A5: A,B7: B,C5: C,D4: D3,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D3 @ E ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D3 @ E ) @ C5 @ ( product_Pair @ D3 @ E @ D4 @ E2 ) ) ) ) )
     => ( P @ X3 ) ) )).

% prod_induct5
thf(fact_194_prod__induct6,axiom,(
    ! [F6: $tType,E: $tType,D3: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) ) )] :
      ( ! [A5: A,B7: B,C5: C,D4: D3,E2: E,F4: F6] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D3 @ ( product_prod @ E @ F6 ) ) @ C5 @ ( product_Pair @ D3 @ ( product_prod @ E @ F6 ) @ D4 @ ( product_Pair @ E @ F6 @ E2 @ F4 ) ) ) ) ) )
     => ( P @ X3 ) ) )).

% prod_induct6
thf(fact_195_prod__induct7,axiom,(
    ! [G3: $tType,F6: $tType,E: $tType,D3: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) ) ) > $o ),X3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) ) )] :
      ( ! [A5: A,B7: B,C5: C,D4: D3,E2: E,F4: F6,G4: G3] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) ) @ B7 @ ( product_Pair @ C @ ( product_prod @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) ) @ C5 @ ( product_Pair @ D3 @ ( product_prod @ E @ ( product_prod @ F6 @ G3 ) ) @ D4 @ ( product_Pair @ E @ ( product_prod @ F6 @ G3 ) @ E2 @ ( product_Pair @ F6 @ G3 @ F4 @ G4 ) ) ) ) ) ) )
     => ( P @ X3 ) ) )).

% prod_induct7
thf(fact_196_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y3: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B7: B] :
            ( Y3
           != ( product_Pair @ A @ B @ A5 @ B7 ) ) ) )).

% old.prod.exhaust
thf(fact_197_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B7: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B7 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_198_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_199_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B4: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B4 ) )
      = ( F1 @ A2 @ B4 ) ) )).

% old.prod.rec
thf(fact_200_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( insert @ A @ ( the_elem @ A @ A7 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_201_is__singletonI,axiom,(
    ! [A: $tType,X3: A] :
      ( is_singleton @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_202_is__singletonI_H,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X2: A,Y2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ( ( member @ A @ Y2 @ A3 )
             => ( X2 = Y2 ) ) )
       => ( is_singleton @ A @ A3 ) ) ) )).

% is_singletonI'
thf(fact_203_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A7: ( set @ A )] :
          ? [X4: A] :
            ( A7
            = ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_204_is__singletonE,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( is_singleton @ A @ A3 )
     => ~ ( ! [X2: A] :
              ( A3
             != ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_205_insert__subsetI,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),X5: ( set @ A )] :
      ( ( member @ A @ X3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ X5 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ X5 ) @ A3 ) ) ) )).

% insert_subsetI
thf(fact_206_subset__emptyI,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X2: A] :
          ~ ( member @ A @ X2 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_207_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S2: B,R2: ( set @ ( product_prod @ A @ B ) ),S3: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R2 )
     => ( ( S3 = S2 )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S3 ) @ R2 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_208_lset__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A )
      = ( coinductive_gen_lset @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_code
thf(fact_209_top__conj_I1_J,axiom,(
    ! [A: $tType,X3: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X3 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_210_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X3: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X3 ) )
      = P ) )).

% top_conj(2)
thf(fact_211_prod__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X3: A,Y3: B] :
      ( ( basic_fsts @ A @ B @ ( product_Pair @ A @ B @ X3 @ Y3 ) )
      = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% prod_set_simps(1)
thf(fact_212_prod__set__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X3: A,Y3: B] :
      ( ( basic_snds @ A @ B @ ( product_Pair @ A @ B @ X3 @ Y3 ) )
      = ( insert @ B @ Y3 @ ( bot_bot @ ( set @ B ) ) ) ) )).

% prod_set_simps(2)
thf(fact_213_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_214_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B4: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B4 ) )
      = ( C2 @ A2 @ B4 ) ) )).

% internal_case_prod_conv
thf(fact_215_finite__remove__induct,axiom,(
    ! [A: $tType,B3: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A4: ( set @ A )] :
              ( ( finite_finite2 @ A @ A4 )
             => ( ( A4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A4 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A4 ) ) ) ) )
         => ( P @ B3 ) ) ) ) )).

% finite_remove_induct
thf(fact_216_remove__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),B3: ( set @ A )] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite2 @ A @ B3 )
         => ( P @ B3 ) )
       => ( ! [A4: ( set @ A )] :
              ( ( finite_finite2 @ A @ A4 )
             => ( ( A4
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B3 )
                 => ( ! [X6: A] :
                        ( ( member @ A @ X6 @ A4 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A4 ) ) ) ) )
         => ( P @ B3 ) ) ) ) )).

% remove_induct
thf(fact_217_minus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),B5: ( A > B ),X4: A] :
              ( minus_minus @ B @ ( A7 @ X4 ) @ ( B5 @ X4 ) ) ) ) ) )).

% minus_apply
thf(fact_218_DiffI,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ~ ( member @ A @ C2 @ B3 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) ) )).

% DiffI
thf(fact_219_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ~ ( member @ A @ C2 @ B3 ) ) ) )).

% Diff_iff
thf(fact_220_Diff__idemp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ B3 )
      = ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) )).

% Diff_idemp
thf(fact_221_minus__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B4 ) )
          = ( minus_minus @ A @ B4 @ A2 ) ) ) )).

% minus_diff_eq
thf(fact_222_Diff__empty,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) )).

% Diff_empty
thf(fact_223_empty__Diff,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_224_Diff__cancel,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ A3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_225_finite__Diff2,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
        = ( finite_finite2 @ A @ A3 ) ) ) )).

% finite_Diff2
thf(fact_226_finite__Diff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% finite_Diff
thf(fact_227_insert__Diff1,axiom,(
    ! [A: $tType,X3: A,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ X3 @ B3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ B3 )
        = ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% insert_Diff1
thf(fact_228_Diff__insert0,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X3 @ B3 ) )
        = ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% Diff_insert0
thf(fact_229_Diff__UNIV,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_UNIV
thf(fact_230_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) )).

% Diff_eq_empty_iff
thf(fact_231_insert__Diff__single,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A3 ) ) )).

% insert_Diff_single
thf(fact_232_finite__Diff__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B3: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B3 ) ) )
      = ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% finite_Diff_insert
thf(fact_233_Diff__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),C3: ( set @ A ),D: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ D @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ ( minus_minus @ ( set @ A ) @ C3 @ D ) ) ) ) )).

% Diff_mono
thf(fact_234_Diff__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ A3 ) )).

% Diff_subset
thf(fact_235_double__diff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C3 )
       => ( ( minus_minus @ ( set @ A ) @ B3 @ ( minus_minus @ ( set @ A ) @ C3 @ A3 ) )
          = A3 ) ) ) )).

% double_diff
thf(fact_236_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B4 @ D2 ) ) ) ) ) )).

% diff_mono
thf(fact_237_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B4 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B4 ) ) ) ) )).

% diff_left_mono
thf(fact_238_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B4 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B4 @ C2 ) ) ) ) )).

% diff_right_mono
thf(fact_239_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B4 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B4 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_240_subset__Diff__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),X3: A,C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ ( insert @ A @ X3 @ C3 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ C3 ) )
        & ~ ( member @ A @ X3 @ A3 ) ) ) )).

% subset_Diff_insert
thf(fact_241_Compl__eq__Diff__UNIV,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) ) ) )).

% Compl_eq_Diff_UNIV
thf(fact_242_DiffE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ( member @ A @ C2 @ B3 ) ) ) )).

% DiffE
thf(fact_243_DiffD1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
     => ( member @ A @ C2 @ A3 ) ) )).

% DiffD1
thf(fact_244_DiffD2,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
     => ~ ( member @ A @ C2 @ B3 ) ) )).

% DiffD2
thf(fact_245_insert__Diff__if,axiom,(
    ! [A: $tType,X3: A,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( ( member @ A @ X3 @ B3 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ B3 )
          = ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) )
      & ( ~ ( member @ A @ X3 @ B3 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ B3 )
          = ( insert @ A @ X3 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) )).

% insert_Diff_if
thf(fact_246_Diff__infinite__finite,axiom,(
    ! [A: $tType,T3: ( set @ A ),S: ( set @ A )] :
      ( ( finite_finite2 @ A @ T3 )
     => ( ~ ( finite_finite2 @ A @ S )
       => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S @ T3 ) ) ) ) )).

% Diff_infinite_finite
thf(fact_247_fun__diff__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: ( A > B ),B5: ( A > B ),X4: A] :
              ( minus_minus @ B @ ( A7 @ X4 ) @ ( B5 @ X4 ) ) ) ) ) )).

% fun_diff_def
thf(fact_248_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B4 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B4 )
            = ( C2 = D2 ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_249_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,B4: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B4 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B4 ) @ C2 ) ) ) )).

% diff_right_commute
thf(fact_250_Diff__insert__absorb,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A3 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
        = A3 ) ) )).

% Diff_insert_absorb
thf(fact_251_Diff__insert2,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) ) )).

% Diff_insert2
thf(fact_252_insert__Diff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A3 ) ) )).

% insert_Diff
thf(fact_253_Diff__insert,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert

%----Type constructors (37)
thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( boolean_algebra @ A10 @ ( type2 @ A10 ) )
     => ( boolean_algebra @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order_top @ A10 @ ( type2 @ A10 ) )
     => ( order_top @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order_bot @ A10 @ ( type2 @ A10 ) )
     => ( order_bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( preorder @ A10 @ ( type2 @ A10 ) )
     => ( preorder @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order @ A10 @ ( type2 @ A10 ) )
     => ( order @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( top @ A10 @ ( type2 @ A10 ) )
     => ( top @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ord @ A10 @ ( type2 @ A10 ) )
     => ( ord @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( bot @ A10 @ ( type2 @ A10 ) )
     => ( bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( uminus @ A10 @ ( type2 @ A10 ) )
     => ( uminus @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( minus @ A10 @ ( type2 @ A10 ) )
     => ( minus @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_1,axiom,(
    ! [A9: $tType] :
      ( boolean_algebra @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_2,axiom,(
    ! [A9: $tType] :
      ( order_top @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_3,axiom,(
    ! [A9: $tType] :
      ( order_bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_4,axiom,(
    ! [A9: $tType] :
      ( preorder @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_5,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_6,axiom,(
    ! [A9: $tType] :
      ( order @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_7,axiom,(
    ! [A9: $tType] :
      ( top @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_8,axiom,(
    ! [A9: $tType] :
      ( ord @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_9,axiom,(
    ! [A9: $tType] :
      ( bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_10,axiom,(
    ! [A9: $tType] :
      ( uminus @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_11,axiom,(
    ! [A9: $tType] :
      ( minus @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_12,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_13,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_14,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_15,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_16,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_17,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_18,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_19,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_20,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_21,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_22,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_23,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( sum_sum @ A9 @ A10 ) @ ( type2 @ ( sum_sum @ A9 @ A10 ) ) ) ) )).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_24,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( option @ A9 ) @ ( type2 @ ( option @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_25,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( product_prod @ A9 @ A10 ) @ ( type2 @ ( product_prod @ A9 @ A10 ) ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ? [N: node,Ns: ( set @ node )] :
      ( ( ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ( bot_bot @ ( set @ node ) ) ) )
        = ( f @ ( product_Pair @ node @ ( set @ node ) @ N @ Ns ) ) )
      & ( finite_finite2 @ node @ Ns )
      & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N @ Ns ) ) @ N ) ) ) )).

%------------------------------------------------------------------------------
