%------------------------------------------------------------------------------
% File     : COM181^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Koenig's lemma 269
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : koenigslemma__269.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  335 (   0 unit;  47 type;   0 defn)
%            Number of atoms       : 4205 ( 226 equality;2373 variable)
%            Maximal formula depth :   28 (   9 average)
%            Number of connectives : 3903 ( 114   ~;   7   |;  61   &;3419   @)
%                                         (   0 <=>; 302  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  243 ( 243   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   51 (  47   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1100 (  10 sgn; 904   !;  24   ?; 116   ^)
%                                         (1100   :;  38  !>;   0  ?*)
%                                         (   0  @-;  18  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:48:04.439
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_node,type,(
    node: $tType )).

%----Explicit typings (40)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oconnected,type,(
    koenig793108494nected: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > $o ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Opaths,type,(
    koenig916195507_paths: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ ( coinductive_llist @ Node ) ) ) )).

thf(sy_c_Koenigslemma__Mirabelle__aepjeeakgn_Oreachable__via,type,(
    koenig317145564le_via: 
      !>[Node: $tType] :
        ( ( Node > Node > $o ) > ( set @ Node ) > Node > ( set @ Node ) ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_LTL____,type,(
    ltl: ( product_prod @ node @ ( set @ node ) ) > ( product_prod @ node @ ( set @ node ) ) )).

thf(sy_v_f____,type,(
    f: ( product_prod @ node @ ( set @ node ) ) > ( coinductive_llist @ node ) )).

thf(sy_v_graph,type,(
    graph: node > node > $o )).

thf(sy_v_n,type,(
    n: node )).

thf(sy_v_na____,type,(
    na: node )).

thf(sy_v_ns____,type,(
    ns: ( set @ node ) )).

thf(sy_v_nsa____,type,(
    nsa: ( set @ node ) )).

%----Relevant facts (256)
thf(fact_0_connected,axiom,
    ( koenig793108494nected @ node @ graph )).

% connected
thf(fact_1__092_060open_062finite_Ans_092_060close_062,axiom,
    ( finite_finite2 @ node @ nsa )).

% \<open>finite ns\<close>
thf(fact_2_finite__branching,axiom,(
    ! [N: node] :
      ( finite_finite2 @ node @ ( collect @ node @ ( graph @ N ) ) ) )).

% finite_branching
thf(fact_3_infinite,axiom,(
    ~ ( finite_finite2 @ node @ ( top_top @ ( set @ node ) ) ) )).

% infinite
thf(fact_4__092_060open_062_092_060exists_062n_H_O_A_Icase_A_In_M_Ans_J_Aof_A_In_M_Ans_J_A_092_060Rightarrow_062_A_092_060lambda_062n_H_O_Agraph_An_An_H_A_092_060and_062_Ainfinite_A_Ireachable__via_Agraph_A_I_N_Ainsert_An_A_Iinsert_An_H_Ans_J_J_An_H_J_A_092_060and_062_An_H_A_092_060notin_062_Ainsert_An_Ans_J_An_H_092_060close_062,axiom,(
    ? [X1: node] :
      ( product_case_prod @ node @ ( set @ node ) @ ( node > $o )
      @ ^ [N2: node,Ns: ( set @ node ),N3: node] :
          ( ( graph @ N2 @ N3 )
          & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N2 @ ( insert @ node @ N3 @ Ns ) ) ) @ N3 ) )
          & ~ ( member @ node @ N3 @ ( insert @ node @ N2 @ Ns ) ) )
      @ ( product_Pair @ node @ ( set @ node ) @ na @ nsa )
      @ X1 ) )).

% \<open>\<exists>n'. (case (n, ns) of (n, ns) \<Rightarrow> \<lambda>n'. graph n n' \<and> infinite (reachable_via graph (- insert n (insert n' ns)) n') \<and> n' \<notin> insert n ns) n'\<close>
thf(fact_5_ldistinct_I1_J,axiom,
    ( ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ na @ nsa ) ) @ na ) )
    & ( finite_finite2 @ node @ nsa ) )).

% ldistinct(1)
thf(fact_6__092_060open_062infinite_A_Ireachable__via_Agraph_A_I_N_Ainsert_An_Ans_J_An_J_092_060close_062,axiom,(
    ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ na @ nsa ) ) @ na ) ) )).

% \<open>infinite (reachable_via graph (- insert n ns) n)\<close>
thf(fact_7_ex__P__I,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ( ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ Na @ Nsa ) ) @ Na ) )
     => ? [X1: node] :
          ( product_case_prod @ node @ ( set @ node ) @ ( node > $o )
          @ ^ [N2: node,Ns: ( set @ node ),N3: node] :
              ( ( graph @ N2 @ N3 )
              & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N2 @ ( insert @ node @ N3 @ Ns ) ) ) @ N3 ) )
              & ~ ( member @ node @ N3 @ ( insert @ node @ N2 @ Ns ) ) )
          @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa )
          @ X1 ) ) )).

% ex_P_I
thf(fact_8__092_060open_062_092_060And_062thesis_O_A_I_092_060lbrakk_062finite_Ans_059_Ainfinite_A_Ireachable__via_Agraph_A_I_N_Ainsert_An_Ans_J_An_J_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ( finite_finite2 @ node @ nsa )
     => ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ na @ nsa ) ) @ na ) ) ) )).

% \<open>\<And>thesis. (\<lbrakk>finite ns; infinite (reachable_via graph (- insert n ns) n)\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_9_LTL__def,axiom,
    ( ltl
    = ( product_case_prod @ node @ ( set @ node ) @ ( product_prod @ node @ ( set @ node ) )
      @ ^ [N2: node,Ns: ( set @ node )] :
          ( product_Pair @ node @ ( set @ node )
          @ ( ^ [P: ( node > $o )] :
              @+[X: node] :
                ( P @ X )
            @ ( product_case_prod @ node @ ( set @ node ) @ ( node > $o )
              @ ^ [O: node,Nt: ( set @ node ),N3: node] :
                  ( ( graph @ O @ N3 )
                  & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ O @ ( insert @ node @ N3 @ Nt ) ) ) @ N3 ) )
                  & ~ ( member @ node @ N3 @ ( insert @ node @ O @ Nt ) ) )
              @ ( product_Pair @ node @ ( set @ node ) @ N2 @ Ns ) ) )
          @ ( insert @ node @ N2 @ Ns ) ) ) )).

% LTL_def
thf(fact_10_case__prodI2_H,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P2: ( product_prod @ A @ B ),C2: ( A > B > C > $o ),X2: C] :
      ( ! [A2: A,B2: B] :
          ( ( ( product_Pair @ A @ B @ A2 @ B2 )
            = P2 )
         => ( C2 @ A2 @ B2 @ X2 ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ X2 ) ) )).

% case_prodI2'
thf(fact_11_case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A3: B,B3: C] :
      ( ( product_case_prod @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A3 @ B3 ) )
      = ( F @ A3 @ B3 ) ) )).

% case_prod_conv
thf(fact_12_finite__insert,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A3 @ A4 ) )
      = ( finite_finite2 @ A @ A4 ) ) )).

% finite_insert
thf(fact_13_some__equality,axiom,(
    ! [A: $tType,P3: ( A > $o ),A3: A] :
      ( ( P3 @ A3 )
     => ( ! [X3: A] :
            ( ( P3 @ X3 )
           => ( X3 = A3 ) )
       => ( ( ^ [P: ( A > $o )] :
              @+[X: A] :
                ( P @ X )
            @ P3 )
          = A3 ) ) ) )).

% some_equality
thf(fact_14_some__eq__trivial,axiom,(
    ! [A: $tType,X2: A] :
      ( ( @+[Y: A] : ( Y = X2 ) )
      = X2 ) )).

% some_eq_trivial
thf(fact_15_some__sym__eq__trivial,axiom,(
    ! [A: $tType,X2: A] :
      ( ( ^ [P: ( A > $o )] :
          @+[X: A] :
            ( P @ X )
        @ ( ^ [Y2: A,Z: A] : ( Y2 = Z )
          @ X2 ) )
      = X2 ) )).

% some_sym_eq_trivial
thf(fact_16_finite__Collect__conjI,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
        | ( finite_finite2 @ A @ ( collect @ A @ Q ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X4: A] :
              ( ( P3 @ X4 )
              & ( Q @ X4 ) ) ) ) ) )).

% finite_Collect_conjI
thf(fact_17_finite__Collect__disjI,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X4: A] :
              ( ( P3 @ X4 )
              | ( Q @ X4 ) ) ) )
      = ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
        & ( finite_finite2 @ A @ ( collect @ A @ Q ) ) ) ) )).

% finite_Collect_disjI
thf(fact_18_ComplI,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A )] :
      ( ~ ( member @ A @ C2 @ A4 )
     => ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) ) )).

% ComplI
thf(fact_19_Compl__iff,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( ~ ( member @ A @ C2 @ A4 ) ) ) )).

% Compl_iff
thf(fact_20_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A4 )
        = ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( A4 = B4 ) ) )).

% Compl_eq_Compl_iff
thf(fact_21_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
      = ( ( A3 = A5 )
        & ( B3 = B5 ) ) ) )).

% old.prod.inject
thf(fact_22_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X12: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X12 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X12 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_23_UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_24_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A6: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_25_insert__absorb2,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ X2 @ A4 ) )
      = ( insert @ A @ X2 @ A4 ) ) )).

% insert_absorb2
thf(fact_26_insert__iff,axiom,(
    ! [A: $tType,A3: A,B3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B3 @ A4 ) )
      = ( ( A3 = B3 )
        | ( member @ A @ A3 @ A4 ) ) ) )).

% insert_iff
thf(fact_27_insertCI,axiom,(
    ! [A: $tType,A3: A,B4: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A3 @ B4 )
       => ( A3 = B3 ) )
     => ( member @ A @ A3 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% insertCI
thf(fact_28_Eps__case__prod__eq,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y3: B] :
      ( ( ^ [P: ( ( product_prod @ A @ B ) > $o )] :
          @+[X: ( product_prod @ A @ B )] :
            ( P @ X )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X5: A,Y4: B] :
              ( ( X2 = X5 )
              & ( Y3 = Y4 ) ) ) )
      = ( product_Pair @ A @ B @ X2 @ Y3 ) ) )).

% Eps_case_prod_eq
thf(fact_29_mem__case__prodI2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( product_prod @ A @ B ),Z2: C,C2: ( A > B > ( set @ C ) )] :
      ( ! [A2: A,B2: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A2 @ B2 ) )
         => ( member @ C @ Z2 @ ( C2 @ A2 @ B2 ) ) )
     => ( member @ C @ Z2 @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P2 ) ) ) )).

% mem_case_prodI2
thf(fact_30_mem__case__prodI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: ( B > C > ( set @ A ) ),A3: B,B3: C] :
      ( ( member @ A @ Z2 @ ( C2 @ A3 @ B3 ) )
     => ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A3 @ B3 ) ) ) ) )).

% mem_case_prodI
thf(fact_31_case__prodI2,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B ),C2: ( A > B > $o )] :
      ( ! [A2: A,B2: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A2 @ B2 ) )
         => ( C2 @ A2 @ B2 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P2 ) ) )).

% case_prodI2
thf(fact_32_case__prodI,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A3: A,B3: B] :
      ( ( F @ A3 @ B3 )
     => ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A3 @ B3 ) ) ) )).

% case_prodI
thf(fact_33_finite__Plus__UNIV__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_Plus_UNIV_iff
thf(fact_34_finite__Collect__not,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ( ( finite_finite2 @ A
          @ ( collect @ A
            @ ^ [X4: A] :
                ~ ( P3 @ X4 ) ) )
        = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finite_Collect_not
thf(fact_35_finite__compl,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( finite_finite2 @ A @ A4 )
     => ( ( finite_finite2 @ A @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
        = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finite_compl
thf(fact_36_UNIV__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X4: A] : $true ) ) )).

% UNIV_def
thf(fact_37_UNIV__eq__I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A4 )
     => ( ( top_top @ ( set @ A ) )
        = A4 ) ) )).

% UNIV_eq_I
thf(fact_38_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_39_Finite__Set_Ofinite__set,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% Finite_Set.finite_set
thf(fact_40_finite__prod,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_prod
thf(fact_41_finite__Prod__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% finite_Prod_UNIV
thf(fact_42_finite__fun__UNIVD2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) )).

% finite_fun_UNIVD2
thf(fact_43_split__paired__Eps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P: ( ( product_prod @ A @ B ) > $o )] :
          @+[X: ( product_prod @ A @ B )] :
            ( P @ X ) )
      = ( ^ [P4: ( ( product_prod @ A @ B ) > $o )] :
            ( ^ [P: ( ( product_prod @ A @ B ) > $o )] :
              @+[X: ( product_prod @ A @ B )] :
                ( P @ X )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [A7: A,B6: B] :
                  ( P4 @ ( product_Pair @ A @ B @ A7 @ B6 ) ) ) ) ) ) )).

% split_paired_Eps
thf(fact_44_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ( ! [X3: B,Y5: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X3 @ Y5 ) )
             => ~ ( member @ A @ Z2 @ ( C2 @ X3 @ Y5 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P3: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P3 ) )
      = ( P3 @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P3 @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P3 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_finite__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_UNIV
thf(fact_50_infinite__UNIV__char__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% infinite_UNIV_char_0
thf(fact_51_ex__new__if__finite,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A @ A4 )
       => ? [A2: A] :
            ~ ( member @ A @ A2 @ A4 ) ) ) )).

% ex_new_if_finite
thf(fact_52_insert__UNIV,axiom,(
    ! [A: $tType,X2: A] :
      ( ( insert @ A @ X2 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% insert_UNIV
thf(fact_53_case__prodE,axiom,(
    ! [A: $tType,B: $tType,C2: ( A > B > $o ),P2: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P2 )
     => ~ ( ! [X3: A,Y5: B] :
              ( ( P2
                = ( product_Pair @ A @ B @ X3 @ Y5 ) )
             => ~ ( C2 @ X3 @ Y5 ) ) ) ) )).

% case_prodE
thf(fact_54_case__prodD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A3: A,B3: B] :
      ( ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ( F @ A3 @ B3 ) ) )).

% case_prodD
thf(fact_55_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P3: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A2: A,B2: B] :
          ( P3 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( P3 @ Prod ) ) )).

% old.prod.inducts
thf(fact_56_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y3: ( product_prod @ A @ B )] :
      ~ ( ! [A2: A,B2: B] :
            ( Y3
           != ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% old.prod.exhaust
thf(fact_57_prod__induct7,axiom,(
    ! [G2: $tType,F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) )] :
      ( ! [A2: A,B2: B,C3: C,D2: D,E2: E,F3: F2,G3: G2] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) @ B2 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G2 ) @ E2 @ ( product_Pair @ F2 @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P3 @ X2 ) ) )).

% prod_induct7
thf(fact_58_prod__induct6,axiom,(
    ! [F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ( ! [A2: A,B2: B,C3: C,D2: D,E2: E,F3: F2] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B2 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) )
     => ( P3 @ X2 ) ) )).

% prod_induct6
thf(fact_59_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A2: A,B2: B,C3: C,D2: D,E2: E] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B2 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P3 @ X2 ) ) )).

% prod_induct5
thf(fact_60_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A2: A,B2: B,C3: C,D2: D] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B2 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P3 @ X2 ) ) )).

% prod_induct4
thf(fact_61_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P3: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A2: A,B2: B,C3: C] :
          ( P3 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A2 @ ( product_Pair @ B @ C @ B2 @ C3 ) ) )
     => ( P3 @ X2 ) ) )).

% prod_induct3
thf(fact_62_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,G2: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A2: A,B2: B,C3: C,D2: D,E2: E,F3: F2,G3: G2] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) @ B2 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G2 ) @ E2 @ ( product_Pair @ F2 @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_63_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ~ ( ! [A2: A,B2: B,C3: C,D2: D,E2: E,F3: F2] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B2 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_64_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A2: A,B2: B,C3: C,D2: D,E2: E] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B2 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_65_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A2: A,B2: B,C3: C,D2: D] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A2 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B2 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_66_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A2: A,B2: B,C3: C] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A2 @ ( product_Pair @ B @ C @ B2 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_67_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ~ ( ( A3 = A5 )
         => ( B3 != B5 ) ) ) )).

% Pair_inject
thf(fact_68_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P3: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A2: A,B2: B] :
          ( P3 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( P3 @ P2 ) ) )).

% prod_cases
thf(fact_69_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y5: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y5 ) ) )).

% surj_pair
thf(fact_70_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A4: ( set @ A )] :
          ( finite_finite2 @ A @ A4 ) ) )).

% finite
thf(fact_71_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),P3: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A4 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ? [X13: B] :
                ( P3 @ X3 @ X13 ) )
       => ? [F3: ( A > B )] :
          ! [X6: A] :
            ( ( member @ A @ X6 @ A4 )
           => ( P3 @ X6 @ ( F3 @ X6 ) ) ) ) ) )).

% finite_set_choice
thf(fact_72_mk__disjoint__insert,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ A4 )
     => ? [B7: ( set @ A )] :
          ( ( A4
            = ( insert @ A @ A3 @ B7 ) )
          & ~ ( member @ A @ A3 @ B7 ) ) ) )).

% mk_disjoint_insert
thf(fact_73_insert__commute,axiom,(
    ! [A: $tType,X2: A,Y3: A,A4: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ Y3 @ A4 ) )
      = ( insert @ A @ Y3 @ ( insert @ A @ X2 @ A4 ) ) ) )).

% insert_commute
thf(fact_74_insert__eq__iff,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B3: A,B4: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ A4 )
     => ( ~ ( member @ A @ B3 @ B4 )
       => ( ( ( insert @ A @ A3 @ A4 )
            = ( insert @ A @ B3 @ B4 ) )
          = ( ( ( A3 = B3 )
             => ( A4 = B4 ) )
            & ( ( A3 != B3 )
             => ? [C4: ( set @ A )] :
                  ( ( A4
                    = ( insert @ A @ B3 @ C4 ) )
                  & ~ ( member @ A @ B3 @ C4 )
                  & ( B4
                    = ( insert @ A @ A3 @ C4 ) )
                  & ~ ( member @ A @ A3 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_75_insert__absorb,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( insert @ A @ A3 @ A4 )
        = A4 ) ) )).

% insert_absorb
thf(fact_76_insert__ident,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A4 )
     => ( ~ ( member @ A @ X2 @ B4 )
       => ( ( ( insert @ A @ X2 @ A4 )
            = ( insert @ A @ X2 @ B4 ) )
          = ( A4 = B4 ) ) ) ) )).

% insert_ident
thf(fact_77_Set_Oset__insert,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A )] :
      ( ( member @ A @ X2 @ A4 )
     => ~ ( ! [B7: ( set @ A )] :
              ( ( A4
                = ( insert @ A @ X2 @ B7 ) )
             => ( member @ A @ X2 @ B7 ) ) ) ) )).

% Set.set_insert
thf(fact_78_insertI2,axiom,(
    ! [A: $tType,A3: A,B4: ( set @ A ),B3: A] :
      ( ( member @ A @ A3 @ B4 )
     => ( member @ A @ A3 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% insertI2
thf(fact_79_insertI1,axiom,(
    ! [A: $tType,A3: A,B4: ( set @ A )] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ B4 ) ) )).

% insertI1
thf(fact_80_insertE,axiom,(
    ! [A: $tType,A3: A,B3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B3 @ A4 ) )
     => ( ( A3 != B3 )
       => ( member @ A @ A3 @ A4 ) ) ) )).

% insertE
thf(fact_81_double__complement,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = A4 ) )).

% double_complement
thf(fact_82_ComplD,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
     => ~ ( member @ A @ C2 @ A4 ) ) )).

% ComplD
thf(fact_83_tfl__some,axiom,(
    ! [A: $tType,P5: ( A > $o ),X6: A] :
      ( ( P5 @ X6 )
     => ( P5
        @ ( ^ [P: ( A > $o )] :
            @+[X: A] :
              ( P @ X )
          @ P5 ) ) ) )).

% tfl_some
thf(fact_84_someI,axiom,(
    ! [A: $tType,P3: ( A > $o ),X2: A] :
      ( ( P3 @ X2 )
     => ( P3
        @ ( ^ [P: ( A > $o )] :
            @+[X: A] :
              ( P @ X )
          @ P3 ) ) ) )).

% someI
thf(fact_85_pigeonhole__infinite__rel,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),B4: ( set @ B ),R: ( A > B > $o )] :
      ( ~ ( finite_finite2 @ A @ A4 )
     => ( ( finite_finite2 @ B @ B4 )
       => ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ? [Xa: B] :
                  ( ( member @ B @ Xa @ B4 )
                  & ( R @ X3 @ Xa ) ) )
         => ? [X3: B] :
              ( ( member @ B @ X3 @ B4 )
              & ~ ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [A7: A] :
                        ( ( member @ A @ A7 @ A4 )
                        & ( R @ A7 @ X3 ) ) ) ) ) ) ) ) )).

% pigeonhole_infinite_rel
thf(fact_86_not__finite__existsD,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ~ ( finite_finite2 @ A @ ( collect @ A @ P3 ) )
     => ? [X1: A] :
          ( P3 @ X1 ) ) )).

% not_finite_existsD
thf(fact_87_prod_Ocase__distrib,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: ( C > D ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X14: A,X23: B] :
            ( H @ ( F @ X14 @ X23 ) )
        @ Prod ) ) )).

% prod.case_distrib
thf(fact_88_insert__Collect,axiom,(
    ! [A: $tType,A3: A,P3: ( A > $o )] :
      ( ( insert @ A @ A3 @ ( collect @ A @ P3 ) )
      = ( collect @ A
        @ ^ [U: A] :
            ( ( U != A3 )
           => ( P3 @ U ) ) ) ) )).

% insert_Collect
thf(fact_89_insert__compr,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A7: A,B8: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A7 )
                | ( member @ A @ X4 @ B8 ) ) ) ) ) )).

% insert_compr
thf(fact_90_Collect__neg__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ~ ( P3 @ X4 ) )
      = ( uminus_uminus @ ( set @ A ) @ ( collect @ A @ P3 ) ) ) )).

% Collect_neg_eq
thf(fact_91_Compl__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A6: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ~ ( member @ A @ X4 @ A6 ) ) ) ) )).

% Compl_eq
thf(fact_92_some1__equality,axiom,(
    ! [A: $tType,P3: ( A > $o ),A3: A] :
      ( ? [X6: A] :
          ( ( P3 @ X6 )
          & ! [Y5: A] :
              ( ( P3 @ Y5 )
             => ( Y5 = X6 ) ) )
     => ( ( P3 @ A3 )
       => ( ( ^ [P: ( A > $o )] :
              @+[X: A] :
                ( P @ X )
            @ P3 )
          = A3 ) ) ) )).

% some1_equality
thf(fact_93_some__eq__ex,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( P3
        @ ( ^ [P: ( A > $o )] :
            @+[X: A] :
              ( P @ X )
          @ P3 ) )
      = ( ^ [P: ( A > $o )] :
          ? [X: A] :
            ( P @ X )
        @ P3 ) ) )).

% some_eq_ex
thf(fact_94_someI2__bex,axiom,(
    ! [A: $tType,A4: ( set @ A ),P3: ( A > $o ),Q: ( A > $o )] :
      ( ? [X6: A] :
          ( ( member @ A @ X6 @ A4 )
          & ( P3 @ X6 ) )
     => ( ! [X3: A] :
            ( ( ( member @ A @ X3 @ A4 )
              & ( P3 @ X3 ) )
           => ( Q @ X3 ) )
       => ( Q
          @ @+[X4: A] :
              ( ( member @ A @ X4 @ A4 )
              & ( P3 @ X4 ) ) ) ) ) )).

% someI2_bex
thf(fact_95_someI2__ex,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ? [X13: A] :
          ( P3 @ X13 )
     => ( ! [X3: A] :
            ( ( P3 @ X3 )
           => ( Q @ X3 ) )
       => ( Q
          @ ( ^ [P: ( A > $o )] :
              @+[X: A] :
                ( P @ X )
            @ P3 ) ) ) ) )).

% someI2_ex
thf(fact_96_someI__ex,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ? [X13: A] :
          ( P3 @ X13 )
     => ( P3
        @ ( ^ [P: ( A > $o )] :
            @+[X: A] :
              ( P @ X )
          @ P3 ) ) ) )).

% someI_ex
thf(fact_97_someI2,axiom,(
    ! [A: $tType,P3: ( A > $o ),A3: A,Q: ( A > $o )] :
      ( ( P3 @ A3 )
     => ( ! [X3: A] :
            ( ( P3 @ X3 )
           => ( Q @ X3 ) )
       => ( Q
          @ ( ^ [P: ( A > $o )] :
              @+[X: A] :
                ( P @ X )
            @ P3 ) ) ) ) )).

% someI2
thf(fact_98_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X12: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X12 @ X22 ) )
      = ( F @ X12 @ X22 ) ) )).

% old.prod.case
thf(fact_99_finite_OinsertI,axiom,(
    ! [A: $tType,A4: ( set @ A ),A3: A] :
      ( ( finite_finite2 @ A @ A4 )
     => ( finite_finite2 @ A @ ( insert @ A @ A3 @ A4 ) ) ) )).

% finite.insertI
thf(fact_100_cond__case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),G: ( ( product_prod @ A @ B ) > C )] :
      ( ! [X3: A,Y5: B] :
          ( ( F @ X3 @ Y5 )
          = ( G @ ( product_Pair @ A @ B @ X3 @ Y5 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F )
        = G ) ) )).

% cond_case_prod_eta
thf(fact_101_case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X4: A,Y: B] :
            ( F @ ( product_Pair @ A @ B @ X4 @ Y ) ) )
      = F ) )).

% case_prod_eta
thf(fact_102_case__prodE2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Q: ( A > $o ),P3: ( B > C > A ),Z2: ( product_prod @ B @ C )] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P3 @ Z2 ) )
     => ~ ( ! [X3: B,Y5: C] :
              ( ( Z2
                = ( product_Pair @ B @ C @ X3 @ Y5 ) )
             => ~ ( Q @ ( P3 @ X3 @ Y5 ) ) ) ) ) )).

% case_prodE2
thf(fact_103_case__prodE_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( A > B > C > $o ),P2: ( product_prod @ A @ B ),Z2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ Z2 )
     => ~ ( ! [X3: A,Y5: B] :
              ( ( P2
                = ( product_Pair @ A @ B @ X3 @ Y5 ) )
             => ~ ( C2 @ X3 @ Y5 @ Z2 ) ) ) ) )).

% case_prodE'
thf(fact_104_case__prodD_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R: ( A > B > C > $o ),A3: A,B3: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A3 @ B3 ) @ C2 )
     => ( R @ A3 @ B3 @ C2 ) ) )).

% case_prodD'
thf(fact_105_finite__option__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_option_UNIV
thf(fact_106_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A3: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( F1 @ A3 @ B3 ) ) )).

% old.prod.rec
thf(fact_107_case__prod__Pair__iden,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P2 )
      = P2 ) )).

% case_prod_Pair_iden
thf(fact_108_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_109_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A] :
          ( ( ( uminus_uminus @ A @ X2 )
            = ( uminus_uminus @ A @ Y3 ) )
          = ( X2 = Y3 ) ) ) )).

% compl_eq_compl_iff
thf(fact_110_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X2 ) )
          = X2 ) ) )).

% double_compl
thf(fact_111_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B3 ) )
          = ( A3 = B3 ) ) ) )).

% neg_equal_iff_equal
thf(fact_112_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A3 ) )
          = A3 ) ) )).

% add.inverse_inverse
thf(fact_113_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A6: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A6 @ X4 ) ) ) ) ) )).

% uminus_apply
thf(fact_114_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X4: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_115_split__part,axiom,(
    ! [B: $tType,A: $tType,P3: $o,Q: ( A > B > $o )] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A7: A,B6: B] :
            ( P3
            & ( Q @ A7 @ B6 ) ) )
      = ( ^ [Ab: ( product_prod @ A @ B )] :
            ( P3
            & ( product_case_prod @ A @ B @ $o @ Q @ Ab ) ) ) ) )).

% split_part
thf(fact_116_prod_Odisc__eq__case,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu: A,Uv: B] : $true
      @ Prod ) )).

% prod.disc_eq_case
thf(fact_117_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_118_uminus__set__def,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( ^ [A6: ( set @ A )] :
            ( collect @ A
            @ ( uminus_uminus @ ( A > $o )
              @ ^ [X4: A] :
                  ( member @ A @ X4 @ A6 ) ) ) ) ) )).

% uminus_set_def
thf(fact_119_fun__Compl__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A6: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A6 @ X4 ) ) ) ) ) )).

% fun_Compl_def
thf(fact_120_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B3 ) )
          = ( B3
            = ( uminus_uminus @ A @ A3 ) ) ) ) )).

% equation_minus_iff
thf(fact_121_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B3 )
          = ( ( uminus_uminus @ A @ B3 )
            = A3 ) ) ) )).

% minus_equation_iff
thf(fact_122_case__prod__app,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F4: ( B > C > D > A ),X4: ( product_prod @ B @ C ),Y: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L: B,R2: C] :
                ( F4 @ L @ R2 @ Y )
            @ X4 ) ) ) )).

% case_prod_app
thf(fact_123_top__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X4: A,Y: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% top_empty_eq2
thf(fact_124__092_060open_062infinite_A_Ireachable__via_Agraph_A_I_N_Ainsert_An_Ans_____J_An_J_A_092_060and_062_Afinite_Ans_____092_060close_062,axiom,
    ( ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ns ) ) @ n ) )
    & ( finite_finite2 @ node @ ns ) )).

% \<open>infinite (reachable_via graph (- insert n ns__) n) \<and> finite ns__\<close>
thf(fact_125_ldistinct_I2_J,axiom,(
    ~ ( coinductive_lnull @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ na @ nsa ) ) ) )).

% ldistinct(2)
thf(fact_126_f__simps_I3_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ( ( coinductive_ltl @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) )
      = ( f
        @ ( product_Pair @ node @ ( set @ node )
          @ ( ^ [P: ( node > $o )] :
              @+[X: node] :
                ( P @ X )
            @ ( product_case_prod @ node @ ( set @ node ) @ ( node > $o )
              @ ^ [N2: node,Ns: ( set @ node ),N3: node] :
                  ( ( graph @ N2 @ N3 )
                  & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N2 @ ( insert @ node @ N3 @ Ns ) ) ) @ N3 ) )
                  & ~ ( member @ node @ N3 @ ( insert @ node @ N2 @ Ns ) ) )
              @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) )
          @ ( insert @ node @ Na @ Nsa ) ) ) ) )).

% f_simps(3)
thf(fact_127_f__simps_I1_J,axiom,(
    ! [Na: node,Nsa: ( set @ node )] :
      ~ ( coinductive_lnull @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) ) )).

% f_simps(1)
thf(fact_128_top1I,axiom,(
    ! [A: $tType,X2: A] :
      ( top_top @ ( A > $o ) @ X2 ) )).

% top1I
thf(fact_129_ns__def,axiom,
    ( ns
    = ( bot_bot @ ( set @ node ) ) )).

% ns_def
thf(fact_130_top2I,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y3: B] :
      ( top_top @ ( A > B > $o ) @ X2 @ Y3 ) )).

% top2I
thf(fact_131_top__conj_I2_J,axiom,(
    ! [A: $tType,P3: $o,X2: A] :
      ( ( P3
        & ( top_top @ ( A > $o ) @ X2 ) )
      = P3 ) )).

% top_conj(2)
thf(fact_132_top__conj_I1_J,axiom,(
    ! [A: $tType,X2: A,P3: $o] :
      ( ( ( top_top @ ( A > $o ) @ X2 )
        & P3 )
      = P3 ) )).

% top_conj(1)
thf(fact_133_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_134_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X4: A,Y: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ R ) )
        = ( ^ [X4: A,Y: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ S ) ) )
      = ( R = S ) ) )).

% pred_equals_eq2
thf(fact_135_X,axiom,(
    ? [N4: node,Ns2: ( set @ node )] :
      ( ( ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ( bot_bot @ ( set @ node ) ) ) )
        = ( f @ ( product_Pair @ node @ ( set @ node ) @ N4 @ Ns2 ) ) )
      & ( finite_finite2 @ node @ Ns2 )
      & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N4 @ Ns2 ) ) @ N4 ) ) ) )).

% X
thf(fact_136__092_060open_062infinite_A_Ireachable__via_Agraph_A_I_N_A_123n_125_J_An_J_092_060close_062,axiom,(
    ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ n ) ) )).

% \<open>infinite (reachable_via graph (- {n}) n)\<close>
thf(fact_137_lset,axiom,(
    ! [X7: node,Na: node,Nsa: ( set @ node )] :
      ( ( member @ node @ X7 @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ Na @ Nsa ) ) ) )
     => ( ~ ( member @ node @ Na @ Nsa )
       => ( ( finite_finite2 @ node @ Nsa )
         => ( ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ Na @ Nsa ) ) @ Na ) )
           => ~ ( member @ node @ X7 @ Nsa ) ) ) ) ) )).

% lset
thf(fact_138__092_060open_062n_A_092_060in_062_Alset_A_If_A_In_M_Ans_____J_J_092_060close_062,axiom,
    ( member @ node @ n @ ( coinductive_lset @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) )).

% \<open>n \<in> lset (f (n, ns__))\<close>
thf(fact_139_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X4: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_140_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_141_all__not__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_142_Collect__empty__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( collect @ A @ P3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P3 @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_143_empty__Collect__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P3 ) )
      = ( ! [X4: A] :
            ~ ( P3 @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_144_singletonI,axiom,(
    ! [A: $tType,A3: A] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_145_Collect__const,axiom,(
    ! [A: $tType,P3: $o] :
      ( ( P3
       => ( ( collect @ A
            @ ^ [S2: A] : P3 )
          = ( top_top @ ( set @ A ) ) ) )
      & ( ~ ( P3 )
       => ( ( collect @ A
            @ ^ [S2: A] : P3 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_const
thf(fact_146_singleton__conv,axiom,(
    ! [A: $tType,A3: A] :
      ( ( collect @ A
        @ ^ [X4: A] : ( X4 = A3 ) )
      = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv
thf(fact_147_singleton__conv2,axiom,(
    ! [A: $tType,A3: A] :
      ( ( collect @ A
        @ ( ^ [Y2: A,Z: A] : ( Y2 = Z )
          @ A3 ) )
      = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv2
thf(fact_148_compl__top__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( top_top @ A ) )
        = ( bot_bot @ A ) ) ) )).

% compl_top_eq
thf(fact_149_compl__bot__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( bot_bot @ A ) )
        = ( top_top @ A ) ) ) )).

% compl_bot_eq
thf(fact_150_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_151_emptyE,axiom,(
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_152_equals0D,axiom,(
    ! [A: $tType,A4: ( set @ A ),A3: A] :
      ( ( A4
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A3 @ A4 ) ) )).

% equals0D
thf(fact_153_equals0I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [Y5: A] :
          ~ ( member @ A @ Y5 @ A4 )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_154_ex__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A4 ) )
      = ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_155_singleton__inject,axiom,(
    ! [A: $tType,A3: A,B3: A] :
      ( ( ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A3 = B3 ) ) )).

% singleton_inject
thf(fact_156_insert__not__empty,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( insert @ A @ A3 @ A4 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_157_doubleton__eq__iff,axiom,(
    ! [A: $tType,A3: A,B3: A,C2: A,D3: A] :
      ( ( ( insert @ A @ A3 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A3 = C2 )
          & ( B3 = D3 ) )
        | ( ( A3 = D3 )
          & ( B3 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_158_singleton__iff,axiom,(
    ! [A: $tType,B3: A,A3: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A3 ) ) )).

% singleton_iff
thf(fact_159_singletonD,axiom,(
    ! [A: $tType,B3: A,A3: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A3 ) ) )).

% singletonD
thf(fact_160_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_161_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_162_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X4: A] : $false ) ) )).

% empty_def
thf(fact_163_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_164_Collect__conv__if,axiom,(
    ! [A: $tType,P3: ( A > $o ),A3: A] :
      ( ( ( P3 @ A3 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A3 )
                & ( P3 @ X4 ) ) )
          = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P3 @ A3 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A3 )
                & ( P3 @ X4 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if
thf(fact_165_Collect__conv__if2,axiom,(
    ! [A: $tType,P3: ( A > $o ),A3: A] :
      ( ( ( P3 @ A3 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( A3 = X4 )
                & ( P3 @ X4 ) ) )
          = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P3 @ A3 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( A3 = X4 )
                & ( P3 @ X4 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if2
thf(fact_166_some__in__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( member @ A
        @ @+[X4: A] :
            ( member @ A @ X4 @ A4 )
        @ A4 )
      = ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% some_in_eq
thf(fact_167_finite_Ocases,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A8: ( set @ A )] :
                ( ? [A2: A] :
                    ( A3
                    = ( insert @ A @ A2 @ A8 ) )
               => ~ ( finite_finite2 @ A @ A8 ) ) ) ) ) )).

% finite.cases
thf(fact_168_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A7: ( set @ A )] :
            ( ( A7
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A6: ( set @ A ),B6: A] :
                ( ( A7
                  = ( insert @ A @ B6 @ A6 ) )
                & ( finite_finite2 @ A @ A6 ) ) ) ) ) )).

% finite.simps
thf(fact_169_finite__induct,axiom,(
    ! [A: $tType,F5: ( set @ A ),P3: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( ( P3 @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X3 @ F6 )
               => ( ( P3 @ F6 )
                 => ( P3 @ ( insert @ A @ X3 @ F6 ) ) ) ) )
         => ( P3 @ F5 ) ) ) ) )).

% finite_induct
thf(fact_170_finite_Oinducts,axiom,(
    ! [A: $tType,X2: ( set @ A ),P3: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X2 )
     => ( ( P3 @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: ( set @ A ),A2: A] :
              ( ( finite_finite2 @ A @ A8 )
             => ( ( P3 @ A8 )
               => ( P3 @ ( insert @ A @ A2 @ A8 ) ) ) )
         => ( P3 @ X2 ) ) ) ) )).

% finite.inducts
thf(fact_171_finite__ne__induct,axiom,(
    ! [A: $tType,F5: ( set @ A ),P3: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( ( F5
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A] :
              ( P3 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X3: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( F6
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X3 @ F6 )
                   => ( ( P3 @ F6 )
                     => ( P3 @ ( insert @ A @ X3 @ F6 ) ) ) ) ) )
           => ( P3 @ F5 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_172_infinite__finite__induct,axiom,(
    ! [A: $tType,P3: ( ( set @ A ) > $o ),A4: ( set @ A )] :
      ( ! [A8: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A8 )
         => ( P3 @ A8 ) )
     => ( ( P3 @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X3 @ F6 )
               => ( ( P3 @ F6 )
                 => ( P3 @ ( insert @ A @ X3 @ F6 ) ) ) ) )
         => ( P3 @ A4 ) ) ) ) )).

% infinite_finite_induct
thf(fact_173_Compl__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Compl_empty_eq
thf(fact_174_Compl__UNIV__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_UNIV_eq
thf(fact_175__092_060open_062f_A_In_M_A_123_125_J_A_092_060in_062_Apaths_Agraph_092_060close_062,axiom,
    ( member @ ( coinductive_llist @ node ) @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ ( koenig916195507_paths @ node @ graph ) )).

% \<open>f (n, {}) \<in> paths graph\<close>
thf(fact_176_lset__eq__empty,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lset_eq_empty
thf(fact_177__092_060open_062_N_A_123n_125_A_092_060subseteq_062_Areachable__via_Agraph_A_I_N_A_123n_125_J_An_092_060close_062,axiom,
    ( ord_less_eq @ ( set @ node ) @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ n @ ( bot_bot @ ( set @ node ) ) ) ) @ n ) )).

% \<open>- {n} \<subseteq> reachable_via graph (- {n}) n\<close>
thf(fact_178__092_060open_062_092_060not_062_Alfinite_A_If_A_In_M_Ans_____J_J_092_060close_062,axiom,(
    ~ ( coinductive_lfinite @ node @ ( f @ ( product_Pair @ node @ ( set @ node ) @ n @ ns ) ) ) )).

% \<open>\<not> lfinite (f (n, ns__))\<close>
thf(fact_179_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ X2 @ X2 ) ) )).

% order_refl
thf(fact_180_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_181_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( member @ A @ X3 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% subsetI
thf(fact_182_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B3 ) ) ) )).

% neg_le_iff_le
thf(fact_183_compl__le__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X2 ) ) ) )).

% compl_le_compl_iff
thf(fact_184_subset__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_185_empty__subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 ) )).

% empty_subsetI
thf(fact_186_insert__subset,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A4 ) @ B4 )
      = ( ( member @ A @ X2 @ B4 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% insert_subset
thf(fact_187_Compl__subset__Compl__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) )
      = ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) )).

% Compl_subset_Compl_iff
thf(fact_188_Compl__anti__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B4 ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) ) )).

% Compl_anti_mono
thf(fact_189_lfinite__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_ltl @ A @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_ltl
thf(fact_190_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B3: A] :
      ( ( ( insert @ A @ A3 @ A4 )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_191_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B3: A,A3: A,A4: ( set @ A )] :
      ( ( ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A3 @ A4 ) )
      = ( ( A3 = B3 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_192_finite__Collect__subsets,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( finite_finite2 @ A @ A4 )
     => ( finite_finite2 @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: ( set @ A )] :
              ( ord_less_eq @ ( set @ A ) @ B8 @ A4 ) ) ) ) )).

% finite_Collect_subsets
thf(fact_193_subset__Compl__singleton,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B3 @ A4 ) ) ) )).

% subset_Compl_singleton
thf(fact_194_bot__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X4: A,Y: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X4 @ Y ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% bot_empty_eq2
thf(fact_195_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_196_lset__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) @ ( coinductive_lset @ A @ Xs ) ) )).

% lset_ltl
thf(fact_197_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_198_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) )).

% bot.extremum
thf(fact_199_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_200_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_201_lfinite__imp__finite__lset,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( finite_finite2 @ A @ ( coinductive_lset @ A @ Xs ) ) ) )).

% lfinite_imp_finite_lset
thf(fact_202_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B3 )
           => ( A3 = B3 ) ) ) ) )).

% dual_order.antisym
thf(fact_203_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B3 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_204_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > A > $o ),A3: A,B3: A] :
          ( ! [A2: A,B2: A] :
              ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( P3 @ A2 @ B2 ) )
         => ( ! [A2: A,B2: A] :
                ( ( P3 @ B2 @ A2 )
               => ( P3 @ A2 @ B2 ) )
           => ( P3 @ A3 @ B3 ) ) ) ) )).

% linorder_wlog
thf(fact_205_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_206_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A,Z2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ Z2 )
           => ( ord_less_eq @ A @ X2 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_207_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A3 )
           => ( A3 = B3 ) ) ) ) )).

% order_class.order.antisym
thf(fact_208_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_209_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( A3 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_210_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y3: A,X2: A] :
          ( ( ord_less_eq @ A @ Y3 @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y3 )
            = ( X2 = Y3 ) ) ) ) )).

% antisym_conv
thf(fact_211_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y3 )
           => ~ ( ord_less_eq @ A @ Y3 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y3 @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y3 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y3 )
                 => ~ ( ord_less_eq @ A @ Y3 @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y3 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y3 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_212_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% order.trans
thf(fact_213_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y3 )
         => ( ord_less_eq @ A @ Y3 @ X2 ) ) ) )).

% le_cases
thf(fact_214_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A] :
          ( ( X2 = Y3 )
         => ( ord_less_eq @ A @ X2 @ Y3 ) ) ) )).

% eq_refl
thf(fact_215_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A] :
          ( ( ord_less_eq @ A @ X2 @ Y3 )
          | ( ord_less_eq @ A @ Y3 @ X2 ) ) ) )).

% linear
thf(fact_216_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X2: A,Y3: A] :
          ( ( ord_less_eq @ A @ X2 @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ X2 )
           => ( X2 = Y3 ) ) ) ) )).

% antisym
thf(fact_217_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [X4: A,Y: A] :
              ( ( ord_less_eq @ A @ X4 @ Y )
              & ( ord_less_eq @ A @ Y @ X4 ) ) ) ) ) )).

% eq_iff
thf(fact_218_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B3: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ( F @ B3 )
              = C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ B @ ( F @ X3 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ B @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_219_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B3: B,C2: B] :
          ( ( A3
            = ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_220_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B3: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ C @ ( F @ B3 ) @ C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ C @ ( F @ X3 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_221_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B3: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_222_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B )] :
            ! [X4: A] :
              ( ord_less_eq @ B @ ( F4 @ X4 ) @ ( G4 @ X4 ) ) ) ) ) )).

% le_fun_def
thf(fact_223_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X3: A] :
              ( ord_less_eq @ B @ ( F @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_224_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funE
thf(fact_225_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funD
thf(fact_226_finite__subset,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( finite_finite2 @ A @ B4 )
       => ( finite_finite2 @ A @ A4 ) ) ) )).

% finite_subset
thf(fact_227_infinite__super,axiom,(
    ! [A: $tType,S: ( set @ A ),T2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
     => ( ~ ( finite_finite2 @ A @ S )
       => ~ ( finite_finite2 @ A @ T2 ) ) ) )).

% infinite_super
thf(fact_228_rev__finite__subset,axiom,(
    ! [A: $tType,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( finite_finite2 @ A @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( finite_finite2 @ A @ A4 ) ) ) )).

% rev_finite_subset
thf(fact_229_Set_Oinsert__mono,axiom,(
    ! [A: $tType,C5: ( set @ A ),D4: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C5 @ D4 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A3 @ C5 ) @ ( insert @ A @ A3 @ D4 ) ) ) )).

% Set.insert_mono
thf(fact_230_subset__insert,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X2 @ B4 ) )
        = ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% subset_insert
thf(fact_231_subset__insertI,axiom,(
    ! [A: $tType,B4: ( set @ A ),A3: A] :
      ( ord_less_eq @ ( set @ A ) @ B4 @ ( insert @ A @ A3 @ B4 ) ) )).

% subset_insertI
thf(fact_232_subset__insertI2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),B3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B3 @ B4 ) ) ) )).

% subset_insertI2
thf(fact_233_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > A > $o ),B3: A,A3: A] :
          ( ! [A2: A,B2: A] :
              ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( P3 @ A2 @ B2 ) )
         => ( ( ( P3 @ B3 @ A3 )
             => ( P3 @ A3 @ B3 ) )
           => ( P3 @ A3 @ B3 ) ) ) ) )).

% wlog_linorder_le
thf(fact_234_Collect__mono__iff,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) )
      = ( ! [X4: A] :
            ( ( P3 @ X4 )
           => ( Q @ X4 ) ) ) ) )).

% Collect_mono_iff
thf(fact_235_contra__subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ~ ( member @ A @ C2 @ B4 )
       => ~ ( member @ A @ C2 @ A4 ) ) ) )).

% contra_subsetD
thf(fact_236_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y2: ( set @ A ),Z: ( set @ A )] : ( Y2 = Z ) )
      = ( ^ [A6: ( set @ A ),B8: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A6 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A6 ) ) ) ) )).

% set_eq_subset
thf(fact_237_subset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ A4 @ C5 ) ) ) )).

% subset_trans
thf(fact_238_Collect__mono,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P3 @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_239_subset__refl,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ A4 ) )).

% subset_refl
thf(fact_240_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% rev_subsetD
thf(fact_241_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B8: ( set @ A )] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A6 )
           => ( member @ A @ T3 @ B8 ) ) ) ) )).

% subset_iff
thf(fact_242_set__rev__mp,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ X2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% set_rev_mp
thf(fact_243_equalityD2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) )).

% equalityD2
thf(fact_244_equalityD1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% equalityD1
thf(fact_245_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B8: ( set @ A )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A6 )
           => ( member @ A @ X4 @ B8 ) ) ) ) )).

% subset_eq
thf(fact_246_equalityE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) )).

% equalityE
thf(fact_247_subsetCE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetCE
thf(fact_248_subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetD
thf(fact_249_in__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X2 @ A4 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% in_mono
thf(fact_250_set__mp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X2 @ A4 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% set_mp
thf(fact_251_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_252_lfinite__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P3: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lnull @ A @ Xs2 )
           => ( P3 @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ Xs2 )
               => ( ( P3 @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P3 @ Xs2 ) ) ) )
         => ( P3 @ Xs ) ) ) ) )).

% lfinite_induct
thf(fact_253_subset__UNIV,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_254_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_imp_neg_le
thf(fact_255_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B3 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B3 ) @ A3 ) ) ) )).

% minus_le_iff

%----Type constructors (31)
thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( boolean_algebra @ A10 @ ( type2 @ A10 ) )
     => ( boolean_algebra @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order_bot @ A10 @ ( type2 @ A10 ) )
     => ( order_bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( preorder @ A10 @ ( type2 @ A10 ) )
     => ( preorder @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order @ A10 @ ( type2 @ A10 ) )
     => ( order @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( top @ A10 @ ( type2 @ A10 ) )
     => ( top @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ord @ A10 @ ( type2 @ A10 ) )
     => ( ord @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( bot @ A10 @ ( type2 @ A10 ) )
     => ( bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( uminus @ A10 @ ( type2 @ A10 ) )
     => ( uminus @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_1,axiom,(
    ! [A9: $tType] :
      ( boolean_algebra @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_2,axiom,(
    ! [A9: $tType] :
      ( order_bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_3,axiom,(
    ! [A9: $tType] :
      ( preorder @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_4,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_5,axiom,(
    ! [A9: $tType] :
      ( order @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_6,axiom,(
    ! [A9: $tType] :
      ( top @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_7,axiom,(
    ! [A9: $tType] :
      ( ord @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_8,axiom,(
    ! [A9: $tType] :
      ( bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_9,axiom,(
    ! [A9: $tType] :
      ( uminus @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_10,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_11,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_12,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_13,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_14,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_15,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_16,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_17,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_18,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_19,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( sum_sum @ A9 @ A10 ) @ ( type2 @ ( sum_sum @ A9 @ A10 ) ) ) ) )).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_20,axiom,(
    ! [A9: $tType] :
      ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
     => ( finite_finite @ ( option @ A9 ) @ ( type2 @ ( option @ A9 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_21,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ( finite_finite @ A9 @ ( type2 @ A9 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( product_prod @ A9 @ A10 ) @ ( type2 @ ( product_prod @ A9 @ A10 ) ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( product_case_prod @ node @ ( set @ node ) @ ( node > $o )
    @ ^ [N2: node,Ns: ( set @ node ),N3: node] :
        ( ( graph @ N2 @ N3 )
        & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N2 @ ( insert @ node @ N3 @ Ns ) ) ) @ N3 ) )
        & ~ ( member @ node @ N3 @ ( insert @ node @ N2 @ Ns ) ) )
    @ ( product_Pair @ node @ ( set @ node ) @ na @ nsa )
    @ ( ^ [P: ( node > $o )] :
        @+[X: node] :
          ( P @ X )
      @ ( product_case_prod @ node @ ( set @ node ) @ ( node > $o )
        @ ^ [N2: node,Ns: ( set @ node ),N3: node] :
            ( ( graph @ N2 @ N3 )
            & ~ ( finite_finite2 @ node @ ( koenig317145564le_via @ node @ graph @ ( uminus_uminus @ ( set @ node ) @ ( insert @ node @ N2 @ ( insert @ node @ N3 @ Ns ) ) ) @ N3 ) )
            & ~ ( member @ node @ N3 @ ( insert @ node @ N2 @ Ns ) ) )
        @ ( product_Pair @ node @ ( set @ node ) @ na @ nsa ) ) ) )).

%------------------------------------------------------------------------------
