%------------------------------------------------------------------------------
% File     : COM182^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 60
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__60.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  329 (   0 unit;  53 type;   0 defn)
%            Number of atoms       : 4481 ( 300 equality;2742 variable)
%            Maximal formula depth :   22 (  10 average)
%            Number of connectives : 4149 ( 106   ~;  11   |;  53   &;3632   @)
%                                         (   0 <=>; 347  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  250 ( 250   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   57 (  53   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1170 (   1 sgn;1041   !;  32   ?;  46   ^)
%                                         (1170   :;  51  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:40:08.012
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_FSet_Ofset,type,(
    fset: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (46)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Basic__BNFs_Osetl,type,(
    basic_setl: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_Basic__BNFs_Osetr,type,(
    basic_setr: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_ONNode,type,(
    nNode: n > ( fset @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Odtree_Ocase__dtree,type,(
    case_dtree: 
      !>[A: $tType] :
        ( ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ) > dtree > A ) )).

thf(sy_c_DTree_Odtree_Occont,type,(
    ccont: dtree > ( fset @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,(
    lattic477160up_fin: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,(
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_nsa,type,(
    nsa: ( set @ n ) )).

thf(sy_v_ta,type,(
    ta: t )).

thf(sy_v_tra,type,(
    tra: dtree )).

%----Relevant facts (256)
thf(fact_0_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_1_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: A] :
      ( ( ( sum_Inl @ A @ B @ A2 )
        = ( sum_Inl @ A @ B @ A3 ) )
      = ( A2 = A3 ) ) )).

% old.sum.inject(1)
thf(fact_2_dtree__cong,axiom,(
    ! [Tr: dtree,Tr2: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr2 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr2 ) )
       => ( Tr = Tr2 ) ) ) )).

% dtree_cong
thf(fact_3_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_4_inFr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) )).

% inFr.Base
thf(fact_5_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_6_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_7_inFr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L1333338417e_inFr @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr1: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ A22 ) )
               => ~ ( gram_L1333338417e_inFr @ A1 @ Tr1 @ A32 ) ) ) ) ) )).

% inFr.cases
thf(fact_8_inFr_Osimps,axiom,
    ( gram_L1333338417e_inFr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr3: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr3 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr3 ) ) )
          | ? [Tr3: dtree,Ns2: ( set @ n ),Tr12: dtree,T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr3 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr3 ) )
              & ( gram_L1333338417e_inFr @ Ns2 @ Tr12 @ T3 ) ) ) ) )).

% inFr.simps
thf(fact_9_inFr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L1333338417e_inFr @ X1 @ X2 @ X3 )
     => ( ! [Tr4: dtree,Ns3: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr4 ) )
             => ( P @ Ns3 @ Tr4 @ T4 ) ) )
       => ( ! [Tr4: dtree,Ns3: ( set @ n ),Tr1: dtree,T4: t] :
              ( ( member @ n @ ( root @ Tr4 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr4 ) )
               => ( ( gram_L1333338417e_inFr @ Ns3 @ Tr1 @ T4 )
                 => ( ( P @ Ns3 @ Tr1 @ T4 )
                   => ( P @ Ns3 @ Tr4 @ T4 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inFr.inducts
thf(fact_10_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F2: ( B > T ),A2: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( F1 @ A2 ) ) )).

% old.sum.simps(7)
thf(fact_11_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_12_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% sum.inject(2)
thf(fact_13_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B3: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B3 ) )
      = ( B2 = B3 ) ) )).

% old.sum.inject(2)
thf(fact_14_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_15_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F2: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F2 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_16_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_17_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A4: A] :
          ( P @ ( sum_Inl @ A @ B @ A4 ) )
     => ( ! [B4: B] :
            ( P @ ( sum_Inr @ B @ A @ B4 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_18_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A4: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A4 ) )
     => ~ ( ! [B4: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B4 ) ) ) ) )).

% old.sum.exhaust
thf(fact_19_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X4: ( sum_sum @ A @ B )] :
            ( P2 @ X4 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X5: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X5 ) )
            & ! [X5: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X5 ) ) ) ) ) )).

% split_sum_all
thf(fact_20_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X4: ( sum_sum @ A @ B )] :
            ( P2 @ X4 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X5: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X5 ) )
            | ? [X5: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X5 ) ) ) ) ) )).

% split_sum_ex
thf(fact_21_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A2: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A2 ) ) )).

% Inr_not_Inl
thf(fact_22_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X6: A] :
          ( S
         != ( sum_Inl @ A @ B @ X6 ) )
     => ~ ( ! [Y3: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y3 ) ) ) ) )).

% sumE
thf(fact_23_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: A,B3: B] :
      ( ( sum_Inl @ A @ B @ A2 )
     != ( sum_Inr @ B @ A @ B3 ) ) )).

% old.sum.distinct(1)
thf(fact_24_old_Osum_Odistinct_I2_J,axiom,(
    ! [B5: $tType,A5: $tType,B6: B5,A6: A5] :
      ( ( sum_Inr @ B5 @ A5 @ B6 )
     != ( sum_Inl @ A5 @ B5 @ A6 ) ) )).

% old.sum.distinct(2)
thf(fact_25_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X2 ) ) )).

% sum.distinct(1)
thf(fact_26_inFr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr13: dtree,T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr ) )
       => ( ( gram_L1333338417e_inFr @ Ns @ Tr13 @ T2 )
         => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr.Ind
thf(fact_27_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_28_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_29_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X6: A] :
          ( S
         != ( sum_Inl @ A @ B @ X6 ) )
     => ~ ( ! [X6: B] :
              ( S
             != ( sum_Inr @ B @ A @ X6 ) ) ) ) )).

% obj_sumE
thf(fact_30_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X6: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X6 ) ) )
         => P )
     => ( ! [X6: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X6 ) ) )
           => P )
       => ! [X7: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X7 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_31_inFr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L805317441_inFr2 @ X1 @ X2 @ X3 )
     => ( ! [Tr4: dtree,Ns3: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr4 ) )
             => ( P @ Ns3 @ Tr4 @ T4 ) ) )
       => ( ! [Tr1: dtree,Tr4: dtree,Ns1: ( set @ n ),T4: t] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr4 ) )
             => ( ( gram_L805317441_inFr2 @ Ns1 @ Tr1 @ T4 )
               => ( ( P @ Ns1 @ Tr1 @ T4 )
                 => ( P @ ( insert @ n @ ( root @ Tr4 ) @ Ns1 ) @ Tr4 @ T4 ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inFr2.inducts
thf(fact_32_inFr2_Osimps,axiom,
    ( gram_L805317441_inFr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr3: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr3 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr3 ) ) )
          | ? [Tr12: dtree,Tr3: dtree,Ns12: ( set @ n ),T3: t] :
              ( ( A12
                = ( insert @ n @ ( root @ Tr3 ) @ Ns12 ) )
              & ( A23 = Tr3 )
              & ( A33 = T3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr3 ) )
              & ( gram_L805317441_inFr2 @ Ns12 @ Tr12 @ T3 ) ) ) ) )).

% inFr2.simps
thf(fact_33_inFr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L805317441_inFr2 @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ! [Tr1: dtree,Tr4: dtree,Ns1: ( set @ n )] :
                ( ( A1
                  = ( insert @ n @ ( root @ Tr4 ) @ Ns1 ) )
               => ( ( A22 = Tr4 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr4 ) )
                   => ~ ( gram_L805317441_inFr2 @ Ns1 @ Tr1 @ A32 ) ) ) ) ) ) ) )).

% inFr2.cases
thf(fact_34_inFr2_OInd,axiom,(
    ! [Tr13: dtree,Tr: dtree,Ns13: ( set @ n ),T2: t] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr ) )
     => ( ( gram_L805317441_inFr2 @ Ns13 @ Tr13 @ T2 )
       => ( gram_L805317441_inFr2 @ ( insert @ n @ ( root @ Tr ) @ Ns13 ) @ Tr @ T2 ) ) ) )).

% inFr2.Ind
thf(fact_35_inFr__Ind__minus,axiom,(
    ! [Ns13: ( set @ n ),Tr13: dtree,T2: t,Tr: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns13 @ Tr13 @ T2 )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ ( insert @ n @ ( root @ Tr ) @ Ns13 ) @ Tr @ T2 ) ) ) )).

% inFr_Ind_minus
thf(fact_36_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X ) )
      = ( F @ X ) ) )).

% Suml.simps
thf(fact_37_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F @ ( sum_Inr @ B @ A @ X ) )
      = ( F @ X ) ) )).

% Sumr.simps
thf(fact_38_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),G: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F )
        = ( sum_Sumr @ B @ C @ A @ G ) )
     => ( F = G ) ) )).

% Sumr_inject
thf(fact_39_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G ) )
     => ( F = G ) ) )).

% Suml_inject
thf(fact_40_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( X != Y )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_41_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A7 ) )
      = ( insert @ A @ X @ A7 ) ) )).

% insert_absorb2
thf(fact_42_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A7: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A7 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A7 ) ) ) )).

% insert_iff
thf(fact_43_insertCI,axiom,(
    ! [A: $tType,A2: A,B7: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B7 )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B7 ) ) ) )).

% insertCI
thf(fact_44_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B2: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% corec(1)
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X5: A] :
            ( member @ A @ X5 @ A7 ) )
      = A7 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( P @ X6 )
          = ( Q @ X6 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X6: A] :
          ( ( F @ X6 )
          = ( G @ X6 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_50_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_51_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A )] :
      ( ( member @ A @ A2 @ A7 )
     => ? [B8: ( set @ A )] :
          ( ( A7
            = ( insert @ A @ A2 @ B8 ) )
          & ~ ( member @ A @ A2 @ B8 ) ) ) )).

% mk_disjoint_insert
thf(fact_52_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A7: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A7 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A7 ) ) ) )).

% insert_commute
thf(fact_53_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A ),B2: A,B7: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A7 )
     => ( ~ ( member @ A @ B2 @ B7 )
       => ( ( ( insert @ A @ A2 @ A7 )
            = ( insert @ A @ B2 @ B7 ) )
          = ( ( ( A2 = B2 )
             => ( A7 = B7 ) )
            & ( ( A2 != B2 )
             => ? [C2: ( set @ A )] :
                  ( ( A7
                    = ( insert @ A @ B2 @ C2 ) )
                  & ~ ( member @ A @ B2 @ C2 )
                  & ( B7
                    = ( insert @ A @ A2 @ C2 ) )
                  & ~ ( member @ A @ A2 @ C2 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_54_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N: n,N2: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N @ As )
            = ( node @ N2 @ As2 ) )
          = ( ( N = N2 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_55_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_56_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N3: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N3 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_57_insertE,axiom,(
    ! [A: $tType,A2: A,B2: A,A7: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A7 ) )
     => ( ( A2 != B2 )
       => ( member @ A @ A2 @ A7 ) ) ) )).

% insertE
thf(fact_58_insertI1,axiom,(
    ! [A: $tType,A2: A,B7: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B7 ) ) )).

% insertI1
thf(fact_59_insertI2,axiom,(
    ! [A: $tType,A2: A,B7: ( set @ A ),B2: A] :
      ( ( member @ A @ A2 @ B7 )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B7 ) ) ) )).

% insertI2
thf(fact_60_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A )] :
      ( ( member @ A @ X @ A7 )
     => ~ ( ! [B8: ( set @ A )] :
              ( ( A7
                = ( insert @ A @ X @ B8 ) )
             => ( member @ A @ X @ B8 ) ) ) ) )).

% Set.set_insert
thf(fact_61_insert__ident,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A7 )
     => ( ~ ( member @ A @ X @ B7 )
       => ( ( ( insert @ A @ X @ A7 )
            = ( insert @ A @ X @ B7 ) )
          = ( A7 = B7 ) ) ) ) )).

% insert_ident
thf(fact_62_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A )] :
      ( ( member @ A @ A2 @ A7 )
     => ( ( insert @ A @ A2 @ A7 )
        = A7 ) ) )).

% insert_absorb
thf(fact_63_finite__insert,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A2 @ A7 ) )
      = ( finite_finite2 @ A @ A7 ) ) )).

% finite_insert
thf(fact_64_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A8: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_65_finite_OinsertI,axiom,(
    ! [A: $tType,A7: ( set @ A ),A2: A] :
      ( ( finite_finite2 @ A @ A7 )
     => ( finite_finite2 @ A @ ( insert @ A @ A2 @ A7 ) ) ) )).

% finite.insertI
thf(fact_66_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A7: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A7 )
     => ( ! [X6: A] :
            ( ( member @ A @ X6 @ A7 )
           => ? [X12: B] :
                ( P @ X6 @ X12 ) )
       => ? [F3: ( A > B )] :
          ! [X7: A] :
            ( ( member @ A @ X7 @ A7 )
           => ( P @ X7 @ ( F3 @ X7 ) ) ) ) ) )).

% finite_set_choice
thf(fact_67_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A7: ( set @ A )] :
          ( finite_finite2 @ A @ A7 ) ) )).

% finite
thf(fact_68_case__sum__if,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P4: $o,F: ( B > A ),G: ( C > A ),X: B,Y: C] :
      ( ( P4
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P4 @ ( sum_Inl @ B @ C @ X ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( F @ X ) ) )
      & ( ~ ( P4 )
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P4 @ ( sum_Inl @ B @ C @ X ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( G @ Y ) ) ) ) )).

% case_sum_if
thf(fact_69_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A7: ( set @ A ),B7: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A7 @ B7 ) )
     => ( ! [X6: A] :
            ( ( member @ A @ X6 @ A7 )
           => ( U
             != ( sum_Inl @ A @ B @ X6 ) ) )
       => ~ ( ! [Y3: B] :
                ( ( member @ B @ Y3 @ B7 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y3 ) ) ) ) ) ) )).

% PlusE
thf(fact_70_dtree_Osel_I1_J,axiom,(
    ! [X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( nNode @ X1 @ X2 ) )
      = X1 ) )).

% dtree.sel(1)
thf(fact_71_dtree_Oinject,axiom,(
    ! [X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) ),Y1: n,Y2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( ( nNode @ X1 @ X2 )
        = ( nNode @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% dtree.inject
thf(fact_72_InrI,axiom,(
    ! [B: $tType,A: $tType,B2: A,B7: ( set @ A ),A7: ( set @ B )] :
      ( ( member @ A @ B2 @ B7 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B2 ) @ ( sum_Plus @ B @ A @ A7 @ B7 ) ) ) )).

% InrI
thf(fact_73_InlI,axiom,(
    ! [A: $tType,B: $tType,A2: A,A7: ( set @ A ),B7: ( set @ B )] :
      ( ( member @ A @ A2 @ A7 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A2 ) @ ( sum_Plus @ A @ B @ A7 @ B7 ) ) ) )).

% InlI
thf(fact_74_finite__Plus__iff,axiom,(
    ! [A: $tType,B: $tType,A7: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A7 @ B7 ) )
      = ( ( finite_finite2 @ A @ A7 )
        & ( finite_finite2 @ B @ B7 ) ) ) )).

% finite_Plus_iff
thf(fact_75_dtree_Oexhaust,axiom,(
    ! [Y: dtree] :
      ~ ( ! [X13: n,X22: ( fset @ ( sum_sum @ t @ dtree ) )] :
            ( Y
           != ( nNode @ X13 @ X22 ) ) ) )).

% dtree.exhaust
thf(fact_76_case__sum__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F2: ( B > C ),G1: ( A > C ),G2: ( B > C )] :
      ( ( ( sum_case_sum @ A @ C @ B @ F1 @ F2 )
        = ( sum_case_sum @ A @ C @ B @ G1 @ G2 ) )
     => ~ ( ( F1 = G1 )
         => ( F2 != G2 ) ) ) )).

% case_sum_inject
thf(fact_77_case__sum__step_I1_J,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F4: ( B > A ),G3: ( C > A ),G: ( D > A ),P4: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ ( sum_sum @ B @ C ) @ A @ D @ ( sum_case_sum @ B @ A @ C @ F4 @ G3 ) @ G @ ( sum_Inl @ ( sum_sum @ B @ C ) @ D @ P4 ) )
      = ( sum_case_sum @ B @ A @ C @ F4 @ G3 @ P4 ) ) )).

% case_sum_step(1)
thf(fact_78_case__sum__step_I2_J,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,F: ( E > A ),F4: ( B > A ),G3: ( C > A ),P4: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ E @ A @ ( sum_sum @ B @ C ) @ F @ ( sum_case_sum @ B @ A @ C @ F4 @ G3 ) @ ( sum_Inr @ ( sum_sum @ B @ C ) @ E @ P4 ) )
      = ( sum_case_sum @ B @ A @ C @ F4 @ G3 @ P4 ) ) )).

% case_sum_step(2)
thf(fact_79_old_Osum_Osimps_I6_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F2: ( B > C ),X2: B] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F2 @ ( sum_Inr @ B @ A @ X2 ) )
      = ( F2 @ X2 ) ) )).

% old.sum.simps(6)
thf(fact_80_old_Osum_Osimps_I5_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F1: ( A > C ),F2: ( B > C ),X1: A] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F2 @ ( sum_Inl @ A @ B @ X1 ) )
      = ( F1 @ X1 ) ) )).

% old.sum.simps(5)
thf(fact_81_finite__Plus,axiom,(
    ! [A: $tType,B: $tType,A7: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ A @ A7 )
     => ( ( finite_finite2 @ B @ B7 )
       => ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A7 @ B7 ) ) ) ) )).

% finite_Plus
thf(fact_82_finite__PlusD_I1_J,axiom,(
    ! [B: $tType,A: $tType,A7: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A7 @ B7 ) )
     => ( finite_finite2 @ A @ A7 ) ) )).

% finite_PlusD(1)
thf(fact_83_finite__PlusD_I2_J,axiom,(
    ! [A: $tType,B: $tType,A7: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A7 @ B7 ) )
     => ( finite_finite2 @ B @ B7 ) ) )).

% finite_PlusD(2)
thf(fact_84_dtree_Ocollapse,axiom,(
    ! [Dtree: dtree] :
      ( ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) )
      = Dtree ) )).

% dtree.collapse
thf(fact_85_dtree_Oexhaust__sel,axiom,(
    ! [Dtree: dtree] :
      ( Dtree
      = ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) ) )).

% dtree.exhaust_sel
thf(fact_86_case__sum__expand__Inr__pointfree,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = F ) ) )).

% case_sum_expand_Inr_pointfree
thf(fact_87_case__sum__expand__Inr_H,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),H: ( C > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( H
          = ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = ( ( sum_case_sum @ A @ B @ C @ G @ H )
          = F ) ) ) )).

% case_sum_expand_Inr'
thf(fact_88_case__sum__expand__Inr,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),X: ( sum_sum @ A @ C )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( F @ X )
        = ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) @ X ) ) ) )).

% case_sum_expand_Inr
thf(fact_89_dtree_Ocase,axiom,(
    ! [A: $tType,F: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( case_dtree @ A @ F @ ( nNode @ X1 @ X2 ) )
      = ( F @ X1 @ X2 ) ) )).

% dtree.case
thf(fact_90_finite__Diff__insert,axiom,(
    ! [A: $tType,A7: ( set @ A ),A2: A,B7: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ A2 @ B7 ) ) )
      = ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% finite_Diff_insert
thf(fact_91_Diff__idemp,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) @ B7 )
      = ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) )).

% Diff_idemp
thf(fact_92_Diff__iff,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) )
      = ( ( member @ A @ C3 @ A7 )
        & ~ ( member @ A @ C3 @ B7 ) ) ) )).

% Diff_iff
thf(fact_93_DiffI,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ A7 )
     => ( ~ ( member @ A @ C3 @ B7 )
       => ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) ) ) )).

% DiffI
thf(fact_94_finite__Diff2,axiom,(
    ! [A: $tType,B7: ( set @ A ),A7: ( set @ A )] :
      ( ( finite_finite2 @ A @ B7 )
     => ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) )
        = ( finite_finite2 @ A @ A7 ) ) ) )).

% finite_Diff2
thf(fact_95_finite__Diff,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( finite_finite2 @ A @ A7 )
     => ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% finite_Diff
thf(fact_96_Diff__insert0,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A7 )
     => ( ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ X @ B7 ) )
        = ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% Diff_insert0
thf(fact_97_insert__Diff1,axiom,(
    ! [A: $tType,X: A,B7: ( set @ A ),A7: ( set @ A )] :
      ( ( member @ A @ X @ B7 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A7 ) @ B7 )
        = ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% insert_Diff1
thf(fact_98_o__case__sum,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H: ( D > C ),F: ( A > D ),G: ( B > D )] :
      ( ( comp @ D @ C @ ( sum_sum @ A @ B ) @ H @ ( sum_case_sum @ A @ D @ B @ F @ G ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ H @ F ) @ ( comp @ D @ C @ B @ H @ G ) ) ) )).

% o_case_sum
thf(fact_99_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_100_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_101_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_102_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_103_DiffD2,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) )
     => ~ ( member @ A @ C3 @ B7 ) ) )).

% DiffD2
thf(fact_104_DiffD1,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) )
     => ( member @ A @ C3 @ A7 ) ) )).

% DiffD1
thf(fact_105_DiffE,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) )
     => ~ ( ( member @ A @ C3 @ A7 )
         => ( member @ A @ C3 @ B7 ) ) ) )).

% DiffE
thf(fact_106_dtree_Ocase__eq__if,axiom,(
    ! [A: $tType] :
      ( ( case_dtree @ A )
      = ( ^ [F5: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),Dtree2: dtree] :
            ( F5 @ ( root @ Dtree2 ) @ ( ccont @ Dtree2 ) ) ) ) )).

% dtree.case_eq_if
thf(fact_107_Diff__infinite__finite,axiom,(
    ! [A: $tType,T5: ( set @ A ),S2: ( set @ A )] :
      ( ( finite_finite2 @ A @ T5 )
     => ( ~ ( finite_finite2 @ A @ S2 )
       => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) )).

% Diff_infinite_finite
thf(fact_108_insert__Diff__if,axiom,(
    ! [A: $tType,X: A,B7: ( set @ A ),A7: ( set @ A )] :
      ( ( ( member @ A @ X @ B7 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A7 ) @ B7 )
          = ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) )
      & ( ~ ( member @ A @ X @ B7 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A7 ) @ B7 )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) ) ) ) ) )).

% insert_Diff_if
thf(fact_109_dtree_Oexpand,axiom,(
    ! [Dtree: dtree,Dtree3: dtree] :
      ( ( ( ( root @ Dtree )
          = ( root @ Dtree3 ) )
        & ( ( ccont @ Dtree )
          = ( ccont @ Dtree3 ) ) )
     => ( Dtree = Dtree3 ) ) )).

% dtree.expand
thf(fact_110_dtree_Osplit__sel__asm,axiom,(
    ! [A: $tType,P: ( A > $o ),F: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),Dtree: dtree] :
      ( ( P @ ( case_dtree @ A @ F @ Dtree ) )
      = ( ~ ( ( Dtree
              = ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) )
            & ~ ( P @ ( F @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) ) ) ) ) )).

% dtree.split_sel_asm
thf(fact_111_dtree_Osplit__sel,axiom,(
    ! [A: $tType,P: ( A > $o ),F: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),Dtree: dtree] :
      ( ( P @ ( case_dtree @ A @ F @ Dtree ) )
      = ( ( Dtree
          = ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) )
       => ( P @ ( F @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) ) ) ) )).

% dtree.split_sel
thf(fact_112_dtree_Osel_I2_J,axiom,(
    ! [X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( ccont @ ( nNode @ X1 @ X2 ) )
      = X2 ) )).

% dtree.sel(2)
thf(fact_113_case__sum__o__inj_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inl @ A @ C ) )
      = F ) )).

% case_sum_o_inj(1)
thf(fact_114_case__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ C @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inr @ C @ A ) )
      = G ) )).

% case_sum_o_inj(2)
thf(fact_115_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F5: ( B > A ),G4: ( C > B ),X5: C] :
            ( F5 @ ( G4 @ X5 ) ) ) ) )).

% comp_apply
thf(fact_116_minus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A8: ( A > B ),B9: ( A > B ),X5: A] :
              ( minus_minus @ B @ ( A8 @ X5 ) @ ( B9 @ X5 ) ) ) ) ) )).

% minus_apply
thf(fact_117_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F5: ( B > C ),G4: ( A > B ),X5: A] :
            ( F5 @ ( G4 @ X5 ) ) ) ) )).

% comp_def
thf(fact_118_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_119_fun__diff__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A8: ( A > B ),B9: ( A > B ),X5: A] :
              ( minus_minus @ B @ ( A8 @ X5 ) @ ( B9 @ X5 ) ) ) ) ) )).

% fun_diff_def
thf(fact_120_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_121_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C3 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_122_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C3 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_123_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C3 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_124_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X: C,N4: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X ) )
        = ( N4 @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N4 ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_125_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_126_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G: ( C > B ),X: C,F4: ( D > A ),G3: ( E > D ),X8: E] :
      ( ( ( F @ ( G @ X ) )
        = ( F4 @ ( G3 @ X8 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ E @ F4 @ G3 @ X8 ) ) ) )).

% comp_cong
thf(fact_127_finite__empty__induct,axiom,(
    ! [A: $tType,A7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ A7 )
     => ( ( P @ A7 )
       => ( ! [A4: A,A9: ( set @ A )] :
              ( ( finite_finite2 @ A @ A9 )
             => ( ( member @ A @ A4 @ A9 )
               => ( ( P @ A9 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A9 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% finite_empty_induct
thf(fact_128_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X5: A] :
            ~ ( P @ X5 ) ) ) )).

% empty_Collect_eq
thf(fact_129_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X5: A] :
            ~ ( P @ X5 ) ) ) )).

% Collect_empty_eq
thf(fact_130_all__not__in__conv,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( ! [X5: A] :
            ~ ( member @ A @ X5 @ A7 ) )
      = ( A7
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_131_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_132_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_133_Diff__cancel,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A7 @ A7 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_134_empty__Diff,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A7 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_135_Diff__empty,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A7 @ ( bot_bot @ ( set @ A ) ) )
      = A7 ) )).

% Diff_empty
thf(fact_136_Plus__eq__empty__conv,axiom,(
    ! [A: $tType,B: $tType,A7: ( set @ A ),B7: ( set @ B )] :
      ( ( ( sum_Plus @ A @ B @ A7 @ B7 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A7
          = ( bot_bot @ ( set @ A ) ) )
        & ( B7
          = ( bot_bot @ ( set @ B ) ) ) ) ) )).

% Plus_eq_empty_conv
thf(fact_137_insert__Diff__single,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A )] :
      ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A2 @ A7 ) ) )).

% insert_Diff_single
thf(fact_138_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_139_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S2: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_140_singletonD,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A2 ) ) )).

% singletonD
thf(fact_141_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A2 ) ) )).

% singleton_iff
thf(fact_142_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,C3: A,D2: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C3 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C3 )
          & ( B2 = D2 ) )
        | ( ( A2 = D2 )
          & ( B2 = C3 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_143_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A )] :
      ( ( insert @ A @ A2 @ A7 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_144_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B2 ) ) )).

% singleton_inject
thf(fact_145_ex__in__conv,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( ? [X5: A] :
            ( member @ A @ X5 @ A7 ) )
      = ( A7
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_146_equals0I,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A7 )
     => ( A7
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_147_equals0D,axiom,(
    ! [A: $tType,A7: ( set @ A ),A2: A] :
      ( ( A7
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A7 ) ) )).

% equals0D
thf(fact_148_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_149_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A7: ( set @ A )] :
      ( ! [A9: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A9 )
         => ( P @ A9 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X6: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X6 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X6 @ F6 ) ) ) ) )
         => ( P @ A7 ) ) ) ) )).

% infinite_finite_induct
thf(fact_150_finite__ne__induct,axiom,(
    ! [A: $tType,F7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F7 )
     => ( ( F7
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X6: A] :
              ( P @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X6: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( F6
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X6 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ X6 @ F6 ) ) ) ) ) )
           => ( P @ F7 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_151_finite_Oinducts,axiom,(
    ! [A: $tType,X: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A9: ( set @ A ),A4: A] :
              ( ( finite_finite2 @ A @ A9 )
             => ( ( P @ A9 )
               => ( P @ ( insert @ A @ A4 @ A9 ) ) ) )
         => ( P @ X ) ) ) ) )).

% finite.inducts
thf(fact_152_finite__induct,axiom,(
    ! [A: $tType,F7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F7 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X6: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X6 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X6 @ F6 ) ) ) ) )
         => ( P @ F7 ) ) ) ) )).

% finite_induct
thf(fact_153_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A10: ( set @ A )] :
            ( ( A10
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A8: ( set @ A ),B10: A] :
                ( ( A10
                  = ( insert @ A @ B10 @ A8 ) )
                & ( finite_finite2 @ A @ A8 ) ) ) ) ) )).

% finite.simps
thf(fact_154_finite_Ocases,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ( A2
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A9: ( set @ A )] :
                ( ? [A4: A] :
                    ( A2
                    = ( insert @ A @ A4 @ A9 ) )
               => ~ ( finite_finite2 @ A @ A9 ) ) ) ) ) )).

% finite.cases
thf(fact_155_Diff__insert,axiom,(
    ! [A: $tType,A7: ( set @ A ),A2: A,B7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ A2 @ B7 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert
thf(fact_156_insert__Diff,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A )] :
      ( ( member @ A @ A2 @ A7 )
     => ( ( insert @ A @ A2 @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A7 ) ) )).

% insert_Diff
thf(fact_157_Diff__insert2,axiom,(
    ! [A: $tType,A7: ( set @ A ),A2: A,B7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ A2 @ B7 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 ) ) )).

% Diff_insert2
thf(fact_158_Diff__insert__absorb,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A7 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A7 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A7 ) ) )).

% Diff_insert_absorb
thf(fact_159_infinite__remove,axiom,(
    ! [A: $tType,S2: ( set @ A ),A2: A] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% infinite_remove
thf(fact_160_infinite__coinduct,axiom,(
    ! [A: $tType,X9: ( ( set @ A ) > $o ),A7: ( set @ A )] :
      ( ( X9 @ A7 )
     => ( ! [A9: ( set @ A )] :
            ( ( X9 @ A9 )
           => ? [X7: A] :
                ( ( member @ A @ X7 @ A9 )
                & ( ( X9 @ ( minus_minus @ ( set @ A ) @ A9 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A9 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite2 @ A @ A7 ) ) ) )).

% infinite_coinduct
thf(fact_161_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_162_remove__def,axiom,(
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X5: A,A8: ( set @ A )] :
            ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% remove_def
thf(fact_163_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_164_sum__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: A] :
      ( ( basic_setl @ A @ B @ ( sum_Inl @ A @ B @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(1)
thf(fact_165_member__remove,axiom,(
    ! [A: $tType,X: A,Y: A,A7: ( set @ A )] :
      ( ( member @ A @ X @ ( remove @ A @ Y @ A7 ) )
      = ( ( member @ A @ X @ A7 )
        & ( X != Y ) ) ) )).

% member_remove
thf(fact_166_sum__set__simps_I2_J,axiom,(
    ! [A: $tType,C: $tType,X: A] :
      ( ( basic_setl @ C @ A @ ( sum_Inr @ A @ C @ X ) )
      = ( bot_bot @ ( set @ C ) ) ) )).

% sum_set_simps(2)
thf(fact_167_setl_Ocases,axiom,(
    ! [B: $tType,A: $tType,A2: A,S: ( sum_sum @ A @ B )] :
      ( ( member @ A @ A2 @ ( basic_setl @ A @ B @ S ) )
     => ( S
        = ( sum_Inl @ A @ B @ A2 ) ) ) )).

% setl.cases
thf(fact_168_setl_Osimps,axiom,(
    ! [B: $tType,A: $tType,A2: A,S: ( sum_sum @ A @ B )] :
      ( ( member @ A @ A2 @ ( basic_setl @ A @ B @ S ) )
      = ( ? [X5: A] :
            ( ( A2 = X5 )
            & ( S
              = ( sum_Inl @ A @ B @ X5 ) ) ) ) ) )).

% setl.simps
thf(fact_169_setl_Ointros,axiom,(
    ! [B: $tType,A: $tType,S: ( sum_sum @ A @ B ),X: A] :
      ( ( S
        = ( sum_Inl @ A @ B @ X ) )
     => ( member @ A @ X @ ( basic_setl @ A @ B @ S ) ) ) )).

% setl.intros
thf(fact_170_setl_Oinducts,axiom,(
    ! [B: $tType,A: $tType,X: A,S: ( sum_sum @ A @ B ),P: ( A > $o )] :
      ( ( member @ A @ X @ ( basic_setl @ A @ B @ S ) )
     => ( ! [X6: A] :
            ( ( S
              = ( sum_Inl @ A @ B @ X6 ) )
           => ( P @ X6 ) )
       => ( P @ X ) ) ) )).

% setl.inducts
thf(fact_171_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A8: ( set @ A )] :
            ( A8
            = ( insert @ A @ ( the_elem @ A @ A8 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_172_is__singletonI_H,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( A7
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X6: A,Y3: A] :
            ( ( member @ A @ X6 @ A7 )
           => ( ( member @ A @ Y3 @ A7 )
             => ( X6 = Y3 ) ) )
       => ( is_singleton @ A @ A7 ) ) ) )).

% is_singletonI'
thf(fact_173_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A8: ( set @ A )] :
          ? [X5: A] :
            ( A8
            = ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_174_is__singletonE,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( is_singleton @ A @ A7 )
     => ~ ( ! [X6: A] :
              ( A7
             != ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_175_sum__set__simps_I4_J,axiom,(
    ! [E: $tType,A: $tType,X: A] :
      ( ( basic_setr @ E @ A @ ( sum_Inr @ A @ E @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(4)
thf(fact_176_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A8: ( set @ A )] :
            ( A8
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_177_remove__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),B7: ( set @ A )] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite2 @ A @ B7 )
         => ( P @ B7 ) )
       => ( ! [A9: ( set @ A )] :
              ( ( finite_finite2 @ A @ A9 )
             => ( ( A9
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A9 @ B7 )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ A9 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A9 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A9 ) ) ) ) )
         => ( P @ B7 ) ) ) ) )).

% remove_induct
thf(fact_178_subset__antisym,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A7 )
       => ( A7 = B7 ) ) ) )).

% subset_antisym
thf(fact_179_subsetI,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ! [X6: A] :
          ( ( member @ A @ X6 @ A7 )
         => ( member @ A @ X6 @ B7 ) )
     => ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) )).

% subsetI
thf(fact_180_subset__empty,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ ( bot_bot @ ( set @ A ) ) )
      = ( A7
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_181_empty__subsetI,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A7 ) )).

% empty_subsetI
thf(fact_182_insert__subset,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A7 ) @ B7 )
      = ( ( member @ A @ X @ B7 )
        & ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% insert_subset
thf(fact_183_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A2: A,A7: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A7 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_184_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A2: A,A7: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A2 @ A7 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_185_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A7 @ B7 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) )).

% Diff_eq_empty_iff
thf(fact_186_sum__set__simps_I3_J,axiom,(
    ! [A: $tType,D: $tType,X: A] :
      ( ( basic_setr @ A @ D @ ( sum_Inl @ A @ D @ X ) )
      = ( bot_bot @ ( set @ D ) ) ) )).

% sum_set_simps(3)
thf(fact_187_inFr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Ns4: ( set @ n )] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns4 )
       => ( gram_L1333338417e_inFr @ Ns4 @ Tr @ T2 ) ) ) )).

% inFr_mono
thf(fact_188_setr_Oinducts,axiom,(
    ! [A: $tType,B: $tType,X: B,S: ( sum_sum @ A @ B ),P: ( B > $o )] :
      ( ( member @ B @ X @ ( basic_setr @ A @ B @ S ) )
     => ( ! [X6: B] :
            ( ( S
              = ( sum_Inr @ B @ A @ X6 ) )
           => ( P @ X6 ) )
       => ( P @ X ) ) ) )).

% setr.inducts
thf(fact_189_setr_Ointros,axiom,(
    ! [B: $tType,A: $tType,S: ( sum_sum @ A @ B ),X: B] :
      ( ( S
        = ( sum_Inr @ B @ A @ X ) )
     => ( member @ B @ X @ ( basic_setr @ A @ B @ S ) ) ) )).

% setr.intros
thf(fact_190_setr_Osimps,axiom,(
    ! [A: $tType,B: $tType,A2: B,S: ( sum_sum @ A @ B )] :
      ( ( member @ B @ A2 @ ( basic_setr @ A @ B @ S ) )
      = ( ? [X5: B] :
            ( ( A2 = X5 )
            & ( S
              = ( sum_Inr @ B @ A @ X5 ) ) ) ) ) )).

% setr.simps
thf(fact_191_setr_Ocases,axiom,(
    ! [A: $tType,B: $tType,A2: B,S: ( sum_sum @ A @ B )] :
      ( ( member @ B @ A2 @ ( basic_setr @ A @ B @ S ) )
     => ( S
        = ( sum_Inr @ B @ A @ A2 ) ) ) )).

% setr.cases
thf(fact_192_finite__subset,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( finite_finite2 @ A @ B7 )
       => ( finite_finite2 @ A @ A7 ) ) ) )).

% finite_subset
thf(fact_193_infinite__super,axiom,(
    ! [A: $tType,S2: ( set @ A ),T5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T5 )
     => ( ~ ( finite_finite2 @ A @ S2 )
       => ~ ( finite_finite2 @ A @ T5 ) ) ) )).

% infinite_super
thf(fact_194_rev__finite__subset,axiom,(
    ! [A: $tType,B7: ( set @ A ),A7: ( set @ A )] :
      ( ( finite_finite2 @ A @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
       => ( finite_finite2 @ A @ A7 ) ) ) )).

% rev_finite_subset
thf(fact_195_insert__mono,axiom,(
    ! [A: $tType,C4: ( set @ A ),D3: ( set @ A ),A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ D3 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C4 ) @ ( insert @ A @ A2 @ D3 ) ) ) )).

% insert_mono
thf(fact_196_subset__insert,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ X @ B7 ) )
        = ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% subset_insert
thf(fact_197_subset__insertI,axiom,(
    ! [A: $tType,B7: ( set @ A ),A2: A] :
      ( ord_less_eq @ ( set @ A ) @ B7 @ ( insert @ A @ A2 @ B7 ) ) )).

% subset_insertI
thf(fact_198_subset__insertI2,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ B2 @ B7 ) ) ) )).

% subset_insertI2
thf(fact_199_Diff__mono,axiom,(
    ! [A: $tType,A7: ( set @ A ),C4: ( set @ A ),D3: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ D3 @ B7 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) @ ( minus_minus @ ( set @ A ) @ C4 @ D3 ) ) ) ) )).

% Diff_mono
thf(fact_200_Diff__subset,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ B7 ) @ A7 ) )).

% Diff_subset
thf(fact_201_double__diff,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ C4 )
       => ( ( minus_minus @ ( set @ A ) @ B7 @ ( minus_minus @ ( set @ A ) @ C4 @ A7 ) )
          = A7 ) ) ) )).

% double_diff
thf(fact_202_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X5: A] :
            ( ( P @ X5 )
           => ( Q @ X5 ) ) ) ) )).

% Collect_mono_iff
thf(fact_203_contra__subsetD,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ~ ( member @ A @ C3 @ B7 )
       => ~ ( member @ A @ C3 @ A7 ) ) ) )).

% contra_subsetD
thf(fact_204_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y4: ( set @ A ),Z: ( set @ A )] : ( Y4 = Z ) )
      = ( ^ [A8: ( set @ A ),B9: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A8 @ B9 )
            & ( ord_less_eq @ ( set @ A ) @ B9 @ A8 ) ) ) ) )).

% set_eq_subset
thf(fact_205_subset__trans,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% subset_trans
thf(fact_206_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( P @ X6 )
         => ( Q @ X6 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_207_subset__refl,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A7 @ A7 ) )).

% subset_refl
thf(fact_208_rev__subsetD,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ A7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% rev_subsetD
thf(fact_209_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B9: ( set @ A )] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A8 )
           => ( member @ A @ T3 @ B9 ) ) ) ) )).

% subset_iff
thf(fact_210_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ X @ A7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
       => ( member @ A @ X @ B7 ) ) ) )).

% set_rev_mp
thf(fact_211_equalityD2,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( A7 = B7 )
     => ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) )).

% equalityD2
thf(fact_212_equalityD1,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( A7 = B7 )
     => ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) )).

% equalityD1
thf(fact_213_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B9: ( set @ A )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A8 )
           => ( member @ A @ X5 @ B9 ) ) ) ) )).

% subset_eq
thf(fact_214_equalityE,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( A7 = B7 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) )).

% equalityE
thf(fact_215_subsetCE,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( member @ A @ C3 @ A7 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% subsetCE
thf(fact_216_subsetD,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( member @ A @ C3 @ A7 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% subsetD
thf(fact_217_in__mono,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( member @ A @ X @ A7 )
       => ( member @ A @ X @ B7 ) ) ) )).

% in_mono
thf(fact_218_set__mp,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( member @ A @ X @ A7 )
       => ( member @ A @ X @ B7 ) ) ) )).

% set_mp
thf(fact_219_subset__singletonD,axiom,(
    ! [A: $tType,A7: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A7
          = ( bot_bot @ ( set @ A ) ) )
        | ( A7
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_220_subset__singleton__iff,axiom,(
    ! [A: $tType,X9: ( set @ A ),A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X9 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X9
          = ( bot_bot @ ( set @ A ) ) )
        | ( X9
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_221_subset__Diff__insert,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),X: A,C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ ( minus_minus @ ( set @ A ) @ B7 @ ( insert @ A @ X @ C4 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A7 @ ( minus_minus @ ( set @ A ) @ B7 @ C4 ) )
        & ~ ( member @ A @ X @ A7 ) ) ) )).

% subset_Diff_insert
thf(fact_222_finite__subset__induct,axiom,(
    ! [A: $tType,F7: ( set @ A ),A7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F7 )
     => ( ( ord_less_eq @ ( set @ A ) @ F7 @ A7 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A4: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( member @ A @ A4 @ A7 )
                 => ( ~ ( member @ A @ A4 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ A4 @ F6 ) ) ) ) ) )
           => ( P @ F7 ) ) ) ) ) )).

% finite_subset_induct
thf(fact_223_subset__insert__iff,axiom,(
    ! [A: $tType,A7: ( set @ A ),X: A,B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ X @ B7 ) )
      = ( ( ( member @ A @ X @ A7 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 ) )
        & ( ~ ( member @ A @ X @ A7 )
         => ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) ) ) )).

% subset_insert_iff
thf(fact_224_Diff__single__insert,axiom,(
    ! [A: $tType,A7: ( set @ A ),X: A,B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 )
     => ( ord_less_eq @ ( set @ A ) @ A7 @ ( insert @ A @ X @ B7 ) ) ) )).

% Diff_single_insert
thf(fact_225_finite__remove__induct,axiom,(
    ! [A: $tType,B7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ B7 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A9: ( set @ A )] :
              ( ( finite_finite2 @ A @ A9 )
             => ( ( A9
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A9 @ B7 )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ A9 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A9 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A9 ) ) ) ) )
         => ( P @ B7 ) ) ) ) )).

% finite_remove_induct
thf(fact_226_insert__subsetI,axiom,(
    ! [A: $tType,X: A,A7: ( set @ A ),X9: ( set @ A )] :
      ( ( member @ A @ X @ A7 )
     => ( ( ord_less_eq @ ( set @ A ) @ X9 @ A7 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X9 ) @ A7 ) ) ) )).

% insert_subsetI
thf(fact_227_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,D2: A,C3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C3 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C3 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) )).

% diff_mono
thf(fact_228_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C3: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C3 @ A2 ) @ ( minus_minus @ A @ C3 @ B2 ) ) ) ) )).

% diff_left_mono
thf(fact_229_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,C3: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C3 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C3 ) ) ) )).

% diff_right_commute
thf(fact_230_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C3 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C3 = D2 ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_231_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C3 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C3 @ D2 ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_232_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C3 ) @ ( minus_minus @ A @ B2 @ C3 ) ) ) ) )).

% diff_right_mono
thf(fact_233_psubset__insert__iff,axiom,(
    ! [A: $tType,A7: ( set @ A ),X: A,B7: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A7 @ ( insert @ A @ X @ B7 ) )
      = ( ( ( member @ A @ X @ B7 )
         => ( ord_less @ ( set @ A ) @ A7 @ B7 ) )
        & ( ~ ( member @ A @ X @ B7 )
         => ( ( ( member @ A @ X @ A7 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A7 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 ) )
            & ( ~ ( member @ A @ X @ A7 )
             => ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) ) ) ) ) )).

% psubset_insert_iff
thf(fact_234_finite__induct__select,axiom,(
    ! [A: $tType,S2: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ S2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T6: ( set @ A )] :
              ( ( ord_less @ ( set @ A ) @ T6 @ S2 )
             => ( ( P @ T6 )
               => ? [X7: A] :
                    ( ( member @ A @ X7 @ ( minus_minus @ ( set @ A ) @ S2 @ T6 ) )
                    & ( P @ ( insert @ A @ X7 @ T6 ) ) ) ) )
         => ( P @ S2 ) ) ) ) )).

% finite_induct_select
thf(fact_235_psubsetI,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( A7 != B7 )
       => ( ord_less @ ( set @ A ) @ A7 @ B7 ) ) ) )).

% psubsetI
thf(fact_236_subset__iff__psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B9: ( set @ A )] :
            ( ( ord_less @ ( set @ A ) @ A8 @ B9 )
            | ( A8 = B9 ) ) ) ) )).

% subset_iff_psubset_eq
thf(fact_237_subset__psubset__trans,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
     => ( ( ord_less @ ( set @ A ) @ B7 @ C4 )
       => ( ord_less @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% subset_psubset_trans
thf(fact_238_subset__not__subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B9: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A8 @ B9 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B9 @ A8 ) ) ) ) )).

% subset_not_subset_eq
thf(fact_239_psubset__subset__trans,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ C4 )
       => ( ord_less @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% psubset_subset_trans
thf(fact_240_psubset__imp__subset,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
     => ( ord_less_eq @ ( set @ A ) @ A7 @ B7 ) ) )).

% psubset_imp_subset
thf(fact_241_psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B9: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A8 @ B9 )
            & ( A8 != B9 ) ) ) ) )).

% psubset_eq
thf(fact_242_psubsetE,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
         => ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) )).

% psubsetE
thf(fact_243_diff__strict__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C3 ) @ ( minus_minus @ A @ B2 @ C3 ) ) ) ) )).

% diff_strict_right_mono
thf(fact_244_diff__strict__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C3: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C3 @ A2 ) @ ( minus_minus @ A @ C3 @ B2 ) ) ) ) )).

% diff_strict_left_mono
thf(fact_245_diff__eq__diff__less,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C3 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C3 @ D2 ) ) ) ) )).

% diff_eq_diff_less
thf(fact_246_diff__strict__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,D2: A,C3: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C3 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C3 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) )).

% diff_strict_mono
thf(fact_247_not__psubset__empty,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A7 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_248_finite__psubset__induct,axiom,(
    ! [A: $tType,A7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ A7 )
     => ( ! [A9: ( set @ A )] :
            ( ( finite_finite2 @ A @ A9 )
           => ( ! [B11: ( set @ A )] :
                  ( ( ord_less @ ( set @ A ) @ B11 @ A9 )
                 => ( P @ B11 ) )
             => ( P @ A9 ) ) )
       => ( P @ A7 ) ) ) )).

% finite_psubset_induct
thf(fact_249_psubset__imp__ex__mem,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
     => ? [B4: A] :
          ( member @ A @ B4 @ ( minus_minus @ ( set @ A ) @ B7 @ A7 ) ) ) )).

% psubset_imp_ex_mem
thf(fact_250_psubset__trans,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
     => ( ( ord_less @ ( set @ A ) @ B7 @ C4 )
       => ( ord_less @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% psubset_trans
thf(fact_251_psubsetD,axiom,(
    ! [A: $tType,A7: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less @ ( set @ A ) @ A7 @ B7 )
     => ( ( member @ A @ C3 @ A7 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% psubsetD
thf(fact_252_finite__linorder__min__induct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A7: ( set @ A ),P: ( ( set @ A ) > $o )] :
          ( ( finite_finite2 @ A @ A7 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A9: ( set @ A )] :
                  ( ( finite_finite2 @ A @ A9 )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ A9 )
                       => ( ord_less @ A @ B4 @ X7 ) )
                   => ( ( P @ A9 )
                     => ( P @ ( insert @ A @ B4 @ A9 ) ) ) ) )
             => ( P @ A7 ) ) ) ) ) )).

% finite_linorder_min_induct
thf(fact_253_finite__linorder__max__induct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A7: ( set @ A ),P: ( ( set @ A ) > $o )] :
          ( ( finite_finite2 @ A @ A7 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A9: ( set @ A )] :
                  ( ( finite_finite2 @ A @ A9 )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ A9 )
                       => ( ord_less @ A @ X7 @ B4 ) )
                   => ( ( P @ A9 )
                     => ( P @ ( insert @ A @ B4 @ A9 ) ) ) ) )
             => ( P @ A7 ) ) ) ) ) )).

% finite_linorder_max_induct
thf(fact_254_infinite__growing,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X9: ( set @ A )] :
          ( ( X9
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X6: A] :
                ( ( member @ A @ X6 @ X9 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ X9 )
                    & ( ord_less @ A @ X6 @ Xa ) ) )
           => ~ ( finite_finite2 @ A @ X9 ) ) ) ) )).

% infinite_growing
thf(fact_255_Sup__fin_Oantimono,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A7: ( set @ A ),B7: ( set @ A )] :
          ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
         => ( ( A7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite2 @ A @ B7 )
             => ( ord_less_eq @ A @ ( lattic477160up_fin @ A @ A7 ) @ ( lattic477160up_fin @ A @ B7 ) ) ) ) ) ) )).

% Sup_fin.antimono

%----Type constructors (14)
thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A5: $tType,A11: $tType] :
      ( ( semilattice_sup @ A11 @ ( type2 @ A11 ) )
     => ( semilattice_sup @ ( A5 > A11 ) @ ( type2 @ ( A5 > A11 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A5: $tType,A11: $tType] :
      ( ( ( finite_finite @ A5 @ ( type2 @ A5 ) )
        & ( finite_finite @ A11 @ ( type2 @ A11 ) ) )
     => ( finite_finite @ ( A5 > A11 ) @ ( type2 @ ( A5 > A11 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A5: $tType,A11: $tType] :
      ( ( minus @ A11 @ ( type2 @ A11 ) )
     => ( minus @ ( A5 > A11 ) @ ( type2 @ ( A5 > A11 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_1,axiom,(
    ! [A5: $tType] :
      ( semilattice_sup @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_2,axiom,(
    ! [A5: $tType] :
      ( ( finite_finite @ A5 @ ( type2 @ A5 ) )
     => ( finite_finite @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_3,axiom,(
    ! [A5: $tType] :
      ( minus @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_4,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_5,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_6,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

thf(tcon_FSet_Ofset___Lattices_Osemilattice__sup_7,axiom,(
    ! [A5: $tType] :
      ( semilattice_sup @ ( fset @ A5 ) @ ( type2 @ ( fset @ A5 ) ) ) )).

thf(tcon_FSet_Ofset___Finite__Set_Ofinite_8,axiom,(
    ! [A5: $tType] :
      ( ( finite_finite @ A5 @ ( type2 @ A5 ) )
     => ( finite_finite @ ( fset @ A5 ) @ ( type2 @ ( fset @ A5 ) ) ) ) )).

thf(tcon_FSet_Ofset___Groups_Ominus_9,axiom,(
    ! [A5: $tType] :
      ( minus @ ( fset @ A5 ) @ ( type2 @ ( fset @ A5 ) ) ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_10,axiom,(
    ! [A5: $tType,A11: $tType] :
      ( ( ( finite_finite @ A5 @ ( type2 @ A5 ) )
        & ( finite_finite @ A11 @ ( type2 @ A11 ) ) )
     => ( finite_finite @ ( sum_sum @ A5 @ A11 ) @ ( type2 @ ( sum_sum @ A5 @ A11 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (3)
thf(conj_0,hypothesis,
    ( member @ n @ ( root @ tra ) @ nsa )).

thf(conj_1,hypothesis,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ ta ) @ ( cont @ tra ) )).

thf(conj_2,conjecture,
    ( member @ n @ ( root @ tra ) @ nsa )).

%------------------------------------------------------------------------------
