%------------------------------------------------------------------------------
% File     : COM184^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 228
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__228.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  322 (   0 unit;  51 type;   0 defn)
%            Number of atoms       : 4617 ( 298 equality;2769 variable)
%            Maximal formula depth :   22 (  10 average)
%            Number of connectives : 4268 ( 106   ~;  13   |;  70   &;3713   @)
%                                         (   0 <=>; 366  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  243 ( 243   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   55 (  51   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1189 (   1 sgn;1048   !;  47   ?;  47   ^)
%                                         (1189   :;  47  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:22.472
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (45)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Basic__BNFs_Osetl,type,(
    basic_setl: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_Basic__BNFs_Osetr,type,(
    basic_setr: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OFr,type,(
    gram_L861583724lle_Fr: ( set @ n ) > dtree > ( set @ t ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr,type,(
    gram_L716654942_subtr: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr2,type,(
    gram_L1283001940subtr2: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,(
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_ns,type,(
    ns: ( set @ n ) )).

thf(sy_v_tr1,type,(
    tr1: dtree )).

thf(sy_v_tr2,type,(
    tr2: dtree )).

thf(sy_v_tr3,type,(
    tr3: dtree )).

%----Relevant facts (256)
thf(fact_0_subtr_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L716654942_subtr @ Ns @ Tr @ Tr ) ) )).

% subtr.Refl
thf(fact_1_subtr_OStep,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr3 ) )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr.Step
thf(fact_2_subtr_Ocases,axiom,(
    ! [A1: ( set @ n ),A2: dtree,A3: dtree] :
      ( ( gram_L716654942_subtr @ A1 @ A2 @ A3 )
     => ( ( ( A3 = A2 )
         => ~ ( member @ n @ ( root @ A2 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A3 ) @ A1 )
           => ! [Tr22: dtree] :
                ( ( gram_L716654942_subtr @ A1 @ A2 @ Tr22 )
               => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ A3 ) ) ) ) ) ) )).

% subtr.cases
thf(fact_3_subtr_Osimps,axiom,
    ( gram_L716654942_subtr
    = ( ^ [A12: ( set @ n ),A22: dtree,A32: dtree] :
          ( ? [Tr4: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32 = Tr4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 ) )
          | ? [Tr32: dtree,Ns2: ( set @ n ),Tr12: dtree,Tr23: dtree] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr12 )
              & ( A32 = Tr32 )
              & ( member @ n @ ( root @ Tr32 ) @ Ns2 )
              & ( gram_L716654942_subtr @ Ns2 @ Tr12 @ Tr23 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ Tr32 ) ) ) ) ) )).

% subtr.simps
thf(fact_4_subtr2_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L1283001940subtr2 @ Ns @ Tr @ Tr ) ) )).

% subtr2.Refl
thf(fact_5_subtr2_OStep,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr2: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr2 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr2 @ Tr3 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr2.Step
thf(fact_6_subtr__StepL,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr2: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr2 ) )
       => ( ( gram_L716654942_subtr @ Ns @ Tr2 @ Tr3 )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr_StepL
thf(fact_7_subtr__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Tr3: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr2 @ Tr3 )
       => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr_trans
thf(fact_8_subtr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A2: dtree,A3: dtree] :
      ( ( gram_L1283001940subtr2 @ A1 @ A2 @ A3 )
     => ( ( ( A3 = A2 )
         => ~ ( member @ n @ ( root @ A2 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A2 ) @ A1 )
           => ! [Tr22: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ A2 ) @ ( cont @ Tr22 ) )
               => ~ ( gram_L1283001940subtr2 @ A1 @ Tr22 @ A3 ) ) ) ) ) )).

% subtr2.cases
thf(fact_9_subtr2_Osimps,axiom,
    ( gram_L1283001940subtr2
    = ( ^ [A12: ( set @ n ),A22: dtree,A32: dtree] :
          ( ? [Tr4: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32 = Tr4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 ) )
          | ? [Tr12: dtree,Ns2: ( set @ n ),Tr23: dtree,Tr32: dtree] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr12 )
              & ( A32 = Tr32 )
              & ( member @ n @ ( root @ Tr12 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
              & ( gram_L1283001940subtr2 @ Ns2 @ Tr23 @ Tr32 ) ) ) ) )).

% subtr2.simps
thf(fact_10_subtr2__StepR,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr2: dtree,Tr1: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr3 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr2_StepR
thf(fact_11_subtr2__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Tr3: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( ( gram_L1283001940subtr2 @ Ns @ Tr2 @ Tr3 )
       => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr2_trans
thf(fact_12_subtr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ X1 @ X2 @ X3 )
     => ( ! [Tr5: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
           => ( P @ Ns3 @ Tr5 @ Tr5 ) )
       => ( ! [Tr33: dtree,Ns3: ( set @ n ),Tr13: dtree,Tr22: dtree] :
              ( ( member @ n @ ( root @ Tr33 ) @ Ns3 )
             => ( ( gram_L716654942_subtr @ Ns3 @ Tr13 @ Tr22 )
               => ( ( P @ Ns3 @ Tr13 @ Tr22 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr33 ) )
                   => ( P @ Ns3 @ Tr13 @ Tr33 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% subtr.inducts
thf(fact_13_subtr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L1283001940subtr2 @ X1 @ X2 @ X3 )
     => ( ! [Tr5: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
           => ( P @ Ns3 @ Tr5 @ Tr5 ) )
       => ( ! [Tr13: dtree,Ns3: ( set @ n ),Tr22: dtree,Tr33: dtree] :
              ( ( member @ n @ ( root @ Tr13 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr22 ) )
               => ( ( gram_L1283001940subtr2 @ Ns3 @ Tr22 @ Tr33 )
                 => ( ( P @ Ns3 @ Tr22 @ Tr33 )
                   => ( P @ Ns3 @ Tr13 @ Tr33 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% subtr2.inducts
thf(fact_14_subtr__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr_rootL_in
thf(fact_15_subtr__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr2 ) @ Ns ) ) )).

% subtr_rootR_in
thf(fact_16_subtr2__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr2_rootL_in
thf(fact_17_subtr2__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr2 ) @ Ns ) ) )).

% subtr2_rootR_in
thf(fact_18_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% sum.inject(2)
thf(fact_19_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B3: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B3 ) )
      = ( B2 = B3 ) ) )).

% old.sum.inject(2)
thf(fact_20_dtree__cong,axiom,(
    ! [Tr: dtree,Tr6: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr6 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr6 ) )
       => ( Tr = Tr6 ) ) ) )).

% dtree_cong
thf(fact_21_inItr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,N: n] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L830233218_inItr @ Ns @ Tr1 @ N )
         => ( gram_L830233218_inItr @ Ns @ Tr @ N ) ) ) ) )).

% inItr.Ind
thf(fact_22_inItr_Ocases,axiom,(
    ! [A1: ( set @ n ),A2: dtree,A3: n] :
      ( ( gram_L830233218_inItr @ A1 @ A2 @ A3 )
     => ( ( ( A3
            = ( root @ A2 ) )
         => ~ ( member @ n @ ( root @ A2 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A2 ) @ A1 )
           => ! [Tr13: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ A2 ) )
               => ~ ( gram_L830233218_inItr @ A1 @ Tr13 @ A3 ) ) ) ) ) )).

% inItr.cases
thf(fact_23_inItr_Osimps,axiom,
    ( gram_L830233218_inItr
    = ( ^ [A12: ( set @ n ),A22: dtree,A32: n] :
          ( ? [Tr4: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32
                = ( root @ Tr4 ) )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 ) )
          | ? [Tr4: dtree,Ns2: ( set @ n ),Tr12: dtree,N2: n] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32 = N2 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
              & ( gram_L830233218_inItr @ Ns2 @ Tr12 @ N2 ) ) ) ) )).

% inItr.simps
thf(fact_24_inItr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: n,P: ( ( set @ n ) > dtree > n > $o )] :
      ( ( gram_L830233218_inItr @ X1 @ X2 @ X3 )
     => ( ! [Tr5: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
           => ( P @ Ns3 @ Tr5 @ ( root @ Tr5 ) ) )
       => ( ! [Tr5: dtree,Ns3: ( set @ n ),Tr13: dtree,N3: n] :
              ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr5 ) )
               => ( ( gram_L830233218_inItr @ Ns3 @ Tr13 @ N3 )
                 => ( ( P @ Ns3 @ Tr13 @ N3 )
                   => ( P @ Ns3 @ Tr5 @ N3 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inItr.inducts
thf(fact_25_inFr2__Ind,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr1 @ T2 )
     => ( ( member @ n @ ( root @ Tr ) @ Ns )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
         => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr2_Ind
thf(fact_26_inFr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 )
         => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr.Ind
thf(fact_27_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_28_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( X != Y )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_29_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_30_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_31_inFr__inFr2,axiom,(
    gram_L1333338417e_inFr = gram_L805317441_inFr2 )).

% inFr_inFr2
thf(fact_32_not__root__inFr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ~ ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) )).

% not_root_inFr
thf(fact_33_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_34_inFr2__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr2_root_in
thf(fact_35_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_36_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_37_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F2: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F2 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_38_inFr2_OInd,axiom,(
    ! [Tr1: dtree,Tr: dtree,Ns1: ( set @ n ),T2: t] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
     => ( ( gram_L805317441_inFr2 @ Ns1 @ Tr1 @ T2 )
       => ( gram_L805317441_inFr2 @ ( insert @ n @ ( root @ Tr ) @ Ns1 ) @ Tr @ T2 ) ) ) )).

% inFr2.Ind
thf(fact_39_inFr__Ind__minus,axiom,(
    ! [Ns1: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns1 @ Tr1 @ T2 )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ ( insert @ n @ ( root @ Tr ) @ Ns1 ) @ Tr @ T2 ) ) ) )).

% inFr_Ind_minus
thf(fact_40_inFr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L1333338417e_inFr @ X1 @ X2 @ X3 )
     => ( ! [Tr5: dtree,Ns3: ( set @ n ),T3: t] :
            ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr5 ) )
             => ( P @ Ns3 @ Tr5 @ T3 ) ) )
       => ( ! [Tr5: dtree,Ns3: ( set @ n ),Tr13: dtree,T3: t] :
              ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr5 ) )
               => ( ( gram_L1333338417e_inFr @ Ns3 @ Tr13 @ T3 )
                 => ( ( P @ Ns3 @ Tr13 @ T3 )
                   => ( P @ Ns3 @ Tr5 @ T3 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inFr.inducts
thf(fact_41_inFr_Osimps,axiom,
    ( gram_L1333338417e_inFr
    = ( ^ [A12: ( set @ n ),A22: dtree,A32: t] :
          ( ? [Tr4: dtree,Ns2: ( set @ n ),T4: t] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32 = T4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr4 ) ) )
          | ? [Tr4: dtree,Ns2: ( set @ n ),Tr12: dtree,T4: t] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32 = T4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
              & ( gram_L1333338417e_inFr @ Ns2 @ Tr12 @ T4 ) ) ) ) )).

% inFr.simps
thf(fact_42_inFr_Ocases,axiom,(
    ! [A1: ( set @ n ),A2: dtree,A3: t] :
      ( ( gram_L1333338417e_inFr @ A1 @ A2 @ A3 )
     => ( ( ( member @ n @ ( root @ A2 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A3 ) @ ( cont @ A2 ) ) )
       => ~ ( ( member @ n @ ( root @ A2 ) @ A1 )
           => ! [Tr13: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ A2 ) )
               => ~ ( gram_L1333338417e_inFr @ A1 @ Tr13 @ A3 ) ) ) ) ) )).

% inFr.cases
thf(fact_43_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F @ ( sum_Inr @ B @ A @ X ) )
      = ( F @ X ) ) )).

% Sumr.simps
thf(fact_44_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P: ( A > $o )] :
      ( ( member @ A @ A4 @ ( collect @ A @ P ) )
      = ( P @ A4 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
          = ( Q @ X5 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X5: A] :
          ( ( F @ X5 )
          = ( G @ X5 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B2: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% corec(1)
thf(fact_50_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_51_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A4: A,A6: A] :
      ( ( ( sum_Inl @ A @ B @ A4 )
        = ( sum_Inl @ A @ B @ A6 ) )
      = ( A4 = A6 ) ) )).

% old.sum.inject(1)
thf(fact_52_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F2: ( B > T ),A4: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inl @ A @ B @ A4 ) )
      = ( F1 @ A4 ) ) )).

% old.sum.simps(7)
thf(fact_53_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_54_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),G: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F )
        = ( sum_Sumr @ B @ C @ A @ G ) )
     => ( F = G ) ) )).

% Sumr_inject
thf(fact_55_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X2 ) ) )).

% sum.distinct(1)
thf(fact_56_old_Osum_Odistinct_I2_J,axiom,(
    ! [B4: $tType,A7: $tType,B5: B4,A8: A7] :
      ( ( sum_Inr @ B4 @ A7 @ B5 )
     != ( sum_Inl @ A7 @ B4 @ A8 ) ) )).

% old.sum.distinct(2)
thf(fact_57_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A4: A,B3: B] :
      ( ( sum_Inl @ A @ B @ A4 )
     != ( sum_Inr @ B @ A @ B3 ) ) )).

% old.sum.distinct(1)
thf(fact_58_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X5: A] :
          ( S
         != ( sum_Inl @ A @ B @ X5 ) )
     => ~ ( ! [Y3: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y3 ) ) ) ) )).

% sumE
thf(fact_59_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A4: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A4 ) ) )).

% Inr_not_Inl
thf(fact_60_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X6: ( sum_sum @ A @ B )] :
            ( P2 @ X6 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X4: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X4 ) )
            | ? [X4: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% split_sum_ex
thf(fact_61_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X6: ( sum_sum @ A @ B )] :
            ( P2 @ X6 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X4: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X4 ) )
            & ! [X4: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% split_sum_all
thf(fact_62_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A9: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A9 ) )
     => ~ ( ! [B6: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B6 ) ) ) ) )).

% old.sum.exhaust
thf(fact_63_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A9: A] :
          ( P @ ( sum_Inl @ A @ B @ A9 ) )
     => ( ! [B6: B] :
            ( P @ ( sum_Inr @ B @ A @ B6 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_64_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X5: A] :
          ( S
         != ( sum_Inl @ A @ B @ X5 ) )
     => ~ ( ! [X5: B] :
              ( S
             != ( sum_Inr @ B @ A @ X5 ) ) ) ) )).

% obj_sumE
thf(fact_65_inFr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A2: dtree,A3: t] :
      ( ( gram_L805317441_inFr2 @ A1 @ A2 @ A3 )
     => ( ( ( member @ n @ ( root @ A2 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A3 ) @ ( cont @ A2 ) ) )
       => ~ ( ! [Tr13: dtree,Tr5: dtree,Ns12: ( set @ n )] :
                ( ( A1
                  = ( insert @ n @ ( root @ Tr5 ) @ Ns12 ) )
               => ( ( A2 = Tr5 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr5 ) )
                   => ~ ( gram_L805317441_inFr2 @ Ns12 @ Tr13 @ A3 ) ) ) ) ) ) ) )).

% inFr2.cases
thf(fact_66_inFr2_Osimps,axiom,
    ( gram_L805317441_inFr2
    = ( ^ [A12: ( set @ n ),A22: dtree,A32: t] :
          ( ? [Tr4: dtree,Ns2: ( set @ n ),T4: t] :
              ( ( A12 = Ns2 )
              & ( A22 = Tr4 )
              & ( A32 = T4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr4 ) ) )
          | ? [Tr12: dtree,Tr4: dtree,Ns13: ( set @ n ),T4: t] :
              ( ( A12
                = ( insert @ n @ ( root @ Tr4 ) @ Ns13 ) )
              & ( A22 = Tr4 )
              & ( A32 = T4 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
              & ( gram_L805317441_inFr2 @ Ns13 @ Tr12 @ T4 ) ) ) ) )).

% inFr2.simps
thf(fact_67_inFr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L805317441_inFr2 @ X1 @ X2 @ X3 )
     => ( ! [Tr5: dtree,Ns3: ( set @ n ),T3: t] :
            ( ( member @ n @ ( root @ Tr5 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr5 ) )
             => ( P @ Ns3 @ Tr5 @ T3 ) ) )
       => ( ! [Tr13: dtree,Tr5: dtree,Ns12: ( set @ n ),T3: t] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr5 ) )
             => ( ( gram_L805317441_inFr2 @ Ns12 @ Tr13 @ T3 )
               => ( ( P @ Ns12 @ Tr13 @ T3 )
                 => ( P @ ( insert @ n @ ( root @ Tr5 ) @ Ns12 ) @ Tr5 @ T3 ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inFr2.inducts
thf(fact_68_inFr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) )).

% inFr.Base
thf(fact_69_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_70_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_71_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_72_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A5 ) )
      = ( insert @ A @ X @ A5 ) ) )).

% insert_absorb2
thf(fact_73_insert__iff,axiom,(
    ! [A: $tType,A4: A,B2: A,A5: ( set @ A )] :
      ( ( member @ A @ A4 @ ( insert @ A @ B2 @ A5 ) )
      = ( ( A4 = B2 )
        | ( member @ A @ A4 @ A5 ) ) ) )).

% insert_iff
thf(fact_74_insertCI,axiom,(
    ! [A: $tType,A4: A,B7: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A4 @ B7 )
       => ( A4 = B2 ) )
     => ( member @ A @ A4 @ ( insert @ A @ B2 @ B7 ) ) ) )).

% insertCI
thf(fact_75_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X5: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X5 ) ) )
         => P )
     => ( ! [X5: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X5 ) ) )
           => P )
       => ! [X7: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X7 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_76_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X ) )
      = ( F @ X ) ) )).

% Suml.simps
thf(fact_77_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_78_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N: n,N4: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N @ As )
            = ( node @ N4 @ As2 ) )
          = ( ( N = N4 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_79_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G ) )
     => ( F = G ) ) )).

% Suml_inject
thf(fact_80_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_81_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N3: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N3 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_82_insertE,axiom,(
    ! [A: $tType,A4: A,B2: A,A5: ( set @ A )] :
      ( ( member @ A @ A4 @ ( insert @ A @ B2 @ A5 ) )
     => ( ( A4 != B2 )
       => ( member @ A @ A4 @ A5 ) ) ) )).

% insertE
thf(fact_83_insertI1,axiom,(
    ! [A: $tType,A4: A,B7: ( set @ A )] :
      ( member @ A @ A4 @ ( insert @ A @ A4 @ B7 ) ) )).

% insertI1
thf(fact_84_insertI2,axiom,(
    ! [A: $tType,A4: A,B7: ( set @ A ),B2: A] :
      ( ( member @ A @ A4 @ B7 )
     => ( member @ A @ A4 @ ( insert @ A @ B2 @ B7 ) ) ) )).

% insertI2
thf(fact_85_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A )] :
      ( ( member @ A @ X @ A5 )
     => ~ ( ! [B8: ( set @ A )] :
              ( ( A5
                = ( insert @ A @ X @ B8 ) )
             => ( member @ A @ X @ B8 ) ) ) ) )).

% Set.set_insert
thf(fact_86_insert__ident,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A5 )
     => ( ~ ( member @ A @ X @ B7 )
       => ( ( ( insert @ A @ X @ A5 )
            = ( insert @ A @ X @ B7 ) )
          = ( A5 = B7 ) ) ) ) )).

% insert_ident
thf(fact_87_insert__absorb,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A )] :
      ( ( member @ A @ A4 @ A5 )
     => ( ( insert @ A @ A4 @ A5 )
        = A5 ) ) )).

% insert_absorb
thf(fact_88_insert__eq__iff,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A ),B2: A,B7: ( set @ A )] :
      ( ~ ( member @ A @ A4 @ A5 )
     => ( ~ ( member @ A @ B2 @ B7 )
       => ( ( ( insert @ A @ A4 @ A5 )
            = ( insert @ A @ B2 @ B7 ) )
          = ( ( ( A4 = B2 )
             => ( A5 = B7 ) )
            & ( ( A4 != B2 )
             => ? [C2: ( set @ A )] :
                  ( ( A5
                    = ( insert @ A @ B2 @ C2 ) )
                  & ~ ( member @ A @ B2 @ C2 )
                  & ( B7
                    = ( insert @ A @ A4 @ C2 ) )
                  & ~ ( member @ A @ A4 @ C2 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_89_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A5: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A5 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A5 ) ) ) )).

% insert_commute
thf(fact_90_mk__disjoint__insert,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A )] :
      ( ( member @ A @ A4 @ A5 )
     => ? [B8: ( set @ A )] :
          ( ( A5
            = ( insert @ A @ A4 @ B8 ) )
          & ~ ( member @ A @ A4 @ B8 ) ) ) )).

% mk_disjoint_insert
thf(fact_91_finite__insert,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A4 @ A5 ) )
      = ( finite_finite2 @ A @ A5 ) ) )).

% finite_insert
thf(fact_92_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A10: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_93_finite_OinsertI,axiom,(
    ! [A: $tType,A5: ( set @ A ),A4: A] :
      ( ( finite_finite2 @ A @ A5 )
     => ( finite_finite2 @ A @ ( insert @ A @ A4 @ A5 ) ) ) )).

% finite.insertI
thf(fact_94_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A5: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A5 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A5 )
           => ? [X12: B] :
                ( P @ X5 @ X12 ) )
       => ? [F3: ( A > B )] :
          ! [X7: A] :
            ( ( member @ A @ X7 @ A5 )
           => ( P @ X7 @ ( F3 @ X7 ) ) ) ) ) )).

% finite_set_choice
thf(fact_95_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A5: ( set @ A )] :
          ( finite_finite2 @ A @ A5 ) ) )).

% finite
thf(fact_96_case__sum__if,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P4: $o,F: ( B > A ),G: ( C > A ),X: B,Y: C] :
      ( ( P4
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P4 @ ( sum_Inl @ B @ C @ X ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( F @ X ) ) )
      & ( ~ ( P4 )
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P4 @ ( sum_Inl @ B @ C @ X ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( G @ Y ) ) ) ) )).

% case_sum_if
thf(fact_97_case__sum__step_I1_J,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F4: ( B > A ),G2: ( C > A ),G: ( D > A ),P4: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ ( sum_sum @ B @ C ) @ A @ D @ ( sum_case_sum @ B @ A @ C @ F4 @ G2 ) @ G @ ( sum_Inl @ ( sum_sum @ B @ C ) @ D @ P4 ) )
      = ( sum_case_sum @ B @ A @ C @ F4 @ G2 @ P4 ) ) )).

% case_sum_step(1)
thf(fact_98_case__sum__step_I2_J,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,F: ( E > A ),F4: ( B > A ),G2: ( C > A ),P4: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ E @ A @ ( sum_sum @ B @ C ) @ F @ ( sum_case_sum @ B @ A @ C @ F4 @ G2 ) @ ( sum_Inr @ ( sum_sum @ B @ C ) @ E @ P4 ) )
      = ( sum_case_sum @ B @ A @ C @ F4 @ G2 @ P4 ) ) )).

% case_sum_step(2)
thf(fact_99_case__sum__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F2: ( B > C ),G1: ( A > C ),G22: ( B > C )] :
      ( ( ( sum_case_sum @ A @ C @ B @ F1 @ F2 )
        = ( sum_case_sum @ A @ C @ B @ G1 @ G22 ) )
     => ~ ( ( F1 = G1 )
         => ( F2 != G22 ) ) ) )).

% case_sum_inject
thf(fact_100_old_Osum_Osimps_I6_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F2: ( B > C ),X2: B] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F2 @ ( sum_Inr @ B @ A @ X2 ) )
      = ( F2 @ X2 ) ) )).

% old.sum.simps(6)
thf(fact_101_old_Osum_Osimps_I5_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F1: ( A > C ),F2: ( B > C ),X1: A] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F2 @ ( sum_Inl @ A @ B @ X1 ) )
      = ( F1 @ X1 ) ) )).

% old.sum.simps(5)
thf(fact_102_case__sum__expand__Inr,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),X: ( sum_sum @ A @ C )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( F @ X )
        = ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) @ X ) ) ) )).

% case_sum_expand_Inr
thf(fact_103_case__sum__expand__Inr_H,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),H: ( C > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( H
          = ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = ( ( sum_case_sum @ A @ B @ C @ G @ H )
          = F ) ) ) )).

% case_sum_expand_Inr'
thf(fact_104_case__sum__expand__Inr__pointfree,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = F ) ) )).

% case_sum_expand_Inr_pointfree
thf(fact_105_finite__Plus__iff,axiom,(
    ! [A: $tType,B: $tType,A5: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A5 @ B7 ) )
      = ( ( finite_finite2 @ A @ A5 )
        & ( finite_finite2 @ B @ B7 ) ) ) )).

% finite_Plus_iff
thf(fact_106_finite__Diff__insert,axiom,(
    ! [A: $tType,A5: ( set @ A ),A4: A,B7: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ A4 @ B7 ) ) )
      = ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) ) )).

% finite_Diff_insert
thf(fact_107_Diff__idemp,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) @ B7 )
      = ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) )).

% Diff_idemp
thf(fact_108_Diff__iff,axiom,(
    ! [A: $tType,C3: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) )
      = ( ( member @ A @ C3 @ A5 )
        & ~ ( member @ A @ C3 @ B7 ) ) ) )).

% Diff_iff
thf(fact_109_DiffI,axiom,(
    ! [A: $tType,C3: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ A5 )
     => ( ~ ( member @ A @ C3 @ B7 )
       => ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) ) ) )).

% DiffI
thf(fact_110_finite__Diff2,axiom,(
    ! [A: $tType,B7: ( set @ A ),A5: ( set @ A )] :
      ( ( finite_finite2 @ A @ B7 )
     => ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) )
        = ( finite_finite2 @ A @ A5 ) ) ) )).

% finite_Diff2
thf(fact_111_finite__Diff,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( finite_finite2 @ A @ A5 )
     => ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) ) )).

% finite_Diff
thf(fact_112_insert__Diff1,axiom,(
    ! [A: $tType,X: A,B7: ( set @ A ),A5: ( set @ A )] :
      ( ( member @ A @ X @ B7 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A5 ) @ B7 )
        = ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) ) )).

% insert_Diff1
thf(fact_113_Diff__insert0,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A5 )
     => ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ X @ B7 ) )
        = ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) ) )).

% Diff_insert0
thf(fact_114_InrI,axiom,(
    ! [B: $tType,A: $tType,B2: A,B7: ( set @ A ),A5: ( set @ B )] :
      ( ( member @ A @ B2 @ B7 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B2 ) @ ( sum_Plus @ B @ A @ A5 @ B7 ) ) ) )).

% InrI
thf(fact_115_InlI,axiom,(
    ! [A: $tType,B: $tType,A4: A,A5: ( set @ A ),B7: ( set @ B )] :
      ( ( member @ A @ A4 @ A5 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A4 ) @ ( sum_Plus @ A @ B @ A5 @ B7 ) ) ) )).

% InlI
thf(fact_116_o__case__sum,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H: ( D > C ),F: ( A > D ),G: ( B > D )] :
      ( ( comp @ D @ C @ ( sum_sum @ A @ B ) @ H @ ( sum_case_sum @ A @ D @ B @ F @ G ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ H @ F ) @ ( comp @ D @ C @ B @ H @ G ) ) ) )).

% o_case_sum
thf(fact_117_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_118_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_119_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_120_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_121_DiffD2,axiom,(
    ! [A: $tType,C3: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) )
     => ~ ( member @ A @ C3 @ B7 ) ) )).

% DiffD2
thf(fact_122_DiffD1,axiom,(
    ! [A: $tType,C3: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) )
     => ( member @ A @ C3 @ A5 ) ) )).

% DiffD1
thf(fact_123_DiffE,axiom,(
    ! [A: $tType,C3: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) )
     => ~ ( ( member @ A @ C3 @ A5 )
         => ( member @ A @ C3 @ B7 ) ) ) )).

% DiffE
thf(fact_124_Diff__infinite__finite,axiom,(
    ! [A: $tType,T5: ( set @ A ),S2: ( set @ A )] :
      ( ( finite_finite2 @ A @ T5 )
     => ( ~ ( finite_finite2 @ A @ S2 )
       => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) )).

% Diff_infinite_finite
thf(fact_125_insert__Diff__if,axiom,(
    ! [A: $tType,X: A,B7: ( set @ A ),A5: ( set @ A )] :
      ( ( ( member @ A @ X @ B7 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A5 ) @ B7 )
          = ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) )
      & ( ~ ( member @ A @ X @ B7 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A5 ) @ B7 )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) ) ) ) ) )).

% insert_Diff_if
thf(fact_126_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A5: ( set @ A ),B7: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A5 @ B7 ) )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A5 )
           => ( U
             != ( sum_Inl @ A @ B @ X5 ) ) )
       => ~ ( ! [Y3: B] :
                ( ( member @ B @ Y3 @ B7 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y3 ) ) ) ) ) ) )).

% PlusE
thf(fact_127_finite__PlusD_I2_J,axiom,(
    ! [A: $tType,B: $tType,A5: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A5 @ B7 ) )
     => ( finite_finite2 @ B @ B7 ) ) )).

% finite_PlusD(2)
thf(fact_128_finite__PlusD_I1_J,axiom,(
    ! [B: $tType,A: $tType,A5: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A5 @ B7 ) )
     => ( finite_finite2 @ A @ A5 ) ) )).

% finite_PlusD(1)
thf(fact_129_finite__Plus,axiom,(
    ! [A: $tType,B: $tType,A5: ( set @ A ),B7: ( set @ B )] :
      ( ( finite_finite2 @ A @ A5 )
     => ( ( finite_finite2 @ B @ B7 )
       => ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A5 @ B7 ) ) ) ) )).

% finite_Plus
thf(fact_130_case__sum__o__inj_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inl @ A @ C ) )
      = F ) )).

% case_sum_o_inj(1)
thf(fact_131_case__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ C @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inr @ C @ A ) )
      = G ) )).

% case_sum_o_inj(2)
thf(fact_132_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F5: ( B > A ),G3: ( C > B ),X4: C] :
            ( F5 @ ( G3 @ X4 ) ) ) ) )).

% comp_apply
thf(fact_133_minus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A10: ( A > B ),B9: ( A > B ),X4: A] :
              ( minus_minus @ B @ ( A10 @ X4 ) @ ( B9 @ X4 ) ) ) ) ) )).

% minus_apply
thf(fact_134_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F5: ( B > C ),G3: ( A > B ),X4: A] :
            ( F5 @ ( G3 @ X4 ) ) ) ) )).

% comp_def
thf(fact_135_fun__diff__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A10: ( A > B ),B9: ( A > B ),X4: A] :
              ( minus_minus @ B @ ( A10 @ X4 ) @ ( B9 @ X4 ) ) ) ) ) )).

% fun_diff_def
thf(fact_136_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_137_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A4: ( C > B ),B2: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A4 @ B2 )
        = C3 )
     => ( ( A4 @ ( B2 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_138_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A4: ( C > B ),B2: ( A > C ),C3: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A4 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ! [V2: A] :
          ( ( A4 @ ( B2 @ V2 ) )
          = ( C3 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_139_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A4: ( C > B ),B2: ( A > C ),C3: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A4 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ( ( A4 @ ( B2 @ V ) )
        = ( C3 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_140_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_141_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X: C,N5: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X ) )
        = ( N5 @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N5 ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_142_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_143_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G: ( C > B ),X: C,F4: ( D > A ),G2: ( E > D ),X8: E] :
      ( ( ( F @ ( G @ X ) )
        = ( F4 @ ( G2 @ X8 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ E @ F4 @ G2 @ X8 ) ) ) )).

% comp_cong
thf(fact_144_infinite__remove,axiom,(
    ! [A: $tType,S2: ( set @ A ),A4: A] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% infinite_remove
thf(fact_145_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_146_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_147_all__not__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_148_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_149_singletonI,axiom,(
    ! [A: $tType,A4: A] :
      ( member @ A @ A4 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_150_Diff__cancel,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ A5 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_151_empty__Diff,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A5 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_152_Diff__empty,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) )
      = A5 ) )).

% Diff_empty
thf(fact_153_Plus__eq__empty__conv,axiom,(
    ! [A: $tType,B: $tType,A5: ( set @ A ),B7: ( set @ B )] :
      ( ( ( sum_Plus @ A @ B @ A5 @ B7 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        & ( B7
          = ( bot_bot @ ( set @ B ) ) ) ) ) )).

% Plus_eq_empty_conv
thf(fact_154_insert__Diff__single,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A )] :
      ( ( insert @ A @ A4 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A4 @ A5 ) ) )).

% insert_Diff_single
thf(fact_155_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_156_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S2: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_157_singletonD,axiom,(
    ! [A: $tType,B2: A,A4: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A4 ) ) )).

% singletonD
thf(fact_158_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A4: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A4 ) ) )).

% singleton_iff
thf(fact_159_doubleton__eq__iff,axiom,(
    ! [A: $tType,A4: A,B2: A,C3: A,D2: A] :
      ( ( ( insert @ A @ A4 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C3 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A4 = C3 )
          & ( B2 = D2 ) )
        | ( ( A4 = D2 )
          & ( B2 = C3 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_160_insert__not__empty,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A )] :
      ( ( insert @ A @ A4 @ A5 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_161_singleton__inject,axiom,(
    ! [A: $tType,A4: A,B2: A] :
      ( ( ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A4 = B2 ) ) )).

% singleton_inject
thf(fact_162_ex__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A5 ) )
      = ( A5
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_163_equals0I,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A5 )
     => ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_164_equals0D,axiom,(
    ! [A: $tType,A5: ( set @ A ),A4: A] :
      ( ( A5
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A4 @ A5 ) ) )).

% equals0D
thf(fact_165_emptyE,axiom,(
    ! [A: $tType,A4: A] :
      ~ ( member @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_166_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A5: ( set @ A )] :
      ( ! [A11: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A11 )
         => ( P @ A11 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X5: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X5 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X5 @ F6 ) ) ) ) )
         => ( P @ A5 ) ) ) ) )).

% infinite_finite_induct
thf(fact_167_finite__ne__induct,axiom,(
    ! [A: $tType,F7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F7 )
     => ( ( F7
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X5: A] :
              ( P @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X5: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( F6
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X5 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ X5 @ F6 ) ) ) ) ) )
           => ( P @ F7 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_168_finite_Oinducts,axiom,(
    ! [A: $tType,X: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A11: ( set @ A ),A9: A] :
              ( ( finite_finite2 @ A @ A11 )
             => ( ( P @ A11 )
               => ( P @ ( insert @ A @ A9 @ A11 ) ) ) )
         => ( P @ X ) ) ) ) )).

% finite.inducts
thf(fact_169_finite__induct,axiom,(
    ! [A: $tType,F7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F7 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X5: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X5 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X5 @ F6 ) ) ) ) )
         => ( P @ F7 ) ) ) ) )).

% finite_induct
thf(fact_170_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A13: ( set @ A )] :
            ( ( A13
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A10: ( set @ A ),B10: A] :
                ( ( A13
                  = ( insert @ A @ B10 @ A10 ) )
                & ( finite_finite2 @ A @ A10 ) ) ) ) ) )).

% finite.simps
thf(fact_171_finite_Ocases,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( finite_finite2 @ A @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A11: ( set @ A )] :
                ( ? [A9: A] :
                    ( A4
                    = ( insert @ A @ A9 @ A11 ) )
               => ~ ( finite_finite2 @ A @ A11 ) ) ) ) ) )).

% finite.cases
thf(fact_172_Diff__insert,axiom,(
    ! [A: $tType,A5: ( set @ A ),A4: A,B7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ A4 @ B7 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert
thf(fact_173_insert__Diff,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A )] :
      ( ( member @ A @ A4 @ A5 )
     => ( ( insert @ A @ A4 @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A5 ) ) )).

% insert_Diff
thf(fact_174_Diff__insert2,axiom,(
    ! [A: $tType,A5: ( set @ A ),A4: A,B7: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ A4 @ B7 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 ) ) )).

% Diff_insert2
thf(fact_175_Diff__insert__absorb,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A )] :
      ( ~ ( member @ A @ X @ A5 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A5 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A5 ) ) )).

% Diff_insert_absorb
thf(fact_176_finite__empty__induct,axiom,(
    ! [A: $tType,A5: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ A5 )
     => ( ( P @ A5 )
       => ( ! [A9: A,A11: ( set @ A )] :
              ( ( finite_finite2 @ A @ A11 )
             => ( ( member @ A @ A9 @ A11 )
               => ( ( P @ A11 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A11 @ ( insert @ A @ A9 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% finite_empty_induct
thf(fact_177_infinite__coinduct,axiom,(
    ! [A: $tType,X9: ( ( set @ A ) > $o ),A5: ( set @ A )] :
      ( ( X9 @ A5 )
     => ( ! [A11: ( set @ A )] :
            ( ( X9 @ A11 )
           => ? [X7: A] :
                ( ( member @ A @ X7 @ A11 )
                & ( ( X9 @ ( minus_minus @ ( set @ A ) @ A11 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A11 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite2 @ A @ A5 ) ) ) )).

% infinite_coinduct
thf(fact_178_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_179_remove__def,axiom,(
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X4: A,A10: ( set @ A )] :
            ( minus_minus @ ( set @ A ) @ A10 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% remove_def
thf(fact_180_not__root__Fr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( gram_L861583724lle_Fr @ Ns @ Tr )
        = ( bot_bot @ ( set @ t ) ) ) ) )).

% not_root_Fr
thf(fact_181_member__remove,axiom,(
    ! [A: $tType,X: A,Y: A,A5: ( set @ A )] :
      ( ( member @ A @ X @ ( remove @ A @ Y @ A5 ) )
      = ( ( member @ A @ X @ A5 )
        & ( X != Y ) ) ) )).

% member_remove
thf(fact_182_is__singletonI_H,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( A5
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X5: A,Y3: A] :
            ( ( member @ A @ X5 @ A5 )
           => ( ( member @ A @ Y3 @ A5 )
             => ( X5 = Y3 ) ) )
       => ( is_singleton @ A @ A5 ) ) ) )).

% is_singletonI'
thf(fact_183_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A10: ( set @ A )] :
          ? [X4: A] :
            ( A10
            = ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_184_is__singletonE,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( is_singleton @ A @ A5 )
     => ~ ( ! [X5: A] :
              ( A5
             != ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_185_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A10: ( set @ A )] :
            ( A10
            = ( insert @ A @ ( the_elem @ A @ A10 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_186_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_187_sum__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: A] :
      ( ( basic_setl @ A @ B @ ( sum_Inl @ A @ B @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(1)
thf(fact_188_sum__set__simps_I2_J,axiom,(
    ! [A: $tType,C: $tType,X: A] :
      ( ( basic_setl @ C @ A @ ( sum_Inr @ A @ C @ X ) )
      = ( bot_bot @ ( set @ C ) ) ) )).

% sum_set_simps(2)
thf(fact_189_setl_Oinducts,axiom,(
    ! [B: $tType,A: $tType,X: A,S: ( sum_sum @ A @ B ),P: ( A > $o )] :
      ( ( member @ A @ X @ ( basic_setl @ A @ B @ S ) )
     => ( ! [X5: A] :
            ( ( S
              = ( sum_Inl @ A @ B @ X5 ) )
           => ( P @ X5 ) )
       => ( P @ X ) ) ) )).

% setl.inducts
thf(fact_190_setl_Ointros,axiom,(
    ! [B: $tType,A: $tType,S: ( sum_sum @ A @ B ),X: A] :
      ( ( S
        = ( sum_Inl @ A @ B @ X ) )
     => ( member @ A @ X @ ( basic_setl @ A @ B @ S ) ) ) )).

% setl.intros
thf(fact_191_setl_Osimps,axiom,(
    ! [B: $tType,A: $tType,A4: A,S: ( sum_sum @ A @ B )] :
      ( ( member @ A @ A4 @ ( basic_setl @ A @ B @ S ) )
      = ( ? [X4: A] :
            ( ( A4 = X4 )
            & ( S
              = ( sum_Inl @ A @ B @ X4 ) ) ) ) ) )).

% setl.simps
thf(fact_192_setl_Ocases,axiom,(
    ! [B: $tType,A: $tType,A4: A,S: ( sum_sum @ A @ B )] :
      ( ( member @ A @ A4 @ ( basic_setl @ A @ B @ S ) )
     => ( S
        = ( sum_Inl @ A @ B @ A4 ) ) ) )).

% setl.cases
thf(fact_193_sum__set__simps_I4_J,axiom,(
    ! [E: $tType,A: $tType,X: A] :
      ( ( basic_setr @ E @ A @ ( sum_Inr @ A @ E @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(4)
thf(fact_194_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A10: ( set @ A )] :
            ( A10
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_195_sum__set__simps_I3_J,axiom,(
    ! [A: $tType,D: $tType,X: A] :
      ( ( basic_setr @ A @ D @ ( sum_Inl @ A @ D @ X ) )
      = ( bot_bot @ ( set @ D ) ) ) )).

% sum_set_simps(3)
thf(fact_196_setr_Oinducts,axiom,(
    ! [A: $tType,B: $tType,X: B,S: ( sum_sum @ A @ B ),P: ( B > $o )] :
      ( ( member @ B @ X @ ( basic_setr @ A @ B @ S ) )
     => ( ! [X5: B] :
            ( ( S
              = ( sum_Inr @ B @ A @ X5 ) )
           => ( P @ X5 ) )
       => ( P @ X ) ) ) )).

% setr.inducts
thf(fact_197_setr_Ointros,axiom,(
    ! [B: $tType,A: $tType,S: ( sum_sum @ A @ B ),X: B] :
      ( ( S
        = ( sum_Inr @ B @ A @ X ) )
     => ( member @ B @ X @ ( basic_setr @ A @ B @ S ) ) ) )).

% setr.intros
thf(fact_198_setr_Osimps,axiom,(
    ! [A: $tType,B: $tType,A4: B,S: ( sum_sum @ A @ B )] :
      ( ( member @ B @ A4 @ ( basic_setr @ A @ B @ S ) )
      = ( ? [X4: B] :
            ( ( A4 = X4 )
            & ( S
              = ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% setr.simps
thf(fact_199_setr_Ocases,axiom,(
    ! [A: $tType,B: $tType,A4: B,S: ( sum_sum @ A @ B )] :
      ( ( member @ B @ A4 @ ( basic_setr @ A @ B @ S ) )
     => ( S
        = ( sum_Inr @ B @ A @ A4 ) ) ) )).

% setr.cases
thf(fact_200_remove__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),B7: ( set @ A )] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite2 @ A @ B7 )
         => ( P @ B7 ) )
       => ( ! [A11: ( set @ A )] :
              ( ( finite_finite2 @ A @ A11 )
             => ( ( A11
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A11 @ B7 )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ A11 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A11 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A11 ) ) ) ) )
         => ( P @ B7 ) ) ) ) )).

% remove_induct
thf(fact_201_finite__remove__induct,axiom,(
    ! [A: $tType,B7: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ B7 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A11: ( set @ A )] :
              ( ( finite_finite2 @ A @ A11 )
             => ( ( A11
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A11 @ B7 )
                 => ( ! [X7: A] :
                        ( ( member @ A @ X7 @ A11 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A11 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A11 ) ) ) ) )
         => ( P @ B7 ) ) ) ) )).

% finite_remove_induct
thf(fact_202_subset__antisym,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A5 )
       => ( A5 = B7 ) ) ) )).

% subset_antisym
thf(fact_203_subsetI,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A5 )
         => ( member @ A @ X5 @ B7 ) )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) )).

% subsetI
thf(fact_204_empty__subsetI,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A5 ) )).

% empty_subsetI
thf(fact_205_subset__empty,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_206_insert__subset,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A5 ) @ B7 )
      = ( ( member @ A @ X @ B7 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) ) )).

% insert_subset
thf(fact_207_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A4: A,A5: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A4 @ A5 ) )
      = ( ( A4 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_208_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A4: A,A5: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A4 @ A5 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A4 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_209_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A5 @ B7 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) )).

% Diff_eq_empty_iff
thf(fact_210_Diff__mono,axiom,(
    ! [A: $tType,A5: ( set @ A ),C4: ( set @ A ),D3: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ D3 @ B7 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) @ ( minus_minus @ ( set @ A ) @ C4 @ D3 ) ) ) ) )).

% Diff_mono
thf(fact_211_Diff__subset,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ B7 ) @ A5 ) )).

% Diff_subset
thf(fact_212_double__diff,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ C4 )
       => ( ( minus_minus @ ( set @ A ) @ B7 @ ( minus_minus @ ( set @ A ) @ C4 @ A5 ) )
          = A5 ) ) ) )).

% double_diff
thf(fact_213_subtr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Ns4: ( set @ n )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns4 )
       => ( gram_L716654942_subtr @ Ns4 @ Tr1 @ Tr2 ) ) ) )).

% subtr_mono
thf(fact_214_subtr2__mono,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Ns4: ( set @ n )] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns4 )
       => ( gram_L1283001940subtr2 @ Ns4 @ Tr1 @ Tr2 ) ) ) )).

% subtr2_mono
thf(fact_215_inFr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Ns4: ( set @ n )] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns4 )
       => ( gram_L1333338417e_inFr @ Ns4 @ Tr @ T2 ) ) ) )).

% inFr_mono
thf(fact_216_inFr2__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Ns4: ( set @ n )] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns4 )
       => ( gram_L805317441_inFr2 @ Ns4 @ Tr @ T2 ) ) ) )).

% inFr2_mono
thf(fact_217_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) ) ) ) )).

% Collect_mono_iff
thf(fact_218_contra__subsetD,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ~ ( member @ A @ C3 @ B7 )
       => ~ ( member @ A @ C3 @ A5 ) ) ) )).

% contra_subsetD
thf(fact_219_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y4: ( set @ A ),Z: ( set @ A )] : ( Y4 = Z ) )
      = ( ^ [A10: ( set @ A ),B9: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A10 @ B9 )
            & ( ord_less_eq @ ( set @ A ) @ B9 @ A10 ) ) ) ) )).

% set_eq_subset
thf(fact_220_subset__trans,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B7 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A5 @ C4 ) ) ) )).

% subset_trans
thf(fact_221_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( Q @ X5 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_222_subset__refl,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A5 @ A5 ) )).

% subset_refl
thf(fact_223_rev__subsetD,axiom,(
    ! [A: $tType,C3: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ C3 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% rev_subsetD
thf(fact_224_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A10: ( set @ A ),B9: ( set @ A )] :
          ! [T4: A] :
            ( ( member @ A @ T4 @ A10 )
           => ( member @ A @ T4 @ B9 ) ) ) ) )).

% subset_iff
thf(fact_225_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
       => ( member @ A @ X @ B7 ) ) ) )).

% set_rev_mp
thf(fact_226_equalityD2,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( A5 = B7 )
     => ( ord_less_eq @ ( set @ A ) @ B7 @ A5 ) ) )).

% equalityD2
thf(fact_227_equalityD1,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( A5 = B7 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) )).

% equalityD1
thf(fact_228_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A10: ( set @ A ),B9: ( set @ A )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A10 )
           => ( member @ A @ X4 @ B9 ) ) ) ) )).

% subset_eq
thf(fact_229_equalityE,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( A5 = B7 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B7 @ A5 ) ) ) )).

% equalityE
thf(fact_230_subsetCE,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( member @ A @ C3 @ A5 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% subsetCE
thf(fact_231_subsetD,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( member @ A @ C3 @ A5 )
       => ( member @ A @ C3 @ B7 ) ) ) )).

% subsetD
thf(fact_232_in__mono,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( member @ A @ X @ A5 )
       => ( member @ A @ X @ B7 ) ) ) )).

% in_mono
thf(fact_233_set__mp,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( member @ A @ X @ A5 )
       => ( member @ A @ X @ B7 ) ) ) )).

% set_mp
thf(fact_234_insert__mono,axiom,(
    ! [A: $tType,C4: ( set @ A ),D3: ( set @ A ),A4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ D3 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A4 @ C4 ) @ ( insert @ A @ A4 @ D3 ) ) ) )).

% insert_mono
thf(fact_235_subset__insert,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A ),B7: ( set @ A )] :
      ( ~ ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ X @ B7 ) )
        = ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) ) )).

% subset_insert
thf(fact_236_subset__insertI,axiom,(
    ! [A: $tType,B7: ( set @ A ),A4: A] :
      ( ord_less_eq @ ( set @ A ) @ B7 @ ( insert @ A @ A4 @ B7 ) ) )).

% subset_insertI
thf(fact_237_subset__insertI2,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ B2 @ B7 ) ) ) )).

% subset_insertI2
thf(fact_238_finite__subset,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
     => ( ( finite_finite2 @ A @ B7 )
       => ( finite_finite2 @ A @ A5 ) ) ) )).

% finite_subset
thf(fact_239_infinite__super,axiom,(
    ! [A: $tType,S2: ( set @ A ),T5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T5 )
     => ( ~ ( finite_finite2 @ A @ S2 )
       => ~ ( finite_finite2 @ A @ T5 ) ) ) )).

% infinite_super
thf(fact_240_rev__finite__subset,axiom,(
    ! [A: $tType,B7: ( set @ A ),A5: ( set @ A )] :
      ( ( finite_finite2 @ A @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B7 )
       => ( finite_finite2 @ A @ A5 ) ) ) )).

% rev_finite_subset
thf(fact_241_inItr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n,Ns4: ( set @ n )] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns4 )
       => ( gram_L830233218_inItr @ Ns4 @ Tr @ N ) ) ) )).

% inItr_mono
thf(fact_242_subset__Diff__insert,axiom,(
    ! [A: $tType,A5: ( set @ A ),B7: ( set @ A ),X: A,C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B7 @ ( insert @ A @ X @ C4 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( minus_minus @ ( set @ A ) @ B7 @ C4 ) )
        & ~ ( member @ A @ X @ A5 ) ) ) )).

% subset_Diff_insert
thf(fact_243_subset__singleton__iff,axiom,(
    ! [A: $tType,X9: ( set @ A ),A4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X9 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X9
          = ( bot_bot @ ( set @ A ) ) )
        | ( X9
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_244_subset__singletonD,axiom,(
    ! [A: $tType,A5: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        | ( A5
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_245_finite__subset__induct,axiom,(
    ! [A: $tType,F7: ( set @ A ),A5: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F7 )
     => ( ( ord_less_eq @ ( set @ A ) @ F7 @ A5 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A9: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( member @ A @ A9 @ A5 )
                 => ( ~ ( member @ A @ A9 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ A9 @ F6 ) ) ) ) ) )
           => ( P @ F7 ) ) ) ) ) )).

% finite_subset_induct
thf(fact_246_subset__insert__iff,axiom,(
    ! [A: $tType,A5: ( set @ A ),X: A,B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ X @ B7 ) )
      = ( ( ( member @ A @ X @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 ) )
        & ( ~ ( member @ A @ X @ A5 )
         => ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) ) ) )).

% subset_insert_iff
thf(fact_247_Diff__single__insert,axiom,(
    ! [A: $tType,A5: ( set @ A ),X: A,B7: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ ( insert @ A @ X @ B7 ) ) ) )).

% Diff_single_insert
thf(fact_248_insert__subsetI,axiom,(
    ! [A: $tType,X: A,A5: ( set @ A ),X9: ( set @ A )] :
      ( ( member @ A @ X @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ X9 @ A5 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X9 ) @ A5 ) ) ) )).

% insert_subsetI
thf(fact_249_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B2: A,D2: A,C3: A] :
          ( ( ord_less_eq @ A @ A4 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C3 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ C3 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) )).

% diff_mono
thf(fact_250_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A4: A,C3: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A4 @ C3 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A4 @ B2 ) @ C3 ) ) ) )).

% diff_right_commute
thf(fact_251_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B2: A,C3: A,D2: A] :
          ( ( ( minus_minus @ A @ A4 @ B2 )
            = ( minus_minus @ A @ C3 @ D2 ) )
         => ( ( A4 = B2 )
            = ( C3 = D2 ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_252_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B2: A,C3: A,D2: A] :
          ( ( ( minus_minus @ A @ A4 @ B2 )
            = ( minus_minus @ A @ C3 @ D2 ) )
         => ( ( ord_less_eq @ A @ A4 @ B2 )
            = ( ord_less_eq @ A @ C3 @ D2 ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_253_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B2: A,C3: A] :
          ( ( ord_less_eq @ A @ A4 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ C3 ) @ ( minus_minus @ A @ B2 @ C3 ) ) ) ) )).

% diff_right_mono
thf(fact_254_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A4: A,C3: A] :
          ( ( ord_less_eq @ A @ B2 @ A4 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C3 @ A4 ) @ ( minus_minus @ A @ C3 @ B2 ) ) ) ) )).

% diff_left_mono
thf(fact_255_psubset__insert__iff,axiom,(
    ! [A: $tType,A5: ( set @ A ),X: A,B7: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A5 @ ( insert @ A @ X @ B7 ) )
      = ( ( ( member @ A @ X @ B7 )
         => ( ord_less @ ( set @ A ) @ A5 @ B7 ) )
        & ( ~ ( member @ A @ X @ B7 )
         => ( ( ( member @ A @ X @ A5 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A5 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B7 ) )
            & ( ~ ( member @ A @ X @ A5 )
             => ( ord_less_eq @ ( set @ A ) @ A5 @ B7 ) ) ) ) ) ) )).

% psubset_insert_iff

%----Type constructors (7)
thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A7: $tType,A14: $tType] :
      ( ( ( finite_finite @ A7 @ ( type2 @ A7 ) )
        & ( finite_finite @ A14 @ ( type2 @ A14 ) ) )
     => ( finite_finite @ ( A7 > A14 ) @ ( type2 @ ( A7 > A14 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A7: $tType,A14: $tType] :
      ( ( minus @ A14 @ ( type2 @ A14 ) )
     => ( minus @ ( A7 > A14 ) @ ( type2 @ ( A7 > A14 ) ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_1,axiom,(
    ! [A7: $tType] :
      ( ( finite_finite @ A7 @ ( type2 @ A7 ) )
     => ( finite_finite @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_2,axiom,(
    ! [A7: $tType] :
      ( minus @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_3,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_4,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_5,axiom,(
    ! [A7: $tType,A14: $tType] :
      ( ( ( finite_finite @ A7 @ ( type2 @ A7 ) )
        & ( finite_finite @ A14 @ ( type2 @ A14 ) ) )
     => ( finite_finite @ ( sum_sum @ A7 @ A14 ) @ ( type2 @ ( sum_sum @ A7 @ A14 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (5)
thf(conj_0,hypothesis,
    ( member @ n @ ( root @ tr1 ) @ ns )).

thf(conj_1,hypothesis,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr1 ) @ ( cont @ tr2 ) )).

thf(conj_2,hypothesis,
    ( gram_L1283001940subtr2 @ ns @ tr2 @ tr3 )).

thf(conj_3,hypothesis,
    ( gram_L716654942_subtr @ ns @ tr2 @ tr3 )).

thf(conj_4,conjecture,
    ( gram_L716654942_subtr @ ns @ tr1 @ tr3 )).

%------------------------------------------------------------------------------
