%------------------------------------------------------------------------------
% File     : COM185^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 307
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__307.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  322 (   0 unit;  47 type;   0 defn)
%            Number of atoms       : 4760 ( 375 equality;2789 variable)
%            Maximal formula depth :   21 (  10 average)
%            Number of connectives : 4154 (  82   ~;  10   |;  96   &;3652   @)
%                                         (   0 <=>; 314  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  293 ( 293   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   51 (  47   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1282 (  19 sgn;1033   !;  71   ?; 131   ^)
%                                         (1282   :;  47  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:42:04.312
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (41)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_OSup,type,(
    complete_Sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Partial__Order_Occpo,type,(
    comple1141879883l_ccpo: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,(
    comple187826305attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,(
    condit378418413attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,(
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] :
        ( ( C > A ) > ( D > B ) > ( C > D > $o ) > A > B > $o ) )).

thf(sy_c_Basic__BNFs_Osetl,type,(
    basic_setl: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_Basic__BNFs_Osetr,type,(
    basic_setr: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,(
    complete_Sup_Sup: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OFr,type,(
    gram_L861583724lle_Fr: ( set @ n ) > dtree > ( set @ t ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OItr,type,(
    gram_L1580978439le_Itr: ( set @ n ) > dtree > ( set @ n ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr,type,(
    gram_L716654942_subtr: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr2,type,(
    gram_L1283001940subtr2: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_HOL_OThe,type,(
    the: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lifting_Orel__pred__comp,type,(
    rel_pred_comp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( B > $o ) > A > $o ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__set__sum,type,(
    sum_rec_set_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T > $o ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,(
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_ns,type,(
    ns: ( set @ n ) )).

thf(sy_v_tr,type,(
    tr: dtree )).

%----Relevant facts (256)
thf(fact_0_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_1_subtr_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L716654942_subtr @ Ns @ Tr @ Tr ) ) )).

% subtr.Refl
thf(fact_2_inItr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ? [Tr2: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr2 @ Tr )
          & ( ( root @ Tr2 )
            = N ) ) ) )).

% inItr_subtr
thf(fact_3_subtr__inItr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L830233218_inItr @ Ns @ Tr1 @ N ) ) ) )).

% subtr_inItr
thf(fact_4_subtr__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr3: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr3 )
       => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr_trans
thf(fact_5_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_6_subtr__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr_rootL_in
thf(fact_7_subtr__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr_rootR_in
thf(fact_8_Itr__def,axiom,
    ( gram_L1580978439le_Itr
    = ( ^ [Ns2: ( set @ n ),Tr4: dtree] :
          ( collect @ n @ ( gram_L830233218_inItr @ Ns2 @ Tr4 ) ) ) )).

% Itr_def
thf(fact_9_rel__pred__comp__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rel_pred_comp @ A @ B )
      = ( ^ [R: ( A > B > $o ),P: ( B > $o ),X: A] :
          ? [Y: B] :
            ( ( R @ X @ Y )
            & ( P @ Y ) ) ) ) )).

% rel_pred_comp_def
thf(fact_10_Itr__subtr,axiom,
    ( gram_L1580978439le_Itr
    = ( ^ [Ns2: ( set @ n ),Tr4: dtree] :
          ( complete_Sup_Sup @ ( set @ n )
          @ ( collect @ ( set @ n )
            @ ^ [Uu: ( set @ n )] :
              ? [Tr5: dtree] :
                ( ( Uu
                  = ( gram_L1580978439le_Itr @ Ns2 @ Tr5 ) )
                & ( gram_L716654942_subtr @ Ns2 @ Tr5 @ Tr4 ) ) ) ) ) )).

% Itr_subtr
thf(fact_11_inFr2__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr2_root_in
thf(fact_12_Fr__subtr,axiom,
    ( gram_L861583724lle_Fr
    = ( ^ [Ns2: ( set @ n ),Tr4: dtree] :
          ( complete_Sup_Sup @ ( set @ t )
          @ ( collect @ ( set @ t )
            @ ^ [Uu: ( set @ t )] :
              ? [Tr5: dtree] :
                ( ( Uu
                  = ( gram_L861583724lle_Fr @ Ns2 @ Tr5 ) )
                & ( gram_L716654942_subtr @ Ns2 @ Tr5 @ Tr4 ) ) ) ) ) )).

% Fr_subtr
thf(fact_13_subtr__inFr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Tr1: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 ) ) ) )).

% subtr_inFr
thf(fact_14_subtr__subtr2,axiom,(
    gram_L716654942_subtr = gram_L1283001940subtr2 )).

% subtr_subtr2
thf(fact_15_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_16_not__root__inFr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ~ ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) )).

% not_root_inFr
thf(fact_17_subtr2_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L1283001940subtr2 @ Ns @ Tr @ Tr ) ) )).

% subtr2.Refl
thf(fact_18_subtr2__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr2_rootL_in
thf(fact_19_subtr2__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr2_rootR_in
thf(fact_20_inFr__inFr2,axiom,(
    gram_L1333338417e_inFr = gram_L805317441_inFr2 )).

% inFr_inFr2
thf(fact_21_subtr2__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr3: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L1283001940subtr2 @ Ns @ Tr22 @ Tr3 )
       => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr2_trans
thf(fact_22_Fr__def,axiom,
    ( gram_L861583724lle_Fr
    = ( ^ [Ns2: ( set @ n ),Tr4: dtree] :
          ( collect @ t @ ( gram_L1333338417e_inFr @ Ns2 @ Tr4 ) ) ) )).

% Fr_def
thf(fact_23_UN__ball__bex__simps_I3_J,axiom,(
    ! [D: $tType,A2: ( set @ ( set @ D ) ),P2: ( D > $o )] :
      ( ( ? [X: D] :
            ( ( member @ D @ X @ ( complete_Sup_Sup @ ( set @ D ) @ A2 ) )
            & ( P2 @ X ) ) )
      = ( ? [X: ( set @ D )] :
            ( ( member @ ( set @ D ) @ X @ A2 )
            & ? [Y: D] :
                ( ( member @ D @ Y @ X )
                & ( P2 @ Y ) ) ) ) ) )).

% UN_ball_bex_simps(3)
thf(fact_24_UN__ball__bex__simps_I1_J,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) ),P2: ( A > $o )] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) )
           => ( P2 @ X ) ) )
      = ( ! [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ A2 )
           => ! [Y: A] :
                ( ( member @ A @ Y @ X )
               => ( P2 @ Y ) ) ) ) ) )).

% UN_ball_bex_simps(1)
thf(fact_25_UnionI,axiom,(
    ! [A: $tType,X2: ( set @ A ),C2: ( set @ ( set @ A ) ),A2: A] :
      ( ( member @ ( set @ A ) @ X2 @ C2 )
     => ( ( member @ A @ A2 @ X2 )
       => ( member @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ C2 ) ) ) ) )).

% UnionI
thf(fact_26_Union__iff,axiom,(
    ! [A: $tType,A2: A,C2: ( set @ ( set @ A ) )] :
      ( ( member @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ C2 ) )
      = ( ? [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ C2 )
            & ( member @ A @ A2 @ X ) ) ) ) )).

% Union_iff
thf(fact_27_Union__SetCompr__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( set @ A ) ),P2: ( B > $o )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [Uu: ( set @ A )] :
            ? [X: B] :
              ( ( Uu
                = ( F @ X ) )
              & ( P2 @ X ) ) ) )
      = ( collect @ A
        @ ^ [A3: A] :
          ? [X: B] :
            ( ( P2 @ X )
            & ( member @ A @ A3 @ ( F @ X ) ) ) ) ) )).

% Union_SetCompr_eq
thf(fact_28_UnionE,axiom,(
    ! [A: $tType,A2: A,C2: ( set @ ( set @ A ) )] :
      ( ( member @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ C2 ) )
     => ~ ( ! [X3: ( set @ A )] :
              ( ( member @ A @ A2 @ X3 )
             => ~ ( member @ ( set @ A ) @ X3 @ C2 ) ) ) ) )).

% UnionE
thf(fact_29_not__root__Fr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( gram_L861583724lle_Fr @ Ns @ Tr )
        = ( bot_bot @ ( set @ t ) ) ) ) )).

% not_root_Fr
thf(fact_30_Fr__subtr__cont,axiom,
    ( gram_L861583724lle_Fr
    = ( ^ [Ns2: ( set @ n ),Tr4: dtree] :
          ( complete_Sup_Sup @ ( set @ t )
          @ ( collect @ ( set @ t )
            @ ^ [Uu: ( set @ t )] :
              ? [Tr5: dtree] :
                ( ( Uu
                  = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr5 ) ) )
                & ( gram_L716654942_subtr @ Ns2 @ Tr5 @ Tr4 ) ) ) ) ) )).

% Fr_subtr_cont
thf(fact_31_image2p__def,axiom,(
    ! [D: $tType,B: $tType,A: $tType,C: $tType] :
      ( ( bNF_Greatest_image2p @ C @ A @ D @ B )
      = ( ^ [F2: ( C > A ),G: ( D > B ),R: ( C > D > $o ),X: A,Y: B] :
          ? [X4: C,Y2: D] :
            ( ( R @ X4 @ Y2 )
            & ( ( F2 @ X4 )
              = X )
            & ( ( G @ Y2 )
              = Y ) ) ) ) )).

% image2p_def
thf(fact_32_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_33_Sup__bot__conv_I1_J,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( ( complete_Sup_Sup @ A @ A2 )
            = ( bot_bot @ A ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A2 )
               => ( X
                  = ( bot_bot @ A ) ) ) ) ) ) )).

% Sup_bot_conv(1)
thf(fact_34_Sup__bot__conv_I2_J,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ A2 ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A2 )
               => ( X
                  = ( bot_bot @ A ) ) ) ) ) ) )).

% Sup_bot_conv(2)
thf(fact_35_Sup__empty,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) )).

% Sup_empty
thf(fact_36_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_37_Union__empty,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Union_empty
thf(fact_38_image2pI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R2: ( A > B > $o ),X5: A,Y3: B,F: ( A > C ),G2: ( B > D )] :
      ( ( R2 @ X5 @ Y3 )
     => ( bNF_Greatest_image2p @ A @ C @ B @ D @ F @ G2 @ R2 @ ( F @ X5 ) @ ( G2 @ Y3 ) ) ) )).

% image2pI
thf(fact_39_image2pE,axiom,(
    ! [D: $tType,B: $tType,A: $tType,C: $tType,F: ( A > B ),G2: ( C > D ),R2: ( A > C > $o ),Fx: B,Gy: D] :
      ( ( bNF_Greatest_image2p @ A @ B @ C @ D @ F @ G2 @ R2 @ Fx @ Gy )
     => ~ ( ! [X6: A] :
              ( ( Fx
                = ( F @ X6 ) )
             => ! [Y4: C] :
                  ( ( Gy
                    = ( G2 @ Y4 ) )
                 => ~ ( R2 @ X6 @ Y4 ) ) ) ) ) )).

% image2pE
thf(fact_40_empty__Union__conv,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ A2 ) )
      = ( ! [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ A2 )
           => ( X
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% empty_Union_conv
thf(fact_41_Union__empty__conv,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) )] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ A2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ A2 )
           => ( X
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% Union_empty_conv
thf(fact_42_dtree__cong,axiom,(
    ! [Tr: dtree,Tr6: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr6 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr6 ) )
       => ( Tr = Tr6 ) ) ) )).

% dtree_cong
thf(fact_43_inFr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) )).

% inFr.Base
thf(fact_44_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P2: ( A > $o )] :
      ( ( member @ A @ A4 @ ( collect @ A @ P2 ) )
      = ( P2 @ A4 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( P2 @ X6 )
          = ( Q @ X6 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G2: ( A > B )] :
      ( ! [X6: A] :
          ( ( F @ X6 )
          = ( G2 @ X6 ) )
     => ( F = G2 ) ) )).

% ext
thf(fact_49_inFr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ? [Tr2: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr2 @ Tr )
          & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr2 ) ) ) ) )).

% inFr_subtr
thf(fact_50_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_51_vimage__Collect__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),P2: ( B > $o )] :
      ( ( vimage @ A @ B @ F @ ( collect @ B @ P2 ) )
      = ( collect @ A
        @ ^ [Y: A] :
            ( P2 @ ( F @ Y ) ) ) ) )).

% vimage_Collect_eq
thf(fact_52_vimage__ident,axiom,(
    ! [A: $tType,Y5: ( set @ A )] :
      ( ( vimage @ A @ A
        @ ^ [X: A] : X
        @ Y5 )
      = Y5 ) )).

% vimage_ident
thf(fact_53_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A4: A,F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ A @ A4 @ ( vimage @ A @ B @ F @ B2 ) )
      = ( member @ B @ ( F @ A4 ) @ B2 ) ) )).

% vimage_eq
thf(fact_54_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A4: B,B3: A,B2: ( set @ A )] :
      ( ( ( F @ A4 )
        = B3 )
     => ( ( member @ A @ B3 @ B2 )
       => ( member @ B @ A4 @ ( vimage @ B @ A @ F @ B2 ) ) ) ) )).

% vimageI
thf(fact_55_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A4: A,A5: A] :
      ( ( ( sum_Inl @ A @ B @ A4 )
        = ( sum_Inl @ A @ B @ A5 ) )
      = ( A4 = A5 ) ) )).

% old.sum.inject(1)
thf(fact_56_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_57_empty__Collect__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P2 ) )
      = ( ! [X: A] :
            ~ ( P2 @ X ) ) ) )).

% empty_Collect_eq
thf(fact_58_Collect__empty__eq,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: A] :
            ~ ( P2 @ X ) ) ) )).

% Collect_empty_eq
thf(fact_59_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_60_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X: A] :
            ~ ( member @ A @ X @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_61_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_62_emptyE,axiom,(
    ! [A: $tType,A4: A] :
      ~ ( member @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_63_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A4: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A4 @ A2 ) ) )).

% equals0D
thf(fact_64_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y4: A] :
          ~ ( member @ A @ Y4 @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_65_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X: A] :
            ( member @ A @ X @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_66_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X5: A,Y3: A] :
      ( ( ( sum_Inl @ A @ B @ X5 )
        = ( sum_Inl @ A @ B @ Y3 ) )
     => ( X5 = Y3 ) ) )).

% Inl_inject
thf(fact_67_vimageD,axiom,(
    ! [A: $tType,B: $tType,A4: A,F: ( A > B ),A2: ( set @ B )] :
      ( ( member @ A @ A4 @ ( vimage @ A @ B @ F @ A2 ) )
     => ( member @ B @ ( F @ A4 ) @ A2 ) ) )).

% vimageD
thf(fact_68_vimageE,axiom,(
    ! [A: $tType,B: $tType,A4: A,F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ A @ A4 @ ( vimage @ A @ B @ F @ B2 ) )
     => ( member @ B @ ( F @ A4 ) @ B2 ) ) )).

% vimageE
thf(fact_69_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A4: B,A2: ( set @ A )] :
      ( ( member @ A @ ( F @ A4 ) @ A2 )
     => ( member @ B @ A4 @ ( vimage @ B @ A @ F @ A2 ) ) ) )).

% vimageI2
thf(fact_70_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( P2 @ ( F @ X6 ) )
          = ( Q @ X6 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P2 ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_71_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X: A] : $false ) ) )).

% empty_def
thf(fact_72_vimage__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F2: ( A > B ),B4: ( set @ B )] :
            ( collect @ A
            @ ^ [X: A] :
                ( member @ B @ ( F2 @ X ) @ B4 ) ) ) ) )).

% vimage_def
thf(fact_73_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_74_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A4: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A4 ) )
      = ( F1 @ A4 ) ) )).

% old.sum.simps(7)
thf(fact_75_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A6: ( set @ A )] :
            ( A6
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_76_inFr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L1333338417e_inFr @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L1333338417e_inFr @ A1 @ Tr12 @ A32 ) ) ) ) ) )).

% inFr.cases
thf(fact_77_inFr_Osimps,axiom,
    ( gram_L1333338417e_inFr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr4: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr4 ) ) )
          | ? [Tr4: dtree,Ns2: ( set @ n ),Tr13: dtree,T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr4 ) )
              & ( gram_L1333338417e_inFr @ Ns2 @ Tr13 @ T3 ) ) ) ) )).

% inFr.simps
thf(fact_78_inFr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: t,P2: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L1333338417e_inFr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr7 ) )
             => ( P2 @ Ns3 @ Tr7 @ T4 ) ) )
       => ( ! [Tr7: dtree,Ns3: ( set @ n ),Tr12: dtree,T4: t] :
              ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
               => ( ( gram_L1333338417e_inFr @ Ns3 @ Tr12 @ T4 )
                 => ( ( P2 @ Ns3 @ Tr12 @ T4 )
                   => ( P2 @ Ns3 @ Tr7 @ T4 ) ) ) ) )
         => ( P2 @ X1 @ X22 @ X32 ) ) ) ) )).

% inFr.inducts
thf(fact_79_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X5: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X5 ) )
      = ( F @ X5 ) ) )).

% Suml.simps
thf(fact_80_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X22: B,Y22: B] :
      ( ( ( sum_Inr @ B @ A @ X22 )
        = ( sum_Inr @ B @ A @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% sum.inject(2)
thf(fact_81_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B3: B,B5: B] :
      ( ( ( sum_Inr @ B @ A @ B3 )
        = ( sum_Inr @ B @ A @ B5 ) )
      = ( B3 = B5 ) ) )).

% old.sum.inject(2)
thf(fact_82_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B3: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B3 ) )
      = ( F22 @ B3 ) ) )).

% old.sum.simps(8)
thf(fact_83_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X5: B,Y3: B] :
      ( ( ( sum_Inr @ B @ A @ X5 )
        = ( sum_Inr @ B @ A @ Y3 ) )
     => ( X5 = Y3 ) ) )).

% Inr_inject
thf(fact_84_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X5: A,Y3: A] :
      ( ( X5 != Y3 )
     => ( ( sum_Inr @ A @ B @ X5 )
       != ( sum_Inr @ A @ B @ Y3 ) ) ) )).

% not_arg_cong_Inr
thf(fact_85_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G2: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G2 ) )
     => ( F = G2 ) ) )).

% Suml_inject
thf(fact_86_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X6: A] :
          ( S
         != ( sum_Inl @ A @ B @ X6 ) )
     => ~ ( ! [X6: B] :
              ( S
             != ( sum_Inr @ B @ A @ X6 ) ) ) ) )).

% obj_sumE
thf(fact_87_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X22 ) ) )).

% sum.distinct(1)
thf(fact_88_old_Osum_Odistinct_I2_J,axiom,(
    ! [B6: $tType,A7: $tType,B7: B6,A8: A7] :
      ( ( sum_Inr @ B6 @ A7 @ B7 )
     != ( sum_Inl @ A7 @ B6 @ A8 ) ) )).

% old.sum.distinct(2)
thf(fact_89_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A4: A,B5: B] :
      ( ( sum_Inl @ A @ B @ A4 )
     != ( sum_Inr @ B @ A @ B5 ) ) )).

% old.sum.distinct(1)
thf(fact_90_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X6: A] :
          ( S
         != ( sum_Inl @ A @ B @ X6 ) )
     => ~ ( ! [Y4: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y4 ) ) ) ) )).

% sumE
thf(fact_91_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B3: B,A4: A] :
      ( ( sum_Inr @ B @ A @ B3 )
     != ( sum_Inl @ A @ B @ A4 ) ) )).

% Inr_not_Inl
thf(fact_92_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X7: ( sum_sum @ A @ B )] :
            ( P3 @ X7 ) )
      = ( ^ [P: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X: A] :
                ( P @ ( sum_Inl @ A @ B @ X ) )
            | ? [X: B] :
                ( P @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_ex
thf(fact_93_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X7: ( sum_sum @ A @ B )] :
            ( P3 @ X7 ) )
      = ( ^ [P: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X: A] :
                ( P @ ( sum_Inl @ A @ B @ X ) )
            & ! [X: B] :
                ( P @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_all
thf(fact_94_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y3: ( sum_sum @ A @ B )] :
      ( ! [A9: A] :
          ( Y3
         != ( sum_Inl @ A @ B @ A9 ) )
     => ~ ( ! [B8: B] :
              ( Y3
             != ( sum_Inr @ B @ A @ B8 ) ) ) ) )).

% old.sum.exhaust
thf(fact_95_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A9: A] :
          ( P2 @ ( sum_Inl @ A @ B @ A9 ) )
     => ( ! [B8: B] :
            ( P2 @ ( sum_Inr @ B @ A @ B8 ) )
       => ( P2 @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_96_subtr_OStep,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr3 ) )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr.Step
thf(fact_97_subtr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L716654942_subtr @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A32 ) @ A1 )
           => ! [Tr23: dtree] :
                ( ( gram_L716654942_subtr @ A1 @ A22 @ Tr23 )
               => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ A32 ) ) ) ) ) ) )).

% subtr.cases
thf(fact_98_subtr_Osimps,axiom,
    ( gram_L716654942_subtr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr4: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33 = Tr4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 ) )
          | ? [Tr32: dtree,Ns2: ( set @ n ),Tr13: dtree,Tr24: dtree] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr13 )
              & ( A33 = Tr32 )
              & ( member @ n @ ( root @ Tr32 ) @ Ns2 )
              & ( gram_L716654942_subtr @ Ns2 @ Tr13 @ Tr24 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr24 ) @ ( cont @ Tr32 ) ) ) ) ) )).

% subtr.simps
thf(fact_99_subtr__StepL,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr22: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr22 ) )
       => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr3 )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr_StepL
thf(fact_100_subtr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P2: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( P2 @ Ns3 @ Tr7 @ Tr7 ) )
       => ( ! [Tr33: dtree,Ns3: ( set @ n ),Tr12: dtree,Tr23: dtree] :
              ( ( member @ n @ ( root @ Tr33 ) @ Ns3 )
             => ( ( gram_L716654942_subtr @ Ns3 @ Tr12 @ Tr23 )
               => ( ( P2 @ Ns3 @ Tr12 @ Tr23 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ Tr33 ) )
                   => ( P2 @ Ns3 @ Tr12 @ Tr33 ) ) ) ) )
         => ( P2 @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr.inducts
thf(fact_101_subtr__inductL,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Phi: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ! [Ns3: ( set @ n ),Tr7: dtree] :
            ( Phi @ Ns3 @ Tr7 @ Tr7 )
       => ( ! [Ns3: ( set @ n ),Tr12: dtree,Tr23: dtree,Tr33: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
               => ( ( gram_L716654942_subtr @ Ns3 @ Tr23 @ Tr33 )
                 => ( ( Phi @ Ns3 @ Tr23 @ Tr33 )
                   => ( Phi @ Ns3 @ Tr12 @ Tr33 ) ) ) ) )
         => ( Phi @ Ns @ Tr1 @ Tr22 ) ) ) ) )).

% subtr_inductL
thf(fact_102_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_103_subtr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P2: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L1283001940subtr2 @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( P2 @ Ns3 @ Tr7 @ Tr7 ) )
       => ( ! [Tr12: dtree,Ns3: ( set @ n ),Tr23: dtree,Tr33: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
               => ( ( gram_L1283001940subtr2 @ Ns3 @ Tr23 @ Tr33 )
                 => ( ( P2 @ Ns3 @ Tr23 @ Tr33 )
                   => ( P2 @ Ns3 @ Tr12 @ Tr33 ) ) ) ) )
         => ( P2 @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr2.inducts
thf(fact_104_subtr2__StepR,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr22: dtree,Tr1: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr3 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr2_StepR
thf(fact_105_subtr2_Osimps,axiom,
    ( gram_L1283001940subtr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr4: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33 = Tr4 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 ) )
          | ? [Tr13: dtree,Ns2: ( set @ n ),Tr24: dtree,Tr32: dtree] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr13 )
              & ( A33 = Tr32 )
              & ( member @ n @ ( root @ Tr13 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr24 ) )
              & ( gram_L1283001940subtr2 @ Ns2 @ Tr24 @ Tr32 ) ) ) ) )).

% subtr2.simps
thf(fact_106_subtr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L1283001940subtr2 @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr23: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ A22 ) @ ( cont @ Tr23 ) )
               => ~ ( gram_L1283001940subtr2 @ A1 @ Tr23 @ A32 ) ) ) ) ) )).

% subtr2.cases
thf(fact_107_subtr2_OStep,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr22: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr22 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr22 @ Tr3 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr2.Step
thf(fact_108_inFr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 )
         => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr.Ind
thf(fact_109_inItr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,N: n] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L830233218_inItr @ Ns @ Tr1 @ N )
         => ( gram_L830233218_inItr @ Ns @ Tr @ N ) ) ) ) )).

% inItr.Ind
thf(fact_110_inItr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: n] :
      ( ( gram_L830233218_inItr @ A1 @ A22 @ A32 )
     => ( ( ( A32
            = ( root @ A22 ) )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L830233218_inItr @ A1 @ Tr12 @ A32 ) ) ) ) ) )).

% inItr.cases
thf(fact_111_inItr_Osimps,axiom,
    ( gram_L830233218_inItr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: n] :
          ( ? [Tr4: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33
                = ( root @ Tr4 ) )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 ) )
          | ? [Tr4: dtree,Ns2: ( set @ n ),Tr13: dtree,N2: n] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33 = N2 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr4 ) )
              & ( gram_L830233218_inItr @ Ns2 @ Tr13 @ N2 ) ) ) ) )).

% inItr.simps
thf(fact_112_inItr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: n,P2: ( ( set @ n ) > dtree > n > $o )] :
      ( ( gram_L830233218_inItr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( P2 @ Ns3 @ Tr7 @ ( root @ Tr7 ) ) )
       => ( ! [Tr7: dtree,Ns3: ( set @ n ),Tr12: dtree,N3: n] :
              ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
               => ( ( gram_L830233218_inItr @ Ns3 @ Tr12 @ N3 )
                 => ( ( P2 @ Ns3 @ Tr12 @ N3 )
                   => ( P2 @ Ns3 @ Tr7 @ N3 ) ) ) ) )
         => ( P2 @ X1 @ X22 @ X32 ) ) ) ) )).

% inItr.inducts
thf(fact_113_inFr2__Ind,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr1 @ T2 )
     => ( ( member @ n @ ( root @ Tr ) @ Ns )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
         => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr2_Ind
thf(fact_114_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X5: A,Y3: B] :
      ( ( sum_Inl @ A @ B @ X5 )
     != ( sum_Inr @ B @ A @ Y3 ) ) )).

% Inl_Inr_False
thf(fact_115_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X5: B,Y3: A] :
      ( ( sum_Inr @ B @ A @ X5 )
     != ( sum_Inl @ A @ B @ Y3 ) ) )).

% Inr_Inl_False
thf(fact_116_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ ( sum_sum @ A @ B ) ),B2: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A2 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B2 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A2 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B2 ) )
       => ( A2 = B2 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_117_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_118_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ( ( collect @ A @ P2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P2
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_119_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P2: $o] :
      ( ! [X6: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X6 ) ) )
         => P2 )
     => ( ! [X6: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X6 ) ) )
           => P2 )
       => ! [X8: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X8 ) )
           => P2 ) ) ) )).

% obj_sumE_f
thf(fact_120_inFr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: t,P2: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L805317441_inFr2 @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr7 ) )
             => ( P2 @ Ns3 @ Tr7 @ T4 ) ) )
       => ( ! [Tr12: dtree,Tr7: dtree,Ns1: ( set @ n ),T4: t] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
             => ( ( gram_L805317441_inFr2 @ Ns1 @ Tr12 @ T4 )
               => ( ( P2 @ Ns1 @ Tr12 @ T4 )
                 => ( P2 @ ( insert @ n @ ( root @ Tr7 ) @ Ns1 ) @ Tr7 @ T4 ) ) ) )
         => ( P2 @ X1 @ X22 @ X32 ) ) ) ) )).

% inFr2.inducts
thf(fact_121_inFr2_Osimps,axiom,
    ( gram_L805317441_inFr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr4: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr4 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr4 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr4 ) ) )
          | ? [Tr13: dtree,Tr4: dtree,Ns12: ( set @ n ),T3: t] :
              ( ( A12
                = ( insert @ n @ ( root @ Tr4 ) @ Ns12 ) )
              & ( A23 = Tr4 )
              & ( A33 = T3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr4 ) )
              & ( gram_L805317441_inFr2 @ Ns12 @ Tr13 @ T3 ) ) ) ) )).

% inFr2.simps
thf(fact_122_inFr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L805317441_inFr2 @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ! [Tr12: dtree,Tr7: dtree,Ns1: ( set @ n )] :
                ( ( A1
                  = ( insert @ n @ ( root @ Tr7 ) @ Ns1 ) )
               => ( ( A22 = Tr7 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
                   => ~ ( gram_L805317441_inFr2 @ Ns1 @ Tr12 @ A32 ) ) ) ) ) ) ) )).

% inFr2.cases
thf(fact_123_inFr2_OInd,axiom,(
    ! [Tr1: dtree,Tr: dtree,Ns13: ( set @ n ),T2: t] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
     => ( ( gram_L805317441_inFr2 @ Ns13 @ Tr1 @ T2 )
       => ( gram_L805317441_inFr2 @ ( insert @ n @ ( root @ Tr ) @ Ns13 ) @ Tr @ T2 ) ) ) )).

% inFr2.Ind
thf(fact_124_insertCI,axiom,(
    ! [A: $tType,A4: A,B2: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A4 @ B2 )
       => ( A4 = B3 ) )
     => ( member @ A @ A4 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertCI
thf(fact_125_insert__iff,axiom,(
    ! [A: $tType,A4: A,B3: A,A2: ( set @ A )] :
      ( ( member @ A @ A4 @ ( insert @ A @ B3 @ A2 ) )
      = ( ( A4 = B3 )
        | ( member @ A @ A4 @ A2 ) ) ) )).

% insert_iff
thf(fact_126_insert__absorb2,axiom,(
    ! [A: $tType,X5: A,A2: ( set @ A )] :
      ( ( insert @ A @ X5 @ ( insert @ A @ X5 @ A2 ) )
      = ( insert @ A @ X5 @ A2 ) ) )).

% insert_absorb2
thf(fact_127_singletonI,axiom,(
    ! [A: $tType,A4: A] :
      ( member @ A @ A4 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_128_singleton__conv2,axiom,(
    ! [A: $tType,A4: A] :
      ( ( collect @ A
        @ ( ^ [Y6: A,Z: A] : ( Y6 = Z )
          @ A4 ) )
      = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv2
thf(fact_129_singleton__conv,axiom,(
    ! [A: $tType,A4: A] :
      ( ( collect @ A
        @ ^ [X: A] : ( X = A4 ) )
      = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv
thf(fact_130_singleton__inject,axiom,(
    ! [A: $tType,A4: A,B3: A] :
      ( ( ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A4 = B3 ) ) )).

% singleton_inject
thf(fact_131_insert__not__empty,axiom,(
    ! [A: $tType,A4: A,A2: ( set @ A )] :
      ( ( insert @ A @ A4 @ A2 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_132_doubleton__eq__iff,axiom,(
    ! [A: $tType,A4: A,B3: A,C3: A,D2: A] :
      ( ( ( insert @ A @ A4 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C3 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A4 = C3 )
          & ( B3 = D2 ) )
        | ( ( A4 = D2 )
          & ( B3 = C3 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_133_singleton__iff,axiom,(
    ! [A: $tType,B3: A,A4: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A4 ) ) )).

% singleton_iff
thf(fact_134_singletonD,axiom,(
    ! [A: $tType,B3: A,A4: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A4 ) ) )).

% singletonD
thf(fact_135_insertE,axiom,(
    ! [A: $tType,A4: A,B3: A,A2: ( set @ A )] :
      ( ( member @ A @ A4 @ ( insert @ A @ B3 @ A2 ) )
     => ( ( A4 != B3 )
       => ( member @ A @ A4 @ A2 ) ) ) )).

% insertE
thf(fact_136_insertI1,axiom,(
    ! [A: $tType,A4: A,B2: ( set @ A )] :
      ( member @ A @ A4 @ ( insert @ A @ A4 @ B2 ) ) )).

% insertI1
thf(fact_137_insertI2,axiom,(
    ! [A: $tType,A4: A,B2: ( set @ A ),B3: A] :
      ( ( member @ A @ A4 @ B2 )
     => ( member @ A @ A4 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertI2
thf(fact_138_Set_Oset__insert,axiom,(
    ! [A: $tType,X5: A,A2: ( set @ A )] :
      ( ( member @ A @ X5 @ A2 )
     => ~ ( ! [B9: ( set @ A )] :
              ( ( A2
                = ( insert @ A @ X5 @ B9 ) )
             => ( member @ A @ X5 @ B9 ) ) ) ) )).

% Set.set_insert
thf(fact_139_insert__compr,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A3: A,B4: ( set @ A )] :
            ( collect @ A
            @ ^ [X: A] :
                ( ( X = A3 )
                | ( member @ A @ X @ B4 ) ) ) ) ) )).

% insert_compr
thf(fact_140_insert__ident,axiom,(
    ! [A: $tType,X5: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X5 @ A2 )
     => ( ~ ( member @ A @ X5 @ B2 )
       => ( ( ( insert @ A @ X5 @ A2 )
            = ( insert @ A @ X5 @ B2 ) )
          = ( A2 = B2 ) ) ) ) )).

% insert_ident
thf(fact_141_insert__absorb,axiom,(
    ! [A: $tType,A4: A,A2: ( set @ A )] :
      ( ( member @ A @ A4 @ A2 )
     => ( ( insert @ A @ A4 @ A2 )
        = A2 ) ) )).

% insert_absorb
thf(fact_142_insert__eq__iff,axiom,(
    ! [A: $tType,A4: A,A2: ( set @ A ),B3: A,B2: ( set @ A )] :
      ( ~ ( member @ A @ A4 @ A2 )
     => ( ~ ( member @ A @ B3 @ B2 )
       => ( ( ( insert @ A @ A4 @ A2 )
            = ( insert @ A @ B3 @ B2 ) )
          = ( ( ( A4 = B3 )
             => ( A2 = B2 ) )
            & ( ( A4 != B3 )
             => ? [C4: ( set @ A )] :
                  ( ( A2
                    = ( insert @ A @ B3 @ C4 ) )
                  & ~ ( member @ A @ B3 @ C4 )
                  & ( B2
                    = ( insert @ A @ A4 @ C4 ) )
                  & ~ ( member @ A @ A4 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_143_insert__Collect,axiom,(
    ! [A: $tType,A4: A,P2: ( A > $o )] :
      ( ( insert @ A @ A4 @ ( collect @ A @ P2 ) )
      = ( collect @ A
        @ ^ [U: A] :
            ( ( U != A4 )
           => ( P2 @ U ) ) ) ) )).

% insert_Collect
thf(fact_144_insert__commute,axiom,(
    ! [A: $tType,X5: A,Y3: A,A2: ( set @ A )] :
      ( ( insert @ A @ X5 @ ( insert @ A @ Y3 @ A2 ) )
      = ( insert @ A @ Y3 @ ( insert @ A @ X5 @ A2 ) ) ) )).

% insert_commute
thf(fact_145_mk__disjoint__insert,axiom,(
    ! [A: $tType,A4: A,A2: ( set @ A )] :
      ( ( member @ A @ A4 @ A2 )
     => ? [B9: ( set @ A )] :
          ( ( A2
            = ( insert @ A @ A4 @ B9 ) )
          & ~ ( member @ A @ A4 @ B9 ) ) ) )).

% mk_disjoint_insert
thf(fact_146_Collect__conv__if2,axiom,(
    ! [A: $tType,P2: ( A > $o ),A4: A] :
      ( ( ( P2 @ A4 )
       => ( ( collect @ A
            @ ^ [X: A] :
                ( ( A4 = X )
                & ( P2 @ X ) ) )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P2 @ A4 )
       => ( ( collect @ A
            @ ^ [X: A] :
                ( ( A4 = X )
                & ( P2 @ X ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if2
thf(fact_147_Collect__conv__if,axiom,(
    ! [A: $tType,P2: ( A > $o ),A4: A] :
      ( ( ( P2 @ A4 )
       => ( ( collect @ A
            @ ^ [X: A] :
                ( ( X = A4 )
                & ( P2 @ X ) ) )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P2 @ A4 )
       => ( ( collect @ A
            @ ^ [X: A] :
                ( ( X = A4 )
                & ( P2 @ X ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if
thf(fact_148_vimage__singleton__eq,axiom,(
    ! [A: $tType,B: $tType,A4: A,F: ( A > B ),B3: B] :
      ( ( member @ A @ A4 @ ( vimage @ A @ B @ F @ ( insert @ B @ B3 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( ( F @ A4 )
        = B3 ) ) )).

% vimage_singleton_eq
thf(fact_149_inFr__Ind__minus,axiom,(
    ! [Ns13: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns13 @ Tr1 @ T2 )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ ( insert @ n @ ( root @ Tr ) @ Ns13 ) @ Tr @ T2 ) ) ) )).

% inFr_Ind_minus
thf(fact_150_ccpo__Sup__singleton,axiom,(
    ! [A: $tType] :
      ( ( comple1141879883l_ccpo @ A @ ( type2 @ A ) )
     => ! [X5: A] :
          ( ( complete_Sup_Sup @ A @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) )
          = X5 ) ) )).

% ccpo_Sup_singleton
thf(fact_151_cSup__singleton,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [X5: A] :
          ( ( complete_Sup_Sup @ A @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) )
          = X5 ) ) )).

% cSup_singleton
thf(fact_152_is__singletonI,axiom,(
    ! [A: $tType,X5: A] :
      ( is_singleton @ A @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_153_the__elem__eq,axiom,(
    ! [A: $tType,X5: A] :
      ( ( the_elem @ A @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) )
      = X5 ) )).

% the_elem_eq
thf(fact_154_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A6: ( set @ A )] :
            ( A6
            = ( insert @ A @ ( the_elem @ A @ A6 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_155_is__singletonI_H,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( A2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X6: A,Y4: A] :
            ( ( member @ A @ X6 @ A2 )
           => ( ( member @ A @ Y4 @ A2 )
             => ( X6 = Y4 ) ) )
       => ( is_singleton @ A @ A2 ) ) ) )).

% is_singletonI'
thf(fact_156_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A6: ( set @ A )] :
          ? [X: A] :
            ( A6
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_157_is__singletonE,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( is_singleton @ A @ A2 )
     => ~ ( ! [X6: A] :
              ( A2
             != ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_158_sum__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X5: A] :
      ( ( basic_setl @ A @ B @ ( sum_Inl @ A @ B @ X5 ) )
      = ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(1)
thf(fact_159_sum__set__simps_I4_J,axiom,(
    ! [E: $tType,A: $tType,X5: A] :
      ( ( basic_setr @ E @ A @ ( sum_Inr @ A @ E @ X5 ) )
      = ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(4)
thf(fact_160_the__elem__def,axiom,(
    ! [A: $tType] :
      ( ( the_elem @ A )
      = ( ^ [X9: ( set @ A )] :
            ( the @ A
            @ ^ [X: A] :
                ( X9
                = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% the_elem_def
thf(fact_161_sum__set__simps_I2_J,axiom,(
    ! [A: $tType,C: $tType,X5: A] :
      ( ( basic_setl @ C @ A @ ( sum_Inr @ A @ C @ X5 ) )
      = ( bot_bot @ ( set @ C ) ) ) )).

% sum_set_simps(2)
thf(fact_162_sum__set__simps_I3_J,axiom,(
    ! [A: $tType,D: $tType,X5: A] :
      ( ( basic_setr @ A @ D @ ( sum_Inl @ A @ D @ X5 ) )
      = ( bot_bot @ ( set @ D ) ) ) )).

% sum_set_simps(3)
thf(fact_163_old_Orec__sum__def,axiom,(
    ! [B: $tType,T: $tType,A: $tType] :
      ( ( sum_rec_sum @ A @ T @ B )
      = ( ^ [F12: ( A > T ),F23: ( B > T ),X: ( sum_sum @ A @ B )] :
            ( the @ T @ ( sum_rec_set_sum @ A @ T @ B @ F12 @ F23 @ X ) ) ) ) )).

% old.rec_sum_def
thf(fact_164_the__sym__eq__trivial,axiom,(
    ! [A: $tType,X5: A] :
      ( ( the @ A
        @ ( ^ [Y6: A,Z: A] : ( Y6 = Z )
          @ X5 ) )
      = X5 ) )).

% the_sym_eq_trivial
thf(fact_165_the__eq__trivial,axiom,(
    ! [A: $tType,A4: A] :
      ( ( the @ A
        @ ^ [X: A] : ( X = A4 ) )
      = A4 ) )).

% the_eq_trivial
thf(fact_166_the__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A4: A] :
      ( ( P2 @ A4 )
     => ( ! [X6: A] :
            ( ( P2 @ X6 )
           => ( X6 = A4 ) )
       => ( ( the @ A @ P2 )
          = A4 ) ) ) )).

% the_equality
thf(fact_167_theI,axiom,(
    ! [A: $tType,P2: ( A > $o ),A4: A] :
      ( ( P2 @ A4 )
     => ( ! [X6: A] :
            ( ( P2 @ X6 )
           => ( X6 = A4 ) )
       => ( P2 @ ( the @ A @ P2 ) ) ) ) )).

% theI
thf(fact_168_theI_H,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ? [X8: A] :
          ( ( P2 @ X8 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X8 ) ) )
     => ( P2 @ ( the @ A @ P2 ) ) ) )).

% theI'
thf(fact_169_theI2,axiom,(
    ! [A: $tType,P2: ( A > $o ),A4: A,Q: ( A > $o )] :
      ( ( P2 @ A4 )
     => ( ! [X6: A] :
            ( ( P2 @ X6 )
           => ( X6 = A4 ) )
       => ( ! [X6: A] :
              ( ( P2 @ X6 )
             => ( Q @ X6 ) )
         => ( Q @ ( the @ A @ P2 ) ) ) ) ) )).

% theI2
thf(fact_170_If__def,axiom,(
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P: $o,X: A,Y: A] :
            ( the @ A
            @ ^ [Z2: A] :
                ( ( P
                 => ( Z2 = X ) )
                & ( ~ ( P )
                 => ( Z2 = Y ) ) ) ) ) ) )).

% If_def
thf(fact_171_the1I2,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ? [X8: A] :
          ( ( P2 @ X8 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X8 ) ) )
     => ( ! [X6: A] :
            ( ( P2 @ X6 )
           => ( Q @ X6 ) )
       => ( Q @ ( the @ A @ P2 ) ) ) ) )).

% the1I2
thf(fact_172_the1__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A4: A] :
      ( ? [X8: A] :
          ( ( P2 @ X8 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X8 ) ) )
     => ( ( P2 @ A4 )
       => ( ( the @ A @ P2 )
          = A4 ) ) ) )).

% the1_equality
thf(fact_173_setl_Oinducts,axiom,(
    ! [B: $tType,A: $tType,X5: A,S: ( sum_sum @ A @ B ),P2: ( A > $o )] :
      ( ( member @ A @ X5 @ ( basic_setl @ A @ B @ S ) )
     => ( ! [X6: A] :
            ( ( S
              = ( sum_Inl @ A @ B @ X6 ) )
           => ( P2 @ X6 ) )
       => ( P2 @ X5 ) ) ) )).

% setl.inducts
thf(fact_174_setl_Ointros,axiom,(
    ! [B: $tType,A: $tType,S: ( sum_sum @ A @ B ),X5: A] :
      ( ( S
        = ( sum_Inl @ A @ B @ X5 ) )
     => ( member @ A @ X5 @ ( basic_setl @ A @ B @ S ) ) ) )).

% setl.intros
thf(fact_175_setl_Osimps,axiom,(
    ! [B: $tType,A: $tType,A4: A,S: ( sum_sum @ A @ B )] :
      ( ( member @ A @ A4 @ ( basic_setl @ A @ B @ S ) )
      = ( ? [X: A] :
            ( ( A4 = X )
            & ( S
              = ( sum_Inl @ A @ B @ X ) ) ) ) ) )).

% setl.simps
thf(fact_176_setr_Oinducts,axiom,(
    ! [A: $tType,B: $tType,X5: B,S: ( sum_sum @ A @ B ),P2: ( B > $o )] :
      ( ( member @ B @ X5 @ ( basic_setr @ A @ B @ S ) )
     => ( ! [X6: B] :
            ( ( S
              = ( sum_Inr @ B @ A @ X6 ) )
           => ( P2 @ X6 ) )
       => ( P2 @ X5 ) ) ) )).

% setr.inducts
thf(fact_177_setr_Ointros,axiom,(
    ! [B: $tType,A: $tType,S: ( sum_sum @ A @ B ),X5: B] :
      ( ( S
        = ( sum_Inr @ B @ A @ X5 ) )
     => ( member @ B @ X5 @ ( basic_setr @ A @ B @ S ) ) ) )).

% setr.intros
thf(fact_178_setr_Osimps,axiom,(
    ! [A: $tType,B: $tType,A4: B,S: ( sum_sum @ A @ B )] :
      ( ( member @ B @ A4 @ ( basic_setr @ A @ B @ S ) )
      = ( ? [X: B] :
            ( ( A4 = X )
            & ( S
              = ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% setr.simps
thf(fact_179_setr_Ocases,axiom,(
    ! [A: $tType,B: $tType,A4: B,S: ( sum_sum @ A @ B )] :
      ( ( member @ B @ A4 @ ( basic_setr @ A @ B @ S ) )
     => ( S
        = ( sum_Inr @ B @ A @ A4 ) ) ) )).

% setr.cases
thf(fact_180_setl_Ocases,axiom,(
    ! [B: $tType,A: $tType,A4: A,S: ( sum_sum @ A @ B )] :
      ( ( member @ A @ A4 @ ( basic_setl @ A @ B @ S ) )
     => ( S
        = ( sum_Inl @ A @ B @ A4 ) ) ) )).

% setl.cases
thf(fact_181_vimage__eq__UN,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F2: ( A > B ),B4: ( set @ B )] :
            ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] :
                  ( vimage @ A @ B @ F2 @ ( insert @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) )
              @ B4 ) ) ) ) )).

% vimage_eq_UN
thf(fact_182_sum__set__defs_I2_J,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( basic_setr @ C @ D )
      = ( sum_case_sum @ C @ ( set @ D ) @ D
        @ ^ [A3: C] :
            ( bot_bot @ ( set @ D ) )
        @ ^ [Z2: D] :
            ( insert @ D @ Z2 @ ( bot_bot @ ( set @ D ) ) ) ) ) )).

% sum_set_defs(2)
thf(fact_183_sum__set__defs_I1_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( basic_setl @ A @ B )
      = ( sum_case_sum @ A @ ( set @ A ) @ B
        @ ^ [Z2: A] :
            ( insert @ A @ Z2 @ ( bot_bot @ ( set @ A ) ) )
        @ ^ [B10: B] :
            ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_defs(1)
thf(fact_184_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),X5: B,A2: ( set @ B )] :
      ( ( B3
        = ( F @ X5 ) )
     => ( ( member @ B @ X5 @ A2 )
       => ( member @ A @ B3 @ ( image @ B @ A @ F @ A2 ) ) ) ) )).

% image_eqI
thf(fact_185_image__ident,axiom,(
    ! [A: $tType,Y5: ( set @ A )] :
      ( ( image @ A @ A
        @ ^ [X: A] : X
        @ Y5 )
      = Y5 ) )).

% image_ident
thf(fact_186_case__sum__KK,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A4: C] :
      ( ( sum_case_sum @ A @ C @ B
        @ ^ [X: A] : A4
        @ ^ [X: B] : A4 )
      = ( ^ [X: ( sum_sum @ A @ B )] : A4 ) ) )).

% case_sum_KK
thf(fact_187_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_188_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_189_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_190_insert__image,axiom,(
    ! [B: $tType,A: $tType,X5: A,A2: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X5 @ A2 )
     => ( ( insert @ B @ ( F @ X5 ) @ ( image @ A @ B @ F @ A2 ) )
        = ( image @ A @ B @ F @ A2 ) ) ) )).

% insert_image
thf(fact_191_image__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: B,B2: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( insert @ B @ A4 @ B2 ) )
      = ( insert @ A @ ( F @ A4 ) @ ( image @ B @ A @ F @ B2 ) ) ) )).

% image_insert
thf(fact_192_ball__UN,axiom,(
    ! [A: $tType,B: $tType,B2: ( B > ( set @ A ) ),A2: ( set @ B ),P2: ( A > $o )] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
           => ( P2 @ X ) ) )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ! [Y: A] :
                ( ( member @ A @ Y @ ( B2 @ X ) )
               => ( P2 @ Y ) ) ) ) ) )).

% ball_UN
thf(fact_193_bex__UN,axiom,(
    ! [A: $tType,B: $tType,B2: ( B > ( set @ A ) ),A2: ( set @ B ),P2: ( A > $o )] :
      ( ( ? [X: A] :
            ( ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
            & ( P2 @ X ) ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A2 )
            & ? [Y: A] :
                ( ( member @ A @ Y @ ( B2 @ X ) )
                & ( P2 @ Y ) ) ) ) ) )).

% bex_UN
thf(fact_194_UN__ball__bex__simps_I2_J,axiom,(
    ! [C: $tType,B: $tType,B2: ( B > ( set @ C ) ),A2: ( set @ B ),P2: ( C > $o )] :
      ( ( ! [X: C] :
            ( ( member @ C @ X @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ B @ ( set @ C ) @ B2 @ A2 ) ) )
           => ( P2 @ X ) ) )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ! [Y: C] :
                ( ( member @ C @ Y @ ( B2 @ X ) )
               => ( P2 @ Y ) ) ) ) ) )).

% UN_ball_bex_simps(2)
thf(fact_195_UN__ball__bex__simps_I4_J,axiom,(
    ! [F3: $tType,E: $tType,B2: ( E > ( set @ F3 ) ),A2: ( set @ E ),P2: ( F3 > $o )] :
      ( ( ? [X: F3] :
            ( ( member @ F3 @ X @ ( complete_Sup_Sup @ ( set @ F3 ) @ ( image @ E @ ( set @ F3 ) @ B2 @ A2 ) ) )
            & ( P2 @ X ) ) )
      = ( ? [X: E] :
            ( ( member @ E @ X @ A2 )
            & ? [Y: F3] :
                ( ( member @ F3 @ Y @ ( B2 @ X ) )
                & ( P2 @ Y ) ) ) ) ) )).

% UN_ball_bex_simps(4)
thf(fact_196_SUP__identity__eq,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ A @ A
              @ ^ [X: A] : X
              @ A2 ) )
          = ( complete_Sup_Sup @ A @ A2 ) ) ) )).

% SUP_identity_eq
thf(fact_197_SUP__apply,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( complete_Sup @ A @ ( type2 @ A ) )
     => ! [F: ( C > B > A ),A2: ( set @ C ),X5: B] :
          ( ( complete_Sup_Sup @ ( B > A ) @ ( image @ C @ ( B > A ) @ F @ A2 ) @ X5 )
          = ( complete_Sup_Sup @ A
            @ ( image @ C @ A
              @ ^ [Y: C] :
                  ( F @ Y @ X5 )
              @ A2 ) ) ) ) )).

% SUP_apply
thf(fact_198_UN__I,axiom,(
    ! [B: $tType,A: $tType,A4: A,A2: ( set @ A ),B3: B,B2: ( A > ( set @ B ) )] :
      ( ( member @ A @ A4 @ A2 )
     => ( ( member @ B @ B3 @ ( B2 @ A4 ) )
       => ( member @ B @ B3 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B2 @ A2 ) ) ) ) ) )).

% UN_I
thf(fact_199_UN__iff,axiom,(
    ! [A: $tType,B: $tType,B3: A,B2: ( B > ( set @ A ) ),A2: ( set @ B )] :
      ( ( member @ A @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A2 )
            & ( member @ A @ B3 @ ( B2 @ X ) ) ) ) ) )).

% UN_iff
thf(fact_200_SUP__bot,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B )] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [X: B] :
                  ( bot_bot @ A )
              @ A2 ) )
          = ( bot_bot @ A ) ) ) )).

% SUP_bot
thf(fact_201_SUP__bot__conv_I1_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [B2: ( B > A ),A2: ( set @ B )] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ B2 @ A2 ) )
            = ( bot_bot @ A ) )
          = ( ! [X: B] :
                ( ( member @ B @ X @ A2 )
               => ( ( B2 @ X )
                  = ( bot_bot @ A ) ) ) ) ) ) )).

% SUP_bot_conv(1)
thf(fact_202_SUP__bot__conv_I2_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [B2: ( B > A ),A2: ( set @ B )] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ ( image @ B @ A @ B2 @ A2 ) ) )
          = ( ! [X: B] :
                ( ( member @ B @ X @ A2 )
               => ( ( B2 @ X )
                  = ( bot_bot @ A ) ) ) ) ) ) )).

% SUP_bot_conv(2)
thf(fact_203_cSUP__const,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),C3: A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [X: B] : C3
                @ A2 ) )
            = C3 ) ) ) )).

% cSUP_const
thf(fact_204_SUP__const,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),F: A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [I: B] : F
                @ A2 ) )
            = F ) ) ) )).

% SUP_const
thf(fact_205_UN__constant,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ B ),C3: ( set @ A )] :
      ( ( ( A2
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] : C3
              @ A2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [Y: B] : C3
              @ A2 ) )
          = C3 ) ) ) )).

% UN_constant
thf(fact_206_SUP__empty,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [F: ( B > A )] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) ) )
          = ( bot_bot @ A ) ) ) )).

% SUP_empty
thf(fact_207_UN__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,C2: ( set @ B ),A4: A,B2: ( B > ( set @ A ) )] :
      ( ( ( C2
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [X: B] :
                  ( insert @ A @ A4 @ ( B2 @ X ) )
              @ C2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( C2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [X: B] :
                  ( insert @ A @ A4 @ ( B2 @ X ) )
              @ C2 ) )
          = ( insert @ A @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ C2 ) ) ) ) ) ) )).

% UN_simps(1)
thf(fact_208_UN__singleton,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ A @ ( set @ A )
          @ ^ [X: A] :
              ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) )
          @ A2 ) )
      = A2 ) )).

% UN_singleton
thf(fact_209_SUP__eq__const,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [I2: ( set @ B ),F: ( B > A ),X5: A] :
          ( ( I2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I3: B] :
                ( ( member @ B @ I3 @ I2 )
               => ( ( F @ I3 )
                  = X5 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ I2 ) )
              = X5 ) ) ) ) )).

% SUP_eq_const
thf(fact_210_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ B ),B2: ( set @ B ),C2: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A2 = B2 )
     => ( ! [X6: B] :
            ( ( member @ B @ X6 @ B2 )
           => ( ( C2 @ X6 )
              = ( D3 @ X6 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C2 @ A2 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B2 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_211_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ B ),B2: ( set @ B ),C2: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A2 = B2 )
     => ( ! [X6: B] :
            ( ( member @ B @ X6 @ B2 )
           => ( ( C2 @ X6 )
              = ( D3 @ X6 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C2 @ A2 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B2 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_212_case__sum__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F22: ( B > C ),G1: ( A > C ),G22: ( B > C )] :
      ( ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 )
        = ( sum_case_sum @ A @ C @ B @ G1 @ G22 ) )
     => ~ ( ( F1 = G1 )
         => ( F22 != G22 ) ) ) )).

% case_sum_inject
thf(fact_213_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X5: A,A2: ( set @ A ),B3: B,F: ( A > B )] :
      ( ( member @ A @ X5 @ A2 )
     => ( ( B3
          = ( F @ X5 ) )
       => ( member @ B @ B3 @ ( image @ A @ B @ F @ A2 ) ) ) ) )).

% rev_image_eqI
thf(fact_214_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P2: ( A > $o )] :
      ( ! [X6: A] :
          ( ( member @ A @ X6 @ ( image @ B @ A @ F @ A2 ) )
         => ( P2 @ X6 ) )
     => ! [X8: B] :
          ( ( member @ B @ X8 @ A2 )
         => ( P2 @ ( F @ X8 ) ) ) ) )).

% ball_imageD
thf(fact_215_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N4: ( set @ A ),F: ( A > B ),G2: ( A > B )] :
      ( ( M = N4 )
     => ( ! [X6: A] :
            ( ( member @ A @ X6 @ N4 )
           => ( ( F @ X6 )
              = ( G2 @ X6 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G2 @ N4 ) ) ) ) )).

% image_cong
thf(fact_216_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P2: ( A > $o )] :
      ( ? [X8: A] :
          ( ( member @ A @ X8 @ ( image @ B @ A @ F @ A2 ) )
          & ( P2 @ X8 ) )
     => ? [X6: B] :
          ( ( member @ B @ X6 @ A2 )
          & ( P2 @ ( F @ X6 ) ) ) ) )).

% bex_imageD
thf(fact_217_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z3: A,F: ( B > A ),A2: ( set @ B )] :
      ( ( member @ A @ Z3 @ ( image @ B @ A @ F @ A2 ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A2 )
            & ( Z3
              = ( F @ X ) ) ) ) ) )).

% image_iff
thf(fact_218_imageI,axiom,(
    ! [B: $tType,A: $tType,X5: A,A2: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X5 @ A2 )
     => ( member @ B @ ( F @ X5 ) @ ( image @ A @ B @ F @ A2 ) ) ) )).

% imageI
thf(fact_219_SUP__cong,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( complete_Sup @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),B2: ( set @ B ),C2: ( B > A ),D3: ( B > A )] :
          ( ( A2 = B2 )
         => ( ! [X6: B] :
                ( ( member @ B @ X6 @ B2 )
               => ( ( C2 @ X6 )
                  = ( D3 @ X6 ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ C2 @ A2 ) )
              = ( complete_Sup_Sup @ A @ ( image @ B @ A @ D3 @ B2 ) ) ) ) ) ) )).

% SUP_cong
thf(fact_220_Sup__SUP__eq,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( A > $o ) )
      = ( ^ [S2: ( set @ ( A > $o ) ),X: A] :
            ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( A > $o ) @ ( set @ A ) @ ( collect @ A ) @ S2 ) ) ) ) ) )).

% Sup_SUP_eq
thf(fact_221_case__sum__step_I1_J,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F4: ( B > A ),G3: ( C > A ),G2: ( D > A ),P4: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ ( sum_sum @ B @ C ) @ A @ D @ ( sum_case_sum @ B @ A @ C @ F4 @ G3 ) @ G2 @ ( sum_Inl @ ( sum_sum @ B @ C ) @ D @ P4 ) )
      = ( sum_case_sum @ B @ A @ C @ F4 @ G3 @ P4 ) ) )).

% case_sum_step(1)
thf(fact_222_case__sum__step_I2_J,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,F: ( E > A ),F4: ( B > A ),G3: ( C > A ),P4: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ E @ A @ ( sum_sum @ B @ C ) @ F @ ( sum_case_sum @ B @ A @ C @ F4 @ G3 ) @ ( sum_Inr @ ( sum_sum @ B @ C ) @ E @ P4 ) )
      = ( sum_case_sum @ B @ A @ C @ F4 @ G3 @ P4 ) ) )).

% case_sum_step(2)
thf(fact_223_old_Osum_Osimps_I5_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F1: ( A > C ),F22: ( B > C ),X1: A] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ X1 ) )
      = ( F1 @ X1 ) ) )).

% old.sum.simps(5)
thf(fact_224_old_Osum_Osimps_I6_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F22: ( B > C ),X22: B] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ X22 ) )
      = ( F22 @ X22 ) ) )).

% old.sum.simps(6)
thf(fact_225_setcompr__eq__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),P2: ( B > $o )] :
      ( ( collect @ A
        @ ^ [Uu: A] :
          ? [X: B] :
            ( ( Uu
              = ( F @ X ) )
            & ( P2 @ X ) ) )
      = ( image @ B @ A @ F @ ( collect @ B @ P2 ) ) ) )).

% setcompr_eq_image
thf(fact_226_Setcompr__eq__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( collect @ A
        @ ^ [Uu: A] :
          ? [X: B] :
            ( ( Uu
              = ( F @ X ) )
            & ( member @ B @ X @ A2 ) ) )
      = ( image @ B @ A @ F @ A2 ) ) )).

% Setcompr_eq_image
thf(fact_227_SUP__commute,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [F: ( B > C > A ),B2: ( set @ C ),A2: ( set @ B )] :
          ( ( complete_Sup_Sup @ A
            @ ( image @ B @ A
              @ ^ [I: B] :
                  ( complete_Sup_Sup @ A @ ( image @ C @ A @ ( F @ I ) @ B2 ) )
              @ A2 ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ C @ A
              @ ^ [J: C] :
                  ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [I: B] :
                        ( F @ I @ J )
                    @ A2 ) )
              @ B2 ) ) ) ) )).

% SUP_commute
thf(fact_228_UN__extend__simps_I9_J,axiom,(
    ! [S3: $tType,R3: $tType,Q2: $tType,C2: ( R3 > ( set @ S3 ) ),B2: ( Q2 > ( set @ R3 ) ),A2: ( set @ Q2 )] :
      ( ( complete_Sup_Sup @ ( set @ S3 )
        @ ( image @ Q2 @ ( set @ S3 )
          @ ^ [X: Q2] :
              ( complete_Sup_Sup @ ( set @ S3 ) @ ( image @ R3 @ ( set @ S3 ) @ C2 @ ( B2 @ X ) ) )
          @ A2 ) )
      = ( complete_Sup_Sup @ ( set @ S3 ) @ ( image @ R3 @ ( set @ S3 ) @ C2 @ ( complete_Sup_Sup @ ( set @ R3 ) @ ( image @ Q2 @ ( set @ R3 ) @ B2 @ A2 ) ) ) ) ) )).

% UN_extend_simps(9)
thf(fact_229_UN__E,axiom,(
    ! [A: $tType,B: $tType,B3: A,B2: ( B > ( set @ A ) ),A2: ( set @ B )] :
      ( ( member @ A @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
     => ~ ( ! [X6: B] :
              ( ( member @ B @ X6 @ A2 )
             => ~ ( member @ A @ B3 @ ( B2 @ X6 ) ) ) ) ) )).

% UN_E
thf(fact_230_UN__UN__flatten,axiom,(
    ! [A: $tType,B: $tType,C: $tType,C2: ( B > ( set @ A ) ),B2: ( C > ( set @ B ) ),A2: ( set @ C )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ C2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ B2 @ A2 ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ C @ ( set @ A )
          @ ^ [Y: C] :
              ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ C2 @ ( B2 @ Y ) ) )
          @ A2 ) ) ) )).

% UN_UN_flatten
thf(fact_231_SUP__UNION,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [F: ( B > A ),G2: ( C > ( set @ B ) ),A2: ( set @ C )] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ G2 @ A2 ) ) ) )
          = ( complete_Sup_Sup @ A
            @ ( image @ C @ A
              @ ^ [Y: C] :
                  ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ ( G2 @ Y ) ) )
              @ A2 ) ) ) ) )).

% SUP_UNION
thf(fact_232_imageE,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),A2: ( set @ B )] :
      ( ( member @ A @ B3 @ ( image @ B @ A @ F @ A2 ) )
     => ~ ( ! [X6: B] :
              ( ( B3
                = ( F @ X6 ) )
             => ~ ( member @ B @ X6 @ A2 ) ) ) ) )).

% imageE
thf(fact_233_image__image,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G2: ( C > B ),A2: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G2 @ A2 ) )
      = ( image @ C @ A
        @ ^ [X: C] :
            ( F @ ( G2 @ X ) )
        @ A2 ) ) )).

% image_image
thf(fact_234_Compr__image__eq,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P2: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( ( member @ A @ X @ ( image @ B @ A @ F @ A2 ) )
            & ( P2 @ X ) ) )
      = ( image @ B @ A @ F
        @ ( collect @ B
          @ ^ [X: B] :
              ( ( member @ B @ X @ A2 )
              & ( P2 @ ( F @ X ) ) ) ) ) ) )).

% Compr_image_eq
thf(fact_235_sum_Ocase__distrib,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,H: ( C > D ),F1: ( A > C ),F22: ( B > C ),Sum: ( sum_sum @ A @ B )] :
      ( ( H @ ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ Sum ) )
      = ( sum_case_sum @ A @ D @ B
        @ ^ [X: A] :
            ( H @ ( F1 @ X ) )
        @ ^ [X: B] :
            ( H @ ( F22 @ X ) )
        @ Sum ) ) )).

% sum.case_distrib
thf(fact_236_image__UN,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),B2: ( C > ( set @ B ) ),A2: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ B2 @ A2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ C @ ( set @ A )
          @ ^ [X: C] :
              ( image @ B @ A @ F @ ( B2 @ X ) )
          @ A2 ) ) ) )).

% image_UN
thf(fact_237_UN__extend__simps_I10_J,axiom,(
    ! [V: $tType,U2: $tType,T: $tType,B2: ( U2 > ( set @ V ) ),F: ( T > U2 ),A2: ( set @ T )] :
      ( ( complete_Sup_Sup @ ( set @ V )
        @ ( image @ T @ ( set @ V )
          @ ^ [A3: T] :
              ( B2 @ ( F @ A3 ) )
          @ A2 ) )
      = ( complete_Sup_Sup @ ( set @ V ) @ ( image @ U2 @ ( set @ V ) @ B2 @ ( image @ T @ U2 @ F @ A2 ) ) ) ) )).

% UN_extend_simps(10)
thf(fact_238_image__Union,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S4: ( set @ ( set @ B ) )] :
      ( ( image @ B @ A @ F @ ( complete_Sup_Sup @ ( set @ B ) @ S4 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F ) @ S4 ) ) ) )).

% image_Union
thf(fact_239_UN__extend__simps_I8_J,axiom,(
    ! [P5: $tType,O: $tType,B2: ( O > ( set @ P5 ) ),A2: ( set @ ( set @ O ) )] :
      ( ( complete_Sup_Sup @ ( set @ P5 )
        @ ( image @ ( set @ O ) @ ( set @ P5 )
          @ ^ [Y: ( set @ O )] :
              ( complete_Sup_Sup @ ( set @ P5 ) @ ( image @ O @ ( set @ P5 ) @ B2 @ Y ) )
          @ A2 ) )
      = ( complete_Sup_Sup @ ( set @ P5 ) @ ( image @ O @ ( set @ P5 ) @ B2 @ ( complete_Sup_Sup @ ( set @ O ) @ A2 ) ) ) ) )).

% UN_extend_simps(8)
thf(fact_240_Inf_OINF__identity__eq,axiom,(
    ! [A: $tType,Inf: ( ( set @ A ) > A ),A2: ( set @ A )] :
      ( ( Inf
        @ ( image @ A @ A
          @ ^ [X: A] : X
          @ A2 ) )
      = ( Inf @ A2 ) ) )).

% Inf.INF_identity_eq
thf(fact_241_Sup_OSUP__identity__eq,axiom,(
    ! [A: $tType,Sup: ( ( set @ A ) > A ),A2: ( set @ A )] :
      ( ( Sup
        @ ( image @ A @ A
          @ ^ [X: A] : X
          @ A2 ) )
      = ( Sup @ A2 ) ) )).

% Sup.SUP_identity_eq
thf(fact_242_the__elem__image__unique,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),F: ( A > B ),X5: A] :
      ( ( A2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [Y4: A] :
            ( ( member @ A @ Y4 @ A2 )
           => ( ( F @ Y4 )
              = ( F @ X5 ) ) )
       => ( ( the_elem @ B @ ( image @ A @ B @ F @ A2 ) )
          = ( F @ X5 ) ) ) ) )).

% the_elem_image_unique
thf(fact_243_image__constant__conv,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ B ),C3: A] :
      ( ( ( A2
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ B @ A
            @ ^ [X: B] : C3
            @ A2 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ B @ A
            @ ^ [X: B] : C3
            @ A2 )
          = ( insert @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% image_constant_conv
thf(fact_244_image__constant,axiom,(
    ! [A: $tType,B: $tType,X5: A,A2: ( set @ A ),C3: B] :
      ( ( member @ A @ X5 @ A2 )
     => ( ( image @ A @ B
          @ ^ [X: A] : C3
          @ A2 )
        = ( insert @ B @ C3 @ ( bot_bot @ ( set @ B ) ) ) ) ) )).

% image_constant
thf(fact_245_UN__empty2,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ B )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X: B] :
              ( bot_bot @ ( set @ A ) )
          @ A2 ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% UN_empty2
thf(fact_246_UN__empty,axiom,(
    ! [B: $tType,A: $tType,B2: ( B > ( set @ A ) )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ ( bot_bot @ ( set @ B ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% UN_empty
thf(fact_247_UNION__empty__conv_I1_J,axiom,(
    ! [A: $tType,B: $tType,B2: ( B > ( set @ A ) ),A2: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ( ( B2 @ X )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% UNION_empty_conv(1)
thf(fact_248_UNION__empty__conv_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: ( B > ( set @ A ) ),A2: ( set @ B )] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ( ( B2 @ X )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% UNION_empty_conv(2)
thf(fact_249_UN__insert__distrib,axiom,(
    ! [B: $tType,A: $tType,U3: A,A2: ( set @ A ),A4: B,B2: ( A > ( set @ B ) )] :
      ( ( member @ A @ U3 @ A2 )
     => ( ( complete_Sup_Sup @ ( set @ B )
          @ ( image @ A @ ( set @ B )
            @ ^ [X: A] :
                ( insert @ B @ A4 @ ( B2 @ X ) )
            @ A2 ) )
        = ( insert @ B @ A4 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B2 @ A2 ) ) ) ) ) )).

% UN_insert_distrib
thf(fact_250_vimage__UN,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),B2: ( C > ( set @ B ) ),A2: ( set @ C )] :
      ( ( vimage @ A @ B @ F @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ C @ ( set @ B ) @ B2 @ A2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ C @ ( set @ A )
          @ ^ [X: C] :
              ( vimage @ A @ B @ F @ ( B2 @ X ) )
          @ A2 ) ) ) )).

% vimage_UN
thf(fact_251_vimage__Union,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A2: ( set @ ( set @ B ) )] :
      ( ( vimage @ A @ B @ F @ ( complete_Sup_Sup @ ( set @ B ) @ A2 ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( vimage @ A @ B @ F ) @ A2 ) ) ) )).

% vimage_Union
thf(fact_252_case__sum__if,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P4: $o,F: ( B > A ),G2: ( C > A ),X5: B,Y3: C] :
      ( ( P4
       => ( ( sum_case_sum @ B @ A @ C @ F @ G2 @ ( if @ ( sum_sum @ B @ C ) @ P4 @ ( sum_Inl @ B @ C @ X5 ) @ ( sum_Inr @ C @ B @ Y3 ) ) )
          = ( F @ X5 ) ) )
      & ( ~ ( P4 )
       => ( ( sum_case_sum @ B @ A @ C @ F @ G2 @ ( if @ ( sum_sum @ B @ C ) @ P4 @ ( sum_Inl @ B @ C @ X5 ) @ ( sum_Inr @ C @ B @ Y3 ) ) )
          = ( G2 @ Y3 ) ) ) ) )).

% case_sum_if
thf(fact_253_surjective__sum,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( sum_sum @ A @ B ) > C )] :
      ( ( sum_case_sum @ A @ C @ B
        @ ^ [X: A] :
            ( F @ ( sum_Inl @ A @ B @ X ) )
        @ ^ [Y: B] :
            ( F @ ( sum_Inr @ B @ A @ Y ) ) )
      = F ) )).

% surjective_sum
thf(fact_254_SUP__constant,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),C3: A] :
          ( ( ( A2
              = ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image @ B @ A
                  @ ^ [Y: B] : C3
                  @ A2 ) )
              = ( bot_bot @ A ) ) )
          & ( ( A2
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( complete_Sup_Sup @ A
                @ ( image @ B @ A
                  @ ^ [Y: B] : C3
                  @ A2 ) )
              = C3 ) ) ) ) )).

% SUP_constant
thf(fact_255_UN__extend__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,C2: ( set @ B ),A4: A,B2: ( B > ( set @ A ) )] :
      ( ( ( C2
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( insert @ A @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ C2 ) ) )
          = ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ( C2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( insert @ A @ A4 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ C2 ) ) )
          = ( complete_Sup_Sup @ ( set @ A )
            @ ( image @ B @ ( set @ A )
              @ ^ [X: B] :
                  ( insert @ A @ A4 @ ( B2 @ X ) )
              @ C2 ) ) ) ) ) )).

% UN_extend_simps(1)

%----Type constructors (15)
thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( comple187826305attice @ A10 @ ( type2 @ A10 ) )
     => ( condit378418413attice @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( comple187826305attice @ A10 @ ( type2 @ A10 ) )
     => ( comple187826305attice @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Complete__Partial__Order_Occpo,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( comple187826305attice @ A10 @ ( type2 @ A10 ) )
     => ( comple1141879883l_ccpo @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Complete__Lattices_OSup,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( complete_Sup @ A10 @ ( type2 @ A10 ) )
     => ( complete_Sup @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( bot @ A10 @ ( type2 @ A10 ) )
     => ( bot @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_1,axiom,(
    ! [A7: $tType] :
      ( condit378418413attice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_2,axiom,(
    ! [A7: $tType] :
      ( comple187826305attice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Complete__Partial__Order_Occpo_3,axiom,(
    ! [A7: $tType] :
      ( comple1141879883l_ccpo @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Complete__Lattices_OSup_4,axiom,(
    ! [A7: $tType] :
      ( complete_Sup @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_5,axiom,(
    ! [A7: $tType] :
      ( bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    ( condit378418413attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_7,axiom,
    ( comple187826305attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Partial__Order_Occpo_8,axiom,
    ( comple1141879883l_ccpo @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Lattices_OSup_9,axiom,
    ( complete_Sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_10,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X5: A,Y3: A] :
      ( ( if @ A @ $false @ X5 @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X5: A,Y3: A] :
      ( ( if @ A @ $true @ X5 @ Y3 )
      = X5 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( collect @ n @ ( gram_L830233218_inItr @ ns @ tr ) )
    = ( collect @ n
      @ ^ [Uu: n] :
        ? [Tr5: dtree] :
          ( ( Uu
            = ( root @ Tr5 ) )
          & ( gram_L716654942_subtr @ ns @ Tr5 @ tr ) ) ) )).

%------------------------------------------------------------------------------
