%------------------------------------------------------------------------------
% File     : COM187^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 549
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__549.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  310 (   0 unit;  45 type;   0 defn)
%            Number of atoms       : 5389 ( 325 equality;2776 variable)
%            Maximal formula depth :   22 (  11 average)
%            Number of connectives : 4872 (  79   ~;  12   |;  82   &;4348   @)
%                                         (   0 <=>; 351  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  286 ( 286   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   49 (  45   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1157 (   1 sgn;1032   !;  57   ?;  36   ^)
%                                         (1157   :;  32  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:43:13.600
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (38)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Fun_Oinj__on,type,(
    inj_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OP,type,(
    gram_L1451583632elle_P: ( set @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OS,type,(
    gram_L1451583635elle_S: n > ( set @ ( sum_sum @ t @ n ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Odeftr,type,(
    gram_L1231612515_deftr: n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst,type,(
    gram_L1004374585hsubst: dtree > dtree > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c,type,(
    gram_L1905609002ubst_c: dtree > dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__r,type,(
    gram_L1905609017ubst_r: dtree > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFrr,type,(
    gram_L805317505_inFrr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr,type,(
    gram_L716654942_subtr: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr2,type,(
    gram_L1283001940subtr2: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OsubtrOf,type,(
    gram_L1614515765ubtrOf: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Owf,type,(
    gram_L864798063lle_wf: dtree > $o )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_Omap__sum,type,(
    sum_map_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_tr,type,(
    tr: dtree )).

thf(sy_v_tr0,type,(
    tr0: dtree )).

%----Relevant facts (256)
thf(fact_0__092_060open_062cont_A_Ilocal_Ohsubst_Atr_J_A_061_A_Iid_A_092_060oplus_062_Alocal_Ohsubst_J_A_096_Acont_Atr_092_060close_062,axiom,
    ( ( cont @ ( gram_L1004374585hsubst @ tr0 @ tr ) )
    = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ tr0 ) ) @ ( cont @ tr ) ) )).

% \<open>cont (local.hsubst tr) = (id \<oplus> local.hsubst) ` cont tr\<close>
thf(fact_1_assms,axiom,(
    ( root @ tr )
 != ( root @ tr0 ) )).

% assms
thf(fact_2_Inl__m__oplus,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
      = ( vimage @ A @ ( sum_sum @ A @ C ) @ ( sum_Inl @ A @ C ) @ Tns ) ) )).

% Inl_m_oplus
thf(fact_3_Inl__oplus__iff,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Tr: A,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
      = ( member @ ( sum_sum @ A @ C ) @ ( sum_Inl @ A @ C @ Tr ) @ Tns ) ) )).

% Inl_oplus_iff
thf(fact_4_vimage__id,axiom,(
    ! [A: $tType] :
      ( ( vimage @ A @ A @ ( id @ A ) )
      = ( id @ ( set @ A ) ) ) )).

% vimage_id
thf(fact_5_image__id,axiom,(
    ! [A: $tType] :
      ( ( image @ A @ A @ ( id @ A ) )
      = ( id @ ( set @ A ) ) ) )).

% image_id
thf(fact_6_Inl__oplus__elim,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Tr: A,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
     => ( member @ ( sum_sum @ A @ C ) @ ( sum_Inl @ A @ C @ Tr ) @ Tns ) ) )).

% Inl_oplus_elim
thf(fact_7_cont__hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) )
        = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ tr0 ) ) @ ( cont @ tr0 ) ) ) ) )).

% cont_hsubst_eq
thf(fact_8_cont__hsubst__neq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
       != ( root @ tr0 ) )
     => ( ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) )
        = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ tr0 ) ) @ ( cont @ Tr ) ) ) ) )).

% cont_hsubst_neq
thf(fact_9_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_10_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: A] :
      ( ( ( sum_Inl @ A @ B @ A2 )
        = ( sum_Inl @ A @ B @ A3 ) )
      = ( A2 = A3 ) ) )).

% old.sum.inject(1)
thf(fact_11_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: A,B3: ( set @ A )] :
      ( ( ( F @ A2 )
        = B2 )
     => ( ( member @ A @ B2 @ B3 )
       => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ B3 ) ) ) ) )).

% vimageI
thf(fact_12_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
      = ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimage_eq
thf(fact_13_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_apply
thf(fact_14_hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( gram_L1004374585hsubst @ tr0 @ Tr )
        = ( gram_L1004374585hsubst @ tr0 @ tr0 ) ) ) )).

% hsubst_eq
thf(fact_15_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X2: B,A4: ( set @ B )] :
      ( ( B2
        = ( F @ X2 ) )
     => ( ( member @ B @ X2 @ A4 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A4 ) ) ) ) )).

% image_eqI
thf(fact_16_root__hsubst,axiom,(
    ! [Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ tr0 @ Tr ) )
      = ( root @ Tr ) ) )).

% root_hsubst
thf(fact_17_hsubst__c__def,axiom,(
    ! [Tr: dtree] :
      ( ( ( ( root @ Tr )
          = ( root @ tr0 ) )
       => ( ( gram_L1905609002ubst_c @ tr0 @ Tr )
          = ( cont @ tr0 ) ) )
      & ( ( ( root @ Tr )
         != ( root @ tr0 ) )
       => ( ( gram_L1905609002ubst_c @ tr0 @ Tr )
          = ( cont @ Tr ) ) ) ) )).

% hsubst_c_def
thf(fact_18_Inl__cont__hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ tr0 ) ) ) ) )).

% Inl_cont_hsubst_eq
thf(fact_19_Inl__prodOf,axiom,(
    ! [Tr: dtree] :
      ( ( vimage @ t @ ( sum_sum @ t @ n ) @ ( sum_Inl @ t @ n ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr ) ) ) )).

% Inl_prodOf
thf(fact_20_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
      = ( root @ Tr ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_hsubst
thf(fact_21_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( gram_L1004374585hsubst @ Tr0 @ Tr )
        = ( gram_L1004374585hsubst @ Tr0 @ Tr0 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.hsubst_eq
thf(fact_22_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A4: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X2 @ A4 )
     => ( ( B2
          = ( F @ X2 ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A4 ) ) ) ) )).

% rev_image_eqI
thf(fact_23_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A4 ) )
         => ( P @ X3 ) )
     => ! [X4: B] :
          ( ( member @ B @ X4 @ A4 )
         => ( P @ ( F @ X4 ) ) ) ) )).

% ball_imageD
thf(fact_24_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G @ N ) ) ) ) )).

% image_cong
thf(fact_25_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A4 ) )
          & ( P @ X4 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A4 )
          & ( P @ ( F @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_26_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z: A,F: ( B > A ),A4: ( set @ B )] :
      ( ( member @ A @ Z @ ( image @ B @ A @ F @ A4 ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A4 )
            & ( Z
              = ( F @ X ) ) ) ) ) )).

% image_iff
thf(fact_27_imageI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A4: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X2 @ A4 )
     => ( member @ B @ ( F @ X2 ) @ ( image @ A @ B @ F @ A4 ) ) ) )).

% imageI
thf(fact_28_eq__id__iff,axiom,(
    ! [A: $tType,F: ( A > A )] :
      ( ( ! [X: A] :
            ( ( F @ X )
            = X ) )
      = ( F
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_29_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_def
thf(fact_30_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_31_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,A4: ( set @ A )] :
      ( ( member @ A @ ( F @ A2 ) @ A4 )
     => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ A4 ) ) ) )).

% vimageI2
thf(fact_32_vimageE,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
     => ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimageE
thf(fact_33_vimageD,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),A4: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ A4 ) )
     => ( member @ B @ ( F @ A2 ) @ A4 ) ) )).

% vimageD
thf(fact_34_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X2 )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X2 = Y ) ) )).

% Inl_inject
thf(fact_35_Gram__Lang__Mirabelle__ojxrtuoybn_OInl__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr0 ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inl_cont_hsubst_eq
thf(fact_36_Gram__Lang__Mirabelle__ojxrtuoybn_Ocont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr0 ) )
     => ( ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
        = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ Tr0 ) ) @ ( cont @ Tr ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.cont_hsubst_neq
thf(fact_37_Gram__Lang__Mirabelle__ojxrtuoybn_Ocont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
        = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ Tr0 ) ) @ ( cont @ Tr0 ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.cont_hsubst_eq
thf(fact_38_map__sum__InlD,axiom,(
    ! [D: $tType,B: $tType,C: $tType,A: $tType,F: ( C > A ),G: ( D > B ),Z: ( sum_sum @ C @ D ),X2: A] :
      ( ( ( sum_map_sum @ C @ A @ D @ B @ F @ G @ Z )
        = ( sum_Inl @ A @ B @ X2 ) )
     => ? [Y2: C] :
          ( ( Z
            = ( sum_Inl @ C @ D @ Y2 ) )
          & ( ( F @ Y2 )
            = X2 ) ) ) )).

% map_sum_InlD
thf(fact_39_map__sum_Osimps_I1_J,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F1: ( A > C ),F2: ( B > D ),A2: A] :
      ( ( sum_map_sum @ A @ C @ B @ D @ F1 @ F2 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( sum_Inl @ C @ D @ ( F1 @ A2 ) ) ) )).

% map_sum.simps(1)
thf(fact_40_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F2: ( B > T ),A2: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( F1 @ A2 ) ) )).

% old.sum.simps(7)
thf(fact_41_map__sum__if__distrib__then_I1_J,axiom,(
    ! [D: $tType,B: $tType,C: $tType,A: $tType,E: $o,F: ( A > B ),G: ( C > D ),X2: A,Y: ( sum_sum @ A @ C )] :
      ( ( E
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ ( sum_Inl @ A @ C @ X2 ) @ Y ) )
          = ( sum_Inl @ B @ D @ ( F @ X2 ) ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ ( sum_Inl @ A @ C @ X2 ) @ Y ) )
          = ( sum_map_sum @ A @ B @ C @ D @ F @ G @ Y ) ) ) ) )).

% map_sum_if_distrib_then(1)
thf(fact_42_map__sum__if__distrib__else_I1_J,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,E: $o,F: ( A > B ),G: ( C > D ),X2: ( sum_sum @ A @ C ),Y: A] :
      ( ( E
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ X2 @ ( sum_Inl @ A @ C @ Y ) ) )
          = ( sum_map_sum @ A @ B @ C @ D @ F @ G @ X2 ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ X2 @ ( sum_Inl @ A @ C @ Y ) ) )
          = ( sum_Inl @ B @ D @ ( F @ Y ) ) ) ) ) )).

% map_sum_if_distrib_else(1)
thf(fact_43_dtree__cong,axiom,(
    ! [Tr: dtree,Tr2: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr2 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr2 ) )
       => ( Tr = Tr2 ) ) ) )).

% dtree_cong
thf(fact_44_sum_Omap__id0,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_map_sum @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( sum_sum @ A @ B ) ) ) )).

% sum.map_id0
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_sum_Omap__id,axiom,(
    ! [B: $tType,A: $tType,T2: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) @ T2 )
      = T2 ) )).

% sum.map_id
thf(fact_50_Sup_OSUP__id__eq,axiom,(
    ! [A: $tType,Sup: ( ( set @ A ) > A ),A4: ( set @ A )] :
      ( ( Sup @ ( image @ A @ A @ ( id @ A ) @ A4 ) )
      = ( Sup @ A4 ) ) )).

% Sup.SUP_id_eq
thf(fact_51_Inf_OINF__id__eq,axiom,(
    ! [A: $tType,Inf: ( ( set @ A ) > A ),A4: ( set @ A )] :
      ( ( Inf @ ( image @ A @ A @ ( id @ A ) @ A4 ) )
      = ( Inf @ A4 ) ) )).

% Inf.INF_id_eq
thf(fact_52_Inr__m__oplus,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),Tns: ( set @ ( sum_sum @ B @ C ) )] :
      ( ( vimage @ A @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B ) @ ( image @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ A ) @ ( sum_map_sum @ B @ B @ C @ A @ ( id @ B ) @ F ) @ Tns ) )
      = ( image @ C @ A @ F @ ( vimage @ C @ ( sum_sum @ B @ C ) @ ( sum_Inr @ C @ B ) @ Tns ) ) ) )).

% Inr_m_oplus
thf(fact_53_Inr__cont__hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ tr0 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ tr0 ) ) ) ) ) )).

% Inr_cont_hsubst_eq
thf(fact_54_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_55_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X22: B,Y22: B] :
      ( ( ( sum_Inr @ B @ A @ X22 )
        = ( sum_Inr @ B @ A @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% sum.inject(2)
thf(fact_56_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B4: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B4 ) )
      = ( B2 = B4 ) ) )).

% old.sum.inject(2)
thf(fact_57_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X2 )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_58_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X2: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X2 )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_59_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F2: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F2 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_60_Inr__oplus__iff,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Tr: B,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
      = ( ? [N2: C] :
            ( ( member @ ( sum_sum @ A @ C ) @ ( sum_Inr @ C @ A @ N2 ) @ Tns )
            & ( ( F @ N2 )
              = Tr ) ) ) ) )).

% Inr_oplus_iff
thf(fact_61_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X2 = Y ) ) )).

% Inr_inject
thf(fact_62_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X3: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X3 ) ) )
         => P )
     => ( ! [X3: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X3 ) ) )
           => P )
       => ! [X4: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X4 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_63_map__sum__if__distrib__else_I2_J,axiom,(
    ! [E2: $tType,F3: $tType,H: $tType,G2: $tType,E: $o,F: ( E2 > F3 ),G: ( G2 > H ),X2: ( sum_sum @ E2 @ G2 ),Y: G2] :
      ( ( E
       => ( ( sum_map_sum @ E2 @ F3 @ G2 @ H @ F @ G @ ( if @ ( sum_sum @ E2 @ G2 ) @ E @ X2 @ ( sum_Inr @ G2 @ E2 @ Y ) ) )
          = ( sum_map_sum @ E2 @ F3 @ G2 @ H @ F @ G @ X2 ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ E2 @ F3 @ G2 @ H @ F @ G @ ( if @ ( sum_sum @ E2 @ G2 ) @ E @ X2 @ ( sum_Inr @ G2 @ E2 @ Y ) ) )
          = ( sum_Inr @ H @ F3 @ ( G @ Y ) ) ) ) ) )).

% map_sum_if_distrib_else(2)
thf(fact_64_map__sum__if__distrib__then_I2_J,axiom,(
    ! [H: $tType,F3: $tType,G2: $tType,E2: $tType,E: $o,F: ( E2 > F3 ),G: ( G2 > H ),X2: G2,Y: ( sum_sum @ E2 @ G2 )] :
      ( ( E
       => ( ( sum_map_sum @ E2 @ F3 @ G2 @ H @ F @ G @ ( if @ ( sum_sum @ E2 @ G2 ) @ E @ ( sum_Inr @ G2 @ E2 @ X2 ) @ Y ) )
          = ( sum_Inr @ H @ F3 @ ( G @ X2 ) ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ E2 @ F3 @ G2 @ H @ F @ G @ ( if @ ( sum_sum @ E2 @ G2 ) @ E @ ( sum_Inr @ G2 @ E2 @ X2 ) @ Y ) )
          = ( sum_map_sum @ E2 @ F3 @ G2 @ H @ F @ G @ Y ) ) ) ) )).

% map_sum_if_distrib_then(2)
thf(fact_65_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X22 ) ) )).

% sum.distinct(1)
thf(fact_66_old_Osum_Odistinct_I2_J,axiom,(
    ! [B5: $tType,A5: $tType,B6: B5,A6: A5] :
      ( ( sum_Inr @ B5 @ A5 @ B6 )
     != ( sum_Inl @ A5 @ B5 @ A6 ) ) )).

% old.sum.distinct(2)
thf(fact_67_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: A,B4: B] :
      ( ( sum_Inl @ A @ B @ A2 )
     != ( sum_Inr @ B @ A @ B4 ) ) )).

% old.sum.distinct(1)
thf(fact_68_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [Y2: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y2 ) ) ) ) )).

% sumE
thf(fact_69_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A2: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A2 ) ) )).

% Inr_not_Inl
thf(fact_70_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X5: ( sum_sum @ A @ B )] :
            ( P2 @ X5 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X ) )
            | ? [X: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_ex
thf(fact_71_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X5: ( sum_sum @ A @ B )] :
            ( P2 @ X5 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X ) )
            & ! [X: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_all
thf(fact_72_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A7: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A7 ) )
     => ~ ( ! [B7: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B7 ) ) ) ) )).

% old.sum.exhaust
thf(fact_73_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A7: A] :
          ( P @ ( sum_Inl @ A @ B @ A7 ) )
     => ( ! [B7: B] :
            ( P @ ( sum_Inr @ B @ A @ B7 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_74_map__sum_Osimps_I2_J,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F1: ( A > C ),F2: ( B > D ),A2: B] :
      ( ( sum_map_sum @ A @ C @ B @ D @ F1 @ F2 @ ( sum_Inr @ B @ A @ A2 ) )
      = ( sum_Inr @ D @ C @ ( F2 @ A2 ) ) ) )).

% map_sum.simps(2)
thf(fact_75_map__sum__InrD,axiom,(
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F: ( C > A ),G: ( D > B ),Z: ( sum_sum @ C @ D ),X2: B] :
      ( ( ( sum_map_sum @ C @ A @ D @ B @ F @ G @ Z )
        = ( sum_Inr @ B @ A @ X2 ) )
     => ? [Y2: D] :
          ( ( Z
            = ( sum_Inr @ D @ C @ Y2 ) )
          & ( ( G @ Y2 )
            = X2 ) ) ) )).

% map_sum_InrD
thf(fact_76_inFr2__Ind,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr1 @ T2 )
     => ( ( member @ n @ ( root @ Tr ) @ Ns )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
         => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr2_Ind
thf(fact_77_root__prodOf,axiom,(
    ! [Tr2: dtree,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr ) )
     => ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ ( root @ Tr2 ) ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) ) ) )).

% root_prodOf
thf(fact_78_inFr2__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr2_root_in
thf(fact_79_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ ( sum_sum @ A @ B ) ),B3: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A4 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B3 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A4 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B3 ) )
       => ( A4 = B3 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_80_Inr__oplus__elim,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Tr: B,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
     => ? [N3: C] :
          ( ( member @ ( sum_sum @ A @ C ) @ ( sum_Inr @ C @ A @ N3 ) @ Tns )
          & ( ( F @ N3 )
            = Tr ) ) ) )).

% Inr_oplus_elim
thf(fact_81_Gram__Lang__Mirabelle__ojxrtuoybn_OInr__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ Tr0 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr0 ) ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inr_cont_hsubst_eq
thf(fact_82_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ B ),B3: ( set @ B ),C2: ( B > A ),D2: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A4 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C2 @ X3 )
              = ( D2 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C2 @ A4 ) )
          = ( Inf @ ( image @ B @ A @ D2 @ B3 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_83_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ B ),B3: ( set @ B ),C2: ( B > A ),D2: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A4 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C2 @ X3 )
              = ( D2 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C2 @ A4 ) )
          = ( Sup @ ( image @ B @ A @ D2 @ B3 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_84_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c__def,axiom,
    ( gram_L1905609002ubst_c
    = ( ^ [Tr02: dtree,Tr3: dtree] :
          ( if @ ( set @ ( sum_sum @ t @ dtree ) )
          @ ( ( root @ Tr3 )
            = ( root @ Tr02 ) )
          @ ( cont @ Tr02 )
          @ ( cont @ Tr3 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.hsubst_c_def
thf(fact_85_hsubst__def,axiom,
    ( ( gram_L1004374585hsubst @ tr0 )
    = ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ tr0 ) ) )).

% hsubst_def
thf(fact_86_root__subtrOf,axiom,(
    ! [N4: n,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N4 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
     => ( ( root @ ( gram_L1614515765ubtrOf @ Tr @ N4 ) )
        = N4 ) ) )).

% root_subtrOf
thf(fact_87_Inr__subtrOf,axiom,(
    ! [N4: n,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N4 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
     => ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ ( gram_L1614515765ubtrOf @ Tr @ N4 ) ) @ ( cont @ Tr ) ) ) )).

% Inr_subtrOf
thf(fact_88_subtrOf,axiom,(
    ! [N4: n,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N4 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ ( gram_L1614515765ubtrOf @ Tr @ N4 ) ) @ ( cont @ Tr ) )
        & ( ( root @ ( gram_L1614515765ubtrOf @ Tr @ N4 ) )
          = N4 ) ) ) )).

% subtrOf
thf(fact_89_finite__hsubst__c,axiom,(
    ! [N4: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( gram_L1905609002ubst_c @ tr0 @ N4 ) ) )).

% finite_hsubst_c
thf(fact_90_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [X3: B] :
              ( S
             != ( sum_Inr @ B @ A @ X3 ) ) ) ) )).

% obj_sumE
thf(fact_91_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_92_inFr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L1333338417e_inFr @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L1333338417e_inFr @ A1 @ Tr12 @ A32 ) ) ) ) ) )).

% inFr.cases
thf(fact_93_root__Node,axiom,(
    ! [N4: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N4 @ As ) )
      = N4 ) )).

% root_Node
thf(fact_94_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N4: n,N5: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N4 @ As )
            = ( node @ N5 @ As2 ) )
          = ( ( N4 = N5 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_95_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N4: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N4 @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_96_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N3: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N3 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_97_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_98_Gram__Lang__Mirabelle__ojxrtuoybn_Ofinite__hsubst__c,axiom,(
    ! [Tr0: dtree,N4: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( gram_L1905609002ubst_c @ Tr0 @ N4 ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.finite_hsubst_c
thf(fact_99_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_100_not__root__inFr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ~ ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) )).

% not_root_inFr
thf(fact_101_inFr__inFr2,axiom,(
    gram_L1333338417e_inFr = gram_L805317441_inFr2 )).

% inFr_inFr2
thf(fact_102_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_103_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__def,axiom,
    ( gram_L1004374585hsubst
    = ( ^ [Tr02: dtree] :
          ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ Tr02 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.hsubst_def
thf(fact_104_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: A] :
      ( ( X2 != Y )
     => ( ( sum_Inr @ A @ B @ X2 )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_105_unfold_I2_J,axiom,(
    ! [A: $tType,Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A,Rt: ( A > n )] :
      ( ( finite_finite2 @ ( sum_sum @ t @ A ) @ ( Ct @ B2 ) )
     => ( ( cont @ ( unfold @ A @ Rt @ Ct @ B2 ) )
        = ( image @ ( sum_sum @ t @ A ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ A @ dtree @ ( id @ t ) @ ( unfold @ A @ Rt @ Ct ) ) @ ( Ct @ B2 ) ) ) ) )).

% unfold(2)
thf(fact_106_hsubst__r__def,axiom,(
    gram_L1905609017ubst_r = root )).

% hsubst_r_def
thf(fact_107_inFr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 )
         => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr.Ind
thf(fact_108_inFr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) )).

% inFr.Base
thf(fact_109_inFr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L1333338417e_inFr @ X1 @ X22 @ X32 )
     => ( ! [Tr4: dtree,Ns2: ( set @ n ),T3: t] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr4 ) )
             => ( P @ Ns2 @ Tr4 @ T3 ) ) )
       => ( ! [Tr4: dtree,Ns2: ( set @ n ),Tr12: dtree,T3: t] :
              ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
               => ( ( gram_L1333338417e_inFr @ Ns2 @ Tr12 @ T3 )
                 => ( ( P @ Ns2 @ Tr12 @ T3 )
                   => ( P @ Ns2 @ Tr4 @ T3 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inFr.inducts
thf(fact_110_inFr_Osimps,axiom,
    ( gram_L1333338417e_inFr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr3: dtree,Ns3: ( set @ n ),T4: t] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33 = T4 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr3 ) ) )
          | ? [Tr3: dtree,Ns3: ( set @ n ),Tr13: dtree,T4: t] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33 = T4 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr3 ) )
              & ( gram_L1333338417e_inFr @ Ns3 @ Tr13 @ T4 ) ) ) ) )).

% inFr.simps
thf(fact_111_inFrr__def,axiom,
    ( gram_L805317505_inFrr
    = ( ^ [Ns3: ( set @ n ),Tr3: dtree,T4: t] :
        ? [Tr5: dtree] :
          ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr3 ) )
          & ( gram_L1333338417e_inFr @ Ns3 @ Tr5 @ T4 ) ) ) )).

% inFrr_def
thf(fact_112_finite__imageI,axiom,(
    ! [B: $tType,A: $tType,F4: ( set @ A ),H2: ( A > B )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( finite_finite2 @ B @ ( image @ A @ B @ H2 @ F4 ) ) ) )).

% finite_imageI
thf(fact_113_surj__subtrOf,axiom,(
    ! [Tr: dtree,Tr2: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr ) )
       => ? [N3: n] :
            ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N3 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
            & ( ( gram_L1614515765ubtrOf @ Tr @ N3 )
              = Tr2 ) ) ) ) )).

% surj_subtrOf
thf(fact_114_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A8: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_115_subtrOf__root,axiom,(
    ! [Tr: dtree,Tr2: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr ) )
       => ( ( gram_L1614515765ubtrOf @ Tr @ ( root @ Tr2 ) )
          = Tr2 ) ) ) )).

% subtrOf_root
thf(fact_116_wf__inj,axiom,(
    ! [Tr: dtree,Tr1: dtree,Tr22: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr ) )
         => ( ( ( root @ Tr1 )
              = ( root @ Tr22 ) )
            = ( Tr1 = Tr22 ) ) ) ) ) )).

% wf_inj
thf(fact_117_wf__cont,axiom,(
    ! [Tr: dtree,Tr2: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr ) )
       => ( gram_L864798063lle_wf @ Tr2 ) ) ) )).

% wf_cont
thf(fact_118_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type @ A ) )
     => ! [A4: ( set @ A )] :
          ( finite_finite2 @ A @ A4 ) ) )).

% finite
thf(fact_119_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A4 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ? [X12: B] :
                ( P @ X3 @ X12 ) )
       => ? [F5: ( A > B )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A4 )
           => ( P @ X4 @ ( F5 @ X4 ) ) ) ) ) )).

% finite_set_choice
thf(fact_120_inFr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L805317441_inFr2 @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ! [Tr12: dtree,Tr4: dtree,Ns1: ( set @ n )] :
                ( ( A1
                  = ( insert @ n @ ( root @ Tr4 ) @ Ns1 ) )
               => ( ( A22 = Tr4 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
                   => ~ ( gram_L805317441_inFr2 @ Ns1 @ Tr12 @ A32 ) ) ) ) ) ) ) )).

% inFr2.cases
thf(fact_121_inFr2_Osimps,axiom,
    ( gram_L805317441_inFr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr3: dtree,Ns3: ( set @ n ),T4: t] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33 = T4 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr3 ) ) )
          | ? [Tr13: dtree,Tr3: dtree,Ns12: ( set @ n ),T4: t] :
              ( ( A12
                = ( insert @ n @ ( root @ Tr3 ) @ Ns12 ) )
              & ( A23 = Tr3 )
              & ( A33 = T4 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr3 ) )
              & ( gram_L805317441_inFr2 @ Ns12 @ Tr13 @ T4 ) ) ) ) )).

% inFr2.simps
thf(fact_122_inFr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L805317441_inFr2 @ X1 @ X22 @ X32 )
     => ( ! [Tr4: dtree,Ns2: ( set @ n ),T3: t] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr4 ) )
             => ( P @ Ns2 @ Tr4 @ T3 ) ) )
       => ( ! [Tr12: dtree,Tr4: dtree,Ns1: ( set @ n ),T3: t] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
             => ( ( gram_L805317441_inFr2 @ Ns1 @ Tr12 @ T3 )
               => ( ( P @ Ns1 @ Tr12 @ T3 )
                 => ( P @ ( insert @ n @ ( root @ Tr4 ) @ Ns1 ) @ Tr4 @ T3 ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inFr2.inducts
thf(fact_123_wf__inj__on,axiom,(
    ! [Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) )).

% wf_inj_on
thf(fact_124_insert__absorb2,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ X2 @ A4 ) )
      = ( insert @ A @ X2 @ A4 ) ) )).

% insert_absorb2
thf(fact_125_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A4 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A4 ) ) ) )).

% insert_iff
thf(fact_126_insertCI,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B3 )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertCI
thf(fact_127_insert__image,axiom,(
    ! [B: $tType,A: $tType,X2: A,A4: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X2 @ A4 )
     => ( ( insert @ B @ ( F @ X2 ) @ ( image @ A @ B @ F @ A4 ) )
        = ( image @ A @ B @ F @ A4 ) ) ) )).

% insert_image
thf(fact_128_image__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: B,B3: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( insert @ B @ A2 @ B3 ) )
      = ( insert @ A @ ( F @ A2 ) @ ( image @ B @ A @ F @ B3 ) ) ) )).

% image_insert
thf(fact_129_finite__insert,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A2 @ A4 ) )
      = ( finite_finite2 @ A @ A4 ) ) )).

% finite_insert
thf(fact_130_finite_OinsertI,axiom,(
    ! [A: $tType,A4: ( set @ A ),A2: A] :
      ( ( finite_finite2 @ A @ A4 )
     => ( finite_finite2 @ A @ ( insert @ A @ A2 @ A4 ) ) ) )).

% finite.insertI
thf(fact_131_inj__on__image__iff,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),G: ( A > B ),F: ( A > A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ! [Xa: A] :
              ( ( member @ A @ Xa @ A4 )
             => ( ( ( G @ ( F @ X3 ) )
                  = ( G @ ( F @ Xa ) ) )
                = ( ( G @ X3 )
                  = ( G @ Xa ) ) ) ) )
     => ( ( inj_on @ A @ A @ F @ A4 )
       => ( ( inj_on @ A @ B @ G @ ( image @ A @ A @ F @ A4 ) )
          = ( inj_on @ A @ B @ G @ A4 ) ) ) ) )).

% inj_on_image_iff
thf(fact_132_inj__img__insertE,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),X2: B,B3: ( set @ B )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ~ ( member @ B @ X2 @ B3 )
       => ( ( ( insert @ B @ X2 @ B3 )
            = ( image @ A @ B @ F @ A4 ) )
         => ~ ( ! [X6: A,A9: ( set @ A )] :
                  ( ~ ( member @ A @ X6 @ A9 )
                 => ( ( A4
                      = ( insert @ A @ X6 @ A9 ) )
                   => ( ( X2
                        = ( F @ X6 ) )
                     => ( B3
                       != ( image @ A @ B @ F @ A9 ) ) ) ) ) ) ) ) ) )).

% inj_img_insertE
thf(fact_133_inj__on__id,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( inj_on @ A @ A @ ( id @ A ) @ A4 ) )).

% inj_on_id
thf(fact_134_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ A4 )
     => ? [B8: ( set @ A )] :
          ( ( A4
            = ( insert @ A @ A2 @ B8 ) )
          & ~ ( member @ A @ A2 @ B8 ) ) ) )).

% mk_disjoint_insert
thf(fact_135_inj__on__inverseI,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),G: ( B > A ),F: ( A > B )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ( G @ ( F @ X3 ) )
            = X3 ) )
     => ( inj_on @ A @ B @ F @ A4 ) ) )).

% inj_on_inverseI
thf(fact_136_insert__commute,axiom,(
    ! [A: $tType,X2: A,Y: A,A4: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ Y @ A4 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X2 @ A4 ) ) ) )).

% insert_commute
thf(fact_137_inj__on__contraD,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),X2: A,Y: A] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( X2 != Y )
       => ( ( member @ A @ X2 @ A4 )
         => ( ( member @ A @ Y @ A4 )
           => ( ( F @ X2 )
             != ( F @ Y ) ) ) ) ) ) )).

% inj_on_contraD
thf(fact_138_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A ),B2: A,B3: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A4 )
     => ( ~ ( member @ A @ B2 @ B3 )
       => ( ( ( insert @ A @ A2 @ A4 )
            = ( insert @ A @ B2 @ B3 ) )
          = ( ( ( A2 = B2 )
             => ( A4 = B3 ) )
            & ( ( A2 != B2 )
             => ? [C3: ( set @ A )] :
                  ( ( A4
                    = ( insert @ A @ B2 @ C3 ) )
                  & ~ ( member @ A @ B2 @ C3 )
                  & ( B3
                    = ( insert @ A @ A2 @ C3 ) )
                  & ~ ( member @ A @ A2 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_139_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ A4 )
     => ( ( insert @ A @ A2 @ A4 )
        = A4 ) ) )).

% insert_absorb
thf(fact_140_inj__on__eq__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),X2: A,Y: A] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( member @ A @ X2 @ A4 )
       => ( ( member @ A @ Y @ A4 )
         => ( ( ( F @ X2 )
              = ( F @ Y ) )
            = ( X2 = Y ) ) ) ) ) )).

% inj_on_eq_iff
thf(fact_141_insert__ident,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A4 )
     => ( ~ ( member @ A @ X2 @ B3 )
       => ( ( ( insert @ A @ X2 @ A4 )
            = ( insert @ A @ X2 @ B3 ) )
          = ( A4 = B3 ) ) ) ) )).

% insert_ident
thf(fact_142_inj__on__cong,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [A7: A] :
          ( ( member @ A @ A7 @ A4 )
         => ( ( F @ A7 )
            = ( G @ A7 ) ) )
     => ( ( inj_on @ A @ B @ F @ A4 )
        = ( inj_on @ A @ B @ G @ A4 ) ) ) )).

% inj_on_cong
thf(fact_143_Set_Oset__insert,axiom,(
    ! [A: $tType,X2: A,A4: ( set @ A )] :
      ( ( member @ A @ X2 @ A4 )
     => ~ ( ! [B8: ( set @ A )] :
              ( ( A4
                = ( insert @ A @ X2 @ B8 ) )
             => ( member @ A @ X2 @ B8 ) ) ) ) )).

% Set.set_insert
thf(fact_144_inj__on__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( inj_on @ A @ B )
      = ( ^ [F6: ( A > B ),A8: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ A8 )
           => ! [Y3: A] :
                ( ( member @ A @ Y3 @ A8 )
               => ( ( ( F6 @ X )
                    = ( F6 @ Y3 ) )
                 => ( X = Y3 ) ) ) ) ) ) )).

% inj_on_def
thf(fact_145_insertI2,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B2: A] :
      ( ( member @ A @ A2 @ B3 )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertI2
thf(fact_146_insertI1,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B3 ) ) )).

% insertI1
thf(fact_147_insertE,axiom,(
    ! [A: $tType,A2: A,B2: A,A4: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A4 ) )
     => ( ( A2 != B2 )
       => ( member @ A @ A2 @ A4 ) ) ) )).

% insertE
thf(fact_148_inj__onI,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),F: ( A > B )] :
      ( ! [X3: A,Y2: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ( member @ A @ Y2 @ A4 )
           => ( ( ( F @ X3 )
                = ( F @ Y2 ) )
             => ( X3 = Y2 ) ) ) )
     => ( inj_on @ A @ B @ F @ A4 ) ) )).

% inj_onI
thf(fact_149_inj__onD,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),X2: A,Y: A] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( ( F @ X2 )
          = ( F @ Y ) )
       => ( ( member @ A @ X2 @ A4 )
         => ( ( member @ A @ Y @ A4 )
           => ( X2 = Y ) ) ) ) ) )).

% inj_onD
thf(fact_150_finite__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A4 ) )
     => ( ( inj_on @ B @ A @ F @ A4 )
       => ( finite_finite2 @ B @ A4 ) ) ) )).

% finite_imageD
thf(fact_151_finite__image__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F @ A4 ) )
        = ( finite_finite2 @ A @ A4 ) ) ) )).

% finite_image_iff
thf(fact_152_inFr__Ind__minus,axiom,(
    ! [Ns13: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns13 @ Tr1 @ T2 )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ ( insert @ n @ ( root @ Tr ) @ Ns13 ) @ Tr @ T2 ) ) ) )).

% inFr_Ind_minus
thf(fact_153_inFr2_OInd,axiom,(
    ! [Tr1: dtree,Tr: dtree,Ns13: ( set @ n ),T2: t] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
     => ( ( gram_L805317441_inFr2 @ Ns13 @ Tr1 @ T2 )
       => ( gram_L805317441_inFr2 @ ( insert @ n @ ( root @ Tr ) @ Ns13 ) @ Tr @ T2 ) ) ) )).

% inFr2.Ind
thf(fact_154_wf__subtr__inj__on,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) ) )).

% wf_subtr_inj_on
thf(fact_155_wf_Ocases,axiom,(
    ! [A2: dtree] :
      ( ( gram_L864798063lle_wf @ A2 )
     => ~ ( ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ A2 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ A2 ) ) ) @ gram_L1451583632elle_P )
         => ( ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ A2 ) ) )
           => ~ ( ! [Tr6: dtree] :
                    ( ( member @ dtree @ Tr6 @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ A2 ) ) )
                   => ( gram_L864798063lle_wf @ Tr6 ) ) ) ) ) ) )).

% wf.cases
thf(fact_156_wf_Osimps,axiom,
    ( gram_L864798063lle_wf
    = ( ^ [A10: dtree] :
        ? [Tr3: dtree] :
          ( ( A10 = Tr3 )
          & ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr3 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr3 ) ) ) @ gram_L1451583632elle_P )
          & ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr3 ) ) )
          & ! [X: dtree] :
              ( ( member @ dtree @ X @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr3 ) ) )
             => ( gram_L864798063lle_wf @ X ) ) ) ) )).

% wf.simps
thf(fact_157_wf__coind,axiom,(
    ! [Phi: ( dtree > $o ),Tr: dtree] :
      ( ( Phi @ Tr )
     => ( ! [Tr4: dtree] :
            ( ( Phi @ Tr4 )
           => ( ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr4 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr4 ) ) ) @ gram_L1451583632elle_P )
              & ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr4 ) ) )
              & ! [X3: dtree] :
                  ( ( member @ dtree @ X3 @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr4 ) ) )
                 => ( ( Phi @ X3 )
                    | ( gram_L864798063lle_wf @ X3 ) ) ) ) )
       => ( gram_L864798063lle_wf @ Tr ) ) ) )).

% wf_coind
thf(fact_158_inj__Inr,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A )] :
      ( inj_on @ A @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B ) @ A4 ) )).

% inj_Inr
thf(fact_159_inj__Inl,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A )] :
      ( inj_on @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A4 ) )).

% inj_Inl
thf(fact_160_subtr__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr32: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr32 )
       => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr32 ) ) ) )).

% subtr_trans
thf(fact_161_used,axiom,(
    ! [N4: n] :
    ? [Tns2: ( set @ ( sum_sum @ t @ n ) )] :
      ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ N4 @ Tns2 ) @ gram_L1451583632elle_P ) )).

% used
thf(fact_162_finite__in__P,axiom,(
    ! [N4: n,Tns: ( set @ ( sum_sum @ t @ n ) )] :
      ( ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ N4 @ Tns ) @ gram_L1451583632elle_P )
     => ( finite_finite2 @ ( sum_sum @ t @ n ) @ Tns ) ) )).

% finite_in_P
thf(fact_163_subtr__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr_rootR_in
thf(fact_164_subtr__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr_rootL_in
thf(fact_165_subtr_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L716654942_subtr @ Ns @ Tr @ Tr ) ) )).

% subtr.Refl
thf(fact_166_wf__subtr,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L864798063lle_wf @ Tr ) ) ) )).

% wf_subtr
thf(fact_167_subtr__inFr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Tr1: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 ) ) ) )).

% subtr_inFr
thf(fact_168_wf__subtr__P,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) ) @ gram_L1451583632elle_P ) ) ) )).

% wf_subtr_P
thf(fact_169_subtr__inductL,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Phi: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ! [Ns2: ( set @ n ),Tr4: dtree] :
            ( Phi @ Ns2 @ Tr4 @ Tr4 )
       => ( ! [Ns2: ( set @ n ),Tr12: dtree,Tr23: dtree,Tr33: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns2 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
               => ( ( gram_L716654942_subtr @ Ns2 @ Tr23 @ Tr33 )
                 => ( ( Phi @ Ns2 @ Tr23 @ Tr33 )
                   => ( Phi @ Ns2 @ Tr12 @ Tr33 ) ) ) ) )
         => ( Phi @ Ns @ Tr1 @ Tr22 ) ) ) ) )).

% subtr_inductL
thf(fact_170_subtr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ X1 @ X22 @ X32 )
     => ( ! [Tr4: dtree,Ns2: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
           => ( P @ Ns2 @ Tr4 @ Tr4 ) )
       => ( ! [Tr33: dtree,Ns2: ( set @ n ),Tr12: dtree,Tr23: dtree] :
              ( ( member @ n @ ( root @ Tr33 ) @ Ns2 )
             => ( ( gram_L716654942_subtr @ Ns2 @ Tr12 @ Tr23 )
               => ( ( P @ Ns2 @ Tr12 @ Tr23 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ Tr33 ) )
                   => ( P @ Ns2 @ Tr12 @ Tr33 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr.inducts
thf(fact_171_subtr__StepL,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr22: dtree,Tr32: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr22 ) )
       => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr32 )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr32 ) ) ) ) )).

% subtr_StepL
thf(fact_172_subtr_Osimps,axiom,
    ( gram_L716654942_subtr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr3: dtree,Ns3: ( set @ n )] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33 = Tr3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 ) )
          | ? [Tr34: dtree,Ns3: ( set @ n ),Tr13: dtree,Tr24: dtree] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr13 )
              & ( A33 = Tr34 )
              & ( member @ n @ ( root @ Tr34 ) @ Ns3 )
              & ( gram_L716654942_subtr @ Ns3 @ Tr13 @ Tr24 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr24 ) @ ( cont @ Tr34 ) ) ) ) ) )).

% subtr.simps
thf(fact_173_subtr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L716654942_subtr @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A32 ) @ A1 )
           => ! [Tr23: dtree] :
                ( ( gram_L716654942_subtr @ A1 @ A22 @ Tr23 )
               => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ A32 ) ) ) ) ) ) )).

% subtr.cases
thf(fact_174_subtr_OStep,axiom,(
    ! [Tr32: dtree,Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( member @ n @ ( root @ Tr32 ) @ Ns )
     => ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr32 ) )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr32 ) ) ) ) )).

% subtr.Step
thf(fact_175_inFr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ? [Tr7: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr7 @ Tr )
          & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr7 ) ) ) ) )).

% inFr_subtr
thf(fact_176_wf__P,axiom,(
    ! [Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) ) @ gram_L1451583632elle_P ) ) )).

% wf_P
thf(fact_177_wf__raw__coind,axiom,(
    ! [Phi: ( dtree > $o ),Tr: dtree] :
      ( ( Phi @ Tr )
     => ( ! [Tr4: dtree] :
            ( ( Phi @ Tr4 )
           => ( ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr4 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr4 ) ) ) @ gram_L1451583632elle_P )
              & ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr4 ) ) )
              & ! [X3: dtree] :
                  ( ( member @ dtree @ X3 @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr4 ) ) )
                 => ( Phi @ X3 ) ) ) )
       => ( gram_L864798063lle_wf @ Tr ) ) ) )).

% wf_raw_coind
thf(fact_178_wf_Ocoinduct,axiom,(
    ! [X7: ( dtree > $o ),X2: dtree] :
      ( ( X7 @ X2 )
     => ( ! [X3: dtree] :
            ( ( X7 @ X3 )
           => ? [Tr8: dtree] :
                ( ( X3 = Tr8 )
                & ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr8 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr8 ) ) ) @ gram_L1451583632elle_P )
                & ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr8 ) ) )
                & ! [Xa: dtree] :
                    ( ( member @ dtree @ Xa @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr8 ) ) )
                   => ( ( X7 @ Xa )
                      | ( gram_L864798063lle_wf @ Xa ) ) ) ) )
       => ( gram_L864798063lle_wf @ X2 ) ) ) )).

% wf.coinduct
thf(fact_179_wf_Ointros,axiom,(
    ! [Tr: dtree] :
      ( ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ ( root @ Tr ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) ) @ gram_L1451583632elle_P )
     => ( ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) )
       => ( ! [Tr7: dtree] :
              ( ( member @ dtree @ Tr7 @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) )
             => ( gram_L864798063lle_wf @ Tr7 ) )
         => ( gram_L864798063lle_wf @ Tr ) ) ) ) )).

% wf.intros
thf(fact_180_S__P,axiom,(
    ! [N4: n] :
      ( member @ ( product_prod @ n @ ( set @ ( sum_sum @ t @ n ) ) ) @ ( product_Pair @ n @ ( set @ ( sum_sum @ t @ n ) ) @ N4 @ ( gram_L1451583635elle_S @ N4 ) ) @ gram_L1451583632elle_P ) )).

% S_P
thf(fact_181_inItr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: n,P: ( ( set @ n ) > dtree > n > $o )] :
      ( ( gram_L830233218_inItr @ X1 @ X22 @ X32 )
     => ( ! [Tr4: dtree,Ns2: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
           => ( P @ Ns2 @ Tr4 @ ( root @ Tr4 ) ) )
       => ( ! [Tr4: dtree,Ns2: ( set @ n ),Tr12: dtree,N3: n] :
              ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr4 ) )
               => ( ( gram_L830233218_inItr @ Ns2 @ Tr12 @ N3 )
                 => ( ( P @ Ns2 @ Tr12 @ N3 )
                   => ( P @ Ns2 @ Tr4 @ N3 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inItr.inducts
thf(fact_182_inItr_Osimps,axiom,
    ( gram_L830233218_inItr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: n] :
          ( ? [Tr3: dtree,Ns3: ( set @ n )] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33
                = ( root @ Tr3 ) )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 ) )
          | ? [Tr3: dtree,Ns3: ( set @ n ),Tr13: dtree,N2: n] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33 = N2 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr3 ) )
              & ( gram_L830233218_inItr @ Ns3 @ Tr13 @ N2 ) ) ) ) )).

% inItr.simps
thf(fact_183_finite__S,axiom,(
    ! [N4: n] :
      ( finite_finite2 @ ( sum_sum @ t @ n ) @ ( gram_L1451583635elle_S @ N4 ) ) )).

% finite_S
thf(fact_184_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_185_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N4: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N4 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_186_subtr__inItr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N4: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N4 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L830233218_inItr @ Ns @ Tr1 @ N4 ) ) ) )).

% subtr_inItr
thf(fact_187_inItr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N4: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N4 )
     => ? [Tr7: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr7 @ Tr )
          & ( ( root @ Tr7 )
            = N4 ) ) ) )).

% inItr_subtr
thf(fact_188_inItr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,N4: n] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L830233218_inItr @ Ns @ Tr1 @ N4 )
         => ( gram_L830233218_inItr @ Ns @ Tr @ N4 ) ) ) ) )).

% inItr.Ind
thf(fact_189_inItr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: n] :
      ( ( gram_L830233218_inItr @ A1 @ A22 @ A32 )
     => ( ( ( A32
            = ( root @ A22 ) )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L830233218_inItr @ A1 @ Tr12 @ A32 ) ) ) ) ) )).

% inItr.cases
thf(fact_190_cont__deftr,axiom,(
    ! [N4: n] :
      ( ( cont @ ( gram_L1231612515_deftr @ N4 ) )
      = ( image @ ( sum_sum @ t @ n ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ n @ dtree @ ( id @ t ) @ gram_L1231612515_deftr ) @ ( gram_L1451583635elle_S @ N4 ) ) ) )).

% cont_deftr
thf(fact_191_subtr2_OStep,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr22: dtree,Tr32: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr22 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr22 @ Tr32 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr32 ) ) ) ) )).

% subtr2.Step
thf(fact_192_subtr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L1283001940subtr2 @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr23: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ A22 ) @ ( cont @ Tr23 ) )
               => ~ ( gram_L1283001940subtr2 @ A1 @ Tr23 @ A32 ) ) ) ) ) )).

% subtr2.cases
thf(fact_193_root__deftr,axiom,(
    ! [N4: n] :
      ( ( root @ ( gram_L1231612515_deftr @ N4 ) )
      = N4 ) )).

% root_deftr
thf(fact_194_subtr__subtr2,axiom,(
    gram_L716654942_subtr = gram_L1283001940subtr2 )).

% subtr_subtr2
thf(fact_195_subtr2__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr32: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L1283001940subtr2 @ Ns @ Tr22 @ Tr32 )
       => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr32 ) ) ) )).

% subtr2_trans
thf(fact_196_subtr2_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L1283001940subtr2 @ Ns @ Tr @ Tr ) ) )).

% subtr2.Refl
thf(fact_197_subtr2__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr2_rootL_in
thf(fact_198_subtr2__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr2_rootR_in
thf(fact_199_wf__deftr,axiom,(
    ! [N4: n] :
      ( gram_L864798063lle_wf @ ( gram_L1231612515_deftr @ N4 ) ) )).

% wf_deftr
thf(fact_200_deftr__def,axiom,
    ( gram_L1231612515_deftr
    = ( unfold @ n @ ( id @ n ) @ gram_L1451583635elle_S ) )).

% deftr_def
thf(fact_201_subtr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L1283001940subtr2 @ X1 @ X22 @ X32 )
     => ( ! [Tr4: dtree,Ns2: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr4 ) @ Ns2 )
           => ( P @ Ns2 @ Tr4 @ Tr4 ) )
       => ( ! [Tr12: dtree,Ns2: ( set @ n ),Tr23: dtree,Tr33: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns2 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
               => ( ( gram_L1283001940subtr2 @ Ns2 @ Tr23 @ Tr33 )
                 => ( ( P @ Ns2 @ Tr23 @ Tr33 )
                   => ( P @ Ns2 @ Tr12 @ Tr33 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr2.inducts
thf(fact_202_subtr2__StepR,axiom,(
    ! [Tr32: dtree,Ns: ( set @ n ),Tr22: dtree,Tr1: dtree] :
      ( ( member @ n @ ( root @ Tr32 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr32 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr32 ) ) ) ) )).

% subtr2_StepR
thf(fact_203_subtr2_Osimps,axiom,
    ( gram_L1283001940subtr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr3: dtree,Ns3: ( set @ n )] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr3 )
              & ( A33 = Tr3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns3 ) )
          | ? [Tr13: dtree,Ns3: ( set @ n ),Tr24: dtree,Tr34: dtree] :
              ( ( A12 = Ns3 )
              & ( A23 = Tr13 )
              & ( A33 = Tr34 )
              & ( member @ n @ ( root @ Tr13 ) @ Ns3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr24 ) )
              & ( gram_L1283001940subtr2 @ Ns3 @ Tr24 @ Tr34 ) ) ) ) )).

% subtr2.simps
thf(fact_204_root__o__subst,axiom,
    ( ( comp @ dtree @ n @ dtree @ root @ ( gram_L1004374585hsubst @ tr0 ) )
    = root )).

% root_o_subst
thf(fact_205_inf__img__fin__dom,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A4 ) )
     => ( ~ ( finite_finite2 @ B @ A4 )
       => ? [X3: A] :
            ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A4 ) )
            & ~ ( finite_finite2 @ B @ ( vimage @ B @ A @ F @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )).

% inf_img_fin_dom
thf(fact_206_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% empty_Collect_eq
thf(fact_207_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% Collect_empty_eq
thf(fact_208_all__not__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ! [X: A] :
            ~ ( member @ A @ X @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_209_empty__iff,axiom,(
    ! [A: $tType,C4: A] :
      ~ ( member @ A @ C4 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_210_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F6: ( B > A ),G3: ( C > B ),X: C] :
            ( F6 @ ( G3 @ X ) ) ) ) )).

% comp_apply
thf(fact_211_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_212_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_213_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_214_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_215_inj__on__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( inj_on @ A @ B @ F @ ( bot_bot @ ( set @ A ) ) ) )).

% inj_on_empty
thf(fact_216_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_217_comp__id,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( comp @ A @ B @ A @ F @ ( id @ A ) )
      = F ) )).

% comp_id
thf(fact_218_id__comp,axiom,(
    ! [B: $tType,A: $tType,G: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G )
      = G ) )).

% id_comp
thf(fact_219_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_220_comp__inj__on__iff,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),F7: ( B > C )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ B @ C @ F7 @ ( image @ A @ B @ F @ A4 ) )
        = ( inj_on @ A @ C @ ( comp @ B @ C @ A @ F7 @ F ) @ A4 ) ) ) )).

% comp_inj_on_iff
thf(fact_221_inj__on__imageI,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( C > B ),F: ( A > C ),A4: ( set @ A )] :
      ( ( inj_on @ A @ B @ ( comp @ C @ B @ A @ G @ F ) @ A4 )
     => ( inj_on @ C @ B @ G @ ( image @ A @ C @ F @ A4 ) ) ) )).

% inj_on_imageI
thf(fact_222_comp__inj__on,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),G: ( B > C )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ B @ C @ G @ ( image @ A @ B @ F @ A4 ) )
       => ( inj_on @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ A4 ) ) ) )).

% comp_inj_on
thf(fact_223_map__sum_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,E2: $tType,C: $tType,B: $tType,A: $tType,F: ( C > E2 ),G: ( D > F3 ),H2: ( A > C ),I: ( B > D ),Sum: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ C @ E2 @ D @ F3 @ F @ G @ ( sum_map_sum @ A @ C @ B @ D @ H2 @ I @ Sum ) )
      = ( sum_map_sum @ A @ E2 @ B @ F3 @ ( comp @ C @ E2 @ A @ F @ H2 ) @ ( comp @ D @ F3 @ B @ G @ I ) @ Sum ) ) )).

% map_sum.compositionality
thf(fact_224_sum_Omap__comp,axiom,(
    ! [D: $tType,F3: $tType,E2: $tType,C: $tType,B: $tType,A: $tType,G1: ( C > E2 ),G22: ( D > F3 ),F1: ( A > C ),F2: ( B > D ),V: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ C @ E2 @ D @ F3 @ G1 @ G22 @ ( sum_map_sum @ A @ C @ B @ D @ F1 @ F2 @ V ) )
      = ( sum_map_sum @ A @ E2 @ B @ F3 @ ( comp @ C @ E2 @ A @ G1 @ F1 ) @ ( comp @ D @ F3 @ B @ G22 @ F2 ) @ V ) ) )).

% sum.map_comp
thf(fact_225_map__sum_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E2: $tType,F3: $tType,D: $tType,B: $tType,F: ( C > E2 ),G: ( D > F3 ),H2: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( sum_sum @ C @ D ) @ ( sum_sum @ E2 @ F3 ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ C @ E2 @ D @ F3 @ F @ G ) @ ( sum_map_sum @ A @ C @ B @ D @ H2 @ I ) )
      = ( sum_map_sum @ A @ E2 @ B @ F3 @ ( comp @ C @ E2 @ A @ F @ H2 ) @ ( comp @ D @ F3 @ B @ G @ I ) ) ) )).

% map_sum.comp
thf(fact_226_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A4: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A4 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) )).

% Inf.INF_image
thf(fact_227_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A4: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A4 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) )).

% Sup.SUP_image
thf(fact_228_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),R: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G @ R ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F @ G ) @ R ) ) )).

% image_comp
thf(fact_229_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( B > A ),A4: ( set @ B ),G: ( C > A ),B3: ( set @ C ),H2: ( A > D )] :
      ( ( ( image @ B @ A @ F @ A4 )
        = ( image @ C @ A @ G @ B3 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H2 @ F ) @ A4 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H2 @ G ) @ B3 ) ) ) )).

% image_eq_imp_comp
thf(fact_230_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__o__subst,axiom,(
    ! [Tr0: dtree] :
      ( ( comp @ dtree @ n @ dtree @ root @ ( gram_L1004374585hsubst @ Tr0 ) )
      = root ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_o_subst
thf(fact_231_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A4: ( set @ A )] :
      ( ! [A11: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A11 )
         => ( P @ A11 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F8: ( set @ A )] :
              ( ( finite_finite2 @ A @ F8 )
             => ( ~ ( member @ A @ X3 @ F8 )
               => ( ( P @ F8 )
                 => ( P @ ( insert @ A @ X3 @ F8 ) ) ) ) )
         => ( P @ A4 ) ) ) ) )).

% infinite_finite_induct
thf(fact_232_finite__ne__induct,axiom,(
    ! [A: $tType,F4: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( ( F4
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A] :
              ( P @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X3: A,F8: ( set @ A )] :
                ( ( finite_finite2 @ A @ F8 )
               => ( ( F8
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X3 @ F8 )
                   => ( ( P @ F8 )
                     => ( P @ ( insert @ A @ X3 @ F8 ) ) ) ) ) )
           => ( P @ F4 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_233_finite_Oinducts,axiom,(
    ! [A: $tType,X2: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A11: ( set @ A ),A7: A] :
              ( ( finite_finite2 @ A @ A11 )
             => ( ( P @ A11 )
               => ( P @ ( insert @ A @ A7 @ A11 ) ) ) )
         => ( P @ X2 ) ) ) ) )).

% finite.inducts
thf(fact_234_finite__induct,axiom,(
    ! [A: $tType,F4: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F8: ( set @ A )] :
              ( ( finite_finite2 @ A @ F8 )
             => ( ~ ( member @ A @ X3 @ F8 )
               => ( ( P @ F8 )
                 => ( P @ ( insert @ A @ X3 @ F8 ) ) ) ) )
         => ( P @ F4 ) ) ) ) )).

% finite_induct
thf(fact_235_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A10: ( set @ A )] :
            ( ( A10
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A8: ( set @ A ),B9: A] :
                ( ( A10
                  = ( insert @ A @ B9 @ A8 ) )
                & ( finite_finite2 @ A @ A8 ) ) ) ) ) )).

% finite.simps
thf(fact_236_finite_Ocases,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ( A2
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A11: ( set @ A )] :
                ( ? [A7: A] :
                    ( A2
                    = ( insert @ A @ A7 @ A11 ) )
               => ~ ( finite_finite2 @ A @ A11 ) ) ) ) ) )).

% finite.cases
thf(fact_237_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B2 ) ) )).

% singleton_inject
thf(fact_238_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A4: ( set @ A )] :
      ( ( insert @ A @ A2 @ A4 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_239_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,C4: A,D3: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C4 @ ( insert @ A @ D3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C4 )
          & ( B2 = D3 ) )
        | ( ( A2 = D3 )
          & ( B2 = C4 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_240_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A2 ) ) )).

% singleton_iff
thf(fact_241_singletonD,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A2 ) ) )).

% singletonD
thf(fact_242_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_243_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),G: ( A > B ),X2: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X2 ) )
        = X2 ) ) )).

% pointfree_idE
thf(fact_244_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C4: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C4 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C4 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_245_vimage__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( B > C ),X2: ( set @ C )] :
      ( ( vimage @ A @ B @ F @ ( vimage @ B @ C @ G @ X2 ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ X2 ) ) )).

% vimage_comp
thf(fact_246_set_Ocompositionality,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( C > B ),G: ( B > A ),Set: ( set @ A )] :
      ( ( vimage @ C @ B @ F @ ( vimage @ B @ A @ G @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ Set ) ) )).

% set.compositionality
thf(fact_247_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E2: $tType,D: $tType,A: $tType,G: ( C > B ),H2: ( A > C ),R1: ( D > B ),R2: ( A > D ),F: ( B > E2 ),L: ( D > E2 )] :
      ( ( ( comp @ C @ B @ A @ G @ H2 )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E2 @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E2 @ A @ ( comp @ B @ E2 @ C @ F @ G ) @ H2 )
          = ( comp @ D @ E2 @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_248_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E2: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H2: ( E2 > A ),R: ( E2 > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E2 @ L2 @ H2 )
          = R )
       => ( ( comp @ C @ B @ E2 @ F @ ( comp @ A @ C @ E2 @ G @ H2 ) )
          = ( comp @ D @ B @ E2 @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_249_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H2: ( A > C ),R: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H2 )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H2 )
        = ( comp @ B @ D @ A @ F @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_250_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H2: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H2 ) )
        = ( comp @ A @ B @ D @ L @ H2 ) ) ) )).

% rewriteL_comp_comp
thf(fact_251_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_252_set_Ocomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),G: ( B > A )] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F ) @ ( vimage @ B @ A @ G ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) ) ) )).

% set.comp
thf(fact_253_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C4: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C4 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C4 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_254_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C4: ( D > B ),D3: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C4 @ D3 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C4 @ ( D3 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_255_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C4: ( D > B ),D3: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C4 @ D3 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C4 @ ( D3 @ V ) ) ) ) )).

% comp_eq_dest

%----Type constructors (5)
thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A5: $tType,A13: $tType] :
      ( ( ( finite_finite @ A5 @ ( type @ A5 ) )
        & ( finite_finite @ A13 @ ( type @ A13 ) ) )
     => ( finite_finite @ ( A5 > A13 ) @ ( type @ ( A5 > A13 ) ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_1,axiom,(
    ! [A5: $tType] :
      ( ( finite_finite @ A5 @ ( type @ A5 ) )
     => ( finite_finite @ ( set @ A5 ) @ ( type @ ( set @ A5 ) ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_2,axiom,
    ( finite_finite @ $o @ ( type @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_3,axiom,(
    ! [A5: $tType,A13: $tType] :
      ( ( ( finite_finite @ A5 @ ( type @ A5 ) )
        & ( finite_finite @ A13 @ ( type @ A13 ) ) )
     => ( finite_finite @ ( sum_sum @ A5 @ A13 ) @ ( type @ ( sum_sum @ A5 @ A13 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_4,axiom,(
    ! [A5: $tType,A13: $tType] :
      ( ( ( finite_finite @ A5 @ ( type @ A5 ) )
        & ( finite_finite @ A13 @ ( type @ A13 ) ) )
     => ( finite_finite @ ( product_prod @ A5 @ A13 ) @ ( type @ ( product_prod @ A5 @ A13 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ tr0 ) ) @ ( cont @ tr ) ) )
    = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ tr ) ) )).

%------------------------------------------------------------------------------
