%------------------------------------------------------------------------------
% File     : COM188^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 619
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__619.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  319 (   1 unit;  54 type;   0 defn)
%            Number of atoms       : 4548 ( 320 equality;2518 variable)
%            Maximal formula depth :   22 (  10 average)
%            Number of connectives : 4052 ( 105   ~;  15   |;  75   &;3563   @)
%                                         (   0 <=>; 294  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  260 ( 260   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   58 (  54   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1096 (   7 sgn; 936   !;  48   ?;  75   ^)
%                                         (1096   :;  35  !>;   0  ?*)
%                                         (   0  @-;   2  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:43:44.227
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (48)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Def_Ocollect,type,(
    bNF_collect: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( B > ( set @ A ) ) ) > B > ( set @ A ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Ouniv,type,(
    bNF_Greatest_univ: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( set @ B ) > A ) )).

thf(sy_c_Basic__BNFs_Osetl,type,(
    basic_setl: 
      !>[A: $tType,B: $tType] :
        ( ( sum_sum @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oinj__on,type,(
    inj_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OFrr,type,(
    gram_L1556062726le_Frr: ( set @ n ) > dtree > ( set @ t ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Odeftr,type,(
    gram_L1231612515_deftr: n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst,type,(
    gram_L1004374585hsubst: dtree > dtree > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c,type,(
    gram_L1905609002ubst_c: dtree > dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__r,type,(
    gram_L1905609017ubst_r: dtree > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFrr,type,(
    gram_L805317505_inFrr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr2,type,(
    gram_L1283001940subtr2: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OsubtrOf,type,(
    gram_L1614515765ubtrOf: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Owf,type,(
    gram_L864798063lle_wf: dtree > $o )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_ns,type,(
    ns: ( set @ n ) )).

thf(sy_v_nsa____,type,(
    nsa: ( set @ n ) )).

thf(sy_v_t,type,(
    t2: t )).

thf(sy_v_ta____,type,(
    ta: t )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

thf(sy_v_tr,type,(
    tr: dtree )).

thf(sy_v_tr0,type,(
    tr0: dtree )).

thf(sy_v_tr1_H____,type,(
    tr1: dtree )).

thf(sy_v_tr1a____,type,(
    tr1a: dtree )).

thf(sy_v_tra____,type,(
    tra: dtree )).

%----Relevant facts (256)
thf(fact_0_tr1_H__tr1,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr1 ) @ ( cont @ tr1a ) )).

% tr1'_tr1
thf(fact_1_tr1,axiom,
    ( tr1a
    = ( gram_L1004374585hsubst @ tr0 @ tra ) )).

% tr1
thf(fact_2_wf__hsubst,axiom,(
    ! [Tr: dtree] :
      ( ( gram_L864798063lle_wf @ tr0 )
     => ( ( gram_L864798063lle_wf @ Tr )
       => ( gram_L864798063lle_wf @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) ) ) )).

% wf_hsubst
thf(fact_3_assms,axiom,
    ( gram_L1333338417e_inFr @ ns @ ( gram_L1004374585hsubst @ tr0 @ tr ) @ t2 )).

% assms
thf(fact_4_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% sum.inject(2)
thf(fact_5_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B3: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B3 ) )
      = ( B2 = B3 ) ) )).

% old.sum.inject(2)
thf(fact_6_hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( gram_L1004374585hsubst @ tr0 @ Tr )
        = ( gram_L1004374585hsubst @ tr0 @ tr0 ) ) ) )).

% hsubst_eq
thf(fact_7_hsubst__def,axiom,
    ( ( gram_L1004374585hsubst @ tr0 )
    = ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ tr0 ) ) )).

% hsubst_def
thf(fact_8_t__tr1_H,axiom,
    ( gram_L1333338417e_inFr @ nsa @ tr1 @ ta )).

% t_tr1'
thf(fact_9_True,axiom,
    ( ( root @ tr1a )
    = ( root @ tr0 ) )).

% True
thf(fact_10_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_11_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( X != Y )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_12_root__hsubst,axiom,(
    ! [Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ tr0 @ Tr ) )
      = ( root @ Tr ) ) )).

% root_hsubst
thf(fact_13_hsubst__c__def,axiom,(
    ! [Tr: dtree] :
      ( ( ( ( root @ Tr )
          = ( root @ tr0 ) )
       => ( ( gram_L1905609002ubst_c @ tr0 @ Tr )
          = ( cont @ tr0 ) ) )
      & ( ( ( root @ Tr )
         != ( root @ tr0 ) )
       => ( ( gram_L1905609002ubst_c @ tr0 @ Tr )
          = ( cont @ Tr ) ) ) ) )).

% hsubst_c_def
thf(fact_14_Ind_Ohyps_I1_J,axiom,
    ( member @ n @ ( root @ tr1a ) @ nsa )).

% Ind.hyps(1)
thf(fact_15_rtr1,axiom,
    ( ( root @ tr1a )
    = ( root @ tra ) )).

% rtr1
thf(fact_16_wf__inj,axiom,(
    ! [Tr: dtree,Tr1: dtree,Tr2: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr ) )
         => ( ( ( root @ Tr1 )
              = ( root @ Tr2 ) )
            = ( Tr1 = Tr2 ) ) ) ) ) )).

% wf_inj
thf(fact_17_hsubst__r__def,axiom,(
    gram_L1905609017ubst_r = root )).

% hsubst_r_def
thf(fact_18_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_19_not__root__inFr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ~ ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) )).

% not_root_inFr
thf(fact_20_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c__def,axiom,
    ( gram_L1905609002ubst_c
    = ( ^ [Tr0: dtree,Tr3: dtree] :
          ( if @ ( set @ ( sum_sum @ t @ dtree ) )
          @ ( ( root @ Tr3 )
            = ( root @ Tr0 ) )
          @ ( cont @ Tr0 )
          @ ( cont @ Tr3 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.hsubst_c_def
thf(fact_21_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__def,axiom,
    ( gram_L1004374585hsubst
    = ( ^ [Tr0: dtree] :
          ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ Tr0 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.hsubst_def
thf(fact_22_inFr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 )
         => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr.Ind
thf(fact_23_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__hsubst,axiom,(
    ! [Tr02: dtree,Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ Tr02 @ Tr ) )
      = ( root @ Tr ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_hsubst
thf(fact_24_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__eq,axiom,(
    ! [Tr: dtree,Tr02: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr02 ) )
     => ( ( gram_L1004374585hsubst @ Tr02 @ Tr )
        = ( gram_L1004374585hsubst @ Tr02 @ Tr02 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.hsubst_eq
thf(fact_25_Gram__Lang__Mirabelle__ojxrtuoybn_Owf__hsubst,axiom,(
    ! [Tr02: dtree,Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr02 )
     => ( ( gram_L864798063lle_wf @ Tr )
       => ( gram_L864798063lle_wf @ ( gram_L1004374585hsubst @ Tr02 @ Tr ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.wf_hsubst
thf(fact_26_wf__cont,axiom,(
    ! [Tr: dtree,Tr4: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr4 ) @ ( cont @ Tr ) )
       => ( gram_L864798063lle_wf @ Tr4 ) ) ) )).

% wf_cont
thf(fact_27_subtrOf__root,axiom,(
    ! [Tr: dtree,Tr4: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr4 ) @ ( cont @ Tr ) )
       => ( ( gram_L1614515765ubtrOf @ Tr @ ( root @ Tr4 ) )
          = Tr4 ) ) ) )).

% subtrOf_root
thf(fact_28_inFrr__def,axiom,
    ( gram_L805317505_inFrr
    = ( ^ [Ns2: ( set @ n ),Tr3: dtree,T3: t] :
        ? [Tr5: dtree] :
          ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr3 ) )
          & ( gram_L1333338417e_inFr @ Ns2 @ Tr5 @ T3 ) ) ) )).

% inFrr_def
thf(fact_29_finite__hsubst__c,axiom,(
    ! [N: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( gram_L1905609002ubst_c @ tr0 @ N ) ) )).

% finite_hsubst_c
thf(fact_30_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_31_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F2: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F2 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_32_dtree__cong,axiom,(
    ! [Tr: dtree,Tr4: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr4 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr4 ) )
       => ( Tr = Tr4 ) ) ) )).

% dtree_cong
thf(fact_33_inFr2__Ind,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr1 @ T2 )
     => ( ( member @ n @ ( root @ Tr ) @ Ns )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
         => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr2_Ind
thf(fact_34_inItr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: n,P: ( ( set @ n ) > dtree > n > $o )] :
      ( ( gram_L830233218_inItr @ X1 @ X2 @ X3 )
     => ( ! [Tr6: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr6 ) @ Ns3 )
           => ( P @ Ns3 @ Tr6 @ ( root @ Tr6 ) ) )
       => ( ! [Tr6: dtree,Ns3: ( set @ n ),Tr12: dtree,N2: n] :
              ( ( member @ n @ ( root @ Tr6 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr6 ) )
               => ( ( gram_L830233218_inItr @ Ns3 @ Tr12 @ N2 )
                 => ( ( P @ Ns3 @ Tr12 @ N2 )
                   => ( P @ Ns3 @ Tr6 @ N2 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inItr.inducts
thf(fact_35_inItr_Osimps,axiom,
    ( gram_L830233218_inItr
    = ( ^ [A1: ( set @ n ),A2: dtree,A3: n] :
          ( ? [Tr3: dtree,Ns2: ( set @ n )] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr3 )
              & ( A3
                = ( root @ Tr3 ) )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 ) )
          | ? [Tr3: dtree,Ns2: ( set @ n ),Tr13: dtree,N3: n] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr3 )
              & ( A3 = N3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr3 ) )
              & ( gram_L830233218_inItr @ Ns2 @ Tr13 @ N3 ) ) ) ) )).

% inItr.simps
thf(fact_36_inItr_Ocases,axiom,(
    ! [A12: ( set @ n ),A22: dtree,A32: n] :
      ( ( gram_L830233218_inItr @ A12 @ A22 @ A32 )
     => ( ( ( A32
            = ( root @ A22 ) )
         => ~ ( member @ n @ ( root @ A22 ) @ A12 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A12 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L830233218_inItr @ A12 @ Tr12 @ A32 ) ) ) ) ) )).

% inItr.cases
thf(fact_37_inItr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,N: n] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L830233218_inItr @ Ns @ Tr1 @ N )
         => ( gram_L830233218_inItr @ Ns @ Tr @ N ) ) ) ) )).

% inItr.Ind
thf(fact_38_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_39_Gram__Lang__Mirabelle__ojxrtuoybn_Ofinite__hsubst__c,axiom,(
    ! [Tr02: dtree,N: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( gram_L1905609002ubst_c @ Tr02 @ N ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.finite_hsubst_c
thf(fact_40_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_41_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_42_inFr2__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr2_root_in
thf(fact_43_inFr__inFr2,axiom,(
    gram_L1333338417e_inFr = gram_L805317441_inFr2 )).

% inFr_inFr2
thf(fact_44_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A4: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A5: A,P: ( A > $o )] :
      ( ( member @ A @ A5 @ ( collect @ A @ P ) )
      = ( P @ A5 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A6 ) )
      = A6 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
          = ( Q @ X5 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X5: A] :
          ( ( F @ X5 )
          = ( G @ X5 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_50_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_51_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N: n,N4: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N @ As )
            = ( node @ N4 @ As2 ) )
          = ( ( N = N4 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_52_inFr2_OInd,axiom,(
    ! [Tr1: dtree,Tr: dtree,Ns1: ( set @ n ),T2: t] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
     => ( ( gram_L805317441_inFr2 @ Ns1 @ Tr1 @ T2 )
       => ( gram_L805317441_inFr2 @ ( insert @ n @ ( root @ Tr ) @ Ns1 ) @ Tr @ T2 ) ) ) )).

% inFr2.Ind
thf(fact_53_subtr2_OStep,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr2: dtree,Tr32: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr2 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr2 @ Tr32 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr32 ) ) ) ) )).

% subtr2.Step
thf(fact_54_subtr2_Ocases,axiom,(
    ! [A12: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L1283001940subtr2 @ A12 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A12 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A12 )
           => ! [Tr22: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ A22 ) @ ( cont @ Tr22 ) )
               => ~ ( gram_L1283001940subtr2 @ A12 @ Tr22 @ A32 ) ) ) ) ) )).

% subtr2.cases
thf(fact_55_subtr2_Osimps,axiom,
    ( gram_L1283001940subtr2
    = ( ^ [A1: ( set @ n ),A2: dtree,A3: dtree] :
          ( ? [Tr3: dtree,Ns2: ( set @ n )] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr3 )
              & ( A3 = Tr3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 ) )
          | ? [Tr13: dtree,Ns2: ( set @ n ),Tr23: dtree,Tr33: dtree] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr13 )
              & ( A3 = Tr33 )
              & ( member @ n @ ( root @ Tr13 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr23 ) )
              & ( gram_L1283001940subtr2 @ Ns2 @ Tr23 @ Tr33 ) ) ) ) )).

% subtr2.simps
thf(fact_56_subtr2__StepR,axiom,(
    ! [Tr32: dtree,Ns: ( set @ n ),Tr2: dtree,Tr1: dtree] :
      ( ( member @ n @ ( root @ Tr32 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr32 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr32 ) ) ) ) )).

% subtr2_StepR
thf(fact_57_finite__insert,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A5 @ A6 ) )
      = ( finite_finite2 @ A @ A6 ) ) )).

% finite_insert
thf(fact_58_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_59_finite_OinsertI,axiom,(
    ! [A: $tType,A6: ( set @ A ),A5: A] :
      ( ( finite_finite2 @ A @ A6 )
     => ( finite_finite2 @ A @ ( insert @ A @ A5 @ A6 ) ) ) )).

% finite.insertI
thf(fact_60_subtr2__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Tr32: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( ( gram_L1283001940subtr2 @ Ns @ Tr2 @ Tr32 )
       => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr32 ) ) ) )).

% subtr2_trans
thf(fact_61_subtr2_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L1283001940subtr2 @ Ns @ Tr @ Tr ) ) )).

% subtr2.Refl
thf(fact_62_subtr2__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr2_rootL_in
thf(fact_63_subtr2__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr2 ) @ Ns ) ) )).

% subtr2_rootR_in
thf(fact_64_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ A6 )
           => ? [X12: B] :
                ( P @ X5 @ X12 ) )
       => ? [F3: ( A > B )] :
          ! [X6: A] :
            ( ( member @ A @ X6 @ A6 )
           => ( P @ X6 @ ( F3 @ X6 ) ) ) ) ) )).

% finite_set_choice
thf(fact_65_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type @ A ) )
     => ! [A6: ( set @ A )] :
          ( finite_finite2 @ A @ A6 ) ) )).

% finite
thf(fact_66_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N2: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N2 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_67_inFr__Ind__minus,axiom,(
    ! [Ns1: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns1 @ Tr1 @ T2 )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ ( insert @ n @ ( root @ Tr ) @ Ns1 ) @ Tr @ T2 ) ) ) )).

% inFr_Ind_minus
thf(fact_68_subtr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L1283001940subtr2 @ X1 @ X2 @ X3 )
     => ( ! [Tr6: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr6 ) @ Ns3 )
           => ( P @ Ns3 @ Tr6 @ Tr6 ) )
       => ( ! [Tr12: dtree,Ns3: ( set @ n ),Tr22: dtree,Tr34: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr22 ) )
               => ( ( gram_L1283001940subtr2 @ Ns3 @ Tr22 @ Tr34 )
                 => ( ( P @ Ns3 @ Tr22 @ Tr34 )
                   => ( P @ Ns3 @ Tr12 @ Tr34 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% subtr2.inducts
thf(fact_69_insertCI,axiom,(
    ! [A: $tType,A5: A,B4: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A5 @ B4 )
       => ( A5 = B2 ) )
     => ( member @ A @ A5 @ ( insert @ A @ B2 @ B4 ) ) ) )).

% insertCI
thf(fact_70_insert__iff,axiom,(
    ! [A: $tType,A5: A,B2: A,A6: ( set @ A )] :
      ( ( member @ A @ A5 @ ( insert @ A @ B2 @ A6 ) )
      = ( ( A5 = B2 )
        | ( member @ A @ A5 @ A6 ) ) ) )).

% insert_iff
thf(fact_71_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A6 ) )
      = ( insert @ A @ X @ A6 ) ) )).

% insert_absorb2
thf(fact_72_inFr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L805317441_inFr2 @ X1 @ X2 @ X3 )
     => ( ! [Tr6: dtree,Ns3: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr6 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr6 ) )
             => ( P @ Ns3 @ Tr6 @ T4 ) ) )
       => ( ! [Tr12: dtree,Tr6: dtree,Ns12: ( set @ n ),T4: t] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr6 ) )
             => ( ( gram_L805317441_inFr2 @ Ns12 @ Tr12 @ T4 )
               => ( ( P @ Ns12 @ Tr12 @ T4 )
                 => ( P @ ( insert @ n @ ( root @ Tr6 ) @ Ns12 ) @ Tr6 @ T4 ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inFr2.inducts
thf(fact_73_inFr2_Osimps,axiom,
    ( gram_L805317441_inFr2
    = ( ^ [A1: ( set @ n ),A2: dtree,A3: t] :
          ( ? [Tr3: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr3 )
              & ( A3 = T3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr3 ) ) )
          | ? [Tr13: dtree,Tr3: dtree,Ns13: ( set @ n ),T3: t] :
              ( ( A1
                = ( insert @ n @ ( root @ Tr3 ) @ Ns13 ) )
              & ( A2 = Tr3 )
              & ( A3 = T3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr3 ) )
              & ( gram_L805317441_inFr2 @ Ns13 @ Tr13 @ T3 ) ) ) ) )).

% inFr2.simps
thf(fact_74_inFr2_Ocases,axiom,(
    ! [A12: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L805317441_inFr2 @ A12 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A12 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ! [Tr12: dtree,Tr6: dtree,Ns12: ( set @ n )] :
                ( ( A12
                  = ( insert @ n @ ( root @ Tr6 ) @ Ns12 ) )
               => ( ( A22 = Tr6 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr6 ) )
                   => ~ ( gram_L805317441_inFr2 @ Ns12 @ Tr12 @ A32 ) ) ) ) ) ) ) )).

% inFr2.cases
thf(fact_75_root__deftr,axiom,(
    ! [N: n] :
      ( ( root @ ( gram_L1231612515_deftr @ N ) )
      = N ) )).

% root_deftr
thf(fact_76_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_77_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A5: A,A7: A] :
      ( ( ( sum_Inl @ A @ B @ A5 )
        = ( sum_Inl @ A @ B @ A7 ) )
      = ( A5 = A7 ) ) )).

% old.sum.inject(1)
thf(fact_78_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F2: ( B > T ),A5: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F2 @ ( sum_Inl @ A @ B @ A5 ) )
      = ( F1 @ A5 ) ) )).

% old.sum.simps(7)
thf(fact_79_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_80_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X2 ) ) )).

% sum.distinct(1)
thf(fact_81_old_Osum_Odistinct_I2_J,axiom,(
    ! [B5: $tType,A8: $tType,B6: B5,A9: A8] :
      ( ( sum_Inr @ B5 @ A8 @ B6 )
     != ( sum_Inl @ A8 @ B5 @ A9 ) ) )).

% old.sum.distinct(2)
thf(fact_82_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A5: A,B3: B] :
      ( ( sum_Inl @ A @ B @ A5 )
     != ( sum_Inr @ B @ A @ B3 ) ) )).

% old.sum.distinct(1)
thf(fact_83_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X5: A] :
          ( S
         != ( sum_Inl @ A @ B @ X5 ) )
     => ~ ( ! [Y3: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y3 ) ) ) ) )).

% sumE
thf(fact_84_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A5: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A5 ) ) )).

% Inr_not_Inl
thf(fact_85_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X7: ( sum_sum @ A @ B )] :
            ( P2 @ X7 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X4: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X4 ) )
            | ? [X4: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% split_sum_ex
thf(fact_86_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X7: ( sum_sum @ A @ B )] :
            ( P2 @ X7 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X4: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X4 ) )
            & ! [X4: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% split_sum_all
thf(fact_87_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A10: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A10 ) )
     => ~ ( ! [B7: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B7 ) ) ) ) )).

% old.sum.exhaust
thf(fact_88_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A10: A] :
          ( P @ ( sum_Inl @ A @ B @ A10 ) )
     => ( ! [B7: B] :
            ( P @ ( sum_Inr @ B @ A @ B7 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_89_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X5: A] :
          ( S
         != ( sum_Inl @ A @ B @ X5 ) )
     => ~ ( ! [X5: B] :
              ( S
             != ( sum_Inr @ B @ A @ X5 ) ) ) ) )).

% obj_sumE
thf(fact_90_wf__deftr,axiom,(
    ! [N: n] :
      ( gram_L864798063lle_wf @ ( gram_L1231612515_deftr @ N ) ) )).

% wf_deftr
thf(fact_91_inFr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) )).

% inFr.Base
thf(fact_92_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_93_mk__disjoint__insert,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A )] :
      ( ( member @ A @ A5 @ A6 )
     => ? [B8: ( set @ A )] :
          ( ( A6
            = ( insert @ A @ A5 @ B8 ) )
          & ~ ( member @ A @ A5 @ B8 ) ) ) )).

% mk_disjoint_insert
thf(fact_94_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A6: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A6 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A6 ) ) ) )).

% insert_commute
thf(fact_95_insert__eq__iff,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A ),B2: A,B4: ( set @ A )] :
      ( ~ ( member @ A @ A5 @ A6 )
     => ( ~ ( member @ A @ B2 @ B4 )
       => ( ( ( insert @ A @ A5 @ A6 )
            = ( insert @ A @ B2 @ B4 ) )
          = ( ( ( A5 = B2 )
             => ( A6 = B4 ) )
            & ( ( A5 != B2 )
             => ? [C2: ( set @ A )] :
                  ( ( A6
                    = ( insert @ A @ B2 @ C2 ) )
                  & ~ ( member @ A @ B2 @ C2 )
                  & ( B4
                    = ( insert @ A @ A5 @ C2 ) )
                  & ~ ( member @ A @ A5 @ C2 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_96_insert__absorb,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A )] :
      ( ( member @ A @ A5 @ A6 )
     => ( ( insert @ A @ A5 @ A6 )
        = A6 ) ) )).

% insert_absorb
thf(fact_97_insert__ident,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X @ A6 )
     => ( ~ ( member @ A @ X @ B4 )
       => ( ( ( insert @ A @ X @ A6 )
            = ( insert @ A @ X @ B4 ) )
          = ( A6 = B4 ) ) ) ) )).

% insert_ident
thf(fact_98_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A )] :
      ( ( member @ A @ X @ A6 )
     => ~ ( ! [B8: ( set @ A )] :
              ( ( A6
                = ( insert @ A @ X @ B8 ) )
             => ( member @ A @ X @ B8 ) ) ) ) )).

% Set.set_insert
thf(fact_99_insertI2,axiom,(
    ! [A: $tType,A5: A,B4: ( set @ A ),B2: A] :
      ( ( member @ A @ A5 @ B4 )
     => ( member @ A @ A5 @ ( insert @ A @ B2 @ B4 ) ) ) )).

% insertI2
thf(fact_100_insertI1,axiom,(
    ! [A: $tType,A5: A,B4: ( set @ A )] :
      ( member @ A @ A5 @ ( insert @ A @ A5 @ B4 ) ) )).

% insertI1
thf(fact_101_insertE,axiom,(
    ! [A: $tType,A5: A,B2: A,A6: ( set @ A )] :
      ( ( member @ A @ A5 @ ( insert @ A @ B2 @ A6 ) )
     => ( ( A5 != B2 )
       => ( member @ A @ A5 @ A6 ) ) ) )).

% insertE
thf(fact_102_inFr_Ocases,axiom,(
    ! [A12: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L1333338417e_inFr @ A12 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A12 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A12 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L1333338417e_inFr @ A12 @ Tr12 @ A32 ) ) ) ) ) )).

% inFr.cases
thf(fact_103_inFr_Osimps,axiom,
    ( gram_L1333338417e_inFr
    = ( ^ [A1: ( set @ n ),A2: dtree,A3: t] :
          ( ? [Tr3: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr3 )
              & ( A3 = T3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr3 ) ) )
          | ? [Tr3: dtree,Ns2: ( set @ n ),Tr13: dtree,T3: t] :
              ( ( A1 = Ns2 )
              & ( A2 = Tr3 )
              & ( A3 = T3 )
              & ( member @ n @ ( root @ Tr3 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr3 ) )
              & ( gram_L1333338417e_inFr @ Ns2 @ Tr13 @ T3 ) ) ) ) )).

% inFr.simps
thf(fact_104_inFr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X2: dtree,X3: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L1333338417e_inFr @ X1 @ X2 @ X3 )
     => ( ! [Tr6: dtree,Ns3: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr6 ) @ Ns3 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr6 ) )
             => ( P @ Ns3 @ Tr6 @ T4 ) ) )
       => ( ! [Tr6: dtree,Ns3: ( set @ n ),Tr12: dtree,T4: t] :
              ( ( member @ n @ ( root @ Tr6 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr6 ) )
               => ( ( gram_L1333338417e_inFr @ Ns3 @ Tr12 @ T4 )
                 => ( ( P @ Ns3 @ Tr12 @ T4 )
                   => ( P @ Ns3 @ Tr6 @ T4 ) ) ) ) )
         => ( P @ X1 @ X2 @ X3 ) ) ) ) )).

% inFr.inducts
thf(fact_105_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_106_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_107_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X5: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X5 ) ) )
         => P )
     => ( ! [X5: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X5 ) ) )
           => P )
       => ! [X6: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X6 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_108_Inl__cont__hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ tr0 ) ) ) ) )).

% Inl_cont_hsubst_eq
thf(fact_109_Inl__cont__hsubst__neq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
       != ( root @ tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr ) ) ) ) )).

% Inl_cont_hsubst_neq
thf(fact_110_root__o__subst,axiom,
    ( ( comp @ dtree @ n @ dtree @ root @ ( gram_L1004374585hsubst @ tr0 ) )
    = root )).

% root_o_subst
thf(fact_111_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),B4: ( set @ B )] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ B4 ) )
      = ( member @ B @ ( F @ A5 ) @ B4 ) ) )).

% vimage_eq
thf(fact_112_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A5: B,B2: A,B4: ( set @ A )] :
      ( ( ( F @ A5 )
        = B2 )
     => ( ( member @ A @ B2 @ B4 )
       => ( member @ B @ A5 @ ( vimage @ B @ A @ F @ B4 ) ) ) ) )).

% vimageI
thf(fact_113_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ ( F @ X5 ) )
          = ( Q @ X5 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_114_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A5: B,A6: ( set @ A )] :
      ( ( member @ A @ ( F @ A5 ) @ A6 )
     => ( member @ B @ A5 @ ( vimage @ B @ A @ F @ A6 ) ) ) )).

% vimageI2
thf(fact_115_vimageE,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),B4: ( set @ B )] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ B4 ) )
     => ( member @ B @ ( F @ A5 ) @ B4 ) ) )).

% vimageE
thf(fact_116_vimageD,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),A6: ( set @ B )] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ A6 ) )
     => ( member @ B @ ( F @ A5 ) @ A6 ) ) )).

% vimageD
thf(fact_117_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_118_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_119_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_120_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_121_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__o__subst,axiom,(
    ! [Tr02: dtree] :
      ( ( comp @ dtree @ n @ dtree @ root @ ( gram_L1004374585hsubst @ Tr02 ) )
      = root ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_o_subst
thf(fact_122_Gram__Lang__Mirabelle__ojxrtuoybn_OInl__cont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr02: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr02 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr02 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inl_cont_hsubst_neq
thf(fact_123_Gram__Lang__Mirabelle__ojxrtuoybn_OInl__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr02: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr02 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr02 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr02 ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inl_cont_hsubst_eq
thf(fact_124_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ ( sum_sum @ A @ B ) ),B4: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A6 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B4 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A6 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B4 ) )
       => ( A6 = B4 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_125_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F4: ( B > A ),G2: ( C > B ),X4: C] :
            ( F4 @ ( G2 @ X4 ) ) ) ) )).

% comp_apply
thf(fact_126_set_Ocomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),G: ( B > A )] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F ) @ ( vimage @ B @ A @ G ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) ) ) )).

% set.comp
thf(fact_127_vimage__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( B > C ),X: ( set @ C )] :
      ( ( vimage @ A @ B @ F @ ( vimage @ B @ C @ G @ X ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ X ) ) )).

% vimage_comp
thf(fact_128_set_Ocompositionality,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( C > B ),G: ( B > A ),Set: ( set @ A )] :
      ( ( vimage @ C @ B @ F @ ( vimage @ B @ A @ G @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ Set ) ) )).

% set.compositionality
thf(fact_129_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A5: ( C > B ),B2: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A5 @ B2 )
        = C3 )
     => ( ( A5 @ ( B2 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_130_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A5: ( C > B ),B2: ( A > C ),C3: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A5 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ! [V2: A] :
          ( ( A5 @ ( B2 @ V2 ) )
          = ( C3 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_131_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A5: ( C > B ),B2: ( A > C ),C3: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A5 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ( ( A5 @ ( B2 @ V ) )
        = ( C3 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_132_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_133_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F4: ( B > C ),G2: ( A > B ),X4: A] :
            ( F4 @ ( G2 @ X4 ) ) ) ) )).

% comp_def
thf(fact_134_Inr__cont__hsubst__eq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
        = ( root @ tr0 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ tr0 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ tr0 ) ) ) ) ) )).

% Inr_cont_hsubst_eq
thf(fact_135_Inr__cont__hsubst__neq,axiom,(
    ! [Tr: dtree] :
      ( ( ( root @ Tr )
       != ( root @ tr0 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ tr0 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ tr0 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) ) )).

% Inr_cont_hsubst_neq
thf(fact_136_IH,axiom,(
    ! [Tr: dtree] :
      ( ( tr1
        = ( gram_L1004374585hsubst @ tr0 @ Tr ) )
     => ( ( member @ t @ ta @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ tr0 ) ) )
        | ( gram_L805317505_inFrr @ ( minus_minus @ ( set @ n ) @ nsa @ ( insert @ n @ ( root @ tr0 ) @ ( bot_bot @ ( set @ n ) ) ) ) @ tr0 @ ta )
        | ( gram_L1333338417e_inFr @ ( minus_minus @ ( set @ n ) @ nsa @ ( insert @ n @ ( root @ tr0 ) @ ( bot_bot @ ( set @ n ) ) ) ) @ Tr @ ta ) ) ) )).

% IH
thf(fact_137_Gram__Lang__Mirabelle__ojxrtuoybn_OInr__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr02: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr02 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ Tr02 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ Tr02 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr02 ) ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inr_cont_hsubst_eq
thf(fact_138_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B,A6: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( member @ B @ X @ A6 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A6 ) ) ) ) )).

% image_eqI
thf(fact_139_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_140_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_141_all__not__in__conv,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A6 ) )
      = ( A6
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_142_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_143_Diff__idemp,axiom,(
    ! [A: $tType,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) @ B4 )
      = ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) )).

% Diff_idemp
thf(fact_144_Diff__iff,axiom,(
    ! [A: $tType,C3: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) )
      = ( ( member @ A @ C3 @ A6 )
        & ~ ( member @ A @ C3 @ B4 ) ) ) )).

% Diff_iff
thf(fact_145_DiffI,axiom,(
    ! [A: $tType,C3: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C3 @ A6 )
     => ( ~ ( member @ A @ C3 @ B4 )
       => ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) ) ) )).

% DiffI
thf(fact_146_image__ident,axiom,(
    ! [A: $tType,Y4: ( set @ A )] :
      ( ( image @ A @ A
        @ ^ [X4: A] : X4
        @ Y4 )
      = Y4 ) )).

% image_ident
thf(fact_147_finite__Collect__conjI,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        | ( finite_finite2 @ A @ ( collect @ A @ Q ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X4: A] :
              ( ( P @ X4 )
              & ( Q @ X4 ) ) ) ) ) )).

% finite_Collect_conjI
thf(fact_148_finite__Collect__disjI,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X4: A] :
              ( ( P @ X4 )
              | ( Q @ X4 ) ) ) )
      = ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        & ( finite_finite2 @ A @ ( collect @ A @ Q ) ) ) ) )).

% finite_Collect_disjI
thf(fact_149_vimage__Collect__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),P: ( B > $o )] :
      ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
      = ( collect @ A
        @ ^ [Y5: A] :
            ( P @ ( F @ Y5 ) ) ) ) )).

% vimage_Collect_eq
thf(fact_150_vimage__ident,axiom,(
    ! [A: $tType,Y4: ( set @ A )] :
      ( ( vimage @ A @ A
        @ ^ [X4: A] : X4
        @ Y4 )
      = Y4 ) )).

% vimage_ident
thf(fact_151_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A6 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A6
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_152_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A6 ) )
      = ( A6
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_153_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_154_finite__imageI,axiom,(
    ! [B: $tType,A: $tType,F5: ( set @ A ),H: ( A > B )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( finite_finite2 @ B @ ( image @ A @ B @ H @ F5 ) ) ) )).

% finite_imageI
thf(fact_155_image__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: B,B4: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( insert @ B @ A5 @ B4 ) )
      = ( insert @ A @ ( F @ A5 ) @ ( image @ B @ A @ F @ B4 ) ) ) )).

% image_insert
thf(fact_156_insert__image,axiom,(
    ! [B: $tType,A: $tType,X: A,A6: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A6 )
     => ( ( insert @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A6 ) )
        = ( image @ A @ B @ F @ A6 ) ) ) )).

% insert_image
thf(fact_157_singletonI,axiom,(
    ! [A: $tType,A5: A] :
      ( member @ A @ A5 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_158_Diff__cancel,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A6 @ A6 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_159_empty__Diff,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A6 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_160_Diff__empty,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A6 @ ( bot_bot @ ( set @ A ) ) )
      = A6 ) )).

% Diff_empty
thf(fact_161_finite__Diff2,axiom,(
    ! [A: $tType,B4: ( set @ A ),A6: ( set @ A )] :
      ( ( finite_finite2 @ A @ B4 )
     => ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) )
        = ( finite_finite2 @ A @ A6 ) ) ) )).

% finite_Diff2
thf(fact_162_finite__Diff,axiom,(
    ! [A: $tType,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) ) )).

% finite_Diff
thf(fact_163_Diff__insert0,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ~ ( member @ A @ X @ A6 )
     => ( ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ X @ B4 ) )
        = ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) ) )).

% Diff_insert0
thf(fact_164_insert__Diff1,axiom,(
    ! [A: $tType,X: A,B4: ( set @ A ),A6: ( set @ A )] :
      ( ( member @ A @ X @ B4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A6 ) @ B4 )
        = ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) ) )).

% insert_Diff1
thf(fact_165_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_166_singleton__conv,axiom,(
    ! [A: $tType,A5: A] :
      ( ( collect @ A
        @ ^ [X4: A] : ( X4 = A5 ) )
      = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv
thf(fact_167_singleton__conv2,axiom,(
    ! [A: $tType,A5: A] :
      ( ( collect @ A
        @ ( ^ [Y6: A,Z: A] : ( Y6 = Z )
          @ A5 ) )
      = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv2
thf(fact_168_insert__Diff__single,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A )] :
      ( ( insert @ A @ A5 @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A5 @ A6 ) ) )).

% insert_Diff_single
thf(fact_169_finite__Diff__insert,axiom,(
    ! [A: $tType,A6: ( set @ A ),A5: A,B4: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ B4 ) ) )
      = ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) ) )).

% finite_Diff_insert
thf(fact_170_vimage__Diff,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B ),B4: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( minus_minus @ ( set @ B ) @ A6 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( vimage @ A @ B @ F @ A6 ) @ ( vimage @ A @ B @ F @ B4 ) ) ) )).

% vimage_Diff
thf(fact_171_vimage__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F4: ( A > B ),B9: ( set @ B )] :
            ( collect @ A
            @ ^ [X4: A] :
                ( member @ B @ ( F4 @ X4 ) @ B9 ) ) ) ) )).

% vimage_def
thf(fact_172_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),R: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G @ R ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F @ G ) @ R ) ) )).

% image_comp
thf(fact_173_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( B > A ),A6: ( set @ B ),G: ( C > A ),B4: ( set @ C ),H: ( A > D )] :
      ( ( ( image @ B @ A @ F @ A6 )
        = ( image @ C @ A @ G @ B4 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H @ F ) @ A6 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H @ G ) @ B4 ) ) ) )).

% image_eq_imp_comp
thf(fact_174_Diff__insert,axiom,(
    ! [A: $tType,A6: ( set @ A ),A5: A,B4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert
thf(fact_175_insert__Diff,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A )] :
      ( ( member @ A @ A5 @ A6 )
     => ( ( insert @ A @ A5 @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A6 ) ) )).

% insert_Diff
thf(fact_176_Diff__insert2,axiom,(
    ! [A: $tType,A6: ( set @ A ),A5: A,B4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ B4 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) )).

% Diff_insert2
thf(fact_177_insert__compr,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A11: A,B9: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A11 )
                | ( member @ A @ X4 @ B9 ) ) ) ) ) )).

% insert_compr
thf(fact_178_image__constant,axiom,(
    ! [A: $tType,B: $tType,X: A,A6: ( set @ A ),C3: B] :
      ( ( member @ A @ X @ A6 )
     => ( ( image @ A @ B
          @ ^ [X4: A] : C3
          @ A6 )
        = ( insert @ B @ C3 @ ( bot_bot @ ( set @ B ) ) ) ) ) )).

% image_constant
thf(fact_179_insert__Collect,axiom,(
    ! [A: $tType,A5: A,P: ( A > $o )] :
      ( ( insert @ A @ A5 @ ( collect @ A @ P ) )
      = ( collect @ A
        @ ^ [U: A] :
            ( ( U != A5 )
           => ( P @ U ) ) ) ) )).

% insert_Collect
thf(fact_180_Collect__conv__if,axiom,(
    ! [A: $tType,P: ( A > $o ),A5: A] :
      ( ( ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A5 )
                & ( P @ X4 ) ) )
          = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( X4 = A5 )
                & ( P @ X4 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if
thf(fact_181_Collect__conv__if2,axiom,(
    ! [A: $tType,P: ( A > $o ),A5: A] :
      ( ( ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( A5 = X4 )
                & ( P @ X4 ) ) )
          = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X4: A] :
                ( ( A5 = X4 )
                & ( P @ X4 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if2
thf(fact_182_Diff__insert__absorb,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A )] :
      ( ~ ( member @ A @ X @ A6 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A6 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A6 ) ) )).

% Diff_insert_absorb
thf(fact_183_image__constant__conv,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ B ),C3: A] :
      ( ( ( A6
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ B @ A
            @ ^ [X4: B] : C3
            @ A6 )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( A6
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ B @ A
            @ ^ [X4: B] : C3
            @ A6 )
          = ( insert @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% image_constant_conv
thf(fact_184_Compr__image__eq,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B ),P: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A6 ) )
            & ( P @ X4 ) ) )
      = ( image @ B @ A @ F
        @ ( collect @ B
          @ ^ [X4: B] :
              ( ( member @ B @ X4 @ A6 )
              & ( P @ ( F @ X4 ) ) ) ) ) ) )).

% Compr_image_eq
thf(fact_185_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A6: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X @ A6 )
     => ( ( B2
          = ( F @ X ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A6 ) ) ) ) )).

% rev_image_eqI
thf(fact_186_set__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( minus_minus @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B9: ( set @ A )] :
            ( collect @ A
            @ ^ [X4: A] :
                ( ( member @ A @ X4 @ A4 )
                & ~ ( member @ A @ X4 @ B9 ) ) ) ) ) )).

% set_diff_eq
thf(fact_187_image__image,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G: ( C > B ),A6: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G @ A6 ) )
      = ( image @ C @ A
        @ ^ [X4: C] :
            ( F @ ( G @ X4 ) )
        @ A6 ) ) )).

% image_image
thf(fact_188_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B ),P: ( A > $o )] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ ( image @ B @ A @ F @ A6 ) )
         => ( P @ X5 ) )
     => ! [X6: B] :
          ( ( member @ B @ X6 @ A6 )
         => ( P @ ( F @ X6 ) ) ) ) )).

% ball_imageD
thf(fact_189_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N5: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M = N5 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ N5 )
           => ( ( F @ X5 )
              = ( G @ X5 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G @ N5 ) ) ) ) )).

% image_cong
thf(fact_190_ex__in__conv,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A6 ) )
      = ( A6
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_191_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B ),P: ( A > $o )] :
      ( ? [X6: A] :
          ( ( member @ A @ X6 @ ( image @ B @ A @ F @ A6 ) )
          & ( P @ X6 ) )
     => ? [X5: B] :
          ( ( member @ B @ X5 @ A6 )
          & ( P @ ( F @ X5 ) ) ) ) )).

% bex_imageD
thf(fact_192_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z2: A,F: ( B > A ),A6: ( set @ B )] :
      ( ( member @ A @ Z2 @ ( image @ B @ A @ F @ A6 ) )
      = ( ? [X4: B] :
            ( ( member @ B @ X4 @ A6 )
            & ( Z2
              = ( F @ X4 ) ) ) ) ) )).

% image_iff
thf(fact_193_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X4: A] : $false ) ) )).

% empty_def
thf(fact_194_equals0I,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A6 )
     => ( A6
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_195_equals0D,axiom,(
    ! [A: $tType,A6: ( set @ A ),A5: A] :
      ( ( A6
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A5 @ A6 ) ) )).

% equals0D
thf(fact_196_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A6: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A6 )
     => ( member @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A6 ) ) ) )).

% imageI
thf(fact_197_imageE,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),A6: ( set @ B )] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ F @ A6 ) )
     => ~ ( ! [X5: B] :
              ( ( B2
                = ( F @ X5 ) )
             => ~ ( member @ B @ X5 @ A6 ) ) ) ) )).

% imageE
thf(fact_198_emptyE,axiom,(
    ! [A: $tType,A5: A] :
      ~ ( member @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_199_DiffD2,axiom,(
    ! [A: $tType,C3: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) )
     => ~ ( member @ A @ C3 @ B4 ) ) )).

% DiffD2
thf(fact_200_DiffD1,axiom,(
    ! [A: $tType,C3: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) )
     => ( member @ A @ C3 @ A6 ) ) )).

% DiffD1
thf(fact_201_DiffE,axiom,(
    ! [A: $tType,C3: A,A6: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C3 @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) )
     => ~ ( ( member @ A @ C3 @ A6 )
         => ( member @ A @ C3 @ B4 ) ) ) )).

% DiffE
thf(fact_202_not__finite__existsD,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ~ ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ? [X13: A] :
          ( P @ X13 ) ) )).

% not_finite_existsD
thf(fact_203_pigeonhole__infinite,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),F: ( A > B )] :
      ( ~ ( finite_finite2 @ A @ A6 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F @ A6 ) )
       => ? [X5: A] :
            ( ( member @ A @ X5 @ A6 )
            & ~ ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [A11: A] :
                      ( ( member @ A @ A11 @ A6 )
                      & ( ( F @ A11 )
                        = ( F @ X5 ) ) ) ) ) ) ) ) )).

% pigeonhole_infinite
thf(fact_204_pigeonhole__infinite__rel,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),B4: ( set @ B ),R3: ( A > B > $o )] :
      ( ~ ( finite_finite2 @ A @ A6 )
     => ( ( finite_finite2 @ B @ B4 )
       => ( ! [X5: A] :
              ( ( member @ A @ X5 @ A6 )
             => ? [Xa: B] :
                  ( ( member @ B @ Xa @ B4 )
                  & ( R3 @ X5 @ Xa ) ) )
         => ? [X5: B] :
              ( ( member @ B @ X5 @ B4 )
              & ~ ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [A11: A] :
                        ( ( member @ A @ A11 @ A6 )
                        & ( R3 @ A11 @ X5 ) ) ) ) ) ) ) ) )).

% pigeonhole_infinite_rel
thf(fact_205_singletonD,axiom,(
    ! [A: $tType,B2: A,A5: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A5 ) ) )).

% singletonD
thf(fact_206_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A5: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A5 ) ) )).

% singleton_iff
thf(fact_207_doubleton__eq__iff,axiom,(
    ! [A: $tType,A5: A,B2: A,C3: A,D2: A] :
      ( ( ( insert @ A @ A5 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C3 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A5 = C3 )
          & ( B2 = D2 ) )
        | ( ( A5 = D2 )
          & ( B2 = C3 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_208_insert__not__empty,axiom,(
    ! [A: $tType,A5: A,A6: ( set @ A )] :
      ( ( insert @ A @ A5 @ A6 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_209_singleton__inject,axiom,(
    ! [A: $tType,A5: A,B2: A] :
      ( ( ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A5 = B2 ) ) )).

% singleton_inject
thf(fact_210_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_211_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S2: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ( S2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_212_insert__Diff__if,axiom,(
    ! [A: $tType,X: A,B4: ( set @ A ),A6: ( set @ A )] :
      ( ( ( member @ A @ X @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A6 ) @ B4 )
          = ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) )
      & ( ~ ( member @ A @ X @ B4 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A6 ) @ B4 )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A6 @ B4 ) ) ) ) ) )).

% insert_Diff_if
thf(fact_213_Diff__infinite__finite,axiom,(
    ! [A: $tType,T5: ( set @ A ),S2: ( set @ A )] :
      ( ( finite_finite2 @ A @ T5 )
     => ( ~ ( finite_finite2 @ A @ S2 )
       => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ T5 ) ) ) ) )).

% Diff_infinite_finite
thf(fact_214_infinite__remove,axiom,(
    ! [A: $tType,S2: ( set @ A ),A5: A] :
      ( ~ ( finite_finite2 @ A @ S2 )
     => ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ S2 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% infinite_remove
thf(fact_215_infinite__coinduct,axiom,(
    ! [A: $tType,X8: ( ( set @ A ) > $o ),A6: ( set @ A )] :
      ( ( X8 @ A6 )
     => ( ! [A13: ( set @ A )] :
            ( ( X8 @ A13 )
           => ? [X6: A] :
                ( ( member @ A @ X6 @ A13 )
                & ( ( X8 @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  | ~ ( finite_finite2 @ A @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
       => ~ ( finite_finite2 @ A @ A6 ) ) ) )).

% infinite_coinduct
thf(fact_216_finite__empty__induct,axiom,(
    ! [A: $tType,A6: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ( P @ A6 )
       => ( ! [A10: A,A13: ( set @ A )] :
              ( ( finite_finite2 @ A @ A13 )
             => ( ( member @ A @ A10 @ A13 )
               => ( ( P @ A13 )
                 => ( P @ ( minus_minus @ ( set @ A ) @ A13 @ ( insert @ A @ A10 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )
         => ( P @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% finite_empty_induct
thf(fact_217_inf__img__fin__domE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A6 ) )
     => ( ~ ( finite_finite2 @ B @ A6 )
       => ~ ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ ( image @ B @ A @ F @ A6 ) )
               => ( finite_finite2 @ B @ ( vimage @ B @ A @ F @ ( insert @ A @ Y3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) )).

% inf_img_fin_domE
thf(fact_218_inf__img__fin__dom,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A6 ) )
     => ( ~ ( finite_finite2 @ B @ A6 )
       => ? [X5: A] :
            ( ( member @ A @ X5 @ ( image @ B @ A @ F @ A6 ) )
            & ~ ( finite_finite2 @ B @ ( vimage @ B @ A @ F @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )).

% inf_img_fin_dom
thf(fact_219_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A6: ( set @ A )] :
      ( ! [A13: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A13 )
         => ( P @ A13 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X5: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X5 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X5 @ F6 ) ) ) ) )
         => ( P @ A6 ) ) ) ) )).

% infinite_finite_induct
thf(fact_220_finite__ne__induct,axiom,(
    ! [A: $tType,F5: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( ( F5
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X5: A] :
              ( P @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X5: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( F6
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X5 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ X5 @ F6 ) ) ) ) ) )
           => ( P @ F5 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_221_finite_Oinducts,axiom,(
    ! [A: $tType,X: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A13: ( set @ A ),A10: A] :
              ( ( finite_finite2 @ A @ A13 )
             => ( ( P @ A13 )
               => ( P @ ( insert @ A @ A10 @ A13 ) ) ) )
         => ( P @ X ) ) ) ) )).

% finite.inducts
thf(fact_222_finite__induct,axiom,(
    ! [A: $tType,F5: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X5: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X5 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X5 @ F6 ) ) ) ) )
         => ( P @ F5 ) ) ) ) )).

% finite_induct
thf(fact_223_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A11: ( set @ A )] :
            ( ( A11
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A4: ( set @ A ),B10: A] :
                ( ( A11
                  = ( insert @ A @ B10 @ A4 ) )
                & ( finite_finite2 @ A @ A4 ) ) ) ) ) )).

% finite.simps
thf(fact_224_finite_Ocases,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( finite_finite2 @ A @ A5 )
     => ( ( A5
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A13: ( set @ A )] :
                ( ? [A10: A] :
                    ( A5
                    = ( insert @ A @ A10 @ A13 ) )
               => ~ ( finite_finite2 @ A @ A13 ) ) ) ) ) )).

% finite.cases
thf(fact_225_vimage__singleton__eq,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),B2: B] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ ( insert @ B @ B2 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( ( F @ A5 )
        = B2 ) ) )).

% vimage_singleton_eq
thf(fact_226_Gram__Lang__Mirabelle__ojxrtuoybn_OInr__cont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr02: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr02 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ Tr02 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ Tr02 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inr_cont_hsubst_neq
thf(fact_227_empty__natural,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: ( A > C ),G: ( D > B )] :
      ( ( comp @ C @ ( set @ B ) @ A
        @ ^ [Uu: C] :
            ( bot_bot @ ( set @ B ) )
        @ F )
      = ( comp @ ( set @ D ) @ ( set @ B ) @ A @ ( image @ D @ B @ G )
        @ ^ [Uu: A] :
            ( bot_bot @ ( set @ D ) ) ) ) )).

% empty_natural
thf(fact_228_Frr,axiom,
    ( gram_L1556062726le_Frr
    = ( ^ [Ns2: ( set @ n ),Tr3: dtree] :
          ( collect @ t @ ( gram_L805317505_inFrr @ Ns2 @ Tr3 ) ) ) )).

% Frr
thf(fact_229_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_230_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A6: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A6 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A6 ) ) ) )).

% Inf.INF_image
thf(fact_231_is__singletonI_H,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( A6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X5: A,Y3: A] :
            ( ( member @ A @ X5 @ A6 )
           => ( ( member @ A @ Y3 @ A6 )
             => ( X5 = Y3 ) ) )
       => ( is_singleton @ A @ A6 ) ) ) )).

% is_singletonI'
thf(fact_232_in__image__insert__iff,axiom,(
    ! [A: $tType,B4: ( set @ ( set @ A ) ),X: A,A6: ( set @ A )] :
      ( ! [C4: ( set @ A )] :
          ( ( member @ ( set @ A ) @ C4 @ B4 )
         => ~ ( member @ A @ X @ C4 ) )
     => ( ( member @ ( set @ A ) @ A6 @ ( image @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ X ) @ B4 ) )
        = ( ( member @ A @ X @ A6 )
          & ( member @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B4 ) ) ) ) )).

% in_image_insert_iff
thf(fact_233_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X: C,N5: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X ) )
        = ( N5 @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N5 ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_234_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
          ? [X4: A] :
            ( A4
            = ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_235_is__singletonE,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( is_singleton @ A @ A6 )
     => ~ ( ! [X5: A] :
              ( A6
             != ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_236_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A6: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A6 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A6 ) ) ) )).

% Sup.SUP_image
thf(fact_237_image__o__collect,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( C > B ),F5: ( set @ ( A > ( set @ C ) ) )] :
      ( ( bNF_collect @ A @ B @ ( image @ ( A > ( set @ C ) ) @ ( A > ( set @ B ) ) @ ( comp @ ( set @ C ) @ ( set @ B ) @ A @ ( image @ C @ B @ G ) ) @ F5 ) )
      = ( comp @ ( set @ C ) @ ( set @ B ) @ A @ ( image @ C @ B @ G ) @ ( bNF_collect @ A @ C @ F5 ) ) ) )).

% image_o_collect
thf(fact_238_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( insert @ A @ ( the_elem @ A @ A4 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_239_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_240_the__elem__image__unique,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),F: ( A > B ),X: A] :
      ( ( A6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [Y3: A] :
            ( ( member @ A @ Y3 @ A6 )
           => ( ( F @ Y3 )
              = ( F @ X ) ) )
       => ( ( the_elem @ B @ ( image @ A @ B @ F @ A6 ) )
          = ( F @ X ) ) ) ) )).

% the_elem_image_unique
thf(fact_241_collect__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F5: ( set @ ( C > ( set @ B ) ) ),G: ( A > C )] :
      ( ( comp @ C @ ( set @ B ) @ A @ ( bNF_collect @ C @ B @ F5 ) @ G )
      = ( bNF_collect @ A @ B
        @ ( image @ ( C > ( set @ B ) ) @ ( A > ( set @ B ) )
          @ ^ [F4: ( C > ( set @ B ) )] :
              ( comp @ C @ ( set @ B ) @ A @ F4 @ G )
          @ F5 ) ) ) )).

% collect_comp
thf(fact_242_subtrOf__def,axiom,
    ( gram_L1614515765ubtrOf
    = ( ^ [Tr3: dtree,N3: n] :
        @+[Tr5: dtree] :
          ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr3 ) )
          & ( ( root @ Tr5 )
            = N3 ) ) ) )).

% subtrOf_def
thf(fact_243_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_244_remove__def,axiom,(
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X4: A,A4: ( set @ A )] :
            ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% remove_def
thf(fact_245_univ__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( bNF_Greatest_univ @ B @ A )
      = ( ^ [F4: ( B > A ),X9: ( set @ B )] :
            ( F4
            @ @+[X4: B] :
                ( member @ B @ X4 @ X9 ) ) ) ) )).

% univ_def
thf(fact_246_member__remove,axiom,(
    ! [A: $tType,X: A,Y: A,A6: ( set @ A )] :
      ( ( member @ A @ X @ ( remove @ A @ Y @ A6 ) )
      = ( ( member @ A @ X @ A6 )
        & ( X != Y ) ) ) )).

% member_remove
thf(fact_247_wf__inj__on,axiom,(
    ! [Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) )).

% wf_inj_on
thf(fact_248_sum__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: A] :
      ( ( basic_setl @ A @ B @ ( sum_Inl @ A @ B @ X ) )
      = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% sum_set_simps(1)
thf(fact_249_sum__set__simps_I2_J,axiom,(
    ! [A: $tType,C: $tType,X: A] :
      ( ( basic_setl @ C @ A @ ( sum_Inr @ A @ C @ X ) )
      = ( bot_bot @ ( set @ C ) ) ) )).

% sum_set_simps(2)
thf(fact_250_inj__on__insert,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A5: A,A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F @ ( insert @ A @ A5 @ A6 ) )
      = ( ( inj_on @ A @ B @ F @ A6 )
        & ~ ( member @ B @ ( F @ A5 ) @ ( image @ A @ B @ F @ ( minus_minus @ ( set @ A ) @ A6 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )).

% inj_on_insert
thf(fact_251_finite__image__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F @ A6 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F @ A6 ) )
        = ( finite_finite2 @ A @ A6 ) ) ) )).

% finite_image_iff
thf(fact_252_finite__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A6 ) )
     => ( ( inj_on @ B @ A @ F @ A6 )
       => ( finite_finite2 @ B @ A6 ) ) ) )).

% finite_imageD
thf(fact_253_comp__inj__on__iff,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B ),A6: ( set @ A ),F7: ( B > C )] :
      ( ( inj_on @ A @ B @ F @ A6 )
     => ( ( inj_on @ B @ C @ F7 @ ( image @ A @ B @ F @ A6 ) )
        = ( inj_on @ A @ C @ ( comp @ B @ C @ A @ F7 @ F ) @ A6 ) ) ) )).

% comp_inj_on_iff
thf(fact_254_inj__on__imageI,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( C > B ),F: ( A > C ),A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ ( comp @ C @ B @ A @ G @ F ) @ A6 )
     => ( inj_on @ C @ B @ G @ ( image @ A @ C @ F @ A6 ) ) ) )).

% inj_on_imageI
thf(fact_255_comp__inj__on,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B ),A6: ( set @ A ),G: ( B > C )] :
      ( ( inj_on @ A @ B @ F @ A6 )
     => ( ( inj_on @ B @ C @ G @ ( image @ A @ B @ F @ A6 ) )
       => ( inj_on @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ A6 ) ) ) )).

% comp_inj_on

%----Type constructors (4)
thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A14: $tType] :
      ( ( ( finite_finite @ A8 @ ( type @ A8 ) )
        & ( finite_finite @ A14 @ ( type @ A14 ) ) )
     => ( finite_finite @ ( A8 > A14 ) @ ( type @ ( A8 > A14 ) ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_1,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type @ ( set @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_2,axiom,
    ( finite_finite @ $o @ ( type @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_3,axiom,(
    ! [A8: $tType,A14: $tType] :
      ( ( ( finite_finite @ A8 @ ( type @ A8 ) )
        & ( finite_finite @ A14 @ ( type @ A14 ) ) )
     => ( finite_finite @ ( sum_sum @ A8 @ A14 ) @ ( type @ ( sum_sum @ A8 @ A14 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ! [Tr7: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr7 ) @ ( cont @ tr0 ) )
     => ( ( tr1
          = ( gram_L1004374585hsubst @ tr0 @ Tr7 ) )
       => thesis ) ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
