%------------------------------------------------------------------------------
% File     : COM189^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 706
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__706.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  331 (   0 unit;  52 type;   0 defn)
%            Number of atoms       : 4403 ( 265 equality;2564 variable)
%            Maximal formula depth :   30 (  10 average)
%            Number of connectives : 3930 (  73   ~;  11   |;  65   &;3420   @)
%                                         (   0 <=>; 361  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  292 ( 292   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   56 (  52   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1143 (   2 sgn;1001   !;  46   ?;  62   ^)
%                                         (1143   :;  34  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:44:19.466
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (46)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OS,type,(
    gram_L1451583635elle_S: n > ( set @ ( sum_sum @ t @ n ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Odeftr,type,(
    gram_L1231612515_deftr: n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst,type,(
    gram_L1004374585hsubst: dtree > dtree > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c,type,(
    gram_L1905609002ubst_c: dtree > dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__r,type,(
    gram_L1905609017ubst_r: dtree > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFrr,type,(
    gram_L805317505_inFrr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Oreg,type,(
    gram_L1918716148le_reg: ( n > dtree ) > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Oregular,type,(
    gram_L646766332egular: dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr,type,(
    gram_L716654942_subtr: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr2,type,(
    gram_L1283001940subtr2: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OsubtrOf,type,(
    gram_L1614515765ubtrOf: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Owf,type,(
    gram_L864798063lle_wf: dtree > $o )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Typedef_Otype__definition,type,(
    type_definition: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f,type,(
    f: n > dtree )).

thf(sy_v_tr,type,(
    tr: dtree )).

%----Relevant facts (256)
thf(fact_0_assms,axiom,
    ( gram_L1918716148le_reg @ f @ tr )).

% assms
thf(fact_1_hsubst__r__def,axiom,(
    gram_L1905609017ubst_r = root )).

% hsubst_r_def
thf(fact_2_root__deftr,axiom,(
    ! [N: n] :
      ( ( root @ ( gram_L1231612515_deftr @ N ) )
      = N ) )).

% root_deftr
thf(fact_3_root__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
      = ( root @ Tr ) ) )).

% root_hsubst
thf(fact_4_inFr2__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr2_root_in
thf(fact_5_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_6_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_7_regular__def2,axiom,
    ( gram_L646766332egular
    = ( ^ [Tr2: dtree] :
        ? [F: ( n > dtree )] :
          ( ( gram_L1918716148le_reg @ F @ Tr2 )
          & ! [N2: n] :
              ( ( root @ ( F @ N2 ) )
              = N2 ) ) ) )).

% regular_def2
thf(fact_8_hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( gram_L1004374585hsubst @ Tr0 @ Tr )
        = ( gram_L1004374585hsubst @ Tr0 @ Tr0 ) ) ) )).

% hsubst_eq
thf(fact_9_subtr2_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L1283001940subtr2 @ Ns @ Tr @ Tr ) ) )).

% subtr2.Refl
thf(fact_10_subtr2__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr2_rootL_in
thf(fact_11_subtr2__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr2_rootR_in
thf(fact_12_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_13_inFr__inFr2,axiom,(
    gram_L1333338417e_inFr = gram_L805317441_inFr2 )).

% inFr_inFr2
thf(fact_14_regular__def,axiom,
    ( gram_L646766332egular
    = ( ^ [Tr2: dtree] :
        ? [F: ( n > dtree )] :
          ( gram_L1918716148le_reg @ F @ Tr2 ) ) )).

% regular_def
thf(fact_15_subtr2__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr3: dtree] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L1283001940subtr2 @ Ns @ Tr22 @ Tr3 )
       => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr2_trans
thf(fact_16_inFr__hsubst__notin,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Tr0: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ~ ( member @ n @ ( root @ Tr0 ) @ Ns )
       => ( gram_L1333338417e_inFr @ Ns @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) @ T2 ) ) ) )).

% inFr_hsubst_notin
thf(fact_17_not__root__inFr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ~ ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) )).

% not_root_inFr
thf(fact_18_hsubst__def,axiom,
    ( gram_L1004374585hsubst
    = ( ^ [Tr02: dtree] :
          ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ Tr02 ) ) ) )).

% hsubst_def
thf(fact_19_reg__def2,axiom,
    ( gram_L1918716148le_reg
    = ( ^ [F: ( n > dtree ),Tr2: dtree] :
        ! [Ns2: ( set @ n ),Tr4: dtree] :
          ( ( gram_L716654942_subtr @ Ns2 @ Tr4 @ Tr2 )
         => ( Tr4
            = ( F @ ( root @ Tr4 ) ) ) ) ) )).

% reg_def2
thf(fact_20_inItr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ? [Tr5: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr5 @ Tr )
          & ( ( root @ Tr5 )
            = N ) ) ) )).

% inItr_subtr
thf(fact_21_root__o__subst,axiom,(
    ! [Tr0: dtree] :
      ( ( comp @ dtree @ n @ dtree @ root @ ( gram_L1004374585hsubst @ Tr0 ) )
      = root ) )).

% root_o_subst
thf(fact_22_wf__deftr,axiom,(
    ! [N: n] :
      ( gram_L864798063lle_wf @ ( gram_L1231612515_deftr @ N ) ) )).

% wf_deftr
thf(fact_23_wf__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( ( gram_L864798063lle_wf @ Tr )
       => ( gram_L864798063lle_wf @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) ) ) )).

% wf_hsubst
thf(fact_24_subtr__inItr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L830233218_inItr @ Ns @ Tr1 @ N ) ) ) )).

% subtr_inItr
thf(fact_25_subtr__subtr2,axiom,(
    gram_L716654942_subtr = gram_L1283001940subtr2 )).

% subtr_subtr2
thf(fact_26_subtr__inFr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Tr1: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 ) ) ) )).

% subtr_inFr
thf(fact_27_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_28_inFr2__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Ns3: ( set @ n )] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L805317441_inFr2 @ Ns3 @ Tr @ T2 ) ) ) )).

% inFr2_mono
thf(fact_29_subtr__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr3: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr3 )
       => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr_trans
thf(fact_30_subtr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Ns3: ( set @ n )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L716654942_subtr @ Ns3 @ Tr1 @ Tr22 ) ) ) )).

% subtr_mono
thf(fact_31_wf__subtr,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L864798063lle_wf @ Tr ) ) ) )).

% wf_subtr
thf(fact_32_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_33_subtr_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L716654942_subtr @ Ns @ Tr @ Tr ) ) )).

% subtr.Refl
thf(fact_34_subtr__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr_rootL_in
thf(fact_35_subtr__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr_rootR_in
thf(fact_36_inFr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t,Ns3: ( set @ n )] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L1333338417e_inFr @ Ns3 @ Tr @ T2 ) ) ) )).

% inFr_mono
thf(fact_37_subtr2__mono,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Ns3: ( set @ n )] :
      ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L1283001940subtr2 @ Ns3 @ Tr1 @ Tr22 ) ) ) )).

% subtr2_mono
thf(fact_38_inItr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n,Ns3: ( set @ n )] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L830233218_inItr @ Ns3 @ Tr @ N ) ) ) )).

% inItr_mono
thf(fact_39_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F: ( B > A ),G: ( C > B ),X: C] :
            ( F @ ( G @ X ) ) ) ) )).

% comp_apply
thf(fact_40_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( A2 = B3 ) ) ) )).

% subset_antisym
thf(fact_41_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A2 )
         => ( member @ A @ X2 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% subsetI
thf(fact_42_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ord_less_eq @ A @ X3 @ X3 ) ) )).

% order_refl
thf(fact_43_reg__def,axiom,
    ( gram_L1918716148le_reg
    = ( ^ [F: ( n > dtree ),Tr2: dtree] :
        ! [Tr4: dtree] :
          ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr4 @ Tr2 )
         => ( Tr4
            = ( F @ ( root @ Tr4 ) ) ) ) ) )).

% reg_def
thf(fact_44_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G2: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F2: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G2 @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E @ D @ F2 @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F2 @ G2 ) @ H )
          = ( comp @ D @ E @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G2: ( A > B )] :
      ( ! [X2: A] :
          ( ( F2 @ X2 )
          = ( G2 @ X2 ) )
     => ( F2 = G2 ) ) )).

% ext
thf(fact_49_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F2: ( C > B ),G2: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F2 @ G2 )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F2 @ ( comp @ A @ C @ E @ G2 @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_50_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G2: ( C > B ),H: ( A > C ),R: ( A > B ),F2: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G2 @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F2 @ G2 ) @ H )
        = ( comp @ B @ D @ A @ F2 @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_51_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F2: ( C > B ),G2: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F2 @ G2 )
        = L )
     => ( ( comp @ C @ B @ D @ F2 @ ( comp @ A @ C @ D @ G2 @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_52_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_53_UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_54_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X2: A] :
          ( member @ A @ X2 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_55_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_56_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_57_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_58_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_59_subset__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_60_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G2: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) )).

% le_funD
thf(fact_61_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G2: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G2 )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G2 @ X3 ) ) ) ) )).

% le_funE
thf(fact_62_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G2: ( A > B )] :
          ( ! [X2: A] :
              ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G2 ) ) ) )).

% le_funI
thf(fact_63_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F: ( A > B ),G: ( A > B )] :
            ! [X: A] :
              ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) ) )).

% le_fun_def
thf(fact_64_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_65_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B2: A,F2: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X2: A,Y: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y )
                 => ( ord_less_eq @ C @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A3 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_66_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B2: B,C2: B] :
          ( ( A3
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X2: B,Y: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_67_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B2: A,F2: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X2: A,Y: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A3 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_68_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y2: A,Z: A] : ( Y2 = Z ) )
        = ( ^ [X: A,Y3: A] :
              ( ( ord_less_eq @ A @ X @ Y3 )
              & ( ord_less_eq @ A @ Y3 @ X ) ) ) ) ) )).

% eq_iff
thf(fact_69_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y4: A] :
          ( ( ord_less_eq @ A @ X3 @ Y4 )
         => ( ( ord_less_eq @ A @ Y4 @ X3 )
           => ( X3 = Y4 ) ) ) ) )).

% antisym
thf(fact_70_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y4: A] :
          ( ( ord_less_eq @ A @ X3 @ Y4 )
          | ( ord_less_eq @ A @ Y4 @ X3 ) ) ) )).

% linear
thf(fact_71_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y4: A] :
          ( ( X3 = Y4 )
         => ( ord_less_eq @ A @ X3 @ Y4 ) ) ) )).

% eq_refl
thf(fact_72_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y4: A] :
          ( ~ ( ord_less_eq @ A @ X3 @ Y4 )
         => ( ord_less_eq @ A @ Y4 @ X3 ) ) ) )).

% le_cases
thf(fact_73_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% order.trans
thf(fact_74_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y4: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y4 )
           => ~ ( ord_less_eq @ A @ Y4 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y4 @ X3 )
             => ~ ( ord_less_eq @ A @ X3 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X3 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y4 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y4 )
                 => ~ ( ord_less_eq @ A @ Y4 @ X3 ) )
               => ( ( ( ord_less_eq @ A @ Y4 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X3 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X3 )
                     => ~ ( ord_less_eq @ A @ X3 @ Y4 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_75_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y4: A,X3: A] :
          ( ( ord_less_eq @ A @ Y4 @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y4 )
            = ( X3 = Y4 ) ) ) ) )).

% antisym_conv
thf(fact_76_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C2: A] :
          ( ( A3 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_77_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_78_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( A3 = B2 ) ) ) ) )).

% order_class.order.antisym
thf(fact_79_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y4: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y4 )
         => ( ( ord_less_eq @ A @ Y4 @ Z2 )
           => ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_80_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_81_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A3: A,B2: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P @ A4 @ B4 ) )
         => ( ! [A4: A,B4: A] :
                ( ( P @ B4 @ A4 )
               => ( P @ A4 @ B4 ) )
           => ( P @ A3 @ B2 ) ) ) ) )).

% linorder_wlog
thf(fact_82_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_83_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( A3 = B2 ) ) ) ) )).

% dual_order.antisym
thf(fact_84_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ X3 @ A2 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% set_mp
thf(fact_85_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ X3 @ A2 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% in_mono
thf(fact_86_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetD
thf(fact_87_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetCE
thf(fact_88_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( A2 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) ) )).

% equalityE
thf(fact_89_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ A5 )
           => ( member @ A @ X @ B5 ) ) ) ) )).

% subset_eq
thf(fact_90_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( A2 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% equalityD1
thf(fact_91_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( A2 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) )).

% equalityD2
thf(fact_92_set__rev__mp,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% set_rev_mp
thf(fact_93_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A5 )
           => ( member @ A @ T3 @ B5 ) ) ) ) )).

% subset_iff
thf(fact_94_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% rev_subsetD
thf(fact_95_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_96_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_97_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% subset_trans
thf(fact_98_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y2: ( set @ A ),Z: ( set @ A )] : ( Y2 = Z ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ) )).

% set_eq_subset
thf(fact_99_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ~ ( member @ A @ C2 @ B3 )
       => ~ ( member @ A @ C2 @ A2 ) ) ) )).

% contra_subsetD
thf(fact_100_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) ) ) ) )).

% Collect_mono_iff
thf(fact_101_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F: ( B > C ),G: ( A > B ),X: A] :
            ( F @ ( G @ X ) ) ) ) )).

% comp_def
thf(fact_102_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F2: ( D > B ),G2: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F2 @ G2 ) @ H )
      = ( comp @ D @ B @ A @ F2 @ ( comp @ C @ D @ A @ G2 @ H ) ) ) )).

% comp_assoc
thf(fact_103_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A3 @ ( B2 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_104_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A3 @ ( B2 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_105_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A3: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = C2 )
     => ( ( A3 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_106_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_107_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F2: ( B > A ),G2: ( C > B ),X3: C,F3: ( D > A ),G3: ( E > D ),X4: E] :
      ( ( ( F2 @ ( G2 @ X3 ) )
        = ( F3 @ ( G3 @ X4 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X3 )
        = ( comp @ D @ A @ E @ F3 @ G3 @ X4 ) ) ) )).

% comp_cong
thf(fact_108_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F2: ( B > A ),G2: ( C > B ),X3: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F2 @ ( G2 @ X3 ) )
        = ( H @ ( K @ X3 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X3 )
        = ( comp @ D @ A @ C @ H @ K @ X3 ) ) ) )).

% comp_apply_eq
thf(fact_109_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G2: ( B > C ),F2: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G2 @ ( comp @ A @ B @ D @ F2 @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G2 @ F2 ) @ V ) ) )).

% fun.map_comp
thf(fact_110_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G2: ( C > B ),X3: C,N3: ( D > A ),H: ( C > D ),F2: ( A > E )] :
      ( ( ( M @ ( G2 @ X3 ) )
        = ( N3 @ ( H @ X3 ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F2 @ M ) @ G2 @ X3 )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F2 @ N3 ) @ H @ X3 ) ) ) )).

% type_copy_map_cong0
thf(fact_111_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B2: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% corec(1)
thf(fact_112_root__o__deftr,axiom,
    ( ( comp @ dtree @ n @ n @ root @ gram_L1231612515_deftr )
    = ( id @ n ) )).

% root_o_deftr
thf(fact_113_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_114_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_apply
thf(fact_115_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_116_id__comp,axiom,(
    ! [B: $tType,A: $tType,G2: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G2 )
      = G2 ) )).

% id_comp
thf(fact_117_comp__id,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B )] :
      ( ( comp @ A @ B @ A @ F2 @ ( id @ A ) )
      = F2 ) )).

% comp_id
thf(fact_118_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_119_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_def
thf(fact_120_eq__id__iff,axiom,(
    ! [A: $tType,F2: ( A > A )] :
      ( ( ! [X: A] :
            ( ( F2 @ X )
            = X ) )
      = ( F2
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_121_DEADID_Oin__rel,axiom,(
    ! [B: $tType] :
      ( ( ^ [Y2: B,Z: B] : ( Y2 = Z ) )
      = ( ^ [A6: B,B6: B] :
          ? [Z3: B] :
            ( ( member @ B @ Z3 @ ( top_top @ ( set @ B ) ) )
            & ( ( id @ B @ Z3 )
              = A6 )
            & ( ( id @ B @ Z3 )
              = B6 ) ) ) ) )).

% DEADID.in_rel
thf(fact_122_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A3: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B2 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C2 ) )
     => ( ( A3 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_123_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),G2: ( A > B ),X3: A] :
      ( ( ( comp @ B @ A @ A @ F2 @ G2 )
        = ( id @ A ) )
     => ( ( F2 @ ( G2 @ X3 ) )
        = X3 ) ) )).

% pointfree_idE
thf(fact_124_dtree__cong,axiom,(
    ! [Tr: dtree,Tr6: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr6 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr6 ) )
       => ( Tr = Tr6 ) ) ) )).

% dtree_cong
thf(fact_125_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_126_hsubst__c__def,axiom,
    ( gram_L1905609002ubst_c
    = ( ^ [Tr02: dtree,Tr2: dtree] :
          ( if @ ( set @ ( sum_sum @ t @ dtree ) )
          @ ( ( root @ Tr2 )
            = ( root @ Tr02 ) )
          @ ( cont @ Tr02 )
          @ ( cont @ Tr2 ) ) ) )).

% hsubst_c_def
thf(fact_127_deftr__def,axiom,
    ( gram_L1231612515_deftr
    = ( unfold @ n @ ( id @ n ) @ gram_L1451583635elle_S ) )).

% deftr_def
thf(fact_128_wf__inj,axiom,(
    ! [Tr: dtree,Tr1: dtree,Tr22: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr ) )
         => ( ( ( root @ Tr1 )
              = ( root @ Tr22 ) )
            = ( Tr1 = Tr22 ) ) ) ) ) )).

% wf_inj
thf(fact_129_subtr__UNIV__inductL,axiom,(
    ! [Tr1: dtree,Tr22: dtree,Phi: ( dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr1 @ Tr22 )
     => ( ! [Tr7: dtree] :
            ( Phi @ Tr7 @ Tr7 )
       => ( ! [Tr12: dtree,Tr23: dtree,Tr32: dtree] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
             => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr23 @ Tr32 )
               => ( ( Phi @ Tr23 @ Tr32 )
                 => ( Phi @ Tr12 @ Tr32 ) ) ) )
         => ( Phi @ Tr1 @ Tr22 ) ) ) ) )).

% subtr_UNIV_inductL
thf(fact_130_type__copy__map__id0,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A ),M: ( B > B )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( id @ B ) )
       => ( ( comp @ B @ A @ A @ ( comp @ B @ A @ B @ Abs @ M ) @ Rep )
          = ( id @ A ) ) ) ) )).

% type_copy_map_id0
thf(fact_131_type__copy__Abs__o__Rep,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( comp @ B @ A @ A @ Abs @ Rep )
        = ( id @ A ) ) ) )).

% type_copy_Abs_o_Rep
thf(fact_132_top1I,axiom,(
    ! [A: $tType,X3: A] :
      ( top_top @ ( A > $o ) @ X3 ) )).

% top1I
thf(fact_133_type__copy__wit,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),X3: C,S: ( B > ( set @ C ) ),Y4: B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( member @ C @ X3 @ ( comp @ B @ ( set @ C ) @ A @ S @ Rep @ ( Abs @ Y4 ) ) )
       => ( member @ C @ X3 @ ( S @ Y4 ) ) ) ) )).

% type_copy_wit
thf(fact_134_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X3: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X3 ) )
      = P ) )).

% top_conj(2)
thf(fact_135_top__conj_I1_J,axiom,(
    ! [A: $tType,X3: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X3 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_136_type__copy__ex__RepI,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A ),F4: ( B > $o )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ^ [P2: ( B > $o )] :
            ? [X5: B] :
              ( P2 @ X5 )
          @ F4 )
        = ( ? [B6: A] :
              ( F4 @ ( Rep @ B6 ) ) ) ) ) )).

% type_copy_ex_RepI
thf(fact_137_type__copy__obj__one__point__absE,axiom,(
    ! [A: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),S2: A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ~ ( ! [X2: B] :
              ( S2
             != ( Abs @ X2 ) ) ) ) )).

% type_copy_obj_one_point_absE
thf(fact_138_wf__cont,axiom,(
    ! [Tr: dtree,Tr6: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr6 ) @ ( cont @ Tr ) )
       => ( gram_L864798063lle_wf @ Tr6 ) ) ) )).

% wf_cont
thf(fact_139_type__copy__map__comp0__undo,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,D: $tType,F5: $tType,Rep: ( A > B ),Abs: ( B > A ),Rep2: ( C > D ),Abs2: ( D > C ),Rep3: ( E > F5 ),Abs3: ( F5 > E ),M: ( F5 > D ),M1: ( B > D ),M2: ( F5 > B )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( type_definition @ C @ D @ Rep2 @ Abs2 @ ( top_top @ ( set @ D ) ) )
       => ( ( type_definition @ E @ F5 @ Rep3 @ Abs3 @ ( top_top @ ( set @ F5 ) ) )
         => ( ( ( comp @ F5 @ C @ E @ ( comp @ D @ C @ F5 @ Abs2 @ M ) @ Rep3 )
              = ( comp @ A @ C @ E @ ( comp @ B @ C @ A @ ( comp @ D @ C @ B @ Abs2 @ M1 ) @ Rep ) @ ( comp @ F5 @ A @ E @ ( comp @ B @ A @ F5 @ Abs @ M2 ) @ Rep3 ) ) )
           => ( ( comp @ B @ D @ F5 @ M1 @ M2 )
              = M ) ) ) ) ) )).

% type_copy_map_comp0_undo
thf(fact_140_type__copy__map__comp0,axiom,(
    ! [F5: $tType,D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Rep: ( A > B ),Abs: ( B > A ),M: ( C > D ),M1: ( B > D ),M2: ( C > B ),F2: ( D > F5 ),G2: ( E > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( comp @ B @ D @ C @ M1 @ M2 ) )
       => ( ( comp @ C @ F5 @ E @ ( comp @ D @ F5 @ C @ F2 @ M ) @ G2 )
          = ( comp @ A @ F5 @ E @ ( comp @ B @ F5 @ A @ ( comp @ D @ F5 @ B @ F2 @ M1 ) @ Rep ) @ ( comp @ C @ A @ E @ ( comp @ B @ A @ C @ Abs @ M2 ) @ G2 ) ) ) ) ) )).

% type_copy_map_comp0
thf(fact_141_subtr_OStep,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr3 ) )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr.Step
thf(fact_142_subtr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L716654942_subtr @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A32 ) @ A1 )
           => ! [Tr23: dtree] :
                ( ( gram_L716654942_subtr @ A1 @ A22 @ Tr23 )
               => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ A32 ) ) ) ) ) ) )).

% subtr.cases
thf(fact_143_subtr_Osimps,axiom,
    ( gram_L716654942_subtr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr2: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33 = Tr2 )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 ) )
          | ? [Tr33: dtree,Ns2: ( set @ n ),Tr13: dtree,Tr24: dtree] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr13 )
              & ( A33 = Tr33 )
              & ( member @ n @ ( root @ Tr33 ) @ Ns2 )
              & ( gram_L716654942_subtr @ Ns2 @ Tr13 @ Tr24 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr24 ) @ ( cont @ Tr33 ) ) ) ) ) )).

% subtr.simps
thf(fact_144_subtr__StepL,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr22: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr22 ) )
       => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr3 )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr_StepL
thf(fact_145_subtr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns4: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
           => ( P @ Ns4 @ Tr7 @ Tr7 ) )
       => ( ! [Tr32: dtree,Ns4: ( set @ n ),Tr12: dtree,Tr23: dtree] :
              ( ( member @ n @ ( root @ Tr32 ) @ Ns4 )
             => ( ( gram_L716654942_subtr @ Ns4 @ Tr12 @ Tr23 )
               => ( ( P @ Ns4 @ Tr12 @ Tr23 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ Tr32 ) )
                   => ( P @ Ns4 @ Tr12 @ Tr32 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr.inducts
thf(fact_146_subtr__inductL,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Phi: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ! [Ns4: ( set @ n ),Tr7: dtree] :
            ( Phi @ Ns4 @ Tr7 @ Tr7 )
       => ( ! [Ns4: ( set @ n ),Tr12: dtree,Tr23: dtree,Tr32: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns4 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
               => ( ( gram_L716654942_subtr @ Ns4 @ Tr23 @ Tr32 )
                 => ( ( Phi @ Ns4 @ Tr23 @ Tr32 )
                   => ( Phi @ Ns4 @ Tr12 @ Tr32 ) ) ) ) )
         => ( Phi @ Ns @ Tr1 @ Tr22 ) ) ) ) )).

% subtr_inductL
thf(fact_147_inFr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T2 )
         => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr.Ind
thf(fact_148_subtr2_OStep,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr22: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr22 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr22 @ Tr3 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr2.Step
thf(fact_149_subtr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L1283001940subtr2 @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr23: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ A22 ) @ ( cont @ Tr23 ) )
               => ~ ( gram_L1283001940subtr2 @ A1 @ Tr23 @ A32 ) ) ) ) ) )).

% subtr2.cases
thf(fact_150_subtr2_Osimps,axiom,
    ( gram_L1283001940subtr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr2: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33 = Tr2 )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 ) )
          | ? [Tr13: dtree,Ns2: ( set @ n ),Tr24: dtree,Tr33: dtree] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr13 )
              & ( A33 = Tr33 )
              & ( member @ n @ ( root @ Tr13 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr24 ) )
              & ( gram_L1283001940subtr2 @ Ns2 @ Tr24 @ Tr33 ) ) ) ) )).

% subtr2.simps
thf(fact_151_subtr2__StepR,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr22: dtree,Tr1: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr3 ) )
       => ( ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr22 )
         => ( gram_L1283001940subtr2 @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr2_StepR
thf(fact_152_subtr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L1283001940subtr2 @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns4: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
           => ( P @ Ns4 @ Tr7 @ Tr7 ) )
       => ( ! [Tr12: dtree,Ns4: ( set @ n ),Tr23: dtree,Tr32: dtree] :
              ( ( member @ n @ ( root @ Tr12 ) @ Ns4 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr23 ) )
               => ( ( gram_L1283001940subtr2 @ Ns4 @ Tr23 @ Tr32 )
                 => ( ( P @ Ns4 @ Tr23 @ Tr32 )
                   => ( P @ Ns4 @ Tr12 @ Tr32 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr2.inducts
thf(fact_153_inItr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,N: n] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L830233218_inItr @ Ns @ Tr1 @ N )
         => ( gram_L830233218_inItr @ Ns @ Tr @ N ) ) ) ) )).

% inItr.Ind
thf(fact_154_inItr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: n] :
      ( ( gram_L830233218_inItr @ A1 @ A22 @ A32 )
     => ( ( ( A32
            = ( root @ A22 ) )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L830233218_inItr @ A1 @ Tr12 @ A32 ) ) ) ) ) )).

% inItr.cases
thf(fact_155_inItr_Osimps,axiom,
    ( gram_L830233218_inItr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: n] :
          ( ? [Tr2: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33
                = ( root @ Tr2 ) )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 ) )
          | ? [Tr2: dtree,Ns2: ( set @ n ),Tr13: dtree,N2: n] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33 = N2 )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr2 ) )
              & ( gram_L830233218_inItr @ Ns2 @ Tr13 @ N2 ) ) ) ) )).

% inItr.simps
thf(fact_156_inItr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: n,P: ( ( set @ n ) > dtree > n > $o )] :
      ( ( gram_L830233218_inItr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns4: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
           => ( P @ Ns4 @ Tr7 @ ( root @ Tr7 ) ) )
       => ( ! [Tr7: dtree,Ns4: ( set @ n ),Tr12: dtree,N4: n] :
              ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
               => ( ( gram_L830233218_inItr @ Ns4 @ Tr12 @ N4 )
                 => ( ( P @ Ns4 @ Tr12 @ N4 )
                   => ( P @ Ns4 @ Tr7 @ N4 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inItr.inducts
thf(fact_157_inFr2__Ind,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr1 @ T2 )
     => ( ( member @ n @ ( root @ Tr ) @ Ns )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
         => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr2_Ind
thf(fact_158_type__copy__Rep__o__Abs,axiom,(
    ! [A: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( comp @ A @ B @ B @ Rep @ Abs )
        = ( id @ B ) ) ) )).

% type_copy_Rep_o_Abs
thf(fact_159_subtrOf__root,axiom,(
    ! [Tr: dtree,Tr6: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr6 ) @ ( cont @ Tr ) )
       => ( ( gram_L1614515765ubtrOf @ Tr @ ( root @ Tr6 ) )
          = Tr6 ) ) ) )).

% subtrOf_root
thf(fact_160_inFrr__def,axiom,
    ( gram_L805317505_inFrr
    = ( ^ [Ns2: ( set @ n ),Tr2: dtree,T3: t] :
        ? [Tr4: dtree] :
          ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr4 ) @ ( cont @ Tr2 ) )
          & ( gram_L1333338417e_inFr @ Ns2 @ Tr4 @ T3 ) ) ) )).

% inFrr_def
thf(fact_161_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X22: B,Y22: B] :
      ( ( ( sum_Inr @ B @ A @ X22 )
        = ( sum_Inr @ B @ A @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% sum.inject(2)
thf(fact_162_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B7: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B7 ) )
      = ( B2 = B7 ) ) )).

% old.sum.inject(2)
thf(fact_163_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X3: B,Y4: B] :
      ( ( ( sum_Inr @ B @ A @ X3 )
        = ( sum_Inr @ B @ A @ Y4 ) )
     => ( X3 = Y4 ) ) )).

% Inr_inject
thf(fact_164_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_165_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F22 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_166_inFr2_OInd,axiom,(
    ! [Tr1: dtree,Tr: dtree,Ns1: ( set @ n ),T2: t] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
     => ( ( gram_L805317441_inFr2 @ Ns1 @ Tr1 @ T2 )
       => ( gram_L805317441_inFr2 @ ( insert @ n @ ( root @ Tr ) @ Ns1 ) @ Tr @ T2 ) ) ) )).

% inFr2.Ind
thf(fact_167_insert__absorb2,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ X3 @ A2 ) )
      = ( insert @ A @ X3 @ A2 ) ) )).

% insert_absorb2
thf(fact_168_insert__iff,axiom,(
    ! [A: $tType,A3: A,B2: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B2 @ A2 ) )
      = ( ( A3 = B2 )
        | ( member @ A @ A3 @ A2 ) ) ) )).

% insert_iff
thf(fact_169_insertCI,axiom,(
    ! [A: $tType,A3: A,B3: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A3 @ B3 )
       => ( A3 = B2 ) )
     => ( member @ A @ A3 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertCI
thf(fact_170_insert__subset,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ B3 )
      = ( ( member @ A @ X3 @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% insert_subset
thf(fact_171_subset__insertI2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% subset_insertI2
thf(fact_172_subset__insertI,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: A] :
      ( ord_less_eq @ ( set @ A ) @ B3 @ ( insert @ A @ A3 @ B3 ) ) )).

% subset_insertI
thf(fact_173_subset__insert,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% subset_insert
thf(fact_174_insert__mono,axiom,(
    ! [A: $tType,C3: ( set @ A ),D3: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ D3 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A3 @ C3 ) @ ( insert @ A @ A3 @ D3 ) ) ) )).

% insert_mono
thf(fact_175_mk__disjoint__insert,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ? [B8: ( set @ A )] :
          ( ( A2
            = ( insert @ A @ A3 @ B8 ) )
          & ~ ( member @ A @ A3 @ B8 ) ) ) )).

% mk_disjoint_insert
thf(fact_176_insert__commute,axiom,(
    ! [A: $tType,X3: A,Y4: A,A2: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ Y4 @ A2 ) )
      = ( insert @ A @ Y4 @ ( insert @ A @ X3 @ A2 ) ) ) )).

% insert_commute
thf(fact_177_insert__eq__iff,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),B2: A,B3: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ A2 )
     => ( ~ ( member @ A @ B2 @ B3 )
       => ( ( ( insert @ A @ A3 @ A2 )
            = ( insert @ A @ B2 @ B3 ) )
          = ( ( ( A3 = B2 )
             => ( A2 = B3 ) )
            & ( ( A3 != B2 )
             => ? [C4: ( set @ A )] :
                  ( ( A2
                    = ( insert @ A @ B2 @ C4 ) )
                  & ~ ( member @ A @ B2 @ C4 )
                  & ( B3
                    = ( insert @ A @ A3 @ C4 ) )
                  & ~ ( member @ A @ A3 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_178_insert__absorb,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ( ( insert @ A @ A3 @ A2 )
        = A2 ) ) )).

% insert_absorb
thf(fact_179_insert__ident,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ~ ( member @ A @ X3 @ B3 )
       => ( ( ( insert @ A @ X3 @ A2 )
            = ( insert @ A @ X3 @ B3 ) )
          = ( A2 = B3 ) ) ) ) )).

% insert_ident
thf(fact_180_Set_Oset__insert,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A )] :
      ( ( member @ A @ X3 @ A2 )
     => ~ ( ! [B8: ( set @ A )] :
              ( ( A2
                = ( insert @ A @ X3 @ B8 ) )
             => ( member @ A @ X3 @ B8 ) ) ) ) )).

% Set.set_insert
thf(fact_181_insertI2,axiom,(
    ! [A: $tType,A3: A,B3: ( set @ A ),B2: A] :
      ( ( member @ A @ A3 @ B3 )
     => ( member @ A @ A3 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertI2
thf(fact_182_insertI1,axiom,(
    ! [A: $tType,A3: A,B3: ( set @ A )] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ B3 ) ) )).

% insertI1
thf(fact_183_insertE,axiom,(
    ! [A: $tType,A3: A,B2: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B2 @ A2 ) )
     => ( ( A3 != B2 )
       => ( member @ A @ A3 @ A2 ) ) ) )).

% insertE
thf(fact_184_insert__UNIV,axiom,(
    ! [A: $tType,X3: A] :
      ( ( insert @ A @ X3 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% insert_UNIV
thf(fact_185_inFr__Ind__minus,axiom,(
    ! [Ns1: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns1 @ Tr1 @ T2 )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ ( insert @ n @ ( root @ Tr ) @ Ns1 ) @ Tr @ T2 ) ) ) )).

% inFr_Ind_minus
thf(fact_186_insert__subsetI,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),X6: ( set @ A )] :
      ( ( member @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ X6 @ A2 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ X6 ) @ A2 ) ) ) )).

% insert_subsetI
thf(fact_187_inFr2_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L805317441_inFr2 @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ! [Tr12: dtree,Tr7: dtree,Ns12: ( set @ n )] :
                ( ( A1
                  = ( insert @ n @ ( root @ Tr7 ) @ Ns12 ) )
               => ( ( A22 = Tr7 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
                   => ~ ( gram_L805317441_inFr2 @ Ns12 @ Tr12 @ A32 ) ) ) ) ) ) ) )).

% inFr2.cases
thf(fact_188_inFr2_Osimps,axiom,
    ( gram_L805317441_inFr2
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr2: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr2 ) ) )
          | ? [Tr13: dtree,Tr2: dtree,Ns13: ( set @ n ),T3: t] :
              ( ( A12
                = ( insert @ n @ ( root @ Tr2 ) @ Ns13 ) )
              & ( A23 = Tr2 )
              & ( A33 = T3 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr2 ) )
              & ( gram_L805317441_inFr2 @ Ns13 @ Tr13 @ T3 ) ) ) ) )).

% inFr2.simps
thf(fact_189_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X3: A,Y4: B] :
      ( ( sum_Inl @ A @ B @ X3 )
     != ( sum_Inr @ B @ A @ Y4 ) ) )).

% Inl_Inr_False
thf(fact_190_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X3: B,Y4: A] :
      ( ( sum_Inr @ B @ A @ X3 )
     != ( sum_Inl @ A @ B @ Y4 ) ) )).

% Inr_Inl_False
thf(fact_191_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S2: B,F2: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X2: A] :
          ( ( S2
            = ( F2 @ ( sum_Inl @ A @ C @ X2 ) ) )
         => P )
     => ( ! [X2: C] :
            ( ( S2
              = ( F2 @ ( sum_Inr @ C @ A @ X2 ) ) )
           => P )
       => ! [X7: ( sum_sum @ A @ C )] :
            ( ( S2
              = ( F2 @ X7 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_192_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A4: A] :
          ( P @ ( sum_Inl @ A @ B @ A4 ) )
     => ( ! [B4: B] :
            ( P @ ( sum_Inr @ B @ A @ B4 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_193_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y4: ( sum_sum @ A @ B )] :
      ( ! [A4: A] :
          ( Y4
         != ( sum_Inl @ A @ B @ A4 ) )
     => ~ ( ! [B4: B] :
              ( Y4
             != ( sum_Inr @ B @ A @ B4 ) ) ) ) )).

% old.sum.exhaust
thf(fact_194_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X5: ( sum_sum @ A @ B )] :
            ( P2 @ X5 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X ) )
            & ! [X: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_all
thf(fact_195_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P2: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X5: ( sum_sum @ A @ B )] :
            ( P2 @ X5 ) )
      = ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X: A] :
                ( P3 @ ( sum_Inl @ A @ B @ X ) )
            | ? [X: B] :
                ( P3 @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_ex
thf(fact_196_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A3: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A3 ) ) )).

% Inr_not_Inl
thf(fact_197_sumE,axiom,(
    ! [A: $tType,B: $tType,S2: ( sum_sum @ A @ B )] :
      ( ! [X2: A] :
          ( S2
         != ( sum_Inl @ A @ B @ X2 ) )
     => ~ ( ! [Y: B] :
              ( S2
             != ( sum_Inr @ B @ A @ Y ) ) ) ) )).

% sumE
thf(fact_198_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A3: A,B7: B] :
      ( ( sum_Inl @ A @ B @ A3 )
     != ( sum_Inr @ B @ A @ B7 ) ) )).

% old.sum.distinct(1)
thf(fact_199_old_Osum_Odistinct_I2_J,axiom,(
    ! [B9: $tType,A7: $tType,B10: B9,A8: A7] :
      ( ( sum_Inr @ B9 @ A7 @ B10 )
     != ( sum_Inl @ A7 @ B9 @ A8 ) ) )).

% old.sum.distinct(2)
thf(fact_200_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X22 ) ) )).

% sum.distinct(1)
thf(fact_201_inFr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 ) ) ) )).

% inFr.Base
thf(fact_202_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_203_inFr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T2 )
     => ? [Tr5: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr5 @ Tr )
          & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr5 ) ) ) ) )).

% inFr_subtr
thf(fact_204_inFr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: t] :
      ( ( gram_L1333338417e_inFr @ A1 @ A22 @ A32 )
     => ( ( ( member @ n @ ( root @ A22 ) @ A1 )
         => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ A32 ) @ ( cont @ A22 ) ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr12: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ A22 ) )
               => ~ ( gram_L1333338417e_inFr @ A1 @ Tr12 @ A32 ) ) ) ) ) )).

% inFr.cases
thf(fact_205_inFr_Osimps,axiom,
    ( gram_L1333338417e_inFr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: t] :
          ( ? [Tr2: dtree,Ns2: ( set @ n ),T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T3 ) @ ( cont @ Tr2 ) ) )
          | ? [Tr2: dtree,Ns2: ( set @ n ),Tr13: dtree,T3: t] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr2 )
              & ( A33 = T3 )
              & ( member @ n @ ( root @ Tr2 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr2 ) )
              & ( gram_L1333338417e_inFr @ Ns2 @ Tr13 @ T3 ) ) ) ) )).

% inFr.simps
thf(fact_206_inFr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L1333338417e_inFr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns4: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr7 ) )
             => ( P @ Ns4 @ Tr7 @ T4 ) ) )
       => ( ! [Tr7: dtree,Ns4: ( set @ n ),Tr12: dtree,T4: t] :
              ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
               => ( ( gram_L1333338417e_inFr @ Ns4 @ Tr12 @ T4 )
                 => ( ( P @ Ns4 @ Tr12 @ T4 )
                   => ( P @ Ns4 @ Tr7 @ T4 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inFr.inducts
thf(fact_207_inFr2_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: t,P: ( ( set @ n ) > dtree > t > $o )] :
      ( ( gram_L805317441_inFr2 @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns4: ( set @ n ),T4: t] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns4 )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T4 ) @ ( cont @ Tr7 ) )
             => ( P @ Ns4 @ Tr7 @ T4 ) ) )
       => ( ! [Tr12: dtree,Tr7: dtree,Ns12: ( set @ n ),T4: t] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr7 ) )
             => ( ( gram_L805317441_inFr2 @ Ns12 @ Tr12 @ T4 )
               => ( ( P @ Ns12 @ Tr12 @ T4 )
                 => ( P @ ( insert @ n @ ( root @ Tr7 ) @ Ns12 ) @ Tr7 @ T4 ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inFr2.inducts
thf(fact_208_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S2: ( sum_sum @ A @ B )] :
      ( ! [X2: A] :
          ( S2
         != ( sum_Inl @ A @ B @ X2 ) )
     => ~ ( ! [X2: B] :
              ( S2
             != ( sum_Inr @ B @ A @ X2 ) ) ) ) )).

% obj_sumE
thf(fact_209_Inl__cont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr ) ) ) ) )).

% Inl_cont_hsubst_neq
thf(fact_210_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A3: A,F2: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F2 @ B3 ) )
      = ( member @ B @ ( F2 @ A3 ) @ B3 ) ) )).

% vimage_eq
thf(fact_211_vimageI,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),A3: B,B2: A,B3: ( set @ A )] :
      ( ( ( F2 @ A3 )
        = B2 )
     => ( ( member @ A @ B2 @ B3 )
       => ( member @ B @ A3 @ ( vimage @ B @ A @ F2 @ B3 ) ) ) ) )).

% vimageI
thf(fact_212_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B )] :
      ( ( vimage @ A @ B @ F2 @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_213_vimage__id,axiom,(
    ! [A: $tType] :
      ( ( vimage @ A @ A @ ( id @ A ) )
      = ( id @ ( set @ A ) ) ) )).

% vimage_id
thf(fact_214_Inl__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr0 ) ) ) ) )).

% Inl_cont_hsubst_eq
thf(fact_215_set_Ocompositionality,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( C > B ),G2: ( B > A ),Set: ( set @ A )] :
      ( ( vimage @ C @ B @ F2 @ ( vimage @ B @ A @ G2 @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G2 @ F2 ) @ Set ) ) )).

% set.compositionality
thf(fact_216_vimage__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( A > B ),G2: ( B > C ),X3: ( set @ C )] :
      ( ( vimage @ A @ B @ F2 @ ( vimage @ B @ C @ G2 @ X3 ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G2 @ F2 ) @ X3 ) ) )).

% vimage_comp
thf(fact_217_set_Ocomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( C > B ),G2: ( B > A )] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F2 ) @ ( vimage @ B @ A @ G2 ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G2 @ F2 ) ) ) )).

% set.comp
thf(fact_218_vimage__mono,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B3: ( set @ A ),F2: ( B > A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F2 @ A2 ) @ ( vimage @ B @ A @ F2 @ B3 ) ) ) )).

% vimage_mono
thf(fact_219_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F2: ( A > B ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ ( F2 @ X2 ) )
          = ( Q @ X2 ) )
     => ( ( vimage @ A @ B @ F2 @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_220_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),A3: B,A2: ( set @ A )] :
      ( ( member @ A @ ( F2 @ A3 ) @ A2 )
     => ( member @ B @ A3 @ ( vimage @ B @ A @ F2 @ A2 ) ) ) )).

% vimageI2
thf(fact_221_vimageE,axiom,(
    ! [A: $tType,B: $tType,A3: A,F2: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F2 @ B3 ) )
     => ( member @ B @ ( F2 @ A3 ) @ B3 ) ) )).

% vimageE
thf(fact_222_vimageD,axiom,(
    ! [A: $tType,B: $tType,A3: A,F2: ( A > B ),A2: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F2 @ A2 ) )
     => ( member @ B @ ( F2 @ A3 ) @ A2 ) ) )).

% vimageD
thf(fact_223_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X3: A,Y4: A] :
      ( ( X3 != Y4 )
     => ( ( sum_Inr @ A @ B @ X3 )
       != ( sum_Inr @ A @ B @ Y4 ) ) ) )).

% not_arg_cong_Inr
thf(fact_224_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ ( sum_sum @ A @ B ) ),B3: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A2 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B3 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A2 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B3 ) )
       => ( A2 = B3 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_225_inFr__hsubst__imp,axiom,(
    ! [Ns: ( set @ n ),Tr0: dtree,Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) @ T2 )
     => ( ( member @ t @ T2 @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr0 ) ) )
        | ( gram_L805317505_inFrr @ ( minus_minus @ ( set @ n ) @ Ns @ ( insert @ n @ ( root @ Tr0 ) @ ( bot_bot @ ( set @ n ) ) ) ) @ Tr0 @ T2 )
        | ( gram_L1333338417e_inFr @ ( minus_minus @ ( set @ n ) @ Ns @ ( insert @ n @ ( root @ Tr0 ) @ ( bot_bot @ ( set @ n ) ) ) ) @ Tr @ T2 ) ) ) )).

% inFr_hsubst_imp
thf(fact_226_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_227_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_228_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X: A] :
            ~ ( member @ A @ X @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_229_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% Collect_empty_eq
thf(fact_230_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% empty_Collect_eq
thf(fact_231_DiffI,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( ~ ( member @ A @ C2 @ B3 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) ) )).

% DiffI
thf(fact_232_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
      = ( ( member @ A @ C2 @ A2 )
        & ~ ( member @ A @ C2 @ B3 ) ) ) )).

% Diff_iff
thf(fact_233_Diff__idemp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ B3 )
      = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) )).

% Diff_idemp
thf(fact_234_subset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_235_empty__subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) )).

% empty_subsetI
thf(fact_236_singletonI,axiom,(
    ! [A: $tType,A3: A] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_237_Diff__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = A2 ) )).

% Diff_empty
thf(fact_238_empty__Diff,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_239_Diff__cancel,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ A2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_240_Diff__insert0,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) )
        = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% Diff_insert0
thf(fact_241_insert__Diff1,axiom,(
    ! [A: $tType,X3: A,B3: ( set @ A ),A2: ( set @ A )] :
      ( ( member @ A @ X3 @ B3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ B3 )
        = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% insert_Diff1
thf(fact_242_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B )] :
      ( ( vimage @ A @ B @ F2 @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_243_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A3: A,A2: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A3 @ A2 ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_244_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A3 @ A2 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_245_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A2 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% Diff_eq_empty_iff
thf(fact_246_insert__Diff__single,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( insert @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A3 @ A2 ) ) )).

% insert_Diff_single
thf(fact_247_Diff__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_UNIV
thf(fact_248_vimage__singleton__eq,axiom,(
    ! [A: $tType,B: $tType,A3: A,F2: ( A > B ),B2: B] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F2 @ ( insert @ B @ B2 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( ( F2 @ A3 )
        = B2 ) ) )).

% vimage_singleton_eq
thf(fact_249_vimage__Diff,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),A2: ( set @ B ),B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F2 @ ( minus_minus @ ( set @ B ) @ A2 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A2 ) @ ( vimage @ A @ B @ F2 @ B3 ) ) ) )).

% vimage_Diff
thf(fact_250_inFr__hsubst__minus,axiom,(
    ! [Ns: ( set @ n ),Tr0: dtree,Tr: dtree,T2: t] :
      ( ( gram_L1333338417e_inFr @ ( minus_minus @ ( set @ n ) @ Ns @ ( insert @ n @ ( root @ Tr0 ) @ ( bot_bot @ ( set @ n ) ) ) ) @ Tr @ T2 )
     => ( gram_L1333338417e_inFr @ Ns @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) @ T2 ) ) )).

% inFr_hsubst_minus
thf(fact_251_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_252_DiffE,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ( ( member @ A @ C2 @ A2 )
         => ( member @ A @ C2 @ B3 ) ) ) )).

% DiffE
thf(fact_253_DiffD1,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ( member @ A @ C2 @ A2 ) ) )).

% DiffD1
thf(fact_254_DiffD2,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ( member @ A @ C2 @ B3 ) ) )).

% DiffD2
thf(fact_255_emptyE,axiom,(
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE

%----Type constructors (19)
thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A7: $tType,A9: $tType] :
      ( ( order_top @ A9 @ ( type2 @ A9 ) )
     => ( order_top @ ( A7 > A9 ) @ ( type2 @ ( A7 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A7: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A7 > A9 ) @ ( type2 @ ( A7 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A7 > A9 ) @ ( type2 @ ( A7 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A7: $tType,A9: $tType] :
      ( ( top @ A9 @ ( type2 @ A9 ) )
     => ( top @ ( A7 > A9 ) @ ( type2 @ ( A7 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A7 > A9 ) @ ( type2 @ ( A7 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A7: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A7 > A9 ) @ ( type2 @ ( A7 > A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_1,axiom,(
    ! [A7: $tType] :
      ( order_top @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_2,axiom,(
    ! [A7: $tType] :
      ( preorder @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_3,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_4,axiom,(
    ! [A7: $tType] :
      ( top @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_5,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_6,axiom,(
    ! [A7: $tType] :
      ( bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_7,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_8,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_9,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_10,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_11,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_12,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X3: A,Y4: A] :
      ( ( if @ A @ $false @ X3 @ Y4 )
      = Y4 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X3: A,Y4: A] :
      ( ( if @ A @ $true @ X3 @ Y4 )
      = X3 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( f @ ( root @ tr ) )
    = tr )).

%------------------------------------------------------------------------------
