%------------------------------------------------------------------------------
% File     : COM192^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 1005
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__1005.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  323 (   2 unit;  51 type;   0 defn)
%            Number of atoms       : 5079 ( 316 equality;2777 variable)
%            Maximal formula depth :   22 (  10 average)
%            Number of connectives : 4456 (  38   ~;   4   |;  47   &;4118   @)
%                                         (   0 <=>; 249  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  365 ( 365   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   55 (  51   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1152 (   2 sgn;1048   !;  34   ?;  34   ^)
%                                         (1152   :;  36  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:46:10.588
%------------------------------------------------------------------------------
%----Could-be-implicit typings (8)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (43)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Fun_Oinj__on,type,(
    inj_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OH,type,(
    gram_L1451583624elle_H: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OH__c,type,(
    gram_L1221482011le_H_c: dtree > n > ( set @ ( sum_sum @ t @ n ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OH__r,type,(
    gram_L1221482026le_H_r: dtree > n > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OS,type,(
    gram_L1451583635elle_S: n > ( set @ ( sum_sum @ t @ n ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Odeftr,type,(
    gram_L1231612515_deftr: n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst,type,(
    gram_L1004374585hsubst: dtree > dtree > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c,type,(
    gram_L1905609002ubst_c: dtree > dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__r,type,(
    gram_L1905609017ubst_r: dtree > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr2,type,(
    gram_L805317441_inFr2: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Opick,type,(
    gram_L315592705e_pick: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr,type,(
    gram_L716654942_subtr: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OsubtrOf,type,(
    gram_L1614515765ubtrOf: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Owf,type,(
    gram_L864798063lle_wf: dtree > $o )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_Omap__sum,type,(
    sum_map_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,(
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_a,type,(
    a: t )).

thf(sy_v_n,type,(
    n2: n )).

thf(sy_v_t__tr,type,(
    t_tr: ( sum_sum @ t @ dtree ) )).

thf(sy_v_tr0,type,(
    tr0: dtree )).

%----Relevant facts (256)
thf(fact_0_n,axiom,
    ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ n2 )).

% n
thf(fact_1_root__H__pick,axiom,(
    ! [N: n] :
      ( ( root @ ( gram_L1451583624elle_H @ tr0 @ N ) )
      = ( root @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) )).

% root_H_pick
thf(fact_2_t__tr,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ t_tr @ ( cont @ ( gram_L315592705e_pick @ tr0 @ n2 ) ) )).

% t_tr
thf(fact_3_root__pick,axiom,(
    ! [N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N )
     => ( ( root @ ( gram_L315592705e_pick @ tr0 @ N ) )
        = N ) ) )).

% root_pick
thf(fact_4_H__r__def,axiom,(
    ! [N: n] :
      ( ( gram_L1221482026le_H_r @ tr0 @ N )
      = ( root @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) )).

% H_r_def
thf(fact_5_root__H,axiom,(
    ! [N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N )
     => ( ( root @ ( gram_L1451583624elle_H @ tr0 @ N ) )
        = N ) ) )).

% root_H
thf(fact_6_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__H,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N )
     => ( ( root @ ( gram_L1451583624elle_H @ Tr0 @ N ) )
        = N ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_H
thf(fact_7_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__pick,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N )
     => ( ( root @ ( gram_L315592705e_pick @ Tr0 @ N ) )
        = N ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_pick
thf(fact_8_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_9_Gram__Lang__Mirabelle__ojxrtuoybn_Oroot__H__pick,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( root @ ( gram_L1451583624elle_H @ Tr0 @ N ) )
      = ( root @ ( gram_L315592705e_pick @ Tr0 @ N ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.root_H_pick
thf(fact_10_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_11_wf__pick,axiom,(
    ! [N: n] :
      ( ( gram_L864798063lle_wf @ tr0 )
     => ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N )
       => ( gram_L864798063lle_wf @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) ) )).

% wf_pick
thf(fact_12_pick,axiom,(
    ! [N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N )
     => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ ( gram_L315592705e_pick @ tr0 @ N ) @ tr0 )
        & ( ( root @ ( gram_L315592705e_pick @ tr0 @ N ) )
          = N ) ) ) )).

% pick
thf(fact_13_comp__id,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( comp @ A @ B @ A @ F @ ( id @ A ) )
      = F ) )).

% comp_id
thf(fact_14_id__comp,axiom,(
    ! [B: $tType,A: $tType,G: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G )
      = G ) )).

% id_comp
thf(fact_15_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_16_subtr__H,axiom,(
    ! [N: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N )
     => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr1 @ ( gram_L1451583624elle_H @ tr0 @ N ) )
       => ? [N1: n] :
            ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N1 )
            & ( Tr1
              = ( gram_L1451583624elle_H @ tr0 @ N1 ) ) ) ) ) )).

% subtr_H
thf(fact_17_subtr__pick,axiom,(
    ! [N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ tr0 @ N )
     => ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ ( gram_L315592705e_pick @ tr0 @ N ) @ tr0 ) ) )).

% subtr_pick
thf(fact_18_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_19_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: A] :
      ( ( ( sum_Inl @ A @ B @ A2 )
        = ( sum_Inl @ A @ B @ A3 ) )
      = ( A2 = A3 ) ) )).

% old.sum.inject(1)
thf(fact_20_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_apply
thf(fact_21_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F2: ( B > A ),G2: ( C > B ),X: C] :
            ( F2 @ ( G2 @ X ) ) ) ) )).

% comp_apply
thf(fact_22_UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_23_wf__subtr,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L864798063lle_wf @ Tr ) ) ) )).

% wf_subtr
thf(fact_24_subtr__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Tr3: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr2 @ Tr3 )
       => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) )).

% subtr_trans
thf(fact_25_subtr__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr2 ) @ Ns ) ) )).

% subtr_rootR_in
thf(fact_26_subtr__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr_rootL_in
thf(fact_27_subtr_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L716654942_subtr @ Ns @ Tr @ Tr ) ) )).

% subtr.Refl
thf(fact_28_subtr__inItr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L830233218_inItr @ Ns @ Tr1 @ N ) ) ) )).

% subtr_inItr
thf(fact_29_inItr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N )
     => ? [Tr4: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr4 @ Tr )
          & ( ( root @ Tr4 )
            = N ) ) ) )).

% inItr_subtr
thf(fact_30_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_31_UNIV__eq__I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A4 )
     => ( ( top_top @ ( set @ A ) )
        = A4 ) ) )).

% UNIV_eq_I
thf(fact_32_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_33_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C2 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_34_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_35_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_36_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_37_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F2: ( B > C ),G2: ( A > B ),X: A] :
            ( F2 @ ( G2 @ X ) ) ) ) )).

% comp_def
thf(fact_38_eq__id__iff,axiom,(
    ! [A: $tType,F: ( A > A )] :
      ( ( ! [X: A] :
            ( ( F @ X )
            = X ) )
      = ( F
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_39_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_def
thf(fact_40_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X2 )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X2 = Y ) ) )).

% Inl_inject
thf(fact_41_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr__pick,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N )
     => ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ ( gram_L315592705e_pick @ Tr0 @ N ) @ Tr0 ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.subtr_pick
thf(fact_42_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr__H,axiom,(
    ! [Tr0: dtree,N: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N )
     => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr1 @ ( gram_L1451583624elle_H @ Tr0 @ N ) )
       => ? [N1: n] :
            ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N1 )
            & ( Tr1
              = ( gram_L1451583624elle_H @ Tr0 @ N1 ) ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.subtr_H
thf(fact_43_Gram__Lang__Mirabelle__ojxrtuoybn_Owf__pick,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N )
       => ( gram_L864798063lle_wf @ ( gram_L315592705e_pick @ Tr0 @ N ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.wf_pick
thf(fact_44_Gram__Lang__Mirabelle__ojxrtuoybn_Opick,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N )
     => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ ( gram_L315592705e_pick @ Tr0 @ N ) @ Tr0 )
        & ( ( root @ ( gram_L315592705e_pick @ Tr0 @ N ) )
          = N ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.pick
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_Gram__Lang__Mirabelle__ojxrtuoybn_OH__r__def,axiom,
    ( gram_L1221482026le_H_r
    = ( ^ [Tr02: dtree,N2: n] :
          ( root @ ( gram_L315592705e_pick @ Tr02 @ N2 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.H_r_def
thf(fact_50_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_51_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_52_map__sum_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: ( C > E ),G: ( D > F3 ),H: ( A > C ),I: ( B > D ),Sum: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ C @ E @ D @ F3 @ F @ G @ ( sum_map_sum @ A @ C @ B @ D @ H @ I @ Sum ) )
      = ( sum_map_sum @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ F @ H ) @ ( comp @ D @ F3 @ B @ G @ I ) @ Sum ) ) )).

% map_sum.compositionality
thf(fact_53_sum_Omap__comp,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: ( C > E ),G22: ( D > F3 ),F1: ( A > C ),F22: ( B > D ),V: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ C @ E @ D @ F3 @ G1 @ G22 @ ( sum_map_sum @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( sum_map_sum @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F3 @ B @ G22 @ F22 ) @ V ) ) )).

% sum.map_comp
thf(fact_54_map__sum_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E: $tType,F3: $tType,D: $tType,B: $tType,F: ( C > E ),G: ( D > F3 ),H: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( sum_sum @ C @ D ) @ ( sum_sum @ E @ F3 ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ C @ E @ D @ F3 @ F @ G ) @ ( sum_map_sum @ A @ C @ B @ D @ H @ I ) )
      = ( sum_map_sum @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ F @ H ) @ ( comp @ D @ F3 @ B @ G @ I ) ) ) )).

% map_sum.comp
thf(fact_55_sum_Omap__id0,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_map_sum @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( sum_sum @ A @ B ) ) ) )).

% sum.map_id0
thf(fact_56_sum_Omap__id,axiom,(
    ! [B: $tType,A: $tType,T2: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) @ T2 )
      = T2 ) )).

% sum.map_id
thf(fact_57_map__sum_Osimps_I1_J,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F1: ( A > C ),F22: ( B > D ),A2: A] :
      ( ( sum_map_sum @ A @ C @ B @ D @ F1 @ F22 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( sum_Inl @ C @ D @ ( F1 @ A2 ) ) ) )).

% map_sum.simps(1)
thf(fact_58_H__def,axiom,
    ( ( gram_L1451583624elle_H @ tr0 )
    = ( unfold @ n @ ( gram_L1221482026le_H_r @ tr0 ) @ ( gram_L1221482011le_H_c @ tr0 ) ) )).

% H_def
thf(fact_59_root__o__deftr,axiom,
    ( ( comp @ dtree @ n @ n @ root @ gram_L1231612515_deftr )
    = ( id @ n ) )).

% root_o_deftr
thf(fact_60_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_61_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_62_H__c__def,axiom,(
    ! [N: n] :
      ( ( gram_L1221482011le_H_c @ tr0 @ N )
      = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) ) )).

% H_c_def
thf(fact_63_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A2: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( F1 @ A2 ) ) )).

% old.sum.simps(7)
thf(fact_64_map__sum__o__inj_I1_J,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( D > C )] :
      ( ( comp @ ( sum_sum @ A @ D ) @ ( sum_sum @ B @ C ) @ A @ ( sum_map_sum @ A @ B @ D @ C @ F @ G ) @ ( sum_Inl @ A @ D ) )
      = ( comp @ B @ ( sum_sum @ B @ C ) @ A @ ( sum_Inl @ B @ C ) @ F ) ) )).

% map_sum_o_inj(1)
thf(fact_65_map__sum__InlD,axiom,(
    ! [D: $tType,B: $tType,C: $tType,A: $tType,F: ( C > A ),G: ( D > B ),Z: ( sum_sum @ C @ D ),X2: A] :
      ( ( ( sum_map_sum @ C @ A @ D @ B @ F @ G @ Z )
        = ( sum_Inl @ A @ B @ X2 ) )
     => ? [Y2: C] :
          ( ( Z
            = ( sum_Inl @ C @ D @ Y2 ) )
          & ( ( F @ Y2 )
            = X2 ) ) ) )).

% map_sum_InlD
thf(fact_66_map__sum__if__distrib__then_I1_J,axiom,(
    ! [D: $tType,B: $tType,C: $tType,A: $tType,E2: $o,F: ( A > B ),G: ( C > D ),X2: A,Y: ( sum_sum @ A @ C )] :
      ( ( E2
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E2 @ ( sum_Inl @ A @ C @ X2 ) @ Y ) )
          = ( sum_Inl @ B @ D @ ( F @ X2 ) ) ) )
      & ( ~ ( E2 )
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E2 @ ( sum_Inl @ A @ C @ X2 ) @ Y ) )
          = ( sum_map_sum @ A @ B @ C @ D @ F @ G @ Y ) ) ) ) )).

% map_sum_if_distrib_then(1)
thf(fact_67_map__sum__if__distrib__else_I1_J,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,E2: $o,F: ( A > B ),G: ( C > D ),X2: ( sum_sum @ A @ C ),Y: A] :
      ( ( E2
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E2 @ X2 @ ( sum_Inl @ A @ C @ Y ) ) )
          = ( sum_map_sum @ A @ B @ C @ D @ F @ G @ X2 ) ) )
      & ( ~ ( E2 )
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E2 @ X2 @ ( sum_Inl @ A @ C @ Y ) ) )
          = ( sum_Inl @ B @ D @ ( F @ Y ) ) ) ) ) )).

% map_sum_if_distrib_else(1)
thf(fact_68_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X2: B,A4: ( set @ B )] :
      ( ( B2
        = ( F @ X2 ) )
     => ( ( member @ B @ X2 @ A4 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A4 ) ) ) ) )).

% image_eqI
thf(fact_69_image__id,axiom,(
    ! [A: $tType] :
      ( ( image @ A @ A @ ( id @ A ) )
      = ( id @ ( set @ A ) ) ) )).

% image_id
thf(fact_70_root__deftr,axiom,(
    ! [N: n] :
      ( ( root @ ( gram_L1231612515_deftr @ N ) )
      = N ) )).

% root_deftr
thf(fact_71_Inl__oplus__iff,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Tr: A,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
      = ( member @ ( sum_sum @ A @ C ) @ ( sum_Inl @ A @ C @ Tr ) @ Tns ) ) )).

% Inl_oplus_iff
thf(fact_72_imageI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A4: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X2 @ A4 )
     => ( member @ B @ ( F @ X2 ) @ ( image @ A @ B @ F @ A4 ) ) ) )).

% imageI
thf(fact_73_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z: A,F: ( B > A ),A4: ( set @ B )] :
      ( ( member @ A @ Z @ ( image @ B @ A @ F @ A4 ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A4 )
            & ( Z
              = ( F @ X ) ) ) ) ) )).

% image_iff
thf(fact_74_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A4 ) )
          & ( P @ X4 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A4 )
          & ( P @ ( F @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_75_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N3: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M = N3 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N3 )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G @ N3 ) ) ) ) )).

% image_cong
thf(fact_76_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A4 ) )
         => ( P @ X3 ) )
     => ! [X4: B] :
          ( ( member @ B @ X4 @ A4 )
         => ( P @ ( F @ X4 ) ) ) ) )).

% ball_imageD
thf(fact_77_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A4: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X2 @ A4 )
     => ( ( B2
          = ( F @ X2 ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A4 ) ) ) ) )).

% rev_image_eqI
thf(fact_78_surjD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X3: B] :
          ( Y
          = ( F @ X3 ) ) ) )).

% surjD
thf(fact_79_surjE,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X3: B] :
              ( Y
             != ( F @ X3 ) ) ) ) )).

% surjE
thf(fact_80_surjI,axiom,(
    ! [B: $tType,A: $tType,G: ( B > A ),F: ( A > B )] :
      ( ! [X3: A] :
          ( ( G @ ( F @ X3 ) )
          = X3 )
     => ( ( image @ B @ A @ G @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_81_rangeI,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X2: B] :
      ( member @ A @ ( F @ X2 ) @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_82_surj__def,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y3: A] :
          ? [X: B] :
            ( Y3
            = ( F @ X ) ) ) ) )).

% surj_def
thf(fact_83_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X2: B] :
      ( ( B2
        = ( F @ X2 ) )
     => ( member @ A @ B2 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_84_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),R: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G @ R ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F @ G ) @ R ) ) )).

% image_comp
thf(fact_85_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( B > A ),A4: ( set @ B ),G: ( C > A ),B3: ( set @ C ),H: ( A > D )] :
      ( ( ( image @ B @ A @ F @ A4 )
        = ( image @ C @ A @ G @ B3 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H @ F ) @ A4 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H @ G ) @ B3 ) ) ) )).

% image_eq_imp_comp
thf(fact_86_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_87_comp__surj,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( A > C )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( image @ A @ C @ G @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ C ) ) )
       => ( ( image @ B @ C @ ( comp @ A @ C @ B @ G @ F ) @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ C ) ) ) ) ) )).

% comp_surj
thf(fact_88_fun_Oset__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,F: ( A > B ),V: ( D > A )] :
      ( ( image @ D @ B @ ( comp @ A @ B @ D @ F @ V ) @ ( top_top @ ( set @ D ) ) )
      = ( image @ A @ B @ F @ ( image @ D @ A @ V @ ( top_top @ ( set @ D ) ) ) ) ) )).

% fun.set_map
thf(fact_89_fun_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( D > A ),Ya: ( D > A ),F: ( A > B ),G: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z2: A] :
            ( ( member @ A @ Z2 @ ( image @ D @ A @ Ya @ ( top_top @ ( set @ D ) ) ) )
           => ( ( F @ Z2 )
              = ( G @ Z2 ) ) )
       => ( ( comp @ A @ B @ D @ F @ X2 )
          = ( comp @ A @ B @ D @ G @ Ya ) ) ) ) )).

% fun.map_cong
thf(fact_90_fun_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( D > A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z2: A] :
          ( ( member @ A @ Z2 @ ( image @ D @ A @ X2 @ ( top_top @ ( set @ D ) ) ) )
         => ( ( F @ Z2 )
            = ( G @ Z2 ) ) )
     => ( ( comp @ A @ B @ D @ F @ X2 )
        = ( comp @ A @ B @ D @ G @ X2 ) ) ) )).

% fun.map_cong0
thf(fact_91_fun_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( D > A ),Xa: ( D > A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z2: A,Za: A] :
          ( ( member @ A @ Z2 @ ( image @ D @ A @ X2 @ ( top_top @ ( set @ D ) ) ) )
         => ( ( member @ A @ Za @ ( image @ D @ A @ Xa @ ( top_top @ ( set @ D ) ) ) )
           => ( ( ( F @ Z2 )
                = ( Fa @ Za ) )
             => ( Z2 = Za ) ) ) )
     => ( ( ( comp @ A @ B @ D @ F @ X2 )
          = ( comp @ A @ B @ D @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% fun.inj_map_strong
thf(fact_92_surj__id,axiom,(
    ! [A: $tType] :
      ( ( image @ A @ A @ ( id @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% surj_id
thf(fact_93_Inl__oplus__elim,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Tr: A,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
     => ( member @ ( sum_sum @ A @ C ) @ ( sum_Inl @ A @ C @ Tr ) @ Tns ) ) )).

% Inl_oplus_elim
thf(fact_94_wf__deftr,axiom,(
    ! [N: n] :
      ( gram_L864798063lle_wf @ ( gram_L1231612515_deftr @ N ) ) )).

% wf_deftr
thf(fact_95_Gram__Lang__Mirabelle__ojxrtuoybn_OH__def,axiom,
    ( gram_L1451583624elle_H
    = ( ^ [Tr02: dtree] :
          ( unfold @ n @ ( gram_L1221482026le_H_r @ Tr02 ) @ ( gram_L1221482011le_H_c @ Tr02 ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.H_def
thf(fact_96_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X2: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X2 ) )
        = ( H @ ( K @ X2 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ C @ H @ K @ X2 ) ) ) )).

% comp_apply_eq
thf(fact_97_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_98_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_99_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_100_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_101_Gram__Lang__Mirabelle__ojxrtuoybn_OH__c__def,axiom,
    ( gram_L1221482011le_H_c
    = ( ^ [Tr02: dtree,N2: n] :
          ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ ( gram_L315592705e_pick @ Tr02 @ N2 ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.H_c_def
thf(fact_102_subtr__deftr,axiom,(
    ! [Ns: ( set @ n ),Tr5: dtree,N: n] :
      ( ( gram_L716654942_subtr @ Ns @ Tr5 @ ( gram_L1231612515_deftr @ N ) )
     => ( Tr5
        = ( gram_L1231612515_deftr @ ( root @ Tr5 ) ) ) ) )).

% subtr_deftr
thf(fact_103_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),G: ( A > B ),X2: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X2 ) )
        = X2 ) ) )).

% pointfree_idE
thf(fact_104_deftr__def,axiom,
    ( gram_L1231612515_deftr
    = ( unfold @ n @ ( id @ n ) @ gram_L1451583635elle_S ) )).

% deftr_def
thf(fact_105_surj__fun__eq,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( B > A ),X5: ( set @ B ),G1: ( A > C ),G22: ( A > C )] :
      ( ( ( image @ B @ A @ F @ X5 )
        = ( top_top @ ( set @ A ) ) )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ X5 )
           => ( ( comp @ A @ C @ B @ G1 @ F @ X3 )
              = ( comp @ A @ C @ B @ G22 @ F @ X3 ) ) )
       => ( G1 = G22 ) ) ) )).

% surj_fun_eq
thf(fact_106_finite__H__c,axiom,(
    ! [N: n] :
      ( finite_finite2 @ ( sum_sum @ t @ n ) @ ( gram_L1221482011le_H_c @ tr0 @ N ) ) )).

% finite_H_c
thf(fact_107_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_108_cont__H,axiom,(
    ! [N: n] :
      ( ( cont @ ( gram_L1451583624elle_H @ tr0 @ N ) )
      = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( comp @ n @ dtree @ dtree @ ( gram_L1451583624elle_H @ tr0 ) @ root ) ) @ ( cont @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) ) )).

% cont_H
thf(fact_109_dtree__cong,axiom,(
    ! [Tr: dtree,Tr5: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr5 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr5 ) )
       => ( Tr = Tr5 ) ) ) )).

% dtree_cong
thf(fact_110_hsubst__c__def,axiom,
    ( gram_L1905609002ubst_c
    = ( ^ [Tr02: dtree,Tr6: dtree] :
          ( if @ ( set @ ( sum_sum @ t @ dtree ) )
          @ ( ( root @ Tr6 )
            = ( root @ Tr02 ) )
          @ ( cont @ Tr02 )
          @ ( cont @ Tr6 ) ) ) )).

% hsubst_c_def
thf(fact_111_top1I,axiom,(
    ! [A: $tType,X2: A] :
      ( top_top @ ( A > $o ) @ X2 ) )).

% top1I
thf(fact_112_cont__deftr,axiom,(
    ! [N: n] :
      ( ( cont @ ( gram_L1231612515_deftr @ N ) )
      = ( image @ ( sum_sum @ t @ n ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ n @ dtree @ ( id @ t ) @ gram_L1231612515_deftr ) @ ( gram_L1451583635elle_S @ N ) ) ) )).

% cont_deftr
thf(fact_113_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X2: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X2 ) )
      = P ) )).

% top_conj(2)
thf(fact_114_top__conj_I1_J,axiom,(
    ! [A: $tType,X2: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X2 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_115_finite__S,axiom,(
    ! [N: n] :
      ( finite_finite2 @ ( sum_sum @ t @ n ) @ ( gram_L1451583635elle_S @ N ) ) )).

% finite_S
thf(fact_116_unfold_I2_J,axiom,(
    ! [A: $tType,Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A,Rt: ( A > n )] :
      ( ( finite_finite2 @ ( sum_sum @ t @ A ) @ ( Ct @ B2 ) )
     => ( ( cont @ ( unfold @ A @ Rt @ Ct @ B2 ) )
        = ( image @ ( sum_sum @ t @ A ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ A @ dtree @ ( id @ t ) @ ( unfold @ A @ Rt @ Ct ) ) @ ( Ct @ B2 ) ) ) ) )).

% unfold(2)
thf(fact_117_Gram__Lang__Mirabelle__ojxrtuoybn_Ofinite__H__c,axiom,(
    ! [Tr0: dtree,N: n] :
      ( finite_finite2 @ ( sum_sum @ t @ n ) @ ( gram_L1221482011le_H_c @ Tr0 @ N ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.finite_H_c
thf(fact_118_Gram__Lang__Mirabelle__ojxrtuoybn_Ocont__H,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( cont @ ( gram_L1451583624elle_H @ Tr0 @ N ) )
      = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( comp @ n @ dtree @ dtree @ ( gram_L1451583624elle_H @ Tr0 ) @ root ) ) @ ( cont @ ( gram_L315592705e_pick @ Tr0 @ N ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.cont_H
thf(fact_119_finite__Plus__UNIV__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_Plus_UNIV_iff
thf(fact_120_finite__option__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_option_UNIV
thf(fact_121_finite__imageI,axiom,(
    ! [B: $tType,A: $tType,F4: ( set @ A ),H: ( A > B )] :
      ( ( finite_finite2 @ A @ F4 )
     => ( finite_finite2 @ B @ ( image @ A @ B @ H @ F4 ) ) ) )).

% finite_imageI
thf(fact_122_cont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr0 ) )
     => ( ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
        = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ Tr0 ) ) @ ( cont @ Tr ) ) ) ) )).

% cont_hsubst_neq
thf(fact_123_cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
        = ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ dtree @ dtree @ ( id @ t ) @ ( gram_L1004374585hsubst @ Tr0 ) ) @ ( cont @ Tr0 ) ) ) ) )).

% cont_hsubst_eq
thf(fact_124_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A5: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_125_root__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
      = ( root @ Tr ) ) )).

% root_hsubst
thf(fact_126_root__o__subst,axiom,(
    ! [Tr0: dtree] :
      ( ( comp @ dtree @ n @ dtree @ root @ ( gram_L1004374585hsubst @ Tr0 ) )
      = root ) )).

% root_o_subst
thf(fact_127_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_128_finite__N,axiom,
    ( finite_finite2 @ n @ ( top_top @ ( set @ n ) ) )).

% finite_N
thf(fact_129_hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( gram_L1004374585hsubst @ Tr0 @ Tr )
        = ( gram_L1004374585hsubst @ Tr0 @ Tr0 ) ) ) )).

% hsubst_eq
thf(fact_130_wf__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( ( gram_L864798063lle_wf @ Tr )
       => ( gram_L864798063lle_wf @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) ) ) )).

% wf_hsubst
thf(fact_131_finite__hsubst__c,axiom,(
    ! [Tr0: dtree,N: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( gram_L1905609002ubst_c @ Tr0 @ N ) ) )).

% finite_hsubst_c
thf(fact_132_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A4: ( set @ A )] :
          ( finite_finite2 @ A @ A4 ) ) )).

% finite
thf(fact_133_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A4 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ? [X12: B] :
                ( P @ X3 @ X12 ) )
       => ? [F5: ( A > B )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A4 )
           => ( P @ X4 @ ( F5 @ X4 ) ) ) ) ) )).

% finite_set_choice
thf(fact_134_finite__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_UNIV
thf(fact_135_infinite__UNIV__char__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% infinite_UNIV_char_0
thf(fact_136_ex__new__if__finite,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A @ A4 )
       => ? [A6: A] :
            ~ ( member @ A @ A6 @ A4 ) ) ) )).

% ex_new_if_finite
thf(fact_137_finite__fun__UNIVD2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) )).

% finite_fun_UNIVD2
thf(fact_138_finite__Prod__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% finite_Prod_UNIV
thf(fact_139_finite__prod,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_prod
thf(fact_140_Finite__Set_Ofinite__set,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% Finite_Set.finite_set
thf(fact_141_hsubst__def,axiom,
    ( gram_L1004374585hsubst
    = ( ^ [Tr02: dtree] :
          ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ Tr02 ) ) ) )).

% hsubst_def
thf(fact_142_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_143_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_144_DEADID_Oin__rel,axiom,(
    ! [B: $tType] :
      ( ( ^ [Y4: B,Z3: B] : ( Y4 = Z3 ) )
      = ( ^ [A7: B,B4: B] :
          ? [Z4: B] :
            ( ( member @ B @ Z4 @ ( top_top @ ( set @ B ) ) )
            & ( ( id @ B @ Z4 )
              = A7 )
            & ( ( id @ B @ Z4 )
              = B4 ) ) ) ) )).

% DEADID.in_rel
thf(fact_145_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_146_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N: n,N4: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N @ As )
            = ( node @ N4 @ As2 ) )
          = ( ( N = N4 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_147_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_148_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N5: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N5 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_149_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X2: C,N3: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X2 ) )
        = ( N3 @ ( H @ X2 ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X2 )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N3 ) @ H @ X2 ) ) ) )).

% type_copy_map_cong0
thf(fact_150_hsubst__r__def,axiom,(
    gram_L1905609017ubst_r = root )).

% hsubst_r_def
thf(fact_151_Sup_OSUP__id__eq,axiom,(
    ! [A: $tType,Sup: ( ( set @ A ) > A ),A4: ( set @ A )] :
      ( ( Sup @ ( image @ A @ A @ ( id @ A ) @ A4 ) )
      = ( Sup @ A4 ) ) )).

% Sup.SUP_id_eq
thf(fact_152_Inf_OINF__id__eq,axiom,(
    ! [A: $tType,Inf: ( ( set @ A ) > A ),A4: ( set @ A )] :
      ( ( Inf @ ( image @ A @ A @ ( id @ A ) @ A4 ) )
      = ( Inf @ A4 ) ) )).

% Inf.INF_id_eq
thf(fact_153_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A4: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A4 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) )).

% Sup.SUP_image
thf(fact_154_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ B ),B3: ( set @ B ),C3: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A4 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C3 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C3 @ A4 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B3 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_155_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ B ),B3: ( set @ B ),C3: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A4 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C3 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C3 @ A4 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B3 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_156_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G: ( B > A ),F: ( C > B ),A4: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G @ ( image @ C @ B @ F @ A4 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ A4 ) ) ) )).

% Inf.INF_image
thf(fact_157_Inl__cont__H,axiom,(
    ! [N: n] :
      ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1451583624elle_H @ tr0 @ N ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) ) )).

% Inl_cont_H
thf(fact_158_case__sum__o__map__sum__id,axiom,(
    ! [A: $tType,B: $tType,C: $tType,G: ( B > A ),F: ( C > A ),X2: ( sum_sum @ C @ B )] :
      ( ( comp @ ( sum_sum @ A @ B ) @ A @ ( sum_sum @ C @ B ) @ ( sum_case_sum @ A @ A @ B @ ( id @ A ) @ G ) @ ( sum_map_sum @ C @ A @ B @ B @ F @ ( id @ B ) ) @ X2 )
      = ( sum_case_sum @ C @ A @ B @ ( comp @ C @ A @ C @ F @ ( id @ C ) ) @ G @ X2 ) ) )).

% case_sum_o_map_sum_id
thf(fact_159_inFr2_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T2: t] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr ) )
       => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) )).

% inFr2.Base
thf(fact_160_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
      = ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimage_eq
thf(fact_161_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: A,B3: ( set @ A )] :
      ( ( ( F @ A2 )
        = B2 )
     => ( ( member @ A @ B2 @ B3 )
       => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ B3 ) ) ) ) )).

% vimageI
thf(fact_162_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_163_vimage__id,axiom,(
    ! [A: $tType] :
      ( ( vimage @ A @ A @ ( id @ A ) )
      = ( id @ ( set @ A ) ) ) )).

% vimage_id
thf(fact_164_Inl__m__oplus,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
      = ( vimage @ A @ ( sum_sum @ A @ C ) @ ( sum_Inl @ A @ C ) @ Tns ) ) )).

% Inl_m_oplus
thf(fact_165_Inl__cont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr ) ) ) ) )).

% Inl_cont_hsubst_neq
thf(fact_166_Inl__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr0 ) ) ) ) )).

% Inl_cont_hsubst_eq
thf(fact_167_case__sum__step_I1_J,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F6: ( B > A ),G3: ( C > A ),G: ( D > A ),P2: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ ( sum_sum @ B @ C ) @ A @ D @ ( sum_case_sum @ B @ A @ C @ F6 @ G3 ) @ G @ ( sum_Inl @ ( sum_sum @ B @ C ) @ D @ P2 ) )
      = ( sum_case_sum @ B @ A @ C @ F6 @ G3 @ P2 ) ) )).

% case_sum_step(1)
thf(fact_168_case__sum__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F22: ( B > C ),G1: ( A > C ),G22: ( B > C )] :
      ( ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 )
        = ( sum_case_sum @ A @ C @ B @ G1 @ G22 ) )
     => ~ ( ( F1 = G1 )
         => ( F22 != G22 ) ) ) )).

% case_sum_inject
thf(fact_169_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_170_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,A4: ( set @ A )] :
      ( ( member @ A @ ( F @ A2 ) @ A4 )
     => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ A4 ) ) ) )).

% vimageI2
thf(fact_171_vimageE,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
     => ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimageE
thf(fact_172_vimageD,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),A4: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ A4 ) )
     => ( member @ B @ ( F @ A2 ) @ A4 ) ) )).

% vimageD
thf(fact_173_old_Osum_Osimps_I5_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F1: ( A > C ),F22: ( B > C ),X1: A] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ X1 ) )
      = ( F1 @ X1 ) ) )).

% old.sum.simps(5)
thf(fact_174_set_Ocompositionality,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( C > B ),G: ( B > A ),Set: ( set @ A )] :
      ( ( vimage @ C @ B @ F @ ( vimage @ B @ A @ G @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ Set ) ) )).

% set.compositionality
thf(fact_175_vimage__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( B > C ),X2: ( set @ C )] :
      ( ( vimage @ A @ B @ F @ ( vimage @ B @ C @ G @ X2 ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ X2 ) ) )).

% vimage_comp
thf(fact_176_set_Ocomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),G: ( B > A )] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F ) @ ( vimage @ B @ A @ G ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) ) ) )).

% set.comp
thf(fact_177_surj__image__vimage__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A4: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ F @ ( vimage @ B @ A @ F @ A4 ) )
        = A4 ) ) )).

% surj_image_vimage_eq
thf(fact_178_inFr2__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T2: t] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr2_root_in
thf(fact_179_case__sum__map__sum,axiom,(
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,L: ( B > A ),R: ( C > A ),F: ( D > B ),G: ( E > C ),X2: ( sum_sum @ D @ E )] :
      ( ( sum_case_sum @ B @ A @ C @ L @ R @ ( sum_map_sum @ D @ B @ E @ C @ F @ G @ X2 ) )
      = ( sum_case_sum @ D @ A @ E @ ( comp @ B @ A @ D @ L @ F ) @ ( comp @ C @ A @ E @ R @ G ) @ X2 ) ) )).

% case_sum_map_sum
thf(fact_180_finite__vimageD,axiom,(
    ! [A: $tType,B: $tType,H: ( A > B ),F4: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( vimage @ A @ B @ H @ F4 ) )
     => ( ( ( image @ A @ B @ H @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ B @ F4 ) ) ) )).

% finite_vimageD
thf(fact_181_case__sum__o__inj_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inl @ A @ C ) )
      = F ) )).

% case_sum_o_inj(1)
thf(fact_182_o__case__sum,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H: ( D > C ),F: ( A > D ),G: ( B > D )] :
      ( ( comp @ D @ C @ ( sum_sum @ A @ B ) @ H @ ( sum_case_sum @ A @ D @ B @ F @ G ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ H @ F ) @ ( comp @ D @ C @ B @ H @ G ) ) ) )).

% o_case_sum
thf(fact_183_Gram__Lang__Mirabelle__ojxrtuoybn_OInl__cont__H,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L1451583624elle_H @ Tr0 @ N ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( gram_L315592705e_pick @ Tr0 @ N ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inl_cont_H
thf(fact_184_case__sum__o__map__sum,axiom,(
    ! [A: $tType,D: $tType,C: $tType,E: $tType,B: $tType,F: ( D > C ),G: ( E > C ),H1: ( A > D ),H2: ( B > E )] :
      ( ( comp @ ( sum_sum @ D @ E ) @ C @ ( sum_sum @ A @ B ) @ ( sum_case_sum @ D @ C @ E @ F @ G ) @ ( sum_map_sum @ A @ D @ B @ E @ H1 @ H2 ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ F @ H1 ) @ ( comp @ E @ C @ B @ G @ H2 ) ) ) )).

% case_sum_o_map_sum
thf(fact_185_Inl__prodOf,axiom,(
    ! [Tr: dtree] :
      ( ( vimage @ t @ ( sum_sum @ t @ n ) @ ( sum_Inl @ t @ n ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ Tr ) ) ) )).

% Inl_prodOf
thf(fact_186_corec_I2_J,axiom,(
    ! [A: $tType,Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B2: A,Rt: ( A > n )] :
      ( ( finite_finite2 @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) @ ( Ct @ B2 ) )
     => ( ( cont @ ( corec @ A @ Rt @ Ct @ B2 ) )
        = ( image @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) @ ( sum_sum @ t @ dtree ) @ ( sum_map_sum @ t @ t @ ( sum_sum @ dtree @ A ) @ dtree @ ( id @ t ) @ ( sum_case_sum @ dtree @ dtree @ A @ ( id @ dtree ) @ ( corec @ A @ Rt @ Ct ) ) ) @ ( Ct @ B2 ) ) ) ) )).

% corec(2)
thf(fact_187_Inr__m__oplus,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),Tns: ( set @ ( sum_sum @ B @ C ) )] :
      ( ( vimage @ A @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B ) @ ( image @ ( sum_sum @ B @ C ) @ ( sum_sum @ B @ A ) @ ( sum_map_sum @ B @ B @ C @ A @ ( id @ B ) @ F ) @ Tns ) )
      = ( image @ C @ A @ F @ ( vimage @ C @ ( sum_sum @ B @ C ) @ ( sum_Inr @ C @ B ) @ Tns ) ) ) )).

% Inr_m_oplus
thf(fact_188_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X22: B,Y22: B] :
      ( ( ( sum_Inr @ B @ A @ X22 )
        = ( sum_Inr @ B @ A @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% sum.inject(2)
thf(fact_189_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B5: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B5 ) )
      = ( B2 = B5 ) ) )).

% old.sum.inject(2)
thf(fact_190_Inr__cont__H,axiom,(
    ! [N: n] :
      ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1451583624elle_H @ tr0 @ N ) ) )
      = ( image @ dtree @ dtree @ ( comp @ n @ dtree @ dtree @ ( gram_L1451583624elle_H @ tr0 ) @ root ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L315592705e_pick @ tr0 @ N ) ) ) ) ) )).

% Inr_cont_H
thf(fact_191_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X2: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X2 )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_192_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X2 )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_193_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F22 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_194_wf__inj,axiom,(
    ! [Tr: dtree,Tr1: dtree,Tr2: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr ) )
         => ( ( ( root @ Tr1 )
              = ( root @ Tr2 ) )
            = ( Tr1 = Tr2 ) ) ) ) ) )).

% wf_inj
thf(fact_195_Inr__cont__hsubst__neq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
       != ( root @ Tr0 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ Tr0 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) ) )).

% Inr_cont_hsubst_neq
thf(fact_196_Inr__cont__hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) )
        = ( image @ dtree @ dtree @ ( gram_L1004374585hsubst @ Tr0 ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr0 ) ) ) ) ) )).

% Inr_cont_hsubst_eq
thf(fact_197_Inr__oplus__iff,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Tr: B,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
      = ( ? [N2: C] :
            ( ( member @ ( sum_sum @ A @ C ) @ ( sum_Inr @ C @ A @ N2 ) @ Tns )
            & ( ( F @ N2 )
              = Tr ) ) ) ) )).

% Inr_oplus_iff
thf(fact_198_case__sum__step_I2_J,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,F: ( E > A ),F6: ( B > A ),G3: ( C > A ),P2: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ E @ A @ ( sum_sum @ B @ C ) @ F @ ( sum_case_sum @ B @ A @ C @ F6 @ G3 ) @ ( sum_Inr @ ( sum_sum @ B @ C ) @ E @ P2 ) )
      = ( sum_case_sum @ B @ A @ C @ F6 @ G3 @ P2 ) ) )).

% case_sum_step(2)
thf(fact_199_old_Osum_Osimps_I6_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F22: ( B > C ),X22: B] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ X22 ) )
      = ( F22 @ X22 ) ) )).

% old.sum.simps(6)
thf(fact_200_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A6: A] :
          ( P @ ( sum_Inl @ A @ B @ A6 ) )
     => ( ! [B6: B] :
            ( P @ ( sum_Inr @ B @ A @ B6 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_201_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A6: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A6 ) )
     => ~ ( ! [B6: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B6 ) ) ) ) )).

% old.sum.exhaust
thf(fact_202_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X6: ( sum_sum @ A @ B )] :
            ( P3 @ X6 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X ) )
            & ! [X: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_all
thf(fact_203_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X6: ( sum_sum @ A @ B )] :
            ( P3 @ X6 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X ) )
            | ? [X: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X ) ) ) ) ) )).

% split_sum_ex
thf(fact_204_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A2: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A2 ) ) )).

% Inr_not_Inl
thf(fact_205_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [Y2: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y2 ) ) ) ) )).

% sumE
thf(fact_206_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: A,B5: B] :
      ( ( sum_Inl @ A @ B @ A2 )
     != ( sum_Inr @ B @ A @ B5 ) ) )).

% old.sum.distinct(1)
thf(fact_207_old_Osum_Odistinct_I2_J,axiom,(
    ! [B7: $tType,A8: $tType,B8: B7,A9: A8] :
      ( ( sum_Inr @ B7 @ A8 @ B8 )
     != ( sum_Inl @ A8 @ B7 @ A9 ) ) )).

% old.sum.distinct(2)
thf(fact_208_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X22 ) ) )).

% sum.distinct(1)
thf(fact_209_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X3: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X3 ) ) )
         => P )
     => ( ! [X3: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X3 ) ) )
           => P )
       => ! [X4: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X4 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_210_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X2 = Y ) ) )).

% Inr_inject
thf(fact_211_map__sum__if__distrib__else_I2_J,axiom,(
    ! [E: $tType,F3: $tType,H3: $tType,G4: $tType,E2: $o,F: ( E > F3 ),G: ( G4 > H3 ),X2: ( sum_sum @ E @ G4 ),Y: G4] :
      ( ( E2
       => ( ( sum_map_sum @ E @ F3 @ G4 @ H3 @ F @ G @ ( if @ ( sum_sum @ E @ G4 ) @ E2 @ X2 @ ( sum_Inr @ G4 @ E @ Y ) ) )
          = ( sum_map_sum @ E @ F3 @ G4 @ H3 @ F @ G @ X2 ) ) )
      & ( ~ ( E2 )
       => ( ( sum_map_sum @ E @ F3 @ G4 @ H3 @ F @ G @ ( if @ ( sum_sum @ E @ G4 ) @ E2 @ X2 @ ( sum_Inr @ G4 @ E @ Y ) ) )
          = ( sum_Inr @ H3 @ F3 @ ( G @ Y ) ) ) ) ) )).

% map_sum_if_distrib_else(2)
thf(fact_212_map__sum__if__distrib__then_I2_J,axiom,(
    ! [H3: $tType,F3: $tType,G4: $tType,E: $tType,E2: $o,F: ( E > F3 ),G: ( G4 > H3 ),X2: G4,Y: ( sum_sum @ E @ G4 )] :
      ( ( E2
       => ( ( sum_map_sum @ E @ F3 @ G4 @ H3 @ F @ G @ ( if @ ( sum_sum @ E @ G4 ) @ E2 @ ( sum_Inr @ G4 @ E @ X2 ) @ Y ) )
          = ( sum_Inr @ H3 @ F3 @ ( G @ X2 ) ) ) )
      & ( ~ ( E2 )
       => ( ( sum_map_sum @ E @ F3 @ G4 @ H3 @ F @ G @ ( if @ ( sum_sum @ E @ G4 ) @ E2 @ ( sum_Inr @ G4 @ E @ X2 ) @ Y ) )
          = ( sum_map_sum @ E @ F3 @ G4 @ H3 @ F @ G @ Y ) ) ) ) )).

% map_sum_if_distrib_then(2)
thf(fact_213_map__sum__InrD,axiom,(
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F: ( C > A ),G: ( D > B ),Z: ( sum_sum @ C @ D ),X2: B] :
      ( ( ( sum_map_sum @ C @ A @ D @ B @ F @ G @ Z )
        = ( sum_Inr @ B @ A @ X2 ) )
     => ? [Y2: D] :
          ( ( Z
            = ( sum_Inr @ D @ C @ Y2 ) )
          & ( ( G @ Y2 )
            = X2 ) ) ) )).

% map_sum_InrD
thf(fact_214_map__sum_Osimps_I2_J,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F1: ( A > C ),F22: ( B > D ),A2: B] :
      ( ( sum_map_sum @ A @ C @ B @ D @ F1 @ F22 @ ( sum_Inr @ B @ A @ A2 ) )
      = ( sum_Inr @ D @ C @ ( F22 @ A2 ) ) ) )).

% map_sum.simps(2)
thf(fact_215_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ ( sum_sum @ A @ B ) ),B3: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A4 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B3 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A4 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B3 ) )
       => ( A4 = B3 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_216_case__sum__if,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: $o,F: ( B > A ),G: ( C > A ),X2: B,Y: C] :
      ( ( P2
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P2 @ ( sum_Inl @ B @ C @ X2 ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( F @ X2 ) ) )
      & ( ~ ( P2 )
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P2 @ ( sum_Inl @ B @ C @ X2 ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( G @ Y ) ) ) ) )).

% case_sum_if
thf(fact_217_wf__cont,axiom,(
    ! [Tr: dtree,Tr5: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr ) )
       => ( gram_L864798063lle_wf @ Tr5 ) ) ) )).

% wf_cont
thf(fact_218_case__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ C @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inr @ C @ A ) )
      = G ) )).

% case_sum_o_inj(2)
thf(fact_219_root__prodOf,axiom,(
    ! [Tr5: dtree,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr ) )
     => ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ ( root @ Tr5 ) ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) ) ) )).

% root_prodOf
thf(fact_220_Gram__Lang__Mirabelle__ojxrtuoybn_OInr__cont__H,axiom,(
    ! [Tr0: dtree,N: n] :
      ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L1451583624elle_H @ Tr0 @ N ) ) )
      = ( image @ dtree @ dtree @ ( comp @ n @ dtree @ dtree @ ( gram_L1451583624elle_H @ Tr0 ) @ root ) @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( gram_L315592705e_pick @ Tr0 @ N ) ) ) ) ) )).

% Gram_Lang_Mirabelle_ojxrtuoybn.Inr_cont_H
thf(fact_221_Inr__oplus__elim,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Tr: B,F: ( C > B ),Tns: ( set @ ( sum_sum @ A @ C ) )] :
      ( ( member @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A @ Tr ) @ ( image @ ( sum_sum @ A @ C ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ A @ A @ C @ B @ ( id @ A ) @ F ) @ Tns ) )
     => ? [N5: C] :
          ( ( member @ ( sum_sum @ A @ C ) @ ( sum_Inr @ C @ A @ N5 ) @ Tns )
          & ( ( F @ N5 )
            = Tr ) ) ) )).

% Inr_oplus_elim
thf(fact_222_subtr_OStep,axiom,(
    ! [Tr3: dtree,Ns: ( set @ n ),Tr1: dtree,Tr2: dtree] :
      ( ( member @ n @ ( root @ Tr3 ) @ Ns )
     => ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr2 ) @ ( cont @ Tr3 ) )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr.Step
thf(fact_223_subtr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: dtree] :
      ( ( gram_L716654942_subtr @ A1 @ A22 @ A32 )
     => ( ( ( A32 = A22 )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A32 ) @ A1 )
           => ! [Tr22: dtree] :
                ( ( gram_L716654942_subtr @ A1 @ A22 @ Tr22 )
               => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ A32 ) ) ) ) ) ) )).

% subtr.cases
thf(fact_224_subtr_Osimps,axiom,
    ( gram_L716654942_subtr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: dtree] :
          ( ? [Tr6: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr6 )
              & ( A33 = Tr6 )
              & ( member @ n @ ( root @ Tr6 ) @ Ns2 ) )
          | ? [Tr32: dtree,Ns2: ( set @ n ),Tr12: dtree,Tr23: dtree] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr12 )
              & ( A33 = Tr32 )
              & ( member @ n @ ( root @ Tr32 ) @ Ns2 )
              & ( gram_L716654942_subtr @ Ns2 @ Tr12 @ Tr23 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr23 ) @ ( cont @ Tr32 ) ) ) ) ) )).

% subtr.simps
thf(fact_225_subtr__StepL,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr2: dtree,Tr3: dtree] :
      ( ( member @ n @ ( root @ Tr1 ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr2 ) )
       => ( ( gram_L716654942_subtr @ Ns @ Tr2 @ Tr3 )
         => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr3 ) ) ) ) )).

% subtr_StepL
thf(fact_226_subtr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: dtree,P: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( P @ Ns3 @ Tr7 @ Tr7 ) )
       => ( ! [Tr33: dtree,Ns3: ( set @ n ),Tr13: dtree,Tr22: dtree] :
              ( ( member @ n @ ( root @ Tr33 ) @ Ns3 )
             => ( ( gram_L716654942_subtr @ Ns3 @ Tr13 @ Tr22 )
               => ( ( P @ Ns3 @ Tr13 @ Tr22 )
                 => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ Tr33 ) )
                   => ( P @ Ns3 @ Tr13 @ Tr33 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% subtr.inducts
thf(fact_227_subtr__inductL,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr2: dtree,Phi: ( ( set @ n ) > dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr2 )
     => ( ! [Ns3: ( set @ n ),Tr7: dtree] :
            ( Phi @ Ns3 @ Tr7 @ Tr7 )
       => ( ! [Ns3: ( set @ n ),Tr13: dtree,Tr22: dtree,Tr33: dtree] :
              ( ( member @ n @ ( root @ Tr13 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr22 ) )
               => ( ( gram_L716654942_subtr @ Ns3 @ Tr22 @ Tr33 )
                 => ( ( Phi @ Ns3 @ Tr22 @ Tr33 )
                   => ( Phi @ Ns3 @ Tr13 @ Tr33 ) ) ) ) )
         => ( Phi @ Ns @ Tr1 @ Tr2 ) ) ) ) )).

% subtr_inductL
thf(fact_228_inItr_OInd,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr1: dtree,N: n] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
       => ( ( gram_L830233218_inItr @ Ns @ Tr1 @ N )
         => ( gram_L830233218_inItr @ Ns @ Tr @ N ) ) ) ) )).

% inItr.Ind
thf(fact_229_inItr_Ocases,axiom,(
    ! [A1: ( set @ n ),A22: dtree,A32: n] :
      ( ( gram_L830233218_inItr @ A1 @ A22 @ A32 )
     => ( ( ( A32
            = ( root @ A22 ) )
         => ~ ( member @ n @ ( root @ A22 ) @ A1 ) )
       => ~ ( ( member @ n @ ( root @ A22 ) @ A1 )
           => ! [Tr13: dtree] :
                ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ A22 ) )
               => ~ ( gram_L830233218_inItr @ A1 @ Tr13 @ A32 ) ) ) ) ) )).

% inItr.cases
thf(fact_230_inItr_Osimps,axiom,
    ( gram_L830233218_inItr
    = ( ^ [A12: ( set @ n ),A23: dtree,A33: n] :
          ( ? [Tr6: dtree,Ns2: ( set @ n )] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr6 )
              & ( A33
                = ( root @ Tr6 ) )
              & ( member @ n @ ( root @ Tr6 ) @ Ns2 ) )
          | ? [Tr6: dtree,Ns2: ( set @ n ),Tr12: dtree,N2: n] :
              ( ( A12 = Ns2 )
              & ( A23 = Tr6 )
              & ( A33 = N2 )
              & ( member @ n @ ( root @ Tr6 ) @ Ns2 )
              & ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ Tr6 ) )
              & ( gram_L830233218_inItr @ Ns2 @ Tr12 @ N2 ) ) ) ) )).

% inItr.simps
thf(fact_231_inItr_Oinducts,axiom,(
    ! [X1: ( set @ n ),X22: dtree,X32: n,P: ( ( set @ n ) > dtree > n > $o )] :
      ( ( gram_L830233218_inItr @ X1 @ X22 @ X32 )
     => ( ! [Tr7: dtree,Ns3: ( set @ n )] :
            ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
           => ( P @ Ns3 @ Tr7 @ ( root @ Tr7 ) ) )
       => ( ! [Tr7: dtree,Ns3: ( set @ n ),Tr13: dtree,N5: n] :
              ( ( member @ n @ ( root @ Tr7 ) @ Ns3 )
             => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr7 ) )
               => ( ( gram_L830233218_inItr @ Ns3 @ Tr13 @ N5 )
                 => ( ( P @ Ns3 @ Tr13 @ N5 )
                   => ( P @ Ns3 @ Tr7 @ N5 ) ) ) ) )
         => ( P @ X1 @ X22 @ X32 ) ) ) ) )).

% inItr.inducts
thf(fact_232_case__sum__expand__Inr,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),X2: ( sum_sum @ A @ C )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( F @ X2 )
        = ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) @ X2 ) ) ) )).

% case_sum_expand_Inr
thf(fact_233_case__sum__expand__Inr_H,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),H: ( C > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( H
          = ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = ( ( sum_case_sum @ A @ B @ C @ G @ H )
          = F ) ) ) )).

% case_sum_expand_Inr'
thf(fact_234_case__sum__expand__Inr__pointfree,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = F ) ) )).

% case_sum_expand_Inr_pointfree
thf(fact_235_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B2: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% corec(1)
thf(fact_236_subtr__UNIV__inductL,axiom,(
    ! [Tr1: dtree,Tr2: dtree,Phi: ( dtree > dtree > $o )] :
      ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr1 @ Tr2 )
     => ( ! [Tr7: dtree] :
            ( Phi @ Tr7 @ Tr7 )
       => ( ! [Tr13: dtree,Tr22: dtree,Tr33: dtree] :
              ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr13 ) @ ( cont @ Tr22 ) )
             => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr22 @ Tr33 )
               => ( ( Phi @ Tr22 @ Tr33 )
                 => ( Phi @ Tr13 @ Tr33 ) ) ) )
         => ( Phi @ Tr1 @ Tr2 ) ) ) ) )).

% subtr_UNIV_inductL
thf(fact_237_inFr2__Ind,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,T2: t,Tr: dtree] :
      ( ( gram_L805317441_inFr2 @ Ns @ Tr1 @ T2 )
     => ( ( member @ n @ ( root @ Tr ) @ Ns )
       => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr1 ) @ ( cont @ Tr ) )
         => ( gram_L805317441_inFr2 @ Ns @ Tr @ T2 ) ) ) ) )).

% inFr2_Ind
thf(fact_238_map__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: ( A > B ),G: ( D > C )] :
      ( ( comp @ ( sum_sum @ A @ D ) @ ( sum_sum @ B @ C ) @ D @ ( sum_map_sum @ A @ B @ D @ C @ F @ G ) @ ( sum_Inr @ D @ A ) )
      = ( comp @ C @ ( sum_sum @ B @ C ) @ D @ ( sum_Inr @ C @ B ) @ G ) ) )).

% map_sum_o_inj(2)
thf(fact_239_root__subtrOf,axiom,(
    ! [N: n,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
     => ( ( root @ ( gram_L1614515765ubtrOf @ Tr @ N ) )
        = N ) ) )).

% root_subtrOf
thf(fact_240_surj__subtrOf,axiom,(
    ! [Tr: dtree,Tr5: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr ) )
       => ? [N5: n] :
            ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N5 ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
            & ( ( gram_L1614515765ubtrOf @ Tr @ N5 )
              = Tr5 ) ) ) ) )).

% surj_subtrOf
thf(fact_241_subtrOf__root,axiom,(
    ! [Tr: dtree,Tr5: dtree] :
      ( ( gram_L864798063lle_wf @ Tr )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr5 ) @ ( cont @ Tr ) )
       => ( ( gram_L1614515765ubtrOf @ Tr @ ( root @ Tr5 ) )
          = Tr5 ) ) ) )).

% subtrOf_root
thf(fact_242_Inr__subtrOf,axiom,(
    ! [N: n,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
     => ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ ( gram_L1614515765ubtrOf @ Tr @ N ) ) @ ( cont @ Tr ) ) ) )).

% Inr_subtrOf
thf(fact_243_subtrOf,axiom,(
    ! [N: n,Tr: dtree] :
      ( ( member @ ( sum_sum @ t @ n ) @ ( sum_Inr @ n @ t @ N ) @ ( image @ ( sum_sum @ t @ dtree ) @ ( sum_sum @ t @ n ) @ ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root ) @ ( cont @ Tr ) ) )
     => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ ( gram_L1614515765ubtrOf @ Tr @ N ) ) @ ( cont @ Tr ) )
        & ( ( root @ ( gram_L1614515765ubtrOf @ Tr @ N ) )
          = N ) ) ) )).

% subtrOf
thf(fact_244_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [X3: B] :
              ( S
             != ( sum_Inr @ B @ A @ X3 ) ) ) ) )).

% obj_sumE
thf(fact_245_wf__subtr__inj__on,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( inj_on @ dtree @ n @ root @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr ) ) ) ) ) )).

% wf_subtr_inj_on
thf(fact_246_inj__on__image__iff,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ A ),G: ( A > B ),F: ( A > A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ! [Xa2: A] :
              ( ( member @ A @ Xa2 @ A4 )
             => ( ( ( G @ ( F @ X3 ) )
                  = ( G @ ( F @ Xa2 ) ) )
                = ( ( G @ X3 )
                  = ( G @ Xa2 ) ) ) ) )
     => ( ( inj_on @ A @ A @ F @ A4 )
       => ( ( inj_on @ A @ B @ G @ ( image @ A @ A @ F @ A4 ) )
          = ( inj_on @ A @ B @ G @ A4 ) ) ) ) )).

% inj_on_image_iff
thf(fact_247_finite__image__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F @ A4 ) )
        = ( finite_finite2 @ A @ A4 ) ) ) )).

% finite_image_iff
thf(fact_248_finite__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A4 ) )
     => ( ( inj_on @ B @ A @ F @ A4 )
       => ( finite_finite2 @ B @ A4 ) ) ) )).

% finite_imageD
thf(fact_249_range__ex1__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),B2: B] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( member @ B @ B2 @ ( image @ A @ B @ F @ ( top_top @ ( set @ A ) ) ) )
        = ( ? [X: A] :
              ( ( B2
                = ( F @ X ) )
              & ! [Y3: A] :
                  ( ( B2
                    = ( F @ Y3 ) )
                 => ( Y3 = X ) ) ) ) ) ) )).

% range_ex1_eq
thf(fact_250_inj__image__eq__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),B3: ( set @ A )] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( ( image @ A @ B @ F @ A4 )
          = ( image @ A @ B @ F @ B3 ) )
        = ( A4 = B3 ) ) ) )).

% inj_image_eq_iff
thf(fact_251_inj__image__mem__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: A,A4: ( set @ A )] :
      ( ( inj_on @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
     => ( ( member @ B @ ( F @ A2 ) @ ( image @ A @ B @ F @ A4 ) )
        = ( member @ A @ A2 @ A4 ) ) ) )).

% inj_image_mem_iff
thf(fact_252_comp__inj__on,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),G: ( B > C )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ B @ C @ G @ ( image @ A @ B @ F @ A4 ) )
       => ( inj_on @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ A4 ) ) ) )).

% comp_inj_on
thf(fact_253_inj__on__imageI,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( C > B ),F: ( A > C ),A4: ( set @ A )] :
      ( ( inj_on @ A @ B @ ( comp @ C @ B @ A @ G @ F ) @ A4 )
     => ( inj_on @ C @ B @ G @ ( image @ A @ C @ F @ A4 ) ) ) )).

% inj_on_imageI
thf(fact_254_comp__inj__on__iff,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B ),A4: ( set @ A ),F6: ( B > C )] :
      ( ( inj_on @ A @ B @ F @ A4 )
     => ( ( inj_on @ B @ C @ F6 @ ( image @ A @ B @ F @ A4 ) )
        = ( inj_on @ A @ C @ ( comp @ B @ C @ A @ F6 @ F ) @ A4 ) ) ) )).

% comp_inj_on_iff
thf(fact_255_finite__UNIV__inj__surj,axiom,(
    ! [A: $tType,F: ( A > A )] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( inj_on @ A @ A @ F @ ( top_top @ ( set @ A ) ) )
       => ( ( image @ A @ A @ F @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ) )).

% finite_UNIV_inj_surj

%----Type constructors (9)
thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( top @ A10 @ ( type2 @ A10 ) )
     => ( top @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_1,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_2,axiom,(
    ! [A8: $tType] :
      ( top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_3,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_4,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_5,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( sum_sum @ A8 @ A10 ) @ ( type2 @ ( sum_sum @ A8 @ A10 ) ) ) ) )).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_6,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_7,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A10 ) @ ( type2 @ ( product_prod @ A8 @ A10 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (4)
thf(conj_0,hypothesis,(
    $true )).

thf(conj_1,hypothesis,(
    $true )).

thf(conj_2,hypothesis,
    ( t_tr
    = ( sum_Inl @ t @ dtree @ a ) )).

thf(conj_3,conjecture,
    ( ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ ( comp @ n @ n @ dtree @ ( comp @ dtree @ n @ n @ root @ ( gram_L1451583624elle_H @ tr0 ) ) @ root ) @ t_tr )
    = ( sum_map_sum @ t @ t @ dtree @ n @ ( id @ t ) @ root @ t_tr ) )).

%------------------------------------------------------------------------------
