%------------------------------------------------------------------------------
% File     : COM193^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Grammars and languages 1154
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : gram_lang__1154.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  340 (   1 unit;  57 type;   0 defn)
%            Number of atoms       : 3631 ( 215 equality;2044 variable)
%            Maximal formula depth :   19 (   8 average)
%            Number of connectives : 3215 (  70   ~;   6   |;  38   &;2817   @)
%                                         (   0 <=>; 284  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  172 ( 172   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   60 (  57   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  847 (   3 sgn; 759   !;  11   ?;  46   ^)
%                                         ( 847   :;  31  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:47:18.227
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (51)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OFr,type,(
    gram_L861583724lle_Fr: ( set @ n ) > dtree > ( set @ t ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OH,type,(
    gram_L1451583624elle_H: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OH__c,type,(
    gram_L1221482011le_H_c: dtree > n > ( set @ ( sum_sum @ t @ n ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OH__r,type,(
    gram_L1221482026le_H_r: dtree > n > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OL,type,(
    gram_L1451583628elle_L: ( set @ n ) > n > ( set @ ( set @ t ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Odeftr,type,(
    gram_L1231612515_deftr: n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst,type,(
    gram_L1004374585hsubst: dtree > dtree > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__c,type,(
    gram_L1905609002ubst_c: dtree > dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Ohsubst__r,type,(
    gram_L1905609017ubst_r: dtree > n )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinFr,type,(
    gram_L1333338417e_inFr: ( set @ n ) > dtree > t > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_OinItr,type,(
    gram_L830233218_inItr: ( set @ n ) > dtree > n > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Opick,type,(
    gram_L315592705e_pick: dtree > n > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Orcut,type,(
    gram_L1828378864e_rcut: dtree > dtree )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Oreg,type,(
    gram_L1918716148le_reg: ( n > dtree ) > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Oregular,type,(
    gram_L646766332egular: dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Osubtr,type,(
    gram_L716654942_subtr: ( set @ n ) > dtree > dtree > $o )).

thf(sy_c_Gram__Lang__Mirabelle__ojxrtuoybn_Owf,type,(
    gram_L864798063lle_wf: dtree > $o )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Oinv__imagep,type,(
    inv_imagep: 
      !>[B: $tType,A: $tType] :
        ( ( B > B > $o ) > ( A > B ) > A > A > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_OPow,type,(
    pow: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( set @ A ) ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_n,type,(
    n2: n )).

thf(sy_v_ns,type,(
    ns: ( set @ n ) )).

%----Relevant facts (256)
thf(fact_0_assms,axiom,(
    ~ ( member @ n @ n2 @ ns ) )).

% assms
thf(fact_1_not__root__Fr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ( ( gram_L861583724lle_Fr @ Ns @ Tr )
        = ( bot_bot @ ( set @ t ) ) ) ) )).

% not_root_Fr
thf(fact_2_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_3_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X: A] :
            ~ ( member @ A @ X @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_4_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% Collect_empty_eq
thf(fact_5_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X: A] :
            ~ ( P @ X ) ) ) )).

% empty_Collect_eq
thf(fact_6_bot__apply,axiom,(
    ! [C2: $tType,D: $tType] :
      ( ( bot @ C2 @ ( type2 @ C2 ) )
     => ( ( bot_bot @ ( D > C2 ) )
        = ( ^ [X: D] :
              ( bot_bot @ C2 ) ) ) ) )).

% bot_apply
thf(fact_7_hsubst__r__def,axiom,(
    gram_L1905609017ubst_r = root )).

% hsubst_r_def
thf(fact_8_root__rcut,axiom,(
    ! [Tr0: dtree] :
      ( ( root @ ( gram_L1828378864e_rcut @ Tr0 ) )
      = ( root @ Tr0 ) ) )).

% root_rcut
thf(fact_9_regular__def2,axiom,
    ( gram_L646766332egular
    = ( ^ [Tr2: dtree] :
        ? [F: ( n > dtree )] :
          ( ( gram_L1918716148le_reg @ F @ Tr2 )
          & ! [N: n] :
              ( ( root @ ( F @ N ) )
              = N ) ) ) )).

% regular_def2
thf(fact_10_emptyE,axiom,(
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_11_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A3 @ A2 ) ) )).

% equals0D
thf(fact_12_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y: A] :
          ~ ( member @ A @ Y @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_13_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X: A] :
            ( member @ A @ X @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_14_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_15_reg__root,axiom,(
    ! [F2: ( n > dtree ),Tr: dtree] :
      ( ( gram_L1918716148le_reg @ F2 @ Tr )
     => ( ( F2 @ ( root @ Tr ) )
        = Tr ) ) )).

% reg_root
thf(fact_16_regular__def,axiom,
    ( gram_L646766332egular
    = ( ^ [Tr2: dtree] :
        ? [F: ( n > dtree )] :
          ( gram_L1918716148le_reg @ F @ Tr2 ) ) )).

% regular_def
thf(fact_17_wf__rcut,axiom,(
    ! [Tr0: dtree] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( gram_L864798063lle_wf @ ( gram_L1828378864e_rcut @ Tr0 ) ) ) )).

% wf_rcut
thf(fact_18_regular__rcut,axiom,(
    ! [Tr0: dtree] :
      ( gram_L646766332egular @ ( gram_L1828378864e_rcut @ Tr0 ) ) )).

% regular_rcut
thf(fact_19_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_20_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_21_rcut__eq,axiom,(
    ! [Tr0: dtree] :
      ( ( ( gram_L1828378864e_rcut @ Tr0 )
        = Tr0 )
      = ( gram_L1918716148le_reg @ ( gram_L1451583624elle_H @ Tr0 ) @ Tr0 ) ) )).

% rcut_eq
thf(fact_22_rcut__reg,axiom,(
    ! [Tr0: dtree] :
      ( ( gram_L1918716148le_reg @ ( gram_L1451583624elle_H @ Tr0 ) @ Tr0 )
     => ( ( gram_L1828378864e_rcut @ Tr0 )
        = Tr0 ) ) )).

% rcut_reg
thf(fact_23_reg__rcut,axiom,(
    ! [Tr0: dtree] :
      ( gram_L1918716148le_reg @ ( gram_L1451583624elle_H @ Tr0 ) @ ( gram_L1828378864e_rcut @ Tr0 ) ) )).

% reg_rcut
thf(fact_24_rcut__def,axiom,
    ( gram_L1828378864e_rcut
    = ( ^ [Tr02: dtree] :
          ( gram_L1451583624elle_H @ Tr02 @ ( root @ Tr02 ) ) ) )).

% rcut_def
thf(fact_25_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_26_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_27_root__deftr,axiom,(
    ! [N2: n] :
      ( ( root @ ( gram_L1231612515_deftr @ N2 ) )
      = N2 ) )).

% root_deftr
thf(fact_28_is__singletonI_H,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( A2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X2: A,Y: A] :
            ( ( member @ A @ X2 @ A2 )
           => ( ( member @ A @ Y @ A2 )
             => ( X2 = Y ) ) )
       => ( is_singleton @ A @ A2 ) ) ) )).

% is_singletonI'
thf(fact_29_reg__deftr,axiom,(
    ! [N2: n] :
      ( gram_L1918716148le_reg @ gram_L1231612515_deftr @ ( gram_L1231612515_deftr @ N2 ) ) )).

% reg_deftr
thf(fact_30_reg__def2,axiom,
    ( gram_L1918716148le_reg
    = ( ^ [F: ( n > dtree ),Tr2: dtree] :
        ! [Ns2: ( set @ n ),Tr3: dtree] :
          ( ( gram_L716654942_subtr @ Ns2 @ Tr3 @ Tr2 )
         => ( Tr3
            = ( F @ ( root @ Tr3 ) ) ) ) ) )).

% reg_def2
thf(fact_31_subtr__trans,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Tr32: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr22 @ Tr32 )
       => ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr32 ) ) ) )).

% subtr_trans
thf(fact_32_subtr__deftr,axiom,(
    ! [Ns: ( set @ n ),Tr4: dtree,N2: n] :
      ( ( gram_L716654942_subtr @ Ns @ Tr4 @ ( gram_L1231612515_deftr @ N2 ) )
     => ( Tr4
        = ( gram_L1231612515_deftr @ ( root @ Tr4 ) ) ) ) )).

% subtr_deftr
thf(fact_33_subtr_ORefl,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L716654942_subtr @ Ns @ Tr @ Tr ) ) )).

% subtr.Refl
thf(fact_34_subtr__rootL__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr1 ) @ Ns ) ) )).

% subtr_rootL_in
thf(fact_35_subtr__rootR__in,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( member @ n @ ( root @ Tr22 ) @ Ns ) ) )).

% subtr_rootR_in
thf(fact_36_wf__subtr,axiom,(
    ! [Tr1: dtree,Ns: ( set @ n ),Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr1 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L864798063lle_wf @ Tr ) ) ) )).

% wf_subtr
thf(fact_37_reg__subtr,axiom,(
    ! [F2: ( n > dtree ),Tr: dtree,Ns: ( set @ n ),Tr4: dtree] :
      ( ( gram_L1918716148le_reg @ F2 @ Tr )
     => ( ( gram_L716654942_subtr @ Ns @ Tr4 @ Tr )
       => ( gram_L1918716148le_reg @ F2 @ Tr4 ) ) ) )).

% reg_subtr
thf(fact_38_regular__subtr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),Tr4: dtree] :
      ( ( gram_L646766332egular @ Tr )
     => ( ( gram_L716654942_subtr @ Ns @ Tr4 @ Tr )
       => ( gram_L646766332egular @ Tr4 ) ) ) )).

% regular_subtr
thf(fact_39_wf__deftr,axiom,(
    ! [N2: n] :
      ( gram_L864798063lle_wf @ ( gram_L1231612515_deftr @ N2 ) ) )).

% wf_deftr
thf(fact_40_root__H__pick,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( root @ ( gram_L1451583624elle_H @ Tr0 @ N2 ) )
      = ( root @ ( gram_L315592705e_pick @ Tr0 @ N2 ) ) ) )).

% root_H_pick
thf(fact_41_reg__def,axiom,
    ( gram_L1918716148le_reg
    = ( ^ [F: ( n > dtree ),Tr2: dtree] :
        ! [Tr3: dtree] :
          ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr3 @ Tr2 )
         => ( Tr3
            = ( F @ ( root @ Tr3 ) ) ) ) ) )).

% reg_def
thf(fact_42_in__inv__imagep,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( inv_imagep @ A @ B )
      = ( ^ [R: ( A > A > $o ),F: ( B > A ),X: B,Y2: B] :
            ( R @ ( F @ X ) @ ( F @ Y2 ) ) ) ) )).

% in_inv_imagep
thf(fact_43_is__singletonI,axiom,(
    ! [A: $tType,X3: A] :
      ( is_singleton @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_44_inItr__subtr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N2: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N2 )
     => ? [Tr5: dtree] :
          ( ( gram_L716654942_subtr @ Ns @ Tr5 @ Tr )
          & ( ( root @ Tr5 )
            = N2 ) ) ) )).

% inItr_subtr
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F2 @ X2 )
          = ( G @ X2 ) )
     => ( F2 = G ) ) )).

% ext
thf(fact_49_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
          ? [X: A] :
            ( A4
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_50_is__singletonE,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( is_singleton @ A @ A2 )
     => ~ ( ! [X2: A] :
              ( A2
             != ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_51_root__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( root @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) )
      = ( root @ Tr ) ) )).

% root_hsubst
thf(fact_52_pairwise__empty,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) )).

% pairwise_empty
thf(fact_53_top__apply,axiom,(
    ! [C2: $tType,D: $tType] :
      ( ( top @ C2 @ ( type2 @ C2 ) )
     => ( ( top_top @ ( D > C2 ) )
        = ( ^ [X: D] :
              ( top_top @ C2 ) ) ) ) )).

% top_apply
thf(fact_54_UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_55_insert__absorb2,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ X3 @ A2 ) )
      = ( insert @ A @ X3 @ A2 ) ) )).

% insert_absorb2
thf(fact_56_insert__iff,axiom,(
    ! [A: $tType,A3: A,B2: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B2 @ A2 ) )
      = ( ( A3 = B2 )
        | ( member @ A @ A3 @ A2 ) ) ) )).

% insert_iff
thf(fact_57_insertCI,axiom,(
    ! [A: $tType,A3: A,B3: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A3 @ B3 )
       => ( A3 = B2 ) )
     => ( member @ A @ A3 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertCI
thf(fact_58_singletonI,axiom,(
    ! [A: $tType,A3: A] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_59_root__H,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
     => ( ( root @ ( gram_L1451583624elle_H @ Tr0 @ N2 ) )
        = N2 ) ) )).

% root_H
thf(fact_60_subtr__pick,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
     => ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ ( gram_L315592705e_pick @ Tr0 @ N2 ) @ Tr0 ) ) )).

% subtr_pick
thf(fact_61_pairwise__def,axiom,(
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R2: ( A > A > $o ),S: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ S )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ S )
               => ( ( X != Y2 )
                 => ( R2 @ X @ Y2 ) ) ) ) ) ) )).

% pairwise_def
thf(fact_62_wf__pick,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
       => ( gram_L864798063lle_wf @ ( gram_L315592705e_pick @ Tr0 @ N2 ) ) ) ) )).

% wf_pick
thf(fact_63_root__pick,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
     => ( ( root @ ( gram_L315592705e_pick @ Tr0 @ N2 ) )
        = N2 ) ) )).

% root_pick
thf(fact_64_mk__disjoint__insert,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ? [B4: ( set @ A )] :
          ( ( A2
            = ( insert @ A @ A3 @ B4 ) )
          & ~ ( member @ A @ A3 @ B4 ) ) ) )).

% mk_disjoint_insert
thf(fact_65_pairwise__insert,axiom,(
    ! [A: $tType,R3: ( A > A > $o ),X3: A,S2: ( set @ A )] :
      ( ( pairwise @ A @ R3 @ ( insert @ A @ X3 @ S2 ) )
      = ( ! [Y2: A] :
            ( ( ( member @ A @ Y2 @ S2 )
              & ( Y2 != X3 ) )
           => ( ( R3 @ X3 @ Y2 )
              & ( R3 @ Y2 @ X3 ) ) )
        & ( pairwise @ A @ R3 @ S2 ) ) ) )).

% pairwise_insert
thf(fact_66_insert__commute,axiom,(
    ! [A: $tType,X3: A,Y3: A,A2: ( set @ A )] :
      ( ( insert @ A @ X3 @ ( insert @ A @ Y3 @ A2 ) )
      = ( insert @ A @ Y3 @ ( insert @ A @ X3 @ A2 ) ) ) )).

% insert_commute
thf(fact_67_insert__eq__iff,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),B2: A,B3: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ A2 )
     => ( ~ ( member @ A @ B2 @ B3 )
       => ( ( ( insert @ A @ A3 @ A2 )
            = ( insert @ A @ B2 @ B3 ) )
          = ( ( ( A3 = B2 )
             => ( A2 = B3 ) )
            & ( ( A3 != B2 )
             => ? [C3: ( set @ A )] :
                  ( ( A2
                    = ( insert @ A @ B2 @ C3 ) )
                  & ~ ( member @ A @ B2 @ C3 )
                  & ( B3
                    = ( insert @ A @ A3 @ C3 ) )
                  & ~ ( member @ A @ A3 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_68_insert__absorb,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ( ( insert @ A @ A3 @ A2 )
        = A2 ) ) )).

% insert_absorb
thf(fact_69_insert__ident,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ~ ( member @ A @ X3 @ B3 )
       => ( ( ( insert @ A @ X3 @ A2 )
            = ( insert @ A @ X3 @ B3 ) )
          = ( A2 = B3 ) ) ) ) )).

% insert_ident
thf(fact_70_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_71_insert__UNIV,axiom,(
    ! [A: $tType,X3: A] :
      ( ( insert @ A @ X3 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% insert_UNIV
thf(fact_72_Set_Oset__insert,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A )] :
      ( ( member @ A @ X3 @ A2 )
     => ~ ( ! [B4: ( set @ A )] :
              ( ( A2
                = ( insert @ A @ X3 @ B4 ) )
             => ( member @ A @ X3 @ B4 ) ) ) ) )).

% Set.set_insert
thf(fact_73_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X2: A] :
          ( member @ A @ X2 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_74_insertI2,axiom,(
    ! [A: $tType,A3: A,B3: ( set @ A ),B2: A] :
      ( ( member @ A @ A3 @ B3 )
     => ( member @ A @ A3 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertI2
thf(fact_75_insertI1,axiom,(
    ! [A: $tType,A3: A,B3: ( set @ A )] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ B3 ) ) )).

% insertI1
thf(fact_76_insertE,axiom,(
    ! [A: $tType,A3: A,B2: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B2 @ A2 ) )
     => ( ( A3 != B2 )
       => ( member @ A @ A3 @ A2 ) ) ) )).

% insertE
thf(fact_77_pairwise__singleton,axiom,(
    ! [A: $tType,P: ( A > A > $o ),A2: A] :
      ( pairwise @ A @ P @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_78_pick,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
     => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ ( gram_L315592705e_pick @ Tr0 @ N2 ) @ Tr0 )
        & ( ( root @ ( gram_L315592705e_pick @ Tr0 @ N2 ) )
          = N2 ) ) ) )).

% pick
thf(fact_79_singleton__inject,axiom,(
    ! [A: $tType,A3: A,B2: A] :
      ( ( ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A3 = B2 ) ) )).

% singleton_inject
thf(fact_80_insert__not__empty,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( insert @ A @ A3 @ A2 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_81_doubleton__eq__iff,axiom,(
    ! [A: $tType,A3: A,B2: A,C: A,D2: A] :
      ( ( ( insert @ A @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A3 = C )
          & ( B2 = D2 ) )
        | ( ( A3 = D2 )
          & ( B2 = C ) ) ) ) )).

% doubleton_eq_iff
thf(fact_82_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A3: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A3 ) ) )).

% singleton_iff
thf(fact_83_singletonD,axiom,(
    ! [A: $tType,B2: A,A3: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A3 ) ) )).

% singletonD
thf(fact_84_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_85_subtr__H,axiom,(
    ! [Tr0: dtree,N2: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
     => ( ( gram_L716654942_subtr @ ( top_top @ ( set @ n ) ) @ Tr1 @ ( gram_L1451583624elle_H @ Tr0 @ N2 ) )
       => ? [N1: n] :
            ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N1 )
            & ( Tr1
              = ( gram_L1451583624elle_H @ Tr0 @ N1 ) ) ) ) ) )).

% subtr_H
thf(fact_86_wf__H,axiom,(
    ! [Tr0: dtree,N2: n] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( ( gram_L830233218_inItr @ ( top_top @ ( set @ n ) ) @ Tr0 @ N2 )
       => ( gram_L864798063lle_wf @ ( gram_L1451583624elle_H @ Tr0 @ N2 ) ) ) ) )).

% wf_H
thf(fact_87_inItr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N2: n] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N2 )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inItr_root_in
thf(fact_88_inItr_OBase,axiom,(
    ! [Tr: dtree,Ns: ( set @ n )] :
      ( ( member @ n @ ( root @ Tr ) @ Ns )
     => ( gram_L830233218_inItr @ Ns @ Tr @ ( root @ Tr ) ) ) )).

% inItr.Base
thf(fact_89_hsubst__eq,axiom,(
    ! [Tr: dtree,Tr0: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr0 ) )
     => ( ( gram_L1004374585hsubst @ Tr0 @ Tr )
        = ( gram_L1004374585hsubst @ Tr0 @ Tr0 ) ) ) )).

% hsubst_eq
thf(fact_90_subtr__inItr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N2: n,Tr1: dtree] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N2 )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L830233218_inItr @ Ns @ Tr1 @ N2 ) ) ) )).

% subtr_inItr
thf(fact_91_wf__hsubst,axiom,(
    ! [Tr0: dtree,Tr: dtree] :
      ( ( gram_L864798063lle_wf @ Tr0 )
     => ( ( gram_L864798063lle_wf @ Tr )
       => ( gram_L864798063lle_wf @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) ) ) ) )).

% wf_hsubst
thf(fact_92_H__r__def,axiom,
    ( gram_L1221482026le_H_r
    = ( ^ [Tr02: dtree,N: n] :
          ( root @ ( gram_L315592705e_pick @ Tr02 @ N ) ) ) )).

% H_r_def
thf(fact_93_L__rec__notin,axiom,(
    ! [N2: n,Ns: ( set @ n )] :
      ( ~ ( member @ n @ N2 @ Ns )
     => ( ( gram_L1451583628elle_L @ Ns @ N2 )
        = ( insert @ ( set @ t ) @ ( bot_bot @ ( set @ t ) ) @ ( bot_bot @ ( set @ ( set @ t ) ) ) ) ) ) )).

% L_rec_notin
thf(fact_94_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_95_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( insert @ A @ ( the_elem @ A @ A4 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_96_the__elem__eq,axiom,(
    ! [A: $tType,X3: A] :
      ( ( the_elem @ A @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
      = X3 ) )).

% the_elem_eq
thf(fact_97_hsubst__def,axiom,
    ( gram_L1004374585hsubst
    = ( ^ [Tr02: dtree] :
          ( unfold @ dtree @ gram_L1905609017ubst_r @ ( gram_L1905609002ubst_c @ Tr02 ) ) ) )).

% hsubst_def
thf(fact_98_Fr__rcut,axiom,(
    ! [Tr0: dtree] :
      ( ord_less_eq @ ( set @ t ) @ ( gram_L861583724lle_Fr @ ( top_top @ ( set @ n ) ) @ ( gram_L1828378864e_rcut @ Tr0 ) ) @ ( gram_L861583724lle_Fr @ ( top_top @ ( set @ n ) ) @ Tr0 ) ) )).

% Fr_rcut
thf(fact_99_inFr__hsubst__notin,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T: t,Tr0: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T )
     => ( ~ ( member @ n @ ( root @ Tr0 ) @ Ns )
       => ( gram_L1333338417e_inFr @ Ns @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) @ T ) ) ) )).

% inFr_hsubst_notin
thf(fact_100_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ord_less_eq @ A @ X3 @ X3 ) ) )).

% order_refl
thf(fact_101_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ A2 )
         => ( member @ A @ X2 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% subsetI
thf(fact_102_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A2 )
       => ( A2 = B3 ) ) ) )).

% subset_antisym
thf(fact_103_subset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_104_empty__subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) )).

% empty_subsetI
thf(fact_105_insert__subset,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ B3 )
      = ( ( member @ A @ X3 @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% insert_subset
thf(fact_106_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A3: A,A2: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A3 @ A2 ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_107_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A3 @ A2 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_108_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ X3 @ A2 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% set_mp
thf(fact_109_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ X3 @ A2 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% in_mono
thf(fact_110_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ C @ A2 )
       => ( member @ A @ C @ B3 ) ) ) )).

% subsetD
thf(fact_111_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( member @ A @ C @ A2 )
       => ( member @ A @ C @ B3 ) ) ) )).

% subsetCE
thf(fact_112_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( A2 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) ) )).

% equalityE
thf(fact_113_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ A4 )
           => ( member @ A @ X @ B5 ) ) ) ) )).

% subset_eq
thf(fact_114_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( A2 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% equalityD1
thf(fact_115_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( A2 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) )).

% equalityD2
thf(fact_116_set__rev__mp,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( member @ A @ X3 @ B3 ) ) ) )).

% set_rev_mp
thf(fact_117_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
          ! [T2: A] :
            ( ( member @ A @ T2 @ A4 )
           => ( member @ A @ T2 @ B5 ) ) ) ) )).

% subset_iff
thf(fact_118_rev__subsetD,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
       => ( member @ A @ C @ B3 ) ) ) )).

% rev_subsetD
thf(fact_119_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_120_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
         => ( Q @ X2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_121_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C4 ) ) ) )).

% subset_trans
thf(fact_122_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) )).

% le_funD
thf(fact_123_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G: ( A > B ),X3: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) )).

% le_funE
thf(fact_124_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F2: ( A > B ),G: ( A > B )] :
          ( ! [X2: A] :
              ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) )).

% le_funI
thf(fact_125_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y4: ( set @ A ),Z: ( set @ A )] : ( Y4 = Z ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A4 ) ) ) ) )).

% set_eq_subset
thf(fact_126_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ~ ( member @ A @ C @ B3 )
       => ~ ( member @ A @ C @ A2 ) ) ) )).

% contra_subsetD
thf(fact_127_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F: ( A > B ),G2: ( A > B )] :
            ! [X: A] :
              ( ord_less_eq @ B @ ( F @ X ) @ ( G2 @ X ) ) ) ) ) )).

% le_fun_def
thf(fact_128_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X: A] :
            ( ( P @ X )
           => ( Q @ X ) ) ) ) )).

% Collect_mono_iff
thf(fact_129_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B2: B,C: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C )
           => ( ! [X2: B,Y: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C ) ) ) ) ) ) )).

% order_subst1
thf(fact_130_order__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B2: A,F2: ( A > C2 ),C: C2] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ C2 @ ( F2 @ B2 ) @ C )
           => ( ! [X2: A,Y: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y )
                 => ( ord_less_eq @ C2 @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ C2 @ ( F2 @ A3 ) @ C ) ) ) ) ) )).

% order_subst2
thf(fact_131_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B2: B,C: B] :
          ( ( A3
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C )
           => ( ! [X2: B,Y: B] :
                  ( ( ord_less_eq @ B @ X2 @ Y )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F2 @ C ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_132_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B2: A,F2: ( A > B ),C: B] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ( F2 @ B2 )
              = C )
           => ( ! [X2: A,Y: A] :
                  ( ( ord_less_eq @ A @ X2 @ Y )
                 => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A3 ) @ C ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_133_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y4: A,Z: A] : ( Y4 = Z ) )
        = ( ^ [X: A,Y2: A] :
              ( ( ord_less_eq @ A @ X @ Y2 )
              & ( ord_less_eq @ A @ Y2 @ X ) ) ) ) ) )).

% eq_iff
thf(fact_134_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ X3 )
           => ( X3 = Y3 ) ) ) ) )).

% antisym
thf(fact_135_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
          | ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% linear
thf(fact_136_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( X3 = Y3 )
         => ( ord_less_eq @ A @ X3 @ Y3 ) ) ) )).

% eq_refl
thf(fact_137_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ~ ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% le_cases
thf(fact_138_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C )
           => ( ord_less_eq @ A @ A3 @ C ) ) ) ) )).

% order.trans
thf(fact_139_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X3 @ Y3 )
           => ~ ( ord_less_eq @ A @ Y3 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y3 @ X3 )
             => ~ ( ord_less_eq @ A @ X3 @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X3 @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y3 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y3 )
                 => ~ ( ord_less_eq @ A @ Y3 @ X3 ) )
               => ( ( ( ord_less_eq @ A @ Y3 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X3 ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X3 )
                     => ~ ( ord_less_eq @ A @ X3 @ Y3 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_140_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ Y3 @ X3 )
         => ( ( ord_less_eq @ A @ X3 @ Y3 )
            = ( X3 = Y3 ) ) ) ) )).

% antisym_conv
thf(fact_141_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C: A] :
          ( ( A3 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C )
           => ( ord_less_eq @ A @ A3 @ C ) ) ) ) )).

% ord_eq_le_trans
thf(fact_142_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( B2 = C )
           => ( ord_less_eq @ A @ A3 @ C ) ) ) ) )).

% ord_le_eq_trans
thf(fact_143_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A3 )
           => ( A3 = B2 ) ) ) ) )).

% order_class.order.antisym
thf(fact_144_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A,Z2: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ( ord_less_eq @ A @ Y3 @ Z2 )
           => ( ord_less_eq @ A @ X3 @ Z2 ) ) ) ) )).

% order_trans
thf(fact_145_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_146_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A3: A,B2: A] :
          ( ! [A5: A,B6: A] :
              ( ( ord_less_eq @ A @ A5 @ B6 )
             => ( P @ A5 @ B6 ) )
         => ( ! [A5: A,B6: A] :
                ( ( P @ B6 @ A5 )
               => ( P @ A5 @ B6 ) )
           => ( P @ A3 @ B2 ) ) ) ) )).

% linorder_wlog
thf(fact_147_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A3: A,C: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ C @ B2 )
           => ( ord_less_eq @ A @ C @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_148_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
           => ( A3 = B2 ) ) ) ) )).

% dual_order.antisym
thf(fact_149_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_150_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_151_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) )).

% bot.extremum
thf(fact_152_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_153_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_154_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_155_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_156_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_157_subset__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_158_insert__mono,axiom,(
    ! [A: $tType,C4: ( set @ A ),D3: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ D3 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A3 @ C4 ) @ ( insert @ A @ A3 @ D3 ) ) ) )).

% insert_mono
thf(fact_159_subset__insert,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% subset_insert
thf(fact_160_subset__insertI,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: A] :
      ( ord_less_eq @ ( set @ A ) @ B3 @ ( insert @ A @ A3 @ B3 ) ) )).

% subset_insertI
thf(fact_161_subset__insertI2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% subset_insertI2
thf(fact_162_inFr__root__in,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T: t] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T )
     => ( member @ n @ ( root @ Tr ) @ Ns ) ) )).

% inFr_root_in
thf(fact_163_not__root__inFr,axiom,(
    ! [Tr: dtree,Ns: ( set @ n ),T: t] :
      ( ~ ( member @ n @ ( root @ Tr ) @ Ns )
     => ~ ( gram_L1333338417e_inFr @ Ns @ Tr @ T ) ) )).

% not_root_inFr
thf(fact_164_subtr__inFr,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T: t,Tr1: dtree] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T )
     => ( ( gram_L716654942_subtr @ Ns @ Tr @ Tr1 )
       => ( gram_L1333338417e_inFr @ Ns @ Tr1 @ T ) ) ) )).

% subtr_inFr
thf(fact_165_pairwise__subset,axiom,(
    ! [A: $tType,P: ( A > A > $o ),S3: ( set @ A ),T3: ( set @ A )] :
      ( ( pairwise @ A @ P @ S3 )
     => ( ( ord_less_eq @ ( set @ A ) @ T3 @ S3 )
       => ( pairwise @ A @ P @ T3 ) ) ) )).

% pairwise_subset
thf(fact_166_subset__singletonD,axiom,(
    ! [A: $tType,A2: ( set @ A ),X3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ( A2
          = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_167_subset__singleton__iff,axiom,(
    ! [A: $tType,X4: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X4 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X4
          = ( bot_bot @ ( set @ A ) ) )
        | ( X4
          = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_168_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B2: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% unfold(1)
thf(fact_169_insert__subsetI,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),X4: ( set @ A )] :
      ( ( member @ A @ X3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ X4 @ A2 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X3 @ X4 ) @ A2 ) ) ) )).

% insert_subsetI
thf(fact_170_subset__emptyI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X2: A] :
          ~ ( member @ A @ X2 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_171_Pow__empty,axiom,(
    ! [A: $tType] :
      ( ( pow @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) )).

% Pow_empty
thf(fact_172_Pow__singleton__iff,axiom,(
    ! [A: $tType,X4: ( set @ A ),Y5: ( set @ A )] :
      ( ( ( pow @ A @ X4 )
        = ( insert @ ( set @ A ) @ Y5 @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) )
      = ( ( X4
          = ( bot_bot @ ( set @ A ) ) )
        & ( Y5
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Pow_singleton_iff
thf(fact_173_top1I,axiom,(
    ! [A: $tType,X3: A] :
      ( top_top @ ( A > $o ) @ X3 ) )).

% top1I
thf(fact_174_Pow__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A2 @ ( pow @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% Pow_iff
thf(fact_175_PowI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( member @ ( set @ A ) @ A2 @ ( pow @ A @ B3 ) ) ) )).

% PowI
thf(fact_176_Pow__UNIV,axiom,(
    ! [A: $tType] :
      ( ( pow @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( set @ A ) ) ) ) )).

% Pow_UNIV
thf(fact_177_Pow__top,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( set @ A ) @ A2 @ ( pow @ A @ A2 ) ) )).

% Pow_top
thf(fact_178_Pow__bottom,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( pow @ A @ B3 ) ) )).

% Pow_bottom
thf(fact_179_Pow__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow @ A @ A2 ) @ ( pow @ A @ B3 ) ) ) )).

% Pow_mono
thf(fact_180_PowD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A2 @ ( pow @ A @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% PowD
thf(fact_181_subtr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr1: dtree,Tr22: dtree,Ns3: ( set @ n )] :
      ( ( gram_L716654942_subtr @ Ns @ Tr1 @ Tr22 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L716654942_subtr @ Ns3 @ Tr1 @ Tr22 ) ) ) )).

% subtr_mono
thf(fact_182_inFr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,T: t,Ns3: ( set @ n )] :
      ( ( gram_L1333338417e_inFr @ Ns @ Tr @ T )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L1333338417e_inFr @ Ns3 @ Tr @ T ) ) ) )).

% inFr_mono
thf(fact_183_inItr__mono,axiom,(
    ! [Ns: ( set @ n ),Tr: dtree,N2: n,Ns3: ( set @ n )] :
      ( ( gram_L830233218_inItr @ Ns @ Tr @ N2 )
     => ( ( ord_less_eq @ ( set @ n ) @ Ns @ Ns3 )
       => ( gram_L830233218_inItr @ Ns3 @ Tr @ N2 ) ) ) )).

% inItr_mono
thf(fact_184_Pow__not__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( pow @ A @ A2 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) )).

% Pow_not_empty
thf(fact_185_H__def,axiom,
    ( gram_L1451583624elle_H
    = ( ^ [Tr02: dtree] :
          ( unfold @ n @ ( gram_L1221482026le_H_r @ Tr02 ) @ ( gram_L1221482011le_H_c @ Tr02 ) ) ) )).

% H_def
thf(fact_186_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X3: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X3 ) )
      = P ) )).

% top_conj(2)
thf(fact_187_top__conj_I1_J,axiom,(
    ! [A: $tType,X3: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X3 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_188_root__Node,axiom,(
    ! [N2: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N2 @ As ) )
      = N2 ) )).

% root_Node
thf(fact_189_subset__Compl__singleton,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A2 ) ) ) )).

% subset_Compl_singleton
thf(fact_190_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A2 )
        = ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( A2 = B3 ) ) )).

% Compl_eq_Compl_iff
thf(fact_191_Compl__iff,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A )] :
      ( ( member @ A @ C @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = ( ~ ( member @ A @ C @ A2 ) ) ) )).

% Compl_iff
thf(fact_192_ComplI,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A )] :
      ( ~ ( member @ A @ C @ A2 )
     => ( member @ A @ C @ ( uminus_uminus @ ( set @ A ) @ A2 ) ) ) )).

% ComplI
thf(fact_193_Compl__subset__Compl__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ B3 @ A2 ) ) )).

% Compl_subset_Compl_iff
thf(fact_194_Compl__anti__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) ) ) )).

% Compl_anti_mono
thf(fact_195_subset__Compl__self__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_Compl_self_eq
thf(fact_196_Compl__UNIV__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_UNIV_eq
thf(fact_197_Compl__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Compl_empty_eq
thf(fact_198_double__complement,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
      = A2 ) )).

% double_complement
thf(fact_199_ComplD,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A )] :
      ( ( member @ A @ C @ ( uminus_uminus @ ( set @ A ) @ A2 ) )
     => ~ ( member @ A @ C @ A2 ) ) )).

% ComplD
thf(fact_200_compl__bot__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( bot_bot @ A ) )
        = ( top_top @ A ) ) ) )).

% compl_bot_eq
thf(fact_201_compl__top__eq,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( top_top @ A ) )
        = ( bot_bot @ A ) ) ) )).

% compl_top_eq
thf(fact_202_compl__le__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ ( uminus_uminus @ A @ Y3 ) )
          = ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% compl_le_compl_iff
thf(fact_203_compl__mono,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ( ord_less_eq @ A @ X3 @ Y3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y3 ) @ ( uminus_uminus @ A @ X3 ) ) ) ) )).

% compl_mono
thf(fact_204_compl__le__swap1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ Y3 @ ( uminus_uminus @ A @ X3 ) )
         => ( ord_less_eq @ A @ X3 @ ( uminus_uminus @ A @ Y3 ) ) ) ) )).

% compl_le_swap1
thf(fact_205_compl__le__swap2,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y3 ) @ X3 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X3 ) @ Y3 ) ) ) )).

% compl_le_swap2
thf(fact_206_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B2 ) ) ) )).

% neg_le_iff_le
thf(fact_207_le__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_minus_iff
thf(fact_208_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_imp_neg_le
thf(fact_209_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A3 ) ) ) )).

% minus_le_iff
thf(fact_210_inFr__hsubst__minus,axiom,(
    ! [Ns: ( set @ n ),Tr0: dtree,Tr: dtree,T: t] :
      ( ( gram_L1333338417e_inFr @ ( minus_minus @ ( set @ n ) @ Ns @ ( insert @ n @ ( root @ Tr0 ) @ ( bot_bot @ ( set @ n ) ) ) ) @ Tr @ T )
     => ( gram_L1333338417e_inFr @ Ns @ ( gram_L1004374585hsubst @ Tr0 @ Tr ) @ T ) ) )).

% inFr_hsubst_minus
thf(fact_211_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B2: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B2 ) )
      = ( Rt @ B2 ) ) )).

% corec(1)
thf(fact_212_DiffI,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ A2 )
     => ( ~ ( member @ A @ C @ B3 )
       => ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) ) )).

% DiffI
thf(fact_213_Diff__iff,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
      = ( ( member @ A @ C @ A2 )
        & ~ ( member @ A @ C @ B3 ) ) ) )).

% Diff_iff
thf(fact_214_Diff__idemp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ B3 )
      = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) )).

% Diff_idemp
thf(fact_215_Diff__cancel,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ A2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_216_empty__Diff,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_217_Diff__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = A2 ) )).

% Diff_empty
thf(fact_218_insert__Diff1,axiom,(
    ! [A: $tType,X3: A,B3: ( set @ A ),A2: ( set @ A )] :
      ( ( member @ A @ X3 @ B3 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ B3 )
        = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% insert_Diff1
thf(fact_219_Diff__insert0,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) )
        = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% Diff_insert0
thf(fact_220_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A2 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) )).

% Diff_eq_empty_iff
thf(fact_221_Diff__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_UNIV
thf(fact_222_insert__Diff__single,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( insert @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A3 @ A2 ) ) )).

% insert_Diff_single
thf(fact_223_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C: A,D2: A] :
          ( ( ( minus_minus @ A @ A3 @ B2 )
            = ( minus_minus @ A @ C @ D2 ) )
         => ( ( ord_less_eq @ A @ A3 @ B2 )
            = ( ord_less_eq @ A @ C @ D2 ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_224_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,C: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C ) @ ( minus_minus @ A @ B2 @ C ) ) ) ) )).

% diff_right_mono
thf(fact_225_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A3: A,C: A] :
          ( ( ord_less_eq @ A @ B2 @ A3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C @ A3 ) @ ( minus_minus @ A @ C @ B2 ) ) ) ) )).

% diff_left_mono
thf(fact_226_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B2: A,D2: A,C: A] :
          ( ( ord_less_eq @ A @ A3 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) )).

% diff_mono
thf(fact_227_insert__Diff__if,axiom,(
    ! [A: $tType,X3: A,B3: ( set @ A ),A2: ( set @ A )] :
      ( ( ( member @ A @ X3 @ B3 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ B3 )
          = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) )
      & ( ~ ( member @ A @ X3 @ B3 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ B3 )
          = ( insert @ A @ X3 @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) ) ) )).

% insert_Diff_if
thf(fact_228_DiffE,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ( ( member @ A @ C @ A2 )
         => ( member @ A @ C @ B3 ) ) ) )).

% DiffE
thf(fact_229_DiffD1,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ( member @ A @ C @ A2 ) ) )).

% DiffD1
thf(fact_230_DiffD2,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ( member @ A @ C @ B3 ) ) )).

% DiffD2
thf(fact_231_subset__Diff__insert,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),X3: A,C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B3 @ ( insert @ A @ X3 @ C4 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B3 @ C4 ) )
        & ~ ( member @ A @ X3 @ A2 ) ) ) )).

% subset_Diff_insert
thf(fact_232_Diff__insert__absorb,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A )] :
      ( ~ ( member @ A @ X3 @ A2 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
        = A2 ) ) )).

% Diff_insert_absorb
thf(fact_233_Diff__insert2,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A,B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) ) )).

% Diff_insert2
thf(fact_234_insert__Diff,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ( ( insert @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A2 ) ) )).

% insert_Diff
thf(fact_235_Diff__insert,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A,B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ A3 @ B3 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert
thf(fact_236_Diff__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),C4: ( set @ A ),D3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ D3 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ ( minus_minus @ ( set @ A ) @ C4 @ D3 ) ) ) ) )).

% Diff_mono
thf(fact_237_Diff__subset,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ A2 ) )).

% Diff_subset
thf(fact_238_double__diff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C4 )
       => ( ( minus_minus @ ( set @ A ) @ B3 @ ( minus_minus @ ( set @ A ) @ C4 @ A2 ) )
          = A2 ) ) ) )).

% double_diff
thf(fact_239_Compl__eq__Diff__UNIV,axiom,(
    ! [A: $tType] :
      ( ( uminus_uminus @ ( set @ A ) )
      = ( minus_minus @ ( set @ A ) @ ( top_top @ ( set @ A ) ) ) ) )).

% Compl_eq_Diff_UNIV
thf(fact_240_Diff__single__insert,axiom,(
    ! [A: $tType,A2: ( set @ A ),X3: A,B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) ) ) )).

% Diff_single_insert
thf(fact_241_subset__insert__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),X3: A,B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) )
      = ( ( ( member @ A @ X3 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
        & ( ~ ( member @ A @ X3 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ) )).

% subset_insert_iff
thf(fact_242_Compl__insert,axiom,(
    ! [A: $tType,X3: A,A2: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X3 @ A2 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A2 ) @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Compl_insert
thf(fact_243_remove__def,axiom,(
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X: A,A4: ( set @ A )] :
            ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% remove_def
thf(fact_244_psubset__insert__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),X3: A,B3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ B3 ) )
      = ( ( ( member @ A @ X3 @ B3 )
         => ( ord_less @ ( set @ A ) @ A2 @ B3 ) )
        & ( ~ ( member @ A @ X3 @ B3 )
         => ( ( ( member @ A @ X3 @ A2 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
            & ( ~ ( member @ A @ X3 @ A2 )
             => ( ord_less_eq @ ( set @ A ) @ A2 @ B3 ) ) ) ) ) ) )).

% psubset_insert_iff
thf(fact_245_member__remove,axiom,(
    ! [A: $tType,X3: A,Y3: A,A2: ( set @ A )] :
      ( ( member @ A @ X3 @ ( remove @ A @ Y3 @ A2 ) )
      = ( ( member @ A @ X3 @ A2 )
        & ( X3 != Y3 ) ) ) )).

% member_remove
thf(fact_246_psubsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B3 )
     => ( ( A2 != B3 )
       => ( ord_less @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% psubsetI
thf(fact_247_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( A3
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A3 ) ) ) )).

% bot.not_eq_extremum
thf(fact_248_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_249_not__psubset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_250_psubset__imp__ex__mem,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B3 )
     => ? [B6: A] :
          ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) ) ) )).

% psubset_imp_ex_mem
thf(fact_251_leD,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y3: A,X3: A] :
          ( ( ord_less_eq @ A @ Y3 @ X3 )
         => ~ ( ord_less @ A @ X3 @ Y3 ) ) ) )).

% leD
thf(fact_252_leI,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y3: A] :
          ( ~ ( ord_less @ A @ X3 @ Y3 )
         => ( ord_less_eq @ A @ Y3 @ X3 ) ) ) )).

% leI
thf(fact_253_le__less,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [X: A,Y2: A] :
              ( ( ord_less @ A @ X @ Y2 )
              | ( X = Y2 ) ) ) ) ) )).

% le_less
thf(fact_254_less__le,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X: A,Y2: A] :
              ( ( ord_less_eq @ A @ X @ Y2 )
              & ( X != Y2 ) ) ) ) ) )).

% less_le
thf(fact_255_order__le__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F2: ( B > A ),B2: B,C: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C )
           => ( ! [X2: B,Y: B] :
                  ( ( ord_less @ B @ X2 @ Y )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y ) ) )
             => ( ord_less @ A @ A3 @ ( F2 @ C ) ) ) ) ) ) )).

% order_le_less_subst1

%----Type constructors (25)
thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( boolean_algebra @ A7 @ ( type2 @ A7 ) )
     => ( boolean_algebra @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order_top @ A7 @ ( type2 @ A7 ) )
     => ( order_top @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order_bot @ A7 @ ( type2 @ A7 ) )
     => ( order_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( preorder @ A7 @ ( type2 @ A7 ) )
     => ( preorder @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( top @ A7 @ ( type2 @ A7 ) )
     => ( top @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bot @ A7 @ ( type2 @ A7 ) )
     => ( bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_1,axiom,(
    ! [A6: $tType] :
      ( boolean_algebra @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_2,axiom,(
    ! [A6: $tType] :
      ( order_top @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_3,axiom,(
    ! [A6: $tType] :
      ( order_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_4,axiom,(
    ! [A6: $tType] :
      ( preorder @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_5,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_6,axiom,(
    ! [A6: $tType] :
      ( top @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_7,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_8,axiom,(
    ! [A6: $tType] :
      ( bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_9,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_10,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_11,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_12,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_13,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_14,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_15,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_16,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    $true )).

thf(conj_1,conjecture,(
    ? [Tr6: dtree] :
      ( ( ( bot_bot @ ( set @ t ) )
        = ( gram_L861583724lle_Fr @ ns @ Tr6 ) )
      & ( gram_L864798063lle_wf @ Tr6 )
      & ( ( root @ Tr6 )
        = n2 )
      & ( gram_L646766332egular @ Tr6 ) ) )).

%------------------------------------------------------------------------------
