%------------------------------------------------------------------------------
% File     : COM202^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Parallel extension to grammars and languages 38
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : parallel__38.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  323 (   0 unit;  46 type;   0 defn)
%            Number of atoms       : 4776 ( 339 equality;2814 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 4406 ( 106   ~;  22   |;  57   &;3981   @)
%                                         (   0 <=>; 240  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  261 ( 261   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   50 (  46   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1268 (  27 sgn;1073   !;  24   ?; 120   ^)
%                                         (1268   :;  51  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:38:45.901
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (39)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__c,type,(
    parall1914194347_par_c: ( product_prod @ dtree @ dtree ) > ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__c__rel,type,(
    parall1418634510_c_rel: ( product_prod @ dtree @ dtree ) > ( product_prod @ dtree @ dtree ) > $o )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_OSigma,type,(
    product_Sigma: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oproduct,type,(
    product_product: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_OId,type,(
    id: 
      !>[A: $tType] :
        ( set @ ( product_prod @ A @ A ) ) )).

thf(sy_c_Relation_Oantisym,type,(
    antisym: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_tr1,type,(
    tr1: dtree )).

thf(sy_v_tr2,type,(
    tr2: dtree )).

%----Relevant facts (256)
thf(fact_0_finite__SigmaI,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ! [A3: A] :
            ( ( member @ A @ A3 @ A2 )
           => ( finite_finite2 @ B @ ( B2 @ A3 ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) ) ) ) )).

% finite_SigmaI
thf(fact_1_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_2_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_3_vimage__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A2: ( set @ B ),B2: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( sup_sup @ ( set @ B ) @ A2 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ A2 ) @ ( vimage @ A @ B @ F @ B2 ) ) ) )).

% vimage_Un
thf(fact_4_finite__Un,axiom,(
    ! [A: $tType,F2: ( set @ A ),G: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ F2 @ G ) )
      = ( ( finite_finite2 @ A @ F2 )
        & ( finite_finite2 @ A @ G ) ) ) )).

% finite_Un
thf(fact_5_finite__imageI,axiom,(
    ! [B: $tType,A: $tType,F2: ( set @ A ),H: ( A > B )] :
      ( ( finite_finite2 @ A @ F2 )
     => ( finite_finite2 @ B @ ( image @ A @ B @ H @ F2 ) ) ) )).

% finite_imageI
thf(fact_6_par__c_Oelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y: ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) )] :
      ( ( ( parall1914194347_par_c @ X )
        = Y )
     => ~ ( ! [Tr1: dtree,Tr2: dtree] :
              ( ( X
                = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
             => ( Y
               != ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr1 ) @ ( cont @ Tr2 ) ) ) )
                  @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
                    @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr1 ) )
                      @ ^ [Uu: dtree] :
                          ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr2 ) ) ) ) ) ) ) ) ) )).

% par_c.elims
thf(fact_7_par__c_Osimps,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( parall1914194347_par_c @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) )
      = ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr12 ) @ ( cont @ Tr22 ) ) ) )
        @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
          @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr12 ) )
            @ ^ [Uu: dtree] :
                ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr22 ) ) ) ) ) ) )).

% par_c.simps
thf(fact_8_vimage__ident,axiom,(
    ! [A: $tType,Y2: ( set @ A )] :
      ( ( vimage @ A @ A
        @ ^ [X2: A] : X2
        @ Y2 )
      = Y2 ) )).

% vimage_ident
thf(fact_9_vimage__Collect__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),P: ( B > $o )] :
      ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
      = ( collect @ A
        @ ^ [Y3: A] :
            ( P @ ( F @ Y3 ) ) ) ) )).

% vimage_Collect_eq
thf(fact_10_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ ( sum_sum @ A @ B ) ),B2: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A2 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B2 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A2 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B2 ) )
       => ( A2 = B2 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_11_finite__Collect__conjI,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        | ( finite_finite2 @ A @ ( collect @ A @ Q ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              & ( Q @ X2 ) ) ) ) ) )).

% finite_Collect_conjI
thf(fact_12_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),X: B,A2: ( set @ B )] :
      ( ( B3
        = ( F @ X ) )
     => ( ( member @ B @ X @ A2 )
       => ( member @ A @ B3 @ ( image @ B @ A @ F @ A2 ) ) ) ) )).

% image_eqI
thf(fact_13_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A4: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_14_Un__iff,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
      = ( ( member @ A @ C2 @ A2 )
        | ( member @ A @ C2 @ B2 ) ) ) )).

% Un_iff
thf(fact_15_UnCI,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A2: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ A2 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% UnCI
thf(fact_16_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ B2 ) )
      = ( member @ B @ ( F @ A5 ) @ B2 ) ) )).

% vimage_eq
thf(fact_17_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A5: B,B3: A,B2: ( set @ A )] :
      ( ( ( F @ A5 )
        = B3 )
     => ( ( member @ A @ B3 @ B2 )
       => ( member @ B @ A5 @ ( vimage @ B @ A @ F @ B2 ) ) ) ) )).

% vimageI
thf(fact_18_image__ident,axiom,(
    ! [A: $tType,Y2: ( set @ A )] :
      ( ( image @ A @ A
        @ ^ [X2: A] : X2
        @ Y2 )
      = Y2 ) )).

% image_ident
thf(fact_19_finite__Collect__disjI,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( P @ X2 )
              | ( Q @ X2 ) ) ) )
      = ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        & ( finite_finite2 @ A @ ( collect @ A @ Q ) ) ) ) )).

% finite_Collect_disjI
thf(fact_20_par__r_Ocases,axiom,(
    ! [X: ( product_prod @ dtree @ dtree )] :
      ~ ( ! [Tr1: dtree,Tr2: dtree] :
            ( X
           != ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) )).

% par_r.cases
thf(fact_21_par__r_Oinduct,axiom,(
    ! [P: ( ( product_prod @ dtree @ dtree ) > $o ),A0: ( product_prod @ dtree @ dtree )] :
      ( ! [Tr1: dtree,Tr2: dtree] :
          ( P @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
     => ( P @ A0 ) ) )).

% par_r.induct
thf(fact_22_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A2: ( set @ A ),B3: B,F: ( A > B )] :
      ( ( member @ A @ X @ A2 )
     => ( ( B3
          = ( F @ X ) )
       => ( member @ B @ B3 @ ( image @ A @ B @ F @ A2 ) ) ) ) )).

% rev_image_eqI
thf(fact_23_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A2 ) )
         => ( P @ X3 ) )
     => ! [X4: B] :
          ( ( member @ B @ X4 @ A2 )
         => ( P @ ( F @ X4 ) ) ) ) )).

% ball_imageD
thf(fact_24_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F: ( A > B ),G2: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N )
           => ( ( F @ X3 )
              = ( G2 @ X3 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G2 @ N ) ) ) ) )).

% image_cong
thf(fact_25_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A2 ) )
          & ( P @ X4 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A2 )
          & ( P @ ( F @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_26_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z: A,F: ( B > A ),A2: ( set @ B )] :
      ( ( member @ A @ Z @ ( image @ B @ A @ F @ A2 ) )
      = ( ? [X2: B] :
            ( ( member @ B @ X2 @ A2 )
            & ( Z
              = ( F @ X2 ) ) ) ) ) )).

% image_iff
thf(fact_27_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A2: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A2 )
     => ( member @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A2 ) ) ) )).

% imageI
thf(fact_28_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( finite_finite2 @ A @ A2 ) ) )).

% finite
thf(fact_29_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A2 )
           => ? [X1: B] :
                ( P @ X3 @ X1 ) )
       => ? [F3: ( A > B )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A2 )
           => ( P @ X4 @ ( F3 @ X4 ) ) ) ) ) )).

% finite_set_choice
thf(fact_30_Un__left__commute,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B2 @ ( sup_sup @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_31_Un__left__absorb,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) )).

% Un_left_absorb
thf(fact_32_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B4 @ A4 ) ) ) )).

% Un_commute
thf(fact_33_Un__absorb,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ A2 )
      = A2 ) )).

% Un_absorb
thf(fact_34_Un__assoc,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_assoc
thf(fact_35_ball__Un,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
           => ( P @ X2 ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A2 )
           => ( P @ X2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ B2 )
           => ( P @ X2 ) ) ) ) )).

% ball_Un
thf(fact_36_bex__Un,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
            & ( P @ X2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ A2 )
            & ( P @ X2 ) )
        | ? [X2: A] :
            ( ( member @ A @ X2 @ B2 )
            & ( P @ X2 ) ) ) ) )).

% bex_Un
thf(fact_37_UnI2,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A2: ( set @ A )] :
      ( ( member @ A @ C2 @ B2 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% UnI2
thf(fact_38_UnI1,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% UnI1
thf(fact_39_UnE,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
     => ( ~ ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% UnE
thf(fact_40_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_41_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A5: B,A2: ( set @ A )] :
      ( ( member @ A @ ( F @ A5 ) @ A2 )
     => ( member @ B @ A5 @ ( vimage @ B @ A @ F @ A2 ) ) ) )).

% vimageI2
thf(fact_42_vimageE,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ B2 ) )
     => ( member @ B @ ( F @ A5 ) @ B2 ) ) )).

% vimageE
thf(fact_43_vimageD,axiom,(
    ! [A: $tType,B: $tType,A5: A,F: ( A > B ),A2: ( set @ B )] :
      ( ( member @ A @ A5 @ ( vimage @ A @ B @ F @ A2 ) )
     => ( member @ B @ ( F @ A5 ) @ A2 ) ) )).

% vimageD
thf(fact_44_Compr__image__eq,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ ( image @ B @ A @ F @ A2 ) )
            & ( P @ X2 ) ) )
      = ( image @ B @ A @ F
        @ ( collect @ B
          @ ^ [X2: B] :
              ( ( member @ B @ X2 @ A2 )
              & ( P @ ( F @ X2 ) ) ) ) ) ) )).

% Compr_image_eq
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A5: A,P: ( A > $o )] :
      ( ( member @ A @ A5 @ ( collect @ A @ P ) )
      = ( P @ A5 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G2: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G2 @ X3 ) )
     => ( F = G2 ) ) )).

% ext
thf(fact_49_image__image,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G2: ( C > B ),A2: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G2 @ A2 ) )
      = ( image @ C @ A
        @ ^ [X2: C] :
            ( F @ ( G2 @ X2 ) )
        @ A2 ) ) )).

% image_image
thf(fact_50_imageE,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),A2: ( set @ B )] :
      ( ( member @ A @ B3 @ ( image @ B @ A @ F @ A2 ) )
     => ~ ( ! [X3: B] :
              ( ( B3
                = ( F @ X3 ) )
             => ~ ( member @ B @ X3 @ A2 ) ) ) ) )).

% imageE
thf(fact_51_pigeonhole__infinite__rel,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ B ),R: ( A > B > $o )] :
      ( ~ ( finite_finite2 @ A @ A2 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( ! [X3: A] :
              ( ( member @ A @ X3 @ A2 )
             => ? [Xa: B] :
                  ( ( member @ B @ Xa @ B2 )
                  & ( R @ X3 @ Xa ) ) )
         => ? [X3: B] :
              ( ( member @ B @ X3 @ B2 )
              & ~ ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [A6: A] :
                        ( ( member @ A @ A6 @ A2 )
                        & ( R @ A6 @ X3 ) ) ) ) ) ) ) ) )).

% pigeonhole_infinite_rel
thf(fact_52_not__finite__existsD,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ~ ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ? [X12: A] :
          ( P @ X12 ) ) )).

% not_finite_existsD
thf(fact_53_Collect__disj__eq,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            | ( Q @ X2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_disj_eq
thf(fact_54_Un__def,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A4 )
                | ( member @ A @ X2 @ B4 ) ) ) ) ) )).

% Un_def
thf(fact_55_vimage__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F4: ( A > B ),B4: ( set @ B )] :
            ( collect @ A
            @ ^ [X2: A] :
                ( member @ B @ ( F4 @ X2 ) @ B4 ) ) ) ) )).

% vimage_def
thf(fact_56_image__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),B2: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A2 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F @ A2 ) @ ( image @ B @ A @ F @ B2 ) ) ) )).

% image_Un
thf(fact_57_infinite__Un,axiom,(
    ! [A: $tType,S: ( set @ A ),T2: ( set @ A )] :
      ( ( ~ ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ S @ T2 ) ) )
      = ( ~ ( finite_finite2 @ A @ S )
        | ~ ( finite_finite2 @ A @ T2 ) ) ) )).

% infinite_Un
thf(fact_58_Un__infinite,axiom,(
    ! [A: $tType,S: ( set @ A ),T2: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S )
     => ~ ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ S @ T2 ) ) ) )).

% Un_infinite
thf(fact_59_finite__UnI,axiom,(
    ! [A: $tType,F2: ( set @ A ),G: ( set @ A )] :
      ( ( finite_finite2 @ A @ F2 )
     => ( ( finite_finite2 @ A @ G )
       => ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ F2 @ G ) ) ) ) )).

% finite_UnI
thf(fact_60_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S2: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X3: A] :
          ( ( S2
            = ( F @ ( sum_Inl @ A @ C @ X3 ) ) )
         => P )
     => ( ! [X3: C] :
            ( ( S2
              = ( F @ ( sum_Inr @ C @ A @ X3 ) ) )
           => P )
       => ! [X4: ( sum_sum @ A @ C )] :
            ( ( S2
              = ( F @ X4 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_61_pigeonhole__infinite,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),F: ( A > B )] :
      ( ~ ( finite_finite2 @ A @ A2 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F @ A2 ) )
       => ? [X3: A] :
            ( ( member @ A @ X3 @ A2 )
            & ~ ( finite_finite2 @ A
                @ ( collect @ A
                  @ ^ [A6: A] :
                      ( ( member @ A @ A6 @ A2 )
                      & ( ( F @ A6 )
                        = ( F @ X3 ) ) ) ) ) ) ) ) )).

% pigeonhole_infinite
thf(fact_62_finite__cartesian__product,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( finite_finite2 @ ( product_prod @ A @ B )
          @ ( product_Sigma @ A @ B @ A2
            @ ^ [Uu: A] : B2 ) ) ) ) )).

% finite_cartesian_product
thf(fact_63_par__c_Opelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y: ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) )] :
      ( ( ( parall1914194347_par_c @ X )
        = Y )
     => ( ( accp @ ( product_prod @ dtree @ dtree ) @ parall1418634510_c_rel @ X )
       => ~ ( ! [Tr1: dtree,Tr2: dtree] :
                ( ( X
                  = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
               => ( ( Y
                    = ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr1 ) @ ( cont @ Tr2 ) ) ) )
                      @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
                        @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr1 ) )
                          @ ^ [Uu: dtree] :
                              ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr2 ) ) ) ) ) )
                 => ~ ( accp @ ( product_prod @ dtree @ dtree ) @ parall1418634510_c_rel @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) ) ) ) ) )).

% par_c.pelims
thf(fact_64_mem__Sigma__iff,axiom,(
    ! [B: $tType,A: $tType,A5: A,B3: B,A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B3 ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) )
      = ( ( member @ A @ A5 @ A2 )
        & ( member @ B @ B3 @ ( B2 @ A5 ) ) ) ) )).

% mem_Sigma_iff
thf(fact_65_SigmaI,axiom,(
    ! [B: $tType,A: $tType,A5: A,A2: ( set @ A ),B3: B,B2: ( A > ( set @ B ) )] :
      ( ( member @ A @ A5 @ A2 )
     => ( ( member @ B @ B3 @ ( B2 @ A5 ) )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B3 ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) ) ) ) )).

% SigmaI
thf(fact_66_infinite__cartesian__product,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ~ ( finite_finite2 @ A @ A2 )
     => ( ~ ( finite_finite2 @ B @ B2 )
       => ~ ( finite_finite2 @ ( product_prod @ A @ B )
            @ ( product_Sigma @ A @ B @ A2
              @ ^ [Uu: A] : B2 ) ) ) ) )).

% infinite_cartesian_product
thf(fact_67_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A5: A,A7: A] :
      ( ( ( sum_Inl @ A @ B @ A5 )
        = ( sum_Inl @ A @ B @ A7 ) )
      = ( A5 = A7 ) ) )).

% old.sum.inject(1)
thf(fact_68_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X13: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X13 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X13 = Y1 ) ) )).

% sum.inject(1)
thf(fact_69_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B3: B,B5: B] :
      ( ( ( sum_Inr @ B @ A @ B3 )
        = ( sum_Inr @ B @ A @ B5 ) )
      = ( B3 = B5 ) ) )).

% old.sum.inject(2)
thf(fact_70_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X22: B,Y22: B] :
      ( ( ( sum_Inr @ B @ A @ X22 )
        = ( sum_Inr @ B @ A @ Y22 ) )
      = ( X22 = Y22 ) ) )).

% sum.inject(2)
thf(fact_71_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A5: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A5 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A5 @ B3 ) ) ) )).

% sup.right_idem
thf(fact_72_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_73_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A5: A,B3: A] :
          ( ( sup_sup @ A @ A5 @ ( sup_sup @ A @ A5 @ B3 ) )
          = ( sup_sup @ A @ A5 @ B3 ) ) ) )).

% sup.left_idem
thf(fact_74_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A5: A,B3: B,A7: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A5 @ B3 )
        = ( product_Pair @ A @ B @ A7 @ B5 ) )
      = ( ( A5 = A7 )
        & ( B3 = B5 ) ) ) )).

% old.prod.inject
thf(fact_75_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X13: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X13 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X13 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_76_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G3: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F4 @ X2 ) @ ( G3 @ X2 ) ) ) ) ) )).

% sup_apply
thf(fact_77_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A5: A] :
          ( ( sup_sup @ A @ A5 @ A5 )
          = A5 ) ) )).

% sup.idem
thf(fact_78_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_79_sup__set__def,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B4: ( set @ A )] :
            ( collect @ A
            @ ( sup_sup @ ( A > $o )
              @ ^ [X2: A] :
                  ( member @ A @ X2 @ A4 )
              @ ^ [X2: A] :
                  ( member @ A @ X2 @ B4 ) ) ) ) ) )).

% sup_set_def
thf(fact_80_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A3: A,B6: B] :
          ( P @ ( product_Pair @ A @ B @ A3 @ B6 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_81_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A3: A,B6: B] :
            ( Y
           != ( product_Pair @ A @ B @ A3 @ B6 ) ) ) )).

% old.prod.exhaust
thf(fact_82_prod__induct7,axiom,(
    ! [G4: $tType,F5: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) ) )] :
      ( ! [A3: A,B6: B,C4: C,D2: D,E2: E,F3: F5,G5: G4] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F5 @ G4 ) @ E2 @ ( product_Pair @ F5 @ G4 @ F3 @ G5 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_83_prod__induct6,axiom,(
    ! [F5: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) ) )] :
      ( ! [A3: A,B6: B,C4: C,D2: D,E2: E,F3: F5] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F5 ) @ D2 @ ( product_Pair @ E @ F5 @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_84_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A3: A,B6: B,C4: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_85_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A3: A,B6: B,C4: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_86_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A3: A,B6: B,C4: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A3 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_87_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F5: $tType,G4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) ) )] :
      ~ ( ! [A3: A,B6: B,C4: C,D2: D,E2: E,F3: F5,G5: G4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F5 @ G4 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F5 @ G4 ) @ E2 @ ( product_Pair @ F5 @ G4 @ F3 @ G5 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_88_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F5: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) ) )] :
      ~ ( ! [A3: A,B6: B,C4: C,D2: D,E2: E,F3: F5] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F5 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F5 ) @ D2 @ ( product_Pair @ E @ F5 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_89_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A3: A,B6: B,C4: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_90_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A3: A,B6: B,C4: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_91_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A3: A,B6: B,C4: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A3 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) ) ) )).

% prod_cases3
thf(fact_92_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A5: A,B3: B,A7: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A5 @ B3 )
        = ( product_Pair @ A @ B @ A7 @ B5 ) )
     => ~ ( ( A5 = A7 )
         => ( B3 != B5 ) ) ) )).

% Pair_inject
thf(fact_93_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A3: A,B6: B] :
          ( P @ ( product_Pair @ A @ B @ A3 @ B6 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_94_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y4: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y4 ) ) )).

% surj_pair
thf(fact_95_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_96_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_97_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_98_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y3: A] :
              ( sup_sup @ A @ Y3 @ X2 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_99_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G3: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F4 @ X2 ) @ ( G3 @ X2 ) ) ) ) ) )).

% sup_fun_def
thf(fact_100_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A5: A,B3: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A5 @ B3 ) @ C2 )
          = ( sup_sup @ A @ A5 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.assoc
thf(fact_101_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% sup_assoc
thf(fact_102_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A6: A,B7: A] :
              ( sup_sup @ A @ B7 @ A6 ) ) ) ) )).

% sup.commute
thf(fact_103_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y3: A] :
              ( sup_sup @ A @ Y3 @ X2 ) ) ) ) )).

% sup_commute
thf(fact_104_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A5: A,C2: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A5 @ C2 ) )
          = ( sup_sup @ A @ A5 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.left_commute
thf(fact_105_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_left_commute
thf(fact_106_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_107_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_108_Sigma__cong,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( A > ( set @ B ) ),D3: ( A > ( set @ B ) )] :
      ( ( A2 = B2 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ B2 )
           => ( ( C3 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( product_Sigma @ A @ B @ A2 @ C3 )
          = ( product_Sigma @ A @ B @ B2 @ D3 ) ) ) ) )).

% Sigma_cong
thf(fact_109_Times__eq__cancel2,axiom,(
    ! [A: $tType,B: $tType,X: A,C3: ( set @ A ),A2: ( set @ B ),B2: ( set @ B )] :
      ( ( member @ A @ X @ C3 )
     => ( ( ( product_Sigma @ B @ A @ A2
            @ ^ [Uu: B] : C3 )
          = ( product_Sigma @ B @ A @ B2
            @ ^ [Uu: B] : C3 ) )
        = ( A2 = B2 ) ) ) )).

% Times_eq_cancel2
thf(fact_110_SigmaE,axiom,(
    ! [A: $tType,B: $tType,C2: ( product_prod @ A @ B ),A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( product_Sigma @ A @ B @ A2 @ B2 ) )
     => ~ ( ! [X3: A] :
              ( ( member @ A @ X3 @ A2 )
             => ! [Y4: B] :
                  ( ( member @ B @ Y4 @ ( B2 @ X3 ) )
                 => ( C2
                   != ( product_Pair @ A @ B @ X3 @ Y4 ) ) ) ) ) ) )).

% SigmaE
thf(fact_111_SigmaD1,axiom,(
    ! [B: $tType,A: $tType,A5: A,B3: B,A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B3 ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) )
     => ( member @ A @ A5 @ A2 ) ) )).

% SigmaD1
thf(fact_112_SigmaD2,axiom,(
    ! [B: $tType,A: $tType,A5: A,B3: B,A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B3 ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) )
     => ( member @ B @ B3 @ ( B2 @ A5 ) ) ) )).

% SigmaD2
thf(fact_113_SigmaE2,axiom,(
    ! [B: $tType,A: $tType,A5: A,B3: B,A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B3 ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) )
     => ~ ( ( member @ A @ A5 @ A2 )
         => ~ ( member @ B @ B3 @ ( B2 @ A5 ) ) ) ) )).

% SigmaE2
thf(fact_114_Sigma__Un__distrib1,axiom,(
    ! [B: $tType,A: $tType,I: ( set @ A ),J: ( set @ A ),C3: ( A > ( set @ B ) )] :
      ( ( product_Sigma @ A @ B @ ( sup_sup @ ( set @ A ) @ I @ J ) @ C3 )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ C3 ) @ ( product_Sigma @ A @ B @ J @ C3 ) ) ) )).

% Sigma_Un_distrib1
thf(fact_115_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X13: A,X22: B] :
      ( ( sum_Inl @ A @ B @ X13 )
     != ( sum_Inr @ B @ A @ X22 ) ) )).

% sum.distinct(1)
thf(fact_116_old_Osum_Odistinct_I2_J,axiom,(
    ! [B8: $tType,A8: $tType,B9: B8,A9: A8] :
      ( ( sum_Inr @ B8 @ A8 @ B9 )
     != ( sum_Inl @ A8 @ B8 @ A9 ) ) )).

% old.sum.distinct(2)
thf(fact_117_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A5: A,B5: B] :
      ( ( sum_Inl @ A @ B @ A5 )
     != ( sum_Inr @ B @ A @ B5 ) ) )).

% old.sum.distinct(1)
thf(fact_118_sumE,axiom,(
    ! [A: $tType,B: $tType,S2: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S2
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [Y4: B] :
              ( S2
             != ( sum_Inr @ B @ A @ Y4 ) ) ) ) )).

% sumE
thf(fact_119_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B3: B,A5: A] :
      ( ( sum_Inr @ B @ A @ B3 )
     != ( sum_Inl @ A @ B @ A5 ) ) )).

% Inr_not_Inl
thf(fact_120_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X5: ( sum_sum @ A @ B )] :
            ( P3 @ X5 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X2: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X2 ) )
            | ? [X2: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X2 ) ) ) ) ) )).

% split_sum_ex
thf(fact_121_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X5: ( sum_sum @ A @ B )] :
            ( P3 @ X5 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X2: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X2 ) )
            & ! [X2: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X2 ) ) ) ) ) )).

% split_sum_all
thf(fact_122_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A3: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A3 ) )
     => ~ ( ! [B6: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B6 ) ) ) ) )).

% old.sum.exhaust
thf(fact_123_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A3: A] :
          ( P @ ( sum_Inl @ A @ B @ A3 ) )
     => ( ! [B6: B] :
            ( P @ ( sum_Inr @ B @ A @ B6 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_124_Sigma__Un__distrib2,axiom,(
    ! [B: $tType,A: $tType,I: ( set @ A ),A2: ( A > ( set @ B ) ),B2: ( A > ( set @ B ) )] :
      ( ( product_Sigma @ A @ B @ I
        @ ^ [I2: A] :
            ( sup_sup @ ( set @ B ) @ ( A2 @ I2 ) @ ( B2 @ I2 ) ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ A2 ) @ ( product_Sigma @ A @ B @ I @ B2 ) ) ) )).

% Sigma_Un_distrib2
thf(fact_125_Times__Un__distrib1,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( sup_sup @ ( set @ A ) @ A2 @ B2 )
        @ ^ [Uu: A] : C3 )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : C3 )
        @ ( product_Sigma @ A @ B @ B2
          @ ^ [Uu: A] : C3 ) ) ) )).

% Times_Un_distrib1
thf(fact_126_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A5: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A5 @ B3 ) )
      = ( F1 @ A5 @ B3 ) ) )).

% old.prod.rec
thf(fact_127_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A5: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A5 ) )
      = ( F1 @ A5 ) ) )).

% old.sum.simps(7)
thf(fact_128_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B3: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B3 ) )
      = ( F22 @ B3 ) ) )).

% old.sum.simps(8)
thf(fact_129_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S2: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S2
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [X3: B] :
              ( S2
             != ( sum_Inr @ B @ A @ X3 ) ) ) ) )).

% obj_sumE
thf(fact_130_Product__Type_Oproduct__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_product @ A @ B )
      = ( ^ [A4: ( set @ A ),B4: ( set @ B )] :
            ( product_Sigma @ A @ B @ A4
            @ ^ [Uu: A] : B4 ) ) ) )).

% Product_Type.product_def
thf(fact_131_member__product,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B ),A2: ( set @ A ),B2: ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ X @ ( product_product @ A @ B @ A2 @ B2 ) )
      = ( member @ ( product_prod @ A @ B ) @ X
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : B2 ) ) ) )).

% member_product
thf(fact_132_sup1CI,axiom,(
    ! [A: $tType,B2: ( A > $o ),X: A,A2: ( A > $o )] :
      ( ( ~ ( B2 @ X )
       => ( A2 @ X ) )
     => ( sup_sup @ ( A > $o ) @ A2 @ B2 @ X ) ) )).

% sup1CI
thf(fact_133_sup1E,axiom,(
    ! [A: $tType,A2: ( A > $o ),B2: ( A > $o ),X: A] :
      ( ( sup_sup @ ( A > $o ) @ A2 @ B2 @ X )
     => ( ~ ( A2 @ X )
       => ( B2 @ X ) ) ) )).

% sup1E
thf(fact_134_sup1I1,axiom,(
    ! [A: $tType,A2: ( A > $o ),X: A,B2: ( A > $o )] :
      ( ( A2 @ X )
     => ( sup_sup @ ( A > $o ) @ A2 @ B2 @ X ) ) )).

% sup1I1
thf(fact_135_sup1I2,axiom,(
    ! [A: $tType,B2: ( A > $o ),X: A,A2: ( A > $o )] :
      ( ( B2 @ X )
     => ( sup_sup @ ( A > $o ) @ A2 @ B2 @ X ) ) )).

% sup1I2
thf(fact_136_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( X != Y )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_137_sup__Un__eq,axiom,(
    ! [A: $tType,R: ( set @ A ),S: ( set @ A )] :
      ( ( sup_sup @ ( A > $o )
        @ ^ [X2: A] :
            ( member @ A @ X2 @ R )
        @ ^ [X2: A] :
            ( member @ A @ X2 @ S ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ R @ S ) ) ) ) )).

% sup_Un_eq
thf(fact_138_sup__Un__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X2: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ R )
        @ ^ [X2: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ S ) )
      = ( ^ [X2: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ) ) )).

% sup_Un_eq2
thf(fact_139_Plus__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B )
      = ( ^ [A4: ( set @ A ),B4: ( set @ B )] :
            ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A4 ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B4 ) ) ) ) )).

% Plus_def
thf(fact_140_Sup_OSUP__identity__eq,axiom,(
    ! [A: $tType,Sup: ( ( set @ A ) > A ),A2: ( set @ A )] :
      ( ( Sup
        @ ( image @ A @ A
          @ ^ [X2: A] : X2
          @ A2 ) )
      = ( Sup @ A2 ) ) )).

% Sup.SUP_identity_eq
thf(fact_141_sup2CI,axiom,(
    ! [A: $tType,B: $tType,B2: ( A > B > $o ),X: A,Y: B,A2: ( A > B > $o )] :
      ( ( ~ ( B2 @ X @ Y )
       => ( A2 @ X @ Y ) )
     => ( sup_sup @ ( A > B > $o ) @ A2 @ B2 @ X @ Y ) ) )).

% sup2CI
thf(fact_142_InrI,axiom,(
    ! [B: $tType,A: $tType,B3: A,B2: ( set @ A ),A2: ( set @ B )] :
      ( ( member @ A @ B3 @ B2 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B3 ) @ ( sum_Plus @ B @ A @ A2 @ B2 ) ) ) )).

% InrI
thf(fact_143_InlI,axiom,(
    ! [A: $tType,B: $tType,A5: A,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( member @ A @ A5 @ A2 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A5 ) @ ( sum_Plus @ A @ B @ A2 @ B2 ) ) ) )).

% InlI
thf(fact_144_finite__Plus__iff,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A2 @ B2 ) )
      = ( ( finite_finite2 @ A @ A2 )
        & ( finite_finite2 @ B @ B2 ) ) ) )).

% finite_Plus_iff
thf(fact_145_sup2E,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o ),B2: ( A > B > $o ),X: A,Y: B] :
      ( ( sup_sup @ ( A > B > $o ) @ A2 @ B2 @ X @ Y )
     => ( ~ ( A2 @ X @ Y )
       => ( B2 @ X @ Y ) ) ) )).

% sup2E
thf(fact_146_sup2I1,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o ),X: A,Y: B,B2: ( A > B > $o )] :
      ( ( A2 @ X @ Y )
     => ( sup_sup @ ( A > B > $o ) @ A2 @ B2 @ X @ Y ) ) )).

% sup2I1
thf(fact_147_sup2I2,axiom,(
    ! [A: $tType,B: $tType,B2: ( A > B > $o ),X: A,Y: B,A2: ( A > B > $o )] :
      ( ( B2 @ X @ Y )
     => ( sup_sup @ ( A > B > $o ) @ A2 @ B2 @ X @ Y ) ) )).

% sup2I2
thf(fact_148_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A2: ( set @ A ),B2: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A2 @ B2 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A2 )
           => ( U
             != ( sum_Inl @ A @ B @ X3 ) ) )
       => ~ ( ! [Y4: B] :
                ( ( member @ B @ Y4 @ B2 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y4 ) ) ) ) ) ) )).

% PlusE
thf(fact_149_finite__PlusD_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A2 @ B2 ) )
     => ( finite_finite2 @ B @ B2 ) ) )).

% finite_PlusD(2)
thf(fact_150_finite__PlusD_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A2 @ B2 ) )
     => ( finite_finite2 @ A @ A2 ) ) )).

% finite_PlusD(1)
thf(fact_151_finite__Plus,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ( finite_finite2 @ B @ B2 )
       => ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A2 @ B2 ) ) ) ) )).

% finite_Plus
thf(fact_152_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ B ),B2: ( set @ B ),C3: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A2 = B2 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B2 )
           => ( ( C3 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C3 @ A2 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B2 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_153_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ B ),B2: ( set @ B ),C3: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A2 = B2 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B2 )
           => ( ( C3 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C3 @ A2 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B2 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_154_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X2: A,Y3: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ R ) )
        = ( ^ [X2: A,Y3: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ S ) ) )
      = ( R = S ) ) )).

% pred_equals_eq2
thf(fact_155_Inf_OINF__identity__eq,axiom,(
    ! [A: $tType,Inf: ( ( set @ A ) > A ),A2: ( set @ A )] :
      ( ( Inf
        @ ( image @ A @ A
          @ ^ [X2: A] : X2
          @ A2 ) )
      = ( Inf @ A2 ) ) )).

% Inf.INF_identity_eq
thf(fact_156_reflclp__idemp,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ( sup_sup @ ( A > A > $o ) @ P
          @ ^ [Y5: A,Z2: A] : ( Y5 = Z2 ) )
        @ ^ [Y5: A,Z2: A] : ( Y5 = Z2 ) )
      = ( sup_sup @ ( A > A > $o ) @ P
        @ ^ [Y5: A,Z2: A] : ( Y5 = Z2 ) ) ) )).

% reflclp_idemp
thf(fact_157_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A5: B,B3: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A5 @ B3 ) )
      = ( C2 @ A5 @ B3 ) ) )).

% internal_case_prod_conv
thf(fact_158_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_159_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X ) )
      = ( F @ X ) ) )).

% Suml.simps
thf(fact_160_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G2: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G2 ) )
     => ( F = G2 ) ) )).

% Suml_inject
thf(fact_161_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N2: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N2 @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_162_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N2: n,N3: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N2 @ As )
            = ( node @ N3 @ As2 ) )
          = ( ( N2 = N3 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_163_reflcl__set__eq,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ^ [X2: A,Y3: A] :
            ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R2 )
        @ ^ [Y5: A,Z2: A] : ( Y5 = Z2 ) )
      = ( ^ [X2: A,Y3: A] :
            ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ ( id @ A ) ) ) ) ) )).

% reflcl_set_eq
thf(fact_164_IdI,axiom,(
    ! [A: $tType,A5: A] :
      ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A5 ) @ ( id @ A ) ) )).

% IdI
thf(fact_165_pair__in__Id__conv,axiom,(
    ! [A: $tType,A5: A,B3: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B3 ) @ ( id @ A ) )
      = ( A5 = B3 ) ) )).

% pair_in_Id_conv
thf(fact_166_IdD,axiom,(
    ! [A: $tType,A5: A,B3: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B3 ) @ ( id @ A ) )
     => ( A5 = B3 ) ) )).

% IdD
thf(fact_167_IdE,axiom,(
    ! [A: $tType,P2: ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P2 @ ( id @ A ) )
     => ~ ( ! [X3: A] :
              ( P2
             != ( product_Pair @ A @ A @ X3 @ X3 ) ) ) ) )).

% IdE
thf(fact_168_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N4: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N4 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_169_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_170_antisym__reflcl,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ( antisym @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ ( id @ A ) ) )
      = ( antisym @ A @ R2 ) ) )).

% antisym_reflcl
thf(fact_171_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F @ ( sum_Inr @ B @ A @ X ) )
      = ( F @ X ) ) )).

% Sumr.simps
thf(fact_172_root__Node,axiom,(
    ! [N2: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N2 @ As ) )
      = N2 ) )).

% root_Node
thf(fact_173_antisym__Id,axiom,(
    ! [A: $tType] :
      ( antisym @ A @ ( id @ A ) ) )).

% antisym_Id
thf(fact_174_antisym__def,axiom,(
    ! [A: $tType] :
      ( ( antisym @ A )
      = ( ^ [R3: ( set @ ( product_prod @ A @ A ) )] :
          ! [X2: A,Y3: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y3 ) @ R3 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X2 ) @ R3 )
             => ( X2 = Y3 ) ) ) ) ) )).

% antisym_def
thf(fact_175_antisymI,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ! [X3: A,Y4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R2 )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ X3 ) @ R2 )
           => ( X3 = Y4 ) ) )
     => ( antisym @ A @ R2 ) ) )).

% antisymI
thf(fact_176_antisymD,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),A5: A,B3: A] :
      ( ( antisym @ A @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B3 ) @ R2 )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B3 @ A5 ) @ R2 )
         => ( A5 = B3 ) ) ) ) )).

% antisymD
thf(fact_177_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),G2: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F )
        = ( sum_Sumr @ B @ C @ A @ G2 ) )
     => ( F = G2 ) ) )).

% Sumr_inject
thf(fact_178_dtree__cong,axiom,(
    ! [Tr: dtree,Tr3: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr3 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr3 ) )
       => ( Tr = Tr3 ) ) ) )).

% dtree_cong
thf(fact_179_finite__cartesian__product__iff,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : B2 ) )
      = ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ( B2
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( finite_finite2 @ A @ A2 )
          & ( finite_finite2 @ B @ B2 ) ) ) ) )).

% finite_cartesian_product_iff
thf(fact_180_finite__cartesian__productD2,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : B2 ) )
     => ( ( A2
         != ( bot_bot @ ( set @ A ) ) )
       => ( finite_finite2 @ B @ B2 ) ) ) )).

% finite_cartesian_productD2
thf(fact_181_finite__cartesian__productD1,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( finite_finite2 @ ( product_prod @ A @ B )
        @ ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : B2 ) )
     => ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( finite_finite2 @ A @ A2 ) ) ) )).

% finite_cartesian_productD1
thf(fact_182_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_183_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X2: A] :
            ~ ( member @ A @ X2 @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_184_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) )).

% Collect_empty_eq
thf(fact_185_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) )).

% empty_Collect_eq
thf(fact_186_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_187_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_188_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_189_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_190_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_191_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A5: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A5 )
          = A5 ) ) )).

% sup_bot.left_neutral
thf(fact_192_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A5: A] :
          ( ( sup_sup @ A @ A5 @ ( bot_bot @ A ) )
          = A5 ) ) )).

% sup_bot.right_neutral
thf(fact_193_Un__empty,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A2 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        & ( B2
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_194_Sigma__empty1,axiom,(
    ! [B: $tType,A: $tType,B2: ( A > ( set @ B ) )] :
      ( ( product_Sigma @ A @ B @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% Sigma_empty1
thf(fact_195_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_196_Plus__eq__empty__conv,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( ( sum_Plus @ A @ B @ A2 @ B2 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        & ( B2
          = ( bot_bot @ ( set @ B ) ) ) ) ) )).

% Plus_eq_empty_conv
thf(fact_197_Sigma__empty2,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A )] :
      ( ( product_Sigma @ A @ B @ A2
        @ ^ [Uu: A] :
            ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% Sigma_empty2
thf(fact_198_Times__empty,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B )] :
      ( ( ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : B2 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( A2
          = ( bot_bot @ ( set @ A ) ) )
        | ( B2
          = ( bot_bot @ ( set @ B ) ) ) ) ) )).

% Times_empty
thf(fact_199_antisym__empty,axiom,(
    ! [A: $tType] :
      ( antisym @ A @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) )).

% antisym_empty
thf(fact_200_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_201_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_202_times__eq__iff,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),B2: ( set @ B ),C3: ( set @ A ),D3: ( set @ B )] :
      ( ( ( product_Sigma @ A @ B @ A2
          @ ^ [Uu: A] : B2 )
        = ( product_Sigma @ A @ B @ C3
          @ ^ [Uu: A] : D3 ) )
      = ( ( ( A2 = C3 )
          & ( B2 = D3 ) )
        | ( ( ( A2
              = ( bot_bot @ ( set @ A ) ) )
            | ( B2
              = ( bot_bot @ ( set @ B ) ) ) )
          & ( ( C3
              = ( bot_bot @ ( set @ A ) ) )
            | ( D3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )).

% times_eq_iff
thf(fact_203_emptyE,axiom,(
    ! [A: $tType,A5: A] :
      ~ ( member @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_204_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A5: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A5 @ A2 ) ) )).

% equals0D
thf(fact_205_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y4: A] :
          ~ ( member @ A @ Y4 @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_206_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X2: A] :
            ( member @ A @ X2 @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_207_empty__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X2: A] : $false ) ) )).

% empty_def
thf(fact_208_Sigma__empty__iff,axiom,(
    ! [B: $tType,A: $tType,I: ( set @ A ),X6: ( A > ( set @ B ) )] :
      ( ( ( product_Sigma @ A @ B @ I @ X6 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ I )
           => ( ( X6 @ X2 )
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) )).

% Sigma_empty_iff
thf(fact_209_Un__empty__left,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = B2 ) )).

% Un_empty_left
thf(fact_210_Un__empty__right,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = A2 ) )).

% Un_empty_right
thf(fact_211_sup__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) )).

% sup_bot_left
thf(fact_212_sup__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) )).

% sup_bot_right
thf(fact_213_Pair__vimage__Sigma,axiom,(
    ! [B: $tType,A: $tType,X: B,A2: ( set @ B ),F: ( B > ( set @ A ) )] :
      ( ( ( member @ B @ X @ A2 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X ) @ ( product_Sigma @ B @ A @ A2 @ F ) )
          = ( F @ X ) ) )
      & ( ~ ( member @ B @ X @ A2 )
       => ( ( vimage @ A @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X ) @ ( product_Sigma @ B @ A @ A2 @ F ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Pair_vimage_Sigma
thf(fact_214_finite__SigmaI2,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( A > ( set @ B ) )] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X2: A] :
              ( ( member @ A @ X2 @ A2 )
              & ( ( B2 @ X2 )
               != ( bot_bot @ ( set @ B ) ) ) ) ) )
     => ( ! [A3: A] :
            ( ( member @ A @ A3 @ A2 )
           => ( finite_finite2 @ B @ ( B2 @ A3 ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( product_Sigma @ A @ B @ A2 @ B2 ) ) ) ) )).

% finite_SigmaI2
thf(fact_215_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A4: ( set @ A )] :
            ( A4
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_216_fst__image__times,axiom,(
    ! [B: $tType,A: $tType,B2: ( set @ B ),A2: ( set @ A )] :
      ( ( ( B2
          = ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
            @ ( product_Sigma @ A @ B @ A2
              @ ^ [Uu: A] : B2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( B2
         != ( bot_bot @ ( set @ B ) ) )
       => ( ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B )
            @ ( product_Sigma @ A @ B @ A2
              @ ^ [Uu: A] : B2 ) )
          = A2 ) ) ) )).

% fst_image_times
thf(fact_217_inf__img__fin__dom,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F @ A2 ) )
     => ( ~ ( finite_finite2 @ B @ A2 )
       => ? [X3: A] :
            ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A2 ) )
            & ~ ( finite_finite2 @ B @ ( vimage @ B @ A @ F @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) )).

% inf_img_fin_dom
thf(fact_218_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A2: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A2 ) )
      = ( insert @ A @ X @ A2 ) ) )).

% insert_absorb2
thf(fact_219_insert__iff,axiom,(
    ! [A: $tType,A5: A,B3: A,A2: ( set @ A )] :
      ( ( member @ A @ A5 @ ( insert @ A @ B3 @ A2 ) )
      = ( ( A5 = B3 )
        | ( member @ A @ A5 @ A2 ) ) ) )).

% insert_iff
thf(fact_220_insertCI,axiom,(
    ! [A: $tType,A5: A,B2: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A5 @ B2 )
       => ( A5 = B3 ) )
     => ( member @ A @ A5 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertCI
thf(fact_221_insert__image,axiom,(
    ! [B: $tType,A: $tType,X: A,A2: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A2 )
     => ( ( insert @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A2 ) )
        = ( image @ A @ B @ F @ A2 ) ) ) )).

% insert_image
thf(fact_222_image__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A5: B,B2: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( insert @ B @ A5 @ B2 ) )
      = ( insert @ A @ ( F @ A5 ) @ ( image @ B @ A @ F @ B2 ) ) ) )).

% image_insert
thf(fact_223_singletonI,axiom,(
    ! [A: $tType,A5: A] :
      ( member @ A @ A5 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_224_finite__insert,axiom,(
    ! [A: $tType,A5: A,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( insert @ A @ A5 @ A2 ) )
      = ( finite_finite2 @ A @ A2 ) ) )).

% finite_insert
thf(fact_225_Un__insert__right,axiom,(
    ! [A: $tType,A2: ( set @ A ),A5: A,B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( insert @ A @ A5 @ B2 ) )
      = ( insert @ A @ A5 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% Un_insert_right
thf(fact_226_Un__insert__left,axiom,(
    ! [A: $tType,A5: A,B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ A5 @ B2 ) @ C3 )
      = ( insert @ A @ A5 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_insert_left
thf(fact_227_singleton__conv,axiom,(
    ! [A: $tType,A5: A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( X2 = A5 ) )
      = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv
thf(fact_228_singleton__conv2,axiom,(
    ! [A: $tType,A5: A] :
      ( ( collect @ A
        @ ( ^ [Y5: A,Z2: A] : ( Y5 = Z2 )
          @ A5 ) )
      = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singleton_conv2
thf(fact_229_insert__times__insert,axiom,(
    ! [B: $tType,A: $tType,A5: A,A2: ( set @ A ),B3: B,B2: ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( insert @ A @ A5 @ A2 )
        @ ^ [Uu: A] :
            ( insert @ B @ B3 @ B2 ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B3 )
        @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
          @ ( product_Sigma @ A @ B @ A2
            @ ^ [Uu: A] :
                ( insert @ B @ B3 @ B2 ) )
          @ ( product_Sigma @ A @ B @ ( insert @ A @ A5 @ A2 )
            @ ^ [Uu: A] : B2 ) ) ) ) )).

% insert_times_insert
thf(fact_230_infinite__finite__induct,axiom,(
    ! [A: $tType,P: ( ( set @ A ) > $o ),A2: ( set @ A )] :
      ( ! [A10: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A10 )
         => ( P @ A10 ) )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X3 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X3 @ F6 ) ) ) ) )
         => ( P @ A2 ) ) ) ) )).

% infinite_finite_induct
thf(fact_231_finite__ne__induct,axiom,(
    ! [A: $tType,F2: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F2 )
     => ( ( F2
         != ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A] :
              ( P @ ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) )
         => ( ! [X3: A,F6: ( set @ A )] :
                ( ( finite_finite2 @ A @ F6 )
               => ( ( F6
                   != ( bot_bot @ ( set @ A ) ) )
                 => ( ~ ( member @ A @ X3 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ X3 @ F6 ) ) ) ) ) )
           => ( P @ F2 ) ) ) ) ) )).

% finite_ne_induct
thf(fact_232_finite_Oinducts,axiom,(
    ! [A: $tType,X: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ X )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A10: ( set @ A ),A3: A] :
              ( ( finite_finite2 @ A @ A10 )
             => ( ( P @ A10 )
               => ( P @ ( insert @ A @ A3 @ A10 ) ) ) )
         => ( P @ X ) ) ) ) )).

% finite.inducts
thf(fact_233_finite__induct,axiom,(
    ! [A: $tType,F2: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ F2 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [X3: A,F6: ( set @ A )] :
              ( ( finite_finite2 @ A @ F6 )
             => ( ~ ( member @ A @ X3 @ F6 )
               => ( ( P @ F6 )
                 => ( P @ ( insert @ A @ X3 @ F6 ) ) ) ) )
         => ( P @ F2 ) ) ) ) )).

% finite_induct
thf(fact_234_finite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ A )
      = ( ^ [A6: ( set @ A )] :
            ( ( A6
              = ( bot_bot @ ( set @ A ) ) )
            | ? [A4: ( set @ A ),B7: A] :
                ( ( A6
                  = ( insert @ A @ B7 @ A4 ) )
                & ( finite_finite2 @ A @ A4 ) ) ) ) ) )).

% finite.simps
thf(fact_235_finite_Ocases,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( finite_finite2 @ A @ A5 )
     => ( ( A5
         != ( bot_bot @ ( set @ A ) ) )
       => ~ ( ! [A10: ( set @ A )] :
                ( ? [A3: A] :
                    ( A5
                    = ( insert @ A @ A3 @ A10 ) )
               => ~ ( finite_finite2 @ A @ A10 ) ) ) ) ) )).

% finite.cases
thf(fact_236_singletonD,axiom,(
    ! [A: $tType,B3: A,A5: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B3 = A5 ) ) )).

% singletonD
thf(fact_237_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_238_singleton__iff,axiom,(
    ! [A: $tType,B3: A,A5: A] :
      ( ( member @ A @ B3 @ ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B3 = A5 ) ) )).

% singleton_iff
thf(fact_239_Collect__conv__if,axiom,(
    ! [A: $tType,P: ( A > $o ),A5: A] :
      ( ( ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( X2 = A5 )
                & ( P @ X2 ) ) )
          = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( X2 = A5 )
                & ( P @ X2 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if
thf(fact_240_Collect__conv__if2,axiom,(
    ! [A: $tType,P: ( A > $o ),A5: A] :
      ( ( ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( A5 = X2 )
                & ( P @ X2 ) ) )
          = ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) ) ) )
      & ( ~ ( P @ A5 )
       => ( ( collect @ A
            @ ^ [X2: A] :
                ( ( A5 = X2 )
                & ( P @ X2 ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Collect_conv_if2
thf(fact_241_doubleton__eq__iff,axiom,(
    ! [A: $tType,A5: A,B3: A,C2: A,D4: A] :
      ( ( ( insert @ A @ A5 @ ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A5 = C2 )
          & ( B3 = D4 ) )
        | ( ( A5 = D4 )
          & ( B3 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_242_insert__not__empty,axiom,(
    ! [A: $tType,A5: A,A2: ( set @ A )] :
      ( ( insert @ A @ A5 @ A2 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_243_singleton__inject,axiom,(
    ! [A: $tType,A5: A,B3: A] :
      ( ( ( insert @ A @ A5 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A5 = B3 ) ) )).

% singleton_inject
thf(fact_244_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_245_insert__is__Un,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A6: A] :
            ( sup_sup @ ( set @ A ) @ ( insert @ A @ A6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% insert_is_Un
thf(fact_246_Un__singleton__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ( sup_sup @ ( set @ A ) @ A2 @ B2 )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( ( A2
            = ( bot_bot @ ( set @ A ) ) )
          & ( B2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% Un_singleton_iff
thf(fact_247_singleton__Un__iff,axiom,(
    ! [A: $tType,X: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) )
        = ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
      = ( ( ( A2
            = ( bot_bot @ ( set @ A ) ) )
          & ( B2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B2
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% singleton_Un_iff
thf(fact_248_bot__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X2: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y3 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% bot_empty_eq2
thf(fact_249_insert__def,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A6: A] :
            ( sup_sup @ ( set @ A )
            @ ( collect @ A
              @ ^ [X2: A] : ( X2 = A6 ) ) ) ) ) )).

% insert_def
thf(fact_250_insert__Collect,axiom,(
    ! [A: $tType,A5: A,P: ( A > $o )] :
      ( ( insert @ A @ A5 @ ( collect @ A @ P ) )
      = ( collect @ A
        @ ^ [U2: A] :
            ( ( U2 != A5 )
           => ( P @ U2 ) ) ) ) )).

% insert_Collect
thf(fact_251_insert__compr,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A6: A,B4: ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( X2 = A6 )
                | ( member @ A @ X2 @ B4 ) ) ) ) ) )).

% insert_compr
thf(fact_252_mk__disjoint__insert,axiom,(
    ! [A: $tType,A5: A,A2: ( set @ A )] :
      ( ( member @ A @ A5 @ A2 )
     => ? [B10: ( set @ A )] :
          ( ( A2
            = ( insert @ A @ A5 @ B10 ) )
          & ~ ( member @ A @ A5 @ B10 ) ) ) )).

% mk_disjoint_insert
thf(fact_253_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A2: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A2 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A2 ) ) ) )).

% insert_commute
thf(fact_254_insert__eq__iff,axiom,(
    ! [A: $tType,A5: A,A2: ( set @ A ),B3: A,B2: ( set @ A )] :
      ( ~ ( member @ A @ A5 @ A2 )
     => ( ~ ( member @ A @ B3 @ B2 )
       => ( ( ( insert @ A @ A5 @ A2 )
            = ( insert @ A @ B3 @ B2 ) )
          = ( ( ( A5 = B3 )
             => ( A2 = B2 ) )
            & ( ( A5 != B3 )
             => ? [C5: ( set @ A )] :
                  ( ( A2
                    = ( insert @ A @ B3 @ C5 ) )
                  & ~ ( member @ A @ B3 @ C5 )
                  & ( B2
                    = ( insert @ A @ A5 @ C5 ) )
                  & ~ ( member @ A @ A5 @ C5 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_255_insert__absorb,axiom,(
    ! [A: $tType,A5: A,A2: ( set @ A )] :
      ( ( member @ A @ A5 @ A2 )
     => ( ( insert @ A @ A5 @ A2 )
        = A2 ) ) )).

% insert_absorb

%----Type constructors (20)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( bounded_lattice @ A11 @ ( type2 @ A11 ) )
     => ( bounded_lattice @ ( A8 > A11 ) @ ( type2 @ ( A8 > A11 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( bounded_lattice @ A11 @ ( type2 @ A11 ) )
     => ( bounde1808546759up_bot @ ( A8 > A11 ) @ ( type2 @ ( A8 > A11 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( bounded_lattice @ A11 @ ( type2 @ A11 ) )
     => ( bounded_lattice_bot @ ( A8 > A11 ) @ ( type2 @ ( A8 > A11 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( semilattice_sup @ A11 @ ( type2 @ A11 ) )
     => ( semilattice_sup @ ( A8 > A11 ) @ ( type2 @ ( A8 > A11 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A11 @ ( type2 @ A11 ) ) )
     => ( finite_finite @ ( A8 > A11 ) @ ( type2 @ ( A8 > A11 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( lattice @ A11 @ ( type2 @ A11 ) )
     => ( lattice @ ( A8 > A11 ) @ ( type2 @ ( A8 > A11 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_3,axiom,(
    ! [A8: $tType] :
      ( bounde1808546759up_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_4,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_5,axiom,(
    ! [A8: $tType] :
      ( semilattice_sup @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_6,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_7,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_8,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_9,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_10,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_11,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_12,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_13,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A11 @ ( type2 @ A11 ) ) )
     => ( finite_finite @ ( sum_sum @ A8 @ A11 ) @ ( type2 @ ( sum_sum @ A8 @ A11 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_14,axiom,(
    ! [A8: $tType,A11: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A11 @ ( type2 @ A11 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A11 ) @ ( type2 @ ( product_prod @ A8 @ A11 ) ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( finite_finite2 @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) )
    @ ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ tr1 ) @ ( cont @ tr2 ) ) ) )
      @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
        @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ tr1 ) )
          @ ^ [Uu: dtree] :
              ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ tr2 ) ) ) ) ) )).

%------------------------------------------------------------------------------
