%------------------------------------------------------------------------------
% File     : COM203^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Parallel extension to grammars and languages 44
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : parallel__44.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  329 (   0 unit;  57 type;   0 defn)
%            Number of atoms       : 4533 ( 250 equality;2861 variable)
%            Maximal formula depth :   28 (  11 average)
%            Number of connectives : 4381 (  46   ~;   2   |;  27   &;4031   @)
%                                         (   0 <=>; 275  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  363 ( 363   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   60 (  57   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1272 (   2 sgn;1137   !;  18   ?;  44   ^)
%                                         (1272   :;  73  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:38:49.144
%------------------------------------------------------------------------------
%----Could-be-implicit typings (8)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (49)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,(
    bNF_Ca1785829860lChain: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) )).

thf(sy_c_BNF__Def_OfstOp,type,(
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > ( product_prod @ A @ C ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Def_Opick__middlep,type,(
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] :
        ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) )).

thf(sy_c_BNF__Def_OsndOp,type,(
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( C > A > $o ) > ( A > B > $o ) > ( product_prod @ C @ B ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Oinj__on,type,(
    inj_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_Fun_Oswap,type,(
    swap: 
      !>[A: $tType,B: $tType] :
        ( A > A > ( A > B ) > A > B ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_ONplus,type,(
    parall1518086719_Nplus: n > n > n )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar,type,(
    parall1899940088le_par: ( product_prod @ dtree @ dtree ) > dtree )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__c,type,(
    parall1914194347_par_c: ( product_prod @ dtree @ dtree ) > ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__r,type,(
    parall1914194362_par_r: ( product_prod @ dtree @ dtree ) > n )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__r__rel,type,(
    parall556292031_r_rel: ( product_prod @ dtree @ dtree ) > ( product_prod @ dtree @ dtree ) > $o )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Osnd,type,(
    product_snd: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > B ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Product__Type_Oscomp,type,(
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Oinv__image,type,(
    inv_image: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_OPow,type,(
    pow: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( set @ A ) ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_c_Wellfounded_Olex__prod,type,(
    lex_prod: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_tr1,type,(
    tr1: dtree )).

thf(sy_v_tr2,type,(
    tr2: dtree )).

%----Relevant facts (256)
thf(fact_0__092_060open_062root_A_Iunfold_Apar__r_Apar__c_A_Itr1_M_Atr2_J_J_A_061_Apar__r_A_Itr1_M_Atr2_J_092_060close_062,axiom,
    ( ( root @ ( unfold @ ( product_prod @ dtree @ dtree ) @ parall1914194362_par_r @ parall1914194347_par_c @ ( product_Pair @ dtree @ dtree @ tr1 @ tr2 ) ) )
    = ( parall1914194362_par_r @ ( product_Pair @ dtree @ dtree @ tr1 @ tr2 ) ) )).

% \<open>root (unfold par_r par_c (tr1, tr2)) = par_r (tr1, tr2)\<close>
thf(fact_1_Nplus__comm,axiom,
    ( parall1518086719_Nplus
    = ( ^ [A2: n,B2: n] :
          ( parall1518086719_Nplus @ B2 @ A2 ) ) )).

% Nplus_comm
thf(fact_2_Nplus__assoc,axiom,(
    ! [A3: n,B3: n,C2: n] :
      ( ( parall1518086719_Nplus @ ( parall1518086719_Nplus @ A3 @ B3 ) @ C2 )
      = ( parall1518086719_Nplus @ A3 @ ( parall1518086719_Nplus @ B3 @ C2 ) ) ) )).

% Nplus_assoc
thf(fact_3_par__r_Ocases,axiom,(
    ! [X: ( product_prod @ dtree @ dtree )] :
      ~ ( ! [Tr1: dtree,Tr2: dtree] :
            ( X
           != ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) )).

% par_r.cases
thf(fact_4_par__r_Oelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y: n] :
      ( ( ( parall1914194362_par_r @ X )
        = Y )
     => ~ ( ! [Tr1: dtree,Tr2: dtree] :
              ( ( X
                = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
             => ( Y
               != ( parall1518086719_Nplus @ ( root @ Tr1 ) @ ( root @ Tr2 ) ) ) ) ) ) )).

% par_r.elims
thf(fact_5_par__r_Osimps,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( parall1914194362_par_r @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) )
      = ( parall1518086719_Nplus @ ( root @ Tr12 ) @ ( root @ Tr22 ) ) ) )).

% par_r.simps
thf(fact_6_par__r_Oinduct,axiom,(
    ! [P: ( ( product_prod @ dtree @ dtree ) > $o ),A0: ( product_prod @ dtree @ dtree )] :
      ( ! [Tr1: dtree,Tr2: dtree] :
          ( P @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
     => ( P @ A0 ) ) )).

% par_r.induct
thf(fact_7_par__def,axiom,
    ( parall1899940088le_par
    = ( unfold @ ( product_prod @ dtree @ dtree ) @ parall1914194362_par_r @ parall1914194347_par_c ) )).

% par_def
thf(fact_8_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B3: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B3 ) )
      = ( Rt @ B3 ) ) )).

% unfold(1)
thf(fact_9_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X2 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% prod.inject
thf(fact_10_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A4: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A4 @ B4 ) )
      = ( ( A3 = A4 )
        & ( B3 = B4 ) ) ) )).

% old.prod.inject
thf(fact_11_par__r_Opelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y: n] :
      ( ( ( parall1914194362_par_r @ X )
        = Y )
     => ( ( accp @ ( product_prod @ dtree @ dtree ) @ parall556292031_r_rel @ X )
       => ~ ( ! [Tr1: dtree,Tr2: dtree] :
                ( ( X
                  = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
               => ( ( Y
                    = ( parall1518086719_Nplus @ ( root @ Tr1 ) @ ( root @ Tr2 ) ) )
                 => ~ ( accp @ ( product_prod @ dtree @ dtree ) @ parall556292031_r_rel @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) ) ) ) ) )).

% par_r.pelims
thf(fact_12_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y3: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y3 ) ) )).

% surj_pair
thf(fact_13_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A5: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_14_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A4: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ~ ( ( A3 = A4 )
         => ( B3 != B4 ) ) ) )).

% Pair_inject
thf(fact_15_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B5: B,C3: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_16_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_17_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_18_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F2: F] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F ) @ D2 @ ( product_Pair @ E @ F @ E2 @ F2 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_19_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_20_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B5: B] :
            ( Y
           != ( product_Pair @ A @ B @ A5 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_21_prod__induct7,axiom,(
    ! [G: $tType,F: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F2: F,G2: G] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F @ G ) @ E2 @ ( product_Pair @ F @ G @ F2 @ G2 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_22_prod__induct6,axiom,(
    ! [F: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F2: F] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F ) @ D2 @ ( product_Pair @ E @ F @ E2 @ F2 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_23_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_24_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_25_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B5: B,C3: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_26_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F: $tType,G: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F2: F,G2: G] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F @ G ) @ E2 @ ( product_Pair @ F @ G @ F2 @ G2 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_27_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A3: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( F1 @ A3 @ B3 ) ) )).

% old.prod.rec
thf(fact_28_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A3: B,B3: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A3 @ B3 ) )
      = ( C2 @ A3 @ B3 ) ) )).

% internal_case_prod_conv
thf(fact_29_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_30_accp_Ocases,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A3: A] :
      ( ( accp @ A @ R @ A3 )
     => ! [Y4: A] :
          ( ( R @ Y4 @ A3 )
         => ( accp @ A @ R @ Y4 ) ) ) )).

% accp.cases
thf(fact_31_accp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( accp @ A )
      = ( ^ [R2: ( A > A > $o ),A2: A] :
          ? [X4: A] :
            ( ( A2 = X4 )
            & ! [Y5: A] :
                ( ( R2 @ Y5 @ X4 )
               => ( accp @ A @ R2 @ Y5 ) ) ) ) ) )).

% accp.simps
thf(fact_32_accp_Ointros,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A] :
      ( ! [Y3: A] :
          ( ( R @ Y3 @ X )
         => ( accp @ A @ R @ Y3 ) )
     => ( accp @ A @ R @ X ) ) )).

% accp.intros
thf(fact_33_accp__induct,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A3: A,P: ( A > $o )] :
      ( ( accp @ A @ R @ A3 )
     => ( ! [X3: A] :
            ( ( accp @ A @ R @ X3 )
           => ( ! [Y4: A] :
                  ( ( R @ Y4 @ X3 )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) ) )
       => ( P @ A3 ) ) ) )).

% accp_induct
thf(fact_34_accp_Oinducts,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,P: ( A > $o )] :
      ( ( accp @ A @ R @ X )
     => ( ! [X3: A] :
            ( ! [Y4: A] :
                ( ( R @ Y4 @ X3 )
               => ( accp @ A @ R @ Y4 ) )
           => ( ! [Y4: A] :
                  ( ( R @ Y4 @ X3 )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) ) )
       => ( P @ X ) ) ) )).

% accp.inducts
thf(fact_35_accp__downward,axiom,(
    ! [A: $tType,R: ( A > A > $o ),B3: A,A3: A] :
      ( ( accp @ A @ R @ B3 )
     => ( ( R @ A3 @ B3 )
       => ( accp @ A @ R @ A3 ) ) ) )).

% accp_downward
thf(fact_36_not__accp__down,axiom,(
    ! [A: $tType,R3: ( A > A > $o ),X: A] :
      ( ~ ( accp @ A @ R3 @ X )
     => ~ ( ! [Z: A] :
              ( ( R3 @ Z @ X )
             => ( accp @ A @ R3 @ Z ) ) ) ) )).

% not_accp_down
thf(fact_37_accp__induct__rule,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A3: A,P: ( A > $o )] :
      ( ( accp @ A @ R @ A3 )
     => ( ! [X3: A] :
            ( ( accp @ A @ R @ X3 )
           => ( ! [Y4: A] :
                  ( ( R @ Y4 @ X3 )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) ) )
       => ( P @ A3 ) ) ) )).

% accp_induct_rule
thf(fact_38_in__lex__prod,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A4: A,B4: B,R: ( set @ ( product_prod @ A @ A ) ),S: ( set @ ( product_prod @ B @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B3 ) @ ( product_Pair @ A @ B @ A4 @ B4 ) ) @ ( lex_prod @ A @ B @ R @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A4 ) @ R )
        | ( ( A3 = A4 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B3 @ B4 ) @ S ) ) ) ) )).

% in_lex_prod
thf(fact_39_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_40_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B3: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B3 ) )
      = ( Rt @ B3 ) ) )).

% corec(1)
thf(fact_41_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R3: ( set @ ( product_prod @ A @ B ) ),S2: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R3 )
     => ( ( S2 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R3 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_42_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F3: ( ( product_prod @ B @ C ) > A ),A2: B,B2: C] :
            ( F3 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) )).

% curry_conv
thf(fact_43_finite__par__c,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( parall1914194347_par_c @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )).

% finite_par_c
thf(fact_44_curryI,axiom,(
    ! [A: $tType,B: $tType,F4: ( ( product_prod @ A @ B ) > $o ),A3: A,B3: B] :
      ( ( F4 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ( product_curry @ A @ B @ $o @ F4 @ A3 @ B3 ) ) )).

% curryI
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A6 ) )
      = A6 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),G3: ( A > B )] :
      ( ! [X3: A] :
          ( ( F4 @ X3 )
          = ( G3 @ X3 ) )
     => ( F4 = G3 ) ) )).

% ext
thf(fact_49_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X ) ) )).

% swap_simp
thf(fact_50_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_51_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P2 ) )
      = P2 ) )).

% swap_swap
thf(fact_52_curry__case__prod,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F4: ( A > B > C )] :
      ( ( product_curry @ A @ B @ C @ ( product_case_prod @ A @ B @ C @ F4 ) )
      = F4 ) )).

% curry_case_prod
thf(fact_53_case__prod__curry,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F4: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C @ ( product_curry @ A @ B @ C @ F4 ) )
      = F4 ) )).

% case_prod_curry
thf(fact_54_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( member @ A @ Z2 @ ( C2 @ X3 @ Y3 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_55_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F4: ( A > B > C ),X1: A,X2: B] :
      ( ( product_case_prod @ A @ B @ C @ F4 @ ( product_Pair @ A @ B @ X1 @ X2 ) )
      = ( F4 @ X1 @ X2 ) ) )).

% old.prod.case
thf(fact_56_dtree__cong,axiom,(
    ! [Tr: dtree,Tr3: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr3 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr3 ) )
       => ( Tr = Tr3 ) ) ) )).

% dtree_cong
thf(fact_57_curryE,axiom,(
    ! [A: $tType,B: $tType,F4: ( ( product_prod @ A @ B ) > $o ),A3: A,B3: B] :
      ( ( product_curry @ A @ B @ $o @ F4 @ A3 @ B3 )
     => ( F4 @ ( product_Pair @ A @ B @ A3 @ B3 ) ) ) )).

% curryE
thf(fact_58_curryD,axiom,(
    ! [A: $tType,B: $tType,F4: ( ( product_prod @ A @ B ) > $o ),A3: A,B3: B] :
      ( ( product_curry @ A @ B @ $o @ F4 @ A3 @ B3 )
     => ( F4 @ ( product_Pair @ A @ B @ A3 @ B3 ) ) ) )).

% curryD
thf(fact_59_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A7: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_60_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F4: ( A > B > C ),G3: ( A > B > C ),P2: ( product_prod @ A @ B )] :
      ( ! [X3: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y3 )
            = Q2 )
         => ( ( F4 @ X3 @ Y3 )
            = ( G3 @ X3 @ Y3 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F4 @ P2 )
          = ( product_case_prod @ A @ B @ C @ G3 @ Q2 ) ) ) ) )).

% split_cong
thf(fact_61_same__fstI,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),X: A,Y6: B,Y: B,R3: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ( P @ X )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y ) @ ( R3 @ X ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y6 ) @ ( product_Pair @ A @ B @ X @ Y ) ) @ ( same_fst @ A @ B @ P @ R3 ) ) ) ) )).

% same_fstI
thf(fact_62_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_63_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ? [X12: B] :
                ( P @ X3 @ X12 ) )
       => ? [F2: ( A > B )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A6 )
           => ( P @ X5 @ ( F2 @ X5 ) ) ) ) ) )).

% finite_set_choice
thf(fact_64_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A6: ( set @ A )] :
          ( finite_finite2 @ A @ A6 ) ) )).

% finite
thf(fact_65_scomp__apply,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_scomp @ B @ C @ D @ A )
      = ( ^ [F3: ( B > ( product_prod @ C @ D ) ),G4: ( C > D > A ),X4: B] :
            ( product_case_prod @ C @ D @ A @ G4 @ ( F3 @ X4 ) ) ) ) )).

% scomp_apply
thf(fact_66_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y: A,X: B,A6: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A6 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ A6 ) ) )).

% pair_in_swap_image
thf(fact_67_finite__imageI,axiom,(
    ! [B: $tType,A: $tType,F5: ( set @ A ),H: ( A > B )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( finite_finite2 @ B @ ( image @ A @ B @ H @ F5 ) ) ) )).

% finite_imageI
thf(fact_68_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N: n,N2: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N @ As )
            = ( node @ N2 @ As2 ) )
          = ( ( N = N2 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_69_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_70_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N3: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N3 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_71_scomp__Pair,axiom,(
    ! [C: $tType,B: $tType,A: $tType,X: ( A > ( product_prod @ B @ C ) )] :
      ( ( product_scomp @ A @ B @ C @ ( product_prod @ B @ C ) @ X @ ( product_Pair @ B @ C ) )
      = X ) )).

% scomp_Pair
thf(fact_72_Pair__scomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X: C,F4: ( C > A > B )] :
      ( ( product_scomp @ A @ C @ A @ B @ ( product_Pair @ C @ A @ X ) @ F4 )
      = ( F4 @ X ) ) )).

% Pair_scomp
thf(fact_73_scomp__def,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F3: ( A > ( product_prod @ B @ C ) ),G4: ( B > C > D ),X4: A] :
            ( product_case_prod @ B @ C @ D @ G4 @ ( F3 @ X4 ) ) ) ) )).

% scomp_def
thf(fact_74_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F4: ( B > A ),X: B,A6: ( set @ B )] :
      ( ( B3
        = ( F4 @ X ) )
     => ( ( member @ B @ X @ A6 )
       => ( member @ A @ B3 @ ( image @ B @ A @ F4 @ A6 ) ) ) ) )).

% image_eqI
thf(fact_75_surj__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% surj_swap
thf(fact_76_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ B ),B6: ( set @ B ),C4: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A6 = B6 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B6 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C4 @ A6 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B6 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_77_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ B ),B6: ( set @ B ),C4: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A6 = B6 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B6 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C4 @ A6 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B6 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_78_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A6: ( set @ A ),B3: B,F4: ( A > B )] :
      ( ( member @ A @ X @ A6 )
     => ( ( B3
          = ( F4 @ X ) )
       => ( member @ B @ B3 @ ( image @ A @ B @ F4 @ A6 ) ) ) ) )).

% rev_image_eqI
thf(fact_79_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),A6: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F4 @ A6 ) )
         => ( P @ X3 ) )
     => ! [X5: B] :
          ( ( member @ B @ X5 @ A6 )
         => ( P @ ( F4 @ X5 ) ) ) ) )).

% ball_imageD
thf(fact_80_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N4: ( set @ A ),F4: ( A > B ),G3: ( A > B )] :
      ( ( M = N4 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N4 )
           => ( ( F4 @ X3 )
              = ( G3 @ X3 ) ) )
       => ( ( image @ A @ B @ F4 @ M )
          = ( image @ A @ B @ G3 @ N4 ) ) ) ) )).

% image_cong
thf(fact_81_UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_82_finite__Plus__UNIV__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_Plus_UNIV_iff
thf(fact_83_Finite__Set_Ofinite__set,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% Finite_Set.finite_set
thf(fact_84_finite__prod,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_prod
thf(fact_85_finite__Prod__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% finite_Prod_UNIV
thf(fact_86_finite__fun__UNIVD2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) )).

% finite_fun_UNIVD2
thf(fact_87_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F4: ( B > A ),X: B] :
      ( ( B3
        = ( F4 @ X ) )
     => ( member @ A @ B3 @ ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_88_rangeI,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),X: B] :
      ( member @ A @ ( F4 @ X ) @ ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_89_UNIV__eq__I,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A6 )
     => ( ( top_top @ ( set @ A ) )
        = A6 ) ) )).

% UNIV_eq_I
thf(fact_90_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_91_finite__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_UNIV
thf(fact_92_infinite__UNIV__char__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% infinite_UNIV_char_0
thf(fact_93_ex__new__if__finite,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A @ A6 )
       => ? [A5: A] :
            ~ ( member @ A @ A5 @ A6 ) ) ) )).

% ex_new_if_finite
thf(fact_94_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A6: ( set @ A ),F4: ( A > B )] :
      ( ( member @ A @ X @ A6 )
     => ( member @ B @ ( F4 @ X ) @ ( image @ A @ B @ F4 @ A6 ) ) ) )).

% imageI
thf(fact_95_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z2: A,F4: ( B > A ),A6: ( set @ B )] :
      ( ( member @ A @ Z2 @ ( image @ B @ A @ F4 @ A6 ) )
      = ( ? [X4: B] :
            ( ( member @ B @ X4 @ A6 )
            & ( Z2
              = ( F4 @ X4 ) ) ) ) ) )).

% image_iff
thf(fact_96_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),A6: ( set @ B ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( image @ B @ A @ F4 @ A6 ) )
          & ( P @ X5 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A6 )
          & ( P @ ( F4 @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_97_finite__option__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_option_UNIV
thf(fact_98_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_99_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X4: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_100_surj__def,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A )] :
      ( ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y5: A] :
          ? [X4: B] :
            ( Y5
            = ( F4 @ X4 ) ) ) ) )).

% surj_def
thf(fact_101_surjI,axiom,(
    ! [B: $tType,A: $tType,G3: ( B > A ),F4: ( A > B )] :
      ( ! [X3: A] :
          ( ( G3 @ ( F4 @ X3 ) )
          = X3 )
     => ( ( image @ B @ A @ G3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_102_surjE,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X3: B] :
              ( Y
             != ( F4 @ X3 ) ) ) ) )).

% surjE
thf(fact_103_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_104_surjD,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X3: B] :
          ( Y
          = ( F4 @ X3 ) ) ) )).

% surjD
thf(fact_105_map__prod__surj,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F4: ( A > B ),G3: ( C > D )] :
      ( ( ( image @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ B ) ) )
     => ( ( ( image @ C @ D @ G3 @ ( top_top @ ( set @ C ) ) )
          = ( top_top @ ( set @ D ) ) )
       => ( ( image @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F4 @ G3 ) @ ( top_top @ ( set @ ( product_prod @ A @ C ) ) ) )
          = ( top_top @ ( set @ ( product_prod @ B @ D ) ) ) ) ) ) )).

% map_prod_surj
thf(fact_106_Pow__UNIV,axiom,(
    ! [A: $tType] :
      ( ( pow @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( set @ A ) ) ) ) )).

% Pow_UNIV
thf(fact_107_surj__swap__iff,axiom,(
    ! [B: $tType,A: $tType,A3: B,B3: B,F4: ( B > A )] :
      ( ( ( image @ B @ A @ ( swap @ B @ A @ A3 @ B3 @ F4 ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_swap_iff
thf(fact_108_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_109_finite__Pow__iff,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( finite_finite2 @ ( set @ A ) @ ( pow @ A @ A6 ) )
      = ( finite_finite2 @ A @ A6 ) ) )).

% finite_Pow_iff
thf(fact_110_top1I,axiom,(
    ! [A: $tType,X: A] :
      ( top_top @ ( A > $o ) @ X ) )).

% top1I
thf(fact_111_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F4: ( C > A ),G3: ( D > B ),A3: C,B3: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F4 @ G3 @ ( product_Pair @ C @ D @ A3 @ B3 ) )
      = ( product_Pair @ A @ B @ ( F4 @ A3 ) @ ( G3 @ B3 ) ) ) )).

% map_prod_simp
thf(fact_112_swap__image__eq,axiom,(
    ! [B: $tType,A: $tType,A3: A,A6: ( set @ A ),B3: A,F4: ( A > B )] :
      ( ( member @ A @ A3 @ A6 )
     => ( ( member @ A @ B3 @ A6 )
       => ( ( image @ A @ B @ ( swap @ A @ B @ A3 @ B3 @ F4 ) @ A6 )
          = ( image @ A @ B @ F4 @ A6 ) ) ) ) )).

% swap_image_eq
thf(fact_113_map__prod__imageI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A3: A,B3: B,R3: ( set @ ( product_prod @ A @ B ) ),F4: ( A > C ),G3: ( B > D )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B3 ) @ R3 )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F4 @ A3 ) @ ( G3 @ B3 ) ) @ ( image @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F4 @ G3 ) @ R3 ) ) ) )).

% map_prod_imageI
thf(fact_114_Cantors__paradox,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ~ ( ? [X5: ( A > ( set @ A ) )] :
            ( ( image @ A @ ( set @ A ) @ X5 @ A6 )
            = ( pow @ A @ A6 ) ) ) )).

% Cantors_paradox
thf(fact_115_Pow__top,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( member @ ( set @ A ) @ A6 @ ( pow @ A @ A6 ) ) )).

% Pow_top
thf(fact_116_image__Pow__surj,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A6: ( set @ B ),B6: ( set @ A )] :
      ( ( ( image @ B @ A @ F4 @ A6 )
        = B6 )
     => ( ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F4 ) @ ( pow @ B @ A6 ) )
        = ( pow @ A @ B6 ) ) ) )).

% image_Pow_surj
thf(fact_117_prod__fun__imageE,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C2: ( product_prod @ A @ B ),F4: ( C > A ),G3: ( D > B ),R3: ( set @ ( product_prod @ C @ D ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F4 @ G3 ) @ R3 ) )
     => ~ ( ! [X3: C,Y3: D] :
              ( ( C2
                = ( product_Pair @ A @ B @ ( F4 @ X3 ) @ ( G3 @ Y3 ) ) )
             => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X3 @ Y3 ) @ R3 ) ) ) ) )).

% prod_fun_imageE
thf(fact_118_surj__imp__surj__swap,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A3: B,B3: B] :
      ( ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ ( swap @ B @ A @ A3 @ B3 @ F4 ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_imp_surj_swap
thf(fact_119_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X ) )
      = P ) )).

% top_conj(2)
thf(fact_120_top__conj_I1_J,axiom,(
    ! [A: $tType,X: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_121_range__fst,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% range_fst
thf(fact_122_range__snd,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ A @ ( product_snd @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% range_snd
thf(fact_123_in__inv__image,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: A,R: ( set @ ( product_prod @ B @ B ) ),F4: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( inv_image @ B @ A @ R @ F4 ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F4 @ X ) @ ( F4 @ Y ) ) @ R ) ) )).

% in_inv_image
thf(fact_124_fst__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F4: ( C > A ),G3: ( D > B ),X: ( product_prod @ C @ D )] :
      ( ( product_fst @ A @ B @ ( product_map_prod @ C @ A @ D @ B @ F4 @ G3 @ X ) )
      = ( F4 @ ( product_fst @ C @ D @ X ) ) ) )).

% fst_map_prod
thf(fact_125_snd__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F4: ( C > B ),G3: ( D > A ),X: ( product_prod @ C @ D )] :
      ( ( product_snd @ B @ A @ ( product_map_prod @ C @ B @ D @ A @ F4 @ G3 @ X ) )
      = ( G3 @ ( product_snd @ C @ D @ X ) ) ) )).

% snd_map_prod
thf(fact_126_prod_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) )).

% prod.collapse
thf(fact_127_snd__swap,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B )] :
      ( ( product_snd @ B @ A @ ( product_swap @ A @ B @ X ) )
      = ( product_fst @ A @ B @ X ) ) )).

% snd_swap
thf(fact_128_fst__swap,axiom,(
    ! [A: $tType,B: $tType,X: ( product_prod @ B @ A )] :
      ( ( product_fst @ A @ B @ ( product_swap @ B @ A @ X ) )
      = ( product_snd @ B @ A @ X ) ) )).

% fst_swap
thf(fact_129_prod_Osplit__sel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( C > $o ),F4: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F4 @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P @ ( F4 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) )).

% prod.split_sel
thf(fact_130_prod_Osplit__sel__asm,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( C > $o ),F4: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F4 @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P @ ( F4 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) )).

% prod.split_sel_asm
thf(fact_131_prod_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) )).

% prod.exhaust_sel
thf(fact_132_surjective__pairing,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) )).

% surjective_pairing
thf(fact_133_prod__eqI,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B ),Q2: ( product_prod @ A @ B )] :
      ( ( ( product_fst @ A @ B @ P2 )
        = ( product_fst @ A @ B @ Q2 ) )
     => ( ( ( product_snd @ A @ B @ P2 )
          = ( product_snd @ A @ B @ Q2 ) )
       => ( P2 = Q2 ) ) ) )).

% prod_eqI
thf(fact_134_prod_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B ),Prod2: ( product_prod @ A @ B )] :
      ( ( ( ( product_fst @ A @ B @ Prod )
          = ( product_fst @ A @ B @ Prod2 ) )
        & ( ( product_snd @ A @ B @ Prod )
          = ( product_snd @ A @ B @ Prod2 ) ) )
     => ( Prod = Prod2 ) ) )).

% prod.expand
thf(fact_135_prod__eq__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [Y7: ( product_prod @ A @ B ),Z3: ( product_prod @ A @ B )] : ( Y7 = Z3 ) )
      = ( ^ [S3: ( product_prod @ A @ B ),T3: ( product_prod @ A @ B )] :
            ( ( ( product_fst @ A @ B @ S3 )
              = ( product_fst @ A @ B @ T3 ) )
            & ( ( product_snd @ A @ B @ S3 )
              = ( product_snd @ A @ B @ T3 ) ) ) ) ) )).

% prod_eq_iff
thf(fact_136_case__prod__beta,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ A )
      = ( ^ [F3: ( B > C > A ),P3: ( product_prod @ B @ C )] :
            ( F3 @ ( product_fst @ B @ C @ P3 ) @ ( product_snd @ B @ C @ P3 ) ) ) ) )).

% case_prod_beta
thf(fact_137_prod_Ocase__eq__if,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F3: ( A > B > C ),Prod3: ( product_prod @ A @ B )] :
            ( F3 @ ( product_fst @ A @ B @ Prod3 ) @ ( product_snd @ A @ B @ Prod3 ) ) ) ) )).

% prod.case_eq_if
thf(fact_138_Product__Type_OCollect__case__prodD,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B ),A6: ( A > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ X @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A6 ) ) )
     => ( A6 @ ( product_fst @ A @ B @ X ) @ ( product_snd @ A @ B @ X ) ) ) )).

% Product_Type.Collect_case_prodD
thf(fact_139_fst__conv,axiom,(
    ! [B: $tType,A: $tType,X1: A,X2: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X2 ) )
      = X1 ) )).

% fst_conv
thf(fact_140_fst__eqD,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: B,A3: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X @ Y ) )
        = A3 )
     => ( X = A3 ) ) )).

% fst_eqD
thf(fact_141_snd__conv,axiom,(
    ! [Aa: $tType,A: $tType,X1: Aa,X2: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X2 ) )
      = X2 ) )).

% snd_conv
thf(fact_142_snd__eqD,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A,A3: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
        = A3 )
     => ( Y = A3 ) ) )).

% snd_eqD
thf(fact_143_prod_Oswap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_swap @ A @ B )
      = ( ^ [P3: ( product_prod @ A @ B )] :
            ( product_Pair @ B @ A @ ( product_snd @ A @ B @ P3 ) @ ( product_fst @ A @ B @ P3 ) ) ) ) )).

% prod.swap_def
thf(fact_144_exI__realizer,axiom,(
    ! [B: $tType,A: $tType,P: ( A > B > $o ),Y: A,X: B] :
      ( ( P @ Y @ X )
     => ( P @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) ) ) ) )).

% exI_realizer
thf(fact_145_conjI__realizer,axiom,(
    ! [A: $tType,B: $tType,P: ( A > $o ),P2: A,Q: ( B > $o ),Q2: B] :
      ( ( P @ P2 )
     => ( ( Q @ Q2 )
       => ( ( P @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q2 ) ) )
          & ( Q @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P2 @ Q2 ) ) ) ) ) ) )).

% conjI_realizer
thf(fact_146_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,(
    ! [B: $tType,A: $tType,P: ( A > B > $o ),X: A,Y: B,A3: ( product_prod @ A @ B )] :
      ( ( P @ X @ Y )
     => ( ( A3
          = ( product_Pair @ A @ B @ X @ Y ) )
       => ( P @ ( product_fst @ A @ B @ A3 ) @ ( product_snd @ A @ B @ A3 ) ) ) ) )).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_147_sndI,axiom,(
    ! [A: $tType,B: $tType,X: ( product_prod @ A @ B ),Y: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_snd @ A @ B @ X )
        = Z2 ) ) )).

% sndI
thf(fact_148_fstI,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B ),Y: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_fst @ A @ B @ X )
        = Y ) ) )).

% fstI
thf(fact_149_eq__snd__iff,axiom,(
    ! [A: $tType,B: $tType,B3: A,P2: ( product_prod @ B @ A )] :
      ( ( B3
        = ( product_snd @ B @ A @ P2 ) )
      = ( ? [A2: B] :
            ( P2
            = ( product_Pair @ B @ A @ A2 @ B3 ) ) ) ) )).

% eq_snd_iff
thf(fact_150_eq__fst__iff,axiom,(
    ! [A: $tType,B: $tType,A3: A,P2: ( product_prod @ A @ B )] :
      ( ( A3
        = ( product_fst @ A @ B @ P2 ) )
      = ( ? [B2: B] :
            ( P2
            = ( product_Pair @ A @ B @ A3 @ B2 ) ) ) ) )).

% eq_fst_iff
thf(fact_151_Collect__split__mono__strong,axiom,(
    ! [B: $tType,A: $tType,X6: ( set @ A ),A6: ( set @ ( product_prod @ A @ B ) ),Y8: ( set @ B ),P: ( A > B > $o ),Q: ( A > B > $o )] :
      ( ( X6
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A6 ) )
     => ( ( Y8
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A6 ) )
       => ( ! [X3: A] :
              ( ( member @ A @ X3 @ X6 )
             => ! [Xa: B] :
                  ( ( member @ B @ Xa @ Y8 )
                 => ( ( P @ X3 @ Xa )
                   => ( Q @ X3 @ Xa ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A6 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A6 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) )).

% Collect_split_mono_strong
thf(fact_152_subsetI,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A6 )
         => ( member @ A @ X3 @ B6 ) )
     => ( ord_less_eq @ ( set @ A ) @ A6 @ B6 ) ) )).

% subsetI
thf(fact_153_subset__antisym,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ A6 )
       => ( A6 = B6 ) ) ) )).

% subset_antisym
thf(fact_154_Pow__iff,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A6 @ ( pow @ A @ B6 ) )
      = ( ord_less_eq @ ( set @ A ) @ A6 @ B6 ) ) )).

% Pow_iff
thf(fact_155_PowI,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( member @ ( set @ A ) @ A6 @ ( pow @ A @ B6 ) ) ) )).

% PowI
thf(fact_156_subrelI,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ! [X3: A,Y3: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ S ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) )).

% subrelI
thf(fact_157_Pow__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow @ A @ A6 ) @ ( pow @ A @ B6 ) ) ) )).

% Pow_mono
thf(fact_158_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_159_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_160_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_161_rev__finite__subset,axiom,(
    ! [A: $tType,B6: ( set @ A ),A6: ( set @ A )] :
      ( ( finite_finite2 @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
       => ( finite_finite2 @ A @ A6 ) ) ) )).

% rev_finite_subset
thf(fact_162_infinite__super,axiom,(
    ! [A: $tType,S4: ( set @ A ),T4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S4 @ T4 )
     => ( ~ ( finite_finite2 @ A @ S4 )
       => ~ ( finite_finite2 @ A @ T4 ) ) ) )).

% infinite_super
thf(fact_163_finite__subset,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( finite_finite2 @ A @ B6 )
       => ( finite_finite2 @ A @ A6 ) ) ) )).

% finite_subset
thf(fact_164_subset__UNIV,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A6 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_165_set__mp,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( member @ A @ X @ A6 )
       => ( member @ A @ X @ B6 ) ) ) )).

% set_mp
thf(fact_166_in__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( member @ A @ X @ A6 )
       => ( member @ A @ X @ B6 ) ) ) )).

% in_mono
thf(fact_167_subsetD,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( member @ A @ C2 @ A6 )
       => ( member @ A @ C2 @ B6 ) ) ) )).

% subsetD
thf(fact_168_subsetCE,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( member @ A @ C2 @ A6 )
       => ( member @ A @ C2 @ B6 ) ) ) )).

% subsetCE
thf(fact_169_equalityE,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( A6 = B6 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) ) )).

% equalityE
thf(fact_170_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
          ! [X4: A] :
            ( ( member @ A @ X4 @ A7 )
           => ( member @ A @ X4 @ B7 ) ) ) ) )).

% subset_eq
thf(fact_171_equalityD1,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( A6 = B6 )
     => ( ord_less_eq @ ( set @ A ) @ A6 @ B6 ) ) )).

% equalityD1
thf(fact_172_equalityD2,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( A6 = B6 )
     => ( ord_less_eq @ ( set @ A ) @ B6 @ A6 ) ) )).

% equalityD2
thf(fact_173_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ X @ A6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
       => ( member @ A @ X @ B6 ) ) ) )).

% set_rev_mp
thf(fact_174_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A7 )
           => ( member @ A @ T3 @ B7 ) ) ) ) )).

% subset_iff
thf(fact_175_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ A6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
       => ( member @ A @ C2 @ B6 ) ) ) )).

% rev_subsetD
thf(fact_176_subset__refl,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A6 @ A6 ) )).

% subset_refl
thf(fact_177_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_178_subset__trans,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A6 @ C4 ) ) ) )).

% subset_trans
thf(fact_179_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y7: ( set @ A ),Z3: ( set @ A )] : ( Y7 = Z3 ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B7 )
            & ( ord_less_eq @ ( set @ A ) @ B7 @ A7 ) ) ) ) )).

% set_eq_subset
thf(fact_180_contra__subsetD,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ~ ( member @ A @ C2 @ B6 )
       => ~ ( member @ A @ C2 @ A6 ) ) ) )).

% contra_subsetD
thf(fact_181_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X4: A] :
            ( ( P @ X4 )
           => ( Q @ X4 ) ) ) ) )).

% Collect_mono_iff
thf(fact_182_PowD,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A6 @ ( pow @ A @ B6 ) )
     => ( ord_less_eq @ ( set @ A ) @ A6 @ B6 ) ) )).

% PowD
thf(fact_183_image__mono,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),B6: ( set @ A ),F4: ( A > B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F4 @ A6 ) @ ( image @ A @ B @ F4 @ B6 ) ) ) )).

% image_mono
thf(fact_184_image__subsetI,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),F4: ( A > B ),B6: ( set @ B )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A6 )
         => ( member @ B @ ( F4 @ X3 ) @ B6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F4 @ A6 ) @ B6 ) ) )).

% image_subsetI
thf(fact_185_subset__imageE,axiom,(
    ! [A: $tType,B: $tType,B6: ( set @ A ),F4: ( B > A ),A6: ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F4 @ A6 ) )
     => ~ ( ! [C5: ( set @ B )] :
              ( ( ord_less_eq @ ( set @ B ) @ C5 @ A6 )
             => ( B6
               != ( image @ B @ A @ F4 @ C5 ) ) ) ) ) )).

% subset_imageE
thf(fact_186_image__subset__iff,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),A6: ( set @ B ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F4 @ A6 ) @ B6 )
      = ( ! [X4: B] :
            ( ( member @ B @ X4 @ A6 )
           => ( member @ A @ ( F4 @ X4 ) @ B6 ) ) ) ) )).

% image_subset_iff
thf(fact_187_subset__image__iff,axiom,(
    ! [A: $tType,B: $tType,B6: ( set @ A ),F4: ( B > A ),A6: ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F4 @ A6 ) )
      = ( ? [AA: ( set @ B )] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A6 )
            & ( B6
              = ( image @ B @ A @ F4 @ AA ) ) ) ) ) )).

% subset_image_iff
thf(fact_188_image__Pow__mono,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A6: ( set @ B ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F4 @ A6 ) @ B6 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F4 ) @ ( pow @ B @ A6 ) ) @ ( pow @ A @ B6 ) ) ) )).

% image_Pow_mono
thf(fact_189_finite__surj,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),B6: ( set @ B ),F4: ( A > B )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F4 @ A6 ) )
       => ( finite_finite2 @ B @ B6 ) ) ) )).

% finite_surj
thf(fact_190_finite__subset__image,axiom,(
    ! [A: $tType,B: $tType,B6: ( set @ A ),F4: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F4 @ A6 ) )
       => ? [C5: ( set @ B )] :
            ( ( ord_less_eq @ ( set @ B ) @ C5 @ A6 )
            & ( finite_finite2 @ B @ C5 )
            & ( B6
              = ( image @ B @ A @ F4 @ C5 ) ) ) ) ) )).

% finite_subset_image
thf(fact_191_relChain__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( bNF_Ca1785829860lChain @ A @ B )
        = ( ^ [R2: ( set @ ( product_prod @ A @ A ) ),As4: ( A > B )] :
            ! [I: A,J: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I @ J ) @ R2 )
             => ( ord_less_eq @ B @ ( As4 @ I ) @ ( As4 @ J ) ) ) ) ) ) )).

% relChain_def
thf(fact_192_fstOp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_fstOp @ A @ B @ C )
      = ( ^ [P4: ( A > B > $o ),Q3: ( B > C > $o ),Ac: ( product_prod @ A @ C )] :
            ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Ac ) @ ( bNF_pick_middlep @ A @ B @ C @ P4 @ Q3 @ ( product_fst @ A @ C @ Ac ) @ ( product_snd @ A @ C @ Ac ) ) ) ) ) )).

% fstOp_def
thf(fact_193_sndOp__def,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( bNF_sndOp @ C @ A @ B )
      = ( ^ [P4: ( C > A > $o ),Q3: ( A > B > $o ),Ac: ( product_prod @ C @ B )] :
            ( product_Pair @ A @ B @ ( bNF_pick_middlep @ C @ A @ B @ P4 @ Q3 @ ( product_fst @ C @ B @ Ac ) @ ( product_snd @ C @ B @ Ac ) ) @ ( product_snd @ C @ B @ Ac ) ) ) ) )).

% sndOp_def
thf(fact_194_accp__subset,axiom,(
    ! [A: $tType,R1: ( A > A > $o ),R22: ( A > A > $o )] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R1 @ R22 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R22 ) @ ( accp @ A @ R1 ) ) ) )).

% accp_subset
thf(fact_195_accp__subset__induct,axiom,(
    ! [A: $tType,D3: ( A > $o ),R3: ( A > A > $o ),X: A,P: ( A > $o )] :
      ( ( ord_less_eq @ ( A > $o ) @ D3 @ ( accp @ A @ R3 ) )
     => ( ! [X3: A,Z: A] :
            ( ( D3 @ X3 )
           => ( ( R3 @ Z @ X3 )
             => ( D3 @ Z ) ) )
       => ( ( D3 @ X )
         => ( ! [X3: A] :
                ( ( D3 @ X3 )
               => ( ! [Z4: A] :
                      ( ( R3 @ Z4 @ X3 )
                     => ( P @ Z4 ) )
                 => ( P @ X3 ) ) )
           => ( P @ X ) ) ) ) ) )).

% accp_subset_induct
thf(fact_196_Collect__case__prod__mono,axiom,(
    ! [B: $tType,A: $tType,A6: ( A > B > $o ),B6: ( A > B > $o )] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A6 @ B6 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A6 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B6 ) ) ) ) )).

% Collect_case_prod_mono
thf(fact_197_finite__vimageD_H,axiom,(
    ! [A: $tType,B: $tType,F4: ( A > B ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( vimage @ A @ B @ F4 @ A6 ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A6 @ ( image @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) ) )
       => ( finite_finite2 @ B @ A6 ) ) ) )).

% finite_vimageD'
thf(fact_198_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B3: A,F4: ( B > A ),X: B,C2: C,G3: ( B > C ),A6: ( set @ B )] :
      ( ( B3
        = ( F4 @ X ) )
     => ( ( C2
          = ( G3 @ X ) )
       => ( ( member @ B @ X @ A6 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B3 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A6 @ F4 @ G3 ) ) ) ) ) )).

% image2_eqI
thf(fact_199_vimageI,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A3: B,B3: A,B6: ( set @ A )] :
      ( ( ( F4 @ A3 )
        = B3 )
     => ( ( member @ A @ B3 @ B6 )
       => ( member @ B @ A3 @ ( vimage @ B @ A @ F4 @ B6 ) ) ) ) )).

% vimageI
thf(fact_200_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A3: A,F4: ( A > B ),B6: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F4 @ B6 ) )
      = ( member @ B @ ( F4 @ A3 ) @ B6 ) ) )).

% vimage_eq
thf(fact_201_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B )] :
      ( ( vimage @ A @ B @ F4 @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_202_vimage__mono,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),B6: ( set @ A ),F4: ( B > A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F4 @ A6 ) @ ( vimage @ B @ A @ F4 @ B6 ) ) ) )).

% vimage_mono
thf(fact_203_image__subset__iff__subset__vimage,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A6: ( set @ B ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F4 @ A6 ) @ B6 )
      = ( ord_less_eq @ ( set @ B ) @ A6 @ ( vimage @ B @ A @ F4 @ B6 ) ) ) )).

% image_subset_iff_subset_vimage
thf(fact_204_image__vimage__subset,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F4 @ ( vimage @ B @ A @ F4 @ A6 ) ) @ A6 ) )).

% image_vimage_subset
thf(fact_205_surj__image__vimage__eq,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A6: ( set @ A )] :
      ( ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ F4 @ ( vimage @ B @ A @ F4 @ A6 ) )
        = A6 ) ) )).

% surj_image_vimage_eq
thf(fact_206_vimageD,axiom,(
    ! [A: $tType,B: $tType,A3: A,F4: ( A > B ),A6: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F4 @ A6 ) )
     => ( member @ B @ ( F4 @ A3 ) @ A6 ) ) )).

% vimageD
thf(fact_207_vimageE,axiom,(
    ! [A: $tType,B: $tType,A3: A,F4: ( A > B ),B6: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F4 @ B6 ) )
     => ( member @ B @ ( F4 @ A3 ) @ B6 ) ) )).

% vimageE
thf(fact_208_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F4: ( B > A ),A3: B,A6: ( set @ A )] :
      ( ( member @ A @ ( F4 @ A3 ) @ A6 )
     => ( member @ B @ A3 @ ( vimage @ B @ A @ F4 @ A6 ) ) ) )).

% vimageI2
thf(fact_209_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F4: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F4 @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F4 @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_210_finite__vimageD,axiom,(
    ! [A: $tType,B: $tType,H: ( A > B ),F5: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( vimage @ A @ B @ H @ F5 ) )
     => ( ( ( image @ A @ B @ H @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ B @ F5 ) ) ) )).

% finite_vimageD
thf(fact_211_vimage__subsetD,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),B6: ( set @ A ),A6: ( set @ B )] :
      ( ( ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F4 @ B6 ) @ A6 )
       => ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F4 @ A6 ) ) ) ) )).

% vimage_subsetD
thf(fact_212_image__vimage__eq,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),A6: ( set @ A )] :
      ( ( image @ B @ A @ F4 @ ( vimage @ B @ A @ F4 @ A6 ) )
      = ( inf_inf @ ( set @ A ) @ A6 @ ( image @ B @ A @ F4 @ ( top_top @ ( set @ B ) ) ) ) ) )).

% image_vimage_eq
thf(fact_213_vimage__subsetI,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),B6: ( set @ B ),A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F4 @ A6 ) )
       => ( ord_less_eq @ ( set @ A ) @ ( vimage @ A @ B @ F4 @ B6 ) @ A6 ) ) ) )).

% vimage_subsetI
thf(fact_214_Int__iff,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
      = ( ( member @ A @ C2 @ A6 )
        & ( member @ A @ C2 @ B6 ) ) ) )).

% Int_iff
thf(fact_215_IntI,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ A6 )
     => ( ( member @ A @ C2 @ B6 )
       => ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) ) ) ) )).

% IntI
thf(fact_216_finite__Int,axiom,(
    ! [A: $tType,F5: ( set @ A ),G5: ( set @ A )] :
      ( ( ( finite_finite2 @ A @ F5 )
        | ( finite_finite2 @ A @ G5 ) )
     => ( finite_finite2 @ A @ ( inf_inf @ ( set @ A ) @ F5 @ G5 ) ) ) )).

% finite_Int
thf(fact_217_Int__subset__iff,axiom,(
    ! [A: $tType,C4: ( set @ A ),A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C4 @ A6 )
        & ( ord_less_eq @ ( set @ A ) @ C4 @ B6 ) ) ) )).

% Int_subset_iff
thf(fact_218_Int__UNIV,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A6 @ B6 )
        = ( top_top @ ( set @ A ) ) )
      = ( ( A6
          = ( top_top @ ( set @ A ) ) )
        & ( B6
          = ( top_top @ ( set @ A ) ) ) ) ) )).

% Int_UNIV
thf(fact_219_vimage__Int,axiom,(
    ! [A: $tType,B: $tType,F4: ( A > B ),A6: ( set @ B ),B6: ( set @ B )] :
      ( ( vimage @ A @ B @ F4 @ ( inf_inf @ ( set @ B ) @ A6 @ B6 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F4 @ A6 ) @ ( vimage @ A @ B @ F4 @ B6 ) ) ) )).

% vimage_Int
thf(fact_220_Pow__Int__eq,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( pow @ A @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
      = ( inf_inf @ ( set @ ( set @ A ) ) @ ( pow @ A @ A6 ) @ ( pow @ A @ B6 ) ) ) )).

% Pow_Int_eq
thf(fact_221_Int__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),C4: ( set @ A ),B6: ( set @ A ),D3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ D3 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ ( inf_inf @ ( set @ A ) @ C4 @ D3 ) ) ) ) )).

% Int_mono
thf(fact_222_Int__lower1,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ A6 ) )).

% Int_lower1
thf(fact_223_Int__lower2,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ B6 ) )).

% Int_lower2
thf(fact_224_Int__absorb1,axiom,(
    ! [A: $tType,B6: ( set @ A ),A6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A6 )
     => ( ( inf_inf @ ( set @ A ) @ A6 @ B6 )
        = B6 ) ) )).

% Int_absorb1
thf(fact_225_Int__absorb2,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( inf_inf @ ( set @ A ) @ A6 @ B6 )
        = A6 ) ) )).

% Int_absorb2
thf(fact_226_Int__greatest,axiom,(
    ! [A: $tType,C4: ( set @ A ),A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ A6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C4 @ B6 )
       => ( ord_less_eq @ ( set @ A ) @ C4 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) ) ) ) )).

% Int_greatest
thf(fact_227_Int__Collect__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( ( P @ X3 )
             => ( Q @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B6 @ ( collect @ A @ Q ) ) ) ) ) )).

% Int_Collect_mono
thf(fact_228_inj__on__image__Int,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),C4: ( set @ A ),A6: ( set @ A ),B6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
         => ( ( image @ A @ B @ F4 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F4 @ A6 ) @ ( image @ A @ B @ F4 @ B6 ) ) ) ) ) ) )).

% inj_on_image_Int
thf(fact_229_inj__on__image__eq__iff,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),C4: ( set @ A ),A6: ( set @ A ),B6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
       => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
         => ( ( ( image @ A @ B @ F4 @ A6 )
              = ( image @ A @ B @ F4 @ B6 ) )
            = ( A6 = B6 ) ) ) ) ) )).

% inj_on_image_eq_iff
thf(fact_230_inj__on__image__mem__iff,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),B6: ( set @ A ),A3: A,A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ B6 )
     => ( ( member @ A @ A3 @ B6 )
       => ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
         => ( ( member @ B @ ( F4 @ A3 ) @ ( image @ A @ B @ F4 @ A6 ) )
            = ( member @ A @ A3 @ A6 ) ) ) ) ) )).

% inj_on_image_mem_iff
thf(fact_231_inj__on__image__mem__iff__alt,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),B6: ( set @ A ),A6: ( set @ A ),A3: A] :
      ( ( inj_on @ A @ B @ F4 @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
       => ( ( member @ B @ ( F4 @ A3 ) @ ( image @ A @ B @ F4 @ A6 ) )
         => ( ( member @ A @ A3 @ B6 )
           => ( member @ A @ A3 @ A6 ) ) ) ) ) )).

% inj_on_image_mem_iff_alt
thf(fact_232_image__Int__subset,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),A6: ( set @ B ),B6: ( set @ B )] :
      ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F4 @ ( inf_inf @ ( set @ B ) @ A6 @ B6 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F4 @ A6 ) @ ( image @ B @ A @ F4 @ B6 ) ) ) )).

% image_Int_subset
thf(fact_233_vimage__inter__cong,axiom,(
    ! [B: $tType,A: $tType,S4: ( set @ A ),F4: ( A > B ),G3: ( A > B ),Y: ( set @ B )] :
      ( ! [W: A] :
          ( ( member @ A @ W @ S4 )
         => ( ( F4 @ W )
            = ( G3 @ W ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F4 @ Y ) @ S4 )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G3 @ Y ) @ S4 ) ) ) )).

% vimage_inter_cong
thf(fact_234_finite__vimage__IntI,axiom,(
    ! [A: $tType,B: $tType,F5: ( set @ A ),H: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ F5 )
     => ( ( inj_on @ B @ A @ H @ A6 )
       => ( finite_finite2 @ B @ ( inf_inf @ ( set @ B ) @ ( vimage @ B @ A @ H @ F5 ) @ A6 ) ) ) ) )).

% finite_vimage_IntI
thf(fact_235_image__Int,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),A6: ( set @ A ),B6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ B @ F4 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
        = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F4 @ A6 ) @ ( image @ A @ B @ F4 @ B6 ) ) ) ) )).

% image_Int
thf(fact_236_inj__on__image__iff,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),G3: ( A > B ),F4: ( A > A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A6 )
         => ! [Xa: A] :
              ( ( member @ A @ Xa @ A6 )
             => ( ( ( G3 @ ( F4 @ X3 ) )
                  = ( G3 @ ( F4 @ Xa ) ) )
                = ( ( G3 @ X3 )
                  = ( G3 @ Xa ) ) ) ) )
     => ( ( inj_on @ A @ A @ F4 @ A6 )
       => ( ( inj_on @ A @ B @ G3 @ ( image @ A @ A @ F4 @ A6 ) )
          = ( inj_on @ A @ B @ G3 @ A6 ) ) ) ) )).

% inj_on_image_iff
thf(fact_237_inj__swap,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ ( product_prod @ A @ B ) )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A ) @ ( product_swap @ A @ B ) @ A6 ) )).

% inj_swap
thf(fact_238_Int__left__commute,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A6 @ ( inf_inf @ ( set @ A ) @ B6 @ C4 ) )
      = ( inf_inf @ ( set @ A ) @ B6 @ ( inf_inf @ ( set @ A ) @ A6 @ C4 ) ) ) )).

% Int_left_commute
thf(fact_239_Int__left__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A6 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
      = ( inf_inf @ ( set @ A ) @ A6 @ B6 ) ) )).

% Int_left_absorb
thf(fact_240_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B7 @ A7 ) ) ) )).

% Int_commute
thf(fact_241_Int__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A6 @ A6 )
      = A6 ) )).

% Int_absorb
thf(fact_242_Int__assoc,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ C4 )
      = ( inf_inf @ ( set @ A ) @ A6 @ ( inf_inf @ ( set @ A ) @ B6 @ C4 ) ) ) )).

% Int_assoc
thf(fact_243_IntD2,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
     => ( member @ A @ C2 @ B6 ) ) )).

% IntD2
thf(fact_244_IntD1,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
     => ( member @ A @ C2 @ A6 ) ) )).

% IntD1
thf(fact_245_IntE,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) )
     => ~ ( ( member @ A @ C2 @ A6 )
         => ~ ( member @ A @ C2 @ B6 ) ) ) )).

% IntE
thf(fact_246_Int__UNIV__left,axiom,(
    ! [A: $tType,B6: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B6 )
      = B6 ) )).

% Int_UNIV_left
thf(fact_247_Int__UNIV__right,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A6 @ ( top_top @ ( set @ A ) ) )
      = A6 ) )).

% Int_UNIV_right
thf(fact_248_inj__eq,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),X: A,Y: A] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( F4 @ X )
          = ( F4 @ Y ) )
        = ( X = Y ) ) ) )).

% inj_eq
thf(fact_249_injI,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B )] :
      ( ! [X3: A,Y3: A] :
          ( ( ( F4 @ X3 )
            = ( F4 @ Y3 ) )
         => ( X3 = Y3 ) )
     => ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) ) ) )).

% injI
thf(fact_250_injD,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),X: A,Y: A] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( F4 @ X )
          = ( F4 @ Y ) )
       => ( X = Y ) ) ) )).

% injD
thf(fact_251_range__ex1__eq,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),B3: B] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( member @ B @ B3 @ ( image @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) ) )
        = ( ? [X4: A] :
              ( ( B3
                = ( F4 @ X4 ) )
              & ! [Y5: A] :
                  ( ( B3
                    = ( F4 @ Y5 ) )
                 => ( Y5 = X4 ) ) ) ) ) ) )).

% range_ex1_eq
thf(fact_252_inj__image__eq__iff,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),A6: ( set @ A ),B6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( image @ A @ B @ F4 @ A6 )
          = ( image @ A @ B @ F4 @ B6 ) )
        = ( A6 = B6 ) ) ) )).

% inj_image_eq_iff
thf(fact_253_inj__image__mem__iff,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),A3: A,A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ ( top_top @ ( set @ A ) ) )
     => ( ( member @ B @ ( F4 @ A3 ) @ ( image @ A @ B @ F4 @ A6 ) )
        = ( member @ A @ A3 @ A6 ) ) ) )).

% inj_image_mem_iff
thf(fact_254_finite__imageD,axiom,(
    ! [A: $tType,B: $tType,F4: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( image @ B @ A @ F4 @ A6 ) )
     => ( ( inj_on @ B @ A @ F4 @ A6 )
       => ( finite_finite2 @ B @ A6 ) ) ) )).

% finite_imageD
thf(fact_255_finite__image__iff,axiom,(
    ! [B: $tType,A: $tType,F4: ( A > B ),A6: ( set @ A )] :
      ( ( inj_on @ A @ B @ F4 @ A6 )
     => ( ( finite_finite2 @ B @ ( image @ A @ B @ F4 @ A6 ) )
        = ( finite_finite2 @ A @ A6 ) ) ) )).

% finite_image_iff

%----Type constructors (15)
thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_top @ A9 @ ( type2 @ A9 ) )
     => ( order_top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( top @ A9 @ ( type2 @ A9 ) )
     => ( top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_1,axiom,(
    ! [A8: $tType] :
      ( order_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_2,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_3,axiom,(
    ! [A8: $tType] :
      ( top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_4,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_5,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_6,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_7,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_8,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_9,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( sum_sum @ A8 @ A9 ) @ ( type2 @ ( sum_sum @ A8 @ A9 ) ) ) ) )).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_10,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_11,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A9 ) @ ( type2 @ ( product_prod @ A8 @ A9 ) ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( root @ ( unfold @ ( product_prod @ dtree @ dtree ) @ parall1914194362_par_r @ parall1914194347_par_c @ ( product_Pair @ dtree @ dtree @ tr1 @ tr2 ) ) )
    = ( parall1518086719_Nplus @ ( root @ tr1 ) @ ( root @ tr2 ) ) )).

%------------------------------------------------------------------------------
