%------------------------------------------------------------------------------
% File     : COM204^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Parallel extension to grammars and languages 65
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : parallel__65.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  327 (   0 unit;  55 type;   0 defn)
%            Number of atoms       : 4868 ( 281 equality;2994 variable)
%            Maximal formula depth :   28 (  11 average)
%            Number of connectives : 4633 (  69   ~;   9   |;  29   &;4304   @)
%                                         (   0 <=>; 222  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  403 ( 403   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   59 (  55   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1454 (  27 sgn;1185   !;  16   ?; 177   ^)
%                                         (1454   :;  76  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:38:53.195
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (48)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Fun__Def_Orp__inv__image,type,(
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) )).

thf(sy_c_HOL_OThe,type,(
    the: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar,type,(
    parall1899940088le_par: ( product_prod @ dtree @ dtree ) > dtree )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__c,type,(
    parall1914194347_par_c: ( product_prod @ dtree @ dtree ) > ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__c__rel,type,(
    parall1418634510_c_rel: ( product_prod @ dtree @ dtree ) > ( product_prod @ dtree @ dtree ) > $o )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__r,type,(
    parall1914194362_par_r: ( product_prod @ dtree @ dtree ) > n )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_OSigma,type,(
    product_Sigma: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,(
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T > $o ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Product__Type_Oproduct,type,(
    product_product: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_OId,type,(
    id: 
      !>[A: $tType] :
        ( set @ ( product_prod @ A @ A ) ) )).

thf(sy_c_Relation_Oantisym,type,(
    antisym: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > $o ) )).

thf(sy_c_Relation_Oinv__image,type,(
    inv_image: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__set__sum,type,(
    sum_rec_set_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T > $o ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_c_Wellfounded_Olex__prod,type,(
    lex_prod: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_t,type,(
    t2: dtree )).

thf(sy_v_tr1,type,(
    tr1: dtree )).

thf(sy_v_tr2,type,(
    tr2: dtree )).

%----Relevant facts (256)
thf(fact_0_par__r_Ocases,axiom,(
    ! [X: ( product_prod @ dtree @ dtree )] :
      ~ ( ! [Tr1: dtree,Tr2: dtree] :
            ( X
           != ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) )).

% par_r.cases
thf(fact_1_par__r_Oinduct,axiom,(
    ! [P: ( ( product_prod @ dtree @ dtree ) > $o ),A0: ( product_prod @ dtree @ dtree )] :
      ( ! [Tr1: dtree,Tr2: dtree] :
          ( P @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
     => ( P @ A0 ) ) )).

% par_r.induct
thf(fact_2__092_060open_062Inr_A_N_096_Acont_A_Itr1_A_092_060parallel_062_Atr2_J_A_061_Apar_A_096_A_IInr_A_N_096_Acont_Atr1_A_092_060times_062_AInr_A_N_096_Acont_Atr2_J_092_060close_062,axiom,
    ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1 @ tr2 ) ) ) )
    = ( image @ ( product_prod @ dtree @ dtree ) @ dtree @ parall1899940088le_par
      @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ tr1 ) )
        @ ^ [Uu: dtree] :
            ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ tr2 ) ) ) ) )).

% \<open>Inr -` cont (tr1 \<parallel> tr2) = par ` (Inr -` cont tr1 \<times> Inr -` cont tr2)\<close>
thf(fact_3_SigmaI,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: ( set @ A ),B2: B,B3: ( A > ( set @ B ) )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( member @ B @ B2 @ ( B3 @ A2 ) )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) ) ) ) )).

% SigmaI
thf(fact_4_mem__Sigma__iff,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: ( set @ A ),B3: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
      = ( ( member @ A @ A2 @ A3 )
        & ( member @ B @ B2 @ ( B3 @ A2 ) ) ) ) )).

% mem_Sigma_iff
thf(fact_5_image__ident,axiom,(
    ! [A: $tType,Y: ( set @ A )] :
      ( ( image @ A @ A
        @ ^ [X2: A] : X2
        @ Y )
      = Y ) )).

% image_ident
thf(fact_6_Inr__cont__par,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )
      = ( image @ ( product_prod @ dtree @ dtree ) @ dtree @ parall1899940088le_par
        @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr12 ) )
          @ ^ [Uu: dtree] :
              ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr22 ) ) ) ) ) )).

% Inr_cont_par
thf(fact_7_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X22: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X22 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X22 = Y2 ) ) )).

% sum.inject(2)
thf(fact_8_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B4: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B4 ) )
      = ( B2 = B4 ) ) )).

% old.sum.inject(2)
thf(fact_9_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B,A3: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( member @ B @ X @ A3 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A3 ) ) ) ) )).

% image_eqI
thf(fact_10_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y2 ) ) ) )).

% prod.inject
thf(fact_11_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A4: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A4 @ B4 ) )
      = ( ( A2 = A4 )
        & ( B2 = B4 ) ) ) )).

% old.prod.inject
thf(fact_12_SigmaE,axiom,(
    ! [A: $tType,B: $tType,C2: ( product_prod @ A @ B ),A3: ( set @ A ),B3: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ~ ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ! [Y3: B] :
                  ( ( member @ B @ Y3 @ ( B3 @ X3 ) )
                 => ( C2
                   != ( product_Pair @ A @ B @ X3 @ Y3 ) ) ) ) ) ) )).

% SigmaE
thf(fact_13_SigmaD1,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: ( set @ A ),B3: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ( member @ A @ A2 @ A3 ) ) )).

% SigmaD1
thf(fact_14_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: A,B3: ( set @ A )] :
      ( ( ( F @ A2 )
        = B2 )
     => ( ( member @ A @ B2 @ B3 )
       => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ B3 ) ) ) ) )).

% vimageI
thf(fact_15_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
      = ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimage_eq
thf(fact_16_vimage__ident,axiom,(
    ! [A: $tType,Y: ( set @ A )] :
      ( ( vimage @ A @ A
        @ ^ [X2: A] : X2
        @ Y )
      = Y ) )).

% vimage_ident
thf(fact_17_vimage__Collect__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),P: ( B > $o )] :
      ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
      = ( collect @ A
        @ ^ [Y4: A] :
            ( P @ ( F @ Y4 ) ) ) ) )).

% vimage_Collect_eq
thf(fact_18_vimageD,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),A3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ A3 ) )
     => ( member @ B @ ( F @ A2 ) @ A3 ) ) )).

% vimageD
thf(fact_19_vimageE,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
     => ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimageE
thf(fact_20_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,A3: ( set @ A )] :
      ( ( member @ A @ ( F @ A2 ) @ A3 )
     => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ A3 ) ) ) )).

% vimageI2
thf(fact_21_vimage__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( vimage @ A @ B )
      = ( ^ [F2: ( A > B ),B5: ( set @ B )] :
            ( collect @ A
            @ ^ [X2: A] :
                ( member @ B @ ( F2 @ X2 ) @ B5 ) ) ) ) )).

% vimage_def
thf(fact_22_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_23_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B6: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B6 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_24_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y5: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B6: B] :
            ( Y5
           != ( product_Pair @ A @ B @ A5 @ B6 ) ) ) )).

% old.prod.exhaust
thf(fact_25_prod__induct7,axiom,(
    ! [G: $tType,F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) )] :
      ( ! [A5: A,B6: B,C3: C,D2: D,E2: E,F4: F3,G2: G] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G ) @ E2 @ ( product_Pair @ F3 @ G @ F4 @ G2 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_26_prod__induct6,axiom,(
    ! [F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ( ! [A5: A,B6: B,C3: C,D2: D,E2: E,F4: F3] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_27_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A5: A,B6: B,C3: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_28_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A5: A,B6: B,C3: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_29_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B6: B,C3: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B6 @ C3 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_30_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,G: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) )] :
      ~ ( ! [A5: A,B6: B,C3: C,D2: D,E2: E,F4: F3,G2: G] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G ) @ E2 @ ( product_Pair @ F3 @ G @ F4 @ G2 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_31_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ~ ( ! [A5: A,B6: B,C3: C,D2: D,E2: E,F4: F3] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_32_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A5: A,B6: B,C3: C,D2: D,E2: E] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_33_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A5: A,B6: B,C3: C,D2: D] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_34_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y5: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B6: B,C3: C] :
            ( Y5
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B6 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_35_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A4: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ~ ( ( A2 = A4 )
         => ( B2 != B4 ) ) ) )).

% Pair_inject
thf(fact_36_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A5: A,B6: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B6 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_37_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y3: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y3 ) ) )).

% surj_pair
thf(fact_38_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A3: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X @ A3 )
     => ( ( B2
          = ( F @ X ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A3 ) ) ) ) )).

% rev_image_eqI
thf(fact_39_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A3 ) )
         => ( P @ X3 ) )
     => ! [X4: B] :
          ( ( member @ B @ X4 @ A3 )
         => ( P @ ( F @ X4 ) ) ) ) )).

% ball_imageD
thf(fact_40_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F: ( A > B ),G3: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N )
           => ( ( F @ X3 )
              = ( G3 @ X3 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G3 @ N ) ) ) ) )).

% image_cong
thf(fact_41_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A3 ) )
          & ( P @ X4 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A3 )
          & ( P @ ( F @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_42_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z: A,F: ( B > A ),A3: ( set @ B )] :
      ( ( member @ A @ Z @ ( image @ B @ A @ F @ A3 ) )
      = ( ? [X2: B] :
            ( ( member @ B @ X2 @ A3 )
            & ( Z
              = ( F @ X2 ) ) ) ) ) )).

% image_iff
thf(fact_43_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A3: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A3 )
     => ( member @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A3 ) ) ) )).

% imageI
thf(fact_44_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y5: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y5 ) )
     => ( X = Y5 ) ) )).

% Inr_inject
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G3: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G3 @ X3 ) )
     => ( F = G3 ) ) )).

% ext
thf(fact_49_Compr__image__eq,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),P: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( member @ A @ X2 @ ( image @ B @ A @ F @ A3 ) )
            & ( P @ X2 ) ) )
      = ( image @ B @ A @ F
        @ ( collect @ B
          @ ^ [X2: B] :
              ( ( member @ B @ X2 @ A3 )
              & ( P @ ( F @ X2 ) ) ) ) ) ) )).

% Compr_image_eq
thf(fact_50_image__image,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),G3: ( C > B ),A3: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G3 @ A3 ) )
      = ( image @ C @ A
        @ ^ [X2: C] :
            ( F @ ( G3 @ X2 ) )
        @ A3 ) ) )).

% image_image
thf(fact_51_imageE,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),A3: ( set @ B )] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ F @ A3 ) )
     => ~ ( ! [X3: B] :
              ( ( B2
                = ( F @ X3 ) )
             => ~ ( member @ B @ X3 @ A3 ) ) ) ) )).

% imageE
thf(fact_52_Times__eq__cancel2,axiom,(
    ! [A: $tType,B: $tType,X: A,C4: ( set @ A ),A3: ( set @ B ),B3: ( set @ B )] :
      ( ( member @ A @ X @ C4 )
     => ( ( ( product_Sigma @ B @ A @ A3
            @ ^ [Uu: B] : C4 )
          = ( product_Sigma @ B @ A @ B3
            @ ^ [Uu: B] : C4 ) )
        = ( A3 = B3 ) ) ) )).

% Times_eq_cancel2
thf(fact_53_Sigma__cong,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ A ),B3: ( set @ A ),C4: ( A > ( set @ B ) ),D3: ( A > ( set @ B ) )] :
      ( ( A3 = B3 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ B3 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( product_Sigma @ A @ B @ A3 @ C4 )
          = ( product_Sigma @ A @ B @ B3 @ D3 ) ) ) ) )).

% Sigma_cong
thf(fact_54_SigmaE2,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: ( set @ A ),B3: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ~ ( ( member @ A @ A2 @ A3 )
         => ~ ( member @ B @ B2 @ ( B3 @ A2 ) ) ) ) )).

% SigmaE2
thf(fact_55_SigmaD2,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: ( set @ A ),B3: ( A > ( set @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
     => ( member @ B @ B2 @ ( B3 @ A2 ) ) ) )).

% SigmaD2
thf(fact_56_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_57_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F22 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_58_member__product,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B ),A3: ( set @ A ),B3: ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ X @ ( product_product @ A @ B @ A3 @ B3 ) )
      = ( member @ ( product_prod @ A @ B ) @ X
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : B3 ) ) ) )).

% member_product
thf(fact_59_Product__Type_Oproduct__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_product @ A @ B )
      = ( ^ [A6: ( set @ A ),B5: ( set @ B )] :
            ( product_Sigma @ A @ B @ A6
            @ ^ [Uu: A] : B5 ) ) ) )).

% Product_Type.product_def
thf(fact_60_Sup_OSUP__identity__eq,axiom,(
    ! [A: $tType,Sup: ( ( set @ A ) > A ),A3: ( set @ A )] :
      ( ( Sup
        @ ( image @ A @ A
          @ ^ [X2: A] : X2
          @ A3 ) )
      = ( Sup @ A3 ) ) )).

% Sup.SUP_identity_eq
thf(fact_61_Inf_OINF__identity__eq,axiom,(
    ! [A: $tType,Inf: ( ( set @ A ) > A ),A3: ( set @ A )] :
      ( ( Inf
        @ ( image @ A @ A
          @ ^ [X2: A] : X2
          @ A3 ) )
      = ( Inf @ A3 ) ) )).

% Inf.INF_identity_eq
thf(fact_62_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X2: A,Y4: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ R ) )
        = ( ^ [X2: A,Y4: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ S ) ) )
      = ( R = S ) ) )).

% pred_equals_eq2
thf(fact_63_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C2 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_64_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F @ ( sum_Inr @ B @ A @ X ) )
      = ( F @ X ) ) )).

% Sumr.simps
thf(fact_65_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y5: A] :
      ( ( X != Y5 )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y5 ) ) ) )).

% not_arg_cong_Inr
thf(fact_66_Inl__in__cont__par,axiom,(
    ! [T2: t,Tr12: dtree,Tr22: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )
      = ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr12 ) )
        | ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr22 ) ) ) ) )).

% Inl_in_cont_par
thf(fact_67_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_68_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: A,A4: A] :
      ( ( ( sum_Inl @ A @ B @ A2 )
        = ( sum_Inl @ A @ B @ A4 ) )
      = ( A2 = A4 ) ) )).

% old.sum.inject(1)
thf(fact_69_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A2: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( F1 @ A2 ) ) )).

% old.sum.simps(7)
thf(fact_70_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y5: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y5 ) )
     => ( X = Y5 ) ) )).

% Inl_inject
thf(fact_71_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S2: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S2
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [X3: B] :
              ( S2
             != ( sum_Inr @ B @ A @ X3 ) ) ) ) )).

% obj_sumE
thf(fact_72_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),G3: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F )
        = ( sum_Sumr @ B @ C @ A @ G3 ) )
     => ( F = G3 ) ) )).

% Sumr_inject
thf(fact_73_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X22 ) ) )).

% sum.distinct(1)
thf(fact_74_old_Osum_Odistinct_I2_J,axiom,(
    ! [B7: $tType,A7: $tType,B8: B7,A8: A7] :
      ( ( sum_Inr @ B7 @ A7 @ B8 )
     != ( sum_Inl @ A7 @ B7 @ A8 ) ) )).

% old.sum.distinct(2)
thf(fact_75_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: A,B4: B] :
      ( ( sum_Inl @ A @ B @ A2 )
     != ( sum_Inr @ B @ A @ B4 ) ) )).

% old.sum.distinct(1)
thf(fact_76_sumE,axiom,(
    ! [A: $tType,B: $tType,S2: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S2
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [Y3: B] :
              ( S2
             != ( sum_Inr @ B @ A @ Y3 ) ) ) ) )).

% sumE
thf(fact_77_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A2: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A2 ) ) )).

% Inr_not_Inl
thf(fact_78_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X5: ( sum_sum @ A @ B )] :
            ( P3 @ X5 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X2: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X2 ) )
            | ? [X2: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X2 ) ) ) ) ) )).

% split_sum_ex
thf(fact_79_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X5: ( sum_sum @ A @ B )] :
            ( P3 @ X5 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X2: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X2 ) )
            & ! [X2: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X2 ) ) ) ) ) )).

% split_sum_all
thf(fact_80_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y5: ( sum_sum @ A @ B )] :
      ( ! [A5: A] :
          ( Y5
         != ( sum_Inl @ A @ B @ A5 ) )
     => ~ ( ! [B6: B] :
              ( Y5
             != ( sum_Inr @ B @ A @ B6 ) ) ) ) )).

% old.sum.exhaust
thf(fact_81_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A5: A] :
          ( P @ ( sum_Inl @ A @ B @ A5 ) )
     => ( ! [B6: B] :
            ( P @ ( sum_Inr @ B @ A @ B6 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_82_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A3: ( set @ B ),B3: ( set @ B ),C4: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A3 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C4 @ A3 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B3 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_83_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A3: ( set @ B ),B3: ( set @ B ),C4: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A3 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C4 @ A3 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B3 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_84_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y5: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y5 ) ) )).

% Inl_Inr_False
thf(fact_85_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y5: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y5 ) ) )).

% Inr_Inl_False
thf(fact_86_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ ( sum_sum @ A @ B ) ),B3: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A3 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B3 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A3 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B3 ) )
       => ( A3 = B3 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_87_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S2: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X3: A] :
          ( ( S2
            = ( F @ ( sum_Inl @ A @ C @ X3 ) ) )
         => P )
     => ( ! [X3: C] :
            ( ( S2
              = ( F @ ( sum_Inr @ C @ A @ X3 ) ) )
           => P )
       => ! [X4: ( sum_sum @ A @ C )] :
            ( ( S2
              = ( F @ X4 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_88_Inl__cont__par,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr12 ) @ ( cont @ Tr22 ) ) ) ) )).

% Inl_cont_par
thf(fact_89_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X ) )
      = ( F @ X ) ) )).

% Suml.simps
thf(fact_90_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B2: A,F: ( B > A ),X: B,C2: C,G3: ( B > C ),A3: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( C2
          = ( G3 @ X ) )
       => ( ( member @ B @ X @ A3 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A3 @ F @ G3 ) ) ) ) ) )).

% image2_eqI
thf(fact_91_Un__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
      = ( ( member @ A @ C2 @ A3 )
        | ( member @ A @ C2 @ B3 ) ) ) )).

% Un_iff
thf(fact_92_UnCI,axiom,(
    ! [A: $tType,C2: A,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B3 )
       => ( member @ A @ C2 @ A3 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% UnCI
thf(fact_93_vimage__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A3: ( set @ B ),B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ A3 ) @ ( vimage @ A @ B @ F @ B3 ) ) ) )).

% vimage_Un
thf(fact_94_Sigma__Un__distrib1,axiom,(
    ! [B: $tType,A: $tType,I: ( set @ A ),J: ( set @ A ),C4: ( A > ( set @ B ) )] :
      ( ( product_Sigma @ A @ B @ ( sup_sup @ ( set @ A ) @ I @ J ) @ C4 )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ C4 ) @ ( product_Sigma @ A @ B @ J @ C4 ) ) ) )).

% Sigma_Un_distrib1
thf(fact_95_Collect__disj__eq,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            | ( Q @ X2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_disj_eq
thf(fact_96_Un__def,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A6 )
                | ( member @ A @ X2 @ B5 ) ) ) ) ) )).

% Un_def
thf(fact_97_Sigma__Un__distrib2,axiom,(
    ! [B: $tType,A: $tType,I: ( set @ A ),A3: ( A > ( set @ B ) ),B3: ( A > ( set @ B ) )] :
      ( ( product_Sigma @ A @ B @ I
        @ ^ [I2: A] :
            ( sup_sup @ ( set @ B ) @ ( A3 @ I2 ) @ ( B3 @ I2 ) ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ ( product_Sigma @ A @ B @ I @ A3 ) @ ( product_Sigma @ A @ B @ I @ B3 ) ) ) )).

% Sigma_Un_distrib2
thf(fact_98_Times__Un__distrib1,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ A ),B3: ( set @ A ),C4: ( set @ B )] :
      ( ( product_Sigma @ A @ B @ ( sup_sup @ ( set @ A ) @ A3 @ B3 )
        @ ^ [Uu: A] : C4 )
      = ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu: A] : C4 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu: A] : C4 ) ) ) )).

% Times_Un_distrib1
thf(fact_99_Un__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A3 @ C4 ) ) ) )).

% Un_left_commute
thf(fact_100_Un__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) )).

% Un_left_absorb
thf(fact_101_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A6 ) ) ) )).

% Un_commute
thf(fact_102_Un__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Un_absorb
thf(fact_103_Un__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ C4 )
      = ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Un_assoc
thf(fact_104_ball__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
           => ( P @ X2 ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ( P @ X2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ B3 )
           => ( P @ X2 ) ) ) ) )).

% ball_Un
thf(fact_105_bex__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
            & ( P @ X2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( P @ X2 ) )
        | ? [X2: A] :
            ( ( member @ A @ X2 @ B3 )
            & ( P @ X2 ) ) ) ) )).

% bex_Un
thf(fact_106_UnI2,axiom,(
    ! [A: $tType,C2: A,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ C2 @ B3 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% UnI2
thf(fact_107_UnI1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% UnI1
thf(fact_108_UnE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
     => ( ~ ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% UnE
thf(fact_109_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G3: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G3 ) )
     => ( F = G3 ) ) )).

% Suml_inject
thf(fact_110_image__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),B3: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F @ A3 ) @ ( image @ B @ A @ F @ B3 ) ) ) )).

% image_Un
thf(fact_111_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G4: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G4 @ X2 ) ) ) ) ) )).

% sup_apply
thf(fact_112_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_113_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_114_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.left_idem
thf(fact_115_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y5: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y5 ) )
          = ( sup_sup @ A @ X @ Y5 ) ) ) )).

% sup_left_idem
thf(fact_116_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.right_idem
thf(fact_117_sup__Un__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ A @ B ) )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X2: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ R )
        @ ^ [X2: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ S ) )
      = ( ^ [X2: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R @ S ) ) ) ) )).

% sup_Un_eq2
thf(fact_118_sup__set__def,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( collect @ A
            @ ( sup_sup @ ( A > $o )
              @ ^ [X2: A] :
                  ( member @ A @ X2 @ A6 )
              @ ^ [X2: A] :
                  ( member @ A @ X2 @ B5 ) ) ) ) ) )).

% sup_set_def
thf(fact_119_sup__Un__eq,axiom,(
    ! [A: $tType,R: ( set @ A ),S: ( set @ A )] :
      ( ( sup_sup @ ( A > $o )
        @ ^ [X2: A] :
            ( member @ A @ X2 @ R )
        @ ^ [X2: A] :
            ( member @ A @ X2 @ S ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ R @ S ) ) ) ) )).

% sup_Un_eq
thf(fact_120_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y5: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y5 @ Z ) )
          = ( sup_sup @ A @ Y5 @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_left_commute
thf(fact_121_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A2 @ C2 ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) )).

% sup.left_commute
thf(fact_122_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X2 ) ) ) ) )).

% sup_commute
thf(fact_123_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A9: A,B9: A] :
              ( sup_sup @ A @ B9 @ A9 ) ) ) ) )).

% sup.commute
thf(fact_124_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y5: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y5 ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y5 @ Z ) ) ) ) )).

% sup_assoc
thf(fact_125_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ C2 )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) )).

% sup.assoc
thf(fact_126_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G4: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G4 @ X2 ) ) ) ) ) )).

% sup_fun_def
thf(fact_127_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X2 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_128_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y5: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y5 ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y5 @ Z ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_129_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y5: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y5 @ Z ) )
          = ( sup_sup @ A @ Y5 @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_130_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y5: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y5 ) )
          = ( sup_sup @ A @ X @ Y5 ) ) ) )).

% inf_sup_aci(8)
thf(fact_131_par__c_Oelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y5: ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) )] :
      ( ( ( parall1914194347_par_c @ X )
        = Y5 )
     => ~ ( ! [Tr1: dtree,Tr2: dtree] :
              ( ( X
                = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
             => ( Y5
               != ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr1 ) @ ( cont @ Tr2 ) ) ) )
                  @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
                    @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr1 ) )
                      @ ^ [Uu: dtree] :
                          ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr2 ) ) ) ) ) ) ) ) ) )).

% par_c.elims
thf(fact_132_par__c_Osimps,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( parall1914194347_par_c @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) )
      = ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr12 ) @ ( cont @ Tr22 ) ) ) )
        @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
          @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr12 ) )
            @ ^ [Uu: dtree] :
                ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr22 ) ) ) ) ) ) )).

% par_c.simps
thf(fact_133_par__c_Opelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y5: ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) )] :
      ( ( ( parall1914194347_par_c @ X )
        = Y5 )
     => ( ( accp @ ( product_prod @ dtree @ dtree ) @ parall1418634510_c_rel @ X )
       => ~ ( ! [Tr1: dtree,Tr2: dtree] :
                ( ( X
                  = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
               => ( ( Y5
                    = ( sup_sup @ ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) @ ( image @ t @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inl @ t @ ( product_prod @ dtree @ dtree ) ) @ ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr1 ) @ ( cont @ Tr2 ) ) ) )
                      @ ( image @ ( product_prod @ dtree @ dtree ) @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( sum_Inr @ ( product_prod @ dtree @ dtree ) @ t )
                        @ ( product_Sigma @ dtree @ dtree @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr1 ) )
                          @ ^ [Uu: dtree] :
                              ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ Tr2 ) ) ) ) ) )
                 => ~ ( accp @ ( product_prod @ dtree @ dtree ) @ parall1418634510_c_rel @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) ) ) ) ) )).

% par_c.pelims
thf(fact_134_Plus__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B )
      = ( ^ [A6: ( set @ A ),B5: ( set @ B )] :
            ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A6 ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B5 ) ) ) ) )).

% Plus_def
thf(fact_135_sup2CI,axiom,(
    ! [A: $tType,B: $tType,B3: ( A > B > $o ),X: A,Y5: B,A3: ( A > B > $o )] :
      ( ( ~ ( B3 @ X @ Y5 )
       => ( A3 @ X @ Y5 ) )
     => ( sup_sup @ ( A > B > $o ) @ A3 @ B3 @ X @ Y5 ) ) )).

% sup2CI
thf(fact_136_sup1CI,axiom,(
    ! [A: $tType,B3: ( A > $o ),X: A,A3: ( A > $o )] :
      ( ( ~ ( B3 @ X )
       => ( A3 @ X ) )
     => ( sup_sup @ ( A > $o ) @ A3 @ B3 @ X ) ) )).

% sup1CI
thf(fact_137_InrI,axiom,(
    ! [B: $tType,A: $tType,B2: A,B3: ( set @ A ),A3: ( set @ B )] :
      ( ( member @ A @ B2 @ B3 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B2 ) @ ( sum_Plus @ B @ A @ A3 @ B3 ) ) ) )).

% InrI
thf(fact_138_InlI,axiom,(
    ! [A: $tType,B: $tType,A2: A,A3: ( set @ A ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A2 ) @ ( sum_Plus @ A @ B @ A3 @ B3 ) ) ) )).

% InlI
thf(fact_139_sup1E,axiom,(
    ! [A: $tType,A3: ( A > $o ),B3: ( A > $o ),X: A] :
      ( ( sup_sup @ ( A > $o ) @ A3 @ B3 @ X )
     => ( ~ ( A3 @ X )
       => ( B3 @ X ) ) ) )).

% sup1E
thf(fact_140_sup2E,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o ),B3: ( A > B > $o ),X: A,Y5: B] :
      ( ( sup_sup @ ( A > B > $o ) @ A3 @ B3 @ X @ Y5 )
     => ( ~ ( A3 @ X @ Y5 )
       => ( B3 @ X @ Y5 ) ) ) )).

% sup2E
thf(fact_141_sup1I1,axiom,(
    ! [A: $tType,A3: ( A > $o ),X: A,B3: ( A > $o )] :
      ( ( A3 @ X )
     => ( sup_sup @ ( A > $o ) @ A3 @ B3 @ X ) ) )).

% sup1I1
thf(fact_142_sup1I2,axiom,(
    ! [A: $tType,B3: ( A > $o ),X: A,A3: ( A > $o )] :
      ( ( B3 @ X )
     => ( sup_sup @ ( A > $o ) @ A3 @ B3 @ X ) ) )).

% sup1I2
thf(fact_143_sup2I1,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o ),X: A,Y5: B,B3: ( A > B > $o )] :
      ( ( A3 @ X @ Y5 )
     => ( sup_sup @ ( A > B > $o ) @ A3 @ B3 @ X @ Y5 ) ) )).

% sup2I1
thf(fact_144_sup2I2,axiom,(
    ! [A: $tType,B: $tType,B3: ( A > B > $o ),X: A,Y5: B,A3: ( A > B > $o )] :
      ( ( B3 @ X @ Y5 )
     => ( sup_sup @ ( A > B > $o ) @ A3 @ B3 @ X @ Y5 ) ) )).

% sup2I2
thf(fact_145_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A3: ( set @ A ),B3: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A3 @ B3 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( U
             != ( sum_Inl @ A @ B @ X3 ) ) )
       => ~ ( ! [Y3: B] :
                ( ( member @ B @ Y3 @ B3 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y3 ) ) ) ) ) ) )).

% PlusE
thf(fact_146_reflclp__idemp,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ( sup_sup @ ( A > A > $o ) @ P
          @ ^ [Y6: A,Z2: A] : ( Y6 = Z2 ) )
        @ ^ [Y6: A,Z2: A] : ( Y6 = Z2 ) )
      = ( sup_sup @ ( A > A > $o ) @ P
        @ ^ [Y6: A,Z2: A] : ( Y6 = Z2 ) ) ) )).

% reflclp_idemp
thf(fact_147_accp_Ocases,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),A2: A] :
      ( ( accp @ A @ R2 @ A2 )
     => ! [Y7: A] :
          ( ( R2 @ Y7 @ A2 )
         => ( accp @ A @ R2 @ Y7 ) ) ) )).

% accp.cases
thf(fact_148_accp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( accp @ A )
      = ( ^ [R3: ( A > A > $o ),A9: A] :
          ? [X2: A] :
            ( ( A9 = X2 )
            & ! [Y4: A] :
                ( ( R3 @ Y4 @ X2 )
               => ( accp @ A @ R3 @ Y4 ) ) ) ) ) )).

% accp.simps
thf(fact_149_accp_Ointros,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),X: A] :
      ( ! [Y3: A] :
          ( ( R2 @ Y3 @ X )
         => ( accp @ A @ R2 @ Y3 ) )
     => ( accp @ A @ R2 @ X ) ) )).

% accp.intros
thf(fact_150_accp__induct__rule,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),A2: A,P: ( A > $o )] :
      ( ( accp @ A @ R2 @ A2 )
     => ( ! [X3: A] :
            ( ( accp @ A @ R2 @ X3 )
           => ( ! [Y7: A] :
                  ( ( R2 @ Y7 @ X3 )
                 => ( P @ Y7 ) )
             => ( P @ X3 ) ) )
       => ( P @ A2 ) ) ) )).

% accp_induct_rule
thf(fact_151_not__accp__down,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A] :
      ( ~ ( accp @ A @ R @ X )
     => ~ ( ! [Z3: A] :
              ( ( R @ Z3 @ X )
             => ( accp @ A @ R @ Z3 ) ) ) ) )).

% not_accp_down
thf(fact_152_accp__downward,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),B2: A,A2: A] :
      ( ( accp @ A @ R2 @ B2 )
     => ( ( R2 @ A2 @ B2 )
       => ( accp @ A @ R2 @ A2 ) ) ) )).

% accp_downward
thf(fact_153_accp_Oinducts,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),X: A,P: ( A > $o )] :
      ( ( accp @ A @ R2 @ X )
     => ( ! [X3: A] :
            ( ! [Y7: A] :
                ( ( R2 @ Y7 @ X3 )
               => ( accp @ A @ R2 @ Y7 ) )
           => ( ! [Y7: A] :
                  ( ( R2 @ Y7 @ X3 )
                 => ( P @ Y7 ) )
             => ( P @ X3 ) ) )
       => ( P @ X ) ) ) )).

% accp.inducts
thf(fact_154_accp__induct,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),A2: A,P: ( A > $o )] :
      ( ( accp @ A @ R2 @ A2 )
     => ( ! [X3: A] :
            ( ( accp @ A @ R2 @ X3 )
           => ( ! [Y7: A] :
                  ( ( R2 @ Y7 @ X3 )
                 => ( P @ Y7 ) )
             => ( P @ X3 ) ) )
       => ( P @ A2 ) ) ) )).

% accp_induct
thf(fact_155_in__lex__prod,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A4: A,B4: B,R2: ( set @ ( product_prod @ A @ A ) ),S2: ( set @ ( product_prod @ B @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Pair @ A @ B @ A4 @ B4 ) ) @ ( lex_prod @ A @ B @ R2 @ S2 ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A4 ) @ R2 )
        | ( ( A2 = A4 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B4 ) @ S2 ) ) ) ) )).

% in_lex_prod
thf(fact_156_reflcl__set__eq,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ( sup_sup @ ( A > A > $o )
        @ ^ [X2: A,Y4: A] :
            ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R2 )
        @ ^ [Y6: A,Z2: A] : ( Y6 = Z2 ) )
      = ( ^ [X2: A,Y4: A] :
            ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ ( id @ A ) ) ) ) ) )).

% reflcl_set_eq
thf(fact_157_par__def,axiom,
    ( parall1899940088le_par
    = ( unfold @ ( product_prod @ dtree @ dtree ) @ parall1914194362_par_r @ parall1914194347_par_c ) )).

% par_def
thf(fact_158_IdI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( id @ A ) ) )).

% IdI
thf(fact_159_pair__in__Id__conv,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id @ A ) )
      = ( A2 = B2 ) ) )).

% pair_in_Id_conv
thf(fact_160_IdE,axiom,(
    ! [A: $tType,P2: ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P2 @ ( id @ A ) )
     => ~ ( ! [X3: A] :
              ( P2
             != ( product_Pair @ A @ A @ X3 @ X3 ) ) ) ) )).

% IdE
thf(fact_161_IdD,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id @ A ) )
     => ( A2 = B2 ) ) )).

% IdD
thf(fact_162_same__fstI,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),X: A,Y8: B,Y5: B,R: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ( P @ X )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y8 @ Y5 ) @ ( R @ X ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y8 ) @ ( product_Pair @ A @ B @ X @ Y5 ) ) @ ( same_fst @ A @ B @ P @ R ) ) ) ) )).

% same_fstI
thf(fact_163_antisym__reflcl,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ( antisym @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R2 @ ( id @ A ) ) )
      = ( antisym @ A @ R2 ) ) )).

% antisym_reflcl
thf(fact_164_pair__imageI,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: A,B2: B,A3: ( set @ ( product_prod @ A @ B ) ),F: ( A > B > C )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ A3 )
     => ( member @ C @ ( F @ A2 @ B2 ) @ ( image @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F ) @ A3 ) ) ) )).

% pair_imageI
thf(fact_165_case__prodI,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A2: A,B2: B] :
      ( ( F @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% case_prodI
thf(fact_166_case__prodI2,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B ),C2: ( A > B > $o )] :
      ( ! [A5: A,B6: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A5 @ B6 ) )
         => ( C2 @ A5 @ B6 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P2 ) ) )).

% case_prodI2
thf(fact_167_mem__case__prodI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Z: A,C2: ( B > C > ( set @ A ) ),A2: B,B2: C] :
      ( ( member @ A @ Z @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) )).

% mem_case_prodI
thf(fact_168_mem__case__prodI2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( product_prod @ A @ B ),Z: C,C2: ( A > B > ( set @ C ) )] :
      ( ! [A5: A,B6: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A5 @ B6 ) )
         => ( member @ C @ Z @ ( C2 @ A5 @ B6 ) ) )
     => ( member @ C @ Z @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P2 ) ) ) )).

% mem_case_prodI2
thf(fact_169_case__prodI2_H,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P2: ( product_prod @ A @ B ),C2: ( A > B > C > $o ),X: C] :
      ( ! [A5: A,B6: B] :
          ( ( ( product_Pair @ A @ B @ A5 @ B6 )
            = P2 )
         => ( C2 @ A5 @ B6 @ X ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ X ) ) )).

% case_prodI2'
thf(fact_170_Collect__case__prod,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),Q: ( B > $o )] :
      ( ( collect @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [A9: A,B9: B] :
              ( ( P @ A9 )
              & ( Q @ B9 ) ) ) )
      = ( product_Sigma @ A @ B @ ( collect @ A @ P )
        @ ^ [Uu: A] :
            ( collect @ B @ Q ) ) ) )).

% Collect_case_prod
thf(fact_171_case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F @ A2 @ B2 ) ) )).

% case_prod_conv
thf(fact_172_lex__prod__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: ( set @ ( product_prod @ A @ A ) ),Rb: ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A9: A,B9: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A10: A,B10: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A9 @ A10 ) @ Ra )
                        | ( ( A9 = A10 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B9 @ B10 ) @ Rb ) ) ) ) ) ) ) ) ) )).

% lex_prod_def
thf(fact_173_case__prodD_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R: ( A > B > C > $o ),A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R @ A2 @ B2 @ C2 ) ) )).

% case_prodD'
thf(fact_174_case__prodE_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( A > B > C > $o ),P2: ( product_prod @ A @ B ),Z: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ Z )
     => ~ ( ! [X3: A,Y3: B] :
              ( ( P2
                = ( product_Pair @ A @ B @ X3 @ Y3 ) )
             => ~ ( C2 @ X3 @ Y3 @ Z ) ) ) ) )).

% case_prodE'
thf(fact_175_case__prodE2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Q: ( A > $o ),P: ( B > C > A ),Z: ( product_prod @ B @ C )] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( Z
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( Q @ ( P @ X3 @ Y3 ) ) ) ) ) )).

% case_prodE2
thf(fact_176_case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X2: A,Y4: B] :
            ( F @ ( product_Pair @ A @ B @ X2 @ Y4 ) ) )
      = F ) )).

% case_prod_eta
thf(fact_177_cond__case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),G3: ( ( product_prod @ A @ B ) > C )] :
      ( ! [X3: A,Y3: B] :
          ( ( F @ X3 @ Y3 )
          = ( G3 @ ( product_Pair @ A @ B @ X3 @ Y3 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F )
        = G3 ) ) )).

% cond_case_prod_eta
thf(fact_178_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z: A,C2: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( member @ A @ Z @ ( C2 @ X3 @ Y3 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_179_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F @ X1 @ X22 ) ) )).

% old.prod.case
thf(fact_180_same__fst__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P4: ( A > $o ),R4: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X6: A,Y9: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X2: A,Y4: B] :
                        ( ( X6 = X2 )
                        & ( P4 @ X2 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y9 @ Y4 ) @ ( R4 @ X2 ) ) ) ) ) ) ) ) ) )).

% same_fst_def
thf(fact_181_antisym__Id,axiom,(
    ! [A: $tType] :
      ( antisym @ A @ ( id @ A ) ) )).

% antisym_Id
thf(fact_182_antisymD,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),A2: A,B2: A] :
      ( ( antisym @ A @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R2 )
       => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ A2 ) @ R2 )
         => ( A2 = B2 ) ) ) ) )).

% antisymD
thf(fact_183_antisymI,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ! [X3: A,Y3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y3 ) @ R2 )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X3 ) @ R2 )
           => ( X3 = Y3 ) ) )
     => ( antisym @ A @ R2 ) ) )).

% antisymI
thf(fact_184_antisym__def,axiom,(
    ! [A: $tType] :
      ( ( antisym @ A )
      = ( ^ [R3: ( set @ ( product_prod @ A @ A ) )] :
          ! [X2: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R3 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ X2 ) @ R3 )
             => ( X2 = Y4 ) ) ) ) ) )).

% antisym_def
thf(fact_185_case__prod__Pair__iden,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P2 )
      = P2 ) )).

% case_prod_Pair_iden
thf(fact_186_case__prodD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F @ A2 @ B2 ) ) )).

% case_prodD
thf(fact_187_case__prodE,axiom,(
    ! [A: $tType,B: $tType,C2: ( A > B > $o ),P2: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P2 )
     => ~ ( ! [X3: A,Y3: B] :
              ( ( P2
                = ( product_Pair @ A @ B @ X3 @ Y3 ) )
             => ~ ( C2 @ X3 @ Y3 ) ) ) ) )).

% case_prodE
thf(fact_188_Collect__case__prod__Sigma,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),Q: ( A > B > $o )] :
      ( ( collect @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X2: A,Y4: B] :
              ( ( P @ X2 )
              & ( Q @ X2 @ Y4 ) ) ) )
      = ( product_Sigma @ A @ B @ ( collect @ A @ P )
        @ ^ [X2: A] :
            ( collect @ B @ ( Q @ X2 ) ) ) ) )).

% Collect_case_prod_Sigma
thf(fact_189_case__prod__app,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F2: ( B > C > D > A ),X2: ( product_prod @ B @ C ),Y4: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L: B,R3: C] :
                ( F2 @ L @ R3 @ Y4 )
            @ X2 ) ) ) )).

% case_prod_app
thf(fact_190_prod_Ocase__distrib,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: ( C > D ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X12: A,X23: B] :
            ( H @ ( F @ X12 @ X23 ) )
        @ Prod ) ) )).

% prod.case_distrib
thf(fact_191_antisymP__equality,axiom,(
    ! [A: $tType] :
      ( antisym @ A
      @ ( collect @ ( product_prod @ A @ A )
        @ ( product_case_prod @ A @ A @ $o
          @ ^ [Y6: A,Z2: A] : ( Y6 = Z2 ) ) ) ) )).

% antisymP_equality
thf(fact_192_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_193_swap__product,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ B ),B3: ( set @ A )] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [I2: B,J2: A] :
              ( product_Pair @ A @ B @ J2 @ I2 ) )
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu: B] : B3 ) )
      = ( product_Sigma @ A @ B @ B3
        @ ^ [Uu: A] : A3 ) ) )).

% swap_product
thf(fact_194_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F: ( A > B > C ),G3: ( A > B > C ),P2: ( product_prod @ A @ B )] :
      ( ! [X3: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y3 )
            = Q2 )
         => ( ( F @ X3 @ Y3 )
            = ( G3 @ X3 @ Y3 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F @ P2 )
          = ( product_case_prod @ A @ B @ C @ G3 @ Q2 ) ) ) ) )).

% split_cong
thf(fact_195_case__swap,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B > A ),P2: ( product_prod @ C @ B )] :
      ( ( product_case_prod @ B @ C @ A
        @ ^ [Y4: B,X2: C] :
            ( F @ X2 @ Y4 )
        @ ( product_swap @ C @ B @ P2 ) )
      = ( product_case_prod @ C @ B @ A @ F @ P2 ) ) )).

% case_swap
thf(fact_196_case__prod__curry,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C @ ( product_curry @ A @ B @ C @ F ) )
      = F ) )).

% case_prod_curry
thf(fact_197_curryI,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( product_curry @ A @ B @ $o @ F @ A2 @ B2 ) ) )).

% curryI
thf(fact_198_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P2 ) )
      = P2 ) )).

% swap_swap
thf(fact_199_split__part,axiom,(
    ! [B: $tType,A: $tType,P: $o,Q: ( A > B > $o )] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A9: A,B9: B] :
            ( P
            & ( Q @ A9 @ B9 ) ) )
      = ( ^ [Ab: ( product_prod @ A @ B )] :
            ( P
            & ( product_case_prod @ A @ B @ $o @ Q @ Ab ) ) ) ) )).

% split_part
thf(fact_200_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X: B,Y5: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y5 ) )
      = ( product_Pair @ A @ B @ Y5 @ X ) ) )).

% swap_simp
thf(fact_201_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F2: ( ( product_prod @ B @ C ) > A ),A9: B,B9: C] :
            ( F2 @ ( product_Pair @ B @ C @ A9 @ B9 ) ) ) ) )).

% curry_conv
thf(fact_202_curry__case__prod,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C )] :
      ( ( product_curry @ A @ B @ C @ ( product_case_prod @ A @ B @ C @ F ) )
      = F ) )).

% curry_case_prod
thf(fact_203_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y5: A,X: B,A3: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y5 @ X ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A3 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y5 ) @ A3 ) ) )).

% pair_in_swap_image
thf(fact_204_prod_Odisc__eq__case,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu: A,Uv: B] : $true
      @ Prod ) )).

% prod.disc_eq_case
thf(fact_205_curry__K,axiom,(
    ! [B: $tType,C: $tType,A: $tType,C2: C] :
      ( ( product_curry @ A @ B @ C
        @ ^ [X2: ( product_prod @ A @ B )] : C2 )
      = ( ^ [X2: A,Y4: B] : C2 ) ) )).

% curry_K
thf(fact_206_curryE,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryE
thf(fact_207_curryD,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryD
thf(fact_208_product__swap,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ B ),B3: ( set @ A )] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A )
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu: B] : B3 ) )
      = ( product_Sigma @ A @ B @ B3
        @ ^ [Uu: A] : A3 ) ) )).

% product_swap
thf(fact_209_curry__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_curry @ A @ B @ C )
      = ( ^ [C5: ( ( product_prod @ A @ B ) > C ),X2: A,Y4: B] :
            ( C5 @ ( product_Pair @ A @ B @ X2 @ Y4 ) ) ) ) )).

% curry_def
thf(fact_210_inv__image__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( inv_image @ B @ A )
      = ( ^ [R3: ( set @ ( product_prod @ B @ B ) ),F2: ( A > B )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y4: A] :
                  ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ X2 ) @ ( F2 @ Y4 ) ) @ R3 ) ) ) ) ) )).

% inv_image_def
thf(fact_211_map__prod__surj__on,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( B > A ),A3: ( set @ B ),A11: ( set @ A ),G3: ( D > C ),B3: ( set @ D ),B11: ( set @ C )] :
      ( ( ( image @ B @ A @ F @ A3 )
        = A11 )
     => ( ( ( image @ D @ C @ G3 @ B3 )
          = B11 )
       => ( ( image @ ( product_prod @ B @ D ) @ ( product_prod @ A @ C ) @ ( product_map_prod @ B @ A @ D @ C @ F @ G3 )
            @ ( product_Sigma @ B @ D @ A3
              @ ^ [Uu: B] : B3 ) )
          = ( product_Sigma @ A @ C @ A11
            @ ^ [Uu: A] : B11 ) ) ) ) )).

% map_prod_surj_on
thf(fact_212_map__prod__ident,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [Y4: B] : Y4 )
      = ( ^ [Z4: ( product_prod @ A @ B )] : Z4 ) ) )).

% map_prod_ident
thf(fact_213_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G3: ( D > B ),A2: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F @ G3 @ ( product_Pair @ C @ D @ A2 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F @ A2 ) @ ( G3 @ B2 ) ) ) )).

% map_prod_simp
thf(fact_214_in__inv__image,axiom,(
    ! [A: $tType,B: $tType,X: A,Y5: A,R2: ( set @ ( product_prod @ B @ B ) ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y5 ) @ ( inv_image @ B @ A @ R2 @ F ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X ) @ ( F @ Y5 ) ) @ R2 ) ) )).

% in_inv_image
thf(fact_215_map__prod__imageI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A2: A,B2: B,R: ( set @ ( product_prod @ A @ B ) ),F: ( A > C ),G3: ( B > D )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F @ A2 ) @ ( G3 @ B2 ) ) @ ( image @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G3 ) @ R ) ) ) )).

% map_prod_imageI
thf(fact_216_case__prod__map__prod,axiom,(
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,H: ( B > C > A ),F: ( D > B ),G3: ( E > C ),X: ( product_prod @ D @ E )] :
      ( ( product_case_prod @ B @ C @ A @ H @ ( product_map_prod @ D @ B @ E @ C @ F @ G3 @ X ) )
      = ( product_case_prod @ D @ E @ A
        @ ^ [L: D,R3: E] :
            ( H @ ( F @ L ) @ ( G3 @ R3 ) )
        @ X ) ) )).

% case_prod_map_prod
thf(fact_217_prod__fun__imageE,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C2: ( product_prod @ A @ B ),F: ( C > A ),G3: ( D > B ),R: ( set @ ( product_prod @ C @ D ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F @ G3 ) @ R ) )
     => ~ ( ! [X3: C,Y3: D] :
              ( ( C2
                = ( product_Pair @ A @ B @ ( F @ X3 ) @ ( G3 @ Y3 ) ) )
             => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X3 @ Y3 ) @ R ) ) ) ) )).

% prod_fun_imageE
thf(fact_218_map__prod__def,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( product_map_prod @ A @ C @ B @ D )
      = ( ^ [F2: ( A > C ),G4: ( B > D )] :
            ( product_case_prod @ A @ B @ ( product_prod @ C @ D )
            @ ^ [X2: A,Y4: B] :
                ( product_Pair @ C @ D @ ( F2 @ X2 ) @ ( G4 @ Y4 ) ) ) ) ) )).

% map_prod_def
thf(fact_219_rp__inv__image__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R4: ( set @ ( product_prod @ A @ A ) ),S3: ( set @ ( product_prod @ A @ A ) ),F2: ( B > A )] :
            ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R4 @ F2 ) @ ( inv_image @ A @ B @ S3 @ F2 ) ) ) ) )).

% rp_inv_image_def
thf(fact_220_prod_Omap__ident,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [X2: B] : X2
        @ T2 )
      = T2 ) )).

% prod.map_ident
thf(fact_221_surj__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% surj_swap
thf(fact_222_The__split__eq,axiom,(
    ! [A: $tType,B: $tType,X: A,Y5: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X6: A,Y9: B] :
              ( ( X = X6 )
              & ( Y5 = Y9 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y5 ) ) )).

% The_split_eq
thf(fact_223_UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_224_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_225_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_226_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_227_UNIV__Plus__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) ) )).

% UNIV_Plus_UNIV
thf(fact_228_UNIV__Times__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_Sigma @ A @ B @ ( top_top @ ( set @ A ) )
        @ ^ [Uu: A] :
            ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% UNIV_Times_UNIV
thf(fact_229_UNIV__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X2: A] : $true ) ) )).

% UNIV_def
thf(fact_230_rangeE,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A )] :
      ( ( member @ A @ B2 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) )
     => ~ ( ! [X3: B] :
              ( B2
             != ( F @ X3 ) ) ) ) )).

% rangeE
thf(fact_231_range__composition,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),G3: ( B > C )] :
      ( ( image @ B @ A
        @ ^ [X2: B] :
            ( F @ ( G3 @ X2 ) )
        @ ( top_top @ ( set @ B ) ) )
      = ( image @ C @ A @ F @ ( image @ B @ C @ G3 @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_composition
thf(fact_232_rangeI,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X: B] :
      ( member @ A @ ( F @ X ) @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_233_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B] :
      ( ( B2
        = ( F @ X ) )
     => ( member @ A @ B2 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_234_Un__UNIV__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B3 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_235_Un__UNIV__right,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_236_UNIV__eq__I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A3 )
     => ( ( top_top @ ( set @ A ) )
        = A3 ) ) )).

% UNIV_eq_I
thf(fact_237_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_238_UNIV__sum,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( top_top @ ( set @ ( sum_sum @ A @ B ) ) )
      = ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ ( top_top @ ( set @ A ) ) ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ ( top_top @ ( set @ B ) ) ) ) ) )).

% UNIV_sum
thf(fact_239_map__prod__surj,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( A > B ),G3: ( C > D )] :
      ( ( ( image @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ B ) ) )
     => ( ( ( image @ C @ D @ G3 @ ( top_top @ ( set @ C ) ) )
          = ( top_top @ ( set @ D ) ) )
       => ( ( image @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F @ G3 ) @ ( top_top @ ( set @ ( product_prod @ A @ C ) ) ) )
          = ( top_top @ ( set @ ( product_prod @ B @ D ) ) ) ) ) ) )).

% map_prod_surj
thf(fact_240_old_Orec__sum__def,axiom,(
    ! [B: $tType,T: $tType,A: $tType] :
      ( ( sum_rec_sum @ A @ T @ B )
      = ( ^ [F12: ( A > T ),F23: ( B > T ),X2: ( sum_sum @ A @ B )] :
            ( the @ T @ ( sum_rec_set_sum @ A @ T @ B @ F12 @ F23 @ X2 ) ) ) ) )).

% old.rec_sum_def
thf(fact_241_old_Orec__prod__def,axiom,(
    ! [T: $tType,B: $tType,A: $tType] :
      ( ( product_rec_prod @ A @ B @ T )
      = ( ^ [F12: ( A > B > T ),X2: ( product_prod @ A @ B )] :
            ( the @ T @ ( product_rec_set_prod @ A @ B @ T @ F12 @ X2 ) ) ) ) )).

% old.rec_prod_def
thf(fact_242_top__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X2: A,Y4: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y4 ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% top_empty_eq2
thf(fact_243_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_244_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_245_the__sym__eq__trivial,axiom,(
    ! [A: $tType,X: A] :
      ( ( the @ A
        @ ( ^ [Y6: A,Z2: A] : ( Y6 = Z2 )
          @ X ) )
      = X ) )).

% the_sym_eq_trivial
thf(fact_246_the__eq__trivial,axiom,(
    ! [A: $tType,A2: A] :
      ( ( the @ A
        @ ^ [X2: A] : ( X2 = A2 ) )
      = A2 ) )).

% the_eq_trivial
thf(fact_247_the__equality,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A] :
      ( ( P @ A2 )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ( X3 = A2 ) )
       => ( ( the @ A @ P )
          = A2 ) ) ) )).

% the_equality
thf(fact_248_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X ) )
      = P ) )).

% top_conj(2)
thf(fact_249_top__conj_I1_J,axiom,(
    ! [A: $tType,X: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_250_theI,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A] :
      ( ( P @ A2 )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ( X3 = A2 ) )
       => ( P @ ( the @ A @ P ) ) ) ) )).

% theI
thf(fact_251_theI_H,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( P @ ( the @ A @ P ) ) ) )).

% theI'
thf(fact_252_theI2,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A,Q: ( A > $o )] :
      ( ( P @ A2 )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ( X3 = A2 ) )
       => ( ! [X3: A] :
              ( ( P @ X3 )
             => ( Q @ X3 ) )
         => ( Q @ ( the @ A @ P ) ) ) ) ) )).

% theI2
thf(fact_253_If__def,axiom,(
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P4: $o,X2: A,Y4: A] :
            ( the @ A
            @ ^ [Z4: A] :
                ( ( P4
                 => ( Z4 = X2 ) )
                & ( ~ ( P4 )
                 => ( Z4 = Y4 ) ) ) ) ) ) )).

% If_def
thf(fact_254_the1I2,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q @ X3 ) )
       => ( Q @ ( the @ A @ P ) ) ) ) )).

% the1I2
thf(fact_255_the1__equality,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A] :
      ( ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y3: A] :
              ( ( P @ Y3 )
             => ( Y3 = X4 ) ) )
     => ( ( P @ A2 )
       => ( ( the @ A @ P )
          = A2 ) ) ) )).

% the1_equality

%----Type constructors (12)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A7: $tType] :
      ( bounded_lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A7: $tType,A12: $tType] :
      ( ( bounded_lattice @ A12 @ ( type2 @ A12 ) )
     => ( bounded_lattice @ ( A7 > A12 ) @ ( type2 @ ( A7 > A12 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A7: $tType,A12: $tType] :
      ( ( bounded_lattice @ A12 @ ( type2 @ A12 ) )
     => ( bounded_lattice_top @ ( A7 > A12 ) @ ( type2 @ ( A7 > A12 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A7: $tType,A12: $tType] :
      ( ( semilattice_sup @ A12 @ ( type2 @ A12 ) )
     => ( semilattice_sup @ ( A7 > A12 ) @ ( type2 @ ( A7 > A12 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A7: $tType,A12: $tType] :
      ( ( lattice @ A12 @ ( type2 @ A12 ) )
     => ( lattice @ ( A7 > A12 ) @ ( type2 @ ( A7 > A12 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_3,axiom,(
    ! [A7: $tType] :
      ( bounded_lattice_top @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_4,axiom,(
    ! [A7: $tType] :
      ( semilattice_sup @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_5,axiom,(
    ! [A7: $tType] :
      ( lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_6,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_7,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_8,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y5: A] :
      ( ( if @ A @ $false @ X @ Y5 )
      = Y5 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y5: A] :
      ( ( if @ A @ $true @ X @ Y5 )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ t2 ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1 @ tr2 ) ) ) )
    = ( member @ dtree @ t2
      @ ( image @ ( product_prod @ dtree @ dtree ) @ dtree @ parall1899940088le_par
        @ ( product_Sigma @ dtree @ dtree
          @ ( collect @ dtree
            @ ^ [X2: dtree] :
                ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ X2 ) @ ( cont @ tr1 ) ) )
          @ ^ [Uu: dtree] :
              ( collect @ dtree
              @ ^ [X2: dtree] :
                  ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ X2 ) @ ( cont @ tr2 ) ) ) ) ) ) )).

%------------------------------------------------------------------------------
