%------------------------------------------------------------------------------
% File     : COM205^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Parallel extension to grammars and languages 84
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : parallel__84.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  359 (   0 unit;  67 type;   0 defn)
%            Number of atoms       : 4491 ( 268 equality;2708 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 4240 (  68   ~;   7   |;  30   &;3873   @)
%                                         (   0 <=>; 262  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  287 ( 287   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   70 (  67   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1207 (   1 sgn;1075   !;  15   ?;  43   ^)
%                                         (1207   :;  74  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:38:58.086
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_FSet_Ofset,type,(
    fset: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_DTree_ON,type,(
    n: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (58)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Odistrib__lattice,type,(
    distrib_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_DTree_ONode,type,(
    node: n > ( set @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Ocorec,type,(
    corec: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_ONNode,type,(
    nNode: n > ( fset @ ( sum_sum @ t @ dtree ) ) > dtree )).

thf(sy_c_DTree_Odtree_Ocase__dtree,type,(
    case_dtree: 
      !>[A: $tType] :
        ( ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ) > dtree > A ) )).

thf(sy_c_DTree_Odtree_Occont,type,(
    ccont: dtree > ( fset @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_DTree_Odtree_Ocorec__dtree,type,(
    corec_dtree: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( fset @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ) > A > dtree ) )).

thf(sy_c_DTree_Odtree_Oroot,type,(
    root: dtree > n )).

thf(sy_c_DTree_Ounfold,type,(
    unfold: 
      !>[A: $tType] :
        ( ( A > n ) > ( A > ( set @ ( sum_sum @ t @ A ) ) ) > A > dtree ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_ONplus,type,(
    parall1518086719_Nplus: n > n > n )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar,type,(
    parall1899940088le_par: ( product_prod @ dtree @ dtree ) > dtree )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__c,type,(
    parall1914194347_par_c: ( product_prod @ dtree @ dtree ) > ( set @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) ) )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__r,type,(
    parall1914194362_par_r: ( product_prod @ dtree @ dtree ) > n )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar__r__rel,type,(
    parall556292031_r_rel: ( product_prod @ dtree @ dtree ) > ( product_prod @ dtree @ dtree ) > $o )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_c_Wellfounded_Olex__prod,type,(
    lex_prod: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_Wfrec_Oadm__wf,type,(
    adm_wf: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( ( A > B ) > A > B ) > $o ) )).

thf(sy_c_Wfrec_Ocut,type,(
    cut: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ ( product_prod @ A @ A ) ) > A > A > B ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_tr1a____,type,(
    tr1a: dtree )).

thf(sy_v_tr2a____,type,(
    tr2a: dtree )).

thf(sy_v_trA____,type,(
    trA: dtree )).

thf(sy_v_trB____,type,(
    trB: dtree )).

%----Relevant facts (256)
thf(fact_0_Nplus__comm,axiom,
    ( parall1518086719_Nplus
    = ( ^ [A2: n,B2: n] :
          ( parall1518086719_Nplus @ B2 @ A2 ) ) )).

% Nplus_comm
thf(fact_1_Nplus__assoc,axiom,(
    ! [A3: n,B3: n,C2: n] :
      ( ( parall1518086719_Nplus @ ( parall1518086719_Nplus @ A3 @ B3 ) @ C2 )
      = ( parall1518086719_Nplus @ A3 @ ( parall1518086719_Nplus @ B3 @ C2 ) ) ) )).

% Nplus_assoc
thf(fact_2_par__r_Oelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y: n] :
      ( ( ( parall1914194362_par_r @ X )
        = Y )
     => ~ ( ! [Tr1: dtree,Tr2: dtree] :
              ( ( X
                = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
             => ( Y
               != ( parall1518086719_Nplus @ ( root @ Tr1 ) @ ( root @ Tr2 ) ) ) ) ) ) )).

% par_r.elims
thf(fact_3_par__r_Osimps,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( parall1914194362_par_r @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) )
      = ( parall1518086719_Nplus @ ( root @ Tr12 ) @ ( root @ Tr22 ) ) ) )).

% par_r.simps
thf(fact_4_root__Node,axiom,(
    ! [N: n,As: ( set @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( node @ N @ As ) )
      = N ) )).

% root_Node
thf(fact_5_root__par,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( root @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) )
      = ( parall1518086719_Nplus @ ( root @ Tr12 ) @ ( root @ Tr22 ) ) ) )).

% root_par
thf(fact_6_corec_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),B3: A] :
      ( ( root @ ( corec @ A @ Rt @ Ct @ B3 ) )
      = ( Rt @ B3 ) ) )).

% corec(1)
thf(fact_7_unfold_I1_J,axiom,(
    ! [A: $tType,Rt: ( A > n ),Ct: ( A > ( set @ ( sum_sum @ t @ A ) ) ),B3: A] :
      ( ( root @ ( unfold @ A @ Rt @ Ct @ B3 ) )
      = ( Rt @ B3 ) ) )).

% unfold(1)
thf(fact_8_dtree_Osel_I1_J,axiom,(
    ! [X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( root @ ( nNode @ X1 @ X2 ) )
      = X1 ) )).

% dtree.sel(1)
thf(fact_9_dtree_Ocorec__sel_I1_J,axiom,(
    ! [A: $tType,G1: ( A > n ),G2: ( A > ( fset @ ( sum_sum @ t @ ( sum_sum @ dtree @ A ) ) ) ),A3: A] :
      ( ( root @ ( corec_dtree @ A @ G1 @ G2 @ A3 ) )
      = ( G1 @ A3 ) ) )).

% dtree.corec_sel(1)
thf(fact_10_dtree_Oexpand,axiom,(
    ! [Dtree: dtree,Dtree2: dtree] :
      ( ( ( ( root @ Dtree )
          = ( root @ Dtree2 ) )
        & ( ( ccont @ Dtree )
          = ( ccont @ Dtree2 ) ) )
     => ( Dtree = Dtree2 ) ) )).

% dtree.expand
thf(fact_11_par__r_Opelims,axiom,(
    ! [X: ( product_prod @ dtree @ dtree ),Y: n] :
      ( ( ( parall1914194362_par_r @ X )
        = Y )
     => ( ( accp @ ( product_prod @ dtree @ dtree ) @ parall556292031_r_rel @ X )
       => ~ ( ! [Tr1: dtree,Tr2: dtree] :
                ( ( X
                  = ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
               => ( ( Y
                    = ( parall1518086719_Nplus @ ( root @ Tr1 ) @ ( root @ Tr2 ) ) )
                 => ~ ( accp @ ( product_prod @ dtree @ dtree ) @ parall556292031_r_rel @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) ) ) ) ) )).

% par_r.pelims
thf(fact_12_dtree__cong,axiom,(
    ! [Tr: dtree,Tr3: dtree] :
      ( ( ( root @ Tr )
        = ( root @ Tr3 ) )
     => ( ( ( cont @ Tr )
          = ( cont @ Tr3 ) )
       => ( Tr = Tr3 ) ) ) )).

% dtree_cong
thf(fact_13_dtree_Ocollapse,axiom,(
    ! [Dtree: dtree] :
      ( ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) )
      = Dtree ) )).

% dtree.collapse
thf(fact_14__092_060open_062_092_060exists_062tr1_Atr2_O_AtrA_A_061_Atr1_A_092_060parallel_062_Atr2_A_092_060and_062_AtrB_A_061_Atr2_A_092_060parallel_062_Atr1_092_060close_062,axiom,(
    ? [Tr1: dtree,Tr2: dtree] :
      ( ( trA
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) )
      & ( trB
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr2 @ Tr1 ) ) ) ) )).

% \<open>\<exists>tr1 tr2. trA = tr1 \<parallel> tr2 \<and> trB = tr2 \<parallel> tr1\<close>
thf(fact_15_dtree_Oinject,axiom,(
    ! [X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) ),Y1: n,Y2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( ( nNode @ X1 @ X2 )
        = ( nNode @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% dtree.inject
thf(fact_16_Node__root__cont,axiom,(
    ! [Tr: dtree] :
      ( ( node @ ( root @ Tr ) @ ( cont @ Tr ) )
      = Tr ) )).

% Node_root_cont
thf(fact_17_dtree_Osel_I2_J,axiom,(
    ! [X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( ccont @ ( nNode @ X1 @ X2 ) )
      = X2 ) )).

% dtree.sel(2)
thf(fact_18_dtree_Oexhaust,axiom,(
    ! [Y: dtree] :
      ~ ( ! [X12: n,X22: ( fset @ ( sum_sum @ t @ dtree ) )] :
            ( Y
           != ( nNode @ X12 @ X22 ) ) ) )).

% dtree.exhaust
thf(fact_19_dtree_Ocorec__disc,axiom,(
    ! [A: $tType] :
      ( ( corec_dtree @ A )
      = ( corec_dtree @ A ) ) )).

% dtree.corec_disc
thf(fact_20_par__r_Ocases,axiom,(
    ! [X: ( product_prod @ dtree @ dtree )] :
      ~ ( ! [Tr1: dtree,Tr2: dtree] :
            ( X
           != ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) )).

% par_r.cases
thf(fact_21_par__r_Oinduct,axiom,(
    ! [P: ( ( product_prod @ dtree @ dtree ) > $o ),A0: ( product_prod @ dtree @ dtree )] :
      ( ! [Tr1: dtree,Tr2: dtree] :
          ( P @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
     => ( P @ A0 ) ) )).

% par_r.induct
thf(fact_22_dtree_Oexhaust__sel,axiom,(
    ! [Dtree: dtree] :
      ( Dtree
      = ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) ) )).

% dtree.exhaust_sel
thf(fact_23_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X2 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% prod.inject
thf(fact_24_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A4: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A4 @ B4 ) )
      = ( ( A3 = A4 )
        & ( B3 = B4 ) ) ) )).

% old.prod.inject
thf(fact_25_dtree_Osplit__sel,axiom,(
    ! [A: $tType,P: ( A > $o ),F: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),Dtree: dtree] :
      ( ( P @ ( case_dtree @ A @ F @ Dtree ) )
      = ( ( Dtree
          = ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) )
       => ( P @ ( F @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) ) ) ) )).

% dtree.split_sel
thf(fact_26_dtree_Osplit__sel__asm,axiom,(
    ! [A: $tType,P: ( A > $o ),F: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),Dtree: dtree] :
      ( ( P @ ( case_dtree @ A @ F @ Dtree ) )
      = ( ~ ( ( Dtree
              = ( nNode @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) )
            & ~ ( P @ ( F @ ( root @ Dtree ) @ ( ccont @ Dtree ) ) ) ) ) ) )).

% dtree.split_sel_asm
thf(fact_27_par__def,axiom,
    ( parall1899940088le_par
    = ( unfold @ ( product_prod @ dtree @ dtree ) @ parall1914194362_par_r @ parall1914194347_par_c ) )).

% par_def
thf(fact_28_dtree_Ocase__eq__if,axiom,(
    ! [A: $tType] :
      ( ( case_dtree @ A )
      = ( ^ [F2: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),Dtree3: dtree] :
            ( F2 @ ( root @ Dtree3 ) @ ( ccont @ Dtree3 ) ) ) ) )).

% dtree.case_eq_if
thf(fact_29_accp_Ocases,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A3: A] :
      ( ( accp @ A @ R @ A3 )
     => ! [Y3: A] :
          ( ( R @ Y3 @ A3 )
         => ( accp @ A @ R @ Y3 ) ) ) )).

% accp.cases
thf(fact_30_accp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( accp @ A )
      = ( ^ [R2: ( A > A > $o ),A2: A] :
          ? [X3: A] :
            ( ( A2 = X3 )
            & ! [Y4: A] :
                ( ( R2 @ Y4 @ X3 )
               => ( accp @ A @ R2 @ Y4 ) ) ) ) ) )).

% accp.simps
thf(fact_31_accp_Ointros,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A] :
      ( ! [Y5: A] :
          ( ( R @ Y5 @ X )
         => ( accp @ A @ R @ Y5 ) )
     => ( accp @ A @ R @ X ) ) )).

% accp.intros
thf(fact_32_accp__induct,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A3: A,P: ( A > $o )] :
      ( ( accp @ A @ R @ A3 )
     => ( ! [X4: A] :
            ( ( accp @ A @ R @ X4 )
           => ( ! [Y3: A] :
                  ( ( R @ Y3 @ X4 )
                 => ( P @ Y3 ) )
             => ( P @ X4 ) ) )
       => ( P @ A3 ) ) ) )).

% accp_induct
thf(fact_33_accp_Oinducts,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,P: ( A > $o )] :
      ( ( accp @ A @ R @ X )
     => ( ! [X4: A] :
            ( ! [Y3: A] :
                ( ( R @ Y3 @ X4 )
               => ( accp @ A @ R @ Y3 ) )
           => ( ! [Y3: A] :
                  ( ( R @ Y3 @ X4 )
                 => ( P @ Y3 ) )
             => ( P @ X4 ) ) )
       => ( P @ X ) ) ) )).

% accp.inducts
thf(fact_34_dtree_Ocase,axiom,(
    ! [A: $tType,F: ( n > ( fset @ ( sum_sum @ t @ dtree ) ) > A ),X1: n,X2: ( fset @ ( sum_sum @ t @ dtree ) )] :
      ( ( case_dtree @ A @ F @ ( nNode @ X1 @ X2 ) )
      = ( F @ X1 @ X2 ) ) )).

% dtree.case
thf(fact_35_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_36_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B5: B] :
            ( Y
           != ( product_Pair @ A @ B @ A5 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_37_prod__induct7,axiom,(
    ! [G: $tType,F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F4: F3,G3: G] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G ) @ E2 @ ( product_Pair @ F3 @ G @ F4 @ G3 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_38_prod__induct6,axiom,(
    ! [F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F4: F3] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_39_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_40_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_41_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B5: B,C3: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_42_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,G: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F4: F3,G3: G] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G ) @ E2 @ ( product_Pair @ F3 @ G @ F4 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_43_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D,E2: E,F4: F3] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_44_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A6 ) )
      = A6 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G4: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G4 @ X4 ) )
     => ( F = G4 ) ) )).

% ext
thf(fact_49_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A5: A,B5: B,C3: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_50_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B5: B,C3: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_51_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A4: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B3 )
        = ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ~ ( ( A3 = A4 )
         => ( B3 != B4 ) ) ) )).

% Pair_inject
thf(fact_52_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A5: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_53_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X4: A,Y5: B] :
      ( P2
      = ( product_Pair @ A @ B @ X4 @ Y5 ) ) )).

% surj_pair
thf(fact_54_accp__induct__rule,axiom,(
    ! [A: $tType,R: ( A > A > $o ),A3: A,P: ( A > $o )] :
      ( ( accp @ A @ R @ A3 )
     => ( ! [X4: A] :
            ( ( accp @ A @ R @ X4 )
           => ( ! [Y3: A] :
                  ( ( R @ Y3 @ X4 )
                 => ( P @ Y3 ) )
             => ( P @ X4 ) ) )
       => ( P @ A3 ) ) ) )).

% accp_induct_rule
thf(fact_55_not__accp__down,axiom,(
    ! [A: $tType,R3: ( A > A > $o ),X: A] :
      ( ~ ( accp @ A @ R3 @ X )
     => ~ ( ! [Z: A] :
              ( ( R3 @ Z @ X )
             => ( accp @ A @ R3 @ Z ) ) ) ) )).

% not_accp_down
thf(fact_56_accp__downward,axiom,(
    ! [A: $tType,R: ( A > A > $o ),B3: A,A3: A] :
      ( ( accp @ A @ R @ B3 )
     => ( ( R @ A3 @ B3 )
       => ( accp @ A @ R @ A3 ) ) ) )).

% accp_downward
thf(fact_57_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A3: A,B3: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( F1 @ A3 @ B3 ) ) )).

% old.prod.rec
thf(fact_58_in__lex__prod,axiom,(
    ! [A: $tType,B: $tType,A3: A,B3: B,A4: A,B4: B,R: ( set @ ( product_prod @ A @ A ) ),S: ( set @ ( product_prod @ B @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B3 ) @ ( product_Pair @ A @ B @ A4 @ B4 ) ) @ ( lex_prod @ A @ B @ R @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A4 ) @ R )
        | ( ( A3 = A4 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B3 @ B4 ) @ S ) ) ) ) )).

% in_lex_prod
thf(fact_59_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A3: B,B3: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A3 @ B3 ) )
      = ( C2 @ A3 @ B3 ) ) )).

% internal_case_prod_conv
thf(fact_60_Inl__in__cont__par,axiom,(
    ! [T2: t,Tr12: dtree,Tr22: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )
      = ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr12 ) )
        | ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr22 ) ) ) ) )).

% Inl_in_cont_par
thf(fact_61_cont__Node,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),N: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( cont @ ( node @ N @ As ) )
        = As ) ) )).

% cont_Node
thf(fact_62_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R3: ( set @ ( product_prod @ A @ B ) ),S2: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R3 )
     => ( ( S2 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R3 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_63_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F2: ( ( product_prod @ B @ C ) > A ),A2: B,B2: C] :
            ( F2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) )).

% curry_conv
thf(fact_64_finite__par__c,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ ( product_prod @ dtree @ dtree ) ) @ ( parall1914194347_par_c @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )).

% finite_par_c
thf(fact_65_curryI,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A3: A,B3: B] :
      ( ( F @ ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ( product_curry @ A @ B @ $o @ F @ A3 @ B3 ) ) )).

% curryI
thf(fact_66_dtree__simps,axiom,(
    ! [As: ( set @ ( sum_sum @ t @ dtree ) ),As2: ( set @ ( sum_sum @ t @ dtree ) ),N: n,N2: n] :
      ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As )
     => ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As2 )
       => ( ( ( node @ N @ As )
            = ( node @ N2 @ As2 ) )
          = ( ( N = N2 )
            & ( As = As2 ) ) ) ) ) )).

% dtree_simps
thf(fact_67_finite__cont,axiom,(
    ! [Tr: dtree] :
      ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ ( cont @ Tr ) ) )).

% finite_cont
thf(fact_68_dtree__cases,axiom,(
    ! [Tr: dtree] :
      ~ ( ! [N3: n,As3: ( set @ ( sum_sum @ t @ dtree ) )] :
            ( ( finite_finite2 @ ( sum_sum @ t @ dtree ) @ As3 )
           => ( Tr
             != ( node @ N3 @ As3 ) ) ) ) )).

% dtree_cases
thf(fact_69_curryD,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A3: A,B3: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A3 @ B3 )
     => ( F @ ( product_Pair @ A @ B @ A3 @ B3 ) ) ) )).

% curryD
thf(fact_70_curryE,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A3: A,B3: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A3 @ B3 )
     => ( F @ ( product_Pair @ A @ B @ A3 @ B3 ) ) ) )).

% curryE
thf(fact_71_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_72_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A3: A,A4: A] :
      ( ( ( sum_Inl @ A @ B @ A3 )
        = ( sum_Inl @ A @ B @ A4 ) )
      = ( A3 = A4 ) ) )).

% old.sum.inject(1)
thf(fact_73_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A7: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_74_same__fstI,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),X: A,Y6: B,Y: B,R3: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ( P @ X )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y ) @ ( R3 @ X ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y6 ) @ ( product_Pair @ A @ B @ X @ Y ) ) @ ( same_fst @ A @ B @ P @ R3 ) ) ) ) )).

% same_fstI
thf(fact_75_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_76_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A6 )
           => ? [X13: B] :
                ( P @ X4 @ X13 ) )
       => ? [F4: ( A > B )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A6 )
           => ( P @ X5 @ ( F4 @ X5 ) ) ) ) ) )).

% finite_set_choice
thf(fact_77_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A6: ( set @ A )] :
          ( finite_finite2 @ A @ A6 ) ) )).

% finite
thf(fact_78_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A3: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A3 ) )
      = ( F1 @ A3 ) ) )).

% old.sum.simps(7)
thf(fact_79_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X ) )
      = ( F @ X ) ) )).

% Suml.simps
thf(fact_80_finite__Plus__iff,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),B6: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A6 @ B6 ) )
      = ( ( finite_finite2 @ A @ A6 )
        & ( finite_finite2 @ B @ B6 ) ) ) )).

% finite_Plus_iff
thf(fact_81_adm__wf__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( adm_wf @ A @ B )
      = ( ^ [R4: ( set @ ( product_prod @ A @ A ) ),F5: ( ( A > B ) > A > B )] :
          ! [F2: ( A > B ),G5: ( A > B ),X3: A] :
            ( ! [Z2: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z2 @ X3 ) @ R4 )
               => ( ( F2 @ Z2 )
                  = ( G5 @ Z2 ) ) )
           => ( ( F5 @ F2 @ X3 )
              = ( F5 @ G5 @ X3 ) ) ) ) ) )).

% adm_wf_def
thf(fact_82_Inl__cont__par,axiom,(
    ! [Tr12: dtree,Tr22: dtree] :
      ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr12 ) @ ( cont @ Tr22 ) ) ) ) )).

% Inl_cont_par
thf(fact_83_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X ) ) )).

% swap_simp
thf(fact_84_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P2 ) )
      = P2 ) )).

% swap_swap
thf(fact_85_finite__Un,axiom,(
    ! [A: $tType,F6: ( set @ A ),G6: ( set @ A )] :
      ( ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ F6 @ G6 ) )
      = ( ( finite_finite2 @ A @ F6 )
        & ( finite_finite2 @ A @ G6 ) ) ) )).

% finite_Un
thf(fact_86_InlI,axiom,(
    ! [A: $tType,B: $tType,A3: A,A6: ( set @ A ),B6: ( set @ B )] :
      ( ( member @ A @ A3 @ A6 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A3 ) @ ( sum_Plus @ A @ B @ A6 @ B6 ) ) ) )).

% InlI
thf(fact_87_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G4: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G4 ) )
     => ( F = G4 ) ) )).

% Suml_inject
thf(fact_88_infinite__Un,axiom,(
    ! [A: $tType,S3: ( set @ A ),T3: ( set @ A )] :
      ( ( ~ ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ S3 @ T3 ) ) )
      = ( ~ ( finite_finite2 @ A @ S3 )
        | ~ ( finite_finite2 @ A @ T3 ) ) ) )).

% infinite_Un
thf(fact_89_Un__infinite,axiom,(
    ! [A: $tType,S3: ( set @ A ),T3: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S3 )
     => ~ ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ S3 @ T3 ) ) ) )).

% Un_infinite
thf(fact_90_finite__UnI,axiom,(
    ! [A: $tType,F6: ( set @ A ),G6: ( set @ A )] :
      ( ( finite_finite2 @ A @ F6 )
     => ( ( finite_finite2 @ A @ G6 )
       => ( finite_finite2 @ A @ ( sup_sup @ ( set @ A ) @ F6 @ G6 ) ) ) ) )).

% finite_UnI
thf(fact_91_finite__PlusD_I2_J,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),B6: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A6 @ B6 ) )
     => ( finite_finite2 @ B @ B6 ) ) )).

% finite_PlusD(2)
thf(fact_92_finite__PlusD_I1_J,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),B6: ( set @ B )] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A6 @ B6 ) )
     => ( finite_finite2 @ A @ A6 ) ) )).

% finite_PlusD(1)
thf(fact_93_finite__Plus,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),B6: ( set @ B )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ( finite_finite2 @ B @ B6 )
       => ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A6 @ B6 ) ) ) ) )).

% finite_Plus
thf(fact_94_vimage__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B ),B6: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( sup_sup @ ( set @ B ) @ A6 @ B6 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ A6 ) @ ( vimage @ A @ B @ F @ B6 ) ) ) )).

% vimage_Un
thf(fact_95_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A3: B,B3: A,B6: ( set @ A )] :
      ( ( ( F @ A3 )
        = B3 )
     => ( ( member @ A @ B3 @ B6 )
       => ( member @ B @ A3 @ ( vimage @ B @ A @ F @ B6 ) ) ) ) )).

% vimageI
thf(fact_96_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A3: A,F: ( A > B ),B6: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F @ B6 ) )
      = ( member @ B @ ( F @ A3 ) @ B6 ) ) )).

% vimage_eq
thf(fact_97_UnCI,axiom,(
    ! [A: $tType,C2: A,B6: ( set @ A ),A6: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B6 )
       => ( member @ A @ C2 @ A6 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) ) ) )).

% UnCI
thf(fact_98_Un__iff,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
      = ( ( member @ A @ C2 @ A6 )
        | ( member @ A @ C2 @ B6 ) ) ) )).

% Un_iff
thf(fact_99_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G5: ( A > B ),X3: A] :
              ( sup_sup @ B @ ( F2 @ X3 ) @ ( G5 @ X3 ) ) ) ) ) )).

% sup_apply
thf(fact_100_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A3 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A3 @ B3 ) ) ) )).

% sup.right_idem
thf(fact_101_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_102_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( sup_sup @ A @ A3 @ ( sup_sup @ A @ A3 @ B3 ) )
          = ( sup_sup @ A @ A3 @ B3 ) ) ) )).

% sup.left_idem
thf(fact_103_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_104_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( sup_sup @ A @ A3 @ A3 )
          = A3 ) ) )).

% sup.idem
thf(fact_105_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z3 ) ) ) ) )).

% sup_left_commute
thf(fact_106_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A,C2: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A3 @ C2 ) )
          = ( sup_sup @ A @ A3 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.left_commute
thf(fact_107_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X3: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X3 ) ) ) ) )).

% sup_commute
thf(fact_108_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A2: A,B2: A] :
              ( sup_sup @ A @ B2 @ A2 ) ) ) ) )).

% sup.commute
thf(fact_109_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z3 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% sup_assoc
thf(fact_110_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A3 @ B3 ) @ C2 )
          = ( sup_sup @ A @ A3 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.assoc
thf(fact_111_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G5: ( A > B ),X3: A] :
              ( sup_sup @ B @ ( F2 @ X3 ) @ ( G5 @ X3 ) ) ) ) ) )).

% sup_fun_def
thf(fact_112_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X3: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X3 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_113_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z3 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_114_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z3 ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_115_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_116_Un__left__commute,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ B6 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ B6 @ ( sup_sup @ ( set @ A ) @ A6 @ C4 ) ) ) )).

% Un_left_commute
thf(fact_117_Un__left__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
      = ( sup_sup @ ( set @ A ) @ A6 @ B6 ) ) )).

% Un_left_absorb
thf(fact_118_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B7 @ A7 ) ) ) )).

% Un_commute
thf(fact_119_Un__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ A6 )
      = A6 ) )).

% Un_absorb
thf(fact_120_Un__assoc,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) @ C4 )
      = ( sup_sup @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ B6 @ C4 ) ) ) )).

% Un_assoc
thf(fact_121_ball__Un,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( P @ X3 ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ B6 )
           => ( P @ X3 ) ) ) ) )).

% ball_Un
thf(fact_122_bex__Un,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ A6 )
            & ( P @ X3 ) )
        | ? [X3: A] :
            ( ( member @ A @ X3 @ B6 )
            & ( P @ X3 ) ) ) ) )).

% bex_Un
thf(fact_123_UnI2,axiom,(
    ! [A: $tType,C2: A,B6: ( set @ A ),A6: ( set @ A )] :
      ( ( member @ A @ C2 @ B6 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) ) ) )).

% UnI2
thf(fact_124_UnI1,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ A6 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) ) ) )).

% UnI1
thf(fact_125_UnE,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) )
     => ( ~ ( member @ A @ C2 @ A6 )
       => ( member @ A @ C2 @ B6 ) ) ) )).

% UnE
thf(fact_126_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ ( F @ X4 ) )
          = ( Q @ X4 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_127_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A3: B,A6: ( set @ A )] :
      ( ( member @ A @ ( F @ A3 ) @ A6 )
     => ( member @ B @ A3 @ ( vimage @ B @ A @ F @ A6 ) ) ) )).

% vimageI2
thf(fact_128_vimageE,axiom,(
    ! [A: $tType,B: $tType,A3: A,F: ( A > B ),B6: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F @ B6 ) )
     => ( member @ B @ ( F @ A3 ) @ B6 ) ) )).

% vimageE
thf(fact_129_vimageD,axiom,(
    ! [A: $tType,B: $tType,A3: A,F: ( A > B ),A6: ( set @ B )] :
      ( ( member @ A @ A3 @ ( vimage @ A @ B @ F @ A6 ) )
     => ( member @ B @ ( F @ A3 ) @ A6 ) ) )).

% vimageD
thf(fact_130_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y: A,X: B,A6: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A6 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ A6 ) ) )).

% pair_in_swap_image
thf(fact_131_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_132_cut__apply,axiom,(
    ! [B: $tType,A: $tType,X: A,A3: A,R3: ( set @ ( product_prod @ A @ A ) ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ A3 ) @ R3 )
     => ( ( cut @ A @ B @ F @ R3 @ A3 @ X )
        = ( F @ X ) ) ) )).

% cut_apply
thf(fact_133_cuts__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),R3: ( set @ ( product_prod @ A @ A ) ),X: A,G4: ( A > B )] :
      ( ( ( cut @ A @ B @ F @ R3 @ X )
        = ( cut @ A @ B @ G4 @ R3 @ X ) )
      = ( ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ X ) @ R3 )
           => ( ( F @ Y4 )
              = ( G4 @ Y4 ) ) ) ) ) )).

% cuts_eq
thf(fact_134_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B3: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B3 ) )
      = ( F22 @ B3 ) ) )).

% old.sum.simps(8)
thf(fact_135_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B3: B,B4: B] :
      ( ( ( sum_Inr @ B @ A @ B3 )
        = ( sum_Inr @ B @ A @ B4 ) )
      = ( B3 = B4 ) ) )).

% old.sum.inject(2)
thf(fact_136_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% sum.inject(2)
thf(fact_137_finite__imageI,axiom,(
    ! [B: $tType,A: $tType,F6: ( set @ A ),H: ( A > B )] :
      ( ( finite_finite2 @ A @ F6 )
     => ( finite_finite2 @ B @ ( image @ A @ B @ H @ F6 ) ) ) )).

% finite_imageI
thf(fact_138_InrI,axiom,(
    ! [B: $tType,A: $tType,B3: A,B6: ( set @ A ),A6: ( set @ B )] :
      ( ( member @ A @ B3 @ B6 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B3 ) @ ( sum_Plus @ B @ A @ A6 @ B6 ) ) ) )).

% InrI
thf(fact_139_curry__case__prod,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C )] :
      ( ( product_curry @ A @ B @ C @ ( product_case_prod @ A @ B @ C @ F ) )
      = F ) )).

% curry_case_prod
thf(fact_140_case__prod__curry,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C @ ( product_curry @ A @ B @ C @ F ) )
      = F ) )).

% case_prod_curry
thf(fact_141_image__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ B ),B6: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A6 @ B6 ) )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F @ A6 ) @ ( image @ B @ A @ F @ B6 ) ) ) )).

% image_Un
thf(fact_142_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X2 ) ) )).

% sum.distinct(1)
thf(fact_143_old_Osum_Odistinct_I2_J,axiom,(
    ! [B8: $tType,A8: $tType,B9: B8,A9: A8] :
      ( ( sum_Inr @ B8 @ A8 @ B9 )
     != ( sum_Inl @ A8 @ B8 @ A9 ) ) )).

% old.sum.distinct(2)
thf(fact_144_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A3: A,B4: B] :
      ( ( sum_Inl @ A @ B @ A3 )
     != ( sum_Inr @ B @ A @ B4 ) ) )).

% old.sum.distinct(1)
thf(fact_145_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X4: A] :
          ( S
         != ( sum_Inl @ A @ B @ X4 ) )
     => ~ ( ! [Y5: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y5 ) ) ) ) )).

% sumE
thf(fact_146_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B3: B,A3: A] :
      ( ( sum_Inr @ B @ A @ B3 )
     != ( sum_Inl @ A @ B @ A3 ) ) )).

% Inr_not_Inl
thf(fact_147_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X6: ( sum_sum @ A @ B )] :
            ( P3 @ X6 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X3: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X3 ) )
            | ? [X3: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X3 ) ) ) ) ) )).

% split_sum_ex
thf(fact_148_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X6: ( sum_sum @ A @ B )] :
            ( P3 @ X6 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X3: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X3 ) )
            & ! [X3: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X3 ) ) ) ) ) )).

% split_sum_all
thf(fact_149_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A5: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A5 ) )
     => ~ ( ! [B5: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B5 ) ) ) ) )).

% old.sum.exhaust
thf(fact_150_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A5: A] :
          ( P @ ( sum_Inl @ A @ B @ A5 ) )
     => ( ! [B5: B] :
            ( P @ ( sum_Inr @ B @ A @ B5 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_151_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_152_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z3: A,C2: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z3 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ( ! [X4: B,Y5: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X4 @ Y5 ) )
             => ~ ( member @ A @ Z3 @ ( C2 @ X4 @ Y5 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_153_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X1: A,X2: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X2 ) )
      = ( F @ X1 @ X2 ) ) )).

% old.prod.case
thf(fact_154_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A6: ( set @ A ),B6: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A6 @ B6 ) )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A6 )
           => ( U
             != ( sum_Inl @ A @ B @ X4 ) ) )
       => ~ ( ! [Y5: B] :
                ( ( member @ B @ Y5 @ B6 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y5 ) ) ) ) ) ) )).

% PlusE
thf(fact_155_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_156_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_157_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ ( sum_sum @ A @ B ) ),B6: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A6 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B6 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A6 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B6 ) )
       => ( A6 = B6 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_158_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X4: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X4 ) ) )
         => P )
     => ( ! [X4: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X4 ) ) )
           => P )
       => ! [X5: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X5 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_159_Plus__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B )
      = ( ^ [A7: ( set @ A ),B7: ( set @ B )] :
            ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A7 ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B7 ) ) ) ) )).

% Plus_def
thf(fact_160_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X4: A] :
          ( S
         != ( sum_Inl @ A @ B @ X4 ) )
     => ~ ( ! [X4: B] :
              ( S
             != ( sum_Inr @ B @ A @ X4 ) ) ) ) )).

% obj_sumE
thf(fact_161_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F: ( A > B > C ),G4: ( A > B > C ),P2: ( product_prod @ A @ B )] :
      ( ! [X4: A,Y5: B] :
          ( ( ( product_Pair @ A @ B @ X4 @ Y5 )
            = Q2 )
         => ( ( F @ X4 @ Y5 )
            = ( G4 @ X4 @ Y5 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F @ P2 )
          = ( product_case_prod @ A @ B @ C @ G4 @ Q2 ) ) ) ) )).

% split_cong
thf(fact_162_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F @ ( sum_Inr @ B @ A @ X ) )
      = ( F @ X ) ) )).

% Sumr.simps
thf(fact_163_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),G4: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F )
        = ( sum_Sumr @ B @ C @ A @ G4 ) )
     => ( F = G4 ) ) )).

% Sumr_inject
thf(fact_164_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B3: A,F: ( B > A ),X: B,C2: C,G4: ( B > C ),A6: ( set @ B )] :
      ( ( B3
        = ( F @ X ) )
     => ( ( C2
          = ( G4 @ X ) )
       => ( ( member @ B @ X @ A6 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B3 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A6 @ F @ G4 ) ) ) ) ) )).

% image2_eqI
thf(fact_165_surj__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% surj_swap
thf(fact_166_finite__vimageD,axiom,(
    ! [A: $tType,B: $tType,H: ( A > B ),F6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( vimage @ A @ B @ H @ F6 ) )
     => ( ( ( image @ A @ B @ H @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ B @ F6 ) ) ) )).

% finite_vimageD
thf(fact_167_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_168_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_169_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_170_UNIV__Plus__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) ) )).

% UNIV_Plus_UNIV
thf(fact_171_finite__Plus__UNIV__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( sum_sum @ A @ B ) @ ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_Plus_UNIV_iff
thf(fact_172_Un__UNIV__left,axiom,(
    ! [A: $tType,B6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B6 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_173_Un__UNIV__right,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_174_finite__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_UNIV
thf(fact_175_infinite__UNIV__char__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% infinite_UNIV_char_0
thf(fact_176_ex__new__if__finite,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ A @ A6 )
       => ? [A5: A] :
            ~ ( member @ A @ A5 @ A6 ) ) ) )).

% ex_new_if_finite
thf(fact_177_Finite__Set_Ofinite__set,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% Finite_Set.finite_set
thf(fact_178_finite__prod,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
        & ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) ) )).

% finite_prod
thf(fact_179_finite__Prod__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) )
       => ( finite_finite2 @ ( product_prod @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% finite_Prod_UNIV
thf(fact_180_finite__fun__UNIVD2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( finite_finite2 @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( finite_finite2 @ B @ ( top_top @ ( set @ B ) ) ) ) )).

% finite_fun_UNIVD2
thf(fact_181_UNIV__sum,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( top_top @ ( set @ ( sum_sum @ A @ B ) ) )
      = ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ ( top_top @ ( set @ A ) ) ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ ( top_top @ ( set @ B ) ) ) ) ) )).

% UNIV_sum
thf(fact_182_finite__option__UNIV,axiom,(
    ! [A: $tType] :
      ( ( finite_finite2 @ ( option @ A ) @ ( top_top @ ( set @ ( option @ A ) ) ) )
      = ( finite_finite2 @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% finite_option_UNIV
thf(fact_183_surj__image__vimage__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A6: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ F @ ( vimage @ B @ A @ F @ A6 ) )
        = A6 ) ) )).

% surj_image_vimage_eq
thf(fact_184_map__prod__surj,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( A > B ),G4: ( C > D )] :
      ( ( ( image @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ B ) ) )
     => ( ( ( image @ C @ D @ G4 @ ( top_top @ ( set @ C ) ) )
          = ( top_top @ ( set @ D ) ) )
       => ( ( image @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F @ G4 ) @ ( top_top @ ( set @ ( product_prod @ A @ C ) ) ) )
          = ( top_top @ ( set @ ( product_prod @ B @ D ) ) ) ) ) ) )).

% map_prod_surj
thf(fact_185_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G4: ( D > B ),A3: C,B3: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F @ G4 @ ( product_Pair @ C @ D @ A3 @ B3 ) )
      = ( product_Pair @ A @ B @ ( F @ A3 ) @ ( G4 @ B3 ) ) ) )).

% map_prod_simp
thf(fact_186_map__prod__imageI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A3: A,B3: B,R3: ( set @ ( product_prod @ A @ B ) ),F: ( A > C ),G4: ( B > D )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B3 ) @ R3 )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F @ A3 ) @ ( G4 @ B3 ) ) @ ( image @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G4 ) @ R3 ) ) ) )).

% map_prod_imageI
thf(fact_187_prod__fun__imageE,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C2: ( product_prod @ A @ B ),F: ( C > A ),G4: ( D > B ),R3: ( set @ ( product_prod @ C @ D ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F @ G4 ) @ R3 ) )
     => ~ ( ! [X4: C,Y5: D] :
              ( ( C2
                = ( product_Pair @ A @ B @ ( F @ X4 ) @ ( G4 @ Y5 ) ) )
             => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X4 @ Y5 ) @ R3 ) ) ) ) )).

% prod_fun_imageE
thf(fact_188_finite__vimageD_H,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ ( vimage @ A @ B @ F @ A6 ) )
     => ( ( ord_less_eq @ ( set @ B ) @ A6 @ ( image @ A @ B @ F @ ( top_top @ ( set @ A ) ) ) )
       => ( finite_finite2 @ B @ A6 ) ) ) )).

% finite_vimageD'
thf(fact_189_image__vimage__eq,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A6: ( set @ A )] :
      ( ( image @ B @ A @ F @ ( vimage @ B @ A @ F @ A6 ) )
      = ( inf_inf @ ( set @ A ) @ A6 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% image_vimage_eq
thf(fact_190_surj__vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A6: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( vimage @ B @ A @ F @ A6 )
          = ( bot_bot @ ( set @ B ) ) )
        = ( A6
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% surj_vimage_empty
thf(fact_191_le__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z3 )
          = ( ( ord_less_eq @ A @ X @ Z3 )
            & ( ord_less_eq @ A @ Y @ Z3 ) ) ) ) )).

% le_sup_iff
thf(fact_192_sup_Obounded__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A3 )
          = ( ( ord_less_eq @ A @ B3 @ A3 )
            & ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% sup.bounded_iff
thf(fact_193_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_194_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_195_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A3 )
          = A3 ) ) )).

% sup_bot.left_neutral
thf(fact_196_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( sup_sup @ A @ A3 @ ( bot_bot @ A ) )
          = A3 ) ) )).

% sup_bot.right_neutral
thf(fact_197_inf__sup__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) )).

% inf_sup_absorb
thf(fact_198_sup__inf__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) )).

% sup_inf_absorb
thf(fact_199_finite__Int,axiom,(
    ! [A: $tType,F6: ( set @ A ),G6: ( set @ A )] :
      ( ( ( finite_finite2 @ A @ F6 )
        | ( finite_finite2 @ A @ G6 ) )
     => ( finite_finite2 @ A @ ( inf_inf @ ( set @ A ) @ F6 @ G6 ) ) ) )).

% finite_Int
thf(fact_200_Un__empty,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A6 @ B6 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A6
          = ( bot_bot @ ( set @ A ) ) )
        & ( B6
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_201_Un__subset__iff,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) @ C4 )
      = ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
        & ( ord_less_eq @ ( set @ A ) @ B6 @ C4 ) ) ) )).

% Un_subset_iff
thf(fact_202_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_203_vimage__Int,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B ),B6: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( inf_inf @ ( set @ B ) @ A6 @ B6 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ A6 ) @ ( vimage @ A @ B @ F @ B6 ) ) ) )).

% vimage_Int
thf(fact_204_Plus__eq__empty__conv,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),B6: ( set @ B )] :
      ( ( ( sum_Plus @ A @ B @ A6 @ B6 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A6
          = ( bot_bot @ ( set @ A ) ) )
        & ( B6
          = ( bot_bot @ ( set @ B ) ) ) ) ) )).

% Plus_eq_empty_conv
thf(fact_205_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_206_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S3: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S3 )
     => ( S3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_207_finite__subset,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( finite_finite2 @ A @ B6 )
       => ( finite_finite2 @ A @ A6 ) ) ) )).

% finite_subset
thf(fact_208_infinite__super,axiom,(
    ! [A: $tType,S3: ( set @ A ),T3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S3 @ T3 )
     => ( ~ ( finite_finite2 @ A @ S3 )
       => ~ ( finite_finite2 @ A @ T3 ) ) ) )).

% infinite_super
thf(fact_209_rev__finite__subset,axiom,(
    ! [A: $tType,B6: ( set @ A ),A6: ( set @ A )] :
      ( ( finite_finite2 @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
       => ( finite_finite2 @ A @ A6 ) ) ) )).

% rev_finite_subset
thf(fact_210_finite__subset__image,axiom,(
    ! [A: $tType,B: $tType,B6: ( set @ A ),F: ( B > A ),A6: ( set @ B )] :
      ( ( finite_finite2 @ A @ B6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ ( image @ B @ A @ F @ A6 ) )
       => ? [C5: ( set @ B )] :
            ( ( ord_less_eq @ ( set @ B ) @ C5 @ A6 )
            & ( finite_finite2 @ B @ C5 )
            & ( B6
              = ( image @ B @ A @ F @ C5 ) ) ) ) ) )).

% finite_subset_image
thf(fact_211_finite__surj,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),B6: ( set @ B ),F: ( A > B )] :
      ( ( finite_finite2 @ A @ A6 )
     => ( ( ord_less_eq @ ( set @ B ) @ B6 @ ( image @ A @ B @ F @ A6 ) )
       => ( finite_finite2 @ B @ B6 ) ) ) )).

% finite_surj
thf(fact_212_Un__Int__assoc__eq,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A ),C4: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B6 ) @ C4 )
        = ( inf_inf @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ B6 @ C4 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C4 @ A6 ) ) )).

% Un_Int_assoc_eq
thf(fact_213_distrib__imp1,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ! [X4: A,Y5: A,Z: A] :
              ( ( inf_inf @ A @ X4 @ ( sup_sup @ A @ Y5 @ Z ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X4 @ Y5 ) @ ( inf_inf @ A @ X4 @ Z ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z3 ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z3 ) ) ) ) ) )).

% distrib_imp1
thf(fact_214_distrib__imp2,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ! [X4: A,Y5: A,Z: A] :
              ( ( sup_sup @ A @ X4 @ ( inf_inf @ A @ Y5 @ Z ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X4 @ Y5 ) @ ( sup_sup @ A @ X4 @ Z ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z3 ) ) ) ) ) )).

% distrib_imp2
thf(fact_215_distrib__inf__le,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z3 ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% distrib_inf_le
thf(fact_216_distrib__sup__le,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z3 ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z3 ) ) ) ) )).

% distrib_sup_le
thf(fact_217_inf__sup__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z3 ) ) ) ) )).

% inf_sup_distrib1
thf(fact_218_inf__sup__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z3: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z3 ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z3 @ X ) ) ) ) )).

% inf_sup_distrib2
thf(fact_219_sup__inf__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z3 ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z3 ) ) ) ) )).

% sup_inf_distrib1
thf(fact_220_sup__inf__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z3: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z3 ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z3 @ X ) ) ) ) )).

% sup_inf_distrib2
thf(fact_221_Un__empty__left,axiom,(
    ! [A: $tType,B6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B6 )
      = B6 ) )).

% Un_empty_left
thf(fact_222_Un__empty__right,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( bot_bot @ ( set @ A ) ) )
      = A6 ) )).

% Un_empty_right
thf(fact_223_Un__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),C4: ( set @ A ),B6: ( set @ A ),D3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ D3 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) @ ( sup_sup @ ( set @ A ) @ C4 @ D3 ) ) ) ) )).

% Un_mono
thf(fact_224_Un__least,axiom,(
    ! [A: $tType,A6: ( set @ A ),C4: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B6 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) @ C4 ) ) ) )).

% Un_least
thf(fact_225_Un__upper1,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) ) )).

% Un_upper1
thf(fact_226_Un__upper2,axiom,(
    ! [A: $tType,B6: ( set @ A ),A6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ B6 @ ( sup_sup @ ( set @ A ) @ A6 @ B6 ) ) )).

% Un_upper2
thf(fact_227_Un__absorb1,axiom,(
    ! [A: $tType,A6: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B6 )
     => ( ( sup_sup @ ( set @ A ) @ A6 @ B6 )
        = B6 ) ) )).

% Un_absorb1
thf(fact_228_Un__absorb2,axiom,(
    ! [A: $tType,B6: ( set @ A ),A6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ B6 @ A6 )
     => ( ( sup_sup @ ( set @ A ) @ A6 @ B6 )
        = A6 ) ) )).

% Un_absorb2
thf(fact_229_subset__Un__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B7: ( set @ A )] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B7 )
            = B7 ) ) ) )).

% subset_Un_eq
thf(fact_230_inf__sup__ord_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_ord(4)
thf(fact_231_inf__sup__ord_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_ord(3)
thf(fact_232_le__supE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B3 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A3 @ X )
             => ~ ( ord_less_eq @ A @ B3 @ X ) ) ) ) )).

% le_supE
thf(fact_233_le__supI,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,X: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ X )
         => ( ( ord_less_eq @ A @ B3 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B3 ) @ X ) ) ) ) )).

% le_supI
thf(fact_234_sup__ge1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_ge1
thf(fact_235_sup__ge2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_ge2
thf(fact_236_le__supI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,A3: A,B3: A] :
          ( ( ord_less_eq @ A @ X @ A3 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A3 @ B3 ) ) ) ) )).

% le_supI1
thf(fact_237_le__supI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,B3: A,A3: A] :
          ( ( ord_less_eq @ A @ X @ B3 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A3 @ B3 ) ) ) ) )).

% le_supI2
thf(fact_238_sup_Omono,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,A3: A,D4: A,B3: A] :
          ( ( ord_less_eq @ A @ C2 @ A3 )
         => ( ( ord_less_eq @ A @ D4 @ B3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D4 ) @ ( sup_sup @ A @ A3 @ B3 ) ) ) ) ) )).

% sup.mono
thf(fact_239_sup__mono,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,C2: A,B3: A,D4: A] :
          ( ( ord_less_eq @ A @ A3 @ C2 )
         => ( ( ord_less_eq @ A @ B3 @ D4 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A3 @ B3 ) @ ( sup_sup @ A @ C2 @ D4 ) ) ) ) ) )).

% sup_mono
thf(fact_240_sup__least,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A,Z3: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z3 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z3 ) @ X ) ) ) ) )).

% sup_least
thf(fact_241_le__iff__sup,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [X3: A,Y4: A] :
              ( ( sup_sup @ A @ X3 @ Y4 )
              = Y4 ) ) ) ) )).

% le_iff_sup
thf(fact_242_sup_OorderE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( A3
            = ( sup_sup @ A @ A3 @ B3 ) ) ) ) )).

% sup.orderE
thf(fact_243_sup_OorderI,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( A3
            = ( sup_sup @ A @ A3 @ B3 ) )
         => ( ord_less_eq @ A @ B3 @ A3 ) ) ) )).

% sup.orderI
thf(fact_244_sup__unique,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [F: ( A > A > A ),X: A,Y: A] :
          ( ! [X4: A,Y5: A] :
              ( ord_less_eq @ A @ X4 @ ( F @ X4 @ Y5 ) )
         => ( ! [X4: A,Y5: A] :
                ( ord_less_eq @ A @ Y5 @ ( F @ X4 @ Y5 ) )
           => ( ! [X4: A,Y5: A,Z: A] :
                  ( ( ord_less_eq @ A @ Y5 @ X4 )
                 => ( ( ord_less_eq @ A @ Z @ X4 )
                   => ( ord_less_eq @ A @ ( F @ Y5 @ Z ) @ X4 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F @ X @ Y ) ) ) ) ) ) )).

% sup_unique
thf(fact_245_sup_Oabsorb1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( sup_sup @ A @ A3 @ B3 )
            = A3 ) ) ) )).

% sup.absorb1
thf(fact_246_sup_Oabsorb2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( sup_sup @ A @ A3 @ B3 )
            = B3 ) ) ) )).

% sup.absorb2
thf(fact_247_sup__absorb1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) )).

% sup_absorb1
thf(fact_248_sup__absorb2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) )).

% sup_absorb2
thf(fact_249_sup_OboundedE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C2: A,A3: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A3 )
         => ~ ( ( ord_less_eq @ A @ B3 @ A3 )
             => ~ ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% sup.boundedE
thf(fact_250_sup_OboundedI,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ A3 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A3 ) ) ) ) )).

% sup.boundedI
thf(fact_251_sup_Oorder__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B2: A,A2: A] :
              ( A2
              = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) )).

% sup.order_iff
thf(fact_252_sup_Ocobounded1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ord_less_eq @ A @ A3 @ ( sup_sup @ A @ A3 @ B3 ) ) ) )).

% sup.cobounded1
thf(fact_253_sup_Ocobounded2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ord_less_eq @ A @ B3 @ ( sup_sup @ A @ A3 @ B3 ) ) ) )).

% sup.cobounded2
thf(fact_254_sup_Oabsorb__iff1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B2: A,A2: A] :
              ( ( sup_sup @ A @ A2 @ B2 )
              = A2 ) ) ) ) )).

% sup.absorb_iff1
thf(fact_255_sup_Oabsorb__iff2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A2: A,B2: A] :
              ( ( sup_sup @ A @ A2 @ B2 )
              = B2 ) ) ) ) )).

% sup.absorb_iff2

%----Type constructors (35)
thf(tcon_FSet_Ofset___Lattices_Obounded__lattice,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( bounded_lattice @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_1,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_2,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_3,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounde1808546759up_bot @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice_top @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice_bot @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( semilattice_sup @ A10 @ ( type2 @ A10 ) )
     => ( semilattice_sup @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( distrib_lattice @ A10 @ ( type2 @ A10 ) )
     => ( distrib_lattice @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( lattice @ A10 @ ( type2 @ A10 ) )
     => ( lattice @ ( A8 > A10 ) @ ( type2 @ ( A8 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_4,axiom,(
    ! [A8: $tType] :
      ( bounde1808546759up_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_5,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_6,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_7,axiom,(
    ! [A8: $tType] :
      ( semilattice_sup @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_8,axiom,(
    ! [A8: $tType] :
      ( distrib_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_9,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_10,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_11,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_12,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_13,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_14,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_15,axiom,
    ( distrib_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_16,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_17,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_FSet_Ofset___Lattices_Obounded__semilattice__sup__bot_18,axiom,(
    ! [A8: $tType] :
      ( bounde1808546759up_bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Lattices_Obounded__lattice__top_19,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( bounded_lattice_top @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_FSet_Ofset___Lattices_Obounded__lattice__bot_20,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_bot @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Lattices_Osemilattice__sup_21,axiom,(
    ! [A8: $tType] :
      ( semilattice_sup @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Lattices_Odistrib__lattice_22,axiom,(
    ! [A8: $tType] :
      ( distrib_lattice @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_FSet_Ofset___Finite__Set_Ofinite_23,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) ) )).

thf(tcon_FSet_Ofset___Lattices_Olattice_24,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( fset @ A8 ) @ ( type2 @ ( fset @ A8 ) ) ) )).

thf(tcon_Sum__Type_Osum___Finite__Set_Ofinite_25,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( sum_sum @ A8 @ A10 ) @ ( type2 @ ( sum_sum @ A8 @ A10 ) ) ) ) )).

thf(tcon_Option_Ooption___Finite__Set_Ofinite_26,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( option @ A8 ) @ ( type2 @ ( option @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Finite__Set_Ofinite_27,axiom,(
    ! [A8: $tType,A10: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A10 @ ( type2 @ A10 ) ) )
     => ( finite_finite @ ( product_prod @ A8 @ A10 ) @ ( type2 @ ( product_prod @ A8 @ A10 ) ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( parall1518086719_Nplus @ ( root @ tr1a ) @ ( root @ tr2a ) )
    = ( parall1518086719_Nplus @ ( root @ tr2a ) @ ( root @ tr1a ) ) )).

%------------------------------------------------------------------------------
