%------------------------------------------------------------------------------
% File     : COM206^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Parallel extension to grammars and languages 97
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : parallel__97.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  334 (   3 unit;  50 type;   0 defn)
%            Number of atoms       : 5071 ( 321 equality;3259 variable)
%            Maximal formula depth :   30 (  11 average)
%            Number of connectives : 4588 (  53   ~;   5   |;  18   &;4303   @)
%                                         (   0 <=>; 209  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  402 ( 402   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   54 (  50   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1443 (   0 sgn;1306   !;  18   ?;  50   ^)
%                                         (1443   :;  69  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:39:04.035
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (44)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Odistrib__lattice,type,(
    distrib_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__inf,type,(
    semilattice_inf: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,(
    bounde1561333602nf_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar,type,(
    parall1899940088le_par: ( product_prod @ dtree @ dtree ) > dtree )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Product__Type_Oscomp,type,(
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,(
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Typedef_Otype__definition,type,(
    type_definition: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_tr1_H____,type,(
    tr1: dtree )).

thf(sy_v_tr1a____,type,(
    tr1a: dtree )).

thf(sy_v_tr2_H____,type,(
    tr2: dtree )).

thf(sy_v_tr2a____,type,(
    tr2a: dtree )).

thf(sy_v_trA_H____,type,(
    trA: dtree )).

thf(sy_v_trA____,type,(
    trA2: dtree )).

thf(sy_v_trB____,type,(
    trB: dtree )).

%----Relevant facts (256)
thf(fact_0__092_060open_062_092_060exists_062tr1_Atr2_O_AtrA_A_061_Atr1_A_092_060parallel_062_Atr2_A_092_060and_062_AtrB_A_061_Atr2_A_092_060parallel_062_Atr1_092_060close_062,axiom,(
    ? [Tr1: dtree,Tr2: dtree] :
      ( ( trA2
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) )
      & ( trB
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr2 @ Tr1 ) ) ) ) )).

% \<open>\<exists>tr1 tr2. trA = tr1 \<parallel> tr2 \<and> trB = tr2 \<parallel> tr1\<close>
thf(fact_1__092_060open_062Inr_Atr1_H_A_092_060in_062_Acont_Atr1_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr1 ) @ ( cont @ tr1a ) )).

% \<open>Inr tr1' \<in> cont tr1\<close>
thf(fact_2__092_060open_062Inr_Atr2_H_A_092_060in_062_Acont_Atr2_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr2 ) @ ( cont @ tr2a ) )).

% \<open>Inr tr2' \<in> cont tr2\<close>
thf(fact_3__092_060open_062trA_H_A_061_Atr1_H_A_092_060parallel_062_Atr2_H_092_060close_062,axiom,
    ( trA
    = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1 @ tr2 ) ) )).

% \<open>trA' = tr1' \<parallel> tr2'\<close>
thf(fact_4__092_060open_062Inr_AtrA_H_A_092_060in_062_Acont_A_Itr1_A_092_060parallel_062_Atr2_J_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ trA ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1a @ tr2a ) ) ) )).

% \<open>Inr trA' \<in> cont (tr1 \<parallel> tr2)\<close>
thf(fact_5__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062tr1_H_Atr2_H_O_A_092_060lbrakk_062trA_H_A_061_Atr1_H_A_092_060parallel_062_Atr2_H_059_AInr_Atr1_H_A_092_060in_062_Acont_Atr1_059_AInr_Atr2_H_A_092_060in_062_Acont_Atr2_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [Tr12: dtree,Tr22: dtree] :
          ( ( trA
            = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ Tr22 ) ) )
         => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ tr1a ) )
           => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ tr2a ) ) ) ) ) )).

% \<open>\<And>thesis. (\<And>tr1' tr2'. \<lbrakk>trA' = tr1' \<parallel> tr2'; Inr tr1' \<in> cont tr1; Inr tr2' \<in> cont tr2\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_6_par__r_Ocases,axiom,(
    ! [X: ( product_prod @ dtree @ dtree )] :
      ~ ( ! [Tr1: dtree,Tr2: dtree] :
            ( X
           != ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) )).

% par_r.cases
thf(fact_7_par__r_Oinduct,axiom,(
    ! [P: ( ( product_prod @ dtree @ dtree ) > $o ),A0: ( product_prod @ dtree @ dtree )] :
      ( ! [Tr1: dtree,Tr2: dtree] :
          ( P @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
     => ( P @ A0 ) ) )).

% par_r.induct
thf(fact_8_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% sum.inject(2)
thf(fact_9_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B3: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B3 ) )
      = ( B2 = B3 ) ) )).

% old.sum.inject(2)
thf(fact_10_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X2 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% prod.inject
thf(fact_11_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( ( A2 = A3 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_12_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_13_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( X != Y )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_14_Inl__in__cont__par,axiom,(
    ! [T2: t,Tr13: dtree,Tr23: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr13 @ Tr23 ) ) ) )
      = ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr13 ) )
        | ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr23 ) ) ) ) )).

% Inl_in_cont_par
thf(fact_15_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y3: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y3 ) ) )).

% surj_pair
thf(fact_16_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_17_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ~ ( ( A2 = A3 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_18_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A4: A,B4: B,C2: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) ) ) )).

% prod_cases3
thf(fact_19_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_20_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_21_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: A] :
      ( ( ( sum_Inl @ A @ B @ A2 )
        = ( sum_Inl @ A @ B @ A3 ) )
      = ( A2 = A3 ) ) )).

% old.sum.inject(1)
thf(fact_22_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_23_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [X3: B] :
              ( S
             != ( sum_Inr @ B @ A @ X3 ) ) ) ) )).

% obj_sumE
thf(fact_24_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A4: A] :
          ( P @ ( sum_Inl @ A @ B @ A4 ) )
     => ( ! [B4: B] :
            ( P @ ( sum_Inr @ B @ A @ B4 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_25_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A4: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A4 ) )
     => ~ ( ! [B4: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B4 ) ) ) ) )).

% old.sum.exhaust
thf(fact_26_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X4: ( sum_sum @ A @ B )] :
            ( P3 @ X4 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X5: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X5 ) )
            & ! [X5: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X5 ) ) ) ) ) )).

% split_sum_all
thf(fact_27_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X4: ( sum_sum @ A @ B )] :
            ( P3 @ X4 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X5: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X5 ) )
            | ? [X5: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X5 ) ) ) ) ) )).

% split_sum_ex
thf(fact_28_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A2: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A2 ) ) )).

% Inr_not_Inl
thf(fact_29_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [Y3: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y3 ) ) ) ) )).

% sumE
thf(fact_30_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: A,B3: B] :
      ( ( sum_Inl @ A @ B @ A2 )
     != ( sum_Inr @ B @ A @ B3 ) ) )).

% old.sum.distinct(1)
thf(fact_31_old_Osum_Odistinct_I2_J,axiom,(
    ! [B5: $tType,A5: $tType,B6: B5,A6: A5] :
      ( ( sum_Inr @ B5 @ A5 @ B6 )
     != ( sum_Inl @ A5 @ B5 @ A6 ) ) )).

% old.sum.distinct(2)
thf(fact_32_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X2 ) ) )).

% sum.distinct(1)
thf(fact_33_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_34_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A4: A,B4: B] :
            ( Y
           != ( product_Pair @ A @ B @ A4 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_35_prod__induct7,axiom,(
    ! [G: $tType,F: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F,G2: G] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F @ G ) @ E2 @ ( product_Pair @ F @ G @ F2 @ G2 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_36_prod__induct6,axiom,(
    ! [F: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F ) @ D2 @ ( product_Pair @ E @ F @ E2 @ F2 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_37_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_38_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_39_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A4: A,B4: B,C2: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_40_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F: $tType,G: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F,G2: G] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F @ G ) @ E2 @ ( product_Pair @ F @ G @ F2 @ G2 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_41_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E2: E,F2: F] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F ) @ D2 @ ( product_Pair @ E @ F @ E2 @ F2 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_42_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_43_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_44_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X5: A] :
            ( member @ A @ X5 @ A7 ) )
      = A7 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F3: ( A > B ),G3: ( A > B )] :
      ( ! [X3: A] :
          ( ( F3 @ X3 )
          = ( G3 @ X3 ) )
     => ( F3 = G3 ) ) )).

% ext
thf(fact_49_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_50_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A2: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( F1 @ A2 ) ) )).

% old.sum.simps(7)
thf(fact_51_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F22 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_52_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F3: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X3: A] :
          ( ( S
            = ( F3 @ ( sum_Inl @ A @ C @ X3 ) ) )
         => P )
     => ( ! [X3: C] :
            ( ( S
              = ( F3 @ ( sum_Inr @ C @ A @ X3 ) ) )
           => P )
       => ! [X6: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F3 @ X6 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_53_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C3: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C3 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C3 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_54_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F3 @ ( sum_Inl @ A @ B @ X ) )
      = ( F3 @ X ) ) )).

% Suml.simps
thf(fact_55_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F3: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F3 @ ( sum_Inr @ B @ A @ X ) )
      = ( F3 @ X ) ) )).

% Sumr.simps
thf(fact_56_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B2: A,F3: ( B > A ),X: B,C3: C,G3: ( B > C ),A7: ( set @ B )] :
      ( ( B2
        = ( F3 @ X ) )
     => ( ( C3
          = ( G3 @ X ) )
       => ( ( member @ B @ X @ A7 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C3 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A7 @ F3 @ G3 ) ) ) ) ) )).

% image2_eqI
thf(fact_57_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F3: ( B > C ),G3: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F3 )
        = ( sum_Sumr @ B @ C @ A @ G3 ) )
     => ( F3 = G3 ) ) )).

% Sumr_inject
thf(fact_58_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: ( A > C ),G3: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F3 )
        = ( sum_Suml @ A @ C @ B @ G3 ) )
     => ( F3 = G3 ) ) )).

% Suml_inject
thf(fact_59_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R2: ( set @ ( product_prod @ A @ B ) ),S2: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R2 )
     => ( ( S2 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R2 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_60_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F4: ( ( product_prod @ B @ C ) > A ),A8: B,B7: C] :
            ( F4 @ ( product_Pair @ B @ C @ A8 @ B7 ) ) ) ) )).

% curry_conv
thf(fact_61_curryI,axiom,(
    ! [A: $tType,B: $tType,F3: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( F3 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( product_curry @ A @ B @ $o @ F3 @ A2 @ B2 ) ) )).

% curryI
thf(fact_62_case__sum__if,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: $o,F3: ( B > A ),G3: ( C > A ),X: B,Y: C] :
      ( ( P2
       => ( ( sum_case_sum @ B @ A @ C @ F3 @ G3 @ ( if @ ( sum_sum @ B @ C ) @ P2 @ ( sum_Inl @ B @ C @ X ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( F3 @ X ) ) )
      & ( ~ ( P2 )
       => ( ( sum_case_sum @ B @ A @ C @ F3 @ G3 @ ( if @ ( sum_sum @ B @ C ) @ P2 @ ( sum_Inl @ B @ C @ X ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( G3 @ Y ) ) ) ) )).

% case_sum_if
thf(fact_63_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X ) ) )).

% swap_simp
thf(fact_64_Inl__cont__par,axiom,(
    ! [Tr13: dtree,Tr23: dtree] :
      ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr13 @ Tr23 ) ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr13 ) @ ( cont @ Tr23 ) ) ) ) )).

% Inl_cont_par
thf(fact_65_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_66_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P2 ) )
      = P2 ) )).

% swap_swap
thf(fact_67_curry__case__prod,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F3: ( A > B > C )] :
      ( ( product_curry @ A @ B @ C @ ( product_case_prod @ A @ B @ C @ F3 ) )
      = F3 ) )).

% curry_case_prod
thf(fact_68_case__prod__curry,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F3: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C @ ( product_curry @ A @ B @ C @ F3 ) )
      = F3 ) )).

% case_prod_curry
thf(fact_69_case__sum__step_I2_J,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,F3: ( E > A ),F5: ( B > A ),G4: ( C > A ),P2: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ E @ A @ ( sum_sum @ B @ C ) @ F3 @ ( sum_case_sum @ B @ A @ C @ F5 @ G4 ) @ ( sum_Inr @ ( sum_sum @ B @ C ) @ E @ P2 ) )
      = ( sum_case_sum @ B @ A @ C @ F5 @ G4 @ P2 ) ) )).

% case_sum_step(2)
thf(fact_70_case__sum__step_I1_J,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F5: ( B > A ),G4: ( C > A ),G3: ( D > A ),P2: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ ( sum_sum @ B @ C ) @ A @ D @ ( sum_case_sum @ B @ A @ C @ F5 @ G4 ) @ G3 @ ( sum_Inl @ ( sum_sum @ B @ C ) @ D @ P2 ) )
      = ( sum_case_sum @ B @ A @ C @ F5 @ G4 @ P2 ) ) )).

% case_sum_step(1)
thf(fact_71_case__sum__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F22: ( B > C ),G1: ( A > C ),G22: ( B > C )] :
      ( ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 )
        = ( sum_case_sum @ A @ C @ B @ G1 @ G22 ) )
     => ~ ( ( F1 = G1 )
         => ( F22 != G22 ) ) ) )).

% case_sum_inject
thf(fact_72_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z: A,C3: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C3 @ P2 ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( member @ A @ Z @ ( C3 @ X3 @ Y3 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_73_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F3: ( A > B > C ),X1: A,X2: B] :
      ( ( product_case_prod @ A @ B @ C @ F3 @ ( product_Pair @ A @ B @ X1 @ X2 ) )
      = ( F3 @ X1 @ X2 ) ) )).

% old.prod.case
thf(fact_74_old_Osum_Osimps_I6_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F1: ( A > C ),F22: ( B > C ),X2: B] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ X2 ) )
      = ( F22 @ X2 ) ) )).

% old.sum.simps(6)
thf(fact_75_old_Osum_Osimps_I5_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F1: ( A > C ),F22: ( B > C ),X1: A] :
      ( ( sum_case_sum @ A @ C @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ X1 ) )
      = ( F1 @ X1 ) ) )).

% old.sum.simps(5)
thf(fact_76_curryE,axiom,(
    ! [A: $tType,B: $tType,F3: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F3 @ A2 @ B2 )
     => ( F3 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryE
thf(fact_77_curryD,axiom,(
    ! [A: $tType,B: $tType,F3: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F3 @ A2 @ B2 )
     => ( F3 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryD
thf(fact_78_vimage__Un,axiom,(
    ! [A: $tType,B: $tType,F3: ( A > B ),A7: ( set @ B ),B8: ( set @ B )] :
      ( ( vimage @ A @ B @ F3 @ ( sup_sup @ ( set @ B ) @ A7 @ B8 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ A7 ) @ ( vimage @ A @ B @ F3 @ B8 ) ) ) )).

% vimage_Un
thf(fact_79_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A7: ( set @ ( sum_sum @ A @ B ) ),B8: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A7 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B8 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A7 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B8 ) )
       => ( A7 = B8 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_80_vimageI,axiom,(
    ! [B: $tType,A: $tType,F3: ( B > A ),A2: B,B2: A,B8: ( set @ A )] :
      ( ( ( F3 @ A2 )
        = B2 )
     => ( ( member @ A @ B2 @ B8 )
       => ( member @ B @ A2 @ ( vimage @ B @ A @ F3 @ B8 ) ) ) ) )).

% vimageI
thf(fact_81_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F3: ( A > B ),B8: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F3 @ B8 ) )
      = ( member @ B @ ( F3 @ A2 ) @ B8 ) ) )).

% vimage_eq
thf(fact_82_UnCI,axiom,(
    ! [A: $tType,C3: A,B8: ( set @ A ),A7: ( set @ A )] :
      ( ( ~ ( member @ A @ C3 @ B8 )
       => ( member @ A @ C3 @ A7 ) )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) ) ) )).

% UnCI
thf(fact_83_Un__iff,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
      = ( ( member @ A @ C3 @ A7 )
        | ( member @ A @ C3 @ B8 ) ) ) )).

% Un_iff
thf(fact_84_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G5: ( A > B ),X5: A] :
              ( sup_sup @ B @ ( F4 @ X5 ) @ ( G5 @ X5 ) ) ) ) ) )).

% sup_apply
thf(fact_85_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.right_idem
thf(fact_86_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_87_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.left_idem
thf(fact_88_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_89_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_90_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_left_commute
thf(fact_91_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C3: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A2 @ C3 ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C3 ) ) ) ) )).

% sup.left_commute
thf(fact_92_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X5: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X5 ) ) ) ) )).

% sup_commute
thf(fact_93_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A8: A,B7: A] :
              ( sup_sup @ A @ B7 @ A8 ) ) ) ) )).

% sup.commute
thf(fact_94_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% sup_assoc
thf(fact_95_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ C3 )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C3 ) ) ) ) )).

% sup.assoc
thf(fact_96_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G5: ( A > B ),X5: A] :
              ( sup_sup @ B @ ( F4 @ X5 ) @ ( G5 @ X5 ) ) ) ) ) )).

% sup_fun_def
thf(fact_97_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X5: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X5 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_98_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_99_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_100_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_101_Un__left__commute,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A7 @ ( sup_sup @ ( set @ A ) @ B8 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ B8 @ ( sup_sup @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% Un_left_commute
thf(fact_102_Un__left__absorb,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A7 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
      = ( sup_sup @ ( set @ A ) @ A7 @ B8 ) ) )).

% Un_left_absorb
thf(fact_103_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A9: ( set @ A ),B9: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B9 @ A9 ) ) ) )).

% Un_commute
thf(fact_104_Un__absorb,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A7 @ A7 )
      = A7 ) )).

% Un_absorb
thf(fact_105_Un__assoc,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) @ C4 )
      = ( sup_sup @ ( set @ A ) @ A7 @ ( sup_sup @ ( set @ A ) @ B8 @ C4 ) ) ) )).

% Un_assoc
thf(fact_106_ball__Un,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
           => ( P @ X5 ) ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ A7 )
           => ( P @ X5 ) )
        & ! [X5: A] :
            ( ( member @ A @ X5 @ B8 )
           => ( P @ X5 ) ) ) ) )).

% ball_Un
thf(fact_107_bex__Un,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
            & ( P @ X5 ) ) )
      = ( ? [X5: A] :
            ( ( member @ A @ X5 @ A7 )
            & ( P @ X5 ) )
        | ? [X5: A] :
            ( ( member @ A @ X5 @ B8 )
            & ( P @ X5 ) ) ) ) )).

% bex_Un
thf(fact_108_UnI2,axiom,(
    ! [A: $tType,C3: A,B8: ( set @ A ),A7: ( set @ A )] :
      ( ( member @ A @ C3 @ B8 )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) ) ) )).

% UnI2
thf(fact_109_UnI1,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ A7 )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) ) ) )).

% UnI1
thf(fact_110_UnE,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) )
     => ( ~ ( member @ A @ C3 @ A7 )
       => ( member @ A @ C3 @ B8 ) ) ) )).

% UnE
thf(fact_111_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F3: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F3 @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F3 @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_112_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F3: ( B > A ),A2: B,A7: ( set @ A )] :
      ( ( member @ A @ ( F3 @ A2 ) @ A7 )
     => ( member @ B @ A2 @ ( vimage @ B @ A @ F3 @ A7 ) ) ) )).

% vimageI2
thf(fact_113_vimageE,axiom,(
    ! [A: $tType,B: $tType,A2: A,F3: ( A > B ),B8: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F3 @ B8 ) )
     => ( member @ B @ ( F3 @ A2 ) @ B8 ) ) )).

% vimageE
thf(fact_114_vimageD,axiom,(
    ! [A: $tType,B: $tType,A2: A,F3: ( A > B ),A7: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F3 @ A7 ) )
     => ( member @ B @ ( F3 @ A2 ) @ A7 ) ) )).

% vimageD
thf(fact_115_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F3: ( A > B > C ),G3: ( A > B > C ),P2: ( product_prod @ A @ B )] :
      ( ! [X3: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y3 )
            = Q2 )
         => ( ( F3 @ X3 @ Y3 )
            = ( G3 @ X3 @ Y3 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F3 @ P2 )
          = ( product_case_prod @ A @ B @ C @ G3 @ Q2 ) ) ) ) )).

% split_cong
thf(fact_116_case__sum__expand__Inr__pointfree,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: ( ( sum_sum @ A @ C ) > B ),G3: ( A > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F3 @ ( sum_Inl @ A @ C ) )
        = G3 )
     => ( ( sum_case_sum @ A @ B @ C @ G3 @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F3 @ ( sum_Inr @ C @ A ) ) )
        = F3 ) ) )).

% case_sum_expand_Inr_pointfree
thf(fact_117_case__sum__expand__Inr_H,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: ( ( sum_sum @ A @ C ) > B ),G3: ( A > B ),H: ( C > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F3 @ ( sum_Inl @ A @ C ) )
        = G3 )
     => ( ( H
          = ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F3 @ ( sum_Inr @ C @ A ) ) )
        = ( ( sum_case_sum @ A @ B @ C @ G3 @ H )
          = F3 ) ) ) )).

% case_sum_expand_Inr'
thf(fact_118_case__sum__expand__Inr,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: ( ( sum_sum @ A @ C ) > B ),G3: ( A > B ),X: ( sum_sum @ A @ C )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F3 @ ( sum_Inl @ A @ C ) )
        = G3 )
     => ( ( F3 @ X )
        = ( sum_case_sum @ A @ B @ C @ G3 @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F3 @ ( sum_Inr @ C @ A ) ) @ X ) ) ) )).

% case_sum_expand_Inr
thf(fact_119_scomp__apply,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_scomp @ B @ C @ D @ A )
      = ( ^ [F4: ( B > ( product_prod @ C @ D ) ),G5: ( C > D > A ),X5: B] :
            ( product_case_prod @ C @ D @ A @ G5 @ ( F4 @ X5 ) ) ) ) )).

% scomp_apply
thf(fact_120_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y: A,X: B,A7: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A7 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ A7 ) ) )).

% pair_in_swap_image
thf(fact_121_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F3: ( B > A ),X: B,A7: ( set @ B )] :
      ( ( B2
        = ( F3 @ X ) )
     => ( ( member @ B @ X @ A7 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F3 @ A7 ) ) ) ) )).

% image_eqI
thf(fact_122_o__case__sum,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H: ( D > C ),F3: ( A > D ),G3: ( B > D )] :
      ( ( comp @ D @ C @ ( sum_sum @ A @ B ) @ H @ ( sum_case_sum @ A @ D @ B @ F3 @ G3 ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ H @ F3 ) @ ( comp @ D @ C @ B @ H @ G3 ) ) ) )).

% o_case_sum
thf(fact_123_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A7: ( set @ A ),B2: B,F3: ( A > B )] :
      ( ( member @ A @ X @ A7 )
     => ( ( B2
          = ( F3 @ X ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F3 @ A7 ) ) ) ) )).

% rev_image_eqI
thf(fact_124_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),A7: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F3 @ A7 ) )
         => ( P @ X3 ) )
     => ! [X6: B] :
          ( ( member @ B @ X6 @ A7 )
         => ( P @ ( F3 @ X6 ) ) ) ) )).

% ball_imageD
thf(fact_125_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F3: ( A > B ),G3: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N )
           => ( ( F3 @ X3 )
              = ( G3 @ X3 ) ) )
       => ( ( image @ A @ B @ F3 @ M )
          = ( image @ A @ B @ G3 @ N ) ) ) ) )).

% image_cong
thf(fact_126_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),A7: ( set @ B ),P: ( A > $o )] :
      ( ? [X6: A] :
          ( ( member @ A @ X6 @ ( image @ B @ A @ F3 @ A7 ) )
          & ( P @ X6 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A7 )
          & ( P @ ( F3 @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_127_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z: A,F3: ( B > A ),A7: ( set @ B )] :
      ( ( member @ A @ Z @ ( image @ B @ A @ F3 @ A7 ) )
      = ( ? [X5: B] :
            ( ( member @ B @ X5 @ A7 )
            & ( Z
              = ( F3 @ X5 ) ) ) ) ) )).

% image_iff
thf(fact_128_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A7: ( set @ A ),F3: ( A > B )] :
      ( ( member @ A @ X @ A7 )
     => ( member @ B @ ( F3 @ X ) @ ( image @ A @ B @ F3 @ A7 ) ) ) )).

% imageI
thf(fact_129_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G3: ( C > B ),H: ( A > C ),R1: ( D > B ),R22: ( A > D ),F3: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G3 @ H )
        = ( comp @ D @ B @ A @ R1 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F3 @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F3 @ G3 ) @ H )
          = ( comp @ D @ E @ A @ L @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_130_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F3: ( C > B ),G3: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F3 @ G3 )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F3 @ ( comp @ A @ C @ E @ G3 @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_131_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G3: ( C > B ),H: ( A > C ),R: ( A > B ),F3: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G3 @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F3 @ G3 ) @ H )
        = ( comp @ B @ D @ A @ F3 @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_132_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F3: ( C > B ),G3: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F3 @ G3 )
        = L )
     => ( ( comp @ C @ B @ D @ F3 @ ( comp @ A @ C @ D @ G3 @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_133_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F3: ( B > A ),G3: ( C > B ),X: C,F5: ( D > A ),G4: ( E > D ),X7: E] :
      ( ( ( F3 @ ( G3 @ X ) )
        = ( F5 @ ( G4 @ X7 ) ) )
     => ( ( comp @ B @ A @ C @ F3 @ G3 @ X )
        = ( comp @ D @ A @ E @ F5 @ G4 @ X7 ) ) ) )).

% comp_cong
thf(fact_134_image__Un,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),A7: ( set @ B ),B8: ( set @ B )] :
      ( ( image @ B @ A @ F3 @ ( sup_sup @ ( set @ B ) @ A7 @ B8 ) )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F3 @ A7 ) @ ( image @ B @ A @ F3 @ B8 ) ) ) )).

% image_Un
thf(fact_135_scomp__Pair,axiom,(
    ! [C: $tType,B: $tType,A: $tType,X: ( A > ( product_prod @ B @ C ) )] :
      ( ( product_scomp @ A @ B @ C @ ( product_prod @ B @ C ) @ X @ ( product_Pair @ B @ C ) )
      = X ) )).

% scomp_Pair
thf(fact_136_Pair__scomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X: C,F3: ( C > A > B )] :
      ( ( product_scomp @ A @ C @ A @ B @ ( product_Pair @ C @ A @ X ) @ F3 )
      = ( F3 @ X ) ) )).

% Pair_scomp
thf(fact_137_scomp__def,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F4: ( A > ( product_prod @ B @ C ) ),G5: ( B > C > D ),X5: A] :
            ( product_case_prod @ B @ C @ D @ G5 @ ( F4 @ X5 ) ) ) ) )).

% scomp_def
thf(fact_138_case__sum__o__inj_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F3: ( A > B ),G3: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ ( sum_case_sum @ A @ B @ C @ F3 @ G3 ) @ ( sum_Inl @ A @ C ) )
      = F3 ) )).

% case_sum_o_inj(1)
thf(fact_139_case__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F3: ( A > B ),G3: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ C @ ( sum_case_sum @ A @ B @ C @ F3 @ G3 ) @ ( sum_Inr @ C @ A ) )
      = G3 ) )).

% case_sum_o_inj(2)
thf(fact_140_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F4: ( B > A ),G5: ( C > B ),X5: C] :
            ( F4 @ ( G5 @ X5 ) ) ) ) )).

% comp_apply
thf(fact_141_set_Ocomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F3: ( C > B ),G3: ( B > A )] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F3 ) @ ( vimage @ B @ A @ G3 ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G3 @ F3 ) ) ) )).

% set.comp
thf(fact_142_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F3: ( B > A ),G3: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F3 @ ( G3 @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F3 @ G3 @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_143_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C3 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_144_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( D > B ),D3: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D3 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C3 @ ( D3 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_145_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( D > B ),D3: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D3 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C3 @ ( D3 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_146_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F3: ( D > B ),G3: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F3 @ G3 ) @ H )
      = ( comp @ D @ B @ A @ F3 @ ( comp @ C @ D @ A @ G3 @ H ) ) ) )).

% comp_assoc
thf(fact_147_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F4: ( B > C ),G5: ( A > B ),X5: A] :
            ( F4 @ ( G5 @ X5 ) ) ) ) )).

% comp_def
thf(fact_148_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F3: ( B > A ),A7: ( set @ B ),G3: ( C > A ),B8: ( set @ C ),H: ( A > D )] :
      ( ( ( image @ B @ A @ F3 @ A7 )
        = ( image @ C @ A @ G3 @ B8 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H @ F3 ) @ A7 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H @ G3 ) @ B8 ) ) ) )).

% image_eq_imp_comp
thf(fact_149_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F3: ( B > A ),G3: ( C > B ),R: ( set @ C )] :
      ( ( image @ B @ A @ F3 @ ( image @ C @ B @ G3 @ R ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F3 @ G3 ) @ R ) ) )).

% image_comp
thf(fact_150_set_Ocompositionality,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F3: ( C > B ),G3: ( B > A ),Set: ( set @ A )] :
      ( ( vimage @ C @ B @ F3 @ ( vimage @ B @ A @ G3 @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G3 @ F3 ) @ Set ) ) )).

% set.compositionality
thf(fact_151_vimage__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F3: ( A > B ),G3: ( B > C ),X: ( set @ C )] :
      ( ( vimage @ A @ B @ F3 @ ( vimage @ B @ C @ G3 @ X ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G3 @ F3 ) @ X ) ) )).

% vimage_comp
thf(fact_152_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G3: ( B > A ),F3: ( C > B ),A7: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G3 @ ( image @ C @ B @ F3 @ A7 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G3 @ F3 ) @ A7 ) ) ) )).

% Sup.SUP_image
thf(fact_153_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G3: ( B > A ),F3: ( C > B ),A7: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G3 @ ( image @ C @ B @ F3 @ A7 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G3 @ F3 ) @ A7 ) ) ) )).

% Inf.INF_image
thf(fact_154_Plus__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B )
      = ( ^ [A9: ( set @ A ),B9: ( set @ B )] :
            ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A9 ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B9 ) ) ) ) )).

% Plus_def
thf(fact_155_surj__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% surj_swap
thf(fact_156_UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_157_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_158_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_159_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F3: ( A > B )] :
      ( ( vimage @ A @ B @ F3 @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_160_UNIV__Plus__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) ) )).

% UNIV_Plus_UNIV
thf(fact_161_InrI,axiom,(
    ! [B: $tType,A: $tType,B2: A,B8: ( set @ A ),A7: ( set @ B )] :
      ( ( member @ A @ B2 @ B8 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B2 ) @ ( sum_Plus @ B @ A @ A7 @ B8 ) ) ) )).

% InrI
thf(fact_162_InlI,axiom,(
    ! [A: $tType,B: $tType,A2: A,A7: ( set @ A ),B8: ( set @ B )] :
      ( ( member @ A @ A2 @ A7 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A2 ) @ ( sum_Plus @ A @ B @ A7 @ B8 ) ) ) )).

% InlI
thf(fact_163_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F3: ( B > A ),X: B] :
      ( ( B2
        = ( F3 @ X ) )
     => ( member @ A @ B2 @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_164_rangeI,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),X: B] :
      ( member @ A @ ( F3 @ X ) @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_165_surjD,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X3: B] :
          ( Y
          = ( F3 @ X3 ) ) ) )).

% surjD
thf(fact_166_surjE,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X3: B] :
              ( Y
             != ( F3 @ X3 ) ) ) ) )).

% surjE
thf(fact_167_surjI,axiom,(
    ! [B: $tType,A: $tType,G3: ( B > A ),F3: ( A > B )] :
      ( ! [X3: A] :
          ( ( G3 @ ( F3 @ X3 ) )
          = X3 )
     => ( ( image @ B @ A @ G3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_168_surj__def,axiom,(
    ! [B: $tType,A: $tType,F3: ( B > A )] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y4: A] :
          ? [X5: B] :
            ( Y4
            = ( F3 @ X5 ) ) ) ) )).

% surj_def
thf(fact_169_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_170_UNIV__eq__I,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A7 )
     => ( ( top_top @ ( set @ A ) )
        = A7 ) ) )).

% UNIV_eq_I
thf(fact_171_Un__UNIV__left,axiom,(
    ! [A: $tType,B8: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B8 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_172_Un__UNIV__right,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A7 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_173_UNIV__sum,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( top_top @ ( set @ ( sum_sum @ A @ B ) ) )
      = ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ ( top_top @ ( set @ A ) ) ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ ( top_top @ ( set @ B ) ) ) ) ) )).

% UNIV_sum
thf(fact_174_surj__fun__eq,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: ( B > A ),X8: ( set @ B ),G1: ( A > C ),G22: ( A > C )] :
      ( ( ( image @ B @ A @ F3 @ X8 )
        = ( top_top @ ( set @ A ) ) )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ X8 )
           => ( ( comp @ A @ C @ B @ G1 @ F3 @ X3 )
              = ( comp @ A @ C @ B @ G22 @ F3 @ X3 ) ) )
       => ( G1 = G22 ) ) ) )).

% surj_fun_eq
thf(fact_175_comp__surj,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F3: ( B > A ),G3: ( A > C )] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( image @ A @ C @ G3 @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ C ) ) )
       => ( ( image @ B @ C @ ( comp @ A @ C @ B @ G3 @ F3 ) @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ C ) ) ) ) ) )).

% comp_surj
thf(fact_176_surj__image__vimage__eq,axiom,(
    ! [B: $tType,A: $tType,F3: ( B > A ),A7: ( set @ A )] :
      ( ( ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ F3 @ ( vimage @ B @ A @ F3 @ A7 ) )
        = A7 ) ) )).

% surj_image_vimage_eq
thf(fact_177_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A7: ( set @ A ),B8: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A7 @ B8 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A7 )
           => ( U
             != ( sum_Inl @ A @ B @ X3 ) ) )
       => ~ ( ! [Y3: B] :
                ( ( member @ B @ Y3 @ B8 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y3 ) ) ) ) ) ) )).

% PlusE
thf(fact_178_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A7: ( set @ B ),B8: ( set @ B ),C4: ( B > A ),D4: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A7 = B8 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B8 )
           => ( ( C4 @ X3 )
              = ( D4 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C4 @ A7 ) )
          = ( Inf @ ( image @ B @ A @ D4 @ B8 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_179_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A7: ( set @ B ),B8: ( set @ B ),C4: ( B > A ),D4: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A7 = B8 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B8 )
           => ( ( C4 @ X3 )
              = ( D4 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C4 @ A7 ) )
          = ( Sup @ ( image @ B @ A @ D4 @ B8 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_180_fun_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),Xa: ( D > A ),F3: ( A > B ),Fa: ( A > B )] :
      ( ! [Z2: A,Za: A] :
          ( ( member @ A @ Z2 @ ( image @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
         => ( ( member @ A @ Za @ ( image @ D @ A @ Xa @ ( top_top @ ( set @ D ) ) ) )
           => ( ( ( F3 @ Z2 )
                = ( Fa @ Za ) )
             => ( Z2 = Za ) ) ) )
     => ( ( ( comp @ A @ B @ D @ F3 @ X )
          = ( comp @ A @ B @ D @ Fa @ Xa ) )
       => ( X = Xa ) ) ) )).

% fun.inj_map_strong
thf(fact_181_fun_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),F3: ( A > B ),G3: ( A > B )] :
      ( ! [Z2: A] :
          ( ( member @ A @ Z2 @ ( image @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
         => ( ( F3 @ Z2 )
            = ( G3 @ Z2 ) ) )
     => ( ( comp @ A @ B @ D @ F3 @ X )
        = ( comp @ A @ B @ D @ G3 @ X ) ) ) )).

% fun.map_cong0
thf(fact_182_fun_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),Ya: ( D > A ),F3: ( A > B ),G3: ( A > B )] :
      ( ( X = Ya )
     => ( ! [Z2: A] :
            ( ( member @ A @ Z2 @ ( image @ D @ A @ Ya @ ( top_top @ ( set @ D ) ) ) )
           => ( ( F3 @ Z2 )
              = ( G3 @ Z2 ) ) )
       => ( ( comp @ A @ B @ D @ F3 @ X )
          = ( comp @ A @ B @ D @ G3 @ Ya ) ) ) ) )).

% fun.map_cong
thf(fact_183_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_184_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G3: ( B > C ),F3: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G3 @ ( comp @ A @ B @ D @ F3 @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G3 @ F3 ) @ V ) ) )).

% fun.map_comp
thf(fact_185_fun_Oset__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,F3: ( A > B ),V: ( D > A )] :
      ( ( image @ D @ B @ ( comp @ A @ B @ D @ F3 @ V ) @ ( top_top @ ( set @ D ) ) )
      = ( image @ A @ B @ F3 @ ( image @ D @ A @ V @ ( top_top @ ( set @ D ) ) ) ) ) )).

% fun.set_map
thf(fact_186_map__prod__surj,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F3: ( A > B ),G3: ( C > D )] :
      ( ( ( image @ A @ B @ F3 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ B ) ) )
     => ( ( ( image @ C @ D @ G3 @ ( top_top @ ( set @ C ) ) )
          = ( top_top @ ( set @ D ) ) )
       => ( ( image @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F3 @ G3 ) @ ( top_top @ ( set @ ( product_prod @ A @ C ) ) ) )
          = ( top_top @ ( set @ ( product_prod @ B @ D ) ) ) ) ) ) )).

% map_prod_surj
thf(fact_187_type__copy__set__map0,axiom,(
    ! [A: $tType,B: $tType,D: $tType,E: $tType,C: $tType,F: $tType,Rep: ( A > B ),Abs: ( B > A ),S3: ( B > ( set @ D ) ),M: ( C > B ),F3: ( E > D ),S4: ( C > ( set @ E ) ),G3: ( F > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ( comp @ B @ ( set @ D ) @ C @ S3 @ M )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ C @ ( image @ E @ D @ F3 ) @ S4 ) )
       => ( ( comp @ A @ ( set @ D ) @ F @ ( comp @ B @ ( set @ D ) @ A @ S3 @ Rep ) @ ( comp @ C @ A @ F @ ( comp @ B @ A @ C @ Abs @ M ) @ G3 ) )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ F @ ( image @ E @ D @ F3 ) @ ( comp @ C @ ( set @ E ) @ F @ S4 @ G3 ) ) ) ) ) )).

% type_copy_set_map0
thf(fact_188_image__vimage__eq,axiom,(
    ! [A: $tType,B: $tType,F3: ( B > A ),A7: ( set @ A )] :
      ( ( image @ B @ A @ F3 @ ( vimage @ B @ A @ F3 @ A7 ) )
      = ( inf_inf @ ( set @ A ) @ A7 @ ( image @ B @ A @ F3 @ ( top_top @ ( set @ B ) ) ) ) ) )).

% image_vimage_eq
thf(fact_189_inf__right__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_right_idem
thf(fact_190_inf_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.right_idem
thf(fact_191_inf__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_left_idem
thf(fact_192_inf_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B2 ) )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.left_idem
thf(fact_193_inf__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) )).

% inf_idem
thf(fact_194_inf_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) )).

% inf.idem
thf(fact_195_inf__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G5: ( A > B ),X5: A] :
              ( inf_inf @ B @ ( F4 @ X5 ) @ ( G5 @ X5 ) ) ) ) ) )).

% inf_apply
thf(fact_196_Int__iff,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) )
      = ( ( member @ A @ C3 @ A7 )
        & ( member @ A @ C3 @ B8 ) ) ) )).

% Int_iff
thf(fact_197_IntI,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ A7 )
     => ( ( member @ A @ C3 @ B8 )
       => ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) ) ) ) )).

% IntI
thf(fact_198_sup__inf__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) )).

% sup_inf_absorb
thf(fact_199_inf__sup__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) )).

% inf_sup_absorb
thf(fact_200_inf__top_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1561333602nf_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ ( top_top @ A ) )
          = A2 ) ) )).

% inf_top.right_neutral
thf(fact_201_inf__top_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1561333602nf_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A2 )
          = A2 ) ) )).

% inf_top.left_neutral
thf(fact_202_inf__eq__top__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) )).

% inf_eq_top_iff
thf(fact_203_Int__UNIV,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A7 @ B8 )
        = ( top_top @ ( set @ A ) ) )
      = ( ( A7
          = ( top_top @ ( set @ A ) ) )
        & ( B8
          = ( top_top @ ( set @ A ) ) ) ) ) )).

% Int_UNIV
thf(fact_204_vimage__Int,axiom,(
    ! [A: $tType,B: $tType,F3: ( A > B ),A7: ( set @ B ),B8: ( set @ B )] :
      ( ( vimage @ A @ B @ F3 @ ( inf_inf @ ( set @ B ) @ A7 @ B8 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ A7 ) @ ( vimage @ A @ B @ F3 @ B8 ) ) ) )).

% vimage_Int
thf(fact_205_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F3: ( C > A ),G3: ( D > B ),A2: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F3 @ G3 @ ( product_Pair @ C @ D @ A2 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F3 @ A2 ) @ ( G3 @ B2 ) ) ) )).

% map_prod_simp
thf(fact_206_map__prod__imageI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A2: A,B2: B,R2: ( set @ ( product_prod @ A @ B ) ),F3: ( A > C ),G3: ( B > D )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R2 )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F3 @ A2 ) @ ( G3 @ B2 ) ) @ ( image @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F3 @ G3 ) @ R2 ) ) ) )).

% map_prod_imageI
thf(fact_207_type__copy__wit,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),X: C,S3: ( B > ( set @ C ) ),Y: B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( member @ C @ X @ ( comp @ B @ ( set @ C ) @ A @ S3 @ Rep @ ( Abs @ Y ) ) )
       => ( member @ C @ X @ ( S3 @ Y ) ) ) ) )).

% type_copy_wit
thf(fact_208_type__copy__map__comp0,axiom,(
    ! [F: $tType,D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Rep: ( A > B ),Abs: ( B > A ),M: ( C > D ),M1: ( B > D ),M2: ( C > B ),F3: ( D > F ),G3: ( E > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( comp @ B @ D @ C @ M1 @ M2 ) )
       => ( ( comp @ C @ F @ E @ ( comp @ D @ F @ C @ F3 @ M ) @ G3 )
          = ( comp @ A @ F @ E @ ( comp @ B @ F @ A @ ( comp @ D @ F @ B @ F3 @ M1 ) @ Rep ) @ ( comp @ C @ A @ E @ ( comp @ B @ A @ C @ Abs @ M2 ) @ G3 ) ) ) ) ) )).

% type_copy_map_comp0
thf(fact_209_inf__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) )).

% inf_top_right
thf(fact_210_inf__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X )
          = X ) ) )).

% inf_top_left
thf(fact_211_Int__UNIV__right,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A7 @ ( top_top @ ( set @ A ) ) )
      = A7 ) )).

% Int_UNIV_right
thf(fact_212_Int__UNIV__left,axiom,(
    ! [A: $tType,B8: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B8 )
      = B8 ) )).

% Int_UNIV_left
thf(fact_213_type__copy__obj__one__point__absE,axiom,(
    ! [A: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),S: A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ~ ( ! [X3: B] :
              ( S
             != ( Abs @ X3 ) ) ) ) )).

% type_copy_obj_one_point_absE
thf(fact_214_top__conj_I1_J,axiom,(
    ! [A: $tType,X: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_215_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X ) )
      = P ) )).

% top_conj(2)
thf(fact_216_prod_Omap__comp,axiom,(
    ! [D: $tType,F: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: ( C > E ),G22: ( D > F ),F1: ( A > C ),F22: ( B > D ),V: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F @ G1 @ G22 @ ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( product_map_prod @ A @ E @ B @ F @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F @ B @ G22 @ F22 ) @ V ) ) )).

% prod.map_comp
thf(fact_217_map__prod_Ocompositionality,axiom,(
    ! [D: $tType,F: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F3: ( C > E ),G3: ( D > F ),H: ( A > C ),I: ( B > D ),Prod: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F @ F3 @ G3 @ ( product_map_prod @ A @ C @ B @ D @ H @ I @ Prod ) )
      = ( product_map_prod @ A @ E @ B @ F @ ( comp @ C @ E @ A @ F3 @ H ) @ ( comp @ D @ F @ B @ G3 @ I ) @ Prod ) ) )).

% map_prod.compositionality
thf(fact_218_map__prod__compose,axiom,(
    ! [D: $tType,C: $tType,A: $tType,E: $tType,F: $tType,B: $tType,F1: ( E > C ),F22: ( A > E ),G1: ( F > D ),G22: ( B > F )] :
      ( ( product_map_prod @ A @ C @ B @ D @ ( comp @ E @ C @ A @ F1 @ F22 ) @ ( comp @ F @ D @ B @ G1 @ G22 ) )
      = ( comp @ ( product_prod @ E @ F ) @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ E @ C @ F @ D @ F1 @ G1 ) @ ( product_map_prod @ A @ E @ B @ F @ F22 @ G22 ) ) ) )).

% map_prod_compose
thf(fact_219_map__prod_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E: $tType,F: $tType,D: $tType,B: $tType,F3: ( C > E ),G3: ( D > F ),H: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ ( product_prod @ E @ F ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ E @ D @ F @ F3 @ G3 ) @ ( product_map_prod @ A @ C @ B @ D @ H @ I ) )
      = ( product_map_prod @ A @ E @ B @ F @ ( comp @ C @ E @ A @ F3 @ H ) @ ( comp @ D @ F @ B @ G3 @ I ) ) ) )).

% map_prod.comp
thf(fact_220_inf__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_left_commute
thf(fact_221_inf_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C3: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A2 @ C3 ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C3 ) ) ) ) )).

% inf.left_commute
thf(fact_222_inf__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X5: A,Y4: A] :
              ( inf_inf @ A @ Y4 @ X5 ) ) ) ) )).

% inf_commute
thf(fact_223_inf_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [A8: A,B7: A] :
              ( inf_inf @ A @ B7 @ A8 ) ) ) ) )).

% inf.commute
thf(fact_224_inf__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_assoc
thf(fact_225_inf_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C3 )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C3 ) ) ) ) )).

% inf.assoc
thf(fact_226_Int__left__commute,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A7 @ ( inf_inf @ ( set @ A ) @ B8 @ C4 ) )
      = ( inf_inf @ ( set @ A ) @ B8 @ ( inf_inf @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% Int_left_commute
thf(fact_227_inf__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G5: ( A > B ),X5: A] :
              ( inf_inf @ B @ ( F4 @ X5 ) @ ( G5 @ X5 ) ) ) ) ) )).

% inf_fun_def
thf(fact_228_Int__left__absorb,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A7 @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) )
      = ( inf_inf @ ( set @ A ) @ A7 @ B8 ) ) )).

% Int_left_absorb
thf(fact_229_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A9: ( set @ A ),B9: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B9 @ A9 ) ) ) )).

% Int_commute
thf(fact_230_Int__absorb,axiom,(
    ! [A: $tType,A7: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A7 @ A7 )
      = A7 ) )).

% Int_absorb
thf(fact_231_Int__assoc,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) @ C4 )
      = ( inf_inf @ ( set @ A ) @ A7 @ ( inf_inf @ ( set @ A ) @ B8 @ C4 ) ) ) )).

% Int_assoc
thf(fact_232_IntD2,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) )
     => ( member @ A @ C3 @ B8 ) ) )).

% IntD2
thf(fact_233_IntD1,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) )
     => ( member @ A @ C3 @ A7 ) ) )).

% IntD1
thf(fact_234_IntE,axiom,(
    ! [A: $tType,C3: A,A7: ( set @ A ),B8: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) )
     => ~ ( ( member @ A @ C3 @ A7 )
         => ~ ( member @ A @ C3 @ B8 ) ) ) )).

% IntE
thf(fact_235_inf__sup__aci_I1_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X5: A,Y4: A] :
              ( inf_inf @ A @ Y4 @ X5 ) ) ) ) )).

% inf_sup_aci(1)
thf(fact_236_inf__sup__aci_I2_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(2)
thf(fact_237_inf__sup__aci_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(3)
thf(fact_238_inf__sup__aci_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_sup_aci(4)
thf(fact_239_vimage__inter__cong,axiom,(
    ! [B: $tType,A: $tType,S3: ( set @ A ),F3: ( A > B ),G3: ( A > B ),Y: ( set @ B )] :
      ( ! [W: A] :
          ( ( member @ A @ W @ S3 )
         => ( ( F3 @ W )
            = ( G3 @ W ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F3 @ Y ) @ S3 )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G3 @ Y ) @ S3 ) ) ) )).

% vimage_inter_cong
thf(fact_240_sup__inf__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z @ X ) ) ) ) )).

% sup_inf_distrib2
thf(fact_241_sup__inf__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_inf_distrib1
thf(fact_242_inf__sup__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z @ X ) ) ) ) )).

% inf_sup_distrib2
thf(fact_243_inf__sup__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_sup_distrib1
thf(fact_244_distrib__imp2,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y3: A,Z2: A] :
              ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y3 @ Z2 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y3 ) @ ( sup_sup @ A @ X3 @ Z2 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ) )).

% distrib_imp2
thf(fact_245_distrib__imp1,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y3: A,Z2: A] :
              ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y3 @ Z2 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y3 ) @ ( inf_inf @ A @ X3 @ Z2 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ) )).

% distrib_imp1
thf(fact_246_Un__Int__distrib2,axiom,(
    ! [A: $tType,B8: ( set @ A ),C4: ( set @ A ),A7: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B8 @ C4 ) @ A7 )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B8 @ A7 ) @ ( sup_sup @ ( set @ A ) @ C4 @ A7 ) ) ) )).

% Un_Int_distrib2
thf(fact_247_Int__Un__distrib2,axiom,(
    ! [A: $tType,B8: ( set @ A ),C4: ( set @ A ),A7: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B8 @ C4 ) @ A7 )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B8 @ A7 ) @ ( inf_inf @ ( set @ A ) @ C4 @ A7 ) ) ) )).

% Int_Un_distrib2
thf(fact_248_Un__Int__distrib,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A7 @ ( inf_inf @ ( set @ A ) @ B8 @ C4 ) )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) @ ( sup_sup @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% Un_Int_distrib
thf(fact_249_Int__Un__distrib,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A7 @ ( sup_sup @ ( set @ A ) @ B8 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) @ ( inf_inf @ ( set @ A ) @ A7 @ C4 ) ) ) )).

% Int_Un_distrib
thf(fact_250_Un__Int__crazy,axiom,(
    ! [A: $tType,A7: ( set @ A ),B8: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A7 @ B8 ) @ ( inf_inf @ ( set @ A ) @ B8 @ C4 ) ) @ ( inf_inf @ ( set @ A ) @ C4 @ A7 ) )
      = ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A7 @ B8 ) @ ( sup_sup @ ( set @ A ) @ B8 @ C4 ) ) @ ( sup_sup @ ( set @ A ) @ C4 @ A7 ) ) ) )).

% Un_Int_crazy
thf(fact_251_type__copy__map__comp0__undo,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,D: $tType,F: $tType,Rep: ( A > B ),Abs: ( B > A ),Rep2: ( C > D ),Abs2: ( D > C ),Rep3: ( E > F ),Abs3: ( F > E ),M: ( F > D ),M1: ( B > D ),M2: ( F > B )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( type_definition @ C @ D @ Rep2 @ Abs2 @ ( top_top @ ( set @ D ) ) )
       => ( ( type_definition @ E @ F @ Rep3 @ Abs3 @ ( top_top @ ( set @ F ) ) )
         => ( ( ( comp @ F @ C @ E @ ( comp @ D @ C @ F @ Abs2 @ M ) @ Rep3 )
              = ( comp @ A @ C @ E @ ( comp @ B @ C @ A @ ( comp @ D @ C @ B @ Abs2 @ M1 ) @ Rep ) @ ( comp @ F @ A @ E @ ( comp @ B @ A @ F @ Abs @ M2 ) @ Rep3 ) ) )
           => ( ( comp @ B @ D @ F @ M1 @ M2 )
              = M ) ) ) ) ) )).

% type_copy_map_comp0_undo
thf(fact_252_prod__fun__imageE,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C3: ( product_prod @ A @ B ),F3: ( C > A ),G3: ( D > B ),R2: ( set @ ( product_prod @ C @ D ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C3 @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F3 @ G3 ) @ R2 ) )
     => ~ ( ! [X3: C,Y3: D] :
              ( ( C3
                = ( product_Pair @ A @ B @ ( F3 @ X3 ) @ ( G3 @ Y3 ) ) )
             => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X3 @ Y3 ) @ R2 ) ) ) ) )).

% prod_fun_imageE
thf(fact_253_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G3: ( C > B ),X: C,N: ( D > A ),H: ( C > D ),F3: ( A > E )] :
      ( ( ( M @ ( G3 @ X ) )
        = ( N @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F3 @ M ) @ G3 @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F3 @ N ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_254_type__definition_OAbs__image,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A7: ( set @ A )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A7 )
     => ( ( image @ A @ B @ Abs @ A7 )
        = ( top_top @ ( set @ B ) ) ) ) )).

% type_definition.Abs_image
thf(fact_255_type__definition_ORep__range,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A7: ( set @ A )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A7 )
     => ( ( image @ B @ A @ Rep @ ( top_top @ ( set @ B ) ) )
        = A7 ) ) )).

% type_definition.Rep_range

%----Type constructors (21)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A5: $tType] :
      ( bounded_lattice @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounde1561333602nf_top @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice_top @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( semilattice_sup @ A10 @ ( type2 @ A10 ) )
     => ( semilattice_sup @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( semilattice_inf @ A10 @ ( type2 @ A10 ) )
     => ( semilattice_inf @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( distrib_lattice @ A10 @ ( type2 @ A10 ) )
     => ( distrib_lattice @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A5: $tType,A10: $tType] :
      ( ( lattice @ A10 @ ( type2 @ A10 ) )
     => ( lattice @ ( A5 > A10 ) @ ( type2 @ ( A5 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_3,axiom,(
    ! [A5: $tType] :
      ( bounde1561333602nf_top @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_4,axiom,(
    ! [A5: $tType] :
      ( bounded_lattice_top @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_5,axiom,(
    ! [A5: $tType] :
      ( semilattice_sup @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_6,axiom,(
    ! [A5: $tType] :
      ( semilattice_inf @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_7,axiom,(
    ! [A5: $tType] :
      ( distrib_lattice @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_8,axiom,(
    ! [A5: $tType] :
      ( lattice @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_9,axiom,
    ( bounde1561333602nf_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_10,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_11,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_12,axiom,
    ( semilattice_inf @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_13,axiom,
    ( distrib_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_14,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (4)
thf(conj_0,hypothesis,(
    $true )).

thf(conj_1,hypothesis,(
    $true )).

thf(conj_2,hypothesis,(
    $true )).

thf(conj_3,conjecture,(
    ? [Tr14: dtree,Tr24: dtree] :
      ( ( trA
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr14 @ Tr24 ) ) )
      & ( ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr2 @ tr1 ) )
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr24 @ Tr14 ) ) ) ) )).

%------------------------------------------------------------------------------
