%------------------------------------------------------------------------------
% File     : COM210^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Computing Theory
% Problem  : Parallel extension to grammars and languages 140
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : parallel__140.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  351 (   0 unit;  58 type;   0 defn)
%            Number of atoms       : 4483 ( 313 equality;2592 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 3996 (  60   ~;   4   |;  23   &;3714   @)
%                                         (   0 <=>; 195  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  245 ( 245   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   60 (  58   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1192 (   1 sgn;1054   !;  22   ?;  47   ^)
%                                         (1192   :;  69  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:39:23.004
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_DTree_Odtree,type,(
    dtree: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_DTree_OT,type,(
    t: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

%----Explicit typings (52)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Odistrib__lattice,type,(
    distrib_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__inf,type,(
    semilattice_inf: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,(
    bounde1561333602nf_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_DTree_Ocont,type,(
    cont: dtree > ( set @ ( sum_sum @ t @ dtree ) ) )).

thf(sy_c_Fun_Oswap,type,(
    swap: 
      !>[A: $tType,B: $tType] :
        ( A > A > ( A > B ) > A > B ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Parallel__Mirabelle__hykpkoupgu_Opar,type,(
    parall1899940088le_par: ( product_prod @ dtree @ dtree ) > dtree )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Odisjnt,type,(
    disjnt: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OPlus,type,(
    sum_Plus: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) )).

thf(sy_c_Sum__Type_OSuml,type,(
    sum_Suml: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_OSumr,type,(
    sum_Sumr: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_Sum__Type_Oold_Osum_Orec__sum,type,(
    sum_rec_sum: 
      !>[A: $tType,T: $tType,B: $tType] :
        ( ( A > T ) > ( B > T ) > ( sum_sum @ A @ B ) > T ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_tr1_H____,type,(
    tr1: dtree )).

thf(sy_v_tr1a____,type,(
    tr1a: dtree )).

thf(sy_v_tr2_H____,type,(
    tr2: dtree )).

thf(sy_v_tr2a____,type,(
    tr2a: dtree )).

thf(sy_v_tr3_H____,type,(
    tr3: dtree )).

thf(sy_v_tr3a____,type,(
    tr3a: dtree )).

thf(sy_v_trA____,type,(
    trA: dtree )).

thf(sy_v_trB_H____,type,(
    trB: dtree )).

thf(sy_v_trB____,type,(
    trB2: dtree )).

%----Relevant facts (256)
thf(fact_0__092_060open_062Inr_Atr1_H_A_092_060in_062_Acont_Atr1_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr1 ) @ ( cont @ tr1a ) )).

% \<open>Inr tr1' \<in> cont tr1\<close>
thf(fact_1__092_060open_062Inr_Atr2_H_A_092_060in_062_Acont_Atr2_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr2 ) @ ( cont @ tr2a ) )).

% \<open>Inr tr2' \<in> cont tr2\<close>
thf(fact_2__092_060open_062Inr_Atr3_H_A_092_060in_062_Acont_Atr3_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ tr3 ) @ ( cont @ tr3a ) )).

% \<open>Inr tr3' \<in> cont tr3\<close>
thf(fact_3__092_060open_062trB_H_A_061_Atr1_H_A_092_060parallel_062_Atr2_H_A_092_060parallel_062_Atr3_H_092_060close_062,axiom,
    ( trB
    = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1 @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr2 @ tr3 ) ) ) ) )).

% \<open>trB' = tr1' \<parallel> tr2' \<parallel> tr3'\<close>
thf(fact_4__092_060open_062_092_060exists_062tr1_Atr2_Atr3_O_AtrA_A_061_A_Itr1_A_092_060parallel_062_Atr2_J_A_092_060parallel_062_Atr3_A_092_060and_062_AtrB_A_061_Atr1_A_092_060parallel_062_Atr2_A_092_060parallel_062_Atr3_092_060close_062,axiom,(
    ? [Tr1: dtree,Tr2: dtree,Tr3: dtree] :
      ( ( trA
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) @ Tr3 ) ) )
      & ( trB2
        = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr1 @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr2 @ Tr3 ) ) ) ) ) ) )).

% \<open>\<exists>tr1 tr2 tr3. trA = (tr1 \<parallel> tr2) \<parallel> tr3 \<and> trB = tr1 \<parallel> tr2 \<parallel> tr3\<close>
thf(fact_5__092_060open_062Inr_AtrB_H_A_092_060in_062_Acont_A_Itr1_A_092_060parallel_062_Atr2_A_092_060parallel_062_Atr3_J_092_060close_062,axiom,
    ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ trB ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1a @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr2a @ tr3a ) ) ) ) ) )).

% \<open>Inr trB' \<in> cont (tr1 \<parallel> tr2 \<parallel> tr3)\<close>
thf(fact_6__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062tr1_H_Atr2_H_Atr3_H_O_A_092_060lbrakk_062trB_H_A_061_Atr1_H_A_092_060parallel_062_Atr2_H_A_092_060parallel_062_Atr3_H_059_AInr_Atr1_H_A_092_060in_062_Acont_Atr1_059_AInr_Atr2_H_A_092_060in_062_Acont_Atr2_059_AInr_Atr3_H_A_092_060in_062_Acont_Atr3_092_060rbrakk_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [Tr12: dtree,Tr22: dtree,Tr32: dtree] :
          ( ( trB
            = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr12 @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr22 @ Tr32 ) ) ) ) )
         => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr12 ) @ ( cont @ tr1a ) )
           => ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr22 ) @ ( cont @ tr2a ) )
             => ~ ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t @ Tr32 ) @ ( cont @ tr3a ) ) ) ) ) ) )).

% \<open>\<And>thesis. (\<And>tr1' tr2' tr3'. \<lbrakk>trB' = tr1' \<parallel> tr2' \<parallel> tr3'; Inr tr1' \<in> cont tr1; Inr tr2' \<in> cont tr2; Inr tr3' \<in> cont tr3\<rbrakk> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_7_par__com,axiom,(
    ! [Tr13: dtree,Tr23: dtree] :
      ( ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr13 @ Tr23 ) )
      = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr23 @ Tr13 ) ) ) )).

% par_com
thf(fact_8_par__r_Ocases,axiom,(
    ! [X: ( product_prod @ dtree @ dtree )] :
      ~ ( ! [Tr1: dtree,Tr2: dtree] :
            ( X
           != ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) ) ) )).

% par_r.cases
thf(fact_9_par__r_Oinduct,axiom,(
    ! [P: ( ( product_prod @ dtree @ dtree ) > $o ),A0: ( product_prod @ dtree @ dtree )] :
      ( ! [Tr1: dtree,Tr2: dtree] :
          ( P @ ( product_Pair @ dtree @ dtree @ Tr1 @ Tr2 ) )
     => ( P @ A0 ) ) )).

% par_r.induct
thf(fact_10_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: A,B3: ( set @ A )] :
      ( ( ( F @ A2 )
        = B2 )
     => ( ( member @ A @ B2 @ B3 )
       => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ B3 ) ) ) ) )).

% vimageI
thf(fact_11_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
      = ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimage_eq
thf(fact_12_sum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y2: B] :
      ( ( ( sum_Inr @ B @ A @ X2 )
        = ( sum_Inr @ B @ A @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% sum.inject(2)
thf(fact_13_old_Osum_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,B2: B,B4: B] :
      ( ( ( sum_Inr @ B @ A @ B2 )
        = ( sum_Inr @ B @ A @ B4 ) )
      = ( B2 = B4 ) ) )).

% old.sum.inject(2)
thf(fact_14_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X2 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% prod.inject
thf(fact_15_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B4 ) )
      = ( ( A2 = A3 )
        & ( B2 = B4 ) ) ) )).

% old.prod.inject
thf(fact_16_vimageD,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),A4: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ A4 ) )
     => ( member @ B @ ( F @ A2 ) @ A4 ) ) )).

% vimageD
thf(fact_17_vimageE,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
     => ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimageE
thf(fact_18_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,A4: ( set @ A )] :
      ( ( member @ A @ ( F @ A2 ) @ A4 )
     => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ A4 ) ) ) )).

% vimageI2
thf(fact_19_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ ( F @ X3 ) )
          = ( Q @ X3 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_20_Inr__inject,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: B] :
      ( ( ( sum_Inr @ B @ A @ X )
        = ( sum_Inr @ B @ A @ Y ) )
     => ( X = Y ) ) )).

% Inr_inject
thf(fact_21_not__arg__cong__Inr,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( X != Y )
     => ( ( sum_Inr @ A @ B @ X )
       != ( sum_Inr @ A @ B @ Y ) ) ) )).

% not_arg_cong_Inr
thf(fact_22_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A5: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_23_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A5: A,B5: B] :
            ( Y
           != ( product_Pair @ A @ B @ A5 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_24_prod__induct7,axiom,(
    ! [G: $tType,F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) ) )] :
      ( ! [A5: A,B5: B,C2: C,D2: D,E2: E,F3: F2,G2: G] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G ) @ E2 @ ( product_Pair @ F2 @ G @ F3 @ G2 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_25_prod__induct6,axiom,(
    ! [F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ( ! [A5: A,B5: B,C2: C,D2: D,E2: E,F3: F2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_26_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A5: A,B5: B,C2: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_27_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A5: A,B5: B,C2: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_28_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A5: A,B5: B,C2: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C2 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_29_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,G: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C2: C,D2: D,E2: E,F3: F2,G2: G] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G ) @ E2 @ ( product_Pair @ F2 @ G @ F3 @ G2 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_30_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C2: C,D2: D,E2: E,F3: F2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_31_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A5: A,B5: B,C2: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_32_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A5: A,B5: B,C2: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_33_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A5: A,B5: B,C2: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C2 ) ) ) ) )).

% prod_cases3
thf(fact_34_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B4 ) )
     => ~ ( ( A2 = A3 )
         => ( B2 != B4 ) ) ) )).

% Pair_inject
thf(fact_35_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A5: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_36_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y3: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y3 ) ) )).

% surj_pair
thf(fact_37_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_38_old_Osum_Osimps_I8_J,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > T ),F22: ( B > T ),B2: B] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inr @ B @ A @ B2 ) )
      = ( F22 @ B2 ) ) )).

% old.sum.simps(8)
thf(fact_39_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C3: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C3 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C3 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_40_Sumr_Osimps,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),X: B] :
      ( ( sum_Sumr @ B @ C @ A @ F @ ( sum_Inr @ B @ A @ X ) )
      = ( F @ X ) ) )).

% Sumr.simps
thf(fact_41_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B2: A,F: ( B > A ),X: B,C3: C,G3: ( B > C ),A4: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( C3
          = ( G3 @ X ) )
       => ( ( member @ B @ X @ A4 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C3 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A4 @ F @ G3 ) ) ) ) ) )).

% image2_eqI
thf(fact_42_Inl__in__cont__par,axiom,(
    ! [T2: t,Tr13: dtree,Tr23: dtree] :
      ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr13 @ Tr23 ) ) ) )
      = ( ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr13 ) )
        | ( member @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree @ T2 ) @ ( cont @ Tr23 ) ) ) ) )).

% Inl_in_cont_par
thf(fact_43_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R2: ( set @ ( product_prod @ A @ B ) ),S2: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R2 )
     => ( ( S2 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R2 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_44_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F4: ( ( product_prod @ B @ C ) > A ),A6: B,B6: C] :
            ( F4 @ ( product_Pair @ B @ C @ A6 @ B6 ) ) ) ) )).

% curry_conv
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G3: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G3 @ X3 ) )
     => ( F = G3 ) ) )).

% ext
thf(fact_49_curryI,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( product_curry @ A @ B @ $o @ F @ A2 @ B2 ) ) )).

% curryI
thf(fact_50_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X ) ) )).

% swap_simp
thf(fact_51_sum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,X1: A,Y1: A] :
      ( ( ( sum_Inl @ A @ B @ X1 )
        = ( sum_Inl @ A @ B @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sum.inject(1)
thf(fact_52_old_Osum_Oinject_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: A] :
      ( ( ( sum_Inl @ A @ B @ A2 )
        = ( sum_Inl @ A @ B @ A3 ) )
      = ( A2 = A3 ) ) )).

% old.sum.inject(1)
thf(fact_53_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P2 ) )
      = P2 ) )).

% swap_swap
thf(fact_54_old_Osum_Osimps_I7_J,axiom,(
    ! [B: $tType,T: $tType,A: $tType,F1: ( A > T ),F22: ( B > T ),A2: A] :
      ( ( sum_rec_sum @ A @ T @ B @ F1 @ F22 @ ( sum_Inl @ A @ B @ A2 ) )
      = ( F1 @ A2 ) ) )).

% old.sum.simps(7)
thf(fact_55_Inl__inject,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: A] :
      ( ( ( sum_Inl @ A @ B @ X )
        = ( sum_Inl @ A @ B @ Y ) )
     => ( X = Y ) ) )).

% Inl_inject
thf(fact_56_Sumr__inject,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( B > C ),G3: ( B > C )] :
      ( ( ( sum_Sumr @ B @ C @ A @ F )
        = ( sum_Sumr @ B @ C @ A @ G3 ) )
     => ( F = G3 ) ) )).

% Sumr_inject
thf(fact_57_sum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B] :
      ( ( sum_Inl @ A @ B @ X1 )
     != ( sum_Inr @ B @ A @ X2 ) ) )).

% sum.distinct(1)
thf(fact_58_old_Osum_Odistinct_I2_J,axiom,(
    ! [B7: $tType,A7: $tType,B8: B7,A8: A7] :
      ( ( sum_Inr @ B7 @ A7 @ B8 )
     != ( sum_Inl @ A7 @ B7 @ A8 ) ) )).

% old.sum.distinct(2)
thf(fact_59_old_Osum_Odistinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: A,B4: B] :
      ( ( sum_Inl @ A @ B @ A2 )
     != ( sum_Inr @ B @ A @ B4 ) ) )).

% old.sum.distinct(1)
thf(fact_60_sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [Y3: B] :
              ( S
             != ( sum_Inr @ B @ A @ Y3 ) ) ) ) )).

% sumE
thf(fact_61_Inr__not__Inl,axiom,(
    ! [B: $tType,A: $tType,B2: B,A2: A] :
      ( ( sum_Inr @ B @ A @ B2 )
     != ( sum_Inl @ A @ B @ A2 ) ) )).

% Inr_not_Inl
thf(fact_62_split__sum__ex,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ? [X5: ( sum_sum @ A @ B )] :
            ( P3 @ X5 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ? [X4: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X4 ) )
            | ? [X4: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% split_sum_ex
thf(fact_63_split__sum__all,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [P3: ( ( sum_sum @ A @ B ) > $o )] :
          ! [X5: ( sum_sum @ A @ B )] :
            ( P3 @ X5 ) )
      = ( ^ [P4: ( ( sum_sum @ A @ B ) > $o )] :
            ( ! [X4: A] :
                ( P4 @ ( sum_Inl @ A @ B @ X4 ) )
            & ! [X4: B] :
                ( P4 @ ( sum_Inr @ B @ A @ X4 ) ) ) ) ) )).

% split_sum_all
thf(fact_64_old_Osum_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( sum_sum @ A @ B )] :
      ( ! [A5: A] :
          ( Y
         != ( sum_Inl @ A @ B @ A5 ) )
     => ~ ( ! [B5: B] :
              ( Y
             != ( sum_Inr @ B @ A @ B5 ) ) ) ) )).

% old.sum.exhaust
thf(fact_65_old_Osum_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( sum_sum @ A @ B ) > $o ),Sum: ( sum_sum @ A @ B )] :
      ( ! [A5: A] :
          ( P @ ( sum_Inl @ A @ B @ A5 ) )
     => ( ! [B5: B] :
            ( P @ ( sum_Inr @ B @ A @ B5 ) )
       => ( P @ Sum ) ) ) )).

% old.sum.inducts
thf(fact_66_obj__sumE,axiom,(
    ! [A: $tType,B: $tType,S: ( sum_sum @ A @ B )] :
      ( ! [X3: A] :
          ( S
         != ( sum_Inl @ A @ B @ X3 ) )
     => ~ ( ! [X3: B] :
              ( S
             != ( sum_Inr @ B @ A @ X3 ) ) ) ) )).

% obj_sumE
thf(fact_67_curryD,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryD
thf(fact_68_curryE,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryE
thf(fact_69_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_70_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_71_Inl__Inr__image__cong,axiom,(
    ! [B: $tType,A: $tType,A4: ( set @ ( sum_sum @ A @ B ) ),B3: ( set @ ( sum_sum @ A @ B ) )] :
      ( ( ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A4 )
        = ( vimage @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ B3 ) )
     => ( ( ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ A4 )
          = ( vimage @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B3 ) )
       => ( A4 = B3 ) ) ) )).

% Inl_Inr_image_cong
thf(fact_72_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X3: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X3 ) ) )
         => P )
     => ( ! [X3: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X3 ) ) )
           => P )
       => ! [X6: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X6 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_73_Inl__cont__par,axiom,(
    ! [Tr13: dtree,Tr23: dtree] :
      ( ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr13 @ Tr23 ) ) ) )
      = ( vimage @ t @ ( sum_sum @ t @ dtree ) @ ( sum_Inl @ t @ dtree ) @ ( sup_sup @ ( set @ ( sum_sum @ t @ dtree ) ) @ ( cont @ Tr13 ) @ ( cont @ Tr23 ) ) ) ) )).

% Inl_cont_par
thf(fact_74_Suml_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),X: A] :
      ( ( sum_Suml @ A @ C @ B @ F @ ( sum_Inl @ A @ B @ X ) )
      = ( F @ X ) ) )).

% Suml.simps
thf(fact_75_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y: A,X: B,A4: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A4 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X @ Y ) @ A4 ) ) )).

% pair_in_swap_image
thf(fact_76_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_77_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B,A4: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( member @ B @ X @ A4 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A4 ) ) ) ) )).

% image_eqI
thf(fact_78_Un__iff,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
      = ( ( member @ A @ C3 @ A4 )
        | ( member @ A @ C3 @ B3 ) ) ) )).

% Un_iff
thf(fact_79_UnCI,axiom,(
    ! [A: $tType,C3: A,B3: ( set @ A ),A4: ( set @ A )] :
      ( ( ~ ( member @ A @ C3 @ B3 )
       => ( member @ A @ C3 @ A4 ) )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) ) )).

% UnCI
thf(fact_80_vimage__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A4: ( set @ B ),B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ A4 ) @ ( vimage @ A @ B @ F @ B3 ) ) ) )).

% vimage_Un
thf(fact_81_curry__case__prod,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C )] :
      ( ( product_curry @ A @ B @ C @ ( product_case_prod @ A @ B @ C @ F ) )
      = F ) )).

% curry_case_prod
thf(fact_82_case__prod__curry,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C @ ( product_curry @ A @ B @ C @ F ) )
      = F ) )).

% case_prod_curry
thf(fact_83_Un__left__commute,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A4 @ C4 ) ) ) )).

% Un_left_commute
thf(fact_84_Un__left__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) )).

% Un_left_absorb
thf(fact_85_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A4: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X @ A4 )
     => ( ( B2
          = ( F @ X ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A4 ) ) ) ) )).

% rev_image_eqI
thf(fact_86_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A4 ) )
         => ( P @ X3 ) )
     => ! [X6: B] :
          ( ( member @ B @ X6 @ A4 )
         => ( P @ ( F @ X6 ) ) ) ) )).

% ball_imageD
thf(fact_87_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F: ( A > B ),G3: ( A > B )] :
      ( ( M = N )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ N )
           => ( ( F @ X3 )
              = ( G3 @ X3 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G3 @ N ) ) ) ) )).

% image_cong
thf(fact_88_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),P: ( A > $o )] :
      ( ? [X6: A] :
          ( ( member @ A @ X6 @ ( image @ B @ A @ F @ A4 ) )
          & ( P @ X6 ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A4 )
          & ( P @ ( F @ X3 ) ) ) ) )).

% bex_imageD
thf(fact_89_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A9: ( set @ A ),B9: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B9 @ A9 ) ) ) )).

% Un_commute
thf(fact_90_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z: A,F: ( B > A ),A4: ( set @ B )] :
      ( ( member @ A @ Z @ ( image @ B @ A @ F @ A4 ) )
      = ( ? [X4: B] :
            ( ( member @ B @ X4 @ A4 )
            & ( Z
              = ( F @ X4 ) ) ) ) ) )).

% image_iff
thf(fact_91_Un__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ A4 )
      = A4 ) )).

% Un_absorb
thf(fact_92_image__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B ),B3: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A4 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F @ A4 ) @ ( image @ B @ A @ F @ B3 ) ) ) )).

% image_Un
thf(fact_93_Un__assoc,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) @ C4 )
      = ( sup_sup @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Un_assoc
thf(fact_94_ball__Un,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
           => ( P @ X4 ) ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ A4 )
           => ( P @ X4 ) )
        & ! [X4: A] :
            ( ( member @ A @ X4 @ B3 )
           => ( P @ X4 ) ) ) ) )).

% ball_Un
thf(fact_95_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A4: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A4 )
     => ( member @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A4 ) ) ) )).

% imageI
thf(fact_96_bex__Un,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
            & ( P @ X4 ) ) )
      = ( ? [X4: A] :
            ( ( member @ A @ X4 @ A4 )
            & ( P @ X4 ) )
        | ? [X4: A] :
            ( ( member @ A @ X4 @ B3 )
            & ( P @ X4 ) ) ) ) )).

% bex_Un
thf(fact_97_UnI2,axiom,(
    ! [A: $tType,C3: A,B3: ( set @ A ),A4: ( set @ A )] :
      ( ( member @ A @ C3 @ B3 )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) ) )).

% UnI2
thf(fact_98_UnI1,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ A4 )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) ) ) )).

% UnI1
thf(fact_99_UnE,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) )
     => ( ~ ( member @ A @ C3 @ A4 )
       => ( member @ A @ C3 @ B3 ) ) ) )).

% UnE
thf(fact_100_Suml__inject,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C ),G3: ( A > C )] :
      ( ( ( sum_Suml @ A @ C @ B @ F )
        = ( sum_Suml @ A @ C @ B @ G3 ) )
     => ( F = G3 ) ) )).

% Suml_inject
thf(fact_101_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z: A,C3: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C3 @ P2 ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( member @ A @ Z @ ( C3 @ X3 @ Y3 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_102_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X1: A,X2: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X2 ) )
      = ( F @ X1 @ X2 ) ) )).

% old.prod.case
thf(fact_103_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B ),X4: A] :
              ( sup_sup @ B @ ( F4 @ X4 ) @ ( G4 @ X4 ) ) ) ) ) )).

% sup_apply
thf(fact_104_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_105_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_106_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.left_idem
thf(fact_107_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_108_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.right_idem
thf(fact_109_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_left_commute
thf(fact_110_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C3: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A2 @ C3 ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C3 ) ) ) ) )).

% sup.left_commute
thf(fact_111_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X4: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X4 ) ) ) ) )).

% sup_commute
thf(fact_112_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A6: A,B6: A] :
              ( sup_sup @ A @ B6 @ A6 ) ) ) ) )).

% sup.commute
thf(fact_113_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% sup_assoc
thf(fact_114_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ C3 )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C3 ) ) ) ) )).

% sup.assoc
thf(fact_115_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B ),X4: A] :
              ( sup_sup @ B @ ( F4 @ X4 ) @ ( G4 @ X4 ) ) ) ) ) )).

% sup_fun_def
thf(fact_116_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X4: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X4 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_117_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_118_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_119_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_120_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F: ( A > B > C ),G3: ( A > B > C ),P2: ( product_prod @ A @ B )] :
      ( ! [X3: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y3 )
            = Q2 )
         => ( ( F @ X3 @ Y3 )
            = ( G3 @ X3 @ Y3 ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F @ P2 )
          = ( product_case_prod @ A @ B @ C @ G3 @ Q2 ) ) ) ) )).

% split_cong
thf(fact_121_Plus__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B )
      = ( ^ [A9: ( set @ A ),B9: ( set @ B )] :
            ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ A9 ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ B9 ) ) ) ) )).

% Plus_def
thf(fact_122_surj__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% surj_swap
thf(fact_123_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ B ),B3: ( set @ B ),C4: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A4 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C4 @ A4 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B3 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_124_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ B ),B3: ( set @ B ),C4: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A4 = B3 )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ B3 )
           => ( ( C4 @ X3 )
              = ( D3 @ X3 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C4 @ A4 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B3 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_125_UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_126_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_127_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_128_vimage__UNIV,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% vimage_UNIV
thf(fact_129_UNIV__Plus__UNIV,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_Plus @ A @ B @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ B ) ) )
      = ( top_top @ ( set @ ( sum_sum @ A @ B ) ) ) ) )).

% UNIV_Plus_UNIV
thf(fact_130_InrI,axiom,(
    ! [B: $tType,A: $tType,B2: A,B3: ( set @ A ),A4: ( set @ B )] :
      ( ( member @ A @ B2 @ B3 )
     => ( member @ ( sum_sum @ B @ A ) @ ( sum_Inr @ A @ B @ B2 ) @ ( sum_Plus @ B @ A @ A4 @ B3 ) ) ) )).

% InrI
thf(fact_131_InlI,axiom,(
    ! [A: $tType,B: $tType,A2: A,A4: ( set @ A ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ A4 )
     => ( member @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ A2 ) @ ( sum_Plus @ A @ B @ A4 @ B3 ) ) ) )).

% InlI
thf(fact_132_rangeI,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X: B] :
      ( member @ A @ ( F @ X ) @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_133_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B] :
      ( ( B2
        = ( F @ X ) )
     => ( member @ A @ B2 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_134_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_135_UNIV__eq__I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [X3: A] :
          ( member @ A @ X3 @ A4 )
     => ( ( top_top @ ( set @ A ) )
        = A4 ) ) )).

% UNIV_eq_I
thf(fact_136_Un__UNIV__right,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_137_Un__UNIV__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B3 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_138_UNIV__sum,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( top_top @ ( set @ ( sum_sum @ A @ B ) ) )
      = ( sup_sup @ ( set @ ( sum_sum @ A @ B ) ) @ ( image @ A @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B ) @ ( top_top @ ( set @ A ) ) ) @ ( image @ B @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A ) @ ( top_top @ ( set @ B ) ) ) ) ) )).

% UNIV_sum
thf(fact_139_PlusE,axiom,(
    ! [A: $tType,B: $tType,U: ( sum_sum @ A @ B ),A4: ( set @ A ),B3: ( set @ B )] :
      ( ( member @ ( sum_sum @ A @ B ) @ U @ ( sum_Plus @ A @ B @ A4 @ B3 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( U
             != ( sum_Inl @ A @ B @ X3 ) ) )
       => ~ ( ! [Y3: B] :
                ( ( member @ B @ Y3 @ B3 )
               => ( U
                 != ( sum_Inr @ B @ A @ Y3 ) ) ) ) ) ) )).

% PlusE
thf(fact_140_surj__image__vimage__eq,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A4: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ F @ ( vimage @ B @ A @ F @ A4 ) )
        = A4 ) ) )).

% surj_image_vimage_eq
thf(fact_141_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_142_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X4: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_143_surjD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X3: B] :
          ( Y
          = ( F @ X3 ) ) ) )).

% surjD
thf(fact_144_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_145_surj__def,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y4: A] :
          ? [X4: B] :
            ( Y4
            = ( F @ X4 ) ) ) ) )).

% surj_def
thf(fact_146_surjI,axiom,(
    ! [B: $tType,A: $tType,G3: ( B > A ),F: ( A > B )] :
      ( ! [X3: A] :
          ( ( G3 @ ( F @ X3 ) )
          = X3 )
     => ( ( image @ B @ A @ G3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_147_surjE,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X3: B] :
              ( Y
             != ( F @ X3 ) ) ) ) )).

% surjE
thf(fact_148_map__prod__surj,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( A > B ),G3: ( C > D )] :
      ( ( ( image @ A @ B @ F @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ B ) ) )
     => ( ( ( image @ C @ D @ G3 @ ( top_top @ ( set @ C ) ) )
          = ( top_top @ ( set @ D ) ) )
       => ( ( image @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F @ G3 ) @ ( top_top @ ( set @ ( product_prod @ A @ C ) ) ) )
          = ( top_top @ ( set @ ( product_prod @ B @ D ) ) ) ) ) ) )).

% map_prod_surj
thf(fact_149_image__vimage__eq,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ A )] :
      ( ( image @ B @ A @ F @ ( vimage @ B @ A @ F @ A4 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% image_vimage_eq
thf(fact_150_surj__swap__iff,axiom,(
    ! [B: $tType,A: $tType,A2: B,B2: B,F: ( B > A )] :
      ( ( ( image @ B @ A @ ( swap @ B @ A @ A2 @ B2 @ F ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_swap_iff
thf(fact_151_surj__vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A4: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( vimage @ B @ A @ F @ A4 )
          = ( bot_bot @ ( set @ B ) ) )
        = ( A4
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% surj_vimage_empty
thf(fact_152_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_153_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_154_all__not__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_155_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_156_inf__right__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_right_idem
thf(fact_157_inf_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.right_idem
thf(fact_158_inf__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_left_idem
thf(fact_159_inf_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B2 ) )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.left_idem
thf(fact_160_inf__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) )).

% inf_idem
thf(fact_161_inf_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) )).

% inf.idem
thf(fact_162_inf__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B ),X4: A] :
              ( inf_inf @ B @ ( F4 @ X4 ) @ ( G4 @ X4 ) ) ) ) ) )).

% inf_apply
thf(fact_163_Int__iff,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( ( member @ A @ C3 @ A4 )
        & ( member @ A @ C3 @ B3 ) ) ) )).

% Int_iff
thf(fact_164_IntI,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ A4 )
     => ( ( member @ A @ C3 @ B3 )
       => ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) ) ) )).

% IntI
thf(fact_165_top1I,axiom,(
    ! [A: $tType,X: A] :
      ( top_top @ ( A > $o ) @ X ) )).

% top1I
thf(fact_166_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_167_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_168_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A4: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_169_inf__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_right
thf(fact_170_inf__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_left
thf(fact_171_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_172_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_173_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A2 )
          = A2 ) ) )).

% sup_bot.left_neutral
thf(fact_174_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ ( bot_bot @ A ) )
          = A2 ) ) )).

% sup_bot.right_neutral
thf(fact_175_inf__sup__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) )).

% inf_sup_absorb
thf(fact_176_sup__inf__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) )).

% sup_inf_absorb
thf(fact_177_inf__top_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1561333602nf_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ ( top_top @ A ) )
          = A2 ) ) )).

% inf_top.right_neutral
thf(fact_178_inf__top_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1561333602nf_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A2 )
          = A2 ) ) )).

% inf_top.left_neutral
thf(fact_179_inf__eq__top__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) )).

% inf_eq_top_iff
thf(fact_180_Un__empty,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        & ( B3
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_181_Int__UNIV,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( top_top @ ( set @ A ) ) )
      = ( ( A4
          = ( top_top @ ( set @ A ) ) )
        & ( B3
          = ( top_top @ ( set @ A ) ) ) ) ) )).

% Int_UNIV
thf(fact_182_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_183_vimage__Int,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A4: ( set @ B ),B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( inf_inf @ ( set @ B ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ A4 ) @ ( vimage @ A @ B @ F @ B3 ) ) ) )).

% vimage_Int
thf(fact_184_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G3: ( D > B ),A2: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F @ G3 @ ( product_Pair @ C @ D @ A2 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F @ A2 ) @ ( G3 @ B2 ) ) ) )).

% map_prod_simp
thf(fact_185_Plus__eq__empty__conv,axiom,(
    ! [A: $tType,B: $tType,A4: ( set @ A ),B3: ( set @ B )] :
      ( ( ( sum_Plus @ A @ B @ A4 @ B3 )
        = ( bot_bot @ ( set @ ( sum_sum @ A @ B ) ) ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        & ( B3
          = ( bot_bot @ ( set @ B ) ) ) ) ) )).

% Plus_eq_empty_conv
thf(fact_186_swap__image__eq,axiom,(
    ! [B: $tType,A: $tType,A2: A,A4: ( set @ A ),B2: A,F: ( A > B )] :
      ( ( member @ A @ A2 @ A4 )
     => ( ( member @ A @ B2 @ A4 )
       => ( ( image @ A @ B @ ( swap @ A @ B @ A2 @ B2 @ F ) @ A4 )
          = ( image @ A @ B @ F @ A4 ) ) ) ) )).

% swap_image_eq
thf(fact_187_map__prod__imageI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A2: A,B2: B,R2: ( set @ ( product_prod @ A @ B ) ),F: ( A > C ),G3: ( B > D )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R2 )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F @ A2 ) @ ( G3 @ B2 ) ) @ ( image @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G3 ) @ R2 ) ) ) )).

% map_prod_imageI
thf(fact_188_inf__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) )).

% inf_top_right
thf(fact_189_inf__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X )
          = X ) ) )).

% inf_top_left
thf(fact_190_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_191_Int__UNIV__right,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( top_top @ ( set @ A ) ) )
      = A4 ) )).

% Int_UNIV_right
thf(fact_192_Int__UNIV__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B3 )
      = B3 ) )).

% Int_UNIV_left
thf(fact_193_top__conj_I1_J,axiom,(
    ! [A: $tType,X: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_194_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X ) )
      = P ) )).

% top_conj(2)
thf(fact_195_inf__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_left_commute
thf(fact_196_inf_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C3: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A2 @ C3 ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C3 ) ) ) ) )).

% inf.left_commute
thf(fact_197_inf__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X4: A,Y4: A] :
              ( inf_inf @ A @ Y4 @ X4 ) ) ) ) )).

% inf_commute
thf(fact_198_inf_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [A6: A,B6: A] :
              ( inf_inf @ A @ B6 @ A6 ) ) ) ) )).

% inf.commute
thf(fact_199_inf__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_assoc
thf(fact_200_inf_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C3: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C3 )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C3 ) ) ) ) )).

% inf.assoc
thf(fact_201_inf__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B ),X4: A] :
              ( inf_inf @ B @ ( F4 @ X4 ) @ ( G4 @ X4 ) ) ) ) ) )).

% inf_fun_def
thf(fact_202_inf__sup__aci_I1_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X4: A,Y4: A] :
              ( inf_inf @ A @ Y4 @ X4 ) ) ) ) )).

% inf_sup_aci(1)
thf(fact_203_inf__sup__aci_I2_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(2)
thf(fact_204_inf__sup__aci_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(3)
thf(fact_205_inf__sup__aci_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_sup_aci(4)
thf(fact_206_vimage__inter__cong,axiom,(
    ! [B: $tType,A: $tType,S3: ( set @ A ),F: ( A > B ),G3: ( A > B ),Y: ( set @ B )] :
      ( ! [W: A] :
          ( ( member @ A @ W @ S3 )
         => ( ( F @ W )
            = ( G3 @ W ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ Y ) @ S3 )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G3 @ Y ) @ S3 ) ) ) )).

% vimage_inter_cong
thf(fact_207_disjoint__iff__not__equal,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ A4 )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ B3 )
               => ( X4 != Y4 ) ) ) ) ) )).

% disjoint_iff_not_equal
thf(fact_208_Int__left__commute,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) )
      = ( inf_inf @ ( set @ A ) @ B3 @ ( inf_inf @ ( set @ A ) @ A4 @ C4 ) ) ) )).

% Int_left_commute
thf(fact_209_Int__left__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B3 ) ) )).

% Int_left_absorb
thf(fact_210_Int__empty__right,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_right
thf(fact_211_Int__empty__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_left
thf(fact_212_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A9: ( set @ A ),B9: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B9 @ A9 ) ) ) )).

% Int_commute
thf(fact_213_ex__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A4 ) )
      = ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_214_Int__emptyI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ~ ( member @ A @ X3 @ B3 ) )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B3 )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% Int_emptyI
thf(fact_215_Int__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ A4 )
      = A4 ) )).

% Int_absorb
thf(fact_216_Int__assoc,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ C4 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Int_assoc
thf(fact_217_equals0I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [Y3: A] :
          ~ ( member @ A @ Y3 @ A4 )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_218_equals0D,axiom,(
    ! [A: $tType,A4: ( set @ A ),A2: A] :
      ( ( A4
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A4 ) ) )).

% equals0D
thf(fact_219_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_220_IntD2,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ( member @ A @ C3 @ B3 ) ) )).

% IntD2
thf(fact_221_IntD1,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ( member @ A @ C3 @ A4 ) ) )).

% IntD1
thf(fact_222_IntE,axiom,(
    ! [A: $tType,C3: A,A4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) )
     => ~ ( ( member @ A @ C3 @ A4 )
         => ~ ( member @ A @ C3 @ B3 ) ) ) )).

% IntE
thf(fact_223_Un__empty__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = B3 ) )).

% Un_empty_left
thf(fact_224_Un__empty__right,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = A4 ) )).

% Un_empty_right
thf(fact_225_Un__Int__distrib2,axiom,(
    ! [A: $tType,B3: ( set @ A ),C4: ( set @ A ),A4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) @ A4 )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B3 @ A4 ) @ ( sup_sup @ ( set @ A ) @ C4 @ A4 ) ) ) )).

% Un_Int_distrib2
thf(fact_226_Int__Un__distrib2,axiom,(
    ! [A: $tType,B3: ( set @ A ),C4: ( set @ A ),A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) @ A4 )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B3 @ A4 ) @ ( inf_inf @ ( set @ A ) @ C4 @ A4 ) ) ) )).

% Int_Un_distrib2
thf(fact_227_Un__Int__distrib,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) @ ( sup_sup @ ( set @ A ) @ A4 @ C4 ) ) ) )).

% Un_Int_distrib
thf(fact_228_Int__Un__distrib,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ A ) @ A4 @ C4 ) ) ) )).

% Int_Un_distrib
thf(fact_229_Un__Int__crazy,axiom,(
    ! [A: $tType,A4: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B3 ) @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) @ ( inf_inf @ ( set @ A ) @ C4 @ A4 ) )
      = ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B3 ) @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) ) @ ( sup_sup @ ( set @ A ) @ C4 @ A4 ) ) ) )).

% Un_Int_crazy
thf(fact_230_sup__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) )).

% sup_bot_right
thf(fact_231_sup__inf__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z @ X ) ) ) ) )).

% sup_inf_distrib2
thf(fact_232_sup__inf__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_inf_distrib1
thf(fact_233_inf__sup__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z @ X ) ) ) ) )).

% inf_sup_distrib2
thf(fact_234_inf__sup__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_sup_distrib1
thf(fact_235_sup__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) )).

% sup_bot_left
thf(fact_236_distrib__imp2,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y3: A,Z2: A] :
              ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y3 @ Z2 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y3 ) @ ( sup_sup @ A @ X3 @ Z2 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ) )).

% distrib_imp2
thf(fact_237_distrib__imp1,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y3: A,Z2: A] :
              ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y3 @ Z2 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y3 ) @ ( inf_inf @ A @ X3 @ Z2 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ) )).

% distrib_imp1
thf(fact_238_prod__fun__imageE,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C3: ( product_prod @ A @ B ),F: ( C > A ),G3: ( D > B ),R2: ( set @ ( product_prod @ C @ D ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C3 @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F @ G3 ) @ R2 ) )
     => ~ ( ! [X3: C,Y3: D] :
              ( ( C3
                = ( product_Pair @ A @ B @ ( F @ X3 ) @ ( G3 @ Y3 ) ) )
             => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X3 @ Y3 ) @ R2 ) ) ) ) )).

% prod_fun_imageE
thf(fact_239_surj__imp__surj__swap,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: B] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ ( swap @ B @ A @ A2 @ B2 @ F ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_imp_surj_swap
thf(fact_240_disjnt__def,axiom,(
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A9: ( set @ A ),B9: ( set @ A )] :
            ( ( inf_inf @ ( set @ A ) @ A9 @ B9 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% disjnt_def
thf(fact_241_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_242_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A9: ( set @ A )] :
            ( A9
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_243_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_244_disjnt__iff,axiom,(
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A9: ( set @ A ),B9: ( set @ A )] :
          ! [X4: A] :
            ~ ( ( member @ A @ X4 @ A9 )
              & ( member @ A @ X4 @ B9 ) ) ) ) )).

% disjnt_iff
thf(fact_245_compl__unique,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
         => ( ( ( sup_sup @ A @ X @ Y )
              = ( top_top @ A ) )
           => ( ( uminus_uminus @ A @ X )
              = Y ) ) ) ) )).

% compl_unique
thf(fact_246_range__fst,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% range_fst
thf(fact_247_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X )
            = ( uminus_uminus @ A @ Y ) )
          = ( X = Y ) ) ) )).

% compl_eq_compl_iff
thf(fact_248_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X ) )
          = X ) ) )).

% double_compl
thf(fact_249_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A9: ( A > B ),X4: A] :
              ( uminus_uminus @ B @ ( A9 @ X4 ) ) ) ) ) )).

% uminus_apply
thf(fact_250_Compl__disjoint,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_disjoint
thf(fact_251_Compl__disjoint2,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_disjoint2
thf(fact_252_fst__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( C > A ),G3: ( D > B ),X: ( product_prod @ C @ D )] :
      ( ( product_fst @ A @ B @ ( product_map_prod @ C @ A @ D @ B @ F @ G3 @ X ) )
      = ( F @ ( product_fst @ C @ D @ X ) ) ) )).

% fst_map_prod
thf(fact_253_compl__inf__bot,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ X )
          = ( bot_bot @ A ) ) ) )).

% compl_inf_bot
thf(fact_254_inf__compl__bot,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( uminus_uminus @ A @ X ) )
          = ( bot_bot @ A ) ) ) )).

% inf_compl_bot
thf(fact_255_inf__compl__bot__left1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ ( inf_inf @ A @ X @ Y ) )
          = ( bot_bot @ A ) ) ) )).

% inf_compl_bot_left1

%----Type constructors (36)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A7: $tType] :
      ( bounded_lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounde1808546759up_bot @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounde1561333602nf_top @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice_top @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice_bot @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( semilattice_sup @ A10 @ ( type2 @ A10 ) )
     => ( semilattice_sup @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( semilattice_inf @ A10 @ ( type2 @ A10 ) )
     => ( semilattice_inf @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( distrib_lattice @ A10 @ ( type2 @ A10 ) )
     => ( distrib_lattice @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( boolean_algebra @ A10 @ ( type2 @ A10 ) )
     => ( boolean_algebra @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( lattice @ A10 @ ( type2 @ A10 ) )
     => ( lattice @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( top @ A10 @ ( type2 @ A10 ) )
     => ( top @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A7: $tType,A10: $tType] :
      ( ( uminus @ A10 @ ( type2 @ A10 ) )
     => ( uminus @ ( A7 > A10 ) @ ( type2 @ ( A7 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_3,axiom,(
    ! [A7: $tType] :
      ( bounde1808546759up_bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_4,axiom,(
    ! [A7: $tType] :
      ( bounde1561333602nf_top @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_5,axiom,(
    ! [A7: $tType] :
      ( bounded_lattice_top @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_6,axiom,(
    ! [A7: $tType] :
      ( bounded_lattice_bot @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_7,axiom,(
    ! [A7: $tType] :
      ( semilattice_sup @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_8,axiom,(
    ! [A7: $tType] :
      ( semilattice_inf @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_9,axiom,(
    ! [A7: $tType] :
      ( distrib_lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_10,axiom,(
    ! [A7: $tType] :
      ( boolean_algebra @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_11,axiom,(
    ! [A7: $tType] :
      ( lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_12,axiom,(
    ! [A7: $tType] :
      ( top @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_13,axiom,(
    ! [A7: $tType] :
      ( uminus @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_14,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_15,axiom,
    ( bounde1561333602nf_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_16,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_17,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_18,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_19,axiom,
    ( semilattice_inf @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_20,axiom,
    ( distrib_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_21,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_22,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_23,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_24,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ? [X6: dtree] :
      ( ( member @ dtree @ X6 @ ( vimage @ dtree @ ( sum_sum @ t @ dtree ) @ ( sum_Inr @ dtree @ t ) @ ( cont @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ tr1a @ tr2a ) ) @ tr3a ) ) ) ) )
      & ? [Tr14: dtree,Tr24: dtree,Tr33: dtree] :
          ( ( X6
            = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr14 @ Tr24 ) ) @ Tr33 ) ) )
          & ( trB
            = ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr14 @ ( parall1899940088le_par @ ( product_Pair @ dtree @ dtree @ Tr24 @ Tr33 ) ) ) ) ) ) ) )).

%------------------------------------------------------------------------------
