%------------------------------------------------------------------------------
% File     : DAT122^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive list 1876
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_list__1876.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  402 (   0 unit;  73 type;   0 defn)
%            Number of atoms       : 4393 ( 340 equality;2521 variable)
%            Maximal formula depth :   28 (   8 average)
%            Number of connectives : 4016 ( 156   ~;  40   |;  81   &;3506   @)
%                                         (   0 <=>; 233  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  303 ( 303   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   77 (  73   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1090 (   3 sgn; 955   !;  39   ?;  36   ^)
%                                         (1090   :;  60  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:53:07.332
%------------------------------------------------------------------------------
%----Could-be-implicit typings (15)
thf(ty_t_Coinductive__List__Mirabelle__kmikjhschf_Ollist,type,(
    coindu1593790203_llist: $tType > $tType )).

thf(ty_t_Record_Otuple__isomorphism,type,(
    tuple_isomorphism: $tType > $tType > $tType > $tType )).

thf(ty_t_Code__Numeral_Onatural,type,(
    code_natural: $tType )).

thf(ty_t_Code__Evaluation_Oterm,type,(
    code_term: $tType )).

thf(ty_t_Product__Type_Ounit,type,(
    product_unit: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Extended__Nat_Oenat,type,(
    extended_enat: $tType )).

thf(ty_t_Typerep_Otyperep,type,(
    typerep: $tType )).

thf(ty_t_String_Oliteral,type,(
    literal: $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (58)
thf(sy_cl_Enum_Oenum,type,(
    enum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Typerep_Otyperep,type,(
    typerep2: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Oequal,type,(
    cl_HOL_Oequal: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Code__Evaluation_Oterm__of,type,(
    code_term_of: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osize,type,(
    size: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__1,type,(
    semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Quickcheck__Random_Orandom,type,(
    quickcheck_random: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Divides_Osemiring__numeral__div,type,(
    semiring_numeral_div: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Code__Numeral_OSuc,type,(
    code_Suc: code_natural > code_natural )).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,(
    code_case_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,(
    code_rec_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Osize__natural,type,(
    code_size_natural: code_natural > nat )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Oiterates,type,(
    coindu1529956631erates: 
      !>[A: $tType] :
        ( ( A > A ) > A > ( coindu1593790203_llist @ A ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Olappend,type,(
    coindu268472904append: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollexord,type,(
    coindu300403952lexord: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_OLCons,type,(
    coindu1121789889_LCons: 
      !>[A: $tType] :
        ( A > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_OLNil,type,(
    coindu1598213697e_LNil: 
      !>[A: $tType] :
        ( coindu1593790203_llist @ A ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_Ocase__llist,type,(
    coindu882539134_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coindu1593790203_llist @ A ) > B ) > ( coindu1593790203_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_Olhd,type,(
    coindu1046438764le_lhd: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_Ollist__all2,type,(
    coindu987187967t_all2: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ B ) > $o ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_Olmap,type,(
    coindu1062782156e_lmap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ Aa ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_Olnull,type,(
    coindu335574135_lnull: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ollist_Oltl,type,(
    coindu1047225960le_ltl: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Olmember,type,(
    coindu567634248member: 
      !>[A: $tType] :
        ( A > ( coindu1593790203_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Olnth,type,(
    coindu749330388e_lnth: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > nat > A ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Olprefix,type,(
    coindu1696667936prefix: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Olstrict__prefix,type,(
    coindu574146665prefix: 
      !>[A: $tType] :
        ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Oltake,type,(
    coindu1802687541_ltake: 
      !>[A: $tType] :
        ( extended_enat > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_OltakeWhile,type,(
    coindu721411036eWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Olzip,type,(
    coindu847746867e_lzip: 
      !>[A: $tType,B: $tType] :
        ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ B ) > ( coindu1593790203_llist @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Coinductive__List__Mirabelle__kmikjhschf_Ounfold__llist,type,(
    coindu1599971794_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coindu1593790203_llist @ B ) ) )).

thf(sy_c_Coinductive__Nat_Oco_Oenat_Ocase__enat,type,(
    coindu440805660e_enat: 
      !>[A: $tType] :
        ( A > ( extended_enat > A ) > extended_enat > A ) )).

thf(sy_c_Coinductive__Nat_Oco_Oenat_Oepred,type,(
    coinductive_epred: extended_enat > extended_enat )).

thf(sy_c_Coinductive__Nat_Oenat__unfold,type,(
    coindu1491768222unfold: 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > A ) > A > extended_enat ) )).

thf(sy_c_Divides_Osemiring__numeral__div__class_Odivides__aux,type,(
    semiri577515795es_aux: 
      !>[A: $tType] :
        ( ( product_prod @ A @ A ) > $o ) )).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,(
    extended_case_enat: 
      !>[T: $tType] :
        ( ( nat > T ) > T > extended_enat > T ) )).

thf(sy_c_Extended__Nat_Othe__enat,type,(
    extended_the_enat: extended_enat > nat )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_Obool_Osize__bool,type,(
    size_bool: $o > nat )).

thf(sy_c_HOL_Odefault__class_Odefault,type,(
    default_default: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,(
    rec_nat: 
      !>[T: $tType] :
        ( T > ( nat > T > T ) > nat > T ) )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,(
    semiri532925092at_aux: 
      !>[A: $tType] :
        ( ( A > A ) > nat > A > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_OUnity,type,(
    product_Unity: product_unit )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,(
    product_rec_unit: 
      !>[T: $tType] :
        ( T > product_unit > T ) )).

thf(sy_c_Product__Type_Ounit_Ocase__unit,type,(
    product_case_unit: 
      !>[A: $tType] :
        ( A > product_unit > A ) )).

thf(sy_c_Product__Type_Ounit_Osize__unit,type,(
    product_size_unit: product_unit > nat )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_xs,type,(
    xs: ( coindu1593790203_llist @ a ) )).

%----Relevant facts (241)
thf(fact_0_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ~ ( ( coindu335574135_lnull @ A @ Xs )
          | ( coindu335574135_lnull @ B @ Ys ) )
     => ~ ( ~ ( coindu335574135_lnull @ A @ Xs )
         => ( coindu335574135_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_1_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
       => ~ ( coindu335574135_lnull @ A @ Ys ) )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
        | ~ ( coindu335574135_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_2_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ~ ( ( coindu335574135_lnull @ A @ Xs )
          | ~ ( P @ ( coindu1046438764le_lhd @ A @ Xs ) ) )
     => ~ ( ~ ( coindu335574135_lnull @ A @ Xs )
         => ~ ( P @ ( coindu1046438764le_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_3_ltakeWhile_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coindu1593790203_llist @ A )] :
      ( ( ~ ( coindu335574135_lnull @ A @ ( coindu721411036eWhile @ A @ P @ Xs ) ) )
      = ( ~ ( coindu335574135_lnull @ A @ Xs )
        & ( P @ ( coindu1046438764le_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(2)
thf(fact_4_ltakeWhile_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ ( coindu721411036eWhile @ A @ P @ Xs ) )
      = ( ( coindu335574135_lnull @ A @ Xs )
        | ~ ( P @ ( coindu1046438764le_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(1)
thf(fact_5_ltakeWhile_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ( P @ ( coindu1046438764le_lhd @ A @ Xs ) )
       => ~ ( coindu335574135_lnull @ A @ ( coindu721411036eWhile @ A @ P @ Xs ) ) ) ) )).

% ltakeWhile.disc(2)
thf(fact_6_ltakeWhile_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
        | ~ ( P @ ( coindu1046438764le_lhd @ A @ Xs ) ) )
     => ( coindu335574135_lnull @ A @ ( coindu721411036eWhile @ A @ P @ Xs ) ) ) )).

% ltakeWhile.disc(1)
thf(fact_7_ltakeWhile_Osimps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ( P @ ( coindu1046438764le_lhd @ A @ Xs ) )
       => ( ( coindu1046438764le_lhd @ A @ ( coindu721411036eWhile @ A @ P @ Xs ) )
          = ( coindu1046438764le_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.simps(3)
thf(fact_8_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) )).

% zero_natural.rsp
thf(fact_9_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_10_lzip_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ( ~ ( coindu335574135_lnull @ ( product_prod @ A @ B ) @ ( coindu847746867e_lzip @ A @ B @ Xs @ Ys ) ) )
      = ( ~ ( coindu335574135_lnull @ A @ Xs )
        & ~ ( coindu335574135_lnull @ B @ Ys ) ) ) )).

% lzip.disc_iff(2)
thf(fact_11_lzip_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ( coindu335574135_lnull @ ( product_prod @ A @ B ) @ ( coindu847746867e_lzip @ A @ B @ Xs @ Ys ) )
      = ( ( coindu335574135_lnull @ A @ Xs )
        | ( coindu335574135_lnull @ B @ Ys ) ) ) )).

% lzip.disc_iff(1)
thf(fact_12_Coinductive__List__Mirabelle__kmikjhschf_Oiterates_Osimps_I2_J,axiom,(
    ! [A: $tType,F: ( A > A ),X: A] :
      ( ( coindu1046438764le_lhd @ A @ ( coindu1529956631erates @ A @ F @ X ) )
      = X ) )).

% Coinductive_List_Mirabelle_kmikjhschf.iterates.simps(2)
thf(fact_13_ltake_Oexhaust,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ~ ( ( N
            = ( zero_zero @ extended_enat ) )
          | ( coindu335574135_lnull @ A @ Xs ) )
     => ~ ( ( N
           != ( zero_zero @ extended_enat ) )
         => ( coindu335574135_lnull @ A @ Xs ) ) ) )).

% ltake.exhaust
thf(fact_14_lzip_Odisc_I1_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
        | ( coindu335574135_lnull @ B @ Ys ) )
     => ( coindu335574135_lnull @ ( product_prod @ A @ B ) @ ( coindu847746867e_lzip @ A @ B @ Xs @ Ys ) ) ) )).

% lzip.disc(1)
thf(fact_15_lzip_Odisc_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ~ ( coindu335574135_lnull @ B @ Ys )
       => ~ ( coindu335574135_lnull @ ( product_prod @ A @ B ) @ ( coindu847746867e_lzip @ A @ B @ Xs @ Ys ) ) ) ) )).

% lzip.disc(2)
thf(fact_16_iterates_Odisc__iff,axiom,(
    ! [A: $tType,F: ( A > A ),X: A] :
      ~ ( coindu335574135_lnull @ A @ ( coindu1529956631erates @ A @ F @ X ) ) )).

% iterates.disc_iff
thf(fact_17_natural_Osize_I1_J,axiom,
    ( ( code_size_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(1)
thf(fact_18_natural_Osize_I3_J,axiom,
    ( ( size_size @ code_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(3)
thf(fact_19_lzip_Osimps_I3_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ~ ( coindu335574135_lnull @ B @ Ys )
       => ( ( coindu1046438764le_lhd @ ( product_prod @ A @ B ) @ ( coindu847746867e_lzip @ A @ B @ Xs @ Ys ) )
          = ( product_Pair @ A @ B @ ( coindu1046438764le_lhd @ A @ Xs ) @ ( coindu1046438764le_lhd @ B @ Ys ) ) ) ) ) )).

% lzip.simps(3)
thf(fact_20_ltakeWhile_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
        | ~ ( P @ ( coindu1046438764le_lhd @ A @ Xs ) ) )
     => ( ( coindu721411036eWhile @ A @ P @ Xs )
        = ( coindu1598213697e_LNil @ A ) ) ) )).

% ltakeWhile.ctr(1)
thf(fact_21_ltakeWhile_Osimps_I4_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ( P @ ( coindu1046438764le_lhd @ A @ Xs ) )
       => ( ( coindu1047225960le_ltl @ A @ ( coindu721411036eWhile @ A @ P @ Xs ) )
          = ( coindu721411036eWhile @ A @ P @ ( coindu1047225960le_ltl @ A @ Xs ) ) ) ) ) )).

% ltakeWhile.simps(4)
thf(fact_22_of__nat__aux_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [Inc: ( A > A ),I: A] :
          ( ( semiri532925092at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) )).

% of_nat_aux.simps(1)
thf(fact_23_lnth__0,axiom,(
    ! [A: $tType,X: A,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu749330388e_lnth @ A @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ ( zero_zero @ nat ) )
      = X ) )).

% lnth_0
thf(fact_24_llist_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( coindu1593790203_llist @ A ),F: ( A > B )] :
      ( ~ ( coindu335574135_lnull @ A @ A2 )
     => ( ( coindu1046438764le_lhd @ B @ ( coindu1062782156e_lmap @ A @ B @ F @ A2 ) )
        = ( F @ ( coindu1046438764le_lhd @ A @ A2 ) ) ) ) )).

% llist.map_sel(1)
thf(fact_25_lhd__lappend,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1046438764le_lhd @ A @ ( coindu268472904append @ A @ Xs @ Ys ) )
          = ( coindu1046438764le_lhd @ A @ Ys ) ) )
      & ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1046438764le_lhd @ A @ ( coindu268472904append @ A @ Xs @ Ys ) )
          = ( coindu1046438764le_lhd @ A @ Xs ) ) ) ) )).

% lhd_lappend
thf(fact_26_old_Onat_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F2: ( nat > T > T )] :
      ( ( rec_nat @ T @ F1 @ F2 @ ( zero_zero @ nat ) )
      = F1 ) )).

% old.nat.simps(6)
thf(fact_27_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coindu1593790203_llist @ A ),Y21: A,Y22: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu1121789889_LCons @ A @ X21 @ X22 )
        = ( coindu1121789889_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_28_lappend_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ~ ( coindu335574135_lnull @ A @ ( coindu268472904append @ A @ Xs @ Ys ) ) )
      = ( ~ ( coindu335574135_lnull @ A @ Xs )
        | ~ ( coindu335574135_lnull @ A @ Ys ) ) ) )).

% lappend.disc_iff(2)
thf(fact_29_lnull__lappend,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ ( coindu268472904append @ A @ Xs @ Ys ) )
      = ( ( coindu335574135_lnull @ A @ Xs )
        & ( coindu335574135_lnull @ A @ Ys ) ) ) )).

% lnull_lappend
thf(fact_30_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa: A,X: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu268472904append @ A @ ( coindu1121789889_LCons @ A @ Xa @ X ) @ Ys )
      = ( coindu1121789889_LCons @ A @ Xa @ ( coindu268472904append @ A @ X @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_31_llist_Omap__disc__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ B @ ( coindu1062782156e_lmap @ A @ B @ F @ A2 ) )
      = ( coindu335574135_lnull @ A @ A2 ) ) )).

% llist.map_disc_iff
thf(fact_32_lappend__LNil2,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu268472904append @ A @ Xs @ ( coindu1598213697e_LNil @ A ) )
      = Xs ) )).

% lappend_LNil2
thf(fact_33_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu268472904append @ A @ ( coindu1598213697e_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_34_ltl__lmap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coindu1593790203_llist @ B )] :
      ( ( coindu1047225960le_ltl @ A @ ( coindu1062782156e_lmap @ B @ A @ F @ Xs ) )
      = ( coindu1062782156e_lmap @ B @ A @ F @ ( coindu1047225960le_ltl @ B @ Xs ) ) ) )).

% ltl_lmap
thf(fact_35_ltl__lappend,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1047225960le_ltl @ A @ ( coindu268472904append @ A @ Xs @ Ys ) )
          = ( coindu1047225960le_ltl @ A @ Ys ) ) )
      & ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1047225960le_ltl @ A @ ( coindu268472904append @ A @ Xs @ Ys ) )
          = ( coindu268472904append @ A @ ( coindu1047225960le_ltl @ A @ Xs ) @ Ys ) ) ) ) )).

% ltl_lappend
thf(fact_36_lhd__LCons__ltl,axiom,(
    ! [A: $tType,Llist: ( coindu1593790203_llist @ A )] :
      ( ~ ( coindu335574135_lnull @ A @ Llist )
     => ( ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Llist ) @ ( coindu1047225960le_ltl @ A @ Llist ) )
        = Llist ) ) )).

% lhd_LCons_ltl
thf(fact_37_eq__LConsD,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Y: A,Ys: ( coindu1593790203_llist @ A )] :
      ( ( Xs
        = ( coindu1121789889_LCons @ A @ Y @ Ys ) )
     => ( ( Xs
         != ( coindu1598213697e_LNil @ A ) )
        & ( ( coindu1046438764le_lhd @ A @ Xs )
          = Y )
        & ( ( coindu1047225960le_ltl @ A @ Xs )
          = Ys ) ) ) )).

% eq_LConsD
thf(fact_38_llist_Oexhaust__sel,axiom,(
    ! [A: $tType,Llist: ( coindu1593790203_llist @ A )] :
      ( ( Llist
       != ( coindu1598213697e_LNil @ A ) )
     => ( Llist
        = ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Llist ) @ ( coindu1047225960le_ltl @ A @ Llist ) ) ) ) )).

% llist.exhaust_sel
thf(fact_39_lappend__ltl,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ( coindu268472904append @ A @ ( coindu1047225960le_ltl @ A @ Xs ) @ Ys )
        = ( coindu1047225960le_ltl @ A @ ( coindu268472904append @ A @ Xs @ Ys ) ) ) ) )).

% lappend_ltl
thf(fact_40_llist_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( coindu1593790203_llist @ A ),F: ( A > B )] :
      ( ~ ( coindu335574135_lnull @ A @ A2 )
     => ( ( coindu1047225960le_ltl @ B @ ( coindu1062782156e_lmap @ A @ B @ F @ A2 ) )
        = ( coindu1062782156e_lmap @ A @ B @ F @ ( coindu1047225960le_ltl @ A @ A2 ) ) ) ) )).

% llist.map_sel(2)
thf(fact_41_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_42_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_43_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_44_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_45_lappend__snocL1__conv__LCons2,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Y: A,Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu268472904append @ A @ ( coindu268472904append @ A @ Xs @ ( coindu1121789889_LCons @ A @ Y @ ( coindu1598213697e_LNil @ A ) ) ) @ Ys )
      = ( coindu268472904append @ A @ Xs @ ( coindu1121789889_LCons @ A @ Y @ Ys ) ) ) )).

% lappend_snocL1_conv_LCons2
thf(fact_46_lmap__lappend__distrib,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coindu1593790203_llist @ B ),Ys: ( coindu1593790203_llist @ B )] :
      ( ( coindu1062782156e_lmap @ B @ A @ F @ ( coindu268472904append @ B @ Xs @ Ys ) )
      = ( coindu268472904append @ A @ ( coindu1062782156e_lmap @ B @ A @ F @ Xs ) @ ( coindu1062782156e_lmap @ B @ A @ F @ Ys ) ) ) )).

% lmap_lappend_distrib
thf(fact_47_lappend__eq__LNil__iff,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu268472904append @ A @ Xs @ Ys )
        = ( coindu1598213697e_LNil @ A ) )
      = ( ( Xs
          = ( coindu1598213697e_LNil @ A ) )
        & ( Ys
          = ( coindu1598213697e_LNil @ A ) ) ) ) )).

% lappend_eq_LNil_iff
thf(fact_48_LNil__eq__lappend__iff,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu1598213697e_LNil @ A )
        = ( coindu268472904append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( coindu1598213697e_LNil @ A ) )
        & ( Ys
          = ( coindu1598213697e_LNil @ A ) ) ) ) )).

% LNil_eq_lappend_iff
thf(fact_49_lmap__eq__LCons__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coindu1593790203_llist @ B ),Y: A,Ys: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu1062782156e_lmap @ B @ A @ F @ Xs )
        = ( coindu1121789889_LCons @ A @ Y @ Ys ) )
      = ( ? [X2: B,Xs2: ( coindu1593790203_llist @ B )] :
            ( ( Xs
              = ( coindu1121789889_LCons @ B @ X2 @ Xs2 ) )
            & ( Y
              = ( F @ X2 ) )
            & ( Ys
              = ( coindu1062782156e_lmap @ B @ A @ F @ Xs2 ) ) ) ) ) )).

% lmap_eq_LCons_conv
thf(fact_50_lappend__LNil__LNil,axiom,(
    ! [A: $tType] :
      ( ( coindu268472904append @ A @ ( coindu1598213697e_LNil @ A ) @ ( coindu1598213697e_LNil @ A ) )
      = ( coindu1598213697e_LNil @ A ) ) )).

% lappend_LNil_LNil
thf(fact_51_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( Xs
       != ( coindu1598213697e_LNil @ A ) )
      = ( ? [X2: A,Xs2: ( coindu1593790203_llist @ A )] :
            ( Xs
            = ( coindu1121789889_LCons @ A @ X2 @ Xs2 ) ) ) ) )).

% neq_LNil_conv
thf(fact_52_llist_Oexhaust,axiom,(
    ! [A: $tType,Y: ( coindu1593790203_llist @ A )] :
      ( ( Y
       != ( coindu1598213697e_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coindu1593790203_llist @ A )] :
              ( Y
             != ( coindu1121789889_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_53_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A ),Zs: ( coindu1593790203_llist @ A )] :
      ( ( coindu268472904append @ A @ ( coindu268472904append @ A @ Xs @ Ys ) @ Zs )
      = ( coindu268472904append @ A @ Xs @ ( coindu268472904append @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_54_lmap__eq__LNil,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coindu1593790203_llist @ B )] :
      ( ( ( coindu1062782156e_lmap @ B @ A @ F @ Xs )
        = ( coindu1598213697e_LNil @ A ) )
      = ( Xs
        = ( coindu1598213697e_LNil @ B ) ) ) )).

% lmap_eq_LNil
thf(fact_55_LNil__eq__lmap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coindu1593790203_llist @ B )] :
      ( ( ( coindu1598213697e_LNil @ A )
        = ( coindu1062782156e_lmap @ B @ A @ F @ Xs ) )
      = ( Xs
        = ( coindu1598213697e_LNil @ B ) ) ) )).

% LNil_eq_lmap
thf(fact_56_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coindu1593790203_llist @ A )] :
      ( ( coindu1598213697e_LNil @ A )
     != ( coindu1121789889_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_57_llist_Osimps_I12_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B )] :
      ( ( coindu1062782156e_lmap @ A @ B @ F @ ( coindu1598213697e_LNil @ A ) )
      = ( coindu1598213697e_LNil @ B ) ) )).

% llist.simps(12)
thf(fact_58_llist_Osimps_I13_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X21: A,X22: ( coindu1593790203_llist @ A )] :
      ( ( coindu1062782156e_lmap @ A @ B @ F @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) )
      = ( coindu1121789889_LCons @ B @ ( F @ X21 ) @ ( coindu1062782156e_lmap @ A @ B @ F @ X22 ) ) ) )).

% llist.simps(13)
thf(fact_59_ltl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coindu1047225960le_ltl @ A @ ( coindu1598213697e_LNil @ A ) )
      = ( coindu1598213697e_LNil @ A ) ) )).

% ltl_simps(1)
thf(fact_60_ltl__simps_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coindu1593790203_llist @ A )] :
      ( ( coindu1047225960le_ltl @ A @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) )
      = X22 ) )).

% ltl_simps(2)
thf(fact_61_lappend_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Xs )
     => ( ( coindu335574135_lnull @ A @ Ys )
       => ( ( coindu268472904append @ A @ Xs @ Ys )
          = ( coindu1598213697e_LNil @ A ) ) ) ) )).

% lappend.ctr(1)
thf(fact_62_lzip_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu847746867e_lzip @ A @ B )
      = ( ^ [Xs3: ( coindu1593790203_llist @ A ),Ys2: ( coindu1593790203_llist @ B )] :
            ( if @ ( coindu1593790203_llist @ ( product_prod @ A @ B ) )
            @ ( ( coindu335574135_lnull @ A @ Xs3 )
              | ( coindu335574135_lnull @ B @ Ys2 ) )
            @ ( coindu1598213697e_LNil @ ( product_prod @ A @ B ) )
            @ ( coindu1121789889_LCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( coindu1046438764le_lhd @ A @ Xs3 ) @ ( coindu1046438764le_lhd @ B @ Ys2 ) ) @ ( coindu847746867e_lzip @ A @ B @ ( coindu1047225960le_ltl @ A @ Xs3 ) @ ( coindu1047225960le_ltl @ B @ Ys2 ) ) ) ) ) ) )).

% lzip.code
thf(fact_63_ltakeWhile_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coindu721411036eWhile @ A )
      = ( ^ [P2: ( A > $o ),Xs3: ( coindu1593790203_llist @ A )] :
            ( if @ ( coindu1593790203_llist @ A )
            @ ( ( coindu335574135_lnull @ A @ Xs3 )
              | ~ ( P2 @ ( coindu1046438764le_lhd @ A @ Xs3 ) ) )
            @ ( coindu1598213697e_LNil @ A )
            @ ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Xs3 ) @ ( coindu721411036eWhile @ A @ P2 @ ( coindu1047225960le_ltl @ A @ Xs3 ) ) ) ) ) ) )).

% ltakeWhile.code
thf(fact_64_lzip_Octr_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ~ ( coindu335574135_lnull @ B @ Ys )
       => ( ( coindu847746867e_lzip @ A @ B @ Xs @ Ys )
          = ( coindu1121789889_LCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( coindu1046438764le_lhd @ A @ Xs ) @ ( coindu1046438764le_lhd @ B @ Ys ) ) @ ( coindu847746867e_lzip @ A @ B @ ( coindu1047225960le_ltl @ A @ Xs ) @ ( coindu1047225960le_ltl @ B @ Ys ) ) ) ) ) ) )).

% lzip.ctr(2)
thf(fact_65_lzip_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ~ ( coindu335574135_lnull @ B @ Ys )
       => ( ( coindu1047225960le_ltl @ ( product_prod @ A @ B ) @ ( coindu847746867e_lzip @ A @ B @ Xs @ Ys ) )
          = ( coindu847746867e_lzip @ A @ B @ ( coindu1047225960le_ltl @ A @ Xs ) @ ( coindu1047225960le_ltl @ B @ Ys ) ) ) ) ) )).

% lzip.simps(4)
thf(fact_66_lnull__ltlI,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Xs )
     => ( coindu335574135_lnull @ A @ ( coindu1047225960le_ltl @ A @ Xs ) ) ) )).

% lnull_ltlI
thf(fact_67_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coindu1593790203_llist @ A )] :
      ~ ( coindu335574135_lnull @ A @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_68_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coindu1593790203_llist @ A ),X21: A,X22: ( coindu1593790203_llist @ A )] :
      ( ( Llist
        = ( coindu1121789889_LCons @ A @ X21 @ X22 ) )
     => ~ ( coindu335574135_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_69_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ~ ( coindu335574135_lnull @ A @ Xs ) )
      = ( ? [X2: A,Xs2: ( coindu1593790203_llist @ A )] :
            ( Xs
            = ( coindu1121789889_LCons @ A @ X2 @ Xs2 ) ) ) ) )).

% not_lnull_conv
thf(fact_70_lappend_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ~ ( coindu335574135_lnull @ A @ Xs )
        | ~ ( coindu335574135_lnull @ A @ Ys ) )
     => ~ ( coindu335574135_lnull @ A @ ( coindu268472904append @ A @ Xs @ Ys ) ) ) )).

% lappend.disc(2)
thf(fact_71_lappend_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Xs )
     => ( ( coindu335574135_lnull @ A @ Ys )
       => ( coindu335574135_lnull @ A @ ( coindu268472904append @ A @ Xs @ Ys ) ) ) ) )).

% lappend.disc(1)
thf(fact_72_lappend__lnull1,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Xs )
     => ( ( coindu268472904append @ A @ Xs @ Ys )
        = Ys ) ) )).

% lappend_lnull1
thf(fact_73_lappend__lnull2,axiom,(
    ! [A: $tType,Ys: ( coindu1593790203_llist @ A ),Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Ys )
     => ( ( coindu268472904append @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_lnull2
thf(fact_74_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X22: ( coindu1593790203_llist @ A )] :
      ( ( coindu1046438764le_lhd @ A @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_75_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coindu335574135_lnull @ A @ ( coindu1598213697e_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_76_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coindu1593790203_llist @ A )] :
      ( ( Llist
        = ( coindu1598213697e_LNil @ A ) )
     => ( coindu335574135_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_77_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Llist )
     => ( Llist
        = ( coindu1598213697e_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_78_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coindu335574135_lnull @ A )
      = ( ^ [Llist2: ( coindu1593790203_llist @ A )] :
            ( Llist2
            = ( coindu1598213697e_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_79_Coinductive__List__Mirabelle__kmikjhschf_Oiterates_Osimps_I3_J,axiom,(
    ! [A: $tType,F: ( A > A ),X: A] :
      ( ( coindu1047225960le_ltl @ A @ ( coindu1529956631erates @ A @ F @ X ) )
      = ( coindu1529956631erates @ A @ F @ ( F @ X ) ) ) )).

% Coinductive_List_Mirabelle_kmikjhschf.iterates.simps(3)
thf(fact_80_iterates_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coindu1529956631erates @ A )
      = ( ^ [F3: ( A > A ),X2: A] :
            ( coindu1121789889_LCons @ A @ X2 @ ( coindu1529956631erates @ A @ F3 @ ( F3 @ X2 ) ) ) ) ) )).

% iterates.code
thf(fact_81_ltakeWhile_Octr_I2_J,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),P: ( A > $o )] :
      ( ~ ( coindu335574135_lnull @ A @ Xs )
     => ( ( P @ ( coindu1046438764le_lhd @ A @ Xs ) )
       => ( ( coindu721411036eWhile @ A @ P @ Xs )
          = ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Xs ) @ ( coindu721411036eWhile @ A @ P @ ( coindu1047225960le_ltl @ A @ Xs ) ) ) ) ) ) )).

% ltakeWhile.ctr(2)
thf(fact_82_llist_Oexpand,axiom,(
    ! [A: $tType,Llist: ( coindu1593790203_llist @ A ),Llist3: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu335574135_lnull @ A @ Llist )
        = ( coindu335574135_lnull @ A @ Llist3 ) )
     => ( ( ~ ( coindu335574135_lnull @ A @ Llist )
         => ( ~ ( coindu335574135_lnull @ A @ Llist3 )
           => ( ( ( coindu1046438764le_lhd @ A @ Llist )
                = ( coindu1046438764le_lhd @ A @ Llist3 ) )
              & ( ( coindu1047225960le_ltl @ A @ Llist )
                = ( coindu1047225960le_ltl @ A @ Llist3 ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.expand
thf(fact_83_llist_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ),Llist: ( coindu1593790203_llist @ A ),Llist3: ( coindu1593790203_llist @ A )] :
      ( ( R @ Llist @ Llist3 )
     => ( ! [Llist4: ( coindu1593790203_llist @ A ),Llist5: ( coindu1593790203_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coindu335574135_lnull @ A @ Llist4 )
                = ( coindu335574135_lnull @ A @ Llist5 ) )
              & ( ~ ( coindu335574135_lnull @ A @ Llist4 )
               => ( ~ ( coindu335574135_lnull @ A @ Llist5 )
                 => ( ( ( coindu1046438764le_lhd @ A @ Llist4 )
                      = ( coindu1046438764le_lhd @ A @ Llist5 ) )
                    & ( R @ ( coindu1047225960le_ltl @ A @ Llist4 ) @ ( coindu1047225960le_ltl @ A @ Llist5 ) ) ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.coinduct
thf(fact_84_llist_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ),Llist: ( coindu1593790203_llist @ A ),Llist3: ( coindu1593790203_llist @ A )] :
      ( ( R @ Llist @ Llist3 )
     => ( ! [Llist4: ( coindu1593790203_llist @ A ),Llist5: ( coindu1593790203_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coindu335574135_lnull @ A @ Llist4 )
                = ( coindu335574135_lnull @ A @ Llist5 ) )
              & ( ~ ( coindu335574135_lnull @ A @ Llist4 )
               => ( ~ ( coindu335574135_lnull @ A @ Llist5 )
                 => ( ( ( coindu1046438764le_lhd @ A @ Llist4 )
                      = ( coindu1046438764le_lhd @ A @ Llist5 ) )
                    & ( ( R @ ( coindu1047225960le_ltl @ A @ Llist4 ) @ ( coindu1047225960le_ltl @ A @ Llist5 ) )
                      | ( ( coindu1047225960le_ltl @ A @ Llist4 )
                        = ( coindu1047225960le_ltl @ A @ Llist5 ) ) ) ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.coinduct_strong
thf(fact_85_lzip_Octr_I1_J,axiom,(
    ! [B: $tType,A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ B )] :
      ( ( ( coindu335574135_lnull @ A @ Xs )
        | ( coindu335574135_lnull @ B @ Ys ) )
     => ( ( coindu847746867e_lzip @ A @ B @ Xs @ Ys )
        = ( coindu1598213697e_LNil @ ( product_prod @ A @ B ) ) ) ) )).

% lzip.ctr(1)
thf(fact_86_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A4: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A4 @ B3 ) )
      = ( ( A2 = A4 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_87_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X23: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X23 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X23 = Y2 ) ) ) )).

% prod.inject
thf(fact_88_natural_Osimps_I4_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T )] :
      ( ( code_case_natural @ T @ F1 @ F2 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(4)
thf(fact_89_llist_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F2: ( A > ( coindu1593790203_llist @ A ) > B ),Llist: ( coindu1593790203_llist @ A )] :
      ( ( P @ ( coindu882539134_llist @ B @ A @ F1 @ F2 @ Llist ) )
      = ( ( ( Llist
            = ( coindu1598213697e_LNil @ A ) )
         => ( P @ F1 ) )
        & ( ( Llist
            = ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Llist ) @ ( coindu1047225960le_ltl @ A @ Llist ) ) )
         => ( P @ ( F2 @ ( coindu1046438764le_lhd @ A @ Llist ) @ ( coindu1047225960le_ltl @ A @ Llist ) ) ) ) ) ) )).

% llist.split_sel
thf(fact_90_llist_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F2: ( A > ( coindu1593790203_llist @ A ) > B ),Llist: ( coindu1593790203_llist @ A )] :
      ( ( P @ ( coindu882539134_llist @ B @ A @ F1 @ F2 @ Llist ) )
      = ( ~ ( ( ( Llist
                = ( coindu1598213697e_LNil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Llist
                = ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Llist ) @ ( coindu1047225960le_ltl @ A @ Llist ) ) )
              & ~ ( P @ ( F2 @ ( coindu1046438764le_lhd @ A @ Llist ) @ ( coindu1047225960le_ltl @ A @ Llist ) ) ) ) ) ) ) )).

% llist.split_sel_asm
thf(fact_91_unfold__llist__id,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu1599971794_llist @ ( coindu1593790203_llist @ A ) @ A @ ( coindu335574135_lnull @ A ) @ ( coindu1046438764le_lhd @ A ) @ ( coindu1047225960le_ltl @ A ) @ Xs )
      = Xs ) )).

% unfold_llist_id
thf(fact_92_natural_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T > T )] :
      ( ( code_rec_natural @ T @ F1 @ F2 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(6)
thf(fact_93_llist_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( coindu882539134_llist @ B @ A )
      = ( ^ [F12: B,F22: ( A > ( coindu1593790203_llist @ A ) > B ),Llist2: ( coindu1593790203_llist @ A )] :
            ( if @ B @ ( coindu335574135_lnull @ A @ Llist2 ) @ F12 @ ( F22 @ ( coindu1046438764le_lhd @ A @ Llist2 ) @ ( coindu1047225960le_ltl @ A @ Llist2 ) ) ) ) ) )).

% llist.case_eq_if
thf(fact_94_divides__aux__eq,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral_div @ A @ ( type2 @ A ) )
     => ! [Q2: A,R2: A] :
          ( ( semiri577515795es_aux @ A @ ( product_Pair @ A @ A @ Q2 @ R2 ) )
          = ( R2
            = ( zero_zero @ A ) ) ) ) )).

% divides_aux_eq
thf(fact_95_unfold__llist_Odisc__iff_I1_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A2: A] :
      ( ( coindu335574135_lnull @ B @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 ) )
      = ( P3 @ A2 ) ) )).

% unfold_llist.disc_iff(1)
thf(fact_96_unfold__llist_Odisc__iff_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A2: A] :
      ( ( ~ ( coindu335574135_lnull @ B @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 ) ) )
      = ( ~ ( P3 @ A2 ) ) ) )).

% unfold_llist.disc_iff(2)
thf(fact_97_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B2: B,X: A,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu1599971794_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B2 )
        = ( coindu1121789889_LCons @ A @ X @ Xs ) )
      = ( ~ ( IS_LNIL @ B2 )
        & ( X
          = ( LHD @ B2 ) )
        & ( Xs
          = ( coindu1599971794_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B2 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_98_unfold__llist_Odisc_I1_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ( P3 @ A2 )
     => ( coindu335574135_lnull @ B @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 ) ) ) )).

% unfold_llist.disc(1)
thf(fact_99_unfold__llist_Odisc_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ~ ( coindu335574135_lnull @ B @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 ) ) ) )).

% unfold_llist.disc(2)
thf(fact_100_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 )
        = ( coindu1121789889_LCons @ B @ ( G21 @ A2 ) @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_101_unfold__llist_Octr_I1_J,axiom,(
    ! [A: $tType,B: $tType,P3: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ( P3 @ A2 )
     => ( ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 )
        = ( coindu1598213697e_LNil @ B ) ) ) )).

% unfold_llist.ctr(1)
thf(fact_102_unfold__llist_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1047225960le_ltl @ B @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 ) )
        = ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) )).

% unfold_llist.simps(4)
thf(fact_103_unfold__llist_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P3 @ A2 )
     => ( ( coindu1046438764le_lhd @ B @ ( coindu1599971794_llist @ A @ B @ P3 @ G21 @ G22 @ A2 ) )
        = ( G21 @ A2 ) ) ) )).

% unfold_llist.simps(3)
thf(fact_104_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F2: ( A > ( coindu1593790203_llist @ A ) > B ),X21: A,X22: ( coindu1593790203_llist @ A )] :
      ( ( coindu882539134_llist @ B @ A @ F1 @ F2 @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) )
      = ( F2 @ X21 @ X22 ) ) )).

% llist.simps(5)
thf(fact_105_llist_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F1: B,F2: ( A > ( coindu1593790203_llist @ A ) > B )] :
      ( ( coindu882539134_llist @ B @ A @ F1 @ F2 @ ( coindu1598213697e_LNil @ A ) )
      = F1 ) )).

% llist.simps(4)
thf(fact_106_unfold__llist_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu1599971794_llist @ A @ B )
      = ( ^ [P4: ( A > $o ),G212: ( A > B ),G222: ( A > A ),A5: A] :
            ( if @ ( coindu1593790203_llist @ B ) @ ( P4 @ A5 ) @ ( coindu1598213697e_LNil @ B ) @ ( coindu1121789889_LCons @ B @ ( G212 @ A5 ) @ ( coindu1599971794_llist @ A @ B @ P4 @ G212 @ G222 @ ( G222 @ A5 ) ) ) ) ) ) )).

% unfold_llist.code
thf(fact_107_ltl__unfold__llist,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),A2: B,LHD: ( B > A ),LTL: ( B > B )] :
      ( ( ( IS_LNIL @ A2 )
       => ( ( coindu1047225960le_ltl @ A @ ( coindu1599971794_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ A2 ) )
          = ( coindu1598213697e_LNil @ A ) ) )
      & ( ~ ( IS_LNIL @ A2 )
       => ( ( coindu1047225960le_ltl @ A @ ( coindu1599971794_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ A2 ) )
          = ( coindu1599971794_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ A2 ) ) ) ) ) )).

% ltl_unfold_llist
thf(fact_108_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P3: ( product_prod @ A @ B )] :
    ? [X3: A,Y3: B] :
      ( P3
      = ( product_Pair @ A @ B @ X3 @ Y3 ) ) )).

% surj_pair
thf(fact_109_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P3: ( product_prod @ A @ B )] :
      ( ! [A6: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A6 @ B4 ) )
     => ( P @ P3 ) ) )).

% prod_cases
thf(fact_110_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A4: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A4 @ B3 ) )
     => ~ ( ( A2 = A4 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_111_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A6: A,B4: B,C2: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) ) ) )).

% prod_cases3
thf(fact_112_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A6: A,B4: B,C2: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_113_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A6: A,B4: B,C2: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_114_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A6: A,B4: B,C2: C,D2: D,E2: E,F5: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D2 @ ( product_Pair @ E @ F4 @ E2 @ F5 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_115_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A6: A,B4: B,C2: C,D2: D,E2: E,F5: F4,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F5 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_116_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A6: A,B4: B,C2: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A6 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_117_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A6: A,B4: B,C2: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_118_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A6: A,B4: B,C2: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C2 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_119_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A6: A,B4: B,C2: C,D2: D,E2: E,F5: F4] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D2 @ ( product_Pair @ E @ F4 @ E2 @ F5 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_120_prod__induct7,axiom,(
    ! [G2: $tType,F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ( ! [A6: A,B4: B,C2: C,D2: D,E2: E,F5: F4,G3: G2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A6 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F5 @ G3 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_121_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A6: A,B4: B] :
            ( Y
           != ( product_Pair @ A @ B @ A6 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_122_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A6: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A6 @ B4 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_123_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_124_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C3: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C3 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C3 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_125_llexord_Ocases,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),A1: ( coindu1593790203_llist @ A ),A22: ( coindu1593790203_llist @ A )] :
      ( ( coindu300403952lexord @ A @ R2 @ A1 @ A22 )
     => ( ! [Xs4: ( coindu1593790203_llist @ A ),Ys3: ( coindu1593790203_llist @ A ),X3: A] :
            ( ( A1
              = ( coindu1121789889_LCons @ A @ X3 @ Xs4 ) )
           => ( ( A22
                = ( coindu1121789889_LCons @ A @ X3 @ Ys3 ) )
             => ~ ( coindu300403952lexord @ A @ R2 @ Xs4 @ Ys3 ) ) )
       => ( ! [X3: A] :
              ( ? [Xs4: ( coindu1593790203_llist @ A )] :
                  ( A1
                  = ( coindu1121789889_LCons @ A @ X3 @ Xs4 ) )
             => ! [Y3: A] :
                  ( ? [Ys3: ( coindu1593790203_llist @ A )] :
                      ( A22
                      = ( coindu1121789889_LCons @ A @ Y3 @ Ys3 ) )
                 => ~ ( R2 @ X3 @ Y3 ) ) )
         => ~ ( ( A1
                = ( coindu1598213697e_LNil @ A ) )
             => ! [Ys3: ( coindu1593790203_llist @ A )] : ( A22 != Ys3 ) ) ) ) ) )).

% llexord.cases
thf(fact_126_llexord_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu300403952lexord @ A )
      = ( ^ [R3: ( A > A > $o ),A12: ( coindu1593790203_llist @ A ),A23: ( coindu1593790203_llist @ A )] :
            ( ? [Xs3: ( coindu1593790203_llist @ A ),Ys2: ( coindu1593790203_llist @ A ),X2: A] :
                ( ( A12
                  = ( coindu1121789889_LCons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( coindu1121789889_LCons @ A @ X2 @ Ys2 ) )
                & ( coindu300403952lexord @ A @ R3 @ Xs3 @ Ys2 ) )
            | ? [X2: A,Y4: A,Xs3: ( coindu1593790203_llist @ A ),Ys2: ( coindu1593790203_llist @ A )] :
                ( ( A12
                  = ( coindu1121789889_LCons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( coindu1121789889_LCons @ A @ Y4 @ Ys2 ) )
                & ( R3 @ X2 @ Y4 ) )
            | ? [Ys2: ( coindu1593790203_llist @ A )] :
                ( ( A12
                  = ( coindu1598213697e_LNil @ A ) )
                & ( A23 = Ys2 ) ) ) ) ) )).

% llexord.simps
thf(fact_127_llexord_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ),X: ( coindu1593790203_llist @ A ),Xa: ( coindu1593790203_llist @ A ),R2: ( A > A > $o )] :
      ( ( X4 @ X @ Xa )
     => ( ! [X3: ( coindu1593790203_llist @ A ),Xa2: ( coindu1593790203_llist @ A )] :
            ( ( X4 @ X3 @ Xa2 )
           => ( ? [Xs5: ( coindu1593790203_llist @ A ),Ys4: ( coindu1593790203_llist @ A ),Xb: A] :
                  ( ( X3
                    = ( coindu1121789889_LCons @ A @ Xb @ Xs5 ) )
                  & ( Xa2
                    = ( coindu1121789889_LCons @ A @ Xb @ Ys4 ) )
                  & ( ( X4 @ Xs5 @ Ys4 )
                    | ( coindu300403952lexord @ A @ R2 @ Xs5 @ Ys4 ) ) )
              | ? [Xb: A,Y5: A,Xs5: ( coindu1593790203_llist @ A ),Ys4: ( coindu1593790203_llist @ A )] :
                  ( ( X3
                    = ( coindu1121789889_LCons @ A @ Xb @ Xs5 ) )
                  & ( Xa2
                    = ( coindu1121789889_LCons @ A @ Y5 @ Ys4 ) )
                  & ( R2 @ Xb @ Y5 ) )
              | ? [Ys4: ( coindu1593790203_llist @ A )] :
                  ( ( X3
                    = ( coindu1598213697e_LNil @ A ) )
                  & ( Xa2 = Ys4 ) ) ) )
       => ( coindu300403952lexord @ A @ R2 @ X @ Xa ) ) ) )).

% llexord.coinduct
thf(fact_128_llexord__LCons__less,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),X: A,Y: A,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( R2 @ X @ Y )
     => ( coindu300403952lexord @ A @ R2 @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ ( coindu1121789889_LCons @ A @ Y @ Ys ) ) ) )).

% llexord_LCons_less
thf(fact_129_llexord__LCons__eq,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A ),X: A] :
      ( ( coindu300403952lexord @ A @ R2 @ Xs @ Ys )
     => ( coindu300403952lexord @ A @ R2 @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ ( coindu1121789889_LCons @ A @ X @ Ys ) ) ) )).

% llexord_LCons_eq
thf(fact_130_llexord__LNil,axiom,(
    ! [A: $tType,R2: ( A > A > $o ),Ys: ( coindu1593790203_llist @ A )] :
      ( coindu300403952lexord @ A @ R2 @ ( coindu1598213697e_LNil @ A ) @ Ys ) )).

% llexord_LNil
thf(fact_131_natural_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T ),Natural: code_natural] :
      ( ( code_case_natural @ T @ F1 @ F2 @ ( code_Suc @ Natural ) )
      = ( F2 @ Natural ) ) )).

% natural.simps(5)
thf(fact_132_lmember__code_I1_J,axiom,(
    ! [A: $tType,X: A] :
      ~ ( coindu567634248member @ A @ X @ ( coindu1598213697e_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_133_lmember__code_I2_J,axiom,(
    ! [A: $tType,X: A,Y: A,Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu567634248member @ A @ X @ ( coindu1121789889_LCons @ A @ Y @ Ys ) )
      = ( ( X = Y )
        | ( coindu567634248member @ A @ X @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_134_natural_Oinject,axiom,(
    ! [Natural: code_natural,Natural2: code_natural] :
      ( ( ( code_Suc @ Natural )
        = ( code_Suc @ Natural2 ) )
      = ( Natural = Natural2 ) ) )).

% natural.inject
thf(fact_135_natural_Osimps_I7_J,axiom,(
    ! [T: $tType,F1: T,F2: ( code_natural > T > T ),Natural: code_natural] :
      ( ( code_rec_natural @ T @ F1 @ F2 @ ( code_Suc @ Natural ) )
      = ( F2 @ Natural @ ( code_rec_natural @ T @ F1 @ F2 @ Natural ) ) ) )).

% natural.simps(7)
thf(fact_136_natural_Oinducts,axiom,(
    ! [P: ( code_natural > $o ),Natural: code_natural] :
      ( ( P @ ( zero_zero @ code_natural ) )
     => ( ! [Natural3: code_natural] :
            ( ( P @ Natural3 )
           => ( P @ ( code_Suc @ Natural3 ) ) )
       => ( P @ Natural ) ) ) )).

% natural.inducts
thf(fact_137_natural_Oexhaust,axiom,(
    ! [Y: code_natural] :
      ( ( Y
       != ( zero_zero @ code_natural ) )
     => ~ ( ! [Natural3: code_natural] :
              ( Y
             != ( code_Suc @ Natural3 ) ) ) ) )).

% natural.exhaust
thf(fact_138_natural_Odistinct_I1_J,axiom,(
    ! [Natural2: code_natural] :
      ( ( zero_zero @ code_natural )
     != ( code_Suc @ Natural2 ) ) )).

% natural.distinct(1)
thf(fact_139_natural_Odistinct_I2_J,axiom,(
    ! [Natural4: code_natural] :
      ( ( code_Suc @ Natural4 )
     != ( zero_zero @ code_natural ) ) )).

% natural.distinct(2)
thf(fact_140_random__aux__set_Ocases,axiom,(
    ! [X: ( product_prod @ code_natural @ code_natural )] :
      ( ! [J: code_natural] :
          ( X
         != ( product_Pair @ code_natural @ code_natural @ ( zero_zero @ code_natural ) @ J ) )
     => ~ ( ! [I2: code_natural,J: code_natural] :
              ( X
             != ( product_Pair @ code_natural @ code_natural @ ( code_Suc @ I2 ) @ J ) ) ) ) )).

% random_aux_set.cases
thf(fact_141_random__aux__rec,axiom,(
    ! [A: $tType,Random_aux: ( code_natural > A ),Rhs: ( code_natural > A ),K: code_natural] :
      ( ( ( Random_aux @ ( zero_zero @ code_natural ) )
        = ( Rhs @ ( zero_zero @ code_natural ) ) )
     => ( ! [K2: code_natural] :
            ( ( Random_aux @ ( code_Suc @ K2 ) )
            = ( Rhs @ ( code_Suc @ K2 ) ) )
       => ( ( Random_aux @ K )
          = ( Rhs @ K ) ) ) ) )).

% random_aux_rec
thf(fact_142_random__aux__set_Oinduct,axiom,(
    ! [B: $tType] :
      ( ( quickcheck_random @ B @ ( type2 @ B ) )
     => ! [P: ( code_natural > code_natural > $o ),A0: code_natural,A1: code_natural] :
          ( ! [X12: code_natural] :
              ( P @ ( zero_zero @ code_natural ) @ X12 )
         => ( ! [I2: code_natural,J: code_natural] :
                ( ! [X5: ( product_prod @ B @ ( product_unit > code_term ) )] :
                    ( P @ I2 @ J )
               => ( P @ ( code_Suc @ I2 ) @ J ) )
           => ( P @ A0 @ A1 ) ) ) ) )).

% random_aux_set.induct
thf(fact_143_case__enat__0,axiom,(
    ! [A: $tType,F: ( nat > A ),I: A] :
      ( ( extended_case_enat @ A @ F @ I @ ( zero_zero @ extended_enat ) )
      = ( F @ ( zero_zero @ nat ) ) ) )).

% case_enat_0
thf(fact_144_the__enat__0,axiom,
    ( ( extended_the_enat @ ( zero_zero @ extended_enat ) )
    = ( zero_zero @ nat ) )).

% the_enat_0
thf(fact_145_size__ne__size__imp__ne,axiom,(
    ! [A: $tType] :
      ( ( size @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) )).

% size_ne_size_imp_ne
thf(fact_146_lprefix__expand,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ~ ( coindu335574135_lnull @ A @ Ys )
          & ( ( coindu1046438764le_lhd @ A @ Xs )
            = ( coindu1046438764le_lhd @ A @ Ys ) )
          & ( coindu1696667936prefix @ A @ ( coindu1047225960le_ltl @ A @ Xs ) @ ( coindu1047225960le_ltl @ A @ Ys ) ) ) )
     => ( coindu1696667936prefix @ A @ Xs @ Ys ) ) )).

% lprefix_expand
thf(fact_147_lprefix__refl,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( coindu1696667936prefix @ A @ Xs @ Xs ) )).

% lprefix_refl
thf(fact_148_llist_Oleq__refl,axiom,(
    ! [A: $tType,X: ( coindu1593790203_llist @ A )] :
      ( coindu1696667936prefix @ A @ X @ X ) )).

% llist.leq_refl
thf(fact_149_LCons__lprefix__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coindu1593790203_llist @ A ),Y: A,Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ ( coindu1121789889_LCons @ A @ Y @ Ys ) )
      = ( ( X = Y )
        & ( coindu1696667936prefix @ A @ Xs @ Ys ) ) ) )).

% LCons_lprefix_LCons
thf(fact_150_lprefix__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coindu1593790203_llist @ A )] :
      ( coindu1696667936prefix @ A @ ( coindu1598213697e_LNil @ A ) @ Ys ) )).

% lprefix_code(1)
thf(fact_151_lprefix__LNil,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ ( coindu1598213697e_LNil @ A ) )
      = ( coindu335574135_lnull @ A @ Xs ) ) )).

% lprefix_LNil
thf(fact_152_lnull__lprefix,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Xs )
     => ( coindu1696667936prefix @ A @ Xs @ Ys ) ) )).

% lnull_lprefix
thf(fact_153_lprefix__lnull,axiom,(
    ! [A: $tType,Ys: ( coindu1593790203_llist @ A ),Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ Ys )
     => ( ( coindu1696667936prefix @ A @ Xs @ Ys )
        = ( coindu335574135_lnull @ A @ Xs ) ) ) )).

% lprefix_lnull
thf(fact_154_lprefix__lnullD,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( ( coindu335574135_lnull @ A @ Ys )
       => ( coindu335574135_lnull @ A @ Xs ) ) ) )).

% lprefix_lnullD
thf(fact_155_lprefix__not__lnullD,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ~ ( coindu335574135_lnull @ A @ Ys ) ) ) )).

% lprefix_not_lnullD
thf(fact_156_LCons__lprefix__conv,axiom,(
    ! [A: $tType,X: A,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ Ys )
      = ( ? [Ys5: ( coindu1593790203_llist @ A )] :
            ( ( Ys
              = ( coindu1121789889_LCons @ A @ X @ Ys5 ) )
            & ( coindu1696667936prefix @ A @ Xs @ Ys5 ) ) ) ) )).

% LCons_lprefix_conv
thf(fact_157_Le__LCons,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A ),X: A] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( coindu1696667936prefix @ A @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ ( coindu1121789889_LCons @ A @ X @ Ys ) ) ) )).

% Le_LCons
thf(fact_158_LNil__lprefix,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( coindu1696667936prefix @ A @ ( coindu1598213697e_LNil @ A ) @ Xs ) )).

% LNil_lprefix
thf(fact_159_lprefix__ltlI,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( coindu1696667936prefix @ A @ ( coindu1047225960le_ltl @ A @ Xs ) @ ( coindu1047225960le_ltl @ A @ Ys ) ) ) )).

% lprefix_ltlI
thf(fact_160_lprefix__lappend__sameI,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A ),Zs: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( coindu1696667936prefix @ A @ ( coindu268472904append @ A @ Zs @ Xs ) @ ( coindu268472904append @ A @ Zs @ Ys ) ) ) )).

% lprefix_lappend_sameI
thf(fact_161_lprefix__lappend,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( coindu1696667936prefix @ A @ Xs @ ( coindu268472904append @ A @ Xs @ Ys ) ) )).

% lprefix_lappend
thf(fact_162_lprefix__trans,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A ),Zs: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( ( coindu1696667936prefix @ A @ Ys @ Zs )
       => ( coindu1696667936prefix @ A @ Xs @ Zs ) ) ) )).

% lprefix_trans
thf(fact_163_llist_Oleq__trans,axiom,(
    ! [A: $tType,X: ( coindu1593790203_llist @ A ),Y: ( coindu1593790203_llist @ A ),Z: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ X @ Y )
     => ( ( coindu1696667936prefix @ A @ Y @ Z )
       => ( coindu1696667936prefix @ A @ X @ Z ) ) ) )).

% llist.leq_trans
thf(fact_164_lprefix__antisym,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( ( coindu1696667936prefix @ A @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% lprefix_antisym
thf(fact_165_llist_Oleq__antisym,axiom,(
    ! [A: $tType,X: ( coindu1593790203_llist @ A ),Y: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ X @ Y )
     => ( ( coindu1696667936prefix @ A @ Y @ X )
       => ( X = Y ) ) ) )).

% llist.leq_antisym
thf(fact_166_lprefix__down__linear,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Zs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Zs )
     => ( ( coindu1696667936prefix @ A @ Ys @ Zs )
       => ( ( coindu1696667936prefix @ A @ Xs @ Ys )
          | ( coindu1696667936prefix @ A @ Ys @ Xs ) ) ) ) )).

% lprefix_down_linear
thf(fact_167_lprefixI,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A ),X4: ( set @ ( product_prod @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) ) )] :
      ( ( member @ ( product_prod @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) ) @ ( product_Pair @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) @ Xs @ Ys ) @ X4 )
     => ( ! [Xs4: ( coindu1593790203_llist @ A ),Ys3: ( coindu1593790203_llist @ A )] :
            ( ( member @ ( product_prod @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) ) @ ( product_Pair @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) @ Xs4 @ Ys3 ) @ X4 )
           => ( ( coindu335574135_lnull @ A @ Xs4 )
              | ? [X5: A,Xs6: ( coindu1593790203_llist @ A ),Ys6: ( coindu1593790203_llist @ A )] :
                  ( ( Xs4
                    = ( coindu1121789889_LCons @ A @ X5 @ Xs6 ) )
                  & ( Ys3
                    = ( coindu1121789889_LCons @ A @ X5 @ Ys6 ) )
                  & ( ( member @ ( product_prod @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) ) @ ( product_Pair @ ( coindu1593790203_llist @ A ) @ ( coindu1593790203_llist @ A ) @ Xs6 @ Ys6 ) @ X4 )
                    | ( coindu1696667936prefix @ A @ Xs6 @ Ys6 ) ) ) ) )
       => ( coindu1696667936prefix @ A @ Xs @ Ys ) ) ) )).

% lprefixI
thf(fact_168_lprefix__code_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coindu1593790203_llist @ A )] :
      ~ ( coindu1696667936prefix @ A @ ( coindu1121789889_LCons @ A @ X @ Xs ) @ ( coindu1598213697e_LNil @ A ) ) )).

% lprefix_code(2)
thf(fact_169_lprefix_Ocases,axiom,(
    ! [A: $tType,A1: ( coindu1593790203_llist @ A ),A22: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ A1 @ A22 )
     => ( ( ( A1
            = ( coindu1598213697e_LNil @ A ) )
         => ! [Xs4: ( coindu1593790203_llist @ A )] : ( A22 != Xs4 ) )
       => ~ ( ! [Xs4: ( coindu1593790203_llist @ A ),Ys3: ( coindu1593790203_llist @ A ),X3: A] :
                ( ( A1
                  = ( coindu1121789889_LCons @ A @ X3 @ Xs4 ) )
               => ( ( A22
                    = ( coindu1121789889_LCons @ A @ X3 @ Ys3 ) )
                 => ~ ( coindu1696667936prefix @ A @ Xs4 @ Ys3 ) ) ) ) ) ) )).

% lprefix.cases
thf(fact_170_lprefix_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu1696667936prefix @ A )
      = ( ^ [A12: ( coindu1593790203_llist @ A ),A23: ( coindu1593790203_llist @ A )] :
            ( ? [Xs3: ( coindu1593790203_llist @ A )] :
                ( ( A12
                  = ( coindu1598213697e_LNil @ A ) )
                & ( A23 = Xs3 ) )
            | ? [Xs3: ( coindu1593790203_llist @ A ),Ys2: ( coindu1593790203_llist @ A ),X2: A] :
                ( ( A12
                  = ( coindu1121789889_LCons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( coindu1121789889_LCons @ A @ X2 @ Ys2 ) )
                & ( coindu1696667936prefix @ A @ Xs3 @ Ys2 ) ) ) ) ) )).

% lprefix.simps
thf(fact_171_lprefix_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ),X: ( coindu1593790203_llist @ A ),Xa: ( coindu1593790203_llist @ A )] :
      ( ( X4 @ X @ Xa )
     => ( ! [X3: ( coindu1593790203_llist @ A ),Xa2: ( coindu1593790203_llist @ A )] :
            ( ( X4 @ X3 @ Xa2 )
           => ( ? [Xs5: ( coindu1593790203_llist @ A )] :
                  ( ( X3
                    = ( coindu1598213697e_LNil @ A ) )
                  & ( Xa2 = Xs5 ) )
              | ? [Xs5: ( coindu1593790203_llist @ A ),Ys4: ( coindu1593790203_llist @ A ),Xb: A] :
                  ( ( X3
                    = ( coindu1121789889_LCons @ A @ Xb @ Xs5 ) )
                  & ( Xa2
                    = ( coindu1121789889_LCons @ A @ Xb @ Ys4 ) )
                  & ( ( X4 @ Xs5 @ Ys4 )
                    | ( coindu1696667936prefix @ A @ Xs5 @ Ys4 ) ) ) ) )
       => ( coindu1696667936prefix @ A @ X @ Xa ) ) ) )).

% lprefix.coinduct
thf(fact_172_lprefix__LCons__conv,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Y: A,Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ ( coindu1121789889_LCons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( coindu1598213697e_LNil @ A ) )
        | ? [Xs2: ( coindu1593790203_llist @ A )] :
            ( ( Xs
              = ( coindu1121789889_LCons @ A @ Y @ Xs2 ) )
            & ( coindu1696667936prefix @ A @ Xs2 @ Ys ) ) ) ) )).

% lprefix_LCons_conv
thf(fact_173_lprefix__lhdD,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( coindu1696667936prefix @ A @ Xs @ Ys )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1046438764le_lhd @ A @ Xs )
          = ( coindu1046438764le_lhd @ A @ Ys ) ) ) ) )).

% lprefix_lhdD
thf(fact_174_lprefix__coinduct,axiom,(
    ! [A: $tType,P: ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ A ) > $o ),Xs: ( coindu1593790203_llist @ A ),Ys: ( coindu1593790203_llist @ A )] :
      ( ( P @ Xs @ Ys )
     => ( ! [Xs4: ( coindu1593790203_llist @ A ),Ys3: ( coindu1593790203_llist @ A )] :
            ( ( P @ Xs4 @ Ys3 )
           => ( ( ( coindu335574135_lnull @ A @ Ys3 )
               => ( coindu335574135_lnull @ A @ Xs4 ) )
              & ( ~ ( coindu335574135_lnull @ A @ Xs4 )
               => ( ~ ( coindu335574135_lnull @ A @ Ys3 )
                 => ( ( ( coindu1046438764le_lhd @ A @ Xs4 )
                      = ( coindu1046438764le_lhd @ A @ Ys3 ) )
                    & ( ( P @ ( coindu1047225960le_ltl @ A @ Xs4 ) @ ( coindu1047225960le_ltl @ A @ Ys3 ) )
                      | ( coindu1696667936prefix @ A @ ( coindu1047225960le_ltl @ A @ Xs4 ) @ ( coindu1047225960le_ltl @ A @ Ys3 ) ) ) ) ) ) ) )
       => ( coindu1696667936prefix @ A @ Xs @ Ys ) ) ) )).

% lprefix_coinduct
thf(fact_175_bool_Osize_I4_J,axiom,
    ( ( size_size @ $o @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(4)
thf(fact_176_bool_Osize_I3_J,axiom,
    ( ( size_size @ $o @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(3)
thf(fact_177_lstrict__prefix__def,axiom,(
    ! [A: $tType] :
      ( ( coindu574146665prefix @ A )
      = ( ^ [Xs3: ( coindu1593790203_llist @ A ),Ys2: ( coindu1593790203_llist @ A )] :
            ( ( coindu1696667936prefix @ A @ Xs3 @ Ys2 )
            & ( Xs3 != Ys2 ) ) ) ) )).

% lstrict_prefix_def
thf(fact_178_size__bool,axiom,
    ( ( size_size @ $o )
    = ( ^ [B5: $o] :
          ( zero_zero @ nat ) ) )).

% size_bool
thf(fact_179_sum_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,X: ( sum_sum @ A @ B )] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ X )
     != ( zero_zero @ nat ) ) )).

% sum.size_neq
thf(fact_180_prod_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,X: ( product_prod @ A @ B )] :
      ( ( size_size @ ( product_prod @ A @ B ) @ X )
     != ( zero_zero @ nat ) ) )).

% prod.size_neq
thf(fact_181_bool_Osize_I2_J,axiom,
    ( ( size_bool @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(2)
thf(fact_182_bool_Osize_I1_J,axiom,
    ( ( size_bool @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(1)
thf(fact_183_size__bool__overloaded__def,axiom,
    ( ( size_size @ $o )
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_overloaded_def
thf(fact_184_old_Obool_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F2: T] :
      ( ( product_rec_bool @ T @ F1 @ F2 @ $true )
      = F1 ) )).

% old.bool.simps(5)
thf(fact_185_old_Obool_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F2: T] :
      ( ( product_rec_bool @ T @ F1 @ F2 @ $false )
      = F2 ) )).

% old.bool.simps(6)
thf(fact_186_size__bool__def,axiom,
    ( size_bool
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_def
thf(fact_187_tuple__isomorphism_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X: ( tuple_isomorphism @ A @ B @ C )] :
      ( ( size_size @ ( tuple_isomorphism @ A @ B @ C ) @ X )
     != ( zero_zero @ nat ) ) )).

% tuple_isomorphism.size_neq
thf(fact_188_size__literal__def,axiom,
    ( ( size_size @ literal )
    = ( ^ [S: literal] :
          ( zero_zero @ nat ) ) )).

% size_literal_def
thf(fact_189_typerep_Osize__neq,axiom,(
    ! [X: typerep] :
      ( ( size_size @ typerep @ X )
     != ( zero_zero @ nat ) ) )).

% typerep.size_neq
thf(fact_190_option_Osize__neq,axiom,(
    ! [A: $tType,X: ( option @ A )] :
      ( ( size_size @ ( option @ A ) @ X )
     != ( zero_zero @ nat ) ) )).

% option.size_neq
thf(fact_191_size__unit__overloaded__def,axiom,
    ( ( size_size @ product_unit )
    = ( product_rec_unit @ nat @ ( zero_zero @ nat ) ) )).

% size_unit_overloaded_def
thf(fact_192_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R2: A,S2: B,R: ( set @ ( product_prod @ A @ B ) ),S3: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R2 @ S2 ) @ R )
     => ( ( S3 = S2 )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R2 @ S3 ) @ R ) ) ) )).

% ssubst_Pair_rhs
thf(fact_193_size__unit__def,axiom,
    ( product_size_unit
    = ( product_rec_unit @ nat @ ( zero_zero @ nat ) ) )).

% size_unit_def
thf(fact_194_unit_Osize_I2_J,axiom,
    ( ( size_size @ product_unit @ product_Unity )
    = ( zero_zero @ nat ) )).

% unit.size(2)
thf(fact_195_old_Ounit_Orec,axiom,(
    ! [T: $tType,F1: T] :
      ( ( product_rec_unit @ T @ F1 @ product_Unity )
      = F1 ) )).

% old.unit.rec
thf(fact_196_unit_Osize_I1_J,axiom,
    ( ( product_size_unit @ product_Unity )
    = ( zero_zero @ nat ) )).

% unit.size(1)
thf(fact_197_old_Ounit_Oinducts,axiom,(
    ! [P: ( product_unit > $o ),Unit: product_unit] :
      ( ( P @ product_Unity )
     => ( P @ Unit ) ) )).

% old.unit.inducts
thf(fact_198_old_Ounit_Oexhaust,axiom,(
    ! [Y: product_unit] : ( Y = product_Unity ) )).

% old.unit.exhaust
thf(fact_199_default__unit__def,axiom,
    ( ( default_default @ product_unit )
    = product_Unity )).

% default_unit_def
thf(fact_200_old_Ounit_Ocase,axiom,(
    ! [A: $tType,F: A] :
      ( ( product_case_unit @ A @ F @ product_Unity )
      = F ) )).

% old.unit.case
thf(fact_201_unit_Ocase__distrib,axiom,(
    ! [A: $tType,B: $tType,H: ( A > B ),F: A,Unit: product_unit] :
      ( ( H @ ( product_case_unit @ A @ F @ Unit ) )
      = ( product_case_unit @ B @ ( H @ F ) @ Unit ) ) )).

% unit.case_distrib
thf(fact_202_ltake_Osimps_I3_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( N
       != ( zero_zero @ extended_enat ) )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1046438764le_lhd @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) )
          = ( coindu1046438764le_lhd @ A @ Xs ) ) ) ) )).

% ltake.simps(3)
thf(fact_203_llist_Orel__sel,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu987187967t_all2 @ A @ B )
      = ( ^ [R4: ( A > B > $o ),A5: ( coindu1593790203_llist @ A ),B5: ( coindu1593790203_llist @ B )] :
            ( ( ( coindu335574135_lnull @ A @ A5 )
              = ( coindu335574135_lnull @ B @ B5 ) )
            & ( ~ ( coindu335574135_lnull @ A @ A5 )
             => ( ~ ( coindu335574135_lnull @ B @ B5 )
               => ( ( R4 @ ( coindu1046438764le_lhd @ A @ A5 ) @ ( coindu1046438764le_lhd @ B @ B5 ) )
                  & ( coindu987187967t_all2 @ A @ B @ R4 @ ( coindu1047225960le_ltl @ A @ A5 ) @ ( coindu1047225960le_ltl @ B @ B5 ) ) ) ) ) ) ) ) )).

% llist.rel_sel
thf(fact_204_ltake__is__lprefix,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( coindu1696667936prefix @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) @ Xs ) )).

% ltake_is_lprefix
thf(fact_205_ltake__LNil,axiom,(
    ! [A: $tType,N: extended_enat] :
      ( ( coindu1802687541_ltake @ A @ N @ ( coindu1598213697e_LNil @ A ) )
      = ( coindu1598213697e_LNil @ A ) ) )).

% ltake_LNil
thf(fact_206_llist_Orel__inject_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X21: A,X22: ( coindu1593790203_llist @ A ),Y21: B,Y22: ( coindu1593790203_llist @ B )] :
      ( ( coindu987187967t_all2 @ A @ B @ R @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) @ ( coindu1121789889_LCons @ B @ Y21 @ Y22 ) )
      = ( ( R @ X21 @ Y21 )
        & ( coindu987187967t_all2 @ A @ B @ R @ X22 @ Y22 ) ) ) )).

% llist.rel_inject(2)
thf(fact_207_ltake__lmap,axiom,(
    ! [A: $tType,B: $tType,N: extended_enat,F: ( B > A ),Xs: ( coindu1593790203_llist @ B )] :
      ( ( coindu1802687541_ltake @ A @ N @ ( coindu1062782156e_lmap @ B @ A @ F @ Xs ) )
      = ( coindu1062782156e_lmap @ B @ A @ F @ ( coindu1802687541_ltake @ B @ N @ Xs ) ) ) )).

% ltake_lmap
thf(fact_208_lnull__ltake,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) )
      = ( ( coindu335574135_lnull @ A @ Xs )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) )).

% lnull_ltake
thf(fact_209_ltake_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu335574135_lnull @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) )
      = ( ( N
          = ( zero_zero @ extended_enat ) )
        | ( coindu335574135_lnull @ A @ Xs ) ) ) )).

% ltake.disc_iff(1)
thf(fact_210_ltake_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ~ ( coindu335574135_lnull @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) ) )
      = ( ( N
         != ( zero_zero @ extended_enat ) )
        & ~ ( coindu335574135_lnull @ A @ Xs ) ) ) )).

% ltake.disc_iff(2)
thf(fact_211_LNil__eq__ltake__iff,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu1598213697e_LNil @ A )
        = ( coindu1802687541_ltake @ A @ N @ Xs ) )
      = ( ( Xs
          = ( coindu1598213697e_LNil @ A ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) )).

% LNil_eq_ltake_iff
thf(fact_212_ltake__0,axiom,(
    ! [A: $tType,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu1802687541_ltake @ A @ ( zero_zero @ extended_enat ) @ Xs )
      = ( coindu1598213697e_LNil @ A ) ) )).

% ltake_0
thf(fact_213_lhd__ltake,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( N
       != ( zero_zero @ extended_enat ) )
     => ( ( coindu1046438764le_lhd @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) )
        = ( coindu1046438764le_lhd @ A @ Xs ) ) ) )).

% lhd_ltake
thf(fact_214_llist_Orel__cases,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),A2: ( coindu1593790203_llist @ A ),B2: ( coindu1593790203_llist @ B )] :
      ( ( coindu987187967t_all2 @ A @ B @ R @ A2 @ B2 )
     => ( ( ( A2
            = ( coindu1598213697e_LNil @ A ) )
         => ( B2
           != ( coindu1598213697e_LNil @ B ) ) )
       => ~ ( ! [X12: A,X24: ( coindu1593790203_llist @ A )] :
                ( ( A2
                  = ( coindu1121789889_LCons @ A @ X12 @ X24 ) )
               => ! [Y12: B,Y23: ( coindu1593790203_llist @ B )] :
                    ( ( B2
                      = ( coindu1121789889_LCons @ B @ Y12 @ Y23 ) )
                   => ( ( R @ X12 @ Y12 )
                     => ~ ( coindu987187967t_all2 @ A @ B @ R @ X24 @ Y23 ) ) ) ) ) ) ) )).

% llist.rel_cases
thf(fact_215_llist_Orel__distinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),Y21: B,Y22: ( coindu1593790203_llist @ B )] :
      ~ ( coindu987187967t_all2 @ A @ B @ R @ ( coindu1598213697e_LNil @ A ) @ ( coindu1121789889_LCons @ B @ Y21 @ Y22 ) ) )).

% llist.rel_distinct(1)
thf(fact_216_llist_Orel__distinct_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),Y21: A,Y22: ( coindu1593790203_llist @ A )] :
      ~ ( coindu987187967t_all2 @ A @ B @ R @ ( coindu1121789889_LCons @ A @ Y21 @ Y22 ) @ ( coindu1598213697e_LNil @ B ) ) )).

% llist.rel_distinct(2)
thf(fact_217_ltake_Odisc_I2_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( N
       != ( zero_zero @ extended_enat ) )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ~ ( coindu335574135_lnull @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) ) ) ) )).

% ltake.disc(2)
thf(fact_218_ltake_Odisc_I1_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ( N
          = ( zero_zero @ extended_enat ) )
        | ( coindu335574135_lnull @ A @ Xs ) )
     => ( coindu335574135_lnull @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) ) ) )).

% ltake.disc(1)
thf(fact_219_ltake__eq__LNil__iff,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ( coindu1802687541_ltake @ A @ N @ Xs )
        = ( coindu1598213697e_LNil @ A ) )
      = ( ( Xs
          = ( coindu1598213697e_LNil @ A ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) )).

% ltake_eq_LNil_iff
thf(fact_220_llist_Orel__intros_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X21: A,Y21: B,X22: ( coindu1593790203_llist @ A ),Y22: ( coindu1593790203_llist @ B )] :
      ( ( R @ X21 @ Y21 )
     => ( ( coindu987187967t_all2 @ A @ B @ R @ X22 @ Y22 )
       => ( coindu987187967t_all2 @ A @ B @ R @ ( coindu1121789889_LCons @ A @ X21 @ X22 ) @ ( coindu1121789889_LCons @ B @ Y21 @ Y22 ) ) ) ) )).

% llist.rel_intros(2)
thf(fact_221_llist_Octr__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( coindu987187967t_all2 @ A @ B @ R @ ( coindu1598213697e_LNil @ A ) @ ( coindu1598213697e_LNil @ B ) ) )).

% llist.ctr_transfer(1)
thf(fact_222_llist_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( coindu987187967t_all2 @ A @ A
        @ ^ [Y6: A,Z2: A] : ( Y6 = Z2 ) )
      = ( ^ [Y6: ( coindu1593790203_llist @ A ),Z2: ( coindu1593790203_llist @ A )] : ( Y6 = Z2 ) ) ) )).

% llist.rel_eq
thf(fact_223_llist_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X: ( coindu1593790203_llist @ B )] :
      ( ! [X3: B] :
          ( Ra @ X3 @ X3 )
     => ( coindu987187967t_all2 @ B @ B @ Ra @ X @ X ) ) )).

% llist.rel_refl
thf(fact_224_ltake_Octr_I1_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( ( N
          = ( zero_zero @ extended_enat ) )
        | ( coindu335574135_lnull @ A @ Xs ) )
     => ( ( coindu1802687541_ltake @ A @ N @ Xs )
        = ( coindu1598213697e_LNil @ A ) ) ) )).

% ltake.ctr(1)
thf(fact_225_llist_Orel__coinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( coindu1593790203_llist @ A ) > ( coindu1593790203_llist @ B ) > $o ),X: ( coindu1593790203_llist @ A ),Y: ( coindu1593790203_llist @ B ),R: ( A > B > $o )] :
      ( ( P @ X @ Y )
     => ( ! [Llist4: ( coindu1593790203_llist @ A ),Llist5: ( coindu1593790203_llist @ B )] :
            ( ( P @ Llist4 @ Llist5 )
           => ( ( ( coindu335574135_lnull @ A @ Llist4 )
                = ( coindu335574135_lnull @ B @ Llist5 ) )
              & ( ~ ( coindu335574135_lnull @ A @ Llist4 )
               => ( ~ ( coindu335574135_lnull @ B @ Llist5 )
                 => ( ( R @ ( coindu1046438764le_lhd @ A @ Llist4 ) @ ( coindu1046438764le_lhd @ B @ Llist5 ) )
                    & ( P @ ( coindu1047225960le_ltl @ A @ Llist4 ) @ ( coindu1047225960le_ltl @ B @ Llist5 ) ) ) ) ) ) )
       => ( coindu987187967t_all2 @ A @ B @ R @ X @ Y ) ) ) )).

% llist.rel_coinduct
thf(fact_226_ltake_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coindu1802687541_ltake @ A )
      = ( ^ [N2: extended_enat,Xs3: ( coindu1593790203_llist @ A )] :
            ( if @ ( coindu1593790203_llist @ A )
            @ ( ( N2
                = ( zero_zero @ extended_enat ) )
              | ( coindu335574135_lnull @ A @ Xs3 ) )
            @ ( coindu1598213697e_LNil @ A )
            @ ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Xs3 ) @ ( coindu1802687541_ltake @ A @ ( coinductive_epred @ N2 ) @ ( coindu1047225960le_ltl @ A @ Xs3 ) ) ) ) ) ) )).

% ltake.code
thf(fact_227_ltake_Octr_I2_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( N
       != ( zero_zero @ extended_enat ) )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1802687541_ltake @ A @ N @ Xs )
          = ( coindu1121789889_LCons @ A @ ( coindu1046438764le_lhd @ A @ Xs ) @ ( coindu1802687541_ltake @ A @ ( coinductive_epred @ N ) @ ( coindu1047225960le_ltl @ A @ Xs ) ) ) ) ) ) )).

% ltake.ctr(2)
thf(fact_228_ltake__epred__ltl,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( coindu1802687541_ltake @ A @ ( coinductive_epred @ N ) @ ( coindu1047225960le_ltl @ A @ Xs ) )
      = ( coindu1047225960le_ltl @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) ) ) )).

% ltake_epred_ltl
thf(fact_229_epred__0,axiom,
    ( ( coinductive_epred @ ( zero_zero @ extended_enat ) )
    = ( zero_zero @ extended_enat ) )).

% epred_0
thf(fact_230_epred__inject,axiom,(
    ! [X: extended_enat,Y: extended_enat] :
      ( ( X
       != ( zero_zero @ extended_enat ) )
     => ( ( Y
         != ( zero_zero @ extended_enat ) )
       => ( ( ( coinductive_epred @ X )
            = ( coinductive_epred @ Y ) )
          = ( X = Y ) ) ) ) )).

% epred_inject
thf(fact_231_enat__coinduct,axiom,(
    ! [P: ( extended_enat > extended_enat > $o ),M: extended_enat,N: extended_enat] :
      ( ( P @ M @ N )
     => ( ! [M2: extended_enat,N3: extended_enat] :
            ( ( P @ M2 @ N3 )
           => ( ( ( M2
                  = ( zero_zero @ extended_enat ) )
                = ( N3
                  = ( zero_zero @ extended_enat ) ) )
              & ( ( M2
                 != ( zero_zero @ extended_enat ) )
               => ( ( N3
                   != ( zero_zero @ extended_enat ) )
                 => ( ( P @ ( coinductive_epred @ M2 ) @ ( coinductive_epred @ N3 ) )
                    | ( ( coinductive_epred @ M2 )
                      = ( coinductive_epred @ N3 ) ) ) ) ) ) )
       => ( M = N ) ) ) )).

% enat_coinduct
thf(fact_232_co_Oenat_Oexpand,axiom,(
    ! [Enat: extended_enat,Enat2: extended_enat] :
      ( ( ( Enat
          = ( zero_zero @ extended_enat ) )
        = ( Enat2
          = ( zero_zero @ extended_enat ) ) )
     => ( ( ( Enat
           != ( zero_zero @ extended_enat ) )
         => ( ( Enat2
             != ( zero_zero @ extended_enat ) )
           => ( ( coinductive_epred @ Enat )
              = ( coinductive_epred @ Enat2 ) ) ) )
       => ( Enat = Enat2 ) ) ) )).

% co.enat.expand
thf(fact_233_enat__coinduct2,axiom,(
    ! [P: ( extended_enat > extended_enat > $o ),M: extended_enat,N: extended_enat] :
      ( ( P @ M @ N )
     => ( ! [M2: extended_enat,N3: extended_enat] :
            ( ( P @ M2 @ N3 )
           => ( ( M2
                = ( zero_zero @ extended_enat ) )
              = ( N3
                = ( zero_zero @ extended_enat ) ) ) )
       => ( ! [M2: extended_enat,N3: extended_enat] :
              ( ( P @ M2 @ N3 )
             => ( ( M2
                 != ( zero_zero @ extended_enat ) )
               => ( ( N3
                   != ( zero_zero @ extended_enat ) )
                 => ( ( P @ ( coinductive_epred @ M2 ) @ ( coinductive_epred @ N3 ) )
                    | ( ( coinductive_epred @ M2 )
                      = ( coinductive_epred @ N3 ) ) ) ) ) )
         => ( M = N ) ) ) ) )).

% enat_coinduct2
thf(fact_234_ltake_Osimps_I4_J,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coindu1593790203_llist @ A )] :
      ( ( N
       != ( zero_zero @ extended_enat ) )
     => ( ~ ( coindu335574135_lnull @ A @ Xs )
       => ( ( coindu1047225960le_ltl @ A @ ( coindu1802687541_ltake @ A @ N @ Xs ) )
          = ( coindu1802687541_ltake @ A @ ( coinductive_epred @ N ) @ ( coindu1047225960le_ltl @ A @ Xs ) ) ) ) ) )).

% ltake.simps(4)
thf(fact_235_epred__enat__unfold,axiom,(
    ! [A: $tType,Stop: ( A > $o ),A2: A,Next: ( A > A )] :
      ( ( ( Stop @ A2 )
       => ( ( coinductive_epred @ ( coindu1491768222unfold @ A @ Stop @ Next @ A2 ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ~ ( Stop @ A2 )
       => ( ( coinductive_epred @ ( coindu1491768222unfold @ A @ Stop @ Next @ A2 ) )
          = ( coindu1491768222unfold @ A @ Stop @ Next @ ( Next @ A2 ) ) ) ) ) )).

% epred_enat_unfold
thf(fact_236_co_Oenat_Ocase__eq__if,axiom,(
    ! [A: $tType] :
      ( ( coindu440805660e_enat @ A )
      = ( ^ [F12: A,F22: ( extended_enat > A ),Enat3: extended_enat] :
            ( if @ A
            @ ( Enat3
              = ( zero_zero @ extended_enat ) )
            @ F12
            @ ( F22 @ ( coinductive_epred @ Enat3 ) ) ) ) ) )).

% co.enat.case_eq_if
thf(fact_237_enat__unfold__stop,axiom,(
    ! [A: $tType,Stop: ( A > $o ),A2: A,Next: ( A > A )] :
      ( ( Stop @ A2 )
     => ( ( coindu1491768222unfold @ A @ Stop @ Next @ A2 )
        = ( zero_zero @ extended_enat ) ) ) )).

% enat_unfold_stop
thf(fact_238_enat__unfold__eq__0,axiom,(
    ! [A: $tType,Stop: ( A > $o ),Next: ( A > A ),A2: A] :
      ( ( ( coindu1491768222unfold @ A @ Stop @ Next @ A2 )
        = ( zero_zero @ extended_enat ) )
      = ( Stop @ A2 ) ) )).

% enat_unfold_eq_0
thf(fact_239_enat__cocase__0,axiom,(
    ! [A: $tType,Z: A,S2: ( extended_enat > A )] :
      ( ( coindu440805660e_enat @ A @ Z @ S2 @ ( zero_zero @ extended_enat ) )
      = Z ) )).

% enat_cocase_0
thf(fact_240_co_Oenat_Ocase_I1_J,axiom,(
    ! [A: $tType,F1: A,F2: ( extended_enat > A )] :
      ( ( coindu440805660e_enat @ A @ F1 @ F2 @ ( zero_zero @ extended_enat ) )
      = F1 ) )).

% co.enat.case(1)

%----Type constructors (83)
thf(tcon_Coinductive__List__Mirabelle__kmikjhschf_Ollist___Code__Evaluation_Oterm__of,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( code_term_of @ ( coindu1593790203_llist @ A7 ) @ ( type2 @ ( coindu1593790203_llist @ A7 ) ) ) ) )).

thf(tcon_Coinductive__List__Mirabelle__kmikjhschf_Ollist___HOL_Oequal,axiom,(
    ! [A7: $tType] :
      ( cl_HOL_Oequal @ ( coindu1593790203_llist @ A7 ) @ ( type2 @ ( coindu1593790203_llist @ A7 ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___Code__Evaluation_Oterm__of_1,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) )
        & ( typerep2 @ A9 @ ( type2 @ A9 ) ) )
     => ( code_term_of @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___HOL_Oequal_2,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( cl_HOL_Oequal @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) )).

thf(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_3,axiom,
    ( code_term_of @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___HOL_Oequal_4,axiom,
    ( cl_HOL_Oequal @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_5,axiom,
    ( code_term_of @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Evaluation_Oterm___HOL_Oequal_6,axiom,
    ( cl_HOL_Oequal @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_7,axiom,
    ( code_term_of @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___HOL_Oequal_8,axiom,
    ( cl_HOL_Oequal @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_9,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___HOL_Oequal_10,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( cl_HOL_Oequal @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) )).

thf(tcon_Extended__Nat_Oenat___Code__Evaluation_Oterm__of_11,axiom,
    ( code_term_of @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___HOL_Oequal_12,axiom,
    ( cl_HOL_Oequal @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Typerep_Otyperep___Code__Evaluation_Oterm__of_13,axiom,
    ( code_term_of @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Typerep_Otyperep___HOL_Oequal_14,axiom,
    ( cl_HOL_Oequal @ typerep @ ( type2 @ typerep ) )).

thf(tcon_String_Oliteral___Code__Evaluation_Oterm__of_15,axiom,
    ( code_term_of @ literal @ ( type2 @ literal ) )).

thf(tcon_String_Oliteral___HOL_Oequal_16,axiom,
    ( cl_HOL_Oequal @ literal @ ( type2 @ literal ) )).

thf(tcon_Option_Ooption___Code__Evaluation_Oterm__of_17,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( code_term_of @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___HOL_Oequal_18,axiom,(
    ! [A7: $tType] :
      ( cl_HOL_Oequal @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) )).

thf(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_19,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___HOL_Oequal_20,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( cl_HOL_Oequal @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Code__Evaluation_Oterm__of_21,axiom,
    ( code_term_of @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___HOL_Oequal_22,axiom,
    ( cl_HOL_Oequal @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Code__Evaluation_Oterm__of_23,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( code_term_of @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Set_Oset___HOL_Oequal_24,axiom,(
    ! [A7: $tType] :
      ( ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) )
     => ( cl_HOL_Oequal @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Code__Evaluation_Oterm__of_25,axiom,
    ( code_term_of @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___HOL_Oequal_26,axiom,
    ( cl_HOL_Oequal @ nat @ ( type2 @ nat ) )).

thf(tcon_fun___Code__Evaluation_Oterm__of_27,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___HOL_Oequal_28,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( cl_HOL_Oequal @ A8 @ ( type2 @ A8 ) ) )
     => ( cl_HOL_Oequal @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Typerep_Otyperep,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Enum_Oenum,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( enum @ A8 @ ( type2 @ A8 ) ) )
     => ( enum @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Typerep_Otyperep_29,axiom,
    ( typerep2 @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Typerep_Otyperep_30,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( typerep2 @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Set_Oset___Enum_Oenum_31,axiom,(
    ! [A7: $tType] :
      ( ( enum @ A7 @ ( type2 @ A7 ) )
     => ( enum @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_HOL_Obool___Typerep_Otyperep_32,axiom,
    ( typerep2 @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Enum_Oenum_33,axiom,
    ( enum @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Typerep_Otyperep_34,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Enum_Oenum_35,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( enum @ A8 @ ( type2 @ A8 ) ) )
     => ( enum @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Option_Ooption___Typerep_Otyperep_36,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( typerep2 @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___Enum_Oenum_37,axiom,(
    ! [A7: $tType] :
      ( ( enum @ A7 @ ( type2 @ A7 ) )
     => ( enum @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_String_Oliteral___Typerep_Otyperep_38,axiom,
    ( typerep2 @ literal @ ( type2 @ literal ) )).

thf(tcon_Typerep_Otyperep___Typerep_Otyperep_39,axiom,
    ( typerep2 @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Extended__Nat_Oenat___Typerep_Otyperep_40,axiom,
    ( typerep2 @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Product__Type_Oprod___Typerep_Otyperep_41,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Enum_Oenum_42,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( enum @ A8 @ ( type2 @ A8 ) ) )
     => ( enum @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Ounit___Typerep_Otyperep_43,axiom,
    ( typerep2 @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Enum_Oenum_44,axiom,
    ( enum @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_45,axiom,
    ( typerep2 @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Numeral_Onatural___Typerep_Otyperep_46,axiom,
    ( typerep2 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Record_Otuple__isomorphism___Typerep_Otyperep_47,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) )
        & ( typerep2 @ A9 @ ( type2 @ A9 ) ) )
     => ( typerep2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) ) )).

thf(tcon_Coinductive__List__Mirabelle__kmikjhschf_Ollist___Typerep_Otyperep_48,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( typerep2 @ ( coindu1593790203_llist @ A7 ) @ ( type2 @ ( coindu1593790203_llist @ A7 ) ) ) ) )).

thf(tcon_fun___Quickcheck__Random_Orandom,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( code_term_of @ A7 @ ( type2 @ A7 ) )
        & ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Divides_Osemiring__numeral__div,axiom,
    ( semiring_numeral_div @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Quickcheck__Random_Orandom_49,axiom,
    ( quickcheck_random @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__1,axiom,
    ( semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    ( size @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Quickcheck__Random_Orandom_50,axiom,(
    ! [A7: $tType] :
      ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
     => ( quickcheck_random @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_HOL_Obool___Quickcheck__Random_Orandom_51,axiom,
    ( quickcheck_random @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Nat_Osize_52,axiom,
    ( size @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_53,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Nat_Osize_54,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( size @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) )).

thf(tcon_Option_Ooption___Quickcheck__Random_Orandom_55,axiom,(
    ! [A7: $tType] :
      ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
     => ( quickcheck_random @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___Nat_Osize_56,axiom,(
    ! [A7: $tType] :
      ( size @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) )).

thf(tcon_String_Oliteral___Quickcheck__Random_Orandom_57,axiom,
    ( quickcheck_random @ literal @ ( type2 @ literal ) )).

thf(tcon_String_Oliteral___Nat_Osize_58,axiom,
    ( size @ literal @ ( type2 @ literal ) )).

thf(tcon_Typerep_Otyperep___Nat_Osize_59,axiom,
    ( size @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Extended__Nat_Oenat___Quickcheck__Random_Orandom_60,axiom,
    ( quickcheck_random @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_61,axiom,
    ( semiring_1 @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_62,axiom,
    ( zero @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Nat_Osize_63,axiom,
    ( size @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_64,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Nat_Osize_65,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( size @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) )).

thf(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_66,axiom,
    ( quickcheck_random @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Nat_Osize_67,axiom,
    ( size @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_68,axiom,
    ( quickcheck_random @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_69,axiom,
    ( semiring_1 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_70,axiom,
    ( zero @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Nat_Osize_71,axiom,
    ( size @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Record_Otuple__isomorphism___Quickcheck__Random_Orandom_72,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( ( ( code_term_of @ A7 @ ( type2 @ A7 ) )
        & ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
        & ( quickcheck_random @ A9 @ ( type2 @ A9 ) ) )
     => ( quickcheck_random @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___Nat_Osize_73,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( size @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) )).

thf(tcon_Coinductive__List__Mirabelle__kmikjhschf_Ollist___Quickcheck__Random_Orandom_74,axiom,(
    ! [A7: $tType] :
      ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
     => ( quickcheck_random @ ( coindu1593790203_llist @ A7 ) @ ( type2 @ ( coindu1593790203_llist @ A7 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ~ ( coindu335574135_lnull @ a @ xs ) )).

thf(conj_1,conjecture,
    ( ( coindu1046438764le_lhd @ a @ xs )
    = ( coindu749330388e_lnth @ a @ xs @ ( zero_zero @ nat ) ) )).

%------------------------------------------------------------------------------
