%------------------------------------------------------------------------------
% File     : DAT141^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive list prefix 70
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_list_prefix__70.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  325 (   0 unit;  55 type;   0 defn)
%            Number of atoms       : 5109 ( 329 equality;3507 variable)
%            Maximal formula depth :   28 (  12 average)
%            Number of connectives : 4668 (  43   ~;   1   |;  23   &;4439   @)
%                                         (   0 <=>; 162  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  629 ( 629   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   59 (  55   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1597 (  13 sgn;1314   !;   7   ?; 181   ^)
%                                         (1597   :;  95  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:40:51.031
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Ounit,type,(
    product_unit: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (48)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__inf,type,(
    semilattice_inf: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Def_OGrp,type,(
    bNF_Grp: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > B ) > A > B > $o ) )).

thf(sy_c_BNF__Def_Oconvol,type,(
    bNF_convol: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B ) > ( A > C ) > A > ( product_prod @ B @ C ) ) )).

thf(sy_c_BNF__Def_Ocsquare,type,(
    bNF_csquare: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( set @ A ) > ( B > C ) > ( D > C ) > ( A > B ) > ( A > D ) > $o ) )).

thf(sy_c_BNF__Def_OfstOp,type,(
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > ( product_prod @ A @ C ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Def_Opick__middlep,type,(
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] :
        ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) )).

thf(sy_c_BNF__Def_OsndOp,type,(
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( C > A > $o ) > ( A > B > $o ) > ( product_prod @ C @ B ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,(
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) )).

thf(sy_c_Basic__BNFs_Opred__fun,type,(
    basic_pred_fun: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Fun__Def_Oreduction__pair,type,(
    fun_reduction_pair: 
      !>[A: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > $o ) )).

thf(sy_c_Fun__Def_Orp__inv__image,type,(
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) )).

thf(sy_c_HOL_OThe,type,(
    the: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oapfst,type,(
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) )).

thf(sy_c_Product__Type_Oapsnd,type,(
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__set__bool,type,(
    product_rec_set_bool: 
      !>[T: $tType] :
        ( T > T > $o > T > $o ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,(
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T > $o ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__set__unit,type,(
    product_rec_set_unit: 
      !>[T: $tType] :
        ( T > product_unit > T > $o ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,(
    product_rec_unit: 
      !>[T: $tType] :
        ( T > product_unit > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Osnd,type,(
    product_snd: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > B ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Product__Type_Oscomp,type,(
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Record_Oiso__tuple__update__accessor__cong__assist,type,(
    iso_tu2017585022assist: 
      !>[B: $tType,A: $tType] :
        ( ( ( B > B ) > A > A ) > ( A > B ) > $o ) )).

thf(sy_c_Record_Oiso__tuple__update__accessor__eq__assist,type,(
    iso_tu2011167877assist: 
      !>[B: $tType,A: $tType] :
        ( ( ( B > B ) > A > A ) > ( A > B ) > A > ( B > B ) > A > B > $o ) )).

thf(sy_c_Relation_Oinv__image,type,(
    inv_image: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_xs,type,(
    xs: ( coinductive_llist @ a ) )).

%----Relevant facts (256)
thf(fact_0_local_Oinf__llist__def,axiom,
    ( ( inf_inf @ ( coinductive_llist @ a ) )
    = ( ^ [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
          ( coindu1441602521_llist @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) @ a
          @ ( product_case_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ $o
            @ ^ [Xt: ( coinductive_llist @ a ),Yt: ( coinductive_llist @ a )] :
                ( ( Xt
                 != ( coinductive_LNil @ a ) )
               => ( ( Yt
                   != ( coinductive_LNil @ a ) )
                 => ( ( coinductive_lhd @ a @ Xt )
                   != ( coinductive_lhd @ a @ Yt ) ) ) ) )
          @ ( comp @ ( coinductive_llist @ a ) @ a @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) @ ( coinductive_lhd @ a ) @ ( product_snd @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) )
          @ ( product_map_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_ltl @ a ) @ ( coinductive_ltl @ a ) )
          @ ( product_Pair @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Xs @ Ys ) ) ) )).

% local.inf_llist_def
thf(fact_1_snd__comp__map__prod,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: ( A > D ),G: ( B > C )] :
      ( ( comp @ ( product_prod @ D @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ D @ C ) @ ( product_map_prod @ A @ D @ B @ C @ F @ G ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ G @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_map_prod
thf(fact_2_case__prodI,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A2: A,B2: B] :
      ( ( F @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% case_prodI
thf(fact_3_case__prodI2,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ),C2: ( A > B > $o )] :
      ( ! [A3: A,B3: B] :
          ( ( P
            = ( product_Pair @ A @ B @ A3 @ B3 ) )
         => ( C2 @ A3 @ B3 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P ) ) )).

% case_prodI2
thf(fact_4_case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F @ A2 @ B2 ) ) )).

% case_prod_conv
thf(fact_5_snd__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( C > B ),G: ( D > A ),X: ( product_prod @ C @ D )] :
      ( ( product_snd @ B @ A @ ( product_map_prod @ C @ B @ D @ A @ F @ G @ X ) )
      = ( G @ ( product_snd @ C @ D @ X ) ) ) )).

% snd_map_prod
thf(fact_6_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G: ( D > B ),A2: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F @ G @ ( product_Pair @ C @ D @ A2 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F @ A2 ) @ ( G @ B2 ) ) ) )).

% map_prod_simp
thf(fact_7_Coinductive__List__Prefix__Mirabelle__yfrixeyiok_Oinf__llist__def,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( coinductive_llist @ A ) )
      = ( ^ [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
            ( coindu1441602521_llist @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) @ A
            @ ( product_case_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ $o
              @ ^ [Xt: ( coinductive_llist @ A ),Yt: ( coinductive_llist @ A )] :
                  ( ( Xt
                   != ( coinductive_LNil @ A ) )
                 => ( ( Yt
                     != ( coinductive_LNil @ A ) )
                   => ( ( coinductive_lhd @ A @ Xt )
                     != ( coinductive_lhd @ A @ Yt ) ) ) ) )
            @ ( comp @ ( coinductive_llist @ A ) @ A @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) @ ( coinductive_lhd @ A ) @ ( product_snd @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) )
            @ ( product_map_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_ltl @ A ) @ ( coinductive_ltl @ A ) )
            @ ( product_Pair @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Xs @ Ys ) ) ) ) )).

% Coinductive_List_Prefix_Mirabelle_yfrixeyiok.inf_llist_def
thf(fact_8_map__prod__ident,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [Y: B] : Y )
      = ( ^ [Z: ( product_prod @ A @ B )] : Z ) ) )).

% map_prod_ident
thf(fact_9_split__part,axiom,(
    ! [B: $tType,A: $tType,P2: $o,Q: ( A > B > $o )] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A4: A,B4: B] :
            ( P2
            & ( Q @ A4 @ B4 ) ) )
      = ( ^ [Ab: ( product_prod @ A @ B )] :
            ( P2
            & ( product_case_prod @ A @ B @ $o @ Q @ Ab ) ) ) ) )).

% split_part
thf(fact_10_ltl__unfold__llist,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),A2: B,LHD: ( B > A ),LTL: ( B > B )] :
      ( ( ( IS_LNIL @ A2 )
       => ( ( coinductive_ltl @ A @ ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ A2 ) )
          = ( coinductive_LNil @ A ) ) )
      & ( ~ ( IS_LNIL @ A2 )
       => ( ( coinductive_ltl @ A @ ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ A2 ) )
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ A2 ) ) ) ) ) )).

% ltl_unfold_llist
thf(fact_11_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F2: ( B > A ),G2: ( C > B ),X2: C] :
            ( F2 @ ( G2 @ X2 ) ) ) ) )).

% comp_apply
thf(fact_12_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
      = ( ( A2 = A5 )
        & ( B2 = B5 ) ) ) )).

% old.prod.inject
thf(fact_13_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y2 ) ) ) )).

% prod.inject
thf(fact_14_mem__case__prodI2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ B ),Z2: C,C2: ( A > B > ( set @ C ) )] :
      ( ! [A3: A,B3: B] :
          ( ( P
            = ( product_Pair @ A @ B @ A3 @ B3 ) )
         => ( member @ C @ Z2 @ ( C2 @ A3 @ B3 ) ) )
     => ( member @ C @ Z2 @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P ) ) ) )).

% mem_case_prodI2
thf(fact_15_mem__case__prodI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Z2: A,C2: ( B > C > ( set @ A ) ),A2: B,B2: C] :
      ( ( member @ A @ Z2 @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) )).

% mem_case_prodI
thf(fact_16_case__prodI2_H,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P: ( product_prod @ A @ B ),C2: ( A > B > C > $o ),X: C] :
      ( ! [A3: A,B3: B] :
          ( ( ( product_Pair @ A @ B @ A3 @ B3 )
            = P )
         => ( C2 @ A3 @ B3 @ X ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P @ X ) ) )).

% case_prodI2'
thf(fact_17_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: ( B > C > ( set @ A ) ),P: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( P
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( member @ A @ Z2 @ ( C2 @ X3 @ Y3 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_18_case__prodE_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( A > B > C > $o ),P: ( product_prod @ A @ B ),Z2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P @ Z2 )
     => ~ ( ! [X3: A,Y3: B] :
              ( ( P
                = ( product_Pair @ A @ B @ X3 @ Y3 ) )
             => ~ ( C2 @ X3 @ Y3 @ Z2 ) ) ) ) )).

% case_prodE'
thf(fact_19_case__prodD_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R: ( A > B > C > $o ),A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R @ A2 @ B2 @ C2 ) ) )).

% case_prodD'
thf(fact_20_map__prod__def,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( product_map_prod @ A @ C @ B @ D )
      = ( ^ [F2: ( A > C ),G2: ( B > D )] :
            ( product_case_prod @ A @ B @ ( product_prod @ C @ D )
            @ ^ [X2: A,Y: B] :
                ( product_Pair @ C @ D @ ( F2 @ X2 ) @ ( G2 @ Y ) ) ) ) ) )).

% map_prod_def
thf(fact_21_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A3: A,B3: B] :
          ( P2 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ( P2 @ Prod ) ) )).

% old.prod.inducts
thf(fact_22_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y4: ( product_prod @ A @ B )] :
      ~ ( ! [A3: A,B3: B] :
            ( Y4
           != ( product_Pair @ A @ B @ A3 @ B3 ) ) ) )).

% old.prod.exhaust
thf(fact_23_prod__induct7,axiom,(
    ! [G3: $tType,F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) ) )] :
      ( ! [A3: A,B3: B,C3: C,D2: D,E2: E,F4: F3,G4: G3] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) @ B3 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G3 ) @ E2 @ ( product_Pair @ F3 @ G3 @ F4 @ G4 ) ) ) ) ) ) )
     => ( P2 @ X ) ) )).

% prod_induct7
thf(fact_24_prod__induct6,axiom,(
    ! [F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ( ! [A3: A,B3: B,C3: C,D2: D,E2: E,F4: F3] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B3 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) )
     => ( P2 @ X ) ) )).

% prod_induct6
thf(fact_25_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A3: A,B3: B,C3: C,D2: D,E2: E] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B3 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P2 @ X ) ) )).

% prod_induct5
thf(fact_26_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A3: A,B3: B,C3: C,D2: D] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B3 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P2 @ X ) ) )).

% prod_induct4
thf(fact_27_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A3: A,B3: B,C3: C] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A3 @ ( product_Pair @ B @ C @ B3 @ C3 ) ) )
     => ( P2 @ X ) ) )).

% prod_induct3
thf(fact_28_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,G3: $tType,Y4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) ) )] :
      ~ ( ! [A3: A,B3: B,C3: C,D2: D,E2: E,F4: F3,G4: G3] :
            ( Y4
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) ) @ B3 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G3 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G3 ) @ E2 @ ( product_Pair @ F3 @ G3 @ F4 @ G4 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_29_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,Y4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ~ ( ! [A3: A,B3: B,C3: C,D2: D,E2: E,F4: F3] :
            ( Y4
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B3 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_30_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A3: A,B3: B,C3: C,D2: D,E2: E] :
            ( Y4
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B3 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_31_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y4: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A3: A,B3: B,C3: C,D2: D] :
            ( Y4
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B3 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_32_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y4: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A3: A,B3: B,C3: C] :
            ( Y4
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A3 @ ( product_Pair @ B @ C @ B3 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_33_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B5 ) ) ) )).

% Pair_inject
thf(fact_34_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),P: ( product_prod @ A @ B )] :
      ( ! [A3: A,B3: B] :
          ( P2 @ ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ( P2 @ P ) ) )).

% prod_cases
thf(fact_35_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P: ( product_prod @ A @ B )] :
    ? [X3: A,Y3: B] :
      ( P
      = ( product_Pair @ A @ B @ X3 @ Y3 ) ) )).

% surj_pair
thf(fact_36_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C2 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_37_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D3: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D3 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C2 @ ( D3 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_38_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D3: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D3 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ ( D3 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_39_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_40_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F2: ( B > C ),G2: ( A > B ),X2: A] :
            ( F2 @ ( G2 @ X2 ) ) ) ) )).

% comp_def
thf(fact_41_prod_Ocase__distrib,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: ( C > D ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X12: A,X23: B] :
            ( H @ ( F @ X12 @ X23 ) )
        @ Prod ) ) )).

% prod.case_distrib
thf(fact_42_prod_Odisc__eq__case,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu: A,Uv: B] : $true
      @ Prod ) )).

% prod.disc_eq_case
thf(fact_43_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F @ X1 @ X22 ) ) )).

% old.prod.case
thf(fact_44_snd__conv,axiom,(
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) )).

% snd_conv
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A6 ) )
      = A6 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P2 @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_snd__eqD,axiom,(
    ! [B: $tType,A: $tType,X: B,Y4: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y4 ) )
        = A2 )
     => ( Y4 = A2 ) ) )).

% snd_eqD
thf(fact_50_ltl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltl_simps(1)
thf(fact_51_map__prod_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: ( C > E ),G: ( D > F3 ),H: ( A > C ),I: ( B > D ),Prod: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F3 @ F @ G @ ( product_map_prod @ A @ C @ B @ D @ H @ I @ Prod ) )
      = ( product_map_prod @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ F @ H ) @ ( comp @ D @ F3 @ B @ G @ I ) @ Prod ) ) )).

% map_prod.compositionality
thf(fact_52_map__prod__compose,axiom,(
    ! [D: $tType,C: $tType,A: $tType,E: $tType,F3: $tType,B: $tType,F1: ( E > C ),F22: ( A > E ),G1: ( F3 > D ),G22: ( B > F3 )] :
      ( ( product_map_prod @ A @ C @ B @ D @ ( comp @ E @ C @ A @ F1 @ F22 ) @ ( comp @ F3 @ D @ B @ G1 @ G22 ) )
      = ( comp @ ( product_prod @ E @ F3 ) @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ E @ C @ F3 @ D @ F1 @ G1 ) @ ( product_map_prod @ A @ E @ B @ F3 @ F22 @ G22 ) ) ) )).

% map_prod_compose
thf(fact_53_map__prod_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E: $tType,F3: $tType,D: $tType,B: $tType,F: ( C > E ),G: ( D > F3 ),H: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ ( product_prod @ E @ F3 ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ E @ D @ F3 @ F @ G ) @ ( product_map_prod @ A @ C @ B @ D @ H @ I ) )
      = ( product_map_prod @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ F @ H ) @ ( comp @ D @ F3 @ B @ G @ I ) ) ) )).

% map_prod.comp
thf(fact_54_unfold__llist__ltl__unroll,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B2: B] :
      ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B2 ) )
      = ( coindu1441602521_llist @ B @ A @ ( comp @ B @ $o @ B @ IS_LNIL @ LTL ) @ ( comp @ B @ A @ B @ LHD @ LTL ) @ LTL @ B2 ) ) )).

% unfold_llist_ltl_unroll
thf(fact_55_unfold__llist_Octr_I1_J,axiom,(
    ! [A: $tType,B: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G222: ( A > A )] :
      ( ( P @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P @ G21 @ G222 @ A2 )
        = ( coinductive_LNil @ B ) ) ) )).

% unfold_llist.ctr(1)
thf(fact_56_unfold__llist_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G222: ( A > A )] :
      ( ~ ( P @ A2 )
     => ( ( coinductive_ltl @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G222 @ A2 ) )
        = ( coindu1441602521_llist @ A @ B @ P @ G21 @ G222 @ ( G222 @ A2 ) ) ) ) )).

% unfold_llist.simps(4)
thf(fact_57_unfold__llist_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),A2: A,G21: ( A > B ),G222: ( A > A )] :
      ( ~ ( P @ A2 )
     => ( ( coinductive_lhd @ B @ ( coindu1441602521_llist @ A @ B @ P @ G21 @ G222 @ A2 ) )
        = ( G21 @ A2 ) ) ) )).

% unfold_llist.simps(3)
thf(fact_58_cond__case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),G: ( ( product_prod @ A @ B ) > C )] :
      ( ! [X3: A,Y3: B] :
          ( ( F @ X3 @ Y3 )
          = ( G @ ( product_Pair @ A @ B @ X3 @ Y3 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F )
        = G ) ) )).

% cond_case_prod_eta
thf(fact_59_case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X2: A,Y: B] :
            ( F @ ( product_Pair @ A @ B @ X2 @ Y ) ) )
      = F ) )).

% case_prod_eta
thf(fact_60_case__prodE2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Q: ( A > $o ),P2: ( B > C > A ),Z2: ( product_prod @ B @ C )] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P2 @ Z2 ) )
     => ~ ( ! [X3: B,Y3: C] :
              ( ( Z2
                = ( product_Pair @ B @ C @ X3 @ Y3 ) )
             => ~ ( Q @ ( P2 @ X3 @ Y3 ) ) ) ) ) )).

% case_prodE2
thf(fact_61_case__prodE,axiom,(
    ! [A: $tType,B: $tType,C2: ( A > B > $o ),P: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P )
     => ~ ( ! [X3: A,Y3: B] :
              ( ( P
                = ( product_Pair @ A @ B @ X3 @ Y3 ) )
             => ~ ( C2 @ X3 @ Y3 ) ) ) ) )).

% case_prodE
thf(fact_62_case__prodD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F @ A2 @ B2 ) ) )).

% case_prodD
thf(fact_63_snd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_snd @ A @ B )
      = ( product_case_prod @ A @ B @ B
        @ ^ [X12: A,X23: B] : X23 ) ) )).

% snd_def
thf(fact_64_case__prod__o__map__prod,axiom,(
    ! [B: $tType,D: $tType,C: $tType,E: $tType,A: $tType,F: ( D > E > C ),G1: ( A > D ),G22: ( B > E )] :
      ( ( comp @ ( product_prod @ D @ E ) @ C @ ( product_prod @ A @ B ) @ ( product_case_prod @ D @ E @ C @ F ) @ ( product_map_prod @ A @ D @ B @ E @ G1 @ G22 ) )
      = ( product_case_prod @ A @ B @ C
        @ ^ [L: A,R2: B] :
            ( F @ ( G1 @ L ) @ ( G22 @ R2 ) ) ) ) )).

% case_prod_o_map_prod
thf(fact_65_snd__diag__snd,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] :
              ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) )).

% snd_diag_snd
thf(fact_66_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_67_case__prod__map__prod,axiom,(
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,H: ( B > C > A ),F: ( D > B ),G: ( E > C ),X: ( product_prod @ D @ E )] :
      ( ( product_case_prod @ B @ C @ A @ H @ ( product_map_prod @ D @ B @ E @ C @ F @ G @ X ) )
      = ( product_case_prod @ D @ E @ A
        @ ^ [L: D,R2: E] :
            ( H @ ( F @ L ) @ ( G @ R2 ) )
        @ X ) ) )).

% case_prod_map_prod
thf(fact_68_inf__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( inf_inf @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% inf_apply
thf(fact_69_inf_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) )).

% inf.idem
thf(fact_70_inf__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) )).

% inf_idem
thf(fact_71_inf_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B2 ) )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.left_idem
thf(fact_72_inf__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y4 ) )
          = ( inf_inf @ A @ X @ Y4 ) ) ) )).

% inf_left_idem
thf(fact_73_inf_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.right_idem
thf(fact_74_inf__right__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y4 ) @ Y4 )
          = ( inf_inf @ A @ X @ Y4 ) ) ) )).

% inf_right_idem
thf(fact_75_inf__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y4 @ Z2 ) )
          = ( inf_inf @ A @ Y4 @ ( inf_inf @ A @ X @ Z2 ) ) ) ) )).

% inf_left_commute
thf(fact_76_inf_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A2 @ C2 ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) )).

% inf.left_commute
thf(fact_77_inf__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y: A] :
              ( inf_inf @ A @ Y @ X2 ) ) ) ) )).

% inf_commute
thf(fact_78_inf_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [A4: A,B4: A] :
              ( inf_inf @ A @ B4 @ A4 ) ) ) ) )).

% inf.commute
thf(fact_79_inf__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y4 ) @ Z2 )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y4 @ Z2 ) ) ) ) )).

% inf_assoc
thf(fact_80_inf_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) )).

% inf.assoc
thf(fact_81_inf__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( inf_inf @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% inf_fun_def
thf(fact_82_inf__sup__aci_I1_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y: A] :
              ( inf_inf @ A @ Y @ X2 ) ) ) ) )).

% inf_sup_aci(1)
thf(fact_83_inf__sup__aci_I2_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A,Z2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y4 ) @ Z2 )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y4 @ Z2 ) ) ) ) )).

% inf_sup_aci(2)
thf(fact_84_inf__sup__aci_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A,Z2: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y4 @ Z2 ) )
          = ( inf_inf @ A @ Y4 @ ( inf_inf @ A @ X @ Z2 ) ) ) ) )).

% inf_sup_aci(3)
thf(fact_85_inf__sup__aci_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y4: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y4 ) )
          = ( inf_inf @ A @ X @ Y4 ) ) ) )).

% inf_sup_aci(4)
thf(fact_86_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L2: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L2 )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L2 @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_87_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R3: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R3 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R3 ) ) ) )).

% rewriteR_comp_comp
thf(fact_88_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L22: ( A > D ),H: ( E > A ),R3: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L22 ) )
     => ( ( ( comp @ A @ D @ E @ L22 @ H )
          = R3 )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R3 ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_89_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R22: ( A > D ),F: ( B > E ),L2: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L2 )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L2 @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_90_case__prod__Pair__iden,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P )
      = P ) )).

% case_prod_Pair_iden
thf(fact_91_case__prod__app,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F2: ( B > C > D > A ),X2: ( product_prod @ B @ C ),Y: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L: B,R2: C] :
                ( F2 @ L @ R2 @ Y )
            @ X2 ) ) ) )).

% case_prod_app
thf(fact_92_prod_Omap__comp,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: ( C > E ),G22: ( D > F3 ),F1: ( A > C ),F22: ( B > D ),V: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F3 @ G1 @ G22 @ ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( product_map_prod @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F3 @ B @ G22 @ F22 ) @ V ) ) )).

% prod.map_comp
thf(fact_93_sndI,axiom,(
    ! [A: $tType,B: $tType,X: ( product_prod @ A @ B ),Y4: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y4 @ Z2 ) )
     => ( ( product_snd @ A @ B @ X )
        = Z2 ) ) )).

% sndI
thf(fact_94_eq__snd__iff,axiom,(
    ! [A: $tType,B: $tType,B2: A,P: ( product_prod @ B @ A )] :
      ( ( B2
        = ( product_snd @ B @ A @ P ) )
      = ( ? [A4: B] :
            ( P
            = ( product_Pair @ B @ A @ A4 @ B2 ) ) ) ) )).

% eq_snd_iff
thf(fact_95_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F: ( A > B > C ),G: ( A > B > C ),P: ( product_prod @ A @ B )] :
      ( ! [X3: A,Y3: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y3 )
            = Q2 )
         => ( ( F @ X3 @ Y3 )
            = ( G @ X3 @ Y3 ) ) )
     => ( ( P = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F @ P )
          = ( product_case_prod @ A @ B @ C @ G @ Q2 ) ) ) ) )).

% split_cong
thf(fact_96_snd__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ F @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_apsnd
thf(fact_97_map__prod__o__convol,axiom,(
    ! [D: $tType,B: $tType,C: $tType,E: $tType,A: $tType,H1: ( D > B ),H2: ( E > C ),F: ( A > D ),G: ( A > E )] :
      ( ( comp @ ( product_prod @ D @ E ) @ ( product_prod @ B @ C ) @ A @ ( product_map_prod @ D @ B @ E @ C @ H1 @ H2 ) @ ( bNF_convol @ A @ D @ E @ F @ G ) )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ H1 @ F ) @ ( comp @ E @ C @ A @ H2 @ G ) ) ) )).

% map_prod_o_convol
thf(fact_98_apsnd__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),X: A,Y4: C] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_Pair @ A @ C @ X @ Y4 ) )
      = ( product_Pair @ A @ B @ X @ ( F @ Y4 ) ) ) )).

% apsnd_conv
thf(fact_99_apsnd__eq__conv,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),X: ( product_prod @ A @ C ),G: ( C > B )] :
      ( ( ( product_apsnd @ C @ B @ A @ F @ X )
        = ( product_apsnd @ C @ B @ A @ G @ X ) )
      = ( ( F @ ( product_snd @ A @ C @ X ) )
        = ( G @ ( product_snd @ A @ C @ X ) ) ) ) )).

% apsnd_eq_conv
thf(fact_100_snd__apsnd,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),X: ( product_prod @ B @ C )] :
      ( ( product_snd @ B @ A @ ( product_apsnd @ C @ A @ B @ F @ X ) )
      = ( F @ ( product_snd @ B @ C @ X ) ) ) )).

% snd_apsnd
thf(fact_101_convol__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_convol @ A @ B @ C )
      = ( ^ [F2: ( A > B ),G2: ( A > C ),A4: A] :
            ( product_Pair @ B @ C @ ( F2 @ A4 ) @ ( G2 @ A4 ) ) ) ) )).

% convol_def
thf(fact_102_apsnd__compose,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: ( C > B ),G: ( D > C ),X: ( product_prod @ A @ D )] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apsnd @ D @ C @ A @ G @ X ) )
      = ( product_apsnd @ D @ B @ A @ ( comp @ C @ B @ D @ F @ G ) @ X ) ) )).

% apsnd_compose
thf(fact_103_snd__convol_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > B ),G: ( C > A ),X: C] :
      ( ( product_snd @ B @ A @ ( bNF_convol @ C @ B @ A @ F @ G @ X ) )
      = ( G @ X ) ) )).

% snd_convol'
thf(fact_104_snd__convol,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C ),G: ( A > B )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ A @ ( product_snd @ C @ B ) @ ( bNF_convol @ A @ C @ B @ F @ G ) )
      = G ) )).

% snd_convol
thf(fact_105_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_106_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_107_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G: ( C > B ),X: C,F5: ( D > A ),G5: ( E > D ),X4: E] :
      ( ( ( F @ ( G @ X ) )
        = ( F5 @ ( G5 @ X4 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ E @ F5 @ G5 @ X4 ) ) ) )).

% comp_cong
thf(fact_108_convol__o,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType,F: ( D > B ),G: ( D > C ),H: ( A > D )] :
      ( ( comp @ D @ ( product_prod @ B @ C ) @ A @ ( bNF_convol @ D @ B @ C @ F @ G ) @ H )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ F @ H ) @ ( comp @ D @ C @ A @ G @ H ) ) ) )).

% convol_o
thf(fact_109_fun_Omap__ident,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D
        @ ^ [X2: A] : X2
        @ T2 )
      = T2 ) )).

% fun.map_ident
thf(fact_110_prod_Omap__ident,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [X2: B] : X2
        @ T2 )
      = T2 ) )).

% prod.map_ident
thf(fact_111_snd__sndOp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: ( B > C > $o ),Q: ( C > A > $o )] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ C @ A ) @ A @ ( product_prod @ B @ A ) @ ( product_snd @ C @ A ) @ ( bNF_sndOp @ B @ C @ A @ P2 @ Q ) ) ) )).

% snd_sndOp
thf(fact_112_conj__comp__iff,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),Q: ( B > $o ),G: ( A > B )] :
      ( ( comp @ B @ $o @ A
        @ ^ [X2: B] :
            ( ( P2 @ X2 )
            & ( Q @ X2 ) )
        @ G )
      = ( ^ [X2: A] :
            ( ( comp @ B @ $o @ A @ P2 @ G @ X2 )
            & ( comp @ B @ $o @ A @ Q @ G @ X2 ) ) ) ) )).

% conj_comp_iff
thf(fact_113_snd__diag__fst,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] :
              ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) )).

% snd_diag_fst
thf(fact_114_fst__diag__snd,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X2: B] :
              ( product_Pair @ B @ B @ X2 @ X2 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) )).

% fst_diag_snd
thf(fact_115_K__record__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,C2: B,F: ( A > C )] :
      ( ( comp @ C @ B @ A
        @ ^ [X2: C] : C2
        @ F )
      = ( ^ [X2: A] : C2 ) ) )).

% K_record_comp
thf(fact_116_fst__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( C > A ),G: ( D > B ),X: ( product_prod @ C @ D )] :
      ( ( product_fst @ A @ B @ ( product_map_prod @ C @ A @ D @ B @ F @ G @ X ) )
      = ( F @ ( product_fst @ C @ D @ X ) ) ) )).

% fst_map_prod
thf(fact_117_fst__apsnd,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),X: ( product_prod @ A @ C )] :
      ( ( product_fst @ A @ B @ ( product_apsnd @ C @ B @ A @ F @ X ) )
      = ( product_fst @ A @ C @ X ) ) )).

% fst_apsnd
thf(fact_118_prod_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) )).

% prod.collapse
thf(fact_119_fst__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( product_fst @ A @ B ) ) )).

% fst_comp_apsnd
thf(fact_120_fst__comp__map__prod,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: ( A > C ),G: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_map_prod
thf(fact_121_fstI,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B ),Y4: A,Z2: B] :
      ( ( X
        = ( product_Pair @ A @ B @ Y4 @ Z2 ) )
     => ( ( product_fst @ A @ B @ X )
        = Y4 ) ) )).

% fstI
thf(fact_122_eq__fst__iff,axiom,(
    ! [A: $tType,B: $tType,A2: A,P: ( product_prod @ A @ B )] :
      ( ( A2
        = ( product_fst @ A @ B @ P ) )
      = ( ? [B4: B] :
            ( P
            = ( product_Pair @ A @ B @ A2 @ B4 ) ) ) ) )).

% eq_fst_iff
thf(fact_123_fst__conv,axiom,(
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) )).

% fst_conv
thf(fact_124_fst__eqD,axiom,(
    ! [B: $tType,A: $tType,X: A,Y4: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X @ Y4 ) )
        = A2 )
     => ( X = A2 ) ) )).

% fst_eqD
thf(fact_125_prod__eq__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [Y5: ( product_prod @ A @ B ),Z3: ( product_prod @ A @ B )] : ( Y5 = Z3 ) )
      = ( ^ [S: ( product_prod @ A @ B ),T3: ( product_prod @ A @ B )] :
            ( ( ( product_fst @ A @ B @ S )
              = ( product_fst @ A @ B @ T3 ) )
            & ( ( product_snd @ A @ B @ S )
              = ( product_snd @ A @ B @ T3 ) ) ) ) ) )).

% prod_eq_iff
thf(fact_126_prod_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B ),Prod2: ( product_prod @ A @ B )] :
      ( ( ( ( product_fst @ A @ B @ Prod )
          = ( product_fst @ A @ B @ Prod2 ) )
        & ( ( product_snd @ A @ B @ Prod )
          = ( product_snd @ A @ B @ Prod2 ) ) )
     => ( Prod = Prod2 ) ) )).

% prod.expand
thf(fact_127_prod__eqI,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ),Q2: ( product_prod @ A @ B )] :
      ( ( ( product_fst @ A @ B @ P )
        = ( product_fst @ A @ B @ Q2 ) )
     => ( ( ( product_snd @ A @ B @ P )
          = ( product_snd @ A @ B @ Q2 ) )
       => ( P = Q2 ) ) ) )).

% prod_eqI
thf(fact_128_fst__convol_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > A ),G: ( C > B ),X: C] :
      ( ( product_fst @ A @ B @ ( bNF_convol @ C @ A @ B @ F @ G @ X ) )
      = ( F @ X ) ) )).

% fst_convol'
thf(fact_129_fst__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( product_case_prod @ A @ B @ A
        @ ^ [X12: A,X23: B] : X12 ) ) )).

% fst_def
thf(fact_130_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o ),X: A,Y4: B,A2: ( product_prod @ A @ B )] :
      ( ( P2 @ X @ Y4 )
     => ( ( A2
          = ( product_Pair @ A @ B @ X @ Y4 ) )
       => ( P2 @ ( product_fst @ A @ B @ A2 ) @ ( product_snd @ A @ B @ A2 ) ) ) ) )).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_131_prod_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) )).

% prod.exhaust_sel
thf(fact_132_surjective__pairing,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) )).

% surjective_pairing
thf(fact_133_case__prod__beta,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ A )
      = ( ^ [F2: ( B > C > A ),P3: ( product_prod @ B @ C )] :
            ( F2 @ ( product_fst @ B @ C @ P3 ) @ ( product_snd @ B @ C @ P3 ) ) ) ) )).

% case_prod_beta
thf(fact_134_prod_Ocase__eq__if,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F2: ( A > B > C ),Prod3: ( product_prod @ A @ B )] :
            ( F2 @ ( product_fst @ A @ B @ Prod3 ) @ ( product_snd @ A @ B @ Prod3 ) ) ) ) )).

% prod.case_eq_if
thf(fact_135_Product__Type_OCollect__case__prodD,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B ),A6: ( A > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ X @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A6 ) ) )
     => ( A6 @ ( product_fst @ A @ B @ X ) @ ( product_snd @ A @ B @ X ) ) ) )).

% Product_Type.Collect_case_prodD
thf(fact_136_split__comp__eq,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,F: ( A > B > C ),G: ( D > A )] :
      ( ( ^ [U: ( product_prod @ D @ B )] :
            ( F @ ( G @ ( product_fst @ D @ B @ U ) ) @ ( product_snd @ D @ B @ U ) ) )
      = ( product_case_prod @ D @ B @ C
        @ ^ [X2: D] :
            ( F @ ( G @ X2 ) ) ) ) )).

% split_comp_eq
thf(fact_137_case__prod__beta_H,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F2: ( A > B > C ),X2: ( product_prod @ A @ B )] :
            ( F2 @ ( product_fst @ A @ B @ X2 ) @ ( product_snd @ A @ B @ X2 ) ) ) ) )).

% case_prod_beta'
thf(fact_138_case__prod__unfold,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [C4: ( A > B > C ),P3: ( product_prod @ A @ B )] :
            ( C4 @ ( product_fst @ A @ B @ P3 ) @ ( product_snd @ A @ B @ P3 ) ) ) ) )).

% case_prod_unfold
thf(fact_139_case__prod__comp,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F: ( D > C > A ),G: ( B > D ),X: ( product_prod @ B @ C )] :
      ( ( product_case_prod @ B @ C @ A @ ( comp @ D @ ( C > A ) @ B @ F @ G ) @ X )
      = ( F @ ( G @ ( product_fst @ B @ C @ X ) ) @ ( product_snd @ B @ C @ X ) ) ) )).

% case_prod_comp
thf(fact_140_fst__convol,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( A > C )] :
      ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ ( bNF_convol @ A @ B @ C @ F @ G ) )
      = F ) )).

% fst_convol
thf(fact_141_prod_Osplit__sel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( C > $o ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P2 @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P2 @ ( F @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) )).

% prod.split_sel
thf(fact_142_prod_Osplit__sel__asm,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( C > $o ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P2 @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P2 @ ( F @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) )).

% prod.split_sel_asm
thf(fact_143_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X: C,N: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X ) )
        = ( N @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_144_convol__expand__snd_H,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > ( product_prod @ B @ C ) ),G: ( A > B ),H: ( A > C )] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F )
        = G )
     => ( ( H
          = ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) )
        = ( ( bNF_convol @ A @ B @ C @ G @ H )
          = F ) ) ) )).

% convol_expand_snd'
thf(fact_145_convol__expand__snd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > ( product_prod @ B @ C ) ),G: ( A > B )] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F )
        = G )
     => ( ( bNF_convol @ A @ B @ C @ G @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) )
        = F ) ) )).

% convol_expand_snd
thf(fact_146_fst__diag__fst,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X2: A] :
              ( product_Pair @ A @ A @ X2 @ X2 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) )).

% fst_diag_fst
thf(fact_147_fst__snd__flip,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X2: A,Y: B] :
              ( product_Pair @ B @ A @ Y @ X2 ) ) ) ) )).

% fst_snd_flip
thf(fact_148_snd__fst__flip,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X2: B,Y: A] :
              ( product_Pair @ A @ B @ Y @ X2 ) ) ) ) )).

% snd_fst_flip
thf(fact_149_exE__realizer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,P2: ( A > B > $o ),P: ( product_prod @ B @ A ),Q: ( C > $o ),F: ( B > A > C )] :
      ( ( P2 @ ( product_snd @ B @ A @ P ) @ ( product_fst @ B @ A @ P ) )
     => ( ! [X3: B,Y3: A] :
            ( ( P2 @ Y3 @ X3 )
           => ( Q @ ( F @ X3 @ Y3 ) ) )
       => ( Q @ ( product_case_prod @ B @ A @ C @ F @ P ) ) ) ) )).

% exE_realizer
thf(fact_150_sndOp__def,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( bNF_sndOp @ C @ A @ B )
      = ( ^ [P4: ( C > A > $o ),Q3: ( A > B > $o ),Ac: ( product_prod @ C @ B )] :
            ( product_Pair @ A @ B @ ( bNF_pick_middlep @ C @ A @ B @ P4 @ Q3 @ ( product_fst @ C @ B @ Ac ) @ ( product_snd @ C @ B @ Ac ) ) @ ( product_snd @ C @ B @ Ac ) ) ) ) )).

% sndOp_def
thf(fact_151_exI__realizer,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o ),Y4: A,X: B] :
      ( ( P2 @ Y4 @ X )
     => ( P2 @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X @ Y4 ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X @ Y4 ) ) ) ) )).

% exI_realizer
thf(fact_152_conjI__realizer,axiom,(
    ! [A: $tType,B: $tType,P2: ( A > $o ),P: A,Q: ( B > $o ),Q2: B] :
      ( ( P2 @ P )
     => ( ( Q @ Q2 )
       => ( ( P2 @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P @ Q2 ) ) )
          & ( Q @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P @ Q2 ) ) ) ) ) ) )).

% conjI_realizer
thf(fact_153_exE__realizer_H,axiom,(
    ! [A: $tType,B: $tType,P2: ( A > B > $o ),P: ( product_prod @ B @ A )] :
      ( ( P2 @ ( product_snd @ B @ A @ P ) @ ( product_fst @ B @ A @ P ) )
     => ~ ( ! [X3: B,Y3: A] :
              ~ ( P2 @ Y3 @ X3 ) ) ) )).

% exE_realizer'
thf(fact_154_fstOp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_fstOp @ A @ B @ C )
      = ( ^ [P4: ( A > B > $o ),Q3: ( B > C > $o ),Ac: ( product_prod @ A @ C )] :
            ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Ac ) @ ( bNF_pick_middlep @ A @ B @ C @ P4 @ Q3 @ ( product_fst @ A @ C @ Ac ) @ ( product_snd @ A @ C @ Ac ) ) ) ) ) )).

% fstOp_def
thf(fact_155_apfst__apsnd,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F: ( C > A ),G: ( D > B ),X: ( product_prod @ C @ D )] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_apsnd @ D @ B @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( F @ ( product_fst @ C @ D @ X ) ) @ ( G @ ( product_snd @ C @ D @ X ) ) ) ) )).

% apfst_apsnd
thf(fact_156_apsnd__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: ( C > B ),G: ( D > A ),X: ( product_prod @ D @ C )] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apfst @ D @ A @ C @ G @ X ) )
      = ( product_Pair @ A @ B @ ( G @ ( product_fst @ D @ C @ X ) ) @ ( F @ ( product_snd @ D @ C @ X ) ) ) ) )).

% apsnd_apfst
thf(fact_157_apfst__conv,axiom,(
    ! [C: $tType,A: $tType,B: $tType,F: ( C > A ),X: C,Y4: B] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_Pair @ C @ B @ X @ Y4 ) )
      = ( product_Pair @ A @ B @ ( F @ X ) @ Y4 ) ) )).

% apfst_conv
thf(fact_158_snd__apfst,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > B ),X: ( product_prod @ C @ A )] :
      ( ( product_snd @ B @ A @ ( product_apfst @ C @ B @ A @ F @ X ) )
      = ( product_snd @ C @ A @ X ) ) )).

% snd_apfst
thf(fact_159_fst__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > A ),X: ( product_prod @ C @ B )] :
      ( ( product_fst @ A @ B @ ( product_apfst @ C @ A @ B @ F @ X ) )
      = ( F @ ( product_fst @ C @ B @ X ) ) ) )).

% fst_apfst
thf(fact_160_apfst__eq__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > A ),X: ( product_prod @ C @ B ),G: ( C > A )] :
      ( ( ( product_apfst @ C @ A @ B @ F @ X )
        = ( product_apfst @ C @ A @ B @ G @ X ) )
      = ( ( F @ ( product_fst @ C @ B @ X ) )
        = ( G @ ( product_fst @ C @ B @ X ) ) ) ) )).

% apfst_eq_conv
thf(fact_161_snd__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( product_snd @ A @ B ) ) )).

% snd_comp_apfst
thf(fact_162_fst__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_apfst
thf(fact_163_apfst__compose,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G: ( D > C ),X: ( product_prod @ D @ B )] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_apfst @ D @ C @ B @ G @ X ) )
      = ( product_apfst @ D @ A @ B @ ( comp @ C @ A @ D @ F @ G ) @ X ) ) )).

% apfst_compose
thf(fact_164_apsnd__apfst__commute,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: ( C > B ),G: ( D > A ),P: ( product_prod @ D @ C )] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apfst @ D @ A @ C @ G @ P ) )
      = ( product_apfst @ D @ A @ B @ G @ ( product_apsnd @ C @ B @ D @ F @ P ) ) ) )).

% apsnd_apfst_commute
thf(fact_165_fst__fstOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P2: ( A > C > $o ),Q: ( C > B > $o )] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q ) ) ) )).

% fst_fstOp
thf(fact_166_apfst__convE,axiom,(
    ! [C: $tType,A: $tType,B: $tType,Q2: ( product_prod @ A @ B ),F: ( C > A ),P: ( product_prod @ C @ B )] :
      ( ( Q2
        = ( product_apfst @ C @ A @ B @ F @ P ) )
     => ~ ( ! [X3: C,Y3: B] :
              ( ( P
                = ( product_Pair @ C @ B @ X3 @ Y3 ) )
             => ( Q2
               != ( product_Pair @ A @ B @ ( F @ X3 ) @ Y3 ) ) ) ) ) )).

% apfst_convE
thf(fact_167_scomp__unfold,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F2: ( A > ( product_prod @ B @ C ) ),G2: ( B > C > D ),X2: A] :
            ( G2 @ ( product_fst @ B @ C @ ( F2 @ X2 ) ) @ ( product_snd @ B @ C @ ( F2 @ X2 ) ) ) ) ) )).

% scomp_unfold
thf(fact_168_Collect__case__prod__Grp__eqD,axiom,(
    ! [B: $tType,A: $tType,Z2: ( product_prod @ A @ B ),A6: ( set @ A ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Z2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A6 @ F ) ) ) )
     => ( ( comp @ A @ B @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) @ Z2 )
        = ( product_snd @ A @ B @ Z2 ) ) ) )).

% Collect_case_prod_Grp_eqD
thf(fact_169_scomp__apply,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_scomp @ B @ C @ D @ A )
      = ( ^ [F2: ( B > ( product_prod @ C @ D ) ),G2: ( C > D > A ),X2: B] :
            ( product_case_prod @ C @ D @ A @ G2 @ ( F2 @ X2 ) ) ) ) )).

% scomp_apply
thf(fact_170_scomp__scomp,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F3: $tType,E: $tType,F: ( A > ( product_prod @ E @ F3 ) ),G: ( E > F3 > ( product_prod @ C @ D ) ),H: ( C > D > B )] :
      ( ( product_scomp @ A @ C @ D @ B @ ( product_scomp @ A @ E @ F3 @ ( product_prod @ C @ D ) @ F @ G ) @ H )
      = ( product_scomp @ A @ E @ F3 @ B @ F
        @ ^ [X2: E] :
            ( product_scomp @ F3 @ C @ D @ B @ ( G @ X2 ) @ H ) ) ) )).

% scomp_scomp
thf(fact_171_Grp__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Grp @ A @ B )
      = ( ^ [A7: ( set @ A ),F2: ( A > B ),A4: A,B4: B] :
            ( ( B4
              = ( F2 @ A4 ) )
            & ( member @ A @ A4 @ A7 ) ) ) ) )).

% Grp_def
thf(fact_172_GrpI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),X: B,Y4: A,A6: ( set @ B )] :
      ( ( ( F @ X )
        = Y4 )
     => ( ( member @ B @ X @ A6 )
       => ( bNF_Grp @ B @ A @ A6 @ F @ X @ Y4 ) ) ) )).

% GrpI
thf(fact_173_GrpE,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),F: ( A > B ),X: A,Y4: B] :
      ( ( bNF_Grp @ A @ B @ A6 @ F @ X @ Y4 )
     => ~ ( ( ( F @ X )
            = Y4 )
         => ~ ( member @ A @ X @ A6 ) ) ) )).

% GrpE
thf(fact_174_scomp__Pair,axiom,(
    ! [C: $tType,B: $tType,A: $tType,X: ( A > ( product_prod @ B @ C ) )] :
      ( ( product_scomp @ A @ B @ C @ ( product_prod @ B @ C ) @ X @ ( product_Pair @ B @ C ) )
      = X ) )).

% scomp_Pair
thf(fact_175_Pair__scomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X: C,F: ( C > A > B )] :
      ( ( product_scomp @ A @ C @ A @ B @ ( product_Pair @ C @ A @ X ) @ F )
      = ( F @ X ) ) )).

% Pair_scomp
thf(fact_176_scomp__def,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F2: ( A > ( product_prod @ B @ C ) ),G2: ( B > C > D ),X2: A] :
            ( product_case_prod @ B @ C @ D @ G2 @ ( F2 @ X2 ) ) ) ) )).

% scomp_def
thf(fact_177_Collect__case__prod__Grp__in,axiom,(
    ! [B: $tType,A: $tType,Z2: ( product_prod @ A @ B ),A6: ( set @ A ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Z2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A6 @ F ) ) ) )
     => ( member @ A @ ( product_fst @ A @ B @ Z2 ) @ A6 ) ) )).

% Collect_case_prod_Grp_in
thf(fact_178_prod_Oswap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_swap @ A @ B )
      = ( ^ [P3: ( product_prod @ A @ B )] :
            ( product_Pair @ B @ A @ ( product_snd @ A @ B @ P3 ) @ ( product_fst @ A @ B @ P3 ) ) ) ) )).

% prod.swap_def
thf(fact_179_map__prod__o__convol__id,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > A ),G: ( C > B ),X: C] :
      ( ( comp @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B ) @ C @ ( product_map_prod @ C @ A @ B @ B @ F @ ( id @ B ) ) @ ( bNF_convol @ C @ C @ B @ ( id @ C ) @ G ) @ X )
      = ( bNF_convol @ C @ A @ B @ ( comp @ A @ A @ C @ ( id @ A ) @ F ) @ G @ X ) ) )).

% map_prod_o_convol_id
thf(fact_180_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_181_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X2: A] : X2 ) ) )).

% id_apply
thf(fact_182_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P ) )
      = P ) )).

% swap_swap
thf(fact_183_comp__id,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( comp @ A @ B @ A @ F @ ( id @ A ) )
      = F ) )).

% comp_id
thf(fact_184_id__comp,axiom,(
    ! [B: $tType,A: $tType,G: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G )
      = G ) )).

% id_comp
thf(fact_185_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_186_case__prod__Pair,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% case_prod_Pair
thf(fact_187_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X: B,Y4: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X @ Y4 ) )
      = ( product_Pair @ A @ B @ Y4 @ X ) ) )).

% swap_simp
thf(fact_188_apfst__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_apfst @ A @ A @ B @ ( id @ A ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% apfst_id
thf(fact_189_apsnd__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_apsnd @ B @ B @ A @ ( id @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% apsnd_id
thf(fact_190_case__swap,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B > A ),P: ( product_prod @ C @ B )] :
      ( ( product_case_prod @ B @ C @ A
        @ ^ [Y: B,X2: C] :
            ( F @ X2 @ Y )
        @ ( product_swap @ C @ B @ P ) )
      = ( product_case_prod @ C @ B @ A @ F @ P ) ) )).

% case_swap
thf(fact_191_swap__comp__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( product_swap @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% swap_comp_swap
thf(fact_192_fst__swap,axiom,(
    ! [A: $tType,B: $tType,X: ( product_prod @ B @ A )] :
      ( ( product_fst @ A @ B @ ( product_swap @ B @ A @ X ) )
      = ( product_snd @ B @ A @ X ) ) )).

% fst_swap
thf(fact_193_snd__swap,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ B )] :
      ( ( product_snd @ B @ A @ ( product_swap @ A @ B @ X ) )
      = ( product_fst @ A @ B @ X ) ) )).

% snd_swap
thf(fact_194_map__prod_Oidentity,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X2: A] : X2
        @ ^ [X2: B] : X2 )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% map_prod.identity
thf(fact_195_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_196_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_197_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),G: ( A > B ),X: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X ) )
        = X ) ) )).

% pointfree_idE
thf(fact_198_prod_Omap__id0,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% prod.map_id0
thf(fact_199_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X2: A] : X2 ) ) )).

% id_def
thf(fact_200_eq__id__iff,axiom,(
    ! [A: $tType,F: ( A > A )] :
      ( ( ! [X2: A] :
            ( ( F @ X2 )
            = X2 ) )
      = ( F
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_201_prod_Omap__id,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) @ T2 )
      = T2 ) )).

% prod.map_id
thf(fact_202_apfst__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( product_apfst @ A @ C @ B )
      = ( ^ [F2: ( A > C )] :
            ( product_map_prod @ A @ C @ B @ B @ F2 @ ( id @ B ) ) ) ) )).

% apfst_def
thf(fact_203_apsnd__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( product_apsnd @ B @ C @ A )
      = ( product_map_prod @ A @ A @ B @ C @ ( id @ A ) ) ) )).

% apsnd_def
thf(fact_204_convol__mem__GrpI,axiom,(
    ! [B: $tType,A: $tType,X: A,A6: ( set @ A ),G: ( A > B )] :
      ( ( member @ A @ X @ A6 )
     => ( member @ ( product_prod @ A @ B ) @ ( bNF_convol @ A @ A @ B @ ( id @ A ) @ G @ X ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A6 @ G ) ) ) ) ) )).

% convol_mem_GrpI
thf(fact_205_snd__diag__id,axiom,(
    ! [A: $tType,Z2: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_snd @ A @ A )
        @ ^ [X2: A] :
            ( product_Pair @ A @ A @ X2 @ X2 )
        @ Z2 )
      = ( id @ A @ Z2 ) ) )).

% snd_diag_id
thf(fact_206_fst__diag__id,axiom,(
    ! [A: $tType,Z2: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_fst @ A @ A )
        @ ^ [X2: A] :
            ( product_Pair @ A @ A @ X2 @ X2 )
        @ Z2 )
      = ( id @ A @ Z2 ) ) )).

% fst_diag_id
thf(fact_207_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C2 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_208_inf__Int__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X2: A,Y: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R )
        @ ^ [X2: A,Y: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ S2 ) )
      = ( ^ [X2: A,Y: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S2 ) ) ) ) )).

% inf_Int_eq2
thf(fact_209_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X2: A,Y: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R ) )
        = ( ^ [X2: A,Y: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ S2 ) ) )
      = ( R = S2 ) ) )).

% pred_equals_eq2
thf(fact_210_prod_Osize__gen__o__map,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( C > nat ),Fa: ( D > nat ),G: ( A > C ),Ga: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ nat @ ( product_prod @ A @ B ) @ ( basic_BNF_size_prod @ C @ D @ F @ Fa ) @ ( product_map_prod @ A @ C @ B @ D @ G @ Ga ) )
      = ( basic_BNF_size_prod @ A @ B @ ( comp @ C @ nat @ A @ F @ G ) @ ( comp @ D @ nat @ B @ Fa @ Ga ) ) ) )).

% prod.size_gen_o_map
thf(fact_211_inv__image__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( inv_image @ B @ A )
      = ( ^ [R2: ( set @ ( product_prod @ B @ B ) ),F2: ( A > B )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y: A] :
                  ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ X2 ) @ ( F2 @ Y ) ) @ R2 ) ) ) ) ) )).

% inv_image_def
thf(fact_212_iso__tuple__update__accessor__eq__assist__idI,axiom,(
    ! [A: $tType,V3: A,F: ( A > A ),V: A] :
      ( ( V3
        = ( F @ V ) )
     => ( iso_tu2011167877assist @ A @ A @ ( id @ ( A > A ) ) @ ( id @ A ) @ V @ F @ V3 @ V ) ) )).

% iso_tuple_update_accessor_eq_assist_idI
thf(fact_213_in__inv__image,axiom,(
    ! [A: $tType,B: $tType,X: A,Y4: A,R3: ( set @ ( product_prod @ B @ B ) ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y4 ) @ ( inv_image @ B @ A @ R3 @ F ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X ) @ ( F @ Y4 ) ) @ R3 ) ) )).

% in_inv_image
thf(fact_214_update__accessor__updator__eqE,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),V: B,F: ( A > A ),V3: B,X: A] :
      ( ( iso_tu2011167877assist @ A @ B @ Upd @ Ac2 @ V @ F @ V3 @ X )
     => ( ( Upd @ F @ V )
        = V3 ) ) )).

% update_accessor_updator_eqE
thf(fact_215_update__accessor__accessor__eqE,axiom,(
    ! [B: $tType,A: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),V: B,F: ( A > A ),V3: B,X: A] :
      ( ( iso_tu2011167877assist @ A @ B @ Upd @ Ac2 @ V @ F @ V3 @ X )
     => ( ( Ac2 @ V )
        = X ) ) )).

% update_accessor_accessor_eqE
thf(fact_216_iso__tuple__update__accessor__eq__assist__triv,axiom,(
    ! [B: $tType,A: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),V: B,F: ( A > A ),V3: B,X: A] :
      ( ( iso_tu2011167877assist @ A @ B @ Upd @ Ac2 @ V @ F @ V3 @ X )
     => ( iso_tu2011167877assist @ A @ B @ Upd @ Ac2 @ V @ F @ V3 @ X ) ) )).

% iso_tuple_update_accessor_eq_assist_triv
thf(fact_217_rp__inv__image__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R4: ( set @ ( product_prod @ A @ A ) ),S3: ( set @ ( product_prod @ A @ A ) ),F2: ( B > A )] :
            ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R4 @ F2 ) @ ( inv_image @ A @ B @ S3 @ F2 ) ) ) ) )).

% rp_inv_image_def
thf(fact_218_fun_Opred__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,Q: ( B > $o ),F: ( A > B ),X: ( D > A )] :
      ( ( basic_pred_fun @ D @ B
        @ ^ [Uu: D] : $true
        @ Q
        @ ( comp @ A @ B @ D @ F @ X ) )
      = ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ( comp @ B @ $o @ A @ Q @ F )
        @ X ) ) )).

% fun.pred_map
thf(fact_219_pred__funI,axiom,(
    ! [B: $tType,A: $tType,A6: ( A > $o ),B6: ( B > $o ),F: ( A > B )] :
      ( ! [X3: A] :
          ( ( A6 @ X3 )
         => ( B6 @ ( F @ X3 ) ) )
     => ( basic_pred_fun @ A @ B @ A6 @ B6 @ F ) ) )).

% pred_funI
thf(fact_220_fun_Opred__True,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: ( D > A )] : $true ) ) )).

% fun.pred_True
thf(fact_221_fun_Omap__cong__pred,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),Ya: ( D > A ),F: ( A > B ),G: ( A > B )] :
      ( ( X = Ya )
     => ( ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ ^ [Z: A] :
              ( ( F @ Z )
              = ( G @ Z ) )
          @ Ya )
       => ( ( comp @ A @ B @ D @ F @ X )
          = ( comp @ A @ B @ D @ G @ Ya ) ) ) ) )).

% fun.map_cong_pred
thf(fact_222_rp__inv__image__rp,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ),F: ( B > A )] :
      ( ( fun_reduction_pair @ A @ P2 )
     => ( fun_reduction_pair @ B @ ( fun_rp_inv_image @ A @ B @ P2 @ F ) ) ) )).

% rp_inv_image_rp
thf(fact_223_csquare__fstOp__sndOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( ( A > B > $o ) > ( product_prod @ A @ B ) > $o ),P2: ( A > C > $o ),Q: ( C > B > $o )] :
      ( bNF_csquare @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) @ C @ ( product_prod @ C @ B ) @ ( collect @ ( product_prod @ A @ B ) @ ( F @ ( relcompp @ A @ C @ B @ P2 @ Q ) ) ) @ ( product_snd @ A @ C ) @ ( product_fst @ C @ B ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q ) @ ( bNF_sndOp @ A @ C @ B @ P2 @ Q ) ) )).

% csquare_fstOp_sndOp
thf(fact_224_fstOp__in,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Ac2: ( product_prod @ A @ B ),P2: ( A > C > $o ),Q: ( C > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ Ac2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( relcompp @ A @ C @ B @ P2 @ Q ) ) ) )
     => ( member @ ( product_prod @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q @ Ac2 ) @ ( collect @ ( product_prod @ A @ C ) @ ( product_case_prod @ A @ C @ $o @ P2 ) ) ) ) )).

% fstOp_in
thf(fact_225_sndOp__in,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Ac2: ( product_prod @ A @ B ),P2: ( A > C > $o ),Q: ( C > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ Ac2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( relcompp @ A @ C @ B @ P2 @ Q ) ) ) )
     => ( member @ ( product_prod @ C @ B ) @ ( bNF_sndOp @ A @ C @ B @ P2 @ Q @ Ac2 ) @ ( collect @ ( product_prod @ C @ B ) @ ( product_case_prod @ C @ B @ $o @ Q ) ) ) ) )).

% sndOp_in
thf(fact_226_csquare__def,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType] :
      ( ( bNF_csquare @ A @ B @ C @ D )
      = ( ^ [A7: ( set @ A ),F12: ( B > C ),F23: ( D > C ),P1: ( A > B ),P22: ( A > D )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A7 )
           => ( ( F12 @ ( P1 @ X2 ) )
              = ( F23 @ ( P22 @ X2 ) ) ) ) ) ) )).

% csquare_def
thf(fact_227_pick__middlep,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: ( A > B > $o ),Q: ( B > C > $o ),A2: A,C2: C] :
      ( ( relcompp @ A @ B @ C @ P2 @ Q @ A2 @ C2 )
     => ( ( P2 @ A2 @ ( bNF_pick_middlep @ A @ B @ C @ P2 @ Q @ A2 @ C2 ) )
        & ( Q @ ( bNF_pick_middlep @ A @ B @ C @ P2 @ Q @ A2 @ C2 ) @ C2 ) ) ) )).

% pick_middlep
thf(fact_228_update__accessor__cong__assist__idI,axiom,(
    ! [A: $tType] :
      ( iso_tu2017585022assist @ A @ A @ ( id @ ( A > A ) ) @ ( id @ A ) ) )).

% update_accessor_cong_assist_idI
thf(fact_229_The__case__prod,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o )] :
      ( ( the @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P2 ) )
      = ( the @ ( product_prod @ A @ B )
        @ ^ [Xy: ( product_prod @ A @ B )] :
            ( P2 @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) )).

% The_case_prod
thf(fact_230_The__split__eq,axiom,(
    ! [A: $tType,B: $tType,X: A,Y4: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X5: A,Y6: B] :
              ( ( X = X5 )
              & ( Y4 = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X @ Y4 ) ) )).

% The_split_eq
thf(fact_231_iso__tuple__update__accessor__cong__from__eq,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),V: B,F: ( A > A ),V3: B,X: A] :
      ( ( iso_tu2011167877assist @ A @ B @ Upd @ Ac2 @ V @ F @ V3 @ X )
     => ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 ) ) )).

% iso_tuple_update_accessor_cong_from_eq
thf(fact_232_iso__tuple__update__accessor__eq__assist__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( iso_tu2011167877assist @ B @ A )
      = ( ^ [Upd2: ( ( B > B ) > A > A ),Ac: ( A > B ),V4: A,F2: ( B > B ),V5: A,X2: B] :
            ( ( ( Upd2 @ F2 @ V4 )
              = V5 )
            & ( ( Ac @ V4 )
              = X2 )
            & ( iso_tu2017585022assist @ B @ A @ Upd2 @ Ac ) ) ) ) )).

% iso_tuple_update_accessor_eq_assist_def
thf(fact_233_update__accessor__congruence__unfoldE,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),R3: B,R5: B,V3: A,F: ( A > A ),F5: ( A > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 )
     => ( ( R3 = R5 )
       => ( ( ( Ac2 @ R5 )
            = V3 )
         => ( ! [V6: A] :
                ( ( V6 = V3 )
               => ( ( F @ V6 )
                  = ( F5 @ V6 ) ) )
           => ( ( Upd @ F @ R3 )
              = ( Upd @ F5 @ R5 ) ) ) ) ) ) )).

% update_accessor_congruence_unfoldE
thf(fact_234_update__accessor__congruence__foldE,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),R3: B,R5: B,V3: A,F: ( A > A ),F5: ( A > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 )
     => ( ( R3 = R5 )
       => ( ( ( Ac2 @ R5 )
            = V3 )
         => ( ! [V6: A] :
                ( ( V3 = V6 )
               => ( ( F @ V6 )
                  = ( F5 @ V6 ) ) )
           => ( ( Upd @ F @ R3 )
              = ( Upd @ F5 @ R5 ) ) ) ) ) ) )).

% update_accessor_congruence_foldE
thf(fact_235_update__accessor__cong__assist__triv,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 )
     => ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 ) ) )).

% update_accessor_cong_assist_triv
thf(fact_236_update__accessor__noopE,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),F: ( A > A ),X: B] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 )
     => ( ( ( F @ ( Ac2 @ X ) )
          = ( Ac2 @ X ) )
       => ( ( Upd @ F @ X )
          = X ) ) ) )).

% update_accessor_noopE
thf(fact_237_iso__tuple__update__accessor__cong__assist__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( iso_tu2017585022assist @ B @ A )
      = ( ^ [Upd2: ( ( B > B ) > A > A ),Ac: ( A > B )] :
            ( ! [F2: ( B > B ),V4: A] :
                ( ( Upd2
                  @ ^ [X2: B] :
                      ( F2 @ ( Ac @ V4 ) )
                  @ V4 )
                = ( Upd2 @ F2 @ V4 ) )
            & ! [V4: A] :
                ( ( Upd2 @ ( id @ B ) @ V4 )
                = V4 ) ) ) ) )).

% iso_tuple_update_accessor_cong_assist_def
thf(fact_238_update__accessor__noop__compE,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A ),F: ( A > A ),X: B,G: ( A > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 )
     => ( ( ( F @ ( Ac2 @ X ) )
          = ( Ac2 @ X ) )
       => ( ( Upd @ ( comp @ A @ A @ A @ G @ F ) @ X )
          = ( Upd @ G @ X ) ) ) ) )).

% update_accessor_noop_compE
thf(fact_239_iso__tuple__update__accessor__cong__assist__id,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac2: ( B > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac2 )
     => ( ( Upd @ ( id @ A ) )
        = ( id @ B ) ) ) )).

% iso_tuple_update_accessor_cong_assist_id
thf(fact_240_old_Orec__prod__def,axiom,(
    ! [T: $tType,B: $tType,A: $tType] :
      ( ( product_rec_prod @ A @ B @ T )
      = ( ^ [F12: ( A > B > T ),X2: ( product_prod @ A @ B )] :
            ( the @ T @ ( product_rec_set_prod @ A @ B @ T @ F12 @ X2 ) ) ) ) )).

% old.rec_prod_def
thf(fact_241_the__sym__eq__trivial,axiom,(
    ! [A: $tType,X: A] :
      ( ( the @ A
        @ ( ^ [Y5: A,Z3: A] : ( Y5 = Z3 )
          @ X ) )
      = X ) )).

% the_sym_eq_trivial
thf(fact_242_the__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( P2 @ A2 )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( X3 = A2 ) )
       => ( ( the @ A @ P2 )
          = A2 ) ) ) )).

% the_equality
thf(fact_243_the__eq__trivial,axiom,(
    ! [A: $tType,A2: A] :
      ( ( the @ A
        @ ^ [X2: A] : ( X2 = A2 ) )
      = A2 ) )).

% the_eq_trivial
thf(fact_244_theI,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( P2 @ A2 )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( X3 = A2 ) )
       => ( P2 @ ( the @ A @ P2 ) ) ) ) )).

% theI
thf(fact_245_theI_H,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ? [X6: A] :
          ( ( P2 @ X6 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X6 ) ) )
     => ( P2 @ ( the @ A @ P2 ) ) ) )).

% theI'
thf(fact_246_theI2,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A,Q: ( A > $o )] :
      ( ( P2 @ A2 )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( X3 = A2 ) )
       => ( ! [X3: A] :
              ( ( P2 @ X3 )
             => ( Q @ X3 ) )
         => ( Q @ ( the @ A @ P2 ) ) ) ) ) )).

% theI2
thf(fact_247_If__def,axiom,(
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P4: $o,X2: A,Y: A] :
            ( the @ A
            @ ^ [Z: A] :
                ( ( P4
                 => ( Z = X2 ) )
                & ( ~ ( P4 )
                 => ( Z = Y ) ) ) ) ) ) )).

% If_def
thf(fact_248_the1I2,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ? [X6: A] :
          ( ( P2 @ X6 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X6 ) ) )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( Q @ X3 ) )
       => ( Q @ ( the @ A @ P2 ) ) ) ) )).

% the1I2
thf(fact_249_the1__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ? [X6: A] :
          ( ( P2 @ X6 )
          & ! [Y3: A] :
              ( ( P2 @ Y3 )
             => ( Y3 = X6 ) ) )
     => ( ( P2 @ A2 )
       => ( ( the @ A @ P2 )
          = A2 ) ) ) )).

% the1_equality
thf(fact_250_old_Orec__unit__def,axiom,(
    ! [T: $tType] :
      ( ( product_rec_unit @ T )
      = ( ^ [F12: T,X2: product_unit] :
            ( the @ T @ ( product_rec_set_unit @ T @ F12 @ X2 ) ) ) ) )).

% old.rec_unit_def
thf(fact_251_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B2: A,F: ( B > A ),X: B,C2: C,G: ( B > C ),A6: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( C2
          = ( G @ X ) )
       => ( ( member @ B @ X @ A6 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A6 @ F @ G ) ) ) ) ) )).

% image2_eqI
thf(fact_252_same__fst__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P4: ( A > $o ),R4: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X5: A,Y6: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X2: A,Y: B] :
                        ( ( X5 = X2 )
                        & ( P4 @ X2 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y ) @ ( R4 @ X2 ) ) ) ) ) ) ) ) ) )).

% same_fst_def
thf(fact_253_old_Orec__bool__def,axiom,(
    ! [T: $tType] :
      ( ( product_rec_bool @ T )
      = ( ^ [F12: T,F23: T,X2: $o] :
            ( the @ T @ ( product_rec_set_bool @ T @ F12 @ F23 @ X2 ) ) ) ) )).

% old.rec_bool_def
thf(fact_254_old_Obool_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F22: T] :
      ( ( product_rec_bool @ T @ F1 @ F22 @ $false )
      = F22 ) )).

% old.bool.simps(6)
thf(fact_255_old_Obool_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F22: T] :
      ( ( product_rec_bool @ T @ F1 @ F22 @ $true )
      = F1 ) )).

% old.bool.simps(5)

%----Type constructors (10)
thf(tcon_fun___Lattices_Osemilattice__inf,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( semilattice_inf @ A9 @ ( type2 @ A9 ) )
     => ( semilattice_inf @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( lattice @ A9 @ ( type2 @ A9 ) )
     => ( lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_1,axiom,
    ( semilattice_inf @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Lattices_Olattice_2,axiom,
    ( lattice @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_3,axiom,(
    ! [A8: $tType] :
      ( semilattice_inf @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_4,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_5,axiom,
    ( semilattice_inf @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_6,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_7,axiom,
    ( semilattice_inf @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_8,axiom,
    ( lattice @ product_unit @ ( type2 @ product_unit ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y4: A] :
      ( ( if @ A @ $false @ X @ Y4 )
      = Y4 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y4: A] :
      ( ( if @ A @ $true @ X @ Y4 )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( coindu1441602521_llist @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) @ a
      @ ( product_case_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ $o
        @ ^ [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
            ( ( Xs
             != ( coinductive_LNil @ a ) )
           => ( ( Ys
               != ( coinductive_LNil @ a ) )
             => ( ( coinductive_lhd @ a @ Xs )
               != ( coinductive_lhd @ a @ Ys ) ) ) ) )
      @ ( comp @ ( coinductive_llist @ a ) @ a @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) @ ( coinductive_lhd @ a ) @ ( product_snd @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) )
      @ ( product_map_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_ltl @ a ) @ ( coinductive_ltl @ a ) )
      @ ( product_Pair @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_LNil @ a ) @ xs ) )
    = ( coinductive_LNil @ a ) )).

%------------------------------------------------------------------------------
