%------------------------------------------------------------------------------
% File     : DAT145^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive stream 82
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_stream__82.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  324 (   0 unit;  64 type;   0 defn)
%            Number of atoms       : 5341 ( 322 equality;3780 variable)
%            Maximal formula depth :   28 (  13 average)
%            Number of connectives : 5130 (  44   ~;   3   |;  38   &;4913   @)
%                                         (   0 <=>; 132  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  598 ( 598   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   68 (  64   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1692 (   6 sgn;1359   !;  24   ?; 200   ^)
%                                         (1692   :; 109  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 15:13:02.283
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Product__Type_Ounit,type,(
    product_unit: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_c,type,(
    c: $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (55)
thf(sy_c_BNF__Def_OGrp,type,(
    bNF_Grp: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > B ) > A > B > $o ) )).

thf(sy_c_BNF__Def_Oconvol,type,(
    bNF_convol: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B ) > ( A > C ) > A > ( product_prod @ B @ C ) ) )).

thf(sy_c_BNF__Def_Ocsquare,type,(
    bNF_csquare: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( set @ A ) > ( B > C ) > ( D > C ) > ( A > B ) > ( A > D ) > $o ) )).

thf(sy_c_BNF__Def_OfstOp,type,(
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > ( product_prod @ A @ C ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Def_Opick__middlep,type,(
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] :
        ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) )).

thf(sy_c_BNF__Def_OsndOp,type,(
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( C > A > $o ) > ( A > B > $o ) > ( product_prod @ C @ B ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,(
    bNF_Gr1317331620lImage: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( B > A ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,(
    bNF_Gr2107612801vImage: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,(
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ounfold__stream,type,(
    coindu139217191stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > A ) > A > ( stream @ B ) ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Fun__Def_Oin__rel,type,(
    fun_in_rel: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > A > B > $o ) )).

thf(sy_c_Fun__Def_Oreduction__pair,type,(
    fun_reduction_pair: 
      !>[A: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > $o ) )).

thf(sy_c_Fun__Def_Orp__inv__image,type,(
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) )).

thf(sy_c_HOL_OThe,type,(
    the: 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oapfst,type,(
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) )).

thf(sy_c_Product__Type_Oapsnd,type,(
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__set__bool,type,(
    product_rec_set_bool: 
      !>[T: $tType] :
        ( T > T > $o > T > $o ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__set__prod,type,(
    product_rec_set_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T > $o ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__set__unit,type,(
    product_rec_set_unit: 
      !>[T: $tType] :
        ( T > product_unit > T > $o ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,(
    product_rec_unit: 
      !>[T: $tType] :
        ( T > product_unit > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Osnd,type,(
    product_snd: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > B ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Product__Type_Oscomp,type,(
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Oinv__image,type,(
    inv_image: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Relation_Orelcomp,type,(
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Stream_Osdrop,type,(
    sdrop: 
      !>[A: $tType] :
        ( nat > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osmap2,type,(
    smap2: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( stream @ A ) > ( stream @ B ) > ( stream @ C ) ) )).

thf(sy_c_Stream_Osmember,type,(
    smember: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Osmerge,type,(
    smerge: 
      !>[A: $tType] :
        ( ( stream @ ( stream @ A ) ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osnth,type,(
    snth: 
      !>[A: $tType] :
        ( ( stream @ A ) > nat > A ) )).

thf(sy_c_Stream_Osproduct,type,(
    sproduct: 
      !>[A: $tType,B: $tType] :
        ( ( stream @ A ) > ( stream @ B ) > ( stream @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Stream_Ostream_OSCons,type,(
    sCons: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Ocorec__stream,type,(
    corec_stream: 
      !>[C: $tType,A: $tType] :
        ( ( C > A ) > ( C > $o ) > ( C > ( stream @ A ) ) > ( C > C ) > C > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Osmap,type,(
    smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream @ A ) > ( stream @ Aa ) ) )).

thf(sy_c_Stream_Oszip,type,(
    szip: 
      !>[A: $tType,B: $tType] :
        ( ( stream @ A ) > ( stream @ B ) > ( stream @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Wellfounded_Olex__prod,type,(
    lex_prod: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_g,type,(
    g: c > b )).

thf(sy_v_xs,type,(
    xs: ( stream @ a ) )).

thf(sy_v_ys,type,(
    ys: ( stream @ c ) )).

%----Relevant facts (256)
thf(fact_0_szip__smap1,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),Xs: ( stream @ C ),Ys: ( stream @ B )] :
      ( ( szip @ A @ B @ ( smap @ C @ A @ F @ Xs ) @ Ys )
      = ( smap @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B ) @ ( product_apfst @ C @ A @ B @ F ) @ ( szip @ C @ B @ Xs @ Ys ) ) ) )).

% szip_smap1
thf(fact_1_smap__eq__SCons__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( stream @ B ),Y: A,Ys: ( stream @ A )] :
      ( ( ( smap @ B @ A @ F @ Xs )
        = ( sCons @ A @ Y @ Ys ) )
      = ( ? [X: B,Xs2: ( stream @ B )] :
            ( ( Xs
              = ( sCons @ B @ X @ Xs2 ) )
            & ( Y
              = ( F @ X ) )
            & ( Ys
              = ( smap @ B @ A @ F @ Xs2 ) ) ) ) ) )).

% smap_eq_SCons_conv
thf(fact_2_smap2__szip,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( smap2 @ B @ C @ A )
      = ( ^ [F2: ( B > C > A ),S1: ( stream @ B ),S2: ( stream @ C )] :
            ( smap @ ( product_prod @ B @ C ) @ A @ ( product_case_prod @ B @ C @ A @ F2 ) @ ( szip @ B @ C @ S1 @ S2 ) ) ) ) )).

% smap2_szip
thf(fact_3_apsnd__apfst__commute,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: ( C > B ),G: ( D > A ),P: ( product_prod @ D @ C )] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apfst @ D @ A @ C @ G @ P ) )
      = ( product_apfst @ D @ A @ B @ G @ ( product_apsnd @ C @ B @ D @ F @ P ) ) ) )).

% apsnd_apfst_commute
thf(fact_4_apsnd__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),X2: A,Y: C] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_Pair @ A @ C @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ X2 @ ( F @ Y ) ) ) )).

% apsnd_conv
thf(fact_5_sdrop__smap,axiom,(
    ! [A: $tType,B: $tType,N: nat,F: ( B > A ),S: ( stream @ B )] :
      ( ( sdrop @ A @ N @ ( smap @ B @ A @ F @ S ) )
      = ( smap @ B @ A @ F @ ( sdrop @ B @ N @ S ) ) ) )).

% sdrop_smap
thf(fact_6_smap__szip__fst,axiom,(
    ! [C: $tType,A: $tType,B: $tType,F: ( B > A ),S12: ( stream @ B ),S22: ( stream @ C )] :
      ( ( smap @ ( product_prod @ B @ C ) @ A
        @ ^ [X: ( product_prod @ B @ C )] :
            ( F @ ( product_fst @ B @ C @ X ) )
        @ ( szip @ B @ C @ S12 @ S22 ) )
      = ( smap @ B @ A @ F @ S12 ) ) )).

% smap_szip_fst
thf(fact_7_smap__szip__snd,axiom,(
    ! [B: $tType,A: $tType,C: $tType,G: ( C > A ),S12: ( stream @ B ),S22: ( stream @ C )] :
      ( ( smap @ ( product_prod @ B @ C ) @ A
        @ ^ [X: ( product_prod @ B @ C )] :
            ( G @ ( product_snd @ B @ C @ X ) )
        @ ( szip @ B @ C @ S12 @ S22 ) )
      = ( smap @ C @ A @ G @ S22 ) ) )).

% smap_szip_snd
thf(fact_8_fst__apsnd,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),X2: ( product_prod @ A @ C )] :
      ( ( product_fst @ A @ B @ ( product_apsnd @ C @ B @ A @ F @ X2 ) )
      = ( product_fst @ A @ C @ X2 ) ) )).

% fst_apsnd
thf(fact_9_snth__smap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S: ( stream @ B ),N: nat] :
      ( ( snth @ A @ ( smap @ B @ A @ F @ S ) @ N )
      = ( F @ ( snth @ B @ S @ N ) ) ) )).

% snth_smap
thf(fact_10_snd__apsnd,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( C > A ),X2: ( product_prod @ B @ C )] :
      ( ( product_snd @ B @ A @ ( product_apsnd @ C @ A @ B @ F @ X2 ) )
      = ( F @ ( product_snd @ B @ C @ X2 ) ) ) )).

% snd_apsnd
thf(fact_11_apsnd__eq__conv,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),X2: ( product_prod @ A @ C ),G: ( C > B )] :
      ( ( ( product_apsnd @ C @ B @ A @ F @ X2 )
        = ( product_apsnd @ C @ B @ A @ G @ X2 ) )
      = ( ( F @ ( product_snd @ A @ C @ X2 ) )
        = ( G @ ( product_snd @ A @ C @ X2 ) ) ) ) )).

% apsnd_eq_conv
thf(fact_12_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y2 ) ) ) )).

% prod.inject
thf(fact_13_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B3 ) )
      = ( ( A2 = A3 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_14_stream_Oinject,axiom,(
    ! [A: $tType,X1: A,X22: ( stream @ A ),Y1: A,Y2: ( stream @ A )] :
      ( ( ( sCons @ A @ X1 @ X22 )
        = ( sCons @ A @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y2 ) ) ) )).

% stream.inject
thf(fact_15_case__prodI,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A2: A,B2: B] :
      ( ( F @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% case_prodI
thf(fact_16_case__prodI2,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ),C2: ( A > B > $o )] :
      ( ! [A4: A,B4: B] :
          ( ( P
            = ( product_Pair @ A @ B @ A4 @ B4 ) )
         => ( C2 @ A4 @ B4 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P ) ) )).

% case_prodI2
thf(fact_17_case__prodI2_H,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P: ( product_prod @ A @ B ),C2: ( A > B > C > $o ),X2: C] :
      ( ! [A4: A,B4: B] :
          ( ( ( product_Pair @ A @ B @ A4 @ B4 )
            = P )
         => ( C2 @ A4 @ B4 @ X2 ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P @ X2 ) ) )).

% case_prodI2'
thf(fact_18_mem__case__prodI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Z: A,C2: ( B > C > ( set @ A ) ),A2: B,B2: C] :
      ( ( member @ A @ Z @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) )).

% mem_case_prodI
thf(fact_19_mem__case__prodI2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ B ),Z: C,C2: ( A > B > ( set @ C ) )] :
      ( ! [A4: A,B4: B] :
          ( ( P
            = ( product_Pair @ A @ B @ A4 @ B4 ) )
         => ( member @ C @ Z @ ( C2 @ A4 @ B4 ) ) )
     => ( member @ C @ Z @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P ) ) ) )).

% mem_case_prodI2
thf(fact_20_stream_Omap__ident,axiom,(
    ! [A: $tType,T2: ( stream @ A )] :
      ( ( smap @ A @ A
        @ ^ [X: A] : X
        @ T2 )
      = T2 ) )).

% stream.map_ident
thf(fact_21_apfst__conv,axiom,(
    ! [C: $tType,A: $tType,B: $tType,F: ( C > A ),X2: C,Y: B] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_Pair @ C @ B @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ ( F @ X2 ) @ Y ) ) )).

% apfst_conv
thf(fact_22_fst__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > A ),X2: ( product_prod @ C @ B )] :
      ( ( product_fst @ A @ B @ ( product_apfst @ C @ A @ B @ F @ X2 ) )
      = ( F @ ( product_fst @ C @ B @ X2 ) ) ) )).

% fst_apfst
thf(fact_23_apfst__eq__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > A ),X2: ( product_prod @ C @ B ),G: ( C > A )] :
      ( ( ( product_apfst @ C @ A @ B @ F @ X2 )
        = ( product_apfst @ C @ A @ B @ G @ X2 ) )
      = ( ( F @ ( product_fst @ C @ B @ X2 ) )
        = ( G @ ( product_fst @ C @ B @ X2 ) ) ) ) )).

% apfst_eq_conv
thf(fact_24_snd__apfst,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > B ),X2: ( product_prod @ C @ A )] :
      ( ( product_snd @ B @ A @ ( product_apfst @ C @ B @ A @ F @ X2 ) )
      = ( product_snd @ C @ A @ X2 ) ) )).

% snd_apfst
thf(fact_25_case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F @ A2 @ B2 ) ) )).

% case_prod_conv
thf(fact_26_snth__smap2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),S12: ( stream @ B ),S22: ( stream @ C ),N: nat] :
      ( ( snth @ A @ ( smap2 @ B @ C @ A @ F @ S12 @ S22 ) @ N )
      = ( F @ ( snth @ B @ S12 @ N ) @ ( snth @ C @ S22 @ N ) ) ) )).

% snth_smap2
thf(fact_27_sdrop__szip,axiom,(
    ! [A: $tType,B: $tType,N: nat,S12: ( stream @ A ),S22: ( stream @ B )] :
      ( ( sdrop @ ( product_prod @ A @ B ) @ N @ ( szip @ A @ B @ S12 @ S22 ) )
      = ( szip @ A @ B @ ( sdrop @ A @ N @ S12 ) @ ( sdrop @ B @ N @ S22 ) ) ) )).

% sdrop_szip
thf(fact_28_sdrop__smap2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,N: nat,F: ( B > C > A ),S12: ( stream @ B ),S22: ( stream @ C )] :
      ( ( sdrop @ A @ N @ ( smap2 @ B @ C @ A @ F @ S12 @ S22 ) )
      = ( smap2 @ B @ C @ A @ F @ ( sdrop @ B @ N @ S12 ) @ ( sdrop @ C @ N @ S22 ) ) ) )).

% sdrop_smap2
thf(fact_29_smap__smap2,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( B > A ),G: ( C > D > B ),S12: ( stream @ C ),S22: ( stream @ D )] :
      ( ( smap @ B @ A @ F @ ( smap2 @ C @ D @ B @ G @ S12 @ S22 ) )
      = ( smap2 @ C @ D @ A
        @ ^ [X: C,Y3: D] :
            ( F @ ( G @ X @ Y3 ) )
        @ S12
        @ S22 ) ) )).

% smap_smap2
thf(fact_30_prod_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) )).

% prod.collapse
thf(fact_31_snth__szip,axiom,(
    ! [A: $tType,B: $tType,S12: ( stream @ A ),S22: ( stream @ B ),N: nat] :
      ( ( snth @ ( product_prod @ A @ B ) @ ( szip @ A @ B @ S12 @ S22 ) @ N )
      = ( product_Pair @ A @ B @ ( snth @ A @ S12 @ N ) @ ( snth @ B @ S22 @ N ) ) ) )).

% snth_szip
thf(fact_32_apfst__apsnd,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F: ( C > A ),G: ( D > B ),X2: ( product_prod @ C @ D )] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_apsnd @ D @ B @ C @ G @ X2 ) )
      = ( product_Pair @ A @ B @ ( F @ ( product_fst @ C @ D @ X2 ) ) @ ( G @ ( product_snd @ C @ D @ X2 ) ) ) ) )).

% apfst_apsnd
thf(fact_33_apsnd__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: ( C > B ),G: ( D > A ),X2: ( product_prod @ D @ C )] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apfst @ D @ A @ C @ G @ X2 ) )
      = ( product_Pair @ A @ B @ ( G @ ( product_fst @ D @ C @ X2 ) ) @ ( F @ ( product_snd @ D @ C @ X2 ) ) ) ) )).

% apsnd_apfst
thf(fact_34_smap2__alt,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > C > A ),S12: ( stream @ B ),S22: ( stream @ C ),S: ( stream @ A )] :
      ( ( ( smap2 @ B @ C @ A @ F @ S12 @ S22 )
        = S )
      = ( ! [N2: nat] :
            ( ( F @ ( snth @ B @ S12 @ N2 ) @ ( snth @ C @ S22 @ N2 ) )
            = ( snth @ A @ S @ N2 ) ) ) ) )).

% smap2_alt
thf(fact_35_szip__unfold,axiom,(
    ! [A: $tType,B: $tType,A2: A,S12: ( stream @ A ),B2: B,S22: ( stream @ B )] :
      ( ( szip @ A @ B @ ( sCons @ A @ A2 @ S12 ) @ ( sCons @ B @ B2 @ S22 ) )
      = ( sCons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( szip @ A @ B @ S12 @ S22 ) ) ) )).

% szip_unfold
thf(fact_36_smap2__unfold,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A2: B,S12: ( stream @ B ),B2: C,S22: ( stream @ C )] :
      ( ( smap2 @ B @ C @ A @ F @ ( sCons @ B @ A2 @ S12 ) @ ( sCons @ C @ B2 @ S22 ) )
      = ( sCons @ A @ ( F @ A2 @ B2 ) @ ( smap2 @ B @ C @ A @ F @ S12 @ S22 ) ) ) )).

% smap2_unfold
thf(fact_37_fst__eqD,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X2 @ Y ) )
        = A2 )
     => ( X2 = A2 ) ) )).

% fst_eqD
thf(fact_38_snd__eqD,axiom,(
    ! [B: $tType,A: $tType,X2: B,Y: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) )
        = A2 )
     => ( Y = A2 ) ) )).

% snd_eqD
thf(fact_39_fst__conv,axiom,(
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) )).

% fst_conv
thf(fact_40_prod__eqI,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ),Q: ( product_prod @ A @ B )] :
      ( ( ( product_fst @ A @ B @ P )
        = ( product_fst @ A @ B @ Q ) )
     => ( ( ( product_snd @ A @ B @ P )
          = ( product_snd @ A @ B @ Q ) )
       => ( P = Q ) ) ) )).

% prod_eqI
thf(fact_41_snd__conv,axiom,(
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) )).

% snd_conv
thf(fact_42_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream @ A )] :
      ~ ( ! [X12: A,X23: ( stream @ A )] :
            ( Y
           != ( sCons @ A @ X12 @ X23 ) ) ) )).

% stream.exhaust
thf(fact_43_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P: ( product_prod @ A @ B )] :
    ? [X3: A,Y4: B] :
      ( P
      = ( product_Pair @ A @ B @ X3 @ Y4 ) ) )).

% surj_pair
thf(fact_44_case__prodD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F @ A2 @ B2 ) ) )).

% case_prodD
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P2: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P2 ) )
      = ( P2 @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P2 @ X3 )
          = ( Q2 @ X3 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q2 ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_case__prodE,axiom,(
    ! [A: $tType,B: $tType,C2: ( A > B > $o ),P: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P )
     => ~ ( ! [X3: A,Y4: B] :
              ( ( P
                = ( product_Pair @ A @ B @ X3 @ Y4 ) )
             => ~ ( C2 @ X3 @ Y4 ) ) ) ) )).

% case_prodE
thf(fact_50_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),P: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P2 @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P2 @ P ) ) )).

% prod_cases
thf(fact_51_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A3 @ B3 ) )
     => ~ ( ( A2 = A3 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_52_case__prodD_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R: ( A > B > C > $o ),A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R @ A2 @ B2 @ C2 ) ) )).

% case_prodD'
thf(fact_53_case__prodE_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( A > B > C > $o ),P: ( product_prod @ A @ B ),Z: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P @ Z )
     => ~ ( ! [X3: A,Y4: B] :
              ( ( P
                = ( product_Pair @ A @ B @ X3 @ Y4 ) )
             => ~ ( C2 @ X3 @ Y4 @ Z ) ) ) ) )).

% case_prodE'
thf(fact_54_case__prodE2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Q2: ( A > $o ),P2: ( B > C > A ),Z: ( product_prod @ B @ C )] :
      ( ( Q2 @ ( product_case_prod @ B @ C @ A @ P2 @ Z ) )
     => ~ ( ! [X3: B,Y4: C] :
              ( ( Z
                = ( product_Pair @ B @ C @ X3 @ Y4 ) )
             => ~ ( Q2 @ ( P2 @ X3 @ Y4 ) ) ) ) ) )).

% case_prodE2
thf(fact_55_prod_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B ),Prod2: ( product_prod @ A @ B )] :
      ( ( ( ( product_fst @ A @ B @ Prod )
          = ( product_fst @ A @ B @ Prod2 ) )
        & ( ( product_snd @ A @ B @ Prod )
          = ( product_snd @ A @ B @ Prod2 ) ) )
     => ( Prod = Prod2 ) ) )).

% prod.expand
thf(fact_56_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A4: A,B4: B,C3: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_57_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A4: A,B4: B,C3: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_58_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C3: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_59_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C3: C,D2: D,E2: E,F4: F3] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_60_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F3: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C3: C,D2: D,E2: E,F4: F3,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G2 ) @ E2 @ ( product_Pair @ F3 @ G2 @ F4 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_61_prod__eq__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [Y5: ( product_prod @ A @ B ),Z2: ( product_prod @ A @ B )] : ( Y5 = Z2 ) )
      = ( ^ [S3: ( product_prod @ A @ B ),T3: ( product_prod @ A @ B )] :
            ( ( ( product_fst @ A @ B @ S3 )
              = ( product_fst @ A @ B @ T3 ) )
            & ( ( product_snd @ A @ B @ S3 )
              = ( product_snd @ A @ B @ T3 ) ) ) ) ) )).

% prod_eq_iff
thf(fact_62_fst__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( product_case_prod @ A @ B @ A
        @ ^ [X13: A,X24: B] : X13 ) ) )).

% fst_def
thf(fact_63_snd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_snd @ A @ B )
      = ( product_case_prod @ A @ B @ B
        @ ^ [X13: A,X24: B] : X24 ) ) )).

% snd_def
thf(fact_64_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A4: A,B4: B,C3: C] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C3 ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct3
thf(fact_65_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A4: A,B4: B,C3: C,D2: D] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct4
thf(fact_66_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A4: A,B4: B,C3: C,D2: D,E2: E] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct5
thf(fact_67_prod__induct6,axiom,(
    ! [F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) )] :
      ( ! [A4: A,B4: B,C3: C,D2: D,E2: E,F4: F3] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F3 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F3 ) @ D2 @ ( product_Pair @ E @ F3 @ E2 @ F4 ) ) ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct6
thf(fact_68_prod__induct7,axiom,(
    ! [G2: $tType,F3: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P2: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) ) )] :
      ( ! [A4: A,B4: B,C3: C,D2: D,E2: E,F4: F3,G3: G2] :
          ( P2 @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F3 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F3 @ G2 ) @ E2 @ ( product_Pair @ F3 @ G2 @ F4 @ G3 ) ) ) ) ) ) )
     => ( P2 @ X2 ) ) )).

% prod_induct7
thf(fact_69_case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X: A,Y3: B] :
            ( F @ ( product_Pair @ A @ B @ X @ Y3 ) ) )
      = F ) )).

% case_prod_eta
thf(fact_70_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F @ X1 @ X22 ) ) )).

% old.prod.case
thf(fact_71_split__comp__eq,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,F: ( A > B > C ),G: ( D > A )] :
      ( ( ^ [U: ( product_prod @ D @ B )] :
            ( F @ ( G @ ( product_fst @ D @ B @ U ) ) @ ( product_snd @ D @ B @ U ) ) )
      = ( product_case_prod @ D @ B @ C
        @ ^ [X: D] :
            ( F @ ( G @ X ) ) ) ) )).

% split_comp_eq
thf(fact_72_case__prod__beta,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ A )
      = ( ^ [F2: ( B > C > A ),P3: ( product_prod @ B @ C )] :
            ( F2 @ ( product_fst @ B @ C @ P3 ) @ ( product_snd @ B @ C @ P3 ) ) ) ) )).

% case_prod_beta
thf(fact_73_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z: A,C2: ( B > C > ( set @ A ) ),P: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P ) )
     => ~ ( ! [X3: B,Y4: C] :
              ( ( P
                = ( product_Pair @ B @ C @ X3 @ Y4 ) )
             => ~ ( member @ A @ Z @ ( C2 @ X3 @ Y4 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_74_prod_Osplit__sel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( C > $o ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P2 @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P2 @ ( F @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) )).

% prod.split_sel
thf(fact_75_case__prod__beta_H,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F2: ( A > B > C ),X: ( product_prod @ A @ B )] :
            ( F2 @ ( product_fst @ A @ B @ X ) @ ( product_snd @ A @ B @ X ) ) ) ) )).

% case_prod_beta'
thf(fact_76_prod_Ocase__eq__if,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F2: ( A > B > C ),Prod3: ( product_prod @ A @ B )] :
            ( F2 @ ( product_fst @ A @ B @ Prod3 ) @ ( product_snd @ A @ B @ Prod3 ) ) ) ) )).

% prod.case_eq_if
thf(fact_77_case__prod__unfold,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [C4: ( A > B > C ),P3: ( product_prod @ A @ B )] :
            ( C4 @ ( product_fst @ A @ B @ P3 ) @ ( product_snd @ A @ B @ P3 ) ) ) ) )).

% case_prod_unfold
thf(fact_78_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A4: A,B4: B] :
            ( Y
           != ( product_Pair @ A @ B @ A4 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_79_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P2: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P2 @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P2 @ Prod ) ) )).

% old.prod.inducts
thf(fact_80_prod_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) )).

% prod.exhaust_sel
thf(fact_81_prod_Ocase__distrib,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: ( C > D ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X13: A,X24: B] :
            ( H @ ( F @ X13 @ X24 ) )
        @ Prod ) ) )).

% prod.case_distrib
thf(fact_82_Product__Type_OCollect__case__prodD,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B ),A5: ( A > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A5 ) ) )
     => ( A5 @ ( product_fst @ A @ B @ X2 ) @ ( product_snd @ A @ B @ X2 ) ) ) )).

% Product_Type.Collect_case_prodD
thf(fact_83_cond__case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),G: ( ( product_prod @ A @ B ) > C )] :
      ( ! [X3: A,Y4: B] :
          ( ( F @ X3 @ Y4 )
          = ( G @ ( product_Pair @ A @ B @ X3 @ Y4 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F )
        = G ) ) )).

% cond_case_prod_eta
thf(fact_84_prod_Osplit__sel__asm,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( C > $o ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P2 @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P2 @ ( F @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) )).

% prod.split_sel_asm
thf(fact_85_surjective__pairing,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) )).

% surjective_pairing
thf(fact_86_stream_Omap,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X1: A,X22: ( stream @ A )] :
      ( ( smap @ A @ B @ F @ ( sCons @ A @ X1 @ X22 ) )
      = ( sCons @ B @ ( F @ X1 ) @ ( smap @ A @ B @ F @ X22 ) ) ) )).

% stream.map
thf(fact_87_smap__alt,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S: ( stream @ B ),S4: ( stream @ A )] :
      ( ( ( smap @ B @ A @ F @ S )
        = S4 )
      = ( ! [N2: nat] :
            ( ( F @ ( snth @ B @ S @ N2 ) )
            = ( snth @ A @ S4 @ N2 ) ) ) ) )).

% smap_alt
thf(fact_88_exE__realizer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,P2: ( A > B > $o ),P: ( product_prod @ B @ A ),Q2: ( C > $o ),F: ( B > A > C )] :
      ( ( P2 @ ( product_snd @ B @ A @ P ) @ ( product_fst @ B @ A @ P ) )
     => ( ! [X3: B,Y4: A] :
            ( ( P2 @ Y4 @ X3 )
           => ( Q2 @ ( F @ X3 @ Y4 ) ) )
       => ( Q2 @ ( product_case_prod @ B @ A @ C @ F @ P ) ) ) ) )).

% exE_realizer
thf(fact_89_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_90_exI__realizer,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o ),Y: A,X2: B] :
      ( ( P2 @ Y @ X2 )
     => ( P2 @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) ) ) ) )).

% exI_realizer
thf(fact_91_conjI__realizer,axiom,(
    ! [A: $tType,B: $tType,P2: ( A > $o ),P: A,Q2: ( B > $o ),Q: B] :
      ( ( P2 @ P )
     => ( ( Q2 @ Q )
       => ( ( P2 @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P @ Q ) ) )
          & ( Q2 @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P @ Q ) ) ) ) ) ) )).

% conjI_realizer
thf(fact_92_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o ),X2: A,Y: B,A2: ( product_prod @ A @ B )] :
      ( ( P2 @ X2 @ Y )
     => ( ( A2
          = ( product_Pair @ A @ B @ X2 @ Y ) )
       => ( P2 @ ( product_fst @ A @ B @ A2 ) @ ( product_snd @ A @ B @ A2 ) ) ) ) )).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_93_smember__code,axiom,(
    ! [A: $tType,X2: A,Y: A,S: ( stream @ A )] :
      ( ( smember @ A @ X2 @ ( sCons @ A @ Y @ S ) )
      = ( ( X2 != Y )
       => ( smember @ A @ X2 @ S ) ) ) )).

% smember_code
thf(fact_94_apfst__convE,axiom,(
    ! [C: $tType,A: $tType,B: $tType,Q: ( product_prod @ A @ B ),F: ( C > A ),P: ( product_prod @ C @ B )] :
      ( ( Q
        = ( product_apfst @ C @ A @ B @ F @ P ) )
     => ~ ( ! [X3: C,Y4: B] :
              ( ( P
                = ( product_Pair @ C @ B @ X3 @ Y4 ) )
             => ( Q
               != ( product_Pair @ A @ B @ ( F @ X3 ) @ Y4 ) ) ) ) ) )).

% apfst_convE
thf(fact_95_exE__realizer_H,axiom,(
    ! [A: $tType,B: $tType,P2: ( A > B > $o ),P: ( product_prod @ B @ A )] :
      ( ( P2 @ ( product_snd @ B @ A @ P ) @ ( product_fst @ B @ A @ P ) )
     => ~ ( ! [X3: B,Y4: A] :
              ~ ( P2 @ Y4 @ X3 ) ) ) )).

% exE_realizer'
thf(fact_96_sndI,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ A @ B ),Y: A,Z: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y @ Z ) )
     => ( ( product_snd @ A @ B @ X2 )
        = Z ) ) )).

% sndI
thf(fact_97_eq__snd__iff,axiom,(
    ! [A: $tType,B: $tType,B2: A,P: ( product_prod @ B @ A )] :
      ( ( B2
        = ( product_snd @ B @ A @ P ) )
      = ( ? [A6: B] :
            ( P
            = ( product_Pair @ B @ A @ A6 @ B2 ) ) ) ) )).

% eq_snd_iff
thf(fact_98_fstI,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B ),Y: A,Z: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y @ Z ) )
     => ( ( product_fst @ A @ B @ X2 )
        = Y ) ) )).

% fstI
thf(fact_99_split__part,axiom,(
    ! [B: $tType,A: $tType,P2: $o,Q2: ( A > B > $o )] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A6: A,B5: B] :
            ( P2
            & ( Q2 @ A6 @ B5 ) ) )
      = ( ^ [Ab: ( product_prod @ A @ B )] :
            ( P2
            & ( product_case_prod @ A @ B @ $o @ Q2 @ Ab ) ) ) ) )).

% split_part
thf(fact_100_prod_Odisc__eq__case,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu: A,Uv: B] : $true
      @ Prod ) )).

% prod.disc_eq_case
thf(fact_101_eq__fst__iff,axiom,(
    ! [A: $tType,B: $tType,A2: A,P: ( product_prod @ A @ B )] :
      ( ( A2
        = ( product_fst @ A @ B @ P ) )
      = ( ? [B5: B] :
            ( P
            = ( product_Pair @ A @ B @ A2 @ B5 ) ) ) ) )).

% eq_fst_iff
thf(fact_102_case__prod__app,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F2: ( B > C > D > A ),X: ( product_prod @ B @ C ),Y3: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L: B,R2: C] :
                ( F2 @ L @ R2 @ Y3 )
            @ X ) ) ) )).

% case_prod_app
thf(fact_103_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q: ( product_prod @ A @ B ),F: ( A > B > C ),G: ( A > B > C ),P: ( product_prod @ A @ B )] :
      ( ! [X3: A,Y4: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y4 )
            = Q )
         => ( ( F @ X3 @ Y4 )
            = ( G @ X3 @ Y4 ) ) )
     => ( ( P = Q )
       => ( ( product_case_prod @ A @ B @ C @ F @ P )
          = ( product_case_prod @ A @ B @ C @ G @ Q ) ) ) ) )).

% split_cong
thf(fact_104_sproduct__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sproduct @ A @ B )
      = ( ^ [S1: ( stream @ A ),S2: ( stream @ B )] :
            ( smerge @ ( product_prod @ A @ B )
            @ ( smap @ A @ ( stream @ ( product_prod @ A @ B ) )
              @ ^ [X: A] :
                  ( smap @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ S2 )
              @ S1 ) ) ) ) )).

% sproduct_def
thf(fact_105_scomp__unfold,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F2: ( A > ( product_prod @ B @ C ) ),G4: ( B > C > D ),X: A] :
            ( G4 @ ( product_fst @ B @ C @ ( F2 @ X ) ) @ ( product_snd @ B @ C @ ( F2 @ X ) ) ) ) ) )).

% scomp_unfold
thf(fact_106_prod_Oswap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_swap @ A @ B )
      = ( ^ [P3: ( product_prod @ A @ B )] :
            ( product_Pair @ B @ A @ ( product_snd @ A @ B @ P3 ) @ ( product_fst @ A @ B @ P3 ) ) ) ) )).

% prod.swap_def
thf(fact_107_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P ) )
      = P ) )).

% swap_swap
thf(fact_108_scomp__apply,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_scomp @ B @ C @ D @ A )
      = ( ^ [F2: ( B > ( product_prod @ C @ D ) ),G4: ( C > D > A ),X: B] :
            ( product_case_prod @ C @ D @ A @ G4 @ ( F2 @ X ) ) ) ) )).

% scomp_apply
thf(fact_109_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X2 ) ) )).

% swap_simp
thf(fact_110_case__swap,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B > A ),P: ( product_prod @ C @ B )] :
      ( ( product_case_prod @ B @ C @ A
        @ ^ [Y3: B,X: C] :
            ( F @ X @ Y3 )
        @ ( product_swap @ C @ B @ P ) )
      = ( product_case_prod @ C @ B @ A @ F @ P ) ) )).

% case_swap
thf(fact_111_fst__swap,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ B @ A )] :
      ( ( product_fst @ A @ B @ ( product_swap @ B @ A @ X2 ) )
      = ( product_snd @ B @ A @ X2 ) ) )).

% fst_swap
thf(fact_112_snd__swap,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B )] :
      ( ( product_snd @ B @ A @ ( product_swap @ A @ B @ X2 ) )
      = ( product_fst @ A @ B @ X2 ) ) )).

% snd_swap
thf(fact_113_scomp__scomp,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F3: $tType,E: $tType,F: ( A > ( product_prod @ E @ F3 ) ),G: ( E > F3 > ( product_prod @ C @ D ) ),H: ( C > D > B )] :
      ( ( product_scomp @ A @ C @ D @ B @ ( product_scomp @ A @ E @ F3 @ ( product_prod @ C @ D ) @ F @ G ) @ H )
      = ( product_scomp @ A @ E @ F3 @ B @ F
        @ ^ [X: E] :
            ( product_scomp @ F3 @ C @ D @ B @ ( G @ X ) @ H ) ) ) )).

% scomp_scomp
thf(fact_114_scomp__Pair,axiom,(
    ! [C: $tType,B: $tType,A: $tType,X2: ( A > ( product_prod @ B @ C ) )] :
      ( ( product_scomp @ A @ B @ C @ ( product_prod @ B @ C ) @ X2 @ ( product_Pair @ B @ C ) )
      = X2 ) )).

% scomp_Pair
thf(fact_115_Pair__scomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X2: C,F: ( C > A > B )] :
      ( ( product_scomp @ A @ C @ A @ B @ ( product_Pair @ C @ A @ X2 ) @ F )
      = ( F @ X2 ) ) )).

% Pair_scomp
thf(fact_116_scomp__def,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( product_scomp @ A @ B @ C @ D )
      = ( ^ [F2: ( A > ( product_prod @ B @ C ) ),G4: ( B > C > D ),X: A] :
            ( product_case_prod @ B @ C @ D @ G4 @ ( F2 @ X ) ) ) ) )).

% scomp_def
thf(fact_117_case__prod__Pair__iden,axiom,(
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P )
      = P ) )).

% case_prod_Pair_iden
thf(fact_118_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_119_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) ),S5: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X: A,Y3: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ R ) )
        = ( ^ [X: A,Y3: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ S5 ) ) )
      = ( R = S5 ) ) )).

% pred_equals_eq2
thf(fact_120_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C2 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_121_The__case__prod,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > B > $o )] :
      ( ( the @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P2 ) )
      = ( the @ ( product_prod @ A @ B )
        @ ^ [Xy: ( product_prod @ A @ B )] :
            ( P2 @ ( product_fst @ A @ B @ Xy ) @ ( product_snd @ A @ B @ Xy ) ) ) ) )).

% The_case_prod
thf(fact_122_fstOp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_fstOp @ A @ B @ C )
      = ( ^ [P4: ( A > B > $o ),Q3: ( B > C > $o ),Ac: ( product_prod @ A @ C )] :
            ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Ac ) @ ( bNF_pick_middlep @ A @ B @ C @ P4 @ Q3 @ ( product_fst @ A @ C @ Ac ) @ ( product_snd @ A @ C @ Ac ) ) ) ) ) )).

% fstOp_def
thf(fact_123_The__split__eq,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X4: A,Y6: B] :
              ( ( X2 = X4 )
              & ( Y = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X2 @ Y ) ) )).

% The_split_eq
thf(fact_124_old_Orec__prod__def,axiom,(
    ! [T: $tType,B: $tType,A: $tType] :
      ( ( product_rec_prod @ A @ B @ T )
      = ( ^ [F12: ( A > B > T ),X: ( product_prod @ A @ B )] :
            ( the @ T @ ( product_rec_set_prod @ A @ B @ T @ F12 @ X ) ) ) ) )).

% old.rec_prod_def
thf(fact_125_the__sym__eq__trivial,axiom,(
    ! [A: $tType,X2: A] :
      ( ( the @ A
        @ ( ^ [Y5: A,Z2: A] : ( Y5 = Z2 )
          @ X2 ) )
      = X2 ) )).

% the_sym_eq_trivial
thf(fact_126_the__eq__trivial,axiom,(
    ! [A: $tType,A2: A] :
      ( ( the @ A
        @ ^ [X: A] : ( X = A2 ) )
      = A2 ) )).

% the_eq_trivial
thf(fact_127_the__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( P2 @ A2 )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( X3 = A2 ) )
       => ( ( the @ A @ P2 )
          = A2 ) ) ) )).

% the_equality
thf(fact_128_theI,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ( P2 @ A2 )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( X3 = A2 ) )
       => ( P2 @ ( the @ A @ P2 ) ) ) ) )).

% theI
thf(fact_129_theI_H,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X5 ) ) )
     => ( P2 @ ( the @ A @ P2 ) ) ) )).

% theI'
thf(fact_130_theI2,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A,Q2: ( A > $o )] :
      ( ( P2 @ A2 )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( X3 = A2 ) )
       => ( ! [X3: A] :
              ( ( P2 @ X3 )
             => ( Q2 @ X3 ) )
         => ( Q2 @ ( the @ A @ P2 ) ) ) ) ) )).

% theI2
thf(fact_131_If__def,axiom,(
    ! [A: $tType] :
      ( ( if @ A )
      = ( ^ [P4: $o,X: A,Y3: A] :
            ( the @ A
            @ ^ [Z3: A] :
                ( ( P4
                 => ( Z3 = X ) )
                & ( ~ ( P4 )
                 => ( Z3 = Y3 ) ) ) ) ) ) )).

% If_def
thf(fact_132_the1I2,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q2: ( A > $o )] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X5 ) ) )
     => ( ! [X3: A] :
            ( ( P2 @ X3 )
           => ( Q2 @ X3 ) )
       => ( Q2 @ ( the @ A @ P2 ) ) ) ) )).

% the1I2
thf(fact_133_the1__equality,axiom,(
    ! [A: $tType,P2: ( A > $o ),A2: A] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X5 ) ) )
     => ( ( P2 @ A2 )
       => ( ( the @ A @ P2 )
          = A2 ) ) ) )).

% the1_equality
thf(fact_134_sndOp__def,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( bNF_sndOp @ C @ A @ B )
      = ( ^ [P4: ( C > A > $o ),Q3: ( A > B > $o ),Ac: ( product_prod @ C @ B )] :
            ( product_Pair @ A @ B @ ( bNF_pick_middlep @ C @ A @ B @ P4 @ Q3 @ ( product_fst @ C @ B @ Ac ) @ ( product_snd @ C @ B @ Ac ) ) @ ( product_snd @ C @ B @ Ac ) ) ) ) )).

% sndOp_def
thf(fact_135_inv__image__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( inv_image @ B @ A )
      = ( ^ [R2: ( set @ ( product_prod @ B @ B ) ),F2: ( A > B )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X: A,Y3: A] :
                  ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ X ) @ ( F2 @ Y3 ) ) @ R2 ) ) ) ) ) )).

% inv_image_def
thf(fact_136_fst__snd__flip,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X: A,Y3: B] :
              ( product_Pair @ B @ A @ Y3 @ X ) ) ) ) )).

% fst_snd_flip
thf(fact_137_snd__fst__flip,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X: B,Y3: A] :
              ( product_Pair @ A @ B @ Y3 @ X ) ) ) ) )).

% snd_fst_flip
thf(fact_138_in__inv__image,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y: A,R3: ( set @ ( product_prod @ B @ B ) ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ ( inv_image @ B @ A @ R3 @ F ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X2 ) @ ( F @ Y ) ) @ R3 ) ) )).

% in_inv_image
thf(fact_139_snd__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( product_snd @ A @ B ) ) )).

% snd_comp_apfst
thf(fact_140_fst__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( product_fst @ A @ B ) ) )).

% fst_comp_apsnd
thf(fact_141_fst__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ B ) @ ( product_apfst @ A @ C @ B @ F ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_apfst
thf(fact_142_snd__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ F @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_apsnd
thf(fact_143_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G: ( C > B ),X2: C,F5: ( D > A ),G5: ( E > D ),X6: E] :
      ( ( ( F @ ( G @ X2 ) )
        = ( F5 @ ( G5 @ X6 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ E @ F5 @ G5 @ X6 ) ) ) )).

% comp_cong
thf(fact_144_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L2: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L2 )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L2 @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_145_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R3: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R3 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R3 ) ) ) )).

% rewriteR_comp_comp
thf(fact_146_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L22: ( A > D ),H: ( E > A ),R3: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L22 ) )
     => ( ( ( comp @ A @ D @ E @ L22 @ H )
          = R3 )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R3 ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_147_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R22: ( A > D ),F: ( B > E ),L2: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R1 )
          = L2 )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L2 @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_148_stream_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( B > C ),F: ( A > B ),V: ( stream @ A )] :
      ( ( smap @ B @ C @ G @ ( smap @ A @ B @ F @ V ) )
      = ( smap @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% stream.map_comp
thf(fact_149_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X2: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X2 ) )
        = ( H @ ( K @ X2 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ C @ H @ K @ X2 ) ) ) )).

% comp_apply_eq
thf(fact_150_snd__sndOp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: ( B > C > $o ),Q2: ( C > A > $o )] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ C @ A ) @ A @ ( product_prod @ B @ A ) @ ( product_snd @ C @ A ) @ ( bNF_sndOp @ B @ C @ A @ P2 @ Q2 ) ) ) )).

% snd_sndOp
thf(fact_151_apsnd__compose,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F: ( C > B ),G: ( D > C ),X2: ( product_prod @ A @ D )] :
      ( ( product_apsnd @ C @ B @ A @ F @ ( product_apsnd @ D @ C @ A @ G @ X2 ) )
      = ( product_apsnd @ D @ B @ A @ ( comp @ C @ B @ D @ F @ G ) @ X2 ) ) )).

% apsnd_compose
thf(fact_152_apfst__compose,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G: ( D > C ),X2: ( product_prod @ D @ B )] :
      ( ( product_apfst @ C @ A @ B @ F @ ( product_apfst @ D @ C @ B @ G @ X2 ) )
      = ( product_apfst @ D @ A @ B @ ( comp @ C @ A @ D @ F @ G ) @ X2 ) ) )).

% apfst_compose
thf(fact_153_fst__fstOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P2: ( A > C > $o ),Q2: ( C > B > $o )] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q2 ) ) ) )).

% fst_fstOp
thf(fact_154_rp__inv__image__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R4: ( set @ ( product_prod @ A @ A ) ),S6: ( set @ ( product_prod @ A @ A ) ),F2: ( B > A )] :
            ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R4 @ F2 ) @ ( inv_image @ A @ B @ S6 @ F2 ) ) ) ) )).

% rp_inv_image_def
thf(fact_155_convol__expand__snd_H,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > ( product_prod @ B @ C ) ),G: ( A > B ),H: ( A > C )] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F )
        = G )
     => ( ( H
          = ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) )
        = ( ( bNF_convol @ A @ B @ C @ G @ H )
          = F ) ) ) )).

% convol_expand_snd'
thf(fact_156_convol__expand__snd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > ( product_prod @ B @ C ) ),G: ( A > B )] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F )
        = G )
     => ( ( bNF_convol @ A @ B @ C @ G @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F ) )
        = F ) ) )).

% convol_expand_snd
thf(fact_157_Collect__case__prod__Grp__eqD,axiom,(
    ! [B: $tType,A: $tType,Z: ( product_prod @ A @ B ),A5: ( set @ A ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Z @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A5 @ F ) ) ) )
     => ( ( comp @ A @ B @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) @ Z )
        = ( product_snd @ A @ B @ Z ) ) ) )).

% Collect_case_prod_Grp_eqD
thf(fact_158_GrpI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),X2: B,Y: A,A5: ( set @ B )] :
      ( ( ( F @ X2 )
        = Y )
     => ( ( member @ B @ X2 @ A5 )
       => ( bNF_Grp @ B @ A @ A5 @ F @ X2 @ Y ) ) ) )).

% GrpI
thf(fact_159_GrpE,axiom,(
    ! [B: $tType,A: $tType,A5: ( set @ A ),F: ( A > B ),X2: A,Y: B] :
      ( ( bNF_Grp @ A @ B @ A5 @ F @ X2 @ Y )
     => ~ ( ( ( F @ X2 )
            = Y )
         => ~ ( member @ A @ X2 @ A5 ) ) ) )).

% GrpE
thf(fact_160_Grp__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Grp @ A @ B )
      = ( ^ [A7: ( set @ A ),F2: ( A > B ),A6: A,B5: B] :
            ( ( B5
              = ( F2 @ A6 ) )
            & ( member @ A @ A6 @ A7 ) ) ) ) )).

% Grp_def
thf(fact_161_convol__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_convol @ A @ B @ C )
      = ( ^ [F2: ( A > B ),G4: ( A > C ),A6: A] :
            ( product_Pair @ B @ C @ ( F2 @ A6 ) @ ( G4 @ A6 ) ) ) ) )).

% convol_def
thf(fact_162_convol__o,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType,F: ( D > B ),G: ( D > C ),H: ( A > D )] :
      ( ( comp @ D @ ( product_prod @ B @ C ) @ A @ ( bNF_convol @ D @ B @ C @ F @ G ) @ H )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ F @ H ) @ ( comp @ D @ C @ A @ G @ H ) ) ) )).

% convol_o
thf(fact_163_fst__convol_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > A ),G: ( C > B ),X2: C] :
      ( ( product_fst @ A @ B @ ( bNF_convol @ C @ A @ B @ F @ G @ X2 ) )
      = ( F @ X2 ) ) )).

% fst_convol'
thf(fact_164_snd__convol_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > B ),G: ( C > A ),X2: C] :
      ( ( product_snd @ B @ A @ ( bNF_convol @ C @ B @ A @ F @ G @ X2 ) )
      = ( G @ X2 ) ) )).

% snd_convol'
thf(fact_165_Collect__case__prod__Grp__in,axiom,(
    ! [B: $tType,A: $tType,Z: ( product_prod @ A @ B ),A5: ( set @ A ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Z @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A5 @ F ) ) ) )
     => ( member @ A @ ( product_fst @ A @ B @ Z ) @ A5 ) ) )).

% Collect_case_prod_Grp_in
thf(fact_166_case__prod__comp,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F: ( D > C > A ),G: ( B > D ),X2: ( product_prod @ B @ C )] :
      ( ( product_case_prod @ B @ C @ A @ ( comp @ D @ ( C > A ) @ B @ F @ G ) @ X2 )
      = ( F @ ( G @ ( product_fst @ B @ C @ X2 ) ) @ ( product_snd @ B @ C @ X2 ) ) ) )).

% case_prod_comp
thf(fact_167_fst__convol,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( A > C )] :
      ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ ( bNF_convol @ A @ B @ C @ F @ G ) )
      = F ) )).

% fst_convol
thf(fact_168_snd__convol,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > C ),G: ( A > B )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ A @ ( product_snd @ C @ B ) @ ( bNF_convol @ A @ C @ B @ F @ G ) )
      = G ) )).

% snd_convol
thf(fact_169_fst__diag__fst,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X: A] :
              ( product_Pair @ A @ A @ X @ X )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) )).

% fst_diag_fst
thf(fact_170_snd__diag__snd,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X: B] :
              ( product_Pair @ B @ B @ X @ X )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) )).

% snd_diag_snd
thf(fact_171_fst__diag__snd,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X: B] :
              ( product_Pair @ B @ B @ X @ X )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) )).

% fst_diag_snd
thf(fact_172_snd__diag__fst,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X: A] :
              ( product_Pair @ A @ A @ X @ X )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) )).

% snd_diag_fst
thf(fact_173_rp__inv__image__rp,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ),F: ( B > A )] :
      ( ( fun_reduction_pair @ A @ P2 )
     => ( fun_reduction_pair @ B @ ( fun_rp_inv_image @ A @ B @ P2 @ F ) ) ) )).

% rp_inv_image_rp
thf(fact_174_K__record__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,C2: B,F: ( A > C )] :
      ( ( comp @ C @ B @ A
        @ ^ [X: C] : C2
        @ F )
      = ( ^ [X: A] : C2 ) ) )).

% K_record_comp
thf(fact_175_fun_Omap__ident,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D
        @ ^ [X: A] : X
        @ T2 )
      = T2 ) )).

% fun.map_ident
thf(fact_176_snd__comp__map__prod,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: ( A > D ),G: ( B > C )] :
      ( ( comp @ ( product_prod @ D @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ D @ C ) @ ( product_map_prod @ A @ D @ B @ C @ F @ G ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ G @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_map_prod
thf(fact_177_fst__comp__map__prod,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: ( A > C ),G: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F @ G ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_map_prod
thf(fact_178_old_Orec__unit__def,axiom,(
    ! [T: $tType] :
      ( ( product_rec_unit @ T )
      = ( ^ [F12: T,X: product_unit] :
            ( the @ T @ ( product_rec_set_unit @ T @ F12 @ X ) ) ) ) )).

% old.rec_unit_def
thf(fact_179_map__prod__ident,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X: A] : X
        @ ^ [Y3: B] : Y3 )
      = ( ^ [Z3: ( product_prod @ A @ B )] : Z3 ) ) )).

% map_prod_ident
thf(fact_180_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F: ( C > A ),G: ( D > B ),A2: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F @ G @ ( product_Pair @ C @ D @ A2 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F @ A2 ) @ ( G @ B2 ) ) ) )).

% map_prod_simp
thf(fact_181_fst__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( C > A ),G: ( D > B ),X2: ( product_prod @ C @ D )] :
      ( ( product_fst @ A @ B @ ( product_map_prod @ C @ A @ D @ B @ F @ G @ X2 ) )
      = ( F @ ( product_fst @ C @ D @ X2 ) ) ) )).

% fst_map_prod
thf(fact_182_snd__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( C > B ),G: ( D > A ),X2: ( product_prod @ C @ D )] :
      ( ( product_snd @ B @ A @ ( product_map_prod @ C @ B @ D @ A @ F @ G @ X2 ) )
      = ( G @ ( product_snd @ C @ D @ X2 ) ) ) )).

% snd_map_prod
thf(fact_183_map__prod_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E: $tType,F3: $tType,D: $tType,B: $tType,F: ( C > E ),G: ( D > F3 ),H: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ ( product_prod @ E @ F3 ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ E @ D @ F3 @ F @ G ) @ ( product_map_prod @ A @ C @ B @ D @ H @ I ) )
      = ( product_map_prod @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ F @ H ) @ ( comp @ D @ F3 @ B @ G @ I ) ) ) )).

% map_prod.comp
thf(fact_184_map__prod__compose,axiom,(
    ! [D: $tType,C: $tType,A: $tType,E: $tType,F3: $tType,B: $tType,F1: ( E > C ),F22: ( A > E ),G1: ( F3 > D ),G22: ( B > F3 )] :
      ( ( product_map_prod @ A @ C @ B @ D @ ( comp @ E @ C @ A @ F1 @ F22 ) @ ( comp @ F3 @ D @ B @ G1 @ G22 ) )
      = ( comp @ ( product_prod @ E @ F3 ) @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ E @ C @ F3 @ D @ F1 @ G1 ) @ ( product_map_prod @ A @ E @ B @ F3 @ F22 @ G22 ) ) ) )).

% map_prod_compose
thf(fact_185_map__prod_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F: ( C > E ),G: ( D > F3 ),H: ( A > C ),I: ( B > D ),Prod: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F3 @ F @ G @ ( product_map_prod @ A @ C @ B @ D @ H @ I @ Prod ) )
      = ( product_map_prod @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ F @ H ) @ ( comp @ D @ F3 @ B @ G @ I ) @ Prod ) ) )).

% map_prod.compositionality
thf(fact_186_prod_Omap__ident,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X: A] : X
        @ ^ [X: B] : X
        @ T2 )
      = T2 ) )).

% prod.map_ident
thf(fact_187_case__prod__map__prod,axiom,(
    ! [C: $tType,A: $tType,B: $tType,E: $tType,D: $tType,H: ( B > C > A ),F: ( D > B ),G: ( E > C ),X2: ( product_prod @ D @ E )] :
      ( ( product_case_prod @ B @ C @ A @ H @ ( product_map_prod @ D @ B @ E @ C @ F @ G @ X2 ) )
      = ( product_case_prod @ D @ E @ A
        @ ^ [L: D,R2: E] :
            ( H @ ( F @ L ) @ ( G @ R2 ) )
        @ X2 ) ) )).

% case_prod_map_prod
thf(fact_188_map__prod__o__convol,axiom,(
    ! [D: $tType,B: $tType,C: $tType,E: $tType,A: $tType,H1: ( D > B ),H2: ( E > C ),F: ( A > D ),G: ( A > E )] :
      ( ( comp @ ( product_prod @ D @ E ) @ ( product_prod @ B @ C ) @ A @ ( product_map_prod @ D @ B @ E @ C @ H1 @ H2 ) @ ( bNF_convol @ A @ D @ E @ F @ G ) )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ H1 @ F ) @ ( comp @ E @ C @ A @ H2 @ G ) ) ) )).

% map_prod_o_convol
thf(fact_189_map__prod__def,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( product_map_prod @ A @ C @ B @ D )
      = ( ^ [F2: ( A > C ),G4: ( B > D )] :
            ( product_case_prod @ A @ B @ ( product_prod @ C @ D )
            @ ^ [X: A,Y3: B] :
                ( product_Pair @ C @ D @ ( F2 @ X ) @ ( G4 @ Y3 ) ) ) ) ) )).

% map_prod_def
thf(fact_190_case__prod__o__map__prod,axiom,(
    ! [B: $tType,D: $tType,C: $tType,E: $tType,A: $tType,F: ( D > E > C ),G1: ( A > D ),G22: ( B > E )] :
      ( ( comp @ ( product_prod @ D @ E ) @ C @ ( product_prod @ A @ B ) @ ( product_case_prod @ D @ E @ C @ F ) @ ( product_map_prod @ A @ D @ B @ E @ G1 @ G22 ) )
      = ( product_case_prod @ A @ B @ C
        @ ^ [L: A,R2: B] :
            ( F @ ( G1 @ L ) @ ( G22 @ R2 ) ) ) ) )).

% case_prod_o_map_prod
thf(fact_191_prod_Osize__gen__o__map,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( C > nat ),Fa: ( D > nat ),G: ( A > C ),Ga: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ nat @ ( product_prod @ A @ B ) @ ( basic_BNF_size_prod @ C @ D @ F @ Fa ) @ ( product_map_prod @ A @ C @ B @ D @ G @ Ga ) )
      = ( basic_BNF_size_prod @ A @ B @ ( comp @ C @ nat @ A @ F @ G ) @ ( comp @ D @ nat @ B @ Fa @ Ga ) ) ) )).

% prod.size_gen_o_map
thf(fact_192_Nitpick_OThe__psimp,axiom,(
    ! [A: $tType,P2: ( A > $o ),X2: A] :
      ( ( P2
        = ( ^ [Y5: A,Z2: A] : ( Y5 = Z2 )
          @ X2 ) )
     => ( ( the @ A @ P2 )
        = X2 ) ) )).

% Nitpick.The_psimp
thf(fact_193_theI__unique,axiom,(
    ! [A: $tType,P2: ( A > $o ),X2: A] :
      ( ? [X5: A] :
          ( ( P2 @ X5 )
          & ! [Y4: A] :
              ( ( P2 @ Y4 )
             => ( Y4 = X5 ) ) )
     => ( ( P2 @ X2 )
        = ( X2
          = ( the @ A @ P2 ) ) ) ) )).

% theI_unique
thf(fact_194_same__fst__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P4: ( A > $o ),R4: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X4: A,Y6: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X: A,Y3: B] :
                        ( ( X4 = X )
                        & ( P4 @ X )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y3 ) @ ( R4 @ X ) ) ) ) ) ) ) ) ) )).

% same_fst_def
thf(fact_195_same__fstI,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),X2: A,Y7: B,Y: B,R: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ( P2 @ X2 )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y7 @ Y ) @ ( R @ X2 ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y7 ) @ ( product_Pair @ A @ B @ X2 @ Y ) ) @ ( same_fst @ A @ B @ P2 @ R ) ) ) ) )).

% same_fstI
thf(fact_196_lex__prod__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: ( set @ ( product_prod @ A @ A ) ),Rb: ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A6: A,B5: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A8: A,B6: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A6 @ A8 ) @ Ra )
                        | ( ( A6 = A8 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B5 @ B6 ) @ Rb ) ) ) ) ) ) ) ) ) )).

% lex_prod_def
thf(fact_197_map__prod__o__convol__id,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( C > A ),G: ( C > B ),X2: C] :
      ( ( comp @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B ) @ C @ ( product_map_prod @ C @ A @ B @ B @ F @ ( id @ B ) ) @ ( bNF_convol @ C @ C @ B @ ( id @ C ) @ G ) @ X2 )
      = ( bNF_convol @ C @ A @ B @ ( comp @ A @ A @ C @ ( id @ A ) @ F ) @ G @ X2 ) ) )).

% map_prod_o_convol_id
thf(fact_198_case__prod__Pair,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% case_prod_Pair
thf(fact_199_apfst__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_apfst @ A @ A @ B @ ( id @ A ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% apfst_id
thf(fact_200_apsnd__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_apsnd @ B @ B @ A @ ( id @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% apsnd_id
thf(fact_201_swap__comp__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( product_swap @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% swap_comp_swap
thf(fact_202_in__lex__prod,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A3: A,B3: B,R3: ( set @ ( product_prod @ A @ A ) ),S: ( set @ ( product_prod @ B @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Pair @ A @ B @ A3 @ B3 ) ) @ ( lex_prod @ A @ B @ R3 @ S ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A3 ) @ R3 )
        | ( ( A2 = A3 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B3 ) @ S ) ) ) ) )).

% in_lex_prod
thf(fact_203_map__prod_Oidentity,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B
        @ ^ [X: A] : X
        @ ^ [X: B] : X )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% map_prod.identity
thf(fact_204_stream_Omap__id0,axiom,(
    ! [A: $tType] :
      ( ( smap @ A @ A @ ( id @ A ) )
      = ( id @ ( stream @ A ) ) ) )).

% stream.map_id0
thf(fact_205_stream_Omap__id,axiom,(
    ! [A: $tType,T2: ( stream @ A )] :
      ( ( smap @ A @ A @ ( id @ A ) @ T2 )
      = T2 ) )).

% stream.map_id
thf(fact_206_apsnd__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( product_apsnd @ B @ C @ A )
      = ( product_map_prod @ A @ A @ B @ C @ ( id @ A ) ) ) )).

% apsnd_def
thf(fact_207_apfst__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( product_apfst @ A @ C @ B )
      = ( ^ [F2: ( A > C )] :
            ( product_map_prod @ A @ C @ B @ B @ F2 @ ( id @ B ) ) ) ) )).

% apfst_def
thf(fact_208_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),G: ( A > B ),X2: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X2 ) )
        = X2 ) ) )).

% pointfree_idE
thf(fact_209_convol__mem__GrpI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( set @ A ),G: ( A > B )] :
      ( ( member @ A @ X2 @ A5 )
     => ( member @ ( product_prod @ A @ B ) @ ( bNF_convol @ A @ A @ B @ ( id @ A ) @ G @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A5 @ G ) ) ) ) ) )).

% convol_mem_GrpI
thf(fact_210_fst__diag__id,axiom,(
    ! [A: $tType,Z: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_fst @ A @ A )
        @ ^ [X: A] :
            ( product_Pair @ A @ A @ X @ X )
        @ Z )
      = ( id @ A @ Z ) ) )).

% fst_diag_id
thf(fact_211_snd__diag__id,axiom,(
    ! [A: $tType,Z: A] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ A @ ( product_snd @ A @ A )
        @ ^ [X: A] :
            ( product_Pair @ A @ A @ X @ X )
        @ Z )
      = ( id @ A @ Z ) ) )).

% snd_diag_id
thf(fact_212_csquare__fstOp__sndOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( ( A > B > $o ) > ( product_prod @ A @ B ) > $o ),P2: ( A > C > $o ),Q2: ( C > B > $o )] :
      ( bNF_csquare @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) @ C @ ( product_prod @ C @ B ) @ ( collect @ ( product_prod @ A @ B ) @ ( F @ ( relcompp @ A @ C @ B @ P2 @ Q2 ) ) ) @ ( product_snd @ A @ C ) @ ( product_fst @ C @ B ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q2 ) @ ( bNF_sndOp @ A @ C @ B @ P2 @ Q2 ) ) )).

% csquare_fstOp_sndOp
thf(fact_213_smap__unfold__stream,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),SHD: ( C > B ),STL: ( C > C ),B2: C] :
      ( ( smap @ B @ A @ F @ ( coindu139217191stream @ C @ B @ SHD @ STL @ B2 ) )
      = ( coindu139217191stream @ C @ A @ ( comp @ B @ A @ C @ F @ SHD ) @ STL @ B2 ) ) )).

% smap_unfold_stream
thf(fact_214_unfold__stream__eq__SCons,axiom,(
    ! [A: $tType,B: $tType,SHD: ( B > A ),STL: ( B > B ),B2: B,X2: A,Xs: ( stream @ A )] :
      ( ( ( coindu139217191stream @ B @ A @ SHD @ STL @ B2 )
        = ( sCons @ A @ X2 @ Xs ) )
      = ( ( X2
          = ( SHD @ B2 ) )
        & ( Xs
          = ( coindu139217191stream @ B @ A @ SHD @ STL @ ( STL @ B2 ) ) ) ) ) )).

% unfold_stream_eq_SCons
thf(fact_215_unfold__stream__ltl__unroll,axiom,(
    ! [A: $tType,B: $tType,SHD: ( B > A ),STL: ( B > B ),B2: B] :
      ( ( coindu139217191stream @ B @ A @ SHD @ STL @ ( STL @ B2 ) )
      = ( coindu139217191stream @ B @ A @ ( comp @ B @ A @ B @ SHD @ STL ) @ STL @ B2 ) ) )).

% unfold_stream_ltl_unroll
thf(fact_216_unfold__stream_Ocode,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( coindu139217191stream @ A @ B )
      = ( ^ [G12: ( A > B ),G23: ( A > A ),A6: A] :
            ( sCons @ B @ ( G12 @ A6 ) @ ( coindu139217191stream @ A @ B @ G12 @ G23 @ ( G23 @ A6 ) ) ) ) ) )).

% unfold_stream.code
thf(fact_217_csquare__def,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType] :
      ( ( bNF_csquare @ A @ B @ C @ D )
      = ( ^ [A7: ( set @ A ),F12: ( B > C ),F23: ( D > C ),P1: ( A > B ),P22: ( A > D )] :
          ! [X: A] :
            ( ( member @ A @ X @ A7 )
           => ( ( F12 @ ( P1 @ X ) )
              = ( F23 @ ( P22 @ X ) ) ) ) ) ) )).

% csquare_def
thf(fact_218_pick__middlep,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: ( A > B > $o ),Q2: ( B > C > $o ),A2: A,C2: C] :
      ( ( relcompp @ A @ B @ C @ P2 @ Q2 @ A2 @ C2 )
     => ( ( P2 @ A2 @ ( bNF_pick_middlep @ A @ B @ C @ P2 @ Q2 @ A2 @ C2 ) )
        & ( Q2 @ ( bNF_pick_middlep @ A @ B @ C @ P2 @ Q2 @ A2 @ C2 ) @ C2 ) ) ) )).

% pick_middlep
thf(fact_219_relcompp_OrelcompI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R3: ( A > B > $o ),A2: A,B2: B,S: ( B > C > $o ),C2: C] :
      ( ( R3 @ A2 @ B2 )
     => ( ( S @ B2 @ C2 )
       => ( relcompp @ A @ B @ C @ R3 @ S @ A2 @ C2 ) ) ) )).

% relcompp.relcompI
thf(fact_220_relcompp_Oinducts,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R3: ( A > B > $o ),S: ( B > C > $o ),X1: A,X22: C,P2: ( A > C > $o )] :
      ( ( relcompp @ A @ B @ C @ R3 @ S @ X1 @ X22 )
     => ( ! [A4: A,B4: B,C3: C] :
            ( ( R3 @ A4 @ B4 )
           => ( ( S @ B4 @ C3 )
             => ( P2 @ A4 @ C3 ) ) )
       => ( P2 @ X1 @ X22 ) ) ) )).

% relcompp.inducts
thf(fact_221_relcompp__assoc,axiom,(
    ! [A: $tType,D: $tType,B: $tType,C: $tType,R3: ( A > D > $o ),S: ( D > C > $o ),T2: ( C > B > $o )] :
      ( ( relcompp @ A @ C @ B @ ( relcompp @ A @ D @ C @ R3 @ S ) @ T2 )
      = ( relcompp @ A @ D @ B @ R3 @ ( relcompp @ D @ C @ B @ S @ T2 ) ) ) )).

% relcompp_assoc
thf(fact_222_relcompp__apply,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcompp @ A @ B @ C )
      = ( ^ [R4: ( A > B > $o ),S6: ( B > C > $o ),A6: A,C4: C] :
          ? [B5: B] :
            ( ( R4 @ A6 @ B5 )
            & ( S6 @ B5 @ C4 ) ) ) ) )).

% relcompp_apply
thf(fact_223_relcompp_Osimps,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcompp @ A @ B @ C )
      = ( ^ [R2: ( A > B > $o ),S3: ( B > C > $o ),A1: A,A22: C] :
          ? [A6: A,B5: B,C4: C] :
            ( ( A1 = A6 )
            & ( A22 = C4 )
            & ( R2 @ A6 @ B5 )
            & ( S3 @ B5 @ C4 ) ) ) ) )).

% relcompp.simps
thf(fact_224_relcompp_Ocases,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R3: ( A > B > $o ),S: ( B > C > $o ),A12: A,A23: C] :
      ( ( relcompp @ A @ B @ C @ R3 @ S @ A12 @ A23 )
     => ~ ( ! [B4: B] :
              ( ( R3 @ A12 @ B4 )
             => ~ ( S @ B4 @ A23 ) ) ) ) )).

% relcompp.cases
thf(fact_225_relcomppE,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R3: ( A > B > $o ),S: ( B > C > $o ),A2: A,C2: C] :
      ( ( relcompp @ A @ B @ C @ R3 @ S @ A2 @ C2 )
     => ~ ( ! [B4: B] :
              ( ( R3 @ A2 @ B4 )
             => ~ ( S @ B4 @ C2 ) ) ) ) )).

% relcomppE
thf(fact_226_eq__OO,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( relcompp @ A @ A @ B
        @ ^ [Y5: A,Z2: A] : ( Y5 = Z2 )
        @ R )
      = R ) )).

% eq_OO
thf(fact_227_OO__eq,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( relcompp @ A @ B @ B @ R
        @ ^ [Y5: B,Z2: B] : ( Y5 = Z2 ) )
      = R ) )).

% OO_eq
thf(fact_228_fstOp__in,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Ac2: ( product_prod @ A @ B ),P2: ( A > C > $o ),Q2: ( C > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ Ac2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( relcompp @ A @ C @ B @ P2 @ Q2 ) ) ) )
     => ( member @ ( product_prod @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P2 @ Q2 @ Ac2 ) @ ( collect @ ( product_prod @ A @ C ) @ ( product_case_prod @ A @ C @ $o @ P2 ) ) ) ) )).

% fstOp_in
thf(fact_229_sndOp__in,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Ac2: ( product_prod @ A @ B ),P2: ( A > C > $o ),Q2: ( C > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ Ac2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( relcompp @ A @ C @ B @ P2 @ Q2 ) ) ) )
     => ( member @ ( product_prod @ C @ B ) @ ( bNF_sndOp @ A @ C @ B @ P2 @ Q2 @ Ac2 ) @ ( collect @ ( product_prod @ C @ B ) @ ( product_case_prod @ C @ B @ $o @ Q2 ) ) ) ) )).

% sndOp_in
thf(fact_230_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B2: A,F: ( B > A ),X2: B,C2: C,G: ( B > C ),A5: ( set @ B )] :
      ( ( B2
        = ( F @ X2 ) )
     => ( ( C2
          = ( G @ X2 ) )
       => ( ( member @ B @ X2 @ A5 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A5 @ F @ G ) ) ) ) ) )).

% image2_eqI
thf(fact_231_old_Orec__bool__def,axiom,(
    ! [T: $tType] :
      ( ( product_rec_bool @ T )
      = ( ^ [F12: T,F23: T,X: $o] :
            ( the @ T @ ( product_rec_set_bool @ T @ F12 @ F23 @ X ) ) ) ) )).

% old.rec_bool_def
thf(fact_232_old_Obool_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F22: T] :
      ( ( product_rec_bool @ T @ F1 @ F22 @ $false )
      = F22 ) )).

% old.bool.simps(6)
thf(fact_233_old_Obool_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F22: T] :
      ( ( product_rec_bool @ T @ F1 @ F22 @ $true )
      = F1 ) )).

% old.bool.simps(5)
thf(fact_234_smap__corec__stream,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),SHD: ( C > B ),EndORmore: ( C > $o ),STL_end: ( C > ( stream @ B ) ),STL_more: ( C > C ),B2: C] :
      ( ( smap @ B @ A @ F @ ( corec_stream @ C @ B @ SHD @ EndORmore @ STL_end @ STL_more @ B2 ) )
      = ( corec_stream @ C @ A @ ( comp @ B @ A @ C @ F @ SHD ) @ EndORmore @ ( comp @ ( stream @ B ) @ ( stream @ A ) @ C @ ( smap @ B @ A @ F ) @ STL_end ) @ STL_more @ B2 ) ) )).

% smap_corec_stream
thf(fact_235_stream_Omap__o__corec,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > A ),Ga: ( C > $o ),Gb: ( C > ( stream @ A ) ),Gc: ( C > C )] :
      ( ( comp @ ( stream @ A ) @ ( stream @ B ) @ C @ ( smap @ A @ B @ F ) @ ( corec_stream @ C @ A @ G @ Ga @ Gb @ Gc ) )
      = ( corec_stream @ C @ B @ ( comp @ A @ B @ C @ F @ G ) @ Ga @ ( comp @ ( stream @ A ) @ ( stream @ B ) @ C @ ( smap @ A @ B @ F ) @ Gb ) @ Gc ) ) )).

% stream.map_o_corec
thf(fact_236_stream_Ocorec__code,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( corec_stream @ C @ A )
      = ( ^ [G12: ( C > A ),Q22: ( C > $o ),G21: ( C > ( stream @ A ) ),G222: ( C > C ),A6: C] :
            ( sCons @ A @ ( G12 @ A6 ) @ ( if @ ( stream @ A ) @ ( Q22 @ A6 ) @ ( G21 @ A6 ) @ ( corec_stream @ C @ A @ G12 @ Q22 @ G21 @ G222 @ ( G222 @ A6 ) ) ) ) ) ) )).

% stream.corec_code
thf(fact_237_stream_Ocorec__disc,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( corec_stream @ C @ A )
      = ( corec_stream @ C @ A ) ) )).

% stream.corec_disc
thf(fact_238_relcomp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcomp @ A @ B @ C )
      = ( ^ [R2: ( set @ ( product_prod @ A @ B ) ),S3: ( set @ ( product_prod @ B @ C ) )] :
            ( collect @ ( product_prod @ A @ C )
            @ ( product_case_prod @ A @ C @ $o
              @ ( relcompp @ A @ B @ C
                @ ^ [X: A,Y3: B] :
                    ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ R2 )
                @ ^ [X: B,Y3: C] :
                    ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ X @ Y3 ) @ S3 ) ) ) ) ) ) )).

% relcomp_def
thf(fact_239_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R3: A,S: B,R: ( set @ ( product_prod @ A @ B ) ),S4: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R3 @ S ) @ R )
     => ( ( S4 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R3 @ S4 ) @ R ) ) ) )).

% ssubst_Pair_rhs
thf(fact_240_relcompp__relcomp__eq,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R3: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ B @ C ) )] :
      ( ( relcompp @ A @ B @ C
        @ ^ [X: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ R3 )
        @ ^ [X: B,Y3: C] :
            ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ X @ Y3 ) @ S ) )
      = ( ^ [X: A,Y3: C] :
            ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X @ Y3 ) @ ( relcomp @ A @ B @ C @ R3 @ S ) ) ) ) )).

% relcompp_relcomp_eq
thf(fact_241_relcomp_OrelcompI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: A,B2: B,R3: ( set @ ( product_prod @ A @ B ) ),C2: C,S: ( set @ ( product_prod @ B @ C ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R3 )
     => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B2 @ C2 ) @ S )
       => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ C2 ) @ ( relcomp @ A @ B @ C @ R3 @ S ) ) ) ) )).

% relcomp.relcompI
thf(fact_242_relcomp_Oinducts,axiom,(
    ! [B: $tType,A: $tType,C: $tType,X1: A,X22: C,R3: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ B @ C ) ),P2: ( A > C > $o )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X1 @ X22 ) @ ( relcomp @ A @ B @ C @ R3 @ S ) )
     => ( ! [A4: A,B4: B,C3: C] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B4 ) @ R3 )
           => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B4 @ C3 ) @ S )
             => ( P2 @ A4 @ C3 ) ) )
       => ( P2 @ X1 @ X22 ) ) ) )).

% relcomp.inducts
thf(fact_243_relcomp_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,A12: A,A23: C,R3: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ B @ C ) )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A12 @ A23 ) @ ( relcomp @ A @ B @ C @ R3 @ S ) )
      = ( ? [A6: A,B5: B,C4: C] :
            ( ( A12 = A6 )
            & ( A23 = C4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A6 @ B5 ) @ R3 )
            & ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B5 @ C4 ) @ S ) ) ) ) )).

% relcomp.simps
thf(fact_244_relcomp_Ocases,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A12: A,A23: C,R3: ( set @ ( product_prod @ A @ B ) ),S: ( set @ ( product_prod @ B @ C ) )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A12 @ A23 ) @ ( relcomp @ A @ B @ C @ R3 @ S ) )
     => ~ ( ! [B4: B] :
              ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B4 ) @ R3 )
             => ~ ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B4 @ A23 ) @ S ) ) ) ) )).

% relcomp.cases
thf(fact_245_relcompEpair,axiom,(
    ! [A: $tType,B: $tType,C: $tType,A2: A,C2: B,R3: ( set @ ( product_prod @ A @ C ) ),S: ( set @ ( product_prod @ C @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ C2 ) @ ( relcomp @ A @ C @ B @ R3 @ S ) )
     => ~ ( ! [B4: C] :
              ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ B4 ) @ R3 )
             => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ B4 @ C2 ) @ S ) ) ) ) )).

% relcompEpair
thf(fact_246_relcompE,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Xz: ( product_prod @ A @ B ),R3: ( set @ ( product_prod @ A @ C ) ),S: ( set @ ( product_prod @ C @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ Xz @ ( relcomp @ A @ C @ B @ R3 @ S ) )
     => ~ ( ! [X3: A,Y4: C,Z4: B] :
              ( ( Xz
                = ( product_Pair @ A @ B @ X3 @ Z4 ) )
             => ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X3 @ Y4 ) @ R3 )
               => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y4 @ Z4 ) @ S ) ) ) ) ) )).

% relcompE
thf(fact_247_O__assoc,axiom,(
    ! [A: $tType,D: $tType,B: $tType,C: $tType,R: ( set @ ( product_prod @ A @ D ) ),S5: ( set @ ( product_prod @ D @ C ) ),T4: ( set @ ( product_prod @ C @ B ) )] :
      ( ( relcomp @ A @ C @ B @ ( relcomp @ A @ D @ C @ R @ S5 ) @ T4 )
      = ( relcomp @ A @ D @ B @ R @ ( relcomp @ D @ C @ B @ S5 @ T4 ) ) ) )).

% O_assoc
thf(fact_248_relcompp__in__rel,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R: ( set @ ( product_prod @ A @ C ) ),S5: ( set @ ( product_prod @ C @ B ) )] :
      ( ( relcompp @ A @ C @ B @ ( fun_in_rel @ A @ C @ R ) @ ( fun_in_rel @ C @ B @ S5 ) )
      = ( fun_in_rel @ A @ B @ ( relcomp @ A @ C @ B @ R @ S5 ) ) ) )).

% relcompp_in_rel
thf(fact_249_relcomp__unfold,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R2: ( set @ ( product_prod @ A @ C ) ),S3: ( set @ ( product_prod @ C @ B ) )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X: A,Z3: B] :
                ? [Y3: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X @ Y3 ) @ R2 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y3 @ Z3 ) @ S3 ) ) ) ) ) ) )).

% relcomp_unfold
thf(fact_250_in__rel__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_in_rel @ A @ B )
      = ( ^ [R4: ( set @ ( product_prod @ A @ B ) ),X: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y3 ) @ R4 ) ) ) )).

% in_rel_def
thf(fact_251_in__rel__Collect__case__prod__eq,axiom,(
    ! [B: $tType,A: $tType,X7: ( A > B > $o )] :
      ( ( fun_in_rel @ A @ B @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ X7 ) ) )
      = X7 ) )).

% in_rel_Collect_case_prod_eq
thf(fact_252_image2__def,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A7: ( set @ C ),F2: ( C > A ),G4: ( C > B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: ( product_prod @ A @ B )] :
              ? [A6: C] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ ( F2 @ A6 ) @ ( G4 @ A6 ) ) )
                & ( member @ C @ A6 @ A7 ) ) ) ) ) )).

% image2_def
thf(fact_253_OO__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcompp @ A @ C @ B )
      = ( ^ [R4: ( A > C > $o ),S6: ( C > B > $o ),X: A,Z3: B] :
          ? [Y3: C] :
            ( ( R4 @ X @ Y3 )
            & ( S6 @ Y3 @ Z3 ) ) ) ) )).

% OO_def
thf(fact_254_relImage__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( bNF_Gr1317331620lImage @ B @ A )
      = ( ^ [R4: ( set @ ( product_prod @ B @ B ) ),F2: ( B > A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: ( product_prod @ A @ A )] :
              ? [A1: B,A22: B] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ ( F2 @ A1 ) @ ( F2 @ A22 ) ) )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A1 @ A22 ) @ R4 ) ) ) ) ) )).

% relImage_def
thf(fact_255_relInvImage__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr2107612801vImage @ A @ B )
      = ( ^ [A7: ( set @ A ),R4: ( set @ ( product_prod @ B @ B ) ),F2: ( A > B )] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: ( product_prod @ A @ A )] :
              ? [A1: A,A22: A] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ A1 @ A22 ) )
                & ( member @ A @ A1 @ A7 )
                & ( member @ A @ A22 @ A7 )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F2 @ A1 ) @ ( F2 @ A22 ) ) @ R4 ) ) ) ) ) )).

% relInvImage_def

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( szip @ a @ b @ xs @ ( smap @ c @ b @ g @ ys ) )
    = ( smap @ ( product_prod @ a @ c ) @ ( product_prod @ a @ b ) @ ( product_apsnd @ c @ b @ a @ g ) @ ( szip @ a @ c @ xs @ ys ) ) )).

%------------------------------------------------------------------------------
