%------------------------------------------------------------------------------
% File     : DAT147^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive stream 192
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_stream__192.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  336 (   0 unit;  54 type;   0 defn)
%            Number of atoms       : 4144 ( 270 equality;2539 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 3790 ( 112   ~;  17   |;  50   &;3350   @)
%                                         (   0 <=>; 261  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  211 ( 211   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   58 (  54   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  984 (   2 sgn; 862   !;  25   ?;  48   ^)
%                                         ( 984   :;  49  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 15:13:31.164
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (49)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Odistrib__lattice,type,(
    distrib_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__inf,type,(
    semilattice_inf: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olconcat,type,(
    coinductive_lconcat: 
      !>[A: $tType] :
        ( ( coinductive_llist @ ( coinductive_llist @ A ) ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oldistinct,type,(
    coindu351974385stinct: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OldropWhile,type,(
    coindu218763757pWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfilter,type,(
    coinductive_lfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olsetp,type,(
    coinductive_lsetp: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OltakeWhile,type,(
    coindu501562517eWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ollist__of__stream,type,(
    coindu1724414836stream: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__from__llist__setup_Ocr__stream,type,(
    coindu1183105481stream: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__of__llist,type,(
    coindu2010755910_llist: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( stream @ A ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ounfold__stream,type,(
    coindu139217191stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > A ) > A > ( stream @ B ) ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Odisjnt,type,(
    disjnt: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Stream_Osinterleave,type,(
    sinterleave: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osmember,type,(
    smember: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Ostream_Oshd,type,(
    shd: 
      !>[A: $tType] :
        ( ( stream @ A ) > A ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_x____,type,(
    x: a )).

thf(sy_v_xs,type,(
    xs: ( stream @ a ) )).

thf(sy_v_xsa____,type,(
    xsa: ( stream @ a ) )).

%----Relevant facts (254)
thf(fact_0__092_060open_062_092_060not_062_Alnull_A_Illist__of__stream_Axs_J_A_092_060Longrightarrow_062_Alhd_A_Illist__of__stream_Axs_J_A_092_060in_062_Alset_A_Illist__of__stream_Axs_J_092_060close_062,axiom,
    ( ~ ( coinductive_lnull @ a @ ( coindu1724414836stream @ a @ xsa ) )
   => ( member @ a @ ( coinductive_lhd @ a @ ( coindu1724414836stream @ a @ xsa ) ) @ ( coinductive_lset @ a @ ( coindu1724414836stream @ a @ xsa ) ) ) )).

% \<open>\<not> lnull (llist_of_stream xs) \<Longrightarrow> lhd (llist_of_stream xs) \<in> lset (llist_of_stream xs)\<close>
thf(fact_1_stream_ORep__inject,axiom,(
    ! [A: $tType,X: ( stream @ A ),Y: ( stream @ A )] :
      ( ( ( coindu1724414836stream @ A @ X )
        = ( coindu1724414836stream @ A @ Y ) )
      = ( X = Y ) ) )).

% stream.Rep_inject
thf(fact_2_lhd__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( coinductive_lhd @ A @ ( coindu1724414836stream @ A @ Xs ) )
      = ( shd @ A @ Xs ) ) )).

% lhd_llist_of_stream
thf(fact_3_lnull__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ~ ( coinductive_lnull @ A @ ( coindu1724414836stream @ A @ Xs ) ) )).

% lnull_llist_of_stream
thf(fact_4_stream_ORep__inverse,axiom,(
    ! [A: $tType,X: ( stream @ A )] :
      ( ( coindu2010755910_llist @ A @ ( coindu1724414836stream @ A @ X ) )
      = X ) )).

% stream.Rep_inverse
thf(fact_5_stream__of__llist__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( coindu2010755910_llist @ A @ ( coindu1724414836stream @ A @ Xs ) )
      = Xs ) )).

% stream_of_llist_llist_of_stream
thf(fact_6_unfold__stream_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,G1: ( A > B ),G2: ( A > A ),A2: A] :
      ( ( shd @ B @ ( coindu139217191stream @ A @ B @ G1 @ G2 @ A2 ) )
      = ( G1 @ A2 ) ) )).

% unfold_stream.simps(1)
thf(fact_7_shd__stream__of__llist,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( shd @ A @ ( coindu2010755910_llist @ A @ Xs ) )
      = ( coinductive_lhd @ A @ Xs ) ) )).

% shd_stream_of_llist
thf(fact_8_lset__lmember,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
      = ( coinductive_lmember @ A @ X @ Xs ) ) )).

% lset_lmember
thf(fact_9_lfinite__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ~ ( coinductive_lfinite @ A @ ( coindu1724414836stream @ A @ Xs ) ) )).

% lfinite_llist_of_stream
thf(fact_10__092_060open_062x_A_092_060in_062_Asset_Axs_092_060close_062,axiom,
    ( member @ a @ x @ ( sset @ a @ xs ) )).

% \<open>x \<in> sset xs\<close>
thf(fact_11_llist_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( member @ A @ ( coinductive_lhd @ A @ A2 ) @ ( coinductive_lset @ A @ A2 ) ) ) )).

% llist.set_sel(1)
thf(fact_12_sinterleave_Osimps_I1_J,axiom,(
    ! [A: $tType,S1: ( stream @ A ),S2: ( stream @ A )] :
      ( ( shd @ A @ ( sinterleave @ A @ S1 @ S2 ) )
      = ( shd @ A @ S1 ) ) )).

% sinterleave.simps(1)
thf(fact_13_Coinductive__List_Olset__into__lsetp,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( coinductive_lsetp @ A @ Xs @ X ) ) )).

% Coinductive_List.lset_into_lsetp
thf(fact_14_llist__of__stream__stream__of__llist,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coindu1724414836stream @ A @ ( coindu2010755910_llist @ A @ Xs ) )
        = Xs ) ) )).

% llist_of_stream_stream_of_llist
thf(fact_15_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_16_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_17_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_18_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_19_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream @ A )] :
      ( member @ A @ ( shd @ A @ A2 ) @ ( sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_20_lsetp__into__lset,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lsetp @ A @ Xs @ X )
     => ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) )).

% lsetp_into_lset
thf(fact_21_cr__streamI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( coindu1183105481stream @ A @ Xs @ ( coindu2010755910_llist @ A @ Xs ) ) ) )).

% cr_streamI
thf(fact_22_Stream_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( smember @ A )
      = ( ^ [X2: A,S: ( stream @ A )] :
            ( member @ A @ X2 @ ( sset @ A @ S ) ) ) ) )).

% Stream.smember_def
thf(fact_23_llist__set__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ~ ( coinductive_lnull @ A @ Xs2 )
           => ( P @ ( coinductive_lhd @ A @ Xs2 ) @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),Y2: A] :
              ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ( member @ A @ Y2 @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
               => ( ( P @ Y2 @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P @ Y2 @ Xs2 ) ) ) )
         => ( P @ X @ Xs ) ) ) ) )).

% llist_set_induct
thf(fact_24_lset__eq__empty,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lset_eq_empty
thf(fact_25_lnull__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X2 ) ) ) ) )).

% lnull_ldropWhile
thf(fact_26_lhd__lconcat,axiom,(
    ! [A: $tType,Xss: ( coinductive_llist @ ( coinductive_llist @ A ) )] :
      ( ~ ( coinductive_lnull @ ( coinductive_llist @ A ) @ Xss )
     => ( ~ ( coinductive_lnull @ A @ ( coinductive_lhd @ ( coinductive_llist @ A ) @ Xss ) )
       => ( ( coinductive_lhd @ A @ ( coinductive_lconcat @ A @ Xss ) )
          = ( coinductive_lhd @ A @ ( coinductive_lhd @ ( coinductive_llist @ A ) @ Xss ) ) ) ) ) )).

% lhd_lconcat
thf(fact_27_sset__sinterleave,axiom,(
    ! [A: $tType,S1: ( stream @ A ),S2: ( stream @ A )] :
      ( ( sset @ A @ ( sinterleave @ A @ S1 @ S2 ) )
      = ( sup_sup @ ( set @ A ) @ ( sset @ A @ S1 ) @ ( sset @ A @ S2 ) ) ) )).

% sset_sinterleave
thf(fact_28_ltakeWhile_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(2)
thf(fact_29_ltakeWhile_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.disc_iff(1)
thf(fact_30_lnull__ltakeWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lnull_ltakeWhile
thf(fact_31_lnull__lfilter,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
           => ~ ( P @ X2 ) ) ) ) )).

% lnull_lfilter
thf(fact_32_lfilter__idem,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( coinductive_lfilter @ A @ P @ Xs ) ) )).

% lfilter_idem
thf(fact_33_lfinite__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_ltl @ A @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_ltl
thf(fact_34_ltakeWhile_Osimps_I4_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coinductive_ltl @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
          = ( coindu501562517eWhile @ A @ P @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) )).

% ltakeWhile.simps(4)
thf(fact_35_lnull__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% lnull_ltlI
thf(fact_36_in__lset__ltlD,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ltlD
thf(fact_37_lfilter__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( coinductive_lfilter @ A @ P @ Xs )
          = ( coinductive_lfilter @ A @ Q @ Ys ) ) ) ) )).

% lfilter_cong
thf(fact_38_lfilter__id__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = Xs )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X2 ) ) ) ) )).

% lfilter_id_conv
thf(fact_39_lfinite__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )).

% lfinite_lfilterI
thf(fact_40_ltakeWhile__all,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( coindu501562517eWhile @ A @ P @ Xs )
        = Xs ) ) )).

% ltakeWhile_all
thf(fact_41_ltakeWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( coindu501562517eWhile @ A @ P @ Xs )
          = ( coindu501562517eWhile @ A @ Q @ Ys ) ) ) ) )).

% ltakeWhile_cong
thf(fact_42_lset__ltakeWhileD,axiom,(
    ! [A: $tType,X: A,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        & ( P @ X ) ) ) )).

% lset_ltakeWhileD
thf(fact_43_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_46_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_47_ldropWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( coindu218763757pWhile @ A @ P @ Xs )
          = ( coindu218763757pWhile @ A @ Q @ Ys ) ) ) ) )).

% ldropWhile_cong
thf(fact_48_in__lset__ldropWhileD,axiom,(
    ! [A: $tType,X: A,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ldropWhileD
thf(fact_49_sset__neq__empty,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( sset @ A @ Xs )
     != ( bot_bot @ ( set @ A ) ) ) )).

% sset_neq_empty
thf(fact_50_llist_Oset__sel_I2_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),X: A] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ A2 ) ) )
       => ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) ) ) ) )).

% llist.set_sel(2)
thf(fact_51_lfinite__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lnull @ A @ Xs2 )
           => ( P @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ Xs2 )
               => ( ( P @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lfinite_induct
thf(fact_52_llist_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist2: ( coinductive_llist @ A )] :
      ( ( R @ Llist @ Llist2 )
     => ( ! [Llist3: ( coinductive_llist @ A ),Llist4: ( coinductive_llist @ A )] :
            ( ( R @ Llist3 @ Llist4 )
           => ( ( ( coinductive_lnull @ A @ Llist3 )
                = ( coinductive_lnull @ A @ Llist4 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist3 )
               => ( ~ ( coinductive_lnull @ A @ Llist4 )
                 => ( ( ( coinductive_lhd @ A @ Llist3 )
                      = ( coinductive_lhd @ A @ Llist4 ) )
                    & ( ( R @ ( coinductive_ltl @ A @ Llist3 ) @ ( coinductive_ltl @ A @ Llist4 ) )
                      | ( ( coinductive_ltl @ A @ Llist3 )
                        = ( coinductive_ltl @ A @ Llist4 ) ) ) ) ) ) ) )
       => ( Llist = Llist2 ) ) ) )).

% llist.coinduct_strong
thf(fact_53_llist_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist2: ( coinductive_llist @ A )] :
      ( ( R @ Llist @ Llist2 )
     => ( ! [Llist3: ( coinductive_llist @ A ),Llist4: ( coinductive_llist @ A )] :
            ( ( R @ Llist3 @ Llist4 )
           => ( ( ( coinductive_lnull @ A @ Llist3 )
                = ( coinductive_lnull @ A @ Llist4 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist3 )
               => ( ~ ( coinductive_lnull @ A @ Llist4 )
                 => ( ( ( coinductive_lhd @ A @ Llist3 )
                      = ( coinductive_lhd @ A @ Llist4 ) )
                    & ( R @ ( coinductive_ltl @ A @ Llist3 ) @ ( coinductive_ltl @ A @ Llist4 ) ) ) ) ) ) )
       => ( Llist = Llist2 ) ) ) )).

% llist.coinduct
thf(fact_54_llist_Oexpand,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),Llist2: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Llist )
        = ( coinductive_lnull @ A @ Llist2 ) )
     => ( ( ~ ( coinductive_lnull @ A @ Llist )
         => ( ~ ( coinductive_lnull @ A @ Llist2 )
           => ( ( ( coinductive_lhd @ A @ Llist )
                = ( coinductive_lhd @ A @ Llist2 ) )
              & ( ( coinductive_ltl @ A @ Llist )
                = ( coinductive_ltl @ A @ Llist2 ) ) ) ) )
       => ( Llist = Llist2 ) ) ) )).

% llist.expand
thf(fact_55_lhd__ltakeWhile,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coinductive_lhd @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
          = ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lhd_ltakeWhile
thf(fact_56_ltakeWhile_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) )
     => ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) ) )).

% ltakeWhile.disc(1)
thf(fact_57_ltakeWhile_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P @ ( coinductive_lhd @ A @ Xs ) )
       => ~ ( coinductive_lnull @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) ) ) )).

% ltakeWhile.disc(2)
thf(fact_58_lfinite__ltakeWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        | ? [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X2 ) ) ) ) )).

% lfinite_ltakeWhile
thf(fact_59_stream__of__llist__def,axiom,(
    ! [A: $tType] :
      ( ( coindu2010755910_llist @ A )
      = ( coindu139217191stream @ ( coinductive_llist @ A ) @ A @ ( coinductive_lhd @ A ) @ ( coinductive_ltl @ A ) ) ) )).

% stream_of_llist_def
thf(fact_60_lset__lnull,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lset @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_lnull
thf(fact_61_lfinite__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X2 ) )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lfinite_ldropWhile
thf(fact_62_lhd__ldropWhile,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
          & ~ ( P @ X4 ) )
     => ~ ( P @ ( coinductive_lhd @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) ) ) ) )).

% lhd_ldropWhile
thf(fact_63_lhd__ldropWhile__in__lset,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
          & ~ ( P @ X4 ) )
     => ( member @ A @ ( coinductive_lhd @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) ) @ ( coinductive_lset @ A @ Xs ) ) ) )).

% lhd_ldropWhile_in_lset
thf(fact_64_Un__empty,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        & ( B2
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_65_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ ( bot_bot @ A ) )
          = A2 ) ) )).

% sup_bot.right_neutral
thf(fact_66_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A2 )
          = A2 ) ) )).

% sup_bot.left_neutral
thf(fact_67_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_68_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_69_Un__iff,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( member @ A @ C @ A3 )
        | ( member @ A @ C @ B2 ) ) ) )).

% Un_iff
thf(fact_70_UnCI,axiom,(
    ! [A: $tType,C: A,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( ~ ( member @ A @ C @ B2 )
       => ( member @ A @ C @ A3 ) )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnCI
thf(fact_71_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.right_idem
thf(fact_72_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_73_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_74_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X2: A] :
            ~ ( member @ A @ X2 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_75_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) )).

% Collect_empty_eq
thf(fact_76_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X2: A] :
            ~ ( P @ X2 ) ) ) )).

% empty_Collect_eq
thf(fact_77_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G3: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G3 @ X2 ) ) ) ) ) )).

% sup_apply
thf(fact_78_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_79_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_80_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B3 ) )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.left_idem
thf(fact_81_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_82_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_83_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_84_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_85_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_86_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_87_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_88_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_89_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y3: A] :
              ( sup_sup @ A @ Y3 @ X2 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_90_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G3: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G3 @ X2 ) ) ) ) ) )).

% sup_fun_def
thf(fact_91_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B3 ) @ C )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B3 @ C ) ) ) ) )).

% sup.assoc
thf(fact_92_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) )).

% sup_assoc
thf(fact_93_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A4: A,B4: A] :
              ( sup_sup @ A @ B4 @ A4 ) ) ) ) )).

% sup.commute
thf(fact_94_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y3: A] :
              ( sup_sup @ A @ Y3 @ X2 ) ) ) ) )).

% sup_commute
thf(fact_95_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A2 @ C ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B3 @ C ) ) ) ) )).

% sup.left_commute
thf(fact_96_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_left_commute
thf(fact_97_UnE,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
     => ( ~ ( member @ A @ C @ A3 )
       => ( member @ A @ C @ B2 ) ) ) )).

% UnE
thf(fact_98_UnI1,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ A3 )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnI1
thf(fact_99_UnI2,axiom,(
    ! [A: $tType,C: A,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ C @ B2 )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnI2
thf(fact_100_bex__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
            & ( P @ X2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ A3 )
            & ( P @ X2 ) )
        | ? [X2: A] :
            ( ( member @ A @ X2 @ B2 )
            & ( P @ X2 ) ) ) ) )).

% bex_Un
thf(fact_101_ball__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
           => ( P @ X2 ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ( P @ X2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ B2 )
           => ( P @ X2 ) ) ) ) )).

% ball_Un
thf(fact_102_Un__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ C2 )
      = ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C2 ) ) ) )).

% Un_assoc
thf(fact_103_Un__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Un_absorb
thf(fact_104_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Un_commute
thf(fact_105_Un__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) )).

% Un_left_absorb
thf(fact_106_Un__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C2 ) )
      = ( sup_sup @ ( set @ A ) @ B2 @ ( sup_sup @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% Un_left_commute
thf(fact_107_sup__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) )).

% sup_bot_left
thf(fact_108_sup__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) )).

% sup_bot_right
thf(fact_109_Un__empty__left,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = B2 ) )).

% Un_empty_left
thf(fact_110_Un__empty__right,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = A3 ) )).

% Un_empty_right
thf(fact_111_bot__apply,axiom,(
    ! [C3: $tType,D: $tType] :
      ( ( bot @ C3 @ ( type2 @ C3 ) )
     => ( ( bot_bot @ ( D > C3 ) )
        = ( ^ [X2: D] :
              ( bot_bot @ C3 ) ) ) ) )).

% bot_apply
thf(fact_112_ltl__lconcat,axiom,(
    ! [A: $tType,Xss: ( coinductive_llist @ ( coinductive_llist @ A ) )] :
      ( ~ ( coinductive_lnull @ ( coinductive_llist @ A ) @ Xss )
     => ( ~ ( coinductive_lnull @ A @ ( coinductive_lhd @ ( coinductive_llist @ A ) @ Xss ) )
       => ( ( coinductive_ltl @ A @ ( coinductive_lconcat @ A @ Xss ) )
          = ( coinductive_lappend @ A @ ( coinductive_ltl @ A @ ( coinductive_lhd @ ( coinductive_llist @ A ) @ Xss ) ) @ ( coinductive_lconcat @ A @ ( coinductive_ltl @ ( coinductive_llist @ A ) @ Xss ) ) ) ) ) ) )).

% ltl_lconcat
thf(fact_113_gen__lset__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_gen_lset @ A )
      = ( ^ [A5: ( set @ A ),Xs3: ( coinductive_llist @ A )] :
            ( sup_sup @ ( set @ A ) @ A5 @ ( coinductive_lset @ A @ Xs3 ) ) ) ) )).

% gen_lset_def
thf(fact_114_lset__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A )
      = ( coinductive_gen_lset @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_code
thf(fact_115_unfold__llist__id,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu1441602521_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_lnull @ A ) @ ( coinductive_lhd @ A ) @ ( coinductive_ltl @ A ) @ Xs )
      = Xs ) )).

% unfold_llist_id
thf(fact_116_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A5: ( set @ A )] :
            ( A5
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_117_lnull__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        & ( coinductive_lnull @ A @ Ys ) ) ) )).

% lnull_lappend
thf(fact_118_lappend_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.disc_iff(2)
thf(fact_119_lfinite__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ( coinductive_lfinite @ A @ Ys ) ) ) )).

% lfinite_lappend
thf(fact_120_lconcat__lappend,axiom,(
    ! [A: $tType,Xss: ( coinductive_llist @ ( coinductive_llist @ A ) ),Yss: ( coinductive_llist @ ( coinductive_llist @ A ) )] :
      ( ( coinductive_lfinite @ ( coinductive_llist @ A ) @ Xss )
     => ( ( coinductive_lconcat @ A @ ( coinductive_lappend @ ( coinductive_llist @ A ) @ Xss @ Yss ) )
        = ( coinductive_lappend @ A @ ( coinductive_lconcat @ A @ Xss ) @ ( coinductive_lconcat @ A @ Yss ) ) ) ) )).

% lconcat_lappend
thf(fact_121_unfold__llist_Odisc__iff_I1_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A2: A] :
      ( ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 ) )
      = ( P2 @ A2 ) ) )).

% unfold_llist.disc_iff(1)
thf(fact_122_unfold__llist_Odisc__iff_I2_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),G21: ( A > B ),G22: ( A > A ),A2: A] :
      ( ( ~ ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 ) ) )
      = ( ~ ( P2 @ A2 ) ) ) )).

% unfold_llist.disc_iff(2)
thf(fact_123_ltl__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_ltl @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_ltl @ A @ Ys ) ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_ltl @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lappend @ A @ ( coinductive_ltl @ A @ Xs ) @ Ys ) ) ) ) )).

% ltl_lappend
thf(fact_124_lhd__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_lhd @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lhd @ A @ Ys ) ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_lhd @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% lhd_lappend
thf(fact_125_lfilter__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( coinductive_lappend @ A @ ( coinductive_lfilter @ A @ P @ Xs ) @ ( coinductive_lfilter @ A @ P @ Ys ) ) ) ) )).

% lfilter_lappend_lfinite
thf(fact_126_lappend__ltakeWhile__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = Xs ) )).

% lappend_ltakeWhile_ldropWhile
thf(fact_127_lset__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% lset_lappend_lfinite
thf(fact_128_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_129_lappend__lnull2,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_lnull2
thf(fact_130_lappend__lnull1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Ys ) ) )).

% lappend_lnull1
thf(fact_131_lappend_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) ) )).

% lappend.disc(1)
thf(fact_132_lappend_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) )
     => ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) )).

% lappend.disc(2)
thf(fact_133_lappend__inf,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_inf
thf(fact_134_unfold__llist_Odisc_I1_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ( P2 @ A2 )
     => ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 ) ) ) )).

% unfold_llist.disc(1)
thf(fact_135_unfold__llist_Odisc_I2_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P2 @ A2 )
     => ~ ( coinductive_lnull @ B @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 ) ) ) )).

% unfold_llist.disc(2)
thf(fact_136_unfold__llist_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P2 @ A2 )
     => ( ( coinductive_ltl @ B @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 ) )
        = ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) )).

% unfold_llist.simps(4)
thf(fact_137_unfold__llist_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P2 @ A2 )
     => ( ( coinductive_lhd @ B @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 ) )
        = ( G21 @ A2 ) ) ) )).

% unfold_llist.simps(3)
thf(fact_138_lappend__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lappend @ A @ ( coinductive_ltl @ A @ Xs ) @ Ys )
        = ( coinductive_ltl @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) ) )).

% lappend_ltl
thf(fact_139_in__lset__lappend__iff,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        | ( ( coinductive_lfinite @ A @ Xs )
          & ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) ) ) ) ) )).

% in_lset_lappend_iff
thf(fact_140_ltakeWhile__lappend1,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coindu501562517eWhile @ A @ P @ Xs ) ) ) ) )).

% ltakeWhile_lappend1
thf(fact_141_lfilter__eq__lappend__lfiniteD,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_lappend @ A @ Ys @ Zs ) )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_lappend @ A @ Us @ Vs ) )
            & ( coinductive_lfinite @ A @ Us )
            & ( Ys
              = ( coinductive_lfilter @ A @ P @ Us ) )
            & ( Zs
              = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) ) )).

% lfilter_eq_lappend_lfiniteD
thf(fact_142_lset__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfinite @ A @ Xs )
       => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) ) ) )
      & ( ~ ( coinductive_lfinite @ A @ Xs )
       => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lset @ A @ Xs ) ) ) ) )).

% lset_lappend_conv
thf(fact_143_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X2: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_144_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_145_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_146_lstrict__prefix__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lstrict_prefix_lappend_conv
thf(fact_147_ldistinct__coinduct,axiom,(
    ! [A: $tType,X5: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( X5 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( X5 @ Xs2 )
           => ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ~ ( member @ A @ ( coinductive_lhd @ A @ Xs2 ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
                & ( ( X5 @ ( coinductive_ltl @ A @ Xs2 ) )
                  | ( coindu351974385stinct @ A @ ( coinductive_ltl @ A @ Xs2 ) ) ) ) ) )
       => ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_coinduct
thf(fact_148_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs2: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs2 )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) )).

% llist_less_induct
thf(fact_149_ldistinct__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( coindu351974385stinct @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% ldistinct_ltlI
thf(fact_150_ldistinct__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( coindu351974385stinct @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )).

% ldistinct_lfilterI
thf(fact_151_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ Ys )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lstrict_prefix_lfinite1
thf(fact_152_ldistinct__lhdD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( member @ A @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) )).

% ldistinct_lhdD
thf(fact_153_ldistinct__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coindu351974385stinct @ A @ Xs )
        & ( ( coinductive_lfinite @ A @ Xs )
         => ( ( coindu351974385stinct @ A @ Ys )
            & ( ( inf_inf @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% ldistinct_lappend
thf(fact_154_ldistinct__lconcat,axiom,(
    ! [A: $tType,Xss: ( coinductive_llist @ ( coinductive_llist @ A ) )] :
      ( ( coindu351974385stinct @ ( coinductive_llist @ A ) @ Xss )
     => ( ! [Ys3: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ Ys3 @ ( coinductive_lset @ ( coinductive_llist @ A ) @ Xss ) )
           => ( coindu351974385stinct @ A @ Ys3 ) )
       => ( ! [Ys3: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ Ys3 @ ( coinductive_lset @ ( coinductive_llist @ A ) @ Xss ) )
             => ( ( member @ ( coinductive_llist @ A ) @ Zs2 @ ( coinductive_lset @ ( coinductive_llist @ A ) @ Xss ) )
               => ( ( Ys3 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( coinductive_lset @ A @ Ys3 ) @ ( coinductive_lset @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( coindu351974385stinct @ A @ ( coinductive_lconcat @ A @ Xss ) ) ) ) ) )).

% ldistinct_lconcat
thf(fact_155_llist_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( coindu1381640503_llist @ B @ A )
      = ( ^ [F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist5: ( coinductive_llist @ A )] :
            ( if @ B @ ( coinductive_lnull @ A @ Llist5 ) @ F1 @ ( F22 @ ( coinductive_lhd @ A @ Llist5 ) @ ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) )).

% llist.case_eq_if
thf(fact_156_inf__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G3: ( A > B ),X2: A] :
              ( inf_inf @ B @ ( F2 @ X2 ) @ ( G3 @ X2 ) ) ) ) ) )).

% inf_apply
thf(fact_157_inf_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) )).

% inf.idem
thf(fact_158_inf__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) )).

% inf_idem
thf(fact_159_inf_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B3 ) )
          = ( inf_inf @ A @ A2 @ B3 ) ) ) )).

% inf.left_idem
thf(fact_160_inf__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_left_idem
thf(fact_161_inf_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B3 ) @ B3 )
          = ( inf_inf @ A @ A2 @ B3 ) ) ) )).

% inf.right_idem
thf(fact_162_inf__right__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_right_idem
thf(fact_163_IntI,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ A3 )
     => ( ( member @ A @ C @ B2 )
       => ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) ) ) )).

% IntI
thf(fact_164_Int__iff,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( member @ A @ C @ A3 )
        & ( member @ A @ C @ B2 ) ) ) )).

% Int_iff
thf(fact_165_inf__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_left
thf(fact_166_inf__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_right
thf(fact_167_inf__sup__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) )).

% inf_sup_absorb
thf(fact_168_sup__inf__absorb,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) )).

% sup_inf_absorb
thf(fact_169_inf__sup__aci_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) )).

% inf_sup_aci(4)
thf(fact_170_inf__sup__aci_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_sup_aci(3)
thf(fact_171_inf__sup__aci_I2_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(2)
thf(fact_172_inf__sup__aci_I1_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y3: A] :
              ( inf_inf @ A @ Y3 @ X2 ) ) ) ) )).

% inf_sup_aci(1)
thf(fact_173_IntE,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ~ ( ( member @ A @ C @ A3 )
         => ~ ( member @ A @ C @ B2 ) ) ) )).

% IntE
thf(fact_174_IntD1,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ( member @ A @ C @ A3 ) ) )).

% IntD1
thf(fact_175_IntD2,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
     => ( member @ A @ C @ B2 ) ) )).

% IntD2
thf(fact_176_Int__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ C2 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C2 ) ) ) )).

% Int_assoc
thf(fact_177_Int__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Int_absorb
thf(fact_178_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Int_commute
thf(fact_179_Int__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B2 ) ) )).

% Int_left_absorb
thf(fact_180_inf__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G3: ( A > B ),X2: A] :
              ( inf_inf @ B @ ( F2 @ X2 ) @ ( G3 @ X2 ) ) ) ) ) )).

% inf_fun_def
thf(fact_181_Int__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C2 ) )
      = ( inf_inf @ ( set @ A ) @ B2 @ ( inf_inf @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% Int_left_commute
thf(fact_182_inf_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B3 ) @ C )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B3 @ C ) ) ) ) )).

% inf.assoc
thf(fact_183_inf__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_assoc
thf(fact_184_inf_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [A4: A,B4: A] :
              ( inf_inf @ A @ B4 @ A4 ) ) ) ) )).

% inf.commute
thf(fact_185_inf__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y3: A] :
              ( inf_inf @ A @ Y3 @ X2 ) ) ) ) )).

% inf_commute
thf(fact_186_inf_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C: A] :
          ( ( inf_inf @ A @ B3 @ ( inf_inf @ A @ A2 @ C ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B3 @ C ) ) ) ) )).

% inf.left_commute
thf(fact_187_inf__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_left_commute
thf(fact_188_Un__Int__distrib2,axiom,(
    ! [A: $tType,B2: ( set @ A ),C2: ( set @ A ),A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B2 @ C2 ) @ A3 )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B2 @ A3 ) @ ( sup_sup @ ( set @ A ) @ C2 @ A3 ) ) ) )).

% Un_Int_distrib2
thf(fact_189_Int__Un__distrib2,axiom,(
    ! [A: $tType,B2: ( set @ A ),C2: ( set @ A ),A3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ B2 @ C2 ) @ A3 )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ B2 @ A3 ) @ ( inf_inf @ ( set @ A ) @ C2 @ A3 ) ) ) )).

% Int_Un_distrib2
thf(fact_190_Un__Int__distrib,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C2 ) )
      = ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ ( sup_sup @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% Un_Int_distrib
thf(fact_191_Int__Un__distrib,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C2 ) )
      = ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% Int_Un_distrib
thf(fact_192_Un__Int__crazy,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B2 ) @ ( inf_inf @ ( set @ A ) @ B2 @ C2 ) ) @ ( inf_inf @ ( set @ A ) @ C2 @ A3 ) )
      = ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ ( sup_sup @ ( set @ A ) @ B2 @ C2 ) ) @ ( sup_sup @ ( set @ A ) @ C2 @ A3 ) ) ) )).

% Un_Int_crazy
thf(fact_193_disjoint__iff__not__equal,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A3 )
           => ! [Y3: A] :
                ( ( member @ A @ Y3 @ B2 )
               => ( X2 != Y3 ) ) ) ) ) )).

% disjoint_iff_not_equal
thf(fact_194_Int__empty__right,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_right
thf(fact_195_Int__empty__left,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_left
thf(fact_196_Int__emptyI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ~ ( member @ A @ X3 @ B2 ) )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% Int_emptyI
thf(fact_197_sup__inf__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z @ X ) ) ) ) )).

% sup_inf_distrib2
thf(fact_198_sup__inf__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) )).

% sup_inf_distrib1
thf(fact_199_inf__sup__distrib2,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [Y: A,Z: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z @ X ) ) ) ) )).

% inf_sup_distrib2
thf(fact_200_inf__sup__distrib1,axiom,(
    ! [A: $tType] :
      ( ( distrib_lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) )).

% inf_sup_distrib1
thf(fact_201_distrib__imp2,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y2: A,Z2: A] :
              ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y2 @ Z2 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y2 ) @ ( sup_sup @ A @ X3 @ Z2 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ) )).

% distrib_imp2
thf(fact_202_distrib__imp1,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y2: A,Z2: A] :
              ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y2 @ Z2 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y2 ) @ ( inf_inf @ A @ X3 @ Z2 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ) )).

% distrib_imp1
thf(fact_203_disjnt__def,axiom,(
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( inf_inf @ ( set @ A ) @ A5 @ B5 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% disjnt_def
thf(fact_204_lfilter__eq__LConsD,axiom,(
    ! [A: $tType,P: ( A > $o ),Ys: ( coinductive_llist @ A ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Ys )
        = ( coinductive_LCons @ A @ X @ Xs ) )
     => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
          ( ( Ys
            = ( coinductive_lappend @ A @ Us @ ( coinductive_LCons @ A @ X @ Vs ) ) )
          & ( coinductive_lfinite @ A @ Us )
          & ! [X4: A] :
              ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Us ) )
             => ~ ( P @ X4 ) )
          & ( P @ X )
          & ( Xs
            = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) )).

% lfilter_eq_LConsD
thf(fact_205_ltakeWhile_Octr_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ( P @ ( coinductive_lhd @ A @ Xs ) )
       => ( ( coindu501562517eWhile @ A @ P @ Xs )
          = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Xs ) @ ( coindu501562517eWhile @ A @ P @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) ) )).

% ltakeWhile.ctr(2)
thf(fact_206_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_207_lfinite__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_208_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_209_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa: A,X: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa @ X ) @ Ys )
      = ( coinductive_LCons @ A @ Xa @ ( coinductive_lappend @ A @ X @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_210_lfilter__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons
thf(fact_211_ldropWhile__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coindu218763757pWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LCons @ A @ X @ Xs ) ) ) ) )).

% ldropWhile_LCons
thf(fact_212_lconcat__LCons,axiom,(
    ! [B: $tType,Xs: ( coinductive_llist @ B ),Xss: ( coinductive_llist @ ( coinductive_llist @ B ) )] :
      ( ( coinductive_lconcat @ B @ ( coinductive_LCons @ ( coinductive_llist @ B ) @ Xs @ Xss ) )
      = ( coinductive_lappend @ B @ Xs @ ( coinductive_lconcat @ B @ Xss ) ) ) )).

% lconcat_LCons
thf(fact_213_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B3: B,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B3 )
        = ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( IS_LNIL @ B3 )
        & ( X
          = ( LHD @ B3 ) )
        & ( Xs
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B3 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_214_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B ),Y: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs ) @ ( coinductive_LCons @ B @ Y @ Ys ) )
      = ( ( X = Y )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_215_ldistinct__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        & ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_LCons
thf(fact_216_lhd__LCons__ltl,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ Llist )
     => ( ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) )
        = Llist ) ) )).

% lhd_LCons_ltl
thf(fact_217_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F12: B,F23: ( A > ( coinductive_llist @ A ) > B ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F12 @ F23 @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = ( F23 @ X21 @ X22 ) ) )).

% llist.simps(5)
thf(fact_218_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) )
       => ( ! [Z1: A,Z22: ( coinductive_llist @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( coinductive_lset @ A @ Z22 ) )
             => ( ( P @ Xa2 @ Z22 )
               => ( P @ Xa2 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_219_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z22: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z22 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z22 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_220_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_221_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( X != X6 )
               => ( ( P @ Xs2 )
                 => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_222_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs4: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X @ Xs4 ) )
       => ~ ( ! [X6: A,Xs4: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X6 @ Xs4 ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs4 ) ) ) ) ) ) )).

% lset_cases
thf(fact_223_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_224_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_225_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_226_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),X7: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X7 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_227_lmember__code_I2_J,axiom,(
    ! [A: $tType,X: A,Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( X = Y )
        | ( coinductive_lmember @ A @ X @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_228_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X2: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X2 @ Xs5 ) ) ) ) )).

% not_lnull_conv
thf(fact_229_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X21 @ X22 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_230_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_231_ltl__simps_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_ltl @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X22 ) )).

% ltl_simps(2)
thf(fact_232_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_233_lfilter__LCons__seek,axiom,(
    ! [A: $tType,P2: ( A > $o ),X: A,L: ( coinductive_llist @ A )] :
      ( ~ ( P2 @ X )
     => ( ( coinductive_lfilter @ A @ P2 @ ( coinductive_LCons @ A @ X @ L ) )
        = ( coinductive_lfilter @ A @ P2 @ L ) ) ) )).

% lfilter_LCons_seek
thf(fact_234_lfilter__LCons__found,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( P @ X )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
        = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons_found
thf(fact_235_disjnt__iff,axiom,(
    ! [A: $tType] :
      ( ( disjnt @ A )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [X2: A] :
            ~ ( ( member @ A @ X2 @ A5 )
              & ( member @ A @ X2 @ B5 ) ) ) ) )).

% disjnt_iff
thf(fact_236_lsetp_Oinducts,axiom,(
    ! [A: $tType,X1: ( coinductive_llist @ A ),X23: A,P: ( ( coinductive_llist @ A ) > A > $o )] :
      ( ( coinductive_lsetp @ A @ X1 @ X23 )
     => ( ! [X3: A,Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X3 @ Xs2 ) @ X3 )
       => ( ! [Xs2: ( coinductive_llist @ A ),X3: A,X6: A] :
              ( ( coinductive_lsetp @ A @ Xs2 @ X3 )
             => ( ( P @ Xs2 @ X3 )
               => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) @ X3 ) ) )
         => ( P @ X1 @ X23 ) ) ) ) )).

% lsetp.inducts
thf(fact_237_lsetp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lsetp @ A )
      = ( ^ [A12: ( coinductive_llist @ A ),A23: A] :
            ( ? [X2: A,Xs3: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X2 @ Xs3 ) )
                & ( A23 = X2 ) )
            | ? [Xs3: ( coinductive_llist @ A ),X2: A,X8: A] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X8 @ Xs3 ) )
                & ( A23 = X2 )
                & ( coinductive_lsetp @ A @ Xs3 @ X2 ) ) ) ) ) )).

% lsetp.simps
thf(fact_238_lsetp_Ocases,axiom,(
    ! [A: $tType,A1: ( coinductive_llist @ A ),A22: A] :
      ( ( coinductive_lsetp @ A @ A1 @ A22 )
     => ( ! [X3: A] :
            ( ? [Xs2: ( coinductive_llist @ A )] :
                ( A1
                = ( coinductive_LCons @ A @ X3 @ Xs2 ) )
           => ( A22 != X3 ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X6: A] :
                    ( A1
                    = ( coinductive_LCons @ A @ X6 @ Xs2 ) )
               => ~ ( coinductive_lsetp @ A @ Xs2 @ A22 ) ) ) ) ) )).

% lsetp.cases
thf(fact_239_lsetp_Ointros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lsetp @ A @ ( coinductive_LCons @ A @ X @ Xs ) @ X ) )).

% lsetp.intros(1)
thf(fact_240_lsetp_Ointros_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A,X7: A] :
      ( ( coinductive_lsetp @ A @ Xs @ X )
     => ( coinductive_lsetp @ A @ ( coinductive_LCons @ A @ X7 @ Xs ) @ X ) ) )).

% lsetp.intros(2)
thf(fact_241_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_242_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P2: ( A > $o ),A2: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P2 @ A2 )
     => ( ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ A2 )
        = ( coinductive_LCons @ B @ ( G21 @ A2 ) @ ( coindu1441602521_llist @ A @ B @ P2 @ G21 @ G22 @ ( G22 @ A2 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_243_ldistinct_OLCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ( coindu351974385stinct @ A @ Xs )
       => ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) ) )).

% ldistinct.LCons
thf(fact_244_split__llist,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys3: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys3 @ ( coinductive_LCons @ A @ X @ Zs2 ) ) )
          & ( coinductive_lfinite @ A @ Ys3 ) ) ) )).

% split_llist
thf(fact_245_split__llist__first,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys3: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys3 @ ( coinductive_LCons @ A @ X @ Zs2 ) ) )
          & ( coinductive_lfinite @ A @ Ys3 )
          & ~ ( member @ A @ X @ ( coinductive_lset @ A @ Ys3 ) ) ) ) )).

% split_llist_first
thf(fact_246_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_247_ltakeWhile_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coindu501562517eWhile @ A )
      = ( ^ [P3: ( A > $o ),Xs3: ( coinductive_llist @ A )] :
            ( if @ ( coinductive_llist @ A )
            @ ( ( coinductive_lnull @ A @ Xs3 )
              | ~ ( P3 @ ( coinductive_lhd @ A @ Xs3 ) ) )
            @ ( coinductive_LNil @ A )
            @ ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Xs3 ) @ ( coindu501562517eWhile @ A @ P3 @ ( coinductive_ltl @ A @ Xs3 ) ) ) ) ) ) )).

% ltakeWhile.code
thf(fact_248_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_249_lappend__LNil2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ Xs @ ( coinductive_LNil @ A ) )
      = Xs ) )).

% lappend_LNil2
thf(fact_250_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_251_lfilter__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lfilter_LNil
thf(fact_252_ltakeWhile__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coindu501562517eWhile @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltakeWhile_LNil
thf(fact_253_lconcat__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lconcat @ A @ ( coinductive_LNil @ ( coinductive_llist @ A ) ) )
      = ( coinductive_LNil @ A ) ) )).

% lconcat_LNil

%----Type constructors (24)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A6: $tType] :
      ( bounded_lattice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounded_lattice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounde1808546759up_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounded_lattice_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( semilattice_sup @ A7 @ ( type2 @ A7 ) )
     => ( semilattice_sup @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( semilattice_inf @ A7 @ ( type2 @ A7 ) )
     => ( semilattice_inf @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( distrib_lattice @ A7 @ ( type2 @ A7 ) )
     => ( distrib_lattice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( lattice @ A7 @ ( type2 @ A7 ) )
     => ( lattice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bot @ A7 @ ( type2 @ A7 ) )
     => ( bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_3,axiom,(
    ! [A6: $tType] :
      ( bounde1808546759up_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_4,axiom,(
    ! [A6: $tType] :
      ( bounded_lattice_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_5,axiom,(
    ! [A6: $tType] :
      ( semilattice_sup @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_6,axiom,(
    ! [A6: $tType] :
      ( semilattice_inf @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_7,axiom,(
    ! [A6: $tType] :
      ( distrib_lattice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_8,axiom,(
    ! [A6: $tType] :
      ( lattice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_9,axiom,(
    ! [A6: $tType] :
      ( bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_10,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_11,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_12,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_13,axiom,
    ( semilattice_inf @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_14,axiom,
    ( distrib_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_15,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_16,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( member @ a @ ( shd @ a @ xsa ) @ ( coinductive_lset @ a @ ( coindu1724414836stream @ a @ xsa ) ) )).

%------------------------------------------------------------------------------
