%------------------------------------------------------------------------------
% File     : DAT148^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive stream 241
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_stream__241.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  316 (   0 unit;  55 type;   0 defn)
%            Number of atoms       : 6492 ( 303 equality;4619 variable)
%            Maximal formula depth :   30 (  13 average)
%            Number of connectives : 5123 (  35   ~;   1   |;  33   &;4795   @)
%                                         (   0 <=>; 259  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  : 1735 (1735   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   60 (  55   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1907 (  19 sgn;1384   !;  27   ?; 418   ^)
%                                         (1907   :;  78  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 15:13:48.760
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (49)
thf(sy_c_BNF__Def_Orel__fun,type,(
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) )).

thf(sy_c_Basic__BNFs_Opred__fun,type,(
    basic_pred_fun: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Coinductive__List_Oiterates,type,(
    coinductive_iterates: 
      !>[A: $tType] :
        ( ( A > A ) > A > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Ocorec__llist,type,(
    coindu1259883913_llist: 
      !>[C: $tType,A: $tType] :
        ( ( C > $o ) > ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Ollist__all2,type,(
    coindu1486289336t_all2: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Opred__llist,type,(
    coindu543516966_llist: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ollist__of__stream,type,(
    coindu1724414836stream: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__from__llist__setup_Ocr__stream,type,(
    coindu1183105481stream: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__from__llist__setup_Opcr__stream,type,(
    coindu773941317stream: 
      !>[C: $tType,B: $tType] :
        ( ( C > B > $o ) > ( coinductive_llist @ C ) > ( stream @ B ) > $o ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__of__llist,type,(
    coindu2010755910_llist: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( stream @ A ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ounfold__stream,type,(
    coindu139217191stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > A ) > A > ( stream @ B ) ) )).

thf(sy_c_Complete__Partial__Order_Omonotone,type,(
    comple1396247847notone: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Omap__fun,type,(
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] :
        ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lifting_Orel__pred__comp,type,(
    rel_pred_comp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( B > $o ) > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Partial__Function_Ofun__ord,type,(
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) )).

thf(sy_c_Partial__Function_Oimg__ord,type,(
    partial_img_ord: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( C > C > B ) > A > A > B ) )).

thf(sy_c_Partial__Function_Omk__less,type,(
    partial_mk_less: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Quotient_OBex1__rel,type,(
    bex1_rel: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > $o ) )).

thf(sy_c_Quotient_OQuotient3,type,(
    quotient3: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) )).

thf(sy_c_Relation_ODomainp,type,(
    domainp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > A > $o ) )).

thf(sy_c_Relation_OPowp,type,(
    powp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Relation_Oreflp,type,(
    reflp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > $o ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Set_OBall,type,(
    ball: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OBex,type,(
    bex: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Stream_Ositerate,type,(
    siterate: 
      !>[A: $tType] :
        ( ( A > A ) > A > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Ocase__stream,type,(
    case_stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Stream_Ostream_Ocorec__stream,type,(
    corec_stream: 
      !>[C: $tType,A: $tType] :
        ( ( C > A ) > ( C > $o ) > ( C > ( stream @ A ) ) > ( C > C ) > C > ( stream @ A ) ) )).

thf(sy_c_Stream_Ostream_Opred__stream,type,(
    pred_stream: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Ostream_Ostream__all2,type,(
    stream_all2: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( stream @ A ) > ( stream @ B ) > $o ) )).

thf(sy_c_Transfer_Obi__total,type,(
    bi_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Oleft__total,type,(
    left_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Orev__implies,type,(
    rev_implies: $o > $o > $o )).

thf(sy_c_Transfer_Oright__total,type,(
    right_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Otransfer__bforall,type,(
    transfer_bforall: 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > $o ) > $o ) )).

thf(sy_c_Transfer_Otransfer__forall,type,(
    transfer_forall: 
      !>[A: $tType] :
        ( ( A > $o ) > $o ) )).

thf(sy_c_Typedef_Otype__definition,type,(
    type_definition: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_xb,type,(
    xb: a > ( coinductive_llist @ b ) )).

thf(sy_v_yb,type,(
    yb: a > ( stream @ b ) )).

%----Relevant facts (256)
thf(fact_0_stream_ORep__inject,axiom,(
    ! [A: $tType,X: ( stream @ A ),Y: ( stream @ A )] :
      ( ( ( coindu1724414836stream @ A @ X )
        = ( coindu1724414836stream @ A @ Y ) )
      = ( X = Y ) ) )).

% stream.Rep_inject
thf(fact_1_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F: ( B > A ),G: ( C > B ),X2: C] :
            ( F @ ( G @ X2 ) ) ) ) )).

% comp_apply
thf(fact_2_rel__funI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F2: ( A > C ),G2: ( B > D )] :
      ( ! [X3: A,Y2: B] :
          ( ( A2 @ X3 @ Y2 )
         => ( B2 @ ( F2 @ X3 ) @ ( G2 @ Y2 ) ) )
     => ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F2 @ G2 ) ) )).

% rel_funI
thf(fact_3_fun_Orel__map_I2_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sa: ( A > C > $o ),X: ( D > A ),G2: ( B > C ),Y: ( D > B )] :
      ( ( bNF_rel_fun @ D @ D @ A @ C
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ Sa
        @ X
        @ ( comp @ B @ C @ D @ G2 @ Y ) )
      = ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ^ [X2: A,Y4: B] :
            ( Sa @ X2 @ ( G2 @ Y4 ) )
        @ X
        @ Y ) ) )).

% fun.rel_map(2)
thf(fact_4_fun_Orel__map_I1_J,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,Sb: ( C > B > $o ),I: ( A > C ),X: ( D > A ),Y: ( D > B )] :
      ( ( bNF_rel_fun @ D @ D @ C @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ Sb
        @ ( comp @ A @ C @ D @ I @ X )
        @ Y )
      = ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ^ [X2: A] :
            ( Sb @ ( I @ X2 ) )
        @ X
        @ Y ) ) )).

% fun.rel_map(1)
thf(fact_5_o__rsp_I2_J,axiom,(
    ! [E: $tType,F3: $tType,H: $tType,G3: $tType,R1: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( G3 > H ) @ ( G3 > H ) @ ( ( E > G3 ) > E > H ) @ ( ( F3 > G3 ) > F3 > H )
      @ ^ [Y3: ( G3 > H ),Z: ( G3 > H )] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( E > G3 ) @ ( F3 > G3 ) @ ( E > H ) @ ( F3 > H )
        @ ( bNF_rel_fun @ E @ F3 @ G3 @ G3 @ R1
          @ ^ [Y3: G3,Z: G3] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ E @ F3 @ H @ H @ R1
          @ ^ [Y3: H,Z: H] : ( Y3 = Z ) ) )
      @ ( comp @ G3 @ H @ E )
      @ ( comp @ G3 @ H @ F3 ) ) )).

% o_rsp(2)
thf(fact_6_o__rsp_I1_J,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,D: $tType,C: $tType,R2: ( A > C > $o ),R3: ( B > D > $o ),R1: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F3 > C ) > F3 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ R2 @ R3 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F3 > C ) @ ( E > B ) @ ( F3 > D ) @ ( bNF_rel_fun @ E @ F3 @ A @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ E @ F3 @ B @ D @ R1 @ R3 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F3 ) ) )).

% o_rsp(1)
thf(fact_7_fun_Omap__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,G3: $tType,F3: $tType,Rb: ( A > F3 > $o ),Sd: ( B > G3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( F3 > G3 ) @ ( ( D > A ) > D > B ) @ ( ( D > F3 ) > D > G3 ) @ ( bNF_rel_fun @ A @ F3 @ B @ G3 @ Rb @ Sd )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > F3 ) @ ( D > B ) @ ( D > G3 )
        @ ( bNF_rel_fun @ D @ D @ A @ F3
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Rb )
        @ ( bNF_rel_fun @ D @ D @ B @ G3
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Sd ) )
      @ ( comp @ A @ B @ D )
      @ ( comp @ F3 @ G3 @ D ) ) )).

% fun.map_transfer
thf(fact_8_comp__transfer,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,D: $tType,C: $tType,B2: ( A > C > $o ),C2: ( B > D > $o ),A2: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F3 > C ) > F3 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ B2 @ C2 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F3 > C ) @ ( E > B ) @ ( F3 > D ) @ ( bNF_rel_fun @ E @ F3 @ A @ C @ A2 @ B2 ) @ ( bNF_rel_fun @ E @ F3 @ B @ D @ A2 @ C2 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F3 ) ) )).

% comp_transfer
thf(fact_9_K__record__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,C3: B,F2: ( A > C )] :
      ( ( comp @ C @ B @ A
        @ ^ [X2: C] : C3
        @ F2 )
      = ( ^ [X2: A] : C3 ) ) )).

% K_record_comp
thf(fact_10_fun_Omap__ident,axiom,(
    ! [A: $tType,D: $tType,T: ( D > A )] :
      ( ( comp @ A @ A @ D
        @ ^ [X2: A] : X2
        @ T )
      = T ) )).

% fun.map_ident
thf(fact_11_stream__from__llist__setup_Ocr__stream__def,axiom,(
    ! [A: $tType] :
      ( ( coindu1183105481stream @ A )
      = ( ^ [X2: ( coinductive_llist @ A ),Y4: ( stream @ A )] :
            ( X2
            = ( coindu1724414836stream @ A @ Y4 ) ) ) ) )).

% stream_from_llist_setup.cr_stream_def
thf(fact_12_llist__of__stream__corec__stream,axiom,(
    ! [A: $tType,B: $tType,SHD: ( B > A ),EndORmore: ( B > $o ),STL_more: ( B > ( stream @ A ) ),STL_end: ( B > B ),X: B] :
      ( ( coindu1724414836stream @ A @ ( corec_stream @ B @ A @ SHD @ EndORmore @ STL_more @ STL_end @ X ) )
      = ( coindu1259883913_llist @ B @ A
        @ ^ [Uu: B] : $false
        @ SHD
        @ EndORmore
        @ ( comp @ ( stream @ A ) @ ( coinductive_llist @ A ) @ B @ ( coindu1724414836stream @ A ) @ STL_more )
        @ STL_end
        @ X ) ) )).

% llist_of_stream_corec_stream
thf(fact_13_rel__fun__def__butlast,axiom,(
    ! [B: $tType,D: $tType,C: $tType,E: $tType,F3: $tType,A: $tType,R: ( A > B > $o ),S: ( C > E > $o ),T2: ( D > F3 > $o ),F2: ( A > C > D ),G2: ( B > E > F3 )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > D ) @ ( E > F3 ) @ R @ ( bNF_rel_fun @ C @ E @ D @ F3 @ S @ T2 ) @ F2 @ G2 )
      = ( ! [X2: A,Y4: B] :
            ( ( R @ X2 @ Y4 )
           => ( bNF_rel_fun @ C @ E @ D @ F3 @ S @ T2 @ ( F2 @ X2 ) @ ( G2 @ Y4 ) ) ) ) ) )).

% rel_fun_def_butlast
thf(fact_14_If__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( B > B > B )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A2 @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) )
      @ ( if @ A )
      @ ( if @ B ) ) )).

% If_transfer
thf(fact_15_fun_Orel__transfer,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E: $tType,D: $tType,Sa: ( A > C > $o ),Sc: ( B > E > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > E > $o ) @ ( ( D > A ) > ( D > B ) > $o ) @ ( ( D > C ) > ( D > E ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( E > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ E @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > C ) @ ( ( D > B ) > $o ) @ ( ( D > E ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ C
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Sa )
        @ ( bNF_rel_fun @ ( D > B ) @ ( D > E ) @ $o @ $o
          @ ( bNF_rel_fun @ D @ D @ B @ E
            @ ^ [Y3: D,Z: D] : ( Y3 = Z )
            @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ D @ D @ C @ E
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) ) ) )).

% fun.rel_transfer
thf(fact_16_fun_Orel__refl,axiom,(
    ! [B: $tType,D: $tType,Ra: ( B > B > $o ),X: ( D > B )] :
      ( ! [X3: B] :
          ( Ra @ X3 @ X3 )
     => ( bNF_rel_fun @ D @ D @ B @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ Ra
        @ X
        @ X ) ) )).

% fun.rel_refl
thf(fact_17_fun_Orel__eq,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( D > A ),Z: ( D > A )] : ( Y3 = Z ) ) ) )).

% fun.rel_eq
thf(fact_18_rel__fun__mono_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Y5: ( A > B > $o ),X4: ( A > B > $o ),A2: ( C > D > $o ),B2: ( C > D > $o ),F2: ( A > C ),G2: ( B > D )] :
      ( ! [X3: A,Y2: B] :
          ( ( Y5 @ X3 @ Y2 )
         => ( X4 @ X3 @ Y2 ) )
     => ( ! [X3: C,Y2: D] :
            ( ( A2 @ X3 @ Y2 )
           => ( B2 @ X3 @ Y2 ) )
       => ( ( bNF_rel_fun @ A @ B @ C @ D @ X4 @ A2 @ F2 @ G2 )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y5 @ B2 @ F2 @ G2 ) ) ) ) )).

% rel_fun_mono'
thf(fact_19_rel__fun__mono,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,X4: ( A > B > $o ),A2: ( C > D > $o ),F2: ( A > C ),G2: ( B > D ),Y5: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ X4 @ A2 @ F2 @ G2 )
     => ( ! [X3: A,Y2: B] :
            ( ( Y5 @ X3 @ Y2 )
           => ( X4 @ X3 @ Y2 ) )
       => ( ! [X3: C,Y2: D] :
              ( ( A2 @ X3 @ Y2 )
             => ( B2 @ X3 @ Y2 ) )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y5 @ B2 @ F2 @ G2 ) ) ) ) )).

% rel_fun_mono
thf(fact_20_let__rsp,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ R1 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 ) @ R2 )
      @ ^ [S2: A,F: ( A > C )] :
          ( F @ S2 )
      @ ^ [S2: B,F: ( B > D )] :
          ( F @ S2 ) ) )).

% let_rsp
thf(fact_21_rel__funD,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F2: ( A > C ),G2: ( B > D ),X: A,Y: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F2 @ G2 )
     => ( ( A2 @ X @ Y )
       => ( B2 @ ( F2 @ X ) @ ( G2 @ Y ) ) ) ) )).

% rel_funD
thf(fact_22_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G2: ( C > B ),H2: ( A > C ),R12: ( D > B ),R22: ( A > D ),F2: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G2 @ H2 )
        = ( comp @ D @ B @ A @ R12 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F2 @ R12 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F2 @ G2 ) @ H2 )
          = ( comp @ D @ E @ A @ L @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_23_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F2: ( C > B ),G2: ( A > C ),L1: ( D > B ),L2: ( A > D ),H2: ( E > A ),R4: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F2 @ G2 )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H2 )
          = R4 )
       => ( ( comp @ C @ B @ E @ F2 @ ( comp @ A @ C @ E @ G2 @ H2 ) )
          = ( comp @ D @ B @ E @ L1 @ R4 ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_24_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G2: ( C > B ),H2: ( A > C ),R4: ( A > B ),F2: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G2 @ H2 )
        = R4 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F2 @ G2 ) @ H2 )
        = ( comp @ B @ D @ A @ F2 @ R4 ) ) ) )).

% rewriteR_comp_comp
thf(fact_25_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F2: ( C > B ),G2: ( A > C ),L: ( A > B ),H2: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F2 @ G2 )
        = L )
     => ( ( comp @ C @ B @ D @ F2 @ ( comp @ A @ C @ D @ G2 @ H2 ) )
        = ( comp @ A @ B @ D @ L @ H2 ) ) ) )).

% rewriteL_comp_comp
thf(fact_26_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G2: ( B > C ),F2: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G2 @ ( comp @ A @ B @ D @ F2 @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G2 @ F2 ) @ V ) ) )).

% fun.map_comp
thf(fact_27_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F2: ( B > A ),G2: ( C > B ),X: C,H2: ( D > A ),K: ( C > D )] :
      ( ( ( F2 @ ( G2 @ X ) )
        = ( H2 @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X )
        = ( comp @ D @ A @ C @ H2 @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_28_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = C3 )
     => ( ( A3 @ ( B3 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_29_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ! [V2: A] :
          ( ( A3 @ ( B3 @ V2 ) )
          = ( C3 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_30_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = ( comp @ D @ B @ A @ C3 @ D2 ) )
     => ( ( A3 @ ( B3 @ V ) )
        = ( C3 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_31_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F2: ( D > B ),G2: ( C > D ),H2: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F2 @ G2 ) @ H2 )
      = ( comp @ D @ B @ A @ F2 @ ( comp @ C @ D @ A @ G2 @ H2 ) ) ) )).

% comp_assoc
thf(fact_32_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F: ( B > C ),G: ( A > B ),X2: A] :
            ( F @ ( G @ X2 ) ) ) ) )).

% comp_def
thf(fact_33_Let__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ A2 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ B2 )
      @ ^ [S2: A,F: ( A > C )] :
          ( F @ S2 )
      @ ^ [S2: B,F: ( B > D )] :
          ( F @ S2 ) ) )).

% Let_transfer
thf(fact_34_stream_Ocorec__disc,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( corec_stream @ C @ A )
      = ( corec_stream @ C @ A ) ) )).

% stream.corec_disc
thf(fact_35_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G2: ( C > B ),X: C,N: ( D > A ),H2: ( C > D ),F2: ( A > E )] :
      ( ( ( M @ ( G2 @ X ) )
        = ( N @ ( H2 @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F2 @ M ) @ G2 @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F2 @ N ) @ H2 @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_36_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F2: ( B > A ),G2: ( C > B ),X: C,F4: ( D > A ),G4: ( E > D ),X5: E] :
      ( ( ( F2 @ ( G2 @ X ) )
        = ( F4 @ ( G4 @ X5 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X )
        = ( comp @ D @ A @ E @ F4 @ G4 @ X5 ) ) ) )).

% comp_cong
thf(fact_37_rel__funD2,axiom,(
    ! [B: $tType,C: $tType,A: $tType,A2: ( A > A > $o ),B2: ( B > C > $o ),F2: ( A > B ),G2: ( A > C ),X: A] :
      ( ( bNF_rel_fun @ A @ A @ B @ C @ A2 @ B2 @ F2 @ G2 )
     => ( ( A2 @ X @ X )
       => ( B2 @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) )).

% rel_funD2
thf(fact_38_apply__rsp_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o ),F2: ( A > C ),G2: ( B > D ),X: A,Y: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 @ F2 @ G2 )
     => ( ( R1 @ X @ Y )
       => ( R2 @ ( F2 @ X ) @ ( G2 @ Y ) ) ) ) )).

% apply_rsp'
thf(fact_39_rel__funE,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F2: ( A > C ),G2: ( B > D ),X: A,Y: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F2 @ G2 )
     => ( ( A2 @ X @ Y )
       => ( B2 @ ( F2 @ X ) @ ( G2 @ Y ) ) ) ) )).

% rel_funE
thf(fact_40_stream__from__llist__setup_Ostream_Opcr__cr__eq,axiom,(
    ! [D: $tType] :
      ( ( coindu773941317stream @ D @ D
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) )
      = ( coindu1183105481stream @ D ) ) )).

% stream_from_llist_setup.stream.pcr_cr_eq
thf(fact_41_stream__of__llist__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( coindu2010755910_llist @ A @ ( coindu1724414836stream @ A @ Xs ) )
      = Xs ) )).

% stream_of_llist_llist_of_stream
thf(fact_42_stream_ORep__inverse,axiom,(
    ! [A: $tType,X: ( stream @ A )] :
      ( ( coindu2010755910_llist @ A @ ( coindu1724414836stream @ A @ X ) )
      = X ) )).

% stream.Rep_inverse
thf(fact_43_map__fun__parametric,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,H: $tType,G3: $tType,D: $tType,C: $tType,A2: ( A > C > $o ),B2: ( B > D > $o ),C2: ( E > G3 > $o ),D3: ( F3 > H > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > F3 ) > ( B > E ) > A > F3 ) @ ( ( G3 > H ) > ( D > G3 ) > C > H ) @ ( bNF_rel_fun @ A @ C @ B @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( E > F3 ) @ ( G3 > H ) @ ( ( B > E ) > A > F3 ) @ ( ( D > G3 ) > C > H ) @ ( bNF_rel_fun @ E @ G3 @ F3 @ H @ C2 @ D3 ) @ ( bNF_rel_fun @ ( B > E ) @ ( D > G3 ) @ ( A > F3 ) @ ( C > H ) @ ( bNF_rel_fun @ B @ D @ E @ G3 @ B2 @ C2 ) @ ( bNF_rel_fun @ A @ C @ F3 @ H @ A2 @ D3 ) ) ) @ ( map_fun @ A @ B @ E @ F3 ) @ ( map_fun @ C @ D @ G3 @ H ) ) )).

% map_fun_parametric
thf(fact_44_map__fun__apply,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( map_fun @ B @ C @ D @ A )
      = ( ^ [F: ( B > C ),G: ( D > A ),H3: ( C > D ),X2: B] :
            ( G @ ( H3 @ ( F @ X2 ) ) ) ) ) )).

% map_fun_apply
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G2: ( A > B )] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G2 @ X3 ) )
     => ( F2 = G2 ) ) )).

% ext
thf(fact_49_map__fun__def,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType] :
      ( ( map_fun @ C @ A @ B @ D )
      = ( ^ [F: ( C > A ),G: ( B > D ),H3: ( A > B )] :
            ( comp @ A @ D @ C @ ( comp @ B @ D @ A @ G @ H3 ) @ F ) ) ) )).

% map_fun_def
thf(fact_50_map__fun_Ocomp,axiom,(
    ! [E: $tType,C: $tType,A: $tType,F3: $tType,D: $tType,B: $tType,F2: ( E > C ),G2: ( D > F3 ),H2: ( C > A ),I: ( B > D )] :
      ( ( comp @ ( C > D ) @ ( E > F3 ) @ ( A > B ) @ ( map_fun @ E @ C @ D @ F3 @ F2 @ G2 ) @ ( map_fun @ C @ A @ B @ D @ H2 @ I ) )
      = ( map_fun @ E @ A @ B @ F3 @ ( comp @ C @ A @ E @ H2 @ F2 ) @ ( comp @ D @ F3 @ B @ G2 @ I ) ) ) )).

% map_fun.comp
thf(fact_51_map__fun_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,C: $tType,E: $tType,B: $tType,A: $tType,F2: ( E > C ),G2: ( D > F3 ),H2: ( C > A ),I: ( B > D ),Fun: ( A > B )] :
      ( ( map_fun @ E @ C @ D @ F3 @ F2 @ G2 @ ( map_fun @ C @ A @ B @ D @ H2 @ I @ Fun ) )
      = ( map_fun @ E @ A @ B @ F3 @ ( comp @ C @ A @ E @ H2 @ F2 ) @ ( comp @ D @ F3 @ B @ G2 @ I ) @ Fun ) ) )).

% map_fun.compositionality
thf(fact_52_fun_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( D > A ) > $o ) @ ( ( D > B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > B ) @ $o @ $o
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ R )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true )
      @ ( basic_pred_fun @ D @ B
        @ ^ [Uu: D] : $true ) ) )).

% fun.pred_transfer
thf(fact_53_if__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( A > A > A )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( bNF_rel_fun @ A @ A @ ( A > A ) @ ( A > A ) @ R @ ( bNF_rel_fun @ A @ A @ A @ A @ R @ R ) )
        @ ( if @ A )
        @ ( if @ A ) ) ) )).

% if_rsp
thf(fact_54_stream_Ocorec__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( C > $o ) > ( C > ( stream @ A ) ) > ( C > C ) > C > ( stream @ A ) ) @ ( ( D > $o ) > ( D > ( stream @ B ) ) > ( D > D ) > D > ( stream @ B ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ S @ R )
      @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( stream @ A ) ) > ( C > C ) > C > ( stream @ A ) ) @ ( ( D > ( stream @ B ) ) > ( D > D ) > D > ( stream @ B ) )
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ ( C > ( stream @ A ) ) @ ( D > ( stream @ B ) ) @ ( ( C > C ) > C > ( stream @ A ) ) @ ( ( D > D ) > D > ( stream @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( stream @ A ) @ ( stream @ B ) @ S @ ( stream_all2 @ A @ B @ R ) ) @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( C > ( stream @ A ) ) @ ( D > ( stream @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S @ S ) @ ( bNF_rel_fun @ C @ D @ ( stream @ A ) @ ( stream @ B ) @ S @ ( stream_all2 @ A @ B @ R ) ) ) ) )
      @ ( corec_stream @ C @ A )
      @ ( corec_stream @ D @ B ) ) )).

% stream.corec_transfer
thf(fact_55_unfold__stream__transfer,axiom,(
    ! [B: $tType,A: $tType] :
      ( bNF_rel_fun @ ( A > B ) @ ( A > B ) @ ( ( A > A ) > A > ( coinductive_llist @ B ) ) @ ( ( A > A ) > A > ( stream @ B ) )
      @ ^ [Y3: ( A > B ),Z: ( A > B )] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( A > A ) @ ( A > A ) @ ( A > ( coinductive_llist @ B ) ) @ ( A > ( stream @ B ) )
        @ ^ [Y3: ( A > A ),Z: ( A > A )] : ( Y3 = Z )
        @ ( bNF_rel_fun @ A @ A @ ( coinductive_llist @ B ) @ ( stream @ B )
          @ ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ ( coindu773941317stream @ B @ B
            @ ^ [Y3: B,Z: B] : ( Y3 = Z ) ) ) )
      @ ( coindu1441602521_llist @ A @ B
        @ ^ [Uu: A] : $false )
      @ ( coindu139217191stream @ A @ B ) ) )).

% unfold_stream_transfer
thf(fact_56_fun__ord__parametric,axiom,(
    ! [C: $tType,D: $tType,A: $tType,B: $tType,F3: $tType,E: $tType,C2: ( A > B > $o ),A2: ( C > E > $o ),B2: ( D > F3 > $o )] :
      ( ( bi_total @ A @ B @ C2 )
     => ( bNF_rel_fun @ ( C > D > $o ) @ ( E > F3 > $o ) @ ( ( A > C ) > ( A > D ) > $o ) @ ( ( B > E ) > ( B > F3 ) > $o )
        @ ( bNF_rel_fun @ C @ E @ ( D > $o ) @ ( F3 > $o ) @ A2
          @ ( bNF_rel_fun @ D @ F3 @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > C ) @ ( B > E ) @ ( ( A > D ) > $o ) @ ( ( B > F3 ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ E @ C2 @ A2 )
          @ ( bNF_rel_fun @ ( A > D ) @ ( B > F3 ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ D @ F3 @ C2 @ B2 )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( partial_fun_ord @ C @ D @ A )
        @ ( partial_fun_ord @ E @ F3 @ B ) ) ) )).

% fun_ord_parametric
thf(fact_57_llist__of__stream__stream__of__llist,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coindu1724414836stream @ A @ ( coindu2010755910_llist @ A @ Xs ) )
        = Xs ) ) )).

% llist_of_stream_stream_of_llist
thf(fact_58_cr__streamI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( coindu1183105481stream @ A @ Xs @ ( coindu2010755910_llist @ A @ Xs ) ) ) )).

% cr_streamI
thf(fact_59_stream_OAbs__inverse,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Y
        @ ( collect @ ( coinductive_llist @ A )
          @ ^ [Xs2: ( coinductive_llist @ A )] :
              ~ ( coinductive_lfinite @ A @ Xs2 ) ) )
     => ( ( coindu1724414836stream @ A @ ( coindu2010755910_llist @ A @ Y ) )
        = Y ) ) )).

% stream.Abs_inverse
thf(fact_60_llist__of__stream__unfold__stream,axiom,(
    ! [A: $tType,B: $tType,SHD: ( B > A ),STL: ( B > B ),X: B] :
      ( ( coindu1724414836stream @ A @ ( coindu139217191stream @ B @ A @ SHD @ STL @ X ) )
      = ( coindu1441602521_llist @ B @ A
        @ ^ [Uu: B] : $false
        @ SHD
        @ STL
        @ X ) ) )).

% llist_of_stream_unfold_stream
thf(fact_61_stream_Odisc__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( stream @ A ) @ ( stream @ B ) @ $o @ $o @ ( stream_all2 @ A @ B @ R )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ^ [Stream: ( stream @ A )] : ( Stream = Stream )
      @ ^ [Stream: ( stream @ B )] : ( Stream = Stream ) ) )).

% stream.disc_transfer
thf(fact_62_stream_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X: ( stream @ B )] :
      ( ! [X3: B] :
          ( Ra @ X3 @ X3 )
     => ( stream_all2 @ B @ B @ Ra @ X @ X ) ) )).

% stream.rel_refl
thf(fact_63_stream_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( stream_all2 @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( stream @ A ),Z: ( stream @ A )] : ( Y3 = Z ) ) ) )).

% stream.rel_eq
thf(fact_64_stream_Obi__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ R )
     => ( bi_total @ ( stream @ A ) @ ( stream @ B ) @ ( stream_all2 @ A @ B @ R ) ) ) )).

% stream.bi_total_rel
thf(fact_65_bi__total__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_total @ A @ B )
      = ( ^ [R5: ( A > B > $o )] :
            ( ! [X2: A] :
                ( ^ [P2: ( B > $o )] :
                  ? [X6: B] :
                    ( P2 @ X6 )
                @ ( R5 @ X2 ) )
            & ! [Y4: B] :
              ? [X2: A] :
                ( R5 @ X2 @ Y4 ) ) ) ) )).

% bi_total_def
thf(fact_66_bi__total__eq,axiom,(
    ! [A: $tType] :
      ( bi_total @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% bi_total_eq
thf(fact_67_Quotient3__rep__reflp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( R @ ( Rep @ A3 ) @ ( Rep @ A3 ) ) ) )).

% Quotient3_rep_reflp
thf(fact_68_Quotient3__rep__abs,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R4: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R4 @ R4 )
       => ( R @ ( Rep @ ( Abs @ R4 ) ) @ R4 ) ) ) )).

% Quotient3_rep_abs
thf(fact_69_Quotient3__rel__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B,B3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ ( Rep @ A3 ) @ ( Rep @ B3 ) )
        = ( A3 = B3 ) ) ) )).

% Quotient3_rel_rep
thf(fact_70_Quotient3__rel__abs,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R4: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R4 @ S3 )
       => ( ( Abs @ R4 )
          = ( Abs @ S3 ) ) ) ) )).

% Quotient3_rel_abs
thf(fact_71_Quotient3__abs__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( Abs @ ( Rep @ A3 ) )
        = A3 ) ) )).

% Quotient3_abs_rep
thf(fact_72_rep__abs__rsp__left,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X22: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ X1 @ X22 )
       => ( R @ ( Rep @ ( Abs @ X1 ) ) @ X22 ) ) ) )).

% rep_abs_rsp_left
thf(fact_73_Quotient3__refl2,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R4: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R4 @ S3 )
       => ( R @ S3 @ S3 ) ) ) )).

% Quotient3_refl2
thf(fact_74_Quotient3__refl1,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R4: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R4 @ S3 )
       => ( R @ R4 @ R4 ) ) ) )).

% Quotient3_refl1
thf(fact_75_Quotient3__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R4: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( ( R @ R4 @ R4 )
          & ( R @ S3 @ S3 )
          & ( ( Abs @ R4 )
            = ( Abs @ S3 ) ) )
        = ( R @ R4 @ S3 ) ) ) )).

% Quotient3_rel
thf(fact_76_Quotient3__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( quotient3 @ A @ B )
      = ( ^ [R5: ( A > A > $o ),Abs2: ( A > B ),Rep2: ( B > A )] :
            ( ! [A4: B] :
                ( ( Abs2 @ ( Rep2 @ A4 ) )
                = A4 )
            & ! [A4: B] :
                ( R5 @ ( Rep2 @ A4 ) @ ( Rep2 @ A4 ) )
            & ! [R6: A,S2: A] :
                ( ( R5 @ R6 @ S2 )
                = ( ( R5 @ R6 @ R6 )
                  & ( R5 @ S2 @ S2 )
                  & ( ( Abs2 @ R6 )
                    = ( Abs2 @ S2 ) ) ) ) ) ) ) )).

% Quotient3_def
thf(fact_77_rep__abs__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X22: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ X1 @ X22 )
       => ( R @ X1 @ ( Rep @ ( Abs @ X22 ) ) ) ) ) )).

% rep_abs_rsp
thf(fact_78_pred__funI,axiom,(
    ! [B: $tType,A: $tType,A2: ( A > $o ),B2: ( B > $o ),F2: ( A > B )] :
      ( ! [X3: A] :
          ( ( A2 @ X3 )
         => ( B2 @ ( F2 @ X3 ) ) )
     => ( basic_pred_fun @ A @ B @ A2 @ B2 @ F2 ) ) )).

% pred_funI
thf(fact_79_equals__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),Xa: A,Xb: A,Ya: A,Yb: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ Xa @ Xb )
       => ( ( R @ Ya @ Yb )
         => ( ( R @ Xa @ Ya )
            = ( R @ Xb @ Yb ) ) ) ) ) )).

% equals_rsp
thf(fact_80_Quotient3I,axiom,(
    ! [B: $tType,A: $tType,Abs: ( B > A ),Rep: ( A > B ),R: ( B > B > $o )] :
      ( ! [A5: A] :
          ( ( Abs @ ( Rep @ A5 ) )
          = A5 )
     => ( ! [A5: A] :
            ( R @ ( Rep @ A5 ) @ ( Rep @ A5 ) )
       => ( ! [R7: B,S4: B] :
              ( ( R @ R7 @ S4 )
              = ( ( R @ R7 @ R7 )
                & ( R @ S4 @ S4 )
                & ( ( Abs @ R7 )
                  = ( Abs @ S4 ) ) ) )
         => ( quotient3 @ B @ A @ R @ Abs @ Rep ) ) ) ) )).

% Quotient3I
thf(fact_81_cond__prs,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A ),A3: $o,B3: B,C3: B] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( ( A3
         => ( ( Absf @ ( if @ A @ A3 @ ( Repf @ B3 ) @ ( Repf @ C3 ) ) )
            = B3 ) )
        & ( ~ ( A3 )
         => ( ( Absf @ ( if @ A @ A3 @ ( Repf @ B3 ) @ ( Repf @ C3 ) ) )
            = C3 ) ) ) ) )).

% cond_prs
thf(fact_82_fun_Opred__True,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: ( D > A )] : $true ) ) )).

% fun.pred_True
thf(fact_83_fun__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R2: ( C > C > $o ),Abs22: ( C > D ),Rep22: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs22 @ Rep22 )
       => ( quotient3 @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 ) @ ( map_fun @ B @ A @ C @ D @ Rep1 @ Abs22 ) @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep22 ) ) ) ) )).

% fun_quotient3
thf(fact_84_apply__rspQ3_H_H,axiom,(
    ! [C: $tType,A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),S: ( C > C > $o ),F2: ( A > C ),X: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R @ S @ F2 @ F2 )
       => ( S @ ( F2 @ ( Rep @ X ) ) @ ( F2 @ ( Rep @ X ) ) ) ) ) )).

% apply_rspQ3''
thf(fact_85_apply__rspQ3,axiom,(
    ! [B: $tType,C: $tType,A: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),F2: ( A > C ),G2: ( A > C ),X: A,Y: A] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 @ F2 @ G2 )
       => ( ( R1 @ X @ Y )
         => ( R2 @ ( F2 @ X ) @ ( G2 @ Y ) ) ) ) ) )).

% apply_rspQ3
thf(fact_86_let__prs,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs23: ( C > D ),Rep23: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs23 @ Rep23 )
       => ( ( map_fun @ D @ C @ ( ( C > A ) > A ) @ ( ( D > B ) > B ) @ Rep23 @ ( map_fun @ ( D > B ) @ ( C > A ) @ A @ B @ ( map_fun @ C @ D @ B @ A @ Abs23 @ Rep12 ) @ Abs12 )
            @ ^ [S2: C,F: ( C > A )] :
                ( F @ S2 ) )
          = ( ^ [S2: D,F: ( D > B )] :
                ( F @ S2 ) ) ) ) ) )).

% let_prs
thf(fact_87_lfinite__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ~ ( coinductive_lfinite @ A @ ( coindu1724414836stream @ A @ Xs ) ) )).

% lfinite_llist_of_stream
thf(fact_88_lambda__prs1,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs23: ( C > D ),Rep23: ( D > C ),F2: ( B > D )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs23 @ Rep23 )
       => ( ( map_fun @ B @ A @ C @ D @ Rep12 @ Abs23 @ ( map_fun @ A @ B @ D @ C @ Abs12 @ Rep23 @ F2 ) )
          = F2 ) ) ) )).

% lambda_prs1
thf(fact_89_lambda__prs,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs23: ( C > D ),Rep23: ( D > C ),F2: ( B > D )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs23 @ Rep23 )
       => ( ( map_fun @ B @ A @ C @ D @ Rep12 @ Abs23
            @ ^ [X2: A] :
                ( Rep23 @ ( F2 @ ( Abs12 @ X2 ) ) ) )
          = F2 ) ) ) )).

% lambda_prs
thf(fact_90_stream_ORep__induct,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ Y
        @ ( collect @ ( coinductive_llist @ A )
          @ ^ [Xs2: ( coinductive_llist @ A )] :
              ~ ( coinductive_lfinite @ A @ Xs2 ) ) )
     => ( ! [X3: ( stream @ A )] :
            ( P @ ( coindu1724414836stream @ A @ X3 ) )
       => ( P @ Y ) ) ) )).

% stream.Rep_induct
thf(fact_91_stream_ORep__cases,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Y
        @ ( collect @ ( coinductive_llist @ A )
          @ ^ [Xs2: ( coinductive_llist @ A )] :
              ~ ( coinductive_lfinite @ A @ Xs2 ) ) )
     => ~ ( ! [X3: ( stream @ A )] :
              ( Y
             != ( coindu1724414836stream @ A @ X3 ) ) ) ) )).

% stream.Rep_cases
thf(fact_92_stream_ORep,axiom,(
    ! [A: $tType,X: ( stream @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coindu1724414836stream @ A @ X )
      @ ( collect @ ( coinductive_llist @ A )
        @ ^ [Xs2: ( coinductive_llist @ A )] :
            ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) )).

% stream.Rep
thf(fact_93_stream_OAbs__cases,axiom,(
    ! [A: $tType,X: ( stream @ A )] :
      ~ ( ! [Y2: ( coinductive_llist @ A )] :
            ( ( X
              = ( coindu2010755910_llist @ A @ Y2 ) )
           => ~ ( member @ ( coinductive_llist @ A ) @ Y2
                @ ( collect @ ( coinductive_llist @ A )
                  @ ^ [Xs2: ( coinductive_llist @ A )] :
                      ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% stream.Abs_cases
thf(fact_94_stream_OAbs__induct,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),X: ( stream @ A )] :
      ( ! [Y2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ Y2
            @ ( collect @ ( coinductive_llist @ A )
              @ ^ [Xs2: ( coinductive_llist @ A )] :
                  ~ ( coinductive_lfinite @ A @ Xs2 ) ) )
         => ( P @ ( coindu2010755910_llist @ A @ Y2 ) ) )
     => ( P @ X ) ) )).

% stream.Abs_induct
thf(fact_95_stream_OAbs__inject,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),Y: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X
        @ ( collect @ ( coinductive_llist @ A )
          @ ^ [Xs2: ( coinductive_llist @ A )] :
              ~ ( coinductive_lfinite @ A @ Xs2 ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Y
          @ ( collect @ ( coinductive_llist @ A )
            @ ^ [Xs2: ( coinductive_llist @ A )] :
                ~ ( coinductive_lfinite @ A @ Xs2 ) ) )
       => ( ( ( coindu2010755910_llist @ A @ X )
            = ( coindu2010755910_llist @ A @ Y ) )
          = ( X = Y ) ) ) ) )).

% stream.Abs_inject
thf(fact_96_unfold__stream__ltl__unroll,axiom,(
    ! [A: $tType,B: $tType,SHD: ( B > A ),STL: ( B > B ),B3: B] :
      ( ( coindu139217191stream @ B @ A @ SHD @ STL @ ( STL @ B3 ) )
      = ( coindu139217191stream @ B @ A @ ( comp @ B @ A @ B @ SHD @ STL ) @ STL @ B3 ) ) )).

% unfold_stream_ltl_unroll
thf(fact_97_stream_Orel__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: ( A > C > $o ),Sc: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( stream @ A ) > ( stream @ B ) > $o ) @ ( ( stream @ C ) > ( stream @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( stream @ A ) @ ( stream @ C ) @ ( ( stream @ B ) > $o ) @ ( ( stream @ D ) > $o ) @ ( stream_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( stream @ B ) @ ( stream @ D ) @ $o @ $o @ ( stream_all2 @ B @ D @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( stream_all2 @ A @ B )
      @ ( stream_all2 @ C @ D ) ) )).

% stream.rel_transfer
thf(fact_98_o__prs_I1_J,axiom,(
    ! [C: $tType,E: $tType,A: $tType,B: $tType,F3: $tType,D: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs23: ( C > D ),Rep23: ( D > C ),R3: ( E > E > $o ),Abs3: ( E > F3 ),Rep3: ( F3 > E )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs23 @ Rep23 )
       => ( ( quotient3 @ E @ F3 @ R3 @ Abs3 @ Rep3 )
         => ( ( map_fun @ ( D > F3 ) @ ( C > E ) @ ( ( A > C ) > A > E ) @ ( ( B > D ) > B > F3 ) @ ( map_fun @ C @ D @ F3 @ E @ Abs23 @ Rep3 ) @ ( map_fun @ ( B > D ) @ ( A > C ) @ ( A > E ) @ ( B > F3 ) @ ( map_fun @ A @ B @ D @ C @ Abs12 @ Rep23 ) @ ( map_fun @ B @ A @ E @ F3 @ Rep12 @ Abs3 ) ) @ ( comp @ C @ E @ A ) )
            = ( comp @ D @ F3 @ B ) ) ) ) ) )).

% o_prs(1)
thf(fact_99_fun_Omap__cong__pred,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),Ya: ( D > A ),F2: ( A > B ),G2: ( A > B )] :
      ( ( X = Ya )
     => ( ( basic_pred_fun @ D @ A
          @ ^ [Uu: D] : $true
          @ ^ [Z2: A] :
              ( ( F2 @ Z2 )
              = ( G2 @ Z2 ) )
          @ Ya )
       => ( ( comp @ A @ B @ D @ F2 @ X )
          = ( comp @ A @ B @ D @ G2 @ Ya ) ) ) ) )).

% fun.map_cong_pred
thf(fact_100_fun_Opred__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,Q: ( B > $o ),F2: ( A > B ),X: ( D > A )] :
      ( ( basic_pred_fun @ D @ B
        @ ^ [Uu: D] : $true
        @ Q
        @ ( comp @ A @ B @ D @ F2 @ X ) )
      = ( basic_pred_fun @ D @ A
        @ ^ [Uu: D] : $true
        @ ( comp @ B @ $o @ A @ Q @ F2 )
        @ X ) ) )).

% fun.pred_map
thf(fact_101_quot__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( bNF_rel_fun @ A @ A @ ( A > $o ) @ ( A > $o ) @ R
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ R
        @ R ) ) )).

% quot_rel_rsp
thf(fact_102_corec__llist__never__stop,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),MORE: ( B > ( coinductive_llist @ A ) ),LTL: ( B > B ),X: B] :
      ( ( coindu1259883913_llist @ B @ A @ IS_LNIL @ LHD
        @ ^ [Uu: B] : $false
        @ MORE
        @ LTL
        @ X )
      = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ X ) ) )).

% corec_llist_never_stop
thf(fact_103_unfold__llist__ltl__unroll,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B3: B] :
      ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B3 ) )
      = ( coindu1441602521_llist @ B @ A @ ( comp @ B @ $o @ B @ IS_LNIL @ LTL ) @ ( comp @ B @ A @ B @ LHD @ LTL ) @ LTL @ B3 ) ) )).

% unfold_llist_ltl_unroll
thf(fact_104_monotone__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( C > C > $o ) > ( A > C ) > $o ) @ ( ( D > D > $o ) > ( B > D ) > $o )
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( C > C > $o ) @ ( D > D > $o ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o )
          @ ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B2
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( comple1396247847notone @ A @ C )
        @ ( comple1396247847notone @ B @ D ) ) ) )).

% monotone_parametric
thf(fact_105_stream_Otype__definition__axioms,axiom,(
    ! [A: $tType] :
      ( type_definition @ ( stream @ A ) @ ( coinductive_llist @ A ) @ ( coindu1724414836stream @ A ) @ ( coindu2010755910_llist @ A )
      @ ( collect @ ( coinductive_llist @ A )
        @ ^ [Xs2: ( coinductive_llist @ A )] :
            ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) )).

% stream.type_definition_axioms
thf(fact_106_relcompp__transfer,axiom,(
    ! [C: $tType,A: $tType,E: $tType,F3: $tType,B: $tType,D: $tType,B2: ( A > B > $o ),A2: ( C > D > $o ),C2: ( E > F3 > $o )] :
      ( ( bi_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( ( A > E > $o ) > C > E > $o ) @ ( ( B > F3 > $o ) > D > F3 > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > E > $o ) @ ( B > F3 > $o ) @ ( C > E > $o ) @ ( D > F3 > $o )
          @ ( bNF_rel_fun @ A @ B @ ( E > $o ) @ ( F3 > $o ) @ B2
            @ ( bNF_rel_fun @ E @ F3 @ $o @ $o @ C2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ C @ D @ ( E > $o ) @ ( F3 > $o ) @ A2
            @ ( bNF_rel_fun @ E @ F3 @ $o @ $o @ C2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) ) )
        @ ( relcompp @ C @ A @ E )
        @ ( relcompp @ D @ B @ F3 ) ) ) )).

% relcompp_transfer
thf(fact_107_bex1__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( bNF_rel_fun @ ( A > $o ) @ ( A > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( bex1_rel @ A @ R )
        @ ( bex1_rel @ A @ R ) ) ) )).

% bex1_rel_rsp
thf(fact_108_left__total__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_total @ C @ D @ B2 )
       => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
          @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ ( left_total @ A @ C )
          @ ( left_total @ B @ D ) ) ) ) )).

% left_total_parametric
thf(fact_109_fun_Orel__compp,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( bNF_rel_fun @ D @ D @ A @ C
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ( relcompp @ A @ B @ C @ R @ S ) )
      = ( relcompp @ ( D > A ) @ ( D > B ) @ ( D > C )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ R )
        @ ( bNF_rel_fun @ D @ D @ B @ C
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ S ) ) ) )).

% fun.rel_compp
thf(fact_110_conj__comp__iff,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),Q: ( B > $o ),G2: ( A > B )] :
      ( ( comp @ B @ $o @ A
        @ ^ [X2: B] :
            ( ( P @ X2 )
            & ( Q @ X2 ) )
        @ G2 )
      = ( ^ [X2: A] :
            ( ( comp @ B @ $o @ A @ P @ G2 @ X2 )
            & ( comp @ B @ $o @ A @ Q @ G2 @ X2 ) ) ) ) )).

% conj_comp_iff
thf(fact_111_stream_Orel__compp,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( stream_all2 @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) )
      = ( relcompp @ ( stream @ A ) @ ( stream @ B ) @ ( stream @ C ) @ ( stream_all2 @ A @ B @ R ) @ ( stream_all2 @ B @ C @ S ) ) ) )).

% stream.rel_compp
thf(fact_112_stream_Oleft__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( left_total @ ( stream @ A ) @ ( stream @ B ) @ ( stream_all2 @ A @ B @ R ) ) ) )).

% stream.left_total_rel
thf(fact_113_eq__comp__r,axiom,(
    ! [A: $tType,R: ( A > A > $o )] :
      ( ( relcompp @ A @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( relcompp @ A @ A @ A @ R
          @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )
      = R ) )).

% eq_comp_r
thf(fact_114_bex1__rel__aux,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: ( A > $o ),Y: ( A > $o )] :
      ( ! [Xa2: A,Ya2: A] :
          ( ( R @ Xa2 @ Ya2 )
         => ( ( X @ Xa2 )
            = ( Y @ Ya2 ) ) )
     => ( ( bex1_rel @ A @ R @ X )
       => ( bex1_rel @ A @ R @ Y ) ) ) )).

% bex1_rel_aux
thf(fact_115_bex1__rel__aux2,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: ( A > $o ),Y: ( A > $o )] :
      ( ! [Xa2: A,Ya2: A] :
          ( ( R @ Xa2 @ Ya2 )
         => ( ( X @ Xa2 )
            = ( Y @ Ya2 ) ) )
     => ( ( bex1_rel @ A @ R @ Y )
       => ( bex1_rel @ A @ R @ X ) ) ) )).

% bex1_rel_aux2
thf(fact_116_left__totalE,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ! [X7: A] :
        ? [X12: B] :
          ( R @ X7 @ X12 ) ) )).

% left_totalE
thf(fact_117_left__totalI,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ! [X3: A] :
        ? [X13: B] :
          ( R @ X3 @ X13 )
     => ( left_total @ A @ B @ R ) ) )).

% left_totalI
thf(fact_118_left__total__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( ( left_total @ B @ C @ S )
       => ( left_total @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) ) ) ) )).

% left_total_OO
thf(fact_119_left__total__eq,axiom,(
    ! [A: $tType] :
      ( left_total @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% left_total_eq
thf(fact_120_left__total__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( left_total @ A @ B )
      = ( ^ [R5: ( A > B > $o )] :
          ! [X2: A] :
            ( ^ [P2: ( B > $o )] :
              ? [X6: B] :
                ( P2 @ X6 )
            @ ( R5 @ X2 ) ) ) ) )).

% left_total_def
thf(fact_121_bi__total__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: ( A > B > $o ),B2: ( B > C > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_total @ B @ C @ B2 )
       => ( bi_total @ A @ C @ ( relcompp @ A @ B @ C @ A2 @ B2 ) ) ) ) )).

% bi_total_OO
thf(fact_122_typedef__rep__transfer,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),T2: ( A > B > $o )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( T2
          = ( ^ [X2: A,Y4: B] :
                ( X2
                = ( Rep @ Y4 ) ) ) )
       => ( bNF_rel_fun @ A @ B @ A @ A @ T2
          @ ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ ^ [X2: A] : X2
          @ Rep ) ) ) )).

% typedef_rep_transfer
thf(fact_123_OOO__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( B > B > $o ),Abs23: ( B > C ),Rep23: ( C > B ),R23: ( A > A > $o )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ B @ C @ R2 @ Abs23 @ Rep23 )
       => ( ! [X3: A,Y2: A] :
              ( ( R23 @ X3 @ Y2 )
             => ( ( R1 @ X3 @ X3 )
               => ( ( R1 @ Y2 @ Y2 )
                 => ( R2 @ ( Abs12 @ X3 ) @ ( Abs12 @ Y2 ) ) ) ) )
         => ( ! [X3: B,Y2: B] :
                ( ( R2 @ X3 @ Y2 )
               => ( R23 @ ( Rep12 @ X3 ) @ ( Rep12 @ Y2 ) ) )
           => ( quotient3 @ A @ C @ ( relcompp @ A @ A @ A @ R1 @ ( relcompp @ A @ A @ A @ R23 @ R1 ) ) @ ( comp @ B @ C @ A @ Abs23 @ Abs12 ) @ ( comp @ B @ A @ C @ Rep12 @ Rep23 ) ) ) ) ) ) )).

% OOO_quotient3
thf(fact_124_OOO__eq__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),Abs23: ( B > C ),Rep23: ( C > B )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ B @ C
          @ ^ [Y3: B,Z: B] : ( Y3 = Z )
          @ Abs23
          @ Rep23 )
       => ( quotient3 @ A @ C
          @ ( relcompp @ A @ A @ A @ R1
            @ ( relcompp @ A @ A @ A
              @ ^ [Y3: A,Z: A] : ( Y3 = Z )
              @ R1 ) )
          @ ( comp @ B @ C @ A @ Abs23 @ Abs12 )
          @ ( comp @ B @ A @ C @ Rep12 @ Rep23 ) ) ) ) )).

% OOO_eq_quotient3
thf(fact_125_monotone__applyI,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),F5: ( A > B ),X: C] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ F5 )
     => ( comple1396247847notone @ ( C > A ) @ B @ ( partial_fun_ord @ A @ A @ C @ Orda ) @ Ordb
        @ ^ [F: ( C > A )] :
            ( F5 @ ( F @ X ) ) ) ) )).

% monotone_applyI
thf(fact_126_monotone__fun__ord__apply,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Orda: ( A > A > $o ),Ordb: ( C > C > $o ),F2: ( A > B > C )] :
      ( ( comple1396247847notone @ A @ ( B > C ) @ Orda @ ( partial_fun_ord @ C @ C @ B @ Ordb ) @ F2 )
      = ( ! [X2: B] :
            ( comple1396247847notone @ A @ C @ Orda @ Ordb
            @ ^ [Y4: A] :
                ( F2 @ Y4 @ X2 ) ) ) ) )).

% monotone_fun_ord_apply
thf(fact_127_stream_Ocase__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R: ( A > B > $o ),S: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > ( stream @ A ) > C ) @ ( B > ( stream @ B ) > D ) @ ( ( stream @ A ) > C ) @ ( ( stream @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( stream @ A ) > C ) @ ( ( stream @ B ) > D ) @ R @ ( bNF_rel_fun @ ( stream @ A ) @ ( stream @ B ) @ C @ D @ ( stream_all2 @ A @ B @ R ) @ S ) ) @ ( bNF_rel_fun @ ( stream @ A ) @ ( stream @ B ) @ C @ D @ ( stream_all2 @ A @ B @ R ) @ S ) @ ( case_stream @ A @ C ) @ ( case_stream @ B @ D ) ) )).

% stream.case_transfer
thf(fact_128_monotone__if__fun,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Orda: ( B > B > $o ),Ordb: ( D > D > $o ),F5: ( ( A > B ) > C > D ),G5: ( ( A > B ) > C > D ),C3: ( C > $o )] :
      ( ( comple1396247847notone @ ( A > B ) @ ( C > D ) @ ( partial_fun_ord @ B @ B @ A @ Orda ) @ ( partial_fun_ord @ D @ D @ C @ Ordb ) @ F5 )
     => ( ( comple1396247847notone @ ( A > B ) @ ( C > D ) @ ( partial_fun_ord @ B @ B @ A @ Orda ) @ ( partial_fun_ord @ D @ D @ C @ Ordb ) @ G5 )
       => ( comple1396247847notone @ ( A > B ) @ ( C > D ) @ ( partial_fun_ord @ B @ B @ A @ Orda ) @ ( partial_fun_ord @ D @ D @ C @ Ordb )
          @ ^ [F: ( A > B ),N2: C] :
              ( if @ D @ ( C3 @ N2 ) @ ( F5 @ F @ N2 ) @ ( G5 @ F @ N2 ) ) ) ) ) )).

% monotone_if_fun
thf(fact_129_monotone__fun__apply__fun,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Ord: ( C > C > $o ),T: A,G2: ( D > B )] :
      ( comple1396247847notone @ ( A > B > C ) @ ( D > C ) @ ( partial_fun_ord @ ( B > C ) @ ( B > C ) @ A @ ( partial_fun_ord @ C @ C @ B @ Ord ) ) @ ( partial_fun_ord @ C @ C @ D @ Ord )
      @ ^ [F: ( A > B > C ),N2: D] :
          ( F @ T @ ( G2 @ N2 ) ) ) )).

% monotone_fun_apply_fun
thf(fact_130_stream_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H2: ( B > C ),F2: ( A > ( stream @ A ) > B ),Stream2: ( stream @ A )] :
      ( ( H2 @ ( case_stream @ A @ B @ F2 @ Stream2 ) )
      = ( case_stream @ A @ C
        @ ^ [X14: A,X23: ( stream @ A )] :
            ( H2 @ ( F2 @ X14 @ X23 ) )
        @ Stream2 ) ) )).

% stream.case_distrib
thf(fact_131_monotone__id_H,axiom,(
    ! [A: $tType,Ord: ( A > A > $o )] :
      ( comple1396247847notone @ A @ A @ Ord @ Ord
      @ ^ [X2: A] : X2 ) )).

% monotone_id'
thf(fact_132_call__mono,axiom,(
    ! [B: $tType,A: $tType,Ord: ( B > B > $o ),T: A] :
      ( comple1396247847notone @ ( A > B ) @ B @ ( partial_fun_ord @ B @ B @ A @ Ord ) @ Ord
      @ ^ [F: ( A > B )] :
          ( F @ T ) ) )).

% call_mono
thf(fact_133_stream_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( stream @ A ) > $o ) @ ( ( stream @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( stream @ A ) @ ( stream @ B ) @ $o @ $o @ ( stream_all2 @ A @ B @ R )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( pred_stream @ A )
      @ ( pred_stream @ B ) ) )).

% stream.pred_transfer
thf(fact_134_transfer__forall__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(1)
thf(fact_135_Domainp__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B2: ( A > B > $o ),A2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( C > $o ) @ ( D > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ( domainp @ C @ A )
        @ ( domainp @ D @ B ) ) ) )).

% Domainp_transfer
thf(fact_136_stream_Opred__True,axiom,(
    ! [A: $tType] :
      ( ( pred_stream @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: ( stream @ A )] : $true ) ) )).

% stream.pred_True
thf(fact_137_fun_ODomainp__rel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( domainp @ ( C > A ) @ ( C > B )
        @ ( bNF_rel_fun @ C @ C @ A @ B
          @ ^ [Y3: C,Z: C] : ( Y3 = Z )
          @ R ) )
      = ( basic_pred_fun @ C @ A
        @ ^ [Uu: C] : $true
        @ ( domainp @ A @ B @ R ) ) ) )).

% fun.Domainp_rel
thf(fact_138_stream_ODomainp__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( domainp @ ( stream @ A ) @ ( stream @ B ) @ ( stream_all2 @ A @ B @ R ) )
      = ( pred_stream @ A @ ( domainp @ A @ B @ R ) ) ) )).

% stream.Domainp_rel
thf(fact_139_Domainp__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( domainp @ A @ B )
      = ( ^ [T3: ( A > B > $o ),X2: A] :
            ( ^ [P2: ( B > $o )] :
              ? [X6: B] :
                ( P2 @ X6 )
            @ ( T3 @ X2 ) ) ) ) )).

% Domainp_iff
thf(fact_140_Domainp__refl,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( domainp @ A @ B )
      = ( domainp @ A @ B ) ) )).

% Domainp_refl
thf(fact_141_pcr__Domainp__total,axiom,(
    ! [A: $tType,B: $tType,C: $tType,B2: ( A > B > $o ),A2: ( C > A > $o ),P: ( C > $o )] :
      ( ( left_total @ A @ B @ B2 )
     => ( ( ( domainp @ C @ A @ A2 )
          = P )
       => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A2 @ B2 ) )
          = P ) ) ) )).

% pcr_Domainp_total
thf(fact_142_stream__from__llist__setup_Ostream_Odomain__eq,axiom,(
    ! [A: $tType] :
      ( ( domainp @ ( coinductive_llist @ A ) @ ( stream @ A )
        @ ( coindu773941317stream @ A @ A
          @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )
      = ( ^ [Xs2: ( coinductive_llist @ A )] :
            ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) )).

% stream_from_llist_setup.stream.domain_eq
thf(fact_143_fun__ord__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( partial_fun_ord @ A @ B @ C )
      = ( ^ [Ord2: ( A > B > $o ),F: ( C > A ),G: ( C > B )] :
          ! [X2: C] :
            ( Ord2 @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% fun_ord_def
thf(fact_144_pcr__Domainp__par__left__total,axiom,(
    ! [A: $tType,B: $tType,C: $tType,B2: ( A > B > $o ),P: ( A > $o ),A2: ( C > A > $o ),P3: ( C > $o )] :
      ( ( ( domainp @ A @ B @ B2 )
        = P )
     => ( ( left_total @ C @ A @ A2 )
       => ( ( bNF_rel_fun @ C @ A @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
            @ P3
            @ P )
         => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A2 @ B2 ) )
            = P3 ) ) ) ) )).

% pcr_Domainp_par_left_total
thf(fact_145_let__mono,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Orda: ( B > B > $o ),Ordb: ( C > C > $o ),B3: ( B > A > C ),T: A] :
      ( ! [X3: A] :
          ( comple1396247847notone @ B @ C @ Orda @ Ordb
          @ ^ [F: B] :
              ( B3 @ F @ X3 ) )
     => ( comple1396247847notone @ B @ C @ Orda @ Ordb
        @ ^ [F: B] :
            ( B3 @ F @ T ) ) ) )).

% let_mono
thf(fact_146_if__mono,axiom,(
    ! [B: $tType,A: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),F5: ( A > B ),G5: ( A > B ),C3: $o] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ F5 )
     => ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ G5 )
       => ( comple1396247847notone @ A @ B @ Orda @ Ordb
          @ ^ [F: A] :
              ( if @ B @ C3 @ ( F5 @ F ) @ ( G5 @ F ) ) ) ) ) )).

% if_mono
thf(fact_147_transfer__forall__transfer_I4_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ rev_implies
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(4)
thf(fact_148_transfer__forall__transfer_I5_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ rev_implies ) @ rev_implies @ ( transfer_forall @ A ) @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(5)
thf(fact_149_reflp__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(1)
thf(fact_150_right__total__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_total @ C @ D @ B2 )
       => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
          @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ ( right_total @ A @ C )
          @ ( right_total @ B @ D ) ) ) ) )).

% right_total_parametric
thf(fact_151_fun_Orel__reflp,axiom,(
    ! [D: $tType,A: $tType,R: ( A > A > $o )] :
      ( ( reflp @ A @ R )
     => ( reflp @ ( D > A )
        @ ( bNF_rel_fun @ D @ D @ A @ A
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ R ) ) ) )).

% fun.rel_reflp
thf(fact_152_DEADID_Orel__reflp,axiom,(
    ! [A: $tType] :
      ( reflp @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% DEADID.rel_reflp
thf(fact_153_right__total__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( right_total @ A @ B )
      = ( ^ [R5: ( A > B > $o )] :
          ! [Y4: B] :
          ? [X2: A] :
            ( R5 @ X2 @ Y4 ) ) ) )).

% right_total_def
thf(fact_154_rev__implies__def,axiom,
    ( rev_implies
    = ( ^ [X2: $o,Y4: $o] :
          ( Y4
         => X2 ) ) )).

% rev_implies_def
thf(fact_155_right__total__eq,axiom,(
    ! [A: $tType] :
      ( right_total @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% right_total_eq
thf(fact_156_right__totalI,axiom,(
    ! [A: $tType,B: $tType,A2: ( B > A > $o )] :
      ( ! [Y2: A] :
        ? [X7: B] :
          ( A2 @ X7 @ Y2 )
     => ( right_total @ B @ A @ A2 ) ) )).

% right_totalI
thf(fact_157_right__totalE,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o ),Y: B] :
      ( ( right_total @ A @ B @ A2 )
     => ~ ( ! [X3: A] :
              ~ ( A2 @ X3 @ Y ) ) ) )).

% right_totalE
thf(fact_158_stream__from__llist__setup_Ostream_Oright__total,axiom,(
    ! [F3: $tType,E: $tType,T2: ( E > F3 > $o )] :
      ( ( right_total @ E @ F3 @ T2 )
     => ( right_total @ ( coinductive_llist @ E ) @ ( stream @ F3 ) @ ( coindu773941317stream @ E @ F3 @ T2 ) ) ) )).

% stream_from_llist_setup.stream.right_total
thf(fact_159_stream_Oright__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( right_total @ A @ B @ R )
     => ( right_total @ ( stream @ A ) @ ( stream @ B ) @ ( stream_all2 @ A @ B @ R ) ) ) )).

% stream.right_total_rel
thf(fact_160_stream_Orel__reflp,axiom,(
    ! [A: $tType,R: ( A > A > $o )] :
      ( ( reflp @ A @ R )
     => ( reflp @ ( stream @ A ) @ ( stream_all2 @ A @ A @ R ) ) ) )).

% stream.rel_reflp
thf(fact_161_right__total__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: ( A > B > $o ),B2: ( B > C > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( ( right_total @ B @ C @ B2 )
       => ( right_total @ A @ C @ ( relcompp @ A @ B @ C @ A2 @ B2 ) ) ) ) )).

% right_total_OO
thf(fact_162_typedef__right__total,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),T2: ( A > B > $o )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( T2
          = ( ^ [X2: A,Y4: B] :
                ( X2
                = ( Rep @ Y4 ) ) ) )
       => ( right_total @ A @ B @ T2 ) ) ) )).

% typedef_right_total
thf(fact_163_reflp__transfer_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ => ) ) @ => @ ( reflp @ A ) @ ( reflp @ B ) ) ) )).

% reflp_transfer(2)
thf(fact_164_reflp__transfer_I3_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ =>
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(3)
thf(fact_165_bi__totalI,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( ( right_total @ A @ B @ R )
       => ( bi_total @ A @ B @ R ) ) ) )).

% bi_totalI
thf(fact_166_bi__total__alt__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_total @ A @ B )
      = ( ^ [A6: ( A > B > $o )] :
            ( ( left_total @ A @ B @ A6 )
            & ( right_total @ A @ B @ A6 ) ) ) ) )).

% bi_total_alt_def
thf(fact_167_reflp__transfer_I4_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ rev_implies ) ) @ rev_implies @ ( reflp @ A ) @ ( reflp @ B ) ) ) )).

% reflp_transfer(4)
thf(fact_168_reflp__transfer_I5_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ rev_implies
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(5)
thf(fact_169_transfer__forall__transfer_I3_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ => ) @ => @ ( transfer_forall @ A ) @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(3)
thf(fact_170_transfer__forall__transfer_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ =>
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(2)
thf(fact_171_Domainp__forall__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( transfer_bforall @ A @ ( domainp @ A @ B @ A2 ) )
        @ ( transfer_forall @ B ) ) ) )).

% Domainp_forall_transfer
thf(fact_172_right__total__relcompp__transfer,axiom,(
    ! [C: $tType,A: $tType,E: $tType,F3: $tType,B: $tType,D: $tType,B2: ( A > B > $o ),A2: ( C > D > $o ),C2: ( E > F3 > $o )] :
      ( ( right_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( ( A > E > $o ) > C > E > $o ) @ ( ( B > F3 > $o ) > D > F3 > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > E > $o ) @ ( B > F3 > $o ) @ ( C > E > $o ) @ ( D > F3 > $o )
          @ ( bNF_rel_fun @ A @ B @ ( E > $o ) @ ( F3 > $o ) @ B2
            @ ( bNF_rel_fun @ E @ F3 @ $o @ $o @ C2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ C @ D @ ( E > $o ) @ ( F3 > $o ) @ A2
            @ ( bNF_rel_fun @ E @ F3 @ $o @ $o @ C2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) ) )
        @ ^ [R5: ( C > A > $o ),S5: ( A > E > $o ),X2: C,Z2: E] :
          ? [Y4: A] :
            ( ( member @ A @ Y4 @ ( collect @ A @ ( domainp @ A @ B @ B2 ) ) )
            & ( R5 @ X2 @ Y4 )
            & ( S5 @ Y4 @ Z2 ) )
        @ ( relcompp @ D @ B @ F3 ) ) ) )).

% right_total_relcompp_transfer
thf(fact_173_right__total__Domainp__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B2: ( A > B > $o ),A2: ( C > D > $o )] :
      ( ( right_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( C > $o ) @ ( D > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [T3: ( C > A > $o ),X2: C] :
          ? [Y4: A] :
            ( ( member @ A @ Y4 @ ( collect @ A @ ( domainp @ A @ B @ B2 ) ) )
            & ( T3 @ X2 @ Y4 ) )
        @ ( domainp @ D @ B ) ) ) )).

% right_total_Domainp_transfer
thf(fact_174_bex__reg,axiom,(
    ! [A: $tType,R: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ R )
         => ( ( P @ X3 )
           => ( Q @ X3 ) ) )
     => ( ? [X7: A] :
            ( ( member @ A @ X7 @ R )
            & ( P @ X7 ) )
       => ? [X3: A] :
            ( ( member @ A @ X3 @ R )
            & ( Q @ X3 ) ) ) ) )).

% bex_reg
thf(fact_175_right__total__Ex__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( bex @ A @ ( collect @ A @ ( domainp @ A @ B @ A2 ) ) )
        @ ^ [P2: ( B > $o )] :
          ? [X6: B] :
            ( P2 @ X6 ) ) ) )).

% right_total_Ex_transfer
thf(fact_176_Domainp__prod__fun__eq,axiom,(
    ! [C: $tType,B: $tType,A: $tType,T2: ( B > C > $o )] :
      ( ( domainp @ ( A > B ) @ ( A > C )
        @ ( bNF_rel_fun @ A @ A @ B @ C
          @ ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ T2 ) )
      = ( ^ [F: ( A > B )] :
          ! [X2: A] :
            ( domainp @ B @ C @ T2 @ ( F @ X2 ) ) ) ) )).

% Domainp_prod_fun_eq
thf(fact_177_stream__from__llist__setup_Ostream_Odomain__par__left__total,axiom,(
    ! [B: $tType,C: $tType,T2: ( C > B > $o ),P3: ( ( coinductive_llist @ C ) > $o )] :
      ( ( left_total @ ( coinductive_llist @ C ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ C @ B @ T2 ) )
     => ( ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ C @ B @ T2 )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ P3
          @ ^ [Xs2: ( coinductive_llist @ B )] :
              ~ ( coinductive_lfinite @ B @ Xs2 ) )
       => ( ( domainp @ ( coinductive_llist @ C ) @ ( stream @ B ) @ ( coindu773941317stream @ C @ B @ T2 ) )
          = P3 ) ) ) )).

% stream_from_llist_setup.stream.domain_par_left_total
thf(fact_178_llist_Orel__reflp,axiom,(
    ! [A: $tType,R: ( A > A > $o )] :
      ( ( reflp @ A @ R )
     => ( reflp @ ( coinductive_llist @ A ) @ ( coindu1486289336t_all2 @ A @ A @ R ) ) ) )).

% llist.rel_reflp
thf(fact_179_llist_Oright__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( right_total @ A @ B @ R )
     => ( right_total @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.right_total_rel
thf(fact_180_bex__reg__left,axiom,(
    ! [A: $tType,R: ( set @ A ),Q: ( A > $o ),P: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ R )
         => ( ( Q @ X3 )
           => ( P @ X3 ) ) )
     => ( ? [X7: A] :
            ( ( member @ A @ X7 @ R )
            & ( Q @ X7 ) )
       => ? [X12: A] :
            ( P @ X12 ) ) ) )).

% bex_reg_left
thf(fact_181_rel__fun__eq__rel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R: ( B > C > $o )] :
      ( ( bNF_rel_fun @ A @ A @ B @ C
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R )
      = ( ^ [F: ( A > B ),G: ( A > C )] :
          ! [X2: A] :
            ( R @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% rel_fun_eq_rel
thf(fact_182_rel__fun__def,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType] :
      ( ( bNF_rel_fun @ A @ C @ B @ D )
      = ( ^ [A6: ( A > C > $o ),B4: ( B > D > $o ),F: ( A > B ),G: ( C > D )] :
          ! [X2: A,Y4: C] :
            ( ( A6 @ X2 @ Y4 )
           => ( B4 @ ( F @ X2 ) @ ( G @ Y4 ) ) ) ) ) )).

% rel_fun_def
thf(fact_183_stream__from__llist__setup_Ostream_Odomain,axiom,(
    ! [B: $tType,C: $tType,T2: ( C > B > $o )] :
      ( ( domainp @ ( coinductive_llist @ C ) @ ( stream @ B ) @ ( coindu773941317stream @ C @ B @ T2 ) )
      = ( ^ [X2: ( coinductive_llist @ C )] :
          ? [Y4: ( coinductive_llist @ B )] :
            ( ( coindu1486289336t_all2 @ C @ B @ T2 @ X2 @ Y4 )
            & ~ ( coinductive_lfinite @ B @ Y4 ) ) ) ) )).

% stream_from_llist_setup.stream.domain
thf(fact_184_llist__all2__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ R
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o ) @ ( coindu1486289336t_all2 @ A @ B @ R )
        @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ R )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( coindu1486289336t_all2 @ A @ A )
      @ ( coindu1486289336t_all2 @ B @ B ) ) )).

% llist_all2_transfer
thf(fact_185_llist_Orel__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: ( A > C > $o ),Sc: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > $o ) @ ( ( coinductive_llist @ C ) > ( coinductive_llist @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ C ) @ ( ( coinductive_llist @ B ) > $o ) @ ( ( coinductive_llist @ D ) > $o ) @ ( coindu1486289336t_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( coinductive_llist @ B ) @ ( coinductive_llist @ D ) @ $o @ $o @ ( coindu1486289336t_all2 @ B @ D @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( coindu1486289336t_all2 @ A @ B )
      @ ( coindu1486289336t_all2 @ C @ D ) ) )).

% llist.rel_transfer
thf(fact_186_lfinite__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ A2 )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ( coinductive_lfinite @ A )
      @ ( coinductive_lfinite @ B ) ) )).

% lfinite_transfer
thf(fact_187_transfer__forall__def,axiom,(
    ! [A: $tType] :
      ( ( transfer_forall @ A )
      = ( ^ [P2: ( A > $o )] :
          ! [X6: A] :
            ( P2 @ X6 ) ) ) )).

% transfer_forall_def
thf(fact_188_OO__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcompp @ A @ C @ B )
      = ( ^ [R5: ( A > C > $o ),S5: ( C > B > $o ),X2: A,Z2: B] :
          ? [Y4: C] :
            ( ( R5 @ X2 @ Y4 )
            & ( S5 @ Y4 @ Z2 ) ) ) ) )).

% OO_def
thf(fact_189_llist_Obi__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ R )
     => ( bi_total @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.bi_total_rel
thf(fact_190_llist__all2__lfiniteD,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( coinductive_lfinite @ A @ Xs )
        = ( coinductive_lfinite @ B @ Ys ) ) ) )).

% llist_all2_lfiniteD
thf(fact_191_llist_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X: ( coinductive_llist @ B )] :
      ( ! [X3: B] :
          ( Ra @ X3 @ X3 )
     => ( coindu1486289336t_all2 @ B @ B @ Ra @ X @ X ) ) )).

% llist.rel_refl
thf(fact_192_llist_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( coindu1486289336t_all2 @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( coinductive_llist @ A ),Z: ( coinductive_llist @ A )] : ( Y3 = Z ) ) ) )).

% llist.rel_eq
thf(fact_193_llist__all2__mono,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),P3: ( A > B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X3: A,Y2: B] :
            ( ( P @ X3 @ Y2 )
           => ( P3 @ X3 @ Y2 ) )
       => ( coindu1486289336t_all2 @ A @ B @ P3 @ Xs @ Ys ) ) ) )).

% llist_all2_mono
thf(fact_194_llist__all2__rsp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),S: ( A > A > $o ),T2: ( B > B > $o ),X: ( coinductive_llist @ A ),Y: ( coinductive_llist @ B ),A3: ( coinductive_llist @ A ),B3: ( coinductive_llist @ B )] :
      ( ! [X3: A,Y2: B] :
          ( ( R @ X3 @ Y2 )
         => ! [A5: A,B5: B] :
              ( ( R @ A5 @ B5 )
             => ( ( S @ X3 @ A5 )
                = ( T2 @ Y2 @ B5 ) ) ) )
     => ( ( coindu1486289336t_all2 @ A @ B @ R @ X @ Y )
       => ( ( coindu1486289336t_all2 @ A @ B @ R @ A3 @ B3 )
         => ( ( coindu1486289336t_all2 @ A @ A @ S @ X @ A3 )
            = ( coindu1486289336t_all2 @ B @ B @ T2 @ Y @ B3 ) ) ) ) ) )).

% llist_all2_rsp
thf(fact_195_llist__all2__conj,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Q: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B
        @ ^ [X2: A,Y4: B] :
            ( ( P @ X2 @ Y4 )
            & ( Q @ X2 @ Y4 ) )
        @ Xs
        @ Ys )
      = ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
        & ( coindu1486289336t_all2 @ A @ B @ Q @ Xs @ Ys ) ) ) )).

% llist_all2_conj
thf(fact_196_llist_Oleft__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( left_total @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.left_total_rel
thf(fact_197_llist_Orel__compp,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( coindu1486289336t_all2 @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) )
      = ( relcompp @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ C ) @ ( coindu1486289336t_all2 @ A @ B @ R ) @ ( coindu1486289336t_all2 @ B @ C @ S ) ) ) )).

% llist.rel_compp
thf(fact_198_pred__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( basic_pred_fun @ A @ B )
      = ( ^ [A6: ( A > $o ),B4: ( B > $o ),F: ( A > B )] :
          ! [X2: A] :
            ( ( A6 @ X2 )
           => ( B4 @ ( F @ X2 ) ) ) ) ) )).

% pred_fun_def
thf(fact_199_pcr__Domainp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,B2: ( A > B > $o ),P: ( A > $o ),A2: ( C > A > $o )] :
      ( ( ( domainp @ A @ B @ B2 )
        = P )
     => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A2 @ B2 ) )
        = ( ^ [X2: C] :
            ? [Y4: A] :
              ( ( A2 @ X2 @ Y4 )
              & ( P @ Y4 ) ) ) ) ) )).

% pcr_Domainp
thf(fact_200_stream__from__llist__setup_Ostream_Orep__transfer,axiom,(
    ! [E: $tType,F3: $tType,T2: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( coinductive_llist @ E ) @ ( stream @ F3 ) @ ( coinductive_llist @ E ) @ ( coinductive_llist @ F3 ) @ ( coindu773941317stream @ E @ F3 @ T2 ) @ ( coindu1486289336t_all2 @ E @ F3 @ T2 )
      @ ^ [X2: ( coinductive_llist @ E )] : X2
      @ ( coindu1724414836stream @ F3 ) ) )).

% stream_from_llist_setup.stream.rep_transfer
thf(fact_201_stream__from__llist__setup_Opcr__stream__def,axiom,(
    ! [B: $tType,C: $tType] :
      ( ( coindu773941317stream @ C @ B )
      = ( ^ [T3: ( C > B > $o )] :
            ( relcompp @ ( coinductive_llist @ C ) @ ( coinductive_llist @ B ) @ ( stream @ B ) @ ( coindu1486289336t_all2 @ C @ B @ T3 ) @ ( coindu1183105481stream @ B ) ) ) ) )).

% stream_from_llist_setup.pcr_stream_def
thf(fact_202_transfer__bforall__def,axiom,(
    ! [A: $tType] :
      ( ( transfer_bforall @ A )
      = ( ^ [P4: ( A > $o ),Q2: ( A > $o )] :
          ! [X2: A] :
            ( ( P4 @ X2 )
           => ( Q2 @ X2 ) ) ) ) )).

% transfer_bforall_def
thf(fact_203_unfold__llist__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > C ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > D ) > ( B > B ) > B > ( coinductive_llist @ D ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) ) )
      @ ( coindu1441602521_llist @ A @ C )
      @ ( coindu1441602521_llist @ B @ D ) ) )).

% unfold_llist_transfer
thf(fact_204_llist_Ocorec__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > B ) > ( D > $o ) > ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > $o ) > ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ S @ R )
        @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) )
          @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
          @ ( bNF_rel_fun @ ( C > ( coinductive_llist @ A ) ) @ ( D > ( coinductive_llist @ B ) ) @ ( ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > D ) > D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ S @ ( coindu1486289336t_all2 @ A @ B @ R ) ) @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( C > ( coinductive_llist @ A ) ) @ ( D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S @ S ) @ ( bNF_rel_fun @ C @ D @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ S @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) ) ) )
      @ ( coindu1259883913_llist @ C @ A )
      @ ( coindu1259883913_llist @ D @ B ) ) )).

% llist.corec_transfer
thf(fact_205_llist__corec__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > C ) > ( A > $o ) > ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > D ) > ( B > $o ) > ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > $o ) > ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > $o ) > ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 )
        @ ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) )
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
          @ ( bNF_rel_fun @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) ) ) ) )
      @ ( coindu1259883913_llist @ A @ C )
      @ ( coindu1259883913_llist @ B @ D ) ) )).

% llist_corec_transfer
thf(fact_206_Ex__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ^ [P2: ( A > $o )] :
          ? [X6: A] :
            ( P2 @ X6 )
        @ ^ [P2: ( B > $o )] :
          ? [X6: B] :
            ( P2 @ X6 ) ) ) )).

% Ex_transfer
thf(fact_207_All__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ^ [P2: ( A > $o )] :
          ! [X6: A] :
            ( P2 @ X6 )
        @ ^ [P2: ( B > $o )] :
          ! [X6: B] :
            ( P2 @ X6 ) ) ) )).

% All_transfer
thf(fact_208_bi__total__alt__def2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_total @ A @ B )
      = ( ^ [R5: ( A > B > $o )] :
            ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
            @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R5
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
            @ ^ [P2: ( A > $o )] :
              ! [X6: A] :
                ( P2 @ X6 )
            @ ^ [P2: ( B > $o )] :
              ! [X6: B] :
                ( P2 @ X6 ) ) ) ) )).

% bi_total_alt_def2
thf(fact_209_right__total__alt__def2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( right_total @ A @ B )
      = ( ^ [R5: ( A > B > $o )] :
            ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R5 @ => ) @ =>
            @ ^ [P2: ( A > $o )] :
              ! [X6: A] :
                ( P2 @ X6 )
            @ ^ [P2: ( B > $o )] :
              ! [X6: B] :
                ( P2 @ X6 ) ) ) ) )).

% right_total_alt_def2
thf(fact_210_Bex__def__raw,axiom,(
    ! [A: $tType] :
      ( ( bex @ A )
      = ( ^ [A6: ( set @ A ),P4: ( A > $o )] :
          ? [X2: A] :
            ( ( member @ A @ X2 @ A6 )
            & ( P4 @ X2 ) ) ) ) )).

% Bex_def_raw
thf(fact_211_rel__pred__comp__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rel_pred_comp @ A @ B )
      = ( ^ [R5: ( A > B > $o ),P4: ( B > $o ),X2: A] :
          ? [Y4: B] :
            ( ( R5 @ X2 @ Y4 )
            & ( P4 @ Y4 ) ) ) ) )).

% rel_pred_comp_def
thf(fact_212_right__total__All__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( ball @ A @ ( collect @ A @ ( domainp @ A @ B @ A2 ) ) )
        @ ^ [P2: ( B > $o )] :
          ! [X6: B] :
            ( P2 @ X6 ) ) ) )).

% right_total_All_transfer
thf(fact_213_ball__reg__right,axiom,(
    ! [A: $tType,R: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ R )
         => ( ( P @ X3 )
           => ( Q @ X3 ) ) )
     => ( ! [X12: A] :
            ( P @ X12 )
       => ! [X7: A] :
            ( ( member @ A @ X7 @ R )
           => ( Q @ X7 ) ) ) ) )).

% ball_reg_right
thf(fact_214_Ball__def__raw,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A6: ( set @ A ),P4: ( A > $o )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A6 )
           => ( P4 @ X2 ) ) ) ) )).

% Ball_def_raw
thf(fact_215_Ball__comp__iff,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( B > ( set @ C ) ),F2: ( C > $o ),G2: ( A > B )] :
      ( ( comp @ B @ $o @ A
        @ ^ [X2: B] :
          ! [Y4: C] :
            ( ( member @ C @ Y4 @ ( A2 @ X2 ) )
           => ( F2 @ Y4 ) )
        @ G2 )
      = ( ^ [X2: A] :
          ! [Y4: C] :
            ( ( member @ C @ Y4 @ ( comp @ B @ ( set @ C ) @ A @ A2 @ G2 @ X2 ) )
           => ( F2 @ Y4 ) ) ) ) )).

% Ball_comp_iff
thf(fact_216_ball__reg,axiom,(
    ! [A: $tType,R: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ R )
         => ( ( P @ X3 )
           => ( Q @ X3 ) ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ R )
           => ( P @ X3 ) )
       => ! [X7: A] :
            ( ( member @ A @ X7 @ R )
           => ( Q @ X7 ) ) ) ) )).

% ball_reg
thf(fact_217_iterates__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ A ) ) @ ( B > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ A2 @ ( coindu1486289336t_all2 @ A @ B @ A2 ) ) @ ( coinductive_iterates @ A ) @ ( coinductive_iterates @ B ) ) )).

% iterates_transfer
thf(fact_218_llist_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ R )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( coindu543516966_llist @ A )
      @ ( coindu543516966_llist @ B ) ) )).

% llist.pred_transfer
thf(fact_219_lfinite__iterates,axiom,(
    ! [A: $tType,F2: ( A > A ),X: A] :
      ~ ( coinductive_lfinite @ A @ ( coinductive_iterates @ A @ F2 @ X ) ) )).

% lfinite_iterates
thf(fact_220_llist_Opred__True,axiom,(
    ! [A: $tType] :
      ( ( coindu543516966_llist @ A
        @ ^ [Uu: A] : $true )
      = ( ^ [Uu: ( coinductive_llist @ A )] : $true ) ) )).

% llist.pred_True
thf(fact_221_llist_ODomainp__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( domainp @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) )
      = ( coindu543516966_llist @ A @ ( domainp @ A @ B @ R ) ) ) )).

% llist.Domainp_rel
thf(fact_222_llist__all__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ A2 )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( coindu543516966_llist @ A )
      @ ( coindu543516966_llist @ B ) ) )).

% llist_all_transfer
thf(fact_223_stream__from__llist__setup_Ostream_Odomain__par,axiom,(
    ! [B: $tType,C: $tType,T2: ( C > B > $o ),DR: ( C > $o ),P22: ( ( coinductive_llist @ C ) > $o )] :
      ( ( ( domainp @ C @ B @ T2 )
        = DR )
     => ( ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ C @ B @ T2 )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ P22
          @ ^ [Xs2: ( coinductive_llist @ B )] :
              ~ ( coinductive_lfinite @ B @ Xs2 ) )
       => ( ( domainp @ ( coinductive_llist @ C ) @ ( stream @ B ) @ ( coindu773941317stream @ C @ B @ T2 ) )
          = ( inf_inf @ ( ( coinductive_llist @ C ) > $o ) @ ( coindu543516966_llist @ C @ DR ) @ P22 ) ) ) ) )).

% stream_from_llist_setup.stream.domain_par
thf(fact_224_case__llist__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,B2: ( A > B > $o ),A2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( C > ( coinductive_llist @ C ) > A ) > ( coinductive_llist @ C ) > A ) @ ( ( D > ( coinductive_llist @ D ) > B ) > ( coinductive_llist @ D ) > B ) @ B2 @ ( bNF_rel_fun @ ( C > ( coinductive_llist @ C ) > A ) @ ( D > ( coinductive_llist @ D ) > B ) @ ( ( coinductive_llist @ C ) > A ) @ ( ( coinductive_llist @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ ( ( coinductive_llist @ C ) > A ) @ ( ( coinductive_llist @ D ) > B ) @ A2 @ ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A @ B @ ( coindu1486289336t_all2 @ C @ D @ A2 ) @ B2 ) ) @ ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A @ B @ ( coindu1486289336t_all2 @ C @ D @ A2 ) @ B2 ) ) @ ( coindu1381640503_llist @ A @ C ) @ ( coindu1381640503_llist @ B @ D ) ) )).

% case_llist_transfer
thf(fact_225_llist__case__mono,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),Lnil: ( A > B ),Lcons: ( A > C > ( coinductive_llist @ C ) > B ),X: ( coinductive_llist @ C )] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ Lnil )
     => ( ! [X3: C,Xs3: ( coinductive_llist @ C )] :
            ( comple1396247847notone @ A @ B @ Orda @ Ordb
            @ ^ [F: A] :
                ( Lcons @ F @ X3 @ Xs3 ) )
       => ( comple1396247847notone @ A @ B @ Orda @ Ordb
          @ ^ [F: A] :
              ( coindu1381640503_llist @ B @ C @ ( Lnil @ F ) @ ( Lcons @ F ) @ X ) ) ) ) )).

% llist_case_mono
thf(fact_226_llist_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H2: ( B > C ),F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( H2 @ ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ Llist ) )
      = ( coindu1381640503_llist @ C @ A @ ( H2 @ F1 )
        @ ^ [X14: A,X23: ( coinductive_llist @ A )] :
            ( H2 @ ( F22 @ X14 @ X23 ) )
        @ Llist ) ) )).

% llist.case_distrib
thf(fact_227_pcr__Domainp__par,axiom,(
    ! [A: $tType,B: $tType,C: $tType,B2: ( A > B > $o ),P23: ( A > $o ),A2: ( C > A > $o ),P1: ( C > $o ),P22: ( C > $o )] :
      ( ( ( domainp @ A @ B @ B2 )
        = P23 )
     => ( ( ( domainp @ C @ A @ A2 )
          = P1 )
       => ( ( bNF_rel_fun @ C @ A @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
            @ P22
            @ P23 )
         => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A2 @ B2 ) )
            = ( inf_inf @ ( C > $o ) @ P1 @ P22 ) ) ) ) ) )).

% pcr_Domainp_par
thf(fact_228_llist_Ocase__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ C @ D @ ( ( A > ( coinductive_llist @ A ) > C ) > ( coinductive_llist @ A ) > C ) @ ( ( B > ( coinductive_llist @ B ) > D ) > ( coinductive_llist @ B ) > D ) @ S @ ( bNF_rel_fun @ ( A > ( coinductive_llist @ A ) > C ) @ ( B > ( coinductive_llist @ B ) > D ) @ ( ( coinductive_llist @ A ) > C ) @ ( ( coinductive_llist @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > C ) @ ( ( coinductive_llist @ B ) > D ) @ R @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ D @ ( coindu1486289336t_all2 @ A @ B @ R ) @ S ) ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ D @ ( coindu1486289336t_all2 @ A @ B @ R ) @ S ) ) @ ( coindu1381640503_llist @ C @ A ) @ ( coindu1381640503_llist @ D @ B ) ) )).

% llist.case_transfer
thf(fact_229_img__ord__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( partial_img_ord @ A @ C @ B )
      = ( ^ [F: ( A > C ),Ord2: ( C > C > B ),X2: A,Y4: A] :
            ( Ord2 @ ( F @ X2 ) @ ( F @ Y4 ) ) ) ) )).

% img_ord_def
thf(fact_230_mk__less__def,axiom,(
    ! [A: $tType] :
      ( ( partial_mk_less @ A )
      = ( ^ [R5: ( A > A > $o ),X2: A,Y4: A] :
            ( ( R5 @ X2 @ Y4 )
            & ~ ( R5 @ Y4 @ X2 ) ) ) ) )).

% mk_less_def
thf(fact_231_type__definition_ORep,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),X: B] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( member @ A @ ( Rep @ X ) @ A2 ) ) )).

% type_definition.Rep
thf(fact_232_type__definition__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( type_definition @ B @ A )
      = ( ^ [Rep2: ( B > A ),Abs2: ( A > B ),A6: ( set @ A )] :
            ( ! [X2: B] :
                ( member @ A @ ( Rep2 @ X2 ) @ A6 )
            & ! [X2: B] :
                ( ( Abs2 @ ( Rep2 @ X2 ) )
                = X2 )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ A6 )
               => ( ( Rep2 @ ( Abs2 @ Y4 ) )
                  = Y4 ) ) ) ) ) )).

% type_definition_def
thf(fact_233_type__definition_ORep__inverse,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),X: B] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( Abs @ ( Rep @ X ) )
        = X ) ) )).

% type_definition.Rep_inverse
thf(fact_234_type__definition_OAbs__inverse,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),Y: A] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( member @ A @ Y @ A2 )
       => ( ( Rep @ ( Abs @ Y ) )
          = Y ) ) ) )).

% type_definition.Abs_inverse
thf(fact_235_type__definition_ORep__inject,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),X: B,Y: B] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( ( Rep @ X )
          = ( Rep @ Y ) )
        = ( X = Y ) ) ) )).

% type_definition.Rep_inject
thf(fact_236_type__definition_ORep__induct,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),Y: A,P: ( A > $o )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( member @ A @ Y @ A2 )
       => ( ! [X3: B] :
              ( P @ ( Rep @ X3 ) )
         => ( P @ Y ) ) ) ) )).

% type_definition.Rep_induct
thf(fact_237_type__definition_OAbs__inject,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),X: A,Y: A] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( member @ A @ X @ A2 )
       => ( ( member @ A @ Y @ A2 )
         => ( ( ( Abs @ X )
              = ( Abs @ Y ) )
            = ( X = Y ) ) ) ) ) )).

% type_definition.Abs_inject
thf(fact_238_type__definition_OAbs__induct,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),P: ( B > $o ),X: B] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ! [Y2: A] :
            ( ( member @ A @ Y2 @ A2 )
           => ( P @ ( Abs @ Y2 ) ) )
       => ( P @ X ) ) ) )).

% type_definition.Abs_induct
thf(fact_239_type__definition_ORep__cases,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),Y: A] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ( ( member @ A @ Y @ A2 )
       => ~ ( ! [X3: B] :
                ( Y
               != ( Rep @ X3 ) ) ) ) ) )).

% type_definition.Rep_cases
thf(fact_240_type__definition_OAbs__cases,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A2: ( set @ A ),X: B] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A2 )
     => ~ ( ! [Y2: A] :
              ( ( X
                = ( Abs @ Y2 ) )
             => ~ ( member @ A @ Y2 @ A2 ) ) ) ) )).

% type_definition.Abs_cases
thf(fact_241_type__definition_Ointro,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),A2: ( set @ A ),Abs: ( A > B )] :
      ( ! [X3: B] :
          ( member @ A @ ( Rep @ X3 ) @ A2 )
     => ( ! [X3: B] :
            ( ( Abs @ ( Rep @ X3 ) )
            = X3 )
       => ( ! [Y2: A] :
              ( ( member @ A @ Y2 @ A2 )
             => ( ( Rep @ ( Abs @ Y2 ) )
                = Y2 ) )
         => ( type_definition @ B @ A @ Rep @ Abs @ A2 ) ) ) ) )).

% type_definition.intro
thf(fact_242_llist__of__stream__siterates,axiom,(
    ! [A: $tType,F2: ( A > A ),X: A] :
      ( ( coindu1724414836stream @ A @ ( siterate @ A @ F2 @ X ) )
      = ( coinductive_iterates @ A @ F2 @ X ) ) )).

% llist_of_stream_siterates
thf(fact_243_nchotomy__relcomppE,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F2: ( B > A ),R4: ( C > A > $o ),S3: ( A > D > $o ),A3: C,C3: D] :
      ( ! [Y2: A] :
        ? [X7: B] :
          ( Y2
          = ( F2 @ X7 ) )
     => ( ( relcompp @ C @ A @ D @ R4 @ S3 @ A3 @ C3 )
       => ~ ( ! [B5: B] :
                ( ( R4 @ A3 @ ( F2 @ B5 ) )
               => ~ ( S3 @ ( F2 @ B5 ) @ C3 ) ) ) ) ) )).

% nchotomy_relcomppE
thf(fact_244_OO__eq,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( relcompp @ A @ B @ B @ R
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) )
      = R ) )).

% OO_eq
thf(fact_245_eq__OO,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( relcompp @ A @ A @ B
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ R )
      = R ) )).

% eq_OO
thf(fact_246_relcompp_OrelcompI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R4: ( A > B > $o ),A3: A,B3: B,S3: ( B > C > $o ),C3: C] :
      ( ( R4 @ A3 @ B3 )
     => ( ( S3 @ B3 @ C3 )
       => ( relcompp @ A @ B @ C @ R4 @ S3 @ A3 @ C3 ) ) ) )).

% relcompp.relcompI
thf(fact_247_relcompp_Oinducts,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R4: ( A > B > $o ),S3: ( B > C > $o ),X1: A,X22: C,P: ( A > C > $o )] :
      ( ( relcompp @ A @ B @ C @ R4 @ S3 @ X1 @ X22 )
     => ( ! [A5: A,B5: B,C4: C] :
            ( ( R4 @ A5 @ B5 )
           => ( ( S3 @ B5 @ C4 )
             => ( P @ A5 @ C4 ) ) )
       => ( P @ X1 @ X22 ) ) ) )).

% relcompp.inducts
thf(fact_248_relcompp__assoc,axiom,(
    ! [A: $tType,D: $tType,B: $tType,C: $tType,R4: ( A > D > $o ),S3: ( D > C > $o ),T: ( C > B > $o )] :
      ( ( relcompp @ A @ C @ B @ ( relcompp @ A @ D @ C @ R4 @ S3 ) @ T )
      = ( relcompp @ A @ D @ B @ R4 @ ( relcompp @ D @ C @ B @ S3 @ T ) ) ) )).

% relcompp_assoc
thf(fact_249_relcompp__apply,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcompp @ A @ B @ C )
      = ( ^ [R5: ( A > B > $o ),S5: ( B > C > $o ),A4: A,C5: C] :
          ? [B6: B] :
            ( ( R5 @ A4 @ B6 )
            & ( S5 @ B6 @ C5 ) ) ) ) )).

% relcompp_apply
thf(fact_250_relcompp_Osimps,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( relcompp @ A @ B @ C )
      = ( ^ [R6: ( A > B > $o ),S2: ( B > C > $o ),A1: A,A22: C] :
          ? [A4: A,B6: B,C5: C] :
            ( ( A1 = A4 )
            & ( A22 = C5 )
            & ( R6 @ A4 @ B6 )
            & ( S2 @ B6 @ C5 ) ) ) ) )).

% relcompp.simps
thf(fact_251_relcompp_Ocases,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R4: ( A > B > $o ),S3: ( B > C > $o ),A12: A,A23: C] :
      ( ( relcompp @ A @ B @ C @ R4 @ S3 @ A12 @ A23 )
     => ~ ( ! [B5: B] :
              ( ( R4 @ A12 @ B5 )
             => ~ ( S3 @ B5 @ A23 ) ) ) ) )).

% relcompp.cases
thf(fact_252_relcomppE,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R4: ( A > B > $o ),S3: ( B > C > $o ),A3: A,C3: C] :
      ( ( relcompp @ A @ B @ C @ R4 @ S3 @ A3 @ C3 )
     => ~ ( ! [B5: B] :
              ( ( R4 @ A3 @ B5 )
             => ~ ( S3 @ B5 @ C3 ) ) ) ) )).

% relcomppE
thf(fact_253_Powp__def,axiom,(
    ! [A: $tType] :
      ( ( powp @ A )
      = ( ^ [A6: ( A > $o ),B4: ( set @ A )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ B4 )
           => ( A6 @ X2 ) ) ) ) )).

% Powp_def
thf(fact_254_pos__fun__distr,axiom,(
    ! [E: $tType,C: $tType,A: $tType,B: $tType,D: $tType,F3: $tType,R: ( A > E > $o ),S: ( B > F3 > $o ),R8: ( E > C > $o ),S6: ( F3 > D > $o )] :
      ( ord_less_eq @ ( ( A > B ) > ( C > D ) > $o ) @ ( relcompp @ ( A > B ) @ ( E > F3 ) @ ( C > D ) @ ( bNF_rel_fun @ A @ E @ B @ F3 @ R @ S ) @ ( bNF_rel_fun @ E @ C @ F3 @ D @ R8 @ S6 ) ) @ ( bNF_rel_fun @ A @ C @ B @ D @ ( relcompp @ A @ E @ C @ R @ R8 ) @ ( relcompp @ B @ F3 @ D @ S @ S6 ) ) ) )).

% pos_fun_distr
thf(fact_255_relcompp__mono,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R9: ( A > B > $o ),R4: ( A > B > $o ),S7: ( B > C > $o ),S3: ( B > C > $o )] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R9 @ R4 )
     => ( ( ord_less_eq @ ( B > C > $o ) @ S7 @ S3 )
       => ( ord_less_eq @ ( A > C > $o ) @ ( relcompp @ A @ B @ C @ R9 @ S7 ) @ ( relcompp @ A @ B @ C @ R4 @ S3 ) ) ) ) )).

% relcompp_mono

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,
    ( bNF_rel_fun @ a @ a @ ( coinductive_llist @ b ) @ ( stream @ b )
    @ ^ [Y3: a,Z: a] : ( Y3 = Z )
    @ ^ [X2: ( coinductive_llist @ b ),Y4: ( stream @ b )] :
        ( X2
        = ( coindu1724414836stream @ b @ Y4 ) )
    @ xb
    @ yb )).

thf(conj_1,conjecture,
    ( xb
    = ( comp @ ( stream @ b ) @ ( coinductive_llist @ b ) @ a @ ( coindu1724414836stream @ b ) @ yb ) )).

%------------------------------------------------------------------------------
