%------------------------------------------------------------------------------
% File     : DAT150^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive stream 331
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_stream__331.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  381 (   0 unit;  68 type;   0 defn)
%            Number of atoms       : 4444 ( 246 equality;2662 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 3986 (  56   ~;   1   |;  31   &;3476   @)
%                                         (   0 <=>; 422  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  299 ( 299   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   71 (  68   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1113 (   3 sgn; 980   !;  25   ?;  40   ^)
%                                         (1113   :;  68  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 15:14:17.934
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (62)
thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable_Ocountable,type,(
    countable: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_OSup,type,(
    complete_Sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Partial__Order_Occpo,type,(
    comple1141879883l_ccpo: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,(
    comple187826305attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,(
    counta840220525attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,(
    condit378418413attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Oinf__llist,type,(
    coindu68654304_llist: 
      !>[A: $tType] :
        ( ( nat > A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olmap,type,(
    coinductive_lmap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( coinductive_llist @ A ) > ( coinductive_llist @ Aa ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Opred__llist,type,(
    coindu543516966_llist: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olnth,type,(
    coinductive_lnth: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > A ) )).

thf(sy_c_Coinductive__List_Omonoid__add__class_Ollistsum,type,(
    coindu780009021istsum: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ollist__of__stream,type,(
    coindu1724414836stream: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Oof__seq,type,(
    coindu176146587of_seq: 
      !>[A: $tType] :
        ( ( nat > A ) > ( stream @ A ) ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__from__llist__setup_Ocr__stream,type,(
    coindu1183105481stream: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( stream @ A ) > $o ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Ostream__of__llist,type,(
    coindu2010755910_llist: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( stream @ A ) ) )).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,(
    complete_Sup_Sup: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Complete__Partial__Order2_Ocompact,type,(
    comple2143767107ompact: 
      !>[A: $tType] :
        ( ( ( set @ A ) > A ) > ( A > A > $o ) > A > $o ) )).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,(
    condit1810911227_above: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Countable_Ofrom__nat,type,(
    from_nat: 
      !>[A: $tType] :
        ( nat > A ) )).

thf(sy_c_Fun_Oswap,type,(
    swap: 
      !>[A: $tType,B: $tType] :
        ( A > A > ( A > B ) > A > B ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OBall,type,(
    ball: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_OPow,type,(
    pow: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( set @ A ) ) ) )).

thf(sy_c_Set_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ B ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Stream_Osmap2,type,(
    smap2: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( stream @ A ) > ( stream @ B ) > ( stream @ C ) ) )).

thf(sy_c_Stream_Osmember,type,(
    smember: 
      !>[A: $tType] :
        ( A > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Osmerge,type,(
    smerge: 
      !>[A: $tType] :
        ( ( stream @ ( stream @ A ) ) > ( stream @ A ) ) )).

thf(sy_c_Stream_Osnth,type,(
    snth: 
      !>[A: $tType] :
        ( ( stream @ A ) > nat > A ) )).

thf(sy_c_Stream_Ostream_Opred__stream,type,(
    pred_stream: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Ostream_Osmap,type,(
    smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream @ A ) > ( stream @ Aa ) ) )).

thf(sy_c_Stream_Ostream_Osset,type,(
    sset: 
      !>[A: $tType] :
        ( ( stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream_Ostream__all,type,(
    stream_all: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream @ A ) > $o ) )).

thf(sy_c_Stream_Ostreams,type,(
    streams: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( stream @ A ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f,type,(
    f: nat > a )).

%----Relevant facts (255)
thf(fact_0_stream__all__def,axiom,(
    ! [A: $tType] :
      ( ( stream_all @ A )
      = ( ^ [P: ( A > $o ),S: ( stream @ A )] :
          ! [P2: nat] :
            ( P @ ( snth @ A @ S @ P2 ) ) ) ) )).

% stream_all_def
thf(fact_1_snth__smap2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),S1: ( stream @ B ),S2: ( stream @ C ),N: nat] :
      ( ( snth @ A @ ( smap2 @ B @ C @ A @ F @ S1 @ S2 ) @ N )
      = ( F @ ( snth @ B @ S1 @ N ) @ ( snth @ C @ S2 @ N ) ) ) )).

% snth_smap2
thf(fact_2_smap2__alt,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > C > A ),S1: ( stream @ B ),S2: ( stream @ C ),S3: ( stream @ A )] :
      ( ( ( smap2 @ B @ C @ A @ F @ S1 @ S2 )
        = S3 )
      = ( ! [N2: nat] :
            ( ( F @ ( snth @ B @ S1 @ N2 ) @ ( snth @ C @ S2 @ N2 ) )
            = ( snth @ A @ S3 @ N2 ) ) ) ) )).

% smap2_alt
thf(fact_3_of__seq_Oabs__eq,axiom,(
    ! [A: $tType] :
      ( ( coindu176146587of_seq @ A )
      = ( ^ [X: ( nat > A )] :
            ( coindu2010755910_llist @ A @ ( coindu68654304_llist @ A @ X ) ) ) ) )).

% of_seq.abs_eq
thf(fact_4_of__seq_Orep__eq,axiom,(
    ! [A: $tType,X2: ( nat > A )] :
      ( ( coindu1724414836stream @ A @ ( coindu176146587of_seq @ A @ X2 ) )
      = ( coindu68654304_llist @ A @ X2 ) ) )).

% of_seq.rep_eq
thf(fact_5_snth__in,axiom,(
    ! [A: $tType,S3: ( stream @ A ),X3: ( set @ A ),N: nat] :
      ( ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ X3 ) )
     => ( member @ A @ ( snth @ A @ S3 @ N ) @ X3 ) ) )).

% snth_in
thf(fact_6_streams__iff__snth,axiom,(
    ! [A: $tType,S3: ( stream @ A ),X3: ( set @ A )] :
      ( ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ X3 ) )
      = ( ! [N2: nat] :
            ( member @ A @ ( snth @ A @ S3 @ N2 ) @ X3 ) ) ) )).

% streams_iff_snth
thf(fact_7_snth__smap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S3: ( stream @ B ),N: nat] :
      ( ( snth @ A @ ( smap @ B @ A @ F @ S3 ) @ N )
      = ( F @ ( snth @ B @ S3 @ N ) ) ) )).

% snth_smap
thf(fact_8_snth__sset,axiom,(
    ! [A: $tType,S3: ( stream @ A ),N: nat] :
      ( member @ A @ ( snth @ A @ S3 @ N ) @ ( sset @ A @ S3 ) ) )).

% snth_sset
thf(fact_9_lnth__list__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( coinductive_lnth @ A @ ( coindu1724414836stream @ A @ Xs ) )
      = ( snth @ A @ Xs ) ) )).

% lnth_list_of_stream
thf(fact_10_smap__alt,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S3: ( stream @ B ),S4: ( stream @ A )] :
      ( ( ( smap @ B @ A @ F @ S3 )
        = S4 )
      = ( ! [N2: nat] :
            ( ( F @ ( snth @ B @ S3 @ N2 ) )
            = ( snth @ A @ S4 @ N2 ) ) ) ) )).

% smap_alt
thf(fact_11_snth__sset__smerge,axiom,(
    ! [A: $tType,Ss: ( stream @ ( stream @ A ) ),N: nat,M: nat] :
      ( member @ A @ ( snth @ A @ ( snth @ ( stream @ A ) @ Ss @ N ) @ M ) @ ( sset @ A @ ( smerge @ A @ Ss ) ) ) )).

% snth_sset_smerge
thf(fact_12_stream_ORep__inverse,axiom,(
    ! [A: $tType,X2: ( stream @ A )] :
      ( ( coindu2010755910_llist @ A @ ( coindu1724414836stream @ A @ X2 ) )
      = X2 ) )).

% stream.Rep_inverse
thf(fact_13_stream__of__llist__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( coindu2010755910_llist @ A @ ( coindu1724414836stream @ A @ Xs ) )
      = Xs ) )).

% stream_of_llist_llist_of_stream
thf(fact_14_smap__streams,axiom,(
    ! [A: $tType,B: $tType,S3: ( stream @ A ),A2: ( set @ A ),F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ A2 ) )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A2 )
           => ( member @ B @ ( F @ X4 ) @ B2 ) )
       => ( member @ ( stream @ B ) @ ( smap @ A @ B @ F @ S3 ) @ ( streams @ B @ B2 ) ) ) ) )).

% smap_streams
thf(fact_15_stream_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream @ A ),Ya: ( stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( sset @ A @ Ya ) )
           => ( ( F @ Z )
              = ( G @ Z ) ) )
       => ( ( smap @ A @ B @ F @ X2 )
          = ( smap @ A @ B @ G @ Ya ) ) ) ) )).

% stream.map_cong
thf(fact_16_stream_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z: A] :
          ( ( member @ A @ Z @ ( sset @ A @ X2 ) )
         => ( ( F @ Z )
            = ( G @ Z ) ) )
     => ( ( smap @ A @ B @ F @ X2 )
        = ( smap @ A @ B @ G @ X2 ) ) ) )).

% stream.map_cong0
thf(fact_17_stream_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream @ A ),Xa: ( stream @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z: A,Za: A] :
          ( ( member @ A @ Z @ ( sset @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( sset @ A @ Xa ) )
           => ( ( ( F @ Z )
                = ( Fa @ Za ) )
             => ( Z = Za ) ) ) )
     => ( ( ( smap @ A @ B @ F @ X2 )
          = ( smap @ A @ B @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% stream.inj_map_strong
thf(fact_18_stream_ORep__inject,axiom,(
    ! [A: $tType,X2: ( stream @ A ),Y: ( stream @ A )] :
      ( ( ( coindu1724414836stream @ A @ X2 )
        = ( coindu1724414836stream @ A @ Y ) )
      = ( X2 = Y ) ) )).

% stream.Rep_inject
thf(fact_19_lnth__inf__llist,axiom,(
    ! [A: $tType,F: ( nat > A ),N: nat] :
      ( ( coinductive_lnth @ A @ ( coindu68654304_llist @ A @ F ) @ N )
      = ( F @ N ) ) )).

% lnth_inf_llist
thf(fact_20_inf__llist__inj,axiom,(
    ! [A: $tType,F: ( nat > A ),G: ( nat > A )] :
      ( ( ( coindu68654304_llist @ A @ F )
        = ( coindu68654304_llist @ A @ G ) )
      = ( F = G ) ) )).

% inf_llist_inj
thf(fact_21_Stream_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( smember @ A )
      = ( ^ [X: A,S: ( stream @ A )] :
            ( member @ A @ X @ ( sset @ A @ S ) ) ) ) )).

% Stream.smember_def
thf(fact_22_stream__all__iff,axiom,(
    ! [A: $tType] :
      ( ( stream_all @ A )
      = ( ^ [P: ( A > $o ),S: ( stream @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ ( sset @ A @ S ) )
           => ( P @ X ) ) ) ) )).

% stream_all_iff
thf(fact_23_llist__of__stream__stream__of__llist,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coindu1724414836stream @ A @ ( coindu2010755910_llist @ A @ Xs ) )
        = Xs ) ) )).

% llist_of_stream_stream_of_llist
thf(fact_24_lset__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( coinductive_lset @ A @ ( coindu1724414836stream @ A @ Xs ) )
      = ( sset @ A @ Xs ) ) )).

% lset_llist_of_stream
thf(fact_25_sset__streams,axiom,(
    ! [A: $tType,S3: ( stream @ A ),A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sset @ A @ S3 ) @ A2 )
     => ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ A2 ) ) ) )).

% sset_streams
thf(fact_26_streams__sset,axiom,(
    ! [A: $tType,S3: ( stream @ A ),A2: ( set @ A )] :
      ( ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ A2 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( sset @ A @ S3 ) @ A2 ) ) )).

% streams_sset
thf(fact_27_streams__iff__sset,axiom,(
    ! [A: $tType,S3: ( stream @ A ),A2: ( set @ A )] :
      ( ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ A2 ) )
      = ( ord_less_eq @ ( set @ A ) @ ( sset @ A @ S3 ) @ A2 ) ) )).

% streams_iff_sset
thf(fact_28_lmap__llist__of__stream,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( stream @ B )] :
      ( ( coinductive_lmap @ B @ A @ F @ ( coindu1724414836stream @ B @ Xs ) )
      = ( coindu1724414836stream @ A @ ( smap @ B @ A @ F @ Xs ) ) ) )).

% lmap_llist_of_stream
thf(fact_29_stream_Oset__map,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),V: ( stream @ A )] :
      ( ( sset @ B @ ( smap @ A @ B @ F @ V ) )
      = ( image @ A @ B @ F @ ( sset @ A @ V ) ) ) )).

% stream.set_map
thf(fact_30_lfinite__lmap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_lmap
thf(fact_31_llist_Oset__map,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),V: ( coinductive_llist @ A )] :
      ( ( coinductive_lset @ B @ ( coinductive_lmap @ A @ B @ F @ V ) )
      = ( image @ A @ B @ F @ ( coinductive_lset @ A @ V ) ) ) )).

% llist.set_map
thf(fact_32_inf__llist__lnth,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coindu68654304_llist @ A @ ( coinductive_lnth @ A @ Xs ) )
        = Xs ) ) )).

% inf_llist_lnth
thf(fact_33_sset__stream__of__llist,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ~ ( coinductive_lfinite @ A @ Xs )
       => ( ( sset @ A @ ( coindu2010755910_llist @ A @ Xs ) )
          = ( coinductive_lset @ A @ Xs ) ) ) ) )).

% sset_stream_of_llist
thf(fact_34_smap__stream__of__llist,axiom,(
    ! [B: $tType,A: $tType,Xs: ( coinductive_llist @ A ),F: ( A > B )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( smap @ A @ B @ F @ ( coindu2010755910_llist @ A @ Xs ) )
        = ( coindu2010755910_llist @ B @ ( coinductive_lmap @ A @ B @ F @ Xs ) ) ) ) )).

% smap_stream_of_llist
thf(fact_35_llist_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,X2: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z: A,Za: A] :
          ( ( member @ A @ Z @ ( coinductive_lset @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( coinductive_lset @ A @ Xa ) )
           => ( ( ( F @ Z )
                = ( Fa @ Za ) )
             => ( Z = Za ) ) ) )
     => ( ( ( coinductive_lmap @ A @ B @ F @ X2 )
          = ( coinductive_lmap @ A @ B @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% llist.inj_map_strong
thf(fact_36_llist_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,X2: ( coinductive_llist @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z: A] :
          ( ( member @ A @ Z @ ( coinductive_lset @ A @ X2 ) )
         => ( ( F @ Z )
            = ( G @ Z ) ) )
     => ( ( coinductive_lmap @ A @ B @ F @ X2 )
        = ( coinductive_lmap @ A @ B @ G @ X2 ) ) ) )).

% llist.map_cong0
thf(fact_37_llist_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,X2: ( coinductive_llist @ A ),Ya: ( coinductive_llist @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( coinductive_lset @ A @ Ya ) )
           => ( ( F @ Z )
              = ( G @ Z ) ) )
       => ( ( coinductive_lmap @ A @ B @ F @ X2 )
          = ( coinductive_lmap @ A @ B @ G @ Ya ) ) ) ) )).

% llist.map_cong
thf(fact_38_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > A > $o ),B3: A,A3: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P3 @ A4 @ B4 ) )
         => ( ( ( P3 @ B3 @ A3 )
             => ( P3 @ A3 @ B3 ) )
           => ( P3 @ A3 @ B3 ) ) ) ) )).

% wlog_linorder_le
thf(fact_39_streams__mono2,axiom,(
    ! [A: $tType,S5: ( set @ A ),T: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S5 @ T )
     => ( ord_less_eq @ ( set @ ( stream @ A ) ) @ ( streams @ A @ S5 ) @ ( streams @ A @ T ) ) ) )).

% streams_mono2
thf(fact_40_lfinite__inf__llist,axiom,(
    ! [A: $tType,F: ( nat > A )] :
      ~ ( coinductive_lfinite @ A @ ( coindu68654304_llist @ A @ F ) ) )).

% lfinite_inf_llist
thf(fact_41_lfinite__llist__of__stream,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ~ ( coinductive_lfinite @ A @ ( coindu1724414836stream @ A @ Xs ) ) )).

% lfinite_llist_of_stream
thf(fact_42_streams__mono,axiom,(
    ! [A: $tType,S3: ( stream @ A ),A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ A2 ) )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member @ ( stream @ A ) @ S3 @ ( streams @ A @ B2 ) ) ) ) )).

% streams_mono
thf(fact_43_not__False__in__image__Ball,axiom,(
    ! [A: $tType,P3: ( A > $o ),A2: ( set @ A )] :
      ( ( ~ ( member @ $o @ $false @ ( image @ A @ $o @ P3 @ A2 ) ) )
      = ( ! [X: A] :
            ( ( member @ A @ X @ A2 )
           => ( P3 @ X ) ) ) ) )).

% not_False_in_image_Ball
thf(fact_44_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A2 )
       => ( A2 = B2 ) ) ) )).

% subset_antisym
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P3: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P3 ) )
      = ( P3 @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P3 @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P3 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A2 )
         => ( member @ A @ X4 @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% subsetI
thf(fact_50_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),X2: B,A2: ( set @ B )] :
      ( ( B3
        = ( F @ X2 ) )
     => ( ( member @ B @ X2 @ A2 )
       => ( member @ A @ B3 @ ( image @ B @ A @ F @ A2 ) ) ) ) )).

% image_eqI
thf(fact_51_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ X2 @ X2 ) ) )).

% order_refl
thf(fact_52_Ball__Collect,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A5: ( set @ A ),P: ( A > $o )] :
            ( ord_less_eq @ ( set @ A ) @ A5 @ ( collect @ A @ P ) ) ) ) )).

% Ball_Collect
thf(fact_53_subset__image__iff,axiom,(
    ! [A: $tType,B: $tType,B2: ( set @ A ),F: ( B > A ),A2: ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( image @ B @ A @ F @ A2 ) )
      = ( ? [AA: ( set @ B )] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A2 )
            & ( B2
              = ( image @ B @ A @ F @ AA ) ) ) ) ) )).

% subset_image_iff
thf(fact_54_image__subset__iff,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F @ A2 ) @ B2 )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ( member @ A @ ( F @ X ) @ B2 ) ) ) ) )).

% image_subset_iff
thf(fact_55_subset__imageE,axiom,(
    ! [A: $tType,B: $tType,B2: ( set @ A ),F: ( B > A ),A2: ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ ( image @ B @ A @ F @ A2 ) )
     => ~ ( ! [C2: ( set @ B )] :
              ( ( ord_less_eq @ ( set @ B ) @ C2 @ A2 )
             => ( B2
               != ( image @ B @ A @ F @ C2 ) ) ) ) ) )).

% subset_imageE
thf(fact_56_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funD
thf(fact_57_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funE
thf(fact_58_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X4: A] :
              ( ord_less_eq @ B @ ( F @ X4 ) @ ( G @ X4 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_59_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B )] :
            ! [X: A] :
              ( ord_less_eq @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ) )).

% le_fun_def
thf(fact_60_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B3: B,C3: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C3 )
           => ( ! [X4: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C3 ) ) ) ) ) ) )).

% order_subst1
thf(fact_61_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B3: A,F: ( A > C ),C3: C] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ C @ ( F @ B3 ) @ C3 )
           => ( ! [X4: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y2 )
                 => ( ord_less_eq @ C @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ C @ ( F @ A3 ) @ C3 ) ) ) ) ) )).

% order_subst2
thf(fact_62_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B3: B,C3: B] :
          ( ( A3
            = ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C3 )
           => ( ! [X4: B,Y2: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y2 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C3 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_63_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B3: A,F: ( A > B ),C3: B] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ( F @ B3 )
              = C3 )
           => ( ! [X4: A,Y2: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y2 )
                 => ( ord_less_eq @ B @ ( F @ X4 ) @ ( F @ Y2 ) ) )
             => ( ord_less_eq @ B @ ( F @ A3 ) @ C3 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_64_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X: A,Y4: A] :
              ( ( ord_less_eq @ A @ X @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X ) ) ) ) ) )).

% eq_iff
thf(fact_65_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X2 )
           => ( X2 = Y ) ) ) ) )).

% antisym
thf(fact_66_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
          | ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% linear
thf(fact_67_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( X2 = Y )
         => ( ord_less_eq @ A @ X2 @ Y ) ) ) )).

% eq_refl
thf(fact_68_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y )
         => ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% le_cases
thf(fact_69_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C3 )
           => ( ord_less_eq @ A @ A3 @ C3 ) ) ) ) )).

% order.trans
thf(fact_70_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z3 ) )
         => ( ( ( ord_less_eq @ A @ Y @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z3 ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z3 )
               => ~ ( ord_less_eq @ A @ Z3 @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z3 @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z3 )
                   => ~ ( ord_less_eq @ A @ Z3 @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z3 @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_71_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A] :
          ( ( ord_less_eq @ A @ Y @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y )
            = ( X2 = Y ) ) ) ) )).

% antisym_conv
thf(fact_72_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( A3 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C3 )
           => ( ord_less_eq @ A @ A3 @ C3 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_73_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( B3 = C3 )
           => ( ord_less_eq @ A @ A3 @ C3 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_74_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ord_less_eq @ A @ A3 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A3 )
           => ( A3 = B3 ) ) ) ) )).

% order_class.order.antisym
thf(fact_75_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z3 )
           => ( ord_less_eq @ A @ X2 @ Z3 ) ) ) ) )).

% order_trans
thf(fact_76_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_77_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P3: ( A > A > $o ),A3: A,B3: A] :
          ( ! [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
             => ( P3 @ A4 @ B4 ) )
         => ( ! [A4: A,B4: A] :
                ( ( P3 @ B4 @ A4 )
               => ( P3 @ A4 @ B4 ) )
           => ( P3 @ A3 @ B3 ) ) ) ) )).

% linorder_wlog
thf(fact_78_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A,C3: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ C3 @ B3 )
           => ( ord_less_eq @ A @ C3 @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_79_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ord_less_eq @ A @ B3 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B3 )
           => ( A3 = B3 ) ) ) ) )).

% dual_order.antisym
thf(fact_80_imageI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A2: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X2 @ A2 )
     => ( member @ B @ ( F @ X2 ) @ ( image @ A @ B @ F @ A2 ) ) ) )).

% imageI
thf(fact_81_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z3: A,F: ( B > A ),A2: ( set @ B )] :
      ( ( member @ A @ Z3 @ ( image @ B @ A @ F @ A2 ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A2 )
            & ( Z3
              = ( F @ X ) ) ) ) ) )).

% image_iff
thf(fact_82_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P3: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( image @ B @ A @ F @ A2 ) )
          & ( P3 @ X5 ) )
     => ? [X4: B] :
          ( ( member @ B @ X4 @ A2 )
          & ( P3 @ ( F @ X4 ) ) ) ) )).

% bex_imageD
thf(fact_83_image__cong,axiom,(
    ! [B: $tType,A: $tType,M2: ( set @ A ),N3: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( M2 = N3 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ N3 )
           => ( ( F @ X4 )
              = ( G @ X4 ) ) )
       => ( ( image @ A @ B @ F @ M2 )
          = ( image @ A @ B @ G @ N3 ) ) ) ) )).

% image_cong
thf(fact_84_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B ),P3: ( A > $o )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A2 ) )
         => ( P3 @ X4 ) )
     => ! [X5: B] :
          ( ( member @ B @ X5 @ A2 )
         => ( P3 @ ( F @ X5 ) ) ) ) )).

% ball_imageD
thf(fact_85_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A2: ( set @ A ),B3: B,F: ( A > B )] :
      ( ( member @ A @ X2 @ A2 )
     => ( ( B3
          = ( F @ X2 ) )
       => ( member @ B @ B3 @ ( image @ A @ B @ F @ A2 ) ) ) ) )).

% rev_image_eqI
thf(fact_86_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ B ),B2: ( set @ B ),C4: ( B > A ),D: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A2 = B2 )
     => ( ! [X4: B] :
            ( ( member @ B @ X4 @ B2 )
           => ( ( C4 @ X4 )
              = ( D @ X4 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C4 @ A2 ) )
          = ( Inf @ ( image @ B @ A @ D @ B2 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_87_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ B ),B2: ( set @ B ),C4: ( B > A ),D: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A2 = B2 )
     => ( ! [X4: B] :
            ( ( member @ B @ X4 @ B2 )
           => ( ( C4 @ X4 )
              = ( D @ X4 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C4 @ A2 ) )
          = ( Sup @ ( image @ B @ A @ D @ B2 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_88_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ X2 @ A2 )
       => ( member @ A @ X2 @ B2 ) ) ) )).

% set_mp
thf(fact_89_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ X2 @ A2 )
       => ( member @ A @ X2 @ B2 ) ) ) )).

% in_mono
thf(fact_90_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ C3 @ A2 )
       => ( member @ A @ C3 @ B2 ) ) ) )).

% subsetD
thf(fact_91_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ C3 @ A2 )
       => ( member @ A @ C3 @ B2 ) ) ) )).

% subsetCE
thf(fact_92_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) ) )).

% equalityE
thf(fact_93_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ A5 )
           => ( member @ A @ X @ B5 ) ) ) ) )).

% subset_eq
thf(fact_94_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% equalityD1
thf(fact_95_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) )).

% equalityD2
thf(fact_96_set__rev__mp,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ X2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member @ A @ X2 @ B2 ) ) ) )).

% set_rev_mp
thf(fact_97_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [T2: A] :
            ( ( member @ A @ T2 @ A5 )
           => ( member @ A @ T2 @ B5 ) ) ) ) )).

% subset_iff
thf(fact_98_rev__subsetD,axiom,(
    ! [A: $tType,C3: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C3 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member @ A @ C3 @ B2 ) ) ) )).

% rev_subsetD
thf(fact_99_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_100_Collect__mono,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P3 @ X4 )
         => ( Q @ X4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_101_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C4 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C4 ) ) ) )).

% subset_trans
thf(fact_102_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( set @ A ),Z2: ( set @ A )] : ( Y3 = Z2 ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ) )).

% set_eq_subset
thf(fact_103_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ~ ( member @ A @ C3 @ B2 )
       => ~ ( member @ A @ C3 @ A2 ) ) ) )).

% contra_subsetD
thf(fact_104_Collect__mono__iff,axiom,(
    ! [A: $tType,P3: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P3 ) @ ( collect @ A @ Q ) )
      = ( ! [X: A] :
            ( ( P3 @ X )
           => ( Q @ X ) ) ) ) )).

% Collect_mono_iff
thf(fact_105_Ball__def,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A5: ( set @ A ),P: ( A > $o )] :
          ! [X: A] :
            ( ( member @ A @ X @ A5 )
           => ( P @ X ) ) ) ) )).

% Ball_def
thf(fact_106_image__mono,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),B2: ( set @ A ),F: ( A > B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F @ A2 ) @ ( image @ A @ B @ F @ B2 ) ) ) )).

% image_mono
thf(fact_107_image__subsetI,axiom,(
    ! [A: $tType,B: $tType,A2: ( set @ A ),F: ( A > B ),B2: ( set @ B )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A2 )
         => ( member @ B @ ( F @ X4 ) @ B2 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F @ A2 ) @ B2 ) ) )).

% image_subsetI
thf(fact_108_cr__streamI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( coindu1183105481stream @ A @ Xs @ ( coindu2010755910_llist @ A @ Xs ) ) ) )).

% cr_streamI
thf(fact_109_llistsum__mono,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B @ ( type2 @ B ) )
        & ( ordere779506340up_add @ B @ ( type2 @ B ) ) )
     => ! [Xs: ( coinductive_llist @ A ),F: ( A > B ),G: ( A > B )] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ ( coinductive_lset @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F @ X4 ) @ ( G @ X4 ) ) )
         => ( ord_less_eq @ B @ ( coindu780009021istsum @ B @ ( coinductive_lmap @ A @ B @ F @ Xs ) ) @ ( coindu780009021istsum @ B @ ( coinductive_lmap @ A @ B @ G @ Xs ) ) ) ) ) )).

% llistsum_mono
thf(fact_110_lset__lmember,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
      = ( coinductive_lmember @ A @ X2 @ Xs ) ) )).

% lset_lmember
thf(fact_111_ball__reg,axiom,(
    ! [A: $tType,R: ( set @ A ),P3: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ R )
         => ( ( P3 @ X4 )
           => ( Q @ X4 ) ) )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ R )
           => ( P3 @ X4 ) )
       => ! [X5: A] :
            ( ( member @ A @ X5 @ R )
           => ( Q @ X5 ) ) ) ) )).

% ball_reg
thf(fact_112_stream_Opred__set,axiom,(
    ! [A: $tType] :
      ( ( pred_stream @ A )
      = ( ^ [P: ( A > $o ),X: ( stream @ A )] :
          ! [Y4: A] :
            ( ( member @ A @ Y4 @ ( sset @ A @ X ) )
           => ( P @ Y4 ) ) ) ) )).

% stream.pred_set
thf(fact_113_lfp_Oleq__refl,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ X2 @ X2 ) ) )).

% lfp.leq_refl
thf(fact_114_gfp_Oleq__trans,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A,Z3: A] :
          ( ( ord_less_eq @ A @ Y @ X2 )
         => ( ( ord_less_eq @ A @ Z3 @ Y )
           => ( ord_less_eq @ A @ Z3 @ X2 ) ) ) ) )).

% gfp.leq_trans
thf(fact_115_lfp_Oleq__trans,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z3 )
           => ( ord_less_eq @ A @ X2 @ Z3 ) ) ) ) )).

% lfp.leq_trans
thf(fact_116_stream_Opred__mono__strong,axiom,(
    ! [A: $tType,P3: ( A > $o ),X2: ( stream @ A ),Pa: ( A > $o )] :
      ( ( pred_stream @ A @ P3 @ X2 )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( sset @ A @ X2 ) )
           => ( ( P3 @ Z )
             => ( Pa @ Z ) ) )
       => ( pred_stream @ A @ Pa @ X2 ) ) ) )).

% stream.pred_mono_strong
thf(fact_117_stream_Opred__cong,axiom,(
    ! [A: $tType,X2: ( stream @ A ),Ya: ( stream @ A ),P3: ( A > $o ),Pa: ( A > $o )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( sset @ A @ Ya ) )
           => ( ( P3 @ Z )
              = ( Pa @ Z ) ) )
       => ( ( pred_stream @ A @ P3 @ X2 )
          = ( pred_stream @ A @ Pa @ Ya ) ) ) ) )).

% stream.pred_cong
thf(fact_118_lfp_Oleq__antisym,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X2 )
           => ( X2 = Y ) ) ) ) )).

% lfp.leq_antisym
thf(fact_119_gfp_Oleq__antisym,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A] :
          ( ( ord_less_eq @ A @ Y @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y )
           => ( X2 = Y ) ) ) ) )).

% gfp.leq_antisym
thf(fact_120_llistsum__inf,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A )] :
          ( ~ ( coinductive_lfinite @ A @ Xs )
         => ( ( coindu780009021istsum @ A @ Xs )
            = ( zero_zero @ A ) ) ) ) )).

% llistsum_inf
thf(fact_121_lset__inf__llist,axiom,(
    ! [A: $tType,F: ( nat > A )] :
      ( ( coinductive_lset @ A @ ( coindu68654304_llist @ A @ F ) )
      = ( image @ nat @ A @ F @ ( top_top @ ( set @ nat ) ) ) ) )).

% lset_inf_llist
thf(fact_122_sset__smerge,axiom,(
    ! [A: $tType,Ss: ( stream @ ( stream @ A ) )] :
      ( ( sset @ A @ ( smerge @ A @ Ss ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( stream @ A ) @ ( set @ A ) @ ( sset @ A ) @ ( sset @ ( stream @ A ) @ Ss ) ) ) ) )).

% sset_smerge
thf(fact_123_llist_Opred__set,axiom,(
    ! [A: $tType] :
      ( ( coindu543516966_llist @ A )
      = ( ^ [P: ( A > $o ),X: ( coinductive_llist @ A )] :
          ! [Y4: A] :
            ( ( member @ A @ Y4 @ ( coinductive_lset @ A @ X ) )
           => ( P @ Y4 ) ) ) ) )).

% llist.pred_set
thf(fact_124_top__apply,axiom,(
    ! [C: $tType,D2: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D2 > C ) )
        = ( ^ [X: D2] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_125_UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_126_Union__iff,axiom,(
    ! [A: $tType,A2: A,C4: ( set @ ( set @ A ) )] :
      ( ( member @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ C4 ) )
      = ( ? [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ C4 )
            & ( member @ A @ A2 @ X ) ) ) ) )).

% Union_iff
thf(fact_127_UnionI,axiom,(
    ! [A: $tType,X3: ( set @ A ),C4: ( set @ ( set @ A ) ),A2: A] :
      ( ( member @ ( set @ A ) @ X3 @ C4 )
     => ( ( member @ A @ A2 @ X3 )
       => ( member @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ C4 ) ) ) ) )).

% UnionI
thf(fact_128_UN__ball__bex__simps_I1_J,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) ),P3: ( A > $o )] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) )
           => ( P3 @ X ) ) )
      = ( ! [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ A2 )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ X )
               => ( P3 @ Y4 ) ) ) ) ) )).

% UN_ball_bex_simps(1)
thf(fact_129_UN__ball__bex__simps_I3_J,axiom,(
    ! [D2: $tType,A2: ( set @ ( set @ D2 ) ),P3: ( D2 > $o )] :
      ( ( ? [X: D2] :
            ( ( member @ D2 @ X @ ( complete_Sup_Sup @ ( set @ D2 ) @ A2 ) )
            & ( P3 @ X ) ) )
      = ( ? [X: ( set @ D2 )] :
            ( ( member @ ( set @ D2 ) @ X @ A2 )
            & ? [Y4: D2] :
                ( ( member @ D2 @ Y4 @ X )
                & ( P3 @ Y4 ) ) ) ) ) )).

% UN_ball_bex_simps(3)
thf(fact_130_UN__ball__bex__simps_I4_J,axiom,(
    ! [F3: $tType,E: $tType,B2: ( E > ( set @ F3 ) ),A2: ( set @ E ),P3: ( F3 > $o )] :
      ( ( ? [X: F3] :
            ( ( member @ F3 @ X @ ( complete_Sup_Sup @ ( set @ F3 ) @ ( image @ E @ ( set @ F3 ) @ B2 @ A2 ) ) )
            & ( P3 @ X ) ) )
      = ( ? [X: E] :
            ( ( member @ E @ X @ A2 )
            & ? [Y4: F3] :
                ( ( member @ F3 @ Y4 @ ( B2 @ X ) )
                & ( P3 @ Y4 ) ) ) ) ) )).

% UN_ball_bex_simps(4)
thf(fact_131_UN__ball__bex__simps_I2_J,axiom,(
    ! [C: $tType,B: $tType,B2: ( B > ( set @ C ) ),A2: ( set @ B ),P3: ( C > $o )] :
      ( ( ! [X: C] :
            ( ( member @ C @ X @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ B @ ( set @ C ) @ B2 @ A2 ) ) )
           => ( P3 @ X ) ) )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ! [Y4: C] :
                ( ( member @ C @ Y4 @ ( B2 @ X ) )
               => ( P3 @ Y4 ) ) ) ) ) )).

% UN_ball_bex_simps(2)
thf(fact_132_bex__UN,axiom,(
    ! [A: $tType,B: $tType,B2: ( B > ( set @ A ) ),A2: ( set @ B ),P3: ( A > $o )] :
      ( ( ? [X: A] :
            ( ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
            & ( P3 @ X ) ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A2 )
            & ? [Y4: A] :
                ( ( member @ A @ Y4 @ ( B2 @ X ) )
                & ( P3 @ Y4 ) ) ) ) ) )).

% bex_UN
thf(fact_133_ball__UN,axiom,(
    ! [A: $tType,B: $tType,B2: ( B > ( set @ A ) ),A2: ( set @ B ),P3: ( A > $o )] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B2 @ A2 ) ) )
           => ( P3 @ X ) ) )
      = ( ! [X: B] :
            ( ( member @ B @ X @ A2 )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( B2 @ X ) )
               => ( P3 @ Y4 ) ) ) ) ) )).

% ball_UN
thf(fact_134_streams__UNIV,axiom,(
    ! [A: $tType] :
      ( ( streams @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( stream @ A ) ) ) ) )).

% streams_UNIV
thf(fact_135_Sup__UNIV,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ( ( complete_Sup_Sup @ A @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ A ) ) ) )).

% Sup_UNIV
thf(fact_136_Sup__eqI,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),X2: A] :
          ( ! [Y2: A] :
              ( ( member @ A @ Y2 @ A2 )
             => ( ord_less_eq @ A @ Y2 @ X2 ) )
         => ( ! [Y2: A] :
                ( ! [Z4: A] :
                    ( ( member @ A @ Z4 @ A2 )
                   => ( ord_less_eq @ A @ Z4 @ Y2 ) )
               => ( ord_less_eq @ A @ X2 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ A2 )
              = X2 ) ) ) ) )).

% Sup_eqI
thf(fact_137_complete__lattice__class_OSup__mono,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),B2: ( set @ A )] :
          ( ! [A4: A] :
              ( ( member @ A @ A4 @ A2 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ B2 )
                  & ( ord_less_eq @ A @ A4 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) )).

% complete_lattice_class.Sup_mono
thf(fact_138_Sup__least,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),Z3: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A2 )
             => ( ord_less_eq @ A @ X4 @ Z3 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ Z3 ) ) ) )).

% Sup_least
thf(fact_139_Sup__upper,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [X2: A,A2: ( set @ A )] :
          ( ( member @ A @ X2 @ A2 )
         => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) )).

% Sup_upper
thf(fact_140_Sup__le__iff,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),B3: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ B3 )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A2 )
               => ( ord_less_eq @ A @ X @ B3 ) ) ) ) ) )).

% Sup_le_iff
thf(fact_141_Sup__upper2,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [U: A,A2: ( set @ A ),V: A] :
          ( ( member @ A @ U @ A2 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ) )).

% Sup_upper2
thf(fact_142_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_143_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_144_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_145_SUP__cong,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( complete_Sup @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),B2: ( set @ B ),C4: ( B > A ),D: ( B > A )] :
          ( ( A2 = B2 )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ B2 )
               => ( ( C4 @ X4 )
                  = ( D @ X4 ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ C4 @ A2 ) )
              = ( complete_Sup_Sup @ A @ ( image @ B @ A @ D @ B2 ) ) ) ) ) ) )).

% SUP_cong
thf(fact_146_Union__upper,axiom,(
    ! [A: $tType,B2: ( set @ A ),A2: ( set @ ( set @ A ) )] :
      ( ( member @ ( set @ A ) @ B2 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) ) ) )).

% Union_upper
thf(fact_147_Union__least,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) ),C4: ( set @ A )] :
      ( ! [X6: ( set @ A )] :
          ( ( member @ ( set @ A ) @ X6 @ A2 )
         => ( ord_less_eq @ ( set @ A ) @ X6 @ C4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) @ C4 ) ) )).

% Union_least
thf(fact_148_Union__mono,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) ),B2: ( set @ ( set @ A ) )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B2 ) ) ) )).

% Union_mono
thf(fact_149_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B3: A,F: ( B > A ),X2: B] :
      ( ( B3
        = ( F @ X2 ) )
     => ( member @ A @ B3 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_150_rangeI,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X2: B] :
      ( member @ A @ ( F @ X2 ) @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_151_subset__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_152_Union__UNIV,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Union_UNIV
thf(fact_153_UnionE,axiom,(
    ! [A: $tType,A2: A,C4: ( set @ ( set @ A ) )] :
      ( ( member @ A @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ C4 ) )
     => ~ ( ! [X6: ( set @ A )] :
              ( ( member @ A @ A2 @ X6 )
             => ~ ( member @ ( set @ A ) @ X6 @ C4 ) ) ) ) )).

% UnionE
thf(fact_154_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X4: A] :
      ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_155_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X4: A] :
          ( member @ A @ X4 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_156_llist_Opred__cong,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Ya: ( coinductive_llist @ A ),P3: ( A > $o ),Pa: ( A > $o )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( coinductive_lset @ A @ Ya ) )
           => ( ( P3 @ Z )
              = ( Pa @ Z ) ) )
       => ( ( coindu543516966_llist @ A @ P3 @ X2 )
          = ( coindu543516966_llist @ A @ Pa @ Ya ) ) ) ) )).

% llist.pred_cong
thf(fact_157_llist_Opred__mono__strong,axiom,(
    ! [A: $tType,P3: ( A > $o ),X2: ( coinductive_llist @ A ),Pa: ( A > $o )] :
      ( ( coindu543516966_llist @ A @ P3 @ X2 )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( coinductive_lset @ A @ X2 ) )
           => ( ( P3 @ Z )
             => ( Pa @ Z ) ) )
       => ( coindu543516966_llist @ A @ Pa @ X2 ) ) ) )).

% llist.pred_mono_strong
thf(fact_158_SUP__eq,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),B2: ( set @ C ),F: ( B > A ),G: ( C > A )] :
          ( ! [I: B] :
              ( ( member @ B @ I @ A2 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B2 )
                  & ( ord_less_eq @ A @ ( F @ I ) @ ( G @ X5 ) ) ) )
         => ( ! [J: C] :
                ( ( member @ C @ J @ B2 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A2 )
                    & ( ord_less_eq @ A @ ( G @ J ) @ ( F @ X5 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B2 ) ) ) ) ) ) )).

% SUP_eq
thf(fact_159_Sup__subset__mono,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),B2: ( set @ A )] :
          ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) )).

% Sup_subset_mono
thf(fact_160_sset__range,axiom,(
    ! [A: $tType] :
      ( ( sset @ A )
      = ( ^ [S: ( stream @ A )] :
            ( image @ nat @ A @ ( snth @ A @ S ) @ ( top_top @ ( set @ nat ) ) ) ) ) )).

% sset_range
thf(fact_161_llistsum__infllist,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [F: ( nat > A )] :
          ( ( coindu780009021istsum @ A @ ( coindu68654304_llist @ A @ F ) )
          = ( zero_zero @ A ) ) ) )).

% llistsum_infllist
thf(fact_162_le__zero__eq,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) )).

% le_zero_eq
thf(fact_163_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_164_surj__def,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y4: A] :
          ? [X: B] :
            ( Y4
            = ( F @ X ) ) ) ) )).

% surj_def
thf(fact_165_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_166_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( ( zero_zero @ A )
            = X2 )
          = ( X2
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_167_zero__le,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) )).

% zero_le
thf(fact_168_surjD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X4: B] :
          ( Y
          = ( F @ X4 ) ) ) )).

% surjD
thf(fact_169_surjE,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X4: B] :
              ( Y
             != ( F @ X4 ) ) ) ) )).

% surjE
thf(fact_170_surjI,axiom,(
    ! [B: $tType,A: $tType,G: ( B > A ),F: ( A > B )] :
      ( ! [X4: A] :
          ( ( G @ ( F @ X4 ) )
          = X4 )
     => ( ( image @ B @ A @ G @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_171_cSup__eq,axiom,(
    ! [A: $tType] :
      ( ( ( condit378418413attice @ A @ ( type2 @ A ) )
        & ( no_bot @ A @ ( type2 @ A ) ) )
     => ! [X3: ( set @ A ),A3: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ X3 )
             => ( ord_less_eq @ A @ X4 @ A3 ) )
         => ( ! [Y2: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X3 )
                   => ( ord_less_eq @ A @ X5 @ Y2 ) )
               => ( ord_less_eq @ A @ A3 @ Y2 ) )
           => ( ( complete_Sup_Sup @ A @ X3 )
              = A3 ) ) ) ) )).

% cSup_eq
thf(fact_172_cSup__eq__maximum,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [Z3: A,X3: ( set @ A )] :
          ( ( member @ A @ Z3 @ X3 )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X3 )
               => ( ord_less_eq @ A @ X4 @ Z3 ) )
           => ( ( complete_Sup_Sup @ A @ X3 )
              = Z3 ) ) ) ) )).

% cSup_eq_maximum
thf(fact_173_le__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% le_numeral_extra(3)
thf(fact_174_top1I,axiom,(
    ! [A: $tType,X2: A] :
      ( top_top @ ( A > $o ) @ X2 ) )).

% top1I
thf(fact_175_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X: A] :
            ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_176_top__conj_I2_J,axiom,(
    ! [A: $tType,P3: $o,X2: A] :
      ( ( P3
        & ( top_top @ ( A > $o ) @ X2 ) )
      = P3 ) )).

% top_conj(2)
thf(fact_177_top__conj_I1_J,axiom,(
    ! [A: $tType,X2: A,P3: $o] :
      ( ( ( top_top @ ( A > $o ) @ X2 )
        & P3 )
      = P3 ) )).

% top_conj(1)
thf(fact_178_Sup__SUP__eq,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( A > $o ) )
      = ( ^ [S6: ( set @ ( A > $o ) ),X: A] :
            ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( A > $o ) @ ( set @ A ) @ ( collect @ A ) @ S6 ) ) ) ) ) )).

% Sup_SUP_eq
thf(fact_179_surj__from__nat,axiom,(
    ! [A: $tType] :
      ( ( countable @ A @ ( type2 @ A ) )
     => ( ( image @ nat @ A @ ( from_nat @ A ) @ ( top_top @ ( set @ nat ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_from_nat
thf(fact_180_member__bind,axiom,(
    ! [A: $tType,B: $tType,X2: A,P3: ( set @ B ),F: ( B > ( set @ A ) )] :
      ( ( member @ A @ X2 @ ( bind @ B @ A @ P3 @ F ) )
      = ( member @ A @ X2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F @ P3 ) ) ) ) )).

% member_bind
thf(fact_181_image__Pow__mono,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: ( set @ B ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F @ A2 ) @ B2 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F ) @ ( pow @ B @ A2 ) ) @ ( pow @ A @ B2 ) ) ) )).

% image_Pow_mono
thf(fact_182_Sup1__I,axiom,(
    ! [A: $tType,P3: ( A > $o ),A2: ( set @ ( A > $o ) ),A3: A] :
      ( ( member @ ( A > $o ) @ P3 @ A2 )
     => ( ( P3 @ A3 )
       => ( complete_Sup_Sup @ ( A > $o ) @ A2 @ A3 ) ) ) )).

% Sup1_I
thf(fact_183_Pow__iff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A2 @ ( pow @ A @ B2 ) )
      = ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% Pow_iff
thf(fact_184_PowI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( member @ ( set @ A ) @ A2 @ ( pow @ A @ B2 ) ) ) )).

% PowI
thf(fact_185_Union__Pow__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( pow @ A @ A2 ) )
      = A2 ) )).

% Union_Pow_eq
thf(fact_186_Pow__UNIV,axiom,(
    ! [A: $tType] :
      ( ( pow @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( set @ A ) ) ) ) )).

% Pow_UNIV
thf(fact_187_image__Pow__surj,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: ( set @ B ),B2: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ A2 )
        = B2 )
     => ( ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F ) @ ( pow @ B @ A2 ) )
        = ( pow @ A @ B2 ) ) ) )).

% image_Pow_surj
thf(fact_188_Sup1__E,axiom,(
    ! [A: $tType,A2: ( set @ ( A > $o ) ),A3: A] :
      ( ( complete_Sup_Sup @ ( A > $o ) @ A2 @ A3 )
     => ~ ( ! [P4: ( A > $o )] :
              ( ( member @ ( A > $o ) @ P4 @ A2 )
             => ~ ( P4 @ A3 ) ) ) ) )).

% Sup1_E
thf(fact_189_Cantors__paradox,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ~ ( ? [X5: ( A > ( set @ A ) )] :
            ( ( image @ A @ ( set @ A ) @ X5 @ A2 )
            = ( pow @ A @ A2 ) ) ) )).

% Cantors_paradox
thf(fact_190_PowD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ ( set @ A ) @ A2 @ ( pow @ A @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% PowD
thf(fact_191_Pow__top,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( set @ A ) @ A2 @ ( pow @ A @ A2 ) ) )).

% Pow_top
thf(fact_192_Pow__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow @ A @ A2 ) @ ( pow @ A @ B2 ) ) ) )).

% Pow_mono
thf(fact_193_subset__Pow__Union,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) )] :
      ( ord_less_eq @ ( set @ ( set @ A ) ) @ A2 @ ( pow @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A2 ) ) ) )).

% subset_Pow_Union
thf(fact_194_bind__UNION,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( bind @ B @ A )
      = ( ^ [A5: ( set @ B ),F2: ( B > ( set @ A ) )] :
            ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ A5 ) ) ) ) )).

% bind_UNION
thf(fact_195_surj__swap__iff,axiom,(
    ! [B: $tType,A: $tType,A3: B,B3: B,F: ( B > A )] :
      ( ( ( image @ B @ A @ ( swap @ B @ A @ A3 @ B3 @ F ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_swap_iff
thf(fact_196_cSUP__least,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),F: ( B > A ),M2: A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X4: B] :
                ( ( member @ B @ X4 @ A2 )
               => ( ord_less_eq @ A @ ( F @ X4 ) @ M2 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) ) @ M2 ) ) ) ) )).

% cSUP_least
thf(fact_197_SUP__eq__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [I2: ( set @ B ),C3: A,F: ( B > A )] :
          ( ( I2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I: B] :
                ( ( member @ B @ I @ I2 )
               => ( ord_less_eq @ A @ C3 @ ( F @ I ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ I2 ) )
                = C3 )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ I2 )
                   => ( ( F @ X )
                      = C3 ) ) ) ) ) ) ) )).

% SUP_eq_iff
thf(fact_198_bot__apply,axiom,(
    ! [C: $tType,D2: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D2 > C ) )
        = ( ^ [X: D2] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_199_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_200_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X: A] :
            ~ ( member @ A @ X @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_201_Collect__empty__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( collect @ A @ P3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: A] :
            ~ ( P3 @ X ) ) ) )).

% Collect_empty_eq
thf(fact_202_empty__Collect__eq,axiom,(
    ! [A: $tType,P3: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P3 ) )
      = ( ! [X: A] :
            ~ ( P3 @ X ) ) ) )).

% empty_Collect_eq
thf(fact_203_image__is__empty,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( ( image @ B @ A @ F @ A2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% image_is_empty
thf(fact_204_empty__is__image,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: ( set @ B )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( image @ B @ A @ F @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% empty_is_image
thf(fact_205_image__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( image @ B @ A @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% image_empty
thf(fact_206_Sup__bot__conv_I1_J,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( ( complete_Sup_Sup @ A @ A2 )
            = ( bot_bot @ A ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A2 )
               => ( X
                  = ( bot_bot @ A ) ) ) ) ) ) )).

% Sup_bot_conv(1)
thf(fact_207_Sup__bot__conv_I2_J,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( ( bot_bot @ A )
            = ( complete_Sup_Sup @ A @ A2 ) )
          = ( ! [X: A] :
                ( ( member @ A @ X @ A2 )
               => ( X
                  = ( bot_bot @ A ) ) ) ) ) ) )).

% Sup_bot_conv(2)
thf(fact_208_subset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_209_empty__subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) )).

% empty_subsetI
thf(fact_210_ball__empty,axiom,(
    ! [A: $tType,P3: ( A > $o ),X5: A] :
      ( ( member @ A @ X5 @ ( bot_bot @ ( set @ A ) ) )
     => ( P3 @ X5 ) ) )).

% ball_empty
thf(fact_211_swap__image__eq,axiom,(
    ! [B: $tType,A: $tType,A3: A,A2: ( set @ A ),B3: A,F: ( A > B )] :
      ( ( member @ A @ A3 @ A2 )
     => ( ( member @ A @ B3 @ A2 )
       => ( ( image @ A @ B @ ( swap @ A @ B @ A3 @ B3 @ F ) @ A2 )
          = ( image @ A @ B @ F @ A2 ) ) ) ) )).

% swap_image_eq
thf(fact_212_empty__bind,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( set @ A ) )] :
      ( ( bind @ B @ A @ ( bot_bot @ ( set @ B ) ) @ F )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_bind
thf(fact_213_Sup__empty,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) )).

% Sup_empty
thf(fact_214_empty__Union__conv,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ A2 ) )
      = ( ! [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ A2 )
           => ( X
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% empty_Union_conv
thf(fact_215_Union__empty__conv,axiom,(
    ! [A: $tType,A2: ( set @ ( set @ A ) )] :
      ( ( ( complete_Sup_Sup @ ( set @ A ) @ A2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X @ A2 )
           => ( X
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% Union_empty_conv
thf(fact_216_Union__empty,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Union_empty
thf(fact_217_Pow__not__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( pow @ A @ A2 )
     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) )).

% Pow_not_empty
thf(fact_218_Pow__bottom,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( member @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( pow @ A @ B2 ) ) )).

% Pow_bottom
thf(fact_219_empty__not__UNIV,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
     != ( top_top @ ( set @ A ) ) ) )).

% empty_not_UNIV
thf(fact_220_sset__neq__empty,axiom,(
    ! [A: $tType,Xs: ( stream @ A )] :
      ( ( sset @ A @ Xs )
     != ( bot_bot @ ( set @ A ) ) ) )).

% sset_neq_empty
thf(fact_221_emptyE,axiom,(
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_222_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A3: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A3 @ A2 ) ) )).

% equals0D
thf(fact_223_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_224_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X: A] :
            ( member @ A @ X @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_225_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_226_streams__empty,axiom,(
    ! [A: $tType] :
      ( ( streams @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ ( stream @ A ) ) ) ) )).

% streams_empty
thf(fact_227_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) )).

% bot.extremum
thf(fact_228_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_229_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_230_less__eq__Sup,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),U: A] :
          ( ! [V2: A] :
              ( ( member @ A @ V2 @ A2 )
             => ( ord_less_eq @ A @ U @ V2 ) )
         => ( ( A2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ) )).

% less_eq_Sup
thf(fact_231_cSup__least,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [X3: ( set @ A ),Z3: A] :
          ( ( X3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X3 )
               => ( ord_less_eq @ A @ X4 @ Z3 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X3 ) @ Z3 ) ) ) ) )).

% cSup_least
thf(fact_232_cSup__eq__non__empty,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [X3: ( set @ A ),A3: A] :
          ( ( X3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X4: A] :
                ( ( member @ A @ X4 @ X3 )
               => ( ord_less_eq @ A @ X4 @ A3 ) )
           => ( ! [Y2: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X3 )
                     => ( ord_less_eq @ A @ X5 @ Y2 ) )
                 => ( ord_less_eq @ A @ A3 @ Y2 ) )
             => ( ( complete_Sup_Sup @ A @ X3 )
                = A3 ) ) ) ) ) )).

% cSup_eq_non_empty
thf(fact_233_SUP__eq__const,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [I2: ( set @ B ),F: ( B > A ),X2: A] :
          ( ( I2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I: B] :
                ( ( member @ B @ I @ I2 )
               => ( ( F @ I )
                  = X2 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ I2 ) )
              = X2 ) ) ) ) )).

% SUP_eq_const
thf(fact_234_surj__imp__surj__swap,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A3: B,B3: B] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ ( swap @ B @ A @ A3 @ B3 @ F ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_imp_surj_swap
thf(fact_235_ccSup__empty,axiom,(
    ! [A: $tType] :
      ( ( counta840220525attice @ A @ ( type2 @ A ) )
     => ( ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( bot_bot @ A ) ) ) )).

% ccSup_empty
thf(fact_236_subset__emptyI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X4: A] :
          ~ ( member @ A @ X4 @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_237_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_238_lset__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lset @ A )
      = ( coinductive_gen_lset @ A @ ( bot_bot @ ( set @ A ) ) ) ) )).

% lset_code
thf(fact_239_the__elem__image__unique,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),F: ( A > B ),X2: A] :
      ( ( A2
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [Y2: A] :
            ( ( member @ A @ Y2 @ A2 )
           => ( ( F @ Y2 )
              = ( F @ X2 ) ) )
       => ( ( the_elem @ B @ ( image @ A @ B @ F @ A2 ) )
          = ( F @ X2 ) ) ) ) )).

% the_elem_image_unique
thf(fact_240_cSUP__subset__mono,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),G: ( B > A ),B2: ( set @ B ),F: ( B > A )] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1810911227_above @ A @ ( image @ B @ A @ G @ B2 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A2 @ B2 )
             => ( ! [X4: B] :
                    ( ( member @ B @ X4 @ B2 )
                   => ( ord_less_eq @ A @ ( F @ X4 ) @ ( G @ X4 ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B2 ) ) ) ) ) ) ) ) )).

% cSUP_subset_mono
thf(fact_241_compact__bot,axiom,(
    ! [A: $tType] :
      ( ( comple1141879883l_ccpo @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( X2
            = ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) ) )
         => ( comple2143767107ompact @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ X2 ) ) ) )).

% compact_bot
thf(fact_242_bdd__aboveI,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),M2: A] :
          ( ! [X4: A] :
              ( ( member @ A @ X4 @ A2 )
             => ( ord_less_eq @ A @ X4 @ M2 ) )
         => ( condit1810911227_above @ A @ A2 ) ) ) )).

% bdd_aboveI
thf(fact_243_cSup__le__iff,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [S5: ( set @ A ),A3: A] :
          ( ( S5
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1810911227_above @ A @ S5 )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S5 ) @ A3 )
              = ( ! [X: A] :
                    ( ( member @ A @ X @ S5 )
                   => ( ord_less_eq @ A @ X @ A3 ) ) ) ) ) ) ) )).

% cSup_le_iff
thf(fact_244_cSup__mono,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [B2: ( set @ A ),A2: ( set @ A )] :
          ( ( B2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1810911227_above @ A @ A2 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B2 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A2 )
                      & ( ord_less_eq @ A @ B4 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B2 ) @ ( complete_Sup_Sup @ A @ A2 ) ) ) ) ) ) )).

% cSup_mono
thf(fact_245_bdd__above__def,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ( ( condit1810911227_above @ A )
        = ( ^ [A5: ( set @ A )] :
            ? [M3: A] :
            ! [X: A] :
              ( ( member @ A @ X @ A5 )
             => ( ord_less_eq @ A @ X @ M3 ) ) ) ) ) )).

% bdd_above_def
thf(fact_246_bdd__above__mono,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [B2: ( set @ A ),A2: ( set @ A )] :
          ( ( condit1810911227_above @ A @ B2 )
         => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
           => ( condit1810911227_above @ A @ A2 ) ) ) ) )).

% bdd_above_mono
thf(fact_247_cSup__upper2,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [X2: A,X3: ( set @ A ),Y: A] :
          ( ( member @ A @ X2 @ X3 )
         => ( ( ord_less_eq @ A @ Y @ X2 )
           => ( ( condit1810911227_above @ A @ X3 )
             => ( ord_less_eq @ A @ Y @ ( complete_Sup_Sup @ A @ X3 ) ) ) ) ) ) )).

% cSup_upper2
thf(fact_248_cSup__upper,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [X2: A,X3: ( set @ A )] :
          ( ( member @ A @ X2 @ X3 )
         => ( ( condit1810911227_above @ A @ X3 )
           => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ X3 ) ) ) ) ) )).

% cSup_upper
thf(fact_249_bdd__aboveI2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),F: ( B > A ),M2: A] :
          ( ! [X4: B] :
              ( ( member @ B @ X4 @ A2 )
             => ( ord_less_eq @ A @ ( F @ X4 ) @ M2 ) )
         => ( condit1810911227_above @ A @ ( image @ B @ A @ F @ A2 ) ) ) ) )).

% bdd_aboveI2
thf(fact_250_cSUP__upper2,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [F: ( B > A ),A2: ( set @ B ),X2: B,U: A] :
          ( ( condit1810911227_above @ A @ ( image @ B @ A @ F @ A2 ) )
         => ( ( member @ B @ X2 @ A2 )
           => ( ( ord_less_eq @ A @ U @ ( F @ X2 ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) ) ) ) ) ) ) )).

% cSUP_upper2
thf(fact_251_cSUP__upper,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [X2: B,A2: ( set @ B ),F: ( B > A )] :
          ( ( member @ B @ X2 @ A2 )
         => ( ( condit1810911227_above @ A @ ( image @ B @ A @ F @ A2 ) )
           => ( ord_less_eq @ A @ ( F @ X2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) ) ) ) ) ) )).

% cSUP_upper
thf(fact_252_cSUP__le__iff,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),F: ( B > A ),U: A] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1810911227_above @ A @ ( image @ B @ A @ F @ A2 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) ) @ U )
              = ( ! [X: B] :
                    ( ( member @ B @ X @ A2 )
                   => ( ord_less_eq @ A @ ( F @ X ) @ U ) ) ) ) ) ) ) )).

% cSUP_le_iff
thf(fact_253_cSUP__mono,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ B ),G: ( C > A ),B2: ( set @ C ),F: ( B > A )] :
          ( ( A2
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1810911227_above @ A @ ( image @ C @ A @ G @ B2 ) )
           => ( ! [N4: B] :
                  ( ( member @ B @ N4 @ A2 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B2 )
                      & ( ord_less_eq @ A @ ( F @ N4 ) @ ( G @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F @ A2 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B2 ) ) ) ) ) ) ) )).

% cSUP_mono
thf(fact_254_cSup__subset__mono,axiom,(
    ! [A: $tType] :
      ( ( condit378418413attice @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A ),B2: ( set @ A )] :
          ( ( A2
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1810911227_above @ A @ B2 )
           => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A2 ) @ ( complete_Sup_Sup @ A @ B2 ) ) ) ) ) ) )).

% cSup_subset_mono

%----Type constructors (57)
thf(tcon_HOL_Obool___Finite__Set_Ofinite,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_1,axiom,(
    ! [A6: $tType] :
      ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
     => ( finite_finite @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite_2,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
        & ( finite_finite @ A7 @ ( type2 @ A7 ) ) )
     => ( finite_finite @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( comple187826305attice @ A7 @ ( type2 @ A7 ) )
     => ( condit378418413attice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( counta840220525attice @ A7 @ ( type2 @ A7 ) )
     => ( counta840220525attice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( comple187826305attice @ A7 @ ( type2 @ A7 ) )
     => ( comple187826305attice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Complete__Partial__Order_Occpo,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( comple187826305attice @ A7 @ ( type2 @ A7 ) )
     => ( comple1141879883l_ccpo @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Complete__Lattices_OSup,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( complete_Sup @ A7 @ ( type2 @ A7 ) )
     => ( complete_Sup @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order_top @ A7 @ ( type2 @ A7 ) )
     => ( order_top @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order_bot @ A7 @ ( type2 @ A7 ) )
     => ( order_bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Countable_Ocountable,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
        & ( countable @ A7 @ ( type2 @ A7 ) ) )
     => ( countable @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( preorder @ A7 @ ( type2 @ A7 ) )
     => ( preorder @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( top @ A7 @ ( type2 @ A7 ) )
     => ( top @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bot @ A7 @ ( type2 @ A7 ) )
     => ( bot @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_3,axiom,
    ( condit378418413attice @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Complete__Lattices_OSup_4,axiom,
    ( complete_Sup @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_5,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Countable_Ocountable_6,axiom,
    ( countable @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_7,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add,axiom,
    ( monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_8,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_9,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_10,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_11,axiom,(
    ! [A6: $tType] :
      ( condit378418413attice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_12,axiom,(
    ! [A6: $tType] :
      ( counta840220525attice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_13,axiom,(
    ! [A6: $tType] :
      ( comple187826305attice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Complete__Partial__Order_Occpo_14,axiom,(
    ! [A6: $tType] :
      ( comple1141879883l_ccpo @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Complete__Lattices_OSup_15,axiom,(
    ! [A6: $tType] :
      ( complete_Sup @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_16,axiom,(
    ! [A6: $tType] :
      ( order_top @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_17,axiom,(
    ! [A6: $tType] :
      ( order_bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Countable_Ocountable_18,axiom,(
    ! [A6: $tType] :
      ( ( finite_finite @ A6 @ ( type2 @ A6 ) )
     => ( countable @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_19,axiom,(
    ! [A6: $tType] :
      ( preorder @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_20,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_21,axiom,(
    ! [A6: $tType] :
      ( top @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_22,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_23,axiom,(
    ! [A6: $tType] :
      ( bot @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_24,axiom,
    ( condit378418413attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_25,axiom,
    ( counta840220525attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_26,axiom,
    ( comple187826305attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Partial__Order_Occpo_27,axiom,
    ( comple1141879883l_ccpo @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Lattices_OSup_28,axiom,
    ( complete_Sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_29,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_30,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Countable_Ocountable_31,axiom,
    ( countable @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_32,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_33,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_34,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_35,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_36,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_37,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( snth @ a @ ( coindu176146587of_seq @ a @ f ) )
    = f )).

%------------------------------------------------------------------------------
