%------------------------------------------------------------------------------
% File     : DAT152^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Coinductive stream 429
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : coinductive_stream__429.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  323 (   0 unit;  39 type;   0 defn)
%            Number of atoms       : 3752 ( 179 equality;2277 variable)
%            Maximal formula depth :   21 (   9 average)
%            Number of connectives : 3478 ( 119   ~;  22   |;  45   &;2820   @)
%                                         (   0 <=>; 472  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  198 ( 198   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   43 (  39   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  991 (   3 sgn; 816   !;  38   ?; 106   ^)
%                                         ( 991   :;  31  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 15:14:51.363
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Extended__Nat_Oenat,type,(
    extended_enat: $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (33)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__linorder,type,(
    dense_linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,(
    condit1656338222tinuum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,(
    condit1037483654norder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__Stream__Mirabelle__dydkjoctes_Oscount,type,(
    coindu1365464361scount: 
      !>[S: $tType] :
        ( ( ( stream @ S ) > $o ) > ( stream @ S ) > extended_enat ) )).

thf(sy_c_Extended__Nat_Oenat,type,(
    extended_enat2: nat > extended_enat )).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,(
    extended_case_enat: 
      !>[T: $tType] :
        ( ( nat > T ) > T > extended_enat > T ) )).

thf(sy_c_Extended__Nat_Oenat_Orec__enat,type,(
    extended_rec_enat: 
      !>[T: $tType] :
        ( ( nat > T ) > T > extended_enat > T ) )).

thf(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,(
    extend1396239628finity: 
      !>[A: $tType] : A )).

thf(sy_c_Finite__Set_Ocard,type,(
    finite_card: 
      !>[B: $tType] :
        ( ( set @ B ) > nat ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Oalw,type,(
    linear1386806755on_alw: 
      !>[A: $tType] :
        ( ( ( stream @ A ) > $o ) > ( stream @ A ) > $o ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Oev,type,(
    linear505997466_on_ev: 
      !>[A: $tType] :
        ( ( ( stream @ A ) > $o ) > ( stream @ A ) > $o ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Onxt,type,(
    linear1494993505on_nxt: 
      !>[A: $tType,B: $tType] :
        ( ( ( stream @ A ) > B ) > ( stream @ A ) > B ) )).

thf(sy_c_Linear__Temporal__Logic__on__Streams_Owait,type,(
    linear1335279038n_wait: 
      !>[A: $tType] :
        ( ( ( stream @ A ) > $o ) > ( stream @ A ) > nat ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Stream_Osdrop,type,(
    sdrop: 
      !>[A: $tType] :
        ( nat > ( stream @ A ) > ( stream @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_P,type,(
    p: ( stream @ a ) > $o )).

thf(sy_v__092_060omega_062,type,(
    omega: ( stream @ a ) )).

%----Relevant facts (256)
thf(fact_0__092_060open_062ev_A_Ialw_A_I_092_060lambda_062xs_O_A_092_060not_062_AP_Axs_J_J_A_092_060omega_062_A_092_060Longrightarrow_062_Ascount_AP_A_092_060omega_062_A_061_Aenat_A_Icard_A_123i_O_AP_A_Isdrop_Ai_A_092_060omega_062_J_125_J_092_060close_062,axiom,
    ( ( linear505997466_on_ev @ a
      @ ( linear1386806755on_alw @ a
        @ ^ [Xs: ( stream @ a )] :
            ~ ( p @ Xs ) )
      @ omega )
   => ( ( coindu1365464361scount @ a @ p @ omega )
      = ( extended_enat2
        @ ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [I: nat] :
                ( p @ ( sdrop @ a @ I @ omega ) ) ) ) ) ) )).

% \<open>ev (alw (\<lambda>xs. \<not> P xs)) \<omega> \<Longrightarrow> scount P \<omega> = enat (card {i. P (sdrop i \<omega>)})\<close>
thf(fact_1_not__ev__not,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o )] :
      ( ( ^ [Xs: ( stream @ A )] :
            ~ ( linear505997466_on_ev @ A
              @ ^ [Xt: ( stream @ A )] :
                  ~ ( Phi @ Xt )
              @ Xs ) )
      = ( linear1386806755on_alw @ A @ Phi ) ) )).

% not_ev_not
thf(fact_2_not__alw__not,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o )] :
      ( ( ^ [Xs: ( stream @ A )] :
            ~ ( linear1386806755on_alw @ A
              @ ^ [Xt: ( stream @ A )] :
                  ~ ( Phi @ Xt )
              @ Xs ) )
      = ( linear505997466_on_ev @ A @ Phi ) ) )).

% not_alw_not
thf(fact_3_enat__ord__simps_I6_J,axiom,(
    ! [Q: extended_enat] :
      ~ ( ord_less @ extended_enat @ ( extend1396239628finity @ extended_enat ) @ Q ) )).

% enat_ord_simps(6)
thf(fact_4_enat__ord__simps_I4_J,axiom,(
    ! [Q: extended_enat] :
      ( ( ord_less @ extended_enat @ Q @ ( extend1396239628finity @ extended_enat ) )
      = ( Q
       != ( extend1396239628finity @ extended_enat ) ) ) )).

% enat_ord_simps(4)
thf(fact_5_ev__ev,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A @ ( linear505997466_on_ev @ A @ Phi ) )
      = ( linear505997466_on_ev @ A @ Phi ) ) )).

% ev_ev
thf(fact_6_alw__alw,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A @ ( linear1386806755on_alw @ A @ Phi ) )
      = ( linear1386806755on_alw @ A @ Phi ) ) )).

% alw_alw
thf(fact_7_not__ev,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o )] :
      ( ( ^ [Xs: ( stream @ A )] :
            ~ ( linear505997466_on_ev @ A @ Phi @ Xs ) )
      = ( linear1386806755on_alw @ A
        @ ^ [Xs: ( stream @ A )] :
            ~ ( Phi @ Xs ) ) ) )).

% not_ev
thf(fact_8_not__alw,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o )] :
      ( ( ^ [Xs: ( stream @ A )] :
            ~ ( linear1386806755on_alw @ A @ Phi @ Xs ) )
      = ( linear505997466_on_ev @ A
        @ ^ [Xs: ( stream @ A )] :
            ~ ( Phi @ Xs ) ) ) )).

% not_alw
thf(fact_9_not__ev__iff,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( ~ ( linear505997466_on_ev @ A @ P @ Omega ) )
      = ( linear1386806755on_alw @ A
        @ ^ [Xs: ( stream @ A )] :
            ~ ( P @ Xs )
        @ Omega ) ) )).

% not_ev_iff
thf(fact_10_ev__alw__aand,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A @ ( linear1386806755on_alw @ A @ Phi ) @ Xs2 )
     => ( ( linear505997466_on_ev @ A @ ( linear1386806755on_alw @ A @ Psi ) @ Xs2 )
       => ( linear505997466_on_ev @ A
          @ ( linear1386806755on_alw @ A
            @ ^ [Xs: ( stream @ A )] :
                ( ( Phi @ Xs )
                & ( Psi @ Xs ) ) )
          @ Xs2 ) ) ) )).

% ev_alw_aand
thf(fact_11_ev__alw__impl,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A @ Phi @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( Phi @ Xs )
             => ( Psi @ Xs ) )
          @ Xs2 )
       => ( linear505997466_on_ev @ A @ Psi @ Xs2 ) ) ) )).

% ev_alw_impl
thf(fact_12_not__alw__iff,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( ~ ( linear1386806755on_alw @ A @ P @ Omega ) )
      = ( linear505997466_on_ev @ A
        @ ^ [Xs: ( stream @ A )] :
            ~ ( P @ Xs )
        @ Omega ) ) )).

% not_alw_iff
thf(fact_13_enat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( extended_enat2 @ Nat )
        = ( extended_enat2 @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% enat.inject
thf(fact_14_not__infinity__eq,axiom,(
    ! [X: extended_enat] :
      ( ( X
       != ( extend1396239628finity @ extended_enat ) )
      = ( ? [I: nat] :
            ( X
            = ( extended_enat2 @ I ) ) ) ) )).

% not_infinity_eq
thf(fact_15_not__enat__eq,axiom,(
    ! [X: extended_enat] :
      ( ( ! [Y: nat] :
            ( X
           != ( extended_enat2 @ Y ) ) )
      = ( X
        = ( extend1396239628finity @ extended_enat ) ) ) )).

% not_enat_eq
thf(fact_16_enat__ex__split,axiom,
    ( ( ^ [P2: ( extended_enat > $o )] :
        ? [X2: extended_enat] :
          ( P2 @ X2 ) )
    = ( ^ [P3: ( extended_enat > $o )] :
          ( ( P3 @ ( extend1396239628finity @ extended_enat ) )
          | ? [X3: nat] :
              ( P3 @ ( extended_enat2 @ X3 ) ) ) ) )).

% enat_ex_split
thf(fact_17_enat_Oinducts,axiom,(
    ! [P: ( extended_enat > $o ),Enat: extended_enat] :
      ( ! [Nat3: nat] :
          ( P @ ( extended_enat2 @ Nat3 ) )
     => ( ( P @ ( extend1396239628finity @ extended_enat ) )
       => ( P @ Enat ) ) ) )).

% enat.inducts
thf(fact_18_enat_Oexhaust,axiom,(
    ! [Y2: extended_enat] :
      ( ! [Nat3: nat] :
          ( Y2
         != ( extended_enat2 @ Nat3 ) )
     => ( Y2
        = ( extend1396239628finity @ extended_enat ) ) ) )).

% enat.exhaust
thf(fact_19_enat3__cases,axiom,(
    ! [Y2: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y2
            = ( extended_enat2 @ Nat3 ) )
       => ( ? [Nata: nat] :
              ( Ya
              = ( extended_enat2 @ Nata ) )
         => ! [Natb: nat] :
              ( Yb
             != ( extended_enat2 @ Natb ) ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y2
              = ( extended_enat2 @ Nat3 ) )
         => ( ? [Nata: nat] :
                ( Ya
                = ( extended_enat2 @ Nata ) )
           => ( Yb
             != ( extend1396239628finity @ extended_enat ) ) ) )
       => ( ( ? [Nat3: nat] :
                ( Y2
                = ( extended_enat2 @ Nat3 ) )
           => ( ( Ya
                = ( extend1396239628finity @ extended_enat ) )
             => ! [Nata: nat] :
                  ( Yb
                 != ( extended_enat2 @ Nata ) ) ) )
         => ( ( ? [Nat3: nat] :
                  ( Y2
                  = ( extended_enat2 @ Nat3 ) )
             => ( ( Ya
                  = ( extend1396239628finity @ extended_enat ) )
               => ( Yb
                 != ( extend1396239628finity @ extended_enat ) ) ) )
           => ( ( ( Y2
                  = ( extend1396239628finity @ extended_enat ) )
               => ( ? [Nat3: nat] :
                      ( Ya
                      = ( extended_enat2 @ Nat3 ) )
                 => ! [Nata: nat] :
                      ( Yb
                     != ( extended_enat2 @ Nata ) ) ) )
             => ( ( ( Y2
                    = ( extend1396239628finity @ extended_enat ) )
                 => ( ? [Nat3: nat] :
                        ( Ya
                        = ( extended_enat2 @ Nat3 ) )
                   => ( Yb
                     != ( extend1396239628finity @ extended_enat ) ) ) )
               => ( ( ( Y2
                      = ( extend1396239628finity @ extended_enat ) )
                   => ( ( Ya
                        = ( extend1396239628finity @ extended_enat ) )
                     => ! [Nat3: nat] :
                          ( Yb
                         != ( extended_enat2 @ Nat3 ) ) ) )
                 => ~ ( ( Y2
                        = ( extend1396239628finity @ extended_enat ) )
                     => ( ( Ya
                          = ( extend1396239628finity @ extended_enat ) )
                       => ( Yb
                         != ( extend1396239628finity @ extended_enat ) ) ) ) ) ) ) ) ) ) ) )).

% enat3_cases
thf(fact_20_enat2__cases,axiom,(
    ! [Y2: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y2
            = ( extended_enat2 @ Nat3 ) )
       => ! [Nata: nat] :
            ( Ya
           != ( extended_enat2 @ Nata ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y2
              = ( extended_enat2 @ Nat3 ) )
         => ( Ya
           != ( extend1396239628finity @ extended_enat ) ) )
       => ( ( ( Y2
              = ( extend1396239628finity @ extended_enat ) )
           => ! [Nat3: nat] :
                ( Ya
               != ( extended_enat2 @ Nat3 ) ) )
         => ~ ( ( Y2
                = ( extend1396239628finity @ extended_enat ) )
             => ( Ya
               != ( extend1396239628finity @ extended_enat ) ) ) ) ) ) )).

% enat2_cases
thf(fact_21_enat_Odistinct_I1_J,axiom,(
    ! [Nat: nat] :
      ( ( extended_enat2 @ Nat )
     != ( extend1396239628finity @ extended_enat ) ) )).

% enat.distinct(1)
thf(fact_22_enat_Odistinct_I2_J,axiom,(
    ! [Nat4: nat] :
      ( ( extend1396239628finity @ extended_enat )
     != ( extended_enat2 @ Nat4 ) ) )).

% enat.distinct(2)
thf(fact_23_enat__iless,axiom,(
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K: nat] :
          ( N
          = ( extended_enat2 @ K ) ) ) )).

% enat_iless
thf(fact_24_chain__incr,axiom,(
    ! [A: $tType,Y3: ( A > extended_enat ),K2: nat] :
      ( ! [I2: A] :
        ? [J: A] :
          ( ord_less @ extended_enat @ ( Y3 @ I2 ) @ ( Y3 @ J ) )
     => ? [J2: A] :
          ( ord_less @ extended_enat @ ( extended_enat2 @ K2 ) @ ( Y3 @ J2 ) ) ) )).

% chain_incr
thf(fact_25_alw__iff__sdrop,axiom,(
    ! [A: $tType] :
      ( ( linear1386806755on_alw @ A )
      = ( ^ [P3: ( ( stream @ A ) > $o ),Omega2: ( stream @ A )] :
          ! [M2: nat] :
            ( P3 @ ( sdrop @ A @ M2 @ Omega2 ) ) ) ) )).

% alw_iff_sdrop
thf(fact_26_ev__iff__sdrop,axiom,(
    ! [A: $tType] :
      ( ( linear505997466_on_ev @ A )
      = ( ^ [P3: ( ( stream @ A ) > $o ),Omega2: ( stream @ A )] :
          ? [M2: nat] :
            ( P3 @ ( sdrop @ A @ M2 @ Omega2 ) ) ) ) )).

% ev_iff_sdrop
thf(fact_27_alw__sdrop,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),N: nat] :
      ( ( linear1386806755on_alw @ A @ Phi @ Xs2 )
     => ( linear1386806755on_alw @ A @ Phi @ ( sdrop @ A @ N @ Xs2 ) ) ) )).

% alw_sdrop
thf(fact_28_all__imp__alw,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ! [X1: ( stream @ A )] :
          ( Phi @ X1 )
     => ( linear1386806755on_alw @ A @ Phi @ Xs2 ) ) )).

% all_imp_alw
thf(fact_29_alw__mono,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A @ Phi @ Xs2 )
     => ( ! [Xs3: ( stream @ A )] :
            ( ( Phi @ Xs3 )
           => ( Psi @ Xs3 ) )
       => ( linear1386806755on_alw @ A @ Psi @ Xs2 ) ) ) )).

% alw_mono
thf(fact_30_alw__cong,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A ),Q1: ( ( stream @ A ) > $o ),Q2: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A @ P @ Omega )
     => ( ! [Omega3: ( stream @ A )] :
            ( ( P @ Omega3 )
           => ( ( Q1 @ Omega3 )
              = ( Q2 @ Omega3 ) ) )
       => ( ( linear1386806755on_alw @ A @ Q1 @ Omega )
          = ( linear1386806755on_alw @ A @ Q2 @ Omega ) ) ) ) )).

% alw_cong
thf(fact_31_alw__alwD,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( linear1386806755on_alw @ A @ P @ Omega )
     => ( linear1386806755on_alw @ A @ ( linear1386806755on_alw @ A @ P ) @ Omega ) ) )).

% alw_alwD
thf(fact_32_ev__mono,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A @ Phi @ Xs2 )
     => ( ! [Xs3: ( stream @ A )] :
            ( ( Phi @ Xs3 )
           => ( Psi @ Xs3 ) )
       => ( linear505997466_on_ev @ A @ Psi @ Xs2 ) ) ) )).

% ev_mono
thf(fact_33_ev_Obase,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ( Phi @ Xs2 )
     => ( linear505997466_on_ev @ A @ Phi @ Xs2 ) ) )).

% ev.base
thf(fact_34_alwD,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),X: ( stream @ A )] :
      ( ( linear1386806755on_alw @ A @ P @ X )
     => ( P @ X ) ) )).

% alwD
thf(fact_35_enat__less__induct,axiom,(
    ! [P: ( extended_enat > $o ),N: extended_enat] :
      ( ! [N2: extended_enat] :
          ( ! [M3: extended_enat] :
              ( ( ord_less @ extended_enat @ M3 @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% enat_less_induct
thf(fact_36_infinity__ilessE,axiom,(
    ! [M: nat] :
      ~ ( ord_less @ extended_enat @ ( extend1396239628finity @ extended_enat ) @ ( extended_enat2 @ M ) ) )).

% infinity_ilessE
thf(fact_37_less__infinityE,axiom,(
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ N @ ( extend1396239628finity @ extended_enat ) )
     => ~ ( ! [K: nat] :
              ( N
             != ( extended_enat2 @ K ) ) ) ) )).

% less_infinityE
thf(fact_38_enat__ord__code_I4_J,axiom,(
    ! [M: nat] :
      ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extend1396239628finity @ extended_enat ) ) )).

% enat_ord_code(4)
thf(fact_39_alw__ev__sdrop,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),M: nat,Xs2: ( stream @ A )] :
      ( ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ Phi ) @ ( sdrop @ A @ M @ Xs2 ) )
     => ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ Phi ) @ Xs2 ) ) )).

% alw_ev_sdrop
thf(fact_40_alw__False,axiom,(
    ! [A: $tType,Omega: ( stream @ A )] :
      ~ ( linear1386806755on_alw @ A
        @ ^ [X3: ( stream @ A )] : $false
        @ Omega ) )).

% alw_False
thf(fact_41_ev__False,axiom,(
    ! [A: $tType,Omega: ( stream @ A )] :
      ~ ( linear505997466_on_ev @ A
        @ ^ [X3: ( stream @ A )] : $false
        @ Omega ) )).

% ev_False
thf(fact_42_alw__aand,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A
        @ ^ [Xs: ( stream @ A )] :
            ( ( Phi @ Xs )
            & ( Psi @ Xs ) ) )
      = ( ^ [Xs: ( stream @ A )] :
            ( ( linear1386806755on_alw @ A @ Phi @ Xs )
            & ( linear1386806755on_alw @ A @ Psi @ Xs ) ) ) ) )).

% alw_aand
thf(fact_43_alw__mp,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A @ Phi @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( Phi @ Xs )
             => ( Psi @ Xs ) )
          @ Xs2 )
       => ( linear1386806755on_alw @ A @ Psi @ Xs2 ) ) ) )).

% alw_mp
thf(fact_44_ev__or,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A
        @ ^ [Xs: ( stream @ A )] :
            ( ( Phi @ Xs )
            | ( Psi @ Xs ) ) )
      = ( ^ [Xs: ( stream @ A )] :
            ( ( linear505997466_on_ev @ A @ Phi @ Xs )
            | ( linear505997466_on_ev @ A @ Psi @ Xs ) ) ) ) )).

% ev_or
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q3: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q3 @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q3 ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_scount__eq__card,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( linear505997466_on_ev @ A
        @ ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ~ ( P @ Xs ) )
        @ Omega )
     => ( ( coindu1365464361scount @ A @ P @ Omega )
        = ( extended_enat2
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [I: nat] :
                  ( P @ ( sdrop @ A @ I @ Omega ) ) ) ) ) ) ) )).

% scount_eq_card
thf(fact_50_ev__alw__imp__alw__ev,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ( linear505997466_on_ev @ A @ ( linear1386806755on_alw @ A @ Phi ) @ Xs2 )
     => ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ Phi ) @ Xs2 ) ) )).

% ev_alw_imp_alw_ev
thf(fact_51_ev__cong,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A ),Q1: ( ( stream @ A ) > $o ),Q2: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A @ P @ Omega )
     => ( ! [Omega3: ( stream @ A )] :
            ( ( P @ Omega3 )
           => ( ( Q1 @ Omega3 )
              = ( Q2 @ Omega3 ) ) )
       => ( ( linear505997466_on_ev @ A @ Q1 @ Omega )
          = ( linear505997466_on_ev @ A @ Q2 @ Omega ) ) ) ) )).

% ev_cong
thf(fact_52_alw__ev__imp__ev__alw,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ P ) @ Omega )
     => ( linear505997466_on_ev @ A
        @ ^ [Xs: ( stream @ A )] :
            ( ( P @ Xs )
            & ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ P ) @ Xs ) )
        @ Omega ) ) )).

% alw_ev_imp_ev_alw
thf(fact_53_ev__alw__alw__impl,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A @ ( linear1386806755on_alw @ A @ Phi ) @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( linear1386806755on_alw @ A @ Phi @ Xs )
             => ( linear505997466_on_ev @ A @ Psi @ Xs ) )
          @ Xs2 )
       => ( linear505997466_on_ev @ A @ Psi @ Xs2 ) ) ) )).

% ev_alw_alw_impl
thf(fact_54_alw__impl__ev__alw,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Psi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ( linear1386806755on_alw @ A
        @ ^ [Xs: ( stream @ A )] :
            ( ( Phi @ Xs )
           => ( linear505997466_on_ev @ A @ Psi @ Xs ) )
        @ Xs2 )
     => ( linear1386806755on_alw @ A
        @ ^ [Xs: ( stream @ A )] :
            ( ( linear505997466_on_ev @ A @ Phi @ Xs )
           => ( linear505997466_on_ev @ A @ Psi @ Xs ) )
        @ Xs2 ) ) )).

% alw_impl_ev_alw
thf(fact_55_alw__alw__impl__ev,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear1386806755on_alw @ A
        @ ^ [Xs: ( stream @ A )] :
            ( ( linear1386806755on_alw @ A @ Phi @ Xs )
           => ( linear505997466_on_ev @ A @ Psi @ Xs ) ) )
      = ( ^ [Xs: ( stream @ A )] :
            ( ( linear505997466_on_ev @ A @ ( linear1386806755on_alw @ A @ Phi ) @ Xs )
           => ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ Psi ) @ Xs ) ) ) ) )).

% alw_alw_impl_ev
thf(fact_56_ev__alw__impl__ev,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear505997466_on_ev @ A @ Phi @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( Phi @ Xs )
             => ( linear505997466_on_ev @ A @ Psi @ Xs ) )
          @ Xs2 )
       => ( linear505997466_on_ev @ A @ Psi @ Xs2 ) ) ) )).

% ev_alw_impl_ev
thf(fact_57_enat_Osimps_I7_J,axiom,(
    ! [T: $tType,F1: ( nat > T ),F2: T] :
      ( ( extended_rec_enat @ T @ F1 @ F2 @ ( extend1396239628finity @ extended_enat ) )
      = F2 ) )).

% enat.simps(7)
thf(fact_58_enat_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: ( nat > T ),F2: T,Nat: nat] :
      ( ( extended_rec_enat @ T @ F1 @ F2 @ ( extended_enat2 @ Nat ) )
      = ( F1 @ Nat ) ) )).

% enat.simps(6)
thf(fact_59_sdrop__wait,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ( linear505997466_on_ev @ A @ Phi @ Xs2 )
     => ( Phi @ ( sdrop @ A @ ( linear1335279038n_wait @ A @ Phi @ Xs2 ) @ Xs2 ) ) ) )).

% sdrop_wait
thf(fact_60_enat_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: ( nat > T ),F2: T] :
      ( ( extended_case_enat @ T @ F1 @ F2 @ ( extend1396239628finity @ extended_enat ) )
      = F2 ) )).

% enat.simps(5)
thf(fact_61_enat_Osimps_I4_J,axiom,(
    ! [T: $tType,F1: ( nat > T ),F2: T,Nat: nat] :
      ( ( extended_case_enat @ T @ F1 @ F2 @ ( extended_enat2 @ Nat ) )
      = ( F1 @ Nat ) ) )).

% enat.simps(4)
thf(fact_62_infinite__iff__alw__ev,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( ~ ( finite_finite2 @ nat
            @ ( collect @ nat
              @ ^ [M2: nat] :
                  ( P @ ( sdrop @ A @ M2 @ Omega ) ) ) ) )
      = ( linear1386806755on_alw @ A @ ( linear505997466_on_ev @ A @ P ) @ Omega ) ) )).

% infinite_iff_alw_ev
thf(fact_63_ev__alw__not__HLD__finite,axiom,(
    ! [A: $tType,P: ( ( stream @ A ) > $o ),Omega: ( stream @ A )] :
      ( ( linear505997466_on_ev @ A
        @ ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ~ ( P @ Xs ) )
        @ Omega )
     => ( finite_finite2 @ nat
        @ ( collect @ nat
          @ ^ [I: nat] :
              ( P @ ( sdrop @ A @ I @ Omega ) ) ) ) ) )).

% ev_alw_not_HLD_finite
thf(fact_64_ev__alw__imp__nxt,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ( linear505997466_on_ev @ A @ Phi @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( Phi @ Xs )
             => ( linear1494993505on_nxt @ A @ $o @ Phi @ Xs ) )
          @ Xs2 )
       => ( linear505997466_on_ev @ A @ ( linear1386806755on_alw @ A @ Phi ) @ Xs2 ) ) ) )).

% ev_alw_imp_nxt
thf(fact_65_variance,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( Phi @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( Phi @ Xs )
             => ( ( Psi @ Xs )
                | ( linear1494993505on_nxt @ A @ $o @ Phi @ Xs ) ) )
          @ Xs2 )
       => ( ( linear1386806755on_alw @ A @ Phi @ Xs2 )
          | ( linear505997466_on_ev @ A @ Psi @ Xs2 ) ) ) ) )).

% variance
thf(fact_66_ex__gt__or__lt,axiom,(
    ! [A: $tType] :
      ( ( condit1656338222tinuum @ A @ ( type2 @ A ) )
     => ! [A2: A] :
        ? [B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
          | ( ord_less @ A @ B2 @ A2 ) ) ) )).

% ex_gt_or_lt
thf(fact_67_linorder__neqE__linordered__idom,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
         => ( ~ ( ord_less @ A @ X @ Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_68_enat__ord__simps_I2_J,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ M @ N ) ) )).

% enat_ord_simps(2)
thf(fact_69_nxt__mono,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),Psi: ( ( stream @ A ) > $o )] :
      ( ( linear1494993505on_nxt @ A @ $o @ Phi @ Xs2 )
     => ( ! [Xs3: ( stream @ A )] :
            ( ( Phi @ Xs3 )
           => ( Psi @ Xs3 ) )
       => ( linear1494993505on_nxt @ A @ $o @ Psi @ Xs2 ) ) ) )).

% nxt_mono
thf(fact_70_case__enat__def,axiom,(
    ! [T: $tType] :
      ( ( extended_case_enat @ T )
      = ( extended_rec_enat @ T ) ) )).

% case_enat_def
thf(fact_71_less__enat__def,axiom,
    ( ( ord_less @ extended_enat )
    = ( ^ [M2: extended_enat,N3: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [M1: nat] :
              ( extended_case_enat @ $o @ ( ord_less @ nat @ M1 ) @ $true @ N3 )
          @ $false
          @ M2 ) ) )).

% less_enat_def
thf(fact_72_ev__nxt,axiom,(
    ! [A: $tType] :
      ( ( linear505997466_on_ev @ A )
      = ( ^ [Phi2: ( ( stream @ A ) > $o ),Xs: ( stream @ A )] :
            ( ( Phi2 @ Xs )
            | ( linear1494993505on_nxt @ A @ $o @ ( linear505997466_on_ev @ A @ Phi2 ) @ Xs ) ) ) ) )).

% ev_nxt
thf(fact_73_alw__nxt,axiom,(
    ! [A: $tType] :
      ( ( linear1386806755on_alw @ A )
      = ( ^ [Phi2: ( ( stream @ A ) > $o ),Xs: ( stream @ A )] :
            ( ( Phi2 @ Xs )
            & ( linear1494993505on_nxt @ A @ $o @ ( linear1386806755on_alw @ A @ Phi2 ) @ Xs ) ) ) ) )).

% alw_nxt
thf(fact_74_alw__invar,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A )] :
      ( ( Phi @ Xs2 )
     => ( ( linear1386806755on_alw @ A
          @ ^ [Xs: ( stream @ A )] :
              ( ( Phi @ Xs )
             => ( linear1494993505on_nxt @ A @ $o @ Phi @ Xs ) )
          @ Xs2 )
       => ( linear1386806755on_alw @ A @ Phi @ Xs2 ) ) ) )).

% alw_invar
thf(fact_75_less__enatE,axiom,(
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ~ ( ! [K: nat] :
              ( ( N
                = ( extended_enat2 @ K ) )
             => ~ ( ord_less @ nat @ K @ M ) ) ) ) )).

% less_enatE
thf(fact_76_card__Collect__less__nat,axiom,(
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I: nat] :
              ( ord_less @ nat @ I @ N ) ) )
      = N ) )).

% card_Collect_less_nat
thf(fact_77_finite__Collect__less__nat,axiom,(
    ! [K2: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] :
            ( ord_less @ nat @ N3 @ K2 ) ) ) )).

% finite_Collect_less_nat
thf(fact_78_finite__Collect__disjI,axiom,(
    ! [A: $tType,P: ( A > $o ),Q3: ( A > $o )] :
      ( ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( P @ X3 )
              | ( Q3 @ X3 ) ) ) )
      = ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        & ( finite_finite2 @ A @ ( collect @ A @ Q3 ) ) ) ) )).

% finite_Collect_disjI
thf(fact_79_finite__Collect__conjI,axiom,(
    ! [A: $tType,P: ( A > $o ),Q3: ( A > $o )] :
      ( ( ( finite_finite2 @ A @ ( collect @ A @ P ) )
        | ( finite_finite2 @ A @ ( collect @ A @ Q3 ) ) )
     => ( finite_finite2 @ A
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( P @ X3 )
              & ( Q3 @ X3 ) ) ) ) ) )).

% finite_Collect_conjI
thf(fact_80_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A4: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_81_psubset__card__mono,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) )).

% psubset_card_mono
thf(fact_82_finite__M__bounded__by__nat,axiom,(
    ! [P: ( nat > $o ),I3: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I3 ) ) ) ) )).

% finite_M_bounded_by_nat
thf(fact_83_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ A3 )
           => ? [X12: B] :
                ( P @ X4 @ X12 ) )
       => ? [F3: ( A > B )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A3 )
           => ( P @ X5 @ ( F3 @ X5 ) ) ) ) ) )).

% finite_set_choice
thf(fact_84_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ A )] :
          ( finite_finite2 @ A @ A3 ) ) )).

% finite
thf(fact_85_finite__psubset__induct,axiom,(
    ! [A: $tType,A3: ( set @ A ),P: ( ( set @ A ) > $o )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( ! [A5: ( set @ A )] :
            ( ( finite_finite2 @ A @ A5 )
           => ( ! [B4: ( set @ A )] :
                  ( ( ord_less @ ( set @ A ) @ B4 @ A5 )
                 => ( P @ B4 ) )
             => ( P @ A5 ) ) )
       => ( P @ A3 ) ) ) )).

% finite_psubset_induct
thf(fact_86_bounded__nat__set__is__finite,axiom,(
    ! [N4: ( set @ nat ),N: nat] :
      ( ! [X4: nat] :
          ( ( member @ nat @ X4 @ N4 )
         => ( ord_less @ nat @ X4 @ N ) )
     => ( finite_finite2 @ nat @ N4 ) ) )).

% bounded_nat_set_is_finite
thf(fact_87_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite2 @ nat )
    = ( ^ [N5: ( set @ nat )] :
        ? [M2: nat] :
        ! [X3: nat] :
          ( ( member @ nat @ X3 @ N5 )
         => ( ord_less @ nat @ X3 @ M2 ) ) ) )).

% finite_nat_set_iff_bounded
thf(fact_88_not__finite__existsD,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ~ ( finite_finite2 @ A @ ( collect @ A @ P ) )
     => ? [X1: A] :
          ( P @ X1 ) ) )).

% not_finite_existsD
thf(fact_89_pigeonhole__infinite__rel,axiom,(
    ! [B: $tType,A: $tType,A3: ( set @ A ),B3: ( set @ B ),R: ( A > B > $o )] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ( ( finite_finite2 @ B @ B3 )
       => ( ! [X4: A] :
              ( ( member @ A @ X4 @ A3 )
             => ? [Xa: B] :
                  ( ( member @ B @ Xa @ B3 )
                  & ( R @ X4 @ Xa ) ) )
         => ? [X4: B] :
              ( ( member @ B @ X4 @ B3 )
              & ~ ( finite_finite2 @ A
                  @ ( collect @ A
                    @ ^ [A6: A] :
                        ( ( member @ A @ A6 @ A3 )
                        & ( R @ A6 @ X4 ) ) ) ) ) ) ) ) )).

% pigeonhole_infinite_rel
thf(fact_90_unbounded__k__infinite,axiom,(
    ! [K2: nat,S2: ( set @ nat )] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K2 @ M4 )
         => ? [N6: nat] :
              ( ( ord_less @ nat @ M4 @ N6 )
              & ( member @ nat @ N6 @ S2 ) ) )
     => ~ ( finite_finite2 @ nat @ S2 ) ) )).

% unbounded_k_infinite
thf(fact_91_infinite__nat__iff__unbounded,axiom,(
    ! [S2: ( set @ nat )] :
      ( ( ~ ( finite_finite2 @ nat @ S2 ) )
      = ( ! [M2: nat] :
          ? [N3: nat] :
            ( ( ord_less @ nat @ M2 @ N3 )
            & ( member @ nat @ N3 @ S2 ) ) ) ) )).

% infinite_nat_iff_unbounded
thf(fact_92_less__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ord_less @ ( A > $o )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ A4 )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ B5 ) ) ) ) )).

% less_set_def
thf(fact_93_card__psubset,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B3 ) ) ) ) )).

% card_psubset
thf(fact_94_sdrop__wait__least,axiom,(
    ! [A: $tType,Phi: ( ( stream @ A ) > $o ),Xs2: ( stream @ A ),N: nat] :
      ( ( linear505997466_on_ev @ A @ Phi @ Xs2 )
     => ( ( Phi @ ( sdrop @ A @ N @ Xs2 ) )
       => ( ord_less_eq @ nat @ ( linear1335279038n_wait @ A @ Phi @ Xs2 ) @ N ) ) ) )).

% sdrop_wait_least
thf(fact_95_psubset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C )
       => ( ord_less @ ( set @ A ) @ A3 @ C ) ) ) )).

% psubset_trans
thf(fact_96_subset__antisym,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( A3 = B3 ) ) ) )).

% subset_antisym
thf(fact_97_subsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A3 )
         => ( member @ A @ X4 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) )).

% subsetI
thf(fact_98_psubsetI,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( A3 != B3 )
       => ( ord_less @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% psubsetI
thf(fact_99_finite__Collect__subsets,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ A3 )
     => ( finite_finite2 @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B5: ( set @ A )] :
              ( ord_less_eq @ ( set @ A ) @ B5 @ A3 ) ) ) ) )).

% finite_Collect_subsets
thf(fact_100_finite__Collect__le__nat,axiom,(
    ! [K2: nat] :
      ( finite_finite2 @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] :
            ( ord_less_eq @ nat @ N3 @ K2 ) ) ) )).

% finite_Collect_le_nat
thf(fact_101_infinite__nat__iff__unbounded__le,axiom,(
    ! [S2: ( set @ nat )] :
      ( ( ~ ( finite_finite2 @ nat @ S2 ) )
      = ( ! [M2: nat] :
          ? [N3: nat] :
            ( ( ord_less_eq @ nat @ M2 @ N3 )
            & ( member @ nat @ N3 @ S2 ) ) ) ) )).

% infinite_nat_iff_unbounded_le
thf(fact_102_subset__iff__psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less @ ( set @ A ) @ A4 @ B5 )
            | ( A4 = B5 ) ) ) ) )).

% subset_iff_psubset_eq
thf(fact_103_subset__psubset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C )
       => ( ord_less @ ( set @ A ) @ A3 @ C ) ) ) )).

% subset_psubset_trans
thf(fact_104_subset__not__subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B5 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B5 @ A4 ) ) ) ) )).

% subset_not_subset_eq
thf(fact_105_psubset__subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C )
       => ( ord_less @ ( set @ A ) @ A3 @ C ) ) ) )).

% psubset_subset_trans
thf(fact_106_psubset__imp__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) )).

% psubset_imp_subset
thf(fact_107_psubset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B5 )
            & ( A4 != B5 ) ) ) ) )).

% psubset_eq
thf(fact_108_psubsetE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) )).

% psubsetE
thf(fact_109_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q3: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q3 ) )
      = ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q3 @ X3 ) ) ) ) )).

% Collect_mono_iff
thf(fact_110_contra__subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ~ ( member @ A @ C2 @ B3 )
       => ~ ( member @ A @ C2 @ A3 ) ) ) )).

% contra_subsetD
thf(fact_111_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y4: ( set @ A ),Z: ( set @ A )] : ( Y4 = Z ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A4 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A4 ) ) ) ) )).

% set_eq_subset
thf(fact_112_subset__trans,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C ) ) ) )).

% subset_trans
thf(fact_113_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q3: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
         => ( Q3 @ X4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q3 ) ) ) )).

% Collect_mono
thf(fact_114_subset__refl,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) )).

% subset_refl
thf(fact_115_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% rev_subsetD
thf(fact_116_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
          ! [T2: A] :
            ( ( member @ A @ T2 @ A4 )
           => ( member @ A @ T2 @ B5 ) ) ) ) )).

% subset_iff
thf(fact_117_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ X @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( member @ A @ X @ B3 ) ) ) )).

% set_rev_mp
thf(fact_118_equalityD2,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) )).

% equalityD2
thf(fact_119_equalityD1,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) )).

% equalityD1
thf(fact_120_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( member @ A @ X3 @ B5 ) ) ) ) )).

% subset_eq
thf(fact_121_equalityE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( A3 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) )).

% equalityE
thf(fact_122_subsetCE,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetCE
thf(fact_123_subsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetD
thf(fact_124_in__mono,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B3 ) ) ) )).

% in_mono
thf(fact_125_set__mp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ X @ A3 )
       => ( member @ A @ X @ B3 ) ) ) )).

% set_mp
thf(fact_126_card__seteq,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B3 ) @ ( finite_card @ A @ A3 ) )
         => ( A3 = B3 ) ) ) ) )).

% card_seteq
thf(fact_127_card__mono,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) )).

% card_mono
thf(fact_128_complete__interval,axiom,(
    ! [A: $tType] :
      ( ( condit1037483654norder @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,P: ( A > $o )] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B6 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B6 )
                  & ! [X5: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X5 )
                        & ( ord_less @ A @ X5 @ C3 ) )
                     => ( P @ X5 ) )
                  & ! [D: A] :
                      ( ! [X4: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X4 )
                            & ( ord_less @ A @ X4 @ D ) )
                         => ( P @ X4 ) )
                     => ( ord_less_eq @ A @ D @ C3 ) ) ) ) ) ) ) )).

% complete_interval
thf(fact_129_finite__subset,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( finite_finite2 @ A @ B3 )
       => ( finite_finite2 @ A @ A3 ) ) ) )).

% finite_subset
thf(fact_130_infinite__super,axiom,(
    ! [A: $tType,S2: ( set @ A ),T3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S2 @ T3 )
     => ( ~ ( finite_finite2 @ A @ S2 )
       => ~ ( finite_finite2 @ A @ T3 ) ) ) )).

% infinite_super
thf(fact_131_rev__finite__subset,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( finite_finite2 @ A @ A3 ) ) ) )).

% rev_finite_subset
thf(fact_132_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite2 @ nat )
    = ( ^ [N5: ( set @ nat )] :
        ? [M2: nat] :
        ! [X3: nat] :
          ( ( member @ nat @ X3 @ N5 )
         => ( ord_less_eq @ nat @ X3 @ M2 ) ) ) )).

% finite_nat_set_iff_bounded_le
thf(fact_133_finite__less__ub,axiom,(
    ! [F: ( nat > nat ),U: nat] :
      ( ! [N2: nat] :
          ( ord_less_eq @ nat @ N2 @ ( F @ N2 ) )
     => ( finite_finite2 @ nat
        @ ( collect @ nat
          @ ^ [N3: nat] :
              ( ord_less_eq @ nat @ ( F @ N3 ) @ U ) ) ) ) )).

% finite_less_ub
thf(fact_134_card__subset__eq,axiom,(
    ! [A: $tType,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( finite_finite2 @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ( finite_card @ A @ A3 )
            = ( finite_card @ A @ B3 ) )
         => ( A3 = B3 ) ) ) ) )).

% card_subset_eq
thf(fact_135_infinite__arbitrarily__large,axiom,(
    ! [A: $tType,A3: ( set @ A ),N: nat] :
      ( ~ ( finite_finite2 @ A @ A3 )
     => ? [B7: ( set @ A )] :
          ( ( finite_finite2 @ A @ B7 )
          & ( ( finite_card @ A @ B7 )
            = N )
          & ( ord_less_eq @ ( set @ A ) @ B7 @ A3 ) ) ) )).

% infinite_arbitrarily_large
thf(fact_136_psubsetD,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% psubsetD
thf(fact_137_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_138_ex__has__greatest__nat,axiom,(
    ! [A: $tType,P: ( A > $o ),K2: A,M: ( A > nat ),B6: nat] :
      ( ( P @ K2 )
     => ( ! [Y5: A] :
            ( ( P @ Y5 )
           => ( ord_less @ nat @ ( M @ Y5 ) @ B6 ) )
       => ? [X4: A] :
            ( ( P @ X4 )
            & ! [Y6: A] :
                ( ( P @ Y6 )
               => ( ord_less_eq @ nat @ ( M @ Y6 ) @ ( M @ X4 ) ) ) ) ) ) )).

% ex_has_greatest_nat
thf(fact_139_less__mono__imp__le__mono,axiom,(
    ! [F: ( nat > nat ),I3: nat,J3: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less @ nat @ I2 @ J2 )
         => ( ord_less @ nat @ ( F @ I2 ) @ ( F @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I3 @ J3 )
       => ( ord_less_eq @ nat @ ( F @ I3 ) @ ( F @ J3 ) ) ) ) )).

% less_mono_imp_le_mono
thf(fact_140_le__neq__implies__less,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) )).

% le_neq_implies_less
thf(fact_141_less__or__eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) )).

% less_or_eq_imp_le
thf(fact_142_enat__ord__simps_I5_J,axiom,(
    ! [Q: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extend1396239628finity @ extended_enat ) @ Q )
      = ( Q
        = ( extend1396239628finity @ extended_enat ) ) ) )).

% enat_ord_simps(5)
thf(fact_143_enat__ord__code_I3_J,axiom,(
    ! [Q: extended_enat] :
      ( ord_less_eq @ extended_enat @ Q @ ( extend1396239628finity @ extended_enat ) ) )).

% enat_ord_code(3)
thf(fact_144_enat__ord__simps_I1_J,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) )).

% enat_ord_simps(1)
thf(fact_145_less__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G2: ( A > B )] :
              ( ( ord_less_eq @ ( A > B ) @ F4 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F4 ) ) ) ) ) )).

% less_fun_def
thf(fact_146_finite__enat__bounded,axiom,(
    ! [A3: ( set @ extended_enat ),N: nat] :
      ( ! [Y5: extended_enat] :
          ( ( member @ extended_enat @ Y5 @ A3 )
         => ( ord_less_eq @ extended_enat @ Y5 @ ( extended_enat2 @ N ) ) )
     => ( finite_finite2 @ extended_enat @ A3 ) ) )).

% finite_enat_bounded
thf(fact_147_enat__ile,axiom,(
    ! [N: extended_enat,M: nat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K: nat] :
          ( N
          = ( extended_enat2 @ K ) ) ) )).

% enat_ile
thf(fact_148_enat__ord__simps_I3_J,axiom,(
    ! [Q: extended_enat] :
      ( ord_less_eq @ extended_enat @ Q @ ( extend1396239628finity @ extended_enat ) ) )).

% enat_ord_simps(3)
thf(fact_149_less__eq__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ A4 )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ B5 ) ) ) ) )).

% less_eq_set_def
thf(fact_150_infinity__ileE,axiom,(
    ! [M: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend1396239628finity @ extended_enat ) @ ( extended_enat2 @ M ) ) )).

% infinity_ileE
thf(fact_151_enat__ord__code_I5_J,axiom,(
    ! [N: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend1396239628finity @ extended_enat ) @ ( extended_enat2 @ N ) ) )).

% enat_ord_code(5)
thf(fact_152_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funD
thf(fact_153_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funE
thf(fact_154_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X4: A] :
              ( ord_less_eq @ B @ ( F @ X4 ) @ ( G @ X4 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_155_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G2: ( A > B )] :
            ! [X3: A] :
              ( ord_less_eq @ B @ ( F4 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) )).

% le_fun_def
thf(fact_156_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B6: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B6 ) )
         => ( ( ord_less_eq @ B @ B6 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_157_order__subst2,axiom,(
    ! [A: $tType,C4: $tType] :
      ( ( ( order @ C4 @ ( type2 @ C4 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B6: A,F: ( A > C4 ),C2: C4] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( ord_less_eq @ C4 @ ( F @ B6 ) @ C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y5 )
                 => ( ord_less_eq @ C4 @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ C4 @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_158_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B6: B,C2: B] :
          ( ( A2
            = ( F @ B6 ) )
         => ( ( ord_less_eq @ B @ B6 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_159_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B6: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( ( F @ B6 )
              = C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y5 )
                 => ( ord_less_eq @ B @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ B @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_160_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y4: A,Z: A] : ( Y4 = Z ) )
        = ( ^ [X3: A,Y: A] :
              ( ( ord_less_eq @ A @ X3 @ Y )
              & ( ord_less_eq @ A @ Y @ X3 ) ) ) ) ) )).

% eq_iff
thf(fact_161_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X )
           => ( X = Y2 ) ) ) ) )).

% antisym
thf(fact_162_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% linear
thf(fact_163_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X = Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) )).

% eq_refl
thf(fact_164_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% le_cases
thf(fact_165_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( ord_less_eq @ A @ B6 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% order.trans
thf(fact_166_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z2 ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X )
             => ~ ( ord_less_eq @ A @ X @ Z2 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z2 )
               => ~ ( ord_less_eq @ A @ Z2 @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z2 @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z2 )
                   => ~ ( ord_less_eq @ A @ Z2 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z2 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_167_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv
thf(fact_168_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( A2 = B6 )
         => ( ( ord_less_eq @ A @ B6 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_169_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( B6 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_170_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( ord_less_eq @ A @ B6 @ A2 )
           => ( A2 = B6 ) ) ) ) )).

% order_class.order.antisym
thf(fact_171_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z2 )
           => ( ord_less_eq @ A @ X @ Z2 ) ) ) ) )).

% order_trans
thf(fact_172_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_173_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B6: A] :
          ( ! [A7: A,B2: A] :
              ( ( ord_less_eq @ A @ A7 @ B2 )
             => ( P @ A7 @ B2 ) )
         => ( ! [A7: A,B2: A] :
                ( ( P @ B2 @ A7 )
               => ( P @ A7 @ B2 ) )
           => ( P @ A2 @ B6 ) ) ) ) )).

% linorder_wlog
thf(fact_174_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B6 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B6 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_175_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A] :
          ( ( ord_less_eq @ A @ B6 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B6 )
           => ( A2 = B6 ) ) ) ) )).

% dual_order.antisym
thf(fact_176_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A] :
          ( ( ord_less @ A @ B6 @ A2 )
         => ( A2 != B6 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_177_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( A2 != B6 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_178_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X )
            | ( X = Y2 ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_179_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B6 @ A2 )
         => ( ( ord_less @ A @ C2 @ B6 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_180_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_imp_not_less
thf(fact_181_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( ord_less @ A @ B6 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% order.strict_trans
thf(fact_182_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) )).

% dual_order.irrefl
thf(fact_183_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( X != Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% linorder_cases
thf(fact_184_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,P: $o] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X )
           => P ) ) ) )).

% less_imp_triv
thf(fact_185_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( Y2 != X ) ) ) )).

% less_imp_not_eq2
thf(fact_186_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less @ A @ Y2 @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv3
thf(fact_187_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),A2: A] :
          ( ! [X4: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ A @ Y6 @ X4 )
                 => ( P @ Y6 ) )
             => ( P @ X4 ) )
         => ( P @ A2 ) ) ) )).

% less_induct
thf(fact_188_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_not_sym
thf(fact_189_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( X != Y2 ) ) ) )).

% less_imp_not_eq
thf(fact_190_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A] :
          ( ( ord_less @ A @ B6 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B6 ) ) ) )).

% dual_order.asym
thf(fact_191_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( B6 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% ord_less_eq_trans
thf(fact_192_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( A2 = B6 )
         => ( ( ord_less @ A @ B6 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_less_trans
thf(fact_193_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) )).

% less_irrefl
thf(fact_194_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
          | ( X = Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_linear
thf(fact_195_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) )).

% less_trans
thf(fact_196_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ~ ( ord_less @ A @ B6 @ A2 ) ) ) )).

% less_asym'
thf(fact_197_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_asym
thf(fact_198_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( X != Y2 ) ) ) )).

% less_imp_neq
thf(fact_199_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X @ Z3 )
              & ( ord_less @ A @ Z3 @ Y2 ) ) ) ) )).

% dense
thf(fact_200_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ~ ( ord_less @ A @ B6 @ A2 ) ) ) )).

% order.asym
thf(fact_201_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
          = ( ( ord_less @ A @ X @ Y2 )
            | ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% neq_iff
thf(fact_202_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
         => ( ~ ( ord_less @ A @ X @ Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% neqE
thf(fact_203_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X1: A] :
          ( ord_less @ A @ X @ X1 ) ) )).

% gt_ex
thf(fact_204_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y5: A] :
          ( ord_less @ A @ Y5 @ X ) ) )).

% lt_ex
thf(fact_205_order__less__subst2,axiom,(
    ! [A: $tType,C4: $tType] :
      ( ( ( order @ C4 @ ( type2 @ C4 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B6: A,F: ( A > C4 ),C2: C4] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( ord_less @ C4 @ ( F @ B6 ) @ C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less @ A @ X4 @ Y5 )
                 => ( ord_less @ C4 @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ C4 @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_less_subst2
thf(fact_206_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B6: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F @ B6 ) )
         => ( ( ord_less @ B @ B6 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less @ B @ X4 @ Y5 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_207_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B6: A,F: ( A > B ),C2: B] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( ( F @ B6 )
              = C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less @ A @ X4 @ Y5 )
                 => ( ord_less @ B @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ B @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_208_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B6: B,C2: B] :
          ( ( A2
            = ( F @ B6 ) )
         => ( ( ord_less @ B @ B6 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less @ B @ X4 @ Y5 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_209_less__eq__enat__def,axiom,
    ( ( ord_less_eq @ extended_enat )
    = ( ^ [M2: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [N1: nat] :
              ( extended_case_enat @ $o
              @ ^ [M1: nat] :
                  ( ord_less_eq @ nat @ M1 @ N1 )
              @ $false
              @ M2 )
          @ $true ) ) )).

% less_eq_enat_def
thf(fact_210_infinite__descent__measure,axiom,(
    ! [A: $tType,P: ( A > $o ),V: ( A > nat ),X: A] :
      ( ! [X4: A] :
          ( ~ ( P @ X4 )
         => ? [Y6: A] :
              ( ( ord_less @ nat @ ( V @ Y6 ) @ ( V @ X4 ) )
              & ~ ( P @ Y6 ) ) )
     => ( P @ X ) ) )).

% infinite_descent_measure
thf(fact_211_measure__induct__rule,axiom,(
    ! [A: $tType,F: ( A > nat ),P: ( A > $o ),A2: A] :
      ( ! [X4: A] :
          ( ! [Y6: A] :
              ( ( ord_less @ nat @ ( F @ Y6 ) @ ( F @ X4 ) )
             => ( P @ Y6 ) )
         => ( P @ X4 ) )
     => ( P @ A2 ) ) )).

% measure_induct_rule
thf(fact_212_linorder__neqE__nat,axiom,(
    ! [X: nat,Y2: nat] :
      ( ( X != Y2 )
     => ( ~ ( ord_less @ nat @ X @ Y2 )
       => ( ord_less @ nat @ Y2 @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_213_infinite__descent,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N2 )
              & ~ ( P @ M3 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_214_nat__less__induct,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ! [N2: nat] :
          ( ! [M3: nat] :
              ( ( ord_less @ nat @ M3 @ N2 )
             => ( P @ M3 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_215_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_216_measure__induct,axiom,(
    ! [A: $tType,F: ( A > nat ),P: ( A > $o ),A2: A] :
      ( ! [X4: A] :
          ( ! [Y6: A] :
              ( ( ord_less @ nat @ ( F @ Y6 ) @ ( F @ X4 ) )
             => ( P @ Y6 ) )
         => ( P @ X4 ) )
     => ( P @ A2 ) ) )).

% measure_induct
thf(fact_217_less__not__refl3,axiom,(
    ! [S3: nat,T4: nat] :
      ( ( ord_less @ nat @ S3 @ T4 )
     => ( S3 != T4 ) ) )).

% less_not_refl3
thf(fact_218_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_219_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) )).

% less_not_refl
thf(fact_220_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_221_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq @ nat @ N @ N ) )).

% le_refl
thf(fact_222_le__trans,axiom,(
    ! [I3: nat,J3: nat,K2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J3 )
     => ( ( ord_less_eq @ nat @ J3 @ K2 )
       => ( ord_less_eq @ nat @ I3 @ K2 ) ) ) )).

% le_trans
thf(fact_223_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_224_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_225_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_226_ex__has__least__nat,axiom,(
    ! [A: $tType,P: ( A > $o ),K2: A,M: ( A > nat )] :
      ( ( P @ K2 )
     => ? [X4: A] :
          ( ( P @ X4 )
          & ! [Y6: A] :
              ( ( P @ Y6 )
             => ( ord_less_eq @ nat @ ( M @ X4 ) @ ( M @ Y6 ) ) ) ) ) )).

% ex_has_least_nat
thf(fact_227_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( A2 != B6 )
         => ( ( ord_less_eq @ A @ A2 @ B6 )
           => ( ord_less @ A @ A2 @ B6 ) ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_228_dual__order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A] :
          ( ( ord_less @ A @ B6 @ A2 )
         => ( ord_less_eq @ A @ B6 @ A2 ) ) ) )).

% dual_order.strict_implies_order
thf(fact_229_dual__order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B8: A,A6: A] :
              ( ( ord_less_eq @ A @ B8 @ A6 )
              & ( A6 != B8 ) ) ) ) ) )).

% dual_order.strict_iff_order
thf(fact_230_dual__order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B8: A,A6: A] :
              ( ( ord_less @ A @ B8 @ A6 )
              | ( A6 = B8 ) ) ) ) ) )).

% dual_order.order_iff_strict
thf(fact_231_order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ord_less_eq @ A @ A2 @ B6 ) ) ) )).

% order.strict_implies_order
thf(fact_232_dense__le__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y2 )
                 => ( ord_less_eq @ A @ W @ Z2 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) )).

% dense_le_bounded
thf(fact_233_dense__ge__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z2: A,X: A,Y2: A] :
          ( ( ord_less @ A @ Z2 @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z2 @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y2 @ W ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) ) )).

% dense_ge_bounded
thf(fact_234_dual__order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B6 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B6 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.strict_trans2
thf(fact_235_dual__order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B6: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B6 @ A2 )
         => ( ( ord_less @ A @ C2 @ B6 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.strict_trans1
thf(fact_236_order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [A6: A,B8: A] :
              ( ( ord_less_eq @ A @ A6 @ B8 )
              & ( A6 != B8 ) ) ) ) ) )).

% order.strict_iff_order
thf(fact_237_order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A6: A,B8: A] :
              ( ( ord_less @ A @ A6 @ B8 )
              | ( A6 = B8 ) ) ) ) ) )).

% order.order_iff_strict
thf(fact_238_order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( ord_less_eq @ A @ B6 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% order.strict_trans2
thf(fact_239_order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( ord_less @ A @ B6 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% order.strict_trans1
thf(fact_240_not__le__imp__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X )
         => ( ord_less @ A @ X @ Y2 ) ) ) )).

% not_le_imp_less
thf(fact_241_less__le__not__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X3: A,Y: A] :
              ( ( ord_less_eq @ A @ X3 @ Y )
              & ~ ( ord_less_eq @ A @ Y @ X3 ) ) ) ) ) )).

% less_le_not_le
thf(fact_242_le__imp__less__or__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ X @ Y2 )
            | ( X = Y2 ) ) ) ) )).

% le_imp_less_or_eq
thf(fact_243_le__less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) )).

% le_less_linear
thf(fact_244_dense__le,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,Z2: A] :
          ( ! [X4: A] :
              ( ( ord_less @ A @ X4 @ Y2 )
             => ( ord_less_eq @ A @ X4 @ Z2 ) )
         => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) )).

% dense_le
thf(fact_245_dense__ge,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z2: A,Y2: A] :
          ( ! [X4: A] :
              ( ( ord_less @ A @ Z2 @ X4 )
             => ( ord_less_eq @ A @ Y2 @ X4 ) )
         => ( ord_less_eq @ A @ Y2 @ Z2 ) ) ) )).

% dense_ge
thf(fact_246_less__le__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) )).

% less_le_trans
thf(fact_247_le__less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X @ Z2 ) ) ) ) )).

% le_less_trans
thf(fact_248_antisym__conv2,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv2
thf(fact_249_antisym__conv1,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv1
thf(fact_250_less__imp__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) )).

% less_imp_le
thf(fact_251_le__neq__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B6: A] :
          ( ( ord_less_eq @ A @ A2 @ B6 )
         => ( ( A2 != B6 )
           => ( ord_less @ A @ A2 @ B6 ) ) ) ) )).

% le_neq_trans
thf(fact_252_not__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% not_less
thf(fact_253_not__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X ) ) ) )).

% not_le
thf(fact_254_order__less__le__subst2,axiom,(
    ! [A: $tType,C4: $tType] :
      ( ( ( order @ C4 @ ( type2 @ C4 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B6: A,F: ( A > C4 ),C2: C4] :
          ( ( ord_less @ A @ A2 @ B6 )
         => ( ( ord_less_eq @ C4 @ ( F @ B6 ) @ C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less @ A @ X4 @ Y5 )
                 => ( ord_less @ C4 @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ C4 @ ( F @ A2 ) @ C2 ) ) ) ) ) )).

% order_less_le_subst2
thf(fact_255_order__less__le__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B6: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F @ B6 ) )
         => ( ( ord_less_eq @ B @ B6 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C2 ) ) ) ) ) ) )).

% order_less_le_subst1

%----Type constructors (26)
thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    ( condit1037483654norder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_1,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Ono__top,axiom,
    ( no_top @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_2,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_3,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_4,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_5,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_6,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_7,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_8,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_9,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_10,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_11,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_12,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_13,axiom,
    ( condit1037483654norder @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_14,axiom,
    ( wellorder @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_15,axiom,
    ( preorder @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_16,axiom,
    ( linorder @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_17,axiom,
    ( order @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_18,axiom,
    ( ord @ extended_enat @ ( type2 @ extended_enat ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,
    ( linear505997466_on_ev @ a
    @ ( linear1386806755on_alw @ a
      @ ^ [Xs: ( stream @ a )] :
          ~ ( p @ Xs ) )
    @ omega )).

thf(conj_1,conjecture,
    ( ord_less @ extended_enat @ ( coindu1365464361scount @ a @ p @ omega ) @ ( extend1396239628finity @ extended_enat ) )).

%------------------------------------------------------------------------------
