%------------------------------------------------------------------------------
% File     : DAT154^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Hamming stream 35
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : hamming_stream__35.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  322 (   0 unit;  59 type;   0 defn)
%            Number of atoms       : 4372 ( 384 equality;2571 variable)
%            Maximal formula depth :   23 (  10 average)
%            Number of connectives : 4035 ( 152   ~;  33   |;  76   &;3501   @)
%                                         (   0 <=>; 273  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  307 ( 307   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   61 (  59   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1107 (   0 sgn; 938   !;  65   ?;  48   ^)
%                                         (1107   :;  56  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:40:50.764
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (54)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__inf,type,(
    semilattice_inf: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,(
    bNF_Greatest_Shift: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,(
    bNF_Greatest_Succ: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oshift,type,(
    bNF_Greatest_shift: 
      !>[A: $tType,B: $tType] :
        ( ( ( list @ A ) > B ) > A > ( list @ A ) > B ) )).

thf(sy_c_Coinductive__List_Olist__of__aux,type,(
    coindu1384447384of_aux: 
      !>[A: $tType] :
        ( ( list @ A ) > ( coinductive_llist @ A ) > ( list @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Oord_Olsorted,type,(
    coinductive_lsorted: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Hamming__Stream__Mirabelle__rwekfkwckg_Oord_Olmerge,type,(
    hammin1328233080lmerge: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Hamming__Stream__Mirabelle__rwekfkwckg_Oord__class_Olmerge,type,(
    hammin1138290136lmerge: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Obutlast,type,(
    butlast: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olast,type,(
    last: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Ohd,type,(
    hd: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_Omap,type,(
    map: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Omap__tailrec,type,(
    map_tailrec: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omap__tailrec__rev,type,(
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Oord_Olexordp,type,(
    lexordp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Orev,type,(
    rev: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_Orderings_Oord_Omax,type,(
    max: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > A ) )).

thf(sy_c_Orderings_Oord_Omin,type,(
    min: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > A ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeast,type,(
    set_atLeast: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeastAtMost,type,(
    set_atLeastAtMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeastLessThan,type,(
    set_atLeastLessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatMost,type,(
    set_atMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,(
    set_gr323396891AtMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,(
    set_gr1161524159ssThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Sublist_Oprefixes,type,(
    prefixes: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_Sublist_Oprefixes__rel,type,(
    prefixes_rel: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_Sublist_Ostrict__suffix,type,(
    strict_suffix: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_less__eq,type,(
    less_eq: a > a > $o )).

thf(sy_v_xs,type,(
    xs: ( coinductive_llist @ a ) )).

thf(sy_v_ys,type,(
    ys: ( coinductive_llist @ a ) )).

%----Relevant facts (253)
thf(fact_0_lmerge_Oexhaust,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( ( coinductive_lnull @ a @ Xs )
          | ( coinductive_lnull @ a @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ a @ Xs )
         => ( coinductive_lnull @ a @ Ys ) ) ) )).

% lmerge.exhaust
thf(fact_1_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_2_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_3_lmerge_Odisc_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% lmerge.disc(2)
thf(fact_4_lmerge_Odisc_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) )
     => ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) )).

% lmerge.disc(1)
thf(fact_5_lmerge_Osimps_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ a @ Xs )
        & ~ ( coinductive_lnull @ a @ Ys ) ) ) )).

% lmerge.simps(2)
thf(fact_6_lmerge_Osimps_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) ) ) )).

% lmerge.simps(1)
thf(fact_7_ord_Olmerge_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lmerge.disc(2)
thf(fact_8_ord_Olmerge_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) )
     => ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) )).

% ord.lmerge.disc(1)
thf(fact_9_ord_Olmerge_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.disc_iff(2)
thf(fact_10_ord_Olmerge_Odisc__iff_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.disc_iff(1)
thf(fact_11_ord_Olmerge_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ A @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.exhaust
thf(fact_12_ord__class_Olmerge_Oexhaust,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ~ ( ( coinductive_lnull @ A @ Xs )
              | ( coinductive_lnull @ A @ Ys ) )
         => ~ ( ~ ( coinductive_lnull @ A @ Xs )
             => ( coinductive_lnull @ A @ Ys ) ) ) ) )).

% ord_class.lmerge.exhaust
thf(fact_13_lmerge_Octr_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) )
     => ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
        = ( coinductive_LNil @ a ) ) ) )).

% lmerge.ctr(1)
thf(fact_14_local_Olexordp__eq__refl,axiom,(
    ! [Xs: ( list @ a )] :
      ( lexordp_eq @ a @ less @ Xs @ Xs ) )).

% local.lexordp_eq_refl
thf(fact_15_local_OgreaterThanLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr1161524159ssThan @ a @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.greaterThanLessThan_iff
thf(fact_16_local_Olexordp__irreflexive,axiom,(
    ! [Xs: ( list @ a )] :
      ( ! [X: a] :
          ~ ( less @ X @ X )
     => ~ ( lexordp @ a @ less @ Xs @ Xs ) ) )).

% local.lexordp_irreflexive
thf(fact_17_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_18_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_19_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_20_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_21_ord_Olmerge_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) )
     => ( ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys )
        = ( coinductive_LNil @ A ) ) ) )).

% ord.lmerge.ctr(1)
thf(fact_22_ord__class_Olmerge_Odisc_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ~ ( coinductive_lnull @ A @ Xs )
         => ( ~ ( coinductive_lnull @ A @ Ys )
           => ~ ( coinductive_lnull @ A @ ( hammin1138290136lmerge @ A @ Xs @ Ys ) ) ) ) ) )).

% ord_class.lmerge.disc(2)
thf(fact_23_local_Olexordp__into__lexordp__eq,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( lexordp_eq @ a @ less @ Xs @ Ys ) ) )).

% local.lexordp_into_lexordp_eq
thf(fact_24_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist: ( coinductive_llist @ A )] :
            ( Llist
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_25_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist2 )
     => ( Llist2
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_26_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A )] :
      ( ( Llist2
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist2 ) ) )).

% llist.discI(1)
thf(fact_27_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_28_ord__class_Olmerge_Octr_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( ( coinductive_lnull @ A @ Xs )
            | ( coinductive_lnull @ A @ Ys ) )
         => ( ( hammin1138290136lmerge @ A @ Xs @ Ys )
            = ( coinductive_LNil @ A ) ) ) ) )).

% ord_class.lmerge.ctr(1)
thf(fact_29_ord__class_Olmerge_Odisc__iff_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( coinductive_lnull @ A @ ( hammin1138290136lmerge @ A @ Xs @ Ys ) )
          = ( ( coinductive_lnull @ A @ Xs )
            | ( coinductive_lnull @ A @ Ys ) ) ) ) )).

% ord_class.lmerge.disc_iff(1)
thf(fact_30_ord__class_Olmerge_Odisc__iff_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( ~ ( coinductive_lnull @ A @ ( hammin1138290136lmerge @ A @ Xs @ Ys ) ) )
          = ( ~ ( coinductive_lnull @ A @ Xs )
            & ~ ( coinductive_lnull @ A @ Ys ) ) ) ) )).

% ord_class.lmerge.disc_iff(2)
thf(fact_31_ord__class_Olmerge_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( ( coinductive_lnull @ A @ Xs )
            | ( coinductive_lnull @ A @ Ys ) )
         => ( coinductive_lnull @ A @ ( hammin1138290136lmerge @ A @ Xs @ Ys ) ) ) ) )).

% ord_class.lmerge.disc(1)
thf(fact_32_local_OgreaterThanLessThan__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ A2 ) @ ( set_lessThan @ a @ less @ B2 ) ) ) )).

% local.greaterThanLessThan_eq
thf(fact_33_local_OgreaterThanLessThan__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ L ) @ ( set_lessThan @ a @ less @ U ) ) ) )).

% local.greaterThanLessThan_def
thf(fact_34_local_Olexordp__eq_ONil,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq.Nil
thf(fact_35_local_Olexordp__eq_OCons__eq,axiom,(
    ! [X2: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X2 @ Y )
     => ( ~ ( less @ Y @ X2 )
       => ( ( lexordp_eq @ a @ less @ Xs @ Ys )
         => ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) ) ) )).

% local.lexordp_eq.Cons_eq
thf(fact_36_local_Olexordp__eq_OCons,axiom,(
    ! [X2: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X2 @ Y )
     => ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) )).

% local.lexordp_eq.Cons
thf(fact_37_ord_Olexordp__into__lexordp__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less @ Xs @ Ys )
     => ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) )).

% ord.lexordp_into_lexordp_eq
thf(fact_38_local_Olexordp_OCons__eq,axiom,(
    ! [X2: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X2 @ Y )
     => ( ~ ( less @ Y @ X2 )
       => ( ( lexordp @ a @ less @ Xs @ Ys )
         => ( lexordp @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) ) ) )).

% local.lexordp.Cons_eq
thf(fact_39_local_Olexordp_OCons,axiom,(
    ! [X2: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X2 @ Y )
     => ( lexordp @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) )).

% local.lexordp.Cons
thf(fact_40_local_Olexordp__append__leftI,axiom,(
    ! [Us: ( list @ a ),Vs: ( list @ a ),Xs: ( list @ a )] :
      ( ( lexordp @ a @ less @ Us @ Vs )
     => ( lexordp @ a @ less @ ( append @ a @ Xs @ Us ) @ ( append @ a @ Xs @ Vs ) ) ) )).

% local.lexordp_append_leftI
thf(fact_41_local_Olexordp__append__leftD,axiom,(
    ! [Xs: ( list @ a ),Us: ( list @ a ),Vs: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( append @ a @ Xs @ Us ) @ ( append @ a @ Xs @ Vs ) )
     => ( ! [A3: a] :
            ~ ( less @ A3 @ A3 )
       => ( lexordp @ a @ less @ Us @ Vs ) ) ) )).

% local.lexordp_append_leftD
thf(fact_42_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_43_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_46_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X: A] :
          ( ( F @ X )
          = ( G @ X ) )
     => ( F = G ) ) )).

% ext
thf(fact_47_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_48_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_49_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_50_local_Olexordp_ONil,axiom,(
    ! [Y: a,Ys: ( list @ a )] :
      ( lexordp @ a @ less @ ( nil @ a ) @ ( cons @ a @ Y @ Ys ) ) )).

% local.lexordp.Nil
thf(fact_51_local_Olexordp_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Y2: a,Ys2: ( list @ a )] :
              ( A22
             != ( cons @ a @ Y2 @ Ys2 ) ) )
       => ( ! [X: a] :
              ( ? [Xs2: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X @ Xs2 ) )
             => ! [Y2: a] :
                  ( ? [Ys2: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y2 @ Ys2 ) )
                 => ~ ( less @ X @ Y2 ) ) )
         => ~ ( ! [X: a,Y2: a,Xs2: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X @ Xs2 ) )
                 => ! [Ys2: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y2 @ Ys2 ) )
                     => ( ~ ( less @ X @ Y2 )
                       => ( ~ ( less @ Y2 @ X )
                         => ~ ( lexordp @ a @ less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% local.lexordp.cases
thf(fact_52_local_Olexordp_Oinducts,axiom,(
    ! [X1: ( list @ a ),X23: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp @ a @ less @ X1 @ X23 )
     => ( ! [Y2: a,Ys2: ( list @ a )] :
            ( P @ ( nil @ a ) @ ( cons @ a @ Y2 @ Ys2 ) )
       => ( ! [X: a,Y2: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
              ( ( less @ X @ Y2 )
             => ( P @ ( cons @ a @ X @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) )
         => ( ! [X: a,Y2: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ~ ( less @ X @ Y2 )
               => ( ~ ( less @ Y2 @ X )
                 => ( ( lexordp @ a @ less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ a @ X @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% local.lexordp.inducts
thf(fact_53_local_Olexordp_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
      = ( ? [Y3: a,Ys3: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) ) )
        | ? [X3: a,Y3: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X3 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) )
            & ( less @ X3 @ Y3 ) )
        | ? [X3: a,Y3: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X3 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) )
            & ~ ( less @ X3 @ Y3 )
            & ~ ( less @ Y3 @ X3 )
            & ( lexordp @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp.simps
thf(fact_54_local_Olexordp__eq_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Ys2: ( list @ a )] : ( A22 != Ys2 ) )
       => ( ! [X: a] :
              ( ? [Xs2: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X @ Xs2 ) )
             => ! [Y2: a] :
                  ( ? [Ys2: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y2 @ Ys2 ) )
                 => ~ ( less @ X @ Y2 ) ) )
         => ~ ( ! [X: a,Y2: a,Xs2: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X @ Xs2 ) )
                 => ! [Ys2: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y2 @ Ys2 ) )
                     => ( ~ ( less @ X @ Y2 )
                       => ( ~ ( less @ Y2 @ X )
                         => ~ ( lexordp_eq @ a @ less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% local.lexordp_eq.cases
thf(fact_55_local_Olexordp__eq_Oinducts,axiom,(
    ! [X1: ( list @ a ),X23: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp_eq @ a @ less @ X1 @ X23 )
     => ( ! [X12: ( list @ a )] :
            ( P @ ( nil @ a ) @ X12 )
       => ( ! [X: a,Y2: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
              ( ( less @ X @ Y2 )
             => ( P @ ( cons @ a @ X @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) )
         => ( ! [X: a,Y2: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ~ ( less @ X @ Y2 )
               => ( ~ ( less @ Y2 @ X )
                 => ( ( lexordp_eq @ a @ less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ a @ X @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% local.lexordp_eq.inducts
thf(fact_56_local_Olexordp__eq_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
      = ( ? [Ys3: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22 = Ys3 ) )
        | ? [X3: a,Y3: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X3 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) )
            & ( less @ X3 @ Y3 ) )
        | ? [X3: a,Y3: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X3 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) )
            & ~ ( less @ X3 @ Y3 )
            & ~ ( less @ Y3 @ X3 )
            & ( lexordp_eq @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp_eq.simps
thf(fact_57_local_Olexordp__append__left__rightI,axiom,(
    ! [X2: a,Y: a,Us: ( list @ a ),Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X2 @ Y )
     => ( lexordp @ a @ less @ ( append @ a @ Us @ ( cons @ a @ X2 @ Xs ) ) @ ( append @ a @ Us @ ( cons @ a @ Y @ Ys ) ) ) ) )).

% local.lexordp_append_left_rightI
thf(fact_58_local_Olexordp__append__rightI,axiom,(
    ! [Ys: ( list @ a ),Xs: ( list @ a )] :
      ( ( Ys
       != ( nil @ a ) )
     => ( lexordp @ a @ less @ Xs @ ( append @ a @ Xs @ Ys ) ) ) )).

% local.lexordp_append_rightI
thf(fact_59_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_60_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_61_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_62_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_63_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_64_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_65_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_66_ord_Olexordp__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X2 @ Y )
        | ( ~ ( Less @ Y @ X2 )
          & ( lexordp @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_simps(3)
thf(fact_67_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X2 @ Y )
        | ( ~ ( Less @ Y @ X2 )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_68_ord_Olexordp__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less @ ( nil @ A ) @ Ys )
      = ( Ys
       != ( nil @ A ) ) ) )).

% ord.lexordp_simps(1)
thf(fact_69_ord_Olexordp__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ~ ( lexordp @ A @ Less @ Xs @ ( nil @ A ) ) )).

% ord.lexordp_simps(2)
thf(fact_70_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_71_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_72_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X2 = Y ) ) ) )).

% append1_eq_conv
thf(fact_73_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_74_local_Olexordp__simps_I3_J,axiom,(
    ! [X2: a,Xs: ( list @ a ),Y: a,Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( cons @ a @ Y @ Ys ) )
      = ( ( less @ X2 @ Y )
        | ( ~ ( less @ Y @ X2 )
          & ( lexordp @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_simps(3)
thf(fact_75_local_Olexordp__eq__simps_I4_J,axiom,(
    ! [X2: a,Xs: ( list @ a ),Y: a,Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( cons @ a @ Y @ Ys ) )
      = ( ( less @ X2 @ Y )
        | ( ~ ( less @ Y @ X2 )
          & ( lexordp_eq @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_eq_simps(4)
thf(fact_76_local_Olexordp__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ~ ( lexordp @ a @ less @ Xs @ ( nil @ a ) ) )).

% local.lexordp_simps(2)
thf(fact_77_local_Olexordp__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( nil @ a ) @ Ys )
      = ( Ys
       != ( nil @ a ) ) ) )).

% local.lexordp_simps(1)
thf(fact_78_local_Olexordp__eq__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ ( nil @ a ) )
      = ( Xs
        = ( nil @ a ) ) ) )).

% local.lexordp_eq_simps(2)
thf(fact_79_local_Olexordp__eq__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq_simps(1)
thf(fact_80_local_Olexordp__eq__simps_I3_J,axiom,(
    ! [X2: a,Xs: ( list @ a )] :
      ~ ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs ) @ ( nil @ a ) ) )).

% local.lexordp_eq_simps(3)
thf(fact_81_ord_Olexordp_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Y: A,Ys: ( list @ A )] :
      ( lexordp @ A @ Less @ ( nil @ A ) @ ( cons @ A @ Y @ Ys ) ) )).

% ord.lexordp.Nil
thf(fact_82_ord_Olexordp_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Y2: A,Ys2: ( list @ A )] :
              ( A22
             != ( cons @ A @ Y2 @ Ys2 ) ) )
       => ( ! [X: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X @ Xs2 ) )
             => ! [Y2: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y2 @ Ys2 ) )
                 => ~ ( Less @ X @ Y2 ) ) )
         => ~ ( ! [X: A,Y2: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( ~ ( Less @ X @ Y2 )
                       => ( ~ ( Less @ Y2 @ X )
                         => ~ ( lexordp @ A @ Less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp.cases
thf(fact_83_ord_Olexordp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Y3: A,Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) ) )
            | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ( Less2 @ X3 @ Y3 ) )
            | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ~ ( Less2 @ X3 @ Y3 )
                & ~ ( Less2 @ Y3 @ X3 )
                & ( lexordp @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp.simps
thf(fact_84_ord_Olexordp_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp @ A @ Less @ X1 @ X23 )
     => ( ! [Y2: A,Ys2: ( list @ A )] :
            ( P @ ( nil @ A ) @ ( cons @ A @ Y2 @ Ys2 ) )
       => ( ! [X: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less @ X @ Y2 )
             => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( ! [X: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less @ X @ Y2 )
               => ( ~ ( Less @ Y2 @ X )
                 => ( ( lexordp @ A @ Less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% ord.lexordp.inducts
thf(fact_85_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys2: ( list @ A )] : ( A22 != Ys2 ) )
       => ( ! [X: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X @ Xs2 ) )
             => ! [Y2: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y2 @ Ys2 ) )
                 => ~ ( Less @ X @ Y2 ) ) )
         => ~ ( ! [X: A,Y2: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( ~ ( Less @ X @ Y2 )
                       => ( ~ ( Less @ Y2 @ X )
                         => ~ ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_86_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys3 ) )
            | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ( Less2 @ X3 @ Y3 ) )
            | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ~ ( Less2 @ X3 @ Y3 )
                & ~ ( Less2 @ Y3 @ X3 )
                & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_87_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X1 @ X23 )
     => ( ! [X12: ( list @ A )] :
            ( P @ ( nil @ A ) @ X12 )
       => ( ! [X: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less @ X @ Y2 )
             => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( ! [X: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less @ X @ Y2 )
               => ( ~ ( Less @ Y2 @ X )
                 => ( ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_88_ord_Olexordp__append__rightI,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( Ys
       != ( nil @ A ) )
     => ( lexordp @ A @ Less @ Xs @ ( append @ A @ Xs @ Ys ) ) ) )).

% ord.lexordp_append_rightI
thf(fact_89_ord_Olexordp__append__left__rightI,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Y: A,Us: ( list @ A ),Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X2 @ Y )
     => ( lexordp @ A @ Less @ ( append @ A @ Us @ ( cons @ A @ X2 @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys ) ) ) ) )).

% ord.lexordp_append_left_rightI
thf(fact_90_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F2: ( A > B ),X12: ( list @ B )] :
          ( P @ F2 @ ( nil @ A ) @ X12 )
     => ( ! [F2: ( A > B ),A3: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F2 @ As @ ( cons @ B @ ( F2 @ A3 ) @ Bs ) )
           => ( P @ F2 @ ( cons @ A @ A3 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_91_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_92_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_93_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_94_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X2: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X2 @ Xs ) ) )
        | ? [Ys4: ( list @ A )] :
            ( ( Ys
              = ( cons @ A @ X2 @ Ys4 ) )
            & ( ( append @ A @ Ys4 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_95_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X2 @ Xs )
            = Zs ) )
        | ? [Ys4: ( list @ A )] :
            ( ( ( cons @ A @ X2 @ Ys4 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys4 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_96_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X: A,Y2: A,Xs2: ( list @ A )] :
              ( ( ( X = Y2 )
               => ( P @ ( cons @ A @ X @ Xs2 ) ) )
             => ( ( ( X != Y2 )
                 => ( P @ ( cons @ A @ Y2 @ Xs2 ) ) )
               => ( P @ ( cons @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_97_append__Cons,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( cons @ A @ X2 @ ( append @ A @ Xs @ Ys ) ) ) )).

% append_Cons
thf(fact_98_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ A )] :
      ( ( X2
       != ( nil @ A ) )
     => ( ! [X: A] :
            ( X2
           != ( cons @ A @ X @ ( nil @ A ) ) )
       => ~ ( ! [X: A,Y2: A,Xs2: ( list @ A )] :
                ( X2
               != ( cons @ A @ X @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_99_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_100_append__Nil,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_101_transpose_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ ( list @ A ) )] :
      ( ( X2
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X2
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X2
               != ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_102_Cons__eq__appendI,axiom,(
    ! [A: $tType,X2: A,Xs1: ( list @ A ),Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X2 @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_103_not__Cons__self2,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X2 @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_104_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_105_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P @ ( nil @ A ) @ X12 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
              ( ( P @ Xs2 @ Ys2 )
             => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_106_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X: A,Xs2: ( list @ A )] :
            ( P @ ( cons @ A @ X @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys2: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys2 ) )
         => ( ! [X: A,Xs2: ( list @ A ),Y2: B,Ys2: ( list @ B )] :
                ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_107_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_108_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X12: A,X24: ( list @ A )] :
            ( ( P @ X24 )
           => ( P @ ( cons @ A @ X12 @ X24 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_109_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_110_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys2: ( list @ A ),Y2: A] :
              ( Xs
             != ( append @ A @ Ys2 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_111_rev__induct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X: A,Xs2: ( list @ A )] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) )).

% rev_induct
thf(fact_112_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_113_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_114_ord_Olexordp__append__leftI,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Us: ( list @ A ),Vs: ( list @ A ),Xs: ( list @ A )] :
      ( ( lexordp @ A @ Less @ Us @ Vs )
     => ( lexordp @ A @ Less @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) ) ) )).

% ord.lexordp_append_leftI
thf(fact_115_ord_Olexordp__append__leftD,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A ),Us: ( list @ A ),Vs: ( list @ A )] :
      ( ( lexordp @ A @ Less @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) )
     => ( ! [A3: A] :
            ~ ( Less @ A3 @ A3 )
       => ( lexordp @ A @ Less @ Us @ Vs ) ) ) )).

% ord.lexordp_append_leftD
thf(fact_116_ord_Olexordp_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X2 @ Y )
     => ( ~ ( Less @ Y @ X2 )
       => ( ( lexordp @ A @ Less @ Xs @ Ys )
         => ( lexordp @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp.Cons_eq
thf(fact_117_ord_Olexordp_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X2 @ Y )
     => ( lexordp @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp.Cons
thf(fact_118_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X2 @ Y )
     => ( ~ ( Less @ Y @ X2 )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_119_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X2: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X2 @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_120_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_121_ord_Olexordp__irreflexive,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ! [X: A] :
          ~ ( Less @ X @ X )
     => ~ ( lexordp @ A @ Less @ Xs @ Xs ) ) )).

% ord.lexordp_irreflexive
thf(fact_122_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_123_ord_OgreaterThanLessThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_gr1161524159ssThan @ A )
      = ( ^ [Less2: ( A > A > $o ),L2: A,U2: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L2 ) @ ( set_lessThan @ A @ Less2 @ U2 ) ) ) ) )).

% ord.greaterThanLessThan_def
thf(fact_124_ord_OgreaterThanLessThan__eq,axiom,(
    ! [A: $tType] :
      ( ( set_gr1161524159ssThan @ A )
      = ( ^ [Less2: ( A > A > $o ),A5: A,B3: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ A5 ) @ ( set_lessThan @ A @ Less2 @ B3 ) ) ) ) )).

% ord.greaterThanLessThan_eq
thf(fact_125_Int__iff,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( member @ A @ C @ A4 )
        & ( member @ A @ C @ B4 ) ) ) )).

% Int_iff
thf(fact_126_IntI,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ A4 )
     => ( ( member @ A @ C @ B4 )
       => ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) ) ) ) )).

% IntI
thf(fact_127_inf__right__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X2 @ Y ) @ Y )
          = ( inf_inf @ A @ X2 @ Y ) ) ) )).

% inf_right_idem
thf(fact_128_inf_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.right_idem
thf(fact_129_inf__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( inf_inf @ A @ X2 @ ( inf_inf @ A @ X2 @ Y ) )
          = ( inf_inf @ A @ X2 @ Y ) ) ) )).

% inf_left_idem
thf(fact_130_inf_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B2 ) )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) )).

% inf.left_idem
thf(fact_131_inf__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B ),X3: A] :
              ( inf_inf @ B @ ( F3 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) )).

% inf_apply
thf(fact_132_inf_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) )).

% inf.idem
thf(fact_133_inf__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( inf_inf @ A @ X2 @ X2 )
          = X2 ) ) )).

% inf_idem
thf(fact_134_inf__sup__aci_I4_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( inf_inf @ A @ X2 @ ( inf_inf @ A @ X2 @ Y ) )
          = ( inf_inf @ A @ X2 @ Y ) ) ) )).

% inf_sup_aci(4)
thf(fact_135_inf__sup__aci_I3_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X2 @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X2 @ Z ) ) ) ) )).

% inf_sup_aci(3)
thf(fact_136_inf__sup__aci_I2_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X2 @ Y ) @ Z )
          = ( inf_inf @ A @ X2 @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_sup_aci(2)
thf(fact_137_inf__sup__aci_I1_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X3: A,Y3: A] :
              ( inf_inf @ A @ Y3 @ X3 ) ) ) ) )).

% inf_sup_aci(1)
thf(fact_138_inf__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B @ ( type2 @ B ) )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B ),X3: A] :
              ( inf_inf @ B @ ( F3 @ X3 ) @ ( G2 @ X3 ) ) ) ) ) )).

% inf_fun_def
thf(fact_139_inf_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C ) ) ) ) )).

% inf.assoc
thf(fact_140_inf__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X2 @ Y ) @ Z )
          = ( inf_inf @ A @ X2 @ ( inf_inf @ A @ Y @ Z ) ) ) ) )).

% inf_assoc
thf(fact_141_inf_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [A5: A,B3: A] :
              ( inf_inf @ A @ B3 @ A5 ) ) ) ) )).

% inf.commute
thf(fact_142_inf__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ( ( inf_inf @ A )
        = ( ^ [X3: A,Y3: A] :
              ( inf_inf @ A @ Y3 @ X3 ) ) ) ) )).

% inf_commute
thf(fact_143_inf_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A2 @ C ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C ) ) ) ) )).

% inf.left_commute
thf(fact_144_inf__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X2 @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X2 @ Z ) ) ) ) )).

% inf_left_commute
thf(fact_145_IntE,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
     => ~ ( ( member @ A @ C @ A4 )
         => ~ ( member @ A @ C @ B4 ) ) ) )).

% IntE
thf(fact_146_IntD1,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
     => ( member @ A @ C @ A4 ) ) )).

% IntD1
thf(fact_147_IntD2,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
     => ( member @ A @ C @ B4 ) ) )).

% IntD2
thf(fact_148_Int__assoc,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) @ C2 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B4 @ C2 ) ) ) )).

% Int_assoc
thf(fact_149_Int__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ A4 )
      = A4 ) )).

% Int_absorb
thf(fact_150_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B5: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B5 @ A6 ) ) ) )).

% Int_commute
thf(fact_151_Int__left__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B4 ) ) )).

% Int_left_absorb
thf(fact_152_Int__left__commute,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B4 @ C2 ) )
      = ( inf_inf @ ( set @ A ) @ B4 @ ( inf_inf @ ( set @ A ) @ A4 @ C2 ) ) ) )).

% Int_left_commute
thf(fact_153_ord_OlessThan__iff,axiom,(
    ! [A: $tType,I: A,Less: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_lessThan @ A @ Less @ K ) )
      = ( Less @ I @ K ) ) )).

% ord.lessThan_iff
thf(fact_154_ord_OgreaterThan__iff,axiom,(
    ! [A: $tType,I: A,Less: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_greaterThan @ A @ Less @ K ) )
      = ( Less @ K @ I ) ) )).

% ord.greaterThan_iff
thf(fact_155_ord_OgreaterThanLessThan__iff,axiom,(
    ! [A: $tType,I: A,Less: ( A > A > $o ),L: A,U: A] :
      ( ( member @ A @ I @ ( set_gr1161524159ssThan @ A @ Less @ L @ U ) )
      = ( ( Less @ L @ I )
        & ( Less @ I @ U ) ) ) )).

% ord.greaterThanLessThan_iff
thf(fact_156_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_157_prefixes_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ A )] :
      ( ( X2
       != ( nil @ A ) )
     => ~ ( ! [X: A,Xs2: ( list @ A )] :
              ( X2
             != ( cons @ A @ X @ Xs2 ) ) ) ) )).

% prefixes.cases
thf(fact_158_prefixes_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X: A,Xs2: ( list @ A )] :
            ( ( P @ Xs2 )
           => ( P @ ( cons @ A @ X @ Xs2 ) ) )
       => ( P @ A0 ) ) ) )).

% prefixes.induct
thf(fact_159_longest__common__prefix_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
          ( ( ( X = Y2 )
           => ( P @ Xs2 @ Ys2 ) )
         => ( P @ ( cons @ A @ X @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
     => ( ! [X12: ( list @ A )] :
            ( P @ ( nil @ A ) @ X12 )
       => ( ! [Uu: ( list @ A )] :
              ( P @ Uu @ ( nil @ A ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% longest_common_prefix.induct
thf(fact_160_prefixes__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( prefixes @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = ( append @ ( list @ A ) @ ( prefixes @ A @ Xs ) @ ( cons @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) @ ( nil @ ( list @ A ) ) ) ) ) )).

% prefixes_snoc
thf(fact_161_prefixes__eq__Snoc,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ ( list @ A ) ),X2: ( list @ A )] :
      ( ( ( prefixes @ A @ Ys )
        = ( append @ ( list @ A ) @ Xs @ ( cons @ ( list @ A ) @ X2 @ ( nil @ ( list @ A ) ) ) ) )
      = ( ( ( ( Ys
              = ( nil @ A ) )
            & ( Xs
              = ( nil @ ( list @ A ) ) ) )
          | ? [Z2: A,Zs2: ( list @ A )] :
              ( ( Ys
                = ( append @ A @ Zs2 @ ( cons @ A @ Z2 @ ( nil @ A ) ) ) )
              & ( Xs
                = ( prefixes @ A @ Zs2 ) ) ) )
        & ( X2 = Ys ) ) ) )).

% prefixes_eq_Snoc
thf(fact_162_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Xs: ( list @ B ),F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X2 @ Xs ) @ F )
      = ( append @ A @ ( F @ X2 ) @ ( bind @ B @ A @ Xs @ F ) ) ) )).

% bind_simps(2)
thf(fact_163_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_164_prefixes_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( prefixes @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% prefixes.simps(1)
thf(fact_165_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_166_prefixes_Oelims,axiom,(
    ! [A: $tType,X2: ( list @ A ),Y: ( list @ ( list @ A ) )] :
      ( ( ( prefixes @ A @ X2 )
        = Y )
     => ( ( ( X2
            = ( nil @ A ) )
         => ( Y
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
       => ~ ( ! [X: A,Xs2: ( list @ A )] :
                ( ( X2
                  = ( cons @ A @ X @ Xs2 ) )
               => ( Y
                 != ( cons @ ( list @ A ) @ ( nil @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( prefixes @ A @ Xs2 ) ) ) ) ) ) ) ) )).

% prefixes.elims
thf(fact_167_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( list @ A ) ),X2: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F @ ( cons @ B @ X2 @ Xs ) )
      = ( append @ A @ ( F @ X2 ) @ ( maps @ B @ A @ F @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_168_Nil__is__map__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% Nil_is_map_conv
thf(fact_169_map__is__Nil__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% map_is_Nil_conv
thf(fact_170_list_Omap__disc__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( list @ A )] :
      ( ( ( map @ A @ B @ F @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) )).

% list.map_disc_iff
thf(fact_171_map__append,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),Ys: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F @ Xs ) @ ( map @ B @ A @ F @ Ys ) ) ) )).

% map_append
thf(fact_172_list_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X21: A,X22: ( list @ A )] :
      ( ( map @ A @ B @ F @ ( cons @ A @ X21 @ X22 ) )
      = ( cons @ B @ ( F @ X21 ) @ ( map @ A @ B @ F @ X22 ) ) ) )).

% list.simps(9)
thf(fact_173_Cons__eq__map__D,axiom,(
    ! [A: $tType,B: $tType,X2: A,Xs: ( list @ A ),F: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( map @ B @ A @ F @ Ys ) )
     => ? [Z3: B,Zs3: ( list @ B )] :
          ( ( Ys
            = ( cons @ B @ Z3 @ Zs3 ) )
          & ( X2
            = ( F @ Z3 ) )
          & ( Xs
            = ( map @ B @ A @ F @ Zs3 ) ) ) ) )).

% Cons_eq_map_D
thf(fact_174_map__eq__Cons__D,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z3: B,Zs3: ( list @ B )] :
          ( ( Xs
            = ( cons @ B @ Z3 @ Zs3 ) )
          & ( ( F @ Z3 )
            = Y )
          & ( ( map @ B @ A @ F @ Zs3 )
            = Ys ) ) ) )).

% map_eq_Cons_D
thf(fact_175_Cons__eq__map__conv,axiom,(
    ! [A: $tType,B: $tType,X2: A,Xs: ( list @ A ),F: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( map @ B @ A @ F @ Ys ) )
      = ( ? [Z2: B,Zs2: ( list @ B )] :
            ( ( Ys
              = ( cons @ B @ Z2 @ Zs2 ) )
            & ( X2
              = ( F @ Z2 ) )
            & ( Xs
              = ( map @ B @ A @ F @ Zs2 ) ) ) ) ) )).

% Cons_eq_map_conv
thf(fact_176_map__eq__Cons__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ? [Z2: B,Zs2: ( list @ B )] :
            ( ( Xs
              = ( cons @ B @ Z2 @ Zs2 ) )
            & ( ( F @ Z2 )
              = Y )
            & ( ( map @ B @ A @ F @ Zs2 )
              = Ys ) ) ) ) )).

% map_eq_Cons_conv
thf(fact_177_list_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B )] :
      ( ( map @ A @ B @ F @ ( nil @ A ) )
      = ( nil @ B ) ) )).

% list.simps(8)
thf(fact_178_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_179_prefixes_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( prefixes @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( prefixes @ A @ Xs ) ) ) ) )).

% prefixes.simps(2)
thf(fact_180_prefixes_Opelims,axiom,(
    ! [A: $tType,X2: ( list @ A ),Y: ( list @ ( list @ A ) )] :
      ( ( ( prefixes @ A @ X2 )
        = Y )
     => ( ( accp @ ( list @ A ) @ ( prefixes_rel @ A ) @ X2 )
       => ( ( ( X2
              = ( nil @ A ) )
           => ( ( Y
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) )
             => ~ ( accp @ ( list @ A ) @ ( prefixes_rel @ A ) @ ( nil @ A ) ) ) )
         => ~ ( ! [X: A,Xs2: ( list @ A )] :
                  ( ( X2
                    = ( cons @ A @ X @ Xs2 ) )
                 => ( ( Y
                      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X ) @ ( prefixes @ A @ Xs2 ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( prefixes_rel @ A ) @ ( cons @ A @ X @ Xs2 ) ) ) ) ) ) ) ) )).

% prefixes.pelims
thf(fact_181_insert__Nil,axiom,(
    ! [A: $tType,X2: A] :
      ( ( insert @ A @ X2 @ ( nil @ A ) )
      = ( cons @ A @ X2 @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_182_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_183_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_184_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_185_map__eq__map__tailrec,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) )).

% map_eq_map_tailrec
thf(fact_186_last__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = X2 ) )).

% last_snoc
thf(fact_187_butlast__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = Xs ) )).

% butlast_snoc
thf(fact_188_last__appendR,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Ys ) ) ) )).

% last_appendR
thf(fact_189_last__appendL,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Xs ) ) ) )).

% last_appendL
thf(fact_190_append__butlast__last__id,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) )).

% append_butlast_last_id
thf(fact_191_map__butlast,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( butlast @ B @ Xs ) )
      = ( butlast @ A @ ( map @ B @ A @ F @ Xs ) ) ) )).

% map_butlast
thf(fact_192_snoc__eq__iff__butlast,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A,Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = Ys )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X2 ) ) ) )).

% snoc_eq_iff_butlast
thf(fact_193_butlast_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% butlast.simps(1)
thf(fact_194_last__ConsR,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X2 @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_ConsR
thf(fact_195_last__ConsL,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X2 @ Xs ) )
        = X2 ) ) )).

% last_ConsL
thf(fact_196_last_Osimps,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X2 @ Xs ) )
          = X2 ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) )).

% last.simps
thf(fact_197_butlast_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( butlast @ A @ Xs ) ) ) ) ) )).

% butlast.simps(2)
thf(fact_198_last__map,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),F: ( A > B )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ B @ ( map @ A @ B @ F @ Xs ) )
        = ( F @ ( last @ A @ Xs ) ) ) ) )).

% last_map
thf(fact_199_longest__common__suffix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
    ? [Ss: ( list @ A ),Xs4: ( list @ A ),Ys5: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs4 @ Ss ) )
      & ( Ys
        = ( append @ A @ Ys5 @ Ss ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( last @ A @ Xs4 )
         != ( last @ A @ Ys5 ) ) ) ) )).

% longest_common_suffix
thf(fact_200_butlast__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys ) ) ) ) ) )).

% butlast_append
thf(fact_201_last__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Ys ) ) ) ) )).

% last_append
thf(fact_202_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_203_strict__suffix__def,axiom,(
    ! [A: $tType] :
      ( ( strict_suffix @ A )
      = ( ^ [Xs3: ( list @ A ),Ys3: ( list @ A )] :
          ? [Us2: ( list @ A )] :
            ( ( Ys3
              = ( append @ A @ Us2 @ Xs3 ) )
            & ( Us2
             != ( nil @ A ) ) ) ) ) )).

% strict_suffix_def
thf(fact_204_strict__suffix__trans,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( strict_suffix @ A @ Xs @ Ys )
     => ( ( strict_suffix @ A @ Ys @ Zs )
       => ( strict_suffix @ A @ Xs @ Zs ) ) ) )).

% strict_suffix_trans
thf(fact_205_map__tailrec__rev_Oelims,axiom,(
    ! [A: $tType,B: $tType,X2: ( A > B ),Xa: ( list @ A ),Xb: ( list @ B ),Y: ( list @ B )] :
      ( ( ( map_tailrec_rev @ A @ B @ X2 @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb ) )
       => ~ ( ! [A3: A,As: ( list @ A )] :
                ( ( Xa
                  = ( cons @ A @ A3 @ As ) )
               => ( Y
                 != ( map_tailrec_rev @ A @ B @ X2 @ As @ ( cons @ B @ ( X2 @ A3 ) @ Xb ) ) ) ) ) ) ) )).

% map_tailrec_rev.elims
thf(fact_206_SuccD,axiom,(
    ! [A: $tType,K: A,Kl: ( set @ ( list @ A ) ),Kl2: ( list @ A )] :
      ( ( member @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl @ Kl2 ) )
     => ( member @ ( list @ A ) @ ( append @ A @ Kl2 @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl ) ) )).

% SuccD
thf(fact_207_map__tailrec__rev_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A2: A,As2: ( list @ A ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F @ ( cons @ A @ A2 @ As2 ) @ Bs2 )
      = ( map_tailrec_rev @ A @ B @ F @ As2 @ ( cons @ B @ ( F @ A2 ) @ Bs2 ) ) ) )).

% map_tailrec_rev.simps(2)
thf(fact_208_map__tailrec__rev_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F @ ( nil @ A ) @ Bs2 )
      = Bs2 ) )).

% map_tailrec_rev.simps(1)
thf(fact_209_SuccI,axiom,(
    ! [A: $tType,Kl2: ( list @ A ),K: A,Kl: ( set @ ( list @ A ) )] :
      ( ( member @ ( list @ A ) @ ( append @ A @ Kl2 @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl )
     => ( member @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl @ Kl2 ) ) ) )).

% SuccI
thf(fact_210_shift__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Greatest_shift @ A @ B )
      = ( ^ [Lab: ( ( list @ A ) > B ),K2: A,Kl3: ( list @ A )] :
            ( Lab @ ( cons @ A @ K2 @ Kl3 ) ) ) ) )).

% shift_def
thf(fact_211_empty__Shift,axiom,(
    ! [A: $tType,Kl: ( set @ ( list @ A ) ),K: A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ Kl )
     => ( ( member @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl @ ( nil @ A ) ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( bNF_Greatest_Shift @ A @ Kl @ K ) ) ) ) )).

% empty_Shift
thf(fact_212_ShiftD,axiom,(
    ! [A: $tType,Kl2: ( list @ A ),Kl: ( set @ ( list @ A ) ),K: A] :
      ( ( member @ ( list @ A ) @ Kl2 @ ( bNF_Greatest_Shift @ A @ Kl @ K ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ K @ Kl2 ) @ Kl ) ) )).

% ShiftD
thf(fact_213_Succ__Shift,axiom,(
    ! [A: $tType,Kl: ( set @ ( list @ A ) ),K: A,Kl2: ( list @ A )] :
      ( ( bNF_Greatest_Succ @ A @ ( bNF_Greatest_Shift @ A @ Kl @ K ) @ Kl2 )
      = ( bNF_Greatest_Succ @ A @ Kl @ ( cons @ A @ K @ Kl2 ) ) ) )).

% Succ_Shift
thf(fact_214_map__tailrec__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map_tailrec @ A @ B )
      = ( ^ [F3: ( A > B ),As3: ( list @ A )] :
            ( rev @ B @ ( map_tailrec_rev @ A @ B @ F3 @ As3 @ ( nil @ B ) ) ) ) ) )).

% map_tailrec_def
thf(fact_215_ord_OgreaterThanAtMost__def,axiom,(
    ! [A: $tType] :
      ( ( set_gr323396891AtMost @ A )
      = ( ^ [Less_eq: ( A > A > $o ),Less2: ( A > A > $o ),L2: A,U2: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L2 ) @ ( set_atMost @ A @ Less_eq @ U2 ) ) ) ) )).

% ord.greaterThanAtMost_def
thf(fact_216_rev__rev__ident,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) )).

% rev_rev_ident
thf(fact_217_rev__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) )).

% rev_is_rev_conv
thf(fact_218_Nil__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% Nil_is_rev_conv
thf(fact_219_rev__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rev_is_Nil_conv
thf(fact_220_rev__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) )).

% rev_append
thf(fact_221_rev__singleton__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% rev_singleton_conv
thf(fact_222_singleton__rev__conv,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% singleton_rev_conv
thf(fact_223_rev__eq__Cons__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) )).

% rev_eq_Cons_iff
thf(fact_224_rev__map,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( rev @ A @ ( map @ B @ A @ F @ Xs ) )
      = ( map @ B @ A @ F @ ( rev @ B @ Xs ) ) ) )).

% rev_map
thf(fact_225_ord_OatMost__iff,axiom,(
    ! [A: $tType,I: A,Less_eq2: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_atMost @ A @ Less_eq2 @ K ) )
      = ( Less_eq2 @ I @ K ) ) )).

% ord.atMost_iff
thf(fact_226_ord_OgreaterThanAtMost__iff,axiom,(
    ! [A: $tType,I: A,Less_eq2: ( A > A > $o ),Less: ( A > A > $o ),L: A,U: A] :
      ( ( member @ A @ I @ ( set_gr323396891AtMost @ A @ Less_eq2 @ Less @ L @ U ) )
      = ( ( Less @ L @ I )
        & ( Less_eq2 @ I @ U ) ) ) )).

% ord.greaterThanAtMost_iff
thf(fact_227_rev_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rev.simps(1)
thf(fact_228_rev__swap,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) )).

% rev_swap
thf(fact_229_rev_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( rev @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% rev.simps(2)
thf(fact_230_map__tailrec__rev,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( map_tailrec_rev @ B @ A )
      = ( ^ [F3: ( B > A ),As3: ( list @ B )] :
            ( append @ A @ ( rev @ A @ ( map @ B @ A @ F3 @ As3 ) ) ) ) ) )).

% map_tailrec_rev
thf(fact_231_list__of__aux__code_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( coindu1384447384of_aux @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( rev @ A @ Xs ) ) )).

% list_of_aux_code(1)
thf(fact_232_local_OgreaterThanAtMost__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_gr323396891AtMost @ a @ less_eq @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ L ) @ ( set_atMost @ a @ less_eq @ U ) ) ) )).

% local.greaterThanAtMost_def
thf(fact_233_local_Oord__eq__le__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.ord_eq_le_trans
thf(fact_234_local_Oord__le__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.ord_le_eq_trans
thf(fact_235_local_Omax__def,axiom,(
    ! [A2: a,B2: a] :
      ( ( ( less_eq @ A2 @ B2 )
       => ( ( max @ a @ less_eq @ A2 @ B2 )
          = B2 ) )
      & ( ~ ( less_eq @ A2 @ B2 )
       => ( ( max @ a @ less_eq @ A2 @ B2 )
          = A2 ) ) ) )).

% local.max_def
thf(fact_236_local_Omin__def,axiom,(
    ! [A2: a,B2: a] :
      ( ( ( less_eq @ A2 @ B2 )
       => ( ( min @ a @ less_eq @ A2 @ B2 )
          = A2 ) )
      & ( ~ ( less_eq @ A2 @ B2 )
       => ( ( min @ a @ less_eq @ A2 @ B2 )
          = B2 ) ) ) )).

% local.min_def
thf(fact_237_local_OatMost__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_atMost @ a @ less_eq @ K ) )
      = ( less_eq @ I @ K ) ) )).

% local.atMost_iff
thf(fact_238_local_OgreaterThanAtMost__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr323396891AtMost @ a @ less_eq @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less_eq @ I @ U ) ) ) )).

% local.greaterThanAtMost_iff
thf(fact_239_local_OatLeastLessThan__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_atLeastLessThan @ a @ less_eq @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_atLeast @ a @ less_eq @ L ) @ ( set_lessThan @ a @ less @ U ) ) ) )).

% local.atLeastLessThan_def
thf(fact_240_local_OatLeastAtMost__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_atLeastAtMost @ a @ less_eq @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_atLeast @ a @ less_eq @ L ) @ ( set_atMost @ a @ less_eq @ U ) ) ) )).

% local.atLeastAtMost_def
thf(fact_241_local_OatLeast__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_atLeast @ a @ less_eq @ K ) )
      = ( less_eq @ K @ I ) ) )).

% local.atLeast_iff
thf(fact_242_local_OatLeastAtMost__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_atLeastAtMost @ a @ less_eq @ L @ U ) )
      = ( ( less_eq @ L @ I )
        & ( less_eq @ I @ U ) ) ) )).

% local.atLeastAtMost_iff
thf(fact_243_local_OatLeastLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_atLeastLessThan @ a @ less_eq @ less @ L @ U ) )
      = ( ( less_eq @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.atLeastLessThan_iff
thf(fact_244_ord_OatLeast__iff,axiom,(
    ! [A: $tType,I: A,Less_eq2: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_atLeast @ A @ Less_eq2 @ K ) )
      = ( Less_eq2 @ K @ I ) ) )).

% ord.atLeast_iff
thf(fact_245_ord_OatLeastAtMost__iff,axiom,(
    ! [A: $tType,I: A,Less_eq2: ( A > A > $o ),L: A,U: A] :
      ( ( member @ A @ I @ ( set_atLeastAtMost @ A @ Less_eq2 @ L @ U ) )
      = ( ( Less_eq2 @ L @ I )
        & ( Less_eq2 @ I @ U ) ) ) )).

% ord.atLeastAtMost_iff
thf(fact_246_ord_OatLeastLessThan__iff,axiom,(
    ! [A: $tType,I: A,Less_eq2: ( A > A > $o ),Less: ( A > A > $o ),L: A,U: A] :
      ( ( member @ A @ I @ ( set_atLeastLessThan @ A @ Less_eq2 @ Less @ L @ U ) )
      = ( ( Less_eq2 @ L @ I )
        & ( Less @ I @ U ) ) ) )).

% ord.atLeastLessThan_iff
thf(fact_247_ord_OatLeastLessThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_atLeastLessThan @ A )
      = ( ^ [Less_eq: ( A > A > $o ),Less2: ( A > A > $o ),L2: A,U2: A] :
            ( inf_inf @ ( set @ A ) @ ( set_atLeast @ A @ Less_eq @ L2 ) @ ( set_lessThan @ A @ Less2 @ U2 ) ) ) ) )).

% ord.atLeastLessThan_def
thf(fact_248_ord_OatLeastAtMost__def,axiom,(
    ! [A: $tType] :
      ( ( set_atLeastAtMost @ A )
      = ( ^ [Less_eq: ( A > A > $o ),L2: A,U2: A] :
            ( inf_inf @ ( set @ A ) @ ( set_atLeast @ A @ Less_eq @ L2 ) @ ( set_atMost @ A @ Less_eq @ U2 ) ) ) ) )).

% ord.atLeastAtMost_def
thf(fact_249_local_Olsorted_OLNil,axiom,
    ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LNil @ a ) )).

% local.lsorted.LNil
thf(fact_250_hd__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rev @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% hd_rev
thf(fact_251_hd__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) )).

% hd_append2
thf(fact_252_local_Olsorted__code_I1_J,axiom,
    ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LNil @ a ) )).

% local.lsorted_code(1)

%----Type constructors (9)
thf(tcon_fun___Lattices_Osemilattice__inf,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( semilattice_inf @ A8 @ ( type2 @ A8 ) )
     => ( semilattice_inf @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( lattice @ A8 @ ( type2 @ A8 ) )
     => ( lattice @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_1,axiom,(
    ! [A7: $tType] :
      ( semilattice_inf @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_2,axiom,(
    ! [A7: $tType] :
      ( lattice @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_3,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_4,axiom,
    ( semilattice_inf @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_5,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_6,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ xs @ ys ) )
    = ( ( coinductive_lnull @ a @ xs )
      | ( coinductive_lnull @ a @ ys ) ) )).

%------------------------------------------------------------------------------
