%------------------------------------------------------------------------------
% File     : DAT155^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Hamming stream 89
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : hamming_stream__89.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  300 (   0 unit;  39 type;   0 defn)
%            Number of atoms       : 5413 ( 306 equality;3173 variable)
%            Maximal formula depth :   26 (  11 average)
%            Number of connectives : 5352 ( 188   ~;  36   |;  82   &;4718   @)
%                                         (   0 <=>; 328  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  442 ( 442   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   43 (  39   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1294 (  28 sgn;1028   !;  63   ?; 166   ^)
%                                         (1294   :;  37  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:11.012
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Extended__Nat_Oenat,type,(
    extended_enat: $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (32)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olprefix,type,(
    coinductive_lprefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__Nat_Oco_Oenat_Ocase__enat,type,(
    coindu440805660e_enat: 
      !>[A: $tType] :
        ( A > ( extended_enat > A ) > extended_enat > A ) )).

thf(sy_c_Complete__Partial__Order_Omonotone,type,(
    comple1396247847notone: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_Hamming__Stream__Mirabelle__rwekfkwckg_Oord_Olmerge,type,(
    hammin1328233080lmerge: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Oord_Olexordp,type,(
    lexordp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_Partial__Function_Ofun__ord,type,(
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,(
    set_gr1161524159ssThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_F,type,(
    f: ( ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) > ( coinductive_llist @ a ) ) > ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) > ( coinductive_llist @ a ) )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_xsa,type,(
    xsa: ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) )).

%----Relevant facts (253)
thf(fact_0_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.ord_eq_less_trans
thf(fact_1_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.ord_less_eq_trans
thf(fact_2_assms,axiom,
    ( f
    = ( ^ [Lmerge: ( ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) > ( coinductive_llist @ a ) )] :
          ( product_case_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a )
          @ ^ [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
              ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
              @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
                  ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
                  @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                      ( if @ ( coinductive_llist @ a ) @ ( less @ X @ Y ) @ ( coinductive_LCons @ a @ X @ ( product_curry @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Lmerge @ Xs2 @ Ys ) ) @ ( if @ ( coinductive_llist @ a ) @ ( less @ Y @ X ) @ ( coinductive_LCons @ a @ Y @ ( product_curry @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Lmerge @ Xs @ Ys2 ) ) @ ( coinductive_LCons @ a @ Y @ ( product_curry @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Lmerge @ Xs2 @ Ys2 ) ) ) )
                  @ Ys )
              @ Xs ) ) ) )).

% assms
thf(fact_3_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_4_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X: a] :
            ( less @ X @ U ) ) ) )).

% local.lessThan_def
thf(fact_5_lprefix__code_I1_J,axiom,(
    ! [A: $tType,Ys3: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_LNil @ A ) @ Ys3 ) )).

% lprefix_code(1)
thf(fact_6_LCons__lprefix__LCons,axiom,(
    ! [A: $tType,X2: A,Xs3: ( coinductive_llist @ A ),Y2: A,Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ ( coinductive_LCons @ A @ Y2 @ Ys3 ) )
      = ( ( X2 = Y2 )
        & ( coinductive_lprefix @ A @ Xs3 @ Ys3 ) ) ) )).

% LCons_lprefix_LCons
thf(fact_7_case__prod__curry,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C @ ( product_curry @ A @ B @ C @ F ) )
      = F ) )).

% case_prod_curry
thf(fact_8_curry__case__prod,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C )] :
      ( ( product_curry @ A @ B @ C @ ( product_case_prod @ A @ B @ C @ F ) )
      = F ) )).

% curry_case_prod
thf(fact_9_LCons__mono,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A3: ( ( A > ( coinductive_llist @ B ) ) > ( coinductive_llist @ C ) ),X2: C] :
      ( ( comple1396247847notone @ ( A > ( coinductive_llist @ B ) ) @ ( coinductive_llist @ C ) @ ( partial_fun_ord @ ( coinductive_llist @ B ) @ ( coinductive_llist @ B ) @ A @ ( coinductive_lprefix @ B ) ) @ ( coinductive_lprefix @ C ) @ A3 )
     => ( comple1396247847notone @ ( A > ( coinductive_llist @ B ) ) @ ( coinductive_llist @ C ) @ ( partial_fun_ord @ ( coinductive_llist @ B ) @ ( coinductive_llist @ B ) @ A @ ( coinductive_lprefix @ B ) ) @ ( coinductive_lprefix @ C )
        @ ^ [F2: ( A > ( coinductive_llist @ B ) )] :
            ( coinductive_LCons @ C @ X2 @ ( A3 @ F2 ) ) ) ) )).

% LCons_mono
thf(fact_10_mono2mono__LCons,axiom,(
    ! [A: $tType,C: $tType,Orda: ( C > C > $o ),T: ( C > ( coinductive_llist @ A ) ),X3: A] :
      ( ( comple1396247847notone @ C @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A ) @ T )
     => ( comple1396247847notone @ C @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A )
        @ ^ [X: C] :
            ( coinductive_LCons @ A @ X3 @ ( T @ X ) ) ) ) )).

% mono2mono_LCons
thf(fact_11_llist_Omono2mono,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Ordb: ( B > B > $o ),F: ( B > ( coinductive_llist @ A ) ),Orda: ( C > C > $o ),T: ( C > B )] :
      ( ( comple1396247847notone @ B @ ( coinductive_llist @ A ) @ Ordb @ ( coinductive_lprefix @ A ) @ F )
     => ( ( comple1396247847notone @ C @ B @ Orda @ Ordb @ T )
       => ( comple1396247847notone @ C @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A )
          @ ^ [X: C] :
              ( F @ ( T @ X ) ) ) ) ) )).

% llist.mono2mono
thf(fact_12_monotone__applyI,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),F3: ( A > B ),X2: C] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ F3 )
     => ( comple1396247847notone @ ( C > A ) @ B @ ( partial_fun_ord @ A @ A @ C @ Orda ) @ Ordb
        @ ^ [F2: ( C > A )] :
            ( F3 @ ( F2 @ X2 ) ) ) ) )).

% monotone_applyI
thf(fact_13_llist__lift_Omono2mono,axiom,(
    ! [B: $tType,A: $tType,Ba: $tType,C: $tType,Ordb: ( B > B > $o ),F: ( B > Ba > ( coinductive_llist @ A ) ),Orda: ( C > C > $o ),T: ( C > B )] :
      ( ( comple1396247847notone @ B @ ( Ba > ( coinductive_llist @ A ) ) @ Ordb @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) ) @ F )
     => ( ( comple1396247847notone @ C @ B @ Orda @ Ordb @ T )
       => ( comple1396247847notone @ C @ ( Ba > ( coinductive_llist @ A ) ) @ Orda @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) )
          @ ^ [X: C] :
              ( F @ ( T @ X ) ) ) ) ) )).

% llist_lift.mono2mono
thf(fact_14_llist__lift_Omonotone__if__bot,axiom,(
    ! [B: $tType,A: $tType,Ba: $tType,Bound: ( Ba > ( coinductive_llist @ A ) ),G: ( ( Ba > ( coinductive_llist @ A ) ) > B ),Bot: B,F: ( ( Ba > ( coinductive_llist @ A ) ) > B ),Ord: ( B > B > $o )] :
      ( ! [X4: ( Ba > ( coinductive_llist @ A ) )] :
          ( ( ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) @ X4 @ Bound )
           => ( ( G @ X4 )
              = Bot ) )
          & ( ~ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) @ X4 @ Bound )
           => ( ( G @ X4 )
              = ( F @ X4 ) ) ) )
     => ( ! [X4: ( Ba > ( coinductive_llist @ A ) ),Y3: ( Ba > ( coinductive_llist @ A ) )] :
            ( ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) @ X4 @ Y3 )
           => ( ~ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) @ X4 @ Bound )
             => ( Ord @ ( F @ X4 ) @ ( F @ Y3 ) ) ) )
       => ( ! [X4: ( Ba > ( coinductive_llist @ A ) )] :
              ( ~ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) @ X4 @ Bound )
             => ( Ord @ Bot @ ( F @ X4 ) ) )
         => ( ( Ord @ Bot @ Bot )
           => ( comple1396247847notone @ ( Ba > ( coinductive_llist @ A ) ) @ B @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) ) @ Ord @ G ) ) ) ) ) )).

% llist_lift.monotone_if_bot
thf(fact_15_lprefix__code_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs3: ( coinductive_llist @ A )] :
      ~ ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ ( coinductive_LNil @ A ) ) )).

% lprefix_code(2)
thf(fact_16_lprefix_Ocases,axiom,(
    ! [A: $tType,A1: ( coinductive_llist @ A ),A22: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ A1 @ A22 )
     => ( ( ( A1
            = ( coinductive_LNil @ A ) )
         => ! [Xs4: ( coinductive_llist @ A )] : ( A22 != Xs4 ) )
       => ~ ( ! [Xs4: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A ),X4: A] :
                ( ( A1
                  = ( coinductive_LCons @ A @ X4 @ Xs4 ) )
               => ( ( A22
                    = ( coinductive_LCons @ A @ X4 @ Ys4 ) )
                 => ~ ( coinductive_lprefix @ A @ Xs4 @ Ys4 ) ) ) ) ) ) )).

% lprefix.cases
thf(fact_17_llist_Oleq__refl,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ X2 @ X2 ) )).

% llist.leq_refl
thf(fact_18_lprefix__refl,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ Xs3 @ Xs3 ) )).

% lprefix_refl
thf(fact_19_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_20_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_21_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_22_llist_Omonotone__if__bot,axiom,(
    ! [B: $tType,A: $tType,Bound: ( coinductive_llist @ A ),G: ( ( coinductive_llist @ A ) > B ),Bot: B,F: ( ( coinductive_llist @ A ) > B ),Ord: ( B > B > $o )] :
      ( ! [X4: ( coinductive_llist @ A )] :
          ( ( ( coinductive_lprefix @ A @ X4 @ Bound )
           => ( ( G @ X4 )
              = Bot ) )
          & ( ~ ( coinductive_lprefix @ A @ X4 @ Bound )
           => ( ( G @ X4 )
              = ( F @ X4 ) ) ) )
     => ( ! [X4: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ A )] :
            ( ( coinductive_lprefix @ A @ X4 @ Y3 )
           => ( ~ ( coinductive_lprefix @ A @ X4 @ Bound )
             => ( Ord @ ( F @ X4 ) @ ( F @ Y3 ) ) ) )
       => ( ! [X4: ( coinductive_llist @ A )] :
              ( ~ ( coinductive_lprefix @ A @ X4 @ Bound )
             => ( Ord @ Bot @ ( F @ X4 ) ) )
         => ( ( Ord @ Bot @ Bot )
           => ( comple1396247847notone @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ Ord @ G ) ) ) ) ) )).

% llist.monotone_if_bot
thf(fact_23_monotone__case__prod__apply__iff,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType,Orda: ( ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o ),Ordb: ( C > C > $o ),F: ( A > B > D > C ),Y2: D] :
      ( ( comple1396247847notone @ ( product_prod @ A @ B ) @ C @ Orda @ Ordb
        @ ^ [X: ( product_prod @ A @ B )] :
            ( product_case_prod @ A @ B @ ( D > C ) @ F @ X @ Y2 ) )
      = ( comple1396247847notone @ ( product_prod @ A @ B ) @ C @ Orda @ Ordb
        @ ( product_case_prod @ A @ B @ C
          @ ^ [A4: A,B3: B] :
              ( F @ A4 @ B3 @ Y2 ) ) ) ) )).

% monotone_case_prod_apply_iff
thf(fact_24_monotone__case__prod__applyI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Orda: ( ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o ),Ordb: ( C > C > $o ),F: ( A > B > D > C ),Y2: D] :
      ( ( comple1396247847notone @ ( product_prod @ A @ B ) @ C @ Orda @ Ordb
        @ ( product_case_prod @ A @ B @ C
          @ ^ [A4: A,B3: B] :
              ( F @ A4 @ B3 @ Y2 ) ) )
     => ( comple1396247847notone @ ( product_prod @ A @ B ) @ C @ Orda @ Ordb
        @ ^ [X: ( product_prod @ A @ B )] :
            ( product_case_prod @ A @ B @ ( D > C ) @ F @ X @ Y2 ) ) ) )).

% monotone_case_prod_applyI
thf(fact_25_monotone__case__prod__applyD,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType,Orda: ( ( product_prod @ A @ B ) > ( product_prod @ A @ B ) > $o ),Ordb: ( C > C > $o ),F: ( A > B > D > C ),Y2: D] :
      ( ( comple1396247847notone @ ( product_prod @ A @ B ) @ C @ Orda @ Ordb
        @ ^ [X: ( product_prod @ A @ B )] :
            ( product_case_prod @ A @ B @ ( D > C ) @ F @ X @ Y2 ) )
     => ( comple1396247847notone @ ( product_prod @ A @ B ) @ C @ Orda @ Ordb
        @ ( product_case_prod @ A @ B @ C
          @ ^ [A4: A,B3: B] :
              ( F @ A4 @ B3 @ Y2 ) ) ) ) )).

% monotone_case_prod_applyD
thf(fact_26_monotone__if__fun,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,Orda: ( B > B > $o ),Ordb: ( D > D > $o ),F3: ( ( A > B ) > C > D ),G2: ( ( A > B ) > C > D ),C2: ( C > $o )] :
      ( ( comple1396247847notone @ ( A > B ) @ ( C > D ) @ ( partial_fun_ord @ B @ B @ A @ Orda ) @ ( partial_fun_ord @ D @ D @ C @ Ordb ) @ F3 )
     => ( ( comple1396247847notone @ ( A > B ) @ ( C > D ) @ ( partial_fun_ord @ B @ B @ A @ Orda ) @ ( partial_fun_ord @ D @ D @ C @ Ordb ) @ G2 )
       => ( comple1396247847notone @ ( A > B ) @ ( C > D ) @ ( partial_fun_ord @ B @ B @ A @ Orda ) @ ( partial_fun_ord @ D @ D @ C @ Ordb )
          @ ^ [F2: ( A > B ),N: C] :
              ( if @ D @ ( C2 @ N ) @ ( F3 @ F2 @ N ) @ ( G2 @ F2 @ N ) ) ) ) ) )).

% monotone_if_fun
thf(fact_27_monotone__fun__apply__fun,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Ord: ( C > C > $o ),T: A,G: ( D > B )] :
      ( comple1396247847notone @ ( A > B > C ) @ ( D > C ) @ ( partial_fun_ord @ ( B > C ) @ ( B > C ) @ A @ ( partial_fun_ord @ C @ C @ B @ Ord ) ) @ ( partial_fun_ord @ C @ C @ D @ Ord )
      @ ^ [F2: ( A > B > C ),N: D] :
          ( F2 @ T @ ( G @ N ) ) ) )).

% monotone_fun_apply_fun
thf(fact_28_monotone__LCons,axiom,(
    ! [A: $tType,X2: A] :
      ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_LCons @ A @ X2 ) ) )).

% monotone_LCons
thf(fact_29_ldropWhile_Omono,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( coinductive_llist @ A ) @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) ) @ ( coinductive_lprefix @ A )
      @ ^ [LdropWhile: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) )] :
          ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
          @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
              ( if @ ( coinductive_llist @ A ) @ ( P @ X ) @ ( LdropWhile @ Xs2 ) @ X2 )
          @ X2 ) ) )).

% ldropWhile.mono
thf(fact_30_llist__lift_Oconst__mono,axiom,(
    ! [Ba: $tType,A: $tType,B: $tType,Ord: ( B > B > $o ),C2: ( Ba > ( coinductive_llist @ A ) )] :
      ( comple1396247847notone @ B @ ( Ba > ( coinductive_llist @ A ) ) @ Ord @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ba @ ( coinductive_lprefix @ A ) )
      @ ^ [F2: B] : C2 ) )).

% llist_lift.const_mono
thf(fact_31_ltakeWhile__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs3: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( coinductive_llist @ A ) @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) ) @ ( coinductive_lprefix @ A )
      @ ^ [LtakeWhile: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) )] :
          ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
          @ ^ [X: A,Xs: ( coinductive_llist @ A )] :
              ( if @ ( coinductive_llist @ A ) @ ( P @ X ) @ ( coinductive_LCons @ A @ X @ ( LtakeWhile @ Xs ) ) @ ( coinductive_LNil @ A ) )
          @ Xs3 ) ) )).

% ltakeWhile_mono
thf(fact_32_lfilter_Omono,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( coinductive_llist @ A ) @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) ) @ ( coinductive_lprefix @ A )
      @ ^ [Lfilter: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) )] :
          ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
          @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
              ( if @ ( coinductive_llist @ A ) @ ( P @ X ) @ ( coinductive_LCons @ A @ X @ ( Lfilter @ Xs2 ) ) @ ( Lfilter @ Xs2 ) )
          @ X2 ) ) )).

% lfilter.mono
thf(fact_33_lmap__mono,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),Xs3: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) ) @ ( coinductive_llist @ B ) @ ( partial_fun_ord @ ( coinductive_llist @ B ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ B ) ) @ ( coinductive_lprefix @ B )
      @ ^ [Lmap: ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) )] :
          ( coindu1381640503_llist @ ( coinductive_llist @ B ) @ A @ ( coinductive_LNil @ B )
          @ ^ [X: A,Xs: ( coinductive_llist @ A )] :
              ( coinductive_LCons @ B @ ( F @ X ) @ ( Lmap @ Xs ) )
          @ Xs3 ) ) )).

% lmap_mono
thf(fact_34_monotone__lprefix__case,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ B ) )] :
      ( ! [X4: A] :
          ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ B )
          @ ^ [Xs: ( coinductive_llist @ A )] :
              ( F @ X4 @ Xs @ ( coinductive_LCons @ A @ X4 @ Xs ) ) )
     => ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ B )
        @ ^ [Xs: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ B ) @ A @ ( coinductive_LNil @ B )
            @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
                ( F @ X @ Xs2 @ Xs )
            @ Xs ) ) ) )).

% monotone_lprefix_case
thf(fact_35_lprefix__down__linear,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Zs )
     => ( ( coinductive_lprefix @ A @ Ys3 @ Zs )
       => ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
          | ( coinductive_lprefix @ A @ Ys3 @ Xs3 ) ) ) ) )).

% lprefix_down_linear
thf(fact_36_llist_Oleq__antisym,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Y2: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X2 @ Y2 )
     => ( ( coinductive_lprefix @ A @ Y2 @ X2 )
       => ( X2 = Y2 ) ) ) )).

% llist.leq_antisym
thf(fact_37_lprefix__antisym,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( ( coinductive_lprefix @ A @ Ys3 @ Xs3 )
       => ( Xs3 = Ys3 ) ) ) )).

% lprefix_antisym
thf(fact_38_llist_Oleq__trans,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Y2: ( coinductive_llist @ A ),Z: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X2 @ Y2 )
     => ( ( coinductive_lprefix @ A @ Y2 @ Z )
       => ( coinductive_lprefix @ A @ X2 @ Z ) ) ) )).

% llist.leq_trans
thf(fact_39_lprefix__trans,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( ( coinductive_lprefix @ A @ Ys3 @ Zs )
       => ( coinductive_lprefix @ A @ Xs3 @ Zs ) ) ) )).

% lprefix_trans
thf(fact_40_prod_Ocase__distrib,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: ( C > D ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X1: A,X23: B] :
            ( H @ ( F @ X1 @ X23 ) )
        @ Prod ) ) )).

% prod.case_distrib
thf(fact_41_monotone__id_H,axiom,(
    ! [A: $tType,Ord: ( A > A > $o )] :
      ( comple1396247847notone @ A @ A @ Ord @ Ord
      @ ^ [X: A] : X ) )).

% monotone_id'
thf(fact_42_curry__K,axiom,(
    ! [B: $tType,C: $tType,A: $tType,C2: C] :
      ( ( product_curry @ A @ B @ C
        @ ^ [X: ( product_prod @ A @ B )] : C2 )
      = ( ^ [X: A,Y: B] : C2 ) ) )).

% curry_K
thf(fact_43_llist_Ocase__distrib,axiom,(
    ! [B: $tType,C: $tType,A: $tType,H: ( B > C ),F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( H @ ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ Llist ) )
      = ( coindu1381640503_llist @ C @ A @ ( H @ F1 )
        @ ^ [X1: A,X23: ( coinductive_llist @ A )] :
            ( H @ ( F22 @ X1 @ X23 ) )
        @ Llist ) ) )).

% llist.case_distrib
thf(fact_44_LCons__lprefix__conv,axiom,(
    ! [A: $tType,X2: A,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ Ys3 )
      = ( ? [Ys2: ( coinductive_llist @ A )] :
            ( ( Ys3
              = ( coinductive_LCons @ A @ X2 @ Ys2 ) )
            & ( coinductive_lprefix @ A @ Xs3 @ Ys2 ) ) ) ) )).

% LCons_lprefix_conv
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_Le__LCons,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),X2: A] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ ( coinductive_LCons @ A @ X2 @ Ys3 ) ) ) )).

% Le_LCons
thf(fact_50_LNil__lprefix,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_LNil @ A ) @ Xs3 ) )).

% LNil_lprefix
thf(fact_51_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( Xs3
       != ( coinductive_LNil @ A ) )
      = ( ? [X: A,Xs2: ( coinductive_llist @ A )] :
            ( Xs3
            = ( coinductive_LCons @ A @ X @ Xs2 ) ) ) ) )).

% neq_LNil_conv
thf(fact_52_llist_Oexhaust,axiom,(
    ! [A: $tType,Y2: ( coinductive_llist @ A )] :
      ( ( Y2
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y2
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_53_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_54_llist__lift_Oleq__antisym,axiom,(
    ! [A: $tType,B: $tType,X2: ( B > ( coinductive_llist @ A ) ),Y2: ( B > ( coinductive_llist @ A ) )] :
      ( ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ X2 @ Y2 )
     => ( ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ Y2 @ X2 )
       => ( X2 = Y2 ) ) ) )).

% llist_lift.leq_antisym
thf(fact_55_llist__lift_Oleq__trans,axiom,(
    ! [A: $tType,B: $tType,X2: ( B > ( coinductive_llist @ A ) ),Y2: ( B > ( coinductive_llist @ A ) ),Z: ( B > ( coinductive_llist @ A ) )] :
      ( ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ X2 @ Y2 )
     => ( ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ Y2 @ Z )
       => ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ X2 @ Z ) ) ) )).

% llist_lift.leq_trans
thf(fact_56_llist__lift_Oleq__refl,axiom,(
    ! [A: $tType,B: $tType,X2: ( B > ( coinductive_llist @ A ) )] :
      ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ X2 @ X2 ) )).

% llist_lift.leq_refl
thf(fact_57_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = ( F22 @ X21 @ X22 ) ) )).

% llist.simps(5)
thf(fact_58_llist_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F1: B,F22: ( A > ( coinductive_llist @ A ) > B )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ ( coinductive_LNil @ A ) )
      = F1 ) )).

% llist.simps(4)
thf(fact_59_mono2mono__case__prod,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Orda: ( C > C > $o ),Ordb: ( D > D > $o ),Pair: ( C > A > B > D ),X2: ( product_prod @ A @ B )] :
      ( ! [X4: A,Y3: B] :
          ( comple1396247847notone @ C @ D @ Orda @ Ordb
          @ ^ [F2: C] :
              ( Pair @ F2 @ X4 @ Y3 ) )
     => ( comple1396247847notone @ C @ D @ Orda @ Ordb
        @ ^ [F2: C] :
            ( product_case_prod @ A @ B @ D @ ( Pair @ F2 ) @ X2 ) ) ) )).

% mono2mono_case_prod
thf(fact_60_monotone__fun__ord__apply,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Orda: ( A > A > $o ),Ordb: ( C > C > $o ),F: ( A > B > C )] :
      ( ( comple1396247847notone @ A @ ( B > C ) @ Orda @ ( partial_fun_ord @ C @ C @ B @ Ordb ) @ F )
      = ( ! [X: B] :
            ( comple1396247847notone @ A @ C @ Orda @ Ordb
            @ ^ [Y: A] :
                ( F @ Y @ X ) ) ) ) )).

% monotone_fun_ord_apply
thf(fact_61_llist__case__mono,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),Lnil: ( A > B ),Lcons: ( A > C > ( coinductive_llist @ C ) > B ),X2: ( coinductive_llist @ C )] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ Lnil )
     => ( ! [X4: C,Xs4: ( coinductive_llist @ C )] :
            ( comple1396247847notone @ A @ B @ Orda @ Ordb
            @ ^ [F2: A] :
                ( Lcons @ F2 @ X4 @ Xs4 ) )
       => ( comple1396247847notone @ A @ B @ Orda @ Ordb
          @ ^ [F2: A] :
              ( coindu1381640503_llist @ B @ C @ ( Lnil @ F2 ) @ ( Lcons @ F2 ) @ X2 ) ) ) ) )).

% llist_case_mono
thf(fact_62_llist_Oconst__mono,axiom,(
    ! [A: $tType,B: $tType,Ord: ( B > B > $o ),C2: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ B @ ( coinductive_llist @ A ) @ Ord @ ( coinductive_lprefix @ A )
      @ ^ [F2: B] : C2 ) )).

% llist.const_mono
thf(fact_63_lprefix__LCons__conv,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Y2: A,Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ ( coinductive_LCons @ A @ Y2 @ Ys3 ) )
      = ( ( Xs3
          = ( coinductive_LNil @ A ) )
        | ? [Xs2: ( coinductive_llist @ A )] :
            ( ( Xs3
              = ( coinductive_LCons @ A @ Y2 @ Xs2 ) )
            & ( coinductive_lprefix @ A @ Xs2 @ Ys3 ) ) ) ) )).

% lprefix_LCons_conv
thf(fact_64_lprefix_Ocoinduct,axiom,(
    ! [A: $tType,X5: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),X2: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A )] :
      ( ( X5 @ X2 @ Xa )
     => ( ! [X4: ( coinductive_llist @ A ),Xa2: ( coinductive_llist @ A )] :
            ( ( X5 @ X4 @ Xa2 )
           => ( ? [Xs5: ( coinductive_llist @ A )] :
                  ( ( X4
                    = ( coinductive_LNil @ A ) )
                  & ( Xa2 = Xs5 ) )
              | ? [Xs5: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A ),Xb: A] :
                  ( ( X4
                    = ( coinductive_LCons @ A @ Xb @ Xs5 ) )
                  & ( Xa2
                    = ( coinductive_LCons @ A @ Xb @ Ys5 ) )
                  & ( ( X5 @ Xs5 @ Ys5 )
                    | ( coinductive_lprefix @ A @ Xs5 @ Ys5 ) ) ) ) )
       => ( coinductive_lprefix @ A @ X2 @ Xa ) ) ) )).

% lprefix.coinduct
thf(fact_65_lprefix_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lprefix @ A )
      = ( ^ [A12: ( coinductive_llist @ A ),A23: ( coinductive_llist @ A )] :
            ( ? [Xs: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LNil @ A ) )
                & ( A23 = Xs ) )
            | ? [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X: A] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X @ Xs ) )
                & ( A23
                  = ( coinductive_LCons @ A @ X @ Ys ) )
                & ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) ) ) )).

% lprefix.simps
thf(fact_66_call__mono,axiom,(
    ! [B: $tType,A: $tType,Ord: ( B > B > $o ),T: A] :
      ( comple1396247847notone @ ( A > B ) @ B @ ( partial_fun_ord @ B @ B @ A @ Ord ) @ Ord
      @ ^ [F2: ( A > B )] :
          ( F2 @ T ) ) )).

% call_mono
thf(fact_67_lprefix__lmergeI,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Xs6: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a ),Ys6: ( coinductive_llist @ a )] :
      ( ( coinductive_lprefix @ a @ Xs3 @ Xs6 )
     => ( ( coinductive_lprefix @ a @ Ys3 @ Ys6 )
       => ( coinductive_lprefix @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) @ ( hammin1328233080lmerge @ a @ less @ Xs6 @ Ys6 ) ) ) ) )).

% lprefix_lmergeI
thf(fact_68_lmerge__eq__LNil__iff,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 )
        = ( coinductive_LNil @ a ) )
      = ( ( Xs3
          = ( coinductive_LNil @ a ) )
        | ( Ys3
          = ( coinductive_LNil @ a ) ) ) ) )).

% lmerge_eq_LNil_iff
thf(fact_69_local_Olexordp__eq__refl,axiom,(
    ! [Xs3: ( list @ a )] :
      ( lexordp_eq @ a @ less @ Xs3 @ Xs3 ) )).

% local.lexordp_eq_refl
thf(fact_70_lmerge__simps,axiom,(
    ! [X2: a,Y2: a,Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( ( less @ X2 @ Y2 )
       => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X2 @ Xs3 ) @ ( coinductive_LCons @ a @ Y2 @ Ys3 ) )
          = ( coinductive_LCons @ a @ X2 @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ ( coinductive_LCons @ a @ Y2 @ Ys3 ) ) ) ) )
      & ( ~ ( less @ X2 @ Y2 )
       => ( ( ( less @ Y2 @ X2 )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X2 @ Xs3 ) @ ( coinductive_LCons @ a @ Y2 @ Ys3 ) )
              = ( coinductive_LCons @ a @ Y2 @ ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X2 @ Xs3 ) @ Ys3 ) ) ) )
          & ( ~ ( less @ Y2 @ X2 )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X2 @ Xs3 ) @ ( coinductive_LCons @ a @ Y2 @ Ys3 ) )
              = ( coinductive_LCons @ a @ Y2 @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) ) ) ) ) ) ) )).

% lmerge_simps
thf(fact_71_ltake__mono,axiom,(
    ! [A: $tType,Nxs: ( product_prod @ extended_enat @ ( coinductive_llist @ A ) )] :
      ( comple1396247847notone @ ( ( product_prod @ extended_enat @ ( coinductive_llist @ A ) ) > ( coinductive_llist @ A ) ) @ ( coinductive_llist @ A ) @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( product_prod @ extended_enat @ ( coinductive_llist @ A ) ) @ ( coinductive_lprefix @ A ) ) @ ( coinductive_lprefix @ A )
      @ ^ [Ltake: ( ( product_prod @ extended_enat @ ( coinductive_llist @ A ) ) > ( coinductive_llist @ A ) )] :
          ( product_case_prod @ extended_enat @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A )
          @ ^ [N: extended_enat] :
              ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
              @ ^ [X: A,Xs: ( coinductive_llist @ A )] :
                  ( coindu440805660e_enat @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A )
                  @ ^ [O: extended_enat] :
                      ( coinductive_LCons @ A @ X @ ( product_curry @ extended_enat @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ltake @ O @ Xs ) )
                  @ N ) )
          @ Nxs ) ) )).

% ltake_mono
thf(fact_72_local_OgreaterThanLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr1161524159ssThan @ a @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.greaterThanLessThan_iff
thf(fact_73_ord_OlessThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_lessThan @ A )
      = ( ^ [Less: ( A > A > $o ),U2: A] :
            ( collect @ A
            @ ^ [X: A] :
                ( Less @ X @ U2 ) ) ) ) )).

% ord.lessThan_def
thf(fact_74_ord_OgreaterThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_greaterThan @ A )
      = ( ^ [Less: ( A > A > $o ),L2: A] :
            ( collect @ A @ ( Less @ L2 ) ) ) ) )).

% ord.greaterThan_def
thf(fact_75_local_OgreaterThanLessThan__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ A2 ) @ ( set_lessThan @ a @ less @ B2 ) ) ) )).

% local.greaterThanLessThan_eq
thf(fact_76_local_OgreaterThanLessThan__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ L ) @ ( set_lessThan @ a @ less @ U ) ) ) )).

% local.greaterThanLessThan_def
thf(fact_77_lmerge__LNil_I2_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ Xs3 @ ( coinductive_LNil @ a ) )
      = ( coinductive_LNil @ a ) ) )).

% lmerge_LNil(2)
thf(fact_78_lmerge__LNil_I1_J,axiom,(
    ! [Ys3: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LNil @ a ) @ Ys3 )
      = ( coinductive_LNil @ a ) ) )).

% lmerge_LNil(1)
thf(fact_79_ord_OgreaterThanLessThan__iff,axiom,(
    ! [A: $tType,I: A,Less2: ( A > A > $o ),L: A,U: A] :
      ( ( member @ A @ I @ ( set_gr1161524159ssThan @ A @ Less2 @ L @ U ) )
      = ( ( Less2 @ L @ I )
        & ( Less2 @ I @ U ) ) ) )).

% ord.greaterThanLessThan_iff
thf(fact_80_ord_Olprefix__lmergeI,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Xs6: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Ys6: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Xs6 )
     => ( ( coinductive_lprefix @ A @ Ys3 @ Ys6 )
       => ( coinductive_lprefix @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs6 @ Ys6 ) ) ) ) )).

% ord.lprefix_lmergeI
thf(fact_81_ord_Olmerge__simps,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Y2: A,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( ( Less2 @ X2 @ Y2 )
       => ( ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ ( coinductive_LCons @ A @ Y2 @ Ys3 ) )
          = ( coinductive_LCons @ A @ X2 @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ ( coinductive_LCons @ A @ Y2 @ Ys3 ) ) ) ) )
      & ( ~ ( Less2 @ X2 @ Y2 )
       => ( ( ( Less2 @ Y2 @ X2 )
           => ( ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ ( coinductive_LCons @ A @ Y2 @ Ys3 ) )
              = ( coinductive_LCons @ A @ Y2 @ ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ Ys3 ) ) ) )
          & ( ~ ( Less2 @ Y2 @ X2 )
           => ( ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_LCons @ A @ X2 @ Xs3 ) @ ( coinductive_LCons @ A @ Y2 @ Ys3 ) )
              = ( coinductive_LCons @ A @ Y2 @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) ) ) )).

% ord.lmerge_simps
thf(fact_82_ord_Olmerge__LNil_I2_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( coinductive_llist @ A )] :
      ( ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ord.lmerge_LNil(2)
thf(fact_83_ord_Olmerge__LNil_I1_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys3: ( coinductive_llist @ A )] :
      ( ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_LNil @ A ) @ Ys3 )
      = ( coinductive_LNil @ A ) ) )).

% ord.lmerge_LNil(1)
thf(fact_84_ord_Olmerge__eq__LNil__iff,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs3
          = ( coinductive_LNil @ A ) )
        | ( Ys3
          = ( coinductive_LNil @ A ) ) ) ) )).

% ord.lmerge_eq_LNil_iff
thf(fact_85_ord_OgreaterThanLessThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_gr1161524159ssThan @ A )
      = ( ^ [Less: ( A > A > $o ),L2: A,U2: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less @ L2 ) @ ( set_lessThan @ A @ Less @ U2 ) ) ) ) )).

% ord.greaterThanLessThan_def
thf(fact_86_ord_OgreaterThanLessThan__eq,axiom,(
    ! [A: $tType] :
      ( ( set_gr1161524159ssThan @ A )
      = ( ^ [Less: ( A > A > $o ),A4: A,B3: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less @ A4 ) @ ( set_lessThan @ A @ Less @ B3 ) ) ) ) )).

% ord.greaterThanLessThan_eq
thf(fact_87_fun__ord__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( partial_fun_ord @ A @ B @ C )
      = ( ^ [Ord2: ( A > B > $o ),F2: ( C > A ),G3: ( C > B )] :
          ! [X: C] :
            ( Ord2 @ ( F2 @ X ) @ ( G3 @ X ) ) ) ) )).

% fun_ord_def
thf(fact_88_ord_OgreaterThan__iff,axiom,(
    ! [A: $tType,I: A,Less2: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_greaterThan @ A @ Less2 @ K ) )
      = ( Less2 @ K @ I ) ) )).

% ord.greaterThan_iff
thf(fact_89_ord_OlessThan__iff,axiom,(
    ! [A: $tType,I: A,Less2: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_lessThan @ A @ Less2 @ K ) )
      = ( Less2 @ I @ K ) ) )).

% ord.lessThan_iff
thf(fact_90_if__mono,axiom,(
    ! [B: $tType,A: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),F3: ( A > B ),G2: ( A > B ),C2: $o] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ F3 )
     => ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ G2 )
       => ( comple1396247847notone @ A @ B @ Orda @ Ordb
          @ ^ [F2: A] :
              ( if @ B @ C2 @ ( F3 @ F2 ) @ ( G2 @ F2 ) ) ) ) ) )).

% if_mono
thf(fact_91_let__mono,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Orda: ( B > B > $o ),Ordb: ( C > C > $o ),B2: ( B > A > C ),T: A] :
      ( ! [X4: A] :
          ( comple1396247847notone @ B @ C @ Orda @ Ordb
          @ ^ [F2: B] :
              ( B2 @ F2 @ X4 ) )
     => ( comple1396247847notone @ B @ C @ Orda @ Ordb
        @ ^ [F2: B] :
            ( B2 @ F2 @ T ) ) ) )).

% let_mono
thf(fact_92_ldrop_Omono,axiom,(
    ! [A: $tType,X2: ( product_prod @ extended_enat @ ( coinductive_llist @ A ) )] :
      ( comple1396247847notone @ ( ( product_prod @ extended_enat @ ( coinductive_llist @ A ) ) > ( coinductive_llist @ A ) ) @ ( coinductive_llist @ A ) @ ( partial_fun_ord @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( product_prod @ extended_enat @ ( coinductive_llist @ A ) ) @ ( coinductive_lprefix @ A ) ) @ ( coinductive_lprefix @ A )
      @ ^ [Ldrop: ( ( product_prod @ extended_enat @ ( coinductive_llist @ A ) ) > ( coinductive_llist @ A ) )] :
          ( product_case_prod @ extended_enat @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A )
          @ ^ [N: extended_enat,Xs: ( coinductive_llist @ A )] :
              ( coindu440805660e_enat @ ( coinductive_llist @ A ) @ Xs
              @ ^ [N2: extended_enat] :
                  ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
                  @ ^ [X: A] :
                      ( product_curry @ extended_enat @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ Ldrop @ N2 )
                  @ Xs )
              @ N )
          @ X2 ) ) )).

% ldrop.mono
thf(fact_93_lmerge_Ocode,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 )
      = ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
        @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
            @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) ) @ ( coinductive_LCons @ a @ X @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys3 ) ) @ ( coinductive_LCons @ a @ Y @ ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Ys3 ) @ ( coinductive_lhd @ a @ Xs3 ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys2 ) @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys2 ) ) ) )
            @ Ys3 )
        @ Xs3 ) ) )).

% lmerge.code
thf(fact_94_lmerge_Octr_I1_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs3 )
        | ( coinductive_lnull @ a @ Ys3 ) )
     => ( ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 )
        = ( coinductive_LNil @ a ) ) ) )).

% lmerge.ctr(1)
thf(fact_95_enat__cocase__mono,axiom,(
    ! [B: $tType,A: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),Zero: ( A > B ),Esuc: ( A > extended_enat > B ),X2: extended_enat] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ Zero )
     => ( ! [N3: extended_enat] :
            ( comple1396247847notone @ A @ B @ Orda @ Ordb
            @ ^ [F2: A] :
                ( Esuc @ F2 @ N3 ) )
       => ( comple1396247847notone @ A @ B @ Orda @ Ordb
          @ ^ [F2: A] :
              ( coindu440805660e_enat @ B @ ( Zero @ F2 ) @ ( Esuc @ F2 ) @ X2 ) ) ) ) )).

% enat_cocase_mono
thf(fact_96_local_Olexordp__eq_ONil,axiom,(
    ! [Ys3: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys3 ) )).

% local.lexordp_eq.Nil
thf(fact_97_Int__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ( member @ A @ C2 @ B4 ) ) ) )).

% Int_iff
thf(fact_98_IntI,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) )).

% IntI
thf(fact_99_lmerge_Oexhaust,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( ( coinductive_lnull @ a @ Xs3 )
          | ( coinductive_lnull @ a @ Ys3 ) )
     => ~ ( ~ ( coinductive_lnull @ a @ Xs3 )
         => ( coinductive_lnull @ a @ Ys3 ) ) ) )).

% lmerge.exhaust
thf(fact_100_lmerge_Odisc_I1_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs3 )
        | ( coinductive_lnull @ a @ Ys3 ) )
     => ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) ) ) )).

% lmerge.disc(1)
thf(fact_101_lmerge_Odisc_I2_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs3 )
     => ( ~ ( coinductive_lnull @ a @ Ys3 )
       => ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% lmerge.disc(2)
thf(fact_102_lhd__lmerge,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs3 )
     => ( ~ ( coinductive_lnull @ a @ Ys3 )
       => ( ( ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) )
           => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
              = ( coinductive_lhd @ a @ Xs3 ) ) )
          & ( ~ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) )
           => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
              = ( coinductive_lhd @ a @ Ys3 ) ) ) ) ) ) )).

% lhd_lmerge
thf(fact_103_lprefix__LNil,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ ( coinductive_LNil @ A ) )
      = ( coinductive_lnull @ A @ Xs3 ) ) )).

% lprefix_LNil
thf(fact_104_lnull__lmerge,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
      = ( ( coinductive_lnull @ a @ Xs3 )
        | ( coinductive_lnull @ a @ Ys3 ) ) ) )).

% lnull_lmerge
thf(fact_105_lmerge_Osimps_I2_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ( ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) ) )
      = ( ~ ( coinductive_lnull @ a @ Xs3 )
        & ~ ( coinductive_lnull @ a @ Ys3 ) ) ) )).

% lmerge.simps(2)
thf(fact_106_local_Olexordp__eq__simps_I1_J,axiom,(
    ! [Ys3: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys3 ) )).

% local.lexordp_eq_simps(1)
thf(fact_107_local_Olexordp__eq__simps_I2_J,axiom,(
    ! [Xs3: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs3 @ ( nil @ a ) )
      = ( Xs3
        = ( nil @ a ) ) ) )).

% local.lexordp_eq_simps(2)
thf(fact_108_llist_Odisc__eq__case_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Llist ) )
      = ( coindu1381640503_llist @ $o @ A @ $false
        @ ^ [Uu: A,Uv: ( coinductive_llist @ A )] : $true
        @ Llist ) ) )).

% llist.disc_eq_case(2)
thf(fact_109_llist_Odisc__eq__case_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( coindu1381640503_llist @ $o @ A @ $true
        @ ^ [Uu: A,Uv: ( coinductive_llist @ A )] : $false ) ) )).

% llist.disc_eq_case(1)
thf(fact_110_ord_Olhd__lmerge,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs3 )
     => ( ~ ( coinductive_lnull @ A @ Ys3 )
       => ( ( ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) )
           => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
              = ( coinductive_lhd @ A @ Xs3 ) ) )
          & ( ~ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) )
           => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
              = ( coinductive_lhd @ A @ Ys3 ) ) ) ) ) ) )).

% ord.lhd_lmerge
thf(fact_111_ord_Olmerge_Oexhaust,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs3 )
          | ( coinductive_lnull @ A @ Ys3 ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs3 )
         => ( coinductive_lnull @ A @ Ys3 ) ) ) )).

% ord.lmerge.exhaust
thf(fact_112_ord__class_Olmerge_Oexhaust,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
          ( ~ ( ( coinductive_lnull @ A @ Xs3 )
              | ( coinductive_lnull @ A @ Ys3 ) )
         => ~ ( ~ ( coinductive_lnull @ A @ Xs3 )
             => ( coinductive_lnull @ A @ Ys3 ) ) ) ) )).

% ord_class.lmerge.exhaust
thf(fact_113_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs3 )
          | ~ ( P @ ( coinductive_lhd @ A @ Xs3 ) ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs3 )
         => ~ ( P @ ( coinductive_lhd @ A @ Xs3 ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_114_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs3 )
       => ~ ( coinductive_lnull @ A @ Ys3 ) )
     => ( ~ ( coinductive_lnull @ A @ Xs3 )
        | ~ ( coinductive_lnull @ A @ Ys3 ) ) ) )).

% lappend.exhaust
thf(fact_115_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs3 )
          | ( coinductive_lnull @ B @ Ys3 ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs3 )
         => ( coinductive_lnull @ B @ Ys3 ) ) ) )).

% lzip.exhaust
thf(fact_116_lprefix__lhdD,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( ~ ( coinductive_lnull @ A @ Xs3 )
       => ( ( coinductive_lhd @ A @ Xs3 )
          = ( coinductive_lhd @ A @ Ys3 ) ) ) ) )).

% lprefix_lhdD
thf(fact_117_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_118_lprefix__not__lnullD,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( ~ ( coinductive_lnull @ A @ Xs3 )
       => ~ ( coinductive_lnull @ A @ Ys3 ) ) ) )).

% lprefix_not_lnullD
thf(fact_119_lprefix__lnullD,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( ( coinductive_lnull @ A @ Ys3 )
       => ( coinductive_lnull @ A @ Xs3 ) ) ) )).

% lprefix_lnullD
thf(fact_120_lprefix__lnull,axiom,(
    ! [A: $tType,Ys3: ( coinductive_llist @ A ),Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys3 )
     => ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
        = ( coinductive_lnull @ A @ Xs3 ) ) ) )).

% lprefix_lnull
thf(fact_121_lnull__lprefix,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs3 )
     => ( coinductive_lprefix @ A @ Xs3 @ Ys3 ) ) )).

% lnull_lprefix
thf(fact_122_not__lnull__conv,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs3 ) )
      = ( ? [X: A,Xs2: ( coinductive_llist @ A )] :
            ( Xs3
            = ( coinductive_LCons @ A @ X @ Xs2 ) ) ) ) )).

% not_lnull_conv
thf(fact_123_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X21 @ X22 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_124_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_125_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist2: ( coinductive_llist @ A )] :
            ( Llist2
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_126_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist )
     => ( Llist
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_127_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_128_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_129_ord_Olmerge_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs3 )
     => ( ~ ( coinductive_lnull @ A @ Ys3 )
       => ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) )).

% ord.lmerge.disc(2)
thf(fact_130_ord_Olmerge_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs3 )
        | ( coinductive_lnull @ A @ Ys3 ) )
     => ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) ) ) )).

% ord.lmerge.disc(1)
thf(fact_131_ord_Olmerge_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs3 )
        & ~ ( coinductive_lnull @ A @ Ys3 ) ) ) )).

% ord.lmerge.disc_iff(2)
thf(fact_132_ord_Olnull__lmerge,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
      = ( ( coinductive_lnull @ A @ Xs3 )
        | ( coinductive_lnull @ A @ Ys3 ) ) ) )).

% ord.lnull_lmerge
thf(fact_133_ord_Olmerge_Octr_I1_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs3 )
        | ( coinductive_lnull @ A @ Ys3 ) )
     => ( ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 )
        = ( coinductive_LNil @ A ) ) ) )).

% ord.lmerge.ctr(1)
thf(fact_134_IntE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ~ ( member @ A @ C2 @ B4 ) ) ) )).

% IntE
thf(fact_135_IntD1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C2 @ A3 ) ) )).

% IntD1
thf(fact_136_IntD2,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C2 @ B4 ) ) )).

% IntD2
thf(fact_137_Int__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Int_assoc
thf(fact_138_Int__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Int_absorb
thf(fact_139_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Int_commute
thf(fact_140_Int__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) )).

% Int_left_absorb
thf(fact_141_Int__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ B4 @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% Int_left_commute
thf(fact_142_ord_Olmerge_Ocode,axiom,(
    ! [A: $tType] :
      ( ( hammin1328233080lmerge @ A )
      = ( ^ [Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
            @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
                @ ^ [Y: A,Ys2: ( coinductive_llist @ A )] :
                    ( if @ ( coinductive_llist @ A ) @ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) ) @ ( coinductive_LCons @ A @ X @ ( hammin1328233080lmerge @ A @ Less @ Xs2 @ Ys ) ) @ ( coinductive_LCons @ A @ Y @ ( if @ ( coinductive_llist @ A ) @ ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) ) @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys2 ) @ ( hammin1328233080lmerge @ A @ Less @ Xs2 @ Ys2 ) ) ) )
                @ Ys )
            @ Xs ) ) ) )).

% ord.lmerge.code
thf(fact_143_Int__def,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( collect @ A
            @ ^ [X: A] :
                ( ( member @ A @ X @ A5 )
                & ( member @ A @ X @ B5 ) ) ) ) ) )).

% Int_def
thf(fact_144_Int__Collect,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A ),P: ( A > $o )] :
      ( ( member @ A @ X2 @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) )
      = ( ( member @ A @ X2 @ A3 )
        & ( P @ X2 ) ) ) )).

% Int_Collect
thf(fact_145_Collect__conj__eq,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( ( P @ X )
            & ( Q @ X ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_conj_eq
thf(fact_146_co_Oenat_Ocase__distrib,axiom,(
    ! [B: $tType,A: $tType,H: ( A > B ),F1: A,F22: ( extended_enat > A ),Enat: extended_enat] :
      ( ( H @ ( coindu440805660e_enat @ A @ F1 @ F22 @ Enat ) )
      = ( coindu440805660e_enat @ B @ ( H @ F1 )
        @ ^ [X: extended_enat] :
            ( H @ ( F22 @ X ) )
        @ Enat ) ) )).

% co.enat.case_distrib
thf(fact_147_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys3: ( list @ A )] :
      ( lexordp_eq @ A @ Less2 @ ( nil @ A ) @ Ys3 ) )).

% ord.lexordp_eq_simps(1)
thf(fact_148_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less2 @ Xs3 @ ( nil @ A ) )
      = ( Xs3
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_149_lmerge_Osimps_I3_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs3 )
     => ( ~ ( coinductive_lnull @ a @ Ys3 )
       => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
          = ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
            @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
                ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
                @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                    ( if @ a @ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) ) @ X @ Y )
                @ Ys3 )
            @ Xs3 ) ) ) ) )).

% lmerge.simps(3)
thf(fact_150_ltl__lmerge,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs3 )
     => ( ~ ( coinductive_lnull @ a @ Ys3 )
       => ( ( ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) )
           => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
              = ( hammin1328233080lmerge @ a @ less @ ( coinductive_ltl @ a @ Xs3 ) @ Ys3 ) ) )
          & ( ~ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) )
           => ( ( ( less @ ( coinductive_lhd @ a @ Ys3 ) @ ( coinductive_lhd @ a @ Xs3 ) )
               => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
                  = ( hammin1328233080lmerge @ a @ less @ Xs3 @ ( coinductive_ltl @ a @ Ys3 ) ) ) )
              & ( ~ ( less @ ( coinductive_lhd @ a @ Ys3 ) @ ( coinductive_lhd @ a @ Xs3 ) )
               => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
                  = ( hammin1328233080lmerge @ a @ less @ ( coinductive_ltl @ a @ Xs3 ) @ ( coinductive_ltl @ a @ Ys3 ) ) ) ) ) ) ) ) ) )).

% ltl_lmerge
thf(fact_151_local_Olexordp__eq_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
      = ( ? [Ys: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22 = Ys ) )
        | ? [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs ) )
            & ( A22
              = ( cons @ a @ Y @ Ys ) )
            & ( less @ X @ Y ) )
        | ? [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs ) )
            & ( A22
              = ( cons @ a @ Y @ Ys ) )
            & ~ ( less @ X @ Y )
            & ~ ( less @ Y @ X )
            & ( lexordp_eq @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_eq.simps
thf(fact_152_local_Olexordp__eq_OCons,axiom,(
    ! [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
      ( ( less @ X2 @ Y2 )
     => ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( cons @ a @ Y2 @ Ys3 ) ) ) )).

% local.lexordp_eq.Cons
thf(fact_153_local_Olexordp__eq_OCons__eq,axiom,(
    ! [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
      ( ~ ( less @ X2 @ Y2 )
     => ( ~ ( less @ Y2 @ X2 )
       => ( ( lexordp_eq @ a @ less @ Xs3 @ Ys3 )
         => ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( cons @ a @ Y2 @ Ys3 ) ) ) ) ) )).

% local.lexordp_eq.Cons_eq
thf(fact_154_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_155_local_Olexordp__eq_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Ys4: ( list @ a )] : ( A22 != Ys4 ) )
       => ( ! [X4: a] :
              ( ? [Xs4: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X4 @ Xs4 ) )
             => ! [Y3: a] :
                  ( ? [Ys4: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y3 @ Ys4 ) )
                 => ~ ( less @ X4 @ Y3 ) ) )
         => ~ ( ! [X4: a,Y3: a,Xs4: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X4 @ Xs4 ) )
                 => ! [Ys4: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y3 @ Ys4 ) )
                     => ( ~ ( less @ X4 @ Y3 )
                       => ( ~ ( less @ Y3 @ X4 )
                         => ~ ( lexordp_eq @ a @ less @ Xs4 @ Ys4 ) ) ) ) ) ) ) ) ) )).

% local.lexordp_eq.cases
thf(fact_156_local_Olexordp__eq_Oinducts,axiom,(
    ! [X12: ( list @ a ),X24: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp_eq @ a @ less @ X12 @ X24 )
     => ( ! [X13: ( list @ a )] :
            ( P @ ( nil @ a ) @ X13 )
       => ( ! [X4: a,Y3: a,Xs4: ( list @ a ),Ys4: ( list @ a )] :
              ( ( less @ X4 @ Y3 )
             => ( P @ ( cons @ a @ X4 @ Xs4 ) @ ( cons @ a @ Y3 @ Ys4 ) ) )
         => ( ! [X4: a,Y3: a,Xs4: ( list @ a ),Ys4: ( list @ a )] :
                ( ~ ( less @ X4 @ Y3 )
               => ( ~ ( less @ Y3 @ X4 )
                 => ( ( lexordp_eq @ a @ less @ Xs4 @ Ys4 )
                   => ( ( P @ Xs4 @ Ys4 )
                     => ( P @ ( cons @ a @ X4 @ Xs4 ) @ ( cons @ a @ Y3 @ Ys4 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% local.lexordp_eq.inducts
thf(fact_157_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Xs3: ( list @ A ),Y2: A,Ys3: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys3 ) )
      = ( ( Less2 @ X2 @ Y2 )
        | ( ~ ( Less2 @ Y2 @ X2 )
          & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_158_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Xs3: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_159_local_Olexordp__eq__simps_I4_J,axiom,(
    ! [X2: a,Xs3: ( list @ a ),Y2: a,Ys3: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( cons @ a @ Y2 @ Ys3 ) )
      = ( ( less @ X2 @ Y2 )
        | ( ~ ( less @ Y2 @ X2 )
          & ( lexordp_eq @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp_eq_simps(4)
thf(fact_160_lhd__LCons__ltl,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ Llist )
     => ( ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) )
        = Llist ) ) )).

% lhd_LCons_ltl
thf(fact_161_local_Olexordp__eq__simps_I3_J,axiom,(
    ! [X2: a,Xs3: ( list @ a )] :
      ~ ( lexordp_eq @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( nil @ a ) ) )).

% local.lexordp_eq_simps(3)
thf(fact_162_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_163_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_164_list_Oexhaust,axiom,(
    ! [A: $tType,Y2: ( list @ A )] :
      ( ( Y2
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y2
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_165_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X13: A,X25: ( list @ A )] :
            ( ( P @ X25 )
           => ( P @ ( cons @ A @ X13 @ X25 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_166_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs3: ( list @ A )] :
      ( ( Xs3
       != ( nil @ A ) )
      = ( ? [Y: A,Ys: ( list @ A )] :
            ( Xs3
            = ( cons @ A @ Y @ Ys ) ) ) ) )).

% neq_Nil_conv
thf(fact_167_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs3: ( list @ A ),Ys3: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X4: A,Xs4: ( list @ A )] :
            ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( nil @ B ) )
       => ( ! [Y3: B,Ys4: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y3 @ Ys4 ) )
         => ( ! [X4: A,Xs4: ( list @ A ),Y3: B,Ys4: ( list @ B )] :
                ( ( P @ Xs4 @ Ys4 )
               => ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( cons @ B @ Y3 @ Ys4 ) ) )
           => ( P @ Xs3 @ Ys3 ) ) ) ) ) )).

% list_induct2'
thf(fact_168_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X13: ( list @ A )] :
          ( P @ ( nil @ A ) @ X13 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X4: A,Xs4: ( list @ A ),Y3: A,Ys4: ( list @ A )] :
              ( ( P @ Xs4 @ Ys4 )
             => ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys4 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_169_transpose_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ ( list @ A ) )] :
      ( ( X2
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X2
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X4: A,Xs4: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X2
               != ( cons @ ( list @ A ) @ ( cons @ A @ X4 @ Xs4 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_170_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ A )] :
      ( ( X2
       != ( nil @ A ) )
     => ( ! [X4: A] :
            ( X2
           != ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ~ ( ! [X4: A,Y3: A,Xs4: ( list @ A )] :
                ( X2
               != ( cons @ A @ X4 @ ( cons @ A @ Y3 @ Xs4 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_171_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X4: A] :
            ( P @ ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ( ! [X4: A,Y3: A,Xs4: ( list @ A )] :
              ( ( ( X4 = Y3 )
               => ( P @ ( cons @ A @ X4 @ Xs4 ) ) )
             => ( ( ( X4 != Y3 )
                 => ( P @ ( cons @ A @ Y3 @ Xs4 ) ) )
               => ( P @ ( cons @ A @ X4 @ ( cons @ A @ Y3 @ Xs4 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_172_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs3
       != ( nil @ A ) )
     => ( ! [X4: A] :
            ( P @ ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ( ! [X4: A,Xs4: ( list @ A )] :
              ( ( Xs4
               != ( nil @ A ) )
             => ( ( P @ Xs4 )
               => ( P @ ( cons @ A @ X4 @ Xs4 ) ) ) )
         => ( P @ Xs3 ) ) ) ) )).

% list_nonempty_induct
thf(fact_173_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F4: ( A > B ),X13: ( list @ B )] :
          ( P @ F4 @ ( nil @ A ) @ X13 )
     => ( ! [F4: ( A > B ),A6: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F4 @ As @ ( cons @ B @ ( F4 @ A6 ) @ Bs ) )
           => ( P @ F4 @ ( cons @ A @ A6 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_174_lnull__ltlI,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs3 )
     => ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs3 ) ) ) )).

% lnull_ltlI
thf(fact_175_lprefix__ltlI,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs3 @ Ys3 )
     => ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs3 ) @ ( coinductive_ltl @ A @ Ys3 ) ) ) )).

% lprefix_ltlI
thf(fact_176_ltl__simps_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_ltl @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X22 ) )).

% ltl_simps(2)
thf(fact_177_ltl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltl_simps(1)
thf(fact_178_not__Cons__self2,axiom,(
    ! [A: $tType,X2: A,Xs3: ( list @ A )] :
      ( ( cons @ A @ X2 @ Xs3 )
     != Xs3 ) )).

% not_Cons_self2
thf(fact_179_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( Less2 @ X2 @ Y2 )
     => ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys3 ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_180_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ~ ( Less2 @ X2 @ Y2 )
     => ( ~ ( Less2 @ Y2 @ X2 )
       => ( ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 )
         => ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_181_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys4: ( list @ A )] : ( A22 != Ys4 ) )
       => ( ! [X4: A] :
              ( ? [Xs4: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X4 @ Xs4 ) )
             => ! [Y3: A] :
                  ( ? [Ys4: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y3 @ Ys4 ) )
                 => ~ ( Less2 @ X4 @ Y3 ) ) )
         => ~ ( ! [X4: A,Y3: A,Xs4: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X4 @ Xs4 ) )
                 => ! [Ys4: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y3 @ Ys4 ) )
                     => ( ~ ( Less2 @ X4 @ Y3 )
                       => ( ~ ( Less2 @ Y3 @ X4 )
                         => ~ ( lexordp_eq @ A @ Less2 @ Xs4 @ Ys4 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_182_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys ) )
            | ? [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs ) )
                & ( A23
                  = ( cons @ A @ Y @ Ys ) )
                & ( Less @ X @ Y ) )
            | ? [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs ) )
                & ( A23
                  = ( cons @ A @ Y @ Ys ) )
                & ~ ( Less @ X @ Y )
                & ~ ( Less @ Y @ X )
                & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_183_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X12: ( list @ A ),X24: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less2 @ X12 @ X24 )
     => ( ! [X13: ( list @ A )] :
            ( P @ ( nil @ A ) @ X13 )
       => ( ! [X4: A,Y3: A,Xs4: ( list @ A ),Ys4: ( list @ A )] :
              ( ( Less2 @ X4 @ Y3 )
             => ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys4 ) ) )
         => ( ! [X4: A,Y3: A,Xs4: ( list @ A ),Ys4: ( list @ A )] :
                ( ~ ( Less2 @ X4 @ Y3 )
               => ( ~ ( Less2 @ Y3 @ X4 )
                 => ( ( lexordp_eq @ A @ Less2 @ Xs4 @ Ys4 )
                   => ( ( P @ Xs4 @ Ys4 )
                     => ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys4 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_184_llist_Oexpand,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Llist )
        = ( coinductive_lnull @ A @ Llist3 ) )
     => ( ( ~ ( coinductive_lnull @ A @ Llist )
         => ( ~ ( coinductive_lnull @ A @ Llist3 )
           => ( ( ( coinductive_lhd @ A @ Llist )
                = ( coinductive_lhd @ A @ Llist3 ) )
              & ( ( coinductive_ltl @ A @ Llist )
                = ( coinductive_ltl @ A @ Llist3 ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.expand
thf(fact_185_llist_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( R @ Llist @ Llist3 )
     => ( ! [Llist4: ( coinductive_llist @ A ),Llist5: ( coinductive_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coinductive_lnull @ A @ Llist4 )
                = ( coinductive_lnull @ A @ Llist5 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist4 )
               => ( ~ ( coinductive_lnull @ A @ Llist5 )
                 => ( ( ( coinductive_lhd @ A @ Llist4 )
                      = ( coinductive_lhd @ A @ Llist5 ) )
                    & ( R @ ( coinductive_ltl @ A @ Llist4 ) @ ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.coinduct
thf(fact_186_llist_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( R @ Llist @ Llist3 )
     => ( ! [Llist4: ( coinductive_llist @ A ),Llist5: ( coinductive_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coinductive_lnull @ A @ Llist4 )
                = ( coinductive_lnull @ A @ Llist5 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist4 )
               => ( ~ ( coinductive_lnull @ A @ Llist5 )
                 => ( ( ( coinductive_lhd @ A @ Llist4 )
                      = ( coinductive_lhd @ A @ Llist5 ) )
                    & ( ( R @ ( coinductive_ltl @ A @ Llist4 ) @ ( coinductive_ltl @ A @ Llist5 ) )
                      | ( ( coinductive_ltl @ A @ Llist4 )
                        = ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.coinduct_strong
thf(fact_187_monotone__ltl,axiom,(
    ! [A: $tType] :
      ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_ltl @ A ) ) )).

% monotone_ltl
thf(fact_188_mono2mono__ltl,axiom,(
    ! [A: $tType,C: $tType,Orda: ( C > C > $o ),T: ( C > ( coinductive_llist @ A ) )] :
      ( ( comple1396247847notone @ C @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A ) @ T )
     => ( comple1396247847notone @ C @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A )
        @ ^ [X: C] :
            ( coinductive_ltl @ A @ ( T @ X ) ) ) ) )).

% mono2mono_ltl
thf(fact_189_ltl__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A )
      = ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
        @ ^ [X213: A,X223: ( coinductive_llist @ A )] : X223 ) ) )).

% ltl_def
thf(fact_190_lhd__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lhd @ A )
      = ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X223: ( coinductive_llist @ A )] : X213 ) ) )).

% lhd_def
thf(fact_191_lprefix__expand,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs3 )
       => ( ~ ( coinductive_lnull @ A @ Ys3 )
          & ( ( coinductive_lhd @ A @ Xs3 )
            = ( coinductive_lhd @ A @ Ys3 ) )
          & ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs3 ) @ ( coinductive_ltl @ A @ Ys3 ) ) ) )
     => ( coinductive_lprefix @ A @ Xs3 @ Ys3 ) ) )).

% lprefix_expand
thf(fact_192_lprefix__coinduct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
      ( ( P @ Xs3 @ Ys3 )
     => ( ! [Xs4: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A )] :
            ( ( P @ Xs4 @ Ys4 )
           => ( ( ( coinductive_lnull @ A @ Ys4 )
               => ( coinductive_lnull @ A @ Xs4 ) )
              & ( ~ ( coinductive_lnull @ A @ Xs4 )
               => ( ~ ( coinductive_lnull @ A @ Ys4 )
                 => ( ( ( coinductive_lhd @ A @ Xs4 )
                      = ( coinductive_lhd @ A @ Ys4 ) )
                    & ( ( P @ ( coinductive_ltl @ A @ Xs4 ) @ ( coinductive_ltl @ A @ Ys4 ) )
                      | ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs4 ) @ ( coinductive_ltl @ A @ Ys4 ) ) ) ) ) ) ) )
       => ( coinductive_lprefix @ A @ Xs3 @ Ys3 ) ) ) )).

% lprefix_coinduct
thf(fact_193_eq__LConsD,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Y2: A,Ys3: ( coinductive_llist @ A )] :
      ( ( Xs3
        = ( coinductive_LCons @ A @ Y2 @ Ys3 ) )
     => ( ( Xs3
         != ( coinductive_LNil @ A ) )
        & ( ( coinductive_lhd @ A @ Xs3 )
          = Y2 )
        & ( ( coinductive_ltl @ A @ Xs3 )
          = Ys3 ) ) ) )).

% eq_LConsD
thf(fact_194_llist_Oexhaust__sel,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
       != ( coinductive_LNil @ A ) )
     => ( Llist
        = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) )).

% llist.exhaust_sel
thf(fact_195_llist_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( coindu1381640503_llist @ B @ A )
      = ( ^ [F12: B,F23: ( A > ( coinductive_llist @ A ) > B ),Llist2: ( coinductive_llist @ A )] :
            ( if @ B @ ( coinductive_lnull @ A @ Llist2 ) @ F12 @ ( F23 @ ( coinductive_lhd @ A @ Llist2 ) @ ( coinductive_ltl @ A @ Llist2 ) ) ) ) ) )).

% llist.case_eq_if
thf(fact_196_ord_Oltl__lmerge,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs3 )
     => ( ~ ( coinductive_lnull @ A @ Ys3 )
       => ( ( ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) )
           => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
              = ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_ltl @ A @ Xs3 ) @ Ys3 ) ) )
          & ( ~ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) )
           => ( ( ( Less2 @ ( coinductive_lhd @ A @ Ys3 ) @ ( coinductive_lhd @ A @ Xs3 ) )
               => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
                  = ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ ( coinductive_ltl @ A @ Ys3 ) ) ) )
              & ( ~ ( Less2 @ ( coinductive_lhd @ A @ Ys3 ) @ ( coinductive_lhd @ A @ Xs3 ) )
               => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
                  = ( hammin1328233080lmerge @ A @ Less2 @ ( coinductive_ltl @ A @ Xs3 ) @ ( coinductive_ltl @ A @ Ys3 ) ) ) ) ) ) ) ) ) )).

% ord.ltl_lmerge
thf(fact_197_ord_Olmerge_Octr_I2_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs3 )
     => ( ~ ( coinductive_lnull @ A @ Ys3 )
       => ( ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 )
          = ( coinductive_LCons @ A
            @ ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
              @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
                  ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
                  @ ^ [Y: A,Ys2: ( coinductive_llist @ A )] :
                      ( if @ A @ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) ) @ X @ Y )
                  @ Ys3 )
              @ Xs3 )
            @ ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
              @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
                  ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
                  @ ^ [Y: A,Ys2: ( coinductive_llist @ A )] :
                      ( if @ ( coinductive_llist @ A ) @ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs2 @ Ys3 ) @ ( if @ ( coinductive_llist @ A ) @ ( Less2 @ ( coinductive_lhd @ A @ Ys3 ) @ ( coinductive_lhd @ A @ Xs3 ) ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys2 ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs2 @ Ys2 ) ) )
                  @ Ys3 )
              @ Xs3 ) ) ) ) ) )).

% ord.lmerge.ctr(2)
thf(fact_198_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( list @ A )] :
      ( lexordp_eq @ A @ Less2 @ Xs3 @ Xs3 ) )).

% ord.lexordp_eq_refl
thf(fact_199_llist_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( P @ ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ Llist ) )
      = ( ( ( Llist
            = ( coinductive_LNil @ A ) )
         => ( P @ F1 ) )
        & ( ( Llist
            = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) )
         => ( P @ ( F22 @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) ) ) )).

% llist.split_sel
thf(fact_200_llist_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( P @ ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ Llist ) )
      = ( ~ ( ( ( Llist
                = ( coinductive_LNil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Llist
                = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) )
              & ~ ( P @ ( F22 @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) ) ) ) )).

% llist.split_sel_asm
thf(fact_201_ord_Olmerge_Osimps_I3_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs3 )
     => ( ~ ( coinductive_lnull @ A @ Ys3 )
       => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
          = ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
            @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
                ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
                @ ^ [Y: A,Ys2: ( coinductive_llist @ A )] :
                    ( if @ A @ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) ) @ X @ Y )
                @ Ys3 )
            @ Xs3 ) ) ) ) )).

% ord.lmerge.simps(3)
thf(fact_202_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys3: ( list @ A )] :
      ( lexordp_eq @ A @ Less2 @ ( nil @ A ) @ Ys3 ) )).

% ord.lexordp_eq.Nil
thf(fact_203_lmerge_Octr_I2_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs3 )
     => ( ~ ( coinductive_lnull @ a @ Ys3 )
       => ( ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 )
          = ( coinductive_LCons @ a
            @ ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
              @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
                  ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
                  @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                      ( if @ a @ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) ) @ X @ Y )
                  @ Ys3 )
              @ Xs3 )
            @ ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
              @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
                  ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
                  @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                      ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys3 ) @ ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Ys3 ) @ ( coinductive_lhd @ a @ Xs3 ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys2 ) @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys2 ) ) )
                  @ Ys3 )
              @ Xs3 ) ) ) ) ) )).

% lmerge.ctr(2)
thf(fact_204_lmerge_Osimps_I4_J,axiom,(
    ! [Xs3: ( coinductive_llist @ a ),Ys3: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs3 )
     => ( ~ ( coinductive_lnull @ a @ Ys3 )
       => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys3 ) )
          = ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
            @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
                @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                    ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Xs3 ) @ ( coinductive_lhd @ a @ Ys3 ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys3 ) @ ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Ys3 ) @ ( coinductive_lhd @ a @ Xs3 ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys2 ) @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys2 ) ) )
                @ Ys3 )
            @ Xs3 ) ) ) ) )).

% lmerge.simps(4)
thf(fact_205_local_Olexordp_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
      = ( ? [Y: a,Ys: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22
              = ( cons @ a @ Y @ Ys ) ) )
        | ? [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs ) )
            & ( A22
              = ( cons @ a @ Y @ Ys ) )
            & ( less @ X @ Y ) )
        | ? [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs ) )
            & ( A22
              = ( cons @ a @ Y @ Ys ) )
            & ~ ( less @ X @ Y )
            & ~ ( less @ Y @ X )
            & ( lexordp @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp.simps
thf(fact_206_local_Olexordp__irreflexive,axiom,(
    ! [Xs3: ( list @ a )] :
      ( ! [X4: a] :
          ~ ( less @ X4 @ X4 )
     => ~ ( lexordp @ a @ less @ Xs3 @ Xs3 ) ) )).

% local.lexordp_irreflexive
thf(fact_207_local_Olexordp_OCons__eq,axiom,(
    ! [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
      ( ~ ( less @ X2 @ Y2 )
     => ( ~ ( less @ Y2 @ X2 )
       => ( ( lexordp @ a @ less @ Xs3 @ Ys3 )
         => ( lexordp @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( cons @ a @ Y2 @ Ys3 ) ) ) ) ) )).

% local.lexordp.Cons_eq
thf(fact_208_local_Olexordp_OCons,axiom,(
    ! [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
      ( ( less @ X2 @ Y2 )
     => ( lexordp @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( cons @ a @ Y2 @ Ys3 ) ) ) )).

% local.lexordp.Cons
thf(fact_209_local_Olexordp__into__lexordp__eq,axiom,(
    ! [Xs3: ( list @ a ),Ys3: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs3 @ Ys3 )
     => ( lexordp_eq @ a @ less @ Xs3 @ Ys3 ) ) )).

% local.lexordp_into_lexordp_eq
thf(fact_210_local_Olexordp_ONil,axiom,(
    ! [Y2: a,Ys3: ( list @ a )] :
      ( lexordp @ a @ less @ ( nil @ a ) @ ( cons @ a @ Y2 @ Ys3 ) ) )).

% local.lexordp.Nil
thf(fact_211_local_Olexordp_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Y3: a,Ys4: ( list @ a )] :
              ( A22
             != ( cons @ a @ Y3 @ Ys4 ) ) )
       => ( ! [X4: a] :
              ( ? [Xs4: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X4 @ Xs4 ) )
             => ! [Y3: a] :
                  ( ? [Ys4: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y3 @ Ys4 ) )
                 => ~ ( less @ X4 @ Y3 ) ) )
         => ~ ( ! [X4: a,Y3: a,Xs4: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X4 @ Xs4 ) )
                 => ! [Ys4: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y3 @ Ys4 ) )
                     => ( ~ ( less @ X4 @ Y3 )
                       => ( ~ ( less @ Y3 @ X4 )
                         => ~ ( lexordp @ a @ less @ Xs4 @ Ys4 ) ) ) ) ) ) ) ) ) )).

% local.lexordp.cases
thf(fact_212_local_Olexordp_Oinducts,axiom,(
    ! [X12: ( list @ a ),X24: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp @ a @ less @ X12 @ X24 )
     => ( ! [Y3: a,Ys4: ( list @ a )] :
            ( P @ ( nil @ a ) @ ( cons @ a @ Y3 @ Ys4 ) )
       => ( ! [X4: a,Y3: a,Xs4: ( list @ a ),Ys4: ( list @ a )] :
              ( ( less @ X4 @ Y3 )
             => ( P @ ( cons @ a @ X4 @ Xs4 ) @ ( cons @ a @ Y3 @ Ys4 ) ) )
         => ( ! [X4: a,Y3: a,Xs4: ( list @ a ),Ys4: ( list @ a )] :
                ( ~ ( less @ X4 @ Y3 )
               => ( ~ ( less @ Y3 @ X4 )
                 => ( ( lexordp @ a @ less @ Xs4 @ Ys4 )
                   => ( ( P @ Xs4 @ Ys4 )
                     => ( P @ ( cons @ a @ X4 @ Xs4 ) @ ( cons @ a @ Y3 @ Ys4 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% local.lexordp.inducts
thf(fact_213_ord_Olexordp__simps_I3_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Xs3: ( list @ A ),Y2: A,Ys3: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys3 ) )
      = ( ( Less2 @ X2 @ Y2 )
        | ( ~ ( Less2 @ Y2 @ X2 )
          & ( lexordp @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) )).

% ord.lexordp_simps(3)
thf(fact_214_ord_Olexordp__simps_I1_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys3: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ ( nil @ A ) @ Ys3 )
      = ( Ys3
       != ( nil @ A ) ) ) )).

% ord.lexordp_simps(1)
thf(fact_215_ord_Olexordp__simps_I2_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( list @ A )] :
      ~ ( lexordp @ A @ Less2 @ Xs3 @ ( nil @ A ) ) )).

% ord.lexordp_simps(2)
thf(fact_216_local_Olexordp__simps_I3_J,axiom,(
    ! [X2: a,Xs3: ( list @ a ),Y2: a,Ys3: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( cons @ a @ X2 @ Xs3 ) @ ( cons @ a @ Y2 @ Ys3 ) )
      = ( ( less @ X2 @ Y2 )
        | ( ~ ( less @ Y2 @ X2 )
          & ( lexordp @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp_simps(3)
thf(fact_217_local_Olexordp__simps_I2_J,axiom,(
    ! [Xs3: ( list @ a )] :
      ~ ( lexordp @ a @ less @ Xs3 @ ( nil @ a ) ) )).

% local.lexordp_simps(2)
thf(fact_218_local_Olexordp__simps_I1_J,axiom,(
    ! [Ys3: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( nil @ a ) @ Ys3 )
      = ( Ys3
       != ( nil @ a ) ) ) )).

% local.lexordp_simps(1)
thf(fact_219_ord_Olexordp__irreflexive,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( list @ A )] :
      ( ! [X4: A] :
          ~ ( Less2 @ X4 @ X4 )
     => ~ ( lexordp @ A @ Less2 @ Xs3 @ Xs3 ) ) )).

% ord.lexordp_irreflexive
thf(fact_220_ord_Olexordp_OCons__eq,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ~ ( Less2 @ X2 @ Y2 )
     => ( ~ ( Less2 @ Y2 @ X2 )
       => ( ( lexordp @ A @ Less2 @ Xs3 @ Ys3 )
         => ( lexordp @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys3 ) ) ) ) ) )).

% ord.lexordp.Cons_eq
thf(fact_221_ord_Olexordp_OCons,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( Less2 @ X2 @ Y2 )
     => ( lexordp @ A @ Less2 @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y2 @ Ys3 ) ) ) )).

% ord.lexordp.Cons
thf(fact_222_ord_Olexordp__into__lexordp__eq,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ Xs3 @ Ys3 )
     => ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 ) ) )).

% ord.lexordp_into_lexordp_eq
thf(fact_223_ord_Olexordp_Oinducts,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X12: ( list @ A ),X24: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp @ A @ Less2 @ X12 @ X24 )
     => ( ! [Y3: A,Ys4: ( list @ A )] :
            ( P @ ( nil @ A ) @ ( cons @ A @ Y3 @ Ys4 ) )
       => ( ! [X4: A,Y3: A,Xs4: ( list @ A ),Ys4: ( list @ A )] :
              ( ( Less2 @ X4 @ Y3 )
             => ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys4 ) ) )
         => ( ! [X4: A,Y3: A,Xs4: ( list @ A ),Ys4: ( list @ A )] :
                ( ~ ( Less2 @ X4 @ Y3 )
               => ( ~ ( Less2 @ Y3 @ X4 )
                 => ( ( lexordp @ A @ Less2 @ Xs4 @ Ys4 )
                   => ( ( P @ Xs4 @ Ys4 )
                     => ( P @ ( cons @ A @ X4 @ Xs4 ) @ ( cons @ A @ Y3 @ Ys4 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% ord.lexordp.inducts
thf(fact_224_ord_Olexordp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [Less: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Y: A,Ys: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23
                  = ( cons @ A @ Y @ Ys ) ) )
            | ? [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs ) )
                & ( A23
                  = ( cons @ A @ Y @ Ys ) )
                & ( Less @ X @ Y ) )
            | ? [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs ) )
                & ( A23
                  = ( cons @ A @ Y @ Ys ) )
                & ~ ( Less @ X @ Y )
                & ~ ( Less @ Y @ X )
                & ( lexordp @ A @ Less @ Xs @ Ys ) ) ) ) ) )).

% ord.lexordp.simps
thf(fact_225_ord_Olexordp_Ocases,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Y3: A,Ys4: ( list @ A )] :
              ( A22
             != ( cons @ A @ Y3 @ Ys4 ) ) )
       => ( ! [X4: A] :
              ( ? [Xs4: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X4 @ Xs4 ) )
             => ! [Y3: A] :
                  ( ? [Ys4: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y3 @ Ys4 ) )
                 => ~ ( Less2 @ X4 @ Y3 ) ) )
         => ~ ( ! [X4: A,Y3: A,Xs4: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X4 @ Xs4 ) )
                 => ! [Ys4: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y3 @ Ys4 ) )
                     => ( ~ ( Less2 @ X4 @ Y3 )
                       => ( ~ ( Less2 @ Y3 @ X4 )
                         => ~ ( lexordp @ A @ Less2 @ Xs4 @ Ys4 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp.cases
thf(fact_226_ord_Olexordp_ONil,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Y2: A,Ys3: ( list @ A )] :
      ( lexordp @ A @ Less2 @ ( nil @ A ) @ ( cons @ A @ Y2 @ Ys3 ) ) )).

% ord.lexordp.Nil
thf(fact_227_ord_Olmerge_Osimps_I4_J,axiom,(
    ! [A: $tType,Xs3: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),Less2: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs3 )
     => ( ~ ( coinductive_lnull @ A @ Ys3 )
       => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys3 ) )
          = ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
            @ ^ [X: A,Xs2: ( coinductive_llist @ A )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
                @ ^ [Y: A,Ys2: ( coinductive_llist @ A )] :
                    ( if @ ( coinductive_llist @ A ) @ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys3 ) ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs2 @ Ys3 ) @ ( if @ ( coinductive_llist @ A ) @ ( Less2 @ ( coinductive_lhd @ A @ Ys3 ) @ ( coinductive_lhd @ A @ Xs3 ) ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys2 ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs2 @ Ys2 ) ) )
                @ Ys3 )
            @ Xs3 ) ) ) ) )).

% ord.lmerge.simps(4)
thf(fact_228_local_Olexordp__append__rightI,axiom,(
    ! [Ys3: ( list @ a ),Xs3: ( list @ a )] :
      ( ( Ys3
       != ( nil @ a ) )
     => ( lexordp @ a @ less @ Xs3 @ ( append @ a @ Xs3 @ Ys3 ) ) ) )).

% local.lexordp_append_rightI
thf(fact_229_local_Olexordp__append__left__rightI,axiom,(
    ! [X2: a,Y2: a,Us: ( list @ a ),Xs3: ( list @ a ),Ys3: ( list @ a )] :
      ( ( less @ X2 @ Y2 )
     => ( lexordp @ a @ less @ ( append @ a @ Us @ ( cons @ a @ X2 @ Xs3 ) ) @ ( append @ a @ Us @ ( cons @ a @ Y2 @ Ys3 ) ) ) ) )).

% local.lexordp_append_left_rightI
thf(fact_230_local_Olexordp__append__leftI,axiom,(
    ! [Us: ( list @ a ),Vs: ( list @ a ),Xs3: ( list @ a )] :
      ( ( lexordp @ a @ less @ Us @ Vs )
     => ( lexordp @ a @ less @ ( append @ a @ Xs3 @ Us ) @ ( append @ a @ Xs3 @ Vs ) ) ) )).

% local.lexordp_append_leftI
thf(fact_231_local_Olexordp__append__leftD,axiom,(
    ! [Xs3: ( list @ a ),Us: ( list @ a ),Vs: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( append @ a @ Xs3 @ Us ) @ ( append @ a @ Xs3 @ Vs ) )
     => ( ! [A6: a] :
            ~ ( less @ A6 @ A6 )
       => ( lexordp @ a @ less @ Us @ Vs ) ) ) )).

% local.lexordp_append_leftD
thf(fact_232_append__assoc,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs3 @ Ys3 ) @ Zs )
      = ( append @ A @ Xs3 @ ( append @ A @ Ys3 @ Zs ) ) ) )).

% append_assoc
thf(fact_233_append__same__eq,axiom,(
    ! [A: $tType,Ys3: ( list @ A ),Xs3: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys3 @ Xs3 )
        = ( append @ A @ Zs @ Xs3 ) )
      = ( Ys3 = Zs ) ) )).

% append_same_eq
thf(fact_234_same__append__eq,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs3 @ Ys3 )
        = ( append @ A @ Xs3 @ Zs ) )
      = ( Ys3 = Zs ) ) )).

% same_append_eq
thf(fact_235_append__Nil2,axiom,(
    ! [A: $tType,Xs3: ( list @ A )] :
      ( ( append @ A @ Xs3 @ ( nil @ A ) )
      = Xs3 ) )).

% append_Nil2
thf(fact_236_append__self__conv,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( ( append @ A @ Xs3 @ Ys3 )
        = Xs3 )
      = ( Ys3
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_237_self__append__conv,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( Xs3
        = ( append @ A @ Xs3 @ Ys3 ) )
      = ( Ys3
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_238_append__self__conv2,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( ( append @ A @ Xs3 @ Ys3 )
        = Ys3 )
      = ( Xs3
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_239_self__append__conv2,axiom,(
    ! [A: $tType,Ys3: ( list @ A ),Xs3: ( list @ A )] :
      ( ( Ys3
        = ( append @ A @ Xs3 @ Ys3 ) )
      = ( Xs3
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_240_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs3 @ Ys3 ) )
      = ( ( Xs3
          = ( nil @ A ) )
        & ( Ys3
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_241_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( ( append @ A @ Xs3 @ Ys3 )
        = ( nil @ A ) )
      = ( ( Xs3
          = ( nil @ A ) )
        & ( Ys3
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_242_append1__eq__conv,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),X2: A,Ys3: ( list @ A ),Y2: A] :
      ( ( ( append @ A @ Xs3 @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = ( append @ A @ Ys3 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
      = ( ( Xs3 = Ys3 )
        & ( X2 = Y2 ) ) ) )).

% append1_eq_conv
thf(fact_243_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( Xs3 = Ys3 )
     => ( Xs3
        = ( append @ A @ ( nil @ A ) @ Ys3 ) ) ) )).

% eq_Nil_appendI
thf(fact_244_append__Nil,axiom,(
    ! [A: $tType,Ys3: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys3 )
      = Ys3 ) )).

% append_Nil
thf(fact_245_ord_Olexordp__append__rightI,axiom,(
    ! [A: $tType,Ys3: ( list @ A ),Less2: ( A > A > $o ),Xs3: ( list @ A )] :
      ( ( Ys3
       != ( nil @ A ) )
     => ( lexordp @ A @ Less2 @ Xs3 @ ( append @ A @ Xs3 @ Ys3 ) ) ) )).

% ord.lexordp_append_rightI
thf(fact_246_ord_Olexordp__append__left__rightI,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X2: A,Y2: A,Us: ( list @ A ),Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( Less2 @ X2 @ Y2 )
     => ( lexordp @ A @ Less2 @ ( append @ A @ Us @ ( cons @ A @ X2 @ Xs3 ) ) @ ( append @ A @ Us @ ( cons @ A @ Y2 @ Ys3 ) ) ) ) )).

% ord.lexordp_append_left_rightI
thf(fact_247_ord_Olexordp__append__leftI,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Us: ( list @ A ),Vs: ( list @ A ),Xs3: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ Us @ Vs )
     => ( lexordp @ A @ Less2 @ ( append @ A @ Xs3 @ Us ) @ ( append @ A @ Xs3 @ Vs ) ) ) )).

% ord.lexordp_append_leftI
thf(fact_248_ord_Olexordp__append__leftD,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs3: ( list @ A ),Us: ( list @ A ),Vs: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ ( append @ A @ Xs3 @ Us ) @ ( append @ A @ Xs3 @ Vs ) )
     => ( ! [A6: A] :
            ~ ( Less2 @ A6 @ A6 )
       => ( lexordp @ A @ Less2 @ Us @ Vs ) ) ) )).

% ord.lexordp_append_leftD
thf(fact_249_append__Cons,axiom,(
    ! [A: $tType,X2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X2 @ Xs3 ) @ Ys3 )
      = ( cons @ A @ X2 @ ( append @ A @ Xs3 @ Ys3 ) ) ) )).

% append_Cons
thf(fact_250_Cons__eq__appendI,axiom,(
    ! [A: $tType,X2: A,Xs1: ( list @ A ),Ys3: ( list @ A ),Xs3: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs1 )
        = Ys3 )
     => ( ( Xs3
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X2 @ Xs3 )
          = ( append @ A @ Ys3 @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_251_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs3: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs3
       != ( nil @ A ) )
     => ( ! [X4: A] :
            ( P @ ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ( ! [X4: A,Xs4: ( list @ A )] :
              ( ( Xs4
               != ( nil @ A ) )
             => ( ( P @ Xs4 )
               => ( P @ ( append @ A @ Xs4 @ ( cons @ A @ X4 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs3 ) ) ) ) )).

% rev_nonempty_induct
thf(fact_252_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys3: ( list @ A ),Zs: ( list @ A ),X2: A,Xs3: ( list @ A )] :
      ( ( ( append @ A @ Ys3 @ Zs )
        = ( cons @ A @ X2 @ Xs3 ) )
      = ( ( ( Ys3
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X2 @ Xs3 ) ) )
        | ? [Ys2: ( list @ A )] :
            ( ( Ys3
              = ( cons @ A @ X2 @ Ys2 ) )
            & ( ( append @ A @ Ys2 @ Zs )
              = Xs3 ) ) ) ) )).

% append_eq_Cons_conv

%----Type constructors (4)
thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_1,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oord_2,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_3,axiom,
    ( ord @ extended_enat @ ( type2 @ extended_enat ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $false @ X2 @ Y2 )
      = Y2 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $true @ X2 @ Y2 )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( comple1396247847notone @ ( ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) > ( coinductive_llist @ a ) ) @ ( coinductive_llist @ a ) @ ( partial_fun_ord @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) @ ( coinductive_lprefix @ a ) ) @ ( coinductive_lprefix @ a )
    @ ^ [Lmerge: ( ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) > ( coinductive_llist @ a ) )] :
        ( product_case_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a )
        @ ^ [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
            @ ^ [X: a,Xs2: ( coinductive_llist @ a )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
                @ ^ [Y: a,Ys2: ( coinductive_llist @ a )] :
                    ( if @ ( coinductive_llist @ a ) @ ( less @ X @ Y ) @ ( coinductive_LCons @ a @ X @ ( product_curry @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Lmerge @ Xs2 @ Ys ) ) @ ( if @ ( coinductive_llist @ a ) @ ( less @ Y @ X ) @ ( coinductive_LCons @ a @ Y @ ( product_curry @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Lmerge @ Xs @ Ys2 ) ) @ ( coinductive_LCons @ a @ Y @ ( product_curry @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Lmerge @ Xs2 @ Ys2 ) ) ) )
                @ Ys )
            @ Xs )
        @ xsa ) )).

%------------------------------------------------------------------------------
