%------------------------------------------------------------------------------
% File     : DAT156^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Hamming stream 122
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : hamming_stream__122.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  295 (   0 unit;  35 type;   0 defn)
%            Number of atoms       : 5007 ( 261 equality;2941 variable)
%            Maximal formula depth :   25 (  11 average)
%            Number of connectives : 5021 ( 191   ~;  40   |;  81   &;4348   @)
%                                         (   0 <=>; 361  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  345 ( 345   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   39 (  35   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1187 (  24 sgn; 972   !;  63   ?; 121   ^)
%                                         (1187   :;  31  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:31.616
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (30)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OlSup,type,(
    coinductive_lSup: 
      !>[A: $tType] :
        ( ( set @ ( coinductive_llist @ A ) ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olprefix,type,(
    coinductive_lprefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Complete__Partial__Order2_Omcont,type,(
    comple1403672095_mcont: 
      !>[A: $tType,B: $tType] :
        ( ( ( set @ A ) > A ) > ( A > A > $o ) > ( ( set @ B ) > B ) > ( B > B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Complete__Partial__Order_Omonotone,type,(
    comple1396247847notone: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_Hamming__Stream__Mirabelle__rwekfkwckg_Oord_Olmerge,type,(
    hammin1328233080lmerge: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Oord_Olexordp,type,(
    lexordp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,(
    set_gr1161524159ssThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_xs,type,(
    xs: ( coinductive_llist @ a ) )).

%----Relevant facts (253)
thf(fact_0_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_1_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_2_lprefix__lmergeI,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Xs2: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a ),Ys2: ( coinductive_llist @ a )] :
      ( ( coinductive_lprefix @ a @ Xs @ Xs2 )
     => ( ( coinductive_lprefix @ a @ Ys @ Ys2 )
       => ( coinductive_lprefix @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) @ ( hammin1328233080lmerge @ a @ less @ Xs2 @ Ys2 ) ) ) ) )).

% lprefix_lmergeI
thf(fact_3_mcont2mcont__lmerge1,axiom,(
    ! [C2: $tType,Lub: ( ( set @ C2 ) > C2 ),Ord: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ a ) ),Ys: ( coinductive_llist @ a )] :
      ( ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ a ) @ Lub @ Ord @ ( coinductive_lSup @ a ) @ ( coinductive_lprefix @ a ) @ T )
     => ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ a ) @ Lub @ Ord @ ( coinductive_lSup @ a ) @ ( coinductive_lprefix @ a )
        @ ^ [X: C2] :
            ( hammin1328233080lmerge @ a @ less @ ( T @ X ) @ Ys ) ) ) )).

% mcont2mcont_lmerge1
thf(fact_4_mcont__lmerge1,axiom,(
    ! [Ys: ( coinductive_llist @ a )] :
      ( comple1403672095_mcont @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_lSup @ a ) @ ( coinductive_lprefix @ a ) @ ( coinductive_lSup @ a ) @ ( coinductive_lprefix @ a )
      @ ^ [Xs3: ( coinductive_llist @ a )] :
          ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys ) ) )).

% mcont_lmerge1
thf(fact_5_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_6_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X: a] :
            ( less @ X @ U ) ) ) )).

% local.lessThan_def
thf(fact_7_ord_Olprefix__lmergeI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Xs2: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Ys2: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( coinductive_lprefix @ A @ Xs @ Xs2 )
     => ( ( coinductive_lprefix @ A @ Ys @ Ys2 )
       => ( coinductive_lprefix @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) @ ( hammin1328233080lmerge @ A @ Less @ Xs2 @ Ys2 ) ) ) ) )).

% ord.lprefix_lmergeI
thf(fact_8_ord_Omcont2mcont__lmerge1,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( comple1403672095_mcont @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
      @ ^ [Xs3: ( coinductive_llist @ A )] :
          ( hammin1328233080lmerge @ A @ Less @ Xs3 @ Ys ) ) )).

% ord.mcont2mcont_lmerge1
thf(fact_9_llist_Omcont2mcont,axiom,(
    ! [B: $tType,A: $tType,C2: $tType,Lub2: ( ( set @ B ) > B ),Ord2: ( B > B > $o ),F: ( B > ( coinductive_llist @ A ) ),Lub: ( ( set @ C2 ) > C2 ),Ord: ( C2 > C2 > $o ),T: ( C2 > B )] :
      ( ( comple1403672095_mcont @ B @ ( coinductive_llist @ A ) @ Lub2 @ Ord2 @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ F )
     => ( ( comple1403672095_mcont @ C2 @ B @ Lub @ Ord @ Lub2 @ Ord2 @ T )
       => ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
          @ ^ [X: C2] :
              ( F @ ( T @ X ) ) ) ) ) )).

% llist.mcont2mcont
thf(fact_10_llist_Omcont2mcont_H,axiom,(
    ! [C2: $tType,A: $tType,B: $tType,Lub2: ( ( set @ C2 ) > C2 ),Ord2: ( C2 > C2 > $o ),F: ( B > C2 > ( coinductive_llist @ A ) ),Lub: ( ( set @ B ) > B ),Ord: ( B > B > $o ),T: ( B > C2 )] :
      ( ! [X2: B] :
          ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ A ) @ Lub2 @ Ord2 @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( F @ X2 ) )
     => ( ! [Y: C2] :
            ( comple1403672095_mcont @ B @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
            @ ^ [X: B] :
                ( F @ X @ Y ) )
       => ( ( comple1403672095_mcont @ B @ C2 @ Lub @ Ord @ Lub2 @ Ord2 @ T )
         => ( comple1403672095_mcont @ B @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
            @ ^ [X: B] :
                ( F @ X @ ( T @ X ) ) ) ) ) ) )).

% llist.mcont2mcont'
thf(fact_11_llist_Omcont__const,axiom,(
    ! [A: $tType,B: $tType,Luba: ( ( set @ B ) > B ),Orda: ( B > B > $o ),C: ( coinductive_llist @ A )] :
      ( comple1403672095_mcont @ B @ ( coinductive_llist @ A ) @ Luba @ Orda @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
      @ ^ [X: B] : C ) )).

% llist.mcont_const
thf(fact_12_monotone__lmerge1,axiom,(
    ! [Ys: ( coinductive_llist @ a )] :
      ( comple1396247847notone @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_lprefix @ a ) @ ( coinductive_lprefix @ a )
      @ ^ [Xs3: ( coinductive_llist @ a )] :
          ( hammin1328233080lmerge @ a @ less @ Xs3 @ Ys ) ) )).

% monotone_lmerge1
thf(fact_13_monotone__lmerge2,axiom,(
    ! [Xs: ( coinductive_llist @ a )] :
      ( comple1396247847notone @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_lprefix @ a ) @ ( coinductive_lprefix @ a ) @ ( hammin1328233080lmerge @ a @ less @ Xs ) ) )).

% monotone_lmerge2
thf(fact_14_mono2mono__lmerge1,axiom,(
    ! [C2: $tType,Orda: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ a ) ),Ys: ( coinductive_llist @ a )] :
      ( ( comple1396247847notone @ C2 @ ( coinductive_llist @ a ) @ Orda @ ( coinductive_lprefix @ a ) @ T )
     => ( comple1396247847notone @ C2 @ ( coinductive_llist @ a ) @ Orda @ ( coinductive_lprefix @ a )
        @ ^ [X: C2] :
            ( hammin1328233080lmerge @ a @ less @ ( T @ X ) @ Ys ) ) ) )).

% mono2mono_lmerge1
thf(fact_15_mono2mono__lmerge2,axiom,(
    ! [C2: $tType,Orda: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ a ) ),Xs: ( coinductive_llist @ a )] :
      ( ( comple1396247847notone @ C2 @ ( coinductive_llist @ a ) @ Orda @ ( coinductive_lprefix @ a ) @ T )
     => ( comple1396247847notone @ C2 @ ( coinductive_llist @ a ) @ Orda @ ( coinductive_lprefix @ a )
        @ ^ [X: C2] :
            ( hammin1328233080lmerge @ a @ less @ Xs @ ( T @ X ) ) ) ) )).

% mono2mono_lmerge2
thf(fact_16_lprefix__refl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ Xs @ Xs ) )).

% lprefix_refl
thf(fact_17_llist_Oleq__refl,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ X3 @ X3 ) )).

% llist.leq_refl
thf(fact_18_lmerge__eq__LNil__iff,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
        = ( coinductive_LNil @ a ) )
      = ( ( Xs
          = ( coinductive_LNil @ a ) )
        | ( Ys
          = ( coinductive_LNil @ a ) ) ) ) )).

% lmerge_eq_LNil_iff
thf(fact_19_lmerge__simps,axiom,(
    ! [X3: a,Y2: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( less @ X3 @ Y2 )
       => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X3 @ Xs ) @ ( coinductive_LCons @ a @ Y2 @ Ys ) )
          = ( coinductive_LCons @ a @ X3 @ ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_LCons @ a @ Y2 @ Ys ) ) ) ) )
      & ( ~ ( less @ X3 @ Y2 )
       => ( ( ( less @ Y2 @ X3 )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X3 @ Xs ) @ ( coinductive_LCons @ a @ Y2 @ Ys ) )
              = ( coinductive_LCons @ a @ Y2 @ ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X3 @ Xs ) @ Ys ) ) ) )
          & ( ~ ( less @ Y2 @ X3 )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X3 @ Xs ) @ ( coinductive_LCons @ a @ Y2 @ Ys ) )
              = ( coinductive_LCons @ a @ Y2 @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) ) ) ) )).

% lmerge_simps
thf(fact_20_lmerge_Odisc_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% lmerge.disc(2)
thf(fact_21_lmerge_Oexhaust,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( ( coinductive_lnull @ a @ Xs )
          | ( coinductive_lnull @ a @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ a @ Xs )
         => ( coinductive_lnull @ a @ Ys ) ) ) )).

% lmerge.exhaust
thf(fact_22_lmerge_Odisc_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) )
     => ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) )).

% lmerge.disc(1)
thf(fact_23_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_24_lmerge_Octr_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) )
     => ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
        = ( coinductive_LNil @ a ) ) ) )).

% lmerge.ctr(1)
thf(fact_25_LCons__lprefix__LCons,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ( X3 = Y2 )
        & ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) )).

% LCons_lprefix_LCons
thf(fact_26_lprefix__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_LNil @ A ) @ Ys ) )).

% lprefix_code(1)
thf(fact_27_lnull__lSup,axiom,(
    ! [A: $tType,A3: ( set @ ( coinductive_llist @ A ) )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lSup @ A @ A3 ) )
      = ( ! [X: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X @ A3 )
           => ( coinductive_lnull @ A @ X ) ) ) ) )).

% lnull_lSup
thf(fact_28_lprefix__LNil,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( coinductive_lnull @ A @ Xs ) ) )).

% lprefix_LNil
thf(fact_29_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_30_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_31_lnull__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) ) ) )).

% lnull_lmerge
thf(fact_32_lmerge_Osimps_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ a @ Xs )
        & ~ ( coinductive_lnull @ a @ Ys ) ) ) )).

% lmerge.simps(2)
thf(fact_33_lmerge__LNil_I1_J,axiom,(
    ! [Ys: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LNil @ a ) @ Ys )
      = ( coinductive_LNil @ a ) ) )).

% lmerge_LNil(1)
thf(fact_34_lmerge__LNil_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_LNil @ a ) )
      = ( coinductive_LNil @ a ) ) )).

% lmerge_LNil(2)
thf(fact_35_lSup_Octr_I1_J,axiom,(
    ! [A: $tType,A3: ( set @ ( coinductive_llist @ A ) )] :
      ( ! [X2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ X2 @ A3 )
         => ( coinductive_lnull @ A @ X2 ) )
     => ( ( coinductive_lSup @ A @ A3 )
        = ( coinductive_LNil @ A ) ) ) )).

% lSup.ctr(1)
thf(fact_36_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_37_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_38_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X21 @ X22 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_39_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_40_lprefix__code_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ~ ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LNil @ A ) ) )).

% lprefix_code(2)
thf(fact_41_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist )
     => ( Llist
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_42_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_43_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_llist_Oexhaust,axiom,(
    ! [A: $tType,Y2: ( coinductive_llist @ A )] :
      ( ( Y2
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y2
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_49_lprefix_Ocases,axiom,(
    ! [A: $tType,A1: ( coinductive_llist @ A ),A22: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ A1 @ A22 )
     => ( ( ( A1
            = ( coinductive_LNil @ A ) )
         => ! [Xs4: ( coinductive_llist @ A )] : ( A22 != Xs4 ) )
       => ~ ( ! [Xs4: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A ),X2: A] :
                ( ( A1
                  = ( coinductive_LCons @ A @ X2 @ Xs4 ) )
               => ( ( A22
                    = ( coinductive_LCons @ A @ X2 @ Ys3 ) )
                 => ~ ( coinductive_lprefix @ A @ Xs4 @ Ys3 ) ) ) ) ) ) )).

% lprefix.cases
thf(fact_50_lprefix_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lprefix @ A )
      = ( ^ [A12: ( coinductive_llist @ A ),A23: ( coinductive_llist @ A )] :
            ( ? [Xs3: ( coinductive_llist @ A )] :
                ( ( A12
                  = ( coinductive_LNil @ A ) )
                & ( A23 = Xs3 ) )
            | ? [Xs3: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A ),X: A] :
                ( ( A12
                  = ( coinductive_LCons @ A @ X @ Xs3 ) )
                & ( A23
                  = ( coinductive_LCons @ A @ X @ Ys4 ) )
                & ( coinductive_lprefix @ A @ Xs3 @ Ys4 ) ) ) ) ) )).

% lprefix.simps
thf(fact_51_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X @ Xs5 ) ) ) ) )).

% neq_LNil_conv
thf(fact_52_monotone__LCons,axiom,(
    ! [A: $tType,X3: A] :
      ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_LCons @ A @ X3 ) ) )).

% monotone_LCons
thf(fact_53_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X @ Xs5 ) ) ) ) )).

% not_lnull_conv
thf(fact_54_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_55_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist2: ( coinductive_llist @ A )] :
            ( Llist2
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_56_llist_Omono2mono,axiom,(
    ! [B: $tType,A: $tType,C2: $tType,Ordb: ( B > B > $o ),F: ( B > ( coinductive_llist @ A ) ),Orda: ( C2 > C2 > $o ),T: ( C2 > B )] :
      ( ( comple1396247847notone @ B @ ( coinductive_llist @ A ) @ Ordb @ ( coinductive_lprefix @ A ) @ F )
     => ( ( comple1396247847notone @ C2 @ B @ Orda @ Ordb @ T )
       => ( comple1396247847notone @ C2 @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A )
          @ ^ [X: C2] :
              ( F @ ( T @ X ) ) ) ) ) )).

% llist.mono2mono
thf(fact_57_lprefix_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),X3: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A )] :
      ( ( X4 @ X3 @ Xa )
     => ( ! [X2: ( coinductive_llist @ A ),Xa2: ( coinductive_llist @ A )] :
            ( ( X4 @ X2 @ Xa2 )
           => ( ? [Xs6: ( coinductive_llist @ A )] :
                  ( ( X2
                    = ( coinductive_LNil @ A ) )
                  & ( Xa2 = Xs6 ) )
              | ? [Xs6: ( coinductive_llist @ A ),Ys5: ( coinductive_llist @ A ),Xb: A] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ Xb @ Xs6 ) )
                  & ( Xa2
                    = ( coinductive_LCons @ A @ Xb @ Ys5 ) )
                  & ( ( X4 @ Xs6 @ Ys5 )
                    | ( coinductive_lprefix @ A @ Xs6 @ Ys5 ) ) ) ) )
       => ( coinductive_lprefix @ A @ X3 @ Xa ) ) ) )).

% lprefix.coinduct
thf(fact_58_lprefix__LCons__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs5: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y2 @ Xs5 ) )
            & ( coinductive_lprefix @ A @ Xs5 @ Ys ) ) ) ) )).

% lprefix_LCons_conv
thf(fact_59_ord_Olmerge_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ A @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.exhaust
thf(fact_60_ord__class_Olmerge_Oexhaust,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ~ ( ( coinductive_lnull @ A @ Xs )
              | ( coinductive_lnull @ A @ Ys ) )
         => ~ ( ~ ( coinductive_lnull @ A @ Xs )
             => ( coinductive_lnull @ A @ Ys ) ) ) ) )).

% ord_class.lmerge.exhaust
thf(fact_61_mono2mono__LCons,axiom,(
    ! [A: $tType,C2: $tType,Orda: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ A ) ),X5: A] :
      ( ( comple1396247847notone @ C2 @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A ) @ T )
     => ( comple1396247847notone @ C2 @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A )
        @ ^ [X: C2] :
            ( coinductive_LCons @ A @ X5 @ ( T @ X ) ) ) ) )).

% mono2mono_LCons
thf(fact_62_llist_Omonotone__if__bot,axiom,(
    ! [B: $tType,A: $tType,Bound: ( coinductive_llist @ A ),G: ( ( coinductive_llist @ A ) > B ),Bot: B,F: ( ( coinductive_llist @ A ) > B ),Ord: ( B > B > $o )] :
      ( ! [X2: ( coinductive_llist @ A )] :
          ( ( ( coinductive_lprefix @ A @ X2 @ Bound )
           => ( ( G @ X2 )
              = Bot ) )
          & ( ~ ( coinductive_lprefix @ A @ X2 @ Bound )
           => ( ( G @ X2 )
              = ( F @ X2 ) ) ) )
     => ( ! [X2: ( coinductive_llist @ A ),Y: ( coinductive_llist @ A )] :
            ( ( coinductive_lprefix @ A @ X2 @ Y )
           => ( ~ ( coinductive_lprefix @ A @ X2 @ Bound )
             => ( Ord @ ( F @ X2 ) @ ( F @ Y ) ) ) )
       => ( ! [X2: ( coinductive_llist @ A )] :
              ( ~ ( coinductive_lprefix @ A @ X2 @ Bound )
             => ( Ord @ Bot @ ( F @ X2 ) ) )
         => ( ( Ord @ Bot @ Bot )
           => ( comple1396247847notone @ ( coinductive_llist @ A ) @ B @ ( coinductive_lprefix @ A ) @ Ord @ G ) ) ) ) ) )).

% llist.monotone_if_bot
thf(fact_63_ord_Olmerge_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) )
     => ( ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys )
        = ( coinductive_LNil @ A ) ) ) )).

% ord.lmerge.ctr(1)
thf(fact_64_lprefix__not__lnullD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lprefix_not_lnullD
thf(fact_65_lprefix__lnullD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( coinductive_lnull @ A @ Xs ) ) ) )).

% lprefix_lnullD
thf(fact_66_lprefix__lnull,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_lprefix @ A @ Xs @ Ys )
        = ( coinductive_lnull @ A @ Xs ) ) ) )).

% lprefix_lnull
thf(fact_67_lnull__lprefix,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lprefix @ A @ Xs @ Ys ) ) )).

% lnull_lprefix
thf(fact_68_LCons__lprefix__conv,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ Ys )
      = ( ? [Ys6: ( coinductive_llist @ A )] :
            ( ( Ys
              = ( coinductive_LCons @ A @ X3 @ Ys6 ) )
            & ( coinductive_lprefix @ A @ Xs @ Ys6 ) ) ) ) )).

% LCons_lprefix_conv
thf(fact_69_Le__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X3: A] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ X3 @ Ys ) ) ) )).

% Le_LCons
thf(fact_70_lSup_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,A3: ( set @ ( coinductive_llist @ A ) )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lSup @ A @ A3 ) )
      = ( ! [X: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X @ A3 )
           => ( coinductive_lnull @ A @ X ) ) ) ) )).

% lSup.disc_iff(2)
thf(fact_71_lSup_Odisc_I1_J,axiom,(
    ! [A: $tType,A3: ( set @ ( coinductive_llist @ A ) )] :
      ( ! [X2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ X2 @ A3 )
         => ( coinductive_lnull @ A @ X2 ) )
     => ( coinductive_lnull @ A @ ( coinductive_lSup @ A @ A3 ) ) ) )).

% lSup.disc(1)
thf(fact_72_lSup_Odisc_I2_J,axiom,(
    ! [A: $tType,A3: ( set @ ( coinductive_llist @ A ) )] :
      ( ~ ( ! [X6: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ X6 @ A3 )
             => ( coinductive_lnull @ A @ X6 ) ) )
     => ~ ( coinductive_lnull @ A @ ( coinductive_lSup @ A @ A3 ) ) ) )).

% lSup.disc(2)
thf(fact_73_LNil__lprefix,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% LNil_lprefix
thf(fact_74_llist_Oconst__mono,axiom,(
    ! [A: $tType,B: $tType,Ord: ( B > B > $o ),C: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ B @ ( coinductive_llist @ A ) @ Ord @ ( coinductive_lprefix @ A )
      @ ^ [F2: B] : C ) )).

% llist.const_mono
thf(fact_75_ord_Olnull__lmerge,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lnull_lmerge
thf(fact_76_ord_Olmerge_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.disc_iff(2)
thf(fact_77_ord_Olmerge_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) )
     => ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) )).

% ord.lmerge.disc(1)
thf(fact_78_ord_Olmerge_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lmerge.disc(2)
thf(fact_79_ord_Olmerge__simps,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y2: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( Less @ X3 @ Y2 )
       => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
          = ( coinductive_LCons @ A @ X3 @ ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_LCons @ A @ Y2 @ Ys ) ) ) ) )
      & ( ~ ( Less @ X3 @ Y2 )
       => ( ( ( Less @ Y2 @ X3 )
           => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
              = ( coinductive_LCons @ A @ Y2 @ ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X3 @ Xs ) @ Ys ) ) ) )
          & ( ~ ( Less @ Y2 @ X3 )
           => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
              = ( coinductive_LCons @ A @ Y2 @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) ) ) ) )).

% ord.lmerge_simps
thf(fact_80_ord_Olmerge__eq__LNil__iff,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% ord.lmerge_eq_LNil_iff
thf(fact_81_ord_Olmerge__LNil_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LNil @ A ) @ Ys )
      = ( coinductive_LNil @ A ) ) )).

% ord.lmerge_LNil(1)
thf(fact_82_ord_Olmerge__LNil_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ord.lmerge_LNil(2)
thf(fact_83_mcont__LCons,axiom,(
    ! [A: $tType,X3: A] :
      ( comple1403672095_mcont @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_LCons @ A @ X3 ) ) )).

% mcont_LCons
thf(fact_84_ord_Omono2mono__lmerge2,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ A ) @ ( hammin1328233080lmerge @ A @ Less @ Xs ) ) )).

% ord.mono2mono_lmerge2
thf(fact_85_ord_Omono2mono__lmerge1,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ A )
      @ ^ [Xs3: ( coinductive_llist @ A )] :
          ( hammin1328233080lmerge @ A @ Less @ Xs3 @ Ys ) ) )).

% ord.mono2mono_lmerge1
thf(fact_86_mcont2mcont__LCons,axiom,(
    ! [A: $tType,C2: $tType,Lub: ( ( set @ C2 ) > C2 ),Ord: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ A ) ),X5: A] :
      ( ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ T )
     => ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
        @ ^ [X: C2] :
            ( coinductive_LCons @ A @ X5 @ ( T @ X ) ) ) ) )).

% mcont2mcont_LCons
thf(fact_87_lprefix__down__linear,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Zs )
     => ( ( coinductive_lprefix @ A @ Ys @ Zs )
       => ( ( coinductive_lprefix @ A @ Xs @ Ys )
          | ( coinductive_lprefix @ A @ Ys @ Xs ) ) ) ) )).

% lprefix_down_linear
thf(fact_88_llist_Oleq__antisym,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),Y2: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X3 @ Y2 )
     => ( ( coinductive_lprefix @ A @ Y2 @ X3 )
       => ( X3 = Y2 ) ) ) )).

% llist.leq_antisym
thf(fact_89_lprefix__antisym,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lprefix @ A @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% lprefix_antisym
thf(fact_90_llist_Oleq__trans,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),Y2: ( coinductive_llist @ A ),Z: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X3 @ Y2 )
     => ( ( coinductive_lprefix @ A @ Y2 @ Z )
       => ( coinductive_lprefix @ A @ X3 @ Z ) ) ) )).

% llist.leq_trans
thf(fact_91_lprefix__trans,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lprefix @ A @ Ys @ Zs )
       => ( coinductive_lprefix @ A @ Xs @ Zs ) ) ) )).

% lprefix_trans
thf(fact_92_lhd__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
              = ( coinductive_lhd @ a @ Xs ) ) )
          & ( ~ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
              = ( coinductive_lhd @ a @ Ys ) ) ) ) ) ) )).

% lhd_lmerge
thf(fact_93_mcont__mono,axiom,(
    ! [B: $tType,A: $tType,Luba: ( ( set @ A ) > A ),Orda: ( A > A > $o ),Lubb: ( ( set @ B ) > B ),Ordb: ( B > B > $o ),F: ( A > B )] :
      ( ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb @ F )
     => ( comple1396247847notone @ A @ B @ Orda @ Ordb @ F ) ) )).

% mcont_mono
thf(fact_94_in__lset__lmergeD,axiom,(
    ! [X3: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( member @ a @ X3 @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) )
     => ( ( member @ a @ X3 @ ( coinductive_lset @ a @ Xs ) )
        | ( member @ a @ X3 @ ( coinductive_lset @ a @ Ys ) ) ) ) )).

% in_lset_lmergeD
thf(fact_95_local_Olexordp__eq__refl,axiom,(
    ! [Xs: ( list @ a )] :
      ( lexordp_eq @ a @ less @ Xs @ Xs ) )).

% local.lexordp_eq_refl
thf(fact_96_lfinite__lmergeD,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
     => ( ( coinductive_lfinite @ a @ Xs )
        | ( coinductive_lfinite @ a @ Ys ) ) ) )).

% lfinite_lmergeD
thf(fact_97_local_OgreaterThanLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr1161524159ssThan @ a @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.greaterThanLessThan_iff
thf(fact_98_ord_OlessThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_lessThan @ A )
      = ( ^ [Less2: ( A > A > $o ),U2: A] :
            ( collect @ A
            @ ^ [X: A] :
                ( Less2 @ X @ U2 ) ) ) ) )).

% ord.lessThan_def
thf(fact_99_ord_OgreaterThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_greaterThan @ A )
      = ( ^ [Less2: ( A > A > $o ),L2: A] :
            ( collect @ A @ ( Less2 @ L2 ) ) ) ) )).

% ord.greaterThan_def
thf(fact_100_local_OgreaterThanLessThan__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ A2 ) @ ( set_lessThan @ a @ less @ B2 ) ) ) )).

% local.greaterThanLessThan_eq
thf(fact_101_local_OgreaterThanLessThan__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ L ) @ ( set_lessThan @ a @ less @ U ) ) ) )).

% local.greaterThanLessThan_def
thf(fact_102_lfinite__LCons,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_103_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X3: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X3 @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_104_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_105_llist_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( member @ A @ ( coinductive_lhd @ A @ A2 ) @ ( coinductive_lset @ A @ A2 ) ) ) )).

% llist.set_sel(1)
thf(fact_106_ord_OgreaterThanLessThan__iff,axiom,(
    ! [A: $tType,I: A,Less: ( A > A > $o ),L: A,U: A] :
      ( ( member @ A @ I @ ( set_gr1161524159ssThan @ A @ Less @ L @ U ) )
      = ( ( Less @ L @ I )
        & ( Less @ I @ U ) ) ) )).

% ord.greaterThanLessThan_iff
thf(fact_107_lprefix__lfiniteD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lprefix_lfiniteD
thf(fact_108_not__lfinite__lprefix__conv__eq,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lprefix @ A @ Xs @ Ys )
        = ( Xs = Ys ) ) ) )).

% not_lfinite_lprefix_conv_eq
thf(fact_109_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X3: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_110_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_111_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_112_lfinite__lSupD,axiom,(
    ! [A: $tType,A3: ( set @ ( coinductive_llist @ A ) )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lSup @ A @ A3 ) )
     => ! [X6: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ X6 @ A3 )
         => ( coinductive_lfinite @ A @ X6 ) ) ) )).

% lfinite_lSupD
thf(fact_113_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_114_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_115_llist_Oset__induct,axiom,(
    ! [A: $tType,X3: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( coinductive_llist @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( coinductive_lset @ A @ Z2 ) )
             => ( ( P @ Xa2 @ Z2 )
               => ( P @ Xa2 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P @ X3 @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_116_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z2: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z2 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_117_lset__induct_H,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs4: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X3 @ Xs4 ) )
       => ( ! [X7: A,Xs4: ( coinductive_llist @ A )] :
              ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs4 ) )
             => ( ( P @ Xs4 )
               => ( P @ ( coinductive_LCons @ A @ X7 @ Xs4 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_118_lset__induct,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs4: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X3 @ Xs4 ) )
       => ( ! [X7: A,Xs4: ( coinductive_llist @ A )] :
              ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs4 ) )
             => ( ( X3 != X7 )
               => ( ( P @ Xs4 )
                 => ( P @ ( coinductive_LCons @ A @ X7 @ Xs4 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_119_lset__cases,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs7: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X3 @ Xs7 ) )
       => ~ ( ! [X7: A,Xs7: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X7 @ Xs7 ) )
               => ~ ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs7 ) ) ) ) ) ) )).

% lset_cases
thf(fact_120_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_121_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X3: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_122_lset__intros_I1_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X3 @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_123_lset__intros_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),X8: A] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X8 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_124_ord_Olfinite__lmergeD,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
     => ( ( coinductive_lfinite @ A @ Xs )
        | ( coinductive_lfinite @ A @ Ys ) ) ) )).

% ord.lfinite_lmergeD
thf(fact_125_ord_Oin__lset__lmergeD,axiom,(
    ! [A: $tType,X3: A,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) )
     => ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
        | ( member @ A @ X3 @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% ord.in_lset_lmergeD
thf(fact_126_ord_OgreaterThanLessThan__def,axiom,(
    ! [A: $tType] :
      ( ( set_gr1161524159ssThan @ A )
      = ( ^ [Less2: ( A > A > $o ),L2: A,U2: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ L2 ) @ ( set_lessThan @ A @ Less2 @ U2 ) ) ) ) )).

% ord.greaterThanLessThan_def
thf(fact_127_ord_OgreaterThanLessThan__eq,axiom,(
    ! [A: $tType] :
      ( ( set_gr1161524159ssThan @ A )
      = ( ^ [Less2: ( A > A > $o ),A4: A,B3: A] :
            ( inf_inf @ ( set @ A ) @ ( set_greaterThan @ A @ Less2 @ A4 ) @ ( set_lessThan @ A @ Less2 @ B3 ) ) ) ) )).

% ord.greaterThanLessThan_eq
thf(fact_128_lfinite_Oinducts,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X3 )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs4: ( coinductive_llist @ A ),X2: A] :
              ( ( coinductive_lfinite @ A @ Xs4 )
             => ( ( P @ Xs4 )
               => ( P @ ( coinductive_LCons @ A @ X2 @ Xs4 ) ) ) )
         => ( P @ X3 ) ) ) ) )).

% lfinite.inducts
thf(fact_129_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A4: ( coinductive_llist @ A )] :
            ( ( A4
              = ( coinductive_LNil @ A ) )
            | ? [Xs3: ( coinductive_llist @ A ),X: A] :
                ( ( A4
                  = ( coinductive_LCons @ A @ X @ Xs3 ) )
                & ( coinductive_lfinite @ A @ Xs3 ) ) ) ) ) )).

% lfinite.simps
thf(fact_130_lfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs4: ( coinductive_llist @ A )] :
                ( ? [X2: A] :
                    ( A2
                    = ( coinductive_LCons @ A @ X2 @ Xs4 ) )
               => ~ ( coinductive_lfinite @ A @ Xs4 ) ) ) ) ) )).

% lfinite.cases
thf(fact_131_lprefix__lhdD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_lhd @ A @ Xs )
          = ( coinductive_lhd @ A @ Ys ) ) ) ) )).

% lprefix_lhdD
thf(fact_132_ord_Olhd__lmerge,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
              = ( coinductive_lhd @ A @ Xs ) ) )
          & ( ~ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
              = ( coinductive_lhd @ A @ Ys ) ) ) ) ) ) )).

% ord.lhd_lmerge
thf(fact_133_lSup__finite__prefixes,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lSup @ A
        @ ( collect @ ( coinductive_llist @ A )
          @ ^ [Ys4: ( coinductive_llist @ A )] :
              ( ( coinductive_lprefix @ A @ Ys4 @ Xs )
              & ( coinductive_lfinite @ A @ Ys4 ) ) ) )
      = Xs ) )).

% lSup_finite_prefixes
thf(fact_134_lSup__strict__prefixes,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lSup @ A
          @ ( collect @ ( coinductive_llist @ A )
            @ ^ [Ys4: ( coinductive_llist @ A )] :
                ( ( coinductive_lprefix @ A @ Ys4 @ Xs )
                & ( Ys4 != Xs ) ) ) )
        = Xs ) ) )).

% lSup_strict_prefixes
thf(fact_135_lSup__finite__gen__prefixes,axiom,(
    ! [A: $tType,Zs: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Zs @ Xs )
     => ( ( coinductive_lfinite @ A @ Zs )
       => ( ( coinductive_lSup @ A
            @ ( collect @ ( coinductive_llist @ A )
              @ ^ [Ys4: ( coinductive_llist @ A )] :
                  ( ( coinductive_lprefix @ A @ Ys4 @ Xs )
                  & ( coinductive_lprefix @ A @ Zs @ Ys4 )
                  & ( coinductive_lfinite @ A @ Ys4 ) ) ) )
          = Xs ) ) ) )).

% lSup_finite_gen_prefixes
thf(fact_136_mcont__monoD,axiom,(
    ! [B: $tType,A: $tType,Luba: ( ( set @ A ) > A ),Orda: ( A > A > $o ),Lubb: ( ( set @ B ) > B ),Ordb: ( B > B > $o ),F: ( A > B ),X3: A,Y2: A] :
      ( ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb @ F )
     => ( ( Orda @ X3 @ Y2 )
       => ( Ordb @ ( F @ X3 ) @ ( F @ Y2 ) ) ) ) )).

% mcont_monoD
thf(fact_137_ord_OgreaterThan__iff,axiom,(
    ! [A: $tType,I: A,Less: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_greaterThan @ A @ Less @ K ) )
      = ( Less @ K @ I ) ) )).

% ord.greaterThan_iff
thf(fact_138_ord_OlessThan__iff,axiom,(
    ! [A: $tType,I: A,Less: ( A > A > $o ),K: A] :
      ( ( member @ A @ I @ ( set_lessThan @ A @ Less @ K ) )
      = ( Less @ I @ K ) ) )).

% ord.lessThan_iff
thf(fact_139_monotone__id_H,axiom,(
    ! [A: $tType,Ord: ( A > A > $o )] :
      ( comple1396247847notone @ A @ A @ Ord @ Ord
      @ ^ [X: A] : X ) )).

% monotone_id'
thf(fact_140_mcont__if,axiom,(
    ! [B: $tType,A: $tType,Luba: ( ( set @ A ) > A ),Orda: ( A > A > $o ),Lubb: ( ( set @ B ) > B ),Ordb: ( B > B > $o ),F: ( A > B ),G: ( A > B ),C: $o] :
      ( ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb @ F )
     => ( ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb @ G )
       => ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb
          @ ^ [X: A] :
              ( if @ B @ C @ ( F @ X ) @ ( G @ X ) ) ) ) ) )).

% mcont_if
thf(fact_141_mcont__id_H,axiom,(
    ! [A: $tType,Lub: ( ( set @ A ) > A ),Ord: ( A > A > $o )] :
      ( comple1403672095_mcont @ A @ A @ Lub @ Ord @ Lub @ Ord
      @ ^ [X: A] : X ) )).

% mcont_id'
thf(fact_142_lmerge_Ocode,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
      = ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
        @ ^ [X: a,Xs5: ( coinductive_llist @ a )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( coinductive_LNil @ a )
            @ ^ [Y3: a,Ys6: ( coinductive_llist @ a )] :
                ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) ) @ ( coinductive_LCons @ a @ X @ ( hammin1328233080lmerge @ a @ less @ Xs5 @ Ys ) ) @ ( coinductive_LCons @ a @ Y3 @ ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys6 ) @ ( hammin1328233080lmerge @ a @ less @ Xs5 @ Ys6 ) ) ) )
            @ Ys )
        @ Xs ) ) )).

% lmerge.code
thf(fact_143_ltl__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
              = ( hammin1328233080lmerge @ a @ less @ ( coinductive_ltl @ a @ Xs ) @ Ys ) ) )
          & ( ~ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) )
               => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_ltl @ a @ Ys ) ) ) )
              & ( ~ ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) )
               => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ a @ less @ ( coinductive_ltl @ a @ Xs ) @ ( coinductive_ltl @ a @ Ys ) ) ) ) ) ) ) ) ) )).

% ltl_lmerge
thf(fact_144_local_Olexordp__eq_ONil,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq.Nil
thf(fact_145_Int__iff,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = ( ( member @ A @ C @ A3 )
        & ( member @ A @ C @ B4 ) ) ) )).

% Int_iff
thf(fact_146_IntI,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ A3 )
     => ( ( member @ A @ C @ B4 )
       => ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) ) ) )).

% IntI
thf(fact_147_lfinite__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_ltl @ A @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_ltl
thf(fact_148_lhd__LCons__ltl,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ Llist )
     => ( ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) )
        = Llist ) ) )).

% lhd_LCons_ltl
thf(fact_149_local_Olexordp__eq__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq_simps(1)
thf(fact_150_local_Olexordp__eq__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ ( nil @ a ) )
      = ( Xs
        = ( nil @ a ) ) ) )).

% local.lexordp_eq_simps(2)
thf(fact_151_in__lset__ltlD,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) )
     => ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ltlD
thf(fact_152_llist_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( coindu1381640503_llist @ B @ A )
      = ( ^ [F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),Llist2: ( coinductive_llist @ A )] :
            ( if @ B @ ( coinductive_lnull @ A @ Llist2 ) @ F1 @ ( F22 @ ( coinductive_lhd @ A @ Llist2 ) @ ( coinductive_ltl @ A @ Llist2 ) ) ) ) ) )).

% llist.case_eq_if
thf(fact_153_ltl__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A )
      = ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
        @ ^ [X213: A,X223: ( coinductive_llist @ A )] : X223 ) ) )).

% ltl_def
thf(fact_154_llist_Ocase__distrib,axiom,(
    ! [B: $tType,C2: $tType,A: $tType,H: ( B > C2 ),F12: B,F23: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( H @ ( coindu1381640503_llist @ B @ A @ F12 @ F23 @ Llist ) )
      = ( coindu1381640503_llist @ C2 @ A @ ( H @ F12 )
        @ ^ [X1: A,X23: ( coinductive_llist @ A )] :
            ( H @ ( F23 @ X1 @ X23 ) )
        @ Llist ) ) )).

% llist.case_distrib
thf(fact_155_lprefix__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ A @ Ys ) ) ) )).

% lprefix_ltlI
thf(fact_156_ltl__simps_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_ltl @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X22 ) )).

% ltl_simps(2)
thf(fact_157_lnull__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% lnull_ltlI
thf(fact_158_ltl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltl_simps(1)
thf(fact_159_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F12: B,F23: ( A > ( coinductive_llist @ A ) > B ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F12 @ F23 @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = ( F23 @ X21 @ X22 ) ) )).

% llist.simps(5)
thf(fact_160_llist_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F12: B,F23: ( A > ( coinductive_llist @ A ) > B )] :
      ( ( coindu1381640503_llist @ B @ A @ F12 @ F23 @ ( coinductive_LNil @ A ) )
      = F12 ) )).

% llist.simps(4)
thf(fact_161_llist_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F12: B,F23: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( P @ ( coindu1381640503_llist @ B @ A @ F12 @ F23 @ Llist ) )
      = ( ( ( Llist
            = ( coinductive_LNil @ A ) )
         => ( P @ F12 ) )
        & ( ( Llist
            = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) )
         => ( P @ ( F23 @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) ) ) )).

% llist.split_sel
thf(fact_162_llist_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F12: B,F23: ( A > ( coinductive_llist @ A ) > B ),Llist: ( coinductive_llist @ A )] :
      ( ( P @ ( coindu1381640503_llist @ B @ A @ F12 @ F23 @ Llist ) )
      = ( ~ ( ( ( Llist
                = ( coinductive_LNil @ A ) )
              & ~ ( P @ F12 ) )
            | ( ( Llist
                = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) )
              & ~ ( P @ ( F23 @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) ) ) ) )).

% llist.split_sel_asm
thf(fact_163_llist__case__mono,axiom,(
    ! [C2: $tType,B: $tType,A: $tType,Orda: ( A > A > $o ),Ordb: ( B > B > $o ),Lnil: ( A > B ),Lcons: ( A > C2 > ( coinductive_llist @ C2 ) > B ),X3: ( coinductive_llist @ C2 )] :
      ( ( comple1396247847notone @ A @ B @ Orda @ Ordb @ Lnil )
     => ( ! [X2: C2,Xs4: ( coinductive_llist @ C2 )] :
            ( comple1396247847notone @ A @ B @ Orda @ Ordb
            @ ^ [F2: A] :
                ( Lcons @ F2 @ X2 @ Xs4 ) )
       => ( comple1396247847notone @ A @ B @ Orda @ Ordb
          @ ^ [F2: A] :
              ( coindu1381640503_llist @ B @ C2 @ ( Lnil @ F2 ) @ ( Lcons @ F2 ) @ X3 ) ) ) ) )).

% llist_case_mono
thf(fact_164_mcont__llist__case,axiom,(
    ! [C2: $tType,B: $tType,A: $tType,Luba: ( ( set @ A ) > A ),Orda: ( A > A > $o ),Lubb: ( ( set @ B ) > B ),Ordb: ( B > B > $o ),F: ( A > B ),G: ( C2 > ( coinductive_llist @ C2 ) > A > B ),Xs: ( coinductive_llist @ C2 )] :
      ( ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb @ F )
     => ( ! [X2: C2,Xs4: ( coinductive_llist @ C2 )] :
            ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb @ ( G @ X2 @ Xs4 ) )
       => ( comple1403672095_mcont @ A @ B @ Luba @ Orda @ Lubb @ Ordb
          @ ^ [Y3: A] :
              ( coindu1381640503_llist @ B @ C2 @ ( F @ Y3 )
              @ ^ [X: C2,Xs5: ( coinductive_llist @ C2 )] :
                  ( G @ X @ Xs5 @ Y3 )
              @ Xs ) ) ) ) )).

% mcont_llist_case
thf(fact_165_llist_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( R @ Llist @ Llist3 )
     => ( ! [Llist4: ( coinductive_llist @ A ),Llist5: ( coinductive_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coinductive_lnull @ A @ Llist4 )
                = ( coinductive_lnull @ A @ Llist5 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist4 )
               => ( ~ ( coinductive_lnull @ A @ Llist5 )
                 => ( ( ( coinductive_lhd @ A @ Llist4 )
                      = ( coinductive_lhd @ A @ Llist5 ) )
                    & ( ( R @ ( coinductive_ltl @ A @ Llist4 ) @ ( coinductive_ltl @ A @ Llist5 ) )
                      | ( ( coinductive_ltl @ A @ Llist4 )
                        = ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.coinduct_strong
thf(fact_166_llist_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( R @ Llist @ Llist3 )
     => ( ! [Llist4: ( coinductive_llist @ A ),Llist5: ( coinductive_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coinductive_lnull @ A @ Llist4 )
                = ( coinductive_lnull @ A @ Llist5 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist4 )
               => ( ~ ( coinductive_lnull @ A @ Llist5 )
                 => ( ( ( coinductive_lhd @ A @ Llist4 )
                      = ( coinductive_lhd @ A @ Llist5 ) )
                    & ( R @ ( coinductive_ltl @ A @ Llist4 ) @ ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.coinduct
thf(fact_167_llist_Oexpand,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Llist )
        = ( coinductive_lnull @ A @ Llist3 ) )
     => ( ( ~ ( coinductive_lnull @ A @ Llist )
         => ( ~ ( coinductive_lnull @ A @ Llist3 )
           => ( ( ( coinductive_lhd @ A @ Llist )
                = ( coinductive_lhd @ A @ Llist3 ) )
              & ( ( coinductive_ltl @ A @ Llist )
                = ( coinductive_ltl @ A @ Llist3 ) ) ) ) )
       => ( Llist = Llist3 ) ) ) )).

% llist.expand
thf(fact_168_llist_Oset__sel_I2_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),X3: A] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( ( member @ A @ X3 @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ A2 ) ) )
       => ( member @ A @ X3 @ ( coinductive_lset @ A @ A2 ) ) ) ) )).

% llist.set_sel(2)
thf(fact_169_lfinite__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ! [Xs4: ( coinductive_llist @ A )] :
            ( ( coinductive_lnull @ A @ Xs4 )
           => ( P @ Xs4 ) )
       => ( ! [Xs4: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs4 )
             => ( ~ ( coinductive_lnull @ A @ Xs4 )
               => ( ( P @ ( coinductive_ltl @ A @ Xs4 ) )
                 => ( P @ Xs4 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lfinite_induct
thf(fact_170_monotone__ltl,axiom,(
    ! [A: $tType] :
      ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_ltl @ A ) ) )).

% monotone_ltl
thf(fact_171_mono2mono__ltl,axiom,(
    ! [A: $tType,C2: $tType,Orda: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ A ) )] :
      ( ( comple1396247847notone @ C2 @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A ) @ T )
     => ( comple1396247847notone @ C2 @ ( coinductive_llist @ A ) @ Orda @ ( coinductive_lprefix @ A )
        @ ^ [X: C2] :
            ( coinductive_ltl @ A @ ( T @ X ) ) ) ) )).

% mono2mono_ltl
thf(fact_172_lprefix__expand,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ~ ( coinductive_lnull @ A @ Ys )
          & ( ( coinductive_lhd @ A @ Xs )
            = ( coinductive_lhd @ A @ Ys ) )
          & ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ A @ Ys ) ) ) )
     => ( coinductive_lprefix @ A @ Xs @ Ys ) ) )).

% lprefix_expand
thf(fact_173_lprefix__coinduct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( P @ Xs @ Ys )
     => ( ! [Xs4: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
            ( ( P @ Xs4 @ Ys3 )
           => ( ( ( coinductive_lnull @ A @ Ys3 )
               => ( coinductive_lnull @ A @ Xs4 ) )
              & ( ~ ( coinductive_lnull @ A @ Xs4 )
               => ( ~ ( coinductive_lnull @ A @ Ys3 )
                 => ( ( ( coinductive_lhd @ A @ Xs4 )
                      = ( coinductive_lhd @ A @ Ys3 ) )
                    & ( ( P @ ( coinductive_ltl @ A @ Xs4 ) @ ( coinductive_ltl @ A @ Ys3 ) )
                      | ( coinductive_lprefix @ A @ ( coinductive_ltl @ A @ Xs4 ) @ ( coinductive_ltl @ A @ Ys3 ) ) ) ) ) ) ) )
       => ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) )).

% lprefix_coinduct
thf(fact_174_eq__LConsD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( Xs
        = ( coinductive_LCons @ A @ Y2 @ Ys ) )
     => ( ( Xs
         != ( coinductive_LNil @ A ) )
        & ( ( coinductive_lhd @ A @ Xs )
          = Y2 )
        & ( ( coinductive_ltl @ A @ Xs )
          = Ys ) ) ) )).

% eq_LConsD
thf(fact_175_llist_Oexhaust__sel,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
       != ( coinductive_LNil @ A ) )
     => ( Llist
        = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist ) @ ( coinductive_ltl @ A @ Llist ) ) ) ) )).

% llist.exhaust_sel
thf(fact_176_llist__set__induct,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs4: ( coinductive_llist @ A )] :
            ( ~ ( coinductive_lnull @ A @ Xs4 )
           => ( P @ ( coinductive_lhd @ A @ Xs4 ) @ Xs4 ) )
       => ( ! [Xs4: ( coinductive_llist @ A ),Y: A] :
              ( ~ ( coinductive_lnull @ A @ Xs4 )
             => ( ( member @ A @ Y @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs4 ) ) )
               => ( ( P @ Y @ ( coinductive_ltl @ A @ Xs4 ) )
                 => ( P @ Y @ Xs4 ) ) ) )
         => ( P @ X3 @ Xs ) ) ) ) )).

% llist_set_induct
thf(fact_177_ord_Oltl__lmerge,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
              = ( hammin1328233080lmerge @ A @ Less @ ( coinductive_ltl @ A @ Xs ) @ Ys ) ) )
          & ( ~ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) )
               => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_ltl @ A @ Ys ) ) ) )
              & ( ~ ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) )
               => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ A @ Less @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ A @ Ys ) ) ) ) ) ) ) ) ) )).

% ord.ltl_lmerge
thf(fact_178_mcont__ltl,axiom,(
    ! [A: $tType] :
      ( comple1403672095_mcont @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_ltl @ A ) ) )).

% mcont_ltl
thf(fact_179_mcont2mcont__ltl,axiom,(
    ! [A: $tType,C2: $tType,Lub: ( ( set @ C2 ) > C2 ),Ord: ( C2 > C2 > $o ),T: ( C2 > ( coinductive_llist @ A ) )] :
      ( ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ T )
     => ( comple1403672095_mcont @ C2 @ ( coinductive_llist @ A ) @ Lub @ Ord @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A )
        @ ^ [X: C2] :
            ( coinductive_ltl @ A @ ( T @ X ) ) ) ) )).

% mcont2mcont_ltl
thf(fact_180_IntE,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ~ ( ( member @ A @ C @ A3 )
         => ~ ( member @ A @ C @ B4 ) ) ) )).

% IntE
thf(fact_181_IntD1,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C @ A3 ) ) )).

% IntD1
thf(fact_182_IntD2,axiom,(
    ! [A: $tType,C: A,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
     => ( member @ A @ C @ B4 ) ) )).

% IntD2
thf(fact_183_Int__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Int_assoc
thf(fact_184_Int__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Int_absorb
thf(fact_185_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Int_commute
thf(fact_186_Int__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ A3 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A3 @ B4 ) ) )).

% Int_left_absorb
thf(fact_187_Int__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( inf_inf @ ( set @ A ) @ B4 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ B4 @ ( inf_inf @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% Int_left_commute
thf(fact_188_ord_Olmerge_Ocode,axiom,(
    ! [A: $tType] :
      ( ( hammin1328233080lmerge @ A )
      = ( ^ [Less2: ( A > A > $o ),Xs3: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
            @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( coinductive_LNil @ A )
                @ ^ [Y3: A,Ys6: ( coinductive_llist @ A )] :
                    ( if @ ( coinductive_llist @ A ) @ ( Less2 @ ( coinductive_lhd @ A @ Xs3 ) @ ( coinductive_lhd @ A @ Ys4 ) ) @ ( coinductive_LCons @ A @ X @ ( hammin1328233080lmerge @ A @ Less2 @ Xs5 @ Ys4 ) ) @ ( coinductive_LCons @ A @ Y3 @ ( if @ ( coinductive_llist @ A ) @ ( Less2 @ ( coinductive_lhd @ A @ Ys4 ) @ ( coinductive_lhd @ A @ Xs3 ) ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs3 @ Ys6 ) @ ( hammin1328233080lmerge @ A @ Less2 @ Xs5 @ Ys6 ) ) ) )
                @ Ys4 )
            @ Xs3 ) ) ) )).

% ord.lmerge.code
thf(fact_189_monotone__lprefix__case,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ B ) )] :
      ( ! [X2: A] :
          ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ B )
          @ ^ [Xs3: ( coinductive_llist @ A )] :
              ( F @ X2 @ Xs3 @ ( coinductive_LCons @ A @ X2 @ Xs3 ) ) )
     => ( comple1396247847notone @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lprefix @ B )
        @ ^ [Xs3: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ B ) @ A @ ( coinductive_LNil @ B )
            @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                ( F @ X @ Xs5 @ Xs3 )
            @ Xs3 ) ) ) )).

% monotone_lprefix_case
thf(fact_190_Int__def,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( collect @ A
            @ ^ [X: A] :
                ( ( member @ A @ X @ A5 )
                & ( member @ A @ X @ B5 ) ) ) ) ) )).

% Int_def
thf(fact_191_Int__Collect,axiom,(
    ! [A: $tType,X3: A,A3: ( set @ A ),P: ( A > $o )] :
      ( ( member @ A @ X3 @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) )
      = ( ( member @ A @ X3 @ A3 )
        & ( P @ X3 ) ) ) )).

% Int_Collect
thf(fact_192_Collect__conj__eq,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( ( P @ X )
            & ( Q @ X ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_conj_eq
thf(fact_193_mcont__lprefix__case,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ B ) )] :
      ( ! [X2: A] :
          ( comple1403672095_mcont @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lSup @ B ) @ ( coinductive_lprefix @ B )
          @ ^ [Xs3: ( coinductive_llist @ A )] :
              ( F @ X2 @ Xs3 @ ( coinductive_LCons @ A @ X2 @ Xs3 ) ) )
     => ( comple1403672095_mcont @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_lSup @ A ) @ ( coinductive_lprefix @ A ) @ ( coinductive_lSup @ B ) @ ( coinductive_lprefix @ B )
        @ ^ [Xs3: ( coinductive_llist @ A )] :
            ( coindu1381640503_llist @ ( coinductive_llist @ B ) @ A @ ( coinductive_LNil @ B )
            @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                ( F @ X @ Xs5 @ Xs3 )
            @ Xs3 ) ) ) )).

% mcont_lprefix_case
thf(fact_194_lmerge_Osimps_I4_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
          = ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
            @ ^ [X: a,Xs5: ( coinductive_llist @ a )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
                @ ^ [Y3: a,Ys6: ( coinductive_llist @ a )] :
                    ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs5 @ Ys ) @ ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys6 ) @ ( hammin1328233080lmerge @ a @ less @ Xs5 @ Ys6 ) ) )
                @ Ys )
            @ Xs ) ) ) ) )).

% lmerge.simps(4)
thf(fact_195_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_196_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_197_llist_Odisc__eq__case_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( coindu1381640503_llist @ $o @ A @ $true
        @ ^ [Uu: A,Uv: ( coinductive_llist @ A )] : $false ) ) )).

% llist.disc_eq_case(1)
thf(fact_198_llist_Odisc__eq__case_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Llist ) )
      = ( coindu1381640503_llist @ $o @ A @ $false
        @ ^ [Uu: A,Uv: ( coinductive_llist @ A )] : $true
        @ Llist ) ) )).

% llist.disc_eq_case(2)
thf(fact_199_lhd__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lhd @ A )
      = ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
        @ ^ [X213: A,X223: ( coinductive_llist @ A )] : X213 ) ) )).

% lhd_def
thf(fact_200_ord_Olmerge_Octr_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys )
          = ( coinductive_LCons @ A
            @ ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
              @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                  ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
                  @ ^ [Y3: A,Ys6: ( coinductive_llist @ A )] :
                      ( if @ A @ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) ) @ X @ Y3 )
                  @ Ys )
              @ Xs )
            @ ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
              @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                  ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
                  @ ^ [Y3: A,Ys6: ( coinductive_llist @ A )] :
                      ( if @ ( coinductive_llist @ A ) @ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) ) @ ( hammin1328233080lmerge @ A @ Less @ Xs5 @ Ys ) @ ( if @ ( coinductive_llist @ A ) @ ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) ) @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys6 ) @ ( hammin1328233080lmerge @ A @ Less @ Xs5 @ Ys6 ) ) )
                  @ Ys )
              @ Xs ) ) ) ) ) )).

% ord.lmerge.ctr(2)
thf(fact_201_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_202_ord_Olmerge_Osimps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
          = ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
            @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                ( coindu1381640503_llist @ A @ A @ ( undefined @ A )
                @ ^ [Y3: A,Ys6: ( coinductive_llist @ A )] :
                    ( if @ A @ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) ) @ X @ Y3 )
                @ Ys )
            @ Xs ) ) ) ) )).

% ord.lmerge.simps(3)
thf(fact_203_ord_Olmerge_Osimps_I4_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
          = ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
            @ ^ [X: A,Xs5: ( coinductive_llist @ A )] :
                ( coindu1381640503_llist @ ( coinductive_llist @ A ) @ A @ ( undefined @ ( coinductive_llist @ A ) )
                @ ^ [Y3: A,Ys6: ( coinductive_llist @ A )] :
                    ( if @ ( coinductive_llist @ A ) @ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) ) @ ( hammin1328233080lmerge @ A @ Less @ Xs5 @ Ys ) @ ( if @ ( coinductive_llist @ A ) @ ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) ) @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys6 ) @ ( hammin1328233080lmerge @ A @ Less @ Xs5 @ Ys6 ) ) )
                @ Ys )
            @ Xs ) ) ) ) )).

% ord.lmerge.simps(4)
thf(fact_204_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_205_lmerge_Octr_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
          = ( coinductive_LCons @ a
            @ ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
              @ ^ [X: a,Xs5: ( coinductive_llist @ a )] :
                  ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
                  @ ^ [Y3: a,Ys6: ( coinductive_llist @ a )] :
                      ( if @ a @ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) ) @ X @ Y3 )
                  @ Ys )
              @ Xs )
            @ ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
              @ ^ [X: a,Xs5: ( coinductive_llist @ a )] :
                  ( coindu1381640503_llist @ ( coinductive_llist @ a ) @ a @ ( undefined @ ( coinductive_llist @ a ) )
                  @ ^ [Y3: a,Ys6: ( coinductive_llist @ a )] :
                      ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs5 @ Ys ) @ ( if @ ( coinductive_llist @ a ) @ ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) ) @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys6 ) @ ( hammin1328233080lmerge @ a @ less @ Xs5 @ Ys6 ) ) )
                  @ Ys )
              @ Xs ) ) ) ) ) )).

% lmerge.ctr(2)
thf(fact_206_lmerge_Osimps_I3_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
          = ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
            @ ^ [X: a,Xs5: ( coinductive_llist @ a )] :
                ( coindu1381640503_llist @ a @ a @ ( undefined @ a )
                @ ^ [Y3: a,Ys6: ( coinductive_llist @ a )] :
                    ( if @ a @ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) ) @ X @ Y3 )
                @ Ys )
            @ Xs ) ) ) ) )).

% lmerge.simps(3)
thf(fact_207_local_Olexordp__eq_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
      = ( ? [Ys4: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22 = Ys4 ) )
        | ? [X: a,Y3: a,Xs3: ( list @ a ),Ys4: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys4 ) )
            & ( less @ X @ Y3 ) )
        | ? [X: a,Y3: a,Xs3: ( list @ a ),Ys4: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys4 ) )
            & ~ ( less @ X @ Y3 )
            & ~ ( less @ Y3 @ X )
            & ( lexordp_eq @ a @ less @ Xs3 @ Ys4 ) ) ) ) )).

% local.lexordp_eq.simps
thf(fact_208_local_Olexordp__eq_Oinducts,axiom,(
    ! [X12: ( list @ a ),X24: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp_eq @ a @ less @ X12 @ X24 )
     => ( ! [X13: ( list @ a )] :
            ( P @ ( nil @ a ) @ X13 )
       => ( ! [X2: a,Y: a,Xs4: ( list @ a ),Ys3: ( list @ a )] :
              ( ( less @ X2 @ Y )
             => ( P @ ( cons @ a @ X2 @ Xs4 ) @ ( cons @ a @ Y @ Ys3 ) ) )
         => ( ! [X2: a,Y: a,Xs4: ( list @ a ),Ys3: ( list @ a )] :
                ( ~ ( less @ X2 @ Y )
               => ( ~ ( less @ Y @ X2 )
                 => ( ( lexordp_eq @ a @ less @ Xs4 @ Ys3 )
                   => ( ( P @ Xs4 @ Ys3 )
                     => ( P @ ( cons @ a @ X2 @ Xs4 ) @ ( cons @ a @ Y @ Ys3 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% local.lexordp_eq.inducts
thf(fact_209_local_Olexordp__eq_OCons,axiom,(
    ! [X3: a,Y2: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X3 @ Y2 )
     => ( lexordp_eq @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( cons @ a @ Y2 @ Ys ) ) ) )).

% local.lexordp_eq.Cons
thf(fact_210_local_Olexordp__eq_OCons__eq,axiom,(
    ! [X3: a,Y2: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X3 @ Y2 )
     => ( ~ ( less @ Y2 @ X3 )
       => ( ( lexordp_eq @ a @ less @ Xs @ Ys )
         => ( lexordp_eq @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( cons @ a @ Y2 @ Ys ) ) ) ) ) )).

% local.lexordp_eq.Cons_eq
thf(fact_211_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_212_local_Olexordp__eq_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Ys3: ( list @ a )] : ( A22 != Ys3 ) )
       => ( ! [X2: a] :
              ( ? [Xs4: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X2 @ Xs4 ) )
             => ! [Y: a] :
                  ( ? [Ys3: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y @ Ys3 ) )
                 => ~ ( less @ X2 @ Y ) ) )
         => ~ ( ! [X2: a,Y: a,Xs4: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X2 @ Xs4 ) )
                 => ! [Ys3: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y @ Ys3 ) )
                     => ( ~ ( less @ X2 @ Y )
                       => ( ~ ( less @ Y @ X2 )
                         => ~ ( lexordp_eq @ a @ less @ Xs4 @ Ys3 ) ) ) ) ) ) ) ) ) )).

% local.lexordp_eq.cases
thf(fact_213_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Xs: ( list @ A ),Y2: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) )
      = ( ( Less @ X3 @ Y2 )
        | ( ~ ( Less @ Y2 @ X3 )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_214_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_215_local_Olexordp__eq__simps_I4_J,axiom,(
    ! [X3: a,Xs: ( list @ a ),Y2: a,Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( cons @ a @ Y2 @ Ys ) )
      = ( ( less @ X3 @ Y2 )
        | ( ~ ( less @ Y2 @ X3 )
          & ( lexordp_eq @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_eq_simps(4)
thf(fact_216_local_Olexordp__eq__simps_I3_J,axiom,(
    ! [X3: a,Xs: ( list @ a )] :
      ~ ( lexordp_eq @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( nil @ a ) ) )).

% local.lexordp_eq_simps(3)
thf(fact_217_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X3 @ Y2 )
     => ( ~ ( Less @ Y2 @ X3 )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_218_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X3 @ Y2 )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_219_not__Cons__self2,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X3 @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_220_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F3: ( A > B ),X13: ( list @ B )] :
          ( P @ F3 @ ( nil @ A ) @ X13 )
     => ( ! [F3: ( A > B ),A6: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F3 @ As @ ( cons @ B @ ( F3 @ A6 ) @ Bs ) )
           => ( P @ F3 @ ( cons @ A @ A6 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_221_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs4: ( list @ A )] :
              ( ( Xs4
               != ( nil @ A ) )
             => ( ( P @ Xs4 )
               => ( P @ ( cons @ A @ X2 @ Xs4 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_222_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Y: A,Xs4: ( list @ A )] :
              ( ( ( X2 = Y )
               => ( P @ ( cons @ A @ X2 @ Xs4 ) ) )
             => ( ( ( X2 != Y )
                 => ( P @ ( cons @ A @ Y @ Xs4 ) ) )
               => ( P @ ( cons @ A @ X2 @ ( cons @ A @ Y @ Xs4 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_223_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X3: ( list @ A )] :
      ( ( X3
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( X3
           != ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ~ ( ! [X2: A,Y: A,Xs4: ( list @ A )] :
                ( X3
               != ( cons @ A @ X2 @ ( cons @ A @ Y @ Xs4 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_224_transpose_Ocases,axiom,(
    ! [A: $tType,X3: ( list @ ( list @ A ) )] :
      ( ( X3
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X3
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X2: A,Xs4: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X3
               != ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs4 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_225_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X13: ( list @ A )] :
          ( P @ ( nil @ A ) @ X13 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X2: A,Xs4: ( list @ A ),Y: A,Ys3: ( list @ A )] :
              ( ( P @ Xs4 @ Ys3 )
             => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y @ Ys3 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_226_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X2: A,Xs4: ( list @ A )] :
            ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( nil @ B ) )
       => ( ! [Y: B,Ys3: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y @ Ys3 ) )
         => ( ! [X2: A,Xs4: ( list @ A ),Y: B,Ys3: ( list @ B )] :
                ( ( P @ Xs4 @ Ys3 )
               => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ B @ Y @ Ys3 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_227_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys4: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys4 ) ) ) ) )).

% neq_Nil_conv
thf(fact_228_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X13: A,X25: ( list @ A )] :
            ( ( P @ X25 )
           => ( P @ ( cons @ A @ X13 @ X25 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_229_list_Oexhaust,axiom,(
    ! [A: $tType,Y2: ( list @ A )] :
      ( ( Y2
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y2
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_230_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_231_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_232_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys3: ( list @ A )] : ( A22 != Ys3 ) )
       => ( ! [X2: A] :
              ( ? [Xs4: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X2 @ Xs4 ) )
             => ! [Y: A] :
                  ( ? [Ys3: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y @ Ys3 ) )
                 => ~ ( Less @ X2 @ Y ) ) )
         => ~ ( ! [X2: A,Y: A,Xs4: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs4 ) )
                 => ! [Ys3: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y @ Ys3 ) )
                     => ( ~ ( Less @ X2 @ Y )
                       => ( ~ ( Less @ Y @ X2 )
                         => ~ ( lexordp_eq @ A @ Less @ Xs4 @ Ys3 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_233_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys4: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys4 ) )
            | ? [X: A,Y3: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys4 ) )
                & ( Less2 @ X @ Y3 ) )
            | ? [X: A,Y3: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys4 ) )
                & ~ ( Less2 @ X @ Y3 )
                & ~ ( Less2 @ Y3 @ X )
                & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys4 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_234_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X12: ( list @ A ),X24: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X12 @ X24 )
     => ( ! [X13: ( list @ A )] :
            ( P @ ( nil @ A ) @ X13 )
       => ( ! [X2: A,Y: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
              ( ( Less @ X2 @ Y )
             => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y @ Ys3 ) ) )
         => ( ! [X2: A,Y: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                ( ~ ( Less @ X2 @ Y )
               => ( ~ ( Less @ Y @ X2 )
                 => ( ( lexordp_eq @ A @ Less @ Xs4 @ Ys3 )
                   => ( ( P @ Xs4 @ Ys3 )
                     => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_235_local_Olexordp_ONil,axiom,(
    ! [Y2: a,Ys: ( list @ a )] :
      ( lexordp @ a @ less @ ( nil @ a ) @ ( cons @ a @ Y2 @ Ys ) ) )).

% local.lexordp.Nil
thf(fact_236_local_Olexordp_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Y: a,Ys3: ( list @ a )] :
              ( A22
             != ( cons @ a @ Y @ Ys3 ) ) )
       => ( ! [X2: a] :
              ( ? [Xs4: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X2 @ Xs4 ) )
             => ! [Y: a] :
                  ( ? [Ys3: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y @ Ys3 ) )
                 => ~ ( less @ X2 @ Y ) ) )
         => ~ ( ! [X2: a,Y: a,Xs4: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X2 @ Xs4 ) )
                 => ! [Ys3: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y @ Ys3 ) )
                     => ( ~ ( less @ X2 @ Y )
                       => ( ~ ( less @ Y @ X2 )
                         => ~ ( lexordp @ a @ less @ Xs4 @ Ys3 ) ) ) ) ) ) ) ) ) )).

% local.lexordp.cases
thf(fact_237_local_Olexordp__irreflexive,axiom,(
    ! [Xs: ( list @ a )] :
      ( ! [X2: a] :
          ~ ( less @ X2 @ X2 )
     => ~ ( lexordp @ a @ less @ Xs @ Xs ) ) )).

% local.lexordp_irreflexive
thf(fact_238_local_Olexordp_OCons,axiom,(
    ! [X3: a,Y2: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X3 @ Y2 )
     => ( lexordp @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( cons @ a @ Y2 @ Ys ) ) ) )).

% local.lexordp.Cons
thf(fact_239_local_Olexordp_OCons__eq,axiom,(
    ! [X3: a,Y2: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X3 @ Y2 )
     => ( ~ ( less @ Y2 @ X3 )
       => ( ( lexordp @ a @ less @ Xs @ Ys )
         => ( lexordp @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( cons @ a @ Y2 @ Ys ) ) ) ) ) )).

% local.lexordp.Cons_eq
thf(fact_240_local_Olexordp__into__lexordp__eq,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( lexordp_eq @ a @ less @ Xs @ Ys ) ) )).

% local.lexordp_into_lexordp_eq
thf(fact_241_local_Olexordp_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
      = ( ? [Y3: a,Ys4: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys4 ) ) )
        | ? [X: a,Y3: a,Xs3: ( list @ a ),Ys4: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys4 ) )
            & ( less @ X @ Y3 ) )
        | ? [X: a,Y3: a,Xs3: ( list @ a ),Ys4: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys4 ) )
            & ~ ( less @ X @ Y3 )
            & ~ ( less @ Y3 @ X )
            & ( lexordp @ a @ less @ Xs3 @ Ys4 ) ) ) ) )).

% local.lexordp.simps
thf(fact_242_local_Olexordp_Oinducts,axiom,(
    ! [X12: ( list @ a ),X24: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp @ a @ less @ X12 @ X24 )
     => ( ! [Y: a,Ys3: ( list @ a )] :
            ( P @ ( nil @ a ) @ ( cons @ a @ Y @ Ys3 ) )
       => ( ! [X2: a,Y: a,Xs4: ( list @ a ),Ys3: ( list @ a )] :
              ( ( less @ X2 @ Y )
             => ( P @ ( cons @ a @ X2 @ Xs4 ) @ ( cons @ a @ Y @ Ys3 ) ) )
         => ( ! [X2: a,Y: a,Xs4: ( list @ a ),Ys3: ( list @ a )] :
                ( ~ ( less @ X2 @ Y )
               => ( ~ ( less @ Y @ X2 )
                 => ( ( lexordp @ a @ less @ Xs4 @ Ys3 )
                   => ( ( P @ Xs4 @ Ys3 )
                     => ( P @ ( cons @ a @ X2 @ Xs4 ) @ ( cons @ a @ Y @ Ys3 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% local.lexordp.inducts
thf(fact_243_ord_Olexordp__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Xs: ( list @ A ),Y2: A,Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) )
      = ( ( Less @ X3 @ Y2 )
        | ( ~ ( Less @ Y2 @ X3 )
          & ( lexordp @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_simps(3)
thf(fact_244_ord_Olexordp__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ~ ( lexordp @ A @ Less @ Xs @ ( nil @ A ) ) )).

% ord.lexordp_simps(2)
thf(fact_245_ord_Olexordp__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less @ ( nil @ A ) @ Ys )
      = ( Ys
       != ( nil @ A ) ) ) )).

% ord.lexordp_simps(1)
thf(fact_246_local_Olexordp__simps_I3_J,axiom,(
    ! [X3: a,Xs: ( list @ a ),Y2: a,Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( cons @ a @ X3 @ Xs ) @ ( cons @ a @ Y2 @ Ys ) )
      = ( ( less @ X3 @ Y2 )
        | ( ~ ( less @ Y2 @ X3 )
          & ( lexordp @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_simps(3)
thf(fact_247_local_Olexordp__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ~ ( lexordp @ a @ less @ Xs @ ( nil @ a ) ) )).

% local.lexordp_simps(2)
thf(fact_248_local_Olexordp__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( nil @ a ) @ Ys )
      = ( Ys
       != ( nil @ a ) ) ) )).

% local.lexordp_simps(1)
thf(fact_249_ord_Olexordp_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X3 @ Y2 )
     => ( lexordp @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) ) )).

% ord.lexordp.Cons
thf(fact_250_ord_Olexordp_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X3 @ Y2 )
     => ( ~ ( Less @ Y2 @ X3 )
       => ( ( lexordp @ A @ Less @ Xs @ Ys )
         => ( lexordp @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) ) ) ) )).

% ord.lexordp.Cons_eq
thf(fact_251_ord_Olexordp_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X12: ( list @ A ),X24: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp @ A @ Less @ X12 @ X24 )
     => ( ! [Y: A,Ys3: ( list @ A )] :
            ( P @ ( nil @ A ) @ ( cons @ A @ Y @ Ys3 ) )
       => ( ! [X2: A,Y: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
              ( ( Less @ X2 @ Y )
             => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y @ Ys3 ) ) )
         => ( ! [X2: A,Y: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                ( ~ ( Less @ X2 @ Y )
               => ( ~ ( Less @ Y @ X2 )
                 => ( ( lexordp @ A @ Less @ Xs4 @ Ys3 )
                   => ( ( P @ Xs4 @ Ys3 )
                     => ( P @ ( cons @ A @ X2 @ Xs4 ) @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% ord.lexordp.inducts
thf(fact_252_ord_Olexordp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Y3: A,Ys4: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys4 ) ) )
            | ? [X: A,Y3: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys4 ) )
                & ( Less2 @ X @ Y3 ) )
            | ? [X: A,Y3: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys4 ) )
                & ~ ( Less2 @ X @ Y3 )
                & ~ ( Less2 @ Y3 @ X )
                & ( lexordp @ A @ Less2 @ Xs3 @ Ys4 ) ) ) ) ) )).

% ord.lexordp.simps

%----Type constructors (3)
thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_1,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oord_2,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X3: A,Y2: A] :
      ( ( if @ A @ $false @ X3 @ Y2 )
      = Y2 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X3: A,Y2: A] :
      ( ( if @ A @ $true @ X3 @ Y2 )
      = X3 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( comple1403672095_mcont @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ ( coinductive_lSup @ a ) @ ( coinductive_lprefix @ a ) @ ( coinductive_lSup @ a ) @ ( coinductive_lprefix @ a ) @ ( hammin1328233080lmerge @ a @ less @ xs ) )).

%------------------------------------------------------------------------------
