%------------------------------------------------------------------------------
% File     : DAT157^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Hamming stream 157
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : hamming_stream__157.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  310 (   1 unit;  48 type;   0 defn)
%            Number of atoms       : 3360 ( 173 equality;1734 variable)
%            Maximal formula depth :   18 (   8 average)
%            Number of connectives : 3016 (  83   ~;  23   |;  37   &;2599   @)
%                                         (   0 <=>; 274  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  196 ( 196   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   50 (  48   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  767 (   0 sgn; 688   !;   4   ?;  34   ^)
%                                         ( 767   :;  41  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:50.421
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (43)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Oldistinct,type,(
    coindu351974385stinct: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Oord_Olsorted,type,(
    coinductive_lsorted: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,(
    condit2040224947_above: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,(
    condit1201339847_below: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Finite__Set_Ofolding,type,(
    finite_folding: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B ) > $o ) )).

thf(sy_c_Groups_Osemigroup,type,(
    semigroup: 
      !>[A: $tType] :
        ( ( A > A > A ) > $o ) )).

thf(sy_c_Hamming__Stream__Mirabelle__rwekfkwckg_Oord_Olmerge,type,(
    hammin1328233080lmerge: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lattices_Osemilattice,type,(
    semilattice: 
      !>[A: $tType] :
        ( ( A > A > A ) > $o ) )).

thf(sy_c_Lattices__Big_Osemilattice__order__set,type,(
    lattic1693879045er_set: 
      !>[A: $tType] :
        ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) )).

thf(sy_c_List_Olinorder_Oinsort__key,type,(
    insort_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_Orderings_Oord_OLeast,type,(
    least: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > A ) )).

thf(sy_c_Orderings_Oord_Omin,type,(
    min: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder_Oantimono,type,(
    antimono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Orderings_Oorder_Omono,type,(
    mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Orderings_Oordering,type,(
    ordering: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Otransp,type,(
    transp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeast,type,(
    set_atLeast: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeastAtMost,type,(
    set_atLeastAtMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeastLessThan,type,(
    set_atLeastLessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatMost,type,(
    set_atMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,(
    set_gr323396891AtMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,(
    set_gr1161524159ssThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_less__eq,type,(
    less_eq: a > a > $o )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

thf(sy_v_x,type,(
    x: a )).

thf(sy_v_x_H____,type,(
    x2: a )).

thf(sy_v_xsa____,type,(
    xsa: ( coinductive_llist @ a ) )).

thf(sy_v_ysa____,type,(
    ysa: ( coinductive_llist @ a ) )).

%----Relevant facts (256)
thf(fact_0_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_1_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_2_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_3_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_4_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_5_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_6_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_7_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_8_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_9_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_10_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_11_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_12_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_13_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_14_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_trans
thf(fact_15_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_16_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_17_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_18_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_19_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_20_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_21_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_22_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_23_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_24_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans
thf(fact_25_step_Ohyps_I2_J,axiom,(
    x != x2 )).

% step.hyps(2)
thf(fact_26_step_Oprems_I2_J,axiom,(
    ~ ( coinductive_lfinite @ a @ ysa ) )).

% step.prems(2)
thf(fact_27_step_Ohyps_I1_J,axiom,
    ( member @ a @ x @ ( coinductive_lset @ a @ xsa ) )).

% step.hyps(1)
thf(fact_28_local_Oantisym,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less_eq @ Y @ X )
       => ( X = Y ) ) ) )).

% local.antisym
thf(fact_29_local_Oantisym__conv,axiom,(
    ! [Y: a,X: a] :
      ( ( less_eq @ Y @ X )
     => ( ( less_eq @ X @ Y )
        = ( X = Y ) ) ) )).

% local.antisym_conv
thf(fact_30_local_Odual__order_Oantisym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( less_eq @ A2 @ B2 )
       => ( A2 = B2 ) ) ) )).

% local.dual_order.antisym
thf(fact_31_local_Odual__order_Otrans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( less_eq @ C @ B2 )
       => ( less_eq @ C @ A2 ) ) ) )).

% local.dual_order.trans
thf(fact_32_local_Oeq__iff,axiom,
    ( ( ^ [Y2: a,Z2: a] : ( Y2 = Z2 ) )
    = ( ^ [X2: a,Y3: a] :
          ( ( less_eq @ X2 @ Y3 )
          & ( less_eq @ Y3 @ X2 ) ) ) )).

% local.eq_iff
thf(fact_33_local_Oeq__refl,axiom,(
    ! [X: a,Y: a] :
      ( ( X = Y )
     => ( less_eq @ X @ Y ) ) )).

% local.eq_refl
thf(fact_34_local_Ole__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less_eq @ X @ Y )
     => ( less_eq @ Y @ X ) ) )).

% local.le_cases
thf(fact_35_local_Ole__cases3,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( ( less_eq @ X @ Y )
       => ~ ( less_eq @ Y @ Z ) )
     => ( ( ( less_eq @ Y @ X )
         => ~ ( less_eq @ X @ Z ) )
       => ( ( ( less_eq @ X @ Z )
           => ~ ( less_eq @ Z @ Y ) )
         => ( ( ( less_eq @ Z @ Y )
             => ~ ( less_eq @ Y @ X ) )
           => ( ( ( less_eq @ Y @ Z )
               => ~ ( less_eq @ Z @ X ) )
             => ~ ( ( less_eq @ Z @ X )
                 => ~ ( less_eq @ X @ Y ) ) ) ) ) ) ) )).

% local.le_cases3
thf(fact_36_local_Olinear,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
      | ( less_eq @ Y @ X ) ) )).

% local.linear
thf(fact_37_local_Olinorder__wlog,axiom,(
    ! [P: ( a > a > $o ),A2: a,B2: a] :
      ( ! [A3: a,B3: a] :
          ( ( less_eq @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: a,B3: a] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A2 @ B2 ) ) ) )).

% local.linorder_wlog
thf(fact_38_local_Oord__eq__le__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.ord_eq_le_trans
thf(fact_39_local_Oord__le__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.ord_le_eq_trans
thf(fact_40_local_Oorder_Oantisym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less_eq @ B2 @ A2 )
       => ( A2 = B2 ) ) ) )).

% local.order.antisym
thf(fact_41_local_Oorder_Otrans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.order.trans
thf(fact_42_local_Oorder__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less_eq @ Y @ Z )
       => ( less_eq @ X @ Z ) ) ) )).

% local.order_trans
thf(fact_43_step_Oprems_I3_J,axiom,(
    ? [X3: a] :
      ( ( member @ a @ X3 @ ( coinductive_lset @ a @ ysa ) )
      & ( less_eq @ x @ X3 ) ) )).

% step.prems(3)
thf(fact_44_local_Oantisym__conv1,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( less_eq @ X @ Y )
        = ( X = Y ) ) ) )).

% local.antisym_conv1
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_Oantisym__conv2,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv2
thf(fact_50_local_Odual__order_Onot__eq__order__implies__strict,axiom,(
    ! [A2: a,B2: a] :
      ( ( A2 != B2 )
     => ( ( less_eq @ B2 @ A2 )
       => ( less @ B2 @ A2 ) ) ) )).

% local.dual_order.not_eq_order_implies_strict
thf(fact_51_local_Odual__order_Oorder__iff__strict,axiom,(
    ! [B2: a,A2: a] :
      ( ( less_eq @ B2 @ A2 )
      = ( ( less @ B2 @ A2 )
        | ( A2 = B2 ) ) ) )).

% local.dual_order.order_iff_strict
thf(fact_52_local_Odual__order_Ostrict__iff__order,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
      = ( ( less_eq @ B2 @ A2 )
        & ( A2 != B2 ) ) ) )).

% local.dual_order.strict_iff_order
thf(fact_53_local_Odual__order_Ostrict__implies__order,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( less_eq @ B2 @ A2 ) ) )).

% local.dual_order.strict_implies_order
thf(fact_54_local_Odual__order_Ostrict__trans1,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans1
thf(fact_55_local_Odual__order_Ostrict__trans2,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less_eq @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans2
thf(fact_56_local_OleD,axiom,(
    ! [Y: a,X: a] :
      ( ( less_eq @ Y @ X )
     => ~ ( less @ X @ Y ) ) )).

% local.leD
thf(fact_57_local_OleI,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( less_eq @ Y @ X ) ) )).

% local.leI
thf(fact_58_local_Ole__imp__less__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less @ X @ Y )
        | ( X = Y ) ) ) )).

% local.le_imp_less_or_eq
thf(fact_59_local_Ole__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
      = ( ( less @ X @ Y )
        | ( X = Y ) ) ) )).

% local.le_less
thf(fact_60_local_Ole__less__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
      | ( less @ Y @ X ) ) )).

% local.le_less_linear
thf(fact_61_local_Ole__less__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.le_less_trans
thf(fact_62_local_Ole__neq__trans,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( A2 != B2 )
       => ( less @ A2 @ B2 ) ) ) )).

% local.le_neq_trans
thf(fact_63_local_Oless__imp__le,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( less_eq @ X @ Y ) ) )).

% local.less_imp_le
thf(fact_64_local_Oless__le,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      = ( ( less_eq @ X @ Y )
        & ( X != Y ) ) ) )).

% local.less_le
thf(fact_65_local_Oless__le__not__le,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      = ( ( less_eq @ X @ Y )
        & ~ ( less_eq @ Y @ X ) ) ) )).

% local.less_le_not_le
thf(fact_66_local_Oless__le__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less_eq @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_le_trans
thf(fact_67_local_Onot__le,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less_eq @ X @ Y ) )
      = ( less @ Y @ X ) ) )).

% local.not_le
thf(fact_68_local_Onot__le__imp__less,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less_eq @ Y @ X )
     => ( less @ X @ Y ) ) )).

% local.not_le_imp_less
thf(fact_69_local_Onot__less,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( less_eq @ Y @ X ) ) )).

% local.not_less
thf(fact_70_local_Oorder_Onot__eq__order__implies__strict,axiom,(
    ! [A2: a,B2: a] :
      ( ( A2 != B2 )
     => ( ( less_eq @ A2 @ B2 )
       => ( less @ A2 @ B2 ) ) ) )).

% local.order.not_eq_order_implies_strict
thf(fact_71_local_Oorder_Oorder__iff__strict,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
      = ( ( less @ A2 @ B2 )
        | ( A2 = B2 ) ) ) )).

% local.order.order_iff_strict
thf(fact_72_local_Oorder_Ostrict__iff__order,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
      = ( ( less_eq @ A2 @ B2 )
        & ( A2 != B2 ) ) ) )).

% local.order.strict_iff_order
thf(fact_73_local_Oorder_Ostrict__implies__order,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( less_eq @ A2 @ B2 ) ) )).

% local.order.strict_implies_order
thf(fact_74_local_Oorder_Ostrict__trans1,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans1
thf(fact_75_local_Oorder_Ostrict__trans2,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans2
thf(fact_76_local_Oorder_Orefl,axiom,(
    ! [A2: a] :
      ( less_eq @ A2 @ A2 ) )).

% local.order.refl
thf(fact_77_local_Oorder__refl,axiom,(
    ! [X: a] :
      ( less_eq @ X @ X ) )).

% local.order_refl
thf(fact_78_local_OLeastI2__order,axiom,(
    ! [P: ( a > $o ),X: a,Q: ( a > $o )] :
      ( ( P @ X )
     => ( ! [Y4: a] :
            ( ( P @ Y4 )
           => ( less_eq @ X @ Y4 ) )
       => ( ! [X3: a] :
              ( ( P @ X3 )
             => ( ! [Y5: a] :
                    ( ( P @ Y5 )
                   => ( less_eq @ X3 @ Y5 ) )
               => ( Q @ X3 ) ) )
         => ( Q @ ( least @ a @ less_eq @ P ) ) ) ) ) )).

% local.LeastI2_order
thf(fact_79_local_OLeast__equality,axiom,(
    ! [P: ( a > $o ),X: a] :
      ( ( P @ X )
     => ( ! [Y4: a] :
            ( ( P @ Y4 )
           => ( less_eq @ X @ Y4 ) )
       => ( ( least @ a @ less_eq @ P )
          = X ) ) ) )).

% local.Least_equality
thf(fact_80_local_Olsorted_OLCons__LCons,axiom,(
    ! [X: a,Y: a,Xs: ( coinductive_llist @ a )] :
      ( ( less_eq @ X @ Y )
     => ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y @ Xs ) )
       => ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ ( coinductive_LCons @ a @ Y @ Xs ) ) ) ) ) )).

% local.lsorted.LCons_LCons
thf(fact_81_local_Olsorted__LCons,axiom,(
    ! [X: a,Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ Xs ) )
      = ( ( coinductive_lsorted @ a @ less_eq @ Xs )
        & ! [X2: a] :
            ( ( member @ a @ X2 @ ( coinductive_lset @ a @ Xs ) )
           => ( less_eq @ X @ X2 ) ) ) ) )).

% local.lsorted_LCons
thf(fact_82_local_Oin__lset__lmergeD,axiom,(
    ! [X: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( member @ a @ X @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) )
     => ( ( member @ a @ X @ ( coinductive_lset @ a @ Xs ) )
        | ( member @ a @ X @ ( coinductive_lset @ a @ Ys ) ) ) ) )).

% local.in_lset_lmergeD
thf(fact_83_local_Obdd__above__def,axiom,(
    ! [A4: ( set @ a )] :
      ( ( condit2040224947_above @ a @ less_eq @ A4 )
      = ( ? [M: a] :
          ! [X2: a] :
            ( ( member @ a @ X2 @ A4 )
           => ( less_eq @ X2 @ M ) ) ) ) )).

% local.bdd_above_def
thf(fact_84_local_Obdd__below__def,axiom,(
    ! [A4: ( set @ a )] :
      ( ( condit1201339847_below @ a @ less_eq @ A4 )
      = ( ? [M2: a] :
          ! [X2: a] :
            ( ( member @ a @ X2 @ A4 )
           => ( less_eq @ M2 @ X2 ) ) ) ) )).

% local.bdd_below_def
thf(fact_85_local_Oinsort__key__left__comm,axiom,(
    ! [B: $tType,F: ( B > a ),X: B,Y: B,Xs: ( list @ B )] :
      ( ( ( F @ X )
       != ( F @ Y ) )
     => ( ( insort_key @ a @ B @ less_eq @ F @ Y @ ( insort_key @ a @ B @ less_eq @ F @ X @ Xs ) )
        = ( insort_key @ a @ B @ less_eq @ F @ X @ ( insort_key @ a @ B @ less_eq @ F @ Y @ Xs ) ) ) ) )).

% local.insort_key_left_comm
thf(fact_86_local_Otransp__le,axiom,
    ( transp @ a @ less_eq )).

% local.transp_le
thf(fact_87_ord_Oin__lset__lmergeD,axiom,(
    ! [A: $tType,X: A,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        | ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% ord.in_lset_lmergeD
thf(fact_88_local_Olsorted__ldistinct__lset__unique,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ Xs )
     => ( ( coindu351974385stinct @ a @ Xs )
       => ( ( coinductive_lsorted @ a @ less_eq @ Ys )
         => ( ( coindu351974385stinct @ a @ Ys )
           => ( ( ( coinductive_lset @ a @ Xs )
                = ( coinductive_lset @ a @ Ys ) )
             => ( Xs = Ys ) ) ) ) ) ) )).

% local.lsorted_ldistinct_lset_unique
thf(fact_89_local_Olsorted__LCons__LCons,axiom,(
    ! [X: a,Y: a,Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ ( coinductive_LCons @ a @ Y @ Xs ) ) )
      = ( ( less_eq @ X @ Y )
        & ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y @ Xs ) ) ) ) )).

% local.lsorted_LCons_LCons
thf(fact_90_local_Omin_Oabsorb1,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( min @ a @ less_eq @ A2 @ B2 )
        = A2 ) ) )).

% local.min.absorb1
thf(fact_91_local_Omin_Oabsorb2,axiom,(
    ! [B2: a,A2: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( min @ a @ less_eq @ A2 @ B2 )
        = B2 ) ) )).

% local.min.absorb2
thf(fact_92_local_Omin_Oabsorb__iff1,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
      = ( ( min @ a @ less_eq @ A2 @ B2 )
        = A2 ) ) )).

% local.min.absorb_iff1
thf(fact_93_local_Omin_Oabsorb__iff2,axiom,(
    ! [B2: a,A2: a] :
      ( ( less_eq @ B2 @ A2 )
      = ( ( min @ a @ less_eq @ A2 @ B2 )
        = B2 ) ) )).

% local.min.absorb_iff2
thf(fact_94_local_Omin__le__iff__disj,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less_eq @ ( min @ a @ less_eq @ X @ Y ) @ Z )
      = ( ( less_eq @ X @ Z )
        | ( less_eq @ Y @ Z ) ) ) )).

% local.min_le_iff_disj
thf(fact_95_local_Omin__def,axiom,(
    ! [A2: a,B2: a] :
      ( ( ( less_eq @ A2 @ B2 )
       => ( ( min @ a @ less_eq @ A2 @ B2 )
          = A2 ) )
      & ( ~ ( less_eq @ A2 @ B2 )
       => ( ( min @ a @ less_eq @ A2 @ B2 )
          = B2 ) ) ) )).

% local.min_def
thf(fact_96_local_Omin_Oorder__iff,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
      = ( A2
        = ( min @ a @ less_eq @ A2 @ B2 ) ) ) )).

% local.min.order_iff
thf(fact_97_local_Omin_OorderI,axiom,(
    ! [A2: a,B2: a] :
      ( ( A2
        = ( min @ a @ less_eq @ A2 @ B2 ) )
     => ( less_eq @ A2 @ B2 ) ) )).

% local.min.orderI
thf(fact_98_local_Omin_OorderE,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( A2
        = ( min @ a @ less_eq @ A2 @ B2 ) ) ) )).

% local.min.orderE
thf(fact_99_local_Omin_Omono,axiom,(
    ! [A2: a,C: a,B2: a,D: a] :
      ( ( less_eq @ A2 @ C )
     => ( ( less_eq @ B2 @ D )
       => ( less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ ( min @ a @ less_eq @ C @ D ) ) ) ) )).

% local.min.mono
thf(fact_100_local_Omin_Oleft__commute,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( min @ a @ less_eq @ B2 @ ( min @ a @ less_eq @ A2 @ C ) )
      = ( min @ a @ less_eq @ A2 @ ( min @ a @ less_eq @ B2 @ C ) ) ) )).

% local.min.left_commute
thf(fact_101_local_Omin_Ocommute,axiom,(
    ! [A2: a,B2: a] :
      ( ( min @ a @ less_eq @ A2 @ B2 )
      = ( min @ a @ less_eq @ B2 @ A2 ) ) )).

% local.min.commute
thf(fact_102_local_Omin_OcoboundedI2,axiom,(
    ! [B2: a,C: a,A2: a] :
      ( ( less_eq @ B2 @ C )
     => ( less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ C ) ) )).

% local.min.coboundedI2
thf(fact_103_local_Omin_OcoboundedI1,axiom,(
    ! [A2: a,C: a,B2: a] :
      ( ( less_eq @ A2 @ C )
     => ( less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ C ) ) )).

% local.min.coboundedI1
thf(fact_104_local_Omin_Ocobounded2,axiom,(
    ! [A2: a,B2: a] :
      ( less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ B2 ) )).

% local.min.cobounded2
thf(fact_105_local_Omin_Ocobounded1,axiom,(
    ! [A2: a,B2: a] :
      ( less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ A2 ) )).

% local.min.cobounded1
thf(fact_106_local_Omin_OboundedI,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less_eq @ A2 @ C )
       => ( less_eq @ A2 @ ( min @ a @ less_eq @ B2 @ C ) ) ) ) )).

% local.min.boundedI
thf(fact_107_local_Omin_OboundedE,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ ( min @ a @ less_eq @ B2 @ C ) )
     => ~ ( ( less_eq @ A2 @ B2 )
         => ~ ( less_eq @ A2 @ C ) ) ) )).

% local.min.boundedE
thf(fact_108_local_Omin_Oassoc,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( min @ a @ less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ C )
      = ( min @ a @ less_eq @ A2 @ ( min @ a @ less_eq @ B2 @ C ) ) ) )).

% local.min.assoc
thf(fact_109_local_Olmerge__simps,axiom,(
    ! [X: a,Y: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( less @ X @ Y )
       => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ ( coinductive_LCons @ a @ Y @ Ys ) )
          = ( coinductive_LCons @ a @ X @ ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_LCons @ a @ Y @ Ys ) ) ) ) )
      & ( ~ ( less @ X @ Y )
       => ( ( ( less @ Y @ X )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ ( coinductive_LCons @ a @ Y @ Ys ) )
              = ( coinductive_LCons @ a @ Y @ ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ Ys ) ) ) )
          & ( ~ ( less @ Y @ X )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ ( coinductive_LCons @ a @ Y @ Ys ) )
              = ( coinductive_LCons @ a @ Y @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) ) ) ) )).

% local.lmerge_simps
thf(fact_110_local_Olinfinite__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lfinite @ a @ Xs )
     => ( ~ ( coinductive_lfinite @ a @ Ys )
       => ~ ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.linfinite_lmerge
thf(fact_111_local_Olfinite__lmergeI,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lfinite @ a @ Xs )
     => ( ( coinductive_lfinite @ a @ Ys )
       => ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lfinite_lmergeI
thf(fact_112_local_Olfinite__lmergeD,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
     => ( ( coinductive_lfinite @ a @ Xs )
        | ( coinductive_lfinite @ a @ Ys ) ) ) )).

% local.lfinite_lmergeD
thf(fact_113_local_Omin__less__iff__disj,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ ( min @ a @ less_eq @ X @ Y ) @ Z )
      = ( ( less @ X @ Z )
        | ( less @ Y @ Z ) ) ) )).

% local.min_less_iff_disj
thf(fact_114_local_Omin_Ostrict__order__iff,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
      = ( ( A2
          = ( min @ a @ less_eq @ A2 @ B2 ) )
        & ( A2 != B2 ) ) ) )).

% local.min.strict_order_iff
thf(fact_115_local_Omin_Ostrict__coboundedI2,axiom,(
    ! [B2: a,C: a,A2: a] :
      ( ( less @ B2 @ C )
     => ( less @ ( min @ a @ less_eq @ A2 @ B2 ) @ C ) ) )).

% local.min.strict_coboundedI2
thf(fact_116_local_Omin_Ostrict__coboundedI1,axiom,(
    ! [A2: a,C: a,B2: a] :
      ( ( less @ A2 @ C )
     => ( less @ ( min @ a @ less_eq @ A2 @ B2 ) @ C ) ) )).

% local.min.strict_coboundedI1
thf(fact_117_local_Omin_Ostrict__boundedE,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ ( min @ a @ less_eq @ B2 @ C ) )
     => ~ ( ( less @ A2 @ B2 )
         => ~ ( less @ A2 @ C ) ) ) )).

% local.min.strict_boundedE
thf(fact_118_local_Omin_Oright__idem,axiom,(
    ! [A2: a,B2: a] :
      ( ( min @ a @ less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) @ B2 )
      = ( min @ a @ less_eq @ A2 @ B2 ) ) )).

% local.min.right_idem
thf(fact_119_local_Omin_Oleft__idem,axiom,(
    ! [A2: a,B2: a] :
      ( ( min @ a @ less_eq @ A2 @ ( min @ a @ less_eq @ A2 @ B2 ) )
      = ( min @ a @ less_eq @ A2 @ B2 ) ) )).

% local.min.left_idem
thf(fact_120_local_Omin_Oidem,axiom,(
    ! [A2: a] :
      ( ( min @ a @ less_eq @ A2 @ A2 )
      = A2 ) )).

% local.min.idem
thf(fact_121_local_Omin_Obounded__iff,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ ( min @ a @ less_eq @ B2 @ C ) )
      = ( ( less_eq @ A2 @ B2 )
        & ( less_eq @ A2 @ C ) ) ) )).

% local.min.bounded_iff
thf(fact_122_local_Obdd__belowI,axiom,(
    ! [A4: ( set @ a ),M3: a] :
      ( ! [X3: a] :
          ( ( member @ a @ X3 @ A4 )
         => ( less_eq @ M3 @ X3 ) )
     => ( condit1201339847_below @ a @ less_eq @ A4 ) ) )).

% local.bdd_belowI
thf(fact_123_local_Obdd__aboveI,axiom,(
    ! [A4: ( set @ a ),M4: a] :
      ( ! [X3: a] :
          ( ( member @ a @ X3 @ A4 )
         => ( less_eq @ X3 @ M4 ) )
     => ( condit2040224947_above @ a @ less_eq @ A4 ) ) )).

% local.bdd_aboveI
thf(fact_124_local_Omin__less__iff__conj,axiom,(
    ! [Z: a,X: a,Y: a] :
      ( ( less @ Z @ ( min @ a @ less_eq @ X @ Y ) )
      = ( ( less @ Z @ X )
        & ( less @ Z @ Y ) ) ) )).

% local.min_less_iff_conj
thf(fact_125_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_126_ord_Olinfinite__lmerge,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ~ ( coinductive_lfinite @ A @ Ys )
       => ~ ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.linfinite_lmerge
thf(fact_127_ord_Olfinite__lmergeI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lfinite_lmergeI
thf(fact_128_ord_Olfinite__lmergeD,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
     => ( ( coinductive_lfinite @ A @ Xs )
        | ( coinductive_lfinite @ A @ Ys ) ) ) )).

% ord.lfinite_lmergeD
thf(fact_129_ord_Olmerge__simps,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( Less @ X @ Y )
       => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
          = ( coinductive_LCons @ A @ X @ ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )
      & ( ~ ( Less @ X @ Y )
       => ( ( ( Less @ Y @ X )
           => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
              = ( coinductive_LCons @ A @ Y @ ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ Ys ) ) ) )
          & ( ~ ( Less @ Y @ X )
           => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
              = ( coinductive_LCons @ A @ Y @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) ) ) ) )).

% ord.lmerge_simps
thf(fact_130_local_OMin_Osemilattice__order__set__axioms,axiom,
    ( lattic1693879045er_set @ a @ ( min @ a @ less_eq ) @ less_eq @ less )).

% local.Min.semilattice_order_set_axioms
thf(fact_131_ldistinct__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        & ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_LCons
thf(fact_132_local_OIoc__inj,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 )
        = ( set_gr323396891AtMost @ a @ less_eq @ less @ C @ D ) )
      = ( ( ( less_eq @ B2 @ A2 )
          & ( less_eq @ D @ C ) )
        | ( ( A2 = C )
          & ( B2 = D ) ) ) ) )).

% local.Ioc_inj
thf(fact_133_step_OIH,axiom,(
    ! [Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ xsa )
     => ( ~ ( coinductive_lfinite @ a @ Ys )
       => ( ? [X4: a] :
              ( ( member @ a @ X4 @ ( coinductive_lset @ a @ Ys ) )
              & ( less_eq @ x @ X4 ) )
         => ( member @ a @ x @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ xsa @ Ys ) ) ) ) ) ) )).

% step.IH
thf(fact_134_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_135_local_Oinsort__left__comm,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a )] :
      ( ( insort_key @ a @ a @ less_eq
        @ ^ [X2: a] : X2
        @ X
        @ ( insort_key @ a @ a @ less_eq
          @ ^ [X2: a] : X2
          @ Y
          @ Xs ) )
      = ( insort_key @ a @ a @ less_eq
        @ ^ [X2: a] : X2
        @ Y
        @ ( insort_key @ a @ a @ less_eq
          @ ^ [X2: a] : X2
          @ X
          @ Xs ) ) ) )).

% local.insort_left_comm
thf(fact_136_step_Oprems_I1_J,axiom,
    ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ x2 @ xsa ) )).

% step.prems(1)
thf(fact_137_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_138_lfinite__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_139_local_OgreaterThanAtMost__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr323396891AtMost @ a @ less_eq @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less_eq @ I @ U ) ) ) )).

% local.greaterThanAtMost_iff
thf(fact_140_local_Obdd__above__Ioc,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_above_Ioc
thf(fact_141_local_Obdd__below__Ioc,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_below_Ioc
thf(fact_142_local_Ostrict__mono__mono,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( mono @ a @ B @ less_eq @ F ) ) ) )).

% local.strict_mono_mono
thf(fact_143_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),X5: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X5 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_144_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_145_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_146_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_147_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ~ ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X6 @ Xs2 ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) ) ) ) ) ) )).

% lset_cases
thf(fact_148_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs3: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
       => ( ! [X6: A,Xs3: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
             => ( ( X != X6 )
               => ( ( P @ Xs3 )
                 => ( P @ ( coinductive_LCons @ A @ X6 @ Xs3 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_149_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs3: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs3 ) )
       => ( ! [X6: A,Xs3: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs3 ) )
             => ( ( P @ Xs3 )
               => ( P @ ( coinductive_LCons @ A @ X6 @ Xs3 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_150_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z22: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z22 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z22 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_151_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) )
       => ( ! [Z1: A,Z22: ( coinductive_llist @ A ),Xa: A] :
              ( ( member @ A @ Xa @ ( coinductive_lset @ A @ Z22 ) )
             => ( ( P @ Xa @ Z22 )
               => ( P @ Xa @ ( coinductive_LCons @ A @ Z1 @ Z22 ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_152_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_153_ord_Olsorted__LCons__LCons,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) )
      = ( ( Less_eq @ X @ Y )
        & ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) ) )).

% ord.lsorted_LCons_LCons
thf(fact_154_ord_OLCons__LCons,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( Less_eq @ X @ Y )
     => ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y @ Xs ) )
       => ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) ) ) )).

% ord.LCons_LCons
thf(fact_155_ldistinct_OLCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ( coindu351974385stinct @ A @ Xs )
       => ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) ) )).

% ldistinct.LCons
thf(fact_156_local_Osorted__list__of__set_Ofolding__axioms,axiom,
    ( finite_folding @ a @ ( list @ a )
    @ ( insort_key @ a @ a @ less_eq
      @ ^ [X2: a] : X2 ) )).

% local.sorted_list_of_set.folding_axioms
thf(fact_157_local_OatLeast__def,axiom,(
    ! [L: a] :
      ( ( set_atLeast @ a @ less_eq @ L )
      = ( collect @ a @ ( less_eq @ L ) ) ) )).

% local.atLeast_def
thf(fact_158_local_Odual__order_Oordering__axioms,axiom,
    ( ordering @ a
    @ ^ [X2: a,Y3: a] :
        ( less_eq @ Y3 @ X2 )
    @ ^ [X2: a,Y3: a] :
        ( less @ Y3 @ X2 ) )).

% local.dual_order.ordering_axioms
thf(fact_159_local_OatMost__def,axiom,(
    ! [U: a] :
      ( ( set_atMost @ a @ less_eq @ U )
      = ( collect @ a
        @ ^ [X2: a] :
            ( less_eq @ X2 @ U ) ) ) )).

% local.atMost_def
thf(fact_160_local_Oorder_Oordering__axioms,axiom,
    ( ordering @ a @ less_eq @ less )).

% local.order.ordering_axioms
thf(fact_161_local_OatMost__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_atMost @ a @ less_eq @ K ) )
      = ( less_eq @ I @ K ) ) )).

% local.atMost_iff
thf(fact_162_local_OatLeast__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_atLeast @ a @ less_eq @ K ) )
      = ( less_eq @ K @ I ) ) )).

% local.atLeast_iff
thf(fact_163_local_Obdd__above__Iic,axiom,(
    ! [B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_atMost @ a @ less_eq @ B2 ) ) )).

% local.bdd_above_Iic
thf(fact_164_local_Obdd__below__Ici,axiom,(
    ! [A2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_atLeast @ a @ less_eq @ A2 ) ) )).

% local.bdd_below_Ici
thf(fact_165_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_166_local_Omin_Osemilattice__axioms,axiom,
    ( semilattice @ a @ ( min @ a @ less_eq ) )).

% local.min.semilattice_axioms
thf(fact_167_local_Omin_Osemigroup__axioms,axiom,
    ( semigroup @ a @ ( min @ a @ less_eq ) )).

% local.min.semigroup_axioms
thf(fact_168_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_169_local_Obdd__below__Ioi,axiom,(
    ! [A2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_greaterThan @ a @ less @ A2 ) ) )).

% local.bdd_below_Ioi
thf(fact_170_local_OgreaterThanAtMost__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_gr323396891AtMost @ a @ less_eq @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ L ) @ ( set_atMost @ a @ less_eq @ U ) ) ) )).

% local.greaterThanAtMost_def
thf(fact_171_local_OIci__subset__Ioi__iff,axiom,(
    ! [A2: a,B2: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atLeast @ a @ less_eq @ A2 ) @ ( set_greaterThan @ a @ less @ B2 ) )
      = ( less @ B2 @ A2 ) ) )).

% local.Ici_subset_Ioi_iff
thf(fact_172_local_OIoi__le__Ico,axiom,(
    ! [A2: a] :
      ( ord_less_eq @ ( set @ a ) @ ( set_greaterThan @ a @ less @ A2 ) @ ( set_atLeast @ a @ less_eq @ A2 ) ) )).

% local.Ioi_le_Ico
thf(fact_173_local_Omono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( mono @ a @ B @ less_eq @ F )
          = ( ! [X2: a,Y3: a] :
                ( ( less_eq @ X2 @ Y3 )
               => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) ) ) )).

% local.mono_def
thf(fact_174_local_OmonoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y4: a] :
              ( ( less_eq @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( mono @ a @ B @ less_eq @ F ) ) ) )).

% local.monoI
thf(fact_175_local_OmonoE,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( mono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.monoE
thf(fact_176_local_OmonoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( mono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.monoD
thf(fact_177_local_Obdd__below__Int2,axiom,(
    ! [B4: ( set @ a ),A4: ( set @ a )] :
      ( ( condit1201339847_below @ a @ less_eq @ B4 )
     => ( condit1201339847_below @ a @ less_eq @ ( inf_inf @ ( set @ a ) @ A4 @ B4 ) ) ) )).

% local.bdd_below_Int2
thf(fact_178_local_Obdd__below__Int1,axiom,(
    ! [A4: ( set @ a ),B4: ( set @ a )] :
      ( ( condit1201339847_below @ a @ less_eq @ A4 )
     => ( condit1201339847_below @ a @ less_eq @ ( inf_inf @ ( set @ a ) @ A4 @ B4 ) ) ) )).

% local.bdd_below_Int1
thf(fact_179_local_Obdd__above__Int2,axiom,(
    ! [B4: ( set @ a ),A4: ( set @ a )] :
      ( ( condit2040224947_above @ a @ less_eq @ B4 )
     => ( condit2040224947_above @ a @ less_eq @ ( inf_inf @ ( set @ a ) @ A4 @ B4 ) ) ) )).

% local.bdd_above_Int2
thf(fact_180_local_Obdd__above__Int1,axiom,(
    ! [A4: ( set @ a ),B4: ( set @ a )] :
      ( ( condit2040224947_above @ a @ less_eq @ A4 )
     => ( condit2040224947_above @ a @ less_eq @ ( inf_inf @ ( set @ a ) @ A4 @ B4 ) ) ) )).

% local.bdd_above_Int1
thf(fact_181_local_Obdd__below__mono,axiom,(
    ! [B4: ( set @ a ),A4: ( set @ a )] :
      ( ( condit1201339847_below @ a @ less_eq @ B4 )
     => ( ( ord_less_eq @ ( set @ a ) @ A4 @ B4 )
       => ( condit1201339847_below @ a @ less_eq @ A4 ) ) ) )).

% local.bdd_below_mono
thf(fact_182_local_Obdd__above__mono,axiom,(
    ! [B4: ( set @ a ),A4: ( set @ a )] :
      ( ( condit2040224947_above @ a @ less_eq @ B4 )
     => ( ( ord_less_eq @ ( set @ a ) @ A4 @ B4 )
       => ( condit2040224947_above @ a @ less_eq @ A4 ) ) ) )).

% local.bdd_above_mono
thf(fact_183_local_Ostrict__mono__less__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( less_eq @ X @ Y ) ) ) ) )).

% local.strict_mono_less_eq
thf(fact_184_local_OIoc__subset__iff,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 ) @ ( set_gr323396891AtMost @ a @ less_eq @ less @ C @ D ) )
      = ( ( less_eq @ B2 @ A2 )
        | ( ( less_eq @ C @ A2 )
          & ( less_eq @ B2 @ D ) ) ) ) )).

% local.Ioc_subset_iff
thf(fact_185_local_Oantimono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( antimono @ a @ B @ less_eq @ F )
          = ( ! [X2: a,Y3: a] :
                ( ( less_eq @ X2 @ Y3 )
               => ( ord_less_eq @ B @ ( F @ Y3 ) @ ( F @ X2 ) ) ) ) ) ) )).

% local.antimono_def
thf(fact_186_local_OantimonoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y4: a] :
              ( ( less_eq @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F @ Y4 ) @ ( F @ X3 ) ) )
         => ( antimono @ a @ B @ less_eq @ F ) ) ) )).

% local.antimonoI
thf(fact_187_local_OantimonoE,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( antimono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) )).

% local.antimonoE
thf(fact_188_local_OantimonoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( antimono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) )).

% local.antimonoD
thf(fact_189_local_OInt__atMost,axiom,(
    ! [A2: a,B2: a] :
      ( ( inf_inf @ ( set @ a ) @ ( set_atMost @ a @ less_eq @ A2 ) @ ( set_atMost @ a @ less_eq @ B2 ) )
      = ( set_atMost @ a @ less_eq @ ( min @ a @ less_eq @ A2 @ B2 ) ) ) )).

% local.Int_atMost
thf(fact_190_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B2: A,A2: A] :
          ( ! [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
             => ( P @ A3 @ B3 ) )
         => ( ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
           => ( P @ A2 @ B2 ) ) ) ) )).

% wlog_linorder_le
thf(fact_191_local_OatLeastLessThan__subset__iff,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atLeastLessThan @ a @ less_eq @ less @ A2 @ B2 ) @ ( set_atLeastLessThan @ a @ less_eq @ less @ C @ D ) )
     => ( ( less_eq @ B2 @ A2 )
        | ( ( less_eq @ C @ A2 )
          & ( less_eq @ B2 @ D ) ) ) ) )).

% local.atLeastLessThan_subset_iff
thf(fact_192_local_OIic__subset__Iio__iff,axiom,(
    ! [A2: a,B2: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atMost @ a @ less_eq @ A2 ) @ ( set_lessThan @ a @ less @ B2 ) )
      = ( less @ A2 @ B2 ) ) )).

% local.Iic_subset_Iio_iff
thf(fact_193_local_OgreaterThan__Int__greaterThan,axiom,(
    ! [A2: a,B2: a] :
      ( ( inf_inf @ ( set @ a ) @ ( set_lessThan @ a @ less @ A2 ) @ ( set_lessThan @ a @ less @ B2 ) )
      = ( set_lessThan @ a @ less @ ( min @ a @ less_eq @ A2 @ B2 ) ) ) )).

% local.greaterThan_Int_greaterThan
thf(fact_194_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X2: a] :
            ( less @ X2 @ U ) ) ) )).

% local.lessThan_def
thf(fact_195_local_OatLeastLessThan__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_atLeastLessThan @ a @ less_eq @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_atLeast @ a @ less_eq @ L ) @ ( set_lessThan @ a @ less @ U ) ) ) )).

% local.atLeastLessThan_def
thf(fact_196_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_197_local_OatLeastLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_atLeastLessThan @ a @ less_eq @ less @ L @ U ) )
      = ( ( less_eq @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.atLeastLessThan_iff
thf(fact_198_local_Obdd__above__Iio,axiom,(
    ! [B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_lessThan @ a @ less @ B2 ) ) )).

% local.bdd_above_Iio
thf(fact_199_local_Obdd__above__Ico,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_atLeastLessThan @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_above_Ico
thf(fact_200_local_Obdd__below__Ico,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_atLeastLessThan @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_below_Ico
thf(fact_201_local_OgreaterThanLessThan__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ A2 ) @ ( set_lessThan @ a @ less @ B2 ) ) ) )).

% local.greaterThanLessThan_eq
thf(fact_202_local_OgreaterThanLessThan__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_gr1161524159ssThan @ a @ less @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_greaterThan @ a @ less @ L ) @ ( set_lessThan @ a @ less @ U ) ) ) )).

% local.greaterThanLessThan_def
thf(fact_203_local_OgreaterThanLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr1161524159ssThan @ a @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.greaterThanLessThan_iff
thf(fact_204_local_Obdd__below__Ioo,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 ) ) )).

% local.bdd_below_Ioo
thf(fact_205_local_Obdd__above__Ioo,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 ) ) )).

% local.bdd_above_Ioo
thf(fact_206_local_OatLeastAtMost__def,axiom,(
    ! [L: a,U: a] :
      ( ( set_atLeastAtMost @ a @ less_eq @ L @ U )
      = ( inf_inf @ ( set @ a ) @ ( set_atLeast @ a @ less_eq @ L ) @ ( set_atMost @ a @ less_eq @ U ) ) ) )).

% local.atLeastAtMost_def
thf(fact_207_Int__subset__iff,axiom,(
    ! [A: $tType,C2: ( set @ A ),A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C2 @ A4 )
        & ( ord_less_eq @ ( set @ A ) @ C2 @ B4 ) ) ) )).

% Int_subset_iff
thf(fact_208_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_209_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( member @ A @ X3 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% subsetI
thf(fact_210_Int__iff,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( member @ A @ C @ A4 )
        & ( member @ A @ C @ B4 ) ) ) )).

% Int_iff
thf(fact_211_IntI,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ A4 )
     => ( ( member @ A @ C @ B4 )
       => ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) ) ) ) )).

% IntI
thf(fact_212_local_OatLeastAtMost__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_atLeastAtMost @ a @ less_eq @ L @ U ) )
      = ( ( less_eq @ L @ I )
        & ( less_eq @ I @ U ) ) ) )).

% local.atLeastAtMost_iff
thf(fact_213_local_OIcc__eq__Icc,axiom,(
    ! [L: a,H: a,L2: a,H2: a] :
      ( ( ( set_atLeastAtMost @ a @ less_eq @ L @ H )
        = ( set_atLeastAtMost @ a @ less_eq @ L2 @ H2 ) )
      = ( ( ( L = L2 )
          & ( H = H2 ) )
        | ( ~ ( less_eq @ L @ H )
          & ~ ( less_eq @ L2 @ H2 ) ) ) ) )).

% local.Icc_eq_Icc
thf(fact_214_local_OatLeastatMost__subset__iff,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atLeastAtMost @ a @ less_eq @ A2 @ B2 ) @ ( set_atLeastAtMost @ a @ less_eq @ C @ D ) )
      = ( ~ ( less_eq @ A2 @ B2 )
        | ( ( less_eq @ C @ A2 )
          & ( less_eq @ B2 @ D ) ) ) ) )).

% local.atLeastatMost_subset_iff
thf(fact_215_local_Obdd__above__Icc,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_atLeastAtMost @ a @ less_eq @ A2 @ B2 ) ) )).

% local.bdd_above_Icc
thf(fact_216_local_Obdd__below__Icc,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_atLeastAtMost @ a @ less_eq @ A2 @ B2 ) ) )).

% local.bdd_below_Icc
thf(fact_217_local_OIcc__subset__Iic__iff,axiom,(
    ! [L: a,H: a,H2: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atLeastAtMost @ a @ less_eq @ L @ H ) @ ( set_atMost @ a @ less_eq @ H2 ) )
      = ( ~ ( less_eq @ L @ H )
        | ( less_eq @ H @ H2 ) ) ) )).

% local.Icc_subset_Iic_iff
thf(fact_218_local_OIcc__subset__Ici__iff,axiom,(
    ! [L: a,H: a,L2: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atLeastAtMost @ a @ less_eq @ L @ H ) @ ( set_atLeast @ a @ less_eq @ L2 ) )
      = ( ~ ( less_eq @ L @ H )
        | ( less_eq @ L2 @ L ) ) ) )).

% local.Icc_subset_Ici_iff
thf(fact_219_local_OInt__atLeastAtMostL1,axiom,(
    ! [A2: a,B2: a,D: a] :
      ( ( inf_inf @ ( set @ a ) @ ( set_atLeastAtMost @ a @ less_eq @ A2 @ B2 ) @ ( set_atMost @ a @ less_eq @ D ) )
      = ( set_atLeastAtMost @ a @ less_eq @ A2 @ ( min @ a @ less_eq @ B2 @ D ) ) ) )).

% local.Int_atLeastAtMostL1
thf(fact_220_local_OInt__atLeastAtMostR1,axiom,(
    ! [B2: a,C: a,D: a] :
      ( ( inf_inf @ ( set @ a ) @ ( set_atMost @ a @ less_eq @ B2 ) @ ( set_atLeastAtMost @ a @ less_eq @ C @ D ) )
      = ( set_atLeastAtMost @ a @ less_eq @ C @ ( min @ a @ less_eq @ B2 @ D ) ) ) )).

% local.Int_atLeastAtMostR1
thf(fact_221_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X2: A] :
            ( ( P @ X2 )
           => ( Q @ X2 ) ) ) ) )).

% Collect_mono_iff
thf(fact_222_contra__subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ~ ( member @ A @ C @ B4 )
       => ~ ( member @ A @ C @ A4 ) ) ) )).

% contra_subsetD
thf(fact_223_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y2: ( set @ A ),Z2: ( set @ A )] : ( Y2 = Z2 ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B5 )
            & ( ord_less_eq @ ( set @ A ) @ B5 @ A5 ) ) ) ) )).

% set_eq_subset
thf(fact_224_subset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ C2 )
       => ( ord_less_eq @ ( set @ A ) @ A4 @ C2 ) ) ) )).

% subset_trans
thf(fact_225_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_226_subset__refl,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ A4 ) )).

% subset_refl
thf(fact_227_rev__subsetD,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% rev_subsetD
thf(fact_228_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [T: A] :
            ( ( member @ A @ T @ A5 )
           => ( member @ A @ T @ B5 ) ) ) ) )).

% subset_iff
thf(fact_229_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% set_rev_mp
thf(fact_230_equalityD2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) )).

% equalityD2
thf(fact_231_equalityD1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% equalityD1
thf(fact_232_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A5 )
           => ( member @ A @ X2 @ B5 ) ) ) ) )).

% subset_eq
thf(fact_233_equalityE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( A4 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A4 ) ) ) )).

% equalityE
thf(fact_234_subsetCE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C @ A4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% subsetCE
thf(fact_235_subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C @ A4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% subsetD
thf(fact_236_in__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% in_mono
thf(fact_237_set__mp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% set_mp
thf(fact_238_Int__left__commute,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B4 @ C2 ) )
      = ( inf_inf @ ( set @ A ) @ B4 @ ( inf_inf @ ( set @ A ) @ A4 @ C2 ) ) ) )).

% Int_left_commute
thf(fact_239_Int__left__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B4 ) ) )).

% Int_left_absorb
thf(fact_240_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B5 @ A5 ) ) ) )).

% Int_commute
thf(fact_241_Int__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ A4 )
      = A4 ) )).

% Int_absorb
thf(fact_242_Int__assoc,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) @ C2 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B4 @ C2 ) ) ) )).

% Int_assoc
thf(fact_243_IntD2,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
     => ( member @ A @ C @ B4 ) ) )).

% IntD2
thf(fact_244_IntD1,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
     => ( member @ A @ C @ A4 ) ) )).

% IntD1
thf(fact_245_IntE,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) )
     => ~ ( ( member @ A @ C @ A4 )
         => ~ ( member @ A @ C @ B4 ) ) ) )).

% IntE
thf(fact_246_less__eq__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X2: A] :
                ( member @ A @ X2 @ A5 )
            @ ^ [X2: A] :
                ( member @ A @ X2 @ B5 ) ) ) ) )).

% less_eq_set_def
thf(fact_247_Int__def,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B5: ( set @ A )] :
            ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ A5 )
                & ( member @ A @ X2 @ B5 ) ) ) ) ) )).

% Int_def
thf(fact_248_Int__Collect,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),P: ( A > $o )] :
      ( ( member @ A @ X @ ( inf_inf @ ( set @ A ) @ A4 @ ( collect @ A @ P ) ) )
      = ( ( member @ A @ X @ A4 )
        & ( P @ X ) ) ) )).

% Int_Collect
thf(fact_249_Collect__conj__eq,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( ( P @ X2 )
            & ( Q @ X2 ) ) )
      = ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_conj_eq
thf(fact_250_Int__Collect__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( ( P @ X3 )
             => ( Q @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B4 @ ( collect @ A @ Q ) ) ) ) ) )).

% Int_Collect_mono
thf(fact_251_Int__greatest,axiom,(
    ! [A: $tType,C2: ( set @ A ),A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ C2 @ B4 )
       => ( ord_less_eq @ ( set @ A ) @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) ) ) ) )).

% Int_greatest
thf(fact_252_Int__absorb2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B4 )
        = A4 ) ) )).

% Int_absorb2
thf(fact_253_Int__absorb1,axiom,(
    ! [A: $tType,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B4 )
        = B4 ) ) )).

% Int_absorb1
thf(fact_254_Int__lower2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) @ B4 ) )).

% Int_lower2
thf(fact_255_Int__lower1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B4 ) @ A4 ) )).

% Int_lower1

%----Type constructors (4)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_1,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_2,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ! [Y5: a] :
      ( ( member @ a @ Y5 @ ( coinductive_lset @ a @ ysa ) )
     => ( ( less_eq @ x @ Y5 )
       => thesis ) ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
