%------------------------------------------------------------------------------
% File     : DAT158^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Hamming stream 184
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : hamming_stream__184.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  305 (   0 unit;  40 type;   0 defn)
%            Number of atoms       : 3883 ( 205 equality;2155 variable)
%            Maximal formula depth :   21 (   9 average)
%            Number of connectives : 3641 ( 168   ~;  51   |;  60   &;2977   @)
%                                         (   0 <=>; 385  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  211 ( 211   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   42 (  40   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  813 (   0 sgn; 734   !;  31   ?;  13   ^)
%                                         ( 813   :;  35  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:42:10.581
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (35)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Oldistinct,type,(
    coindu351974385stinct: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Oltl,type,(
    coinductive_ltl: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oord_Olsorted,type,(
    coinductive_lsorted: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__above,type,(
    condit2040224947_above: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder_Obdd__below,type,(
    condit1201339847_below: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Hamming__Stream__Mirabelle__rwekfkwckg_Oord_Olmerge,type,(
    hammin1328233080lmerge: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Olinorder_Oinsort__key,type,(
    insort_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_Orderings_Oord_OLeast,type,(
    least: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder_Oantimono,type,(
    antimono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Orderings_Oorder_Omono,type,(
    mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Orderings_Oordering,type,(
    ordering: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OatLeastLessThan,type,(
    set_atLeastLessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanAtMost,type,(
    set_gr323396891AtMost: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThanLessThan,type,(
    set_gr1161524159ssThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_less__eq,type,(
    less_eq: a > a > $o )).

thf(sy_v_xsa____,type,(
    xsa: ( coinductive_llist @ a ) )).

thf(sy_v_ysa____,type,(
    ysa: ( coinductive_llist @ a ) )).

%----Relevant facts (254)
thf(fact_0_local_Olmerge_Oexhaust,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( ( coinductive_lnull @ a @ Xs )
          | ( coinductive_lnull @ a @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ a @ Xs )
         => ( coinductive_lnull @ a @ Ys ) ) ) )).

% local.lmerge.exhaust
thf(fact_1_local_Oantisym,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less_eq @ Y @ X )
       => ( X = Y ) ) ) )).

% local.antisym
thf(fact_2_local_Oantisym__conv,axiom,(
    ! [Y: a,X: a] :
      ( ( less_eq @ Y @ X )
     => ( ( less_eq @ X @ Y )
        = ( X = Y ) ) ) )).

% local.antisym_conv
thf(fact_3_local_Odual__order_Oantisym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( less_eq @ A2 @ B2 )
       => ( A2 = B2 ) ) ) )).

% local.dual_order.antisym
thf(fact_4_local_Odual__order_Otrans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( less_eq @ C @ B2 )
       => ( less_eq @ C @ A2 ) ) ) )).

% local.dual_order.trans
thf(fact_5_local_Oeq__iff,axiom,
    ( ( ^ [Y2: a,Z: a] : ( Y2 = Z ) )
    = ( ^ [X2: a,Y3: a] :
          ( ( less_eq @ X2 @ Y3 )
          & ( less_eq @ Y3 @ X2 ) ) ) )).

% local.eq_iff
thf(fact_6_local_Oeq__refl,axiom,(
    ! [X: a,Y: a] :
      ( ( X = Y )
     => ( less_eq @ X @ Y ) ) )).

% local.eq_refl
thf(fact_7_local_Ole__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less_eq @ X @ Y )
     => ( less_eq @ Y @ X ) ) )).

% local.le_cases
thf(fact_8_local_Ole__cases3,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( ( less_eq @ X @ Y )
       => ~ ( less_eq @ Y @ Z2 ) )
     => ( ( ( less_eq @ Y @ X )
         => ~ ( less_eq @ X @ Z2 ) )
       => ( ( ( less_eq @ X @ Z2 )
           => ~ ( less_eq @ Z2 @ Y ) )
         => ( ( ( less_eq @ Z2 @ Y )
             => ~ ( less_eq @ Y @ X ) )
           => ( ( ( less_eq @ Y @ Z2 )
               => ~ ( less_eq @ Z2 @ X ) )
             => ~ ( ( less_eq @ Z2 @ X )
                 => ~ ( less_eq @ X @ Y ) ) ) ) ) ) ) )).

% local.le_cases3
thf(fact_9_local_Olinear,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
      | ( less_eq @ Y @ X ) ) )).

% local.linear
thf(fact_10_local_Olinorder__wlog,axiom,(
    ! [P: ( a > a > $o ),A2: a,B2: a] :
      ( ! [A3: a,B3: a] :
          ( ( less_eq @ A3 @ B3 )
         => ( P @ A3 @ B3 ) )
     => ( ! [A3: a,B3: a] :
            ( ( P @ B3 @ A3 )
           => ( P @ A3 @ B3 ) )
       => ( P @ A2 @ B2 ) ) ) )).

% local.linorder_wlog
thf(fact_11_local_Oord__eq__le__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.ord_eq_le_trans
thf(fact_12_local_Oord__le__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.ord_le_eq_trans
thf(fact_13_local_Oorder_Oantisym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less_eq @ B2 @ A2 )
       => ( A2 = B2 ) ) ) )).

% local.order.antisym
thf(fact_14_local_Oorder_Otrans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less_eq @ A2 @ C ) ) ) )).

% local.order.trans
thf(fact_15_local_Oorder__trans,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less_eq @ Y @ Z2 )
       => ( less_eq @ X @ Z2 ) ) ) )).

% local.order_trans
thf(fact_16_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_17_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_18_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_19_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_20_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_21_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_22_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_23_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_24_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_25_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_26_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_27_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_28_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_29_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_30_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z2 )
       => ( less @ X @ Z2 ) ) ) )).

% local.less_trans
thf(fact_31_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_32_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_33_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_34_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_35_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_36_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_37_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_38_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_39_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_40_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans
thf(fact_41_lsorted_I2_J,axiom,
    ( coinductive_lsorted @ a @ less_eq @ ysa )).

% lsorted(2)
thf(fact_42_lsorted_I1_J,axiom,
    ( coinductive_lsorted @ a @ less_eq @ xsa )).

% lsorted(1)
thf(fact_43_local_Oantisym__conv1,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( less_eq @ X @ Y )
        = ( X = Y ) ) ) )).

% local.antisym_conv1
thf(fact_44_local_Oantisym__conv2,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv2
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_Odual__order_Onot__eq__order__implies__strict,axiom,(
    ! [A2: a,B2: a] :
      ( ( A2 != B2 )
     => ( ( less_eq @ B2 @ A2 )
       => ( less @ B2 @ A2 ) ) ) )).

% local.dual_order.not_eq_order_implies_strict
thf(fact_50_local_Odual__order_Oorder__iff__strict,axiom,(
    ! [B2: a,A2: a] :
      ( ( less_eq @ B2 @ A2 )
      = ( ( less @ B2 @ A2 )
        | ( A2 = B2 ) ) ) )).

% local.dual_order.order_iff_strict
thf(fact_51_local_Odual__order_Ostrict__iff__order,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
      = ( ( less_eq @ B2 @ A2 )
        & ( A2 != B2 ) ) ) )).

% local.dual_order.strict_iff_order
thf(fact_52_local_Odual__order_Ostrict__implies__order,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( less_eq @ B2 @ A2 ) ) )).

% local.dual_order.strict_implies_order
thf(fact_53_local_Odual__order_Ostrict__trans1,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less_eq @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans1
thf(fact_54_local_Odual__order_Ostrict__trans2,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less_eq @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans2
thf(fact_55_local_OleD,axiom,(
    ! [Y: a,X: a] :
      ( ( less_eq @ Y @ X )
     => ~ ( less @ X @ Y ) ) )).

% local.leD
thf(fact_56_local_OleI,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( less_eq @ Y @ X ) ) )).

% local.leI
thf(fact_57_local_Ole__imp__less__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less @ X @ Y )
        | ( X = Y ) ) ) )).

% local.le_imp_less_or_eq
thf(fact_58_local_Ole__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
      = ( ( less @ X @ Y )
        | ( X = Y ) ) ) )).

% local.le_less
thf(fact_59_local_Ole__less__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less_eq @ X @ Y )
      | ( less @ Y @ X ) ) )).

% local.le_less_linear
thf(fact_60_local_Ole__less__trans,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( less_eq @ X @ Y )
     => ( ( less @ Y @ Z2 )
       => ( less @ X @ Z2 ) ) ) )).

% local.le_less_trans
thf(fact_61_local_Ole__neq__trans,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( A2 != B2 )
       => ( less @ A2 @ B2 ) ) ) )).

% local.le_neq_trans
thf(fact_62_local_Oless__imp__le,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( less_eq @ X @ Y ) ) )).

% local.less_imp_le
thf(fact_63_local_Oless__le,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      = ( ( less_eq @ X @ Y )
        & ( X != Y ) ) ) )).

% local.less_le
thf(fact_64_local_Oless__le__not__le,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      = ( ( less_eq @ X @ Y )
        & ~ ( less_eq @ Y @ X ) ) ) )).

% local.less_le_not_le
thf(fact_65_local_Oless__le__trans,axiom,(
    ! [X: a,Y: a,Z2: a] :
      ( ( less @ X @ Y )
     => ( ( less_eq @ Y @ Z2 )
       => ( less @ X @ Z2 ) ) ) )).

% local.less_le_trans
thf(fact_66_local_Onot__le,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less_eq @ X @ Y ) )
      = ( less @ Y @ X ) ) )).

% local.not_le
thf(fact_67_local_Onot__le__imp__less,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less_eq @ Y @ X )
     => ( less @ X @ Y ) ) )).

% local.not_le_imp_less
thf(fact_68_local_Onot__less,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( less_eq @ Y @ X ) ) )).

% local.not_less
thf(fact_69_local_Oorder_Onot__eq__order__implies__strict,axiom,(
    ! [A2: a,B2: a] :
      ( ( A2 != B2 )
     => ( ( less_eq @ A2 @ B2 )
       => ( less @ A2 @ B2 ) ) ) )).

% local.order.not_eq_order_implies_strict
thf(fact_70_local_Oorder_Oorder__iff__strict,axiom,(
    ! [A2: a,B2: a] :
      ( ( less_eq @ A2 @ B2 )
      = ( ( less @ A2 @ B2 )
        | ( A2 = B2 ) ) ) )).

% local.order.order_iff_strict
thf(fact_71_local_Oorder_Ostrict__iff__order,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
      = ( ( less_eq @ A2 @ B2 )
        & ( A2 != B2 ) ) ) )).

% local.order.strict_iff_order
thf(fact_72_local_Oorder_Ostrict__implies__order,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( less_eq @ A2 @ B2 ) ) )).

% local.order.strict_implies_order
thf(fact_73_local_Oorder_Ostrict__trans1,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less_eq @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans1
thf(fact_74_local_Oorder_Ostrict__trans2,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less_eq @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans2
thf(fact_75_lsorted_I3_J,axiom,(
    ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ xsa @ ysa ) ) )).

% lsorted(3)
thf(fact_76_local_Oin__lset__lmergeD,axiom,(
    ! [X: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( member @ a @ X @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) )
     => ( ( member @ a @ X @ ( coinductive_lset @ a @ Xs ) )
        | ( member @ a @ X @ ( coinductive_lset @ a @ Ys ) ) ) ) )).

% local.in_lset_lmergeD
thf(fact_77_local_Olmerge_Odisc_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lmerge.disc(2)
thf(fact_78_local_Olmerge_Odisc_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) )
     => ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) )).

% local.lmerge.disc(1)
thf(fact_79_local_Olsorted__ltlI,axiom,(
    ! [Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ Xs )
     => ( coinductive_lsorted @ a @ less_eq @ ( coinductive_ltl @ a @ Xs ) ) ) )).

% local.lsorted_ltlI
thf(fact_80_local_Oorder_Orefl,axiom,(
    ! [A2: a] :
      ( less_eq @ A2 @ A2 ) )).

% local.order.refl
thf(fact_81_local_Oorder__refl,axiom,(
    ! [X: a] :
      ( less_eq @ X @ X ) )).

% local.order_refl
thf(fact_82_local_OLeastI2__order,axiom,(
    ! [P: ( a > $o ),X: a,Q: ( a > $o )] :
      ( ( P @ X )
     => ( ! [Y4: a] :
            ( ( P @ Y4 )
           => ( less_eq @ X @ Y4 ) )
       => ( ! [X3: a] :
              ( ( P @ X3 )
             => ( ! [Y5: a] :
                    ( ( P @ Y5 )
                   => ( less_eq @ X3 @ Y5 ) )
               => ( Q @ X3 ) ) )
         => ( Q @ ( least @ a @ less_eq @ P ) ) ) ) ) )).

% local.LeastI2_order
thf(fact_83_local_OLeast__equality,axiom,(
    ! [P: ( a > $o ),X: a] :
      ( ( P @ X )
     => ( ! [Y4: a] :
            ( ( P @ Y4 )
           => ( less_eq @ X @ Y4 ) )
       => ( ( least @ a @ less_eq @ P )
          = X ) ) ) )).

% local.Least_equality
thf(fact_84_local_Olhd__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
              = ( coinductive_lhd @ a @ Xs ) ) )
          & ( ~ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
              = ( coinductive_lhd @ a @ Ys ) ) ) ) ) ) )).

% local.lhd_lmerge
thf(fact_85_local_Oltl__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lnull @ a @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Ys )
       => ( ( ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
              = ( hammin1328233080lmerge @ a @ less @ ( coinductive_ltl @ a @ Xs ) @ Ys ) ) )
          & ( ~ ( less @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ Ys ) )
           => ( ( ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) )
               => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_ltl @ a @ Ys ) ) ) )
              & ( ~ ( less @ ( coinductive_lhd @ a @ Ys ) @ ( coinductive_lhd @ a @ Xs ) )
               => ( ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ a @ less @ ( coinductive_ltl @ a @ Xs ) @ ( coinductive_ltl @ a @ Ys ) ) ) ) ) ) ) ) ) )).

% local.ltl_lmerge
thf(fact_86_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_87_local_Olsorted__coinduct_H,axiom,(
    ! [X4: ( ( coinductive_llist @ a ) > $o ),Xs: ( coinductive_llist @ a )] :
      ( ( X4 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ a )] :
            ( ( X4 @ Xs2 )
           => ( ~ ( coinductive_lnull @ a @ Xs2 )
             => ( ~ ( coinductive_lnull @ a @ ( coinductive_ltl @ a @ Xs2 ) )
               => ( ( less_eq @ ( coinductive_lhd @ a @ Xs2 ) @ ( coinductive_lhd @ a @ ( coinductive_ltl @ a @ Xs2 ) ) )
                  & ( ( X4 @ ( coinductive_ltl @ a @ Xs2 ) )
                    | ( coinductive_lsorted @ a @ less_eq @ ( coinductive_ltl @ a @ Xs2 ) ) ) ) ) ) )
       => ( coinductive_lsorted @ a @ less_eq @ Xs ) ) ) )).

% local.lsorted_coinduct'
thf(fact_88_local_Olsorted__lhdD,axiom,(
    ! [Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Xs )
       => ( ~ ( coinductive_lnull @ a @ ( coinductive_ltl @ a @ Xs ) )
         => ( less_eq @ ( coinductive_lhd @ a @ Xs ) @ ( coinductive_lhd @ a @ ( coinductive_ltl @ a @ Xs ) ) ) ) ) ) )).

% local.lsorted_lhdD
thf(fact_89_local_OlsortedD,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Y: a] :
      ( ( coinductive_lsorted @ a @ less_eq @ Xs )
     => ( ~ ( coinductive_lnull @ a @ Xs )
       => ( ( member @ a @ Y @ ( coinductive_lset @ a @ ( coinductive_ltl @ a @ Xs ) ) )
         => ( less_eq @ ( coinductive_lhd @ a @ Xs ) @ Y ) ) ) ) )).

% local.lsortedD
thf(fact_90_local_Olsorted__coinduct,axiom,(
    ! [X4: ( ( coinductive_llist @ a ) > $o ),Xs: ( coinductive_llist @ a )] :
      ( ( X4 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ a )] :
            ( ( X4 @ Xs2 )
           => ( ~ ( coinductive_lnull @ a @ Xs2 )
             => ( ! [X3: a] :
                    ( ( member @ a @ X3 @ ( coinductive_lset @ a @ ( coinductive_ltl @ a @ Xs2 ) ) )
                   => ( less_eq @ ( coinductive_lhd @ a @ Xs2 ) @ X3 ) )
                & ( ( X4 @ ( coinductive_ltl @ a @ Xs2 ) )
                  | ( coinductive_lsorted @ a @ less_eq @ ( coinductive_ltl @ a @ Xs2 ) ) ) ) ) )
       => ( coinductive_lsorted @ a @ less_eq @ Xs ) ) ) )).

% local.lsorted_coinduct
thf(fact_91_ord_Oin__lset__lmergeD,axiom,(
    ! [A: $tType,X: A,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        | ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% ord.in_lset_lmergeD
thf(fact_92_local_Olmerge_Osimps_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ~ ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ a @ Xs )
        & ~ ( coinductive_lnull @ a @ Ys ) ) ) )).

% local.lmerge.simps(2)
thf(fact_93_local_Olnull__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lnull @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) ) ) )).

% local.lnull_lmerge
thf(fact_94_local_OIoc__inj,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 )
        = ( set_gr323396891AtMost @ a @ less_eq @ less @ C @ D ) )
      = ( ( ( less_eq @ B2 @ A2 )
          & ( less_eq @ D @ C ) )
        | ( ( A2 = C )
          & ( B2 = D ) ) ) ) )).

% local.Ioc_inj
thf(fact_95_local_Oorder_Oordering__axioms,axiom,
    ( ordering @ a @ less_eq @ less )).

% local.order.ordering_axioms
thf(fact_96_local_Obdd__above__def,axiom,(
    ! [A4: ( set @ a )] :
      ( ( condit2040224947_above @ a @ less_eq @ A4 )
      = ( ? [M: a] :
          ! [X2: a] :
            ( ( member @ a @ X2 @ A4 )
           => ( less_eq @ X2 @ M ) ) ) ) )).

% local.bdd_above_def
thf(fact_97_local_Obdd__below__def,axiom,(
    ! [A4: ( set @ a )] :
      ( ( condit1201339847_below @ a @ less_eq @ A4 )
      = ( ? [M2: a] :
          ! [X2: a] :
            ( ( member @ a @ X2 @ A4 )
           => ( less_eq @ M2 @ X2 ) ) ) ) )).

% local.bdd_below_def
thf(fact_98_ord_Oltl__lmerge,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
              = ( hammin1328233080lmerge @ A @ Less @ ( coinductive_ltl @ A @ Xs ) @ Ys ) ) )
          & ( ~ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) )
               => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_ltl @ A @ Ys ) ) ) )
              & ( ~ ( Less @ ( coinductive_lhd @ A @ Ys ) @ ( coinductive_lhd @ A @ Xs ) )
               => ( ( coinductive_ltl @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
                  = ( hammin1328233080lmerge @ A @ Less @ ( coinductive_ltl @ A @ Xs ) @ ( coinductive_ltl @ A @ Ys ) ) ) ) ) ) ) ) ) )).

% ord.ltl_lmerge
thf(fact_99_local_Oinsort__key__left__comm,axiom,(
    ! [B: $tType,F: ( B > a ),X: B,Y: B,Xs: ( list @ B )] :
      ( ( ( F @ X )
       != ( F @ Y ) )
     => ( ( insort_key @ a @ B @ less_eq @ F @ Y @ ( insort_key @ a @ B @ less_eq @ F @ X @ Xs ) )
        = ( insort_key @ a @ B @ less_eq @ F @ X @ ( insort_key @ a @ B @ less_eq @ F @ Y @ Xs ) ) ) ) )).

% local.insort_key_left_comm
thf(fact_100_ord_Olhd__lmerge,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
              = ( coinductive_lhd @ A @ Xs ) ) )
          & ( ~ ( Less @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ Ys ) )
           => ( ( coinductive_lhd @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
              = ( coinductive_lhd @ A @ Ys ) ) ) ) ) ) )).

% ord.lhd_lmerge
thf(fact_101_local_Olmerge__eq__LNil__iff,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
        = ( coinductive_LNil @ a ) )
      = ( ( Xs
          = ( coinductive_LNil @ a ) )
        | ( Ys
          = ( coinductive_LNil @ a ) ) ) ) )).

% local.lmerge_eq_LNil_iff
thf(fact_102_in__lset__lmergeI1,axiom,(
    ! [X: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( member @ a @ X @ ( coinductive_lset @ a @ Xs ) )
     => ( ( coinductive_lsorted @ a @ less_eq @ Xs )
       => ( ~ ( coinductive_lfinite @ a @ Ys )
         => ( ? [X5: a] :
                ( ( member @ a @ X5 @ ( coinductive_lset @ a @ Ys ) )
                & ( less_eq @ X @ X5 ) )
           => ( member @ a @ X @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) ) ) ) )).

% in_lset_lmergeI1
thf(fact_103_in__lset__lmergeI2,axiom,(
    ! [X: a,Ys: ( coinductive_llist @ a ),Xs: ( coinductive_llist @ a )] :
      ( ( member @ a @ X @ ( coinductive_lset @ a @ Ys ) )
     => ( ( coinductive_lsorted @ a @ less_eq @ Ys )
       => ( ~ ( coinductive_lfinite @ a @ Xs )
         => ( ? [X5: a] :
                ( ( member @ a @ X5 @ ( coinductive_lset @ a @ Xs ) )
                & ( less_eq @ X @ X5 ) )
           => ( member @ a @ X @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) ) ) ) )).

% in_lset_lmergeI2
thf(fact_104_local_Olsorted_OLNil,axiom,
    ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LNil @ a ) )).

% local.lsorted.LNil
thf(fact_105_local_Olinfinite__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ~ ( coinductive_lfinite @ a @ Xs )
     => ( ~ ( coinductive_lfinite @ a @ Ys )
       => ~ ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.linfinite_lmerge
thf(fact_106_local_Olfinite__lmergeI,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lfinite @ a @ Xs )
     => ( ( coinductive_lfinite @ a @ Ys )
       => ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lfinite_lmergeI
thf(fact_107_local_Olfinite__lmergeD,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lfinite @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) )
     => ( ( coinductive_lfinite @ a @ Xs )
        | ( coinductive_lfinite @ a @ Ys ) ) ) )).

% local.lfinite_lmergeD
thf(fact_108_local_Olmerge_Octr_I1_J,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( coinductive_lnull @ a @ Xs )
        | ( coinductive_lnull @ a @ Ys ) )
     => ( ( hammin1328233080lmerge @ a @ less @ Xs @ Ys )
        = ( coinductive_LNil @ a ) ) ) )).

% local.lmerge.ctr(1)
thf(fact_109_local_Obdd__belowI,axiom,(
    ! [A4: ( set @ a ),M3: a] :
      ( ! [X3: a] :
          ( ( member @ a @ X3 @ A4 )
         => ( less_eq @ M3 @ X3 ) )
     => ( condit1201339847_below @ a @ less_eq @ A4 ) ) )).

% local.bdd_belowI
thf(fact_110_local_Obdd__aboveI,axiom,(
    ! [A4: ( set @ a ),M4: a] :
      ( ! [X3: a] :
          ( ( member @ a @ X3 @ A4 )
         => ( less_eq @ X3 @ M4 ) )
     => ( condit2040224947_above @ a @ less_eq @ A4 ) ) )).

% local.bdd_aboveI
thf(fact_111_local_Olsorted__code_I1_J,axiom,
    ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LNil @ a ) )).

% local.lsorted_code(1)
thf(fact_112_local_Olmerge__LNil_I1_J,axiom,(
    ! [Ys: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LNil @ a ) @ Ys )
      = ( coinductive_LNil @ a ) ) )).

% local.lmerge_LNil(1)
thf(fact_113_local_Olmerge__LNil_I2_J,axiom,(
    ! [Xs: ( coinductive_llist @ a )] :
      ( ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_LNil @ a ) )
      = ( coinductive_LNil @ a ) ) )).

% local.lmerge_LNil(2)
thf(fact_114_local_OgreaterThanAtMost__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr323396891AtMost @ a @ less_eq @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less_eq @ I @ U ) ) ) )).

% local.greaterThanAtMost_iff
thf(fact_115_local_Obdd__below__Ioc,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_below_Ioc
thf(fact_116_local_Obdd__above__Ioc,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_above_Ioc
thf(fact_117_local_Ostrict__mono__mono,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( mono @ a @ B @ less_eq @ F ) ) ) )).

% local.strict_mono_mono
thf(fact_118_ord_Olmerge_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) )
     => ( ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys )
        = ( coinductive_LNil @ A ) ) ) )).

% ord.lmerge.ctr(1)
thf(fact_119_ord_Olinfinite__lmerge,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ~ ( coinductive_lfinite @ A @ Ys )
       => ~ ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.linfinite_lmerge
thf(fact_120_ord_Olfinite__lmergeI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lfinite_lmergeI
thf(fact_121_ord_Olfinite__lmergeD,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
     => ( ( coinductive_lfinite @ A @ Xs )
        | ( coinductive_lfinite @ A @ Ys ) ) ) )).

% ord.lfinite_lmergeD
thf(fact_122_ord_Olmerge__eq__LNil__iff,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% ord.lmerge_eq_LNil_iff
thf(fact_123_ord_Olmerge__LNil_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LNil @ A ) @ Ys )
      = ( coinductive_LNil @ A ) ) )).

% ord.lmerge_LNil(1)
thf(fact_124_ord_Olmerge__LNil_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ord.lmerge_LNil(2)
thf(fact_125_ord__class_Olmerge_Oexhaust,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ~ ( ( coinductive_lnull @ A @ Xs )
              | ( coinductive_lnull @ A @ Ys ) )
         => ~ ( ~ ( coinductive_lnull @ A @ Xs )
             => ( coinductive_lnull @ A @ Ys ) ) ) ) )).

% ord_class.lmerge.exhaust
thf(fact_126_ord_Olmerge_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ A @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.exhaust
thf(fact_127_ord_Olnull__lmerge,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lnull_lmerge
thf(fact_128_ord_Olmerge_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% ord.lmerge.disc_iff(2)
thf(fact_129_ord_Olmerge_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ( ( coinductive_lnull @ A @ Xs )
        | ( coinductive_lnull @ A @ Ys ) )
     => ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) )).

% ord.lmerge.disc(1)
thf(fact_130_ord_Olmerge_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Less: ( A > A > $o )] :
      ( ~ ( coinductive_lnull @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Ys )
       => ~ ( coinductive_lnull @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lmerge.disc(2)
thf(fact_131_lfinite__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_ltl @ A @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_ltl
thf(fact_132_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_133_ord_Olsorted__coinduct_H,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A ),Less_eq: ( A > A > $o )] :
      ( ( X4 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( X4 @ Xs2 )
           => ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs2 ) )
               => ( ( Less_eq @ ( coinductive_lhd @ A @ Xs2 ) @ ( coinductive_lhd @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
                  & ( ( X4 @ ( coinductive_ltl @ A @ Xs2 ) )
                    | ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_ltl @ A @ Xs2 ) ) ) ) ) ) )
       => ( coinductive_lsorted @ A @ Less_eq @ Xs ) ) ) )).

% ord.lsorted_coinduct'
thf(fact_134_ord_Olsorted__lhdD,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ~ ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs ) )
         => ( Less_eq @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lhd @ A @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) ) )).

% ord.lsorted_lhdD
thf(fact_135_llist__set__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ~ ( coinductive_lnull @ A @ Xs2 )
           => ( P @ ( coinductive_lhd @ A @ Xs2 ) @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),Y4: A] :
              ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ( member @ A @ Y4 @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
               => ( ( P @ Y4 @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P @ Y4 @ Xs2 ) ) ) )
         => ( P @ X @ Xs ) ) ) ) )).

% llist_set_induct
thf(fact_136_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_137_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_138_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist: ( coinductive_llist @ A )] :
            ( Llist
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_139_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist2 )
     => ( Llist2
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_140_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A )] :
      ( ( Llist2
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist2 ) ) )).

% llist.discI(1)
thf(fact_141_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_142_ltakeWhile_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ~ ( P @ ( coinductive_lhd @ A @ Xs ) ) ) ) )).

% ltakeWhile.exhaust
thf(fact_143_lnull__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lnull @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% lnull_ltlI
thf(fact_144_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_145_ltl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( coinductive_ltl @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% ltl_simps(1)
thf(fact_146_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_147_in__lset__ltlD,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ltlD
thf(fact_148_ord_OLNil,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o )] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LNil @ A ) ) )).

% ord.LNil
thf(fact_149_ord_Olsorted__code_I1_J,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o )] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LNil @ A ) ) )).

% ord.lsorted_code(1)
thf(fact_150_ord_Olsorted__ltlI,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ Xs )
     => ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% ord.lsorted_ltlI
thf(fact_151_llist_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( member @ A @ ( coinductive_lhd @ A @ A2 ) @ ( coinductive_lset @ A @ A2 ) ) ) )).

% llist.set_sel(1)
thf(fact_152_llist_Oexpand,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Llist2 )
        = ( coinductive_lnull @ A @ Llist3 ) )
     => ( ( ~ ( coinductive_lnull @ A @ Llist2 )
         => ( ~ ( coinductive_lnull @ A @ Llist3 )
           => ( ( ( coinductive_lhd @ A @ Llist2 )
                = ( coinductive_lhd @ A @ Llist3 ) )
              & ( ( coinductive_ltl @ A @ Llist2 )
                = ( coinductive_ltl @ A @ Llist3 ) ) ) ) )
       => ( Llist2 = Llist3 ) ) ) )).

% llist.expand
thf(fact_153_llist_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist2: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( R @ Llist2 @ Llist3 )
     => ( ! [Llist4: ( coinductive_llist @ A ),Llist5: ( coinductive_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coinductive_lnull @ A @ Llist4 )
                = ( coinductive_lnull @ A @ Llist5 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist4 )
               => ( ~ ( coinductive_lnull @ A @ Llist5 )
                 => ( ( ( coinductive_lhd @ A @ Llist4 )
                      = ( coinductive_lhd @ A @ Llist5 ) )
                    & ( R @ ( coinductive_ltl @ A @ Llist4 ) @ ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) ) )
       => ( Llist2 = Llist3 ) ) ) )).

% llist.coinduct
thf(fact_154_llist_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ),Llist2: ( coinductive_llist @ A ),Llist3: ( coinductive_llist @ A )] :
      ( ( R @ Llist2 @ Llist3 )
     => ( ! [Llist4: ( coinductive_llist @ A ),Llist5: ( coinductive_llist @ A )] :
            ( ( R @ Llist4 @ Llist5 )
           => ( ( ( coinductive_lnull @ A @ Llist4 )
                = ( coinductive_lnull @ A @ Llist5 ) )
              & ( ~ ( coinductive_lnull @ A @ Llist4 )
               => ( ~ ( coinductive_lnull @ A @ Llist5 )
                 => ( ( ( coinductive_lhd @ A @ Llist4 )
                      = ( coinductive_lhd @ A @ Llist5 ) )
                    & ( ( R @ ( coinductive_ltl @ A @ Llist4 ) @ ( coinductive_ltl @ A @ Llist5 ) )
                      | ( ( coinductive_ltl @ A @ Llist4 )
                        = ( coinductive_ltl @ A @ Llist5 ) ) ) ) ) ) ) )
       => ( Llist2 = Llist3 ) ) ) )).

% llist.coinduct_strong
thf(fact_155_llist_Oset__sel_I2_J,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),X: A] :
      ( ~ ( coinductive_lnull @ A @ A2 )
     => ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ A2 ) ) )
       => ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) ) ) ) )).

% llist.set_sel(2)
thf(fact_156_lfinite__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lnull @ A @ Xs2 )
           => ( P @ Xs2 ) )
       => ( ! [Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ~ ( coinductive_lnull @ A @ Xs2 )
               => ( ( P @ ( coinductive_ltl @ A @ Xs2 ) )
                 => ( P @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lfinite_induct
thf(fact_157_local_Olsorted__ldistinct__lset__unique,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ Xs )
     => ( ( coindu351974385stinct @ a @ Xs )
       => ( ( coinductive_lsorted @ a @ less_eq @ Ys )
         => ( ( coindu351974385stinct @ a @ Ys )
           => ( ( ( coinductive_lset @ a @ Xs )
                = ( coinductive_lset @ a @ Ys ) )
             => ( Xs = Ys ) ) ) ) ) ) )).

% local.lsorted_ldistinct_lset_unique
thf(fact_158_local_Ostrict__mono__less__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( less_eq @ X @ Y ) ) ) ) )).

% local.strict_mono_less_eq
thf(fact_159_local_OIoc__subset__iff,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_gr323396891AtMost @ a @ less_eq @ less @ A2 @ B2 ) @ ( set_gr323396891AtMost @ a @ less_eq @ less @ C @ D ) )
      = ( ( less_eq @ B2 @ A2 )
        | ( ( less_eq @ C @ A2 )
          & ( less_eq @ B2 @ D ) ) ) ) )).

% local.Ioc_subset_iff
thf(fact_160_local_Olsorted__LCons_H,axiom,(
    ! [X: a,Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ Xs ) )
      = ( ~ ( coinductive_lnull @ a @ Xs )
       => ( ( less_eq @ X @ ( coinductive_lhd @ a @ Xs ) )
          & ( coinductive_lsorted @ a @ less_eq @ Xs ) ) ) ) )).

% local.lsorted_LCons'
thf(fact_161_local_Olsorted_OLCons__LCons,axiom,(
    ! [X: a,Y: a,Xs: ( coinductive_llist @ a )] :
      ( ( less_eq @ X @ Y )
     => ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y @ Xs ) )
       => ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ ( coinductive_LCons @ a @ Y @ Xs ) ) ) ) ) )).

% local.lsorted.LCons_LCons
thf(fact_162_local_Omono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( mono @ a @ B @ less_eq @ F )
          = ( ! [X2: a,Y3: a] :
                ( ( less_eq @ X2 @ Y3 )
               => ( ord_less_eq @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) ) ) )).

% local.mono_def
thf(fact_163_local_OmonoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y4: a] :
              ( ( less_eq @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F @ X3 ) @ ( F @ Y4 ) ) )
         => ( mono @ a @ B @ less_eq @ F ) ) ) )).

% local.monoI
thf(fact_164_local_OmonoE,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( mono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.monoE
thf(fact_165_local_OmonoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( mono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.monoD
thf(fact_166_local_Olmerge__simps,axiom,(
    ! [X: a,Y: a,Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ( ( less @ X @ Y )
       => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ ( coinductive_LCons @ a @ Y @ Ys ) )
          = ( coinductive_LCons @ a @ X @ ( hammin1328233080lmerge @ a @ less @ Xs @ ( coinductive_LCons @ a @ Y @ Ys ) ) ) ) )
      & ( ~ ( less @ X @ Y )
       => ( ( ( less @ Y @ X )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ ( coinductive_LCons @ a @ Y @ Ys ) )
              = ( coinductive_LCons @ a @ Y @ ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ Ys ) ) ) )
          & ( ~ ( less @ Y @ X )
           => ( ( hammin1328233080lmerge @ a @ less @ ( coinductive_LCons @ a @ X @ Xs ) @ ( coinductive_LCons @ a @ Y @ Ys ) )
              = ( coinductive_LCons @ a @ Y @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) ) ) ) ) ) )).

% local.lmerge_simps
thf(fact_167_local_Obdd__below__mono,axiom,(
    ! [B4: ( set @ a ),A4: ( set @ a )] :
      ( ( condit1201339847_below @ a @ less_eq @ B4 )
     => ( ( ord_less_eq @ ( set @ a ) @ A4 @ B4 )
       => ( condit1201339847_below @ a @ less_eq @ A4 ) ) ) )).

% local.bdd_below_mono
thf(fact_168_local_Obdd__above__mono,axiom,(
    ! [B4: ( set @ a ),A4: ( set @ a )] :
      ( ( condit2040224947_above @ a @ less_eq @ B4 )
     => ( ( ord_less_eq @ ( set @ a ) @ A4 @ B4 )
       => ( condit2040224947_above @ a @ less_eq @ A4 ) ) ) )).

% local.bdd_above_mono
thf(fact_169_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_170_local_Olsorted_Osimps,axiom,(
    ! [A2: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ A2 )
      = ( ( A2
          = ( coinductive_LNil @ a ) )
        | ? [X2: a] :
            ( A2
            = ( coinductive_LCons @ a @ X2 @ ( coinductive_LNil @ a ) ) )
        | ? [X2: a,Y3: a,Xs3: ( coinductive_llist @ a )] :
            ( ( A2
              = ( coinductive_LCons @ a @ X2 @ ( coinductive_LCons @ a @ Y3 @ Xs3 ) ) )
            & ( less_eq @ X2 @ Y3 )
            & ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y3 @ Xs3 ) ) ) ) ) )).

% local.lsorted.simps
thf(fact_171_local_Olsorted_Ocoinduct,axiom,(
    ! [X4: ( ( coinductive_llist @ a ) > $o ),X: ( coinductive_llist @ a )] :
      ( ( X4 @ X )
     => ( ! [X3: ( coinductive_llist @ a )] :
            ( ( X4 @ X3 )
           => ( ( X3
                = ( coinductive_LNil @ a ) )
              | ? [Xa: a] :
                  ( X3
                  = ( coinductive_LCons @ a @ Xa @ ( coinductive_LNil @ a ) ) )
              | ? [Xa: a,Y5: a,Xs4: ( coinductive_llist @ a )] :
                  ( ( X3
                    = ( coinductive_LCons @ a @ Xa @ ( coinductive_LCons @ a @ Y5 @ Xs4 ) ) )
                  & ( less_eq @ Xa @ Y5 )
                  & ( ( X4 @ ( coinductive_LCons @ a @ Y5 @ Xs4 ) )
                    | ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y5 @ Xs4 ) ) ) ) ) )
       => ( coinductive_lsorted @ a @ less_eq @ X ) ) ) )).

% local.lsorted.coinduct
thf(fact_172_local_Olsorted_Ocases,axiom,(
    ! [A2: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ a ) )
       => ( ! [X3: a] :
              ( A2
             != ( coinductive_LCons @ a @ X3 @ ( coinductive_LNil @ a ) ) )
         => ~ ( ! [X3: a,Y4: a,Xs2: ( coinductive_llist @ a )] :
                  ( ( A2
                    = ( coinductive_LCons @ a @ X3 @ ( coinductive_LCons @ a @ Y4 @ Xs2 ) ) )
                 => ( ( less_eq @ X3 @ Y4 )
                   => ~ ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y4 @ Xs2 ) ) ) ) ) ) ) ) )).

% local.lsorted.cases
thf(fact_173_local_Olsorted_OSingleton,axiom,(
    ! [X: a] :
      ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ ( coinductive_LNil @ a ) ) ) )).

% local.lsorted.Singleton
thf(fact_174_local_Olsorted__LCons,axiom,(
    ! [X: a,Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ Xs ) )
      = ( ( coinductive_lsorted @ a @ less_eq @ Xs )
        & ! [X2: a] :
            ( ( member @ a @ X2 @ ( coinductive_lset @ a @ Xs ) )
           => ( less_eq @ X @ X2 ) ) ) ) )).

% local.lsorted_LCons
thf(fact_175_local_Oantimono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( antimono @ a @ B @ less_eq @ F )
          = ( ! [X2: a,Y3: a] :
                ( ( less_eq @ X2 @ Y3 )
               => ( ord_less_eq @ B @ ( F @ Y3 ) @ ( F @ X2 ) ) ) ) ) ) )).

% local.antimono_def
thf(fact_176_local_OantimonoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y4: a] :
              ( ( less_eq @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F @ Y4 ) @ ( F @ X3 ) ) )
         => ( antimono @ a @ B @ less_eq @ F ) ) ) )).

% local.antimonoI
thf(fact_177_local_OantimonoE,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( antimono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) )).

% local.antimonoE
thf(fact_178_local_OantimonoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( antimono @ a @ B @ less_eq @ F )
         => ( ( less_eq @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) )).

% local.antimonoD
thf(fact_179_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_180_lfinite__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_181_ldistinct__LNil__code,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct_LNil_code
thf(fact_182_ldistinct__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        & ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_LCons
thf(fact_183_local_Olsorted__LCons__LCons,axiom,(
    ! [X: a,Y: a,Xs: ( coinductive_llist @ a )] :
      ( ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ ( coinductive_LCons @ a @ Y @ Xs ) ) )
      = ( ( less_eq @ X @ Y )
        & ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ Y @ Xs ) ) ) ) )).

% local.lsorted_LCons_LCons
thf(fact_184_lhd__LCons__ltl,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lnull @ A @ Llist2 )
     => ( ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist2 ) @ ( coinductive_ltl @ A @ Llist2 ) )
        = Llist2 ) ) )).

% lhd_LCons_ltl
thf(fact_185_local_Olsorted__code_I2_J,axiom,(
    ! [X: a] :
      ( coinductive_lsorted @ a @ less_eq @ ( coinductive_LCons @ a @ X @ ( coinductive_LNil @ a ) ) ) )).

% local.lsorted_code(2)
thf(fact_186_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.disc(2)
thf(fact_187_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A ),X21: A,X22: ( coinductive_llist @ A )] :
      ( ( Llist2
        = ( coinductive_LCons @ A @ X21 @ X22 ) )
     => ~ ( coinductive_lnull @ A @ Llist2 ) ) )).

% llist.discI(2)
thf(fact_188_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_189_llist_Oexhaust,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( Y
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llist.exhaust
thf(fact_190_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X2: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X2 @ Xs5 ) ) ) ) )).

% neq_LNil_conv
thf(fact_191_ldistinct_OLNil,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct.LNil
thf(fact_192_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X2: A,Xs5: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X2 @ Xs5 ) ) ) ) )).

% not_lnull_conv
thf(fact_193_ldistinct_OLCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ( coindu351974385stinct @ A @ Xs )
       => ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) ) )).

% ldistinct.LCons
thf(fact_194_ldistinct_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [X3: A,Xs2: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ X3 @ Xs2 ) )
               => ( ~ ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs2 ) )
                 => ~ ( coindu351974385stinct @ A @ Xs2 ) ) ) ) ) ) )).

% ldistinct.cases
thf(fact_195_ldistinct_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu351974385stinct @ A )
      = ( ^ [A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [X2: A,Xs3: ( coinductive_llist @ A )] :
                ( ( A5
                  = ( coinductive_LCons @ A @ X2 @ Xs3 ) )
                & ~ ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs3 ) )
                & ( coindu351974385stinct @ A @ Xs3 ) ) ) ) ) )).

% ldistinct.simps
thf(fact_196_ldistinct_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A )] :
      ( ( X4 @ X )
     => ( ! [X3: ( coinductive_llist @ A )] :
            ( ( X4 @ X3 )
           => ( ( X3
                = ( coinductive_LNil @ A ) )
              | ? [Xa: A,Xs4: ( coinductive_llist @ A )] :
                  ( ( X3
                    = ( coinductive_LCons @ A @ Xa @ Xs4 ) )
                  & ~ ( member @ A @ Xa @ ( coinductive_lset @ A @ Xs4 ) )
                  & ( ( X4 @ Xs4 )
                    | ( coindu351974385stinct @ A @ Xs4 ) ) ) ) )
       => ( coindu351974385stinct @ A @ X ) ) ) )).

% ldistinct.coinduct
thf(fact_197_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_198_ord_OLCons__LCons,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( Less_eq @ X @ Y )
     => ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y @ Xs ) )
       => ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) ) ) )).

% ord.LCons_LCons
thf(fact_199_ord_Olsorted__LCons__LCons,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) )
      = ( ( Less_eq @ X @ Y )
        & ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) ) )).

% ord.lsorted_LCons_LCons
thf(fact_200_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_201_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A2: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) )
       => ( ! [Z1: A,Z22: ( coinductive_llist @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( coinductive_lset @ A @ Z22 ) )
             => ( ( P @ Xa2 @ Z22 )
               => ( P @ Xa2 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% llist.set_induct
thf(fact_202_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A2 ) )
     => ( ! [Z22: ( coinductive_llist @ A )] :
            ( A2
           != ( coinductive_LCons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
                ( ( A2
                  = ( coinductive_LCons @ A @ Z1 @ Z22 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z22 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_203_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_204_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X6: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( X != X6 )
               => ( ( P @ Xs2 )
                 => ( P @ ( coinductive_LCons @ A @ X6 @ Xs2 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_205_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs6: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X @ Xs6 ) )
       => ~ ( ! [X6: A,Xs6: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X6 @ Xs6 ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs6 ) ) ) ) ) ) )).

% lset_cases
thf(fact_206_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_207_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_208_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_209_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),X7: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X7 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_210_ltl__simps_I2_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_ltl @ A @ ( coinductive_LCons @ A @ X21 @ X22 ) )
      = X22 ) )).

% ltl_simps(2)
thf(fact_211_ldistinct__ltlI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( coindu351974385stinct @ A @ ( coinductive_ltl @ A @ Xs ) ) ) )).

% ldistinct_ltlI
thf(fact_212_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B2: A,A2: A] :
          ( ! [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
             => ( P @ A3 @ B3 ) )
         => ( ( ( P @ B2 @ A2 )
             => ( P @ A2 @ B2 ) )
           => ( P @ A2 @ B2 ) ) ) ) )).

% wlog_linorder_le
thf(fact_213_ord_Olmerge__simps,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( Less @ X @ Y )
       => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
          = ( coinductive_LCons @ A @ X @ ( hammin1328233080lmerge @ A @ Less @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )
      & ( ~ ( Less @ X @ Y )
       => ( ( ( Less @ Y @ X )
           => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
              = ( coinductive_LCons @ A @ Y @ ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ Ys ) ) ) )
          & ( ~ ( Less @ Y @ X )
           => ( ( hammin1328233080lmerge @ A @ Less @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
              = ( coinductive_LCons @ A @ Y @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) ) ) ) ) ) )).

% ord.lmerge_simps
thf(fact_214_lfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X3: A] :
                    ( A2
                    = ( coinductive_LCons @ A @ X3 @ Xs2 ) )
               => ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% lfinite.cases
thf(fact_215_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [Xs3: ( coinductive_llist @ A ),X2: A] :
                ( ( A5
                  = ( coinductive_LCons @ A @ X2 @ Xs3 ) )
                & ( coinductive_lfinite @ A @ Xs3 ) ) ) ) ) )).

% lfinite.simps
thf(fact_216_lfinite_Oinducts,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),X3: A] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ X ) ) ) ) )).

% lfinite.inducts
thf(fact_217_ord_Olsorted__code_I2_J,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) )).

% ord.lsorted_code(2)
thf(fact_218_ord_Olsorted_Ocases,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ( ! [X3: A] :
              ( A2
             != ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) )
         => ~ ( ! [X3: A,Y4: A,Xs2: ( coinductive_llist @ A )] :
                  ( ( A2
                    = ( coinductive_LCons @ A @ X3 @ ( coinductive_LCons @ A @ Y4 @ Xs2 ) ) )
                 => ( ( Less_eq @ X3 @ Y4 )
                   => ~ ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y4 @ Xs2 ) ) ) ) ) ) ) ) )).

% ord.lsorted.cases
thf(fact_219_ord_Olsorted_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lsorted @ A )
      = ( ^ [Less_eq2: ( A > A > $o ),A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [X2: A] :
                ( A5
                = ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) )
            | ? [X2: A,Y3: A,Xs3: ( coinductive_llist @ A )] :
                ( ( A5
                  = ( coinductive_LCons @ A @ X2 @ ( coinductive_LCons @ A @ Y3 @ Xs3 ) ) )
                & ( Less_eq2 @ X2 @ Y3 )
                & ( coinductive_lsorted @ A @ Less_eq2 @ ( coinductive_LCons @ A @ Y3 @ Xs3 ) ) ) ) ) ) )).

% ord.lsorted.simps
thf(fact_220_ord_Olsorted_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A ),Less_eq: ( A > A > $o )] :
      ( ( X4 @ X )
     => ( ! [X3: ( coinductive_llist @ A )] :
            ( ( X4 @ X3 )
           => ( ( X3
                = ( coinductive_LNil @ A ) )
              | ? [Xa: A] :
                  ( X3
                  = ( coinductive_LCons @ A @ Xa @ ( coinductive_LNil @ A ) ) )
              | ? [Xa: A,Y5: A,Xs4: ( coinductive_llist @ A )] :
                  ( ( X3
                    = ( coinductive_LCons @ A @ Xa @ ( coinductive_LCons @ A @ Y5 @ Xs4 ) ) )
                  & ( Less_eq @ Xa @ Y5 )
                  & ( ( X4 @ ( coinductive_LCons @ A @ Y5 @ Xs4 ) )
                    | ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ Y5 @ Xs4 ) ) ) ) ) )
       => ( coinductive_lsorted @ A @ Less_eq @ X ) ) ) )).

% ord.lsorted.coinduct
thf(fact_221_ord_OSingleton,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A] :
      ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) )).

% ord.Singleton
thf(fact_222_lset__ltl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) @ ( coinductive_lset @ A @ Xs ) ) )).

% lset_ltl
thf(fact_223_llist_Oexhaust__sel,axiom,(
    ! [A: $tType,Llist2: ( coinductive_llist @ A )] :
      ( ( Llist2
       != ( coinductive_LNil @ A ) )
     => ( Llist2
        = ( coinductive_LCons @ A @ ( coinductive_lhd @ A @ Llist2 ) @ ( coinductive_ltl @ A @ Llist2 ) ) ) ) )).

% llist.exhaust_sel
thf(fact_224_eq__LConsD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( Xs
        = ( coinductive_LCons @ A @ Y @ Ys ) )
     => ( ( Xs
         != ( coinductive_LNil @ A ) )
        & ( ( coinductive_lhd @ A @ Xs )
          = Y )
        & ( ( coinductive_ltl @ A @ Xs )
          = Ys ) ) ) )).

% eq_LConsD
thf(fact_225_ord_Olsorted__LCons_H,axiom,(
    ! [A: $tType,Less_eq: ( A > A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lsorted @ A @ Less_eq @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( Less_eq @ X @ ( coinductive_lhd @ A @ Xs ) )
          & ( coinductive_lsorted @ A @ Less_eq @ Xs ) ) ) ) )).

% ord.lsorted_LCons'
thf(fact_226_ldistinct__coinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( X4 @ Xs )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( ( X4 @ Xs2 )
           => ( ~ ( coinductive_lnull @ A @ Xs2 )
             => ( ~ ( member @ A @ ( coinductive_lhd @ A @ Xs2 ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs2 ) ) )
                & ( ( X4 @ ( coinductive_ltl @ A @ Xs2 ) )
                  | ( coindu351974385stinct @ A @ ( coinductive_ltl @ A @ Xs2 ) ) ) ) ) )
       => ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_coinduct
thf(fact_227_ldistinct__lhdD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( ~ ( coinductive_lnull @ A @ Xs )
       => ~ ( member @ A @ ( coinductive_lhd @ A @ Xs ) @ ( coinductive_lset @ A @ ( coinductive_ltl @ A @ Xs ) ) ) ) ) )).

% ldistinct_lhdD
thf(fact_228_local_OatLeastLessThan__subset__iff,axiom,(
    ! [A2: a,B2: a,C: a,D: a] :
      ( ( ord_less_eq @ ( set @ a ) @ ( set_atLeastLessThan @ a @ less_eq @ less @ A2 @ B2 ) @ ( set_atLeastLessThan @ a @ less_eq @ less @ C @ D ) )
     => ( ( less_eq @ B2 @ A2 )
        | ( ( less_eq @ C @ A2 )
          & ( less_eq @ B2 @ D ) ) ) ) )).

% local.atLeastLessThan_subset_iff
thf(fact_229_local_Olset__lmerge,axiom,(
    ! [Xs: ( coinductive_llist @ a ),Ys: ( coinductive_llist @ a )] :
      ( ord_less_eq @ ( set @ a ) @ ( coinductive_lset @ a @ ( hammin1328233080lmerge @ a @ less @ Xs @ Ys ) ) @ ( sup_sup @ ( set @ a ) @ ( coinductive_lset @ a @ Xs ) @ ( coinductive_lset @ a @ Ys ) ) ) )).

% local.lset_lmerge
thf(fact_230_local_Obdd__below__Ioo,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 ) ) )).

% local.bdd_below_Ioo
thf(fact_231_local_OgreaterThanLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_gr1161524159ssThan @ a @ less @ L @ U ) )
      = ( ( less @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.greaterThanLessThan_iff
thf(fact_232_local_OatLeastLessThan__iff,axiom,(
    ! [I: a,L: a,U: a] :
      ( ( member @ a @ I @ ( set_atLeastLessThan @ a @ less_eq @ less @ L @ U ) )
      = ( ( less_eq @ L @ I )
        & ( less @ I @ U ) ) ) )).

% local.atLeastLessThan_iff
thf(fact_233_local_Obdd__above__Ico,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_atLeastLessThan @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_above_Ico
thf(fact_234_local_Obdd__below__Ico,axiom,(
    ! [A2: a,B2: a] :
      ( condit1201339847_below @ a @ less_eq @ ( set_atLeastLessThan @ a @ less_eq @ less @ A2 @ B2 ) ) )).

% local.bdd_below_Ico
thf(fact_235_local_Obdd__above__Ioo,axiom,(
    ! [A2: a,B2: a] :
      ( condit2040224947_above @ a @ less_eq @ ( set_gr1161524159ssThan @ a @ less @ A2 @ B2 ) ) )).

% local.bdd_above_Ioo
thf(fact_236_ord_Olset__lmerge,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( coinductive_lset @ A @ ( hammin1328233080lmerge @ A @ Less @ Xs @ Ys ) ) @ ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) ) ) )).

% ord.lset_lmerge
thf(fact_237_Un__subset__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) @ C2 )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ C2 )
        & ( ord_less_eq @ ( set @ A ) @ B4 @ C2 ) ) ) )).

% Un_subset_iff
thf(fact_238_le__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z2 )
          = ( ( ord_less_eq @ A @ X @ Z2 )
            & ( ord_less_eq @ A @ Y @ Z2 ) ) ) ) )).

% le_sup_iff
thf(fact_239_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( member @ A @ X3 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B4 ) ) )).

% subsetI
thf(fact_240_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A4 )
       => ( A4 = B4 ) ) ) )).

% subset_antisym
thf(fact_241_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% sup_apply
thf(fact_242_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_243_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_244_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.left_idem
thf(fact_245_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_246_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) )).

% sup.right_idem
thf(fact_247_UnCI,axiom,(
    ! [A: $tType,C: A,B4: ( set @ A ),A4: ( set @ A )] :
      ( ( ~ ( member @ A @ C @ B4 )
       => ( member @ A @ C @ A4 ) )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) ) ) )).

% UnCI
thf(fact_248_Un__iff,axiom,(
    ! [A: $tType,C: A,A4: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A4 @ B4 ) )
      = ( ( member @ A @ C @ A4 )
        | ( member @ A @ C @ B4 ) ) ) )).

% Un_iff
thf(fact_249_sup_Obounded__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B2: A,C: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C @ A2 ) ) ) ) )).

% sup.bounded_iff
thf(fact_250_set__mp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% set_mp
thf(fact_251_in__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B4 ) ) ) )).

% in_mono
thf(fact_252_subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C @ A4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% subsetD
thf(fact_253_subsetCE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B4 )
     => ( ( member @ A @ C @ A4 )
       => ( member @ A @ C @ B4 ) ) ) )).

% subsetCE

%----Type constructors (10)
thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( semilattice_sup @ A7 @ ( type2 @ A7 ) )
     => ( semilattice_sup @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_1,axiom,(
    ! [A6: $tType] :
      ( semilattice_sup @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_2,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_3,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_4,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_5,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_6,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ! [X3: a] :
      ( ( member @ a @ X3 @ ( coinductive_lset @ a @ ( coinductive_ltl @ a @ ( hammin1328233080lmerge @ a @ less @ xsa @ ysa ) ) ) )
     => ( less_eq @ ( coinductive_lhd @ a @ ( hammin1328233080lmerge @ a @ less @ xsa @ ysa ) ) @ X3 ) ) )).

%------------------------------------------------------------------------------
