%------------------------------------------------------------------------------
% File     : DAT175^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Lazy lists II 183
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Fri04] Friedrich (2004), Lazy Lists II
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : llist2__183.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  326 (   0 unit;  53 type;   0 defn)
%            Number of atoms       : 4708 ( 197 equality;3075 variable)
%            Maximal formula depth :   28 (  11 average)
%            Number of connectives : 4840 (  88   ~;  14   |;  59   &;4340   @)
%                                         (   0 <=>; 339  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  305 ( 305   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   56 (  53   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1369 (   4 sgn;1129   !;  48   ?; 124   ^)
%                                         (1369   :;  68  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:44:38.061
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (48)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,(
    bNF_Ca1785829860lChain: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,(
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2p,type,(
    bNF_Greatest_image2p: 
      !>[C: $tType,A: $tType,D: $tType,B: $tType] :
        ( ( C > A ) > ( D > B ) > ( C > D > $o ) > A > B > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OrelImage,type,(
    bNF_Gr1317331620lImage: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( B > A ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OrelInvImage,type,(
    bNF_Gr2107612801vImage: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Fun__Def_Oreduction__pair,type,(
    fun_reduction_pair: 
      !>[A: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > $o ) )).

thf(sy_c_Fun__Def_Orp__inv__image,type,(
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllsts,type,(
    lList2435255213lllsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllstsp,type,(
    lList21511617539llstsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts,type,(
    lList2236698231inlsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts__pred,type,(
    lList22005681144s_pred: 
      !>[A: $tType] :
        ( set @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlstsp,type,(
    lList2860480441nlstsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oposlsts,type,(
    lList21148268032oslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_ODomain,type,(
    domain: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ A ) ) )).

thf(sy_c_Relation_ORange,type,(
    range: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ B ) ) )).

thf(sy_c_Relation_ORangep,type,(
    rangep: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > B > $o ) )).

thf(sy_c_Relation_Oinv__image,type,(
    inv_image: 
      !>[B: $tType,A: $tType] :
        ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) )).

thf(sy_c_Relation_Orelcomp,type,(
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Wellfounded_Olex__prod,type,(
    lex_prod: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_Wellfounded_Owf,type,(
    wf: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > $o ) )).

thf(sy_c_Wfrec_Osame__fst,type,(
    same_fst: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_P____,type,(
    p: ( coinductive_llist @ a ) > $o )).

thf(sy_v_a____,type,(
    a2: a )).

thf(sy_v_l____,type,(
    l: ( coinductive_llist @ a ) )).

thf(sy_v_x____,type,(
    x: ( coinductive_llist @ a ) )).

%----Relevant facts (256)
thf(fact_0_xfin,axiom,
    ( member @ ( coinductive_llist @ a ) @ x @ ( lList2236698231inlsts @ a @ ( top_top @ ( set @ a ) ) ) )).

% xfin
thf(fact_1_LCons__fin_Ohyps_I1_J,axiom,
    ( member @ ( coinductive_llist @ a ) @ l @ ( lList2236698231inlsts @ a @ ( top_top @ ( set @ a ) ) ) )).

% LCons_fin.hyps(1)
thf(fact_2_LCons__fin_Ohyps_I3_J,axiom,
    ( member @ a @ a2 @ ( top_top @ ( set @ a ) ) )).

% LCons_fin.hyps(3)
thf(fact_3_LCons__fin_Ohyps_I2_J,axiom,
    ( p @ l )).

% LCons_fin.hyps(2)
thf(fact_4_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_5_finlsts_OLCons__fin,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ A @ A3 @ A2 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A3 @ L ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% finlsts.LCons_fin
thf(fact_6_H,axiom,(
    ! [X: ( coinductive_llist @ a )] :
      ( ! [Y: ( coinductive_llist @ a )] :
          ( ( member @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) ) @ ( product_Pair @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ Y @ X )
            @ ( collect @ ( product_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) )
              @ ( product_case_prod @ ( coinductive_llist @ a ) @ ( coinductive_llist @ a ) @ $o
                @ ^ [R: ( coinductive_llist @ a ),S: ( coinductive_llist @ a )] :
                    ( ( member @ ( coinductive_llist @ a ) @ R @ ( lList2236698231inlsts @ a @ ( top_top @ ( set @ a ) ) ) )
                    & ? [A4: a] :
                        ( ( coinductive_LCons @ a @ A4 @ R )
                        = S ) ) ) ) )
         => ( p @ Y ) )
     => ( p @ X ) ) )).

% H
thf(fact_7_LConsE,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X2 @ Xs ) @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( member @ A @ X2 @ A2 )
        & ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% LConsE
thf(fact_8_alllstsp_OLCons__all,axiom,(
    ! [A: $tType,A2: ( A > $o ),L: ( coinductive_llist @ A ),A3: A] :
      ( ( lList21511617539llstsp @ A @ A2 @ L )
     => ( ( A2 @ A3 )
       => ( lList21511617539llstsp @ A @ A2 @ ( coinductive_LCons @ A @ A3 @ L ) ) ) ) )).

% alllstsp.LCons_all
thf(fact_9_finlstsp_OLCons__fin,axiom,(
    ! [A: $tType,A2: ( A > $o ),L: ( coinductive_llist @ A ),A3: A] :
      ( ( lList2860480441nlstsp @ A @ A2 @ L )
     => ( ( A2 @ A3 )
       => ( lList2860480441nlstsp @ A @ A2 @ ( coinductive_LCons @ A @ A3 @ L ) ) ) ) )).

% finlstsp.LCons_fin
thf(fact_10_alllsts_OLCons__all,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( member @ A @ A3 @ A2 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A3 @ L ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllsts.LCons_all
thf(fact_11_finlsts__predI,axiom,(
    ! [A: $tType,R2: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) ) @ ( product_Pair @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ R2 @ ( coinductive_LCons @ A @ A3 @ R2 ) ) @ ( lList22005681144s_pred @ A ) ) ) )).

% finlsts_predI
thf(fact_12_lmember__code_I2_J,axiom,(
    ! [A: $tType,X2: A,Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X2 @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ( X2 = Y2 )
        | ( coinductive_lmember @ A @ X2 @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_13_llistE,axiom,(
    ! [A: $tType,Y2: ( coinductive_llist @ A )] :
      ( ( Y2
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y2
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llistE
thf(fact_14_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X2: B,Xs: ( coinductive_llist @ B ),Y2: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X2 @ Xs ) @ ( coinductive_LCons @ B @ Y2 @ Ys ) )
      = ( ( X2 = Y2 )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_15_llast__LCons2,axiom,(
    ! [A: $tType,X2: A,Y2: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LCons @ A @ Y2 @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y2 @ Xs ) ) ) )).

% llast_LCons2
thf(fact_16_alllsts__UNIV,axiom,(
    ! [A: $tType,S2: ( coinductive_llist @ A )] :
      ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList2435255213lllsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% alllsts_UNIV
thf(fact_17_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_18_llast__singleton,axiom,(
    ! [A: $tType,X2: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) )
      = X2 ) )).

% llast_singleton
thf(fact_19_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y2: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y2 @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_20_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X2: B,Xs: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X2 @ Xs ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_21_lmember__code_I1_J,axiom,(
    ! [A: $tType,X2: A] :
      ~ ( coinductive_lmember @ A @ X2 @ ( coinductive_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_22_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs2: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs2 )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) )).

% llist_less_induct
thf(fact_23_alllsts__def,axiom,(
    ! [A: $tType] :
      ( ( lList2435255213lllsts @ A )
      = ( ^ [A5: ( set @ A )] :
            ( collect @ ( coinductive_llist @ A )
            @ ( lList21511617539llstsp @ A
              @ ^ [X3: A] :
                  ( member @ A @ X3 @ A5 ) ) ) ) ) )).

% alllsts_def
thf(fact_24_finlsts__def,axiom,(
    ! [A: $tType] :
      ( ( lList2236698231inlsts @ A )
      = ( ^ [A5: ( set @ A )] :
            ( collect @ ( coinductive_llist @ A )
            @ ( lList2860480441nlstsp @ A
              @ ^ [X3: A] :
                  ( member @ A @ X3 @ A5 ) ) ) ) ) )).

% finlsts_def
thf(fact_25_finite__lemma,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2435255213lllsts @ A @ B2 ) )
       => ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ B2 ) ) ) ) )).

% finite_lemma
thf(fact_26_finsubsetall,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% finsubsetall
thf(fact_27_alllsts_OLNil__all,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2435255213lllsts @ A @ A2 ) ) )).

% alllsts.LNil_all
thf(fact_28_finlsts_OLNil__fin,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2236698231inlsts @ A @ A2 ) ) )).

% finlsts.LNil_fin
thf(fact_29_finlsts__pred__def,axiom,(
    ! [A: $tType] :
      ( ( lList22005681144s_pred @ A )
      = ( collect @ ( product_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) )
        @ ( product_case_prod @ ( coinductive_llist @ A ) @ ( coinductive_llist @ A ) @ $o
          @ ^ [R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
              & ? [A4: A] :
                  ( ( coinductive_LCons @ A @ A4 @ R )
                  = S ) ) ) ) ) )).

% finlsts_pred_def
thf(fact_30_alllstsp_OLNil__all,axiom,(
    ! [A: $tType,A2: ( A > $o )] :
      ( lList21511617539llstsp @ A @ A2 @ ( coinductive_LNil @ A ) ) )).

% alllstsp.LNil_all
thf(fact_31_finlstsp_OLNil__fin,axiom,(
    ! [A: $tType,A2: ( A > $o )] :
      ( lList2860480441nlstsp @ A @ A2 @ ( coinductive_LNil @ A ) ) )).

% finlstsp.LNil_fin
thf(fact_32_alllstsp__alllsts__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( lList21511617539llstsp @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A2 ) )
      = ( ^ [X3: ( coinductive_llist @ A )] :
            ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllstsp_alllsts_eq
thf(fact_33_finlstsp__finlsts__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( lList2860480441nlstsp @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A2 ) )
      = ( ^ [X3: ( coinductive_llist @ A )] :
            ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% finlstsp_finlsts_eq
thf(fact_34_alllsts_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X2: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( X4 @ X2 )
     => ( ! [X5: ( coinductive_llist @ A )] :
            ( ( X4 @ X5 )
           => ( ( X5
                = ( coinductive_LNil @ A ) )
              | ? [L2: ( coinductive_llist @ A ),A6: A] :
                  ( ( X5
                    = ( coinductive_LCons @ A @ A6 @ L2 ) )
                  & ( ( X4 @ L2 )
                    | ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2435255213lllsts @ A @ A2 ) ) )
                  & ( member @ A @ A6 @ A2 ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllsts.coinduct
thf(fact_35_alllsts_Osimps,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( A3
          = ( coinductive_LNil @ A ) )
        | ? [L3: ( coinductive_llist @ A ),A4: A] :
            ( ( A3
              = ( coinductive_LCons @ A @ A4 @ L3 ) )
            & ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2435255213lllsts @ A @ A2 ) )
            & ( member @ A @ A4 @ A2 ) ) ) ) )).

% alllsts.simps
thf(fact_36_alllsts_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L4: ( coinductive_llist @ A ),A7: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A7 @ L4 ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2435255213lllsts @ A @ A2 ) )
                 => ~ ( member @ A @ A7 @ A2 ) ) ) ) ) ) )).

% alllsts.cases
thf(fact_37_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X3: A,Xs3: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs3 ) ) ) ) )).

% neq_LNil_conv
thf(fact_38_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_39_alllstsp_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X2: ( coinductive_llist @ A ),A2: ( A > $o )] :
      ( ( X4 @ X2 )
     => ( ! [X5: ( coinductive_llist @ A )] :
            ( ( X4 @ X5 )
           => ( ( X5
                = ( coinductive_LNil @ A ) )
              | ? [L2: ( coinductive_llist @ A ),A6: A] :
                  ( ( X5
                    = ( coinductive_LCons @ A @ A6 @ L2 ) )
                  & ( ( X4 @ L2 )
                    | ( lList21511617539llstsp @ A @ A2 @ L2 ) )
                  & ( A2 @ A6 ) ) ) )
       => ( lList21511617539llstsp @ A @ A2 @ X2 ) ) ) )).

% alllstsp.coinduct
thf(fact_40_finlstsp_Oinducts,axiom,(
    ! [A: $tType,A2: ( A > $o ),X2: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( lList2860480441nlstsp @ A @ A2 @ X2 )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L4: ( coinductive_llist @ A ),A7: A] :
              ( ( lList2860480441nlstsp @ A @ A2 @ L4 )
             => ( ( P @ L4 )
               => ( ( A2 @ A7 )
                 => ( P @ ( coinductive_LCons @ A @ A7 @ L4 ) ) ) ) )
         => ( P @ X2 ) ) ) ) )).

% finlstsp.inducts
thf(fact_41_finlstsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lList2860480441nlstsp @ A )
      = ( ^ [A5: ( A > $o ),A4: ( coinductive_llist @ A )] :
            ( ( A4
              = ( coinductive_LNil @ A ) )
            | ? [L3: ( coinductive_llist @ A ),B3: A] :
                ( ( A4
                  = ( coinductive_LCons @ A @ B3 @ L3 ) )
                & ( lList2860480441nlstsp @ A @ A5 @ L3 )
                & ( A5 @ B3 ) ) ) ) ) )).

% finlstsp.simps
thf(fact_42_finlstsp_Ocases,axiom,(
    ! [A: $tType,A2: ( A > $o ),A3: ( coinductive_llist @ A )] :
      ( ( lList2860480441nlstsp @ A @ A2 @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L4: ( coinductive_llist @ A ),A7: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A7 @ L4 ) )
               => ( ( lList2860480441nlstsp @ A @ A2 @ L4 )
                 => ~ ( A2 @ A7 ) ) ) ) ) ) )).

% finlstsp.cases
thf(fact_43_alllstsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lList21511617539llstsp @ A )
      = ( ^ [A5: ( A > $o ),A4: ( coinductive_llist @ A )] :
            ( ( A4
              = ( coinductive_LNil @ A ) )
            | ? [L3: ( coinductive_llist @ A ),B3: A] :
                ( ( A4
                  = ( coinductive_LCons @ A @ B3 @ L3 ) )
                & ( lList21511617539llstsp @ A @ A5 @ L3 )
                & ( A5 @ B3 ) ) ) ) ) )).

% alllstsp.simps
thf(fact_44_alllstsp_Ocases,axiom,(
    ! [A: $tType,A2: ( A > $o ),A3: ( coinductive_llist @ A )] :
      ( ( lList21511617539llstsp @ A @ A2 @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L4: ( coinductive_llist @ A ),A7: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A7 @ L4 ) )
               => ( ( lList21511617539llstsp @ A @ A2 @ L4 )
                 => ~ ( A2 @ A7 ) ) ) ) ) ) )).

% alllstsp.cases
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
          = ( Q @ X5 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X5: A] :
          ( ( F @ X5 )
          = ( G @ X5 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_fin__finite,axiom,(
    ! [A: $tType,R2: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_finite
thf(fact_50_finT__simp,axiom,(
    ! [A: $tType,R2: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finT_simp
thf(fact_51_finlsts_Oinducts,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L4: ( coinductive_llist @ A ),A7: A] :
              ( ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ L4 )
               => ( ( member @ A @ A7 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A7 @ L4 ) ) ) ) )
         => ( P @ X2 ) ) ) ) )).

% finlsts.inducts
thf(fact_52_finlsts__induct,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ! [L4: ( coinductive_llist @ A )] :
            ( ( L4
              = ( coinductive_LNil @ A ) )
           => ( P @ L4 ) )
       => ( ! [A7: A,L4: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ L4 )
               => ( ( member @ A @ A7 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A7 @ L4 ) ) ) ) )
         => ( P @ X2 ) ) ) ) )).

% finlsts_induct
thf(fact_53_finlsts_Osimps,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2236698231inlsts @ A @ A2 ) )
      = ( ( A3
          = ( coinductive_LNil @ A ) )
        | ? [L3: ( coinductive_llist @ A ),A4: A] :
            ( ( A3
              = ( coinductive_LCons @ A @ A4 @ L3 ) )
            & ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2236698231inlsts @ A @ A2 ) )
            & ( member @ A @ A4 @ A2 ) ) ) ) )).

% finlsts.simps
thf(fact_54_finlsts_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L4: ( coinductive_llist @ A ),A7: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A7 @ L4 ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2236698231inlsts @ A @ A2 ) )
                 => ~ ( member @ A @ A7 @ A2 ) ) ) ) ) ) )).

% finlsts.cases
thf(fact_55_case__prodI,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A3: A,B4: B] :
      ( ( F @ A3 @ B4 )
     => ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A3 @ B4 ) ) ) )).

% case_prodI
thf(fact_56_case__prodI2,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B ),C2: ( A > B > $o )] :
      ( ! [A7: A,B5: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A7 @ B5 ) )
         => ( C2 @ A7 @ B5 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P2 ) ) )).

% case_prodI2
thf(fact_57_case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > C > A ),A3: B,B4: C] :
      ( ( product_case_prod @ B @ C @ A @ F @ ( product_Pair @ B @ C @ A3 @ B4 ) )
      = ( F @ A3 @ B4 ) ) )).

% case_prod_conv
thf(fact_58_split__part,axiom,(
    ! [B: $tType,A: $tType,P: $o,Q: ( A > B > $o )] :
      ( ( product_case_prod @ A @ B @ $o
        @ ^ [A4: A,B3: B] :
            ( P
            & ( Q @ A4 @ B3 ) ) )
      = ( ^ [Ab: ( product_prod @ A @ B )] :
            ( P
            & ( product_case_prod @ A @ B @ $o @ Q @ Ab ) ) ) ) )).

% split_part
thf(fact_59_UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_60_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_61_poslsts__iff,axiom,(
    ! [A: $tType,S2: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList21148268032oslsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList2435255213lllsts @ A @ A2 ) )
        & ( S2
         != ( coinductive_LNil @ A ) ) ) ) )).

% poslsts_iff
thf(fact_62_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X3: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_63_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X23: B,Y1: A,Y23: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X23 )
        = ( product_Pair @ A @ B @ Y1 @ Y23 ) )
      = ( ( X1 = Y1 )
        & ( X23 = Y23 ) ) ) )).

% prod.inject
thf(fact_64_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B4: B,A8: A,B6: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B4 )
        = ( product_Pair @ A @ B @ A8 @ B6 ) )
      = ( ( A3 = A8 )
        & ( B4 = B6 ) ) ) )).

% old.prod.inject
thf(fact_65_mem__case__prodI2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P2: ( product_prod @ A @ B ),Z: C,C2: ( A > B > ( set @ C ) )] :
      ( ! [A7: A,B5: B] :
          ( ( P2
            = ( product_Pair @ A @ B @ A7 @ B5 ) )
         => ( member @ C @ Z @ ( C2 @ A7 @ B5 ) ) )
     => ( member @ C @ Z @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P2 ) ) ) )).

% mem_case_prodI2
thf(fact_66_mem__case__prodI,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Z: A,C2: ( B > C > ( set @ A ) ),A3: B,B4: C] :
      ( ( member @ A @ Z @ ( C2 @ A3 @ B4 ) )
     => ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A3 @ B4 ) ) ) ) )).

% mem_case_prodI
thf(fact_67_case__prodI2_H,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P2: ( product_prod @ A @ B ),C2: ( A > B > C > $o ),X2: C] :
      ( ! [A7: A,B5: B] :
          ( ( ( product_Pair @ A @ B @ A7 @ B5 )
            = P2 )
         => ( C2 @ A7 @ B5 @ X2 ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ X2 ) ) )).

% case_prodI2'
thf(fact_68_poslsts__UNIV,axiom,(
    ! [A: $tType,S2: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList21148268032oslsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( S2
       != ( coinductive_LNil @ A ) ) ) )).

% poslsts_UNIV
thf(fact_69_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z: A,C2: ( B > C > ( set @ A ) ),P2: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P2 ) )
     => ~ ( ! [X5: B,Y: C] :
              ( ( P2
                = ( product_Pair @ B @ C @ X5 @ Y ) )
             => ~ ( member @ A @ Z @ ( C2 @ X5 @ Y ) ) ) ) ) )).

% mem_case_prodE
thf(fact_70_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_71_case__prodE_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( A > B > C > $o ),P2: ( product_prod @ A @ B ),Z: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P2 @ Z )
     => ~ ( ! [X5: A,Y: B] :
              ( ( P2
                = ( product_Pair @ A @ B @ X5 @ Y ) )
             => ~ ( C2 @ X5 @ Y @ Z ) ) ) ) )).

% case_prodE'
thf(fact_72_case__prodD_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,R3: ( A > B > C > $o ),A3: A,B4: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R3 @ ( product_Pair @ A @ B @ A3 @ B4 ) @ C2 )
     => ( R3 @ A3 @ B4 @ C2 ) ) )).

% case_prodD'
thf(fact_73_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A7: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A7 @ B5 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_74_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y2: ( product_prod @ A @ B )] :
      ~ ( ! [A7: A,B5: B] :
            ( Y2
           != ( product_Pair @ A @ B @ A7 @ B5 ) ) ) )).

% old.prod.exhaust
thf(fact_75_prod__induct7,axiom,(
    ! [G2: $tType,F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) )] :
      ( ! [A7: A,B5: B,C3: C,D2: D,E2: E,F3: F2,G3: G2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G2 ) @ E2 @ ( product_Pair @ F2 @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct7
thf(fact_76_prod__induct6,axiom,(
    ! [F2: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ( ! [A7: A,B5: B,C3: C,D2: D,E2: E,F3: F2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct6
thf(fact_77_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A7: A,B5: B,C3: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct5
thf(fact_78_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A7: A,B5: B,C3: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct4
thf(fact_79_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A7: A,B5: B,C3: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A7 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P @ X2 ) ) )).

% prod_induct3
thf(fact_80_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,G2: $tType,Y2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A7: A,B5: B,C3: C,D2: D,E2: E,F3: F2,G3: G2] :
            ( Y2
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F2 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F2 @ G2 ) @ E2 @ ( product_Pair @ F2 @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_81_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F2: $tType,Y2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) )] :
      ~ ( ! [A7: A,B5: B,C3: C,D2: D,E2: E,F3: F2] :
            ( Y2
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F2 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F2 ) @ D2 @ ( product_Pair @ E @ F2 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_82_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A7: A,B5: B,C3: C,D2: D,E2: E] :
            ( Y2
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_83_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A7: A,B5: B,C3: C,D2: D] :
            ( Y2
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_84_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A7: A,B5: B,C3: C] :
            ( Y2
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A7 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_85_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A3: A,B4: B,A8: A,B6: B] :
      ( ( ( product_Pair @ A @ B @ A3 @ B4 )
        = ( product_Pair @ A @ B @ A8 @ B6 ) )
     => ~ ( ( A3 = A8 )
         => ( B4 != B6 ) ) ) )).

% Pair_inject
thf(fact_86_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A7: A,B5: B] :
          ( P @ ( product_Pair @ A @ B @ A7 @ B5 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_87_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X5: A,Y: B] :
      ( P2
      = ( product_Pair @ A @ B @ X5 @ Y ) ) )).

% surj_pair
thf(fact_88_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X5: A] :
      ( member @ A @ X5 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_89_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X5: A] :
          ( member @ A @ X5 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_90_UNIV__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A
        @ ^ [X3: A] : $true ) ) )).

% UNIV_def
thf(fact_91_prod_Ocase__distrib,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,H: ( C > D ),F: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( H @ ( product_case_prod @ A @ B @ C @ F @ Prod ) )
      = ( product_case_prod @ A @ B @ D
        @ ^ [X12: A,X24: B] :
            ( H @ ( F @ X12 @ X24 ) )
        @ Prod ) ) )).

% prod.case_distrib
thf(fact_92_prod_Odisc__eq__case,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( product_case_prod @ A @ B @ $o
      @ ^ [Uu: A,Uv: B] : $true
      @ Prod ) )).

% prod.disc_eq_case
thf(fact_93_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F: ( A > B > C ),X1: A,X23: B] :
      ( ( product_case_prod @ A @ B @ C @ F @ ( product_Pair @ A @ B @ X1 @ X23 ) )
      = ( F @ X1 @ X23 ) ) )).

% old.prod.case
thf(fact_94_cond__case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),G: ( ( product_prod @ A @ B ) > C )] :
      ( ! [X5: A,Y: B] :
          ( ( F @ X5 @ Y )
          = ( G @ ( product_Pair @ A @ B @ X5 @ Y ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F )
        = G ) ) )).

% cond_case_prod_eta
thf(fact_95_case__prod__eta,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( product_prod @ A @ B ) > C )] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X3: A,Y3: B] :
            ( F @ ( product_Pair @ A @ B @ X3 @ Y3 ) ) )
      = F ) )).

% case_prod_eta
thf(fact_96_case__prodE2,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Q: ( A > $o ),P: ( B > C > A ),Z: ( product_prod @ B @ C )] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z ) )
     => ~ ( ! [X5: B,Y: C] :
              ( ( Z
                = ( product_Pair @ B @ C @ X5 @ Y ) )
             => ~ ( Q @ ( P @ X5 @ Y ) ) ) ) ) )).

% case_prodE2
thf(fact_97_case__prodE,axiom,(
    ! [A: $tType,B: $tType,C2: ( A > B > $o ),P2: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P2 )
     => ~ ( ! [X5: A,Y: B] :
              ( ( P2
                = ( product_Pair @ A @ B @ X5 @ Y ) )
             => ~ ( C2 @ X5 @ Y ) ) ) ) )).

% case_prodE
thf(fact_98_case__prodD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B > $o ),A3: A,B4: B] :
      ( ( product_case_prod @ A @ B @ $o @ F @ ( product_Pair @ A @ B @ A3 @ B4 ) )
     => ( F @ A3 @ B4 ) ) )).

% case_prodD
thf(fact_99_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A3: A,B4: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A3 @ B4 ) )
      = ( F1 @ A3 @ B4 ) ) )).

% old.prod.rec
thf(fact_100_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F: ( A > B > C ),G: ( A > B > C ),P2: ( product_prod @ A @ B )] :
      ( ! [X5: A,Y: B] :
          ( ( ( product_Pair @ A @ B @ X5 @ Y )
            = Q2 )
         => ( ( F @ X5 @ Y )
            = ( G @ X5 @ Y ) ) )
     => ( ( P2 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F @ P2 )
          = ( product_case_prod @ A @ B @ C @ G @ Q2 ) ) ) ) )).

% split_cong
thf(fact_101_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs3: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y2 @ Xs3 ) )
            & ( coindu328551480prefix @ A @ Xs3 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_102_case__prod__app,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F4: ( B > C > D > A ),X3: ( product_prod @ B @ C ),Y3: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L3: B,R: C] :
                ( F4 @ L3 @ R @ Y3 )
            @ X3 ) ) ) )).

% case_prod_app
thf(fact_103_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_104_top__empty__eq2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X3: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) )).

% top_empty_eq2
thf(fact_105_case__prod__Pair__iden,axiom,(
    ! [B: $tType,A: $tType,P2: ( product_prod @ A @ B )] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P2 )
      = P2 ) )).

% case_prod_Pair_iden
thf(fact_106_top1I,axiom,(
    ! [A: $tType,X2: A] :
      ( top_top @ ( A > $o ) @ X2 ) )).

% top1I
thf(fact_107_top2I,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y2: B] :
      ( top_top @ ( A > B > $o ) @ X2 @ Y2 ) )).

% top2I
thf(fact_108_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X2: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X2 ) )
      = P ) )).

% top_conj(2)
thf(fact_109_top__conj_I1_J,axiom,(
    ! [A: $tType,X2: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X2 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_110_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_111_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( Xs
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_112_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X3: A] :
            ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_113_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A3: B,B4: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A3 @ B4 ) )
      = ( C2 @ A3 @ B4 ) ) )).

% internal_case_prod_conv
thf(fact_114_pred__equals__eq2,axiom,(
    ! [B: $tType,A: $tType,R3: ( set @ ( product_prod @ A @ B ) ),S3: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ( ^ [X3: A,Y3: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R3 ) )
        = ( ^ [X3: A,Y3: B] :
              ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ S3 ) ) )
      = ( R3 = S3 ) ) )).

% pred_equals_eq2
thf(fact_115_inv__image__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( inv_image @ B @ A )
      = ( ^ [R: ( set @ ( product_prod @ B @ B ) ),F4: ( A > B )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X3: A,Y3: A] :
                  ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F4 @ X3 ) @ ( F4 @ Y3 ) ) @ R ) ) ) ) ) )).

% inv_image_def
thf(fact_116_Range__Collect__case__prod,axiom,(
    ! [B: $tType,A: $tType,P: ( B > A > $o )] :
      ( ( range @ B @ A @ ( collect @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) ) )
      = ( collect @ A
        @ ^ [Y3: A] :
          ? [X3: B] :
            ( P @ X3 @ Y3 ) ) ) )).

% Range_Collect_case_prod
thf(fact_117_same__fst__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P3: ( A > $o ),R4: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X6: A,Y4: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X3: A,Y3: B] :
                        ( ( X6 = X3 )
                        & ( P3 @ X3 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y4 @ Y3 ) @ ( R4 @ X3 ) ) ) ) ) ) ) ) ) )).

% same_fst_def
thf(fact_118_Domain__Collect__case__prod,axiom,(
    ! [B: $tType,A: $tType,P: ( A > B > $o )] :
      ( ( domain @ A @ B @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
      = ( collect @ A
        @ ^ [X3: A] :
            ( ^ [P4: ( B > $o )] :
              ? [X7: B] :
                ( P4 @ X7 )
            @ ( P @ X3 ) ) ) ) )).

% Domain_Collect_case_prod
thf(fact_119_image2__def,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A5: ( set @ C ),F4: ( C > A ),G4: ( C > B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu: ( product_prod @ A @ B )] :
              ? [A4: C] :
                ( ( Uu
                  = ( product_Pair @ A @ B @ ( F4 @ A4 ) @ ( G4 @ A4 ) ) )
                & ( member @ C @ A4 @ A5 ) ) ) ) ) )).

% image2_def
thf(fact_120_in__inv__image,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y2: A,R2: ( set @ ( product_prod @ B @ B ) ),F: ( A > B )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( inv_image @ B @ A @ R2 @ F ) )
      = ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F @ X2 ) @ ( F @ Y2 ) ) @ R2 ) ) )).

% in_inv_image
thf(fact_121_same__fstI,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),X2: A,Y5: B,Y2: B,R3: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ( P @ X2 )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y5 @ Y2 ) @ ( R3 @ X2 ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y5 ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) ) @ ( same_fst @ A @ B @ P @ R3 ) ) ) ) )).

% same_fstI
thf(fact_122_DomainE,axiom,(
    ! [B: $tType,A: $tType,A3: A,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R2 ) )
     => ~ ( ! [B5: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B5 ) @ R2 ) ) ) )).

% DomainE
thf(fact_123_Domain__iff,axiom,(
    ! [A: $tType,B: $tType,A3: A,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R2 ) )
      = ( ? [Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ Y3 ) @ R2 ) ) ) )).

% Domain_iff
thf(fact_124_Domain_Ocases,axiom,(
    ! [B: $tType,A: $tType,A3: A,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R2 ) )
     => ~ ( ! [B5: B] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B5 ) @ R2 ) ) ) )).

% Domain.cases
thf(fact_125_Domain_Osimps,axiom,(
    ! [B: $tType,A: $tType,A3: A,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ A @ A3 @ ( domain @ A @ B @ R2 ) )
      = ( ? [A4: A,B3: B] :
            ( ( A3 = A4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ R2 ) ) ) ) )).

% Domain.simps
thf(fact_126_Domain_ODomainI,axiom,(
    ! [B: $tType,A: $tType,A3: A,B4: B,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B4 ) @ R2 )
     => ( member @ A @ A3 @ ( domain @ A @ B @ R2 ) ) ) )).

% Domain.DomainI
thf(fact_127_Domain_Oinducts,axiom,(
    ! [B: $tType,A: $tType,X2: A,R2: ( set @ ( product_prod @ A @ B ) ),P: ( A > $o )] :
      ( ( member @ A @ X2 @ ( domain @ A @ B @ R2 ) )
     => ( ! [A7: A,B5: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A7 @ B5 ) @ R2 )
           => ( P @ A7 ) )
       => ( P @ X2 ) ) ) )).

% Domain.inducts
thf(fact_128_RangeE,axiom,(
    ! [A: $tType,B: $tType,B4: A,R2: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ A @ B4 @ ( range @ B @ A @ R2 ) )
     => ~ ( ! [A7: B] :
              ~ ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ A7 @ B4 ) @ R2 ) ) ) )).

% RangeE
thf(fact_129_Range__iff,axiom,(
    ! [A: $tType,B: $tType,A3: A,R2: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ A @ A3 @ ( range @ B @ A @ R2 ) )
      = ( ? [Y3: B] :
            ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ Y3 @ A3 ) @ R2 ) ) ) )).

% Range_iff
thf(fact_130_Range_Ocases,axiom,(
    ! [B: $tType,A: $tType,A3: B,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ B @ A3 @ ( range @ A @ B @ R2 ) )
     => ~ ( ! [A7: A] :
              ~ ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A7 @ A3 ) @ R2 ) ) ) )).

% Range.cases
thf(fact_131_Range_Osimps,axiom,(
    ! [B: $tType,A: $tType,A3: B,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ B @ A3 @ ( range @ A @ B @ R2 ) )
      = ( ? [A4: A,B3: B] :
            ( ( A3 = B3 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ R2 ) ) ) ) )).

% Range.simps
thf(fact_132_Range_Ointros,axiom,(
    ! [B: $tType,A: $tType,A3: A,B4: B,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B4 ) @ R2 )
     => ( member @ B @ B4 @ ( range @ A @ B @ R2 ) ) ) )).

% Range.intros
thf(fact_133_Range_Oinducts,axiom,(
    ! [A: $tType,B: $tType,X2: B,R2: ( set @ ( product_prod @ A @ B ) ),P: ( B > $o )] :
      ( ( member @ B @ X2 @ ( range @ A @ B @ R2 ) )
     => ( ! [A7: A,B5: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A7 @ B5 ) @ R2 )
           => ( P @ B5 ) )
       => ( P @ X2 ) ) ) )).

% Range.inducts
thf(fact_134_image2__eqI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,B4: A,F: ( B > A ),X2: B,C2: C,G: ( B > C ),A2: ( set @ B )] :
      ( ( B4
        = ( F @ X2 ) )
     => ( ( C2
          = ( G @ X2 ) )
       => ( ( member @ B @ X2 @ A2 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B4 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A2 @ F @ G ) ) ) ) ) )).

% image2_eqI
thf(fact_135_Domain__unfold,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( domain @ A @ B )
      = ( ^ [R: ( set @ ( product_prod @ A @ B ) )] :
            ( collect @ A
            @ ^ [X3: A] :
              ? [Y3: B] :
                ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R ) ) ) ) )).

% Domain_unfold
thf(fact_136_rp__inv__image__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R4: ( set @ ( product_prod @ A @ A ) ),S4: ( set @ ( product_prod @ A @ A ) ),F4: ( B > A )] :
            ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R4 @ F4 ) @ ( inv_image @ A @ B @ S4 @ F4 ) ) ) ) )).

% rp_inv_image_def
thf(fact_137_lex__prod__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: ( set @ ( product_prod @ A @ A ) ),Rb: ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A4: A,B3: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A9: A,B7: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A9 ) @ Ra )
                        | ( ( A4 = A9 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B3 @ B7 ) @ Rb ) ) ) ) ) ) ) ) ) )).

% lex_prod_def
thf(fact_138_relImage__def,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( bNF_Gr1317331620lImage @ B @ A )
      = ( ^ [R4: ( set @ ( product_prod @ B @ B ) ),F4: ( B > A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: ( product_prod @ A @ A )] :
              ? [A1: B,A22: B] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ ( F4 @ A1 ) @ ( F4 @ A22 ) ) )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A1 @ A22 ) @ R4 ) ) ) ) ) )).

% relImage_def
thf(fact_139_Rangep__Range__eq,axiom,(
    ! [A: $tType,B: $tType,R2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( rangep @ A @ B
        @ ^ [X3: A,Y3: B] :
            ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R2 ) )
      = ( ^ [X3: B] :
            ( member @ B @ X3 @ ( range @ A @ B @ R2 ) ) ) ) )).

% Rangep_Range_eq
thf(fact_140_in__lex__prod,axiom,(
    ! [A: $tType,B: $tType,A3: A,B4: B,A8: A,B6: B,R2: ( set @ ( product_prod @ A @ A ) ),S2: ( set @ ( product_prod @ B @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B4 ) @ ( product_Pair @ A @ B @ A8 @ B6 ) ) @ ( lex_prod @ A @ B @ R2 @ S2 ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A8 ) @ R2 )
        | ( ( A3 = A8 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B4 @ B6 ) @ S2 ) ) ) ) )).

% in_lex_prod
thf(fact_141_Rangep_Oinducts,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),X2: B,P: ( B > $o )] :
      ( ( rangep @ A @ B @ R2 @ X2 )
     => ( ! [A7: A,B5: B] :
            ( ( R2 @ A7 @ B5 )
           => ( P @ B5 ) )
       => ( P @ X2 ) ) ) )).

% Rangep.inducts
thf(fact_142_Rangep_Ointros,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),A3: A,B4: B] :
      ( ( R2 @ A3 @ B4 )
     => ( rangep @ A @ B @ R2 @ B4 ) ) )).

% Rangep.intros
thf(fact_143_Rangep_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rangep @ A @ B )
      = ( ^ [R: ( A > B > $o ),A4: B] :
          ? [B3: A,C4: B] :
            ( ( A4 = C4 )
            & ( R @ B3 @ C4 ) ) ) ) )).

% Rangep.simps
thf(fact_144_Rangep_Ocases,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),A3: B] :
      ( ( rangep @ A @ B @ R2 @ A3 )
     => ~ ( ! [A7: A] :
              ~ ( R2 @ A7 @ A3 ) ) ) )).

% Rangep.cases
thf(fact_145_RangepE,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),B4: B] :
      ( ( rangep @ A @ B @ R2 @ B4 )
     => ~ ( ! [A7: A] :
              ~ ( R2 @ A7 @ B4 ) ) ) )).

% RangepE
thf(fact_146_Range__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( range @ A @ B )
      = ( ^ [R: ( set @ ( product_prod @ A @ B ) )] :
            ( collect @ B
            @ ( rangep @ A @ B
              @ ^ [X3: A,Y3: B] :
                  ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R ) ) ) ) ) )).

% Range_def
thf(fact_147_rp__inv__image__rp,axiom,(
    ! [A: $tType,B: $tType,P: ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ),F: ( B > A )] :
      ( ( fun_reduction_pair @ A @ P )
     => ( fun_reduction_pair @ B @ ( fun_rp_inv_image @ A @ B @ P @ F ) ) ) )).

% rp_inv_image_rp
thf(fact_148_relInvImage__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Gr2107612801vImage @ A @ B )
      = ( ^ [A5: ( set @ A ),R4: ( set @ ( product_prod @ B @ B ) ),F4: ( A > B )] :
            ( collect @ ( product_prod @ A @ A )
            @ ^ [Uu: ( product_prod @ A @ A )] :
              ? [A1: A,A22: A] :
                ( ( Uu
                  = ( product_Pair @ A @ A @ A1 @ A22 ) )
                & ( member @ A @ A1 @ A5 )
                & ( member @ A @ A22 @ A5 )
                & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ ( F4 @ A1 ) @ ( F4 @ A22 ) ) @ R4 ) ) ) ) ) )).

% relInvImage_def
thf(fact_149_image2p__def,axiom,(
    ! [D: $tType,B: $tType,A: $tType,C: $tType] :
      ( ( bNF_Greatest_image2p @ C @ A @ D @ B )
      = ( ^ [F4: ( C > A ),G4: ( D > B ),R4: ( C > D > $o ),X3: A,Y3: B] :
          ? [X6: C,Y4: D] :
            ( ( R4 @ X6 @ Y4 )
            & ( ( F4 @ X6 )
              = X3 )
            & ( ( G4 @ Y4 )
              = Y3 ) ) ) ) )).

% image2p_def
thf(fact_150_relcomp__unfold,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R: ( set @ ( product_prod @ A @ C ) ),S: ( set @ ( product_prod @ C @ B ) )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X3: A,Z2: B] :
                ? [Y3: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X3 @ Y3 ) @ R )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y3 @ Z2 ) @ S ) ) ) ) ) ) )).

% relcomp_unfold
thf(fact_151_relcompE,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Xz: ( product_prod @ A @ B ),R2: ( set @ ( product_prod @ A @ C ) ),S2: ( set @ ( product_prod @ C @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ Xz @ ( relcomp @ A @ C @ B @ R2 @ S2 ) )
     => ~ ( ! [X5: A,Y: C,Z3: B] :
              ( ( Xz
                = ( product_Pair @ A @ B @ X5 @ Z3 ) )
             => ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X5 @ Y ) @ R2 )
               => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y @ Z3 ) @ S2 ) ) ) ) ) )).

% relcompE
thf(fact_152_relcompEpair,axiom,(
    ! [A: $tType,B: $tType,C: $tType,A3: A,C2: B,R2: ( set @ ( product_prod @ A @ C ) ),S2: ( set @ ( product_prod @ C @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ C2 ) @ ( relcomp @ A @ C @ B @ R2 @ S2 ) )
     => ~ ( ! [B5: C] :
              ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A3 @ B5 ) @ R2 )
             => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ B5 @ C2 ) @ S2 ) ) ) ) )).

% relcompEpair
thf(fact_153_relcomp_Ocases,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A12: A,A23: C,R2: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ B @ C ) )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A12 @ A23 ) @ ( relcomp @ A @ B @ C @ R2 @ S2 ) )
     => ~ ( ! [B5: B] :
              ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A12 @ B5 ) @ R2 )
             => ~ ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B5 @ A23 ) @ S2 ) ) ) ) )).

% relcomp.cases
thf(fact_154_relcomp_Osimps,axiom,(
    ! [B: $tType,C: $tType,A: $tType,A12: A,A23: C,R2: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ B @ C ) )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A12 @ A23 ) @ ( relcomp @ A @ B @ C @ R2 @ S2 ) )
      = ( ? [A4: A,B3: B,C4: C] :
            ( ( A12 = A4 )
            & ( A23 = C4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B3 ) @ R2 )
            & ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B3 @ C4 ) @ S2 ) ) ) ) )).

% relcomp.simps
thf(fact_155_relcomp_Oinducts,axiom,(
    ! [B: $tType,A: $tType,C: $tType,X1: A,X23: C,R2: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ B @ C ) ),P: ( A > C > $o )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X1 @ X23 ) @ ( relcomp @ A @ B @ C @ R2 @ S2 ) )
     => ( ! [A7: A,B5: B,C3: C] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A7 @ B5 ) @ R2 )
           => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B5 @ C3 ) @ S2 )
             => ( P @ A7 @ C3 ) ) )
       => ( P @ X1 @ X23 ) ) ) )).

% relcomp.inducts
thf(fact_156_relcomp_OrelcompI,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A3: A,B4: B,R2: ( set @ ( product_prod @ A @ B ) ),C2: C,S2: ( set @ ( product_prod @ B @ C ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A3 @ B4 ) @ R2 )
     => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B4 @ C2 ) @ S2 )
       => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A3 @ C2 ) @ ( relcomp @ A @ B @ C @ R2 @ S2 ) ) ) ) )).

% relcomp.relcompI
thf(fact_157_O__assoc,axiom,(
    ! [A: $tType,D: $tType,B: $tType,C: $tType,R3: ( set @ ( product_prod @ A @ D ) ),S3: ( set @ ( product_prod @ D @ C ) ),T2: ( set @ ( product_prod @ C @ B ) )] :
      ( ( relcomp @ A @ C @ B @ ( relcomp @ A @ D @ C @ R3 @ S3 ) @ T2 )
      = ( relcomp @ A @ D @ B @ R3 @ ( relcomp @ D @ C @ B @ S3 @ T2 ) ) ) )).

% O_assoc
thf(fact_158_image2pE,axiom,(
    ! [D: $tType,B: $tType,A: $tType,C: $tType,F: ( A > B ),G: ( C > D ),R3: ( A > C > $o ),Fx: B,Gy: D] :
      ( ( bNF_Greatest_image2p @ A @ B @ C @ D @ F @ G @ R3 @ Fx @ Gy )
     => ~ ( ! [X5: A] :
              ( ( Fx
                = ( F @ X5 ) )
             => ! [Y: C] :
                  ( ( Gy
                    = ( G @ Y ) )
                 => ~ ( R3 @ X5 @ Y ) ) ) ) ) )).

% image2pE
thf(fact_159_image2pI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R3: ( A > B > $o ),X2: A,Y2: B,F: ( A > C ),G: ( B > D )] :
      ( ( R3 @ X2 @ Y2 )
     => ( bNF_Greatest_image2p @ A @ C @ B @ D @ F @ G @ R3 @ ( F @ X2 ) @ ( G @ Y2 ) ) ) )).

% image2pI
thf(fact_160_relInvImage__UNIV__relImage,axiom,(
    ! [B: $tType,A: $tType,R3: ( set @ ( product_prod @ A @ A ) ),F: ( A > B )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ ( bNF_Gr2107612801vImage @ A @ B @ ( top_top @ ( set @ A ) ) @ ( bNF_Gr1317331620lImage @ A @ B @ R3 @ F ) @ F ) ) )).

% relInvImage_UNIV_relImage
thf(fact_161_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R2: A,S2: B,R3: ( set @ ( product_prod @ A @ B ) ),S5: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R2 @ S2 ) @ R3 )
     => ( ( S5 = S2 )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R2 @ S5 ) @ R3 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_162_llimit__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( P @ ( coinductive_LNil @ A ) )
     => ( ! [X5: A,Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lfinite @ A @ Xs2 )
           => ( ( P @ Xs2 )
             => ( P @ ( coinductive_LCons @ A @ X5 @ Xs2 ) ) ) )
       => ( ( ! [Ys2: ( coinductive_llist @ A )] :
                ( ( coindu1478340336prefix @ A @ Ys2 @ Xs )
               => ( P @ Ys2 ) )
           => ( P @ Xs ) )
         => ( P @ Xs ) ) ) ) )).

% llimit_induct
thf(fact_163_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ X2 @ X2 ) ) )).

% order_refl
thf(fact_164_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A2 )
       => ( A2 = B2 ) ) ) )).

% subset_antisym
thf(fact_165_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ! [X5: A] :
          ( ( member @ A @ X5 @ A2 )
         => ( member @ A @ X5 @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% subsetI
thf(fact_166_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X2: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X2 @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_167_lfinite__LCons,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_168_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_169_relcomp__mono,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R5: ( set @ ( product_prod @ A @ B ) ),R2: ( set @ ( product_prod @ A @ B ) ),S5: ( set @ ( product_prod @ B @ C ) ),S2: ( set @ ( product_prod @ B @ C ) )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R5 @ R2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S5 @ S2 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R5 @ S5 ) @ ( relcomp @ A @ B @ C @ R2 @ S2 ) ) ) ) )).

% relcomp_mono
thf(fact_170_relInvImage__mono,axiom,(
    ! [A: $tType,B: $tType,R1: ( set @ ( product_prod @ A @ A ) ),R22: ( set @ ( product_prod @ A @ A ) ),A2: ( set @ B ),F: ( B > A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ R22 )
     => ( ord_less_eq @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Gr2107612801vImage @ B @ A @ A2 @ R1 @ F ) @ ( bNF_Gr2107612801vImage @ B @ A @ A2 @ R22 @ F ) ) ) )).

% relInvImage_mono
thf(fact_171_relImage__mono,axiom,(
    ! [B: $tType,A: $tType,R1: ( set @ ( product_prod @ A @ A ) ),R22: ( set @ ( product_prod @ A @ A ) ),F: ( A > B )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R1 @ R22 )
     => ( ord_less_eq @ ( set @ ( product_prod @ B @ B ) ) @ ( bNF_Gr1317331620lImage @ A @ B @ R1 @ F ) @ ( bNF_Gr1317331620lImage @ A @ B @ R22 @ F ) ) ) )).

% relImage_mono
thf(fact_172_Range__mono,axiom,(
    ! [B: $tType,A: $tType,R2: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 )
     => ( ord_less_eq @ ( set @ B ) @ ( range @ A @ B @ R2 ) @ ( range @ A @ B @ S2 ) ) ) )).

% Range_mono
thf(fact_173_Domain__mono,axiom,(
    ! [B: $tType,A: $tType,R2: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 )
     => ( ord_less_eq @ ( set @ A ) @ ( domain @ A @ B @ R2 ) @ ( domain @ A @ B @ S2 ) ) ) )).

% Domain_mono
thf(fact_174_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A] :
          ( ( ord_less_eq @ A @ B4 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B4 )
           => ( A3 = B4 ) ) ) ) )).

% dual_order.antisym
thf(fact_175_poslsts__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ ( coinductive_llist @ A ) ) @ ( lList21148268032oslsts @ A @ A2 ) @ ( lList21148268032oslsts @ A @ B2 ) ) ) )).

% poslsts_mono
thf(fact_176_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B4 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B4 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_177_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A3: A,B4: A] :
          ( ! [A7: A,B5: A] :
              ( ( ord_less_eq @ A @ A7 @ B5 )
             => ( P @ A7 @ B5 ) )
         => ( ! [A7: A,B5: A] :
                ( ( P @ B5 @ A7 )
               => ( P @ A7 @ B5 ) )
           => ( P @ A3 @ B4 ) ) ) ) )).

% linorder_wlog
thf(fact_178_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_179_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z )
           => ( ord_less_eq @ A @ X2 @ Z ) ) ) ) )).

% order_trans
thf(fact_180_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ A3 )
           => ( A3 = B4 ) ) ) ) )).

% order_class.order.antisym
thf(fact_181_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( B4 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_182_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( A3 = B4 )
         => ( ( ord_less_eq @ A @ B4 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_183_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
            = ( X2 = Y2 ) ) ) ) )).

% antisym_conv
thf(fact_184_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_185_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% order.trans
thf(fact_186_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) )).

% le_cases
thf(fact_187_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( X2 = Y2 )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) )).

% eq_refl
thf(fact_188_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X2 ) ) ) )).

% linear
thf(fact_189_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X2 )
           => ( X2 = Y2 ) ) ) ) )).

% antisym
thf(fact_190_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y6: A,Z4: A] : ( Y6 = Z4 ) )
        = ( ^ [X3: A,Y3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y3 )
              & ( ord_less_eq @ A @ Y3 @ X3 ) ) ) ) ) )).

% eq_iff
thf(fact_191_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B4: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ( F @ B4 )
              = C2 )
           => ( ! [X5: A,Y: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y )
                 => ( ord_less_eq @ B @ ( F @ X5 ) @ ( F @ Y ) ) )
             => ( ord_less_eq @ B @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_192_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B4: B,C2: B] :
          ( ( A3
            = ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C2 )
           => ( ! [X5: B,Y: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y )
                 => ( ord_less_eq @ A @ ( F @ X5 ) @ ( F @ Y ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_193_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B4: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ C @ ( F @ B4 ) @ C2 )
           => ( ! [X5: A,Y: A] :
                  ( ( ord_less_eq @ A @ X5 @ Y )
                 => ( ord_less_eq @ C @ ( F @ X5 ) @ ( F @ Y ) ) )
             => ( ord_less_eq @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_194_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B4: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C2 )
           => ( ! [X5: B,Y: B] :
                  ( ( ord_less_eq @ B @ X5 @ Y )
                 => ( ord_less_eq @ A @ ( F @ X5 ) @ ( F @ Y ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_195_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q @ X3 ) ) ) ) )).

% Collect_mono_iff
thf(fact_196_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F4: ( A > B ),G4: ( A > B )] :
            ! [X3: A] :
              ( ord_less_eq @ B @ ( F4 @ X3 ) @ ( G4 @ X3 ) ) ) ) ) )).

% le_fun_def
thf(fact_197_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ~ ( member @ A @ C2 @ B2 )
       => ~ ( member @ A @ C2 @ A2 ) ) ) )).

% contra_subsetD
thf(fact_198_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y6: ( set @ A ),Z4: ( set @ A )] : ( Y6 = Z4 ) )
      = ( ^ [A5: ( set @ A ),B8: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A5 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A5 ) ) ) ) )).

% set_eq_subset
thf(fact_199_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X5: A] :
              ( ord_less_eq @ B @ ( F @ X5 ) @ ( G @ X5 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_200_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funE
thf(fact_201_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% le_funD
thf(fact_202_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C5: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C5 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C5 ) ) ) )).

% subset_trans
thf(fact_203_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( Q @ X5 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_204_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_205_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% rev_subsetD
thf(fact_206_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B8: ( set @ A )] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A5 )
           => ( member @ A @ T3 @ B8 ) ) ) ) )).

% subset_iff
thf(fact_207_set__rev__mp,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ X2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member @ A @ X2 @ B2 ) ) ) )).

% set_rev_mp
thf(fact_208_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) )).

% equalityD2
thf(fact_209_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% equalityD1
thf(fact_210_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B8: ( set @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A5 )
           => ( member @ A @ X3 @ B8 ) ) ) ) )).

% subset_eq
thf(fact_211_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) ) )).

% equalityE
thf(fact_212_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetCE
thf(fact_213_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetD
thf(fact_214_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ X2 @ A2 )
       => ( member @ A @ X2 @ B2 ) ) ) )).

% in_mono
thf(fact_215_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member @ A @ X2 @ A2 )
       => ( member @ A @ X2 @ B2 ) ) ) )).

% set_mp
thf(fact_216_finlsts__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2236698231inlsts @ A @ A2 ) @ ( lList2236698231inlsts @ A @ B2 ) ) ) )).

% finlsts_mono
thf(fact_217_alllsts__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ord_less_eq @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2435255213lllsts @ A @ A2 ) @ ( lList2435255213lllsts @ A @ B2 ) ) ) )).

% alllsts_mono
thf(fact_218_wlog__linorder__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),B4: A,A3: A] :
          ( ! [A7: A,B5: A] :
              ( ( ord_less_eq @ A @ A7 @ B5 )
             => ( P @ A7 @ B5 ) )
         => ( ( ( P @ B4 @ A3 )
             => ( P @ A3 @ B4 ) )
           => ( P @ A3 @ B4 ) ) ) ) )).

% wlog_linorder_le
thf(fact_219_subset__UNIV,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) ) )).

% subset_UNIV
thf(fact_220_top_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
         => ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_uniqueI
thf(fact_221_top_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A3 )
          = ( A3
            = ( top_top @ A ) ) ) ) )).

% top.extremum_unique
thf(fact_222_top__greatest,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ ( top_top @ A ) ) ) )).

% top_greatest
thf(fact_223_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_224_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X2: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_225_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ Ys )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lstrict_prefix_lfinite1
thf(fact_226_subrelI,axiom,(
    ! [B: $tType,A: $tType,R2: ( set @ ( product_prod @ A @ B ) ),S2: ( set @ ( product_prod @ A @ B ) )] :
      ( ! [X5: A,Y: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y ) @ R2 )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y ) @ S2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ S2 ) ) )).

% subrelI
thf(fact_227_prop__restrict,axiom,(
    ! [A: $tType,X2: A,Z5: ( set @ A ),X4: ( set @ A ),P: ( A > $o )] :
      ( ( member @ A @ X2 @ Z5 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z5
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ X4 )
                & ( P @ X3 ) ) ) )
       => ( P @ X2 ) ) ) )).

% prop_restrict
thf(fact_228_Collect__restrict,axiom,(
    ! [A: $tType,X4: ( set @ A ),P: ( A > $o )] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X3: A] :
            ( ( member @ A @ X3 @ X4 )
            & ( P @ X3 ) ) )
      @ X4 ) )).

% Collect_restrict
thf(fact_229_subset__Collect__iff,axiom,(
    ! [A: $tType,B2: ( set @ A ),A2: ( set @ A ),P: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A2 )
                & ( P @ X3 ) ) ) )
        = ( ! [X3: A] :
              ( ( member @ A @ X3 @ B2 )
             => ( P @ X3 ) ) ) ) ) )).

% subset_Collect_iff
thf(fact_230_subset__CollectI,axiom,(
    ! [A: $tType,B2: ( set @ A ),A2: ( set @ A ),Q: ( A > $o ),P: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ B2 @ A2 )
     => ( ! [X5: A] :
            ( ( member @ A @ X5 @ B2 )
           => ( ( Q @ X5 )
             => ( P @ X5 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ B2 )
                & ( Q @ X3 ) ) )
          @ ( collect @ A
            @ ^ [X3: A] :
                ( ( member @ A @ X3 @ A2 )
                & ( P @ X3 ) ) ) ) ) ) )).

% subset_CollectI
thf(fact_231_lfinite_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X5: A] :
                    ( A3
                    = ( coinductive_LCons @ A @ X5 @ Xs2 ) )
               => ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% lfinite.cases
thf(fact_232_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A4: ( coinductive_llist @ A )] :
            ( ( A4
              = ( coinductive_LNil @ A ) )
            | ? [Xs4: ( coinductive_llist @ A ),X3: A] :
                ( ( A4
                  = ( coinductive_LCons @ A @ X3 @ Xs4 ) )
                & ( coinductive_lfinite @ A @ Xs4 ) ) ) ) ) )).

% lfinite.simps
thf(fact_233_lfinite_Oinducts,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X2 )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),X5: A] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X5 @ Xs2 ) ) ) )
         => ( P @ X2 ) ) ) ) )).

% lfinite.inducts
thf(fact_234_reduction__pairI,axiom,(
    ! [A: $tType,R3: ( set @ ( product_prod @ A @ A ) ),S3: ( set @ ( product_prod @ A @ A ) )] :
      ( ( wf @ A @ R3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R3 @ S3 ) @ R3 )
       => ( fun_reduction_pair @ A @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S3 ) ) ) ) )).

% reduction_pairI
thf(fact_235_conj__subset__def,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2
        @ ( collect @ A
          @ ^ [X3: A] :
              ( ( P @ X3 )
              & ( Q @ X3 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A2 @ ( collect @ A @ Q ) ) ) ) )).

% conj_subset_def
thf(fact_236_relChain__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( bNF_Ca1785829860lChain @ A @ B )
        = ( ^ [R: ( set @ ( product_prod @ A @ A ) ),As: ( A > B )] :
            ! [I: A,J: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I @ J ) @ R )
             => ( ord_less_eq @ B @ ( As @ I ) @ ( As @ J ) ) ) ) ) ) )).

% relChain_def
thf(fact_237_wf__inv__image,axiom,(
    ! [B: $tType,A: $tType,R2: ( set @ ( product_prod @ B @ B ) ),F: ( A > B )] :
      ( ( wf @ B @ R2 )
     => ( wf @ A @ ( inv_image @ B @ A @ R2 @ F ) ) ) )).

% wf_inv_image
thf(fact_238_wf__lex__prod,axiom,(
    ! [A: $tType,B: $tType,Ra2: ( set @ ( product_prod @ A @ A ) ),Rb2: ( set @ ( product_prod @ B @ B ) )] :
      ( ( wf @ A @ Ra2 )
     => ( ( wf @ B @ Rb2 )
       => ( wf @ ( product_prod @ A @ B ) @ ( lex_prod @ A @ B @ Ra2 @ Rb2 ) ) ) ) )).

% wf_lex_prod
thf(fact_239_finlstsp__mono,axiom,(
    ! [A: $tType,A2: ( A > $o ),B2: ( A > $o )] :
      ( ( ord_less_eq @ ( A > $o ) @ A2 @ B2 )
     => ( ord_less_eq @ ( ( coinductive_llist @ A ) > $o ) @ ( lList2860480441nlstsp @ A @ A2 ) @ ( lList2860480441nlstsp @ A @ B2 ) ) ) )).

% finlstsp_mono
thf(fact_240_alllstsp__mono,axiom,(
    ! [A: $tType,A2: ( A > $o ),B2: ( A > $o )] :
      ( ( ord_less_eq @ ( A > $o ) @ A2 @ B2 )
     => ( ord_less_eq @ ( ( coinductive_llist @ A ) > $o ) @ ( lList21511617539llstsp @ A @ A2 ) @ ( lList21511617539llstsp @ A @ B2 ) ) ) )).

% alllstsp_mono
thf(fact_241_pred__subset__eq,axiom,(
    ! [A: $tType,R3: ( set @ A ),S3: ( set @ A )] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X3: A] :
            ( member @ A @ X3 @ R3 )
        @ ^ [X3: A] :
            ( member @ A @ X3 @ S3 ) )
      = ( ord_less_eq @ ( set @ A ) @ R3 @ S3 ) ) )).

% pred_subset_eq
thf(fact_242_wf__subset,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),P2: ( set @ ( product_prod @ A @ A ) )] :
      ( ( wf @ A @ R2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ P2 @ R2 )
       => ( wf @ A @ P2 ) ) ) )).

% wf_subset
thf(fact_243_less__eq__set__def,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A5: ( set @ A ),B8: ( set @ A )] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ A5 )
            @ ^ [X3: A] :
                ( member @ A @ X3 @ B8 ) ) ) ) )).

% less_eq_set_def
thf(fact_244_wf__def,axiom,(
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R: ( set @ ( product_prod @ A @ A ) )] :
          ! [P3: ( A > $o )] :
            ( ! [X3: A] :
                ( ! [Y3: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X3 ) @ R )
                   => ( P3 @ Y3 ) )
               => ( P3 @ X3 ) )
           => ( ^ [P4: ( A > $o )] :
                ! [X7: A] :
                  ( P4 @ X7 )
              @ P3 ) ) ) ) )).

% wf_def
thf(fact_245_wfE__min,axiom,(
    ! [A: $tType,R3: ( set @ ( product_prod @ A @ A ) ),X2: A,Q: ( set @ A )] :
      ( ( wf @ A @ R3 )
     => ( ( member @ A @ X2 @ Q )
       => ~ ( ! [Z3: A] :
                ( ( member @ A @ Z3 @ Q )
               => ~ ( ! [Y7: A] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y7 @ Z3 ) @ R3 )
                       => ~ ( member @ A @ Y7 @ Q ) ) ) ) ) ) ) )).

% wfE_min
thf(fact_246_wfI__min,axiom,(
    ! [A: $tType,R3: ( set @ ( product_prod @ A @ A ) )] :
      ( ! [X5: A,Q3: ( set @ A )] :
          ( ( member @ A @ X5 @ Q3 )
         => ? [Xa: A] :
              ( ( member @ A @ Xa @ Q3 )
              & ! [Y: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Xa ) @ R3 )
                 => ~ ( member @ A @ Y @ Q3 ) ) ) )
     => ( wf @ A @ R3 ) ) )).

% wfI_min
thf(fact_247_wfUNIVI,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) )] :
      ( ! [P5: ( A > $o ),X5: A] :
          ( ! [Xa: A] :
              ( ! [Y: A] :
                  ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Xa ) @ R2 )
                 => ( P5 @ Y ) )
             => ( P5 @ Xa ) )
         => ( P5 @ X5 ) )
     => ( wf @ A @ R2 ) ) )).

% wfUNIVI
thf(fact_248_wf__asym,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),A3: A,X2: A] :
      ( ( wf @ A @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X2 ) @ R2 )
       => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A3 ) @ R2 ) ) ) )).

% wf_asym
thf(fact_249_wf__induct,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),P: ( A > $o ),A3: A] :
      ( ( wf @ A @ R2 )
     => ( ! [X5: A] :
            ( ! [Y7: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y7 @ X5 ) @ R2 )
               => ( P @ Y7 ) )
           => ( P @ X5 ) )
       => ( P @ A3 ) ) ) )).

% wf_induct
thf(fact_250_wf__irrefl,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),A3: A] :
      ( ( wf @ A @ R2 )
     => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ R2 ) ) )).

% wf_irrefl
thf(fact_251_wf__not__sym,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),A3: A,X2: A] :
      ( ( wf @ A @ R2 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ X2 ) @ R2 )
       => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ A3 ) @ R2 ) ) ) )).

% wf_not_sym
thf(fact_252_wf__not__refl,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),A3: A] :
      ( ( wf @ A @ R2 )
     => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ R2 ) ) )).

% wf_not_refl
thf(fact_253_wf__eq__minimal,axiom,(
    ! [A: $tType] :
      ( ( wf @ A )
      = ( ^ [R: ( set @ ( product_prod @ A @ A ) )] :
          ! [Q4: ( set @ A )] :
            ( ? [X3: A] :
                ( member @ A @ X3 @ Q4 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ Q4 )
                & ! [Y3: A] :
                    ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y3 @ X3 ) @ R )
                   => ~ ( member @ A @ Y3 @ Q4 ) ) ) ) ) ) )).

% wf_eq_minimal
thf(fact_254_wf__induct__rule,axiom,(
    ! [A: $tType,R2: ( set @ ( product_prod @ A @ A ) ),P: ( A > $o ),A3: A] :
      ( ( wf @ A @ R2 )
     => ( ! [X5: A] :
            ( ! [Y7: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y7 @ X5 ) @ R2 )
               => ( P @ Y7 ) )
           => ( P @ X5 ) )
       => ( P @ A3 ) ) ) )).

% wf_induct_rule
thf(fact_255_wf__same__fst,axiom,(
    ! [B: $tType,A: $tType,P: ( A > $o ),R3: ( A > ( set @ ( product_prod @ B @ B ) ) )] :
      ( ! [X5: A] :
          ( ( P @ X5 )
         => ( wf @ B @ ( R3 @ X5 ) ) )
     => ( wf @ ( product_prod @ A @ B ) @ ( same_fst @ A @ B @ P @ R3 ) ) ) )).

% wf_same_fst

%----Type constructors (16)
thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A10: $tType,A11: $tType] :
      ( ( order_top @ A11 @ ( type2 @ A11 ) )
     => ( order_top @ ( A10 > A11 ) @ ( type2 @ ( A10 > A11 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A10: $tType,A11: $tType] :
      ( ( preorder @ A11 @ ( type2 @ A11 ) )
     => ( preorder @ ( A10 > A11 ) @ ( type2 @ ( A10 > A11 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A10: $tType,A11: $tType] :
      ( ( order @ A11 @ ( type2 @ A11 ) )
     => ( order @ ( A10 > A11 ) @ ( type2 @ ( A10 > A11 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A10: $tType,A11: $tType] :
      ( ( top @ A11 @ ( type2 @ A11 ) )
     => ( top @ ( A10 > A11 ) @ ( type2 @ ( A10 > A11 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A10: $tType,A11: $tType] :
      ( ( ord @ A11 @ ( type2 @ A11 ) )
     => ( ord @ ( A10 > A11 ) @ ( type2 @ ( A10 > A11 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_1,axiom,(
    ! [A10: $tType] :
      ( order_top @ ( set @ A10 ) @ ( type2 @ ( set @ A10 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_2,axiom,(
    ! [A10: $tType] :
      ( preorder @ ( set @ A10 ) @ ( type2 @ ( set @ A10 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_3,axiom,(
    ! [A10: $tType] :
      ( order @ ( set @ A10 ) @ ( type2 @ ( set @ A10 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_4,axiom,(
    ! [A10: $tType] :
      ( top @ ( set @ A10 ) @ ( type2 @ ( set @ A10 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_5,axiom,(
    ! [A10: $tType] :
      ( ord @ ( set @ A10 ) @ ( type2 @ ( set @ A10 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_6,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_7,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_8,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_9,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_10,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( p @ ( coinductive_LCons @ a @ a2 @ l ) )).

%------------------------------------------------------------------------------
