%------------------------------------------------------------------------------
% File     : DAT181^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Lazy lists II 762
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Fri04] Friedrich (2004), Lazy Lists II
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : llist2__762.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  325 (   0 unit;  56 type;   0 defn)
%            Number of atoms       : 4212 ( 264 equality;2517 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 4007 ( 102   ~;  26   |;  63   &;3532   @)
%                                         (   0 <=>; 284  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  158 ( 158   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   58 (  56   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  950 (   1 sgn; 851   !;  36   ?;  17   ^)
%                                         ( 950   :;  46  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:49:03.131
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Extended__Nat_Oenat,type,(
    extended_enat: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (50)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__lset,type,(
    coinductive_gen_lset: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oldistinct,type,(
    coindu351974385stinct: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olfilter,type,(
    coinductive_lfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollcp,type,(
    coinductive_llcp: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > extended_enat ) )).

thf(sy_c_Coinductive__List_Ollexord,type,(
    coinductive_llexord: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olsublist,type,(
    coinductive_lsublist: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ nat ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Omonoid__add__class_Ollistsum,type,(
    coindu780009021istsum: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Extended__Nat_OeSuc,type,(
    extended_eSuc: extended_enat > extended_enat )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllsts,type,(
    lList2435255213lllsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllstsp,type,(
    lList21511617539llstsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts,type,(
    lList2236698231inlsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts__rec,type,(
    lList21916056377ts_rec: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlstsp,type,(
    lList2860480441nlstsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofpslsts,type,(
    lList22096119349pslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oinflsts,type,(
    lList21612149805nflsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Olbutlast,type,(
    lList2370560421utlast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oldrop,type,(
    lList2508575361_ldrop: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ollast,type,(
    lList2170638824_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ollength,type,(
    lList21232602520length: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Olrev,type,(
    lList2281150353e_lrev: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oltake,type,(
    lList22119844313_ltake: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oposlsts,type,(
    lList21148268032oslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_A,type,(
    a2: ( set @ a ) )).

thf(sy_v_x,type,(
    x: a )).

thf(sy_v_xs,type,(
    xs: ( coinductive_llist @ a ) )).

%----Relevant facts (254)
thf(fact_0_fin,axiom,
    ( member @ ( coinductive_llist @ a ) @ xs @ ( lList2236698231inlsts @ a @ a2 ) )).

% fin
thf(fact_1_LNil__is__lappend__conv,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ S @ T ) )
      = ( ( S
          = ( coinductive_LNil @ A ) )
        & ( T
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_is_lappend_conv
thf(fact_2_lappend__is__LNil__conv,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ S @ T )
        = ( coinductive_LNil @ A ) )
      = ( ( S
          = ( coinductive_LNil @ A ) )
        & ( T
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_is_LNil_conv
thf(fact_3_lbutlast__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList2370560421utlast @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lbutlast_LNil
thf(fact_4_llistE,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( Y
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X21: A,X22: ( coinductive_llist @ A )] :
              ( Y
             != ( coinductive_LCons @ A @ X21 @ X22 ) ) ) ) )).

% llistE
thf(fact_5_lbutlast__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( ( R
            = ( coinductive_LNil @ A ) )
         => ( ( lList2370560421utlast @ A @ ( coinductive_LCons @ A @ A3 @ R ) )
            = ( coinductive_LNil @ A ) ) )
        & ( ( R
           != ( coinductive_LNil @ A ) )
         => ( ( lList2370560421utlast @ A @ ( coinductive_LCons @ A @ A3 @ R ) )
            = ( coinductive_LCons @ A @ A3 @ ( lList2370560421utlast @ A @ R ) ) ) ) ) ) )).

% lbutlast_LCons
thf(fact_6_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_7_lappend__LNil2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ Xs @ ( coinductive_LNil @ A ) )
      = Xs ) )).

% lappend_LNil2
thf(fact_8_LNil__eq__lappend__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_eq_lappend_iff
thf(fact_9_lappend__eq__LNil__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ Xs @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_eq_LNil_iff
thf(fact_10_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa: A,X: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa @ X ) @ Ys )
      = ( coinductive_LCons @ A @ Xa @ ( coinductive_lappend @ A @ X @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_11_same__lappend__eq,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( ( coinductive_lappend @ A @ R @ S )
          = ( coinductive_lappend @ A @ R @ T ) )
        = ( S = T ) ) ) )).

% same_lappend_eq
thf(fact_12_lapp__fin__fin__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2236698231inlsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
        & ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% lapp_fin_fin_iff
thf(fact_13_lrev__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ Xs2 @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ Xs2 )
               => ( ( member @ A @ X2 @ A2 )
                 => ( P @ ( coinductive_lappend @ A @ Xs2 @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lrev_induct
thf(fact_14_finlsts__rev__cases,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( T
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [A4: A,L: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A2 ) )
               => ( ( member @ A @ A4 @ A2 )
                 => ( T
                   != ( coinductive_lappend @ A @ L @ ( coinductive_LCons @ A @ A4 @ ( coinductive_LNil @ A ) ) ) ) ) ) ) ) ) )).

% finlsts_rev_cases
thf(fact_15_lappend__snocL1__conv__LCons2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ ( coinductive_LNil @ A ) ) ) @ Ys )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) )).

% lappend_snocL1_conv_LCons2
thf(fact_16_llist_Oinject,axiom,(
    ! [A: $tType,X212: A,X222: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X212 @ X222 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X212 = Y21 )
        & ( X222 = Y22 ) ) ) )).

% llist.inject
thf(fact_17_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_18_finlsts_OLCons__fin,axiom,(
    ! [A: $tType,L2: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ A @ A3 @ A2 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A3 @ L2 ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% finlsts.LCons_fin
thf(fact_19_finlsts_OLNil__fin,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2236698231inlsts @ A @ A2 ) ) )).

% finlsts.LNil_fin
thf(fact_20_lapp__fin__fin__lemma,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% lapp_fin_fin_lemma
thf(fact_21_lappfin__finT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% lappfin_finT
thf(fact_22_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X3: A,Xs3: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs3 ) ) ) ) )).

% neq_LNil_conv
thf(fact_23_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X212: A,X222: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X212 @ X222 ) ) )).

% llist.distinct(1)
thf(fact_24_lappend__LNil__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lappend_LNil_LNil
thf(fact_25_finlsts_Oinducts,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L: ( coinductive_llist @ A ),A4: A] :
              ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ L )
               => ( ( member @ A @ A4 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L ) ) ) ) )
         => ( P @ X ) ) ) ) )).

% finlsts.inducts
thf(fact_26_finlsts__induct,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ! [L: ( coinductive_llist @ A )] :
            ( ( L
              = ( coinductive_LNil @ A ) )
           => ( P @ L ) )
       => ( ! [A4: A,L: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ L )
               => ( ( member @ A @ A4 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L ) ) ) ) )
         => ( P @ X ) ) ) ) )).

% finlsts_induct
thf(fact_27_finlsts_Osimps,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2236698231inlsts @ A @ A2 ) )
      = ( ( A3
          = ( coinductive_LNil @ A ) )
        | ? [L3: ( coinductive_llist @ A ),A5: A] :
            ( ( A3
              = ( coinductive_LCons @ A @ A5 @ L3 ) )
            & ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2236698231inlsts @ A @ A2 ) )
            & ( member @ A @ A5 @ A2 ) ) ) ) )).

% finlsts.simps
thf(fact_28_finlsts_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L: ( coinductive_llist @ A ),A4: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A4 @ L ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A2 ) )
                 => ~ ( member @ A @ A4 @ A2 ) ) ) ) ) ) )).

% finlsts.cases
thf(fact_29_llast__snoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A ),X: A] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2170638824_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) )
        = X ) ) )).

% llast_snoc
thf(fact_30_LList2__Mirabelle__hamjzmohle_Ollast__LCons,axiom,(
    ! [B: $tType,R: ( coinductive_llist @ B ),A2: ( set @ B ),A3: B] :
      ( ( member @ ( coinductive_llist @ B ) @ R @ ( lList2236698231inlsts @ B @ A2 ) )
     => ( ( ( R
            = ( coinductive_LNil @ B ) )
         => ( ( lList2170638824_llast @ B @ ( coinductive_LCons @ B @ A3 @ R ) )
            = A3 ) )
        & ( ( R
           != ( coinductive_LNil @ B ) )
         => ( ( lList2170638824_llast @ B @ ( coinductive_LCons @ B @ A3 @ R ) )
            = ( lList2170638824_llast @ B @ R ) ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_LCons
thf(fact_31_lrev__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2281150353e_lrev @ A @ ( coinductive_LCons @ A @ A3 @ R ) )
        = ( coinductive_lappend @ A @ ( lList2281150353e_lrev @ A @ R ) @ ( coinductive_LCons @ A @ A3 @ ( coinductive_LNil @ A ) ) ) ) ) )).

% lrev_LCons
thf(fact_32_fpslsts__iff,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList22096119349pslsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
        & ( S
         != ( coinductive_LNil @ A ) ) ) ) )).

% fpslsts_iff
thf(fact_33_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs3: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y @ Xs3 ) )
            & ( coindu328551480prefix @ A @ Xs3 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_34_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_35_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_36_lbutlast__lapp__llast,axiom,(
    ! [A: $tType,L2: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList22096119349pslsts @ A @ A2 ) )
     => ( L2
        = ( coinductive_lappend @ A @ ( lList2370560421utlast @ A @ L2 ) @ ( coinductive_LCons @ A @ ( lList2170638824_llast @ A @ L2 ) @ ( coinductive_LNil @ A ) ) ) ) ) )).

% lbutlast_lapp_llast
thf(fact_37_finlsts__rec__LCons__def,axiom,(
    ! [B: $tType,A: $tType,F: ( ( coinductive_llist @ A ) > B ),C: B,D: ( A > ( coinductive_llist @ A ) > B > B ),R: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( F
        = ( lList21916056377ts_rec @ B @ A @ C @ D ) )
     => ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( ( F @ ( coinductive_LCons @ A @ A3 @ R ) )
          = ( D @ A3 @ R @ ( F @ R ) ) ) ) ) )).

% finlsts_rec_LCons_def
thf(fact_38_finlsts__rec__LCons,axiom,(
    ! [B: $tType,A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),C: B,D: ( A > ( coinductive_llist @ A ) > B > B ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList21916056377ts_rec @ B @ A @ C @ D @ ( coinductive_LCons @ A @ A3 @ R ) )
        = ( D @ A3 @ R @ ( lList21916056377ts_rec @ B @ A @ C @ D @ R ) ) ) ) )).

% finlsts_rec_LCons
thf(fact_39_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B ),Y: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X @ Xs ) @ ( coinductive_LCons @ B @ Y @ Ys ) )
      = ( ( X = Y )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_40_lrev__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList2281150353e_lrev @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lrev_LNil
thf(fact_41_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_42_lrevT,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2281150353e_lrev @ A @ Xs ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% lrevT
thf(fact_43_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs2: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs2 )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) )).

% llist_less_induct
thf(fact_44_finlsts__rec__LNil,axiom,(
    ! [B: $tType,A: $tType,C: A,D: ( B > ( coinductive_llist @ B ) > A > A )] :
      ( ( lList21916056377ts_rec @ A @ B @ C @ D @ ( coinductive_LNil @ B ) )
      = C ) )).

% finlsts_rec_LNil
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_finlsts__rec__LNil__def,axiom,(
    ! [A: $tType,B: $tType,F: ( ( coinductive_llist @ A ) > B ),C: B,D: ( A > ( coinductive_llist @ A ) > B > B )] :
      ( ( F
        = ( lList21916056377ts_rec @ B @ A @ C @ D ) )
     => ( ( F @ ( coinductive_LNil @ A ) )
        = C ) ) )).

% finlsts_rec_LNil_def
thf(fact_50_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_51_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( Xs
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_52_fps__induct,axiom,(
    ! [A: $tType,L2: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList22096119349pslsts @ A @ A2 ) )
     => ( ! [A4: A] :
            ( ( member @ A @ A4 @ A2 )
           => ( P @ ( coinductive_LCons @ A @ A4 @ ( coinductive_LNil @ A ) ) ) )
       => ( ! [A4: A,L: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList22096119349pslsts @ A @ A2 ) )
             => ( ( P @ L )
               => ( ( member @ A @ A4 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L ) ) ) ) )
         => ( P @ L2 ) ) ) ) )).

% fps_induct
thf(fact_53_fpslsts__cases,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList22096119349pslsts @ A @ A2 ) )
     => ~ ( ! [A4: A,Rs: ( coinductive_llist @ A )] :
              ( ( R
                = ( coinductive_LCons @ A @ A4 @ Rs ) )
             => ( ( member @ A @ A4 @ A2 )
               => ~ ( member @ ( coinductive_llist @ A ) @ Rs @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) ) ) )).

% fpslsts_cases
thf(fact_54_lrev__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Ys @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( lList2281150353e_lrev @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lappend @ A @ ( lList2281150353e_lrev @ A @ Ys ) @ ( lList2281150353e_lrev @ A @ Xs ) ) ) ) ) )).

% lrev_lappend
thf(fact_55_LNil__is__lrev__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( ( coinductive_LNil @ A )
          = ( lList2281150353e_lrev @ A @ Xs ) )
        = ( Xs
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_is_lrev_conv
thf(fact_56_lrev__is__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( ( lList2281150353e_lrev @ A @ Xs )
          = ( coinductive_LNil @ A ) )
        = ( Xs
          = ( coinductive_LNil @ A ) ) ) ) )).

% lrev_is_LNil_conv
thf(fact_57_llast__singleton,axiom,(
    ! [A: $tType,X: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) )
      = X ) )).

% llast_singleton
thf(fact_58_alllstsp_Ocases,axiom,(
    ! [A: $tType,A2: ( A > $o ),A3: ( coinductive_llist @ A )] :
      ( ( lList21511617539llstsp @ A @ A2 @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L: ( coinductive_llist @ A ),A4: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A4 @ L ) )
               => ( ( lList21511617539llstsp @ A @ A2 @ L )
                 => ~ ( A2 @ A4 ) ) ) ) ) ) )).

% alllstsp.cases
thf(fact_59_alllstsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lList21511617539llstsp @ A )
      = ( ^ [A6: ( A > $o ),A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [L3: ( coinductive_llist @ A ),B2: A] :
                ( ( A5
                  = ( coinductive_LCons @ A @ B2 @ L3 ) )
                & ( lList21511617539llstsp @ A @ A6 @ L3 )
                & ( A6 @ B2 ) ) ) ) ) )).

% alllstsp.simps
thf(fact_60_finlstsp_Ocases,axiom,(
    ! [A: $tType,A2: ( A > $o ),A3: ( coinductive_llist @ A )] :
      ( ( lList2860480441nlstsp @ A @ A2 @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L: ( coinductive_llist @ A ),A4: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A4 @ L ) )
               => ( ( lList2860480441nlstsp @ A @ A2 @ L )
                 => ~ ( A2 @ A4 ) ) ) ) ) ) )).

% finlstsp.cases
thf(fact_61_finlstsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lList2860480441nlstsp @ A )
      = ( ^ [A6: ( A > $o ),A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [L3: ( coinductive_llist @ A ),B2: A] :
                ( ( A5
                  = ( coinductive_LCons @ A @ B2 @ L3 ) )
                & ( lList2860480441nlstsp @ A @ A6 @ L3 )
                & ( A6 @ B2 ) ) ) ) ) )).

% finlstsp.simps
thf(fact_62_llast__LCons2,axiom,(
    ! [A: $tType,X: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LCons @ A @ Y @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) )).

% llast_LCons2
thf(fact_63_lrev__lrev__ident,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( lList2281150353e_lrev @ A @ ( lList2281150353e_lrev @ A @ Xs ) )
        = Xs ) ) )).

% lrev_lrev_ident
thf(fact_64_lrev__is__lrev__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Ys @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( ( lList2281150353e_lrev @ A @ Xs )
            = ( lList2281150353e_lrev @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) )).

% lrev_is_lrev_conv
thf(fact_65_finT__simp,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finT_simp
thf(fact_66_fin__finite,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_finite
thf(fact_67_finlstsp_OLCons__fin,axiom,(
    ! [A: $tType,A2: ( A > $o ),L2: ( coinductive_llist @ A ),A3: A] :
      ( ( lList2860480441nlstsp @ A @ A2 @ L2 )
     => ( ( A2 @ A3 )
       => ( lList2860480441nlstsp @ A @ A2 @ ( coinductive_LCons @ A @ A3 @ L2 ) ) ) ) )).

% finlstsp.LCons_fin
thf(fact_68_alllstsp_OLCons__all,axiom,(
    ! [A: $tType,A2: ( A > $o ),L2: ( coinductive_llist @ A ),A3: A] :
      ( ( lList21511617539llstsp @ A @ A2 @ L2 )
     => ( ( A2 @ A3 )
       => ( lList21511617539llstsp @ A @ A2 @ ( coinductive_LCons @ A @ A3 @ L2 ) ) ) ) )).

% alllstsp.LCons_all
thf(fact_69_finlstsp_OLNil__fin,axiom,(
    ! [A: $tType,A2: ( A > $o )] :
      ( lList2860480441nlstsp @ A @ A2 @ ( coinductive_LNil @ A ) ) )).

% finlstsp.LNil_fin
thf(fact_70_alllstsp_OLNil__all,axiom,(
    ! [A: $tType,A2: ( A > $o )] :
      ( lList21511617539llstsp @ A @ A2 @ ( coinductive_LNil @ A ) ) )).

% alllstsp.LNil_all
thf(fact_71_alllstsp_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A ),A2: ( A > $o )] :
      ( ( X4 @ X )
     => ( ! [X2: ( coinductive_llist @ A )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ A ) )
              | ? [L4: ( coinductive_llist @ A ),A7: A] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ A7 @ L4 ) )
                  & ( ( X4 @ L4 )
                    | ( lList21511617539llstsp @ A @ A2 @ L4 ) )
                  & ( A2 @ A7 ) ) ) )
       => ( lList21511617539llstsp @ A @ A2 @ X ) ) ) )).

% alllstsp.coinduct
thf(fact_72_finlstsp_Oinducts,axiom,(
    ! [A: $tType,A2: ( A > $o ),X: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( lList2860480441nlstsp @ A @ A2 @ X )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L: ( coinductive_llist @ A ),A4: A] :
              ( ( lList2860480441nlstsp @ A @ A2 @ L )
             => ( ( P @ L )
               => ( ( A2 @ A4 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L ) ) ) ) )
         => ( P @ X ) ) ) ) )).

% finlstsp.inducts
thf(fact_73_UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_74_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_75_top__apply,axiom,(
    ! [C2: $tType,D2: $tType] :
      ( ( top @ C2 @ ( type2 @ C2 ) )
     => ( ( top_top @ ( D2 > C2 ) )
        = ( ^ [X3: D2] :
              ( top_top @ C2 ) ) ) ) )).

% top_apply
thf(fact_76_poslsts__UNIV,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21148268032oslsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( S
       != ( coinductive_LNil @ A ) ) ) )).

% poslsts_UNIV
thf(fact_77_ltake__fin,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),I: nat] :
      ( member @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ R @ I ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% ltake_fin
thf(fact_78_ldrop__fin__iffT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% ldrop_fin_iffT
thf(fact_79_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_80_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_81_lfinite__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_82_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_83_lfinite__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ( coinductive_lfinite @ A @ Ys ) ) ) )).

% lfinite_lappend
thf(fact_84_LList2__Mirabelle__hamjzmohle_Oldrop__LNil,axiom,(
    ! [A: $tType,I: nat] :
      ( ( lList2508575361_ldrop @ A @ ( coinductive_LNil @ A ) @ I )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ldrop_LNil
thf(fact_85_LList2__Mirabelle__hamjzmohle_Oltake__LNil,axiom,(
    ! [A: $tType,I: nat] :
      ( ( lList22119844313_ltake @ A @ ( coinductive_LNil @ A ) @ I )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ltake_LNil
thf(fact_86_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_87_ltake__ldrop__id,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),I: nat] :
      ( ( coinductive_lappend @ A @ ( lList22119844313_ltake @ A @ X @ I ) @ ( lList2508575361_ldrop @ A @ X @ I ) )
      = X ) )).

% ltake_ldrop_id
thf(fact_88_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_89_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_90_lappend__inf,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_inf
thf(fact_91_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ Ys )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lstrict_prefix_lfinite1
thf(fact_92_drop__nonLNil,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( ( lList2508575361_ldrop @ A @ T @ I )
       != ( coinductive_LNil @ A ) )
     => ( T
       != ( coinductive_LNil @ A ) ) ) )).

% drop_nonLNil
thf(fact_93_ldrop__finT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% ldrop_finT
thf(fact_94_lfinite_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs2: ( coinductive_llist @ A )] :
                ( ? [X2: A] :
                    ( A3
                    = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
               => ~ ( coinductive_lfinite @ A @ Xs2 ) ) ) ) ) )).

% lfinite.cases
thf(fact_95_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [Xs4: ( coinductive_llist @ A ),X3: A] :
                ( ( A5
                  = ( coinductive_LCons @ A @ X3 @ Xs4 ) )
                & ( coinductive_lfinite @ A @ Xs4 ) ) ) ) ) )).

% lfinite.simps
thf(fact_96_lfinite_Oinducts,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs2: ( coinductive_llist @ A ),X2: A] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) )
         => ( P @ X ) ) ) ) )).

% lfinite.inducts
thf(fact_97_lfinite__rev__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs2 )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_lappend @ A @ Xs2 @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lfinite_rev_induct
thf(fact_98_llimit__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( P @ ( coinductive_LNil @ A ) )
     => ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
            ( ( coinductive_lfinite @ A @ Xs2 )
           => ( ( P @ Xs2 )
             => ( P @ ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) )
       => ( ( ! [Ys2: ( coinductive_llist @ A )] :
                ( ( coindu1478340336prefix @ A @ Ys2 @ Xs )
               => ( P @ Ys2 ) )
           => ( P @ Xs ) )
         => ( P @ Xs ) ) ) ) )).

% llimit_induct
thf(fact_99_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_100_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X2: A] :
          ( member @ A @ X2 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_101_ltake__lappend__llength,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList22119844313_ltake @ A @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21232602520length @ A @ R ) )
        = R ) ) )).

% ltake_lappend_llength
thf(fact_102_llength__drop__take,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( ( lList2508575361_ldrop @ A @ T @ I )
       != ( coinductive_LNil @ A ) )
     => ( ( lList21232602520length @ A @ ( lList22119844313_ltake @ A @ T @ I ) )
        = I ) ) )).

% llength_drop_take
thf(fact_103_lapp__suff__llength,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2508575361_ldrop @ A @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21232602520length @ A @ R ) )
        = S ) ) )).

% lapp_suff_llength
thf(fact_104_poslsts__iff,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21148268032oslsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A2 ) )
        & ( S
         != ( coinductive_LNil @ A ) ) ) ) )).

% poslsts_iff
thf(fact_105_take__fin,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% take_fin
thf(fact_106_ldrop__inf__iffT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% ldrop_inf_iffT
thf(fact_107_top1I,axiom,(
    ! [A: $tType,X: A] :
      ( top_top @ ( A > $o ) @ X ) )).

% top1I
thf(fact_108_alllsts__UNIV,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A )] :
      ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% alllsts_UNIV
thf(fact_109_LConsE,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X @ Xs ) @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( member @ A @ X @ A2 )
        & ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% LConsE
thf(fact_110_lapp__inf,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( ( coinductive_lappend @ A @ S @ T )
        = S ) ) )).

% lapp_inf
thf(fact_111_notfin__inf,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A )] :
      ( ( ~ ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ X @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% notfin_inf
thf(fact_112_notinf__fin,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A )] :
      ( ( ~ ( member @ ( coinductive_llist @ A ) @ X @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% notinf_fin
thf(fact_113_llength__take,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( ( lList21232602520length @ A @ ( lList22119844313_ltake @ A @ T @ I ) )
        = I ) ) )).

% llength_take
thf(fact_114_inflstsI,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ~ ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% inflstsI
thf(fact_115_infsubsetall,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% infsubsetall
thf(fact_116_alllstsE,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ~ ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ X @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% alllstsE
thf(fact_117_inflstsE,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList21612149805nflsts @ A @ A2 ) )
     => ~ ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
         => ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% inflstsE
thf(fact_118_lapp__allT__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A2 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_allT_iff
thf(fact_119_infT__simp,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% infT_simp
thf(fact_120_inflsts__cases,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) )
     => ~ ( ! [A4: A,L: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList21612149805nflsts @ A @ A2 ) )
             => ( ( member @ A @ A4 @ A2 )
               => ( S
                 != ( coinductive_LCons @ A @ A4 @ L ) ) ) ) ) ) )).

% inflsts_cases
thf(fact_121_inflstsI2,axiom,(
    ! [A: $tType,A3: A,A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ A @ A3 @ A2 )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A3 @ T ) @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% inflstsI2
thf(fact_122_alllsts_OLCons__all,axiom,(
    ! [A: $tType,L2: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( member @ A @ A3 @ A2 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A3 @ L2 ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllsts.LCons_all
thf(fact_123_alllsts_OLNil__all,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2435255213lllsts @ A @ A2 ) ) )).

% alllsts.LNil_all
thf(fact_124_lapp__all__invT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% lapp_all_invT
thf(fact_125_lappT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% lappT
thf(fact_126_finite__lemma,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ B3 ) )
       => ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ B3 ) ) ) ) )).

% finite_lemma
thf(fact_127_finsubsetall,axiom,(
    ! [A: $tType,X: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% finsubsetall
thf(fact_128_ldrop__infT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList21612149805nflsts @ A @ A2 ) ) ) )).

% ldrop_infT
thf(fact_129_ldropT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% ldropT
thf(fact_130_alllsts_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( X4 @ X )
     => ( ! [X2: ( coinductive_llist @ A )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ A ) )
              | ? [L4: ( coinductive_llist @ A ),A7: A] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ A7 @ L4 ) )
                  & ( ( X4 @ L4 )
                    | ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2435255213lllsts @ A @ A2 ) ) )
                  & ( member @ A @ A7 @ A2 ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllsts.coinduct
thf(fact_131_alllsts_Osimps,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( A3
          = ( coinductive_LNil @ A ) )
        | ? [L3: ( coinductive_llist @ A ),A5: A] :
            ( ( A3
              = ( coinductive_LCons @ A @ A5 @ L3 ) )
            & ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2435255213lllsts @ A @ A2 ) )
            & ( member @ A @ A5 @ A2 ) ) ) ) )).

% alllsts.simps
thf(fact_132_alllsts_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A3 @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L: ( coinductive_llist @ A ),A4: A] :
                ( ( A3
                  = ( coinductive_LCons @ A @ A4 @ L ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2435255213lllsts @ A @ A2 ) )
                 => ~ ( member @ A @ A4 @ A2 ) ) ) ) ) ) )).

% alllsts.cases
thf(fact_133_fin__inf__cases,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A )] :
      ( ~ ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_inf_cases
thf(fact_134_lapp__fin__infT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_fin_infT
thf(fact_135_lapp__inv2T,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_inv2T
thf(fact_136_lapp__infT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A2 ) )
      = ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_infT
thf(fact_137_app__invT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% app_invT
thf(fact_138_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X3: A] :
            ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_139_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X ) )
      = P ) )).

% top_conj(2)
thf(fact_140_top__conj_I1_J,axiom,(
    ! [A: $tType,X: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_141_inflsts__def,axiom,(
    ! [A: $tType] :
      ( ( lList21612149805nflsts @ A )
      = ( ^ [A6: ( set @ A )] :
            ( minus_minus @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2435255213lllsts @ A @ A6 ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% inflsts_def
thf(fact_142_LList2__Mirabelle__hamjzmohle_Ollength__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),A3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList21232602520length @ A @ ( coinductive_LCons @ A @ A3 @ R ) )
        = ( suc @ ( lList21232602520length @ A @ R ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llength_LCons
thf(fact_143_DiffI,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ A2 )
     => ( ~ ( member @ A @ C @ B3 )
       => ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) ) ) )).

% DiffI
thf(fact_144_Diff__iff,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
      = ( ( member @ A @ C @ A2 )
        & ~ ( member @ A @ C @ B3 ) ) ) )).

% Diff_iff
thf(fact_145_Diff__idemp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) @ B3 )
      = ( minus_minus @ ( set @ A ) @ A2 @ B3 ) ) )).

% Diff_idemp
thf(fact_146_DiffE,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ( ( member @ A @ C @ A2 )
         => ( member @ A @ C @ B3 ) ) ) )).

% DiffE
thf(fact_147_DiffD1,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ( member @ A @ C @ A2 ) ) )).

% DiffD1
thf(fact_148_DiffD2,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( minus_minus @ ( set @ A ) @ A2 @ B3 ) )
     => ~ ( member @ A @ C @ B3 ) ) )).

% DiffD2
thf(fact_149_ltake__LCons__Suc,axiom,(
    ! [A: $tType,A3: A,L2: ( coinductive_llist @ A ),I: nat] :
      ( ( lList22119844313_ltake @ A @ ( coinductive_LCons @ A @ A3 @ L2 ) @ ( suc @ I ) )
      = ( coinductive_LCons @ A @ A3 @ ( lList22119844313_ltake @ A @ L2 @ I ) ) ) )).

% ltake_LCons_Suc
thf(fact_150_fin__Un__inf,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2236698231inlsts @ A @ A2 ) @ ( lList21612149805nflsts @ A @ A2 ) )
      = ( lList2435255213lllsts @ A @ A2 ) ) )).

% fin_Un_inf
thf(fact_151_LList2__Mirabelle__hamjzmohle_Ollength__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList21232602520length @ A @ ( coinductive_LNil @ A ) )
      = ( zero_zero @ nat ) ) )).

% LList2_Mirabelle_hamjzmohle.llength_LNil
thf(fact_152_lstrict__prefix__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lstrict_prefix_lappend_conv
thf(fact_153_lmember__code_I1_J,axiom,(
    ! [A: $tType,X: A] :
      ~ ( coinductive_lmember @ A @ X @ ( coinductive_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_154_Un__iff,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
      = ( ( member @ A @ C @ A2 )
        | ( member @ A @ C @ B3 ) ) ) )).

% Un_iff
thf(fact_155_UnCI,axiom,(
    ! [A: $tType,C: A,B3: ( set @ A ),A2: ( set @ A )] :
      ( ( ~ ( member @ A @ C @ B3 )
       => ( member @ A @ C @ A2 ) )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% UnCI
thf(fact_156_Un__Diff__cancel,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) )
      = ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) )).

% Un_Diff_cancel
thf(fact_157_Un__Diff__cancel2,axiom,(
    ! [A: $tType,B3: ( set @ A ),A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ B3 @ A2 ) @ A2 )
      = ( sup_sup @ ( set @ A ) @ B3 @ A2 ) ) )).

% Un_Diff_cancel2
thf(fact_158_lappend_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.disc_iff(2)
thf(fact_159_lnull__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        & ( coinductive_lnull @ A @ Ys ) ) ) )).

% lnull_lappend
thf(fact_160_Un__Diff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ C3 ) @ ( minus_minus @ ( set @ A ) @ B3 @ C3 ) ) ) )).

% Un_Diff
thf(fact_161_LList2__Mirabelle__hamjzmohle_Oldrop_Osimps_I1_J,axiom,(
    ! [A: $tType,L2: ( coinductive_llist @ A )] :
      ( ( lList2508575361_ldrop @ A @ L2 @ ( zero_zero @ nat ) )
      = L2 ) )).

% LList2_Mirabelle_hamjzmohle.ldrop.simps(1)
thf(fact_162_Un__left__commute,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_163_Un__left__absorb,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) )).

% Un_left_absorb
thf(fact_164_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B4: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B4 @ A6 ) ) ) )).

% Un_commute
thf(fact_165_Un__absorb,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ A2 )
      = A2 ) )).

% Un_absorb
thf(fact_166_Un__assoc,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B3 @ C3 ) ) ) )).

% Un_assoc
thf(fact_167_ball__Un,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A2 )
           => ( P @ X3 ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ B3 )
           => ( P @ X3 ) ) ) ) )).

% ball_Un
thf(fact_168_bex__Un,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ A2 )
            & ( P @ X3 ) )
        | ? [X3: A] :
            ( ( member @ A @ X3 @ B3 )
            & ( P @ X3 ) ) ) ) )).

% bex_Un
thf(fact_169_UnI2,axiom,(
    ! [A: $tType,C: A,B3: ( set @ A ),A2: ( set @ A )] :
      ( ( member @ A @ C @ B3 )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% UnI2
thf(fact_170_UnI1,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ A2 )
     => ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) ) ) )).

% UnI1
thf(fact_171_UnE,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C @ ( sup_sup @ ( set @ A ) @ A2 @ B3 ) )
     => ( ~ ( member @ A @ C @ A2 )
       => ( member @ A @ C @ B3 ) ) ) )).

% UnE
thf(fact_172_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_173_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_174_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_175_lappend_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) )
     => ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) )).

% lappend.disc(2)
thf(fact_176_lappend_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) ) )).

% lappend.disc(1)
thf(fact_177_lappend__lnull1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Ys ) ) )).

% lappend_lnull1
thf(fact_178_lappend__lnull2,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_lnull2
thf(fact_179_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_180_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_181_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist )
     => ( Llist
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_182_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist2: ( coinductive_llist @ A )] :
            ( Llist2
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_183_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X212: A,X222: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X212 @ X222 ) ) )).

% llist.disc(2)
thf(fact_184_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X212: A,X222: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X212 @ X222 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_185_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X3: A,Xs3: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs3 ) ) ) ) )).

% not_lnull_conv
thf(fact_186_Un__UNIV__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B3 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_187_Un__UNIV__right,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_188_lappend_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_lappend @ A @ Xs @ Ys )
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend.ctr(1)
thf(fact_189_Coinductive__List_Ollast__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X: A] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
          = X ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_llast @ A @ Xs ) ) ) ) )).

% Coinductive_List.llast_LCons
thf(fact_190_LList2__Mirabelle__hamjzmohle_Oltake_Osimps_I1_J,axiom,(
    ! [A: $tType,L2: ( coinductive_llist @ A )] :
      ( ( lList22119844313_ltake @ A @ L2 @ ( zero_zero @ nat ) )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ltake.simps(1)
thf(fact_191_lmember__code_I2_J,axiom,(
    ! [A: $tType,X: A,Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( X = Y )
        | ( coinductive_lmember @ A @ X @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_192_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_193_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_194_lsublist__singleton,axiom,(
    ! [A: $tType,A2: ( set @ nat ),X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A2 )
       => ( ( coinductive_lsublist @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) @ A2 )
          = ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A2 )
       => ( ( coinductive_lsublist @ A @ ( coinductive_LCons @ A @ X @ ( coinductive_LNil @ A ) ) @ A2 )
          = ( coinductive_LNil @ A ) ) ) ) )).

% lsublist_singleton
thf(fact_195_lsublist__LNil,axiom,(
    ! [A: $tType,A2: ( set @ nat )] :
      ( ( coinductive_lsublist @ A @ ( coinductive_LNil @ A ) @ A2 )
      = ( coinductive_LNil @ A ) ) )).

% lsublist_LNil
thf(fact_196_llistsum__inf,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A )] :
          ( ~ ( coinductive_lfinite @ A @ Xs )
         => ( ( coindu780009021istsum @ A @ Xs )
            = ( zero_zero @ A ) ) ) ) )).

% llistsum_inf
thf(fact_197_llistsum__LNil,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ( ( coindu780009021istsum @ A @ ( coinductive_LNil @ A ) )
        = ( zero_zero @ A ) ) ) )).

% llistsum_LNil
thf(fact_198_ltake_Oexhaust,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( ~ ( ( N
            = ( zero_zero @ extended_enat ) )
          | ( coinductive_lnull @ A @ Xs ) )
     => ~ ( ( N
           != ( zero_zero @ extended_enat ) )
         => ( coinductive_lnull @ A @ Xs ) ) ) )).

% ltake.exhaust
thf(fact_199_llast__lappend,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_llast @ A @ Xs ) ) )
      & ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( coinductive_lfinite @ A @ Xs )
           => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( coinductive_llast @ A @ Ys ) ) )
          & ( ~ ( coinductive_lfinite @ A @ Xs )
           => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( undefined @ A ) ) ) ) ) ) )).

% llast_lappend
thf(fact_200_llistsum__LCons,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),X: A] :
          ( ( coinductive_lfinite @ A @ Xs )
         => ( ( coindu780009021istsum @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
            = ( plus_plus @ A @ X @ ( coindu780009021istsum @ A @ Xs ) ) ) ) ) )).

% llistsum_LCons
thf(fact_201_LList2__Mirabelle__hamjzmohle_Ollast__LNil,axiom,(
    ! [B: $tType] :
      ( ( lList2170638824_llast @ B @ ( coinductive_LNil @ B ) )
      = ( undefined @ B ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_LNil
thf(fact_202_llast__linfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ Xs )
        = ( undefined @ A ) ) ) )).

% llast_linfinite
thf(fact_203_ldrop__add,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat,K: nat] :
      ( ( lList2508575361_ldrop @ A @ T @ ( plus_plus @ nat @ I @ K ) )
      = ( lList2508575361_ldrop @ A @ ( lList2508575361_ldrop @ A @ T @ I ) @ K ) ) )).

% ldrop_add
thf(fact_204_Coinductive__List_Ollast__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llast @ A @ ( coinductive_LNil @ A ) )
      = ( undefined @ A ) ) )).

% Coinductive_List.llast_LNil
thf(fact_205_LList2__Mirabelle__hamjzmohle_Oltake__ldrop,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),M: nat,N: nat] :
      ( ( lList22119844313_ltake @ A @ ( lList2508575361_ldrop @ A @ Xs @ M ) @ N )
      = ( lList2508575361_ldrop @ A @ ( lList22119844313_ltake @ A @ Xs @ ( plus_plus @ nat @ N @ M ) ) @ M ) ) )).

% LList2_Mirabelle_hamjzmohle.ltake_ldrop
thf(fact_206_llistsum__lappend,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( coinductive_lfinite @ A @ Xs )
         => ( ( coinductive_lfinite @ A @ Ys )
           => ( ( coindu780009021istsum @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( plus_plus @ A @ ( coindu780009021istsum @ A @ Xs ) @ ( coindu780009021istsum @ A @ Ys ) ) ) ) ) ) )).

% llistsum_lappend
thf(fact_207_llcp__LNil2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llcp @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( zero_zero @ extended_enat ) ) )).

% llcp_LNil2
thf(fact_208_llcp__LNil1,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llcp @ A @ ( coinductive_LNil @ A ) @ Ys )
      = ( zero_zero @ extended_enat ) ) )).

% llcp_LNil1
thf(fact_209_llcp__commute,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llcp @ A )
      = ( ^ [Xs4: ( coinductive_llist @ A ),Ys3: ( coinductive_llist @ A )] :
            ( coinductive_llcp @ A @ Ys3 @ Xs4 ) ) ) )).

% llcp_commute
thf(fact_210_llcp__LCons,axiom,(
    ! [A: $tType,X: A,Y: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( X = Y )
       => ( ( coinductive_llcp @ A @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
          = ( extended_eSuc @ ( coinductive_llcp @ A @ Xs @ Ys ) ) ) )
      & ( ( X != Y )
       => ( ( coinductive_llcp @ A @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
          = ( zero_zero @ extended_enat ) ) ) ) )).

% llcp_LCons
thf(fact_211_lset__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) ) ) ) )).

% lset_lappend_lfinite
thf(fact_212_lset__lmember,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
      = ( coinductive_lmember @ A @ X @ Xs ) ) )).

% lset_lmember
thf(fact_213_llist_Oset__induct,axiom,(
    ! [A: $tType,X: A,A3: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A3 ) )
     => ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( coinductive_llist @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( coinductive_lset @ A @ Z2 ) )
             => ( ( P @ Xa2 @ Z2 )
               => ( P @ Xa2 @ ( coinductive_LCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P @ X @ A3 ) ) ) ) )).

% llist.set_induct
thf(fact_214_llist_Oset__cases,axiom,(
    ! [A: $tType,E: A,A3: ( coinductive_llist @ A )] :
      ( ( member @ A @ E @ ( coinductive_lset @ A @ A3 ) )
     => ( ! [Z2: ( coinductive_llist @ A )] :
            ( A3
           != ( coinductive_LCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( coinductive_llist @ A )] :
                ( ( A3
                  = ( coinductive_LCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( coinductive_lset @ A @ Z2 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_215_lset__induct_H,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X5: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( P @ Xs2 )
               => ( P @ ( coinductive_LCons @ A @ X5 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_216_lset__induct,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs2: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X @ Xs2 ) )
       => ( ! [X5: A,Xs2: ( coinductive_llist @ A )] :
              ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs2 ) )
             => ( ( X != X5 )
               => ( ( P @ Xs2 )
                 => ( P @ ( coinductive_LCons @ A @ X5 @ Xs2 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_217_lset__cases,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs5: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X @ Xs5 ) )
       => ~ ( ! [X5: A,Xs5: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X5 @ Xs5 ) )
               => ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs5 ) ) ) ) ) ) )).

% lset_cases
thf(fact_218_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_219_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_220_lset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_221_lset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),X6: A] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X6 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_222_in__lset__lappend__iff,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        | ( ( coinductive_lfinite @ A @ Xs )
          & ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) ) ) ) ) )).

% in_lset_lappend_iff
thf(fact_223_split__llist,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys4: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys4 @ ( coinductive_LCons @ A @ X @ Zs2 ) ) )
          & ( coinductive_lfinite @ A @ Ys4 ) ) ) )).

% split_llist
thf(fact_224_split__llist__first,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys4: ( coinductive_llist @ A ),Zs2: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys4 @ ( coinductive_LCons @ A @ X @ Zs2 ) ) )
          & ( coinductive_lfinite @ A @ Ys4 )
          & ~ ( member @ A @ X @ ( coinductive_lset @ A @ Ys4 ) ) ) ) )).

% split_llist_first
thf(fact_225_lset__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfinite @ A @ Xs )
       => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( sup_sup @ ( set @ A ) @ ( coinductive_lset @ A @ Xs ) @ ( coinductive_lset @ A @ Ys ) ) ) )
      & ( ~ ( coinductive_lfinite @ A @ Xs )
       => ( ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lset @ A @ Xs ) ) ) ) )).

% lset_lappend_conv
thf(fact_226_gen__lset__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_gen_lset @ A )
      = ( ^ [A6: ( set @ A ),Xs4: ( coinductive_llist @ A )] :
            ( sup_sup @ ( set @ A ) @ A6 @ ( coinductive_lset @ A @ Xs4 ) ) ) ) )).

% gen_lset_def
thf(fact_227_lfilter__eq__LConsD,axiom,(
    ! [A: $tType,P: ( A > $o ),Ys: ( coinductive_llist @ A ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Ys )
        = ( coinductive_LCons @ A @ X @ Xs ) )
     => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
          ( ( Ys
            = ( coinductive_lappend @ A @ Us @ ( coinductive_LCons @ A @ X @ Vs ) ) )
          & ( coinductive_lfinite @ A @ Us )
          & ! [X7: A] :
              ( ( member @ A @ X7 @ ( coinductive_lset @ A @ Us ) )
             => ~ ( P @ X7 ) )
          & ( P @ X )
          & ( Xs
            = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) )).

% lfilter_eq_LConsD
thf(fact_228_lfilter__idem,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( coinductive_lfilter @ A @ P @ Xs ) ) )).

% lfilter_idem
thf(fact_229_lfilter__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
          = ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons
thf(fact_230_lfilter__LNil,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lfilter_LNil
thf(fact_231_diverge__lfilter__LNil,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
         => ~ ( P @ X2 ) )
     => ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_LNil @ A ) ) ) )).

% diverge_lfilter_LNil
thf(fact_232_lnull__lfilter,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ~ ( P @ X3 ) ) ) ) )).

% lnull_lfilter
thf(fact_233_lfilter__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( coinductive_lappend @ A @ ( coinductive_lfilter @ A @ P @ Xs ) @ ( coinductive_lfilter @ A @ P @ Ys ) ) ) ) )).

% lfilter_lappend_lfinite
thf(fact_234_lfilter__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X2 )
              = ( Q @ X2 ) ) )
       => ( ( coinductive_lfilter @ A @ P @ Xs )
          = ( coinductive_lfilter @ A @ Q @ Ys ) ) ) ) )).

% lfilter_cong
thf(fact_235_lfilter__id__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) )).

% lfilter_id_conv
thf(fact_236_lfilter__empty__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_LNil @ A ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ~ ( P @ X3 ) ) ) ) )).

% lfilter_empty_conv
thf(fact_237_lfilter__eq__lappend__lfiniteD,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_lappend @ A @ Ys @ Zs ) )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ? [Us: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_lappend @ A @ Us @ Vs ) )
            & ( coinductive_lfinite @ A @ Us )
            & ( Ys
              = ( coinductive_lfilter @ A @ P @ Us ) )
            & ( Zs
              = ( coinductive_lfilter @ A @ P @ Vs ) ) ) ) ) )).

% lfilter_eq_lappend_lfiniteD
thf(fact_238_lfinite__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )).

% lfinite_lfilterI
thf(fact_239_lfilter__LCons__seek,axiom,(
    ! [A: $tType,P2: ( A > $o ),X: A,L2: ( coinductive_llist @ A )] :
      ( ~ ( P2 @ X )
     => ( ( coinductive_lfilter @ A @ P2 @ ( coinductive_LCons @ A @ X @ L2 ) )
        = ( coinductive_lfilter @ A @ P2 @ L2 ) ) ) )).

% lfilter_LCons_seek
thf(fact_240_lfilter__LCons__found,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( coinductive_llist @ A )] :
      ( ( P @ X )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X @ Xs ) )
        = ( coinductive_LCons @ A @ X @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons_found
thf(fact_241_gen__lset__code_I1_J,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( coinductive_gen_lset @ A @ A2 @ ( coinductive_LNil @ A ) )
      = A2 ) )).

% gen_lset_code(1)
thf(fact_242_ldistinct_Ocases,axiom,(
    ! [A: $tType,A3: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ A3 )
     => ( ( A3
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [X2: A,Xs2: ( coinductive_llist @ A )] :
                ( ( A3
                  = ( coinductive_LCons @ A @ X2 @ Xs2 ) )
               => ( ~ ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs2 ) )
                 => ~ ( coindu351974385stinct @ A @ Xs2 ) ) ) ) ) ) )).

% ldistinct.cases
thf(fact_243_ldistinct_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coindu351974385stinct @ A )
      = ( ^ [A5: ( coinductive_llist @ A )] :
            ( ( A5
              = ( coinductive_LNil @ A ) )
            | ? [X3: A,Xs4: ( coinductive_llist @ A )] :
                ( ( A5
                  = ( coinductive_LCons @ A @ X3 @ Xs4 ) )
                & ~ ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs4 ) )
                & ( coindu351974385stinct @ A @ Xs4 ) ) ) ) ) )).

% ldistinct.simps
thf(fact_244_ldistinct__LNil__code,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct_LNil_code
thf(fact_245_ldistinct__LCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
        & ( coindu351974385stinct @ A @ Xs ) ) ) )).

% ldistinct_LCons
thf(fact_246_ldistinct__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coindu351974385stinct @ A @ Xs )
     => ( coindu351974385stinct @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )).

% ldistinct_lfilterI
thf(fact_247_ldistinct_OLNil,axiom,(
    ! [A: $tType] :
      ( coindu351974385stinct @ A @ ( coinductive_LNil @ A ) ) )).

% ldistinct.LNil
thf(fact_248_ldistinct_OLCons,axiom,(
    ! [A: $tType,X: A,Xs: ( coinductive_llist @ A )] :
      ( ~ ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
     => ( ( coindu351974385stinct @ A @ Xs )
       => ( coindu351974385stinct @ A @ ( coinductive_LCons @ A @ X @ Xs ) ) ) ) )).

% ldistinct.LCons
thf(fact_249_ldistinct_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X: ( coinductive_llist @ A )] :
      ( ( X4 @ X )
     => ( ! [X2: ( coinductive_llist @ A )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ A ) )
              | ? [Xa3: A,Xs6: ( coinductive_llist @ A )] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ Xa3 @ Xs6 ) )
                  & ~ ( member @ A @ Xa3 @ ( coinductive_lset @ A @ Xs6 ) )
                  & ( ( X4 @ Xs6 )
                    | ( coindu351974385stinct @ A @ Xs6 ) ) ) ) )
       => ( coindu351974385stinct @ A @ X ) ) ) )).

% ldistinct.coinduct
thf(fact_250_llexord__lappend__leftD,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_lappend @ A @ Xs @ Ys ) @ ( coinductive_lappend @ A @ Xs @ Zs ) )
     => ( ( coinductive_lfinite @ A @ Xs )
       => ( ! [X2: A] :
              ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
             => ~ ( R @ X2 @ X2 ) )
         => ( coinductive_llexord @ A @ R @ Ys @ Zs ) ) ) ) )).

% llexord_lappend_leftD
thf(fact_251_llexord__lappend__left,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),R: ( A > A > $o ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
           => ~ ( R @ X2 @ X2 ) )
       => ( ( coinductive_llexord @ A @ R @ ( coinductive_lappend @ A @ Xs @ Ys ) @ ( coinductive_lappend @ A @ Xs @ Zs ) )
          = ( coinductive_llexord @ A @ R @ Ys @ Zs ) ) ) ) )).

% llexord_lappend_left
thf(fact_252_llexord__refl,axiom,(
    ! [A: $tType,R: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( coinductive_llexord @ A @ R @ Xs @ Xs ) )).

% llexord_refl
thf(fact_253_llexord__LCons__LCons,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llexord @ A @ R @ ( coinductive_LCons @ A @ X @ Xs ) @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( ( X = Y )
          & ( coinductive_llexord @ A @ R @ Xs @ Ys ) )
        | ( R @ X @ Y ) ) ) )).

% llexord_LCons_LCons

%----Type constructors (14)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_1,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_2,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_3,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice_top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( top @ A9 @ ( type2 @ A9 ) )
     => ( top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add,axiom,
    ( monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_4,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_5,axiom,(
    ! [A8: $tType] :
      ( top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_6,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_7,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice__top_8,axiom,
    ( bounded_lattice_top @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_9,axiom,
    ( monoid_add @ extended_enat @ ( type2 @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Orderings_Otop_10,axiom,
    ( top @ extended_enat @ ( type2 @ extended_enat ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( lList2370560421utlast @ a @ ( coinductive_lappend @ a @ xs @ ( coinductive_LCons @ a @ x @ ( coinductive_LNil @ a ) ) ) )
    = xs )).

%------------------------------------------------------------------------------
