%------------------------------------------------------------------------------
% File     : DAT183^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Lazy lists II 951
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Fri04] Friedrich (2004), Lazy Lists II
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : llist2__951.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  340 (   0 unit;  54 type;   0 defn)
%            Number of atoms       : 4224 ( 236 equality;2531 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 3958 ( 103   ~;  29   |;  51   &;3421   @)
%                                         (   0 <=>; 354  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  153 ( 153   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   56 (  54   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  998 (   1 sgn; 885   !;  53   ?;  12   ^)
%                                         ( 998   :;  48  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:50:30.967
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (49)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,(
    condit1656338222tinuum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Ollist_Olnull,type,(
    coinductive_lnull: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_HOL_Oundefined,type,(
    undefined: 
      !>[A: $tType] : A )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllsts,type,(
    lList2435255213lllsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllstsp,type,(
    lList21511617539llstsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts,type,(
    lList2236698231inlsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts__rec,type,(
    lList21916056377ts_rec: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlstsp,type,(
    lList2860480441nlstsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofpslsts,type,(
    lList22096119349pslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oinflsts,type,(
    lList21612149805nflsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Olbutlast,type,(
    lList2370560421utlast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oldrop,type,(
    lList2508575361_ldrop: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ollast,type,(
    lList2170638824_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ollength,type,(
    lList21232602520length: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Olrev,type,(
    lList2281150353e_lrev: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oltake,type,(
    lList22119844313_ltake: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oposlsts,type,(
    lList21148268032oslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_r,type,(
    r: ( coinductive_llist @ a ) )).

%----Relevant facts (254)
thf(fact_0_lbutlast__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList2370560421utlast @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lbutlast_LNil
thf(fact_1_LNil__less__LCons,axiom,(
    ! [A: $tType,A2: A,T: ( coinductive_llist @ A )] :
      ( ord_less @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( coinductive_LCons @ A @ A2 @ T ) ) )).

% LNil_less_LCons
thf(fact_2_minf_I11_J,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( ord @ C @ ( type2 @ C ) )
     => ! [F: D] :
        ? [Z: C] :
        ! [X: C] :
          ( ( ord_less @ C @ X @ Z )
         => ( F = F ) ) ) )).

% minf(11)
thf(fact_3_minf_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z )
         => ~ ( ord_less @ A @ T @ X ) ) ) )).

% minf(7)
thf(fact_4_minf_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z )
         => ( ord_less @ A @ X @ T ) ) ) )).

% minf(5)
thf(fact_5_minf_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z )
         => ( X != T ) ) ) )).

% minf(4)
thf(fact_6_minf_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z )
         => ( X != T ) ) ) )).

% minf(3)
thf(fact_7_minf_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),P2: ( A > $o ),Q: ( A > $o ),Q2: ( A > $o )] :
          ( ? [Z2: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Z2 )
             => ( ( P @ X2 )
                = ( P2 @ X2 ) ) )
         => ( ? [Z2: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z2 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z )
               => ( ( ( P @ X )
                    | ( Q @ X ) )
                  = ( ( P2 @ X )
                    | ( Q2 @ X ) ) ) ) ) ) ) )).

% minf(2)
thf(fact_8_minf_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),P2: ( A > $o ),Q: ( A > $o ),Q2: ( A > $o )] :
          ( ? [Z2: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ X2 @ Z2 )
             => ( ( P @ X2 )
                = ( P2 @ X2 ) ) )
         => ( ? [Z2: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ X2 @ Z2 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z )
               => ( ( ( P @ X )
                    & ( Q @ X ) )
                  = ( ( P2 @ X )
                    & ( Q2 @ X ) ) ) ) ) ) ) )).

% minf(1)
thf(fact_9_pinf_I11_J,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( ord @ C @ ( type2 @ C ) )
     => ! [F: D] :
        ? [Z: C] :
        ! [X: C] :
          ( ( ord_less @ C @ Z @ X )
         => ( F = F ) ) ) )).

% pinf(11)
thf(fact_10_pinf_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( ord_less @ A @ T @ X ) ) ) )).

% pinf(7)
thf(fact_11_pinf_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z @ X )
         => ~ ( ord_less @ A @ X @ T ) ) ) )).

% pinf(5)
thf(fact_12_llistE,axiom,(
    ! [A: $tType,Y: ( coinductive_llist @ A )] :
      ( ( Y
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X21: A,X22: ( coinductive_llist @ A )] :
              ( Y
             != ( coinductive_LCons @ A @ X21 @ X22 ) ) ) ) )).

% llistE
thf(fact_13_pinf_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),P2: ( A > $o ),Q: ( A > $o ),Q2: ( A > $o )] :
          ( ? [Z2: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ Z2 @ X2 )
             => ( ( P @ X2 )
                = ( P2 @ X2 ) ) )
         => ( ? [Z2: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z2 @ X2 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z @ X )
               => ( ( ( P @ X )
                    & ( Q @ X ) )
                  = ( ( P2 @ X )
                    & ( Q2 @ X ) ) ) ) ) ) ) )).

% pinf(1)
thf(fact_14_pinf_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),P2: ( A > $o ),Q: ( A > $o ),Q2: ( A > $o )] :
          ( ? [Z2: A] :
            ! [X2: A] :
              ( ( ord_less @ A @ Z2 @ X2 )
             => ( ( P @ X2 )
                = ( P2 @ X2 ) ) )
         => ( ? [Z2: A] :
              ! [X2: A] :
                ( ( ord_less @ A @ Z2 @ X2 )
               => ( ( Q @ X2 )
                  = ( Q2 @ X2 ) ) )
           => ? [Z: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z @ X )
               => ( ( ( P @ X )
                    | ( Q @ X ) )
                  = ( ( P2 @ X )
                    | ( Q2 @ X ) ) ) ) ) ) ) )).

% pinf(2)
thf(fact_15_pinf_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( X != T ) ) ) )).

% pinf(3)
thf(fact_16_pinf_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( X != T ) ) ) )).

% pinf(4)
thf(fact_17_llist_Oinject,axiom,(
    ! [A: $tType,X212: A,X222: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X212 @ X222 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X212 = Y21 )
        & ( X222 = Y22 ) ) ) )).

% llist.inject
thf(fact_18_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X3: A,Xs2: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs2 ) ) ) ) )).

% neq_LNil_conv
thf(fact_19_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X212: A,X222: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X212 @ X222 ) ) )).

% llist.distinct(1)
thf(fact_20_fps__induct,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A3: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList22096119349pslsts @ A @ A3 ) )
     => ( ! [A4: A] :
            ( ( member @ A @ A4 @ A3 )
           => ( P @ ( coinductive_LCons @ A @ A4 @ ( coinductive_LNil @ A ) ) ) )
       => ( ! [A4: A,L2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList22096119349pslsts @ A @ A3 ) )
             => ( ( P @ L2 )
               => ( ( member @ A @ A4 @ A3 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L2 ) ) ) ) )
         => ( P @ L ) ) ) ) )).

% fps_induct
thf(fact_21_lbutlast__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( ( R
            = ( coinductive_LNil @ A ) )
         => ( ( lList2370560421utlast @ A @ ( coinductive_LCons @ A @ A2 @ R ) )
            = ( coinductive_LNil @ A ) ) )
        & ( ( R
           != ( coinductive_LNil @ A ) )
         => ( ( lList2370560421utlast @ A @ ( coinductive_LCons @ A @ A2 @ R ) )
            = ( coinductive_LCons @ A @ A2 @ ( lList2370560421utlast @ A @ R ) ) ) ) ) ) )).

% lbutlast_LCons
thf(fact_22_alllstsp_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X5: ( coinductive_llist @ A ),A3: ( A > $o )] :
      ( ( X4 @ X5 )
     => ( ! [X2: ( coinductive_llist @ A )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ A ) )
              | ? [L3: ( coinductive_llist @ A ),A5: A] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ A5 @ L3 ) )
                  & ( ( X4 @ L3 )
                    | ( lList21511617539llstsp @ A @ A3 @ L3 ) )
                  & ( A3 @ A5 ) ) ) )
       => ( lList21511617539llstsp @ A @ A3 @ X5 ) ) ) )).

% alllstsp.coinduct
thf(fact_23_finlstsp_Oinducts,axiom,(
    ! [A: $tType,A3: ( A > $o ),X5: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( lList2860480441nlstsp @ A @ A3 @ X5 )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L2: ( coinductive_llist @ A ),A4: A] :
              ( ( lList2860480441nlstsp @ A @ A3 @ L2 )
             => ( ( P @ L2 )
               => ( ( A3 @ A4 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L2 ) ) ) ) )
         => ( P @ X5 ) ) ) ) )).

% finlstsp.inducts
thf(fact_24_finlstsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lList2860480441nlstsp @ A )
      = ( ^ [A6: ( A > $o ),A7: ( coinductive_llist @ A )] :
            ( ( A7
              = ( coinductive_LNil @ A ) )
            | ? [L4: ( coinductive_llist @ A ),B2: A] :
                ( ( A7
                  = ( coinductive_LCons @ A @ B2 @ L4 ) )
                & ( lList2860480441nlstsp @ A @ A6 @ L4 )
                & ( A6 @ B2 ) ) ) ) ) )).

% finlstsp.simps
thf(fact_25_finlstsp_Ocases,axiom,(
    ! [A: $tType,A3: ( A > $o ),A2: ( coinductive_llist @ A )] :
      ( ( lList2860480441nlstsp @ A @ A3 @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L2: ( coinductive_llist @ A ),A4: A] :
                ( ( A2
                  = ( coinductive_LCons @ A @ A4 @ L2 ) )
               => ( ( lList2860480441nlstsp @ A @ A3 @ L2 )
                 => ~ ( A3 @ A4 ) ) ) ) ) ) )).

% finlstsp.cases
thf(fact_26_alllstsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lList21511617539llstsp @ A )
      = ( ^ [A6: ( A > $o ),A7: ( coinductive_llist @ A )] :
            ( ( A7
              = ( coinductive_LNil @ A ) )
            | ? [L4: ( coinductive_llist @ A ),B2: A] :
                ( ( A7
                  = ( coinductive_LCons @ A @ B2 @ L4 ) )
                & ( lList21511617539llstsp @ A @ A6 @ L4 )
                & ( A6 @ B2 ) ) ) ) ) )).

% alllstsp.simps
thf(fact_27_alllstsp_Ocases,axiom,(
    ! [A: $tType,A3: ( A > $o ),A2: ( coinductive_llist @ A )] :
      ( ( lList21511617539llstsp @ A @ A3 @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L2: ( coinductive_llist @ A ),A4: A] :
                ( ( A2
                  = ( coinductive_LCons @ A @ A4 @ L2 ) )
               => ( ( lList21511617539llstsp @ A @ A3 @ L2 )
                 => ~ ( A3 @ A4 ) ) ) ) ) ) )).

% alllstsp.cases
thf(fact_28_llist__less__finT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( ord_less @ ( coinductive_llist @ A ) @ R @ S )
     => ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) ) ) ) )).

% llist_less_finT
thf(fact_29_fpslsts__iff,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList22096119349pslsts @ A @ A3 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A3 ) )
        & ( S
         != ( coinductive_LNil @ A ) ) ) ) )).

% fpslsts_iff
thf(fact_30_fpslsts__cases,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList22096119349pslsts @ A @ A3 ) )
     => ~ ( ! [A4: A,Rs: ( coinductive_llist @ A )] :
              ( ( R
                = ( coinductive_LCons @ A @ A4 @ Rs ) )
             => ( ( member @ A @ A4 @ A3 )
               => ~ ( member @ ( coinductive_llist @ A ) @ Rs @ ( lList2236698231inlsts @ A @ A3 ) ) ) ) ) ) )).

% fpslsts_cases
thf(fact_31_finlsts_OLCons__fin,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A3: ( set @ A ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( member @ A @ A2 @ A3 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A2 @ L ) @ ( lList2236698231inlsts @ A @ A3 ) ) ) ) )).

% finlsts.LCons_fin
thf(fact_32_finlsts_OLNil__fin,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2236698231inlsts @ A @ A3 ) ) )).

% finlsts.LNil_fin
thf(fact_33_finlstsp_OLCons__fin,axiom,(
    ! [A: $tType,A3: ( A > $o ),L: ( coinductive_llist @ A ),A2: A] :
      ( ( lList2860480441nlstsp @ A @ A3 @ L )
     => ( ( A3 @ A2 )
       => ( lList2860480441nlstsp @ A @ A3 @ ( coinductive_LCons @ A @ A2 @ L ) ) ) ) )).

% finlstsp.LCons_fin
thf(fact_34_alllstsp_OLCons__all,axiom,(
    ! [A: $tType,A3: ( A > $o ),L: ( coinductive_llist @ A ),A2: A] :
      ( ( lList21511617539llstsp @ A @ A3 @ L )
     => ( ( A3 @ A2 )
       => ( lList21511617539llstsp @ A @ A3 @ ( coinductive_LCons @ A @ A2 @ L ) ) ) ) )).

% alllstsp.LCons_all
thf(fact_35_alllstsp_OLNil__all,axiom,(
    ! [A: $tType,A3: ( A > $o )] :
      ( lList21511617539llstsp @ A @ A3 @ ( coinductive_LNil @ A ) ) )).

% alllstsp.LNil_all
thf(fact_36_finlstsp_OLNil__fin,axiom,(
    ! [A: $tType,A3: ( A > $o )] :
      ( lList2860480441nlstsp @ A @ A3 @ ( coinductive_LNil @ A ) ) )).

% finlstsp.LNil_fin
thf(fact_37_finlsts_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A2 @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L2: ( coinductive_llist @ A ),A4: A] :
                ( ( A2
                  = ( coinductive_LCons @ A @ A4 @ L2 ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A3 ) )
                 => ~ ( member @ A @ A4 @ A3 ) ) ) ) ) ) )).

% finlsts.cases
thf(fact_38_finlsts_Osimps,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A2 @ ( lList2236698231inlsts @ A @ A3 ) )
      = ( ( A2
          = ( coinductive_LNil @ A ) )
        | ? [L4: ( coinductive_llist @ A ),A7: A] :
            ( ( A2
              = ( coinductive_LCons @ A @ A7 @ L4 ) )
            & ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2236698231inlsts @ A @ A3 ) )
            & ( member @ A @ A7 @ A3 ) ) ) ) )).

% finlsts.simps
thf(fact_39_finlsts__induct,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ! [L2: ( coinductive_llist @ A )] :
            ( ( L2
              = ( coinductive_LNil @ A ) )
           => ( P @ L2 ) )
       => ( ! [A4: A,L2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A3 ) )
             => ( ( P @ L2 )
               => ( ( member @ A @ A4 @ A3 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L2 ) ) ) ) )
         => ( P @ X5 ) ) ) ) )).

% finlsts_induct
thf(fact_40_finlsts_Oinducts,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L2: ( coinductive_llist @ A ),A4: A] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A3 ) )
             => ( ( P @ L2 )
               => ( ( member @ A @ A4 @ A3 )
                 => ( P @ ( coinductive_LCons @ A @ A4 @ L2 ) ) ) ) )
         => ( P @ X5 ) ) ) ) )).

% finlsts.inducts
thf(fact_41_LList2__Mirabelle__hamjzmohle_Ollast__LCons,axiom,(
    ! [B: $tType,R: ( coinductive_llist @ B ),A3: ( set @ B ),A2: B] :
      ( ( member @ ( coinductive_llist @ B ) @ R @ ( lList2236698231inlsts @ B @ A3 ) )
     => ( ( ( R
            = ( coinductive_LNil @ B ) )
         => ( ( lList2170638824_llast @ B @ ( coinductive_LCons @ B @ A2 @ R ) )
            = A2 ) )
        & ( ( R
           != ( coinductive_LNil @ B ) )
         => ( ( lList2170638824_llast @ B @ ( coinductive_LCons @ B @ A2 @ R ) )
            = ( lList2170638824_llast @ B @ R ) ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_LCons
thf(fact_42_lbutlast__snoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A3: ( set @ A ),X5: A] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList2370560421utlast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ X5 @ ( coinductive_LNil @ A ) ) ) )
        = Xs ) ) )).

% lbutlast_snoc
thf(fact_43_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs2: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y @ Xs2 ) )
            & ( coindu328551480prefix @ A @ Xs2 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_44_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X5: B,Xs: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X5 @ Xs ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F2 @ X2 )
          = ( G @ X2 ) )
     => ( F2 = G ) ) )).

% ext
thf(fact_49_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_50_finlsts__rec__LCons__def,axiom,(
    ! [B: $tType,A: $tType,F2: ( ( coinductive_llist @ A ) > B ),C2: B,D2: ( A > ( coinductive_llist @ A ) > B > B ),R: ( coinductive_llist @ A ),A3: ( set @ A ),A2: A] :
      ( ( F2
        = ( lList21916056377ts_rec @ B @ A @ C2 @ D2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
       => ( ( F2 @ ( coinductive_LCons @ A @ A2 @ R ) )
          = ( D2 @ A2 @ R @ ( F2 @ R ) ) ) ) ) )).

% finlsts_rec_LCons_def
thf(fact_51_finlsts__rec__LCons,axiom,(
    ! [B: $tType,A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),C2: B,D2: ( A > ( coinductive_llist @ A ) > B > B ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList21916056377ts_rec @ B @ A @ C2 @ D2 @ ( coinductive_LCons @ A @ A2 @ R ) )
        = ( D2 @ A2 @ R @ ( lList21916056377ts_rec @ B @ A @ C2 @ D2 @ R ) ) ) ) )).

% finlsts_rec_LCons
thf(fact_52_llast__singleton,axiom,(
    ! [A: $tType,X5: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X5 @ ( coinductive_LNil @ A ) ) )
      = X5 ) )).

% llast_singleton
thf(fact_53_lmember__code_I1_J,axiom,(
    ! [A: $tType,X5: A] :
      ~ ( coinductive_lmember @ A @ X5 @ ( coinductive_LNil @ A ) ) )).

% lmember_code(1)
thf(fact_54_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa: A,X5: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa @ X5 ) @ Ys )
      = ( coinductive_LCons @ A @ Xa @ ( coinductive_lappend @ A @ X5 @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_55_lappend__is__LNil__conv,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ S @ T )
        = ( coinductive_LNil @ A ) )
      = ( ( S
          = ( coinductive_LNil @ A ) )
        & ( T
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_is_LNil_conv
thf(fact_56_LNil__is__lappend__conv,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ S @ T ) )
      = ( ( S
          = ( coinductive_LNil @ A ) )
        & ( T
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_is_lappend_conv
thf(fact_57_lappend__eq__LNil__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ Xs @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_eq_LNil_iff
thf(fact_58_LNil__eq__lappend__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_eq_lappend_iff
thf(fact_59_lappend__LNil2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ Xs @ ( coinductive_LNil @ A ) )
      = Xs ) )).

% lappend_LNil2
thf(fact_60_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_61_same__lappend__eq,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( ( coinductive_lappend @ A @ R @ S )
          = ( coinductive_lappend @ A @ R @ T ) )
        = ( S = T ) ) ) )).

% same_lappend_eq
thf(fact_62_lapp__fin__fin__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2236698231inlsts @ A @ A3 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
        & ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A3 ) ) ) ) )).

% lapp_fin_fin_iff
thf(fact_63_llast__LCons2,axiom,(
    ! [A: $tType,X5: A,Y: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X5 @ ( coinductive_LCons @ A @ Y @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Xs ) ) ) )).

% llast_LCons2
thf(fact_64_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X5: B,Xs: ( coinductive_llist @ B ),Y: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X5 @ Xs ) @ ( coinductive_LCons @ B @ Y @ Ys ) )
      = ( ( X5 = Y )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_65_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_66_llast__snoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A3: ( set @ A ),X5: A] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList2170638824_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ X5 @ ( coinductive_LNil @ A ) ) ) )
        = X5 ) ) )).

% llast_snoc
thf(fact_67_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs3: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs3 )
             => ( P @ Ys2 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs ) ) )).

% llist_less_induct
thf(fact_68_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_69_lappend__LNil__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lappend_LNil_LNil
thf(fact_70_lappfin__finT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList2236698231inlsts @ A @ A3 ) ) ) ) )).

% lappfin_finT
thf(fact_71_lapp__fin__fin__lemma,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) ) ) )).

% lapp_fin_fin_lemma
thf(fact_72_lappend__snocL1__conv__LCons2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ ( coinductive_LNil @ A ) ) ) @ Ys )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) )).

% lappend_snocL1_conv_LCons2
thf(fact_73_finlsts__rec__LNil__def,axiom,(
    ! [A: $tType,B: $tType,F2: ( ( coinductive_llist @ A ) > B ),C2: B,D2: ( A > ( coinductive_llist @ A ) > B > B )] :
      ( ( F2
        = ( lList21916056377ts_rec @ B @ A @ C2 @ D2 ) )
     => ( ( F2 @ ( coinductive_LNil @ A ) )
        = C2 ) ) )).

% finlsts_rec_LNil_def
thf(fact_74_finlsts__rec__LNil,axiom,(
    ! [B: $tType,A: $tType,C2: A,D2: ( B > ( coinductive_llist @ B ) > A > A )] :
      ( ( lList21916056377ts_rec @ A @ B @ C2 @ D2 @ ( coinductive_LNil @ B ) )
      = C2 ) )).

% finlsts_rec_LNil
thf(fact_75_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( Xs
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_76_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_77_lrev__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A3: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X2: A,Xs3: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ Xs3 @ ( lList2236698231inlsts @ A @ A3 ) )
             => ( ( P @ Xs3 )
               => ( ( member @ A @ X2 @ A3 )
                 => ( P @ ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lrev_induct
thf(fact_78_finlsts__rev__cases,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( T
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [A4: A,L2: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A3 ) )
               => ( ( member @ A @ A4 @ A3 )
                 => ( T
                   != ( coinductive_lappend @ A @ L2 @ ( coinductive_LCons @ A @ A4 @ ( coinductive_LNil @ A ) ) ) ) ) ) ) ) ) )).

% finlsts_rev_cases
thf(fact_79_lbutlast__lapp__llast,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList22096119349pslsts @ A @ A3 ) )
     => ( L
        = ( coinductive_lappend @ A @ ( lList2370560421utlast @ A @ L ) @ ( coinductive_LCons @ A @ ( lList2170638824_llast @ A @ L ) @ ( coinductive_LNil @ A ) ) ) ) ) )).

% lbutlast_lapp_llast
thf(fact_80_lmember__code_I2_J,axiom,(
    ! [A: $tType,X5: A,Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X5 @ ( coinductive_LCons @ A @ Y @ Ys ) )
      = ( ( X5 = Y )
        | ( coinductive_lmember @ A @ X5 @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_81_lrev__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList2281150353e_lrev @ A @ ( coinductive_LCons @ A @ A2 @ R ) )
        = ( coinductive_lappend @ A @ ( lList2281150353e_lrev @ A @ R ) @ ( coinductive_LCons @ A @ A2 @ ( coinductive_LNil @ A ) ) ) ) ) )).

% lrev_LCons
thf(fact_82_LList2__Mirabelle__hamjzmohle_Ollast__lappend,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),Y: ( coinductive_llist @ A ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( lList2170638824_llast @ A @ ( coinductive_lappend @ A @ X5 @ ( coinductive_LCons @ A @ A2 @ Y ) ) )
          = ( lList2170638824_llast @ A @ ( coinductive_LCons @ A @ A2 @ Y ) ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_lappend
thf(fact_83_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_84_llimit__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( P @ ( coinductive_LNil @ A ) )
     => ( ! [X2: A,Xs3: ( coinductive_llist @ A )] :
            ( ( coinductive_lfinite @ A @ Xs3 )
           => ( ( P @ Xs3 )
             => ( P @ ( coinductive_LCons @ A @ X2 @ Xs3 ) ) ) )
       => ( ( ! [Ys2: ( coinductive_llist @ A )] :
                ( ( coindu1478340336prefix @ A @ Ys2 @ Xs )
               => ( P @ Ys2 ) )
           => ( P @ Xs ) )
         => ( P @ Xs ) ) ) ) )).

% llimit_induct
thf(fact_85_ex__gt__or__lt,axiom,(
    ! [A: $tType] :
      ( ( condit1656338222tinuum @ A @ ( type2 @ A ) )
     => ! [A2: A] :
        ? [B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
          | ( ord_less @ A @ B3 @ A2 ) ) ) )).

% ex_gt_or_lt
thf(fact_86_linorder__neqE__linordered__idom,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( X5 != Y )
         => ( ~ ( ord_less @ A @ X5 @ Y )
           => ( ord_less @ A @ Y @ X5 ) ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_87_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ( A2 != B4 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_88_linordered__field__no__ub,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X1: A] :
          ( ord_less @ A @ X @ X1 ) ) )).

% linordered_field_no_ub
thf(fact_89_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X3: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_90_lfinite__LCons,axiom,(
    ! [A: $tType,X5: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X5 @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_91_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X5: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X5 @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_92_lfinite__code_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_code(1)
thf(fact_93_lfinite__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ( coinductive_lfinite @ A @ Ys ) ) ) )).

% lfinite_lappend
thf(fact_94_lrev__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList2281150353e_lrev @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lrev_LNil
thf(fact_95_lrevT,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2281150353e_lrev @ A @ Xs ) @ ( lList2236698231inlsts @ A @ A3 ) ) ) )).

% lrevT
thf(fact_96_lrev__is__lrev__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Ys @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( ( lList2281150353e_lrev @ A @ Xs )
            = ( lList2281150353e_lrev @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) )).

% lrev_is_lrev_conv
thf(fact_97_lrev__lrev__ident,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( lList2281150353e_lrev @ A @ ( lList2281150353e_lrev @ A @ Xs ) )
        = Xs ) ) )).

% lrev_lrev_ident
thf(fact_98_LNil__is__lrev__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( ( coinductive_LNil @ A )
          = ( lList2281150353e_lrev @ A @ Xs ) )
        = ( Xs
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_is_lrev_conv
thf(fact_99_lrev__is__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( ( lList2281150353e_lrev @ A @ Xs )
          = ( coinductive_LNil @ A ) )
        = ( Xs
          = ( coinductive_LNil @ A ) ) ) ) )).

% lrev_is_LNil_conv
thf(fact_100_lrev__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Ys @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( lList2281150353e_lrev @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lappend @ A @ ( lList2281150353e_lrev @ A @ Ys ) @ ( lList2281150353e_lrev @ A @ Xs ) ) ) ) ) )).

% lrev_lappend
thf(fact_101_top_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
           != ( top_top @ A ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) )).

% top.not_eq_extremum
thf(fact_102_top_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) )).

% top.extremum_strict
thf(fact_103_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X5: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X5 @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_104_lfinite__LNil,axiom,(
    ! [A: $tType] :
      ( coinductive_lfinite @ A @ ( coinductive_LNil @ A ) ) )).

% lfinite_LNil
thf(fact_105_lappend__inf,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_inf
thf(fact_106_fin__finite,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_finite
thf(fact_107_finT__simp,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finT_simp
thf(fact_108_lstrict__prefix__lfinite1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ Ys )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lstrict_prefix_lfinite1
thf(fact_109_lfinite_Oinducts,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ X5 )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [Xs3: ( coinductive_llist @ A ),X2: A] :
              ( ( coinductive_lfinite @ A @ Xs3 )
             => ( ( P @ Xs3 )
               => ( P @ ( coinductive_LCons @ A @ X2 @ Xs3 ) ) ) )
         => ( P @ X5 ) ) ) ) )).

% lfinite.inducts
thf(fact_110_lfinite_Osimps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lfinite @ A )
      = ( ^ [A7: ( coinductive_llist @ A )] :
            ( ( A7
              = ( coinductive_LNil @ A ) )
            | ? [Xs4: ( coinductive_llist @ A ),X3: A] :
                ( ( A7
                  = ( coinductive_LCons @ A @ X3 @ Xs4 ) )
                & ( coinductive_lfinite @ A @ Xs4 ) ) ) ) ) )).

% lfinite.simps
thf(fact_111_lfinite_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ A2 )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [Xs3: ( coinductive_llist @ A )] :
                ( ? [X2: A] :
                    ( A2
                    = ( coinductive_LCons @ A @ X2 @ Xs3 ) )
               => ~ ( coinductive_lfinite @ A @ Xs3 ) ) ) ) ) )).

% lfinite.cases
thf(fact_112_lfinite__rev__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X2: A,Xs3: ( coinductive_llist @ A )] :
              ( ( coinductive_lfinite @ A @ Xs3 )
             => ( ( P @ Xs3 )
               => ( P @ ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LNil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lfinite_rev_induct
thf(fact_113_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F2: ( B > A ),B4: B,C2: B] :
          ( ( A2
            = ( F2 @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_114_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B4: A,F2: ( A > B ),C2: B] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ( F2 @ B4 )
              = C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_115_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F2: ( B > A ),B4: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C2 )
           => ( ! [X2: B,Y2: B] :
                  ( ( ord_less @ B @ X2 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_116_order__less__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B4: A,F2: ( A > C ),C2: C] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ord_less @ C @ ( F2 @ B4 ) @ C2 )
           => ( ! [X2: A,Y2: A] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) )).

% order_less_subst2
thf(fact_117_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X5: A] :
        ? [Y2: A] :
          ( ord_less @ A @ Y2 @ X5 ) ) )).

% lt_ex
thf(fact_118_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X5: A] :
        ? [X1: A] :
          ( ord_less @ A @ X5 @ X1 ) ) )).

% gt_ex
thf(fact_119_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( X5 != Y )
         => ( ~ ( ord_less @ A @ X5 @ Y )
           => ( ord_less @ A @ Y @ X5 ) ) ) ) )).

% neqE
thf(fact_120_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( X5 != Y )
          = ( ( ord_less @ A @ X5 @ Y )
            | ( ord_less @ A @ Y @ X5 ) ) ) ) )).

% neq_iff
thf(fact_121_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A2 ) ) ) )).

% order.asym
thf(fact_122_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ? [Z: A] :
              ( ( ord_less @ A @ X5 @ Z )
              & ( ord_less @ A @ Z @ Y ) ) ) ) )).

% dense
thf(fact_123_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ( X5 != Y ) ) ) )).

% less_imp_neq
thf(fact_124_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ~ ( ord_less @ A @ Y @ X5 ) ) ) )).

% less_asym
thf(fact_125_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A2 ) ) ) )).

% less_asym'
thf(fact_126_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A,Z3: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ( ( ord_less @ A @ Y @ Z3 )
           => ( ord_less @ A @ X5 @ Z3 ) ) ) ) )).

% less_trans
thf(fact_127_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
          | ( X5 = Y )
          | ( ord_less @ A @ Y @ X5 ) ) ) )).

% less_linear
thf(fact_128_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X5: A] :
          ~ ( ord_less @ A @ X5 @ X5 ) ) )).

% less_irrefl
thf(fact_129_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( A2 = B4 )
         => ( ( ord_less @ A @ B4 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% ord_eq_less_trans
thf(fact_130_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( B4 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% ord_less_eq_trans
thf(fact_131_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B4 ) ) ) )).

% dual_order.asym
thf(fact_132_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ( X5 != Y ) ) ) )).

% less_imp_not_eq
thf(fact_133_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ~ ( ord_less @ A @ Y @ X5 ) ) ) )).

% less_not_sym
thf(fact_134_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),A2: A] :
          ( ! [X2: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ A @ Y3 @ X2 )
                 => ( P @ Y3 ) )
             => ( P @ X2 ) )
         => ( P @ A2 ) ) ) )).

% less_induct
thf(fact_135_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,X5: A] :
          ( ~ ( ord_less @ A @ Y @ X5 )
         => ( ( ~ ( ord_less @ A @ X5 @ Y ) )
            = ( X5 = Y ) ) ) ) )).

% antisym_conv3
thf(fact_136_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ( Y != X5 ) ) ) )).

% less_imp_not_eq2
thf(fact_137_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X5 @ Y )
         => ( ( ord_less @ A @ Y @ X5 )
           => P ) ) ) )).

% less_imp_triv
thf(fact_138_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ~ ( ord_less @ A @ X5 @ Y )
         => ( ( X5 != Y )
           => ( ord_less @ A @ Y @ X5 ) ) ) ) )).

% linorder_cases
thf(fact_139_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) )).

% dual_order.irrefl
thf(fact_140_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( ( ord_less @ A @ B4 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) )).

% order.strict_trans
thf(fact_141_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less @ A @ X5 @ Y )
         => ~ ( ord_less @ A @ Y @ X5 ) ) ) )).

% less_imp_not_less
thf(fact_142_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B4 @ A2 )
         => ( ( ord_less @ A @ C2 @ B4 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_143_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X5 @ Y ) )
          = ( ( ord_less @ A @ Y @ X5 )
            | ( X5 = Y ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_144_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
         => ( A2 != B4 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_145_linordered__field__no__lb,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y2: A] :
          ( ord_less @ A @ Y2 @ X ) ) )).

% linordered_field_no_lb
thf(fact_146_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X5: A] :
      ( member @ A @ X5 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_147_UNIV__I,axiom,(
    ! [A: $tType,X5: A] :
      ( member @ A @ X5 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_148_poslsts__UNIV,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21148268032oslsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( S
       != ( coinductive_LNil @ A ) ) ) )).

% poslsts_UNIV
thf(fact_149_ltake__fin,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),I: nat] :
      ( member @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ R @ I ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% ltake_fin
thf(fact_150_ldrop__fin__iffT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% ldrop_fin_iffT
thf(fact_151_lstrict__prefix__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coindu1478340336prefix @ A @ Xs @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lstrict_prefix_lappend_conv
thf(fact_152_lnull__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lnull @ A @ Xs )
        & ( coinductive_lnull @ A @ Ys ) ) ) )).

% lnull_lappend
thf(fact_153_lappend_Odisc__iff_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.disc_iff(2)
thf(fact_154_LList2__Mirabelle__hamjzmohle_Oldrop__LNil,axiom,(
    ! [A: $tType,I: nat] :
      ( ( lList2508575361_ldrop @ A @ ( coinductive_LNil @ A ) @ I )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ldrop_LNil
thf(fact_155_LList2__Mirabelle__hamjzmohle_Oltake__LNil,axiom,(
    ! [A: $tType,I: nat] :
      ( ( lList22119844313_ltake @ A @ ( coinductive_LNil @ A ) @ I )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ltake_LNil
thf(fact_156_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_157_ltake__ldrop__id,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),I: nat] :
      ( ( coinductive_lappend @ A @ ( lList22119844313_ltake @ A @ X5 @ I ) @ ( lList2508575361_ldrop @ A @ X5 @ I ) )
      = X5 ) )).

% ltake_ldrop_id
thf(fact_158_lappend_Oexhaust,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ~ ( coinductive_lnull @ A @ Ys ) )
     => ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) ) ) )).

% lappend.exhaust
thf(fact_159_lzip_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ~ ( ( coinductive_lnull @ A @ Xs )
          | ( coinductive_lnull @ B @ Ys ) )
     => ~ ( ~ ( coinductive_lnull @ A @ Xs )
         => ( coinductive_lnull @ B @ Ys ) ) ) )).

% lzip.exhaust
thf(fact_160_llist_Odisc_I2_J,axiom,(
    ! [A: $tType,X212: A,X222: ( coinductive_llist @ A )] :
      ~ ( coinductive_lnull @ A @ ( coinductive_LCons @ A @ X212 @ X222 ) ) )).

% llist.disc(2)
thf(fact_161_llist_OdiscI_I2_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A ),X212: A,X222: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LCons @ A @ X212 @ X222 ) )
     => ~ ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(2)
thf(fact_162_not__lnull__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs ) )
      = ( ? [X3: A,Xs2: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X3 @ Xs2 ) ) ) ) )).

% not_lnull_conv
thf(fact_163_lnull__def,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lnull @ A )
      = ( ^ [Llist2: ( coinductive_llist @ A )] :
            ( Llist2
            = ( coinductive_LNil @ A ) ) ) ) )).

% lnull_def
thf(fact_164_llist_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Llist )
     => ( Llist
        = ( coinductive_LNil @ A ) ) ) )).

% llist.collapse(1)
thf(fact_165_llist_OdiscI_I1_J,axiom,(
    ! [A: $tType,Llist: ( coinductive_llist @ A )] :
      ( ( Llist
        = ( coinductive_LNil @ A ) )
     => ( coinductive_lnull @ A @ Llist ) ) )).

% llist.discI(1)
thf(fact_166_llist_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( coinductive_lnull @ A @ ( coinductive_LNil @ A ) ) )).

% llist.disc(1)
thf(fact_167_lappend__lnull2,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Ys )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_lnull2
thf(fact_168_lappend__lnull1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Ys ) ) )).

% lappend_lnull1
thf(fact_169_lappend_Odisc_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) ) )).

% lappend.disc(1)
thf(fact_170_lappend_Odisc_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ~ ( coinductive_lnull @ A @ Xs )
        | ~ ( coinductive_lnull @ A @ Ys ) )
     => ~ ( coinductive_lnull @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) ) )).

% lappend.disc(2)
thf(fact_171_lnull__imp__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( coinductive_lfinite @ A @ Xs ) ) )).

% lnull_imp_lfinite
thf(fact_172_drop__nonLNil,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( ( lList2508575361_ldrop @ A @ T @ I )
       != ( coinductive_LNil @ A ) )
     => ( T
       != ( coinductive_LNil @ A ) ) ) )).

% drop_nonLNil
thf(fact_173_ldrop__finT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A3: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ A3 ) ) ) )).

% ldrop_finT
thf(fact_174_lappend_Octr_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lnull @ A @ Xs )
     => ( ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_lappend @ A @ Xs @ Ys )
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend.ctr(1)
thf(fact_175_Coinductive__List_Ollast__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X5: A] :
      ( ( ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X5 @ Xs ) )
          = X5 ) )
      & ( ~ ( coinductive_lnull @ A @ Xs )
       => ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X5 @ Xs ) )
          = ( coinductive_llast @ A @ Xs ) ) ) ) )).

% Coinductive_List.llast_LCons
thf(fact_176_UNIV__eq__I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X2: A] :
          ( member @ A @ X2 @ A3 )
     => ( ( top_top @ ( set @ A ) )
        = A3 ) ) )).

% UNIV_eq_I
thf(fact_177_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_178_ltake__lappend__llength,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList22119844313_ltake @ A @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21232602520length @ A @ R ) )
        = R ) ) )).

% ltake_lappend_llength
thf(fact_179_llength__drop__take,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( ( lList2508575361_ldrop @ A @ T @ I )
       != ( coinductive_LNil @ A ) )
     => ( ( lList21232602520length @ A @ ( lList22119844313_ltake @ A @ T @ I ) )
        = I ) ) )).

% llength_drop_take
thf(fact_180_lapp__suff__llength,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList2508575361_ldrop @ A @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21232602520length @ A @ R ) )
        = S ) ) )).

% lapp_suff_llength
thf(fact_181_top1I,axiom,(
    ! [A: $tType,X5: A] :
      ( top_top @ ( A > $o ) @ X5 ) )).

% top1I
thf(fact_182_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X3: A] :
            ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_183_top__conj_I1_J,axiom,(
    ! [A: $tType,X5: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X5 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_184_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X5: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X5 ) )
      = P ) )).

% top_conj(2)
thf(fact_185_Coinductive__List_Ollast__lappend,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lnull @ A @ Ys )
       => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_llast @ A @ Xs ) ) )
      & ( ~ ( coinductive_lnull @ A @ Ys )
       => ( ( ( coinductive_lfinite @ A @ Xs )
           => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( coinductive_llast @ A @ Ys ) ) )
          & ( ~ ( coinductive_lfinite @ A @ Xs )
           => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( undefined @ A ) ) ) ) ) ) )).

% Coinductive_List.llast_lappend
thf(fact_186_LList2__Mirabelle__hamjzmohle_Ollength__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( lList21232602520length @ A @ ( coinductive_LCons @ A @ A2 @ R ) )
        = ( suc @ ( lList21232602520length @ A @ R ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llength_LCons
thf(fact_187_llength__take,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A3: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A3 ) )
     => ( ( lList21232602520length @ A @ ( lList22119844313_ltake @ A @ T @ I ) )
        = I ) ) )).

% llength_take
thf(fact_188_lapp__inf,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A3 ) )
     => ( ( coinductive_lappend @ A @ S @ T )
        = S ) ) )).

% lapp_inf
thf(fact_189_notfin__inf,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A )] :
      ( ( ~ ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% notfin_inf
thf(fact_190_notinf__fin,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A )] :
      ( ( ~ ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% notinf_fin
thf(fact_191_ldrop__inf__iffT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% ldrop_inf_iffT
thf(fact_192_LList2__Mirabelle__hamjzmohle_Ollast__LNil,axiom,(
    ! [B: $tType] :
      ( ( lList2170638824_llast @ B @ ( coinductive_LNil @ B ) )
      = ( undefined @ B ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_LNil
thf(fact_193_ldrop__infT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A3: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList21612149805nflsts @ A @ A3 ) ) ) )).

% ldrop_infT
thf(fact_194_inflstsI2,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A2 @ T ) @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% inflstsI2
thf(fact_195_inflsts__cases,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A3 ) )
     => ~ ( ! [A4: A,L2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList21612149805nflsts @ A @ A3 ) )
             => ( ( member @ A @ A4 @ A3 )
               => ( S
                 != ( coinductive_LCons @ A @ A4 @ L2 ) ) ) ) ) ) )).

% inflsts_cases
thf(fact_196_infT__simp,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% infT_simp
thf(fact_197_Coinductive__List_Ollast__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llast @ A @ ( coinductive_LNil @ A ) )
      = ( undefined @ A ) ) )).

% Coinductive_List.llast_LNil
thf(fact_198_llast__linfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ Xs )
        = ( undefined @ A ) ) ) )).

% llast_linfinite
thf(fact_199_ltake__LCons__Suc,axiom,(
    ! [A: $tType,A2: A,L: ( coinductive_llist @ A ),I: nat] :
      ( ( lList22119844313_ltake @ A @ ( coinductive_LCons @ A @ A2 @ L ) @ ( suc @ I ) )
      = ( coinductive_LCons @ A @ A2 @ ( lList22119844313_ltake @ A @ L @ I ) ) ) )).

% ltake_LCons_Suc
thf(fact_200_fin__inf__cases,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A )] :
      ( ~ ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_inf_cases
thf(fact_201_app__invT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A3: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% app_invT
thf(fact_202_lapp__infT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A3 ) )
      = ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A3 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% lapp_infT
thf(fact_203_lapp__inv2T,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A3 ) )
     => ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A3 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% lapp_inv2T
thf(fact_204_lapp__fin__infT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% lapp_fin_infT
thf(fact_205_lift__Suc__mono__less__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [F2: ( nat > A ),N: nat,M: nat] :
          ( ! [N2: nat] :
              ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) )).

% lift_Suc_mono_less_iff
thf(fact_206_lift__Suc__mono__less,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [F2: ( nat > A ),N: nat,N3: nat] :
          ( ! [N2: nat] :
              ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less @ nat @ N @ N3 )
           => ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ N3 ) ) ) ) ) )).

% lift_Suc_mono_less
thf(fact_207_inflstsI,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( ~ ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% inflstsI
thf(fact_208_lapp__allT__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2435255213lllsts @ A @ A3 ) )
      = ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A3 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A3 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% lapp_allT_iff
thf(fact_209_alllsts__UNIV,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A )] :
      ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% alllsts_UNIV
thf(fact_210_LConsE,axiom,(
    ! [A: $tType,X5: A,Xs: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X5 @ Xs ) @ ( lList2435255213lllsts @ A @ A3 ) )
      = ( ( member @ A @ X5 @ A3 )
        & ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2435255213lllsts @ A @ A3 ) ) ) ) )).

% LConsE
thf(fact_211_take__fin,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A3: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ A3 ) ) ) )).

% take_fin
thf(fact_212_poslsts__iff,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21148268032oslsts @ A @ A3 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A3 ) )
        & ( S
         != ( coinductive_LNil @ A ) ) ) ) )).

% poslsts_iff
thf(fact_213_alllsts_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( coinductive_llist @ A ) > $o ),X5: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( X4 @ X5 )
     => ( ! [X2: ( coinductive_llist @ A )] :
            ( ( X4 @ X2 )
           => ( ( X2
                = ( coinductive_LNil @ A ) )
              | ? [L3: ( coinductive_llist @ A ),A5: A] :
                  ( ( X2
                    = ( coinductive_LCons @ A @ A5 @ L3 ) )
                  & ( ( X4 @ L3 )
                    | ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2435255213lllsts @ A @ A3 ) ) )
                  & ( member @ A @ A5 @ A3 ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ A3 ) ) ) ) )).

% alllsts.coinduct
thf(fact_214_alllsts_Osimps,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A2 @ ( lList2435255213lllsts @ A @ A3 ) )
      = ( ( A2
          = ( coinductive_LNil @ A ) )
        | ? [L4: ( coinductive_llist @ A ),A7: A] :
            ( ( A2
              = ( coinductive_LCons @ A @ A7 @ L4 ) )
            & ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2435255213lllsts @ A @ A3 ) )
            & ( member @ A @ A7 @ A3 ) ) ) ) )).

% alllsts.simps
thf(fact_215_alllsts_Ocases,axiom,(
    ! [A: $tType,A2: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A2 @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( ( A2
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L2: ( coinductive_llist @ A ),A4: A] :
                ( ( A2
                  = ( coinductive_LCons @ A @ A4 @ L2 ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2435255213lllsts @ A @ A3 ) )
                 => ~ ( member @ A @ A4 @ A3 ) ) ) ) ) ) )).

% alllsts.cases
thf(fact_216_ldropT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A3: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2435255213lllsts @ A @ A3 ) ) ) )).

% ldropT
thf(fact_217_alllsts_OLCons__all,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A3: ( set @ A ),A2: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( ( member @ A @ A2 @ A3 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A2 @ L ) @ ( lList2435255213lllsts @ A @ A3 ) ) ) ) )).

% alllsts.LCons_all
thf(fact_218_alllsts_OLNil__all,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2435255213lllsts @ A @ A3 ) ) )).

% alllsts.LNil_all
thf(fact_219_lappT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A3: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList2435255213lllsts @ A @ A3 ) ) ) ) )).

% lappT
thf(fact_220_lapp__all__invT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2435255213lllsts @ A @ A3 ) ) ) )).

% lapp_all_invT
thf(fact_221_finite__lemma,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ B5 ) )
       => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ B5 ) ) ) ) )).

% finite_lemma
thf(fact_222_finsubsetall,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ A3 ) ) ) )).

% finsubsetall
thf(fact_223_infsubsetall,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList21612149805nflsts @ A @ A3 ) )
     => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ A3 ) ) ) )).

% infsubsetall
thf(fact_224_alllstsE,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ A3 ) )
     => ( ~ ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ A3 ) )
       => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList21612149805nflsts @ A @ A3 ) ) ) ) )).

% alllstsE
thf(fact_225_inflstsE,axiom,(
    ! [A: $tType,X5: ( coinductive_llist @ A ),A3: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList21612149805nflsts @ A @ A3 ) )
     => ~ ( ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2435255213lllsts @ A @ A3 ) )
         => ( member @ ( coinductive_llist @ A ) @ X5 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% inflstsE
thf(fact_226_inflsts__def,axiom,(
    ! [A: $tType] :
      ( ( lList21612149805nflsts @ A )
      = ( ^ [A6: ( set @ A )] :
            ( minus_minus @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2435255213lllsts @ A @ A6 ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% inflsts_def
thf(fact_227_fin__Un__inf,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2236698231inlsts @ A @ A3 ) @ ( lList21612149805nflsts @ A @ A3 ) )
      = ( lList2435255213lllsts @ A @ A3 ) ) )).

% fin_Un_inf
thf(fact_228_Un__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
      = ( ( member @ A @ C2 @ A3 )
        | ( member @ A @ C2 @ B5 ) ) ) )).

% Un_iff
thf(fact_229_UnCI,axiom,(
    ! [A: $tType,C2: A,B5: ( set @ A ),A3: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B5 )
       => ( member @ A @ C2 @ A3 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) ) )).

% UnCI
thf(fact_230_Diff__idemp,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) @ B5 )
      = ( minus_minus @ ( set @ A ) @ A3 @ B5 ) ) )).

% Diff_idemp
thf(fact_231_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) )
      = ( ( member @ A @ C2 @ A3 )
        & ~ ( member @ A @ C2 @ B5 ) ) ) )).

% Diff_iff
thf(fact_232_DiffI,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( ~ ( member @ A @ C2 @ B5 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) ) ) ) )).

% DiffI
thf(fact_233_Un__Diff__cancel2,axiom,(
    ! [A: $tType,B5: ( set @ A ),A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) @ A3 )
      = ( sup_sup @ ( set @ A ) @ B5 @ A3 ) ) )).

% Un_Diff_cancel2
thf(fact_234_Un__Diff__cancel,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) )).

% Un_Diff_cancel
thf(fact_235_Un__UNIV__right,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_236_Un__UNIV__left,axiom,(
    ! [A: $tType,B5: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B5 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_237_Un__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B5 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B5 @ ( sup_sup @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_238_Un__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) )).

% Un_left_absorb
thf(fact_239_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A6: ( set @ A ),B6: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B6 @ A6 ) ) ) )).

% Un_commute
thf(fact_240_Un__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Un_absorb
thf(fact_241_Un__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B5 @ C3 ) ) ) )).

% Un_assoc
thf(fact_242_ball__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( P @ X3 ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ B5 )
           => ( P @ X3 ) ) ) ) )).

% ball_Un
thf(fact_243_Un__Diff,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A ),C3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ C3 ) @ ( minus_minus @ ( set @ A ) @ B5 @ C3 ) ) ) )).

% Un_Diff
thf(fact_244_bex__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ A3 )
            & ( P @ X3 ) )
        | ? [X3: A] :
            ( ( member @ A @ X3 @ B5 )
            & ( P @ X3 ) ) ) ) )).

% bex_Un
thf(fact_245_DiffD2,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) )
     => ~ ( member @ A @ C2 @ B5 ) ) )).

% DiffD2
thf(fact_246_DiffD1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) )
     => ( member @ A @ C2 @ A3 ) ) )).

% DiffD1
thf(fact_247_DiffE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A3 @ B5 ) )
     => ~ ( ( member @ A @ C2 @ A3 )
         => ( member @ A @ C2 @ B5 ) ) ) )).

% DiffE
thf(fact_248_UnI2,axiom,(
    ! [A: $tType,C2: A,B5: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ C2 @ B5 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) ) )).

% UnI2
thf(fact_249_UnI1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) ) ) )).

% UnI1
thf(fact_250_UnE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B5 ) )
     => ( ~ ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B5 ) ) ) )).

% UnE
thf(fact_251_psubset__imp__ex__mem,axiom,(
    ! [A: $tType,A3: ( set @ A ),B5: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B5 )
     => ? [B3: A] :
          ( member @ A @ B3 @ ( minus_minus @ ( set @ A ) @ B5 @ A3 ) ) ) )).

% psubset_imp_ex_mem
thf(fact_252_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X5: A] :
          ( ( sup_sup @ A @ X5 @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_253_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X5: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X5 )
          = ( top_top @ A ) ) ) )).

% sup_top_left

%----Type constructors (31)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice_top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_top @ A9 @ ( type2 @ A9 ) )
     => ( order_top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( top @ A9 @ ( type2 @ A9 ) )
     => ( top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_3,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Ono__top,axiom,
    ( no_top @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_4,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_5,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_6,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_7,axiom,(
    ! [A8: $tType] :
      ( order_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_8,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_9,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_10,axiom,(
    ! [A8: $tType] :
      ( top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_11,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_12,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_13,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_14,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_15,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_16,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_17,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_18,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_Coinductive__List_Ollist___Orderings_Opreorder_19,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( coinductive_llist @ A8 ) @ ( type2 @ ( coinductive_llist @ A8 ) ) ) )).

thf(tcon_Coinductive__List_Ollist___Orderings_Oorder_20,axiom,(
    ! [A8: $tType] :
      ( order @ ( coinductive_llist @ A8 ) @ ( type2 @ ( coinductive_llist @ A8 ) ) ) )).

thf(tcon_Coinductive__List_Ollist___Orderings_Oord_21,axiom,(
    ! [A8: $tType] :
      ( ord @ ( coinductive_llist @ A8 ) @ ( type2 @ ( coinductive_llist @ A8 ) ) ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ~ ( ord_less @ ( coinductive_llist @ a ) @ r @ ( coinductive_LNil @ a ) ) )).

%------------------------------------------------------------------------------
