%------------------------------------------------------------------------------
% File     : DAT188^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Lazy lists II 1288
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Fri04] Friedrich (2004), Lazy Lists II
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : llist2__1288.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  372 (   1 unit;  68 type;   0 defn)
%            Number of atoms       : 4815 ( 221 equality;2791 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 4634 (  76   ~;  14   |;  52   &;4137   @)
%                                         (   0 <=>; 355  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  156 ( 156   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   70 (  68   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1043 (   1 sgn; 914   !;  31   ?;  39   ^)
%                                         (1043   :;  59  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:52:31.804
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (63)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ominus,type,(
    minus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__top,type,(
    order_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,(
    cancel146912293up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLNil,type,(
    coinductive_LNil: 
      !>[A: $tType] :
        ( coinductive_llist @ A ) )).

thf(sy_c_Coinductive__List_Olstrict__prefix,type,(
    coindu1478340336prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oalllsts,type,(
    lList2435255213lllsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts,type,(
    lList2236698231inlsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinlsts__rec,type,(
    lList21916056377ts_rec: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofinpref,type,(
    lList21202317876inpref: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ofpslsts,type,(
    lList22096119349pslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oinfliveness,type,(
    lList21015763786veness: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oinflsts,type,(
    lList21612149805nflsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oinfsafety,type,(
    lList21015939545safety: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oinfsuff,type,(
    lList2649413865nfsuff: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Olbutlast,type,(
    lList2370560421utlast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oldrop,type,(
    lList2508575361_ldrop: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oliveness,type,(
    lList21805353693veness: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ollast,type,(
    lList2170638824_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Ollength,type,(
    lList21232602520length: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Olrev,type,(
    lList2281150353e_lrev: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oltake,type,(
    lList22119844313_ltake: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > nat > ( coinductive_llist @ A ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Opfinpref,type,(
    lList2467029176inpref: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oposliveness,type,(
    lList21952340509veness: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oposlsts,type,(
    lList21148268032oslsts: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Opossafety,type,(
    lList292406316safety: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Opprefix__closed,type,(
    lList21974196564closed: 
      !>[A: $tType] :
        ( ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Oprefix__closed,type,(
    lList21638733016closed: 
      !>[A: $tType] :
        ( ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Osafety,type,(
    lList21350011628safety: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( coinductive_llist @ A ) ) > $o ) )).

thf(sy_c_LList2__Mirabelle__hamjzmohle_Osuff,type,(
    lList21475143548e_suff: 
      !>[A: $tType] :
        ( ( set @ A ) > ( coinductive_llist @ A ) > ( set @ ( coinductive_llist @ A ) ) ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_A,type,(
    a2: ( set @ a ) )).

thf(sy_v_P,type,(
    p: ( set @ ( coinductive_llist @ a ) ) )).

thf(sy_v_R,type,(
    r: $o )).

thf(sy_v_s,type,(
    s: ( coinductive_llist @ a ) )).

%----Relevant facts (256)
thf(fact_0_lappT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% lappT
thf(fact_1_poslivenessI,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) )] :
      ( ! [S2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList22096119349pslsts @ A @ A2 ) )
         => ? [X: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
              & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S2 @ X ) @ P ) ) )
     => ( lList21952340509veness @ A @ A2 @ P ) ) )).

% poslivenessI
thf(fact_2_lapp__all__invT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% lapp_all_invT
thf(fact_3_posliveness__def,axiom,(
    ! [A: $tType] :
      ( ( lList21952340509veness @ A )
      = ( ^ [A3: ( set @ A ),P2: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList22096119349pslsts @ A @ A3 ) )
           => ? [Y: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList2435255213lllsts @ A @ A3 ) )
                & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ X2 @ Y ) @ P2 ) ) ) ) ) )).

% posliveness_def
thf(fact_4_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_5_suff__all,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21475143548e_suff @ A @ A2 @ S ) )
     => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% suff_all
thf(fact_6_safetyD,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) ),T: ( coinductive_llist @ A )] :
      ( ( lList21350011628safety @ A @ A2 @ P )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
       => ( ! [R2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList21202317876inpref @ A @ A2 @ T ) )
             => ? [X: ( coinductive_llist @ A )] :
                  ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
                  & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R2 @ X ) @ P ) ) )
         => ( member @ ( coinductive_llist @ A ) @ T @ P ) ) ) ) )).

% safetyD
thf(fact_7_safetyE,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) )] :
      ( ( lList21350011628safety @ A @ A2 @ P )
     => ! [X: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
         => ( ! [Xa: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ Xa @ ( lList21202317876inpref @ A @ A2 @ X ) )
               => ? [Xb: ( coinductive_llist @ A )] :
                    ( ( member @ ( coinductive_llist @ A ) @ Xb @ ( lList2435255213lllsts @ A @ A2 ) )
                    & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Xa @ Xb ) @ P ) ) )
           => ( member @ ( coinductive_llist @ A ) @ X @ P ) ) ) ) )).

% safetyE
thf(fact_8_safetyI,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) )] :
      ( ! [T2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ T2 @ ( lList2435255213lllsts @ A @ A2 ) )
         => ( ! [X: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList21202317876inpref @ A @ A2 @ T2 ) )
               => ? [Xa: ( coinductive_llist @ A )] :
                    ( ( member @ ( coinductive_llist @ A ) @ Xa @ ( lList2435255213lllsts @ A @ A2 ) )
                    & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ X @ Xa ) @ P ) ) )
           => ( member @ ( coinductive_llist @ A ) @ T2 @ P ) ) )
     => ( lList21350011628safety @ A @ A2 @ P ) ) )).

% safetyI
thf(fact_9_safety__def,axiom,(
    ! [A: $tType] :
      ( ( lList21350011628safety @ A )
      = ( ^ [A3: ( set @ A ),P2: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2435255213lllsts @ A @ A3 ) )
           => ( ! [Y: ( coinductive_llist @ A )] :
                  ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList21202317876inpref @ A @ A3 @ X2 ) )
                 => ? [Z: ( coinductive_llist @ A )] :
                      ( ( member @ ( coinductive_llist @ A ) @ Z @ ( lList2435255213lllsts @ A @ A3 ) )
                      & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Y @ Z ) @ P2 ) ) )
             => ( member @ ( coinductive_llist @ A ) @ X2 @ P2 ) ) ) ) ) )).

% safety_def
thf(fact_10_ldropT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% ldropT
thf(fact_11_alllsts__UNIV,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A )] :
      ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% alllsts_UNIV
thf(fact_12_lapp__inf,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( ( coinductive_lappend @ A @ S @ T )
        = S ) ) )).

% lapp_inf
thf(fact_13_livenessE,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) ),S: ( coinductive_llist @ A )] :
      ( ( lList21805353693veness @ A @ A2 @ P )
     => ( ! [T2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ T2 @ ( lList2435255213lllsts @ A @ A2 ) )
           => ~ ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T2 ) @ P ) )
       => ~ ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% livenessE
thf(fact_14_livenessI,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) )] :
      ( ! [S2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList2236698231inlsts @ A @ A2 ) )
         => ? [X: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
              & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S2 @ X ) @ P ) ) )
     => ( lList21805353693veness @ A @ A2 @ P ) ) )).

% livenessI
thf(fact_15_liveness__def,axiom,(
    ! [A: $tType] :
      ( ( lList21805353693veness @ A )
      = ( ^ [A3: ( set @ A ),P2: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ A3 ) )
           => ? [Y: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList2435255213lllsts @ A @ A3 ) )
                & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ X2 @ Y ) @ P2 ) ) ) ) ) )).

% liveness_def
thf(fact_16_lapp__fin__fin__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2236698231inlsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
        & ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% lapp_fin_fin_iff
thf(fact_17_same__lappend__eq,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( ( coinductive_lappend @ A @ R @ S )
          = ( coinductive_lappend @ A @ R @ T ) )
        = ( S = T ) ) ) )).

% same_lappend_eq
thf(fact_18_notfin__inf,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A )] :
      ( ( ~ ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% notfin_inf
thf(fact_19_notinf__fin,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A )] :
      ( ( ~ ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% notinf_fin
thf(fact_20_ldrop__fin__iffT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% ldrop_fin_iffT
thf(fact_21_ldrop__inf__iffT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% ldrop_inf_iffT
thf(fact_22_inflstsI,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ~ ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% inflstsI
thf(fact_23_inflstsE,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ A2 ) )
     => ~ ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) )
         => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% inflstsE
thf(fact_24_finT__simp,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% finT_simp
thf(fact_25_infT__simp,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% infT_simp
thf(fact_26_fin__finite,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_finite
thf(fact_27_ldrop__finT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% ldrop_finT
thf(fact_28_ldrop__infT,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2508575361_ldrop @ A @ T @ I ) @ ( lList21612149805nflsts @ A @ A2 ) ) ) )).

% ldrop_infT
thf(fact_29_finpref__fin,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21202317876inpref @ A @ A2 @ S ) )
     => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% finpref_fin
thf(fact_30_suff__finpref,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),R: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21475143548e_suff @ A @ A2 @ R ) )
     => ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21202317876inpref @ A @ A2 @ T ) ) ) ) )).

% suff_finpref
thf(fact_31_fin__inf__cases,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A )] :
      ( ~ ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) )).

% fin_inf_cases
thf(fact_32_suff__finpref__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
       => ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList21202317876inpref @ A @ A2 @ T ) )
          = ( member @ ( coinductive_llist @ A ) @ T @ ( lList21475143548e_suff @ A @ A2 @ R ) ) ) ) ) )).

% suff_finpref_iff
thf(fact_33_lapp__fin__infT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_fin_infT
thf(fact_34_lapp__inv2T,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_inv2T
thf(fact_35_lapp__infT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A2 ) )
      = ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_infT
thf(fact_36_app__invT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% app_invT
thf(fact_37_alllstsE,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ~ ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% alllstsE
thf(fact_38_finpref__suff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList21202317876inpref @ A @ A2 @ T ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ T @ ( lList21475143548e_suff @ A @ A2 @ R ) ) ) ) )).

% finpref_suff
thf(fact_39_lapp__allT__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
          & ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A2 ) ) )
        | ( member @ ( coinductive_llist @ A ) @ R @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% lapp_allT_iff
thf(fact_40_lapp__fin__fin__lemma,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R @ S ) @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% lapp_fin_fin_lemma
thf(fact_41_lappfin__finT,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ S @ T ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% lappfin_finT
thf(fact_42_finsubsetall,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% finsubsetall
thf(fact_43_finite__lemma,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ B2 ) )
       => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ B2 ) ) ) ) )).

% finite_lemma
thf(fact_44_suff__appE,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21475143548e_suff @ A @ A2 @ R ) )
       => ~ ( ! [S2: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList2435255213lllsts @ A @ A2 ) )
               => ( T
                 != ( coinductive_lappend @ A @ R @ S2 ) ) ) ) ) ) )).

% suff_appE
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P: ( A > $o )] :
      ( ( member @ A @ A4 @ ( collect @ A @ P ) )
      = ( P @ A4 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_infsubsetall,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) ) ) )).

% infsubsetall
thf(fact_50_infsafety__def,axiom,(
    ! [A: $tType] :
      ( ( lList21015939545safety @ A )
      = ( ^ [A3: ( set @ A ),P2: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList21612149805nflsts @ A @ A3 ) )
           => ( ! [Y: ( coinductive_llist @ A )] :
                  ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList21202317876inpref @ A @ A3 @ X2 ) )
                 => ? [Z: ( coinductive_llist @ A )] :
                      ( ( member @ ( coinductive_llist @ A ) @ Z @ ( lList21612149805nflsts @ A @ A3 ) )
                      & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Y @ Z ) @ P2 ) ) )
             => ( member @ ( coinductive_llist @ A ) @ X2 @ P2 ) ) ) ) ) )).

% infsafety_def
thf(fact_51_infliveness__def,axiom,(
    ! [A: $tType] :
      ( ( lList21015763786veness @ A )
      = ( ^ [A3: ( set @ A ),P2: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList2236698231inlsts @ A @ A3 ) )
           => ? [Y: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList21612149805nflsts @ A @ A3 ) )
                & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ X2 @ Y ) @ P2 ) ) ) ) ) )).

% infliveness_def
thf(fact_52_safety__prefix__closed,axiom,(
    ! [A: $tType,P: ( set @ ( coinductive_llist @ A ) )] :
      ( ( lList21350011628safety @ A @ ( top_top @ ( set @ A ) ) @ P )
     => ( lList21638733016closed @ A @ P ) ) )).

% safety_prefix_closed
thf(fact_53_infsuff__finpref__iff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21202317876inpref @ A @ A2 @ R ) )
          = ( member @ ( coinductive_llist @ A ) @ R @ ( lList2649413865nfsuff @ A @ A2 @ T ) ) ) ) ) )).

% infsuff_finpref_iff
thf(fact_54_UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_55_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X3: A] :
      ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_56_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X2: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_57_lrev__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Ys @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( lList2281150353e_lrev @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coinductive_lappend @ A @ ( lList2281150353e_lrev @ A @ Ys ) @ ( lList2281150353e_lrev @ A @ Xs ) ) ) ) ) )).

% lrev_lappend
thf(fact_58_infsuff__appE,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2649413865nfsuff @ A @ A2 @ R ) )
       => ~ ( ! [S2: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ S2 @ ( lList21612149805nflsts @ A @ A2 ) )
               => ( T
                 != ( coinductive_lappend @ A @ R @ S2 ) ) ) ) ) ) )).

% infsuff_appE
thf(fact_59_lapp__suff__llength,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2508575361_ldrop @ A @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21232602520length @ A @ R ) )
        = S ) ) )).

% lapp_suff_llength
thf(fact_60_lrevT,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList2281150353e_lrev @ A @ Xs ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% lrevT
thf(fact_61_lrev__is__lrev__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Ys @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( ( lList2281150353e_lrev @ A @ Xs )
            = ( lList2281150353e_lrev @ A @ Ys ) )
          = ( Xs = Ys ) ) ) ) )).

% lrev_is_lrev_conv
thf(fact_62_lrev__lrev__ident,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( lList2281150353e_lrev @ A @ ( lList2281150353e_lrev @ A @ Xs ) )
        = Xs ) ) )).

% lrev_lrev_ident
thf(fact_63_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_64_infsuff__inf,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2649413865nfsuff @ A @ A2 @ S ) )
     => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21612149805nflsts @ A @ A2 ) ) ) )).

% infsuff_inf
thf(fact_65_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X4: A] :
      ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_66_UNIV__eq__I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X4: A] :
          ( member @ A @ X4 @ A2 )
     => ( ( top_top @ ( set @ A ) )
        = A2 ) ) )).

% UNIV_eq_I
thf(fact_67_infsuff__finpref,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),R: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2649413865nfsuff @ A @ A2 @ R ) )
     => ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ R @ ( lList21202317876inpref @ A @ A2 @ T ) ) ) ) )).

% infsuff_finpref
thf(fact_68_finpref__infsuff,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList21202317876inpref @ A @ A2 @ T ) )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ T @ ( lList2649413865nfsuff @ A @ A2 @ R ) ) ) ) )).

% finpref_infsuff
thf(fact_69_ltake__lappend__llength,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList22119844313_ltake @ A @ ( coinductive_lappend @ A @ R @ S ) @ ( lList21232602520length @ A @ R ) )
        = R ) ) )).

% ltake_lappend_llength
thf(fact_70_llength__take,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
     => ( ( lList21232602520length @ A @ ( lList22119844313_ltake @ A @ T @ I ) )
        = I ) ) )).

% llength_take
thf(fact_71_take__fin,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( member @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ T @ I ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) )).

% take_fin
thf(fact_72_ltake__fin,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),I: nat] :
      ( member @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ R @ I ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) )).

% ltake_fin
thf(fact_73_inflsts__def,axiom,(
    ! [A: $tType] :
      ( ( lList21612149805nflsts @ A )
      = ( ^ [A3: ( set @ A )] :
            ( minus_minus @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2435255213lllsts @ A @ A3 ) @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% inflsts_def
thf(fact_74_lrev__is__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( ( lList2281150353e_lrev @ A @ Xs )
          = ( coinductive_LNil @ A ) )
        = ( Xs
          = ( coinductive_LNil @ A ) ) ) ) )).

% lrev_is_LNil_conv
thf(fact_75_LNil__is__lrev__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( ( coinductive_LNil @ A )
          = ( lList2281150353e_lrev @ A @ Xs ) )
        = ( Xs
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_is_lrev_conv
thf(fact_76_Diff__idemp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ B2 ) @ B2 )
      = ( minus_minus @ ( set @ A ) @ A2 @ B2 ) ) )).

% Diff_idemp
thf(fact_77_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B2 ) )
      = ( ( member @ A @ C2 @ A2 )
        & ~ ( member @ A @ C2 @ B2 ) ) ) )).

% Diff_iff
thf(fact_78_DiffI,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( ~ ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B2 ) ) ) ) )).

% DiffI
thf(fact_79_top1I,axiom,(
    ! [A: $tType,X3: A] :
      ( top_top @ ( A > $o ) @ X3 ) )).

% top1I
thf(fact_80_lappend__eq__LNil__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ Xs @ Ys )
        = ( coinductive_LNil @ A ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_eq_LNil_iff
thf(fact_81_LNil__eq__lappend__iff,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        & ( Ys
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_eq_lappend_iff
thf(fact_82_lappend__LNil2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ Xs @ ( coinductive_LNil @ A ) )
      = Xs ) )).

% lappend_LNil2
thf(fact_83_lappend__code_I1_J,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ Ys )
      = Ys ) )).

% lappend_code(1)
thf(fact_84_lappend__is__LNil__conv,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lappend @ A @ S @ T )
        = ( coinductive_LNil @ A ) )
      = ( ( S
          = ( coinductive_LNil @ A ) )
        & ( T
          = ( coinductive_LNil @ A ) ) ) ) )).

% lappend_is_LNil_conv
thf(fact_85_LNil__is__lappend__conv,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),T: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LNil @ A )
        = ( coinductive_lappend @ A @ S @ T ) )
      = ( ( S
          = ( coinductive_LNil @ A ) )
        & ( T
          = ( coinductive_LNil @ A ) ) ) ) )).

% LNil_is_lappend_conv
thf(fact_86_LList2__Mirabelle__hamjzmohle_Oldrop__LNil,axiom,(
    ! [A: $tType,I: nat] :
      ( ( lList2508575361_ldrop @ A @ ( coinductive_LNil @ A ) @ I )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ldrop_LNil
thf(fact_87_LList2__Mirabelle__hamjzmohle_Oltake__LNil,axiom,(
    ! [A: $tType,I: nat] :
      ( ( lList22119844313_ltake @ A @ ( coinductive_LNil @ A ) @ I )
      = ( coinductive_LNil @ A ) ) )).

% LList2_Mirabelle_hamjzmohle.ltake_LNil
thf(fact_88_lrev__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList2281150353e_lrev @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lrev_LNil
thf(fact_89_LNil__suff,axiom,(
    ! [A: $tType,A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList21475143548e_suff @ A @ A2 @ S ) )
      = ( S
        = ( coinductive_LNil @ A ) ) ) )).

% LNil_suff
thf(fact_90_fpslsts__iff,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList22096119349pslsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
        & ( S
         != ( coinductive_LNil @ A ) ) ) ) )).

% fpslsts_iff
thf(fact_91_suff__LNil,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( lList21475143548e_suff @ A @ A2 @ ( coinductive_LNil @ A ) )
      = ( lList2435255213lllsts @ A @ A2 ) ) )).

% suff_LNil
thf(fact_92_infsuff__LNil,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( lList2649413865nfsuff @ A @ A2 @ ( coinductive_LNil @ A ) )
      = ( lList21612149805nflsts @ A @ A2 ) ) )).

% infsuff_LNil
thf(fact_93_DiffD2,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B2 ) )
     => ~ ( member @ A @ C2 @ B2 ) ) )).

% DiffD2
thf(fact_94_DiffD1,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B2 ) )
     => ( member @ A @ C2 @ A2 ) ) )).

% DiffD1
thf(fact_95_DiffE,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A2 @ B2 ) )
     => ~ ( ( member @ A @ C2 @ A2 )
         => ( member @ A @ C2 @ B2 ) ) ) )).

% DiffE
thf(fact_96_lappend__LNil__LNil,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lappend @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lappend_LNil_LNil
thf(fact_97_finlsts_OLNil__fin,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2236698231inlsts @ A @ A2 ) ) )).

% finlsts.LNil_fin
thf(fact_98_alllsts_OLNil__all,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( member @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( lList2435255213lllsts @ A @ A2 ) ) )).

% alllsts.LNil_all
thf(fact_99_drop__nonLNil,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( ( lList2508575361_ldrop @ A @ T @ I )
       != ( coinductive_LNil @ A ) )
     => ( T
       != ( coinductive_LNil @ A ) ) ) )).

% drop_nonLNil
thf(fact_100_llength__drop__take,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( ( lList2508575361_ldrop @ A @ T @ I )
       != ( coinductive_LNil @ A ) )
     => ( ( lList21232602520length @ A @ ( lList22119844313_ltake @ A @ T @ I ) )
        = I ) ) )).

% llength_drop_take
thf(fact_101_ltake__ldrop__id,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),I: nat] :
      ( ( coinductive_lappend @ A @ ( lList22119844313_ltake @ A @ X3 @ I ) @ ( lList2508575361_ldrop @ A @ X3 @ I ) )
      = X3 ) )).

% ltake_ldrop_id
thf(fact_102_pfinpref__iff,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2467029176inpref @ A @ A2 @ S ) )
      = ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList21202317876inpref @ A @ A2 @ S ) )
        & ( X3
         != ( coinductive_LNil @ A ) ) ) ) )).

% pfinpref_iff
thf(fact_103_minus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A3: ( A > B ),B3: ( A > B ),X2: A] :
              ( minus_minus @ B @ ( A3 @ X2 ) @ ( B3 @ X2 ) ) ) ) ) )).

% minus_apply
thf(fact_104_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X2: A] :
            ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_105_poslsts__iff,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21148268032oslsts @ A @ A2 ) )
      = ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2435255213lllsts @ A @ A2 ) )
        & ( S
         != ( coinductive_LNil @ A ) ) ) ) )).

% poslsts_iff
thf(fact_106_poslsts__UNIV,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21148268032oslsts @ A @ ( top_top @ ( set @ A ) ) ) )
      = ( S
       != ( coinductive_LNil @ A ) ) ) )).

% poslsts_UNIV
thf(fact_107_lrev__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2281150353e_lrev @ A @ ( coinductive_LCons @ A @ A4 @ R ) )
        = ( coinductive_lappend @ A @ ( lList2281150353e_lrev @ A @ R ) @ ( coinductive_LCons @ A @ A4 @ ( coinductive_LNil @ A ) ) ) ) ) )).

% lrev_LCons
thf(fact_108_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X22 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% llist.inject
thf(fact_109_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa2: A,X3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa2 @ X3 ) @ Ys )
      = ( coinductive_LCons @ A @ Xa2 @ ( coinductive_lappend @ A @ X3 @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_110_LConsE,axiom,(
    ! [A: $tType,X3: A,Xs: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ X3 @ Xs ) @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( member @ A @ X3 @ A2 )
        & ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% LConsE
thf(fact_111_llist_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( coinductive_llist @ A )] :
      ( ( coinductive_LNil @ A )
     != ( coinductive_LCons @ A @ X21 @ X22 ) ) )).

% llist.distinct(1)
thf(fact_112_neq__LNil__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( Xs
       != ( coinductive_LNil @ A ) )
      = ( ? [X2: A,Xs2: ( coinductive_llist @ A )] :
            ( Xs
            = ( coinductive_LCons @ A @ X2 @ Xs2 ) ) ) ) )).

% neq_LNil_conv
thf(fact_113_llistE,axiom,(
    ! [A: $tType,Y2: ( coinductive_llist @ A )] :
      ( ( Y2
       != ( coinductive_LNil @ A ) )
     => ~ ( ! [X212: A,X222: ( coinductive_llist @ A )] :
              ( Y2
             != ( coinductive_LCons @ A @ X212 @ X222 ) ) ) ) )).

% llistE
thf(fact_114_finlsts_OLCons__fin,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A2: ( set @ A ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( member @ A @ A4 @ A2 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A4 @ L ) @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% finlsts.LCons_fin
thf(fact_115_alllsts_OLCons__all,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A2: ( set @ A ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( member @ A @ A4 @ A2 )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A4 @ L ) @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllsts.LCons_all
thf(fact_116_inflsts__cases,axiom,(
    ! [A: $tType,S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList21612149805nflsts @ A @ A2 ) )
     => ~ ( ! [A5: A,L2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList21612149805nflsts @ A @ A2 ) )
             => ( ( member @ A @ A5 @ A2 )
               => ( S
                 != ( coinductive_LCons @ A @ A5 @ L2 ) ) ) ) ) ) )).

% inflsts_cases
thf(fact_117_inflstsI2,axiom,(
    ! [A: $tType,A4: A,A2: ( set @ A ),T: ( coinductive_llist @ A )] :
      ( ( member @ A @ A4 @ A2 )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A4 @ T ) @ ( lList21612149805nflsts @ A @ A2 ) ) ) ) )).

% inflstsI2
thf(fact_118_lappend__snocL1__conv__LCons2,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y2 @ ( coinductive_LNil @ A ) ) ) @ Ys )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y2 @ Ys ) ) ) )).

% lappend_snocL1_conv_LCons2
thf(fact_119_finlsts_Ocases,axiom,(
    ! [A: $tType,A4: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A4 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( A4
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L2: ( coinductive_llist @ A ),A5: A] :
                ( ( A4
                  = ( coinductive_LCons @ A @ A5 @ L2 ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A2 ) )
                 => ~ ( member @ A @ A5 @ A2 ) ) ) ) ) ) )).

% finlsts.cases
thf(fact_120_finlsts_Osimps,axiom,(
    ! [A: $tType,A4: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A4 @ ( lList2236698231inlsts @ A @ A2 ) )
      = ( ( A4
          = ( coinductive_LNil @ A ) )
        | ? [L3: ( coinductive_llist @ A ),A6: A] :
            ( ( A4
              = ( coinductive_LCons @ A @ A6 @ L3 ) )
            & ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2236698231inlsts @ A @ A2 ) )
            & ( member @ A @ A6 @ A2 ) ) ) ) )).

% finlsts.simps
thf(fact_121_finlsts__induct,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ! [L2: ( coinductive_llist @ A )] :
            ( ( L2
              = ( coinductive_LNil @ A ) )
           => ( P @ L2 ) )
       => ( ! [A5: A,L2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ L2 )
               => ( ( member @ A @ A5 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A5 @ L2 ) ) ) ) )
         => ( P @ X3 ) ) ) ) )).

% finlsts_induct
thf(fact_122_finlsts_Oinducts,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [L2: ( coinductive_llist @ A ),A5: A] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ L2 )
               => ( ( member @ A @ A5 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A5 @ L2 ) ) ) ) )
         => ( P @ X3 ) ) ) ) )).

% finlsts.inducts
thf(fact_123_alllsts_Ocoinduct,axiom,(
    ! [A: $tType,X5: ( ( coinductive_llist @ A ) > $o ),X3: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( X5 @ X3 )
     => ( ! [X4: ( coinductive_llist @ A )] :
            ( ( X5 @ X4 )
           => ( ( X4
                = ( coinductive_LNil @ A ) )
              | ? [L4: ( coinductive_llist @ A ),A7: A] :
                  ( ( X4
                    = ( coinductive_LCons @ A @ A7 @ L4 ) )
                  & ( ( X5 @ L4 )
                    | ( member @ ( coinductive_llist @ A ) @ L4 @ ( lList2435255213lllsts @ A @ A2 ) ) )
                  & ( member @ A @ A7 @ A2 ) ) ) )
       => ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2435255213lllsts @ A @ A2 ) ) ) ) )).

% alllsts.coinduct
thf(fact_124_alllsts_Osimps,axiom,(
    ! [A: $tType,A4: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A4 @ ( lList2435255213lllsts @ A @ A2 ) )
      = ( ( A4
          = ( coinductive_LNil @ A ) )
        | ? [L3: ( coinductive_llist @ A ),A6: A] :
            ( ( A4
              = ( coinductive_LCons @ A @ A6 @ L3 ) )
            & ( member @ ( coinductive_llist @ A ) @ L3 @ ( lList2435255213lllsts @ A @ A2 ) )
            & ( member @ A @ A6 @ A2 ) ) ) ) )).

% alllsts.simps
thf(fact_125_alllsts_Ocases,axiom,(
    ! [A: $tType,A4: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ A4 @ ( lList2435255213lllsts @ A @ A2 ) )
     => ( ( A4
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [L2: ( coinductive_llist @ A ),A5: A] :
                ( ( A4
                  = ( coinductive_LCons @ A @ A5 @ L2 ) )
               => ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2435255213lllsts @ A @ A2 ) )
                 => ~ ( member @ A @ A5 @ A2 ) ) ) ) ) ) )).

% alllsts.cases
thf(fact_126_fps__induct,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList22096119349pslsts @ A @ A2 ) )
     => ( ! [A5: A] :
            ( ( member @ A @ A5 @ A2 )
           => ( P @ ( coinductive_LCons @ A @ A5 @ ( coinductive_LNil @ A ) ) ) )
       => ( ! [A5: A,L2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList22096119349pslsts @ A @ A2 ) )
             => ( ( P @ L2 )
               => ( ( member @ A @ A5 @ A2 )
                 => ( P @ ( coinductive_LCons @ A @ A5 @ L2 ) ) ) ) )
         => ( P @ L ) ) ) ) )).

% fps_induct
thf(fact_127_fpslsts__cases,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList22096119349pslsts @ A @ A2 ) )
     => ~ ( ! [A5: A,Rs: ( coinductive_llist @ A )] :
              ( ( R
                = ( coinductive_LCons @ A @ A5 @ Rs ) )
             => ( ( member @ A @ A5 @ A2 )
               => ~ ( member @ ( coinductive_llist @ A ) @ Rs @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) ) ) )).

% fpslsts_cases
thf(fact_128_finlsts__rev__cases,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( T
         != ( coinductive_LNil @ A ) )
       => ~ ( ! [A5: A,L2: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ L2 @ ( lList2236698231inlsts @ A @ A2 ) )
               => ( ( member @ A @ A5 @ A2 )
                 => ( T
                   != ( coinductive_lappend @ A @ L2 @ ( coinductive_LCons @ A @ A5 @ ( coinductive_LNil @ A ) ) ) ) ) ) ) ) ) )).

% finlsts_rev_cases
thf(fact_129_lrev__induct,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( P @ ( coinductive_LNil @ A ) )
       => ( ! [X4: A,Xs3: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ Xs3 @ ( lList2236698231inlsts @ A @ A2 ) )
             => ( ( P @ Xs3 )
               => ( ( member @ A @ X4 @ A2 )
                 => ( P @ ( coinductive_lappend @ A @ Xs3 @ ( coinductive_LCons @ A @ X4 @ ( coinductive_LNil @ A ) ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lrev_induct
thf(fact_130_fun__diff__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( minus @ B @ ( type2 @ B ) )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A3: ( A > B ),B3: ( A > B ),X2: A] :
              ( minus_minus @ B @ ( A3 @ X2 ) @ ( B3 @ X2 ) ) ) ) ) )).

% fun_diff_def
thf(fact_131_lbutlast__snoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A ),X3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2370560421utlast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) ) )
        = Xs ) ) )).

% lbutlast_snoc
thf(fact_132_possafetyD,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) ),T: ( coinductive_llist @ A )] :
      ( ( lList292406316safety @ A @ A2 @ P )
     => ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21148268032oslsts @ A @ A2 ) )
       => ( ! [R2: ( coinductive_llist @ A )] :
              ( ( member @ ( coinductive_llist @ A ) @ R2 @ ( lList2467029176inpref @ A @ A2 @ T ) )
             => ? [X: ( coinductive_llist @ A )] :
                  ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2435255213lllsts @ A @ A2 ) )
                  & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ R2 @ X ) @ P ) ) )
         => ( member @ ( coinductive_llist @ A ) @ T @ P ) ) ) ) )).

% possafetyD
thf(fact_133_possafetyE,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) )] :
      ( ( lList292406316safety @ A @ A2 @ P )
     => ! [X: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList21148268032oslsts @ A @ A2 ) )
         => ( ! [Xa: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ Xa @ ( lList2467029176inpref @ A @ A2 @ X ) )
               => ? [Xb: ( coinductive_llist @ A )] :
                    ( ( member @ ( coinductive_llist @ A ) @ Xb @ ( lList2435255213lllsts @ A @ A2 ) )
                    & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Xa @ Xb ) @ P ) ) )
           => ( member @ ( coinductive_llist @ A ) @ X @ P ) ) ) ) )).

% possafetyE
thf(fact_134_possafetyI,axiom,(
    ! [A: $tType,A2: ( set @ A ),P: ( set @ ( coinductive_llist @ A ) )] :
      ( ! [T2: ( coinductive_llist @ A )] :
          ( ( member @ ( coinductive_llist @ A ) @ T2 @ ( lList21148268032oslsts @ A @ A2 ) )
         => ( ! [X: ( coinductive_llist @ A )] :
                ( ( member @ ( coinductive_llist @ A ) @ X @ ( lList2467029176inpref @ A @ A2 @ T2 ) )
               => ? [Xa: ( coinductive_llist @ A )] :
                    ( ( member @ ( coinductive_llist @ A ) @ Xa @ ( lList2435255213lllsts @ A @ A2 ) )
                    & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ X @ Xa ) @ P ) ) )
           => ( member @ ( coinductive_llist @ A ) @ T2 @ P ) ) )
     => ( lList292406316safety @ A @ A2 @ P ) ) )).

% possafetyI
thf(fact_135_possafety__def,axiom,(
    ! [A: $tType] :
      ( ( lList292406316safety @ A )
      = ( ^ [A3: ( set @ A ),P2: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ ( lList21148268032oslsts @ A @ A3 ) )
           => ( ! [Y: ( coinductive_llist @ A )] :
                  ( ( member @ ( coinductive_llist @ A ) @ Y @ ( lList2467029176inpref @ A @ A3 @ X2 ) )
                 => ? [Z: ( coinductive_llist @ A )] :
                      ( ( member @ ( coinductive_llist @ A ) @ Z @ ( lList2435255213lllsts @ A @ A3 ) )
                      & ( member @ ( coinductive_llist @ A ) @ ( coinductive_lappend @ A @ Y @ Z ) @ P2 ) ) )
             => ( member @ ( coinductive_llist @ A ) @ X2 @ P2 ) ) ) ) ) )).

% possafety_def
thf(fact_136_lbutlast__LNil,axiom,(
    ! [A: $tType] :
      ( ( lList2370560421utlast @ A @ ( coinductive_LNil @ A ) )
      = ( coinductive_LNil @ A ) ) )).

% lbutlast_LNil
thf(fact_137_lbutlast__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( ( R
            = ( coinductive_LNil @ A ) )
         => ( ( lList2370560421utlast @ A @ ( coinductive_LCons @ A @ A4 @ R ) )
            = ( coinductive_LNil @ A ) ) )
        & ( ( R
           != ( coinductive_LNil @ A ) )
         => ( ( lList2370560421utlast @ A @ ( coinductive_LCons @ A @ A4 @ R ) )
            = ( coinductive_LCons @ A @ A4 @ ( lList2370560421utlast @ A @ R ) ) ) ) ) ) )).

% lbutlast_LCons
thf(fact_138_llast__snoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),A2: ( set @ A ),X3: A] :
      ( ( member @ ( coinductive_llist @ A ) @ Xs @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList2170638824_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) ) )
        = X3 ) ) )).

% llast_snoc
thf(fact_139_LList2__Mirabelle__hamjzmohle_Ollast__lappend,axiom,(
    ! [A: $tType,X3: ( coinductive_llist @ A ),Y2: ( coinductive_llist @ A ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ X3 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ ( coinductive_llist @ A ) @ Y2 @ ( lList2236698231inlsts @ A @ ( top_top @ ( set @ A ) ) ) )
       => ( ( lList2170638824_llast @ A @ ( coinductive_lappend @ A @ X3 @ ( coinductive_LCons @ A @ A4 @ Y2 ) ) )
          = ( lList2170638824_llast @ A @ ( coinductive_LCons @ A @ A4 @ Y2 ) ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_lappend
thf(fact_140_lbutlast__lapp__llast,axiom,(
    ! [A: $tType,L: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ L @ ( lList22096119349pslsts @ A @ A2 ) )
     => ( L
        = ( coinductive_lappend @ A @ ( lList2370560421utlast @ A @ L ) @ ( coinductive_LCons @ A @ ( lList2170638824_llast @ A @ L ) @ ( coinductive_LNil @ A ) ) ) ) ) )).

% lbutlast_lapp_llast
thf(fact_141_possafety__pprefix__closed,axiom,(
    ! [A: $tType,P: ( set @ ( coinductive_llist @ A ) )] :
      ( ( lList292406316safety @ A @ ( top_top @ ( set @ A ) ) @ P )
     => ( lList21974196564closed @ A @ P ) ) )).

% possafety_pprefix_closed
thf(fact_142_LList2__Mirabelle__hamjzmohle_Ollast__LCons,axiom,(
    ! [B: $tType,R: ( coinductive_llist @ B ),A2: ( set @ B ),A4: B] :
      ( ( member @ ( coinductive_llist @ B ) @ R @ ( lList2236698231inlsts @ B @ A2 ) )
     => ( ( ( R
            = ( coinductive_LNil @ B ) )
         => ( ( lList2170638824_llast @ B @ ( coinductive_LCons @ B @ A4 @ R ) )
            = A4 ) )
        & ( ( R
           != ( coinductive_LNil @ B ) )
         => ( ( lList2170638824_llast @ B @ ( coinductive_LCons @ B @ A4 @ R ) )
            = ( lList2170638824_llast @ B @ R ) ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llast_LCons
thf(fact_143_Coinductive__List_Ofinite__lprefix__nitpick__simps_I3_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ( Xs
          = ( coinductive_LNil @ A ) )
        | ? [Xs2: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ Y2 @ Xs2 ) )
            & ( coindu328551480prefix @ A @ Xs2 @ Ys ) ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(3)
thf(fact_144_top__conj_I1_J,axiom,(
    ! [A: $tType,X3: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X3 )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_145_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X3: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X3 ) )
      = P ) )).

% top_conj(2)
thf(fact_146_lstrict__prefix__code_I2_J,axiom,(
    ! [B: $tType,Y2: B,Ys: ( coinductive_llist @ B )] :
      ( coindu1478340336prefix @ B @ ( coinductive_LNil @ B ) @ ( coinductive_LCons @ B @ Y2 @ Ys ) ) )).

% lstrict_prefix_code(2)
thf(fact_147_lstrict__prefix__code_I4_J,axiom,(
    ! [B: $tType,X3: B,Xs: ( coinductive_llist @ B ),Y2: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X3 @ Xs ) @ ( coinductive_LCons @ B @ Y2 @ Ys ) )
      = ( ( X3 = Y2 )
        & ( coindu1478340336prefix @ B @ Xs @ Ys ) ) ) )).

% lstrict_prefix_code(4)
thf(fact_148_lstrict__prefix__code_I1_J,axiom,(
    ! [A: $tType] :
      ~ ( coindu1478340336prefix @ A @ ( coinductive_LNil @ A ) @ ( coinductive_LNil @ A ) ) )).

% lstrict_prefix_code(1)
thf(fact_149_lstrict__prefix__code_I3_J,axiom,(
    ! [B: $tType,X3: B,Xs: ( coinductive_llist @ B )] :
      ~ ( coindu1478340336prefix @ B @ ( coinductive_LCons @ B @ X3 @ Xs ) @ ( coinductive_LNil @ B ) ) )).

% lstrict_prefix_code(3)
thf(fact_150_llist__less__induct,axiom,(
    ! [A: $tType,P: ( ( coinductive_llist @ A ) > $o ),Xs: ( coinductive_llist @ A )] :
      ( ! [Xs3: ( coinductive_llist @ A )] :
          ( ! [Ys2: ( coinductive_llist @ A )] :
              ( ( coindu1478340336prefix @ A @ Ys2 @ Xs3 )
             => ( P @ Ys2 ) )
         => ( P @ Xs3 ) )
     => ( P @ Xs ) ) )).

% llist_less_induct
thf(fact_151_Coinductive__List_Ofinite__lprefix__nitpick__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coindu328551480prefix @ A @ Xs @ ( coinductive_LNil @ A ) )
      = ( Xs
        = ( coinductive_LNil @ A ) ) ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(1)
thf(fact_152_Coinductive__List_Ofinite__lprefix__nitpick__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coindu328551480prefix @ A @ ( coinductive_LNil @ A ) @ Xs ) )).

% Coinductive_List.finite_lprefix_nitpick_simps(2)
thf(fact_153_finlsts__rec__LCons__def,axiom,(
    ! [B: $tType,A: $tType,F: ( ( coinductive_llist @ A ) > B ),C2: B,D2: ( A > ( coinductive_llist @ A ) > B > B ),R: ( coinductive_llist @ A ),A2: ( set @ A ),A4: A] :
      ( ( F
        = ( lList21916056377ts_rec @ B @ A @ C2 @ D2 ) )
     => ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( ( F @ ( coinductive_LCons @ A @ A4 @ R ) )
          = ( D2 @ A4 @ R @ ( F @ R ) ) ) ) ) )).

% finlsts_rec_LCons_def
thf(fact_154_finlsts__rec__LCons,axiom,(
    ! [B: $tType,A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),C2: B,D2: ( A > ( coinductive_llist @ A ) > B > B ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList21916056377ts_rec @ B @ A @ C2 @ D2 @ ( coinductive_LCons @ A @ A4 @ R ) )
        = ( D2 @ A4 @ R @ ( lList21916056377ts_rec @ B @ A @ C2 @ D2 @ R ) ) ) ) )).

% finlsts_rec_LCons
thf(fact_155_LList2__Mirabelle__hamjzmohle_Ollength__LCons,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),A4: A] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( lList21232602520length @ A @ ( coinductive_LCons @ A @ A4 @ R ) )
        = ( suc @ ( lList21232602520length @ A @ R ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llength_LCons
thf(fact_156_finlsts__rec__LNil__def,axiom,(
    ! [A: $tType,B: $tType,F: ( ( coinductive_llist @ A ) > B ),C2: B,D2: ( A > ( coinductive_llist @ A ) > B > B )] :
      ( ( F
        = ( lList21916056377ts_rec @ B @ A @ C2 @ D2 ) )
     => ( ( F @ ( coinductive_LNil @ A ) )
        = C2 ) ) )).

% finlsts_rec_LNil_def
thf(fact_157_finlsts__rec__LNil,axiom,(
    ! [B: $tType,A: $tType,C2: A,D2: ( B > ( coinductive_llist @ B ) > A > A )] :
      ( ( lList21916056377ts_rec @ A @ B @ C2 @ D2 @ ( coinductive_LNil @ B ) )
      = C2 ) )).

% finlsts_rec_LNil
thf(fact_158_ltake__LCons__Suc,axiom,(
    ! [A: $tType,A4: A,L: ( coinductive_llist @ A ),I: nat] :
      ( ( lList22119844313_ltake @ A @ ( coinductive_LCons @ A @ A4 @ L ) @ ( suc @ I ) )
      = ( coinductive_LCons @ A @ A4 @ ( lList22119844313_ltake @ A @ L @ I ) ) ) )).

% ltake_LCons_Suc
thf(fact_159_llast__singleton,axiom,(
    ! [A: $tType,X3: A] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LNil @ A ) ) )
      = X3 ) )).

% llast_singleton
thf(fact_160_take__inf__less,axiom,(
    ! [A: $tType,T: ( coinductive_llist @ A ),I: nat] :
      ( ( member @ ( coinductive_llist @ A ) @ T @ ( lList21612149805nflsts @ A @ ( top_top @ ( set @ A ) ) ) )
     => ( ord_less @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ T @ I ) @ T ) ) )).

% take_inf_less
thf(fact_161_fin__Un__inf,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ ( coinductive_llist @ A ) ) @ ( lList2236698231inlsts @ A @ A2 ) @ ( lList21612149805nflsts @ A @ A2 ) )
      = ( lList2435255213lllsts @ A @ A2 ) ) )).

% fin_Un_inf
thf(fact_162_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A4 @ B4 ) @ B4 )
          = ( sup_sup @ A @ A4 @ B4 ) ) ) )).

% sup.right_idem
thf(fact_163_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ X3 @ Y2 ) )
          = ( sup_sup @ A @ X3 @ Y2 ) ) ) )).

% sup_left_idem
thf(fact_164_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( sup_sup @ A @ A4 @ ( sup_sup @ A @ A4 @ B4 ) )
          = ( sup_sup @ A @ A4 @ B4 ) ) ) )).

% sup.left_idem
thf(fact_165_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ X3 )
          = X3 ) ) )).

% sup_idem
thf(fact_166_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( sup_sup @ A @ A4 @ A4 )
          = A4 ) ) )).

% sup.idem
thf(fact_167_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% sup_apply
thf(fact_168_Un__iff,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
      = ( ( member @ A @ C2 @ A2 )
        | ( member @ A @ C2 @ B2 ) ) ) )).

% Un_iff
thf(fact_169_UnCI,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A2: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ A2 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% UnCI
thf(fact_170_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ( sup_sup @ A @ X3 @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_171_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X3 )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_172_Un__Diff__cancel,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( minus_minus @ ( set @ A ) @ B2 @ A2 ) )
      = ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) )).

% Un_Diff_cancel
thf(fact_173_Un__Diff__cancel2,axiom,(
    ! [A: $tType,B2: ( set @ A ),A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ B2 @ A2 ) @ A2 )
      = ( sup_sup @ ( set @ A ) @ B2 @ A2 ) ) )).

% Un_Diff_cancel2
thf(fact_174_llast__LCons2,axiom,(
    ! [A: $tType,X3: A,Y2: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X3 @ ( coinductive_LCons @ A @ Y2 @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y2 @ Xs ) ) ) )).

% llast_LCons2
thf(fact_175_less__LCons,axiom,(
    ! [A: $tType,A4: A,R: ( coinductive_llist @ A ),B4: A,T: ( coinductive_llist @ A )] :
      ( ( ord_less @ ( coinductive_llist @ A ) @ ( coinductive_LCons @ A @ A4 @ R ) @ ( coinductive_LCons @ A @ B4 @ T ) )
      = ( ( A4 = B4 )
        & ( ord_less @ ( coinductive_llist @ A ) @ R @ T ) ) ) )).

% less_LCons
thf(fact_176_llist__less__finT,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A ),A2: ( set @ A )] :
      ( ( ord_less @ ( coinductive_llist @ A ) @ R @ S )
     => ( ( member @ ( coinductive_llist @ A ) @ S @ ( lList2236698231inlsts @ A @ A2 ) )
       => ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) ) ) ) )).

% llist_less_finT
thf(fact_177_LNil__less__LCons,axiom,(
    ! [A: $tType,A4: A,T: ( coinductive_llist @ A )] :
      ( ord_less @ ( coinductive_llist @ A ) @ ( coinductive_LNil @ A ) @ ( coinductive_LCons @ A @ A4 @ T ) ) )).

% LNil_less_LCons
thf(fact_178_sup_Ostrict__coboundedI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,B4: A,A4: A] :
          ( ( ord_less @ A @ C2 @ B4 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A4 @ B4 ) ) ) ) )).

% sup.strict_coboundedI2
thf(fact_179_sup_Ostrict__coboundedI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,A4: A,B4: A] :
          ( ( ord_less @ A @ C2 @ A4 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A4 @ B4 ) ) ) ) )).

% sup.strict_coboundedI1
thf(fact_180_sup_Ostrict__order__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B5: A,A6: A] :
              ( ( A6
                = ( sup_sup @ A @ A6 @ B5 ) )
              & ( A6 != B5 ) ) ) ) ) )).

% sup.strict_order_iff
thf(fact_181_sup_Ostrict__boundedE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B4: A,C2: A,A4: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B4 @ C2 ) @ A4 )
         => ~ ( ( ord_less @ A @ B4 @ A4 )
             => ~ ( ord_less @ A @ C2 @ A4 ) ) ) ) )).

% sup.strict_boundedE
thf(fact_182_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A,Z2: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y2 @ Z2 ) )
          = ( sup_sup @ A @ Y2 @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) )).

% sup_left_commute
thf(fact_183_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C2: A] :
          ( ( sup_sup @ A @ B4 @ ( sup_sup @ A @ A4 @ C2 ) )
          = ( sup_sup @ A @ A4 @ ( sup_sup @ A @ B4 @ C2 ) ) ) ) )).

% sup.left_commute
thf(fact_184_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y: A] :
              ( sup_sup @ A @ Y @ X2 ) ) ) ) )).

% sup_commute
thf(fact_185_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A6: A,B5: A] :
              ( sup_sup @ A @ B5 @ A6 ) ) ) ) )).

% sup.commute
thf(fact_186_less__supI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X3: A,B4: A,A4: A] :
          ( ( ord_less @ A @ X3 @ B4 )
         => ( ord_less @ A @ X3 @ ( sup_sup @ A @ A4 @ B4 ) ) ) ) )).

% less_supI2
thf(fact_187_less__supI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X3: A,A4: A,B4: A] :
          ( ( ord_less @ A @ X3 @ A4 )
         => ( ord_less @ A @ X3 @ ( sup_sup @ A @ A4 @ B4 ) ) ) ) )).

% less_supI1
thf(fact_188_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X3 @ Y2 ) @ Z2 )
          = ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y2 @ Z2 ) ) ) ) )).

% sup_assoc
thf(fact_189_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A4 @ B4 ) @ C2 )
          = ( sup_sup @ A @ A4 @ ( sup_sup @ A @ B4 @ C2 ) ) ) ) )).

% sup.assoc
thf(fact_190_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X2: A] :
              ( sup_sup @ B @ ( F2 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% sup_fun_def
thf(fact_191_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y: A] :
              ( sup_sup @ A @ Y @ X2 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_192_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A,Z2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X3 @ Y2 ) @ Z2 )
          = ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y2 @ Z2 ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_193_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A,Z2: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ Y2 @ Z2 ) )
          = ( sup_sup @ A @ Y2 @ ( sup_sup @ A @ X3 @ Z2 ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_194_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( sup_sup @ A @ X3 @ ( sup_sup @ A @ X3 @ Y2 ) )
          = ( sup_sup @ A @ X3 @ Y2 ) ) ) )).

% inf_sup_aci(8)
thf(fact_195_Un__UNIV__right,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_196_Un__UNIV__left,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B2 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_197_top_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( A4
           != ( top_top @ A ) )
          = ( ord_less @ A @ A4 @ ( top_top @ A ) ) ) ) )).

% top.not_eq_extremum
thf(fact_198_top_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_top @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A4 ) ) )).

% top.extremum_strict
thf(fact_199_Un__Diff,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A2 @ C3 ) @ ( minus_minus @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_Diff
thf(fact_200_not__less__LNil,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A )] :
      ~ ( ord_less @ ( coinductive_llist @ A ) @ R @ ( coinductive_LNil @ A ) ) )).

% not_less_LNil
thf(fact_201_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( A4 != B4 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_202_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( A4 != B4 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_203_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X3 @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X3 )
            | ( X3 = Y2 ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_204_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( ( ord_less @ A @ C2 @ B4 )
           => ( ord_less @ A @ C2 @ A4 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_205_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X3 ) ) ) )).

% less_imp_not_less
thf(fact_206_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less @ A @ B4 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) )).

% order.strict_trans
thf(fact_207_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ~ ( ord_less @ A @ A4 @ A4 ) ) )).

% dual_order.irrefl
thf(fact_208_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ~ ( ord_less @ A @ X3 @ Y2 )
         => ( ( X3 != Y2 )
           => ( ord_less @ A @ Y2 @ X3 ) ) ) ) )).

% linorder_cases
thf(fact_209_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A,P: $o] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X3 )
           => P ) ) ) )).

% less_imp_triv
thf(fact_210_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ( Y2 != X3 ) ) ) )).

% less_imp_not_eq2
thf(fact_211_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X3: A] :
          ( ~ ( ord_less @ A @ Y2 @ X3 )
         => ( ( ~ ( ord_less @ A @ X3 @ Y2 ) )
            = ( X3 = Y2 ) ) ) ) )).

% antisym_conv3
thf(fact_212_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),A4: A] :
          ( ! [X4: A] :
              ( ! [Y3: A] :
                  ( ( ord_less @ A @ Y3 @ X4 )
                 => ( P @ Y3 ) )
             => ( P @ X4 ) )
         => ( P @ A4 ) ) ) )).

% less_induct
thf(fact_213_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X3 ) ) ) )).

% less_not_sym
thf(fact_214_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ( X3 != Y2 ) ) ) )).

% less_imp_not_eq
thf(fact_215_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ~ ( ord_less @ A @ A4 @ B4 ) ) ) )).

% dual_order.asym
thf(fact_216_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( B4 = C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) )).

% ord_less_eq_trans
thf(fact_217_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A] :
          ( ( A4 = B4 )
         => ( ( ord_less @ A @ B4 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) )).

% ord_eq_less_trans
thf(fact_218_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ~ ( ord_less @ A @ X3 @ X3 ) ) )).

% less_irrefl
thf(fact_219_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
          | ( X3 = Y2 )
          | ( ord_less @ A @ Y2 @ X3 ) ) ) )).

% less_linear
thf(fact_220_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A,Z2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z2 )
           => ( ord_less @ A @ X3 @ Z2 ) ) ) ) )).

% less_trans
thf(fact_221_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A4 ) ) ) )).

% less_asym'
thf(fact_222_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X3 ) ) ) )).

% less_asym
thf(fact_223_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ( X3 != Y2 ) ) ) )).

% less_imp_neq
thf(fact_224_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( ord_less @ A @ X3 @ Y2 )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X3 @ Z3 )
              & ( ord_less @ A @ Z3 @ Y2 ) ) ) ) )).

% dense
thf(fact_225_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ~ ( ord_less @ A @ B4 @ A4 ) ) ) )).

% order.asym
thf(fact_226_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( X3 != Y2 )
          = ( ( ord_less @ A @ X3 @ Y2 )
            | ( ord_less @ A @ Y2 @ X3 ) ) ) ) )).

% neq_iff
thf(fact_227_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X3: A,Y2: A] :
          ( ( X3 != Y2 )
         => ( ~ ( ord_less @ A @ X3 @ Y2 )
           => ( ord_less @ A @ Y2 @ X3 ) ) ) ) )).

% neqE
thf(fact_228_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X3: A] :
        ? [X1: A] :
          ( ord_less @ A @ X3 @ X1 ) ) )).

% gt_ex
thf(fact_229_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X3: A] :
        ? [Y4: A] :
          ( ord_less @ A @ Y4 @ X3 ) ) )).

% lt_ex
thf(fact_230_order__less__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > C ),C2: C] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less @ C @ ( F @ B4 ) @ C2 )
           => ( ! [X4: A,Y4: A] :
                  ( ( ord_less @ A @ X4 @ Y4 )
                 => ( ord_less @ C @ ( F @ X4 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ C @ ( F @ A4 ) @ C2 ) ) ) ) ) )).

% order_less_subst2
thf(fact_231_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C2: B] :
          ( ( ord_less @ A @ A4 @ ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C2 )
           => ( ! [X4: B,Y4: B] :
                  ( ( ord_less @ B @ X4 @ Y4 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A4 @ ( F @ C2 ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_232_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > B ),C2: B] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ( F @ B4 )
              = C2 )
           => ( ! [X4: A,Y4: A] :
                  ( ( ord_less @ A @ X4 @ Y4 )
                 => ( ord_less @ B @ ( F @ X4 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ B @ ( F @ A4 ) @ C2 ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_233_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C2: B] :
          ( ( A4
            = ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C2 )
           => ( ! [X4: B,Y4: B] :
                  ( ( ord_less @ B @ X4 @ Y4 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y4 ) ) )
             => ( ord_less @ A @ A4 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_234_Un__left__commute,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B2 @ ( sup_sup @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_235_Un__left__absorb,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) )).

% Un_left_absorb
thf(fact_236_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A3: ( set @ A ),B3: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B3 @ A3 ) ) ) )).

% Un_commute
thf(fact_237_Un__absorb,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A2 @ A2 )
      = A2 ) )).

% Un_absorb
thf(fact_238_Un__assoc,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A2 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_assoc
thf(fact_239_ball__Un,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
           => ( P @ X2 ) ) )
      = ( ! [X2: A] :
            ( ( member @ A @ X2 @ A2 )
           => ( P @ X2 ) )
        & ! [X2: A] :
            ( ( member @ A @ X2 @ B2 )
           => ( P @ X2 ) ) ) ) )).

% ball_Un
thf(fact_240_bex__Un,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
            & ( P @ X2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ A2 )
            & ( P @ X2 ) )
        | ? [X2: A] :
            ( ( member @ A @ X2 @ B2 )
            & ( P @ X2 ) ) ) ) )).

% bex_Un
thf(fact_241_UnI2,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A2: ( set @ A )] :
      ( ( member @ A @ C2 @ B2 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% UnI2
thf(fact_242_UnI1,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A2 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) ) ) )).

% UnI1
thf(fact_243_UnE,axiom,(
    ! [A: $tType,C2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A2 @ B2 ) )
     => ( ~ ( member @ A @ C2 @ A2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% UnE
thf(fact_244_diff__strict__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A4 @ C2 ) @ ( minus_minus @ A @ B4 @ D2 ) ) ) ) ) )).

% diff_strict_mono
thf(fact_245_diff__eq__diff__less,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A4 @ B4 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A4 @ B4 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) )).

% diff_eq_diff_less
thf(fact_246_diff__strict__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B4 @ A4 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A4 ) @ ( minus_minus @ A @ C2 @ B4 ) ) ) ) )).

% diff_strict_left_mono
thf(fact_247_LList2__Mirabelle__hamjzmohle_Ollength__mono,axiom,(
    ! [A: $tType,R: ( coinductive_llist @ A ),A2: ( set @ A ),S: ( coinductive_llist @ A )] :
      ( ( member @ ( coinductive_llist @ A ) @ R @ ( lList2236698231inlsts @ A @ A2 ) )
     => ( ( ord_less @ ( coinductive_llist @ A ) @ S @ R )
       => ( ord_less @ nat @ ( lList21232602520length @ A @ S ) @ ( lList21232602520length @ A @ R ) ) ) ) )).

% LList2_Mirabelle_hamjzmohle.llength_mono
thf(fact_248_psubset__imp__ex__mem,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A2 @ B2 )
     => ? [B6: A] :
          ( member @ A @ B6 @ ( minus_minus @ ( set @ A ) @ B2 @ A2 ) ) ) )).

% psubset_imp_ex_mem
thf(fact_249_diff__right__commute,axiom,(
    ! [A: $tType] :
      ( ( cancel146912293up_add @ A @ ( type2 @ A ) )
     => ! [A4: A,C2: A,B4: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A4 @ C2 ) @ B4 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A4 @ B4 ) @ C2 ) ) ) )).

% diff_right_commute
thf(fact_250_diff__eq__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A4 @ B4 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A4 = B4 )
            = ( C2 = D2 ) ) ) ) )).

% diff_eq_diff_eq
thf(fact_251_lapp__take__less,axiom,(
    ! [A: $tType,I: nat,R: ( coinductive_llist @ A ),S: ( coinductive_llist @ A )] :
      ( ( ord_less @ nat @ I @ ( lList21232602520length @ A @ R ) )
     => ( ord_less @ ( coinductive_llist @ A ) @ ( lList22119844313_ltake @ A @ ( coinductive_lappend @ A @ R @ S ) @ I ) @ R ) ) )).

% lapp_take_less
thf(fact_252_diff__strict__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B4 )
         => ( ord_less @ A @ ( minus_minus @ A @ A4 @ C2 ) @ ( minus_minus @ A @ B4 @ C2 ) ) ) ) )).

% diff_strict_right_mono
thf(fact_253_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y2 @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y2 @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_254_pprefix__closed__def,axiom,(
    ! [A: $tType] :
      ( ( lList21974196564closed @ A )
      = ( ^ [A3: ( set @ ( coinductive_llist @ A ) )] :
          ! [X2: ( coinductive_llist @ A )] :
            ( ( member @ ( coinductive_llist @ A ) @ X2 @ A3 )
           => ! [S3: ( coinductive_llist @ A )] :
                ( ( ( ord_less_eq @ ( coinductive_llist @ A ) @ S3 @ X2 )
                  & ( S3
                   != ( coinductive_LNil @ A ) ) )
               => ( member @ ( coinductive_llist @ A ) @ S3 @ A3 ) ) ) ) ) )).

% pprefix_closed_def
thf(fact_255_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X3: A] :
          ( ord_less_eq @ A @ X3 @ X3 ) ) )).

% order_refl

%----Type constructors (44)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice_top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( semilattice_sup @ A9 @ ( type2 @ A9 ) )
     => ( semilattice_sup @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__top,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_top @ A9 @ ( type2 @ A9 ) )
     => ( order_top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( lattice @ A9 @ ( type2 @ A9 ) )
     => ( lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( top @ A9 @ ( type2 @ A9 ) )
     => ( top @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Groups_Ominus,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( minus @ A9 @ ( type2 @ A9 ) )
     => ( minus @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add,axiom,
    ( cancel146912293up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_3,axiom,
    ( semilattice_sup @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_4,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Ono__top,axiom,
    ( no_top @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Lattices_Olattice_5,axiom,
    ( lattice @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_6,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_7,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ominus_8,axiom,
    ( minus @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_9,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_10,axiom,(
    ! [A8: $tType] :
      ( semilattice_sup @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__top_11,axiom,(
    ! [A8: $tType] :
      ( order_top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_12,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_13,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_14,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_15,axiom,(
    ! [A8: $tType] :
      ( top @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_16,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ominus_17,axiom,(
    ! [A8: $tType] :
      ( minus @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_18,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_19,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__top_20,axiom,
    ( order_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_21,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_22,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_23,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_24,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_25,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_26,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ominus_27,axiom,
    ( minus @ $o @ ( type2 @ $o ) )).

thf(tcon_Coinductive__List_Ollist___Orderings_Opreorder_28,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( coinductive_llist @ A8 ) @ ( type2 @ ( coinductive_llist @ A8 ) ) ) )).

thf(tcon_Coinductive__List_Ollist___Orderings_Oorder_29,axiom,(
    ! [A8: $tType] :
      ( order @ ( coinductive_llist @ A8 ) @ ( type2 @ ( coinductive_llist @ A8 ) ) ) )).

thf(tcon_Coinductive__List_Ollist___Orderings_Oord_30,axiom,(
    ! [A8: $tType] :
      ( ord @ ( coinductive_llist @ A8 ) @ ( type2 @ ( coinductive_llist @ A8 ) ) ) )).

%----Conjectures (4)
thf(conj_0,hypothesis,
    ( lList21952340509veness @ a @ a2 @ p )).

thf(conj_1,hypothesis,(
    ! [T3: ( coinductive_llist @ a )] :
      ( ( member @ ( coinductive_llist @ a ) @ T3 @ ( lList2435255213lllsts @ a @ a2 ) )
     => ( ( member @ ( coinductive_llist @ a ) @ ( coinductive_lappend @ a @ s @ T3 ) @ p )
       => r ) ) )).

thf(conj_2,hypothesis,
    ( ~ ( member @ ( coinductive_llist @ a ) @ s @ ( lList22096119349pslsts @ a @ a2 ) )
   => r )).

thf(conj_3,conjecture,(
    r )).

%------------------------------------------------------------------------------
