%------------------------------------------------------------------------------
% File     : DAT197^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Lazy list mirror 137
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : lmirror__137.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  353 (   0 unit;  67 type;   0 defn)
%            Number of atoms       : 5516 ( 309 equality;3672 variable)
%            Maximal formula depth :   25 (  10 average)
%            Number of connectives : 4610 (  27   ~;   6   |;  47   &;4261   @)
%                                         (   0 <=>; 269  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  918 ( 918   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   71 (  67   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1359 (   0 sgn;1152   !;  20   ?; 122   ^)
%                                         (1359   :;  65  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:49.835
%------------------------------------------------------------------------------
%----Could-be-implicit typings (8)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_Code__Numeral_Onatural,type,(
    code_natural: $tType )).

thf(ty_t_Extended__Nat_Oenat,type,(
    extended_enat: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (59)
thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring__1,type,(
    comm_semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__add,type,(
    comm_monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,(
    linord219039673up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,(
    semiri456707255roduct: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Def_Orel__fun,type,(
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) )).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,(
    code_case_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,(
    code_rec_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Osize__natural,type,(
    code_size_natural: code_natural > nat )).

thf(sy_c_Coinductive__List_Ofinite__lprefix,type,(
    coindu328551480prefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ogen__llength,type,(
    coindu246717305length: 
      !>[A: $tType] :
        ( nat > ( coinductive_llist @ A ) > extended_enat ) )).

thf(sy_c_Coinductive__List_Oiterates,type,(
    coinductive_iterates: 
      !>[A: $tType] :
        ( ( A > A ) > A > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olappend,type,(
    coinductive_lappend: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Oldrop,type,(
    coinductive_ldrop: 
      !>[A: $tType] :
        ( extended_enat > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_OldropWhile,type,(
    coindu218763757pWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfilter,type,(
    coinductive_lfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfinite,type,(
    coinductive_lfinite: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Ollast,type,(
    coinductive_llast: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollcp,type,(
    coinductive_llcp: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > extended_enat ) )).

thf(sy_c_Coinductive__List_Ollength,type,(
    coinductive_llength: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > extended_enat ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Ocorec__llist,type,(
    coindu1259883913_llist: 
      !>[C: $tType,A: $tType] :
        ( ( C > $o ) > ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Ollist__all2,type,(
    coindu1486289336t_all2: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olmap,type,(
    coinductive_lmap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( coinductive_llist @ A ) > ( coinductive_llist @ Aa ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olset,type,(
    coinductive_lset: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( set @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Opred__llist,type,(
    coindu543516966_llist: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olprefix,type,(
    coinductive_lprefix: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Oltake,type,(
    coinductive_ltake: 
      !>[A: $tType] :
        ( extended_enat > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_OltakeWhile,type,(
    coindu501562517eWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Omonoid__add__class_Ollistsum,type,(
    coindu780009021istsum: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_Fun_Omap__fun,type,(
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] :
        ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_LMirror__Mirabelle__wyovfcktfy_Olmirror__aux,type,(
    lMirro999291890or_aux: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Nat_Onat_Ocase__nat,type,(
    case_nat: 
      !>[A: $tType] :
        ( A > ( nat > A ) > nat > A ) )).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,(
    rec_nat: 
      !>[T: $tType] :
        ( T > ( nat > T > T ) > nat > T ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Quotient_OBex1__rel,type,(
    bex1_rel: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > $o ) )).

thf(sy_c_Quotient_OQuotient3,type,(
    quotient3: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_P,type,(
    p: a > b > $o )).

thf(sy_v_acc_Ha____,type,(
    acc_a: ( coinductive_llist @ b ) )).

thf(sy_v_acca____,type,(
    acca: ( coinductive_llist @ a ) )).

thf(sy_v_xs_Ha____,type,(
    xs_a: ( coinductive_llist @ b ) )).

thf(sy_v_xsa____,type,(
    xsa: ( coinductive_llist @ a ) )).

%----Relevant facts (254)
thf(fact_0_local_OLNil_I2_J,axiom,
    ( coindu1486289336t_all2 @ a @ b @ p @ acca @ acc_a )).

% local.LNil(2)
thf(fact_1_local_OLNil_I3_J,axiom,
    ( coinductive_lfinite @ a @ acca )).

% local.LNil(3)
thf(fact_2_calculation,axiom,
    ( ( coinductive_llength @ a @ ( lMirro999291890or_aux @ a @ acca @ xsa ) )
    = ( coinductive_llength @ b @ ( lMirro999291890or_aux @ b @ acc_a @ xs_a ) ) )).

% calculation
thf(fact_3_local_OLNil_I1_J,axiom,
    ( coindu1486289336t_all2 @ a @ b @ p @ ( lMirro999291890or_aux @ a @ acca @ xsa ) @ ( lMirro999291890or_aux @ b @ acc_a @ xs_a ) )).

% local.LNil(1)
thf(fact_4_llist__all2__llengthD,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( coinductive_llength @ A @ Xs )
        = ( coinductive_llength @ B @ Ys ) ) ) )).

% llist_all2_llengthD
thf(fact_5_llcp__same__conv__length,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llcp @ A @ Xs @ Xs )
      = ( coinductive_llength @ A @ Xs ) ) )).

% llcp_same_conv_length
thf(fact_6_llength__lmap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_llength @ A @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_llength @ B @ Xs ) ) )).

% llength_lmap
thf(fact_7_lprefix__llength__eq__imp__eq,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( ( coinductive_llength @ A @ Xs )
          = ( coinductive_llength @ A @ Ys ) )
       => ( Xs = Ys ) ) ) )).

% lprefix_llength_eq_imp_eq
thf(fact_8_llength__ltakeWhile__all,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_llength @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
        = ( coinductive_llength @ A @ Xs ) )
      = ( ( coindu501562517eWhile @ A @ P @ Xs )
        = Xs ) ) )).

% llength_ltakeWhile_all
thf(fact_9_llist__all2__llength__ltakeWhileD,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Q1: ( A > $o ),Q2: ( B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( ( Q1 @ X )
              = ( Q2 @ Y ) ) )
       => ( ( coinductive_llength @ A @ ( coindu501562517eWhile @ A @ Q1 @ Xs ) )
          = ( coinductive_llength @ B @ ( coindu501562517eWhile @ B @ Q2 @ Ys ) ) ) ) ) )).

% llist_all2_llength_ltakeWhileD
thf(fact_10_llength__code,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llength @ A )
      = ( coindu246717305length @ A @ ( zero_zero @ nat ) ) ) )).

% llength_code
thf(fact_11_llength__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ extended_enat @ extended_enat @ ( coindu1486289336t_all2 @ A @ B @ A2 )
      @ ^ [Y2: extended_enat,Z: extended_enat] : ( Y2 = Z )
      @ ( coinductive_llength @ A )
      @ ( coinductive_llength @ B ) ) )).

% llength_transfer
thf(fact_12_lprefix__refl,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ Xs @ Xs ) )).

% lprefix_refl
thf(fact_13_llist_Oleq__refl,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ X2 @ X2 ) )).

% llist.leq_refl
thf(fact_14_lfinite__lmap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_lmap
thf(fact_15_lfinite__lmirror__aux,axiom,(
    ! [A: $tType,Acc: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( lMirro999291890or_aux @ A @ Acc @ Xs ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ( coinductive_lfinite @ A @ Acc ) ) ) )).

% lfinite_lmirror_aux
thf(fact_16_llcp__lprefix1,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_llcp @ A @ Xs @ Ys )
        = ( coinductive_llength @ A @ Xs ) ) ) )).

% llcp_lprefix1
thf(fact_17_llcp__lprefix2,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Ys @ Xs )
     => ( ( coinductive_llcp @ A @ Xs @ Ys )
        = ( coinductive_llength @ A @ Ys ) ) ) )).

% llcp_lprefix2
thf(fact_18_llcp__commute,axiom,(
    ! [A: $tType] :
      ( ( coinductive_llcp @ A )
      = ( ^ [Xs2: ( coinductive_llist @ A ),Ys2: ( coinductive_llist @ A )] :
            ( coinductive_llcp @ A @ Ys2 @ Xs2 ) ) ) )).

% llcp_commute
thf(fact_19_lmap__lprefix,axiom,(
    ! [B: $tType,A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),F: ( A > B )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ B @ ( coinductive_lmap @ A @ B @ F @ Xs ) @ ( coinductive_lmap @ A @ B @ F @ Ys ) ) ) )).

% lmap_lprefix
thf(fact_20_lmap__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > C > $o ),B2: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) ) @ ( ( coinductive_llist @ C ) > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ C @ B @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ C ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ D ) @ ( coindu1486289336t_all2 @ A @ C @ A2 ) @ ( coindu1486289336t_all2 @ B @ D @ B2 ) ) @ ( coinductive_lmap @ A @ B ) @ ( coinductive_lmap @ C @ D ) ) )).

% lmap_transfer
thf(fact_21_lprefix__trans,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lprefix @ A @ Ys @ Zs )
       => ( coinductive_lprefix @ A @ Xs @ Zs ) ) ) )).

% lprefix_trans
thf(fact_22_llist__all2__rsp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),S: ( A > A > $o ),T2: ( B > B > $o ),X2: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ B ),A3: ( coinductive_llist @ A ),B3: ( coinductive_llist @ B )] :
      ( ! [X: A,Y: B] :
          ( ( R @ X @ Y )
         => ! [A4: A,B4: B] :
              ( ( R @ A4 @ B4 )
             => ( ( S @ X @ A4 )
                = ( T2 @ Y @ B4 ) ) ) )
     => ( ( coindu1486289336t_all2 @ A @ B @ R @ X2 @ Y3 )
       => ( ( coindu1486289336t_all2 @ A @ B @ R @ A3 @ B3 )
         => ( ( coindu1486289336t_all2 @ A @ A @ S @ X2 @ A3 )
            = ( coindu1486289336t_all2 @ B @ B @ T2 @ Y3 @ B3 ) ) ) ) ) )).

% llist_all2_rsp
thf(fact_23_llist_Oleq__trans,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ A ),Z2: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X2 @ Y3 )
     => ( ( coinductive_lprefix @ A @ Y3 @ Z2 )
       => ( coinductive_lprefix @ A @ X2 @ Z2 ) ) ) )).

% llist.leq_trans
thf(fact_24_llist__all2__mono,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),P2: ( A > B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( P2 @ X @ Y ) )
       => ( coindu1486289336t_all2 @ A @ B @ P2 @ Xs @ Ys ) ) ) )).

% llist_all2_mono
thf(fact_25_lprefix__antisym,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lprefix @ A @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% lprefix_antisym
thf(fact_26_lprefix__lfiniteD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lprefix_lfiniteD
thf(fact_27_llist_Oleq__antisym,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ X2 @ Y3 )
     => ( ( coinductive_lprefix @ A @ Y3 @ X2 )
       => ( X2 = Y3 ) ) ) )).

% llist.leq_antisym
thf(fact_28_lprefix__ltakeWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) @ Xs ) )).

% lprefix_ltakeWhile
thf(fact_29_llist__all2__lfiniteD,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( coinductive_lfinite @ A @ Xs )
        = ( coinductive_lfinite @ B @ Ys ) ) ) )).

% llist_all2_lfiniteD
thf(fact_30_lprefix__down__linear,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Zs )
     => ( ( coinductive_lprefix @ A @ Ys @ Zs )
       => ( ( coinductive_lprefix @ A @ Xs @ Ys )
          | ( coinductive_lprefix @ A @ Ys @ Xs ) ) ) ) )).

% lprefix_down_linear
thf(fact_31_not__lfinite__lprefix__conv__eq,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lprefix @ A @ Xs @ Ys )
        = ( Xs = Ys ) ) ) )).

% not_lfinite_lprefix_conv_eq
thf(fact_32_lmirror__aux__inf,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Acc: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( lMirro999291890or_aux @ A @ Acc @ Xs )
        = Xs ) ) )).

% lmirror_aux_inf
thf(fact_33_lmap__lmirror__aux,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Acc: ( coinductive_llist @ B ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lmap @ B @ A @ F @ ( lMirro999291890or_aux @ B @ Acc @ Xs ) )
      = ( lMirro999291890or_aux @ A @ ( coinductive_lmap @ B @ A @ F @ Acc ) @ ( coinductive_lmap @ B @ A @ F @ Xs ) ) ) )).

% lmap_lmirror_aux
thf(fact_34_llist_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( coindu1486289336t_all2 @ A @ A
        @ ^ [Y2: A,Z: A] : ( Y2 = Z ) )
      = ( ^ [Y2: ( coinductive_llist @ A ),Z: ( coinductive_llist @ A )] : ( Y2 = Z ) ) ) )).

% llist.rel_eq
thf(fact_35_llist_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X2: ( coinductive_llist @ B )] :
      ( ! [X: B] :
          ( Ra @ X @ X )
     => ( coindu1486289336t_all2 @ B @ B @ Ra @ X2 @ X2 ) ) )).

% llist.rel_refl
thf(fact_36_llist__all2__lmirror__aux,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Acc: ( coinductive_llist @ A ),Acc2: ( coinductive_llist @ B ),Xs: ( coinductive_llist @ A ),Xs3: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Acc @ Acc2 )
     => ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Xs3 )
       => ( coindu1486289336t_all2 @ A @ B @ P @ ( lMirro999291890or_aux @ A @ Acc @ Xs ) @ ( lMirro999291890or_aux @ B @ Acc2 @ Xs3 ) ) ) ) )).

% llist_all2_lmirror_aux
thf(fact_37_llist_Omap__transfer,axiom,(
    ! [A: $tType,B: $tType,F2: $tType,E: $tType,Rb: ( A > E > $o ),Sd: ( B > F2 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( E > F2 ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) ) @ ( ( coinductive_llist @ E ) > ( coinductive_llist @ F2 ) ) @ ( bNF_rel_fun @ A @ E @ B @ F2 @ Rb @ Sd ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ E ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ F2 ) @ ( coindu1486289336t_all2 @ A @ E @ Rb ) @ ( coindu1486289336t_all2 @ B @ F2 @ Sd ) ) @ ( coinductive_lmap @ A @ B ) @ ( coinductive_lmap @ E @ F2 ) ) )).

% llist.map_transfer
thf(fact_38_rel__funI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D )] :
      ( ! [X: A,Y: B] :
          ( ( A2 @ X @ Y )
         => ( B2 @ ( F @ X ) @ ( G @ Y ) ) )
     => ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F @ G ) ) )).

% rel_funI
thf(fact_39_Coinductive__List_Olprefix__nitpick__simps,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lprefix @ A )
      = ( ^ [Xs2: ( coinductive_llist @ A ),Ys2: ( coinductive_llist @ A )] :
            ( ( ( coinductive_lfinite @ A @ Xs2 )
             => ( coindu328551480prefix @ A @ Xs2 @ Ys2 ) )
            & ( ~ ( coinductive_lfinite @ A @ Xs2 )
             => ( Xs2 = Ys2 ) ) ) ) ) )).

% Coinductive_List.lprefix_nitpick_simps
thf(fact_40_llistsum__inf,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [Xs: ( coinductive_llist @ A )] :
          ( ~ ( coinductive_lfinite @ A @ Xs )
         => ( ( coindu780009021istsum @ A @ Xs )
            = ( zero_zero @ A ) ) ) ) )).

% llistsum_inf
thf(fact_41_rel__funD,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X2: A,Y3: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F @ G )
     => ( ( A2 @ X2 @ Y3 )
       => ( B2 @ ( F @ X2 ) @ ( G @ Y3 ) ) ) ) )).

% rel_funD
thf(fact_42_let__rsp,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ R1 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 ) @ R2 )
      @ ^ [S2: A,F3: ( A > C )] :
          ( F3 @ S2 )
      @ ^ [S2: B,F3: ( B > D )] :
          ( F3 @ S2 ) ) )).

% let_rsp
thf(fact_43_rel__funE,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X2: A,Y3: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F @ G )
     => ( ( A2 @ X2 @ Y3 )
       => ( B2 @ ( F @ X2 ) @ ( G @ Y3 ) ) ) ) )).

% rel_funE
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X: A] :
          ( ( F @ X )
          = ( G @ X ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_apply__rsp_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X2: A,Y3: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 @ F @ G )
     => ( ( R1 @ X2 @ Y3 )
       => ( R2 @ ( F @ X2 ) @ ( G @ Y3 ) ) ) ) )).

% apply_rsp'
thf(fact_49_rel__funD2,axiom,(
    ! [B: $tType,C: $tType,A: $tType,A2: ( A > A > $o ),B2: ( B > C > $o ),F: ( A > B ),G: ( A > C ),X2: A] :
      ( ( bNF_rel_fun @ A @ A @ B @ C @ A2 @ B2 @ F @ G )
     => ( ( A2 @ X2 @ X2 )
       => ( B2 @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% rel_funD2
thf(fact_50_rel__fun__mono,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,X4: ( A > B > $o ),A2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),Y4: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ X4 @ A2 @ F @ G )
     => ( ! [X: A,Y: B] :
            ( ( Y4 @ X @ Y )
           => ( X4 @ X @ Y ) )
       => ( ! [X: C,Y: D] :
              ( ( A2 @ X @ Y )
             => ( B2 @ X @ Y ) )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y4 @ B2 @ F @ G ) ) ) ) )).

% rel_fun_mono
thf(fact_51_rel__fun__mono_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Y4: ( A > B > $o ),X4: ( A > B > $o ),A2: ( C > D > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D )] :
      ( ! [X: A,Y: B] :
          ( ( Y4 @ X @ Y )
         => ( X4 @ X @ Y ) )
     => ( ! [X: C,Y: D] :
            ( ( A2 @ X @ Y )
           => ( B2 @ X @ Y ) )
       => ( ( bNF_rel_fun @ A @ B @ C @ D @ X4 @ A2 @ F @ G )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y4 @ B2 @ F @ G ) ) ) ) )).

% rel_fun_mono'
thf(fact_52_llist__all2__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ R
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o ) @ ( coindu1486289336t_all2 @ A @ B @ R )
        @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ R )
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) ) )
      @ ( coindu1486289336t_all2 @ A @ A )
      @ ( coindu1486289336t_all2 @ B @ B ) ) )).

% llist_all2_transfer
thf(fact_53_llist_Orel__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: ( A > C > $o ),Sc: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > $o ) @ ( ( coinductive_llist @ C ) > ( coinductive_llist @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ C ) @ ( ( coinductive_llist @ B ) > $o ) @ ( ( coinductive_llist @ D ) > $o ) @ ( coindu1486289336t_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( coinductive_llist @ B ) @ ( coinductive_llist @ D ) @ $o @ $o @ ( coindu1486289336t_all2 @ B @ D @ Sc )
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) ) )
      @ ( coindu1486289336t_all2 @ A @ B )
      @ ( coindu1486289336t_all2 @ C @ D ) ) )).

% llist.rel_transfer
thf(fact_54_ltakeWhile__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coindu501562517eWhile @ A )
      @ ( coindu501562517eWhile @ B ) ) )).

% ltakeWhile_transfer
thf(fact_55_lfinite__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ A2 )
      @ ^ [Y2: $o,Z: $o] : ( Y2 = Z )
      @ ( coinductive_lfinite @ A )
      @ ( coinductive_lfinite @ B ) ) )).

% lfinite_transfer
thf(fact_56_Coinductive__List_Ofinite__lprefix__def,axiom,(
    ! [A: $tType] :
      ( ( coindu328551480prefix @ A )
      = ( coinductive_lprefix @ A ) ) )).

% Coinductive_List.finite_lprefix_def
thf(fact_57_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type @ A ) )
     => ! [X2: A] :
          ( ( ( zero_zero @ A )
            = X2 )
          = ( X2
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_58_Let__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ A2 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ B2 )
      @ ^ [S2: A,F3: ( A > C )] :
          ( F3 @ S2 )
      @ ^ [S2: B,F3: ( B > D )] :
          ( F3 @ S2 ) ) )).

% Let_transfer
thf(fact_59_rel__fun__def__butlast,axiom,(
    ! [B: $tType,D: $tType,C: $tType,E: $tType,F2: $tType,A: $tType,R: ( A > B > $o ),S: ( C > E > $o ),T2: ( D > F2 > $o ),F: ( A > C > D ),G: ( B > E > F2 )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > D ) @ ( E > F2 ) @ R @ ( bNF_rel_fun @ C @ E @ D @ F2 @ S @ T2 ) @ F @ G )
      = ( ! [X3: A,Y5: B] :
            ( ( R @ X3 @ Y5 )
           => ( bNF_rel_fun @ C @ E @ D @ F2 @ S @ T2 @ ( F @ X3 ) @ ( G @ Y5 ) ) ) ) ) )).

% rel_fun_def_butlast
thf(fact_60_If__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( B > B > B )
      @ ^ [Y2: $o,Z: $o] : ( Y2 = Z )
      @ ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A2 @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) )
      @ ( if @ A )
      @ ( if @ B ) ) )).

% If_transfer
thf(fact_61_llist__corec__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > C ) > ( A > $o ) > ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > D ) > ( B > $o ) > ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > $o ) > ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > $o ) > ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 )
        @ ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) )
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
          @ ( bNF_rel_fun @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) ) ) ) )
      @ ( coindu1259883913_llist @ A @ C )
      @ ( coindu1259883913_llist @ B @ D ) ) )).

% llist_corec_transfer
thf(fact_62_llist_Ocorec__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > B ) > ( D > $o ) > ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > $o ) > ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ S @ R )
        @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) )
          @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
            @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
          @ ( bNF_rel_fun @ ( C > ( coinductive_llist @ A ) ) @ ( D > ( coinductive_llist @ B ) ) @ ( ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > D ) > D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ S @ ( coindu1486289336t_all2 @ A @ B @ R ) ) @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( C > ( coinductive_llist @ A ) ) @ ( D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S @ S ) @ ( bNF_rel_fun @ C @ D @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ S @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) ) ) )
      @ ( coindu1259883913_llist @ C @ A )
      @ ( coindu1259883913_llist @ D @ B ) ) )).

% llist.corec_transfer
thf(fact_63_unfold__llist__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > C ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > D ) > ( B > B ) > B > ( coinductive_llist @ D ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) ) )
      @ ( coindu1441602521_llist @ A @ C )
      @ ( coindu1441602521_llist @ B @ D ) ) )).

% unfold_llist_transfer
thf(fact_64_iterates__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ A ) ) @ ( B > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ A2 @ ( coindu1486289336t_all2 @ A @ B @ A2 ) ) @ ( coinductive_iterates @ A ) @ ( coinductive_iterates @ B ) ) )).

% iterates_transfer
thf(fact_65_case__llist__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,B2: ( A > B > $o ),A2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( C > ( coinductive_llist @ C ) > A ) > ( coinductive_llist @ C ) > A ) @ ( ( D > ( coinductive_llist @ D ) > B ) > ( coinductive_llist @ D ) > B ) @ B2 @ ( bNF_rel_fun @ ( C > ( coinductive_llist @ C ) > A ) @ ( D > ( coinductive_llist @ D ) > B ) @ ( ( coinductive_llist @ C ) > A ) @ ( ( coinductive_llist @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ ( ( coinductive_llist @ C ) > A ) @ ( ( coinductive_llist @ D ) > B ) @ A2 @ ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A @ B @ ( coindu1486289336t_all2 @ C @ D @ A2 ) @ B2 ) ) @ ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A @ B @ ( coindu1486289336t_all2 @ C @ D @ A2 ) @ B2 ) ) @ ( coindu1381640503_llist @ A @ C ) @ ( coindu1381640503_llist @ B @ D ) ) )).

% case_llist_transfer
thf(fact_66_llist_Ocase__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ C @ D @ ( ( A > ( coinductive_llist @ A ) > C ) > ( coinductive_llist @ A ) > C ) @ ( ( B > ( coinductive_llist @ B ) > D ) > ( coinductive_llist @ B ) > D ) @ S @ ( bNF_rel_fun @ ( A > ( coinductive_llist @ A ) > C ) @ ( B > ( coinductive_llist @ B ) > D ) @ ( ( coinductive_llist @ A ) > C ) @ ( ( coinductive_llist @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > C ) @ ( ( coinductive_llist @ B ) > D ) @ R @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ D @ ( coindu1486289336t_all2 @ A @ B @ R ) @ S ) ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ D @ ( coindu1486289336t_all2 @ A @ B @ R ) @ S ) ) @ ( coindu1381640503_llist @ C @ A ) @ ( coindu1381640503_llist @ D @ B ) ) )).

% llist.case_transfer
thf(fact_67_lfinite__iterates,axiom,(
    ! [A: $tType,F: ( A > A ),X2: A] :
      ~ ( coinductive_lfinite @ A @ ( coinductive_iterates @ A @ F @ X2 ) ) )).

% lfinite_iterates
thf(fact_68_lmap__iterates,axiom,(
    ! [A: $tType,F: ( A > A ),X2: A] :
      ( ( coinductive_lmap @ A @ A @ F @ ( coinductive_iterates @ A @ F @ X2 ) )
      = ( coinductive_iterates @ A @ F @ ( F @ X2 ) ) ) )).

% lmap_iterates
thf(fact_69_fun_Orel__transfer,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E: $tType,D: $tType,Sa: ( A > C > $o ),Sc: ( B > E > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > E > $o ) @ ( ( D > A ) > ( D > B ) > $o ) @ ( ( D > C ) > ( D > E ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( E > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ E @ $o @ $o @ Sc
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > C ) @ ( ( D > B ) > $o ) @ ( ( D > E ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ C
          @ ^ [Y2: D,Z: D] : ( Y2 = Z )
          @ Sa )
        @ ( bNF_rel_fun @ ( D > B ) @ ( D > E ) @ $o @ $o
          @ ( bNF_rel_fun @ D @ D @ B @ E
            @ ^ [Y2: D,Z: D] : ( Y2 = Z )
            @ Sc )
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) ) )
      @ ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y2: D,Z: D] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ D @ D @ C @ E
        @ ^ [Y2: D,Z: D] : ( Y2 = Z ) ) ) )).

% fun.rel_transfer
thf(fact_70_ldropWhile__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coindu218763757pWhile @ A )
      @ ( coindu218763757pWhile @ B ) ) )).

% ldropWhile_transfer
thf(fact_71_map__fun__parametric,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F2: $tType,H: $tType,G2: $tType,D: $tType,C: $tType,A2: ( A > C > $o ),B2: ( B > D > $o ),C2: ( E > G2 > $o ),D2: ( F2 > H > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > F2 ) > ( B > E ) > A > F2 ) @ ( ( G2 > H ) > ( D > G2 ) > C > H ) @ ( bNF_rel_fun @ A @ C @ B @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( E > F2 ) @ ( G2 > H ) @ ( ( B > E ) > A > F2 ) @ ( ( D > G2 ) > C > H ) @ ( bNF_rel_fun @ E @ G2 @ F2 @ H @ C2 @ D2 ) @ ( bNF_rel_fun @ ( B > E ) @ ( D > G2 ) @ ( A > F2 ) @ ( C > H ) @ ( bNF_rel_fun @ B @ D @ E @ G2 @ B2 @ C2 ) @ ( bNF_rel_fun @ A @ C @ F2 @ H @ A2 @ D2 ) ) ) @ ( map_fun @ A @ B @ E @ F2 ) @ ( map_fun @ C @ D @ G2 @ H ) ) )).

% map_fun_parametric
thf(fact_72_lfilter__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coinductive_lfilter @ A )
      @ ( coinductive_lfilter @ B ) ) )).

% lfilter_transfer
thf(fact_73_llist_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ R )
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( coindu543516966_llist @ A )
      @ ( coindu543516966_llist @ B ) ) )).

% llist.pred_transfer
thf(fact_74_llist__all__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ A2 )
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
      @ ( coindu543516966_llist @ A )
      @ ( coindu543516966_llist @ B ) ) )).

% llist_all_transfer
thf(fact_75_if__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( A > A > A )
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z )
        @ ( bNF_rel_fun @ A @ A @ ( A > A ) @ ( A > A ) @ R @ ( bNF_rel_fun @ A @ A @ A @ A @ R @ R ) )
        @ ( if @ A )
        @ ( if @ A ) ) ) )).

% if_rsp
thf(fact_76_lfilter__idem,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( coinductive_lfilter @ A @ P @ Xs ) ) )).

% lfilter_idem
thf(fact_77_fun__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R2: ( C > C > $o ),Abs2: ( C > D ),Rep2: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs2 @ Rep2 )
       => ( quotient3 @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 ) @ ( map_fun @ B @ A @ C @ D @ Rep1 @ Abs2 ) @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep2 ) ) ) ) )).

% fun_quotient3
thf(fact_78_let__prs,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs22: ( C > D ),Rep22: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs22 @ Rep22 )
       => ( ( map_fun @ D @ C @ ( ( C > A ) > A ) @ ( ( D > B ) > B ) @ Rep22 @ ( map_fun @ ( D > B ) @ ( C > A ) @ A @ B @ ( map_fun @ C @ D @ B @ A @ Abs22 @ Rep12 ) @ Abs12 )
            @ ^ [S2: C,F3: ( C > A )] :
                ( F3 @ S2 ) )
          = ( ^ [S2: D,F3: ( D > B )] :
                ( F3 @ S2 ) ) ) ) ) )).

% let_prs
thf(fact_79_cond__prs,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A ),A3: $o,B3: B,C3: B] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( ( A3
         => ( ( Absf @ ( if @ A @ A3 @ ( Repf @ B3 ) @ ( Repf @ C3 ) ) )
            = B3 ) )
        & ( ~ ( A3 )
         => ( ( Absf @ ( if @ A @ A3 @ ( Repf @ B3 ) @ ( Repf @ C3 ) ) )
            = C3 ) ) ) ) )).

% cond_prs
thf(fact_80_Quotient3I,axiom,(
    ! [B: $tType,A: $tType,Abs: ( B > A ),Rep: ( A > B ),R: ( B > B > $o )] :
      ( ! [A4: A] :
          ( ( Abs @ ( Rep @ A4 ) )
          = A4 )
     => ( ! [A4: A] :
            ( R @ ( Rep @ A4 ) @ ( Rep @ A4 ) )
       => ( ! [R3: B,S3: B] :
              ( ( R @ R3 @ S3 )
              = ( ( R @ R3 @ R3 )
                & ( R @ S3 @ S3 )
                & ( ( Abs @ R3 )
                  = ( Abs @ S3 ) ) ) )
         => ( quotient3 @ B @ A @ R @ Abs @ Rep ) ) ) ) )).

% Quotient3I
thf(fact_81_equals__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),Xa: A,Xb: A,Ya: A,Yb: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ Xa @ Xb )
       => ( ( R @ Ya @ Yb )
         => ( ( R @ Xa @ Ya )
            = ( R @ Xb @ Yb ) ) ) ) ) )).

% equals_rsp
thf(fact_82_rep__abs__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X22: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ X1 @ X22 )
       => ( R @ X1 @ ( Rep @ ( Abs @ X22 ) ) ) ) ) )).

% rep_abs_rsp
thf(fact_83_Quotient3__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( quotient3 @ A @ B )
      = ( ^ [R4: ( A > A > $o ),Abs3: ( A > B ),Rep3: ( B > A )] :
            ( ! [A5: B] :
                ( ( Abs3 @ ( Rep3 @ A5 ) )
                = A5 )
            & ! [A5: B] :
                ( R4 @ ( Rep3 @ A5 ) @ ( Rep3 @ A5 ) )
            & ! [R5: A,S2: A] :
                ( ( R4 @ R5 @ S2 )
                = ( ( R4 @ R5 @ R5 )
                  & ( R4 @ S2 @ S2 )
                  & ( ( Abs3 @ R5 )
                    = ( Abs3 @ S2 ) ) ) ) ) ) ) )).

% Quotient3_def
thf(fact_84_Quotient3__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R6: A,S4: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( ( R @ R6 @ R6 )
          & ( R @ S4 @ S4 )
          & ( ( Abs @ R6 )
            = ( Abs @ S4 ) ) )
        = ( R @ R6 @ S4 ) ) ) )).

% Quotient3_rel
thf(fact_85_Quotient3__refl1,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R6: A,S4: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R6 @ S4 )
       => ( R @ R6 @ R6 ) ) ) )).

% Quotient3_refl1
thf(fact_86_Quotient3__refl2,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R6: A,S4: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R6 @ S4 )
       => ( R @ S4 @ S4 ) ) ) )).

% Quotient3_refl2
thf(fact_87_rep__abs__rsp__left,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X22: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ X1 @ X22 )
       => ( R @ ( Rep @ ( Abs @ X1 ) ) @ X22 ) ) ) )).

% rep_abs_rsp_left
thf(fact_88_Quotient3__abs__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( Abs @ ( Rep @ A3 ) )
        = A3 ) ) )).

% Quotient3_abs_rep
thf(fact_89_Quotient3__rel__abs,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R6: A,S4: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R6 @ S4 )
       => ( ( Abs @ R6 )
          = ( Abs @ S4 ) ) ) ) )).

% Quotient3_rel_abs
thf(fact_90_Quotient3__rel__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B,B3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ ( Rep @ A3 ) @ ( Rep @ B3 ) )
        = ( A3 = B3 ) ) ) )).

% Quotient3_rel_rep
thf(fact_91_Quotient3__rep__abs,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R6: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R6 @ R6 )
       => ( R @ ( Rep @ ( Abs @ R6 ) ) @ R6 ) ) ) )).

% Quotient3_rep_abs
thf(fact_92_Quotient3__rep__reflp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( R @ ( Rep @ A3 ) @ ( Rep @ A3 ) ) ) )).

% Quotient3_rep_reflp
thf(fact_93_lprefix__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_lfilter @ A @ P @ Xs ) @ ( coinductive_lfilter @ A @ P @ Ys ) ) ) )).

% lprefix_lfilterI
thf(fact_94_llist__all2__lfilterI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Q1: ( A > $o ),Q2: ( B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( ( Q1 @ X )
              = ( Q2 @ Y ) ) )
       => ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_lfilter @ A @ Q1 @ Xs ) @ ( coinductive_lfilter @ B @ Q2 @ Ys ) ) ) ) )).

% llist_all2_lfilterI
thf(fact_95_apply__rspQ3_H_H,axiom,(
    ! [C: $tType,A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),S: ( C > C > $o ),F: ( A > C ),X2: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R @ S @ F @ F )
       => ( S @ ( F @ ( Rep @ X2 ) ) @ ( F @ ( Rep @ X2 ) ) ) ) ) )).

% apply_rspQ3''
thf(fact_96_apply__rspQ3,axiom,(
    ! [B: $tType,C: $tType,A: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),F: ( A > C ),G: ( A > C ),X2: A,Y3: A] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 @ F @ G )
       => ( ( R1 @ X2 @ Y3 )
         => ( R2 @ ( F @ X2 ) @ ( G @ Y3 ) ) ) ) ) )).

% apply_rspQ3
thf(fact_97_lfinite__lfilterI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )).

% lfinite_lfilterI
thf(fact_98_llist__all2__ldropWhileI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Q1: ( A > $o ),Q2: ( B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( ( Q1 @ X )
              = ( Q2 @ Y ) ) )
       => ( coindu1486289336t_all2 @ A @ B @ P @ ( coindu218763757pWhile @ A @ Q1 @ Xs ) @ ( coindu218763757pWhile @ B @ Q2 @ Ys ) ) ) ) )).

% llist_all2_ldropWhileI
thf(fact_99_quot__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( bNF_rel_fun @ A @ A @ ( A > $o ) @ ( A > $o ) @ R
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
        @ R
        @ R ) ) )).

% quot_rel_rsp
thf(fact_100_fun_Orel__refl,axiom,(
    ! [B: $tType,D: $tType,Ra: ( B > B > $o ),X2: ( D > B )] :
      ( ! [X: B] :
          ( Ra @ X @ X )
     => ( bNF_rel_fun @ D @ D @ B @ B
        @ ^ [Y2: D,Z: D] : ( Y2 = Z )
        @ Ra
        @ X2
        @ X2 ) ) )).

% fun.rel_refl
thf(fact_101_fun_Orel__eq,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y2: D,Z: D] : ( Y2 = Z )
        @ ^ [Y2: A,Z: A] : ( Y2 = Z ) )
      = ( ^ [Y2: ( D > A ),Z: ( D > A )] : ( Y2 = Z ) ) ) )).

% fun.rel_eq
thf(fact_102_map__fun__apply,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( map_fun @ B @ C @ D @ A )
      = ( ^ [F3: ( B > C ),G3: ( D > A ),H2: ( C > D ),X3: B] :
            ( G3 @ ( H2 @ ( F3 @ X3 ) ) ) ) ) )).

% map_fun_apply
thf(fact_103_bex1__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( bNF_rel_fun @ ( A > $o ) @ ( A > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R
          @ ^ [Y2: $o,Z: $o] : ( Y2 = Z ) )
        @ ^ [Y2: $o,Z: $o] : ( Y2 = Z )
        @ ( bex1_rel @ A @ R )
        @ ( bex1_rel @ A @ R ) ) ) )).

% bex1_rel_rsp
thf(fact_104_llist_Octr__transfer_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) ) @ R @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) @ ( coinductive_LCons @ A ) @ ( coinductive_LCons @ B ) ) )).

% llist.ctr_transfer(2)
thf(fact_105_LCons__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) ) @ A2 @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) ) @ ( coinductive_LCons @ A ) @ ( coinductive_LCons @ B ) ) )).

% LCons_transfer
thf(fact_106_ldropWhile__eq__ldrop,axiom,(
    ! [A: $tType] :
      ( ( coindu218763757pWhile @ A )
      = ( ^ [P3: ( A > $o ),Xs2: ( coinductive_llist @ A )] :
            ( coinductive_ldrop @ A @ ( coinductive_llength @ A @ ( coindu501562517eWhile @ A @ P3 @ Xs2 ) ) @ Xs2 ) ) ) )).

% ldropWhile_eq_ldrop
thf(fact_107_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) )).

% zero_natural.rsp
thf(fact_108_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X222: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X222 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y22 ) ) ) )).

% llist.inject
thf(fact_109_ldrop__0,axiom,(
    ! [B: $tType,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_ldrop @ B @ ( zero_zero @ extended_enat ) @ Xs )
      = Xs ) )).

% ldrop_0
thf(fact_110_LCons__lprefix__LCons,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( X2 = Y3 )
        & ( coinductive_lprefix @ A @ Xs @ Ys ) ) ) )).

% LCons_lprefix_LCons
thf(fact_111_llist__all2__LCons__LCons,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X21: A,X222: ( coinductive_llist @ A ),Y21: B,Y22: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ R @ ( coinductive_LCons @ A @ X21 @ X222 ) @ ( coinductive_LCons @ B @ Y21 @ Y22 ) )
      = ( ( R @ X21 @ Y21 )
        & ( coindu1486289336t_all2 @ A @ B @ R @ X222 @ Y22 ) ) ) )).

% llist_all2_LCons_LCons
thf(fact_112_lfinite__code_I2_J,axiom,(
    ! [B: $tType,X2: B,Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfinite @ B @ ( coinductive_LCons @ B @ X2 @ Xs ) )
      = ( coinductive_lfinite @ B @ Xs ) ) )).

% lfinite_code(2)
thf(fact_113_lfinite__LCons,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) )
      = ( coinductive_lfinite @ A @ Xs ) ) )).

% lfinite_LCons
thf(fact_114_lfilter__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X2 )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coinductive_LCons @ A @ X2 @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X2 )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons
thf(fact_115_ldropWhile__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X2 )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coindu218763757pWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X2 )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coinductive_LCons @ A @ X2 @ Xs ) ) ) ) )).

% ldropWhile_LCons
thf(fact_116_ldrop__lmap,axiom,(
    ! [A: $tType,B: $tType,N: extended_enat,F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_ldrop @ A @ N @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lmap @ B @ A @ F @ ( coinductive_ldrop @ B @ N @ Xs ) ) ) )).

% ldrop_lmap
thf(fact_117_lmirror__aux__simps_I2_J,axiom,(
    ! [A: $tType,Acc: ( coinductive_llist @ A ),Xa: A,X2: ( coinductive_llist @ A )] :
      ( ( lMirro999291890or_aux @ A @ Acc @ ( coinductive_LCons @ A @ Xa @ X2 ) )
      = ( coinductive_LCons @ A @ Xa @ ( lMirro999291890or_aux @ A @ ( coinductive_LCons @ A @ Xa @ Acc ) @ X2 ) ) ) )).

% lmirror_aux_simps(2)
thf(fact_118_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B3: B,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B3 )
        = ( coinductive_LCons @ A @ X2 @ Xs ) )
      = ( ~ ( IS_LNIL @ B3 )
        & ( X2
          = ( LHD @ B3 ) )
        & ( Xs
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B3 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_119_llist_Opred__inject_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),A3: A,Aa2: ( coinductive_llist @ A )] :
      ( ( coindu543516966_llist @ A @ P @ ( coinductive_LCons @ A @ A3 @ Aa2 ) )
      = ( ( P @ A3 )
        & ( coindu543516966_llist @ A @ P @ Aa2 ) ) ) )).

% llist.pred_inject(2)
thf(fact_120_bex1__rel__aux2,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X2: ( A > $o ),Y3: ( A > $o )] :
      ( ! [Xa2: A,Ya2: A] :
          ( ( R @ Xa2 @ Ya2 )
         => ( ( X2 @ Xa2 )
            = ( Y3 @ Ya2 ) ) )
     => ( ( bex1_rel @ A @ R @ Y3 )
       => ( bex1_rel @ A @ R @ X2 ) ) ) )).

% bex1_rel_aux2
thf(fact_121_bex1__rel__aux,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X2: ( A > $o ),Y3: ( A > $o )] :
      ( ! [Xa2: A,Ya2: A] :
          ( ( R @ Xa2 @ Ya2 )
         => ( ( X2 @ Xa2 )
            = ( Y3 @ Ya2 ) ) )
     => ( ( bex1_rel @ A @ R @ X2 )
       => ( bex1_rel @ A @ R @ Y3 ) ) ) )).

% bex1_rel_aux
thf(fact_122_Le__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),X2: A] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) @ ( coinductive_LCons @ A @ X2 @ Ys ) ) ) )).

% Le_LCons
thf(fact_123_LCons__lprefix__conv,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) @ Ys )
      = ( ? [Ys3: ( coinductive_llist @ A )] :
            ( ( Ys
              = ( coinductive_LCons @ A @ X2 @ Ys3 ) )
            & ( coinductive_lprefix @ A @ Xs @ Ys3 ) ) ) ) )).

% LCons_lprefix_conv
thf(fact_124_llist_Orel__intros_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X21: A,Y21: B,X222: ( coinductive_llist @ A ),Y22: ( coinductive_llist @ B )] :
      ( ( R @ X21 @ Y21 )
     => ( ( coindu1486289336t_all2 @ A @ B @ R @ X222 @ Y22 )
       => ( coindu1486289336t_all2 @ A @ B @ R @ ( coinductive_LCons @ A @ X21 @ X222 ) @ ( coinductive_LCons @ B @ Y21 @ Y22 ) ) ) ) )).

% llist.rel_intros(2)
thf(fact_125_llist__all2__LCons1,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),X2: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) @ Ys )
      = ( ? [Y5: B,Ys3: ( coinductive_llist @ B )] :
            ( ( Ys
              = ( coinductive_LCons @ B @ Y5 @ Ys3 ) )
            & ( P @ X2 @ Y5 )
            & ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys3 ) ) ) ) )).

% llist_all2_LCons1
thf(fact_126_llist__all2__LCons2,axiom,(
    ! [B: $tType,A: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Y3: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ ( coinductive_LCons @ B @ Y3 @ Ys ) )
      = ( ? [X3: A,Xs4: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ X3 @ Xs4 ) )
            & ( P @ X3 @ Y3 )
            & ( coindu1486289336t_all2 @ A @ B @ P @ Xs4 @ Ys ) ) ) ) )).

% llist_all2_LCons2
thf(fact_127_lfinite__LConsI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),X2: A] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( coinductive_lfinite @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) ) ) )).

% lfinite_LConsI
thf(fact_128_llist_Osimps_I13_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X21: A,X222: ( coinductive_llist @ A )] :
      ( ( coinductive_lmap @ A @ B @ F @ ( coinductive_LCons @ A @ X21 @ X222 ) )
      = ( coinductive_LCons @ B @ ( F @ X21 ) @ ( coinductive_lmap @ A @ B @ F @ X222 ) ) ) )).

% llist.simps(13)
thf(fact_129_lmap__eq__LCons__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lmap @ B @ A @ F @ Xs )
        = ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ? [X3: B,Xs4: ( coinductive_llist @ B )] :
            ( ( Xs
              = ( coinductive_LCons @ B @ X3 @ Xs4 ) )
            & ( Y3
              = ( F @ X3 ) )
            & ( Ys
              = ( coinductive_lmap @ B @ A @ F @ Xs4 ) ) ) ) ) )).

% lmap_eq_LCons_conv
thf(fact_130_llist__all2__ldropI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),N: extended_enat] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_ldrop @ A @ N @ Xs ) @ ( coinductive_ldrop @ B @ N @ Ys ) ) ) )).

% llist_all2_ldropI
thf(fact_131_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),X21: A,X222: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ ( coinductive_LCons @ A @ X21 @ X222 ) )
      = ( F22 @ X21 @ X222 ) ) )).

% llist.simps(5)
thf(fact_132_lfilter__LCons__found,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( P @ X2 )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
        = ( coinductive_LCons @ A @ X2 @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons_found
thf(fact_133_lfilter__LCons__seek,axiom,(
    ! [A: $tType,P4: ( A > $o ),X2: A,L: ( coinductive_llist @ A )] :
      ( ~ ( P4 @ X2 )
     => ( ( coinductive_lfilter @ A @ P4 @ ( coinductive_LCons @ A @ X2 @ L ) )
        = ( coinductive_lfilter @ A @ P4 @ L ) ) ) )).

% lfilter_LCons_seek
thf(fact_134_iterates_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coinductive_iterates @ A )
      = ( ^ [F3: ( A > A ),X3: A] :
            ( coinductive_LCons @ A @ X3 @ ( coinductive_iterates @ A @ F3 @ ( F3 @ X3 ) ) ) ) ) )).

% iterates.code
thf(fact_135_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P4: ( A > $o ),A3: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P4 @ A3 )
     => ( ( coindu1441602521_llist @ A @ B @ P4 @ G21 @ G22 @ A3 )
        = ( coinductive_LCons @ B @ ( G21 @ A3 ) @ ( coindu1441602521_llist @ A @ B @ P4 @ G21 @ G22 @ ( G22 @ A3 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_136_llist_Ocorec_I2_J,axiom,(
    ! [A: $tType,C: $tType,P4: ( C > $o ),A3: C,G21: ( C > A ),Q22: ( C > $o ),G221: ( C > ( coinductive_llist @ A ) ),G222: ( C > C )] :
      ( ~ ( P4 @ A3 )
     => ( ( coindu1259883913_llist @ C @ A @ P4 @ G21 @ Q22 @ G221 @ G222 @ A3 )
        = ( coinductive_LCons @ A @ ( G21 @ A3 ) @ ( if @ ( coinductive_llist @ A ) @ ( Q22 @ A3 ) @ ( G221 @ A3 ) @ ( coindu1259883913_llist @ C @ A @ P4 @ G21 @ Q22 @ G221 @ G222 @ ( G222 @ A3 ) ) ) ) ) ) )).

% llist.corec(2)
thf(fact_137_iterates__equality,axiom,(
    ! [A: $tType,H3: ( A > ( coinductive_llist @ A ) ),F: ( A > A )] :
      ( ! [X: A] :
          ( ( H3 @ X )
          = ( coinductive_LCons @ A @ X @ ( coinductive_lmap @ A @ A @ F @ ( H3 @ X ) ) ) )
     => ( H3
        = ( coinductive_iterates @ A @ F ) ) ) )).

% iterates_equality
thf(fact_138_iterates__lmap,axiom,(
    ! [A: $tType] :
      ( ( coinductive_iterates @ A )
      = ( ^ [F3: ( A > A ),X3: A] :
            ( coinductive_LCons @ A @ X3 @ ( coinductive_lmap @ A @ A @ F3 @ ( coinductive_iterates @ A @ F3 @ X3 ) ) ) ) ) )).

% iterates_lmap
thf(fact_139_ldrop__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ extended_enat @ extended_enat @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ^ [Y2: extended_enat,Z: extended_enat] : ( Y2 = Z )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coinductive_ldrop @ A )
      @ ( coinductive_ldrop @ B ) ) )).

% ldrop_transfer
thf(fact_140_natural_Osize_I1_J,axiom,
    ( ( code_size_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(1)
thf(fact_141_llistsum__LCons,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),X2: A] :
          ( ( coinductive_lfinite @ A @ Xs )
         => ( ( coindu780009021istsum @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) )
            = ( plus_plus @ A @ X2 @ ( coindu780009021istsum @ A @ Xs ) ) ) ) ) )).

% llistsum_LCons
thf(fact_142_llist__all2__lappend1D_I2_J,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_lappend @ A @ Xs @ Xs3 ) @ Ys )
     => ( ( coinductive_lfinite @ A @ Xs )
       => ( coindu1486289336t_all2 @ A @ B @ P @ Xs3 @ ( coinductive_ldrop @ B @ ( coinductive_llength @ A @ Xs ) @ Ys ) ) ) ) )).

% llist_all2_lappend1D(2)
thf(fact_143_natural_Osize_I3_J,axiom,
    ( ( size_size @ code_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(3)
thf(fact_144_lmember__code_I2_J,axiom,(
    ! [A: $tType,X2: A,Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X2 @ ( coinductive_LCons @ A @ Y3 @ Ys ) )
      = ( ( X2 = Y3 )
        | ( coinductive_lmember @ A @ X2 @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_145_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( ( plus_plus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ A3 @ C3 ) )
          = ( B3 = C3 ) ) ) )).

% add_left_cancel
thf(fact_146_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [B3: A,A3: A,C3: A] :
          ( ( ( plus_plus @ A @ B3 @ A3 )
            = ( plus_plus @ A @ C3 @ A3 ) )
          = ( B3 = C3 ) ) ) )).

% add_right_cancel
thf(fact_147_ldrop__ldrop,axiom,(
    ! [A: $tType,N: extended_enat,M: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_ldrop @ A @ N @ ( coinductive_ldrop @ A @ M @ Xs ) )
      = ( coinductive_ldrop @ A @ ( plus_plus @ extended_enat @ N @ M ) @ Xs ) ) )).

% ldrop_ldrop
thf(fact_148_add__cancel__right__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A] :
          ( ( A3
            = ( plus_plus @ A @ A3 @ B3 ) )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_right
thf(fact_149_add__cancel__right__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A] :
          ( ( A3
            = ( plus_plus @ A @ B3 @ A3 ) )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_left
thf(fact_150_add__cancel__left__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A] :
          ( ( ( plus_plus @ A @ A3 @ B3 )
            = A3 )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_right
thf(fact_151_add__cancel__left__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [B3: A,A3: A] :
          ( ( ( plus_plus @ A @ B3 @ A3 )
            = A3 )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_left
thf(fact_152_double__zero__sym,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A3 @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) )).

% double_zero_sym
thf(fact_153_double__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( ( plus_plus @ A @ A3 @ A3 )
            = ( zero_zero @ A ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) )).

% double_zero
thf(fact_154_add_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) )).

% add.right_neutral
thf(fact_155_add_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) )).

% add.left_neutral
thf(fact_156_lappend__code_I2_J,axiom,(
    ! [A: $tType,Xa: A,X2: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_LCons @ A @ Xa @ X2 ) @ Ys )
      = ( coinductive_LCons @ A @ Xa @ ( coinductive_lappend @ A @ X2 @ Ys ) ) ) )).

% lappend_code(2)
thf(fact_157_llength__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_llength @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( plus_plus @ extended_enat @ ( coinductive_llength @ A @ Xs ) @ ( coinductive_llength @ A @ Ys ) ) ) )).

% llength_lappend
thf(fact_158_lfinite__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        & ( coinductive_lfinite @ A @ Ys ) ) ) )).

% lfinite_lappend
thf(fact_159_lprefix__lappend__same,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ ( coinductive_lappend @ A @ Xs @ Zs ) )
      = ( ( coinductive_lfinite @ A @ Xs )
       => ( coinductive_lprefix @ A @ Ys @ Zs ) ) ) )).

% lprefix_lappend_same
thf(fact_160_lfilter__lappend__lfinite,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
        = ( coinductive_lappend @ A @ ( coinductive_lfilter @ A @ P @ Xs ) @ ( coinductive_lfilter @ A @ P @ Ys ) ) ) ) )).

% lfilter_lappend_lfinite
thf(fact_161_lappend__ltakeWhile__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = Xs ) )).

% lappend_ltakeWhile_ldropWhile
thf(fact_162_llcp__lappend__same,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_llcp @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ ( coinductive_lappend @ A @ Xs @ Zs ) )
      = ( plus_plus @ extended_enat @ ( coinductive_llength @ A @ Xs ) @ ( coinductive_llcp @ A @ Ys @ Zs ) ) ) )).

% llcp_lappend_same
thf(fact_163_lprefix__lappend,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ Xs @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )).

% lprefix_lappend
thf(fact_164_lappend__lprefixE,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
     => ~ ( ! [Zs2: ( coinductive_llist @ A )] :
              ( Zs
             != ( coinductive_lappend @ A @ Xs @ Zs2 ) ) ) ) )).

% lappend_lprefixE
thf(fact_165_lprefix__lappendD,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) )
     => ( ( coinductive_lprefix @ A @ Xs @ Ys )
        | ( coinductive_lprefix @ A @ Ys @ Xs ) ) ) )).

% lprefix_lappendD
thf(fact_166_lprefix__conv__lappend,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lprefix @ A )
      = ( ^ [Xs2: ( coinductive_llist @ A ),Ys2: ( coinductive_llist @ A )] :
          ? [Zs3: ( coinductive_llist @ A )] :
            ( Ys2
            = ( coinductive_lappend @ A @ Xs2 @ Zs3 ) ) ) ) )).

% lprefix_conv_lappend
thf(fact_167_lprefix__lappend__sameI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lprefix @ A @ Xs @ Ys )
     => ( coinductive_lprefix @ A @ ( coinductive_lappend @ A @ Zs @ Xs ) @ ( coinductive_lappend @ A @ Zs @ Ys ) ) ) )).

% lprefix_lappend_sameI
thf(fact_168_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) )).

% comm_monoid_add_class.add_0
thf(fact_169_add_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) )).

% add.comm_neutral
thf(fact_170_add_Ogroup__left__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) )).

% add.group_left_neutral
thf(fact_171_add__eq__0__iff__both__eq__0,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type @ A ) )
     => ! [X2: A,Y3: A] :
          ( ( ( plus_plus @ A @ X2 @ Y3 )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y3
              = ( zero_zero @ A ) ) ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_172_lappend__inf,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ~ ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_lappend @ A @ Xs @ Ys )
        = Xs ) ) )).

% lappend_inf
thf(fact_173_llistsum__lappend,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
          ( ( coinductive_lfinite @ A @ Xs )
         => ( ( coinductive_lfinite @ A @ Ys )
           => ( ( coindu780009021istsum @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) )
              = ( plus_plus @ A @ ( coindu780009021istsum @ A @ Xs ) @ ( coindu780009021istsum @ A @ Ys ) ) ) ) ) ) )).

% llistsum_lappend
thf(fact_174_lmap__lappend__distrib,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B ),Ys: ( coinductive_llist @ B )] :
      ( ( coinductive_lmap @ B @ A @ F @ ( coinductive_lappend @ B @ Xs @ Ys ) )
      = ( coinductive_lappend @ A @ ( coinductive_lmap @ B @ A @ F @ Xs ) @ ( coinductive_lmap @ B @ A @ F @ Ys ) ) ) )).

% lmap_lappend_distrib
thf(fact_175_lappend__assoc,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) @ Zs )
      = ( coinductive_lappend @ A @ Xs @ ( coinductive_lappend @ A @ Ys @ Zs ) ) ) )).

% lappend_assoc
thf(fact_176_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B3 ) @ C3 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_177_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_178_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A3 @ B3 ) @ C3 )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% add.assoc
thf(fact_179_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( ( plus_plus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ A3 @ C3 ) )
          = ( B3 = C3 ) ) ) )).

% add.left_cancel
thf(fact_180_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type @ A ) )
     => ! [B3: A,A3: A,C3: A] :
          ( ( ( plus_plus @ A @ B3 @ A3 )
            = ( plus_plus @ A @ C3 @ A3 ) )
          = ( B3 = C3 ) ) ) )).

% add.right_cancel
thf(fact_181_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B5: A] :
              ( plus_plus @ A @ B5 @ A5 ) ) ) ) )).

% add.commute
thf(fact_182_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type @ A ) )
     => ! [B3: A,A3: A,C3: A] :
          ( ( plus_plus @ A @ B3 @ ( plus_plus @ A @ A3 @ C3 ) )
          = ( plus_plus @ A @ A3 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% add.left_commute
thf(fact_183_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [A3: A,B3: A,C3: A] :
          ( ( ( plus_plus @ A @ A3 @ B3 )
            = ( plus_plus @ A @ A3 @ C3 ) )
         => ( B3 = C3 ) ) ) )).

% add_left_imp_eq
thf(fact_184_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [B3: A,A3: A,C3: A] :
          ( ( ( plus_plus @ A @ B3 @ A3 )
            = ( plus_plus @ A @ C3 @ A3 ) )
         => ( B3 = C3 ) ) ) )).

% add_right_imp_eq
thf(fact_185_lappend__iterates,axiom,(
    ! [A: $tType,F: ( A > A ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_iterates @ A @ F @ X2 ) @ Xs )
      = ( coinductive_iterates @ A @ F @ X2 ) ) )).

% lappend_iterates
thf(fact_186_lmirror__aux__acc,axiom,(
    ! [A: $tType,Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( lMirro999291890or_aux @ A @ ( coinductive_lappend @ A @ Ys @ Zs ) @ Xs )
      = ( coinductive_lappend @ A @ ( lMirro999291890or_aux @ A @ Ys @ Xs ) @ Zs ) ) )).

% lmirror_aux_acc
thf(fact_187_llist__all2__lappendI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Xs3: ( coinductive_llist @ A ),Ys4: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( ( coinductive_lfinite @ A @ Xs )
         => ( ( coinductive_lfinite @ B @ Ys )
           => ( coindu1486289336t_all2 @ A @ B @ P @ Xs3 @ Ys4 ) ) )
       => ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_lappend @ A @ Xs @ Xs3 ) @ ( coinductive_lappend @ B @ Ys @ Ys4 ) ) ) ) )).

% llist_all2_lappendI
thf(fact_188_lappend__eq__lappend__conv,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Us: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Vs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_llength @ A @ Xs )
        = ( coinductive_llength @ A @ Us ) )
     => ( ( ( coinductive_lappend @ A @ Xs @ Ys )
          = ( coinductive_lappend @ A @ Us @ Vs ) )
        = ( ( Xs = Us )
          & ( ( coinductive_lfinite @ A @ Xs )
           => ( Ys = Vs ) ) ) ) ) )).

% lappend_eq_lappend_conv
thf(fact_189_lfilter__eq__lappend__lfiniteD,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),Zs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_lappend @ A @ Ys @ Zs ) )
     => ( ( coinductive_lfinite @ A @ Ys )
       => ? [Us2: ( coinductive_llist @ A ),Vs2: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_lappend @ A @ Us2 @ Vs2 ) )
            & ( coinductive_lfinite @ A @ Us2 )
            & ( Ys
              = ( coinductive_lfilter @ A @ P @ Us2 ) )
            & ( Zs
              = ( coinductive_lfilter @ A @ P @ Vs2 ) ) ) ) ) )).

% lfilter_eq_lappend_lfiniteD
thf(fact_190_lappend__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) ) @ ( coinductive_lappend @ A ) @ ( coinductive_lappend @ B ) ) )).

% lappend_transfer
thf(fact_191_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) )).

% add_is_0
thf(fact_192_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) )).

% Nat.add_0_right
thf(fact_193_natural_Osimps_I4_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T )] :
      ( ( code_case_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(4)
thf(fact_194_plus__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > nat ) @ ( nat > nat )
    @ ^ [Y2: nat,Z: nat] : ( Y2 = Z )
    @ ( bNF_rel_fun @ nat @ nat @ nat @ nat
      @ ^ [Y2: nat,Z: nat] : ( Y2 = Z )
      @ ^ [Y2: nat,Z: nat] : ( Y2 = Z ) )
    @ ( plus_plus @ nat )
    @ ( plus_plus @ nat ) )).

% plus_natural.rsp
thf(fact_195_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) )).

% add_eq_self_zero
thf(fact_196_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_197_ind__euclid,axiom,(
    ! [P: ( nat > nat > $o ),A3: nat,B3: nat] :
      ( ! [A4: nat,B4: nat] :
          ( ( P @ A4 @ B4 )
          = ( P @ B4 @ A4 ) )
     => ( ! [A4: nat] :
            ( P @ A4 @ ( zero_zero @ nat ) )
       => ( ! [A4: nat,B4: nat] :
              ( ( P @ A4 @ B4 )
             => ( P @ A4 @ ( plus_plus @ nat @ A4 @ B4 ) ) )
         => ( P @ A3 @ B3 ) ) ) ) )).

% ind_euclid
thf(fact_198_add__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type @ A ) )
     => ! [B3: A,A3: A] :
          ( ( B3
            = ( plus_plus @ A @ B3 @ A3 ) )
          = ( A3
            = ( zero_zero @ A ) ) ) ) )).

% add_0_iff
thf(fact_199_semiring__normalization__rules_I6_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ A3 @ ( zero_zero @ A ) )
          = A3 ) ) )).

% semiring_normalization_rules(6)
thf(fact_200_semiring__normalization__rules_I5_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type @ A ) )
     => ! [A3: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A3 )
          = A3 ) ) )).

% semiring_normalization_rules(5)
thf(fact_201_llast__lappend__LCons,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Y3: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ Xs )
     => ( ( coinductive_llast @ A @ ( coinductive_lappend @ A @ Xs @ ( coinductive_LCons @ A @ Y3 @ Ys ) ) )
        = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y3 @ Ys ) ) ) ) )).

% llast_lappend_LCons
thf(fact_202_rec__nat__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( nat > A > A ) > nat > A ) @ ( ( nat > B > B ) > nat > B ) @ A2
      @ ( bNF_rel_fun @ ( nat > A > A ) @ ( nat > B > B ) @ ( nat > A ) @ ( nat > B )
        @ ( bNF_rel_fun @ nat @ nat @ ( A > A ) @ ( B > B )
          @ ^ [Y2: nat,Z: nat] : ( Y2 = Z )
          @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) )
        @ ( bNF_rel_fun @ nat @ nat @ A @ B
          @ ^ [Y2: nat,Z: nat] : ( Y2 = Z )
          @ A2 ) )
      @ ( rec_nat @ A )
      @ ( rec_nat @ B ) ) )).

% rec_nat_transfer
thf(fact_203_llast__LCons2,axiom,(
    ! [A: $tType,X2: A,Y3: A,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_llast @ A @ ( coinductive_LCons @ A @ X2 @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) )
      = ( coinductive_llast @ A @ ( coinductive_LCons @ A @ Y3 @ Xs ) ) ) )).

% llast_LCons2
thf(fact_204_old_Onat_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F22: ( nat > T > T )] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) )).

% old.nat.simps(6)
thf(fact_205_case__nat__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( nat > A ) > nat > A ) @ ( ( nat > B ) > nat > B ) @ A2
      @ ( bNF_rel_fun @ ( nat > A ) @ ( nat > B ) @ ( nat > A ) @ ( nat > B )
        @ ( bNF_rel_fun @ nat @ nat @ A @ B
          @ ^ [Y2: nat,Z: nat] : ( Y2 = Z )
          @ A2 )
        @ ( bNF_rel_fun @ nat @ nat @ A @ B
          @ ^ [Y2: nat,Z: nat] : ( Y2 = Z )
          @ A2 ) )
      @ ( case_nat @ A )
      @ ( case_nat @ B ) ) )).

% case_nat_transfer
thf(fact_206_natural_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T > T )] :
      ( ( code_rec_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(6)
thf(fact_207_old_Onat_Osimps_I4_J,axiom,(
    ! [A: $tType,F1: A,F22: ( nat > A )] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) )).

% old.nat.simps(4)
thf(fact_208_ltake__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ extended_enat @ extended_enat @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ^ [Y2: extended_enat,Z: extended_enat] : ( Y2 = Z )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coinductive_ltake @ A )
      @ ( coinductive_ltake @ B ) ) )).

% ltake_transfer
thf(fact_209_lfilter__eq__LConsD,axiom,(
    ! [A: $tType,P: ( A > $o ),Ys: ( coinductive_llist @ A ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Ys )
        = ( coinductive_LCons @ A @ X2 @ Xs ) )
     => ? [Us2: ( coinductive_llist @ A ),Vs2: ( coinductive_llist @ A )] :
          ( ( Ys
            = ( coinductive_lappend @ A @ Us2 @ ( coinductive_LCons @ A @ X2 @ Vs2 ) ) )
          & ( coinductive_lfinite @ A @ Us2 )
          & ! [X5: A] :
              ( ( member @ A @ X5 @ ( coinductive_lset @ A @ Us2 ) )
             => ~ ( P @ X5 ) )
          & ( P @ X2 )
          & ( Xs
            = ( coinductive_lfilter @ A @ P @ Vs2 ) ) ) ) )).

% lfilter_eq_LConsD
thf(fact_210_ltake__is__lprefix,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( coinductive_lprefix @ A @ ( coinductive_ltake @ A @ N @ Xs ) @ Xs ) )).

% ltake_is_lprefix
thf(fact_211_llist__all2__same,axiom,(
    ! [A: $tType,P: ( A > A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coindu1486289336t_all2 @ A @ A @ P @ Xs @ Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X3 @ X3 ) ) ) ) )).

% llist_all2_same
thf(fact_212_ltake__lmap,axiom,(
    ! [A: $tType,B: $tType,N: extended_enat,F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_ltake @ A @ N @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lmap @ B @ A @ F @ ( coinductive_ltake @ B @ N @ Xs ) ) ) )).

% ltake_lmap
thf(fact_213_ldropWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X )
              = ( Q @ X ) ) )
       => ( ( coindu218763757pWhile @ A @ P @ Xs )
          = ( coindu218763757pWhile @ A @ Q @ Ys ) ) ) ) )).

% ldropWhile_cong
thf(fact_214_in__lset__ldropWhileD,axiom,(
    ! [A: $tType,X2: A,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ldropWhileD
thf(fact_215_llist_Opred__cong,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Ya: ( coinductive_llist @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X2 = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ Ya ) )
           => ( ( P @ Z3 )
              = ( Pa @ Z3 ) ) )
       => ( ( coindu543516966_llist @ A @ P @ X2 )
          = ( coindu543516966_llist @ A @ Pa @ Ya ) ) ) ) )).

% llist.pred_cong
thf(fact_216_llist_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: ( coinductive_llist @ A ),Pa: ( A > $o )] :
      ( ( coindu543516966_llist @ A @ P @ X2 )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ X2 ) )
           => ( ( P @ Z3 )
             => ( Pa @ Z3 ) ) )
       => ( coindu543516966_llist @ A @ Pa @ X2 ) ) ) )).

% llist.pred_mono_strong
thf(fact_217_lset__ltakeWhileD,axiom,(
    ! [A: $tType,X2: A,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
        & ( P @ X2 ) ) ) )).

% lset_ltakeWhileD
thf(fact_218_ltakeWhile__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X )
              = ( Q @ X ) ) )
       => ( ( coindu501562517eWhile @ A @ P @ Xs )
          = ( coindu501562517eWhile @ A @ Q @ Ys ) ) ) ) )).

% ltakeWhile_cong
thf(fact_219_ltakeWhile__all,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > $o )] :
      ( ! [X: A] :
          ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
         => ( P @ X ) )
     => ( ( coindu501562517eWhile @ A @ P @ Xs )
        = Xs ) ) )).

% ltakeWhile_all
thf(fact_220_lfilter__cong,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( Xs = Ys )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( coinductive_lset @ A @ Ys ) )
           => ( ( P @ X )
              = ( Q @ X ) ) )
       => ( ( coinductive_lfilter @ A @ P @ Xs )
          = ( coinductive_lfilter @ A @ Q @ Ys ) ) ) ) )).

% lfilter_cong
thf(fact_221_lfilter__id__conv,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = Xs )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
           => ( P @ X3 ) ) ) ) )).

% lfilter_id_conv
thf(fact_222_llist_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,X2: ( coinductive_llist @ A ),Xa: ( coinductive_llist @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( coinductive_lset @ A @ Xa ) )
           => ( ( ( F @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( coinductive_lmap @ A @ B @ F @ X2 )
          = ( coinductive_lmap @ A @ B @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% llist.inj_map_strong
thf(fact_223_llist_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,X2: ( coinductive_llist @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ X2 ) )
         => ( ( F @ Z3 )
            = ( G @ Z3 ) ) )
     => ( ( coinductive_lmap @ A @ B @ F @ X2 )
        = ( coinductive_lmap @ A @ B @ G @ X2 ) ) ) )).

% llist.map_cong0
thf(fact_224_llist_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,X2: ( coinductive_llist @ A ),Ya: ( coinductive_llist @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ Ya ) )
           => ( ( F @ Z3 )
              = ( G @ Z3 ) ) )
       => ( ( coinductive_lmap @ A @ B @ F @ X2 )
          = ( coinductive_lmap @ A @ B @ G @ Ya ) ) ) ) )).

% llist.map_cong
thf(fact_225_llist_Orel__refl__strong,axiom,(
    ! [A: $tType,X2: ( coinductive_llist @ A ),Ra: ( A > A > $o )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ X2 ) )
         => ( Ra @ Z3 @ Z3 ) )
     => ( coindu1486289336t_all2 @ A @ A @ Ra @ X2 @ X2 ) ) )).

% llist.rel_refl_strong
thf(fact_226_llist_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X2: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ B ),Ra: ( A > B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ R @ X2 @ Y3 )
     => ( ! [Z3: A,Yb2: B] :
            ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ X2 ) )
           => ( ( member @ B @ Yb2 @ ( coinductive_lset @ B @ Y3 ) )
             => ( ( R @ Z3 @ Yb2 )
               => ( Ra @ Z3 @ Yb2 ) ) ) )
       => ( coindu1486289336t_all2 @ A @ B @ Ra @ X2 @ Y3 ) ) ) )).

% llist.rel_mono_strong
thf(fact_227_llist_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,X2: ( coinductive_llist @ A ),Ya: ( coinductive_llist @ A ),Y3: ( coinductive_llist @ B ),Xa: ( coinductive_llist @ B ),R: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( X2 = Ya )
     => ( ( Y3 = Xa )
       => ( ! [Z3: A,Yb2: B] :
              ( ( member @ A @ Z3 @ ( coinductive_lset @ A @ Ya ) )
             => ( ( member @ B @ Yb2 @ ( coinductive_lset @ B @ Xa ) )
               => ( ( R @ Z3 @ Yb2 )
                  = ( Ra @ Z3 @ Yb2 ) ) ) )
         => ( ( coindu1486289336t_all2 @ A @ B @ R @ X2 @ Y3 )
            = ( coindu1486289336t_all2 @ A @ B @ Ra @ Ya @ Xa ) ) ) ) ) )).

% llist.rel_cong
thf(fact_228_llist__all2__lsetD2,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Y3: B] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( member @ B @ Y3 @ ( coinductive_lset @ B @ Ys ) )
       => ? [X: A] :
            ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
            & ( P @ X @ Y3 ) ) ) ) )).

% llist_all2_lsetD2
thf(fact_229_llist__all2__lsetD1,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),X2: A] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
       => ? [X: B] :
            ( ( member @ B @ X @ ( coinductive_lset @ B @ Ys ) )
            & ( P @ X2 @ X ) ) ) ) )).

% llist_all2_lsetD1
thf(fact_230_llist__all2__reflI,axiom,(
    ! [A: $tType,Xs: ( coinductive_llist @ A ),P: ( A > A > $o )] :
      ( ! [X: A] :
          ( ( member @ A @ X @ ( coinductive_lset @ A @ Xs ) )
         => ( P @ X @ X ) )
     => ( coindu1486289336t_all2 @ A @ A @ P @ Xs @ Xs ) ) )).

% llist_all2_reflI
thf(fact_231_llist__all2__ltakeI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),N: extended_enat] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_ltake @ A @ N @ Xs ) @ ( coinductive_ltake @ B @ N @ Ys ) ) ) )).

% llist_all2_ltakeI
thf(fact_232_lset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),X6: A] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X6 @ Xs ) ) ) ) )).

% lset_intros(2)
thf(fact_233_lset__intros_I1_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ X2 @ Xs ) ) ) )).

% lset_intros(1)
thf(fact_234_llist_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,A22: ( coinductive_llist @ A ),A1: A] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ A22 ) )
     => ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) ) )).

% llist.set_intros(2)
thf(fact_235_llist_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( coinductive_llist @ A )] :
      ( member @ A @ A1 @ ( coinductive_lset @ A @ ( coinductive_LCons @ A @ A1 @ A22 ) ) ) )).

% llist.set_intros(1)
thf(fact_236_lset__cases,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs5: ( coinductive_llist @ A )] :
            ( Xs
           != ( coinductive_LCons @ A @ X2 @ Xs5 ) )
       => ~ ( ! [X7: A,Xs5: ( coinductive_llist @ A )] :
                ( ( Xs
                  = ( coinductive_LCons @ A @ X7 @ Xs5 ) )
               => ~ ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs5 ) ) ) ) ) ) )).

% lset_cases
thf(fact_237_lset__induct,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs6: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X2 @ Xs6 ) )
       => ( ! [X7: A,Xs6: ( coinductive_llist @ A )] :
              ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs6 ) )
             => ( ( X2 != X7 )
               => ( ( P @ Xs6 )
                 => ( P @ ( coinductive_LCons @ A @ X7 @ Xs6 ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct
thf(fact_238_lset__induct_H,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),P: ( ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ( ! [Xs6: ( coinductive_llist @ A )] :
            ( P @ ( coinductive_LCons @ A @ X2 @ Xs6 ) )
       => ( ! [X7: A,Xs6: ( coinductive_llist @ A )] :
              ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs6 ) )
             => ( ( P @ Xs6 )
               => ( P @ ( coinductive_LCons @ A @ X7 @ Xs6 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% lset_induct'
thf(fact_239_in__lset__ldropD,axiom,(
    ! [A: $tType,X2: A,N: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coinductive_ldrop @ A @ N @ Xs ) ) )
     => ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) ) ) )).

% in_lset_ldropD
thf(fact_240_llist_Oset__cases,axiom,(
    ! [A: $tType,E2: A,A3: ( coinductive_llist @ A )] :
      ( ( member @ A @ E2 @ ( coinductive_lset @ A @ A3 ) )
     => ( ! [Z22: ( coinductive_llist @ A )] :
            ( A3
           != ( coinductive_LCons @ A @ E2 @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
                ( ( A3
                  = ( coinductive_LCons @ A @ Z1 @ Z22 ) )
               => ~ ( member @ A @ E2 @ ( coinductive_lset @ A @ Z22 ) ) ) ) ) ) )).

% llist.set_cases
thf(fact_241_llist_Oset__induct,axiom,(
    ! [A: $tType,X2: A,A3: ( coinductive_llist @ A ),P: ( A > ( coinductive_llist @ A ) > $o )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ A3 ) )
     => ( ! [Z1: A,Z22: ( coinductive_llist @ A )] :
            ( P @ Z1 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) )
       => ( ! [Z1: A,Z22: ( coinductive_llist @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( coinductive_lset @ A @ Z22 ) )
             => ( ( P @ Xa2 @ Z22 )
               => ( P @ Xa2 @ ( coinductive_LCons @ A @ Z1 @ Z22 ) ) ) )
         => ( P @ X2 @ A3 ) ) ) ) )).

% llist.set_induct
thf(fact_242_lset__lmirror__aux,axiom,(
    ! [A: $tType,Acc: ( coinductive_llist @ A ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lset @ A @ ( lMirro999291890or_aux @ A @ Acc @ Xs ) )
      = ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Acc ) ) ) )).

% lset_lmirror_aux
thf(fact_243_lfinite__ldropWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu218763757pWhile @ A @ P @ Xs ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X3 ) )
       => ( coinductive_lfinite @ A @ Xs ) ) ) )).

% lfinite_ldropWhile
thf(fact_244_lfinite__ltakeWhile,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfinite @ A @ ( coindu501562517eWhile @ A @ P @ Xs ) )
      = ( ( coinductive_lfinite @ A @ Xs )
        | ? [X3: A] :
            ( ( member @ A @ X3 @ ( coinductive_lset @ A @ Xs ) )
            & ~ ( P @ X3 ) ) ) ) )).

% lfinite_ltakeWhile
thf(fact_245_ltakeWhile__lappend1,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),P: ( A > $o ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ( ~ ( P @ X2 )
       => ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lappend @ A @ Xs @ Ys ) )
          = ( coindu501562517eWhile @ A @ P @ Xs ) ) ) ) )).

% ltakeWhile_lappend1
thf(fact_246_in__lset__lappend__iff,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ ( coinductive_lappend @ A @ Xs @ Ys ) ) )
      = ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
        | ( ( coinductive_lfinite @ A @ Xs )
          & ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys ) ) ) ) ) )).

% in_lset_lappend_iff
thf(fact_247_lappend__ltake__ldrop,axiom,(
    ! [A: $tType,N: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lappend @ A @ ( coinductive_ltake @ A @ N @ Xs ) @ ( coinductive_ldrop @ A @ N @ Xs ) )
      = Xs ) )).

% lappend_ltake_ldrop
thf(fact_248_lset__lmember,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
      = ( coinductive_lmember @ A @ X2 @ Xs ) ) )).

% lset_lmember
thf(fact_249_ltake__ldrop,axiom,(
    ! [A: $tType,N: extended_enat,M: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_ltake @ A @ N @ ( coinductive_ldrop @ A @ M @ Xs ) )
      = ( coinductive_ldrop @ A @ M @ ( coinductive_ltake @ A @ ( plus_plus @ extended_enat @ N @ M ) @ Xs ) ) ) )).

% ltake_ldrop
thf(fact_250_llist__all2__lappend1D_I1_J,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Xs3: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_lappend @ A @ Xs @ Xs3 ) @ Ys )
     => ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ ( coinductive_ltake @ B @ ( coinductive_llength @ A @ Xs ) @ Ys ) ) ) )).

% llist_all2_lappend1D(1)
thf(fact_251_split__llist__first,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys5: ( coinductive_llist @ A ),Zs4: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys5 @ ( coinductive_LCons @ A @ X2 @ Zs4 ) ) )
          & ( coinductive_lfinite @ A @ Ys5 )
          & ~ ( member @ A @ X2 @ ( coinductive_lset @ A @ Ys5 ) ) ) ) )).

% split_llist_first
thf(fact_252_split__llist,axiom,(
    ! [A: $tType,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( member @ A @ X2 @ ( coinductive_lset @ A @ Xs ) )
     => ? [Ys5: ( coinductive_llist @ A ),Zs4: ( coinductive_llist @ A )] :
          ( ( Xs
            = ( coinductive_lappend @ A @ Ys5 @ ( coinductive_LCons @ A @ X2 @ Zs4 ) ) )
          & ( coinductive_lfinite @ A @ Ys5 ) ) ) )).

% split_llist
thf(fact_253_ltake__plus__conv__lappend,axiom,(
    ! [A: $tType,N: extended_enat,M: extended_enat,Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_ltake @ A @ ( plus_plus @ extended_enat @ N @ M ) @ Xs )
      = ( coinductive_lappend @ A @ ( coinductive_ltake @ A @ N @ Xs ) @ ( coinductive_ltake @ A @ M @ ( coinductive_ldrop @ A @ N @ Xs ) ) ) ) )).

% ltake_plus_conv_lappend

%----Type constructors (28)
thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    ( semiri456707255roduct @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add,axiom,
    ( comm_monoid_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1,axiom,
    ( comm_semiring_1 @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add,axiom,
    ( monoid_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type @ nat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_1,axiom,
    ( canoni770627133id_add @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_2,axiom,
    ( ordere779506340up_add @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_3,axiom,
    ( ab_semigroup_add @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_4,axiom,
    ( comm_monoid_add @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_5,axiom,
    ( comm_semiring_1 @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_6,axiom,
    ( semigroup_add @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_7,axiom,
    ( monoid_add @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_8,axiom,
    ( zero @ extended_enat @ ( type @ extended_enat ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_9,axiom,
    ( ordere779506340up_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_10,axiom,
    ( cancel1352612707id_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_11,axiom,
    ( cancel_semigroup_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_12,axiom,
    ( ab_semigroup_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_13,axiom,
    ( comm_monoid_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_14,axiom,
    ( comm_semiring_1 @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_15,axiom,
    ( semigroup_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_16,axiom,
    ( monoid_add @ code_natural @ ( type @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_17,axiom,
    ( zero @ code_natural @ ( type @ code_natural ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y3: A] :
      ( ( if @ A @ $false @ X2 @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y3: A] :
      ( ( if @ A @ $true @ X2 @ Y3 )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( coinductive_llength @ a @ acca )
    = ( coinductive_llength @ b @ acc_a ) )).

%------------------------------------------------------------------------------
