%------------------------------------------------------------------------------
% File     : DAT198^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Lazy list mirror 164
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Loc10] Lochbihler (2010), Coinductive
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : lmirror__164.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  306 (   0 unit;  46 type;   0 defn)
%            Number of atoms       : 6518 ( 306 equality;4661 variable)
%            Maximal formula depth :   32 (  13 average)
%            Number of connectives : 5116 (  17   ~;   2   |;  30   &;4807   @)
%                                         (   0 <=>; 260  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  : 1562 (1562   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   52 (  46   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1739 (   0 sgn;1391   !;  18   ?; 262   ^)
%                                         (1739   :;  68  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:42:04.265
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_Coinductive__List_Ollist,type,(
    coinductive_llist: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (42)
thf(sy_c_BNF__Def_Orel__fun,type,(
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) )).

thf(sy_c_Coinductive__List_Oiterates,type,(
    coinductive_iterates: 
      !>[A: $tType] :
        ( ( A > A ) > A > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_OldropWhile,type,(
    coindu218763757pWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Olfilter,type,(
    coinductive_lfilter: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_OLCons,type,(
    coinductive_LCons: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Ocase__llist,type,(
    coindu1381640503_llist: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( coinductive_llist @ A ) > B ) > ( coinductive_llist @ A ) > B ) )).

thf(sy_c_Coinductive__List_Ollist_Ocorec__llist,type,(
    coindu1259883913_llist: 
      !>[C: $tType,A: $tType] :
        ( ( C > $o ) > ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ollist_Olhd,type,(
    coinductive_lhd: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > A ) )).

thf(sy_c_Coinductive__List_Ollist_Ollist__all2,type,(
    coindu1486289336t_all2: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > $o ) )).

thf(sy_c_Coinductive__List_Ollist_Olmap,type,(
    coinductive_lmap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( coinductive_llist @ A ) > ( coinductive_llist @ Aa ) ) )).

thf(sy_c_Coinductive__List_Ollist_Opred__llist,type,(
    coindu543516966_llist: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_Olmember,type,(
    coinductive_lmember: 
      !>[A: $tType] :
        ( A > ( coinductive_llist @ A ) > $o ) )).

thf(sy_c_Coinductive__List_OltakeWhile,type,(
    coindu501562517eWhile: 
      !>[A: $tType] :
        ( ( A > $o ) > ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Coinductive__List_Ounfold__llist,type,(
    coindu1441602521_llist: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( A > B ) > ( A > A ) > A > ( coinductive_llist @ B ) ) )).

thf(sy_c_Complete__Partial__Order_Omonotone,type,(
    comple1396247847notone: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Fun_Omap__fun,type,(
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] :
        ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) )).

thf(sy_c_Fun_Oswap,type,(
    swap: 
      !>[A: $tType,B: $tType] :
        ( A > A > ( A > B ) > A > B ) )).

thf(sy_c_HOL_OEx1,type,(
    ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > $o ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_LMirror__Mirabelle__wyovfcktfy_Olmirror,type,(
    lMirro427583474mirror: 
      !>[A: $tType] :
        ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Partial__Function_Ofun__ord,type,(
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Quotient_OBex1__rel,type,(
    bex1_rel: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > $o ) )).

thf(sy_c_Quotient_OQuotient3,type,(
    quotient3: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) )).

thf(sy_c_Relation_ODomainp,type,(
    domainp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > A > $o ) )).

thf(sy_c_Relation_Oreflp,type,(
    reflp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > $o ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Transfer_Obi__total,type,(
    bi_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Obi__unique,type,(
    bi_unique: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Oleft__total,type,(
    left_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Oleft__unique,type,(
    left_unique: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Orev__implies,type,(
    rev_implies: $o > $o > $o )).

thf(sy_c_Transfer_Oright__total,type,(
    right_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Oright__unique,type,(
    right_unique: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Otransfer__bforall,type,(
    transfer_bforall: 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > $o ) > $o ) )).

thf(sy_c_Transfer_Otransfer__forall,type,(
    transfer_forall: 
      !>[A: $tType] :
        ( ( A > $o ) > $o ) )).

thf(sy_c_Transitive__Closure_Ortranclp,type,(
    transitive_rtranclp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > A > $o ) )).

thf(sy_v_A,type,(
    a2: a > b > $o )).

%----Relevant facts (256)
thf(fact_0_llist__all2__lmirror,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ ( lMirro427583474mirror @ A @ Xs ) @ ( lMirro427583474mirror @ B @ Ys ) )
      = ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys ) ) )).

% llist_all2_lmirror
thf(fact_1_llist__all2__lmirrorD,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ ( lMirro427583474mirror @ A @ Xs ) @ ( lMirro427583474mirror @ B @ Ys ) )
     => ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys ) ) )).

% llist_all2_lmirrorD
thf(fact_2_llist__all2__lmirrorI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( coindu1486289336t_all2 @ A @ B @ P @ ( lMirro427583474mirror @ A @ Xs ) @ ( lMirro427583474mirror @ B @ Ys ) ) ) )).

% llist_all2_lmirrorI
thf(fact_3_rel__funI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D )] :
      ( ! [X: A,Y: B] :
          ( ( A2 @ X @ Y )
         => ( B2 @ ( F @ X ) @ ( G @ Y ) ) )
     => ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F @ G ) ) )).

% rel_funI
thf(fact_4_llist__all2__rsp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),S: ( A > A > $o ),T: ( B > B > $o ),X2: ( coinductive_llist @ A ),Y2: ( coinductive_llist @ B ),A3: ( coinductive_llist @ A ),B3: ( coinductive_llist @ B )] :
      ( ! [X: A,Y: B] :
          ( ( R @ X @ Y )
         => ! [A4: A,B4: B] :
              ( ( R @ A4 @ B4 )
             => ( ( S @ X @ A4 )
                = ( T @ Y @ B4 ) ) ) )
     => ( ( coindu1486289336t_all2 @ A @ B @ R @ X2 @ Y2 )
       => ( ( coindu1486289336t_all2 @ A @ B @ R @ A3 @ B3 )
         => ( ( coindu1486289336t_all2 @ A @ A @ S @ X2 @ A3 )
            = ( coindu1486289336t_all2 @ B @ B @ T @ Y2 @ B3 ) ) ) ) ) )).

% llist_all2_rsp
thf(fact_5_llist__all2__mono,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),P2: ( A > B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( P2 @ X @ Y ) )
       => ( coindu1486289336t_all2 @ A @ B @ P2 @ Xs @ Ys ) ) ) )).

% llist_all2_mono
thf(fact_6_llist_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( coindu1486289336t_all2 @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( coinductive_llist @ A ),Z: ( coinductive_llist @ A )] : ( Y3 = Z ) ) ) )).

% llist.rel_eq
thf(fact_7_llist_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X2: ( coinductive_llist @ B )] :
      ( ! [X: B] :
          ( Ra @ X @ X )
     => ( coindu1486289336t_all2 @ B @ B @ Ra @ X2 @ X2 ) ) )).

% llist.rel_refl
thf(fact_8_rel__funD,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X2: A,Y2: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F @ G )
     => ( ( A2 @ X2 @ Y2 )
       => ( B2 @ ( F @ X2 ) @ ( G @ Y2 ) ) ) ) )).

% rel_funD
thf(fact_9_let__rsp,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ R1 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 ) @ R2 )
      @ ^ [S2: A,F2: ( A > C )] :
          ( F2 @ S2 )
      @ ^ [S2: B,F2: ( B > D )] :
          ( F2 @ S2 ) ) )).

% let_rsp
thf(fact_10_rel__funE,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X2: A,Y2: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 @ F @ G )
     => ( ( A2 @ X2 @ Y2 )
       => ( B2 @ ( F @ X2 ) @ ( G @ Y2 ) ) ) ) )).

% rel_funE
thf(fact_11_apply__rsp_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X2: A,Y2: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 @ F @ G )
     => ( ( R1 @ X2 @ Y2 )
       => ( R2 @ ( F @ X2 ) @ ( G @ Y2 ) ) ) ) )).

% apply_rsp'
thf(fact_12_rel__funD2,axiom,(
    ! [B: $tType,C: $tType,A: $tType,A2: ( A > A > $o ),B2: ( B > C > $o ),F: ( A > B ),G: ( A > C ),X2: A] :
      ( ( bNF_rel_fun @ A @ A @ B @ C @ A2 @ B2 @ F @ G )
     => ( ( A2 @ X2 @ X2 )
       => ( B2 @ ( F @ X2 ) @ ( G @ X2 ) ) ) ) )).

% rel_funD2
thf(fact_13_rel__fun__mono,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,X3: ( A > B > $o ),A2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),Y4: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ X3 @ A2 @ F @ G )
     => ( ! [X: A,Y: B] :
            ( ( Y4 @ X @ Y )
           => ( X3 @ X @ Y ) )
       => ( ! [X: C,Y: D] :
              ( ( A2 @ X @ Y )
             => ( B2 @ X @ Y ) )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y4 @ B2 @ F @ G ) ) ) ) )).

% rel_fun_mono
thf(fact_14_rel__fun__mono_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Y4: ( A > B > $o ),X3: ( A > B > $o ),A2: ( C > D > $o ),B2: ( C > D > $o ),F: ( A > C ),G: ( B > D )] :
      ( ! [X: A,Y: B] :
          ( ( Y4 @ X @ Y )
         => ( X3 @ X @ Y ) )
     => ( ! [X: C,Y: D] :
            ( ( A2 @ X @ Y )
           => ( B2 @ X @ Y ) )
       => ( ( bNF_rel_fun @ A @ B @ C @ D @ X3 @ A2 @ F @ G )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y4 @ B2 @ F @ G ) ) ) ) )).

% rel_fun_mono'
thf(fact_15_llist__all2__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ R
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o ) @ ( coindu1486289336t_all2 @ A @ B @ R )
        @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ R )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( coindu1486289336t_all2 @ A @ A )
      @ ( coindu1486289336t_all2 @ B @ B ) ) )).

% llist_all2_transfer
thf(fact_16_llist_Orel__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: ( A > C > $o ),Sc: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) > $o ) @ ( ( coinductive_llist @ C ) > ( coinductive_llist @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ C ) @ ( ( coinductive_llist @ B ) > $o ) @ ( ( coinductive_llist @ D ) > $o ) @ ( coindu1486289336t_all2 @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( coinductive_llist @ B ) @ ( coinductive_llist @ D ) @ $o @ $o @ ( coindu1486289336t_all2 @ B @ D @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( coindu1486289336t_all2 @ A @ B )
      @ ( coindu1486289336t_all2 @ C @ D ) ) )).

% llist.rel_transfer
thf(fact_17_Let__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ A2 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ B2 )
      @ ^ [S2: A,F2: ( A > C )] :
          ( F2 @ S2 )
      @ ^ [S2: B,F2: ( B > D )] :
          ( F2 @ S2 ) ) )).

% Let_transfer
thf(fact_18_rel__fun__def__butlast,axiom,(
    ! [B: $tType,D: $tType,C: $tType,E: $tType,F3: $tType,A: $tType,R: ( A > B > $o ),S: ( C > E > $o ),T: ( D > F3 > $o ),F: ( A > C > D ),G: ( B > E > F3 )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > D ) @ ( E > F3 ) @ R @ ( bNF_rel_fun @ C @ E @ D @ F3 @ S @ T ) @ F @ G )
      = ( ! [X4: A,Y5: B] :
            ( ( R @ X4 @ Y5 )
           => ( bNF_rel_fun @ C @ E @ D @ F3 @ S @ T @ ( F @ X4 ) @ ( G @ Y5 ) ) ) ) ) )).

% rel_fun_def_butlast
thf(fact_19_If__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( B > B > B )
      @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
      @ ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A2 @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) )
      @ ( if @ A )
      @ ( if @ B ) ) )).

% If_transfer
thf(fact_20_llist__corec__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > C ) > ( A > $o ) > ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > D ) > ( B > $o ) > ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > $o ) > ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > $o ) > ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 )
        @ ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > ( coinductive_llist @ C ) ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > ( coinductive_llist @ D ) ) > ( B > B ) > B > ( coinductive_llist @ D ) )
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
          @ ( bNF_rel_fun @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) ) ) ) )
      @ ( coindu1259883913_llist @ A @ C )
      @ ( coindu1259883913_llist @ B @ D ) ) )).

% llist_corec_transfer
thf(fact_21_llist_Ocorec__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > A ) > ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > B ) > ( D > $o ) > ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( C > $o ) > ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > $o ) > ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ S @ R )
        @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( coinductive_llist @ A ) ) > ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > ( coinductive_llist @ B ) ) > ( D > D ) > D > ( coinductive_llist @ B ) )
          @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
          @ ( bNF_rel_fun @ ( C > ( coinductive_llist @ A ) ) @ ( D > ( coinductive_llist @ B ) ) @ ( ( C > C ) > C > ( coinductive_llist @ A ) ) @ ( ( D > D ) > D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ S @ ( coindu1486289336t_all2 @ A @ B @ R ) ) @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( C > ( coinductive_llist @ A ) ) @ ( D > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S @ S ) @ ( bNF_rel_fun @ C @ D @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ S @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) ) ) )
      @ ( coindu1259883913_llist @ C @ A )
      @ ( coindu1259883913_llist @ D @ B ) ) )).

% llist.corec_transfer
thf(fact_22_unfold__llist__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( A > C ) > ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > D ) > ( B > B ) > B > ( coinductive_llist @ D ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( ( A > A ) > A > ( coinductive_llist @ C ) ) @ ( ( B > B ) > B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ C ) ) @ ( B > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A2 @ ( coindu1486289336t_all2 @ C @ D @ B2 ) ) ) )
      @ ( coindu1441602521_llist @ A @ C )
      @ ( coindu1441602521_llist @ B @ D ) ) )).

% unfold_llist_transfer
thf(fact_23_iterates__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > A ) @ ( B > B ) @ ( A > ( coinductive_llist @ A ) ) @ ( B > ( coinductive_llist @ B ) ) @ ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 ) @ ( bNF_rel_fun @ A @ B @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ A2 @ ( coindu1486289336t_all2 @ A @ B @ A2 ) ) @ ( coinductive_iterates @ A ) @ ( coinductive_iterates @ B ) ) )).

% iterates_transfer
thf(fact_24_fun_Orel__transfer,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E: $tType,D: $tType,Sa: ( A > C > $o ),Sc: ( B > E > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > E > $o ) @ ( ( D > A ) > ( D > B ) > $o ) @ ( ( D > C ) > ( D > E ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( E > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ E @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > C ) @ ( ( D > B ) > $o ) @ ( ( D > E ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ C
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Sa )
        @ ( bNF_rel_fun @ ( D > B ) @ ( D > E ) @ $o @ $o
          @ ( bNF_rel_fun @ D @ D @ B @ E
            @ ^ [Y3: D,Z: D] : ( Y3 = Z )
            @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ D @ D @ C @ E
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) ) ) )).

% fun.rel_transfer
thf(fact_25_fun_Orel__refl,axiom,(
    ! [B: $tType,D: $tType,Ra: ( B > B > $o ),X2: ( D > B )] :
      ( ! [X: B] :
          ( Ra @ X @ X )
     => ( bNF_rel_fun @ D @ D @ B @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ Ra
        @ X2
        @ X2 ) ) )).

% fun.rel_refl
thf(fact_26_fun_Orel__eq,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( D > A ),Z: ( D > A )] : ( Y3 = Z ) ) ) )).

% fun.rel_eq
thf(fact_27_case__llist__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,B2: ( A > B > $o ),A2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( C > ( coinductive_llist @ C ) > A ) > ( coinductive_llist @ C ) > A ) @ ( ( D > ( coinductive_llist @ D ) > B ) > ( coinductive_llist @ D ) > B ) @ B2 @ ( bNF_rel_fun @ ( C > ( coinductive_llist @ C ) > A ) @ ( D > ( coinductive_llist @ D ) > B ) @ ( ( coinductive_llist @ C ) > A ) @ ( ( coinductive_llist @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ ( ( coinductive_llist @ C ) > A ) @ ( ( coinductive_llist @ D ) > B ) @ A2 @ ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A @ B @ ( coindu1486289336t_all2 @ C @ D @ A2 ) @ B2 ) ) @ ( bNF_rel_fun @ ( coinductive_llist @ C ) @ ( coinductive_llist @ D ) @ A @ B @ ( coindu1486289336t_all2 @ C @ D @ A2 ) @ B2 ) ) @ ( coindu1381640503_llist @ A @ C ) @ ( coindu1381640503_llist @ B @ D ) ) )).

% case_llist_transfer
thf(fact_28_llist_Ocase__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S: ( C > D > $o ),R: ( A > B > $o )] :
      ( bNF_rel_fun @ C @ D @ ( ( A > ( coinductive_llist @ A ) > C ) > ( coinductive_llist @ A ) > C ) @ ( ( B > ( coinductive_llist @ B ) > D ) > ( coinductive_llist @ B ) > D ) @ S @ ( bNF_rel_fun @ ( A > ( coinductive_llist @ A ) > C ) @ ( B > ( coinductive_llist @ B ) > D ) @ ( ( coinductive_llist @ A ) > C ) @ ( ( coinductive_llist @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > C ) @ ( ( coinductive_llist @ B ) > D ) @ R @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ D @ ( coindu1486289336t_all2 @ A @ B @ R ) @ S ) ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ D @ ( coindu1486289336t_all2 @ A @ B @ R ) @ S ) ) @ ( coindu1381640503_llist @ C @ A ) @ ( coindu1381640503_llist @ D @ B ) ) )).

% llist.case_transfer
thf(fact_29_map__fun__parametric,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,H: $tType,G2: $tType,D: $tType,C: $tType,A2: ( A > C > $o ),B2: ( B > D > $o ),C2: ( E > G2 > $o ),D2: ( F3 > H > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > F3 ) > ( B > E ) > A > F3 ) @ ( ( G2 > H ) > ( D > G2 ) > C > H ) @ ( bNF_rel_fun @ A @ C @ B @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( E > F3 ) @ ( G2 > H ) @ ( ( B > E ) > A > F3 ) @ ( ( D > G2 ) > C > H ) @ ( bNF_rel_fun @ E @ G2 @ F3 @ H @ C2 @ D2 ) @ ( bNF_rel_fun @ ( B > E ) @ ( D > G2 ) @ ( A > F3 ) @ ( C > H ) @ ( bNF_rel_fun @ B @ D @ E @ G2 @ B2 @ C2 ) @ ( bNF_rel_fun @ A @ C @ F3 @ H @ A2 @ D2 ) ) ) @ ( map_fun @ A @ B @ E @ F3 ) @ ( map_fun @ C @ D @ G2 @ H ) ) )).

% map_fun_parametric
thf(fact_30_llist_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ R )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( coindu543516966_llist @ A )
      @ ( coindu543516966_llist @ B ) ) )).

% llist.pred_transfer
thf(fact_31_llist__all__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > $o ) @ ( ( coinductive_llist @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ $o @ $o @ ( coindu1486289336t_all2 @ A @ B @ A2 )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( coindu543516966_llist @ A )
      @ ( coindu543516966_llist @ B ) ) )).

% llist_all_transfer
thf(fact_32_if__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( A > A > A )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( bNF_rel_fun @ A @ A @ ( A > A ) @ ( A > A ) @ R @ ( bNF_rel_fun @ A @ A @ A @ A @ R @ R ) )
        @ ( if @ A )
        @ ( if @ A ) ) ) )).

% if_rsp
thf(fact_33_ldropWhile__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coindu218763757pWhile @ A )
      @ ( coindu218763757pWhile @ B ) ) )).

% ldropWhile_transfer
thf(fact_34_ltakeWhile__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coindu501562517eWhile @ A )
      @ ( coindu501562517eWhile @ B ) ) )).

% ltakeWhile_transfer
thf(fact_35_lfilter__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) )
      @ ( coinductive_lfilter @ A )
      @ ( coinductive_lfilter @ B ) ) )).

% lfilter_transfer
thf(fact_36_fun_Omap__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,G2: $tType,F3: $tType,Rb: ( A > F3 > $o ),Sd: ( B > G2 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( F3 > G2 ) @ ( ( D > A ) > D > B ) @ ( ( D > F3 ) > D > G2 ) @ ( bNF_rel_fun @ A @ F3 @ B @ G2 @ Rb @ Sd )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > F3 ) @ ( D > B ) @ ( D > G2 )
        @ ( bNF_rel_fun @ D @ D @ A @ F3
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Rb )
        @ ( bNF_rel_fun @ D @ D @ B @ G2
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Sd ) )
      @ ( comp @ A @ B @ D )
      @ ( comp @ F3 @ G2 @ D ) ) )).

% fun.map_transfer
thf(fact_37_comp__transfer,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,D: $tType,C: $tType,B2: ( A > C > $o ),C2: ( B > D > $o ),A2: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F3 > C ) > F3 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ B2 @ C2 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F3 > C ) @ ( E > B ) @ ( F3 > D ) @ ( bNF_rel_fun @ E @ F3 @ A @ C @ A2 @ B2 ) @ ( bNF_rel_fun @ E @ F3 @ B @ D @ A2 @ C2 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F3 ) ) )).

% comp_transfer
thf(fact_38_lfilter__idem,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( coinductive_lfilter @ A @ P @ Xs ) ) )).

% lfilter_idem
thf(fact_39_fun__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R2: ( C > C > $o ),Abs2: ( C > D ),Rep2: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs2 @ Rep2 )
       => ( quotient3 @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 ) @ ( map_fun @ B @ A @ C @ D @ Rep1 @ Abs2 ) @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep2 ) ) ) ) )).

% fun_quotient3
thf(fact_40_unfold__llist__ltl__unroll,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B3: B] :
      ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B3 ) )
      = ( coindu1441602521_llist @ B @ A @ ( comp @ B @ $o @ B @ IS_LNIL @ LTL ) @ ( comp @ B @ A @ B @ LHD @ LTL ) @ LTL @ B3 ) ) )).

% unfold_llist_ltl_unroll
thf(fact_41_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H2: ( A > C ),R12: ( D > B ),R22: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H2 )
        = ( comp @ D @ B @ A @ R12 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R12 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H2 )
          = ( comp @ D @ E @ A @ L @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_42_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H2: ( E > A ),R3: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H2 )
          = R3 )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H2 ) )
          = ( comp @ D @ B @ E @ L1 @ R3 ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_43_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H2: ( A > C ),R3: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H2 )
        = R3 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H2 )
        = ( comp @ B @ D @ A @ F @ R3 ) ) ) )).

% rewriteR_comp_comp
thf(fact_44_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H2: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H2 ) )
        = ( comp @ A @ B @ D @ L @ H2 ) ) ) )).

% rewriteL_comp_comp
thf(fact_45_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X: A] :
          ( ( F @ X )
          = ( G @ X ) )
     => ( F = G ) ) )).

% ext
thf(fact_46_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_47_Quotient3__rep__reflp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( R @ ( Rep @ A3 ) @ ( Rep @ A3 ) ) ) )).

% Quotient3_rep_reflp
thf(fact_48_Quotient3__rep__abs,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R3 @ R3 )
       => ( R @ ( Rep @ ( Abs @ R3 ) ) @ R3 ) ) ) )).

% Quotient3_rep_abs
thf(fact_49_Quotient3__rel__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B,B3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ ( Rep @ A3 ) @ ( Rep @ B3 ) )
        = ( A3 = B3 ) ) ) )).

% Quotient3_rel_rep
thf(fact_50_Quotient3__rel__abs,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R3: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R3 @ S3 )
       => ( ( Abs @ R3 )
          = ( Abs @ S3 ) ) ) ) )).

% Quotient3_rel_abs
thf(fact_51_Quotient3__abs__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A3: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( Abs @ ( Rep @ A3 ) )
        = A3 ) ) )).

% Quotient3_abs_rep
thf(fact_52_rep__abs__rsp__left,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X22: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ X1 @ X22 )
       => ( R @ ( Rep @ ( Abs @ X1 ) ) @ X22 ) ) ) )).

% rep_abs_rsp_left
thf(fact_53_Quotient3__refl2,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R3: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R3 @ S3 )
       => ( R @ S3 @ S3 ) ) ) )).

% Quotient3_refl2
thf(fact_54_Quotient3__refl1,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R3: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ R3 @ S3 )
       => ( R @ R3 @ R3 ) ) ) )).

% Quotient3_refl1
thf(fact_55_Quotient3__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R3: A,S3: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( ( R @ R3 @ R3 )
          & ( R @ S3 @ S3 )
          & ( ( Abs @ R3 )
            = ( Abs @ S3 ) ) )
        = ( R @ R3 @ S3 ) ) ) )).

% Quotient3_rel
thf(fact_56_Quotient3__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( quotient3 @ A @ B )
      = ( ^ [R4: ( A > A > $o ),Abs3: ( A > B ),Rep3: ( B > A )] :
            ( ! [A5: B] :
                ( ( Abs3 @ ( Rep3 @ A5 ) )
                = A5 )
            & ! [A5: B] :
                ( R4 @ ( Rep3 @ A5 ) @ ( Rep3 @ A5 ) )
            & ! [R5: A,S2: A] :
                ( ( R4 @ R5 @ S2 )
                = ( ( R4 @ R5 @ R5 )
                  & ( R4 @ S2 @ S2 )
                  & ( ( Abs3 @ R5 )
                    = ( Abs3 @ S2 ) ) ) ) ) ) ) )).

% Quotient3_def
thf(fact_57_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X2: C,H2: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X2 ) )
        = ( H2 @ ( K @ X2 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ C @ H2 @ K @ X2 ) ) ) )).

% comp_apply_eq
thf(fact_58_rep__abs__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X22: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ X1 @ X22 )
       => ( R @ X1 @ ( Rep @ ( Abs @ X22 ) ) ) ) ) )).

% rep_abs_rsp
thf(fact_59_equals__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),Xa: A,Xb: A,Ya: A,Yb: A] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( R @ Xa @ Xb )
       => ( ( R @ Ya @ Yb )
         => ( ( R @ Xa @ Ya )
            = ( R @ Xb @ Yb ) ) ) ) ) )).

% equals_rsp
thf(fact_60_Quotient3I,axiom,(
    ! [B: $tType,A: $tType,Abs: ( B > A ),Rep: ( A > B ),R: ( B > B > $o )] :
      ( ! [A4: A] :
          ( ( Abs @ ( Rep @ A4 ) )
          = A4 )
     => ( ! [A4: A] :
            ( R @ ( Rep @ A4 ) @ ( Rep @ A4 ) )
       => ( ! [R6: B,S4: B] :
              ( ( R @ R6 @ S4 )
              = ( ( R @ R6 @ R6 )
                & ( R @ S4 @ S4 )
                & ( ( Abs @ R6 )
                  = ( Abs @ S4 ) ) ) )
         => ( quotient3 @ B @ A @ R @ Abs @ Rep ) ) ) ) )).

% Quotient3I
thf(fact_61_cond__prs,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A ),A3: $o,B3: B,C3: B] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( ( A3
         => ( ( Absf @ ( if @ A @ A3 @ ( Repf @ B3 ) @ ( Repf @ C3 ) ) )
            = B3 ) )
        & ( ~ ( A3 )
         => ( ( Absf @ ( if @ A @ A3 @ ( Repf @ B3 ) @ ( Repf @ C3 ) ) )
            = C3 ) ) ) ) )).

% cond_prs
thf(fact_62_let__prs,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs22: ( C > D ),Rep22: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs22 @ Rep22 )
       => ( ( map_fun @ D @ C @ ( ( C > A ) > A ) @ ( ( D > B ) > B ) @ Rep22 @ ( map_fun @ ( D > B ) @ ( C > A ) @ A @ B @ ( map_fun @ C @ D @ B @ A @ Abs22 @ Rep12 ) @ Abs12 )
            @ ^ [S2: C,F2: ( C > A )] :
                ( F2 @ S2 ) )
          = ( ^ [S2: D,F2: ( D > B )] :
                ( F2 @ S2 ) ) ) ) ) )).

% let_prs
thf(fact_63_o__prs_I1_J,axiom,(
    ! [C: $tType,E: $tType,A: $tType,B: $tType,F3: $tType,D: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs22: ( C > D ),Rep22: ( D > C ),R32: ( E > E > $o ),Abs32: ( E > F3 ),Rep32: ( F3 > E )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs22 @ Rep22 )
       => ( ( quotient3 @ E @ F3 @ R32 @ Abs32 @ Rep32 )
         => ( ( map_fun @ ( D > F3 ) @ ( C > E ) @ ( ( A > C ) > A > E ) @ ( ( B > D ) > B > F3 ) @ ( map_fun @ C @ D @ F3 @ E @ Abs22 @ Rep32 ) @ ( map_fun @ ( B > D ) @ ( A > C ) @ ( A > E ) @ ( B > F3 ) @ ( map_fun @ A @ B @ D @ C @ Abs12 @ Rep22 ) @ ( map_fun @ B @ A @ E @ F3 @ Rep12 @ Abs32 ) ) @ ( comp @ C @ E @ A ) )
            = ( comp @ D @ F3 @ B ) ) ) ) ) )).

% o_prs(1)
thf(fact_64_llist__all2__lfilterI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Q1: ( A > $o ),Q2: ( B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( ( Q1 @ X )
              = ( Q2 @ Y ) ) )
       => ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_lfilter @ A @ Q1 @ Xs ) @ ( coinductive_lfilter @ B @ Q2 @ Ys ) ) ) ) )).

% llist_all2_lfilterI
thf(fact_65_apply__rspQ3_H_H,axiom,(
    ! [C: $tType,A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),S: ( C > C > $o ),F: ( A > C ),X2: B] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R @ S @ F @ F )
       => ( S @ ( F @ ( Rep @ X2 ) ) @ ( F @ ( Rep @ X2 ) ) ) ) ) )).

% apply_rspQ3''
thf(fact_66_apply__rspQ3,axiom,(
    ! [B: $tType,C: $tType,A: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),F: ( A > C ),G: ( A > C ),X2: A,Y2: A] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 @ F @ G )
       => ( ( R1 @ X2 @ Y2 )
         => ( R2 @ ( F @ X2 ) @ ( G @ Y2 ) ) ) ) ) )).

% apply_rspQ3
thf(fact_67_llist__all2__ldropWhileI,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B ),Q1: ( A > $o ),Q2: ( B > $o )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys )
     => ( ! [X: A,Y: B] :
            ( ( P @ X @ Y )
           => ( ( Q1 @ X )
              = ( Q2 @ Y ) ) )
       => ( coindu1486289336t_all2 @ A @ B @ P @ ( coindu218763757pWhile @ A @ Q1 @ Xs ) @ ( coindu218763757pWhile @ B @ Q2 @ Ys ) ) ) ) )).

% llist_all2_ldropWhileI
thf(fact_68_quot__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( bNF_rel_fun @ A @ A @ ( A > $o ) @ ( A > $o ) @ R
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ R
        @ R ) ) )).

% quot_rel_rsp
thf(fact_69_o__rsp_I1_J,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,D: $tType,C: $tType,R2: ( A > C > $o ),R32: ( B > D > $o ),R1: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F3 > C ) > F3 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ R2 @ R32 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F3 > C ) @ ( E > B ) @ ( F3 > D ) @ ( bNF_rel_fun @ E @ F3 @ A @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ E @ F3 @ B @ D @ R1 @ R32 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F3 ) ) )).

% o_rsp(1)
thf(fact_70_o__rsp_I2_J,axiom,(
    ! [E: $tType,F3: $tType,H: $tType,G2: $tType,R1: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( G2 > H ) @ ( G2 > H ) @ ( ( E > G2 ) > E > H ) @ ( ( F3 > G2 ) > F3 > H )
      @ ^ [Y3: ( G2 > H ),Z: ( G2 > H )] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( E > G2 ) @ ( F3 > G2 ) @ ( E > H ) @ ( F3 > H )
        @ ( bNF_rel_fun @ E @ F3 @ G2 @ G2 @ R1
          @ ^ [Y3: G2,Z: G2] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ E @ F3 @ H @ H @ R1
          @ ^ [Y3: H,Z: H] : ( Y3 = Z ) ) )
      @ ( comp @ G2 @ H @ E )
      @ ( comp @ G2 @ H @ F3 ) ) )).

% o_rsp(2)
thf(fact_71_map__fun__apply,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( map_fun @ B @ C @ D @ A )
      = ( ^ [F2: ( B > C ),G3: ( D > A ),H3: ( C > D ),X4: B] :
            ( G3 @ ( H3 @ ( F2 @ X4 ) ) ) ) ) )).

% map_fun_apply
thf(fact_72_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F2: ( B > A ),G3: ( C > B ),X4: C] :
            ( F2 @ ( G3 @ X4 ) ) ) ) )).

% comp_apply
thf(fact_73_map__fun__def,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType] :
      ( ( map_fun @ C @ A @ B @ D )
      = ( ^ [F2: ( C > A ),G3: ( B > D ),H3: ( A > B )] :
            ( comp @ A @ D @ C @ ( comp @ B @ D @ A @ G3 @ H3 ) @ F2 ) ) ) )).

% map_fun_def
thf(fact_74_map__fun_Ocomp,axiom,(
    ! [E: $tType,C: $tType,A: $tType,F3: $tType,D: $tType,B: $tType,F: ( E > C ),G: ( D > F3 ),H2: ( C > A ),I: ( B > D )] :
      ( ( comp @ ( C > D ) @ ( E > F3 ) @ ( A > B ) @ ( map_fun @ E @ C @ D @ F3 @ F @ G ) @ ( map_fun @ C @ A @ B @ D @ H2 @ I ) )
      = ( map_fun @ E @ A @ B @ F3 @ ( comp @ C @ A @ E @ H2 @ F ) @ ( comp @ D @ F3 @ B @ G @ I ) ) ) )).

% map_fun.comp
thf(fact_75_map__fun_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,C: $tType,E: $tType,B: $tType,A: $tType,F: ( E > C ),G: ( D > F3 ),H2: ( C > A ),I: ( B > D ),Fun: ( A > B )] :
      ( ( map_fun @ E @ C @ D @ F3 @ F @ G @ ( map_fun @ C @ A @ B @ D @ H2 @ I @ Fun ) )
      = ( map_fun @ E @ A @ B @ F3 @ ( comp @ C @ A @ E @ H2 @ F ) @ ( comp @ D @ F3 @ B @ G @ I ) @ Fun ) ) )).

% map_fun.compositionality
thf(fact_76_llist_Omap__transfer,axiom,(
    ! [A: $tType,B: $tType,F3: $tType,E: $tType,Rb: ( A > E > $o ),Sd: ( B > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( E > F3 ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) ) @ ( ( coinductive_llist @ E ) > ( coinductive_llist @ F3 ) ) @ ( bNF_rel_fun @ A @ E @ B @ F3 @ Rb @ Sd ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ E ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ F3 ) @ ( coindu1486289336t_all2 @ A @ E @ Rb ) @ ( coindu1486289336t_all2 @ B @ F3 @ Sd ) ) @ ( coinductive_lmap @ A @ B ) @ ( coinductive_lmap @ E @ F3 ) ) )).

% llist.map_transfer
thf(fact_77_lmap__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > C > $o ),B2: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ B ) ) @ ( ( coinductive_llist @ C ) > ( coinductive_llist @ D ) ) @ ( bNF_rel_fun @ A @ C @ B @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ C ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ D ) @ ( coindu1486289336t_all2 @ A @ C @ A2 ) @ ( coindu1486289336t_all2 @ B @ D @ B2 ) ) @ ( coinductive_lmap @ A @ B ) @ ( coinductive_lmap @ C @ D ) ) )).

% lmap_transfer
thf(fact_78_bex1__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( bNF_rel_fun @ ( A > $o ) @ ( A > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( bex1_rel @ A @ R )
        @ ( bex1_rel @ A @ R ) ) ) )).

% bex1_rel_rsp
thf(fact_79_LCons__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) ) @ A2 @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) @ ( coindu1486289336t_all2 @ A @ B @ A2 ) ) @ ( coinductive_LCons @ A ) @ ( coinductive_LCons @ B ) ) )).

% LCons_transfer
thf(fact_80_llist_Oinject,axiom,(
    ! [A: $tType,X21: A,X222: ( coinductive_llist @ A ),Y21: A,Y22: ( coinductive_llist @ A )] :
      ( ( ( coinductive_LCons @ A @ X21 @ X222 )
        = ( coinductive_LCons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y22 ) ) ) )).

% llist.inject
thf(fact_81_llist__all2__LCons__LCons,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X21: A,X222: ( coinductive_llist @ A ),Y21: B,Y22: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ R @ ( coinductive_LCons @ A @ X21 @ X222 ) @ ( coinductive_LCons @ B @ Y21 @ Y22 ) )
      = ( ( R @ X21 @ Y21 )
        & ( coindu1486289336t_all2 @ A @ B @ R @ X222 @ Y22 ) ) ) )).

% llist_all2_LCons_LCons
thf(fact_82_lfilter__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X2 )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coinductive_LCons @ A @ X2 @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X2 )
       => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons
thf(fact_83_ldropWhile__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( P @ X2 )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coindu218763757pWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X2 )
       => ( ( coindu218763757pWhile @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
          = ( coinductive_LCons @ A @ X2 @ Xs ) ) ) ) )).

% ldropWhile_LCons
thf(fact_84_unfold__llist__eq__LCons,axiom,(
    ! [A: $tType,B: $tType,IS_LNIL: ( B > $o ),LHD: ( B > A ),LTL: ( B > B ),B3: B,X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ B3 )
        = ( coinductive_LCons @ A @ X2 @ Xs ) )
      = ( ~ ( IS_LNIL @ B3 )
        & ( X2
          = ( LHD @ B3 ) )
        & ( Xs
          = ( coindu1441602521_llist @ B @ A @ IS_LNIL @ LHD @ LTL @ ( LTL @ B3 ) ) ) ) ) )).

% unfold_llist_eq_LCons
thf(fact_85_llist_Opred__inject_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),A3: A,Aa2: ( coinductive_llist @ A )] :
      ( ( coindu543516966_llist @ A @ P @ ( coinductive_LCons @ A @ A3 @ Aa2 ) )
      = ( ( P @ A3 )
        & ( coindu543516966_llist @ A @ P @ Aa2 ) ) ) )).

% llist.pred_inject(2)
thf(fact_86_llist_Osimps_I13_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X21: A,X222: ( coinductive_llist @ A )] :
      ( ( coinductive_lmap @ A @ B @ F @ ( coinductive_LCons @ A @ X21 @ X222 ) )
      = ( coinductive_LCons @ B @ ( F @ X21 ) @ ( coinductive_lmap @ A @ B @ F @ X222 ) ) ) )).

% llist.simps(13)
thf(fact_87_bex1__rel__aux,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X2: ( A > $o ),Y2: ( A > $o )] :
      ( ! [Xa2: A,Ya2: A] :
          ( ( R @ Xa2 @ Ya2 )
         => ( ( X2 @ Xa2 )
            = ( Y2 @ Ya2 ) ) )
     => ( ( bex1_rel @ A @ R @ X2 )
       => ( bex1_rel @ A @ R @ Y2 ) ) ) )).

% bex1_rel_aux
thf(fact_88_bex1__rel__aux2,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X2: ( A > $o ),Y2: ( A > $o )] :
      ( ! [Xa2: A,Ya2: A] :
          ( ( R @ Xa2 @ Ya2 )
         => ( ( X2 @ Xa2 )
            = ( Y2 @ Ya2 ) ) )
     => ( ( bex1_rel @ A @ R @ Y2 )
       => ( bex1_rel @ A @ R @ X2 ) ) ) )).

% bex1_rel_aux2
thf(fact_89_lmap__eq__LCons__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B ),Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lmap @ B @ A @ F @ Xs )
        = ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ? [X4: B,Xs2: ( coinductive_llist @ B )] :
            ( ( Xs
              = ( coinductive_LCons @ B @ X4 @ Xs2 ) )
            & ( Y2
              = ( F @ X4 ) )
            & ( Ys
              = ( coinductive_lmap @ B @ A @ F @ Xs2 ) ) ) ) ) )).

% lmap_eq_LCons_conv
thf(fact_90_iterates__equality,axiom,(
    ! [A: $tType,H2: ( A > ( coinductive_llist @ A ) ),F: ( A > A )] :
      ( ! [X: A] :
          ( ( H2 @ X )
          = ( coinductive_LCons @ A @ X @ ( coinductive_lmap @ A @ A @ F @ ( H2 @ X ) ) ) )
     => ( H2
        = ( coinductive_iterates @ A @ F ) ) ) )).

% iterates_equality
thf(fact_91_iterates__lmap,axiom,(
    ! [A: $tType] :
      ( ( coinductive_iterates @ A )
      = ( ^ [F2: ( A > A ),X4: A] :
            ( coinductive_LCons @ A @ X4 @ ( coinductive_lmap @ A @ A @ F2 @ ( coinductive_iterates @ A @ F2 @ X4 ) ) ) ) ) )).

% iterates_lmap
thf(fact_92_llist_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( B > C ),F: ( A > B ),V: ( coinductive_llist @ A )] :
      ( ( coinductive_lmap @ B @ C @ G @ ( coinductive_lmap @ A @ B @ F @ V ) )
      = ( coinductive_lmap @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% llist.map_comp
thf(fact_93_lfilter__lmap,axiom,(
    ! [A: $tType,B: $tType,P: ( A > $o ),F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lfilter @ A @ P @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lmap @ B @ A @ F @ ( coinductive_lfilter @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) )).

% lfilter_lmap
thf(fact_94_ltakeWhile__lmap,axiom,(
    ! [A: $tType,B: $tType,P: ( A > $o ),F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coindu501562517eWhile @ A @ P @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lmap @ B @ A @ F @ ( coindu501562517eWhile @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) )).

% ltakeWhile_lmap
thf(fact_95_ldropWhile__lmap,axiom,(
    ! [A: $tType,B: $tType,P: ( A > $o ),F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coindu218763757pWhile @ A @ P @ ( coinductive_lmap @ B @ A @ F @ Xs ) )
      = ( coinductive_lmap @ B @ A @ F @ ( coindu218763757pWhile @ B @ ( comp @ A @ $o @ B @ P @ F ) @ Xs ) ) ) )).

% ldropWhile_lmap
thf(fact_96_lmap__iterates,axiom,(
    ! [A: $tType,F: ( A > A ),X2: A] :
      ( ( coinductive_lmap @ A @ A @ F @ ( coinductive_iterates @ A @ F @ X2 ) )
      = ( coinductive_iterates @ A @ F @ ( F @ X2 ) ) ) )).

% lmap_iterates
thf(fact_97_llist_Orel__intros_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X21: A,Y21: B,X222: ( coinductive_llist @ A ),Y22: ( coinductive_llist @ B )] :
      ( ( R @ X21 @ Y21 )
     => ( ( coindu1486289336t_all2 @ A @ B @ R @ X222 @ Y22 )
       => ( coindu1486289336t_all2 @ A @ B @ R @ ( coinductive_LCons @ A @ X21 @ X222 ) @ ( coinductive_LCons @ B @ Y21 @ Y22 ) ) ) ) )).

% llist.rel_intros(2)
thf(fact_98_llist__all2__LCons1,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),X2: A,Xs: ( coinductive_llist @ A ),Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) @ Ys )
      = ( ? [Y5: B,Ys2: ( coinductive_llist @ B )] :
            ( ( Ys
              = ( coinductive_LCons @ B @ Y5 @ Ys2 ) )
            & ( P @ X2 @ Y5 )
            & ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ Ys2 ) ) ) ) )).

% llist_all2_LCons1
thf(fact_99_llist__all2__LCons2,axiom,(
    ! [B: $tType,A: $tType,P: ( A > B > $o ),Xs: ( coinductive_llist @ A ),Y2: B,Ys: ( coinductive_llist @ B )] :
      ( ( coindu1486289336t_all2 @ A @ B @ P @ Xs @ ( coinductive_LCons @ B @ Y2 @ Ys ) )
      = ( ? [X4: A,Xs2: ( coinductive_llist @ A )] :
            ( ( Xs
              = ( coinductive_LCons @ A @ X4 @ Xs2 ) )
            & ( P @ X4 @ Y2 )
            & ( coindu1486289336t_all2 @ A @ B @ P @ Xs2 @ Ys ) ) ) ) )).

% llist_all2_LCons2
thf(fact_100_lmap__lmirror,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( coinductive_llist @ B )] :
      ( ( coinductive_lmap @ B @ A @ F @ ( lMirro427583474mirror @ B @ Xs ) )
      = ( lMirro427583474mirror @ A @ ( coinductive_lmap @ B @ A @ F @ Xs ) ) ) )).

% lmap_lmirror
thf(fact_101_llist_Opred__map,axiom,(
    ! [B: $tType,A: $tType,Q: ( B > $o ),F: ( A > B ),X2: ( coinductive_llist @ A )] :
      ( ( coindu543516966_llist @ B @ Q @ ( coinductive_lmap @ A @ B @ F @ X2 ) )
      = ( coindu543516966_llist @ A @ ( comp @ B @ $o @ A @ Q @ F ) @ X2 ) ) )).

% llist.pred_map
thf(fact_102_llist_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F22: ( A > ( coinductive_llist @ A ) > B ),X21: A,X222: ( coinductive_llist @ A )] :
      ( ( coindu1381640503_llist @ B @ A @ F1 @ F22 @ ( coinductive_LCons @ A @ X21 @ X222 ) )
      = ( F22 @ X21 @ X222 ) ) )).

% llist.simps(5)
thf(fact_103_lfilter__LCons__seek,axiom,(
    ! [A: $tType,P3: ( A > $o ),X2: A,L: ( coinductive_llist @ A )] :
      ( ~ ( P3 @ X2 )
     => ( ( coinductive_lfilter @ A @ P3 @ ( coinductive_LCons @ A @ X2 @ L ) )
        = ( coinductive_lfilter @ A @ P3 @ L ) ) ) )).

% lfilter_LCons_seek
thf(fact_104_lfilter__LCons__found,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( coinductive_llist @ A )] :
      ( ( P @ X2 )
     => ( ( coinductive_lfilter @ A @ P @ ( coinductive_LCons @ A @ X2 @ Xs ) )
        = ( coinductive_LCons @ A @ X2 @ ( coinductive_lfilter @ A @ P @ Xs ) ) ) ) )).

% lfilter_LCons_found
thf(fact_105_iterates_Ocode,axiom,(
    ! [A: $tType] :
      ( ( coinductive_iterates @ A )
      = ( ^ [F2: ( A > A ),X4: A] :
            ( coinductive_LCons @ A @ X4 @ ( coinductive_iterates @ A @ F2 @ ( F2 @ X4 ) ) ) ) ) )).

% iterates.code
thf(fact_106_unfold__llist_Octr_I2_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A3: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P3 @ A3 )
     => ( ( coindu1441602521_llist @ A @ B @ P3 @ G21 @ G22 @ A3 )
        = ( coinductive_LCons @ B @ ( G21 @ A3 ) @ ( coindu1441602521_llist @ A @ B @ P3 @ G21 @ G22 @ ( G22 @ A3 ) ) ) ) ) )).

% unfold_llist.ctr(2)
thf(fact_107_llist_Ocorec_I2_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),A3: C,G21: ( C > A ),Q22: ( C > $o ),G221: ( C > ( coinductive_llist @ A ) ),G222: ( C > C )] :
      ( ~ ( P3 @ A3 )
     => ( ( coindu1259883913_llist @ C @ A @ P3 @ G21 @ Q22 @ G221 @ G222 @ A3 )
        = ( coinductive_LCons @ A @ ( G21 @ A3 ) @ ( if @ ( coinductive_llist @ A ) @ ( Q22 @ A3 ) @ ( G221 @ A3 ) @ ( coindu1259883913_llist @ C @ A @ P3 @ G21 @ Q22 @ G221 @ G222 @ ( G222 @ A3 ) ) ) ) ) ) )).

% llist.corec(2)
thf(fact_108_lmap__unfold__llist,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),IS_LNIL: ( C > $o ),LHD: ( C > B ),LTL: ( C > C ),B3: C] :
      ( ( coinductive_lmap @ B @ A @ F @ ( coindu1441602521_llist @ C @ B @ IS_LNIL @ LHD @ LTL @ B3 ) )
      = ( coindu1441602521_llist @ C @ A @ IS_LNIL @ ( comp @ B @ A @ C @ F @ LHD ) @ LTL @ B3 ) ) )).

% lmap_unfold_llist
thf(fact_109_llist_Omap__o__corec,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > $o ),Ga: ( C > A ),Gb: ( C > $o ),Gc: ( C > ( coinductive_llist @ A ) ),Gd: ( C > C )] :
      ( ( comp @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ ( coinductive_lmap @ A @ B @ F ) @ ( coindu1259883913_llist @ C @ A @ G @ Ga @ Gb @ Gc @ Gd ) )
      = ( coindu1259883913_llist @ C @ B @ G @ ( comp @ A @ B @ C @ F @ Ga ) @ Gb @ ( comp @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ C @ ( coinductive_lmap @ A @ B @ F ) @ Gc ) @ Gd ) ) )).

% llist.map_o_corec
thf(fact_110_lmap__corec__llist,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),IS_LNIL: ( C > $o ),LHD: ( C > B ),EndORmore: ( C > $o ),TTL_end: ( C > ( coinductive_llist @ B ) ),TTL_more: ( C > C ),B3: C] :
      ( ( coinductive_lmap @ B @ A @ F @ ( coindu1259883913_llist @ C @ B @ IS_LNIL @ LHD @ EndORmore @ TTL_end @ TTL_more @ B3 ) )
      = ( coindu1259883913_llist @ C @ A @ IS_LNIL @ ( comp @ B @ A @ C @ F @ LHD ) @ EndORmore @ ( comp @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ C @ ( coinductive_lmap @ B @ A @ F ) @ TTL_end ) @ TTL_more @ B3 ) ) )).

% lmap_corec_llist
thf(fact_111_lfilter__eq__LCons,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A ),X2: A,Xs3: ( coinductive_llist @ A )] :
      ( ( ( coinductive_lfilter @ A @ P @ Xs )
        = ( coinductive_LCons @ A @ X2 @ Xs3 ) )
     => ? [Xs4: ( coinductive_llist @ A )] :
          ( ( Xs3
            = ( coinductive_lfilter @ A @ P @ Xs4 ) )
          & ( ( coindu218763757pWhile @ A @ ( comp @ $o @ $o @ A @ ~ @ P ) @ Xs )
            = ( coinductive_LCons @ A @ X2 @ Xs4 ) ) ) ) )).

% lfilter_eq_LCons
thf(fact_112_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = C3 )
     => ( ( A3 @ ( B3 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_113_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( D > B ),D3: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = ( comp @ D @ B @ A @ C3 @ D3 ) )
     => ! [V2: A] :
          ( ( A3 @ ( B3 @ V2 ) )
          = ( C3 @ ( D3 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_114_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( D > B ),D3: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = ( comp @ D @ B @ A @ C3 @ D3 ) )
     => ( ( A3 @ ( B3 @ V ) )
        = ( C3 @ ( D3 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_115_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H2: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H2 )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H2 ) ) ) )).

% comp_assoc
thf(fact_116_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F2: ( B > C ),G3: ( A > B ),X4: A] :
            ( F2 @ ( G3 @ X4 ) ) ) ) )).

% comp_def
thf(fact_117_llist_Octr__transfer_I2_J,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( coinductive_llist @ A ) > ( coinductive_llist @ A ) ) @ ( ( coinductive_llist @ B ) > ( coinductive_llist @ B ) ) @ R @ ( bNF_rel_fun @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) @ ( coinductive_LCons @ A ) @ ( coinductive_LCons @ B ) ) )).

% llist.ctr_transfer(2)
thf(fact_118_lmember__code_I2_J,axiom,(
    ! [A: $tType,X2: A,Y2: A,Ys: ( coinductive_llist @ A )] :
      ( ( coinductive_lmember @ A @ X2 @ ( coinductive_LCons @ A @ Y2 @ Ys ) )
      = ( ( X2 = Y2 )
        | ( coinductive_lmember @ A @ X2 @ Ys ) ) ) )).

% lmember_code(2)
thf(fact_119_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X2: C,N: ( D > A ),H2: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X2 ) )
        = ( N @ ( H2 @ X2 ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X2 )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N ) @ H2 @ X2 ) ) ) )).

% type_copy_map_cong0
thf(fact_120_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G: ( C > B ),X2: C,F4: ( D > A ),G4: ( E > D ),X5: E] :
      ( ( ( F @ ( G @ X2 ) )
        = ( F4 @ ( G4 @ X5 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ E @ F4 @ G4 @ X5 ) ) ) )).

% comp_cong
thf(fact_121_if__prs,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( map_fun @ $o @ $o @ ( A > A > A ) @ ( B > B > B ) @ ( id @ $o ) @ ( map_fun @ B @ A @ ( A > A ) @ ( B > B ) @ Rep @ ( map_fun @ B @ A @ A @ B @ Rep @ Abs ) ) @ ( if @ A ) )
        = ( if @ B ) ) ) )).

% if_prs
thf(fact_122_o__prs_I2_J,axiom,(
    ! [F3: $tType,E: $tType,C: $tType,D: $tType,A: $tType,B: $tType,H: $tType,G2: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs22: ( C > D ),Rep22: ( D > C ),R32: ( E > E > $o ),Abs32: ( E > F3 ),Rep32: ( F3 > E )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs22 @ Rep22 )
       => ( ( quotient3 @ E @ F3 @ R32 @ Abs32 @ Rep32 )
         => ( ( map_fun @ ( G2 > H ) @ ( G2 > H ) @ ( ( A > G2 ) > A > H ) @ ( ( B > G2 ) > B > H ) @ ( id @ ( G2 > H ) ) @ ( map_fun @ ( B > G2 ) @ ( A > G2 ) @ ( A > H ) @ ( B > H ) @ ( map_fun @ A @ B @ G2 @ G2 @ Abs12 @ ( id @ G2 ) ) @ ( map_fun @ B @ A @ H @ H @ Rep12 @ ( id @ H ) ) ) @ ( comp @ G2 @ H @ A ) )
            = ( comp @ G2 @ H @ B ) ) ) ) ) )).

% o_prs(2)
thf(fact_123_fun__ord__parametric,axiom,(
    ! [C: $tType,D: $tType,A: $tType,B: $tType,F3: $tType,E: $tType,C2: ( A > B > $o ),A2: ( C > E > $o ),B2: ( D > F3 > $o )] :
      ( ( bi_total @ A @ B @ C2 )
     => ( bNF_rel_fun @ ( C > D > $o ) @ ( E > F3 > $o ) @ ( ( A > C ) > ( A > D ) > $o ) @ ( ( B > E ) > ( B > F3 ) > $o )
        @ ( bNF_rel_fun @ C @ E @ ( D > $o ) @ ( F3 > $o ) @ A2
          @ ( bNF_rel_fun @ D @ F3 @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > C ) @ ( B > E ) @ ( ( A > D ) > $o ) @ ( ( B > F3 ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ E @ C2 @ A2 )
          @ ( bNF_rel_fun @ ( A > D ) @ ( B > F3 ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ D @ F3 @ C2 @ B2 )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( partial_fun_ord @ C @ D @ A )
        @ ( partial_fun_ord @ E @ F3 @ B ) ) ) )).

% fun_ord_parametric
thf(fact_124_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X4: A] : X4 ) ) )).

% id_apply
thf(fact_125_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_126_comp__id,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( comp @ A @ B @ A @ F @ ( id @ A ) )
      = F ) )).

% comp_id
thf(fact_127_id__comp,axiom,(
    ! [B: $tType,A: $tType,G: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G )
      = G ) )).

% id_comp
thf(fact_128_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_129_map__fun__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map_fun @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( A > B ) ) ) )).

% map_fun_id
thf(fact_130_llist_Omap__id0,axiom,(
    ! [A: $tType] :
      ( ( coinductive_lmap @ A @ A @ ( id @ A ) )
      = ( id @ ( coinductive_llist @ A ) ) ) )).

% llist.map_id0
thf(fact_131_eq__id__iff,axiom,(
    ! [A: $tType,F: ( A > A )] :
      ( ( ! [X4: A] :
            ( ( F @ X4 )
            = X4 ) )
      = ( F
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_132_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X4: A] : X4 ) ) )).

% id_def
thf(fact_133_llist_Obi__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ R )
     => ( bi_total @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.bi_total_rel
thf(fact_134_bi__total__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_total @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
            ( ! [X4: A] :
                ( ^ [P4: ( B > $o )] :
                  ? [X6: B] :
                    ( P4 @ X6 )
                @ ( R4 @ X4 ) )
            & ! [Y5: B] :
              ? [X4: A] :
                ( R4 @ X4 @ Y5 ) ) ) ) )).

% bi_total_def
thf(fact_135_bi__total__eq,axiom,(
    ! [A: $tType] :
      ( bi_total @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% bi_total_eq
thf(fact_136_id__rsp,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ A @ B @ R @ R @ ( id @ A ) @ ( id @ B ) ) )).

% id_rsp
thf(fact_137_id__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( bNF_rel_fun @ A @ B @ A @ B @ A2 @ A2 @ ( id @ A ) @ ( id @ B ) ) )).

% id_transfer
thf(fact_138_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),G: ( A > B ),X2: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X2 ) )
        = X2 ) ) )).

% pointfree_idE
thf(fact_139_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A3: ( C > B ),B3: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A3 @ B3 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C3 ) )
     => ( ( A3 @ ( B3 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_140_llist_Omap__id,axiom,(
    ! [A: $tType,T2: ( coinductive_llist @ A )] :
      ( ( coinductive_lmap @ A @ A @ ( id @ A ) @ T2 )
      = T2 ) )).

% llist.map_id
thf(fact_141_identity__quotient3,axiom,(
    ! [A: $tType] :
      ( quotient3 @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z )
      @ ( id @ A )
      @ ( id @ A ) ) )).

% identity_quotient3
thf(fact_142_abs__o__rep,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( comp @ A @ B @ B @ Abs @ Rep )
        = ( id @ B ) ) ) )).

% abs_o_rep
thf(fact_143_id__prs,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R @ Abs @ Rep )
     => ( ( map_fun @ B @ A @ A @ B @ Rep @ Abs @ ( id @ A ) )
        = ( id @ B ) ) ) )).

% id_prs
thf(fact_144_transfer__forall__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(1)
thf(fact_145_monotone__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( C > C > $o ) > ( A > C ) > $o ) @ ( ( D > D > $o ) > ( B > D ) > $o )
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( C > C > $o ) @ ( D > D > $o ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o )
          @ ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B2
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( comple1396247847notone @ A @ C )
        @ ( comple1396247847notone @ B @ D ) ) ) )).

% monotone_parametric
thf(fact_146_swap__comp__involutory,axiom,(
    ! [B: $tType,A: $tType,A3: A,B3: A] :
      ( ( comp @ ( A > B ) @ ( A > B ) @ ( A > B ) @ ( swap @ A @ B @ A3 @ B3 ) @ ( swap @ A @ B @ A3 @ B3 ) )
      = ( id @ ( A > B ) ) ) )).

% swap_comp_involutory
thf(fact_147_ex1__prs,axiom,(
    ! [A: $tType,B: $tType,R: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A ),F: ( B > $o )] :
      ( ( quotient3 @ A @ B @ R @ Absf @ Repf )
     => ( ( map_fun @ ( B > $o ) @ ( A > $o ) @ $o @ $o @ ( map_fun @ A @ B @ $o @ $o @ Absf @ ( id @ $o ) ) @ ( id @ $o ) @ ( bex1_rel @ A @ R ) @ F )
        = ( ? [X4: B] :
              ( ( F @ X4 )
              & ! [Y5: B] :
                  ( ( F @ Y5 )
                 => ( Y5 = X4 ) ) ) ) ) ) )).

% ex1_prs
thf(fact_148_swap__apply_I3_J,axiom,(
    ! [A: $tType,B: $tType,C3: B,A3: B,B3: B,F: ( B > A )] :
      ( ( C3 != A3 )
     => ( ( C3 != B3 )
       => ( ( swap @ B @ A @ A3 @ B3 @ F @ C3 )
          = ( F @ C3 ) ) ) ) )).

% swap_apply(3)
thf(fact_149_swap__apply_I2_J,axiom,(
    ! [A: $tType,B: $tType,A3: B,B3: B,F: ( B > A )] :
      ( ( swap @ B @ A @ A3 @ B3 @ F @ B3 )
      = ( F @ A3 ) ) )).

% swap_apply(2)
thf(fact_150_swap__apply_I1_J,axiom,(
    ! [A: $tType,B: $tType,A3: B,B3: B,F: ( B > A )] :
      ( ( swap @ B @ A @ A3 @ B3 @ F @ A3 )
      = ( F @ B3 ) ) )).

% swap_apply(1)
thf(fact_151_swap__self,axiom,(
    ! [B: $tType,A: $tType,A3: A,F: ( A > B )] :
      ( ( swap @ A @ B @ A3 @ A3 @ F )
      = F ) )).

% swap_self
thf(fact_152_swap__nilpotent,axiom,(
    ! [B: $tType,A: $tType,A3: A,B3: A,F: ( A > B )] :
      ( ( swap @ A @ B @ A3 @ B3 @ ( swap @ A @ B @ A3 @ B3 @ F ) )
      = F ) )).

% swap_nilpotent
thf(fact_153_swap__triple,axiom,(
    ! [B: $tType,A: $tType,A3: A,C3: A,B3: A,F: ( A > B )] :
      ( ( A3 != C3 )
     => ( ( B3 != C3 )
       => ( ( swap @ A @ B @ A3 @ B3 @ ( swap @ A @ B @ B3 @ C3 @ ( swap @ A @ B @ A3 @ B3 @ F ) ) )
          = ( swap @ A @ B @ A3 @ C3 @ F ) ) ) ) )).

% swap_triple
thf(fact_154_swap__commute,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( swap @ A @ B )
      = ( ^ [A5: A,B5: A] :
            ( swap @ A @ B @ B5 @ A5 ) ) ) )).

% swap_commute
thf(fact_155_comp__swap,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),A3: A,B3: A,G: ( A > C )] :
      ( ( comp @ C @ B @ A @ F @ ( swap @ A @ C @ A3 @ B3 @ G ) )
      = ( swap @ A @ B @ A3 @ B3 @ ( comp @ C @ B @ A @ F @ G ) ) ) )).

% comp_swap
thf(fact_156_transfer__forall__transfer_I4_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ rev_implies
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(4)
thf(fact_157_transfer__forall__transfer_I5_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ rev_implies ) @ rev_implies @ ( transfer_forall @ A ) @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(5)
thf(fact_158_Domainp__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B2: ( A > B > $o ),A2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( C > $o ) @ ( D > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ( domainp @ C @ A )
        @ ( domainp @ D @ B ) ) ) )).

% Domainp_transfer
thf(fact_159_rev__implies__def,axiom,
    ( rev_implies
    = ( ^ [X4: $o,Y5: $o] :
          ( Y5
         => X4 ) ) )).

% rev_implies_def
thf(fact_160_Domainp__refl,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( domainp @ A @ B )
      = ( domainp @ A @ B ) ) )).

% Domainp_refl
thf(fact_161_Domainp__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( domainp @ A @ B )
      = ( ^ [T3: ( A > B > $o ),X4: A] :
            ( ^ [P4: ( B > $o )] :
              ? [X6: B] :
                ( P4 @ X6 )
            @ ( T3 @ X4 ) ) ) ) )).

% Domainp_iff
thf(fact_162_llist_ODomainp__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( domainp @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) )
      = ( coindu543516966_llist @ A @ ( domainp @ A @ B @ R ) ) ) )).

% llist.Domainp_rel
thf(fact_163_reflp__transfer_I5_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ rev_implies
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(5)
thf(fact_164_reflp__transfer_I4_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ rev_implies ) ) @ rev_implies @ ( reflp @ A ) @ ( reflp @ B ) ) ) )).

% reflp_transfer(4)
thf(fact_165_Ex1__parametric,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( bi_total @ A @ B @ A2 )
       => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ ( ex1 @ A )
          @ ( ex1 @ B ) ) ) ) )).

% Ex1_parametric
thf(fact_166_bi__unique__fun,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_unique @ C @ D @ B2 )
       => ( bi_unique @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) ) )).

% bi_unique_fun
thf(fact_167_fun_Orel__reflp,axiom,(
    ! [D: $tType,A: $tType,R: ( A > A > $o )] :
      ( ( reflp @ A @ R )
     => ( reflp @ ( D > A )
        @ ( bNF_rel_fun @ D @ D @ A @ A
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ R ) ) ) )).

% fun.rel_reflp
thf(fact_168_DEADID_Orel__reflp,axiom,(
    ! [A: $tType] :
      ( reflp @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% DEADID.rel_reflp
thf(fact_169_bi__uniqueDl,axiom,(
    ! [B: $tType,A: $tType,A2: ( A > B > $o ),X2: A,Y2: B,Z2: A] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( A2 @ X2 @ Y2 )
       => ( ( A2 @ Z2 @ Y2 )
         => ( X2 = Z2 ) ) ) ) )).

% bi_uniqueDl
thf(fact_170_bi__uniqueDr,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o ),X2: A,Y2: B,Z2: B] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( A2 @ X2 @ Y2 )
       => ( ( A2 @ X2 @ Z2 )
         => ( Y2 = Z2 ) ) ) ) )).

% bi_uniqueDr
thf(fact_171_bi__unique__eq,axiom,(
    ! [A: $tType] :
      ( bi_unique @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% bi_unique_eq
thf(fact_172_bi__unique__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_unique @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
            ( ! [X4: A,Y5: B,Z3: B] :
                ( ( R4 @ X4 @ Y5 )
               => ( ( R4 @ X4 @ Z3 )
                 => ( Y5 = Z3 ) ) )
            & ! [X4: A,Y5: A,Z3: B] :
                ( ( R4 @ X4 @ Z3 )
               => ( ( R4 @ Y5 @ Z3 )
                 => ( X4 = Y5 ) ) ) ) ) ) )).

% bi_unique_def
thf(fact_173_llist_Orel__reflp,axiom,(
    ! [A: $tType,R: ( A > A > $o )] :
      ( ( reflp @ A @ R )
     => ( reflp @ ( coinductive_llist @ A ) @ ( coindu1486289336t_all2 @ A @ A @ R ) ) ) )).

% llist.rel_reflp
thf(fact_174_llist_Obi__unique__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( bi_unique @ A @ B @ R )
     => ( bi_unique @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.bi_unique_rel
thf(fact_175_bi__total__fun,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( bi_total @ C @ D @ B2 )
       => ( bi_total @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) ) )).

% bi_total_fun
thf(fact_176_eq__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) ) ) )).

% eq_transfer
thf(fact_177_bi__unique__alt__def2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_unique @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
            ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ R4
            @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R4
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
            @ ^ [Y3: A,Z: A] : ( Y3 = Z )
            @ ^ [Y3: B,Z: B] : ( Y3 = Z ) ) ) ) )).

% bi_unique_alt_def2
thf(fact_178_reflp__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(1)
thf(fact_179_fun__upd__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ ( A > C > A > C ) @ ( B > D > B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) @ ( bNF_rel_fun @ A @ B @ ( C > A > C ) @ ( D > B > D ) @ A2 @ ( bNF_rel_fun @ C @ D @ ( A > C ) @ ( B > D ) @ B2 @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) @ ( fun_upd @ A @ C ) @ ( fun_upd @ B @ D ) ) ) )).

% fun_upd_transfer
thf(fact_180_right__unique__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_unique @ C @ D @ B2 )
       => ( ( bi_total @ C @ D @ B2 )
         => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
            @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
              @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
                @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
            @ ( right_unique @ A @ C )
            @ ( right_unique @ B @ D ) ) ) ) ) )).

% right_unique_parametric
thf(fact_181_left__unique__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( bi_total @ A @ B @ A2 )
       => ( ( bi_total @ C @ D @ B2 )
         => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
            @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
              @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
                @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
            @ ( left_unique @ A @ C )
            @ ( left_unique @ B @ D ) ) ) ) ) )).

% left_unique_parametric
thf(fact_182_fun__upd__apply,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( fun_upd @ B @ A )
      = ( ^ [F2: ( B > A ),X4: B,Y5: A,Z3: B] :
            ( if @ A @ ( Z3 = X4 ) @ Y5 @ ( F2 @ Z3 ) ) ) ) )).

% fun_upd_apply
thf(fact_183_fun__upd__triv,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X2: A] :
      ( ( fun_upd @ A @ B @ F @ X2 @ ( F @ X2 ) )
      = F ) )).

% fun_upd_triv
thf(fact_184_fun__upd__upd,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X2: A,Y2: B,Z2: B] :
      ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F @ X2 @ Y2 ) @ X2 @ Z2 )
      = ( fun_upd @ A @ B @ F @ X2 @ Z2 ) ) )).

% fun_upd_upd
thf(fact_185_bi__uniqueI,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_unique @ A @ B @ R )
     => ( ( right_unique @ A @ B @ R )
       => ( bi_unique @ A @ B @ R ) ) ) )).

% bi_uniqueI
thf(fact_186_bi__unique__alt__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_unique @ A @ B )
      = ( ^ [A6: ( A > B > $o )] :
            ( ( left_unique @ A @ B @ A6 )
            & ( right_unique @ A @ B @ A6 ) ) ) ) )).

% bi_unique_alt_def
thf(fact_187_fun__upd__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),G: ( A > C ),X2: A,Y2: C] :
      ( ( comp @ C @ B @ A @ F @ ( fun_upd @ A @ C @ G @ X2 @ Y2 ) )
      = ( fun_upd @ A @ B @ ( comp @ C @ B @ A @ F @ G ) @ X2 @ ( F @ Y2 ) ) ) )).

% fun_upd_comp
thf(fact_188_fun__upd__idem__iff,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X2: A,Y2: B] :
      ( ( ( fun_upd @ A @ B @ F @ X2 @ Y2 )
        = F )
      = ( ( F @ X2 )
        = Y2 ) ) )).

% fun_upd_idem_iff
thf(fact_189_fun__upd__twist,axiom,(
    ! [A: $tType,B: $tType,A3: A,C3: A,M2: ( A > B ),B3: B,D3: B] :
      ( ( A3 != C3 )
     => ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M2 @ A3 @ B3 ) @ C3 @ D3 )
        = ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M2 @ C3 @ D3 ) @ A3 @ B3 ) ) ) )).

% fun_upd_twist
thf(fact_190_fun__upd__other,axiom,(
    ! [B: $tType,A: $tType,Z2: A,X2: A,F: ( A > B ),Y2: B] :
      ( ( Z2 != X2 )
     => ( ( fun_upd @ A @ B @ F @ X2 @ Y2 @ Z2 )
        = ( F @ Z2 ) ) ) )).

% fun_upd_other
thf(fact_191_fun__upd__same,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),X2: B,Y2: A] :
      ( ( fun_upd @ B @ A @ F @ X2 @ Y2 @ X2 )
      = Y2 ) )).

% fun_upd_same
thf(fact_192_fun__upd__idem,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X2: B,Y2: A] :
      ( ( ( F @ X2 )
        = Y2 )
     => ( ( fun_upd @ B @ A @ F @ X2 @ Y2 )
        = F ) ) )).

% fun_upd_idem
thf(fact_193_fun__upd__eqD,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),X2: A,Y2: B,G: ( A > B ),Z2: B] :
      ( ( ( fun_upd @ A @ B @ F @ X2 @ Y2 )
        = ( fun_upd @ A @ B @ G @ X2 @ Z2 ) )
     => ( Y2 = Z2 ) ) )).

% fun_upd_eqD
thf(fact_194_fun__upd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_upd @ A @ B )
      = ( ^ [F2: ( A > B ),A5: A,B5: B,X4: A] :
            ( if @ B @ ( X4 = A5 ) @ B5 @ ( F2 @ X4 ) ) ) ) )).

% fun_upd_def
thf(fact_195_right__unique__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( right_unique @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
          ! [X4: A,Y5: B,Z3: B] :
            ( ( R4 @ X4 @ Y5 )
           => ( ( R4 @ X4 @ Z3 )
             => ( Y5 = Z3 ) ) ) ) ) )).

% right_unique_def
thf(fact_196_right__unique__eq,axiom,(
    ! [A: $tType] :
      ( right_unique @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% right_unique_eq
thf(fact_197_left__unique__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( left_unique @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
          ! [X4: A,Y5: A,Z3: B] :
            ( ( R4 @ X4 @ Z3 )
           => ( ( R4 @ Y5 @ Z3 )
             => ( X4 = Y5 ) ) ) ) ) )).

% left_unique_def
thf(fact_198_left__unique__eq,axiom,(
    ! [A: $tType] :
      ( left_unique @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% left_unique_eq
thf(fact_199_right__uniqueI,axiom,(
    ! [B: $tType,A: $tType,A2: ( A > B > $o )] :
      ( ! [X: A,Y: B,Z4: B] :
          ( ( A2 @ X @ Y )
         => ( ( A2 @ X @ Z4 )
           => ( Y = Z4 ) ) )
     => ( right_unique @ A @ B @ A2 ) ) )).

% right_uniqueI
thf(fact_200_right__uniqueD,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o ),X2: A,Y2: B,Z2: B] :
      ( ( right_unique @ A @ B @ A2 )
     => ( ( A2 @ X2 @ Y2 )
       => ( ( A2 @ X2 @ Z2 )
         => ( Y2 = Z2 ) ) ) ) )).

% right_uniqueD
thf(fact_201_left__uniqueI,axiom,(
    ! [B: $tType,A: $tType,A2: ( A > B > $o )] :
      ( ! [X: A,Y: A,Z4: B] :
          ( ( A2 @ X @ Z4 )
         => ( ( A2 @ Y @ Z4 )
           => ( X = Y ) ) )
     => ( left_unique @ A @ B @ A2 ) ) )).

% left_uniqueI
thf(fact_202_left__uniqueD,axiom,(
    ! [B: $tType,A: $tType,A2: ( A > B > $o ),X2: A,Z2: B,Y2: A] :
      ( ( left_unique @ A @ B @ A2 )
     => ( ( A2 @ X2 @ Z2 )
       => ( ( A2 @ Y2 @ Z2 )
         => ( X2 = Y2 ) ) ) ) )).

% left_uniqueD
thf(fact_203_llist_Oright__unique__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( right_unique @ A @ B @ R )
     => ( right_unique @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.right_unique_rel
thf(fact_204_llist_Oleft__unique__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_unique @ A @ B @ R )
     => ( left_unique @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.left_unique_rel
thf(fact_205_swap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( swap @ A @ B )
      = ( ^ [A5: A,B5: A,F2: ( A > B )] :
            ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F2 @ A5 @ ( F2 @ B5 ) ) @ B5 @ ( F2 @ A5 ) ) ) ) )).

% swap_def
thf(fact_206_right__unique__alt__def2,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( right_unique @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
            ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ R4 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R4 @ => )
            @ ^ [Y3: A,Z: A] : ( Y3 = Z )
            @ ^ [Y3: B,Z: B] : ( Y3 = Z ) ) ) ) )).

% right_unique_alt_def2
thf(fact_207_eq__imp__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_unique @ A @ B @ A2 )
     => ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ => )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) ) ) )).

% eq_imp_transfer
thf(fact_208_left__unique__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( ( right_total @ C @ D @ B2 )
       => ( ( bi_unique @ A @ B @ A2 )
         => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
            @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
              @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
                @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
            @ =>
            @ ( left_unique @ A @ C )
            @ ( left_unique @ B @ D ) ) ) ) ) )).

% left_unique_transfer
thf(fact_209_right__unique__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( ( right_total @ C @ D @ B2 )
       => ( ( bi_unique @ C @ D @ B2 )
         => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
            @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
              @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
                @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
            @ =>
            @ ( right_unique @ A @ C )
            @ ( right_unique @ B @ D ) ) ) ) ) )).

% right_unique_transfer
thf(fact_210_rtranclp__parametric,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( bi_total @ A @ B @ A2 )
       => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( A > A > $o ) @ ( B > B > $o )
          @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
            @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
            @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( transitive_rtranclp @ A )
          @ ( transitive_rtranclp @ B ) ) ) ) )).

% rtranclp_parametric
thf(fact_211_right__total__fun,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( right_unique @ A @ B @ A2 )
     => ( ( right_total @ C @ D @ B2 )
       => ( right_total @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) ) )).

% right_total_fun
thf(fact_212_functional__converse__relation,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_unique @ A @ B @ R )
     => ( ( right_total @ A @ B @ R )
       => ! [Y6: B] :
          ? [X: A] :
            ( ( R @ X @ Y6 )
            & ! [Ya3: A] :
                ( ( R @ Ya3 @ Y6 )
               => ( Ya3 = X ) ) ) ) ) )).

% functional_converse_relation
thf(fact_213_right__totalE,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o ),Y2: B] :
      ( ( right_total @ A @ B @ A2 )
     => ~ ( ! [X: A] :
              ~ ( A2 @ X @ Y2 ) ) ) )).

% right_totalE
thf(fact_214_right__totalI,axiom,(
    ! [A: $tType,B: $tType,A2: ( B > A > $o )] :
      ( ! [Y: A] :
        ? [X7: B] :
          ( A2 @ X7 @ Y )
     => ( right_total @ B @ A @ A2 ) ) )).

% right_totalI
thf(fact_215_right__total__eq,axiom,(
    ! [A: $tType] :
      ( right_total @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% right_total_eq
thf(fact_216_right__total__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( right_total @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
          ! [Y5: B] :
          ? [X4: A] :
            ( R4 @ X4 @ Y5 ) ) ) )).

% right_total_def
thf(fact_217_llist_Oright__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( right_total @ A @ B @ R )
     => ( right_total @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.right_total_rel
thf(fact_218_right__unique__fun,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( ( right_unique @ C @ D @ B2 )
       => ( right_unique @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) ) )).

% right_unique_fun
thf(fact_219_transfer__forall__transfer_I3_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ => ) @ => @ ( transfer_forall @ A ) @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(3)
thf(fact_220_transfer__forall__transfer_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ =>
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(2)
thf(fact_221_right__total__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_total @ C @ D @ B2 )
       => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
          @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ ( right_total @ A @ C )
          @ ( right_total @ B @ D ) ) ) ) )).

% right_total_parametric
thf(fact_222_reflp__transfer_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2 @ => ) ) @ => @ ( reflp @ A ) @ ( reflp @ B ) ) ) )).

% reflp_transfer(2)
thf(fact_223_reflp__transfer_I3_J,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ =>
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(3)
thf(fact_224_Domainp__forall__transfer,axiom,(
    ! [A: $tType,B: $tType,A2: ( A > B > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
        @ ( transfer_bforall @ A @ ( domainp @ A @ B @ A2 ) )
        @ ( transfer_forall @ B ) ) ) )).

% Domainp_forall_transfer
thf(fact_225_left__total__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_total @ C @ D @ B2 )
       => ( bNF_rel_fun @ ( A > C > $o ) @ ( B > D > $o ) @ $o @ $o
          @ ( bNF_rel_fun @ A @ B @ ( C > $o ) @ ( D > $o ) @ A2
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
          @ ( left_total @ A @ C )
          @ ( left_total @ B @ D ) ) ) ) )).

% left_total_parametric
thf(fact_226_left__total__fun,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( left_unique @ A @ B @ A2 )
     => ( ( left_total @ C @ D @ B2 )
       => ( left_total @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) ) )).

% left_total_fun
thf(fact_227_functional__relation,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( ( right_unique @ A @ B @ R )
     => ( ( left_total @ A @ B @ R )
       => ! [X7: A] :
          ? [Xa2: B] :
            ( ( R @ X7 @ Xa2 )
            & ! [Y6: B] :
                ( ( R @ X7 @ Y6 )
               => ( Y6 = Xa2 ) ) ) ) ) )).

% functional_relation
thf(fact_228_left__unique__fun,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,A2: ( A > B > $o ),B2: ( C > D > $o )] :
      ( ( left_total @ A @ B @ A2 )
     => ( ( left_unique @ C @ D @ B2 )
       => ( left_unique @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ B @ C @ D @ A2 @ B2 ) ) ) ) )).

% left_unique_fun
thf(fact_229_left__total__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( left_total @ A @ B )
      = ( ^ [R4: ( A > B > $o )] :
          ! [X4: A] :
            ( ^ [P4: ( B > $o )] :
              ? [X6: B] :
                ( P4 @ X6 )
            @ ( R4 @ X4 ) ) ) ) )).

% left_total_def
thf(fact_230_left__total__eq,axiom,(
    ! [A: $tType] :
      ( left_total @ A @ A
      @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )).

% left_total_eq
thf(fact_231_left__totalI,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ! [X: A] :
        ? [X12: B] :
          ( R @ X @ X12 )
     => ( left_total @ A @ B @ R ) ) )).

% left_totalI
thf(fact_232_left__totalE,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ! [X7: A] :
        ? [X13: B] :
          ( R @ X7 @ X13 ) ) )).

% left_totalE
thf(fact_233_llist_Oleft__total__rel,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( left_total @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coindu1486289336t_all2 @ A @ B @ R ) ) ) )).

% llist.left_total_rel
thf(fact_234_bi__totalI,axiom,(
    ! [B: $tType,A: $tType,R: ( A > B > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( ( right_total @ A @ B @ R )
       => ( bi_total @ A @ B @ R ) ) ) )).

% bi_totalI
thf(fact_235_bi__total__alt__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bi_total @ A @ B )
      = ( ^ [A6: ( A > B > $o )] :
            ( ( left_total @ A @ B @ A6 )
            & ( right_total @ A @ B @ A6 ) ) ) ) )).

% bi_total_alt_def
thf(fact_236_lhd__lfilter,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_lfilter @ A @ P @ Xs ) )
      = ( coinductive_lhd @ A @ ( coindu218763757pWhile @ A @ ( comp @ $o @ $o @ A @ ~ @ P ) @ Xs ) ) ) )).

% lhd_lfilter
thf(fact_237_relcompp__transfer,axiom,(
    ! [C: $tType,A: $tType,E: $tType,F3: $tType,B: $tType,D: $tType,B2: ( A > B > $o ),A2: ( C > D > $o ),C2: ( E > F3 > $o )] :
      ( ( bi_total @ A @ B @ B2 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( ( A > E > $o ) > C > E > $o ) @ ( ( B > F3 > $o ) > D > F3 > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A2
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > E > $o ) @ ( B > F3 > $o ) @ ( C > E > $o ) @ ( D > F3 > $o )
          @ ( bNF_rel_fun @ A @ B @ ( E > $o ) @ ( F3 > $o ) @ B2
            @ ( bNF_rel_fun @ E @ F3 @ $o @ $o @ C2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
          @ ( bNF_rel_fun @ C @ D @ ( E > $o ) @ ( F3 > $o ) @ A2
            @ ( bNF_rel_fun @ E @ F3 @ $o @ $o @ C2
              @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) ) )
        @ ( relcompp @ C @ A @ E )
        @ ( relcompp @ D @ B @ F3 ) ) ) )).

% relcompp_transfer
thf(fact_238_pcr__Domainp__par__left__total,axiom,(
    ! [A: $tType,B: $tType,C: $tType,B2: ( A > B > $o ),P: ( A > $o ),A2: ( C > A > $o ),P2: ( C > $o )] :
      ( ( ( domainp @ A @ B @ B2 )
        = P )
     => ( ( left_total @ C @ A @ A2 )
       => ( ( bNF_rel_fun @ C @ A @ $o @ $o @ A2
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z )
            @ P2
            @ P )
         => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A2 @ B2 ) )
            = P2 ) ) ) ) )).

% pcr_Domainp_par_left_total
thf(fact_239_right__unique__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: ( A > B > $o ),B2: ( B > C > $o )] :
      ( ( right_unique @ A @ B @ A2 )
     => ( ( right_unique @ B @ C @ B2 )
       => ( right_unique @ A @ C @ ( relcompp @ A @ B @ C @ A2 @ B2 ) ) ) ) )).

% right_unique_OO
thf(fact_240_right__total__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: ( A > B > $o ),B2: ( B > C > $o )] :
      ( ( right_total @ A @ B @ A2 )
     => ( ( right_total @ B @ C @ B2 )
       => ( right_total @ A @ C @ ( relcompp @ A @ B @ C @ A2 @ B2 ) ) ) ) )).

% right_total_OO
thf(fact_241_pcr__Domainp__total,axiom,(
    ! [A: $tType,B: $tType,C: $tType,B2: ( A > B > $o ),A2: ( C > A > $o ),P: ( C > $o )] :
      ( ( left_total @ A @ B @ B2 )
     => ( ( ( domainp @ C @ A @ A2 )
          = P )
       => ( ( domainp @ C @ B @ ( relcompp @ C @ A @ B @ A2 @ B2 ) )
          = P ) ) ) )).

% pcr_Domainp_total
thf(fact_242_left__total__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( left_total @ A @ B @ R )
     => ( ( left_total @ B @ C @ S )
       => ( left_total @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) ) ) ) )).

% left_total_OO
thf(fact_243_bi__unique__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: ( A > B > $o ),B2: ( B > C > $o )] :
      ( ( bi_unique @ A @ B @ A2 )
     => ( ( bi_unique @ B @ C @ B2 )
       => ( bi_unique @ A @ C @ ( relcompp @ A @ B @ C @ A2 @ B2 ) ) ) ) )).

% bi_unique_OO
thf(fact_244_bi__total__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,A2: ( A > B > $o ),B2: ( B > C > $o )] :
      ( ( bi_total @ A @ B @ A2 )
     => ( ( bi_total @ B @ C @ B2 )
       => ( bi_total @ A @ C @ ( relcompp @ A @ B @ C @ A2 @ B2 ) ) ) ) )).

% bi_total_OO
thf(fact_245_lhd__LCons,axiom,(
    ! [A: $tType,X21: A,X222: ( coinductive_llist @ A )] :
      ( ( coinductive_lhd @ A @ ( coinductive_LCons @ A @ X21 @ X222 ) )
      = X21 ) )).

% lhd_LCons
thf(fact_246_lhd__iterates,axiom,(
    ! [A: $tType,F: ( A > A ),X2: A] :
      ( ( coinductive_lhd @ A @ ( coinductive_iterates @ A @ F @ X2 ) )
      = X2 ) )).

% lhd_iterates
thf(fact_247_unfold__llist_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,P3: ( A > $o ),A3: A,G21: ( A > B ),G22: ( A > A )] :
      ( ~ ( P3 @ A3 )
     => ( ( coinductive_lhd @ B @ ( coindu1441602521_llist @ A @ B @ P3 @ G21 @ G22 @ A3 ) )
        = ( G21 @ A3 ) ) ) )).

% unfold_llist.simps(3)
thf(fact_248_llist_Ocorec__sel_I1_J,axiom,(
    ! [A: $tType,C: $tType,P3: ( C > $o ),A3: C,G21: ( C > A ),Q22: ( C > $o ),G221: ( C > ( coinductive_llist @ A ) ),G222: ( C > C )] :
      ( ~ ( P3 @ A3 )
     => ( ( coinductive_lhd @ A @ ( coindu1259883913_llist @ C @ A @ P3 @ G21 @ Q22 @ G221 @ G222 @ A3 ) )
        = ( G21 @ A3 ) ) ) )).

% llist.corec_sel(1)
thf(fact_249_eq__comp__r,axiom,(
    ! [A: $tType,R: ( A > A > $o )] :
      ( ( relcompp @ A @ A @ A
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( relcompp @ A @ A @ A @ R
          @ ^ [Y3: A,Z: A] : ( Y3 = Z ) ) )
      = R ) )).

% eq_comp_r
thf(fact_250_llist_Orel__compp,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( coindu1486289336t_all2 @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) )
      = ( relcompp @ ( coinductive_llist @ A ) @ ( coinductive_llist @ B ) @ ( coinductive_llist @ C ) @ ( coindu1486289336t_all2 @ A @ B @ R ) @ ( coindu1486289336t_all2 @ B @ C @ S ) ) ) )).

% llist.rel_compp
thf(fact_251_OOO__eq__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),Abs22: ( B > C ),Rep22: ( C > B )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ B @ C
          @ ^ [Y3: B,Z: B] : ( Y3 = Z )
          @ Abs22
          @ Rep22 )
       => ( quotient3 @ A @ C
          @ ( relcompp @ A @ A @ A @ R1
            @ ( relcompp @ A @ A @ A
              @ ^ [Y3: A,Z: A] : ( Y3 = Z )
              @ R1 ) )
          @ ( comp @ B @ C @ A @ Abs22 @ Abs12 )
          @ ( comp @ B @ A @ C @ Rep12 @ Rep22 ) ) ) ) )).

% OOO_eq_quotient3
thf(fact_252_OOO__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( B > B > $o ),Abs22: ( B > C ),Rep22: ( C > B ),R23: ( A > A > $o )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ B @ C @ R2 @ Abs22 @ Rep22 )
       => ( ! [X: A,Y: A] :
              ( ( R23 @ X @ Y )
             => ( ( R1 @ X @ X )
               => ( ( R1 @ Y @ Y )
                 => ( R2 @ ( Abs12 @ X ) @ ( Abs12 @ Y ) ) ) ) )
         => ( ! [X: B,Y: B] :
                ( ( R2 @ X @ Y )
               => ( R23 @ ( Rep12 @ X ) @ ( Rep12 @ Y ) ) )
           => ( quotient3 @ A @ C @ ( relcompp @ A @ A @ A @ R1 @ ( relcompp @ A @ A @ A @ R23 @ R1 ) ) @ ( comp @ B @ C @ A @ Abs22 @ Abs12 ) @ ( comp @ B @ A @ C @ Rep12 @ Rep22 ) ) ) ) ) ) )).

% OOO_quotient3
thf(fact_253_left__unique__OO,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( left_unique @ A @ B @ R )
     => ( ( left_unique @ B @ C @ S )
       => ( left_unique @ A @ C @ ( relcompp @ A @ B @ C @ R @ S ) ) ) ) )).

% left_unique_OO
thf(fact_254_fun_Orel__compp,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType,R: ( A > B > $o ),S: ( B > C > $o )] :
      ( ( bNF_rel_fun @ D @ D @ A @ C
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ( relcompp @ A @ B @ C @ R @ S ) )
      = ( relcompp @ ( D > A ) @ ( D > B ) @ ( D > C )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ R )
        @ ( bNF_rel_fun @ D @ D @ B @ C
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ S ) ) ) )).

% fun.rel_compp
thf(fact_255_neg__fun__distr2,axiom,(
    ! [F3: $tType,E: $tType,A: $tType,B: $tType,D: $tType,C: $tType,R7: ( A > B > $o ),S5: ( C > D > $o ),R: ( E > A > $o ),S: ( F3 > C > $o )] :
      ( ( right_unique @ A @ B @ R7 )
     => ( ( left_total @ A @ B @ R7 )
       => ( ( left_unique @ C @ D @ S5 )
         => ( ( right_total @ C @ D @ S5 )
           => ( ord_less_eq @ ( ( E > F3 ) > ( B > D ) > $o ) @ ( bNF_rel_fun @ E @ B @ F3 @ D @ ( relcompp @ E @ A @ B @ R @ R7 ) @ ( relcompp @ F3 @ C @ D @ S @ S5 ) ) @ ( relcompp @ ( E > F3 ) @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ E @ A @ F3 @ C @ R @ S ) @ ( bNF_rel_fun @ A @ B @ C @ D @ R7 @ S5 ) ) ) ) ) ) ) )).

% neg_fun_distr2

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $false @ X2 @ Y2 )
      = Y2 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $true @ X2 @ Y2 )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( bNF_rel_fun @ ( coinductive_llist @ a ) @ ( coinductive_llist @ b ) @ ( coinductive_llist @ a ) @ ( coinductive_llist @ b ) @ ( coindu1486289336t_all2 @ a @ b @ a2 ) @ ( coindu1486289336t_all2 @ a @ b @ a2 ) @ ( lMirro427583474mirror @ a ) @ ( lMirro427583474mirror @ b ) )).

%------------------------------------------------------------------------------
