%------------------------------------------------------------------------------
% File     : DAT204^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Sorted list operations 166
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Lam09] Lammich (2009), Collections Framework
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : sorted_list_operations__166.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  343 (   0 unit;  52 type;   0 defn)
%            Number of atoms       : 4687 ( 353 equality;2887 variable)
%            Maximal formula depth :   25 (   9 average)
%            Number of connectives : 4330 ( 132   ~;   9   |;  90   &;3693   @)
%                                         (   0 <=>; 406  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  209 ( 209   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   56 (  52   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1162 (   3 sgn;1027   !;  63   ?;  25   ^)
%                                         (1162   :;  47  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:40:57.799
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (47)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite2: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Ocan__select,type,(
    can_select: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_List_Ocoset,type,(
    coset: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Ocount__list,type,(
    count_list: 
      !>[A: $tType] :
        ( ( list @ A ) > A > nat ) )).

thf(sy_c_List_Odistinct,type,(
    distinct: 
      !>[A: $tType] :
        ( ( list @ A ) > $o ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olinorder__class_Osorted,type,(
    linorder_sorted: 
      !>[A: $tType] :
        ( ( list @ A ) > $o ) )).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,(
    linord467138063of_set: 
      !>[A: $tType] :
        ( ( set @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omember,type,(
    member: 
      !>[A: $tType] :
        ( ( list @ A ) > A > $o ) )).

thf(sy_c_List_On__lists,type,(
    n_lists: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublist,type,(
    sublist: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Ounion,type,(
    union: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List__More_Ocombinatorial__product,type,(
    list_c659805718roduct: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_Misc_Omergesort__remdups,type,(
    mergesort_remdups: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Sorted__List__Operations__Mirabelle__fineeiboro_Osubset__sorted,type,(
    sorted1061247458sorted: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_member,type,(
    member2: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_l1,type,(
    l1: ( list @ a ) )).

thf(sy_v_l2,type,(
    l2: ( list @ a ) )).

%----Relevant facts (255)
thf(fact_0_l1__OK,axiom,
    ( ( distinct @ a @ l1 )
    & ( linorder_sorted @ a @ l1 ) )).

% l1_OK
thf(fact_1_l2__OK,axiom,
    ( ( distinct @ a @ l2 )
    & ( linorder_sorted @ a @ l2 ) )).

% l2_OK
thf(fact_2_subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ! [X: A] :
          ( ( member2 @ A @ X @ A2 )
         => ( member2 @ A @ X @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% subsetI
thf(fact_3_subset__antisym,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A2 )
       => ( A2 = B2 ) ) ) )).

% subset_antisym
thf(fact_4_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ X2 @ X2 ) ) )).

% order_refl
thf(fact_5_subset__code_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B2 )
      = ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( member2 @ A @ X3 @ B2 ) ) ) ) )).

% subset_code(1)
thf(fact_6_set__mp,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ X2 @ A2 )
       => ( member2 @ A @ X2 @ B2 ) ) ) )).

% set_mp
thf(fact_7_in__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ X2 @ A2 )
       => ( member2 @ A @ X2 @ B2 ) ) ) )).

% in_mono
thf(fact_8_subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ C @ A2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% subsetD
thf(fact_9_subsetCE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( member2 @ A @ C @ A2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% subsetCE
thf(fact_10_equalityE,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) ) )).

% equalityE
thf(fact_11_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A3: ( set @ A ),B3: ( set @ A )] :
          ! [X3: A] :
            ( ( member2 @ A @ X3 @ A3 )
           => ( member2 @ A @ X3 @ B3 ) ) ) ) )).

% subset_eq
thf(fact_12_equalityD1,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ B2 ) ) )).

% equalityD1
thf(fact_13_equalityD2,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( A2 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A2 ) ) )).

% equalityD2
thf(fact_14_sorted__distinct__set__unique,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( linorder_sorted @ A @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linorder_sorted @ A @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs = Ys ) ) ) ) ) ) ) )).

% sorted_distinct_set_unique
thf(fact_15_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A] :
          ( ( ord_less_eq @ A @ B4 @ A4 )
         => ( ( ord_less_eq @ A @ A4 @ B4 )
           => ( A4 = B4 ) ) ) ) )).

% dual_order.antisym
thf(fact_16_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A4: A,C: A] :
          ( ( ord_less_eq @ A @ B4 @ A4 )
         => ( ( ord_less_eq @ A @ C @ B4 )
           => ( ord_less_eq @ A @ C @ A4 ) ) ) ) )).

% dual_order.trans
thf(fact_17_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A4: A,B4: A] :
          ( ! [A5: A,B5: A] :
              ( ( ord_less_eq @ A @ A5 @ B5 )
             => ( P @ A5 @ B5 ) )
         => ( ! [A5: A,B5: A] :
                ( ( P @ B5 @ A5 )
               => ( P @ A5 @ B5 ) )
           => ( P @ A4 @ B4 ) ) ) ) )).

% linorder_wlog
thf(fact_18_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ord_less_eq @ A @ A4 @ A4 ) ) )).

% dual_order.refl
thf(fact_19_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X2 @ Z ) ) ) ) )).

% order_trans
thf(fact_20_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ A4 )
           => ( A4 = B4 ) ) ) ) )).

% order_class.order.antisym
thf(fact_21_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( B4 = C )
           => ( ord_less_eq @ A @ A4 @ C ) ) ) ) )).

% ord_le_eq_trans
thf(fact_22_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( A4 = B4 )
         => ( ( ord_less_eq @ A @ B4 @ C )
           => ( ord_less_eq @ A @ A4 @ C ) ) ) ) )).

% ord_eq_le_trans
thf(fact_23_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X2: A] :
          ( ( ord_less_eq @ A @ Y @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y )
            = ( X2 = Y ) ) ) ) )).

% antisym_conv
thf(fact_24_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_25_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ C )
           => ( ord_less_eq @ A @ A4 @ C ) ) ) ) )).

% order.trans
thf(fact_26_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y )
         => ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% le_cases
thf(fact_27_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( X2 = Y )
         => ( ord_less_eq @ A @ X2 @ Y ) ) ) )).

% eq_refl
thf(fact_28_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
          | ( ord_less_eq @ A @ Y @ X2 ) ) ) )).

% linear
thf(fact_29_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X2 )
           => ( X2 = Y ) ) ) ) )).

% antisym
thf(fact_30_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y2: A,Z2: A] : ( Y2 = Z2 ) )
        = ( ^ [X3: A,Y3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y3 )
              & ( ord_less_eq @ A @ Y3 @ X3 ) ) ) ) ) )).

% eq_iff
thf(fact_31_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > B ),C: B] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ( F @ B4 )
              = C )
           => ( ! [X: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X @ Y4 )
                 => ( ord_less_eq @ B @ ( F @ X ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ B @ ( F @ A4 ) @ C ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_32_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( A4
            = ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C )
           => ( ! [X: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_33_order__subst2,axiom,(
    ! [A: $tType,C2: $tType] :
      ( ( ( order @ C2 @ ( type2 @ C2 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B4: A,F: ( A > C2 ),C: C2] :
          ( ( ord_less_eq @ A @ A4 @ B4 )
         => ( ( ord_less_eq @ C2 @ ( F @ B4 ) @ C )
           => ( ! [X: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X @ Y4 )
                 => ( ord_less_eq @ C2 @ ( F @ X ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ C2 @ ( F @ A4 ) @ C ) ) ) ) ) )).

% order_subst2
thf(fact_34_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F: ( B > A ),B4: B,C: B] :
          ( ( ord_less_eq @ A @ A4 @ ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C )
           => ( ! [X: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X @ Y4 )
                 => ( ord_less_eq @ A @ ( F @ X ) @ ( F @ Y4 ) ) )
             => ( ord_less_eq @ A @ A4 @ ( F @ C ) ) ) ) ) ) )).

% order_subst1
thf(fact_35_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G: ( A > B )] :
            ! [X3: A] :
              ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) ) ) ) )).

% le_fun_def
thf(fact_36_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G2: ( A > B )] :
          ( ! [X: A] :
              ( ord_less_eq @ B @ ( F @ X ) @ ( G2 @ X ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G2 ) ) ) )).

% le_funI
thf(fact_37_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G2: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G2 )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G2 @ X2 ) ) ) ) )).

% le_funE
thf(fact_38_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G2: ( A > B ),X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G2 )
         => ( ord_less_eq @ B @ ( F @ X2 ) @ ( G2 @ X2 ) ) ) ) )).

% le_funD
thf(fact_39_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X3: A] :
            ( ( P @ X3 )
           => ( Q @ X3 ) ) ) ) )).

% Collect_mono_iff
thf(fact_40_contra__subsetD,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ~ ( member2 @ A @ C @ B2 )
       => ~ ( member2 @ A @ C @ A2 ) ) ) )).

% contra_subsetD
thf(fact_41_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y2: ( set @ A ),Z2: ( set @ A )] : ( Y2 = Z2 ) )
      = ( ^ [A3: ( set @ A ),B3: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
            & ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) ) )).

% set_eq_subset
thf(fact_42_subset__trans,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A2 @ C3 ) ) ) )).

% subset_trans
thf(fact_43_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P @ X )
         => ( Q @ X ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_44_subset__refl,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A2 @ A2 ) )).

% subset_refl
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P: ( A > $o )] :
      ( ( member2 @ A @ A4 @ ( collect @ A @ P ) )
      = ( P @ A4 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member2 @ A @ X3 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G2: ( A > B )] :
      ( ! [X: A] :
          ( ( F @ X )
          = ( G2 @ X ) )
     => ( F = G2 ) ) )).

% ext
thf(fact_49_rev__subsetD,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member2 @ A @ C @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member2 @ A @ C @ B2 ) ) ) )).

% rev_subsetD
thf(fact_50_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A3: ( set @ A ),B3: ( set @ A )] :
          ! [T: A] :
            ( ( member2 @ A @ T @ A3 )
           => ( member2 @ A @ T @ B3 ) ) ) ) )).

% subset_iff
thf(fact_51_set__rev__mp,axiom,(
    ! [A: $tType,X2: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member2 @ A @ X2 @ A2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( member2 @ A @ X2 @ B2 ) ) ) )).

% set_rev_mp
thf(fact_52_distinct__union,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) )).

% distinct_union
thf(fact_53_mergesort__remdups__correct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L: ( list @ A )] :
          ( ( distinct @ A @ ( mergesort_remdups @ A @ L ) )
          & ( linorder_sorted @ A @ ( mergesort_remdups @ A @ L ) )
          & ( ( set2 @ A @ ( mergesort_remdups @ A @ L ) )
            = ( set2 @ A @ L ) ) ) ) )).

% mergesort_remdups_correct
thf(fact_54_subset__code_I2_J,axiom,(
    ! [B: $tType,A2: ( set @ B ),Ys: ( list @ B )] :
      ( ( ord_less_eq @ ( set @ B ) @ A2 @ ( coset @ B @ Ys ) )
      = ( ! [X3: B] :
            ( ( member2 @ B @ X3 @ ( set2 @ B @ Ys ) )
           => ~ ( member2 @ B @ X3 @ A2 ) ) ) ) )).

% subset_code(2)
thf(fact_55_subset__Collect__conv,axiom,(
    ! [A: $tType,S: ( set @ A ),P: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ S @ ( collect @ A @ P ) )
      = ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ S )
           => ( P @ X3 ) ) ) ) )).

% subset_Collect_conv
thf(fact_56_in__set__member,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( member @ A @ Xs @ X2 ) ) )).

% in_set_member
thf(fact_57_finite__sorted__distinct__unique,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( finite_finite2 @ A @ A2 )
         => ? [X: ( list @ A )] :
              ( ( ( set2 @ A @ X )
                = A2 )
              & ( linorder_sorted @ A @ X )
              & ( distinct @ A @ X )
              & ! [Y5: ( list @ A )] :
                  ( ( ( ( set2 @ A @ Y5 )
                      = A2 )
                    & ( linorder_sorted @ A @ Y5 )
                    & ( distinct @ A @ Y5 ) )
                 => ( Y5 = X ) ) ) ) ) )).

% finite_sorted_distinct_unique
thf(fact_58_ord__eq__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B4: A,C: A,D: A] :
          ( ( A4 = B4 )
         => ( ( ord_less_eq @ A @ B4 @ C )
           => ( ( C = D )
             => ( ord_less_eq @ A @ A4 @ D ) ) ) ) ) )).

% ord_eq_le_eq_trans
thf(fact_59_sorted__Cons,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Xs: ( list @ A )] :
          ( ( linorder_sorted @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( ( linorder_sorted @ A @ Xs )
            & ! [X3: A] :
                ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X2 @ X3 ) ) ) ) ) )).

% sorted_Cons
thf(fact_60_sorted_OCons,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),X2: A] :
          ( ! [X: A] :
              ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X2 @ X ) )
         => ( ( linorder_sorted @ A @ Xs )
           => ( linorder_sorted @ A @ ( cons @ A @ X2 @ Xs ) ) ) ) ) )).

% sorted.Cons
thf(fact_61_sorted__append,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( linorder_sorted @ A @ ( append @ A @ Xs @ Ys ) )
          = ( ( linorder_sorted @ A @ Xs )
            & ( linorder_sorted @ A @ Ys )
            & ! [X3: A] :
                ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ! [Y3: A] :
                    ( ( member2 @ A @ Y3 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X3 @ Y3 ) ) ) ) ) ) )).

% sorted_append
thf(fact_62_set__sublist__subset,axiom,(
    ! [A: $tType,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( sublist @ A @ Xs @ I ) ) @ ( set2 @ A @ Xs ) ) )).

% set_sublist_subset
thf(fact_63_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_64_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_65_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_66_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_67_List_Ofinite__set,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( finite_finite2 @ A @ ( set2 @ A @ Xs ) ) )).

% List.finite_set
thf(fact_68_sorted__many__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Zs: ( list @ A )] :
          ( ( linorder_sorted @ A @ ( cons @ A @ X2 @ ( cons @ A @ Y @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X2 @ Y )
            & ( linorder_sorted @ A @ ( cons @ A @ Y @ Zs ) ) ) ) ) )).

% sorted_many_eq
thf(fact_69_member__rec_I1_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Y: A] :
      ( ( member @ A @ ( cons @ A @ X2 @ Xs ) @ Y )
      = ( ( X2 = Y )
        | ( member @ A @ Xs @ Y ) ) ) )).

% member_rec(1)
thf(fact_70_not__Cons__self2,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X2 @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_71_distinct__match,axiom,(
    ! [A: $tType,Al: ( list @ A ),E: A,Bl: ( list @ A ),Al2: ( list @ A ),Bl2: ( list @ A )] :
      ( ( distinct @ A @ ( append @ A @ Al @ ( cons @ A @ E @ Bl ) ) )
     => ( ( ( append @ A @ Al @ ( cons @ A @ E @ Bl ) )
          = ( append @ A @ Al2 @ ( cons @ A @ E @ Bl2 ) ) )
        = ( ( Al = Al2 )
          & ( Bl = Bl2 ) ) ) ) )).

% distinct_match
thf(fact_72_Cons__eq__appendI,axiom,(
    ! [A: $tType,X2: A,Xs1: ( list @ A ),Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X2 @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_73_xy__in__set__cases,axiom,(
    ! [A: $tType,X2: A,L: ( list @ A ),Y: A] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ L ) )
     => ( ( member2 @ A @ Y @ ( set2 @ A @ L ) )
       => ( ( ( X2 = Y )
           => ! [L1: ( list @ A ),L2: ( list @ A )] :
                ( L
               != ( append @ A @ L1 @ ( cons @ A @ Y @ L2 ) ) ) )
         => ( ( ( X2 != Y )
             => ! [L1: ( list @ A ),L2: ( list @ A ),L3: ( list @ A )] :
                  ( L
                 != ( append @ A @ L1 @ ( cons @ A @ X2 @ ( append @ A @ L2 @ ( cons @ A @ Y @ L3 ) ) ) ) ) )
           => ~ ( ( X2 != Y )
               => ! [L1: ( list @ A ),L2: ( list @ A ),L3: ( list @ A )] :
                    ( L
                   != ( append @ A @ L1 @ ( cons @ A @ Y @ ( append @ A @ L2 @ ( cons @ A @ X2 @ L3 ) ) ) ) ) ) ) ) ) ) )).

% xy_in_set_cases
thf(fact_74_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_75_append__Cons,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( cons @ A @ X2 @ ( append @ A @ Xs @ Ys ) ) ) )).

% append_Cons
thf(fact_76_in__set__list__format,axiom,(
    ! [A: $tType,E: A,L: ( list @ A )] :
      ( ( member2 @ A @ E @ ( set2 @ A @ L ) )
     => ~ ( ! [L1: ( list @ A ),L2: ( list @ A )] :
              ( L
             != ( append @ A @ L1 @ ( cons @ A @ E @ L2 ) ) ) ) ) )).

% in_set_list_format
thf(fact_77_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_78_list__match__lel__lel,axiom,(
    ! [A: $tType,C1: ( list @ A ),Qs: A,C22: ( list @ A ),C12: ( list @ A ),Qs2: A,C23: ( list @ A )] :
      ( ( ( append @ A @ C1 @ ( cons @ A @ Qs @ C22 ) )
        = ( append @ A @ C12 @ ( cons @ A @ Qs2 @ C23 ) ) )
     => ( ! [C21: ( list @ A )] :
            ( ( C1
              = ( append @ A @ C12 @ ( cons @ A @ Qs2 @ C21 ) ) )
           => ( C23
             != ( append @ A @ C21 @ ( cons @ A @ Qs @ C22 ) ) ) )
       => ( ( ( C12 = C1 )
           => ( ( Qs2 = Qs )
             => ( C23 != C22 ) ) )
         => ~ ( ! [C212: ( list @ A )] :
                  ( ( C12
                    = ( append @ A @ C1 @ ( cons @ A @ Qs @ C212 ) ) )
                 => ( C22
                   != ( append @ A @ C212 @ ( cons @ A @ Qs2 @ C23 ) ) ) ) ) ) ) ) )).

% list_match_lel_lel
thf(fact_79_list__tail__coinc,axiom,(
    ! [A: $tType,N1: A,R1: ( list @ A ),N2: A,R2: ( list @ A )] :
      ( ( ( cons @ A @ N1 @ R1 )
        = ( cons @ A @ N2 @ R2 ) )
     => ( ( N1 = N2 )
        & ( R1 = R2 ) ) ) )).

% list_tail_coinc
thf(fact_80_split__list__first__prop__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( P @ X3 ) ) )
      = ( ? [Ys2: ( list @ A ),X3: A] :
            ( ? [Zs2: ( list @ A )] :
                ( Xs
                = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
            & ( P @ X3 )
            & ! [Y3: A] :
                ( ( member2 @ A @ Y3 @ ( set2 @ A @ Ys2 ) )
               => ~ ( P @ Y3 ) ) ) ) ) )).

% split_list_first_prop_iff
thf(fact_81_split__list__last__prop__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs ) )
            & ( P @ X3 ) ) )
      = ( ? [Ys2: ( list @ A ),X3: A,Zs2: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
            & ( P @ X3 )
            & ! [Y3: A] :
                ( ( member2 @ A @ Y3 @ ( set2 @ A @ Zs2 ) )
               => ~ ( P @ Y3 ) ) ) ) ) )).

% split_list_last_prop_iff
thf(fact_82_in__set__conv__decomp__first,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys2: ( list @ A ),Zs2: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs2 ) ) )
            & ~ ( member2 @ A @ X2 @ ( set2 @ A @ Ys2 ) ) ) ) ) )).

% in_set_conv_decomp_first
thf(fact_83_in__set__conv__decomp__last,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys2: ( list @ A ),Zs2: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs2 ) ) )
            & ~ ( member2 @ A @ X2 @ ( set2 @ A @ Zs2 ) ) ) ) ) )).

% in_set_conv_decomp_last
thf(fact_84_split__list__first__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ~ ( ! [Ys3: ( list @ A ),X: A] :
              ( ? [Zs3: ( list @ A )] :
                  ( Xs
                  = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
             => ( ( P @ X )
               => ~ ( ! [Xa: A] :
                        ( ( member2 @ A @ Xa @ ( set2 @ A @ Ys3 ) )
                       => ~ ( P @ Xa ) ) ) ) ) ) ) )).

% split_list_first_propE
thf(fact_85_split__list__last__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ~ ( ! [Ys3: ( list @ A ),X: A,Zs3: ( list @ A )] :
              ( ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
             => ( ( P @ X )
               => ~ ( ! [Xa: A] :
                        ( ( member2 @ A @ Xa @ ( set2 @ A @ Zs3 ) )
                       => ~ ( P @ Xa ) ) ) ) ) ) ) )).

% split_list_last_propE
thf(fact_86_split__list__first__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ? [Ys3: ( list @ A ),X: A] :
          ( ? [Zs3: ( list @ A )] :
              ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
          & ( P @ X )
          & ! [Xa: A] :
              ( ( member2 @ A @ Xa @ ( set2 @ A @ Ys3 ) )
             => ~ ( P @ Xa ) ) ) ) )).

% split_list_first_prop
thf(fact_87_split__list__last__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ? [Ys3: ( list @ A ),X: A,Zs3: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
          & ( P @ X )
          & ! [Xa: A] :
              ( ( member2 @ A @ Xa @ ( set2 @ A @ Zs3 ) )
             => ~ ( P @ Xa ) ) ) ) )).

% split_list_last_prop
thf(fact_88_in__set__conv__decomp,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys2: ( list @ A ),Zs2: ( list @ A )] :
            ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs2 ) ) ) ) ) )).

% in_set_conv_decomp
thf(fact_89_split__list__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ~ ( ! [Ys3: ( list @ A ),X: A] :
              ( ? [Zs3: ( list @ A )] :
                  ( Xs
                  = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
             => ~ ( P @ X ) ) ) ) )).

% split_list_propE
thf(fact_90_split__list__first,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys3: ( list @ A ),Zs3: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
          & ~ ( member2 @ A @ X2 @ ( set2 @ A @ Ys3 ) ) ) ) )).

% split_list_first
thf(fact_91_split__list__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member2 @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ? [Ys3: ( list @ A ),X: A] :
          ( ? [Zs3: ( list @ A )] :
              ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
          & ( P @ X ) ) ) )).

% split_list_prop
thf(fact_92_split__list__last,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys3: ( list @ A ),Zs3: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
          & ~ ( member2 @ A @ X2 @ ( set2 @ A @ Zs3 ) ) ) ) )).

% split_list_last
thf(fact_93_split__list,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys3: ( list @ A ),Zs3: ( list @ A )] :
          ( Xs
          = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) ) ) )).

% split_list
thf(fact_94_not__distinct__conv__prefix,axiom,(
    ! [A: $tType,As: ( list @ A )] :
      ( ( ~ ( distinct @ A @ As ) )
      = ( ? [Xs2: ( list @ A ),Y3: A,Ys2: ( list @ A )] :
            ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs2 ) )
            & ( distinct @ A @ Xs2 )
            & ( As
              = ( append @ A @ Xs2 @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) ) ) )).

% not_distinct_conv_prefix
thf(fact_95_finite__list,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ? [Xs3: ( list @ A )] :
          ( ( set2 @ A @ Xs3 )
          = A2 ) ) )).

% finite_list
thf(fact_96_list_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,A22: ( list @ A ),A1: A] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ A22 ) )
     => ( member2 @ A @ X2 @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) ) )).

% list.set_intros(2)
thf(fact_97_list_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( list @ A )] :
      ( member2 @ A @ A1 @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) )).

% list.set_intros(1)
thf(fact_98_set__ConsD,axiom,(
    ! [A: $tType,Y: A,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ Y @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) )
     => ( ( Y = X2 )
        | ( member2 @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) )).

% set_ConsD
thf(fact_99_list_Oset__cases,axiom,(
    ! [A: $tType,E: A,A4: ( list @ A )] :
      ( ( member2 @ A @ E @ ( set2 @ A @ A4 ) )
     => ( ! [Z22: ( list @ A )] :
            ( A4
           != ( cons @ A @ E @ Z22 ) )
       => ~ ( ! [Z1: A,Z22: ( list @ A )] :
                ( ( A4
                  = ( cons @ A @ Z1 @ Z22 ) )
               => ~ ( member2 @ A @ E @ ( set2 @ A @ Z22 ) ) ) ) ) ) )).

% list.set_cases
thf(fact_100_distinct__length__2__or__more,axiom,(
    ! [A: $tType,A4: A,B4: A,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( cons @ A @ A4 @ ( cons @ A @ B4 @ Xs ) ) )
      = ( ( A4 != B4 )
        & ( distinct @ A @ ( cons @ A @ A4 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B4 @ Xs ) ) ) ) )).

% distinct_length_2_or_more
thf(fact_101_in__set__sublistD,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ ( sublist @ A @ Xs @ I ) ) )
     => ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) ) ) )).

% in_set_sublistD
thf(fact_102_notin__set__sublistI,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ~ ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ~ ( member2 @ A @ X2 @ ( set2 @ A @ ( sublist @ A @ Xs @ I ) ) ) ) )).

% notin_set_sublistI
thf(fact_103_distinct__sublistI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),I: ( set @ nat )] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( sublist @ A @ Xs @ I ) ) ) )).

% distinct_sublistI
thf(fact_104_set__subset__Cons,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) ) )).

% set_subset_Cons
thf(fact_105_sorted__many,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Zs: ( list @ A )] :
          ( ( ord_less_eq @ A @ X2 @ Y )
         => ( ( linorder_sorted @ A @ ( cons @ A @ Y @ Zs ) )
           => ( linorder_sorted @ A @ ( cons @ A @ X2 @ ( cons @ A @ Y @ Zs ) ) ) ) ) ) )).

% sorted_many
thf(fact_106_finite__distinct__list,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ A2 )
     => ? [Xs3: ( list @ A )] :
          ( ( ( set2 @ A @ Xs3 )
            = A2 )
          & ( distinct @ A @ Xs3 ) ) ) )).

% finite_distinct_list
thf(fact_107_distinct_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( ~ ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) )).

% distinct.simps(2)
thf(fact_108_finite__code,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ( ( finite_finite2 @ A )
        = ( ^ [A3: ( set @ A )] : $true ) ) ) )).

% finite_code
thf(fact_109_finite__subset,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ( finite_finite2 @ A @ B2 )
       => ( finite_finite2 @ A @ A2 ) ) ) )).

% finite_subset
thf(fact_110_infinite__super,axiom,(
    ! [A: $tType,S: ( set @ A ),T2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ S @ T2 )
     => ( ~ ( finite_finite2 @ A @ S )
       => ~ ( finite_finite2 @ A @ T2 ) ) ) )).

% infinite_super
thf(fact_111_rev__finite__subset,axiom,(
    ! [A: $tType,B2: ( set @ A ),A2: ( set @ A )] :
      ( ( finite_finite2 @ A @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
       => ( finite_finite2 @ A @ A2 ) ) ) )).

% rev_finite_subset
thf(fact_112_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Xs: ( list @ B ),F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X2 @ Xs ) @ F )
      = ( append @ A @ ( F @ X2 ) @ ( bind @ B @ A @ Xs @ F ) ) ) )).

% bind_simps(2)
thf(fact_113_sorted__list__of__set,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( finite_finite2 @ A @ A2 )
         => ( ( ( set2 @ A @ ( linord467138063of_set @ A @ A2 ) )
              = A2 )
            & ( linorder_sorted @ A @ ( linord467138063of_set @ A @ A2 ) )
            & ( distinct @ A @ ( linord467138063of_set @ A @ A2 ) ) ) ) ) )).

% sorted_list_of_set
thf(fact_114_sorted__append__bigger,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Y: A] :
          ( ( linorder_sorted @ A @ Xs )
         => ( ! [X: A] :
                ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X @ Y ) )
           => ( linorder_sorted @ A @ ( append @ A @ Xs @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) ) ) )).

% sorted_append_bigger
thf(fact_115_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_116_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_117_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_118_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_119_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_120_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_121_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_122_sublist__nil,axiom,(
    ! [A: $tType,A2: ( set @ nat )] :
      ( ( sublist @ A @ ( nil @ A ) @ A2 )
      = ( nil @ A ) ) )).

% sublist_nil
thf(fact_123_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_124_list__e__eq__lel_I2_J,axiom,(
    ! [A: $tType,L12: ( list @ A ),E2: A,L22: ( list @ A ),E: A] :
      ( ( ( append @ A @ L12 @ ( cons @ A @ E2 @ L22 ) )
        = ( cons @ A @ E @ ( nil @ A ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E2 = E )
        & ( L22
          = ( nil @ A ) ) ) ) )).

% list_e_eq_lel(2)
thf(fact_125_list__e__eq__lel_I1_J,axiom,(
    ! [A: $tType,E: A,L12: ( list @ A ),E2: A,L22: ( list @ A )] :
      ( ( ( cons @ A @ E @ ( nil @ A ) )
        = ( append @ A @ L12 @ ( cons @ A @ E2 @ L22 ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E2 = E )
        & ( L22
          = ( nil @ A ) ) ) ) )).

% list_e_eq_lel(1)
thf(fact_126_list__se__match_I4_J,axiom,(
    ! [A: $tType,L22: ( list @ A ),A4: A,L12: ( list @ A )] :
      ( ( L22
       != ( nil @ A ) )
     => ( ( ( cons @ A @ A4 @ ( nil @ A ) )
          = ( append @ A @ L12 @ L22 ) )
        = ( ( L12
            = ( nil @ A ) )
          & ( L22
            = ( cons @ A @ A4 @ ( nil @ A ) ) ) ) ) ) )).

% list_se_match(4)
thf(fact_127_list__se__match_I3_J,axiom,(
    ! [A: $tType,L12: ( list @ A ),A4: A,L22: ( list @ A )] :
      ( ( L12
       != ( nil @ A ) )
     => ( ( ( cons @ A @ A4 @ ( nil @ A ) )
          = ( append @ A @ L12 @ L22 ) )
        = ( ( L12
            = ( cons @ A @ A4 @ ( nil @ A ) ) )
          & ( L22
            = ( nil @ A ) ) ) ) ) )).

% list_se_match(3)
thf(fact_128_list__se__match_I2_J,axiom,(
    ! [A: $tType,L22: ( list @ A ),L12: ( list @ A ),A4: A] :
      ( ( L22
       != ( nil @ A ) )
     => ( ( ( append @ A @ L12 @ L22 )
          = ( cons @ A @ A4 @ ( nil @ A ) ) )
        = ( ( L12
            = ( nil @ A ) )
          & ( L22
            = ( cons @ A @ A4 @ ( nil @ A ) ) ) ) ) ) )).

% list_se_match(2)
thf(fact_129_list__se__match_I1_J,axiom,(
    ! [A: $tType,L12: ( list @ A ),L22: ( list @ A ),A4: A] :
      ( ( L12
       != ( nil @ A ) )
     => ( ( ( append @ A @ L12 @ L22 )
          = ( cons @ A @ A4 @ ( nil @ A ) ) )
        = ( ( L12
            = ( cons @ A @ A4 @ ( nil @ A ) ) )
          & ( L22
            = ( nil @ A ) ) ) ) ) )).

% list_se_match(1)
thf(fact_130_list__ee__eq__leel_I2_J,axiom,(
    ! [A: $tType,L12: ( list @ A ),E1: A,E22: A,L22: ( list @ A ),E12: A,E23: A] :
      ( ( ( append @ A @ L12 @ ( cons @ A @ E1 @ ( cons @ A @ E22 @ L22 ) ) )
        = ( cons @ A @ E12 @ ( cons @ A @ E23 @ ( nil @ A ) ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E12 = E1 )
        & ( E23 = E22 )
        & ( L22
          = ( nil @ A ) ) ) ) )).

% list_ee_eq_leel(2)
thf(fact_131_list__ee__eq__leel_I1_J,axiom,(
    ! [A: $tType,E12: A,E23: A,L12: ( list @ A ),E1: A,E22: A,L22: ( list @ A )] :
      ( ( ( cons @ A @ E12 @ ( cons @ A @ E23 @ ( nil @ A ) ) )
        = ( append @ A @ L12 @ ( cons @ A @ E1 @ ( cons @ A @ E22 @ L22 ) ) ) )
      = ( ( L12
          = ( nil @ A ) )
        & ( E12 = E1 )
        & ( E23 = E22 )
        & ( L22
          = ( nil @ A ) ) ) ) )).

% list_ee_eq_leel(1)
thf(fact_132_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X2 = Y ) ) ) )).

% append1_eq_conv
thf(fact_133_sorted__single,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( linorder_sorted @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% sorted_single
thf(fact_134_sorted__list__of__set_Oinfinite,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ~ ( finite_finite2 @ A @ A2 )
         => ( ( linord467138063of_set @ A @ A2 )
            = ( nil @ A ) ) ) ) )).

% sorted_list_of_set.infinite
thf(fact_135_transpose_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ ( list @ A ) )] :
      ( ( X2
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X2
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X: A,Xs3: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X2
               != ( cons @ ( list @ A ) @ ( cons @ A @ X @ Xs3 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_136_revg_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X1: ( list @ A )] :
          ( P @ ( nil @ A ) @ X1 )
     => ( ! [A5: A,As2: ( list @ A ),B5: ( list @ A )] :
            ( ( P @ As2 @ ( cons @ A @ A5 @ B5 ) )
           => ( P @ ( cons @ A @ A5 @ As2 ) @ B5 ) )
       => ( P @ A0 @ A1 ) ) ) )).

% revg.induct
thf(fact_137_zipf_Oinduct,axiom,(
    ! [A: $tType,C2: $tType,B: $tType,P: ( ( A > B > C2 ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B > C2 ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F3: ( A > B > C2 )] :
          ( P @ F3 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [F3: ( A > B > C2 ),A5: A,As2: ( list @ A ),B5: B,Bs: ( list @ B )] :
            ( ( P @ F3 @ As2 @ Bs )
           => ( P @ F3 @ ( cons @ A @ A5 @ As2 ) @ ( cons @ B @ B5 @ Bs ) ) )
       => ( ! [A5: ( A > B > C2 ),V: A,Va: ( list @ A )] :
              ( P @ A5 @ ( cons @ A @ V @ Va ) @ ( nil @ B ) )
         => ( ! [A5: ( A > B > C2 ),V: B,Va: ( list @ B )] :
                ( P @ A5 @ ( nil @ A ) @ ( cons @ B @ V @ Va ) )
           => ( P @ A0 @ A1 @ A22 ) ) ) ) ) )).

% zipf.induct
thf(fact_138_list__2pre__induct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),W1: ( list @ A ),W2: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [E3: A,W12: ( list @ A ),W22: ( list @ B )] :
            ( ( P @ W12 @ W22 )
           => ( P @ ( cons @ A @ E3 @ W12 ) @ W22 ) )
       => ( ! [E3: B,W13: ( list @ A ),W23: ( list @ B )] :
              ( ( P @ W13 @ W23 )
             => ( P @ W13 @ ( cons @ B @ E3 @ W23 ) ) )
         => ( P @ W1 @ W2 ) ) ) ) )).

% list_2pre_induct
thf(fact_139_list__induct__first2,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X1: A,X23: A,Xs3: ( list @ A )] :
              ( ( P @ Xs3 )
             => ( P @ ( cons @ A @ X1 @ ( cons @ A @ X23 @ Xs3 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_induct_first2
thf(fact_140_list__all__zip_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B > $o ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [P2: ( A > B > $o )] :
          ( P @ P2 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [P2: ( A > B > $o ),A5: A,As2: ( list @ A ),B5: B,Bs: ( list @ B )] :
            ( ( P @ P2 @ As2 @ Bs )
           => ( P @ P2 @ ( cons @ A @ A5 @ As2 ) @ ( cons @ B @ B5 @ Bs ) ) )
       => ( ! [P2: ( A > B > $o ),V: A,Va: ( list @ A )] :
              ( P @ P2 @ ( cons @ A @ V @ Va ) @ ( nil @ B ) )
         => ( ! [P2: ( A > B > $o ),V: B,Va: ( list @ B )] :
                ( P @ P2 @ ( nil @ A ) @ ( cons @ B @ V @ Va ) )
           => ( P @ A0 @ A1 @ A22 ) ) ) ) ) )).

% list_all_zip.induct
thf(fact_141_mergesort__by__rel__merge_Oinduct,axiom,(
    ! [A: $tType,P: ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ),A0: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ! [R: ( A > A > $o ),X: A,Xs3: ( list @ A ),Y4: A,Ys3: ( list @ A )] :
          ( ( ( R @ X @ Y4 )
           => ( P @ R @ Xs3 @ ( cons @ A @ Y4 @ Ys3 ) ) )
         => ( ( ~ ( R @ X @ Y4 )
             => ( P @ R @ ( cons @ A @ X @ Xs3 ) @ Ys3 ) )
           => ( P @ R @ ( cons @ A @ X @ Xs3 ) @ ( cons @ A @ Y4 @ Ys3 ) ) ) )
     => ( ! [R: ( A > A > $o ),Xs3: ( list @ A )] :
            ( P @ R @ Xs3 @ ( nil @ A ) )
       => ( ! [R: ( A > A > $o ),V: A,Va: ( list @ A )] :
              ( P @ R @ ( nil @ A ) @ ( cons @ A @ V @ Va ) )
         => ( P @ A0 @ A1 @ A22 ) ) ) ) )).

% mergesort_by_rel_merge.induct
thf(fact_142_mergesort__by__rel__merge__induct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),R3: ( A > B > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ! [Xs3: ( list @ A )] :
          ( P @ Xs3 @ ( nil @ B ) )
     => ( ! [X1: ( list @ B )] :
            ( P @ ( nil @ A ) @ X1 )
       => ( ! [X: A,Xs3: ( list @ A ),Y4: B,Ys3: ( list @ B )] :
              ( ( R3 @ X @ Y4 )
             => ( ( P @ Xs3 @ ( cons @ B @ Y4 @ Ys3 ) )
               => ( P @ ( cons @ A @ X @ Xs3 ) @ ( cons @ B @ Y4 @ Ys3 ) ) ) )
         => ( ! [X: A,Xs3: ( list @ A ),Y4: B,Ys3: ( list @ B )] :
                ( ~ ( R3 @ X @ Y4 )
               => ( ( P @ ( cons @ A @ X @ Xs3 ) @ Ys3 )
                 => ( P @ ( cons @ A @ X @ Xs3 ) @ ( cons @ B @ Y4 @ Ys3 ) ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% mergesort_by_rel_merge_induct
thf(fact_143_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F3: ( A > B ),X1: ( list @ B )] :
          ( P @ F3 @ ( nil @ A ) @ X1 )
     => ( ! [F3: ( A > B ),A5: A,As2: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F3 @ As2 @ ( cons @ B @ ( F3 @ A5 ) @ Bs ) )
           => ( P @ F3 @ ( cons @ A @ A5 @ As2 ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_144_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X: A,Xs3: ( list @ A )] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( cons @ A @ X @ Xs3 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_145_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X: A,Y4: A,Xs3: ( list @ A )] :
              ( ( ( X = Y4 )
               => ( P @ ( cons @ A @ X @ Xs3 ) ) )
             => ( ( ( X != Y4 )
                 => ( P @ ( cons @ A @ Y4 @ Xs3 ) ) )
               => ( P @ ( cons @ A @ X @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_146_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ A )] :
      ( ( X2
       != ( nil @ A ) )
     => ( ! [X: A] :
            ( X2
           != ( cons @ A @ X @ ( nil @ A ) ) )
       => ~ ( ! [X: A,Y4: A,Xs3: ( list @ A )] :
                ( X2
               != ( cons @ A @ X @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_147_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X1: ( list @ A )] :
          ( P @ ( nil @ A ) @ X1 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X: A,Xs3: ( list @ A ),Y4: A,Ys3: ( list @ A )] :
              ( ( P @ Xs3 @ Ys3 )
             => ( P @ ( cons @ A @ X @ Xs3 ) @ ( cons @ A @ Y4 @ Ys3 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_148_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X: A,Xs3: ( list @ A )] :
            ( P @ ( cons @ A @ X @ Xs3 ) @ ( nil @ B ) )
       => ( ! [Y4: B,Ys3: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y4 @ Ys3 ) )
         => ( ! [X: A,Xs3: ( list @ A ),Y4: B,Ys3: ( list @ B )] :
                ( ( P @ Xs3 @ Ys3 )
               => ( P @ ( cons @ A @ X @ Xs3 ) @ ( cons @ B @ Y4 @ Ys3 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_149_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys2: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys2 ) ) ) ) )).

% neq_Nil_conv
thf(fact_150_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X1: A,X23: ( list @ A )] :
            ( ( P @ X23 )
           => ( P @ ( cons @ A @ X1 @ X23 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_151_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_152_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_153_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_154_append__Nil,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_155_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_156_distinct_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( distinct @ A @ ( nil @ A ) ) )).

% distinct.simps(1)
thf(fact_157_sorted_ONil,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( linorder_sorted @ A @ ( nil @ A ) ) ) )).

% sorted.Nil
thf(fact_158_subset__sorted_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L22: ( list @ A )] :
          ( sorted1061247458sorted @ A @ ( nil @ A ) @ L22 ) ) )).

% subset_sorted.simps(1)
thf(fact_159_distinct__sorted__list__of__set,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( distinct @ A @ ( linord467138063of_set @ A @ A2 ) ) ) )).

% distinct_sorted_list_of_set
thf(fact_160_member__rec_I2_J,axiom,(
    ! [A: $tType,Y: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y ) )).

% member_rec(2)
thf(fact_161_rev__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X: A,Xs3: ( list @ A )] :
            ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( nil @ B ) )
       => ( ! [Y4: B,Ys3: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y4 @ ( nil @ B ) ) ) )
         => ( ! [X: A,Xs3: ( list @ A ),Y4: B,Ys3: ( list @ B )] :
                ( ( P @ Xs3 @ Ys3 )
               => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y4 @ ( nil @ B ) ) ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% rev_induct2'
thf(fact_162_list__rev__decomp,axiom,(
    ! [A: $tType,L: ( list @ A )] :
      ( ( L
       != ( nil @ A ) )
     => ? [Ll: ( list @ A ),E3: A] :
          ( L
          = ( append @ A @ Ll @ ( cons @ A @ E3 @ ( nil @ A ) ) ) ) ) )).

% list_rev_decomp
thf(fact_163_neq__Nil__rev__conv,axiom,(
    ! [A: $tType,L: ( list @ A )] :
      ( ( L
       != ( nil @ A ) )
      = ( ? [Xs2: ( list @ A ),X3: A] :
            ( L
            = ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) ) )).

% neq_Nil_rev_conv
thf(fact_164_rev__nonempty__induct2_H,axiom,(
    ! [A: $tType,B: $tType,Xs: ( list @ A ),Ys: ( list @ B ),P: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ B ) )
       => ( ! [X: A,Y4: B] :
              ( P @ ( cons @ A @ X @ ( nil @ A ) ) @ ( cons @ B @ Y4 @ ( nil @ B ) ) )
         => ( ! [X: A,Xs3: ( list @ A ),Y4: B] :
                ( ( Xs3
                 != ( nil @ A ) )
               => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( cons @ B @ Y4 @ ( nil @ B ) ) ) )
           => ( ! [X: A,Y4: B,Ys3: ( list @ B )] :
                  ( ( Ys3
                   != ( nil @ B ) )
                 => ( P @ ( cons @ A @ X @ ( nil @ A ) ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y4 @ ( nil @ B ) ) ) ) )
             => ( ! [X: A,Xs3: ( list @ A ),Y4: B,Ys3: ( list @ B )] :
                    ( ( P @ Xs3 @ Ys3 )
                   => ( ( Xs3
                       != ( nil @ A ) )
                     => ( ( Ys3
                         != ( nil @ B ) )
                       => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ B @ Ys3 @ ( cons @ B @ Y4 @ ( nil @ B ) ) ) ) ) ) )
               => ( P @ Xs @ Ys ) ) ) ) ) ) ) )).

% rev_nonempty_induct2'
thf(fact_165_list__Cons__eq__append__cases,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( ( Ys
            = ( nil @ A ) )
         => ( Zs
           != ( cons @ A @ X2 @ Xs ) ) )
       => ~ ( ! [Ys4: ( list @ A )] :
                ( ( Ys
                  = ( cons @ A @ X2 @ Ys4 ) )
               => ( ( append @ A @ Ys4 @ Zs )
                 != Xs ) ) ) ) ) )).

% list_Cons_eq_append_cases
thf(fact_166_list__append__eq__Cons__cases,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X2: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X2 @ Xs ) )
     => ( ( ( Ys
            = ( nil @ A ) )
         => ( Zs
           != ( cons @ A @ X2 @ Xs ) ) )
       => ~ ( ! [Ys4: ( list @ A )] :
                ( ( Ys
                  = ( cons @ A @ X2 @ Ys4 ) )
               => ( ( append @ A @ Ys4 @ Zs )
                 != Xs ) ) ) ) ) )).

% list_append_eq_Cons_cases
thf(fact_167_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X: A] :
            ( P @ ( cons @ A @ X @ ( nil @ A ) ) )
       => ( ! [X: A,Xs3: ( list @ A )] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_168_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X2: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X2 @ Xs ) ) )
        | ? [Ys5: ( list @ A )] :
            ( ( Ys
              = ( cons @ A @ X2 @ Ys5 ) )
            & ( ( append @ A @ Ys5 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_169_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X2 @ Xs )
            = Zs ) )
        | ? [Ys5: ( list @ A )] :
            ( ( ( cons @ A @ X2 @ Ys5 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys5 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_170_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys3: ( list @ A ),Y4: A] :
              ( Xs
             != ( append @ A @ Ys3 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_171_rev__induct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X: A,Xs3: ( list @ A )] :
            ( ( P @ Xs3 )
           => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) )).

% rev_induct
thf(fact_172_distinct__singleton,axiom,(
    ! [A: $tType,X2: A] :
      ( distinct @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )).

% distinct_singleton
thf(fact_173_list__bind__cong,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),F: ( A > ( list @ B ) ),G2: ( A > ( list @ B ) )] :
      ( ( Xs = Ys )
     => ( ! [X: A] :
            ( ( member2 @ A @ X @ ( set2 @ A @ Xs ) )
           => ( ( F @ X )
              = ( G2 @ X ) ) )
       => ( ( bind @ A @ B @ Xs @ F )
          = ( bind @ A @ B @ Ys @ G2 ) ) ) ) )).

% list_bind_cong
thf(fact_174_subset__sorted_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X12: A,L12: ( list @ A )] :
          ~ ( sorted1061247458sorted @ A @ ( cons @ A @ X12 @ L12 ) @ ( nil @ A ) ) ) )).

% subset_sorted.simps(2)
thf(fact_175_finite__set__choice,axiom,(
    ! [B: $tType,A: $tType,A2: ( set @ A ),P: ( A > B > $o )] :
      ( ( finite_finite2 @ A @ A2 )
     => ( ! [X: A] :
            ( ( member2 @ A @ X @ A2 )
           => ? [X13: B] :
                ( P @ X @ X13 ) )
       => ? [F3: ( A > B )] :
          ! [X4: A] :
            ( ( member2 @ A @ X4 @ A2 )
           => ( P @ X4 @ ( F3 @ X4 ) ) ) ) ) )).

% finite_set_choice
thf(fact_176_finite,axiom,(
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( finite_finite2 @ A @ A2 ) ) )).

% finite
thf(fact_177_not__distinct__decomp,axiom,(
    ! [A: $tType,Ws: ( list @ A )] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs3: ( list @ A ),Ys3: ( list @ A ),Zs3: ( list @ A ),Y4: A] :
          ( Ws
          = ( append @ A @ Xs3 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ ( append @ A @ Ys3 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ Zs3 ) ) ) ) ) ) )).

% not_distinct_decomp
thf(fact_178_subset__code_I3_J,axiom,(
    ! [C2: $tType] :
      ~ ( ord_less_eq @ ( set @ C2 ) @ ( coset @ C2 @ ( nil @ C2 ) ) @ ( set2 @ C2 @ ( nil @ C2 ) ) ) )).

% subset_code(3)
thf(fact_179_sorted_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: ( list @ A ),P: ( ( list @ A ) > $o )] :
          ( ( linorder_sorted @ A @ X2 )
         => ( ( P @ ( nil @ A ) )
           => ( ! [Xs3: ( list @ A ),X: A] :
                  ( ! [Xa: A] :
                      ( ( member2 @ A @ Xa @ ( set2 @ A @ Xs3 ) )
                     => ( ord_less_eq @ A @ X @ Xa ) )
                 => ( ( linorder_sorted @ A @ Xs3 )
                   => ( ( P @ Xs3 )
                     => ( P @ ( cons @ A @ X @ Xs3 ) ) ) ) )
             => ( P @ X2 ) ) ) ) ) )).

% sorted.inducts
thf(fact_180_sorted_Osimps,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( linorder_sorted @ A )
        = ( ^ [A6: ( list @ A )] :
              ( ( A6
                = ( nil @ A ) )
              | ? [Xs2: ( list @ A ),X3: A] :
                  ( ( A6
                    = ( cons @ A @ X3 @ Xs2 ) )
                  & ! [Y3: A] :
                      ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs2 ) )
                     => ( ord_less_eq @ A @ X3 @ Y3 ) )
                  & ( linorder_sorted @ A @ Xs2 ) ) ) ) ) ) )).

% sorted.simps
thf(fact_181_sorted_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A4: ( list @ A )] :
          ( ( linorder_sorted @ A @ A4 )
         => ( ( A4
             != ( nil @ A ) )
           => ~ ( ! [Xs3: ( list @ A ),X: A] :
                    ( ( A4
                      = ( cons @ A @ X @ Xs3 ) )
                   => ( ! [Xa: A] :
                          ( ( member2 @ A @ Xa @ ( set2 @ A @ Xs3 ) )
                         => ( ord_less_eq @ A @ X @ Xa ) )
                     => ~ ( linorder_sorted @ A @ Xs3 ) ) ) ) ) ) ) )).

% sorted.cases
thf(fact_182_not__distinct__split__distinct,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ~ ( distinct @ A @ Xs )
     => ~ ( ! [Y4: A,Ys3: ( list @ A )] :
              ( ( distinct @ A @ Ys3 )
             => ( ( member2 @ A @ Y4 @ ( set2 @ A @ Ys3 ) )
               => ! [Zs3: ( list @ A )] :
                    ( Xs
                   != ( append @ A @ Ys3 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ Zs3 ) ) ) ) ) ) ) )).

% not_distinct_split_distinct
thf(fact_183_the__elem__set,axiom,(
    ! [A: $tType,X2: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = X2 ) )).

% the_elem_set
thf(fact_184_quicksort_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X2: ( list @ A )] :
          ( ( X2
           != ( nil @ A ) )
         => ~ ( ! [X: A,Xs3: ( list @ A )] :
                  ( X2
                 != ( cons @ A @ X @ Xs3 ) ) ) ) ) )).

% quicksort.cases
thf(fact_185_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( list @ A ) ),X2: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F @ ( cons @ B @ X2 @ Xs ) )
      = ( append @ A @ ( F @ X2 ) @ ( maps @ B @ A @ F @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_186_not__in__set__insert,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ~ ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X2 @ Xs )
        = ( cons @ A @ X2 @ Xs ) ) ) )).

% not_in_set_insert
thf(fact_187_in__set__insert,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X2 @ Xs )
        = Xs ) ) )).

% in_set_insert
thf(fact_188_distinct__insert,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( insert @ A @ X2 @ Xs ) )
      = ( distinct @ A @ Xs ) ) )).

% distinct_insert
thf(fact_189_insert__Nil,axiom,(
    ! [A: $tType,X2: A] :
      ( ( insert @ A @ X2 @ ( nil @ A ) )
      = ( cons @ A @ X2 @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_190_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_191_List_Oinsert__def,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X3: A,Xs2: ( list @ A )] :
            ( if @ ( list @ A ) @ ( member2 @ A @ X3 @ ( set2 @ A @ Xs2 ) ) @ Xs2 @ ( cons @ A @ X3 @ Xs2 ) ) ) ) )).

% List.insert_def
thf(fact_192_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_193_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_194_distinct__product__lists,axiom,(
    ! [A: $tType,Xss2: ( list @ ( list @ A ) )] :
      ( ! [X: ( list @ A )] :
          ( ( member2 @ ( list @ A ) @ X @ ( set2 @ ( list @ A ) @ Xss2 ) )
         => ( distinct @ A @ X ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss2 ) ) ) )).

% distinct_product_lists
thf(fact_195_remove__code_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( remove @ A @ X2 @ ( coset @ A @ Xs ) )
      = ( coset @ A @ ( insert @ A @ X2 @ Xs ) ) ) )).

% remove_code(2)
thf(fact_196_combinatorial__product_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( list_c659805718roduct @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% combinatorial_product.simps(1)
thf(fact_197_member__remove,axiom,(
    ! [A: $tType,X2: A,Y: A,A2: ( set @ A )] :
      ( ( member2 @ A @ X2 @ ( remove @ A @ Y @ A2 ) )
      = ( ( member2 @ A @ X2 @ A2 )
        & ( X2 != Y ) ) ) )).

% member_remove
thf(fact_198_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_199_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_200_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_201_set__rotate1,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) )).

% set_rotate1
thf(fact_202_distinct1__rotate,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) )).

% distinct1_rotate
thf(fact_203_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_204_list__ex1__iff,axiom,(
    ! [A: $tType] :
      ( ( list_ex1 @ A )
      = ( ^ [P3: ( A > $o ),Xs2: ( list @ A )] :
          ? [X3: A] :
            ( ( member2 @ A @ X3 @ ( set2 @ A @ Xs2 ) )
            & ( P3 @ X3 )
            & ! [Y3: A] :
                ( ( ( member2 @ A @ Y3 @ ( set2 @ A @ Xs2 ) )
                  & ( P3 @ Y3 ) )
               => ( Y3 = X3 ) ) ) ) ) )).

% list_ex1_iff
thf(fact_205_can__select__set__list__ex1,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: ( list @ A )] :
      ( ( can_select @ A @ P @ ( set2 @ A @ A2 ) )
      = ( list_ex1 @ A @ P @ A2 ) ) )).

% can_select_set_list_ex1
thf(fact_206_sublist__singleton,axiom,(
    ! [A: $tType,A2: ( set @ nat ),X2: A] :
      ( ( ( member2 @ nat @ ( zero_zero @ nat ) @ A2 )
       => ( ( sublist @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ A2 )
          = ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      & ( ~ ( member2 @ nat @ ( zero_zero @ nat ) @ A2 )
       => ( ( sublist @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ A2 )
          = ( nil @ A ) ) ) ) )).

% sublist_singleton
thf(fact_207_can__select__def,axiom,(
    ! [A: $tType] :
      ( ( can_select @ A )
      = ( ^ [P3: ( A > $o ),A3: ( set @ A )] :
          ? [X3: A] :
            ( ( member2 @ A @ X3 @ A3 )
            & ( P3 @ X3 )
            & ! [Y3: A] :
                ( ( ( member2 @ A @ Y3 @ A3 )
                  & ( P3 @ Y3 ) )
               => ( Y3 = X3 ) ) ) ) ) )).

% can_select_def
thf(fact_208_le__zero__eq,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) )).

% le_zero_eq
thf(fact_209_n__lists__Nil,axiom,(
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) )).

% n_lists_Nil
thf(fact_210_zero__le,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) )).

% zero_le
thf(fact_211_n__lists_Osimps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% n_lists.simps(1)
thf(fact_212_distinct__n__lists,axiom,(
    ! [A: $tType,Xs: ( list @ A ),N: nat] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) ) )).

% distinct_n_lists
thf(fact_213_le__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% le_numeral_extra(3)
thf(fact_214_count__notin,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ~ ( member2 @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X2 )
        = ( zero_zero @ nat ) ) ) )).

% count_notin
thf(fact_215_sorted__list__of__set__eq__Nil__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: ( set @ A )] :
          ( ( finite_finite2 @ A @ A2 )
         => ( ( ( linord467138063of_set @ A @ A2 )
              = ( nil @ A ) )
            = ( A2
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% sorted_list_of_set_eq_Nil_iff
thf(fact_216_bot__apply,axiom,(
    ! [C2: $tType,D2: $tType] :
      ( ( bot @ C2 @ ( type2 @ C2 ) )
     => ( ( bot_bot @ ( D2 > C2 ) )
        = ( ^ [X3: D2] :
              ( bot_bot @ C2 ) ) ) ) )).

% bot_apply
thf(fact_217_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X3: A] :
            ~ ( P @ X3 ) ) ) )).

% empty_Collect_eq
thf(fact_218_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ~ ( P @ X3 ) ) ) )).

% Collect_empty_eq
thf(fact_219_all__not__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ! [X3: A] :
            ~ ( member2 @ A @ X3 @ A2 ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_220_empty__iff,axiom,(
    ! [A: $tType,C: A] :
      ~ ( member2 @ A @ C @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_221_subset__empty,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_222_empty__subsetI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A2 ) )).

% empty_subsetI
thf(fact_223_sublist__empty,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( sublist @ A @ Xs @ ( bot_bot @ ( set @ nat ) ) )
      = ( nil @ A ) ) )).

% sublist_empty
thf(fact_224_set__empty2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% set_empty2
thf(fact_225_set__empty,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% set_empty
thf(fact_226_sorted__list__of__set__empty,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( linord467138063of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) )).

% sorted_list_of_set_empty
thf(fact_227_empty__set,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) )).

% empty_set
thf(fact_228_memb__imp__not__empty,axiom,(
    ! [A: $tType,X2: A,S: ( set @ A )] :
      ( ( member2 @ A @ X2 @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% memb_imp_not_empty
thf(fact_229_set__notEmptyE,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ( S
       != ( bot_bot @ ( set @ A ) ) )
     => ~ ( ! [X: A] :
              ~ ( member2 @ A @ X @ S ) ) ) )).

% set_notEmptyE
thf(fact_230_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X3: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_231_ex__in__conv,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( ? [X3: A] :
            ( member2 @ A @ X3 @ A2 ) )
      = ( A2
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_232_equals0I,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [Y4: A] :
          ~ ( member2 @ A @ Y4 @ A2 )
     => ( A2
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_233_equals0D,axiom,(
    ! [A: $tType,A2: ( set @ A ),A4: A] :
      ( ( A2
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member2 @ A @ A4 @ A2 ) ) )).

% equals0D
thf(fact_234_emptyE,axiom,(
    ! [A: $tType,A4: A] :
      ~ ( member2 @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_235_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A4 ) ) )).

% bot.extremum
thf(fact_236_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( bot_bot @ A ) )
          = ( A4
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_237_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( ord_less_eq @ A @ A4 @ ( bot_bot @ A ) )
         => ( A4
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_238_finite_OemptyI,axiom,(
    ! [A: $tType] :
      ( finite_finite2 @ A @ ( bot_bot @ ( set @ A ) ) ) )).

% finite.emptyI
thf(fact_239_infinite__imp__nonempty,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ~ ( finite_finite2 @ A @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% infinite_imp_nonempty
thf(fact_240_count__list_Osimps_I1_J,axiom,(
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) )).

% count_list.simps(1)
thf(fact_241_subset__emptyI,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ! [X: A] :
          ~ ( member2 @ A @ X @ A2 )
     => ( ord_less_eq @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_242_distinct__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% distinct_append
thf(fact_243_IntI,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member2 @ A @ C @ A2 )
     => ( ( member2 @ A @ C @ B2 )
       => ( member2 @ A @ C @ ( inf_inf @ ( set @ A ) @ A2 @ B2 ) ) ) ) )).

% IntI
thf(fact_244_Int__iff,axiom,(
    ! [A: $tType,C: A,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( member2 @ A @ C @ ( inf_inf @ ( set @ A ) @ A2 @ B2 ) )
      = ( ( member2 @ A @ C @ A2 )
        & ( member2 @ A @ C @ B2 ) ) ) )).

% Int_iff
thf(fact_245_finite__Int,axiom,(
    ! [A: $tType,F4: ( set @ A ),G3: ( set @ A )] :
      ( ( ( finite_finite2 @ A @ F4 )
        | ( finite_finite2 @ A @ G3 ) )
     => ( finite_finite2 @ A @ ( inf_inf @ ( set @ A ) @ F4 @ G3 ) ) ) )).

% finite_Int
thf(fact_246_Int__subset__iff,axiom,(
    ! [A: $tType,C3: ( set @ A ),A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ ( inf_inf @ ( set @ A ) @ A2 @ B2 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C3 @ A2 )
        & ( ord_less_eq @ ( set @ A ) @ C3 @ B2 ) ) ) )).

% Int_subset_iff
thf(fact_247_disjoint__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),A7: ( set @ A ),B4: ( set @ A ),B6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ A7 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ B6 )
       => ( ( ( inf_inf @ ( set @ A ) @ A7 @ B6 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( inf_inf @ ( set @ A ) @ A4 @ B4 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% disjoint_mono
thf(fact_248_disjointI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: ( set @ A )] :
      ( ! [X: A] :
          ( ( member2 @ A @ X @ A4 )
         => ~ ( member2 @ A @ X @ B4 ) )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B4 )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% disjointI
thf(fact_249_disjoint__iff__not__equal,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A2 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ( ( member2 @ A @ X3 @ A2 )
           => ! [Y3: A] :
                ( ( member2 @ A @ Y3 @ B2 )
               => ( X3 != Y3 ) ) ) ) ) )).

% disjoint_iff_not_equal
thf(fact_250_Int__empty__right,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A2 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_right
thf(fact_251_Int__empty__left,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_left
thf(fact_252_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_253_Int__emptyI,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A )] :
      ( ! [X: A] :
          ( ( member2 @ A @ X @ A2 )
         => ~ ( member2 @ A @ X @ B2 ) )
     => ( ( inf_inf @ ( set @ A ) @ A2 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% Int_emptyI
thf(fact_254_Int__Collect__mono,axiom,(
    ! [A: $tType,A2: ( set @ A ),B2: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ A2 @ B2 )
     => ( ! [X: A] :
            ( ( member2 @ A @ X @ A2 )
           => ( ( P @ X )
             => ( Q @ X ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A2 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B2 @ ( collect @ A @ Q ) ) ) ) ) )).

% Int_Collect_mono

%----Subclasses (4)
thf(subcl_Orderings_Olinorder___HOL_Otype,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( type @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oord,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ord @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( order @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Opreorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( preorder @ A @ ( type2 @ A ) ) ) )).

%----Type constructors (27)
thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_bot @ A9 @ ( type2 @ A9 ) )
     => ( order_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Finite__Set_Ofinite,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
        & ( finite_finite @ A9 @ ( type2 @ A9 ) ) )
     => ( finite_finite @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_1,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_2,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_3,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_4,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_5,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_6,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_7,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Finite__Set_Ofinite_8,axiom,(
    ! [A8: $tType] :
      ( ( finite_finite @ A8 @ ( type2 @ A8 ) )
     => ( finite_finite @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_9,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_10,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_11,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_12,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_13,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_14,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Finite__Set_Ofinite_15,axiom,
    ( finite_finite @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_16,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_17,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_18,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type2 @ a ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( sorted1061247458sorted @ a @ l1 @ l2 )
    = ( ord_less_eq @ ( set @ a ) @ ( set2 @ a @ l1 ) @ ( set2 @ a @ l2 ) ) )).

%------------------------------------------------------------------------------
