%------------------------------------------------------------------------------
% File     : DAT207^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Sorted list operations 243
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Lam09] Lammich (2009), Collections Framework
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : sorted_list_operations__243.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  348 (   0 unit;  56 type;   0 defn)
%            Number of atoms       : 5383 ( 453 equality;3380 variable)
%            Maximal formula depth :   28 (  10 average)
%            Number of connectives : 4897 ( 170   ~;  14   |;  82   &;4153   @)
%                                         (   0 <=>; 478  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  277 ( 277   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   58 (  56   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1273 (   2 sgn;1134   !;  49   ?;  34   ^)
%                                         (1273   :;  56  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:25.989
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (52)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oshift,type,(
    bNF_Greatest_shift: 
      !>[A: $tType,B: $tType] :
        ( ( ( list @ A ) > B ) > A > ( list @ A ) > B ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,(
    linord467138063of_set: 
      !>[A: $tType] :
        ( ( set @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Omap,type,(
    map: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Olistrelp,type,(
    listrelp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) )).

thf(sy_c_List_Omap__tailrec,type,(
    map_tailrec: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omap__tailrec__rev,type,(
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord__class_Olexordp__eq,type,(
    ord_lexordp_eq: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Orev,type,(
    rev: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osplice,type,(
    splice: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List__More_Ocombinatorial__product,type,(
    list_c659805718roduct: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_Misc_Olist__collect__set,type,(
    list_collect_set: 
      !>[B: $tType,A: $tType] :
        ( ( B > ( set @ A ) ) > ( list @ B ) > ( set @ A ) ) )).

thf(sy_c_Misc_Omerge,type,(
    merge: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Misc_Omerge__list,type,(
    merge_list: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > ( list @ A ) ) )).

thf(sy_c_Misc_Orevg,type,(
    revg: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Sorted__List__Operations__Mirabelle__fineeiboro_Odiff__sorted,type,(
    sorted1267110213sorted: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Sorted__List__Operations__Mirabelle__fineeiboro_Ointer__sorted,type,(
    sorted2037043510sorted: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Sorted__List__Operations__Mirabelle__fineeiboro_Osubset__sorted,type,(
    sorted1061247458sorted: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_l1_H____,type,(
    l1: ( list @ a ) )).

thf(sy_v_l2a____,type,(
    l2a: ( list @ a ) )).

thf(sy_v_x1____,type,(
    x1: a )).

%----Relevant facts (255)
thf(fact_0_local_ONil,axiom,
    ( l2a
    = ( nil @ a ) )).

% local.Nil
thf(fact_1_ind__hyp,axiom,(
    ! [L2: ( list @ a )] :
      ( ( l1 = L2 )
      = ( ( sorted1061247458sorted @ a @ l1 @ L2 )
        & ( sorted1061247458sorted @ a @ L2 @ l1 ) ) ) )).

% ind_hyp
thf(fact_2_subset__sorted_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X1: A,L1: ( list @ A )] :
          ~ ( sorted1061247458sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( nil @ A ) ) ) )).

% subset_sorted.simps(2)
thf(fact_3_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_4_subset__sorted_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( list @ A )] :
          ( sorted1061247458sorted @ A @ ( nil @ A ) @ L2 ) ) )).

% subset_sorted.simps(1)
thf(fact_5_not__Cons__self2,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_6_list__tail__coinc,axiom,(
    ! [A: $tType,N1: A,R1: ( list @ A ),N2: A,R2: ( list @ A )] :
      ( ( ( cons @ A @ N1 @ R1 )
        = ( cons @ A @ N2 @ R2 ) )
     => ( ( N1 = N2 )
        & ( R1 = R2 ) ) ) )).

% list_tail_coinc
thf(fact_7_subset__sorted_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X1: A,L1: ( list @ A ),X2: A,L2: ( list @ A )] :
          ( ( sorted1061247458sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
          = ( ~ ( ord_less @ A @ X1 @ X2 )
            & ( ~ ( ord_less @ A @ X1 @ X2 )
             => ( ( ( X1 = X2 )
                 => ( sorted1061247458sorted @ A @ L1 @ L2 ) )
                & ( ( X1 != X2 )
                 => ( sorted1061247458sorted @ A @ ( cons @ A @ X1 @ L1 ) @ L2 ) ) ) ) ) ) ) )).

% subset_sorted.simps(3)
thf(fact_8_shift__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Greatest_shift @ A @ B )
      = ( ^ [Lab: ( ( list @ A ) > B ),K: A,Kl: ( list @ A )] :
            ( Lab @ ( cons @ A @ K @ Kl ) ) ) ) )).

% shift_def
thf(fact_9_subset__sorted_Oelims_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A ),Xa: ( list @ A )] :
          ( ~ ( sorted1061247458sorted @ A @ X @ Xa )
         => ( ( ? [X12: A,L12: ( list @ A )] :
                  ( X
                  = ( cons @ A @ X12 @ L12 ) )
             => ( Xa
               != ( nil @ A ) ) )
           => ~ ( ! [X12: A,L12: ( list @ A )] :
                    ( ( X
                      = ( cons @ A @ X12 @ L12 ) )
                   => ! [X23: A,L22: ( list @ A )] :
                        ( ( Xa
                          = ( cons @ A @ X23 @ L22 ) )
                       => ( ~ ( ord_less @ A @ X12 @ X23 )
                          & ( ~ ( ord_less @ A @ X12 @ X23 )
                           => ( ( ( X12 = X23 )
                               => ( sorted1061247458sorted @ A @ L12 @ L22 ) )
                              & ( ( X12 != X23 )
                               => ( sorted1061247458sorted @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) ) ) ) ) ) )).

% subset_sorted.elims(3)
thf(fact_10_subset__sorted_Oelims_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A ),Xa: ( list @ A )] :
          ( ( sorted1061247458sorted @ A @ X @ Xa )
         => ( ( ( X
                = ( nil @ A ) )
             => ! [L22: ( list @ A )] : ( Xa != L22 ) )
           => ~ ( ! [X12: A,L12: ( list @ A )] :
                    ( ( X
                      = ( cons @ A @ X12 @ L12 ) )
                   => ! [X23: A,L22: ( list @ A )] :
                        ( ( Xa
                          = ( cons @ A @ X23 @ L22 ) )
                       => ~ ( ~ ( ord_less @ A @ X12 @ X23 )
                            & ( ~ ( ord_less @ A @ X12 @ X23 )
                             => ( ( ( X12 = X23 )
                                 => ( sorted1061247458sorted @ A @ L12 @ L22 ) )
                                & ( ( X12 != X23 )
                                 => ( sorted1061247458sorted @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) ) ) ) ) ) )).

% subset_sorted.elims(2)
thf(fact_11_subset__sorted_Oelims_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A ),Xa: ( list @ A ),Y: $o] :
          ( ( ( sorted1061247458sorted @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ A ) )
             => ~ ( Y ) )
           => ( ( ? [X12: A,L12: ( list @ A )] :
                    ( X
                    = ( cons @ A @ X12 @ L12 ) )
               => ( ( Xa
                    = ( nil @ A ) )
                 => Y ) )
             => ~ ( ! [X12: A,L12: ( list @ A )] :
                      ( ( X
                        = ( cons @ A @ X12 @ L12 ) )
                     => ! [X23: A,L22: ( list @ A )] :
                          ( ( Xa
                            = ( cons @ A @ X23 @ L22 ) )
                         => ( Y
                            = ( ~ ( ~ ( ord_less @ A @ X12 @ X23 )
                                  & ( ~ ( ord_less @ A @ X12 @ X23 )
                                   => ( ( ( X12 = X23 )
                                       => ( sorted1061247458sorted @ A @ L12 @ L22 ) )
                                      & ( ( X12 != X23 )
                                       => ( sorted1061247458sorted @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) ) ) ) ) ) ) ) ) )).

% subset_sorted.elims(1)
thf(fact_12_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_13_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_14_transpose_Ocases,axiom,(
    ! [A: $tType,X: ( list @ ( list @ A ) )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X3: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X
               != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_15_subset__sorted_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
          ( ! [X12: ( list @ A )] :
              ( P @ ( nil @ A ) @ X12 )
         => ( ! [X12: A,L12: ( list @ A )] :
                ( P @ ( cons @ A @ X12 @ L12 ) @ ( nil @ A ) )
           => ( ! [X12: A,L12: ( list @ A ),X23: A,L22: ( list @ A )] :
                  ( ( ~ ( ord_less @ A @ X12 @ X23 )
                   => ( ( X12 = X23 )
                     => ( P @ L12 @ L22 ) ) )
                 => ( ( ~ ( ord_less @ A @ X12 @ X23 )
                     => ( ( X12 != X23 )
                       => ( P @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) )
                   => ( P @ ( cons @ A @ X12 @ L12 ) @ ( cons @ A @ X23 @ L22 ) ) ) )
             => ( P @ A0 @ A1 ) ) ) ) ) )).

% subset_sorted.induct
thf(fact_16_inter__sorted_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
          ( ! [X12: ( list @ A )] :
              ( P @ ( nil @ A ) @ X12 )
         => ( ! [V: A,Va: ( list @ A )] :
                ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
           => ( ! [X12: A,L12: ( list @ A ),X23: A,L22: ( list @ A )] :
                  ( ( ( ord_less @ A @ X12 @ X23 )
                   => ( P @ L12 @ ( cons @ A @ X23 @ L22 ) ) )
                 => ( ( ~ ( ord_less @ A @ X12 @ X23 )
                     => ( ( X12 = X23 )
                       => ( P @ L12 @ L22 ) ) )
                   => ( ( ~ ( ord_less @ A @ X12 @ X23 )
                       => ( ( X12 != X23 )
                         => ( P @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) )
                     => ( P @ ( cons @ A @ X12 @ L12 ) @ ( cons @ A @ X23 @ L22 ) ) ) ) )
             => ( P @ A0 @ A1 ) ) ) ) ) )).

% inter_sorted.induct
thf(fact_17_mergesort__by__rel__merge__induct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),R: ( A > B > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ! [Xs2: ( list @ A )] :
          ( P @ Xs2 @ ( nil @ B ) )
     => ( ! [X12: ( list @ B )] :
            ( P @ ( nil @ A ) @ X12 )
       => ( ! [X3: A,Xs2: ( list @ A ),Y2: B,Ys2: ( list @ B )] :
              ( ( R @ X3 @ Y2 )
             => ( ( P @ Xs2 @ ( cons @ B @ Y2 @ Ys2 ) )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) ) )
         => ( ! [X3: A,Xs2: ( list @ A ),Y2: B,Ys2: ( list @ B )] :
                ( ~ ( R @ X3 @ Y2 )
               => ( ( P @ ( cons @ A @ X3 @ Xs2 ) @ Ys2 )
                 => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% mergesort_by_rel_merge_induct
thf(fact_18_mergesort__by__rel__merge_Oinduct,axiom,(
    ! [A: $tType,P: ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ),A0: ( A > A > $o ),A1: ( list @ A ),A2: ( list @ A )] :
      ( ! [R3: ( A > A > $o ),X3: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
          ( ( ( R3 @ X3 @ Y2 )
           => ( P @ R3 @ Xs2 @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( ( ~ ( R3 @ X3 @ Y2 )
             => ( P @ R3 @ ( cons @ A @ X3 @ Xs2 ) @ Ys2 ) )
           => ( P @ R3 @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) )
     => ( ! [R3: ( A > A > $o ),Xs2: ( list @ A )] :
            ( P @ R3 @ Xs2 @ ( nil @ A ) )
       => ( ! [R3: ( A > A > $o ),V: A,Va: ( list @ A )] :
              ( P @ R3 @ ( nil @ A ) @ ( cons @ A @ V @ Va ) )
         => ( P @ A0 @ A1 @ A2 ) ) ) ) )).

% mergesort_by_rel_merge.induct
thf(fact_19_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A2: ( list @ B )] :
      ( ! [F: ( A > B ),X12: ( list @ B )] :
          ( P @ F @ ( nil @ A ) @ X12 )
     => ( ! [F: ( A > B ),A3: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F @ As @ ( cons @ B @ ( F @ A3 ) @ Bs ) )
           => ( P @ F @ ( cons @ A @ A3 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A2 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_20_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_21_list__all__zip_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B > $o ),A1: ( list @ A ),A2: ( list @ B )] :
      ( ! [P2: ( A > B > $o )] :
          ( P @ P2 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [P2: ( A > B > $o ),A3: A,As: ( list @ A ),B2: B,Bs: ( list @ B )] :
            ( ( P @ P2 @ As @ Bs )
           => ( P @ P2 @ ( cons @ A @ A3 @ As ) @ ( cons @ B @ B2 @ Bs ) ) )
       => ( ! [P2: ( A > B > $o ),V: A,Va: ( list @ A )] :
              ( P @ P2 @ ( cons @ A @ V @ Va ) @ ( nil @ B ) )
         => ( ! [P2: ( A > B > $o ),V: B,Va: ( list @ B )] :
                ( P @ P2 @ ( nil @ A ) @ ( cons @ B @ V @ Va ) )
           => ( P @ A0 @ A1 @ A2 ) ) ) ) ) )).

% list_all_zip.induct
thf(fact_22_list__induct__first2,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X12: A,X23: A,Xs2: ( list @ A )] :
              ( ( P @ Xs2 )
             => ( P @ ( cons @ A @ X12 @ ( cons @ A @ X23 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_induct_first2
thf(fact_23_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
              ( ( ( X3 = Y2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) )
             => ( ( ( X3 != Y2 )
                 => ( P @ ( cons @ A @ Y2 @ Xs2 ) ) )
               => ( P @ ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_24_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X: ( list @ A )] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
                ( X
               != ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_25_list__2pre__induct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),W1: ( list @ A ),W2: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [E: A,W12: ( list @ A ),W22: ( list @ B )] :
            ( ( P @ W12 @ W22 )
           => ( P @ ( cons @ A @ E @ W12 ) @ W22 ) )
       => ( ! [E: B,W13: ( list @ A ),W23: ( list @ B )] :
              ( ( P @ W13 @ W23 )
             => ( P @ W13 @ ( cons @ B @ E @ W23 ) ) )
         => ( P @ W1 @ W2 ) ) ) ) )).

% list_2pre_induct
thf(fact_26_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P @ ( nil @ A ) @ X12 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X3: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
              ( ( P @ Xs2 @ Ys2 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_27_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: ( list @ A )] :
            ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys2: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys2 ) )
         => ( ! [X3: A,Xs2: ( list @ A ),Y2: B,Ys2: ( list @ B )] :
                ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_28_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_29_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X12: A,X23: ( list @ A )] :
            ( ( P @ X23 )
           => ( P @ ( cons @ A @ X12 @ X23 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_30_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_31_zipf_Oinduct,axiom,(
    ! [A: $tType,C: $tType,B: $tType,P: ( ( A > B > C ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B > C ),A1: ( list @ A ),A2: ( list @ B )] :
      ( ! [F: ( A > B > C )] :
          ( P @ F @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [F: ( A > B > C ),A3: A,As: ( list @ A ),B2: B,Bs: ( list @ B )] :
            ( ( P @ F @ As @ Bs )
           => ( P @ F @ ( cons @ A @ A3 @ As ) @ ( cons @ B @ B2 @ Bs ) ) )
       => ( ! [A3: ( A > B > C ),V: A,Va: ( list @ A )] :
              ( P @ A3 @ ( cons @ A @ V @ Va ) @ ( nil @ B ) )
         => ( ! [A3: ( A > B > C ),V: B,Va: ( list @ B )] :
                ( P @ A3 @ ( nil @ A ) @ ( cons @ B @ V @ Va ) )
           => ( P @ A0 @ A1 @ A2 ) ) ) ) ) )).

% zipf.induct
thf(fact_32_revg_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P @ ( nil @ A ) @ X12 )
     => ( ! [A3: A,As: ( list @ A ),B2: ( list @ A )] :
            ( ( P @ As @ ( cons @ A @ A3 @ B2 ) )
           => ( P @ ( cons @ A @ A3 @ As ) @ B2 ) )
       => ( P @ A0 @ A1 ) ) ) )).

% revg.induct
thf(fact_33_quicksort_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A )] :
          ( ( X
           != ( nil @ A ) )
         => ~ ( ! [X3: A,Xs2: ( list @ A )] :
                  ( X
                 != ( cons @ A @ X3 @ Xs2 ) ) ) ) ) )).

% quicksort.cases
thf(fact_34_insert__Nil,axiom,(
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_35_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_36_inter__sorted_Oelims,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
          ( ( ( sorted2037043510sorted @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ A ) )
             => ( Y
               != ( nil @ A ) ) )
           => ( ( ? [V: A,Va: ( list @ A )] :
                    ( X
                    = ( cons @ A @ V @ Va ) )
               => ( ( Xa
                    = ( nil @ A ) )
                 => ( Y
                   != ( nil @ A ) ) ) )
             => ~ ( ! [X12: A,L12: ( list @ A )] :
                      ( ( X
                        = ( cons @ A @ X12 @ L12 ) )
                     => ! [X23: A,L22: ( list @ A )] :
                          ( ( Xa
                            = ( cons @ A @ X23 @ L22 ) )
                         => ~ ( ( ( ord_less @ A @ X12 @ X23 )
                               => ( Y
                                  = ( sorted2037043510sorted @ A @ L12 @ ( cons @ A @ X23 @ L22 ) ) ) )
                              & ( ~ ( ord_less @ A @ X12 @ X23 )
                               => ( ( ( X12 = X23 )
                                   => ( Y
                                      = ( cons @ A @ X12 @ ( sorted2037043510sorted @ A @ L12 @ L22 ) ) ) )
                                  & ( ( X12 != X23 )
                                   => ( Y
                                      = ( sorted2037043510sorted @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) ) ) ) ) ) ) ) )).

% inter_sorted.elims
thf(fact_37_diff__sorted_Oelims,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
          ( ( ( sorted1267110213sorted @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ A ) )
             => ( Y
               != ( nil @ A ) ) )
           => ( ! [V: A,Va: ( list @ A )] :
                  ( ( X
                    = ( cons @ A @ V @ Va ) )
                 => ( ( Xa
                      = ( nil @ A ) )
                   => ( Y
                     != ( cons @ A @ V @ Va ) ) ) )
             => ~ ( ! [X12: A,L12: ( list @ A )] :
                      ( ( X
                        = ( cons @ A @ X12 @ L12 ) )
                     => ! [X23: A,L22: ( list @ A )] :
                          ( ( Xa
                            = ( cons @ A @ X23 @ L22 ) )
                         => ~ ( ( ( ord_less @ A @ X12 @ X23 )
                               => ( Y
                                  = ( cons @ A @ X12 @ ( sorted1267110213sorted @ A @ L12 @ ( cons @ A @ X23 @ L22 ) ) ) ) )
                              & ( ~ ( ord_less @ A @ X12 @ X23 )
                               => ( ( ( X12 = X23 )
                                   => ( Y
                                      = ( sorted1267110213sorted @ A @ L12 @ L22 ) ) )
                                  & ( ( X12 != X23 )
                                   => ( Y
                                      = ( sorted1267110213sorted @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) ) ) ) ) ) ) ) )).

% diff_sorted.elims
thf(fact_38_merge_Oelims,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
          ( ( ( merge @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ A ) )
             => ( Y != Xa ) )
           => ( ! [V: A,Va: ( list @ A )] :
                  ( ( X
                    = ( cons @ A @ V @ Va ) )
                 => ( ( Xa
                      = ( nil @ A ) )
                   => ( Y
                     != ( cons @ A @ V @ Va ) ) ) )
             => ~ ( ! [X12: A,L12: ( list @ A )] :
                      ( ( X
                        = ( cons @ A @ X12 @ L12 ) )
                     => ! [X23: A,L22: ( list @ A )] :
                          ( ( Xa
                            = ( cons @ A @ X23 @ L22 ) )
                         => ~ ( ( ( ord_less @ A @ X12 @ X23 )
                               => ( Y
                                  = ( cons @ A @ X12 @ ( merge @ A @ L12 @ ( cons @ A @ X23 @ L22 ) ) ) ) )
                              & ( ~ ( ord_less @ A @ X12 @ X23 )
                               => ( ( ( X12 = X23 )
                                   => ( Y
                                      = ( cons @ A @ X12 @ ( merge @ A @ L12 @ L22 ) ) ) )
                                  & ( ( X12 != X23 )
                                   => ( Y
                                      = ( cons @ A @ X23 @ ( merge @ A @ ( cons @ A @ X12 @ L12 ) @ L22 ) ) ) ) ) ) ) ) ) ) ) ) ) ) )).

% merge.elims
thf(fact_39_revg_Oelims,axiom,(
    ! [A: $tType,X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
      ( ( ( revg @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ~ ( ! [A3: A,As: ( list @ A )] :
                ( ( X
                  = ( cons @ A @ A3 @ As ) )
               => ( Y
                 != ( revg @ A @ As @ ( cons @ A @ A3 @ Xa ) ) ) ) ) ) ) )).

% revg.elims
thf(fact_40_list__collect__set__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > ( set @ A ) ),A4: B] :
      ( ( list_collect_set @ B @ A @ F2 @ ( cons @ B @ A4 @ ( nil @ B ) ) )
      = ( F2 @ A4 ) ) )).

% list_collect_set_simps(2)
thf(fact_41_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_42_lexordp__eq_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A1: ( list @ A ),A2: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ A1 @ A2 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Ys2: ( list @ A )] : ( A2 != Ys2 ) )
           => ( ! [X3: A] :
                  ( ? [Xs2: ( list @ A )] :
                      ( A1
                      = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y2: A] :
                      ( ? [Ys2: ( list @ A )] :
                          ( A2
                          = ( cons @ A @ Y2 @ Ys2 ) )
                     => ~ ( ord_less @ A @ X3 @ Y2 ) ) )
             => ~ ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
                      ( ( A1
                        = ( cons @ A @ X3 @ Xs2 ) )
                     => ! [Ys2: ( list @ A )] :
                          ( ( A2
                            = ( cons @ A @ Y2 @ Ys2 ) )
                         => ( ~ ( ord_less @ A @ X3 @ Y2 )
                           => ( ~ ( ord_less @ A @ Y2 @ X3 )
                             => ~ ( ord_lexordp_eq @ A @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) ) )).

% lexordp_eq.cases
thf(fact_43_lexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [A12: ( list @ A ),A22: ( list @ A )] :
              ( ? [Ys3: ( list @ A )] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A22 = Ys3 ) )
              | ? [X4: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X4 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ( ord_less @ A @ X4 @ Y3 ) )
              | ? [X4: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X4 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ~ ( ord_less @ A @ X4 @ Y3 )
                  & ~ ( ord_less @ A @ Y3 @ X4 )
                  & ( ord_lexordp_eq @ A @ Xs3 @ Ys3 ) ) ) ) ) ) )).

% lexordp_eq.simps
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P: ( A > $o )] :
      ( ( member @ A @ A4 @ ( collect @ A @ P ) )
      = ( P @ A4 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) )).

% ext
thf(fact_48_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_49_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_50_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_51_lexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) )).

% lexordp_eq_simps(1)
thf(fact_52_lexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ ( nil @ A ) )
          = ( Xs
            = ( nil @ A ) ) ) ) )).

% lexordp_eq_simps(2)
thf(fact_53_lexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp_eq @ A @ Xs @ Ys ) ) ) ) ) )).

% lexordp_eq_simps(4)
thf(fact_54_lexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A )] :
          ~ ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) ) )).

% lexordp_eq_simps(3)
thf(fact_55_merge__list_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ),A0: ( list @ ( list @ A ) ),A1: ( list @ ( list @ A ) )] :
          ( ( P @ ( nil @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) )
         => ( ! [L: ( list @ A )] :
                ( P @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L @ ( nil @ ( list @ A ) ) ) )
           => ( ! [La: ( list @ A ),Acc2: ( list @ ( list @ A ) )] :
                  ( ( P @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La @ Acc2 ) )
                 => ( P @ ( cons @ ( list @ A ) @ La @ Acc2 ) @ ( nil @ ( list @ A ) ) ) )
             => ( ! [La: ( list @ A ),Acc2: ( list @ ( list @ A ) ),L: ( list @ A )] :
                    ( ( P @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) )
                   => ( P @ ( cons @ ( list @ A ) @ La @ Acc2 ) @ ( cons @ ( list @ A ) @ L @ ( nil @ ( list @ A ) ) ) ) )
               => ( ! [Acc2: ( list @ ( list @ A ) ),L12: ( list @ A ),L22: ( list @ A ),Ls: ( list @ ( list @ A ) )] :
                      ( ( P @ ( cons @ ( list @ A ) @ ( merge @ A @ L12 @ L22 ) @ Acc2 ) @ Ls )
                     => ( P @ Acc2 @ ( cons @ ( list @ A ) @ L12 @ ( cons @ ( list @ A ) @ L22 @ Ls ) ) ) )
                 => ( P @ A0 @ A1 ) ) ) ) ) ) ) )).

% merge_list.induct
thf(fact_56_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_57_lexordp__eq__refl,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ord_lexordp_eq @ A @ Xs @ Xs ) ) )).

% lexordp_eq_refl
thf(fact_58_lexordp__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Zs )
           => ( ord_lexordp_eq @ A @ Xs @ Zs ) ) ) ) )).

% lexordp_eq_trans
thf(fact_59_lexordp__eq__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
          | ( ord_lexordp_eq @ A @ Ys @ Xs ) ) ) )).

% lexordp_eq_linear
thf(fact_60_lexordp__eq__antisym,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Xs )
           => ( Xs = Ys ) ) ) ) )).

% lexordp_eq_antisym
thf(fact_61_lexordp__eq_ONil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) )).

% lexordp_eq.Nil
thf(fact_62_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_63_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_64_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_65_merge_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( list @ A )] :
          ( ( merge @ A @ ( nil @ A ) @ L2 )
          = L2 ) ) )).

% merge.simps(1)
thf(fact_66_inter__sorted_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( list @ A )] :
          ( ( sorted2037043510sorted @ A @ ( nil @ A ) @ L2 )
          = ( nil @ A ) ) ) )).

% inter_sorted.simps(1)
thf(fact_67_diff__sorted_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( list @ A )] :
          ( ( sorted1267110213sorted @ A @ ( nil @ A ) @ L2 )
          = ( nil @ A ) ) ) )).

% diff_sorted.simps(1)
thf(fact_68_revg_Osimps_I2_J,axiom,(
    ! [A: $tType,A4: A,As2: ( list @ A ),B3: ( list @ A )] :
      ( ( revg @ A @ ( cons @ A @ A4 @ As2 ) @ B3 )
      = ( revg @ A @ As2 @ ( cons @ A @ A4 @ B3 ) ) ) )).

% revg.simps(2)
thf(fact_69_revg_Osimps_I1_J,axiom,(
    ! [A: $tType,B3: ( list @ A )] :
      ( ( revg @ A @ ( nil @ A ) @ B3 )
      = B3 ) )).

% revg.simps(1)
thf(fact_70_lexordp__eq_OCons__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp_eq @ A @ Xs @ Ys )
             => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ) )).

% lexordp_eq.Cons_eq
thf(fact_71_lexordp__eq_OCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) )).

% lexordp_eq.Cons
thf(fact_72_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A2: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A2 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys2: ( list @ A )] : ( A2 != Ys2 ) )
       => ( ! [X3: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y2: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A2
                      = ( cons @ A @ Y2 @ Ys2 ) )
                 => ~ ( Less @ X3 @ Y2 ) ) )
         => ~ ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A2
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( ~ ( Less @ X3 @ Y2 )
                       => ( ~ ( Less @ Y2 @ X3 )
                         => ~ ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_73_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A22: ( list @ A )] :
            ( ? [Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A22 = Ys3 ) )
            | ? [X4: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( A22
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ( Less2 @ X4 @ Y3 ) )
            | ? [X4: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( A22
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ~ ( Less2 @ X4 @ Y3 )
                & ~ ( Less2 @ Y3 @ X4 )
                & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_74_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X1: ( list @ A ),X2: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X1 @ X2 )
     => ( ! [X12: ( list @ A )] :
            ( P @ ( nil @ A ) @ X12 )
       => ( ! [X3: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less @ X3 @ Y2 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( ! [X3: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less @ X3 @ Y2 )
               => ( ~ ( Less @ Y2 @ X3 )
                 => ( ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X2 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_75_merge_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X1: A,X2: A,L1: ( list @ A ),L2: ( list @ A )] :
          ( ( ( ord_less @ A @ X1 @ X2 )
           => ( ( merge @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
              = ( cons @ A @ X1 @ ( merge @ A @ L1 @ ( cons @ A @ X2 @ L2 ) ) ) ) )
          & ( ~ ( ord_less @ A @ X1 @ X2 )
           => ( ( ( X1 = X2 )
               => ( ( merge @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
                  = ( cons @ A @ X1 @ ( merge @ A @ L1 @ L2 ) ) ) )
              & ( ( X1 != X2 )
               => ( ( merge @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
                  = ( cons @ A @ X2 @ ( merge @ A @ ( cons @ A @ X1 @ L1 ) @ L2 ) ) ) ) ) ) ) ) )).

% merge.simps(3)
thf(fact_76_merge_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [V2: A,Va2: ( list @ A )] :
          ( ( merge @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
          = ( cons @ A @ V2 @ Va2 ) ) ) )).

% merge.simps(2)
thf(fact_77_diff__sorted_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X1: A,X2: A,L1: ( list @ A ),L2: ( list @ A )] :
          ( ( ( ord_less @ A @ X1 @ X2 )
           => ( ( sorted1267110213sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
              = ( cons @ A @ X1 @ ( sorted1267110213sorted @ A @ L1 @ ( cons @ A @ X2 @ L2 ) ) ) ) )
          & ( ~ ( ord_less @ A @ X1 @ X2 )
           => ( ( ( X1 = X2 )
               => ( ( sorted1267110213sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
                  = ( sorted1267110213sorted @ A @ L1 @ L2 ) ) )
              & ( ( X1 != X2 )
               => ( ( sorted1267110213sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
                  = ( sorted1267110213sorted @ A @ ( cons @ A @ X1 @ L1 ) @ L2 ) ) ) ) ) ) ) )).

% diff_sorted.simps(3)
thf(fact_78_inter__sorted_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X1: A,X2: A,L1: ( list @ A ),L2: ( list @ A )] :
          ( ( ( ord_less @ A @ X1 @ X2 )
           => ( ( sorted2037043510sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
              = ( sorted2037043510sorted @ A @ L1 @ ( cons @ A @ X2 @ L2 ) ) ) )
          & ( ~ ( ord_less @ A @ X1 @ X2 )
           => ( ( ( X1 = X2 )
               => ( ( sorted2037043510sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
                  = ( cons @ A @ X1 @ ( sorted2037043510sorted @ A @ L1 @ L2 ) ) ) )
              & ( ( X1 != X2 )
               => ( ( sorted2037043510sorted @ A @ ( cons @ A @ X1 @ L1 ) @ ( cons @ A @ X2 @ L2 ) )
                  = ( sorted2037043510sorted @ A @ ( cons @ A @ X1 @ L1 ) @ L2 ) ) ) ) ) ) ) )).

% inter_sorted.simps(3)
thf(fact_79_diff__sorted_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [V2: A,Va2: ( list @ A )] :
          ( ( sorted1267110213sorted @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
          = ( cons @ A @ V2 @ Va2 ) ) ) )).

% diff_sorted.simps(2)
thf(fact_80_inter__sorted_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [V2: A,Va2: ( list @ A )] :
          ( ( sorted2037043510sorted @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
          = ( nil @ A ) ) ) )).

% inter_sorted.simps(2)
thf(fact_81_lexordp__eq_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X1: ( list @ A ),X2: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp_eq @ A @ X1 @ X2 )
         => ( ! [X12: ( list @ A )] :
                ( P @ ( nil @ A ) @ X12 )
           => ( ! [X3: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                  ( ( ord_less @ A @ X3 @ Y2 )
                 => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
             => ( ! [X3: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                    ( ~ ( ord_less @ A @ X3 @ Y2 )
                   => ( ~ ( ord_less @ A @ Y2 @ X3 )
                     => ( ( ord_lexordp_eq @ A @ Xs2 @ Ys2 )
                       => ( ( P @ Xs2 @ Ys2 )
                         => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
               => ( P @ X1 @ X2 ) ) ) ) ) ) )).

% lexordp_eq.inducts
thf(fact_82_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_83_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_84_merge__list_Oelims,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( list @ ( list @ A ) ),Xa: ( list @ ( list @ A ) ),Y: ( list @ A )] :
          ( ( ( merge_list @ A @ X @ Xa )
            = Y )
         => ( ( ( X
                = ( nil @ ( list @ A ) ) )
             => ( ( Xa
                  = ( nil @ ( list @ A ) ) )
               => ( Y
                 != ( nil @ A ) ) ) )
           => ( ( ( X
                  = ( nil @ ( list @ A ) ) )
               => ! [L: ( list @ A )] :
                    ( ( Xa
                      = ( cons @ ( list @ A ) @ L @ ( nil @ ( list @ A ) ) ) )
                   => ( Y != L ) ) )
             => ( ! [La: ( list @ A ),Acc2: ( list @ ( list @ A ) )] :
                    ( ( X
                      = ( cons @ ( list @ A ) @ La @ Acc2 ) )
                   => ( ( Xa
                        = ( nil @ ( list @ A ) ) )
                     => ( Y
                       != ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) ) ) )
               => ( ! [La: ( list @ A ),Acc2: ( list @ ( list @ A ) )] :
                      ( ( X
                        = ( cons @ ( list @ A ) @ La @ Acc2 ) )
                     => ! [L: ( list @ A )] :
                          ( ( Xa
                            = ( cons @ ( list @ A ) @ L @ ( nil @ ( list @ A ) ) ) )
                         => ( Y
                           != ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L @ ( cons @ ( list @ A ) @ La @ Acc2 ) ) ) ) ) )
                 => ~ ( ! [L12: ( list @ A ),L22: ( list @ A ),Ls: ( list @ ( list @ A ) )] :
                          ( ( Xa
                            = ( cons @ ( list @ A ) @ L12 @ ( cons @ ( list @ A ) @ L22 @ Ls ) ) )
                         => ( Y
                           != ( merge_list @ A @ ( cons @ ( list @ A ) @ ( merge @ A @ L12 @ L22 ) @ X ) @ Ls ) ) ) ) ) ) ) ) ) ) )).

% merge_list.elims
thf(fact_85_combinatorial__product_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( list_c659805718roduct @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% combinatorial_product.simps(1)
thf(fact_86_map__tailrec__rev_Oelims,axiom,(
    ! [A: $tType,B: $tType,X: ( A > B ),Xa: ( list @ A ),Xb: ( list @ B ),Y: ( list @ B )] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb ) )
       => ~ ( ! [A3: A,As: ( list @ A )] :
                ( ( Xa
                  = ( cons @ A @ A3 @ As ) )
               => ( Y
                 != ( map_tailrec_rev @ A @ B @ X @ As @ ( cons @ B @ ( X @ A3 ) @ Xb ) ) ) ) ) ) ) )).

% map_tailrec_rev.elims
thf(fact_87_list__collect__set__map__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( B > ( set @ A ) ),X: ( C > B ),A4: C] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ ( cons @ C @ A4 @ ( nil @ C ) ) ) )
      = ( F2 @ ( X @ A4 ) ) ) )).

% list_collect_set_map_simps(2)
thf(fact_88_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_89_splice_Osimps_I2_J,axiom,(
    ! [A: $tType,V2: A,Va2: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
      = ( cons @ A @ V2 @ Va2 ) ) )).

% splice.simps(2)
thf(fact_90_Nil__is__map__conv,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% Nil_is_map_conv
thf(fact_91_map__is__Nil__conv,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% map_is_Nil_conv
thf(fact_92_list_Omap__disc__iff,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),A4: ( list @ A )] :
      ( ( ( map @ A @ B @ F2 @ A4 )
        = ( nil @ B ) )
      = ( A4
        = ( nil @ A ) ) ) )).

% list.map_disc_iff
thf(fact_93_splice__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% splice_Nil2
thf(fact_94_map__eq__Cons__conv,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ? [Z: B,Zs2: ( list @ B )] :
            ( ( Xs
              = ( cons @ B @ Z @ Zs2 ) )
            & ( ( F2 @ Z )
              = Y )
            & ( ( map @ B @ A @ F2 @ Zs2 )
              = Ys ) ) ) ) )).

% map_eq_Cons_conv
thf(fact_95_Cons__eq__map__conv,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),F2: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
      = ( ? [Z: B,Zs2: ( list @ B )] :
            ( ( Ys
              = ( cons @ B @ Z @ Zs2 ) )
            & ( X
              = ( F2 @ Z ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ) )).

% Cons_eq_map_conv
thf(fact_96_map__eq__Cons__D,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z2: B,Zs3: ( list @ B )] :
          ( ( Xs
            = ( cons @ B @ Z2 @ Zs3 ) )
          & ( ( F2 @ Z2 )
            = Y )
          & ( ( map @ B @ A @ F2 @ Zs3 )
            = Ys ) ) ) )).

% map_eq_Cons_D
thf(fact_97_Cons__eq__map__D,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),F2: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ? [Z2: B,Zs3: ( list @ B )] :
          ( ( Ys
            = ( cons @ B @ Z2 @ Zs3 ) )
          & ( X
            = ( F2 @ Z2 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) )).

% Cons_eq_map_D
thf(fact_98_map__eq__consE,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),Ls2: ( list @ B ),Fa: A,Fl: ( list @ A )] :
      ( ( ( map @ B @ A @ F2 @ Ls2 )
        = ( cons @ A @ Fa @ Fl ) )
     => ~ ( ! [A3: B,L: ( list @ B )] :
              ( ( Ls2
                = ( cons @ B @ A3 @ L ) )
             => ( ( ( F2 @ A3 )
                  = Fa )
               => ( ( map @ B @ A @ F2 @ L )
                 != Fl ) ) ) ) ) )).

% map_eq_consE
thf(fact_99_list_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),X21: A,X22: ( list @ A )] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X22 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X22 ) ) ) )).

% list.simps(9)
thf(fact_100_map__consI_I1_J,axiom,(
    ! [A: $tType,B: $tType,W: ( list @ A ),F2: ( B > A ),Ww: ( list @ B ),A4: B] :
      ( ( W
        = ( map @ B @ A @ F2 @ Ww ) )
     => ( ( cons @ A @ ( F2 @ A4 ) @ W )
        = ( map @ B @ A @ F2 @ ( cons @ B @ A4 @ Ww ) ) ) ) )).

% map_consI(1)
thf(fact_101_list_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B )] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) )).

% list.simps(8)
thf(fact_102_splice_Osimps_I3_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( cons @ A @ X @ ( cons @ A @ Y @ ( splice @ A @ Xs @ Ys ) ) ) ) )).

% splice.simps(3)
thf(fact_103_splice_Osimps_I1_J,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% splice.simps(1)
thf(fact_104_map__tailrec__rev_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),A4: A,As2: ( list @ A ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( cons @ A @ A4 @ As2 ) @ Bs2 )
      = ( map_tailrec_rev @ A @ B @ F2 @ As2 @ ( cons @ B @ ( F2 @ A4 ) @ Bs2 ) ) ) )).

% map_tailrec_rev.simps(2)
thf(fact_105_map__tailrec__rev_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( nil @ A ) @ Bs2 )
      = Bs2 ) )).

% map_tailrec_rev.simps(1)
thf(fact_106_merge__list_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( nil @ ( list @ A ) ) )
        = ( nil @ A ) ) ) )).

% merge_list.simps(1)
thf(fact_107_merge__list_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L3: ( list @ A )] :
          ( ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L3 @ ( nil @ ( list @ A ) ) ) )
          = L3 ) ) )).

% merge_list.simps(2)
thf(fact_108_merge__list_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [La2: ( list @ A ),Acc22: ( list @ ( list @ A ) )] :
          ( ( merge_list @ A @ ( cons @ ( list @ A ) @ La2 @ Acc22 ) @ ( nil @ ( list @ A ) ) )
          = ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ La2 @ Acc22 ) ) ) ) )).

% merge_list.simps(3)
thf(fact_109_merge__list_Osimps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [La2: ( list @ A ),Acc22: ( list @ ( list @ A ) ),L3: ( list @ A )] :
          ( ( merge_list @ A @ ( cons @ ( list @ A ) @ La2 @ Acc22 ) @ ( cons @ ( list @ A ) @ L3 @ ( nil @ ( list @ A ) ) ) )
          = ( merge_list @ A @ ( nil @ ( list @ A ) ) @ ( cons @ ( list @ A ) @ L3 @ ( cons @ ( list @ A ) @ La2 @ Acc22 ) ) ) ) ) )).

% merge_list.simps(4)
thf(fact_110_merge__list_Osimps_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Acc22: ( list @ ( list @ A ) ),L1: ( list @ A ),L2: ( list @ A ),Ls2: ( list @ ( list @ A ) )] :
          ( ( merge_list @ A @ Acc22 @ ( cons @ ( list @ A ) @ L1 @ ( cons @ ( list @ A ) @ L2 @ Ls2 ) ) )
          = ( merge_list @ A @ ( cons @ ( list @ A ) @ ( merge @ A @ L1 @ L2 ) @ Acc22 ) @ Ls2 ) ) ) )).

% merge_list.simps(5)
thf(fact_111_splice_Oelims,axiom,(
    ! [A: $tType,X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ( ! [V: A,Va: ( list @ A )] :
              ( ( X
                = ( cons @ A @ V @ Va ) )
             => ( ( Xa
                  = ( nil @ A ) )
               => ( Y
                 != ( cons @ A @ V @ Va ) ) ) )
         => ~ ( ! [X3: A,Xs2: ( list @ A )] :
                  ( ( X
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y2: A,Ys2: ( list @ A )] :
                      ( ( Xa
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( Y
                       != ( cons @ A @ X3 @ ( cons @ A @ Y2 @ ( splice @ A @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) ) )).

% splice.elims
thf(fact_112_map__eq__map__tailrec,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) )).

% map_eq_map_tailrec
thf(fact_113_list__collect__set__map__simps_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( B > ( set @ A ) ),X: ( C > B )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ ( nil @ C ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% list_collect_set_map_simps(1)
thf(fact_114_list__collect__set__map__simps_I3_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( B > ( set @ A ) ),X: ( C > B ),A4: C,L3: ( list @ C )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ ( cons @ C @ A4 @ L3 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( F2 @ ( X @ A4 ) ) @ ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ L3 ) ) ) ) )).

% list_collect_set_map_simps(3)
thf(fact_115_listrelp_Oinducts,axiom,(
    ! [A: $tType,B: $tType,R4: ( A > B > $o ),X1: ( list @ A ),X2: ( list @ B ),P: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( listrelp @ A @ B @ R4 @ X1 @ X2 )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Y2: B,Xs2: ( list @ A ),Ys2: ( list @ B )] :
              ( ( R4 @ X3 @ Y2 )
             => ( ( listrelp @ A @ B @ R4 @ Xs2 @ Ys2 )
               => ( ( P @ Xs2 @ Ys2 )
                 => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) ) ) )
         => ( P @ X1 @ X2 ) ) ) ) )).

% listrelp.inducts
thf(fact_116_listrelp_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R5: ( A > B > $o ),A12: ( list @ A ),A22: ( list @ B )] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A22
                = ( nil @ B ) ) )
            | ? [X4: A,Y3: B,Xs3: ( list @ A ),Ys3: ( list @ B )] :
                ( ( A12
                  = ( cons @ A @ X4 @ Xs3 ) )
                & ( A22
                  = ( cons @ B @ Y3 @ Ys3 ) )
                & ( R5 @ X4 @ Y3 )
                & ( listrelp @ A @ B @ R5 @ Xs3 @ Ys3 ) ) ) ) ) )).

% listrelp.simps
thf(fact_117_listrelp_Ocases,axiom,(
    ! [A: $tType,B: $tType,R4: ( A > B > $o ),A1: ( list @ A ),A2: ( list @ B )] :
      ( ( listrelp @ A @ B @ R4 @ A1 @ A2 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A2
           != ( nil @ B ) ) )
       => ~ ( ! [X3: A,Y2: B,Xs2: ( list @ A )] :
                ( ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ! [Ys2: ( list @ B )] :
                    ( ( A2
                      = ( cons @ B @ Y2 @ Ys2 ) )
                   => ( ( R4 @ X3 @ Y2 )
                     => ~ ( listrelp @ A @ B @ R4 @ Xs2 @ Ys2 ) ) ) ) ) ) ) )).

% listrelp.cases
thf(fact_118_list__collect__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > ( set @ A ) )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( nil @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% list_collect_set_simps(1)
thf(fact_119_list__collect__set__simps_I3_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > ( set @ A ) ),A4: B,L3: ( list @ B )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( cons @ B @ A4 @ L3 ) )
      = ( sup_sup @ ( set @ A ) @ ( F2 @ A4 ) @ ( list_collect_set @ B @ A @ F2 @ L3 ) ) ) )).

% list_collect_set_simps(3)
thf(fact_120_set__notEmptyE,axiom,(
    ! [A: $tType,S: ( set @ A )] :
      ( ( S
       != ( bot_bot @ ( set @ A ) ) )
     => ~ ( ! [X3: A] :
              ~ ( member @ A @ X3 @ S ) ) ) )).

% set_notEmptyE
thf(fact_121_memb__imp__not__empty,axiom,(
    ! [A: $tType,X: A,S: ( set @ A )] :
      ( ( member @ A @ X @ S )
     => ( S
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% memb_imp_not_empty
thf(fact_122_listrelp_OCons,axiom,(
    ! [A: $tType,B: $tType,R4: ( A > B > $o ),X: A,Y: B,Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( R4 @ X @ Y )
     => ( ( listrelp @ A @ B @ R4 @ Xs @ Ys )
       => ( listrelp @ A @ B @ R4 @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) ) ) )).

% listrelp.Cons
thf(fact_123_listrelp_ONil,axiom,(
    ! [A: $tType,B: $tType,R4: ( A > B > $o )] :
      ( listrelp @ A @ B @ R4 @ ( nil @ A ) @ ( nil @ B ) ) )).

% listrelp.Nil
thf(fact_124_Un__empty,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A5 @ B4 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A5
          = ( bot_bot @ ( set @ A ) ) )
        & ( B4
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_125_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( sup_sup @ A @ A4 @ ( bot_bot @ A ) )
          = A4 ) ) )).

% sup_bot.right_neutral
thf(fact_126_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A4 )
          = A4 ) ) )).

% sup_bot.left_neutral
thf(fact_127_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_128_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_129_all__not__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ! [X4: A] :
            ~ ( member @ A @ X4 @ A5 ) )
      = ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_130_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% Collect_empty_eq
thf(fact_131_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X4: A] :
            ~ ( P @ X4 ) ) ) )).

% empty_Collect_eq
thf(fact_132_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B ),X4: A] :
              ( sup_sup @ B @ ( F3 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) )).

% sup_apply
thf(fact_133_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( sup_sup @ A @ A4 @ A4 )
          = A4 ) ) )).

% sup.idem
thf(fact_134_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) )).

% sup_idem
thf(fact_135_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A] :
          ( ( sup_sup @ A @ A4 @ ( sup_sup @ A @ A4 @ B3 ) )
          = ( sup_sup @ A @ A4 @ B3 ) ) ) )).

% sup.left_idem
thf(fact_136_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% sup_left_idem
thf(fact_137_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A4 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A4 @ B3 ) ) ) )).

% sup.right_idem
thf(fact_138_UnCI,axiom,(
    ! [A: $tType,C2: A,B4: ( set @ A ),A5: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B4 )
       => ( member @ A @ C2 @ A5 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) ) ) )).

% UnCI
thf(fact_139_Un__iff,axiom,(
    ! [A: $tType,C2: A,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
      = ( ( member @ A @ C2 @ A5 )
        | ( member @ A @ C2 @ B4 ) ) ) )).

% Un_iff
thf(fact_140_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_141_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_142_emptyE,axiom,(
    ! [A: $tType,A4: A] :
      ~ ( member @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_143_equals0D,axiom,(
    ! [A: $tType,A5: ( set @ A ),A4: A] :
      ( ( A5
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A4 @ A5 ) ) )).

% equals0D
thf(fact_144_equals0I,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ! [Y2: A] :
          ~ ( member @ A @ Y2 @ A5 )
     => ( A5
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_145_ex__in__conv,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( ? [X4: A] :
            ( member @ A @ X4 @ A5 ) )
      = ( A5
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_146_not__psubset__empty,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_147_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_148_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z3 ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_149_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z3 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_150_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X4: A,Y3: A] :
              ( sup_sup @ A @ Y3 @ X4 ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_151_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B ),X4: A] :
              ( sup_sup @ B @ ( F3 @ X4 ) @ ( G2 @ X4 ) ) ) ) ) )).

% sup_fun_def
thf(fact_152_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A4 @ B3 ) @ C2 )
          = ( sup_sup @ A @ A4 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.assoc
thf(fact_153_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z3 )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% sup_assoc
thf(fact_154_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A6: A,B5: A] :
              ( sup_sup @ A @ B5 @ A6 ) ) ) ) )).

% sup.commute
thf(fact_155_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X4: A,Y3: A] :
              ( sup_sup @ A @ Y3 @ X4 ) ) ) ) )).

% sup_commute
thf(fact_156_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A4: A,C2: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A4 @ C2 ) )
          = ( sup_sup @ A @ A4 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.left_commute
thf(fact_157_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z3 ) ) ) ) )).

% sup_left_commute
thf(fact_158_UnE,axiom,(
    ! [A: $tType,C2: A,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
     => ( ~ ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% UnE
thf(fact_159_UnI1,axiom,(
    ! [A: $tType,C2: A,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ C2 @ A5 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) ) ) )).

% UnI1
thf(fact_160_UnI2,axiom,(
    ! [A: $tType,C2: A,B4: ( set @ A ),A5: ( set @ A )] :
      ( ( member @ A @ C2 @ B4 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) ) ) )).

% UnI2
thf(fact_161_bex__Un,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X4: A] :
            ( ( member @ A @ X4 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
            & ( P @ X4 ) ) )
      = ( ? [X4: A] :
            ( ( member @ A @ X4 @ A5 )
            & ( P @ X4 ) )
        | ? [X4: A] :
            ( ( member @ A @ X4 @ B4 )
            & ( P @ X4 ) ) ) ) )).

% bex_Un
thf(fact_162_ball__Un,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X4: A] :
            ( ( member @ A @ X4 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
           => ( P @ X4 ) ) )
      = ( ! [X4: A] :
            ( ( member @ A @ X4 @ A5 )
           => ( P @ X4 ) )
        & ! [X4: A] :
            ( ( member @ A @ X4 @ B4 )
           => ( P @ X4 ) ) ) ) )).

% ball_Un
thf(fact_163_Un__assoc,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B4 @ C3 ) ) ) )).

% Un_assoc
thf(fact_164_Un__absorb,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A5 @ A5 )
      = A5 ) )).

% Un_absorb
thf(fact_165_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B6: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B6 @ A7 ) ) ) )).

% Un_commute
thf(fact_166_Un__left__absorb,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ A5 @ B4 ) )
      = ( sup_sup @ ( set @ A ) @ A5 @ B4 ) ) )).

% Un_left_absorb
thf(fact_167_Un__left__commute,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A5 @ ( sup_sup @ ( set @ A ) @ B4 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B4 @ ( sup_sup @ ( set @ A ) @ A5 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_168_sup_Ostrict__coboundedI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,B3: A,A4: A] :
          ( ( ord_less @ A @ C2 @ B3 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) )).

% sup.strict_coboundedI2
thf(fact_169_sup_Ostrict__coboundedI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [C2: A,A4: A,B3: A] :
          ( ( ord_less @ A @ C2 @ A4 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) )).

% sup.strict_coboundedI1
thf(fact_170_sup_Ostrict__order__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B5: A,A6: A] :
              ( ( A6
                = ( sup_sup @ A @ A6 @ B5 ) )
              & ( A6 != B5 ) ) ) ) ) )).

% sup.strict_order_iff
thf(fact_171_sup_Ostrict__boundedE,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,C2: A,A4: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B3 @ C2 ) @ A4 )
         => ~ ( ( ord_less @ A @ B3 @ A4 )
             => ~ ( ord_less @ A @ C2 @ A4 ) ) ) ) )).

% sup.strict_boundedE
thf(fact_172_less__supI2,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,B3: A,A4: A] :
          ( ( ord_less @ A @ X @ B3 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) )).

% less_supI2
thf(fact_173_less__supI1,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X: A,A4: A,B3: A] :
          ( ( ord_less @ A @ X @ A4 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A4 @ B3 ) ) ) ) )).

% less_supI1
thf(fact_174_sup__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) )).

% sup_bot_left
thf(fact_175_sup__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) )).

% sup_bot_right
thf(fact_176_Un__empty__left,axiom,(
    ! [A: $tType,B4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B4 )
      = B4 ) )).

% Un_empty_left
thf(fact_177_Un__empty__right,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A5 @ ( bot_bot @ ( set @ A ) ) )
      = A5 ) )).

% Un_empty_right
thf(fact_178_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X4: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_179_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ( ( A4
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A4 ) ) ) )).

% bot.not_eq_extremum
thf(fact_180_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ~ ( ord_less @ A @ A4 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_181_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_182_psubset__trans,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B4 )
     => ( ( ord_less @ ( set @ A ) @ B4 @ C3 )
       => ( ord_less @ ( set @ A ) @ A5 @ C3 ) ) ) )).

% psubset_trans
thf(fact_183_psubsetD,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less @ ( set @ A ) @ A5 @ B4 )
     => ( ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% psubsetD
thf(fact_184_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( A4 != B3 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_185_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( A4 != B3 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_186_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_187_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A4: A,C2: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ( ( ord_less @ A @ C2 @ B3 )
           => ( ord_less @ A @ C2 @ A4 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_188_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_imp_not_less
thf(fact_189_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) )).

% order.strict_trans
thf(fact_190_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A] :
          ~ ( ord_less @ A @ A4 @ A4 ) ) )).

% dual_order.irrefl
thf(fact_191_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% linorder_cases
thf(fact_192_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P ) ) ) )).

% less_imp_triv
thf(fact_193_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) )).

% less_imp_not_eq2
thf(fact_194_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) )).

% antisym_conv3
thf(fact_195_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),A4: A] :
          ( ! [X3: A] :
              ( ! [Y4: A] :
                  ( ( ord_less @ A @ Y4 @ X3 )
                 => ( P @ Y4 ) )
             => ( P @ X3 ) )
         => ( P @ A4 ) ) ) )).

% less_induct
thf(fact_196_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_not_sym
thf(fact_197_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) )).

% less_imp_not_eq
thf(fact_198_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A4: A] :
          ( ( ord_less @ A @ B3 @ A4 )
         => ~ ( ord_less @ A @ A4 @ B3 ) ) ) )).

% dual_order.asym
thf(fact_199_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A,C2: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( B3 = C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) )).

% ord_less_eq_trans
thf(fact_200_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A,C2: A] :
          ( ( A4 = B3 )
         => ( ( ord_less @ A @ B3 @ C2 )
           => ( ord_less @ A @ A4 @ C2 ) ) ) ) )).

% ord_eq_less_trans
thf(fact_201_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) )).

% less_irrefl
thf(fact_202_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) )).

% less_linear
thf(fact_203_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z3: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z3 )
           => ( ord_less @ A @ X @ Z3 ) ) ) ) )).

% less_trans
thf(fact_204_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A4 ) ) ) )).

% less_asym'
thf(fact_205_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) )).

% less_asym
thf(fact_206_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) )).

% less_imp_neq
thf(fact_207_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z2: A] :
              ( ( ord_less @ A @ X @ Z2 )
              & ( ord_less @ A @ Z2 @ Y ) ) ) ) )).

% dense
thf(fact_208_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A4: A,B3: A] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A4 ) ) ) )).

% order.asym
thf(fact_209_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) )).

% neq_iff
thf(fact_210_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% neqE
thf(fact_211_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X12: A] :
          ( ord_less @ A @ X @ X12 ) ) )).

% gt_ex
thf(fact_212_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y2: A] :
          ( ord_less @ A @ Y2 @ X ) ) )).

% lt_ex
thf(fact_213_order__less__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B3: A,F2: ( A > C ),C2: C] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ord_less @ C @ ( F2 @ B3 ) @ C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less @ A @ X3 @ Y2 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ C @ ( F2 @ A4 ) @ C2 ) ) ) ) ) )).

% order_less_subst2
thf(fact_214_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F2: ( B > A ),B3: B,C2: B] :
          ( ( ord_less @ A @ A4 @ ( F2 @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less @ B @ X3 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_215_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,B3: A,F2: ( A > B ),C2: B] :
          ( ( ord_less @ A @ A4 @ B3 )
         => ( ( ( F2 @ B3 )
              = C2 )
           => ( ! [X3: A,Y2: A] :
                  ( ( ord_less @ A @ X3 @ Y2 )
                 => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ B @ ( F2 @ A4 ) @ C2 ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_216_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A4: A,F2: ( B > A ),B3: B,C2: B] :
          ( ( A4
            = ( F2 @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C2 )
           => ( ! [X3: B,Y2: B] :
                  ( ( ord_less @ B @ X3 @ Y2 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y2 ) ) )
             => ( ord_less @ A @ A4 @ ( F2 @ C2 ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_217_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X4: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_218_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X4: A] :
            ( member @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_219_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_220_map__tailrec__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map_tailrec @ A @ B )
      = ( ^ [F3: ( A > B ),As3: ( list @ A )] :
            ( rev @ B @ ( map_tailrec_rev @ A @ B @ F3 @ As3 @ ( nil @ B ) ) ) ) ) )).

% map_tailrec_def
thf(fact_221_rev__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) )).

% rev_is_rev_conv
thf(fact_222_rev__rev__ident,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) )).

% rev_rev_ident
thf(fact_223_rev__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rev_is_Nil_conv
thf(fact_224_Nil__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% Nil_is_rev_conv
thf(fact_225_singleton__rev__conv,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% singleton_rev_conv
thf(fact_226_rev__singleton__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% rev_singleton_conv
thf(fact_227_rev_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rev.simps(1)
thf(fact_228_rev__map,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) )).

% rev_map
thf(fact_229_rev__swap,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) )).

% rev_swap
thf(fact_230_list__collect__set__map__simps_I4_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( B > ( set @ A ) ),X: ( C > B ),L3: ( list @ C ),L4: ( list @ C )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ ( append @ C @ L3 @ L4 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ L3 ) ) @ ( list_collect_set @ B @ A @ F2 @ ( map @ C @ B @ X @ L4 ) ) ) ) )).

% list_collect_set_map_simps(4)
thf(fact_231_sorted__list__of__set__empty,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( linord467138063of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) )).

% sorted_list_of_set_empty
thf(fact_232_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_233_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_234_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_235_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_236_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_237_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_238_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_239_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_240_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_241_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_242_map__append,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B ),Ys: ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys ) ) ) )).

% map_append
thf(fact_243_rev__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) )).

% rev_append
thf(fact_244_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X = Y ) ) ) )).

% append1_eq_conv
thf(fact_245_list__ee__eq__leel_I1_J,axiom,(
    ! [A: $tType,E1: A,E2: A,L1: ( list @ A ),E12: A,E22: A,L2: ( list @ A )] :
      ( ( ( cons @ A @ E1 @ ( cons @ A @ E2 @ ( nil @ A ) ) )
        = ( append @ A @ L1 @ ( cons @ A @ E12 @ ( cons @ A @ E22 @ L2 ) ) ) )
      = ( ( L1
          = ( nil @ A ) )
        & ( E1 = E12 )
        & ( E2 = E22 )
        & ( L2
          = ( nil @ A ) ) ) ) )).

% list_ee_eq_leel(1)
thf(fact_246_list__ee__eq__leel_I2_J,axiom,(
    ! [A: $tType,L1: ( list @ A ),E12: A,E22: A,L2: ( list @ A ),E1: A,E2: A] :
      ( ( ( append @ A @ L1 @ ( cons @ A @ E12 @ ( cons @ A @ E22 @ L2 ) ) )
        = ( cons @ A @ E1 @ ( cons @ A @ E2 @ ( nil @ A ) ) ) )
      = ( ( L1
          = ( nil @ A ) )
        & ( E1 = E12 )
        & ( E2 = E22 )
        & ( L2
          = ( nil @ A ) ) ) ) )).

% list_ee_eq_leel(2)
thf(fact_247_list__se__match_I1_J,axiom,(
    ! [A: $tType,L1: ( list @ A ),L2: ( list @ A ),A4: A] :
      ( ( L1
       != ( nil @ A ) )
     => ( ( ( append @ A @ L1 @ L2 )
          = ( cons @ A @ A4 @ ( nil @ A ) ) )
        = ( ( L1
            = ( cons @ A @ A4 @ ( nil @ A ) ) )
          & ( L2
            = ( nil @ A ) ) ) ) ) )).

% list_se_match(1)
thf(fact_248_list__se__match_I2_J,axiom,(
    ! [A: $tType,L2: ( list @ A ),L1: ( list @ A ),A4: A] :
      ( ( L2
       != ( nil @ A ) )
     => ( ( ( append @ A @ L1 @ L2 )
          = ( cons @ A @ A4 @ ( nil @ A ) ) )
        = ( ( L1
            = ( nil @ A ) )
          & ( L2
            = ( cons @ A @ A4 @ ( nil @ A ) ) ) ) ) ) )).

% list_se_match(2)
thf(fact_249_list__se__match_I3_J,axiom,(
    ! [A: $tType,L1: ( list @ A ),A4: A,L2: ( list @ A )] :
      ( ( L1
       != ( nil @ A ) )
     => ( ( ( cons @ A @ A4 @ ( nil @ A ) )
          = ( append @ A @ L1 @ L2 ) )
        = ( ( L1
            = ( cons @ A @ A4 @ ( nil @ A ) ) )
          & ( L2
            = ( nil @ A ) ) ) ) ) )).

% list_se_match(3)
thf(fact_250_list__se__match_I4_J,axiom,(
    ! [A: $tType,L2: ( list @ A ),A4: A,L1: ( list @ A )] :
      ( ( L2
       != ( nil @ A ) )
     => ( ( ( cons @ A @ A4 @ ( nil @ A ) )
          = ( append @ A @ L1 @ L2 ) )
        = ( ( L1
            = ( nil @ A ) )
          & ( L2
            = ( cons @ A @ A4 @ ( nil @ A ) ) ) ) ) ) )).

% list_se_match(4)
thf(fact_251_list__e__eq__lel_I1_J,axiom,(
    ! [A: $tType,E3: A,L1: ( list @ A ),E4: A,L2: ( list @ A )] :
      ( ( ( cons @ A @ E3 @ ( nil @ A ) )
        = ( append @ A @ L1 @ ( cons @ A @ E4 @ L2 ) ) )
      = ( ( L1
          = ( nil @ A ) )
        & ( E4 = E3 )
        & ( L2
          = ( nil @ A ) ) ) ) )).

% list_e_eq_lel(1)
thf(fact_252_list__e__eq__lel_I2_J,axiom,(
    ! [A: $tType,L1: ( list @ A ),E4: A,L2: ( list @ A ),E3: A] :
      ( ( ( append @ A @ L1 @ ( cons @ A @ E4 @ L2 ) )
        = ( cons @ A @ E3 @ ( nil @ A ) ) )
      = ( ( L1
          = ( nil @ A ) )
        & ( E4 = E3 )
        & ( L2
          = ( nil @ A ) ) ) ) )).

% list_e_eq_lel(2)
thf(fact_253_list__collect__set__simps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > ( set @ A ) ),L3: ( list @ B ),L4: ( list @ B )] :
      ( ( list_collect_set @ B @ A @ F2 @ ( append @ B @ L3 @ L4 ) )
      = ( sup_sup @ ( set @ A ) @ ( list_collect_set @ B @ A @ F2 @ L3 ) @ ( list_collect_set @ B @ A @ F2 @ L4 ) ) ) )).

% list_collect_set_simps(4)
thf(fact_254_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X: B,Xs: ( list @ B ),F2: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) )).

% bind_simps(2)

%----Subclasses (4)
thf(subcl_Orderings_Olinorder___HOL_Otype,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( type @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oord,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ord @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( order @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Opreorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( preorder @ A @ ( type2 @ A ) ) ) )).

%----Type constructors (31)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounde1808546759up_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bounded_lattice @ A9 @ ( type2 @ A9 ) )
     => ( bounded_lattice_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( semilattice_sup @ A9 @ ( type2 @ A9 ) )
     => ( semilattice_sup @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order_bot @ A9 @ ( type2 @ A9 ) )
     => ( order_bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( preorder @ A9 @ ( type2 @ A9 ) )
     => ( preorder @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( lattice @ A9 @ ( type2 @ A9 ) )
     => ( lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( order @ A9 @ ( type2 @ A9 ) )
     => ( order @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_3,axiom,(
    ! [A8: $tType] :
      ( bounde1808546759up_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_4,axiom,(
    ! [A8: $tType] :
      ( bounded_lattice_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_5,axiom,(
    ! [A8: $tType] :
      ( semilattice_sup @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_6,axiom,(
    ! [A8: $tType] :
      ( order_bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_7,axiom,(
    ! [A8: $tType] :
      ( preorder @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_8,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_9,axiom,(
    ! [A8: $tType] :
      ( order @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_10,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_11,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_12,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_13,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_14,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_15,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_16,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_17,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_18,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_19,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_20,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type2 @ a ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( ( cons @ a @ x1 @ l1 )
      = l2a )
    = ( ( sorted1061247458sorted @ a @ ( cons @ a @ x1 @ l1 ) @ l2a )
      & ( sorted1061247458sorted @ a @ l2a @ ( cons @ a @ x1 @ l1 ) ) ) )).

%------------------------------------------------------------------------------
