%------------------------------------------------------------------------------
% File     : DAT209^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Splay tree analysis 17
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Nip14] Nipkow (2014), Amortized Complexity Verified
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : splay_tree_analysis__17.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  434 (   0 unit;  87 type;   0 defn)
%            Number of atoms       : 4496 ( 429 equality;2210 variable)
%            Maximal formula depth :   16 (   7 average)
%            Number of connectives : 3395 (  29   ~;  20   |;  20   &;3066   @)
%                                         (   0 <=>; 260  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  126 ( 126   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   91 (  87   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  784 (   0 sgn; 678   !;   0   ?;  24   ^)
%                                         ( 784   :;  82  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:48:22.648
%------------------------------------------------------------------------------
%----Could-be-implicit typings (5)
thf(ty_t_Tree_Otree,type,(
    tree: $tType > $tType )).

thf(ty_t_Real_Oreal,type,(
    real: $tType )).

thf(ty_t_Int_Oint,type,(
    int: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (82)
thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oidom,type,(
    idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring,type,(
    ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring__1,type,(
    ring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osgn__if,type,(
    sgn_if: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring,type,(
    semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Oring__char__0,type,(
    ring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Omult__zero,type,(
    mult_zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__ring__1,type,(
    comm_ring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Transcendental_Oln,type,(
    ln: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__mult,type,(
    monoid_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__neq__one,type,(
    zero_neq_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__group__add,type,(
    ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring,type,(
    comm_semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__mult,type,(
    semigroup_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring__1,type,(
    comm_semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__ring,type,(
    linordered_ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__add,type,(
    comm_monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,(
    comm_monoid_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__mult,type,(
    ab_semigroup_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__ring__strict,type,(
    linord581940658strict: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,(
    ring_11004092258visors: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,(
    linord219039673up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,(
    real_V1076094709vector: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,(
    archim1727834104eiling: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,(
    ordere142940540dd_abs: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,(
    real_V148923926lgebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,(
    semiri1193490041visors: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,(
    real_V84468443ebra_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,(
    real_V55928688vector: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,(
    semiri1923998003cancel: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,(
    real_V1229719638ebra_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,(
    real_V68988228lgebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,(
    semiri456707255roduct: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Archimedean__Field_Oceiling,type,(
    archimedean_ceiling: 
      !>[A: $tType] :
        ( A > int ) )).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,(
    archim2085082626_floor: 
      !>[A: $tType] :
        ( A > int ) )).

thf(sy_c_Archimedean__Field_Oround,type,(
    archimedean_round: 
      !>[A: $tType] :
        ( A > int ) )).

thf(sy_c_Groups_Oabs__class_Oabs,type,(
    abs_abs: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Osgn__class_Osgn,type,(
    sgn_sgn: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Groups_Otimes__class_Otimes,type,(
    times_times: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,(
    neg_numeral_dbl: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,(
    neg_numeral_dbl_dec: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,(
    neg_numeral_dbl_inc: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Real__Vector__Spaces_Olinear__axioms,type,(
    real_V2128096322axioms: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > $o ) )).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,(
    real_V1127708846m_norm: 
      !>[A: $tType] :
        ( A > real ) )).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,(
    real_Vector_of_real: 
      !>[A: $tType] :
        ( real > A ) )).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,(
    real_V1908273582scaleR: 
      !>[A: $tType] :
        ( real > A > A ) )).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,(
    zero_neq_one_of_bool: 
      !>[A: $tType] :
        ( $o > A ) )).

thf(sy_c_Splay__Tree__Analysis__Mirabelle__pcaxyvimtd_OA,type,(
    splay_266122055elle_A: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > real ) )).

thf(sy_c_Transcendental_Oln__class_Oln,type,(
    ln_ln: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Transcendental_Opowr,type,(
    powr: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Tree_Otree_ONode,type,(
    node: 
      !>[A: $tType] :
        ( ( tree @ A ) > A > ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Tree_Otree_Ocase__tree,type,(
    case_tree: 
      !>[B: $tType,A: $tType] :
        ( B > ( ( tree @ A ) > A > ( tree @ A ) > B ) > ( tree @ A ) > B ) )).

thf(sy_c_Tree_Otree_Opred__tree,type,(
    pred_tree: 
      !>[A: $tType] :
        ( ( A > $o ) > ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Otree_Orec__tree,type,(
    rec_tree: 
      !>[C: $tType,A: $tType] :
        ( C > ( ( tree @ A ) > A > ( tree @ A ) > C > C > C ) > ( tree @ A ) > C ) )).

thf(sy_c_Tree_Otree_Oval,type,(
    val: 
      !>[A: $tType] :
        ( ( tree @ A ) > A ) )).

thf(sy_v_a,type,(
    a2: a )).

thf(sy_v_l,type,(
    l: ( tree @ a ) )).

thf(sy_v_r,type,(
    r: ( tree @ a ) )).

%----Relevant facts (254)
thf(fact_0_tree_Oinject,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A ),Y21: ( tree @ A ),Y22: A,Y23: ( tree @ A )] :
      ( ( ( node @ A @ X21 @ X22 @ X23 )
        = ( node @ A @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% tree.inject
thf(fact_1_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_2_powr__one__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) )).

% powr_one_eq_one
thf(fact_3_norm__one,axiom,(
    ! [A: $tType] :
      ( ( real_V1229719638ebra_1 @ A @ ( type2 @ A ) )
     => ( ( real_V1127708846m_norm @ A @ ( one_one @ A ) )
        = ( one_one @ real ) ) ) )).

% norm_one
thf(fact_4_of__real__1,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ( ( real_Vector_of_real @ A @ ( one_one @ real ) )
        = ( one_one @ A ) ) ) )).

% of_real_1
thf(fact_5_of__bool__eq_I2_J,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) )).

% of_bool_eq(2)
thf(fact_6_dbl__dec__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) )).

% dbl_dec_simps(3)
thf(fact_7_tree_Osimps_I7_J,axiom,(
    ! [C: $tType,A: $tType,F1: C,F2: ( ( tree @ A ) > A > ( tree @ A ) > C > C > C ),X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( rec_tree @ C @ A @ F1 @ F2 @ ( node @ A @ X21 @ X22 @ X23 ) )
      = ( F2 @ X21 @ X22 @ X23 @ ( rec_tree @ C @ A @ F1 @ F2 @ X21 ) @ ( rec_tree @ C @ A @ F1 @ F2 @ X23 ) ) ) )).

% tree.simps(7)
thf(fact_8_tree_Opred__inject_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: ( tree @ A ),Aa: A,Ab: ( tree @ A )] :
      ( ( pred_tree @ A @ P @ ( node @ A @ A2 @ Aa @ Ab ) )
      = ( ( pred_tree @ A @ P @ A2 )
        & ( P @ Aa )
        & ( pred_tree @ A @ P @ Ab ) ) ) )).

% tree.pred_inject(2)
thf(fact_9_round__1,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) )).

% round_1
thf(fact_10_tree_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F2: ( ( tree @ A ) > A > ( tree @ A ) > B ),X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( case_tree @ B @ A @ F1 @ F2 @ ( node @ A @ X21 @ X22 @ X23 ) )
      = ( F2 @ X21 @ X22 @ X23 ) ) )).

% tree.simps(5)
thf(fact_11_of__real__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ! [X: real,Y: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( real_Vector_of_real @ A @ Y ) )
          = ( X = Y ) ) ) )).

% of_real_eq_iff
thf(fact_12_of__bool__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ! [P2: $o,Q: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P2 )
            = ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P2 = Q ) ) ) )).

% of_bool_eq_iff
thf(fact_13_one__integer_Orsp,axiom,
    ( ( one_one @ int )
    = ( one_one @ int ) )).

% one_integer.rsp
thf(fact_14_powr__zero__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) )).

% powr_zero_eq_one
thf(fact_15_of__bool__def,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P3: $o] :
              ( if @ A @ P3 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) )).

% of_bool_def
thf(fact_16_split__of__bool,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ( P2
             => ( P @ ( one_one @ A ) ) )
            & ( ~ ( P2 )
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) )).

% split_of_bool
thf(fact_17_split__of__bool__asm,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),P2: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P2 ) )
          = ( ~ ( ( P2
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ ( P2 )
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) )).

% split_of_bool_asm
thf(fact_18_norm__of__real,axiom,(
    ! [A: $tType] :
      ( ( real_V1229719638ebra_1 @ A @ ( type2 @ A ) )
     => ! [R: real] :
          ( ( real_V1127708846m_norm @ A @ ( real_Vector_of_real @ A @ R ) )
          = ( abs_abs @ real @ R ) ) ) )).

% norm_of_real
thf(fact_19_ceiling__one,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) )).

% ceiling_one
thf(fact_20_floor__one,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archim2085082626_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) )).

% floor_one
thf(fact_21_of__bool__eq_I1_J,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) )).

% of_bool_eq(1)
thf(fact_22_of__real__def,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ( ( real_Vector_of_real @ A )
        = ( ^ [R2: real] :
              ( real_V1908273582scaleR @ A @ R2 @ ( one_one @ A ) ) ) ) ) )).

% of_real_def
thf(fact_23_tree_Osel_I3_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( val @ A @ ( node @ A @ X21 @ X22 @ X23 ) )
      = X22 ) )).

% tree.sel(3)
thf(fact_24_abs__idempotent,axiom,(
    ! [A: $tType] :
      ( ( ordere142940540dd_abs @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) )).

% abs_idempotent
thf(fact_25_real__vector_Oscale__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A,Y: A] :
          ( ( ( real_V1908273582scaleR @ A @ A2 @ X )
            = ( real_V1908273582scaleR @ A @ A2 @ Y ) )
          = ( ( X = Y )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) )).

% real_vector.scale_cancel_left
thf(fact_26_abs__0__eq,axiom,(
    ! [A: $tType] :
      ( ( ordere142940540dd_abs @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% abs_0_eq
thf(fact_27_abs__eq__0,axiom,(
    ! [A: $tType] :
      ( ( ordere142940540dd_abs @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% abs_eq_0
thf(fact_28_abs__zero,axiom,(
    ! [A: $tType] :
      ( ( ordere142940540dd_abs @ A @ ( type2 @ A ) )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) )).

% abs_zero
thf(fact_29_norm__eq__zero,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( real_V1127708846m_norm @ A @ X )
            = ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) )).

% norm_eq_zero
thf(fact_30_norm__zero,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ( ( real_V1127708846m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) )).

% norm_zero
thf(fact_31_abs__one,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) )).

% abs_one
thf(fact_32_real__vector_Oscale__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A] :
          ( ( ( real_V1908273582scaleR @ A @ A2 @ X )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) )).

% real_vector.scale_eq_0_iff
thf(fact_33_real__vector_Oscale__zero__left,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( real_V1908273582scaleR @ A @ ( zero_zero @ real ) @ X )
          = ( zero_zero @ A ) ) ) )).

% real_vector.scale_zero_left
thf(fact_34_real__vector_Oscale__zero__right,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real] :
          ( ( real_V1908273582scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% real_vector.scale_zero_right
thf(fact_35_real__vector_Oscale__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A,B2: real] :
          ( ( ( real_V1908273582scaleR @ A @ A2 @ X )
            = ( real_V1908273582scaleR @ A @ B2 @ X ) )
          = ( ( A2 = B2 )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) )).

% real_vector.scale_cancel_right
thf(fact_36_of__real__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ real ) ) ) ) )).

% of_real_eq_0_iff
thf(fact_37_of__real__0,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) )).

% of_real_0
thf(fact_38_floor__zero,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archim2085082626_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) )).

% floor_zero
thf(fact_39_powr__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) )).

% powr_eq_0_iff
thf(fact_40_powr__0,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) )).

% powr_0
thf(fact_41_scaleR__one,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( real_V1908273582scaleR @ A @ ( one_one @ real ) @ X )
          = X ) ) )).

% scaleR_one
thf(fact_42_ceiling__zero,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) )).

% ceiling_zero
thf(fact_43_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_44_abs__norm__cancel,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( abs_abs @ real @ ( real_V1127708846m_norm @ A @ A2 ) )
          = ( real_V1127708846m_norm @ A @ A2 ) ) ) )).

% abs_norm_cancel
thf(fact_45_round__0,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) )).

% round_0
thf(fact_46_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_47_real__norm__def,axiom,
    ( ( real_V1127708846m_norm @ real )
    = ( abs_abs @ real ) )).

% real_norm_def
thf(fact_48_real__vector_Oscale__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A,Y: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V1908273582scaleR @ A @ A2 @ X )
              = ( real_V1908273582scaleR @ A @ A2 @ Y ) )
           => ( X = Y ) ) ) ) )).

% real_vector.scale_left_imp_eq
thf(fact_49_real__vector_Oscale__left__commute,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V1908273582scaleR @ A @ A2 @ ( real_V1908273582scaleR @ A @ B2 @ X ) )
          = ( real_V1908273582scaleR @ A @ B2 @ ( real_V1908273582scaleR @ A @ A2 @ X ) ) ) ) )).

% real_vector.scale_left_commute
thf(fact_50_real__vector_Oscale__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [X: A,A2: real,B2: real] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ( real_V1908273582scaleR @ A @ A2 @ X )
              = ( real_V1908273582scaleR @ A @ B2 @ X ) )
           => ( A2 = B2 ) ) ) ) )).

% real_vector.scale_right_imp_eq
thf(fact_51_zero__neq__one,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) )).

% zero_neq_one
thf(fact_52_ln__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) )).

% ln_one
thf(fact_53_dbl__inc__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) )).

% dbl_inc_simps(2)
thf(fact_54_dbl__dec__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% dbl_dec_simps(2)
thf(fact_55_norm__scaleR,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A] :
          ( ( real_V1127708846m_norm @ A @ ( real_V1908273582scaleR @ A @ A2 @ X ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V1127708846m_norm @ A @ X ) ) ) ) )).

% norm_scaleR
thf(fact_56_norm__sgn,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V1127708846m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V1127708846m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) )).

% norm_sgn
thf(fact_57_abs__sgn__eq,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) )).

% abs_sgn_eq
thf(fact_58_dbl__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) )).

% dbl_simps(2)
thf(fact_59_linear__axioms__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
        & ( real_V1076094709vector @ B @ ( type2 @ B ) ) )
     => ( ( real_V2128096322axioms @ A @ B )
        = ( ^ [F3: ( A > B )] :
            ! [R2: real,X3: A] :
              ( ( F3 @ ( real_V1908273582scaleR @ A @ R2 @ X3 ) )
              = ( real_V1908273582scaleR @ B @ R2 @ ( F3 @ X3 ) ) ) ) ) ) )).

% linear_axioms_def
thf(fact_60_linear__axioms_Ointro,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
        & ( real_V1076094709vector @ B @ ( type2 @ B ) ) )
     => ! [F: ( A > B )] :
          ( ! [R3: real,X2: A] :
              ( ( F @ ( real_V1908273582scaleR @ A @ R3 @ X2 ) )
              = ( real_V1908273582scaleR @ B @ R3 @ ( F @ X2 ) ) )
         => ( real_V2128096322axioms @ A @ B @ F ) ) ) )).

% linear_axioms.intro
thf(fact_61_norm__of__real__add1,axiom,(
    ! [A: $tType] :
      ( ( real_V68988228lgebra @ A @ ( type2 @ A ) )
     => ! [X: real] :
          ( ( real_V1127708846m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) ) ) ) )).

% norm_of_real_add1
thf(fact_62_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) )).

% add_right_cancel
thf(fact_63_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) )).

% add_left_cancel
thf(fact_64_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) )).

% neg_equal_iff_equal
thf(fact_65_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) )).

% add.inverse_inverse
thf(fact_66_sgn__sgn,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) )).

% sgn_sgn
thf(fact_67_mult__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) )).

% mult_cancel_right
thf(fact_68_mult__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) )).

% mult_cancel_left
thf(fact_69_mult__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri1193490041visors @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) )).

% mult_eq_0_iff
thf(fact_70_mult__zero__right,axiom,(
    ! [A: $tType] :
      ( ( mult_zero @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% mult_zero_right
thf(fact_71_mult__zero__left,axiom,(
    ! [A: $tType] :
      ( ( mult_zero @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% mult_zero_left
thf(fact_72_add__cancel__right__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_right
thf(fact_73_add__cancel__right__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_left
thf(fact_74_add__cancel__left__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_right
thf(fact_75_add__cancel__left__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_left
thf(fact_76_double__zero__sym,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero_sym
thf(fact_77_double__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero
thf(fact_78_add_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.right_neutral
thf(fact_79_add_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.left_neutral
thf(fact_80_mult_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% mult.right_neutral
thf(fact_81_mult_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% mult.left_neutral
thf(fact_82_neg__equal__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% neg_equal_zero
thf(fact_83_equal__neg__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% equal_neg_zero
thf(fact_84_neg__equal__0__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% neg_equal_0_iff_equal
thf(fact_85_neg__0__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) )).

% neg_0_equal_iff_equal
thf(fact_86_add_Oinverse__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) )).

% add.inverse_neutral
thf(fact_87_mult__minus__right,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) )).

% mult_minus_right
thf(fact_88_minus__mult__minus,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) )).

% minus_mult_minus
thf(fact_89_mult__minus__left,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) )).

% mult_minus_left
thf(fact_90_minus__add__distrib,axiom,(
    ! [A: $tType] :
      ( ( ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) )).

% minus_add_distrib
thf(fact_91_minus__add__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) )).

% minus_add_cancel
thf(fact_92_add__minus__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) )).

% add_minus_cancel
thf(fact_93_abs__mult__self,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) )).

% abs_mult_self
thf(fact_94_abs__add__abs,axiom,(
    ! [A: $tType] :
      ( ( ordere142940540dd_abs @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) )).

% abs_add_abs
thf(fact_95_abs__minus__cancel,axiom,(
    ! [A: $tType] :
      ( ( ordere142940540dd_abs @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) )).

% abs_minus_cancel
thf(fact_96_mult__scaleR__right,axiom,(
    ! [A: $tType] :
      ( ( real_V148923926lgebra @ A @ ( type2 @ A ) )
     => ! [X: A,A2: real,Y: A] :
          ( ( times_times @ A @ X @ ( real_V1908273582scaleR @ A @ A2 @ Y ) )
          = ( real_V1908273582scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) )).

% mult_scaleR_right
thf(fact_97_mult__scaleR__left,axiom,(
    ! [A: $tType] :
      ( ( real_V148923926lgebra @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A,Y: A] :
          ( ( times_times @ A @ ( real_V1908273582scaleR @ A @ A2 @ X ) @ Y )
          = ( real_V1908273582scaleR @ A @ A2 @ ( times_times @ A @ X @ Y ) ) ) ) )).

% mult_scaleR_left
thf(fact_98_norm__minus__cancel,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( real_V1127708846m_norm @ A @ ( uminus_uminus @ A @ X ) )
          = ( real_V1127708846m_norm @ A @ X ) ) ) )).

% norm_minus_cancel
thf(fact_99_real__vector_Oscale__minus__left,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A] :
          ( ( real_V1908273582scaleR @ A @ ( uminus_uminus @ real @ A2 ) @ X )
          = ( uminus_uminus @ A @ ( real_V1908273582scaleR @ A @ A2 @ X ) ) ) ) )).

% real_vector.scale_minus_left
thf(fact_100_scaleR__left_Ominus,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [X: real,Xa: A] :
          ( ( real_V1908273582scaleR @ A @ ( uminus_uminus @ real @ X ) @ Xa )
          = ( uminus_uminus @ A @ ( real_V1908273582scaleR @ A @ X @ Xa ) ) ) ) )).

% scaleR_left.minus
thf(fact_101_real__vector_Oscale__minus__right,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A] :
          ( ( real_V1908273582scaleR @ A @ A2 @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( real_V1908273582scaleR @ A @ A2 @ X ) ) ) ) )).

% real_vector.scale_minus_right
thf(fact_102_sgn__zero,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) )).

% sgn_zero
thf(fact_103_sgn0,axiom,(
    ! [A: $tType] :
      ( ( sgn_if @ A @ ( type2 @ A ) )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) )).

% sgn0
thf(fact_104_of__real__minus,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ! [X: real] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) )).

% of_real_minus
thf(fact_105_scaleR__scaleR,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V1908273582scaleR @ A @ A2 @ ( real_V1908273582scaleR @ A @ B2 @ X ) )
          = ( real_V1908273582scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X ) ) ) )).

% scaleR_scaleR
thf(fact_106_sgn__one,axiom,(
    ! [A: $tType] :
      ( ( real_V1229719638ebra_1 @ A @ ( type2 @ A ) )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) )).

% sgn_one
thf(fact_107_mult__cancel__left1,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type2 @ A ) )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_left1
thf(fact_108_mult__cancel__left2,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_left2
thf(fact_109_mult__cancel__right1,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type2 @ A ) )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_right1
thf(fact_110_mult__cancel__right2,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_right2
thf(fact_111_add_Oleft__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% add.left_inverse
thf(fact_112_add_Oright__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) )).

% add.right_inverse
thf(fact_113_mult__minus1,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) )).

% mult_minus1
thf(fact_114_mult__minus1__right,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) )).

% mult_minus1_right
thf(fact_115_abs__neg__one,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) )).

% abs_neg_one
thf(fact_116_scaleR__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V1908273582scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V1908273582scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) )).

% scaleR_eq_iff
thf(fact_117_scaleR__minus1__left,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( real_V1908273582scaleR @ A @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
          = ( uminus_uminus @ A @ X ) ) ) )).

% scaleR_minus1_left
thf(fact_118_of__real__mult,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X @ Y ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) )).

% of_real_mult
thf(fact_119_of__real__add,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ! [X: real,Y: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X @ Y ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) )).

% of_real_add
thf(fact_120_dbl__inc__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% dbl_inc_simps(4)
thf(fact_121_add__neg__numeral__special_I7_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) )).

% add_neg_numeral_special(7)
thf(fact_122_add__neg__numeral__special_I8_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) )).

% add_neg_numeral_special(8)
thf(fact_123_floor__add__one,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( archim2085082626_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archim2085082626_floor @ A @ X ) @ ( one_one @ int ) ) ) ) )).

% floor_add_one
thf(fact_124_ceiling__add__one,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) )).

% ceiling_add_one
thf(fact_125_ln__powr,axiom,(
    ! [X: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( ln_ln @ real @ X ) ) ) ) )).

% ln_powr
thf(fact_126_real__scaleR__def,axiom,
    ( ( real_V1908273582scaleR @ real )
    = ( times_times @ real ) )).

% real_scaleR_def
thf(fact_127_scaleR__left_Oadd,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [X: real,Y: real,Xa: A] :
          ( ( real_V1908273582scaleR @ A @ ( plus_plus @ real @ X @ Y ) @ Xa )
          = ( plus_plus @ A @ ( real_V1908273582scaleR @ A @ X @ Xa ) @ ( real_V1908273582scaleR @ A @ Y @ Xa ) ) ) ) )).

% scaleR_left.add
thf(fact_128_add__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) )).

% add_eq_0_iff
thf(fact_129_ab__group__add__class_Oab__left__minus,axiom,(
    ! [A: $tType] :
      ( ( ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% ab_group_add_class.ab_left_minus
thf(fact_130_add_Oinverse__unique,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) )).

% add.inverse_unique
thf(fact_131_eq__neg__iff__add__eq__0,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) )).

% eq_neg_iff_add_eq_0
thf(fact_132_neg__eq__iff__add__eq__0,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) )).

% neg_eq_iff_add_eq_0
thf(fact_133_scaleR__add__left,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,B2: real,X: A] :
          ( ( real_V1908273582scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X )
          = ( plus_plus @ A @ ( real_V1908273582scaleR @ A @ A2 @ X ) @ ( real_V1908273582scaleR @ A @ B2 @ X ) ) ) ) )).

% scaleR_add_left
thf(fact_134_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) )).

% zero_integer.rsp
thf(fact_135_square__eq__1__iff,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( times_times @ A @ X @ X )
            = ( one_one @ A ) )
          = ( ( X
              = ( one_one @ A ) )
            | ( X
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) )).

% square_eq_1_iff
thf(fact_136_norm__mult,axiom,(
    ! [A: $tType] :
      ( ( real_V68988228lgebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( real_V1127708846m_norm @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ real @ ( real_V1127708846m_norm @ A @ X ) @ ( real_V1127708846m_norm @ A @ Y ) ) ) ) )).

% norm_mult
thf(fact_137_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) )).

% add_right_imp_eq
thf(fact_138_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) )).

% add_left_imp_eq
thf(fact_139_mult_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% mult.left_commute
thf(fact_140_add_Oinverse__distrib__swap,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% add.inverse_distrib_swap
thf(fact_141_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% add.left_commute
thf(fact_142_mult_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type2 @ A ) )
     => ( ( times_times @ A )
        = ( ^ [A3: A,B3: A] :
              ( times_times @ A @ B3 @ A3 ) ) ) ) )).

% mult.commute
thf(fact_143_combine__common__factor,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,E: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E ) @ C2 ) ) ) )).

% combine_common_factor
thf(fact_144_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) )).

% minus_equation_iff
thf(fact_145_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) )).

% equation_minus_iff
thf(fact_146_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B3: A] :
              ( plus_plus @ A @ B3 @ A3 ) ) ) ) )).

% add.commute
thf(fact_147_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) )).

% add.right_cancel
thf(fact_148_mult_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_mult @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% mult.assoc
thf(fact_149_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) )).

% add.left_cancel
thf(fact_150_sgn__times,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) )).

% sgn_times
thf(fact_151_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% add.assoc
thf(fact_152_minus__mult__commute,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) )).

% minus_mult_commute
thf(fact_153_distrib__right,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% distrib_right
thf(fact_154_distrib__left,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) )).

% distrib_left
thf(fact_155_comm__semiring__class_Odistrib,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% comm_semiring_class.distrib
thf(fact_156_square__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( idom @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) )).

% square_eq_iff
thf(fact_157_dbl__def,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X3: A] :
              ( plus_plus @ A @ X3 @ X3 ) ) ) ) )).

% dbl_def
thf(fact_158_sgn__minus,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ X ) ) ) ) )).

% sgn_minus
thf(fact_159_sgn__mult,axiom,(
    ! [A: $tType] :
      ( ( real_V68988228lgebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X @ Y ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( sgn_sgn @ A @ Y ) ) ) ) )).

% sgn_mult
thf(fact_160_powr__powr,axiom,(
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ X @ ( times_times @ real @ A2 @ B2 ) ) ) )).

% powr_powr
thf(fact_161_powr__add,axiom,(
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ X @ ( plus_plus @ real @ A2 @ B2 ) )
      = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) )).

% powr_add
thf(fact_162_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_163_is__num__normalize_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% is_num_normalize(1)
thf(fact_164_is__num__normalize_I8_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% is_num_normalize(8)
thf(fact_165_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_166_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_167_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_168_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_169_mult__sgn__abs,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X ) @ ( abs_abs @ A @ X ) )
          = X ) ) )).

% mult_sgn_abs
thf(fact_170_abs__sgn,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ( ( abs_abs @ A )
        = ( ^ [K2: A] :
              ( times_times @ A @ K2 @ ( sgn_sgn @ A @ K2 ) ) ) ) ) )).

% abs_sgn
thf(fact_171_sgn__scaleR,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [R: real,X: A] :
          ( ( sgn_sgn @ A @ ( real_V1908273582scaleR @ A @ R @ X ) )
          = ( real_V1908273582scaleR @ A @ ( sgn_sgn @ real @ R ) @ ( sgn_sgn @ A @ X ) ) ) ) )).

% sgn_scaleR
thf(fact_172_sgn__of__real,axiom,(
    ! [A: $tType] :
      ( ( real_V1229719638ebra_1 @ A @ ( type2 @ A ) )
     => ! [R: real] :
          ( ( sgn_sgn @ A @ ( real_Vector_of_real @ A @ R ) )
          = ( real_Vector_of_real @ A @ ( sgn_sgn @ real @ R ) ) ) ) )).

% sgn_of_real
thf(fact_173_dbl__inc__def,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X3: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ X3 @ X3 ) @ ( one_one @ A ) ) ) ) ) )).

% dbl_inc_def
thf(fact_174_ceiling__minus,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archim2085082626_floor @ A @ X ) ) ) ) )).

% ceiling_minus
thf(fact_175_floor__minus,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( archim2085082626_floor @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archimedean_ceiling @ A @ X ) ) ) ) )).

% floor_minus
thf(fact_176_ceiling__def,axiom,(
    ! [A: $tType] :
      ( ( archim1727834104eiling @ A @ ( type2 @ A ) )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X3: A] :
              ( uminus_uminus @ int @ ( archim2085082626_floor @ A @ ( uminus_uminus @ A @ X3 ) ) ) ) ) ) )).

% ceiling_def
thf(fact_177_add__eq__0__iff__both__eq__0,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_178_add_Ogroup__left__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.group_left_neutral
thf(fact_179_add_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.comm_neutral
thf(fact_180_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_add_class.add_0
thf(fact_181_one__neq__neg__one,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% one_neq_neg_one
thf(fact_182_mult__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) )).

% mult_right_cancel
thf(fact_183_mult__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type2 @ A ) )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) )).

% mult_left_cancel
thf(fact_184_no__zero__divisors,axiom,(
    ! [A: $tType] :
      ( ( semiri1193490041visors @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) )).

% no_zero_divisors
thf(fact_185_divisors__zero,axiom,(
    ! [A: $tType] :
      ( ( semiri1193490041visors @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) )).

% divisors_zero
thf(fact_186_mult__not__zero,axiom,(
    ! [A: $tType] :
      ( ( mult_zero @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) )).

% mult_not_zero
thf(fact_187_mult_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% mult.comm_neutral
thf(fact_188_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_mult_class.mult_1
thf(fact_189_abs__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_ring @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( abs_abs @ A @ X )
            = ( abs_abs @ A @ Y ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) )).

% abs_eq_iff
thf(fact_190_abs__mult,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) )).

% abs_mult
thf(fact_191_scaleR__add__right,axiom,(
    ! [A: $tType] :
      ( ( real_V1076094709vector @ A @ ( type2 @ A ) )
     => ! [A2: real,X: A,Y: A] :
          ( ( real_V1908273582scaleR @ A @ A2 @ ( plus_plus @ A @ X @ Y ) )
          = ( plus_plus @ A @ ( real_V1908273582scaleR @ A @ A2 @ X ) @ ( real_V1908273582scaleR @ A @ A2 @ Y ) ) ) ) )).

% scaleR_add_right
thf(fact_192_sgn__0__0,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% sgn_0_0
thf(fact_193_sgn__zero__iff,axiom,(
    ! [A: $tType] :
      ( ( real_V55928688vector @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( sgn_sgn @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) )).

% sgn_zero_iff
thf(fact_194_zero__neq__neg__one,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% zero_neq_neg_one
thf(fact_195_scaleR__conv__of__real,axiom,(
    ! [A: $tType] :
      ( ( real_V84468443ebra_1 @ A @ ( type2 @ A ) )
     => ( ( real_V1908273582scaleR @ A )
        = ( ^ [R2: real] :
              ( times_times @ A @ ( real_Vector_of_real @ A @ R2 ) ) ) ) ) )).

% scaleR_conv_of_real
thf(fact_196_sum__squares__eq__zero__iff,axiom,(
    ! [A: $tType] :
      ( ( linord581940658strict @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% sum_squares_eq_zero_iff
thf(fact_197_real__add__minus__iff,axiom,(
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) )).

% real_add_minus_iff
thf(fact_198_ring__normalization__rules_I1_J,axiom,(
    ! [A: $tType] :
      ( ( comm_ring_1 @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A )
        = ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) )).

% ring_normalization_rules(1)
thf(fact_199_semiring__normalization__rules_I2_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,M: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ M ) @ M )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) )).

% semiring_normalization_rules(2)
thf(fact_200_semiring__normalization__rules_I3_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [M: A,A2: A] :
          ( ( plus_plus @ A @ M @ ( times_times @ A @ A2 @ M ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) )).

% semiring_normalization_rules(3)
thf(fact_201_semiring__normalization__rules_I4_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [M: A] :
          ( ( plus_plus @ A @ M @ M )
          = ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) @ M ) ) ) )).

% semiring_normalization_rules(4)
thf(fact_202_add__scale__eq__noteq,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [R: A,A2: A,B2: A,C2: A,D: A] :
          ( ( R
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R @ D ) ) ) ) ) ) )).

% add_scale_eq_noteq
thf(fact_203_powr__powr__swap,axiom,(
    ! [X: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B2 )
      = ( powr @ real @ ( powr @ real @ X @ B2 ) @ A2 ) ) )).

% powr_powr_swap
thf(fact_204_semiring__normalization__rules_I7_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ( ( times_times @ A )
        = ( ^ [A3: A,B3: A] :
              ( times_times @ A @ B3 @ A3 ) ) ) ) )).

% semiring_normalization_rules(7)
thf(fact_205_semiring__normalization__rules_I13_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ ( times_times @ A @ Lx @ Rx ) @ ( times_times @ A @ Ly @ Ry ) ) ) ) )).

% semiring_normalization_rules(13)
thf(fact_206_semiring__normalization__rules_I14_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ Lx @ ( times_times @ A @ Ly @ ( times_times @ A @ Rx @ Ry ) ) ) ) ) )).

% semiring_normalization_rules(14)
thf(fact_207_semiring__normalization__rules_I15_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ Rx @ ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ Ry ) ) ) ) )).

% semiring_normalization_rules(15)
thf(fact_208_semiring__normalization__rules_I16_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ Rx )
          = ( times_times @ A @ ( times_times @ A @ Lx @ Rx ) @ Ly ) ) ) )).

% semiring_normalization_rules(16)
thf(fact_209_semiring__normalization__rules_I17_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ Rx )
          = ( times_times @ A @ Lx @ ( times_times @ A @ Ly @ Rx ) ) ) ) )).

% semiring_normalization_rules(17)
thf(fact_210_semiring__normalization__rules_I18_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ Lx @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ ( times_times @ A @ Lx @ Rx ) @ Ry ) ) ) )).

% semiring_normalization_rules(18)
thf(fact_211_semiring__normalization__rules_I19_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ Lx @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ Rx @ ( times_times @ A @ Lx @ Ry ) ) ) ) )).

% semiring_normalization_rules(19)
thf(fact_212_semiring__normalization__rules_I20_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A,D: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D ) ) ) ) )).

% semiring_normalization_rules(20)
thf(fact_213_semiring__normalization__rules_I21_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% semiring_normalization_rules(21)
thf(fact_214_semiring__normalization__rules_I22_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C2 @ D ) )
          = ( plus_plus @ A @ C2 @ ( plus_plus @ A @ A2 @ D ) ) ) ) )).

% semiring_normalization_rules(22)
thf(fact_215_semiring__normalization__rules_I23_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) )).

% semiring_normalization_rules(23)
thf(fact_216_semiring__normalization__rules_I24_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,C3: A] :
              ( plus_plus @ A @ C3 @ A3 ) ) ) ) )).

% semiring_normalization_rules(24)
thf(fact_217_semiring__normalization__rules_I25_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C2: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C2 @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ D ) ) ) )).

% semiring_normalization_rules(25)
thf(fact_218_semiring__normalization__rules_I9_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% semiring_normalization_rules(9)
thf(fact_219_semiring__normalization__rules_I10_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% semiring_normalization_rules(10)
thf(fact_220_add__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% add_0_iff
thf(fact_221_semiring__normalization__rules_I5_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% semiring_normalization_rules(5)
thf(fact_222_semiring__normalization__rules_I6_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% semiring_normalization_rules(6)
thf(fact_223_crossproduct__noteq,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A,D: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D ) )
           != ( plus_plus @ A @ ( times_times @ A @ A2 @ D ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) )).

% crossproduct_noteq
thf(fact_224_crossproduct__eq,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [W: A,Y: A,X: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y ) @ ( times_times @ A @ X @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X @ Y ) ) )
          = ( ( W = X )
            | ( Y = Z ) ) ) ) )).

% crossproduct_eq
thf(fact_225_semiring__normalization__rules_I1_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,M: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ M ) @ ( times_times @ A @ B2 @ M ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ M ) ) ) )).

% semiring_normalization_rules(1)
thf(fact_226_semiring__normalization__rules_I8_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% semiring_normalization_rules(8)
thf(fact_227_semiring__normalization__rules_I34_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( times_times @ A @ X @ ( plus_plus @ A @ Y @ Z ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ Y ) @ ( times_times @ A @ X @ Z ) ) ) ) )).

% semiring_normalization_rules(34)
thf(fact_228_semiring__normalization__rules_I12_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% semiring_normalization_rules(12)
thf(fact_229_semiring__normalization__rules_I11_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% semiring_normalization_rules(11)
thf(fact_230_odd__nonzero,axiom,(
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) )).

% odd_nonzero
thf(fact_231_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X )
            = ( uminus_uminus @ A @ Y ) )
          = ( X = Y ) ) ) )).

% compl_eq_compl_iff
thf(fact_232_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A4: ( A > B ),X3: A] :
              ( uminus_uminus @ B @ ( A4 @ X3 ) ) ) ) ) )).

% uminus_apply
thf(fact_233_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X ) )
          = X ) ) )).

% double_compl
thf(fact_234_fun__Compl__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A4: ( A > B ),X3: A] :
              ( uminus_uminus @ B @ ( A4 @ X3 ) ) ) ) ) )).

% fun_Compl_def
thf(fact_235_times__int__code_I2_J,axiom,(
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) )).

% times_int_code(2)
thf(fact_236_times__int__code_I1_J,axiom,(
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) )).

% times_int_code(1)
thf(fact_237_abs__zmult__eq__1,axiom,(
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) )).

% abs_zmult_eq_1
thf(fact_238_int__distrib_I1_J,axiom,(
    ! [Z1: int,Z2: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z2 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z2 @ W ) ) ) )).

% int_distrib(1)
thf(fact_239_int__distrib_I2_J,axiom,(
    ! [W: int,Z1: int,Z2: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z2 ) ) ) )).

% int_distrib(2)
thf(fact_240_plus__int__code_I1_J,axiom,(
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) )).

% plus_int_code(1)
thf(fact_241_plus__int__code_I2_J,axiom,(
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) )).

% plus_int_code(2)
thf(fact_242_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) )).

% uminus_int_code(1)
thf(fact_243_zmult__eq__1__iff,axiom,(
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) )).

% zmult_eq_1_iff
thf(fact_244_pos__zmult__eq__1__iff__lemma,axiom,(
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) )).

% pos_zmult_eq_1_iff_lemma
thf(fact_245_linordered__field__class_Osign__simps_I36_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(36)
thf(fact_246_linordered__field__class_Osign__simps_I35_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(35)
thf(fact_247_linordered__field__class_Osign__simps_I23_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(23)
thf(fact_248_linordered__field__class_Osign__simps_I24_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ( ( times_times @ A )
        = ( ^ [A3: A,B3: A] :
              ( times_times @ A @ B3 @ A3 ) ) ) ) )).

% linordered_field_class.sign_simps(24)
thf(fact_249_linordered__field__class_Osign__simps_I25_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(25)
thf(fact_250_linordered__field__class_Osign__simps_I26_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(26)
thf(fact_251_linordered__field__class_Osign__simps_I27_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B3: A] :
              ( plus_plus @ A @ B3 @ A3 ) ) ) ) )).

% linordered_field_class.sign_simps(27)
thf(fact_252_linordered__field__class_Osign__simps_I28_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) )).

% linordered_field_class.sign_simps(28)
thf(fact_253_powr__mult__base,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y ) ) ) ) )).

% powr_mult_base

%----Subclasses (1)
thf(subcl_Orderings_Olinorder___HOL_Otype,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( type @ A @ ( type2 @ A ) ) ) )).

%----Type constructors (87)
thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( boolean_algebra @ A6 @ ( type2 @ A6 ) )
     => ( boolean_algebra @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( uminus @ A6 @ ( type2 @ A6 ) )
     => ( uminus @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    ( semiri456707255roduct @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    ( semiri1923998003cancel @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    ( semiri1193490041visors @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ( ordere142940540dd_abs @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    ( linord219039673up_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ( ring_11004092258visors @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    ( linord581940658strict @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ( ab_semigroup_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    ( comm_monoid_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    ( comm_monoid_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    ( linordered_ring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    ( linordered_idom @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    ( comm_semiring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    ( semigroup_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    ( comm_semiring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ( ab_group_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    ( zero_neq_one @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    ( monoid_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    ( comm_ring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    ( monoid_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    ( group_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    ( mult_zero @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    ( neg_numeral @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ( ring_char_0 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    ( semiring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ouminus_1,axiom,
    ( uminus @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Osgn__if,axiom,
    ( sgn_if @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ( ring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    ( zero @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ( ring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    ( idom @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    ( one @ int @ ( type2 @ int ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_2,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_3,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_4,axiom,
    ( semiri456707255roduct @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    ( real_V68988228lgebra @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    ( real_V1229719638ebra_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_5,axiom,
    ( semiri1923998003cancel @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    ( real_V55928688vector @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    ( real_V84468443ebra_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_6,axiom,
    ( semiri1193490041visors @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    ( real_V148923926lgebra @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_7,axiom,
    ( ordere779506340up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_8,axiom,
    ( ordere142940540dd_abs @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling,axiom,
    ( archim1727834104eiling @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    ( real_V1076094709vector @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_9,axiom,
    ( linord219039673up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_10,axiom,
    ( ring_11004092258visors @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_11,axiom,
    ( cancel1352612707id_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_12,axiom,
    ( linord581940658strict @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_13,axiom,
    ( cancel_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_14,axiom,
    ( ab_semigroup_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_15,axiom,
    ( comm_monoid_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_16,axiom,
    ( ab_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Fields_Olinordered__field,axiom,
    ( linordered_field @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_17,axiom,
    ( comm_monoid_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_18,axiom,
    ( linordered_ring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_19,axiom,
    ( linordered_idom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_20,axiom,
    ( comm_semiring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_21,axiom,
    ( semigroup_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_22,axiom,
    ( semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_23,axiom,
    ( comm_semiring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__group__add_24,axiom,
    ( ab_group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_25,axiom,
    ( zero_neq_one @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_26,axiom,
    ( monoid_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ( ln @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_27,axiom,
    ( comm_ring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Omonoid__add_28,axiom,
    ( monoid_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ogroup__add_29,axiom,
    ( group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Omult__zero_30,axiom,
    ( mult_zero @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Num_Oneg__numeral_31,axiom,
    ( neg_numeral @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Nat_Oring__char__0_32,axiom,
    ( ring_char_0 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring_33,axiom,
    ( semiring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ouminus_34,axiom,
    ( uminus @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osgn__if_35,axiom,
    ( sgn_if @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring__1_36,axiom,
    ( ring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ozero_37,axiom,
    ( zero @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring_38,axiom,
    ( ring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oidom_39,axiom,
    ( idom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oone_40,axiom,
    ( one @ real @ ( type2 @ real ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type2 @ a ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( splay_266122055elle_A @ a @ a2 @ ( node @ a @ l @ a2 @ r ) )
    = ( one_one @ real ) )).

%------------------------------------------------------------------------------
