%------------------------------------------------------------------------------
% File     : DAT213^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Splay tree analysis 186
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Nip14] Nipkow (2014), Amortized Complexity Verified
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : splay_tree_analysis__186.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  368 (   1 unit;  60 type;   0 defn)
%            Number of atoms       : 5014 ( 256 equality;3150 variable)
%            Maximal formula depth :   25 (  10 average)
%            Number of connectives : 4601 ( 113   ~;  12   |;  69   &;3855   @)
%                                         (   0 <=>; 552  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  222 ( 222   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   64 (  60   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1181 (   0 sgn;1064   !;  23   ?;  40   ^)
%                                         (1181   :;  54  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:49:47.790
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Tree_Otree,type,(
    tree: $tType > $tType )).

thf(ty_t_Real_Oreal,type,(
    real: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (54)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Transcendental_Oln,type,(
    ln: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Owellorder,type,(
    wellorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__order,type,(
    dense_order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Odense__linorder,type,(
    dense_linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,(
    ordere236663937imp_le: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,(
    condit1037483654norder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Splay__Tree_Ois__root,type,(
    splay_is_root: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > $o ) )).

thf(sy_c_Splay__Tree_Osplay,type,(
    splay_splay: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Splay__Tree_Osplay__max,type,(
    splay_splay_max: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Splay__Tree__Analysis__Base_Ot__splay,type,(
    splay_914434265_splay: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > nat ) )).

thf(sy_c_Splay__Tree__Analysis__Mirabelle__pcaxyvimtd_OA,type,(
    splay_266122055elle_A: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > real ) )).

thf(sy_c_Transcendental_Opowr,type,(
    powr: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Tree_Olinorder__class_Obst,type,(
    linorder_bst: 
      !>[A: $tType] :
        ( ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Olinorder__class_Obst__eq,type,(
    linorder_bst_eq: 
      !>[A: $tType] :
        ( ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Omirror,type,(
    mirror: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Tree_Osubtrees,type,(
    subtrees: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( set @ ( tree @ A ) ) ) )).

thf(sy_c_Tree_Otree_OLeaf,type,(
    leaf: 
      !>[A: $tType] :
        ( tree @ A ) )).

thf(sy_c_Tree_Otree_ONode,type,(
    node: 
      !>[A: $tType] :
        ( ( tree @ A ) > A > ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Tree_Otree_Ocase__tree,type,(
    case_tree: 
      !>[B: $tType,A: $tType] :
        ( B > ( ( tree @ A ) > A > ( tree @ A ) > B ) > ( tree @ A ) > B ) )).

thf(sy_c_Tree_Otree_Ois__Leaf,type,(
    is_Leaf: 
      !>[A: $tType] :
        ( ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Otree_Oleft,type,(
    left: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Tree_Otree_Opred__tree,type,(
    pred_tree: 
      !>[A: $tType] :
        ( ( A > $o ) > ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Otree_Orec__tree,type,(
    rec_tree: 
      !>[C: $tType,A: $tType] :
        ( C > ( ( tree @ A ) > A > ( tree @ A ) > C > C > C ) > ( tree @ A ) > C ) )).

thf(sy_c_Tree_Otree_Orel__tree,type,(
    rel_tree: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( tree @ A ) > ( tree @ B ) > $o ) )).

thf(sy_c_Tree_Otree_Oright,type,(
    right: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Tree_Otree_Oset__tree,type,(
    set_tree: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( set @ A ) ) )).

thf(sy_c_Tree_Otree_Oval,type,(
    val: 
      !>[A: $tType] :
        ( ( tree @ A ) > A ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_a,type,(
    a2: a )).

thf(sy_v_t,type,(
    t: ( tree @ a ) )).

thf(sy_v_thesis____,type,(
    thesis: $o )).

%----Relevant facts (254)
thf(fact_0_assms_I2_J,axiom,
    ( member @ a @ a2 @ ( set_tree @ a @ t ) )).

% assms(2)
thf(fact_1_assms_I1_J,axiom,
    ( linorder_bst @ a @ t )).

% assms(1)
thf(fact_2_tree_Oinject,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A ),Y21: ( tree @ A ),Y22: A,Y23: ( tree @ A )] :
      ( ( ( node @ A @ X21 @ X22 @ X23 )
        = ( node @ A @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% tree.inject
thf(fact_3_set__treeE,axiom,(
    ! [A: $tType,A2: A,T: ( tree @ A )] :
      ( ( member @ A @ A2 @ ( set_tree @ A @ T ) )
     => ? [L: ( tree @ A ),R: ( tree @ A )] :
          ( member @ ( tree @ A ) @ ( node @ A @ L @ A2 @ R ) @ ( subtrees @ A @ T ) ) ) )).

% set_treeE
thf(fact_4_in__set__tree__if,axiom,(
    ! [A: $tType,L2: ( tree @ A ),A2: A,R2: ( tree @ A ),T: ( tree @ A )] :
      ( ( member @ ( tree @ A ) @ ( node @ A @ L2 @ A2 @ R2 ) @ ( subtrees @ A @ T ) )
     => ( member @ A @ A2 @ ( set_tree @ A @ T ) ) ) )).

% in_set_tree_if
thf(fact_5_Node__notin__subtrees__if,axiom,(
    ! [A: $tType,A2: A,T: ( tree @ A ),L2: ( tree @ A ),R2: ( tree @ A )] :
      ( ~ ( member @ A @ A2 @ ( set_tree @ A @ T ) )
     => ~ ( member @ ( tree @ A ) @ ( node @ A @ L2 @ A2 @ R2 ) @ ( subtrees @ A @ T ) ) ) )).

% Node_notin_subtrees_if
thf(fact_6_tree_Oset__intros_I3_J,axiom,(
    ! [A: $tType,Xa: A,A3: ( tree @ A ),A1: ( tree @ A ),A22: A] :
      ( ( member @ A @ Xa @ ( set_tree @ A @ A3 ) )
     => ( member @ A @ Xa @ ( set_tree @ A @ ( node @ A @ A1 @ A22 @ A3 ) ) ) ) )).

% tree.set_intros(3)
thf(fact_7_tree_Oset__intros_I2_J,axiom,(
    ! [A: $tType,A22: A,A1: ( tree @ A ),A3: ( tree @ A )] :
      ( member @ A @ A22 @ ( set_tree @ A @ ( node @ A @ A1 @ A22 @ A3 ) ) ) )).

% tree.set_intros(2)
thf(fact_8_tree_Oset__intros_I1_J,axiom,(
    ! [A: $tType,X: A,A1: ( tree @ A ),A22: A,A3: ( tree @ A )] :
      ( ( member @ A @ X @ ( set_tree @ A @ A1 ) )
     => ( member @ A @ X @ ( set_tree @ A @ ( node @ A @ A1 @ A22 @ A3 ) ) ) ) )).

% tree.set_intros(1)
thf(fact_9_tree_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( tree @ A )] :
      ( ( member @ A @ E @ ( set_tree @ A @ A2 ) )
     => ( ! [Z1: ( tree @ A )] :
            ( ? [Z2: A,Z3: ( tree @ A )] :
                ( A2
                = ( node @ A @ Z1 @ Z2 @ Z3 ) )
           => ~ ( member @ A @ E @ ( set_tree @ A @ Z1 ) ) )
       => ( ! [Z1: ( tree @ A ),Z3: ( tree @ A )] :
              ( A2
             != ( node @ A @ Z1 @ E @ Z3 ) )
         => ~ ( ! [Z1: ( tree @ A ),Z2: A,Z3: ( tree @ A )] :
                  ( ( A2
                    = ( node @ A @ Z1 @ Z2 @ Z3 ) )
                 => ~ ( member @ A @ E @ ( set_tree @ A @ Z3 ) ) ) ) ) ) ) )).

% tree.set_cases
thf(fact_10_tree_Osimps_I7_J,axiom,(
    ! [C: $tType,A: $tType,F1: C,F2: ( ( tree @ A ) > A > ( tree @ A ) > C > C > C ),X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( rec_tree @ C @ A @ F1 @ F2 @ ( node @ A @ X21 @ X22 @ X23 ) )
      = ( F2 @ X21 @ X22 @ X23 @ ( rec_tree @ C @ A @ F1 @ F2 @ X21 ) @ ( rec_tree @ C @ A @ F1 @ F2 @ X23 ) ) ) )).

% tree.simps(7)
thf(fact_11_tree_Opred__inject_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: ( tree @ A ),Aa: A,Ab: ( tree @ A )] :
      ( ( pred_tree @ A @ P @ ( node @ A @ A2 @ Aa @ Ab ) )
      = ( ( pred_tree @ A @ P @ A2 )
        & ( P @ Aa )
        & ( pred_tree @ A @ P @ Ab ) ) ) )).

% tree.pred_inject(2)
thf(fact_12_A__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,L2: ( tree @ A ),R2: ( tree @ A )] :
          ( ( splay_266122055elle_A @ A @ A2 @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( one_one @ real ) ) ) )).

% A_simps(1)
thf(fact_13_tree_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F1: B,F2: ( ( tree @ A ) > A > ( tree @ A ) > B ),X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( case_tree @ B @ A @ F1 @ F2 @ ( node @ A @ X21 @ X22 @ X23 ) )
      = ( F2 @ X21 @ X22 @ X23 ) ) )).

% tree.simps(5)
thf(fact_14_tree_Opred__cong,axiom,(
    ! [A: $tType,X: ( tree @ A ),Ya: ( tree @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( set_tree @ A @ Ya ) )
           => ( ( P @ Z )
              = ( Pa @ Z ) ) )
       => ( ( pred_tree @ A @ P @ X )
          = ( pred_tree @ A @ Pa @ Ya ) ) ) ) )).

% tree.pred_cong
thf(fact_15_tree_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X: ( tree @ A ),Pa: ( A > $o )] :
      ( ( pred_tree @ A @ P @ X )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( set_tree @ A @ X ) )
           => ( ( P @ Z )
             => ( Pa @ Z ) ) )
       => ( pred_tree @ A @ Pa @ X ) ) ) )).

% tree.pred_mono_strong
thf(fact_16_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_17_splay__to__root,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A,T2: ( tree @ A )] :
          ( ( linorder_bst @ A @ T )
         => ( ( ( splay_splay @ A @ A2 @ T )
              = T2 )
           => ( ( member @ A @ A2 @ ( set_tree @ A @ T ) )
              = ( ? [L3: ( tree @ A ),R3: ( tree @ A )] :
                    ( T2
                    = ( node @ A @ L3 @ A2 @ R3 ) ) ) ) ) ) ) )).

% splay_to_root
thf(fact_18_tree_Opred__set,axiom,(
    ! [A: $tType] :
      ( ( pred_tree @ A )
      = ( ^ [P2: ( A > $o ),X2: ( tree @ A )] :
          ! [Y: A] :
            ( ( member @ A @ Y @ ( set_tree @ A @ X2 ) )
           => ( P2 @ Y ) ) ) ) )).

% tree.pred_set
thf(fact_19_tree_Osel_I3_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( val @ A @ ( node @ A @ X21 @ X22 @ X23 ) )
      = X22 ) )).

% tree.sel(3)
thf(fact_20_tree_Osel_I2_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( left @ A @ ( node @ A @ X21 @ X22 @ X23 ) )
      = X21 ) )).

% tree.sel(2)
thf(fact_21_tree_Osel_I5_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( right @ A @ ( node @ A @ X21 @ X22 @ X23 ) )
      = X23 ) )).

% tree.sel(5)
thf(fact_22_bst__eq__if__bst,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A )] :
          ( ( linorder_bst @ A @ T )
         => ( linorder_bst_eq @ A @ T ) ) ) )).

% bst_eq_if_bst
thf(fact_23_mirror_Osimps_I2_J,axiom,(
    ! [A: $tType,L2: ( tree @ A ),X: A,R2: ( tree @ A )] :
      ( ( mirror @ A @ ( node @ A @ L2 @ X @ R2 ) )
      = ( node @ A @ ( mirror @ A @ R2 ) @ X @ ( mirror @ A @ L2 ) ) ) )).

% mirror.simps(2)
thf(fact_24_tree_Osimps_I6_J,axiom,(
    ! [A: $tType,C: $tType,F1: C,F2: ( ( tree @ A ) > A > ( tree @ A ) > C > C > C )] :
      ( ( rec_tree @ C @ A @ F1 @ F2 @ ( leaf @ A ) )
      = F1 ) )).

% tree.simps(6)
thf(fact_25_powr__one__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) )).

% powr_one_eq_one
thf(fact_26_mirror__mirror,axiom,(
    ! [A: $tType,T: ( tree @ A )] :
      ( ( mirror @ A @ ( mirror @ A @ T ) )
      = T ) )).

% mirror_mirror
thf(fact_27_splay__Leaf__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,T: ( tree @ A )] :
          ( ( ( splay_splay @ A @ A2 @ T )
            = ( leaf @ A ) )
          = ( T
            = ( leaf @ A ) ) ) ) )).

% splay_Leaf_iff
thf(fact_28_mirror__Leaf,axiom,(
    ! [A: $tType,T: ( tree @ A )] :
      ( ( ( mirror @ A @ T )
        = ( leaf @ A ) )
      = ( T
        = ( leaf @ A ) ) ) )).

% mirror_Leaf
thf(fact_29_tree_Osel_I4_J,axiom,(
    ! [A: $tType] :
      ( ( right @ A @ ( leaf @ A ) )
      = ( leaf @ A ) ) )).

% tree.sel(4)
thf(fact_30_tree_Osel_I1_J,axiom,(
    ! [A: $tType] :
      ( ( left @ A @ ( leaf @ A ) )
      = ( leaf @ A ) ) )).

% tree.sel(1)
thf(fact_31_mirror_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( mirror @ A @ ( leaf @ A ) )
      = ( leaf @ A ) ) )).

% mirror.simps(1)
thf(fact_32_bst__eq_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( linorder_bst_eq @ A @ ( leaf @ A ) ) ) )).

% bst_eq.simps(1)
thf(fact_33_tree_Oexhaust__sel,axiom,(
    ! [A: $tType,Tree: ( tree @ A )] :
      ( ( Tree
       != ( leaf @ A ) )
     => ( Tree
        = ( node @ A @ ( left @ A @ Tree ) @ ( val @ A @ Tree ) @ ( right @ A @ Tree ) ) ) ) )).

% tree.exhaust_sel
thf(fact_34_splay__not__Leaf,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A] :
          ( ( T
           != ( leaf @ A ) )
         => ? [L: ( tree @ A ),X3: A,R: ( tree @ A )] :
              ( ( splay_splay @ A @ A2 @ T )
              = ( node @ A @ L @ X3 @ R ) ) ) ) )).

% splay_not_Leaf
thf(fact_35_splay_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( splay_splay @ A @ A2 @ ( leaf @ A ) )
          = ( leaf @ A ) ) ) )).

% splay.simps(1)
thf(fact_36_splay_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,L2: ( tree @ A ),R2: ( tree @ A )] :
          ( ( splay_splay @ A @ A2 @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( node @ A @ L2 @ A2 @ R2 ) ) ) )).

% splay.simps(2)
thf(fact_37_mirror_Oelims,axiom,(
    ! [A: $tType,X: ( tree @ A ),Y2: ( tree @ A )] :
      ( ( ( mirror @ A @ X )
        = Y2 )
     => ( ( ( X
            = ( leaf @ A ) )
         => ( Y2
           != ( leaf @ A ) ) )
       => ~ ( ! [L: ( tree @ A ),X3: A,R: ( tree @ A )] :
                ( ( X
                  = ( node @ A @ L @ X3 @ R ) )
               => ( Y2
                 != ( node @ A @ ( mirror @ A @ R ) @ X3 @ ( mirror @ A @ L ) ) ) ) ) ) ) )).

% mirror.elims
thf(fact_38_tree_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F2: ( ( tree @ A ) > A > ( tree @ A ) > B ),Tree: ( tree @ A )] :
      ( ( P @ ( case_tree @ B @ A @ F1 @ F2 @ Tree ) )
      = ( ~ ( ( ( Tree
                = ( leaf @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Tree
                = ( node @ A @ ( left @ A @ Tree ) @ ( val @ A @ Tree ) @ ( right @ A @ Tree ) ) )
              & ~ ( P @ ( F2 @ ( left @ A @ Tree ) @ ( val @ A @ Tree ) @ ( right @ A @ Tree ) ) ) ) ) ) ) )).

% tree.split_sel_asm
thf(fact_39_tree_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F1: B,F2: ( ( tree @ A ) > A > ( tree @ A ) > B ),Tree: ( tree @ A )] :
      ( ( P @ ( case_tree @ B @ A @ F1 @ F2 @ Tree ) )
      = ( ( ( Tree
            = ( leaf @ A ) )
         => ( P @ F1 ) )
        & ( ( Tree
            = ( node @ A @ ( left @ A @ Tree ) @ ( val @ A @ Tree ) @ ( right @ A @ Tree ) ) )
         => ( P @ ( F2 @ ( left @ A @ Tree ) @ ( val @ A @ Tree ) @ ( right @ A @ Tree ) ) ) ) ) ) )).

% tree.split_sel
thf(fact_40_set__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,T: ( tree @ A )] :
          ( ( set_tree @ A @ ( splay_splay @ A @ A2 @ T ) )
          = ( set_tree @ A @ T ) ) ) )).

% set_splay
thf(fact_41_bst__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A] :
          ( ( linorder_bst @ A @ T )
         => ( linorder_bst @ A @ ( splay_splay @ A @ A2 @ T ) ) ) ) )).

% bst_splay
thf(fact_42_tree_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( leaf @ A )
     != ( node @ A @ X21 @ X22 @ X23 ) ) )).

% tree.distinct(1)
thf(fact_43_tree_Oinduct,axiom,(
    ! [A: $tType,P: ( ( tree @ A ) > $o ),Tree: ( tree @ A )] :
      ( ( P @ ( leaf @ A ) )
     => ( ! [X1: ( tree @ A ),X24: A,X32: ( tree @ A )] :
            ( ( P @ X1 )
           => ( ( P @ X32 )
             => ( P @ ( node @ A @ X1 @ X24 @ X32 ) ) ) )
       => ( P @ Tree ) ) ) )).

% tree.induct
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_neq__Leaf__iff,axiom,(
    ! [A: $tType,T: ( tree @ A )] :
      ( ( T
       != ( leaf @ A ) )
      = ( ? [L3: ( tree @ A ),A5: A,R3: ( tree @ A )] :
            ( T
            = ( node @ A @ L3 @ A5 @ R3 ) ) ) ) )).

% neq_Leaf_iff
thf(fact_49_tree_Oexhaust,axiom,(
    ! [A: $tType,Y2: ( tree @ A )] :
      ( ( Y2
       != ( leaf @ A ) )
     => ~ ( ! [X212: ( tree @ A ),X222: A,X232: ( tree @ A )] :
              ( Y2
             != ( node @ A @ X212 @ X222 @ X232 ) ) ) ) )).

% tree.exhaust
thf(fact_50_mirror_Oinduct,axiom,(
    ! [A: $tType,P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
      ( ( P @ ( leaf @ A ) )
     => ( ! [L: ( tree @ A ),X3: A,R: ( tree @ A )] :
            ( ( P @ R )
           => ( ( P @ L )
             => ( P @ ( node @ A @ L @ X3 @ R ) ) ) )
       => ( P @ A0 ) ) ) )).

% mirror.induct
thf(fact_51_bst__eq_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ( X
           != ( leaf @ A ) )
         => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                  ( X
                 != ( node @ A @ L @ A6 @ R ) ) ) ) ) )).

% bst_eq.cases
thf(fact_52_bst__eq_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
          ( ( P @ ( leaf @ A ) )
         => ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                ( ( P @ L )
               => ( ( P @ R )
                 => ( P @ ( node @ A @ L @ A6 @ R ) ) ) )
           => ( P @ A0 ) ) ) ) )).

% bst_eq.induct
thf(fact_53_bst_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( linorder_bst @ A @ ( leaf @ A ) ) ) )).

% bst.simps(1)
thf(fact_54_tree_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F1: B,F2: ( ( tree @ A ) > A > ( tree @ A ) > B )] :
      ( ( case_tree @ B @ A @ F1 @ F2 @ ( leaf @ A ) )
      = F1 ) )).

% tree.simps(4)
thf(fact_55_tree_Opred__inject_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( pred_tree @ A @ P @ ( leaf @ A ) ) )).

% tree.pred_inject(1)
thf(fact_56_is__root__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A] :
          ( ( linorder_bst @ A @ T )
         => ( ( splay_is_root @ A @ A2 @ ( splay_splay @ A @ A2 @ T ) )
            = ( member @ A @ A2 @ ( set_tree @ A @ T ) ) ) ) ) )).

% is_root_splay
thf(fact_57_tree_Ocollapse_I2_J,axiom,(
    ! [A: $tType,Tree: ( tree @ A )] :
      ( ~ ( is_Leaf @ A @ Tree )
     => ( ( node @ A @ ( left @ A @ Tree ) @ ( val @ A @ Tree ) @ ( right @ A @ Tree ) )
        = Tree ) ) )).

% tree.collapse(2)
thf(fact_58__092_060Phi_062_Ocases,axiom,(
    ! [A: $tType,X: ( tree @ A )] :
      ( ( X
       != ( leaf @ A ) )
     => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
              ( X
             != ( node @ A @ L @ A6 @ R ) ) ) ) )).

% \<Phi>.cases
thf(fact_59__092_060Phi_062_Oinduct,axiom,(
    ! [A: $tType,P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
      ( ( P @ ( leaf @ A ) )
     => ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
            ( ( P @ L )
           => ( ( P @ R )
             => ( P @ ( node @ A @ L @ A6 @ R ) ) ) )
       => ( P @ A0 ) ) ) )).

% \<Phi>.induct
thf(fact_60_t__splay__max_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ( X
           != ( leaf @ A ) )
         => ( ! [L: ( tree @ A ),B2: A] :
                ( X
               != ( node @ A @ L @ B2 @ ( leaf @ A ) ) )
           => ~ ( ! [L: ( tree @ A ),B2: A,Rl: ( tree @ A ),C2: A,Rr: ( tree @ A )] :
                    ( X
                   != ( node @ A @ L @ B2 @ ( node @ A @ Rl @ C2 @ Rr ) ) ) ) ) ) ) )).

% t_splay_max.cases
thf(fact_61_t__splay__max_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
          ( ( P @ ( leaf @ A ) )
         => ( ! [L: ( tree @ A ),B2: A] :
                ( P @ ( node @ A @ L @ B2 @ ( leaf @ A ) ) )
           => ( ! [L: ( tree @ A ),B2: A,Rl: ( tree @ A ),C2: A,Rr: ( tree @ A )] :
                  ( ( ( Rr
                     != ( leaf @ A ) )
                   => ( P @ Rr ) )
                 => ( P @ ( node @ A @ L @ B2 @ ( node @ A @ Rl @ C2 @ Rr ) ) ) )
             => ( P @ A0 ) ) ) ) ) )).

% t_splay_max.induct
thf(fact_62_tree_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( case_tree @ B @ A )
      = ( ^ [F12: B,F22: ( ( tree @ A ) > A > ( tree @ A ) > B ),Tree2: ( tree @ A )] :
            ( if @ B @ ( is_Leaf @ A @ Tree2 ) @ F12 @ ( F22 @ ( left @ A @ Tree2 ) @ ( val @ A @ Tree2 ) @ ( right @ A @ Tree2 ) ) ) ) ) )).

% tree.case_eq_if
thf(fact_63_bst__eq_Oelims_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ( linorder_bst_eq @ A @ X )
         => ( ( X
             != ( leaf @ A ) )
           => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                    ( ( X
                      = ( node @ A @ L @ A6 @ R ) )
                   => ~ ( ( linorder_bst_eq @ A @ L )
                        & ( linorder_bst_eq @ A @ R )
                        & ! [X4: A] :
                            ( ( member @ A @ X4 @ ( set_tree @ A @ L ) )
                           => ( ord_less_eq @ A @ X4 @ A6 ) )
                        & ! [X4: A] :
                            ( ( member @ A @ X4 @ ( set_tree @ A @ R ) )
                           => ( ord_less_eq @ A @ A6 @ X4 ) ) ) ) ) ) ) ) )).

% bst_eq.elims(2)
thf(fact_64_bst__eq_Oelims_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A ),Y2: $o] :
          ( ( ( linorder_bst_eq @ A @ X )
            = Y2 )
         => ( ( ( X
                = ( leaf @ A ) )
             => ~ ( Y2 ) )
           => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                    ( ( X
                      = ( node @ A @ L @ A6 @ R ) )
                   => ( Y2
                      = ( ~ ( ( linorder_bst_eq @ A @ L )
                            & ( linorder_bst_eq @ A @ R )
                            & ! [X2: A] :
                                ( ( member @ A @ X2 @ ( set_tree @ A @ L ) )
                               => ( ord_less_eq @ A @ X2 @ A6 ) )
                            & ! [X2: A] :
                                ( ( member @ A @ X2 @ ( set_tree @ A @ R ) )
                               => ( ord_less_eq @ A @ A6 @ X2 ) ) ) ) ) ) ) ) ) ) )).

% bst_eq.elims(1)
thf(fact_65_powr__mono,axiom,(
    ! [A2: real,B3: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B3 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B3 ) ) ) ) )).

% powr_mono
thf(fact_66_tree_OdiscI_I2_J,axiom,(
    ! [A: $tType,Tree: ( tree @ A ),X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( Tree
        = ( node @ A @ X21 @ X22 @ X23 ) )
     => ~ ( is_Leaf @ A @ Tree ) ) )).

% tree.discI(2)
thf(fact_67_tree_Odisc_I2_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ~ ( is_Leaf @ A @ ( node @ A @ X21 @ X22 @ X23 ) ) )).

% tree.disc(2)
thf(fact_68_is__Leaf__def,axiom,(
    ! [A: $tType] :
      ( ( is_Leaf @ A )
      = ( ^ [Tree2: ( tree @ A )] :
            ( Tree2
            = ( leaf @ A ) ) ) ) )).

% is_Leaf_def
thf(fact_69_tree_Ocollapse_I1_J,axiom,(
    ! [A: $tType,Tree: ( tree @ A )] :
      ( ( is_Leaf @ A @ Tree )
     => ( Tree
        = ( leaf @ A ) ) ) )).

% tree.collapse(1)
thf(fact_70_tree_OdiscI_I1_J,axiom,(
    ! [A: $tType,Tree: ( tree @ A )] :
      ( ( Tree
        = ( leaf @ A ) )
     => ( is_Leaf @ A @ Tree ) ) )).

% tree.discI(1)
thf(fact_71_tree_Odisc_I1_J,axiom,(
    ! [A: $tType] :
      ( is_Leaf @ A @ ( leaf @ A ) ) )).

% tree.disc(1)
thf(fact_72_tree_Oset__sel_I3_J,axiom,(
    ! [A: $tType,A2: ( tree @ A ),Xa: A] :
      ( ~ ( is_Leaf @ A @ A2 )
     => ( ( member @ A @ Xa @ ( set_tree @ A @ ( right @ A @ A2 ) ) )
       => ( member @ A @ Xa @ ( set_tree @ A @ A2 ) ) ) ) )).

% tree.set_sel(3)
thf(fact_73_tree_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A2: ( tree @ A ),X: A] :
      ( ~ ( is_Leaf @ A @ A2 )
     => ( ( member @ A @ X @ ( set_tree @ A @ ( left @ A @ A2 ) ) )
       => ( member @ A @ X @ ( set_tree @ A @ A2 ) ) ) ) )).

% tree.set_sel(1)
thf(fact_74_tree_Oset__sel_I2_J,axiom,(
    ! [A: $tType,A2: ( tree @ A )] :
      ( ~ ( is_Leaf @ A @ A2 )
     => ( member @ A @ ( val @ A @ A2 ) @ ( set_tree @ A @ A2 ) ) ) )).

% tree.set_sel(2)
thf(fact_75_bst__eq_Oelims_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ~ ( linorder_bst_eq @ A @ X )
         => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                  ( ( X
                    = ( node @ A @ L @ A6 @ R ) )
                 => ( ( linorder_bst_eq @ A @ L )
                    & ( linorder_bst_eq @ A @ R )
                    & ! [X3: A] :
                        ( ( member @ A @ X3 @ ( set_tree @ A @ L ) )
                       => ( ord_less_eq @ A @ X3 @ A6 ) )
                    & ! [X3: A] :
                        ( ( member @ A @ X3 @ ( set_tree @ A @ R ) )
                       => ( ord_less_eq @ A @ A6 @ X3 ) ) ) ) ) ) ) )).

% bst_eq.elims(3)
thf(fact_76_bst__eq_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( tree @ A ),A2: A,R2: ( tree @ A )] :
          ( ( linorder_bst_eq @ A @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( ( linorder_bst_eq @ A @ L2 )
            & ( linorder_bst_eq @ A @ R2 )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set_tree @ A @ L2 ) )
               => ( ord_less_eq @ A @ X2 @ A2 ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set_tree @ A @ R2 ) )
               => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ) )).

% bst_eq.simps(2)
thf(fact_77_tree_Oexpand,axiom,(
    ! [A: $tType,Tree: ( tree @ A ),Tree3: ( tree @ A )] :
      ( ( ( is_Leaf @ A @ Tree )
        = ( is_Leaf @ A @ Tree3 ) )
     => ( ( ~ ( is_Leaf @ A @ Tree )
         => ( ~ ( is_Leaf @ A @ Tree3 )
           => ( ( ( left @ A @ Tree )
                = ( left @ A @ Tree3 ) )
              & ( ( val @ A @ Tree )
                = ( val @ A @ Tree3 ) )
              & ( ( right @ A @ Tree )
                = ( right @ A @ Tree3 ) ) ) ) )
       => ( Tree = Tree3 ) ) ) )).

% tree.expand
thf(fact_78_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_79_le__numeral__extra_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) )).

% le_numeral_extra(4)
thf(fact_80_splay__max__eq__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A] :
          ( ( linorder_bst @ A @ T )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set_tree @ A @ T ) )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ( splay_splay_max @ A @ T )
              = ( splay_splay @ A @ A2 @ T ) ) ) ) ) )).

% splay_max_eq_splay
thf(fact_81_ex__in__set__tree,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A] :
          ( ( T
           != ( leaf @ A ) )
         => ( ( linorder_bst @ A @ T )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ ( set_tree @ A @ T ) )
                & ( ( splay_splay @ A @ X3 @ T )
                  = ( splay_splay @ A @ A2 @ T ) )
                & ( ( splay_914434265_splay @ A @ X3 @ T )
                  = ( splay_914434265_splay @ A @ A2 @ T ) ) ) ) ) ) )).

% ex_in_set_tree
thf(fact_82_bst_Oelims_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ( linorder_bst @ A @ X )
         => ( ( X
             != ( leaf @ A ) )
           => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                    ( ( X
                      = ( node @ A @ L @ A6 @ R ) )
                   => ~ ( ( linorder_bst @ A @ L )
                        & ( linorder_bst @ A @ R )
                        & ! [X4: A] :
                            ( ( member @ A @ X4 @ ( set_tree @ A @ L ) )
                           => ( ord_less @ A @ X4 @ A6 ) )
                        & ! [X4: A] :
                            ( ( member @ A @ X4 @ ( set_tree @ A @ R ) )
                           => ( ord_less @ A @ A6 @ X4 ) ) ) ) ) ) ) ) )).

% bst.elims(2)
thf(fact_83_bst_Oelims_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A ),Y2: $o] :
          ( ( ( linorder_bst @ A @ X )
            = Y2 )
         => ( ( ( X
                = ( leaf @ A ) )
             => ~ ( Y2 ) )
           => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                    ( ( X
                      = ( node @ A @ L @ A6 @ R ) )
                   => ( Y2
                      = ( ~ ( ( linorder_bst @ A @ L )
                            & ( linorder_bst @ A @ R )
                            & ! [X2: A] :
                                ( ( member @ A @ X2 @ ( set_tree @ A @ L ) )
                               => ( ord_less @ A @ X2 @ A6 ) )
                            & ! [X2: A] :
                                ( ( member @ A @ X2 @ ( set_tree @ A @ R ) )
                               => ( ord_less @ A @ A6 @ X2 ) ) ) ) ) ) ) ) ) ) )).

% bst.elims(1)
thf(fact_84_tree_Orel__sel,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rel_tree @ A @ B )
      = ( ^ [R4: ( A > B > $o ),A5: ( tree @ A ),B4: ( tree @ B )] :
            ( ( ( is_Leaf @ A @ A5 )
              = ( is_Leaf @ B @ B4 ) )
            & ( ~ ( is_Leaf @ A @ A5 )
             => ( ~ ( is_Leaf @ B @ B4 )
               => ( ( rel_tree @ A @ B @ R4 @ ( left @ A @ A5 ) @ ( left @ B @ B4 ) )
                  & ( R4 @ ( val @ A @ A5 ) @ ( val @ B @ B4 ) )
                  & ( rel_tree @ A @ B @ R4 @ ( right @ A @ A5 ) @ ( right @ B @ B4 ) ) ) ) ) ) ) ) )).

% tree.rel_sel
thf(fact_85_powr__less__cancel__iff,axiom,(
    ! [X: real,A2: real,B3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B3 ) )
        = ( ord_less @ real @ A2 @ B3 ) ) ) )).

% powr_less_cancel_iff
thf(fact_86_t__splay__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,L2: ( tree @ A ),R2: ( tree @ A )] :
          ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( one_one @ nat ) ) ) )).

% t_splay_simps(1)
thf(fact_87_splay__max__Leaf__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A )] :
          ( ( ( splay_splay_max @ A @ T )
            = ( leaf @ A ) )
          = ( T
            = ( leaf @ A ) ) ) ) )).

% splay_max_Leaf_iff
thf(fact_88_powr__le__cancel__iff,axiom,(
    ! [X: real,A2: real,B3: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B3 ) )
        = ( ord_less_eq @ real @ A2 @ B3 ) ) ) )).

% powr_le_cancel_iff
thf(fact_89_t__splay__simps_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,L2: ( tree @ A ),Rl2: ( tree @ A ),Rr2: ( tree @ A )] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B3 @ ( node @ A @ Rl2 @ A2 @ Rr2 ) ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(7)
thf(fact_90_t__splay__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,Ll: ( tree @ A ),Lr: ( tree @ A ),R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ A2 @ Lr ) @ B3 @ R2 ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(3)
thf(fact_91_t__splay__simps_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,L2: ( tree @ A )] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B3 @ ( leaf @ A ) ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(6)
thf(fact_92_t__splay__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( leaf @ A ) @ B3 @ R2 ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(2)
thf(fact_93_leD,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ~ ( ord_less @ A @ X @ Y2 ) ) ) )).

% leD
thf(fact_94_leI,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% leI
thf(fact_95_le__less,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less @ A @ X2 @ Y )
              | ( X2 = Y ) ) ) ) ) )).

% le_less
thf(fact_96_less__le,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
              & ( X2 != Y ) ) ) ) ) )).

% less_le
thf(fact_97_order__le__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C3: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C3 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less @ B @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C3 ) ) ) ) ) ) )).

% order_le_less_subst1
thf(fact_98_order__le__less__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C ),C3: C] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less @ C @ ( F @ B3 ) @ C3 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C @ ( F @ A2 ) @ C3 ) ) ) ) ) )).

% order_le_less_subst2
thf(fact_99_order__less__le__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C3: B] :
          ( ( ord_less @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C3 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C3 ) ) ) ) ) ) )).

% order_less_le_subst1
thf(fact_100_order__less__le__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C ),C3: C] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ C @ ( F @ B3 ) @ C3 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ C @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C @ ( F @ A2 ) @ C3 ) ) ) ) ) )).

% order_less_le_subst2
thf(fact_101_not__le,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X ) ) ) )).

% not_le
thf(fact_102_not__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% not_less
thf(fact_103_le__neq__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( A2 != B3 )
           => ( ord_less @ A @ A2 @ B3 ) ) ) ) )).

% le_neq_trans
thf(fact_104_less__imp__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) )).

% less_imp_le
thf(fact_105_antisym__conv1,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv1
thf(fact_106_antisym__conv2,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv2
thf(fact_107_le__less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z4: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z4 )
           => ( ord_less @ A @ X @ Z4 ) ) ) ) )).

% le_less_trans
thf(fact_108_less__le__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z4: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z4 )
           => ( ord_less @ A @ X @ Z4 ) ) ) ) )).

% less_le_trans
thf(fact_109_dense__ge,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z4: A,Y2: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ord_less_eq @ A @ Y2 @ X3 ) )
         => ( ord_less_eq @ A @ Y2 @ Z4 ) ) ) )).

% dense_ge
thf(fact_110_dense__le,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,Z4: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ord_less_eq @ A @ X3 @ Z4 ) )
         => ( ord_less_eq @ A @ Y2 @ Z4 ) ) ) )).

% dense_le
thf(fact_111_le__less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) )).

% le_less_linear
thf(fact_112_le__imp__less__or__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less @ A @ X @ Y2 )
            | ( X = Y2 ) ) ) ) )).

% le_imp_less_or_eq
thf(fact_113_less__le__not__le,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
              & ~ ( ord_less_eq @ A @ Y @ X2 ) ) ) ) ) )).

% less_le_not_le
thf(fact_114_not__le__imp__less,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X )
         => ( ord_less @ A @ X @ Y2 ) ) ) )).

% not_le_imp_less
thf(fact_115_order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less @ A @ B3 @ C3 )
           => ( ord_less @ A @ A2 @ C3 ) ) ) ) )).

% order.strict_trans1
thf(fact_116_order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C3 )
           => ( ord_less @ A @ A2 @ C3 ) ) ) ) )).

% order.strict_trans2
thf(fact_117_order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
              | ( A5 = B4 ) ) ) ) ) )).

% order.order_iff_strict
thf(fact_118_order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
              & ( A5 != B4 ) ) ) ) ) )).

% order.strict_iff_order
thf(fact_119_dual__order_Ostrict__trans1,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less @ A @ C3 @ B3 )
           => ( ord_less @ A @ C3 @ A2 ) ) ) ) )).

% dual_order.strict_trans1
thf(fact_120_dual__order_Ostrict__trans2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ C3 @ B3 )
           => ( ord_less @ A @ C3 @ A2 ) ) ) ) )).

% dual_order.strict_trans2
thf(fact_121_dense__ge__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [Z4: A,X: A,Y2: A] :
          ( ( ord_less @ A @ Z4 @ X )
         => ( ! [W: A] :
                ( ( ord_less @ A @ Z4 @ W )
               => ( ( ord_less @ A @ W @ X )
                 => ( ord_less_eq @ A @ Y2 @ W ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z4 ) ) ) ) )).

% dense_ge_bounded
thf(fact_122_dense__le__bounded,axiom,(
    ! [A: $tType] :
      ( ( dense_linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z4: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ! [W: A] :
                ( ( ord_less @ A @ X @ W )
               => ( ( ord_less @ A @ W @ Y2 )
                 => ( ord_less_eq @ A @ W @ Z4 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z4 ) ) ) ) )).

% dense_le_bounded
thf(fact_123_order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ord_less_eq @ A @ A2 @ B3 ) ) ) )).

% order.strict_implies_order
thf(fact_124_dual__order_Oorder__iff__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less @ A @ B4 @ A5 )
              | ( A5 = B4 ) ) ) ) ) )).

% dual_order.order_iff_strict
thf(fact_125_dual__order_Ostrict__iff__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A5: A] :
              ( ( ord_less_eq @ A @ B4 @ A5 )
              & ( A5 != B4 ) ) ) ) ) )).

% dual_order.strict_iff_order
thf(fact_126_dual__order_Ostrict__implies__order,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ord_less_eq @ A @ B3 @ A2 ) ) ) )).

% dual_order.strict_implies_order
thf(fact_127_order_Onot__eq__order__implies__strict,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( A2 != B3 )
         => ( ( ord_less_eq @ A @ A2 @ B3 )
           => ( ord_less @ A @ A2 @ B3 ) ) ) ) )).

% order.not_eq_order_implies_strict
thf(fact_128_tree_Orel__mono,axiom,(
    ! [B: $tType,A: $tType,R5: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( ord_less_eq @ ( A > B > $o ) @ R5 @ Ra )
     => ( ord_less_eq @ ( ( tree @ A ) > ( tree @ B ) > $o ) @ ( rel_tree @ A @ B @ R5 ) @ ( rel_tree @ A @ B @ Ra ) ) ) )).

% tree.rel_mono
thf(fact_129_less__numeral__extra_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) )).

% less_numeral_extra(4)
thf(fact_130_tree_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( rel_tree @ A @ A
        @ ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
      = ( ^ [Y4: ( tree @ A ),Z5: ( tree @ A )] : ( Y4 = Z5 ) ) ) )).

% tree.rel_eq
thf(fact_131_tree_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X: ( tree @ B )] :
      ( ! [X3: B] :
          ( Ra @ X3 @ X3 )
     => ( rel_tree @ B @ B @ Ra @ X @ X ) ) )).

% tree.rel_refl
thf(fact_132_dual__order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( A2 != B3 ) ) ) )).

% dual_order.strict_implies_not_eq
thf(fact_133_order_Ostrict__implies__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( A2 != B3 ) ) ) )).

% order.strict_implies_not_eq
thf(fact_134_not__less__iff__gr__or__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X )
            | ( X = Y2 ) ) ) ) )).

% not_less_iff_gr_or_eq
thf(fact_135_dual__order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( ord_less @ A @ C3 @ B3 )
           => ( ord_less @ A @ C3 @ A2 ) ) ) ) )).

% dual_order.strict_trans
thf(fact_136_less__imp__not__less,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_imp_not_less
thf(fact_137_order_Ostrict__trans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less @ A @ B3 @ C3 )
           => ( ord_less @ A @ A2 @ C3 ) ) ) ) )).

% order.strict_trans
thf(fact_138_dual__order_Oirrefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) )).

% dual_order.irrefl
thf(fact_139_linorder__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less @ A @ X @ Y2 )
         => ( ( X != Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% linorder_cases
thf(fact_140_less__imp__triv,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,P: $o] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X )
           => P ) ) ) )).

% less_imp_triv
thf(fact_141_less__imp__not__eq2,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( Y2 != X ) ) ) )).

% less_imp_not_eq2
thf(fact_142_antisym__conv3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ~ ( ord_less @ A @ Y2 @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y2 ) )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv3
thf(fact_143_less__induct,axiom,(
    ! [A: $tType] :
      ( ( wellorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > $o ),A2: A] :
          ( ! [X3: A] :
              ( ! [Y5: A] :
                  ( ( ord_less @ A @ Y5 @ X3 )
                 => ( P @ Y5 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) )).

% less_induct
thf(fact_144_less__not__sym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_not_sym
thf(fact_145_less__imp__not__eq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( X != Y2 ) ) ) )).

% less_imp_not_eq
thf(fact_146_dual__order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B3 ) ) ) )).

% dual_order.asym
thf(fact_147_ord__less__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( B3 = C3 )
           => ( ord_less @ A @ A2 @ C3 ) ) ) ) )).

% ord_less_eq_trans
thf(fact_148_ord__eq__less__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( A2 = B3 )
         => ( ( ord_less @ A @ B3 @ C3 )
           => ( ord_less @ A @ A2 @ C3 ) ) ) ) )).

% ord_eq_less_trans
thf(fact_149_less__irrefl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) )).

% less_irrefl
thf(fact_150_less__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
          | ( X = Y2 )
          | ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_linear
thf(fact_151_less__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z4: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z4 )
           => ( ord_less @ A @ X @ Z4 ) ) ) ) )).

% less_trans
thf(fact_152_less__asym_H,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A2 ) ) ) )).

% less_asym'
thf(fact_153_less__asym,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X ) ) ) )).

% less_asym
thf(fact_154_less__imp__neq,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ( X != Y2 ) ) ) )).

% less_imp_neq
thf(fact_155_dense,axiom,(
    ! [A: $tType] :
      ( ( dense_order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less @ A @ X @ Y2 )
         => ? [Z: A] :
              ( ( ord_less @ A @ X @ Z )
              & ( ord_less @ A @ Z @ Y2 ) ) ) ) )).

% dense
thf(fact_156_order_Oasym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ~ ( ord_less @ A @ B3 @ A2 ) ) ) )).

% order.asym
thf(fact_157_neq__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
          = ( ( ord_less @ A @ X @ Y2 )
            | ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% neq_iff
thf(fact_158_neqE,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X != Y2 )
         => ( ~ ( ord_less @ A @ X @ Y2 )
           => ( ord_less @ A @ Y2 @ X ) ) ) ) )).

% neqE
thf(fact_159_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X1: A] :
          ( ord_less @ A @ X @ X1 ) ) )).

% gt_ex
thf(fact_160_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y3: A] :
          ( ord_less @ A @ Y3 @ X ) ) )).

% lt_ex
thf(fact_161_order__less__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C ),C3: C] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less @ C @ ( F @ B3 ) @ C3 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ C @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ C @ ( F @ A2 ) @ C3 ) ) ) ) ) )).

% order_less_subst2
thf(fact_162_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C3: B] :
          ( ( ord_less @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C3 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less @ B @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C3 ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_163_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > B ),C3: B] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ( F @ B3 )
              = C3 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less @ A @ X3 @ Y3 )
                 => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ B @ ( F @ A2 ) @ C3 ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_164_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C3: B] :
          ( ( A2
            = ( F @ B3 ) )
         => ( ( ord_less @ B @ B3 @ C3 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less @ B @ X3 @ Y3 )
                 => ( ord_less @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less @ A @ A2 @ ( F @ C3 ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_165_powr__powr__swap,axiom,(
    ! [X: real,A2: real,B3: real] :
      ( ( powr @ real @ ( powr @ real @ X @ A2 ) @ B3 )
      = ( powr @ real @ ( powr @ real @ X @ B3 ) @ A2 ) ) )).

% powr_powr_swap
thf(fact_166_tree_Orel__inject_I2_J,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),X21: ( tree @ A ),X22: A,X23: ( tree @ A ),Y21: ( tree @ B ),Y22: B,Y23: ( tree @ B )] :
      ( ( rel_tree @ A @ B @ R5 @ ( node @ A @ X21 @ X22 @ X23 ) @ ( node @ B @ Y21 @ Y22 @ Y23 ) )
      = ( ( rel_tree @ A @ B @ R5 @ X21 @ Y21 )
        & ( R5 @ X22 @ Y22 )
        & ( rel_tree @ A @ B @ R5 @ X23 @ Y23 ) ) ) )).

% tree.rel_inject(2)
thf(fact_167_tree_Orel__intros_I2_J,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),X21: ( tree @ A ),Y21: ( tree @ B ),X22: A,Y22: B,X23: ( tree @ A ),Y23: ( tree @ B )] :
      ( ( rel_tree @ A @ B @ R5 @ X21 @ Y21 )
     => ( ( R5 @ X22 @ Y22 )
       => ( ( rel_tree @ A @ B @ R5 @ X23 @ Y23 )
         => ( rel_tree @ A @ B @ R5 @ ( node @ A @ X21 @ X22 @ X23 ) @ ( node @ B @ Y21 @ Y22 @ Y23 ) ) ) ) ) )).

% tree.rel_intros(2)
thf(fact_168_tree_Octr__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o )] :
      ( rel_tree @ A @ B @ R5 @ ( leaf @ A ) @ ( leaf @ B ) ) )).

% tree.ctr_transfer(1)
thf(fact_169_tree_Orel__refl__strong,axiom,(
    ! [A: $tType,X: ( tree @ A ),Ra: ( A > A > $o )] :
      ( ! [Z: A] :
          ( ( member @ A @ Z @ ( set_tree @ A @ X ) )
         => ( Ra @ Z @ Z ) )
     => ( rel_tree @ A @ A @ Ra @ X @ X ) ) )).

% tree.rel_refl_strong
thf(fact_170_tree_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),X: ( tree @ A ),Y2: ( tree @ B ),Ra: ( A > B > $o )] :
      ( ( rel_tree @ A @ B @ R5 @ X @ Y2 )
     => ( ! [Z: A,Yb: B] :
            ( ( member @ A @ Z @ ( set_tree @ A @ X ) )
           => ( ( member @ B @ Yb @ ( set_tree @ B @ Y2 ) )
             => ( ( R5 @ Z @ Yb )
               => ( Ra @ Z @ Yb ) ) ) )
       => ( rel_tree @ A @ B @ Ra @ X @ Y2 ) ) ) )).

% tree.rel_mono_strong
thf(fact_171_tree_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,X: ( tree @ A ),Ya: ( tree @ A ),Y2: ( tree @ B ),Xa: ( tree @ B ),R5: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( X = Ya )
     => ( ( Y2 = Xa )
       => ( ! [Z: A,Yb: B] :
              ( ( member @ A @ Z @ ( set_tree @ A @ Ya ) )
             => ( ( member @ B @ Yb @ ( set_tree @ B @ Xa ) )
               => ( ( R5 @ Z @ Yb )
                  = ( Ra @ Z @ Yb ) ) ) )
         => ( ( rel_tree @ A @ B @ R5 @ X @ Y2 )
            = ( rel_tree @ A @ B @ Ra @ Ya @ Xa ) ) ) ) ) )).

% tree.rel_cong
thf(fact_172_powr__less__mono,axiom,(
    ! [A2: real,B3: real,X: real] :
      ( ( ord_less @ real @ A2 @ B3 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B3 ) ) ) ) )).

% powr_less_mono
thf(fact_173_powr__less__cancel,axiom,(
    ! [X: real,A2: real,B3: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B3 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B3 ) ) ) )).

% powr_less_cancel
thf(fact_174_t__splay_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( splay_914434265_splay @ A @ A2 @ ( leaf @ A ) )
          = ( one_one @ nat ) ) ) )).

% t_splay.simps(1)
thf(fact_175_splay__max_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( splay_splay_max @ A @ ( leaf @ A ) )
        = ( leaf @ A ) ) ) )).

% splay_max.simps(1)
thf(fact_176_set__splay__max,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A )] :
          ( ( set_tree @ A @ ( splay_splay_max @ A @ T ) )
          = ( set_tree @ A @ T ) ) ) )).

% set_splay_max
thf(fact_177_bst__splay__max,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A )] :
          ( ( linorder_bst @ A @ T )
         => ( linorder_bst @ A @ ( splay_splay_max @ A @ T ) ) ) ) )).

% bst_splay_max
thf(fact_178_tree_Orel__induct,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),X: ( tree @ A ),Y2: ( tree @ B ),Q: ( ( tree @ A ) > ( tree @ B ) > $o )] :
      ( ( rel_tree @ A @ B @ R5 @ X @ Y2 )
     => ( ( Q @ ( leaf @ A ) @ ( leaf @ B ) )
       => ( ! [A21: ( tree @ A ),A222: A,A23: ( tree @ A ),B21: ( tree @ B ),B22: B,B23: ( tree @ B )] :
              ( ( Q @ A21 @ B21 )
             => ( ( R5 @ A222 @ B22 )
               => ( ( Q @ A23 @ B23 )
                 => ( Q @ ( node @ A @ A21 @ A222 @ A23 ) @ ( node @ B @ B21 @ B22 @ B23 ) ) ) ) )
         => ( Q @ X @ Y2 ) ) ) ) )).

% tree.rel_induct
thf(fact_179_tree_Orel__cases,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),A2: ( tree @ A ),B3: ( tree @ B )] :
      ( ( rel_tree @ A @ B @ R5 @ A2 @ B3 )
     => ( ( ( A2
            = ( leaf @ A ) )
         => ( B3
           != ( leaf @ B ) ) )
       => ~ ( ! [X1: ( tree @ A ),X24: A,X32: ( tree @ A )] :
                ( ( A2
                  = ( node @ A @ X1 @ X24 @ X32 ) )
               => ! [Y1: ( tree @ B ),Y24: B,Y32: ( tree @ B )] :
                    ( ( B3
                      = ( node @ B @ Y1 @ Y24 @ Y32 ) )
                   => ( ( rel_tree @ A @ B @ R5 @ X1 @ Y1 )
                     => ( ( R5 @ X24 @ Y24 )
                       => ~ ( rel_tree @ A @ B @ R5 @ X32 @ Y32 ) ) ) ) ) ) ) ) )).

% tree.rel_cases
thf(fact_180_tree_Orel__distinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),Y21: ( tree @ B ),Y22: B,Y23: ( tree @ B )] :
      ~ ( rel_tree @ A @ B @ R5 @ ( leaf @ A ) @ ( node @ B @ Y21 @ Y22 @ Y23 ) ) )).

% tree.rel_distinct(1)
thf(fact_181_tree_Orel__distinct_I2_J,axiom,(
    ! [A: $tType,B: $tType,R5: ( A > B > $o ),Y21: ( tree @ A ),Y22: A,Y23: ( tree @ A )] :
      ~ ( rel_tree @ A @ B @ R5 @ ( node @ A @ Y21 @ Y22 @ Y23 ) @ ( leaf @ B ) ) )).

% tree.rel_distinct(2)
thf(fact_182_splay_Osimps_I9_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,Lb: ( tree @ A ),La: ( tree @ A ),Ra2: ( tree @ A )] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( splay_splay @ A @ A2 @ ( node @ A @ Lb @ B3 @ ( node @ A @ La @ A2 @ Ra2 ) ) )
            = ( node @ A @ ( node @ A @ Lb @ B3 @ La ) @ A2 @ Ra2 ) ) ) ) )).

% splay.simps(9)
thf(fact_183_splay_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,La: ( tree @ A ),Ra2: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( splay_splay @ A @ A2 @ ( node @ A @ ( node @ A @ La @ A2 @ Ra2 ) @ B3 @ Rb ) )
            = ( node @ A @ La @ A2 @ ( node @ A @ Ra2 @ B3 @ Rb ) ) ) ) ) )).

% splay.simps(3)
thf(fact_184_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B3 )
           => ( A2 = B3 ) ) ) ) )).

% dual_order.antisym
thf(fact_185_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ord_less_eq @ A @ B3 @ A2 )
         => ( ( ord_less_eq @ A @ C3 @ B3 )
           => ( ord_less_eq @ A @ C3 @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_186_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B3: A] :
          ( ! [A6: A,B2: A] :
              ( ( ord_less_eq @ A @ A6 @ B2 )
             => ( P @ A6 @ B2 ) )
         => ( ! [A6: A,B2: A] :
                ( ( P @ B2 @ A6 )
               => ( P @ A6 @ B2 ) )
           => ( P @ A2 @ B3 ) ) ) ) )).

% linorder_wlog
thf(fact_187_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_188_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z4: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z4 )
           => ( ord_less_eq @ A @ X @ Z4 ) ) ) ) )).

% order_trans
thf(fact_189_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ A2 )
           => ( A2 = B3 ) ) ) ) )).

% order_class.order.antisym
thf(fact_190_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( B3 = C3 )
           => ( ord_less_eq @ A @ A2 @ C3 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_191_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( A2 = B3 )
         => ( ( ord_less_eq @ A @ B3 @ C3 )
           => ( ord_less_eq @ A @ A2 @ C3 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_192_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y2: A,X: A] :
          ( ( ord_less_eq @ A @ Y2 @ X )
         => ( ( ord_less_eq @ A @ X @ Y2 )
            = ( X = Y2 ) ) ) ) )).

% antisym_conv
thf(fact_193_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A,Z4: A] :
          ( ( ( ord_less_eq @ A @ X @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z4 ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X )
             => ~ ( ord_less_eq @ A @ X @ Z4 ) )
           => ( ( ( ord_less_eq @ A @ X @ Z4 )
               => ~ ( ord_less_eq @ A @ Z4 @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z4 @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z4 )
                   => ~ ( ord_less_eq @ A @ Z4 @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z4 @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y2 ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_194_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ A @ B3 @ C3 )
           => ( ord_less_eq @ A @ A2 @ C3 ) ) ) ) )).

% order.trans
thf(fact_195_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% le_cases
thf(fact_196_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( X = Y2 )
         => ( ord_less_eq @ A @ X @ Y2 ) ) ) )).

% eq_refl
thf(fact_197_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X ) ) ) )).

% linear
thf(fact_198_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y2: A] :
          ( ( ord_less_eq @ A @ X @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X )
           => ( X = Y2 ) ) ) ) )).

% antisym
thf(fact_199_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [X2: A,Y: A] :
              ( ( ord_less_eq @ A @ X2 @ Y )
              & ( ord_less_eq @ A @ Y @ X2 ) ) ) ) ) )).

% eq_iff
thf(fact_200_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > B ),C3: B] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ( F @ B3 )
              = C3 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ B @ ( F @ A2 ) @ C3 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_201_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C3: B] :
          ( ( A2
            = ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C3 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C3 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_202_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B3: A,F: ( A > C ),C3: C] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ( ord_less_eq @ C @ ( F @ B3 ) @ C3 )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ C @ ( F @ A2 ) @ C3 ) ) ) ) ) )).

% order_subst2
thf(fact_203_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B > A ),B3: B,C3: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B3 ) )
         => ( ( ord_less_eq @ B @ B3 @ C3 )
           => ( ! [X3: B,Y3: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C3 ) ) ) ) ) ) )).

% order_subst1
thf(fact_204_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B )] :
            ! [X2: A] :
              ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) )).

% le_fun_def
thf(fact_205_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B )] :
          ( ! [X3: A] :
              ( ord_less_eq @ B @ ( F @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G ) ) ) )).

% le_funI
thf(fact_206_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funE
thf(fact_207_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G @ X ) ) ) ) )).

% le_funD
thf(fact_208_splay__max_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [La: ( tree @ A ),A2: A] :
          ( ( splay_splay_max @ A @ ( node @ A @ La @ A2 @ ( leaf @ A ) ) )
          = ( node @ A @ La @ A2 @ ( leaf @ A ) ) ) ) )).

% splay_max.simps(2)
thf(fact_209_splay__max__Leaf,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),L2: ( tree @ A ),A2: A,R2: ( tree @ A )] :
          ( ( ( splay_splay_max @ A @ T )
            = ( node @ A @ L2 @ A2 @ R2 ) )
         => ( R2
            = ( leaf @ A ) ) ) ) )).

% splay_max_Leaf
thf(fact_210_splay_Osimps_I13_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,B3: A,La: ( tree @ A ),Lb: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ B3 @ X )
           => ( ( splay_splay @ A @ X @ ( node @ A @ La @ A2 @ ( node @ A @ Lb @ B3 @ ( leaf @ A ) ) ) )
              = ( node @ A @ ( node @ A @ La @ A2 @ Lb ) @ B3 @ ( leaf @ A ) ) ) ) ) ) )).

% splay.simps(13)
thf(fact_211_splay_Osimps_I12_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,B3: A,La: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B3 )
           => ( ( splay_splay @ A @ X @ ( node @ A @ La @ A2 @ ( node @ A @ ( leaf @ A ) @ B3 @ Rb ) ) )
              = ( node @ A @ ( node @ A @ La @ A2 @ ( leaf @ A ) ) @ B3 @ Rb ) ) ) ) ) )).

% splay.simps(12)
thf(fact_212_splay_Osimps_I10_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,L2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( splay_splay @ A @ X @ ( node @ A @ L2 @ A2 @ ( leaf @ A ) ) )
            = ( node @ A @ L2 @ A2 @ ( leaf @ A ) ) ) ) ) )).

% splay.simps(10)
thf(fact_213_splay_Osimps_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,B3: A,A2: A,La: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ X @ B3 )
         => ( ( ord_less @ A @ A2 @ X )
           => ( ( splay_splay @ A @ X @ ( node @ A @ ( node @ A @ La @ A2 @ ( leaf @ A ) ) @ B3 @ Rb ) )
              = ( node @ A @ La @ A2 @ ( node @ A @ ( leaf @ A ) @ B3 @ Rb ) ) ) ) ) ) )).

% splay.simps(7)
thf(fact_214_splay_Osimps_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,A2: A,B3: A,Ra2: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ X @ B3 )
           => ( ( splay_splay @ A @ X @ ( node @ A @ ( node @ A @ ( leaf @ A ) @ A2 @ Ra2 ) @ B3 @ Rb ) )
              = ( node @ A @ ( leaf @ A ) @ A2 @ ( node @ A @ Ra2 @ B3 @ Rb ) ) ) ) ) ) )).

% splay.simps(5)
thf(fact_215_splay_Osimps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( splay_splay @ A @ A2 @ ( node @ A @ ( leaf @ A ) @ B3 @ R2 ) )
            = ( node @ A @ ( leaf @ A ) @ B3 @ R2 ) ) ) ) )).

% splay.simps(4)
thf(fact_216_splay__max__eq__splay__ex,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A )] :
          ( ( linorder_bst @ A @ T )
         => ? [A6: A] :
              ( ( splay_splay_max @ A @ T )
              = ( splay_splay @ A @ A6 @ T ) ) ) ) )).

% splay_max_eq_splay_ex
thf(fact_217_bst_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( tree @ A ),A2: A,R2: ( tree @ A )] :
          ( ( linorder_bst @ A @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( ( linorder_bst @ A @ L2 )
            & ( linorder_bst @ A @ R2 )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set_tree @ A @ L2 ) )
               => ( ord_less @ A @ X2 @ A2 ) )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set_tree @ A @ R2 ) )
               => ( ord_less @ A @ A2 @ X2 ) ) ) ) ) )).

% bst.simps(2)
thf(fact_218_bst_Oelims_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ~ ( linorder_bst @ A @ X )
         => ~ ( ! [L: ( tree @ A ),A6: A,R: ( tree @ A )] :
                  ( ( X
                    = ( node @ A @ L @ A6 @ R ) )
                 => ( ( linorder_bst @ A @ L )
                    & ( linorder_bst @ A @ R )
                    & ! [X3: A] :
                        ( ( member @ A @ X3 @ ( set_tree @ A @ L ) )
                       => ( ord_less @ A @ X3 @ A6 ) )
                    & ! [X3: A] :
                        ( ( member @ A @ X3 @ ( set_tree @ A @ R ) )
                       => ( ord_less @ A @ A6 @ X3 ) ) ) ) ) ) ) )).

% bst.elims(3)
thf(fact_219_splay__bstR,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A,L2: ( tree @ A ),E: A,R2: ( tree @ A ),X: A] :
          ( ( linorder_bst @ A @ T )
         => ( ( ( splay_splay @ A @ A2 @ T )
              = ( node @ A @ L2 @ E @ R2 ) )
           => ( ( member @ A @ X @ ( set_tree @ A @ R2 ) )
             => ( ord_less @ A @ A2 @ X ) ) ) ) ) )).

% splay_bstR
thf(fact_220_splay__bstL,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( tree @ A ),A2: A,L2: ( tree @ A ),E: A,R2: ( tree @ A ),X: A] :
          ( ( linorder_bst @ A @ T )
         => ( ( ( splay_splay @ A @ A2 @ T )
              = ( node @ A @ L2 @ E @ R2 ) )
           => ( ( member @ A @ X @ ( set_tree @ A @ L2 ) )
             => ( ord_less @ A @ X @ A2 ) ) ) ) ) )).

% splay_bstL
thf(fact_221_minf_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z )
         => ~ ( ord_less_eq @ A @ T @ X4 ) ) ) )).

% minf(8)
thf(fact_222_minf_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ X4 @ Z )
         => ( ord_less_eq @ A @ X4 @ T ) ) ) )).

% minf(6)
thf(fact_223_pinf_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z @ X4 )
         => ( ord_less_eq @ A @ T @ X4 ) ) ) )).

% pinf(8)
thf(fact_224_pinf_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: A] :
        ? [Z: A] :
        ! [X4: A] :
          ( ( ord_less @ A @ Z @ X4 )
         => ~ ( ord_less_eq @ A @ X4 @ T ) ) ) )).

% pinf(6)
thf(fact_225_complete__interval,axiom,(
    ! [A: $tType] :
      ( ( condit1037483654norder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,P: ( A > $o )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B3 )
             => ? [C2: A] :
                  ( ( ord_less_eq @ A @ A2 @ C2 )
                  & ( ord_less_eq @ A @ C2 @ B3 )
                  & ! [X4: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X4 )
                        & ( ord_less @ A @ X4 @ C2 ) )
                     => ( P @ X4 ) )
                  & ! [D: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X3 )
                            & ( ord_less @ A @ X3 @ D ) )
                         => ( P @ X3 ) )
                     => ( ord_less_eq @ A @ D @ C2 ) ) ) ) ) ) ) )).

% complete_interval
thf(fact_226_t__splay__simps_I9_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A,Rr2: ( tree @ A ),L2: ( tree @ A ),Rl2: ( tree @ A )] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( ord_less @ A @ C3 @ A2 )
           => ( ( ( Rr2
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B3 @ ( node @ A @ Rl2 @ C3 @ Rr2 ) ) )
                  = ( one_one @ nat ) ) )
              & ( ( Rr2
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B3 @ ( node @ A @ Rl2 @ C3 @ Rr2 ) ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Rr2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(9)
thf(fact_227_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = ( plus_plus @ A @ C3 @ A2 ) )
          = ( B3 = C3 ) ) ) )).

% add_right_cancel
thf(fact_228_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ A2 @ C3 ) )
          = ( B3 = C3 ) ) ) )).

% add_left_cancel
thf(fact_229_predicate2I,axiom,(
    ! [B: $tType,A: $tType,P: ( A > B > $o ),Q: ( A > B > $o )] :
      ( ! [X3: A,Y3: B] :
          ( ( P @ X3 @ Y3 )
         => ( Q @ X3 @ Y3 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) )).

% predicate2I
thf(fact_230_add__le__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C3: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C3 ) @ ( plus_plus @ A @ B3 @ C3 ) )
          = ( ord_less_eq @ A @ A2 @ B3 ) ) ) )).

% add_le_cancel_right
thf(fact_231_add__le__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C3: A,A2: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C3 @ A2 ) @ ( plus_plus @ A @ C3 @ B3 ) )
          = ( ord_less_eq @ A @ A2 @ B3 ) ) ) )).

% add_le_cancel_left
thf(fact_232_add__less__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C3: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C3 ) @ ( plus_plus @ A @ B3 @ C3 ) )
          = ( ord_less @ A @ A2 @ B3 ) ) ) )).

% add_less_cancel_right
thf(fact_233_add__less__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C3: A,A2: A,B3: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C3 @ A2 ) @ ( plus_plus @ A @ C3 @ B3 ) )
          = ( ord_less @ A @ A2 @ B3 ) ) ) )).

% add_less_cancel_left
thf(fact_234_t__splay__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A,Ll: ( tree @ A ),Lr: ( tree @ A ),R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less @ A @ A2 @ C3 )
           => ( ( ( Ll
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C3 @ Lr ) @ B3 @ R2 ) )
                  = ( one_one @ nat ) ) )
              & ( ( Ll
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C3 @ Lr ) @ B3 @ R2 ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Ll ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(4)
thf(fact_235_t__splay__simps_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A,Lr: ( tree @ A ),Ll: ( tree @ A ),R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B3 )
         => ( ( ord_less @ A @ C3 @ A2 )
           => ( ( ( Lr
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C3 @ Lr ) @ B3 @ R2 ) )
                  = ( one_one @ nat ) ) )
              & ( ( Lr
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C3 @ Lr ) @ B3 @ R2 ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Lr ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(5)
thf(fact_236_t__splay__simps_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A,Rl2: ( tree @ A ),L2: ( tree @ A ),Rr2: ( tree @ A )] :
          ( ( ord_less @ A @ B3 @ A2 )
         => ( ( ord_less @ A @ A2 @ C3 )
           => ( ( ( Rl2
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B3 @ ( node @ A @ Rl2 @ C3 @ Rr2 ) ) )
                  = ( one_one @ nat ) ) )
              & ( ( Rl2
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B3 @ ( node @ A @ Rl2 @ C3 @ Rr2 ) ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Rl2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(8)
thf(fact_237_predicate2D,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),Q: ( A > B > $o ),X: A,Y2: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X @ Y2 )
       => ( Q @ X @ Y2 ) ) ) )).

% predicate2D
thf(fact_238_less__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: ( A > B ),G2: ( A > B )] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F3 ) ) ) ) ) )).

% less_fun_def
thf(fact_239_rev__predicate2D,axiom,(
    ! [A: $tType,B: $tType,P: ( A > B > $o ),X: A,Y2: B,Q: ( A > B > $o )] :
      ( ( P @ X @ Y2 )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X @ Y2 ) ) ) )).

% rev_predicate2D
thf(fact_240_is__num__normalize_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B3 ) @ C3 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% is_num_normalize(1)
thf(fact_241_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = ( plus_plus @ A @ C3 @ A2 ) )
         => ( B3 = C3 ) ) ) )).

% add_right_imp_eq
thf(fact_242_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ A2 @ C3 ) )
         => ( B3 = C3 ) ) ) )).

% add_left_imp_eq
thf(fact_243_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( plus_plus @ A @ B3 @ ( plus_plus @ A @ A2 @ C3 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% add.left_commute
thf(fact_244_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] :
              ( plus_plus @ A @ B4 @ A5 ) ) ) ) )).

% add.commute
thf(fact_245_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C3: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = ( plus_plus @ A @ C3 @ A2 ) )
          = ( B3 = C3 ) ) ) )).

% add.right_cancel
thf(fact_246_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ A2 @ C3 ) )
          = ( B3 = C3 ) ) ) )).

% add.left_cancel
thf(fact_247_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B3 ) @ C3 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% add.assoc
thf(fact_248_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( I = J )
            & ( K = L2 ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L2 ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_249_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B3 ) @ C3 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_250_add__le__imp__le__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C3: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C3 ) @ ( plus_plus @ A @ B3 @ C3 ) )
         => ( ord_less_eq @ A @ A2 @ B3 ) ) ) )).

% add_le_imp_le_right
thf(fact_251_add__le__imp__le__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C3: A,A2: A,B3: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C3 @ A2 ) @ ( plus_plus @ A @ C3 @ B3 ) )
         => ( ord_less_eq @ A @ A2 @ B3 ) ) ) )).

% add_le_imp_le_left
thf(fact_252_le__iff__add,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A5: A,B4: A] :
            ? [C4: A] :
              ( B4
              = ( plus_plus @ A @ A5 @ C4 ) ) ) ) ) )).

% le_iff_add
thf(fact_253_add__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C3: A] :
          ( ( ord_less_eq @ A @ A2 @ B3 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C3 ) @ ( plus_plus @ A @ B3 @ C3 ) ) ) ) )).

% add_right_mono

%----Subclasses (4)
thf(subcl_Orderings_Olinorder___HOL_Otype,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( type @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oord,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ord @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( order @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Opreorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( preorder @ A @ ( type2 @ A ) ) ) )).

%----Type constructors (44)
thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( preorder @ A8 @ ( type2 @ A8 ) )
     => ( preorder @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order @ A8 @ ( type2 @ A8 ) )
     => ( order @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    ( condit1037483654norder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ( ordere236663937imp_le @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    ( wellorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_1,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Ono__top,axiom,
    ( no_top @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_2,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_3,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oone,axiom,
    ( one @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_4,axiom,(
    ! [A7: $tType] :
      ( preorder @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_5,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_6,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_7,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_8,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_9,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_10,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_11,axiom,
    ( condit1037483654norder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_12,axiom,
    ( ordere236663937imp_le @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_13,axiom,
    ( ordere779506340up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_14,axiom,
    ( cancel_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_15,axiom,
    ( linordered_semidom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Odense__linorder,axiom,
    ( dense_linorder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_16,axiom,
    ( ab_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Odense__order,axiom,
    ( dense_order @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_17,axiom,
    ( semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Opreorder_18,axiom,
    ( preorder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Olinorder_19,axiom,
    ( linorder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ( ln @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Ono__top_20,axiom,
    ( no_top @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Ono__bot,axiom,
    ( no_bot @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ogroup__add,axiom,
    ( group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Oorder_21,axiom,
    ( order @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Num_Oneg__numeral,axiom,
    ( neg_numeral @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Oord_22,axiom,
    ( ord @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oone_23,axiom,
    ( one @ real @ ( type2 @ real ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y2: A] :
      ( ( if @ A @ $false @ X @ Y2 )
      = Y2 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y2: A] :
      ( ( if @ A @ $true @ X @ Y2 )
      = X ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type2 @ a ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ! [La2: ( tree @ a ),Ra3: ( tree @ a )] :
      ( ( member @ ( tree @ a ) @ ( node @ a @ La2 @ a2 @ Ra3 ) @ ( subtrees @ a @ t ) )
     => thesis ) )).

thf(conj_1,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
