%------------------------------------------------------------------------------
% File     : DAT214^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Splay tree analysis 231
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Nip14] Nipkow (2014), Amortized Complexity Verified
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : splay_tree_analysis__231.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  416 (   0 unit;  80 type;   0 defn)
%            Number of atoms       : 4593 ( 320 equality;2194 variable)
%            Maximal formula depth :   24 (   8 average)
%            Number of connectives : 3902 (  88   ~;   4   |;  24   &;3425   @)
%                                         (   0 <=>; 361  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  136 ( 136   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   84 (  80   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  852 (   1 sgn; 759   !;  17   ?;  15   ^)
%                                         ( 852   :;  61  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:50:17.933
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Splay__Tree__Analysis__Base_Oop_092_060_094sub_062s_092_060_094sub_062t,type,(
    splay_2011811431op_s_t: $tType > $tType )).

thf(ty_t_Code__Numeral_Onatural,type,(
    code_natural: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Tree_Otree,type,(
    tree: $tType > $tType )).

thf(ty_t_Real_Oreal,type,(
    real: $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (71)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osize,type,(
    size: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Transcendental_Oln,type,(
    ln: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__neq__one,type,(
    zero_neq_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__less__one,type,(
    zero_less_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring__1,type,(
    comm_semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__add,type,(
    comm_monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,(
    linord219039673up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,(
    ordere216010020id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,(
    linord1659791738miring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,(
    strict797366125id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,(
    ordere236663937imp_le: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,(
    ordere223160158up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,(
    strict2144017051up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,(
    ordere516151231imp_le: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,(
    semiri456707255roduct: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,(
    code_case_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,(
    code_rec_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Osize__natural,type,(
    code_size_natural: code_natural > nat )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_Obool_Osize__bool,type,(
    size_bool: $o > nat )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,(
    neg_numeral_dbl_dec: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,(
    neg_numeral_dbl_inc: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,(
    set_fo292404081st_nat: 
      !>[A: $tType] :
        ( ( nat > A > A ) > nat > nat > A > A ) )).

thf(sy_c_Splay__Tree_Osplay,type,(
    splay_splay: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Splay__Tree_Osplay__max,type,(
    splay_splay_max: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Splay__Tree__Analysis__Base_Ot__splay,type,(
    splay_914434265_splay: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > nat ) )).

thf(sy_c_Splay__Tree__Analysis__Base_Ot__splay__max,type,(
    splay_878424299ay_max: 
      !>[A: $tType] :
        ( ( tree @ A ) > nat ) )).

thf(sy_c_Splay__Tree__Analysis__Base_Ot__splay__max__rel,type,(
    splay_1816415694ax_rel: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) > $o ) )).

thf(sy_c_Splay__Tree__Analysis__Mirabelle__pcaxyvimtd_OA,type,(
    splay_266122055elle_A: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > real ) )).

thf(sy_c_Transcendental_Oln__class_Oln,type,(
    ln_ln: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Transcendental_Opowr,type,(
    powr: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Tree_Olinorder__class_Obst,type,(
    linorder_bst: 
      !>[A: $tType] :
        ( ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Opath__len,type,(
    path_len: 
      !>[A: $tType] :
        ( ( tree @ A ) > nat ) )).

thf(sy_c_Tree_Opath__len__rel,type,(
    path_len_rel: 
      !>[A: $tType] :
        ( ( tree @ A ) > ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Osize1,type,(
    size1: 
      !>[A: $tType] :
        ( ( tree @ A ) > nat ) )).

thf(sy_c_Tree_Otree_OLeaf,type,(
    leaf: 
      !>[A: $tType] :
        ( tree @ A ) )).

thf(sy_c_Tree_Otree_ONode,type,(
    node: 
      !>[A: $tType] :
        ( ( tree @ A ) > A > ( tree @ A ) > ( tree @ A ) ) )).

thf(sy_c_Tree_Otree_Osize__tree,type,(
    size_tree: 
      !>[A: $tType] :
        ( ( A > nat ) > ( tree @ A ) > nat ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_v_b____,type,(
    b: a )).

thf(sy_v_c____,type,(
    c: a )).

thf(sy_v_l_H____,type,(
    l: ( tree @ a ) )).

thf(sy_v_l____,type,(
    l2: ( tree @ a ) )).

thf(sy_v_r_H____,type,(
    r: ( tree @ a ) )).

thf(sy_v_rl____,type,(
    rl: ( tree @ a ) )).

thf(sy_v_rr____,type,(
    rr: ( tree @ a ) )).

thf(sy_v_u____,type,(
    u: a )).

%----Relevant facts (253)
thf(fact_0__092_060open_062size_Arr_A_061_Asize_A_Isplay__max_Arr_J_092_060close_062,axiom,
    ( ( size_size @ ( tree @ a ) @ rr )
    = ( size_size @ ( tree @ a ) @ ( splay_splay_max @ a @ rr ) ) )).

% \<open>size rr = size (splay_max rr)\<close>
thf(fact_1_sp,axiom,
    ( ( splay_splay_max @ a @ rr )
    = ( node @ a @ l @ u @ r ) )).

% sp
thf(fact_2__092_060open_062_092_060And_062thesis_O_A_I_092_060And_062l_H_Au_Ar_H_O_Asplay__max_Arr_A_061_A_092_060langle_062l_H_M_Au_M_Ar_H_092_060rangle_062_A_092_060Longrightarrow_062_Athesis_J_A_092_060Longrightarrow_062_Athesis_092_060close_062,axiom,(
    ~ ( ! [L: ( tree @ a ),U: a,R: ( tree @ a )] :
          ( ( splay_splay_max @ a @ rr )
         != ( node @ a @ L @ U @ R ) ) ) )).

% \<open>\<And>thesis. (\<And>l' u r'. splay_max rr = \<langle>l', u, r'\<rangle> \<Longrightarrow> thesis) \<Longrightarrow> thesis\<close>
thf(fact_3__092_060open_062rr_A_092_060noteq_062_A_092_060langle_062_092_060rangle_062_092_060close_062,axiom,(
    rr
 != ( leaf @ a ) )).

% \<open>rr \<noteq> \<langle>\<rangle>\<close>
thf(fact_4_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
          = ( B = C ) ) ) )).

% add_left_cancel
thf(fact_5_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
          = ( B = C ) ) ) )).

% add_right_cancel
thf(fact_6_size__if__splay__max,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A ),L2: ( tree @ A ),U2: A,R2: ( tree @ A )] :
          ( ( ( splay_splay_max @ A @ T2 )
            = ( node @ A @ L2 @ U2 @ R2 ) )
         => ( ( size_size @ ( tree @ A ) @ T2 )
            = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_size @ ( tree @ A ) @ L2 ) @ ( size_size @ ( tree @ A ) @ R2 ) ) @ ( one_one @ nat ) ) ) ) ) )).

% size_if_splay_max
thf(fact_7_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) )).

% one_natural.rsp
thf(fact_8_size__ne__size__imp__ne,axiom,(
    ! [A: $tType] :
      ( ( size @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) )).

% size_ne_size_imp_ne
thf(fact_9_nat__add__left__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ K @ M )
        = ( plus_plus @ nat @ K @ N ) )
      = ( M = N ) ) )).

% nat_add_left_cancel
thf(fact_10_nat__add__right__cancel,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ K )
        = ( plus_plus @ nat @ N @ K ) )
      = ( M = N ) ) )).

% nat_add_right_cancel
thf(fact_11_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_12_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_13_is__num__normalize_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% is_num_normalize(1)
thf(fact_14_linordered__field__class_Osign__simps_I28_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( plus_plus @ A @ B @ ( plus_plus @ A @ A2 @ C ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% linordered_field_class.sign_simps(28)
thf(fact_15_splay__max__Leaf__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A )] :
          ( ( ( splay_splay_max @ A @ T2 )
            = ( leaf @ A ) )
          = ( T2
            = ( leaf @ A ) ) ) ) )).

% splay_max_Leaf_iff
thf(fact_16_splay__max_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [La: ( tree @ A ),A2: A] :
          ( ( splay_splay_max @ A @ ( node @ A @ La @ A2 @ ( leaf @ A ) ) )
          = ( node @ A @ La @ A2 @ ( leaf @ A ) ) ) ) )).

% splay_max.simps(2)
thf(fact_17_splay__max_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( splay_splay_max @ A @ ( leaf @ A ) )
        = ( leaf @ A ) ) ) )).

% splay_max.simps(1)
thf(fact_18_splay__max__Leaf,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A ),L2: ( tree @ A ),A2: A,R2: ( tree @ A )] :
          ( ( ( splay_splay_max @ A @ T2 )
            = ( node @ A @ L2 @ A2 @ R2 ) )
         => ( R2
            = ( leaf @ A ) ) ) ) )).

% splay_max_Leaf
thf(fact_19_size__splay__max,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A )] :
          ( ( size_size @ ( tree @ A ) @ ( splay_splay_max @ A @ T2 ) )
          = ( size_size @ ( tree @ A ) @ T2 ) ) ) )).

% size_splay_max
thf(fact_20_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
         => ( B = C ) ) ) )).

% add_right_imp_eq
thf(fact_21_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
         => ( B = C ) ) ) )).

% add_left_imp_eq
thf(fact_22_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( plus_plus @ A @ B @ ( plus_plus @ A @ A2 @ C ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add.left_commute
thf(fact_23_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B2: A] :
              ( plus_plus @ A @ B2 @ A3 ) ) ) ) )).

% add.commute
thf(fact_24_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
          = ( B = C ) ) ) )).

% add.right_cancel
thf(fact_25_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
          = ( B = C ) ) ) )).

% add.left_cancel
thf(fact_26_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add.assoc
thf(fact_27_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( I = J )
            & ( K = L2 ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L2 ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_28_linordered__field__class_Osign__simps_I26_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% linordered_field_class.sign_simps(26)
thf(fact_29_linordered__field__class_Osign__simps_I27_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B2: A] :
              ( plus_plus @ A @ B2 @ A3 ) ) ) ) )).

% linordered_field_class.sign_simps(27)
thf(fact_30__C3_Oprems_C_I2_J,axiom,(
    ( node @ a @ l2 @ b @ ( node @ a @ rl @ c @ rr ) )
 != ( leaf @ a ) )).

% "3.prems"(2)
thf(fact_31_tree_Oinject,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A ),Y21: ( tree @ A ),Y22: A,Y23: ( tree @ A )] :
      ( ( ( node @ A @ X21 @ X22 @ X23 )
        = ( node @ A @ Y21 @ Y22 @ Y23 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 ) ) ) )).

% tree.inject
thf(fact_32_tree_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: ( tree @ A ),X22: A,X23: ( tree @ A )] :
      ( ( leaf @ A )
     != ( node @ A @ X21 @ X22 @ X23 ) ) )).

% tree.distinct(1)
thf(fact_33_tree_Oinduct,axiom,(
    ! [A: $tType,P: ( ( tree @ A ) > $o ),Tree: ( tree @ A )] :
      ( ( P @ ( leaf @ A ) )
     => ( ! [X1: ( tree @ A ),X2: A,X3: ( tree @ A )] :
            ( ( P @ X1 )
           => ( ( P @ X3 )
             => ( P @ ( node @ A @ X1 @ X2 @ X3 ) ) ) )
       => ( P @ Tree ) ) ) )).

% tree.induct
thf(fact_34_neq__Leaf__iff,axiom,(
    ! [A: $tType,T2: ( tree @ A )] :
      ( ( T2
       != ( leaf @ A ) )
      = ( ? [L3: ( tree @ A ),A3: A,R3: ( tree @ A )] :
            ( T2
            = ( node @ A @ L3 @ A3 @ R3 ) ) ) ) )).

% neq_Leaf_iff
thf(fact_35_tree_Oexhaust,axiom,(
    ! [A: $tType,Y: ( tree @ A )] :
      ( ( Y
       != ( leaf @ A ) )
     => ~ ( ! [X212: ( tree @ A ),X222: A,X232: ( tree @ A )] :
              ( Y
             != ( node @ A @ X212 @ X222 @ X232 ) ) ) ) )).

% tree.exhaust
thf(fact_36_mirror_Oinduct,axiom,(
    ! [A: $tType,P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
      ( ( P @ ( leaf @ A ) )
     => ( ! [L4: ( tree @ A ),X4: A,R4: ( tree @ A )] :
            ( ( P @ R4 )
           => ( ( P @ L4 )
             => ( P @ ( node @ A @ L4 @ X4 @ R4 ) ) ) )
       => ( P @ A0 ) ) ) )).

% mirror.induct
thf(fact_37_bst__eq_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ( X
           != ( leaf @ A ) )
         => ~ ( ! [L4: ( tree @ A ),A4: A,R4: ( tree @ A )] :
                  ( X
                 != ( node @ A @ L4 @ A4 @ R4 ) ) ) ) ) )).

% bst_eq.cases
thf(fact_38_bst__eq_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
          ( ( P @ ( leaf @ A ) )
         => ( ! [L4: ( tree @ A ),A4: A,R4: ( tree @ A )] :
                ( ( P @ L4 )
               => ( ( P @ R4 )
                 => ( P @ ( node @ A @ L4 @ A4 @ R4 ) ) ) )
           => ( P @ A0 ) ) ) ) )).

% bst_eq.induct
thf(fact_39__092_060Phi_062_Ocases,axiom,(
    ! [A: $tType,X: ( tree @ A )] :
      ( ( X
       != ( leaf @ A ) )
     => ~ ( ! [L4: ( tree @ A ),A4: A,R4: ( tree @ A )] :
              ( X
             != ( node @ A @ L4 @ A4 @ R4 ) ) ) ) )).

% \<Phi>.cases
thf(fact_40__C3_Oprems_C_I1_J,axiom,
    ( linorder_bst @ a @ ( node @ a @ l2 @ b @ ( node @ a @ rl @ c @ rr ) ) )).

% "3.prems"(1)
thf(fact_41_t__splay__max_Oinduct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
          ( ( P @ ( leaf @ A ) )
         => ( ! [L4: ( tree @ A ),B3: A] :
                ( P @ ( node @ A @ L4 @ B3 @ ( leaf @ A ) ) )
           => ( ! [L4: ( tree @ A ),B3: A,Rl: ( tree @ A ),C2: A,Rr: ( tree @ A )] :
                  ( ( ( Rr
                     != ( leaf @ A ) )
                   => ( P @ Rr ) )
                 => ( P @ ( node @ A @ L4 @ B3 @ ( node @ A @ Rl @ C2 @ Rr ) ) ) )
             => ( P @ A0 ) ) ) ) ) )).

% t_splay_max.induct
thf(fact_42_t__splay__max_Ocases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A )] :
          ( ( X
           != ( leaf @ A ) )
         => ( ! [L4: ( tree @ A ),B3: A] :
                ( X
               != ( node @ A @ L4 @ B3 @ ( leaf @ A ) ) )
           => ~ ( ! [L4: ( tree @ A ),B3: A,Rl: ( tree @ A ),C2: A,Rr: ( tree @ A )] :
                    ( X
                   != ( node @ A @ L4 @ B3 @ ( node @ A @ Rl @ C2 @ Rr ) ) ) ) ) ) ) )).

% t_splay_max.cases
thf(fact_43__092_060Phi_062_Oinduct,axiom,(
    ! [A: $tType,P: ( ( tree @ A ) > $o ),A0: ( tree @ A )] :
      ( ( P @ ( leaf @ A ) )
     => ( ! [L4: ( tree @ A ),A4: A,R4: ( tree @ A )] :
            ( ( P @ L4 )
           => ( ( P @ R4 )
             => ( P @ ( node @ A @ L4 @ A4 @ R4 ) ) ) )
       => ( P @ A0 ) ) ) )).

% \<Phi>.induct
thf(fact_44_ext,axiom,(
    ! [B4: $tType,A: $tType,F: ( A > B4 ),G: ( A > B4 )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_45_t__splay__max_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Rr2: ( tree @ A ),L2: ( tree @ A ),B: A,Rl2: ( tree @ A ),C: A] :
          ( ( ( Rr2
              = ( leaf @ A ) )
           => ( ( splay_878424299ay_max @ A @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ C @ Rr2 ) ) )
              = ( one_one @ nat ) ) )
          & ( ( Rr2
             != ( leaf @ A ) )
           => ( ( splay_878424299ay_max @ A @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ C @ Rr2 ) ) )
              = ( plus_plus @ nat @ ( splay_878424299ay_max @ A @ Rr2 ) @ ( one_one @ nat ) ) ) ) ) ) )).

% t_splay_max.simps(3)
thf(fact_46_t__splay__max_Oelims,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A ),Y: nat] :
          ( ( ( splay_878424299ay_max @ A @ X )
            = Y )
         => ( ( ( X
                = ( leaf @ A ) )
             => ( Y
               != ( one_one @ nat ) ) )
           => ( ( ? [L4: ( tree @ A ),B3: A] :
                    ( X
                    = ( node @ A @ L4 @ B3 @ ( leaf @ A ) ) )
               => ( Y
                 != ( one_one @ nat ) ) )
             => ~ ( ! [L4: ( tree @ A ),B3: A,Rl: ( tree @ A ),C2: A,Rr: ( tree @ A )] :
                      ( ( X
                        = ( node @ A @ L4 @ B3 @ ( node @ A @ Rl @ C2 @ Rr ) ) )
                     => ~ ( ( ( Rr
                              = ( leaf @ A ) )
                           => ( Y
                              = ( one_one @ nat ) ) )
                          & ( ( Rr
                             != ( leaf @ A ) )
                           => ( Y
                              = ( plus_plus @ nat @ ( splay_878424299ay_max @ A @ Rr ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ) ) )).

% t_splay_max.elims
thf(fact_47_path__len_Osimps_I2_J,axiom,(
    ! [A: $tType,L2: ( tree @ A ),Uu: A,R2: ( tree @ A )] :
      ( ( path_len @ A @ ( node @ A @ L2 @ Uu @ R2 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( path_len @ A @ L2 ) @ ( size_size @ ( tree @ A ) @ L2 ) ) @ ( path_len @ A @ R2 ) ) @ ( size_size @ ( tree @ A ) @ R2 ) ) ) )).

% path_len.simps(2)
thf(fact_48_t__splay__max_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [L2: ( tree @ A ),B: A] :
          ( ( splay_878424299ay_max @ A @ ( node @ A @ L2 @ B @ ( leaf @ A ) ) )
          = ( one_one @ nat ) ) ) )).

% t_splay_max.simps(2)
thf(fact_49_size__if__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,T2: ( tree @ A ),L2: ( tree @ A ),U2: A,R2: ( tree @ A )] :
          ( ( ( splay_splay @ A @ A2 @ T2 )
            = ( node @ A @ L2 @ U2 @ R2 ) )
         => ( ( size_size @ ( tree @ A ) @ T2 )
            = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_size @ ( tree @ A ) @ L2 ) @ ( size_size @ ( tree @ A ) @ R2 ) ) @ ( one_one @ nat ) ) ) ) ) )).

% size_if_splay
thf(fact_50_size1__def,axiom,(
    ! [A: $tType] :
      ( ( size1 @ A )
      = ( ^ [T3: ( tree @ A )] :
            ( plus_plus @ nat @ ( size_size @ ( tree @ A ) @ T3 ) @ ( one_one @ nat ) ) ) ) )).

% size1_def
thf(fact_51_dbl__inc__def,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X5: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ X5 @ X5 ) @ ( one_one @ A ) ) ) ) ) )).

% dbl_inc_def
thf(fact_52_t__splay__max_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( splay_878424299ay_max @ A @ ( leaf @ A ) )
        = ( one_one @ nat ) ) ) )).

% t_splay_max.simps(1)
thf(fact_53_splay__Leaf__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,T2: ( tree @ A )] :
          ( ( ( splay_splay @ A @ A2 @ T2 )
            = ( leaf @ A ) )
          = ( T2
            = ( leaf @ A ) ) ) ) )).

% splay_Leaf_iff
thf(fact_54_size__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,T2: ( tree @ A )] :
          ( ( size_size @ ( tree @ A ) @ ( splay_splay @ A @ A2 @ T2 ) )
          = ( size_size @ ( tree @ A ) @ T2 ) ) ) )).

% size_splay
thf(fact_55_size1__simps_I2_J,axiom,(
    ! [B4: $tType,L2: ( tree @ B4 ),X: B4,R2: ( tree @ B4 )] :
      ( ( size1 @ B4 @ ( node @ B4 @ L2 @ X @ R2 ) )
      = ( plus_plus @ nat @ ( size1 @ B4 @ L2 ) @ ( size1 @ B4 @ R2 ) ) ) )).

% size1_simps(2)
thf(fact_56_size1__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( size1 @ A @ ( leaf @ A ) )
      = ( one_one @ nat ) ) )).

% size1_simps(1)
thf(fact_57_bst__splay,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A ),A2: A] :
          ( ( linorder_bst @ A @ T2 )
         => ( linorder_bst @ A @ ( splay_splay @ A @ A2 @ T2 ) ) ) ) )).

% bst_splay
thf(fact_58_splay__max__eq__splay__ex,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A )] :
          ( ( linorder_bst @ A @ T2 )
         => ? [A4: A] :
              ( ( splay_splay_max @ A @ T2 )
              = ( splay_splay @ A @ A4 @ T2 ) ) ) ) )).

% splay_max_eq_splay_ex
thf(fact_59_splay_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,L2: ( tree @ A ),R2: ( tree @ A )] :
          ( ( splay_splay @ A @ A2 @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( node @ A @ L2 @ A2 @ R2 ) ) ) )).

% splay.simps(2)
thf(fact_60_splay_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( splay_splay @ A @ A2 @ ( leaf @ A ) )
          = ( leaf @ A ) ) ) )).

% splay.simps(1)
thf(fact_61_bst_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( linorder_bst @ A @ ( leaf @ A ) ) ) )).

% bst.simps(1)
thf(fact_62_bst__splay__max,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A )] :
          ( ( linorder_bst @ A @ T2 )
         => ( linorder_bst @ A @ ( splay_splay_max @ A @ T2 ) ) ) ) )).

% bst_splay_max
thf(fact_63_splay__not__Leaf,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T2: ( tree @ A ),A2: A] :
          ( ( T2
           != ( leaf @ A ) )
         => ? [L4: ( tree @ A ),X4: A,R4: ( tree @ A )] :
              ( ( splay_splay @ A @ A2 @ T2 )
              = ( node @ A @ L4 @ X4 @ R4 ) ) ) ) )).

% splay_not_Leaf
thf(fact_64_path__len_Oelims,axiom,(
    ! [A: $tType,X: ( tree @ A ),Y: nat] :
      ( ( ( path_len @ A @ X )
        = Y )
     => ( ( ( X
            = ( leaf @ A ) )
         => ( Y
           != ( zero_zero @ nat ) ) )
       => ~ ( ! [L4: ( tree @ A ),Uu2: A,R4: ( tree @ A )] :
                ( ( X
                  = ( node @ A @ L4 @ Uu2 @ R4 ) )
               => ( Y
                 != ( plus_plus @ nat @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( path_len @ A @ L4 ) @ ( size_size @ ( tree @ A ) @ L4 ) ) @ ( path_len @ A @ R4 ) ) @ ( size_size @ ( tree @ A ) @ R4 ) ) ) ) ) ) ) )).

% path_len.elims
thf(fact_65_A__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,L2: ( tree @ A ),R2: ( tree @ A )] :
          ( ( splay_266122055elle_A @ A @ A2 @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( one_one @ real ) ) ) )).

% A_simps(1)
thf(fact_66_t__splay__max_Opelims,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( tree @ A ),Y: nat] :
          ( ( ( splay_878424299ay_max @ A @ X )
            = Y )
         => ( ( accp @ ( tree @ A ) @ ( splay_1816415694ax_rel @ A ) @ X )
           => ( ( ( X
                  = ( leaf @ A ) )
               => ( ( Y
                    = ( one_one @ nat ) )
                 => ~ ( accp @ ( tree @ A ) @ ( splay_1816415694ax_rel @ A ) @ ( leaf @ A ) ) ) )
             => ( ! [L4: ( tree @ A ),B3: A] :
                    ( ( X
                      = ( node @ A @ L4 @ B3 @ ( leaf @ A ) ) )
                   => ( ( Y
                        = ( one_one @ nat ) )
                     => ~ ( accp @ ( tree @ A ) @ ( splay_1816415694ax_rel @ A ) @ ( node @ A @ L4 @ B3 @ ( leaf @ A ) ) ) ) )
               => ~ ( ! [L4: ( tree @ A ),B3: A,Rl: ( tree @ A ),C2: A,Rr: ( tree @ A )] :
                        ( ( X
                          = ( node @ A @ L4 @ B3 @ ( node @ A @ Rl @ C2 @ Rr ) ) )
                       => ( ( ( ( Rr
                                = ( leaf @ A ) )
                             => ( Y
                                = ( one_one @ nat ) ) )
                            & ( ( Rr
                               != ( leaf @ A ) )
                             => ( Y
                                = ( plus_plus @ nat @ ( splay_878424299ay_max @ A @ Rr ) @ ( one_one @ nat ) ) ) ) )
                         => ~ ( accp @ ( tree @ A ) @ ( splay_1816415694ax_rel @ A ) @ ( node @ A @ L4 @ B3 @ ( node @ A @ Rl @ C2 @ Rr ) ) ) ) ) ) ) ) ) ) ) )).

% t_splay_max.pelims
thf(fact_67_dbl__dec__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) )).

% dbl_dec_simps(3)
thf(fact_68_dbl__inc__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) )).

% dbl_inc_simps(2)
thf(fact_69_t__splay__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,L2: ( tree @ A ),R2: ( tree @ A )] :
          ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ A2 @ R2 ) )
          = ( one_one @ nat ) ) ) )).

% t_splay_simps(1)
thf(fact_70_splay_Osimps_I13_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,B: A,La: ( tree @ A ),Lb: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ B @ X )
           => ( ( splay_splay @ A @ X @ ( node @ A @ La @ A2 @ ( node @ A @ Lb @ B @ ( leaf @ A ) ) ) )
              = ( node @ A @ ( node @ A @ La @ A2 @ Lb ) @ B @ ( leaf @ A ) ) ) ) ) ) )).

% splay.simps(13)
thf(fact_71_natural_Osize_I3_J,axiom,
    ( ( size_size @ code_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(3)
thf(fact_72_neq0__conv,axiom,(
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) )).

% neq0_conv
thf(fact_73_nat__add__left__cancel__less,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) )).

% nat_add_left_cancel_less
thf(fact_74_not__gr__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) )).

% not_gr_zero
thf(fact_75_add_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.left_neutral
thf(fact_76_add_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.right_neutral
thf(fact_77_double__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero
thf(fact_78_double__zero__sym,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero_sym
thf(fact_79_add__cancel__left__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = A2 )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_left
thf(fact_80_add__cancel__left__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = A2 )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_right
thf(fact_81_add__cancel__right__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( A2
            = ( plus_plus @ A @ B @ A2 ) )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_left
thf(fact_82_add__cancel__right__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B ) )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_right
thf(fact_83_add__less__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
          = ( ord_less @ A @ A2 @ B ) ) ) )).

% add_less_cancel_left
thf(fact_84_add__less__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
          = ( ord_less @ A @ A2 @ B ) ) ) )).

% add_less_cancel_right
thf(fact_85_add__gr__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) )).

% add_gr_0
thf(fact_86_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) )).

% add_is_0
thf(fact_87_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) )).

% Nat.add_0_right
thf(fact_88_less__one,axiom,(
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) )).

% less_one
thf(fact_89_add__less__same__cancel1,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B @ A2 ) @ B )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% add_less_same_cancel1
thf(fact_90_add__less__same__cancel2,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B ) @ B )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% add_less_same_cancel2
thf(fact_91_less__add__same__cancel1,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B ) ) ) )).

% less_add_same_cancel1
thf(fact_92_less__add__same__cancel2,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B ) ) ) )).

% less_add_same_cancel2
thf(fact_93_double__add__less__zero__iff__single__add__less__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_94_zero__less__double__add__iff__zero__less__single__add,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) )).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_95_t__splay__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,Ll: ( tree @ A ),Lr: ( tree @ A ),R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ A2 @ Lr ) @ B @ R2 ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(3)
thf(fact_96_t__splay__simps_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,L2: ( tree @ A ),Rl2: ( tree @ A ),Rr2: ( tree @ A )] :
          ( ( ord_less @ A @ B @ A2 )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ A2 @ Rr2 ) ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(7)
thf(fact_97_t__splay__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( leaf @ A ) @ B @ R2 ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(2)
thf(fact_98_t__splay__simps_I6_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,L2: ( tree @ A )] :
          ( ( ord_less @ A @ B @ A2 )
         => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B @ ( leaf @ A ) ) )
            = ( one_one @ nat ) ) ) ) )).

% t_splay_simps(6)
thf(fact_99_t__splay__simps_I9_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A,Rr2: ( tree @ A ),L2: ( tree @ A ),Rl2: ( tree @ A )] :
          ( ( ord_less @ A @ B @ A2 )
         => ( ( ord_less @ A @ C @ A2 )
           => ( ( ( Rr2
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ C @ Rr2 ) ) )
                  = ( one_one @ nat ) ) )
              & ( ( Rr2
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ C @ Rr2 ) ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Rr2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(9)
thf(fact_100_t__splay__simps_I8_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A,Rl2: ( tree @ A ),L2: ( tree @ A ),Rr2: ( tree @ A )] :
          ( ( ord_less @ A @ B @ A2 )
         => ( ( ord_less @ A @ A2 @ C )
           => ( ( ( Rl2
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ C @ Rr2 ) ) )
                  = ( one_one @ nat ) ) )
              & ( ( Rl2
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ L2 @ B @ ( node @ A @ Rl2 @ C @ Rr2 ) ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Rl2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(8)
thf(fact_101_t__splay__simps_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,Lr: ( tree @ A ),Ll: ( tree @ A ),R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( ord_less @ A @ C @ A2 )
           => ( ( ( Lr
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C @ Lr ) @ B @ R2 ) )
                  = ( one_one @ nat ) ) )
              & ( ( Lr
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C @ Lr ) @ B @ R2 ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Lr ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(5)
thf(fact_102_t__splay__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,Ll: ( tree @ A ),Lr: ( tree @ A ),R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( ord_less @ A @ A2 @ C )
           => ( ( ( Ll
                  = ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C @ Lr ) @ B @ R2 ) )
                  = ( one_one @ nat ) ) )
              & ( ( Ll
                 != ( leaf @ A ) )
               => ( ( splay_914434265_splay @ A @ A2 @ ( node @ A @ ( node @ A @ Ll @ C @ Lr ) @ B @ R2 ) )
                  = ( plus_plus @ nat @ ( splay_914434265_splay @ A @ A2 @ Ll ) @ ( one_one @ nat ) ) ) ) ) ) ) ) )).

% t_splay_simps(4)
thf(fact_103_size1__ge0,axiom,(
    ! [A: $tType,T2: ( tree @ A )] :
      ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size1 @ A @ T2 ) ) )).

% size1_ge0
thf(fact_104_less__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% less_numeral_extra(3)
thf(fact_105_gr0I,axiom,(
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) )).

% gr0I
thf(fact_106_not__gr0,axiom,(
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) )).

% not_gr0
thf(fact_107_not__less0,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) )).

% not_less0
thf(fact_108_less__zeroE,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) )).

% less_zeroE
thf(fact_109_gr__implies__not0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) )).

% gr_implies_not0
thf(fact_110_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_111_infinite__descent0,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) )).

% infinite_descent0
thf(fact_112_less__nat__zero__code,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) )).

% less_nat_zero_code
thf(fact_113_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) )).

% zero_natural.rsp
thf(fact_114_infinite__descent0__measure,axiom,(
    ! [A: $tType,V: ( A > nat ),P: ( A > $o ),X: A] :
      ( ! [X4: A] :
          ( ( ( V @ X4 )
            = ( zero_zero @ nat ) )
         => ( P @ X4 ) )
     => ( ! [X4: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V @ X4 ) )
           => ( ~ ( P @ X4 )
             => ? [Y2: A] :
                  ( ( ord_less @ nat @ ( V @ Y2 ) @ ( V @ X4 ) )
                  & ~ ( P @ Y2 ) ) ) )
       => ( P @ X ) ) ) )).

% infinite_descent0_measure
thf(fact_115_linordered__field__no__lb,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X6: A] :
        ? [Y3: A] :
          ( ord_less @ A @ Y3 @ X6 ) ) )).

% linordered_field_no_lb
thf(fact_116_linordered__field__no__ub,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [X6: A] :
        ? [X1: A] :
          ( ord_less @ A @ X6 @ X1 ) ) )).

% linordered_field_no_ub
thf(fact_117_gr__zeroI,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) )).

% gr_zeroI
thf(fact_118_not__less__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) )).

% not_less_zero
thf(fact_119_gr__implies__not__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) )).

% gr_implies_not_zero
thf(fact_120_zero__less__iff__neq__zero,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( N
           != ( zero_zero @ A ) ) ) ) )).

% zero_less_iff_neq_zero
thf(fact_121_less__imp__add__positive,axiom,(
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I @ K2 )
            = J ) ) ) )).

% less_imp_add_positive
thf(fact_122_less__numeral__extra_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) )).

% less_numeral_extra(2)
thf(fact_123_less__numeral__extra_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) )).

% less_numeral_extra(1)
thf(fact_124_add__neg__neg,axiom,(
    ! [A: $tType] :
      ( ( ordere216010020id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B ) @ ( zero_zero @ A ) ) ) ) ) )).

% add_neg_neg
thf(fact_125_add__pos__pos,axiom,(
    ! [A: $tType] :
      ( ( ordere216010020id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B ) ) ) ) ) )).

% add_pos_pos
thf(fact_126_pos__add__strict,axiom,(
    ! [A: $tType] :
      ( ( strict797366125id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B @ C )
           => ( ord_less @ A @ B @ ( plus_plus @ A @ A2 @ C ) ) ) ) ) )).

% pos_add_strict
thf(fact_127_op_092_060_094sub_062s_092_060_094sub_062t_Osize__neq,axiom,(
    ! [A: $tType,X: ( splay_2011811431op_s_t @ A )] :
      ( ( size_size @ ( splay_2011811431op_s_t @ A ) @ X )
     != ( zero_zero @ nat ) ) )).

% op\<^sub>s\<^sub>t.size_neq
thf(fact_128_add__mono__thms__linordered__field_I5_J,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) )).

% add_mono_thms_linordered_field(5)
thf(fact_129_add__mono__thms__linordered__field_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( I = J )
            & ( ord_less @ A @ K @ L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) )).

% add_mono_thms_linordered_field(2)
thf(fact_130_add__mono__thms__linordered__field_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L2: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( K = L2 ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L2 ) ) ) ) )).

% add_mono_thms_linordered_field(1)
thf(fact_131_add__strict__mono,axiom,(
    ! [A: $tType] :
      ( ( strict2144017051up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( ord_less @ A @ C @ D )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) ) )).

% add_strict_mono
thf(fact_132_add__strict__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ord_less @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) ) ) ) )).

% add_strict_left_mono
thf(fact_133_add__strict__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add_strict_right_mono
thf(fact_134_add__less__imp__less__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
         => ( ord_less @ A @ A2 @ B ) ) ) )).

% add_less_imp_less_left
thf(fact_135_add__less__imp__less__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
         => ( ord_less @ A @ A2 @ B ) ) ) )).

% add_less_imp_less_right
thf(fact_136_less__numeral__extra_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) )).

% less_numeral_extra(4)
thf(fact_137_add__lessD1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
     => ( ord_less @ nat @ I @ K ) ) )).

% add_lessD1
thf(fact_138_add__less__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L2: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ K @ L2 )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L2 ) ) ) ) )).

% add_less_mono
thf(fact_139_not__add__less1,axiom,(
    ! [I: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ I ) )).

% not_add_less1
thf(fact_140_not__add__less2,axiom,(
    ! [J: nat,I: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I ) @ I ) )).

% not_add_less2
thf(fact_141_add__less__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) )).

% add_less_mono1
thf(fact_142_trans__less__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) )).

% trans_less_add1
thf(fact_143_trans__less__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) )).

% trans_less_add2
thf(fact_144_less__add__eq__less,axiom,(
    ! [K: nat,L2: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L2 )
     => ( ( ( plus_plus @ nat @ M @ L2 )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) )).

% less_add_eq_less
thf(fact_145_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_add_class.add_0
thf(fact_146_add_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.comm_neutral
thf(fact_147_add_Ogroup__left__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.group_left_neutral
thf(fact_148_add__eq__0__iff__both__eq__0,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_149_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_150_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) )).

% add_eq_self_zero
thf(fact_151_splay_Osimps_I9_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,Lb: ( tree @ A ),La: ( tree @ A ),Ra: ( tree @ A )] :
          ( ( ord_less @ A @ B @ A2 )
         => ( ( splay_splay @ A @ A2 @ ( node @ A @ Lb @ B @ ( node @ A @ La @ A2 @ Ra ) ) )
            = ( node @ A @ ( node @ A @ Lb @ B @ La ) @ A2 @ Ra ) ) ) ) )).

% splay.simps(9)
thf(fact_152_splay_Osimps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,La: ( tree @ A ),Ra: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( splay_splay @ A @ A2 @ ( node @ A @ ( node @ A @ La @ A2 @ Ra ) @ B @ Rb ) )
            = ( node @ A @ La @ A2 @ ( node @ A @ Ra @ B @ Rb ) ) ) ) ) )).

% splay.simps(3)
thf(fact_153_size__0__iff__Leaf,axiom,(
    ! [A: $tType,T2: ( tree @ A )] :
      ( ( ( size_size @ ( tree @ A ) @ T2 )
        = ( zero_zero @ nat ) )
      = ( T2
        = ( leaf @ A ) ) ) )).

% size_0_iff_Leaf
thf(fact_154_tree_Osize_I3_J,axiom,(
    ! [A: $tType] :
      ( ( size_size @ ( tree @ A ) @ ( leaf @ A ) )
      = ( zero_zero @ nat ) ) )).

% tree.size(3)
thf(fact_155_t__splay_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( splay_914434265_splay @ A @ A2 @ ( leaf @ A ) )
          = ( one_one @ nat ) ) ) )).

% t_splay.simps(1)
thf(fact_156_path__len_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( path_len @ A @ ( leaf @ A ) )
      = ( zero_zero @ nat ) ) )).

% path_len.simps(1)
thf(fact_157_splay_Osimps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,R2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( splay_splay @ A @ A2 @ ( node @ A @ ( leaf @ A ) @ B @ R2 ) )
            = ( node @ A @ ( leaf @ A ) @ B @ R2 ) ) ) ) )).

% splay.simps(4)
thf(fact_158_splay_Osimps_I5_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,A2: A,B: A,Ra: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ X @ B )
           => ( ( splay_splay @ A @ X @ ( node @ A @ ( node @ A @ ( leaf @ A ) @ A2 @ Ra ) @ B @ Rb ) )
              = ( node @ A @ ( leaf @ A ) @ A2 @ ( node @ A @ Ra @ B @ Rb ) ) ) ) ) ) )).

% splay.simps(5)
thf(fact_159_splay_Osimps_I7_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,B: A,A2: A,La: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ X @ B )
         => ( ( ord_less @ A @ A2 @ X )
           => ( ( splay_splay @ A @ X @ ( node @ A @ ( node @ A @ La @ A2 @ ( leaf @ A ) ) @ B @ Rb ) )
              = ( node @ A @ La @ A2 @ ( node @ A @ ( leaf @ A ) @ B @ Rb ) ) ) ) ) ) )).

% splay.simps(7)
thf(fact_160_splay_Osimps_I10_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,L2: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( splay_splay @ A @ X @ ( node @ A @ L2 @ A2 @ ( leaf @ A ) ) )
            = ( node @ A @ L2 @ A2 @ ( leaf @ A ) ) ) ) ) )).

% splay.simps(10)
thf(fact_161_splay_Osimps_I12_J,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [A2: A,X: A,B: A,La: ( tree @ A ),Rb: ( tree @ A )] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B )
           => ( ( splay_splay @ A @ X @ ( node @ A @ La @ A2 @ ( node @ A @ ( leaf @ A ) @ B @ Rb ) ) )
              = ( node @ A @ ( node @ A @ La @ A2 @ ( leaf @ A ) ) @ B @ Rb ) ) ) ) ) )).

% splay.simps(12)
thf(fact_162_path__len_Opelims,axiom,(
    ! [A: $tType,X: ( tree @ A ),Y: nat] :
      ( ( ( path_len @ A @ X )
        = Y )
     => ( ( accp @ ( tree @ A ) @ ( path_len_rel @ A ) @ X )
       => ( ( ( X
              = ( leaf @ A ) )
           => ( ( Y
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( tree @ A ) @ ( path_len_rel @ A ) @ ( leaf @ A ) ) ) )
         => ~ ( ! [L4: ( tree @ A ),Uu2: A,R4: ( tree @ A )] :
                  ( ( X
                    = ( node @ A @ L4 @ Uu2 @ R4 ) )
                 => ( ( Y
                      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( path_len @ A @ L4 ) @ ( size_size @ ( tree @ A ) @ L4 ) ) @ ( path_len @ A @ R4 ) ) @ ( size_size @ ( tree @ A ) @ R4 ) ) )
                   => ~ ( accp @ ( tree @ A ) @ ( path_len_rel @ A ) @ ( node @ A @ L4 @ Uu2 @ R4 ) ) ) ) ) ) ) ) )).

% path_len.pelims
thf(fact_163_zero__less__two,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type2 @ A ) )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) )).

% zero_less_two
thf(fact_164_less__add__one,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) )).

% less_add_one
thf(fact_165_zero__less__one,axiom,(
    ! [A: $tType] :
      ( ( zero_less_one @ A @ ( type2 @ A ) )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) )).

% zero_less_one
thf(fact_166_not__one__less__zero,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type2 @ A ) )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) )).

% not_one_less_zero
thf(fact_167_bool_Osize_I4_J,axiom,
    ( ( size_size @ $o @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(4)
thf(fact_168_bool_Osize_I3_J,axiom,
    ( ( size_size @ $o @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(3)
thf(fact_169_nat__neq__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( M != N )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) )).

% nat_neq_iff
thf(fact_170_less__not__refl,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) )).

% less_not_refl
thf(fact_171_less__not__refl2,axiom,(
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) )).

% less_not_refl2
thf(fact_172_less__not__refl3,axiom,(
    ! [S: nat,T2: nat] :
      ( ( ord_less @ nat @ S @ T2 )
     => ( S != T2 ) ) )).

% less_not_refl3
thf(fact_173_measure__induct,axiom,(
    ! [A: $tType,F: ( A > nat ),P: ( A > $o ),A2: A] :
      ( ! [X4: A] :
          ( ! [Y2: A] :
              ( ( ord_less @ nat @ ( F @ Y2 ) @ ( F @ X4 ) )
             => ( P @ Y2 ) )
         => ( P @ X4 ) )
     => ( P @ A2 ) ) )).

% measure_induct
thf(fact_174_less__irrefl__nat,axiom,(
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) )).

% less_irrefl_nat
thf(fact_175_nat__less__induct,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) )).

% nat_less_induct
thf(fact_176_infinite__descent,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) )).

% infinite_descent
thf(fact_177_linorder__neqE__nat,axiom,(
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less @ nat @ X @ Y )
       => ( ord_less @ nat @ Y @ X ) ) ) )).

% linorder_neqE_nat
thf(fact_178_measure__induct__rule,axiom,(
    ! [A: $tType,F: ( A > nat ),P: ( A > $o ),A2: A] :
      ( ! [X4: A] :
          ( ! [Y2: A] :
              ( ( ord_less @ nat @ ( F @ Y2 ) @ ( F @ X4 ) )
             => ( P @ Y2 ) )
         => ( P @ X4 ) )
     => ( P @ A2 ) ) )).

% measure_induct_rule
thf(fact_179_infinite__descent__measure,axiom,(
    ! [A: $tType,P: ( A > $o ),V: ( A > nat ),X: A] :
      ( ! [X4: A] :
          ( ~ ( P @ X4 )
         => ? [Y2: A] :
              ( ( ord_less @ nat @ ( V @ Y2 ) @ ( V @ X4 ) )
              & ~ ( P @ Y2 ) ) )
     => ( P @ X ) ) )).

% infinite_descent_measure
thf(fact_180_linorder__neqE__linordered__idom,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) )).

% linorder_neqE_linordered_idom
thf(fact_181_prod_Osize__neq,axiom,(
    ! [A: $tType,B4: $tType,X: ( product_prod @ A @ B4 )] :
      ( ( size_size @ ( product_prod @ A @ B4 ) @ X )
     != ( zero_zero @ nat ) ) )).

% prod.size_neq
thf(fact_182_sum_Osize__neq,axiom,(
    ! [A: $tType,B4: $tType,X: ( sum_sum @ A @ B4 )] :
      ( ( size_size @ ( sum_sum @ A @ B4 ) @ X )
     != ( zero_zero @ nat ) ) )).

% sum.size_neq
thf(fact_183_size__bool,axiom,
    ( ( size_size @ $o )
    = ( ^ [B2: $o] :
          ( zero_zero @ nat ) ) )).

% size_bool
thf(fact_184_zero__neq__one,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type2 @ A ) )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) )).

% zero_neq_one
thf(fact_185_natural_Osize_I1_J,axiom,
    ( ( code_size_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(1)
thf(fact_186_fold__atLeastAtMost__nat_Oinduct,axiom,(
    ! [A: $tType,P: ( ( nat > A > A ) > nat > nat > A > $o ),A0: ( nat > A > A ),A1: nat,A22: nat,A32: A] :
      ( ! [F2: ( nat > A > A ),A4: nat,B3: nat,Acc: A] :
          ( ( ~ ( ord_less @ nat @ B3 @ A4 )
           => ( P @ F2 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B3 @ ( F2 @ A4 @ Acc ) ) )
         => ( P @ F2 @ A4 @ B3 @ Acc ) )
     => ( P @ A0 @ A1 @ A22 @ A32 ) ) )).

% fold_atLeastAtMost_nat.induct
thf(fact_187_natural_Osimps_I4_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T )] :
      ( ( code_case_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(4)
thf(fact_188_bool_Osize_I1_J,axiom,
    ( ( size_bool @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(1)
thf(fact_189_bool_Osize_I2_J,axiom,
    ( ( size_bool @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(2)
thf(fact_190_size__bool__def,axiom,
    ( size_bool
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_def
thf(fact_191_ind__euclid,axiom,(
    ! [P: ( nat > nat > $o ),A2: nat,B: nat] :
      ( ! [A4: nat,B3: nat] :
          ( ( P @ A4 @ B3 )
          = ( P @ B3 @ A4 ) )
     => ( ! [A4: nat] :
            ( P @ A4 @ ( zero_zero @ nat ) )
       => ( ! [A4: nat,B3: nat] :
              ( ( P @ A4 @ B3 )
             => ( P @ A4 @ ( plus_plus @ nat @ A4 @ B3 ) ) )
         => ( P @ A2 @ B ) ) ) ) )).

% ind_euclid
thf(fact_192_size__bool__overloaded__def,axiom,
    ( ( size_size @ $o )
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_overloaded_def
thf(fact_193_add__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A] :
          ( ( B
            = ( plus_plus @ A @ B @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% add_0_iff
thf(fact_194_semiring__normalization__rules_I5_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% semiring_normalization_rules(5)
thf(fact_195_semiring__normalization__rules_I20_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ ( plus_plus @ A @ C @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) )).

% semiring_normalization_rules(20)
thf(fact_196_semiring__normalization__rules_I21_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% semiring_normalization_rules(21)
thf(fact_197_semiring__normalization__rules_I22_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C @ D ) )
          = ( plus_plus @ A @ C @ ( plus_plus @ A @ A2 @ D ) ) ) ) )).

% semiring_normalization_rules(22)
thf(fact_198_semiring__normalization__rules_I23_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C ) @ B ) ) ) )).

% semiring_normalization_rules(23)
thf(fact_199_semiring__normalization__rules_I24_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,C3: A] :
              ( plus_plus @ A @ C3 @ A3 ) ) ) ) )).

% semiring_normalization_rules(24)
thf(fact_200_semiring__normalization__rules_I25_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C ) @ D ) ) ) )).

% semiring_normalization_rules(25)
thf(fact_201_semiring__normalization__rules_I6_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% semiring_normalization_rules(6)
thf(fact_202_natural_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T > T )] :
      ( ( code_rec_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(6)
thf(fact_203_fold__atLeastAtMost__nat_Osimps,axiom,(
    ! [A: $tType] :
      ( ( set_fo292404081st_nat @ A )
      = ( ^ [F3: ( nat > A > A ),A3: nat,B2: nat,Acc2: A] :
            ( if @ A @ ( ord_less @ nat @ B2 @ A3 ) @ Acc2 @ ( set_fo292404081st_nat @ A @ F3 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B2 @ ( F3 @ A3 @ Acc2 ) ) ) ) ) )).

% fold_atLeastAtMost_nat.simps
thf(fact_204_fold__atLeastAtMost__nat_Oelims,axiom,(
    ! [A: $tType,X: ( nat > A > A ),Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( ( set_fo292404081st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y
            = ( set_fo292404081st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) ) ) )).

% fold_atLeastAtMost_nat.elims
thf(fact_205_ln__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) )).

% ln_one
thf(fact_206_tree_Osize__gen_I1_J,axiom,(
    ! [A: $tType,X: ( A > nat )] :
      ( ( size_tree @ A @ X @ ( leaf @ A ) )
      = ( zero_zero @ nat ) ) )).

% tree.size_gen(1)
thf(fact_207_ln__less__zero__iff,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) )).

% ln_less_zero_iff
thf(fact_208_ln__gt__zero__iff,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) )).

% ln_gt_zero_iff
thf(fact_209_ln__eq__zero__iff,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) )).

% ln_eq_zero_iff
thf(fact_210_ln__gt__zero__imp__gt__one,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) )).

% ln_gt_zero_imp_gt_one
thf(fact_211_ln__less__zero,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) )).

% ln_less_zero
thf(fact_212_ln__gt__zero,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) )).

% ln_gt_zero
thf(fact_213_powr__zero__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) )).

% powr_zero_eq_one
thf(fact_214_powr__one__eq__one,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) )).

% powr_one_eq_one
thf(fact_215_powr__gt__zero,axiom,(
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ A2 ) )
      = ( X
       != ( zero_zero @ real ) ) ) )).

% powr_gt_zero
thf(fact_216_powr__less__cancel__iff,axiom,(
    ! [X: real,A2: real,B: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B ) )
        = ( ord_less @ real @ A2 @ B ) ) ) )).

% powr_less_cancel_iff
thf(fact_217_powr__0,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) )).

% powr_0
thf(fact_218_powr__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( ln @ A @ ( type2 @ A ) )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) )).

% powr_eq_0_iff
thf(fact_219_ln__inj__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( ln_ln @ real @ X )
            = ( ln_ln @ real @ Y ) )
          = ( X = Y ) ) ) ) )).

% ln_inj_iff
thf(fact_220_ln__less__cancel__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) )).

% ln_less_cancel_iff
thf(fact_221_ln__less__self,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( ln_ln @ real @ X ) @ X ) ) )).

% ln_less_self
thf(fact_222_powr__less__mono2__neg,axiom,(
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) )).

% powr_less_mono2_neg
thf(fact_223_powr__less__cancel,axiom,(
    ! [X: real,A2: real,B: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B ) ) ) )).

% powr_less_cancel
thf(fact_224_powr__less__mono,axiom,(
    ! [A2: real,B: real,X: real] :
      ( ( ord_less @ real @ A2 @ B )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B ) ) ) ) )).

% powr_less_mono
thf(fact_225_powr__inj,axiom,(
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y ) )
          = ( X = Y ) ) ) ) )).

% powr_inj
thf(fact_226_real__lbound__gt__zero,axiom,(
    ! [D1: real,D2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D1 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ? [E: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
            & ( ord_less @ real @ E @ D1 )
            & ( ord_less @ real @ E @ D2 ) ) ) ) )).

% real_lbound_gt_zero
thf(fact_227_ln__ge__zero__iff,axiom,(
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) )).

% ln_ge_zero_iff
thf(fact_228_le__zero__eq,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) )).

% le_zero_eq
thf(fact_229_add__le__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_cancel_left
thf(fact_230_add__le__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_cancel_right
thf(fact_231_zero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) )).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_232_double__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_233_le__add__same__cancel2,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) ) ) )).

% le_add_same_cancel2
thf(fact_234_le__add__same__cancel1,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) ) ) )).

% le_add_same_cancel1
thf(fact_235_add__le__same__cancel2,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B ) @ B )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% add_le_same_cancel2
thf(fact_236_add__le__same__cancel1,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B @ A2 ) @ B )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% add_le_same_cancel1
thf(fact_237_ln__le__cancel__iff,axiom,(
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) )).

% ln_le_cancel_iff
thf(fact_238_powr__one__gt__zero__iff,axiom,(
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) )).

% powr_one_gt_zero_iff
thf(fact_239_powr__one,axiom,(
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) )).

% powr_one
thf(fact_240_powr__le__cancel__iff,axiom,(
    ! [X: real,A2: real,B: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B ) )
        = ( ord_less_eq @ real @ A2 @ B ) ) ) )).

% powr_le_cancel_iff
thf(fact_241_ln__bound,axiom,(
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) )).

% ln_bound
thf(fact_242_powr__mono,axiom,(
    ! [A2: real,B: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B ) ) ) ) )).

% powr_mono
thf(fact_243_powr__mono2,axiom,(
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) )).

% powr_mono2
thf(fact_244_powr__mono2_H,axiom,(
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) )).

% powr_mono2'
thf(fact_245_powr__ge__pzero,axiom,(
    ! [X: real,Y: real] :
      ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y ) ) )).

% powr_ge_pzero
thf(fact_246_powr__less__mono2,axiom,(
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) )).

% powr_less_mono2
thf(fact_247_ge__one__powr__ge__zero,axiom,(
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) )).

% ge_one_powr_ge_zero
thf(fact_248_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X5: real,Y4: real] :
          ( ( ord_less @ real @ X5 @ Y4 )
          | ( X5 = Y4 ) ) ) )).

% less_eq_real_def
thf(fact_249_zero__le,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )).

% zero_le
thf(fact_250_le__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% le_numeral_extra(3)
thf(fact_251_add__less__le__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ C @ D )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) ) )).

% add_less_le_mono
thf(fact_252_add__le__less__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere223160158up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less @ A @ C @ D )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) ) )).

% add_le_less_mono

%----Subclasses (1)
thf(subcl_Orderings_Olinorder___HOL_Otype,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( type @ A @ ( type2 @ A ) ) ) )).

%----Type constructors (77)
thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    ( semiri456707255roduct @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ( ordere516151231imp_le @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    ( strict2144017051up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ( ordere223160158up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ( ordere236663937imp_le @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    ( strict797366125id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring,axiom,
    ( linord1659791738miring @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add,axiom,
    ( ordere216010020id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add,axiom,
    ( comm_monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1,axiom,
    ( comm_semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ozero__less__one,axiom,
    ( zero_less_one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one,axiom,
    ( zero_neq_one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add,axiom,
    ( monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oone,axiom,
    ( one @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    ( size @ nat @ ( type2 @ nat ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_1,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Nat_Osize_2,axiom,
    ( size @ $o @ ( type2 @ $o ) )).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_3,axiom,
    ( semiri456707255roduct @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_4,axiom,
    ( ordere516151231imp_le @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_5,axiom,
    ( strict2144017051up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_6,axiom,
    ( ordere223160158up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_7,axiom,
    ( ordere236663937imp_le @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_8,axiom,
    ( strict797366125id_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_9,axiom,
    ( linord1659791738miring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_10,axiom,
    ( ordere779506340up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_11,axiom,
    ( ordere216010020id_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add,axiom,
    ( linord219039673up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_12,axiom,
    ( cancel1352612707id_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_13,axiom,
    ( cancel_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_14,axiom,
    ( linordered_semidom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_15,axiom,
    ( ab_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Fields_Olinordered__field,axiom,
    ( linordered_field @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_16,axiom,
    ( comm_monoid_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__idom,axiom,
    ( linordered_idom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_17,axiom,
    ( comm_semiring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_18,axiom,
    ( semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_19,axiom,
    ( zero_less_one @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_20,axiom,
    ( zero_neq_one @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Olinorder_21,axiom,
    ( linorder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ( ln @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Omonoid__add_22,axiom,
    ( monoid_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ogroup__add,axiom,
    ( group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Num_Oneg__numeral,axiom,
    ( neg_numeral @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ozero_23,axiom,
    ( zero @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oone_24,axiom,
    ( one @ real @ ( type2 @ real ) )).

thf(tcon_Tree_Otree___Nat_Osize_25,axiom,(
    ! [A5: $tType] :
      ( size @ ( tree @ A5 ) @ ( type2 @ ( tree @ A5 ) ) ) )).

thf(tcon_Sum__Type_Osum___Nat_Osize_26,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( size @ ( sum_sum @ A5 @ A6 ) @ ( type2 @ ( sum_sum @ A5 @ A6 ) ) ) )).

thf(tcon_Product__Type_Oprod___Nat_Osize_27,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( size @ ( product_prod @ A5 @ A6 ) @ ( type2 @ ( product_prod @ A5 @ A6 ) ) ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_28,axiom,
    ( ordere516151231imp_le @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_29,axiom,
    ( strict2144017051up_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_30,axiom,
    ( ordere223160158up_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_31,axiom,
    ( ordere236663937imp_le @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_32,axiom,
    ( strict797366125id_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_33,axiom,
    ( ordere779506340up_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_34,axiom,
    ( ordere216010020id_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_35,axiom,
    ( cancel1352612707id_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_36,axiom,
    ( cancel_semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_37,axiom,
    ( ab_semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_38,axiom,
    ( comm_monoid_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_39,axiom,
    ( comm_semiring_1 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_40,axiom,
    ( semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_41,axiom,
    ( zero_neq_one @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Orderings_Olinorder_42,axiom,
    ( linorder @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_43,axiom,
    ( monoid_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_44,axiom,
    ( zero @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oone_45,axiom,
    ( one @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Nat_Osize_46,axiom,
    ( size @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Splay__Tree__Analysis__Base_Oop_092_060_094sub_062s_092_060_094sub_062t___Nat_Osize_47,axiom,(
    ! [A5: $tType] :
      ( size @ ( splay_2011811431op_s_t @ A5 ) @ ( type2 @ ( splay_2011811431op_s_t @ A5 ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type2 @ a ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( size_size @ ( tree @ a ) @ rr )
    = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_size @ ( tree @ a ) @ l ) @ ( size_size @ ( tree @ a ) @ r ) ) @ ( one_one @ nat ) ) )).

%------------------------------------------------------------------------------
