%------------------------------------------------------------------------------
% File     : DAT216^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Splay tree analysis 312
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Nip14] Nipkow (2014), Amortized Complexity Verified
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : splay_tree_analysis__312.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  437 (   2 unit;  73 type;   0 defn)
%            Number of atoms       : 4313 ( 312 equality;1863 variable)
%            Maximal formula depth :   20 (   7 average)
%            Number of connectives : 3414 (  36   ~;  18   |;  21   &;3092   @)
%                                         (   0 <=>; 247  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   70 (  70   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   76 (  73   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  687 (   0 sgn; 612   !;   8   ?;  11   ^)
%                                         ( 687   :;  56  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:50:57.630
%------------------------------------------------------------------------------
%----Could-be-implicit typings (8)
thf(ty_t_Tree_Otree,type,(
    tree: $tType > $tType )).

thf(ty_t_Real_Oreal,type,(
    real: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Num_Onum,type,(
    num: $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_Int_Oint,type,(
    int: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (65)
thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring,type,(
    ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Onumeral,type,(
    numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring,type,(
    semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Omult__zero,type,(
    mult_zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__1,type,(
    semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__mult,type,(
    monoid_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oordered__ring,type,(
    ordered_ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ozero__neq__one,type,(
    zero_neq_one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring,type,(
    comm_semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Osemiring__numeral,type,(
    semiring_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__mult,type,(
    semigroup_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__ring,type,(
    linordered_ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__add,type,(
    comm_monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oordered__semiring,type,(
    ordered_semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__mult,type,(
    ab_semigroup_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oordered__semiring__0,type,(
    ordered_semiring_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semiring__1,type,(
    linord1278240602ring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oordered__comm__semiring,type,(
    ordere1490568538miring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__ring__strict,type,(
    linord581940658strict: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,(
    ring_11004092258visors: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,(
    linord219039673up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,(
    semiri1193490041visors: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,(
    linord1659791738miring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,(
    ordere236663937imp_le: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,(
    semiri1923998003cancel: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,(
    ordere516151231imp_le: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Otimes__class_Otimes,type,(
    times_times: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,(
    semiring_1_of_nat: 
      !>[A: $tType] :
        ( nat > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Num_Onum_OBit0,type,(
    bit0: num > num )).

thf(sy_c_Num_Onum_OBit1,type,(
    bit1: num > num )).

thf(sy_c_Num_Onum_OOne,type,(
    one2: num )).

thf(sy_c_Num_Onumeral__class_Onumeral,type,(
    numeral_numeral: 
      !>[A: $tType] :
        ( num > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Splay__Tree__Analysis__Base_O_092_060Phi_062,type,(
    splay_1414789891is_Phi: 
      !>[A: $tType] :
        ( ( tree @ A ) > real ) )).

thf(sy_c_Splay__Tree__Analysis__Base_Ot__splay,type,(
    splay_914434265_splay: 
      !>[A: $tType] :
        ( A > ( tree @ A ) > nat ) )).

thf(sy_c_Transcendental_Olog,type,(
    log: real > real > real )).

thf(sy_c_Tree_Olinorder__class_Obst,type,(
    linorder_bst: 
      !>[A: $tType] :
        ( ( tree @ A ) > $o ) )).

thf(sy_c_Tree_Otree_OLeaf,type,(
    leaf: 
      !>[A: $tType] :
        ( tree @ A ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_a____,type,(
    a2: a )).

thf(sy_v_e____,type,(
    e: a )).

thf(sy_v_l____,type,(
    l: ( tree @ a ) )).

thf(sy_v_r____,type,(
    r: ( tree @ a ) )).

thf(sy_v_s____,type,(
    s: ( tree @ a ) )).

%----Relevant facts (251)
thf(fact_0__092_060open_062e_A_061_Aa_092_060close_062,axiom,(
    e = a2 )).

% \<open>e = a\<close>
thf(fact_1__092_060open_062s_A_092_060noteq_062_A_092_060langle_062_092_060rangle_062_092_060close_062,axiom,(
    s
 != ( leaf @ a ) )).

% \<open>s \<noteq> \<langle>\<rangle>\<close>
thf(fact_2_nneg,axiom,
    ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ s ) ) ) ) )).

% nneg
thf(fact_3__C5_C,axiom,
    ( linorder_bst @ a @ s )).

% "5"
thf(fact_4_one__add__one,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )).

% one_add_one
thf(fact_5_numeral__plus__one,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) )).

% numeral_plus_one
thf(fact_6_one__plus__numeral,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) )).

% one_plus_numeral
thf(fact_7_numeral__le__one__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) )).

% numeral_le_one_iff
thf(fact_8_numeral__eq__one__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) )).

% numeral_eq_one_iff
thf(fact_9_one__eq__numeral__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) )).

% one_eq_numeral_iff
thf(fact_10_distrib__left__numeral,axiom,(
    ! [A: $tType] :
      ( ( ( numeral @ A @ ( type @ A ) )
        & ( semiring @ A @ ( type @ A ) ) )
     => ! [V: num,B: A,C: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C ) ) ) ) )).

% distrib_left_numeral
thf(fact_11_distrib__right__numeral,axiom,(
    ! [A: $tType] :
      ( ( ( numeral @ A @ ( type @ A ) )
        & ( semiring @ A @ ( type @ A ) ) )
     => ! [A2: A,B: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B @ ( numeral_numeral @ A @ V ) ) ) ) ) )).

% distrib_right_numeral
thf(fact_12_of__nat__1,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type @ A ) )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) )).

% of_nat_1
thf(fact_13_of__nat__add,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type @ A ) )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) )).

% of_nat_add
thf(fact_14_of__nat__numeral,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) )).

% of_nat_numeral
thf(fact_15_of__nat__mult,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type @ A ) )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) )).

% of_nat_mult
thf(fact_16_num_Oinject_I1_J,axiom,(
    ! [X2: num,Y2: num] :
      ( ( ( bit0 @ X2 )
        = ( bit0 @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% num.inject(1)
thf(fact_17_numeral__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) )).

% numeral_eq_iff
thf(fact_18_num_Oinject_I2_J,axiom,(
    ! [X3: num,Y3: num] :
      ( ( ( bit1 @ X3 )
        = ( bit1 @ Y3 ) )
      = ( X3 = Y3 ) ) )).

% num.inject(2)
thf(fact_19_of__nat__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) )).

% of_nat_eq_iff
thf(fact_20_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_21_numeral__times__numeral,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type @ A ) )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) )).

% numeral_times_numeral
thf(fact_22_of__nat__le__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) )).

% of_nat_le_iff
thf(fact_23_of__nat__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) )).

% of_nat_eq_0_iff
thf(fact_24_of__nat__0__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) )).

% of_nat_0_eq_iff
thf(fact_25_of__nat__0,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type @ A ) )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) )).

% of_nat_0
thf(fact_26_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_27_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_28_of__nat__le__0__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) )).

% of_nat_le_0_iff
thf(fact_29_numeral__plus__numeral,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) )).

% numeral_plus_numeral
thf(fact_30_add__numeral__left,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) )).

% add_numeral_left
thf(fact_31_numeral__le__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) )).

% numeral_le_iff
thf(fact_32_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) )).

% numerals(1)
thf(fact_33_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) )).

% add_leE
thf(fact_34_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) )).

% le_add1
thf(fact_35_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) )).

% le_add2
thf(fact_36_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) )).

% le_cube
thf(fact_37_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) )).

% add_leD1
thf(fact_38_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) )).

% add_leD2
thf(fact_39_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_40_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) )).

% le_square
thf(fact_41_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) )).

% nat_mult_1
thf(fact_42_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_43_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_48_zadd__int__left,axiom,(
    ! [M: nat,N: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z ) ) )).

% zadd_int_left
thf(fact_49_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_50_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_51_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_52_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_53_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M2: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus @ nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_54_add__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) )).

% add_mult_distrib
thf(fact_55_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) )).

% nat_mult_1_right
thf(fact_56_add__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) )).

% add_mult_distrib2
thf(fact_57_nat__add__left__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ K @ M )
        = ( plus_plus @ nat @ K @ N ) )
      = ( M = N ) ) )).

% nat_add_left_cancel
thf(fact_58_nat__add__right__cancel,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ K )
        = ( plus_plus @ nat @ N @ K ) )
      = ( M = N ) ) )).

% nat_add_right_cancel
thf(fact_59_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )).

% nat_1_add_1
thf(fact_60_add__One__commute,axiom,(
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) )).

% add_One_commute
thf(fact_61_le__num__One__iff,axiom,(
    ! [X5: num] :
      ( ( ord_less_eq @ num @ X5 @ one2 )
      = ( X5 = one2 ) ) )).

% le_num_One_iff
thf(fact_62_le__numeral__extra_I3_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) )).

% le_numeral_extra(3)
thf(fact_63_zero__neq__numeral,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) )).

% zero_neq_numeral
thf(fact_64_is__num__normalize_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% is_num_normalize(1)
thf(fact_65_not__numeral__le__zero,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) )).

% not_numeral_le_zero
thf(fact_66_zero__le__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) )).

% zero_le_numeral
thf(fact_67_le__numeral__extra_I1_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) )).

% le_numeral_extra(1)
thf(fact_68_le__numeral__extra_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) )).

% le_numeral_extra(2)
thf(fact_69_of__nat__0__le__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [N: nat] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) )).

% of_nat_0_le_iff
thf(fact_70_le__numeral__extra_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) )).

% le_numeral_extra(4)
thf(fact_71_num_Odistinct_I5_J,axiom,(
    ! [X2: num,X3: num] :
      ( ( bit0 @ X2 )
     != ( bit1 @ X3 ) ) )).

% num.distinct(5)
thf(fact_72_num_Odistinct_I1_J,axiom,(
    ! [X2: num] :
      ( one2
     != ( bit0 @ X2 ) ) )).

% num.distinct(1)
thf(fact_73_num_Odistinct_I3_J,axiom,(
    ! [X3: num] :
      ( one2
     != ( bit1 @ X3 ) ) )).

% num.distinct(3)
thf(fact_74_mult__of__nat__commute,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type @ A ) )
     => ! [X5: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X5 ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X5 ) ) ) ) )).

% mult_of_nat_commute
thf(fact_75_one__le__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) )).

% one_le_numeral
thf(fact_76_numeral__Bit0,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) )).

% numeral_Bit0
thf(fact_77_num_Oexhaust,axiom,(
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X22: num] :
            ( Y
           != ( bit0 @ X22 ) )
       => ~ ( ! [X32: num] :
                ( Y
               != ( bit1 @ X32 ) ) ) ) ) )).

% num.exhaust
thf(fact_78_num_Oinduct,axiom,(
    ! [P: ( num > $o ),Num: num] :
      ( ( P @ one2 )
     => ( ! [X4: num] :
            ( ( P @ X4 )
           => ( P @ ( bit0 @ X4 ) ) )
       => ( ! [X4: num] :
              ( ( P @ X4 )
             => ( P @ ( bit1 @ X4 ) ) )
         => ( P @ Num ) ) ) ) )).

% num.induct
thf(fact_79_mult__numeral__1__right,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) )).

% mult_numeral_1_right
thf(fact_80_mult__numeral__1,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) )).

% mult_numeral_1
thf(fact_81_one__plus__numeral__commute,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [X5: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X5 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X5 ) @ ( one_one @ A ) ) ) ) )).

% one_plus_numeral_commute
thf(fact_82_numeral__One,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) )).

% numeral_One
thf(fact_83_numeral__Bit1,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) )).

% numeral_Bit1
thf(fact_84_mult__2__right,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) )).

% mult_2_right
thf(fact_85_mult__2,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) )).

% mult_2
thf(fact_86_numeral__le__real__of__nat__iff,axiom,(
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) )).

% numeral_le_real_of_nat_iff
thf(fact_87_semiring__norm_I3_J,axiom,(
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) )).

% semiring_norm(3)
thf(fact_88_semiring__norm_I4_J,axiom,(
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) )).

% semiring_norm(4)
thf(fact_89_semiring__norm_I5_J,axiom,(
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) )).

% semiring_norm(5)
thf(fact_90_semiring__norm_I8_J,axiom,(
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) )).

% semiring_norm(8)
thf(fact_91_semiring__norm_I10_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) )).

% semiring_norm(10)
thf(fact_92_semiring__norm_I70_J,axiom,(
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) )).

% semiring_norm(70)
thf(fact_93_semiring__norm_I69_J,axiom,(
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) )).

% semiring_norm(69)
thf(fact_94_semiring__norm_I72_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) )).

% semiring_norm(72)
thf(fact_95_log__one,axiom,(
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) )).

% log_one
thf(fact_96_semiring__norm_I87_J,axiom,(
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) )).

% semiring_norm(87)
thf(fact_97_semiring__norm_I90_J,axiom,(
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) )).

% semiring_norm(90)
thf(fact_98_semiring__norm_I89_J,axiom,(
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) )).

% semiring_norm(89)
thf(fact_99_semiring__norm_I88_J,axiom,(
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) )).

% semiring_norm(88)
thf(fact_100_semiring__norm_I85_J,axiom,(
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) )).

% semiring_norm(85)
thf(fact_101_semiring__norm_I83_J,axiom,(
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) )).

% semiring_norm(83)
thf(fact_102_semiring__norm_I86_J,axiom,(
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) )).

% semiring_norm(86)
thf(fact_103_semiring__norm_I84_J,axiom,(
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) )).

% semiring_norm(84)
thf(fact_104_Nat_Oadd__0__right,axiom,(
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) )).

% Nat.add_0_right
thf(fact_105_add__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) )).

% add_is_0
thf(fact_106_le0,axiom,(
    ! [N: nat] :
      ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) )).

% le0
thf(fact_107_mult__cancel2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) )).

% mult_cancel2
thf(fact_108_mult__cancel1,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) )).

% mult_cancel1
thf(fact_109_mult__0__right,axiom,(
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) )).

% mult_0_right
thf(fact_110_mult__is__0,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) )).

% mult_is_0
thf(fact_111_semiring__norm_I6_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) )).

% semiring_norm(6)
thf(fact_112_semiring__norm_I13_J,axiom,(
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) )).

% semiring_norm(13)
thf(fact_113_semiring__norm_I12_J,axiom,(
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) )).

% semiring_norm(12)
thf(fact_114_semiring__norm_I11_J,axiom,(
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) )).

% semiring_norm(11)
thf(fact_115_semiring__norm_I71_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) )).

% semiring_norm(71)
thf(fact_116_semiring__norm_I73_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) )).

% semiring_norm(73)
thf(fact_117_semiring__norm_I68_J,axiom,(
    ! [N: num] :
      ( ord_less_eq @ num @ one2 @ N ) )).

% semiring_norm(68)
thf(fact_118_semiring__norm_I9_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) )).

% semiring_norm(9)
thf(fact_119_semiring__norm_I7_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) )).

% semiring_norm(7)
thf(fact_120_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) )).

% semiring_norm(2)
thf(fact_121_semiring__norm_I15_J,axiom,(
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) )).

% semiring_norm(15)
thf(fact_122_semiring__norm_I14_J,axiom,(
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) )).

% semiring_norm(14)
thf(fact_123_semiring__norm_I169_J,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type @ A ) )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) )).

% semiring_norm(169)
thf(fact_124_semiring__norm_I16_J,axiom,(
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) )).

% semiring_norm(16)
thf(fact_125_int__distrib_I2_J,axiom,(
    ! [W: int,Z1: int,Z2: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z2 ) ) ) )).

% int_distrib(2)
thf(fact_126_int__distrib_I1_J,axiom,(
    ! [Z1: int,Z2: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z2 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z2 @ W ) ) ) )).

% int_distrib(1)
thf(fact_127_plus__int__code_I2_J,axiom,(
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) )).

% plus_int_code(2)
thf(fact_128_plus__int__code_I1_J,axiom,(
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) )).

% plus_int_code(1)
thf(fact_129_less__eq__nat_Osimps_I1_J,axiom,(
    ! [N: nat] :
      ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) )).

% less_eq_nat.simps(1)
thf(fact_130_zle__int,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) )).

% zle_int
thf(fact_131_le__0__eq,axiom,(
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) )).

% le_0_eq
thf(fact_132_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq @ nat @ N @ N ) )).

% le_refl
thf(fact_133_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) )).

% le_trans
thf(fact_134_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_135_int__int__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) )).

% int_int_eq
thf(fact_136_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_137_odd__nonzero,axiom,(
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) )).

% odd_nonzero
thf(fact_138_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W2: int,Z3: int] :
        ? [N3: nat] :
          ( Z3
          = ( plus_plus @ int @ W2 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) )).

% zle_iff_zadd
thf(fact_139_int__ge__induct,axiom,(
    ! [K: int,I: int,P: ( int > $o )] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) )).

% int_ge_induct
thf(fact_140_nonneg__eq__int,axiom,(
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ~ ( ! [M3: nat] :
              ( Z
             != ( semiring_1_of_nat @ int @ M3 ) ) ) ) )).

% nonneg_eq_int
thf(fact_141_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_142_nonneg__int__cases,axiom,(
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ( ! [N2: nat] :
              ( K
             != ( semiring_1_of_nat @ int @ N2 ) ) ) ) )).

% nonneg_int_cases
thf(fact_143_zero__le__imp__eq__int,axiom,(
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N2: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N2 ) ) ) )).

% zero_le_imp_eq_int
thf(fact_144_nat__mult__eq__cancel__disj,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) )).

% nat_mult_eq_cancel_disj
thf(fact_145_add__eq__self__zero,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) )).

% add_eq_self_zero
thf(fact_146_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_147_mult__0,axiom,(
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) )).

% mult_0
thf(fact_148_mult__eq__self__implies__10,axiom,(
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) )).

% mult_eq_self_implies_10
thf(fact_149_complete__real,axiom,(
    ! [S: ( set @ real )] :
      ( ? [X6: real] :
          ( member @ real @ X6 @ S )
     => ( ? [Z4: real] :
          ! [X4: real] :
            ( ( member @ real @ X4 @ S )
           => ( ord_less_eq @ real @ X4 @ Z4 ) )
       => ? [Y4: real] :
            ( ! [X6: real] :
                ( ( member @ real @ X6 @ S )
               => ( ord_less_eq @ real @ X6 @ Y4 ) )
            & ! [Z4: real] :
                ( ! [X4: real] :
                    ( ( member @ real @ X4 @ S )
                   => ( ord_less_eq @ real @ X4 @ Z4 ) )
               => ( ord_less_eq @ real @ Y4 @ Z4 ) ) ) ) ) )).

% complete_real
thf(fact_150_left__add__mult__distrib,axiom,(
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I @ J ) @ U ) @ K ) ) )).

% left_add_mult_distrib
thf(fact_151_mult__cancel__left1,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type @ A ) )
     => ! [C: A,B: A] :
          ( ( C
            = ( times_times @ A @ C @ B ) )
          = ( ( C
              = ( zero_zero @ A ) )
            | ( B
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_left1
thf(fact_152_mult__cancel__left2,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type @ A ) )
     => ! [C: A,A2: A] :
          ( ( ( times_times @ A @ C @ A2 )
            = C )
          = ( ( C
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_left2
thf(fact_153_mult__cancel__right1,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type @ A ) )
     => ! [C: A,B: A] :
          ( ( C
            = ( times_times @ A @ B @ C ) )
          = ( ( C
              = ( zero_zero @ A ) )
            | ( B
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_right1
thf(fact_154_mult__cancel__right2,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type @ A ) )
     => ! [A2: A,C: A] :
          ( ( ( times_times @ A @ A2 @ C )
            = C )
          = ( ( C
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) )).

% mult_cancel_right2
thf(fact_155_sum__squares__eq__zero__iff,axiom,(
    ! [A: $tType] :
      ( ( linord581940658strict @ A @ ( type @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X5 @ X5 ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X5
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% sum_squares_eq_zero_iff
thf(fact_156_mult__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ( times_times @ A @ A2 @ C )
            = ( times_times @ A @ B @ C ) )
          = ( ( C
              = ( zero_zero @ A ) )
            | ( A2 = B ) ) ) ) )).

% mult_cancel_right
thf(fact_157_mult__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ( times_times @ A @ C @ A2 )
            = ( times_times @ A @ C @ B ) )
          = ( ( C
              = ( zero_zero @ A ) )
            | ( A2 = B ) ) ) ) )).

% mult_cancel_left
thf(fact_158_mult__eq__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri1193490041visors @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( times_times @ A @ A2 @ B )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B
              = ( zero_zero @ A ) ) ) ) ) )).

% mult_eq_0_iff
thf(fact_159_mult__zero__right,axiom,(
    ! [A: $tType] :
      ( ( mult_zero @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) )).

% mult_zero_right
thf(fact_160_mult__zero__left,axiom,(
    ! [A: $tType] :
      ( ( mult_zero @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) )).

% mult_zero_left
thf(fact_161_times__int__code_I2_J,axiom,(
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) )).

% times_int_code(2)
thf(fact_162_times__int__code_I1_J,axiom,(
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) )).

% times_int_code(1)
thf(fact_163_less__eq__int__code_I1_J,axiom,
    ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) )).

% less_eq_int_code(1)
thf(fact_164_mult__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( C
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C )
              = ( times_times @ A @ B @ C ) )
            = ( A2 = B ) ) ) ) )).

% mult_right_cancel
thf(fact_165_mult__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( semiri1923998003cancel @ A @ ( type @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( C
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C @ A2 )
              = ( times_times @ A @ C @ B ) )
            = ( A2 = B ) ) ) ) )).

% mult_left_cancel
thf(fact_166_no__zero__divisors,axiom,(
    ! [A: $tType] :
      ( ( semiri1193490041visors @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B )
             != ( zero_zero @ A ) ) ) ) ) )).

% no_zero_divisors
thf(fact_167_divisors__zero,axiom,(
    ! [A: $tType] :
      ( ( semiri1193490041visors @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( times_times @ A @ A2 @ B )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B
              = ( zero_zero @ A ) ) ) ) ) )).

% divisors_zero
thf(fact_168_mult__not__zero,axiom,(
    ! [A: $tType] :
      ( ( mult_zero @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( times_times @ A @ A2 @ B )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B
             != ( zero_zero @ A ) ) ) ) ) )).

% mult_not_zero
thf(fact_169_zero__neq__one,axiom,(
    ! [A: $tType] :
      ( ( zero_neq_one @ A @ ( type @ A ) )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) )).

% zero_neq_one
thf(fact_170_combine__common__factor,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type @ A ) )
     => ! [A2: A,E: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B @ E ) @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ E ) @ C ) ) ) )).

% combine_common_factor
thf(fact_171_distrib__right,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% distrib_right
thf(fact_172_distrib__left,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B ) @ ( times_times @ A @ A2 @ C ) ) ) ) )).

% distrib_left
thf(fact_173_comm__semiring__class_Odistrib,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% comm_semiring_class.distrib
thf(fact_174_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B ) @ ( times_times @ A @ A2 @ C ) ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_175_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_176_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere1490568538miring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C )
           => ( ord_less_eq @ A @ ( times_times @ A @ C @ A2 ) @ ( times_times @ A @ C @ B ) ) ) ) ) )).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_177_zero__le__mult__iff,axiom,(
    ! [A: $tType] :
      ( ( linord581940658strict @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B @ ( zero_zero @ A ) ) ) ) ) ) )).

% zero_le_mult_iff
thf(fact_178_mult__nonneg__nonpos2,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B @ A2 ) @ ( zero_zero @ A ) ) ) ) ) )).

% mult_nonneg_nonpos2
thf(fact_179_mult__nonpos__nonneg,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B ) @ ( zero_zero @ A ) ) ) ) ) )).

% mult_nonpos_nonneg
thf(fact_180_mult__nonneg__nonpos,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B ) @ ( zero_zero @ A ) ) ) ) ) )).

% mult_nonneg_nonpos
thf(fact_181_mult__nonneg__nonneg,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B ) ) ) ) ) )).

% mult_nonneg_nonneg
thf(fact_182_split__mult__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B ) @ ( zero_zero @ A ) ) ) ) )).

% split_mult_neg_le
thf(fact_183_mult__le__0__iff,axiom,(
    ! [A: $tType] :
      ( ( linord581940658strict @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) ) ) ) ) )).

% mult_le_0_iff
thf(fact_184_mult__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) ) )).

% mult_right_mono
thf(fact_185_mult__right__mono__neg,axiom,(
    ! [A: $tType] :
      ( ( ordered_ring @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ord_less_eq @ A @ B @ A2 )
         => ( ( ord_less_eq @ A @ C @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) ) )).

% mult_right_mono_neg
thf(fact_186_mult__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C )
           => ( ord_less_eq @ A @ ( times_times @ A @ C @ A2 ) @ ( times_times @ A @ C @ B ) ) ) ) ) )).

% mult_left_mono
thf(fact_187_mult__nonpos__nonpos,axiom,(
    ! [A: $tType] :
      ( ( ordered_ring @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B ) ) ) ) ) )).

% mult_nonpos_nonpos
thf(fact_188_mult__left__mono__neg,axiom,(
    ! [A: $tType] :
      ( ( ordered_ring @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ord_less_eq @ A @ B @ A2 )
         => ( ( ord_less_eq @ A @ C @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C @ A2 ) @ ( times_times @ A @ C @ B ) ) ) ) ) )).

% mult_left_mono_neg
thf(fact_189_split__mult__pos__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ring @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B ) ) ) ) )).

% split_mult_pos_le
thf(fact_190_zero__le__square,axiom,(
    ! [A: $tType] :
      ( ( linordered_ring @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) )).

% zero_le_square
thf(fact_191_mult__mono_H,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ C @ D )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ D ) ) ) ) ) ) ) )).

% mult_mono'
thf(fact_192_mult__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_semiring @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ C @ D )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ D ) ) ) ) ) ) ) )).

% mult_mono
thf(fact_193_not__one__le__zero,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type @ A ) )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) )).

% not_one_le_zero
thf(fact_194_zero__le__one,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type @ A ) )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) )).

% zero_le_one
thf(fact_195_sum__squares__le__zero__iff,axiom,(
    ! [A: $tType] :
      ( ( linord581940658strict @ A @ ( type @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X5 @ X5 ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X5
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% sum_squares_le_zero_iff
thf(fact_196_sum__squares__ge__zero,axiom,(
    ! [A: $tType] :
      ( ( linordered_ring @ A @ ( type @ A ) )
     => ! [X5: A,Y: A] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X5 @ X5 ) @ ( times_times @ A @ Y @ Y ) ) ) ) )).

% sum_squares_ge_zero
thf(fact_197_mult__left__le,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type @ A ) )
     => ! [C: A,A2: A] :
          ( ( ord_less_eq @ A @ C @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C ) @ A2 ) ) ) ) )).

% mult_left_le
thf(fact_198_mult__le__one,axiom,(
    ! [A: $tType] :
      ( ( linord1659791738miring @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B )
           => ( ( ord_less_eq @ A @ B @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B ) @ ( one_one @ A ) ) ) ) ) ) )).

% mult_le_one
thf(fact_199_mult__right__le__one__le,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X5 @ Y ) @ X5 ) ) ) ) ) )).

% mult_right_le_one_le
thf(fact_200_mult__left__le__one__le,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type @ A ) )
     => ! [X5: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X5 ) @ X5 ) ) ) ) ) )).

% mult_left_le_one_le
thf(fact_201_convex__bound__le,axiom,(
    ! [A: $tType] :
      ( ( linord1278240602ring_1 @ A @ ( type @ A ) )
     => ! [X5: A,A2: A,Y: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X5 @ A2 )
         => ( ( ord_less_eq @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X5 ) @ ( times_times @ A @ V @ Y ) ) @ A2 ) ) ) ) ) ) ) )).

% convex_bound_le
thf(fact_202_zero__le__double__add__iff__zero__le__single__add,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) )).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_203_double__add__le__zero__iff__single__add__le__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_204_le__add__same__cancel2,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) ) ) )).

% le_add_same_cancel2
thf(fact_205_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
          = ( B = C ) ) ) )).

% add_left_cancel
thf(fact_206_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
          = ( B = C ) ) ) )).

% add_right_cancel
thf(fact_207_le__zero__eq,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type @ A ) )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) )).

% le_zero_eq
thf(fact_208_add__le__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_cancel_left
thf(fact_209_add__le__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_cancel_right
thf(fact_210_add_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.left_neutral
thf(fact_211_add_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.right_neutral
thf(fact_212_double__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero
thf(fact_213_double__zero__sym,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero_sym
thf(fact_214_add__cancel__left__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [B: A,A2: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = A2 )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_left
thf(fact_215_add__cancel__left__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = A2 )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_right
thf(fact_216_add__cancel__right__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( A2
            = ( plus_plus @ A @ B @ A2 ) )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_left
thf(fact_217_add__cancel__right__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B ) )
          = ( B
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_right
thf(fact_218_mult_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_mult @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% mult.left_neutral
thf(fact_219_mult_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_mult @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% mult.right_neutral
thf(fact_220_add__le__same__cancel1,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type @ A ) )
     => ! [B: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B @ A2 ) @ B )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% add_le_same_cancel1
thf(fact_221_add__le__same__cancel2,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B ) @ B )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) )).

% add_le_same_cancel2
thf(fact_222_le__add__same__cancel1,axiom,(
    ! [A: $tType] :
      ( ( ordere516151231imp_le @ A @ ( type @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B ) ) ) )).

% le_add_same_cancel1
thf(fact_223_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type @ A ) )
     => ! [X5: A] :
          ( ( ( zero_zero @ A )
            = X5 )
          = ( X5
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_224_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B ) @ C )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B @ C ) ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_225_mult_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_mult @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B ) @ C )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B @ C ) ) ) ) )).

% mult.assoc
thf(fact_226_mult_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type @ A ) )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B2: A] :
              ( times_times @ A @ B2 @ A4 ) ) ) ) )).

% mult.commute
thf(fact_227_mult_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( times_times @ A @ B @ ( times_times @ A @ A2 @ C ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B @ C ) ) ) ) )).

% mult.left_commute
thf(fact_228_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_229_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_230_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add.assoc
thf(fact_231_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
          = ( B = C ) ) ) )).

% add.left_cancel
thf(fact_232_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
          = ( B = C ) ) ) )).

% add.right_cancel
thf(fact_233_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B2: A] :
              ( plus_plus @ A @ B2 @ A4 ) ) ) ) )).

% add.commute
thf(fact_234_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( plus_plus @ A @ B @ ( plus_plus @ A @ A2 @ C ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add.left_commute
thf(fact_235_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
         => ( B = C ) ) ) )).

% add_left_imp_eq
thf(fact_236_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
         => ( B = C ) ) ) )).

% add_right_imp_eq
thf(fact_237_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type @ A ) )
     => ! [X5: A] :
          ( ( ( one_one @ A )
            = X5 )
          = ( X5
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_238_zero__le,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type @ A ) )
     => ! [X5: A] :
          ( ord_less_eq @ A @ ( zero_zero @ A ) @ X5 ) ) )).

% zero_le
thf(fact_239_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_240_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_241_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_242_add__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ C @ D )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) ) )).

% add_mono
thf(fact_243_add__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) ) ) ) )).

% add_left_mono
thf(fact_244_add__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add_right_mono
thf(fact_245_le__iff__add,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B2: A] :
            ? [C2: A] :
              ( B2
              = ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) )).

% le_iff_add
thf(fact_246_add__le__imp__le__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
         => ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_imp_le_left
thf(fact_247_add__le__imp__le__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
         => ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_imp_le_right
thf(fact_248_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_add_class.add_0
thf(fact_249_add_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.comm_neutral
thf(fact_250_add_Ogroup__left__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.group_left_neutral

%----Type constructors (108)
thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ( ordere516151231imp_le @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    ( semiri1923998003cancel @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ( ordere236663937imp_le @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    ( linord1659791738miring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    ( semiri1193490041visors @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    ( linord219039673up_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ( ring_11004092258visors @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    ( linord581940658strict @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ( ordere1490568538miring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    ( linord1278240602ring_1 @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ( ordered_semiring_0 @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ( ab_semigroup_mult @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ( ordered_semiring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    ( comm_monoid_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    ( linordered_ring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    ( linordered_idom @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    ( semigroup_mult @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    ( semiring_numeral @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    ( comm_semiring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    ( semiring_char_0 @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    ( zero_neq_one @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ( ordered_ring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    ( monoid_mult @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    ( monoid_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    ( semiring_1 @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    ( group_add @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    ( mult_zero @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    ( neg_numeral @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    ( semiring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    ( numeral @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    ( zero @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ( ring @ int @ ( type @ int ) )).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    ( one @ int @ ( type @ int ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_1,axiom,
    ( ordere516151231imp_le @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_2,axiom,
    ( semiri1923998003cancel @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_3,axiom,
    ( ordere236663937imp_le @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_4,axiom,
    ( linord1659791738miring @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_5,axiom,
    ( semiri1193490041visors @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_6,axiom,
    ( ordere779506340up_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_7,axiom,
    ( cancel1352612707id_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_8,axiom,
    ( ordere1490568538miring @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_9,axiom,
    ( cancel_semigroup_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_10,axiom,
    ( ordered_semiring_0 @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_11,axiom,
    ( linordered_semidom @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_12,axiom,
    ( ab_semigroup_mult @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_13,axiom,
    ( ab_semigroup_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_14,axiom,
    ( ordered_semiring @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_15,axiom,
    ( comm_monoid_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_16,axiom,
    ( semigroup_mult @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_17,axiom,
    ( semiring_numeral @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_18,axiom,
    ( semigroup_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_19,axiom,
    ( comm_semiring @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_20,axiom,
    ( semiring_char_0 @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_21,axiom,
    ( zero_neq_one @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_22,axiom,
    ( monoid_mult @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add_23,axiom,
    ( monoid_add @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__1_24,axiom,
    ( semiring_1 @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Omult__zero_25,axiom,
    ( mult_zero @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring_26,axiom,
    ( semiring @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Num_Onumeral_27,axiom,
    ( numeral @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero_28,axiom,
    ( zero @ nat @ ( type @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oone_29,axiom,
    ( one @ nat @ ( type @ nat ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_30,axiom,
    ( ordere516151231imp_le @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_31,axiom,
    ( semiri1923998003cancel @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_32,axiom,
    ( ordere236663937imp_le @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_33,axiom,
    ( linord1659791738miring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_34,axiom,
    ( semiri1193490041visors @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_35,axiom,
    ( ordere779506340up_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_36,axiom,
    ( linord219039673up_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_37,axiom,
    ( ring_11004092258visors @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_38,axiom,
    ( cancel1352612707id_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_39,axiom,
    ( linord581940658strict @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_40,axiom,
    ( ordere1490568538miring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_41,axiom,
    ( linord1278240602ring_1 @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_42,axiom,
    ( cancel_semigroup_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_43,axiom,
    ( ordered_semiring_0 @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_44,axiom,
    ( linordered_semidom @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_45,axiom,
    ( ab_semigroup_mult @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_46,axiom,
    ( ab_semigroup_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_47,axiom,
    ( ordered_semiring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_48,axiom,
    ( comm_monoid_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_49,axiom,
    ( linordered_ring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_50,axiom,
    ( linordered_idom @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_51,axiom,
    ( semigroup_mult @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_52,axiom,
    ( semiring_numeral @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_53,axiom,
    ( semigroup_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_54,axiom,
    ( comm_semiring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_55,axiom,
    ( semiring_char_0 @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_56,axiom,
    ( zero_neq_one @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Oordered__ring_57,axiom,
    ( ordered_ring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_58,axiom,
    ( monoid_mult @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Omonoid__add_59,axiom,
    ( monoid_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring__1_60,axiom,
    ( semiring_1 @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Ogroup__add_61,axiom,
    ( group_add @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Omult__zero_62,axiom,
    ( mult_zero @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Num_Oneg__numeral_63,axiom,
    ( neg_numeral @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring_64,axiom,
    ( semiring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Num_Onumeral_65,axiom,
    ( numeral @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Ozero_66,axiom,
    ( zero @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring_67,axiom,
    ( ring @ real @ ( type @ real ) )).

thf(tcon_Real_Oreal___Groups_Oone_68,axiom,
    ( one @ real @ ( type @ real ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type @ a ) )).

%----Conjectures (4)
thf(conj_0,hypothesis,(
    $true )).

thf(conj_1,hypothesis,
    ( ord_less_eq @ real @ ( plus_plus @ real @ ( splay_1414789891is_Phi @ a @ l ) @ ( plus_plus @ real @ ( splay_1414789891is_Phi @ a @ r ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( splay_914434265_splay @ a @ a2 @ s ) ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ l ) ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ r ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( plus_plus @ real @ ( splay_1414789891is_Phi @ a @ s ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ s ) ) ) ) ) ) ) )).

thf(conj_2,hypothesis,(
    $true )).

thf(conj_3,conjecture,
    ( ord_less_eq @ real @ ( plus_plus @ real @ ( splay_1414789891is_Phi @ a @ l ) @ ( plus_plus @ real @ ( splay_1414789891is_Phi @ a @ r ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( splay_914434265_splay @ a @ a2 @ s ) ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ l ) ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ r ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) @ ( plus_plus @ real @ ( splay_1414789891is_Phi @ a @ s ) @ ( plus_plus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ s ) ) ) ) ) ) ) )).

%------------------------------------------------------------------------------
