%------------------------------------------------------------------------------
% File     : DAT217^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Splay tree analysis 341
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [Nip14] Nipkow (2014), Amortized Complexity Verified
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : splay_tree_analysis__341.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  440 (   0 unit;  66 type;   0 defn)
%            Number of atoms       : 4695 ( 279 equality;2261 variable)
%            Maximal formula depth :   17 (   7 average)
%            Number of connectives : 3831 (  32   ~;   8   |;  18   &;3484   @)
%                                         (   0 <=>; 289  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   96 (  96   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   70 (  66   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :  822 (   0 sgn; 738   !;   8   ?;  23   ^)
%                                         ( 822   :;  53  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:51:15.291
%------------------------------------------------------------------------------
%----Could-be-implicit typings (8)
thf(ty_t_Tree_Otree,type,(
    tree: $tType > $tType )).

thf(ty_t_Real_Oreal,type,(
    real: $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Num_Onum,type,(
    num: $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_Int_Oint,type,(
    int: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (58)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oone,type,(
    one: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oidom,type,(
    idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring,type,(
    ring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Onumeral,type,(
    numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring__1,type,(
    ring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring,type,(
    semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Oring__char__0,type,(
    ring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Oneg__numeral,type,(
    neg_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__1,type,(
    semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__ring__1,type,(
    comm_ring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__mult,type,(
    monoid_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__group__add,type,(
    ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osemiring__char__0,type,(
    semiring_char_0: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring,type,(
    comm_semiring: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Num_Osemiring__numeral,type,(
    semiring_numeral: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__mult,type,(
    semigroup_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring__1,type,(
    comm_semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__idom,type,(
    linordered_idom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Fields_Olinordered__field,type,(
    linordered_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,(
    comm_monoid_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__mult,type,(
    ab_semigroup_mult: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Olinordered__semidom,type,(
    linordered_semidom: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,(
    ring_11004092258visors: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,(
    archim1804426504_field: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,(
    ordere236663937imp_le: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,(
    semiri456707255roduct: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Groups_Oone__class_Oone,type,(
    one_one: 
      !>[A: $tType] : A )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Otimes__class_Otimes,type,(
    times_times: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,(
    semiring_1_of_nat: 
      !>[A: $tType] :
        ( nat > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,(
    neg_numeral_dbl: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Num_Onum_OBit0,type,(
    bit0: num > num )).

thf(sy_c_Num_Onum_OOne,type,(
    one2: num )).

thf(sy_c_Num_Onumeral__class_Onumeral,type,(
    numeral_numeral: 
      !>[A: $tType] :
        ( num > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Transcendental_Olog,type,(
    log: real > real > real )).

thf(sy_c_Tree_Osize1,type,(
    size1: 
      !>[A: $tType] :
        ( ( tree @ A ) > nat ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_l____,type,(
    l: ( tree @ a ) )).

thf(sy_v_r____,type,(
    r: ( tree @ a ) )).

%----Relevant facts (252)
thf(fact_0__092_060open_062log_A2_A_I2_A_L_Areal_A_Isize_Ar_J_J_A_092_060le_062_Alog_A2_A_Ireal_A_Isize1_Al_J_A_L_Areal_A_Isize1_Ar_J_J_092_060close_062,axiom,
    ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( size_size @ ( tree @ a ) @ r ) ) ) ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size1 @ a @ l ) ) @ ( semiring_1_of_nat @ real @ ( size1 @ a @ r ) ) ) ) )).

% \<open>log 2 (2 + real (size r)) \<le> log 2 (real (size1 l) + real (size1 r))\<close>
thf(fact_1_one__add__one,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )).

% one_add_one
thf(fact_2_numeral__plus__one,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) )).

% numeral_plus_one
thf(fact_3_one__plus__numeral,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) )).

% one_plus_numeral
thf(fact_4_numeral__le__one__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) )).

% numeral_le_one_iff
thf(fact_5_numeral__eq__one__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) )).

% numeral_eq_one_iff
thf(fact_6_one__eq__numeral__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) )).

% one_eq_numeral_iff
thf(fact_7_distrib__left__numeral,axiom,(
    ! [A: $tType] :
      ( ( ( numeral @ A @ ( type2 @ A ) )
        & ( semiring @ A @ ( type2 @ A ) ) )
     => ! [V: num,B: A,C: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C ) ) ) ) )).

% distrib_left_numeral
thf(fact_8_distrib__right__numeral,axiom,(
    ! [A: $tType] :
      ( ( ( numeral @ A @ ( type2 @ A ) )
        & ( semiring @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B @ ( numeral_numeral @ A @ V ) ) ) ) ) )).

% distrib_right_numeral
thf(fact_9_of__nat__1,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) )).

% of_nat_1
thf(fact_10_of__nat__add,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) )).

% of_nat_add
thf(fact_11_of__nat__numeral,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) )).

% of_nat_numeral
thf(fact_12_num_Oinject_I1_J,axiom,(
    ! [X2: num,Y2: num] :
      ( ( ( bit0 @ X2 )
        = ( bit0 @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% num.inject(1)
thf(fact_13_numeral__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) )).

% numeral_eq_iff
thf(fact_14_of__nat__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( semiring_char_0 @ A @ ( type2 @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) )).

% of_nat_eq_iff
thf(fact_15_nat__add__left__cancel__le,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) )).

% nat_add_left_cancel_le
thf(fact_16_nat__1__eq__mult__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) )).

% nat_1_eq_mult_iff
thf(fact_17_nat__mult__eq__1__iff,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) )).

% nat_mult_eq_1_iff
thf(fact_18_numeral__times__numeral,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) )).

% numeral_times_numeral
thf(fact_19_of__nat__le__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) )).

% of_nat_le_iff
thf(fact_20_of__nat__mult,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) )).

% of_nat_mult
thf(fact_21_numeral__plus__numeral,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) )).

% numeral_plus_numeral
thf(fact_22_add__numeral__left,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) )).

% add_numeral_left
thf(fact_23_numeral__le__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) )).

% numeral_le_iff
thf(fact_24_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) )).

% numerals(1)
thf(fact_25_add__leE,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) )).

% add_leE
thf(fact_26_le__add1,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) )).

% le_add1
thf(fact_27_le__add2,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) )).

% le_add2
thf(fact_28_add__leD1,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) )).

% add_leD1
thf(fact_29_add__leD2,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) )).

% add_leD2
thf(fact_30_le__Suc__ex,axiom,(
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N2 ) ) ) )).

% le_Suc_ex
thf(fact_31_nat__mult__1,axiom,(
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) )).

% nat_mult_1
thf(fact_32_add__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) )).

% add_le_mono
thf(fact_33_add__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) )).

% add_le_mono1
thf(fact_34_zadd__int__left,axiom,(
    ! [M: nat,N: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z ) ) )).

% zadd_int_left
thf(fact_35_trans__le__add1,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) )).

% trans_le_add1
thf(fact_36_trans__le__add2,axiom,(
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) )).

% trans_le_add2
thf(fact_37_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M2: nat,N3: nat] :
        ? [K2: nat] :
          ( N3
          = ( plus_plus @ nat @ M2 @ K2 ) ) ) )).

% nat_le_iff_add
thf(fact_38_add__mult__distrib,axiom,(
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) )).

% add_mult_distrib
thf(fact_39_nat__mult__1__right,axiom,(
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) )).

% nat_mult_1_right
thf(fact_40_add__mult__distrib2,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) )).

% add_mult_distrib2
thf(fact_41_nat__add__left__cancel,axiom,(
    ! [K: nat,M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ K @ M )
        = ( plus_plus @ nat @ K @ N ) )
      = ( M = N ) ) )).

% nat_add_left_cancel
thf(fact_42_nat__add__right__cancel,axiom,(
    ! [M: nat,K: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ K )
        = ( plus_plus @ nat @ N @ K ) )
      = ( M = N ) ) )).

% nat_add_right_cancel
thf(fact_43_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )).

% nat_1_add_1
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_add__One__commute,axiom,(
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) )).

% add_One_commute
thf(fact_48_le__num__One__iff,axiom,(
    ! [X4: num] :
      ( ( ord_less_eq @ num @ X4 @ one2 )
      = ( X4 = one2 ) ) )).

% le_num_One_iff
thf(fact_49_is__num__normalize_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% is_num_normalize(1)
thf(fact_50_le__numeral__extra_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) )).

% le_numeral_extra(4)
thf(fact_51_num_Odistinct_I1_J,axiom,(
    ! [X2: num] :
      ( one2
     != ( bit0 @ X2 ) ) )).

% num.distinct(1)
thf(fact_52_mult__of__nat__commute,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [X4: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X4 ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X4 ) ) ) ) )).

% mult_of_nat_commute
thf(fact_53_one__le__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_semidom @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) )).

% one_le_numeral
thf(fact_54_numeral__Bit0,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) )).

% numeral_Bit0
thf(fact_55_mult__numeral__1__right,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) )).

% mult_numeral_1_right
thf(fact_56_mult__numeral__1,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) )).

% mult_numeral_1
thf(fact_57_one__plus__numeral__commute,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ! [X4: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X4 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X4 ) @ ( one_one @ A ) ) ) ) )).

% one_plus_numeral_commute
thf(fact_58_numeral__One,axiom,(
    ! [A: $tType] :
      ( ( numeral @ A @ ( type2 @ A ) )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) )).

% numeral_One
thf(fact_59_mult__2__right,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) )).

% mult_2_right
thf(fact_60_mult__2,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) )).

% mult_2
thf(fact_61_numeral__le__real__of__nat__iff,axiom,(
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) )).

% numeral_le_real_of_nat_iff
thf(fact_62_semiring__norm_I69_J,axiom,(
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) )).

% semiring_norm(69)
thf(fact_63_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) )).

% semiring_norm(2)
thf(fact_64_semiring__norm_I68_J,axiom,(
    ! [N: num] :
      ( ord_less_eq @ num @ one2 @ N ) )).

% semiring_norm(68)
thf(fact_65_semiring__norm_I71_J,axiom,(
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) )).

% semiring_norm(71)
thf(fact_66_semiring__norm_I6_J,axiom,(
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) )).

% semiring_norm(6)
thf(fact_67_mult_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% mult.right_neutral
thf(fact_68_mult_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% mult.left_neutral
thf(fact_69_semiring__norm_I83_J,axiom,(
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) )).

% semiring_norm(83)
thf(fact_70_semiring__norm_I85_J,axiom,(
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) )).

% semiring_norm(85)
thf(fact_71_semiring__norm_I169_J,axiom,(
    ! [A: $tType] :
      ( ( semiring_numeral @ A @ ( type2 @ A ) )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) )).

% semiring_norm(169)
thf(fact_72_semiring__norm_I87_J,axiom,(
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) )).

% semiring_norm(87)
thf(fact_73_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
          = ( B = C ) ) ) )).

% add_left_cancel
thf(fact_74_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
          = ( B = C ) ) ) )).

% add_right_cancel
thf(fact_75_add__le__cancel__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_cancel_left
thf(fact_76_add__le__cancel__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_cancel_right
thf(fact_77_semiring__norm_I13_J,axiom,(
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) )).

% semiring_norm(13)
thf(fact_78_semiring__norm_I12_J,axiom,(
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) )).

% semiring_norm(12)
thf(fact_79_semiring__norm_I11_J,axiom,(
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) )).

% semiring_norm(11)
thf(fact_80_int__distrib_I2_J,axiom,(
    ! [W: int,Z1: int,Z2: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z2 ) ) ) )).

% int_distrib(2)
thf(fact_81_int__distrib_I1_J,axiom,(
    ! [Z1: int,Z2: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z2 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z2 @ W ) ) ) )).

% int_distrib(1)
thf(fact_82_zle__int,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) )).

% zle_int
thf(fact_83_le__cube,axiom,(
    ! [M: nat] :
      ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) )).

% le_cube
thf(fact_84_le__refl,axiom,(
    ! [N: nat] :
      ( ord_less_eq @ nat @ N @ N ) )).

% le_refl
thf(fact_85_le__trans,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) )).

% le_trans
thf(fact_86_eq__imp__le,axiom,(
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) )).

% eq_imp_le
thf(fact_87_le__square,axiom,(
    ! [M: nat] :
      ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) )).

% le_square
thf(fact_88_int__int__eq,axiom,(
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) )).

% int_int_eq
thf(fact_89_le__antisym,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) )).

% le_antisym
thf(fact_90_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W2: int,Z3: int] :
        ? [N3: nat] :
          ( Z3
          = ( plus_plus @ int @ W2 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) )).

% zle_iff_zadd
thf(fact_91_mult__le__mono,axiom,(
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) )).

% mult_le_mono
thf(fact_92_int__ge__induct,axiom,(
    ! [K: int,I: int,P: ( int > $o )] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) )).

% int_ge_induct
thf(fact_93_mult__le__mono1,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) )).

% mult_le_mono1
thf(fact_94_mult__le__mono2,axiom,(
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) )).

% mult_le_mono2
thf(fact_95_nat__le__linear,axiom,(
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) )).

% nat_le_linear
thf(fact_96_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B ) @ C )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B @ C ) ) ) ) )).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_97_mult_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_mult @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B ) @ C )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B @ C ) ) ) ) )).

% mult.assoc
thf(fact_98_mult_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type2 @ A ) )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B2: A] :
              ( times_times @ A @ B2 @ A4 ) ) ) ) )).

% mult.commute
thf(fact_99_mult_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( times_times @ A @ B @ ( times_times @ A @ A2 @ C ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B @ C ) ) ) ) )).

% mult.left_commute
thf(fact_100_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_101_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_102_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add.assoc
thf(fact_103_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
          = ( B = C ) ) ) )).

% add.left_cancel
thf(fact_104_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
          = ( B = C ) ) ) )).

% add.right_cancel
thf(fact_105_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B2: A] :
              ( plus_plus @ A @ B2 @ A4 ) ) ) ) )).

% add.commute
thf(fact_106_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( plus_plus @ A @ B @ ( plus_plus @ A @ A2 @ C ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add.left_commute
thf(fact_107_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ( plus_plus @ A @ A2 @ B )
            = ( plus_plus @ A @ A2 @ C ) )
         => ( B = C ) ) ) )).

% add_left_imp_eq
thf(fact_108_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ( plus_plus @ A @ B @ A2 )
            = ( plus_plus @ A @ C @ A2 ) )
         => ( B = C ) ) ) )).

% add_right_imp_eq
thf(fact_109_one__reorient,axiom,(
    ! [A: $tType] :
      ( ( one @ A @ ( type2 @ A ) )
     => ! [X4: A] :
          ( ( ( one_one @ A )
            = X4 )
          = ( X4
            = ( one_one @ A ) ) ) ) )).

% one_reorient
thf(fact_110_complete__real,axiom,(
    ! [S: ( set @ real )] :
      ( ? [X5: real] :
          ( member @ real @ X5 @ S )
     => ( ? [Z4: real] :
          ! [X3: real] :
            ( ( member @ real @ X3 @ S )
           => ( ord_less_eq @ real @ X3 @ Z4 ) )
       => ? [Y3: real] :
            ( ! [X5: real] :
                ( ( member @ real @ X5 @ S )
               => ( ord_less_eq @ real @ X5 @ Y3 ) )
            & ! [Z4: real] :
                ( ! [X3: real] :
                    ( ( member @ real @ X3 @ S )
                   => ( ord_less_eq @ real @ X3 @ Z4 ) )
               => ( ord_less_eq @ real @ Y3 @ Z4 ) ) ) ) ) )).

% complete_real
thf(fact_111_left__add__mult__distrib,axiom,(
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I @ J ) @ U ) @ K ) ) )).

% left_add_mult_distrib
thf(fact_112_add__mono__thms__linordered__semiring_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(3)
thf(fact_113_add__mono__thms__linordered__semiring_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(2)
thf(fact_114_add__mono__thms__linordered__semiring_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(1)
thf(fact_115_add__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ C @ D )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) ) )).

% add_mono
thf(fact_116_add__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) ) ) ) )).

% add_left_mono
thf(fact_117_add__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% add_right_mono
thf(fact_118_le__iff__add,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B2: A] :
            ? [C2: A] :
              ( B2
              = ( plus_plus @ A @ A4 @ C2 ) ) ) ) ) )).

% le_iff_add
thf(fact_119_add__le__imp__le__left,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [C: A,A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C @ A2 ) @ ( plus_plus @ A @ C @ B ) )
         => ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_imp_le_left
thf(fact_120_add__le__imp__le__right,axiom,(
    ! [A: $tType] :
      ( ( ordere236663937imp_le @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,B: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ C ) )
         => ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% add_le_imp_le_right
thf(fact_121_comm__monoid__mult__class_Omult__1,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_mult_class.mult_1
thf(fact_122_mult_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% mult.comm_neutral
thf(fact_123_size1__def,axiom,(
    ! [A: $tType] :
      ( ( size1 @ A )
      = ( ^ [T: ( tree @ A )] :
            ( plus_plus @ nat @ ( size_size @ ( tree @ A ) @ T ) @ ( one_one @ nat ) ) ) ) )).

% size1_def
thf(fact_124_transfer__int__nat__numerals_I3_J,axiom,
    ( ( numeral_numeral @ int @ ( bit0 @ one2 ) )
    = ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )).

% transfer_int_nat_numerals(3)
thf(fact_125_Nat__Transfer_Otransfer__int__nat__functions_I1_J,axiom,(
    ! [X4: nat,Y: nat] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ X4 ) @ ( semiring_1_of_nat @ int @ Y ) )
      = ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ X4 @ Y ) ) ) )).

% Nat_Transfer.transfer_int_nat_functions(1)
thf(fact_126_dbl__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )).

% dbl_simps(3)
thf(fact_127_semiring__normalization__rules_I4_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [M: A] :
          ( ( plus_plus @ A @ M @ M )
          = ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) @ M ) ) ) )).

% semiring_normalization_rules(4)
thf(fact_128_semiring__normalization__rules_I3_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [M: A,A2: A] :
          ( ( plus_plus @ A @ M @ ( times_times @ A @ A2 @ M ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) )).

% semiring_normalization_rules(3)
thf(fact_129_dbl__simps_I5_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) )).

% dbl_simps(5)
thf(fact_130_dbl__def,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X: A] :
              ( plus_plus @ A @ X @ X ) ) ) ) )).

% dbl_def
thf(fact_131_semiring__normalization__rules_I7_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B2: A] :
              ( times_times @ A @ B2 @ A4 ) ) ) ) )).

% semiring_normalization_rules(7)
thf(fact_132_semiring__normalization__rules_I13_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ ( times_times @ A @ Lx @ Rx ) @ ( times_times @ A @ Ly @ Ry ) ) ) ) )).

% semiring_normalization_rules(13)
thf(fact_133_semiring__normalization__rules_I14_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ Lx @ ( times_times @ A @ Ly @ ( times_times @ A @ Rx @ Ry ) ) ) ) ) )).

% semiring_normalization_rules(14)
thf(fact_134_semiring__normalization__rules_I15_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ Rx @ ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ Ry ) ) ) ) )).

% semiring_normalization_rules(15)
thf(fact_135_semiring__normalization__rules_I16_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ Rx )
          = ( times_times @ A @ ( times_times @ A @ Lx @ Rx ) @ Ly ) ) ) )).

% semiring_normalization_rules(16)
thf(fact_136_semiring__normalization__rules_I17_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Ly: A,Rx: A] :
          ( ( times_times @ A @ ( times_times @ A @ Lx @ Ly ) @ Rx )
          = ( times_times @ A @ Lx @ ( times_times @ A @ Ly @ Rx ) ) ) ) )).

% semiring_normalization_rules(17)
thf(fact_137_semiring__normalization__rules_I18_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ Lx @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ ( times_times @ A @ Lx @ Rx ) @ Ry ) ) ) )).

% semiring_normalization_rules(18)
thf(fact_138_semiring__normalization__rules_I19_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [Lx: A,Rx: A,Ry: A] :
          ( ( times_times @ A @ Lx @ ( times_times @ A @ Rx @ Ry ) )
          = ( times_times @ A @ Rx @ ( times_times @ A @ Lx @ Ry ) ) ) ) )).

% semiring_normalization_rules(19)
thf(fact_139_semiring__normalization__rules_I20_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ ( plus_plus @ A @ C @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C ) @ ( plus_plus @ A @ B @ D ) ) ) ) )).

% semiring_normalization_rules(20)
thf(fact_140_semiring__normalization__rules_I21_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B @ C ) ) ) ) )).

% semiring_normalization_rules(21)
thf(fact_141_semiring__normalization__rules_I22_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C @ D ) )
          = ( plus_plus @ A @ C @ ( plus_plus @ A @ A2 @ D ) ) ) ) )).

% semiring_normalization_rules(22)
thf(fact_142_semiring__normalization__rules_I23_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C ) @ B ) ) ) )).

% semiring_normalization_rules(23)
thf(fact_143_semiring__normalization__rules_I24_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,C2: A] :
              ( plus_plus @ A @ C2 @ A4 ) ) ) ) )).

% semiring_normalization_rules(24)
thf(fact_144_semiring__normalization__rules_I25_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,C: A,D: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ C @ D ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ A2 @ C ) @ D ) ) ) )).

% semiring_normalization_rules(25)
thf(fact_145_int__if__cong,axiom,(
    ! [P: $o,X4: nat,Y: nat] :
      ( ( P
       => ( ( semiring_1_of_nat @ int @ X4 )
          = ( semiring_1_of_nat @ int @ ( if @ nat @ P @ X4 @ Y ) ) ) )
      & ( ~ ( P )
       => ( ( semiring_1_of_nat @ int @ Y )
          = ( semiring_1_of_nat @ int @ ( if @ nat @ P @ X4 @ Y ) ) ) ) ) )).

% int_if_cong
thf(fact_146_transfer__int__nat__relations_I1_J,axiom,(
    ! [X4: nat,Y: nat] :
      ( ( ( semiring_1_of_nat @ int @ X4 )
        = ( semiring_1_of_nat @ int @ Y ) )
      = ( X4 = Y ) ) )).

% transfer_int_nat_relations(1)
thf(fact_147_crossproduct__noteq,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A,D: A] :
          ( ( ( A2 != B )
            & ( C != D ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ D ) )
           != ( plus_plus @ A @ ( times_times @ A @ A2 @ D ) @ ( times_times @ A @ B @ C ) ) ) ) ) )).

% crossproduct_noteq
thf(fact_148_crossproduct__eq,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [W: A,Y: A,X4: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y ) @ ( times_times @ A @ X4 @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X4 @ Y ) ) )
          = ( ( W = X4 )
            | ( Y = Z ) ) ) ) )).

% crossproduct_eq
thf(fact_149_semiring__normalization__rules_I1_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,M: A,B: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ M ) @ ( times_times @ A @ B @ M ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ M ) ) ) )).

% semiring_normalization_rules(1)
thf(fact_150_semiring__normalization__rules_I8_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% semiring_normalization_rules(8)
thf(fact_151_semiring__normalization__rules_I34_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A,Z: A] :
          ( ( times_times @ A @ X4 @ ( plus_plus @ A @ Y @ Z ) )
          = ( plus_plus @ A @ ( times_times @ A @ X4 @ Y ) @ ( times_times @ A @ X4 @ Z ) ) ) ) )).

% semiring_normalization_rules(34)
thf(fact_152_semiring__normalization__rules_I11_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) )).

% semiring_normalization_rules(11)
thf(fact_153_semiring__normalization__rules_I12_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) )).

% semiring_normalization_rules(12)
thf(fact_154_transfer__int__nat__relations_I3_J,axiom,(
    ! [X4: nat,Y: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ X4 ) @ ( semiring_1_of_nat @ int @ Y ) )
      = ( ord_less_eq @ nat @ X4 @ Y ) ) )).

% transfer_int_nat_relations(3)
thf(fact_155_Nat__Transfer_Otransfer__int__nat__functions_I2_J,axiom,(
    ! [X4: nat,Y: nat] :
      ( ( times_times @ int @ ( semiring_1_of_nat @ int @ X4 ) @ ( semiring_1_of_nat @ int @ Y ) )
      = ( semiring_1_of_nat @ int @ ( times_times @ nat @ X4 @ Y ) ) ) )).

% Nat_Transfer.transfer_int_nat_functions(2)
thf(fact_156_transfer__int__nat__numerals_I2_J,axiom,
    ( ( one_one @ int )
    = ( semiring_1_of_nat @ int @ ( one_one @ nat ) ) )).

% transfer_int_nat_numerals(2)
thf(fact_157_semiring__normalization__rules_I2_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A,M: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ M ) @ M )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) )).

% semiring_normalization_rules(2)
thf(fact_158_upto_Oinduct,axiom,(
    ! [P: ( int > int > $o ),A0: int,A1: int] :
      ( ! [I2: int,J2: int] :
          ( ( ( ord_less_eq @ int @ I2 @ J2 )
           => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) )
         => ( P @ I2 @ J2 ) )
     => ( P @ A0 @ A1 ) ) )).

% upto.induct
thf(fact_159_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X4: A] :
          ( ord_less_eq @ A @ X4 @ X4 ) ) )).

% order_refl
thf(fact_160_real__arch__simple,axiom,(
    ! [A: $tType] :
      ( ( archim1804426504_field @ A @ ( type2 @ A ) )
     => ! [X4: A] :
        ? [N2: nat] :
          ( ord_less_eq @ A @ X4 @ ( semiring_1_of_nat @ A @ N2 ) ) ) )).

% real_arch_simple
thf(fact_161_combine__common__factor,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,E: A,B: A,C: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E ) @ ( plus_plus @ A @ ( times_times @ A @ B @ E ) @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ E ) @ C ) ) ) )).

% combine_common_factor
thf(fact_162_le__funD,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ! [F: ( A > B3 ),G: ( A > B3 ),X4: A] :
          ( ( ord_less_eq @ ( A > B3 ) @ F @ G )
         => ( ord_less_eq @ B3 @ ( F @ X4 ) @ ( G @ X4 ) ) ) ) )).

% le_funD
thf(fact_163_le__funE,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ! [F: ( A > B3 ),G: ( A > B3 ),X4: A] :
          ( ( ord_less_eq @ ( A > B3 ) @ F @ G )
         => ( ord_less_eq @ B3 @ ( F @ X4 ) @ ( G @ X4 ) ) ) ) )).

% le_funE
thf(fact_164_le__funI,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ! [F: ( A > B3 ),G: ( A > B3 )] :
          ( ! [X3: A] :
              ( ord_less_eq @ B3 @ ( F @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B3 ) @ F @ G ) ) ) )).

% le_funI
thf(fact_165_le__fun__def,axiom,(
    ! [B3: $tType,A: $tType] :
      ( ( ord @ B3 @ ( type2 @ B3 ) )
     => ( ( ord_less_eq @ ( A > B3 ) )
        = ( ^ [F2: ( A > B3 ),G2: ( A > B3 )] :
            ! [X: A] :
              ( ord_less_eq @ B3 @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ) )).

% le_fun_def
thf(fact_166_order__subst1,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( order @ B3 @ ( type2 @ B3 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B3 > A ),B: B3,C: B3] :
          ( ( ord_less_eq @ A @ A2 @ ( F @ B ) )
         => ( ( ord_less_eq @ B3 @ B @ C )
           => ( ! [X3: B3,Y3: B3] :
                  ( ( ord_less_eq @ B3 @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% order_subst1
thf(fact_167_order__subst2,axiom,(
    ! [A: $tType,C3: $tType] :
      ( ( ( order @ C3 @ ( type2 @ C3 ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B: A,F: ( A > C3 ),C: C3] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ C3 @ ( F @ B ) @ C )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ C3 @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ C3 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% order_subst2
thf(fact_168_ord__eq__le__subst,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( ord @ B3 @ ( type2 @ B3 ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,F: ( B3 > A ),B: B3,C: B3] :
          ( ( A2
            = ( F @ B ) )
         => ( ( ord_less_eq @ B3 @ B @ C )
           => ( ! [X3: B3,Y3: B3] :
                  ( ( ord_less_eq @ B3 @ X3 @ Y3 )
                 => ( ord_less_eq @ A @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F @ C ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_169_ord__le__eq__subst,axiom,(
    ! [A: $tType,B3: $tType] :
      ( ( ( ord @ B3 @ ( type2 @ B3 ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A2: A,B: A,F: ( A > B3 ),C: B3] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ( F @ B )
              = C )
           => ( ! [X3: A,Y3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y3 )
                 => ( ord_less_eq @ B3 @ ( F @ X3 ) @ ( F @ Y3 ) ) )
             => ( ord_less_eq @ B3 @ ( F @ A2 ) @ C ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_170_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y4: A,Z5: A] : ( Y4 = Z5 ) )
        = ( ^ [X: A,Y5: A] :
              ( ( ord_less_eq @ A @ X @ Y5 )
              & ( ord_less_eq @ A @ Y5 @ X ) ) ) ) ) )).

% eq_iff
thf(fact_171_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( ord_less_eq @ A @ X4 @ Y )
         => ( ( ord_less_eq @ A @ Y @ X4 )
           => ( X4 = Y ) ) ) ) )).

% antisym
thf(fact_172_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( ord_less_eq @ A @ X4 @ Y )
          | ( ord_less_eq @ A @ Y @ X4 ) ) ) )).

% linear
thf(fact_173_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ( X4 = Y )
         => ( ord_less_eq @ A @ X4 @ Y ) ) ) )).

% eq_refl
thf(fact_174_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X4 @ Y )
         => ( ord_less_eq @ A @ Y @ X4 ) ) ) )).

% le_cases
thf(fact_175_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ B @ C )
           => ( ord_less_eq @ A @ A2 @ C ) ) ) ) )).

% order.trans
thf(fact_176_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X4 @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X4 )
             => ~ ( ord_less_eq @ A @ X4 @ Z ) )
           => ( ( ( ord_less_eq @ A @ X4 @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X4 ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X4 ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X4 )
                     => ~ ( ord_less_eq @ A @ X4 @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_177_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X4: A] :
          ( ( ord_less_eq @ A @ Y @ X4 )
         => ( ( ord_less_eq @ A @ X4 @ Y )
            = ( X4 = Y ) ) ) ) )).

% antisym_conv
thf(fact_178_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( A2 = B )
         => ( ( ord_less_eq @ A @ B @ C )
           => ( ord_less_eq @ A @ A2 @ C ) ) ) ) )).

% ord_eq_le_trans
thf(fact_179_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( B = C )
           => ( ord_less_eq @ A @ A2 @ C ) ) ) ) )).

% ord_le_eq_trans
thf(fact_180_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ( ord_less_eq @ A @ B @ A2 )
           => ( A2 = B ) ) ) ) )).

% order_class.order.antisym
thf(fact_181_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X4: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X4 @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X4 @ Z ) ) ) ) )).

% order_trans
thf(fact_182_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ A2 @ A2 ) ) )).

% dual_order.refl
thf(fact_183_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A2: A,B: A] :
          ( ! [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
             => ( P @ A5 @ B4 ) )
         => ( ! [A5: A,B4: A] :
                ( ( P @ B4 @ A5 )
               => ( P @ A5 @ B4 ) )
           => ( P @ A2 @ B ) ) ) ) )).

% linorder_wlog
thf(fact_184_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A,C: A] :
          ( ( ord_less_eq @ A @ B @ A2 )
         => ( ( ord_less_eq @ A @ C @ B )
           => ( ord_less_eq @ A @ C @ A2 ) ) ) ) )).

% dual_order.trans
thf(fact_185_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A] :
          ( ( ord_less_eq @ A @ B @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B )
           => ( A2 = B ) ) ) ) )).

% dual_order.antisym
thf(fact_186_ring__class_Oring__distribs_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% ring_class.ring_distribs(2)
thf(fact_187_ring__class_Oring__distribs_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B ) @ ( times_times @ A @ A2 @ C ) ) ) ) )).

% ring_class.ring_distribs(1)
thf(fact_188_comm__semiring__class_Odistrib,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% comm_semiring_class.distrib
thf(fact_189_distrib__left,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B ) @ ( times_times @ A @ A2 @ C ) ) ) ) )).

% distrib_left
thf(fact_190_distrib__right,axiom,(
    ! [A: $tType] :
      ( ( semiring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% distrib_right
thf(fact_191_linordered__field__class_Osign__simps_I36_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B @ C ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B ) @ ( times_times @ A @ A2 @ C ) ) ) ) )).

% linordered_field_class.sign_simps(36)
thf(fact_192_linordered__field__class_Osign__simps_I35_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_field @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A,C: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B ) @ C )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C ) @ ( times_times @ A @ B @ C ) ) ) ) )).

% linordered_field_class.sign_simps(35)
thf(fact_193_dbl__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) )).

% dbl_simps(4)
thf(fact_194_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B ) )
          = ( A2 = B ) ) ) )).

% neg_equal_iff_equal
thf(fact_195_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) )).

% add.inverse_inverse
thf(fact_196_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B ) ) ) )).

% neg_le_iff_le
thf(fact_197_mult__minus__left,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B ) ) ) ) )).

% mult_minus_left
thf(fact_198_minus__mult__minus,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B ) )
          = ( times_times @ A @ A2 @ B ) ) ) )).

% minus_mult_minus
thf(fact_199_mult__minus__right,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B ) ) ) ) )).

% mult_minus_right
thf(fact_200_neg__numeral__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) )).

% neg_numeral_eq_iff
thf(fact_201_add__minus__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B ) )
          = B ) ) )).

% add_minus_cancel
thf(fact_202_minus__add__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B ) )
          = B ) ) )).

% minus_add_cancel
thf(fact_203_minus__add__distrib,axiom,(
    ! [A: $tType] :
      ( ( ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B ) ) ) ) )).

% minus_add_distrib
thf(fact_204_negative__zle,axiom,(
    ! [N: nat,M: nat] :
      ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) )).

% negative_zle
thf(fact_205_mult__minus1__right,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) )).

% mult_minus1_right
thf(fact_206_mult__minus1,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) )).

% mult_minus1
thf(fact_207_add__neg__numeral__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) )).

% add_neg_numeral_simps(3)
thf(fact_208_dbl__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) )).

% dbl_simps(1)
thf(fact_209_numeral__eq__neg__one__iff,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) )).

% numeral_eq_neg_one_iff
thf(fact_210_neg__one__eq__numeral__iff,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) )).

% neg_one_eq_numeral_iff
thf(fact_211_semiring__norm_I168_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y ) ) ) )).

% semiring_norm(168)
thf(fact_212_mult__neg__numeral__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) )).

% mult_neg_numeral_simps(1)
thf(fact_213_mult__neg__numeral__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) )).

% mult_neg_numeral_simps(2)
thf(fact_214_mult__neg__numeral__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ring_1 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) )).

% mult_neg_numeral_simps(3)
thf(fact_215_semiring__norm_I170_J,axiom,(
    ! [B3: $tType] :
      ( ( ring_1 @ B3 @ ( type2 @ B3 ) )
     => ! [V: num,W: num,Y: B3] :
          ( ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ V ) ) @ ( times_times @ B3 @ ( numeral_numeral @ B3 @ W ) @ Y ) )
          = ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ ( times_times @ num @ V @ W ) ) ) @ Y ) ) ) )).

% semiring_norm(170)
thf(fact_216_semiring__norm_I171_J,axiom,(
    ! [B3: $tType] :
      ( ( ring_1 @ B3 @ ( type2 @ B3 ) )
     => ! [V: num,W: num,Y: B3] :
          ( ( times_times @ B3 @ ( numeral_numeral @ B3 @ V ) @ ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ W ) ) @ Y ) )
          = ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ ( times_times @ num @ V @ W ) ) ) @ Y ) ) ) )).

% semiring_norm(171)
thf(fact_217_semiring__norm_I172_J,axiom,(
    ! [B3: $tType] :
      ( ( ring_1 @ B3 @ ( type2 @ B3 ) )
     => ! [V: num,W: num,Y: B3] :
          ( ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ V ) ) @ ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ W ) ) @ Y ) )
          = ( times_times @ B3 @ ( numeral_numeral @ B3 @ ( times_times @ num @ V @ W ) ) @ Y ) ) ) )).

% semiring_norm(172)
thf(fact_218_neg__numeral__le__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) )).

% neg_numeral_le_iff
thf(fact_219_not__neg__one__le__neg__numeral__iff,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( M != one2 ) ) ) )).

% not_neg_one_le_neg_numeral_iff
thf(fact_220_add__neg__numeral__special_I9_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) )).

% add_neg_numeral_special(9)
thf(fact_221_square__eq__iff,axiom,(
    ! [A: $tType] :
      ( ( idom @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B @ B ) )
          = ( ( A2 = B )
            | ( A2
              = ( uminus_uminus @ A @ B ) ) ) ) ) )).

% square_eq_iff
thf(fact_222_minus__mult__commute,axiom,(
    ! [A: $tType] :
      ( ( ring @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B ) ) ) ) )).

% minus_mult_commute
thf(fact_223_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B )
          = ( ( uminus_uminus @ A @ B )
            = A2 ) ) ) )).

% minus_equation_iff
thf(fact_224_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B ) )
          = ( B
            = ( uminus_uminus @ A @ A2 ) ) ) ) )).

% equation_minus_iff
thf(fact_225_int__cases2,axiom,(
    ! [Z: int] :
      ( ! [N2: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ( ! [N2: nat] :
              ( Z
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) )).

% int_cases2
thf(fact_226_one__neq__neg__one,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% one_neq_neg_one
thf(fact_227_add_Oinverse__distrib__swap,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% add.inverse_distrib_swap
thf(fact_228_is__num__normalize_I8_J,axiom,(
    ! [A: $tType] :
      ( ( neg_numeral @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% is_num_normalize(8)
thf(fact_229_neg__numeral__neq__numeral,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) )).

% neg_numeral_neq_numeral
thf(fact_230_numeral__neq__neg__numeral,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) )).

% numeral_neq_neg_numeral
thf(fact_231_le__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B ) )
          = ( ord_less_eq @ A @ B @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% le_minus_iff
thf(fact_232_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B ) @ A2 ) ) ) )).

% minus_le_iff
thf(fact_233_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B: A] :
          ( ( ord_less_eq @ A @ A2 @ B )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B ) @ ( uminus_uminus @ A @ A2 ) ) ) ) )).

% le_imp_neg_le
thf(fact_234_not__numeral__le__neg__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) )).

% not_numeral_le_neg_numeral
thf(fact_235_neg__numeral__le__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num,N: num] :
          ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) )).

% neg_numeral_le_numeral
thf(fact_236_le__minus__one__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) )).

% le_minus_one_simps(2)
thf(fact_237_le__minus__one__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% le_minus_one_simps(4)
thf(fact_238_numeral__times__minus__swap,axiom,(
    ! [A: $tType] :
      ( ( comm_ring_1 @ A @ ( type2 @ A ) )
     => ! [W: num,X4: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X4 ) )
          = ( times_times @ A @ X4 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) )).

% numeral_times_minus_swap
thf(fact_239_ring__normalization__rules_I1_J,axiom,(
    ! [A: $tType] :
      ( ( comm_ring_1 @ A @ ( type2 @ A ) )
     => ( ( uminus_uminus @ A )
        = ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) )).

% ring_normalization_rules(1)
thf(fact_240_square__eq__1__iff,axiom,(
    ! [A: $tType] :
      ( ( ring_11004092258visors @ A @ ( type2 @ A ) )
     => ! [X4: A] :
          ( ( ( times_times @ A @ X4 @ X4 )
            = ( one_one @ A ) )
          = ( ( X4
              = ( one_one @ A ) )
            | ( X4
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) )).

% square_eq_1_iff
thf(fact_241_one__neq__neg__numeral,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) )).

% one_neq_neg_numeral
thf(fact_242_numeral__neq__neg__one,axiom,(
    ! [A: $tType] :
      ( ( ring_char_0 @ A @ ( type2 @ A ) )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% numeral_neq_neg_one
thf(fact_243_real__minus__mult__self__le,axiom,(
    ! [U: real,X4: real] :
      ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X4 @ X4 ) ) )).

% real_minus_mult_self_le
thf(fact_244_zmult__eq__1__iff,axiom,(
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) )).

% zmult_eq_1_iff
thf(fact_245_pos__zmult__eq__1__iff__lemma,axiom,(
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) )).

% pos_zmult_eq_1_iff_lemma
thf(fact_246_not__one__le__neg__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) )).

% not_one_le_neg_numeral
thf(fact_247_not__numeral__le__neg__one,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% not_numeral_le_neg_one
thf(fact_248_neg__numeral__le__neg__one,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num] :
          ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) )).

% neg_numeral_le_neg_one
thf(fact_249_neg__one__le__numeral,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num] :
          ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) )).

% neg_one_le_numeral
thf(fact_250_neg__numeral__le__one,axiom,(
    ! [A: $tType] :
      ( ( linordered_idom @ A @ ( type2 @ A ) )
     => ! [M: num] :
          ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) )).

% neg_numeral_le_one
thf(fact_251_mult__1s_I3_J,axiom,(
    ! [B3: $tType] :
      ( ( ring_1 @ B3 @ ( type2 @ B3 ) )
     => ! [B: B3] :
          ( ( times_times @ B3 @ ( uminus_uminus @ B3 @ ( numeral_numeral @ B3 @ one2 ) ) @ B )
          = ( uminus_uminus @ B3 @ B ) ) ) )).

% mult_1s(3)

%----Subclasses (4)
thf(subcl_Orderings_Olinorder___HOL_Otype,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( type @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oord,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ord @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Oorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( order @ A @ ( type2 @ A ) ) ) )).

thf(subcl_Orderings_Olinorder___Orderings_Opreorder,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( preorder @ A @ ( type2 @ A ) ) ) )).

%----Type constructors (113)
thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( preorder @ A7 @ ( type2 @ A7 ) )
     => ( preorder @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( uminus @ A7 @ ( type2 @ A7 ) )
     => ( uminus @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    ( semiri456707255roduct @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ( ordere236663937imp_le @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ( ring_11004092258visors @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ( ordered_ab_group_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    ( linordered_semidom @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ( ab_semigroup_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    ( comm_monoid_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    ( linordered_idom @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    ( comm_semiring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    ( semigroup_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    ( semiring_numeral @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    ( comm_semiring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    ( semiring_char_0 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ( ab_group_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Orderings_Opreorder_1,axiom,
    ( preorder @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    ( linorder @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    ( monoid_mult @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    ( comm_ring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    ( semiring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    ( group_add @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Orderings_Oorder_2,axiom,
    ( order @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    ( neg_numeral @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ( ring_char_0 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    ( semiring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Orderings_Oord_3,axiom,
    ( ord @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Ouminus_4,axiom,
    ( uminus @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ( ring_1 @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    ( numeral @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ( ring @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    ( idom @ int @ ( type2 @ int ) )).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    ( one @ int @ ( type2 @ int ) )).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_5,axiom,
    ( semiri456707255roduct @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_6,axiom,
    ( ordere236663937imp_le @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_7,axiom,
    ( ordere779506340up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_8,axiom,
    ( cancel_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_9,axiom,
    ( linordered_semidom @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_10,axiom,
    ( ab_semigroup_mult @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_11,axiom,
    ( comm_monoid_mult @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_12,axiom,
    ( ab_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_13,axiom,
    ( comm_semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_14,axiom,
    ( semigroup_mult @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_15,axiom,
    ( semiring_numeral @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_16,axiom,
    ( semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_17,axiom,
    ( comm_semiring @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_18,axiom,
    ( semiring_char_0 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_19,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder_20,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_21,axiom,
    ( monoid_mult @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__1_22,axiom,
    ( semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_23,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring_24,axiom,
    ( semiring @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_25,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Num_Onumeral_26,axiom,
    ( numeral @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oone_27,axiom,
    ( one @ nat @ ( type2 @ nat ) )).

thf(tcon_Num_Onum___Orderings_Opreorder_28,axiom,
    ( preorder @ num @ ( type2 @ num ) )).

thf(tcon_Num_Onum___Orderings_Olinorder_29,axiom,
    ( linorder @ num @ ( type2 @ num ) )).

thf(tcon_Num_Onum___Orderings_Oorder_30,axiom,
    ( order @ num @ ( type2 @ num ) )).

thf(tcon_Num_Onum___Orderings_Oord_31,axiom,
    ( ord @ num @ ( type2 @ num ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_32,axiom,(
    ! [A6: $tType] :
      ( preorder @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_33,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_34,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_35,axiom,(
    ! [A6: $tType] :
      ( uminus @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_36,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_37,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_38,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_39,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_40,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_41,axiom,
    ( semiri456707255roduct @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_42,axiom,
    ( ordere236663937imp_le @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field,axiom,
    ( archim1804426504_field @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_43,axiom,
    ( ordere779506340up_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_44,axiom,
    ( ring_11004092258visors @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_45,axiom,
    ( ordered_ab_group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_46,axiom,
    ( cancel_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_47,axiom,
    ( linordered_semidom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_48,axiom,
    ( ab_semigroup_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_49,axiom,
    ( comm_monoid_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_50,axiom,
    ( ab_semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Fields_Olinordered__field,axiom,
    ( linordered_field @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_51,axiom,
    ( linordered_idom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_52,axiom,
    ( comm_semiring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_53,axiom,
    ( semigroup_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_54,axiom,
    ( semiring_numeral @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_55,axiom,
    ( semigroup_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_56,axiom,
    ( comm_semiring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_57,axiom,
    ( semiring_char_0 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oab__group__add_58,axiom,
    ( ab_group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Opreorder_59,axiom,
    ( preorder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Olinorder_60,axiom,
    ( linorder @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_61,axiom,
    ( monoid_mult @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_62,axiom,
    ( comm_ring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring__1_63,axiom,
    ( semiring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ogroup__add_64,axiom,
    ( group_add @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Oorder_65,axiom,
    ( order @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Num_Oneg__numeral_66,axiom,
    ( neg_numeral @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Nat_Oring__char__0_67,axiom,
    ( ring_char_0 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Osemiring_68,axiom,
    ( semiring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Orderings_Oord_69,axiom,
    ( ord @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Ouminus_70,axiom,
    ( uminus @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring__1_71,axiom,
    ( ring_1 @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Num_Onumeral_72,axiom,
    ( numeral @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oring_73,axiom,
    ( ring @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Rings_Oidom_74,axiom,
    ( idom @ real @ ( type2 @ real ) )).

thf(tcon_Real_Oreal___Groups_Oone_75,axiom,
    ( one @ real @ ( type2 @ real ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X4: A,Y: A] :
      ( ( if @ A @ $false @ X4 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X4: A,Y: A] :
      ( ( if @ A @ $true @ X4 @ Y )
      = X4 ) )).

%----Free types (1)
thf(tfree_0,hypothesis,
    ( linorder @ a @ ( type2 @ a ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size1 @ a @ l ) ) @ ( semiring_1_of_nat @ real @ ( size1 @ a @ r ) ) ) ) ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( size1 @ a @ l ) ) @ ( semiring_1_of_nat @ real @ ( size1 @ a @ r ) ) ) ) ) )).

%------------------------------------------------------------------------------
