%------------------------------------------------------------------------------
% File     : DAT229^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 26
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__26.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  343 (   2 unit;  59 type;   0 defn)
%            Number of atoms       : 4850 ( 329 equality;3188 variable)
%            Maximal formula depth :   31 (  11 average)
%            Number of connectives : 4376 (  63   ~;   9   |;  49   &;3989   @)
%                                         (   0 <=>; 266  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  489 ( 489   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   63 (  59   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1390 (   2 sgn;1249   !;  15   ?;  51   ^)
%                                         (1390   :;  75  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:38:44.202
%------------------------------------------------------------------------------
%----Could-be-implicit typings (7)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (52)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,(
    bounde1808546759up_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Composition_Oid__bnf,type,(
    bNF_id_bnf: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_BNF__Def_Oeq__onp,type,(
    bNF_eq_onp: 
      !>[A: $tType] :
        ( ( A > $o ) > A > A > $o ) )).

thf(sy_c_BNF__Def_Ovimage2p,type,(
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] :
        ( ( A > D ) > ( B > E ) > ( D > E > C ) > A > B > C ) )).

thf(sy_c_Finite__Set_Ofinite,type,(
    finite_finite: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Fun_Obij__betw,type,(
    bij_betw: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Omap__fun,type,(
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] :
        ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) )).

thf(sy_c_Fun_Ooverride__on,type,(
    override_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > B ) > ( set @ A ) > A > B ) )).

thf(sy_c_Groups_Ocomm__monoid,type,(
    comm_monoid: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Groups_Omonoid,type,(
    monoid: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Lattices_Osemilattice__neutr,type,(
    semilattice_neutr: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OB,type,(
    rBT_Impl_Mirabelle_B: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OR,type,(
    rBT_Impl_Mirabelle_R: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_Ocase__color,type,(
    rBT_Im1975547051_color: 
      !>[A: $tType] :
        ( A > A > rBT_Im1923302023_color > A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_Orec__color,type,(
    rBT_Im1059957627_color: 
      !>[A: $tType] :
        ( A > A > rBT_Im1923302023_color > A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_Osize__color,type,(
    rBT_Im800559290_color: rBT_Im1923302023_color > nat )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Ocase__rbt,type,(
    rBT_Im858806507se_rbt: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( C > ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > C ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Omap__rbt,type,(
    rBT_Im206295089ap_rbt: 
      !>[A: $tType,Aa: $tType,B: $tType,Ba: $tType] :
        ( ( A > Aa ) > ( B > Ba ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ Aa @ Ba ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Opred__rbt,type,(
    rBT_Im1931894874ed_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Orec__rbt,type,(
    rBT_Im1947144893ec_rbt: 
      !>[E: $tType,A: $tType,B: $tType] :
        ( E > ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > E > E > E ) > ( rBT_Im246033960le_rbt @ A @ B ) > E ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Orel__rbt,type,(
    rBT_Im1000242676el_rbt: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ C @ D ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Oset1__rbt,type,(
    rBT_Im1178217900t1_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Oset2__rbt,type,(
    rBT_Im1550225131t2_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Osize__rbt,type,(
    rBT_Im1485196410ze_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( rBT_Im246033960le_rbt @ A @ B ) > nat ) )).

thf(sy_c_Set_OBall,type,(
    ball: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Set_Ovimage,type,(
    vimage: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ B ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_t,type,(
    t: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_thesis,type,(
    thesis: $o )).

%----Relevant facts (256)
thf(fact_0_Empty,axiom,
    ( ( t
      = ( rBT_Im418718756_Empty @ a @ b ) )
   => thesis )).

% Empty
thf(fact_1_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 )
        & ( X24 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_2_Black,axiom,(
    ! [L: ( rBT_Im246033960le_rbt @ a @ b ),K: a,V: b,R: ( rBT_Im246033960le_rbt @ a @ b )] :
      ( ( t
        = ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_B @ L @ K @ V @ R ) )
     => thesis ) )).

% Black
thf(fact_3_Red,axiom,(
    ! [L: ( rBT_Im246033960le_rbt @ a @ b ),K: a,V: b,R: ( rBT_Im246033960le_rbt @ a @ b )] :
      ( ( t
        = ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ L @ K @ V @ R ) )
     => thesis ) )).

% Red
thf(fact_4_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_5_color_Odistinct_I1_J,axiom,(
    rBT_Impl_Mirabelle_R != rBT_Impl_Mirabelle_B )).

% color.distinct(1)
thf(fact_6_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X1: rBT_Im1923302023_color,X2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,X4: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X2 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X1 @ X2 @ X3 @ X4 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_7_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X232 @ X242 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_8_color_Oinduct,axiom,(
    ! [P: ( rBT_Im1923302023_color > $o ),Color: rBT_Im1923302023_color] :
      ( ( P @ rBT_Impl_Mirabelle_R )
     => ( ( P @ rBT_Impl_Mirabelle_B )
       => ( P @ Color ) ) ) )).

% color.induct
thf(fact_9_color_Oexhaust,axiom,(
    ! [Y: rBT_Im1923302023_color] :
      ( ( Y != rBT_Impl_Mirabelle_R )
     => ( Y = rBT_Impl_Mirabelle_B ) ) )).

% color.exhaust
thf(fact_10_color_Osimps_I6_J,axiom,(
    ! [A: $tType,F1: A,F2: A] :
      ( ( rBT_Im1059957627_color @ A @ F1 @ F2 @ rBT_Impl_Mirabelle_B )
      = F2 ) )).

% color.simps(6)
thf(fact_11_color_Osimps_I5_J,axiom,(
    ! [A: $tType,F1: A,F2: A] :
      ( ( rBT_Im1059957627_color @ A @ F1 @ F2 @ rBT_Impl_Mirabelle_R )
      = F1 ) )).

% color.simps(5)
thf(fact_12_color_Osimps_I4_J,axiom,(
    ! [A: $tType,F1: A,F2: A] :
      ( ( rBT_Im1975547051_color @ A @ F1 @ F2 @ rBT_Impl_Mirabelle_B )
      = F2 ) )).

% color.simps(4)
thf(fact_13_color_Osimps_I3_J,axiom,(
    ! [A: $tType,F1: A,F2: A] :
      ( ( rBT_Im1975547051_color @ A @ F1 @ F2 @ rBT_Impl_Mirabelle_R )
      = F1 ) )).

% color.simps(3)
thf(fact_14_rbt_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F1: C,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > C )] :
      ( ( rBT_Im858806507se_rbt @ C @ A @ B @ F1 @ F2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = F1 ) )).

% rbt.simps(4)
thf(fact_15_rbt_Osimps_I5_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F1: C,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > C ),X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im858806507se_rbt @ C @ A @ B @ F1 @ F2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) )
      = ( F2 @ X21 @ X22 @ X23 @ X24 @ X25 ) ) )).

% rbt.simps(5)
thf(fact_16_rbt_Osimps_I6_J,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F1: E,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > E > E > E )] :
      ( ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = F1 ) )).

% rbt.simps(6)
thf(fact_17_rbt_Osimps_I7_J,axiom,(
    ! [E: $tType,B: $tType,A: $tType,F1: E,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > E > E > E ),X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) )
      = ( F2 @ X21 @ X22 @ X23 @ X24 @ X25 @ ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ X22 ) @ ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ X25 ) ) ) )).

% rbt.simps(7)
thf(fact_18_rbt_Opred__inject_I2_J,axiom,(
    ! [B: $tType,A: $tType,P1: ( A > $o ),P2: ( B > $o ),A2: rBT_Im1923302023_color,Aa2: ( rBT_Im246033960le_rbt @ A @ B ),Ab: A,Ac: B,Ad: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 @ ( rBT_Im480247531Branch @ A @ B @ A2 @ Aa2 @ Ab @ Ac @ Ad ) )
      = ( ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 @ Aa2 )
        & ( P1 @ Ab )
        & ( P2 @ Ac )
        & ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 @ Ad ) ) ) )).

% rbt.pred_inject(2)
thf(fact_19_rbt_Orel__distinct_I2_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ~ ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) @ ( rBT_Im418718756_Empty @ C @ D ) ) )).

% rbt.rel_distinct(2)
thf(fact_20_rbt_Orel__distinct_I1_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ C @ D ),Y23: C,Y24: D,Y25: ( rBT_Im246033960le_rbt @ C @ D )] :
      ~ ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ ( rBT_Im418718756_Empty @ A @ B ) @ ( rBT_Im480247531Branch @ C @ D @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) ) )).

% rbt.rel_distinct(1)
thf(fact_21_rbt_Opred__inject_I1_J,axiom,(
    ! [B: $tType,A: $tType,P1: ( A > $o ),P2: ( B > $o )] :
      ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% rbt.pred_inject(1)
thf(fact_22_rbt_Orel__eq,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1000242676el_rbt @ A @ A @ B @ B
        @ ^ [Y2: A,Z: A] : ( Y2 = Z )
        @ ^ [Y2: B,Z: B] : ( Y2 = Z ) )
      = ( ^ [Y2: ( rBT_Im246033960le_rbt @ A @ B ),Z: ( rBT_Im246033960le_rbt @ A @ B )] : ( Y2 = Z ) ) ) )).

% rbt.rel_eq
thf(fact_23_rbt_Orel__refl,axiom,(
    ! [D: $tType,C: $tType,R1a: ( C > C > $o ),R2a: ( D > D > $o ),X: ( rBT_Im246033960le_rbt @ C @ D )] :
      ( ! [X6: C] :
          ( R1a @ X6 @ X6 )
     => ( ! [X6: D] :
            ( R2a @ X6 @ X6 )
       => ( rBT_Im1000242676el_rbt @ C @ C @ D @ D @ R1a @ R2a @ X @ X ) ) ) )).

% rbt.rel_refl
thf(fact_24_color_Ocase__distrib,axiom,(
    ! [A: $tType,B: $tType,H: ( A > B ),F1: A,F2: A,Color: rBT_Im1923302023_color] :
      ( ( H @ ( rBT_Im1975547051_color @ A @ F1 @ F2 @ Color ) )
      = ( rBT_Im1975547051_color @ B @ ( H @ F1 ) @ ( H @ F2 ) @ Color ) ) )).

% color.case_distrib
thf(fact_25_rbt_Orel__intros_I2_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,X21: rBT_Im1923302023_color,Y21: rBT_Im1923302023_color,R1: ( A > C > $o ),R2: ( B > D > $o ),X22: ( rBT_Im246033960le_rbt @ A @ B ),Y22: ( rBT_Im246033960le_rbt @ C @ D ),X23: A,Y23: C,X24: B,Y24: D,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y25: ( rBT_Im246033960le_rbt @ C @ D )] :
      ( ( X21 = Y21 )
     => ( ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ X22 @ Y22 )
       => ( ( R1 @ X23 @ Y23 )
         => ( ( R2 @ X24 @ Y24 )
           => ( ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ X25 @ Y25 )
             => ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) @ ( rBT_Im480247531Branch @ C @ D @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) ) ) ) ) ) ) )).

% rbt.rel_intros(2)
thf(fact_26_rbt_Orel__inject_I2_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ C @ D ),Y23: C,Y24: D,Y25: ( rBT_Im246033960le_rbt @ C @ D )] :
      ( ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) @ ( rBT_Im480247531Branch @ C @ D @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ X22 @ Y22 )
        & ( R1 @ X23 @ Y23 )
        & ( R2 @ X24 @ Y24 )
        & ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ X25 @ Y25 ) ) ) )).

% rbt.rel_inject(2)
thf(fact_27_rbt_Octr__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ ( rBT_Im418718756_Empty @ A @ B ) @ ( rBT_Im418718756_Empty @ C @ D ) ) )).

% rbt.ctr_transfer(1)
thf(fact_28_rbt_Opred__rel,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1931894874ed_rbt @ A @ B )
      = ( ^ [P12: ( A > $o ),P22: ( B > $o ),X7: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im1000242676el_rbt @ A @ A @ B @ B @ ( bNF_eq_onp @ A @ P12 ) @ ( bNF_eq_onp @ B @ P22 ) @ X7 @ X7 ) ) ) )).

% rbt.pred_rel
thf(fact_29_rbt_Oset__intros_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: A,A22: ( rBT_Im246033960le_rbt @ A @ B ),A1: rBT_Im1923302023_color,A3: A,A4: B,A5: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( member @ A @ X @ ( rBT_Im1178217900t1_rbt @ A @ B @ A22 ) )
     => ( member @ A @ X @ ( rBT_Im1178217900t1_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ A1 @ A22 @ A3 @ A4 @ A5 ) ) ) ) )).

% rbt.set_intros(1)
thf(fact_30_rbt_Oset__intros_I2_J,axiom,(
    ! [B: $tType,A: $tType,A3: A,A1: rBT_Im1923302023_color,A22: ( rBT_Im246033960le_rbt @ A @ B ),A4: B,A5: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( member @ A @ A3 @ ( rBT_Im1178217900t1_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ A1 @ A22 @ A3 @ A4 @ A5 ) ) ) )).

% rbt.set_intros(2)
thf(fact_31_rbt_Oset__intros_I3_J,axiom,(
    ! [B: $tType,A: $tType,Xb: A,A5: ( rBT_Im246033960le_rbt @ A @ B ),A1: rBT_Im1923302023_color,A22: ( rBT_Im246033960le_rbt @ A @ B ),A3: A,A4: B] :
      ( ( member @ A @ Xb @ ( rBT_Im1178217900t1_rbt @ A @ B @ A5 ) )
     => ( member @ A @ Xb @ ( rBT_Im1178217900t1_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ A1 @ A22 @ A3 @ A4 @ A5 ) ) ) ) )).

% rbt.set_intros(3)
thf(fact_32_rbt_Oset__intros_I4_J,axiom,(
    ! [B: $tType,A: $tType,Xe: B,A2a: ( rBT_Im246033960le_rbt @ A @ B ),A1a: rBT_Im1923302023_color,A3a: A,A4a: B,A5a: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( member @ B @ Xe @ ( rBT_Im1550225131t2_rbt @ A @ B @ A2a ) )
     => ( member @ B @ Xe @ ( rBT_Im1550225131t2_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ A1a @ A2a @ A3a @ A4a @ A5a ) ) ) ) )).

% rbt.set_intros(4)
thf(fact_33_rbt_Oset__intros_I5_J,axiom,(
    ! [B: $tType,A: $tType,A4a: B,A1a: rBT_Im1923302023_color,A2a: ( rBT_Im246033960le_rbt @ A @ B ),A3a: A,A5a: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( member @ B @ A4a @ ( rBT_Im1550225131t2_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ A1a @ A2a @ A3a @ A4a @ A5a ) ) ) )).

% rbt.set_intros(5)
thf(fact_34_rbt_Oset__intros_I6_J,axiom,(
    ! [B: $tType,A: $tType,Xg: B,A5a: ( rBT_Im246033960le_rbt @ A @ B ),A1a: rBT_Im1923302023_color,A2a: ( rBT_Im246033960le_rbt @ A @ B ),A3a: A,A4a: B] :
      ( ( member @ B @ Xg @ ( rBT_Im1550225131t2_rbt @ A @ B @ A5a ) )
     => ( member @ B @ Xg @ ( rBT_Im1550225131t2_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ A1a @ A2a @ A3a @ A4a @ A5a ) ) ) ) )).

% rbt.set_intros(6)
thf(fact_35_rbt_Oset__cases_I1_J,axiom,(
    ! [B: $tType,A: $tType,E2: A,A2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( member @ A @ E2 @ ( rBT_Im1178217900t1_rbt @ A @ B @ A2 ) )
     => ( ! [Z1: rBT_Im1923302023_color,Z2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ? [Z3: A,Z4: B,Z5: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( A2
                = ( rBT_Im480247531Branch @ A @ B @ Z1 @ Z2 @ Z3 @ Z4 @ Z5 ) )
           => ~ ( member @ A @ E2 @ ( rBT_Im1178217900t1_rbt @ A @ B @ Z2 ) ) )
       => ( ! [Z1: rBT_Im1923302023_color,Z2: ( rBT_Im246033960le_rbt @ A @ B ),Z4: B,Z5: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( A2
             != ( rBT_Im480247531Branch @ A @ B @ Z1 @ Z2 @ E2 @ Z4 @ Z5 ) )
         => ~ ( ! [Z1: rBT_Im1923302023_color,Z2: ( rBT_Im246033960le_rbt @ A @ B ),Z3: A,Z4: B,Z5: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( A2
                    = ( rBT_Im480247531Branch @ A @ B @ Z1 @ Z2 @ Z3 @ Z4 @ Z5 ) )
                 => ~ ( member @ A @ E2 @ ( rBT_Im1178217900t1_rbt @ A @ B @ Z5 ) ) ) ) ) ) ) )).

% rbt.set_cases(1)
thf(fact_36_rbt_Oset__cases_I2_J,axiom,(
    ! [B: $tType,A: $tType,E2: B,A2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( member @ B @ E2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ A2 ) )
     => ( ! [Z1: rBT_Im1923302023_color,Z2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ? [Z3: A,Z4: B,Z5: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( A2
                = ( rBT_Im480247531Branch @ A @ B @ Z1 @ Z2 @ Z3 @ Z4 @ Z5 ) )
           => ~ ( member @ B @ E2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ Z2 ) ) )
       => ( ! [Z1: rBT_Im1923302023_color,Z2: ( rBT_Im246033960le_rbt @ A @ B ),Z3: A,Z5: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( A2
             != ( rBT_Im480247531Branch @ A @ B @ Z1 @ Z2 @ Z3 @ E2 @ Z5 ) )
         => ~ ( ! [Z1: rBT_Im1923302023_color,Z2: ( rBT_Im246033960le_rbt @ A @ B ),Z3: A,Z4: B,Z5: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( A2
                    = ( rBT_Im480247531Branch @ A @ B @ Z1 @ Z2 @ Z3 @ Z4 @ Z5 ) )
                 => ~ ( member @ B @ E2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ Z5 ) ) ) ) ) ) ) )).

% rbt.set_cases(2)
thf(fact_37_rbt_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F1: ( A > C ),F2: ( B > D )] :
      ( ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ C @ D ) ) )).

% rbt.simps(8)
thf(fact_38_rbt_Oinj__map__strong,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B ),Xa: ( rBT_Im246033960le_rbt @ A @ B ),F1: ( A > C ),F1a: ( A > C ),F2: ( B > D ),F2a: ( B > D )] :
      ( ! [Z1: A,Z1a: A] :
          ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ X ) )
         => ( ( member @ A @ Z1a @ ( rBT_Im1178217900t1_rbt @ A @ B @ Xa ) )
           => ( ( ( F1 @ Z1 )
                = ( F1a @ Z1a ) )
             => ( Z1 = Z1a ) ) ) )
     => ( ! [Z2: B,Z2a: B] :
            ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ X ) )
           => ( ( member @ B @ Z2a @ ( rBT_Im1550225131t2_rbt @ A @ B @ Xa ) )
             => ( ( ( F2 @ Z2 )
                  = ( F2a @ Z2a ) )
               => ( Z2 = Z2a ) ) ) )
       => ( ( ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ X )
            = ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1a @ F2a @ Xa ) )
         => ( X = Xa ) ) ) ) )).

% rbt.inj_map_strong
thf(fact_39_rbt_Omap__cong0,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B ),F1: ( A > C ),G1: ( A > C ),F2: ( B > D ),G2: ( B > D )] :
      ( ! [Z1: A] :
          ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ X ) )
         => ( ( F1 @ Z1 )
            = ( G1 @ Z1 ) ) )
     => ( ! [Z2: B] :
            ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ X ) )
           => ( ( F2 @ Z2 )
              = ( G2 @ Z2 ) ) )
       => ( ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ X )
          = ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ G1 @ G2 @ X ) ) ) ) )).

% rbt.map_cong0
thf(fact_40_rbt_Omap__cong,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B ),Ya: ( rBT_Im246033960le_rbt @ A @ B ),F1: ( A > C ),G1: ( A > C ),F2: ( B > D ),G2: ( B > D )] :
      ( ( X = Ya )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ Ya ) )
           => ( ( F1 @ Z1 )
              = ( G1 @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ Ya ) )
             => ( ( F2 @ Z2 )
                = ( G2 @ Z2 ) ) )
         => ( ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ X )
            = ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ G1 @ G2 @ Ya ) ) ) ) ) )).

% rbt.map_cong
thf(fact_41_rbt_Orel__refl__strong,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B ),R1a: ( A > A > $o ),R2a: ( B > B > $o )] :
      ( ! [Z1: A] :
          ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ X ) )
         => ( R1a @ Z1 @ Z1 ) )
     => ( ! [Z2: B] :
            ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ X ) )
           => ( R2a @ Z2 @ Z2 ) )
       => ( rBT_Im1000242676el_rbt @ A @ A @ B @ B @ R1a @ R2a @ X @ X ) ) ) )).

% rbt.rel_refl_strong
thf(fact_42_rbt_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),X: ( rBT_Im246033960le_rbt @ A @ B ),Y: ( rBT_Im246033960le_rbt @ C @ D ),R1a: ( A > C > $o ),R2a: ( B > D > $o )] :
      ( ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ X @ Y )
     => ( ! [Z1: A,Y1: C] :
            ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ X ) )
           => ( ( member @ C @ Y1 @ ( rBT_Im1178217900t1_rbt @ C @ D @ Y ) )
             => ( ( R1 @ Z1 @ Y1 )
               => ( R1a @ Z1 @ Y1 ) ) ) )
       => ( ! [Z2: B,Y26: D] :
              ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ X ) )
             => ( ( member @ D @ Y26 @ ( rBT_Im1550225131t2_rbt @ C @ D @ Y ) )
               => ( ( R2 @ Z2 @ Y26 )
                 => ( R2a @ Z2 @ Y26 ) ) ) )
         => ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1a @ R2a @ X @ Y ) ) ) ) )).

% rbt.rel_mono_strong
thf(fact_43_rbt_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,X: ( rBT_Im246033960le_rbt @ A @ B ),Ya: ( rBT_Im246033960le_rbt @ A @ B ),Y: ( rBT_Im246033960le_rbt @ C @ D ),Xa: ( rBT_Im246033960le_rbt @ C @ D ),R1: ( A > C > $o ),R1a: ( A > C > $o ),R2: ( B > D > $o ),R2a: ( B > D > $o )] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z1: A,Y1: C] :
              ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ Ya ) )
             => ( ( member @ C @ Y1 @ ( rBT_Im1178217900t1_rbt @ C @ D @ Xa ) )
               => ( ( R1 @ Z1 @ Y1 )
                  = ( R1a @ Z1 @ Y1 ) ) ) )
         => ( ! [Z2: B,Y26: D] :
                ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ Ya ) )
               => ( ( member @ D @ Y26 @ ( rBT_Im1550225131t2_rbt @ C @ D @ Xa ) )
                 => ( ( R2 @ Z2 @ Y26 )
                    = ( R2a @ Z2 @ Y26 ) ) ) )
           => ( ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1 @ R2 @ X @ Y )
              = ( rBT_Im1000242676el_rbt @ A @ C @ B @ D @ R1a @ R2a @ Ya @ Xa ) ) ) ) ) ) )).

% rbt.rel_cong
thf(fact_44_rbt_Opred__mono__strong,axiom,(
    ! [B: $tType,A: $tType,P1: ( A > $o ),P2: ( B > $o ),X: ( rBT_Im246033960le_rbt @ A @ B ),P1a: ( A > $o ),P2a: ( B > $o )] :
      ( ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 @ X )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ X ) )
           => ( ( P1 @ Z1 )
             => ( P1a @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ X ) )
             => ( ( P2 @ Z2 )
               => ( P2a @ Z2 ) ) )
         => ( rBT_Im1931894874ed_rbt @ A @ B @ P1a @ P2a @ X ) ) ) ) )).

% rbt.pred_mono_strong
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X7: A] :
            ( member @ A @ X7 @ A6 ) )
      = A6 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( P @ X6 )
          = ( Q @ X6 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X6: A] :
          ( ( F @ X6 )
          = ( G @ X6 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_rbt_Opred__cong,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B ),Ya: ( rBT_Im246033960le_rbt @ A @ B ),P1: ( A > $o ),P1a: ( A > $o ),P2: ( B > $o ),P2a: ( B > $o )] :
      ( ( X = Ya )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( rBT_Im1178217900t1_rbt @ A @ B @ Ya ) )
           => ( ( P1 @ Z1 )
              = ( P1a @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( rBT_Im1550225131t2_rbt @ A @ B @ Ya ) )
             => ( ( P2 @ Z2 )
                = ( P2a @ Z2 ) ) )
         => ( ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 @ X )
            = ( rBT_Im1931894874ed_rbt @ A @ B @ P1a @ P2a @ Ya ) ) ) ) ) )).

% rbt.pred_cong
thf(fact_50_rbt_Orel__eq__onp,axiom,(
    ! [A: $tType,B: $tType,P1: ( A > $o ),P2: ( B > $o )] :
      ( ( rBT_Im1000242676el_rbt @ A @ A @ B @ B @ ( bNF_eq_onp @ A @ P1 ) @ ( bNF_eq_onp @ B @ P2 ) )
      = ( bNF_eq_onp @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( rBT_Im1931894874ed_rbt @ A @ B @ P1 @ P2 ) ) ) )).

% rbt.rel_eq_onp
thf(fact_51_rbt_Osimps_I9_J,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F1: ( A > C ),F2: ( B > D ),X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) )
      = ( rBT_Im480247531Branch @ C @ D @ X21 @ ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ X22 ) @ ( F1 @ X23 ) @ ( F2 @ X24 ) @ ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ X25 ) ) ) )).

% rbt.simps(9)
thf(fact_52_eq__onp__live__step,axiom,(
    ! [A: $tType,X: $o,Y: $o,P: ( A > $o ),A2: A] :
      ( ( X = Y )
     => ( ( ( bNF_eq_onp @ A @ P @ A2 @ A2 )
          & X )
        = ( ( P @ A2 )
          & Y ) ) ) )).

% eq_onp_live_step
thf(fact_53_eq__onp__same__args,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A] :
      ( ( bNF_eq_onp @ A @ P @ X @ X )
      = ( P @ X ) ) )).

% eq_onp_same_args
thf(fact_54_eq__onp__to__eq,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Y: A] :
      ( ( bNF_eq_onp @ A @ P @ X @ Y )
     => ( X = Y ) ) )).

% eq_onp_to_eq
thf(fact_55_eq__onp__mono0,axiom,(
    ! [A: $tType,A6: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( member @ A @ X6 @ A6 )
         => ( ( P @ X6 )
           => ( Q @ X6 ) ) )
     => ! [X8: A] :
          ( ( member @ A @ X8 @ A6 )
         => ! [Xa2: A] :
              ( ( member @ A @ Xa2 @ A6 )
             => ( ( bNF_eq_onp @ A @ P @ X8 @ Xa2 )
               => ( bNF_eq_onp @ A @ Q @ X8 @ Xa2 ) ) ) ) ) )).

% eq_onp_mono0
thf(fact_56_eq__onp__eqD,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > A > $o ),X: A] :
      ( ( ( bNF_eq_onp @ A @ P )
        = Q )
     => ( ( P @ X )
        = ( Q @ X @ X ) ) ) )).

% eq_onp_eqD
thf(fact_57_rbt_Opred__set,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1931894874ed_rbt @ A @ B )
      = ( ^ [P12: ( A > $o ),P22: ( B > $o ),X7: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ! [Y3: A] :
                ( ( member @ A @ Y3 @ ( rBT_Im1178217900t1_rbt @ A @ B @ X7 ) )
               => ( P12 @ Y3 ) )
            & ! [Y3: B] :
                ( ( member @ B @ Y3 @ ( rBT_Im1550225131t2_rbt @ A @ B @ X7 ) )
               => ( P22 @ Y3 ) ) ) ) ) )).

% rbt.pred_set
thf(fact_58_rbt_Osimps_I16_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( rBT_Im1550225131t2_rbt @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( bot_bot @ ( set @ B ) ) ) )).

% rbt.simps(16)
thf(fact_59_rbt_Osimps_I14_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1178217900t1_rbt @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% rbt.simps(14)
thf(fact_60_rbt_Opred__map,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,Q1: ( C > $o ),Q2: ( D > $o ),F1: ( A > C ),F2: ( B > D ),X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1931894874ed_rbt @ C @ D @ Q1 @ Q2 @ ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ X ) )
      = ( rBT_Im1931894874ed_rbt @ A @ B @ ( comp @ C @ $o @ A @ Q1 @ F1 ) @ ( comp @ D @ $o @ B @ Q2 @ F2 ) @ X ) ) )).

% rbt.pred_map
thf(fact_61_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_62_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_63_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_64_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_65_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R12: ( D > B ),R22: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R12 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R12 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G ) @ H )
          = ( comp @ D @ E @ A @ L @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_66_rbt_Omap__comp,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: ( C > E ),G2: ( D > F3 ),F1: ( A > C ),F2: ( B > D ),V: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im206295089ap_rbt @ C @ E @ D @ F3 @ G1 @ G2 @ ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ F1 @ F2 @ V ) )
      = ( rBT_Im206295089ap_rbt @ A @ E @ B @ F3 @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F3 @ B @ G2 @ F2 ) @ V ) ) )).

% rbt.map_comp
thf(fact_67_ball__empty,axiom,(
    ! [A: $tType,P: ( A > $o ),X8: A] :
      ( ( member @ A @ X8 @ ( bot_bot @ ( set @ A ) ) )
     => ( P @ X8 ) ) )).

% ball_empty
thf(fact_68_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F4: ( B > A ),G3: ( C > B ),X7: C] :
            ( F4 @ ( G3 @ X7 ) ) ) ) )).

% comp_apply
thf(fact_69_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_70_all__not__in__conv,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( ! [X7: A] :
            ~ ( member @ A @ X7 @ A6 ) )
      = ( A6
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_71_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X7: A] :
            ~ ( P @ X7 ) ) ) )).

% Collect_empty_eq
thf(fact_72_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X7: A] :
            ~ ( P @ X7 ) ) ) )).

% empty_Collect_eq
thf(fact_73_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X7: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_74_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_75_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X7: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_76_ex__in__conv,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( ? [X7: A] :
            ( member @ A @ X7 @ A6 ) )
      = ( A6
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_77_equals0I,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ! [Y4: A] :
          ~ ( member @ A @ Y4 @ A6 )
     => ( A6
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_78_equals0D,axiom,(
    ! [A: $tType,A6: ( set @ A ),A2: A] :
      ( ( A6
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A6 ) ) )).

% equals0D
thf(fact_79_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_80_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C2 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_81_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_82_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_83_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_84_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F4: ( B > C ),G3: ( A > B ),X7: A] :
            ( F4 @ ( G3 @ X7 ) ) ) ) )).

% comp_def
thf(fact_85_Ball__def,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: ( set @ A ),P3: ( A > $o )] :
          ! [X7: A] :
            ( ( member @ A @ X7 @ A7 )
           => ( P3 @ X7 ) ) ) ) )).

% Ball_def
thf(fact_86_override__on__emptyset,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ( override_on @ A @ B @ F @ G @ ( bot_bot @ ( set @ A ) ) )
      = F ) )).

% override_on_emptyset
thf(fact_87_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_88_ball__reg,axiom,(
    ! [A: $tType,R3: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( member @ A @ X6 @ R3 )
         => ( ( P @ X6 )
           => ( Q @ X6 ) ) )
     => ( ! [X6: A] :
            ( ( member @ A @ X6 @ R3 )
           => ( P @ X6 ) )
       => ! [X8: A] :
            ( ( member @ A @ X8 @ R3 )
           => ( Q @ X8 ) ) ) ) )).

% ball_reg
thf(fact_89_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X: C,N: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G @ X ) )
        = ( N @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_90_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_91_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G: ( C > B ),X: C,F5: ( D > A ),G4: ( E > D ),X9: E] :
      ( ( ( F @ ( G @ X ) )
        = ( F5 @ ( G4 @ X9 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X )
        = ( comp @ D @ A @ E @ F5 @ G4 @ X9 ) ) ) )).

% comp_cong
thf(fact_92_override__on__apply__in,axiom,(
    ! [B: $tType,A: $tType,A2: A,A6: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( member @ A @ A2 @ A6 )
     => ( ( override_on @ A @ B @ F @ G @ A6 @ A2 )
        = ( G @ A2 ) ) ) )).

% override_on_apply_in
thf(fact_93_override__on__apply__notin,axiom,(
    ! [B: $tType,A: $tType,A2: A,A6: ( set @ A ),F: ( A > B ),G: ( A > B )] :
      ( ~ ( member @ A @ A2 @ A6 )
     => ( ( override_on @ A @ B @ F @ G @ A6 @ A2 )
        = ( F @ A2 ) ) ) )).

% override_on_apply_notin
thf(fact_94_override__on__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( override_on @ A @ B )
      = ( ^ [F4: ( A > B ),G3: ( A > B ),A7: ( set @ A ),A8: A] :
            ( if @ B @ ( member @ A @ A8 @ A7 ) @ ( G3 @ A8 ) @ ( F4 @ A8 ) ) ) ) )).

% override_on_def
thf(fact_95_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_96_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X7: A] :
            ( member @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_97_rbt_Osize__gen__o__map,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( C > nat ),Fa: ( D > nat ),G: ( A > C ),Ga: ( B > D )] :
      ( ( comp @ ( rBT_Im246033960le_rbt @ C @ D ) @ nat @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( rBT_Im1485196410ze_rbt @ C @ D @ F @ Fa ) @ ( rBT_Im206295089ap_rbt @ A @ C @ B @ D @ G @ Ga ) )
      = ( rBT_Im1485196410ze_rbt @ A @ B @ ( comp @ C @ nat @ A @ F @ G ) @ ( comp @ D @ nat @ B @ Fa @ Ga ) ) ) )).

% rbt.size_gen_o_map
thf(fact_98_is__singletonI_H,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( A6
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X6: A,Y4: A] :
            ( ( member @ A @ X6 @ A6 )
           => ( ( member @ A @ Y4 @ A6 )
             => ( X6 = Y4 ) ) )
       => ( is_singleton @ A @ A6 ) ) ) )).

% is_singletonI'
thf(fact_99_vimage2p__comp,axiom,(
    ! [E: $tType,D: $tType,F3: $tType,A: $tType,C: $tType,B: $tType,G5: $tType,F1: ( F3 > A ),F2: ( D > F3 ),G1: ( G5 > B ),G2: ( E > G5 )] :
      ( ( bNF_vimage2p @ D @ A @ E @ B @ C @ ( comp @ F3 @ A @ D @ F1 @ F2 ) @ ( comp @ G5 @ B @ E @ G1 @ G2 ) )
      = ( comp @ ( F3 > G5 > C ) @ ( D > E > C ) @ ( A > B > C ) @ ( bNF_vimage2p @ D @ F3 @ E @ G5 @ C @ F2 @ G2 ) @ ( bNF_vimage2p @ F3 @ A @ G5 @ B @ C @ F1 @ G1 ) ) ) )).

% vimage2p_comp
thf(fact_100_vimage2p__cong,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,R3: ( A > B > C ),S: ( A > B > C ),F: ( D > A ),G: ( E > B )] :
      ( ( R3 = S )
     => ( ( bNF_vimage2p @ D @ A @ E @ B @ C @ F @ G @ R3 )
        = ( bNF_vimage2p @ D @ A @ E @ B @ C @ F @ G @ S ) ) ) )).

% vimage2p_cong
thf(fact_101_rbt_Osize__gen_I1_J,axiom,(
    ! [A: $tType,B: $tType,Xa: ( A > nat ),X: ( B > nat )] :
      ( ( rBT_Im1485196410ze_rbt @ A @ B @ Xa @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( zero_zero @ nat ) ) )).

% rbt.size_gen(1)
thf(fact_102_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_103_map__fun_Ocomp,axiom,(
    ! [E: $tType,C: $tType,A: $tType,F3: $tType,D: $tType,B: $tType,F: ( E > C ),G: ( D > F3 ),H: ( C > A ),I: ( B > D )] :
      ( ( comp @ ( C > D ) @ ( E > F3 ) @ ( A > B ) @ ( map_fun @ E @ C @ D @ F3 @ F @ G ) @ ( map_fun @ C @ A @ B @ D @ H @ I ) )
      = ( map_fun @ E @ A @ B @ F3 @ ( comp @ C @ A @ E @ H @ F ) @ ( comp @ D @ F3 @ B @ G @ I ) ) ) )).

% map_fun.comp
thf(fact_104_is__singletonE,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( is_singleton @ A @ A6 )
     => ~ ( ! [X6: A] :
              ( A6
             != ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_105_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A7: ( set @ A )] :
          ? [X7: A] :
            ( A7
            = ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_106_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A6 ) )
      = ( insert @ A @ X @ A6 ) ) )).

% insert_absorb2
thf(fact_107_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A6: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A6 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A6 ) ) ) )).

% insert_iff
thf(fact_108_insertCI,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B3 )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertCI
thf(fact_109_map__fun__apply,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( map_fun @ B @ C @ D @ A )
      = ( ^ [F4: ( B > C ),G3: ( D > A ),H2: ( C > D ),X7: B] :
            ( G3 @ ( H2 @ ( F4 @ X7 ) ) ) ) ) )).

% map_fun_apply
thf(fact_110_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_111_singletonD,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A2 ) ) )).

% singletonD
thf(fact_112_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A2 ) ) )).

% singleton_iff
thf(fact_113_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,C2: A,D2: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C2 )
          & ( B2 = D2 ) )
        | ( ( A2 = D2 )
          & ( B2 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_114_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A )] :
      ( ( insert @ A @ A2 @ A6 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_115_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B2 ) ) )).

% singleton_inject
thf(fact_116_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A )] :
      ( ( member @ A @ A2 @ A6 )
     => ? [B4: ( set @ A )] :
          ( ( A6
            = ( insert @ A @ A2 @ B4 ) )
          & ~ ( member @ A @ A2 @ B4 ) ) ) )).

% mk_disjoint_insert
thf(fact_117_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A6: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A6 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A6 ) ) ) )).

% insert_commute
thf(fact_118_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B2: A,B3: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A6 )
     => ( ~ ( member @ A @ B2 @ B3 )
       => ( ( ( insert @ A @ A2 @ A6 )
            = ( insert @ A @ B2 @ B3 ) )
          = ( ( ( A2 = B2 )
             => ( A6 = B3 ) )
            & ( ( A2 != B2 )
             => ? [C3: ( set @ A )] :
                  ( ( A6
                    = ( insert @ A @ B2 @ C3 ) )
                  & ~ ( member @ A @ B2 @ C3 )
                  & ( B3
                    = ( insert @ A @ A2 @ C3 ) )
                  & ~ ( member @ A @ A2 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_119_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A )] :
      ( ( member @ A @ A2 @ A6 )
     => ( ( insert @ A @ A2 @ A6 )
        = A6 ) ) )).

% insert_absorb
thf(fact_120_insert__ident,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ X @ A6 )
     => ( ~ ( member @ A @ X @ B3 )
       => ( ( ( insert @ A @ X @ A6 )
            = ( insert @ A @ X @ B3 ) )
          = ( A6 = B3 ) ) ) ) )).

% insert_ident
thf(fact_121_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A )] :
      ( ( member @ A @ X @ A6 )
     => ~ ( ! [B4: ( set @ A )] :
              ( ( A6
                = ( insert @ A @ X @ B4 ) )
             => ( member @ A @ X @ B4 ) ) ) ) )).

% Set.set_insert
thf(fact_122_insertI2,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B2: A] :
      ( ( member @ A @ A2 @ B3 )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertI2
thf(fact_123_insertI1,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B3 ) ) )).

% insertI1
thf(fact_124_insertE,axiom,(
    ! [A: $tType,A2: A,B2: A,A6: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A6 ) )
     => ( ( A2 != B2 )
       => ( member @ A @ A2 @ A6 ) ) ) )).

% insertE
thf(fact_125_map__fun_Ocompositionality,axiom,(
    ! [D: $tType,F3: $tType,C: $tType,E: $tType,B: $tType,A: $tType,F: ( E > C ),G: ( D > F3 ),H: ( C > A ),I: ( B > D ),Fun: ( A > B )] :
      ( ( map_fun @ E @ C @ D @ F3 @ F @ G @ ( map_fun @ C @ A @ B @ D @ H @ I @ Fun ) )
      = ( map_fun @ E @ A @ B @ F3 @ ( comp @ C @ A @ E @ H @ F ) @ ( comp @ D @ F3 @ B @ G @ I ) @ Fun ) ) )).

% map_fun.compositionality
thf(fact_126_map__fun__def,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType] :
      ( ( map_fun @ C @ A @ B @ D )
      = ( ^ [F4: ( C > A ),G3: ( B > D ),H2: ( A > B )] :
            ( comp @ A @ D @ C @ ( comp @ B @ D @ A @ G3 @ H2 ) @ F4 ) ) ) )).

% map_fun_def
thf(fact_127_color_Osize__gen_I1_J,axiom,
    ( ( rBT_Im800559290_color @ rBT_Impl_Mirabelle_R )
    = ( zero_zero @ nat ) )).

% color.size_gen(1)
thf(fact_128_color_Osize__gen_I2_J,axiom,
    ( ( rBT_Im800559290_color @ rBT_Impl_Mirabelle_B )
    = ( zero_zero @ nat ) )).

% color.size_gen(2)
thf(fact_129_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A7: ( set @ A )] :
            ( A7
            = ( insert @ A @ ( the_elem @ A @ A7 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_130_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_131_color_Osize_I3_J,axiom,
    ( ( size_size @ rBT_Im1923302023_color @ rBT_Impl_Mirabelle_R )
    = ( zero_zero @ nat ) )).

% color.size(3)
thf(fact_132_color_Osize_I4_J,axiom,
    ( ( size_size @ rBT_Im1923302023_color @ rBT_Impl_Mirabelle_B )
    = ( zero_zero @ nat ) )).

% color.size(4)
thf(fact_133_rbt_Osize_I3_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( size_size @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( zero_zero @ nat ) ) )).

% rbt.size(3)
thf(fact_134_rbt_Osimps_I15_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1178217900t1_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) )
      = ( insert @ A @ X23 @ ( sup_sup @ ( set @ A ) @ ( rBT_Im1178217900t1_rbt @ A @ B @ X22 ) @ ( rBT_Im1178217900t1_rbt @ A @ B @ X25 ) ) ) ) )).

% rbt.simps(15)
thf(fact_135_rbt_Osimps_I17_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1550225131t2_rbt @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) )
      = ( insert @ B @ X24 @ ( sup_sup @ ( set @ B ) @ ( rBT_Im1550225131t2_rbt @ A @ B @ X22 ) @ ( rBT_Im1550225131t2_rbt @ A @ B @ X25 ) ) ) ) )).

% rbt.simps(17)
thf(fact_136_pairwise__singleton,axiom,(
    ! [A: $tType,P: ( A > A > $o ),A6: A] :
      ( pairwise @ A @ P @ ( insert @ A @ A6 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_137_Un__iff,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) )
      = ( ( member @ A @ C2 @ A6 )
        | ( member @ A @ C2 @ B3 ) ) ) )).

% Un_iff
thf(fact_138_UnCI,axiom,(
    ! [A: $tType,C2: A,B3: ( set @ A ),A6: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B3 )
       => ( member @ A @ C2 @ A6 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% UnCI
thf(fact_139_Un__empty,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ( sup_sup @ ( set @ A ) @ A6 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( A6
          = ( bot_bot @ ( set @ A ) ) )
        & ( B3
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Un_empty
thf(fact_140_Un__insert__left,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ A2 @ B3 ) @ C4 )
      = ( insert @ A @ A2 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Un_insert_left
thf(fact_141_Un__insert__right,axiom,(
    ! [A: $tType,A6: ( set @ A ),A2: A,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( insert @ A @ A2 @ B3 ) )
      = ( insert @ A @ A2 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% Un_insert_right
thf(fact_142_Un__empty__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = B3 ) )).

% Un_empty_left
thf(fact_143_Un__empty__right,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( bot_bot @ ( set @ A ) ) )
      = A6 ) )).

% Un_empty_right
thf(fact_144_Un__left__commute,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) )
      = ( sup_sup @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A6 @ C4 ) ) ) )).

% Un_left_commute
thf(fact_145_Un__left__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ A6 @ B3 ) ) )).

% Un_left_absorb
thf(fact_146_pairwise__def,axiom,(
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R4: ( A > A > $o ),S2: ( set @ A )] :
          ! [X7: A] :
            ( ( member @ A @ X7 @ S2 )
           => ! [Y3: A] :
                ( ( member @ A @ Y3 @ S2 )
               => ( ( X7 != Y3 )
                 => ( R4 @ X7 @ Y3 ) ) ) ) ) ) )).

% pairwise_def
thf(fact_147_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A7 ) ) ) )).

% Un_commute
thf(fact_148_Un__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A6 @ A6 )
      = A6 ) )).

% Un_absorb
thf(fact_149_Un__assoc,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) @ C4 )
      = ( sup_sup @ ( set @ A ) @ A6 @ ( sup_sup @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Un_assoc
thf(fact_150_ball__Un,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X7: A] :
            ( ( member @ A @ X7 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) )
           => ( P @ X7 ) ) )
      = ( ! [X7: A] :
            ( ( member @ A @ X7 @ A6 )
           => ( P @ X7 ) )
        & ! [X7: A] :
            ( ( member @ A @ X7 @ B3 )
           => ( P @ X7 ) ) ) ) )).

% ball_Un
thf(fact_151_bex__Un,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X7: A] :
            ( ( member @ A @ X7 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) )
            & ( P @ X7 ) ) )
      = ( ? [X7: A] :
            ( ( member @ A @ X7 @ A6 )
            & ( P @ X7 ) )
        | ? [X7: A] :
            ( ( member @ A @ X7 @ B3 )
            & ( P @ X7 ) ) ) ) )).

% bex_Un
thf(fact_152_UnI2,axiom,(
    ! [A: $tType,C2: A,B3: ( set @ A ),A6: ( set @ A )] :
      ( ( member @ A @ C2 @ B3 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% UnI2
thf(fact_153_UnI1,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A6 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% UnI1
thf(fact_154_UnE,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) )
     => ( ~ ( member @ A @ C2 @ A6 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% UnE
thf(fact_155_singleton__Un__iff,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) )
        = ( sup_sup @ ( set @ A ) @ A6 @ B3 ) )
      = ( ( ( A6
            = ( bot_bot @ ( set @ A ) ) )
          & ( B3
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A6
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A6
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% singleton_Un_iff
thf(fact_156_Un__singleton__iff,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),X: A] :
      ( ( ( sup_sup @ ( set @ A ) @ A6 @ B3 )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( ( A6
            = ( bot_bot @ ( set @ A ) ) )
          & ( B3
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
        | ( ( A6
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( bot_bot @ ( set @ A ) ) ) )
        | ( ( A6
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          & ( B3
            = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) )).

% Un_singleton_iff
thf(fact_157_insert__is__Un,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [A8: A] :
            ( sup_sup @ ( set @ A ) @ ( insert @ A @ A8 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% insert_is_Un
thf(fact_158_pairwise__empty,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) )).

% pairwise_empty
thf(fact_159_pairwise__insert,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X: A,S3: ( set @ A )] :
      ( ( pairwise @ A @ R @ ( insert @ A @ X @ S3 ) )
      = ( ! [Y3: A] :
            ( ( ( member @ A @ Y3 @ S3 )
              & ( Y3 != X ) )
           => ( ( R @ X @ Y3 )
              & ( R @ Y3 @ X ) ) )
        & ( pairwise @ A @ R @ S3 ) ) ) )).

% pairwise_insert
thf(fact_160_sup__bot_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ ( bot_bot @ A ) )
          = A2 ) ) )).

% sup_bot.right_neutral
thf(fact_161_sup__bot_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A2 )
          = A2 ) ) )).

% sup_bot.left_neutral
thf(fact_162_sup__eq__bot__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% sup_eq_bot_iff
thf(fact_163_bot__eq__sup__iff,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) )).

% bot_eq_sup_iff
thf(fact_164_sup__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) )).

% sup_bot_left
thf(fact_165_sup__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) )).

% sup_bot_right
thf(fact_166_ID_Opred__set,axiom,(
    ! [A: $tType] :
      ( ( bNF_id_bnf @ ( A > $o ) )
      = ( ^ [P3: ( A > $o ),X7: A] :
          ! [Y3: A] :
            ( ( member @ A @ Y3 @ ( insert @ A @ X7 @ ( bot_bot @ ( set @ A ) ) ) )
           => ( P3 @ Y3 ) ) ) ) )).

% ID.pred_set
thf(fact_167_sup__bot_Osemilattice__neutr__axioms,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ( semilattice_neutr @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) )).

% sup_bot.semilattice_neutr_axioms
thf(fact_168_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) )).

% bot_nat_def
thf(fact_169_id__bnf__apply,axiom,(
    ! [A: $tType] :
      ( ( bNF_id_bnf @ A )
      = ( ^ [X7: A] : X7 ) ) )).

% id_bnf_apply
thf(fact_170_BNF__Composition_Oid__bnf__def,axiom,(
    ! [A: $tType] :
      ( ( bNF_id_bnf @ A )
      = ( ^ [X7: A] : X7 ) ) )).

% BNF_Composition.id_bnf_def
thf(fact_171_ID_Opred__map,axiom,(
    ! [B: $tType,A: $tType,Q: ( B > $o ),F: ( A > B ),X: A] :
      ( ( bNF_id_bnf @ ( B > $o ) @ Q @ ( bNF_id_bnf @ ( A > B ) @ F @ X ) )
      = ( bNF_id_bnf @ ( A > $o ) @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) )).

% ID.pred_map
thf(fact_172_ID_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Pa: ( A > $o )] :
      ( ( bNF_id_bnf @ ( A > $o ) @ P @ X )
     => ( ! [Z6: A] :
            ( ( member @ A @ Z6 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( P @ Z6 )
             => ( Pa @ Z6 ) ) )
       => ( bNF_id_bnf @ ( A > $o ) @ Pa @ X ) ) ) )).

% ID.pred_mono_strong
thf(fact_173_ID_Opred__cong,axiom,(
    ! [A: $tType,X: A,Ya: A,P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X = Ya )
     => ( ! [Z6: A] :
            ( ( member @ A @ Z6 @ ( insert @ A @ Ya @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( P @ Z6 )
              = ( Pa @ Z6 ) ) )
       => ( ( bNF_id_bnf @ ( A > $o ) @ P @ X )
          = ( bNF_id_bnf @ ( A > $o ) @ Pa @ Ya ) ) ) ) )).

% ID.pred_cong
thf(fact_174_sup__bot_Omonoid__axioms,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ( monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) )).

% sup_bot.monoid_axioms
thf(fact_175_ID_Orel__eq__onp,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( bNF_id_bnf @ ( A > A > $o ) @ ( bNF_eq_onp @ A @ P ) )
      = ( bNF_eq_onp @ A @ ( bNF_id_bnf @ ( A > $o ) @ P ) ) ) )).

% ID.rel_eq_onp
thf(fact_176_ID_Opred__rel,axiom,(
    ! [A: $tType] :
      ( ( bNF_id_bnf @ ( A > $o ) )
      = ( ^ [P3: ( A > $o ),X7: A] :
            ( bNF_id_bnf @ ( A > A > $o ) @ ( bNF_eq_onp @ A @ P3 ) @ X7 @ X7 ) ) ) )).

% ID.pred_rel
thf(fact_177_ID_Orel__refl,axiom,(
    ! [A: $tType,Ra: ( A > A > $o ),X: A] :
      ( ! [X6: A] :
          ( Ra @ X6 @ X6 )
     => ( bNF_id_bnf @ ( A > A > $o ) @ Ra @ X @ X ) ) )).

% ID.rel_refl
thf(fact_178_ID_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,X: A,Ya: A,Y: B,Xa: B,R3: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z6: A,Yb: B] :
              ( ( member @ A @ Z6 @ ( insert @ A @ Ya @ ( bot_bot @ ( set @ A ) ) ) )
             => ( ( member @ B @ Yb @ ( insert @ B @ Xa @ ( bot_bot @ ( set @ B ) ) ) )
               => ( ( R3 @ Z6 @ Yb )
                  = ( Ra @ Z6 @ Yb ) ) ) )
         => ( ( bNF_id_bnf @ ( A > B > $o ) @ R3 @ X @ Y )
            = ( bNF_id_bnf @ ( A > B > $o ) @ Ra @ Ya @ Xa ) ) ) ) ) )).

% ID.rel_cong
thf(fact_179_ID_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > B > $o ),X: A,Y: B,Ra: ( A > B > $o )] :
      ( ( bNF_id_bnf @ ( A > B > $o ) @ R3 @ X @ Y )
     => ( ! [Z6: A,Yb: B] :
            ( ( member @ A @ Z6 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
           => ( ( member @ B @ Yb @ ( insert @ B @ Y @ ( bot_bot @ ( set @ B ) ) ) )
             => ( ( R3 @ Z6 @ Yb )
               => ( Ra @ Z6 @ Yb ) ) ) )
       => ( bNF_id_bnf @ ( A > B > $o ) @ Ra @ X @ Y ) ) ) )).

% ID.rel_mono_strong
thf(fact_180_ID_Orel__refl__strong,axiom,(
    ! [A: $tType,X: A,Ra: ( A > A > $o )] :
      ( ! [Z6: A] :
          ( ( member @ A @ Z6 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
         => ( Ra @ Z6 @ Z6 ) )
     => ( bNF_id_bnf @ ( A > A > $o ) @ Ra @ X @ X ) ) )).

% ID.rel_refl_strong
thf(fact_181_sup__bot_Ocomm__monoid__axioms,axiom,(
    ! [A: $tType] :
      ( ( bounde1808546759up_bot @ A @ ( type2 @ A ) )
     => ( comm_monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) )).

% sup_bot.comm_monoid_axioms
thf(fact_182_vimage__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A2: B,B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( insert @ B @ A2 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) @ ( vimage @ A @ B @ F @ B3 ) ) ) )).

% vimage_insert
thf(fact_183_notIn__Un__bij__betw3,axiom,(
    ! [A: $tType,B: $tType,B2: A,A6: ( set @ A ),F: ( A > B ),A9: ( set @ B )] :
      ( ~ ( member @ A @ B2 @ A6 )
     => ( ~ ( member @ B @ ( F @ B2 ) @ A9 )
       => ( ( bij_betw @ A @ B @ F @ A6 @ A9 )
          = ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A6 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( sup_sup @ ( set @ B ) @ A9 @ ( insert @ B @ ( F @ B2 ) @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) )).

% notIn_Un_bij_betw3
thf(fact_184_vimage__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
      = ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimage_eq
thf(fact_185_vimageI,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: A,B3: ( set @ A )] :
      ( ( ( F @ A2 )
        = B2 )
     => ( ( member @ A @ B2 @ B3 )
       => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ B3 ) ) ) ) )).

% vimageI
thf(fact_186_vimage__empty,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( vimage @ A @ B @ F @ ( bot_bot @ ( set @ B ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% vimage_empty
thf(fact_187_vimage__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B ),B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( sup_sup @ ( set @ B ) @ A6 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( vimage @ A @ B @ F @ A6 ) @ ( vimage @ A @ B @ F @ B3 ) ) ) )).

% vimage_Un
thf(fact_188_vimage__Collect,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > B ),Q: ( A > $o )] :
      ( ! [X6: A] :
          ( ( P @ ( F @ X6 ) )
          = ( Q @ X6 ) )
     => ( ( vimage @ A @ B @ F @ ( collect @ B @ P ) )
        = ( collect @ A @ Q ) ) ) )).

% vimage_Collect
thf(fact_189_bij__betw__cong,axiom,(
    ! [A: $tType,B: $tType,A6: ( set @ A ),F: ( A > B ),G: ( A > B ),A9: ( set @ B )] :
      ( ! [A10: A] :
          ( ( member @ A @ A10 @ A6 )
         => ( ( F @ A10 )
            = ( G @ A10 ) ) )
     => ( ( bij_betw @ A @ B @ F @ A6 @ A9 )
        = ( bij_betw @ A @ B @ G @ A6 @ A9 ) ) ) )).

% bij_betw_cong
thf(fact_190_bij__betw__inv,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A6: ( set @ A ),B3: ( set @ B )] :
      ( ( bij_betw @ A @ B @ F @ A6 @ B3 )
     => ? [G6: ( B > A )] :
          ( bij_betw @ B @ A @ G6 @ B3 @ A6 ) ) )).

% bij_betw_inv
thf(fact_191_vimageI2,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,A6: ( set @ A )] :
      ( ( member @ A @ ( F @ A2 ) @ A6 )
     => ( member @ B @ A2 @ ( vimage @ B @ A @ F @ A6 ) ) ) )).

% vimageI2
thf(fact_192_vimageE,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B3: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ B3 ) )
     => ( member @ B @ ( F @ A2 ) @ B3 ) ) )).

% vimageE
thf(fact_193_vimageD,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),A6: ( set @ B )] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ A6 ) )
     => ( member @ B @ ( F @ A2 ) @ A6 ) ) )).

% vimageD
thf(fact_194_set_Ocomp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),G: ( B > A )] :
      ( ( comp @ ( set @ B ) @ ( set @ C ) @ ( set @ A ) @ ( vimage @ C @ B @ F ) @ ( vimage @ B @ A @ G ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) ) ) )).

% set.comp
thf(fact_195_vimage__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( B > C ),X: ( set @ C )] :
      ( ( vimage @ A @ B @ F @ ( vimage @ B @ C @ G @ X ) )
      = ( vimage @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ X ) ) )).

% vimage_comp
thf(fact_196_set_Ocompositionality,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( C > B ),G: ( B > A ),Set: ( set @ A )] :
      ( ( vimage @ C @ B @ F @ ( vimage @ B @ A @ G @ Set ) )
      = ( vimage @ C @ A @ ( comp @ B @ A @ C @ G @ F ) @ Set ) ) )).

% set.compositionality
thf(fact_197_bij__betw__trans,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),A6: ( set @ A ),B3: ( set @ B ),G: ( B > C ),C4: ( set @ C )] :
      ( ( bij_betw @ A @ B @ F @ A6 @ B3 )
     => ( ( bij_betw @ B @ C @ G @ B3 @ C4 )
       => ( bij_betw @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ A6 @ C4 ) ) ) )).

% bij_betw_trans
thf(fact_198_bij__betw__comp__iff,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),A6: ( set @ A ),A9: ( set @ B ),F5: ( B > C ),A11: ( set @ C )] :
      ( ( bij_betw @ A @ B @ F @ A6 @ A9 )
     => ( ( bij_betw @ B @ C @ F5 @ A9 @ A11 )
        = ( bij_betw @ A @ C @ ( comp @ B @ C @ A @ F5 @ F ) @ A6 @ A11 ) ) ) )).

% bij_betw_comp_iff
thf(fact_199_vimage__singleton__eq,axiom,(
    ! [A: $tType,B: $tType,A2: A,F: ( A > B ),B2: B] :
      ( ( member @ A @ A2 @ ( vimage @ A @ B @ F @ ( insert @ B @ B2 @ ( bot_bot @ ( set @ B ) ) ) ) )
      = ( ( F @ A2 )
        = B2 ) ) )).

% vimage_singleton_eq
thf(fact_200_bij__betw__empty2,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A6: ( set @ A )] :
      ( ( bij_betw @ A @ B @ F @ A6 @ ( bot_bot @ ( set @ B ) ) )
     => ( A6
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% bij_betw_empty2
thf(fact_201_bij__betw__empty1,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B )] :
      ( ( bij_betw @ A @ B @ F @ ( bot_bot @ ( set @ A ) ) @ A6 )
     => ( A6
        = ( bot_bot @ ( set @ B ) ) ) ) )).

% bij_betw_empty1
thf(fact_202_notIn__Un__bij__betw,axiom,(
    ! [A: $tType,B: $tType,B2: A,A6: ( set @ A ),F: ( A > B ),A9: ( set @ B )] :
      ( ~ ( member @ A @ B2 @ A6 )
     => ( ~ ( member @ B @ ( F @ B2 ) @ A9 )
       => ( ( bij_betw @ A @ B @ F @ A6 @ A9 )
         => ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A6 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( sup_sup @ ( set @ B ) @ A9 @ ( insert @ B @ ( F @ B2 ) @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) )).

% notIn_Un_bij_betw
thf(fact_203_bij__betw__combine,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ A ),B3: ( set @ B ),C4: ( set @ A ),D3: ( set @ B )] :
      ( ( bij_betw @ A @ B @ F @ A6 @ B3 )
     => ( ( bij_betw @ A @ B @ F @ C4 @ D3 )
       => ( ( ( inf_inf @ ( set @ B ) @ B3 @ D3 )
            = ( bot_bot @ ( set @ B ) ) )
         => ( bij_betw @ A @ B @ F @ ( sup_sup @ ( set @ A ) @ A6 @ C4 ) @ ( sup_sup @ ( set @ B ) @ B3 @ D3 ) ) ) ) ) )).

% bij_betw_combine
thf(fact_204_infinite__imp__bij__betw2,axiom,(
    ! [A: $tType,A6: ( set @ A ),A2: A] :
      ( ~ ( finite_finite @ A @ A6 )
     => ? [H3: ( A > A )] :
          ( bij_betw @ A @ A @ H3 @ A6 @ ( sup_sup @ ( set @ A ) @ A6 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% infinite_imp_bij_betw2
thf(fact_205_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B2: A] :
      ( ( ( insert @ A @ A2 @ A6 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A6 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_206_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_207_subsetI,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ! [X6: A] :
          ( ( member @ A @ X6 @ A6 )
         => ( member @ A @ X6 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A6 @ B3 ) ) )).

% subsetI
thf(fact_208_subset__antisym,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A6 )
       => ( A6 = B3 ) ) ) )).

% subset_antisym
thf(fact_209_IntI,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ A6 )
     => ( ( member @ A @ C2 @ B3 )
       => ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) ) )).

% IntI
thf(fact_210_Int__iff,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) )
      = ( ( member @ A @ C2 @ A6 )
        & ( member @ A @ C2 @ B3 ) ) ) )).

% Int_iff
thf(fact_211_inf__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_left
thf(fact_212_inf__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_right
thf(fact_213_subset__empty,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ ( bot_bot @ ( set @ A ) ) )
      = ( A6
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_214_empty__subsetI,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A6 ) )).

% empty_subsetI
thf(fact_215_insert__subset,axiom,(
    ! [A: $tType,X: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A6 ) @ B3 )
      = ( ( member @ A @ X @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% insert_subset
thf(fact_216_Int__subset__iff,axiom,(
    ! [A: $tType,C4: ( set @ A ),A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C4 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C4 @ A6 )
        & ( ord_less_eq @ ( set @ A ) @ C4 @ B3 ) ) ) )).

% Int_subset_iff
thf(fact_217_Int__insert__right__if1,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ A2 @ A6 )
     => ( ( inf_inf @ ( set @ A ) @ A6 @ ( insert @ A @ A2 @ B3 ) )
        = ( insert @ A @ A2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) ) )).

% Int_insert_right_if1
thf(fact_218_Int__insert__right__if0,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A6 )
     => ( ( inf_inf @ ( set @ A ) @ A6 @ ( insert @ A @ A2 @ B3 ) )
        = ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% Int_insert_right_if0
thf(fact_219_insert__inter__insert,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ A6 ) @ ( insert @ A @ A2 @ B3 ) )
      = ( insert @ A @ A2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) )).

% insert_inter_insert
thf(fact_220_Int__insert__left__if1,axiom,(
    ! [A: $tType,A2: A,C4: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ A2 @ C4 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ B3 ) @ C4 )
        = ( insert @ A @ A2 @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) ) ) )).

% Int_insert_left_if1
thf(fact_221_Int__insert__left__if0,axiom,(
    ! [A: $tType,A2: A,C4: ( set @ A ),B3: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ C4 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ B3 ) @ C4 )
        = ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Int_insert_left_if0
thf(fact_222_Un__subset__iff,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A6 @ B3 ) @ C4 )
      = ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
        & ( ord_less_eq @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Un_subset_iff
thf(fact_223_vimage__Int,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A6: ( set @ B ),B3: ( set @ B )] :
      ( ( vimage @ A @ B @ F @ ( inf_inf @ ( set @ B ) @ A6 @ B3 ) )
      = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ A6 ) @ ( vimage @ A @ B @ F @ B3 ) ) ) )).

% vimage_Int
thf(fact_224_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B2: A,A2: A,A6: ( set @ A )] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A6 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A6 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_225_disjoint__insert_I2_J,axiom,(
    ! [A: $tType,A6: ( set @ A ),B2: A,B3: ( set @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ A6 @ ( insert @ A @ B2 @ B3 ) ) )
      = ( ~ ( member @ A @ B2 @ A6 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) ) )).

% disjoint_insert(2)
thf(fact_226_disjoint__insert_I1_J,axiom,(
    ! [A: $tType,B3: ( set @ A ),A2: A,A6: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ B3 @ ( insert @ A @ A2 @ A6 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A2 @ B3 )
        & ( ( inf_inf @ ( set @ A ) @ B3 @ A6 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% disjoint_insert(1)
thf(fact_227_insert__disjoint_I2_J,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ A6 ) @ B3 ) )
      = ( ~ ( member @ A @ A2 @ B3 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) ) )).

% insert_disjoint(2)
thf(fact_228_insert__disjoint_I1_J,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ A6 ) @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A2 @ B3 )
        & ( ( inf_inf @ ( set @ A ) @ A6 @ B3 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% insert_disjoint(1)
thf(fact_229_vimage__inter__cong,axiom,(
    ! [B: $tType,A: $tType,S: ( set @ A ),F: ( A > B ),G: ( A > B ),Y: ( set @ B )] :
      ( ! [W: A] :
          ( ( member @ A @ W @ S )
         => ( ( F @ W )
            = ( G @ W ) ) )
     => ( ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F @ Y ) @ S )
        = ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ G @ Y ) @ S ) ) ) )).

% vimage_inter_cong
thf(fact_230_vimage__mono,axiom,(
    ! [B: $tType,A: $tType,A6: ( set @ A ),B3: ( set @ A ),F: ( B > A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
     => ( ord_less_eq @ ( set @ B ) @ ( vimage @ B @ A @ F @ A6 ) @ ( vimage @ B @ A @ F @ B3 ) ) ) )).

% vimage_mono
thf(fact_231_Int__emptyI,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ! [X6: A] :
          ( ( member @ A @ X6 @ A6 )
         => ~ ( member @ A @ X6 @ B3 ) )
     => ( ( inf_inf @ ( set @ A ) @ A6 @ B3 )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% Int_emptyI
thf(fact_232_Int__empty__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B3 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_left
thf(fact_233_Int__empty__right,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A6 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_right
thf(fact_234_disjoint__iff__not__equal,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A6 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X7: A] :
            ( ( member @ A @ X7 @ A6 )
           => ! [Y3: A] :
                ( ( member @ A @ Y3 @ B3 )
               => ( X7 != Y3 ) ) ) ) ) )).

% disjoint_iff_not_equal
thf(fact_235_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) )).

% bot.extremum
thf(fact_236_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_237_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_238_Int__insert__right,axiom,(
    ! [A: $tType,A2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( ( member @ A @ A2 @ A6 )
       => ( ( inf_inf @ ( set @ A ) @ A6 @ ( insert @ A @ A2 @ B3 ) )
          = ( insert @ A @ A2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) )
      & ( ~ ( member @ A @ A2 @ A6 )
       => ( ( inf_inf @ ( set @ A ) @ A6 @ ( insert @ A @ A2 @ B3 ) )
          = ( inf_inf @ ( set @ A ) @ A6 @ B3 ) ) ) ) )).

% Int_insert_right
thf(fact_239_Int__insert__left,axiom,(
    ! [A: $tType,A2: A,C4: ( set @ A ),B3: ( set @ A )] :
      ( ( ( member @ A @ A2 @ C4 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ B3 ) @ C4 )
          = ( insert @ A @ A2 @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) ) )
      & ( ~ ( member @ A @ A2 @ C4 )
       => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A2 @ B3 ) @ C4 )
          = ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) ) ) )).

% Int_insert_left
thf(fact_240_IntE,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) )
     => ~ ( ( member @ A @ C2 @ A6 )
         => ~ ( member @ A @ C2 @ B3 ) ) ) )).

% IntE
thf(fact_241_IntD1,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) )
     => ( member @ A @ C2 @ A6 ) ) )).

% IntD1
thf(fact_242_IntD2,axiom,(
    ! [A: $tType,C2: A,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) )
     => ( member @ A @ C2 @ B3 ) ) )).

% IntD2
thf(fact_243_set__mp,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
     => ( ( member @ A @ X @ A6 )
       => ( member @ A @ X @ B3 ) ) ) )).

% set_mp
thf(fact_244_in__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
     => ( ( member @ A @ X @ A6 )
       => ( member @ A @ X @ B3 ) ) ) )).

% in_mono
thf(fact_245_subsetD,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
     => ( ( member @ A @ C2 @ A6 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetD
thf(fact_246_Int__mono,axiom,(
    ! [A: $tType,A6: ( set @ A ),C4: ( set @ A ),B3: ( set @ A ),D3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ C4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D3 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) @ ( inf_inf @ ( set @ A ) @ C4 @ D3 ) ) ) ) )).

% Int_mono
thf(fact_247_subsetCE,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
     => ( ( member @ A @ C2 @ A6 )
       => ( member @ A @ C2 @ B3 ) ) ) )).

% subsetCE
thf(fact_248_Int__assoc,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A ),C4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) @ C4 )
      = ( inf_inf @ ( set @ A ) @ A6 @ ( inf_inf @ ( set @ A ) @ B3 @ C4 ) ) ) )).

% Int_assoc
thf(fact_249_equalityE,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( A6 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A6 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A6 ) ) ) )).

% equalityE
thf(fact_250_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B5: ( set @ A )] :
          ! [X7: A] :
            ( ( member @ A @ X7 @ A7 )
           => ( member @ A @ X7 @ B5 ) ) ) ) )).

% subset_eq
thf(fact_251_Int__absorb,axiom,(
    ! [A: $tType,A6: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A6 @ A6 )
      = A6 ) )).

% Int_absorb
thf(fact_252_Int__lower1,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) @ A6 ) )).

% Int_lower1
thf(fact_253_Int__lower2,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A6 @ B3 ) @ B3 ) )).

% Int_lower2
thf(fact_254_equalityD1,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( A6 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A6 @ B3 ) ) )).

% equalityD1
thf(fact_255_equalityD2,axiom,(
    ! [A: $tType,A6: ( set @ A ),B3: ( set @ A )] :
      ( ( A6 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A6 ) ) )).

% equalityD2

%----Type constructors (21)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A12: $tType] :
      ( bounded_lattice @ ( set @ A12 ) @ ( type2 @ ( set @ A12 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A12: $tType,A13: $tType] :
      ( ( bounded_lattice @ A13 @ ( type2 @ A13 ) )
     => ( bounded_lattice @ ( A12 > A13 ) @ ( type2 @ ( A12 > A13 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,(
    ! [A12: $tType,A13: $tType] :
      ( ( bounded_lattice @ A13 @ ( type2 @ A13 ) )
     => ( bounde1808546759up_bot @ ( A12 > A13 ) @ ( type2 @ ( A12 > A13 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A12: $tType,A13: $tType] :
      ( ( bounded_lattice @ A13 @ ( type2 @ A13 ) )
     => ( bounded_lattice_bot @ ( A12 > A13 ) @ ( type2 @ ( A12 > A13 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A12: $tType,A13: $tType] :
      ( ( order_bot @ A13 @ ( type2 @ A13 ) )
     => ( order_bot @ ( A12 > A13 ) @ ( type2 @ ( A12 > A13 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A12: $tType,A13: $tType] :
      ( ( preorder @ A13 @ ( type2 @ A13 ) )
     => ( preorder @ ( A12 > A13 ) @ ( type2 @ ( A12 > A13 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A12: $tType,A13: $tType] :
      ( ( bot @ A13 @ ( type2 @ A13 ) )
     => ( bot @ ( A12 > A13 ) @ ( type2 @ ( A12 > A13 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_3,axiom,
    ( order_bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Opreorder_4,axiom,
    ( preorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Obot_5,axiom,
    ( bot @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_6,axiom,(
    ! [A12: $tType] :
      ( bounde1808546759up_bot @ ( set @ A12 ) @ ( type2 @ ( set @ A12 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_7,axiom,(
    ! [A12: $tType] :
      ( bounded_lattice_bot @ ( set @ A12 ) @ ( type2 @ ( set @ A12 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_8,axiom,(
    ! [A12: $tType] :
      ( order_bot @ ( set @ A12 ) @ ( type2 @ ( set @ A12 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_9,axiom,(
    ! [A12: $tType] :
      ( preorder @ ( set @ A12 ) @ ( type2 @ ( set @ A12 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_10,axiom,(
    ! [A12: $tType] :
      ( bot @ ( set @ A12 ) @ ( type2 @ ( set @ A12 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_11,axiom,
    ( bounde1808546759up_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_12,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_13,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_14,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_15,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (4)
thf(conj_0,hypothesis,(
    $true )).

thf(conj_1,hypothesis,(
    ! [L3: ( rBT_Im246033960le_rbt @ a @ b ),K2: a,V2: b,R5: ( rBT_Im246033960le_rbt @ a @ b )] :
      ( ( t
        = ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ L3 @ K2 @ V2 @ R5 ) )
     => thesis ) )).

thf(conj_2,hypothesis,(
    ! [L3: ( rBT_Im246033960le_rbt @ a @ b ),K2: a,V2: b,R5: ( rBT_Im246033960le_rbt @ a @ b )] :
      ( ( t
        = ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_B @ L3 @ K2 @ V2 @ R5 ) )
     => thesis ) )).

thf(conj_3,conjecture,(
    thesis )).

%------------------------------------------------------------------------------
