%------------------------------------------------------------------------------
% File     : DAT230^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 205
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__205.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  326 (   0 unit;  60 type;   0 defn)
%            Number of atoms       : 4495 ( 338 equality;2688 variable)
%            Maximal formula depth :   23 (  10 average)
%            Number of connectives : 4324 ( 159   ~;  29   |; 106   &;3713   @)
%                                         (   0 <=>; 317  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  239 ( 239   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   64 (  60   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1179 (   2 sgn; 988   !; 107   ?;  22   ^)
%                                         (1179   :;  62  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:39:23.898
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (51)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Fun_Oinj__on,type,(
    inj_on: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Obutlast,type,(
    butlast: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Odistinct,type,(
    distinct: 
      !>[A: $tType] :
        ( ( list @ A ) > $o ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olast,type,(
    last: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Oord_Olexordp,type,(
    lexordp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Ounion,type,(
    union: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Map_Odom,type,(
    dom: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( option @ B ) ) > ( set @ A ) ) )).

thf(sy_c_Map_Omap__of,type,(
    map_of: 
      !>[A: $tType,B: $tType] :
        ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) )).

thf(sy_c_Option_Ooption_ONone,type,(
    none: 
      !>[A: $tType] :
        ( option @ A ) )).

thf(sy_c_Option_Ooption_OSome,type,(
    some: 
      !>[A: $tType] :
        ( A > ( option @ A ) ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oentries,type,(
    rBT_Im954575269ntries: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Okeys,type,(
    rBT_Im380146495e_keys: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ A ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__greater,type,(
    rBT_Im1259024060reater: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__less,type,(
    rBT_Im2075124343t_less: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__lookup,type,(
    rBT_Im35466040lookup: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > A > ( option @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__sorted,type,(
    rBT_Im759614907sorted: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Orbt__greater,type,(
    rBT_Im1332541288reater: 
      !>[A: $tType,B: $tType] :
        ( A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Orbt__less,type,(
    rBT_Im903026891t_less: 
      !>[A: $tType,B: $tType] :
        ( A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Orbt__sorted,type,(
    rBT_Im1183586831sorted: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_c____,type,(
    c: rBT_Im1923302023_color )).

thf(sy_v_k____,type,(
    k: a )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_t1____,type,(
    t1: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_t2____,type,(
    t2: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_v____,type,(
    v: b )).

%----Relevant facts (255)
thf(fact_0_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_1_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_2_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_3_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_4_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_5_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_6_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_7_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_8_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_9_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_10_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_11_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_12_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_13_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_14_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_trans
thf(fact_15_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_16_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_17_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_18_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_19_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_20_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_21_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_22_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_23_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_24_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans
thf(fact_25_local_Orbt__greater__prop,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ T )
      = ( ! [X2: a] :
            ( ( member @ a @ X2 @ ( set2 @ a @ ( rBT_Im380146495e_keys @ a @ B @ T ) ) )
           => ( less @ K @ X2 ) ) ) ) )).

% local.rbt_greater_prop
thf(fact_26_local_Orbt__greater__trans,axiom,(
    ! [C2: $tType,X: a,Y: a,T: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( less @ X @ Y )
     => ( ( rBT_Im1259024060reater @ a @ C2 @ less @ Y @ T )
       => ( rBT_Im1259024060reater @ a @ C2 @ less @ X @ T ) ) ) )).

% local.rbt_greater_trans
thf(fact_27__092_060open_062k_A_092_060guillemotleft_062_124_At2_092_060close_062,axiom,
    ( rBT_Im1259024060reater @ a @ b @ less @ k @ t2 )).

% \<open>k \<guillemotleft>| t2\<close>
thf(fact_28_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_29_local_Orbt__less__prop,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ T )
      = ( ! [X2: a] :
            ( ( member @ a @ X2 @ ( set2 @ a @ ( rBT_Im380146495e_keys @ a @ B @ T ) ) )
           => ( less @ X2 @ K ) ) ) ) )).

% local.rbt_less_prop
thf(fact_30_ord_Orbt__greater__prop,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1259024060reater @ A @ B )
      = ( ^ [Less: ( A > A > $o ),K2: A,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( rBT_Im380146495e_keys @ A @ B @ T2 ) ) )
           => ( Less @ K2 @ X2 ) ) ) ) )).

% ord.rbt_greater_prop
thf(fact_31_local_Orbt__less__trans,axiom,(
    ! [C2: $tType,X: a,T: ( rBT_Im246033960le_rbt @ a @ C2 ),Y: a] :
      ( ( rBT_Im2075124343t_less @ a @ C2 @ less @ X @ T )
     => ( ( less @ X @ Y )
       => ( rBT_Im2075124343t_less @ a @ C2 @ less @ Y @ T ) ) ) )).

% local.rbt_less_trans
thf(fact_32_local_Olexordp__eq__antisym,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
     => ( ( lexordp_eq @ a @ less @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% local.lexordp_eq_antisym
thf(fact_33_local_Olexordp__eq__linear,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
      | ( lexordp_eq @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_eq_linear
thf(fact_34_local_Olexordp__eq__refl,axiom,(
    ! [Xs: ( list @ a )] :
      ( lexordp_eq @ a @ less @ Xs @ Xs ) )).

% local.lexordp_eq_refl
thf(fact_35_local_Olexordp__eq__trans,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a ),Zs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
     => ( ( lexordp_eq @ a @ less @ Ys @ Zs )
       => ( lexordp_eq @ a @ less @ Xs @ Zs ) ) ) )).

% local.lexordp_eq_trans
thf(fact_36_ord_Orbt__less__prop,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im2075124343t_less @ A @ B )
      = ( ^ [Less: ( A > A > $o ),K2: A,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( rBT_Im380146495e_keys @ A @ B @ T2 ) ) )
           => ( Less @ X2 @ K2 ) ) ) ) )).

% ord.rbt_less_prop
thf(fact_37_local_Olexordp__antisym,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ~ ( lexordp @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_antisym
thf(fact_38_local_Olexordp__irreflexive,axiom,(
    ! [Xs: ( list @ a )] :
      ( ! [X3: a] :
          ~ ( less @ X3 @ X3 )
     => ~ ( lexordp @ a @ less @ Xs @ Xs ) ) )).

% local.lexordp_irreflexive
thf(fact_39_local_Olexordp__irreflexive_H,axiom,(
    ! [Xs: ( list @ a )] :
      ~ ( lexordp @ a @ less @ Xs @ Xs ) )).

% local.lexordp_irreflexive'
thf(fact_40_local_Olexordp__linear,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
      | ( Xs = Ys )
      | ( lexordp @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_linear
thf(fact_41_local_Olexordp__trans,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a ),Zs: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( ( lexordp @ a @ less @ Ys @ Zs )
       => ( lexordp @ a @ less @ Xs @ Zs ) ) ) )).

% local.lexordp_trans
thf(fact_42_local_Olexordp__into__lexordp__eq,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( lexordp_eq @ a @ less @ Xs @ Ys ) ) )).

% local.lexordp_into_lexordp_eq
thf(fact_43_local_Olexordp__eq__conv__lexord,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
      = ( ( Xs = Ys )
        | ( lexordp @ a @ less @ Xs @ Ys ) ) ) )).

% local.lexordp_eq_conv_lexord
thf(fact_44_local_Olexordp__conv__lexordp__eq,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
      = ( ( lexordp_eq @ a @ less @ Xs @ Ys )
        & ~ ( lexordp_eq @ a @ less @ Ys @ Xs ) ) ) )).

% local.lexordp_conv_lexordp_eq
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_Ostrict__mono__less,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( less @ X @ Y ) ) ) ) )).

% local.strict_mono_less
thf(fact_50_local_Ostrict__mono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( strict_mono @ a @ B @ less @ F )
          = ( ! [X2: a,Y2: a] :
                ( ( less @ X2 @ Y2 )
               => ( ord_less @ B @ ( F @ X2 ) @ ( F @ Y2 ) ) ) ) ) ) )).

% local.strict_mono_def
thf(fact_51_local_Ostrict__monoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y3: a] :
              ( ( less @ X3 @ Y3 )
             => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( strict_mono @ a @ B @ less @ F ) ) ) )).

% local.strict_monoI
thf(fact_52_local_Ostrict__monoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( less @ X @ Y )
           => ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.strict_monoD
thf(fact_53_local_Olexordp__eq_ONil,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq.Nil
thf(fact_54_ord_Olexordp__into__lexordp__eq,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ Xs @ Ys )
     => ( lexordp_eq @ A @ Less2 @ Xs @ Ys ) ) )).

% ord.lexordp_into_lexordp_eq
thf(fact_55_local_Olexordp__eq_OCons__eq,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X @ Y )
     => ( ~ ( less @ Y @ X )
       => ( ( lexordp_eq @ a @ less @ Xs @ Ys )
         => ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) ) ) )).

% local.lexordp_eq.Cons_eq
thf(fact_56_local_Olexordp__eq_OCons,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X @ Y )
     => ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) )).

% local.lexordp_eq.Cons
thf(fact_57_local_Olexordp_OCons,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X @ Y )
     => ( lexordp @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) )).

% local.lexordp.Cons
thf(fact_58_local_Olexordp_OCons__eq,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X @ Y )
     => ( ~ ( less @ Y @ X )
       => ( ( lexordp @ a @ less @ Xs @ Ys )
         => ( lexordp @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) ) ) )).

% local.lexordp.Cons_eq
thf(fact_59_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_60_local_Olexordp_ONil,axiom,(
    ! [Y: a,Ys: ( list @ a )] :
      ( lexordp @ a @ less @ ( nil @ a ) @ ( cons @ a @ Y @ Ys ) ) )).

% local.lexordp.Nil
thf(fact_61_local_Olexordp_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Y3: a,Ys2: ( list @ a )] :
              ( A22
             != ( cons @ a @ Y3 @ Ys2 ) ) )
       => ( ! [X3: a] :
              ( ? [Xs2: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X3 @ Xs2 ) )
             => ! [Y3: a] :
                  ( ? [Ys2: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y3 @ Ys2 ) )
                 => ~ ( less @ X3 @ Y3 ) ) )
         => ~ ( ! [X3: a,Y3: a,Xs2: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y3 @ Ys2 ) )
                     => ( ~ ( less @ X3 @ Y3 )
                       => ( ~ ( less @ Y3 @ X3 )
                         => ~ ( lexordp @ a @ less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% local.lexordp.cases
thf(fact_62_local_Olexordp_Oinducts,axiom,(
    ! [X1: ( list @ a ),X23: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp @ a @ less @ X1 @ X23 )
     => ( ! [Y3: a,Ys2: ( list @ a )] :
            ( P @ ( nil @ a ) @ ( cons @ a @ Y3 @ Ys2 ) )
       => ( ! [X3: a,Y3: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
              ( ( less @ X3 @ Y3 )
             => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y3 @ Ys2 ) ) )
         => ( ! [X3: a,Y3: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ~ ( less @ X3 @ Y3 )
               => ( ~ ( less @ Y3 @ X3 )
                 => ( ( lexordp @ a @ less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y3 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% local.lexordp.inducts
thf(fact_63_local_Olexordp_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp @ a @ less @ A1 @ A22 )
      = ( ? [Y2: a,Ys3: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22
              = ( cons @ a @ Y2 @ Ys3 ) ) )
        | ? [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X2 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y2 @ Ys3 ) )
            & ( less @ X2 @ Y2 ) )
        | ? [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X2 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y2 @ Ys3 ) )
            & ~ ( less @ X2 @ Y2 )
            & ~ ( less @ Y2 @ X2 )
            & ( lexordp @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp.simps
thf(fact_64_local_Olexordp__cases,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( ( ( Xs
            = ( nil @ a ) )
         => ! [Y3: a,Ys4: ( list @ a )] :
              ( Ys
             != ( cons @ a @ Y3 @ Ys4 ) ) )
       => ( ! [X3: a] :
              ( ? [Xs4: ( list @ a )] :
                  ( Xs
                  = ( cons @ a @ X3 @ Xs4 ) )
             => ! [Y3: a] :
                  ( ? [Ys4: ( list @ a )] :
                      ( Ys
                      = ( cons @ a @ Y3 @ Ys4 ) )
                 => ~ ( less @ X3 @ Y3 ) ) )
         => ~ ( ! [X3: a,Xs4: ( list @ a )] :
                  ( ( Xs
                    = ( cons @ a @ X3 @ Xs4 ) )
                 => ! [Ys4: ( list @ a )] :
                      ( ( Ys
                        = ( cons @ a @ X3 @ Ys4 ) )
                     => ~ ( lexordp @ a @ less @ Xs4 @ Ys4 ) ) ) ) ) ) ) )).

% local.lexordp_cases
thf(fact_65_local_Olexordp__induct,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( ! [Y3: a,Ys2: ( list @ a )] :
            ( P @ ( nil @ a ) @ ( cons @ a @ Y3 @ Ys2 ) )
       => ( ! [X3: a,Xs2: ( list @ a ),Y3: a,Ys2: ( list @ a )] :
              ( ( less @ X3 @ Y3 )
             => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y3 @ Ys2 ) ) )
         => ( ! [X3: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ( lexordp @ a @ less @ Xs2 @ Ys2 )
               => ( ( P @ Xs2 @ Ys2 )
                 => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ X3 @ Ys2 ) ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% local.lexordp_induct
thf(fact_66_local_Olexordp__eq_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Ys2: ( list @ a )] : ( A22 != Ys2 ) )
       => ( ! [X3: a] :
              ( ? [Xs2: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X3 @ Xs2 ) )
             => ! [Y3: a] :
                  ( ? [Ys2: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y3 @ Ys2 ) )
                 => ~ ( less @ X3 @ Y3 ) ) )
         => ~ ( ! [X3: a,Y3: a,Xs2: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y3 @ Ys2 ) )
                     => ( ~ ( less @ X3 @ Y3 )
                       => ( ~ ( less @ Y3 @ X3 )
                         => ~ ( lexordp_eq @ a @ less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% local.lexordp_eq.cases
thf(fact_67_local_Olexordp__eq_Oinducts,axiom,(
    ! [X1: ( list @ a ),X23: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp_eq @ a @ less @ X1 @ X23 )
     => ( ! [X12: ( list @ a )] :
            ( P @ ( nil @ a ) @ X12 )
       => ( ! [X3: a,Y3: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
              ( ( less @ X3 @ Y3 )
             => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y3 @ Ys2 ) ) )
         => ( ! [X3: a,Y3: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ~ ( less @ X3 @ Y3 )
               => ( ~ ( less @ Y3 @ X3 )
                 => ( ( lexordp_eq @ a @ less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y3 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% local.lexordp_eq.inducts
thf(fact_68_local_Olexordp__eq_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
      = ( ? [Ys3: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22 = Ys3 ) )
        | ? [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X2 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y2 @ Ys3 ) )
            & ( less @ X2 @ Y2 ) )
        | ? [X2: a,Y2: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X2 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y2 @ Ys3 ) )
            & ~ ( less @ X2 @ Y2 )
            & ~ ( less @ Y2 @ X2 )
            & ( lexordp_eq @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp_eq.simps
thf(fact_69_ord_Olexordp__simps_I3_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less2 @ X @ Y )
        | ( ~ ( Less2 @ Y @ X )
          & ( lexordp @ A @ Less2 @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_simps(3)
thf(fact_70_ord_Olexordp__simps_I1_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ ( nil @ A ) @ Ys )
      = ( Ys
       != ( nil @ A ) ) ) )).

% ord.lexordp_simps(1)
thf(fact_71_ord_Olexordp__simps_I2_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs: ( list @ A )] :
      ~ ( lexordp @ A @ Less2 @ Xs @ ( nil @ A ) ) )).

% ord.lexordp_simps(2)
thf(fact_72_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less2 @ X @ Y )
        | ( ~ ( Less2 @ Y @ X )
          & ( lexordp_eq @ A @ Less2 @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_73_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less2 @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_74_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less2 @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_75_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_76_local_Olexordp__simps_I3_J,axiom,(
    ! [X: a,Xs: ( list @ a ),Y: a,Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) )
      = ( ( less @ X @ Y )
        | ( ~ ( less @ Y @ X )
          & ( lexordp @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_simps(3)
thf(fact_77_local_Olexordp__eq__simps_I4_J,axiom,(
    ! [X: a,Xs: ( list @ a ),Y: a,Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) )
      = ( ( less @ X @ Y )
        | ( ~ ( less @ Y @ X )
          & ( lexordp_eq @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_eq_simps(4)
thf(fact_78_local_Olexordp__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ~ ( lexordp @ a @ less @ Xs @ ( nil @ a ) ) )).

% local.lexordp_simps(2)
thf(fact_79_local_Olexordp__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( nil @ a ) @ Ys )
      = ( Ys
       != ( nil @ a ) ) ) )).

% local.lexordp_simps(1)
thf(fact_80_local_Olexordp__eq__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ ( nil @ a ) )
      = ( Xs
        = ( nil @ a ) ) ) )).

% local.lexordp_eq_simps(2)
thf(fact_81_local_Olexordp__eq__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq_simps(1)
thf(fact_82_local_Olexordp__eq__simps_I3_J,axiom,(
    ! [X: a,Xs: ( list @ a )] :
      ~ ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( nil @ a ) ) )).

% local.lexordp_eq_simps(3)
thf(fact_83_ord_Olexordp_ONil,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Y: A,Ys: ( list @ A )] :
      ( lexordp @ A @ Less2 @ ( nil @ A ) @ ( cons @ A @ Y @ Ys ) ) )).

% ord.lexordp.Nil
thf(fact_84_ord_Olexordp_Ocases,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Y3: A,Ys2: ( list @ A )] :
              ( A22
             != ( cons @ A @ Y3 @ Ys2 ) ) )
       => ( ! [X3: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y3: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y3 @ Ys2 ) )
                 => ~ ( Less2 @ X3 @ Y3 ) ) )
         => ~ ( ! [X3: A,Y3: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y3 @ Ys2 ) )
                     => ( ~ ( Less2 @ X3 @ Y3 )
                       => ( ~ ( Less2 @ Y3 @ X3 )
                         => ~ ( lexordp @ A @ Less2 @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp.cases
thf(fact_85_ord_Olexordp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [Less: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Y2: A,Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys3 ) ) )
            | ? [X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys3 ) )
                & ( Less @ X2 @ Y2 ) )
            | ? [X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys3 ) )
                & ~ ( Less @ X2 @ Y2 )
                & ~ ( Less @ Y2 @ X2 )
                & ( lexordp @ A @ Less @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp.simps
thf(fact_86_ord_Olexordp_Oinducts,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp @ A @ Less2 @ X1 @ X23 )
     => ( ! [Y3: A,Ys2: ( list @ A )] :
            ( P @ ( nil @ A ) @ ( cons @ A @ Y3 @ Ys2 ) )
       => ( ! [X3: A,Y3: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less2 @ X3 @ Y3 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys2 ) ) )
         => ( ! [X3: A,Y3: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less2 @ X3 @ Y3 )
               => ( ~ ( Less2 @ Y3 @ X3 )
                 => ( ( lexordp @ A @ Less2 @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% ord.lexordp.inducts
thf(fact_87_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys2: ( list @ A )] : ( A22 != Ys2 ) )
       => ( ! [X3: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y3: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y3 @ Ys2 ) )
                 => ~ ( Less2 @ X3 @ Y3 ) ) )
         => ~ ( ! [X3: A,Y3: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y3 @ Ys2 ) )
                     => ( ~ ( Less2 @ X3 @ Y3 )
                       => ( ~ ( Less2 @ Y3 @ X3 )
                         => ~ ( lexordp_eq @ A @ Less2 @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_88_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys3 ) )
            | ? [X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys3 ) )
                & ( Less @ X2 @ Y2 ) )
            | ? [X2: A,Y2: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y2 @ Ys3 ) )
                & ~ ( Less @ X2 @ Y2 )
                & ~ ( Less @ Y2 @ X2 )
                & ( lexordp_eq @ A @ Less @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_89_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less2 @ X1 @ X23 )
     => ( ! [X12: ( list @ A )] :
            ( P @ ( nil @ A ) @ X12 )
       => ( ! [X3: A,Y3: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less2 @ X3 @ Y3 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys2 ) ) )
         => ( ! [X3: A,Y3: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less2 @ X3 @ Y3 )
               => ( ~ ( Less2 @ Y3 @ X3 )
                 => ( ( lexordp_eq @ A @ Less2 @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys2 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_90_list_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( list @ A )] :
      ( ( member @ A @ E @ ( set2 @ A @ A2 ) )
     => ( ! [Z2: ( list @ A )] :
            ( A2
           != ( cons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( list @ A )] :
                ( ( A2
                  = ( cons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( set2 @ A @ Z2 ) ) ) ) ) ) )).

% list.set_cases
thf(fact_91_set__ConsD,axiom,(
    ! [A: $tType,Y: A,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
     => ( ( Y = X )
        | ( member @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) )).

% set_ConsD
thf(fact_92_list_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( list @ A )] :
      ( member @ A @ A1 @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) )).

% list.set_intros(1)
thf(fact_93_list_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A22: ( list @ A ),A1: A] :
      ( ( member @ A @ X @ ( set2 @ A @ A22 ) )
     => ( member @ A @ X @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) ) )).

% list.set_intros(2)
thf(fact_94_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F2: ( A > B ),X12: ( list @ B )] :
          ( P @ F2 @ ( nil @ A ) @ X12 )
     => ( ! [F2: ( A > B ),A4: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F2 @ As @ ( cons @ B @ ( F2 @ A4 ) @ Bs ) )
           => ( P @ F2 @ ( cons @ A @ A4 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_95_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_96_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Y3: A,Xs2: ( list @ A )] :
              ( ( ( X3 = Y3 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) )
             => ( ( ( X3 != Y3 )
                 => ( P @ ( cons @ A @ Y3 @ Xs2 ) ) )
               => ( P @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_97_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X: ( list @ A )] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ( ! [X3: A,Y3: A,Xs2: ( list @ A )] :
                ( X
               != ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_98_transpose_Ocases,axiom,(
    ! [A: $tType,X: ( list @ ( list @ A ) )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X3: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X
               != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_99_not__Cons__self2,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_100_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P @ ( nil @ A ) @ X12 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X3: A,Xs2: ( list @ A ),Y3: A,Ys2: ( list @ A )] :
              ( ( P @ Xs2 @ Ys2 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_101_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: ( list @ A )] :
            ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y3: B,Ys2: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y3 @ Ys2 ) )
         => ( ! [X3: A,Xs2: ( list @ A ),Y3: B,Ys2: ( list @ B )] :
                ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys2 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_102_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y2: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y2 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_103_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X12: A,X24: ( list @ A )] :
            ( ( P @ X24 )
           => ( P @ ( cons @ A @ X12 @ X24 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_104_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_105_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_106_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_107_ord_Olexordp_OCons__eq,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less2 @ X @ Y )
     => ( ~ ( Less2 @ Y @ X )
       => ( ( lexordp @ A @ Less2 @ Xs @ Ys )
         => ( lexordp @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp.Cons_eq
thf(fact_108_ord_Olexordp_OCons,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less2 @ X @ Y )
     => ( lexordp @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp.Cons
thf(fact_109_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less2 @ X @ Y )
     => ( ~ ( Less2 @ Y @ X )
       => ( ( lexordp_eq @ A @ Less2 @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_110_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less2 @ X @ Y )
     => ( lexordp_eq @ A @ Less2 @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_111_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less2 @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_112_ord_Olexordp__irreflexive,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs: ( list @ A )] :
      ( ! [X3: A] :
          ~ ( Less2 @ X3 @ X3 )
     => ~ ( lexordp @ A @ Less2 @ Xs @ Xs ) ) )).

% ord.lexordp_irreflexive
thf(fact_113_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less2 @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_114_local_Olexordp__append__rightI,axiom,(
    ! [Ys: ( list @ a ),Xs: ( list @ a )] :
      ( ( Ys
       != ( nil @ a ) )
     => ( lexordp @ a @ less @ Xs @ ( append @ a @ Xs @ Ys ) ) ) )).

% local.lexordp_append_rightI
thf(fact_115_local_Olexordp__append__left__rightI,axiom,(
    ! [X: a,Y: a,Us: ( list @ a ),Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X @ Y )
     => ( lexordp @ a @ less @ ( append @ a @ Us @ ( cons @ a @ X @ Xs ) ) @ ( append @ a @ Us @ ( cons @ a @ Y @ Ys ) ) ) ) )).

% local.lexordp_append_left_rightI
thf(fact_116_local_Olexordp__iff,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
      = ( ? [X2: a,Vs: ( list @ a )] :
            ( Ys
            = ( append @ a @ Xs @ ( cons @ a @ X2 @ Vs ) ) )
        | ? [Us2: ( list @ a ),A5: a,B3: a,Vs: ( list @ a ),Ws: ( list @ a )] :
            ( ( less @ A5 @ B3 )
            & ( Xs
              = ( append @ a @ Us2 @ ( cons @ a @ A5 @ Vs ) ) )
            & ( Ys
              = ( append @ a @ Us2 @ ( cons @ a @ B3 @ Ws ) ) ) ) ) ) )).

% local.lexordp_iff
thf(fact_117_the__elem__set,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) )).

% the_elem_set
thf(fact_118_local_Olexordp__append__leftD,axiom,(
    ! [Xs: ( list @ a ),Us: ( list @ a ),Vs2: ( list @ a )] :
      ( ( lexordp @ a @ less @ ( append @ a @ Xs @ Us ) @ ( append @ a @ Xs @ Vs2 ) )
     => ( ! [A4: a] :
            ~ ( less @ A4 @ A4 )
       => ( lexordp @ a @ less @ Us @ Vs2 ) ) ) )).

% local.lexordp_append_leftD
thf(fact_119_local_Olexordp__append__leftI,axiom,(
    ! [Us: ( list @ a ),Vs2: ( list @ a ),Xs: ( list @ a )] :
      ( ( lexordp @ a @ less @ Us @ Vs2 )
     => ( lexordp @ a @ less @ ( append @ a @ Xs @ Us ) @ ( append @ a @ Xs @ Vs2 ) ) ) )).

% local.lexordp_append_leftI
thf(fact_120_local_Ostrict__mono__imp__inj__on,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),A3: ( set @ a )] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( inj_on @ a @ B @ F @ A3 ) ) ) )).

% local.strict_mono_imp_inj_on
thf(fact_121_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_122_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_123_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_124_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_125_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_126_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_127_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_128_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_129_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_130_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_131_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X = Y ) ) ) )).

% append1_eq_conv
thf(fact_132_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_133_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_134_Cons__eq__appendI,axiom,(
    ! [A: $tType,X: A,Xs1: ( list @ A ),Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_135_append__Cons,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys ) ) ) )).

% append_Cons
thf(fact_136_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_137_append__Nil,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_138_ord_Olexordp__append__leftI,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Us: ( list @ A ),Vs2: ( list @ A ),Xs: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ Us @ Vs2 )
     => ( lexordp @ A @ Less2 @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs2 ) ) ) )).

% ord.lexordp_append_leftI
thf(fact_139_ord_Olexordp__append__leftD,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),Xs: ( list @ A ),Us: ( list @ A ),Vs2: ( list @ A )] :
      ( ( lexordp @ A @ Less2 @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs2 ) )
     => ( ! [A4: A] :
            ~ ( Less2 @ A4 @ A4 )
       => ( lexordp @ A @ Less2 @ Us @ Vs2 ) ) ) )).

% ord.lexordp_append_leftD
thf(fact_140_rev__induct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A,Xs2: ( list @ A )] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) )).

% rev_induct
thf(fact_141_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys2: ( list @ A ),Y3: A] :
              ( Xs
             != ( append @ A @ Ys2 @ ( cons @ A @ Y3 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_142_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys5: ( list @ A )] :
            ( ( ( cons @ A @ X @ Ys5 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys5 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_143_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys5: ( list @ A )] :
            ( ( Ys
              = ( cons @ A @ X @ Ys5 ) )
            & ( ( append @ A @ Ys5 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_144_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_145_split__list__first__prop__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P @ X2 ) ) )
      = ( ? [Ys3: ( list @ A ),X2: A] :
            ( ? [Zs2: ( list @ A )] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs2 ) ) )
            & ( P @ X2 )
            & ! [Y2: A] :
                ( ( member @ A @ Y2 @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y2 ) ) ) ) ) )).

% split_list_first_prop_iff
thf(fact_146_split__list__last__prop__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
            & ( P @ X2 ) ) )
      = ( ? [Ys3: ( list @ A ),X2: A,Zs2: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs2 ) ) )
            & ( P @ X2 )
            & ! [Y2: A] :
                ( ( member @ A @ Y2 @ ( set2 @ A @ Zs2 ) )
               => ~ ( P @ Y2 ) ) ) ) ) )).

% split_list_last_prop_iff
thf(fact_147_in__set__conv__decomp__first,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: ( list @ A ),Zs2: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs2 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Ys3 ) ) ) ) ) )).

% in_set_conv_decomp_first
thf(fact_148_in__set__conv__decomp__last,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: ( list @ A ),Zs2: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs2 ) ) )
            & ~ ( member @ A @ X @ ( set2 @ A @ Zs2 ) ) ) ) ) )).

% in_set_conv_decomp_last
thf(fact_149_split__list__first__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ~ ( ! [Ys2: ( list @ A ),X3: A] :
              ( ? [Zs3: ( list @ A )] :
                  ( Xs
                  = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs3 ) ) )
             => ( ( P @ X3 )
               => ~ ( ! [Xa: A] :
                        ( ( member @ A @ Xa @ ( set2 @ A @ Ys2 ) )
                       => ~ ( P @ Xa ) ) ) ) ) ) ) )).

% split_list_first_propE
thf(fact_150_split__list__last__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ~ ( ! [Ys2: ( list @ A ),X3: A,Zs3: ( list @ A )] :
              ( ( Xs
                = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs3 ) ) )
             => ( ( P @ X3 )
               => ~ ( ! [Xa: A] :
                        ( ( member @ A @ Xa @ ( set2 @ A @ Zs3 ) )
                       => ~ ( P @ Xa ) ) ) ) ) ) ) )).

% split_list_last_propE
thf(fact_151_split__list__first__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ? [Ys2: ( list @ A ),X3: A] :
          ( ? [Zs3: ( list @ A )] :
              ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs3 ) ) )
          & ( P @ X3 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Ys2 ) )
             => ~ ( P @ Xa ) ) ) ) )).

% split_list_first_prop
thf(fact_152_split__list__last__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ? [Ys2: ( list @ A ),X3: A,Zs3: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs3 ) ) )
          & ( P @ X3 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Zs3 ) )
             => ~ ( P @ Xa ) ) ) ) )).

% split_list_last_prop
thf(fact_153_in__set__conv__decomp,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: ( list @ A ),Zs2: ( list @ A )] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs2 ) ) ) ) ) )).

% in_set_conv_decomp
thf(fact_154_split__list__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ~ ( ! [Ys2: ( list @ A ),X3: A] :
              ( ? [Zs3: ( list @ A )] :
                  ( Xs
                  = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs3 ) ) )
             => ~ ( P @ X3 ) ) ) ) )).

% split_list_propE
thf(fact_155_split__list__first,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys2: ( list @ A ),Zs3: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X @ Zs3 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Ys2 ) ) ) ) )).

% split_list_first
thf(fact_156_split__list__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( set2 @ A @ Xs ) )
          & ( P @ X4 ) )
     => ? [Ys2: ( list @ A ),X3: A] :
          ( ? [Zs3: ( list @ A )] :
              ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs3 ) ) )
          & ( P @ X3 ) ) ) )).

% split_list_prop
thf(fact_157_split__list__last,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys2: ( list @ A ),Zs3: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X @ Zs3 ) ) )
          & ~ ( member @ A @ X @ ( set2 @ A @ Zs3 ) ) ) ) )).

% split_list_last
thf(fact_158_split__list,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ? [Ys2: ( list @ A ),Zs3: ( list @ A )] :
          ( Xs
          = ( append @ A @ Ys2 @ ( cons @ A @ X @ Zs3 ) ) ) ) )).

% split_list
thf(fact_159_ord_Olexordp__append__left__rightI,axiom,(
    ! [A: $tType,Less2: ( A > A > $o ),X: A,Y: A,Us: ( list @ A ),Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less2 @ X @ Y )
     => ( lexordp @ A @ Less2 @ ( append @ A @ Us @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys ) ) ) ) )).

% ord.lexordp_append_left_rightI
thf(fact_160_ord_Olexordp__append__rightI,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Less2: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( Ys
       != ( nil @ A ) )
     => ( lexordp @ A @ Less2 @ Xs @ ( append @ A @ Xs @ Ys ) ) ) )).

% ord.lexordp_append_rightI
thf(fact_161_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_162_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_163_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X: B,Xs: ( list @ B ),F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F )
      = ( append @ A @ ( F @ X ) @ ( bind @ B @ A @ Xs @ F ) ) ) )).

% bind_simps(2)
thf(fact_164_ord__class_Orbt__greater__prop,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( rBT_Im1332541288reater @ A @ B )
        = ( ^ [K2: A,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ ( rBT_Im380146495e_keys @ A @ B @ T2 ) ) )
             => ( ord_less @ A @ K2 @ X2 ) ) ) ) ) )).

% ord_class.rbt_greater_prop
thf(fact_165_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_166_order__class_Orbt__greater__trans,axiom,(
    ! [C2: $tType,A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,T: ( rBT_Im246033960le_rbt @ A @ C2 )] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( rBT_Im1332541288reater @ A @ C2 @ Y @ T )
           => ( rBT_Im1332541288reater @ A @ C2 @ X @ T ) ) ) ) )).

% order_class.rbt_greater_trans
thf(fact_167_list__bind__cong,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),F: ( A > ( list @ B ) ),G: ( A > ( list @ B ) )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( bind @ A @ B @ Xs @ F )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) )).

% list_bind_cong
thf(fact_168_ord__class_Orbt__less__prop,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( rBT_Im903026891t_less @ A @ B )
        = ( ^ [K2: A,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ ( set2 @ A @ ( rBT_Im380146495e_keys @ A @ B @ T2 ) ) )
             => ( ord_less @ A @ X2 @ K2 ) ) ) ) ) )).

% ord_class.rbt_less_prop
thf(fact_169_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( list @ A ) ),X: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F @ ( cons @ B @ X @ Xs ) )
      = ( append @ A @ ( F @ X ) @ ( maps @ B @ A @ F @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_170_not__in__set__insert,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = ( cons @ A @ X @ Xs ) ) ) )).

% not_in_set_insert
thf(fact_171_in__set__insert,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X @ Xs )
        = Xs ) ) )).

% in_set_insert
thf(fact_172_insert__Nil,axiom,(
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_173_order__class_Orbt__less__trans,axiom,(
    ! [C2: $tType,A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,T: ( rBT_Im246033960le_rbt @ A @ C2 ),Y: A] :
          ( ( rBT_Im903026891t_less @ A @ C2 @ X @ T )
         => ( ( ord_less @ A @ X @ Y )
           => ( rBT_Im903026891t_less @ A @ C2 @ Y @ T ) ) ) ) )).

% order_class.rbt_less_trans
thf(fact_174_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_175_List_Oinsert__def,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X2: A,Xs3: ( list @ A )] :
            ( if @ ( list @ A ) @ ( member @ A @ X2 @ ( set2 @ A @ Xs3 ) ) @ Xs3 @ ( cons @ A @ X2 @ Xs3 ) ) ) ) )).

% List.insert_def
thf(fact_176_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_177_local_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_less_simps(1)
thf(fact_178_last__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) )).

% last_snoc
thf(fact_179_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_180_set__rotate1,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) )).

% set_rotate1
thf(fact_181_ord__class_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [K: A] :
          ( rBT_Im1332541288reater @ A @ B @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord_class.rbt_greater_simps(1)
thf(fact_182_ord__class_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [K: A] :
          ( rBT_Im903026891t_less @ A @ B @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord_class.rbt_less_simps(1)
thf(fact_183_last__appendL,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Xs ) ) ) )).

% last_appendL
thf(fact_184_last__appendR,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Ys ) ) ) )).

% last_appendR
thf(fact_185_keys__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im380146495e_keys @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ A ) ) )).

% keys_simps(1)
thf(fact_186_local_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_greater_simps(1)
thf(fact_187_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_188_ord_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less2: ( A > A > $o ),K: A] :
      ( rBT_Im2075124343t_less @ A @ B @ Less2 @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_less_simps(1)
thf(fact_189_ord_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less2: ( A > A > $o ),K: A] :
      ( rBT_Im1259024060reater @ A @ B @ Less2 @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_greater_simps(1)
thf(fact_190_last__ConsR,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_ConsR
thf(fact_191_last__ConsL,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = X ) ) )).

% last_ConsL
thf(fact_192_last_Osimps,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = X ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) )).

% last.simps
thf(fact_193_last__in__set,axiom,(
    ! [A: $tType,As2: ( list @ A )] :
      ( ( As2
       != ( nil @ A ) )
     => ( member @ A @ ( last @ A @ As2 ) @ ( set2 @ A @ As2 ) ) ) )).

% last_in_set
thf(fact_194_last__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Ys ) ) ) ) )).

% last_append
thf(fact_195_longest__common__suffix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
    ? [Ss: ( list @ A ),Xs4: ( list @ A ),Ys4: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs4 @ Ss ) )
      & ( Ys
        = ( append @ A @ Ys4 @ Ss ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys4
          = ( nil @ A ) )
        | ( ( last @ A @ Xs4 )
         != ( last @ A @ Ys4 ) ) ) ) )).

% longest_common_suffix
thf(fact_196_non__empty__rbt__keys,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( T
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ( rBT_Im380146495e_keys @ A @ B @ T )
       != ( nil @ A ) ) ) )).

% non_empty_rbt_keys
thf(fact_197_local_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType] :
      ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_sorted.simps(1)
thf(fact_198_append__butlast__last__id,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) )).

% append_butlast_last_id
thf(fact_199_snoc__eq__iff__butlast,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = Ys )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X ) ) ) )).

% snoc_eq_iff_butlast
thf(fact_200_butlast__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = Xs ) )).

% butlast_snoc
thf(fact_201_butlast_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% butlast.simps(1)
thf(fact_202_in__set__butlastD,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
     => ( member @ A @ X @ ( set2 @ A @ Xs ) ) ) )).

% in_set_butlastD
thf(fact_203_butlast_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( butlast @ A @ Xs ) ) ) ) ) )).

% butlast.simps(2)
thf(fact_204_butlast__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys ) ) ) ) ) )).

% butlast_append
thf(fact_205_in__set__butlast__appendI,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Xs ) ) )
        | ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ Ys ) ) ) )
     => ( member @ A @ X @ ( set2 @ A @ ( butlast @ A @ ( append @ A @ Xs @ Ys ) ) ) ) ) )).

% in_set_butlast_appendI
thf(fact_206_ord_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less2: ( A > A > $o )] :
      ( rBT_Im759614907sorted @ A @ B @ Less2 @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_sorted.simps(1)
thf(fact_207_local_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V2: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ C @ L @ K @ V2 @ R ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
        & ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
        & ( rBT_Im759614907sorted @ a @ B @ less @ L )
        & ( rBT_Im759614907sorted @ a @ B @ less @ R ) ) ) )).

% local.rbt_sorted.simps(2)
thf(fact_208_local_Odistinct__keys,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( distinct @ a @ ( rBT_Im380146495e_keys @ a @ B @ T ) ) ) )).

% local.distinct_keys
thf(fact_209_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X232 @ X242 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X232 = Y23 )
        & ( X242 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_210_distinct1__rotate,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) )).

% distinct1_rotate
thf(fact_211_distinct__insert,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( insert @ A @ X @ Xs ) )
      = ( distinct @ A @ Xs ) ) )).

% distinct_insert
thf(fact_212_ord__class_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V2: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
          ( ( rBT_Im1332541288reater @ A @ C2 @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V2 @ Rt ) )
          = ( ( ord_less @ A @ K @ Kt )
            & ( rBT_Im1332541288reater @ A @ C2 @ K @ Lt )
            & ( rBT_Im1332541288reater @ A @ C2 @ K @ Rt ) ) ) ) )).

% ord_class.rbt_greater_simps(2)
thf(fact_213_ord__class_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V2: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
          ( ( rBT_Im903026891t_less @ A @ C2 @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V2 @ Rt ) )
          = ( ( ord_less @ A @ Kt @ K )
            & ( rBT_Im903026891t_less @ A @ C2 @ K @ Lt )
            & ( rBT_Im903026891t_less @ A @ C2 @ K @ Rt ) ) ) ) )).

% ord_class.rbt_less_simps(2)
thf(fact_214_local_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,K: a,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C2 ),Kt: a,V2: C2,Rt: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ ( rBT_Im480247531Branch @ a @ C2 @ C @ Lt @ Kt @ V2 @ Rt ) )
      = ( ( less @ K @ Kt )
        & ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ Lt )
        & ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ Rt ) ) ) )).

% local.rbt_greater_simps(2)
thf(fact_215_local_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,K: a,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C2 ),Kt: a,V2: C2,Rt: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ ( rBT_Im480247531Branch @ a @ C2 @ C @ Lt @ Kt @ V2 @ Rt ) )
      = ( ( less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ Rt ) ) ) )).

% local.rbt_less_simps(2)
thf(fact_216_keys__simps_I2_J,axiom,(
    ! [D: $tType,C2: $tType,C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ C2 @ D ),K: C2,V2: D,R: ( rBT_Im246033960le_rbt @ C2 @ D )] :
      ( ( rBT_Im380146495e_keys @ C2 @ D @ ( rBT_Im480247531Branch @ C2 @ D @ C @ L @ K @ V2 @ R ) )
      = ( append @ C2 @ ( rBT_Im380146495e_keys @ C2 @ D @ L ) @ ( cons @ C2 @ K @ ( rBT_Im380146495e_keys @ C2 @ D @ R ) ) ) ) )).

% keys_simps(2)
thf(fact_217_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X233: A,X243: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X233 @ X243 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_218_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X12: rBT_Im1923302023_color,X24: ( rBT_Im246033960le_rbt @ A @ B ),X32: A,X42: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X24 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X12 @ X24 @ X32 @ X42 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_219_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X232 @ X242 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_220_distinct__butlast,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( butlast @ A @ Xs ) ) ) )).

% distinct_butlast
thf(fact_221_distinct__singleton,axiom,(
    ! [A: $tType,X: A] :
      ( distinct @ A @ ( cons @ A @ X @ ( nil @ A ) ) ) )).

% distinct_singleton
thf(fact_222_distinct_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( cons @ A @ X @ Xs ) )
      = ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) )).

% distinct.simps(2)
thf(fact_223_distinct__length__2__or__more,axiom,(
    ! [A: $tType,A2: A,B2: A,Xs: ( list @ A )] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) )).

% distinct_length_2_or_more
thf(fact_224_distinct_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( distinct @ A @ ( nil @ A ) ) )).

% distinct.simps(1)
thf(fact_225_ord_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType,Less2: ( A > A > $o ),K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V2: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
      ( ( rBT_Im2075124343t_less @ A @ C2 @ Less2 @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V2 @ Rt ) )
      = ( ( Less2 @ Kt @ K )
        & ( rBT_Im2075124343t_less @ A @ C2 @ Less2 @ K @ Lt )
        & ( rBT_Im2075124343t_less @ A @ C2 @ Less2 @ K @ Rt ) ) ) )).

% ord.rbt_less_simps(2)
thf(fact_226_ord_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType,Less2: ( A > A > $o ),K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V2: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
      ( ( rBT_Im1259024060reater @ A @ C2 @ Less2 @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V2 @ Rt ) )
      = ( ( Less2 @ K @ Kt )
        & ( rBT_Im1259024060reater @ A @ C2 @ Less2 @ K @ Lt )
        & ( rBT_Im1259024060reater @ A @ C2 @ Less2 @ K @ Rt ) ) ) )).

% ord.rbt_greater_simps(2)
thf(fact_227_distinct__product__lists,axiom,(
    ! [A: $tType,Xss2: ( list @ ( list @ A ) )] :
      ( ! [X3: ( list @ A )] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xss2 ) )
         => ( distinct @ A @ X3 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss2 ) ) ) )).

% distinct_product_lists
thf(fact_228_not__distinct__decomp,axiom,(
    ! [A: $tType,Ws2: ( list @ A )] :
      ( ~ ( distinct @ A @ Ws2 )
     => ? [Xs2: ( list @ A ),Ys2: ( list @ A ),Zs3: ( list @ A ),Y3: A] :
          ( Ws2
          = ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ ( append @ A @ Ys2 @ ( append @ A @ ( cons @ A @ Y3 @ ( nil @ A ) ) @ Zs3 ) ) ) ) ) ) )).

% not_distinct_decomp
thf(fact_229_not__distinct__conv__prefix,axiom,(
    ! [A: $tType,As2: ( list @ A )] :
      ( ( ~ ( distinct @ A @ As2 ) )
      = ( ? [Xs3: ( list @ A ),Y2: A,Ys3: ( list @ A )] :
            ( ( member @ A @ Y2 @ ( set2 @ A @ Xs3 ) )
            & ( distinct @ A @ Xs3 )
            & ( As2
              = ( append @ A @ Xs3 @ ( cons @ A @ Y2 @ Ys3 ) ) ) ) ) ) )).

% not_distinct_conv_prefix
thf(fact_230_ord_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less2: ( A > A > $o ),C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V2: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less2 @ ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V2 @ R ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less2 @ K @ L )
        & ( rBT_Im1259024060reater @ A @ B @ Less2 @ K @ R )
        & ( rBT_Im759614907sorted @ A @ B @ Less2 @ L )
        & ( rBT_Im759614907sorted @ A @ B @ Less2 @ R ) ) ) )).

% ord.rbt_sorted.simps(2)
thf(fact_231_distinct__union,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) )).

% distinct_union
thf(fact_232_RBT__SORTED,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im480247531Branch @ a @ b @ c @ t1 @ k @ v @ t2 ) )).

% RBT_SORTED
thf(fact_233_Branch_Oprems,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im480247531Branch @ a @ b @ c @ t1 @ k @ v @ t2 ) )).

% Branch.prems
thf(fact_234_ord__class_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V2: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( ( rBT_Im1183586831sorted @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V2 @ R ) )
          = ( ( rBT_Im903026891t_less @ A @ B @ K @ L )
            & ( rBT_Im1332541288reater @ A @ B @ K @ R )
            & ( rBT_Im1183586831sorted @ A @ B @ L )
            & ( rBT_Im1183586831sorted @ A @ B @ R ) ) ) ) )).

% ord_class.rbt_sorted.simps(2)
thf(fact_235_ord__class_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( rBT_Im1183586831sorted @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord_class.rbt_sorted.simps(1)
thf(fact_236_linorder__class_Odistinct__keys,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [T: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( ( rBT_Im1183586831sorted @ A @ B @ T )
         => ( distinct @ A @ ( rBT_Im380146495e_keys @ A @ B @ T ) ) ) ) )).

% linorder_class.distinct_keys
thf(fact_237_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_238_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X2: a] :
            ( less @ X2 @ U ) ) ) )).

% local.lessThan_def
thf(fact_239_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_240_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_241_DOM__T1,axiom,(
    ! [K3: a] :
      ( ( member @ a @ K3 @ ( dom @ a @ b @ ( rBT_Im35466040lookup @ a @ b @ less @ t1 ) ) )
     => ( less @ K3 @ k ) ) )).

% DOM_T1
thf(fact_242_local_Orbt__lookup__keys,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( ( dom @ a @ B @ ( rBT_Im35466040lookup @ a @ B @ less @ T ) )
        = ( set2 @ a @ ( rBT_Im380146495e_keys @ a @ B @ T ) ) ) ) )).

% local.rbt_lookup_keys
thf(fact_243_Branch_Ohyps_I1_J,axiom,
    ( ( rBT_Im759614907sorted @ a @ b @ less @ t1 )
   => ( ( map_of @ a @ b @ ( rBT_Im954575269ntries @ a @ b @ t1 ) )
      = ( rBT_Im35466040lookup @ a @ b @ less @ t1 ) ) )).

% Branch.hyps(1)
thf(fact_244_Branch_Ohyps_I2_J,axiom,
    ( ( rBT_Im759614907sorted @ a @ b @ less @ t2 )
   => ( ( map_of @ a @ b @ ( rBT_Im954575269ntries @ a @ b @ t2 ) )
      = ( rBT_Im35466040lookup @ a @ b @ less @ t2 ) ) )).

% Branch.hyps(2)
thf(fact_245_entries_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% entries.simps(1)
thf(fact_246_local_Orbt__lookup__Empty,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( ^ [X2: a] :
            ( none @ B ) ) ) )).

% local.rbt_lookup_Empty
thf(fact_247_local_Orbt__lookup_Osimps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) @ K )
      = ( none @ B ) ) )).

% local.rbt_lookup.simps(1)
thf(fact_248_local_Orbt__lookup__rbt__greater,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
        = ( none @ B ) ) ) )).

% local.rbt_lookup_rbt_greater
thf(fact_249_local_Orbt__lookup__rbt__less,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
        = ( none @ B ) ) ) )).

% local.rbt_lookup_rbt_less
thf(fact_250_ord_Orbt__lookup__rbt__less,axiom,(
    ! [A: $tType,B: $tType,Less2: ( A > A > $o ),K: A,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less2 @ K @ T )
     => ( ( rBT_Im35466040lookup @ A @ B @ Less2 @ T @ K )
        = ( none @ B ) ) ) )).

% ord.rbt_lookup_rbt_less
thf(fact_251_ord_Orbt__lookup__rbt__greater,axiom,(
    ! [A: $tType,B: $tType,Less2: ( A > A > $o ),K: A,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less2 @ K @ T )
     => ( ( rBT_Im35466040lookup @ A @ B @ Less2 @ T @ K )
        = ( none @ B ) ) ) )).

% ord.rbt_lookup_rbt_greater
thf(fact_252_ord_Orbt__lookup_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,Less2: ( A > A > $o ),K: A] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less2 @ ( rBT_Im418718756_Empty @ A @ B ) @ K )
      = ( none @ B ) ) )).

% ord.rbt_lookup.simps(1)
thf(fact_253_ord_Orbt__lookup__Empty,axiom,(
    ! [B: $tType,A: $tType,Less2: ( A > A > $o )] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( ^ [X2: A] :
            ( none @ B ) ) ) )).

% ord.rbt_lookup_Empty
thf(fact_254_local_Orbt__lookup_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,Uu: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ Uu @ L @ X @ Y @ R ) @ K )
          = ( rBT_Im35466040lookup @ a @ B @ less @ L @ K ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ Uu @ L @ X @ Y @ R ) @ K )
              = ( rBT_Im35466040lookup @ a @ B @ less @ R @ K ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ Uu @ L @ X @ Y @ R ) @ K )
              = ( some @ B @ Y ) ) ) ) ) ) )).

% local.rbt_lookup.simps(2)

%----Type constructors (7)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_1,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_2,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_3,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_4,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ! [X3: a] :
      ( ( member @ a @ X3 @ ( set2 @ a @ ( rBT_Im380146495e_keys @ a @ b @ t2 ) ) )
     => ( less @ k @ X3 ) ) )).

%------------------------------------------------------------------------------
