%------------------------------------------------------------------------------
% File     : DAT234^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 740
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__740.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  319 (   0 unit;  57 type;   0 defn)
%            Number of atoms       : 6732 ( 232 equality;4388 variable)
%            Maximal formula depth :   36 (  13 average)
%            Number of connectives : 7045 (  95   ~;  13   |;  56   &;6606   @)
%                                         (   0 <=>; 275  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  341 ( 341   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   59 (  57   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1699 (   8 sgn;1599   !;  24   ?;  23   ^)
%                                         (1699   :;  53  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:42:42.561
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (48)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Oord_Olexordp,type,(
    lexordp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_Map_Omap__of,type,(
    map_of: 
      !>[A: $tType,B: $tType] :
        ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) )).

thf(sy_c_Option_Ooption_ONone,type,(
    none: 
      !>[A: $tType] :
        ( option @ A ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance,type,(
    rBT_Im1648453169alance: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__left,type,(
    rBT_Im1278323832e_left: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__right,type,(
    rBT_Im1053358987_right: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OB,type,(
    rBT_Impl_Mirabelle_B: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OR,type,(
    rBT_Impl_Mirabelle_R: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocombine,type,(
    rBT_Im1591839508ombine: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oentries,type,(
    rBT_Im954575269ntries: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Ois__rbt,type,(
    rBT_Im862805236is_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__greater,type,(
    rBT_Im1259024060reater: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__ins,type,(
    rBT_Im1756508336bt_ins: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert,type,(
    rBT_Im852463031insert: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with,type,(
    rBT_Im241132701t_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with__key,type,(
    rBT_Im627674146th_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__less,type,(
    rBT_Im2075124343t_less: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__lookup,type,(
    rBT_Im35466040lookup: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > A > ( option @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__sorted,type,(
    rBT_Im759614907sorted: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Opaint,type,(
    rBT_Im945281971_paint: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_a____,type,(
    a2: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_b____,type,(
    b2: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_c____,type,(
    c: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_d____,type,(
    d: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_k,type,(
    k: a )).

thf(sy_v_l,type,(
    l: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_r,type,(
    r: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_v____,type,(
    v: b )).

thf(sy_v_w____,type,(
    w: b )).

thf(sy_v_x____,type,(
    x: a )).

thf(sy_v_y____,type,(
    y: a )).

%----Relevant facts (255)
thf(fact_0_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_1_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_2_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_3_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_4_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_5_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_6_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_7_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_8_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_9_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_10_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_11_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_12_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_13_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_14_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_trans
thf(fact_15_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_16_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_17_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_18_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_19_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_20_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_21_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_22_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_23_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_24_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans
thf(fact_25_local_Orbt__greater__trans,axiom,(
    ! [C2: $tType,X: a,Y: a,T: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( less @ X @ Y )
     => ( ( rBT_Im1259024060reater @ a @ C2 @ less @ Y @ T )
       => ( rBT_Im1259024060reater @ a @ C2 @ less @ X @ T ) ) ) )).

% local.rbt_greater_trans
thf(fact_26__092_060open_062x_A_060_Ay_A_092_060and_062_Ay_A_092_060guillemotleft_062_124_Ad_092_060close_062,axiom,
    ( ( less @ x @ y )
    & ( rBT_Im1259024060reater @ a @ b @ less @ y @ d ) )).

% \<open>x < y \<and> y \<guillemotleft>| d\<close>
thf(fact_27_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_28_assms_I4_J,axiom,
    ( rBT_Im1259024060reater @ a @ b @ less @ k @ r )).

% assms(4)
thf(fact_29_combine__rbt__greater,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ L )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
       => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) )).

% combine_rbt_greater
thf(fact_30__092_060open_062x_A_092_060guillemotleft_062_124_Ac_092_060close_062,axiom,
    ( rBT_Im1259024060reater @ a @ b @ less @ x @ c )).

% \<open>x \<guillemotleft>| c\<close>
thf(fact_31_local_Obalance__right__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_greater
thf(fact_32_local_Obalance__left__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_greater
thf(fact_33_assms_I2_J,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ r )).

% assms(2)
thf(fact_34_assms_I1_J,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ l )).

% assms(1)
thf(fact_35__092_060open_062x_A_060_Ak_A_092_060and_062_Ak_A_092_060guillemotleft_062_124_Ac_092_060close_062,axiom,
    ( ( less @ x @ k )
    & ( rBT_Im1259024060reater @ a @ b @ less @ k @ c ) )).

% \<open>x < k \<and> k \<guillemotleft>| c\<close>
thf(fact_36_local_Orbt__less__trans,axiom,(
    ! [C2: $tType,X: a,T: ( rBT_Im246033960le_rbt @ a @ C2 ),Y: a] :
      ( ( rBT_Im2075124343t_less @ a @ C2 @ less @ X @ T )
     => ( ( less @ X @ Y )
       => ( rBT_Im2075124343t_less @ a @ C2 @ less @ Y @ T ) ) ) )).

% local.rbt_less_trans
thf(fact_37_local_Olexordp__eq__antisym,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
     => ( ( lexordp_eq @ a @ less @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% local.lexordp_eq_antisym
thf(fact_38_local_Olexordp__eq__linear,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
      | ( lexordp_eq @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_eq_linear
thf(fact_39_local_Olexordp__eq__refl,axiom,(
    ! [Xs: ( list @ a )] :
      ( lexordp_eq @ a @ less @ Xs @ Xs ) )).

% local.lexordp_eq_refl
thf(fact_40_local_Olexordp__eq__trans,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a ),Zs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
     => ( ( lexordp_eq @ a @ less @ Ys @ Zs )
       => ( lexordp_eq @ a @ less @ Xs @ Zs ) ) ) )).

% local.lexordp_eq_trans
thf(fact_41_assms_I3_J,axiom,
    ( rBT_Im2075124343t_less @ a @ b @ less @ k @ l )).

% assms(3)
thf(fact_42_combine__rbt__less,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ R )
       => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) )).

% combine_rbt_less
thf(fact_43_local_Obalance__left__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_less
thf(fact_44_local_Obalance__right__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_less
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_Obalance__left__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1278323832e_left @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_left_rbt_sorted
thf(fact_50_local_Obalance__right__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1053358987_right @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_right_rbt_sorted
thf(fact_51_local_Orbt__insertw__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_rbt_sorted
thf(fact_52_local_Orbt__insert__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_rbt_sorted
thf(fact_53_local_Orbt__insertwk__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_rbt_sorted
thf(fact_54_local_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) )).

% local.is_rbt_rbt_sorted
thf(fact_55__C2_C,axiom,
    ( rBT_Im1259024060reater @ a @ b @ less @ x @ ( rBT_Im1591839508ombine @ a @ b @ b2 @ c ) )).

% "2"
thf(fact_56__C3_C,axiom,
    ( rBT_Im2075124343t_less @ a @ b @ less @ y @ ( rBT_Im1591839508ombine @ a @ b @ b2 @ c ) )).

% "3"
thf(fact_57__092_060open_062k_A_060_Ay_A_092_060and_062_Ab_A_124_092_060guillemotleft_062_Ak_092_060close_062,axiom,
    ( ( less @ k @ y )
    & ( rBT_Im2075124343t_less @ a @ b @ less @ k @ b2 ) )).

% \<open>k < y \<and> b |\<guillemotleft> k\<close>
thf(fact_58__092_060open_062b_A_124_092_060guillemotleft_062_Ay_092_060close_062,axiom,
    ( rBT_Im2075124343t_less @ a @ b @ less @ y @ b2 )).

% \<open>b |\<guillemotleft> y\<close>
thf(fact_59_local_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),C: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) ) ) )).

% local.paint_rbt_sorted
thf(fact_60_local_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ C @ L @ K @ V @ R ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
        & ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
        & ( rBT_Im759614907sorted @ a @ B @ less @ L )
        & ( rBT_Im759614907sorted @ a @ B @ less @ R ) ) ) )).

% local.rbt_sorted.simps(2)
thf(fact_61_local_Obalance__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_rbt_sorted
thf(fact_62_local_Orbt__insertwk__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_is_rbt
thf(fact_63_local_Orbt__insert__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_is_rbt
thf(fact_64_local_Orbt__insertw__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_is_rbt
thf(fact_65_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 )
        & ( X24 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_66_local_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,K: a,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C2 ),Kt: a,V: C2,Rt: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ ( rBT_Im480247531Branch @ a @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ K @ Kt )
        & ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ Lt )
        & ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ Rt ) ) ) )).

% local.rbt_greater_simps(2)
thf(fact_67_local_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,K: a,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C2 ),Kt: a,V: C2,Rt: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ ( rBT_Im480247531Branch @ a @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ Rt ) ) ) )).

% local.rbt_less_simps(2)
thf(fact_68_local_Obalance__rbt__greater,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ A2 )
        & ( rBT_Im1259024060reater @ a @ B @ less @ V @ B2 )
        & ( less @ V @ K ) ) ) )).

% local.balance_rbt_greater
thf(fact_69_local_Obalance__rbt__less,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ a @ B @ less @ V @ B2 )
        & ( less @ K @ V ) ) ) )).

% local.balance_rbt_less
thf(fact_70_local_Opaint__rbt__greater,axiom,(
    ! [B: $tType,V: a,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) )
      = ( rBT_Im1259024060reater @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_greater
thf(fact_71_local_Opaint__rbt__less,axiom,(
    ! [B: $tType,V: a,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) )
      = ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_less
thf(fact_72_Empty,axiom,
    ( ( rBT_Im1591839508ombine @ a @ b @ b2 @ c )
    = ( rBT_Im418718756_Empty @ a @ b ) )).

% Empty
thf(fact_73_paint_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C: rBT_Im1923302023_color,Uu: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im945281971_paint @ A @ B @ C @ ( rBT_Im480247531Branch @ A @ B @ Uu @ L @ K @ V @ R ) )
      = ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V @ R ) ) )).

% paint.simps(2)
thf(fact_74_ord_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType,Less: ( A > A > $o ),K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
      ( ( rBT_Im1259024060reater @ A @ C2 @ Less @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ K @ Kt )
        & ( rBT_Im1259024060reater @ A @ C2 @ Less @ K @ Lt )
        & ( rBT_Im1259024060reater @ A @ C2 @ Less @ K @ Rt ) ) ) )).

% ord.rbt_greater_simps(2)
thf(fact_75_ord_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType,Less: ( A > A > $o ),K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
      ( ( rBT_Im2075124343t_less @ A @ C2 @ Less @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ A @ C2 @ Less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ A @ C2 @ Less @ K @ Rt ) ) ) )).

% ord.rbt_less_simps(2)
thf(fact_76_ord_Obalance__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ V @ B2 )
        & ( Less @ V @ K ) ) ) )).

% ord.balance_rbt_greater
thf(fact_77_ord_Obalance__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ B2 )
        & ( Less @ K @ V ) ) ) )).

% ord.balance_rbt_less
thf(fact_78_ord_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B ),C: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) ) ) )).

% ord.paint_rbt_sorted
thf(fact_79_ord_Opaint__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) )
      = ( rBT_Im1259024060reater @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_greater
thf(fact_80_ord_Opaint__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) )
      = ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_less
thf(fact_81_ord_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V @ R ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ L )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ K @ R )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ L )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ R ) ) ) )).

% ord.rbt_sorted.simps(2)
thf(fact_82_ord_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ T ) ) )).

% ord.is_rbt_rbt_sorted
thf(fact_83__C4_Ohyps_C,axiom,
    ( ( rBT_Im759614907sorted @ a @ b @ less @ b2 )
   => ( ( rBT_Im759614907sorted @ a @ b @ less @ c )
     => ( ( rBT_Im2075124343t_less @ a @ b @ less @ k @ b2 )
       => ( ( rBT_Im1259024060reater @ a @ b @ less @ k @ c )
         => ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im1591839508ombine @ a @ b @ b2 @ c ) ) ) ) ) )).

% "4.hyps"
thf(fact_84_local_Oins__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.ins_rbt_sorted
thf(fact_85_local_Ostrict__monoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( less @ X @ Y )
           => ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.strict_monoD
thf(fact_86_local_Ostrict__monoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y2: a] :
              ( ( less @ X3 @ Y2 )
             => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( strict_mono @ a @ B @ less @ F ) ) ) )).

% local.strict_monoI
thf(fact_87_local_Ostrict__mono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( strict_mono @ a @ B @ less @ F )
          = ( ! [X2: a,Y3: a] :
                ( ( less @ X2 @ Y3 )
               => ( ord_less @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) ) ) )).

% local.strict_mono_def
thf(fact_88_local_Ostrict__mono__less,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( less @ X @ Y ) ) ) ) )).

% local.strict_mono_less
thf(fact_89_local_Olexordp__eq_ONil,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq.Nil
thf(fact_90_local_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType] :
      ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_sorted.simps(1)
thf(fact_91_local_OEmpty__is__rbt,axiom,(
    ! [B: $tType] :
      ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.Empty_is_rbt
thf(fact_92_local_Orbt__insert__def,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im852463031insert @ a @ B @ less )
      = ( rBT_Im627674146th_key @ a @ B @ less
        @ ^ [Uu2: a,Uv: B,Nv: B] : Nv ) ) )).

% local.rbt_insert_def
thf(fact_93_local_Orbt__insertw__def,axiom,(
    ! [B: $tType,F: ( B > B > B )] :
      ( ( rBT_Im241132701t_with @ a @ B @ less @ F )
      = ( rBT_Im627674146th_key @ a @ B @ less
        @ ^ [Uu2: a] : F ) ) )).

% local.rbt_insertw_def
thf(fact_94_local_Olexordp__eq__simps_I1_J,axiom,(
    ! [Ys: ( list @ a )] :
      ( lexordp_eq @ a @ less @ ( nil @ a ) @ Ys ) )).

% local.lexordp_eq_simps(1)
thf(fact_95_local_Olexordp__eq__simps_I2_J,axiom,(
    ! [Xs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ ( nil @ a ) )
      = ( Xs
        = ( nil @ a ) ) ) )).

% local.lexordp_eq_simps(2)
thf(fact_96_local_Oins__rbt__greater,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ T )
        & ( less @ V @ K ) ) ) )).

% local.ins_rbt_greater
thf(fact_97_local_Oins__rbt__less,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T )
        & ( less @ K @ V ) ) ) )).

% local.ins_rbt_less
thf(fact_98_local_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_greater_simps(1)
thf(fact_99_local_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_less_simps(1)
thf(fact_100_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_101_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X1: rBT_Im1923302023_color,X26: ( rBT_Im246033960le_rbt @ A @ B ),X32: A,X4: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X26 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X1 @ X26 @ X32 @ X4 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_102_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X232 @ X242 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_103_ord_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_sorted.simps(1)
thf(fact_104_ord_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im1259024060reater @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_greater_simps(1)
thf(fact_105_ord_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_less_simps(1)
thf(fact_106_ord_Orbt__insert__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im852463031insert @ A @ B )
      = ( ^ [Less2: ( A > A > $o )] :
            ( rBT_Im627674146th_key @ A @ B @ Less2
            @ ^ [Uu2: A,Uv: B,Nv: B] : Nv ) ) ) )).

% ord.rbt_insert_def
thf(fact_107_ord_Orbt__insertw__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im241132701t_with @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( B > B > B )] :
            ( rBT_Im627674146th_key @ A @ B @ Less2
            @ ^ [Uu2: A] : F2 ) ) ) )).

% ord.rbt_insertw_def
thf(fact_108_paint_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,C: rBT_Im1923302023_color] :
      ( ( rBT_Im945281971_paint @ A @ B @ C @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% paint.simps(1)
thf(fact_109_balance__left_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(6)
thf(fact_110_combine_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ X )
      = X ) )).

% combine.simps(1)
thf(fact_111_balance__right_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(6)
thf(fact_112_ord_OEmpty__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.Empty_is_rbt
thf(fact_113_combine_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) ) )).

% combine.simps(2)
thf(fact_114__C4_Oprems_C_I4_J,axiom,
    ( rBT_Im1259024060reater @ a @ b @ less @ k @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_B @ c @ y @ w @ d ) )).

% "4.prems"(4)
thf(fact_115__C4_Oprems_C_I2_J,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_B @ c @ y @ w @ d ) )).

% "4.prems"(2)
thf(fact_116_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_117_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_118_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_119__C4_Oprems_C_I3_J,axiom,
    ( rBT_Im2075124343t_less @ a @ b @ less @ k @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_B @ a2 @ x @ v @ b2 ) )).

% "4.prems"(3)
thf(fact_120_local_Orbt__ins_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
          = ( rBT_Im1648453169alance @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im1648453169alance @ a @ B @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% local.rbt_ins.simps(2)
thf(fact_121_local_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ V @ T )
      = ( rBT_Im945281971_paint @ a @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insert_with_key_def
thf(fact_122__C4_Oprems_C_I1_J,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_B @ a2 @ x @ v @ b2 ) )).

% "4.prems"(1)
thf(fact_123_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_124_balance_Osimps_I23_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) ) )).

% balance.simps(23)
thf(fact_125_balance_Osimps_I27_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(27)
thf(fact_126_balance_Osimps_I29_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(29)
thf(fact_127_balance_Osimps_I39_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(39)
thf(fact_128_balance_Osimps_I43_J,axiom,(
    ! [B: $tType,A: $tType,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(43)
thf(fact_129_balance_Osimps_I45_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(45)
thf(fact_130_balance_Osimps_I14_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(14)
thf(fact_131_balance_Osimps_I15_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(15)
thf(fact_132_balance_Osimps_I16_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(16)
thf(fact_133_balance_Osimps_I17_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(17)
thf(fact_134_balance_Osimps_I18_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(18)
thf(fact_135_balance_Osimps_I19_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(19)
thf(fact_136_balance_Osimps_I20_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(20)
thf(fact_137_balance_Osimps_I21_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(21)
thf(fact_138_balance_Osimps_I22_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(22)
thf(fact_139_balance_Osimps_I24_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(24)
thf(fact_140_balance_Osimps_I25_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(25)
thf(fact_141_balance_Osimps_I26_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(26)
thf(fact_142_balance_Osimps_I28_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(28)
thf(fact_143_balance_Osimps_I32_J,axiom,(
    ! [B: $tType,A: $tType,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(32)
thf(fact_144_balance_Osimps_I33_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vb: A,Vc: B,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(33)
thf(fact_145_balance_Osimps_I34_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(34)
thf(fact_146_balance_Osimps_I35_J,axiom,(
    ! [B: $tType,A: $tType,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(35)
thf(fact_147_balance_Osimps_I36_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(36)
thf(fact_148_balance_Osimps_I37_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(37)
thf(fact_149_balance_Osimps_I40_J,axiom,(
    ! [B: $tType,A: $tType,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(40)
thf(fact_150_balance_Osimps_I41_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: A,Vg: B,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(41)
thf(fact_151_balance_Osimps_I42_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(42)
thf(fact_152_balance_Osimps_I44_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(44)
thf(fact_153_balance__left_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(9)
thf(fact_154_balance__right_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(9)
thf(fact_155_ord_Orbt__ins_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( A > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
          = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im1648453169alance @ A @ B @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% ord.rbt_ins.simps(2)
thf(fact_156_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_157_ord_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im627674146th_key @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( A > B > B > B ),K2: A,V2: B,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less2 @ F2 @ K2 @ V2 @ T2 ) ) ) ) )).

% ord.rbt_insert_with_key_def
thf(fact_158_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_159_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X2: a] :
            ( less @ X2 @ U ) ) ) )).

% local.lessThan_def
thf(fact_160_local_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B] :
      ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ a @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) ) ) )).

% local.rbt_ins.simps(1)
thf(fact_161_local_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,P: ( ( a > B > B > B ) > a > B > ( rBT_Im246033960le_rbt @ a @ B ) > $o ),A0: ( a > B > B > B ),A1: a,A22: B,A32: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ! [F3: ( a > B > B > B ),K3: a,V3: B] :
          ( P @ F3 @ K3 @ V3 @ ( rBT_Im418718756_Empty @ a @ B ) )
     => ( ! [F3: ( a > B > B > B ),K3: a,V3: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
            ( ( ( less @ K3 @ X3 )
             => ( P @ F3 @ K3 @ V3 @ L2 ) )
           => ( ( ~ ( less @ K3 @ X3 )
               => ( ( less @ X3 @ K3 )
                 => ( P @ F3 @ K3 @ V3 @ R2 ) ) )
             => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
       => ( ! [F3: ( a > B > B > B ),K3: a,V3: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
              ( ( ( less @ K3 @ X3 )
               => ( P @ F3 @ K3 @ V3 @ L2 ) )
             => ( ( ~ ( less @ K3 @ X3 )
                 => ( ( less @ X3 @ K3 )
                   => ( P @ F3 @ K3 @ V3 @ R2 ) ) )
               => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% local.rbt_ins.induct
thf(fact_162_local_Orbt__lookup__balance,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,X: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R ) @ X )
              = ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ K @ V @ R ) @ X ) ) ) ) ) ) )).

% local.rbt_lookup_balance
thf(fact_163_local_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
          = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% local.rbt_ins.simps(3)
thf(fact_164_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_165_local_Opaint__rbt__lookup,axiom,(
    ! [B: $tType,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) )
      = ( rBT_Im35466040lookup @ a @ B @ less @ T ) ) )).

% local.paint_rbt_lookup
thf(fact_166_color_Oexhaust,axiom,(
    ! [Y: rBT_Im1923302023_color] :
      ( ( Y != rBT_Impl_Mirabelle_R )
     => ( Y = rBT_Impl_Mirabelle_B ) ) )).

% color.exhaust
thf(fact_167_color_Oinduct,axiom,(
    ! [P: ( rBT_Im1923302023_color > $o ),Color: rBT_Im1923302023_color] :
      ( ( P @ rBT_Impl_Mirabelle_R )
     => ( ( P @ rBT_Impl_Mirabelle_B )
       => ( P @ Color ) ) ) )).

% color.induct
thf(fact_168_color_Odistinct_I1_J,axiom,(
    rBT_Impl_Mirabelle_R != rBT_Impl_Mirabelle_B )).

% color.distinct(1)
thf(fact_169_ord_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( A > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
          = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% ord.rbt_ins.simps(3)
thf(fact_170_ord_Opaint__rbt__lookup,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) )
      = ( rBT_Im35466040lookup @ A @ B @ Less @ T ) ) )).

% ord.paint_rbt_lookup
thf(fact_171_rbt__cases,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( T
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,V3: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( T
           != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ K3 @ V3 @ R2 ) )
       => ~ ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,V3: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( T
               != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ K3 @ V3 @ R2 ) ) ) ) ) )).

% rbt_cases
thf(fact_172_combine_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( rBT_Im246033960le_rbt @ A @ B ),A1: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [X1: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( P @ ( rBT_Im418718756_Empty @ A @ B ) @ X1 )
     => ( ! [V3: rBT_Im1923302023_color,Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( P @ ( rBT_Im480247531Branch @ A @ B @ V3 @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im418718756_Empty @ A @ B ) )
       => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y2: B,D: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( P @ B3 @ C3 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K3 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C3 @ S2 @ Y2 @ D ) ) )
         => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y2: B,D: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( P @ B3 @ C3 )
               => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A4 @ K3 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C3 @ S2 @ Y2 @ D ) ) )
           => ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B ),B3: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,C3: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ B3 )
                 => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B3 @ K3 @ X3 @ C3 ) ) )
             => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
                    ( ( P @ B3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) )
                   => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K3 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) ) )
               => ( P @ A0 @ A1 ) ) ) ) ) ) ) )).

% combine.induct
thf(fact_173_ord_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Less: ( A > A > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [F3: ( A > B > B > B ),K3: A,V3: B] :
          ( P @ F3 @ K3 @ V3 @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( ( Less @ K3 @ X3 )
             => ( P @ F3 @ K3 @ V3 @ L2 ) )
           => ( ( ~ ( Less @ K3 @ X3 )
               => ( ( Less @ X3 @ K3 )
                 => ( P @ F3 @ K3 @ V3 @ R2 ) ) )
             => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
       => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( ( Less @ K3 @ X3 )
               => ( P @ F3 @ K3 @ V3 @ L2 ) )
             => ( ( ~ ( Less @ K3 @ X3 )
                 => ( ( Less @ X3 @ K3 )
                   => ( P @ F3 @ K3 @ V3 @ R2 ) ) )
               => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% ord.rbt_ins.induct
thf(fact_174_balance_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C @ Y @ Z @ D2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ D2 ) ) ) )).

% balance.simps(1)
thf(fact_175_balance_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ W @ X @ B2 ) @ S @ T @ C ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(3)
thf(fact_176_balance_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(7)
thf(fact_177_balance_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C @ Y @ Z @ D2 ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ D2 ) ) ) )).

% balance.simps(9)
thf(fact_178_balance_Osimps_I13_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) ) ) )).

% balance.simps(13)
thf(fact_179_balance__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ C )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ C ) ) )).

% balance_left.simps(1)
thf(fact_180_ord_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,V: B] :
      ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord.rbt_ins.simps(1)
thf(fact_181_balance__left_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(7)
thf(fact_182_balance__left_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(8)
thf(fact_183_balance__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ Y @ C ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C ) ) ) )).

% balance_right.simps(1)
thf(fact_184_combine_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ K @ X @ C ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ B2 ) @ K @ X @ C ) ) )).

% combine.simps(5)
thf(fact_185_combine_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im1591839508ombine @ A @ B @ B2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% combine.simps(6)
thf(fact_186_balance__right_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(7)
thf(fact_187_balance__right_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(8)
thf(fact_188_ord__class_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( ! [F3: ( A > B > B > B ),K3: A,V3: B] :
              ( P @ F3 @ K3 @ V3 @ ( rBT_Im418718756_Empty @ A @ B ) )
         => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( ( ord_less @ A @ K3 @ X3 )
                 => ( P @ F3 @ K3 @ V3 @ L2 ) )
               => ( ( ~ ( ord_less @ A @ K3 @ X3 )
                   => ( ( ord_less @ A @ X3 @ K3 )
                     => ( P @ F3 @ K3 @ V3 @ R2 ) ) )
                 => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
           => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( ( ord_less @ A @ K3 @ X3 )
                   => ( P @ F3 @ K3 @ V3 @ L2 ) )
                 => ( ( ~ ( ord_less @ A @ K3 @ X3 )
                     => ( ( ord_less @ A @ X3 @ K3 )
                       => ( P @ F3 @ K3 @ V3 @ R2 ) ) )
                   => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
             => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) ) )).

% ord_class.rbt_ins.induct
thf(fact_189_balance_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ W @ X @ B2 ) @ S @ T @ C ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(2)
thf(fact_190_balance_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(4)
thf(fact_191_balance_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(5)
thf(fact_192_balance_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(6)
thf(fact_193_balance_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C @ Y @ Z @ D2 ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ D2 ) ) ) )).

% balance.simps(8)
thf(fact_194_balance_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(10)
thf(fact_195_balance_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(11)
thf(fact_196_balance_Osimps_I12_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(12)
thf(fact_197_balance__left_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(11)
thf(fact_198_balance__left_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(10)
thf(fact_199_balance__right_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(11)
thf(fact_200_balance__right_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(10)
thf(fact_201_balance__left_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ S @ Y @ B2 ) ) ) )).

% balance_left.simps(3)
thf(fact_202_balance__right_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance_right.simps(3)
thf(fact_203_balance__left_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ S @ Y @ B2 ) ) ) )).

% balance_left.simps(2)
thf(fact_204_balance__right_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance_right.simps(2)
thf(fact_205_balance__left_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) @ T @ Z @ C ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ A2 ) @ S @ Y @ ( rBT_Im1648453169alance @ A @ B @ B2 @ T @ Z @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ C ) ) ) ) )).

% balance_left.simps(5)
thf(fact_206_balance__right_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C ) ) @ T @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ A2 ) @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ T @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance_right.simps(5)
thf(fact_207_balance__left_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) @ T @ Z @ C ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ A2 ) @ S @ Y @ ( rBT_Im1648453169alance @ A @ B @ B2 @ T @ Z @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ C ) ) ) ) )).

% balance_left.simps(4)
thf(fact_208_balance__right_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C ) ) @ T @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ A2 ) @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C @ T @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance_right.simps(4)
thf(fact_209_local_Oentries__rbt__lookup,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T22: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T22 )
       => ( ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T22 ) )
          = ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T22 ) ) ) ) ) )).

% local.entries_rbt_lookup
thf(fact_210_local_Oentries__eqI,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T22: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T22 )
       => ( ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T22 ) )
         => ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T22 ) ) ) ) ) )).

% local.entries_eqI
thf(fact_211_local_Orbt__lookup_Osimps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) @ K )
      = ( none @ B ) ) )).

% local.rbt_lookup.simps(1)
thf(fact_212_local_Orbt__lookup__Empty,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( ^ [X2: a] :
            ( none @ B ) ) ) )).

% local.rbt_lookup_Empty
thf(fact_213_local_Orbt__lookup__rbt__greater,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
        = ( none @ B ) ) ) )).

% local.rbt_lookup_rbt_greater
thf(fact_214_local_Orbt__lookup__rbt__less,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
        = ( none @ B ) ) ) )).

% local.rbt_lookup_rbt_less
thf(fact_215_entries_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% entries.simps(1)
thf(fact_216_ord_Orbt__lookup__Empty,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( ^ [X2: A] :
            ( none @ B ) ) ) )).

% ord.rbt_lookup_Empty
thf(fact_217_ord_Orbt__lookup_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) @ K )
      = ( none @ B ) ) )).

% ord.rbt_lookup.simps(1)
thf(fact_218_ord_Orbt__lookup__rbt__greater,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ K @ T )
     => ( ( rBT_Im35466040lookup @ A @ B @ Less @ T @ K )
        = ( none @ B ) ) ) )).

% ord.rbt_lookup_rbt_greater
thf(fact_219_ord_Orbt__lookup__rbt__less,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ T )
     => ( ( rBT_Im35466040lookup @ A @ B @ Less @ T @ K )
        = ( none @ B ) ) ) )).

% ord.rbt_lookup_rbt_less
thf(fact_220_local_Omap__of__entries,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( ( map_of @ a @ B @ ( rBT_Im954575269ntries @ a @ B @ T ) )
        = ( rBT_Im35466040lookup @ a @ B @ less @ T ) ) ) )).

% local.map_of_entries
thf(fact_221_local_Olexordp__eq_Ocases,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ a ) )
         => ! [Ys2: ( list @ a )] : ( A22 != Ys2 ) )
       => ( ! [X3: a] :
              ( ? [Xs2: ( list @ a )] :
                  ( A1
                  = ( cons @ a @ X3 @ Xs2 ) )
             => ! [Y2: a] :
                  ( ? [Ys2: ( list @ a )] :
                      ( A22
                      = ( cons @ a @ Y2 @ Ys2 ) )
                 => ~ ( less @ X3 @ Y2 ) ) )
         => ~ ( ! [X3: a,Y2: a,Xs2: ( list @ a )] :
                  ( ( A1
                    = ( cons @ a @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ a )] :
                      ( ( A22
                        = ( cons @ a @ Y2 @ Ys2 ) )
                     => ( ~ ( less @ X3 @ Y2 )
                       => ( ~ ( less @ Y2 @ X3 )
                         => ~ ( lexordp_eq @ a @ less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% local.lexordp_eq.cases
thf(fact_222_local_Olexordp__eq_OCons__eq,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ~ ( less @ X @ Y )
     => ( ~ ( less @ Y @ X )
       => ( ( lexordp_eq @ a @ less @ Xs @ Ys )
         => ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) ) ) )).

% local.lexordp_eq.Cons_eq
thf(fact_223_local_Olexordp__eq_OCons,axiom,(
    ! [X: a,Y: a,Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( less @ X @ Y )
     => ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) ) ) )).

% local.lexordp_eq.Cons
thf(fact_224_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_225_local_Olexordp__eq_Osimps,axiom,(
    ! [A1: ( list @ a ),A22: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ A1 @ A22 )
      = ( ? [Ys3: ( list @ a )] :
            ( ( A1
              = ( nil @ a ) )
            & ( A22 = Ys3 ) )
        | ? [X2: a,Y3: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X2 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) )
            & ( less @ X2 @ Y3 ) )
        | ? [X2: a,Y3: a,Xs3: ( list @ a ),Ys3: ( list @ a )] :
            ( ( A1
              = ( cons @ a @ X2 @ Xs3 ) )
            & ( A22
              = ( cons @ a @ Y3 @ Ys3 ) )
            & ~ ( less @ X2 @ Y3 )
            & ~ ( less @ Y3 @ X2 )
            & ( lexordp_eq @ a @ less @ Xs3 @ Ys3 ) ) ) ) )).

% local.lexordp_eq.simps
thf(fact_226_local_Olexordp__eq_Oinducts,axiom,(
    ! [X12: ( list @ a ),X27: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp_eq @ a @ less @ X12 @ X27 )
     => ( ! [X1: ( list @ a )] :
            ( P @ ( nil @ a ) @ X1 )
       => ( ! [X3: a,Y2: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
              ( ( less @ X3 @ Y2 )
             => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) )
         => ( ! [X3: a,Y2: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ~ ( less @ X3 @ Y2 )
               => ( ~ ( less @ Y2 @ X3 )
                 => ( ( lexordp_eq @ a @ less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X12 @ X27 ) ) ) ) ) )).

% local.lexordp_eq.inducts
thf(fact_227_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_228_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_229_local_Olexordp__eq__simps_I4_J,axiom,(
    ! [X: a,Xs: ( list @ a ),Y: a,Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( cons @ a @ Y @ Ys ) )
      = ( ( less @ X @ Y )
        | ( ~ ( less @ Y @ X )
          & ( lexordp_eq @ a @ less @ Xs @ Ys ) ) ) ) )).

% local.lexordp_eq_simps(4)
thf(fact_230_local_Olexordp__eq__simps_I3_J,axiom,(
    ! [X: a,Xs: ( list @ a )] :
      ~ ( lexordp_eq @ a @ less @ ( cons @ a @ X @ Xs ) @ ( nil @ a ) ) )).

% local.lexordp_eq_simps(3)
thf(fact_231_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys2: ( list @ A )] : ( A22 != Ys2 ) )
       => ( ! [X3: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X3 @ Xs2 ) )
             => ! [Y2: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y2 @ Ys2 ) )
                 => ~ ( Less @ X3 @ Y2 ) ) )
         => ~ ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( ~ ( Less @ X3 @ Y2 )
                       => ( ~ ( Less @ Y2 @ X3 )
                         => ~ ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_232_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys3 ) )
            | ? [X2: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ( Less2 @ X2 @ Y3 ) )
            | ? [X2: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ~ ( Less2 @ X2 @ Y3 )
                & ~ ( Less2 @ Y3 @ X2 )
                & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_233_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X12: ( list @ A ),X27: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X12 @ X27 )
     => ( ! [X1: ( list @ A )] :
            ( P @ ( nil @ A ) @ X1 )
       => ( ! [X3: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less @ X3 @ Y2 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( ! [X3: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less @ X3 @ Y2 )
               => ( ~ ( Less @ Y2 @ X3 )
                 => ( ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X12 @ X27 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_234_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_235_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_236_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_237_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X1: A,X26: ( list @ A )] :
            ( ( P @ X26 )
           => ( P @ ( cons @ A @ X1 @ X26 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_238_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_239_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: ( list @ A )] :
            ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys2: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys2 ) )
         => ( ! [X3: A,Xs2: ( list @ A ),Y2: B,Ys2: ( list @ B )] :
                ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_240_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X1: ( list @ A )] :
          ( P @ ( nil @ A ) @ X1 )
     => ( ! [V3: A,Va2: ( list @ A )] :
            ( P @ ( cons @ A @ V3 @ Va2 ) @ ( nil @ A ) )
       => ( ! [X3: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
              ( ( P @ Xs2 @ Ys2 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_241_transpose_Ocases,axiom,(
    ! [A: $tType,X: ( list @ ( list @ A ) )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X3: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X
               != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_242_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X: ( list @ A )] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
                ( X
               != ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_243_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Y2: A,Xs2: ( list @ A )] :
              ( ( ( X3 = Y2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) )
             => ( ( ( X3 != Y2 )
                 => ( P @ ( cons @ A @ Y2 @ Xs2 ) ) )
               => ( P @ ( cons @ A @ X3 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_244_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_245_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F3: ( A > B ),X1: ( list @ B )] :
          ( P @ F3 @ ( nil @ A ) @ X1 )
     => ( ! [F3: ( A > B ),A4: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F3 @ As @ ( cons @ B @ ( F3 @ A4 ) @ Bs ) )
           => ( P @ F3 @ ( cons @ A @ A4 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_246_not__Cons__self2,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_247_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_248_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_249_local_Oset__entries__inject,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T22: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T22 )
       => ( ( ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T1 ) )
            = ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T22 ) ) )
          = ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T22 ) ) ) ) ) )).

% local.set_entries_inject
thf(fact_250_local_Olexordp__induct,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a ),P: ( ( list @ a ) > ( list @ a ) > $o )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ( ! [Y2: a,Ys2: ( list @ a )] :
            ( P @ ( nil @ a ) @ ( cons @ a @ Y2 @ Ys2 ) )
       => ( ! [X3: a,Xs2: ( list @ a ),Y2: a,Ys2: ( list @ a )] :
              ( ( less @ X3 @ Y2 )
             => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ Y2 @ Ys2 ) ) )
         => ( ! [X3: a,Xs2: ( list @ a ),Ys2: ( list @ a )] :
                ( ( lexordp @ a @ less @ Xs2 @ Ys2 )
               => ( ( P @ Xs2 @ Ys2 )
                 => ( P @ ( cons @ a @ X3 @ Xs2 ) @ ( cons @ a @ X3 @ Ys2 ) ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% local.lexordp_induct
thf(fact_251_local_Olexordp__antisym,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
     => ~ ( lexordp @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_antisym
thf(fact_252_local_Olexordp__irreflexive,axiom,(
    ! [Xs: ( list @ a )] :
      ( ! [X3: a] :
          ~ ( less @ X3 @ X3 )
     => ~ ( lexordp @ a @ less @ Xs @ Xs ) ) )).

% local.lexordp_irreflexive
thf(fact_253_local_Olexordp__irreflexive_H,axiom,(
    ! [Xs: ( list @ a )] :
      ~ ( lexordp @ a @ less @ Xs @ Xs ) )).

% local.lexordp_irreflexive'
thf(fact_254_local_Olexordp__linear,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp @ a @ less @ Xs @ Ys )
      | ( Xs = Ys )
      | ( lexordp @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_linear

%----Type constructors (6)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( order @ A6 @ ( type2 @ A6 ) )
     => ( order @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( ord @ A6 @ ( type2 @ A6 ) )
     => ( ord @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_1,axiom,(
    ! [A5: $tType] :
      ( order @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_2,axiom,(
    ! [A5: $tType] :
      ( ord @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_3,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_4,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( rBT_Im1259024060reater @ a @ b @ less @ x @ d )).

%------------------------------------------------------------------------------
