%------------------------------------------------------------------------------
% File     : DAT245^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Infinite streams (sequences/lists) 108
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream__108.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  341 (   0 unit;  50 type;   0 defn)
%            Number of atoms       : 4325 ( 258 equality;2571 variable)
%            Maximal formula depth :   19 (   9 average)
%            Number of connectives : 3890 (  79   ~;   9   |;  56   &;3424   @)
%                                         (   0 <=>; 322  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  187 ( 187   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   54 (  50   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1030 (   2 sgn; 914   !;  18   ?;  51   ^)
%                                         (1030   :;  47  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:40:45.745
%------------------------------------------------------------------------------
%----Could-be-implicit typings (4)
thf(ty_t_Stream__Mirabelle__hbrgyiwlrc_Ostream,type,(
    stream170649215stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (46)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ouminus,type,(
    uminus: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__bot,type,(
    no_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Ono__top,type,(
    no_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Opreorder,type,(
    preorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder__bot,type,(
    order_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Oboolean__algebra,type,(
    boolean_algebra: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__inf,type,(
    semilattice_inf: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__group__add,type,(
    ordered_ab_group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,(
    bounded_lattice_bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Groups_Ominus__class_Ominus,type,(
    minus_minus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,(
    uminus_uminus: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Oinf__class_Oinf,type,(
    inf_inf: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,(
    order_antimono: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Relation_Oinv__imagep,type,(
    inv_imagep: 
      !>[B: $tType,A: $tType] :
        ( ( B > B > $o ) > ( A > B ) > A > A > $o ) )).

thf(sy_c_Set_OBall,type,(
    ball: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Oremove,type,(
    remove: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osmember,type,(
    stream1586597341member: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_OSCons,type,(
    stream641971652_SCons: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocase__stream,type,(
    stream1342653232stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream170649215stream @ A ) > B ) > ( stream170649215stream @ A ) > B ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocorec__stream,type,(
    stream660621732stream: 
      !>[C: $tType,A: $tType] :
        ( ( C > A ) > ( C > $o ) > ( C > ( stream170649215stream @ A ) ) > ( C > C ) > C > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Opred__stream,type,(
    stream1153105665stream: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osset,type,(
    stream30925839e_sset: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostreams,type,(
    stream2015131171treams: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( stream170649215stream @ A ) ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostreamsp,type,(
    stream86250253reamsp: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_A,type,(
    a2: ( set @ a ) )).

thf(sy_v_s,type,(
    s: ( stream170649215stream @ a ) )).

thf(sy_v_sa____,type,(
    sa: ( stream170649215stream @ a ) )).

%----Relevant facts (256)
thf(fact_0_streams,axiom,
    ( ord_less_eq @ ( set @ a ) @ ( stream30925839e_sset @ a @ sa ) @ a2 )).

% streams
thf(fact_1_assms,axiom,
    ( ord_less_eq @ ( set @ a ) @ ( stream30925839e_sset @ a @ s ) @ a2 )).

% assms
thf(fact_2_stream_Oinject,axiom,(
    ! [A: $tType,X1: A,X2: ( stream170649215stream @ A ),Y1: A,Y2: ( stream170649215stream @ A )] :
      ( ( ( stream641971652_SCons @ A @ X1 @ X2 )
        = ( stream641971652_SCons @ A @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% stream.inject
thf(fact_3_stream_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X: A,A2: ( stream170649215stream @ A ),A1: A] :
      ( ( member @ A @ X @ ( stream30925839e_sset @ A @ A2 ) )
     => ( member @ A @ X @ ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ A1 @ A2 ) ) ) ) )).

% stream.set_intros(2)
thf(fact_4_stream_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A2: ( stream170649215stream @ A )] :
      ( member @ A @ A1 @ ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ A1 @ A2 ) ) ) )).

% stream.set_intros(1)
thf(fact_5_streams_Ocases,axiom,(
    ! [A: $tType,A3: ( stream170649215stream @ A ),A4: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ A3 @ ( stream2015131171treams @ A @ A4 ) )
     => ~ ( ! [A5: A,S: ( stream170649215stream @ A )] :
              ( ( A3
                = ( stream641971652_SCons @ A @ A5 @ S ) )
             => ( ( member @ A @ A5 @ A4 )
               => ~ ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A4 ) ) ) ) ) ) )).

% streams.cases
thf(fact_6_streams_Osimps,axiom,(
    ! [A: $tType,A3: ( stream170649215stream @ A ),A4: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ A3 @ ( stream2015131171treams @ A @ A4 ) )
      = ( ? [A6: A,S2: ( stream170649215stream @ A )] :
            ( ( A3
              = ( stream641971652_SCons @ A @ A6 @ S2 ) )
            & ( member @ A @ A6 @ A4 )
            & ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ A4 ) ) ) ) ) )).

% streams.simps
thf(fact_7_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream170649215stream @ A )] :
      ~ ( ! [X12: A,X22: ( stream170649215stream @ A )] :
            ( Y
           != ( stream641971652_SCons @ A @ X12 @ X22 ) ) ) )).

% stream.exhaust
thf(fact_8_streams__Stream,axiom,(
    ! [A: $tType,X: A,S3: ( stream170649215stream @ A ),A4: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ ( stream641971652_SCons @ A @ X @ S3 ) @ ( stream2015131171treams @ A @ A4 ) )
      = ( ( member @ A @ X @ A4 )
        & ( member @ ( stream170649215stream @ A ) @ S3 @ ( stream2015131171treams @ A @ A4 ) ) ) ) )).

% streams_Stream
thf(fact_9_stream_Oset__cases,axiom,(
    ! [A: $tType,E: A,A3: ( stream170649215stream @ A )] :
      ( ( member @ A @ E @ ( stream30925839e_sset @ A @ A3 ) )
     => ( ! [Z2: ( stream170649215stream @ A )] :
            ( A3
           != ( stream641971652_SCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( stream170649215stream @ A )] :
                ( ( A3
                  = ( stream641971652_SCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( stream30925839e_sset @ A @ Z2 ) ) ) ) ) ) )).

% stream.set_cases
thf(fact_10_streams_Ocoinduct,axiom,(
    ! [A: $tType,X3: ( ( stream170649215stream @ A ) > $o ),X: ( stream170649215stream @ A ),A4: ( set @ A )] :
      ( ( X3 @ X )
     => ( ! [X4: ( stream170649215stream @ A )] :
            ( ( X3 @ X4 )
           => ? [A7: A,S4: ( stream170649215stream @ A )] :
                ( ( X4
                  = ( stream641971652_SCons @ A @ A7 @ S4 ) )
                & ( member @ A @ A7 @ A4 )
                & ( ( X3 @ S4 )
                  | ( member @ ( stream170649215stream @ A ) @ S4 @ ( stream2015131171treams @ A @ A4 ) ) ) ) )
       => ( member @ ( stream170649215stream @ A ) @ X @ ( stream2015131171treams @ A @ A4 ) ) ) ) )).

% streams.coinduct
thf(fact_11_stream_Oset__induct,axiom,(
    ! [A: $tType,X: A,A3: ( stream170649215stream @ A ),P: ( A > ( stream170649215stream @ A ) > $o )] :
      ( ( member @ A @ X @ ( stream30925839e_sset @ A @ A3 ) )
     => ( ! [Z1: A,Z2: ( stream170649215stream @ A )] :
            ( P @ Z1 @ ( stream641971652_SCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( stream170649215stream @ A ),Xa: A] :
              ( ( member @ A @ Xa @ ( stream30925839e_sset @ A @ Z2 ) )
             => ( ( P @ Xa @ Z2 )
               => ( P @ Xa @ ( stream641971652_SCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P @ X @ A3 ) ) ) ) )).

% stream.set_induct
thf(fact_12_smember__code,axiom,(
    ! [A: $tType,X: A,Y: A,S3: ( stream170649215stream @ A )] :
      ( ( stream1586597341member @ A @ X @ ( stream641971652_SCons @ A @ Y @ S3 ) )
      = ( ( X != Y )
       => ( stream1586597341member @ A @ X @ S3 ) ) ) )).

% smember_code
thf(fact_13_subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A4 )
         => ( member @ A @ X4 @ B2 ) )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) )).

% subsetI
thf(fact_14_subset__antisym,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ A4 )
       => ( A4 = B2 ) ) ) )).

% subset_antisym
thf(fact_15_order__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ord_less_eq @ A @ X @ X ) ) )).

% order_refl
thf(fact_16_Stream__Mirabelle__hbrgyiwlrc_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( stream1586597341member @ A )
      = ( ^ [X5: A,S2: ( stream170649215stream @ A )] :
            ( member @ A @ X5 @ ( stream30925839e_sset @ A @ S2 ) ) ) ) )).

% Stream_Mirabelle_hbrgyiwlrc.smember_def
thf(fact_17_set__mp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B2 ) ) ) )).

% set_mp
thf(fact_18_in__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( member @ A @ X @ A4 )
       => ( member @ A @ X @ B2 ) ) ) )).

% in_mono
thf(fact_19_subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetD
thf(fact_20_subsetCE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% subsetCE
thf(fact_21_equalityE,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( A4 = B2 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B2 @ A4 ) ) ) )).

% equalityE
thf(fact_22_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B3: ( set @ A )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A8 )
           => ( member @ A @ X5 @ B3 ) ) ) ) )).

% subset_eq
thf(fact_23_equalityD1,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( A4 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) )).

% equalityD1
thf(fact_24_dual__order_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A] :
          ( ( ord_less_eq @ A @ B4 @ A3 )
         => ( ( ord_less_eq @ A @ A3 @ B4 )
           => ( A3 = B4 ) ) ) ) )).

% dual_order.antisym
thf(fact_25_dual__order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B4 @ A3 )
         => ( ( ord_less_eq @ A @ C2 @ B4 )
           => ( ord_less_eq @ A @ C2 @ A3 ) ) ) ) )).

% dual_order.trans
thf(fact_26_linorder__wlog,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [P: ( A > A > $o ),A3: A,B4: A] :
          ( ! [A5: A,B5: A] :
              ( ( ord_less_eq @ A @ A5 @ B5 )
             => ( P @ A5 @ B5 ) )
         => ( ! [A5: A,B5: A] :
                ( ( P @ B5 @ A5 )
               => ( P @ A5 @ B5 ) )
           => ( P @ A3 @ B4 ) ) ) ) )).

% linorder_wlog
thf(fact_27_dual__order_Orefl,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ A3 @ A3 ) ) )).

% dual_order.refl
thf(fact_28_order__trans,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) )).

% order_trans
thf(fact_29_order__class_Oorder_Oantisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ A3 )
           => ( A3 = B4 ) ) ) ) )).

% order_class.order.antisym
thf(fact_30_ord__le__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( B4 = C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_le_eq_trans
thf(fact_31_ord__eq__le__trans,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( A3 = B4 )
         => ( ( ord_less_eq @ A @ B4 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% ord_eq_le_trans
thf(fact_32_antisym__conv,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) )).

% antisym_conv
thf(fact_33_le__cases3,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) )).

% le_cases3
thf(fact_34_order_Otrans,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ A @ B4 @ C2 )
           => ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% order.trans
thf(fact_35_le__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) )).

% le_cases
thf(fact_36_eq__refl,axiom,(
    ! [A: $tType] :
      ( ( preorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) )).

% eq_refl
thf(fact_37_linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) )).

% linear
thf(fact_38_antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) )).

% antisym
thf(fact_39_eq__iff,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ( ( ^ [Y3: A,Z3: A] : ( Y3 = Z3 ) )
        = ( ^ [X5: A,Y4: A] :
              ( ( ord_less_eq @ A @ X5 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X5 ) ) ) ) ) )).

% eq_iff
thf(fact_40_ord__le__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B4: A,F: ( A > B ),C2: B] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ( F @ B4 )
              = C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y5 )
                 => ( ord_less_eq @ B @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ B @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% ord_le_eq_subst
thf(fact_41_ord__eq__le__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B4: B,C2: B] :
          ( ( A3
            = ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_le_subst
thf(fact_42_order__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B4: A,F: ( A > C ),C2: C] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ C @ ( F @ B4 ) @ C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X4 @ Y5 )
                 => ( ord_less_eq @ C @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% order_subst2
thf(fact_43_order__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B4: B,C2: B] :
          ( ( ord_less_eq @ A @ A3 @ ( F @ B4 ) )
         => ( ( ord_less_eq @ B @ B4 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X4 @ Y5 )
                 => ( ord_less_eq @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less_eq @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% order_subst1
thf(fact_44_le__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G: ( A > B )] :
            ! [X5: A] :
              ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) )).

% le_fun_def
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P: ( A > $o )] :
      ( ( member @ A @ A3 @ ( collect @ A @ P ) )
      = ( P @ A3 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X5: A] :
            ( member @ A @ X5 @ A4 ) )
      = A4 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G2: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G2 @ X4 ) )
     => ( F = G2 ) ) )).

% ext
thf(fact_49_le__funI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G2: ( A > B )] :
          ( ! [X4: A] :
              ( ord_less_eq @ B @ ( F @ X4 ) @ ( G2 @ X4 ) )
         => ( ord_less_eq @ ( A > B ) @ F @ G2 ) ) ) )).

% le_funI
thf(fact_50_le__funE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G2: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G2 )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G2 @ X ) ) ) ) )).

% le_funE
thf(fact_51_le__funD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ B @ ( type2 @ B ) )
     => ! [F: ( A > B ),G2: ( A > B ),X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F @ G2 )
         => ( ord_less_eq @ B @ ( F @ X ) @ ( G2 @ X ) ) ) ) )).

% le_funD
thf(fact_52_Collect__mono__iff,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X5: A] :
            ( ( P @ X5 )
           => ( Q @ X5 ) ) ) ) )).

% Collect_mono_iff
thf(fact_53_contra__subsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ~ ( member @ A @ C2 @ B2 )
       => ~ ( member @ A @ C2 @ A4 ) ) ) )).

% contra_subsetD
thf(fact_54_set__eq__subset,axiom,(
    ! [A: $tType] :
      ( ( ^ [Y3: ( set @ A ),Z3: ( set @ A )] : ( Y3 = Z3 ) )
      = ( ^ [A8: ( set @ A ),B3: ( set @ A )] :
            ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
            & ( ord_less_eq @ ( set @ A ) @ B3 @ A8 ) ) ) ) )).

% set_eq_subset
thf(fact_55_subset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less_eq @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% subset_trans
thf(fact_56_Collect__mono,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
         => ( Q @ X4 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) )).

% Collect_mono
thf(fact_57_subset__refl,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ A4 @ A4 ) )).

% subset_refl
thf(fact_58_rev__subsetD,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% rev_subsetD
thf(fact_59_subset__iff,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B3: ( set @ A )] :
          ! [T: A] :
            ( ( member @ A @ T @ A8 )
           => ( member @ A @ T @ B3 ) ) ) ) )).

% subset_iff
thf(fact_60_set__rev__mp,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
       => ( member @ A @ X @ B2 ) ) ) )).

% set_rev_mp
thf(fact_61_equalityD2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( A4 = B2 )
     => ( ord_less_eq @ ( set @ A ) @ B2 @ A4 ) ) )).

% equalityD2
thf(fact_62_stream_Oset,axiom,(
    ! [A: $tType,X1: A,X2: ( stream170649215stream @ A )] :
      ( ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ X1 @ X2 ) )
      = ( insert @ A @ X1 @ ( stream30925839e_sset @ A @ X2 ) ) ) )).

% stream.set
thf(fact_63_stream_Opred__inject,axiom,(
    ! [A: $tType,P: ( A > $o ),A3: A,Aa: ( stream170649215stream @ A )] :
      ( ( stream1153105665stream @ A @ P @ ( stream641971652_SCons @ A @ A3 @ Aa ) )
      = ( ( P @ A3 )
        & ( stream1153105665stream @ A @ P @ Aa ) ) ) )).

% stream.pred_inject
thf(fact_64_antimono__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A @ ( type2 @ A ) )
        & ( order @ B @ ( type2 @ B ) ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F2: ( A > B )] :
            ! [X5: A,Y4: A] :
              ( ( ord_less_eq @ A @ X5 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ Y4 ) @ ( F2 @ X5 ) ) ) ) ) ) )).

% antimono_def
thf(fact_65_antimonoI,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A @ ( type2 @ A ) )
        & ( order @ B @ ( type2 @ B ) ) )
     => ! [F: ( A > B )] :
          ( ! [X4: A,Y5: A] :
              ( ( ord_less_eq @ A @ X4 @ Y5 )
             => ( ord_less_eq @ B @ ( F @ Y5 ) @ ( F @ X4 ) ) )
         => ( order_antimono @ A @ B @ F ) ) ) )).

% antimonoI
thf(fact_66_antimonoE,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A @ ( type2 @ A ) )
        & ( order @ B @ ( type2 @ B ) ) )
     => ! [F: ( A > B ),X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) )).

% antimonoE
thf(fact_67_antimonoD,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A @ ( type2 @ A ) )
        & ( order @ B @ ( type2 @ B ) ) )
     => ! [F: ( A > B ),X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F @ Y ) @ ( F @ X ) ) ) ) ) )).

% antimonoD
thf(fact_68_streamsp_Ocoinduct,axiom,(
    ! [A: $tType,X3: ( ( stream170649215stream @ A ) > $o ),X: ( stream170649215stream @ A ),A4: ( A > $o )] :
      ( ( X3 @ X )
     => ( ! [X4: ( stream170649215stream @ A )] :
            ( ( X3 @ X4 )
           => ? [A7: A,S4: ( stream170649215stream @ A )] :
                ( ( X4
                  = ( stream641971652_SCons @ A @ A7 @ S4 ) )
                & ( A4 @ A7 )
                & ( ( X3 @ S4 )
                  | ( stream86250253reamsp @ A @ A4 @ S4 ) ) ) )
       => ( stream86250253reamsp @ A @ A4 @ X ) ) ) )).

% streamsp.coinduct
thf(fact_69_streamsp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( stream86250253reamsp @ A )
      = ( ^ [A8: ( A > $o ),A6: ( stream170649215stream @ A )] :
          ? [B6: A,S2: ( stream170649215stream @ A )] :
            ( ( A6
              = ( stream641971652_SCons @ A @ B6 @ S2 ) )
            & ( A8 @ B6 )
            & ( stream86250253reamsp @ A @ A8 @ S2 ) ) ) ) )).

% streamsp.simps
thf(fact_70_streamsp_Ocases,axiom,(
    ! [A: $tType,A4: ( A > $o ),A3: ( stream170649215stream @ A )] :
      ( ( stream86250253reamsp @ A @ A4 @ A3 )
     => ~ ( ! [A5: A,S: ( stream170649215stream @ A )] :
              ( ( A3
                = ( stream641971652_SCons @ A @ A5 @ S ) )
             => ( ( A4 @ A5 )
               => ~ ( stream86250253reamsp @ A @ A4 @ S ) ) ) ) ) )).

% streamsp.cases
thf(fact_71_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( stream170649215stream @ A ) > B ),X1: A,X2: ( stream170649215stream @ A )] :
      ( ( stream1342653232stream @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X2 ) )
      = ( F @ X1 @ X2 ) ) )).

% stream.case
thf(fact_72_insertCI,axiom,(
    ! [A: $tType,A3: A,B2: ( set @ A ),B4: A] :
      ( ( ~ ( member @ A @ A3 @ B2 )
       => ( A3 = B4 ) )
     => ( member @ A @ A3 @ ( insert @ A @ B4 @ B2 ) ) ) )).

% insertCI
thf(fact_73_insert__iff,axiom,(
    ! [A: $tType,A3: A,B4: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B4 @ A4 ) )
      = ( ( A3 = B4 )
        | ( member @ A @ A3 @ A4 ) ) ) )).

% insert_iff
thf(fact_74_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A4 ) )
      = ( insert @ A @ X @ A4 ) ) )).

% insert_absorb2
thf(fact_75_insert__subset,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ B2 )
      = ( ( member @ A @ X @ B2 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% insert_subset
thf(fact_76_insertE,axiom,(
    ! [A: $tType,A3: A,B4: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ ( insert @ A @ B4 @ A4 ) )
     => ( ( A3 != B4 )
       => ( member @ A @ A3 @ A4 ) ) ) )).

% insertE
thf(fact_77_insertI1,axiom,(
    ! [A: $tType,A3: A,B2: ( set @ A )] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ B2 ) ) )).

% insertI1
thf(fact_78_insertI2,axiom,(
    ! [A: $tType,A3: A,B2: ( set @ A ),B4: A] :
      ( ( member @ A @ A3 @ B2 )
     => ( member @ A @ A3 @ ( insert @ A @ B4 @ B2 ) ) ) )).

% insertI2
thf(fact_79_Set_Oset__insert,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A )] :
      ( ( member @ A @ X @ A4 )
     => ~ ( ! [B7: ( set @ A )] :
              ( ( A4
                = ( insert @ A @ X @ B7 ) )
             => ( member @ A @ X @ B7 ) ) ) ) )).

% Set.set_insert
thf(fact_80_insert__ident,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ~ ( member @ A @ X @ B2 )
       => ( ( ( insert @ A @ X @ A4 )
            = ( insert @ A @ X @ B2 ) )
          = ( A4 = B2 ) ) ) ) )).

% insert_ident
thf(fact_81_insert__absorb,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( insert @ A @ A3 @ A4 )
        = A4 ) ) )).

% insert_absorb
thf(fact_82_insert__eq__iff,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B4: A,B2: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ A4 )
     => ( ~ ( member @ A @ B4 @ B2 )
       => ( ( ( insert @ A @ A3 @ A4 )
            = ( insert @ A @ B4 @ B2 ) )
          = ( ( ( A3 = B4 )
             => ( A4 = B2 ) )
            & ( ( A3 != B4 )
             => ? [C4: ( set @ A )] :
                  ( ( A4
                    = ( insert @ A @ B4 @ C4 ) )
                  & ~ ( member @ A @ B4 @ C4 )
                  & ( B2
                    = ( insert @ A @ A3 @ C4 ) )
                  & ~ ( member @ A @ A3 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_83_insert__commute,axiom,(
    ! [A: $tType,X: A,Y: A,A4: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ Y @ A4 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X @ A4 ) ) ) )).

% insert_commute
thf(fact_84_mk__disjoint__insert,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ A4 )
     => ? [B7: ( set @ A )] :
          ( ( A4
            = ( insert @ A @ A3 @ B7 ) )
          & ~ ( member @ A @ A3 @ B7 ) ) ) )).

% mk_disjoint_insert
thf(fact_85_insert__mono,axiom,(
    ! [A: $tType,C3: ( set @ A ),D: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ D )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A3 @ C3 ) @ ( insert @ A @ A3 @ D ) ) ) )).

% insert_mono
thf(fact_86_subset__insert,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B2 ) )
        = ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% subset_insert
thf(fact_87_subset__insertI,axiom,(
    ! [A: $tType,B2: ( set @ A ),A3: A] :
      ( ord_less_eq @ ( set @ A ) @ B2 @ ( insert @ A @ A3 @ B2 ) ) )).

% subset_insertI
thf(fact_88_subset__insertI2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),B4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B4 @ B2 ) ) ) )).

% subset_insertI2
thf(fact_89_stream_Opred__cong,axiom,(
    ! [A: $tType,X: ( stream170649215stream @ A ),Ya: ( stream170649215stream @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X = Ya )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( stream30925839e_sset @ A @ Ya ) )
           => ( ( P @ Z4 )
              = ( Pa @ Z4 ) ) )
       => ( ( stream1153105665stream @ A @ P @ X )
          = ( stream1153105665stream @ A @ Pa @ Ya ) ) ) ) )).

% stream.pred_cong
thf(fact_90_stream_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X: ( stream170649215stream @ A ),Pa: ( A > $o )] :
      ( ( stream1153105665stream @ A @ P @ X )
     => ( ! [Z4: A] :
            ( ( member @ A @ Z4 @ ( stream30925839e_sset @ A @ X ) )
           => ( ( P @ Z4 )
             => ( Pa @ Z4 ) ) )
       => ( stream1153105665stream @ A @ Pa @ X ) ) ) )).

% stream.pred_mono_strong
thf(fact_91_insert__subsetI,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),X3: ( set @ A )] :
      ( ( member @ A @ X @ A4 )
     => ( ( ord_less_eq @ ( set @ A ) @ X3 @ A4 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X @ X3 ) @ A4 ) ) ) )).

% insert_subsetI
thf(fact_92_singleton__insert__inj__eq_H,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B4: A] :
      ( ( ( insert @ A @ A3 @ A4 )
        = ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A3 = B4 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq'
thf(fact_93_singleton__insert__inj__eq,axiom,(
    ! [A: $tType,B4: A,A3: A,A4: ( set @ A )] :
      ( ( ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A3 @ A4 ) )
      = ( ( A3 = B4 )
        & ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% singleton_insert_inj_eq
thf(fact_94_stream_Opred__set,axiom,(
    ! [A: $tType] :
      ( ( stream1153105665stream @ A )
      = ( ^ [P2: ( A > $o ),X5: ( stream170649215stream @ A )] :
          ! [Y4: A] :
            ( ( member @ A @ Y4 @ ( stream30925839e_sset @ A @ X5 ) )
           => ( P2 @ Y4 ) ) ) ) )).

% stream.pred_set
thf(fact_95_subset__singletonD,axiom,(
    ! [A: $tType,A4: ( set @ A ),X: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ( A4
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singletonD
thf(fact_96_subset__singleton__iff,axiom,(
    ! [A: $tType,X3: ( set @ A ),A3: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X3
          = ( bot_bot @ ( set @ A ) ) )
        | ( X3
          = ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% subset_singleton_iff
thf(fact_97_stream_Ocorec__code,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( stream660621732stream @ C @ A )
      = ( ^ [G1: ( C > A ),Q2: ( C > $o ),G21: ( C > ( stream170649215stream @ A ) ),G22: ( C > C ),A6: C] :
            ( stream641971652_SCons @ A @ ( G1 @ A6 ) @ ( if @ ( stream170649215stream @ A ) @ ( Q2 @ A6 ) @ ( G21 @ A6 ) @ ( stream660621732stream @ C @ A @ G1 @ Q2 @ G21 @ G22 @ ( G22 @ A6 ) ) ) ) ) ) )).

% stream.corec_code
thf(fact_98_bot__apply,axiom,(
    ! [C: $tType,D2: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D2 > C ) )
        = ( ^ [X5: D2] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_99_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X5: A] :
            ~ ( P @ X5 ) ) ) )).

% empty_Collect_eq
thf(fact_100_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X5: A] :
            ~ ( P @ X5 ) ) ) )).

% Collect_empty_eq
thf(fact_101_all__not__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ! [X5: A] :
            ~ ( member @ A @ X5 @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_102_empty__iff,axiom,(
    ! [A: $tType,C2: A] :
      ~ ( member @ A @ C2 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_103_empty__subsetI,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 ) )).

% empty_subsetI
thf(fact_104_subset__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_empty
thf(fact_105_singletonI,axiom,(
    ! [A: $tType,A3: A] :
      ( member @ A @ A3 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_106_ball__empty,axiom,(
    ! [A: $tType,P: ( A > $o ),X6: A] :
      ( ( member @ A @ X6 @ ( bot_bot @ ( set @ A ) ) )
     => ( P @ X6 ) ) )).

% ball_empty
thf(fact_107_subset__emptyI,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [X4: A] :
          ~ ( member @ A @ X4 @ A4 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_emptyI
thf(fact_108_stream_Ocorec__disc,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( stream660621732stream @ C @ A )
      = ( stream660621732stream @ C @ A ) ) )).

% stream.corec_disc
thf(fact_109_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X5: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_110_ex__in__conv,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ? [X5: A] :
            ( member @ A @ X5 @ A4 ) )
      = ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_111_equals0I,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ! [Y5: A] :
          ~ ( member @ A @ Y5 @ A4 )
     => ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_112_equals0D,axiom,(
    ! [A: $tType,A4: ( set @ A ),A3: A] :
      ( ( A4
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A3 @ A4 ) ) )).

% equals0D
thf(fact_113_Ball__def,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A8: ( set @ A ),P2: ( A > $o )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A8 )
           => ( P2 @ X5 ) ) ) ) )).

% Ball_def
thf(fact_114_emptyE,axiom,(
    ! [A: $tType,A3: A] :
      ~ ( member @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_115_bot_Oextremum__uniqueI,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
         => ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_uniqueI
thf(fact_116_bot_Oextremum__unique,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( ord_less_eq @ A @ A3 @ ( bot_bot @ A ) )
          = ( A3
            = ( bot_bot @ A ) ) ) ) )).

% bot.extremum_unique
thf(fact_117_bot_Oextremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ord_less_eq @ A @ ( bot_bot @ A ) @ A3 ) ) )).

% bot.extremum
thf(fact_118_singleton__inject,axiom,(
    ! [A: $tType,A3: A,B4: A] :
      ( ( ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A3 = B4 ) ) )).

% singleton_inject
thf(fact_119_insert__not__empty,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( insert @ A @ A3 @ A4 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_120_doubleton__eq__iff,axiom,(
    ! [A: $tType,A3: A,B4: A,C2: A,D3: A] :
      ( ( ( insert @ A @ A3 @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C2 @ ( insert @ A @ D3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A3 = C2 )
          & ( B4 = D3 ) )
        | ( ( A3 = D3 )
          & ( B4 = C2 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_121_singleton__iff,axiom,(
    ! [A: $tType,B4: A,A3: A] :
      ( ( member @ A @ B4 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B4 = A3 ) ) )).

% singleton_iff
thf(fact_122_singletonD,axiom,(
    ! [A: $tType,B4: A,A3: A] :
      ( ( member @ A @ B4 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B4 = A3 ) ) )).

% singletonD
thf(fact_123_the__elem__eq,axiom,(
    ! [A: $tType,X: A] :
      ( ( the_elem @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
      = X ) )).

% the_elem_eq
thf(fact_124_is__singletonI,axiom,(
    ! [A: $tType,X: A] :
      ( is_singleton @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_125_Ball__Collect,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A8: ( set @ A ),P2: ( A > $o )] :
            ( ord_less_eq @ ( set @ A ) @ A8 @ ( collect @ A @ P2 ) ) ) ) )).

% Ball_Collect
thf(fact_126_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A8: ( set @ A )] :
            ( A8
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_127_is__singletonE,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( is_singleton @ A @ A4 )
     => ~ ( ! [X4: A] :
              ( A4
             != ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_128_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_129_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A8: ( set @ A )] :
            ( A8
            = ( insert @ A @ ( the_elem @ A @ A8 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_130_is__singletonI_H,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( A4
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X4: A,Y5: A] :
            ( ( member @ A @ X4 @ A4 )
           => ( ( member @ A @ Y5 @ A4 )
             => ( X4 = Y5 ) ) )
       => ( is_singleton @ A @ A4 ) ) ) )).

% is_singletonI'
thf(fact_131_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A8: ( set @ A )] :
          ? [X5: A] :
            ( A8
            = ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_132_pairwise__singleton,axiom,(
    ! [A: $tType,P: ( A > A > $o ),A4: A] :
      ( pairwise @ A @ P @ ( insert @ A @ A4 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_133_subset__Compl__singleton,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B4 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B4 @ A4 ) ) ) )).

% subset_Compl_singleton
thf(fact_134_ball__reg,axiom,(
    ! [A: $tType,R: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ R )
         => ( ( P @ X4 )
           => ( Q @ X4 ) ) )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ R )
           => ( P @ X4 ) )
       => ! [X6: A] :
            ( ( member @ A @ X6 @ R )
           => ( Q @ X6 ) ) ) ) )).

% ball_reg
thf(fact_135_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X5: A] :
            ( member @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_136_Compl__eq__Compl__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ( uminus_uminus @ ( set @ A ) @ A4 )
        = ( uminus_uminus @ ( set @ A ) @ B2 ) )
      = ( A4 = B2 ) ) )).

% Compl_eq_Compl_iff
thf(fact_137_Compl__iff,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( ~ ( member @ A @ C2 @ A4 ) ) ) )).

% Compl_iff
thf(fact_138_ComplI,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A )] :
      ( ~ ( member @ A @ C2 @ A4 )
     => ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) ) )).

% ComplI
thf(fact_139_Compl__anti__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B2 ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) ) ) )).

% Compl_anti_mono
thf(fact_140_Compl__subset__Compl__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( uminus_uminus @ ( set @ A ) @ B2 ) )
      = ( ord_less_eq @ ( set @ A ) @ B2 @ A4 ) ) )).

% Compl_subset_Compl_iff
thf(fact_141_double__complement,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = A4 ) )).

% double_complement
thf(fact_142_pairwise__def,axiom,(
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R2: ( A > A > $o ),S5: ( set @ A )] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ S5 )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ S5 )
               => ( ( X5 != Y4 )
                 => ( R2 @ X5 @ Y4 ) ) ) ) ) ) )).

% pairwise_def
thf(fact_143_ComplD,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A )] :
      ( ( member @ A @ C2 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
     => ~ ( member @ A @ C2 @ A4 ) ) )).

% ComplD
thf(fact_144_subset__Compl__self__eq,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( A4
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% subset_Compl_self_eq
thf(fact_145_pairwise__empty,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) )).

% pairwise_empty
thf(fact_146_pairwise__subset,axiom,(
    ! [A: $tType,P: ( A > A > $o ),S6: ( set @ A ),T2: ( set @ A )] :
      ( ( pairwise @ A @ P @ S6 )
     => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S6 )
       => ( pairwise @ A @ P @ T2 ) ) ) )).

% pairwise_subset
thf(fact_147_pairwise__insert,axiom,(
    ! [A: $tType,R3: ( A > A > $o ),X: A,S3: ( set @ A )] :
      ( ( pairwise @ A @ R3 @ ( insert @ A @ X @ S3 ) )
      = ( ! [Y4: A] :
            ( ( ( member @ A @ Y4 @ S3 )
              & ( Y4 != X ) )
           => ( ( R3 @ X @ Y4 )
              & ( R3 @ Y4 @ X ) ) )
        & ( pairwise @ A @ R3 @ S3 ) ) ) )).

% pairwise_insert
thf(fact_148_neg__le__iff__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B4 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less_eq @ A @ A3 @ B4 ) ) ) )).

% neg_le_iff_le
thf(fact_149_compl__le__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) )).

% compl_le_compl_iff
thf(fact_150_uminus__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A8: ( A > B ),X5: A] :
              ( uminus_uminus @ B @ ( A8 @ X5 ) ) ) ) ) )).

% uminus_apply
thf(fact_151_add_Oinverse__inverse,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A3 ) )
          = A3 ) ) )).

% add.inverse_inverse
thf(fact_152_compl__eq__compl__iff,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( uminus_uminus @ A @ X )
            = ( uminus_uminus @ A @ Y ) )
          = ( X = Y ) ) ) )).

% compl_eq_compl_iff
thf(fact_153_double__compl,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ X ) )
          = X ) ) )).

% double_compl
thf(fact_154_neg__equal__iff__equal,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = ( uminus_uminus @ A @ B4 ) )
          = ( A3 = B4 ) ) ) )).

% neg_equal_iff_equal
thf(fact_155_minus__equation__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ( uminus_uminus @ A @ A3 )
            = B4 )
          = ( ( uminus_uminus @ A @ B4 )
            = A3 ) ) ) )).

% minus_equation_iff
thf(fact_156_equation__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( A3
            = ( uminus_uminus @ A @ B4 ) )
          = ( B4
            = ( uminus_uminus @ A @ A3 ) ) ) ) )).

% equation_minus_iff
thf(fact_157_fun__Compl__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B @ ( type2 @ B ) )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A8: ( A > B ),X5: A] :
              ( uminus_uminus @ B @ ( A8 @ X5 ) ) ) ) ) )).

% fun_Compl_def
thf(fact_158_le__imp__neg__le,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B4 ) @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_imp_neg_le
thf(fact_159_minus__le__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A3 ) @ B4 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B4 ) @ A3 ) ) ) )).

% minus_le_iff
thf(fact_160_le__minus__iff,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( ord_less_eq @ A @ A3 @ ( uminus_uminus @ A @ B4 ) )
          = ( ord_less_eq @ A @ B4 @ ( uminus_uminus @ A @ A3 ) ) ) ) )).

% le_minus_iff
thf(fact_161_compl__le__swap2,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) )).

% compl_le_swap2
thf(fact_162_compl__le__swap1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) )).

% compl_le_swap1
thf(fact_163_compl__mono,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) )).

% compl_mono
thf(fact_164_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_165_in__inv__imagep,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( inv_imagep @ A @ B )
      = ( ^ [R4: ( A > A > $o ),F2: ( B > A ),X5: B,Y4: B] :
            ( R4 @ ( F2 @ X5 ) @ ( F2 @ Y4 ) ) ) ) )).

% in_inv_imagep
thf(fact_166_Compl__insert,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A )] :
      ( ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X @ A4 ) )
      = ( minus_minus @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Compl_insert
thf(fact_167_Diff__idemp,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) @ B2 )
      = ( minus_minus @ ( set @ A ) @ A4 @ B2 ) ) )).

% Diff_idemp
thf(fact_168_Diff__iff,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) )
      = ( ( member @ A @ C2 @ A4 )
        & ~ ( member @ A @ C2 @ B2 ) ) ) )).

% Diff_iff
thf(fact_169_DiffI,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ~ ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) ) ) ) )).

% DiffI
thf(fact_170_minus__diff__eq,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A3 @ B4 ) )
          = ( minus_minus @ A @ B4 @ A3 ) ) ) )).

% minus_diff_eq
thf(fact_171_Diff__cancel,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_cancel
thf(fact_172_empty__Diff,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% empty_Diff
thf(fact_173_Diff__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = A4 ) )).

% Diff_empty
thf(fact_174_Diff__insert0,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B2 ) )
        = ( minus_minus @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% Diff_insert0
thf(fact_175_insert__Diff1,axiom,(
    ! [A: $tType,X: A,B2: ( set @ A ),A4: ( set @ A )] :
      ( ( member @ A @ X @ B2 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ B2 )
        = ( minus_minus @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% insert_Diff1
thf(fact_176_Diff__eq__empty__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ( minus_minus @ ( set @ A ) @ A4 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) )).

% Diff_eq_empty_iff
thf(fact_177_insert__Diff__single,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( insert @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( insert @ A @ A3 @ A4 ) ) )).

% insert_Diff_single
thf(fact_178_diff__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,D3: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ( ord_less_eq @ A @ D3 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B4 @ D3 ) ) ) ) ) )).

% diff_mono
thf(fact_179_diff__left__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A,C2: A] :
          ( ( ord_less_eq @ A @ B4 @ A3 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A3 ) @ ( minus_minus @ A @ C2 @ B4 ) ) ) ) )).

% diff_left_mono
thf(fact_180_diff__right__mono,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ B4 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ C2 ) @ ( minus_minus @ A @ B4 @ C2 ) ) ) ) )).

% diff_right_mono
thf(fact_181_diff__eq__diff__less__eq,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A,D3: A] :
          ( ( ( minus_minus @ A @ A3 @ B4 )
            = ( minus_minus @ A @ C2 @ D3 ) )
         => ( ( ord_less_eq @ A @ A3 @ B4 )
            = ( ord_less_eq @ A @ C2 @ D3 ) ) ) ) )).

% diff_eq_diff_less_eq
thf(fact_182_Diff__mono,axiom,(
    ! [A: $tType,A4: ( set @ A ),C3: ( set @ A ),D: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ C3 )
     => ( ( ord_less_eq @ ( set @ A ) @ D @ B2 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) @ ( minus_minus @ ( set @ A ) @ C3 @ D ) ) ) ) )).

% Diff_mono
thf(fact_183_Diff__subset,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) @ A4 ) )).

% Diff_subset
thf(fact_184_double__diff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( ord_less_eq @ ( set @ A ) @ B2 @ C3 )
       => ( ( minus_minus @ ( set @ A ) @ B2 @ ( minus_minus @ ( set @ A ) @ C3 @ A4 ) )
          = A4 ) ) ) )).

% double_diff
thf(fact_185_insert__Diff__if,axiom,(
    ! [A: $tType,X: A,B2: ( set @ A ),A4: ( set @ A )] :
      ( ( ( member @ A @ X @ B2 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ B2 )
          = ( minus_minus @ ( set @ A ) @ A4 @ B2 ) ) )
      & ( ~ ( member @ A @ X @ B2 )
       => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ B2 )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) ) ) ) ) )).

% insert_Diff_if
thf(fact_186_DiffD2,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) )
     => ~ ( member @ A @ C2 @ B2 ) ) )).

% DiffD2
thf(fact_187_DiffD1,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) )
     => ( member @ A @ C2 @ A4 ) ) )).

% DiffD1
thf(fact_188_DiffE,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) )
     => ~ ( ( member @ A @ C2 @ A4 )
         => ( member @ A @ C2 @ B2 ) ) ) )).

% DiffE
thf(fact_189_Diff__insert,axiom,(
    ! [A: $tType,A4: ( set @ A ),A3: A,B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Diff_insert
thf(fact_190_insert__Diff,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A )] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( insert @ A @ A3 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = A4 ) ) )).

% insert_Diff
thf(fact_191_Diff__insert2,axiom,(
    ! [A: $tType,A4: ( set @ A ),A3: A,B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) ) )).

% Diff_insert2
thf(fact_192_Diff__insert__absorb,axiom,(
    ! [A: $tType,X: A,A4: ( set @ A )] :
      ( ~ ( member @ A @ X @ A4 )
     => ( ( minus_minus @ ( set @ A ) @ ( insert @ A @ X @ A4 ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = A4 ) ) )).

% Diff_insert_absorb
thf(fact_193_subset__Diff__insert,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),X: A,C3: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B2 @ ( insert @ A @ X @ C3 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B2 @ C3 ) )
        & ~ ( member @ A @ X @ A4 ) ) ) )).

% subset_Diff_insert
thf(fact_194_Diff__single__insert,axiom,(
    ! [A: $tType,A4: ( set @ A ),X: A,B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 )
     => ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B2 ) ) ) )).

% Diff_single_insert
thf(fact_195_subset__insert__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),X: A,B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B2 ) )
      = ( ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) )
        & ( ~ ( member @ A @ X @ A4 )
         => ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) ) ) )).

% subset_insert_iff
thf(fact_196_remove__def,axiom,(
    ! [A: $tType] :
      ( ( remove @ A )
      = ( ^ [X5: A,A8: ( set @ A )] :
            ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% remove_def
thf(fact_197_psubset__insert__iff,axiom,(
    ! [A: $tType,A4: ( set @ A ),X: A,B2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ ( insert @ A @ X @ B2 ) )
      = ( ( ( member @ A @ X @ B2 )
         => ( ord_less @ ( set @ A ) @ A4 @ B2 ) )
        & ( ~ ( member @ A @ X @ B2 )
         => ( ( ( member @ A @ X @ A4 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ B2 ) )
            & ( ~ ( member @ A @ X @ A4 )
             => ( ord_less_eq @ ( set @ A ) @ A4 @ B2 ) ) ) ) ) ) )).

% psubset_insert_iff
thf(fact_198_disjoint__eq__subset__Compl,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ B2 ) ) ) )).

% disjoint_eq_subset_Compl
thf(fact_199_IntI,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A4 )
     => ( ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) ) ) )).

% IntI
thf(fact_200_Int__iff,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) )
      = ( ( member @ A @ C2 @ A4 )
        & ( member @ A @ C2 @ B2 ) ) ) )).

% Int_iff
thf(fact_201_member__remove,axiom,(
    ! [A: $tType,X: A,Y: A,A4: ( set @ A )] :
      ( ( member @ A @ X @ ( remove @ A @ Y @ A4 ) )
      = ( ( member @ A @ X @ A4 )
        & ( X != Y ) ) ) )).

% member_remove
thf(fact_202_le__inf__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z ) ) ) ) )).

% le_inf_iff
thf(fact_203_inf_Obounded__iff,axiom,(
    ! [A: $tType] :
      ( ( semilattice_inf @ A @ ( type2 @ A ) )
     => ! [A3: A,B4: A,C2: A] :
          ( ( ord_less_eq @ A @ A3 @ ( inf_inf @ A @ B4 @ C2 ) )
          = ( ( ord_less_eq @ A @ A3 @ B4 )
            & ( ord_less_eq @ A @ A3 @ C2 ) ) ) ) )).

% inf.bounded_iff
thf(fact_204_neg__less__iff__less,axiom,(
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A @ ( type2 @ A ) )
     => ! [B4: A,A3: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B4 ) @ ( uminus_uminus @ A @ A3 ) )
          = ( ord_less @ A @ A3 @ B4 ) ) ) )).

% neg_less_iff_less
thf(fact_205_inf__bot__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_right
thf(fact_206_inf__bot__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) )).

% inf_bot_left
thf(fact_207_Int__subset__iff,axiom,(
    ! [A: $tType,C3: ( set @ A ),A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ C3 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C3 @ A4 )
        & ( ord_less_eq @ ( set @ A ) @ C3 @ B2 ) ) ) )).

% Int_subset_iff
thf(fact_208_Int__insert__right__if1,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ A3 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ B2 ) )
        = ( insert @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) ) ) )).

% Int_insert_right_if1
thf(fact_209_Int__insert__right__if0,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ A4 )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ ( insert @ A @ A3 @ B2 ) )
        = ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% Int_insert_right_if0
thf(fact_210_insert__inter__insert,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A3 @ A4 ) @ ( insert @ A @ A3 @ B2 ) )
      = ( insert @ A @ A3 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% insert_inter_insert
thf(fact_211_Int__insert__left__if1,axiom,(
    ! [A: $tType,A3: A,C3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ A3 @ C3 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A3 @ B2 ) @ C3 )
        = ( insert @ A @ A3 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) ) )).

% Int_insert_left_if1
thf(fact_212_Int__insert__left__if0,axiom,(
    ! [A: $tType,A3: A,C3: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ A3 @ C3 )
     => ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A3 @ B2 ) @ C3 )
        = ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Int_insert_left_if0
thf(fact_213_psubsetI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A4 @ B2 )
     => ( ( A4 != B2 )
       => ( ord_less @ ( set @ A ) @ A4 @ B2 ) ) ) )).

% psubsetI
thf(fact_214_compl__inf__bot,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ X )
          = ( bot_bot @ A ) ) ) )).

% compl_inf_bot
thf(fact_215_inf__compl__bot,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( uminus_uminus @ A @ X ) )
          = ( bot_bot @ A ) ) ) )).

% inf_compl_bot
thf(fact_216_inf__compl__bot__left1,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ ( inf_inf @ A @ X @ Y ) )
          = ( bot_bot @ A ) ) ) )).

% inf_compl_bot_left1
thf(fact_217_inf__compl__bot__left2,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ ( uminus_uminus @ A @ X ) @ Y ) )
          = ( bot_bot @ A ) ) ) )).

% inf_compl_bot_left2
thf(fact_218_inf__compl__bot__right,axiom,(
    ! [A: $tType] :
      ( ( boolean_algebra @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ ( uminus_uminus @ A @ X ) ) )
          = ( bot_bot @ A ) ) ) )).

% inf_compl_bot_right
thf(fact_219_insert__disjoint_I1_J,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ ( insert @ A @ A3 @ A4 ) @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A3 @ B2 )
        & ( ( inf_inf @ ( set @ A ) @ A4 @ B2 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% insert_disjoint(1)
thf(fact_220_insert__disjoint_I2_J,axiom,(
    ! [A: $tType,A3: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ ( insert @ A @ A3 @ A4 ) @ B2 ) )
      = ( ~ ( member @ A @ A3 @ B2 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) ) ) )).

% insert_disjoint(2)
thf(fact_221_disjoint__insert_I1_J,axiom,(
    ! [A: $tType,B2: ( set @ A ),A3: A,A4: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ B2 @ ( insert @ A @ A3 @ A4 ) )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ~ ( member @ A @ A3 @ B2 )
        & ( ( inf_inf @ ( set @ A ) @ B2 @ A4 )
          = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% disjoint_insert(1)
thf(fact_222_disjoint__insert_I2_J,axiom,(
    ! [A: $tType,A4: ( set @ A ),B4: A,B2: ( set @ A )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( inf_inf @ ( set @ A ) @ A4 @ ( insert @ A @ B4 @ B2 ) ) )
      = ( ~ ( member @ A @ B4 @ A4 )
        & ( ( bot_bot @ ( set @ A ) )
          = ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) ) ) )).

% disjoint_insert(2)
thf(fact_223_Diff__disjoint,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B2 @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Diff_disjoint
thf(fact_224_Compl__disjoint,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ A4 ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_disjoint
thf(fact_225_Compl__disjoint2,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A4 ) @ A4 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Compl_disjoint2
thf(fact_226_Diff__Compl,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( uminus_uminus @ ( set @ A ) @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) )).

% Diff_Compl
thf(fact_227_psubset__imp__ex__mem,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B2 )
     => ? [B5: A] :
          ( member @ A @ B5 @ ( minus_minus @ ( set @ A ) @ B2 @ A4 ) ) ) )).

% psubset_imp_ex_mem
thf(fact_228_Diff__Int__distrib2,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) @ C3 )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Diff_Int_distrib2
thf(fact_229_Diff__Int__distrib,axiom,(
    ! [A: $tType,C3: ( set @ A ),A4: ( set @ A ),B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ C3 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ C3 @ A4 ) @ ( inf_inf @ ( set @ A ) @ C3 @ B2 ) ) ) )).

% Diff_Int_distrib
thf(fact_230_Diff__Diff__Int,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ A4 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) )).

% Diff_Diff_Int
thf(fact_231_Diff__Int2,axiom,(
    ! [A: $tType,A4: ( set @ A ),C3: ( set @ A ),B2: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) )
      = ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) @ B2 ) ) )).

% Diff_Int2
thf(fact_232_Int__Diff,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( minus_minus @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( minus_minus @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Int_Diff
thf(fact_233_Int__emptyI,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A4 )
         => ~ ( member @ A @ X4 @ B2 ) )
     => ( ( inf_inf @ ( set @ A ) @ A4 @ B2 )
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% Int_emptyI
thf(fact_234_Int__empty__left,axiom,(
    ! [A: $tType,B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ B2 )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_left
thf(fact_235_Int__empty__right,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% Int_empty_right
thf(fact_236_disjoint__iff__not__equal,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( ( inf_inf @ ( set @ A ) @ A4 @ B2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ A4 )
           => ! [Y4: A] :
                ( ( member @ A @ Y4 @ B2 )
               => ( X5 != Y4 ) ) ) ) ) )).

% disjoint_iff_not_equal
thf(fact_237_bot_Oextremum__strict,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ~ ( ord_less @ A @ A3 @ ( bot_bot @ A ) ) ) )).

% bot.extremum_strict
thf(fact_238_bot_Onot__eq__extremum,axiom,(
    ! [A: $tType] :
      ( ( order_bot @ A @ ( type2 @ A ) )
     => ! [A3: A] :
          ( ( A3
           != ( bot_bot @ A ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A3 ) ) ) )).

% bot.not_eq_extremum
thf(fact_239_not__psubset__empty,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ~ ( ord_less @ ( set @ A ) @ A4 @ ( bot_bot @ ( set @ A ) ) ) )).

% not_psubset_empty
thf(fact_240_IntE,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) )
     => ~ ( ( member @ A @ C2 @ A4 )
         => ~ ( member @ A @ C2 @ B2 ) ) ) )).

% IntE
thf(fact_241_IntD1,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) )
     => ( member @ A @ C2 @ A4 ) ) )).

% IntD1
thf(fact_242_IntD2,axiom,(
    ! [A: $tType,C2: A,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) )
     => ( member @ A @ C2 @ B2 ) ) )).

% IntD2
thf(fact_243_psubsetD,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C2: A] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B2 )
     => ( ( member @ A @ C2 @ A4 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% psubsetD
thf(fact_244_Int__assoc,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) @ C3 )
      = ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Int_assoc
thf(fact_245_Int__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ A4 )
      = A4 ) )).

% Int_absorb
thf(fact_246_Int__commute,axiom,(
    ! [A: $tType] :
      ( ( inf_inf @ ( set @ A ) )
      = ( ^ [A8: ( set @ A ),B3: ( set @ A )] :
            ( inf_inf @ ( set @ A ) @ B3 @ A8 ) ) ) )).

% Int_commute
thf(fact_247_psubset__trans,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( ord_less @ ( set @ A ) @ A4 @ B2 )
     => ( ( ord_less @ ( set @ A ) @ B2 @ C3 )
       => ( ord_less @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% psubset_trans
thf(fact_248_Int__left__absorb,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ A4 @ B2 ) )
      = ( inf_inf @ ( set @ A ) @ A4 @ B2 ) ) )).

% Int_left_absorb
thf(fact_249_Int__left__commute,axiom,(
    ! [A: $tType,A4: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( inf_inf @ ( set @ A ) @ A4 @ ( inf_inf @ ( set @ A ) @ B2 @ C3 ) )
      = ( inf_inf @ ( set @ A ) @ B2 @ ( inf_inf @ ( set @ A ) @ A4 @ C3 ) ) ) )).

% Int_left_commute
thf(fact_250_ord__eq__less__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B4: B,C2: B] :
          ( ( A3
            = ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less @ B @ X4 @ Y5 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% ord_eq_less_subst
thf(fact_251_ord__less__eq__subst,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B @ ( type2 @ B ) )
        & ( ord @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B4: A,F: ( A > B ),C2: B] :
          ( ( ord_less @ A @ A3 @ B4 )
         => ( ( ( F @ B4 )
              = C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less @ A @ X4 @ Y5 )
                 => ( ord_less @ B @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ B @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% ord_less_eq_subst
thf(fact_252_order__less__subst1,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B @ ( type2 @ B ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,F: ( B > A ),B4: B,C2: B] :
          ( ( ord_less @ A @ A3 @ ( F @ B4 ) )
         => ( ( ord_less @ B @ B4 @ C2 )
           => ( ! [X4: B,Y5: B] :
                  ( ( ord_less @ B @ X4 @ Y5 )
                 => ( ord_less @ A @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ A @ A3 @ ( F @ C2 ) ) ) ) ) ) )).

% order_less_subst1
thf(fact_253_order__less__subst2,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C @ ( type2 @ C ) )
        & ( order @ A @ ( type2 @ A ) ) )
     => ! [A3: A,B4: A,F: ( A > C ),C2: C] :
          ( ( ord_less @ A @ A3 @ B4 )
         => ( ( ord_less @ C @ ( F @ B4 ) @ C2 )
           => ( ! [X4: A,Y5: A] :
                  ( ( ord_less @ A @ X4 @ Y5 )
                 => ( ord_less @ C @ ( F @ X4 ) @ ( F @ Y5 ) ) )
             => ( ord_less @ C @ ( F @ A3 ) @ C2 ) ) ) ) ) )).

% order_less_subst2
thf(fact_254_lt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_bot @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [Y5: A] :
          ( ord_less @ A @ Y5 @ X ) ) )).

% lt_ex
thf(fact_255_gt__ex,axiom,(
    ! [A: $tType] :
      ( ( no_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
        ? [X12: A] :
          ( ord_less @ A @ X @ X12 ) ) )).

% gt_ex

%----Type constructors (31)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A9: $tType] :
      ( bounded_lattice @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( bounded_lattice @ A10 @ ( type2 @ A10 ) )
     => ( bounded_lattice_bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( semilattice_inf @ A10 @ ( type2 @ A10 ) )
     => ( semilattice_inf @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Lattices_Oboolean__algebra,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( boolean_algebra @ A10 @ ( type2 @ A10 ) )
     => ( boolean_algebra @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder__bot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order_bot @ A10 @ ( type2 @ A10 ) )
     => ( order_bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Opreorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( preorder @ A10 @ ( type2 @ A10 ) )
     => ( preorder @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( order @ A10 @ ( type2 @ A10 ) )
     => ( order @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( ord @ A10 @ ( type2 @ A10 ) )
     => ( ord @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( bot @ A10 @ ( type2 @ A10 ) )
     => ( bot @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_fun___Groups_Ouminus,axiom,(
    ! [A9: $tType,A10: $tType] :
      ( ( uminus @ A10 @ ( type2 @ A10 ) )
     => ( uminus @ ( A9 > A10 ) @ ( type2 @ ( A9 > A10 ) ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_3,axiom,(
    ! [A9: $tType] :
      ( bounded_lattice_bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_4,axiom,(
    ! [A9: $tType] :
      ( semilattice_inf @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Oboolean__algebra_5,axiom,(
    ! [A9: $tType] :
      ( boolean_algebra @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder__bot_6,axiom,(
    ! [A9: $tType] :
      ( order_bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Opreorder_7,axiom,(
    ! [A9: $tType] :
      ( preorder @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_8,axiom,(
    ! [A9: $tType] :
      ( order @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_9,axiom,(
    ! [A9: $tType] :
      ( ord @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_10,axiom,(
    ! [A9: $tType] :
      ( bot @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_Set_Oset___Groups_Ouminus_11,axiom,(
    ! [A9: $tType] :
      ( uminus @ ( set @ A9 ) @ ( type2 @ ( set @ A9 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_12,axiom,
    ( bounded_lattice_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_13,axiom,
    ( semilattice_inf @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Oboolean__algebra_14,axiom,
    ( boolean_algebra @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_15,axiom,
    ( order_bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Opreorder_16,axiom,
    ( preorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_17,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_18,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Obot_19,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Groups_Ouminus_20,axiom,
    ( uminus @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ? [A7: a,S4: ( stream170649215stream @ a )] :
      ( ( sa
        = ( stream641971652_SCons @ a @ A7 @ S4 ) )
      & ( member @ a @ A7 @ a2 )
      & ( ? [Sa: ( stream170649215stream @ a )] :
            ( ( S4 = Sa )
            & ( ord_less_eq @ ( set @ a ) @ ( stream30925839e_sset @ a @ Sa ) @ a2 ) )
        | ( member @ ( stream170649215stream @ a ) @ S4 @ ( stream2015131171treams @ a @ a2 ) ) ) ) )).

%------------------------------------------------------------------------------
