%------------------------------------------------------------------------------
% File     : DAT247^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Infinite streams (sequences/lists) 202
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream__202.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  436 (   0 unit;  88 type;   0 defn)
%            Number of atoms       : 4650 ( 360 equality;2701 variable)
%            Maximal formula depth :   22 (   8 average)
%            Number of connectives : 3877 (  58   ~;   6   |;  55   &;3544   @)
%                                         (   0 <=>; 214  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  429 ( 429   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   92 (  88   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1134 (   3 sgn;1015   !;  10   ?;  27   ^)
%                                         (1134   :;  82  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:17.469
%------------------------------------------------------------------------------
%----Could-be-implicit typings (15)
thf(ty_t_Stream__Mirabelle__hbrgyiwlrc_Ostream,type,(
    stream170649215stream: $tType > $tType )).

thf(ty_t_Record_Otuple__isomorphism,type,(
    tuple_isomorphism: $tType > $tType > $tType > $tType )).

thf(ty_t_Code__Numeral_Onatural,type,(
    code_natural: $tType )).

thf(ty_t_Code__Evaluation_Oterm,type,(
    code_term: $tType )).

thf(ty_t_Product__Type_Ounit,type,(
    product_unit: $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Typerep_Otyperep,type,(
    typerep: $tType )).

thf(ty_t_String_Oliteral,type,(
    literal: $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (73)
thf(sy_cl_Enum_Oenum,type,(
    enum: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Typerep_Otyperep,type,(
    typerep2: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Oequal,type,(
    cl_HOL_Oequal: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Code__Evaluation_Oterm__of,type,(
    code_term_of: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Nat_Osize,type,(
    size: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ozero,type,(
    zero: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ogroup__add,type,(
    group_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Osemiring__1,type,(
    semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Omonoid__add,type,(
    monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Osemigroup__add,type,(
    semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Rings_Ocomm__semiring__1,type,(
    comm_semiring_1: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocomm__monoid__add,type,(
    comm_monoid_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oab__semigroup__add,type,(
    ab_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Quickcheck__Random_Orandom,type,(
    quickcheck_random: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,(
    cancel_semigroup_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,(
    cancel1352612707id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,(
    linord219039673up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,(
    ordere779506340up_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,(
    canoni770627133id_add: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,(
    semiri456707255roduct: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Basic__BNF__LFPs_Osum_Osize__sum,type,(
    basic_BNF_size_sum: 
      !>[A: $tType,B: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( sum_sum @ A @ B ) > nat ) )).

thf(sy_c_Code__Numeral_OSuc,type,(
    code_Suc: code_natural > code_natural )).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,(
    code_case_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,(
    code_rec_natural: 
      !>[T: $tType] :
        ( T > ( code_natural > T > T ) > code_natural > T ) )).

thf(sy_c_Code__Numeral_Onatural_Osize__natural,type,(
    code_size_natural: code_natural > nat )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Groups_Omonoid,type,(
    monoid: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Groups_Omonoid__axioms,type,(
    monoid_axioms: 
      !>[A: $tType] :
        ( ( A > A > A ) > A > $o ) )).

thf(sy_c_Groups_Oplus__class_Oplus,type,(
    plus_plus: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Groups_Osemigroup,type,(
    semigroup: 
      !>[A: $tType] :
        ( ( A > A > A ) > $o ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_HOL_Obool_Osize__bool,type,(
    size_bool: $o > nat )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,(
    semiri532925092at_aux: 
      !>[A: $tType] :
        ( ( A > A ) > nat > A > A ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Nat__Bijection_Otriangle,type,(
    nat_triangle: nat > nat )).

thf(sy_c_Option_Ooption_ONone,type,(
    none: 
      !>[A: $tType] :
        ( option @ A ) )).

thf(sy_c_Option_Ooption_OSome,type,(
    some: 
      !>[A: $tType] :
        ( A > ( option @ A ) ) )).

thf(sy_c_Option_Ooption_Osize__option,type,(
    size_option: 
      !>[A: $tType] :
        ( ( A > nat ) > ( option @ A ) > nat ) )).

thf(sy_c_Option_Othese,type,(
    these: 
      !>[A: $tType] :
        ( ( set @ ( option @ A ) ) > ( set @ A ) ) )).

thf(sy_c_Product__Type_OUnity,type,(
    product_Unity: product_unit )).

thf(sy_c_Product__Type_Oold_Obool_Orec__bool,type,(
    product_rec_bool: 
      !>[T: $tType] :
        ( T > T > $o > T ) )).

thf(sy_c_Product__Type_Oold_Ounit_Orec__unit,type,(
    product_rec_unit: 
      !>[T: $tType] :
        ( T > product_unit > T ) )).

thf(sy_c_Product__Type_Ounit_Osize__unit,type,(
    product_size_unit: product_unit > nat )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Record_Oiso__tuple__update__accessor__cong__assist,type,(
    iso_tu2017585022assist: 
      !>[B: $tType,A: $tType] :
        ( ( ( B > B ) > A > A ) > ( A > B ) > $o ) )).

thf(sy_c_Record_Oiso__tuple__update__accessor__eq__assist,type,(
    iso_tu2011167877assist: 
      !>[B: $tType,A: $tType] :
        ( ( ( B > B ) > A > A ) > ( A > B ) > A > ( B > B ) > A > B > $o ) )).

thf(sy_c_Record_Otuple__isomorphism_OTuple__Isomorphism,type,(
    tuple_742722141rphism: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > ( product_prod @ B @ C ) ) > ( ( product_prod @ B @ C ) > A ) > ( tuple_isomorphism @ A @ B @ C ) ) )).

thf(sy_c_Record_Otuple__isomorphism_Osize__tuple__isomorphism,type,(
    tuple_1907371454rphism: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( C > nat ) > ( tuple_isomorphism @ A @ B @ C ) > nat ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osdrop,type,(
    stream135081970_sdrop: 
      !>[A: $tType] :
        ( nat > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osmember,type,(
    stream1586597341member: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osnth,type,(
    stream370371455e_snth: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > nat > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_OSCons,type,(
    stream641971652_SCons: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocase__stream,type,(
    stream1342653232stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream170649215stream @ A ) > B ) > ( stream170649215stream @ A ) > B ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocorec__stream,type,(
    stream660621732stream: 
      !>[C: $tType,A: $tType] :
        ( ( C > A ) > ( C > $o ) > ( C > ( stream170649215stream @ A ) ) > ( C > C ) > C > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Oshd,type,(
    stream_Mirabelle_shd: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osmap,type,(
    stream2128578057e_smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream170649215stream @ A ) > ( stream170649215stream @ Aa ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osset,type,(
    stream30925839e_sset: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ostl,type,(
    stream_Mirabelle_stl: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostreams,type,(
    stream2015131171treams: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( stream170649215stream @ A ) ) ) )).

thf(sy_c_Sum__Type_OInl,type,(
    sum_Inl: 
      !>[A: $tType,B: $tType] :
        ( A > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_OInr,type,(
    sum_Inr: 
      !>[B: $tType,A: $tType] :
        ( B > ( sum_sum @ A @ B ) ) )).

thf(sy_c_Sum__Type_Omap__sum,type,(
    sum_map_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) ) )).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,(
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f,type,(
    f: b > a )).

thf(sy_v_n,type,(
    n: nat )).

thf(sy_v_s,type,(
    s: ( stream170649215stream @ b ) )).

%----Relevant facts (251)
thf(fact_0_snth__smap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S: ( stream170649215stream @ B ),N: nat] :
      ( ( stream370371455e_snth @ A @ ( stream2128578057e_smap @ B @ A @ F @ S ) @ N )
      = ( F @ ( stream370371455e_snth @ B @ S @ N ) ) ) )).

% snth_smap
thf(fact_1_stream_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ B @ ( stream2128578057e_smap @ A @ B @ F @ A2 ) )
      = ( F @ ( stream_Mirabelle_shd @ A @ A2 ) ) ) )).

% stream.map_sel(1)
thf(fact_2_stream_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ B @ ( stream2128578057e_smap @ A @ B @ F @ A2 ) )
      = ( stream2128578057e_smap @ A @ B @ F @ ( stream_Mirabelle_stl @ A @ A2 ) ) ) )).

% stream.map_sel(2)
thf(fact_3_sdrop_Osimps_I1_J,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A )] :
      ( ( stream135081970_sdrop @ A @ ( zero_zero @ nat ) @ S )
      = S ) )).

% sdrop.simps(1)
thf(fact_4_smap__streams,axiom,(
    ! [A: $tType,B: $tType,S: ( stream170649215stream @ A ),A3: ( set @ A ),F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A3 ) )
     => ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( member @ B @ ( F @ X ) @ B2 ) )
       => ( member @ ( stream170649215stream @ B ) @ ( stream2128578057e_smap @ A @ B @ F @ S ) @ ( stream2015131171treams @ B @ B2 ) ) ) ) )).

% smap_streams
thf(fact_5_stream_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream170649215stream @ A ),Ya: ( stream170649215stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ Ya ) )
           => ( ( F @ Z )
              = ( G @ Z ) ) )
       => ( ( stream2128578057e_smap @ A @ B @ F @ X2 )
          = ( stream2128578057e_smap @ A @ B @ G @ Ya ) ) ) ) )).

% stream.map_cong
thf(fact_6_stream_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream170649215stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z: A] :
          ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ X2 ) )
         => ( ( F @ Z )
            = ( G @ Z ) ) )
     => ( ( stream2128578057e_smap @ A @ B @ F @ X2 )
        = ( stream2128578057e_smap @ A @ B @ G @ X2 ) ) ) )).

% stream.map_cong0
thf(fact_7_stream_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream170649215stream @ A ),Xa: ( stream170649215stream @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z: A,Za: A] :
          ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( stream30925839e_sset @ A @ Xa ) )
           => ( ( ( F @ Z )
                = ( Fa @ Za ) )
             => ( Z = Za ) ) ) )
     => ( ( ( stream2128578057e_smap @ A @ B @ F @ X2 )
          = ( stream2128578057e_smap @ A @ B @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% stream.inj_map_strong
thf(fact_8_stream_Omap,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream2128578057e_smap @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = ( stream641971652_SCons @ B @ ( F @ X1 ) @ ( stream2128578057e_smap @ A @ B @ F @ X22 ) ) ) )).

% stream.map
thf(fact_9_stream_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,G: ( B > C ),F: ( A > B ),V: ( stream170649215stream @ A )] :
      ( ( stream2128578057e_smap @ B @ C @ G @ ( stream2128578057e_smap @ A @ B @ F @ V ) )
      = ( stream2128578057e_smap @ A @ C @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% stream.map_comp
thf(fact_10_stream_Omap__id,axiom,(
    ! [A: $tType,T2: ( stream170649215stream @ A )] :
      ( ( stream2128578057e_smap @ A @ A @ ( id @ A ) @ T2 )
      = T2 ) )).

% stream.map_id
thf(fact_11_sdrop__simps_I1_J,axiom,(
    ! [A: $tType,N: nat,S: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream135081970_sdrop @ A @ N @ S ) )
      = ( stream370371455e_snth @ A @ S @ N ) ) )).

% sdrop_simps(1)
thf(fact_12_stream_Oinject,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A ),Y1: A,Y2: ( stream170649215stream @ A )] :
      ( ( ( stream641971652_SCons @ A @ X1 @ X22 )
        = ( stream641971652_SCons @ A @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y2 ) ) ) )).

% stream.inject
thf(fact_13_stream_Ocollapse,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) )
      = Stream ) )).

% stream.collapse
thf(fact_14_snth_Osimps_I1_J,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A )] :
      ( ( stream370371455e_snth @ A @ S @ ( zero_zero @ nat ) )
      = ( stream_Mirabelle_shd @ A @ S ) ) )).

% snth.simps(1)
thf(fact_15_stream_Osel_I2_J,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = X22 ) )).

% stream.sel(2)
thf(fact_16_stream_Osel_I1_J,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = X1 ) )).

% stream.sel(1)
thf(fact_17_stream_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,A22: ( stream170649215stream @ A ),A1: A] :
      ( ( member @ A @ X2 @ ( stream30925839e_sset @ A @ A22 ) )
     => ( member @ A @ X2 @ ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ A1 @ A22 ) ) ) ) )).

% stream.set_intros(2)
thf(fact_18_stream_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( stream170649215stream @ A )] :
      ( member @ A @ A1 @ ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ A1 @ A22 ) ) ) )).

% stream.set_intros(1)
thf(fact_19_snth__in,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),X3: ( set @ A ),N: nat] :
      ( ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ X3 ) )
     => ( member @ A @ ( stream370371455e_snth @ A @ S @ N ) @ X3 ) ) )).

% snth_in
thf(fact_20_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream170649215stream @ A )] :
      ( member @ A @ ( stream_Mirabelle_shd @ A @ A2 ) @ ( stream30925839e_sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_21_stl__sset,axiom,(
    ! [A: $tType,X2: A,A2: ( stream170649215stream @ A )] :
      ( ( member @ A @ X2 @ ( stream30925839e_sset @ A @ ( stream_Mirabelle_stl @ A @ A2 ) ) )
     => ( member @ A @ X2 @ ( stream30925839e_sset @ A @ A2 ) ) ) )).

% stl_sset
thf(fact_22_streamsE,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A3 ) )
     => ~ ( ( member @ A @ ( stream_Mirabelle_shd @ A @ S ) @ A3 )
         => ~ ( member @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S ) @ ( stream2015131171treams @ A @ A3 ) ) ) ) )).

% streamsE
thf(fact_23_snth__sset,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),N: nat] :
      ( member @ A @ ( stream370371455e_snth @ A @ S @ N ) @ ( stream30925839e_sset @ A @ S ) ) )).

% snth_sset
thf(fact_24_in__streams,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),S2: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S ) @ ( stream2015131171treams @ A @ S2 ) )
     => ( ( member @ A @ ( stream_Mirabelle_shd @ A @ S ) @ S2 )
       => ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ S2 ) ) ) ) )).

% in_streams
thf(fact_25_sset__induct,axiom,(
    ! [A: $tType,Y: A,S: ( stream170649215stream @ A ),P: ( A > ( stream170649215stream @ A ) > $o )] :
      ( ( member @ A @ Y @ ( stream30925839e_sset @ A @ S ) )
     => ( ! [S3: ( stream170649215stream @ A )] :
            ( P @ ( stream_Mirabelle_shd @ A @ S3 ) @ S3 )
       => ( ! [S3: ( stream170649215stream @ A ),Y3: A] :
              ( ( member @ A @ Y3 @ ( stream30925839e_sset @ A @ ( stream_Mirabelle_stl @ A @ S3 ) ) )
             => ( ( P @ Y3 @ ( stream_Mirabelle_stl @ A @ S3 ) )
               => ( P @ Y3 @ S3 ) ) )
         => ( P @ Y @ S ) ) ) ) )).

% sset_induct
thf(fact_26_streams__shd,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A3 ) )
     => ( member @ A @ ( stream_Mirabelle_shd @ A @ S ) @ A3 ) ) )).

% streams_shd
thf(fact_27_streams__stl,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A3 ) )
     => ( member @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S ) @ ( stream2015131171treams @ A @ A3 ) ) ) )).

% streams_stl
thf(fact_28_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( ( ( stream_Mirabelle_shd @ A @ Stream )
          = ( stream_Mirabelle_shd @ A @ Stream2 ) )
        & ( ( stream_Mirabelle_stl @ A @ Stream )
          = ( stream_Mirabelle_stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_29_streams_Ocases,axiom,(
    ! [A: $tType,A2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ A2 @ ( stream2015131171treams @ A @ A3 ) )
     => ~ ( ! [A4: A,S3: ( stream170649215stream @ A )] :
              ( ( A2
                = ( stream641971652_SCons @ A @ A4 @ S3 ) )
             => ( ( member @ A @ A4 @ A3 )
               => ~ ( member @ ( stream170649215stream @ A ) @ S3 @ ( stream2015131171treams @ A @ A3 ) ) ) ) ) ) )).

% streams.cases
thf(fact_30_streams_Osimps,axiom,(
    ! [A: $tType,A2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ A2 @ ( stream2015131171treams @ A @ A3 ) )
      = ( ? [A5: A,S4: ( stream170649215stream @ A )] :
            ( ( A2
              = ( stream641971652_SCons @ A @ A5 @ S4 ) )
            & ( member @ A @ A5 @ A3 )
            & ( member @ ( stream170649215stream @ A ) @ S4 @ ( stream2015131171treams @ A @ A3 ) ) ) ) ) )).

% streams.simps
thf(fact_31_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream170649215stream @ A )] :
      ~ ( ! [X12: A,X23: ( stream170649215stream @ A )] :
            ( Y
           != ( stream641971652_SCons @ A @ X12 @ X23 ) ) ) )).

% stream.exhaust
thf(fact_32_streams__Stream,axiom,(
    ! [A: $tType,X2: A,S: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ ( stream641971652_SCons @ A @ X2 @ S ) @ ( stream2015131171treams @ A @ A3 ) )
      = ( ( member @ A @ X2 @ A3 )
        & ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A3 ) ) ) ) )).

% streams_Stream
thf(fact_33_stream_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_34_stream_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( stream170649215stream @ A )] :
      ( ( member @ A @ E @ ( stream30925839e_sset @ A @ A2 ) )
     => ( ! [Z2: ( stream170649215stream @ A )] :
            ( A2
           != ( stream641971652_SCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( stream170649215stream @ A )] :
                ( ( A2
                  = ( stream641971652_SCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( stream30925839e_sset @ A @ Z2 ) ) ) ) ) ) )).

% stream.set_cases
thf(fact_35_streams_Ocoinduct,axiom,(
    ! [A: $tType,X3: ( ( stream170649215stream @ A ) > $o ),X2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( X3 @ X2 )
     => ( ! [X: ( stream170649215stream @ A )] :
            ( ( X3 @ X )
           => ? [A6: A,S5: ( stream170649215stream @ A )] :
                ( ( X
                  = ( stream641971652_SCons @ A @ A6 @ S5 ) )
                & ( member @ A @ A6 @ A3 )
                & ( ( X3 @ S5 )
                  | ( member @ ( stream170649215stream @ A ) @ S5 @ ( stream2015131171treams @ A @ A3 ) ) ) ) )
       => ( member @ ( stream170649215stream @ A ) @ X2 @ ( stream2015131171treams @ A @ A3 ) ) ) ) )).

% streams.coinduct
thf(fact_36_streams__iff__snth,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),X3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ X3 ) )
      = ( ! [N2: nat] :
            ( member @ A @ ( stream370371455e_snth @ A @ S @ N2 ) @ X3 ) ) ) )).

% streams_iff_snth
thf(fact_37_stream_Oset__induct,axiom,(
    ! [A: $tType,X2: A,A2: ( stream170649215stream @ A ),P: ( A > ( stream170649215stream @ A ) > $o )] :
      ( ( member @ A @ X2 @ ( stream30925839e_sset @ A @ A2 ) )
     => ( ! [Z1: A,Z2: ( stream170649215stream @ A )] :
            ( P @ Z1 @ ( stream641971652_SCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( stream170649215stream @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( stream30925839e_sset @ A @ Z2 ) )
             => ( ( P @ Xa2 @ Z2 )
               => ( P @ Xa2 @ ( stream641971652_SCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P @ X2 @ A2 ) ) ) ) )).

% stream.set_induct
thf(fact_38_stream_Oexhaust__sel,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( Stream
      = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) )).

% stream.exhaust_sel
thf(fact_39_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) )
                | ( ( stream_Mirabelle_stl @ A @ Stream3 )
                  = ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_40_smap__ctr,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),S: ( stream170649215stream @ B ),X2: A,S6: ( stream170649215stream @ A )] :
      ( ( ( stream2128578057e_smap @ B @ A @ F @ S )
        = ( stream641971652_SCons @ A @ X2 @ S6 ) )
      = ( ( ( F @ ( stream_Mirabelle_shd @ B @ S ) )
          = X2 )
        & ( ( stream2128578057e_smap @ B @ A @ F @ ( stream_Mirabelle_stl @ B @ S ) )
          = S6 ) ) ) )).

% smap_ctr
thf(fact_41_stream_Omap__id0,axiom,(
    ! [A: $tType] :
      ( ( stream2128578057e_smap @ A @ A @ ( id @ A ) )
      = ( id @ ( stream170649215stream @ A ) ) ) )).

% stream.map_id0
thf(fact_42_comp__id,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B )] :
      ( ( comp @ A @ B @ A @ F @ ( id @ A ) )
      = F ) )).

% comp_id
thf(fact_43_id__comp,axiom,(
    ! [B: $tType,A: $tType,G: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G )
      = G ) )).

% id_comp
thf(fact_44_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X4: A] :
            ( member @ A @ X4 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X: A] :
          ( ( P @ X )
          = ( Q @ X ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X: A] :
          ( ( F @ X )
          = ( G @ X ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X4: A] : X4 ) ) )).

% id_apply
thf(fact_50_smember__code,axiom,(
    ! [A: $tType,X2: A,Y: A,S: ( stream170649215stream @ A )] :
      ( ( stream1586597341member @ A @ X2 @ ( stream641971652_SCons @ A @ Y @ S ) )
      = ( ( X2 != Y )
       => ( stream1586597341member @ A @ X2 @ S ) ) ) )).

% smember_code
thf(fact_51_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F2: ( B > A ),G2: ( C > B ),X4: C] :
            ( F2 @ ( G2 @ X4 ) ) ) ) )).

% comp_apply
thf(fact_52_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B3: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B3 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C2 ) )
     => ( ( A2 @ ( B3 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_53_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_54_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),G: ( A > B ),X2: A] :
      ( ( ( comp @ B @ A @ A @ F @ G )
        = ( id @ A ) )
     => ( ( F @ ( G @ X2 ) )
        = X2 ) ) )).

% pointfree_idE
thf(fact_55_stream_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P @ ( stream1342653232stream @ A @ B @ F @ Stream ) )
      = ( ( Stream
          = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
       => ( P @ ( F @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) )).

% stream.split_sel
thf(fact_56_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( stream170649215stream @ A ) > B ),X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream1342653232stream @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = ( F @ X1 @ X22 ) ) )).

% stream.case
thf(fact_57_zero__reorient,axiom,(
    ! [A: $tType] :
      ( ( zero @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( ( zero_zero @ A )
            = X2 )
          = ( X2
            = ( zero_zero @ A ) ) ) ) )).

% zero_reorient
thf(fact_58_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E2: $tType,D: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F: ( B > E2 ),L: ( D > E2 )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E2 @ D @ F @ R1 )
          = L )
       => ( ( comp @ C @ E2 @ A @ ( comp @ B @ E2 @ C @ F @ G ) @ H )
          = ( comp @ D @ E2 @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_59_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E2: $tType,F: ( C > B ),G: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E2 > A ),R3: ( E2 > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E2 @ L2 @ H )
          = R3 )
       => ( ( comp @ C @ B @ E2 @ F @ ( comp @ A @ C @ E2 @ G @ H ) )
          = ( comp @ D @ B @ E2 @ L1 @ R3 ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_60_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: ( C > B ),H: ( A > C ),R3: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G @ H )
        = R3 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G ) @ H )
        = ( comp @ B @ D @ A @ F @ R3 ) ) ) )).

% rewriteR_comp_comp
thf(fact_61_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_62_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_63_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B3: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B3 )
        = C2 )
     => ( ( A2 @ ( B3 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_64_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B3: ( A > C ),C2: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B3 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B3 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_65_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B3: ( A > C ),C2: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B3 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A2 @ ( B3 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_66_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G @ H ) ) ) )).

% comp_assoc
thf(fact_67_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F2: ( B > C ),G2: ( A > B ),X4: A] :
            ( F2 @ ( G2 @ X4 ) ) ) ) )).

% comp_def
thf(fact_68_eq__id__iff,axiom,(
    ! [A: $tType,F: ( A > A )] :
      ( ( ! [X4: A] :
            ( ( F @ X4 )
            = X4 ) )
      = ( F
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_69_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X4: A] : X4 ) ) )).

% id_def
thf(fact_70_Stream__Mirabelle__hbrgyiwlrc_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( stream1586597341member @ A )
      = ( ^ [X4: A,S4: ( stream170649215stream @ A )] :
            ( member @ A @ X4 @ ( stream30925839e_sset @ A @ S4 ) ) ) ) )).

% Stream_Mirabelle_hbrgyiwlrc.smember_def
thf(fact_71_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( stream1342653232stream @ A @ B )
      = ( ^ [F2: ( A > ( stream170649215stream @ A ) > B ),Stream5: ( stream170649215stream @ A )] :
            ( F2 @ ( stream_Mirabelle_shd @ A @ Stream5 ) @ ( stream_Mirabelle_stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_72_stream_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P @ ( stream1342653232stream @ A @ B @ F @ Stream ) )
      = ( ~ ( ( Stream
              = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
            & ~ ( P @ ( F @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) ) )).

% stream.split_sel_asm
thf(fact_73_stream_Omap__o__corec,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > A ),Ga: ( C > $o ),Gb: ( C > ( stream170649215stream @ A ) ),Gc: ( C > C )] :
      ( ( comp @ ( stream170649215stream @ A ) @ ( stream170649215stream @ B ) @ C @ ( stream2128578057e_smap @ A @ B @ F ) @ ( stream660621732stream @ C @ A @ G @ Ga @ Gb @ Gc ) )
      = ( stream660621732stream @ C @ B @ ( comp @ A @ B @ C @ F @ G ) @ Ga @ ( comp @ ( stream170649215stream @ A ) @ ( stream170649215stream @ B ) @ C @ ( stream2128578057e_smap @ A @ B @ F ) @ Gb ) @ Gc ) ) )).

% stream.map_o_corec
thf(fact_74_sdrop__simps_I2_J,axiom,(
    ! [A: $tType,N: nat,S: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream135081970_sdrop @ A @ N @ S ) )
      = ( stream135081970_sdrop @ A @ ( suc @ N ) @ S ) ) )).

% sdrop_simps(2)
thf(fact_75_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E2: $tType,A: $tType,C: $tType,M: ( B > A ),G: ( C > B ),X2: C,N3: ( D > A ),H: ( C > D ),F: ( A > E2 )] :
      ( ( ( M @ ( G @ X2 ) )
        = ( N3 @ ( H @ X2 ) ) )
     => ( ( comp @ B @ E2 @ C @ ( comp @ A @ E2 @ B @ F @ M ) @ G @ X2 )
        = ( comp @ D @ E2 @ C @ ( comp @ A @ E2 @ D @ F @ N3 ) @ H @ X2 ) ) ) )).

% type_copy_map_cong0
thf(fact_76_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G: ( C > B ),X2: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G @ X2 ) )
        = ( H @ ( K @ X2 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ C @ H @ K @ X2 ) ) ) )).

% comp_apply_eq
thf(fact_77_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E2: $tType,F: ( B > A ),G: ( C > B ),X2: C,F3: ( D > A ),G3: ( E2 > D ),X5: E2] :
      ( ( ( F @ ( G @ X2 ) )
        = ( F3 @ ( G3 @ X5 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G @ X2 )
        = ( comp @ D @ A @ E2 @ F3 @ G3 @ X5 ) ) ) )).

% comp_cong
thf(fact_78_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) )).

% zero_natural.rsp
thf(fact_79_nat_Oinject,axiom,(
    ! [X22: nat,Y2: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y2 ) )
      = ( X22 = Y2 ) ) )).

% nat.inject
thf(fact_80_old_Onat_Oinject,axiom,(
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) )).

% old.nat.inject
thf(fact_81_not0__implies__Suc,axiom,(
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M2: nat] :
          ( N
          = ( suc @ M2 ) ) ) )).

% not0_implies_Suc
thf(fact_82_old_Onat_Oinducts,axiom,(
    ! [P: ( nat > $o ),Nat: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [Nat3: nat] :
            ( ( P @ Nat3 )
           => ( P @ ( suc @ Nat3 ) ) )
       => ( P @ Nat ) ) ) )).

% old.nat.inducts
thf(fact_83_old_Onat_Oexhaust,axiom,(
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ( ! [Nat3: nat] :
              ( Y
             != ( suc @ Nat3 ) ) ) ) )).

% old.nat.exhaust
thf(fact_84_Zero__not__Suc,axiom,(
    ! [M3: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M3 ) ) )).

% Zero_not_Suc
thf(fact_85_Zero__neq__Suc,axiom,(
    ! [M3: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M3 ) ) )).

% Zero_neq_Suc
thf(fact_86_Suc__neq__Zero,axiom,(
    ! [M3: nat] :
      ( ( suc @ M3 )
     != ( zero_zero @ nat ) ) )).

% Suc_neq_Zero
thf(fact_87_zero__induct,axiom,(
    ! [P: ( nat > $o ),K: nat] :
      ( ( P @ K )
     => ( ! [N4: nat] :
            ( ( P @ ( suc @ N4 ) )
           => ( P @ N4 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) )).

% zero_induct
thf(fact_88_diff__induct,axiom,(
    ! [P: ( nat > nat > $o ),M3: nat,N: nat] :
      ( ! [X: nat] :
          ( P @ X @ ( zero_zero @ nat ) )
     => ( ! [Y3: nat] :
            ( P @ ( zero_zero @ nat ) @ ( suc @ Y3 ) )
       => ( ! [X: nat,Y3: nat] :
              ( ( P @ X @ Y3 )
             => ( P @ ( suc @ X ) @ ( suc @ Y3 ) ) )
         => ( P @ M3 @ N ) ) ) ) )).

% diff_induct
thf(fact_89_nat__induct,axiom,(
    ! [P: ( nat > $o ),N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N4: nat] :
            ( ( P @ N4 )
           => ( P @ ( suc @ N4 ) ) )
       => ( P @ N ) ) ) )).

% nat_induct
thf(fact_90_nat_OdiscI,axiom,(
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) )).

% nat.discI
thf(fact_91_old_Onat_Odistinct_I1_J,axiom,(
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) )).

% old.nat.distinct(1)
thf(fact_92_old_Onat_Odistinct_I2_J,axiom,(
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) )).

% old.nat.distinct(2)
thf(fact_93_nat_Odistinct_I1_J,axiom,(
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) )).

% nat.distinct(1)
thf(fact_94_Suc__inject,axiom,(
    ! [X2: nat,Y: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y ) )
     => ( X2 = Y ) ) )).

% Suc_inject
thf(fact_95_n__not__Suc__n,axiom,(
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) )).

% n_not_Suc_n
thf(fact_96_stream_Ocorec__disc,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( stream660621732stream @ C @ A )
      = ( stream660621732stream @ C @ A ) ) )).

% stream.corec_disc
thf(fact_97_stream_Ocorec__code,axiom,(
    ! [A: $tType,C: $tType] :
      ( ( stream660621732stream @ C @ A )
      = ( ^ [G1: ( C > A ),Q2: ( C > $o ),G21: ( C > ( stream170649215stream @ A ) ),G22: ( C > C ),A5: C] :
            ( stream641971652_SCons @ A @ ( G1 @ A5 ) @ ( if @ ( stream170649215stream @ A ) @ ( Q2 @ A5 ) @ ( G21 @ A5 ) @ ( stream660621732stream @ C @ A @ G1 @ Q2 @ G21 @ G22 @ ( G22 @ A5 ) ) ) ) ) ) )).

% stream.corec_code
thf(fact_98_stream_Ocorec__sel_I2_J,axiom,(
    ! [A: $tType,C: $tType,Q22: ( C > $o ),A2: C,G12: ( C > A ),G212: ( C > ( stream170649215stream @ A ) ),G222: ( C > C )] :
      ( ( ( Q22 @ A2 )
       => ( ( stream_Mirabelle_stl @ A @ ( stream660621732stream @ C @ A @ G12 @ Q22 @ G212 @ G222 @ A2 ) )
          = ( G212 @ A2 ) ) )
      & ( ~ ( Q22 @ A2 )
       => ( ( stream_Mirabelle_stl @ A @ ( stream660621732stream @ C @ A @ G12 @ Q22 @ G212 @ G222 @ A2 ) )
          = ( stream660621732stream @ C @ A @ G12 @ Q22 @ G212 @ G222 @ ( G222 @ A2 ) ) ) ) ) )).

% stream.corec_sel(2)
thf(fact_99_stream_Ocorec__sel_I1_J,axiom,(
    ! [A: $tType,C: $tType,G12: ( C > A ),Q22: ( C > $o ),G212: ( C > ( stream170649215stream @ A ) ),G222: ( C > C ),A2: C] :
      ( ( stream_Mirabelle_shd @ A @ ( stream660621732stream @ C @ A @ G12 @ Q22 @ G212 @ G222 @ A2 ) )
      = ( G12 @ A2 ) ) )).

% stream.corec_sel(1)
thf(fact_100_snth__Stream,axiom,(
    ! [A: $tType,X2: A,S: ( stream170649215stream @ A ),I: nat] :
      ( ( stream370371455e_snth @ A @ ( stream641971652_SCons @ A @ X2 @ S ) @ ( suc @ I ) )
      = ( stream370371455e_snth @ A @ S @ I ) ) )).

% snth_Stream
thf(fact_101_snth_Osimps_I2_J,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),N: nat] :
      ( ( stream370371455e_snth @ A @ S @ ( suc @ N ) )
      = ( stream370371455e_snth @ A @ ( stream_Mirabelle_stl @ A @ S ) @ N ) ) )).

% snth.simps(2)
thf(fact_102_sdrop_Osimps_I2_J,axiom,(
    ! [A: $tType,N: nat,S: ( stream170649215stream @ A )] :
      ( ( stream135081970_sdrop @ A @ ( suc @ N ) @ S )
      = ( stream135081970_sdrop @ A @ N @ ( stream_Mirabelle_stl @ A @ S ) ) ) )).

% sdrop.simps(2)
thf(fact_103_dependent__nat__choice,axiom,(
    ! [A: $tType,P: ( nat > A > $o ),Q: ( nat > A > A > $o )] :
      ( ? [X13: A] :
          ( P @ ( zero_zero @ nat ) @ X13 )
     => ( ! [X: A,N4: nat] :
            ( ( P @ N4 @ X )
           => ? [Y4: A] :
                ( ( P @ ( suc @ N4 ) @ Y4 )
                & ( Q @ N4 @ X @ Y4 ) ) )
       => ? [F4: ( nat > A )] :
          ! [N5: nat] :
            ( ( P @ N5 @ ( F4 @ N5 ) )
            & ( Q @ N5 @ ( F4 @ N5 ) @ ( F4 @ ( suc @ N5 ) ) ) ) ) ) )).

% dependent_nat_choice
thf(fact_104_list__decode_Ocases,axiom,(
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ~ ( ! [N4: nat] :
              ( X2
             != ( suc @ N4 ) ) ) ) )).

% list_decode.cases
thf(fact_105_natural_Osize_I1_J,axiom,
    ( ( code_size_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(1)
thf(fact_106_natural_Osize_I3_J,axiom,
    ( ( size_size @ code_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) )).

% natural.size(3)
thf(fact_107_card_Ocomp__fun__commute,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) )).

% card.comp_fun_commute
thf(fact_108_of__nat__aux_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [Inc: ( A > A ),I: A] :
          ( ( semiri532925092at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) )).

% of_nat_aux.simps(1)
thf(fact_109_of__nat__aux_Osimps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( semiring_1 @ A @ ( type2 @ A ) )
     => ! [Inc: ( A > A ),N: nat,I: A] :
          ( ( semiri532925092at_aux @ A @ Inc @ ( suc @ N ) @ I )
          = ( semiri532925092at_aux @ A @ Inc @ N @ ( Inc @ I ) ) ) ) )).

% of_nat_aux.simps(2)
thf(fact_110_natural_Osimps_I4_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T )] :
      ( ( code_case_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(4)
thf(fact_111_natural_Osimps_I6_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T > T )] :
      ( ( code_rec_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) )).

% natural.simps(6)
thf(fact_112_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) )).

% triangle_0
thf(fact_113_size__ne__size__imp__ne,axiom,(
    ! [A: $tType] :
      ( ( size @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ( size_size @ A @ X2 )
           != ( size_size @ A @ Y ) )
         => ( X2 != Y ) ) ) )).

% size_ne_size_imp_ne
thf(fact_114_stream_Oset,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = ( insert @ A @ X1 @ ( stream30925839e_sset @ A @ X22 ) ) ) )).

% stream.set
thf(fact_115_insertCI,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A2 @ B2 )
       => ( A2 = B3 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertCI
thf(fact_116_insert__iff,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B3 @ A3 ) )
      = ( ( A2 = B3 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_117_insert__absorb2,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ X2 @ A3 ) )
      = ( insert @ A @ X2 @ A3 ) ) )).

% insert_absorb2
thf(fact_118_bool_Osize_I4_J,axiom,
    ( ( size_size @ $o @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(4)
thf(fact_119_bool_Osize_I3_J,axiom,
    ( ( size_size @ $o @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(3)
thf(fact_120_prod_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ A @ B )] :
      ( ( size_size @ ( product_prod @ A @ B ) @ X2 )
     != ( zero_zero @ nat ) ) )).

% prod.size_neq
thf(fact_121_sum_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,X2: ( sum_sum @ A @ B )] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ X2 )
     != ( zero_zero @ nat ) ) )).

% sum.size_neq
thf(fact_122_size__bool,axiom,
    ( ( size_size @ $o )
    = ( ^ [B4: $o] :
          ( zero_zero @ nat ) ) )).

% size_bool
thf(fact_123_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ? [B5: ( set @ A )] :
          ( ( A3
            = ( insert @ A @ A2 @ B5 ) )
          & ~ ( member @ A @ A2 @ B5 ) ) ) )).

% mk_disjoint_insert
thf(fact_124_insert__commute,axiom,(
    ! [A: $tType,X2: A,Y: A,A3: ( set @ A )] :
      ( ( insert @ A @ X2 @ ( insert @ A @ Y @ A3 ) )
      = ( insert @ A @ Y @ ( insert @ A @ X2 @ A3 ) ) ) )).

% insert_commute
thf(fact_125_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B3: A,B2: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ B3 @ B2 )
       => ( ( ( insert @ A @ A2 @ A3 )
            = ( insert @ A @ B3 @ B2 ) )
          = ( ( ( A2 = B3 )
             => ( A3 = B2 ) )
            & ( ( A2 != B3 )
             => ? [C3: ( set @ A )] :
                  ( ( A3
                    = ( insert @ A @ B3 @ C3 ) )
                  & ~ ( member @ A @ B3 @ C3 )
                  & ( B2
                    = ( insert @ A @ A2 @ C3 ) )
                  & ~ ( member @ A @ A2 @ C3 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_126_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ A3 )
        = A3 ) ) )).

% insert_absorb
thf(fact_127_insert__ident,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ~ ( member @ A @ X2 @ B2 )
       => ( ( ( insert @ A @ X2 @ A3 )
            = ( insert @ A @ X2 @ B2 ) )
          = ( A3 = B2 ) ) ) ) )).

% insert_ident
thf(fact_128_Set_Oset__insert,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A )] :
      ( ( member @ A @ X2 @ A3 )
     => ~ ( ! [B5: ( set @ A )] :
              ( ( A3
                = ( insert @ A @ X2 @ B5 ) )
             => ( member @ A @ X2 @ B5 ) ) ) ) )).

% Set.set_insert
thf(fact_129_insertI2,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),B3: A] :
      ( ( member @ A @ A2 @ B2 )
     => ( member @ A @ A2 @ ( insert @ A @ B3 @ B2 ) ) ) )).

% insertI2
thf(fact_130_insertI1,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B2 ) ) )).

% insertI1
thf(fact_131_insertE,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B3 @ A3 ) )
     => ( ( A2 != B3 )
       => ( member @ A @ A2 @ A3 ) ) ) )).

% insertE
thf(fact_132_bool_Osize_I1_J,axiom,
    ( ( size_bool @ $true )
    = ( zero_zero @ nat ) )).

% bool.size(1)
thf(fact_133_bool_Osize_I2_J,axiom,
    ( ( size_bool @ $false )
    = ( zero_zero @ nat ) )).

% bool.size(2)
thf(fact_134_size__bool__overloaded__def,axiom,
    ( ( size_size @ $o )
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_overloaded_def
thf(fact_135_natural_Osimps_I5_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T ),Natural: code_natural] :
      ( ( code_case_natural @ T @ F1 @ F22 @ ( code_Suc @ Natural ) )
      = ( F22 @ Natural ) ) )).

% natural.simps(5)
thf(fact_136_natural_Oinject,axiom,(
    ! [Natural: code_natural,Natural2: code_natural] :
      ( ( ( code_Suc @ Natural )
        = ( code_Suc @ Natural2 ) )
      = ( Natural = Natural2 ) ) )).

% natural.inject
thf(fact_137_natural_Osimps_I7_J,axiom,(
    ! [T: $tType,F1: T,F22: ( code_natural > T > T ),Natural: code_natural] :
      ( ( code_rec_natural @ T @ F1 @ F22 @ ( code_Suc @ Natural ) )
      = ( F22 @ Natural @ ( code_rec_natural @ T @ F1 @ F22 @ Natural ) ) ) )).

% natural.simps(7)
thf(fact_138_size__bool__def,axiom,
    ( size_bool
    = ( product_rec_bool @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) )).

% size_bool_def
thf(fact_139_natural_Oinducts,axiom,(
    ! [P: ( code_natural > $o ),Natural: code_natural] :
      ( ( P @ ( zero_zero @ code_natural ) )
     => ( ! [Natural3: code_natural] :
            ( ( P @ Natural3 )
           => ( P @ ( code_Suc @ Natural3 ) ) )
       => ( P @ Natural ) ) ) )).

% natural.inducts
thf(fact_140_natural_Oexhaust,axiom,(
    ! [Y: code_natural] :
      ( ( Y
       != ( zero_zero @ code_natural ) )
     => ~ ( ! [Natural3: code_natural] :
              ( Y
             != ( code_Suc @ Natural3 ) ) ) ) )).

% natural.exhaust
thf(fact_141_natural_Odistinct_I1_J,axiom,(
    ! [Natural2: code_natural] :
      ( ( zero_zero @ code_natural )
     != ( code_Suc @ Natural2 ) ) )).

% natural.distinct(1)
thf(fact_142_natural_Odistinct_I2_J,axiom,(
    ! [Natural4: code_natural] :
      ( ( code_Suc @ Natural4 )
     != ( zero_zero @ code_natural ) ) )).

% natural.distinct(2)
thf(fact_143_random__aux__set_Oinduct,axiom,(
    ! [B: $tType] :
      ( ( quickcheck_random @ B @ ( type2 @ B ) )
     => ! [P: ( code_natural > code_natural > $o ),A0: code_natural,A1: code_natural] :
          ( ! [X12: code_natural] :
              ( P @ ( zero_zero @ code_natural ) @ X12 )
         => ( ! [I2: code_natural,J: code_natural] :
                ( ! [X6: ( product_prod @ B @ ( product_unit > code_term ) )] :
                    ( P @ I2 @ J )
               => ( P @ ( code_Suc @ I2 ) @ J ) )
           => ( P @ A0 @ A1 ) ) ) ) )).

% random_aux_set.induct
thf(fact_144_random__aux__rec,axiom,(
    ! [A: $tType,Random_aux: ( code_natural > A ),Rhs: ( code_natural > A ),K: code_natural] :
      ( ( ( Random_aux @ ( zero_zero @ code_natural ) )
        = ( Rhs @ ( zero_zero @ code_natural ) ) )
     => ( ! [K2: code_natural] :
            ( ( Random_aux @ ( code_Suc @ K2 ) )
            = ( Rhs @ ( code_Suc @ K2 ) ) )
       => ( ( Random_aux @ K )
          = ( Rhs @ K ) ) ) ) )).

% random_aux_rec
thf(fact_145_natural_Osize_I2_J,axiom,(
    ! [Natural: code_natural] :
      ( ( code_size_natural @ ( code_Suc @ Natural ) )
      = ( plus_plus @ nat @ ( code_size_natural @ Natural ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% natural.size(2)
thf(fact_146_natural_Osize_I4_J,axiom,(
    ! [Natural: code_natural] :
      ( ( size_size @ code_natural @ ( code_Suc @ Natural ) )
      = ( plus_plus @ nat @ ( size_size @ code_natural @ Natural ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% natural.size(4)
thf(fact_147_add__left__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B3 = C2 ) ) ) )).

% add_left_cancel
thf(fact_148_add__right__cancel,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B3 = C2 ) ) ) )).

% add_right_cancel
thf(fact_149_add_Oleft__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.left_neutral
thf(fact_150_add_Oright__neutral,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.right_neutral
thf(fact_151_double__zero,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero
thf(fact_152_double__zero__sym,axiom,(
    ! [A: $tType] :
      ( ( linord219039673up_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% double_zero_sym
thf(fact_153_add__cancel__left__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = A2 )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_left
thf(fact_154_add__cancel__left__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = A2 )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_left_right
thf(fact_155_add__cancel__right__left,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( A2
            = ( plus_plus @ A @ B3 @ A2 ) )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_left
thf(fact_156_add__cancel__right__right,axiom,(
    ! [A: $tType] :
      ( ( cancel1352612707id_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B3 ) )
          = ( B3
            = ( zero_zero @ A ) ) ) ) )).

% add_cancel_right_right
thf(fact_157_add__Suc__right,axiom,(
    ! [M3: nat,N: nat] :
      ( ( plus_plus @ nat @ M3 @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M3 @ N ) ) ) )).

% add_Suc_right
thf(fact_158_Nat_Oadd__0__right,axiom,(
    ! [M3: nat] :
      ( ( plus_plus @ nat @ M3 @ ( zero_zero @ nat ) )
      = M3 ) )).

% Nat.add_0_right
thf(fact_159_add__is__0,axiom,(
    ! [M3: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M3 @ N )
        = ( zero_zero @ nat ) )
      = ( ( M3
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) )).

% add_is_0
thf(fact_160_triangle__Suc,axiom,(
    ! [N: nat] :
      ( ( nat_triangle @ ( suc @ N ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N ) @ ( suc @ N ) ) ) )).

% triangle_Suc
thf(fact_161_nat__add__left__cancel,axiom,(
    ! [K: nat,M3: nat,N: nat] :
      ( ( ( plus_plus @ nat @ K @ M3 )
        = ( plus_plus @ nat @ K @ N ) )
      = ( M3 = N ) ) )).

% nat_add_left_cancel
thf(fact_162_nat__add__right__cancel,axiom,(
    ! [M3: nat,K: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M3 @ K )
        = ( plus_plus @ nat @ N @ K ) )
      = ( M3 = N ) ) )).

% nat_add_right_cancel
thf(fact_163_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B3 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) )).

% ab_semigroup_add_class.add_ac(1)
thf(fact_164_add__mono__thms__linordered__semiring_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ordere779506340up_add @ A @ ( type2 @ A ) )
     => ! [I: A,J2: A,K: A,L: A] :
          ( ( ( I = J2 )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J2 @ L ) ) ) ) )).

% add_mono_thms_linordered_semiring(4)
thf(fact_165_add_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B3 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) )).

% add.assoc
thf(fact_166_add_Oleft__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B3 = C2 ) ) ) )).

% add.left_cancel
thf(fact_167_add_Oright__cancel,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B3 = C2 ) ) ) )).

% add.right_cancel
thf(fact_168_add_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ( ( plus_plus @ A )
        = ( ^ [A5: A,B4: A] :
              ( plus_plus @ A @ B4 @ A5 ) ) ) ) )).

% add.commute
thf(fact_169_add_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B3 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B3 @ C2 ) ) ) ) )).

% add.left_commute
thf(fact_170_add__left__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B3 = C2 ) ) ) )).

% add_left_imp_eq
thf(fact_171_add__right__imp__eq,axiom,(
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B3 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B3 = C2 ) ) ) )).

% add_right_imp_eq
thf(fact_172_add__eq__self__zero,axiom,(
    ! [M3: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M3 @ N )
        = M3 )
     => ( N
        = ( zero_zero @ nat ) ) ) )).

% add_eq_self_zero
thf(fact_173_plus__nat_Oadd__0,axiom,(
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) )).

% plus_nat.add_0
thf(fact_174_add__Suc__shift,axiom,(
    ! [M3: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M3 ) @ N )
      = ( plus_plus @ nat @ M3 @ ( suc @ N ) ) ) )).

% add_Suc_shift
thf(fact_175_add__Suc,axiom,(
    ! [M3: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M3 ) @ N )
      = ( suc @ ( plus_plus @ nat @ M3 @ N ) ) ) )).

% add_Suc
thf(fact_176_comm__monoid__add__class_Oadd__0,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% comm_monoid_add_class.add_0
thf(fact_177_add_Ocomm__neutral,axiom,(
    ! [A: $tType] :
      ( ( comm_monoid_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% add.comm_neutral
thf(fact_178_add_Ogroup__left__neutral,axiom,(
    ! [A: $tType] :
      ( ( group_add @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% add.group_left_neutral
thf(fact_179_add__eq__0__iff__both__eq__0,axiom,(
    ! [A: $tType] :
      ( ( canoni770627133id_add @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( ( plus_plus @ A @ X2 @ Y )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) )).

% add_eq_0_iff_both_eq_0
thf(fact_180_one__is__add,axiom,(
    ! [M3: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M3 @ N ) )
      = ( ( ( M3
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M3
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )).

% one_is_add
thf(fact_181_add__is__1,axiom,(
    ! [M3: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M3 @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M3
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M3
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )).

% add_is_1
thf(fact_182_add__0__iff,axiom,(
    ! [A: $tType] :
      ( ( semiri456707255roduct @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A] :
          ( ( B3
            = ( plus_plus @ A @ B3 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) )).

% add_0_iff
thf(fact_183_semiring__normalization__rules_I5_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) )).

% semiring_normalization_rules(5)
thf(fact_184_semiring__normalization__rules_I6_J,axiom,(
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) )).

% semiring_normalization_rules(6)
thf(fact_185_sum_Osize_I3_J,axiom,(
    ! [A: $tType,B: $tType,X1: A] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ ( sum_Inl @ A @ B @ X1 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% sum.size(3)
thf(fact_186_sum_Osize_I4_J,axiom,(
    ! [B: $tType,A: $tType,X22: B] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ ( sum_Inr @ B @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% sum.size(4)
thf(fact_187_Inl__Inr__False,axiom,(
    ! [A: $tType,B: $tType,X2: A,Y: B] :
      ( ( sum_Inl @ A @ B @ X2 )
     != ( sum_Inr @ B @ A @ Y ) ) )).

% Inl_Inr_False
thf(fact_188_Inr__Inl__False,axiom,(
    ! [B: $tType,A: $tType,X2: B,Y: A] :
      ( ( sum_Inr @ B @ A @ X2 )
     != ( sum_Inl @ A @ B @ Y ) ) )).

% Inr_Inl_False
thf(fact_189_obj__sumE__f,axiom,(
    ! [A: $tType,C: $tType,B: $tType,S: B,F: ( ( sum_sum @ A @ C ) > B ),P: $o] :
      ( ! [X: A] :
          ( ( S
            = ( F @ ( sum_Inl @ A @ C @ X ) ) )
         => P )
     => ( ! [X: C] :
            ( ( S
              = ( F @ ( sum_Inr @ C @ A @ X ) ) )
           => P )
       => ! [X6: ( sum_sum @ A @ C )] :
            ( ( S
              = ( F @ X6 ) )
           => P ) ) ) )).

% obj_sumE_f
thf(fact_190_sum_Osize__gen_I1_J,axiom,(
    ! [B: $tType,A: $tType,Xa: ( A > nat ),X2: ( B > nat ),X1: A] :
      ( ( basic_BNF_size_sum @ A @ B @ Xa @ X2 @ ( sum_Inl @ A @ B @ X1 ) )
      = ( plus_plus @ nat @ ( Xa @ X1 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% sum.size_gen(1)
thf(fact_191_sum_Osize__gen_I2_J,axiom,(
    ! [A: $tType,B: $tType,Xa: ( A > nat ),X2: ( B > nat ),X22: B] :
      ( ( basic_BNF_size_sum @ A @ B @ Xa @ X2 @ ( sum_Inr @ B @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X2 @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% sum.size_gen(2)
thf(fact_192_typerep_Osize__neq,axiom,(
    ! [X2: typerep] :
      ( ( size_size @ typerep @ X2 )
     != ( zero_zero @ nat ) ) )).

% typerep.size_neq
thf(fact_193_option_Osize__neq,axiom,(
    ! [A: $tType,X2: ( option @ A )] :
      ( ( size_size @ ( option @ A ) @ X2 )
     != ( zero_zero @ nat ) ) )).

% option.size_neq
thf(fact_194_option_Osize_I3_J,axiom,(
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% option.size(3)
thf(fact_195_option_Osize_I4_J,axiom,(
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% option.size(4)
thf(fact_196_option_Osize__gen_I2_J,axiom,(
    ! [A: $tType,X2: ( A > nat ),X22: A] :
      ( ( size_option @ A @ X2 @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X2 @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) )).

% option.size_gen(2)
thf(fact_197_option_Osize__gen_I1_J,axiom,(
    ! [A: $tType,X2: ( A > nat )] :
      ( ( size_option @ A @ X2 @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% option.size_gen(1)
thf(fact_198_these__insert__Some,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ ( option @ A ) )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( some @ A @ X2 ) @ A3 ) )
      = ( insert @ A @ X2 @ ( these @ A @ A3 ) ) ) )).

% these_insert_Some
thf(fact_199_size__literal__def,axiom,
    ( ( size_size @ literal )
    = ( ^ [S4: literal] :
          ( zero_zero @ nat ) ) )).

% size_literal_def
thf(fact_200_these__insert__None,axiom,(
    ! [A: $tType,A3: ( set @ ( option @ A ) )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( none @ A ) @ A3 ) )
      = ( these @ A @ A3 ) ) )).

% these_insert_None
thf(fact_201_tuple__isomorphism_Osize__neq,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X2: ( tuple_isomorphism @ A @ B @ C )] :
      ( ( size_size @ ( tuple_isomorphism @ A @ B @ C ) @ X2 )
     != ( zero_zero @ nat ) ) )).

% tuple_isomorphism.size_neq
thf(fact_202_size__unit__overloaded__def,axiom,
    ( ( size_size @ product_unit )
    = ( product_rec_unit @ nat @ ( zero_zero @ nat ) ) )).

% size_unit_overloaded_def
thf(fact_203_size__unit__def,axiom,
    ( product_size_unit
    = ( product_rec_unit @ nat @ ( zero_zero @ nat ) ) )).

% size_unit_def
thf(fact_204_tuple__isomorphism_Osize_I2_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,X1: ( A > ( product_prod @ B @ C ) ),X22: ( ( product_prod @ B @ C ) > A )] :
      ( ( size_size @ ( tuple_isomorphism @ A @ B @ C ) @ ( tuple_742722141rphism @ A @ B @ C @ X1 @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% tuple_isomorphism.size(2)
thf(fact_205_tuple__isomorphism_Osize__gen,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Xb: ( A > nat ),Xa: ( B > nat ),X2: ( C > nat ),X1: ( A > ( product_prod @ B @ C ) ),X22: ( ( product_prod @ B @ C ) > A )] :
      ( ( tuple_1907371454rphism @ A @ B @ C @ Xb @ Xa @ X2 @ ( tuple_742722141rphism @ A @ B @ C @ X1 @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) )).

% tuple_isomorphism.size_gen
thf(fact_206_unit_Osize_I1_J,axiom,
    ( ( product_size_unit @ product_Unity )
    = ( zero_zero @ nat ) )).

% unit.size(1)
thf(fact_207_unit_Osize_I2_J,axiom,
    ( ( size_size @ product_unit @ product_Unity )
    = ( zero_zero @ nat ) )).

% unit.size(2)
thf(fact_208_unit__all__impI,axiom,(
    ! [P: ( product_unit > $o ),Q: ( product_unit > $o )] :
      ( ( ( P @ product_Unity )
       => ( Q @ product_Unity ) )
     => ! [X6: product_unit] :
          ( ( P @ X6 )
         => ( Q @ X6 ) ) ) )).

% unit_all_impI
thf(fact_209_eq__sym__Unity__conv,axiom,(
    ! [X2: $o] :
      ( ( X2
        = ( product_Unity = product_Unity ) )
      = X2 ) )).

% eq_sym_Unity_conv
thf(fact_210_iso__tuple__update__accessor__eq__assist__idI,axiom,(
    ! [A: $tType,V3: A,F: ( A > A ),V: A] :
      ( ( V3
        = ( F @ V ) )
     => ( iso_tu2011167877assist @ A @ A @ ( id @ ( A > A ) ) @ ( id @ A ) @ V @ F @ V3 @ V ) ) )).

% iso_tuple_update_accessor_eq_assist_idI
thf(fact_211_update__accessor__cong__assist__idI,axiom,(
    ! [A: $tType] :
      ( iso_tu2017585022assist @ A @ A @ ( id @ ( A > A ) ) @ ( id @ A ) ) )).

% update_accessor_cong_assist_idI
thf(fact_212_iso__tuple__update__accessor__cong__assist__id,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac: ( B > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac )
     => ( ( Upd @ ( id @ A ) )
        = ( id @ B ) ) ) )).

% iso_tuple_update_accessor_cong_assist_id
thf(fact_213_update__accessor__noop__compE,axiom,(
    ! [A: $tType,B: $tType,Upd: ( ( A > A ) > B > B ),Ac: ( B > A ),F: ( A > A ),X2: B,G: ( A > A )] :
      ( ( iso_tu2017585022assist @ A @ B @ Upd @ Ac )
     => ( ( ( F @ ( Ac @ X2 ) )
          = ( Ac @ X2 ) )
       => ( ( Upd @ ( comp @ A @ A @ A @ G @ F ) @ X2 )
          = ( Upd @ G @ X2 ) ) ) ) )).

% update_accessor_noop_compE
thf(fact_214_add_Omonoid__axioms,axiom,(
    ! [A: $tType] :
      ( ( monoid_add @ A @ ( type2 @ A ) )
     => ( monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) )).

% add.monoid_axioms
thf(fact_215_sum_Osize__gen__o__map,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F: ( C > nat ),Fa: ( D > nat ),G: ( A > C ),Ga: ( B > D )] :
      ( ( comp @ ( sum_sum @ C @ D ) @ nat @ ( sum_sum @ A @ B ) @ ( basic_BNF_size_sum @ C @ D @ F @ Fa ) @ ( sum_map_sum @ A @ C @ B @ D @ G @ Ga ) )
      = ( basic_BNF_size_sum @ A @ B @ ( comp @ C @ nat @ A @ F @ G ) @ ( comp @ D @ nat @ B @ Fa @ Ga ) ) ) )).

% sum.size_gen_o_map
thf(fact_216_monoid_Oleft__neutral,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z3: A,A2: A] :
      ( ( monoid @ A @ F @ Z3 )
     => ( ( F @ Z3 @ A2 )
        = A2 ) ) )).

% monoid.left_neutral
thf(fact_217_monoid_Oright__neutral,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z3: A,A2: A] :
      ( ( monoid @ A @ F @ Z3 )
     => ( ( F @ A2 @ Z3 )
        = A2 ) ) )).

% monoid.right_neutral
thf(fact_218_sum_Omap__id,axiom,(
    ! [B: $tType,A: $tType,T2: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) @ T2 )
      = T2 ) )).

% sum.map_id
thf(fact_219_sum_Omap__id0,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( sum_map_sum @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( sum_sum @ A @ B ) ) ) )).

% sum.map_id0
thf(fact_220_sum_Omap__comp,axiom,(
    ! [D: $tType,F5: $tType,E2: $tType,C: $tType,B: $tType,A: $tType,G12: ( C > E2 ),G23: ( D > F5 ),F1: ( A > C ),F22: ( B > D ),V: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ C @ E2 @ D @ F5 @ G12 @ G23 @ ( sum_map_sum @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( sum_map_sum @ A @ E2 @ B @ F5 @ ( comp @ C @ E2 @ A @ G12 @ F1 ) @ ( comp @ D @ F5 @ B @ G23 @ F22 ) @ V ) ) )).

% sum.map_comp
thf(fact_221_map__sum__o__inj_I1_J,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( D > C )] :
      ( ( comp @ ( sum_sum @ A @ D ) @ ( sum_sum @ B @ C ) @ A @ ( sum_map_sum @ A @ B @ D @ C @ F @ G ) @ ( sum_Inl @ A @ D ) )
      = ( comp @ B @ ( sum_sum @ B @ C ) @ A @ ( sum_Inl @ B @ C ) @ F ) ) )).

% map_sum_o_inj(1)
thf(fact_222_map__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F: ( A > B ),G: ( D > C )] :
      ( ( comp @ ( sum_sum @ A @ D ) @ ( sum_sum @ B @ C ) @ D @ ( sum_map_sum @ A @ B @ D @ C @ F @ G ) @ ( sum_Inr @ D @ A ) )
      = ( comp @ C @ ( sum_sum @ B @ C ) @ D @ ( sum_Inr @ C @ B ) @ G ) ) )).

% map_sum_o_inj(2)
thf(fact_223_map__sum__if__distrib__then_I1_J,axiom,(
    ! [D: $tType,B: $tType,C: $tType,A: $tType,E: $o,F: ( A > B ),G: ( C > D ),X2: A,Y: ( sum_sum @ A @ C )] :
      ( ( E
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ ( sum_Inl @ A @ C @ X2 ) @ Y ) )
          = ( sum_Inl @ B @ D @ ( F @ X2 ) ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ ( sum_Inl @ A @ C @ X2 ) @ Y ) )
          = ( sum_map_sum @ A @ B @ C @ D @ F @ G @ Y ) ) ) ) )).

% map_sum_if_distrib_then(1)
thf(fact_224_map__sum__if__distrib__then_I2_J,axiom,(
    ! [H2: $tType,F5: $tType,G4: $tType,E2: $tType,E: $o,F: ( E2 > F5 ),G: ( G4 > H2 ),X2: G4,Y: ( sum_sum @ E2 @ G4 )] :
      ( ( E
       => ( ( sum_map_sum @ E2 @ F5 @ G4 @ H2 @ F @ G @ ( if @ ( sum_sum @ E2 @ G4 ) @ E @ ( sum_Inr @ G4 @ E2 @ X2 ) @ Y ) )
          = ( sum_Inr @ H2 @ F5 @ ( G @ X2 ) ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ E2 @ F5 @ G4 @ H2 @ F @ G @ ( if @ ( sum_sum @ E2 @ G4 ) @ E @ ( sum_Inr @ G4 @ E2 @ X2 ) @ Y ) )
          = ( sum_map_sum @ E2 @ F5 @ G4 @ H2 @ F @ G @ Y ) ) ) ) )).

% map_sum_if_distrib_then(2)
thf(fact_225_map__sum__if__distrib__else_I1_J,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,E: $o,F: ( A > B ),G: ( C > D ),X2: ( sum_sum @ A @ C ),Y: A] :
      ( ( E
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ X2 @ ( sum_Inl @ A @ C @ Y ) ) )
          = ( sum_map_sum @ A @ B @ C @ D @ F @ G @ X2 ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ A @ B @ C @ D @ F @ G @ ( if @ ( sum_sum @ A @ C ) @ E @ X2 @ ( sum_Inl @ A @ C @ Y ) ) )
          = ( sum_Inl @ B @ D @ ( F @ Y ) ) ) ) ) )).

% map_sum_if_distrib_else(1)
thf(fact_226_map__sum__if__distrib__else_I2_J,axiom,(
    ! [E2: $tType,F5: $tType,H2: $tType,G4: $tType,E: $o,F: ( E2 > F5 ),G: ( G4 > H2 ),X2: ( sum_sum @ E2 @ G4 ),Y: G4] :
      ( ( E
       => ( ( sum_map_sum @ E2 @ F5 @ G4 @ H2 @ F @ G @ ( if @ ( sum_sum @ E2 @ G4 ) @ E @ X2 @ ( sum_Inr @ G4 @ E2 @ Y ) ) )
          = ( sum_map_sum @ E2 @ F5 @ G4 @ H2 @ F @ G @ X2 ) ) )
      & ( ~ ( E )
       => ( ( sum_map_sum @ E2 @ F5 @ G4 @ H2 @ F @ G @ ( if @ ( sum_sum @ E2 @ G4 ) @ E @ X2 @ ( sum_Inr @ G4 @ E2 @ Y ) ) )
          = ( sum_Inr @ H2 @ F5 @ ( G @ Y ) ) ) ) ) )).

% map_sum_if_distrib_else(2)
thf(fact_227_map__sum_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E2: $tType,F5: $tType,D: $tType,B: $tType,F: ( C > E2 ),G: ( D > F5 ),H: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( sum_sum @ C @ D ) @ ( sum_sum @ E2 @ F5 ) @ ( sum_sum @ A @ B ) @ ( sum_map_sum @ C @ E2 @ D @ F5 @ F @ G ) @ ( sum_map_sum @ A @ C @ B @ D @ H @ I ) )
      = ( sum_map_sum @ A @ E2 @ B @ F5 @ ( comp @ C @ E2 @ A @ F @ H ) @ ( comp @ D @ F5 @ B @ G @ I ) ) ) )).

% map_sum.comp
thf(fact_228_map__sum_Ocompositionality,axiom,(
    ! [D: $tType,F5: $tType,E2: $tType,C: $tType,B: $tType,A: $tType,F: ( C > E2 ),G: ( D > F5 ),H: ( A > C ),I: ( B > D ),Sum: ( sum_sum @ A @ B )] :
      ( ( sum_map_sum @ C @ E2 @ D @ F5 @ F @ G @ ( sum_map_sum @ A @ C @ B @ D @ H @ I @ Sum ) )
      = ( sum_map_sum @ A @ E2 @ B @ F5 @ ( comp @ C @ E2 @ A @ F @ H ) @ ( comp @ D @ F5 @ B @ G @ I ) @ Sum ) ) )).

% map_sum.compositionality
thf(fact_229_case__sum__o__map__sum__id,axiom,(
    ! [A: $tType,B: $tType,C: $tType,G: ( B > A ),F: ( C > A ),X2: ( sum_sum @ C @ B )] :
      ( ( comp @ ( sum_sum @ A @ B ) @ A @ ( sum_sum @ C @ B ) @ ( sum_case_sum @ A @ A @ B @ ( id @ A ) @ G ) @ ( sum_map_sum @ C @ A @ B @ B @ F @ ( id @ B ) ) @ X2 )
      = ( sum_case_sum @ C @ A @ B @ ( comp @ C @ A @ C @ F @ ( id @ C ) ) @ G @ X2 ) ) )).

% case_sum_o_map_sum_id
thf(fact_230_case__sum__o__map__sum,axiom,(
    ! [A: $tType,D: $tType,C: $tType,E2: $tType,B: $tType,F: ( D > C ),G: ( E2 > C ),H1: ( A > D ),H22: ( B > E2 )] :
      ( ( comp @ ( sum_sum @ D @ E2 ) @ C @ ( sum_sum @ A @ B ) @ ( sum_case_sum @ D @ C @ E2 @ F @ G ) @ ( sum_map_sum @ A @ D @ B @ E2 @ H1 @ H22 ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ F @ H1 ) @ ( comp @ E2 @ C @ B @ G @ H22 ) ) ) )).

% case_sum_o_map_sum
thf(fact_231_case__sum__map__sum,axiom,(
    ! [C: $tType,A: $tType,B: $tType,E2: $tType,D: $tType,L: ( B > A ),R3: ( C > A ),F: ( D > B ),G: ( E2 > C ),X2: ( sum_sum @ D @ E2 )] :
      ( ( sum_case_sum @ B @ A @ C @ L @ R3 @ ( sum_map_sum @ D @ B @ E2 @ C @ F @ G @ X2 ) )
      = ( sum_case_sum @ D @ A @ E2 @ ( comp @ B @ A @ D @ L @ F ) @ ( comp @ C @ A @ E2 @ R3 @ G ) @ X2 ) ) )).

% case_sum_map_sum
thf(fact_232_case__sum__o__inj_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ C @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inr @ C @ A ) )
      = G ) )).

% case_sum_o_inj(2)
thf(fact_233_case__sum__o__inj_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B ),G: ( C > B )] :
      ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ ( sum_case_sum @ A @ B @ C @ F @ G ) @ ( sum_Inl @ A @ C ) )
      = F ) )).

% case_sum_o_inj(1)
thf(fact_234_o__case__sum,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,H: ( D > C ),F: ( A > D ),G: ( B > D )] :
      ( ( comp @ D @ C @ ( sum_sum @ A @ B ) @ H @ ( sum_case_sum @ A @ D @ B @ F @ G ) )
      = ( sum_case_sum @ A @ C @ B @ ( comp @ D @ C @ A @ H @ F ) @ ( comp @ D @ C @ B @ H @ G ) ) ) )).

% o_case_sum
thf(fact_235_case__sum__if,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P2: $o,F: ( B > A ),G: ( C > A ),X2: B,Y: C] :
      ( ( P2
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P2 @ ( sum_Inl @ B @ C @ X2 ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( F @ X2 ) ) )
      & ( ~ ( P2 )
       => ( ( sum_case_sum @ B @ A @ C @ F @ G @ ( if @ ( sum_sum @ B @ C ) @ P2 @ ( sum_Inl @ B @ C @ X2 ) @ ( sum_Inr @ C @ B @ Y ) ) )
          = ( G @ Y ) ) ) ) )).

% case_sum_if
thf(fact_236_case__sum__step_I1_J,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType,F3: ( B > A ),G3: ( C > A ),G: ( D > A ),P2: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ ( sum_sum @ B @ C ) @ A @ D @ ( sum_case_sum @ B @ A @ C @ F3 @ G3 ) @ G @ ( sum_Inl @ ( sum_sum @ B @ C ) @ D @ P2 ) )
      = ( sum_case_sum @ B @ A @ C @ F3 @ G3 @ P2 ) ) )).

% case_sum_step(1)
thf(fact_237_case__sum__step_I2_J,axiom,(
    ! [E2: $tType,A: $tType,C: $tType,B: $tType,F: ( E2 > A ),F3: ( B > A ),G3: ( C > A ),P2: ( sum_sum @ B @ C )] :
      ( ( sum_case_sum @ E2 @ A @ ( sum_sum @ B @ C ) @ F @ ( sum_case_sum @ B @ A @ C @ F3 @ G3 ) @ ( sum_Inr @ ( sum_sum @ B @ C ) @ E2 @ P2 ) )
      = ( sum_case_sum @ B @ A @ C @ F3 @ G3 @ P2 ) ) )).

% case_sum_step(2)
thf(fact_238_case__sum__expand__Inr,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),X2: ( sum_sum @ A @ C )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( F @ X2 )
        = ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) @ X2 ) ) ) )).

% case_sum_expand_Inr
thf(fact_239_case__sum__expand__Inr_H,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B ),H: ( C > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( H
          = ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = ( ( sum_case_sum @ A @ B @ C @ G @ H )
          = F ) ) ) )).

% case_sum_expand_Inr'
thf(fact_240_case__sum__expand__Inr__pointfree,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( ( sum_sum @ A @ C ) > B ),G: ( A > B )] :
      ( ( ( comp @ ( sum_sum @ A @ C ) @ B @ A @ F @ ( sum_Inl @ A @ C ) )
        = G )
     => ( ( sum_case_sum @ A @ B @ C @ G @ ( comp @ ( sum_sum @ A @ C ) @ B @ C @ F @ ( sum_Inr @ C @ A ) ) )
        = F ) ) )).

% case_sum_expand_Inr_pointfree
thf(fact_241_monoid_Oaxioms_I2_J,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z3: A] :
      ( ( monoid @ A @ F @ Z3 )
     => ( monoid_axioms @ A @ F @ Z3 ) ) )).

% monoid.axioms(2)
thf(fact_242_monoid__axioms_Ointro,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z3: A] :
      ( ! [A4: A] :
          ( ( F @ Z3 @ A4 )
          = A4 )
     => ( ! [A4: A] :
            ( ( F @ A4 @ Z3 )
            = A4 )
       => ( monoid_axioms @ A @ F @ Z3 ) ) ) )).

% monoid_axioms.intro
thf(fact_243_monoid__axioms__def,axiom,(
    ! [A: $tType] :
      ( ( monoid_axioms @ A )
      = ( ^ [F2: ( A > A > A ),Z4: A] :
            ( ! [A5: A] :
                ( ( F2 @ Z4 @ A5 )
                = A5 )
            & ! [A5: A] :
                ( ( F2 @ A5 @ Z4 )
                = A5 ) ) ) ) )).

% monoid_axioms_def
thf(fact_244_monoid__def,axiom,(
    ! [A: $tType] :
      ( ( monoid @ A )
      = ( ^ [F2: ( A > A > A ),Z4: A] :
            ( ( semigroup @ A @ F2 )
            & ( monoid_axioms @ A @ F2 @ Z4 ) ) ) ) )).

% monoid_def
thf(fact_245_monoid_Ointro,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z3: A] :
      ( ( semigroup @ A @ F )
     => ( ( monoid_axioms @ A @ F @ Z3 )
       => ( monoid @ A @ F @ Z3 ) ) ) )).

% monoid.intro
thf(fact_246_add_Osemigroup__axioms,axiom,(
    ! [A: $tType] :
      ( ( semigroup_add @ A @ ( type2 @ A ) )
     => ( semigroup @ A @ ( plus_plus @ A ) ) ) )).

% add.semigroup_axioms
thf(fact_247_semigroup__def,axiom,(
    ! [A: $tType] :
      ( ( semigroup @ A )
      = ( ^ [F2: ( A > A > A )] :
          ! [A5: A,B4: A,C4: A] :
            ( ( F2 @ ( F2 @ A5 @ B4 ) @ C4 )
            = ( F2 @ A5 @ ( F2 @ B4 @ C4 ) ) ) ) ) )).

% semigroup_def
thf(fact_248_semigroup_Oassoc,axiom,(
    ! [A: $tType,F: ( A > A > A ),A2: A,B3: A,C2: A] :
      ( ( semigroup @ A @ F )
     => ( ( F @ ( F @ A2 @ B3 ) @ C2 )
        = ( F @ A2 @ ( F @ B3 @ C2 ) ) ) ) )).

% semigroup.assoc
thf(fact_249_semigroup_Ointro,axiom,(
    ! [A: $tType,F: ( A > A > A )] :
      ( ! [A4: A,B6: A,C5: A] :
          ( ( F @ ( F @ A4 @ B6 ) @ C5 )
          = ( F @ A4 @ ( F @ B6 @ C5 ) ) )
     => ( semigroup @ A @ F ) ) )).

% semigroup.intro
thf(fact_250_monoid_Oaxioms_I1_J,axiom,(
    ! [A: $tType,F: ( A > A > A ),Z3: A] :
      ( ( monoid @ A @ F @ Z3 )
     => ( semigroup @ A @ F ) ) )).

% monoid.axioms(1)

%----Type constructors (93)
thf(tcon_Stream__Mirabelle__hbrgyiwlrc_Ostream___Code__Evaluation_Oterm__of,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( code_term_of @ ( stream170649215stream @ A7 ) @ ( type2 @ ( stream170649215stream @ A7 ) ) ) ) )).

thf(tcon_Stream__Mirabelle__hbrgyiwlrc_Ostream___HOL_Oequal,axiom,(
    ! [A7: $tType] :
      ( cl_HOL_Oequal @ ( stream170649215stream @ A7 ) @ ( type2 @ ( stream170649215stream @ A7 ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___Code__Evaluation_Oterm__of_1,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) )
        & ( typerep2 @ A9 @ ( type2 @ A9 ) ) )
     => ( code_term_of @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___HOL_Oequal_2,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( cl_HOL_Oequal @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) )).

thf(tcon_Code__Numeral_Onatural___Code__Evaluation_Oterm__of_3,axiom,
    ( code_term_of @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___HOL_Oequal_4,axiom,
    ( cl_HOL_Oequal @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Evaluation_Oterm___Code__Evaluation_Oterm__of_5,axiom,
    ( code_term_of @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Evaluation_Oterm___HOL_Oequal_6,axiom,
    ( cl_HOL_Oequal @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Product__Type_Ounit___Code__Evaluation_Oterm__of_7,axiom,
    ( code_term_of @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___HOL_Oequal_8,axiom,
    ( cl_HOL_Oequal @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Oprod___Code__Evaluation_Oterm__of_9,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___HOL_Oequal_10,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( cl_HOL_Oequal @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) )).

thf(tcon_Typerep_Otyperep___Code__Evaluation_Oterm__of_11,axiom,
    ( code_term_of @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Typerep_Otyperep___HOL_Oequal_12,axiom,
    ( cl_HOL_Oequal @ typerep @ ( type2 @ typerep ) )).

thf(tcon_String_Oliteral___Code__Evaluation_Oterm__of_13,axiom,
    ( code_term_of @ literal @ ( type2 @ literal ) )).

thf(tcon_String_Oliteral___HOL_Oequal_14,axiom,
    ( cl_HOL_Oequal @ literal @ ( type2 @ literal ) )).

thf(tcon_Option_Ooption___Code__Evaluation_Oterm__of_15,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( code_term_of @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___HOL_Oequal_16,axiom,(
    ! [A7: $tType] :
      ( cl_HOL_Oequal @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) )).

thf(tcon_Sum__Type_Osum___Code__Evaluation_Oterm__of_17,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___HOL_Oequal_18,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( cl_HOL_Oequal @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Code__Evaluation_Oterm__of_19,axiom,
    ( code_term_of @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___HOL_Oequal_20,axiom,
    ( cl_HOL_Oequal @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Code__Evaluation_Oterm__of_21,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( code_term_of @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Set_Oset___HOL_Oequal_22,axiom,(
    ! [A7: $tType] :
      ( ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) )
     => ( cl_HOL_Oequal @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Code__Evaluation_Oterm__of_23,axiom,
    ( code_term_of @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___HOL_Oequal_24,axiom,
    ( cl_HOL_Oequal @ nat @ ( type2 @ nat ) )).

thf(tcon_fun___Code__Evaluation_Oterm__of_25,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( code_term_of @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___HOL_Oequal_26,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( cl_HOL_Oequal @ A8 @ ( type2 @ A8 ) ) )
     => ( cl_HOL_Oequal @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Typerep_Otyperep,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Enum_Oenum,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( enum @ A8 @ ( type2 @ A8 ) ) )
     => ( enum @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Typerep_Otyperep_27,axiom,
    ( typerep2 @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Typerep_Otyperep_28,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( typerep2 @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_Set_Oset___Enum_Oenum_29,axiom,(
    ! [A7: $tType] :
      ( ( enum @ A7 @ ( type2 @ A7 ) )
     => ( enum @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_HOL_Obool___Typerep_Otyperep_30,axiom,
    ( typerep2 @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Enum_Oenum_31,axiom,
    ( enum @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Typerep_Otyperep_32,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Enum_Oenum_33,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( enum @ A8 @ ( type2 @ A8 ) ) )
     => ( enum @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Option_Ooption___Typerep_Otyperep_34,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( typerep2 @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___Enum_Oenum_35,axiom,(
    ! [A7: $tType] :
      ( ( enum @ A7 @ ( type2 @ A7 ) )
     => ( enum @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_String_Oliteral___Typerep_Otyperep_36,axiom,
    ( typerep2 @ literal @ ( type2 @ literal ) )).

thf(tcon_Typerep_Otyperep___Typerep_Otyperep_37,axiom,
    ( typerep2 @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Product__Type_Oprod___Typerep_Otyperep_38,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) ) )
     => ( typerep2 @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Enum_Oenum_39,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( enum @ A7 @ ( type2 @ A7 ) )
        & ( enum @ A8 @ ( type2 @ A8 ) ) )
     => ( enum @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Ounit___Typerep_Otyperep_40,axiom,
    ( typerep2 @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Enum_Oenum_41,axiom,
    ( enum @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Evaluation_Oterm___Typerep_Otyperep_42,axiom,
    ( typerep2 @ code_term @ ( type2 @ code_term ) )).

thf(tcon_Code__Numeral_Onatural___Typerep_Otyperep_43,axiom,
    ( typerep2 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Record_Otuple__isomorphism___Typerep_Otyperep_44,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
        & ( typerep2 @ A8 @ ( type2 @ A8 ) )
        & ( typerep2 @ A9 @ ( type2 @ A9 ) ) )
     => ( typerep2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) ) )).

thf(tcon_Stream__Mirabelle__hbrgyiwlrc_Ostream___Typerep_Otyperep_45,axiom,(
    ! [A7: $tType] :
      ( ( typerep2 @ A7 @ ( type2 @ A7 ) )
     => ( typerep2 @ ( stream170649215stream @ A7 ) @ ( type2 @ ( stream170649215stream @ A7 ) ) ) ) )).

thf(tcon_fun___Quickcheck__Random_Orandom,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( code_term_of @ A7 @ ( type2 @ A7 ) )
        & ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    ( semiri456707255roduct @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    ( canoni770627133id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add,axiom,
    ( ordere779506340up_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add,axiom,
    ( cancel1352612707id_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add,axiom,
    ( cancel_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Quickcheck__Random_Orandom_46,axiom,
    ( quickcheck_random @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add,axiom,
    ( ab_semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add,axiom,
    ( comm_monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1,axiom,
    ( comm_semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Osemigroup__add,axiom,
    ( semigroup_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Omonoid__add,axiom,
    ( monoid_add @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Rings_Osemiring__1,axiom,
    ( semiring_1 @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Groups_Ozero,axiom,
    ( zero @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    ( size @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Quickcheck__Random_Orandom_47,axiom,(
    ! [A7: $tType] :
      ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
     => ( quickcheck_random @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) ) )).

thf(tcon_HOL_Obool___Quickcheck__Random_Orandom_48,axiom,
    ( quickcheck_random @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Nat_Osize_49,axiom,
    ( size @ $o @ ( type2 @ $o ) )).

thf(tcon_Sum__Type_Osum___Quickcheck__Random_Orandom_50,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) ) )).

thf(tcon_Sum__Type_Osum___Nat_Osize_51,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( size @ ( sum_sum @ A7 @ A8 ) @ ( type2 @ ( sum_sum @ A7 @ A8 ) ) ) )).

thf(tcon_Option_Ooption___Quickcheck__Random_Orandom_52,axiom,(
    ! [A7: $tType] :
      ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
     => ( quickcheck_random @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) ) )).

thf(tcon_Option_Ooption___Nat_Osize_53,axiom,(
    ! [A7: $tType] :
      ( size @ ( option @ A7 ) @ ( type2 @ ( option @ A7 ) ) ) )).

thf(tcon_String_Oliteral___Quickcheck__Random_Orandom_54,axiom,
    ( quickcheck_random @ literal @ ( type2 @ literal ) )).

thf(tcon_String_Oliteral___Nat_Osize_55,axiom,
    ( size @ literal @ ( type2 @ literal ) )).

thf(tcon_Typerep_Otyperep___Nat_Osize_56,axiom,
    ( size @ typerep @ ( type2 @ typerep ) )).

thf(tcon_Product__Type_Oprod___Quickcheck__Random_Orandom_57,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) ) )
     => ( quickcheck_random @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) ) )).

thf(tcon_Product__Type_Oprod___Nat_Osize_58,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( size @ ( product_prod @ A7 @ A8 ) @ ( type2 @ ( product_prod @ A7 @ A8 ) ) ) )).

thf(tcon_Product__Type_Ounit___Quickcheck__Random_Orandom_59,axiom,
    ( quickcheck_random @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Product__Type_Ounit___Nat_Osize_60,axiom,
    ( size @ product_unit @ ( type2 @ product_unit ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_61,axiom,
    ( ordere779506340up_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_62,axiom,
    ( cancel1352612707id_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_63,axiom,
    ( cancel_semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Quickcheck__Random_Orandom_64,axiom,
    ( quickcheck_random @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_65,axiom,
    ( ab_semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_66,axiom,
    ( comm_monoid_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_67,axiom,
    ( comm_semiring_1 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_68,axiom,
    ( semigroup_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_69,axiom,
    ( monoid_add @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_70,axiom,
    ( semiring_1 @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_71,axiom,
    ( zero @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Code__Numeral_Onatural___Nat_Osize_72,axiom,
    ( size @ code_natural @ ( type2 @ code_natural ) )).

thf(tcon_Record_Otuple__isomorphism___Quickcheck__Random_Orandom_73,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( ( ( code_term_of @ A7 @ ( type2 @ A7 ) )
        & ( cl_HOL_Oequal @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
        & ( quickcheck_random @ A8 @ ( type2 @ A8 ) )
        & ( quickcheck_random @ A9 @ ( type2 @ A9 ) ) )
     => ( quickcheck_random @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) ) )).

thf(tcon_Record_Otuple__isomorphism___Nat_Osize_74,axiom,(
    ! [A7: $tType,A8: $tType,A9: $tType] :
      ( size @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) @ ( type2 @ ( tuple_isomorphism @ A7 @ A8 @ A9 ) ) ) )).

thf(tcon_Stream__Mirabelle__hbrgyiwlrc_Ostream___Quickcheck__Random_Orandom_75,axiom,(
    ! [A7: $tType] :
      ( ( quickcheck_random @ A7 @ ( type2 @ A7 ) )
     => ( quickcheck_random @ ( stream170649215stream @ A7 ) @ ( type2 @ ( stream170649215stream @ A7 ) ) ) ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( stream135081970_sdrop @ a @ n @ ( stream2128578057e_smap @ b @ a @ f @ s ) )
    = ( stream2128578057e_smap @ b @ a @ f @ ( stream135081970_sdrop @ b @ n @ s ) ) )).

%------------------------------------------------------------------------------
