%------------------------------------------------------------------------------
% File     : DAT249^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Infinite streams (sequences/lists) 301
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream__301.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  332 (   0 unit;  62 type;   0 defn)
%            Number of atoms       : 4739 ( 495 equality;2969 variable)
%            Maximal formula depth :   23 (  10 average)
%            Number of connectives : 4215 ( 139   ~;  29   |;  78   &;3683   @)
%                                         (   0 <=>; 286  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  251 ( 251   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   66 (  62   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1160 (   0 sgn; 993   !;  68   ?;  33   ^)
%                                         (1160   :;  66  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:41:50.225
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Stream__Mirabelle__hbrgyiwlrc_Ostream,type,(
    stream170649215stream: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (56)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,(
    bNF_Greatest_Shift: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,(
    bNF_Greatest_Succ: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oshift,type,(
    bNF_Greatest_shift: 
      !>[A: $tType,B: $tType] :
        ( ( ( list @ A ) > B ) > A > ( list @ A ) > B ) )).

thf(sy_c_Groups_Ozero__class_Ozero,type,(
    zero_zero: 
      !>[A: $tType] : A )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Obutlast,type,(
    butlast: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Ofold,type,(
    fold: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B ) > ( list @ A ) > B > B ) )).

thf(sy_c_List_Ogen__length,type,(
    gen_length: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > nat ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olast,type,(
    last: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Ocase__list,type,(
    case_list: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) )).

thf(sy_c_List_Olist_Ohd,type,(
    hd: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_Omap,type,(
    map: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) )).

thf(sy_c_List_Olist_Otl,type,(
    tl: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Olistrelp,type,(
    listrelp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) )).

thf(sy_c_List_Omap__tailrec,type,(
    map_tailrec: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omap__tailrec__rev,type,(
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omember,type,(
    member: 
      !>[A: $tType] :
        ( ( list @ A ) > A > $o ) )).

thf(sy_c_List_On__lists,type,(
    n_lists: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Onull,type,(
    null: 
      !>[A: $tType] :
        ( ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord__class_Olexordp,type,(
    ord_lexordp: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord__class_Olexordp__eq,type,(
    ord_lexordp_eq: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Oremdups__adj,type,(
    remdups_adj: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Oreplicate,type,(
    replicate: 
      !>[A: $tType] :
        ( nat > A > ( list @ A ) ) )).

thf(sy_c_List_Orev,type,(
    rev: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osplice,type,(
    splice: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Ounion,type,(
    union: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ocycle,type,(
    stream317748790_cycle: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osdrop__while,type,(
    stream1195056575_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Oshift,type,(
    stream1035003186_shift: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osmember,type,(
    stream1586597341member: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostake,type,(
    stream1746350922_stake: 
      !>[A: $tType] :
        ( nat > ( stream170649215stream @ A ) > ( list @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_OSCons,type,(
    stream641971652_SCons: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocase__stream,type,(
    stream1342653232stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream170649215stream @ A ) > B ) > ( stream170649215stream @ A ) > B ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Oshd,type,(
    stream_Mirabelle_shd: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osmap,type,(
    stream2128578057e_smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream170649215stream @ A ) > ( stream170649215stream @ Aa ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ostl,type,(
    stream_Mirabelle_stl: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_member,type,(
    member2: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_u,type,(
    u: ( list @ a ) )).

%----Relevant facts (255)
thf(fact_0_shift__left__inj,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S1: ( stream170649215stream @ A ),S2: ( stream170649215stream @ A )] :
      ( ( ( stream1035003186_shift @ A @ Xs @ S1 )
        = ( stream1035003186_shift @ A @ Xs @ S2 ) )
      = ( S1 = S2 ) ) )).

% shift_left_inj
thf(fact_1_shift_Osimps_I1_J,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( nil @ A ) @ S )
      = S ) )).

% shift.simps(1)
thf(fact_2_shift__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( append @ A @ Xs @ Ys ) @ S )
      = ( stream1035003186_shift @ A @ Xs @ ( stream1035003186_shift @ A @ Ys @ S ) ) ) )).

% shift_append
thf(fact_3_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_4_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_5_shift__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( stream_Mirabelle_shd @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( stream_Mirabelle_shd @ A @ S ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( stream_Mirabelle_shd @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( hd @ A @ Xs ) ) ) ) )).

% shift_simps(1)
thf(fact_6_member__rec_I2_J,axiom,(
    ! [A: $tType,Y: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y ) )).

% member_rec(2)
thf(fact_7_shift__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( stream_Mirabelle_stl @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( stream_Mirabelle_stl @ A @ S ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( stream_Mirabelle_stl @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( stream1035003186_shift @ A @ ( tl @ A @ Xs ) @ S ) ) ) ) )).

% shift_simps(2)
thf(fact_8_gen__length__code_I1_J,axiom,(
    ! [A: $tType,N: nat] :
      ( ( gen_length @ A @ N @ ( nil @ A ) )
      = N ) )).

% gen_length_code(1)
thf(fact_9_splice__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% splice_Nil2
thf(fact_10_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_11_null__rec_I2_J,axiom,(
    ! [B: $tType] :
      ( null @ B @ ( nil @ B ) ) )).

% null_rec(2)
thf(fact_12_eq__Nil__null,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
        = ( nil @ A ) )
      = ( null @ A @ Xs ) ) )).

% eq_Nil_null
thf(fact_13_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_14_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_15_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_16_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_17_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_18_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_19_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_20_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_21_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_22_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_23_tl__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) )).

% tl_append2
thf(fact_24_hd__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) )).

% hd_append2
thf(fact_25_hd__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) )).

% hd_append
thf(fact_26_list_Oexpand,axiom,(
    ! [A: $tType,List: ( list @ A ),List2: ( list @ A )] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) )).

% list.expand
thf(fact_27_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_28_longest__common__prefix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
    ? [Ps: ( list @ A ),Xs2: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs2 ) )
      & ( Ys
        = ( append @ A @ Ps @ Ys2 ) )
      & ( ( Xs2
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs2 )
         != ( hd @ A @ Ys2 ) ) ) ) )).

% longest_common_prefix
thf(fact_29_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_30_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( ( ( stream_Mirabelle_shd @ A @ Stream )
          = ( stream_Mirabelle_shd @ A @ Stream2 ) )
        & ( ( stream_Mirabelle_stl @ A @ Stream )
          = ( stream_Mirabelle_stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_31_stream_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_32_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) )
                | ( ( stream_Mirabelle_stl @ A @ Stream3 )
                  = ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_33_append__Nil,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_34_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_35_list_Osel_I2_J,axiom,(
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% list.sel(2)
thf(fact_36_cycle_Osimps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream317748790_cycle @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) )).

% cycle.simps(1)
thf(fact_37_splice_Osimps_I1_J,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% splice.simps(1)
thf(fact_38_cycle_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream317748790_cycle @ A @ Xs ) )
      = ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) )).

% cycle.simps(2)
thf(fact_39_list_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F1: B,F2: ( A > ( list @ A ) > B ),List3: ( list @ A )] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F1
            @ ( F2 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) )).

% list.case_eq_if
thf(fact_40_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( stream1342653232stream @ A @ B )
      = ( ^ [F3: ( A > ( stream170649215stream @ A ) > B ),Stream5: ( stream170649215stream @ A )] :
            ( F3 @ ( stream_Mirabelle_shd @ A @ Stream5 ) @ ( stream_Mirabelle_stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_41_hd__Cons__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) )).

% hd_Cons_tl
thf(fact_42_list_Ocollapse,axiom,(
    ! [A: $tType,List: ( list @ A )] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) )).

% list.collapse
thf(fact_43_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( stream1195056575_while @ A )
      = ( ^ [P2: ( A > $o ),S3: ( stream170649215stream @ A )] :
            ( if @ ( stream170649215stream @ A ) @ ( P2 @ ( stream_Mirabelle_shd @ A @ S3 ) ) @ ( stream1195056575_while @ A @ P2 @ ( stream_Mirabelle_stl @ A @ S3 ) ) @ S3 ) ) ) )).

% sdrop_while.simps
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member2 @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member2 @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_list_Oexhaust__sel,axiom,(
    ! [A: $tType,List: ( list @ A )] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) )).

% list.exhaust_sel
thf(fact_49_last__appendL,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Xs ) ) ) )).

% last_appendL
thf(fact_50_last__appendR,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Ys ) ) ) )).

% last_appendR
thf(fact_51_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X3: B,Xs: ( list @ B ),F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X3 @ Xs ) @ F )
      = ( append @ A @ ( F @ X3 ) @ ( bind @ B @ A @ Xs @ F ) ) ) )).

% bind_simps(2)
thf(fact_52_stream_Ocollapse,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) )
      = Stream ) )).

% stream.collapse
thf(fact_53_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_54_stream_Oinject,axiom,(
    ! [A: $tType,X1: A,X23: ( stream170649215stream @ A ),Y1: A,Y2: ( stream170649215stream @ A )] :
      ( ( ( stream641971652_SCons @ A @ X1 @ X23 )
        = ( stream641971652_SCons @ A @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X23 = Y2 ) ) ) )).

% stream.inject
thf(fact_55_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X3 = Y ) ) ) )).

% append1_eq_conv
thf(fact_56_last__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
      = X3 ) )).

% last_snoc
thf(fact_57_list_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F12: B,F22: ( A > ( list @ A ) > B ),X21: A,X22: ( list @ A )] :
      ( ( case_list @ B @ A @ F12 @ F22 @ ( cons @ A @ X21 @ X22 ) )
      = ( F22 @ X21 @ X22 ) ) )).

% list.simps(5)
thf(fact_58_not__Cons__self2,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X3 @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_59_sdrop__while__SCons,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A,S: ( stream170649215stream @ A )] :
      ( ( ( P @ A2 )
       => ( ( stream1195056575_while @ A @ P @ ( stream641971652_SCons @ A @ A2 @ S ) )
          = ( stream1195056575_while @ A @ P @ S ) ) )
      & ( ~ ( P @ A2 )
       => ( ( stream1195056575_while @ A @ P @ ( stream641971652_SCons @ A @ A2 @ S ) )
          = ( stream641971652_SCons @ A @ A2 @ S ) ) ) ) )).

% sdrop_while_SCons
thf(fact_60_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream170649215stream @ A )] :
      ~ ( ! [X12: A,X24: ( stream170649215stream @ A )] :
            ( Y
           != ( stream641971652_SCons @ A @ X12 @ X24 ) ) ) )).

% stream.exhaust
thf(fact_61_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( stream170649215stream @ A ) > B ),X1: A,X23: ( stream170649215stream @ A )] :
      ( ( stream1342653232stream @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X23 ) )
      = ( F @ X1 @ X23 ) ) )).

% stream.case
thf(fact_62_transpose_Ocases,axiom,(
    ! [A: $tType,X3: ( list @ ( list @ A ) )] :
      ( ( X3
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X3
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X2: A,Xs3: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X3
               != ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs3 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_63_last__ConsR,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X3 @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_ConsR
thf(fact_64_last__ConsL,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X3 @ Xs ) )
        = X3 ) ) )).

% last_ConsL
thf(fact_65_last_Osimps,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X3 @ Xs ) )
          = X3 ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) )).

% last.simps
thf(fact_66_shift_Osimps_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( cons @ A @ X3 @ Xs ) @ S )
      = ( stream641971652_SCons @ A @ X3 @ ( stream1035003186_shift @ A @ Xs @ S ) ) ) )).

% shift.simps(2)
thf(fact_67_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_68_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_69_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_70_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X12: A,X24: ( list @ A )] :
            ( ( P @ X24 )
           => ( P @ ( cons @ A @ X12 @ X24 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_71_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_72_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X2: A,Xs3: ( list @ A )] :
            ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( nil @ B ) )
       => ( ! [Y4: B,Ys4: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y4 @ Ys4 ) )
         => ( ! [X2: A,Xs3: ( list @ A ),Y4: B,Ys4: ( list @ B )] :
                ( ( P @ Xs3 @ Ys4 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ B @ Y4 @ Ys4 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_73_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P @ ( nil @ A ) @ X12 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X2: A,Xs3: ( list @ A ),Y4: A,Ys4: ( list @ A )] :
              ( ( P @ Xs3 @ Ys4 )
             => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_74_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X3: ( list @ A )] :
      ( ( X3
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( X3
           != ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ~ ( ! [X2: A,Y4: A,Xs3: ( list @ A )] :
                ( X3
               != ( cons @ A @ X2 @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_75_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Y4: A,Xs3: ( list @ A )] :
              ( ( ( X2 = Y4 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) ) )
             => ( ( ( X2 != Y4 )
                 => ( P @ ( cons @ A @ Y4 @ Xs3 ) ) )
               => ( P @ ( cons @ A @ X2 @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_76_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs3: ( list @ A )] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( cons @ A @ X2 @ Xs3 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_77_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F4: ( A > B ),X12: ( list @ B )] :
          ( P @ F4 @ ( nil @ A ) @ X12 )
     => ( ! [F4: ( A > B ),A4: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F4 @ As @ ( cons @ B @ ( F4 @ A4 ) @ Bs ) )
           => ( P @ F4 @ ( cons @ A @ A4 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_78_append__Cons,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X3 @ Xs ) @ Ys )
      = ( cons @ A @ X3 @ ( append @ A @ Xs @ Ys ) ) ) )).

% append_Cons
thf(fact_79_Cons__eq__appendI,axiom,(
    ! [A: $tType,X3: A,Xs1: ( list @ A ),Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X3 @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X3 @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_80_list_Osel_I3_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X22 ) )
      = X22 ) )).

% list.sel(3)
thf(fact_81_list_Osel_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X22 ) )
      = X21 ) )).

% list.sel(1)
thf(fact_82_stream_Osel_I2_J,axiom,(
    ! [A: $tType,X1: A,X23: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream641971652_SCons @ A @ X1 @ X23 ) )
      = X23 ) )).

% stream.sel(2)
thf(fact_83_stream_Osel_I1_J,axiom,(
    ! [A: $tType,X1: A,X23: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream641971652_SCons @ A @ X1 @ X23 ) )
      = X1 ) )).

% stream.sel(1)
thf(fact_84_splice_Osimps_I3_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( cons @ A @ X3 @ ( cons @ A @ Y @ ( splice @ A @ Xs @ Ys ) ) ) ) )).

% splice.simps(3)
thf(fact_85_stream_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P @ ( stream1342653232stream @ A @ B @ F @ Stream ) )
      = ( ~ ( ( Stream
              = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
            & ~ ( P @ ( F @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) ) )).

% stream.split_sel_asm
thf(fact_86_stream_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P @ ( stream1342653232stream @ A @ B @ F @ Stream ) )
      = ( ( Stream
          = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
       => ( P @ ( F @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) )).

% stream.split_sel
thf(fact_87_null__rec_I1_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ~ ( null @ A @ ( cons @ A @ X3 @ Xs ) ) )).

% null_rec(1)
thf(fact_88_member__rec_I1_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A ),Y: A] :
      ( ( member @ A @ ( cons @ A @ X3 @ Xs ) @ Y )
      = ( ( X3 = Y )
        | ( member @ A @ Xs @ Y ) ) ) )).

% member_rec(1)
thf(fact_89_list_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F12: B,F22: ( A > ( list @ A ) > B )] :
      ( ( case_list @ B @ A @ F12 @ F22 @ ( nil @ A ) )
      = F12 ) )).

% list.simps(4)
thf(fact_90_list_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F12: B,F22: ( A > ( list @ A ) > B ),List: ( list @ A )] :
      ( ( P @ ( case_list @ B @ A @ F12 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F12 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) )).

% list.split_sel_asm
thf(fact_91_list_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F12: B,F22: ( A > ( list @ A ) > B ),List: ( list @ A )] :
      ( ( P @ ( case_list @ B @ A @ F12 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F12 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) )).

% list.split_sel
thf(fact_92_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs3: ( list @ A )] :
              ( ( Xs3
               != ( nil @ A ) )
             => ( ( P @ Xs3 )
               => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_93_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X3: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X3 @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X3 @ Xs ) ) )
        | ? [Ys5: ( list @ A )] :
            ( ( Ys
              = ( cons @ A @ X3 @ Ys5 ) )
            & ( ( append @ A @ Ys5 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_94_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X3 @ Xs )
            = Zs ) )
        | ? [Ys5: ( list @ A )] :
            ( ( ( cons @ A @ X3 @ Ys5 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys5 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_95_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys4: ( list @ A ),Y4: A] :
              ( Xs
             != ( append @ A @ Ys4 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_96_rev__induct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A,Xs3: ( list @ A )] :
            ( ( P @ Xs3 )
           => ( P @ ( append @ A @ Xs3 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) )).

% rev_induct
thf(fact_97_tl__Nil,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X: A] :
            ( Xs
            = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )).

% tl_Nil
thf(fact_98_Nil__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X: A] :
            ( Xs
            = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )).

% Nil_tl
thf(fact_99_splice_Oelims,axiom,(
    ! [A: $tType,X3: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
      ( ( ( splice @ A @ X3 @ Xa )
        = Y )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ( ! [V: A,Va: ( list @ A )] :
              ( ( X3
                = ( cons @ A @ V @ Va ) )
             => ( ( Xa
                  = ( nil @ A ) )
               => ( Y
                 != ( cons @ A @ V @ Va ) ) ) )
         => ~ ( ! [X2: A,Xs3: ( list @ A )] :
                  ( ( X3
                    = ( cons @ A @ X2 @ Xs3 ) )
                 => ! [Y4: A,Ys4: ( list @ A )] :
                      ( ( Xa
                        = ( cons @ A @ Y4 @ Ys4 ) )
                     => ( Y
                       != ( cons @ A @ X2 @ ( cons @ A @ Y4 @ ( splice @ A @ Xs3 @ Ys4 ) ) ) ) ) ) ) ) ) ) )).

% splice.elims
thf(fact_100_splice_Osimps_I2_J,axiom,(
    ! [A: $tType,V2: A,Va2: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
      = ( cons @ A @ V2 @ Va2 ) ) )).

% splice.simps(2)
thf(fact_101_stream_Oexhaust__sel,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( Stream
      = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) )).

% stream.exhaust_sel
thf(fact_102_longest__common__suffix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
    ? [Ss: ( list @ A ),Xs2: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs2 @ Ss ) )
      & ( Ys
        = ( append @ A @ Ys2 @ Ss ) )
      & ( ( Xs2
          = ( nil @ A ) )
        | ( Ys2
          = ( nil @ A ) )
        | ( ( last @ A @ Xs2 )
         != ( last @ A @ Ys2 ) ) ) ) )).

% longest_common_suffix
thf(fact_103_last__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Ys ) ) ) ) )).

% last_append
thf(fact_104_last__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( ( tl @ A @ Xs )
         != ( nil @ A ) ) )
     => ( ( last @ A @ ( tl @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_tl
thf(fact_105_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( list @ A ) ),X3: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F @ ( cons @ B @ X3 @ Xs ) )
      = ( append @ A @ ( F @ X3 ) @ ( maps @ B @ A @ F @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_106_cycle_Ocode,axiom,(
    ! [A: $tType] :
      ( ( stream317748790_cycle @ A )
      = ( ^ [Xs4: ( list @ A )] :
            ( stream641971652_SCons @ A @ ( hd @ A @ Xs4 ) @ ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ Xs4 ) @ ( cons @ A @ ( hd @ A @ Xs4 ) @ ( nil @ A ) ) ) ) ) ) ) )).

% cycle.code
thf(fact_107_smember__code,axiom,(
    ! [A: $tType,X3: A,Y: A,S: ( stream170649215stream @ A )] :
      ( ( stream1586597341member @ A @ X3 @ ( stream641971652_SCons @ A @ Y @ S ) )
      = ( ( X3 != Y )
       => ( stream1586597341member @ A @ X3 @ S ) ) ) )).

% smember_code
thf(fact_108_rotate1__hd__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) )).

% rotate1_hd_tl
thf(fact_109_append__butlast__last__id,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) )).

% append_butlast_last_id
thf(fact_110_snoc__eq__iff__butlast,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A,Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) )
        = Ys )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X3 ) ) ) )).

% snoc_eq_iff_butlast
thf(fact_111_insert__Nil,axiom,(
    ! [A: $tType,X3: A] :
      ( ( insert @ A @ X3 @ ( nil @ A ) )
      = ( cons @ A @ X3 @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_112_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_113_remdups__adj__append,axiom,(
    ! [A: $tType,Xs_1: ( list @ A ),X3: A,Xs_2: ( list @ A )] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X3 @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs_2 ) ) ) ) ) )).

% remdups_adj_append
thf(fact_114_butlast__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
      = Xs ) )).

% butlast_snoc
thf(fact_115_remdups__adj__Nil__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% remdups_adj_Nil_iff
thf(fact_116_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_117_hd__remdups__adj,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) )).

% hd_remdups_adj
thf(fact_118_remdups__adj__Cons__alt,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X3 @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) ) ) )).

% remdups_adj_Cons_alt
thf(fact_119_remdups__adj_Osimps_I3_J,axiom,(
    ! [A: $tType,X3: A,Y: A,Xs: ( list @ A )] :
      ( ( ( X3 = Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X3 @ ( cons @ A @ Y @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs ) ) ) )
      & ( ( X3 != Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X3 @ ( cons @ A @ Y @ Xs ) ) )
          = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y @ Xs ) ) ) ) ) ) )).

% remdups_adj.simps(3)
thf(fact_120_remdups__adj_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% remdups_adj.simps(1)
thf(fact_121_butlast_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% butlast.simps(1)
thf(fact_122_butlast__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( butlast @ A @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( butlast @ A @ Xs ) ) ) )).

% butlast_tl
thf(fact_123_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_124_remdups__adj_Osimps_I2_J,axiom,(
    ! [A: $tType,X3: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) )
      = ( cons @ A @ X3 @ ( nil @ A ) ) ) )).

% remdups_adj.simps(2)
thf(fact_125_remdups__adj_Oelims,axiom,(
    ! [A: $tType,X3: ( list @ A ),Y: ( list @ A )] :
      ( ( ( remdups_adj @ A @ X3 )
        = Y )
     => ( ( ( X3
            = ( nil @ A ) )
         => ( Y
           != ( nil @ A ) ) )
       => ( ! [X2: A] :
              ( ( X3
                = ( cons @ A @ X2 @ ( nil @ A ) ) )
             => ( Y
               != ( cons @ A @ X2 @ ( nil @ A ) ) ) )
         => ~ ( ! [X2: A,Y4: A,Xs3: ( list @ A )] :
                  ( ( X3
                    = ( cons @ A @ X2 @ ( cons @ A @ Y4 @ Xs3 ) ) )
                 => ~ ( ( ( X2 = Y4 )
                       => ( Y
                          = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs3 ) ) ) )
                      & ( ( X2 != Y4 )
                       => ( Y
                          = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y4 @ Xs3 ) ) ) ) ) ) ) ) ) ) ) )).

% remdups_adj.elims
thf(fact_126_butlast_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X3 @ Xs ) )
          = ( cons @ A @ X3 @ ( butlast @ A @ Xs ) ) ) ) ) )).

% butlast.simps(2)
thf(fact_127_butlast__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys ) ) ) ) ) )).

% butlast_append
thf(fact_128_remdups__adj__append__two,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A,Y: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X3 = Y ) @ ( nil @ A ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) )).

% remdups_adj_append_two
thf(fact_129_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_130_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_131_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_132_map__tailrec__rev_Oelims,axiom,(
    ! [A: $tType,B: $tType,X3: ( A > B ),Xa: ( list @ A ),Xb: ( list @ B ),Y: ( list @ B )] :
      ( ( ( map_tailrec_rev @ A @ B @ X3 @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb ) )
       => ~ ( ! [A4: A,As: ( list @ A )] :
                ( ( Xa
                  = ( cons @ A @ A4 @ As ) )
               => ( Y
                 != ( map_tailrec_rev @ A @ B @ X3 @ As @ ( cons @ B @ ( X3 @ A4 ) @ Xb ) ) ) ) ) ) ) )).

% map_tailrec_rev.elims
thf(fact_133_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X3 @ Y )
        | ( ~ ( Less @ Y @ X3 )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_134_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_135_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_136_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_137_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X3 @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_138_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X3: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X3 @ Y )
     => ( ~ ( Less @ Y @ X3 )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_139_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_140_map__tailrec__rev_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A2: A,As2: ( list @ A ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F @ ( cons @ A @ A2 @ As2 ) @ Bs2 )
      = ( map_tailrec_rev @ A @ B @ F @ As2 @ ( cons @ B @ ( F @ A2 ) @ Bs2 ) ) ) )).

% map_tailrec_rev.simps(2)
thf(fact_141_map__tailrec__rev_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F @ ( nil @ A ) @ Bs2 )
      = Bs2 ) )).

% map_tailrec_rev.simps(1)
thf(fact_142_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X1 @ X23 )
     => ( ! [X12: ( list @ A )] :
            ( P @ ( nil @ A ) @ X12 )
       => ( ! [X2: A,Y4: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
              ( ( Less @ X2 @ Y4 )
             => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
         => ( ! [X2: A,Y4: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                ( ~ ( Less @ X2 @ Y4 )
               => ( ~ ( Less @ Y4 @ X2 )
                 => ( ( lexordp_eq @ A @ Less @ Xs3 @ Ys4 )
                   => ( ( P @ Xs3 @ Ys4 )
                     => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) )
           => ( P @ X1 @ X23 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_143_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys3 ) )
            | ? [X: A,Y3: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs4 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ( Less2 @ X @ Y3 ) )
            | ? [X: A,Y3: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs4 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ~ ( Less2 @ X @ Y3 )
                & ~ ( Less2 @ Y3 @ X )
                & ( lexordp_eq @ A @ Less2 @ Xs4 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_144_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys4: ( list @ A )] : ( A22 != Ys4 ) )
       => ( ! [X2: A] :
              ( ? [Xs3: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X2 @ Xs3 ) )
             => ! [Y4: A] :
                  ( ? [Ys4: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y4 @ Ys4 ) )
                 => ~ ( Less @ X2 @ Y4 ) ) )
         => ~ ( ! [X2: A,Y4: A,Xs3: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs3 ) )
                 => ! [Ys4: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y4 @ Ys4 ) )
                     => ( ~ ( Less @ X2 @ Y4 )
                       => ( ~ ( Less @ Y4 @ X2 )
                         => ~ ( lexordp_eq @ A @ Less @ Xs3 @ Ys4 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_145_smap__ctr,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),S: ( stream170649215stream @ B ),X3: A,S4: ( stream170649215stream @ A )] :
      ( ( ( stream2128578057e_smap @ B @ A @ F @ S )
        = ( stream641971652_SCons @ A @ X3 @ S4 ) )
      = ( ( ( F @ ( stream_Mirabelle_shd @ B @ S ) )
          = X3 )
        & ( ( stream2128578057e_smap @ B @ A @ F @ ( stream_Mirabelle_stl @ B @ S ) )
          = S4 ) ) ) )).

% smap_ctr
thf(fact_146_SuccI,axiom,(
    ! [A: $tType,Kl: ( list @ A ),K: A,Kl2: ( set @ ( list @ A ) )] :
      ( ( member2 @ ( list @ A ) @ ( append @ A @ Kl @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl2 )
     => ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl2 @ Kl ) ) ) )).

% SuccI
thf(fact_147_SuccD,axiom,(
    ! [A: $tType,K: A,Kl2: ( set @ ( list @ A ) ),Kl: ( list @ A )] :
      ( ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl2 @ Kl ) )
     => ( member2 @ ( list @ A ) @ ( append @ A @ Kl @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl2 ) ) )).

% SuccD
thf(fact_148_rev__eq__Cons__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) )).

% rev_eq_Cons_iff
thf(fact_149_rev__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) )).

% rev_is_rev_conv
thf(fact_150_rev__rev__ident,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) )).

% rev_rev_ident
thf(fact_151_Nil__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% Nil_is_rev_conv
thf(fact_152_rev__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rev_is_Nil_conv
thf(fact_153_rev__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) )).

% rev_append
thf(fact_154_remdups__adj__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) )).

% remdups_adj_rev
thf(fact_155_stream_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ B @ ( stream2128578057e_smap @ A @ B @ F @ A2 ) )
      = ( stream2128578057e_smap @ A @ B @ F @ ( stream_Mirabelle_stl @ A @ A2 ) ) ) )).

% stream.map_sel(2)
thf(fact_156_stream_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ B @ ( stream2128578057e_smap @ A @ B @ F @ A2 ) )
      = ( F @ ( stream_Mirabelle_shd @ A @ A2 ) ) ) )).

% stream.map_sel(1)
thf(fact_157_rev__singleton__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X3: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X3 @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )).

% rev_singleton_conv
thf(fact_158_singleton__rev__conv,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ( ( ( cons @ A @ X3 @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )).

% singleton_rev_conv
thf(fact_159_stream_Omap,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X1: A,X23: ( stream170649215stream @ A )] :
      ( ( stream2128578057e_smap @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X23 ) )
      = ( stream641971652_SCons @ B @ ( F @ X1 ) @ ( stream2128578057e_smap @ A @ B @ F @ X23 ) ) ) )).

% stream.map
thf(fact_160_rev__swap,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) )).

% rev_swap
thf(fact_161_rev_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rev.simps(1)
thf(fact_162_rev_Osimps_I2_J,axiom,(
    ! [A: $tType,X3: A,Xs: ( list @ A )] :
      ( ( rev @ A @ ( cons @ A @ X3 @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )).

% rev.simps(2)
thf(fact_163_hd__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rev @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% hd_rev
thf(fact_164_last__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( rev @ A @ Xs ) )
        = ( hd @ A @ Xs ) ) ) )).

% last_rev
thf(fact_165_map__tailrec__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map_tailrec @ A @ B )
      = ( ^ [F3: ( A > B ),As3: ( list @ A )] :
            ( rev @ B @ ( map_tailrec_rev @ A @ B @ F3 @ As3 @ ( nil @ B ) ) ) ) ) )).

% map_tailrec_def
thf(fact_166_BNF__Greatest__Fixpoint_Oshift__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Greatest_shift @ A @ B )
      = ( ^ [Lab: ( ( list @ A ) > B ),K2: A,Kl3: ( list @ A )] :
            ( Lab @ ( cons @ A @ K2 @ Kl3 ) ) ) ) )).

% BNF_Greatest_Fixpoint.shift_def
thf(fact_167_empty__Shift,axiom,(
    ! [A: $tType,Kl2: ( set @ ( list @ A ) ),K: A] :
      ( ( member2 @ ( list @ A ) @ ( nil @ A ) @ Kl2 )
     => ( ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl2 @ ( nil @ A ) ) )
       => ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( bNF_Greatest_Shift @ A @ Kl2 @ K ) ) ) ) )).

% empty_Shift
thf(fact_168_ShiftD,axiom,(
    ! [A: $tType,Kl: ( list @ A ),Kl2: ( set @ ( list @ A ) ),K: A] :
      ( ( member2 @ ( list @ A ) @ Kl @ ( bNF_Greatest_Shift @ A @ Kl2 @ K ) )
     => ( member2 @ ( list @ A ) @ ( cons @ A @ K @ Kl ) @ Kl2 ) ) )).

% ShiftD
thf(fact_169_Succ__Shift,axiom,(
    ! [A: $tType,Kl2: ( set @ ( list @ A ) ),K: A,Kl: ( list @ A )] :
      ( ( bNF_Greatest_Succ @ A @ ( bNF_Greatest_Shift @ A @ Kl2 @ K ) @ Kl )
      = ( bNF_Greatest_Succ @ A @ Kl2 @ ( cons @ A @ K @ Kl ) ) ) )).

% Succ_Shift
thf(fact_170_listrelp_Oinducts,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),X1: ( list @ A ),X23: ( list @ B ),P: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( listrelp @ A @ B @ R2 @ X1 @ X23 )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X2: A,Y4: B,Xs3: ( list @ A ),Ys4: ( list @ B )] :
              ( ( R2 @ X2 @ Y4 )
             => ( ( listrelp @ A @ B @ R2 @ Xs3 @ Ys4 )
               => ( ( P @ Xs3 @ Ys4 )
                 => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ B @ Y4 @ Ys4 ) ) ) ) )
         => ( P @ X1 @ X23 ) ) ) ) )).

% listrelp.inducts
thf(fact_171_listrelp_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R3: ( A > B > $o ),A12: ( list @ A ),A23: ( list @ B )] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A23
                = ( nil @ B ) ) )
            | ? [X: A,Y3: B,Xs4: ( list @ A ),Ys3: ( list @ B )] :
                ( ( A12
                  = ( cons @ A @ X @ Xs4 ) )
                & ( A23
                  = ( cons @ B @ Y3 @ Ys3 ) )
                & ( R3 @ X @ Y3 )
                & ( listrelp @ A @ B @ R3 @ Xs4 @ Ys3 ) ) ) ) ) )).

% listrelp.simps
thf(fact_172_listrelp_Ocases,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ( listrelp @ A @ B @ R2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ( ! [X2: A,Y4: B,Xs3: ( list @ A )] :
                ( ( A1
                  = ( cons @ A @ X2 @ Xs3 ) )
               => ! [Ys4: ( list @ B )] :
                    ( ( A22
                      = ( cons @ B @ Y4 @ Ys4 ) )
                   => ( ( R2 @ X2 @ Y4 )
                     => ~ ( listrelp @ A @ B @ R2 @ Xs3 @ Ys4 ) ) ) ) ) ) ) )).

% listrelp.cases
thf(fact_173_listrelp_OCons,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),X3: A,Y: B,Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( R2 @ X3 @ Y )
     => ( ( listrelp @ A @ B @ R2 @ Xs @ Ys )
       => ( listrelp @ A @ B @ R2 @ ( cons @ A @ X3 @ Xs ) @ ( cons @ B @ Y @ Ys ) ) ) ) )).

% listrelp.Cons
thf(fact_174_listrelp_ONil,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o )] :
      ( listrelp @ A @ B @ R2 @ ( nil @ A ) @ ( nil @ B ) ) )).

% listrelp.Nil
thf(fact_175_lexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Xs: ( list @ A )] :
          ~ ( ord_lexordp_eq @ A @ ( cons @ A @ X3 @ Xs ) @ ( nil @ A ) ) ) )).

% lexordp_eq_simps(3)
thf(fact_176_fold__Cons__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs )
      = ( append @ A @ ( rev @ A @ Xs ) ) ) )).

% fold_Cons_rev
thf(fact_177_rev__conv__fold,axiom,(
    ! [A: $tType] :
      ( ( rev @ A )
      = ( ^ [Xs4: ( list @ A )] :
            ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs4 @ ( nil @ A ) ) ) ) )).

% rev_conv_fold
thf(fact_178_lexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) )).

% lexordp_eq_simps(1)
thf(fact_179_lexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ ( nil @ A ) )
          = ( Xs
            = ( nil @ A ) ) ) ) )).

% lexordp_eq_simps(2)
thf(fact_180_lexordp__eq_ONil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) )).

% lexordp_eq.Nil
thf(fact_181_fold__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A > A ),X3: B,Xs: ( list @ B ),S: A] :
      ( ( fold @ B @ A @ F @ ( cons @ B @ X3 @ Xs ) @ S )
      = ( fold @ B @ A @ F @ Xs @ ( F @ X3 @ S ) ) ) )).

% fold_simps(2)
thf(fact_182_fold__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A > A ),S: A] :
      ( ( fold @ B @ A @ F @ ( nil @ B ) @ S )
      = S ) )).

% fold_simps(1)
thf(fact_183_lexordp__eq__refl,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ord_lexordp_eq @ A @ Xs @ Xs ) ) )).

% lexordp_eq_refl
thf(fact_184_lexordp__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Zs )
           => ( ord_lexordp_eq @ A @ Xs @ Zs ) ) ) ) )).

% lexordp_eq_trans
thf(fact_185_lexordp__eq__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
          | ( ord_lexordp_eq @ A @ Ys @ Xs ) ) ) )).

% lexordp_eq_linear
thf(fact_186_lexordp__eq__antisym,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Xs )
           => ( Xs = Ys ) ) ) ) )).

% lexordp_eq_antisym
thf(fact_187_List_Ounion__def,axiom,(
    ! [A: $tType] :
      ( ( union @ A )
      = ( fold @ A @ ( list @ A ) @ ( insert @ A ) ) ) )).

% List.union_def
thf(fact_188_lexordp__eq_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp_eq @ A @ X1 @ X23 )
         => ( ! [X12: ( list @ A )] :
                ( P @ ( nil @ A ) @ X12 )
           => ( ! [X2: A,Y4: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                  ( ( ord_less @ A @ X2 @ Y4 )
                 => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
             => ( ! [X2: A,Y4: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                    ( ~ ( ord_less @ A @ X2 @ Y4 )
                   => ( ~ ( ord_less @ A @ Y4 @ X2 )
                     => ( ( ord_lexordp_eq @ A @ Xs3 @ Ys4 )
                       => ( ( P @ Xs3 @ Ys4 )
                         => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) )
               => ( P @ X1 @ X23 ) ) ) ) ) ) )).

% lexordp_eq.inducts
thf(fact_189_lexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [A12: ( list @ A ),A23: ( list @ A )] :
              ( ? [Ys3: ( list @ A )] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A23 = Ys3 ) )
              | ? [X: A,Y3: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ( ord_less @ A @ X @ Y3 ) )
              | ? [X: A,Y3: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ~ ( ord_less @ A @ X @ Y3 )
                  & ~ ( ord_less @ A @ Y3 @ X )
                  & ( ord_lexordp_eq @ A @ Xs4 @ Ys3 ) ) ) ) ) ) )).

% lexordp_eq.simps
thf(fact_190_lexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) )
          = ( ( ord_less @ A @ X3 @ Y )
            | ( ~ ( ord_less @ A @ Y @ X3 )
              & ( ord_lexordp_eq @ A @ Xs @ Ys ) ) ) ) ) )).

% lexordp_eq_simps(4)
thf(fact_191_lexordp__eq_OCons__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ~ ( ord_less @ A @ X3 @ Y )
         => ( ~ ( ord_less @ A @ Y @ X3 )
           => ( ( ord_lexordp_eq @ A @ Xs @ Ys )
             => ( ord_lexordp_eq @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ) )).

% lexordp_eq.Cons_eq
thf(fact_192_lexordp__eq_OCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ord_lexordp_eq @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) )).

% lexordp_eq.Cons
thf(fact_193_lexordp__eq_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A1: ( list @ A ),A22: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ A1 @ A22 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Ys4: ( list @ A )] : ( A22 != Ys4 ) )
           => ( ! [X2: A] :
                  ( ? [Xs3: ( list @ A )] :
                      ( A1
                      = ( cons @ A @ X2 @ Xs3 ) )
                 => ! [Y4: A] :
                      ( ? [Ys4: ( list @ A )] :
                          ( A22
                          = ( cons @ A @ Y4 @ Ys4 ) )
                     => ~ ( ord_less @ A @ X2 @ Y4 ) ) )
             => ~ ( ! [X2: A,Y4: A,Xs3: ( list @ A )] :
                      ( ( A1
                        = ( cons @ A @ X2 @ Xs3 ) )
                     => ! [Ys4: ( list @ A )] :
                          ( ( A22
                            = ( cons @ A @ Y4 @ Ys4 ) )
                         => ( ~ ( ord_less @ A @ X2 @ Y4 )
                           => ( ~ ( ord_less @ A @ Y4 @ X2 )
                             => ~ ( ord_lexordp_eq @ A @ Xs3 @ Ys4 ) ) ) ) ) ) ) ) ) ) )).

% lexordp_eq.cases
thf(fact_194_lexordp__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs4: ( list @ A ),Ys3: ( list @ A )] :
              ( ? [X: A,Vs: ( list @ A )] :
                  ( Ys3
                  = ( append @ A @ Xs4 @ ( cons @ A @ X @ Vs ) ) )
              | ? [Us2: ( list @ A ),A5: A,B2: A,Vs: ( list @ A ),Ws: ( list @ A )] :
                  ( ( ord_less @ A @ A5 @ B2 )
                  & ( Xs4
                    = ( append @ A @ Us2 @ ( cons @ A @ A5 @ Vs ) ) )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ B2 @ Ws ) ) ) ) ) ) ) ) )).

% lexordp_iff
thf(fact_195_lexordp__append__left__rightI,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Us: ( list @ A ),Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ord_lexordp @ A @ ( append @ A @ Us @ ( cons @ A @ X3 @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% lexordp_append_left_rightI
thf(fact_196_lexordp__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ( ord_lexordp @ A @ ( nil @ A ) @ Ys )
          = ( Ys
           != ( nil @ A ) ) ) ) )).

% lexordp_simps(1)
thf(fact_197_lexordp__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ~ ( ord_lexordp @ A @ Xs @ ( nil @ A ) ) ) )).

% lexordp_simps(2)
thf(fact_198_lexordp__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
          ( ( ord_lexordp @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) )
          = ( ( ord_less @ A @ X3 @ Y )
            | ( ~ ( ord_less @ A @ Y @ X3 )
              & ( ord_lexordp @ A @ Xs @ Ys ) ) ) ) ) )).

% lexordp_simps(3)
thf(fact_199_lexordp__irreflexive,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ! [X2: A] :
              ~ ( ord_less @ A @ X2 @ X2 )
         => ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ) )).

% lexordp_irreflexive
thf(fact_200_lexordp__antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ~ ( ord_lexordp @ A @ Ys @ Xs ) ) ) )).

% lexordp_antisym
thf(fact_201_lexordp__trans,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ( ord_lexordp @ A @ Ys @ Zs )
           => ( ord_lexordp @ A @ Xs @ Zs ) ) ) ) )).

% lexordp_trans
thf(fact_202_lexordp__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
          | ( Xs = Ys )
          | ( ord_lexordp @ A @ Ys @ Xs ) ) ) )).

% lexordp_linear
thf(fact_203_lexordp__irreflexive_H,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ~ ( ord_lexordp @ A @ Xs @ Xs ) ) )).

% lexordp_irreflexive'
thf(fact_204_lexordp__append__leftI,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Us: ( list @ A ),Vs2: ( list @ A ),Xs: ( list @ A )] :
          ( ( ord_lexordp @ A @ Us @ Vs2 )
         => ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs2 ) ) ) ) )).

% lexordp_append_leftI
thf(fact_205_lexordp__conv__lexordp__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs4: ( list @ A ),Ys3: ( list @ A )] :
              ( ( ord_lexordp_eq @ A @ Xs4 @ Ys3 )
              & ~ ( ord_lexordp_eq @ A @ Ys3 @ Xs4 ) ) ) ) ) )).

% lexordp_conv_lexordp_eq
thf(fact_206_lexordp__eq__conv__lexord,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [Xs4: ( list @ A ),Ys3: ( list @ A )] :
              ( ( Xs4 = Ys3 )
              | ( ord_lexordp @ A @ Xs4 @ Ys3 ) ) ) ) ) )).

% lexordp_eq_conv_lexord
thf(fact_207_lexordp__into__lexordp__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ord_lexordp_eq @ A @ Xs @ Ys ) ) ) )).

% lexordp_into_lexordp_eq
thf(fact_208_lexordp_OCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_less @ A @ X3 @ Y )
         => ( ord_lexordp @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) )).

% lexordp.Cons
thf(fact_209_lexordp_OCons__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X3: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ~ ( ord_less @ A @ X3 @ Y )
         => ( ~ ( ord_less @ A @ Y @ X3 )
           => ( ( ord_lexordp @ A @ Xs @ Ys )
             => ( ord_lexordp @ A @ ( cons @ A @ X3 @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ) )).

% lexordp.Cons_eq
thf(fact_210_lexordp_ONil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Y: A,Ys: ( list @ A )] :
          ( ord_lexordp @ A @ ( nil @ A ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% lexordp.Nil
thf(fact_211_lexordp__append__leftD,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Us: ( list @ A ),Vs2: ( list @ A )] :
          ( ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs2 ) )
         => ( ! [A4: A] :
                ~ ( ord_less @ A @ A4 @ A4 )
           => ( ord_lexordp @ A @ Us @ Vs2 ) ) ) ) )).

% lexordp_append_leftD
thf(fact_212_lexordp__append__rightI,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A ),Xs: ( list @ A )] :
          ( ( Ys
           != ( nil @ A ) )
         => ( ord_lexordp @ A @ Xs @ ( append @ A @ Xs @ Ys ) ) ) ) )).

% lexordp_append_rightI
thf(fact_213_lexordp__induct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ! [Y4: A,Ys4: ( list @ A )] :
                ( P @ ( nil @ A ) @ ( cons @ A @ Y4 @ Ys4 ) )
           => ( ! [X2: A,Xs3: ( list @ A ),Y4: A,Ys4: ( list @ A )] :
                  ( ( ord_less @ A @ X2 @ Y4 )
                 => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
             => ( ! [X2: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                    ( ( ord_lexordp @ A @ Xs3 @ Ys4 )
                   => ( ( P @ Xs3 @ Ys4 )
                     => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ X2 @ Ys4 ) ) ) )
               => ( P @ Xs @ Ys ) ) ) ) ) ) )).

% lexordp_induct
thf(fact_214_lexordp__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ! [Y4: A,Ys2: ( list @ A )] :
                  ( Ys
                 != ( cons @ A @ Y4 @ Ys2 ) ) )
           => ( ! [X2: A] :
                  ( ? [Xs2: ( list @ A )] :
                      ( Xs
                      = ( cons @ A @ X2 @ Xs2 ) )
                 => ! [Y4: A] :
                      ( ? [Ys2: ( list @ A )] :
                          ( Ys
                          = ( cons @ A @ Y4 @ Ys2 ) )
                     => ~ ( ord_less @ A @ X2 @ Y4 ) ) )
             => ~ ( ! [X2: A,Xs2: ( list @ A )] :
                      ( ( Xs
                        = ( cons @ A @ X2 @ Xs2 ) )
                     => ! [Ys2: ( list @ A )] :
                          ( ( Ys
                            = ( cons @ A @ X2 @ Ys2 ) )
                         => ~ ( ord_lexordp @ A @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) )).

% lexordp_cases
thf(fact_215_lexordp_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X1: ( list @ A ),X23: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp @ A @ X1 @ X23 )
         => ( ! [Y4: A,Ys4: ( list @ A )] :
                ( P @ ( nil @ A ) @ ( cons @ A @ Y4 @ Ys4 ) )
           => ( ! [X2: A,Y4: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                  ( ( ord_less @ A @ X2 @ Y4 )
                 => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
             => ( ! [X2: A,Y4: A,Xs3: ( list @ A ),Ys4: ( list @ A )] :
                    ( ~ ( ord_less @ A @ X2 @ Y4 )
                   => ( ~ ( ord_less @ A @ Y4 @ X2 )
                     => ( ( ord_lexordp @ A @ Xs3 @ Ys4 )
                       => ( ( P @ Xs3 @ Ys4 )
                         => ( P @ ( cons @ A @ X2 @ Xs3 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) )
               => ( P @ X1 @ X23 ) ) ) ) ) ) )).

% lexordp.inducts
thf(fact_216_lexordp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp @ A )
        = ( ^ [A12: ( list @ A ),A23: ( list @ A )] :
              ( ? [Y3: A,Ys3: ( list @ A )] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys3 ) ) )
              | ? [X: A,Y3: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ( ord_less @ A @ X @ Y3 ) )
              | ? [X: A,Y3: A,Xs4: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X @ Xs4 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ~ ( ord_less @ A @ X @ Y3 )
                  & ~ ( ord_less @ A @ Y3 @ X )
                  & ( ord_lexordp @ A @ Xs4 @ Ys3 ) ) ) ) ) ) )).

% lexordp.simps
thf(fact_217_lexordp_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A1: ( list @ A ),A22: ( list @ A )] :
          ( ( ord_lexordp @ A @ A1 @ A22 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Y4: A,Ys4: ( list @ A )] :
                  ( A22
                 != ( cons @ A @ Y4 @ Ys4 ) ) )
           => ( ! [X2: A] :
                  ( ? [Xs3: ( list @ A )] :
                      ( A1
                      = ( cons @ A @ X2 @ Xs3 ) )
                 => ! [Y4: A] :
                      ( ? [Ys4: ( list @ A )] :
                          ( A22
                          = ( cons @ A @ Y4 @ Ys4 ) )
                     => ~ ( ord_less @ A @ X2 @ Y4 ) ) )
             => ~ ( ! [X2: A,Y4: A,Xs3: ( list @ A )] :
                      ( ( A1
                        = ( cons @ A @ X2 @ Xs3 ) )
                     => ! [Ys4: ( list @ A )] :
                          ( ( A22
                            = ( cons @ A @ Y4 @ Ys4 ) )
                         => ( ~ ( ord_less @ A @ X2 @ Y4 )
                           => ( ~ ( ord_less @ A @ Y4 @ X2 )
                             => ~ ( ord_lexordp @ A @ Xs3 @ Ys4 ) ) ) ) ) ) ) ) ) ) )).

% lexordp.cases
thf(fact_218_map__tailrec__rev,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( map_tailrec_rev @ B @ A )
      = ( ^ [F3: ( B > A ),As3: ( list @ B )] :
            ( append @ A @ ( rev @ A @ ( map @ B @ A @ F3 @ As3 ) ) ) ) ) )).

% map_tailrec_rev
thf(fact_219_replicate__append__same,axiom,(
    ! [A: $tType,I: nat,X3: A] :
      ( ( append @ A @ ( replicate @ A @ I @ X3 ) @ ( cons @ A @ X3 @ ( nil @ A ) ) )
      = ( cons @ A @ X3 @ ( replicate @ A @ I @ X3 ) ) ) )).

% replicate_append_same
thf(fact_220_Nil__is__map__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% Nil_is_map_conv
thf(fact_221_map__is__Nil__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% map_is_Nil_conv
thf(fact_222_list_Omap__disc__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( list @ A )] :
      ( ( ( map @ A @ B @ F @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) )).

% list.map_disc_iff
thf(fact_223_map__append,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),Ys: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F @ Xs ) @ ( map @ B @ A @ F @ Ys ) ) ) )).

% map_append
thf(fact_224_map__replicate,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),N: nat,X3: B] :
      ( ( map @ B @ A @ F @ ( replicate @ B @ N @ X3 ) )
      = ( replicate @ A @ N @ ( F @ X3 ) ) ) )).

% map_replicate
thf(fact_225_rev__replicate,axiom,(
    ! [A: $tType,N: nat,X3: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X3 ) )
      = ( replicate @ A @ N @ X3 ) ) )).

% rev_replicate
thf(fact_226_smap__shift,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),S: ( stream170649215stream @ B )] :
      ( ( stream2128578057e_smap @ B @ A @ F @ ( stream1035003186_shift @ B @ Xs @ S ) )
      = ( stream1035003186_shift @ A @ ( map @ B @ A @ F @ Xs ) @ ( stream2128578057e_smap @ B @ A @ F @ S ) ) ) )).

% smap_shift
thf(fact_227_hd__map,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),F: ( A > B )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F @ Xs ) )
        = ( F @ ( hd @ A @ Xs ) ) ) ) )).

% hd_map
thf(fact_228_list_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( list @ A ),F: ( A > B )] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F @ A2 ) )
        = ( F @ ( hd @ A @ A2 ) ) ) ) )).

% list.map_sel(1)
thf(fact_229_last__map,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),F: ( A > B )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ B @ ( map @ A @ B @ F @ Xs ) )
        = ( F @ ( last @ A @ Xs ) ) ) ) )).

% last_map
thf(fact_230_append__replicate__commute,axiom,(
    ! [A: $tType,N: nat,X3: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X3 ) @ ( replicate @ A @ K @ X3 ) )
      = ( append @ A @ ( replicate @ A @ K @ X3 ) @ ( replicate @ A @ N @ X3 ) ) ) )).

% append_replicate_commute
thf(fact_231_map__tl,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F @ Xs ) ) ) )).

% map_tl
thf(fact_232_list_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B )] :
      ( ( map @ A @ B @ F @ ( nil @ A ) )
      = ( nil @ B ) ) )).

% list.simps(8)
thf(fact_233_list_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X21: A,X22: ( list @ A )] :
      ( ( map @ A @ B @ F @ ( cons @ A @ X21 @ X22 ) )
      = ( cons @ B @ ( F @ X21 ) @ ( map @ A @ B @ F @ X22 ) ) ) )).

% list.simps(9)
thf(fact_234_Cons__eq__map__D,axiom,(
    ! [A: $tType,B: $tType,X3: A,Xs: ( list @ A ),F: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( map @ B @ A @ F @ Ys ) )
     => ? [Z: B,Zs2: ( list @ B )] :
          ( ( Ys
            = ( cons @ B @ Z @ Zs2 ) )
          & ( X3
            = ( F @ Z ) )
          & ( Xs
            = ( map @ B @ A @ F @ Zs2 ) ) ) ) )).

% Cons_eq_map_D
thf(fact_235_map__eq__Cons__D,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z: B,Zs2: ( list @ B )] :
          ( ( Xs
            = ( cons @ B @ Z @ Zs2 ) )
          & ( ( F @ Z )
            = Y )
          & ( ( map @ B @ A @ F @ Zs2 )
            = Ys ) ) ) )).

% map_eq_Cons_D
thf(fact_236_Cons__eq__map__conv,axiom,(
    ! [A: $tType,B: $tType,X3: A,Xs: ( list @ A ),F: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X3 @ Xs )
        = ( map @ B @ A @ F @ Ys ) )
      = ( ? [Z2: B,Zs3: ( list @ B )] :
            ( ( Ys
              = ( cons @ B @ Z2 @ Zs3 ) )
            & ( X3
              = ( F @ Z2 ) )
            & ( Xs
              = ( map @ B @ A @ F @ Zs3 ) ) ) ) ) )).

% Cons_eq_map_conv
thf(fact_237_map__eq__Cons__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( cons @ A @ Y @ Ys ) )
      = ( ? [Z2: B,Zs3: ( list @ B )] :
            ( ( Xs
              = ( cons @ B @ Z2 @ Zs3 ) )
            & ( ( F @ Z2 )
              = Y )
            & ( ( map @ B @ A @ F @ Zs3 )
              = Ys ) ) ) ) )).

% map_eq_Cons_conv
thf(fact_238_map__butlast,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( butlast @ B @ Xs ) )
      = ( butlast @ A @ ( map @ B @ A @ F @ Xs ) ) ) )).

% map_butlast
thf(fact_239_rev__map,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( rev @ A @ ( map @ B @ A @ F @ Xs ) )
      = ( map @ B @ A @ F @ ( rev @ B @ Xs ) ) ) )).

% rev_map
thf(fact_240_map__eq__map__tailrec,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) )).

% map_eq_map_tailrec
thf(fact_241_list_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( list @ A ),F: ( A > B )] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F @ A2 ) )
        = ( map @ A @ B @ F @ ( tl @ A @ A2 ) ) ) ) )).

% list.map_sel(2)
thf(fact_242_replicate__app__Cons__same,axiom,(
    ! [A: $tType,N: nat,X3: A,Xs: ( list @ A )] :
      ( ( append @ A @ ( replicate @ A @ N @ X3 ) @ ( cons @ A @ X3 @ Xs ) )
      = ( cons @ A @ X3 @ ( append @ A @ ( replicate @ A @ N @ X3 ) @ Xs ) ) ) )).

% replicate_app_Cons_same
thf(fact_243_remdups__adj__replicate,axiom,(
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X3 ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X3 ) )
          = ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )).

% remdups_adj_replicate
thf(fact_244_stake__smap,axiom,(
    ! [A: $tType,B: $tType,N: nat,F: ( B > A ),S: ( stream170649215stream @ B )] :
      ( ( stream1746350922_stake @ A @ N @ ( stream2128578057e_smap @ B @ A @ F @ S ) )
      = ( map @ B @ A @ F @ ( stream1746350922_stake @ B @ N @ S ) ) ) )).

% stake_smap
thf(fact_245_replicate__eq__replicate,axiom,(
    ! [A: $tType,M: nat,X3: A,N: nat,Y: A] :
      ( ( ( replicate @ A @ M @ X3 )
        = ( replicate @ A @ N @ Y ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X3 = Y ) ) ) ) )).

% replicate_eq_replicate
thf(fact_246_replicate__empty,axiom,(
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( replicate @ A @ N @ X3 )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) )).

% replicate_empty
thf(fact_247_empty__replicate,axiom,(
    ! [A: $tType,N: nat,X3: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X3 ) )
      = ( N
        = ( zero_zero @ nat ) ) ) )).

% empty_replicate
thf(fact_248_stake__invert__Nil,axiom,(
    ! [A: $tType,N: nat,S: ( stream170649215stream @ A )] :
      ( ( ( stream1746350922_stake @ A @ N @ S )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) )).

% stake_invert_Nil
thf(fact_249_hd__replicate,axiom,(
    ! [A: $tType,N: nat,X3: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X3 ) )
        = X3 ) ) )).

% hd_replicate
thf(fact_250_last__replicate,axiom,(
    ! [A: $tType,N: nat,X3: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N @ X3 ) )
        = X3 ) ) )).

% last_replicate
thf(fact_251_replicate__0,axiom,(
    ! [A: $tType,X3: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X3 )
      = ( nil @ A ) ) )).

% replicate_0
thf(fact_252_stake_Osimps_I1_J,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A )] :
      ( ( stream1746350922_stake @ A @ ( zero_zero @ nat ) @ S )
      = ( nil @ A ) ) )).

% stake.simps(1)
thf(fact_253_n__lists__Nil,axiom,(
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) )).

% n_lists_Nil
thf(fact_254_n__lists_Osimps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% n_lists.simps(1)

%----Type constructors (10)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_1,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_2,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder_3,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_4,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_5,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_6,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_7,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X3: A,Y: A] :
      ( ( if @ A @ $false @ X3 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X3: A,Y: A] :
      ( ( if @ A @ $true @ X3 @ Y )
      = X3 ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    u
 != ( nil @ a ) )).

thf(conj_1,conjecture,
    ( ( stream317748790_cycle @ a @ u )
    = ( stream1035003186_shift @ a @ u @ ( stream317748790_cycle @ a @ u ) ) )).

%------------------------------------------------------------------------------
