%------------------------------------------------------------------------------
% File     : DAT250^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Infinite streams (sequences/lists) 347
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream__347.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  325 (   0 unit;  58 type;   0 defn)
%            Number of atoms       : 4403 ( 394 equality;2775 variable)
%            Maximal formula depth :   27 (  10 average)
%            Number of connectives : 3988 (  96   ~;  16   |;  76   &;3561   @)
%                                         (   0 <=>; 239  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  223 ( 223   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   62 (  58   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1116 (   0 sgn; 961   !;  63   ?;  36   ^)
%                                         (1116   :;  56  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:42:05.107
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Stream__Mirabelle__hbrgyiwlrc_Ostream,type,(
    stream170649215stream: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (52)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Olattice,type,(
    lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Osemilattice__sup,type,(
    semilattice_sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,(
    bNF_Greatest_Shift: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,(
    bNF_Greatest_Succ: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oshift,type,(
    bNF_Greatest_shift: 
      !>[A: $tType,B: $tType] :
        ( ( ( list @ A ) > B ) > A > ( list @ A ) > B ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Ocan__select,type,(
    can_select: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_List_Ogen__length,type,(
    gen_length: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > nat ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Ocase__list,type,(
    case_list: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) )).

thf(sy_c_List_Olist_Ohd,type,(
    hd: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_Olist__all,type,(
    list_all: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Olist_Otl,type,(
    tl: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_On__lists,type,(
    n_lists: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Otake,type,(
    take: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Ounion,type,(
    union: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Nat_OSuc,type,(
    suc: nat > nat )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert2: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ocycle,type,(
    stream317748790_cycle: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osdrop,type,(
    stream135081970_sdrop: 
      !>[A: $tType] :
        ( nat > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osdrop__while,type,(
    stream1195056575_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Oshift,type,(
    stream1035003186_shift: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osmember,type,(
    stream1586597341member: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osnth,type,(
    stream370371455e_snth: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > nat > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostake,type,(
    stream1746350922_stake: 
      !>[A: $tType] :
        ( nat > ( stream170649215stream @ A ) > ( list @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_OSCons,type,(
    stream641971652_SCons: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocase__stream,type,(
    stream1342653232stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream170649215stream @ A ) > B ) > ( stream170649215stream @ A ) > B ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Opred__stream,type,(
    stream1153105665stream: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Oshd,type,(
    stream_Mirabelle_shd: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osmap,type,(
    stream2128578057e_smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream170649215stream @ A ) > ( stream170649215stream @ Aa ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osset,type,(
    stream30925839e_sset: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ostl,type,(
    stream_Mirabelle_stl: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream__all,type,(
    stream1056405713am_all: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostreams,type,(
    stream2015131171treams: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( stream170649215stream @ A ) ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_xs,type,(
    xs: ( list @ a ) )).

%----Relevant facts (255)
thf(fact_0_assms,axiom,(
    xs
 != ( nil @ a ) )).

% assms
thf(fact_1_Stream__Mirabelle__hbrgyiwlrc_Osmember__def,axiom,(
    ! [A: $tType] :
      ( ( stream1586597341member @ A )
      = ( ^ [X: A,S: ( stream170649215stream @ A )] :
            ( member @ A @ X @ ( stream30925839e_sset @ A @ S ) ) ) ) )).

% Stream_Mirabelle_hbrgyiwlrc.smember_def
thf(fact_2_stream_Opred__cong,axiom,(
    ! [A: $tType,X2: ( stream170649215stream @ A ),Ya: ( stream170649215stream @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ Ya ) )
           => ( ( P @ Z )
              = ( Pa @ Z ) ) )
       => ( ( stream1153105665stream @ A @ P @ X2 )
          = ( stream1153105665stream @ A @ Pa @ Ya ) ) ) ) )).

% stream.pred_cong
thf(fact_3_stream_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: ( stream170649215stream @ A ),Pa: ( A > $o )] :
      ( ( stream1153105665stream @ A @ P @ X2 )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ X2 ) )
           => ( ( P @ Z )
             => ( Pa @ Z ) ) )
       => ( stream1153105665stream @ A @ Pa @ X2 ) ) ) )).

% stream.pred_mono_strong
thf(fact_4_snth__sset,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),N: nat] :
      ( member @ A @ ( stream370371455e_snth @ A @ S2 @ N ) @ ( stream30925839e_sset @ A @ S2 ) ) )).

% snth_sset
thf(fact_5_shd__sset,axiom,(
    ! [A: $tType,A2: ( stream170649215stream @ A )] :
      ( member @ A @ ( stream_Mirabelle_shd @ A @ A2 ) @ ( stream30925839e_sset @ A @ A2 ) ) )).

% shd_sset
thf(fact_6_stl__sset,axiom,(
    ! [A: $tType,X2: A,A2: ( stream170649215stream @ A )] :
      ( ( member @ A @ X2 @ ( stream30925839e_sset @ A @ ( stream_Mirabelle_stl @ A @ A2 ) ) )
     => ( member @ A @ X2 @ ( stream30925839e_sset @ A @ A2 ) ) ) )).

% stl_sset
thf(fact_7_stream_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream170649215stream @ A ),Ya: ( stream170649215stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ Ya ) )
           => ( ( F @ Z )
              = ( G @ Z ) ) )
       => ( ( stream2128578057e_smap @ A @ B @ F @ X2 )
          = ( stream2128578057e_smap @ A @ B @ G @ Ya ) ) ) ) )).

% stream.map_cong
thf(fact_8_stream_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream170649215stream @ A ),F: ( A > B ),G: ( A > B )] :
      ( ! [Z: A] :
          ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ X2 ) )
         => ( ( F @ Z )
            = ( G @ Z ) ) )
     => ( ( stream2128578057e_smap @ A @ B @ F @ X2 )
        = ( stream2128578057e_smap @ A @ B @ G @ X2 ) ) ) )).

% stream.map_cong0
thf(fact_9_stream_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,X2: ( stream170649215stream @ A ),Xa: ( stream170649215stream @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z: A,Za: A] :
          ( ( member @ A @ Z @ ( stream30925839e_sset @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( stream30925839e_sset @ A @ Xa ) )
           => ( ( ( F @ Z )
                = ( Fa @ Za ) )
             => ( Z = Za ) ) ) )
     => ( ( ( stream2128578057e_smap @ A @ B @ F @ X2 )
          = ( stream2128578057e_smap @ A @ B @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% stream.inj_map_strong
thf(fact_10_stream_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,A22: ( stream170649215stream @ A ),A1: A] :
      ( ( member @ A @ X2 @ ( stream30925839e_sset @ A @ A22 ) )
     => ( member @ A @ X2 @ ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ A1 @ A22 ) ) ) ) )).

% stream.set_intros(2)
thf(fact_11_stream_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( stream170649215stream @ A )] :
      ( member @ A @ A1 @ ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ A1 @ A22 ) ) ) )).

% stream.set_intros(1)
thf(fact_12_stream_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( stream170649215stream @ A )] :
      ( ( member @ A @ E @ ( stream30925839e_sset @ A @ A2 ) )
     => ( ! [Z2: ( stream170649215stream @ A )] :
            ( A2
           != ( stream641971652_SCons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( stream170649215stream @ A )] :
                ( ( A2
                  = ( stream641971652_SCons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( stream30925839e_sset @ A @ Z2 ) ) ) ) ) ) )).

% stream.set_cases
thf(fact_13_stream_Oinject,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A ),Y1: A,Y2: ( stream170649215stream @ A )] :
      ( ( ( stream641971652_SCons @ A @ X1 @ X22 )
        = ( stream641971652_SCons @ A @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y2 ) ) ) )).

% stream.inject
thf(fact_14_stream_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ B @ ( stream2128578057e_smap @ A @ B @ F @ A2 ) )
      = ( stream2128578057e_smap @ A @ B @ F @ ( stream_Mirabelle_stl @ A @ A2 ) ) ) )).

% stream.map_sel(2)
thf(fact_15_stream_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ B @ ( stream2128578057e_smap @ A @ B @ F @ A2 ) )
      = ( F @ ( stream_Mirabelle_shd @ A @ A2 ) ) ) )).

% stream.map_sel(1)
thf(fact_16_snth__smap,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S2: ( stream170649215stream @ B ),N: nat] :
      ( ( stream370371455e_snth @ A @ ( stream2128578057e_smap @ B @ A @ F @ S2 ) @ N )
      = ( F @ ( stream370371455e_snth @ B @ S2 @ N ) ) ) )).

% snth_smap
thf(fact_17_stream_Opred__inject,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A,Aa2: ( stream170649215stream @ A )] :
      ( ( stream1153105665stream @ A @ P @ ( stream641971652_SCons @ A @ A2 @ Aa2 ) )
      = ( ( P @ A2 )
        & ( stream1153105665stream @ A @ P @ Aa2 ) ) ) )).

% stream.pred_inject
thf(fact_18_smember__code,axiom,(
    ! [A: $tType,X2: A,Y: A,S2: ( stream170649215stream @ A )] :
      ( ( stream1586597341member @ A @ X2 @ ( stream641971652_SCons @ A @ Y @ S2 ) )
      = ( ( X2 != Y )
       => ( stream1586597341member @ A @ X2 @ S2 ) ) ) )).

% smember_code
thf(fact_19_stream_Ocollapse,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) )
      = Stream ) )).

% stream.collapse
thf(fact_20_stream_Osel_I2_J,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = X22 ) )).

% stream.sel(2)
thf(fact_21_stream_Osel_I1_J,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = X1 ) )).

% stream.sel(1)
thf(fact_22_smap__alt,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),S2: ( stream170649215stream @ B ),S3: ( stream170649215stream @ A )] :
      ( ( ( stream2128578057e_smap @ B @ A @ F @ S2 )
        = S3 )
      = ( ! [N2: nat] :
            ( ( F @ ( stream370371455e_snth @ B @ S2 @ N2 ) )
            = ( stream370371455e_snth @ A @ S3 @ N2 ) ) ) ) )).

% smap_alt
thf(fact_23_smap__ctr,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),S2: ( stream170649215stream @ B ),X2: A,S3: ( stream170649215stream @ A )] :
      ( ( ( stream2128578057e_smap @ B @ A @ F @ S2 )
        = ( stream641971652_SCons @ A @ X2 @ S3 ) )
      = ( ( ( F @ ( stream_Mirabelle_shd @ B @ S2 ) )
          = X2 )
        & ( ( stream2128578057e_smap @ B @ A @ F @ ( stream_Mirabelle_stl @ B @ S2 ) )
          = S3 ) ) ) )).

% smap_ctr
thf(fact_24_stream_Omap,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream2128578057e_smap @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = ( stream641971652_SCons @ B @ ( F @ X1 ) @ ( stream2128578057e_smap @ A @ B @ F @ X22 ) ) ) )).

% stream.map
thf(fact_25_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( ( ( stream_Mirabelle_shd @ A @ Stream )
          = ( stream_Mirabelle_shd @ A @ Stream2 ) )
        & ( ( stream_Mirabelle_stl @ A @ Stream )
          = ( stream_Mirabelle_stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_26_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream170649215stream @ A )] :
      ~ ( ! [X12: A,X23: ( stream170649215stream @ A )] :
            ( Y
           != ( stream641971652_SCons @ A @ X12 @ X23 ) ) ) )).

% stream.exhaust
thf(fact_27_stream_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_28_stream_Oexhaust__sel,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( Stream
      = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) )).

% stream.exhaust_sel
thf(fact_29_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) )
                | ( ( stream_Mirabelle_stl @ A @ Stream3 )
                  = ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_30_sset__induct,axiom,(
    ! [A: $tType,Y: A,S2: ( stream170649215stream @ A ),P: ( A > ( stream170649215stream @ A ) > $o )] :
      ( ( member @ A @ Y @ ( stream30925839e_sset @ A @ S2 ) )
     => ( ! [S4: ( stream170649215stream @ A )] :
            ( P @ ( stream_Mirabelle_shd @ A @ S4 ) @ S4 )
       => ( ! [S4: ( stream170649215stream @ A ),Y3: A] :
              ( ( member @ A @ Y3 @ ( stream30925839e_sset @ A @ ( stream_Mirabelle_stl @ A @ S4 ) ) )
             => ( ( P @ Y3 @ ( stream_Mirabelle_stl @ A @ S4 ) )
               => ( P @ Y3 @ S4 ) ) )
         => ( P @ Y @ S2 ) ) ) ) )).

% sset_induct
thf(fact_31_stream_Oset__induct,axiom,(
    ! [A: $tType,X2: A,A2: ( stream170649215stream @ A ),P: ( A > ( stream170649215stream @ A ) > $o )] :
      ( ( member @ A @ X2 @ ( stream30925839e_sset @ A @ A2 ) )
     => ( ! [Z1: A,Z2: ( stream170649215stream @ A )] :
            ( P @ Z1 @ ( stream641971652_SCons @ A @ Z1 @ Z2 ) )
       => ( ! [Z1: A,Z2: ( stream170649215stream @ A ),Xa2: A] :
              ( ( member @ A @ Xa2 @ ( stream30925839e_sset @ A @ Z2 ) )
             => ( ( P @ Xa2 @ Z2 )
               => ( P @ Xa2 @ ( stream641971652_SCons @ A @ Z1 @ Z2 ) ) ) )
         => ( P @ X2 @ A2 ) ) ) ) )).

% stream.set_induct
thf(fact_32_stream_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P @ ( stream1342653232stream @ A @ B @ F @ Stream ) )
      = ( ( Stream
          = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
       => ( P @ ( F @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) )).

% stream.split_sel
thf(fact_33_stream_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P @ ( stream1342653232stream @ A @ B @ F @ Stream ) )
      = ( ~ ( ( Stream
              = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
            & ~ ( P @ ( F @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) ) )).

% stream.split_sel_asm
thf(fact_34_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( stream1342653232stream @ A @ B )
      = ( ^ [F2: ( A > ( stream170649215stream @ A ) > B ),Stream5: ( stream170649215stream @ A )] :
            ( F2 @ ( stream_Mirabelle_shd @ A @ Stream5 ) @ ( stream_Mirabelle_stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_35_sdrop__simps_I1_J,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream135081970_sdrop @ A @ N @ S2 ) )
      = ( stream370371455e_snth @ A @ S2 @ N ) ) )).

% sdrop_simps(1)
thf(fact_36_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( stream1195056575_while @ A )
      = ( ^ [P2: ( A > $o ),S: ( stream170649215stream @ A )] :
            ( if @ ( stream170649215stream @ A ) @ ( P2 @ ( stream_Mirabelle_shd @ A @ S ) ) @ ( stream1195056575_while @ A @ P2 @ ( stream_Mirabelle_stl @ A @ S ) ) @ S ) ) ) )).

% sdrop_while.simps
thf(fact_37_stream__all__def,axiom,(
    ! [A: $tType] :
      ( ( stream1056405713am_all @ A )
      = ( ^ [P2: ( A > $o ),S: ( stream170649215stream @ A )] :
          ! [P3: nat] :
            ( P2 @ ( stream370371455e_snth @ A @ S @ P3 ) ) ) ) )).

% stream_all_def
thf(fact_38_cycle__decomp,axiom,(
    ! [A: $tType,U: ( list @ A )] :
      ( ( U
       != ( nil @ A ) )
     => ( ( stream317748790_cycle @ A @ U )
        = ( stream1035003186_shift @ A @ U @ ( stream317748790_cycle @ A @ U ) ) ) ) )).

% cycle_decomp
thf(fact_39_streamsE,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ A3 ) )
     => ~ ( ( member @ A @ ( stream_Mirabelle_shd @ A @ S2 ) @ A3 )
         => ~ ( member @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S2 ) @ ( stream2015131171treams @ A @ A3 ) ) ) ) )).

% streamsE
thf(fact_40_in__streams,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),S5: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S2 ) @ ( stream2015131171treams @ A @ S5 ) )
     => ( ( member @ A @ ( stream_Mirabelle_shd @ A @ S2 ) @ S5 )
       => ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ S5 ) ) ) ) )).

% in_streams
thf(fact_41_stream_Oset,axiom,(
    ! [A: $tType,X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream30925839e_sset @ A @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = ( insert2 @ A @ X1 @ ( stream30925839e_sset @ A @ X22 ) ) ) )).

% stream.set
thf(fact_42_shift__left__inj,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S1: ( stream170649215stream @ A ),S22: ( stream170649215stream @ A )] :
      ( ( ( stream1035003186_shift @ A @ Xs @ S1 )
        = ( stream1035003186_shift @ A @ Xs @ S22 ) )
      = ( S1 = S22 ) ) )).

% shift_left_inj
thf(fact_43_sdrop__smap,axiom,(
    ! [A: $tType,B: $tType,N: nat,F: ( B > A ),S2: ( stream170649215stream @ B )] :
      ( ( stream135081970_sdrop @ A @ N @ ( stream2128578057e_smap @ B @ A @ F @ S2 ) )
      = ( stream2128578057e_smap @ B @ A @ F @ ( stream135081970_sdrop @ B @ N @ S2 ) ) ) )).

% sdrop_smap
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_shift_Osimps_I1_J,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( nil @ A ) @ S2 )
      = S2 ) )).

% shift.simps(1)
thf(fact_49_streams_Ocoinduct,axiom,(
    ! [A: $tType,X4: ( ( stream170649215stream @ A ) > $o ),X2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( X4 @ X2 )
     => ( ! [X3: ( stream170649215stream @ A )] :
            ( ( X4 @ X3 )
           => ? [A4: A,S6: ( stream170649215stream @ A )] :
                ( ( X3
                  = ( stream641971652_SCons @ A @ A4 @ S6 ) )
                & ( member @ A @ A4 @ A3 )
                & ( ( X4 @ S6 )
                  | ( member @ ( stream170649215stream @ A ) @ S6 @ ( stream2015131171treams @ A @ A3 ) ) ) ) )
       => ( member @ ( stream170649215stream @ A ) @ X2 @ ( stream2015131171treams @ A @ A3 ) ) ) ) )).

% streams.coinduct
thf(fact_50_streams__Stream,axiom,(
    ! [A: $tType,X2: A,S2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ ( stream641971652_SCons @ A @ X2 @ S2 ) @ ( stream2015131171treams @ A @ A3 ) )
      = ( ( member @ A @ X2 @ A3 )
        & ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ A3 ) ) ) ) )).

% streams_Stream
thf(fact_51_streams_Osimps,axiom,(
    ! [A: $tType,A2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ A2 @ ( stream2015131171treams @ A @ A3 ) )
      = ( ? [A5: A,S: ( stream170649215stream @ A )] :
            ( ( A2
              = ( stream641971652_SCons @ A @ A5 @ S ) )
            & ( member @ A @ A5 @ A3 )
            & ( member @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A3 ) ) ) ) ) )).

% streams.simps
thf(fact_52_streams_Ocases,axiom,(
    ! [A: $tType,A2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ A2 @ ( stream2015131171treams @ A @ A3 ) )
     => ~ ( ! [A6: A,S4: ( stream170649215stream @ A )] :
              ( ( A2
                = ( stream641971652_SCons @ A @ A6 @ S4 ) )
             => ( ( member @ A @ A6 @ A3 )
               => ~ ( member @ ( stream170649215stream @ A ) @ S4 @ ( stream2015131171treams @ A @ A3 ) ) ) ) ) ) )).

% streams.cases
thf(fact_53_streams__stl,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ A3 ) )
     => ( member @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S2 ) @ ( stream2015131171treams @ A @ A3 ) ) ) )).

% streams_stl
thf(fact_54_smap__streams,axiom,(
    ! [A: $tType,B: $tType,S2: ( stream170649215stream @ A ),A3: ( set @ A ),F: ( A > B ),B2: ( set @ B )] :
      ( ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ A3 ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( member @ B @ ( F @ X3 ) @ B2 ) )
       => ( member @ ( stream170649215stream @ B ) @ ( stream2128578057e_smap @ A @ B @ F @ S2 ) @ ( stream2015131171treams @ B @ B2 ) ) ) ) )).

% smap_streams
thf(fact_55_streams__shd,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),A3: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ A3 ) )
     => ( member @ A @ ( stream_Mirabelle_shd @ A @ S2 ) @ A3 ) ) )).

% streams_shd
thf(fact_56_streams__iff__snth,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),X4: ( set @ A )] :
      ( ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ X4 ) )
      = ( ! [N2: nat] :
            ( member @ A @ ( stream370371455e_snth @ A @ S2 @ N2 ) @ X4 ) ) ) )).

% streams_iff_snth
thf(fact_57_snth__in,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),X4: ( set @ A ),N: nat] :
      ( ( member @ ( stream170649215stream @ A ) @ S2 @ ( stream2015131171treams @ A @ X4 ) )
     => ( member @ A @ ( stream370371455e_snth @ A @ S2 @ N ) @ X4 ) ) )).

% snth_in
thf(fact_58_sdrop__stl,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( stream135081970_sdrop @ A @ N @ ( stream_Mirabelle_stl @ A @ S2 ) )
      = ( stream_Mirabelle_stl @ A @ ( stream135081970_sdrop @ A @ N @ S2 ) ) ) )).

% sdrop_stl
thf(fact_59_sdrop__while__SCons,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A,S2: ( stream170649215stream @ A )] :
      ( ( ( P @ A2 )
       => ( ( stream1195056575_while @ A @ P @ ( stream641971652_SCons @ A @ A2 @ S2 ) )
          = ( stream1195056575_while @ A @ P @ S2 ) ) )
      & ( ~ ( P @ A2 )
       => ( ( stream1195056575_while @ A @ P @ ( stream641971652_SCons @ A @ A2 @ S2 ) )
          = ( stream641971652_SCons @ A @ A2 @ S2 ) ) ) ) )).

% sdrop_while_SCons
thf(fact_60_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F: ( A > ( stream170649215stream @ A ) > B ),X1: A,X22: ( stream170649215stream @ A )] :
      ( ( stream1342653232stream @ A @ B @ F @ ( stream641971652_SCons @ A @ X1 @ X22 ) )
      = ( F @ X1 @ X22 ) ) )).

% stream.case
thf(fact_61_stream__all__Stream,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,X4: ( stream170649215stream @ A )] :
      ( ( stream1056405713am_all @ A @ P @ ( stream641971652_SCons @ A @ X2 @ X4 ) )
      = ( ( P @ X2 )
        & ( stream1056405713am_all @ A @ P @ X4 ) ) ) )).

% stream_all_Stream
thf(fact_62_insert__absorb2,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A )] :
      ( ( insert2 @ A @ X2 @ ( insert2 @ A @ X2 @ A3 ) )
      = ( insert2 @ A @ X2 @ A3 ) ) )).

% insert_absorb2
thf(fact_63_insert__iff,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert2 @ A @ B3 @ A3 ) )
      = ( ( A2 = B3 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_64_insertCI,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),B3: A] :
      ( ( ~ ( member @ A @ A2 @ B2 )
       => ( A2 = B3 ) )
     => ( member @ A @ A2 @ ( insert2 @ A @ B3 @ B2 ) ) ) )).

% insertCI
thf(fact_65_List_Oset__insert,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( set2 @ A @ ( insert @ A @ X2 @ Xs ) )
      = ( insert2 @ A @ X2 @ ( set2 @ A @ Xs ) ) ) )).

% List.set_insert
thf(fact_66_shift__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( stream_Mirabelle_shd @ A @ ( stream1035003186_shift @ A @ Xs @ S2 ) )
          = ( stream_Mirabelle_shd @ A @ S2 ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( stream_Mirabelle_shd @ A @ ( stream1035003186_shift @ A @ Xs @ S2 ) )
          = ( hd @ A @ Xs ) ) ) ) )).

% shift_simps(1)
thf(fact_67_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_68_shift__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( stream_Mirabelle_stl @ A @ ( stream1035003186_shift @ A @ Xs @ S2 ) )
          = ( stream_Mirabelle_stl @ A @ S2 ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( stream_Mirabelle_stl @ A @ ( stream1035003186_shift @ A @ Xs @ S2 ) )
          = ( stream1035003186_shift @ A @ ( tl @ A @ Xs ) @ S2 ) ) ) ) )).

% shift_simps(2)
thf(fact_69_sdrop__cycle__eq,axiom,(
    ! [A: $tType,U: ( list @ A )] :
      ( ( U
       != ( nil @ A ) )
     => ( ( stream135081970_sdrop @ A @ ( size_size @ ( list @ A ) @ U ) @ ( stream317748790_cycle @ A @ U ) )
        = ( stream317748790_cycle @ A @ U ) ) ) )).

% sdrop_cycle_eq
thf(fact_70_in__set__insert,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X2 @ Xs )
        = Xs ) ) )).

% in_set_insert
thf(fact_71_list_Oexpand,axiom,(
    ! [A: $tType,List: ( list @ A ),List2: ( list @ A )] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) )).

% list.expand
thf(fact_72_neq__if__length__neq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) )).

% neq_if_length_neq
thf(fact_73_Ex__list__of__length,axiom,(
    ! [A: $tType,N: nat] :
    ? [Xs2: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N ) )).

% Ex_list_of_length
thf(fact_74_list_Osel_I2_J,axiom,(
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% list.sel(2)
thf(fact_75_list_Oset__sel_I2_J,axiom,(
    ! [A: $tType,A2: ( list @ A ),X2: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X2 @ ( set2 @ A @ A2 ) ) ) ) )).

% list.set_sel(2)
thf(fact_76_list_Oset__sel_I1_J,axiom,(
    ! [A: $tType,A2: ( list @ A )] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) )).

% list.set_sel(1)
thf(fact_77_hd__in__set,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) )).

% hd_in_set
thf(fact_78_cycle_Osimps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream317748790_cycle @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) )).

% cycle.simps(1)
thf(fact_79_list__ex1__iff,axiom,(
    ! [A: $tType] :
      ( ( list_ex1 @ A )
      = ( ^ [P2: ( A > $o ),Xs3: ( list @ A )] :
          ? [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Xs3 ) )
            & ( P2 @ X )
            & ! [Y4: A] :
                ( ( ( member @ A @ Y4 @ ( set2 @ A @ Xs3 ) )
                  & ( P2 @ Y4 ) )
               => ( Y4 = X ) ) ) ) ) )).

% list_ex1_iff
thf(fact_80_insertE,axiom,(
    ! [A: $tType,A2: A,B3: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert2 @ A @ B3 @ A3 ) )
     => ( ( A2 != B3 )
       => ( member @ A @ A2 @ A3 ) ) ) )).

% insertE
thf(fact_81_insertI1,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A )] :
      ( member @ A @ A2 @ ( insert2 @ A @ A2 @ B2 ) ) )).

% insertI1
thf(fact_82_insertI2,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),B3: A] :
      ( ( member @ A @ A2 @ B2 )
     => ( member @ A @ A2 @ ( insert2 @ A @ B3 @ B2 ) ) ) )).

% insertI2
thf(fact_83_Set_Oset__insert,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A )] :
      ( ( member @ A @ X2 @ A3 )
     => ~ ( ! [B4: ( set @ A )] :
              ( ( A3
                = ( insert2 @ A @ X2 @ B4 ) )
             => ( member @ A @ X2 @ B4 ) ) ) ) )).

% Set.set_insert
thf(fact_84_insert__ident,axiom,(
    ! [A: $tType,X2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ~ ( member @ A @ X2 @ B2 )
       => ( ( ( insert2 @ A @ X2 @ A3 )
            = ( insert2 @ A @ X2 @ B2 ) )
          = ( A3 = B2 ) ) ) ) )).

% insert_ident
thf(fact_85_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert2 @ A @ A2 @ A3 )
        = A3 ) ) )).

% insert_absorb
thf(fact_86_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B3: A,B2: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ B3 @ B2 )
       => ( ( ( insert2 @ A @ A2 @ A3 )
            = ( insert2 @ A @ B3 @ B2 ) )
          = ( ( ( A2 = B3 )
             => ( A3 = B2 ) )
            & ( ( A2 != B3 )
             => ? [C: ( set @ A )] :
                  ( ( A3
                    = ( insert2 @ A @ B3 @ C ) )
                  & ~ ( member @ A @ B3 @ C )
                  & ( B2
                    = ( insert2 @ A @ A2 @ C ) )
                  & ~ ( member @ A @ A2 @ C ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_87_insert__commute,axiom,(
    ! [A: $tType,X2: A,Y: A,A3: ( set @ A )] :
      ( ( insert2 @ A @ X2 @ ( insert2 @ A @ Y @ A3 ) )
      = ( insert2 @ A @ Y @ ( insert2 @ A @ X2 @ A3 ) ) ) )).

% insert_commute
thf(fact_88_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ? [B4: ( set @ A )] :
          ( ( A3
            = ( insert2 @ A @ A2 @ B4 ) )
          & ~ ( member @ A @ A2 @ B4 ) ) ) )).

% mk_disjoint_insert
thf(fact_89_can__select__set__list__ex1,axiom,(
    ! [A: $tType,P: ( A > $o ),A3: ( list @ A )] :
      ( ( can_select @ A @ P @ ( set2 @ A @ A3 ) )
      = ( list_ex1 @ A @ P @ A3 ) ) )).

% can_select_set_list_ex1
thf(fact_90_stake__cycle__eq,axiom,(
    ! [A: $tType,U: ( list @ A )] :
      ( ( U
       != ( nil @ A ) )
     => ( ( stream1746350922_stake @ A @ ( size_size @ ( list @ A ) @ U ) @ ( stream317748790_cycle @ A @ U ) )
        = U ) ) )).

% stake_cycle_eq
thf(fact_91_list_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F1: B,F22: ( A > ( list @ A ) > B ),List3: ( list @ A )] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F1
            @ ( F22 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) )).

% list.case_eq_if
thf(fact_92_sset__shift,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( stream30925839e_sset @ A @ ( stream1035003186_shift @ A @ Xs @ S2 ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( stream30925839e_sset @ A @ S2 ) ) ) )).

% sset_shift
thf(fact_93_stream__all__shift,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( stream1056405713am_all @ A @ P @ ( stream1035003186_shift @ A @ Xs @ S2 ) )
      = ( ( list_all @ A @ P @ Xs )
        & ( stream1056405713am_all @ A @ P @ S2 ) ) ) )).

% stream_all_shift
thf(fact_94_hd__Cons__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) )).

% hd_Cons_tl
thf(fact_95_list_Ocollapse,axiom,(
    ! [A: $tType,List: ( list @ A )] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) )).

% list.collapse
thf(fact_96_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y22 ) ) ) )).

% list.inject
thf(fact_97_UnCI,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( ~ ( member @ A @ C2 @ B2 )
       => ( member @ A @ C2 @ A3 ) )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnCI
thf(fact_98_Un__iff,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( ( member @ A @ C2 @ A3 )
        | ( member @ A @ C2 @ B2 ) ) ) )).

% Un_iff
thf(fact_99_Un__insert__right,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( insert2 @ A @ A2 @ B2 ) )
      = ( insert2 @ A @ A2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% Un_insert_right
thf(fact_100_Un__insert__left,axiom,(
    ! [A: $tType,A2: A,B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( insert2 @ A @ A2 @ B2 ) @ C3 )
      = ( insert2 @ A @ A2 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_insert_left
thf(fact_101_list__all__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: A,Xs: ( list @ A )] :
      ( ( list_all @ A @ P @ ( cons @ A @ X2 @ Xs ) )
      = ( ( P @ X2 )
        & ( list_all @ A @ P @ Xs ) ) ) )).

% list_all_simps(1)
thf(fact_102_list_Opred__inject_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o ),A2: A,Aa2: ( list @ A )] :
      ( ( list_all @ A @ P @ ( cons @ A @ A2 @ Aa2 ) )
      = ( ( P @ A2 )
        & ( list_all @ A @ P @ Aa2 ) ) ) )).

% list.pred_inject(2)
thf(fact_103_list__all__simps_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( list_all @ A @ P @ ( nil @ A ) ) )).

% list_all_simps(2)
thf(fact_104_length__stake,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( size_size @ ( list @ A ) @ ( stream1746350922_stake @ A @ N @ S2 ) )
      = N ) )).

% length_stake
thf(fact_105_list_Osimps_I15_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X222 ) )
      = ( insert2 @ A @ X21 @ ( set2 @ A @ X222 ) ) ) )).

% list.simps(15)
thf(fact_106_insert__Nil,axiom,(
    ! [A: $tType,X2: A] :
      ( ( insert @ A @ X2 @ ( nil @ A ) )
      = ( cons @ A @ X2 @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_107_not__in__set__insert,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( insert @ A @ X2 @ Xs )
        = ( cons @ A @ X2 @ Xs ) ) ) )).

% not_in_set_insert
thf(fact_108_UnE,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
     => ( ~ ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B2 ) ) ) )).

% UnE
thf(fact_109_UnI1,axiom,(
    ! [A: $tType,C2: A,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( member @ A @ C2 @ A3 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnI1
thf(fact_110_UnI2,axiom,(
    ! [A: $tType,C2: A,B2: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ C2 @ B2 )
     => ( member @ A @ C2 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) ) )).

% UnI2
thf(fact_111_bex__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X: A] :
            ( ( member @ A @ X @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
            & ( P @ X ) ) )
      = ( ? [X: A] :
            ( ( member @ A @ X @ A3 )
            & ( P @ X ) )
        | ? [X: A] :
            ( ( member @ A @ X @ B2 )
            & ( P @ X ) ) ) ) )).

% bex_Un
thf(fact_112_ball__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X: A] :
            ( ( member @ A @ X @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
           => ( P @ X ) ) )
      = ( ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( P @ X ) )
        & ! [X: A] :
            ( ( member @ A @ X @ B2 )
           => ( P @ X ) ) ) ) )).

% ball_Un
thf(fact_113_Un__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) @ C3 )
      = ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) ) ) )).

% Un_assoc
thf(fact_114_Un__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Un_absorb
thf(fact_115_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A7: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A7 ) ) ) )).

% Un_commute
thf(fact_116_Un__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B2 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B2 ) ) )).

% Un_left_absorb
thf(fact_117_Un__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B2: ( set @ A ),C3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B2 @ C3 ) )
      = ( sup_sup @ ( set @ A ) @ B2 @ ( sup_sup @ ( set @ A ) @ A3 @ C3 ) ) ) )).

% Un_left_commute
thf(fact_118_list_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F12: B,F23: ( A > ( list @ A ) > B ),X21: A,X222: ( list @ A )] :
      ( ( case_list @ B @ A @ F12 @ F23 @ ( cons @ A @ X21 @ X222 ) )
      = ( F23 @ X21 @ X222 ) ) )).

% list.simps(5)
thf(fact_119_not__Cons__self2,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X2 @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_120_transpose_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ ( list @ A ) )] :
      ( ( X2
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X2
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X3: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X2
               != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_121_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F3: ( A > B ),X12: ( list @ B )] :
          ( P @ F3 @ ( nil @ A ) @ X12 )
     => ( ! [F3: ( A > B ),A6: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P @ F3 @ As @ ( cons @ B @ ( F3 @ A6 ) @ Bs ) )
           => ( P @ F3 @ ( cons @ A @ A6 @ As ) @ Bs ) )
       => ( P @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_122_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_123_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Y3: A,Xs2: ( list @ A )] :
              ( ( ( X3 = Y3 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) )
             => ( ( ( X3 != Y3 )
                 => ( P @ ( cons @ A @ Y3 @ Xs2 ) ) )
               => ( P @ ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_124_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X2: ( list @ A )] :
      ( ( X2
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X2
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ( ! [X3: A,Y3: A,Xs2: ( list @ A )] :
                ( X2
               != ( cons @ A @ X3 @ ( cons @ A @ Y3 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_125_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P @ ( nil @ A ) @ X12 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X3: A,Xs2: ( list @ A ),Y3: A,Ys2: ( list @ A )] :
              ( ( P @ Xs2 @ Ys2 )
             => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y3 @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_126_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: ( list @ A )] :
            ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y3: B,Ys2: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y3 @ Ys2 ) )
         => ( ! [X3: A,Xs2: ( list @ A ),Y3: B,Ys2: ( list @ B )] :
                ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys2 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_127_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y4: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y4 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_128_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X12: A,X23: ( list @ A )] :
            ( ( P @ X23 )
           => ( P @ ( cons @ A @ X12 @ X23 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_129_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X223: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X223 ) ) ) ) )).

% list.exhaust
thf(fact_130_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X222: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_131_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) )).

% list.distinct(1)
thf(fact_132_list_Oset__intros_I2_J,axiom,(
    ! [A: $tType,X2: A,A22: ( list @ A ),A1: A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ A22 ) )
     => ( member @ A @ X2 @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) ) )).

% list.set_intros(2)
thf(fact_133_list_Oset__intros_I1_J,axiom,(
    ! [A: $tType,A1: A,A22: ( list @ A )] :
      ( member @ A @ A1 @ ( set2 @ A @ ( cons @ A @ A1 @ A22 ) ) ) )).

% list.set_intros(1)
thf(fact_134_set__ConsD,axiom,(
    ! [A: $tType,Y: A,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ Y @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) )
     => ( ( Y = X2 )
        | ( member @ A @ Y @ ( set2 @ A @ Xs ) ) ) ) )).

% set_ConsD
thf(fact_135_list_Oset__cases,axiom,(
    ! [A: $tType,E: A,A2: ( list @ A )] :
      ( ( member @ A @ E @ ( set2 @ A @ A2 ) )
     => ( ! [Z2: ( list @ A )] :
            ( A2
           != ( cons @ A @ E @ Z2 ) )
       => ~ ( ! [Z1: A,Z2: ( list @ A )] :
                ( ( A2
                  = ( cons @ A @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( set2 @ A @ Z2 ) ) ) ) ) ) )).

% list.set_cases
thf(fact_136_can__select__def,axiom,(
    ! [A: $tType] :
      ( ( can_select @ A )
      = ( ^ [P2: ( A > $o ),A7: ( set @ A )] :
          ? [X: A] :
            ( ( member @ A @ X @ A7 )
            & ( P2 @ X )
            & ! [Y4: A] :
                ( ( ( member @ A @ Y4 @ A7 )
                  & ( P2 @ Y4 ) )
               => ( Y4 = X ) ) ) ) ) )).

% can_select_def
thf(fact_137_list_Osel_I3_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) )).

% list.sel(3)
thf(fact_138_list_Osel_I1_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) )).

% list.sel(1)
thf(fact_139_list_Opred__inject_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( list_all @ A @ P @ ( nil @ A ) ) )).

% list.pred_inject(1)
thf(fact_140_list_Opred__cong,axiom,(
    ! [A: $tType,X2: ( list @ A ),Ya: ( list @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X2 = Ya )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( set2 @ A @ Ya ) )
           => ( ( P @ Z )
              = ( Pa @ Z ) ) )
       => ( ( list_all @ A @ P @ X2 )
          = ( list_all @ A @ Pa @ Ya ) ) ) ) )).

% list.pred_cong
thf(fact_141_list_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X2: ( list @ A ),Pa: ( A > $o )] :
      ( ( list_all @ A @ P @ X2 )
     => ( ! [Z: A] :
            ( ( member @ A @ Z @ ( set2 @ A @ X2 ) )
           => ( ( P @ Z )
             => ( Pa @ Z ) ) )
       => ( list_all @ A @ Pa @ X2 ) ) ) )).

% list.pred_mono_strong
thf(fact_142_list_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F12: B,F23: ( A > ( list @ A ) > B )] :
      ( ( case_list @ B @ A @ F12 @ F23 @ ( nil @ A ) )
      = F12 ) )).

% list.simps(4)
thf(fact_143_list_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F12: B,F23: ( A > ( list @ A ) > B ),List: ( list @ A )] :
      ( ( P @ ( case_list @ B @ A @ F12 @ F23 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F12 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F23 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) )).

% list.split_sel_asm
thf(fact_144_list_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),F12: B,F23: ( A > ( list @ A ) > B ),List: ( list @ A )] :
      ( ( P @ ( case_list @ B @ A @ F12 @ F23 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F12 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F23 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) )).

% list.split_sel
thf(fact_145_list__induct3,axiom,(
    ! [B: $tType,A: $tType,C4: $tType,Xs: ( list @ A ),Ys: ( list @ B ),Zs: ( list @ C4 ),P: ( ( list @ A ) > ( list @ B ) > ( list @ C4 ) > $o )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C4 ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C4 ) )
         => ( ! [X3: A,Xs2: ( list @ A ),Y3: B,Ys2: ( list @ B ),Z: C4,Zs2: ( list @ C4 )] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( size_size @ ( list @ B ) @ Ys2 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys2 )
                    = ( size_size @ ( list @ C4 ) @ Zs2 ) )
                 => ( ( P @ Xs2 @ Ys2 @ Zs2 )
                   => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys2 ) @ ( cons @ C4 @ Z @ Zs2 ) ) ) ) )
           => ( P @ Xs @ Ys @ Zs ) ) ) ) ) )).

% list_induct3
thf(fact_146_list__induct2,axiom,(
    ! [A: $tType,B: $tType,Xs: ( list @ A ),Ys: ( list @ B ),P: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs2: ( list @ A ),Y3: B,Ys2: ( list @ B )] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = ( size_size @ ( list @ B ) @ Ys2 ) )
             => ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y3 @ Ys2 ) ) ) )
         => ( P @ Xs @ Ys ) ) ) ) )).

% list_induct2
thf(fact_147_tl__Nil,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X: A] :
            ( Xs
            = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )).

% tl_Nil
thf(fact_148_Nil__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X: A] :
            ( Xs
            = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) )).

% Nil_tl
thf(fact_149_shift_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( cons @ A @ X2 @ Xs ) @ S2 )
      = ( stream641971652_SCons @ A @ X2 @ ( stream1035003186_shift @ A @ Xs @ S2 ) ) ) )).

% shift.simps(2)
thf(fact_150_List_Oinsert__def,axiom,(
    ! [A: $tType] :
      ( ( insert @ A )
      = ( ^ [X: A,Xs3: ( list @ A )] :
            ( if @ ( list @ A ) @ ( member @ A @ X @ ( set2 @ A @ Xs3 ) ) @ Xs3 @ ( cons @ A @ X @ Xs3 ) ) ) ) )).

% List.insert_def
thf(fact_151_list_Oexhaust__sel,axiom,(
    ! [A: $tType,List: ( list @ A )] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) )).

% list.exhaust_sel
thf(fact_152_stake__sdrop,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( stream1746350922_stake @ A @ N @ S2 ) @ ( stream135081970_sdrop @ A @ N @ S2 ) )
      = S2 ) )).

% stake_sdrop
thf(fact_153_set__union,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) )).

% set_union
thf(fact_154_sup_Oright__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B3 ) @ B3 )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.right_idem
thf(fact_155_sup__left__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( sup_sup @ A @ X2 @ ( sup_sup @ A @ X2 @ Y ) )
          = ( sup_sup @ A @ X2 @ Y ) ) ) )).

% sup_left_idem
thf(fact_156_sup_Oleft__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B3 ) )
          = ( sup_sup @ A @ A2 @ B3 ) ) ) )).

% sup.left_idem
thf(fact_157_sup__idem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X2: A] :
          ( ( sup_sup @ A @ X2 @ X2 )
          = X2 ) ) )).

% sup_idem
thf(fact_158_sup__apply,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X: A] :
              ( sup_sup @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ) )).

% sup_apply
thf(fact_159_sup_Oidem,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) )).

% sup.idem
thf(fact_160_inf__sup__aci_I8_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A] :
          ( ( sup_sup @ A @ X2 @ ( sup_sup @ A @ X2 @ Y ) )
          = ( sup_sup @ A @ X2 @ Y ) ) ) )).

% inf_sup_aci(8)
thf(fact_161_inf__sup__aci_I7_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X2 @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X2 @ Z3 ) ) ) ) )).

% inf_sup_aci(7)
thf(fact_162_inf__sup__aci_I6_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X2 @ Y ) @ Z3 )
          = ( sup_sup @ A @ X2 @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% inf_sup_aci(6)
thf(fact_163_inf__sup__aci_I5_J,axiom,(
    ! [A: $tType] :
      ( ( lattice @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X ) ) ) ) )).

% inf_sup_aci(5)
thf(fact_164_sup__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B @ ( type2 @ B ) )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F2: ( A > B ),G2: ( A > B ),X: A] :
              ( sup_sup @ B @ ( F2 @ X ) @ ( G2 @ X ) ) ) ) ) )).

% sup_fun_def
thf(fact_165_sup_Oassoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [A2: A,B3: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B3 ) @ C2 )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.assoc
thf(fact_166_sup__assoc,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X2 @ Y ) @ Z3 )
          = ( sup_sup @ A @ X2 @ ( sup_sup @ A @ Y @ Z3 ) ) ) ) )).

% sup_assoc
thf(fact_167_sup_Ocommute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [A5: A,B6: A] :
              ( sup_sup @ A @ B6 @ A5 ) ) ) ) )).

% sup.commute
thf(fact_168_sup__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ( ( sup_sup @ A )
        = ( ^ [X: A,Y4: A] :
              ( sup_sup @ A @ Y4 @ X ) ) ) ) )).

% sup_commute
thf(fact_169_sup_Oleft__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [B3: A,A2: A,C2: A] :
          ( ( sup_sup @ A @ B3 @ ( sup_sup @ A @ A2 @ C2 ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B3 @ C2 ) ) ) ) )).

% sup.left_commute
thf(fact_170_sup__left__commute,axiom,(
    ! [A: $tType] :
      ( ( semilattice_sup @ A @ ( type2 @ A ) )
     => ! [X2: A,Y: A,Z3: A] :
          ( ( sup_sup @ A @ X2 @ ( sup_sup @ A @ Y @ Z3 ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X2 @ Z3 ) ) ) ) )).

% sup_left_commute
thf(fact_171_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_172_the__elem__set,axiom,(
    ! [A: $tType,X2: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = X2 ) )).

% the_elem_set
thf(fact_173_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_174_in__set__product__lists__length,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xss2: ( list @ ( list @ A ) )] :
      ( ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss2 ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss2 ) ) ) )).

% in_set_product_lists_length
thf(fact_175_cycle__rotated,axiom,(
    ! [A: $tType,V2: ( list @ A ),U: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( V2
       != ( nil @ A ) )
     => ( ( ( stream317748790_cycle @ A @ U )
          = ( stream1035003186_shift @ A @ V2 @ S2 ) )
       => ( ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ U ) @ ( cons @ A @ ( hd @ A @ U ) @ ( nil @ A ) ) ) )
          = ( stream1035003186_shift @ A @ ( tl @ A @ V2 ) @ S2 ) ) ) ) )).

% cycle_rotated
thf(fact_176_cycle_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream317748790_cycle @ A @ Xs ) )
      = ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) )).

% cycle.simps(2)
thf(fact_177_cycle_Ocode,axiom,(
    ! [A: $tType] :
      ( ( stream317748790_cycle @ A )
      = ( ^ [Xs3: ( list @ A )] :
            ( stream641971652_SCons @ A @ ( hd @ A @ Xs3 ) @ ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ Xs3 ) @ ( cons @ A @ ( hd @ A @ Xs3 ) @ ( nil @ A ) ) ) ) ) ) ) )).

% cycle.code
thf(fact_178_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_179_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_180_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_181_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_182_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_183_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_184_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_185_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_186_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_187_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_188_append__eq__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A ),Vs: ( list @ A )] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) )).

% append_eq_append_conv
thf(fact_189_list__all__append,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( list_all @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( ( list_all @ A @ P @ Xs )
        & ( list_all @ A @ P @ Ys ) ) ) )).

% list_all_append
thf(fact_190_shift__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),S2: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( append @ A @ Xs @ Ys ) @ S2 )
      = ( stream1035003186_shift @ A @ Xs @ ( stream1035003186_shift @ A @ Ys @ S2 ) ) ) )).

% shift_append
thf(fact_191_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X2 = Y ) ) ) )).

% append1_eq_conv
thf(fact_192_set__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) )).

% set_append
thf(fact_193_tl__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) )).

% tl_append2
thf(fact_194_hd__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) )).

% hd_append2
thf(fact_195_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_196_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X2: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X2 @ Xs ) ) )
        | ? [Ys4: ( list @ A )] :
            ( ( Ys
              = ( cons @ A @ X2 @ Ys4 ) )
            & ( ( append @ A @ Ys4 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_197_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X2 @ Xs )
            = Zs ) )
        | ? [Ys4: ( list @ A )] :
            ( ( ( cons @ A @ X2 @ Ys4 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys4 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_198_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys2: ( list @ A ),Y3: A] :
              ( Xs
             != ( append @ A @ Ys2 @ ( cons @ A @ Y3 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_199_rev__induct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A,Xs2: ( list @ A )] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) )).

% rev_induct
thf(fact_200_split__list__first__prop__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ( ? [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
            & ( P @ X ) ) )
      = ( ? [Ys3: ( list @ A ),X: A] :
            ( ? [Zs3: ( list @ A )] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ( P @ X )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y4 ) ) ) ) ) )).

% split_list_first_prop_iff
thf(fact_201_split__list__last__prop__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ( ? [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
            & ( P @ X ) ) )
      = ( ? [Ys3: ( list @ A ),X: A,Zs3: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X @ Zs3 ) ) )
            & ( P @ X )
            & ! [Y4: A] :
                ( ( member @ A @ Y4 @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y4 ) ) ) ) ) )).

% split_list_last_prop_iff
thf(fact_202_in__set__conv__decomp__first,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: ( list @ A ),Zs3: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ~ ( member @ A @ X2 @ ( set2 @ A @ Ys3 ) ) ) ) ) )).

% in_set_conv_decomp_first
thf(fact_203_in__set__conv__decomp__last,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: ( list @ A ),Zs3: ( list @ A )] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ~ ( member @ A @ X2 @ ( set2 @ A @ Zs3 ) ) ) ) ) )).

% in_set_conv_decomp_last
thf(fact_204_split__list__first__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ~ ( ! [Ys2: ( list @ A ),X3: A] :
              ( ? [Zs2: ( list @ A )] :
                  ( Xs
                  = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
             => ( ( P @ X3 )
               => ~ ( ! [Xa3: A] :
                        ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys2 ) )
                       => ~ ( P @ Xa3 ) ) ) ) ) ) ) )).

% split_list_first_propE
thf(fact_205_split__list__last__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ~ ( ! [Ys2: ( list @ A ),X3: A,Zs2: ( list @ A )] :
              ( ( Xs
                = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
             => ( ( P @ X3 )
               => ~ ( ! [Xa3: A] :
                        ( ( member @ A @ Xa3 @ ( set2 @ A @ Zs2 ) )
                       => ~ ( P @ Xa3 ) ) ) ) ) ) ) )).

% split_list_last_propE
thf(fact_206_split__list__first__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ? [Ys2: ( list @ A ),X3: A] :
          ( ? [Zs2: ( list @ A )] :
              ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 )
          & ! [Xa3: A] :
              ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys2 ) )
             => ~ ( P @ Xa3 ) ) ) ) )).

% split_list_first_prop
thf(fact_207_split__list__last__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ? [Ys2: ( list @ A ),X3: A,Zs2: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 )
          & ! [Xa3: A] :
              ( ( member @ A @ Xa3 @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa3 ) ) ) ) )).

% split_list_last_prop
thf(fact_208_in__set__conv__decomp,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: ( list @ A ),Zs3: ( list @ A )] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) ) ) ) )).

% in_set_conv_decomp
thf(fact_209_split__list__propE,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ~ ( ! [Ys2: ( list @ A ),X3: A] :
              ( ? [Zs2: ( list @ A )] :
                  ( Xs
                  = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
             => ~ ( P @ X3 ) ) ) ) )).

% split_list_propE
thf(fact_210_split__list__first,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys2: ( list @ A ),Zs2: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ~ ( member @ A @ X2 @ ( set2 @ A @ Ys2 ) ) ) ) )).

% split_list_first
thf(fact_211_split__list__prop,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
          & ( P @ X5 ) )
     => ? [Ys2: ( list @ A ),X3: A] :
          ( ? [Zs2: ( list @ A )] :
              ( Xs
              = ( append @ A @ Ys2 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 ) ) ) )).

% split_list_prop
thf(fact_212_split__list__last,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys2: ( list @ A ),Zs2: ( list @ A )] :
          ( ( Xs
            = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ~ ( member @ A @ X2 @ ( set2 @ A @ Zs2 ) ) ) ) )).

% split_list_last
thf(fact_213_split__list,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys2: ( list @ A ),Zs2: ( list @ A )] :
          ( Xs
          = ( append @ A @ Ys2 @ ( cons @ A @ X2 @ Zs2 ) ) ) ) )).

% split_list
thf(fact_214_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_215_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_216_append__Nil,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_217_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_218_append__Cons,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( cons @ A @ X2 @ ( append @ A @ Xs @ Ys ) ) ) )).

% append_Cons
thf(fact_219_Cons__eq__appendI,axiom,(
    ! [A: $tType,X2: A,Xs1: ( list @ A ),Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X2 @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X2 @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_220_hd__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) )).

% hd_append
thf(fact_221_longest__common__prefix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
    ? [Ps: ( list @ A ),Xs4: ( list @ A ),Ys5: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs4 ) )
      & ( Ys
        = ( append @ A @ Ps @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) )).

% longest_common_prefix
thf(fact_222_cycle__Cons,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( stream317748790_cycle @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( stream641971652_SCons @ A @ X2 @ ( stream317748790_cycle @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ) )).

% cycle_Cons
thf(fact_223_rotate1__hd__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) )).

% rotate1_hd_tl
thf(fact_224_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X2: B,Xs: ( list @ B ),F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X2 @ Xs ) @ F )
      = ( append @ A @ ( F @ X2 ) @ ( bind @ B @ A @ Xs @ F ) ) ) )).

% bind_simps(2)
thf(fact_225_id__stake__snth__sdrop,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),I: nat] :
      ( S2
      = ( stream1035003186_shift @ A @ ( stream1746350922_stake @ A @ I @ S2 ) @ ( stream641971652_SCons @ A @ ( stream370371455e_snth @ A @ S2 @ I ) @ ( stream135081970_sdrop @ A @ ( suc @ I ) @ S2 ) ) ) ) )).

% id_stake_snth_sdrop
thf(fact_226_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_227_set__rotate1,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) )).

% set_rotate1
thf(fact_228_length__rotate1,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) )).

% length_rotate1
thf(fact_229_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_230_sdrop__simps_I2_J,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream135081970_sdrop @ A @ N @ S2 ) )
      = ( stream135081970_sdrop @ A @ ( suc @ N ) @ S2 ) ) )).

% sdrop_simps(2)
thf(fact_231_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_232_length__Suc__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),N: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N ) )
      = ( ? [Y4: A,Ys3: ( list @ A )] :
            ( ( Xs
              = ( cons @ A @ Y4 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) )).

% length_Suc_conv
thf(fact_233_Suc__length__conv,axiom,(
    ! [A: $tType,N: nat,Xs: ( list @ A )] :
      ( ( ( suc @ N )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y4: A,Ys3: ( list @ A )] :
            ( ( Xs
              = ( cons @ A @ Y4 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N ) ) ) ) )).

% Suc_length_conv
thf(fact_234_list__bind__cong,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),F: ( A > ( list @ B ) ),G: ( A > ( list @ B ) )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( F @ X3 )
              = ( G @ X3 ) ) )
       => ( ( bind @ A @ B @ Xs @ F )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) )).

% list_bind_cong
thf(fact_235_snth__Stream,axiom,(
    ! [A: $tType,X2: A,S2: ( stream170649215stream @ A ),I: nat] :
      ( ( stream370371455e_snth @ A @ ( stream641971652_SCons @ A @ X2 @ S2 ) @ ( suc @ I ) )
      = ( stream370371455e_snth @ A @ S2 @ I ) ) )).

% snth_Stream
thf(fact_236_snth_Osimps_I2_J,axiom,(
    ! [A: $tType,S2: ( stream170649215stream @ A ),N: nat] :
      ( ( stream370371455e_snth @ A @ S2 @ ( suc @ N ) )
      = ( stream370371455e_snth @ A @ ( stream_Mirabelle_stl @ A @ S2 ) @ N ) ) )).

% snth.simps(2)
thf(fact_237_sdrop_Osimps_I2_J,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( stream135081970_sdrop @ A @ ( suc @ N ) @ S2 )
      = ( stream135081970_sdrop @ A @ N @ ( stream_Mirabelle_stl @ A @ S2 ) ) ) )).

% sdrop.simps(2)
thf(fact_238_stake_Osimps_I2_J,axiom,(
    ! [A: $tType,N: nat,S2: ( stream170649215stream @ A )] :
      ( ( stream1746350922_stake @ A @ ( suc @ N ) @ S2 )
      = ( cons @ A @ ( stream_Mirabelle_shd @ A @ S2 ) @ ( stream1746350922_stake @ A @ N @ ( stream_Mirabelle_stl @ A @ S2 ) ) ) ) )).

% stake.simps(2)
thf(fact_239_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_240_length__append__singleton,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X2: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) )).

% length_append_singleton
thf(fact_241_length__Cons,axiom,(
    ! [A: $tType,X2: A,Xs: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) )).

% length_Cons
thf(fact_242_BNF__Greatest__Fixpoint_Oshift__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Greatest_shift @ A @ B )
      = ( ^ [Lab: ( ( list @ A ) > B ),K: A,Kl: ( list @ A )] :
            ( Lab @ ( cons @ A @ K @ Kl ) ) ) ) )).

% BNF_Greatest_Fixpoint.shift_def
thf(fact_243_SuccD,axiom,(
    ! [A: $tType,K2: A,Kl2: ( set @ ( list @ A ) ),Kl3: ( list @ A )] :
      ( ( member @ A @ K2 @ ( bNF_Greatest_Succ @ A @ Kl2 @ Kl3 ) )
     => ( member @ ( list @ A ) @ ( append @ A @ Kl3 @ ( cons @ A @ K2 @ ( nil @ A ) ) ) @ Kl2 ) ) )).

% SuccD
thf(fact_244_SuccI,axiom,(
    ! [A: $tType,Kl3: ( list @ A ),K2: A,Kl2: ( set @ ( list @ A ) )] :
      ( ( member @ ( list @ A ) @ ( append @ A @ Kl3 @ ( cons @ A @ K2 @ ( nil @ A ) ) ) @ Kl2 )
     => ( member @ A @ K2 @ ( bNF_Greatest_Succ @ A @ Kl2 @ Kl3 ) ) ) )).

% SuccI
thf(fact_245_empty__Shift,axiom,(
    ! [A: $tType,Kl2: ( set @ ( list @ A ) ),K2: A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ Kl2 )
     => ( ( member @ A @ K2 @ ( bNF_Greatest_Succ @ A @ Kl2 @ ( nil @ A ) ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( bNF_Greatest_Shift @ A @ Kl2 @ K2 ) ) ) ) )).

% empty_Shift
thf(fact_246_Succ__Shift,axiom,(
    ! [A: $tType,Kl2: ( set @ ( list @ A ) ),K2: A,Kl3: ( list @ A )] :
      ( ( bNF_Greatest_Succ @ A @ ( bNF_Greatest_Shift @ A @ Kl2 @ K2 ) @ Kl3 )
      = ( bNF_Greatest_Succ @ A @ Kl2 @ ( cons @ A @ K2 @ Kl3 ) ) ) )).

% Succ_Shift
thf(fact_247_ShiftD,axiom,(
    ! [A: $tType,Kl3: ( list @ A ),Kl2: ( set @ ( list @ A ) ),K2: A] :
      ( ( member @ ( list @ A ) @ Kl3 @ ( bNF_Greatest_Shift @ A @ Kl2 @ K2 ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ K2 @ Kl3 ) @ Kl2 ) ) )).

% ShiftD
thf(fact_248_gen__length__code_I2_J,axiom,(
    ! [B: $tType,N: nat,X2: B,Xs: ( list @ B )] :
      ( ( gen_length @ B @ N @ ( cons @ B @ X2 @ Xs ) )
      = ( gen_length @ B @ ( suc @ N ) @ Xs ) ) )).

% gen_length_code(2)
thf(fact_249_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( list @ A ) ),X2: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F @ ( cons @ B @ X2 @ Xs ) )
      = ( append @ A @ ( F @ X2 ) @ ( maps @ B @ A @ F @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_250_gen__length__code_I1_J,axiom,(
    ! [A: $tType,N: nat] :
      ( ( gen_length @ A @ N @ ( nil @ A ) )
      = N ) )).

% gen_length_code(1)
thf(fact_251_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_252_length__n__lists__elem,axiom,(
    ! [A: $tType,Ys: ( list @ A ),N: nat,Xs: ( list @ A )] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N ) ) )).

% length_n_lists_elem
thf(fact_253_take__Suc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),N: nat] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( take @ A @ ( suc @ N ) @ Xs )
        = ( cons @ A @ ( hd @ A @ Xs ) @ ( take @ A @ N @ ( tl @ A @ Xs ) ) ) ) ) )).

% take_Suc
thf(fact_254_take__Suc__Cons,axiom,(
    ! [A: $tType,N: nat,X2: A,Xs: ( list @ A )] :
      ( ( take @ A @ ( suc @ N ) @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2 @ ( take @ A @ N @ Xs ) ) ) )).

% take_Suc_Cons

%----Type constructors (8)
thf(tcon_fun___Lattices_Osemilattice__sup,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( semilattice_sup @ A9 @ ( type2 @ A9 ) )
     => ( semilattice_sup @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_fun___Lattices_Olattice,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( lattice @ A9 @ ( type2 @ A9 ) )
     => ( lattice @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_1,axiom,
    ( semilattice_sup @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Lattices_Olattice_2,axiom,
    ( lattice @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_3,axiom,(
    ! [A8: $tType] :
      ( semilattice_sup @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Olattice_4,axiom,(
    ! [A8: $tType] :
      ( lattice @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_5,axiom,
    ( semilattice_sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Olattice_6,axiom,
    ( lattice @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( stream30925839e_sset @ a @ ( stream317748790_cycle @ a @ xs ) )
    = ( set2 @ a @ xs ) )).

%------------------------------------------------------------------------------
