%------------------------------------------------------------------------------
% File     : DAT251^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Infinite streams (sequences/lists) 443
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream__443.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  326 (   0 unit;  59 type;   0 defn)
%            Number of atoms       : 4918 ( 481 equality;3090 variable)
%            Maximal formula depth :   23 (  10 average)
%            Number of connectives : 4460 ( 140   ~;  30   |;  80   &;3912   @)
%                                         (   0 <=>; 298  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  246 ( 246   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   63 (  59   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1171 (   0 sgn;1002   !;  72   ?;  34   ^)
%                                         (1171   :;  63  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:42:29.928
%------------------------------------------------------------------------------
%----Could-be-implicit typings (6)
thf(ty_t_Stream__Mirabelle__hbrgyiwlrc_Ostream,type,(
    stream170649215stream: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (53)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OShift,type,(
    bNF_Greatest_Shift: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > A > ( set @ ( list @ A ) ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_OSucc,type,(
    bNF_Greatest_Succ: 
      !>[A: $tType] :
        ( ( set @ ( list @ A ) ) > ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_BNF__Greatest__Fixpoint_Oshift,type,(
    bNF_Greatest_shift: 
      !>[A: $tType,B: $tType] :
        ( ( ( list @ A ) > B ) > A > ( list @ A ) > B ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Obutlast,type,(
    butlast: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Ofold,type,(
    fold: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B ) > ( list @ A ) > B > B ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olast,type,(
    last: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Ocase__list,type,(
    case_list: 
      !>[B: $tType,A: $tType] :
        ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) )).

thf(sy_c_List_Olist_Ohd,type,(
    hd: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olist_Omap,type,(
    map: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) )).

thf(sy_c_List_Olist_Otl,type,(
    tl: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Olistrelp,type,(
    listrelp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) )).

thf(sy_c_List_Omap__tailrec,type,(
    map_tailrec: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omap__tailrec__rev,type,(
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omember,type,(
    member: 
      !>[A: $tType] :
        ( ( list @ A ) > A > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord__class_Olexordp,type,(
    ord_lexordp: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord__class_Olexordp__eq,type,(
    ord_lexordp_eq: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Oremdups__adj,type,(
    remdups_adj: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Oreplicate,type,(
    replicate: 
      !>[A: $tType] :
        ( nat > A > ( list @ A ) ) )).

thf(sy_c_List_Orev,type,(
    rev: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osplice,type,(
    splice: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Ounion,type,(
    union: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ocycle,type,(
    stream317748790_cycle: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Oflat,type,(
    stream942386729e_flat: 
      !>[A: $tType] :
        ( ( stream170649215stream @ ( list @ A ) ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osdrop__while,type,(
    stream1195056575_while: 
      !>[A: $tType] :
        ( ( A > $o ) > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Oshift,type,(
    stream1035003186_shift: 
      !>[A: $tType] :
        ( ( list @ A ) > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Osmember,type,(
    stream1586597341member: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > $o ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_OSCons,type,(
    stream641971652_SCons: 
      !>[A: $tType] :
        ( A > ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ocase__stream,type,(
    stream1342653232stream: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( stream170649215stream @ A ) > B ) > ( stream170649215stream @ A ) > B ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Oshd,type,(
    stream_Mirabelle_shd: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > A ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Osmap,type,(
    stream2128578057e_smap: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( stream170649215stream @ A ) > ( stream170649215stream @ Aa ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostream_Ostl,type,(
    stream_Mirabelle_stl: 
      !>[A: $tType] :
        ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) ) )).

thf(sy_c_Stream__Mirabelle__hbrgyiwlrc_Ostreams,type,(
    stream2015131171treams: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( stream170649215stream @ A ) ) ) )).

thf(sy_c_member,type,(
    member2: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_ws,type,(
    ws: ( stream170649215stream @ ( list @ a ) ) )).

%----Relevant facts (255)
thf(fact_0_shift__left__inj,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S1: ( stream170649215stream @ A ),S2: ( stream170649215stream @ A )] :
      ( ( ( stream1035003186_shift @ A @ Xs @ S1 )
        = ( stream1035003186_shift @ A @ Xs @ S2 ) )
      = ( S1 = S2 ) ) )).

% shift_left_inj
thf(fact_1_shift_Osimps_I1_J,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( nil @ A ) @ S )
      = S ) )).

% shift.simps(1)
thf(fact_2_stream_Oexpand,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( ( ( stream_Mirabelle_shd @ A @ Stream )
          = ( stream_Mirabelle_shd @ A @ Stream2 ) )
        & ( ( stream_Mirabelle_stl @ A @ Stream )
          = ( stream_Mirabelle_stl @ A @ Stream2 ) ) )
     => ( Stream = Stream2 ) ) )).

% stream.expand
thf(fact_3_stream_Ocoinduct,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct
thf(fact_4_stream_Ocoinduct__strong,axiom,(
    ! [A: $tType,R: ( ( stream170649215stream @ A ) > ( stream170649215stream @ A ) > $o ),Stream: ( stream170649215stream @ A ),Stream2: ( stream170649215stream @ A )] :
      ( ( R @ Stream @ Stream2 )
     => ( ! [Stream3: ( stream170649215stream @ A ),Stream4: ( stream170649215stream @ A )] :
            ( ( R @ Stream3 @ Stream4 )
           => ( ( ( stream_Mirabelle_shd @ A @ Stream3 )
                = ( stream_Mirabelle_shd @ A @ Stream4 ) )
              & ( ( R @ ( stream_Mirabelle_stl @ A @ Stream3 ) @ ( stream_Mirabelle_stl @ A @ Stream4 ) )
                | ( ( stream_Mirabelle_stl @ A @ Stream3 )
                  = ( stream_Mirabelle_stl @ A @ Stream4 ) ) ) ) )
       => ( Stream = Stream2 ) ) ) )).

% stream.coinduct_strong
thf(fact_5_flat__Stream,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ws: ( stream170649215stream @ ( list @ A ) )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( stream942386729e_flat @ A @ ( stream641971652_SCons @ ( list @ A ) @ Xs @ Ws ) )
        = ( stream1035003186_shift @ A @ Xs @ ( stream942386729e_flat @ A @ Ws ) ) ) ) )).

% flat_Stream
thf(fact_6_shift__simps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( stream_Mirabelle_shd @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( stream_Mirabelle_shd @ A @ S ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( stream_Mirabelle_shd @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( hd @ A @ Xs ) ) ) ) )).

% shift_simps(1)
thf(fact_7_flat_Osimps_I1_J,axiom,(
    ! [A: $tType,Ws: ( stream170649215stream @ ( list @ A ) )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream942386729e_flat @ A @ Ws ) )
      = ( hd @ A @ ( stream_Mirabelle_shd @ ( list @ A ) @ Ws ) ) ) )).

% flat.simps(1)
thf(fact_8_stream_Ocase__eq__if,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( stream1342653232stream @ A @ B )
      = ( ^ [F: ( A > ( stream170649215stream @ A ) > B ),Stream5: ( stream170649215stream @ A )] :
            ( F @ ( stream_Mirabelle_shd @ A @ Stream5 ) @ ( stream_Mirabelle_stl @ A @ Stream5 ) ) ) ) )).

% stream.case_eq_if
thf(fact_9_shift__simps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( stream_Mirabelle_stl @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( stream_Mirabelle_stl @ A @ S ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( stream_Mirabelle_stl @ A @ ( stream1035003186_shift @ A @ Xs @ S ) )
          = ( stream1035003186_shift @ A @ ( tl @ A @ Xs ) @ S ) ) ) ) )).

% shift_simps(2)
thf(fact_10_sdrop__while_Osimps,axiom,(
    ! [A: $tType] :
      ( ( stream1195056575_while @ A )
      = ( ^ [P: ( A > $o ),S3: ( stream170649215stream @ A )] :
            ( if @ ( stream170649215stream @ A ) @ ( P @ ( stream_Mirabelle_shd @ A @ S3 ) ) @ ( stream1195056575_while @ A @ P @ ( stream_Mirabelle_stl @ A @ S3 ) ) @ S3 ) ) ) )).

% sdrop_while.simps
thf(fact_11_flat_Osimps_I2_J,axiom,(
    ! [A: $tType,Ws: ( stream170649215stream @ ( list @ A ) )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream942386729e_flat @ A @ Ws ) )
      = ( stream942386729e_flat @ A
        @ ( if @ ( stream170649215stream @ ( list @ A ) )
          @ ( ( tl @ A @ ( stream_Mirabelle_shd @ ( list @ A ) @ Ws ) )
            = ( nil @ A ) )
          @ ( stream_Mirabelle_stl @ ( list @ A ) @ Ws )
          @ ( stream641971652_SCons @ ( list @ A ) @ ( tl @ A @ ( stream_Mirabelle_shd @ ( list @ A ) @ Ws ) ) @ ( stream_Mirabelle_stl @ ( list @ A ) @ Ws ) ) ) ) ) )).

% flat.simps(2)
thf(fact_12_cycle__decomp,axiom,(
    ! [A: $tType,U: ( list @ A )] :
      ( ( U
       != ( nil @ A ) )
     => ( ( stream317748790_cycle @ A @ U )
        = ( stream1035003186_shift @ A @ U @ ( stream317748790_cycle @ A @ U ) ) ) ) )).

% cycle_decomp
thf(fact_13_stream_Ocollapse,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) )
      = Stream ) )).

% stream.collapse
thf(fact_14_streamsE,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A2 ) )
     => ~ ( ( member2 @ A @ ( stream_Mirabelle_shd @ A @ S ) @ A2 )
         => ~ ( member2 @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S ) @ ( stream2015131171treams @ A @ A2 ) ) ) ) )).

% streamsE
thf(fact_15_in__streams,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),S4: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S ) @ ( stream2015131171treams @ A @ S4 ) )
     => ( ( member2 @ A @ ( stream_Mirabelle_shd @ A @ S ) @ S4 )
       => ( member2 @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ S4 ) ) ) ) )).

% in_streams
thf(fact_16_stream_Oinject,axiom,(
    ! [A: $tType,X1: A,X2: ( stream170649215stream @ A ),Y1: A,Y2: ( stream170649215stream @ A )] :
      ( ( ( stream641971652_SCons @ A @ X1 @ X2 )
        = ( stream641971652_SCons @ A @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% stream.inject
thf(fact_17_list_Oexpand,axiom,(
    ! [A: $tType,List: ( list @ A ),List2: ( list @ A )] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) )).

% list.expand
thf(fact_18_stream_Ocase,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > ( stream170649215stream @ A ) > B ),X1: A,X2: ( stream170649215stream @ A )] :
      ( ( stream1342653232stream @ A @ B @ F2 @ ( stream641971652_SCons @ A @ X1 @ X2 ) )
      = ( F2 @ X1 @ X2 ) ) )).

% stream.case
thf(fact_19_streams_Ocases,axiom,(
    ! [A: $tType,A3: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ A3 @ ( stream2015131171treams @ A @ A2 ) )
     => ~ ( ! [A4: A,S5: ( stream170649215stream @ A )] :
              ( ( A3
                = ( stream641971652_SCons @ A @ A4 @ S5 ) )
             => ( ( member2 @ A @ A4 @ A2 )
               => ~ ( member2 @ ( stream170649215stream @ A ) @ S5 @ ( stream2015131171treams @ A @ A2 ) ) ) ) ) ) )).

% streams.cases
thf(fact_20_streams_Osimps,axiom,(
    ! [A: $tType,A3: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ A3 @ ( stream2015131171treams @ A @ A2 ) )
      = ( ? [A5: A,S3: ( stream170649215stream @ A )] :
            ( ( A3
              = ( stream641971652_SCons @ A @ A5 @ S3 ) )
            & ( member2 @ A @ A5 @ A2 )
            & ( member2 @ ( stream170649215stream @ A ) @ S3 @ ( stream2015131171treams @ A @ A2 ) ) ) ) ) )).

% streams.simps
thf(fact_21_stream_Oexhaust,axiom,(
    ! [A: $tType,Y: ( stream170649215stream @ A )] :
      ~ ( ! [X12: A,X22: ( stream170649215stream @ A )] :
            ( Y
           != ( stream641971652_SCons @ A @ X12 @ X22 ) ) ) )).

% stream.exhaust
thf(fact_22_streams__Stream,axiom,(
    ! [A: $tType,X: A,S: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ ( stream641971652_SCons @ A @ X @ S ) @ ( stream2015131171treams @ A @ A2 ) )
      = ( ( member2 @ A @ X @ A2 )
        & ( member2 @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A2 ) ) ) ) )).

% streams_Stream
thf(fact_23_streams_Ocoinduct,axiom,(
    ! [A: $tType,X3: ( ( stream170649215stream @ A ) > $o ),X: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( X3 @ X )
     => ( ! [X4: ( stream170649215stream @ A )] :
            ( ( X3 @ X4 )
           => ? [A6: A,S6: ( stream170649215stream @ A )] :
                ( ( X4
                  = ( stream641971652_SCons @ A @ A6 @ S6 ) )
                & ( member2 @ A @ A6 @ A2 )
                & ( ( X3 @ S6 )
                  | ( member2 @ ( stream170649215stream @ A ) @ S6 @ ( stream2015131171treams @ A @ A2 ) ) ) ) )
       => ( member2 @ ( stream170649215stream @ A ) @ X @ ( stream2015131171treams @ A @ A2 ) ) ) ) )).

% streams.coinduct
thf(fact_24_sdrop__while__SCons,axiom,(
    ! [A: $tType,P2: ( A > $o ),A3: A,S: ( stream170649215stream @ A )] :
      ( ( ( P2 @ A3 )
       => ( ( stream1195056575_while @ A @ P2 @ ( stream641971652_SCons @ A @ A3 @ S ) )
          = ( stream1195056575_while @ A @ P2 @ S ) ) )
      & ( ~ ( P2 @ A3 )
       => ( ( stream1195056575_while @ A @ P2 @ ( stream641971652_SCons @ A @ A3 @ S ) )
          = ( stream641971652_SCons @ A @ A3 @ S ) ) ) ) )).

% sdrop_while_SCons
thf(fact_25_list_Osel_I2_J,axiom,(
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% list.sel(2)
thf(fact_26_cycle_Osimps_I1_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream317748790_cycle @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) )).

% cycle.simps(1)
thf(fact_27_flat_Ocode,axiom,(
    ! [A: $tType] :
      ( ( stream942386729e_flat @ A )
      = ( ^ [Ws2: ( stream170649215stream @ ( list @ A ) )] :
            ( stream641971652_SCons @ A @ ( hd @ A @ ( stream_Mirabelle_shd @ ( list @ A ) @ Ws2 ) )
            @ ( stream942386729e_flat @ A
              @ ( if @ ( stream170649215stream @ ( list @ A ) )
                @ ( ( tl @ A @ ( stream_Mirabelle_shd @ ( list @ A ) @ Ws2 ) )
                  = ( nil @ A ) )
                @ ( stream_Mirabelle_stl @ ( list @ A ) @ Ws2 )
                @ ( stream641971652_SCons @ ( list @ A ) @ ( tl @ A @ ( stream_Mirabelle_shd @ ( list @ A ) @ Ws2 ) ) @ ( stream_Mirabelle_stl @ ( list @ A ) @ Ws2 ) ) ) ) ) ) ) )).

% flat.code
thf(fact_28_stream_Osel_I2_J,axiom,(
    ! [A: $tType,X1: A,X2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream641971652_SCons @ A @ X1 @ X2 ) )
      = X2 ) )).

% stream.sel(2)
thf(fact_29_stream_Osel_I1_J,axiom,(
    ! [A: $tType,X1: A,X2: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ A @ ( stream641971652_SCons @ A @ X1 @ X2 ) )
      = X1 ) )).

% stream.sel(1)
thf(fact_30_stream_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F2: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P2 @ ( stream1342653232stream @ A @ B @ F2 @ Stream ) )
      = ( ~ ( ( Stream
              = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
            & ~ ( P2 @ ( F2 @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) ) )).

% stream.split_sel_asm
thf(fact_31_stream_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F2: ( A > ( stream170649215stream @ A ) > B ),Stream: ( stream170649215stream @ A )] :
      ( ( P2 @ ( stream1342653232stream @ A @ B @ F2 @ Stream ) )
      = ( ( Stream
          = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) )
       => ( P2 @ ( F2 @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) ) ) )).

% stream.split_sel
thf(fact_32_streams__stl,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A2 ) )
     => ( member2 @ ( stream170649215stream @ A ) @ ( stream_Mirabelle_stl @ A @ S ) @ ( stream2015131171treams @ A @ A2 ) ) ) )).

% streams_stl
thf(fact_33_streams__shd,axiom,(
    ! [A: $tType,S: ( stream170649215stream @ A ),A2: ( set @ A )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A2 ) )
     => ( member2 @ A @ ( stream_Mirabelle_shd @ A @ S ) @ A2 ) ) )).

% streams_shd
thf(fact_34_stream_Oexhaust__sel,axiom,(
    ! [A: $tType,Stream: ( stream170649215stream @ A )] :
      ( Stream
      = ( stream641971652_SCons @ A @ ( stream_Mirabelle_shd @ A @ Stream ) @ ( stream_Mirabelle_stl @ A @ Stream ) ) ) )).

% stream.exhaust_sel
thf(fact_35_smember__code,axiom,(
    ! [A: $tType,X: A,Y: A,S: ( stream170649215stream @ A )] :
      ( ( stream1586597341member @ A @ X @ ( stream641971652_SCons @ A @ Y @ S ) )
      = ( ( X != Y )
       => ( stream1586597341member @ A @ X @ S ) ) ) )).

% smember_code
thf(fact_36_flat__Cons,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ws: ( stream170649215stream @ ( list @ A ) )] :
      ( ( stream942386729e_flat @ A @ ( stream641971652_SCons @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ws ) )
      = ( stream641971652_SCons @ A @ X
        @ ( stream942386729e_flat @ A
          @ ( if @ ( stream170649215stream @ ( list @ A ) )
            @ ( Xs
              = ( nil @ A ) )
            @ Ws
            @ ( stream641971652_SCons @ ( list @ A ) @ Xs @ Ws ) ) ) ) ) )).

% flat_Cons
thf(fact_37_list_Ocase__eq__if,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F1: B,F22: ( A > ( list @ A ) > B ),List3: ( list @ A )] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F1
            @ ( F22 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) )).

% list.case_eq_if
thf(fact_38_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P2: ( A > $o )] :
      ~ ( list_ex1 @ A @ P2 @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_39_hd__Cons__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) )).

% hd_Cons_tl
thf(fact_40_list_Ocollapse,axiom,(
    ! [A: $tType,List: ( list @ A )] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) )).

% list.collapse
thf(fact_41_smap__ctr,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),S: ( stream170649215stream @ B ),X: A,S7: ( stream170649215stream @ A )] :
      ( ( ( stream2128578057e_smap @ B @ A @ F2 @ S )
        = ( stream641971652_SCons @ A @ X @ S7 ) )
      = ( ( ( F2 @ ( stream_Mirabelle_shd @ B @ S ) )
          = X )
        & ( ( stream2128578057e_smap @ B @ A @ F2 @ ( stream_Mirabelle_stl @ B @ S ) )
          = S7 ) ) ) )).

% smap_ctr
thf(fact_42_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_43_list_Oexhaust__sel,axiom,(
    ! [A: $tType,List: ( list @ A )] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) )).

% list.exhaust_sel
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A3: A,P2: ( A > $o )] :
      ( ( member2 @ A @ A3 @ ( collect @ A @ P2 ) )
      = ( P2 @ A3 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A2: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X5: A] :
            ( member2 @ A @ X5 @ A2 ) )
      = A2 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P2: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P2 @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P2 )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F2 @ X4 )
          = ( G @ X4 ) )
     => ( F2 = G ) ) )).

% ext
thf(fact_48_member__rec_I2_J,axiom,(
    ! [A: $tType,Y: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y ) )).

% member_rec(2)
thf(fact_49_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y22 ) ) ) )).

% list.inject
thf(fact_50_stream_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),A3: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_stl @ B @ ( stream2128578057e_smap @ A @ B @ F2 @ A3 ) )
      = ( stream2128578057e_smap @ A @ B @ F2 @ ( stream_Mirabelle_stl @ A @ A3 ) ) ) )).

% stream.map_sel(2)
thf(fact_51_stream_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),A3: ( stream170649215stream @ A )] :
      ( ( stream_Mirabelle_shd @ B @ ( stream2128578057e_smap @ A @ B @ F2 @ A3 ) )
      = ( F2 @ ( stream_Mirabelle_shd @ A @ A3 ) ) ) )).

% stream.map_sel(1)
thf(fact_52_list_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,F12: B,F23: ( A > ( list @ A ) > B ),X21: A,X222: ( list @ A )] :
      ( ( case_list @ B @ A @ F12 @ F23 @ ( cons @ A @ X21 @ X222 ) )
      = ( F23 @ X21 @ X222 ) ) )).

% list.simps(5)
thf(fact_53_member__rec_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A] :
      ( ( member @ A @ ( cons @ A @ X @ Xs ) @ Y )
      = ( ( X = Y )
        | ( member @ A @ Xs @ Y ) ) ) )).

% member_rec(1)
thf(fact_54_not__Cons__self2,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_55_transpose_Ocases,axiom,(
    ! [A: $tType,X: ( list @ ( list @ A ) )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X4: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X
               != ( cons @ ( list @ A ) @ ( cons @ A @ X4 @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_56_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) )).

% list.distinct(1)
thf(fact_57_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X222: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_58_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X223: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X223 ) ) ) ) )).

% list.exhaust
thf(fact_59_list_Oinducts,axiom,(
    ! [A: $tType,P2: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [X12: A,X22: ( list @ A )] :
            ( ( P2 @ X22 )
           => ( P2 @ ( cons @ A @ X12 @ X22 ) ) )
       => ( P2 @ List ) ) ) )).

% list.inducts
thf(fact_60_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys ) ) ) ) )).

% neq_Nil_conv
thf(fact_61_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P2: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys2: ( list @ B )] :
      ( ( P2 @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X4: A,Xs2: ( list @ A )] :
            ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y4: B,Ys3: ( list @ B )] :
              ( P2 @ ( nil @ A ) @ ( cons @ B @ Y4 @ Ys3 ) )
         => ( ! [X4: A,Xs2: ( list @ A ),Y4: B,Ys3: ( list @ B )] :
                ( ( P2 @ Xs2 @ Ys3 )
               => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ B @ Y4 @ Ys3 ) ) )
           => ( P2 @ Xs @ Ys2 ) ) ) ) ) )).

% list_induct2'
thf(fact_62_splice_Oinduct,axiom,(
    ! [A: $tType,P2: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X12: ( list @ A )] :
          ( P2 @ ( nil @ A ) @ X12 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P2 @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X4: A,Xs2: ( list @ A ),Y4: A,Ys3: ( list @ A )] :
              ( ( P2 @ Xs2 @ Ys3 )
             => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) )
         => ( P2 @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_63_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X: ( list @ A )] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X4: A] :
            ( X
           != ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ~ ( ! [X4: A,Y4: A,Xs2: ( list @ A )] :
                ( X
               != ( cons @ A @ X4 @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_64_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P2: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [X4: A] :
            ( P2 @ ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ( ! [X4: A,Y4: A,Xs2: ( list @ A )] :
              ( ( ( X4 = Y4 )
               => ( P2 @ ( cons @ A @ X4 @ Xs2 ) ) )
             => ( ( ( X4 != Y4 )
                 => ( P2 @ ( cons @ A @ Y4 @ Xs2 ) ) )
               => ( P2 @ ( cons @ A @ X4 @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) )
         => ( P2 @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_65_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P2: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X4: A] :
            ( P2 @ ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ( ! [X4: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P2 @ Xs2 )
               => ( P2 @ ( cons @ A @ X4 @ Xs2 ) ) ) )
         => ( P2 @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_66_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P2: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ! [F3: ( A > B ),X12: ( list @ B )] :
          ( P2 @ F3 @ ( nil @ A ) @ X12 )
     => ( ! [F3: ( A > B ),A4: A,As: ( list @ A ),Bs: ( list @ B )] :
            ( ( P2 @ F3 @ As @ ( cons @ B @ ( F3 @ A4 ) @ Bs ) )
           => ( P2 @ F3 @ ( cons @ A @ A4 @ As ) @ Bs ) )
       => ( P2 @ A0 @ A1 @ A22 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_67_list_Osel_I3_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) )).

% list.sel(3)
thf(fact_68_list_Osel_I1_J,axiom,(
    ! [A: $tType,X21: A,X222: ( list @ A )] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) )).

% list.sel(1)
thf(fact_69_stream_Omap,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),X1: A,X2: ( stream170649215stream @ A )] :
      ( ( stream2128578057e_smap @ A @ B @ F2 @ ( stream641971652_SCons @ A @ X1 @ X2 ) )
      = ( stream641971652_SCons @ B @ ( F2 @ X1 ) @ ( stream2128578057e_smap @ A @ B @ F2 @ X2 ) ) ) )).

% stream.map
thf(fact_70_smap__streams,axiom,(
    ! [A: $tType,B: $tType,S: ( stream170649215stream @ A ),A2: ( set @ A ),F2: ( A > B ),B2: ( set @ B )] :
      ( ( member2 @ ( stream170649215stream @ A ) @ S @ ( stream2015131171treams @ A @ A2 ) )
     => ( ! [X4: A] :
            ( ( member2 @ A @ X4 @ A2 )
           => ( member2 @ B @ ( F2 @ X4 ) @ B2 ) )
       => ( member2 @ ( stream170649215stream @ B ) @ ( stream2128578057e_smap @ A @ B @ F2 @ S ) @ ( stream2015131171treams @ B @ B2 ) ) ) ) )).

% smap_streams
thf(fact_71_list_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,F12: B,F23: ( A > ( list @ A ) > B )] :
      ( ( case_list @ B @ A @ F12 @ F23 @ ( nil @ A ) )
      = F12 ) )).

% list.simps(4)
thf(fact_72_list_Osplit__sel__asm,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F12: B,F23: ( A > ( list @ A ) > B ),List: ( list @ A )] :
      ( ( P2 @ ( case_list @ B @ A @ F12 @ F23 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P2 @ F12 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P2 @ ( F23 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) )).

% list.split_sel_asm
thf(fact_73_list_Osplit__sel,axiom,(
    ! [B: $tType,A: $tType,P2: ( B > $o ),F12: B,F23: ( A > ( list @ A ) > B ),List: ( list @ A )] :
      ( ( P2 @ ( case_list @ B @ A @ F12 @ F23 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P2 @ F12 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P2 @ ( F23 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) )).

% list.split_sel
thf(fact_74_tl__Nil,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X5: A] :
            ( Xs
            = ( cons @ A @ X5 @ ( nil @ A ) ) ) ) ) )).

% tl_Nil
thf(fact_75_Nil__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X5: A] :
            ( Xs
            = ( cons @ A @ X5 @ ( nil @ A ) ) ) ) ) )).

% Nil_tl
thf(fact_76_shift_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( cons @ A @ X @ Xs ) @ S )
      = ( stream641971652_SCons @ A @ X @ ( stream1035003186_shift @ A @ Xs @ S ) ) ) )).

% shift.simps(2)
thf(fact_77_cycle__rotated,axiom,(
    ! [A: $tType,V2: ( list @ A ),U: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( V2
       != ( nil @ A ) )
     => ( ( ( stream317748790_cycle @ A @ U )
          = ( stream1035003186_shift @ A @ V2 @ S ) )
       => ( ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ U ) @ ( cons @ A @ ( hd @ A @ U ) @ ( nil @ A ) ) ) )
          = ( stream1035003186_shift @ A @ ( tl @ A @ V2 ) @ S ) ) ) ) )).

% cycle_rotated
thf(fact_78_cycle_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( stream_Mirabelle_stl @ A @ ( stream317748790_cycle @ A @ Xs ) )
      = ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) )).

% cycle.simps(2)
thf(fact_79_cycle_Ocode,axiom,(
    ! [A: $tType] :
      ( ( stream317748790_cycle @ A )
      = ( ^ [Xs3: ( list @ A )] :
            ( stream641971652_SCons @ A @ ( hd @ A @ Xs3 ) @ ( stream317748790_cycle @ A @ ( append @ A @ ( tl @ A @ Xs3 ) @ ( cons @ A @ ( hd @ A @ Xs3 ) @ ( nil @ A ) ) ) ) ) ) ) )).

% cycle.code
thf(fact_80_insert__Nil,axiom,(
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_81_cycle__Cons,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( stream317748790_cycle @ A @ ( cons @ A @ X @ Xs ) )
      = ( stream641971652_SCons @ A @ X @ ( stream317748790_cycle @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ) )).

% cycle_Cons
thf(fact_82_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_83_map__tailrec__rev_Oelims,axiom,(
    ! [A: $tType,B: $tType,X: ( A > B ),Xa: ( list @ A ),Xb: ( list @ B ),Y: ( list @ B )] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb ) )
       => ~ ( ! [A4: A,As: ( list @ A )] :
                ( ( Xa
                  = ( cons @ A @ A4 @ As ) )
               => ( Y
                 != ( map_tailrec_rev @ A @ B @ X @ As @ ( cons @ B @ ( X @ A4 ) @ Xb ) ) ) ) ) ) ) )).

% map_tailrec_rev.elims
thf(fact_84_splice_Oelims,axiom,(
    ! [A: $tType,X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ( ! [V: A,Va: ( list @ A )] :
              ( ( X
                = ( cons @ A @ V @ Va ) )
             => ( ( Xa
                  = ( nil @ A ) )
               => ( Y
                 != ( cons @ A @ V @ Va ) ) ) )
         => ~ ( ! [X4: A,Xs2: ( list @ A )] :
                  ( ( X
                    = ( cons @ A @ X4 @ Xs2 ) )
                 => ! [Y4: A,Ys3: ( list @ A )] :
                      ( ( Xa
                        = ( cons @ A @ Y4 @ Ys3 ) )
                     => ( Y
                       != ( cons @ A @ X4 @ ( cons @ A @ Y4 @ ( splice @ A @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ) ) )).

% splice.elims
thf(fact_85_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys2 = Zs ) ) )).

% same_append_eq
thf(fact_86_append__same__eq,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys2 @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys2 = Zs ) ) )).

% append_same_eq
thf(fact_87_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys2 ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys2 @ Zs ) ) ) )).

% append_assoc
thf(fact_88_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_89_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys2 ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys2
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_90_self__append__conv2,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys2
        = ( append @ A @ Xs @ Ys2 ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_91_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Ys2 )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_92_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys2 ) )
      = ( Ys2
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_93_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = Xs )
      = ( Ys2
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_94_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_95_shift__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A ),S: ( stream170649215stream @ A )] :
      ( ( stream1035003186_shift @ A @ ( append @ A @ Xs @ Ys2 ) @ S )
      = ( stream1035003186_shift @ A @ Xs @ ( stream1035003186_shift @ A @ Ys2 @ S ) ) ) )).

% shift_append
thf(fact_96_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A ),Y: A,Ys2: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys2 ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_97_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys2: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys2 ) )).

% ord.lexordp_eq_simps(1)
thf(fact_98_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_99_splice__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% splice_Nil2
thf(fact_100_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys2: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys2 @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys2 )
        & ( X = Y ) ) ) )).

% append1_eq_conv
thf(fact_101_tl__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys2 ) ) ) )).

% tl_append2
thf(fact_102_hd__append2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( hd @ A @ Xs ) ) ) )).

% hd_append2
thf(fact_103_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X: B,Xs: ( list @ B ),F2: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) )).

% bind_simps(2)
thf(fact_104_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys2 )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us ) )
              & ( ( append @ A @ Us @ Ys2 )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us )
                = Zs )
              & ( Ys2
                = ( append @ A @ Us @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_105_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_106_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys2: ( list @ A ),Us2: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys2
          = ( append @ A @ Xs1 @ Us2 ) )
       => ( ( append @ A @ Xs @ Ys2 )
          = ( append @ A @ Zs @ Us2 ) ) ) ) )).

% append_eq_appendI
thf(fact_107_append__Cons,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys2 )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys2 ) ) ) )).

% append_Cons
thf(fact_108_Cons__eq__appendI,axiom,(
    ! [A: $tType,X: A,Xs1: ( list @ A ),Ys2: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys2 )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys2 @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_109_append__Nil,axiom,(
    ! [A: $tType,Ys2: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys2 )
      = Ys2 ) )).

% append_Nil
thf(fact_110_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Xs = Ys2 )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys2 ) ) ) )).

% eq_Nil_appendI
thf(fact_111_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys2 )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_112_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( Less @ X @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_113_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys2: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys2 ) )).

% ord.lexordp_eq.Nil
thf(fact_114_splice_Osimps_I3_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A,Ys2: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
      = ( cons @ A @ X @ ( cons @ A @ Y @ ( splice @ A @ Xs @ Ys2 ) ) ) ) )).

% splice.simps(3)
thf(fact_115_splice_Osimps_I1_J,axiom,(
    ! [A: $tType,Ys2: ( list @ A )] :
      ( ( splice @ A @ ( nil @ A ) @ Ys2 )
      = Ys2 ) )).

% splice.simps(1)
thf(fact_116_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P2: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X4: A] :
            ( P2 @ ( cons @ A @ X4 @ ( nil @ A ) ) )
       => ( ! [X4: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P2 @ Xs2 )
               => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X4 @ ( nil @ A ) ) ) ) ) )
         => ( P2 @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_117_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Zs: ( list @ A ),X: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys2 @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys2
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys4: ( list @ A )] :
            ( ( Ys2
              = ( cons @ A @ X @ Ys4 ) )
            & ( ( append @ A @ Ys4 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_118_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys2: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys2 @ Zs ) )
      = ( ( ( Ys2
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys4: ( list @ A )] :
            ( ( ( cons @ A @ X @ Ys4 )
              = Ys2 )
            & ( Xs
              = ( append @ A @ Ys4 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_119_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys3: ( list @ A ),Y4: A] :
              ( Xs
             != ( append @ A @ Ys3 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_120_rev__induct,axiom,(
    ! [A: $tType,P2: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P2 @ ( nil @ A ) )
     => ( ! [X4: A,Xs2: ( list @ A )] :
            ( ( P2 @ Xs2 )
           => ( P2 @ ( append @ A @ Xs2 @ ( cons @ A @ X4 @ ( nil @ A ) ) ) ) )
       => ( P2 @ Xs ) ) ) )).

% rev_induct
thf(fact_121_map__tailrec__rev_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),A3: A,As2: ( list @ A ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( cons @ A @ A3 @ As2 ) @ Bs2 )
      = ( map_tailrec_rev @ A @ B @ F2 @ As2 @ ( cons @ B @ ( F2 @ A3 ) @ Bs2 ) ) ) )).

% map_tailrec_rev.simps(2)
thf(fact_122_map__tailrec__rev_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),Bs2: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F2 @ ( nil @ A ) @ Bs2 )
      = Bs2 ) )).

% map_tailrec_rev.simps(1)
thf(fact_123_hd__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( hd @ A @ Ys2 ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( hd @ A @ Xs ) ) ) ) )).

% hd_append
thf(fact_124_longest__common__prefix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
    ? [Ps: ( list @ A ),Xs4: ( list @ A ),Ys5: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Ps @ Xs4 ) )
      & ( Ys2
        = ( append @ A @ Ps @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) )).

% longest_common_prefix
thf(fact_125_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A22: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys3: ( list @ A )] : ( A22 != Ys3 ) )
       => ( ! [X4: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X4 @ Xs2 ) )
             => ! [Y4: A] :
                  ( ? [Ys3: ( list @ A )] :
                      ( A22
                      = ( cons @ A @ Y4 @ Ys3 ) )
                 => ~ ( Less @ X4 @ Y4 ) ) )
         => ~ ( ! [X4: A,Y4: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X4 @ Xs2 ) )
                 => ! [Ys3: ( list @ A )] :
                      ( ( A22
                        = ( cons @ A @ Y4 @ Ys3 ) )
                     => ( ~ ( Less @ X4 @ Y4 )
                       => ( ~ ( Less @ Y4 @ X4 )
                         => ~ ( lexordp_eq @ A @ Less @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_126_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A23: ( list @ A )] :
            ( ? [Ys: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A23 = Ys ) )
            | ? [X5: A,Y3: A,Xs3: ( list @ A ),Ys: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys ) )
                & ( Less2 @ X5 @ Y3 ) )
            | ? [X5: A,Y3: A,Xs3: ( list @ A ),Ys: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( A23
                  = ( cons @ A @ Y3 @ Ys ) )
                & ~ ( Less2 @ X5 @ Y3 )
                & ~ ( Less2 @ Y3 @ X5 )
                & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_127_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X1: ( list @ A ),X2: ( list @ A ),P2: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X1 @ X2 )
     => ( ! [X12: ( list @ A )] :
            ( P2 @ ( nil @ A ) @ X12 )
       => ( ! [X4: A,Y4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
              ( ( Less @ X4 @ Y4 )
             => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) )
         => ( ! [X4: A,Y4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
                ( ~ ( Less @ X4 @ Y4 )
               => ( ~ ( Less @ Y4 @ X4 )
                 => ( ( lexordp_eq @ A @ Less @ Xs2 @ Ys3 )
                   => ( ( P2 @ Xs2 @ Ys3 )
                     => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) ) ) ) )
           => ( P2 @ X1 @ X2 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_128_splice_Osimps_I2_J,axiom,(
    ! [A: $tType,V2: A,Va2: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
      = ( cons @ A @ V2 @ Va2 ) ) )).

% splice.simps(2)
thf(fact_129_rotate1__hd__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) )).

% rotate1_hd_tl
thf(fact_130_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_131_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_132_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > ( list @ A ) ),X: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) )
      = ( append @ A @ ( F2 @ X ) @ ( maps @ B @ A @ F2 @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_133_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_134_remdups__adj__append,axiom,(
    ! [A: $tType,Xs_1: ( list @ A ),X: A,Xs_2: ( list @ A )] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs_2 ) ) ) ) ) )).

% remdups_adj_append
thf(fact_135_remdups__adj__Nil__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% remdups_adj_Nil_iff
thf(fact_136_hd__remdups__adj,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) )).

% hd_remdups_adj
thf(fact_137_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_138_remdups__adj__Cons__alt,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )).

% remdups_adj_Cons_alt
thf(fact_139_remdups__adj_Osimps_I3_J,axiom,(
    ! [A: $tType,X: A,Y: A,Xs: ( list @ A )] :
      ( ( ( X = Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X @ Xs ) ) ) )
      & ( ( X != Y )
       => ( ( remdups_adj @ A @ ( cons @ A @ X @ ( cons @ A @ Y @ Xs ) ) )
          = ( cons @ A @ X @ ( remdups_adj @ A @ ( cons @ A @ Y @ Xs ) ) ) ) ) ) )).

% remdups_adj.simps(3)
thf(fact_140_remdups__adj_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% remdups_adj.simps(1)
thf(fact_141_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_142_remdups__adj_Oelims,axiom,(
    ! [A: $tType,X: ( list @ A ),Y: ( list @ A )] :
      ( ( ( remdups_adj @ A @ X )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y
           != ( nil @ A ) ) )
       => ( ! [X4: A] :
              ( ( X
                = ( cons @ A @ X4 @ ( nil @ A ) ) )
             => ( Y
               != ( cons @ A @ X4 @ ( nil @ A ) ) ) )
         => ~ ( ! [X4: A,Y4: A,Xs2: ( list @ A )] :
                  ( ( X
                    = ( cons @ A @ X4 @ ( cons @ A @ Y4 @ Xs2 ) ) )
                 => ~ ( ( ( X4 = Y4 )
                       => ( Y
                          = ( remdups_adj @ A @ ( cons @ A @ X4 @ Xs2 ) ) ) )
                      & ( ( X4 != Y4 )
                       => ( Y
                          = ( cons @ A @ X4 @ ( remdups_adj @ A @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) ) ) ) ) ) ) )).

% remdups_adj.elims
thf(fact_143_remdups__adj_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) )).

% remdups_adj.simps(2)
thf(fact_144_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_145_remdups__adj__append__two,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Y: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X = Y ) @ ( nil @ A ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) )).

% remdups_adj_append_two
thf(fact_146_last__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) )).

% last_snoc
thf(fact_147_butlast__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = Xs ) )).

% butlast_snoc
thf(fact_148_SuccD,axiom,(
    ! [A: $tType,K: A,Kl: ( set @ ( list @ A ) ),Kl2: ( list @ A )] :
      ( ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl @ Kl2 ) )
     => ( member2 @ ( list @ A ) @ ( append @ A @ Kl2 @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl ) ) )).

% SuccD
thf(fact_149_SuccI,axiom,(
    ! [A: $tType,Kl2: ( list @ A ),K: A,Kl: ( set @ ( list @ A ) )] :
      ( ( member2 @ ( list @ A ) @ ( append @ A @ Kl2 @ ( cons @ A @ K @ ( nil @ A ) ) ) @ Kl )
     => ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl @ Kl2 ) ) ) )).

% SuccI
thf(fact_150_last__appendR,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys2
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( last @ A @ Ys2 ) ) ) )).

% last_appendR
thf(fact_151_last__appendL,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys2
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
        = ( last @ A @ Xs ) ) ) )).

% last_appendL
thf(fact_152_append__butlast__last__id,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) )).

% append_butlast_last_id
thf(fact_153_butlast_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% butlast.simps(1)
thf(fact_154_butlast__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( butlast @ A @ ( tl @ A @ Xs ) )
      = ( tl @ A @ ( butlast @ A @ Xs ) ) ) )).

% butlast_tl
thf(fact_155_snoc__eq__iff__butlast,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys2: ( list @ A )] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = Ys2 )
      = ( ( Ys2
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys2 )
          = Xs )
        & ( ( last @ A @ Ys2 )
          = X ) ) ) )).

% snoc_eq_iff_butlast
thf(fact_156_butlast_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( butlast @ A @ Xs ) ) ) ) ) )).

% butlast.simps(2)
thf(fact_157_last_Osimps,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = X ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) )).

% last.simps
thf(fact_158_last__ConsL,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = X ) ) )).

% last_ConsL
thf(fact_159_last__ConsR,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_ConsR
thf(fact_160_longest__common__suffix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
    ? [Ss: ( list @ A ),Xs4: ( list @ A ),Ys5: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs4 @ Ss ) )
      & ( Ys2
        = ( append @ A @ Ys5 @ Ss ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( last @ A @ Xs4 )
         != ( last @ A @ Ys5 ) ) ) ) )).

% longest_common_suffix
thf(fact_161_butlast__append,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys2
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys2
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys2 ) ) ) ) ) )).

% butlast_append
thf(fact_162_last__append,axiom,(
    ! [A: $tType,Ys2: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys2
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys2
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys2 ) )
          = ( last @ A @ Ys2 ) ) ) ) )).

% last_append
thf(fact_163_last__tl,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( Xs
          = ( nil @ A ) )
        | ( ( tl @ A @ Xs )
         != ( nil @ A ) ) )
     => ( ( last @ A @ ( tl @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_tl
thf(fact_164_BNF__Greatest__Fixpoint_Oshift__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_Greatest_shift @ A @ B )
      = ( ^ [Lab: ( ( list @ A ) > B ),K2: A,Kl3: ( list @ A )] :
            ( Lab @ ( cons @ A @ K2 @ Kl3 ) ) ) ) )).

% BNF_Greatest_Fixpoint.shift_def
thf(fact_165_empty__Shift,axiom,(
    ! [A: $tType,Kl: ( set @ ( list @ A ) ),K: A] :
      ( ( member2 @ ( list @ A ) @ ( nil @ A ) @ Kl )
     => ( ( member2 @ A @ K @ ( bNF_Greatest_Succ @ A @ Kl @ ( nil @ A ) ) )
       => ( member2 @ ( list @ A ) @ ( nil @ A ) @ ( bNF_Greatest_Shift @ A @ Kl @ K ) ) ) ) )).

% empty_Shift
thf(fact_166_Succ__Shift,axiom,(
    ! [A: $tType,Kl: ( set @ ( list @ A ) ),K: A,Kl2: ( list @ A )] :
      ( ( bNF_Greatest_Succ @ A @ ( bNF_Greatest_Shift @ A @ Kl @ K ) @ Kl2 )
      = ( bNF_Greatest_Succ @ A @ Kl @ ( cons @ A @ K @ Kl2 ) ) ) )).

% Succ_Shift
thf(fact_167_ShiftD,axiom,(
    ! [A: $tType,Kl2: ( list @ A ),Kl: ( set @ ( list @ A ) ),K: A] :
      ( ( member2 @ ( list @ A ) @ Kl2 @ ( bNF_Greatest_Shift @ A @ Kl @ K ) )
     => ( member2 @ ( list @ A ) @ ( cons @ A @ K @ Kl2 ) @ Kl ) ) )).

% ShiftD
thf(fact_168_rev__eq__Cons__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Y: A,Ys2: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys2 ) @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) ) )).

% rev_eq_Cons_iff
thf(fact_169_listrelp_Oinducts,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),X1: ( list @ A ),X2: ( list @ B ),P2: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( listrelp @ A @ B @ R2 @ X1 @ X2 )
     => ( ( P2 @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X4: A,Y4: B,Xs2: ( list @ A ),Ys3: ( list @ B )] :
              ( ( R2 @ X4 @ Y4 )
             => ( ( listrelp @ A @ B @ R2 @ Xs2 @ Ys3 )
               => ( ( P2 @ Xs2 @ Ys3 )
                 => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ B @ Y4 @ Ys3 ) ) ) ) )
         => ( P2 @ X1 @ X2 ) ) ) ) )).

% listrelp.inducts
thf(fact_170_listrelp_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R3: ( A > B > $o ),A12: ( list @ A ),A23: ( list @ B )] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A23
                = ( nil @ B ) ) )
            | ? [X5: A,Y3: B,Xs3: ( list @ A ),Ys: ( list @ B )] :
                ( ( A12
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( A23
                  = ( cons @ B @ Y3 @ Ys ) )
                & ( R3 @ X5 @ Y3 )
                & ( listrelp @ A @ B @ R3 @ Xs3 @ Ys ) ) ) ) ) )).

% listrelp.simps
thf(fact_171_rev__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys2 ) )
      = ( Xs = Ys2 ) ) )).

% rev_is_rev_conv
thf(fact_172_rev__rev__ident,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) )).

% rev_rev_ident
thf(fact_173_Nil__is__rev__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% Nil_is_rev_conv
thf(fact_174_rev__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rev_is_Nil_conv
thf(fact_175_rev__append,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys2 ) )
      = ( append @ A @ ( rev @ A @ Ys2 ) @ ( rev @ A @ Xs ) ) ) )).

% rev_append
thf(fact_176_remdups__adj__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) )).

% remdups_adj_rev
thf(fact_177_rev__singleton__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% rev_singleton_conv
thf(fact_178_singleton__rev__conv,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( ( cons @ A @ X @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% singleton_rev_conv
thf(fact_179_rev_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rev.simps(1)
thf(fact_180_rev__swap,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys2: ( list @ A )] :
      ( ( ( rev @ A @ Xs )
        = Ys2 )
      = ( Xs
        = ( rev @ A @ Ys2 ) ) ) )).

% rev_swap
thf(fact_181_listrelp_OCons,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),X: A,Y: B,Xs: ( list @ A ),Ys2: ( list @ B )] :
      ( ( R2 @ X @ Y )
     => ( ( listrelp @ A @ B @ R2 @ Xs @ Ys2 )
       => ( listrelp @ A @ B @ R2 @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys2 ) ) ) ) )).

% listrelp.Cons
thf(fact_182_listrelp_ONil,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o )] :
      ( listrelp @ A @ B @ R2 @ ( nil @ A ) @ ( nil @ B ) ) )).

% listrelp.Nil
thf(fact_183_rev_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( rev @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% rev.simps(2)
thf(fact_184_last__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( rev @ A @ Xs ) )
        = ( hd @ A @ Xs ) ) ) )).

% last_rev
thf(fact_185_hd__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( rev @ A @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% hd_rev
thf(fact_186_listrelp_Ocases,axiom,(
    ! [A: $tType,B: $tType,R2: ( A > B > $o ),A1: ( list @ A ),A22: ( list @ B )] :
      ( ( listrelp @ A @ B @ R2 @ A1 @ A22 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A22
           != ( nil @ B ) ) )
       => ~ ( ! [X4: A,Y4: B,Xs2: ( list @ A )] :
                ( ( A1
                  = ( cons @ A @ X4 @ Xs2 ) )
               => ! [Ys3: ( list @ B )] :
                    ( ( A22
                      = ( cons @ B @ Y4 @ Ys3 ) )
                   => ( ( R2 @ X4 @ Y4 )
                     => ~ ( listrelp @ A @ B @ R2 @ Xs2 @ Ys3 ) ) ) ) ) ) ) )).

% listrelp.cases
thf(fact_187_map__tailrec__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map_tailrec @ A @ B )
      = ( ^ [F: ( A > B ),As3: ( list @ A )] :
            ( rev @ B @ ( map_tailrec_rev @ A @ B @ F @ As3 @ ( nil @ B ) ) ) ) ) )).

% map_tailrec_def
thf(fact_188_lexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A )] :
          ~ ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) ) )).

% lexordp_eq_simps(3)
thf(fact_189_fold__Cons__rev,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs )
      = ( append @ A @ ( rev @ A @ Xs ) ) ) )).

% fold_Cons_rev
thf(fact_190_lexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys2: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys2 ) ) )).

% lexordp_eq_simps(1)
thf(fact_191_lexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ ( nil @ A ) )
          = ( Xs
            = ( nil @ A ) ) ) ) )).

% lexordp_eq_simps(2)
thf(fact_192_lexordp__eq__refl,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ord_lexordp_eq @ A @ Xs @ Xs ) ) )).

% lexordp_eq_refl
thf(fact_193_lexordp__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A ),Zs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys2 )
         => ( ( ord_lexordp_eq @ A @ Ys2 @ Zs )
           => ( ord_lexordp_eq @ A @ Xs @ Zs ) ) ) ) )).

% lexordp_eq_trans
thf(fact_194_lexordp__eq__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys2 )
          | ( ord_lexordp_eq @ A @ Ys2 @ Xs ) ) ) )).

% lexordp_eq_linear
thf(fact_195_lexordp__eq__antisym,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys2 )
         => ( ( ord_lexordp_eq @ A @ Ys2 @ Xs )
           => ( Xs = Ys2 ) ) ) ) )).

% lexordp_eq_antisym
thf(fact_196_lexordp__eq_ONil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys2: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys2 ) ) )).

% lexordp_eq.Nil
thf(fact_197_fold__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A > A ),S: A] :
      ( ( fold @ B @ A @ F2 @ ( nil @ B ) @ S )
      = S ) )).

% fold_simps(1)
thf(fact_198_fold__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A > A ),X: B,Xs: ( list @ B ),S: A] :
      ( ( fold @ B @ A @ F2 @ ( cons @ B @ X @ Xs ) @ S )
      = ( fold @ B @ A @ F2 @ Xs @ ( F2 @ X @ S ) ) ) )).

% fold_simps(2)
thf(fact_199_rev__conv__fold,axiom,(
    ! [A: $tType] :
      ( ( rev @ A )
      = ( ^ [Xs3: ( list @ A )] :
            ( fold @ A @ ( list @ A ) @ ( cons @ A ) @ Xs3 @ ( nil @ A ) ) ) ) )).

% rev_conv_fold
thf(fact_200_List_Ounion__def,axiom,(
    ! [A: $tType] :
      ( ( union @ A )
      = ( fold @ A @ ( list @ A ) @ ( insert @ A ) ) ) )).

% List.union_def
thf(fact_201_lexordp__eq_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X1: ( list @ A ),X2: ( list @ A ),P2: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp_eq @ A @ X1 @ X2 )
         => ( ! [X12: ( list @ A )] :
                ( P2 @ ( nil @ A ) @ X12 )
           => ( ! [X4: A,Y4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( ord_less @ A @ X4 @ Y4 )
                 => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) )
             => ( ! [X4: A,Y4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
                    ( ~ ( ord_less @ A @ X4 @ Y4 )
                   => ( ~ ( ord_less @ A @ Y4 @ X4 )
                     => ( ( ord_lexordp_eq @ A @ Xs2 @ Ys3 )
                       => ( ( P2 @ Xs2 @ Ys3 )
                         => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) ) ) ) )
               => ( P2 @ X1 @ X2 ) ) ) ) ) ) )).

% lexordp_eq.inducts
thf(fact_202_lexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A ),Y: A,Ys2: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp_eq @ A @ Xs @ Ys2 ) ) ) ) ) )).

% lexordp_eq_simps(4)
thf(fact_203_lexordp__eq_OCons__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp_eq @ A @ Xs @ Ys2 )
             => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) ) )).

% lexordp_eq.Cons_eq
thf(fact_204_lexordp__eq_OCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) )).

% lexordp_eq.Cons
thf(fact_205_lexordp__eq_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A1: ( list @ A ),A22: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ A1 @ A22 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Ys3: ( list @ A )] : ( A22 != Ys3 ) )
           => ( ! [X4: A] :
                  ( ? [Xs2: ( list @ A )] :
                      ( A1
                      = ( cons @ A @ X4 @ Xs2 ) )
                 => ! [Y4: A] :
                      ( ? [Ys3: ( list @ A )] :
                          ( A22
                          = ( cons @ A @ Y4 @ Ys3 ) )
                     => ~ ( ord_less @ A @ X4 @ Y4 ) ) )
             => ~ ( ! [X4: A,Y4: A,Xs2: ( list @ A )] :
                      ( ( A1
                        = ( cons @ A @ X4 @ Xs2 ) )
                     => ! [Ys3: ( list @ A )] :
                          ( ( A22
                            = ( cons @ A @ Y4 @ Ys3 ) )
                         => ( ~ ( ord_less @ A @ X4 @ Y4 )
                           => ( ~ ( ord_less @ A @ Y4 @ X4 )
                             => ~ ( ord_lexordp_eq @ A @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ) ) )).

% lexordp_eq.cases
thf(fact_206_lexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [A12: ( list @ A ),A23: ( list @ A )] :
              ( ? [Ys: ( list @ A )] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A23 = Ys ) )
              | ? [X5: A,Y3: A,Xs3: ( list @ A ),Ys: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X5 @ Xs3 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys ) )
                  & ( ord_less @ A @ X5 @ Y3 ) )
              | ? [X5: A,Y3: A,Xs3: ( list @ A ),Ys: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X5 @ Xs3 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys ) )
                  & ~ ( ord_less @ A @ X5 @ Y3 )
                  & ~ ( ord_less @ A @ Y3 @ X5 )
                  & ( ord_lexordp_eq @ A @ Xs3 @ Ys ) ) ) ) ) ) )).

% lexordp_eq.simps
thf(fact_207_lexordp__append__left__rightI,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Us2: ( list @ A ),Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( append @ A @ Us2 @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us2 @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) )).

% lexordp_append_left_rightI
thf(fact_208_lexordp__iff,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: ( list @ A ),Ys: ( list @ A )] :
              ( ? [X5: A,Vs: ( list @ A )] :
                  ( Ys
                  = ( append @ A @ Xs3 @ ( cons @ A @ X5 @ Vs ) ) )
              | ? [Us: ( list @ A ),A5: A,B3: A,Vs: ( list @ A ),Ws2: ( list @ A )] :
                  ( ( ord_less @ A @ A5 @ B3 )
                  & ( Xs3
                    = ( append @ A @ Us @ ( cons @ A @ A5 @ Vs ) ) )
                  & ( Ys
                    = ( append @ A @ Us @ ( cons @ A @ B3 @ Ws2 ) ) ) ) ) ) ) ) )).

% lexordp_iff
thf(fact_209_lexordp__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys2: ( list @ A )] :
          ( ( ord_lexordp @ A @ ( nil @ A ) @ Ys2 )
          = ( Ys2
           != ( nil @ A ) ) ) ) )).

% lexordp_simps(1)
thf(fact_210_lexordp__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ~ ( ord_lexordp @ A @ Xs @ ( nil @ A ) ) ) )).

% lexordp_simps(2)
thf(fact_211_lexordp__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A ),Y: A,Ys2: ( list @ A )] :
          ( ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp @ A @ Xs @ Ys2 ) ) ) ) ) )).

% lexordp_simps(3)
thf(fact_212_lexordp__irreflexive,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ! [X4: A] :
              ~ ( ord_less @ A @ X4 @ X4 )
         => ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ) )).

% lexordp_irreflexive
thf(fact_213_lexordp__append__leftD,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Us2: ( list @ A ),Vs2: ( list @ A )] :
          ( ( ord_lexordp @ A @ ( append @ A @ Xs @ Us2 ) @ ( append @ A @ Xs @ Vs2 ) )
         => ( ! [A4: A] :
                ~ ( ord_less @ A @ A4 @ A4 )
           => ( ord_lexordp @ A @ Us2 @ Vs2 ) ) ) ) )).

% lexordp_append_leftD
thf(fact_214_lexordp_OCons__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp @ A @ Xs @ Ys2 )
             => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) ) ) )).

% lexordp.Cons_eq
thf(fact_215_lexordp_OCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys2 ) ) ) ) )).

% lexordp.Cons
thf(fact_216_lexordp_ONil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Y: A,Ys2: ( list @ A )] :
          ( ord_lexordp @ A @ ( nil @ A ) @ ( cons @ A @ Y @ Ys2 ) ) ) )).

% lexordp.Nil
thf(fact_217_lexordp__append__rightI,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys2: ( list @ A ),Xs: ( list @ A )] :
          ( ( Ys2
           != ( nil @ A ) )
         => ( ord_lexordp @ A @ Xs @ ( append @ A @ Xs @ Ys2 ) ) ) ) )).

% lexordp_append_rightI
thf(fact_218_lexordp__antisym,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ~ ( ord_lexordp @ A @ Ys2 @ Xs ) ) ) )).

% lexordp_antisym
thf(fact_219_lexordp__trans,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A ),Zs: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ( ord_lexordp @ A @ Ys2 @ Zs )
           => ( ord_lexordp @ A @ Xs @ Zs ) ) ) ) )).

% lexordp_trans
thf(fact_220_lexordp__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
          | ( Xs = Ys2 )
          | ( ord_lexordp @ A @ Ys2 @ Xs ) ) ) )).

% lexordp_linear
thf(fact_221_lexordp__irreflexive_H,axiom,(
    ! [A: $tType] :
      ( ( order @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ~ ( ord_lexordp @ A @ Xs @ Xs ) ) )).

% lexordp_irreflexive'
thf(fact_222_lexordp__append__leftI,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Us2: ( list @ A ),Vs2: ( list @ A ),Xs: ( list @ A )] :
          ( ( ord_lexordp @ A @ Us2 @ Vs2 )
         => ( ord_lexordp @ A @ ( append @ A @ Xs @ Us2 ) @ ( append @ A @ Xs @ Vs2 ) ) ) ) )).

% lexordp_append_leftI
thf(fact_223_lexordp__conv__lexordp__eq,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: ( list @ A ),Ys: ( list @ A )] :
              ( ( ord_lexordp_eq @ A @ Xs3 @ Ys )
              & ~ ( ord_lexordp_eq @ A @ Ys @ Xs3 ) ) ) ) ) )).

% lexordp_conv_lexordp_eq
thf(fact_224_lexordp__eq__conv__lexord,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [Xs3: ( list @ A ),Ys: ( list @ A )] :
              ( ( Xs3 = Ys )
              | ( ord_lexordp @ A @ Xs3 @ Ys ) ) ) ) ) )).

% lexordp_eq_conv_lexord
thf(fact_225_lexordp__into__lexordp__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ord_lexordp_eq @ A @ Xs @ Ys2 ) ) ) )).

% lexordp_into_lexordp_eq
thf(fact_226_lexordp__induct,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A ),P2: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ! [Y4: A,Ys3: ( list @ A )] :
                ( P2 @ ( nil @ A ) @ ( cons @ A @ Y4 @ Ys3 ) )
           => ( ! [X4: A,Xs2: ( list @ A ),Y4: A,Ys3: ( list @ A )] :
                  ( ( ord_less @ A @ X4 @ Y4 )
                 => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) )
             => ( ! [X4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
                    ( ( ord_lexordp @ A @ Xs2 @ Ys3 )
                   => ( ( P2 @ Xs2 @ Ys3 )
                     => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ X4 @ Ys3 ) ) ) )
               => ( P2 @ Xs @ Ys2 ) ) ) ) ) ) )).

% lexordp_induct
thf(fact_227_lexordp__cases,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys2: ( list @ A )] :
          ( ( ord_lexordp @ A @ Xs @ Ys2 )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ! [Y4: A,Ys5: ( list @ A )] :
                  ( Ys2
                 != ( cons @ A @ Y4 @ Ys5 ) ) )
           => ( ! [X4: A] :
                  ( ? [Xs4: ( list @ A )] :
                      ( Xs
                      = ( cons @ A @ X4 @ Xs4 ) )
                 => ! [Y4: A] :
                      ( ? [Ys5: ( list @ A )] :
                          ( Ys2
                          = ( cons @ A @ Y4 @ Ys5 ) )
                     => ~ ( ord_less @ A @ X4 @ Y4 ) ) )
             => ~ ( ! [X4: A,Xs4: ( list @ A )] :
                      ( ( Xs
                        = ( cons @ A @ X4 @ Xs4 ) )
                     => ! [Ys5: ( list @ A )] :
                          ( ( Ys2
                            = ( cons @ A @ X4 @ Ys5 ) )
                         => ~ ( ord_lexordp @ A @ Xs4 @ Ys5 ) ) ) ) ) ) ) ) )).

% lexordp_cases
thf(fact_228_lexordp_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X1: ( list @ A ),X2: ( list @ A ),P2: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp @ A @ X1 @ X2 )
         => ( ! [Y4: A,Ys3: ( list @ A )] :
                ( P2 @ ( nil @ A ) @ ( cons @ A @ Y4 @ Ys3 ) )
           => ( ! [X4: A,Y4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( ord_less @ A @ X4 @ Y4 )
                 => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) )
             => ( ! [X4: A,Y4: A,Xs2: ( list @ A ),Ys3: ( list @ A )] :
                    ( ~ ( ord_less @ A @ X4 @ Y4 )
                   => ( ~ ( ord_less @ A @ Y4 @ X4 )
                     => ( ( ord_lexordp @ A @ Xs2 @ Ys3 )
                       => ( ( P2 @ Xs2 @ Ys3 )
                         => ( P2 @ ( cons @ A @ X4 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys3 ) ) ) ) ) )
               => ( P2 @ X1 @ X2 ) ) ) ) ) ) )).

% lexordp.inducts
thf(fact_229_lexordp_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp @ A )
        = ( ^ [A12: ( list @ A ),A23: ( list @ A )] :
              ( ? [Y3: A,Ys: ( list @ A )] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys ) ) )
              | ? [X5: A,Y3: A,Xs3: ( list @ A ),Ys: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X5 @ Xs3 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys ) )
                  & ( ord_less @ A @ X5 @ Y3 ) )
              | ? [X5: A,Y3: A,Xs3: ( list @ A ),Ys: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X5 @ Xs3 ) )
                  & ( A23
                    = ( cons @ A @ Y3 @ Ys ) )
                  & ~ ( ord_less @ A @ X5 @ Y3 )
                  & ~ ( ord_less @ A @ Y3 @ X5 )
                  & ( ord_lexordp @ A @ Xs3 @ Ys ) ) ) ) ) ) )).

% lexordp.simps
thf(fact_230_lexordp_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A1: ( list @ A ),A22: ( list @ A )] :
          ( ( ord_lexordp @ A @ A1 @ A22 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Y4: A,Ys3: ( list @ A )] :
                  ( A22
                 != ( cons @ A @ Y4 @ Ys3 ) ) )
           => ( ! [X4: A] :
                  ( ? [Xs2: ( list @ A )] :
                      ( A1
                      = ( cons @ A @ X4 @ Xs2 ) )
                 => ! [Y4: A] :
                      ( ? [Ys3: ( list @ A )] :
                          ( A22
                          = ( cons @ A @ Y4 @ Ys3 ) )
                     => ~ ( ord_less @ A @ X4 @ Y4 ) ) )
             => ~ ( ! [X4: A,Y4: A,Xs2: ( list @ A )] :
                      ( ( A1
                        = ( cons @ A @ X4 @ Xs2 ) )
                     => ! [Ys3: ( list @ A )] :
                          ( ( A22
                            = ( cons @ A @ Y4 @ Ys3 ) )
                         => ( ~ ( ord_less @ A @ X4 @ Y4 )
                           => ( ~ ( ord_less @ A @ Y4 @ X4 )
                             => ~ ( ord_lexordp @ A @ Xs2 @ Ys3 ) ) ) ) ) ) ) ) ) ) )).

% lexordp.cases
thf(fact_231_map__tailrec__rev,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( map_tailrec_rev @ B @ A )
      = ( ^ [F: ( B > A ),As3: ( list @ B )] :
            ( append @ A @ ( rev @ A @ ( map @ B @ A @ F @ As3 ) ) ) ) ) )).

% map_tailrec_rev
thf(fact_232_replicate__append__same,axiom,(
    ! [A: $tType,I: nat,X: A] :
      ( ( append @ A @ ( replicate @ A @ I @ X ) @ ( cons @ A @ X @ ( nil @ A ) ) )
      = ( cons @ A @ X @ ( replicate @ A @ I @ X ) ) ) )).

% replicate_append_same
thf(fact_233_Nil__is__map__conv,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% Nil_is_map_conv
thf(fact_234_map__is__Nil__conv,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% map_is_Nil_conv
thf(fact_235_list_Omap__disc__iff,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),A3: ( list @ A )] :
      ( ( ( map @ A @ B @ F2 @ A3 )
        = ( nil @ B ) )
      = ( A3
        = ( nil @ A ) ) ) )).

% list.map_disc_iff
thf(fact_236_map__append,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B ),Ys2: ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys2 ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys2 ) ) ) )).

% map_append
thf(fact_237_map__replicate,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),N: nat,X: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N @ X ) )
      = ( replicate @ A @ N @ ( F2 @ X ) ) ) )).

% map_replicate
thf(fact_238_rev__replicate,axiom,(
    ! [A: $tType,N: nat,X: A] :
      ( ( rev @ A @ ( replicate @ A @ N @ X ) )
      = ( replicate @ A @ N @ X ) ) )).

% rev_replicate
thf(fact_239_smap__shift,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B ),S: ( stream170649215stream @ B )] :
      ( ( stream2128578057e_smap @ B @ A @ F2 @ ( stream1035003186_shift @ B @ Xs @ S ) )
      = ( stream1035003186_shift @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( stream2128578057e_smap @ B @ A @ F2 @ S ) ) ) )).

% smap_shift
thf(fact_240_map__eq__map__tailrec,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map @ A @ B )
      = ( map_tailrec @ A @ B ) ) )).

% map_eq_map_tailrec
thf(fact_241_list_Omap__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,A3: ( list @ A ),F2: ( A > B )] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A3 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A3 ) ) ) ) )).

% list.map_sel(2)
thf(fact_242_hd__map,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),F2: ( A > B )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) )).

% hd_map
thf(fact_243_list_Omap__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,A3: ( list @ A ),F2: ( A > B )] :
      ( ( A3
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A3 ) )
        = ( F2 @ ( hd @ A @ A3 ) ) ) ) )).

% list.map_sel(1)
thf(fact_244_last__map,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),F2: ( A > B )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( last @ A @ Xs ) ) ) ) )).

% last_map
thf(fact_245_replicate__app__Cons__same,axiom,(
    ! [A: $tType,N: nat,X: A,Xs: ( list @ A )] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( append @ A @ ( replicate @ A @ N @ X ) @ Xs ) ) ) )).

% replicate_app_Cons_same
thf(fact_246_list_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),X21: A,X222: ( list @ A )] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X222 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X222 ) ) ) )).

% list.simps(9)
thf(fact_247_Cons__eq__map__D,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),F2: ( B > A ),Ys2: ( list @ B )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
     => ? [Z: B,Zs2: ( list @ B )] :
          ( ( Ys2
            = ( cons @ B @ Z @ Zs2 ) )
          & ( X
            = ( F2 @ Z ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) )).

% Cons_eq_map_D
thf(fact_248_map__eq__Cons__D,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),Xs: ( list @ B ),Y: A,Ys2: ( list @ A )] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
     => ? [Z: B,Zs2: ( list @ B )] :
          ( ( Xs
            = ( cons @ B @ Z @ Zs2 ) )
          & ( ( F2 @ Z )
            = Y )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys2 ) ) ) )).

% map_eq_Cons_D
thf(fact_249_Cons__eq__map__conv,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),F2: ( B > A ),Ys2: ( list @ B )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F2 @ Ys2 ) )
      = ( ? [Z2: B,Zs3: ( list @ B )] :
            ( ( Ys2
              = ( cons @ B @ Z2 @ Zs3 ) )
            & ( X
              = ( F2 @ Z2 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) )).

% Cons_eq_map_conv
thf(fact_250_map__eq__Cons__conv,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B ),Y: A,Ys2: ( list @ A )] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y @ Ys2 ) )
      = ( ? [Z2: B,Zs3: ( list @ B )] :
            ( ( Xs
              = ( cons @ B @ Z2 @ Zs3 ) )
            & ( ( F2 @ Z2 )
              = Y )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys2 ) ) ) ) )).

% map_eq_Cons_conv
thf(fact_251_list_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B )] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) )).

% list.simps(8)
thf(fact_252_map__tl,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) )).

% map_tl
thf(fact_253_append__replicate__commute,axiom,(
    ! [A: $tType,N: nat,X: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N @ X ) @ ( replicate @ A @ K @ X ) )
      = ( append @ A @ ( replicate @ A @ K @ X ) @ ( replicate @ A @ N @ X ) ) ) )).

% append_replicate_commute
thf(fact_254_map__butlast,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Xs: ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( butlast @ B @ Xs ) )
      = ( butlast @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) )).

% map_butlast

%----Type constructors (7)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( order @ A8 @ ( type2 @ A8 ) )
     => ( order @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A7: $tType,A8: $tType] :
      ( ( ord @ A8 @ ( type2 @ A8 ) )
     => ( ord @ ( A7 > A8 ) @ ( type2 @ ( A7 > A8 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_1,axiom,(
    ! [A7: $tType] :
      ( order @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_2,axiom,(
    ! [A7: $tType] :
      ( ord @ ( set @ A7 ) @ ( type2 @ ( set @ A7 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_3,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_4,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P2: $o] :
      ( ( P2 = $true )
      | ( P2 = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,(
    ( stream_Mirabelle_shd @ ( list @ a ) @ ws )
 != ( nil @ a ) )).

thf(conj_1,conjecture,
    ( ( stream942386729e_flat @ a @ ws )
    = ( stream1035003186_shift @ a @ ( stream_Mirabelle_shd @ ( list @ a ) @ ws ) @ ( stream942386729e_flat @ a @ ( stream_Mirabelle_stl @ ( list @ a ) @ ws ) ) ) )).

%------------------------------------------------------------------------------
