%------------------------------------------------------------------------------
% File     : DAT254^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Data structure for translators from streams to streams 38
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream_processor__38.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  330 (   0 unit;  57 type;   0 defn)
%            Number of atoms       : 7285 ( 339 equality;5169 variable)
%            Maximal formula depth :   30 (  13 average)
%            Number of connectives : 6768 (  41   ~;   3   |;  24   &;6387   @)
%                                         (   0 <=>; 313  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  : 1051 (1051   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   60 (  57   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1874 (   1 sgn;1593   !;  22   ?; 152   ^)
%                                         (1874   :; 107  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:39:09.330
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062,type,(
    stream1273403375_sp_nu: $tType > $tType > $tType )).

thf(ty_t_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062,type,(
    stream901396144_sp_mu: $tType > $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (48)
thf(sy_cl_Lattices_Obounded__lattice,type,(
    bounded_lattice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Otop,type,(
    top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_OSup,type,(
    complete_Sup: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Lattices_Obounded__lattice__top,type,(
    bounded_lattice_top: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,(
    comple187826305attice: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Composition_Oid__bnf,type,(
    bNF_id_bnf: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_BNF__Def_Orel__fun,type,(
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) )).

thf(sy_c_BNF__Def_Orel__sum,type,(
    bNF_rel_sum: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) > $o ) )).

thf(sy_c_BNF__Def_Ovimage2p,type,(
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] :
        ( ( A > D ) > ( B > E ) > ( D > E > C ) > A > B > C ) )).

thf(sy_c_Basic__BNFs_Opred__prod,type,(
    basic_pred_prod: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( product_prod @ A @ B ) > $o ) )).

thf(sy_c_Basic__BNFs_Opred__sum,type,(
    basic_pred_sum: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( sum_sum @ A @ B ) > $o ) )).

thf(sy_c_Basic__BNFs_Orel__prod,type,(
    basic_rel_prod: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( A > B > $o ) > ( C > D > $o ) > ( product_prod @ A @ C ) > ( product_prod @ B @ D ) > $o ) )).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,(
    complete_Sup_Sup: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Oswap,type,(
    swap: 
      !>[A: $tType,B: $tType] :
        ( A > A > ( A > B ) > A > B ) )).

thf(sy_c_Lattices_Osup__class_Osup,type,(
    sup_sup: 
      !>[A: $tType] :
        ( A > A > A ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Set_OBall,type,(
    ball: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_OPow,type,(
    pow: 
      !>[A: $tType] :
        ( ( set @ A ) > ( set @ ( set @ A ) ) ) )).

thf(sy_c_Set_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ B ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Ocopy,type,(
    stream2017582925e_copy: 
      !>[A: $tType] :
        ( stream1273403375_sp_nu @ A @ A ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Orun_092_060_094sub_062_092_060nu_062,type,(
    stream377071682run_nu: 
      !>[A: $tType,B: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( stream @ A ) > ( stream @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_OGet,type,(
    stream1294929701mu_Get: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) > ( stream901396144_sp_mu @ A @ B @ C ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_OPut,type,(
    stream1370332830mu_Put: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( B > C > ( stream901396144_sp_mu @ A @ B @ C ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Ocase__sp_092_060_094sub_062_092_060mu_062,type,(
    stream160000856_sp_mu: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) > D ) > ( B > C > D ) > ( stream901396144_sp_mu @ A @ B @ C ) > D ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Omap__sp_092_060_094sub_062_092_060mu_062,type,(
    stream1058219438_sp_mu: 
      !>[B: $tType,Ba: $tType,C: $tType,Ca: $tType,A: $tType] :
        ( ( B > Ba ) > ( C > Ca ) > ( stream901396144_sp_mu @ A @ B @ C ) > ( stream901396144_sp_mu @ A @ Ba @ Ca ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Opred__sp_092_060_094sub_062_092_060mu_062,type,(
    stream123009735_sp_mu: 
      !>[A: $tType,B: $tType,E: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( stream901396144_sp_mu @ E @ A @ B ) > $o ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Orec__sp_092_060_094sub_062_092_060mu_062,type,(
    stream674629690_sp_mu: 
      !>[A: $tType,B: $tType,C: $tType,G: $tType] :
        ( ( ( A > ( product_prod @ ( stream901396144_sp_mu @ A @ B @ C ) @ G ) ) > G ) > ( B > C > G ) > ( stream901396144_sp_mu @ A @ B @ C ) > G ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Orel__sp_092_060_094sub_062_092_060mu_062,type,(
    stream1924447089_sp_mu: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType,E: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( stream901396144_sp_mu @ E @ A @ B ) > ( stream901396144_sp_mu @ E @ C @ D ) > $o ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Oset1__sp_092_060_094sub_062_092_060mu_062,type,(
    stream2074884121_sp_mu: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( stream901396144_sp_mu @ A @ B @ C ) > ( set @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Oset2__sp_092_060_094sub_062_092_060mu_062,type,(
    stream1259315544_sp_mu: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( stream901396144_sp_mu @ A @ B @ C ) > ( set @ C ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062_Osize__sp_092_060_094sub_062_092_060mu_062,type,(
    stream1362355943_sp_mu: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > nat ) > ( B > nat ) > ( C > nat ) > ( stream901396144_sp_mu @ A @ B @ C ) > nat ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_OIn,type,(
    stream1686501333_nu_In: 
      !>[A: $tType,B: $tType] :
        ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > ( stream1273403375_sp_nu @ A @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Ocase__sp_092_060_094sub_062_092_060nu_062,type,(
    stream1502363800_sp_nu: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > C ) > ( stream1273403375_sp_nu @ A @ B ) > C ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Ocorec__sp_092_060_094sub_062_092_060nu_062,type,(
    stream937840132_sp_nu: 
      !>[E: $tType,A: $tType,B: $tType] :
        ( ( E > ( stream901396144_sp_mu @ A @ B @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ B ) @ E ) ) ) > E > ( stream1273403375_sp_nu @ A @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Omap__sp_092_060_094sub_062_092_060nu_062,type,(
    stream151454380_sp_nu: 
      !>[B: $tType,Ba: $tType,A: $tType] :
        ( ( B > Ba ) > ( stream1273403375_sp_nu @ A @ B ) > ( stream1273403375_sp_nu @ A @ Ba ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Oout,type,(
    stream1200245950nu_out: 
      !>[A: $tType,B: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Opred__sp_092_060_094sub_062_092_060nu_062,type,(
    stream1465372679_sp_nu: 
      !>[A: $tType,C: $tType] :
        ( ( A > $o ) > ( stream1273403375_sp_nu @ C @ A ) > $o ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Orel__sp_092_060_094sub_062_092_060nu_062,type,(
    stream1017682031_sp_nu: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( stream1273403375_sp_nu @ C @ A ) > ( stream1273403375_sp_nu @ C @ B ) > $o ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Oset__sp_092_060_094sub_062_092_060nu_062,type,(
    stream1493736486_sp_nu: 
      !>[A: $tType,B: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_Typedef_Otype__definition,type,(
    type_definition: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_s,type,(
    s: ( stream @ a ) )).

%----Relevant facts (256)
thf(fact_0_sp_092_060_094sub_062_092_060nu_062_Ocorec__disc,axiom,(
    ! [B: $tType,A: $tType,E: $tType] :
      ( ( stream937840132_sp_nu @ E @ A @ B )
      = ( stream937840132_sp_nu @ E @ A @ B ) ) )).

% sp\<^sub>\<nu>.corec_disc
thf(fact_1_sp_092_060_094sub_062_092_060nu_062_Oinject,axiom,(
    ! [B: $tType,A: $tType,X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ),Ya: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( ( stream1686501333_nu_In @ A @ B @ X )
        = ( stream1686501333_nu_In @ A @ B @ Ya ) )
      = ( X = Ya ) ) )).

% sp\<^sub>\<nu>.inject
thf(fact_2_sp_092_060_094sub_062_092_060mu_062_Oinject_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,X21: B,X22: C,Y21: B,Y22: C] :
      ( ( ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 )
        = ( stream1370332830mu_Put @ B @ C @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% sp\<^sub>\<mu>.inject(2)
thf(fact_3_sp_092_060_094sub_062_092_060nu_062_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( stream1273403375_sp_nu @ A @ B )] :
      ~ ( ! [X2: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
            ( Y
           != ( stream1686501333_nu_In @ A @ B @ X2 ) ) ) )).

% sp\<^sub>\<nu>.exhaust
thf(fact_4_sp_092_060_094sub_062_092_060mu_062_Osimps_I6_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F1: ( ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) > D ),F2: ( B > C > D ),X21: B,X22: C] :
      ( ( stream160000856_sp_mu @ A @ B @ C @ D @ F1 @ F2 @ ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 ) )
      = ( F2 @ X21 @ X22 ) ) )).

% sp\<^sub>\<mu>.simps(6)
thf(fact_5_sp_092_060_094sub_062_092_060nu_062_Ocase,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > C ),X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( stream1502363800_sp_nu @ A @ B @ C @ F @ ( stream1686501333_nu_In @ A @ B @ X ) )
      = ( F @ X ) ) )).

% sp\<^sub>\<nu>.case
thf(fact_6_sp_092_060_094sub_062_092_060mu_062_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,G: $tType,C: $tType,F1: ( ( A > ( product_prod @ ( stream901396144_sp_mu @ A @ B @ C ) @ G ) ) > G ),F2: ( B > C > G ),X21: B,X22: C] :
      ( ( stream674629690_sp_mu @ A @ B @ C @ G @ F1 @ F2 @ ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 ) )
      = ( F2 @ X21 @ X22 ) ) )).

% sp\<^sub>\<mu>.simps(8)
thf(fact_7_sp_092_060_094sub_062_092_060mu_062_Opred__inject_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P1: ( B > $o ),P2: ( C > $o ),A2: B,Aa: C] :
      ( ( stream123009735_sp_mu @ B @ C @ A @ P1 @ P2 @ ( stream1370332830mu_Put @ B @ C @ A @ A2 @ Aa ) )
      = ( ( P1 @ A2 )
        & ( P2 @ Aa ) ) ) )).

% sp\<^sub>\<mu>.pred_inject(2)
thf(fact_8_sp_092_060_094sub_062_092_060nu_062_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Sp_nu: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( stream1686501333_nu_In @ A @ B @ ( stream1200245950nu_out @ A @ B @ Sp_nu ) )
      = Sp_nu ) )).

% sp\<^sub>\<nu>.collapse
thf(fact_9_sp_092_060_094sub_062_092_060mu_062_Oset__intros_I4_J,axiom,(
    ! [B: $tType,A: $tType,C: $tType,A2a: C,A1a: B] :
      ( member @ C @ A2a @ ( stream1259315544_sp_mu @ A @ B @ C @ ( stream1370332830mu_Put @ B @ C @ A @ A1a @ A2a ) ) ) )).

% sp\<^sub>\<mu>.set_intros(4)
thf(fact_10_sp_092_060_094sub_062_092_060mu_062_Oset__intros_I2_J,axiom,(
    ! [B: $tType,A: $tType,C: $tType,A1: B,A22: C] :
      ( member @ B @ A1 @ ( stream2074884121_sp_mu @ A @ B @ C @ ( stream1370332830mu_Put @ B @ C @ A @ A1 @ A22 ) ) ) )).

% sp\<^sub>\<mu>.set_intros(2)
thf(fact_11_sp_092_060_094sub_062_092_060nu_062_Osel,axiom,(
    ! [B: $tType,A: $tType,X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( stream1200245950nu_out @ A @ B @ ( stream1686501333_nu_In @ A @ B @ X ) )
      = X ) )).

% sp\<^sub>\<nu>.sel
thf(fact_12_sp_092_060_094sub_062_092_060nu_062_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Sp_nu: ( stream1273403375_sp_nu @ A @ B )] :
      ( Sp_nu
      = ( stream1686501333_nu_In @ A @ B @ ( stream1200245950nu_out @ A @ B @ Sp_nu ) ) ) )).

% sp\<^sub>\<nu>.exhaust_sel
thf(fact_13_sp_092_060_094sub_062_092_060mu_062_Osimps_I10_J,axiom,(
    ! [B: $tType,E: $tType,A: $tType,F3: $tType,C: $tType,F1: ( B > E ),F2: ( C > F3 ),X21: B,X22: C] :
      ( ( stream1058219438_sp_mu @ B @ E @ C @ F3 @ A @ F1 @ F2 @ ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 ) )
      = ( stream1370332830mu_Put @ E @ F3 @ A @ ( F1 @ X21 ) @ ( F2 @ X22 ) ) ) )).

% sp\<^sub>\<mu>.simps(10)
thf(fact_14_sp_092_060_094sub_062_092_060mu_062_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,C: $tType,X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),X21: B,X22: C] :
      ( ( stream1294929701mu_Get @ A @ B @ C @ X1 )
     != ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 ) ) )).

% sp\<^sub>\<mu>.distinct(1)
thf(fact_15_sp_092_060_094sub_062_092_060mu_062_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Y: ( stream901396144_sp_mu @ A @ B @ C )] :
      ( ! [X12: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
          ( Y
         != ( stream1294929701mu_Get @ A @ B @ C @ X12 ) )
     => ~ ( ! [X212: B,X222: C] :
              ( Y
             != ( stream1370332830mu_Put @ B @ C @ A @ X212 @ X222 ) ) ) ) )).

% sp\<^sub>\<mu>.exhaust
thf(fact_16_sp_092_060_094sub_062_092_060mu_062_Oinject_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),Y1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
      ( ( ( stream1294929701mu_Get @ A @ B @ C @ X1 )
        = ( stream1294929701mu_Get @ A @ B @ C @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% sp\<^sub>\<mu>.inject(1)
thf(fact_17_sp_092_060_094sub_062_092_060mu_062_Opred__mono__strong,axiom,(
    ! [B: $tType,A: $tType,G: $tType,P1: ( A > $o ),P2: ( B > $o ),X: ( stream901396144_sp_mu @ G @ A @ B ),P1a: ( A > $o ),P2a: ( B > $o )] :
      ( ( stream123009735_sp_mu @ A @ B @ G @ P1 @ P2 @ X )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ X ) )
           => ( ( P1 @ Z1 )
             => ( P1a @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ X ) )
             => ( ( P2 @ Z2 )
               => ( P2a @ Z2 ) ) )
         => ( stream123009735_sp_mu @ A @ B @ G @ P1a @ P2a @ X ) ) ) ) )).

% sp\<^sub>\<mu>.pred_mono_strong
thf(fact_18_sp_092_060_094sub_062_092_060mu_062_Oinj__map__strong,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: $tType,X: ( stream901396144_sp_mu @ G @ A @ B ),Xa: ( stream901396144_sp_mu @ G @ A @ B ),F1: ( A > C ),F1a: ( A > C ),F2: ( B > D ),F2a: ( B > D )] :
      ( ! [Z1: A,Z1a: A] :
          ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ X ) )
         => ( ( member @ A @ Z1a @ ( stream2074884121_sp_mu @ G @ A @ B @ Xa ) )
           => ( ( ( F1 @ Z1 )
                = ( F1a @ Z1a ) )
             => ( Z1 = Z1a ) ) ) )
     => ( ! [Z2: B,Z2a: B] :
            ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ X ) )
           => ( ( member @ B @ Z2a @ ( stream1259315544_sp_mu @ G @ A @ B @ Xa ) )
             => ( ( ( F2 @ Z2 )
                  = ( F2a @ Z2a ) )
               => ( Z2 = Z2a ) ) ) )
       => ( ( ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ X )
            = ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1a @ F2a @ Xa ) )
         => ( X = Xa ) ) ) ) )).

% sp\<^sub>\<mu>.inj_map_strong
thf(fact_19_sp_092_060_094sub_062_092_060mu_062_Opred__cong,axiom,(
    ! [B: $tType,A: $tType,G: $tType,X: ( stream901396144_sp_mu @ G @ A @ B ),Ya: ( stream901396144_sp_mu @ G @ A @ B ),P1: ( A > $o ),P1a: ( A > $o ),P2: ( B > $o ),P2a: ( B > $o )] :
      ( ( X = Ya )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ Ya ) )
           => ( ( P1 @ Z1 )
              = ( P1a @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ Ya ) )
             => ( ( P2 @ Z2 )
                = ( P2a @ Z2 ) ) )
         => ( ( stream123009735_sp_mu @ A @ B @ G @ P1 @ P2 @ X )
            = ( stream123009735_sp_mu @ A @ B @ G @ P1a @ P2a @ Ya ) ) ) ) ) )).

% sp\<^sub>\<mu>.pred_cong
thf(fact_20_sp_092_060_094sub_062_092_060mu_062_Omap__cong0,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,G: $tType,X: ( stream901396144_sp_mu @ G @ A @ B ),F1: ( A > C ),G1: ( A > C ),F2: ( B > D ),G2: ( B > D )] :
      ( ! [Z1: A] :
          ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ X ) )
         => ( ( F1 @ Z1 )
            = ( G1 @ Z1 ) ) )
     => ( ! [Z2: B] :
            ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ X ) )
           => ( ( F2 @ Z2 )
              = ( G2 @ Z2 ) ) )
       => ( ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ X )
          = ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ G1 @ G2 @ X ) ) ) ) )).

% sp\<^sub>\<mu>.map_cong0
thf(fact_21_sp_092_060_094sub_062_092_060mu_062_Omap__cong,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,G: $tType,X: ( stream901396144_sp_mu @ G @ A @ B ),Ya: ( stream901396144_sp_mu @ G @ A @ B ),F1: ( A > C ),G1: ( A > C ),F2: ( B > D ),G2: ( B > D )] :
      ( ( X = Ya )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ Ya ) )
           => ( ( F1 @ Z1 )
              = ( G1 @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ Ya ) )
             => ( ( F2 @ Z2 )
                = ( G2 @ Z2 ) ) )
         => ( ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ X )
            = ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ G1 @ G2 @ Ya ) ) ) ) ) )).

% sp\<^sub>\<mu>.map_cong
thf(fact_22_sp_092_060_094sub_062_092_060nu_062_Ocase__eq__if,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( stream1502363800_sp_nu @ A @ B @ C )
      = ( ^ [F4: ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > C ),Sp_nu2: ( stream1273403375_sp_nu @ A @ B )] :
            ( F4 @ ( stream1200245950nu_out @ A @ B @ Sp_nu2 ) ) ) ) )).

% sp\<^sub>\<nu>.case_eq_if
thf(fact_23_sp_092_060_094sub_062_092_060nu_062_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Sp_nu: ( stream1273403375_sp_nu @ A @ B ),Sp_nu3: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( ( stream1200245950nu_out @ A @ B @ Sp_nu )
        = ( stream1200245950nu_out @ A @ B @ Sp_nu3 ) )
     => ( Sp_nu = Sp_nu3 ) ) )).

% sp\<^sub>\<nu>.expand
thf(fact_24_sp_092_060_094sub_062_092_060mu_062_Osimps_I5_J,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F1: ( ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) > D ),F2: ( B > C > D ),X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
      ( ( stream160000856_sp_mu @ A @ B @ C @ D @ F1 @ F2 @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) )
      = ( F1 @ X1 ) ) )).

% sp\<^sub>\<mu>.simps(5)
thf(fact_25_sp_092_060_094sub_062_092_060nu_062_Osplit__sel__asm,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( C > $o ),F: ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > C ),Sp_nu: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( P @ ( stream1502363800_sp_nu @ A @ B @ C @ F @ Sp_nu ) )
      = ( ~ ( ( Sp_nu
              = ( stream1686501333_nu_In @ A @ B @ ( stream1200245950nu_out @ A @ B @ Sp_nu ) ) )
            & ~ ( P @ ( F @ ( stream1200245950nu_out @ A @ B @ Sp_nu ) ) ) ) ) ) )).

% sp\<^sub>\<nu>.split_sel_asm
thf(fact_26_sp_092_060_094sub_062_092_060nu_062_Osplit__sel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( C > $o ),F: ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > C ),Sp_nu: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( P @ ( stream1502363800_sp_nu @ A @ B @ C @ F @ Sp_nu ) )
      = ( ( Sp_nu
          = ( stream1686501333_nu_In @ A @ B @ ( stream1200245950nu_out @ A @ B @ Sp_nu ) ) )
       => ( P @ ( F @ ( stream1200245950nu_out @ A @ B @ Sp_nu ) ) ) ) ) )).

% sp\<^sub>\<nu>.split_sel
thf(fact_27_sp_092_060_094sub_062_092_060mu_062_Opred__set,axiom,(
    ! [B: $tType,G: $tType,A: $tType] :
      ( ( stream123009735_sp_mu @ A @ B @ G )
      = ( ^ [P12: ( A > $o ),P22: ( B > $o ),X3: ( stream901396144_sp_mu @ G @ A @ B )] :
            ( ! [Y2: A] :
                ( ( member @ A @ Y2 @ ( stream2074884121_sp_mu @ G @ A @ B @ X3 ) )
               => ( P12 @ Y2 ) )
            & ! [Y2: B] :
                ( ( member @ B @ Y2 @ ( stream1259315544_sp_mu @ G @ A @ B @ X3 ) )
               => ( P22 @ Y2 ) ) ) ) ) )).

% sp\<^sub>\<mu>.pred_set
thf(fact_28_sp_092_060_094sub_062_092_060nu_062_Opred__inject,axiom,(
    ! [B: $tType,A: $tType,P: ( B > $o ),A2: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( stream1465372679_sp_nu @ B @ A @ P @ ( stream1686501333_nu_In @ A @ B @ A2 ) )
      = ( stream123009735_sp_mu @ B @ ( stream1273403375_sp_nu @ A @ B ) @ A @ P @ ( stream1465372679_sp_nu @ B @ A @ P ) @ A2 ) ) )).

% sp\<^sub>\<nu>.pred_inject
thf(fact_29_sp_092_060_094sub_062_092_060mu_062_Orel__refl__strong,axiom,(
    ! [C: $tType,A: $tType,B: $tType,X: ( stream901396144_sp_mu @ B @ A @ C ),R1a: ( A > A > $o ),R2a: ( C > C > $o )] :
      ( ! [Z1: A] :
          ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ B @ A @ C @ X ) )
         => ( R1a @ Z1 @ Z1 ) )
     => ( ! [Z2: C] :
            ( ( member @ C @ Z2 @ ( stream1259315544_sp_mu @ B @ A @ C @ X ) )
           => ( R2a @ Z2 @ Z2 ) )
       => ( stream1924447089_sp_mu @ A @ A @ C @ C @ B @ R1a @ R2a @ X @ X ) ) ) )).

% sp\<^sub>\<mu>.rel_refl_strong
thf(fact_30_sp_092_060_094sub_062_092_060mu_062_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),X: ( stream901396144_sp_mu @ G @ A @ B ),Y: ( stream901396144_sp_mu @ G @ C @ D ),R1a: ( A > C > $o ),R2a: ( B > D > $o )] :
      ( ( stream1924447089_sp_mu @ A @ C @ B @ D @ G @ R1 @ R2 @ X @ Y )
     => ( ! [Z1: A,Y12: C] :
            ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ X ) )
           => ( ( member @ C @ Y12 @ ( stream2074884121_sp_mu @ G @ C @ D @ Y ) )
             => ( ( R1 @ Z1 @ Y12 )
               => ( R1a @ Z1 @ Y12 ) ) ) )
       => ( ! [Z2: B,Y23: D] :
              ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ X ) )
             => ( ( member @ D @ Y23 @ ( stream1259315544_sp_mu @ G @ C @ D @ Y ) )
               => ( ( R2 @ Z2 @ Y23 )
                 => ( R2a @ Z2 @ Y23 ) ) ) )
         => ( stream1924447089_sp_mu @ A @ C @ B @ D @ G @ R1a @ R2a @ X @ Y ) ) ) ) )).

% sp\<^sub>\<mu>.rel_mono_strong
thf(fact_31_sp_092_060_094sub_062_092_060mu_062_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: $tType,X: ( stream901396144_sp_mu @ G @ A @ B ),Ya: ( stream901396144_sp_mu @ G @ A @ B ),Y: ( stream901396144_sp_mu @ G @ C @ D ),Xa: ( stream901396144_sp_mu @ G @ C @ D ),R1: ( A > C > $o ),R1a: ( A > C > $o ),R2: ( B > D > $o ),R2a: ( B > D > $o )] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z1: A,Y12: C] :
              ( ( member @ A @ Z1 @ ( stream2074884121_sp_mu @ G @ A @ B @ Ya ) )
             => ( ( member @ C @ Y12 @ ( stream2074884121_sp_mu @ G @ C @ D @ Xa ) )
               => ( ( R1 @ Z1 @ Y12 )
                  = ( R1a @ Z1 @ Y12 ) ) ) )
         => ( ! [Z2: B,Y23: D] :
                ( ( member @ B @ Z2 @ ( stream1259315544_sp_mu @ G @ A @ B @ Ya ) )
               => ( ( member @ D @ Y23 @ ( stream1259315544_sp_mu @ G @ C @ D @ Xa ) )
                 => ( ( R2 @ Z2 @ Y23 )
                    = ( R2a @ Z2 @ Y23 ) ) ) )
           => ( ( stream1924447089_sp_mu @ A @ C @ B @ D @ G @ R1 @ R2 @ X @ Y )
              = ( stream1924447089_sp_mu @ A @ C @ B @ D @ G @ R1a @ R2a @ Ya @ Xa ) ) ) ) ) ) )).

% sp\<^sub>\<mu>.rel_cong
thf(fact_32_sp_092_060_094sub_062_092_060mu_062_Orel__distinct_I1_J,axiom,(
    ! [B: $tType,C: $tType,E: $tType,A: $tType,F3: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),Y21: E,Y22: F3] :
      ~ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) @ ( stream1370332830mu_Put @ E @ F3 @ A @ Y21 @ Y22 ) ) )).

% sp\<^sub>\<mu>.rel_distinct(1)
thf(fact_33_sp_092_060_094sub_062_092_060mu_062_Orel__distinct_I2_J,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,G: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y21: A,Y22: B,X1: ( G > ( stream901396144_sp_mu @ G @ C @ D ) )] :
      ~ ( stream1924447089_sp_mu @ A @ C @ B @ D @ G @ R1 @ R2 @ ( stream1370332830mu_Put @ A @ B @ G @ Y21 @ Y22 ) @ ( stream1294929701mu_Get @ G @ C @ D @ X1 ) ) )).

% sp\<^sub>\<mu>.rel_distinct(2)
thf(fact_34_sp_092_060_094sub_062_092_060mu_062_Opred__map,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,G: $tType,Q1: ( C > $o ),Q2: ( D > $o ),F1: ( A > C ),F2: ( B > D ),X: ( stream901396144_sp_mu @ G @ A @ B )] :
      ( ( stream123009735_sp_mu @ C @ D @ G @ Q1 @ Q2 @ ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ X ) )
      = ( stream123009735_sp_mu @ A @ B @ G @ ( comp @ C @ $o @ A @ Q1 @ F1 ) @ ( comp @ D @ $o @ B @ Q2 @ F2 ) @ X ) ) )).

% sp\<^sub>\<mu>.pred_map
thf(fact_35_sp_092_060_094sub_062_092_060mu_062_Oset__map_I1_J,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,G: $tType,F1: ( A > C ),F2: ( B > D ),V: ( stream901396144_sp_mu @ G @ A @ B )] :
      ( ( stream2074884121_sp_mu @ G @ C @ D @ ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ V ) )
      = ( image @ A @ C @ F1 @ ( stream2074884121_sp_mu @ G @ A @ B @ V ) ) ) )).

% sp\<^sub>\<mu>.set_map(1)
thf(fact_36_sp_092_060_094sub_062_092_060mu_062_Oset__map_I2_J,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G: $tType,F1: ( A > C ),F2: ( B > D ),V: ( stream901396144_sp_mu @ G @ A @ B )] :
      ( ( stream1259315544_sp_mu @ G @ C @ D @ ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ V ) )
      = ( image @ B @ D @ F2 @ ( stream1259315544_sp_mu @ G @ A @ B @ V ) ) ) )).

% sp\<^sub>\<mu>.set_map(2)
thf(fact_37_sp_092_060_094sub_062_092_060mu_062_Orel__eq,axiom,(
    ! [B: $tType,A: $tType,G: $tType] :
      ( ( stream1924447089_sp_mu @ A @ A @ B @ B @ G
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) )
      = ( ^ [Y3: ( stream901396144_sp_mu @ G @ A @ B ),Z: ( stream901396144_sp_mu @ G @ A @ B )] : ( Y3 = Z ) ) ) )).

% sp\<^sub>\<mu>.rel_eq
thf(fact_38_sp_092_060_094sub_062_092_060mu_062_Orel__refl,axiom,(
    ! [D: $tType,C: $tType,G: $tType,R1a: ( C > C > $o ),R2a: ( D > D > $o ),X: ( stream901396144_sp_mu @ G @ C @ D )] :
      ( ! [X2: C] :
          ( R1a @ X2 @ X2 )
     => ( ! [X2: D] :
            ( R2a @ X2 @ X2 )
       => ( stream1924447089_sp_mu @ C @ C @ D @ D @ G @ R1a @ R2a @ X @ X ) ) ) )).

% sp\<^sub>\<mu>.rel_refl
thf(fact_39_sp_092_060_094sub_062_092_060mu_062_Omap__comp,axiom,(
    ! [D: $tType,F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G: $tType,G1: ( C > E ),G2: ( D > F3 ),F1: ( A > C ),F2: ( B > D ),V: ( stream901396144_sp_mu @ G @ A @ B )] :
      ( ( stream1058219438_sp_mu @ C @ E @ D @ F3 @ G @ G1 @ G2 @ ( stream1058219438_sp_mu @ A @ C @ B @ D @ G @ F1 @ F2 @ V ) )
      = ( stream1058219438_sp_mu @ A @ E @ B @ F3 @ G @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F3 @ B @ G2 @ F2 ) @ V ) ) )).

% sp\<^sub>\<mu>.map_comp
thf(fact_40_sp_092_060_094sub_062_092_060nu_062_Ocoinduct,axiom,(
    ! [B: $tType,A: $tType,R: ( ( stream1273403375_sp_nu @ A @ B ) > ( stream1273403375_sp_nu @ A @ B ) > $o ),Sp_nu: ( stream1273403375_sp_nu @ A @ B ),Sp_nu3: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( R @ Sp_nu @ Sp_nu3 )
     => ( ! [Sp_nu4: ( stream1273403375_sp_nu @ A @ B ),Sp_nu5: ( stream1273403375_sp_nu @ A @ B )] :
            ( ( R @ Sp_nu4 @ Sp_nu5 )
           => ( stream1924447089_sp_mu @ B @ B @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ B ) @ A
              @ ^ [Y3: B,Z: B] : ( Y3 = Z )
              @ R
              @ ( stream1200245950nu_out @ A @ B @ Sp_nu4 )
              @ ( stream1200245950nu_out @ A @ B @ Sp_nu5 ) ) )
       => ( Sp_nu = Sp_nu3 ) ) ) )).

% sp\<^sub>\<nu>.coinduct
thf(fact_41_sp_092_060_094sub_062_092_060mu_062_Orel__inject_I2_J,axiom,(
    ! [A: $tType,E: $tType,B: $tType,C: $tType,F3: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),X21: B,X22: C,Y21: E,Y22: F3] :
      ( ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 @ ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 ) @ ( stream1370332830mu_Put @ E @ F3 @ A @ Y21 @ Y22 ) )
      = ( ( R1 @ X21 @ Y21 )
        & ( R2 @ X22 @ Y22 ) ) ) )).

% sp\<^sub>\<mu>.rel_inject(2)
thf(fact_42_sp_092_060_094sub_062_092_060mu_062_Orel__intros_I2_J,axiom,(
    ! [C: $tType,B: $tType,E: $tType,A: $tType,F3: $tType,R1: ( B > E > $o ),X21: B,Y21: E,R2: ( C > F3 > $o ),X22: C,Y22: F3] :
      ( ( R1 @ X21 @ Y21 )
     => ( ( R2 @ X22 @ Y22 )
       => ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 @ ( stream1370332830mu_Put @ B @ C @ A @ X21 @ X22 ) @ ( stream1370332830mu_Put @ E @ F3 @ A @ Y21 @ Y22 ) ) ) ) )).

% sp\<^sub>\<mu>.rel_intros(2)
thf(fact_43_Ball__image__comp,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),G3: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( image @ B @ A @ F @ A3 ) )
           => ( G3 @ X3 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A3 )
           => ( comp @ A @ $o @ B @ G3 @ F @ X3 ) ) ) ) )).

% Ball_image_comp
thf(fact_44_not__False__in__image__Ball,axiom,(
    ! [A: $tType,P: ( A > $o ),A3: ( set @ A )] :
      ( ( ~ ( member @ $o @ $false @ ( image @ A @ $o @ P @ A3 ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( P @ X3 ) ) ) ) )).

% not_False_in_image_Ball
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G3: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G3 @ X2 ) )
     => ( F = G3 ) ) )).

% ext
thf(fact_49_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F4: ( B > A ),G4: ( C > B ),X3: C] :
            ( F4 @ ( G4 @ X3 ) ) ) ) )).

% comp_apply
thf(fact_50_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B,A3: ( set @ B )] :
      ( ( B2
        = ( F @ X ) )
     => ( ( member @ B @ X @ A3 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F @ A3 ) ) ) ) )).

% image_eqI
thf(fact_51_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G3: ( C > B ),R3: ( set @ C )] :
      ( ( image @ B @ A @ F @ ( image @ C @ B @ G3 @ R3 ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F @ G3 ) @ R3 ) ) )).

% image_comp
thf(fact_52_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F: ( B > A ),A3: ( set @ B ),G3: ( C > A ),B3: ( set @ C ),H: ( A > D )] :
      ( ( ( image @ B @ A @ F @ A3 )
        = ( image @ C @ A @ G3 @ B3 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H @ F ) @ A3 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H @ G3 ) @ B3 ) ) ) )).

% image_eq_imp_comp
thf(fact_53_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G3: ( B > A ),F: ( C > B ),A3: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G3 @ ( image @ C @ B @ F @ A3 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G3 @ F ) @ A3 ) ) ) )).

% Inf.INF_image
thf(fact_54_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G3: ( B > A ),F: ( C > B ),A3: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G3 @ ( image @ C @ B @ F @ A3 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G3 @ F ) @ A3 ) ) ) )).

% Sup.SUP_image
thf(fact_55_sp_092_060_094sub_062_092_060mu_062_Oset__cases_I1_J,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E2: B,A2: ( stream901396144_sp_mu @ A @ B @ C )] :
      ( ( member @ B @ E2 @ ( stream2074884121_sp_mu @ A @ B @ C @ A2 ) )
     => ( ! [Z3: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
            ( ( A2
              = ( stream1294929701mu_Get @ A @ B @ C @ Z3 ) )
           => ! [X2: ( stream901396144_sp_mu @ A @ B @ C )] :
                ( ( member @ ( stream901396144_sp_mu @ A @ B @ C ) @ X2 @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ Z3 @ ( top_top @ ( set @ A ) ) ) )
               => ~ ( member @ B @ E2 @ ( stream2074884121_sp_mu @ A @ B @ C @ X2 ) ) ) )
       => ~ ( ! [Z2: C] :
                ( A2
               != ( stream1370332830mu_Put @ B @ C @ A @ E2 @ Z2 ) ) ) ) ) )).

% sp\<^sub>\<mu>.set_cases(1)
thf(fact_56_UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_57_surjD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X2: B] :
          ( Y
          = ( F @ X2 ) ) ) )).

% surjD
thf(fact_58_surjE,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X2: B] :
              ( Y
             != ( F @ X2 ) ) ) ) )).

% surjE
thf(fact_59_surjI,axiom,(
    ! [B: $tType,A: $tType,G3: ( B > A ),F: ( A > B )] :
      ( ! [X2: A] :
          ( ( G3 @ ( F @ X2 ) )
          = X2 )
     => ( ( image @ B @ A @ G3 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_60_rangeI,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),X: B] :
      ( member @ A @ ( F @ X ) @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_61_surj__def,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y2: A] :
          ? [X3: B] :
            ( Y2
            = ( F @ X3 ) ) ) ) )).

% surj_def
thf(fact_62_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F: ( B > A ),X: B] :
      ( ( B2
        = ( F @ X ) )
     => ( member @ A @ B2 @ ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_63_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_64_UNIV__eq__I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [X2: A] :
          ( member @ A @ X2 @ A3 )
     => ( ( top_top @ ( set @ A ) )
        = A3 ) ) )).

% UNIV_eq_I
thf(fact_65_comp__surj,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F: ( B > A ),G3: ( A > C )] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( image @ A @ C @ G3 @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ C ) ) )
       => ( ( image @ B @ C @ ( comp @ A @ C @ B @ G3 @ F ) @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ C ) ) ) ) ) )).

% comp_surj
thf(fact_66_sp_092_060_094sub_062_092_060mu_062_Osimps_I9_J,axiom,(
    ! [F3: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F1: ( B > E ),F2: ( C > F3 ),X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
      ( ( stream1058219438_sp_mu @ B @ E @ C @ F3 @ A @ F1 @ F2 @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) )
      = ( stream1294929701mu_Get @ A @ E @ F3 @ ( comp @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ A @ ( stream1058219438_sp_mu @ B @ E @ C @ F3 @ A @ F1 @ F2 ) @ X1 ) ) ) )).

% sp\<^sub>\<mu>.simps(9)
thf(fact_67_sp_092_060_094sub_062_092_060mu_062_Oinduct,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( stream901396144_sp_mu @ A @ B @ C ) > $o ),Sp_mu: ( stream901396144_sp_mu @ A @ B @ C )] :
      ( ! [X2: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
          ( ! [Xa2: ( stream901396144_sp_mu @ A @ B @ C )] :
              ( ( member @ ( stream901396144_sp_mu @ A @ B @ C ) @ Xa2 @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ X2 @ ( top_top @ ( set @ A ) ) ) )
             => ( P @ Xa2 ) )
         => ( P @ ( stream1294929701mu_Get @ A @ B @ C @ X2 ) ) )
     => ( ! [X1a: B,X23: C] :
            ( P @ ( stream1370332830mu_Put @ B @ C @ A @ X1a @ X23 ) )
       => ( P @ Sp_mu ) ) ) )).

% sp\<^sub>\<mu>.induct
thf(fact_68_sp_092_060_094sub_062_092_060mu_062_Oset__intros_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,X: ( stream901396144_sp_mu @ A @ B @ C ),A2: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),Xa: B] :
      ( ( member @ ( stream901396144_sp_mu @ A @ B @ C ) @ X @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ A2 @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ B @ Xa @ ( stream2074884121_sp_mu @ A @ B @ C @ X ) )
       => ( member @ B @ Xa @ ( stream2074884121_sp_mu @ A @ B @ C @ ( stream1294929701mu_Get @ A @ B @ C @ A2 ) ) ) ) ) )).

% sp\<^sub>\<mu>.set_intros(1)
thf(fact_69_sp_092_060_094sub_062_092_060mu_062_Oset__intros_I3_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Xc: ( stream901396144_sp_mu @ A @ B @ C ),Aa: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),Xe: C] :
      ( ( member @ ( stream901396144_sp_mu @ A @ B @ C ) @ Xc @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ Aa @ ( top_top @ ( set @ A ) ) ) )
     => ( ( member @ C @ Xe @ ( stream1259315544_sp_mu @ A @ B @ C @ Xc ) )
       => ( member @ C @ Xe @ ( stream1259315544_sp_mu @ A @ B @ C @ ( stream1294929701mu_Get @ A @ B @ C @ Aa ) ) ) ) ) )).

% sp\<^sub>\<mu>.set_intros(3)
thf(fact_70_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A3: ( set @ B ),B3: ( set @ B ),C2: ( B > A ),D2: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A3 = B3 )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ B3 )
           => ( ( C2 @ X2 )
              = ( D2 @ X2 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C2 @ A3 ) )
          = ( Sup @ ( image @ B @ A @ D2 @ B3 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_71_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A3: ( set @ B ),B3: ( set @ B ),C2: ( B > A ),D2: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A3 = B3 )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ B3 )
           => ( ( C2 @ X2 )
              = ( D2 @ X2 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C2 @ A3 ) )
          = ( Inf @ ( image @ B @ A @ D2 @ B3 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_72_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X: A,A3: ( set @ A ),B2: B,F: ( A > B )] :
      ( ( member @ A @ X @ A3 )
     => ( ( B2
          = ( F @ X ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F @ A3 ) ) ) ) )).

% rev_image_eqI
thf(fact_73_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),P: ( A > $o )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ ( image @ B @ A @ F @ A3 ) )
         => ( P @ X2 ) )
     => ! [X4: B] :
          ( ( member @ B @ X4 @ A3 )
         => ( P @ ( F @ X4 ) ) ) ) )).

% ball_imageD
thf(fact_74_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F: ( A > B ),G3: ( A > B )] :
      ( ( M = N )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ N )
           => ( ( F @ X2 )
              = ( G3 @ X2 ) ) )
       => ( ( image @ A @ B @ F @ M )
          = ( image @ A @ B @ G3 @ N ) ) ) ) )).

% image_cong
thf(fact_75_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),P: ( A > $o )] :
      ( ? [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F @ A3 ) )
          & ( P @ X4 ) )
     => ? [X2: B] :
          ( ( member @ B @ X2 @ A3 )
          & ( P @ ( F @ X2 ) ) ) ) )).

% bex_imageD
thf(fact_76_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z4: A,F: ( B > A ),A3: ( set @ B )] :
      ( ( member @ A @ Z4 @ ( image @ B @ A @ F @ A3 ) )
      = ( ? [X3: B] :
            ( ( member @ B @ X3 @ A3 )
            & ( Z4
              = ( F @ X3 ) ) ) ) ) )).

% image_iff
thf(fact_77_imageI,axiom,(
    ! [B: $tType,A: $tType,X: A,A3: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A3 )
     => ( member @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A3 ) ) ) )).

% imageI
thf(fact_78_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F: ( B > A ),G3: ( C > B ),X: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F @ ( G3 @ X ) )
        = ( H @ ( K @ X ) ) )
     => ( ( comp @ B @ A @ C @ F @ G3 @ X )
        = ( comp @ D @ A @ C @ H @ K @ X ) ) ) )).

% comp_apply_eq
thf(fact_79_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C3 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C3 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_80_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( D > B ),D3: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D3 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C3 @ ( D3 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_81_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C3: ( D > B ),D3: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C3 @ D3 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C3 @ ( D3 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_82_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F: ( D > B ),G3: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F @ G3 ) @ H )
      = ( comp @ D @ B @ A @ F @ ( comp @ C @ D @ A @ G3 @ H ) ) ) )).

% comp_assoc
thf(fact_83_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F4: ( B > C ),G4: ( A > B ),X3: A] :
            ( F4 @ ( G4 @ X3 ) ) ) ) )).

% comp_def
thf(fact_84_Ball__def,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A4: ( set @ A ),P3: ( A > $o )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( P3 @ X3 ) ) ) ) )).

% Ball_def
thf(fact_85_sp_092_060_094sub_062_092_060mu_062_Oset__cases_I2_J,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E2: C,A2: ( stream901396144_sp_mu @ A @ B @ C )] :
      ( ( member @ C @ E2 @ ( stream1259315544_sp_mu @ A @ B @ C @ A2 ) )
     => ( ! [Z3: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
            ( ( A2
              = ( stream1294929701mu_Get @ A @ B @ C @ Z3 ) )
           => ! [X2: ( stream901396144_sp_mu @ A @ B @ C )] :
                ( ( member @ ( stream901396144_sp_mu @ A @ B @ C ) @ X2 @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ Z3 @ ( top_top @ ( set @ A ) ) ) )
               => ~ ( member @ C @ E2 @ ( stream1259315544_sp_mu @ A @ B @ C @ X2 ) ) ) )
       => ~ ( ! [Z1: B] :
                ( A2
               != ( stream1370332830mu_Put @ B @ C @ A @ Z1 @ E2 ) ) ) ) ) )).

% sp\<^sub>\<mu>.set_cases(2)
thf(fact_86_surj__fun__eq,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( B > A ),X5: ( set @ B ),G1: ( A > C ),G2: ( A > C )] :
      ( ( ( image @ B @ A @ F @ X5 )
        = ( top_top @ ( set @ A ) ) )
     => ( ! [X2: B] :
            ( ( member @ B @ X2 @ X5 )
           => ( ( comp @ A @ C @ B @ G1 @ F @ X2 )
              = ( comp @ A @ C @ B @ G2 @ F @ X2 ) ) )
       => ( G1 = G2 ) ) ) )).

% surj_fun_eq
thf(fact_87_fun_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),Xa: ( D > A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( image @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
         => ( ( member @ A @ Za @ ( image @ D @ A @ Xa @ ( top_top @ ( set @ D ) ) ) )
           => ( ( ( F @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( comp @ A @ B @ D @ F @ X )
          = ( comp @ A @ B @ D @ Fa @ Xa ) )
       => ( X = Xa ) ) ) )).

% fun.inj_map_strong
thf(fact_88_fun_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),F: ( A > B ),G3: ( A > B )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( image @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
         => ( ( F @ Z3 )
            = ( G3 @ Z3 ) ) )
     => ( ( comp @ A @ B @ D @ F @ X )
        = ( comp @ A @ B @ D @ G3 @ X ) ) ) )).

% fun.map_cong0
thf(fact_89_fun_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( D > A ),Ya: ( D > A ),F: ( A > B ),G3: ( A > B )] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( image @ D @ A @ Ya @ ( top_top @ ( set @ D ) ) ) )
           => ( ( F @ Z3 )
              = ( G3 @ Z3 ) ) )
       => ( ( comp @ A @ B @ D @ F @ X )
          = ( comp @ A @ B @ D @ G3 @ Ya ) ) ) ) )).

% fun.map_cong
thf(fact_90_fun_Oset__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,F: ( A > B ),V: ( D > A )] :
      ( ( image @ D @ B @ ( comp @ A @ B @ D @ F @ V ) @ ( top_top @ ( set @ D ) ) )
      = ( image @ A @ B @ F @ ( image @ D @ A @ V @ ( top_top @ ( set @ D ) ) ) ) ) )).

% fun.set_map
thf(fact_91_iso__tuple__UNIV__I,axiom,(
    ! [A: $tType,X: A] :
      ( member @ A @ X @ ( top_top @ ( set @ A ) ) ) )).

% iso_tuple_UNIV_I
thf(fact_92_top__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( top @ C @ ( type2 @ C ) )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X3: D] :
              ( top_top @ C ) ) ) ) )).

% top_apply
thf(fact_93_sp_092_060_094sub_062_092_060mu_062_Osimps_I15_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
      ( ( stream2074884121_sp_mu @ A @ B @ C @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) )
      = ( complete_Sup_Sup @ ( set @ B ) @ ( image @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( set @ B ) @ ( stream2074884121_sp_mu @ A @ B @ C ) @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ X1 @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% sp\<^sub>\<mu>.simps(15)
thf(fact_94_Union__iff,axiom,(
    ! [A: $tType,A3: A,C2: ( set @ ( set @ A ) )] :
      ( ( member @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ C2 ) )
      = ( ? [X3: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X3 @ C2 )
            & ( member @ A @ A3 @ X3 ) ) ) ) )).

% Union_iff
thf(fact_95_UnionI,axiom,(
    ! [A: $tType,X5: ( set @ A ),C2: ( set @ ( set @ A ) ),A3: A] :
      ( ( member @ ( set @ A ) @ X5 @ C2 )
     => ( ( member @ A @ A3 @ X5 )
       => ( member @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ C2 ) ) ) ) )).

% UnionI
thf(fact_96_UN__ball__bex__simps_I1_J,axiom,(
    ! [A: $tType,A3: ( set @ ( set @ A ) ),P: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: ( set @ A )] :
            ( ( member @ ( set @ A ) @ X3 @ A3 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ X3 )
               => ( P @ Y2 ) ) ) ) ) )).

% UN_ball_bex_simps(1)
thf(fact_97_UN__ball__bex__simps_I3_J,axiom,(
    ! [D: $tType,A3: ( set @ ( set @ D ) ),P: ( D > $o )] :
      ( ( ? [X3: D] :
            ( ( member @ D @ X3 @ ( complete_Sup_Sup @ ( set @ D ) @ A3 ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: ( set @ D )] :
            ( ( member @ ( set @ D ) @ X3 @ A3 )
            & ? [Y2: D] :
                ( ( member @ D @ Y2 @ X3 )
                & ( P @ Y2 ) ) ) ) ) )).

% UN_ball_bex_simps(3)
thf(fact_98_UN__ball__bex__simps_I4_J,axiom,(
    ! [F3: $tType,E: $tType,B3: ( E > ( set @ F3 ) ),A3: ( set @ E ),P: ( F3 > $o )] :
      ( ( ? [X3: F3] :
            ( ( member @ F3 @ X3 @ ( complete_Sup_Sup @ ( set @ F3 ) @ ( image @ E @ ( set @ F3 ) @ B3 @ A3 ) ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: E] :
            ( ( member @ E @ X3 @ A3 )
            & ? [Y2: F3] :
                ( ( member @ F3 @ Y2 @ ( B3 @ X3 ) )
                & ( P @ Y2 ) ) ) ) ) )).

% UN_ball_bex_simps(4)
thf(fact_99_UN__ball__bex__simps_I2_J,axiom,(
    ! [C: $tType,B: $tType,B3: ( B > ( set @ C ) ),A3: ( set @ B ),P: ( C > $o )] :
      ( ( ! [X3: C] :
            ( ( member @ C @ X3 @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ B @ ( set @ C ) @ B3 @ A3 ) ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A3 )
           => ! [Y2: C] :
                ( ( member @ C @ Y2 @ ( B3 @ X3 ) )
               => ( P @ Y2 ) ) ) ) ) )).

% UN_ball_bex_simps(2)
thf(fact_100_bex__UN,axiom,(
    ! [A: $tType,B: $tType,B3: ( B > ( set @ A ) ),A3: ( set @ B ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B3 @ A3 ) ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: B] :
            ( ( member @ B @ X3 @ A3 )
            & ? [Y2: A] :
                ( ( member @ A @ Y2 @ ( B3 @ X3 ) )
                & ( P @ Y2 ) ) ) ) ) )).

% bex_UN
thf(fact_101_ball__UN,axiom,(
    ! [A: $tType,B: $tType,B3: ( B > ( set @ A ) ),A3: ( set @ B ),P: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B3 @ A3 ) ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: B] :
            ( ( member @ B @ X3 @ A3 )
           => ! [Y2: A] :
                ( ( member @ A @ Y2 @ ( B3 @ X3 ) )
               => ( P @ Y2 ) ) ) ) ) )).

% ball_UN
thf(fact_102_SUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( complete_Sup @ A @ ( type2 @ A ) )
     => ! [G3: ( B > A ),F: ( C > B ),A3: ( set @ C )] :
          ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ G3 @ ( image @ C @ B @ F @ A3 ) ) )
          = ( complete_Sup_Sup @ A @ ( image @ C @ A @ ( comp @ B @ A @ C @ G3 @ F ) @ A3 ) ) ) ) )).

% SUP_image
thf(fact_103_Sup__UNIV,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ( ( complete_Sup_Sup @ A @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ A ) ) ) )).

% Sup_UNIV
thf(fact_104_UnionE,axiom,(
    ! [A: $tType,A3: A,C2: ( set @ ( set @ A ) )] :
      ( ( member @ A @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ C2 ) )
     => ~ ( ! [X6: ( set @ A )] :
              ( ( member @ A @ A3 @ X6 )
             => ~ ( member @ ( set @ A ) @ X6 @ C2 ) ) ) ) )).

% UnionE
thf(fact_105_SUP__cong,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( complete_Sup @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ B ),B3: ( set @ B ),C2: ( B > A ),D2: ( B > A )] :
          ( ( A3 = B3 )
         => ( ! [X2: B] :
                ( ( member @ B @ X2 @ B3 )
               => ( ( C2 @ X2 )
                  = ( D2 @ X2 ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ C2 @ A3 ) )
              = ( complete_Sup_Sup @ A @ ( image @ B @ A @ D2 @ B3 ) ) ) ) ) ) )).

% SUP_cong
thf(fact_106_top__set__def,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( set @ A ) )
      = ( collect @ A @ ( top_top @ ( A > $o ) ) ) ) )).

% top_set_def
thf(fact_107_Union__UNIV,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( top_top @ ( set @ ( set @ A ) ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Union_UNIV
thf(fact_108_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G3: ( B > C ),F: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G3 @ ( comp @ A @ B @ D @ F @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G3 @ F ) @ V ) ) )).

% fun.map_comp
thf(fact_109_sp_092_060_094sub_062_092_060mu_062_Osimps_I17_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
      ( ( stream1259315544_sp_mu @ A @ B @ C @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) )
      = ( complete_Sup_Sup @ ( set @ C ) @ ( image @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( set @ C ) @ ( stream1259315544_sp_mu @ A @ B @ C ) @ ( image @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ X1 @ ( top_top @ ( set @ A ) ) ) ) ) ) )).

% sp\<^sub>\<mu>.simps(17)
thf(fact_110_member__bind,axiom,(
    ! [A: $tType,B: $tType,X: A,P: ( set @ B ),F: ( B > ( set @ A ) )] :
      ( ( member @ A @ X @ ( bind @ B @ A @ P @ F ) )
      = ( member @ A @ X @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F @ P ) ) ) ) )).

% member_bind
thf(fact_111_sp_092_060_094sub_062_092_060mu_062_Osize__gen__o__map,axiom,(
    ! [B: $tType,E: $tType,A: $tType,F3: $tType,C: $tType,F: ( A > nat ),Fa: ( E > nat ),Fb: ( F3 > nat ),Ga: ( B > E ),Gb: ( C > F3 )] :
      ( ( comp @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ nat @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream1362355943_sp_mu @ A @ E @ F3 @ F @ Fa @ Fb ) @ ( stream1058219438_sp_mu @ B @ E @ C @ F3 @ A @ Ga @ Gb ) )
      = ( stream1362355943_sp_mu @ A @ B @ C @ F @ ( comp @ E @ nat @ B @ Fa @ Ga ) @ ( comp @ F3 @ nat @ C @ Fb @ Gb ) ) ) )).

% sp\<^sub>\<mu>.size_gen_o_map
thf(fact_112_surj__swap__iff,axiom,(
    ! [B: $tType,A: $tType,A2: B,B2: B,F: ( B > A )] :
      ( ( ( image @ B @ A @ ( swap @ B @ A @ A2 @ B2 @ F ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_swap_iff
thf(fact_113_ball__reg,axiom,(
    ! [A: $tType,R: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( member @ A @ X2 @ R )
         => ( ( P @ X2 )
           => ( Q @ X2 ) ) )
     => ( ! [X2: A] :
            ( ( member @ A @ X2 @ R )
           => ( P @ X2 ) )
       => ! [X4: A] :
            ( ( member @ A @ X4 @ R )
           => ( Q @ X4 ) ) ) ) )).

% ball_reg
thf(fact_114_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F: ( B > A ),G3: ( C > B ),X: C,F5: ( D > A ),G5: ( E > D ),X7: E] :
      ( ( ( F @ ( G3 @ X ) )
        = ( F5 @ ( G5 @ X7 ) ) )
     => ( ( comp @ B @ A @ C @ F @ G3 @ X )
        = ( comp @ D @ A @ E @ F5 @ G5 @ X7 ) ) ) )).

% comp_cong
thf(fact_115_swap__apply_I3_J,axiom,(
    ! [A: $tType,B: $tType,C3: B,A2: B,B2: B,F: ( B > A )] :
      ( ( C3 != A2 )
     => ( ( C3 != B2 )
       => ( ( swap @ B @ A @ A2 @ B2 @ F @ C3 )
          = ( F @ C3 ) ) ) ) )).

% swap_apply(3)
thf(fact_116_swap__apply_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: B,B2: B,F: ( B > A )] :
      ( ( swap @ B @ A @ A2 @ B2 @ F @ B2 )
      = ( F @ A2 ) ) )).

% swap_apply(2)
thf(fact_117_swap__apply_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: B,B2: B,F: ( B > A )] :
      ( ( swap @ B @ A @ A2 @ B2 @ F @ A2 )
      = ( F @ B2 ) ) )).

% swap_apply(1)
thf(fact_118_swap__self,axiom,(
    ! [B: $tType,A: $tType,A2: A,F: ( A > B )] :
      ( ( swap @ A @ B @ A2 @ A2 @ F )
      = F ) )).

% swap_self
thf(fact_119_swap__nilpotent,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: A,F: ( A > B )] :
      ( ( swap @ A @ B @ A2 @ B2 @ ( swap @ A @ B @ A2 @ B2 @ F ) )
      = F ) )).

% swap_nilpotent
thf(fact_120_top1I,axiom,(
    ! [A: $tType,X: A] :
      ( top_top @ ( A > $o ) @ X ) )).

% top1I
thf(fact_121_swap__image__eq,axiom,(
    ! [B: $tType,A: $tType,A2: A,A3: ( set @ A ),B2: A,F: ( A > B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( member @ A @ B2 @ A3 )
       => ( ( image @ A @ B @ ( swap @ A @ B @ A2 @ B2 @ F ) @ A3 )
          = ( image @ A @ B @ F @ A3 ) ) ) ) )).

% swap_image_eq
thf(fact_122_swap__triple,axiom,(
    ! [B: $tType,A: $tType,A2: A,C3: A,B2: A,F: ( A > B )] :
      ( ( A2 != C3 )
     => ( ( B2 != C3 )
       => ( ( swap @ A @ B @ A2 @ B2 @ ( swap @ A @ B @ B2 @ C3 @ ( swap @ A @ B @ A2 @ B2 @ F ) ) )
          = ( swap @ A @ B @ A2 @ C3 @ F ) ) ) ) )).

% swap_triple
thf(fact_123_swap__commute,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( swap @ A @ B )
      = ( ^ [A5: A,B4: A] :
            ( swap @ A @ B @ B4 @ A5 ) ) ) )).

% swap_commute
thf(fact_124_comp__swap,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( C > B ),A2: A,B2: A,G3: ( A > C )] :
      ( ( comp @ C @ B @ A @ F @ ( swap @ A @ C @ A2 @ B2 @ G3 ) )
      = ( swap @ A @ B @ A2 @ B2 @ ( comp @ C @ B @ A @ F @ G3 ) ) ) )).

% comp_swap
thf(fact_125_bind__image,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( C > B ),A3: ( set @ C ),G3: ( B > ( set @ A ) )] :
      ( ( bind @ B @ A @ ( image @ C @ B @ F @ A3 ) @ G3 )
      = ( bind @ C @ A @ A3 @ ( comp @ B @ ( set @ A ) @ C @ G3 @ F ) ) ) )).

% bind_image
thf(fact_126_image__bind,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),A3: ( set @ C ),G3: ( C > ( set @ B ) )] :
      ( ( image @ B @ A @ F @ ( bind @ C @ B @ A3 @ G3 ) )
      = ( bind @ C @ A @ A3 @ ( comp @ ( set @ B ) @ ( set @ A ) @ C @ ( image @ B @ A @ F ) @ G3 ) ) ) )).

% image_bind
thf(fact_127_surj__imp__surj__swap,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A2: B,B2: B] :
      ( ( ( image @ B @ A @ F @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ ( swap @ B @ A @ A2 @ B2 @ F ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_imp_surj_swap
thf(fact_128_bind__UNION,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( bind @ B @ A )
      = ( ^ [A4: ( set @ B ),F4: ( B > ( set @ A ) )] :
            ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F4 @ A4 ) ) ) ) )).

% bind_UNION
thf(fact_129_top__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( top_top @ ( A > $o ) )
      = ( ^ [X3: A] :
            ( member @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )).

% top_empty_eq
thf(fact_130_top__conj_I1_J,axiom,(
    ! [A: $tType,X: A,P: $o] :
      ( ( ( top_top @ ( A > $o ) @ X )
        & P )
      = P ) )).

% top_conj(1)
thf(fact_131_top__conj_I2_J,axiom,(
    ! [A: $tType,P: $o,X: A] :
      ( ( P
        & ( top_top @ ( A > $o ) @ X ) )
      = P ) )).

% top_conj(2)
thf(fact_132_Pow__UNIV,axiom,(
    ! [A: $tType] :
      ( ( pow @ A @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ ( set @ A ) ) ) ) )).

% Pow_UNIV
thf(fact_133_Union__Pow__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( pow @ A @ A3 ) )
      = A3 ) )).

% Union_Pow_eq
thf(fact_134_image__Pow__surj,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),A3: ( set @ B ),B3: ( set @ A )] :
      ( ( ( image @ B @ A @ F @ A3 )
        = B3 )
     => ( ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F ) @ ( pow @ B @ A3 ) )
        = ( pow @ A @ B3 ) ) ) )).

% image_Pow_surj
thf(fact_135_Cantors__paradox,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ~ ( ? [X4: ( A > ( set @ A ) )] :
            ( ( image @ A @ ( set @ A ) @ X4 @ A3 )
            = ( pow @ A @ A3 ) ) ) )).

% Cantors_paradox
thf(fact_136_Pow__top,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( member @ ( set @ A ) @ A3 @ ( pow @ A @ A3 ) ) )).

% Pow_top
thf(fact_137_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( C > B ),G3: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F @ G3 )
        = L )
     => ( ( comp @ C @ B @ D @ F @ ( comp @ A @ C @ D @ G3 @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_138_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G3: ( C > B ),H: ( A > C ),R3: ( A > B ),F: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G3 @ H )
        = R3 )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F @ G3 ) @ H )
        = ( comp @ B @ D @ A @ F @ R3 ) ) ) )).

% rewriteR_comp_comp
thf(fact_139_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F: ( C > B ),G3: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R3: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F @ G3 )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R3 )
       => ( ( comp @ C @ B @ E @ F @ ( comp @ A @ C @ E @ G3 @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R3 ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_140_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G3: ( C > B ),H: ( A > C ),R12: ( D > B ),R22: ( A > D ),F: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G3 @ H )
        = ( comp @ D @ B @ A @ R12 @ R22 ) )
     => ( ( ( comp @ B @ E @ D @ F @ R12 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F @ G3 ) @ H )
          = ( comp @ D @ E @ A @ L @ R22 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_141_Sup__SUP__eq,axiom,(
    ! [A: $tType] :
      ( ( complete_Sup_Sup @ ( A > $o ) )
      = ( ^ [S: ( set @ ( A > $o ) ),X3: A] :
            ( member @ A @ X3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( A > $o ) @ ( set @ A ) @ ( collect @ A ) @ S ) ) ) ) ) )).

% Sup_SUP_eq
thf(fact_142_type__copy__set__map0,axiom,(
    ! [A: $tType,B: $tType,D: $tType,E: $tType,C: $tType,F3: $tType,Rep: ( A > B ),Abs: ( B > A ),S2: ( B > ( set @ D ) ),M: ( C > B ),F: ( E > D ),S3: ( C > ( set @ E ) ),G3: ( F3 > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ( comp @ B @ ( set @ D ) @ C @ S2 @ M )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ C @ ( image @ E @ D @ F ) @ S3 ) )
       => ( ( comp @ A @ ( set @ D ) @ F3 @ ( comp @ B @ ( set @ D ) @ A @ S2 @ Rep ) @ ( comp @ C @ A @ F3 @ ( comp @ B @ A @ C @ Abs @ M ) @ G3 ) )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ F3 @ ( image @ E @ D @ F ) @ ( comp @ C @ ( set @ E ) @ F3 @ S3 @ G3 ) ) ) ) ) )).

% type_copy_set_map0
thf(fact_143_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G3: ( C > B ),X: C,N: ( D > A ),H: ( C > D ),F: ( A > E )] :
      ( ( ( M @ ( G3 @ X ) )
        = ( N @ ( H @ X ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F @ M ) @ G3 @ X )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F @ N ) @ H @ X ) ) ) )).

% type_copy_map_cong0
thf(fact_144_sp_092_060_094sub_062_092_060nu_062_Orel__inject,axiom,(
    ! [B: $tType,D: $tType,A: $tType,R: ( B > D > $o ),X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ),Y: ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) )] :
      ( ( stream1017682031_sp_nu @ B @ D @ A @ R @ ( stream1686501333_nu_In @ A @ B @ X ) @ ( stream1686501333_nu_In @ A @ D @ Y ) )
      = ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ X @ Y ) ) )).

% sp\<^sub>\<nu>.rel_inject
thf(fact_145_sp_092_060_094sub_062_092_060mu_062_Orel__induct,axiom,(
    ! [B: $tType,C: $tType,F3: $tType,E: $tType,A: $tType,R2: ( B > E > $o ),R32: ( C > F3 > $o ),X: ( stream901396144_sp_mu @ A @ B @ C ),Y: ( stream901396144_sp_mu @ A @ E @ F3 ),Q: ( ( stream901396144_sp_mu @ A @ B @ C ) > ( stream901396144_sp_mu @ A @ E @ F3 ) > $o )] :
      ( ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R2 @ R32 @ X @ Y )
     => ( ! [A12: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),B1: ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) )] :
            ( ( bNF_rel_fun @ A @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
              @ ^ [Y3: A,Z: A] : ( Y3 = Z )
              @ Q
              @ A12
              @ B1 )
           => ( Q @ ( stream1294929701mu_Get @ A @ B @ C @ A12 ) @ ( stream1294929701mu_Get @ A @ E @ F3 @ B1 ) ) )
       => ( ! [A21: B,A222: C,B21: E,B22: F3] :
              ( ( R2 @ A21 @ B21 )
             => ( ( R32 @ A222 @ B22 )
               => ( Q @ ( stream1370332830mu_Put @ B @ C @ A @ A21 @ A222 ) @ ( stream1370332830mu_Put @ E @ F3 @ A @ B21 @ B22 ) ) ) )
         => ( Q @ X @ Y ) ) ) ) )).

% sp\<^sub>\<mu>.rel_induct
thf(fact_146_rel__funI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B3: ( C > D > $o ),F: ( A > C ),G3: ( B > D )] :
      ( ! [X2: A,Y4: B] :
          ( ( A3 @ X2 @ Y4 )
         => ( B3 @ ( F @ X2 ) @ ( G3 @ Y4 ) ) )
     => ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B3 @ F @ G3 ) ) )).

% rel_funI
thf(fact_147_Sup1__I,axiom,(
    ! [A: $tType,P: ( A > $o ),A3: ( set @ ( A > $o ) ),A2: A] :
      ( ( member @ ( A > $o ) @ P @ A3 )
     => ( ( P @ A2 )
       => ( complete_Sup_Sup @ ( A > $o ) @ A3 @ A2 ) ) ) )).

% Sup1_I
thf(fact_148_o__rsp_I2_J,axiom,(
    ! [E: $tType,F3: $tType,H2: $tType,G: $tType,R1: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( G > H2 ) @ ( G > H2 ) @ ( ( E > G ) > E > H2 ) @ ( ( F3 > G ) > F3 > H2 )
      @ ^ [Y3: ( G > H2 ),Z: ( G > H2 )] : ( Y3 = Z )
      @ ( bNF_rel_fun @ ( E > G ) @ ( F3 > G ) @ ( E > H2 ) @ ( F3 > H2 )
        @ ( bNF_rel_fun @ E @ F3 @ G @ G @ R1
          @ ^ [Y3: G,Z: G] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ E @ F3 @ H2 @ H2 @ R1
          @ ^ [Y3: H2,Z: H2] : ( Y3 = Z ) ) )
      @ ( comp @ G @ H2 @ E )
      @ ( comp @ G @ H2 @ F3 ) ) )).

% o_rsp(2)
thf(fact_149_o__rsp_I1_J,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,D: $tType,C: $tType,R2: ( A > C > $o ),R32: ( B > D > $o ),R1: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F3 > C ) > F3 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ R2 @ R32 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F3 > C ) @ ( E > B ) @ ( F3 > D ) @ ( bNF_rel_fun @ E @ F3 @ A @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ E @ F3 @ B @ D @ R1 @ R32 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F3 ) ) )).

% o_rsp(1)
thf(fact_150_fun_Omap__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,G: $tType,F3: $tType,Rb: ( A > F3 > $o ),Sd: ( B > G > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( F3 > G ) @ ( ( D > A ) > D > B ) @ ( ( D > F3 ) > D > G ) @ ( bNF_rel_fun @ A @ F3 @ B @ G @ Rb @ Sd )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > F3 ) @ ( D > B ) @ ( D > G )
        @ ( bNF_rel_fun @ D @ D @ A @ F3
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Rb )
        @ ( bNF_rel_fun @ D @ D @ B @ G
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Sd ) )
      @ ( comp @ A @ B @ D )
      @ ( comp @ F3 @ G @ D ) ) )).

% fun.map_transfer
thf(fact_151_comp__transfer,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F3: $tType,D: $tType,C: $tType,B3: ( A > C > $o ),C2: ( B > D > $o ),A3: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E > A ) > E > B ) @ ( ( F3 > C ) > F3 > D ) @ ( bNF_rel_fun @ A @ C @ B @ D @ B3 @ C2 ) @ ( bNF_rel_fun @ ( E > A ) @ ( F3 > C ) @ ( E > B ) @ ( F3 > D ) @ ( bNF_rel_fun @ E @ F3 @ A @ C @ A3 @ B3 ) @ ( bNF_rel_fun @ E @ F3 @ B @ D @ A3 @ C2 ) ) @ ( comp @ A @ B @ E ) @ ( comp @ C @ D @ F3 ) ) )).

% comp_transfer
thf(fact_152_type__copy__obj__one__point__absE,axiom,(
    ! [A: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),S4: A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ~ ( ! [X2: B] :
              ( S4
             != ( Abs @ X2 ) ) ) ) )).

% type_copy_obj_one_point_absE
thf(fact_153_type__copy__map__comp0,axiom,(
    ! [F3: $tType,D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Rep: ( A > B ),Abs: ( B > A ),M: ( C > D ),M1: ( B > D ),M2: ( C > B ),F: ( D > F3 ),G3: ( E > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( comp @ B @ D @ C @ M1 @ M2 ) )
       => ( ( comp @ C @ F3 @ E @ ( comp @ D @ F3 @ C @ F @ M ) @ G3 )
          = ( comp @ A @ F3 @ E @ ( comp @ B @ F3 @ A @ ( comp @ D @ F3 @ B @ F @ M1 ) @ Rep ) @ ( comp @ C @ A @ E @ ( comp @ B @ A @ C @ Abs @ M2 ) @ G3 ) ) ) ) ) )).

% type_copy_map_comp0
thf(fact_154_fun_Orel__eq,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( D > A ),Z: ( D > A )] : ( Y3 = Z ) ) ) )).

% fun.rel_eq
thf(fact_155_fun_Orel__refl,axiom,(
    ! [B: $tType,D: $tType,Ra: ( B > B > $o ),X: ( D > B )] :
      ( ! [X2: B] :
          ( Ra @ X2 @ X2 )
     => ( bNF_rel_fun @ D @ D @ B @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ Ra
        @ X
        @ X ) ) )).

% fun.rel_refl
thf(fact_156_fun_Orel__transfer,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E: $tType,D: $tType,Sa: ( A > C > $o ),Sc: ( B > E > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > E > $o ) @ ( ( D > A ) > ( D > B ) > $o ) @ ( ( D > C ) > ( D > E ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( E > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ E @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > C ) @ ( ( D > B ) > $o ) @ ( ( D > E ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ C
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Sa )
        @ ( bNF_rel_fun @ ( D > B ) @ ( D > E ) @ $o @ $o
          @ ( bNF_rel_fun @ D @ D @ B @ E
            @ ^ [Y3: D,Z: D] : ( Y3 = Z )
            @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ D @ D @ C @ E
        @ ^ [Y3: D,Z: D] : ( Y3 = Z ) ) ) )).

% fun.rel_transfer
thf(fact_157_sp_092_060_094sub_062_092_060mu_062_Octr__transfer_I1_J,axiom,(
    ! [B: $tType,C: $tType,F3: $tType,E: $tType,A: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o )] :
      ( bNF_rel_fun @ ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) @ ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) ) @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
      @ ( bNF_rel_fun @ A @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 ) )
      @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 )
      @ ( stream1294929701mu_Get @ A @ B @ C )
      @ ( stream1294929701mu_Get @ A @ E @ F3 ) ) )).

% sp\<^sub>\<mu>.ctr_transfer(1)
thf(fact_158_sp_092_060_094sub_062_092_060nu_062_Orel__refl,axiom,(
    ! [B: $tType,D: $tType,Ra: ( B > B > $o ),X: ( stream1273403375_sp_nu @ D @ B )] :
      ( ! [X2: B] :
          ( Ra @ X2 @ X2 )
     => ( stream1017682031_sp_nu @ B @ B @ D @ Ra @ X @ X ) ) )).

% sp\<^sub>\<nu>.rel_refl
thf(fact_159_sp_092_060_094sub_062_092_060nu_062_Orel__eq,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( stream1017682031_sp_nu @ A @ A @ D
        @ ^ [Y3: A,Z: A] : ( Y3 = Z ) )
      = ( ^ [Y3: ( stream1273403375_sp_nu @ D @ A ),Z: ( stream1273403375_sp_nu @ D @ A )] : ( Y3 = Z ) ) ) )).

% sp\<^sub>\<nu>.rel_eq
thf(fact_160_rel__funD,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B3: ( C > D > $o ),F: ( A > C ),G3: ( B > D ),X: A,Y: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B3 @ F @ G3 )
     => ( ( A3 @ X @ Y )
       => ( B3 @ ( F @ X ) @ ( G3 @ Y ) ) ) ) )).

% rel_funD
thf(fact_161_rel__fun__mono,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,X5: ( A > B > $o ),A3: ( C > D > $o ),F: ( A > C ),G3: ( B > D ),Y5: ( A > B > $o ),B3: ( C > D > $o )] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ X5 @ A3 @ F @ G3 )
     => ( ! [X2: A,Y4: B] :
            ( ( Y5 @ X2 @ Y4 )
           => ( X5 @ X2 @ Y4 ) )
       => ( ! [X2: C,Y4: D] :
              ( ( A3 @ X2 @ Y4 )
             => ( B3 @ X2 @ Y4 ) )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y5 @ B3 @ F @ G3 ) ) ) ) )).

% rel_fun_mono
thf(fact_162_rel__fun__mono_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Y5: ( A > B > $o ),X5: ( A > B > $o ),A3: ( C > D > $o ),B3: ( C > D > $o ),F: ( A > C ),G3: ( B > D )] :
      ( ! [X2: A,Y4: B] :
          ( ( Y5 @ X2 @ Y4 )
         => ( X5 @ X2 @ Y4 ) )
     => ( ! [X2: C,Y4: D] :
            ( ( A3 @ X2 @ Y4 )
           => ( B3 @ X2 @ Y4 ) )
       => ( ( bNF_rel_fun @ A @ B @ C @ D @ X5 @ A3 @ F @ G3 )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y5 @ B3 @ F @ G3 ) ) ) ) )).

% rel_fun_mono'
thf(fact_163_sp_092_060_094sub_062_092_060mu_062_Ocase__transfer,axiom,(
    ! [B: $tType,C: $tType,G: $tType,H2: $tType,F3: $tType,E: $tType,A: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),S2: ( G > H2 > $o )] :
      ( bNF_rel_fun @ ( ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) > G ) @ ( ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) ) > H2 ) @ ( ( B > C > G ) > ( stream901396144_sp_mu @ A @ B @ C ) > G ) @ ( ( E > F3 > H2 ) > ( stream901396144_sp_mu @ A @ E @ F3 ) > H2 )
      @ ( bNF_rel_fun @ ( A > ( stream901396144_sp_mu @ A @ B @ C ) ) @ ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) ) @ G @ H2
        @ ( bNF_rel_fun @ A @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
          @ ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 ) )
        @ S2 )
      @ ( bNF_rel_fun @ ( B > C > G ) @ ( E > F3 > H2 ) @ ( ( stream901396144_sp_mu @ A @ B @ C ) > G ) @ ( ( stream901396144_sp_mu @ A @ E @ F3 ) > H2 ) @ ( bNF_rel_fun @ B @ E @ ( C > G ) @ ( F3 > H2 ) @ R1 @ ( bNF_rel_fun @ C @ F3 @ G @ H2 @ R2 @ S2 ) ) @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ G @ H2 @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 ) @ S2 ) )
      @ ( stream160000856_sp_mu @ A @ B @ C @ G )
      @ ( stream160000856_sp_mu @ A @ E @ F3 @ H2 ) ) )).

% sp\<^sub>\<mu>.case_transfer
thf(fact_164_sp_092_060_094sub_062_092_060mu_062_Omap__transfer,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,G: $tType,M3: $tType,K2: $tType,L3: $tType,J: $tType,R1b: ( A > J > $o ),S1d: ( C > L3 > $o ),R2b: ( B > K2 > $o ),S2d: ( D > M3 > $o )] :
      ( bNF_rel_fun @ ( A > C ) @ ( J > L3 ) @ ( ( B > D ) > ( stream901396144_sp_mu @ G @ A @ B ) > ( stream901396144_sp_mu @ G @ C @ D ) ) @ ( ( K2 > M3 ) > ( stream901396144_sp_mu @ G @ J @ K2 ) > ( stream901396144_sp_mu @ G @ L3 @ M3 ) ) @ ( bNF_rel_fun @ A @ J @ C @ L3 @ R1b @ S1d ) @ ( bNF_rel_fun @ ( B > D ) @ ( K2 > M3 ) @ ( ( stream901396144_sp_mu @ G @ A @ B ) > ( stream901396144_sp_mu @ G @ C @ D ) ) @ ( ( stream901396144_sp_mu @ G @ J @ K2 ) > ( stream901396144_sp_mu @ G @ L3 @ M3 ) ) @ ( bNF_rel_fun @ B @ K2 @ D @ M3 @ R2b @ S2d ) @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ G @ A @ B ) @ ( stream901396144_sp_mu @ G @ J @ K2 ) @ ( stream901396144_sp_mu @ G @ C @ D ) @ ( stream901396144_sp_mu @ G @ L3 @ M3 ) @ ( stream1924447089_sp_mu @ A @ J @ B @ K2 @ G @ R1b @ R2b ) @ ( stream1924447089_sp_mu @ C @ L3 @ D @ M3 @ G @ S1d @ S2d ) ) ) @ ( stream1058219438_sp_mu @ A @ C @ B @ D @ G ) @ ( stream1058219438_sp_mu @ J @ L3 @ K2 @ M3 @ G ) ) )).

% sp\<^sub>\<mu>.map_transfer
thf(fact_165_sp_092_060_094sub_062_092_060nu_062_Osel__transfer,axiom,(
    ! [B: $tType,D: $tType,A: $tType,R: ( B > D > $o )] :
      ( bNF_rel_fun @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) @ ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) ) @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) ) @ ( stream1200245950nu_out @ A @ B ) @ ( stream1200245950nu_out @ A @ D ) ) )).

% sp\<^sub>\<nu>.sel_transfer
thf(fact_166_Sup1__E,axiom,(
    ! [A: $tType,A3: ( set @ ( A > $o ) ),A2: A] :
      ( ( complete_Sup_Sup @ ( A > $o ) @ A3 @ A2 )
     => ~ ( ! [P4: ( A > $o )] :
              ( ( member @ ( A > $o ) @ P4 @ A3 )
             => ~ ( P4 @ A2 ) ) ) ) )).

% Sup1_E
thf(fact_167_type__copy__ex__RepI,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A ),F6: ( B > $o )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ^ [P5: ( B > $o )] :
            ? [X8: B] :
              ( P5 @ X8 )
          @ F6 )
        = ( ? [B4: A] :
              ( F6 @ ( Rep @ B4 ) ) ) ) ) )).

% type_copy_ex_RepI
thf(fact_168_type__copy__wit,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),X: C,S2: ( B > ( set @ C ) ),Y: B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( member @ C @ X @ ( comp @ B @ ( set @ C ) @ A @ S2 @ Rep @ ( Abs @ Y ) ) )
       => ( member @ C @ X @ ( S2 @ Y ) ) ) ) )).

% type_copy_wit
thf(fact_169_fun_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,X: ( D > A ),Ya: ( D > A ),Y: ( D > B ),Xa: ( D > B ),R: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( image @ D @ A @ Ya @ ( top_top @ ( set @ D ) ) ) )
             => ( ( member @ B @ Yb @ ( image @ D @ B @ Xa @ ( top_top @ ( set @ D ) ) ) )
               => ( ( R @ Z3 @ Yb )
                  = ( Ra @ Z3 @ Yb ) ) ) )
         => ( ( bNF_rel_fun @ D @ D @ A @ B
              @ ^ [Y3: D,Z: D] : ( Y3 = Z )
              @ R
              @ X
              @ Y )
            = ( bNF_rel_fun @ D @ D @ A @ B
              @ ^ [Y3: D,Z: D] : ( Y3 = Z )
              @ Ra
              @ Ya
              @ Xa ) ) ) ) ) )).

% fun.rel_cong
thf(fact_170_fun_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,R: ( A > B > $o ),X: ( D > A ),Y: ( D > B ),Ra: ( A > B > $o )] :
      ( ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y3: D,Z: D] : ( Y3 = Z )
        @ R
        @ X
        @ Y )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( image @ D @ A @ X @ ( top_top @ ( set @ D ) ) ) )
           => ( ( member @ B @ Yb @ ( image @ D @ B @ Y @ ( top_top @ ( set @ D ) ) ) )
             => ( ( R @ Z3 @ Yb )
               => ( Ra @ Z3 @ Yb ) ) ) )
       => ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y3: D,Z: D] : ( Y3 = Z )
          @ Ra
          @ X
          @ Y ) ) ) )).

% fun.rel_mono_strong
thf(fact_171_fun_Orel__refl__strong,axiom,(
    ! [A: $tType,B: $tType,X: ( B > A ),Ra: ( A > A > $o )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( image @ B @ A @ X @ ( top_top @ ( set @ B ) ) ) )
         => ( Ra @ Z3 @ Z3 ) )
     => ( bNF_rel_fun @ B @ B @ A @ A
        @ ^ [Y3: B,Z: B] : ( Y3 = Z )
        @ Ra
        @ X
        @ X ) ) )).

% fun.rel_refl_strong
thf(fact_172_sp_092_060_094sub_062_092_060mu_062_Orel__intros_I1_J,axiom,(
    ! [B: $tType,C: $tType,F3: $tType,E: $tType,A: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),Y1: ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) )] :
      ( ( bNF_rel_fun @ A @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 )
        @ X1
        @ Y1 )
     => ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) @ ( stream1294929701mu_Get @ A @ E @ F3 @ Y1 ) ) ) )).

% sp\<^sub>\<mu>.rel_intros(1)
thf(fact_173_sp_092_060_094sub_062_092_060mu_062_Orel__inject_I1_J,axiom,(
    ! [B: $tType,C: $tType,F3: $tType,E: $tType,A: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),X1: ( A > ( stream901396144_sp_mu @ A @ B @ C ) ),Y1: ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) )] :
      ( ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 @ ( stream1294929701mu_Get @ A @ B @ C @ X1 ) @ ( stream1294929701mu_Get @ A @ E @ F3 @ Y1 ) )
      = ( bNF_rel_fun @ A @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 )
        @ X1
        @ Y1 ) ) )).

% sp\<^sub>\<mu>.rel_inject(1)
thf(fact_174_type__copy__map__comp0__undo,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,D: $tType,F3: $tType,Rep: ( A > B ),Abs: ( B > A ),Rep2: ( C > D ),Abs2: ( D > C ),Rep3: ( E > F3 ),Abs3: ( F3 > E ),M: ( F3 > D ),M1: ( B > D ),M2: ( F3 > B )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( type_definition @ C @ D @ Rep2 @ Abs2 @ ( top_top @ ( set @ D ) ) )
       => ( ( type_definition @ E @ F3 @ Rep3 @ Abs3 @ ( top_top @ ( set @ F3 ) ) )
         => ( ( ( comp @ F3 @ C @ E @ ( comp @ D @ C @ F3 @ Abs2 @ M ) @ Rep3 )
              = ( comp @ A @ C @ E @ ( comp @ B @ C @ A @ ( comp @ D @ C @ B @ Abs2 @ M1 ) @ Rep ) @ ( comp @ F3 @ A @ E @ ( comp @ B @ A @ F3 @ Abs @ M2 ) @ Rep3 ) ) )
           => ( ( comp @ B @ D @ F3 @ M1 @ M2 )
              = M ) ) ) ) ) )).

% type_copy_map_comp0_undo
thf(fact_175_sp_092_060_094sub_062_092_060nu_062_Orel__coinduct,axiom,(
    ! [B: $tType,D: $tType,A: $tType,P: ( ( stream1273403375_sp_nu @ A @ B ) > ( stream1273403375_sp_nu @ A @ D ) > $o ),X: ( stream1273403375_sp_nu @ A @ B ),Y: ( stream1273403375_sp_nu @ A @ D ),R2: ( B > D > $o )] :
      ( ( P @ X @ Y )
     => ( ! [Sp_nu4: ( stream1273403375_sp_nu @ A @ B ),Sp_nu5: ( stream1273403375_sp_nu @ A @ D )] :
            ( ( P @ Sp_nu4 @ Sp_nu5 )
           => ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R2 @ P @ ( stream1200245950nu_out @ A @ B @ Sp_nu4 ) @ ( stream1200245950nu_out @ A @ D @ Sp_nu5 ) ) )
       => ( stream1017682031_sp_nu @ B @ D @ A @ R2 @ X @ Y ) ) ) )).

% sp\<^sub>\<nu>.rel_coinduct
thf(fact_176_sp_092_060_094sub_062_092_060nu_062_Orel__sel,axiom,(
    ! [A: $tType,D: $tType,B: $tType] :
      ( ( stream1017682031_sp_nu @ B @ D @ A )
      = ( ^ [R4: ( B > D > $o ),A5: ( stream1273403375_sp_nu @ A @ B ),B4: ( stream1273403375_sp_nu @ A @ D )] :
            ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R4 @ ( stream1017682031_sp_nu @ B @ D @ A @ R4 ) @ ( stream1200245950nu_out @ A @ B @ A5 ) @ ( stream1200245950nu_out @ A @ D @ B4 ) ) ) ) )).

% sp\<^sub>\<nu>.rel_sel
thf(fact_177_sp_092_060_094sub_062_092_060nu_062_Orel__intros,axiom,(
    ! [B: $tType,D: $tType,A: $tType,R: ( B > D > $o ),X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ),Y: ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) )] :
      ( ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ X @ Y )
     => ( stream1017682031_sp_nu @ B @ D @ A @ R @ ( stream1686501333_nu_In @ A @ B @ X ) @ ( stream1686501333_nu_In @ A @ D @ Y ) ) ) )).

% sp\<^sub>\<nu>.rel_intros
thf(fact_178_sp_092_060_094sub_062_092_060nu_062_Orel__cases,axiom,(
    ! [B: $tType,D: $tType,A: $tType,R: ( B > D > $o ),A2: ( stream1273403375_sp_nu @ A @ B ),B2: ( stream1273403375_sp_nu @ A @ D )] :
      ( ( stream1017682031_sp_nu @ B @ D @ A @ R @ A2 @ B2 )
     => ~ ( ! [Xa3: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
              ( ( A2
                = ( stream1686501333_nu_In @ A @ B @ Xa3 ) )
             => ! [Ya2: ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) )] :
                  ( ( B2
                    = ( stream1686501333_nu_In @ A @ D @ Ya2 ) )
                 => ~ ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ Xa3 @ Ya2 ) ) ) ) ) )).

% sp\<^sub>\<nu>.rel_cases
thf(fact_179_sp_092_060_094sub_062_092_060mu_062_Orel__cases,axiom,(
    ! [E: $tType,B: $tType,A: $tType,C: $tType,F3: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),A2: ( stream901396144_sp_mu @ A @ B @ C ),B2: ( stream901396144_sp_mu @ A @ E @ F3 )] :
      ( ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 @ A2 @ B2 )
     => ( ! [X2: ( A > ( stream901396144_sp_mu @ A @ B @ C ) )] :
            ( ( A2
              = ( stream1294929701mu_Get @ A @ B @ C @ X2 ) )
           => ! [Y4: ( A > ( stream901396144_sp_mu @ A @ E @ F3 ) )] :
                ( ( B2
                  = ( stream1294929701mu_Get @ A @ E @ F3 @ Y4 ) )
               => ~ ( bNF_rel_fun @ A @ A @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 )
                    @ ^ [Y3: A,Z: A] : ( Y3 = Z )
                    @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 )
                    @ X2
                    @ Y4 ) ) )
       => ~ ( ! [X1a: B,X23: C] :
                ( ( A2
                  = ( stream1370332830mu_Put @ B @ C @ A @ X1a @ X23 ) )
               => ! [Y1a: E,Y23: F3] :
                    ( ( B2
                      = ( stream1370332830mu_Put @ E @ F3 @ A @ Y1a @ Y23 ) )
                   => ( ( R1 @ X1a @ Y1a )
                     => ~ ( R2 @ X23 @ Y23 ) ) ) ) ) ) ) )).

% sp\<^sub>\<mu>.rel_cases
thf(fact_180_type__definition_ORep__range,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A3: ( set @ A )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A3 )
     => ( ( image @ B @ A @ Rep @ ( top_top @ ( set @ B ) ) )
        = A3 ) ) )).

% type_definition.Rep_range
thf(fact_181_type__definition_OAbs__image,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A3: ( set @ A )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A3 )
     => ( ( image @ A @ B @ Abs @ A3 )
        = ( top_top @ ( set @ B ) ) ) ) )).

% type_definition.Abs_image
thf(fact_182_Abs__transfer,axiom,(
    ! [B: $tType,A: $tType,C: $tType,D: $tType,Rep1: ( A > B ),Abs1: ( B > A ),Rep22: ( C > D ),Abs22: ( D > C ),R: ( B > D > $o )] :
      ( ( type_definition @ A @ B @ Rep1 @ Abs1 @ ( top_top @ ( set @ B ) ) )
     => ( ( type_definition @ C @ D @ Rep22 @ Abs22 @ ( top_top @ ( set @ D ) ) )
       => ( bNF_rel_fun @ B @ D @ A @ C @ R @ ( bNF_vimage2p @ A @ B @ C @ D @ $o @ Rep1 @ Rep22 @ R ) @ Abs1 @ Abs22 ) ) ) )).

% Abs_transfer
thf(fact_183_sp_092_060_094sub_062_092_060nu_062_Opred__transfer,axiom,(
    ! [A: $tType,D: $tType,B: $tType,R: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( stream1273403375_sp_nu @ D @ A ) > $o ) @ ( ( stream1273403375_sp_nu @ D @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( stream1273403375_sp_nu @ D @ A ) @ ( stream1273403375_sp_nu @ D @ B ) @ $o @ $o @ ( stream1017682031_sp_nu @ A @ B @ D @ R )
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( stream1465372679_sp_nu @ A @ D )
      @ ( stream1465372679_sp_nu @ B @ D ) ) )).

% sp\<^sub>\<nu>.pred_transfer
thf(fact_184_sp_092_060_094sub_062_092_060nu_062_Orel__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,E: $tType,C: $tType,Sa: ( A > C > $o ),Sc: ( B > E > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > E > $o ) @ ( ( stream1273403375_sp_nu @ D @ A ) > ( stream1273403375_sp_nu @ D @ B ) > $o ) @ ( ( stream1273403375_sp_nu @ D @ C ) > ( stream1273403375_sp_nu @ D @ E ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( E > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ E @ $o @ $o @ Sc
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( stream1273403375_sp_nu @ D @ A ) @ ( stream1273403375_sp_nu @ D @ C ) @ ( ( stream1273403375_sp_nu @ D @ B ) > $o ) @ ( ( stream1273403375_sp_nu @ D @ E ) > $o ) @ ( stream1017682031_sp_nu @ A @ C @ D @ Sa )
        @ ( bNF_rel_fun @ ( stream1273403375_sp_nu @ D @ B ) @ ( stream1273403375_sp_nu @ D @ E ) @ $o @ $o @ ( stream1017682031_sp_nu @ B @ E @ D @ Sc )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( stream1017682031_sp_nu @ A @ B @ D )
      @ ( stream1017682031_sp_nu @ C @ E @ D ) ) )).

% sp\<^sub>\<nu>.rel_transfer
thf(fact_185_sp_092_060_094sub_062_092_060mu_062_Orel__transfer,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,G: $tType,I: $tType,F3: $tType,H2: $tType,E: $tType,S1a: ( A > E > $o ),S1c: ( C > H2 > $o ),S2a: ( B > F3 > $o ),S2c: ( D > I > $o )] :
      ( bNF_rel_fun @ ( A > C > $o ) @ ( E > H2 > $o ) @ ( ( B > D > $o ) > ( stream901396144_sp_mu @ G @ A @ B ) > ( stream901396144_sp_mu @ G @ C @ D ) > $o ) @ ( ( F3 > I > $o ) > ( stream901396144_sp_mu @ G @ E @ F3 ) > ( stream901396144_sp_mu @ G @ H2 @ I ) > $o )
      @ ( bNF_rel_fun @ A @ E @ ( C > $o ) @ ( H2 > $o ) @ S1a
        @ ( bNF_rel_fun @ C @ H2 @ $o @ $o @ S1c
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( B > D > $o ) @ ( F3 > I > $o ) @ ( ( stream901396144_sp_mu @ G @ A @ B ) > ( stream901396144_sp_mu @ G @ C @ D ) > $o ) @ ( ( stream901396144_sp_mu @ G @ E @ F3 ) > ( stream901396144_sp_mu @ G @ H2 @ I ) > $o )
        @ ( bNF_rel_fun @ B @ F3 @ ( D > $o ) @ ( I > $o ) @ S2a
          @ ( bNF_rel_fun @ D @ I @ $o @ $o @ S2c
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ G @ A @ B ) @ ( stream901396144_sp_mu @ G @ E @ F3 ) @ ( ( stream901396144_sp_mu @ G @ C @ D ) > $o ) @ ( ( stream901396144_sp_mu @ G @ H2 @ I ) > $o ) @ ( stream1924447089_sp_mu @ A @ E @ B @ F3 @ G @ S1a @ S2a )
          @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ G @ C @ D ) @ ( stream901396144_sp_mu @ G @ H2 @ I ) @ $o @ $o @ ( stream1924447089_sp_mu @ C @ H2 @ D @ I @ G @ S1c @ S2c )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) ) )
      @ ( stream1924447089_sp_mu @ A @ C @ B @ D @ G )
      @ ( stream1924447089_sp_mu @ E @ H2 @ F3 @ I @ G ) ) )).

% sp\<^sub>\<mu>.rel_transfer
thf(fact_186_sp_092_060_094sub_062_092_060nu_062_Ocase__transfer,axiom,(
    ! [B: $tType,E: $tType,F3: $tType,D: $tType,A: $tType,R: ( B > D > $o ),S2: ( E > F3 > $o )] :
      ( bNF_rel_fun @ ( ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) > E ) @ ( ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) ) > F3 ) @ ( ( stream1273403375_sp_nu @ A @ B ) > E ) @ ( ( stream1273403375_sp_nu @ A @ D ) > F3 ) @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) @ ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) ) @ E @ F3 @ ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) ) @ S2 ) @ ( bNF_rel_fun @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ E @ F3 @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ S2 ) @ ( stream1502363800_sp_nu @ A @ B @ E ) @ ( stream1502363800_sp_nu @ A @ D @ F3 ) ) )).

% sp\<^sub>\<nu>.case_transfer
thf(fact_187_sp_092_060_094sub_062_092_060mu_062_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,G: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( C > $o ) @ ( ( B > $o ) > ( stream901396144_sp_mu @ G @ A @ B ) > $o ) @ ( ( D > $o ) > ( stream901396144_sp_mu @ G @ C @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ $o @ $o @ R1
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( B > $o ) @ ( D > $o ) @ ( ( stream901396144_sp_mu @ G @ A @ B ) > $o ) @ ( ( stream901396144_sp_mu @ G @ C @ D ) > $o )
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ R2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ G @ A @ B ) @ ( stream901396144_sp_mu @ G @ C @ D ) @ $o @ $o @ ( stream1924447089_sp_mu @ A @ C @ B @ D @ G @ R1 @ R2 )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( stream123009735_sp_mu @ A @ B @ G )
      @ ( stream123009735_sp_mu @ C @ D @ G ) ) )).

% sp\<^sub>\<mu>.pred_transfer
thf(fact_188_vimage2pI,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,R: ( A > B > $o ),F: ( C > A ),X: C,G3: ( D > B ),Y: D] :
      ( ( R @ ( F @ X ) @ ( G3 @ Y ) )
     => ( bNF_vimage2p @ C @ A @ D @ B @ $o @ F @ G3 @ R @ X @ Y ) ) )).

% vimage2pI
thf(fact_189_vimage2p__comp,axiom,(
    ! [E: $tType,D: $tType,F3: $tType,A: $tType,C: $tType,B: $tType,G: $tType,F1: ( F3 > A ),F2: ( D > F3 ),G1: ( G > B ),G2: ( E > G )] :
      ( ( bNF_vimage2p @ D @ A @ E @ B @ C @ ( comp @ F3 @ A @ D @ F1 @ F2 ) @ ( comp @ G @ B @ E @ G1 @ G2 ) )
      = ( comp @ ( F3 > G > C ) @ ( D > E > C ) @ ( A > B > C ) @ ( bNF_vimage2p @ D @ F3 @ E @ G @ C @ F2 @ G2 ) @ ( bNF_vimage2p @ F3 @ A @ G @ B @ C @ F1 @ G1 ) ) ) )).

% vimage2p_comp
thf(fact_190_sp_092_060_094sub_062_092_060mu_062_Octr__transfer_I2_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F3: $tType,E: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o )] :
      ( bNF_rel_fun @ B @ E @ ( C > ( stream901396144_sp_mu @ A @ B @ C ) ) @ ( F3 > ( stream901396144_sp_mu @ A @ E @ F3 ) ) @ R1 @ ( bNF_rel_fun @ C @ F3 @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ R2 @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 ) ) @ ( stream1370332830mu_Put @ B @ C @ A ) @ ( stream1370332830mu_Put @ E @ F3 @ A ) ) )).

% sp\<^sub>\<mu>.ctr_transfer(2)
thf(fact_191_sp_092_060_094sub_062_092_060nu_062_Octr__transfer,axiom,(
    ! [B: $tType,D: $tType,A: $tType,R: ( B > D > $o )] :
      ( bNF_rel_fun @ ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ) @ ( stream901396144_sp_mu @ A @ D @ ( stream1273403375_sp_nu @ A @ D ) ) @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ ( stream1924447089_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ R @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) ) @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ ( stream1686501333_nu_In @ A @ B ) @ ( stream1686501333_nu_In @ A @ D ) ) )).

% sp\<^sub>\<nu>.ctr_transfer
thf(fact_192_sp_092_060_094sub_062_092_060mu_062_Orec__transfer,axiom,(
    ! [B: $tType,C: $tType,G: $tType,H2: $tType,F3: $tType,E: $tType,A: $tType,R1: ( B > E > $o ),R2: ( C > F3 > $o ),S2: ( G > H2 > $o )] :
      ( bNF_rel_fun @ ( ( A > ( product_prod @ ( stream901396144_sp_mu @ A @ B @ C ) @ G ) ) > G ) @ ( ( A > ( product_prod @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ H2 ) ) > H2 ) @ ( ( B > C > G ) > ( stream901396144_sp_mu @ A @ B @ C ) > G ) @ ( ( E > F3 > H2 ) > ( stream901396144_sp_mu @ A @ E @ F3 ) > H2 )
      @ ( bNF_rel_fun @ ( A > ( product_prod @ ( stream901396144_sp_mu @ A @ B @ C ) @ G ) ) @ ( A > ( product_prod @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ H2 ) ) @ G @ H2
        @ ( bNF_rel_fun @ A @ A @ ( product_prod @ ( stream901396144_sp_mu @ A @ B @ C ) @ G ) @ ( product_prod @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ H2 )
          @ ^ [Y3: A,Z: A] : ( Y3 = Z )
          @ ( basic_rel_prod @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ G @ H2 @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 ) @ S2 ) )
        @ S2 )
      @ ( bNF_rel_fun @ ( B > C > G ) @ ( E > F3 > H2 ) @ ( ( stream901396144_sp_mu @ A @ B @ C ) > G ) @ ( ( stream901396144_sp_mu @ A @ E @ F3 ) > H2 ) @ ( bNF_rel_fun @ B @ E @ ( C > G ) @ ( F3 > H2 ) @ R1 @ ( bNF_rel_fun @ C @ F3 @ G @ H2 @ R2 @ S2 ) ) @ ( bNF_rel_fun @ ( stream901396144_sp_mu @ A @ B @ C ) @ ( stream901396144_sp_mu @ A @ E @ F3 ) @ G @ H2 @ ( stream1924447089_sp_mu @ B @ E @ C @ F3 @ A @ R1 @ R2 ) @ S2 ) )
      @ ( stream674629690_sp_mu @ A @ B @ C @ G )
      @ ( stream674629690_sp_mu @ A @ E @ F3 @ H2 ) ) )).

% sp\<^sub>\<mu>.rec_transfer
thf(fact_193_BNF__Composition_Otype__definition__id__bnf__UNIV,axiom,(
    ! [A: $tType] :
      ( type_definition @ A @ A @ ( bNF_id_bnf @ A ) @ ( bNF_id_bnf @ A ) @ ( top_top @ ( set @ A ) ) ) )).

% BNF_Composition.type_definition_id_bnf_UNIV
thf(fact_194_sp_092_060_094sub_062_092_060nu_062_Opred__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,Q: ( B > $o ),F: ( A > B ),X: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream1465372679_sp_nu @ B @ D @ Q @ ( stream151454380_sp_nu @ A @ B @ D @ F @ X ) )
      = ( stream1465372679_sp_nu @ A @ D @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) )).

% sp\<^sub>\<nu>.pred_map
thf(fact_195_prod_Orel__transfer,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,H2: $tType,F3: $tType,G: $tType,E: $tType,S1a: ( A > E > $o ),S1c: ( C > G > $o ),S2a: ( B > F3 > $o ),S2c: ( D > H2 > $o )] :
      ( bNF_rel_fun @ ( A > C > $o ) @ ( E > G > $o ) @ ( ( B > D > $o ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) > $o ) @ ( ( F3 > H2 > $o ) > ( product_prod @ E @ F3 ) > ( product_prod @ G @ H2 ) > $o )
      @ ( bNF_rel_fun @ A @ E @ ( C > $o ) @ ( G > $o ) @ S1a
        @ ( bNF_rel_fun @ C @ G @ $o @ $o @ S1c
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( B > D > $o ) @ ( F3 > H2 > $o ) @ ( ( product_prod @ A @ B ) > ( product_prod @ C @ D ) > $o ) @ ( ( product_prod @ E @ F3 ) > ( product_prod @ G @ H2 ) > $o )
        @ ( bNF_rel_fun @ B @ F3 @ ( D > $o ) @ ( H2 > $o ) @ S2a
          @ ( bNF_rel_fun @ D @ H2 @ $o @ $o @ S2c
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( product_prod @ A @ B ) @ ( product_prod @ E @ F3 ) @ ( ( product_prod @ C @ D ) > $o ) @ ( ( product_prod @ G @ H2 ) > $o ) @ ( basic_rel_prod @ A @ E @ B @ F3 @ S1a @ S2a )
          @ ( bNF_rel_fun @ ( product_prod @ C @ D ) @ ( product_prod @ G @ H2 ) @ $o @ $o @ ( basic_rel_prod @ C @ G @ D @ H2 @ S1c @ S2c )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) ) )
      @ ( basic_rel_prod @ A @ C @ B @ D )
      @ ( basic_rel_prod @ E @ G @ F3 @ H2 ) ) )).

% prod.rel_transfer
thf(fact_196_sp_092_060_094sub_062_092_060nu_062_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G3: ( B > C ),F: ( A > B ),V: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream151454380_sp_nu @ B @ C @ D @ G3 @ ( stream151454380_sp_nu @ A @ B @ D @ F @ V ) )
      = ( stream151454380_sp_nu @ A @ C @ D @ ( comp @ B @ C @ A @ G3 @ F ) @ V ) ) )).

% sp\<^sub>\<nu>.map_comp
thf(fact_197_prod_Orel__eq,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( basic_rel_prod @ A @ A @ B @ B
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) )
      = ( ^ [Y3: ( product_prod @ A @ B ),Z: ( product_prod @ A @ B )] : ( Y3 = Z ) ) ) )).

% prod.rel_eq
thf(fact_198_prod_Orel__refl,axiom,(
    ! [D: $tType,C: $tType,R1a: ( C > C > $o ),R2a: ( D > D > $o ),X: ( product_prod @ C @ D )] :
      ( ! [X2: C] :
          ( R1a @ X2 @ X2 )
     => ( ! [X2: D] :
            ( R2a @ X2 @ X2 )
       => ( basic_rel_prod @ C @ C @ D @ D @ R1a @ R2a @ X @ X ) ) ) )).

% prod.rel_refl
thf(fact_199_sp_092_060_094sub_062_092_060nu_062_Omap,axiom,(
    ! [D: $tType,B: $tType,A: $tType,F: ( B > D ),X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( stream151454380_sp_nu @ B @ D @ A @ F @ ( stream1686501333_nu_In @ A @ B @ X ) )
      = ( stream1686501333_nu_In @ A @ D @ ( stream1058219438_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ F @ ( stream151454380_sp_nu @ B @ D @ A @ F ) @ X ) ) ) )).

% sp\<^sub>\<nu>.map
thf(fact_200_sp_092_060_094sub_062_092_060nu_062_Omap__sel,axiom,(
    ! [D: $tType,B: $tType,A: $tType,F: ( B > D ),A2: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( stream1200245950nu_out @ A @ D @ ( stream151454380_sp_nu @ B @ D @ A @ F @ A2 ) )
      = ( stream1058219438_sp_mu @ B @ D @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ A @ F @ ( stream151454380_sp_nu @ B @ D @ A @ F ) @ ( stream1200245950nu_out @ A @ B @ A2 ) ) ) )).

% sp\<^sub>\<nu>.map_sel
thf(fact_201_ID_Opred__map,axiom,(
    ! [B: $tType,A: $tType,Q: ( B > $o ),F: ( A > B ),X: A] :
      ( ( bNF_id_bnf @ ( B > $o ) @ Q @ ( bNF_id_bnf @ ( A > B ) @ F @ X ) )
      = ( bNF_id_bnf @ ( A > $o ) @ ( comp @ B @ $o @ A @ Q @ F ) @ X ) ) )).

% ID.pred_map
thf(fact_202_sp_092_060_094sub_062_092_060nu_062_Omap__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,G: $tType,F3: $tType,Rb: ( A > F3 > $o ),Sd: ( B > G > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( F3 > G ) @ ( ( stream1273403375_sp_nu @ D @ A ) > ( stream1273403375_sp_nu @ D @ B ) ) @ ( ( stream1273403375_sp_nu @ D @ F3 ) > ( stream1273403375_sp_nu @ D @ G ) ) @ ( bNF_rel_fun @ A @ F3 @ B @ G @ Rb @ Sd ) @ ( bNF_rel_fun @ ( stream1273403375_sp_nu @ D @ A ) @ ( stream1273403375_sp_nu @ D @ F3 ) @ ( stream1273403375_sp_nu @ D @ B ) @ ( stream1273403375_sp_nu @ D @ G ) @ ( stream1017682031_sp_nu @ A @ F3 @ D @ Rb ) @ ( stream1017682031_sp_nu @ B @ G @ D @ Sd ) ) @ ( stream151454380_sp_nu @ A @ B @ D ) @ ( stream151454380_sp_nu @ F3 @ G @ D ) ) )).

% sp\<^sub>\<nu>.map_transfer
thf(fact_203_sp_092_060_094sub_062_092_060nu_062_Ocorec__transfer,axiom,(
    ! [E: $tType,B: $tType,D: $tType,A: $tType,F3: $tType,S2: ( E > F3 > $o ),R: ( B > D > $o )] :
      ( bNF_rel_fun @ ( E > ( stream901396144_sp_mu @ A @ B @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ B ) @ E ) ) ) @ ( F3 > ( stream901396144_sp_mu @ A @ D @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ D ) @ F3 ) ) ) @ ( E > ( stream1273403375_sp_nu @ A @ B ) ) @ ( F3 > ( stream1273403375_sp_nu @ A @ D ) ) @ ( bNF_rel_fun @ E @ F3 @ ( stream901396144_sp_mu @ A @ B @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ B ) @ E ) ) @ ( stream901396144_sp_mu @ A @ D @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ D ) @ F3 ) ) @ S2 @ ( stream1924447089_sp_mu @ B @ D @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ B ) @ E ) @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ D ) @ F3 ) @ A @ R @ ( bNF_rel_sum @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ E @ F3 @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) @ S2 ) ) ) @ ( bNF_rel_fun @ E @ F3 @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1273403375_sp_nu @ A @ D ) @ S2 @ ( stream1017682031_sp_nu @ B @ D @ A @ R ) ) @ ( stream937840132_sp_nu @ E @ A @ B ) @ ( stream937840132_sp_nu @ F3 @ A @ D ) ) )).

% sp\<^sub>\<nu>.corec_transfer
thf(fact_204_sp_092_060_094sub_062_092_060nu_062_Opred__set,axiom,(
    ! [D: $tType,A: $tType] :
      ( ( stream1465372679_sp_nu @ A @ D )
      = ( ^ [P3: ( A > $o ),X3: ( stream1273403375_sp_nu @ D @ A )] :
          ! [Y2: A] :
            ( ( member @ A @ Y2 @ ( stream1493736486_sp_nu @ D @ A @ X3 ) )
           => ( P3 @ Y2 ) ) ) ) )).

% sp\<^sub>\<nu>.pred_set
thf(fact_205_sp_092_060_094sub_062_092_060nu_062_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( stream1273403375_sp_nu @ D @ A ),Xa: ( stream1273403375_sp_nu @ D @ A ),F: ( A > B ),Fa: ( A > B )] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X ) )
         => ( ( member @ A @ Za @ ( stream1493736486_sp_nu @ D @ A @ Xa ) )
           => ( ( ( F @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( stream151454380_sp_nu @ A @ B @ D @ F @ X )
          = ( stream151454380_sp_nu @ A @ B @ D @ Fa @ Xa ) )
       => ( X = Xa ) ) ) )).

% sp\<^sub>\<nu>.inj_map_strong
thf(fact_206_sp_092_060_094sub_062_092_060nu_062_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( stream1273403375_sp_nu @ D @ A ),F: ( A > B ),G3: ( A > B )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X ) )
         => ( ( F @ Z3 )
            = ( G3 @ Z3 ) ) )
     => ( ( stream151454380_sp_nu @ A @ B @ D @ F @ X )
        = ( stream151454380_sp_nu @ A @ B @ D @ G3 @ X ) ) ) )).

% sp\<^sub>\<nu>.map_cong0
thf(fact_207_sp_092_060_094sub_062_092_060nu_062_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X: ( stream1273403375_sp_nu @ D @ A ),Ya: ( stream1273403375_sp_nu @ D @ A ),F: ( A > B ),G3: ( A > B )] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ Ya ) )
           => ( ( F @ Z3 )
              = ( G3 @ Z3 ) ) )
       => ( ( stream151454380_sp_nu @ A @ B @ D @ F @ X )
          = ( stream151454380_sp_nu @ A @ B @ D @ G3 @ Ya ) ) ) ) )).

% sp\<^sub>\<nu>.map_cong
thf(fact_208_sum_Orel__transfer,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,H2: $tType,F3: $tType,G: $tType,E: $tType,S1a: ( A > E > $o ),S1c: ( C > G > $o ),S2a: ( B > F3 > $o ),S2c: ( D > H2 > $o )] :
      ( bNF_rel_fun @ ( A > C > $o ) @ ( E > G > $o ) @ ( ( B > D > $o ) > ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) > $o ) @ ( ( F3 > H2 > $o ) > ( sum_sum @ E @ F3 ) > ( sum_sum @ G @ H2 ) > $o )
      @ ( bNF_rel_fun @ A @ E @ ( C > $o ) @ ( G > $o ) @ S1a
        @ ( bNF_rel_fun @ C @ G @ $o @ $o @ S1c
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( bNF_rel_fun @ ( B > D > $o ) @ ( F3 > H2 > $o ) @ ( ( sum_sum @ A @ B ) > ( sum_sum @ C @ D ) > $o ) @ ( ( sum_sum @ E @ F3 ) > ( sum_sum @ G @ H2 ) > $o )
        @ ( bNF_rel_fun @ B @ F3 @ ( D > $o ) @ ( H2 > $o ) @ S2a
          @ ( bNF_rel_fun @ D @ H2 @ $o @ $o @ S2c
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
        @ ( bNF_rel_fun @ ( sum_sum @ A @ B ) @ ( sum_sum @ E @ F3 ) @ ( ( sum_sum @ C @ D ) > $o ) @ ( ( sum_sum @ G @ H2 ) > $o ) @ ( bNF_rel_sum @ A @ E @ B @ F3 @ S1a @ S2a )
          @ ( bNF_rel_fun @ ( sum_sum @ C @ D ) @ ( sum_sum @ G @ H2 ) @ $o @ $o @ ( bNF_rel_sum @ C @ G @ D @ H2 @ S1c @ S2c )
            @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) ) )
      @ ( bNF_rel_sum @ A @ C @ B @ D )
      @ ( bNF_rel_sum @ E @ G @ F3 @ H2 ) ) )).

% sum.rel_transfer
thf(fact_209_sp_092_060_094sub_062_092_060nu_062_Orel__refl__strong,axiom,(
    ! [A: $tType,B: $tType,X: ( stream1273403375_sp_nu @ B @ A ),Ra: ( A > A > $o )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ B @ A @ X ) )
         => ( Ra @ Z3 @ Z3 ) )
     => ( stream1017682031_sp_nu @ A @ A @ B @ Ra @ X @ X ) ) )).

% sp\<^sub>\<nu>.rel_refl_strong
thf(fact_210_sp_092_060_094sub_062_092_060nu_062_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,R: ( A > B > $o ),X: ( stream1273403375_sp_nu @ D @ A ),Y: ( stream1273403375_sp_nu @ D @ B ),Ra: ( A > B > $o )] :
      ( ( stream1017682031_sp_nu @ A @ B @ D @ R @ X @ Y )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X ) )
           => ( ( member @ B @ Yb @ ( stream1493736486_sp_nu @ D @ B @ Y ) )
             => ( ( R @ Z3 @ Yb )
               => ( Ra @ Z3 @ Yb ) ) ) )
       => ( stream1017682031_sp_nu @ A @ B @ D @ Ra @ X @ Y ) ) ) )).

% sp\<^sub>\<nu>.rel_mono_strong
thf(fact_211_sp_092_060_094sub_062_092_060nu_062_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,X: ( stream1273403375_sp_nu @ D @ A ),Ya: ( stream1273403375_sp_nu @ D @ A ),Y: ( stream1273403375_sp_nu @ D @ B ),Xa: ( stream1273403375_sp_nu @ D @ B ),R: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( X = Ya )
     => ( ( Y = Xa )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ Ya ) )
             => ( ( member @ B @ Yb @ ( stream1493736486_sp_nu @ D @ B @ Xa ) )
               => ( ( R @ Z3 @ Yb )
                  = ( Ra @ Z3 @ Yb ) ) ) )
         => ( ( stream1017682031_sp_nu @ A @ B @ D @ R @ X @ Y )
            = ( stream1017682031_sp_nu @ A @ B @ D @ Ra @ Ya @ Xa ) ) ) ) ) )).

% sp\<^sub>\<nu>.rel_cong
thf(fact_212_sum_Orel__refl,axiom,(
    ! [D: $tType,C: $tType,R1a: ( C > C > $o ),R2a: ( D > D > $o ),X: ( sum_sum @ C @ D )] :
      ( ! [X2: C] :
          ( R1a @ X2 @ X2 )
     => ( ! [X2: D] :
            ( R2a @ X2 @ X2 )
       => ( bNF_rel_sum @ C @ C @ D @ D @ R1a @ R2a @ X @ X ) ) ) )).

% sum.rel_refl
thf(fact_213_sum_Orel__eq,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bNF_rel_sum @ A @ A @ B @ B
        @ ^ [Y3: A,Z: A] : ( Y3 = Z )
        @ ^ [Y3: B,Z: B] : ( Y3 = Z ) )
      = ( ^ [Y3: ( sum_sum @ A @ B ),Z: ( sum_sum @ A @ B )] : ( Y3 = Z ) ) ) )).

% sum.rel_eq
thf(fact_214_sp_092_060_094sub_062_092_060nu_062_Opred__mono__strong,axiom,(
    ! [A: $tType,D: $tType,P: ( A > $o ),X: ( stream1273403375_sp_nu @ D @ A ),Pa: ( A > $o )] :
      ( ( stream1465372679_sp_nu @ A @ D @ P @ X )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X ) )
           => ( ( P @ Z3 )
             => ( Pa @ Z3 ) ) )
       => ( stream1465372679_sp_nu @ A @ D @ Pa @ X ) ) ) )).

% sp\<^sub>\<nu>.pred_mono_strong
thf(fact_215_sp_092_060_094sub_062_092_060nu_062_Opred__cong,axiom,(
    ! [A: $tType,D: $tType,X: ( stream1273403375_sp_nu @ D @ A ),Ya: ( stream1273403375_sp_nu @ D @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ Ya ) )
           => ( ( P @ Z3 )
              = ( Pa @ Z3 ) ) )
       => ( ( stream1465372679_sp_nu @ A @ D @ P @ X )
          = ( stream1465372679_sp_nu @ A @ D @ Pa @ Ya ) ) ) ) )).

% sp\<^sub>\<nu>.pred_cong
thf(fact_216_sp_092_060_094sub_062_092_060nu_062_Oset__induct,axiom,(
    ! [A: $tType,Aa2: $tType,X: A,A2: ( stream1273403375_sp_nu @ Aa2 @ A ),P: ( A > ( stream1273403375_sp_nu @ Aa2 @ A ) > $o )] :
      ( ( member @ A @ X @ ( stream1493736486_sp_nu @ Aa2 @ A @ A2 ) )
     => ( ! [Z3: ( stream901396144_sp_mu @ Aa2 @ A @ ( stream1273403375_sp_nu @ Aa2 @ A ) ),Xa3: A] :
            ( ( member @ A @ Xa3 @ ( stream2074884121_sp_mu @ Aa2 @ A @ ( stream1273403375_sp_nu @ Aa2 @ A ) @ Z3 ) )
           => ( P @ Xa3 @ ( stream1686501333_nu_In @ Aa2 @ A @ Z3 ) ) )
       => ( ! [Z3: ( stream901396144_sp_mu @ Aa2 @ A @ ( stream1273403375_sp_nu @ Aa2 @ A ) ),Xb: ( stream1273403375_sp_nu @ Aa2 @ A ),Xc2: A] :
              ( ( member @ ( stream1273403375_sp_nu @ Aa2 @ A ) @ Xb @ ( stream1259315544_sp_mu @ Aa2 @ A @ ( stream1273403375_sp_nu @ Aa2 @ A ) @ Z3 ) )
             => ( ( member @ A @ Xc2 @ ( stream1493736486_sp_nu @ Aa2 @ A @ Xb ) )
               => ( ( P @ Xc2 @ Xb )
                 => ( P @ Xc2 @ ( stream1686501333_nu_In @ Aa2 @ A @ Z3 ) ) ) ) )
         => ( P @ X @ A2 ) ) ) ) )).

% sp\<^sub>\<nu>.set_induct
thf(fact_217_sp_092_060_094sub_062_092_060nu_062_Oset__cases,axiom,(
    ! [B: $tType,A: $tType,E2: B,A2: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( member @ B @ E2 @ ( stream1493736486_sp_nu @ A @ B @ A2 ) )
     => ( ! [Z3: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
            ( ( A2
              = ( stream1686501333_nu_In @ A @ B @ Z3 ) )
           => ~ ( member @ B @ E2 @ ( stream2074884121_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ Z3 ) ) )
       => ~ ( ! [Z3: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
                ( ( A2
                  = ( stream1686501333_nu_In @ A @ B @ Z3 ) )
               => ! [Xa3: ( stream1273403375_sp_nu @ A @ B )] :
                    ( ( member @ ( stream1273403375_sp_nu @ A @ B ) @ Xa3 @ ( stream1259315544_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ Z3 ) )
                   => ~ ( member @ B @ E2 @ ( stream1493736486_sp_nu @ A @ B @ Xa3 ) ) ) ) ) ) ) )).

% sp\<^sub>\<nu>.set_cases
thf(fact_218_sp_092_060_094sub_062_092_060nu_062_Oset__intros_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: B,A2: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( member @ B @ X @ ( stream2074884121_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ A2 ) )
     => ( member @ B @ X @ ( stream1493736486_sp_nu @ A @ B @ ( stream1686501333_nu_In @ A @ B @ A2 ) ) ) ) )).

% sp\<^sub>\<nu>.set_intros(1)
thf(fact_219_sp_092_060_094sub_062_092_060nu_062_Oset__intros_I2_J,axiom,(
    ! [B: $tType,A: $tType,Xa: ( stream1273403375_sp_nu @ A @ B ),A2: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) ),Xb2: B] :
      ( ( member @ ( stream1273403375_sp_nu @ A @ B ) @ Xa @ ( stream1259315544_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ A2 ) )
     => ( ( member @ B @ Xb2 @ ( stream1493736486_sp_nu @ A @ B @ Xa ) )
       => ( member @ B @ Xb2 @ ( stream1493736486_sp_nu @ A @ B @ ( stream1686501333_nu_In @ A @ B @ A2 ) ) ) ) ) )).

% sp\<^sub>\<nu>.set_intros(2)
thf(fact_220_sp_092_060_094sub_062_092_060nu_062_Oset__sel_I1_J,axiom,(
    ! [B: $tType,A: $tType,Xa: B,A2: ( stream1273403375_sp_nu @ A @ B )] :
      ( ( member @ B @ Xa @ ( stream2074884121_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1200245950nu_out @ A @ B @ A2 ) ) )
     => ( member @ B @ Xa @ ( stream1493736486_sp_nu @ A @ B @ A2 ) ) ) )).

% sp\<^sub>\<nu>.set_sel(1)
thf(fact_221_sp_092_060_094sub_062_092_060nu_062_Oset__sel_I2_J,axiom,(
    ! [B: $tType,A: $tType,Xb2: ( stream1273403375_sp_nu @ A @ B ),A2: ( stream1273403375_sp_nu @ A @ B ),Xc: B] :
      ( ( member @ ( stream1273403375_sp_nu @ A @ B ) @ Xb2 @ ( stream1259315544_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ ( stream1200245950nu_out @ A @ B @ A2 ) ) )
     => ( ( member @ B @ Xc @ ( stream1493736486_sp_nu @ A @ B @ Xb2 ) )
       => ( member @ B @ Xc @ ( stream1493736486_sp_nu @ A @ B @ A2 ) ) ) ) )).

% sp\<^sub>\<nu>.set_sel(2)
thf(fact_222_sp_092_060_094sub_062_092_060nu_062_Oset__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,F: ( A > B ),V: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream1493736486_sp_nu @ D @ B @ ( stream151454380_sp_nu @ A @ B @ D @ F @ V ) )
      = ( image @ A @ B @ F @ ( stream1493736486_sp_nu @ D @ A @ V ) ) ) )).

% sp\<^sub>\<nu>.set_map
thf(fact_223_prod_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( C > $o ) @ ( ( B > $o ) > ( product_prod @ A @ B ) > $o ) @ ( ( D > $o ) > ( product_prod @ C @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ $o @ $o @ R1
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( B > $o ) @ ( D > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( ( product_prod @ C @ D ) > $o )
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ R2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ $o @ $o @ ( basic_rel_prod @ A @ C @ B @ D @ R1 @ R2 )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( basic_pred_prod @ A @ B )
      @ ( basic_pred_prod @ C @ D ) ) )).

% prod.pred_transfer
thf(fact_224_sp_092_060_094sub_062_092_060nu_062_Oset,axiom,(
    ! [B: $tType,A: $tType,X: ( stream901396144_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) )] :
      ( ( stream1493736486_sp_nu @ A @ B @ ( stream1686501333_nu_In @ A @ B @ X ) )
      = ( sup_sup @ ( set @ B ) @ ( stream2074884121_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ X ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ ( stream1273403375_sp_nu @ A @ B ) @ ( set @ B ) @ ( stream1493736486_sp_nu @ A @ B ) @ ( stream1259315544_sp_mu @ A @ B @ ( stream1273403375_sp_nu @ A @ B ) @ X ) ) ) ) ) )).

% sp\<^sub>\<nu>.set
thf(fact_225_UnCI,axiom,(
    ! [A: $tType,C3: A,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( ~ ( member @ A @ C3 @ B3 )
       => ( member @ A @ C3 @ A3 ) )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% UnCI
thf(fact_226_Un__iff,axiom,(
    ! [A: $tType,C3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
      = ( ( member @ A @ C3 @ A3 )
        | ( member @ A @ C3 @ B3 ) ) ) )).

% Un_iff
thf(fact_227_Union__Un__distrib,axiom,(
    ! [A: $tType,A3: ( set @ ( set @ A ) ),B3: ( set @ ( set @ A ) )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) )).

% Union_Un_distrib
thf(fact_228_UnE,axiom,(
    ! [A: $tType,C3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
     => ( ~ ( member @ A @ C3 @ A3 )
       => ( member @ A @ C3 @ B3 ) ) ) )).

% UnE
thf(fact_229_UnI1,axiom,(
    ! [A: $tType,C3: A,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( member @ A @ C3 @ A3 )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% UnI1
thf(fact_230_UnI2,axiom,(
    ! [A: $tType,C3: A,B3: ( set @ A ),A3: ( set @ A )] :
      ( ( member @ A @ C3 @ B3 )
     => ( member @ A @ C3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% UnI2
thf(fact_231_bex__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ? [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
            & ( P @ X3 ) ) )
      = ( ? [X3: A] :
            ( ( member @ A @ X3 @ A3 )
            & ( P @ X3 ) )
        | ? [X3: A] :
            ( ( member @ A @ X3 @ B3 )
            & ( P @ X3 ) ) ) ) )).

% bex_Un
thf(fact_232_ball__Un,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),P: ( A > $o )] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
           => ( P @ X3 ) ) )
      = ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( P @ X3 ) )
        & ! [X3: A] :
            ( ( member @ A @ X3 @ B3 )
           => ( P @ X3 ) ) ) ) )).

% ball_Un
thf(fact_233_Un__assoc,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ C2 )
      = ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C2 ) ) ) )).

% Un_assoc
thf(fact_234_Un__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ A3 )
      = A3 ) )).

% Un_absorb
thf(fact_235_Un__commute,axiom,(
    ! [A: $tType] :
      ( ( sup_sup @ ( set @ A ) )
      = ( ^ [A4: ( set @ A ),B5: ( set @ A )] :
            ( sup_sup @ ( set @ A ) @ B5 @ A4 ) ) ) )).

% Un_commute
thf(fact_236_Un__left__absorb,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) )).

% Un_left_absorb
thf(fact_237_Un__left__commute,axiom,(
    ! [A: $tType,A3: ( set @ A ),B3: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C2 ) )
      = ( sup_sup @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A3 @ C2 ) ) ) )).

% Un_left_commute
thf(fact_238_Un__UNIV__left,axiom,(
    ! [A: $tType,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ B3 )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_left
thf(fact_239_Un__UNIV__right,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% Un_UNIV_right
thf(fact_240_Sup__union__distrib,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A3: ( set @ A ),B3: ( set @ A )] :
          ( ( complete_Sup_Sup @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
          = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) )).

% Sup_union_distrib
thf(fact_241_image__Un,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A3: ( set @ B ),B3: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ ( image @ B @ A @ F @ A3 ) @ ( image @ B @ A @ F @ B3 ) ) ) )).

% image_Un
thf(fact_242_sup__top__left,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) )).

% sup_top_left
thf(fact_243_sup__top__right,axiom,(
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A @ ( type2 @ A ) )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) )).

% sup_top_right
thf(fact_244_sum_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( C > $o ) @ ( ( B > $o ) > ( sum_sum @ A @ B ) > $o ) @ ( ( D > $o ) > ( sum_sum @ C @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ $o @ $o @ R1
        @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
      @ ( bNF_rel_fun @ ( B > $o ) @ ( D > $o ) @ ( ( sum_sum @ A @ B ) > $o ) @ ( ( sum_sum @ C @ D ) > $o )
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ R2
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) )
        @ ( bNF_rel_fun @ ( sum_sum @ A @ B ) @ ( sum_sum @ C @ D ) @ $o @ $o @ ( bNF_rel_sum @ A @ C @ B @ D @ R1 @ R2 )
          @ ^ [Y3: $o,Z: $o] : ( Y3 = Z ) ) )
      @ ( basic_pred_sum @ A @ B )
      @ ( basic_pred_sum @ C @ D ) ) )).

% sum.pred_transfer
thf(fact_245_Pow__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( pow @ A @ ( insert @ A @ A2 @ A3 ) )
      = ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow @ A @ A3 ) @ ( image @ ( set @ A ) @ ( set @ A ) @ ( insert @ A @ A2 ) @ ( pow @ A @ A3 ) ) ) ) )).

% Pow_insert
thf(fact_246_insertCI,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B3 )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B3 ) ) ) )).

% insertCI
thf(fact_247_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A3 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_248_insert__absorb2,axiom,(
    ! [A: $tType,X: A,A3: ( set @ A )] :
      ( ( insert @ A @ X @ ( insert @ A @ X @ A3 ) )
      = ( insert @ A @ X @ A3 ) ) )).

% insert_absorb2
thf(fact_249_image__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),A2: B,B3: ( set @ B )] :
      ( ( image @ B @ A @ F @ ( insert @ B @ A2 @ B3 ) )
      = ( insert @ A @ ( F @ A2 ) @ ( image @ B @ A @ F @ B3 ) ) ) )).

% image_insert
thf(fact_250_insert__image,axiom,(
    ! [B: $tType,A: $tType,X: A,A3: ( set @ A ),F: ( A > B )] :
      ( ( member @ A @ X @ A3 )
     => ( ( insert @ B @ ( F @ X ) @ ( image @ A @ B @ F @ A3 ) )
        = ( image @ A @ B @ F @ A3 ) ) ) )).

% insert_image
thf(fact_251_Un__insert__left,axiom,(
    ! [A: $tType,A2: A,B3: ( set @ A ),C2: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ A2 @ B3 ) @ C2 )
      = ( insert @ A @ A2 @ ( sup_sup @ ( set @ A ) @ B3 @ C2 ) ) ) )).

% Un_insert_left
thf(fact_252_Un__insert__right,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A,B3: ( set @ A )] :
      ( ( sup_sup @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B3 ) )
      = ( insert @ A @ A2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) )).

% Un_insert_right
thf(fact_253_Sup__insert,axiom,(
    ! [A: $tType] :
      ( ( comple187826305attice @ A @ ( type2 @ A ) )
     => ! [A2: A,A3: ( set @ A )] :
          ( ( complete_Sup_Sup @ A @ ( insert @ A @ A2 @ A3 ) )
          = ( sup_sup @ A @ A2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) )).

% Sup_insert
thf(fact_254_Union__insert,axiom,(
    ! [A: $tType,A2: ( set @ A ),B3: ( set @ ( set @ A ) )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( insert @ ( set @ A ) @ A2 @ B3 ) )
      = ( sup_sup @ ( set @ A ) @ A2 @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) )).

% Union_insert
thf(fact_255_Union__image__insert,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( set @ A ) ),A2: B,B3: ( set @ B )] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F @ ( insert @ B @ A2 @ B3 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( F @ A2 ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F @ B3 ) ) ) ) )).

% Union_image_insert

%----Type constructors (16)
thf(tcon_HOL_Obool___Lattices_Obounded__lattice,axiom,
    ( bounded_lattice @ $o @ ( type2 @ $o ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_1,axiom,(
    ! [A6: $tType] :
      ( bounded_lattice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice_2,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounded_lattice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( comple187826305attice @ A7 @ ( type2 @ A7 ) )
     => ( comple187826305attice @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( bounded_lattice @ A7 @ ( type2 @ A7 ) )
     => ( bounded_lattice_top @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Complete__Lattices_OSup,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( complete_Sup @ A7 @ ( type2 @ A7 ) )
     => ( complete_Sup @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Otop,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( top @ A7 @ ( type2 @ A7 ) )
     => ( top @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Complete__Lattices_OSup_3,axiom,
    ( complete_Sup @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_4,axiom,(
    ! [A6: $tType] :
      ( comple187826305attice @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_5,axiom,(
    ! [A6: $tType] :
      ( bounded_lattice_top @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Complete__Lattices_OSup_6,axiom,(
    ! [A6: $tType] :
      ( complete_Sup @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Otop_7,axiom,(
    ! [A6: $tType] :
      ( top @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_8,axiom,
    ( comple187826305attice @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_9,axiom,
    ( bounded_lattice_top @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Complete__Lattices_OSup_10,axiom,
    ( complete_Sup @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Otop_11,axiom,
    ( top @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( stream377071682run_nu @ a @ a @ ( stream2017582925e_copy @ a ) @ s )
    = s )).

%------------------------------------------------------------------------------
