%------------------------------------------------------------------------------
% File     : DAT258^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Data structure for translators from streams to streams 166
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : stream_processor__166.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  315 (   0 unit;  55 type;   0 defn)
%            Number of atoms       : 5391 ( 337 equality;3820 variable)
%            Maximal formula depth :   32 (  13 average)
%            Number of connectives : 4864 (  32   ~;   1   |;  11   &;4641   @)
%                                         (   0 <=>; 179  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  695 ( 695   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   59 (  55   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1640 (   0 sgn;1447   !;  11   ?;  80   ^)
%                                         (1640   :; 102  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:39:39.033
%------------------------------------------------------------------------------
%----Could-be-implicit typings (10)
thf(ty_t_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062,type,(
    stream1273403375_sp_nu: $tType > $tType > $tType )).

thf(ty_t_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060mu_062,type,(
    stream901396144_sp_mu: $tType > $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Sum__Type_Osum,type,(
    sum_sum: $tType > $tType > $tType )).

thf(ty_t_Stream_Ostream,type,(
    stream: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_c,type,(
    c: $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (45)
thf(sy_c_BNF__Composition_Oid__bnf,type,(
    bNF_id_bnf: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_BNF__Def_OGrp,type,(
    bNF_Grp: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > B ) > A > B > $o ) )).

thf(sy_c_BNF__Def_Oconvol,type,(
    bNF_convol: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B ) > ( A > C ) > A > ( product_prod @ B @ C ) ) )).

thf(sy_c_BNF__Def_Ocsquare,type,(
    bNF_csquare: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( set @ A ) > ( B > C ) > ( D > C ) > ( A > B ) > ( A > D ) > $o ) )).

thf(sy_c_BNF__Def_OfstOp,type,(
    bNF_fstOp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > ( product_prod @ A @ C ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Def_Opick__middlep,type,(
    bNF_pick_middlep: 
      !>[B: $tType,A: $tType,C: $tType] :
        ( ( B > A > $o ) > ( A > C > $o ) > B > C > A ) )).

thf(sy_c_BNF__Def_OsndOp,type,(
    bNF_sndOp: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( C > A > $o ) > ( A > B > $o ) > ( product_prod @ C @ B ) > ( product_prod @ A @ B ) ) )).

thf(sy_c_BNF__Def_Ovimage2p,type,(
    bNF_vimage2p: 
      !>[A: $tType,D: $tType,B: $tType,E: $tType,C: $tType] :
        ( ( A > D ) > ( B > E ) > ( D > E > C ) > A > B > C ) )).

thf(sy_c_Fun_Ocomp,type,(
    comp: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf(sy_c_Fun_Ofcomp,type,(
    fcomp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B ) > ( B > C ) > A > C ) )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_Fun_Oid,type,(
    id: 
      !>[A: $tType] :
        ( A > A ) )).

thf(sy_c_Fun_Omap__fun,type,(
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] :
        ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) )).

thf(sy_c_Fun_Oswap,type,(
    swap: 
      !>[A: $tType,B: $tType] :
        ( A > A > ( A > B ) > A > B ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,(
    ord_less_eq: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Otop__class_Otop,type,(
    top_top: 
      !>[A: $tType] : A )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Oapfst,type,(
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] :
        ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) )).

thf(sy_c_Product__Type_Oapsnd,type,(
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] :
        ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Omap__prod,type,(
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oprod_Ofst,type,(
    product_fst: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > A ) )).

thf(sy_c_Product__Type_Oprod_Osnd,type,(
    product_snd: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > B ) )).

thf(sy_c_Product__Type_Oprod_Oswap,type,(
    product_swap: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( product_prod @ B @ A ) ) )).

thf(sy_c_Pure_Otype,type,(
    type: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Quotient_OQuotient3,type,(
    quotient3: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ B ) ) )).

thf(sy_c_Set_Oimage,type,(
    image: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( set @ A ) > ( set @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Ocopy,type,(
    stream2017582925e_copy: 
      !>[A: $tType] :
        ( stream1273403375_sp_nu @ A @ A ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Orun_092_060_094sub_062_092_060nu_062,type,(
    stream377071682run_nu: 
      !>[A: $tType,B: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( stream @ A ) > ( stream @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Ocorec__sp_092_060_094sub_062_092_060nu_062,type,(
    stream937840132_sp_nu: 
      !>[E: $tType,A: $tType,B: $tType] :
        ( ( E > ( stream901396144_sp_mu @ A @ B @ ( sum_sum @ ( stream1273403375_sp_nu @ A @ B ) @ E ) ) ) > E > ( stream1273403375_sp_nu @ A @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Omap__sp_092_060_094sub_062_092_060nu_062,type,(
    stream151454380_sp_nu: 
      !>[B: $tType,Ba: $tType,A: $tType] :
        ( ( B > Ba ) > ( stream1273403375_sp_nu @ A @ B ) > ( stream1273403375_sp_nu @ A @ Ba ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Opred__sp_092_060_094sub_062_092_060nu_062,type,(
    stream1465372679_sp_nu: 
      !>[A: $tType,C: $tType] :
        ( ( A > $o ) > ( stream1273403375_sp_nu @ C @ A ) > $o ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062_Oset__sp_092_060_094sub_062_092_060nu_062,type,(
    stream1493736486_sp_nu: 
      !>[A: $tType,B: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062__comp,type,(
    stream1967106959u_comp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( stream1273403375_sp_nu @ C @ A ) > ( stream1273403375_sp_nu @ C @ B ) ) )).

thf(sy_c_Stream__Processor__Mirabelle__rrumbueyrq_Osp_092_060_094sub_062_092_060nu_062__comp2,type,(
    stream104478819_comp2: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( stream1273403375_sp_nu @ A @ B ) > ( stream1273403375_sp_nu @ C @ A ) > ( stream1273403375_sp_nu @ C @ B ) ) )).

thf(sy_c_Typedef_Otype__definition,type,(
    type_definition: 
      !>[B: $tType,A: $tType] :
        ( ( B > A ) > ( A > B ) > ( set @ A ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_sp,type,(
    sp: ( stream1273403375_sp_nu @ c @ b ) )).

thf(sy_v_sp_H,type,(
    sp2: ( stream1273403375_sp_nu @ a @ c ) )).

%----Relevant facts (256)
thf(fact_0_run_092_060_094sub_062_092_060nu_062__sp_092_060_094sub_062_092_060nu_062__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Sp: ( stream1273403375_sp_nu @ C @ B ),Sp2: ( stream1273403375_sp_nu @ A @ C )] :
      ( ( stream377071682run_nu @ A @ B @ ( stream1967106959u_comp @ C @ B @ A @ Sp @ Sp2 ) )
      = ( comp @ ( stream @ C ) @ ( stream @ B ) @ ( stream @ A ) @ ( stream377071682run_nu @ C @ B @ Sp ) @ ( stream377071682run_nu @ A @ C @ Sp2 ) ) ) )).

% run\<^sub>\<nu>_sp\<^sub>\<nu>_comp
thf(fact_1_run_092_060_094sub_062_092_060nu_062__sp_092_060_094sub_062_092_060nu_062__comp2,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Sp: ( stream1273403375_sp_nu @ C @ B ),Sp2: ( stream1273403375_sp_nu @ A @ C )] :
      ( ( stream377071682run_nu @ A @ B @ ( stream104478819_comp2 @ C @ B @ A @ Sp @ Sp2 ) )
      = ( comp @ ( stream @ C ) @ ( stream @ B ) @ ( stream @ A ) @ ( stream377071682run_nu @ C @ B @ Sp ) @ ( stream377071682run_nu @ A @ C @ Sp2 ) ) ) )).

% run\<^sub>\<nu>_sp\<^sub>\<nu>_comp2
thf(fact_2_sp_092_060_094sub_062_092_060nu_062_Ocorec__disc,axiom,(
    ! [B: $tType,A: $tType,E: $tType] :
      ( ( stream937840132_sp_nu @ E @ A @ B )
      = ( stream937840132_sp_nu @ E @ A @ B ) ) )).

% sp\<^sub>\<nu>.corec_disc
thf(fact_3_comp__apply,axiom,(
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comp @ B @ A @ C )
      = ( ^ [F: ( B > A ),G: ( C > B ),X: C] :
            ( F @ ( G @ X ) ) ) ) )).

% comp_apply
thf(fact_4_run_092_060_094sub_062_092_060nu_062__copy,axiom,(
    ! [A: $tType,S: ( stream @ A )] :
      ( ( stream377071682run_nu @ A @ A @ ( stream2017582925e_copy @ A ) @ S )
      = S ) )).

% run\<^sub>\<nu>_copy
thf(fact_5_comp__def,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( comp @ B @ C @ A )
      = ( ^ [F: ( B > C ),G: ( A > B ),X: A] :
            ( F @ ( G @ X ) ) ) ) )).

% comp_def
thf(fact_6_comp__assoc,axiom,(
    ! [B: $tType,D: $tType,C: $tType,A: $tType,F2: ( D > B ),G2: ( C > D ),H: ( A > C )] :
      ( ( comp @ C @ B @ A @ ( comp @ D @ B @ C @ F2 @ G2 ) @ H )
      = ( comp @ D @ B @ A @ F2 @ ( comp @ C @ D @ A @ G2 @ H ) ) ) )).

% comp_assoc
thf(fact_7_comp__eq__dest,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ ( D2 @ V ) ) ) ) )).

% comp_eq_dest
thf(fact_8_comp__eq__elim,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( D > B ),D2: ( A > D )] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ D @ B @ A @ C2 @ D2 ) )
     => ! [V2: A] :
          ( ( A2 @ ( B2 @ V2 ) )
          = ( C2 @ ( D2 @ V2 ) ) ) ) )).

% comp_eq_elim
thf(fact_9_comp__cong,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E: $tType,F2: ( B > A ),G2: ( C > B ),X2: C,F3: ( D > A ),G3: ( E > D ),X3: E] :
      ( ( ( F2 @ ( G2 @ X2 ) )
        = ( F3 @ ( G3 @ X3 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X2 )
        = ( comp @ D @ A @ E @ F3 @ G3 @ X3 ) ) ) )).

% comp_cong
thf(fact_10_comp__eq__dest__lhs,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = C2 )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_dest_lhs
thf(fact_11_comp__apply__eq,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType,F2: ( B > A ),G2: ( C > B ),X2: C,H: ( D > A ),K: ( C > D )] :
      ( ( ( F2 @ ( G2 @ X2 ) )
        = ( H @ ( K @ X2 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G2 @ X2 )
        = ( comp @ D @ A @ C @ H @ K @ X2 ) ) ) )).

% comp_apply_eq
thf(fact_12_fun_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G2: ( B > C ),F2: ( A > B ),V: ( D > A )] :
      ( ( comp @ B @ C @ D @ G2 @ ( comp @ A @ B @ D @ F2 @ V ) )
      = ( comp @ A @ C @ D @ ( comp @ B @ C @ A @ G2 @ F2 ) @ V ) ) )).

% fun.map_comp
thf(fact_13_type__copy__map__cong0,axiom,(
    ! [B: $tType,D: $tType,E: $tType,A: $tType,C: $tType,M: ( B > A ),G2: ( C > B ),X2: C,N: ( D > A ),H: ( C > D ),F2: ( A > E )] :
      ( ( ( M @ ( G2 @ X2 ) )
        = ( N @ ( H @ X2 ) ) )
     => ( ( comp @ B @ E @ C @ ( comp @ A @ E @ B @ F2 @ M ) @ G2 @ X2 )
        = ( comp @ D @ E @ C @ ( comp @ A @ E @ D @ F2 @ N ) @ H @ X2 ) ) ) )).

% type_copy_map_cong0
thf(fact_14_rewriteL__comp__comp,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F2: ( C > B ),G2: ( A > C ),L: ( A > B ),H: ( D > A )] :
      ( ( ( comp @ C @ B @ A @ F2 @ G2 )
        = L )
     => ( ( comp @ C @ B @ D @ F2 @ ( comp @ A @ C @ D @ G2 @ H ) )
        = ( comp @ A @ B @ D @ L @ H ) ) ) )).

% rewriteL_comp_comp
thf(fact_15_rewriteR__comp__comp2,axiom,(
    ! [C: $tType,B: $tType,E: $tType,D: $tType,A: $tType,G2: ( C > B ),H: ( A > C ),R1: ( D > B ),R2: ( A > D ),F2: ( B > E ),L: ( D > E )] :
      ( ( ( comp @ C @ B @ A @ G2 @ H )
        = ( comp @ D @ B @ A @ R1 @ R2 ) )
     => ( ( ( comp @ B @ E @ D @ F2 @ R1 )
          = L )
       => ( ( comp @ C @ E @ A @ ( comp @ B @ E @ C @ F2 @ G2 ) @ H )
          = ( comp @ D @ E @ A @ L @ R2 ) ) ) ) )).

% rewriteR_comp_comp2
thf(fact_16_rewriteL__comp__comp2,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,E: $tType,F2: ( C > B ),G2: ( A > C ),L1: ( D > B ),L2: ( A > D ),H: ( E > A ),R: ( E > D )] :
      ( ( ( comp @ C @ B @ A @ F2 @ G2 )
        = ( comp @ D @ B @ A @ L1 @ L2 ) )
     => ( ( ( comp @ A @ D @ E @ L2 @ H )
          = R )
       => ( ( comp @ C @ B @ E @ F2 @ ( comp @ A @ C @ E @ G2 @ H ) )
          = ( comp @ D @ B @ E @ L1 @ R ) ) ) ) )).

% rewriteL_comp_comp2
thf(fact_17_rewriteR__comp__comp,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,G2: ( C > B ),H: ( A > C ),R: ( A > B ),F2: ( B > D )] :
      ( ( ( comp @ C @ B @ A @ G2 @ H )
        = R )
     => ( ( comp @ C @ D @ A @ ( comp @ B @ D @ C @ F2 @ G2 ) @ H )
        = ( comp @ B @ D @ A @ F2 @ R ) ) ) )).

% rewriteR_comp_comp
thf(fact_18_vimage2p__comp,axiom,(
    ! [E: $tType,D: $tType,F4: $tType,A: $tType,C: $tType,B: $tType,G4: $tType,F1: ( F4 > A ),F22: ( D > F4 ),G1: ( G4 > B ),G22: ( E > G4 )] :
      ( ( bNF_vimage2p @ D @ A @ E @ B @ C @ ( comp @ F4 @ A @ D @ F1 @ F22 ) @ ( comp @ G4 @ B @ E @ G1 @ G22 ) )
      = ( comp @ ( F4 > G4 > C ) @ ( D > E > C ) @ ( A > B > C ) @ ( bNF_vimage2p @ D @ F4 @ E @ G4 @ C @ F22 @ G22 ) @ ( bNF_vimage2p @ F4 @ A @ G4 @ B @ C @ F1 @ G1 ) ) ) )).

% vimage2p_comp
thf(fact_19_csquare__def,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType] :
      ( ( bNF_csquare @ A @ B @ C @ D )
      = ( ^ [A3: ( set @ A ),F12: ( B > C ),F23: ( D > C ),P1: ( A > B ),P2: ( A > D )] :
          ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( ( F12 @ ( P1 @ X ) )
              = ( F23 @ ( P2 @ X ) ) ) ) ) ) )).

% csquare_def
thf(fact_20_fcomp__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( fcomp @ A @ C @ B )
      = ( ^ [F: ( A > C ),G: ( C > B )] :
            ( comp @ C @ B @ A @ G @ F ) ) ) )).

% fcomp_comp
thf(fact_21_convol__o,axiom,(
    ! [B: $tType,C: $tType,D: $tType,A: $tType,F2: ( D > B ),G2: ( D > C ),H: ( A > D )] :
      ( ( comp @ D @ ( product_prod @ B @ C ) @ A @ ( bNF_convol @ D @ B @ C @ F2 @ G2 ) @ H )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ F2 @ H ) @ ( comp @ D @ C @ A @ G2 @ H ) ) ) )).

% convol_o
thf(fact_22_comp__swap,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F2: ( C > B ),A2: A,B2: A,G2: ( A > C )] :
      ( ( comp @ C @ B @ A @ F2 @ ( swap @ A @ C @ A2 @ B2 @ G2 ) )
      = ( swap @ A @ B @ A2 @ B2 @ ( comp @ C @ B @ A @ F2 @ G2 ) ) ) )).

% comp_swap
thf(fact_23_fun__upd__comp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( C > B ),G2: ( A > C ),X2: A,Y: C] :
      ( ( comp @ C @ B @ A @ F2 @ ( fun_upd @ A @ C @ G2 @ X2 @ Y ) )
      = ( fun_upd @ A @ B @ ( comp @ C @ B @ A @ F2 @ G2 ) @ X2 @ ( F2 @ Y ) ) ) )).

% fun_upd_comp
thf(fact_24_sp_092_060_094sub_062_092_060nu_062_Omap__comp,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,G2: ( B > C ),F2: ( A > B ),V: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream151454380_sp_nu @ B @ C @ D @ G2 @ ( stream151454380_sp_nu @ A @ B @ D @ F2 @ V ) )
      = ( stream151454380_sp_nu @ A @ C @ D @ ( comp @ B @ C @ A @ G2 @ F2 ) @ V ) ) )).

% sp\<^sub>\<nu>.map_comp
thf(fact_25_map__fun_Ocompositionality,axiom,(
    ! [D: $tType,F4: $tType,C: $tType,E: $tType,B: $tType,A: $tType,F2: ( E > C ),G2: ( D > F4 ),H: ( C > A ),I: ( B > D ),Fun: ( A > B )] :
      ( ( map_fun @ E @ C @ D @ F4 @ F2 @ G2 @ ( map_fun @ C @ A @ B @ D @ H @ I @ Fun ) )
      = ( map_fun @ E @ A @ B @ F4 @ ( comp @ C @ A @ E @ H @ F2 ) @ ( comp @ D @ F4 @ B @ G2 @ I ) @ Fun ) ) )).

% map_fun.compositionality
thf(fact_26_map__fun_Ocomp,axiom,(
    ! [E: $tType,C: $tType,A: $tType,F4: $tType,D: $tType,B: $tType,F2: ( E > C ),G2: ( D > F4 ),H: ( C > A ),I: ( B > D )] :
      ( ( comp @ ( C > D ) @ ( E > F4 ) @ ( A > B ) @ ( map_fun @ E @ C @ D @ F4 @ F2 @ G2 ) @ ( map_fun @ C @ A @ B @ D @ H @ I ) )
      = ( map_fun @ E @ A @ B @ F4 @ ( comp @ C @ A @ E @ H @ F2 ) @ ( comp @ D @ F4 @ B @ G2 @ I ) ) ) )).

% map_fun.comp
thf(fact_27_map__fun__def,axiom,(
    ! [B: $tType,D: $tType,A: $tType,C: $tType] :
      ( ( map_fun @ C @ A @ B @ D )
      = ( ^ [F: ( C > A ),G: ( B > D ),H2: ( A > B )] :
            ( comp @ A @ D @ C @ ( comp @ B @ D @ A @ G @ H2 ) @ F ) ) ) )).

% map_fun_def
thf(fact_28_map__fun__apply,axiom,(
    ! [D: $tType,A: $tType,C: $tType,B: $tType] :
      ( ( map_fun @ B @ C @ D @ A )
      = ( ^ [F: ( B > C ),G: ( D > A ),H2: ( C > D ),X: B] :
            ( G @ ( H2 @ ( F @ X ) ) ) ) ) )).

% map_fun_apply
thf(fact_29_fun__upd__apply,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( fun_upd @ B @ A )
      = ( ^ [F: ( B > A ),X: B,Y2: A,Z: B] :
            ( if @ A @ ( Z = X ) @ Y2 @ ( F @ Z ) ) ) ) )).

% fun_upd_apply
thf(fact_30_fun__upd__triv,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),X2: A] :
      ( ( fun_upd @ A @ B @ F2 @ X2 @ ( F2 @ X2 ) )
      = F2 ) )).

% fun_upd_triv
thf(fact_31_fun__upd__upd,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),X2: A,Y: B,Z2: B] :
      ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F2 @ X2 @ Y ) @ X2 @ Z2 )
      = ( fun_upd @ A @ B @ F2 @ X2 @ Z2 ) ) )).

% fun_upd_upd
thf(fact_32_swap__nilpotent,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: A,F2: ( A > B )] :
      ( ( swap @ A @ B @ A2 @ B2 @ ( swap @ A @ B @ A2 @ B2 @ F2 ) )
      = F2 ) )).

% swap_nilpotent
thf(fact_33_swap__self,axiom,(
    ! [B: $tType,A: $tType,A2: A,F2: ( A > B )] :
      ( ( swap @ A @ B @ A2 @ A2 @ F2 )
      = F2 ) )).

% swap_self
thf(fact_34_swap__apply_I1_J,axiom,(
    ! [A: $tType,B: $tType,A2: B,B2: B,F2: ( B > A )] :
      ( ( swap @ B @ A @ A2 @ B2 @ F2 @ A2 )
      = ( F2 @ B2 ) ) )).

% swap_apply(1)
thf(fact_35_swap__apply_I2_J,axiom,(
    ! [A: $tType,B: $tType,A2: B,B2: B,F2: ( B > A )] :
      ( ( swap @ B @ A @ A2 @ B2 @ F2 @ B2 )
      = ( F2 @ A2 ) ) )).

% swap_apply(2)
thf(fact_36_swap__apply_I3_J,axiom,(
    ! [A: $tType,B: $tType,C2: B,A2: B,B2: B,F2: ( B > A )] :
      ( ( C2 != A2 )
     => ( ( C2 != B2 )
       => ( ( swap @ B @ A @ A2 @ B2 @ F2 @ C2 )
          = ( F2 @ C2 ) ) ) ) )).

% swap_apply(3)
thf(fact_37_fcomp__apply,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( fcomp @ B @ C @ A )
      = ( ^ [F: ( B > C ),G: ( C > A ),X: B] :
            ( G @ ( F @ X ) ) ) ) )).

% fcomp_apply
thf(fact_38_fun__upd__idem__iff,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),X2: A,Y: B] :
      ( ( ( fun_upd @ A @ B @ F2 @ X2 @ Y )
        = F2 )
      = ( ( F2 @ X2 )
        = Y ) ) )).

% fun_upd_idem_iff
thf(fact_39_fun__upd__twist,axiom,(
    ! [A: $tType,B: $tType,A2: A,C2: A,M2: ( A > B ),B2: B,D2: B] :
      ( ( A2 != C2 )
     => ( ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M2 @ A2 @ B2 ) @ C2 @ D2 )
        = ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ M2 @ C2 @ D2 ) @ A2 @ B2 ) ) ) )).

% fun_upd_twist
thf(fact_40_fun__upd__other,axiom,(
    ! [B: $tType,A: $tType,Z2: A,X2: A,F2: ( A > B ),Y: B] :
      ( ( Z2 != X2 )
     => ( ( fun_upd @ A @ B @ F2 @ X2 @ Y @ Z2 )
        = ( F2 @ Z2 ) ) ) )).

% fun_upd_other
thf(fact_41_swap__commute,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( swap @ A @ B )
      = ( ^ [A4: A,B3: A] :
            ( swap @ A @ B @ B3 @ A4 ) ) ) )).

% swap_commute
thf(fact_42_fun__upd__same,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),X2: B,Y: A] :
      ( ( fun_upd @ B @ A @ F2 @ X2 @ Y @ X2 )
      = Y ) )).

% fun_upd_same
thf(fact_43_fun__upd__idem,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),X2: B,Y: A] :
      ( ( ( F2 @ X2 )
        = Y )
     => ( ( fun_upd @ B @ A @ F2 @ X2 @ Y )
        = F2 ) ) )).

% fun_upd_idem
thf(fact_44_swap__triple,axiom,(
    ! [B: $tType,A: $tType,A2: A,C2: A,B2: A,F2: ( A > B )] :
      ( ( A2 != C2 )
     => ( ( B2 != C2 )
       => ( ( swap @ A @ B @ A2 @ B2 @ ( swap @ A @ B @ B2 @ C2 @ ( swap @ A @ B @ A2 @ B2 @ F2 ) ) )
          = ( swap @ A @ B @ A2 @ C2 @ F2 ) ) ) ) )).

% swap_triple
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X: A] :
            ( member @ A @ X @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B ),G2: ( A > B )] :
      ( ! [X4: A] :
          ( ( F2 @ X4 )
          = ( G2 @ X4 ) )
     => ( F2 = G2 ) ) )).

% ext
thf(fact_49_fun__upd__eqD,axiom,(
    ! [A: $tType,B: $tType,F2: ( A > B ),X2: A,Y: B,G2: ( A > B ),Z2: B] :
      ( ( ( fun_upd @ A @ B @ F2 @ X2 @ Y )
        = ( fun_upd @ A @ B @ G2 @ X2 @ Z2 ) )
     => ( Y = Z2 ) ) )).

% fun_upd_eqD
thf(fact_50_fun__upd__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( fun_upd @ A @ B )
      = ( ^ [F: ( A > B ),A4: A,B3: B,X: A] :
            ( if @ B @ ( X = A4 ) @ B3 @ ( F @ X ) ) ) ) )).

% fun_upd_def
thf(fact_51_fcomp__assoc,axiom,(
    ! [A: $tType,D: $tType,B: $tType,C: $tType,F2: ( A > D ),G2: ( D > C ),H: ( C > B )] :
      ( ( fcomp @ A @ C @ B @ ( fcomp @ A @ D @ C @ F2 @ G2 ) @ H )
      = ( fcomp @ A @ D @ B @ F2 @ ( fcomp @ D @ C @ B @ G2 @ H ) ) ) )).

% fcomp_assoc
thf(fact_52_fcomp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( fcomp @ A @ B @ C )
      = ( ^ [F: ( A > B ),G: ( B > C ),X: A] :
            ( G @ ( F @ X ) ) ) ) )).

% fcomp_def
thf(fact_53_swap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( swap @ A @ B )
      = ( ^ [A4: A,B3: A,F: ( A > B )] :
            ( fun_upd @ A @ B @ ( fun_upd @ A @ B @ F @ A4 @ ( F @ B3 ) ) @ B3 @ ( F @ A4 ) ) ) ) )).

% swap_def
thf(fact_54_vimage2p__cong,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,R3: ( A > B > C ),S2: ( A > B > C ),F2: ( D > A ),G2: ( E > B )] :
      ( ( R3 = S2 )
     => ( ( bNF_vimage2p @ D @ A @ E @ B @ C @ F2 @ G2 @ R3 )
        = ( bNF_vimage2p @ D @ A @ E @ B @ C @ F2 @ G2 @ S2 ) ) ) )).

% vimage2p_cong
thf(fact_55_swap__comp__involutory,axiom,(
    ! [B: $tType,A: $tType,A2: A,B2: A] :
      ( ( comp @ ( A > B ) @ ( A > B ) @ ( A > B ) @ ( swap @ A @ B @ A2 @ B2 ) @ ( swap @ A @ B @ A2 @ B2 ) )
      = ( id @ ( A > B ) ) ) )).

% swap_comp_involutory
thf(fact_56_map__prod__o__convol,axiom,(
    ! [D: $tType,B: $tType,C: $tType,E: $tType,A: $tType,H1: ( D > B ),H22: ( E > C ),F2: ( A > D ),G2: ( A > E )] :
      ( ( comp @ ( product_prod @ D @ E ) @ ( product_prod @ B @ C ) @ A @ ( product_map_prod @ D @ B @ E @ C @ H1 @ H22 ) @ ( bNF_convol @ A @ D @ E @ F2 @ G2 ) )
      = ( bNF_convol @ A @ B @ C @ ( comp @ D @ B @ A @ H1 @ F2 ) @ ( comp @ E @ C @ A @ H22 @ G2 ) ) ) )).

% map_prod_o_convol
thf(fact_57_sp_092_060_094sub_062_092_060nu_062_Opred__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,Q: ( B > $o ),F2: ( A > B ),X2: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream1465372679_sp_nu @ B @ D @ Q @ ( stream151454380_sp_nu @ A @ B @ D @ F2 @ X2 ) )
      = ( stream1465372679_sp_nu @ A @ D @ ( comp @ B @ $o @ A @ Q @ F2 ) @ X2 ) ) )).

% sp\<^sub>\<nu>.pred_map
thf(fact_58_sp_092_060_094sub_062_092_060nu_062_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( stream1273403375_sp_nu @ D @ A ),Ya: ( stream1273403375_sp_nu @ D @ A ),F2: ( A > B ),G2: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ Ya ) )
           => ( ( F2 @ Z3 )
              = ( G2 @ Z3 ) ) )
       => ( ( stream151454380_sp_nu @ A @ B @ D @ F2 @ X2 )
          = ( stream151454380_sp_nu @ A @ B @ D @ G2 @ Ya ) ) ) ) )).

% sp\<^sub>\<nu>.map_cong
thf(fact_59_sp_092_060_094sub_062_092_060nu_062_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( stream1273403375_sp_nu @ D @ A ),F2: ( A > B ),G2: ( A > B )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X2 ) )
         => ( ( F2 @ Z3 )
            = ( G2 @ Z3 ) ) )
     => ( ( stream151454380_sp_nu @ A @ B @ D @ F2 @ X2 )
        = ( stream151454380_sp_nu @ A @ B @ D @ G2 @ X2 ) ) ) )).

% sp\<^sub>\<nu>.map_cong0
thf(fact_60_sp_092_060_094sub_062_092_060nu_062_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( stream1273403375_sp_nu @ D @ A ),Xa: ( stream1273403375_sp_nu @ D @ A ),F2: ( A > B ),Fa: ( A > B )] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( stream1493736486_sp_nu @ D @ A @ Xa ) )
           => ( ( ( F2 @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( stream151454380_sp_nu @ A @ B @ D @ F2 @ X2 )
          = ( stream151454380_sp_nu @ A @ B @ D @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% sp\<^sub>\<nu>.inj_map_strong
thf(fact_61_id__fcomp,axiom,(
    ! [B: $tType,A: $tType,G2: ( A > B )] :
      ( ( fcomp @ A @ A @ B @ ( id @ A ) @ G2 )
      = G2 ) )).

% id_fcomp
thf(fact_62_fcomp__id,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B )] :
      ( ( fcomp @ A @ B @ B @ F2 @ ( id @ B ) )
      = F2 ) )).

% fcomp_id
thf(fact_63_swap__image__eq,axiom,(
    ! [B: $tType,A: $tType,A2: A,A5: ( set @ A ),B2: A,F2: ( A > B )] :
      ( ( member @ A @ A2 @ A5 )
     => ( ( member @ A @ B2 @ A5 )
       => ( ( image @ A @ B @ ( swap @ A @ B @ A2 @ B2 @ F2 ) @ A5 )
          = ( image @ A @ B @ F2 @ A5 ) ) ) ) )).

% swap_image_eq
thf(fact_64_id__apply,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_apply
thf(fact_65_image__id,axiom,(
    ! [A: $tType] :
      ( ( image @ A @ A @ ( id @ A ) )
      = ( id @ ( set @ A ) ) ) )).

% image_id
thf(fact_66_fun_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( D > A )] :
      ( ( comp @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% fun.map_id
thf(fact_67_id__comp,axiom,(
    ! [B: $tType,A: $tType,G2: ( A > B )] :
      ( ( comp @ B @ B @ A @ ( id @ B ) @ G2 )
      = G2 ) )).

% id_comp
thf(fact_68_comp__id,axiom,(
    ! [B: $tType,A: $tType,F2: ( A > B )] :
      ( ( comp @ A @ B @ A @ F2 @ ( id @ A ) )
      = F2 ) )).

% comp_id
thf(fact_69_fun_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( comp @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( D > A ) ) ) )).

% fun.map_id0
thf(fact_70_sp_092_060_094sub_062_092_060nu_062_Omap__id0,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( stream151454380_sp_nu @ A @ A @ D @ ( id @ A ) )
      = ( id @ ( stream1273403375_sp_nu @ D @ A ) ) ) )).

% sp\<^sub>\<nu>.map_id0
thf(fact_71_sp_092_060_094sub_062_092_060nu_062_Opred__mono__strong,axiom,(
    ! [A: $tType,D: $tType,P: ( A > $o ),X2: ( stream1273403375_sp_nu @ D @ A ),Pa: ( A > $o )] :
      ( ( stream1465372679_sp_nu @ A @ D @ P @ X2 )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ X2 ) )
           => ( ( P @ Z3 )
             => ( Pa @ Z3 ) ) )
       => ( stream1465372679_sp_nu @ A @ D @ Pa @ X2 ) ) ) )).

% sp\<^sub>\<nu>.pred_mono_strong
thf(fact_72_sp_092_060_094sub_062_092_060nu_062_Opred__cong,axiom,(
    ! [A: $tType,D: $tType,X2: ( stream1273403375_sp_nu @ D @ A ),Ya: ( stream1273403375_sp_nu @ D @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X2 = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( stream1493736486_sp_nu @ D @ A @ Ya ) )
           => ( ( P @ Z3 )
              = ( Pa @ Z3 ) ) )
       => ( ( stream1465372679_sp_nu @ A @ D @ P @ X2 )
          = ( stream1465372679_sp_nu @ A @ D @ Pa @ Ya ) ) ) ) )).

% sp\<^sub>\<nu>.pred_cong
thf(fact_73_id__def,axiom,(
    ! [A: $tType] :
      ( ( id @ A )
      = ( ^ [X: A] : X ) ) )).

% id_def
thf(fact_74_eq__id__iff,axiom,(
    ! [A: $tType,F2: ( A > A )] :
      ( ( ! [X: A] :
            ( ( F2 @ X )
            = X ) )
      = ( F2
        = ( id @ A ) ) ) )).

% eq_id_iff
thf(fact_75_prod_Omap__id,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) @ T2 )
      = T2 ) )).

% prod.map_id
thf(fact_76_prod_Omap__id0,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_map_prod @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% prod.map_id0
thf(fact_77_sp_092_060_094sub_062_092_060nu_062_Oset__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,F2: ( A > B ),V: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream1493736486_sp_nu @ D @ B @ ( stream151454380_sp_nu @ A @ B @ D @ F2 @ V ) )
      = ( image @ A @ B @ F2 @ ( stream1493736486_sp_nu @ D @ A @ V ) ) ) )).

% sp\<^sub>\<nu>.set_map
thf(fact_78_map__prod__o__convol__id,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F2: ( C > A ),G2: ( C > B ),X2: C] :
      ( ( comp @ ( product_prod @ C @ B ) @ ( product_prod @ A @ B ) @ C @ ( product_map_prod @ C @ A @ B @ B @ F2 @ ( id @ B ) ) @ ( bNF_convol @ C @ C @ B @ ( id @ C ) @ G2 ) @ X2 )
      = ( bNF_convol @ C @ A @ B @ ( comp @ A @ A @ C @ ( id @ A ) @ F2 ) @ G2 @ X2 ) ) )).

% map_prod_o_convol_id
thf(fact_79_pointfree__idE,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),G2: ( A > B ),X2: A] :
      ( ( ( comp @ B @ A @ A @ F2 @ G2 )
        = ( id @ A ) )
     => ( ( F2 @ ( G2 @ X2 ) )
        = X2 ) ) )).

% pointfree_idE
thf(fact_80_comp__eq__id__dest,axiom,(
    ! [C: $tType,B: $tType,A: $tType,A2: ( C > B ),B2: ( A > C ),C2: ( A > B ),V: A] :
      ( ( ( comp @ C @ B @ A @ A2 @ B2 )
        = ( comp @ B @ B @ A @ ( id @ B ) @ C2 ) )
     => ( ( A2 @ ( B2 @ V ) )
        = ( C2 @ V ) ) ) )).

% comp_eq_id_dest
thf(fact_81_image__eq__imp__comp,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( B > A ),A5: ( set @ B ),G2: ( C > A ),B4: ( set @ C ),H: ( A > D )] :
      ( ( ( image @ B @ A @ F2 @ A5 )
        = ( image @ C @ A @ G2 @ B4 ) )
     => ( ( image @ B @ D @ ( comp @ A @ D @ B @ H @ F2 ) @ A5 )
        = ( image @ C @ D @ ( comp @ A @ D @ C @ H @ G2 ) @ B4 ) ) ) )).

% image_eq_imp_comp
thf(fact_82_image__comp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F2: ( B > A ),G2: ( C > B ),R: ( set @ C )] :
      ( ( image @ B @ A @ F2 @ ( image @ C @ B @ G2 @ R ) )
      = ( image @ C @ A @ ( comp @ B @ A @ C @ F2 @ G2 ) @ R ) ) )).

% image_comp
thf(fact_83_prod_Omap__comp,axiom,(
    ! [D: $tType,F4: $tType,E: $tType,C: $tType,B: $tType,A: $tType,G1: ( C > E ),G22: ( D > F4 ),F1: ( A > C ),F22: ( B > D ),V: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F4 @ G1 @ G22 @ ( product_map_prod @ A @ C @ B @ D @ F1 @ F22 @ V ) )
      = ( product_map_prod @ A @ E @ B @ F4 @ ( comp @ C @ E @ A @ G1 @ F1 ) @ ( comp @ D @ F4 @ B @ G22 @ F22 ) @ V ) ) )).

% prod.map_comp
thf(fact_84_sp_092_060_094sub_062_092_060nu_062_Omap__id,axiom,(
    ! [A: $tType,D: $tType,T2: ( stream1273403375_sp_nu @ D @ A )] :
      ( ( stream151454380_sp_nu @ A @ A @ D @ ( id @ A ) @ T2 )
      = T2 ) )).

% sp\<^sub>\<nu>.map_id
thf(fact_85_vimage2p__id,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R3: ( A > B > C )] :
      ( ( bNF_vimage2p @ A @ A @ B @ B @ C @ ( id @ A ) @ ( id @ B ) @ R3 )
      = R3 ) )).

% vimage2p_id
thf(fact_86_map__fun__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( map_fun @ A @ A @ B @ B @ ( id @ A ) @ ( id @ B ) )
      = ( id @ ( A > B ) ) ) )).

% map_fun_id
thf(fact_87_image__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F2: ( B > A ),X2: B,A5: ( set @ B )] :
      ( ( B2
        = ( F2 @ X2 ) )
     => ( ( member @ B @ X2 @ A5 )
       => ( member @ A @ B2 @ ( image @ B @ A @ F2 @ A5 ) ) ) ) )).

% image_eqI
thf(fact_88_map__prod_Ocompositionality,axiom,(
    ! [D: $tType,F4: $tType,E: $tType,C: $tType,B: $tType,A: $tType,F2: ( C > E ),G2: ( D > F4 ),H: ( A > C ),I: ( B > D ),Prod: ( product_prod @ A @ B )] :
      ( ( product_map_prod @ C @ E @ D @ F4 @ F2 @ G2 @ ( product_map_prod @ A @ C @ B @ D @ H @ I @ Prod ) )
      = ( product_map_prod @ A @ E @ B @ F4 @ ( comp @ C @ E @ A @ F2 @ H ) @ ( comp @ D @ F4 @ B @ G2 @ I ) @ Prod ) ) )).

% map_prod.compositionality
thf(fact_89_map__prod__compose,axiom,(
    ! [D: $tType,C: $tType,A: $tType,E: $tType,F4: $tType,B: $tType,F1: ( E > C ),F22: ( A > E ),G1: ( F4 > D ),G22: ( B > F4 )] :
      ( ( product_map_prod @ A @ C @ B @ D @ ( comp @ E @ C @ A @ F1 @ F22 ) @ ( comp @ F4 @ D @ B @ G1 @ G22 ) )
      = ( comp @ ( product_prod @ E @ F4 ) @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ E @ C @ F4 @ D @ F1 @ G1 ) @ ( product_map_prod @ A @ E @ B @ F4 @ F22 @ G22 ) ) ) )).

% map_prod_compose
thf(fact_90_map__prod_Ocomp,axiom,(
    ! [A: $tType,C: $tType,E: $tType,F4: $tType,D: $tType,B: $tType,F2: ( C > E ),G2: ( D > F4 ),H: ( A > C ),I: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ ( product_prod @ E @ F4 ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ E @ D @ F4 @ F2 @ G2 ) @ ( product_map_prod @ A @ C @ B @ D @ H @ I ) )
      = ( product_map_prod @ A @ E @ B @ F4 @ ( comp @ C @ E @ A @ F2 @ H ) @ ( comp @ D @ F4 @ B @ G2 @ I ) ) ) )).

% map_prod.comp
thf(fact_91_Sup_OSUP__id__eq,axiom,(
    ! [A: $tType,Sup: ( ( set @ A ) > A ),A5: ( set @ A )] :
      ( ( Sup @ ( image @ A @ A @ ( id @ A ) @ A5 ) )
      = ( Sup @ A5 ) ) )).

% Sup.SUP_id_eq
thf(fact_92_Inf_OINF__id__eq,axiom,(
    ! [A: $tType,Inf: ( ( set @ A ) > A ),A5: ( set @ A )] :
      ( ( Inf @ ( image @ A @ A @ ( id @ A ) @ A5 ) )
      = ( Inf @ A5 ) ) )).

% Inf.INF_id_eq
thf(fact_93_imageI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( set @ A ),F2: ( A > B )] :
      ( ( member @ A @ X2 @ A5 )
     => ( member @ B @ ( F2 @ X2 ) @ ( image @ A @ B @ F2 @ A5 ) ) ) )).

% imageI
thf(fact_94_image__iff,axiom,(
    ! [A: $tType,B: $tType,Z2: A,F2: ( B > A ),A5: ( set @ B )] :
      ( ( member @ A @ Z2 @ ( image @ B @ A @ F2 @ A5 ) )
      = ( ? [X: B] :
            ( ( member @ B @ X @ A5 )
            & ( Z2
              = ( F2 @ X ) ) ) ) ) )).

% image_iff
thf(fact_95_bex__imageD,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),A5: ( set @ B ),P: ( A > $o )] :
      ( ? [X5: A] :
          ( ( member @ A @ X5 @ ( image @ B @ A @ F2 @ A5 ) )
          & ( P @ X5 ) )
     => ? [X4: B] :
          ( ( member @ B @ X4 @ A5 )
          & ( P @ ( F2 @ X4 ) ) ) ) )).

% bex_imageD
thf(fact_96_image__cong,axiom,(
    ! [B: $tType,A: $tType,M: ( set @ A ),N: ( set @ A ),F2: ( A > B ),G2: ( A > B )] :
      ( ( M = N )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ N )
           => ( ( F2 @ X4 )
              = ( G2 @ X4 ) ) )
       => ( ( image @ A @ B @ F2 @ M )
          = ( image @ A @ B @ G2 @ N ) ) ) ) )).

% image_cong
thf(fact_97_ball__imageD,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),A5: ( set @ B ),P: ( A > $o )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ ( image @ B @ A @ F2 @ A5 ) )
         => ( P @ X4 ) )
     => ! [X5: B] :
          ( ( member @ B @ X5 @ A5 )
         => ( P @ ( F2 @ X5 ) ) ) ) )).

% ball_imageD
thf(fact_98_rev__image__eqI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( set @ A ),B2: B,F2: ( A > B )] :
      ( ( member @ A @ X2 @ A5 )
     => ( ( B2
          = ( F2 @ X2 ) )
       => ( member @ B @ B2 @ ( image @ A @ B @ F2 @ A5 ) ) ) ) )).

% rev_image_eqI
thf(fact_99_Inf_OINF__cong,axiom,(
    ! [A: $tType,B: $tType,A5: ( set @ B ),B4: ( set @ B ),C3: ( B > A ),D3: ( B > A ),Inf: ( ( set @ A ) > A )] :
      ( ( A5 = B4 )
     => ( ! [X4: B] :
            ( ( member @ B @ X4 @ B4 )
           => ( ( C3 @ X4 )
              = ( D3 @ X4 ) ) )
       => ( ( Inf @ ( image @ B @ A @ C3 @ A5 ) )
          = ( Inf @ ( image @ B @ A @ D3 @ B4 ) ) ) ) ) )).

% Inf.INF_cong
thf(fact_100_Sup_OSUP__cong,axiom,(
    ! [A: $tType,B: $tType,A5: ( set @ B ),B4: ( set @ B ),C3: ( B > A ),D3: ( B > A ),Sup: ( ( set @ A ) > A )] :
      ( ( A5 = B4 )
     => ( ! [X4: B] :
            ( ( member @ B @ X4 @ B4 )
           => ( ( C3 @ X4 )
              = ( D3 @ X4 ) ) )
       => ( ( Sup @ ( image @ B @ A @ C3 @ A5 ) )
          = ( Sup @ ( image @ B @ A @ D3 @ B4 ) ) ) ) ) )).

% Sup.SUP_cong
thf(fact_101_Sup_OSUP__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Sup: ( ( set @ A ) > A ),G2: ( B > A ),F2: ( C > B ),A5: ( set @ C )] :
      ( ( Sup @ ( image @ B @ A @ G2 @ ( image @ C @ B @ F2 @ A5 ) ) )
      = ( Sup @ ( image @ C @ A @ ( comp @ B @ A @ C @ G2 @ F2 ) @ A5 ) ) ) )).

% Sup.SUP_image
thf(fact_102_Inf_OINF__image,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Inf: ( ( set @ A ) > A ),G2: ( B > A ),F2: ( C > B ),A5: ( set @ C )] :
      ( ( Inf @ ( image @ B @ A @ G2 @ ( image @ C @ B @ F2 @ A5 ) ) )
      = ( Inf @ ( image @ C @ A @ ( comp @ B @ A @ C @ G2 @ F2 ) @ A5 ) ) ) )).

% Inf.INF_image
thf(fact_103_swap__comp__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( product_swap @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% swap_comp_swap
thf(fact_104_apsnd__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_apsnd @ B @ B @ A @ ( id @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% apsnd_id
thf(fact_105_apfst__id,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_apfst @ A @ A @ B @ ( id @ A ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% apfst_id
thf(fact_106_fst__comp__map__prod,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F2: ( A > C ),G2: ( B > D )] :
      ( ( comp @ ( product_prod @ C @ D ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F2 @ G2 ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F2 @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_map_prod
thf(fact_107_snd__comp__map__prod,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,F2: ( A > D ),G2: ( B > C )] :
      ( ( comp @ ( product_prod @ D @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ D @ C ) @ ( product_map_prod @ A @ D @ B @ C @ F2 @ G2 ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ G2 @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_map_prod
thf(fact_108_swap__swap,axiom,(
    ! [B: $tType,A: $tType,P3: ( product_prod @ A @ B )] :
      ( ( product_swap @ B @ A @ ( product_swap @ A @ B @ P3 ) )
      = P3 ) )).

% swap_swap
thf(fact_109_fst__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( C > A ),G2: ( D > B ),X2: ( product_prod @ C @ D )] :
      ( ( product_fst @ A @ B @ ( product_map_prod @ C @ A @ D @ B @ F2 @ G2 @ X2 ) )
      = ( F2 @ ( product_fst @ C @ D @ X2 ) ) ) )).

% fst_map_prod
thf(fact_110_snd__map__prod,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,F2: ( C > B ),G2: ( D > A ),X2: ( product_prod @ C @ D )] :
      ( ( product_snd @ B @ A @ ( product_map_prod @ C @ B @ D @ A @ F2 @ G2 @ X2 ) )
      = ( G2 @ ( product_snd @ C @ D @ X2 ) ) ) )).

% snd_map_prod
thf(fact_111_fst__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( C > A ),X2: ( product_prod @ C @ B )] :
      ( ( product_fst @ A @ B @ ( product_apfst @ C @ A @ B @ F2 @ X2 ) )
      = ( F2 @ ( product_fst @ C @ B @ X2 ) ) ) )).

% fst_apfst
thf(fact_112_apfst__eq__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( C > A ),X2: ( product_prod @ C @ B ),G2: ( C > A )] :
      ( ( ( product_apfst @ C @ A @ B @ F2 @ X2 )
        = ( product_apfst @ C @ A @ B @ G2 @ X2 ) )
      = ( ( F2 @ ( product_fst @ C @ B @ X2 ) )
        = ( G2 @ ( product_fst @ C @ B @ X2 ) ) ) ) )).

% apfst_eq_conv
thf(fact_113_snd__apfst,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F2: ( C > B ),X2: ( product_prod @ C @ A )] :
      ( ( product_snd @ B @ A @ ( product_apfst @ C @ B @ A @ F2 @ X2 ) )
      = ( product_snd @ C @ A @ X2 ) ) )).

% snd_apfst
thf(fact_114_fst__apsnd,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F2: ( C > B ),X2: ( product_prod @ A @ C )] :
      ( ( product_fst @ A @ B @ ( product_apsnd @ C @ B @ A @ F2 @ X2 ) )
      = ( product_fst @ A @ C @ X2 ) ) )).

% fst_apsnd
thf(fact_115_snd__apsnd,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F2: ( C > A ),X2: ( product_prod @ B @ C )] :
      ( ( product_snd @ B @ A @ ( product_apsnd @ C @ A @ B @ F2 @ X2 ) )
      = ( F2 @ ( product_snd @ B @ C @ X2 ) ) ) )).

% snd_apsnd
thf(fact_116_apsnd__eq__conv,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F2: ( C > B ),X2: ( product_prod @ A @ C ),G2: ( C > B )] :
      ( ( ( product_apsnd @ C @ B @ A @ F2 @ X2 )
        = ( product_apsnd @ C @ B @ A @ G2 @ X2 ) )
      = ( ( F2 @ ( product_snd @ A @ C @ X2 ) )
        = ( G2 @ ( product_snd @ A @ C @ X2 ) ) ) ) )).

% apsnd_eq_conv
thf(fact_117_fst__swap,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ B @ A )] :
      ( ( product_fst @ A @ B @ ( product_swap @ B @ A @ X2 ) )
      = ( product_snd @ B @ A @ X2 ) ) )).

% fst_swap
thf(fact_118_snd__swap,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B )] :
      ( ( product_snd @ B @ A @ ( product_swap @ A @ B @ X2 ) )
      = ( product_fst @ A @ B @ X2 ) ) )).

% snd_swap
thf(fact_119_snd__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ C @ B ) @ ( product_apfst @ A @ C @ B @ F2 ) )
      = ( product_snd @ A @ B ) ) )).

% snd_comp_apfst
thf(fact_120_fst__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F2 ) )
      = ( product_fst @ A @ B ) ) )).

% fst_comp_apsnd
thf(fact_121_fst__comp__apfst,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( A > C )] :
      ( ( comp @ ( product_prod @ C @ B ) @ C @ ( product_prod @ A @ B ) @ ( product_fst @ C @ B ) @ ( product_apfst @ A @ C @ B @ F2 ) )
      = ( comp @ A @ C @ ( product_prod @ A @ B ) @ F2 @ ( product_fst @ A @ B ) ) ) )).

% fst_comp_apfst
thf(fact_122_snd__comp__apsnd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( B > C )] :
      ( ( comp @ ( product_prod @ A @ C ) @ C @ ( product_prod @ A @ B ) @ ( product_snd @ A @ C ) @ ( product_apsnd @ B @ C @ A @ F2 ) )
      = ( comp @ B @ C @ ( product_prod @ A @ B ) @ F2 @ ( product_snd @ A @ B ) ) ) )).

% snd_comp_apsnd
thf(fact_123_prod__eqI,axiom,(
    ! [B: $tType,A: $tType,P3: ( product_prod @ A @ B ),Q2: ( product_prod @ A @ B )] :
      ( ( ( product_fst @ A @ B @ P3 )
        = ( product_fst @ A @ B @ Q2 ) )
     => ( ( ( product_snd @ A @ B @ P3 )
          = ( product_snd @ A @ B @ Q2 ) )
       => ( P3 = Q2 ) ) ) )).

% prod_eqI
thf(fact_124_prod_Oexpand,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B ),Prod2: ( product_prod @ A @ B )] :
      ( ( ( ( product_fst @ A @ B @ Prod )
          = ( product_fst @ A @ B @ Prod2 ) )
        & ( ( product_snd @ A @ B @ Prod )
          = ( product_snd @ A @ B @ Prod2 ) ) )
     => ( Prod = Prod2 ) ) )).

% prod.expand
thf(fact_125_prod__eq__iff,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ^ [Y3: ( product_prod @ A @ B ),Z4: ( product_prod @ A @ B )] : ( Y3 = Z4 ) )
      = ( ^ [S3: ( product_prod @ A @ B ),T3: ( product_prod @ A @ B )] :
            ( ( ( product_fst @ A @ B @ S3 )
              = ( product_fst @ A @ B @ T3 ) )
            & ( ( product_snd @ A @ B @ S3 )
              = ( product_snd @ A @ B @ T3 ) ) ) ) ) )).

% prod_eq_iff
thf(fact_126_apsnd__apfst__commute,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F2: ( C > B ),G2: ( D > A ),P3: ( product_prod @ D @ C )] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_apfst @ D @ A @ C @ G2 @ P3 ) )
      = ( product_apfst @ D @ A @ B @ G2 @ ( product_apsnd @ C @ B @ D @ F2 @ P3 ) ) ) )).

% apsnd_apfst_commute
thf(fact_127_convol__expand__snd_H,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( A > ( product_prod @ B @ C ) ),G2: ( A > B ),H: ( A > C )] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F2 )
        = G2 )
     => ( ( H
          = ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F2 ) )
        = ( ( bNF_convol @ A @ B @ C @ G2 @ H )
          = F2 ) ) ) )).

% convol_expand_snd'
thf(fact_128_convol__expand__snd,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( A > ( product_prod @ B @ C ) ),G2: ( A > B )] :
      ( ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ F2 )
        = G2 )
     => ( ( bNF_convol @ A @ B @ C @ G2 @ ( comp @ ( product_prod @ B @ C ) @ C @ A @ ( product_snd @ B @ C ) @ F2 ) )
        = F2 ) ) )).

% convol_expand_snd
thf(fact_129_snd__convol_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F2: ( C > B ),G2: ( C > A ),X2: C] :
      ( ( product_snd @ B @ A @ ( bNF_convol @ C @ B @ A @ F2 @ G2 @ X2 ) )
      = ( G2 @ X2 ) ) )).

% snd_convol'
thf(fact_130_fst__convol_H,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F2: ( C > A ),G2: ( C > B ),X2: C] :
      ( ( product_fst @ A @ B @ ( bNF_convol @ C @ A @ B @ F2 @ G2 @ X2 ) )
      = ( F2 @ X2 ) ) )).

% fst_convol'
thf(fact_131_apfst__compose,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( C > A ),G2: ( D > C ),X2: ( product_prod @ D @ B )] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_apfst @ D @ C @ B @ G2 @ X2 ) )
      = ( product_apfst @ D @ A @ B @ ( comp @ C @ A @ D @ F2 @ G2 ) @ X2 ) ) )).

% apfst_compose
thf(fact_132_apsnd__compose,axiom,(
    ! [C: $tType,B: $tType,D: $tType,A: $tType,F2: ( C > B ),G2: ( D > C ),X2: ( product_prod @ A @ D )] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_apsnd @ D @ C @ A @ G2 @ X2 ) )
      = ( product_apsnd @ D @ B @ A @ ( comp @ C @ B @ D @ F2 @ G2 ) @ X2 ) ) )).

% apsnd_compose
thf(fact_133_snd__convol,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( A > C ),G2: ( A > B )] :
      ( ( comp @ ( product_prod @ C @ B ) @ B @ A @ ( product_snd @ C @ B ) @ ( bNF_convol @ A @ C @ B @ F2 @ G2 ) )
      = G2 ) )).

% snd_convol
thf(fact_134_fst__convol,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F2: ( A > B ),G2: ( A > C )] :
      ( ( comp @ ( product_prod @ B @ C ) @ B @ A @ ( product_fst @ B @ C ) @ ( bNF_convol @ A @ B @ C @ F2 @ G2 ) )
      = F2 ) )).

% fst_convol
thf(fact_135_apfst__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( product_apfst @ A @ C @ B )
      = ( ^ [F: ( A > C )] :
            ( product_map_prod @ A @ C @ B @ B @ F @ ( id @ B ) ) ) ) )).

% apfst_def
thf(fact_136_apsnd__def,axiom,(
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( product_apsnd @ B @ C @ A )
      = ( product_map_prod @ A @ A @ B @ C @ ( id @ A ) ) ) )).

% apsnd_def
thf(fact_137_snd__sndOp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P: ( B > C > $o ),Q: ( C > A > $o )] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ C @ A ) @ A @ ( product_prod @ B @ A ) @ ( product_snd @ C @ A ) @ ( bNF_sndOp @ B @ C @ A @ P @ Q ) ) ) )).

% snd_sndOp
thf(fact_138_fst__fstOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,P: ( A > C > $o ),Q: ( C > B > $o )] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ A @ C ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P @ Q ) ) ) )).

% fst_fstOp
thf(fact_139_apfst__apsnd,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F2: ( C > A ),G2: ( D > B ),X2: ( product_prod @ C @ D )] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_apsnd @ D @ B @ C @ G2 @ X2 ) )
      = ( product_Pair @ A @ B @ ( F2 @ ( product_fst @ C @ D @ X2 ) ) @ ( G2 @ ( product_snd @ C @ D @ X2 ) ) ) ) )).

% apfst_apsnd
thf(fact_140_apsnd__apfst,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F2: ( C > B ),G2: ( D > A ),X2: ( product_prod @ D @ C )] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_apfst @ D @ A @ C @ G2 @ X2 ) )
      = ( product_Pair @ A @ B @ ( G2 @ ( product_fst @ D @ C @ X2 ) ) @ ( F2 @ ( product_snd @ D @ C @ X2 ) ) ) ) )).

% apsnd_apfst
thf(fact_141_prod_Oswap__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_swap @ A @ B )
      = ( ^ [P4: ( product_prod @ A @ B )] :
            ( product_Pair @ B @ A @ ( product_snd @ A @ B @ P4 ) @ ( product_fst @ A @ B @ P4 ) ) ) ) )).

% prod.swap_def
thf(fact_142_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A6: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B5 ) )
      = ( ( A2 = A6 )
        & ( B2 = B5 ) ) ) )).

% old.prod.inject
thf(fact_143_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) )).

% prod.inject
thf(fact_144_map__prod__simp,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,F2: ( C > A ),G2: ( D > B ),A2: C,B2: D] :
      ( ( product_map_prod @ C @ A @ D @ B @ F2 @ G2 @ ( product_Pair @ C @ D @ A2 @ B2 ) )
      = ( product_Pair @ A @ B @ ( F2 @ A2 ) @ ( G2 @ B2 ) ) ) )).

% map_prod_simp
thf(fact_145_map__prod__imageI,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,A2: A,B2: B,R3: ( set @ ( product_prod @ A @ B ) ),F2: ( A > C ),G2: ( B > D )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R3 )
     => ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ ( F2 @ A2 ) @ ( G2 @ B2 ) ) @ ( image @ ( product_prod @ A @ B ) @ ( product_prod @ C @ D ) @ ( product_map_prod @ A @ C @ B @ D @ F2 @ G2 ) @ R3 ) ) ) )).

% map_prod_imageI
thf(fact_146_apfst__conv,axiom,(
    ! [C: $tType,A: $tType,B: $tType,F2: ( C > A ),X2: C,Y: B] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_Pair @ C @ B @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ ( F2 @ X2 ) @ Y ) ) )).

% apfst_conv
thf(fact_147_apsnd__conv,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( C > B ),X2: A,Y: C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_Pair @ A @ C @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ X2 @ ( F2 @ Y ) ) ) )).

% apsnd_conv
thf(fact_148_swap__simp,axiom,(
    ! [A: $tType,B: $tType,X2: B,Y: A] :
      ( ( product_swap @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) )
      = ( product_Pair @ A @ B @ Y @ X2 ) ) )).

% swap_simp
thf(fact_149_pair__in__swap__image,axiom,(
    ! [A: $tType,B: $tType,Y: A,X2: B,A5: ( set @ ( product_prod @ B @ A ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ X2 ) @ ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ A5 ) )
      = ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y ) @ A5 ) ) )).

% pair_in_swap_image
thf(fact_150_prod_Ocollapse,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) )).

% prod.collapse
thf(fact_151_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A7: A,B6: B] :
          ( P @ ( product_Pair @ A @ B @ A7 @ B6 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_152_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A7: A,B6: B] :
            ( Y
           != ( product_Pair @ A @ B @ A7 @ B6 ) ) ) )).

% old.prod.exhaust
thf(fact_153_prod__induct7,axiom,(
    ! [G4: $tType,F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) ) )] :
      ( ! [A7: A,B6: B,C4: C,D4: D,E2: E,F5: F4,G5: G4] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) @ D4 @ ( product_Pair @ E @ ( product_prod @ F4 @ G4 ) @ E2 @ ( product_Pair @ F4 @ G4 @ F5 @ G5 ) ) ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct7
thf(fact_154_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A7: A,B6: B,C4: C,D4: D,E2: E,F5: F4] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D4 @ ( product_Pair @ E @ F4 @ E2 @ F5 ) ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct6
thf(fact_155_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A7: A,B6: B,C4: C,D4: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D4 @ E2 ) ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct5
thf(fact_156_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A7: A,B6: B,C4: C,D4: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D4 ) ) ) )
     => ( P @ X2 ) ) )).

% prod_induct4
thf(fact_157_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X2: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A7: A,B6: B,C4: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A7 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) )
     => ( P @ X2 ) ) )).

% prod_induct3
thf(fact_158_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,G4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) ) )] :
      ~ ( ! [A7: A,B6: B,C4: C,D4: D,E2: E,F5: F4,G5: G4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G4 ) ) @ D4 @ ( product_Pair @ E @ ( product_prod @ F4 @ G4 ) @ E2 @ ( product_Pair @ F4 @ G4 @ F5 @ G5 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_159_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A7: A,B6: B,C4: C,D4: D,E2: E,F5: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C4 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D4 @ ( product_Pair @ E @ F4 @ E2 @ F5 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_160_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A7: A,B6: B,C4: C,D4: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B6 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C4 @ ( product_Pair @ D @ E @ D4 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_161_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A7: A,B6: B,C4: C,D4: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A7 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B6 @ ( product_Pair @ C @ D @ C4 @ D4 ) ) ) ) ) )).

% prod_cases4
thf(fact_162_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A7: A,B6: B,C4: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A7 @ ( product_Pair @ B @ C @ B6 @ C4 ) ) ) ) )).

% prod_cases3
thf(fact_163_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A6: A,B5: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B5 ) )
     => ~ ( ( A2 = A6 )
         => ( B2 != B5 ) ) ) )).

% Pair_inject
thf(fact_164_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P3: ( product_prod @ A @ B )] :
      ( ! [A7: A,B6: B] :
          ( P @ ( product_Pair @ A @ B @ A7 @ B6 ) )
     => ( P @ P3 ) ) )).

% prod_cases
thf(fact_165_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P3: ( product_prod @ A @ B )] :
    ? [X4: A,Y4: B] :
      ( P3
      = ( product_Pair @ A @ B @ X4 @ Y4 ) ) )).

% surj_pair
thf(fact_166_fstI,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B ),Y: A,Z2: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_fst @ A @ B @ X2 )
        = Y ) ) )).

% fstI
thf(fact_167_fst__conv,axiom,(
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) )).

% fst_conv
thf(fact_168_fst__eqD,axiom,(
    ! [B: $tType,A: $tType,X2: A,Y: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X2 @ Y ) )
        = A2 )
     => ( X2 = A2 ) ) )).

% fst_eqD
thf(fact_169_sndI,axiom,(
    ! [A: $tType,B: $tType,X2: ( product_prod @ A @ B ),Y: A,Z2: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y @ Z2 ) )
     => ( ( product_snd @ A @ B @ X2 )
        = Z2 ) ) )).

% sndI
thf(fact_170_snd__conv,axiom,(
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) )).

% snd_conv
thf(fact_171_snd__eqD,axiom,(
    ! [B: $tType,A: $tType,X2: B,Y: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y ) )
        = A2 )
     => ( Y = A2 ) ) )).

% snd_eqD
thf(fact_172_prod__fun__imageE,axiom,(
    ! [B: $tType,A: $tType,D: $tType,C: $tType,C2: ( product_prod @ A @ B ),F2: ( C > A ),G2: ( D > B ),R3: ( set @ ( product_prod @ C @ D ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ C2 @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( product_map_prod @ C @ A @ D @ B @ F2 @ G2 ) @ R3 ) )
     => ~ ( ! [X4: C,Y4: D] :
              ( ( C2
                = ( product_Pair @ A @ B @ ( F2 @ X4 ) @ ( G2 @ Y4 ) ) )
             => ~ ( member @ ( product_prod @ C @ D ) @ ( product_Pair @ C @ D @ X4 @ Y4 ) @ R3 ) ) ) ) )).

% prod_fun_imageE
thf(fact_173_convol__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_convol @ A @ B @ C )
      = ( ^ [F: ( A > B ),G: ( A > C ),A4: A] :
            ( product_Pair @ B @ C @ ( F @ A4 ) @ ( G @ A4 ) ) ) ) )).

% convol_def
thf(fact_174_surjective__pairing,axiom,(
    ! [B: $tType,A: $tType,T2: ( product_prod @ A @ B )] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) )).

% surjective_pairing
thf(fact_175_prod_Oexhaust__sel,axiom,(
    ! [B: $tType,A: $tType,Prod: ( product_prod @ A @ B )] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) )).

% prod.exhaust_sel
thf(fact_176_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_177_fstOp__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( bNF_fstOp @ A @ B @ C )
      = ( ^ [P5: ( A > B > $o ),Q3: ( B > C > $o ),Ac: ( product_prod @ A @ C )] :
            ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Ac ) @ ( bNF_pick_middlep @ A @ B @ C @ P5 @ Q3 @ ( product_fst @ A @ C @ Ac ) @ ( product_snd @ A @ C @ Ac ) ) ) ) ) )).

% fstOp_def
thf(fact_178_sndOp__def,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( bNF_sndOp @ C @ A @ B )
      = ( ^ [P5: ( C > A > $o ),Q3: ( A > B > $o ),Ac: ( product_prod @ C @ B )] :
            ( product_Pair @ A @ B @ ( bNF_pick_middlep @ C @ A @ B @ P5 @ Q3 @ ( product_fst @ C @ B @ Ac ) @ ( product_snd @ C @ B @ Ac ) ) @ ( product_snd @ C @ B @ Ac ) ) ) ) )).

% sndOp_def
thf(fact_179_csquare__fstOp__sndOp,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( ( A > B > $o ) > ( product_prod @ A @ B ) > $o ),P: ( A > C > $o ),Q: ( C > B > $o )] :
      ( bNF_csquare @ ( product_prod @ A @ B ) @ ( product_prod @ A @ C ) @ C @ ( product_prod @ C @ B ) @ ( collect @ ( product_prod @ A @ B ) @ ( F2 @ ( relcompp @ A @ C @ B @ P @ Q ) ) ) @ ( product_snd @ A @ C ) @ ( product_fst @ C @ B ) @ ( bNF_fstOp @ A @ C @ B @ P @ Q ) @ ( bNF_sndOp @ A @ C @ B @ P @ Q ) ) )).

% csquare_fstOp_sndOp
thf(fact_180_pick__middlep,axiom,(
    ! [B: $tType,A: $tType,C: $tType,P: ( A > B > $o ),Q: ( B > C > $o ),A2: A,C2: C] :
      ( ( relcompp @ A @ B @ C @ P @ Q @ A2 @ C2 )
     => ( ( P @ A2 @ ( bNF_pick_middlep @ A @ B @ C @ P @ Q @ A2 @ C2 ) )
        & ( Q @ ( bNF_pick_middlep @ A @ B @ C @ P @ Q @ A2 @ C2 ) @ C2 ) ) ) )).

% pick_middlep
thf(fact_181_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C2 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_182_surj__swap,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B ) @ ( product_swap @ B @ A ) @ ( top_top @ ( set @ ( product_prod @ B @ A ) ) ) )
      = ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) )).

% surj_swap
thf(fact_183_o__prs_I2_J,axiom,(
    ! [F4: $tType,E: $tType,C: $tType,D: $tType,A: $tType,B: $tType,H3: $tType,G4: $tType,R12: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R22: ( C > C > $o ),Abs2: ( C > D ),Rep2: ( D > C ),R32: ( E > E > $o ),Abs3: ( E > F4 ),Rep3: ( F4 > E )] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R22 @ Abs2 @ Rep2 )
       => ( ( quotient3 @ E @ F4 @ R32 @ Abs3 @ Rep3 )
         => ( ( map_fun @ ( G4 > H3 ) @ ( G4 > H3 ) @ ( ( A > G4 ) > A > H3 ) @ ( ( B > G4 ) > B > H3 ) @ ( id @ ( G4 > H3 ) ) @ ( map_fun @ ( B > G4 ) @ ( A > G4 ) @ ( A > H3 ) @ ( B > H3 ) @ ( map_fun @ A @ B @ G4 @ G4 @ Abs1 @ ( id @ G4 ) ) @ ( map_fun @ B @ A @ H3 @ H3 @ Rep1 @ ( id @ H3 ) ) ) @ ( comp @ G4 @ H3 @ A ) )
            = ( comp @ G4 @ H3 @ B ) ) ) ) ) )).

% o_prs(2)
thf(fact_184_UNIV__I,axiom,(
    ! [A: $tType,X2: A] :
      ( member @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_I
thf(fact_185_surj__swap__iff,axiom,(
    ! [B: $tType,A: $tType,A2: B,B2: B,F2: ( B > A )] :
      ( ( ( image @ B @ A @ ( swap @ B @ A @ A2 @ B2 @ F2 ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_swap_iff
thf(fact_186_OOO__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R12: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R22: ( B > B > $o ),Abs2: ( B > C ),Rep2: ( C > B ),R23: ( A > A > $o )] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ B @ C @ R22 @ Abs2 @ Rep2 )
       => ( ! [X4: A,Y4: A] :
              ( ( R23 @ X4 @ Y4 )
             => ( ( R12 @ X4 @ X4 )
               => ( ( R12 @ Y4 @ Y4 )
                 => ( R22 @ ( Abs1 @ X4 ) @ ( Abs1 @ Y4 ) ) ) ) )
         => ( ! [X4: B,Y4: B] :
                ( ( R22 @ X4 @ Y4 )
               => ( R23 @ ( Rep1 @ X4 ) @ ( Rep1 @ Y4 ) ) )
           => ( quotient3 @ A @ C @ ( relcompp @ A @ A @ A @ R12 @ ( relcompp @ A @ A @ A @ R23 @ R12 ) ) @ ( comp @ B @ C @ A @ Abs2 @ Abs1 ) @ ( comp @ B @ A @ C @ Rep1 @ Rep2 ) ) ) ) ) ) )).

% OOO_quotient3
thf(fact_187_OOO__eq__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,R12: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),Abs2: ( B > C ),Rep2: ( C > B )] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ B @ C
          @ ^ [Y3: B,Z4: B] : ( Y3 = Z4 )
          @ Abs2
          @ Rep2 )
       => ( quotient3 @ A @ C
          @ ( relcompp @ A @ A @ A @ R12
            @ ( relcompp @ A @ A @ A
              @ ^ [Y3: A,Z4: A] : ( Y3 = Z4 )
              @ R12 ) )
          @ ( comp @ B @ C @ A @ Abs2 @ Abs1 )
          @ ( comp @ B @ A @ C @ Rep1 @ Rep2 ) ) ) ) )).

% OOO_eq_quotient3
thf(fact_188_range__eqI,axiom,(
    ! [A: $tType,B: $tType,B2: A,F2: ( B > A ),X2: B] :
      ( ( B2
        = ( F2 @ X2 ) )
     => ( member @ A @ B2 @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) )).

% range_eqI
thf(fact_189_rangeI,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),X2: B] :
      ( member @ A @ ( F2 @ X2 ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) )).

% rangeI
thf(fact_190_surj__def,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A )] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
      = ( ! [Y2: A] :
          ? [X: B] :
            ( Y2
            = ( F2 @ X ) ) ) ) )).

% surj_def
thf(fact_191_surjI,axiom,(
    ! [B: $tType,A: $tType,G2: ( B > A ),F2: ( A > B )] :
      ( ! [X4: A] :
          ( ( G2 @ ( F2 @ X4 ) )
          = X4 )
     => ( ( image @ B @ A @ G2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surjI
thf(fact_192_surjE,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ~ ( ! [X4: B] :
              ( Y
             != ( F2 @ X4 ) ) ) ) )).

% surjE
thf(fact_193_surjD,axiom,(
    ! [A: $tType,B: $tType,F2: ( B > A ),Y: A] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ? [X4: B] :
          ( Y
          = ( F2 @ X4 ) ) ) )).

% surjD
thf(fact_194_map__prod__surj,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,F2: ( A > B ),G2: ( C > D )] :
      ( ( ( image @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ B ) ) )
     => ( ( ( image @ C @ D @ G2 @ ( top_top @ ( set @ C ) ) )
          = ( top_top @ ( set @ D ) ) )
       => ( ( image @ ( product_prod @ A @ C ) @ ( product_prod @ B @ D ) @ ( product_map_prod @ A @ B @ C @ D @ F2 @ G2 ) @ ( top_top @ ( set @ ( product_prod @ A @ C ) ) ) )
          = ( top_top @ ( set @ ( product_prod @ B @ D ) ) ) ) ) ) )).

% map_prod_surj
thf(fact_195_let__prs,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R12: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R22: ( C > C > $o ),Abs2: ( C > D ),Rep2: ( D > C )] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R22 @ Abs2 @ Rep2 )
       => ( ( map_fun @ D @ C @ ( ( C > A ) > A ) @ ( ( D > B ) > B ) @ Rep2 @ ( map_fun @ ( D > B ) @ ( C > A ) @ A @ B @ ( map_fun @ C @ D @ B @ A @ Abs2 @ Rep1 ) @ Abs1 )
            @ ^ [S3: C,F: ( C > A )] :
                ( F @ S3 ) )
          = ( ^ [S3: D,F: ( D > B )] :
                ( F @ S3 ) ) ) ) ) )).

% let_prs
thf(fact_196_UNIV__witness,axiom,(
    ! [A: $tType] :
    ? [X4: A] :
      ( member @ A @ X4 @ ( top_top @ ( set @ A ) ) ) )).

% UNIV_witness
thf(fact_197_UNIV__eq__I,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ! [X4: A] :
          ( member @ A @ X4 @ A5 )
     => ( ( top_top @ ( set @ A ) )
        = A5 ) ) )).

% UNIV_eq_I
thf(fact_198_identity__quotient3,axiom,(
    ! [A: $tType] :
      ( quotient3 @ A @ A
      @ ^ [Y3: A,Z4: A] : ( Y3 = Z4 )
      @ ( id @ A )
      @ ( id @ A ) ) )).

% identity_quotient3
thf(fact_199_if__prs,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( map_fun @ $o @ $o @ ( A > A > A ) @ ( B > B > B ) @ ( id @ $o ) @ ( map_fun @ B @ A @ ( A > A ) @ ( B > B ) @ Rep @ ( map_fun @ B @ A @ A @ B @ Rep @ Abs ) ) @ ( if @ A ) )
        = ( if @ B ) ) ) )).

% if_prs
thf(fact_200_id__prs,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( map_fun @ B @ A @ A @ B @ Rep @ Abs @ ( id @ A ) )
        = ( id @ B ) ) ) )).

% id_prs
thf(fact_201_o__prs_I1_J,axiom,(
    ! [C: $tType,E: $tType,A: $tType,B: $tType,F4: $tType,D: $tType,R12: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R22: ( C > C > $o ),Abs2: ( C > D ),Rep2: ( D > C ),R32: ( E > E > $o ),Abs3: ( E > F4 ),Rep3: ( F4 > E )] :
      ( ( quotient3 @ A @ B @ R12 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R22 @ Abs2 @ Rep2 )
       => ( ( quotient3 @ E @ F4 @ R32 @ Abs3 @ Rep3 )
         => ( ( map_fun @ ( D > F4 ) @ ( C > E ) @ ( ( A > C ) > A > E ) @ ( ( B > D ) > B > F4 ) @ ( map_fun @ C @ D @ F4 @ E @ Abs2 @ Rep3 ) @ ( map_fun @ ( B > D ) @ ( A > C ) @ ( A > E ) @ ( B > F4 ) @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep2 ) @ ( map_fun @ B @ A @ E @ F4 @ Rep1 @ Abs3 ) ) @ ( comp @ C @ E @ A ) )
            = ( comp @ D @ F4 @ B ) ) ) ) ) )).

% o_prs(1)
thf(fact_202_abs__o__rep,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( comp @ A @ B @ B @ Abs @ Rep )
        = ( id @ B ) ) ) )).

% abs_o_rep
thf(fact_203_DEADID_Oin__rel,axiom,(
    ! [B: $tType] :
      ( ( ^ [Y3: B,Z4: B] : ( Y3 = Z4 ) )
      = ( ^ [A4: B,B3: B] :
          ? [Z: B] :
            ( ( member @ B @ Z @ ( top_top @ ( set @ B ) ) )
            & ( ( id @ B @ Z )
              = A4 )
            & ( ( id @ B @ Z )
              = B3 ) ) ) ) )).

% DEADID.in_rel
thf(fact_204_comp__surj,axiom,(
    ! [B: $tType,A: $tType,C: $tType,F2: ( B > A ),G2: ( A > C )] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( ( image @ A @ C @ G2 @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ C ) ) )
       => ( ( image @ B @ C @ ( comp @ A @ C @ B @ G2 @ F2 ) @ ( top_top @ ( set @ B ) ) )
          = ( top_top @ ( set @ C ) ) ) ) ) )).

% comp_surj
thf(fact_205_fun_Oset__map,axiom,(
    ! [B: $tType,A: $tType,D: $tType,F2: ( A > B ),V: ( D > A )] :
      ( ( image @ D @ B @ ( comp @ A @ B @ D @ F2 @ V ) @ ( top_top @ ( set @ D ) ) )
      = ( image @ A @ B @ F2 @ ( image @ D @ A @ V @ ( top_top @ ( set @ D ) ) ) ) ) )).

% fun.set_map
thf(fact_206_fun_Omap__cong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( D > A ),Ya: ( D > A ),F2: ( A > B ),G2: ( A > B )] :
      ( ( X2 = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( image @ D @ A @ Ya @ ( top_top @ ( set @ D ) ) ) )
           => ( ( F2 @ Z3 )
              = ( G2 @ Z3 ) ) )
       => ( ( comp @ A @ B @ D @ F2 @ X2 )
          = ( comp @ A @ B @ D @ G2 @ Ya ) ) ) ) )).

% fun.map_cong
thf(fact_207_fun_Omap__cong0,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( D > A ),F2: ( A > B ),G2: ( A > B )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( image @ D @ A @ X2 @ ( top_top @ ( set @ D ) ) ) )
         => ( ( F2 @ Z3 )
            = ( G2 @ Z3 ) ) )
     => ( ( comp @ A @ B @ D @ F2 @ X2 )
        = ( comp @ A @ B @ D @ G2 @ X2 ) ) ) )).

% fun.map_cong0
thf(fact_208_fun_Oinj__map__strong,axiom,(
    ! [B: $tType,A: $tType,D: $tType,X2: ( D > A ),Xa: ( D > A ),F2: ( A > B ),Fa: ( A > B )] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( image @ D @ A @ X2 @ ( top_top @ ( set @ D ) ) ) )
         => ( ( member @ A @ Za @ ( image @ D @ A @ Xa @ ( top_top @ ( set @ D ) ) ) )
           => ( ( ( F2 @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( comp @ A @ B @ D @ F2 @ X2 )
          = ( comp @ A @ B @ D @ Fa @ Xa ) )
       => ( X2 = Xa ) ) ) )).

% fun.inj_map_strong
thf(fact_209_surj__id,axiom,(
    ! [A: $tType] :
      ( ( image @ A @ A @ ( id @ A ) @ ( top_top @ ( set @ A ) ) )
      = ( top_top @ ( set @ A ) ) ) )).

% surj_id
thf(fact_210_surj__imp__surj__swap,axiom,(
    ! [B: $tType,A: $tType,F2: ( B > A ),A2: B,B2: B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ B @ A @ ( swap @ B @ A @ A2 @ B2 @ F2 ) @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) ) ) )).

% surj_imp_surj_swap
thf(fact_211_surj__fun__eq,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F2: ( B > A ),X6: ( set @ B ),G1: ( A > C ),G22: ( A > C )] :
      ( ( ( image @ B @ A @ F2 @ X6 )
        = ( top_top @ ( set @ A ) ) )
     => ( ! [X4: B] :
            ( ( member @ B @ X4 @ X6 )
           => ( ( comp @ A @ C @ B @ G1 @ F2 @ X4 )
              = ( comp @ A @ C @ B @ G22 @ F2 @ X4 ) ) )
       => ( G1 = G22 ) ) ) )).

% surj_fun_eq
thf(fact_212_type__copy__map__id0,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A ),M: ( B > B )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( id @ B ) )
       => ( ( comp @ B @ A @ A @ ( comp @ B @ A @ B @ Abs @ M ) @ Rep )
          = ( id @ A ) ) ) ) )).

% type_copy_map_id0
thf(fact_213_type__copy__Abs__o__Rep,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( comp @ B @ A @ A @ Abs @ Rep )
        = ( id @ A ) ) ) )).

% type_copy_Abs_o_Rep
thf(fact_214_type__copy__obj__one__point__absE,axiom,(
    ! [A: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),S: A] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ~ ( ! [X4: B] :
              ( S
             != ( Abs @ X4 ) ) ) ) )).

% type_copy_obj_one_point_absE
thf(fact_215_type__copy__ex__RepI,axiom,(
    ! [B: $tType,A: $tType,Rep: ( A > B ),Abs: ( B > A ),F6: ( B > $o )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ^ [P6: ( B > $o )] :
            ? [X7: B] :
              ( P6 @ X7 )
          @ F6 )
        = ( ? [B3: A] :
              ( F6 @ ( Rep @ B3 ) ) ) ) ) )).

% type_copy_ex_RepI
thf(fact_216_type__copy__wit,axiom,(
    ! [A: $tType,C: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A ),X2: C,S2: ( B > ( set @ C ) ),Y: B] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( member @ C @ X2 @ ( comp @ B @ ( set @ C ) @ A @ S2 @ Rep @ ( Abs @ Y ) ) )
       => ( member @ C @ X2 @ ( S2 @ Y ) ) ) ) )).

% type_copy_wit
thf(fact_217_type__copy__map__comp0__undo,axiom,(
    ! [E: $tType,A: $tType,C: $tType,B: $tType,D: $tType,F4: $tType,Rep: ( A > B ),Abs: ( B > A ),Rep4: ( C > D ),Abs4: ( D > C ),Rep5: ( E > F4 ),Abs5: ( F4 > E ),M: ( F4 > D ),M1: ( B > D ),M22: ( F4 > B )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( type_definition @ C @ D @ Rep4 @ Abs4 @ ( top_top @ ( set @ D ) ) )
       => ( ( type_definition @ E @ F4 @ Rep5 @ Abs5 @ ( top_top @ ( set @ F4 ) ) )
         => ( ( ( comp @ F4 @ C @ E @ ( comp @ D @ C @ F4 @ Abs4 @ M ) @ Rep5 )
              = ( comp @ A @ C @ E @ ( comp @ B @ C @ A @ ( comp @ D @ C @ B @ Abs4 @ M1 ) @ Rep ) @ ( comp @ F4 @ A @ E @ ( comp @ B @ A @ F4 @ Abs @ M22 ) @ Rep5 ) ) )
           => ( ( comp @ B @ D @ F4 @ M1 @ M22 )
              = M ) ) ) ) ) )).

% type_copy_map_comp0_undo
thf(fact_218_type__copy__map__comp0,axiom,(
    ! [F4: $tType,D: $tType,B: $tType,A: $tType,C: $tType,E: $tType,Rep: ( A > B ),Abs: ( B > A ),M: ( C > D ),M1: ( B > D ),M22: ( C > B ),F2: ( D > F4 ),G2: ( E > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( M
          = ( comp @ B @ D @ C @ M1 @ M22 ) )
       => ( ( comp @ C @ F4 @ E @ ( comp @ D @ F4 @ C @ F2 @ M ) @ G2 )
          = ( comp @ A @ F4 @ E @ ( comp @ B @ F4 @ A @ ( comp @ D @ F4 @ B @ F2 @ M1 ) @ Rep ) @ ( comp @ C @ A @ E @ ( comp @ B @ A @ C @ Abs @ M22 ) @ G2 ) ) ) ) ) )).

% type_copy_map_comp0
thf(fact_219_type__copy__set__map0,axiom,(
    ! [A: $tType,B: $tType,D: $tType,E: $tType,C: $tType,F4: $tType,Rep: ( A > B ),Abs: ( B > A ),S2: ( B > ( set @ D ) ),M: ( C > B ),F2: ( E > D ),S4: ( C > ( set @ E ) ),G2: ( F4 > C )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( ( comp @ B @ ( set @ D ) @ C @ S2 @ M )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ C @ ( image @ E @ D @ F2 ) @ S4 ) )
       => ( ( comp @ A @ ( set @ D ) @ F4 @ ( comp @ B @ ( set @ D ) @ A @ S2 @ Rep ) @ ( comp @ C @ A @ F4 @ ( comp @ B @ A @ C @ Abs @ M ) @ G2 ) )
          = ( comp @ ( set @ E ) @ ( set @ D ) @ F4 @ ( image @ E @ D @ F2 ) @ ( comp @ C @ ( set @ E ) @ F4 @ S4 @ G2 ) ) ) ) ) )).

% type_copy_set_map0
thf(fact_220_type__copy__Rep__o__Abs,axiom,(
    ! [A: $tType,B: $tType,Rep: ( A > B ),Abs: ( B > A )] :
      ( ( type_definition @ A @ B @ Rep @ Abs @ ( top_top @ ( set @ B ) ) )
     => ( ( comp @ A @ B @ B @ Rep @ Abs )
        = ( id @ B ) ) ) )).

% type_copy_Rep_o_Abs
thf(fact_221_type__definition_OAbs__image,axiom,(
    ! [A: $tType,B: $tType,Rep: ( B > A ),Abs: ( A > B ),A5: ( set @ A )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A5 )
     => ( ( image @ A @ B @ Abs @ A5 )
        = ( top_top @ ( set @ B ) ) ) ) )).

% type_definition.Abs_image
thf(fact_222_type__definition_ORep__range,axiom,(
    ! [B: $tType,A: $tType,Rep: ( B > A ),Abs: ( A > B ),A5: ( set @ A )] :
      ( ( type_definition @ B @ A @ Rep @ Abs @ A5 )
     => ( ( image @ B @ A @ Rep @ ( top_top @ ( set @ B ) ) )
        = A5 ) ) )).

% type_definition.Rep_range
thf(fact_223_BNF__Composition_Otype__definition__id__bnf__UNIV,axiom,(
    ! [A: $tType] :
      ( type_definition @ A @ A @ ( bNF_id_bnf @ A ) @ ( bNF_id_bnf @ A ) @ ( top_top @ ( set @ A ) ) ) )).

% BNF_Composition.type_definition_id_bnf_UNIV
thf(fact_224_image__bind,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( B > A ),A5: ( set @ C ),G2: ( C > ( set @ B ) )] :
      ( ( image @ B @ A @ F2 @ ( bind @ C @ B @ A5 @ G2 ) )
      = ( bind @ C @ A @ A5 @ ( comp @ ( set @ B ) @ ( set @ A ) @ C @ ( image @ B @ A @ F2 ) @ G2 ) ) ) )).

% image_bind
thf(fact_225_ID_Opred__map,axiom,(
    ! [B: $tType,A: $tType,Q: ( B > $o ),F2: ( A > B ),X2: A] :
      ( ( bNF_id_bnf @ ( B > $o ) @ Q @ ( bNF_id_bnf @ ( A > B ) @ F2 @ X2 ) )
      = ( bNF_id_bnf @ ( A > $o ) @ ( comp @ B @ $o @ A @ Q @ F2 ) @ X2 ) ) )).

% ID.pred_map
thf(fact_226_BNF__Composition_Oid__bnf__def,axiom,(
    ! [A: $tType] :
      ( ( bNF_id_bnf @ A )
      = ( ^ [X: A] : X ) ) )).

% BNF_Composition.id_bnf_def
thf(fact_227_id__bnf__apply,axiom,(
    ! [A: $tType] :
      ( ( bNF_id_bnf @ A )
      = ( ^ [X: A] : X ) ) )).

% id_bnf_apply
thf(fact_228_bind__image,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F2: ( C > B ),A5: ( set @ C ),G2: ( B > ( set @ A ) )] :
      ( ( bind @ B @ A @ ( image @ C @ B @ F2 @ A5 ) @ G2 )
      = ( bind @ C @ A @ A5 @ ( comp @ B @ ( set @ A ) @ C @ G2 @ F2 ) ) ) )).

% bind_image
thf(fact_229_prod_Osplit__sel__asm,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( C > $o ),F2: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) )).

% prod.split_sel_asm
thf(fact_230_prod_Osplit__sel,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( C > $o ),F2: ( A > B > C ),Prod: ( product_prod @ A @ B )] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) )).

% prod.split_sel
thf(fact_231_case__prod__Pair,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) )
      = ( id @ ( product_prod @ A @ B ) ) ) )).

% case_prod_Pair
thf(fact_232_case__prod__beta,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ A )
      = ( ^ [F: ( B > C > A ),P4: ( product_prod @ B @ C )] :
            ( F @ ( product_fst @ B @ C @ P4 ) @ ( product_snd @ B @ C @ P4 ) ) ) ) )).

% case_prod_beta
thf(fact_233_prod_Ocase__eq__if,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( product_case_prod @ A @ B @ C )
      = ( ^ [F: ( A > B > C ),Prod3: ( product_prod @ A @ B )] :
            ( F @ ( product_fst @ A @ B @ Prod3 ) @ ( product_snd @ A @ B @ Prod3 ) ) ) ) )).

% prod.case_eq_if
thf(fact_234_internal__case__prod__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( produc2004651681e_prod @ A @ B @ C )
      = ( product_case_prod @ A @ B @ C ) ) )).

% internal_case_prod_def
thf(fact_235_sndOp__in,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Ac2: ( product_prod @ A @ B ),P: ( A > C > $o ),Q: ( C > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ Ac2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( relcompp @ A @ C @ B @ P @ Q ) ) ) )
     => ( member @ ( product_prod @ C @ B ) @ ( bNF_sndOp @ A @ C @ B @ P @ Q @ Ac2 ) @ ( collect @ ( product_prod @ C @ B ) @ ( product_case_prod @ C @ B @ $o @ Q ) ) ) ) )).

% sndOp_in
thf(fact_236_fstOp__in,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Ac2: ( product_prod @ A @ B ),P: ( A > C > $o ),Q: ( C > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ Ac2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( relcompp @ A @ C @ B @ P @ Q ) ) ) )
     => ( member @ ( product_prod @ A @ C ) @ ( bNF_fstOp @ A @ C @ B @ P @ Q @ Ac2 ) @ ( collect @ ( product_prod @ A @ C ) @ ( product_case_prod @ A @ C @ $o @ P ) ) ) ) )).

% fstOp_in
thf(fact_237_split__cong,axiom,(
    ! [C: $tType,B: $tType,A: $tType,Q2: ( product_prod @ A @ B ),F2: ( A > B > C ),G2: ( A > B > C ),P3: ( product_prod @ A @ B )] :
      ( ! [X4: A,Y4: B] :
          ( ( ( product_Pair @ A @ B @ X4 @ Y4 )
            = Q2 )
         => ( ( F2 @ X4 @ Y4 )
            = ( G2 @ X4 @ Y4 ) ) )
     => ( ( P3 = Q2 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P3 )
          = ( product_case_prod @ A @ B @ C @ G2 @ Q2 ) ) ) ) )).

% split_cong
thf(fact_238_mem__case__prodE,axiom,(
    ! [B: $tType,A: $tType,C: $tType,Z2: A,C2: ( B > C > ( set @ A ) ),P3: ( product_prod @ B @ C )] :
      ( ( member @ A @ Z2 @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P3 ) )
     => ~ ( ! [X4: B,Y4: C] :
              ( ( P3
                = ( product_Pair @ B @ C @ X4 @ Y4 ) )
             => ~ ( member @ A @ Z2 @ ( C2 @ X4 @ Y4 ) ) ) ) ) )).

% mem_case_prodE
thf(fact_239_old_Oprod_Ocase,axiom,(
    ! [A: $tType,C: $tType,B: $tType,F2: ( A > B > C ),X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F2 @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F2 @ X1 @ X22 ) ) )).

% old.prod.case
thf(fact_240_Product__Type_OCollect__case__prodD,axiom,(
    ! [B: $tType,A: $tType,X2: ( product_prod @ A @ B ),A5: ( A > B > $o )] :
      ( ( member @ ( product_prod @ A @ B ) @ X2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A5 ) ) )
     => ( A5 @ ( product_fst @ A @ B @ X2 ) @ ( product_snd @ A @ B @ X2 ) ) ) )).

% Product_Type.Collect_case_prodD
thf(fact_241_convol__image__vimage2p,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F2: ( C > A ),G2: ( D > B ),R3: ( A > B > $o )] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B ) @ ( bNF_convol @ ( product_prod @ C @ D ) @ A @ B @ ( comp @ C @ A @ ( product_prod @ C @ D ) @ F2 @ ( product_fst @ C @ D ) ) @ ( comp @ D @ B @ ( product_prod @ C @ D ) @ G2 @ ( product_snd @ C @ D ) ) ) @ ( collect @ ( product_prod @ C @ D ) @ ( product_case_prod @ C @ D @ $o @ ( bNF_vimage2p @ C @ A @ D @ B @ $o @ F2 @ G2 @ R3 ) ) ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ R3 ) ) ) )).

% convol_image_vimage2p
thf(fact_242_Collect__case__prod__Grp__eqD,axiom,(
    ! [B: $tType,A: $tType,Z2: ( product_prod @ A @ B ),A5: ( set @ A ),F2: ( A > B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Z2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A5 @ F2 ) ) ) )
     => ( ( comp @ A @ B @ ( product_prod @ A @ B ) @ F2 @ ( product_fst @ A @ B ) @ Z2 )
        = ( product_snd @ A @ B @ Z2 ) ) ) )).

% Collect_case_prod_Grp_eqD
thf(fact_243_subsetI,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ A5 )
         => ( member @ A @ X4 @ B4 ) )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B4 ) ) )).

% subsetI
thf(fact_244_subset__antisym,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( ord_less_eq @ ( set @ A ) @ B4 @ A5 )
       => ( A5 = B4 ) ) ) )).

% subset_antisym
thf(fact_245_convol__mem__GrpI,axiom,(
    ! [B: $tType,A: $tType,X2: A,A5: ( set @ A ),G2: ( A > B )] :
      ( ( member @ A @ X2 @ A5 )
     => ( member @ ( product_prod @ A @ B ) @ ( bNF_convol @ A @ A @ B @ ( id @ A ) @ G2 @ X2 ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A5 @ G2 ) ) ) ) ) )).

% convol_mem_GrpI
thf(fact_246_Collect__case__prod__Grp__in,axiom,(
    ! [B: $tType,A: $tType,Z2: ( product_prod @ A @ B ),A5: ( set @ A ),F2: ( A > B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Z2 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ ( bNF_Grp @ A @ B @ A5 @ F2 ) ) ) )
     => ( member @ A @ ( product_fst @ A @ B @ Z2 ) @ A5 ) ) )).

% Collect_case_prod_Grp_in
thf(fact_247_set__mp,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( member @ A @ X2 @ A5 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% set_mp
thf(fact_248_in__mono,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( member @ A @ X2 @ A5 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% in_mono
thf(fact_249_subsetD,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetD
thf(fact_250_subsetCE,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A ),C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
     => ( ( member @ A @ C2 @ A5 )
       => ( member @ A @ C2 @ B4 ) ) ) )).

% subsetCE
thf(fact_251_equalityE,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( A5 = B4 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B4 @ A5 ) ) ) )).

% equalityE
thf(fact_252_subset__eq,axiom,(
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A3: ( set @ A ),B7: ( set @ A )] :
          ! [X: A] :
            ( ( member @ A @ X @ A3 )
           => ( member @ A @ X @ B7 ) ) ) ) )).

% subset_eq
thf(fact_253_equalityD1,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( A5 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ A5 @ B4 ) ) )).

% equalityD1
thf(fact_254_equalityD2,axiom,(
    ! [A: $tType,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( A5 = B4 )
     => ( ord_less_eq @ ( set @ A ) @ B4 @ A5 ) ) )).

% equalityD2
thf(fact_255_set__rev__mp,axiom,(
    ! [A: $tType,X2: A,A5: ( set @ A ),B4: ( set @ A )] :
      ( ( member @ A @ X2 @ A5 )
     => ( ( ord_less_eq @ ( set @ A ) @ A5 @ B4 )
       => ( member @ A @ X2 @ B4 ) ) ) )).

% set_rev_mp

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $false @ X2 @ Y )
      = Y ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X2: A,Y: A] :
      ( ( if @ A @ $true @ X2 @ Y )
      = X2 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( stream1967106959u_comp @ c @ b @ a @ sp @ sp2 )
    = ( stream104478819_comp2 @ c @ b @ a @ sp @ sp2 ) )).

%------------------------------------------------------------------------------
