%------------------------------------------------------------------------------
% File     : DAT291^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : MAP_o
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : MAP_o_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :   10 (   0 unit;   5 type;   0 defn)
%            Number of atoms       :   70 (   4 equality;  52 variable)
%            Maximal formula depth :   15 (   9 average)
%            Number of connectives :   67 (   0   ~;   0   |;   1   &;  64   @)
%                                         (   0 <=>;   2  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   18 (  18   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    7 (   5   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   32 (   0 sgn;  25   !;   0   ?;   0   ^)
%                                         (  32   :;   7  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_type_type/ind_types/list',type,(
    'type/ind_types/list': $tType > $tType )).

thf('thf_const_const/trivia/o',type,(
    'const/trivia/o': 
      !>[B: $tType,A: $tType,C: $tType] :
        ( ( B > C ) > ( A > B ) > A > C ) )).

thf('thf_const_const/lists/MAP',type,(
    'const/lists/MAP': 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( 'type/ind_types/list' @ A ) > ( 'type/ind_types/list' @ B ) ) )).

thf('thf_const_const/ind_types/NIL',type,(
    'const/ind_types/NIL': 
      !>[A: $tType] :
        ( 'type/ind_types/list' @ A ) )).

thf('thf_const_const/ind_types/CONS',type,(
    'const/ind_types/CONS': 
      !>[A: $tType] :
        ( A > ( 'type/ind_types/list' @ A ) > ( 'type/ind_types/list' @ A ) ) )).

thf('thm/ind_types/list_INDUCT_',axiom,(
    ! [A: $tType,P: ( 'type/ind_types/list' @ A ) > $o] :
      ( ( ( P @ ( 'const/ind_types/NIL' @ A ) )
        & ! [A0: A,A1: 'type/ind_types/list' @ A] :
            ( ( P @ A1 )
           => ( P @ ( 'const/ind_types/CONS' @ A @ A0 @ A1 ) ) ) )
     => ! [A0: 'type/ind_types/list' @ A] :
          ( P @ A0 ) ) )).

thf('thm/lists/MAP_1',axiom,(
    ! [B: $tType,A: $tType,A0: A > B,A1: A,A2: 'type/ind_types/list' @ A] :
      ( ( 'const/lists/MAP' @ A @ B @ A0 @ ( 'const/ind_types/CONS' @ A @ A1 @ A2 ) )
      = ( 'const/ind_types/CONS' @ B @ ( A0 @ A1 ) @ ( 'const/lists/MAP' @ A @ B @ A0 @ A2 ) ) ) )).

thf('thm/trivia/o_THM_',axiom,(
    ! [C: $tType,B: $tType,A: $tType,A0: B > C,A1: A > B,A2: A] :
      ( ( 'const/trivia/o' @ B @ A @ C @ A0 @ A1 @ A2 )
      = ( A0 @ ( A1 @ A2 ) ) ) )).

thf('thm/lists/MAP_0',axiom,(
    ! [A: $tType,B: $tType,A0: A > B] :
      ( ( 'const/lists/MAP' @ A @ B @ A0 @ ( 'const/ind_types/NIL' @ A ) )
      = ( 'const/ind_types/NIL' @ B ) ) )).

thf('thm/lists/MAP_o_',conjecture,(
    ! [C: $tType,B: $tType,A: $tType,A0: A > B,A1: B > C,A2: 'type/ind_types/list' @ A] :
      ( ( 'const/lists/MAP' @ A @ C @ ( 'const/trivia/o' @ B @ A @ C @ A1 @ A0 ) @ A2 )
      = ( 'const/lists/MAP' @ B @ C @ A1 @ ( 'const/lists/MAP' @ A @ B @ A0 @ A2 ) ) ) )).

%------------------------------------------------------------------------------
