%------------------------------------------------------------------------------
% File     : DAT292^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : ALL_IMP
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : ALL_IMP_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :   13 (   0 unit;   6 type;   0 defn)
%            Number of atoms       :   76 (   6 equality;  52 variable)
%            Maximal formula depth :   13 (   7 average)
%            Number of connectives :   68 (   0   ~;   1   |;   4   &;  59   @)
%                                         (   0 <=>;   4  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   14 (  14   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   10 (   6   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   29 (   0 sgn;  24   !;   0   ?;   0   ^)
%                                         (  29   :;   5  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_type_type/ind_types/list',type,(
    'type/ind_types/list': $tType > $tType )).

thf('thf_const_const/trivia/I',type,(
    'const/trivia/I': 
      !>[A: $tType] :
        ( A > A ) )).

thf('thf_const_const/lists/MEM',type,(
    'const/lists/MEM': 
      !>[A: $tType] :
        ( A > ( 'type/ind_types/list' @ A ) > $o ) )).

thf('thf_const_const/lists/ALL',type,(
    'const/lists/ALL': 
      !>[A: $tType] :
        ( ( A > $o ) > ( 'type/ind_types/list' @ A ) > $o ) )).

thf('thf_const_const/ind_types/NIL',type,(
    'const/ind_types/NIL': 
      !>[A: $tType] :
        ( 'type/ind_types/list' @ A ) )).

thf('thf_const_const/ind_types/CONS',type,(
    'const/ind_types/CONS': 
      !>[A: $tType] :
        ( A > ( 'type/ind_types/list' @ A ) > ( 'type/ind_types/list' @ A ) ) )).

thf('thm/ind_types/list_INDUCT_',axiom,(
    ! [A: $tType,P: ( 'type/ind_types/list' @ A ) > $o] :
      ( ( ( P @ ( 'const/ind_types/NIL' @ A ) )
        & ! [A0: A,A1: 'type/ind_types/list' @ A] :
            ( ( P @ A1 )
           => ( P @ ( 'const/ind_types/CONS' @ A @ A0 @ A1 ) ) ) )
     => ! [A0: 'type/ind_types/list' @ A] :
          ( P @ A0 ) ) )).

thf('thm/trivia/I_THM_',axiom,(
    ! [A: $tType,A0: A] :
      ( ( 'const/trivia/I' @ A @ A0 )
      = A0 ) )).

thf('thm/lists/ALL_1',axiom,(
    ! [A: $tType,A0: A,P: A > $o,A1: 'type/ind_types/list' @ A] :
      ( ( 'const/lists/ALL' @ A @ P @ ( 'const/ind_types/CONS' @ A @ A0 @ A1 ) )
      = ( ( P @ A0 )
        & ( 'const/lists/ALL' @ A @ P @ A1 ) ) ) )).

thf('thm/lists/MEM_1',axiom,(
    ! [A: $tType,A0: A,A1: A,A2: 'type/ind_types/list' @ A] :
      ( ( 'const/lists/MEM' @ A @ A1 @ ( 'const/ind_types/CONS' @ A @ A0 @ A2 ) )
      = ( ( A1 = A0 )
        | ( 'const/lists/MEM' @ A @ A1 @ A2 ) ) ) )).

thf('thm/lists/ALL_0',axiom,(
    ! [A: $tType,P: A > $o] :
      ( ( 'const/lists/ALL' @ A @ P @ ( 'const/ind_types/NIL' @ A ) )
      = $true ) )).

thf('thm/lists/MEM_0',axiom,(
    ! [A: $tType,A0: A] :
      ( ( 'const/lists/MEM' @ A @ A0 @ ( 'const/ind_types/NIL' @ A ) )
      = $false ) )).

thf('thm/lists/ALL_IMP_',conjecture,(
    ! [A: $tType,P: A > $o,Q: A > $o,A0: 'type/ind_types/list' @ A] :
      ( ( ! [A1: A] :
            ( ( ( 'const/lists/MEM' @ A @ A1 @ A0 )
              & ( P @ A1 ) )
           => ( Q @ A1 ) )
        & ( 'const/lists/ALL' @ A @ P @ A0 ) )
     => ( 'const/lists/ALL' @ A @ Q @ A0 ) ) )).

%------------------------------------------------------------------------------
