%------------------------------------------------------------------------------
% File     : NUN046^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Number theory
% Problem  : MONOIDAL_AC
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : MONOIDAL_AC_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :    6 (   0 unit;   3 type;   0 defn)
%            Number of atoms       :   80 (  10 equality;  64 variable)
%            Maximal formula depth :   16 (   9 average)
%            Number of connectives :   57 (   0   ~;   0   |;   6   &;  50   @)
%                                         (   0 <=>;   1  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   11 (  11   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    5 (   3   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   25 (   0 sgn;  22   !;   0   ?;   0   ^)
%                                         (  25   :;   3  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_const_const/trivia/I',type,(
    'const/trivia/I': 
      !>[A: $tType] :
        ( A > A ) )).

thf('thf_const_const/iterate/neutral',type,(
    'const/iterate/neutral': 
      !>[A: $tType] :
        ( ( A > A > A ) > A ) )).

thf('thf_const_const/iterate/monoidal',type,(
    'const/iterate/monoidal': 
      !>[A: $tType] :
        ( ( A > A > A ) > $o ) )).

thf('thm/trivia/I_THM_',axiom,(
    ! [A: $tType,A0: A] :
      ( ( 'const/trivia/I' @ A @ A0 )
      = A0 ) )).

thf('thm/iterate/monoidal_',axiom,(
    ! [A: $tType,A0: A > A > A] :
      ( ( 'const/iterate/monoidal' @ A @ A0 )
      = ( ! [A1: A,A2: A] :
            ( ( A0 @ A1 @ A2 )
            = ( A0 @ A2 @ A1 ) )
        & ! [A1: A,A2: A,A3: A] :
            ( ( A0 @ A1 @ ( A0 @ A2 @ A3 ) )
            = ( A0 @ ( A0 @ A1 @ A2 ) @ A3 ) )
        & ! [A1: A] :
            ( ( A0 @ ( 'const/iterate/neutral' @ A @ A0 ) @ A1 )
            = A1 ) ) ) )).

thf('thm/iterate/MONOIDAL_AC_',conjecture,(
    ! [A: $tType,A0: A > A > A] :
      ( ( 'const/iterate/monoidal' @ A @ A0 )
     => ( ! [A1: A] :
            ( ( A0 @ ( 'const/iterate/neutral' @ A @ A0 ) @ A1 )
            = A1 )
        & ! [A1: A] :
            ( ( A0 @ A1 @ ( 'const/iterate/neutral' @ A @ A0 ) )
            = A1 )
        & ! [A1: A,A2: A] :
            ( ( A0 @ A1 @ A2 )
            = ( A0 @ A2 @ A1 ) )
        & ! [A1: A,A2: A,A3: A] :
            ( ( A0 @ ( A0 @ A1 @ A2 ) @ A3 )
            = ( A0 @ A1 @ ( A0 @ A2 @ A3 ) ) )
        & ! [A1: A,A2: A,A3: A] :
            ( ( A0 @ A1 @ ( A0 @ A2 @ A3 ) )
            = ( A0 @ A2 @ ( A0 @ A1 @ A3 ) ) ) ) ) )).

%------------------------------------------------------------------------------
