%------------------------------------------------------------------------------
% File     : NUN047^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Number theory
% Problem  : NEUTRAL_ADD
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : NEUTRAL_ADD_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :   13 (   0 unit;   7 type;   0 defn)
%            Number of atoms       :   52 (   8 equality;  23 variable)
%            Maximal formula depth :   11 (   5 average)
%            Number of connectives :   30 (   0   ~;   0   |;   1   &;  29   @)
%                                         (   0 <=>;   0  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   11 (  11   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    9 (   7   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   12 (   0 sgn;   9   !;   0   ?;   1   ^)
%                                         (  12   :;   2  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_type_type/nums/num',type,(
    'type/nums/num': $tType )).

thf('thf_const_const/nums/SUC',type,(
    'const/nums/SUC': 'type/nums/num' > 'type/nums/num' )).

thf('thf_const_const/nums/NUMERAL',type,(
    'const/nums/NUMERAL': 'type/nums/num' > 'type/nums/num' )).

thf('thf_const_const/nums/_0',type,(
    'const/nums/_0': 'type/nums/num' )).

thf('thf_const_const/iterate/neutral',type,(
    'const/iterate/neutral': 
      !>[A: $tType] :
        ( ( A > A > A ) > A ) )).

thf('thf_const_const/class/@',type,(
    'const/class/@': 
      !>[A: $tType] :
        ( ( A > $o ) > A ) )).

thf('thf_const_const/arith/+',type,(
    'const/arith/+': 'type/nums/num' > 'type/nums/num' > 'type/nums/num' )).

thf('thm/arith/ADD_SUC_',axiom,(
    ! [A: 'type/nums/num',A0: 'type/nums/num'] :
      ( ( 'const/arith/+' @ A @ ( 'const/nums/SUC' @ A0 ) )
      = ( 'const/nums/SUC' @ ( 'const/arith/+' @ A @ A0 ) ) ) )).

thf('thm/arith/ADD_CLAUSES_2',axiom,(
    ! [A: 'type/nums/num',A0: 'type/nums/num'] :
      ( ( 'const/arith/+' @ ( 'const/nums/SUC' @ A ) @ A0 )
      = ( 'const/nums/SUC' @ ( 'const/arith/+' @ A @ A0 ) ) ) )).

thf('thm/arith/ADD_0_',axiom,(
    ! [A: 'type/nums/num'] :
      ( ( 'const/arith/+' @ A @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) )
      = A ) )).

thf('thm/arith/ADD_CLAUSES_0',axiom,(
    ! [A: 'type/nums/num'] :
      ( ( 'const/arith/+' @ ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) @ A )
      = A ) )).

thf('thm/iterate/neutral_',axiom,(
    ! [A: $tType,A0: A > A > A] :
      ( ( 'const/iterate/neutral' @ A @ A0 )
      = ( 'const/class/@' @ A
        @ ^ [A1: A] :
          ! [A2: A] :
            ( ( ( A0 @ A1 @ A2 )
              = A2 )
            & ( ( A0 @ A2 @ A1 )
              = A2 ) ) ) ) )).

thf('thm/iterate/NEUTRAL_ADD_',conjecture,
    ( ( 'const/iterate/neutral' @ 'type/nums/num' @ 'const/arith/+' )
    = ( 'const/nums/NUMERAL' @ 'const/nums/_0' ) )).

%------------------------------------------------------------------------------
