%------------------------------------------------------------------------------
% File     : SEV451^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : UNION_UNIV_
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : UNION_UNIV_1.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :    8 (   0 unit;   3 type;   0 defn)
%            Number of atoms       :   49 (   6 equality;  31 variable)
%            Maximal formula depth :   10 (   7 average)
%            Number of connectives :   32 (   0   ~;   1   |;   0   &;  31   @)
%                                         (   0 <=>;   0  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   15 (  15   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    5 (   3   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   18 (   0 sgn;  15   !;   0   ?;   0   ^)
%                                         (  18   :;   3  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_const_const/sets/UNIV',type,(
    'const/sets/UNIV': 
      !>[A: $tType] :
        ( A > $o ) )).

thf('thf_const_const/sets/UNION',type,(
    'const/sets/UNION': 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > $o ) > A > $o ) )).

thf('thf_const_const/sets/IN',type,(
    'const/sets/IN': 
      !>[A: $tType] :
        ( A > ( A > $o ) > $o ) )).

thf('thm/sets/IN_UNIV_',axiom,(
    ! [A: $tType,A0: A] :
      ( 'const/sets/IN' @ A @ A0 @ ( 'const/sets/UNIV' @ A ) ) )).

thf('thm/sets/IN_',axiom,(
    ! [A: $tType,P: A > $o,A0: A] :
      ( ( 'const/sets/IN' @ A @ A0 @ P )
      = ( P @ A0 ) ) )).

thf('thm/sets/IN_UNION_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o,A2: A] :
      ( ( 'const/sets/IN' @ A @ A2 @ ( 'const/sets/UNION' @ A @ A0 @ A1 ) )
      = ( ( 'const/sets/IN' @ A @ A2 @ A0 )
        | ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) )).

thf('thm/sets/EXTENSION_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o] :
      ( ( A0 = A1 )
      = ( ! [A2: A] :
            ( ( 'const/sets/IN' @ A @ A2 @ A0 )
            = ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) ) )).

thf('thm/sets/UNION_UNIV_1',conjecture,(
    ! [A: $tType,A0: A > $o] :
      ( ( 'const/sets/UNION' @ A @ A0 @ ( 'const/sets/UNIV' @ A ) )
      = ( 'const/sets/UNIV' @ A ) ) )).

%------------------------------------------------------------------------------
