%------------------------------------------------------------------------------
% File     : SEV454^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : DISJOINT_UNION
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : DISJOINT_UNION_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :   12 (   0 unit;   5 type;   0 defn)
%            Number of atoms       :   85 (   9 equality;  56 variable)
%            Maximal formula depth :   11 (   8 average)
%            Number of connectives :   61 (   1   ~;   1   |;   2   &;  57   @)
%                                         (   0 <=>;   0  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   30 (  30   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    7 (   5   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   29 (   0 sgn;  24   !;   0   ?;   0   ^)
%                                         (  29   :;   5  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_const_const/sets/UNION',type,(
    'const/sets/UNION': 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > $o ) > A > $o ) )).

thf('thf_const_const/sets/INTER',type,(
    'const/sets/INTER': 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > $o ) > A > $o ) )).

thf('thf_const_const/sets/IN',type,(
    'const/sets/IN': 
      !>[A: $tType] :
        ( A > ( A > $o ) > $o ) )).

thf('thf_const_const/sets/EMPTY',type,(
    'const/sets/EMPTY': 
      !>[A: $tType] :
        ( A > $o ) )).

thf('thf_const_const/sets/DISJOINT',type,(
    'const/sets/DISJOINT': 
      !>[A: $tType] :
        ( ( A > $o ) > ( A > $o ) > $o ) )).

thf('thm/sets/NOT_IN_EMPTY_',axiom,(
    ! [A: $tType,A0: A] :
      ~ ( 'const/sets/IN' @ A @ A0 @ ( 'const/sets/EMPTY' @ A ) ) )).

thf('thm/sets/IN_',axiom,(
    ! [A: $tType,P: A > $o,A0: A] :
      ( ( 'const/sets/IN' @ A @ A0 @ P )
      = ( P @ A0 ) ) )).

thf('thm/sets/IN_INTER_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o,A2: A] :
      ( ( 'const/sets/IN' @ A @ A2 @ ( 'const/sets/INTER' @ A @ A0 @ A1 ) )
      = ( ( 'const/sets/IN' @ A @ A2 @ A0 )
        & ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) )).

thf('thm/sets/IN_UNION_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o,A2: A] :
      ( ( 'const/sets/IN' @ A @ A2 @ ( 'const/sets/UNION' @ A @ A0 @ A1 ) )
      = ( ( 'const/sets/IN' @ A @ A2 @ A0 )
        | ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) )).

thf('thm/sets/EXTENSION_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o] :
      ( ( A0 = A1 )
      = ( ! [A2: A] :
            ( ( 'const/sets/IN' @ A @ A2 @ A0 )
            = ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) ) )).

thf('thm/sets/DISJOINT_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o] :
      ( ( 'const/sets/DISJOINT' @ A @ A0 @ A1 )
      = ( ( 'const/sets/INTER' @ A @ A0 @ A1 )
        = ( 'const/sets/EMPTY' @ A ) ) ) )).

thf('thm/sets/DISJOINT_UNION_',conjecture,(
    ! [A: $tType,A0: A > $o,A1: A > $o,A2: A > $o] :
      ( ( 'const/sets/DISJOINT' @ A @ ( 'const/sets/UNION' @ A @ A0 @ A1 ) @ A2 )
      = ( ( 'const/sets/DISJOINT' @ A @ A0 @ A2 )
        & ( 'const/sets/DISJOINT' @ A @ A1 @ A2 ) ) ) )).

%------------------------------------------------------------------------------
