%------------------------------------------------------------------------------
% File     : SEV468^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : UNIONS_IMAGE
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : UNIONS_IMAGE_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :   10 (   0 unit;   5 type;   0 defn)
%            Number of atoms       :   84 (   8 equality;  56 variable)
%            Maximal formula depth :   16 (   9 average)
%            Number of connectives :   61 (   0   ~;   0   |;   3   &;  58   @)
%                                         (   0 <=>;   0  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   31 (  31   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    7 (   5   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   32 (   0 sgn;  19   !;   5   ?;   2   ^)
%                                         (  32   :;   6  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_const_const/sets/UNIONS',type,(
    'const/sets/UNIONS': 
      !>[A: $tType] :
        ( ( ( A > $o ) > $o ) > A > $o ) )).

thf('thf_const_const/sets/SETSPEC',type,(
    'const/sets/SETSPEC': 
      !>[A: $tType] :
        ( A > $o > A > $o ) )).

thf('thf_const_const/sets/IN',type,(
    'const/sets/IN': 
      !>[A: $tType] :
        ( A > ( A > $o ) > $o ) )).

thf('thf_const_const/sets/IMAGE',type,(
    'const/sets/IMAGE': 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( A > $o ) > B > $o ) )).

thf('thf_const_const/sets/GSPEC',type,(
    'const/sets/GSPEC': 
      !>[A: $tType] :
        ( ( A > $o ) > A > $o ) )).

thf('thm/sets/IN_ELIM_THM_1',axiom,(
    ! [A: $tType,A0: A > $o,A1: A] :
      ( ( 'const/sets/IN' @ A @ A1
        @ ( 'const/sets/GSPEC' @ A
          @ ^ [A2: A] :
            ? [A3: A] :
              ( 'const/sets/SETSPEC' @ A @ A2 @ ( A0 @ A3 ) @ A3 ) ) )
      = ( A0 @ A1 ) ) )).

thf('thm/sets/IN_IMAGE_',axiom,(
    ! [B: $tType,A: $tType,A0: B,A1: A > $o,A2: A > B] :
      ( ( 'const/sets/IN' @ B @ A0 @ ( 'const/sets/IMAGE' @ A @ B @ A2 @ A1 ) )
      = ( ? [A3: A] :
            ( ( A0
              = ( A2 @ A3 ) )
            & ( 'const/sets/IN' @ A @ A3 @ A1 ) ) ) ) )).

thf('thm/sets/IN_UNIONS_',axiom,(
    ! [A: $tType,A0: ( A > $o ) > $o,A1: A] :
      ( ( 'const/sets/IN' @ A @ A1 @ ( 'const/sets/UNIONS' @ A @ A0 ) )
      = ( ? [A2: A > $o] :
            ( ( 'const/sets/IN' @ ( A > $o ) @ A2 @ A0 )
            & ( 'const/sets/IN' @ A @ A1 @ A2 ) ) ) ) )).

thf('thm/sets/EXTENSION_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > $o] :
      ( ( A0 = A1 )
      = ( ! [A2: A] :
            ( ( 'const/sets/IN' @ A @ A2 @ A0 )
            = ( 'const/sets/IN' @ A @ A2 @ A1 ) ) ) ) )).

thf('thm/sets/UNIONS_IMAGE_',conjecture,(
    ! [A: $tType,A0: $tType,A1: A > A0 > $o,A2: A > $o] :
      ( ( 'const/sets/UNIONS' @ A0 @ ( 'const/sets/IMAGE' @ A @ ( A0 > $o ) @ A1 @ A2 ) )
      = ( 'const/sets/GSPEC' @ A0
        @ ^ [A3: A0] :
          ? [A4: A0] :
            ( 'const/sets/SETSPEC' @ A0 @ A3
            @ ? [A5: A] :
                ( ( 'const/sets/IN' @ A @ A5 @ A2 )
                & ( 'const/sets/IN' @ A0 @ A4 @ ( A1 @ A5 ) ) )
            @ A4 ) ) ) )).

%------------------------------------------------------------------------------
