%------------------------------------------------------------------------------
% File     : SEV487^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Analysis
% Problem  : PAIRWISE_EMPTY
% Version  : Especial.
% English  :

% Refs     : [Kal16] Kalisyk (2016), Email to Geoff Sutcliffe
% Source   : [Kal16]
% Names    : PAIRWISE_EMPTY_.p [Kal16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :    6 (   0 unit;   3 type;   0 defn)
%            Number of atoms       :   31 (   3 equality;  20 variable)
%            Maximal formula depth :   13 (   7 average)
%            Number of connectives :   24 (   2   ~;   0   |;   2   &;  19   @)
%                                         (   0 <=>;   1  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :   14 (  14   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :    6 (   3   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   :   12 (   0 sgn;   9   !;   0   ?;   0   ^)
%                                         (  12   :;   3  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : Exported from core HOL Light.
%------------------------------------------------------------------------------
thf('thf_const_const/sets/pairwise',type,(
    'const/sets/pairwise': 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > $o ) )).

thf('thf_const_const/sets/IN',type,(
    'const/sets/IN': 
      !>[A: $tType] :
        ( A > ( A > $o ) > $o ) )).

thf('thf_const_const/sets/EMPTY',type,(
    'const/sets/EMPTY': 
      !>[A: $tType] :
        ( A > $o ) )).

thf('thm/sets/NOT_IN_EMPTY_',axiom,(
    ! [A: $tType,A0: A] :
      ~ ( 'const/sets/IN' @ A @ A0 @ ( 'const/sets/EMPTY' @ A ) ) )).

thf('thm/sets/pairwise_',axiom,(
    ! [A: $tType,A0: A > $o,A1: A > A > $o] :
      ( ( 'const/sets/pairwise' @ A @ A1 @ A0 )
      = ( ! [A2: A,A3: A] :
            ( ( ( 'const/sets/IN' @ A @ A2 @ A0 )
              & ( 'const/sets/IN' @ A @ A3 @ A0 )
              & ( A2 != A3 ) )
           => ( A1 @ A2 @ A3 ) ) ) ) )).

thf('thm/sets/PAIRWISE_EMPTY_',conjecture,(
    ! [A: $tType,A0: A > A > $o] :
      ( ( 'const/sets/pairwise' @ A @ A0 @ ( 'const/sets/EMPTY' @ A ) )
      = $true ) )).

%------------------------------------------------------------------------------
