%------------------------------------------------------------------------------
% File     : DAT236^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 931
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__931.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  329 (   0 unit;  64 type;   0 defn)
%            Number of atoms       : 7237 ( 262 equality;4489 variable)
%            Maximal formula depth :   36 (  13 average)
%            Number of connectives : 7626 ( 111   ~;   7   |;  64   &;7152   @)
%                                         (   0 <=>; 292  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  413 ( 413   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   66 (  64   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1744 (   6 sgn;1652   !;   3   ?;  20   ^)
%                                         (1744   :;  69  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:44:15.827
%------------------------------------------------------------------------------
%----Could-be-implicit typings (10)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (54)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_Map_Omap__of,type,(
    map_of: 
      !>[A: $tType,B: $tType] :
        ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) )).

thf(sy_c_Option_Ooption_OSome,type,(
    some: 
      !>[A: $tType] :
        ( A > ( option @ A ) ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance,type,(
    rBT_Im1648453169alance: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__left,type,(
    rBT_Im1278323832e_left: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__right,type,(
    rBT_Im1053358987_right: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obheight,type,(
    rBT_Im315265182height: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > nat ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OB,type,(
    rBT_Impl_Mirabelle_B: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OR,type,(
    rBT_Impl_Mirabelle_R: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor__of,type,(
    rBT_Im1805589839lor_of: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > rBT_Im1923302023_color ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocombine,type,(
    rBT_Im1591839508ombine: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oentries,type,(
    rBT_Im954575269ntries: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oinv1,type,(
    rBT_Im1040612427e_inv1: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oinv1l,type,(
    rBT_Im1071879905_inv1l: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oinv2,type,(
    rBT_Im1040612428e_inv2: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Ois__rbt,type,(
    rBT_Im862805236is_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del,type,(
    rBT_Im1714610413bt_del: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del__from__left,type,(
    rBT_Im1152561598m_left: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del__from__right,type,(
    rBT_Im1808746437_right: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__greater,type,(
    rBT_Im1259024060reater: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__ins,type,(
    rBT_Im1756508336bt_ins: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert,type,(
    rBT_Im852463031insert: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with,type,(
    rBT_Im241132701t_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with__key,type,(
    rBT_Im627674146th_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__less,type,(
    rBT_Im2075124343t_less: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__lookup,type,(
    rBT_Im35466040lookup: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > A > ( option @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__sorted,type,(
    rBT_Im759614907sorted: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Opaint,type,(
    rBT_Im945281971_paint: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Transitive__Closure_Oacyclic,type,(
    transitive_acyclic: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_bb____,type,(
    bb: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_c,type,(
    c: rBT_Im1923302023_color )).

thf(sy_v_k,type,(
    k: a )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_ss____,type,(
    ss: b )).

thf(sy_v_v,type,(
    v: b )).

thf(sy_v_vaa____,type,(
    vaa: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_vbb____,type,(
    vbb: a )).

thf(sy_v_vc____,type,(
    vc: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_vdd____,type,(
    vdd: b )).

thf(sy_v_xx____,type,(
    xx: a )).

thf(sy_v_yy____,type,(
    yy: a )).

%----Relevant facts (256)
thf(fact_0__C4__2_Oprems_C_I6_J,axiom,
    ( rBT_Im1040612427e_inv1 @ a @ b @ bb )).

% "4_2.prems"(6)
thf(fact_1__C4__2_Oprems_C_I8_J,axiom,
    ( rBT_Im1040612428e_inv2 @ a @ b @ bb )).

% "4_2.prems"(8)
thf(fact_2_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_3_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_4_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_5_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C @ B2 )
       => ( less @ C @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_6_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_7_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_8_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_9_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_10_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_11_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_12_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_13_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_14_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_15_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_16_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_trans
thf(fact_17_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_18_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_19_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_20_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_21_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_eq_less_trans
thf(fact_22_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C )
       => ( less @ A2 @ C ) ) ) )).

% local.ord_less_eq_trans
thf(fact_23_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_24_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_25_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_26_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C )
       => ( less @ A2 @ C ) ) ) )).

% local.order.strict_trans
thf(fact_27__C4__2_Oprems_C_I2_J,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ bb )).

% "4_2.prems"(2)
thf(fact_28__C4__2_Oprems_C_I10_J,axiom,
    ( less @ xx @ yy )).

% "4_2.prems"(10)
thf(fact_29_local_Orbt__greater__trans,axiom,(
    ! [C2: $tType,X: a,Y: a,T: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( less @ X @ Y )
     => ( ( rBT_Im1259024060reater @ a @ C2 @ less @ Y @ T )
       => ( rBT_Im1259024060reater @ a @ C2 @ less @ X @ T ) ) ) )).

% local.rbt_greater_trans
thf(fact_30_local_Orbt__less__trans,axiom,(
    ! [C2: $tType,X: a,T: ( rBT_Im246033960le_rbt @ a @ C2 ),Y: a] :
      ( ( rBT_Im2075124343t_less @ a @ C2 @ less @ X @ T )
     => ( ( less @ X @ Y )
       => ( rBT_Im2075124343t_less @ a @ C2 @ less @ Y @ T ) ) ) )).

% local.rbt_less_trans
thf(fact_31__C4__2_Oprems_C_I4_J,axiom,
    ( rBT_Im1259024060reater @ a @ b @ less @ yy @ bb )).

% "4_2.prems"(4)
thf(fact_32__C4__2_Oprems_C_I5_J,axiom,
    ( rBT_Im1040612427e_inv1 @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )).

% "4_2.prems"(5)
thf(fact_33__C4__2_Oprems_C_I7_J,axiom,
    ( rBT_Im1040612428e_inv2 @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )).

% "4_2.prems"(7)
thf(fact_34_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 )
        & ( X24 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_35__C4__2_Oprems_C_I1_J,axiom,
    ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )).

% "4_2.prems"(1)
thf(fact_36_rbt__del__from__left__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Rt )
       => ( ( less @ V @ K )
         => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1152561598m_left @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% rbt_del_from_left_rbt_greater
thf(fact_37_rbt__del__from__left__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Rt )
       => ( ( less @ K @ V )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1152561598m_left @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% rbt_del_from_left_rbt_less
thf(fact_38__C4__2_Oprems_C_I9_J,axiom,
    ( ( rBT_Im315265182height @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )
    = ( rBT_Im315265182height @ a @ b @ bb ) )).

% "4_2.prems"(9)
thf(fact_39__C4__2_Oprems_C_I3_J,axiom,
    ( rBT_Im2075124343t_less @ a @ b @ less @ yy @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )).

% "4_2.prems"(3)
thf(fact_40_rbt__del__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% rbt_del_rbt_greater
thf(fact_41_rbt__del__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% rbt_del_rbt_less
thf(fact_42_rbt__del__rbt__sorted,axiom,(
    ! [B: $tType,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ Lt )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% rbt_del_rbt_sorted
thf(fact_43_local_Oset__entries__inject,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T2 )
       => ( ( ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T1 ) )
            = ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T2 ) ) )
          = ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T2 ) ) ) ) ) )).

% local.set_entries_inject
thf(fact_44_local_Orbt__del__from__left_Osimps_I3_J,axiom,(
    ! [B: $tType,X: a,Va: ( rBT_Im246033960le_rbt @ a @ B ),Vb: a,Vc: B,Vd: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) @ Y @ S @ B2 ) ) )).

% local.rbt_del_from_left.simps(3)
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_50__C4__2_Ohyps_C,axiom,
    ( ( rBT_Im759614907sorted @ a @ b @ less @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )
   => ( ( rBT_Im1040612427e_inv1 @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )
     => ( ( rBT_Im1040612428e_inv2 @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) )
       => ( ( member @ ( product_prod @ a @ b ) @ ( product_Pair @ a @ b @ k @ v ) @ ( set2 @ ( product_prod @ a @ b ) @ ( rBT_Im954575269ntries @ a @ b @ ( rBT_Im1714610413bt_del @ a @ b @ less @ xx @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) ) ) ) )
          = ( ( xx != k )
            & ( member @ ( product_prod @ a @ b ) @ ( product_Pair @ a @ b @ k @ v ) @ ( set2 @ ( product_prod @ a @ b ) @ ( rBT_Im954575269ntries @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) ) ) ) ) ) ) ) )).

% "4_2.hyps"
thf(fact_51_local_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,K: a,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C2 ),Kt: a,V: C2,Rt: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ ( rBT_Im480247531Branch @ a @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ K @ Kt )
        & ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ Lt )
        & ( rBT_Im1259024060reater @ a @ C2 @ less @ K @ Rt ) ) ) )).

% local.rbt_greater_simps(2)
thf(fact_52_local_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,K: a,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C2 ),Kt: a,V: C2,Rt: ( rBT_Im246033960le_rbt @ a @ C2 )] :
      ( ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ ( rBT_Im480247531Branch @ a @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ a @ C2 @ less @ K @ Rt ) ) ) )).

% local.rbt_less_simps(2)
thf(fact_53_ord_Orbt__del__from__left_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) @ Y @ S @ B2 ) ) )).

% ord.rbt_del_from_left.simps(3)
thf(fact_54_local_OacyclicI__order,axiom,(
    ! [B: $tType,R: ( set @ ( product_prod @ B @ B ) ),F: ( B > a )] :
      ( ! [A4: B,B3: B] :
          ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ A4 @ B3 ) @ R )
         => ( less @ ( F @ B3 ) @ ( F @ A4 ) ) )
     => ( transitive_acyclic @ B @ R ) ) )).

% local.acyclicI_order
thf(fact_55_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_56_local_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ C @ L @ K @ V @ R ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
        & ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
        & ( rBT_Im759614907sorted @ a @ B @ less @ L )
        & ( rBT_Im759614907sorted @ a @ B @ less @ R ) ) ) )).

% local.rbt_sorted.simps(2)
thf(fact_57_local_Orbt__insert__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_rbt_sorted
thf(fact_58_local_Orbt__insertw__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_rbt_sorted
thf(fact_59_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X2: a] :
            ( less @ X2 @ U ) ) ) )).

% local.lessThan_def
thf(fact_60_local_Orbt__del__from__right_Osimps_I3_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,Va: ( rBT_Im246033960le_rbt @ a @ B ),Vb: a,Vc: B,Vd: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% local.rbt_del_from_right.simps(3)
thf(fact_61_local_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
          = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% local.rbt_ins.simps(3)
thf(fact_62_local_Orbt__lookup__from__in__tree,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T2: ( rBT_Im246033960le_rbt @ a @ B ),K: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T2 )
       => ( ! [V2: B] :
              ( ( member @ ( product_prod @ a @ B ) @ ( product_Pair @ a @ B @ K @ V2 ) @ ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T1 ) ) )
              = ( member @ ( product_prod @ a @ B ) @ ( product_Pair @ a @ B @ K @ V2 ) @ ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T2 ) ) ) )
         => ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 @ K )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T2 @ K ) ) ) ) ) )).

% local.rbt_lookup_from_in_tree
thf(fact_63_local_Oins__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.ins_rbt_sorted
thf(fact_64_rbt__del__from__right__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Rt )
       => ( ( less @ K @ V )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1808746437_right @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% rbt_del_from_right_rbt_less
thf(fact_65_rbt__del__from__right__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Rt )
       => ( ( less @ V @ K )
         => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1808746437_right @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% rbt_del_from_right_rbt_greater
thf(fact_66_local_Oentries__rbt__lookup,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T2 )
       => ( ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T2 ) )
          = ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T2 ) ) ) ) ) )).

% local.entries_rbt_lookup
thf(fact_67_local_Oentries__eqI,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T2 )
       => ( ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T2 ) )
         => ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T2 ) ) ) ) ) )).

% local.entries_eqI
thf(fact_68_local_Oins__inv1__inv2_I1_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( rBT_Im1040612428e_inv2 @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) ) )).

% local.ins_inv1_inv2(1)
thf(fact_69_local_Oins__inv1__inv2_I2_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( ( rBT_Im315265182height @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
          = ( rBT_Im315265182height @ a @ B @ T ) ) ) ) )).

% local.ins_inv1_inv2(2)
thf(fact_70_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_71_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_72_local_Oins__rbt__less,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T )
        & ( less @ K @ V ) ) ) )).

% local.ins_rbt_less
thf(fact_73_local_Oins__rbt__greater,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ T )
        & ( less @ V @ K ) ) ) )).

% local.ins_rbt_greater
thf(fact_74_local_Orbt__insertwk__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_rbt_sorted
thf(fact_75_local_Orbt__insertw__def,axiom,(
    ! [B: $tType,F: ( B > B > B )] :
      ( ( rBT_Im241132701t_with @ a @ B @ less @ F )
      = ( rBT_Im627674146th_key @ a @ B @ less
        @ ^ [Uu: a] : F ) ) )).

% local.rbt_insertw_def
thf(fact_76_local_Orbt__insert__def,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im852463031insert @ a @ B @ less )
      = ( rBT_Im627674146th_key @ a @ B @ less
        @ ^ [Uu: a,Uv: B,Nv: B] : Nv ) ) )).

% local.rbt_insert_def
thf(fact_77_ord_Oins__inv1__inv2_I2_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( ( rBT_Im315265182height @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) )
          = ( rBT_Im315265182height @ A @ B @ T ) ) ) ) )).

% ord.ins_inv1_inv2(2)
thf(fact_78_ord_Oins__inv1__inv2_I1_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) ) ) ) )).

% ord.ins_inv1_inv2(1)
thf(fact_79_inv2_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C @ Lt @ K @ V @ Rt ) )
      = ( ( rBT_Im1040612428e_inv2 @ A @ B @ Lt )
        & ( rBT_Im1040612428e_inv2 @ A @ B @ Rt )
        & ( ( rBT_Im315265182height @ A @ B @ Lt )
          = ( rBT_Im315265182height @ A @ B @ Rt ) ) ) ) )).

% inv2.simps(2)
thf(fact_80_ord_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V @ R ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ L )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ K @ R )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ L )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ R ) ) ) )).

% ord.rbt_sorted.simps(2)
thf(fact_81_ord_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( A > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
          = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% ord.rbt_ins.simps(3)
thf(fact_82_ord_Orbt__del__from__right_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% ord.rbt_del_from_right.simps(3)
thf(fact_83_ord_Orbt__greater__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType,Less: ( A > A > $o ),K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
      ( ( rBT_Im1259024060reater @ A @ C2 @ Less @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ K @ Kt )
        & ( rBT_Im1259024060reater @ A @ C2 @ Less @ K @ Lt )
        & ( rBT_Im1259024060reater @ A @ C2 @ Less @ K @ Rt ) ) ) )).

% ord.rbt_greater_simps(2)
thf(fact_84_ord_Orbt__less__simps_I2_J,axiom,(
    ! [C2: $tType,A: $tType,Less: ( A > A > $o ),K: A,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C2 ),Kt: A,V: C2,Rt: ( rBT_Im246033960le_rbt @ A @ C2 )] :
      ( ( rBT_Im2075124343t_less @ A @ C2 @ Less @ K @ ( rBT_Im480247531Branch @ A @ C2 @ C @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ A @ C2 @ Less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ A @ C2 @ Less @ K @ Rt ) ) ) )).

% ord.rbt_less_simps(2)
thf(fact_85_local_Orbt__insertw__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_is_rbt
thf(fact_86_local_Orbt__insert__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_is_rbt
thf(fact_87_local_Oins__inv1__inv2_I4_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( rBT_Im1071879905_inv1l @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) ) )).

% local.ins_inv1_inv2(4)
thf(fact_88_local_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) )).

% local.is_rbt_rbt_sorted
thf(fact_89_local_Orbt__del_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,Y: a,C: rBT_Im1923302023_color,A2: ( rBT_Im246033960le_rbt @ a @ B ),S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ X @ Y )
       => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C @ A2 @ Y @ S @ B2 ) )
          = ( rBT_Im1152561598m_left @ a @ B @ less @ X @ A2 @ Y @ S @ B2 ) ) )
      & ( ~ ( less @ X @ Y )
       => ( ( ( less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ B2 ) ) )
          & ( ~ ( less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1591839508ombine @ a @ B @ A2 @ B2 ) ) ) ) ) ) )).

% local.rbt_del.simps(2)
thf(fact_90_local_Obalance__right__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1053358987_right @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_right_rbt_sorted
thf(fact_91_local_Ocombine__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) ) ) )).

% local.combine_rbt_sorted
thf(fact_92_local_Ocombine__rbt__greater,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ L )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
       => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) )).

% local.combine_rbt_greater
thf(fact_93_local_Ocombine__rbt__less,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ R )
       => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) )).

% local.combine_rbt_less
thf(fact_94_local_Obalance__right__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_greater
thf(fact_95_local_Obalance__right__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_less
thf(fact_96_local_Orbt__insertwk__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_is_rbt
thf(fact_97_combine__inv1_I2_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) ) ) ) )).

% combine_inv1(2)
thf(fact_98_balance__right__inv1l,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
     => ( ( rBT_Im1071879905_inv1l @ A @ B @ Rt )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1053358987_right @ A @ B @ Lt @ K @ X @ Rt ) ) ) ) )).

% balance_right_inv1l
thf(fact_99_inv1l_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V @ R ) )
      = ( ( rBT_Im1040612427e_inv1 @ A @ B @ L )
        & ( rBT_Im1040612427e_inv1 @ A @ B @ R ) ) ) )).

% inv1l.simps(2)
thf(fact_100_combine__inv2_I1_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ Lt )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ Rt )
       => ( ( ( rBT_Im315265182height @ A @ B @ Lt )
            = ( rBT_Im315265182height @ A @ B @ Rt ) )
         => ( ( rBT_Im315265182height @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) )
            = ( rBT_Im315265182height @ A @ B @ Lt ) ) ) ) ) )).

% combine_inv2(1)
thf(fact_101_combine__inv2_I2_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ Lt )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ Rt )
       => ( ( ( rBT_Im315265182height @ A @ B @ Lt )
            = ( rBT_Im315265182height @ A @ B @ Rt ) )
         => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) ) ) ) ) )).

% combine_inv2(2)
thf(fact_102_ord_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ T ) ) )).

% ord.is_rbt_rbt_sorted
thf(fact_103_ord_Oins__inv1__inv2_I4_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) ) ) ) )).

% ord.ins_inv1_inv2(4)
thf(fact_104_ord_Orbt__insert__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im852463031insert @ A @ B )
      = ( ^ [Less2: ( A > A > $o )] :
            ( rBT_Im627674146th_key @ A @ B @ Less2
            @ ^ [Uu: A,Uv: B,Nv: B] : Nv ) ) ) )).

% ord.rbt_insert_def
thf(fact_105_ord_Orbt__insertw__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im241132701t_with @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( B > B > B )] :
            ( rBT_Im627674146th_key @ A @ B @ Less2
            @ ^ [Uu: A] : F2 ) ) ) )).

% ord.rbt_insertw_def
thf(fact_106_ord_Orbt__del_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Y: A,C: rBT_Im1923302023_color,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ X @ Y )
       => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C @ A2 @ Y @ S @ B2 ) )
          = ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ A2 @ Y @ S @ B2 ) ) )
      & ( ~ ( Less @ X @ Y )
       => ( ( ( Less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ B2 ) ) )
          & ( ~ ( Less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1591839508ombine @ A @ B @ A2 @ B2 ) ) ) ) ) ) )).

% ord.rbt_del.simps(2)
thf(fact_107_combine__in__tree,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),R: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ L )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ R )
       => ( ( ( rBT_Im315265182height @ A @ B @ L )
            = ( rBT_Im315265182height @ A @ B @ R ) )
         => ( ( rBT_Im1040612427e_inv1 @ A @ B @ L )
           => ( ( rBT_Im1040612427e_inv1 @ A @ B @ R )
             => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( set2 @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ L @ R ) ) ) )
                = ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( set2 @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ L ) ) )
                  | ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( set2 @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ R ) ) ) ) ) ) ) ) ) ) )).

% combine_in_tree
thf(fact_108_local_Obalance__left__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1278323832e_left @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_left_rbt_sorted
thf(fact_109_local_Orbt__del_Oelims,axiom,(
    ! [B: $tType,X: a,Xa: ( rBT_Im246033960le_rbt @ a @ B ),Y: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( rBT_Im418718756_Empty @ a @ B ) )
         => ( Y
           != ( rBT_Im418718756_Empty @ a @ B ) ) )
       => ~ ( ! [C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ a @ B ),Y2: a,S2: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
                ( ( Xa
                  = ( rBT_Im480247531Branch @ a @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) )
               => ~ ( ( ( less @ X @ Y2 )
                     => ( Y
                        = ( rBT_Im1152561598m_left @ a @ B @ less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                    & ( ~ ( less @ X @ Y2 )
                     => ( ( ( less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1808746437_right @ a @ B @ less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                        & ( ~ ( less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1591839508ombine @ a @ B @ A4 @ B3 ) ) ) ) ) ) ) ) ) ) )).

% local.rbt_del.elims
thf(fact_110_local_Orbt__del__from__right_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Z: a,V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) )
      = ( rBT_Im1053358987_right @ a @ B @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) ) ) )).

% local.rbt_del_from_right.simps(1)
thf(fact_111_local_Orbt__lookup__in__tree,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
          = ( some @ B @ V ) )
        = ( member @ ( product_prod @ a @ B ) @ ( product_Pair @ a @ B @ K @ V ) @ ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T ) ) ) ) ) )).

% local.rbt_lookup_in_tree
thf(fact_112_local_Orbt__del__from__left_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,Y: a,S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) ) @ Y @ S @ B2 ) ) )).

% local.rbt_del_from_left.simps(2)
thf(fact_113_local_Orbt__del_Ocases,axiom,(
    ! [B: $tType,X: ( product_prod @ a @ ( rBT_Im246033960le_rbt @ a @ B ) )] :
      ( ! [X3: a] :
          ( X
         != ( product_Pair @ a @ ( rBT_Im246033960le_rbt @ a @ B ) @ X3 @ ( rBT_Im418718756_Empty @ a @ B ) ) )
     => ~ ( ! [X3: a,C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ a @ B ),Y2: a,S2: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
              ( X
             != ( product_Pair @ a @ ( rBT_Im246033960le_rbt @ a @ B ) @ X3 @ ( rBT_Im480247531Branch @ a @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) ) ) ) ) )).

% local.rbt_del.cases
thf(fact_114_local_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType] :
      ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_sorted.simps(1)
thf(fact_115_local_Orbt__del_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a] :
      ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_del.simps(1)
thf(fact_116_local_OEmpty__is__rbt,axiom,(
    ! [B: $tType] :
      ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.Empty_is_rbt
thf(fact_117_local_Obalance__left__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_less
thf(fact_118_local_Obalance__left__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_greater
thf(fact_119_local_Orbt__del__from__left_Ocases,axiom,(
    ! [B: $tType,X: ( product_prod @ a @ ( product_prod @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) ) )] :
      ( ! [X3: a,Lt2: ( rBT_Im246033960le_rbt @ a @ B ),Z2: a,V2: B,Rt2: ( rBT_Im246033960le_rbt @ a @ B ),Y2: a,S2: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
          ( X
         != ( product_Pair @ a @ ( product_prod @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt2 @ Z2 @ V2 @ Rt2 ) @ ( product_Pair @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ a @ B ) @ S2 @ B3 ) ) ) ) )
     => ( ! [X3: a,Y2: a,S2: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
            ( X
           != ( product_Pair @ a @ ( product_prod @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) @ ( rBT_Im418718756_Empty @ a @ B ) @ ( product_Pair @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ a @ B ) @ S2 @ B3 ) ) ) ) )
       => ~ ( ! [X3: a,Va2: ( rBT_Im246033960le_rbt @ a @ B ),Vb2: a,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ a @ B ),Y2: a,S2: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
                ( X
               != ( product_Pair @ a @ ( product_prod @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( product_Pair @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ a @ B ) @ S2 @ B3 ) ) ) ) ) ) ) ) )).

% local.rbt_del_from_left.cases
thf(fact_120_local_Orbt__ins_Ocases,axiom,(
    ! [B: $tType,X: ( product_prod @ ( a > B > B > B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) )] :
      ( ! [F3: ( a > B > B > B ),K2: a,V2: B] :
          ( X
         != ( product_Pair @ ( a > B > B > B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) @ F3 @ ( product_Pair @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ a @ B ) @ V2 @ ( rBT_Im418718756_Empty @ a @ B ) ) ) ) )
     => ( ! [F3: ( a > B > B > B ),K2: a,V2: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
            ( X
           != ( product_Pair @ ( a > B > B > B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) @ F3 @ ( product_Pair @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ a @ B ) @ V2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) ) )
       => ~ ( ! [F3: ( a > B > B > B ),K2: a,V2: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
                ( X
               != ( product_Pair @ ( a > B > B > B ) @ ( product_prod @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) ) @ F3 @ ( product_Pair @ a @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ a @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ a @ B ) @ V2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) ) ) ) ) ) )).

% local.rbt_ins.cases
thf(fact_121_local_Orbt__lookup_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,Uu2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ Uu2 @ L @ X @ Y @ R ) @ K )
          = ( rBT_Im35466040lookup @ a @ B @ less @ L @ K ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ Uu2 @ L @ X @ Y @ R ) @ K )
              = ( rBT_Im35466040lookup @ a @ B @ less @ R @ K ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ Uu2 @ L @ X @ Y @ R ) @ K )
              = ( some @ B @ Y ) ) ) ) ) ) )).

% local.rbt_lookup.simps(2)
thf(fact_122_local_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,P: ( ( a > B > B > B ) > a > B > ( rBT_Im246033960le_rbt @ a @ B ) > $o ),A0: ( a > B > B > B ),A1: a,A22: B,A32: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ! [F3: ( a > B > B > B ),K2: a,V2: B] :
          ( P @ F3 @ K2 @ V2 @ ( rBT_Im418718756_Empty @ a @ B ) )
     => ( ! [F3: ( a > B > B > B ),K2: a,V2: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
            ( ( ( less @ K2 @ X3 )
             => ( P @ F3 @ K2 @ V2 @ L2 ) )
           => ( ( ~ ( less @ K2 @ X3 )
               => ( ( less @ X3 @ K2 )
                 => ( P @ F3 @ K2 @ V2 @ R2 ) ) )
             => ( P @ F3 @ K2 @ V2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
       => ( ! [F3: ( a > B > B > B ),K2: a,V2: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
              ( ( ( less @ K2 @ X3 )
               => ( P @ F3 @ K2 @ V2 @ L2 ) )
             => ( ( ~ ( less @ K2 @ X3 )
                 => ( ( less @ X3 @ K2 )
                   => ( P @ F3 @ K2 @ V2 @ R2 ) ) )
               => ( P @ F3 @ K2 @ V2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% local.rbt_ins.induct
thf(fact_123_local_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B] :
      ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ a @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) ) ) )).

% local.rbt_ins.simps(1)
thf(fact_124_local_Orbt__del__from__right_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) ) ) ) )).

% local.rbt_del_from_right.simps(2)
thf(fact_125_local_Orbt__del__from__left_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Z: a,V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) @ Y @ S @ B2 )
      = ( rBT_Im1278323832e_left @ a @ B @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) @ Y @ S @ B2 ) ) )).

% local.rbt_del_from_left.simps(1)
thf(fact_126_local_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_less_simps(1)
thf(fact_127_local_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_greater_simps(1)
thf(fact_128_rbt__cases,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( T
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( T
           != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ K2 @ V2 @ R2 ) )
       => ~ ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( T
               != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ K2 @ V2 @ R2 ) ) ) ) ) )).

% rbt_cases
thf(fact_129_combine_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( rBT_Im246033960le_rbt @ A @ B ),A1: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [X1: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( P @ ( rBT_Im418718756_Empty @ A @ B ) @ X1 )
     => ( ! [V2: rBT_Im1923302023_color,Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( P @ ( rBT_Im480247531Branch @ A @ B @ V2 @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im418718756_Empty @ A @ B ) )
       => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y2: B,D: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( P @ B3 @ C3 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K2 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C3 @ S2 @ Y2 @ D ) ) )
         => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y2: B,D: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( P @ B3 @ C3 )
               => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A4 @ K2 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C3 @ S2 @ Y2 @ D ) ) )
           => ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B ),B3: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,C3: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ B3 )
                 => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B3 @ K2 @ X3 @ C3 ) ) )
             => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
                    ( ( P @ B3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) )
                   => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K2 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) ) )
               => ( P @ A0 @ A1 ) ) ) ) ) ) ) )).

% combine.induct
thf(fact_130_ord_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Less: ( A > A > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [F3: ( A > B > B > B ),K2: A,V2: B] :
          ( P @ F3 @ K2 @ V2 @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [F3: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( ( Less @ K2 @ X3 )
             => ( P @ F3 @ K2 @ V2 @ L2 ) )
           => ( ( ~ ( Less @ K2 @ X3 )
               => ( ( Less @ X3 @ K2 )
                 => ( P @ F3 @ K2 @ V2 @ R2 ) ) )
             => ( P @ F3 @ K2 @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
       => ( ! [F3: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( ( Less @ K2 @ X3 )
               => ( P @ F3 @ K2 @ V2 @ L2 ) )
             => ( ( ~ ( Less @ K2 @ X3 )
                 => ( ( Less @ X3 @ K2 )
                   => ( P @ F3 @ K2 @ V2 @ R2 ) ) )
               => ( P @ F3 @ K2 @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% ord.rbt_ins.induct
thf(fact_131_ord__class_Orbt__del__from__left_Ocases,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: ( product_prod @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) )] :
          ( ! [X3: A,Lt2: ( rBT_Im246033960le_rbt @ A @ B ),Z2: A,V2: B,Rt2: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( X
             != ( product_Pair @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt2 @ Z2 @ V2 @ Rt2 ) @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ S2 @ B3 ) ) ) ) )
         => ( ! [X3: A,Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( X
               != ( product_Pair @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im418718756_Empty @ A @ B ) @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ S2 @ B3 ) ) ) ) )
           => ~ ( ! [X3: A,Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                    ( X
                   != ( product_Pair @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ S2 @ B3 ) ) ) ) ) ) ) ) ) )).

% ord_class.rbt_del_from_left.cases
thf(fact_132_ord_Orbt__del__from__left_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) )] :
      ( ! [X3: A,Lt2: ( rBT_Im246033960le_rbt @ A @ B ),Z2: A,V2: B,Rt2: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( X
         != ( product_Pair @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt2 @ Z2 @ V2 @ Rt2 ) @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ S2 @ B3 ) ) ) ) )
     => ( ! [X3: A,Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( X
           != ( product_Pair @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im418718756_Empty @ A @ B ) @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ S2 @ B3 ) ) ) ) )
       => ~ ( ! [X3: A,Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( X
               != ( product_Pair @ A @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) @ X3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ Y2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ S2 @ B3 ) ) ) ) ) ) ) ) )).

% ord.rbt_del_from_left.cases
thf(fact_133_ord__class_Orbt__ins_Ocases,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: ( product_prod @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) )] :
          ( ! [F3: ( A > B > B > B ),K2: A,V2: B] :
              ( X
             != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ F3 @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ V2 @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )
         => ( ! [F3: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( X
               != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ F3 @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) ) )
           => ~ ( ! [F3: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                    ( X
                   != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ F3 @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) ) ) ) ) ) ) )).

% ord_class.rbt_ins.cases
thf(fact_134_ord_Orbt__ins_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) )] :
      ( ! [F3: ( A > B > B > B ),K2: A,V2: B] :
          ( X
         != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ F3 @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ V2 @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )
     => ( ! [F3: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( X
           != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ F3 @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) ) )
       => ~ ( ! [F3: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( X
               != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ F3 @ ( product_Pair @ A @ ( product_prod @ B @ ( rBT_Im246033960le_rbt @ A @ B ) ) @ K2 @ ( product_Pair @ B @ ( rBT_Im246033960le_rbt @ A @ B ) @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) ) ) ) ) ) )).

% ord.rbt_ins.cases
thf(fact_135_balance__left_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(6)
thf(fact_136_balance__left_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(11)
thf(fact_137_balance__left_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(10)
thf(fact_138_balance__left_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(9)
thf(fact_139_balance__right_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(9)
thf(fact_140_balance__left_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(7)
thf(fact_141_balance__left_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(8)
thf(fact_142_ord__class_Orbt__del_Ocases,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: ( product_prod @ A @ ( rBT_Im246033960le_rbt @ A @ B ) )] :
          ( ! [X3: A] :
              ( X
             != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X3 @ ( rBT_Im418718756_Empty @ A @ B ) ) )
         => ~ ( ! [X3: A,C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( X
                 != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X3 @ ( rBT_Im480247531Branch @ A @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) ) ) ) ) ) )).

% ord_class.rbt_del.cases
thf(fact_143_ord_Orbt__del_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ ( rBT_Im246033960le_rbt @ A @ B ) )] :
      ( ! [X3: A] :
          ( X
         != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X3 @ ( rBT_Im418718756_Empty @ A @ B ) ) )
     => ~ ( ! [X3: A,C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( X
             != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X3 @ ( rBT_Im480247531Branch @ A @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) ) ) ) ) )).

% ord.rbt_del.cases
thf(fact_144_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X232 @ X242 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_145_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X1: rBT_Im1923302023_color,X26: ( rBT_Im246033960le_rbt @ A @ B ),X32: A,X4: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X26 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X1 @ X26 @ X32 @ X4 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_146_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_147_balance__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ C )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ C ) ) )).

% balance_left.simps(1)
thf(fact_148_color_Oexhaust,axiom,(
    ! [Y: rBT_Im1923302023_color] :
      ( ( Y != rBT_Impl_Mirabelle_R )
     => ( Y = rBT_Impl_Mirabelle_B ) ) )).

% color.exhaust
thf(fact_149_color_Oinduct,axiom,(
    ! [P: ( rBT_Im1923302023_color > $o ),Color: rBT_Im1923302023_color] :
      ( ( P @ rBT_Impl_Mirabelle_R )
     => ( ( P @ rBT_Impl_Mirabelle_B )
       => ( P @ Color ) ) ) )).

% color.induct
thf(fact_150_color_Odistinct_I1_J,axiom,(
    rBT_Impl_Mirabelle_R != rBT_Impl_Mirabelle_B )).

% color.distinct(1)
thf(fact_151_ord_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_sorted.simps(1)
thf(fact_152_inv2_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% inv2.simps(1)
thf(fact_153_ord_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_less_simps(1)
thf(fact_154_ord_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im1259024060reater @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_greater_simps(1)
thf(fact_155_inv1_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% inv1.simps(1)
thf(fact_156_ord_Orbt__del_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A] :
      ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_del.simps(1)
thf(fact_157_combine_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ X )
      = X ) )).

% combine.simps(1)
thf(fact_158_balance__right_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(6)
thf(fact_159_inv1l_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% inv1l.simps(1)
thf(fact_160_ord_OEmpty__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.Empty_is_rbt
thf(fact_161_balance__right_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(11)
thf(fact_162_balance__right_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(10)
thf(fact_163_ord_Orbt__del__from__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Z: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) @ Y @ S @ B2 )
      = ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) @ Y @ S @ B2 ) ) )).

% ord.rbt_del_from_left.simps(1)
thf(fact_164_ord_Orbt__lookup_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A,X: A,Uu2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ Uu2 @ L @ X @ Y @ R ) @ K )
          = ( rBT_Im35466040lookup @ A @ B @ Less @ L @ K ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ Uu2 @ L @ X @ Y @ R ) @ K )
              = ( rBT_Im35466040lookup @ A @ B @ Less @ R @ K ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ Uu2 @ L @ X @ Y @ R ) @ K )
              = ( some @ B @ Y ) ) ) ) ) ) )).

% ord.rbt_lookup.simps(2)
thf(fact_165_combine_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) ) )).

% combine.simps(2)
thf(fact_166_balance__left__inv1l,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ Lt )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1278323832e_left @ A @ B @ Lt @ K @ X @ Rt ) ) ) ) )).

% balance_left_inv1l
thf(fact_167_ord_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,V: B] :
      ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord.rbt_ins.simps(1)
thf(fact_168_balance__right_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(7)
thf(fact_169_balance__right_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(8)
thf(fact_170_combine_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ K @ X @ C ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ B2 ) @ K @ X @ C ) ) )).

% combine.simps(5)
thf(fact_171_combine_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im1591839508ombine @ A @ B @ B2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% combine.simps(6)
thf(fact_172_balance__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ Y @ C ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C ) ) ) )).

% balance_right.simps(1)
thf(fact_173_ord_Orbt__del__from__right_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% ord.rbt_del_from_right.simps(2)
thf(fact_174_ord_Orbt__del__from__left_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Y: A,S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) ) @ Y @ S @ B2 ) ) )).

% ord.rbt_del_from_left.simps(2)
thf(fact_175_ord_Orbt__del__from__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Z: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) )
      = ( rBT_Im1053358987_right @ A @ B @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) ) ) )).

% ord.rbt_del_from_right.simps(1)
thf(fact_176_ord_Orbt__del_Oelims,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Xa: ( rBT_Im246033960le_rbt @ A @ B ),Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( rBT_Im418718756_Empty @ A @ B ) )
         => ( Y
           != ( rBT_Im418718756_Empty @ A @ B ) ) )
       => ~ ( ! [C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( Xa
                  = ( rBT_Im480247531Branch @ A @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) )
               => ~ ( ( ( Less @ X @ Y2 )
                     => ( Y
                        = ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                    & ( ~ ( Less @ X @ Y2 )
                     => ( ( ( Less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                        & ( ~ ( Less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1591839508ombine @ A @ B @ A4 @ B3 ) ) ) ) ) ) ) ) ) ) )).

% ord.rbt_del.elims
thf(fact_177_local_Ois__rbt__def,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
      = ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
        & ( rBT_Im1040612428e_inv2 @ a @ B @ T )
        & ( ( rBT_Im1805589839lor_of @ a @ B @ T )
          = rBT_Impl_Mirabelle_B )
        & ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) ) )).

% local.is_rbt_def
thf(fact_178_local_Oins__inv1__inv2_I3_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( ( ( rBT_Im1805589839lor_of @ a @ B @ T )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) ) ) )).

% local.ins_inv1_inv2(3)
thf(fact_179_local_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ V @ T )
      = ( rBT_Im945281971_paint @ a @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insert_with_key_def
thf(fact_180_local_Omap__of__entries,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( ( map_of @ a @ B @ ( rBT_Im954575269ntries @ a @ B @ T ) )
        = ( rBT_Im35466040lookup @ a @ B @ less @ T ) ) ) )).

% local.map_of_entries
thf(fact_181_local_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),C: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) ) ) )).

% local.paint_rbt_sorted
thf(fact_182_paint__color__of,axiom,(
    ! [A: $tType,B: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ T ) )
      = rBT_Impl_Mirabelle_B ) )).

% paint_color_of
thf(fact_183_local_Opaint__rbt__greater,axiom,(
    ! [B: $tType,V: a,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) )
      = ( rBT_Im1259024060reater @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_greater
thf(fact_184_local_Opaint__rbt__less,axiom,(
    ! [B: $tType,V: a,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) )
      = ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_less
thf(fact_185_local_Opaint__rbt__lookup,axiom,(
    ! [B: $tType,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C @ T ) )
      = ( rBT_Im35466040lookup @ a @ B @ less @ T ) ) )).

% local.paint_rbt_lookup
thf(fact_186_paint__in__tree,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X ) @ ( set2 @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) ) ) )
      = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X ) @ ( set2 @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ T ) ) ) ) )).

% paint_in_tree
thf(fact_187_paint_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C: rBT_Im1923302023_color,Uu2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im945281971_paint @ A @ B @ C @ ( rBT_Im480247531Branch @ A @ B @ Uu2 @ L @ K @ V @ R ) )
      = ( rBT_Im480247531Branch @ A @ B @ C @ L @ K @ V @ R ) ) )).

% paint.simps(2)
thf(fact_188_paint_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,C: rBT_Im1923302023_color] :
      ( ( rBT_Im945281971_paint @ A @ B @ C @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% paint.simps(1)
thf(fact_189_color__of_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: rBT_Im1923302023_color,Uu2: ( rBT_Im246033960le_rbt @ A @ B ),Uv2: A,Uw: B,Ux: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C @ Uu2 @ Uv2 @ Uw @ Ux ) )
      = C ) )).

% color_of.simps(2)
thf(fact_190_ord_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B ),C: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) ) ) )).

% ord.paint_rbt_sorted
thf(fact_191_paint__inv2,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),C: rBT_Im1923302023_color] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
     => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) ) ) )).

% paint_inv2
thf(fact_192_ord_Opaint__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) )
      = ( rBT_Im1259024060reater @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_greater
thf(fact_193_ord_Opaint__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) )
      = ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_less
thf(fact_194_ord_Opaint__rbt__lookup,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) )
      = ( rBT_Im35466040lookup @ A @ B @ Less @ T ) ) )).

% ord.paint_rbt_lookup
thf(fact_195_paint__inv1l,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),C: rBT_Im1923302023_color] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ T )
     => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ C @ T ) ) ) )).

% paint_inv1l
thf(fact_196_color__of_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = rBT_Impl_Mirabelle_B ) )).

% color_of.simps(1)
thf(fact_197_inv1_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C @ Lt @ K @ V @ Rt ) )
      = ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
        & ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
        & ( ( C = rBT_Impl_Mirabelle_B )
          | ( ( ( rBT_Im1805589839lor_of @ A @ B @ Lt )
              = rBT_Impl_Mirabelle_B )
            & ( ( rBT_Im1805589839lor_of @ A @ B @ Rt )
              = rBT_Impl_Mirabelle_B ) ) ) ) ) )).

% inv1.simps(2)
thf(fact_198_paint__inv1,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ T )
     => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ T ) ) ) )).

% paint_inv1
thf(fact_199_combine__inv1_I1_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ Lt )
            = rBT_Impl_Mirabelle_B )
         => ( ( ( rBT_Im1805589839lor_of @ A @ B @ Rt )
              = rBT_Impl_Mirabelle_B )
           => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) ) ) ) ) ) )).

% combine_inv1(1)
thf(fact_200_ord_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im627674146th_key @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( A > B > B > B ),K3: A,V3: B,T3: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less2 @ F2 @ K3 @ V3 @ T3 ) ) ) ) )).

% ord.rbt_insert_with_key_def
thf(fact_201_ord_Oins__inv1__inv2_I3_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ T )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) ) ) ) ) )).

% ord.ins_inv1_inv2(3)
thf(fact_202_balance__left__inv1,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ A2 )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ B2 )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ B2 )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1278323832e_left @ A @ B @ A2 @ K @ X @ B2 ) ) ) ) ) )).

% balance_left_inv1
thf(fact_203_balance__right__inv1,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ A2 )
     => ( ( rBT_Im1071879905_inv1l @ A @ B @ B2 )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ A2 )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1053358987_right @ A @ B @ A2 @ K @ X @ B2 ) ) ) ) ) )).

% balance_right_inv1
thf(fact_204_ord_Ois__rbt__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im862805236is_rbt @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),T3: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( rBT_Im1040612427e_inv1 @ A @ B @ T3 )
            & ( rBT_Im1040612428e_inv2 @ A @ B @ T3 )
            & ( ( rBT_Im1805589839lor_of @ A @ B @ T3 )
              = rBT_Impl_Mirabelle_B )
            & ( rBT_Im759614907sorted @ A @ B @ Less2 @ T3 ) ) ) ) )).

% ord.is_rbt_def
thf(fact_205_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C2: $tType,D2: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) ) )] :
      ~ ( ! [A4: A,B3: B,C3: C2,D: D2,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) @ B3 @ ( product_Pair @ C2 @ ( product_prod @ D2 @ E ) @ C3 @ ( product_Pair @ D2 @ E @ D @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_206_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C2: $tType,D2: $tType,E: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A4: A,B3: B,C3: C2,D: D2,E2: E,F3: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) @ B3 @ ( product_Pair @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ F4 ) @ D @ ( product_Pair @ E @ F4 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_207_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C2: $tType,D2: $tType,E: $tType,F4: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A4: A,B3: B,C3: C2,D: D2,E2: E,F3: F4,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B3 @ ( product_Pair @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_208_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B4 ) )
      = ( ( A2 = A5 )
        & ( B2 = B4 ) ) ) )).

% old.prod.inject
thf(fact_209_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X12: A,X27: B,Y1: A,Y26: B] :
      ( ( ( product_Pair @ A @ B @ X12 @ X27 )
        = ( product_Pair @ A @ B @ Y1 @ Y26 ) )
      = ( ( X12 = Y1 )
        & ( X27 = Y26 ) ) ) )).

% prod.inject
thf(fact_210_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A4: A,B3: B] :
          ( P @ ( product_Pair @ A @ B @ A4 @ B3 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_211_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A4: A,B3: B] :
            ( Y
           != ( product_Pair @ A @ B @ A4 @ B3 ) ) ) )).

% old.prod.exhaust
thf(fact_212_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B4: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B4 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B4 ) ) ) )).

% Pair_inject
thf(fact_213_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A4: A,B3: B] :
          ( P @ ( product_Pair @ A @ B @ A4 @ B3 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_214_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X3: A,Y2: B] :
      ( P2
      = ( product_Pair @ A @ B @ X3 @ Y2 ) ) )).

% surj_pair
thf(fact_215_prod__induct3,axiom,(
    ! [C2: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C2 ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C2 ) )] :
      ( ! [A4: A,B3: B,C3: C2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C2 ) @ A4 @ ( product_Pair @ B @ C2 @ B3 @ C3 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_216_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C2 ) )] :
      ~ ( ! [A4: A,B3: B,C3: C2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C2 ) @ A4 @ ( product_Pair @ B @ C2 @ B3 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_217_prod__induct4,axiom,(
    ! [D2: $tType,C2: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ D2 ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ D2 ) ) )] :
      ( ! [A4: A,B3: B,C3: C2,D: D2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ D2 ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ D2 ) @ B3 @ ( product_Pair @ C2 @ D2 @ C3 @ D ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_218_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C2: $tType,D2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ D2 ) ) )] :
      ~ ( ! [A4: A,B3: B,C3: C2,D: D2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ D2 ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ D2 ) @ B3 @ ( product_Pair @ C2 @ D2 @ C3 @ D ) ) ) ) ) )).

% prod_cases4
thf(fact_219_prod__induct7,axiom,(
    ! [G2: $tType,F4: $tType,E: $tType,D2: $tType,C2: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ( ! [A4: A,B3: B,C3: C2,D: D2,E2: E,F3: F4,G3: G2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B3 @ ( product_Pair @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_220_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D2: $tType,C2: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A4: A,B3: B,C3: C2,D: D2,E2: E,F3: F4] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) ) @ B3 @ ( product_Pair @ C2 @ ( product_prod @ D2 @ ( product_prod @ E @ F4 ) ) @ C3 @ ( product_Pair @ D2 @ ( product_prod @ E @ F4 ) @ D @ ( product_Pair @ E @ F4 @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_221_prod__induct5,axiom,(
    ! [E: $tType,D2: $tType,C2: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) ) )] :
      ( ! [A4: A,B3: B,C3: C2,D: D2,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C2 @ ( product_prod @ D2 @ E ) ) @ B3 @ ( product_Pair @ C2 @ ( product_prod @ D2 @ E ) @ C3 @ ( product_Pair @ D2 @ E @ D @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_222_map__of__SomeD,axiom,(
    ! [A: $tType,B: $tType,Xs: ( list @ ( product_prod @ B @ A ) ),K: B,Y: A] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Y ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ Y ) @ ( set2 @ ( product_prod @ B @ A ) @ Xs ) ) ) )).

% map_of_SomeD
thf(fact_223_weak__map__of__SomeI,axiom,(
    ! [A: $tType,B: $tType,K: A,X: B,L: ( list @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X ) @ ( set2 @ ( product_prod @ A @ B ) @ L ) )
     => ? [X3: B] :
          ( ( map_of @ A @ B @ L @ K )
          = ( some @ B @ X3 ) ) ) )).

% weak_map_of_SomeI
thf(fact_224_local_Orbt__lookup__rbt__insert,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) )
        = ( fun_upd @ a @ ( option @ B ) @ ( rBT_Im35466040lookup @ a @ B @ less @ T ) @ K @ ( some @ B @ V ) ) ) ) )).

% local.rbt_lookup_rbt_insert
thf(fact_225_local_Obalance__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_rbt_sorted
thf(fact_226_local_Orbt__ins_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
          = ( rBT_Im1648453169alance @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im1648453169alance @ a @ B @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% local.rbt_ins.simps(2)
thf(fact_227_local_Obalance__rbt__less,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ a @ B @ less @ V @ B2 )
        & ( less @ K @ V ) ) ) )).

% local.balance_rbt_less
thf(fact_228_local_Obalance__rbt__greater,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ A2 )
        & ( rBT_Im1259024060reater @ a @ B @ less @ V @ B2 )
        & ( less @ V @ K ) ) ) )).

% local.balance_rbt_greater
thf(fact_229_local_Orbt__lookup__balance,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,X: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R ) @ X )
              = ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ K @ V @ R ) @ X ) ) ) ) ) ) )).

% local.rbt_lookup_balance
thf(fact_230_map__upd__eqD1,axiom,(
    ! [A: $tType,B: $tType,M: ( A > ( option @ B ) ),A2: A,X: B,N: ( A > ( option @ B ) ),Y: B] :
      ( ( ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ X ) )
        = ( fun_upd @ A @ ( option @ B ) @ N @ A2 @ ( some @ B @ Y ) ) )
     => ( X = Y ) ) )).

% map_upd_eqD1
thf(fact_231_map__upd__triv,axiom,(
    ! [A: $tType,B: $tType,T: ( B > ( option @ A ) ),K: B,X: A] :
      ( ( ( T @ K )
        = ( some @ A @ X ) )
     => ( ( fun_upd @ B @ ( option @ A ) @ T @ K @ ( some @ A @ X ) )
        = T ) ) )).

% map_upd_triv
thf(fact_232_map__upd__Some__unfold,axiom,(
    ! [B: $tType,A: $tType,M: ( B > ( option @ A ) ),A2: B,B2: A,X: B,Y: A] :
      ( ( ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) @ X )
        = ( some @ A @ Y ) )
      = ( ( ( X = A2 )
          & ( B2 = Y ) )
        | ( ( X != A2 )
          & ( ( M @ X )
            = ( some @ A @ Y ) ) ) ) ) )).

% map_upd_Some_unfold
thf(fact_233_ord_Obalance__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ V @ B2 )
        & ( Less @ V @ K ) ) ) )).

% ord.balance_rbt_greater
thf(fact_234_ord_Obalance__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ B2 )
        & ( Less @ K @ V ) ) ) )).

% ord.balance_rbt_less
thf(fact_235_balance__inv1,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),R: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ L )
     => ( ( rBT_Im1071879905_inv1l @ A @ B @ R )
       => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1648453169alance @ A @ B @ L @ K @ V @ R ) ) ) ) )).

% balance_inv1
thf(fact_236_balance__inv2,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),R: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ L )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ R )
       => ( ( ( rBT_Im315265182height @ A @ B @ L )
            = ( rBT_Im315265182height @ A @ B @ R ) )
         => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1648453169alance @ A @ B @ L @ K @ V @ R ) ) ) ) ) )).

% balance_inv2
thf(fact_237_balance_Osimps_I23_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) ) )).

% balance.simps(23)
thf(fact_238_balance_Osimps_I27_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(27)
thf(fact_239_balance_Osimps_I29_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(29)
thf(fact_240_balance_Osimps_I39_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(39)
thf(fact_241_balance_Osimps_I43_J,axiom,(
    ! [B: $tType,A: $tType,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(43)
thf(fact_242_balance_Osimps_I45_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(45)
thf(fact_243_balance_Osimps_I14_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(14)
thf(fact_244_balance_Osimps_I15_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(15)
thf(fact_245_balance_Osimps_I16_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(16)
thf(fact_246_balance_Osimps_I17_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(17)
thf(fact_247_balance_Osimps_I18_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(18)
thf(fact_248_balance_Osimps_I19_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(19)
thf(fact_249_balance_Osimps_I20_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(20)
thf(fact_250_balance_Osimps_I21_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(21)
thf(fact_251_balance_Osimps_I22_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(22)
thf(fact_252_balance_Osimps_I24_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(24)
thf(fact_253_balance_Osimps_I25_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(25)
thf(fact_254_balance_Osimps_I26_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(26)
thf(fact_255_balance_Osimps_I28_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(28)

%----Type constructors (8)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( order @ A7 @ ( type2 @ A7 ) )
     => ( order @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A6: $tType,A7: $tType] :
      ( ( ord @ A7 @ ( type2 @ A7 ) )
     => ( ord @ ( A6 > A7 ) @ ( type2 @ ( A6 > A7 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_1,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_2,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder_3,axiom,(
    ! [A6: $tType] :
      ( order @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_4,axiom,(
    ! [A6: $tType] :
      ( ord @ ( set @ A6 ) @ ( type2 @ ( set @ A6 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_5,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_6,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,(
    ( member @ ( product_prod @ a @ b ) @ ( product_Pair @ a @ b @ k @ v ) @ ( set2 @ ( product_prod @ a @ b ) @ ( rBT_Im954575269ntries @ a @ b @ ( rBT_Im1152561598m_left @ a @ b @ less @ xx @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) @ yy @ ss @ bb ) ) ) )
 != ( ~ ( ( xx != k )
        & ( member @ ( product_prod @ a @ b ) @ ( product_Pair @ a @ b @ k @ v ) @ ( set2 @ ( product_prod @ a @ b ) @ ( rBT_Im954575269ntries @ a @ b @ ( rBT_Im480247531Branch @ a @ b @ c @ ( rBT_Im480247531Branch @ a @ b @ rBT_Impl_Mirabelle_R @ vaa @ vbb @ vdd @ vc ) @ yy @ ss @ bb ) ) ) ) ) ) )).

%------------------------------------------------------------------------------
