%------------------------------------------------------------------------------
% File     : DAT241^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 1921
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__1921.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  327 (   0 unit;  61 type;   0 defn)
%            Number of atoms       : 6317 ( 234 equality;4154 variable)
%            Maximal formula depth :   36 (  13 average)
%            Number of connectives : 6572 (  65   ~;   5   |;  58   &;6180   @)
%                                         (   0 <=>; 264  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  525 ( 525   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   63 (  61   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1694 (  18 sgn;1557   !;   0   ?;  52   ^)
%                                         (1694   :;  85  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:49:11.311
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (52)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_List_Ofold,type,(
    fold: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B ) > ( list @ A ) > B > B ) )).

thf(sy_c_List_Ofoldr,type,(
    foldr: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B ) > ( list @ A ) > B > B ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,(
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance,type,(
    rBT_Im1648453169alance: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__left,type,(
    rBT_Im1278323832e_left: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__right,type,(
    rBT_Im1053358987_right: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obheight,type,(
    rBT_Im315265182height: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > nat ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OB,type,(
    rBT_Impl_Mirabelle_B: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OR,type,(
    rBT_Impl_Mirabelle_R: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor__of,type,(
    rBT_Im1805589839lor_of: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > rBT_Im1923302023_color ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocombine,type,(
    rBT_Im1591839508ombine: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oinv1,type,(
    rBT_Im1040612427e_inv1: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oinv1l,type,(
    rBT_Im1071879905_inv1l: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oinv2,type,(
    rBT_Im1040612428e_inv2: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Omap,type,(
    rBT_Im1728190513le_map: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ C ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Ois__rbt,type,(
    rBT_Im862805236is_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__bulkload,type,(
    rBT_Im1287406358lkload: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( list @ ( product_prod @ A @ B ) ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del,type,(
    rBT_Im1714610413bt_del: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del__from__left,type,(
    rBT_Im1152561598m_left: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del__from__right,type,(
    rBT_Im1808746437_right: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__delete,type,(
    rBT_Im452238249delete: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__greater,type,(
    rBT_Im1259024060reater: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__ins,type,(
    rBT_Im1756508336bt_ins: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert,type,(
    rBT_Im852463031insert: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with,type,(
    rBT_Im241132701t_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with__key,type,(
    rBT_Im627674146th_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__inter,type,(
    rBT_Im707264894_inter: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__inter__with,type,(
    rBT_Im1178254820r_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__inter__with__key,type,(
    rBT_Im1936485275th_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__less,type,(
    rBT_Im2075124343t_less: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__map__entry,type,(
    rBT_Im2018130356_entry: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__sorted,type,(
    rBT_Im759614907sorted: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__union,type,(
    rBT_Im1406913905_union: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__union__with,type,(
    rBT_Im156134743n_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__union__with__key,type,(
    rBT_Im1954753512th_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Opaint,type,(
    rBT_Im945281971_paint: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OgreaterThan,type,(
    set_greaterThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_Set__Interval_Oord_OlessThan,type,(
    set_lessThan: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f,type,(
    f: a > b > b > b )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_t,type,(
    t: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_xs,type,(
    xs: ( list @ ( product_prod @ a @ b ) ) )).

%----Relevant facts (256)
thf(fact_0_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_1_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_2_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_3_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C2: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C2 @ B2 )
       => ( less @ C2 @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_4_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_5_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_6_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_7_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_8_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_9_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_10_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_11_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_12_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_13_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_14_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_trans
thf(fact_15_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_16_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_17_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_18_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_19_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.ord_eq_less_trans
thf(fact_20_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.ord_less_eq_trans
thf(fact_21_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_22_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_23_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_24_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.order.strict_trans
thf(fact_25_local_Orbt__insertwk__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_rbt_sorted
thf(fact_26_local_Orbt__insertw__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_rbt_sorted
thf(fact_27_local_Orbt__insertw__def,axiom,(
    ! [B: $tType,F: ( B > B > B )] :
      ( ( rBT_Im241132701t_with @ a @ B @ less @ F )
      = ( rBT_Im627674146th_key @ a @ B @ less
        @ ^ [Uu: a] : F ) ) )).

% local.rbt_insertw_def
thf(fact_28_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_29_local_Orbt__insert__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_rbt_sorted
thf(fact_30_local_Orbt__insert__def,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im852463031insert @ a @ B @ less )
      = ( rBT_Im627674146th_key @ a @ B @ less
        @ ^ [Uu: a,Uv: B,Nv: B] : Nv ) ) )).

% local.rbt_insert_def
thf(fact_31_local_OgreaterThan__def,axiom,(
    ! [L: a] :
      ( ( set_greaterThan @ a @ less @ L )
      = ( collect @ a @ ( less @ L ) ) ) )).

% local.greaterThan_def
thf(fact_32_local_OlessThan__def,axiom,(
    ! [U: a] :
      ( ( set_lessThan @ a @ less @ U )
      = ( collect @ a
        @ ^ [X2: a] :
            ( less @ X2 @ U ) ) ) )).

% local.lessThan_def
thf(fact_33_local_Omap__rbt__sorted,axiom,(
    ! [B: $tType,C: $tType,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im759614907sorted @ a @ C @ less @ T ) ) )).

% local.map_rbt_sorted
thf(fact_34_local_Orbt__inter__def,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im707264894_inter @ a @ B @ less )
      = ( rBT_Im1936485275th_key @ a @ B @ less
        @ ^ [Uu: a,Uv: B,Rv: B] : Rv ) ) )).

% local.rbt_inter_def
thf(fact_35_local_Orbt__inter__with__def,axiom,(
    ! [B: $tType,F: ( B > B > B )] :
      ( ( rBT_Im1178254820r_with @ a @ B @ less @ F )
      = ( rBT_Im1936485275th_key @ a @ B @ less
        @ ^ [Uu: a] : F ) ) )).

% local.rbt_inter_with_def
thf(fact_36_local_Orbt__union__def,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im1406913905_union @ a @ B @ less )
      = ( rBT_Im1954753512th_key @ a @ B @ less
        @ ^ [Uu: a,Uv: B,Rv: B] : Rv ) ) )).

% local.rbt_union_def
thf(fact_37_local_Orbt__union__with__def,axiom,(
    ! [B: $tType,F: ( B > B > B )] :
      ( ( rBT_Im156134743n_with @ a @ B @ less @ F )
      = ( rBT_Im1954753512th_key @ a @ B @ less
        @ ^ [Uu: a] : F ) ) )).

% local.rbt_union_with_def
thf(fact_38_local_Orbt__map__entry__rbt__sorted,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) )).

% local.rbt_map_entry_rbt_sorted
thf(fact_39_local_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),C2: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) ) ) )).

% local.paint_rbt_sorted
thf(fact_40_local_Orbt__insertwk__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_is_rbt
thf(fact_41_local_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) )).

% local.is_rbt_rbt_sorted
thf(fact_42_local_Oins__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.ins_rbt_sorted
thf(fact_43_local_Orbt__insert__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_is_rbt
thf(fact_44_local_Orbt__insertw__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_is_rbt
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_OlessThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_lessThan @ a @ less @ K ) )
      = ( less @ I @ K ) ) )).

% local.lessThan_iff
thf(fact_50_local_OgreaterThan__iff,axiom,(
    ! [I: a,K: a] :
      ( ( member @ a @ I @ ( set_greaterThan @ a @ less @ K ) )
      = ( less @ K @ I ) ) )).

% local.greaterThan_iff
thf(fact_51_local_Orbt__delete__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im452238249delete @ a @ B @ less @ K @ T ) ) ) )).

% local.rbt_delete_is_rbt
thf(fact_52_local_Orbt__map__entry__is__rbt,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ a @ B @ less @ T ) ) )).

% local.rbt_map_entry_is_rbt
thf(fact_53_local_Omap__is__rbt,axiom,(
    ! [B: $tType,C: $tType,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ a @ C @ less @ T ) ) )).

% local.map_is_rbt
thf(fact_54_ord_Omap__is__rbt,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ A @ C @ Less @ T ) ) )).

% ord.map_is_rbt
thf(fact_55_ord_Orbt__map__entry__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ A @ B @ Less @ T ) ) )).

% ord.rbt_map_entry_is_rbt
thf(fact_56_ord_Orbt__union__with__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im156134743n_with @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( B > B > B )] :
            ( rBT_Im1954753512th_key @ A @ B @ Less2
            @ ^ [Uu: A] : F2 ) ) ) )).

% ord.rbt_union_with_def
thf(fact_57_ord_Orbt__inter__with__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1178254820r_with @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( B > B > B )] :
            ( rBT_Im1936485275th_key @ A @ B @ Less2
            @ ^ [Uu: A] : F2 ) ) ) )).

% ord.rbt_inter_with_def
thf(fact_58_ord_Orbt__union__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1406913905_union @ A @ B )
      = ( ^ [Less2: ( A > A > $o )] :
            ( rBT_Im1954753512th_key @ A @ B @ Less2
            @ ^ [Uu: A,Uv: B,Rv: B] : Rv ) ) ) )).

% ord.rbt_union_def
thf(fact_59_ord_Orbt__inter__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im707264894_inter @ A @ B )
      = ( ^ [Less2: ( A > A > $o )] :
            ( rBT_Im1936485275th_key @ A @ B @ Less2
            @ ^ [Uu: A,Uv: B,Rv: B] : Rv ) ) ) )).

% ord.rbt_inter_def
thf(fact_60_ord_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B ),C2: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) ) ) )).

% ord.paint_rbt_sorted
thf(fact_61_ord_Omap__rbt__sorted,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im759614907sorted @ A @ C @ Less @ T ) ) )).

% ord.map_rbt_sorted
thf(fact_62_ord_Orbt__map__entry__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im759614907sorted @ A @ B @ Less @ T ) ) )).

% ord.rbt_map_entry_rbt_sorted
thf(fact_63_ord_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ T ) ) )).

% ord.is_rbt_rbt_sorted
thf(fact_64_ord_Orbt__insert__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im852463031insert @ A @ B )
      = ( ^ [Less2: ( A > A > $o )] :
            ( rBT_Im627674146th_key @ A @ B @ Less2
            @ ^ [Uu: A,Uv: B,Nv: B] : Nv ) ) ) )).

% ord.rbt_insert_def
thf(fact_65_ord_Orbt__insertw__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im241132701t_with @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( B > B > B )] :
            ( rBT_Im627674146th_key @ A @ B @ Less2
            @ ^ [Uu: A] : F2 ) ) ) )).

% ord.rbt_insertw_def
thf(fact_66_local_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ V @ T )
      = ( rBT_Im945281971_paint @ a @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insert_with_key_def
thf(fact_67_local_Orbt__map__entry__color__of,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1805589839lor_of @ a @ B @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im1805589839lor_of @ a @ B @ T ) ) )).

% local.rbt_map_entry_color_of
thf(fact_68_local_Orbt__bulkload__is__rbt,axiom,(
    ! [B: $tType,Xs: ( list @ ( product_prod @ a @ B ) )] :
      ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im1287406358lkload @ a @ B @ less @ Xs ) ) )).

% local.rbt_bulkload_is_rbt
thf(fact_69_local_Orbt__del__rbt__sorted,axiom,(
    ! [B: $tType,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ Lt )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% local.rbt_del_rbt_sorted
thf(fact_70_case__prod__app,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType] :
      ( ( product_case_prod @ B @ C @ ( D > A ) )
      = ( ^ [F2: ( B > C > D > A ),X2: ( product_prod @ B @ C ),Y2: D] :
            ( product_case_prod @ B @ C @ A
            @ ^ [L2: B,R: C] :
                ( F2 @ L2 @ R @ Y2 )
            @ X2 ) ) ) )).

% case_prod_app
thf(fact_71_local_Ostrict__mono__less,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( less @ X @ Y ) ) ) ) )).

% local.strict_mono_less
thf(fact_72_local_Ostrict__mono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( strict_mono @ a @ B @ less @ F )
          = ( ! [X2: a,Y2: a] :
                ( ( less @ X2 @ Y2 )
               => ( ord_less @ B @ ( F @ X2 ) @ ( F @ Y2 ) ) ) ) ) ) )).

% local.strict_mono_def
thf(fact_73_local_Ostrict__monoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y3: a] :
              ( ( less @ X3 @ Y3 )
             => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y3 ) ) )
         => ( strict_mono @ a @ B @ less @ F ) ) ) )).

% local.strict_monoI
thf(fact_74_local_Ostrict__monoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( less @ X @ Y )
           => ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.strict_monoD
thf(fact_75_local_Orbt__delete__def,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im452238249delete @ a @ B @ less @ K @ T )
      = ( rBT_Im945281971_paint @ a @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1714610413bt_del @ a @ B @ less @ K @ T ) ) ) )).

% local.rbt_delete_def
thf(fact_76_paint__color__of,axiom,(
    ! [A: $tType,B: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ T ) )
      = rBT_Impl_Mirabelle_B ) )).

% paint_color_of
thf(fact_77_ord_Orbt__delete__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im452238249delete @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),K2: A,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1714610413bt_del @ A @ B @ Less2 @ K2 @ T2 ) ) ) ) )).

% ord.rbt_delete_def
thf(fact_78_ord_Orbt__map__entry__color__of,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im1805589839lor_of @ A @ B @ T ) ) )).

% ord.rbt_map_entry_color_of
thf(fact_79_map__color__of,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im1805589839lor_of @ A @ C @ T ) ) )).

% map_color_of
thf(fact_80_ord_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im627674146th_key @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F2: ( A > B > B > B ),K2: A,V2: B,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less2 @ F2 @ K2 @ V2 @ T2 ) ) ) ) )).

% ord.rbt_insert_with_key_def
thf(fact_81_local_Orbt__map__entry__inv1,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im1040612427e_inv1 @ a @ B @ T ) ) )).

% local.rbt_map_entry_inv1
thf(fact_82_local_Orbt__map__entry_Osimps_I1_J,axiom,(
    ! [B: $tType,K: a,F: ( B > B )] :
      ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_map_entry.simps(1)
thf(fact_83_local_Omap__rbt__greater,axiom,(
    ! [B: $tType,C: $tType,K: a,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im1259024060reater @ a @ C @ less @ K @ T ) ) )).

% local.map_rbt_greater
thf(fact_84_local_Omap__rbt__less,axiom,(
    ! [B: $tType,C: $tType,K: a,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im2075124343t_less @ a @ C @ less @ K @ T ) ) )).

% local.map_rbt_less
thf(fact_85_local_Orbt__map__entry__inv2_I1_J,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ a @ B @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im1040612428e_inv2 @ a @ B @ T ) ) )).

% local.rbt_map_entry_inv2(1)
thf(fact_86_local_Orbt__del_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a] :
      ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_del.simps(1)
thf(fact_87_local_Orbt__less__trans,axiom,(
    ! [C: $tType,X: a,T: ( rBT_Im246033960le_rbt @ a @ C ),Y: a] :
      ( ( rBT_Im2075124343t_less @ a @ C @ less @ X @ T )
     => ( ( less @ X @ Y )
       => ( rBT_Im2075124343t_less @ a @ C @ less @ Y @ T ) ) ) )).

% local.rbt_less_trans
thf(fact_88_local_Orbt__greater__trans,axiom,(
    ! [C: $tType,X: a,Y: a,T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( less @ X @ Y )
     => ( ( rBT_Im1259024060reater @ a @ C @ less @ Y @ T )
       => ( rBT_Im1259024060reater @ a @ C @ less @ X @ T ) ) ) )).

% local.rbt_greater_trans
thf(fact_89_local_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType] :
      ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_sorted.simps(1)
thf(fact_90_local_Orbt__del__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% local.rbt_del_rbt_less
thf(fact_91_local_Orbt__del__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% local.rbt_del_rbt_greater
thf(fact_92_local_OEmpty__is__rbt,axiom,(
    ! [B: $tType] :
      ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.Empty_is_rbt
thf(fact_93_local_Orbt__map__entry__rbt__less,axiom,(
    ! [B: $tType,A2: a,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ A2 @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im2075124343t_less @ a @ B @ less @ A2 @ T ) ) )).

% local.rbt_map_entry_rbt_less
thf(fact_94_local_Orbt__map__entry__rbt__greater,axiom,(
    ! [B: $tType,A2: a,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ A2 @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im1259024060reater @ a @ B @ less @ A2 @ T ) ) )).

% local.rbt_map_entry_rbt_greater
thf(fact_95_local_Oins__inv1__inv2_I1_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( rBT_Im1040612428e_inv2 @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) ) )).

% local.ins_inv1_inv2(1)
thf(fact_96_local_Oins__inv1__inv2_I3_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( ( ( rBT_Im1805589839lor_of @ a @ B @ T )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) ) ) )).

% local.ins_inv1_inv2(3)
thf(fact_97_local_Ois__rbt__def,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
      = ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
        & ( rBT_Im1040612428e_inv2 @ a @ B @ T )
        & ( ( rBT_Im1805589839lor_of @ a @ B @ T )
          = rBT_Impl_Mirabelle_B )
        & ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) ) )).

% local.is_rbt_def
thf(fact_98_local_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_greater_simps(1)
thf(fact_99_local_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_less_simps(1)
thf(fact_100_local_Oins__rbt__less,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T )
        & ( less @ K @ V ) ) ) )).

% local.ins_rbt_less
thf(fact_101_local_Oins__rbt__greater,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ T )
        & ( less @ V @ K ) ) ) )).

% local.ins_rbt_greater
thf(fact_102_local_Opaint__rbt__less,axiom,(
    ! [B: $tType,V: a,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) )
      = ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_less
thf(fact_103_local_Opaint__rbt__greater,axiom,(
    ! [B: $tType,V: a,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) )
      = ( rBT_Im1259024060reater @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_greater
thf(fact_104_inv1_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% inv1.simps(1)
thf(fact_105_inv2_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% inv2.simps(1)
thf(fact_106_ord_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_less_simps(1)
thf(fact_107_ord_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im1259024060reater @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_greater_simps(1)
thf(fact_108_ord_Oins__inv1__inv2_I1_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) ) ) ) )).

% ord.ins_inv1_inv2(1)
thf(fact_109_ord_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_sorted.simps(1)
thf(fact_110_paint_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,C2: rBT_Im1923302023_color] :
      ( ( rBT_Im945281971_paint @ A @ B @ C2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% paint.simps(1)
thf(fact_111_ord_Orbt__del_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A] :
      ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_del.simps(1)
thf(fact_112_ord_OEmpty__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.Empty_is_rbt
thf(fact_113_ord_Orbt__map__entry_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B )] :
      ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_map_entry.simps(1)
thf(fact_114_map_Osimps_I1_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B > C )] :
      ( ( rBT_Im1728190513le_map @ A @ B @ C @ F @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ C ) ) )).

% map.simps(1)
thf(fact_115_paint__inv2,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),C2: rBT_Im1923302023_color] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
     => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) ) ) )).

% paint_inv2
thf(fact_116_ord_Orbt__map__entry__inv2_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im1040612428e_inv2 @ A @ B @ T ) ) )).

% ord.rbt_map_entry_inv2(1)
thf(fact_117_map__inv2_I1_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im1040612428e_inv2 @ A @ C @ T ) ) )).

% map_inv2(1)
thf(fact_118_ord_Orbt__map__entry__inv1,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im1040612427e_inv1 @ A @ B @ T ) ) )).

% ord.rbt_map_entry_inv1
thf(fact_119_map__inv1,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im1040612427e_inv1 @ A @ C @ T ) ) )).

% map_inv1
thf(fact_120_ord_Oins__inv1__inv2_I3_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ T )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) ) ) ) ) )).

% ord.ins_inv1_inv2(3)
thf(fact_121_ord_Opaint__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) )
      = ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_less
thf(fact_122_ord_Opaint__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) )
      = ( rBT_Im1259024060reater @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_greater
thf(fact_123_ord_Orbt__map__entry__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),A2: A,K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ A2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im2075124343t_less @ A @ B @ Less @ A2 @ T ) ) )).

% ord.rbt_map_entry_rbt_less
thf(fact_124_ord_Orbt__map__entry__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),A2: A,K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ A2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im1259024060reater @ A @ B @ Less @ A2 @ T ) ) )).

% ord.rbt_map_entry_rbt_greater
thf(fact_125_ord_Omap__rbt__less,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ T ) ) )).

% ord.map_rbt_less
thf(fact_126_ord_Omap__rbt__greater,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ K @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im1259024060reater @ A @ C @ Less @ K @ T ) ) )).

% ord.map_rbt_greater
thf(fact_127_ord_Ois__rbt__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im862805236is_rbt @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( rBT_Im1040612427e_inv1 @ A @ B @ T2 )
            & ( rBT_Im1040612428e_inv2 @ A @ B @ T2 )
            & ( ( rBT_Im1805589839lor_of @ A @ B @ T2 )
              = rBT_Impl_Mirabelle_B )
            & ( rBT_Im759614907sorted @ A @ B @ Less2 @ T2 ) ) ) ) )).

% ord.is_rbt_def
thf(fact_128_color__of_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = rBT_Impl_Mirabelle_B ) )).

% color_of.simps(1)
thf(fact_129_local_Orbt__del__from__right__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Rt )
       => ( ( less @ K @ V )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1808746437_right @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_right_rbt_less
thf(fact_130_local_Orbt__del__from__right__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Rt )
       => ( ( less @ V @ K )
         => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1808746437_right @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_right_rbt_greater
thf(fact_131_local_Orbt__del__from__left__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Rt )
       => ( ( less @ K @ V )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1152561598m_left @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_left_rbt_less
thf(fact_132_local_Orbt__del__from__left__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Rt )
       => ( ( less @ V @ K )
         => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1152561598m_left @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_left_rbt_greater
thf(fact_133_local_Orbt__bulkload__def,axiom,(
    ! [B: $tType,Xs: ( list @ ( product_prod @ a @ B ) )] :
      ( ( rBT_Im1287406358lkload @ a @ B @ less @ Xs )
      = ( foldr @ ( product_prod @ a @ B ) @ ( rBT_Im246033960le_rbt @ a @ B ) @ ( product_case_prod @ a @ B @ ( ( rBT_Im246033960le_rbt @ a @ B ) > ( rBT_Im246033960le_rbt @ a @ B ) ) @ ( rBT_Im852463031insert @ a @ B @ less ) ) @ Xs @ ( rBT_Im418718756_Empty @ a @ B ) ) ) )).

% local.rbt_bulkload_def
thf(fact_134_local_Oins__inv1__inv2_I4_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( rBT_Im1071879905_inv1l @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) ) )).

% local.ins_inv1_inv2(4)
thf(fact_135_inv1l_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% inv1l.simps(1)
thf(fact_136_paint__inv1l,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),C2: rBT_Im1923302023_color] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ T )
     => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) ) ) )).

% paint_inv1l
thf(fact_137_paint__inv1,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ T )
     => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ T ) ) ) )).

% paint_inv1
thf(fact_138_ord_Oins__inv1__inv2_I4_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) ) ) ) )).

% ord.ins_inv1_inv2(4)
thf(fact_139_ord_Orbt__bulkload__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1287406358lkload @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),Xs2: ( list @ ( product_prod @ A @ B ) )] :
            ( foldr @ ( product_prod @ A @ B ) @ ( rBT_Im246033960le_rbt @ A @ B ) @ ( product_case_prod @ A @ B @ ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) @ ( rBT_Im852463031insert @ A @ B @ Less2 ) ) @ Xs2 @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% ord.rbt_bulkload_def
thf(fact_140_local_Obalance__right__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R2 )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R2 )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1053358987_right @ a @ B @ L @ K @ V @ R2 ) ) ) ) ) ) )).

% local.balance_right_rbt_sorted
thf(fact_141_local_Ocombine__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R2: ( rBT_Im246033960le_rbt @ a @ B ),K: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R2 )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R2 )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1591839508ombine @ a @ B @ L @ R2 ) ) ) ) ) ) )).

% local.combine_rbt_sorted
thf(fact_142_local_Obalance__left__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R2 )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R2 )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1278323832e_left @ a @ B @ L @ K @ V @ R2 ) ) ) ) ) ) )).

% local.balance_left_rbt_sorted
thf(fact_143_local_Obalance__right__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_greater
thf(fact_144_local_Ocombine__rbt__less,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ R2 )
       => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R2 ) ) ) ) )).

% local.combine_rbt_less
thf(fact_145_local_Ocombine__rbt__greater,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ L )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R2 )
       => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R2 ) ) ) ) )).

% local.combine_rbt_greater
thf(fact_146_local_Obalance__left__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_less
thf(fact_147_local_Obalance__left__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_greater
thf(fact_148_local_Obalance__right__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_less
thf(fact_149_balance__left_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(6)
thf(fact_150_combine_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ X )
      = X ) )).

% combine.simps(1)
thf(fact_151_balance__right_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(6)
thf(fact_152_balance__left__inv1l,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ Lt )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1278323832e_left @ A @ B @ Lt @ K @ X @ Rt ) ) ) ) )).

% balance_left_inv1l
thf(fact_153_combine__inv1_I2_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) ) ) ) )).

% combine_inv1(2)
thf(fact_154_balance__right__inv1l,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
     => ( ( rBT_Im1071879905_inv1l @ A @ B @ Rt )
       => ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im1053358987_right @ A @ B @ Lt @ K @ X @ Rt ) ) ) ) )).

% balance_right_inv1l
thf(fact_155_combine__inv1_I1_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ Lt )
            = rBT_Impl_Mirabelle_B )
         => ( ( ( rBT_Im1805589839lor_of @ A @ B @ Rt )
              = rBT_Impl_Mirabelle_B )
           => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) ) ) ) ) ) )).

% combine_inv1(1)
thf(fact_156_balance__left__inv1,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ A2 )
     => ( ( rBT_Im1040612427e_inv1 @ A @ B @ B2 )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ B2 )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1278323832e_left @ A @ B @ A2 @ K @ X @ B2 ) ) ) ) ) )).

% balance_left_inv1
thf(fact_157_balance__right__inv1,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ A2 )
     => ( ( rBT_Im1071879905_inv1l @ A @ B @ B2 )
       => ( ( ( rBT_Im1805589839lor_of @ A @ B @ A2 )
            = rBT_Impl_Mirabelle_B )
         => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1053358987_right @ A @ B @ A2 @ K @ X @ B2 ) ) ) ) ) )).

% balance_right_inv1
thf(fact_158_local_Orbt__del_Oelims,axiom,(
    ! [B: $tType,X: a,Xa: ( rBT_Im246033960le_rbt @ a @ B ),Y: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( rBT_Im418718756_Empty @ a @ B ) )
         => ( Y
           != ( rBT_Im418718756_Empty @ a @ B ) ) )
       => ~ ( ! [C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ a @ B ),Y3: a,S: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
                ( ( Xa
                  = ( rBT_Im480247531Branch @ a @ B @ C3 @ A4 @ Y3 @ S @ B3 ) )
               => ~ ( ( ( less @ X @ Y3 )
                     => ( Y
                        = ( rBT_Im1152561598m_left @ a @ B @ less @ X @ A4 @ Y3 @ S @ B3 ) ) )
                    & ( ~ ( less @ X @ Y3 )
                     => ( ( ( less @ Y3 @ X )
                         => ( Y
                            = ( rBT_Im1808746437_right @ a @ B @ less @ X @ A4 @ Y3 @ S @ B3 ) ) )
                        & ( ~ ( less @ Y3 @ X )
                         => ( Y
                            = ( rBT_Im1591839508ombine @ a @ B @ A4 @ B3 ) ) ) ) ) ) ) ) ) ) )).

% local.rbt_del.elims
thf(fact_159_local_Orbt__del_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,Y: a,C2: rBT_Im1923302023_color,A2: ( rBT_Im246033960le_rbt @ a @ B ),S2: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ X @ Y )
       => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C2 @ A2 @ Y @ S2 @ B2 ) )
          = ( rBT_Im1152561598m_left @ a @ B @ less @ X @ A2 @ Y @ S2 @ B2 ) ) )
      & ( ~ ( less @ X @ Y )
       => ( ( ( less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C2 @ A2 @ Y @ S2 @ B2 ) )
              = ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S2 @ B2 ) ) )
          & ( ~ ( less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C2 @ A2 @ Y @ S2 @ B2 ) )
              = ( rBT_Im1591839508ombine @ a @ B @ A2 @ B2 ) ) ) ) ) ) )).

% local.rbt_del.simps(2)
thf(fact_160_local_Orbt__del__from__left_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Z: a,V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S2: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) @ Y @ S2 @ B2 )
      = ( rBT_Im1278323832e_left @ a @ B @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) @ Y @ S2 @ B2 ) ) )).

% local.rbt_del_from_left.simps(1)
thf(fact_161_local_Orbt__del__from__right_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S2: B,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Z: a,V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) )
      = ( rBT_Im1053358987_right @ a @ B @ A2 @ Y @ S2 @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) ) ) )).

% local.rbt_del_from_right.simps(1)
thf(fact_162_local_Orbt__map__entry_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( B > B ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ B ),V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ Rt ) )
          = ( rBT_Im480247531Branch @ a @ B @ C2 @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ Lt ) @ X @ V @ Rt ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ Rt ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ ( F @ V ) @ Rt ) ) ) ) ) ) )).

% local.rbt_map_entry.simps(2)
thf(fact_163_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 )
        & ( X24 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_164_local_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ C2 @ L @ K @ V @ R2 ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
        & ( rBT_Im1259024060reater @ a @ B @ less @ K @ R2 )
        & ( rBT_Im759614907sorted @ a @ B @ less @ L )
        & ( rBT_Im759614907sorted @ a @ B @ less @ R2 ) ) ) )).

% local.rbt_sorted.simps(2)
thf(fact_165_local_Orbt__less__simps_I2_J,axiom,(
    ! [C: $tType,K: a,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C ),Kt: a,V: C,Rt: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im2075124343t_less @ a @ C @ less @ K @ ( rBT_Im480247531Branch @ a @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ a @ C @ less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ a @ C @ less @ K @ Rt ) ) ) )).

% local.rbt_less_simps(2)
thf(fact_166_local_Orbt__greater__simps_I2_J,axiom,(
    ! [C: $tType,K: a,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C ),Kt: a,V: C,Rt: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im1259024060reater @ a @ C @ less @ K @ ( rBT_Im480247531Branch @ a @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ K @ Kt )
        & ( rBT_Im1259024060reater @ a @ C @ less @ K @ Lt )
        & ( rBT_Im1259024060reater @ a @ C @ less @ K @ Rt ) ) ) )).

% local.rbt_greater_simps(2)
thf(fact_167_map_Osimps_I2_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1728190513le_map @ A @ B @ C @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ K @ V @ Rt ) )
      = ( rBT_Im480247531Branch @ A @ C @ C2 @ ( rBT_Im1728190513le_map @ A @ B @ C @ F @ Lt ) @ K @ ( F @ K @ V ) @ ( rBT_Im1728190513le_map @ A @ B @ C @ F @ Rt ) ) ) )).

% map.simps(2)
thf(fact_168_ord_Orbt__map__entry_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( B > B ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ Rt ) )
          = ( rBT_Im480247531Branch @ A @ B @ C2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ Lt ) @ X @ V @ Rt ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ Rt ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ ( F @ V ) @ Rt ) ) ) ) ) ) )).

% ord.rbt_map_entry.simps(2)
thf(fact_169_paint_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C2: rBT_Im1923302023_color,Uu2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im945281971_paint @ A @ B @ C2 @ ( rBT_Im480247531Branch @ A @ B @ Uu2 @ L @ K @ V @ R2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ C2 @ L @ K @ V @ R2 ) ) )).

% paint.simps(2)
thf(fact_170_color__of_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,C2: rBT_Im1923302023_color,Uu2: ( rBT_Im246033960le_rbt @ A @ B ),Uv2: A,Uw: B,Ux: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Uu2 @ Uv2 @ Uw @ Ux ) )
      = C2 ) )).

% color_of.simps(2)
thf(fact_171_ord_Orbt__less__simps_I2_J,axiom,(
    ! [C: $tType,A: $tType,Less: ( A > A > $o ),K: A,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C ),Kt: A,V: C,Rt: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ ( rBT_Im480247531Branch @ A @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ Rt ) ) ) )).

% ord.rbt_less_simps(2)
thf(fact_172_ord_Orbt__greater__simps_I2_J,axiom,(
    ! [C: $tType,A: $tType,Less: ( A > A > $o ),K: A,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C ),Kt: A,V: C,Rt: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1259024060reater @ A @ C @ Less @ K @ ( rBT_Im480247531Branch @ A @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ K @ Kt )
        & ( rBT_Im1259024060reater @ A @ C @ Less @ K @ Lt )
        & ( rBT_Im1259024060reater @ A @ C @ Less @ K @ Rt ) ) ) )).

% ord.rbt_greater_simps(2)
thf(fact_173_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_174_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X1: rBT_Im1923302023_color,X26: ( rBT_Im246033960le_rbt @ A @ B ),X32: A,X4: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X26 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X1 @ X26 @ X32 @ X4 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_175_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X232 @ X242 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_176_combine_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) ) )).

% combine.simps(2)
thf(fact_177_inv1l_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C2 @ L @ K @ V @ R2 ) )
      = ( ( rBT_Im1040612427e_inv1 @ A @ B @ L )
        & ( rBT_Im1040612427e_inv1 @ A @ B @ R2 ) ) ) )).

% inv1l.simps(2)
thf(fact_178_balance__left_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(9)
thf(fact_179_balance__right_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(9)
thf(fact_180_inv1_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ K @ V @ Rt ) )
      = ( ( rBT_Im1040612427e_inv1 @ A @ B @ Lt )
        & ( rBT_Im1040612427e_inv1 @ A @ B @ Rt )
        & ( ( C2 = rBT_Impl_Mirabelle_B )
          | ( ( ( rBT_Im1805589839lor_of @ A @ B @ Lt )
              = rBT_Impl_Mirabelle_B )
            & ( ( rBT_Im1805589839lor_of @ A @ B @ Rt )
              = rBT_Impl_Mirabelle_B ) ) ) ) ) )).

% inv1.simps(2)
thf(fact_181_ord_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ C2 @ L @ K @ V @ R2 ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ L )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ K @ R2 )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ L )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ R2 ) ) ) )).

% ord.rbt_sorted.simps(2)
thf(fact_182_ord_Orbt__del__from__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Z: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S2: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) @ Y @ S2 @ B2 )
      = ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) @ Y @ S2 @ B2 ) ) )).

% ord.rbt_del_from_left.simps(1)
thf(fact_183_ord_Orbt__del__from__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S2: B,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Z: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) )
      = ( rBT_Im1053358987_right @ A @ B @ A2 @ Y @ S2 @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) ) ) )).

% ord.rbt_del_from_right.simps(1)
thf(fact_184_ord_Orbt__del_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Y: A,C2: rBT_Im1923302023_color,A2: ( rBT_Im246033960le_rbt @ A @ B ),S2: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ X @ Y )
       => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C2 @ A2 @ Y @ S2 @ B2 ) )
          = ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ A2 @ Y @ S2 @ B2 ) ) )
      & ( ~ ( Less @ X @ Y )
       => ( ( ( Less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C2 @ A2 @ Y @ S2 @ B2 ) )
              = ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S2 @ B2 ) ) )
          & ( ~ ( Less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C2 @ A2 @ Y @ S2 @ B2 ) )
              = ( rBT_Im1591839508ombine @ A @ B @ A2 @ B2 ) ) ) ) ) ) )).

% ord.rbt_del.simps(2)
thf(fact_185_ord_Orbt__del_Oelims,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Xa: ( rBT_Im246033960le_rbt @ A @ B ),Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( rBT_Im418718756_Empty @ A @ B ) )
         => ( Y
           != ( rBT_Im418718756_Empty @ A @ B ) ) )
       => ~ ( ! [C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ A @ B ),Y3: A,S: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( Xa
                  = ( rBT_Im480247531Branch @ A @ B @ C3 @ A4 @ Y3 @ S @ B3 ) )
               => ~ ( ( ( Less @ X @ Y3 )
                     => ( Y
                        = ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ A4 @ Y3 @ S @ B3 ) ) )
                    & ( ~ ( Less @ X @ Y3 )
                     => ( ( ( Less @ Y3 @ X )
                         => ( Y
                            = ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A4 @ Y3 @ S @ B3 ) ) )
                        & ( ~ ( Less @ Y3 @ X )
                         => ( Y
                            = ( rBT_Im1591839508ombine @ A @ B @ A4 @ B3 ) ) ) ) ) ) ) ) ) ) )).

% ord.rbt_del.elims
thf(fact_186_local_Orbt__del__from__left_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,Y: a,S2: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) @ Y @ S2 @ B2 )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) ) @ Y @ S2 @ B2 ) ) )).

% local.rbt_del_from_left.simps(2)
thf(fact_187_local_Orbt__del__from__right_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S2: B] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S2 @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S2 @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) ) ) ) )).

% local.rbt_del_from_right.simps(2)
thf(fact_188_local_Oins__inv1__inv2_I2_J,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ a @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ a @ B @ T )
       => ( ( rBT_Im315265182height @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
          = ( rBT_Im315265182height @ a @ B @ T ) ) ) ) )).

% local.ins_inv1_inv2(2)
thf(fact_189_local_Orbt__map__entry__inv2_I2_J,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im315265182height @ a @ B @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im315265182height @ a @ B @ T ) ) )).

% local.rbt_map_entry_inv2(2)
thf(fact_190_local_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R2 ) )
          = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R2 ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R2 ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R2 ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R2 ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R2 ) ) ) ) ) ) )).

% local.rbt_ins.simps(3)
thf(fact_191_local_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,P: ( ( a > B > B > B ) > a > B > ( rBT_Im246033960le_rbt @ a @ B ) > $o ),A0: ( a > B > B > B ),A1: a,A22: B,A32: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ! [F3: ( a > B > B > B ),K3: a,V3: B] :
          ( P @ F3 @ K3 @ V3 @ ( rBT_Im418718756_Empty @ a @ B ) )
     => ( ! [F3: ( a > B > B > B ),K3: a,V3: B,L3: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y3: B,R3: ( rBT_Im246033960le_rbt @ a @ B )] :
            ( ( ( less @ K3 @ X3 )
             => ( P @ F3 @ K3 @ V3 @ L3 ) )
           => ( ( ~ ( less @ K3 @ X3 )
               => ( ( less @ X3 @ K3 )
                 => ( P @ F3 @ K3 @ V3 @ R3 ) ) )
             => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L3 @ X3 @ Y3 @ R3 ) ) ) )
       => ( ! [F3: ( a > B > B > B ),K3: a,V3: B,L3: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y3: B,R3: ( rBT_Im246033960le_rbt @ a @ B )] :
              ( ( ( less @ K3 @ X3 )
               => ( P @ F3 @ K3 @ V3 @ L3 ) )
             => ( ( ~ ( less @ K3 @ X3 )
                 => ( ( less @ X3 @ K3 )
                   => ( P @ F3 @ K3 @ V3 @ R3 ) ) )
               => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L3 @ X3 @ Y3 @ R3 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% local.rbt_ins.induct
thf(fact_192_local_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B] :
      ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ a @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) ) ) )).

% local.rbt_ins.simps(1)
thf(fact_193_local_Orbt__del__from__left_Osimps_I3_J,axiom,(
    ! [B: $tType,X: a,Va: ( rBT_Im246033960le_rbt @ a @ B ),Vb: a,Vc: B,Vd: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S2: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) @ Y @ S2 @ B2 )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) @ Y @ S2 @ B2 ) ) )).

% local.rbt_del_from_left.simps(3)
thf(fact_194_local_Orbt__del__from__right_Osimps_I3_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S2: B,Va: ( rBT_Im246033960le_rbt @ a @ B ),Vb: a,Vc: B,Vd: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S2 @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% local.rbt_del_from_right.simps(3)
thf(fact_195_color_Oexhaust,axiom,(
    ! [Y: rBT_Im1923302023_color] :
      ( ( Y != rBT_Impl_Mirabelle_R )
     => ( Y = rBT_Impl_Mirabelle_B ) ) )).

% color.exhaust
thf(fact_196_color_Oinduct,axiom,(
    ! [P: ( rBT_Im1923302023_color > $o ),Color: rBT_Im1923302023_color] :
      ( ( P @ rBT_Impl_Mirabelle_R )
     => ( ( P @ rBT_Impl_Mirabelle_B )
       => ( P @ Color ) ) ) )).

% color.induct
thf(fact_197_color_Odistinct_I1_J,axiom,(
    rBT_Impl_Mirabelle_R != rBT_Impl_Mirabelle_B )).

% color.distinct(1)
thf(fact_198_ord_Orbt__map__entry__inv2_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im315265182height @ A @ B @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im315265182height @ A @ B @ T ) ) )).

% ord.rbt_map_entry_inv2(2)
thf(fact_199_map__inv2_I2_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im315265182height @ A @ B @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im315265182height @ A @ C @ T ) ) )).

% map_inv2(2)
thf(fact_200_ord_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( A > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R2 ) )
          = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ L ) @ X @ Y @ R2 ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R2 ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ R2 ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R2 ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R2 ) ) ) ) ) ) )).

% ord.rbt_ins.simps(3)
thf(fact_201_inv2_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ K @ V @ Rt ) )
      = ( ( rBT_Im1040612428e_inv2 @ A @ B @ Lt )
        & ( rBT_Im1040612428e_inv2 @ A @ B @ Rt )
        & ( ( rBT_Im315265182height @ A @ B @ Lt )
          = ( rBT_Im315265182height @ A @ B @ Rt ) ) ) ) )).

% inv2.simps(2)
thf(fact_202_combine__inv2_I2_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ Lt )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ Rt )
       => ( ( ( rBT_Im315265182height @ A @ B @ Lt )
            = ( rBT_Im315265182height @ A @ B @ Rt ) )
         => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) ) ) ) ) )).

% combine_inv2(2)
thf(fact_203_combine__inv2_I1_J,axiom,(
    ! [B: $tType,A: $tType,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ Lt )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ Rt )
       => ( ( ( rBT_Im315265182height @ A @ B @ Lt )
            = ( rBT_Im315265182height @ A @ B @ Rt ) )
         => ( ( rBT_Im315265182height @ A @ B @ ( rBT_Im1591839508ombine @ A @ B @ Lt @ Rt ) )
            = ( rBT_Im315265182height @ A @ B @ Lt ) ) ) ) ) )).

% combine_inv2(1)
thf(fact_204_ord_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Less: ( A > A > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [F3: ( A > B > B > B ),K3: A,V3: B] :
          ( P @ F3 @ K3 @ V3 @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L3: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( ( Less @ K3 @ X3 )
             => ( P @ F3 @ K3 @ V3 @ L3 ) )
           => ( ( ~ ( Less @ K3 @ X3 )
               => ( ( Less @ X3 @ K3 )
                 => ( P @ F3 @ K3 @ V3 @ R3 ) ) )
             => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L3 @ X3 @ Y3 @ R3 ) ) ) )
       => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L3: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( ( Less @ K3 @ X3 )
               => ( P @ F3 @ K3 @ V3 @ L3 ) )
             => ( ( ~ ( Less @ K3 @ X3 )
                 => ( ( Less @ X3 @ K3 )
                   => ( P @ F3 @ K3 @ V3 @ R3 ) ) )
               => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L3 @ X3 @ Y3 @ R3 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% ord.rbt_ins.induct
thf(fact_205_skip__red_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [L3: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,V3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L3 @ K3 @ V3 @ R3 ) )
     => ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
       => ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) )
         => ( P @ A0 ) ) ) ) )).

% skip_red.induct
thf(fact_206_skip__red_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [L3: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,V3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( X
         != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L3 @ K3 @ V3 @ R3 ) )
     => ( ( X
         != ( rBT_Im418718756_Empty @ A @ B ) )
       => ~ ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( X
               != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) ) ) ) ) )).

% skip_red.cases
thf(fact_207_combine_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( rBT_Im246033960le_rbt @ A @ B ),A1: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [X1: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( P @ ( rBT_Im418718756_Empty @ A @ B ) @ X1 )
     => ( ! [V3: rBT_Im1923302023_color,Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( P @ ( rBT_Im480247531Branch @ A @ B @ V3 @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im418718756_Empty @ A @ B ) )
       => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y3: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( P @ B3 @ C3 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K3 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C3 @ S @ Y3 @ D2 ) ) )
         => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y3: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( P @ B3 @ C3 )
               => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A4 @ K3 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C3 @ S @ Y3 @ D2 ) ) )
           => ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B ),B3: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,C3: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ B3 )
                 => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B3 @ K3 @ X3 @ C3 ) ) )
             => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
                    ( ( P @ B3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) )
                   => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K3 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) ) )
               => ( P @ A0 @ A1 ) ) ) ) ) ) ) )).

% combine.induct
thf(fact_208_rbt__cases,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( T
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [L3: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,V3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( T
           != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L3 @ K3 @ V3 @ R3 ) )
       => ~ ( ! [L3: ( rBT_Im246033960le_rbt @ A @ B ),K3: A,V3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( T
               != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L3 @ K3 @ V3 @ R3 ) ) ) ) ) )).

% rbt_cases
thf(fact_209_balance__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S2 @ Y @ C2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S2 @ Y @ C2 ) ) )).

% balance_left.simps(1)
thf(fact_210_ord_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,V: B] :
      ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord.rbt_ins.simps(1)
thf(fact_211_balance__left_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(7)
thf(fact_212_balance__left_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(8)
thf(fact_213_combine_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im1591839508ombine @ A @ B @ B2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% combine.simps(6)
thf(fact_214_combine_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ K @ X @ C2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ B2 ) @ K @ X @ C2 ) ) )).

% combine.simps(5)
thf(fact_215_balance__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S2 @ Y @ C2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S2 @ Y @ C2 ) ) ) )).

% balance_right.simps(1)
thf(fact_216_balance__right_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(7)
thf(fact_217_balance__right_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(8)
thf(fact_218_ord_Orbt__del__from__right_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S2: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S2 @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% ord.rbt_del_from_right.simps(3)
thf(fact_219_ord_Orbt__del__from__left_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S2: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) @ Y @ S2 @ B2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) @ Y @ S2 @ B2 ) ) )).

% ord.rbt_del_from_left.simps(3)
thf(fact_220_ord_Oins__inv1__inv2_I2_J,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B ),Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,X: B] :
      ( ( rBT_Im1040612427e_inv1 @ A @ B @ T )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ T )
       => ( ( rBT_Im315265182height @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ X @ T ) )
          = ( rBT_Im315265182height @ A @ B @ T ) ) ) ) )).

% ord.ins_inv1_inv2(2)
thf(fact_221_ord__class_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( ! [F3: ( A > B > B > B ),K3: A,V3: B] :
              ( P @ F3 @ K3 @ V3 @ ( rBT_Im418718756_Empty @ A @ B ) )
         => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L3: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( ( ord_less @ A @ K3 @ X3 )
                 => ( P @ F3 @ K3 @ V3 @ L3 ) )
               => ( ( ~ ( ord_less @ A @ K3 @ X3 )
                   => ( ( ord_less @ A @ X3 @ K3 )
                     => ( P @ F3 @ K3 @ V3 @ R3 ) ) )
                 => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L3 @ X3 @ Y3 @ R3 ) ) ) )
           => ( ! [F3: ( A > B > B > B ),K3: A,V3: B,L3: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y3: B,R3: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( ( ord_less @ A @ K3 @ X3 )
                   => ( P @ F3 @ K3 @ V3 @ L3 ) )
                 => ( ( ~ ( ord_less @ A @ K3 @ X3 )
                     => ( ( ord_less @ A @ X3 @ K3 )
                       => ( P @ F3 @ K3 @ V3 @ R3 ) ) )
                   => ( P @ F3 @ K3 @ V3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L3 @ X3 @ Y3 @ R3 ) ) ) )
             => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) ) )).

% ord_class.rbt_ins.induct
thf(fact_222_balance__left_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(11)
thf(fact_223_balance__left_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(10)
thf(fact_224_balance__right_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(11)
thf(fact_225_balance__right_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(10)
thf(fact_226_ord_Orbt__del__from__left_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Y: A,S2: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) @ Y @ S2 @ B2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) ) @ Y @ S2 @ B2 ) ) )).

% ord.rbt_del_from_left.simps(2)
thf(fact_227_ord_Orbt__del__from__right_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S2: B] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S2 @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% ord.rbt_del_from_right.simps(2)
thf(fact_228_local_Orbt__ins_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R2 ) )
          = ( rBT_Im1648453169alance @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R2 ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R2 ) )
              = ( rBT_Im1648453169alance @ a @ B @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R2 ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R2 ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ ( F @ K @ Y @ V ) @ R2 ) ) ) ) ) ) )).

% local.rbt_ins.simps(2)
thf(fact_229_local_Obalance__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R2 )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R2 )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R2 ) ) ) ) ) ) )).

% local.balance_rbt_sorted
thf(fact_230_local_Obalance__rbt__less,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ a @ B @ less @ V @ B2 )
        & ( less @ K @ V ) ) ) )).

% local.balance_rbt_less
thf(fact_231_local_Obalance__rbt__greater,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ A2 )
        & ( rBT_Im1259024060reater @ a @ B @ less @ V @ B2 )
        & ( less @ V @ K ) ) ) )).

% local.balance_rbt_greater
thf(fact_232_balance_Osimps_I23_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) ) )).

% balance.simps(23)
thf(fact_233_balance_Osimps_I27_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(27)
thf(fact_234_balance_Osimps_I29_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(29)
thf(fact_235_balance_Osimps_I39_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(39)
thf(fact_236_balance_Osimps_I43_J,axiom,(
    ! [B: $tType,A: $tType,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(43)
thf(fact_237_balance_Osimps_I45_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(45)
thf(fact_238_ord_Obalance__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ B2 )
        & ( Less @ K @ V ) ) ) )).

% ord.balance_rbt_less
thf(fact_239_ord_Obalance__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ V @ B2 )
        & ( Less @ V @ K ) ) ) )).

% ord.balance_rbt_greater
thf(fact_240_balance__inv2,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),R2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B] :
      ( ( rBT_Im1040612428e_inv2 @ A @ B @ L )
     => ( ( rBT_Im1040612428e_inv2 @ A @ B @ R2 )
       => ( ( ( rBT_Im315265182height @ A @ B @ L )
            = ( rBT_Im315265182height @ A @ B @ R2 ) )
         => ( rBT_Im1040612428e_inv2 @ A @ B @ ( rBT_Im1648453169alance @ A @ B @ L @ K @ V @ R2 ) ) ) ) ) )).

% balance_inv2
thf(fact_241_balance__inv1,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),R2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B] :
      ( ( rBT_Im1071879905_inv1l @ A @ B @ L )
     => ( ( rBT_Im1071879905_inv1l @ A @ B @ R2 )
       => ( rBT_Im1040612427e_inv1 @ A @ B @ ( rBT_Im1648453169alance @ A @ B @ L @ K @ V @ R2 ) ) ) ) )).

% balance_inv1
thf(fact_242_balance_Osimps_I44_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(44)
thf(fact_243_balance_Osimps_I42_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(42)
thf(fact_244_balance_Osimps_I41_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: A,Vg: B,S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(41)
thf(fact_245_balance_Osimps_I40_J,axiom,(
    ! [B: $tType,A: $tType,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(40)
thf(fact_246_balance_Osimps_I37_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(37)
thf(fact_247_balance_Osimps_I36_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,S2: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(36)
thf(fact_248_balance_Osimps_I35_J,axiom,(
    ! [B: $tType,A: $tType,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(35)
thf(fact_249_balance_Osimps_I34_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(34)
thf(fact_250_balance_Osimps_I33_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vb: A,Vc: B,S2: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(33)
thf(fact_251_balance_Osimps_I32_J,axiom,(
    ! [B: $tType,A: $tType,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(32)
thf(fact_252_balance_Osimps_I28_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(28)
thf(fact_253_balance_Osimps_I26_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(26)
thf(fact_254_balance_Osimps_I25_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(25)
thf(fact_255_balance_Osimps_I24_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S2 @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(24)

%----Type constructors (8)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( order @ A6 @ ( type2 @ A6 ) )
     => ( order @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( ord @ A6 @ ( type2 @ A6 ) )
     => ( ord @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Oorder_1,axiom,
    ( order @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_2,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oorder_3,axiom,(
    ! [A5: $tType] :
      ( order @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_4,axiom,(
    ! [A5: $tType] :
      ( ord @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_5,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_6,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (2)
thf(conj_0,hypothesis,
    ( rBT_Im759614907sorted @ a @ b @ less @ t )).

thf(conj_1,conjecture,
    ( rBT_Im759614907sorted @ a @ b @ less @ ( fold @ ( product_prod @ a @ b ) @ ( rBT_Im246033960le_rbt @ a @ b ) @ ( product_case_prod @ a @ b @ ( ( rBT_Im246033960le_rbt @ a @ b ) > ( rBT_Im246033960le_rbt @ a @ b ) ) @ ( rBT_Im627674146th_key @ a @ b @ less @ f ) ) @ xs @ t ) )).

%------------------------------------------------------------------------------
