%------------------------------------------------------------------------------
% File     : DAT242^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 1926
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__1926.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  319 (   0 unit;  56 type;   0 defn)
%            Number of atoms       : 7459 ( 244 equality;4976 variable)
%            Maximal formula depth :   36 (  15 average)
%            Number of connectives : 7819 (  68   ~;   5   |;  49   &;7456   @)
%                                         (   0 <=>; 241  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  425 ( 425   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   58 (  56   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1870 (   2 sgn;1785   !;   0   ?;  11   ^)
%                                         (1870   :;  74  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:49:12.170
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Option_Ooption,type,(
    option: $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (47)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oorder,type,(
    order: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_Fun_Ofun__upd,type,(
    fun_upd: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > A > B > A > B ) )).

thf(sy_c_List_Olist_Oset,type,(
    set2: 
      !>[A: $tType] :
        ( ( list @ A ) > ( set @ A ) ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_Map_Omap__of,type,(
    map_of: 
      !>[A: $tType,B: $tType] :
        ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) )).

thf(sy_c_Option_Ooption_ONone,type,(
    none: 
      !>[A: $tType] :
        ( option @ A ) )).

thf(sy_c_Option_Ooption_Omap__option,type,(
    map_option: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Orderings_Oorder_Ostrict__mono,type,(
    strict_mono: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance,type,(
    rBT_Im1648453169alance: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__left,type,(
    rBT_Im1278323832e_left: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance__right,type,(
    rBT_Im1053358987_right: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OB,type,(
    rBT_Impl_Mirabelle_B: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor_OR,type,(
    rBT_Impl_Mirabelle_R: rBT_Im1923302023_color )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor__of,type,(
    rBT_Im1805589839lor_of: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > rBT_Im1923302023_color ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ocombine,type,(
    rBT_Im1591839508ombine: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oentries,type,(
    rBT_Im954575269ntries: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ofold,type,(
    rBT_Im853940044e_fold: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > C > C ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Omap,type,(
    rBT_Im1728190513le_map: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ C ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Ois__rbt,type,(
    rBT_Im862805236is_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__bulkload,type,(
    rBT_Im1287406358lkload: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( list @ ( product_prod @ A @ B ) ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del,type,(
    rBT_Im1714610413bt_del: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del__from__left,type,(
    rBT_Im1152561598m_left: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__del__from__right,type,(
    rBT_Im1808746437_right: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__delete,type,(
    rBT_Im452238249delete: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__greater,type,(
    rBT_Im1259024060reater: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__ins,type,(
    rBT_Im1756508336bt_ins: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert,type,(
    rBT_Im852463031insert: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with,type,(
    rBT_Im241132701t_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__insert__with__key,type,(
    rBT_Im627674146th_key: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__less,type,(
    rBT_Im2075124343t_less: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__lookup,type,(
    rBT_Im35466040lookup: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > A > ( option @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__map__entry,type,(
    rBT_Im2018130356_entry: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__sorted,type,(
    rBT_Im759614907sorted: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Opaint,type,(
    rBT_Im945281971_paint: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_f,type,(
    f: a > b > b > b )).

thf(sy_v_less,type,(
    less: a > a > $o )).

thf(sy_v_t1,type,(
    t1: ( rBT_Im246033960le_rbt @ a @ b ) )).

thf(sy_v_t2,type,(
    t2: ( rBT_Im246033960le_rbt @ a @ b ) )).

%----Relevant facts (256)
thf(fact_0_local_Oantisym__conv3,axiom,(
    ! [Y: a,X: a] :
      ( ~ ( less @ Y @ X )
     => ( ( ~ ( less @ X @ Y ) )
        = ( X = Y ) ) ) )).

% local.antisym_conv3
thf(fact_1_local_Odual__order_Oasym,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ~ ( less @ A2 @ B2 ) ) )).

% local.dual_order.asym
thf(fact_2_local_Odual__order_Ostrict__implies__not__eq,axiom,(
    ! [B2: a,A2: a] :
      ( ( less @ B2 @ A2 )
     => ( A2 != B2 ) ) )).

% local.dual_order.strict_implies_not_eq
thf(fact_3_local_Odual__order_Ostrict__trans,axiom,(
    ! [B2: a,A2: a,C2: a] :
      ( ( less @ B2 @ A2 )
     => ( ( less @ C2 @ B2 )
       => ( less @ C2 @ A2 ) ) ) )).

% local.dual_order.strict_trans
thf(fact_4_local_Oless__asym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_asym
thf(fact_5_local_Oless__asym_H,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.less_asym'
thf(fact_6_local_Oless__imp__neq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_neq
thf(fact_7_local_Oless__imp__not__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( X != Y ) ) )).

% local.less_imp_not_eq
thf(fact_8_local_Oless__imp__not__eq2,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ( Y != X ) ) )).

% local.less_imp_not_eq2
thf(fact_9_local_Oless__imp__not__less,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_imp_not_less
thf(fact_10_local_Oless__imp__triv,axiom,(
    ! [X: a,Y: a,P: $o] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ X )
       => P ) ) )).

% local.less_imp_triv
thf(fact_11_local_Oless__irrefl,axiom,(
    ! [X: a] :
      ~ ( less @ X @ X ) )).

% local.less_irrefl
thf(fact_12_local_Oless__linear,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
      | ( X = Y )
      | ( less @ Y @ X ) ) )).

% local.less_linear
thf(fact_13_local_Oless__not__sym,axiom,(
    ! [X: a,Y: a] :
      ( ( less @ X @ Y )
     => ~ ( less @ Y @ X ) ) )).

% local.less_not_sym
thf(fact_14_local_Oless__trans,axiom,(
    ! [X: a,Y: a,Z: a] :
      ( ( less @ X @ Y )
     => ( ( less @ Y @ Z )
       => ( less @ X @ Z ) ) ) )).

% local.less_trans
thf(fact_15_local_Olinorder__cases,axiom,(
    ! [X: a,Y: a] :
      ( ~ ( less @ X @ Y )
     => ( ( X != Y )
       => ( less @ Y @ X ) ) ) )).

% local.linorder_cases
thf(fact_16_local_OneqE,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
     => ( ~ ( less @ X @ Y )
       => ( less @ Y @ X ) ) ) )).

% local.neqE
thf(fact_17_local_Oneq__iff,axiom,(
    ! [X: a,Y: a] :
      ( ( X != Y )
      = ( ( less @ X @ Y )
        | ( less @ Y @ X ) ) ) )).

% local.neq_iff
thf(fact_18_local_Onot__less__iff__gr__or__eq,axiom,(
    ! [X: a,Y: a] :
      ( ( ~ ( less @ X @ Y ) )
      = ( ( less @ Y @ X )
        | ( X = Y ) ) ) )).

% local.not_less_iff_gr_or_eq
thf(fact_19_local_Oord__eq__less__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( A2 = B2 )
     => ( ( less @ B2 @ C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.ord_eq_less_trans
thf(fact_20_local_Oord__less__eq__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( less @ A2 @ B2 )
     => ( ( B2 = C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.ord_less_eq_trans
thf(fact_21_local_Oorder_Oasym,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ~ ( less @ B2 @ A2 ) ) )).

% local.order.asym
thf(fact_22_local_Oorder_Oirrefl,axiom,(
    ! [A2: a] :
      ~ ( less @ A2 @ A2 ) )).

% local.order.irrefl
thf(fact_23_local_Oorder_Ostrict__implies__not__eq,axiom,(
    ! [A2: a,B2: a] :
      ( ( less @ A2 @ B2 )
     => ( A2 != B2 ) ) )).

% local.order.strict_implies_not_eq
thf(fact_24_local_Oorder_Ostrict__trans,axiom,(
    ! [A2: a,B2: a,C2: a] :
      ( ( less @ A2 @ B2 )
     => ( ( less @ B2 @ C2 )
       => ( less @ A2 @ C2 ) ) ) )).

% local.order.strict_trans
thf(fact_25_local_Orbt__insertwk__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_is_rbt
thf(fact_26_assms,axiom,
    ( rBT_Im862805236is_rbt @ a @ b @ less @ t1 )).

% assms
thf(fact_27_local_Orbt__delete__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im452238249delete @ a @ B @ less @ K @ T ) ) ) )).

% local.rbt_delete_is_rbt
thf(fact_28_local_Orbt__insertw__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_is_rbt
thf(fact_29_local_Ostrict__mono__eq,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ( F @ X )
              = ( F @ Y ) )
            = ( X = Y ) ) ) ) )).

% local.strict_mono_eq
thf(fact_30_local_Orbt__insert__is__rbt,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_is_rbt
thf(fact_31_local_Orbt__bulkload__is__rbt,axiom,(
    ! [B: $tType,Xs: ( list @ ( product_prod @ a @ B ) )] :
      ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im1287406358lkload @ a @ B @ less @ Xs ) ) )).

% local.rbt_bulkload_is_rbt
thf(fact_32_local_OEmpty__is__rbt,axiom,(
    ! [B: $tType] :
      ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.Empty_is_rbt
thf(fact_33_local_Orbt__insertwk__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.rbt_insertwk_rbt_sorted
thf(fact_34_local_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) )).

% local.is_rbt_rbt_sorted
thf(fact_35_local_Olexordp__eq__antisym,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
     => ( ( lexordp_eq @ a @ less @ Ys @ Xs )
       => ( Xs = Ys ) ) ) )).

% local.lexordp_eq_antisym
thf(fact_36_local_Olexordp__eq__linear,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
      | ( lexordp_eq @ a @ less @ Ys @ Xs ) ) )).

% local.lexordp_eq_linear
thf(fact_37_local_Olexordp__eq__refl,axiom,(
    ! [Xs: ( list @ a )] :
      ( lexordp_eq @ a @ less @ Xs @ Xs ) )).

% local.lexordp_eq_refl
thf(fact_38_local_Olexordp__eq__trans,axiom,(
    ! [Xs: ( list @ a ),Ys: ( list @ a ),Zs: ( list @ a )] :
      ( ( lexordp_eq @ a @ less @ Xs @ Ys )
     => ( ( lexordp_eq @ a @ less @ Ys @ Zs )
       => ( lexordp_eq @ a @ less @ Xs @ Zs ) ) ) )).

% local.lexordp_eq_trans
thf(fact_39_local_Omap__is__rbt,axiom,(
    ! [B: $tType,C: $tType,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ a @ C @ less @ T ) ) )).

% local.map_is_rbt
thf(fact_40_local_Orbt__map__entry__is__rbt,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ a @ B @ less @ T ) ) )).

% local.rbt_map_entry_is_rbt
thf(fact_41_local_Orbt__greater__trans,axiom,(
    ! [C: $tType,X: a,Y: a,T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( less @ X @ Y )
     => ( ( rBT_Im1259024060reater @ a @ C @ less @ Y @ T )
       => ( rBT_Im1259024060reater @ a @ C @ less @ X @ T ) ) ) )).

% local.rbt_greater_trans
thf(fact_42_local_Orbt__less__trans,axiom,(
    ! [C: $tType,X: a,T: ( rBT_Im246033960le_rbt @ a @ C ),Y: a] :
      ( ( rBT_Im2075124343t_less @ a @ C @ less @ X @ T )
     => ( ( less @ X @ Y )
       => ( rBT_Im2075124343t_less @ a @ C @ less @ Y @ T ) ) ) )).

% local.rbt_less_trans
thf(fact_43_local_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType] :
      ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_sorted.simps(1)
thf(fact_44_local_Orbt__map__entry__rbt__sorted,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im759614907sorted @ a @ B @ less @ T ) ) )).

% local.rbt_map_entry_rbt_sorted
thf(fact_45_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X2: A] :
            ( member @ A @ X2 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_48_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X3: A] :
          ( ( F @ X3 )
          = ( G @ X3 ) )
     => ( F = G ) ) )).

% ext
thf(fact_49_local_Orbt__map__entry__rbt__less,axiom,(
    ! [B: $tType,A2: a,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ A2 @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im2075124343t_less @ a @ B @ less @ A2 @ T ) ) )).

% local.rbt_map_entry_rbt_less
thf(fact_50_local_Orbt__map__entry__rbt__greater,axiom,(
    ! [B: $tType,A2: a,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ A2 @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im1259024060reater @ a @ B @ less @ A2 @ T ) ) )).

% local.rbt_map_entry_rbt_greater
thf(fact_51_local_Orbt__map__entry_Osimps_I1_J,axiom,(
    ! [B: $tType,K: a,F: ( B > B )] :
      ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_map_entry.simps(1)
thf(fact_52_local_Omap__rbt__sorted,axiom,(
    ! [B: $tType,C: $tType,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im759614907sorted @ a @ C @ less @ T ) ) )).

% local.map_rbt_sorted
thf(fact_53_local_Orbt__insert__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im852463031insert @ a @ B @ less @ K @ V @ T ) ) ) )).

% local.rbt_insert_rbt_sorted
thf(fact_54_local_Omap__rbt__less,axiom,(
    ! [B: $tType,C: $tType,K: a,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im2075124343t_less @ a @ C @ less @ K @ T ) ) )).

% local.map_rbt_less
thf(fact_55_local_Omap__rbt__greater,axiom,(
    ! [B: $tType,C: $tType,K: a,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) )
      = ( rBT_Im1259024060reater @ a @ C @ less @ K @ T ) ) )).

% local.map_rbt_greater
thf(fact_56_local_Orbt__insertw__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( B > B > B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im241132701t_with @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insertw_rbt_sorted
thf(fact_57_local_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_less_simps(1)
thf(fact_58_local_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_greater_simps(1)
thf(fact_59_map_Osimps_I1_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B > C )] :
      ( ( rBT_Im1728190513le_map @ A @ B @ C @ F @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ C ) ) )).

% map.simps(1)
thf(fact_60_ord_Orbt__less__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_less_simps(1)
thf(fact_61_ord_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_sorted.simps(1)
thf(fact_62_ord_Orbt__greater__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A] :
      ( rBT_Im1259024060reater @ A @ B @ Less @ K @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_greater_simps(1)
thf(fact_63_ord_Orbt__map__entry_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B )] :
      ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_map_entry.simps(1)
thf(fact_64_ord_Omap__rbt__less,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ T ) ) )).

% ord.map_rbt_less
thf(fact_65_ord_Omap__rbt__sorted,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im759614907sorted @ A @ C @ Less @ T ) ) )).

% ord.map_rbt_sorted
thf(fact_66_ord_Omap__rbt__greater,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ K @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im1259024060reater @ A @ C @ Less @ K @ T ) ) )).

% ord.map_rbt_greater
thf(fact_67_ord_Orbt__map__entry__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),A2: A,K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ A2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im2075124343t_less @ A @ B @ Less @ A2 @ T ) ) )).

% ord.rbt_map_entry_rbt_less
thf(fact_68_ord_Orbt__map__entry__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im759614907sorted @ A @ B @ Less @ T ) ) )).

% ord.rbt_map_entry_rbt_sorted
thf(fact_69_ord_Orbt__map__entry__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),A2: A,K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ A2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im1259024060reater @ A @ B @ Less @ A2 @ T ) ) )).

% ord.rbt_map_entry_rbt_greater
thf(fact_70_ord_OEmpty__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.Empty_is_rbt
thf(fact_71_fold__code_I1_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( B > C > A > A ),X: A] :
      ( ( rBT_Im853940044e_fold @ B @ C @ A @ F @ ( rBT_Im418718756_Empty @ B @ C ) @ X )
      = X ) )).

% fold_code(1)
thf(fact_72_ord_Omap__is__rbt,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ A @ C @ Less @ T ) ) )).

% ord.map_is_rbt
thf(fact_73_ord_Orbt__map__entry__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im862805236is_rbt @ A @ B @ Less @ T ) ) )).

% ord.rbt_map_entry_is_rbt
thf(fact_74_ord_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ T ) ) )).

% ord.is_rbt_rbt_sorted
thf(fact_75_local_Orbt__del__from__right__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Rt )
       => ( ( less @ K @ V )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1808746437_right @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_right_rbt_less
thf(fact_76_local_Orbt__del__from__right__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Rt )
       => ( ( less @ V @ K )
         => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1808746437_right @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_right_rbt_greater
thf(fact_77_local_Orbt__del__from__left__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Rt )
       => ( ( less @ K @ V )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1152561598m_left @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_left_rbt_less
thf(fact_78_local_Orbt__del__from__left__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Rt: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: a,Y: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Rt )
       => ( ( less @ V @ K )
         => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1152561598m_left @ a @ B @ less @ X @ Lt @ K @ Y @ Rt ) ) ) ) ) )).

% local.rbt_del_from_left_rbt_greater
thf(fact_79_local_Obalance__right__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1053358987_right @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_right_rbt_sorted
thf(fact_80_local_Ocombine__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) ) ) )).

% local.combine_rbt_sorted
thf(fact_81_local_Obalance__left__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1278323832e_left @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_left_rbt_sorted
thf(fact_82_local_Obalance__right__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_less
thf(fact_83_local_Ocombine__rbt__greater,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ L )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
       => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) )).

% local.combine_rbt_greater
thf(fact_84_local_Ocombine__rbt__less,axiom,(
    ! [B: $tType,K: a,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ R )
       => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1591839508ombine @ a @ B @ L @ R ) ) ) ) )).

% local.combine_rbt_less
thf(fact_85_local_Obalance__left__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_greater
thf(fact_86_local_Obalance__left__rbt__less,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ B2 )
       => ( ( less @ X @ K )
         => ( rBT_Im2075124343t_less @ a @ B @ less @ K @ ( rBT_Im1278323832e_left @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_left_rbt_less
thf(fact_87_local_Obalance__right__rbt__greater,axiom,(
    ! [B: $tType,K: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),B2: ( rBT_Im246033960le_rbt @ a @ B ),X: a,T: B] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ A2 )
     => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ B2 )
       => ( ( less @ K @ X )
         => ( rBT_Im1259024060reater @ a @ B @ less @ K @ ( rBT_Im1053358987_right @ a @ B @ A2 @ X @ T @ B2 ) ) ) ) ) )).

% local.balance_right_rbt_greater
thf(fact_88_balance__left_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(6)
thf(fact_89_combine_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ X )
      = X ) )).

% combine.simps(1)
thf(fact_90_balance__right_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(6)
thf(fact_91_local_Orbt__map__entry__color__of,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1805589839lor_of @ a @ B @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( rBT_Im1805589839lor_of @ a @ B @ T ) ) )).

% local.rbt_map_entry_color_of
thf(fact_92_local_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),C2: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) ) ) )).

% local.paint_rbt_sorted
thf(fact_93_local_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ C2 @ L @ K @ V @ R ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
        & ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
        & ( rBT_Im759614907sorted @ a @ B @ less @ L )
        & ( rBT_Im759614907sorted @ a @ B @ less @ R ) ) ) )).

% local.rbt_sorted.simps(2)
thf(fact_94_local_Obalance__rbt__sorted,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R ) ) ) ) ) ) )).

% local.balance_rbt_sorted
thf(fact_95_local_Orbt__del_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a] :
      ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im418718756_Empty @ a @ B ) ) )).

% local.rbt_del.simps(1)
thf(fact_96_local_Orbt__del__rbt__greater,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ Lt )
     => ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% local.rbt_del_rbt_greater
thf(fact_97_local_Orbt__del__rbt__sorted,axiom,(
    ! [B: $tType,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ Lt )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% local.rbt_del_rbt_sorted
thf(fact_98_local_Orbt__del__rbt__less,axiom,(
    ! [B: $tType,V: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),X: a] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ Lt )
     => ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Lt ) ) ) )).

% local.rbt_del_rbt_less
thf(fact_99_local_Orbt__map__entry_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( B > B ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ B ),V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ Rt ) )
          = ( rBT_Im480247531Branch @ a @ B @ C2 @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ Lt ) @ X @ V @ Rt ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ Rt ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ a @ B @ C2 @ Lt @ X @ ( F @ V ) @ Rt ) ) ) ) ) ) )).

% local.rbt_map_entry.simps(2)
thf(fact_100_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y23: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y23 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X23 = Y23 )
        & ( X24 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_101_local_Orbt__del_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,Y: a,C2: rBT_Im1923302023_color,A2: ( rBT_Im246033960le_rbt @ a @ B ),S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ X @ Y )
       => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C2 @ A2 @ Y @ S @ B2 ) )
          = ( rBT_Im1152561598m_left @ a @ B @ less @ X @ A2 @ Y @ S @ B2 ) ) )
      & ( ~ ( less @ X @ Y )
       => ( ( ( less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C2 @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ B2 ) ) )
          & ( ~ ( less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ C2 @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1591839508ombine @ a @ B @ A2 @ B2 ) ) ) ) ) ) )).

% local.rbt_del.simps(2)
thf(fact_102_local_Orbt__del_Oelims,axiom,(
    ! [B: $tType,X: a,Xa: ( rBT_Im246033960le_rbt @ a @ B ),Y: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( rBT_Im418718756_Empty @ a @ B ) )
         => ( Y
           != ( rBT_Im418718756_Empty @ a @ B ) ) )
       => ~ ( ! [C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ a @ B ),Y2: a,S2: B,B3: ( rBT_Im246033960le_rbt @ a @ B )] :
                ( ( Xa
                  = ( rBT_Im480247531Branch @ a @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) )
               => ~ ( ( ( less @ X @ Y2 )
                     => ( Y
                        = ( rBT_Im1152561598m_left @ a @ B @ less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                    & ( ~ ( less @ X @ Y2 )
                     => ( ( ( less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1808746437_right @ a @ B @ less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                        & ( ~ ( less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1591839508ombine @ a @ B @ A4 @ B3 ) ) ) ) ) ) ) ) ) ) )).

% local.rbt_del.elims
thf(fact_103_local_Orbt__less__simps_I2_J,axiom,(
    ! [C: $tType,K: a,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C ),Kt: a,V: C,Rt: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im2075124343t_less @ a @ C @ less @ K @ ( rBT_Im480247531Branch @ a @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ a @ C @ less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ a @ C @ less @ K @ Rt ) ) ) )).

% local.rbt_less_simps(2)
thf(fact_104_local_Orbt__greater__simps_I2_J,axiom,(
    ! [C: $tType,K: a,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ a @ C ),Kt: a,V: C,Rt: ( rBT_Im246033960le_rbt @ a @ C )] :
      ( ( rBT_Im1259024060reater @ a @ C @ less @ K @ ( rBT_Im480247531Branch @ a @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( less @ K @ Kt )
        & ( rBT_Im1259024060reater @ a @ C @ less @ K @ Lt )
        & ( rBT_Im1259024060reater @ a @ C @ less @ K @ Rt ) ) ) )).

% local.rbt_greater_simps(2)
thf(fact_105_local_Obalance__rbt__less,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ a @ B @ less @ V @ B2 )
        & ( less @ K @ V ) ) ) )).

% local.balance_rbt_less
thf(fact_106_local_Obalance__rbt__greater,axiom,(
    ! [B: $tType,V: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),K: a,X: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1648453169alance @ a @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ A2 )
        & ( rBT_Im1259024060reater @ a @ B @ less @ V @ B2 )
        & ( less @ V @ K ) ) ) )).

% local.balance_rbt_greater
thf(fact_107_local_Opaint__rbt__less,axiom,(
    ! [B: $tType,V: a,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) )
      = ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_less
thf(fact_108_local_Opaint__rbt__greater,axiom,(
    ! [B: $tType,V: a,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) )
      = ( rBT_Im1259024060reater @ a @ B @ less @ V @ T ) ) )).

% local.paint_rbt_greater
thf(fact_109_paint_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,C2: rBT_Im1923302023_color,Uu: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im945281971_paint @ A @ B @ C2 @ ( rBT_Im480247531Branch @ A @ B @ Uu @ L @ K @ V @ R ) )
      = ( rBT_Im480247531Branch @ A @ B @ C2 @ L @ K @ V @ R ) ) )).

% paint.simps(2)
thf(fact_110_color__of_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,C2: rBT_Im1923302023_color,Uu: ( rBT_Im246033960le_rbt @ A @ B ),Uv: A,Uw: B,Ux: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Uu @ Uv @ Uw @ Ux ) )
      = C2 ) )).

% color_of.simps(2)
thf(fact_111_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X23: A,X24: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X23 @ X24 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_112_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X1: rBT_Im1923302023_color,X26: ( rBT_Im246033960le_rbt @ A @ B ),X32: A,X4: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X26 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X1 @ X26 @ X32 @ X4 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_113_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X232 @ X242 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_114_ord_Orbt__less__simps_I2_J,axiom,(
    ! [C: $tType,A: $tType,Less: ( A > A > $o ),K: A,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C ),Kt: A,V: C,Rt: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ ( rBT_Im480247531Branch @ A @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ Kt @ K )
        & ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ Lt )
        & ( rBT_Im2075124343t_less @ A @ C @ Less @ K @ Rt ) ) ) )).

% ord.rbt_less_simps(2)
thf(fact_115_ord_Orbt__greater__simps_I2_J,axiom,(
    ! [C: $tType,A: $tType,Less: ( A > A > $o ),K: A,C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ C ),Kt: A,V: C,Rt: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1259024060reater @ A @ C @ Less @ K @ ( rBT_Im480247531Branch @ A @ C @ C2 @ Lt @ Kt @ V @ Rt ) )
      = ( ( Less @ K @ Kt )
        & ( rBT_Im1259024060reater @ A @ C @ Less @ K @ Lt )
        & ( rBT_Im1259024060reater @ A @ C @ Less @ K @ Rt ) ) ) )).

% ord.rbt_greater_simps(2)
thf(fact_116_ord_Obalance__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ B2 )
        & ( Less @ K @ V ) ) ) )).

% ord.balance_rbt_less
thf(fact_117_ord_Obalance__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im1648453169alance @ A @ B @ A2 @ K @ X @ B2 ) )
      = ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ A2 )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ V @ B2 )
        & ( Less @ V @ K ) ) ) )).

% ord.balance_rbt_greater
thf(fact_118_ord_Orbt__map__entry_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( B > B ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ Rt ) )
          = ( rBT_Im480247531Branch @ A @ B @ C2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ Lt ) @ X @ V @ Rt ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ Rt ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V @ Rt ) )
              = ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ ( F @ V ) @ Rt ) ) ) ) ) ) )).

% ord.rbt_map_entry.simps(2)
thf(fact_119_map_Osimps_I2_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1728190513le_map @ A @ B @ C @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ K @ V @ Rt ) )
      = ( rBT_Im480247531Branch @ A @ C @ C2 @ ( rBT_Im1728190513le_map @ A @ B @ C @ F @ Lt ) @ K @ ( F @ K @ V ) @ ( rBT_Im1728190513le_map @ A @ B @ C @ F @ Rt ) ) ) )).

% map.simps(2)
thf(fact_120_fold__code_I2_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( B > C > A > A ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ B @ C ),K: B,V: C,Rt: ( rBT_Im246033960le_rbt @ B @ C ),X: A] :
      ( ( rBT_Im853940044e_fold @ B @ C @ A @ F @ ( rBT_Im480247531Branch @ B @ C @ C2 @ Lt @ K @ V @ Rt ) @ X )
      = ( rBT_Im853940044e_fold @ B @ C @ A @ F @ Rt @ ( F @ K @ V @ ( rBT_Im853940044e_fold @ B @ C @ A @ F @ Lt @ X ) ) ) ) )).

% fold_code(2)
thf(fact_121_paint_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,C2: rBT_Im1923302023_color] :
      ( ( rBT_Im945281971_paint @ A @ B @ C2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% paint.simps(1)
thf(fact_122_ord_Opaint__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T: ( rBT_Im246033960le_rbt @ A @ B ),C2: rBT_Im1923302023_color] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ T )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) ) ) )).

% ord.paint_rbt_sorted
thf(fact_123_ord_Opaint__rbt__less,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) )
      = ( rBT_Im2075124343t_less @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_less
thf(fact_124_ord_Opaint__rbt__greater,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),V: A,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ V @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) )
      = ( rBT_Im1259024060reater @ A @ B @ Less @ V @ T ) ) )).

% ord.paint_rbt_greater
thf(fact_125_ord_Orbt__map__entry__color__of,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T ) )
      = ( rBT_Im1805589839lor_of @ A @ B @ T ) ) )).

% ord.rbt_map_entry_color_of
thf(fact_126_map__color__of,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C > B ),T: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T ) )
      = ( rBT_Im1805589839lor_of @ A @ C @ T ) ) )).

% map_color_of
thf(fact_127_ord_Orbt__del_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A] :
      ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_del.simps(1)
thf(fact_128_combine_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ V @ Va @ Vb @ Vc @ Vd ) ) )).

% combine.simps(2)
thf(fact_129_ord_Orbt__del_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Y: A,C2: rBT_Im1923302023_color,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ X @ Y )
       => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C2 @ A2 @ Y @ S @ B2 ) )
          = ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ A2 @ Y @ S @ B2 ) ) )
      & ( ~ ( Less @ X @ Y )
       => ( ( ( Less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C2 @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ B2 ) ) )
          & ( ~ ( Less @ Y @ X )
           => ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ C2 @ A2 @ Y @ S @ B2 ) )
              = ( rBT_Im1591839508ombine @ A @ B @ A2 @ B2 ) ) ) ) ) ) )).

% ord.rbt_del.simps(2)
thf(fact_130_ord_Orbt__del_Oelims,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Xa: ( rBT_Im246033960le_rbt @ A @ B ),Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( rBT_Im418718756_Empty @ A @ B ) )
         => ( Y
           != ( rBT_Im418718756_Empty @ A @ B ) ) )
       => ~ ( ! [C3: rBT_Im1923302023_color,A4: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B3: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( Xa
                  = ( rBT_Im480247531Branch @ A @ B @ C3 @ A4 @ Y2 @ S2 @ B3 ) )
               => ~ ( ( ( Less @ X @ Y2 )
                     => ( Y
                        = ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                    & ( ~ ( Less @ X @ Y2 )
                     => ( ( ( Less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A4 @ Y2 @ S2 @ B3 ) ) )
                        & ( ~ ( Less @ Y2 @ X )
                         => ( Y
                            = ( rBT_Im1591839508ombine @ A @ B @ A4 @ B3 ) ) ) ) ) ) ) ) ) ) )).

% ord.rbt_del.elims
thf(fact_131_ord_Orbt__sorted_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im480247531Branch @ A @ B @ C2 @ L @ K @ V @ R ) )
      = ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ L )
        & ( rBT_Im1259024060reater @ A @ B @ Less @ K @ R )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ L )
        & ( rBT_Im759614907sorted @ A @ B @ Less @ R ) ) ) )).

% ord.rbt_sorted.simps(2)
thf(fact_132_local_Orbt__del__from__left_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Z: a,V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) @ Y @ S @ B2 )
      = ( rBT_Im1278323832e_left @ a @ B @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) @ Y @ S @ B2 ) ) )).

% local.rbt_del_from_left.simps(1)
thf(fact_133_local_Orbt__del__from__right_Osimps_I1_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,Lt: ( rBT_Im246033960le_rbt @ a @ B ),Z: a,V: B,Rt: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) )
      = ( rBT_Im1053358987_right @ a @ B @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) ) ) )).

% local.rbt_del_from_right.simps(1)
thf(fact_134_local_Orbt__del__from__left_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,Y: a,S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) ) @ Y @ S @ B2 ) ) )).

% local.rbt_del_from_left.simps(2)
thf(fact_135_local_Orbt__del__from__right_Osimps_I2_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im418718756_Empty @ a @ B ) ) ) ) )).

% local.rbt_del_from_right.simps(2)
thf(fact_136_local_Orbt__delete__def,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im452238249delete @ a @ B @ less @ K @ T )
      = ( rBT_Im945281971_paint @ a @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1714610413bt_del @ a @ B @ less @ K @ T ) ) ) )).

% local.rbt_delete_def
thf(fact_137_local_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,P: ( ( a > B > B > B ) > a > B > ( rBT_Im246033960le_rbt @ a @ B ) > $o ),A0: ( a > B > B > B ),A1: a,A22: B,A32: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ! [F2: ( a > B > B > B ),K2: a,V2: B] :
          ( P @ F2 @ K2 @ V2 @ ( rBT_Im418718756_Empty @ a @ B ) )
     => ( ! [F2: ( a > B > B > B ),K2: a,V2: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
            ( ( ( less @ K2 @ X3 )
             => ( P @ F2 @ K2 @ V2 @ L2 ) )
           => ( ( ~ ( less @ K2 @ X3 )
               => ( ( less @ X3 @ K2 )
                 => ( P @ F2 @ K2 @ V2 @ R2 ) ) )
             => ( P @ F2 @ K2 @ V2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
       => ( ! [F2: ( a > B > B > B ),K2: a,V2: B,L2: ( rBT_Im246033960le_rbt @ a @ B ),X3: a,Y2: B,R2: ( rBT_Im246033960le_rbt @ a @ B )] :
              ( ( ( less @ K2 @ X3 )
               => ( P @ F2 @ K2 @ V2 @ L2 ) )
             => ( ( ~ ( less @ K2 @ X3 )
                 => ( ( less @ X3 @ K2 )
                   => ( P @ F2 @ K2 @ V2 @ R2 ) ) )
               => ( P @ F2 @ K2 @ V2 @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% local.rbt_ins.induct
thf(fact_138_local_Orbt__del__from__right_Osimps_I3_J,axiom,(
    ! [B: $tType,X: a,A2: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,Va: ( rBT_Im246033960le_rbt @ a @ B ),Vb: a,Vc: B,Vd: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1808746437_right @ a @ B @ less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% local.rbt_del_from_right.simps(3)
thf(fact_139_local_Orbt__del__from__left_Osimps_I3_J,axiom,(
    ! [B: $tType,X: a,Va: ( rBT_Im246033960le_rbt @ a @ B ),Vb: a,Vc: B,Vd: ( rBT_Im246033960le_rbt @ a @ B ),Y: a,S: B,B2: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1152561598m_left @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ a @ B @ less @ X @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) @ Y @ S @ B2 ) ) )).

% local.rbt_del_from_left.simps(3)
thf(fact_140_paint__color__of,axiom,(
    ! [A: $tType,B: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ T ) )
      = rBT_Impl_Mirabelle_B ) )).

% paint_color_of
thf(fact_141_rbt__cases,axiom,(
    ! [B: $tType,A: $tType,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( T
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( T
           != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ K2 @ V2 @ R2 ) )
       => ~ ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( T
               != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ K2 @ V2 @ R2 ) ) ) ) ) )).

% rbt_cases
thf(fact_142_combine_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( rBT_Im246033960le_rbt @ A @ B ),A1: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [X1: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( P @ ( rBT_Im418718756_Empty @ A @ B ) @ X1 )
     => ( ! [V2: rBT_Im1923302023_color,Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( P @ ( rBT_Im480247531Branch @ A @ B @ V2 @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im418718756_Empty @ A @ B ) )
       => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y2: B,D: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( P @ B3 @ C3 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K2 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C3 @ S2 @ Y2 @ D ) ) )
         => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),C3: ( rBT_Im246033960le_rbt @ A @ B ),S2: A,Y2: B,D: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( P @ B3 @ C3 )
               => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A4 @ K2 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C3 @ S2 @ Y2 @ D ) ) )
           => ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B ),B3: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,C3: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ B3 )
                 => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B3 @ K2 @ X3 @ C3 ) ) )
             => ( ! [A4: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,X3: B,B3: ( rBT_Im246033960le_rbt @ A @ B ),Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
                    ( ( P @ B3 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) )
                   => ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A4 @ K2 @ X3 @ B3 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) ) )
               => ( P @ A0 @ A1 ) ) ) ) ) ) ) )).

% combine.induct
thf(fact_143_skip__red_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( X
         != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ K2 @ V2 @ R2 ) )
     => ( ( X
         != ( rBT_Im418718756_Empty @ A @ B ) )
       => ~ ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( X
               != ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) ) ) ) ) )).

% skip_red.cases
thf(fact_144_skip__red_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ K2 @ V2 @ R2 ) )
     => ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
       => ( ! [Va2: ( rBT_Im246033960le_rbt @ A @ B ),Vb2: A,Vc2: B,Vd2: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( P @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va2 @ Vb2 @ Vc2 @ Vd2 ) )
         => ( P @ A0 ) ) ) ) )).

% skip_red.induct
thf(fact_145_ord_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Less: ( A > A > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ! [F2: ( A > B > B > B ),K2: A,V2: B] :
          ( P @ F2 @ K2 @ V2 @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [F2: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( ( Less @ K2 @ X3 )
             => ( P @ F2 @ K2 @ V2 @ L2 ) )
           => ( ( ~ ( Less @ K2 @ X3 )
               => ( ( Less @ X3 @ K2 )
                 => ( P @ F2 @ K2 @ V2 @ R2 ) ) )
             => ( P @ F2 @ K2 @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
       => ( ! [F2: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( ( ( Less @ K2 @ X3 )
               => ( P @ F2 @ K2 @ V2 @ L2 ) )
             => ( ( ~ ( Less @ K2 @ X3 )
                 => ( ( Less @ X3 @ K2 )
                   => ( P @ F2 @ K2 @ V2 @ R2 ) ) )
               => ( P @ F2 @ K2 @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
         => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) )).

% ord.rbt_ins.induct
thf(fact_146_balance__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ Y @ C2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C2 ) ) ) )).

% balance_right.simps(1)
thf(fact_147_balance__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ C2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ C2 ) ) )).

% balance_left.simps(1)
thf(fact_148_combine_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),B2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ K @ X @ C2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ B2 ) @ K @ X @ C2 ) ) )).

% combine.simps(5)
thf(fact_149_combine_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1591839508ombine @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im1591839508ombine @ A @ B @ B2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% combine.simps(6)
thf(fact_150_balance_Osimps_I13_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) ) ) )).

% balance.simps(13)
thf(fact_151_balance_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C2 @ Y @ Z @ D2 ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ D2 ) ) ) )).

% balance.simps(9)
thf(fact_152_balance_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(7)
thf(fact_153_balance_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ W @ X @ B2 ) @ S @ T @ C2 ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(3)
thf(fact_154_balance_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C2 @ Y @ Z @ D2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ D2 ) ) ) )).

% balance.simps(1)
thf(fact_155_color_Oexhaust,axiom,(
    ! [Y: rBT_Im1923302023_color] :
      ( ( Y != rBT_Impl_Mirabelle_R )
     => ( Y = rBT_Impl_Mirabelle_B ) ) )).

% color.exhaust
thf(fact_156_color_Oinduct,axiom,(
    ! [P: ( rBT_Im1923302023_color > $o ),Color: rBT_Im1923302023_color] :
      ( ( P @ rBT_Impl_Mirabelle_R )
     => ( ( P @ rBT_Impl_Mirabelle_B )
       => ( P @ Color ) ) ) )).

% color.induct
thf(fact_157_color_Odistinct_I1_J,axiom,(
    rBT_Impl_Mirabelle_R != rBT_Impl_Mirabelle_B )).

% color.distinct(1)
thf(fact_158_balance_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ W @ X @ B2 ) @ S @ T @ C2 ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(2)
thf(fact_159_balance_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(4)
thf(fact_160_balance_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(5)
thf(fact_161_balance_Osimps_I6_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(6)
thf(fact_162_balance_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,D2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ C2 @ Y @ Z @ D2 ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ D2 ) ) ) )).

% balance.simps(8)
thf(fact_163_balance_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(10)
thf(fact_164_balance_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance.simps(11)
thf(fact_165_balance_Osimps_I12_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),W: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,Z: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ B2 @ S @ T @ C2 ) @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ W @ X @ B2 ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ Y @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(12)
thf(fact_166_balance__left_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(10)
thf(fact_167_balance__left_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ Vh ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(11)
thf(fact_168_balance__right_Osimps_I10_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(10)
thf(fact_169_balance__right_Osimps_I11_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Vi @ Vj @ Vk @ Vl ) ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(11)
thf(fact_170_balance__left_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ S @ Y @ B2 ) ) ) )).

% balance_left.simps(3)
thf(fact_171_balance__right_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance_right.simps(3)
thf(fact_172_balance__left_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ S @ Y @ B2 ) ) ) )).

% balance_left.simps(2)
thf(fact_173_balance__right_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance_right.simps(2)
thf(fact_174_balance__left_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) @ T @ Z @ C2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ A2 ) @ S @ Y @ ( rBT_Im1648453169alance @ A @ B @ B2 @ T @ Z @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ C2 ) ) ) ) )).

% balance_left.simps(5)
thf(fact_175_balance__right_Osimps_I5_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C2 ) ) @ T @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ A2 ) @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ T @ Z @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% balance_right.simps(5)
thf(fact_176_balance_Osimps_I23_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) ) )).

% balance.simps(23)
thf(fact_177_balance_Osimps_I27_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(27)
thf(fact_178_balance_Osimps_I29_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(29)
thf(fact_179_balance_Osimps_I39_J,axiom,(
    ! [B: $tType,A: $tType,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(39)
thf(fact_180_balance_Osimps_I43_J,axiom,(
    ! [B: $tType,A: $tType,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(43)
thf(fact_181_balance_Osimps_I45_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vn: A,Vo: B,Vp: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vn @ Vo @ Vp ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(45)
thf(fact_182_color__of_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType] :
      ( ( rBT_Im1805589839lor_of @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = rBT_Impl_Mirabelle_B ) )).

% color_of.simps(1)
thf(fact_183_balance__left_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,A2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B,C2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ A2 @ S @ Y @ B2 ) @ T @ Z @ C2 ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ A2 ) @ S @ Y @ ( rBT_Im1648453169alance @ A @ B @ B2 @ T @ Z @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ C2 ) ) ) ) )).

% balance_left.simps(4)
thf(fact_184_balance__right_Osimps_I4_J,axiom,(
    ! [B: $tType,A: $tType,A2: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B,B2: ( rBT_Im246033960le_rbt @ A @ B ),S: A,Y: B,C2: ( rBT_Im246033960le_rbt @ A @ B ),T: A,Z: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ B2 @ S @ Y @ C2 ) ) @ T @ Z @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_R @ A2 ) @ K @ X @ B2 ) @ S @ Y @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ C2 @ T @ Z @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance_right.simps(4)
thf(fact_185_balance__left_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(8)
thf(fact_186_balance__left_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(7)
thf(fact_187_balance__right_Osimps_I8_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Ve @ Vf @ Vg @ Vh ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(8)
thf(fact_188_balance__right_Osimps_I7_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,K: A,X: B] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(7)
thf(fact_189_balance_Osimps_I14_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(14)
thf(fact_190_balance_Osimps_I15_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(15)
thf(fact_191_balance_Osimps_I16_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(16)
thf(fact_192_balance_Osimps_I17_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(17)
thf(fact_193_balance_Osimps_I18_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(18)
thf(fact_194_balance_Osimps_I19_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(19)
thf(fact_195_balance_Osimps_I20_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(20)
thf(fact_196_balance_Osimps_I21_J,axiom,(
    ! [B: $tType,A: $tType,S: A,T: B,V: rBT_Im1923302023_color,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) ) ) ) )).

% balance.simps(21)
thf(fact_197_balance_Osimps_I22_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(22)
thf(fact_198_balance_Osimps_I24_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(24)
thf(fact_199_balance_Osimps_I25_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(25)
thf(fact_200_balance_Osimps_I26_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% balance.simps(26)
thf(fact_201_balance_Osimps_I28_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) ) ) ) )).

% balance.simps(28)
thf(fact_202_balance_Osimps_I32_J,axiom,(
    ! [B: $tType,A: $tType,Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(32)
thf(fact_203_balance_Osimps_I33_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vb: A,Vc: B,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(33)
thf(fact_204_balance_Osimps_I34_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vf @ Vg @ Vh ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(34)
thf(fact_205_balance_Osimps_I35_J,axiom,(
    ! [B: $tType,A: $tType,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ Vd ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(35)
thf(fact_206_balance_Osimps_I36_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(36)
thf(fact_207_balance_Osimps_I37_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: ( rBT_Im246033960le_rbt @ A @ B ),Vg: A,Vh: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Ve: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vf @ Vg @ Vh @ Vi ) @ Vb @ Vc @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Ve @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% balance.simps(37)
thf(fact_208_balance_Osimps_I40_J,axiom,(
    ! [B: $tType,A: $tType,Vf: A,Vg: B,Vh: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ Vh ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(40)
thf(fact_209_balance_Osimps_I41_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: A,Vg: B,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(41)
thf(fact_210_balance_Osimps_I42_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vf: A,Vg: B,Vi: ( rBT_Im246033960le_rbt @ A @ B ),Vj: A,Vk: B,Vl: ( rBT_Im246033960le_rbt @ A @ B ),S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im418718756_Empty @ A @ B ) @ Vf @ Vg @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vi @ Vj @ Vk @ Vl ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(42)
thf(fact_211_balance_Osimps_I44_J,axiom,(
    ! [B: $tType,A: $tType,V: rBT_Im1923302023_color,Vj: ( rBT_Im246033960le_rbt @ A @ B ),Vk: A,Vl: B,Vm: ( rBT_Im246033960le_rbt @ A @ B ),Vf: A,Vg: B,S: A,T: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im480247531Branch @ A @ B @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Vj @ Vk @ Vl @ Vm ) @ Vf @ Vg @ ( rBT_Im418718756_Empty @ A @ B ) ) @ S @ T @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) ) ) )).

% balance.simps(44)
thf(fact_212_balance__left_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),K: A,X: B] :
      ( ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) @ K @ X @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_left.simps(9)
thf(fact_213_balance__right_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,K: A,X: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1053358987_right @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% balance_right.simps(9)
thf(fact_214_ord_Orbt__del__from__left_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) @ Y @ S @ B2 ) ) )).

% ord.rbt_del_from_left.simps(3)
thf(fact_215_ord_Orbt__del__from__right_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,Va: ( rBT_Im246033960le_rbt @ A @ B ),Vb: A,Vc: B,Vd: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ Va @ Vb @ Vc @ Vd ) ) ) ) )).

% ord.rbt_del_from_right.simps(3)
thf(fact_216_ord_Orbt__delete__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im452238249delete @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),K3: A,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1714610413bt_del @ A @ B @ Less2 @ K3 @ T2 ) ) ) ) )).

% ord.rbt_delete_def
thf(fact_217_ord_Orbt__del__from__right_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) ) ) ) )).

% ord.rbt_del_from_right.simps(2)
thf(fact_218_ord_Orbt__del__from__left_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Y: A,S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) @ Y @ S @ B2 )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im418718756_Empty @ A @ B ) ) @ Y @ S @ B2 ) ) )).

% ord.rbt_del_from_left.simps(2)
thf(fact_219_ord_Orbt__del__from__left_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Z: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,B2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1152561598m_left @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) @ Y @ S @ B2 )
      = ( rBT_Im1278323832e_left @ A @ B @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) @ Y @ S @ B2 ) ) )).

% ord.rbt_del_from_left.simps(1)
thf(fact_220_ord_Orbt__del__from__right_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),X: A,A2: ( rBT_Im246033960le_rbt @ A @ B ),Y: A,S: B,Lt: ( rBT_Im246033960le_rbt @ A @ B ),Z: A,V: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1808746437_right @ A @ B @ Less @ X @ A2 @ Y @ S @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) )
      = ( rBT_Im1053358987_right @ A @ B @ A2 @ Y @ S @ ( rBT_Im1714610413bt_del @ A @ B @ Less @ X @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ Lt @ Z @ V @ Rt ) ) ) ) )).

% ord.rbt_del_from_right.simps(1)
thf(fact_221_local_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im627674146th_key @ a @ B @ less @ F @ K @ V @ T )
      = ( rBT_Im945281971_paint @ a @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ T ) ) ) )).

% local.rbt_insert_with_key_def
thf(fact_222_local_Orbt__ins_Osimps_I2_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
          = ( rBT_Im1648453169alance @ a @ B @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im1648453169alance @ a @ B @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% local.rbt_ins.simps(2)
thf(fact_223_local_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,F: ( a > B > B > B ),K: a,V: B] :
      ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ a @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ a @ B ) ) ) )).

% local.rbt_ins.simps(1)
thf(fact_224_local_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,K: a,X: a,F: ( a > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ a @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( ( less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
          = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( less @ K @ X )
       => ( ( ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ V @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% local.rbt_ins.simps(3)
thf(fact_225_local_Oins__rbt__sorted,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),F: ( a > B > B > B ),K: a,X: B] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( rBT_Im759614907sorted @ a @ B @ less @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) ) ) )).

% local.ins_rbt_sorted
thf(fact_226_local_Oins__rbt__less,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im2075124343t_less @ a @ B @ less @ V @ T )
        & ( less @ K @ V ) ) ) )).

% local.ins_rbt_less
thf(fact_227_local_Oins__rbt__greater,axiom,(
    ! [B: $tType,V: a,F: ( a > B > B > B ),K: a,X: B,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ ( rBT_Im1756508336bt_ins @ a @ B @ less @ F @ K @ X @ T ) )
      = ( ( rBT_Im1259024060reater @ a @ B @ less @ V @ T )
        & ( less @ V @ K ) ) ) )).

% local.ins_rbt_greater
thf(fact_228_ord_Orbt__ins_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( A > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
          = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% ord.rbt_ins.simps(3)
thf(fact_229_ord_Orbt__ins_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,V: B] :
      ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ ( rBT_Im418718756_Empty @ A @ B ) @ K @ V @ ( rBT_Im418718756_Empty @ A @ B ) ) ) )).

% ord.rbt_ins.simps(1)
thf(fact_230_ord_Orbt__ins_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( A > B > B > B ),V: B,L: ( rBT_Im246033960le_rbt @ A @ B ),Y: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
          = ( rBT_Im1648453169alance @ A @ B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ L ) @ X @ Y @ R ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im1648453169alance @ A @ B @ L @ X @ Y @ ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ R ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im1756508336bt_ins @ A @ B @ Less @ F @ K @ V @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ Y @ R ) )
              = ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L @ X @ ( F @ K @ Y @ V ) @ R ) ) ) ) ) ) )).

% ord.rbt_ins.simps(2)
thf(fact_231_ord_Orbt__insert__with__key__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im627674146th_key @ A @ B )
      = ( ^ [Less2: ( A > A > $o ),F3: ( A > B > B > B ),K3: A,V3: B,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( rBT_Im945281971_paint @ A @ B @ rBT_Impl_Mirabelle_B @ ( rBT_Im1756508336bt_ins @ A @ B @ Less2 @ F3 @ K3 @ V3 @ T2 ) ) ) ) )).

% ord.rbt_insert_with_key_def
thf(fact_232_local_Orbt__lookup__balance,axiom,(
    ! [B: $tType,L: ( rBT_Im246033960le_rbt @ a @ B ),R: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,X: a] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ L )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ R )
       => ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ L )
         => ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ R )
           => ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im1648453169alance @ a @ B @ L @ K @ V @ R ) @ X )
              = ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im480247531Branch @ a @ B @ rBT_Impl_Mirabelle_B @ L @ K @ V @ R ) @ X ) ) ) ) ) ) )).

% local.rbt_lookup_balance
thf(fact_233_local_Ostrict__mono__less,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) )
            = ( less @ X @ Y ) ) ) ) )).

% local.strict_mono_less
thf(fact_234_local_Ostrict__monoD,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B ),X: a,Y: a] :
          ( ( strict_mono @ a @ B @ less @ F )
         => ( ( less @ X @ Y )
           => ( ord_less @ B @ ( F @ X ) @ ( F @ Y ) ) ) ) ) )).

% local.strict_monoD
thf(fact_235_local_Ostrict__monoI,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ! [X3: a,Y2: a] :
              ( ( less @ X3 @ Y2 )
             => ( ord_less @ B @ ( F @ X3 ) @ ( F @ Y2 ) ) )
         => ( strict_mono @ a @ B @ less @ F ) ) ) )).

% local.strict_monoI
thf(fact_236_local_Ostrict__mono__def,axiom,(
    ! [B: $tType] :
      ( ( order @ B @ ( type2 @ B ) )
     => ! [F: ( a > B )] :
          ( ( strict_mono @ a @ B @ less @ F )
          = ( ! [X2: a,Y3: a] :
                ( ( less @ X2 @ Y3 )
               => ( ord_less @ B @ ( F @ X2 ) @ ( F @ Y3 ) ) ) ) ) ) )).

% local.strict_mono_def
thf(fact_237_local_Opaint__rbt__lookup,axiom,(
    ! [B: $tType,C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im945281971_paint @ a @ B @ C2 @ T ) )
      = ( rBT_Im35466040lookup @ a @ B @ less @ T ) ) )).

% local.paint_rbt_lookup
thf(fact_238_ord_Opaint__rbt__lookup,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),C2: rBT_Im1923302023_color,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im945281971_paint @ A @ B @ C2 @ T ) )
      = ( rBT_Im35466040lookup @ A @ B @ Less @ T ) ) )).

% ord.paint_rbt_lookup
thf(fact_239_ord__class_Orbt__ins_Oinduct,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [P: ( ( A > B > B > B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > $o ),A0: ( A > B > B > B ),A1: A,A22: B,A32: ( rBT_Im246033960le_rbt @ A @ B )] :
          ( ! [F2: ( A > B > B > B ),K2: A,V2: B] :
              ( P @ F2 @ K2 @ V2 @ ( rBT_Im418718756_Empty @ A @ B ) )
         => ( ! [F2: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                ( ( ( ord_less @ A @ K2 @ X3 )
                 => ( P @ F2 @ K2 @ V2 @ L2 ) )
               => ( ( ~ ( ord_less @ A @ K2 @ X3 )
                   => ( ( ord_less @ A @ X3 @ K2 )
                     => ( P @ F2 @ K2 @ V2 @ R2 ) ) )
                 => ( P @ F2 @ K2 @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_B @ L2 @ X3 @ Y2 @ R2 ) ) ) )
           => ( ! [F2: ( A > B > B > B ),K2: A,V2: B,L2: ( rBT_Im246033960le_rbt @ A @ B ),X3: A,Y2: B,R2: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( ( ( ord_less @ A @ K2 @ X3 )
                   => ( P @ F2 @ K2 @ V2 @ L2 ) )
                 => ( ( ~ ( ord_less @ A @ K2 @ X3 )
                     => ( ( ord_less @ A @ X3 @ K2 )
                       => ( P @ F2 @ K2 @ V2 @ R2 ) ) )
                   => ( P @ F2 @ K2 @ V2 @ ( rBT_Im480247531Branch @ A @ B @ rBT_Impl_Mirabelle_R @ L2 @ X3 @ Y2 @ R2 ) ) ) )
             => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ) ) )).

% ord_class.rbt_ins.induct
thf(fact_240_local_Orbt__lookup__rbt__bulkload,axiom,(
    ! [B: $tType,Xs: ( list @ ( product_prod @ a @ B ) )] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im1287406358lkload @ a @ B @ less @ Xs ) )
      = ( map_of @ a @ B @ Xs ) ) )).

% local.rbt_lookup_rbt_bulkload
thf(fact_241_local_Orbt__lookup__Empty,axiom,(
    ! [B: $tType] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) )
      = ( ^ [X2: a] :
            ( none @ B ) ) ) )).

% local.rbt_lookup_Empty
thf(fact_242_local_Orbt__lookup_Osimps_I1_J,axiom,(
    ! [B: $tType,K: a] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im418718756_Empty @ a @ B ) @ K )
      = ( none @ B ) ) )).

% local.rbt_lookup.simps(1)
thf(fact_243_local_Orbt__lookup__rbt__greater,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im1259024060reater @ a @ B @ less @ K @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
        = ( none @ B ) ) ) )).

% local.rbt_lookup_rbt_greater
thf(fact_244_local_Orbt__lookup__rbt__less,axiom,(
    ! [B: $tType,K: a,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im2075124343t_less @ a @ B @ less @ K @ T )
     => ( ( rBT_Im35466040lookup @ a @ B @ less @ T @ K )
        = ( none @ B ) ) ) )).

% local.rbt_lookup_rbt_less
thf(fact_245_ord_Orbt__lookup__rbt__less,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im2075124343t_less @ A @ B @ Less @ K @ T )
     => ( ( rBT_Im35466040lookup @ A @ B @ Less @ T @ K )
        = ( none @ B ) ) ) )).

% ord.rbt_lookup_rbt_less
thf(fact_246_ord_Orbt__lookup__rbt__greater,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A,T: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1259024060reater @ A @ B @ Less @ K @ T )
     => ( ( rBT_Im35466040lookup @ A @ B @ Less @ T @ K )
        = ( none @ B ) ) ) )).

% ord.rbt_lookup_rbt_greater
thf(fact_247_ord_Orbt__lookup__Empty,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( ^ [X2: A] :
            ( none @ B ) ) ) )).

% ord.rbt_lookup_Empty
thf(fact_248_ord_Orbt__lookup_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,Less: ( A > A > $o ),K: A] :
      ( ( rBT_Im35466040lookup @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) @ K )
      = ( none @ B ) ) )).

% ord.rbt_lookup.simps(1)
thf(fact_249_local_Omap__of__entries,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T )
     => ( ( map_of @ a @ B @ ( rBT_Im954575269ntries @ a @ B @ T ) )
        = ( rBT_Im35466040lookup @ a @ B @ less @ T ) ) ) )).

% local.map_of_entries
thf(fact_250_local_Orbt__lookup__map,axiom,(
    ! [B: $tType,C: $tType,F: ( a > C > B ),T: ( rBT_Im246033960le_rbt @ a @ C ),X: a] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im1728190513le_map @ a @ C @ B @ F @ T ) @ X )
      = ( map_option @ C @ B @ ( F @ X ) @ ( rBT_Im35466040lookup @ a @ C @ less @ T @ X ) ) ) )).

% local.rbt_lookup_map
thf(fact_251_local_Oentries__rbt__lookup,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T22: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T22 )
       => ( ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T22 ) )
          = ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T22 ) ) ) ) ) )).

% local.entries_rbt_lookup
thf(fact_252_local_Oentries__eqI,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T22: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T22 )
       => ( ( ( rBT_Im35466040lookup @ a @ B @ less @ T1 )
            = ( rBT_Im35466040lookup @ a @ B @ less @ T22 ) )
         => ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T22 ) ) ) ) ) )).

% local.entries_eqI
thf(fact_253_local_Orbt__lookup__rbt__map__entry,axiom,(
    ! [B: $tType,K: a,F: ( B > B ),T: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im35466040lookup @ a @ B @ less @ ( rBT_Im2018130356_entry @ a @ B @ less @ K @ F @ T ) )
      = ( fun_upd @ a @ ( option @ B ) @ ( rBT_Im35466040lookup @ a @ B @ less @ T ) @ K @ ( map_option @ B @ B @ F @ ( rBT_Im35466040lookup @ a @ B @ less @ T @ K ) ) ) ) )).

% local.rbt_lookup_rbt_map_entry
thf(fact_254_local_Oset__entries__inject,axiom,(
    ! [B: $tType,T1: ( rBT_Im246033960le_rbt @ a @ B ),T22: ( rBT_Im246033960le_rbt @ a @ B )] :
      ( ( rBT_Im759614907sorted @ a @ B @ less @ T1 )
     => ( ( rBT_Im759614907sorted @ a @ B @ less @ T22 )
       => ( ( ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T1 ) )
            = ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T22 ) ) )
          = ( ( rBT_Im954575269ntries @ a @ B @ T1 )
            = ( rBT_Im954575269ntries @ a @ B @ T22 ) ) ) ) ) )).

% local.set_entries_inject
thf(fact_255_local_Orbt__delete__in__tree,axiom,(
    ! [B: $tType,T: ( rBT_Im246033960le_rbt @ a @ B ),K: a,V: B,X: a] :
      ( ( rBT_Im862805236is_rbt @ a @ B @ less @ T )
     => ( ( member @ ( product_prod @ a @ B ) @ ( product_Pair @ a @ B @ K @ V ) @ ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ ( rBT_Im452238249delete @ a @ B @ less @ X @ T ) ) ) )
        = ( ( X != K )
          & ( member @ ( product_prod @ a @ B ) @ ( product_Pair @ a @ B @ K @ V ) @ ( set2 @ ( product_prod @ a @ B ) @ ( rBT_Im954575269ntries @ a @ B @ T ) ) ) ) ) ) )).

% local.rbt_delete_in_tree

%----Type constructors (6)
thf(tcon_fun___Orderings_Oorder,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( order @ A6 @ ( type2 @ A6 ) )
     => ( order @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A5: $tType,A6: $tType] :
      ( ( ord @ A6 @ ( type2 @ A6 ) )
     => ( ord @ ( A5 > A6 ) @ ( type2 @ ( A5 > A6 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oorder_1,axiom,(
    ! [A5: $tType] :
      ( order @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_Set_Oset___Orderings_Oord_2,axiom,(
    ! [A5: $tType] :
      ( ord @ ( set @ A5 ) @ ( type2 @ ( set @ A5 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Oorder_3,axiom,
    ( order @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_4,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( rBT_Im862805236is_rbt @ a @ b @ less @ ( rBT_Im853940044e_fold @ a @ b @ ( rBT_Im246033960le_rbt @ a @ b ) @ ( rBT_Im627674146th_key @ a @ b @ less @ f ) @ t2 @ t1 ) )).

%------------------------------------------------------------------------------
