%------------------------------------------------------------------------------
% File     : DAT243^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Data Structures
% Problem  : Red-black trees 2056
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : rbt_impl__2056.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  334 (   0 unit;  72 type;   0 defn)
%            Number of atoms       : 8870 ( 413 equality;5714 variable)
%            Maximal formula depth :   29 (  13 average)
%            Number of connectives : 9090 ( 181   ~;  26   |;  78   &;8415   @)
%                                         (   0 <=>; 390  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  :  835 ( 835   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   74 (  72   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1605 (   0 sgn;1444   !;  49   ?;   9   ^)
%                                         (1605   :; 103  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:49:36.456
%------------------------------------------------------------------------------
%----Could-be-implicit typings (9)
thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Ocolor,type,(
    rBT_Im1923302023_color: $tType )).

thf(ty_t_RBT__Impl__Mirabelle__msmaddcmtr_Orbt,type,(
    rBT_Im246033960le_rbt: $tType > $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_List_Olist,type,(
    list: $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_Nat_Onat,type,(
    nat: $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (63)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Oord,type,(
    ord: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Olinorder,type,(
    linorder: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_List_Oappend,type,(
    append: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Obind,type,(
    bind: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) )).

thf(sy_c_List_Obutlast,type,(
    butlast: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Ogen__length,type,(
    gen_length: 
      !>[A: $tType] :
        ( nat > ( list @ A ) > nat ) )).

thf(sy_c_List_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olast,type,(
    last: 
      !>[A: $tType] :
        ( ( list @ A ) > A ) )).

thf(sy_c_List_Olexord,type,(
    lexord: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) )).

thf(sy_c_List_Olist_OCons,type,(
    cons: 
      !>[A: $tType] :
        ( A > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Olist_ONil,type,(
    nil: 
      !>[A: $tType] :
        ( list @ A ) )).

thf(sy_c_List_Olist_Omap,type,(
    map: 
      !>[A: $tType,Aa: $tType] :
        ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) )).

thf(sy_c_List_Olist__ex,type,(
    list_ex: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Olist__ex1,type,(
    list_ex1: 
      !>[A: $tType] :
        ( ( A > $o ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Olistrel,type,(
    listrel: 
      !>[A: $tType,B: $tType] :
        ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) )).

thf(sy_c_List_Olistrel1,type,(
    listrel1: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) )).

thf(sy_c_List_Olistrelp,type,(
    listrelp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) )).

thf(sy_c_List_Omap__tailrec__rev,type,(
    map_tailrec_rev: 
      !>[A: $tType,B: $tType] :
        ( ( A > B ) > ( list @ A ) > ( list @ B ) > ( list @ B ) ) )).

thf(sy_c_List_Omap__tailrec__rev__rel,type,(
    map_tailrec_rev_rel: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) > $o ) )).

thf(sy_c_List_Omaps,type,(
    maps: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( list @ B ) ) > ( list @ A ) > ( list @ B ) ) )).

thf(sy_c_List_Omember,type,(
    member: 
      !>[A: $tType] :
        ( ( list @ A ) > A > $o ) )).

thf(sy_c_List_Onull,type,(
    null: 
      !>[A: $tType] :
        ( ( list @ A ) > $o ) )).

thf(sy_c_List_Oord_Olexordp__eq,type,(
    lexordp_eq: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oord__class_Olexordp__eq,type,(
    ord_lexordp_eq: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > $o ) )).

thf(sy_c_List_Oproduct,type,(
    product: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_List_Oproduct__lists,type,(
    product_lists: 
      !>[A: $tType] :
        ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Orotate1,type,(
    rotate1: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osplice,type,(
    splice: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) )).

thf(sy_c_List_Osublists,type,(
    sublists: 
      !>[A: $tType] :
        ( ( list @ A ) > ( list @ ( list @ A ) ) ) )).

thf(sy_c_List_Ozip,type,(
    zip: 
      !>[A: $tType,B: $tType] :
        ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_Nat_Osize__class_Osize,type,(
    size_size: 
      !>[A: $tType] :
        ( A > nat ) )).

thf(sy_c_Orderings_Oord__class_Oless,type,(
    ord_less: 
      !>[A: $tType] :
        ( A > A > $o ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Obalance,type,(
    rBT_Im1648453169alance: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oentries,type,(
    rBT_Im954575269ntries: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ofoldi,type,(
    rBT_Im501988381_foldi: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( ( C > $o ) > ( A > B > C > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > C > C ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ogen__entries,type,(
    rBT_Im1841113099ntries: 
      !>[A: $tType,B: $tType] :
        ( ( list @ ( product_prod @ ( product_prod @ A @ B ) @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Ogen__keys,type,(
    rBT_Im1235880025n_keys: 
      !>[A: $tType,B: $tType] :
        ( ( list @ ( product_prod @ A @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ A ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Okeys,type,(
    rBT_Im380146495e_keys: 
      !>[A: $tType,B: $tType] :
        ( ( rBT_Im246033960le_rbt @ A @ B ) > ( list @ A ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Omap,type,(
    rBT_Im1728190513le_map: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ C ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Ois__rbt,type,(
    rBT_Im862805236is_rbt: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__map__entry,type,(
    rBT_Im2018130356_entry: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > A > ( B > B ) > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Orbt__sorted,type,(
    rBT_Im759614907sorted: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( rBT_Im246033960le_rbt @ A @ B ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Osinter__with,type,(
    rBT_Im319793781r_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Osinter__with__rel,type,(
    rBT_Im735314116th_rel: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Osunion__with,type,(
    rBT_Im1445157352n_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord_Osunion__with__rel,type,(
    rBT_Im753582353th_rel: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Osinter__with,type,(
    rBT_Im393311009r_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Osinter__with__rel,type,(
    rBT_Im310218520th_rel: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Osunion__with,type,(
    rBT_Im1518674580n_with: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Oord__class_Osunion__with__rel,type,(
    rBT_Im328486757th_rel: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) > $o ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OBranch,type,(
    rBT_Im480247531Branch: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > ( rBT_Im246033960le_rbt @ A @ B ) ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_OEmpty,type,(
    rBT_Im418718756_Empty: 
      !>[A: $tType,B: $tType] :
        ( rBT_Im246033960le_rbt @ A @ B ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Ocase__rbt,type,(
    rBT_Im858806507se_rbt: 
      !>[C: $tType,A: $tType,B: $tType] :
        ( C > ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > C ) > ( rBT_Im246033960le_rbt @ A @ B ) > C ) )).

thf(sy_c_RBT__Impl__Mirabelle__msmaddcmtr_Orbt_Orec__rbt,type,(
    rBT_Im1947144893ec_rbt: 
      !>[E: $tType,A: $tType,B: $tType] :
        ( E > ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > E > E > E ) > ( rBT_Im246033960le_rbt @ A @ B ) > E ) )).

thf(sy_c_Relation_Oasym,type,(
    asym: 
      !>[A: $tType] :
        ( ( set @ ( product_prod @ A @ A ) ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Wellfounded_Oaccp,type,(
    accp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > A > $o ) )).

thf(sy_c_member,type,(
    member2: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

%----Relevant facts (255)
thf(fact_0_gen__keys__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1235880025n_keys @ A @ B @ ( nil @ ( product_prod @ A @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ A ) ) )).

% gen_keys_simps(1)
thf(fact_1_keys__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im380146495e_keys @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ A ) ) )).

% keys_simps(1)
thf(fact_2_map__keys,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > C > B ),T2: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im380146495e_keys @ A @ B @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T2 ) )
      = ( rBT_Im380146495e_keys @ A @ C @ T2 ) ) )).

% map_keys
thf(fact_3_non__empty__rbt__keys,axiom,(
    ! [B: $tType,A: $tType,T2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( T2
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ( rBT_Im380146495e_keys @ A @ B @ T2 )
       != ( nil @ A ) ) ) )).

% non_empty_rbt_keys
thf(fact_4_product_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Uu: ( list @ B )] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% product.simps(1)
thf(fact_5_ord_Osinter__with_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),Uv: ( list @ ( product_prod @ A @ B ) )] :
      ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ Uv @ ( nil @ ( product_prod @ A @ B ) ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% ord.sinter_with.simps(3)
thf(fact_6_ord_Osinter__with_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),Uu: ( list @ ( product_prod @ A @ B ) )] :
      ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Uu )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% ord.sinter_with.simps(2)
thf(fact_7_ord_Osunion__with_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),As: ( list @ ( product_prod @ A @ B ) )] :
      ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ As @ ( nil @ ( product_prod @ A @ B ) ) )
      = As ) )).

% ord.sunion_with.simps(3)
thf(fact_8_ord_Osunion__with_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),Bs: ( list @ ( product_prod @ A @ B ) )] :
      ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Bs )
      = Bs ) )).

% ord.sunion_with.simps(2)
thf(fact_9_sunion__with_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),As: ( list @ ( product_prod @ A @ B ) )] :
          ( ( rBT_Im1518674580n_with @ A @ B @ F @ As @ ( nil @ ( product_prod @ A @ B ) ) )
          = As ) ) )).

% sunion_with.simps(3)
thf(fact_10_sunion__with_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),Bs: ( list @ ( product_prod @ A @ B ) )] :
          ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Bs )
          = Bs ) ) )).

% sunion_with.simps(2)
thf(fact_11_map_Osimps_I1_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,F: ( A > B > C )] :
      ( ( rBT_Im1728190513le_map @ A @ B @ C @ F @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ C ) ) )).

% map.simps(1)
thf(fact_12_gen__entries__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im1841113099ntries @ A @ B @ ( nil @ ( product_prod @ ( product_prod @ A @ B ) @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% gen_entries_simps(1)
thf(fact_13_list__ex1__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex1 @ A @ P @ ( nil @ A ) ) )).

% list_ex1_simps(1)
thf(fact_14_bind__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F )
      = ( nil @ A ) ) )).

% bind_simps(1)
thf(fact_15_member__rec_I2_J,axiom,(
    ! [A: $tType,Y: A] :
      ~ ( member @ A @ ( nil @ A ) @ Y ) )).

% member_rec(2)
thf(fact_16_foldi_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [C2: ( C > $o ),F: ( A > B > C > C ),S: C] :
          ( ( rBT_Im501988381_foldi @ C @ A @ B @ C2 @ F @ ( rBT_Im418718756_Empty @ A @ B ) @ S )
          = S ) ) )).

% foldi.simps(1)
thf(fact_17_gen__length__code_I1_J,axiom,(
    ! [A: $tType,N: nat] :
      ( ( gen_length @ A @ N @ ( nil @ A ) )
      = N ) )).

% gen_length_code(1)
thf(fact_18_ord_Omap__is__rbt,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > C > B ),T2: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T2 ) )
      = ( rBT_Im862805236is_rbt @ A @ C @ Less @ T2 ) ) )).

% ord.map_is_rbt
thf(fact_19_splice__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% splice_Nil2
thf(fact_20_maps__simps_I2_J,axiom,(
    ! [B: $tType,A: $tType,F: ( B > ( list @ A ) )] :
      ( ( maps @ B @ A @ F @ ( nil @ B ) )
      = ( nil @ A ) ) )).

% maps_simps(2)
thf(fact_21_eq__Nil__null,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
        = ( nil @ A ) )
      = ( null @ A @ Xs ) ) )).

% eq_Nil_null
thf(fact_22_null__rec_I2_J,axiom,(
    ! [B: $tType] :
      ( null @ B @ ( nil @ B ) ) )).

% null_rec(2)
thf(fact_23_splice_Osimps_I1_J,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% splice.simps(1)
thf(fact_24_ord_OEmpty__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.Empty_is_rbt
thf(fact_25_entries__code,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im954575269ntries @ A @ B )
      = ( rBT_Im1841113099ntries @ A @ B @ ( nil @ ( product_prod @ ( product_prod @ A @ B ) @ ( rBT_Im246033960le_rbt @ A @ B ) ) ) ) ) )).

% entries_code
thf(fact_26_ord_Orbt__map__entry__is__rbt,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T2 ) )
      = ( rBT_Im862805236is_rbt @ A @ B @ Less @ T2 ) ) )).

% ord.rbt_map_entry_is_rbt
thf(fact_27_ord_Ois__rbt__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),T2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im862805236is_rbt @ A @ B @ Less @ T2 )
     => ( rBT_Im759614907sorted @ A @ B @ Less @ T2 ) ) )).

% ord.is_rbt_rbt_sorted
thf(fact_28_rbt_Osimps_I4_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F1: C,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > C )] :
      ( ( rBT_Im858806507se_rbt @ C @ A @ B @ F1 @ F2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = F1 ) )).

% rbt.simps(4)
thf(fact_29_rotate1__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% rotate1_is_Nil_conv
thf(fact_30_zip__Nil,axiom,(
    ! [B: $tType,A: $tType,Ys: ( list @ B )] :
      ( ( zip @ A @ B @ ( nil @ A ) @ Ys )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% zip_Nil
thf(fact_31_splice_Oelims,axiom,(
    ! [A: $tType,X: ( list @ A ),Xa: ( list @ A ),Y: ( list @ A )] :
      ( ( ( splice @ A @ X @ Xa )
        = Y )
     => ( ( ( X
            = ( nil @ A ) )
         => ( Y != Xa ) )
       => ( ! [V: A,Va: ( list @ A )] :
              ( ( X
                = ( cons @ A @ V @ Va ) )
             => ( ( Xa
                  = ( nil @ A ) )
               => ( Y
                 != ( cons @ A @ V @ Va ) ) ) )
         => ~ ( ! [X2: A,Xs2: ( list @ A )] :
                  ( ( X
                    = ( cons @ A @ X2 @ Xs2 ) )
                 => ! [Y2: A,Ys2: ( list @ A )] :
                      ( ( Xa
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( Y
                       != ( cons @ A @ X2 @ ( cons @ A @ Y2 @ ( splice @ A @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) ) )).

% splice.elims
thf(fact_32_splice_Osimps_I2_J,axiom,(
    ! [A: $tType,V2: A,Va2: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ V2 @ Va2 ) @ ( nil @ A ) )
      = ( cons @ A @ V2 @ Va2 ) ) )).

% splice.simps(2)
thf(fact_33_list__ex__simps_I2_J,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ~ ( list_ex @ A @ P @ ( nil @ A ) ) )).

% list_ex_simps(2)
thf(fact_34_rbt_Osimps_I6_J,axiom,(
    ! [A: $tType,B: $tType,E: $tType,F1: E,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > E > E > E )] :
      ( ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ ( rBT_Im418718756_Empty @ A @ B ) )
      = F1 ) )).

% rbt.simps(6)
thf(fact_35_list_Oinject,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A ),Y21: A,Y22: ( list @ A )] :
      ( ( ( cons @ A @ X21 @ X22 )
        = ( cons @ A @ Y21 @ Y22 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 ) ) ) )).

% list.inject
thf(fact_36_list__ex__simps_I1_J,axiom,(
    ! [A: $tType,P: ( A > $o ),X: A,Xs: ( list @ A )] :
      ( ( list_ex @ A @ P @ ( cons @ A @ X @ Xs ) )
      = ( ( P @ X )
        | ( list_ex @ A @ P @ Xs ) ) ) )).

% list_ex_simps(1)
thf(fact_37_transpose_Ocases,axiom,(
    ! [A: $tType,X: ( list @ ( list @ A ) )] :
      ( ( X
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss: ( list @ ( list @ A ) )] :
            ( X
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
       => ~ ( ! [X2: A,Xs2: ( list @ A ),Xss: ( list @ ( list @ A ) )] :
                ( X
               != ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ Xss ) ) ) ) ) )).

% transpose.cases
thf(fact_38_ord_Orbt__map__entry__rbt__sorted,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B ),T2: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ T2 ) )
      = ( rBT_Im759614907sorted @ A @ B @ Less @ T2 ) ) )).

% ord.rbt_map_entry_rbt_sorted
thf(fact_39_not__Cons__self2,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( cons @ A @ X @ Xs )
     != Xs ) )).

% not_Cons_self2
thf(fact_40_map__tailrec__rev_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > B ) > ( list @ A ) > ( list @ B ) > $o ),A0: ( A > B ),A1: ( list @ A ),A2: ( list @ B )] :
      ( ! [F3: ( A > B ),X1: ( list @ B )] :
          ( P @ F3 @ ( nil @ A ) @ X1 )
     => ( ! [F3: ( A > B ),A3: A,As2: ( list @ A ),Bs2: ( list @ B )] :
            ( ( P @ F3 @ As2 @ ( cons @ B @ ( F3 @ A3 ) @ Bs2 ) )
           => ( P @ F3 @ ( cons @ A @ A3 @ As2 ) @ Bs2 ) )
       => ( P @ A0 @ A1 @ A2 ) ) ) )).

% map_tailrec_rev.induct
thf(fact_41_list__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% list_nonempty_induct
thf(fact_42_remdups__adj_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),A0: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Y2: A,Xs2: ( list @ A )] :
              ( ( ( X2 = Y2 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) ) )
             => ( ( ( X2 != Y2 )
                 => ( P @ ( cons @ A @ Y2 @ Xs2 ) ) )
               => ( P @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) )
         => ( P @ A0 ) ) ) ) )).

% remdups_adj.induct
thf(fact_43_remdups__adj_Ocases,axiom,(
    ! [A: $tType,X: ( list @ A )] :
      ( ( X
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( X
           != ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ~ ( ! [X2: A,Y2: A,Xs2: ( list @ A )] :
                ( X
               != ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs2 ) ) ) ) ) ) )).

% remdups_adj.cases
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A4: A,P: ( A > $o )] :
      ( ( member2 @ A @ A4 @ ( collect @ A @ P ) )
      = ( P @ A4 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A5: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member2 @ A @ X3 @ A5 ) )
      = A5 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X2: A] :
          ( ( P @ X2 )
          = ( Q @ X2 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X2: A] :
          ( ( F @ X2 )
          = ( G @ X2 ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_splice_Oinduct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > ( list @ A ) > $o ),A0: ( list @ A ),A1: ( list @ A )] :
      ( ! [X1: ( list @ A )] :
          ( P @ ( nil @ A ) @ X1 )
     => ( ! [V: A,Va: ( list @ A )] :
            ( P @ ( cons @ A @ V @ Va ) @ ( nil @ A ) )
       => ( ! [X2: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
              ( ( P @ Xs2 @ Ys2 )
             => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) )).

% splice.induct
thf(fact_49_list__induct2_H,axiom,(
    ! [A: $tType,B: $tType,P: ( ( list @ A ) > ( list @ B ) > $o ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X2: A,Xs2: ( list @ A )] :
            ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y2: B,Ys2: ( list @ B )] :
              ( P @ ( nil @ A ) @ ( cons @ B @ Y2 @ Ys2 ) )
         => ( ! [X2: A,Xs2: ( list @ A ),Y2: B,Ys2: ( list @ B )] :
                ( ( P @ Xs2 @ Ys2 )
               => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) )).

% list_induct2'
thf(fact_50_neq__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
      = ( ? [Y3: A,Ys3: ( list @ A )] :
            ( Xs
            = ( cons @ A @ Y3 @ Ys3 ) ) ) ) )).

% neq_Nil_conv
thf(fact_51_list_Oinducts,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),List: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X1: A,X23: ( list @ A )] :
            ( ( P @ X23 )
           => ( P @ ( cons @ A @ X1 @ X23 ) ) )
       => ( P @ List ) ) ) )).

% list.inducts
thf(fact_52_list_Oexhaust,axiom,(
    ! [A: $tType,Y: ( list @ A )] :
      ( ( Y
       != ( nil @ A ) )
     => ~ ( ! [X212: A,X222: ( list @ A )] :
              ( Y
             != ( cons @ A @ X212 @ X222 ) ) ) ) )).

% list.exhaust
thf(fact_53_list_OdiscI,axiom,(
    ! [A: $tType,List: ( list @ A ),X21: A,X22: ( list @ A )] :
      ( ( List
        = ( cons @ A @ X21 @ X22 ) )
     => ( List
       != ( nil @ A ) ) ) )).

% list.discI
thf(fact_54_list_Odistinct_I1_J,axiom,(
    ! [A: $tType,X21: A,X22: ( list @ A )] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X22 ) ) )).

% list.distinct(1)
thf(fact_55_splice_Osimps_I3_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( splice @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( cons @ A @ X @ ( cons @ A @ Y @ ( splice @ A @ Xs @ Ys ) ) ) ) )).

% splice.simps(3)
thf(fact_56_null__rec_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ~ ( null @ A @ ( cons @ A @ X @ Xs ) ) )).

% null_rec(1)
thf(fact_57_member__rec_I1_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A] :
      ( ( member @ A @ ( cons @ A @ X @ Xs ) @ Y )
      = ( ( X = Y )
        | ( member @ A @ Xs @ Y ) ) ) )).

% member_rec(1)
thf(fact_58_rotate1_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% rotate1.simps(1)
thf(fact_59_ord_Orbt__sorted_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o )] :
      ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_sorted.simps(1)
thf(fact_60_ord_Orbt__map__entry_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,F: ( B > B )] :
      ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( rBT_Im418718756_Empty @ A @ B ) ) )).

% ord.rbt_map_entry.simps(1)
thf(fact_61_zip_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A )] :
      ( ( zip @ A @ B @ Xs @ ( nil @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% zip.simps(1)
thf(fact_62_entries_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im418718756_Empty @ A @ B ) )
      = ( nil @ ( product_prod @ A @ B ) ) ) )).

% entries.simps(1)
thf(fact_63_ord_Omap__rbt__sorted,axiom,(
    ! [B: $tType,C: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > C > B ),T2: ( rBT_Im246033960le_rbt @ A @ C )] :
      ( ( rBT_Im759614907sorted @ A @ B @ Less @ ( rBT_Im1728190513le_map @ A @ C @ B @ F @ T2 ) )
      = ( rBT_Im759614907sorted @ A @ C @ Less @ T2 ) ) )).

% ord.map_rbt_sorted
thf(fact_64_insert__Nil,axiom,(
    ! [A: $tType,X: A] :
      ( ( insert @ A @ X @ ( nil @ A ) )
      = ( cons @ A @ X @ ( nil @ A ) ) ) )).

% insert_Nil
thf(fact_65_gen__keys__simps_I2_J,axiom,(
    ! [D: $tType,C: $tType,K: C,T2: ( rBT_Im246033960le_rbt @ C @ D ),Kts: ( list @ ( product_prod @ C @ ( rBT_Im246033960le_rbt @ C @ D ) ) )] :
      ( ( rBT_Im1235880025n_keys @ C @ D @ ( cons @ ( product_prod @ C @ ( rBT_Im246033960le_rbt @ C @ D ) ) @ ( product_Pair @ C @ ( rBT_Im246033960le_rbt @ C @ D ) @ K @ T2 ) @ Kts ) @ ( rBT_Im418718756_Empty @ C @ D ) )
      = ( cons @ C @ K @ ( rBT_Im1235880025n_keys @ C @ D @ Kts @ T2 ) ) ) )).

% gen_keys_simps(2)
thf(fact_66_ord_Olexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A )] :
      ~ ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) )).

% ord.lexordp_eq_simps(3)
thf(fact_67_map__tailrec__rev_Oelims,axiom,(
    ! [A: $tType,B: $tType,X: ( A > B ),Xa: ( list @ A ),Xb: ( list @ B ),Y: ( list @ B )] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( ( Xa
            = ( nil @ A ) )
         => ( Y != Xb ) )
       => ~ ( ! [A3: A,As2: ( list @ A )] :
                ( ( Xa
                  = ( cons @ A @ A3 @ As2 ) )
               => ( Y
                 != ( map_tailrec_rev @ A @ B @ X @ As2 @ ( cons @ B @ ( X @ A3 ) @ Xb ) ) ) ) ) ) ) )).

% map_tailrec_rev.elims
thf(fact_68_listrelp_Ocases,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),A1: ( list @ A ),A2: ( list @ B )] :
      ( ( listrelp @ A @ B @ R @ A1 @ A2 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A2
           != ( nil @ B ) ) )
       => ~ ( ! [X2: A,Y2: B,Xs2: ( list @ A )] :
                ( ( A1
                  = ( cons @ A @ X2 @ Xs2 ) )
               => ! [Ys2: ( list @ B )] :
                    ( ( A2
                      = ( cons @ B @ Y2 @ Ys2 ) )
                   => ( ( R @ X2 @ Y2 )
                     => ~ ( listrelp @ A @ B @ R @ Xs2 @ Ys2 ) ) ) ) ) ) ) )).

% listrelp.cases
thf(fact_69_listrelp_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( listrelp @ A @ B )
      = ( ^ [R2: ( A > B > $o ),A12: ( list @ A ),A22: ( list @ B )] :
            ( ( ( A12
                = ( nil @ A ) )
              & ( A22
                = ( nil @ B ) ) )
            | ? [X3: A,Y3: B,Xs3: ( list @ A ),Ys3: ( list @ B )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A22
                  = ( cons @ B @ Y3 @ Ys3 ) )
                & ( R2 @ X3 @ Y3 )
                & ( listrelp @ A @ B @ R2 @ Xs3 @ Ys3 ) ) ) ) ) )).

% listrelp.simps
thf(fact_70_listrelp_Oinducts,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X12: ( list @ A ),X24: ( list @ B ),P: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( listrelp @ A @ B @ R @ X12 @ X24 )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X2: A,Y2: B,Xs2: ( list @ A ),Ys2: ( list @ B )] :
              ( ( R @ X2 @ Y2 )
             => ( ( listrelp @ A @ B @ R @ Xs2 @ Ys2 )
               => ( ( P @ Xs2 @ Ys2 )
                 => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) ) ) )
         => ( P @ X12 @ X24 ) ) ) ) )).

% listrelp.inducts
thf(fact_71_lexordp__eq__simps_I3_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A )] :
          ~ ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( nil @ A ) ) ) )).

% lexordp_eq_simps(3)
thf(fact_72_rotate1_Osimps_I2_J,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A )] :
      ( ( rotate1 @ A @ ( cons @ A @ X @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) ) )).

% rotate1.simps(2)
thf(fact_73_append__assoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) )).

% append_assoc
thf(fact_74_append__same__eq,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) )).

% append_same_eq
thf(fact_75_same__append__eq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) )).

% same_append_eq
thf(fact_76_append__Nil2,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) )).

% append_Nil2
thf(fact_77_append__self__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) )).

% append_self_conv
thf(fact_78_self__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) )).

% self_append_conv
thf(fact_79_append__self__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) )).

% append_self_conv2
thf(fact_80_self__append__conv2,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( append @ A @ Xs @ Ys ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% self_append_conv2
thf(fact_81_Nil__is__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% Nil_is_append_conv
thf(fact_82_append__is__Nil__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) )).

% append_is_Nil_conv
thf(fact_83_lexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ ( nil @ A ) )
          = ( Xs
            = ( nil @ A ) ) ) ) )).

% lexordp_eq_simps(2)
thf(fact_84_lexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) )).

% lexordp_eq_simps(1)
thf(fact_85_ord_Olexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
      = ( ( Less @ X @ Y )
        | ( ~ ( Less @ Y @ X )
          & ( lexordp_eq @ A @ Less @ Xs @ Ys ) ) ) ) )).

% ord.lexordp_eq_simps(4)
thf(fact_86_ord_Olexordp__eq__simps_I2_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ Xs @ ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) )).

% ord.lexordp_eq_simps(2)
thf(fact_87_ord_Olexordp__eq__simps_I1_J,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq_simps(1)
thf(fact_88_list__ex__append,axiom,(
    ! [A: $tType,P: ( A > $o ),Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( list_ex @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( ( list_ex @ A @ P @ Xs )
        | ( list_ex @ A @ P @ Ys ) ) ) )).

% list_ex_append
thf(fact_89_append1__eq__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys: ( list @ A ),Y: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X = Y ) ) ) )).

% append1_eq_conv
thf(fact_90_bind__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X: B,Xs: ( list @ B ),F: ( B > ( list @ A ) )] :
      ( ( bind @ B @ A @ ( cons @ B @ X @ Xs ) @ F )
      = ( append @ A @ ( F @ X ) @ ( bind @ B @ A @ Xs @ F ) ) ) )).

% bind_simps(2)
thf(fact_91_gen__entries__simps_I2_J,axiom,(
    ! [D: $tType,C: $tType,Kv: ( product_prod @ C @ D ),T2: ( rBT_Im246033960le_rbt @ C @ D ),Kvts: ( list @ ( product_prod @ ( product_prod @ C @ D ) @ ( rBT_Im246033960le_rbt @ C @ D ) ) )] :
      ( ( rBT_Im1841113099ntries @ C @ D @ ( cons @ ( product_prod @ ( product_prod @ C @ D ) @ ( rBT_Im246033960le_rbt @ C @ D ) ) @ ( product_Pair @ ( product_prod @ C @ D ) @ ( rBT_Im246033960le_rbt @ C @ D ) @ Kv @ T2 ) @ Kvts ) @ ( rBT_Im418718756_Empty @ C @ D ) )
      = ( cons @ ( product_prod @ C @ D ) @ Kv @ ( rBT_Im1841113099ntries @ C @ D @ Kvts @ T2 ) ) ) )).

% gen_entries_simps(2)
thf(fact_92_zip__Cons__Cons,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),Y: B,Ys: ( list @ B )] :
      ( ( zip @ A @ B @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) )
      = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ ( zip @ A @ B @ Xs @ Ys ) ) ) )).

% zip_Cons_Cons
thf(fact_93_ord_Osunion__with_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) )] :
      ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
          ( X
         != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
     => ( ! [F3: ( A > B > B > B ),Bs2: ( list @ ( product_prod @ A @ B ) )] :
            ( X
           != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Bs2 ) ) )
       => ~ ( ! [F3: ( A > B > B > B ),As2: ( list @ ( product_prod @ A @ B ) )] :
                ( X
               != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ As2 @ ( nil @ ( product_prod @ A @ B ) ) ) ) ) ) ) ) )).

% ord.sunion_with.cases
thf(fact_94_sunion__with_Ocases,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) )] :
          ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
              ( X
             != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
         => ( ! [F3: ( A > B > B > B ),Bs2: ( list @ ( product_prod @ A @ B ) )] :
                ( X
               != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Bs2 ) ) )
           => ~ ( ! [F3: ( A > B > B > B ),As2: ( list @ ( product_prod @ A @ B ) )] :
                    ( X
                   != ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ As2 @ ( nil @ ( product_prod @ A @ B ) ) ) ) ) ) ) ) ) )).

% sunion_with.cases
thf(fact_95_append__eq__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Xs1: ( list @ A ),Zs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) )).

% append_eq_appendI
thf(fact_96_ord_Olexordp__eq__refl,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Xs: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ Xs @ Xs ) )).

% ord.lexordp_eq_refl
thf(fact_97_append__eq__append__conv2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A ),Ts: ( list @ A )] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: ( list @ A )] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) )).

% append_eq_append_conv2
thf(fact_98_lexordp__eq__refl,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A )] :
          ( ord_lexordp_eq @ A @ Xs @ Xs ) ) )).

% lexordp_eq_refl
thf(fact_99_lexordp__eq__trans,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Zs )
           => ( ord_lexordp_eq @ A @ Xs @ Zs ) ) ) ) )).

% lexordp_eq_trans
thf(fact_100_lexordp__eq__linear,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
          | ( ord_lexordp_eq @ A @ Ys @ Xs ) ) ) )).

% lexordp_eq_linear
thf(fact_101_lexordp__eq__antisym,axiom,(
    ! [A: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ Xs @ Ys )
         => ( ( ord_lexordp_eq @ A @ Ys @ Xs )
           => ( Xs = Ys ) ) ) ) )).

% lexordp_eq_antisym
thf(fact_102_Cons__eq__appendI,axiom,(
    ! [A: $tType,X: A,Xs1: ( list @ A ),Ys: ( list @ A ),Xs: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) )).

% Cons_eq_appendI
thf(fact_103_append__Cons,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( append @ A @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( cons @ A @ X @ ( append @ A @ Xs @ Ys ) ) ) )).

% append_Cons
thf(fact_104_eq__Nil__appendI,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) )).

% eq_Nil_appendI
thf(fact_105_append__Nil,axiom,(
    ! [A: $tType,Ys: ( list @ A )] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) )).

% append_Nil
thf(fact_106_ord_Osunion__with_Oinduct,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),P: ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > $o ),A0: ( A > B > B > B ),A1: ( list @ ( product_prod @ A @ B ) ),A2: ( list @ ( product_prod @ A @ B ) )] :
      ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
          ( ( ( Less @ K3 @ K2 )
           => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ Bs2 ) )
         => ( ( ~ ( Less @ K3 @ K2 )
             => ( ( Less @ K2 @ K3 )
               => ( P @ F3 @ As2 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
           => ( ( ~ ( Less @ K3 @ K2 )
               => ( ~ ( Less @ K2 @ K3 )
                 => ( P @ F3 @ As2 @ Bs2 ) ) )
             => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) ) )
     => ( ! [F3: ( A > B > B > B ),X1: ( list @ ( product_prod @ A @ B ) )] :
            ( P @ F3 @ ( nil @ ( product_prod @ A @ B ) ) @ X1 )
       => ( ! [F3: ( A > B > B > B ),As2: ( list @ ( product_prod @ A @ B ) )] :
              ( P @ F3 @ As2 @ ( nil @ ( product_prod @ A @ B ) ) )
         => ( P @ A0 @ A1 @ A2 ) ) ) ) )).

% ord.sunion_with.induct
thf(fact_107_lexordp__eq_ONil,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [Ys: ( list @ A )] :
          ( ord_lexordp_eq @ A @ ( nil @ A ) @ Ys ) ) )).

% lexordp_eq.Nil
thf(fact_108_ord_Osunion__with_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K4: A,K: A,F: ( A > B > B > B ),V2: B,As: ( list @ ( product_prod @ A @ B ) ),V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
      ( ( ( Less @ K4 @ K )
       => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
          = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) ) )
      & ( ~ ( Less @ K4 @ K )
       => ( ( ( Less @ K @ K4 )
           => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
              = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) ) )
          & ( ~ ( Less @ K @ K4 )
           => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
              = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ As @ Bs ) ) ) ) ) ) ) )).

% ord.sunion_with.simps(1)
thf(fact_109_ord_Osinter__with_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K4: A,K: A,F: ( A > B > B > B ),V2: B,As: ( list @ ( product_prod @ A @ B ) ),V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
      ( ( ( Less @ K4 @ K )
       => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
          = ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) )
      & ( ~ ( Less @ K4 @ K )
       => ( ( ( Less @ K @ K4 )
           => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
              = ( rBT_Im319793781r_with @ A @ B @ Less @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
          & ( ~ ( Less @ K @ K4 )
           => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
              = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im319793781r_with @ A @ B @ Less @ F @ As @ Bs ) ) ) ) ) ) ) )).

% ord.sinter_with.simps(1)
thf(fact_110_ord_Olexordp__eq_OCons,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( Less @ X @ Y )
     => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) )).

% ord.lexordp_eq.Cons
thf(fact_111_ord_Olexordp__eq_OCons__eq,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ~ ( Less @ X @ Y )
     => ( ~ ( Less @ Y @ X )
       => ( ( lexordp_eq @ A @ Less @ Xs @ Ys )
         => ( lexordp_eq @ A @ Less @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) )).

% ord.lexordp_eq.Cons_eq
thf(fact_112_ord_Olexordp__eq_ONil,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),Ys: ( list @ A )] :
      ( lexordp_eq @ A @ Less @ ( nil @ A ) @ Ys ) )).

% ord.lexordp_eq.Nil
thf(fact_113_listrelp_OCons,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o ),X: A,Y: B,Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( R @ X @ Y )
     => ( ( listrelp @ A @ B @ R @ Xs @ Ys )
       => ( listrelp @ A @ B @ R @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) ) ) )).

% listrelp.Cons
thf(fact_114_listrelp_ONil,axiom,(
    ! [A: $tType,B: $tType,R: ( A > B > $o )] :
      ( listrelp @ A @ B @ R @ ( nil @ A ) @ ( nil @ B ) ) )).

% listrelp.Nil
thf(fact_115_rev__induct,axiom,(
    ! [A: $tType,P: ( ( list @ A ) > $o ),Xs: ( list @ A )] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X2: A,Xs2: ( list @ A )] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) )).

% rev_induct
thf(fact_116_rev__exhaust,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ( ! [Ys2: ( list @ A ),Y2: A] :
              ( Xs
             != ( append @ A @ Ys2 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ) )).

% rev_exhaust
thf(fact_117_Cons__eq__append__conv,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ A ),Zs: ( list @ A )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X @ Xs )
            = Zs ) )
        | ? [Ys4: ( list @ A )] :
            ( ( ( cons @ A @ X @ Ys4 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys4 @ Zs ) ) ) ) ) )).

% Cons_eq_append_conv
thf(fact_118_append__eq__Cons__conv,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Zs: ( list @ A ),X: A,Xs: ( list @ A )] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X @ Xs ) ) )
        | ? [Ys4: ( list @ A )] :
            ( ( Ys
              = ( cons @ A @ X @ Ys4 ) )
            & ( ( append @ A @ Ys4 @ Zs )
              = Xs ) ) ) ) )).

% append_eq_Cons_conv
thf(fact_119_rev__nonempty__induct,axiom,(
    ! [A: $tType,Xs: ( list @ A ),P: ( ( list @ A ) > $o )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X2: A] :
            ( P @ ( cons @ A @ X2 @ ( nil @ A ) ) )
       => ( ! [X2: A,Xs2: ( list @ A )] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) )).

% rev_nonempty_induct
thf(fact_120_map__tailrec__rev_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),A4: A,As: ( list @ A ),Bs: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F @ ( cons @ A @ A4 @ As ) @ Bs )
      = ( map_tailrec_rev @ A @ B @ F @ As @ ( cons @ B @ ( F @ A4 ) @ Bs ) ) ) )).

% map_tailrec_rev.simps(2)
thf(fact_121_map__tailrec__rev_Osimps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B ),Bs: ( list @ B )] :
      ( ( map_tailrec_rev @ A @ B @ F @ ( nil @ A ) @ Bs )
      = Bs ) )).

% map_tailrec_rev.simps(1)
thf(fact_122_maps__simps_I1_J,axiom,(
    ! [A: $tType,B: $tType,F: ( B > ( list @ A ) ),X: B,Xs: ( list @ B )] :
      ( ( maps @ B @ A @ F @ ( cons @ B @ X @ Xs ) )
      = ( append @ A @ ( F @ X ) @ ( maps @ B @ A @ F @ Xs ) ) ) )).

% maps_simps(1)
thf(fact_123_ord_Olexordp__eq_Oinducts,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),X12: ( list @ A ),X24: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
      ( ( lexordp_eq @ A @ Less @ X12 @ X24 )
     => ( ! [X1: ( list @ A )] :
            ( P @ ( nil @ A ) @ X1 )
       => ( ! [X2: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
              ( ( Less @ X2 @ Y2 )
             => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
         => ( ! [X2: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                ( ~ ( Less @ X2 @ Y2 )
               => ( ~ ( Less @ Y2 @ X2 )
                 => ( ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 )
                   => ( ( P @ Xs2 @ Ys2 )
                     => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
           => ( P @ X12 @ X24 ) ) ) ) ) )).

% ord.lexordp_eq.inducts
thf(fact_124_ord_Olexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( lexordp_eq @ A )
      = ( ^ [Less2: ( A > A > $o ),A12: ( list @ A ),A22: ( list @ A )] :
            ( ? [Ys3: ( list @ A )] :
                ( ( A12
                  = ( nil @ A ) )
                & ( A22 = Ys3 ) )
            | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A22
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ( Less2 @ X3 @ Y3 ) )
            | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                ( ( A12
                  = ( cons @ A @ X3 @ Xs3 ) )
                & ( A22
                  = ( cons @ A @ Y3 @ Ys3 ) )
                & ~ ( Less2 @ X3 @ Y3 )
                & ~ ( Less2 @ Y3 @ X3 )
                & ( lexordp_eq @ A @ Less2 @ Xs3 @ Ys3 ) ) ) ) ) )).

% ord.lexordp_eq.simps
thf(fact_125_ord_Olexordp__eq_Ocases,axiom,(
    ! [A: $tType,Less: ( A > A > $o ),A1: ( list @ A ),A2: ( list @ A )] :
      ( ( lexordp_eq @ A @ Less @ A1 @ A2 )
     => ( ( ( A1
            = ( nil @ A ) )
         => ! [Ys2: ( list @ A )] : ( A2 != Ys2 ) )
       => ( ! [X2: A] :
              ( ? [Xs2: ( list @ A )] :
                  ( A1
                  = ( cons @ A @ X2 @ Xs2 ) )
             => ! [Y2: A] :
                  ( ? [Ys2: ( list @ A )] :
                      ( A2
                      = ( cons @ A @ Y2 @ Ys2 ) )
                 => ~ ( Less @ X2 @ Y2 ) ) )
         => ~ ( ! [X2: A,Y2: A,Xs2: ( list @ A )] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs2 ) )
                 => ! [Ys2: ( list @ A )] :
                      ( ( A2
                        = ( cons @ A @ Y2 @ Ys2 ) )
                     => ( ~ ( Less @ X2 @ Y2 )
                       => ( ~ ( Less @ Y2 @ X2 )
                         => ~ ( lexordp_eq @ A @ Less @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) )).

% ord.lexordp_eq.cases
thf(fact_126_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A4: A,B2: B,A6: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A4 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B3 ) )
      = ( ( A4 = A6 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_127_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X12: A,X24: B,Y1: A,Y23: B] :
      ( ( ( product_Pair @ A @ B @ X12 @ X24 )
        = ( product_Pair @ A @ B @ Y1 @ Y23 ) )
      = ( ( X12 = Y1 )
        & ( X24 = Y23 ) ) ) )).

% prod.inject
thf(fact_128_sublists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( sublists @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% sublists.simps(1)
thf(fact_129_product__lists_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )).

% product_lists.simps(1)
thf(fact_130_gen__keys__simps_I3_J,axiom,(
    ! [D: $tType,C: $tType,Kts: ( list @ ( product_prod @ C @ ( rBT_Im246033960le_rbt @ C @ D ) ) ),C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ C @ D ),K: C,V2: D,R: ( rBT_Im246033960le_rbt @ C @ D )] :
      ( ( rBT_Im1235880025n_keys @ C @ D @ Kts @ ( rBT_Im480247531Branch @ C @ D @ C2 @ L @ K @ V2 @ R ) )
      = ( rBT_Im1235880025n_keys @ C @ D @ ( cons @ ( product_prod @ C @ ( rBT_Im246033960le_rbt @ C @ D ) ) @ ( product_Pair @ C @ ( rBT_Im246033960le_rbt @ C @ D ) @ K @ R ) @ Kts ) @ L ) ) )).

% gen_keys_simps(3)
thf(fact_131_butlast__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( butlast @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = Xs ) )).

% butlast_snoc
thf(fact_132_rbt_Oinject,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X25: ( rBT_Im246033960le_rbt @ A @ B ),Y21: rBT_Im1923302023_color,Y22: ( rBT_Im246033960le_rbt @ A @ B ),Y232: A,Y24: B,Y25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X232 @ X242 @ X25 )
        = ( rBT_Im480247531Branch @ A @ B @ Y21 @ Y22 @ Y232 @ Y24 @ Y25 ) )
      = ( ( X21 = Y21 )
        & ( X22 = Y22 )
        & ( X232 = Y232 )
        & ( X242 = Y24 )
        & ( X25 = Y25 ) ) ) )).

% rbt.inject
thf(fact_133_keys__simps_I2_J,axiom,(
    ! [D: $tType,C: $tType,C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ C @ D ),K: C,V2: D,R: ( rBT_Im246033960le_rbt @ C @ D )] :
      ( ( rBT_Im380146495e_keys @ C @ D @ ( rBT_Im480247531Branch @ C @ D @ C2 @ L @ K @ V2 @ R ) )
      = ( append @ C @ ( rBT_Im380146495e_keys @ C @ D @ L ) @ ( cons @ C @ K @ ( rBT_Im380146495e_keys @ C @ D @ R ) ) ) ) )).

% keys_simps(2)
thf(fact_134_gen__entries__simps_I3_J,axiom,(
    ! [D: $tType,C: $tType,Kvts: ( list @ ( product_prod @ ( product_prod @ C @ D ) @ ( rBT_Im246033960le_rbt @ C @ D ) ) ),C2: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ C @ D ),K: C,V2: D,R: ( rBT_Im246033960le_rbt @ C @ D )] :
      ( ( rBT_Im1841113099ntries @ C @ D @ Kvts @ ( rBT_Im480247531Branch @ C @ D @ C2 @ L @ K @ V2 @ R ) )
      = ( rBT_Im1841113099ntries @ C @ D @ ( cons @ ( product_prod @ ( product_prod @ C @ D ) @ ( rBT_Im246033960le_rbt @ C @ D ) ) @ ( product_Pair @ ( product_prod @ C @ D ) @ ( rBT_Im246033960le_rbt @ C @ D ) @ ( product_Pair @ C @ D @ K @ V2 ) @ R ) @ Kvts ) @ L ) ) )).

% gen_entries_simps(3)
thf(fact_135_foldi_Ocases,axiom,(
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( linorder @ A @ ( type2 @ A ) )
     => ! [X: ( product_prod @ ( C > $o ) @ ( product_prod @ ( A > B > C > C ) @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ C ) ) )] :
          ( ! [C3: ( C > $o ),F3: ( A > B > C > C ),S2: C] :
              ( X
             != ( product_Pair @ ( C > $o ) @ ( product_prod @ ( A > B > C > C ) @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ C ) ) @ C3 @ ( product_Pair @ ( A > B > C > C ) @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ C ) @ F3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ C @ ( rBT_Im418718756_Empty @ A @ B ) @ S2 ) ) ) )
         => ~ ( ! [C3: ( C > $o ),F3: ( A > B > C > C ),Col: rBT_Im1923302023_color,L2: ( rBT_Im246033960le_rbt @ A @ B ),K2: A,V: B,R3: ( rBT_Im246033960le_rbt @ A @ B ),S2: C] :
                  ( X
                 != ( product_Pair @ ( C > $o ) @ ( product_prod @ ( A > B > C > C ) @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ C ) ) @ C3 @ ( product_Pair @ ( A > B > C > C ) @ ( product_prod @ ( rBT_Im246033960le_rbt @ A @ B ) @ C ) @ F3 @ ( product_Pair @ ( rBT_Im246033960le_rbt @ A @ B ) @ C @ ( rBT_Im480247531Branch @ A @ B @ Col @ L2 @ K2 @ V @ R3 ) @ S2 ) ) ) ) ) ) ) )).

% foldi.cases
thf(fact_136_map__tailrec__rev_Ocases,axiom,(
    ! [A: $tType,B: $tType,X: ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) )] :
      ( ! [F3: ( A > B ),Bs2: ( list @ B )] :
          ( X
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F3 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ( ! [F3: ( A > B ),A3: A,As2: ( list @ A ),Bs2: ( list @ B )] :
              ( X
             != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F3 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A3 @ As2 ) @ Bs2 ) ) ) ) ) )).

% map_tailrec_rev.cases
thf(fact_137_rbt_Odistinct_I1_J,axiom,(
    ! [B: $tType,A: $tType,X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im418718756_Empty @ A @ B )
     != ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X232 @ X242 @ X25 ) ) )).

% rbt.distinct(1)
thf(fact_138_rbt_Oinduct,axiom,(
    ! [B: $tType,A: $tType,P: ( ( rBT_Im246033960le_rbt @ A @ B ) > $o ),Rbt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( P @ ( rBT_Im418718756_Empty @ A @ B ) )
     => ( ! [X1: rBT_Im1923302023_color,X23: ( rBT_Im246033960le_rbt @ A @ B ),X32: A,X4: B,X5: ( rBT_Im246033960le_rbt @ A @ B )] :
            ( ( P @ X23 )
           => ( ( P @ X5 )
             => ( P @ ( rBT_Im480247531Branch @ A @ B @ X1 @ X23 @ X32 @ X4 @ X5 ) ) ) )
       => ( P @ Rbt ) ) ) )).

% rbt.induct
thf(fact_139_rbt_Oexhaust,axiom,(
    ! [B: $tType,A: $tType,Y: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( Y
       != ( rBT_Im418718756_Empty @ A @ B ) )
     => ~ ( ! [X212: rBT_Im1923302023_color,X222: ( rBT_Im246033960le_rbt @ A @ B ),X233: A,X243: B,X252: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( Y
             != ( rBT_Im480247531Branch @ A @ B @ X212 @ X222 @ X233 @ X243 @ X252 ) ) ) ) )).

% rbt.exhaust
thf(fact_140_rbt_Osimps_I5_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F1: C,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > C ),X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im858806507se_rbt @ C @ A @ B @ F1 @ F2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X232 @ X242 @ X25 ) )
      = ( F2 @ X21 @ X22 @ X232 @ X242 @ X25 ) ) )).

% rbt.simps(5)
thf(fact_141_map_Osimps_I2_J,axiom,(
    ! [C: $tType,B: $tType,A: $tType,F: ( A > B > C ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V2: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1728190513le_map @ A @ B @ C @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ K @ V2 @ Rt ) )
      = ( rBT_Im480247531Branch @ A @ C @ C2 @ ( rBT_Im1728190513le_map @ A @ B @ C @ F @ Lt ) @ K @ ( F @ K @ V2 ) @ ( rBT_Im1728190513le_map @ A @ B @ C @ F @ Rt ) ) ) )).

% map.simps(2)
thf(fact_142_butlast_Osimps_I1_J,axiom,(
    ! [A: $tType] :
      ( ( butlast @ A @ ( nil @ A ) )
      = ( nil @ A ) ) )).

% butlast.simps(1)
thf(fact_143_ord_Orbt__map__entry_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),K: A,X: A,F: ( B > B ),C2: rBT_Im1923302023_color,Lt: ( rBT_Im246033960le_rbt @ A @ B ),V2: B,Rt: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( ( Less @ K @ X )
       => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V2 @ Rt ) )
          = ( rBT_Im480247531Branch @ A @ B @ C2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ Lt ) @ X @ V2 @ Rt ) ) )
      & ( ~ ( Less @ K @ X )
       => ( ( ( Less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V2 @ Rt ) )
              = ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V2 @ ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ Rt ) ) ) )
          & ( ~ ( Less @ X @ K )
           => ( ( rBT_Im2018130356_entry @ A @ B @ Less @ K @ F @ ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ V2 @ Rt ) )
              = ( rBT_Im480247531Branch @ A @ B @ C2 @ Lt @ X @ ( F @ V2 ) @ Rt ) ) ) ) ) ) )).

% ord.rbt_map_entry.simps(2)
thf(fact_144_rbt_Osimps_I7_J,axiom,(
    ! [E: $tType,B: $tType,A: $tType,F1: E,F2: ( rBT_Im1923302023_color > ( rBT_Im246033960le_rbt @ A @ B ) > A > B > ( rBT_Im246033960le_rbt @ A @ B ) > E > E > E ),X21: rBT_Im1923302023_color,X22: ( rBT_Im246033960le_rbt @ A @ B ),X232: A,X242: B,X25: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ ( rBT_Im480247531Branch @ A @ B @ X21 @ X22 @ X232 @ X242 @ X25 ) )
      = ( F2 @ X21 @ X22 @ X232 @ X242 @ X25 @ ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ X22 ) @ ( rBT_Im1947144893ec_rbt @ E @ A @ B @ F1 @ F2 @ X25 ) ) ) )).

% rbt.simps(7)
thf(fact_145_splice_Ocases,axiom,(
    ! [A: $tType,X: ( product_prod @ ( list @ A ) @ ( list @ A ) )] :
      ( ! [Ys2: ( list @ A )] :
          ( X
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys2 ) )
     => ( ! [V: A,Va: ( list @ A )] :
            ( X
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ V @ Va ) @ ( nil @ A ) ) )
       => ~ ( ! [X2: A,Xs2: ( list @ A ),Y2: A,Ys2: ( list @ A )] :
                ( X
               != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) ) )).

% splice.cases
thf(fact_146_rbt__del_Ocases,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: ( product_prod @ A @ ( rBT_Im246033960le_rbt @ A @ B ) )] :
          ( ! [X2: A] :
              ( X
             != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X2 @ ( rBT_Im418718756_Empty @ A @ B ) ) )
         => ~ ( ! [X2: A,C3: rBT_Im1923302023_color,A3: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B4: ( rBT_Im246033960le_rbt @ A @ B )] :
                  ( X
                 != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X2 @ ( rBT_Im480247531Branch @ A @ B @ C3 @ A3 @ Y2 @ S2 @ B4 ) ) ) ) ) ) )).

% rbt_del.cases
thf(fact_147_ord_Orbt__del_Ocases,axiom,(
    ! [B: $tType,A: $tType,X: ( product_prod @ A @ ( rBT_Im246033960le_rbt @ A @ B ) )] :
      ( ! [X2: A] :
          ( X
         != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X2 @ ( rBT_Im418718756_Empty @ A @ B ) ) )
     => ~ ( ! [X2: A,C3: rBT_Im1923302023_color,A3: ( rBT_Im246033960le_rbt @ A @ B ),Y2: A,S2: B,B4: ( rBT_Im246033960le_rbt @ A @ B )] :
              ( X
             != ( product_Pair @ A @ ( rBT_Im246033960le_rbt @ A @ B ) @ X2 @ ( rBT_Im480247531Branch @ A @ B @ C3 @ A3 @ Y2 @ S2 @ B4 ) ) ) ) ) )).

% ord.rbt_del.cases
thf(fact_148_butlast_Osimps_I2_J,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( butlast @ A @ Xs ) ) ) ) ) )).

% butlast.simps(2)
thf(fact_149_butlast__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( butlast @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( butlast @ A @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( butlast @ A @ Ys ) ) ) ) ) )).

% butlast_append
thf(fact_150_entries_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Uu: rBT_Im1923302023_color,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V2: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im480247531Branch @ A @ B @ Uu @ L @ K @ V2 @ R ) )
      = ( append @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ L ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( rBT_Im954575269ntries @ A @ B @ R ) ) ) ) )).

% entries.simps(2)
thf(fact_151_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P2: ( product_prod @ A @ B )] :
    ? [X2: A,Y2: B] :
      ( P2
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) )).

% surj_pair
thf(fact_152_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P2: ( product_prod @ A @ B )] :
      ( ! [A3: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A3 @ B4 ) )
     => ( P @ P2 ) ) )).

% prod_cases
thf(fact_153_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A4: A,B2: B,A6: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A4 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B3 ) )
     => ~ ( ( A4 = A6 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_154_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A3: A,B4: B,C3: C] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A3 @ ( product_Pair @ B @ C @ B4 @ C3 ) ) ) ) )).

% prod_cases3
thf(fact_155_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A3: A,B4: B,C3: C,D2: D] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_156_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ~ ( ! [A3: A,B4: B,C3: C,D2: D,E2: E] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_157_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ~ ( ! [A3: A,B4: B,C3: C,D2: D,E2: E,F3: F4] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D2 @ ( product_Pair @ E @ F4 @ E2 @ F3 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_158_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E: $tType,F4: $tType,G2: $tType,Y: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ~ ( ! [A3: A,B4: B,C3: C,D2: D,E2: E,F3: F4,G3: G2] :
            ( Y
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F3 @ G3 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_159_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A3: A,B4: B,C3: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A3 @ ( product_Pair @ B @ C @ B4 @ C3 ) ) )
     => ( P @ X ) ) )).

% prod_induct3
thf(fact_160_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A3: A,B4: B,C3: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C3 @ D2 ) ) ) )
     => ( P @ X ) ) )).

% prod_induct4
thf(fact_161_prod__induct5,axiom,(
    ! [E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) )] :
      ( ! [A3: A,B4: B,C3: C,D2: D,E2: E] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E ) @ C3 @ ( product_Pair @ D @ E @ D2 @ E2 ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct5
thf(fact_162_prod__induct6,axiom,(
    ! [F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) )] :
      ( ! [A3: A,B4: B,C3: C,D2: D,E2: E,F3: F4] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ F4 ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ F4 ) @ D2 @ ( product_Pair @ E @ F4 @ E2 @ F3 ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct6
thf(fact_163_prod__induct7,axiom,(
    ! [G2: $tType,F4: $tType,E: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) ) > $o ),X: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) )] :
      ( ! [A3: A,B4: B,C3: C,D2: D,E2: E,F3: F4,G3: G2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) ) @ A3 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E @ ( product_prod @ F4 @ G2 ) ) @ D2 @ ( product_Pair @ E @ ( product_prod @ F4 @ G2 ) @ E2 @ ( product_Pair @ F4 @ G2 @ F3 @ G3 ) ) ) ) ) ) )
     => ( P @ X ) ) )).

% prod_induct7
thf(fact_164_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y: ( product_prod @ A @ B )] :
      ~ ( ! [A3: A,B4: B] :
            ( Y
           != ( product_Pair @ A @ B @ A3 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_165_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A3: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A3 @ B4 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_166_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A4: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A4 @ B2 ) )
      = ( F1 @ A4 @ B2 ) ) )).

% old.prod.rec
thf(fact_167_append__butlast__last__id,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( append @ A @ ( butlast @ A @ Xs ) @ ( cons @ A @ ( last @ A @ Xs ) @ ( nil @ A ) ) )
        = Xs ) ) )).

% append_butlast_last_id
thf(fact_168_snoc__listrel1__snoc__iff,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys: ( list @ A ),Y: A,R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( X = Y ) )
        | ( ( Xs = Ys )
          & ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R ) ) ) ) )).

% snoc_listrel1_snoc_iff
thf(fact_169_lexord__append__left__rightI,axiom,(
    ! [A: $tType,A4: A,B2: A,R: ( set @ ( product_prod @ A @ A ) ),U: ( list @ A ),X: ( list @ A ),Y: ( list @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B2 ) @ R )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A4 @ X ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y ) ) ) @ ( lexord @ A @ R ) ) ) )).

% lexord_append_left_rightI
thf(fact_170_last__appendL,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
        = ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Xs ) ) ) )).

% last_appendL
thf(fact_171_last__appendR,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
        = ( last @ A @ Ys ) ) ) )).

% last_appendR
thf(fact_172_Cons__listrel1__Cons,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R ) )
      = ( ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
          & ( Xs = Ys ) )
        | ( ( X = Y )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) )).

% Cons_listrel1_Cons
thf(fact_173_last__snoc,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( last @ A @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) )
      = X ) )).

% last_snoc
thf(fact_174_lexord__cons__cons,axiom,(
    ! [A: $tType,A4: A,X: ( list @ A ),B2: A,Y: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A4 @ X ) @ ( cons @ A @ B2 @ Y ) ) @ ( lexord @ A @ R ) )
      = ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B2 ) @ R )
        | ( ( A4 = B2 )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) ) ) ) ) )).

% lexord_cons_cons
thf(fact_175_lexord__Nil__left,axiom,(
    ! [A: $tType,Y: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y ) @ ( lexord @ A @ R ) )
      = ( ? [A7: A,X3: ( list @ A )] :
            ( Y
            = ( cons @ A @ A7 @ X3 ) ) ) ) )).

% lexord_Nil_left
thf(fact_176_listrel1I2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) ),X: A] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ X @ Ys ) ) @ ( listrel1 @ A @ R ) ) ) )).

% listrel1I2
thf(fact_177_not__listrel1__Nil,axiom,(
    ! [A: $tType,Xs: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R ) ) )).

% not_listrel1_Nil
thf(fact_178_not__Nil__listrel1,axiom,(
    ! [A: $tType,Xs: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R ) ) )).

% not_Nil_listrel1
thf(fact_179_append__listrel1I,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) ),Us: ( list @ A ),Vs: ( list @ A )] :
      ( ( ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R ) ) ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R ) ) ) )).

% append_listrel1I
thf(fact_180_last__ConsR,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = ( last @ A @ Xs ) ) ) )).

% last_ConsR
thf(fact_181_last__ConsL,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
        = X ) ) )).

% last_ConsL
thf(fact_182_last_Osimps,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = X ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( last @ A @ ( cons @ A @ X @ Xs ) )
          = ( last @ A @ Xs ) ) ) ) )).

% last.simps
thf(fact_183_last__append,axiom,(
    ! [A: $tType,Ys: ( list @ A ),Xs: ( list @ A )] :
      ( ( ( Ys
          = ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Xs ) ) )
      & ( ( Ys
         != ( nil @ A ) )
       => ( ( last @ A @ ( append @ A @ Xs @ Ys ) )
          = ( last @ A @ Ys ) ) ) ) )).

% last_append
thf(fact_184_longest__common__suffix,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
    ? [Ss: ( list @ A ),Xs4: ( list @ A ),Ys5: ( list @ A )] :
      ( ( Xs
        = ( append @ A @ Xs4 @ Ss ) )
      & ( Ys
        = ( append @ A @ Ys5 @ Ss ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( last @ A @ Xs4 )
         != ( last @ A @ Ys5 ) ) ) ) )).

% longest_common_suffix
thf(fact_185_lexord__linear,axiom,(
    ! [A: $tType,R: ( set @ ( product_prod @ A @ A ) ),X: ( list @ A ),Y: ( list @ A )] :
      ( ! [A3: A,B4: A] :
          ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ B4 ) @ R )
          | ( A3 = B4 )
          | ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A3 ) @ R ) )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R ) )
        | ( X = Y )
        | ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y @ X ) @ ( lexord @ A @ R ) ) ) ) )).

% lexord_linear
thf(fact_186_lexord__irreflexive,axiom,(
    ! [A: $tType,R: ( set @ ( product_prod @ A @ A ) ),Xs: ( list @ A )] :
      ( ! [X2: A] :
          ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ R )
     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R ) ) ) )).

% lexord_irreflexive
thf(fact_187_lexord__Nil__right,axiom,(
    ! [A: $tType,X: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( nil @ A ) ) @ ( lexord @ A @ R ) ) )).

% lexord_Nil_right
thf(fact_188_lexord__append__leftI,axiom,(
    ! [A: $tType,U: ( list @ A ),V2: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) ),X: ( list @ A )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R ) ) ) )).

% lexord_append_leftI
thf(fact_189_Cons__listrel1E2,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Y: A,Ys: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y @ Ys ) ) @ ( listrel1 @ A @ R ) )
     => ( ! [X2: A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys ) )
           => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y ) @ R ) )
       => ~ ( ! [Zs2: ( list @ A )] :
                ( ( Xs
                  = ( cons @ A @ Y @ Zs2 ) )
               => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) ) )).

% Cons_listrel1E2
thf(fact_190_Cons__listrel1E1,axiom,(
    ! [A: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ Ys ) @ ( listrel1 @ A @ R ) )
     => ( ! [Y2: A] :
            ( ( Ys
              = ( cons @ A @ Y2 @ Xs ) )
           => ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y2 ) @ R ) )
       => ~ ( ! [Zs2: ( list @ A )] :
                ( ( Ys
                  = ( cons @ A @ X @ Zs2 ) )
               => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R ) ) ) ) ) ) )).

% Cons_listrel1E1
thf(fact_191_listrel1I1,axiom,(
    ! [A: $tType,X: A,Y: A,R: ( set @ ( product_prod @ A @ A ) ),Xs: ( list @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Xs ) ) @ ( listrel1 @ A @ R ) ) ) )).

% listrel1I1
thf(fact_192_lexord__append__leftD,axiom,(
    ! [A: $tType,X: ( list @ A ),U: ( list @ A ),V2: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X @ U ) @ ( append @ A @ X @ V2 ) ) @ ( lexord @ A @ R ) )
     => ( ! [A3: A] :
            ~ ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A3 @ A3 ) @ R )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V2 ) @ ( lexord @ A @ R ) ) ) ) )).

% lexord_append_leftD
thf(fact_193_lexord__append__rightI,axiom,(
    ! [A: $tType,Y: ( list @ A ),X: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ? [B5: A,Z: ( list @ A )] :
          ( Y
          = ( cons @ A @ B5 @ Z ) )
     => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ ( append @ A @ X @ Y ) ) @ ( lexord @ A @ R ) ) ) )).

% lexord_append_rightI
thf(fact_194_listrel1I,axiom,(
    ! [A: $tType,X: A,Y: A,R: ( set @ ( product_prod @ A @ A ) ),Xs: ( list @ A ),Us: ( list @ A ),Vs: ( list @ A ),Ys: ( list @ A )] :
      ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y @ Vs ) ) )
         => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) ) ) ) ) )).

% listrel1I
thf(fact_195_listrel1E,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),R: ( set @ ( product_prod @ A @ A ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R ) )
     => ~ ( ! [X2: A,Y2: A] :
              ( ( member2 @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
             => ! [Us3: ( list @ A ),Vs2: ( list @ A )] :
                  ( ( Xs
                    = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs2 ) ) )
                 => ( Ys
                   != ( append @ A @ Us3 @ ( cons @ A @ Y2 @ Vs2 ) ) ) ) ) ) ) )).

% listrel1E
thf(fact_196_snoc__eq__iff__butlast,axiom,(
    ! [A: $tType,Xs: ( list @ A ),X: A,Ys: ( list @ A )] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) )
        = Ys )
      = ( ( Ys
         != ( nil @ A ) )
        & ( ( butlast @ A @ Ys )
          = Xs )
        & ( ( last @ A @ Ys )
          = X ) ) ) )).

% snoc_eq_iff_butlast
thf(fact_197_entries__balance,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V2: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im954575269ntries @ A @ B @ ( rBT_Im1648453169alance @ A @ B @ L @ K @ V2 @ R ) )
      = ( append @ ( product_prod @ A @ B ) @ ( rBT_Im954575269ntries @ A @ B @ L ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( rBT_Im954575269ntries @ A @ B @ R ) ) ) ) )).

% entries_balance
thf(fact_198_lexord__asymmetric,axiom,(
    ! [A: $tType,R4: ( set @ ( product_prod @ A @ A ) ),A4: ( list @ A ),B2: ( list @ A )] :
      ( ( asym @ A @ R4 )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A4 @ B2 ) @ ( lexord @ A @ R4 ) )
       => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ B2 @ A4 ) @ ( lexord @ A @ R4 ) ) ) ) )).

% lexord_asymmetric
thf(fact_199_listrel_Oinducts,axiom,(
    ! [A: $tType,B: $tType,X12: ( list @ A ),X24: ( list @ B ),R: ( set @ ( product_prod @ A @ B ) ),P: ( ( list @ A ) > ( list @ B ) > $o )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ X12 @ X24 ) @ ( listrel @ A @ B @ R ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X2: A,Y2: B,Xs2: ( list @ A ),Ys2: ( list @ B )] :
              ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
             => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys2 ) @ ( listrel @ A @ B @ R ) )
               => ( ( P @ Xs2 @ Ys2 )
                 => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ B @ Y2 @ Ys2 ) ) ) ) )
         => ( P @ X12 @ X24 ) ) ) ) )).

% listrel.inducts
thf(fact_200_keys__balance,axiom,(
    ! [B: $tType,A: $tType,L: ( rBT_Im246033960le_rbt @ A @ B ),K: A,V2: B,R: ( rBT_Im246033960le_rbt @ A @ B )] :
      ( ( rBT_Im380146495e_keys @ A @ B @ ( rBT_Im1648453169alance @ A @ B @ L @ K @ V2 @ R ) )
      = ( append @ A @ ( rBT_Im380146495e_keys @ A @ B @ L ) @ ( cons @ A @ K @ ( rBT_Im380146495e_keys @ A @ B @ R ) ) ) ) )).

% keys_balance
thf(fact_201_lexord__asym,axiom,(
    ! [A: $tType,R4: ( set @ ( product_prod @ A @ A ) )] :
      ( ( asym @ A @ R4 )
     => ( asym @ ( list @ A ) @ ( lexord @ A @ R4 ) ) ) )).

% lexord_asym
thf(fact_202_listrel_ONil,axiom,(
    ! [B: $tType,A: $tType,R: ( set @ ( product_prod @ A @ B ) )] :
      ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) ) )).

% listrel.Nil
thf(fact_203_listrel__Nil1,axiom,(
    ! [A: $tType,B: $tType,Xs: ( list @ B ),R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xs ) @ ( listrel @ A @ B @ R ) )
     => ( Xs
        = ( nil @ B ) ) ) )).

% listrel_Nil1
thf(fact_204_listrel__Nil2,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( nil @ B ) ) @ ( listrel @ A @ B @ R ) )
     => ( Xs
        = ( nil @ A ) ) ) )).

% listrel_Nil2
thf(fact_205_listrel_OCons,axiom,(
    ! [B: $tType,A: $tType,X: A,Y: B,R: ( set @ ( product_prod @ A @ B ) ),Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X @ Y ) @ R )
     => ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys ) @ ( listrel @ A @ B @ R ) )
       => ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ X @ Xs ) @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R ) ) ) ) )).

% listrel.Cons
thf(fact_206_listrel__Cons1,axiom,(
    ! [B: $tType,A: $tType,Y: A,Ys: ( list @ A ),Xs: ( list @ B ),R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ Y @ Ys ) @ Xs ) @ ( listrel @ A @ B @ R ) )
     => ~ ( ! [Y2: B,Ys2: ( list @ B )] :
              ( ( Xs
                = ( cons @ B @ Y2 @ Ys2 ) )
             => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Y @ Y2 ) @ R )
               => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Ys @ Ys2 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ) )).

% listrel_Cons1
thf(fact_207_listrel__Cons2,axiom,(
    ! [B: $tType,A: $tType,Xs: ( list @ A ),Y: B,Ys: ( list @ B ),R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ ( cons @ B @ Y @ Ys ) ) @ ( listrel @ A @ B @ R ) )
     => ~ ( ! [X2: A,Xs2: ( list @ A )] :
              ( ( Xs
                = ( cons @ A @ X2 @ Xs2 ) )
             => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y ) @ R )
               => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys ) @ ( listrel @ A @ B @ R ) ) ) ) ) ) )).

% listrel_Cons2
thf(fact_208_listrel_Ocases,axiom,(
    ! [B: $tType,A: $tType,A1: ( list @ A ),A2: ( list @ B ),R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A2 ) @ ( listrel @ A @ B @ R ) )
     => ( ( ( A1
            = ( nil @ A ) )
         => ( A2
           != ( nil @ B ) ) )
       => ~ ( ! [X2: A,Y2: B,Xs2: ( list @ A )] :
                ( ( A1
                  = ( cons @ A @ X2 @ Xs2 ) )
               => ! [Ys2: ( list @ B )] :
                    ( ( A2
                      = ( cons @ B @ Y2 @ Ys2 ) )
                   => ( ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ R )
                     => ~ ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs2 @ Ys2 ) @ ( listrel @ A @ B @ R ) ) ) ) ) ) ) ) )).

% listrel.cases
thf(fact_209_listrel_Osimps,axiom,(
    ! [B: $tType,A: $tType,A1: ( list @ A ),A2: ( list @ B ),R: ( set @ ( product_prod @ A @ B ) )] :
      ( ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ A1 @ A2 ) @ ( listrel @ A @ B @ R ) )
      = ( ( ( A1
            = ( nil @ A ) )
          & ( A2
            = ( nil @ B ) ) )
        | ? [X3: A,Y3: B,Xs3: ( list @ A ),Ys3: ( list @ B )] :
            ( ( A1
              = ( cons @ A @ X3 @ Xs3 ) )
            & ( A2
              = ( cons @ B @ Y3 @ Ys3 ) )
            & ( member2 @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y3 ) @ R )
            & ( member2 @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs3 @ Ys3 ) @ ( listrel @ A @ B @ R ) ) ) ) ) )).

% listrel.simps
thf(fact_210_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C2: ( B > C > A ),A4: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C2 @ ( product_Pair @ B @ C @ A4 @ B2 ) )
      = ( C2 @ A4 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_211_map__tailrec__rev_Opelims,axiom,(
    ! [A: $tType,B: $tType,X: ( A > B ),Xa: ( list @ A ),Xb: ( list @ B ),Y: ( list @ B )] :
      ( ( ( map_tailrec_rev @ A @ B @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xa @ Xb ) ) )
       => ( ( ( Xa
              = ( nil @ A ) )
           => ( ( Y = Xb )
             => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Xb ) ) ) ) )
         => ~ ( ! [A3: A,As2: ( list @ A )] :
                  ( ( Xa
                    = ( cons @ A @ A3 @ As2 ) )
                 => ( ( Y
                      = ( map_tailrec_rev @ A @ B @ X @ As2 @ ( cons @ B @ ( X @ A3 ) @ Xb ) ) )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) @ ( map_tailrec_rev_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ X @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A3 @ As2 ) @ Xb ) ) ) ) ) ) ) ) ) )).

% map_tailrec_rev.pelims
thf(fact_212_ord_Osunion__with_Opsimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,V2: B,As: ( list @ ( product_prod @ A @ B ) ),K4: A,V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
     => ( ( ( Less @ K4 @ K )
         => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
            = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) ) )
        & ( ~ ( Less @ K4 @ K )
         => ( ( ( Less @ K @ K4 )
             => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) ) )
            & ( ~ ( Less @ K @ K4 )
             => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ As @ Bs ) ) ) ) ) ) ) ) )).

% ord.sunion_with.psimps(1)
thf(fact_213_ord_Osinter__with_Opsimps_I1_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),K: A,V2: B,As: ( list @ ( product_prod @ A @ B ) ),K4: A,V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
     => ( ( ( Less @ K4 @ K )
         => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
            = ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) )
        & ( ~ ( Less @ K4 @ K )
         => ( ( ( Less @ K @ K4 )
             => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                = ( rBT_Im319793781r_with @ A @ B @ Less @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
            & ( ~ ( Less @ K @ K4 )
             => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im319793781r_with @ A @ B @ Less @ F @ As @ Bs ) ) ) ) ) ) ) ) )).

% ord.sinter_with.psimps(1)
thf(fact_214_ord_Osinter__with_Opsimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),Uv: ( list @ ( product_prod @ A @ B ) )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ Uv @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
     => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ Uv @ ( nil @ ( product_prod @ A @ B ) ) )
        = ( nil @ ( product_prod @ A @ B ) ) ) ) )).

% ord.sinter_with.psimps(3)
thf(fact_215_ord_Osinter__with_Opsimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),Uu: ( list @ ( product_prod @ A @ B ) )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Uu ) ) )
     => ( ( rBT_Im319793781r_with @ A @ B @ Less @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Uu )
        = ( nil @ ( product_prod @ A @ B ) ) ) ) )).

% ord.sinter_with.psimps(2)
thf(fact_216_ord_Osunion__with_Opsimps_I3_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),As: ( list @ ( product_prod @ A @ B ) )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ As @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
     => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ As @ ( nil @ ( product_prod @ A @ B ) ) )
        = As ) ) )).

% ord.sunion_with.psimps(3)
thf(fact_217_ord_Osunion__with_Opsimps_I2_J,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),F: ( A > B > B > B ),Bs: ( list @ ( product_prod @ A @ B ) )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Bs ) ) )
     => ( ( rBT_Im1445157352n_with @ A @ B @ Less @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Bs )
        = Bs ) ) )).

% ord.sunion_with.psimps(2)
thf(fact_218_ord_Osunion__with_Opinduct,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),A0: ( A > B > B > B ),A1: ( list @ ( product_prod @ A @ B ) ),A2: ( list @ ( product_prod @ A @ B ) ),P: ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > $o )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ A0 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ A1 @ A2 ) ) )
     => ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
            ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
           => ( ( ( Less @ K3 @ K2 )
               => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ Bs2 ) )
             => ( ( ~ ( Less @ K3 @ K2 )
                 => ( ( Less @ K2 @ K3 )
                   => ( P @ F3 @ As2 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
               => ( ( ~ ( Less @ K3 @ K2 )
                   => ( ~ ( Less @ K2 @ K3 )
                     => ( P @ F3 @ As2 @ Bs2 ) ) )
                 => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) ) ) )
       => ( ! [F3: ( A > B > B > B ),Bs2: ( list @ ( product_prod @ A @ B ) )] :
              ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Bs2 ) ) )
             => ( P @ F3 @ ( nil @ ( product_prod @ A @ B ) ) @ Bs2 ) )
         => ( ! [F3: ( A > B > B > B ),As2: ( list @ ( product_prod @ A @ B ) )] :
                ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im753582353th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ As2 @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
               => ( P @ F3 @ As2 @ ( nil @ ( product_prod @ A @ B ) ) ) )
           => ( P @ A0 @ A1 @ A2 ) ) ) ) ) )).

% ord.sunion_with.pinduct
thf(fact_219_ord_Osinter__with_Opinduct,axiom,(
    ! [B: $tType,A: $tType,Less: ( A > A > $o ),A0: ( A > B > B > B ),A1: ( list @ ( product_prod @ A @ B ) ),A2: ( list @ ( product_prod @ A @ B ) ),P: ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > $o )] :
      ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ A0 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ A1 @ A2 ) ) )
     => ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
            ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
           => ( ( ( Less @ K3 @ K2 )
               => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ Bs2 ) )
             => ( ( ~ ( Less @ K3 @ K2 )
                 => ( ( Less @ K2 @ K3 )
                   => ( P @ F3 @ As2 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
               => ( ( ~ ( Less @ K3 @ K2 )
                   => ( ~ ( Less @ K2 @ K3 )
                     => ( P @ F3 @ As2 @ Bs2 ) ) )
                 => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) ) ) )
       => ( ! [F3: ( A > B > B > B ),Uu2: ( list @ ( product_prod @ A @ B ) )] :
              ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Uu2 ) ) )
             => ( P @ F3 @ ( nil @ ( product_prod @ A @ B ) ) @ Uu2 ) )
         => ( ! [F3: ( A > B > B > B ),Uv2: ( list @ ( product_prod @ A @ B ) )] :
                ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im735314116th_rel @ A @ B @ Less ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ Uv2 @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
               => ( P @ F3 @ Uv2 @ ( nil @ ( product_prod @ A @ B ) ) ) )
           => ( P @ A0 @ A1 @ A2 ) ) ) ) ) )).

% ord.sinter_with.pinduct
thf(fact_220_sunion__with_Opsimps_I3_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),As: ( list @ ( product_prod @ A @ B ) )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ As @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
         => ( ( rBT_Im1518674580n_with @ A @ B @ F @ As @ ( nil @ ( product_prod @ A @ B ) ) )
            = As ) ) ) )).

% sunion_with.psimps(3)
thf(fact_221_sunion__with_Opsimps_I2_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),Bs: ( list @ ( product_prod @ A @ B ) )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Bs ) ) )
         => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Bs )
            = Bs ) ) ) )).

% sunion_with.psimps(2)
thf(fact_222_sunion__with_Opsimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),K: A,V2: B,As: ( list @ ( product_prod @ A @ B ) ),K4: A,V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
         => ( ( ( ord_less @ A @ K4 @ K )
             => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) ) )
            & ( ~ ( ord_less @ A @ K4 @ K )
             => ( ( ( ord_less @ A @ K @ K4 )
                 => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                    = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( rBT_Im1518674580n_with @ A @ B @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) ) )
                & ( ~ ( ord_less @ A @ K @ K4 )
                 => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                    = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im1518674580n_with @ A @ B @ F @ As @ Bs ) ) ) ) ) ) ) ) ) )).

% sunion_with.psimps(1)
thf(fact_223_sunion__with_Opinduct,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A0: ( A > B > B > B ),A1: ( list @ ( product_prod @ A @ B ) ),A2: ( list @ ( product_prod @ A @ B ) ),P: ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > $o )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ A0 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ A1 @ A2 ) ) )
         => ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
                ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
               => ( ( ( ord_less @ A @ K3 @ K2 )
                   => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ Bs2 ) )
                 => ( ( ~ ( ord_less @ A @ K3 @ K2 )
                     => ( ( ord_less @ A @ K2 @ K3 )
                       => ( P @ F3 @ As2 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
                   => ( ( ~ ( ord_less @ A @ K3 @ K2 )
                       => ( ~ ( ord_less @ A @ K2 @ K3 )
                         => ( P @ F3 @ As2 @ Bs2 ) ) )
                     => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) ) ) )
           => ( ! [F3: ( A > B > B > B ),Bs2: ( list @ ( product_prod @ A @ B ) )] :
                  ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Bs2 ) ) )
                 => ( P @ F3 @ ( nil @ ( product_prod @ A @ B ) ) @ Bs2 ) )
             => ( ! [F3: ( A > B > B > B ),As2: ( list @ ( product_prod @ A @ B ) )] :
                    ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im328486757th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ As2 @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
                   => ( P @ F3 @ As2 @ ( nil @ ( product_prod @ A @ B ) ) ) )
               => ( P @ A0 @ A1 @ A2 ) ) ) ) ) ) )).

% sunion_with.pinduct
thf(fact_224_lexordp__eq__simps_I4_J,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Xs: ( list @ A ),Y: A,Ys: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp_eq @ A @ Xs @ Ys ) ) ) ) ) )).

% lexordp_eq_simps(4)
thf(fact_225_lexordp__eq_OCons__eq,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp_eq @ A @ Xs @ Ys )
             => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) ) ) )).

% lexordp_eq.Cons_eq
thf(fact_226_lexordp__eq_OCons,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X: A,Y: A,Xs: ( list @ A ),Ys: ( list @ A )] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys ) ) ) ) )).

% lexordp_eq.Cons
thf(fact_227_sunion__with_Oinduct,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [P: ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > $o ),A0: ( A > B > B > B ),A1: ( list @ ( product_prod @ A @ B ) ),A2: ( list @ ( product_prod @ A @ B ) )] :
          ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
              ( ( ( ord_less @ A @ K3 @ K2 )
               => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ Bs2 ) )
             => ( ( ~ ( ord_less @ A @ K3 @ K2 )
                 => ( ( ord_less @ A @ K2 @ K3 )
                   => ( P @ F3 @ As2 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
               => ( ( ~ ( ord_less @ A @ K3 @ K2 )
                   => ( ~ ( ord_less @ A @ K2 @ K3 )
                     => ( P @ F3 @ As2 @ Bs2 ) ) )
                 => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) ) )
         => ( ! [F3: ( A > B > B > B ),X1: ( list @ ( product_prod @ A @ B ) )] :
                ( P @ F3 @ ( nil @ ( product_prod @ A @ B ) ) @ X1 )
           => ( ! [F3: ( A > B > B > B ),As2: ( list @ ( product_prod @ A @ B ) )] :
                  ( P @ F3 @ As2 @ ( nil @ ( product_prod @ A @ B ) ) )
             => ( P @ A0 @ A1 @ A2 ) ) ) ) ) )).

% sunion_with.induct
thf(fact_228_lexordp__eq_Ocases,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A1: ( list @ A ),A2: ( list @ A )] :
          ( ( ord_lexordp_eq @ A @ A1 @ A2 )
         => ( ( ( A1
                = ( nil @ A ) )
             => ! [Ys2: ( list @ A )] : ( A2 != Ys2 ) )
           => ( ! [X2: A] :
                  ( ? [Xs2: ( list @ A )] :
                      ( A1
                      = ( cons @ A @ X2 @ Xs2 ) )
                 => ! [Y2: A] :
                      ( ? [Ys2: ( list @ A )] :
                          ( A2
                          = ( cons @ A @ Y2 @ Ys2 ) )
                     => ~ ( ord_less @ A @ X2 @ Y2 ) ) )
             => ~ ( ! [X2: A,Y2: A,Xs2: ( list @ A )] :
                      ( ( A1
                        = ( cons @ A @ X2 @ Xs2 ) )
                     => ! [Ys2: ( list @ A )] :
                          ( ( A2
                            = ( cons @ A @ Y2 @ Ys2 ) )
                         => ( ~ ( ord_less @ A @ X2 @ Y2 )
                           => ( ~ ( ord_less @ A @ Y2 @ X2 )
                             => ~ ( ord_lexordp_eq @ A @ Xs2 @ Ys2 ) ) ) ) ) ) ) ) ) ) )).

% lexordp_eq.cases
thf(fact_229_lexordp__eq_Osimps,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [A12: ( list @ A ),A22: ( list @ A )] :
              ( ? [Ys3: ( list @ A )] :
                  ( ( A12
                    = ( nil @ A ) )
                  & ( A22 = Ys3 ) )
              | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X3 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ( ord_less @ A @ X3 @ Y3 ) )
              | ? [X3: A,Y3: A,Xs3: ( list @ A ),Ys3: ( list @ A )] :
                  ( ( A12
                    = ( cons @ A @ X3 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y3 @ Ys3 ) )
                  & ~ ( ord_less @ A @ X3 @ Y3 )
                  & ~ ( ord_less @ A @ Y3 @ X3 )
                  & ( ord_lexordp_eq @ A @ Xs3 @ Ys3 ) ) ) ) ) ) )).

% lexordp_eq.simps
thf(fact_230_lexordp__eq_Oinducts,axiom,(
    ! [A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [X12: ( list @ A ),X24: ( list @ A ),P: ( ( list @ A ) > ( list @ A ) > $o )] :
          ( ( ord_lexordp_eq @ A @ X12 @ X24 )
         => ( ! [X1: ( list @ A )] :
                ( P @ ( nil @ A ) @ X1 )
           => ( ! [X2: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                  ( ( ord_less @ A @ X2 @ Y2 )
                 => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) )
             => ( ! [X2: A,Y2: A,Xs2: ( list @ A ),Ys2: ( list @ A )] :
                    ( ~ ( ord_less @ A @ X2 @ Y2 )
                   => ( ~ ( ord_less @ A @ Y2 @ X2 )
                     => ( ( ord_lexordp_eq @ A @ Xs2 @ Ys2 )
                       => ( ( P @ Xs2 @ Ys2 )
                         => ( P @ ( cons @ A @ X2 @ Xs2 ) @ ( cons @ A @ Y2 @ Ys2 ) ) ) ) ) )
               => ( P @ X12 @ X24 ) ) ) ) ) ) )).

% lexordp_eq.inducts
thf(fact_231_sunion__with_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [K4: A,K: A,F: ( A > B > B > B ),V2: B,As: ( list @ ( product_prod @ A @ B ) ),V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
          ( ( ( ord_less @ A @ K4 @ K )
           => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
              = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) ) )
          & ( ~ ( ord_less @ A @ K4 @ K )
           => ( ( ( ord_less @ A @ K @ K4 )
               => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                  = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ ( rBT_Im1518674580n_with @ A @ B @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) ) )
              & ( ~ ( ord_less @ A @ K @ K4 )
               => ( ( rBT_Im1518674580n_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                  = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im1518674580n_with @ A @ B @ F @ As @ Bs ) ) ) ) ) ) ) ) )).

% sunion_with.simps(1)
thf(fact_232_sinter__with_Opinduct,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [A0: ( A > B > B > B ),A1: ( list @ ( product_prod @ A @ B ) ),A2: ( list @ ( product_prod @ A @ B ) ),P: ( ( A > B > B > B ) > ( list @ ( product_prod @ A @ B ) ) > ( list @ ( product_prod @ A @ B ) ) > $o )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ A0 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ A1 @ A2 ) ) )
         => ( ! [F3: ( A > B > B > B ),K2: A,V: B,As2: ( list @ ( product_prod @ A @ B ) ),K3: A,V3: B,Bs2: ( list @ ( product_prod @ A @ B ) )] :
                ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
               => ( ( ( ord_less @ A @ K3 @ K2 )
                   => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ Bs2 ) )
                 => ( ( ~ ( ord_less @ A @ K3 @ K2 )
                     => ( ( ord_less @ A @ K2 @ K3 )
                       => ( P @ F3 @ As2 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) )
                   => ( ( ~ ( ord_less @ A @ K3 @ K2 )
                       => ( ~ ( ord_less @ A @ K2 @ K3 )
                         => ( P @ F3 @ As2 @ Bs2 ) ) )
                     => ( P @ F3 @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K2 @ V ) @ As2 ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K3 @ V3 ) @ Bs2 ) ) ) ) ) )
           => ( ! [F3: ( A > B > B > B ),Uu2: ( list @ ( product_prod @ A @ B ) )] :
                  ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Uu2 ) ) )
                 => ( P @ F3 @ ( nil @ ( product_prod @ A @ B ) ) @ Uu2 ) )
             => ( ! [F3: ( A > B > B > B ),Uv2: ( list @ ( product_prod @ A @ B ) )] :
                    ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F3 @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ Uv2 @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
                   => ( P @ F3 @ Uv2 @ ( nil @ ( product_prod @ A @ B ) ) ) )
               => ( P @ A0 @ A1 @ A2 ) ) ) ) ) ) )).

% sinter_with.pinduct
thf(fact_233_sinter__with_Opsimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),K: A,V2: B,As: ( list @ ( product_prod @ A @ B ) ),K4: A,V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
         => ( ( ( ord_less @ A @ K4 @ K )
             => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                = ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) )
            & ( ~ ( ord_less @ A @ K4 @ K )
             => ( ( ( ord_less @ A @ K @ K4 )
                 => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                    = ( rBT_Im393311009r_with @ A @ B @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
                & ( ~ ( ord_less @ A @ K @ K4 )
                 => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                    = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im393311009r_with @ A @ B @ F @ As @ Bs ) ) ) ) ) ) ) ) ) )).

% sinter_with.psimps(1)
thf(fact_234_sinter__with_Osimps_I2_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),Uu: ( list @ ( product_prod @ A @ B ) )] :
          ( ( rBT_Im393311009r_with @ A @ B @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Uu )
          = ( nil @ ( product_prod @ A @ B ) ) ) ) )).

% sinter_with.simps(2)
thf(fact_235_sinter__with_Osimps_I3_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),Uv: ( list @ ( product_prod @ A @ B ) )] :
          ( ( rBT_Im393311009r_with @ A @ B @ F @ Uv @ ( nil @ ( product_prod @ A @ B ) ) )
          = ( nil @ ( product_prod @ A @ B ) ) ) ) )).

% sinter_with.simps(3)
thf(fact_236_sinter__with_Opsimps_I3_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),Uv: ( list @ ( product_prod @ A @ B ) )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ Uv @ ( nil @ ( product_prod @ A @ B ) ) ) ) )
         => ( ( rBT_Im393311009r_with @ A @ B @ F @ Uv @ ( nil @ ( product_prod @ A @ B ) ) )
            = ( nil @ ( product_prod @ A @ B ) ) ) ) ) )).

% sinter_with.psimps(3)
thf(fact_237_sinter__with_Opsimps_I2_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [F: ( A > B > B > B ),Uu: ( list @ ( product_prod @ A @ B ) )] :
          ( ( accp @ ( product_prod @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) ) @ ( rBT_Im310218520th_rel @ A @ B ) @ ( product_Pair @ ( A > B > B > B ) @ ( product_prod @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) ) @ F @ ( product_Pair @ ( list @ ( product_prod @ A @ B ) ) @ ( list @ ( product_prod @ A @ B ) ) @ ( nil @ ( product_prod @ A @ B ) ) @ Uu ) ) )
         => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( nil @ ( product_prod @ A @ B ) ) @ Uu )
            = ( nil @ ( product_prod @ A @ B ) ) ) ) ) )).

% sinter_with.psimps(2)
thf(fact_238_sinter__with_Osimps_I1_J,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( ord @ A @ ( type2 @ A ) )
     => ! [K4: A,K: A,F: ( A > B > B > B ),V2: B,As: ( list @ ( product_prod @ A @ B ) ),V4: B,Bs: ( list @ ( product_prod @ A @ B ) )] :
          ( ( ( ord_less @ A @ K4 @ K )
           => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
              = ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ Bs ) ) )
          & ( ~ ( ord_less @ A @ K4 @ K )
           => ( ( ( ord_less @ A @ K @ K4 )
               => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                  = ( rBT_Im393311009r_with @ A @ B @ F @ As @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) ) ) )
              & ( ~ ( ord_less @ A @ K @ K4 )
               => ( ( rBT_Im393311009r_with @ A @ B @ F @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V2 ) @ As ) @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K4 @ V4 ) @ Bs ) )
                  = ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ ( F @ K @ V2 @ V4 ) ) @ ( rBT_Im393311009r_with @ A @ B @ F @ As @ Bs ) ) ) ) ) ) ) ) )).

% sinter_with.simps(1)
thf(fact_239_product_Osimps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),Ys: ( list @ B )] :
      ( ( product @ A @ B @ ( cons @ A @ X @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) )).

% product.simps(2)
thf(fact_240_zip__append,axiom,(
    ! [A: $tType,B: $tType,Xs: ( list @ A ),Us: ( list @ B ),Ys: ( list @ A ),Vs: ( list @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Us ) )
     => ( ( zip @ A @ B @ ( append @ A @ Xs @ Ys ) @ ( append @ B @ Us @ Vs ) )
        = ( append @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Us ) @ ( zip @ A @ B @ Ys @ Vs ) ) ) ) )).

% zip_append
thf(fact_241_Nil__is__map__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% Nil_is_map_conv
thf(fact_242_map__is__Nil__conv,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) )).

% map_is_Nil_conv
thf(fact_243_list_Omap__disc__iff,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),A4: ( list @ A )] :
      ( ( ( map @ A @ B @ F @ A4 )
        = ( nil @ B ) )
      = ( A4
        = ( nil @ A ) ) ) )).

% list.map_disc_iff
thf(fact_244_length__map,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B )] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) )).

% length_map
thf(fact_245_append__eq__append__conv,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A ),Us: ( list @ A ),Vs: ( list @ A )] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) )).

% append_eq_append_conv
thf(fact_246_map__append,axiom,(
    ! [A: $tType,B: $tType,F: ( B > A ),Xs: ( list @ B ),Ys: ( list @ B )] :
      ( ( map @ B @ A @ F @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F @ Xs ) @ ( map @ B @ A @ F @ Ys ) ) ) )).

% map_append
thf(fact_247_length__rotate1,axiom,(
    ! [A: $tType,Xs: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) )).

% length_rotate1
thf(fact_248_map__eq__imp__length__eq,axiom,(
    ! [A: $tType,B: $tType,C: $tType,F: ( B > A ),Xs: ( list @ B ),G: ( C > A ),Ys: ( list @ C )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) )).

% map_eq_imp_length_eq
thf(fact_249_neq__if__length__neq,axiom,(
    ! [A: $tType,Xs: ( list @ A ),Ys: ( list @ A )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) )).

% neq_if_length_neq
thf(fact_250_Ex__list__of__length,axiom,(
    ! [A: $tType,N: nat] :
    ? [Xs2: ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N ) )).

% Ex_list_of_length
thf(fact_251_list_Osimps_I8_J,axiom,(
    ! [A: $tType,B: $tType,F: ( A > B )] :
      ( ( map @ A @ B @ F @ ( nil @ A ) )
      = ( nil @ B ) ) )).

% list.simps(8)
thf(fact_252_list_Osimps_I9_J,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),X21: A,X22: ( list @ A )] :
      ( ( map @ A @ B @ F @ ( cons @ A @ X21 @ X22 ) )
      = ( cons @ B @ ( F @ X21 ) @ ( map @ A @ B @ F @ X22 ) ) ) )).

% list.simps(9)
thf(fact_253_Cons__eq__map__D,axiom,(
    ! [A: $tType,B: $tType,X: A,Xs: ( list @ A ),F: ( B > A ),Ys: ( list @ B )] :
      ( ( ( cons @ A @ X @ Xs )
        = ( map @ B @ A @ F @ Ys ) )
     => ? [Z2: B,Zs2: ( list @ B )] :
          ( ( Ys
            = ( cons @ B @ Z2 @ Zs2 ) )
          & ( X
            = ( F @ Z2 ) )
          & ( Xs
            = ( map @ B @ A @ F @ Zs2 ) ) ) ) )).

% Cons_eq_map_D
thf(fact_254_map__eq__Cons__D,axiom,(
    ! [B: $tType,A: $tType,F: ( B > A ),Xs: ( list @ B ),Y: A,Ys: ( list @ A )] :
      ( ( ( map @ B @ A @ F @ Xs )
        = ( cons @ A @ Y @ Ys ) )
     => ? [Z2: B,Zs2: ( list @ B )] :
          ( ( Xs
            = ( cons @ B @ Z2 @ Zs2 ) )
          & ( ( F @ Z2 )
            = Y )
          & ( ( map @ B @ A @ F @ Zs2 )
            = Ys ) ) ) )).

% map_eq_Cons_D

%----Type constructors (6)
thf(tcon_fun___Orderings_Oord,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( ord @ A9 @ ( type2 @ A9 ) )
     => ( ord @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Nat_Onat___Orderings_Olinorder,axiom,
    ( linorder @ nat @ ( type2 @ nat ) )).

thf(tcon_Nat_Onat___Orderings_Oord_1,axiom,
    ( ord @ nat @ ( type2 @ nat ) )).

thf(tcon_Set_Oset___Orderings_Oord_2,axiom,(
    ! [A8: $tType] :
      ( ord @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Olinorder_3,axiom,
    ( linorder @ $o @ ( type2 @ $o ) )).

thf(tcon_HOL_Obool___Orderings_Oord_4,axiom,
    ( ord @ $o @ ( type2 @ $o ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( rBT_Im380146495e_keys @ a @ b )
    = ( rBT_Im1235880025n_keys @ a @ b @ ( nil @ ( product_prod @ a @ ( rBT_Im246033960le_rbt @ a @ b ) ) ) ) )).

%------------------------------------------------------------------------------
