%------------------------------------------------------------------------------
% File     : PRO021^1 : TPTP v7.0.0. Released v7.0.0.
% Domain   : Processes
% Problem  : Process algebra 159
% Version  : [Bla16] axioms : Especial.
% English  :

% Refs     : [BH+14] Blanchette et al. (2014), Truly Modular (Co)datatypes
%          : [RB15]  Reynolds & Blanchette (2015), A Decision Procedure for
%          : [Bla16] Blanchette (2016), Email to Geoff Sutcliffe
% Source   : [Bla16]
% Names    : process__159.p [Bla16]

% Status   : Theorem
% Rating   : ? v7.0.0
% Syntax   : Number of formulae    :  322 (   0 unit;  60 type;   0 defn)
%            Number of atoms       : 7201 ( 308 equality;5187 variable)
%            Maximal formula depth :   30 (  13 average)
%            Number of connectives : 6517 ( 106   ~;   3   |;  33   &;6055   @)
%                                         (   0 <=>; 320  =>;   0  <=;   0 <~>)
%                                         (   0  ~|;   0  ~&)
%            Number of type conns  : 1627 (1627   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :   64 (  60   :;   0   =;   0  @=)
%                                         (   0  !!;   0  ??;   0 @@+;   0 @@-)
%            Number of variables   : 1933 (   2 sgn;1671   !;  11   ?; 153   ^)
%                                         (1933   :;  98  !>;   0  ?*)
%                                         (   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2016-07-13 14:39:50.418
%------------------------------------------------------------------------------
%----Could-be-implicit typings (8)
thf(ty_t_Process__Mirabelle__xovoopgpgi_Oprocess__term,type,(
    proces554692349s_term: $tType > $tType > $tType )).

thf(ty_t_Process__Mirabelle__xovoopgpgi_Oprocess,type,(
    proces634752977rocess: $tType > $tType )).

thf(ty_t_Product__Type_Oprod,type,(
    product_prod: $tType > $tType > $tType )).

thf(ty_t_Set_Oset,type,(
    set: $tType > $tType )).

thf(ty_t_itself,type,(
    itself: $tType > $tType )).

thf(ty_tf_c,type,(
    c: $tType )).

thf(ty_tf_b,type,(
    b: $tType )).

thf(ty_tf_a,type,(
    a: $tType )).

%----Explicit typings (52)
thf(sy_cl_HOL_Otype,type,(
    type: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_cl_Orderings_Obot,type,(
    bot: 
      !>[A: $tType] :
        ( ( itself @ A ) > $o ) )).

thf(sy_c_BNF__Def_Orel__fun,type,(
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) )).

thf(sy_c_Basic__BNFs_Ofsts,type,(
    basic_fsts: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( set @ A ) ) )).

thf(sy_c_Basic__BNFs_Opred__prod,type,(
    basic_pred_prod: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( product_prod @ A @ B ) > $o ) )).

thf(sy_c_Basic__BNFs_Osnds,type,(
    basic_snds: 
      !>[A: $tType,B: $tType] :
        ( ( product_prod @ A @ B ) > ( set @ B ) ) )).

thf(sy_c_Complete__Partial__Order_Omonotone,type,(
    comple1396247847notone: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) )).

thf(sy_c_Fun_Omap__fun,type,(
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] :
        ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) )).

thf(sy_c_If,type,(
    if: 
      !>[A: $tType] :
        ( $o > A > A > A ) )).

thf(sy_c_Orderings_Obot__class_Obot,type,(
    bot_bot: 
      !>[A: $tType] : A )).

thf(sy_c_Partial__Function_Ofun__ord,type,(
    partial_fun_ord: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( C > A ) > ( C > B ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oguarded,type,(
    proces1121166967uarded: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > ( proces554692349s_term @ B @ C ) ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_OisACT,type,(
    proces687458811_isACT: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] :
        ( ( A > ( proces554692349s_term @ B @ C ) ) > ( proces554692349s_term @ D @ A ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess_Ocase__process,type,(
    proces1406508781rocess: 
      !>[A: $tType,B: $tType] :
        ( ( A > ( proces634752977rocess @ A ) > B ) > ( ( proces634752977rocess @ A ) > ( proces634752977rocess @ A ) > B ) > ( proces634752977rocess @ A ) > B ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess_Ocorec__process,type,(
    proces894737309rocess: 
      !>[C: $tType,A: $tType] :
        ( ( C > $o ) > ( C > A ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess_Opred__process,type,(
    proces1205983068rocess: 
      !>[A: $tType] :
        ( ( A > $o ) > ( proces634752977rocess @ A ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess_Orel__process,type,(
    proces749077512rocess: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > ( proces634752977rocess @ A ) > ( proces634752977rocess @ B ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess_Oset__process,type,(
    proces1148692671rocess: 
      !>[A: $tType] :
        ( ( proces634752977rocess @ A ) > ( set @ A ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_OACT,type,(
    proces1454156180ss_ACT: 
      !>[A: $tType,Pvar: $tType] :
        ( A > ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_OCH,type,(
    proces89589571ess_CH: 
      !>[A: $tType,Pvar: $tType] :
        ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_OPROC,type,(
    proces1062592052s_PROC: 
      !>[A: $tType,Pvar: $tType] :
        ( ( proces634752977rocess @ A ) > ( proces554692349s_term @ A @ Pvar ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_OVAR,type,(
    proces1627516585ss_VAR: 
      !>[Pvar: $tType,A: $tType] :
        ( Pvar > ( proces554692349s_term @ A @ Pvar ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Ocase__process__term,type,(
    proces460752237s_term: 
      !>[Pvar: $tType,B: $tType,A: $tType] :
        ( ( Pvar > B ) > ( ( proces634752977rocess @ A ) > B ) > ( A > ( proces554692349s_term @ A @ Pvar ) > B ) > ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > B ) > ( proces554692349s_term @ A @ Pvar ) > B ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Omap__process__term,type,(
    proces224683037s_term: 
      !>[A: $tType,Aa: $tType,Pvar: $tType,Pvara: $tType] :
        ( ( A > Aa ) > ( Pvar > Pvara ) > ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ Aa @ Pvara ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Opred__process__term,type,(
    proces2118920028s_term: 
      !>[A: $tType,B: $tType] :
        ( ( A > $o ) > ( B > $o ) > ( proces554692349s_term @ A @ B ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Orec__process__term,type,(
    proces2117273769s_term: 
      !>[Pvar: $tType,D: $tType,A: $tType] :
        ( ( Pvar > D ) > ( ( proces634752977rocess @ A ) > D ) > ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ) > ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Orel__process__term,type,(
    proces2029722208s_term: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] :
        ( ( A > C > $o ) > ( B > D > $o ) > ( proces554692349s_term @ A @ B ) > ( proces554692349s_term @ C @ D ) > $o ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Oset1__process__term,type,(
    proces1264666542s_term: 
      !>[A: $tType,Pvar: $tType] :
        ( ( proces554692349s_term @ A @ Pvar ) > ( set @ A ) ) )).

thf(sy_c_Process__Mirabelle__xovoopgpgi_Oprocess__term_Oset2__process__term,type,(
    proces1493547885s_term: 
      !>[A: $tType,Pvar: $tType] :
        ( ( proces554692349s_term @ A @ Pvar ) > ( set @ Pvar ) ) )).

thf(sy_c_Product__Type_OPair,type,(
    product_Pair: 
      !>[A: $tType,B: $tType] :
        ( A > B > ( product_prod @ A @ B ) ) )).

thf(sy_c_Product__Type_Ocurry,type,(
    product_curry: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( ( product_prod @ A @ B ) > C ) > A > B > C ) )).

thf(sy_c_Product__Type_Ointernal__case__prod,type,(
    produc2004651681e_prod: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) )).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,(
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] :
        ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) )).

thf(sy_c_Pure_Otype,type,(
    type2: 
      !>[A: $tType] :
        ( itself @ A ) )).

thf(sy_c_Quotient_OBex1__rel,type,(
    bex1_rel: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( A > $o ) > $o ) )).

thf(sy_c_Quotient_OQuotient3,type,(
    quotient3: 
      !>[A: $tType,B: $tType] :
        ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) )).

thf(sy_c_Relation_ODomainp,type,(
    domainp: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > A > $o ) )).

thf(sy_c_Relation_Oreflp,type,(
    reflp: 
      !>[A: $tType] :
        ( ( A > A > $o ) > $o ) )).

thf(sy_c_Relation_Orelcompp,type,(
    relcompp: 
      !>[A: $tType,B: $tType,C: $tType] :
        ( ( A > B > $o ) > ( B > C > $o ) > A > C > $o ) )).

thf(sy_c_Set_OBall,type,(
    ball: 
      !>[A: $tType] :
        ( ( set @ A ) > ( A > $o ) > $o ) )).

thf(sy_c_Set_OCollect,type,(
    collect: 
      !>[A: $tType] :
        ( ( A > $o ) > ( set @ A ) ) )).

thf(sy_c_Set_Oinsert,type,(
    insert: 
      !>[A: $tType] :
        ( A > ( set @ A ) > ( set @ A ) ) )).

thf(sy_c_Set_Ois__empty,type,(
    is_empty: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Ois__singleton,type,(
    is_singleton: 
      !>[A: $tType] :
        ( ( set @ A ) > $o ) )).

thf(sy_c_Set_Opairwise,type,(
    pairwise: 
      !>[A: $tType] :
        ( ( A > A > $o ) > ( set @ A ) > $o ) )).

thf(sy_c_Set_Othe__elem,type,(
    the_elem: 
      !>[A: $tType] :
        ( ( set @ A ) > A ) )).

thf(sy_c_Transfer_Obi__total,type,(
    bi_total: 
      !>[A: $tType,B: $tType] :
        ( ( A > B > $o ) > $o ) )).

thf(sy_c_Transfer_Orev__implies,type,(
    rev_implies: $o > $o > $o )).

thf(sy_c_Transfer_Otransfer__forall,type,(
    transfer_forall: 
      !>[A: $tType] :
        ( ( A > $o ) > $o ) )).

thf(sy_c_member,type,(
    member: 
      !>[A: $tType] :
        ( A > ( set @ A ) > $o ) )).

thf(sy_v_X,type,(
    x: a )).

thf(sy_v_sys,type,(
    sys: a > ( proces554692349s_term @ b @ a ) )).

%----Relevant facts (255)
thf(fact_0_g,axiom,
    ( proces1121166967uarded @ a @ b @ a @ sys )).

% g
thf(fact_1_process__term_Oinject_I1_J,axiom,(
    ! [A: $tType,Pvar: $tType,X1: Pvar,Y1: Pvar] :
      ( ( ( proces1627516585ss_VAR @ Pvar @ A @ X1 )
        = ( proces1627516585ss_VAR @ Pvar @ A @ Y1 ) )
      = ( X1 = Y1 ) ) )).

% process_term.inject(1)
thf(fact_2_guarded__def,axiom,(
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( proces1121166967uarded @ A @ B @ C )
      = ( ^ [Sys: ( A > ( proces554692349s_term @ B @ C ) )] :
          ! [X: A,Y: C] :
            ( ( Sys @ X )
           != ( proces1627516585ss_VAR @ C @ B @ Y ) ) ) ) )).

% guarded_def
thf(fact_3_process__term_Opred__inject_I1_J,axiom,(
    ! [A: $tType,Pvar: $tType,P1: ( A > $o ),P2: ( Pvar > $o ),A2: Pvar] :
      ( ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ ( proces1627516585ss_VAR @ Pvar @ A @ A2 ) )
      = ( P2 @ A2 ) ) )).

% process_term.pred_inject(1)
thf(fact_4_process__term_Osimps_I21_J,axiom,(
    ! [A: $tType,D: $tType,Pvar: $tType,F1: ( Pvar > D ),F2: ( ( proces634752977rocess @ A ) > D ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ),X1: Pvar] :
      ( ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) )
      = ( F1 @ X1 ) ) )).

% process_term.simps(21)
thf(fact_5_process__term_Osimps_I17_J,axiom,(
    ! [A: $tType,B: $tType,Pvar: $tType,F1: ( Pvar > B ),F2: ( ( proces634752977rocess @ A ) > B ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > B ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > B ),X1: Pvar] :
      ( ( proces460752237s_term @ Pvar @ B @ A @ F1 @ F2 @ F3 @ F4 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) )
      = ( F1 @ X1 ) ) )).

% process_term.simps(17)
thf(fact_6_process__term_Oset__intros_I6_J,axiom,(
    ! [A: $tType,Pvar: $tType,Ab: Pvar] :
      ( member @ Pvar @ Ab @ ( proces1493547885s_term @ A @ Pvar @ ( proces1627516585ss_VAR @ Pvar @ A @ Ab ) ) ) )).

% process_term.set_intros(6)
thf(fact_7_process__term_Osimps_I25_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Pvar: $tType,F1: ( A > B ),F2: ( Pvar > C ),X1: Pvar] :
      ( ( proces224683037s_term @ A @ B @ Pvar @ C @ F1 @ F2 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) )
      = ( proces1627516585ss_VAR @ C @ B @ ( F2 @ X1 ) ) ) )).

% process_term.simps(25)
thf(fact_8_isACT_Osimps_I3_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,Sys2: ( A > ( proces554692349s_term @ B @ C ) ),A2: D,T2: ( proces554692349s_term @ D @ A )] :
      ( proces687458811_isACT @ A @ B @ C @ D @ Sys2 @ ( proces1454156180ss_ACT @ D @ A @ A2 @ T2 ) ) )).

% isACT.simps(3)
thf(fact_9_isACT_Osimps_I4_J,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,Sys2: ( A > ( proces554692349s_term @ B @ C ) ),T1: ( proces554692349s_term @ D @ A ),T22: ( proces554692349s_term @ D @ A )] :
      ~ ( proces687458811_isACT @ A @ B @ C @ D @ Sys2 @ ( proces89589571ess_CH @ D @ A @ T1 @ T22 ) ) )).

% isACT.simps(4)
thf(fact_10_process__term_Odistinct_I3_J,axiom,(
    ! [Pvar: $tType,A: $tType,X1: Pvar,X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1627516585ss_VAR @ Pvar @ A @ X1 )
     != ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) ) )).

% process_term.distinct(3)
thf(fact_11_process__term_Odistinct_I5_J,axiom,(
    ! [Pvar: $tType,A: $tType,X1: Pvar,X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1627516585ss_VAR @ Pvar @ A @ X1 )
     != ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) ) )).

% process_term.distinct(5)
thf(fact_12_process__term_Odistinct_I1_J,axiom,(
    ! [Pvar: $tType,A: $tType,X1: Pvar,X2: ( proces634752977rocess @ A )] :
      ( ( proces1627516585ss_VAR @ Pvar @ A @ X1 )
     != ( proces1062592052s_PROC @ A @ Pvar @ X2 ) ) )).

% process_term.distinct(1)
thf(fact_13_process__term_Orel__inject_I1_J,axiom,(
    ! [B: $tType,A: $tType,Pvar: $tType,C: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X1: Pvar,Y1: C] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) @ ( proces1627516585ss_VAR @ C @ B @ Y1 ) )
      = ( R2 @ X1 @ Y1 ) ) )).

% process_term.rel_inject(1)
thf(fact_14_process__term_Oinject_I2_J,axiom,(
    ! [Pvar: $tType,A: $tType,X2: ( proces634752977rocess @ A ),Y2: ( proces634752977rocess @ A )] :
      ( ( ( proces1062592052s_PROC @ A @ Pvar @ X2 )
        = ( proces1062592052s_PROC @ A @ Pvar @ Y2 ) )
      = ( X2 = Y2 ) ) )).

% process_term.inject(2)
thf(fact_15_process__term_Oinject_I4_J,axiom,(
    ! [Pvar: $tType,A: $tType,X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar ),Y41: ( proces554692349s_term @ A @ Pvar ),Y42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 )
        = ( proces89589571ess_CH @ A @ Pvar @ Y41 @ Y42 ) )
      = ( ( X41 = Y41 )
        & ( X42 = Y42 ) ) ) )).

% process_term.inject(4)
thf(fact_16_process__term_Oinject_I3_J,axiom,(
    ! [Pvar: $tType,A: $tType,X31: A,X32: ( proces554692349s_term @ A @ Pvar ),Y31: A,Y32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 )
        = ( proces1454156180ss_ACT @ A @ Pvar @ Y31 @ Y32 ) )
      = ( ( X31 = Y31 )
        & ( X32 = Y32 ) ) ) )).

% process_term.inject(3)
thf(fact_17_process__term_Opred__inject_I4_J,axiom,(
    ! [Pvar: $tType,A: $tType,P1: ( A > $o ),P2: ( Pvar > $o ),A2: ( proces554692349s_term @ A @ Pvar ),Aa2: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ ( proces89589571ess_CH @ A @ Pvar @ A2 @ Aa2 ) )
      = ( ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ A2 )
        & ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ Aa2 ) ) ) )).

% process_term.pred_inject(4)
thf(fact_18_process__term_Opred__inject_I3_J,axiom,(
    ! [Pvar: $tType,A: $tType,P1: ( A > $o ),P2: ( Pvar > $o ),A2: A,Aa2: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ ( proces1454156180ss_ACT @ A @ Pvar @ A2 @ Aa2 ) )
      = ( ( P1 @ A2 )
        & ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ Aa2 ) ) ) )).

% process_term.pred_inject(3)
thf(fact_19_process__term_Osimps_I51_J,axiom,(
    ! [Pvar: $tType,A: $tType,X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1493547885s_term @ A @ Pvar @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) )
      = ( proces1493547885s_term @ A @ Pvar @ X32 ) ) )).

% process_term.simps(51)
thf(fact_20_process__term_Osimps_I28_J,axiom,(
    ! [C: $tType,B: $tType,Pvar: $tType,A: $tType,F1: ( A > B ),F2: ( Pvar > C ),X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces224683037s_term @ A @ B @ Pvar @ C @ F1 @ F2 @ ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) )
      = ( proces89589571ess_CH @ B @ C @ ( proces224683037s_term @ A @ B @ Pvar @ C @ F1 @ F2 @ X41 ) @ ( proces224683037s_term @ A @ B @ Pvar @ C @ F1 @ F2 @ X42 ) ) ) )).

% process_term.simps(28)
thf(fact_21_process__term_Osimps_I27_J,axiom,(
    ! [C: $tType,B: $tType,Pvar: $tType,A: $tType,F1: ( A > B ),F2: ( Pvar > C ),X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces224683037s_term @ A @ B @ Pvar @ C @ F1 @ F2 @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) )
      = ( proces1454156180ss_ACT @ B @ C @ ( F1 @ X31 ) @ ( proces224683037s_term @ A @ B @ Pvar @ C @ F1 @ F2 @ X32 ) ) ) )).

% process_term.simps(27)
thf(fact_22_process__term_Osimps_I24_J,axiom,(
    ! [D: $tType,Pvar: $tType,A: $tType,F1: ( Pvar > D ),F2: ( ( proces634752977rocess @ A ) > D ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ),X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) )
      = ( F4 @ X41 @ X42 @ ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ X41 ) @ ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ X42 ) ) ) )).

% process_term.simps(24)
thf(fact_23_process__term_Osimps_I23_J,axiom,(
    ! [D: $tType,Pvar: $tType,A: $tType,F1: ( Pvar > D ),F2: ( ( proces634752977rocess @ A ) > D ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ),X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) )
      = ( F3 @ X31 @ X32 @ ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ X32 ) ) ) )).

% process_term.simps(23)
thf(fact_24_process__term_Osimps_I22_J,axiom,(
    ! [Pvar: $tType,D: $tType,A: $tType,F1: ( Pvar > D ),F2: ( ( proces634752977rocess @ A ) > D ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ),X2: ( proces634752977rocess @ A )] :
      ( ( proces2117273769s_term @ Pvar @ D @ A @ F1 @ F2 @ F3 @ F4 @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) )
      = ( F2 @ X2 ) ) )).

% process_term.simps(22)
thf(fact_25_process__term_Osimps_I20_J,axiom,(
    ! [B: $tType,Pvar: $tType,A: $tType,F1: ( Pvar > B ),F2: ( ( proces634752977rocess @ A ) > B ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > B ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > B ),X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces460752237s_term @ Pvar @ B @ A @ F1 @ F2 @ F3 @ F4 @ ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) )
      = ( F4 @ X41 @ X42 ) ) )).

% process_term.simps(20)
thf(fact_26_process__term_Osimps_I19_J,axiom,(
    ! [B: $tType,Pvar: $tType,A: $tType,F1: ( Pvar > B ),F2: ( ( proces634752977rocess @ A ) > B ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > B ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > B ),X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces460752237s_term @ Pvar @ B @ A @ F1 @ F2 @ F3 @ F4 @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) )
      = ( F3 @ X31 @ X32 ) ) )).

% process_term.simps(19)
thf(fact_27_process__term_Osimps_I18_J,axiom,(
    ! [Pvar: $tType,B: $tType,A: $tType,F1: ( Pvar > B ),F2: ( ( proces634752977rocess @ A ) > B ),F3: ( A > ( proces554692349s_term @ A @ Pvar ) > B ),F4: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > B ),X2: ( proces634752977rocess @ A )] :
      ( ( proces460752237s_term @ Pvar @ B @ A @ F1 @ F2 @ F3 @ F4 @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) )
      = ( F2 @ X2 ) ) )).

% process_term.simps(18)
thf(fact_28_process__term_Odistinct_I11_J,axiom,(
    ! [Pvar: $tType,A: $tType,X31: A,X32: ( proces554692349s_term @ A @ Pvar ),X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 )
     != ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) ) )).

% process_term.distinct(11)
thf(fact_29_process__term_Odistinct_I9_J,axiom,(
    ! [Pvar: $tType,A: $tType,X2: ( proces634752977rocess @ A ),X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1062592052s_PROC @ A @ Pvar @ X2 )
     != ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) ) )).

% process_term.distinct(9)
thf(fact_30_process__term_Odistinct_I7_J,axiom,(
    ! [Pvar: $tType,A: $tType,X2: ( proces634752977rocess @ A ),X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1062592052s_PROC @ A @ Pvar @ X2 )
     != ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) ) )).

% process_term.distinct(7)
thf(fact_31_process__term_Oset__cases_I2_J,axiom,(
    ! [Pvar: $tType,A: $tType,E: Pvar,A2: ( proces554692349s_term @ A @ Pvar )] :
      ( ( member @ Pvar @ E @ ( proces1493547885s_term @ A @ Pvar @ A2 ) )
     => ( ( A2
         != ( proces1627516585ss_VAR @ Pvar @ A @ E ) )
       => ( ! [Z1: A,Z2: ( proces554692349s_term @ A @ Pvar )] :
              ( ( A2
                = ( proces1454156180ss_ACT @ A @ Pvar @ Z1 @ Z2 ) )
             => ~ ( member @ Pvar @ E @ ( proces1493547885s_term @ A @ Pvar @ Z2 ) ) )
         => ( ! [Z1: ( proces554692349s_term @ A @ Pvar )] :
                ( ? [Z2: ( proces554692349s_term @ A @ Pvar )] :
                    ( A2
                    = ( proces89589571ess_CH @ A @ Pvar @ Z1 @ Z2 ) )
               => ~ ( member @ Pvar @ E @ ( proces1493547885s_term @ A @ Pvar @ Z1 ) ) )
           => ~ ( ! [Z1: ( proces554692349s_term @ A @ Pvar ),Z2: ( proces554692349s_term @ A @ Pvar )] :
                    ( ( A2
                      = ( proces89589571ess_CH @ A @ Pvar @ Z1 @ Z2 ) )
                   => ~ ( member @ Pvar @ E @ ( proces1493547885s_term @ A @ Pvar @ Z2 ) ) ) ) ) ) ) ) )).

% process_term.set_cases(2)
thf(fact_32_process__term_Orel__inject_I4_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X41: ( proces554692349s_term @ A @ Pvar ),X42: ( proces554692349s_term @ A @ Pvar ),Y41: ( proces554692349s_term @ B @ C ),Y42: ( proces554692349s_term @ B @ C )] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) @ ( proces89589571ess_CH @ B @ C @ Y41 @ Y42 ) )
      = ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X41 @ Y41 )
        & ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X42 @ Y42 ) ) ) )).

% process_term.rel_inject(4)
thf(fact_33_process__term_Orel__inject_I3_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X31: A,X32: ( proces554692349s_term @ A @ Pvar ),Y31: B,Y32: ( proces554692349s_term @ B @ C )] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) @ ( proces1454156180ss_ACT @ B @ C @ Y31 @ Y32 ) )
      = ( ( R1 @ X31 @ Y31 )
        & ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X32 @ Y32 ) ) ) )).

% process_term.rel_inject(3)
thf(fact_34_process__term_Orel__intros_I4_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X41: ( proces554692349s_term @ A @ Pvar ),Y41: ( proces554692349s_term @ B @ C ),X42: ( proces554692349s_term @ A @ Pvar ),Y42: ( proces554692349s_term @ B @ C )] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X41 @ Y41 )
     => ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X42 @ Y42 )
       => ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces89589571ess_CH @ A @ Pvar @ X41 @ X42 ) @ ( proces89589571ess_CH @ B @ C @ Y41 @ Y42 ) ) ) ) )).

% process_term.rel_intros(4)
thf(fact_35_process__term_Orel__intros_I3_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),X31: A,Y31: B,R2: ( Pvar > C > $o ),X32: ( proces554692349s_term @ A @ Pvar ),Y32: ( proces554692349s_term @ B @ C )] :
      ( ( R1 @ X31 @ Y31 )
     => ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X32 @ Y32 )
       => ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) @ ( proces1454156180ss_ACT @ B @ C @ Y31 @ Y32 ) ) ) ) )).

% process_term.rel_intros(3)
thf(fact_36_process__term_Oset__intros_I9_J,axiom,(
    ! [Pvar: $tType,A: $tType,Xm: Pvar,A2c: ( proces554692349s_term @ A @ Pvar ),A1c: ( proces554692349s_term @ A @ Pvar )] :
      ( ( member @ Pvar @ Xm @ ( proces1493547885s_term @ A @ Pvar @ A2c ) )
     => ( member @ Pvar @ Xm @ ( proces1493547885s_term @ A @ Pvar @ ( proces89589571ess_CH @ A @ Pvar @ A1c @ A2c ) ) ) ) )).

% process_term.set_intros(9)
thf(fact_37_process__term_Oset__intros_I8_J,axiom,(
    ! [Pvar: $tType,A: $tType,Xk: Pvar,A1c: ( proces554692349s_term @ A @ Pvar ),A2c: ( proces554692349s_term @ A @ Pvar )] :
      ( ( member @ Pvar @ Xk @ ( proces1493547885s_term @ A @ Pvar @ A1c ) )
     => ( member @ Pvar @ Xk @ ( proces1493547885s_term @ A @ Pvar @ ( proces89589571ess_CH @ A @ Pvar @ A1c @ A2c ) ) ) ) )).

% process_term.set_intros(8)
thf(fact_38_process__term_Oset__intros_I7_J,axiom,(
    ! [Pvar: $tType,A: $tType,Xi: Pvar,A2b: ( proces554692349s_term @ A @ Pvar ),A1b: A] :
      ( ( member @ Pvar @ Xi @ ( proces1493547885s_term @ A @ Pvar @ A2b ) )
     => ( member @ Pvar @ Xi @ ( proces1493547885s_term @ A @ Pvar @ ( proces1454156180ss_ACT @ A @ Pvar @ A1b @ A2b ) ) ) ) )).

% process_term.set_intros(7)
thf(fact_39_process__term_Orel__distinct_I12_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y41: ( proces554692349s_term @ A @ B ),Y42: ( proces554692349s_term @ A @ B ),X31: C,X32: ( proces554692349s_term @ C @ D )] :
      ~ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ ( proces89589571ess_CH @ A @ B @ Y41 @ Y42 ) @ ( proces1454156180ss_ACT @ C @ D @ X31 @ X32 ) ) )).

% process_term.rel_distinct(12)
thf(fact_40_process__term_Orel__distinct_I11_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X31: A,X32: ( proces554692349s_term @ A @ Pvar ),Y41: ( proces554692349s_term @ B @ C ),Y42: ( proces554692349s_term @ B @ C )] :
      ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) @ ( proces89589571ess_CH @ B @ C @ Y41 @ Y42 ) ) )).

% process_term.rel_distinct(11)
thf(fact_41_process__term_Orel__distinct_I10_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y41: ( proces554692349s_term @ A @ B ),Y42: ( proces554692349s_term @ A @ B ),X2: ( proces634752977rocess @ C )] :
      ~ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ ( proces89589571ess_CH @ A @ B @ Y41 @ Y42 ) @ ( proces1062592052s_PROC @ C @ D @ X2 ) ) )).

% process_term.rel_distinct(10)
thf(fact_42_process__term_Orel__distinct_I9_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X2: ( proces634752977rocess @ A ),Y41: ( proces554692349s_term @ B @ C ),Y42: ( proces554692349s_term @ B @ C )] :
      ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) @ ( proces89589571ess_CH @ B @ C @ Y41 @ Y42 ) ) )).

% process_term.rel_distinct(9)
thf(fact_43_process__term_Orel__distinct_I8_J,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y31: A,Y32: ( proces554692349s_term @ A @ B ),X2: ( proces634752977rocess @ C )] :
      ~ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ ( proces1454156180ss_ACT @ A @ B @ Y31 @ Y32 ) @ ( proces1062592052s_PROC @ C @ D @ X2 ) ) )).

% process_term.rel_distinct(8)
thf(fact_44_mem__Collect__eq,axiom,(
    ! [A: $tType,A2: A,P: ( A > $o )] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) )).

% mem_Collect_eq
thf(fact_45_Collect__mem__eq,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( collect @ A
        @ ^ [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = A3 ) )).

% Collect_mem_eq
thf(fact_46_Collect__cong,axiom,(
    ! [A: $tType,P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( P @ X4 )
          = ( Q @ X4 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) )).

% Collect_cong
thf(fact_47_ext,axiom,(
    ! [B: $tType,A: $tType,F: ( A > B ),G: ( A > B )] :
      ( ! [X4: A] :
          ( ( F @ X4 )
          = ( G @ X4 ) )
     => ( F = G ) ) )).

% ext
thf(fact_48_process__term_Orel__distinct_I7_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X2: ( proces634752977rocess @ A ),Y31: B,Y32: ( proces554692349s_term @ B @ C )] :
      ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) @ ( proces1454156180ss_ACT @ B @ C @ Y31 @ Y32 ) ) )).

% process_term.rel_distinct(7)
thf(fact_49_CH2_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > ( proces554692349s_term @ B @ A ) ) > ( proces554692349s_term @ B @ A ) > $o ),A0: ( A > ( proces554692349s_term @ B @ A ) ),A1: ( proces554692349s_term @ B @ A )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),X5: A] :
          ( P @ Sys3 @ ( proces1627516585ss_VAR @ A @ B @ X5 ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),P3: ( proces634752977rocess @ B )] :
            ( P @ Sys3 @ ( proces1062592052s_PROC @ B @ A @ P3 ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),T12: ( proces554692349s_term @ B @ A ),T23: ( proces554692349s_term @ B @ A )] :
              ( P @ Sys3 @ ( proces89589571ess_CH @ B @ A @ T12 @ T23 ) )
         => ( ! [A4: ( A > ( proces554692349s_term @ B @ A ) ),V: B,Va: ( proces554692349s_term @ B @ A )] :
                ( P @ A4 @ ( proces1454156180ss_ACT @ B @ A @ V @ Va ) )
           => ( P @ A0 @ A1 ) ) ) ) ) )).

% CH2.induct
thf(fact_50_CONT_Oinduct,axiom,(
    ! [A: $tType,B: $tType,P: ( ( A > ( proces554692349s_term @ B @ A ) ) > ( proces554692349s_term @ B @ A ) > $o ),A0: ( A > ( proces554692349s_term @ B @ A ) ),A1: ( proces554692349s_term @ B @ A )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),X5: A] :
          ( P @ Sys3 @ ( proces1627516585ss_VAR @ A @ B @ X5 ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),P3: ( proces634752977rocess @ B )] :
            ( P @ Sys3 @ ( proces1062592052s_PROC @ B @ A @ P3 ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),A4: B,T3: ( proces554692349s_term @ B @ A )] :
              ( P @ Sys3 @ ( proces1454156180ss_ACT @ B @ A @ A4 @ T3 ) )
         => ( ! [A4: ( A > ( proces554692349s_term @ B @ A ) ),V: ( proces554692349s_term @ B @ A ),Va: ( proces554692349s_term @ B @ A )] :
                ( P @ A4 @ ( proces89589571ess_CH @ B @ A @ V @ Va ) )
           => ( P @ A0 @ A1 ) ) ) ) ) )).

% CONT.induct
thf(fact_51_PREF_Oinduct,axiom,(
    ! [C: $tType,A: $tType,B: $tType,P: ( ( A > ( proces554692349s_term @ B @ C ) ) > ( proces554692349s_term @ B @ A ) > $o ),A0: ( A > ( proces554692349s_term @ B @ C ) ),A1: ( proces554692349s_term @ B @ A )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),X5: A] :
          ( P @ Sys3 @ ( proces1627516585ss_VAR @ A @ B @ X5 ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),P3: ( proces634752977rocess @ B )] :
            ( P @ Sys3 @ ( proces1062592052s_PROC @ B @ A @ P3 ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),A4: B,T3: ( proces554692349s_term @ B @ A )] :
              ( P @ Sys3 @ ( proces1454156180ss_ACT @ B @ A @ A4 @ T3 ) )
         => ( ! [A4: ( A > ( proces554692349s_term @ B @ C ) ),V: ( proces554692349s_term @ B @ A ),Va: ( proces554692349s_term @ B @ A )] :
                ( P @ A4 @ ( proces89589571ess_CH @ B @ A @ V @ Va ) )
           => ( P @ A0 @ A1 ) ) ) ) ) )).

% PREF.induct
thf(fact_52_isACT_Oinduct,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,P: ( ( A > ( proces554692349s_term @ B @ C ) ) > ( proces554692349s_term @ D @ A ) > $o ),A0: ( A > ( proces554692349s_term @ B @ C ) ),A1: ( proces554692349s_term @ D @ A )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),X5: A] :
          ( P @ Sys3 @ ( proces1627516585ss_VAR @ A @ D @ X5 ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),P3: ( proces634752977rocess @ D )] :
            ( P @ Sys3 @ ( proces1062592052s_PROC @ D @ A @ P3 ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),A4: D,T3: ( proces554692349s_term @ D @ A )] :
              ( P @ Sys3 @ ( proces1454156180ss_ACT @ D @ A @ A4 @ T3 ) )
         => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),T12: ( proces554692349s_term @ D @ A ),T23: ( proces554692349s_term @ D @ A )] :
                ( P @ Sys3 @ ( proces89589571ess_CH @ D @ A @ T12 @ T23 ) )
           => ( P @ A0 @ A1 ) ) ) ) ) )).

% isACT.induct
thf(fact_53_process__term_Oinduct,axiom,(
    ! [Pvar: $tType,A: $tType,P: ( ( proces554692349s_term @ A @ Pvar ) > $o ),Process_term: ( proces554692349s_term @ A @ Pvar )] :
      ( ! [X4: Pvar] :
          ( P @ ( proces1627516585ss_VAR @ Pvar @ A @ X4 ) )
     => ( ! [X4: ( proces634752977rocess @ A )] :
            ( P @ ( proces1062592052s_PROC @ A @ Pvar @ X4 ) )
       => ( ! [X1a: A,X2a: ( proces554692349s_term @ A @ Pvar )] :
              ( ( P @ X2a )
             => ( P @ ( proces1454156180ss_ACT @ A @ Pvar @ X1a @ X2a ) ) )
         => ( ! [X1a: ( proces554692349s_term @ A @ Pvar ),X2a: ( proces554692349s_term @ A @ Pvar )] :
                ( ( P @ X1a )
               => ( ( P @ X2a )
                 => ( P @ ( proces89589571ess_CH @ A @ Pvar @ X1a @ X2a ) ) ) )
           => ( P @ Process_term ) ) ) ) ) )).

% process_term.induct
thf(fact_54_process__term_Oexhaust,axiom,(
    ! [Pvar: $tType,A: $tType,Y3: ( proces554692349s_term @ A @ Pvar )] :
      ( ! [X12: Pvar] :
          ( Y3
         != ( proces1627516585ss_VAR @ Pvar @ A @ X12 ) )
     => ( ! [X22: ( proces634752977rocess @ A )] :
            ( Y3
           != ( proces1062592052s_PROC @ A @ Pvar @ X22 ) )
       => ( ! [X312: A,X322: ( proces554692349s_term @ A @ Pvar )] :
              ( Y3
             != ( proces1454156180ss_ACT @ A @ Pvar @ X312 @ X322 ) )
         => ~ ( ! [X412: ( proces554692349s_term @ A @ Pvar ),X422: ( proces554692349s_term @ A @ Pvar )] :
                  ( Y3
                 != ( proces89589571ess_CH @ A @ Pvar @ X412 @ X422 ) ) ) ) ) ) )).

% process_term.exhaust
thf(fact_55_process__term_Orel__eq,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( proces2029722208s_term @ A @ A @ B @ B
        @ ^ [Y4: A,Z: A] : ( Y4 = Z )
        @ ^ [Y4: B,Z: B] : ( Y4 = Z ) )
      = ( ^ [Y4: ( proces554692349s_term @ A @ B ),Z: ( proces554692349s_term @ A @ B )] : ( Y4 = Z ) ) ) )).

% process_term.rel_eq
thf(fact_56_process__term_Orel__refl,axiom,(
    ! [D: $tType,C: $tType,R1a: ( C > C > $o ),R2a: ( D > D > $o ),X6: ( proces554692349s_term @ C @ D )] :
      ( ! [X4: C] :
          ( R1a @ X4 @ X4 )
     => ( ! [X4: D] :
            ( R2a @ X4 @ X4 )
       => ( proces2029722208s_term @ C @ C @ D @ D @ R1a @ R2a @ X6 @ X6 ) ) ) )).

% process_term.rel_refl
thf(fact_57_process__term_Orel__distinct_I1_J,axiom,(
    ! [Pvar: $tType,A: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X1: Pvar,Y2: ( proces634752977rocess @ B )] :
      ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) @ ( proces1062592052s_PROC @ B @ C @ Y2 ) ) )).

% process_term.rel_distinct(1)
thf(fact_58_process__term_Orel__distinct_I2_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y2: ( proces634752977rocess @ A ),X1: D] :
      ~ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ ( proces1062592052s_PROC @ A @ B @ Y2 ) @ ( proces1627516585ss_VAR @ D @ C @ X1 ) ) )).

% process_term.rel_distinct(2)
thf(fact_59_process__term_Orel__distinct_I5_J,axiom,(
    ! [Pvar: $tType,A: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X1: Pvar,Y41: ( proces554692349s_term @ B @ C ),Y42: ( proces554692349s_term @ B @ C )] :
      ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) @ ( proces89589571ess_CH @ B @ C @ Y41 @ Y42 ) ) )).

% process_term.rel_distinct(5)
thf(fact_60_process__term_Orel__distinct_I6_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y41: ( proces554692349s_term @ A @ B ),Y42: ( proces554692349s_term @ A @ B ),X1: D] :
      ~ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ ( proces89589571ess_CH @ A @ B @ Y41 @ Y42 ) @ ( proces1627516585ss_VAR @ D @ C @ X1 ) ) )).

% process_term.rel_distinct(6)
thf(fact_61_process__term_Orel__distinct_I3_J,axiom,(
    ! [Pvar: $tType,A: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X1: Pvar,Y31: B,Y32: ( proces554692349s_term @ B @ C )] :
      ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) @ ( proces1454156180ss_ACT @ B @ C @ Y31 @ Y32 ) ) )).

% process_term.rel_distinct(3)
thf(fact_62_process__term_Orel__distinct_I4_J,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),Y31: A,Y32: ( proces554692349s_term @ A @ B ),X1: D] :
      ~ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ ( proces1454156180ss_ACT @ A @ B @ Y31 @ Y32 ) @ ( proces1627516585ss_VAR @ D @ C @ X1 ) ) )).

% process_term.rel_distinct(4)
thf(fact_63_process__term_Orel__intros_I1_J,axiom,(
    ! [Pvar: $tType,A: $tType,B: $tType,C: $tType,R2: ( Pvar > C > $o ),X1: Pvar,Y1: C,R1: ( A > B > $o )] :
      ( ( R2 @ X1 @ Y1 )
     => ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) @ ( proces1627516585ss_VAR @ C @ B @ Y1 ) ) ) )).

% process_term.rel_intros(1)
thf(fact_64_process__term_Orel__cases,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),A2: ( proces554692349s_term @ A @ Pvar ),B2: ( proces554692349s_term @ B @ C )] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ A2 @ B2 )
     => ( ! [X4: Pvar] :
            ( ( A2
              = ( proces1627516585ss_VAR @ Pvar @ A @ X4 ) )
           => ! [Y5: C] :
                ( ( B2
                  = ( proces1627516585ss_VAR @ C @ B @ Y5 ) )
               => ~ ( R2 @ X4 @ Y5 ) ) )
       => ( ! [Xa: ( proces634752977rocess @ A )] :
              ( ( A2
                = ( proces1062592052s_PROC @ A @ Pvar @ Xa ) )
             => ! [Ya: ( proces634752977rocess @ B )] :
                  ( ( B2
                    = ( proces1062592052s_PROC @ B @ C @ Ya ) )
                 => ~ ( proces749077512rocess @ A @ B @ R1 @ Xa @ Ya ) ) )
         => ( ! [X1a: A,X2a: ( proces554692349s_term @ A @ Pvar )] :
                ( ( A2
                  = ( proces1454156180ss_ACT @ A @ Pvar @ X1a @ X2a ) )
               => ! [Y1a: B,Y2a: ( proces554692349s_term @ B @ C )] :
                    ( ( B2
                      = ( proces1454156180ss_ACT @ B @ C @ Y1a @ Y2a ) )
                   => ( ( R1 @ X1a @ Y1a )
                     => ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X2a @ Y2a ) ) ) )
           => ~ ( ! [X1b: ( proces554692349s_term @ A @ Pvar ),X2b: ( proces554692349s_term @ A @ Pvar )] :
                    ( ( A2
                      = ( proces89589571ess_CH @ A @ Pvar @ X1b @ X2b ) )
                   => ! [Y1b: ( proces554692349s_term @ B @ C ),Y2b: ( proces554692349s_term @ B @ C )] :
                        ( ( B2
                          = ( proces89589571ess_CH @ B @ C @ Y1b @ Y2b ) )
                       => ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X1b @ Y1b )
                         => ~ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X2b @ Y2b ) ) ) ) ) ) ) ) ) )).

% process_term.rel_cases
thf(fact_65_process__term_Orel__induct,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X6: ( proces554692349s_term @ A @ Pvar ),Y3: ( proces554692349s_term @ B @ C ),Q: ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ B @ C ) > $o )] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ X6 @ Y3 )
     => ( ! [A12: Pvar,B1: C] :
            ( ( R2 @ A12 @ B1 )
           => ( Q @ ( proces1627516585ss_VAR @ Pvar @ A @ A12 ) @ ( proces1627516585ss_VAR @ C @ B @ B1 ) ) )
       => ( ! [A22: ( proces634752977rocess @ A ),B22: ( proces634752977rocess @ B )] :
              ( ( proces749077512rocess @ A @ B @ R1 @ A22 @ B22 )
             => ( Q @ ( proces1062592052s_PROC @ A @ Pvar @ A22 ) @ ( proces1062592052s_PROC @ B @ C @ B22 ) ) )
         => ( ! [A31: A,A32: ( proces554692349s_term @ A @ Pvar ),B31: B,B32: ( proces554692349s_term @ B @ C )] :
                ( ( R1 @ A31 @ B31 )
               => ( ( Q @ A32 @ B32 )
                 => ( Q @ ( proces1454156180ss_ACT @ A @ Pvar @ A31 @ A32 ) @ ( proces1454156180ss_ACT @ B @ C @ B31 @ B32 ) ) ) )
           => ( ! [A41: ( proces554692349s_term @ A @ Pvar ),A42: ( proces554692349s_term @ A @ Pvar ),B41: ( proces554692349s_term @ B @ C ),B42: ( proces554692349s_term @ B @ C )] :
                  ( ( Q @ A41 @ B41 )
                 => ( ( Q @ A42 @ B42 )
                   => ( Q @ ( proces89589571ess_CH @ A @ Pvar @ A41 @ A42 ) @ ( proces89589571ess_CH @ B @ C @ B41 @ B42 ) ) ) )
             => ( Q @ X6 @ Y3 ) ) ) ) ) ) )).

% process_term.rel_induct
thf(fact_66_CH2_Ocases,axiom,(
    ! [A: $tType,B: $tType,X6: ( product_prod @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),X5: A] :
          ( X6
         != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1627516585ss_VAR @ A @ B @ X5 ) ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),P3: ( proces634752977rocess @ B )] :
            ( X6
           != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1062592052s_PROC @ B @ A @ P3 ) ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),T12: ( proces554692349s_term @ B @ A ),T23: ( proces554692349s_term @ B @ A )] :
              ( X6
             != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces89589571ess_CH @ B @ A @ T12 @ T23 ) ) )
         => ~ ( ! [A4: ( A > ( proces554692349s_term @ B @ A ) ),V: B,Va: ( proces554692349s_term @ B @ A )] :
                  ( X6
                 != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ A4 @ ( proces1454156180ss_ACT @ B @ A @ V @ Va ) ) ) ) ) ) ) )).

% CH2.cases
thf(fact_67_CONT_Ocases,axiom,(
    ! [A: $tType,B: $tType,X6: ( product_prod @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),X5: A] :
          ( X6
         != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1627516585ss_VAR @ A @ B @ X5 ) ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),P3: ( proces634752977rocess @ B )] :
            ( X6
           != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1062592052s_PROC @ B @ A @ P3 ) ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ A ) ),A4: B,T3: ( proces554692349s_term @ B @ A )] :
              ( X6
             != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1454156180ss_ACT @ B @ A @ A4 @ T3 ) ) )
         => ~ ( ! [A4: ( A > ( proces554692349s_term @ B @ A ) ),V: ( proces554692349s_term @ B @ A ),Va: ( proces554692349s_term @ B @ A )] :
                  ( X6
                 != ( product_Pair @ ( A > ( proces554692349s_term @ B @ A ) ) @ ( proces554692349s_term @ B @ A ) @ A4 @ ( proces89589571ess_CH @ B @ A @ V @ Va ) ) ) ) ) ) ) )).

% CONT.cases
thf(fact_68_PREF_Ocases,axiom,(
    ! [C: $tType,A: $tType,B: $tType,X6: ( product_prod @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ B @ A ) )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),X5: A] :
          ( X6
         != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1627516585ss_VAR @ A @ B @ X5 ) ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),P3: ( proces634752977rocess @ B )] :
            ( X6
           != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1062592052s_PROC @ B @ A @ P3 ) ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),A4: B,T3: ( proces554692349s_term @ B @ A )] :
              ( X6
             != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ B @ A ) @ Sys3 @ ( proces1454156180ss_ACT @ B @ A @ A4 @ T3 ) ) )
         => ~ ( ! [A4: ( A > ( proces554692349s_term @ B @ C ) ),V: ( proces554692349s_term @ B @ A ),Va: ( proces554692349s_term @ B @ A )] :
                  ( X6
                 != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ B @ A ) @ A4 @ ( proces89589571ess_CH @ B @ A @ V @ Va ) ) ) ) ) ) ) )).

% PREF.cases
thf(fact_69_isACT_Ocases,axiom,(
    ! [B: $tType,C: $tType,A: $tType,D: $tType,X6: ( product_prod @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ D @ A ) )] :
      ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),X5: A] :
          ( X6
         != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ D @ A ) @ Sys3 @ ( proces1627516585ss_VAR @ A @ D @ X5 ) ) )
     => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),P3: ( proces634752977rocess @ D )] :
            ( X6
           != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ D @ A ) @ Sys3 @ ( proces1062592052s_PROC @ D @ A @ P3 ) ) )
       => ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),A4: D,T3: ( proces554692349s_term @ D @ A )] :
              ( X6
             != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ D @ A ) @ Sys3 @ ( proces1454156180ss_ACT @ D @ A @ A4 @ T3 ) ) )
         => ~ ( ! [Sys3: ( A > ( proces554692349s_term @ B @ C ) ),T12: ( proces554692349s_term @ D @ A ),T23: ( proces554692349s_term @ D @ A )] :
                  ( X6
                 != ( product_Pair @ ( A > ( proces554692349s_term @ B @ C ) ) @ ( proces554692349s_term @ D @ A ) @ Sys3 @ ( proces89589571ess_CH @ D @ A @ T12 @ T23 ) ) ) ) ) ) ) )).

% isACT.cases
thf(fact_70_process__term_Opred__inject_I2_J,axiom,(
    ! [Pvar: $tType,A: $tType,P1: ( A > $o ),P2: ( Pvar > $o ),A2: ( proces634752977rocess @ A )] :
      ( ( proces2118920028s_term @ A @ Pvar @ P1 @ P2 @ ( proces1062592052s_PROC @ A @ Pvar @ A2 ) )
      = ( proces1205983068rocess @ A @ P1 @ A2 ) ) )).

% process_term.pred_inject(2)
thf(fact_71_process__term_Opred__cong,axiom,(
    ! [B: $tType,A: $tType,X6: ( proces554692349s_term @ A @ B ),Ya2: ( proces554692349s_term @ A @ B ),P1: ( A > $o ),P1a: ( A > $o ),P2: ( B > $o ),P2a: ( B > $o )] :
      ( ( X6 = Ya2 )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ Ya2 ) )
           => ( ( P1 @ Z1 )
              = ( P1a @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ Ya2 ) )
             => ( ( P2 @ Z2 )
                = ( P2a @ Z2 ) ) )
         => ( ( proces2118920028s_term @ A @ B @ P1 @ P2 @ X6 )
            = ( proces2118920028s_term @ A @ B @ P1a @ P2a @ Ya2 ) ) ) ) ) )).

% process_term.pred_cong
thf(fact_72_process__term_Opred__mono__strong,axiom,(
    ! [B: $tType,A: $tType,P1: ( A > $o ),P2: ( B > $o ),X6: ( proces554692349s_term @ A @ B ),P1a: ( A > $o ),P2a: ( B > $o )] :
      ( ( proces2118920028s_term @ A @ B @ P1 @ P2 @ X6 )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ X6 ) )
           => ( ( P1 @ Z1 )
             => ( P1a @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ X6 ) )
             => ( ( P2 @ Z2 )
               => ( P2a @ Z2 ) ) )
         => ( proces2118920028s_term @ A @ B @ P1a @ P2a @ X6 ) ) ) ) )).

% process_term.pred_mono_strong
thf(fact_73_process__term_Omap__cong,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,X6: ( proces554692349s_term @ A @ B ),Ya2: ( proces554692349s_term @ A @ B ),F1: ( A > C ),G1: ( A > C ),F2: ( B > D ),G2: ( B > D )] :
      ( ( X6 = Ya2 )
     => ( ! [Z1: A] :
            ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ Ya2 ) )
           => ( ( F1 @ Z1 )
              = ( G1 @ Z1 ) ) )
       => ( ! [Z2: B] :
              ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ Ya2 ) )
             => ( ( F2 @ Z2 )
                = ( G2 @ Z2 ) ) )
         => ( ( proces224683037s_term @ A @ C @ B @ D @ F1 @ F2 @ X6 )
            = ( proces224683037s_term @ A @ C @ B @ D @ G1 @ G2 @ Ya2 ) ) ) ) ) )).

% process_term.map_cong
thf(fact_74_process_Orel__refl,axiom,(
    ! [B: $tType,Ra: ( B > B > $o ),X6: ( proces634752977rocess @ B )] :
      ( ! [X4: B] :
          ( Ra @ X4 @ X4 )
     => ( proces749077512rocess @ B @ B @ Ra @ X6 @ X6 ) ) )).

% process.rel_refl
thf(fact_75_process_Orel__eq,axiom,(
    ! [A: $tType] :
      ( ( proces749077512rocess @ A @ A
        @ ^ [Y4: A,Z: A] : ( Y4 = Z ) )
      = ( ^ [Y4: ( proces634752977rocess @ A ),Z: ( proces634752977rocess @ A )] : ( Y4 = Z ) ) ) )).

% process.rel_eq
thf(fact_76_process__term_Oset__intros_I4_J,axiom,(
    ! [Pvar: $tType,A: $tType,Xc: A,A1a: ( proces554692349s_term @ A @ Pvar ),A2a: ( proces554692349s_term @ A @ Pvar )] :
      ( ( member @ A @ Xc @ ( proces1264666542s_term @ A @ Pvar @ A1a ) )
     => ( member @ A @ Xc @ ( proces1264666542s_term @ A @ Pvar @ ( proces89589571ess_CH @ A @ Pvar @ A1a @ A2a ) ) ) ) )).

% process_term.set_intros(4)
thf(fact_77_process__term_Oset__intros_I5_J,axiom,(
    ! [Pvar: $tType,A: $tType,Xe: A,A2a: ( proces554692349s_term @ A @ Pvar ),A1a: ( proces554692349s_term @ A @ Pvar )] :
      ( ( member @ A @ Xe @ ( proces1264666542s_term @ A @ Pvar @ A2a ) )
     => ( member @ A @ Xe @ ( proces1264666542s_term @ A @ Pvar @ ( proces89589571ess_CH @ A @ Pvar @ A1a @ A2a ) ) ) ) )).

% process_term.set_intros(5)
thf(fact_78_process__term_Oset__intros_I2_J,axiom,(
    ! [Pvar: $tType,A: $tType,A1: A,A23: ( proces554692349s_term @ A @ Pvar )] :
      ( member @ A @ A1 @ ( proces1264666542s_term @ A @ Pvar @ ( proces1454156180ss_ACT @ A @ Pvar @ A1 @ A23 ) ) ) )).

% process_term.set_intros(2)
thf(fact_79_process__term_Oset__intros_I3_J,axiom,(
    ! [Pvar: $tType,A: $tType,Xa2: A,A23: ( proces554692349s_term @ A @ Pvar ),A1: A] :
      ( ( member @ A @ Xa2 @ ( proces1264666542s_term @ A @ Pvar @ A23 ) )
     => ( member @ A @ Xa2 @ ( proces1264666542s_term @ A @ Pvar @ ( proces1454156180ss_ACT @ A @ Pvar @ A1 @ A23 ) ) ) ) )).

% process_term.set_intros(3)
thf(fact_80_process__term_Orel__intros_I2_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),X2: ( proces634752977rocess @ A ),Y2: ( proces634752977rocess @ B ),R2: ( Pvar > C > $o )] :
      ( ( proces749077512rocess @ A @ B @ R1 @ X2 @ Y2 )
     => ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) @ ( proces1062592052s_PROC @ B @ C @ Y2 ) ) ) )).

% process_term.rel_intros(2)
thf(fact_81_process__term_Orel__inject_I2_J,axiom,(
    ! [C: $tType,Pvar: $tType,A: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o ),X2: ( proces634752977rocess @ A ),Y2: ( proces634752977rocess @ B )] :
      ( ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) @ ( proces1062592052s_PROC @ B @ C @ Y2 ) )
      = ( proces749077512rocess @ A @ B @ R1 @ X2 @ Y2 ) ) )).

% process_term.rel_inject(2)
thf(fact_82_process__term_Orel__refl__strong,axiom,(
    ! [B: $tType,A: $tType,X6: ( proces554692349s_term @ A @ B ),R1a: ( A > A > $o ),R2a: ( B > B > $o )] :
      ( ! [Z1: A] :
          ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ X6 ) )
         => ( R1a @ Z1 @ Z1 ) )
     => ( ! [Z2: B] :
            ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ X6 ) )
           => ( R2a @ Z2 @ Z2 ) )
       => ( proces2029722208s_term @ A @ A @ B @ B @ R1a @ R2a @ X6 @ X6 ) ) ) )).

% process_term.rel_refl_strong
thf(fact_83_process__term_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o ),X6: ( proces554692349s_term @ A @ B ),Y3: ( proces554692349s_term @ C @ D ),R1a: ( A > C > $o ),R2a: ( B > D > $o )] :
      ( ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ X6 @ Y3 )
     => ( ! [Z1: A,Y12: C] :
            ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ X6 ) )
           => ( ( member @ C @ Y12 @ ( proces1264666542s_term @ C @ D @ Y3 ) )
             => ( ( R1 @ Z1 @ Y12 )
               => ( R1a @ Z1 @ Y12 ) ) ) )
       => ( ! [Z2: B,Y22: D] :
              ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ X6 ) )
             => ( ( member @ D @ Y22 @ ( proces1493547885s_term @ C @ D @ Y3 ) )
               => ( ( R2 @ Z2 @ Y22 )
                 => ( R2a @ Z2 @ Y22 ) ) ) )
         => ( proces2029722208s_term @ A @ C @ B @ D @ R1a @ R2a @ X6 @ Y3 ) ) ) ) )).

% process_term.rel_mono_strong
thf(fact_84_process__term_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,X6: ( proces554692349s_term @ A @ B ),Ya2: ( proces554692349s_term @ A @ B ),Y3: ( proces554692349s_term @ C @ D ),Xa2: ( proces554692349s_term @ C @ D ),R1: ( A > C > $o ),R1a: ( A > C > $o ),R2: ( B > D > $o ),R2a: ( B > D > $o )] :
      ( ( X6 = Ya2 )
     => ( ( Y3 = Xa2 )
       => ( ! [Z1: A,Y12: C] :
              ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ Ya2 ) )
             => ( ( member @ C @ Y12 @ ( proces1264666542s_term @ C @ D @ Xa2 ) )
               => ( ( R1 @ Z1 @ Y12 )
                  = ( R1a @ Z1 @ Y12 ) ) ) )
         => ( ! [Z2: B,Y22: D] :
                ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ Ya2 ) )
               => ( ( member @ D @ Y22 @ ( proces1493547885s_term @ C @ D @ Xa2 ) )
                 => ( ( R2 @ Z2 @ Y22 )
                    = ( R2a @ Z2 @ Y22 ) ) ) )
           => ( ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 @ X6 @ Y3 )
              = ( proces2029722208s_term @ A @ C @ B @ D @ R1a @ R2a @ Ya2 @ Xa2 ) ) ) ) ) ) )).

% process_term.rel_cong
thf(fact_85_process__term_Oinj__map__strong,axiom,(
    ! [C: $tType,D: $tType,B: $tType,A: $tType,X6: ( proces554692349s_term @ A @ B ),Xa2: ( proces554692349s_term @ A @ B ),F1: ( A > C ),F1a: ( A > C ),F2: ( B > D ),F2a: ( B > D )] :
      ( ! [Z1: A,Z1a: A] :
          ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ X6 ) )
         => ( ( member @ A @ Z1a @ ( proces1264666542s_term @ A @ B @ Xa2 ) )
           => ( ( ( F1 @ Z1 )
                = ( F1a @ Z1a ) )
             => ( Z1 = Z1a ) ) ) )
     => ( ! [Z2: B,Z2a: B] :
            ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ X6 ) )
           => ( ( member @ B @ Z2a @ ( proces1493547885s_term @ A @ B @ Xa2 ) )
             => ( ( ( F2 @ Z2 )
                  = ( F2a @ Z2a ) )
               => ( Z2 = Z2a ) ) ) )
       => ( ( ( proces224683037s_term @ A @ C @ B @ D @ F1 @ F2 @ X6 )
            = ( proces224683037s_term @ A @ C @ B @ D @ F1a @ F2a @ Xa2 ) )
         => ( X6 = Xa2 ) ) ) ) )).

% process_term.inj_map_strong
thf(fact_86_process__term_Omap__cong0,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,X6: ( proces554692349s_term @ A @ B ),F1: ( A > C ),G1: ( A > C ),F2: ( B > D ),G2: ( B > D )] :
      ( ! [Z1: A] :
          ( ( member @ A @ Z1 @ ( proces1264666542s_term @ A @ B @ X6 ) )
         => ( ( F1 @ Z1 )
            = ( G1 @ Z1 ) ) )
     => ( ! [Z2: B] :
            ( ( member @ B @ Z2 @ ( proces1493547885s_term @ A @ B @ X6 ) )
           => ( ( F2 @ Z2 )
              = ( G2 @ Z2 ) ) )
       => ( ( proces224683037s_term @ A @ C @ B @ D @ F1 @ F2 @ X6 )
          = ( proces224683037s_term @ A @ C @ B @ D @ G1 @ G2 @ X6 ) ) ) ) )).

% process_term.map_cong0
thf(fact_87_old_Oprod_Oinject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B3 ) )
      = ( ( A2 = A5 )
        & ( B2 = B3 ) ) ) )).

% old.prod.inject
thf(fact_88_prod_Oinject,axiom,(
    ! [A: $tType,B: $tType,X1: A,X2: B,Y1: A,Y2: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X2 )
        = ( product_Pair @ A @ B @ Y1 @ Y2 ) )
      = ( ( X1 = Y1 )
        & ( X2 = Y2 ) ) ) )).

% prod.inject
thf(fact_89_process__term_Oset__cases_I1_J,axiom,(
    ! [Pvar: $tType,A: $tType,E: A,A2: ( proces554692349s_term @ A @ Pvar )] :
      ( ( member @ A @ E @ ( proces1264666542s_term @ A @ Pvar @ A2 ) )
     => ( ! [Z3: ( proces634752977rocess @ A )] :
            ( ( A2
              = ( proces1062592052s_PROC @ A @ Pvar @ Z3 ) )
           => ~ ( member @ A @ E @ ( proces1148692671rocess @ A @ Z3 ) ) )
       => ( ! [Z2: ( proces554692349s_term @ A @ Pvar )] :
              ( A2
             != ( proces1454156180ss_ACT @ A @ Pvar @ E @ Z2 ) )
         => ( ! [Z1: A,Z2: ( proces554692349s_term @ A @ Pvar )] :
                ( ( A2
                  = ( proces1454156180ss_ACT @ A @ Pvar @ Z1 @ Z2 ) )
               => ~ ( member @ A @ E @ ( proces1264666542s_term @ A @ Pvar @ Z2 ) ) )
           => ( ! [Z1: ( proces554692349s_term @ A @ Pvar )] :
                  ( ? [Z2: ( proces554692349s_term @ A @ Pvar )] :
                      ( A2
                      = ( proces89589571ess_CH @ A @ Pvar @ Z1 @ Z2 ) )
                 => ~ ( member @ A @ E @ ( proces1264666542s_term @ A @ Pvar @ Z1 ) ) )
             => ~ ( ! [Z1: ( proces554692349s_term @ A @ Pvar ),Z2: ( proces554692349s_term @ A @ Pvar )] :
                      ( ( A2
                        = ( proces89589571ess_CH @ A @ Pvar @ Z1 @ Z2 ) )
                     => ~ ( member @ A @ E @ ( proces1264666542s_term @ A @ Pvar @ Z2 ) ) ) ) ) ) ) ) ) )).

% process_term.set_cases(1)
thf(fact_90_process__term_Opred__set,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( proces2118920028s_term @ A @ B )
      = ( ^ [P12: ( A > $o ),P22: ( B > $o ),X3: ( proces554692349s_term @ A @ B )] :
            ( ! [Y6: A] :
                ( ( member @ A @ Y6 @ ( proces1264666542s_term @ A @ B @ X3 ) )
               => ( P12 @ Y6 ) )
            & ! [Y6: B] :
                ( ( member @ B @ Y6 @ ( proces1493547885s_term @ A @ B @ X3 ) )
               => ( P22 @ Y6 ) ) ) ) ) )).

% process_term.pred_set
thf(fact_91_ssubst__Pair__rhs,axiom,(
    ! [B: $tType,A: $tType,R: A,S: B,R3: ( set @ ( product_prod @ A @ B ) ),S2: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S ) @ R3 )
     => ( ( S2 = S )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R @ S2 ) @ R3 ) ) ) )).

% ssubst_Pair_rhs
thf(fact_92_old_Oprod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),Prod: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P @ Prod ) ) )).

% old.prod.inducts
thf(fact_93_process_Opred__set,axiom,(
    ! [A: $tType] :
      ( ( proces1205983068rocess @ A )
      = ( ^ [P4: ( A > $o ),X3: ( proces634752977rocess @ A )] :
          ! [Y6: A] :
            ( ( member @ A @ Y6 @ ( proces1148692671rocess @ A @ X3 ) )
           => ( P4 @ Y6 ) ) ) ) )).

% process.pred_set
thf(fact_94_process_Orel__cong,axiom,(
    ! [A: $tType,B: $tType,X6: ( proces634752977rocess @ A ),Ya2: ( proces634752977rocess @ A ),Y3: ( proces634752977rocess @ B ),Xa2: ( proces634752977rocess @ B ),R3: ( A > B > $o ),Ra: ( A > B > $o )] :
      ( ( X6 = Ya2 )
     => ( ( Y3 = Xa2 )
       => ( ! [Z3: A,Yb: B] :
              ( ( member @ A @ Z3 @ ( proces1148692671rocess @ A @ Ya2 ) )
             => ( ( member @ B @ Yb @ ( proces1148692671rocess @ B @ Xa2 ) )
               => ( ( R3 @ Z3 @ Yb )
                  = ( Ra @ Z3 @ Yb ) ) ) )
         => ( ( proces749077512rocess @ A @ B @ R3 @ X6 @ Y3 )
            = ( proces749077512rocess @ A @ B @ Ra @ Ya2 @ Xa2 ) ) ) ) ) )).

% process.rel_cong
thf(fact_95_process_Orel__mono__strong,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > B > $o ),X6: ( proces634752977rocess @ A ),Y3: ( proces634752977rocess @ B ),Ra: ( A > B > $o )] :
      ( ( proces749077512rocess @ A @ B @ R3 @ X6 @ Y3 )
     => ( ! [Z3: A,Yb: B] :
            ( ( member @ A @ Z3 @ ( proces1148692671rocess @ A @ X6 ) )
           => ( ( member @ B @ Yb @ ( proces1148692671rocess @ B @ Y3 ) )
             => ( ( R3 @ Z3 @ Yb )
               => ( Ra @ Z3 @ Yb ) ) ) )
       => ( proces749077512rocess @ A @ B @ Ra @ X6 @ Y3 ) ) ) )).

% process.rel_mono_strong
thf(fact_96_process_Orel__refl__strong,axiom,(
    ! [A: $tType,X6: ( proces634752977rocess @ A ),Ra: ( A > A > $o )] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( proces1148692671rocess @ A @ X6 ) )
         => ( Ra @ Z3 @ Z3 ) )
     => ( proces749077512rocess @ A @ A @ Ra @ X6 @ X6 ) ) )).

% process.rel_refl_strong
thf(fact_97_process_Opred__cong,axiom,(
    ! [A: $tType,X6: ( proces634752977rocess @ A ),Ya2: ( proces634752977rocess @ A ),P: ( A > $o ),Pa: ( A > $o )] :
      ( ( X6 = Ya2 )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( proces1148692671rocess @ A @ Ya2 ) )
           => ( ( P @ Z3 )
              = ( Pa @ Z3 ) ) )
       => ( ( proces1205983068rocess @ A @ P @ X6 )
          = ( proces1205983068rocess @ A @ Pa @ Ya2 ) ) ) ) )).

% process.pred_cong
thf(fact_98_process_Opred__mono__strong,axiom,(
    ! [A: $tType,P: ( A > $o ),X6: ( proces634752977rocess @ A ),Pa: ( A > $o )] :
      ( ( proces1205983068rocess @ A @ P @ X6 )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( proces1148692671rocess @ A @ X6 ) )
           => ( ( P @ Z3 )
             => ( Pa @ Z3 ) ) )
       => ( proces1205983068rocess @ A @ Pa @ X6 ) ) ) )).

% process.pred_mono_strong
thf(fact_99_process__term_Osimps_I46_J,axiom,(
    ! [Pvar: $tType,A: $tType,X2: ( proces634752977rocess @ A )] :
      ( ( proces1264666542s_term @ A @ Pvar @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) )
      = ( proces1148692671rocess @ A @ X2 ) ) )).

% process_term.simps(46)
thf(fact_100_process__term_Oset__intros_I1_J,axiom,(
    ! [Pvar: $tType,A: $tType,X6: A,Aa2: ( proces634752977rocess @ A )] :
      ( ( member @ A @ X6 @ ( proces1148692671rocess @ A @ Aa2 ) )
     => ( member @ A @ X6 @ ( proces1264666542s_term @ A @ Pvar @ ( proces1062592052s_PROC @ A @ Pvar @ Aa2 ) ) ) ) )).

% process_term.set_intros(1)
thf(fact_101_surj__pair,axiom,(
    ! [A: $tType,B: $tType,P5: ( product_prod @ A @ B )] :
    ? [X4: A,Y5: B] :
      ( P5
      = ( product_Pair @ A @ B @ X4 @ Y5 ) ) )).

% surj_pair
thf(fact_102_prod__cases,axiom,(
    ! [B: $tType,A: $tType,P: ( ( product_prod @ A @ B ) > $o ),P5: ( product_prod @ A @ B )] :
      ( ! [A4: A,B4: B] :
          ( P @ ( product_Pair @ A @ B @ A4 @ B4 ) )
     => ( P @ P5 ) ) )).

% prod_cases
thf(fact_103_Pair__inject,axiom,(
    ! [A: $tType,B: $tType,A2: A,B2: B,A5: A,B3: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A5 @ B3 ) )
     => ~ ( ( A2 = A5 )
         => ( B2 != B3 ) ) ) )).

% Pair_inject
thf(fact_104_prod__cases3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ~ ( ! [A4: A,B4: B,C2: C] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) ) ) )).

% prod_cases3
thf(fact_105_prod__cases4,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) ) ) )).

% prod_cases4
thf(fact_106_prod__cases5,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E2: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E3: E2] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E2 ) @ C2 @ ( product_Pair @ D @ E2 @ D2 @ E3 ) ) ) ) ) ) )).

% prod_cases5
thf(fact_107_prod__cases6,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E2: $tType,F5: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E3: E2,F6: F5] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E2 @ F5 ) @ D2 @ ( product_Pair @ E2 @ F5 @ E3 @ F6 ) ) ) ) ) ) ) )).

% prod_cases6
thf(fact_108_prod__cases7,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E2: $tType,F5: $tType,G3: $tType,Y3: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) ) )] :
      ~ ( ! [A4: A,B4: B,C2: C,D2: D,E3: E2,F6: F5,G4: G3] :
            ( Y3
           != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) @ D2 @ ( product_Pair @ E2 @ ( product_prod @ F5 @ G3 ) @ E3 @ ( product_Pair @ F5 @ G3 @ F6 @ G4 ) ) ) ) ) ) ) ) )).

% prod_cases7
thf(fact_109_prod__induct3,axiom,(
    ! [C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ C ) )] :
      ( ! [A4: A,B4: B,C2: C] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A4 @ ( product_Pair @ B @ C @ B4 @ C2 ) ) )
     => ( P @ X6 ) ) )).

% prod_induct3
thf(fact_110_prod__induct4,axiom,(
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B4 @ ( product_Pair @ C @ D @ C2 @ D2 ) ) ) )
     => ( P @ X6 ) ) )).

% prod_induct4
thf(fact_111_prod__induct5,axiom,(
    ! [E2: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E3: E2] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E2 ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ E2 ) @ C2 @ ( product_Pair @ D @ E2 @ D2 @ E3 ) ) ) ) )
     => ( P @ X6 ) ) )).

% prod_induct5
thf(fact_112_prod__induct6,axiom,(
    ! [F5: $tType,E2: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E3: E2,F6: F5] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ F5 ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E2 @ F5 ) @ D2 @ ( product_Pair @ E2 @ F5 @ E3 @ F6 ) ) ) ) ) )
     => ( P @ X6 ) ) )).

% prod_induct6
thf(fact_113_prod__induct7,axiom,(
    ! [G3: $tType,F5: $tType,E2: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) ) ) > $o ),X6: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) ) )] :
      ( ! [A4: A,B4: B,C2: C,D2: D,E3: E2,F6: F5,G4: G3] :
          ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) ) @ A4 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) ) @ B4 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) ) @ C2 @ ( product_Pair @ D @ ( product_prod @ E2 @ ( product_prod @ F5 @ G3 ) ) @ D2 @ ( product_Pair @ E2 @ ( product_prod @ F5 @ G3 ) @ E3 @ ( product_Pair @ F5 @ G3 @ F6 @ G4 ) ) ) ) ) ) )
     => ( P @ X6 ) ) )).

% prod_induct7
thf(fact_114_old_Oprod_Oexhaust,axiom,(
    ! [A: $tType,B: $tType,Y3: ( product_prod @ A @ B )] :
      ~ ( ! [A4: A,B4: B] :
            ( Y3
           != ( product_Pair @ A @ B @ A4 @ B4 ) ) ) )).

% old.prod.exhaust
thf(fact_115_old_Oprod_Orec,axiom,(
    ! [A: $tType,T: $tType,B: $tType,F1: ( A > B > T ),A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) )).

% old.prod.rec
thf(fact_116_internal__case__prod__conv,axiom,(
    ! [B: $tType,A: $tType,C: $tType,C3: ( B > C > A ),A2: B,B2: C] :
      ( ( produc2004651681e_prod @ B @ C @ A @ C3 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( C3 @ A2 @ B2 ) ) )).

% internal_case_prod_conv
thf(fact_117_Ball__def,axiom,(
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A6: ( set @ A ),P4: ( A > $o )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ A6 )
           => ( P4 @ X3 ) ) ) ) )).

% Ball_def
thf(fact_118_ball__reg,axiom,(
    ! [A: $tType,R3: ( set @ A ),P: ( A > $o ),Q: ( A > $o )] :
      ( ! [X4: A] :
          ( ( member @ A @ X4 @ R3 )
         => ( ( P @ X4 )
           => ( Q @ X4 ) ) )
     => ( ! [X4: A] :
            ( ( member @ A @ X4 @ R3 )
           => ( P @ X4 ) )
       => ! [X7: A] :
            ( ( member @ A @ X7 @ R3 )
           => ( Q @ X7 ) ) ) ) )).

% ball_reg
thf(fact_119_curry__conv,axiom,(
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( product_curry @ B @ C @ A )
      = ( ^ [F7: ( ( product_prod @ B @ C ) > A ),A7: B,B5: C] :
            ( F7 @ ( product_Pair @ B @ C @ A7 @ B5 ) ) ) ) )).

% curry_conv
thf(fact_120_curryI,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( product_curry @ A @ B @ $o @ F @ A2 @ B2 ) ) )).

% curryI
thf(fact_121_curryD,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryD
thf(fact_122_curryE,axiom,(
    ! [A: $tType,B: $tType,F: ( ( product_prod @ A @ B ) > $o ),A2: A,B2: B] :
      ( ( product_curry @ A @ B @ $o @ F @ A2 @ B2 )
     => ( F @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) )).

% curryE
thf(fact_123_process__term_Octr__transfer_I2_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o )] :
      ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( proces749077512rocess @ A @ B @ R1 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( proces1062592052s_PROC @ A @ Pvar ) @ ( proces1062592052s_PROC @ B @ C ) ) )).

% process_term.ctr_transfer(2)
thf(fact_124_process__term_Osimps_I47_J,axiom,(
    ! [Pvar: $tType,A: $tType,X31: A,X32: ( proces554692349s_term @ A @ Pvar )] :
      ( ( proces1264666542s_term @ A @ Pvar @ ( proces1454156180ss_ACT @ A @ Pvar @ X31 @ X32 ) )
      = ( insert @ A @ X31 @ ( proces1264666542s_term @ A @ Pvar @ X32 ) ) ) )).

% process_term.simps(47)
thf(fact_125_process__term_Osimps_I45_J,axiom,(
    ! [Pvar: $tType,A: $tType,X1: Pvar] :
      ( ( proces1264666542s_term @ A @ Pvar @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) )
      = ( bot_bot @ ( set @ A ) ) ) )).

% process_term.simps(45)
thf(fact_126_process__term_Osimps_I50_J,axiom,(
    ! [A: $tType,Pvar: $tType,X2: ( proces634752977rocess @ A )] :
      ( ( proces1493547885s_term @ A @ Pvar @ ( proces1062592052s_PROC @ A @ Pvar @ X2 ) )
      = ( bot_bot @ ( set @ Pvar ) ) ) )).

% process_term.simps(50)
thf(fact_127_empty__Collect__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( collect @ A @ P ) )
      = ( ! [X3: A] :
            ~ ( P @ X3 ) ) ) )).

% empty_Collect_eq
thf(fact_128_Collect__empty__eq,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ! [X3: A] :
            ~ ( P @ X3 ) ) ) )).

% Collect_empty_eq
thf(fact_129_all__not__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ! [X3: A] :
            ~ ( member @ A @ X3 @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% all_not_in_conv
thf(fact_130_empty__iff,axiom,(
    ! [A: $tType,C3: A] :
      ~ ( member @ A @ C3 @ ( bot_bot @ ( set @ A ) ) ) )).

% empty_iff
thf(fact_131_insert__absorb2,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A )] :
      ( ( insert @ A @ X6 @ ( insert @ A @ X6 @ A3 ) )
      = ( insert @ A @ X6 @ A3 ) ) )).

% insert_absorb2
thf(fact_132_insert__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A3 ) )
      = ( ( A2 = B2 )
        | ( member @ A @ A2 @ A3 ) ) ) )).

% insert_iff
thf(fact_133_insertCI,axiom,(
    ! [A: $tType,A2: A,B6: ( set @ A ),B2: A] :
      ( ( ~ ( member @ A @ A2 @ B6 )
       => ( A2 = B2 ) )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B6 ) ) ) )).

% insertCI
thf(fact_134_singletonI,axiom,(
    ! [A: $tType,A2: A] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% singletonI
thf(fact_135_ball__empty,axiom,(
    ! [A: $tType,P: ( A > $o ),X7: A] :
      ( ( member @ A @ X7 @ ( bot_bot @ ( set @ A ) ) )
     => ( P @ X7 ) ) )).

% ball_empty
thf(fact_136_mk__disjoint__insert,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ? [B7: ( set @ A )] :
          ( ( A3
            = ( insert @ A @ A2 @ B7 ) )
          & ~ ( member @ A @ A2 @ B7 ) ) ) )).

% mk_disjoint_insert
thf(fact_137_singleton__inject,axiom,(
    ! [A: $tType,A2: A,B2: A] :
      ( ( ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( A2 = B2 ) ) )).

% singleton_inject
thf(fact_138_insert__not__empty,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( insert @ A @ A2 @ A3 )
     != ( bot_bot @ ( set @ A ) ) ) )).

% insert_not_empty
thf(fact_139_doubleton__eq__iff,axiom,(
    ! [A: $tType,A2: A,B2: A,C3: A,D3: A] :
      ( ( ( insert @ A @ A2 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
        = ( insert @ A @ C3 @ ( insert @ A @ D3 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ( ( A2 = C3 )
          & ( B2 = D3 ) )
        | ( ( A2 = D3 )
          & ( B2 = C3 ) ) ) ) )).

% doubleton_eq_iff
thf(fact_140_insert__commute,axiom,(
    ! [A: $tType,X6: A,Y3: A,A3: ( set @ A )] :
      ( ( insert @ A @ X6 @ ( insert @ A @ Y3 @ A3 ) )
      = ( insert @ A @ Y3 @ ( insert @ A @ X6 @ A3 ) ) ) )).

% insert_commute
thf(fact_141_singleton__iff,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( B2 = A2 ) ) )).

% singleton_iff
thf(fact_142_insert__eq__iff,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A ),B2: A,B6: ( set @ A )] :
      ( ~ ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ B2 @ B6 )
       => ( ( ( insert @ A @ A2 @ A3 )
            = ( insert @ A @ B2 @ B6 ) )
          = ( ( ( A2 = B2 )
             => ( A3 = B6 ) )
            & ( ( A2 != B2 )
             => ? [C4: ( set @ A )] :
                  ( ( A3
                    = ( insert @ A @ B2 @ C4 ) )
                  & ~ ( member @ A @ B2 @ C4 )
                  & ( B6
                    = ( insert @ A @ A2 @ C4 ) )
                  & ~ ( member @ A @ A2 @ C4 ) ) ) ) ) ) ) )).

% insert_eq_iff
thf(fact_143_insert__absorb,axiom,(
    ! [A: $tType,A2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( insert @ A @ A2 @ A3 )
        = A3 ) ) )).

% insert_absorb
thf(fact_144_insert__ident,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A ),B6: ( set @ A )] :
      ( ~ ( member @ A @ X6 @ A3 )
     => ( ~ ( member @ A @ X6 @ B6 )
       => ( ( ( insert @ A @ X6 @ A3 )
            = ( insert @ A @ X6 @ B6 ) )
          = ( A3 = B6 ) ) ) ) )).

% insert_ident
thf(fact_145_let__rsp,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ R1 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 ) @ R2 )
      @ ^ [S3: A,F7: ( A > C )] :
          ( F7 @ S3 )
      @ ^ [S3: B,F7: ( B > D )] :
          ( F7 @ S3 ) ) )).

% let_rsp
thf(fact_146_singletonD,axiom,(
    ! [A: $tType,B2: A,A2: A] :
      ( ( member @ A @ B2 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( B2 = A2 ) ) )).

% singletonD
thf(fact_147_Set_Oset__insert,axiom,(
    ! [A: $tType,X6: A,A3: ( set @ A )] :
      ( ( member @ A @ X6 @ A3 )
     => ~ ( ! [B7: ( set @ A )] :
              ( ( A3
                = ( insert @ A @ X6 @ B7 ) )
             => ( member @ A @ X6 @ B7 ) ) ) ) )).

% Set.set_insert
thf(fact_148_ex__in__conv,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( ? [X3: A] :
            ( member @ A @ X3 @ A3 ) )
      = ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) )).

% ex_in_conv
thf(fact_149_insertI2,axiom,(
    ! [A: $tType,A2: A,B6: ( set @ A ),B2: A] :
      ( ( member @ A @ A2 @ B6 )
     => ( member @ A @ A2 @ ( insert @ A @ B2 @ B6 ) ) ) )).

% insertI2
thf(fact_150_insertI1,axiom,(
    ! [A: $tType,A2: A,B6: ( set @ A )] :
      ( member @ A @ A2 @ ( insert @ A @ A2 @ B6 ) ) )).

% insertI1
thf(fact_151_equals0I,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ! [Y5: A] :
          ~ ( member @ A @ Y5 @ A3 )
     => ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) )).

% equals0I
thf(fact_152_equals0D,axiom,(
    ! [A: $tType,A3: ( set @ A ),A2: A] :
      ( ( A3
        = ( bot_bot @ ( set @ A ) ) )
     => ~ ( member @ A @ A2 @ A3 ) ) )).

% equals0D
thf(fact_153_insertE,axiom,(
    ! [A: $tType,A2: A,B2: A,A3: ( set @ A )] :
      ( ( member @ A @ A2 @ ( insert @ A @ B2 @ A3 ) )
     => ( ( A2 != B2 )
       => ( member @ A @ A2 @ A3 ) ) ) )).

% insertE
thf(fact_154_emptyE,axiom,(
    ! [A: $tType,A2: A] :
      ~ ( member @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )).

% emptyE
thf(fact_155_process__term_Osimps_I49_J,axiom,(
    ! [A: $tType,Pvar: $tType,X1: Pvar] :
      ( ( proces1493547885s_term @ A @ Pvar @ ( proces1627516585ss_VAR @ Pvar @ A @ X1 ) )
      = ( insert @ Pvar @ X1 @ ( bot_bot @ ( set @ Pvar ) ) ) ) )).

% process_term.simps(49)
thf(fact_156_process__term_Orec__transfer,axiom,(
    ! [Pvar: $tType,D: $tType,A: $tType,B: $tType,E2: $tType,C: $tType,R2: ( Pvar > C > $o ),S4: ( D > E2 > $o ),R1: ( A > B > $o )] :
      ( bNF_rel_fun @ ( Pvar > D ) @ ( C > E2 ) @ ( ( ( proces634752977rocess @ A ) > D ) > ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ) > ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( ( proces634752977rocess @ B ) > E2 ) > ( B > ( proces554692349s_term @ B @ C ) > E2 > E2 ) > ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 > E2 > E2 ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ Pvar @ C @ D @ E2 @ R2 @ S4 ) @ ( bNF_rel_fun @ ( ( proces634752977rocess @ A ) > D ) @ ( ( proces634752977rocess @ B ) > E2 ) @ ( ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ) > ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( B > ( proces554692349s_term @ B @ C ) > E2 > E2 ) > ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 > E2 > E2 ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ D @ E2 @ ( proces749077512rocess @ A @ B @ R1 ) @ S4 ) @ ( bNF_rel_fun @ ( A > ( proces554692349s_term @ A @ Pvar ) > D > D ) @ ( B > ( proces554692349s_term @ B @ C ) > E2 > E2 ) @ ( ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 > E2 > E2 ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ A @ B @ ( ( proces554692349s_term @ A @ Pvar ) > D > D ) @ ( ( proces554692349s_term @ B @ C ) > E2 > E2 ) @ R1 @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( D > D ) @ ( E2 > E2 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ D @ E2 @ D @ E2 @ S4 @ S4 ) ) ) @ ( bNF_rel_fun @ ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D > D > D ) @ ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 > E2 > E2 ) @ ( ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( ( proces554692349s_term @ A @ Pvar ) > D > D > D ) @ ( ( proces554692349s_term @ B @ C ) > E2 > E2 > E2 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( D > D > D ) @ ( E2 > E2 > E2 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ D @ E2 @ ( D > D ) @ ( E2 > E2 ) @ S4 @ ( bNF_rel_fun @ D @ E2 @ D @ E2 @ S4 @ S4 ) ) ) ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ D @ E2 @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ S4 ) ) ) ) @ ( proces2117273769s_term @ Pvar @ D @ A ) @ ( proces2117273769s_term @ C @ E2 @ B ) ) )).

% process_term.rec_transfer
thf(fact_157_process__term_Ocase__transfer,axiom,(
    ! [Pvar: $tType,D: $tType,A: $tType,B: $tType,E2: $tType,C: $tType,R2: ( Pvar > C > $o ),S4: ( D > E2 > $o ),R1: ( A > B > $o )] :
      ( bNF_rel_fun @ ( Pvar > D ) @ ( C > E2 ) @ ( ( ( proces634752977rocess @ A ) > D ) > ( A > ( proces554692349s_term @ A @ Pvar ) > D ) > ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( ( proces634752977rocess @ B ) > E2 ) > ( B > ( proces554692349s_term @ B @ C ) > E2 ) > ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ Pvar @ C @ D @ E2 @ R2 @ S4 ) @ ( bNF_rel_fun @ ( ( proces634752977rocess @ A ) > D ) @ ( ( proces634752977rocess @ B ) > E2 ) @ ( ( A > ( proces554692349s_term @ A @ Pvar ) > D ) > ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( B > ( proces554692349s_term @ B @ C ) > E2 ) > ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ D @ E2 @ ( proces749077512rocess @ A @ B @ R1 ) @ S4 ) @ ( bNF_rel_fun @ ( A > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( B > ( proces554692349s_term @ B @ C ) > E2 ) @ ( ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ A @ B @ ( ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( proces554692349s_term @ B @ C ) > E2 ) @ R1 @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ D @ E2 @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ S4 ) ) @ ( bNF_rel_fun @ ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) > E2 ) @ ( ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( proces554692349s_term @ B @ C ) > E2 ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( ( proces554692349s_term @ A @ Pvar ) > D ) @ ( ( proces554692349s_term @ B @ C ) > E2 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ D @ E2 @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ S4 ) ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ D @ E2 @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ S4 ) ) ) ) @ ( proces460752237s_term @ Pvar @ D @ A ) @ ( proces460752237s_term @ C @ E2 @ B ) ) )).

% process_term.case_transfer
thf(fact_158_process__term_Omap__transfer,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,L: $tType,J: $tType,K: $tType,I: $tType,R1b: ( A > I > $o ),S1d: ( C > K > $o ),R2b: ( B > J > $o ),S2d: ( D > L > $o )] :
      ( bNF_rel_fun @ ( A > C ) @ ( I > K ) @ ( ( B > D ) > ( proces554692349s_term @ A @ B ) > ( proces554692349s_term @ C @ D ) ) @ ( ( J > L ) > ( proces554692349s_term @ I @ J ) > ( proces554692349s_term @ K @ L ) ) @ ( bNF_rel_fun @ A @ I @ C @ K @ R1b @ S1d ) @ ( bNF_rel_fun @ ( B > D ) @ ( J > L ) @ ( ( proces554692349s_term @ A @ B ) > ( proces554692349s_term @ C @ D ) ) @ ( ( proces554692349s_term @ I @ J ) > ( proces554692349s_term @ K @ L ) ) @ ( bNF_rel_fun @ B @ J @ D @ L @ R2b @ S2d ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ B ) @ ( proces554692349s_term @ I @ J ) @ ( proces554692349s_term @ C @ D ) @ ( proces554692349s_term @ K @ L ) @ ( proces2029722208s_term @ A @ I @ B @ J @ R1b @ R2b ) @ ( proces2029722208s_term @ C @ K @ D @ L @ S1d @ S2d ) ) ) @ ( proces224683037s_term @ A @ C @ B @ D ) @ ( proces224683037s_term @ I @ K @ J @ L ) ) )).

% process_term.map_transfer
thf(fact_159_process__term_Octr__transfer_I1_J,axiom,(
    ! [Pvar: $tType,A: $tType,B: $tType,C: $tType,R2: ( Pvar > C > $o ),R1: ( A > B > $o )] :
      ( bNF_rel_fun @ Pvar @ C @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ R2 @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( proces1627516585ss_VAR @ Pvar @ A ) @ ( proces1627516585ss_VAR @ C @ B ) ) )).

% process_term.ctr_transfer(1)
thf(fact_160_the__elem__eq,axiom,(
    ! [A: $tType,X6: A] :
      ( ( the_elem @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) )
      = X6 ) )).

% the_elem_eq
thf(fact_161_rel__funI,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B6: ( C > D > $o ),F: ( A > C ),G: ( B > D )] :
      ( ! [X4: A,Y5: B] :
          ( ( A3 @ X4 @ Y5 )
         => ( B6 @ ( F @ X4 ) @ ( G @ Y5 ) ) )
     => ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B6 @ F @ G ) ) )).

% rel_funI
thf(fact_162_bot__apply,axiom,(
    ! [C: $tType,D: $tType] :
      ( ( bot @ C @ ( type2 @ C ) )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X3: D] :
              ( bot_bot @ C ) ) ) ) )).

% bot_apply
thf(fact_163_is__singletonI,axiom,(
    ! [A: $tType,X6: A] :
      ( is_singleton @ A @ ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% is_singletonI
thf(fact_164_bot__set__def,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( collect @ A @ ( bot_bot @ ( A > $o ) ) ) ) )).

% bot_set_def
thf(fact_165_process_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > B > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ ( ( proces634752977rocess @ A ) > $o ) @ ( ( proces634752977rocess @ B ) > $o )
      @ ( bNF_rel_fun @ A @ B @ $o @ $o @ R3
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
      @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ $o @ $o @ ( proces749077512rocess @ A @ B @ R3 )
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
      @ ( proces1205983068rocess @ A )
      @ ( proces1205983068rocess @ B ) ) )).

% process.pred_transfer
thf(fact_166_process_Orel__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,Sa: ( A > C > $o ),Sc: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > D > $o ) @ ( ( proces634752977rocess @ A ) > ( proces634752977rocess @ B ) > $o ) @ ( ( proces634752977rocess @ C ) > ( proces634752977rocess @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( D > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ Sc
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
      @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ C ) @ ( ( proces634752977rocess @ B ) > $o ) @ ( ( proces634752977rocess @ D ) > $o ) @ ( proces749077512rocess @ A @ C @ Sa )
        @ ( bNF_rel_fun @ ( proces634752977rocess @ B ) @ ( proces634752977rocess @ D ) @ $o @ $o @ ( proces749077512rocess @ B @ D @ Sc )
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
      @ ( proces749077512rocess @ A @ B )
      @ ( proces749077512rocess @ C @ D ) ) )).

% process.rel_transfer
thf(fact_167_process__term_Opred__transfer,axiom,(
    ! [A: $tType,B: $tType,D: $tType,C: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( bNF_rel_fun @ ( A > $o ) @ ( C > $o ) @ ( ( B > $o ) > ( proces554692349s_term @ A @ B ) > $o ) @ ( ( D > $o ) > ( proces554692349s_term @ C @ D ) > $o )
      @ ( bNF_rel_fun @ A @ C @ $o @ $o @ R1
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
      @ ( bNF_rel_fun @ ( B > $o ) @ ( D > $o ) @ ( ( proces554692349s_term @ A @ B ) > $o ) @ ( ( proces554692349s_term @ C @ D ) > $o )
        @ ( bNF_rel_fun @ B @ D @ $o @ $o @ R2
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
        @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ B ) @ ( proces554692349s_term @ C @ D ) @ $o @ $o @ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 )
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
      @ ( proces2118920028s_term @ A @ B )
      @ ( proces2118920028s_term @ C @ D ) ) )).

% process_term.pred_transfer
thf(fact_168_process__term_Orel__transfer,axiom,(
    ! [A: $tType,C: $tType,B: $tType,D: $tType,H: $tType,F5: $tType,G3: $tType,E2: $tType,S1a: ( A > E2 > $o ),S1c: ( C > G3 > $o ),S2a: ( B > F5 > $o ),S2c: ( D > H > $o )] :
      ( bNF_rel_fun @ ( A > C > $o ) @ ( E2 > G3 > $o ) @ ( ( B > D > $o ) > ( proces554692349s_term @ A @ B ) > ( proces554692349s_term @ C @ D ) > $o ) @ ( ( F5 > H > $o ) > ( proces554692349s_term @ E2 @ F5 ) > ( proces554692349s_term @ G3 @ H ) > $o )
      @ ( bNF_rel_fun @ A @ E2 @ ( C > $o ) @ ( G3 > $o ) @ S1a
        @ ( bNF_rel_fun @ C @ G3 @ $o @ $o @ S1c
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
      @ ( bNF_rel_fun @ ( B > D > $o ) @ ( F5 > H > $o ) @ ( ( proces554692349s_term @ A @ B ) > ( proces554692349s_term @ C @ D ) > $o ) @ ( ( proces554692349s_term @ E2 @ F5 ) > ( proces554692349s_term @ G3 @ H ) > $o )
        @ ( bNF_rel_fun @ B @ F5 @ ( D > $o ) @ ( H > $o ) @ S2a
          @ ( bNF_rel_fun @ D @ H @ $o @ $o @ S2c
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ B ) @ ( proces554692349s_term @ E2 @ F5 ) @ ( ( proces554692349s_term @ C @ D ) > $o ) @ ( ( proces554692349s_term @ G3 @ H ) > $o ) @ ( proces2029722208s_term @ A @ E2 @ B @ F5 @ S1a @ S2a )
          @ ( bNF_rel_fun @ ( proces554692349s_term @ C @ D ) @ ( proces554692349s_term @ G3 @ H ) @ $o @ $o @ ( proces2029722208s_term @ C @ G3 @ D @ H @ S1c @ S2c )
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) ) )
      @ ( proces2029722208s_term @ A @ C @ B @ D )
      @ ( proces2029722208s_term @ E2 @ G3 @ F5 @ H ) ) )).

% process_term.rel_transfer
thf(fact_169_process__term_Octr__transfer_I4_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o )] :
      ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) ) @ ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) ) @ ( proces89589571ess_CH @ A @ Pvar ) @ ( proces89589571ess_CH @ B @ C ) ) )).

% process_term.ctr_transfer(4)
thf(fact_170_process__term_Octr__transfer_I3_J,axiom,(
    ! [A: $tType,Pvar: $tType,C: $tType,B: $tType,R1: ( A > B > $o ),R2: ( Pvar > C > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( proces554692349s_term @ A @ Pvar ) > ( proces554692349s_term @ A @ Pvar ) ) @ ( ( proces554692349s_term @ B @ C ) > ( proces554692349s_term @ B @ C ) ) @ R1 @ ( bNF_rel_fun @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( proces554692349s_term @ A @ Pvar ) @ ( proces554692349s_term @ B @ C ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) @ ( proces2029722208s_term @ A @ B @ Pvar @ C @ R1 @ R2 ) ) @ ( proces1454156180ss_ACT @ A @ Pvar ) @ ( proces1454156180ss_ACT @ B @ C ) ) )).

% process_term.ctr_transfer(3)
thf(fact_171_is__singleton__the__elem,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A6: ( set @ A )] :
            ( A6
            = ( insert @ A @ ( the_elem @ A @ A6 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_the_elem
thf(fact_172_is__singletonI_H,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [X4: A,Y5: A] :
            ( ( member @ A @ X4 @ A3 )
           => ( ( member @ A @ Y5 @ A3 )
             => ( X4 = Y5 ) ) )
       => ( is_singleton @ A @ A3 ) ) ) )).

% is_singletonI'
thf(fact_173_bot__fun__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( bot @ B @ ( type2 @ B ) )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X3: A] :
              ( bot_bot @ B ) ) ) ) )).

% bot_fun_def
thf(fact_174_rel__fun__mono_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,Y7: ( A > B > $o ),X8: ( A > B > $o ),A3: ( C > D > $o ),B6: ( C > D > $o ),F: ( A > C ),G: ( B > D )] :
      ( ! [X4: A,Y5: B] :
          ( ( Y7 @ X4 @ Y5 )
         => ( X8 @ X4 @ Y5 ) )
     => ( ! [X4: C,Y5: D] :
            ( ( A3 @ X4 @ Y5 )
           => ( B6 @ X4 @ Y5 ) )
       => ( ( bNF_rel_fun @ A @ B @ C @ D @ X8 @ A3 @ F @ G )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y7 @ B6 @ F @ G ) ) ) ) )).

% rel_fun_mono'
thf(fact_175_rel__fun__mono,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,X8: ( A > B > $o ),A3: ( C > D > $o ),F: ( A > C ),G: ( B > D ),Y7: ( A > B > $o ),B6: ( C > D > $o )] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ X8 @ A3 @ F @ G )
     => ( ! [X4: A,Y5: B] :
            ( ( Y7 @ X4 @ Y5 )
           => ( X8 @ X4 @ Y5 ) )
       => ( ! [X4: C,Y5: D] :
              ( ( A3 @ X4 @ Y5 )
             => ( B6 @ X4 @ Y5 ) )
         => ( bNF_rel_fun @ A @ B @ C @ D @ Y7 @ B6 @ F @ G ) ) ) ) )).

% rel_fun_mono
thf(fact_176_rel__funD,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B6: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X6: A,Y3: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B6 @ F @ G )
     => ( ( A3 @ X6 @ Y3 )
       => ( B6 @ ( F @ X6 ) @ ( G @ Y3 ) ) ) ) )).

% rel_funD
thf(fact_177_is__singletonE,axiom,(
    ! [A: $tType,A3: ( set @ A )] :
      ( ( is_singleton @ A @ A3 )
     => ~ ( ! [X4: A] :
              ( A3
             != ( insert @ A @ X4 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singletonE
thf(fact_178_is__singleton__def,axiom,(
    ! [A: $tType] :
      ( ( is_singleton @ A )
      = ( ^ [A6: ( set @ A )] :
          ? [X3: A] :
            ( A6
            = ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )).

% is_singleton_def
thf(fact_179_Let__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B6: ( C > D > $o )] :
      ( bNF_rel_fun @ A @ B @ ( ( A > C ) > C ) @ ( ( B > D ) > D ) @ A3 @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ C @ D @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B6 ) @ B6 )
      @ ^ [S3: A,F7: ( A > C )] :
          ( F7 @ S3 )
      @ ^ [S3: B,F7: ( B > D )] :
          ( F7 @ S3 ) ) )).

% Let_transfer
thf(fact_180_rel__fun__def__butlast,axiom,(
    ! [B: $tType,D: $tType,C: $tType,E2: $tType,F5: $tType,A: $tType,R3: ( A > B > $o ),S4: ( C > E2 > $o ),T2: ( D > F5 > $o ),F: ( A > C > D ),G: ( B > E2 > F5 )] :
      ( ( bNF_rel_fun @ A @ B @ ( C > D ) @ ( E2 > F5 ) @ R3 @ ( bNF_rel_fun @ C @ E2 @ D @ F5 @ S4 @ T2 ) @ F @ G )
      = ( ! [X3: A,Y6: B] :
            ( ( R3 @ X3 @ Y6 )
           => ( bNF_rel_fun @ C @ E2 @ D @ F5 @ S4 @ T2 @ ( F @ X3 ) @ ( G @ Y6 ) ) ) ) ) )).

% rel_fun_def_butlast
thf(fact_181_If__transfer,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( B > B > B )
      @ ^ [Y4: $o,Z: $o] : ( Y4 = Z )
      @ ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A3 @ ( bNF_rel_fun @ A @ B @ A @ B @ A3 @ A3 ) )
      @ ( if @ A )
      @ ( if @ B ) ) )).

% If_transfer
thf(fact_182_rel__funE,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B6: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X6: A,Y3: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B6 @ F @ G )
     => ( ( A3 @ X6 @ Y3 )
       => ( B6 @ ( F @ X6 ) @ ( G @ Y3 ) ) ) ) )).

% rel_funE
thf(fact_183_rel__funD2,axiom,(
    ! [B: $tType,C: $tType,A: $tType,A3: ( A > A > $o ),B6: ( B > C > $o ),F: ( A > B ),G: ( A > C ),X6: A] :
      ( ( bNF_rel_fun @ A @ A @ B @ C @ A3 @ B6 @ F @ G )
     => ( ( A3 @ X6 @ X6 )
       => ( B6 @ ( F @ X6 ) @ ( G @ X6 ) ) ) ) )).

% rel_funD2
thf(fact_184_fun_Orel__transfer,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E2: $tType,D: $tType,Sa: ( A > C > $o ),Sc: ( B > E2 > $o )] :
      ( bNF_rel_fun @ ( A > B > $o ) @ ( C > E2 > $o ) @ ( ( D > A ) > ( D > B ) > $o ) @ ( ( D > C ) > ( D > E2 ) > $o )
      @ ( bNF_rel_fun @ A @ C @ ( B > $o ) @ ( E2 > $o ) @ Sa
        @ ( bNF_rel_fun @ B @ E2 @ $o @ $o @ Sc
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
      @ ( bNF_rel_fun @ ( D > A ) @ ( D > C ) @ ( ( D > B ) > $o ) @ ( ( D > E2 ) > $o )
        @ ( bNF_rel_fun @ D @ D @ A @ C
          @ ^ [Y4: D,Z: D] : ( Y4 = Z )
          @ Sa )
        @ ( bNF_rel_fun @ ( D > B ) @ ( D > E2 ) @ $o @ $o
          @ ( bNF_rel_fun @ D @ D @ B @ E2
            @ ^ [Y4: D,Z: D] : ( Y4 = Z )
            @ Sc )
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
      @ ( bNF_rel_fun @ D @ D @ A @ B
        @ ^ [Y4: D,Z: D] : ( Y4 = Z ) )
      @ ( bNF_rel_fun @ D @ D @ C @ E2
        @ ^ [Y4: D,Z: D] : ( Y4 = Z ) ) ) )).

% fun.rel_transfer
thf(fact_185_process_Ocase__transfer,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R3: ( A > B > $o ),S4: ( C > D > $o )] :
      ( bNF_rel_fun @ ( A > ( proces634752977rocess @ A ) > C ) @ ( B > ( proces634752977rocess @ B ) > D ) @ ( ( ( proces634752977rocess @ A ) > ( proces634752977rocess @ A ) > C ) > ( proces634752977rocess @ A ) > C ) @ ( ( ( proces634752977rocess @ B ) > ( proces634752977rocess @ B ) > D ) > ( proces634752977rocess @ B ) > D ) @ ( bNF_rel_fun @ A @ B @ ( ( proces634752977rocess @ A ) > C ) @ ( ( proces634752977rocess @ B ) > D ) @ R3 @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ C @ D @ ( proces749077512rocess @ A @ B @ R3 ) @ S4 ) ) @ ( bNF_rel_fun @ ( ( proces634752977rocess @ A ) > ( proces634752977rocess @ A ) > C ) @ ( ( proces634752977rocess @ B ) > ( proces634752977rocess @ B ) > D ) @ ( ( proces634752977rocess @ A ) > C ) @ ( ( proces634752977rocess @ B ) > D ) @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ ( ( proces634752977rocess @ A ) > C ) @ ( ( proces634752977rocess @ B ) > D ) @ ( proces749077512rocess @ A @ B @ R3 ) @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ C @ D @ ( proces749077512rocess @ A @ B @ R3 ) @ S4 ) ) @ ( bNF_rel_fun @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ C @ D @ ( proces749077512rocess @ A @ B @ R3 ) @ S4 ) ) @ ( proces1406508781rocess @ A @ C ) @ ( proces1406508781rocess @ B @ D ) ) )).

% process.case_transfer
thf(fact_186_Collect__empty__eq__bot,axiom,(
    ! [A: $tType,P: ( A > $o )] :
      ( ( ( collect @ A @ P )
        = ( bot_bot @ ( set @ A ) ) )
      = ( P
        = ( bot_bot @ ( A > $o ) ) ) ) )).

% Collect_empty_eq_bot
thf(fact_187_fun_Orel__refl,axiom,(
    ! [B: $tType,D: $tType,Ra: ( B > B > $o ),X6: ( D > B )] :
      ( ! [X4: B] :
          ( Ra @ X4 @ X4 )
     => ( bNF_rel_fun @ D @ D @ B @ B
        @ ^ [Y4: D,Z: D] : ( Y4 = Z )
        @ Ra
        @ X6
        @ X6 ) ) )).

% fun.rel_refl
thf(fact_188_fun_Orel__eq,axiom,(
    ! [A: $tType,D: $tType] :
      ( ( bNF_rel_fun @ D @ D @ A @ A
        @ ^ [Y4: D,Z: D] : ( Y4 = Z )
        @ ^ [Y4: A,Z: A] : ( Y4 = Z ) )
      = ( ^ [Y4: ( D > A ),Z: ( D > A )] : ( Y4 = Z ) ) ) )).

% fun.rel_eq
thf(fact_189_bot__empty__eq,axiom,(
    ! [A: $tType] :
      ( ( bot_bot @ ( A > $o ) )
      = ( ^ [X3: A] :
            ( member @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) )).

% bot_empty_eq
thf(fact_190_map__fun__parametric,axiom,(
    ! [A: $tType,B: $tType,E2: $tType,F5: $tType,H: $tType,G3: $tType,D: $tType,C: $tType,A3: ( A > C > $o ),B6: ( B > D > $o ),C5: ( E2 > G3 > $o ),D4: ( F5 > H > $o )] :
      ( bNF_rel_fun @ ( A > B ) @ ( C > D ) @ ( ( E2 > F5 ) > ( B > E2 ) > A > F5 ) @ ( ( G3 > H ) > ( D > G3 ) > C > H ) @ ( bNF_rel_fun @ A @ C @ B @ D @ A3 @ B6 ) @ ( bNF_rel_fun @ ( E2 > F5 ) @ ( G3 > H ) @ ( ( B > E2 ) > A > F5 ) @ ( ( D > G3 ) > C > H ) @ ( bNF_rel_fun @ E2 @ G3 @ F5 @ H @ C5 @ D4 ) @ ( bNF_rel_fun @ ( B > E2 ) @ ( D > G3 ) @ ( A > F5 ) @ ( C > H ) @ ( bNF_rel_fun @ B @ D @ E2 @ G3 @ B6 @ C5 ) @ ( bNF_rel_fun @ A @ C @ F5 @ H @ A3 @ D4 ) ) ) @ ( map_fun @ A @ B @ E2 @ F5 ) @ ( map_fun @ C @ D @ G3 @ H ) ) )).

% map_fun_parametric
thf(fact_191_prod__set__simps_I1_J,axiom,(
    ! [B: $tType,A: $tType,X6: A,Y3: B] :
      ( ( basic_fsts @ A @ B @ ( product_Pair @ A @ B @ X6 @ Y3 ) )
      = ( insert @ A @ X6 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% prod_set_simps(1)
thf(fact_192_prod__set__simps_I2_J,axiom,(
    ! [A: $tType,B: $tType,X6: A,Y3: B] :
      ( ( basic_snds @ A @ B @ ( product_Pair @ A @ B @ X6 @ Y3 ) )
      = ( insert @ B @ Y3 @ ( bot_bot @ ( set @ B ) ) ) ) )).

% prod_set_simps(2)
thf(fact_193_Set_Ois__empty__def,axiom,(
    ! [A: $tType] :
      ( ( is_empty @ A )
      = ( ^ [A6: ( set @ A )] :
            ( A6
            = ( bot_bot @ ( set @ A ) ) ) ) ) )).

% Set.is_empty_def
thf(fact_194_prod_Opred__set,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( basic_pred_prod @ A @ B )
      = ( ^ [P12: ( A > $o ),P22: ( B > $o ),X3: ( product_prod @ A @ B )] :
            ( ! [Y6: A] :
                ( ( member @ A @ Y6 @ ( basic_fsts @ A @ B @ X3 ) )
               => ( P12 @ Y6 ) )
            & ! [Y6: B] :
                ( ( member @ B @ Y6 @ ( basic_snds @ A @ B @ X3 ) )
               => ( P22 @ Y6 ) ) ) ) ) )).

% prod.pred_set
thf(fact_195_pred__prod__inject,axiom,(
    ! [A: $tType,B: $tType,P1: ( A > $o ),P2: ( B > $o ),A2: A,B2: B] :
      ( ( basic_pred_prod @ A @ B @ P1 @ P2 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( ( P1 @ A2 )
        & ( P2 @ B2 ) ) ) )).

% pred_prod_inject
thf(fact_196_pred__prod_Ocases,axiom,(
    ! [A: $tType,B: $tType,P1: ( A > $o ),P2: ( B > $o ),A2: ( product_prod @ A @ B )] :
      ( ( basic_pred_prod @ A @ B @ P1 @ P2 @ A2 )
     => ~ ( ! [A4: A,B4: B] :
              ( ( A2
                = ( product_Pair @ A @ B @ A4 @ B4 ) )
             => ( ( P1 @ A4 )
               => ~ ( P2 @ B4 ) ) ) ) ) )).

% pred_prod.cases
thf(fact_197_pred__prod_Osimps,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( basic_pred_prod @ A @ B )
      = ( ^ [P12: ( A > $o ),P22: ( B > $o ),A7: ( product_prod @ A @ B )] :
          ? [B5: A,C6: B] :
            ( ( A7
              = ( product_Pair @ A @ B @ B5 @ C6 ) )
            & ( P12 @ B5 )
            & ( P22 @ C6 ) ) ) ) )).

% pred_prod.simps
thf(fact_198_pred__prod_Ointros,axiom,(
    ! [A: $tType,B: $tType,P1: ( A > $o ),A2: A,P2: ( B > $o ),B2: B] :
      ( ( P1 @ A2 )
     => ( ( P2 @ B2 )
       => ( basic_pred_prod @ A @ B @ P1 @ P2 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) ) )).

% pred_prod.intros
thf(fact_199_pred__prod_Oinducts,axiom,(
    ! [B: $tType,A: $tType,P1: ( A > $o ),P2: ( B > $o ),X6: ( product_prod @ A @ B ),P: ( ( product_prod @ A @ B ) > $o )] :
      ( ( basic_pred_prod @ A @ B @ P1 @ P2 @ X6 )
     => ( ! [A4: A,B4: B] :
            ( ( P1 @ A4 )
           => ( ( P2 @ B4 )
             => ( P @ ( product_Pair @ A @ B @ A4 @ B4 ) ) ) )
       => ( P @ X6 ) ) ) )).

% pred_prod.inducts
thf(fact_200_pred__prod__split,axiom,(
    ! [B: $tType,A: $tType,P: ( $o > $o ),Q: ( A > $o ),R3: ( B > $o ),Xy: ( product_prod @ A @ B )] :
      ( ( P @ ( basic_pred_prod @ A @ B @ Q @ R3 @ Xy ) )
      = ( ! [X3: A,Y6: B] :
            ( ( Xy
              = ( product_Pair @ A @ B @ X3 @ Y6 ) )
           => ( P
              @ ( ( Q @ X3 )
                & ( R3 @ Y6 ) ) ) ) ) ) )).

% pred_prod_split
thf(fact_201_if__rsp,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( bNF_rel_fun @ $o @ $o @ ( A > A > A ) @ ( A > A > A )
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z )
        @ ( bNF_rel_fun @ A @ A @ ( A > A ) @ ( A > A ) @ R3 @ ( bNF_rel_fun @ A @ A @ A @ A @ R3 @ R3 ) )
        @ ( if @ A )
        @ ( if @ A ) ) ) )).

% if_rsp
thf(fact_202_fun__quotient3,axiom,(
    ! [A: $tType,B: $tType,C: $tType,D: $tType,R1: ( A > A > $o ),Abs1: ( A > B ),Rep1: ( B > A ),R2: ( C > C > $o ),Abs2: ( C > D ),Rep2: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs1 @ Rep1 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs2 @ Rep2 )
       => ( quotient3 @ ( A > C ) @ ( B > D ) @ ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 ) @ ( map_fun @ B @ A @ C @ D @ Rep1 @ Abs2 ) @ ( map_fun @ A @ B @ D @ C @ Abs1 @ Rep2 ) ) ) ) )).

% fun_quotient3
thf(fact_203_apply__rspQ3_H_H,axiom,(
    ! [C: $tType,A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),S4: ( C > C > $o ),F: ( A > C ),X6: B] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R3 @ S4 @ F @ F )
       => ( S4 @ ( F @ ( Rep @ X6 ) ) @ ( F @ ( Rep @ X6 ) ) ) ) ) )).

% apply_rspQ3''
thf(fact_204_apply__rspQ3,axiom,(
    ! [B: $tType,C: $tType,A: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),F: ( A > C ),G: ( A > C ),X6: A,Y3: A] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( bNF_rel_fun @ A @ A @ C @ C @ R1 @ R2 @ F @ G )
       => ( ( R1 @ X6 @ Y3 )
         => ( R2 @ ( F @ X6 ) @ ( G @ Y3 ) ) ) ) ) )).

% apply_rspQ3
thf(fact_205_quot__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A )] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( bNF_rel_fun @ A @ A @ ( A > $o ) @ ( A > $o ) @ R3
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R3
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
        @ R3
        @ R3 ) ) )).

% quot_rel_rsp
thf(fact_206_let__prs,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,R1: ( A > A > $o ),Abs12: ( A > B ),Rep12: ( B > A ),R2: ( C > C > $o ),Abs22: ( C > D ),Rep22: ( D > C )] :
      ( ( quotient3 @ A @ B @ R1 @ Abs12 @ Rep12 )
     => ( ( quotient3 @ C @ D @ R2 @ Abs22 @ Rep22 )
       => ( ( map_fun @ D @ C @ ( ( C > A ) > A ) @ ( ( D > B ) > B ) @ Rep22 @ ( map_fun @ ( D > B ) @ ( C > A ) @ A @ B @ ( map_fun @ C @ D @ B @ A @ Abs22 @ Rep12 ) @ Abs12 )
            @ ^ [S3: C,F7: ( C > A )] :
                ( F7 @ S3 ) )
          = ( ^ [S3: D,F7: ( D > B )] :
                ( F7 @ S3 ) ) ) ) ) )).

% let_prs
thf(fact_207_cond__prs,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A ),A2: $o,B2: B,C3: B] :
      ( ( quotient3 @ A @ B @ R3 @ Absf @ Repf )
     => ( ( A2
         => ( ( Absf @ ( if @ A @ A2 @ ( Repf @ B2 ) @ ( Repf @ C3 ) ) )
            = B2 ) )
        & ( ~ ( A2 )
         => ( ( Absf @ ( if @ A @ A2 @ ( Repf @ B2 ) @ ( Repf @ C3 ) ) )
            = C3 ) ) ) ) )).

% cond_prs
thf(fact_208_Quotient3I,axiom,(
    ! [B: $tType,A: $tType,Abs: ( B > A ),Rep: ( A > B ),R3: ( B > B > $o )] :
      ( ! [A4: A] :
          ( ( Abs @ ( Rep @ A4 ) )
          = A4 )
     => ( ! [A4: A] :
            ( R3 @ ( Rep @ A4 ) @ ( Rep @ A4 ) )
       => ( ! [R4: B,S5: B] :
              ( ( R3 @ R4 @ S5 )
              = ( ( R3 @ R4 @ R4 )
                & ( R3 @ S5 @ S5 )
                & ( ( Abs @ R4 )
                  = ( Abs @ S5 ) ) ) )
         => ( quotient3 @ B @ A @ R3 @ Abs @ Rep ) ) ) ) )).

% Quotient3I
thf(fact_209_equals__rsp,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),Xa2: A,Xb: A,Ya2: A,Yb2: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ Xa2 @ Xb )
       => ( ( R3 @ Ya2 @ Yb2 )
         => ( ( R3 @ Xa2 @ Ya2 )
            = ( R3 @ Xb @ Yb2 ) ) ) ) ) )).

% equals_rsp
thf(fact_210_rep__abs__rsp,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X2: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ X1 @ X2 )
       => ( R3 @ X1 @ ( Rep @ ( Abs @ X2 ) ) ) ) ) )).

% rep_abs_rsp
thf(fact_211_Quotient3__def,axiom,(
    ! [B: $tType,A: $tType] :
      ( ( quotient3 @ A @ B )
      = ( ^ [R5: ( A > A > $o ),Abs3: ( A > B ),Rep3: ( B > A )] :
            ( ! [A7: B] :
                ( ( Abs3 @ ( Rep3 @ A7 ) )
                = A7 )
            & ! [A7: B] :
                ( R5 @ ( Rep3 @ A7 ) @ ( Rep3 @ A7 ) )
            & ! [R6: A,S3: A] :
                ( ( R5 @ R6 @ S3 )
                = ( ( R5 @ R6 @ R6 )
                  & ( R5 @ S3 @ S3 )
                  & ( ( Abs3 @ R6 )
                    = ( Abs3 @ S3 ) ) ) ) ) ) ) )).

% Quotient3_def
thf(fact_212_Quotient3__rel,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R: A,S: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( ( R3 @ R @ R )
          & ( R3 @ S @ S )
          & ( ( Abs @ R )
            = ( Abs @ S ) ) )
        = ( R3 @ R @ S ) ) ) )).

% Quotient3_rel
thf(fact_213_Quotient3__refl1,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R: A,S: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ R @ S )
       => ( R3 @ R @ R ) ) ) )).

% Quotient3_refl1
thf(fact_214_Quotient3__refl2,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R: A,S: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ R @ S )
       => ( R3 @ S @ S ) ) ) )).

% Quotient3_refl2
thf(fact_215_rep__abs__rsp__left,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),X1: A,X2: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ X1 @ X2 )
       => ( R3 @ ( Rep @ ( Abs @ X1 ) ) @ X2 ) ) ) )).

% rep_abs_rsp_left
thf(fact_216_Quotient3__abs__rep,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A2: B] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( Abs @ ( Rep @ A2 ) )
        = A2 ) ) )).

% Quotient3_abs_rep
thf(fact_217_Quotient3__rel__abs,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R: A,S: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ R @ S )
       => ( ( Abs @ R )
          = ( Abs @ S ) ) ) ) )).

% Quotient3_rel_abs
thf(fact_218_Quotient3__rel__rep,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A2: B,B2: B] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ ( Rep @ A2 ) @ ( Rep @ B2 ) )
        = ( A2 = B2 ) ) ) )).

% Quotient3_rel_rep
thf(fact_219_Quotient3__rep__abs,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),R: A] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( ( R3 @ R @ R )
       => ( R3 @ ( Rep @ ( Abs @ R ) ) @ R ) ) ) )).

% Quotient3_rep_abs
thf(fact_220_Quotient3__rep__reflp,axiom,(
    ! [A: $tType,B: $tType,R3: ( A > A > $o ),Abs: ( A > B ),Rep: ( B > A ),A2: B] :
      ( ( quotient3 @ A @ B @ R3 @ Abs @ Rep )
     => ( R3 @ ( Rep @ A2 ) @ ( Rep @ A2 ) ) ) )).

% Quotient3_rep_reflp
thf(fact_221_apply__rsp_H,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > B > $o ),R2: ( C > D > $o ),F: ( A > C ),G: ( B > D ),X6: A,Y3: B] :
      ( ( bNF_rel_fun @ A @ B @ C @ D @ R1 @ R2 @ F @ G )
     => ( ( R1 @ X6 @ Y3 )
       => ( R2 @ ( F @ X6 ) @ ( G @ Y3 ) ) ) ) )).

% apply_rsp'
thf(fact_222_process_Ocorec__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,S4: ( C > D > $o ),R3: ( A > B > $o )] :
      ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > A ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > B ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) )
      @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S4
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
      @ ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ A @ B @ S4 @ R3 )
        @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) )
          @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S4
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
          @ ( bNF_rel_fun @ ( C > ( proces634752977rocess @ A ) ) @ ( D > ( proces634752977rocess @ B ) ) @ ( ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ S4 @ ( proces749077512rocess @ A @ B @ R3 ) )
            @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S4 @ S4 )
              @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) )
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S4
                  @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
                @ ( bNF_rel_fun @ ( C > ( proces634752977rocess @ A ) ) @ ( D > ( proces634752977rocess @ B ) ) @ ( ( C > C ) > ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > D ) > ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ S4 @ ( proces749077512rocess @ A @ B @ R3 ) )
                  @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( ( C > $o ) > ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > $o ) > ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S4 @ S4 )
                    @ ( bNF_rel_fun @ ( C > $o ) @ ( D > $o ) @ ( ( C > ( proces634752977rocess @ A ) ) > ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > ( proces634752977rocess @ B ) ) > ( D > D ) > D > ( proces634752977rocess @ B ) )
                      @ ( bNF_rel_fun @ C @ D @ $o @ $o @ S4
                        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
                      @ ( bNF_rel_fun @ ( C > ( proces634752977rocess @ A ) ) @ ( D > ( proces634752977rocess @ B ) ) @ ( ( C > C ) > C > ( proces634752977rocess @ A ) ) @ ( ( D > D ) > D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ S4 @ ( proces749077512rocess @ A @ B @ R3 ) ) @ ( bNF_rel_fun @ ( C > C ) @ ( D > D ) @ ( C > ( proces634752977rocess @ A ) ) @ ( D > ( proces634752977rocess @ B ) ) @ ( bNF_rel_fun @ C @ D @ C @ D @ S4 @ S4 ) @ ( bNF_rel_fun @ C @ D @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ S4 @ ( proces749077512rocess @ A @ B @ R3 ) ) ) ) ) ) ) ) ) ) ) )
      @ ( proces894737309rocess @ C @ A )
      @ ( proces894737309rocess @ D @ B ) ) )).

% process.corec_transfer
thf(fact_223_bex1__rel__rsp,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > A > $o ),Absf: ( A > B ),Repf: ( B > A )] :
      ( ( quotient3 @ A @ B @ R3 @ Absf @ Repf )
     => ( bNF_rel_fun @ ( A > $o ) @ ( A > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ A @ $o @ $o @ R3
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z )
        @ ( bex1_rel @ A @ R3 )
        @ ( bex1_rel @ A @ R3 ) ) ) )).

% bex1_rel_rsp
thf(fact_224_bex1__rel__aux2,axiom,(
    ! [A: $tType,R3: ( A > A > $o ),X6: ( A > $o ),Y3: ( A > $o )] :
      ( ! [Xa: A,Ya: A] :
          ( ( R3 @ Xa @ Ya )
         => ( ( X6 @ Xa )
            = ( Y3 @ Ya ) ) )
     => ( ( bex1_rel @ A @ R3 @ Y3 )
       => ( bex1_rel @ A @ R3 @ X6 ) ) ) )).

% bex1_rel_aux2
thf(fact_225_bex1__rel__aux,axiom,(
    ! [A: $tType,R3: ( A > A > $o ),X6: ( A > $o ),Y3: ( A > $o )] :
      ( ! [Xa: A,Ya: A] :
          ( ( R3 @ Xa @ Ya )
         => ( ( X6 @ Xa )
            = ( Y3 @ Ya ) ) )
     => ( ( bex1_rel @ A @ R3 @ X6 )
       => ( bex1_rel @ A @ R3 @ Y3 ) ) ) )).

% bex1_rel_aux
thf(fact_226_pairwise__singleton,axiom,(
    ! [A: $tType,P: ( A > A > $o ),A3: A] :
      ( pairwise @ A @ P @ ( insert @ A @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) )).

% pairwise_singleton
thf(fact_227_fun__ord__parametric,axiom,(
    ! [C: $tType,D: $tType,A: $tType,B: $tType,F5: $tType,E2: $tType,C5: ( A > B > $o ),A3: ( C > E2 > $o ),B6: ( D > F5 > $o )] :
      ( ( bi_total @ A @ B @ C5 )
     => ( bNF_rel_fun @ ( C > D > $o ) @ ( E2 > F5 > $o ) @ ( ( A > C ) > ( A > D ) > $o ) @ ( ( B > E2 ) > ( B > F5 ) > $o )
        @ ( bNF_rel_fun @ C @ E2 @ ( D > $o ) @ ( F5 > $o ) @ A3
          @ ( bNF_rel_fun @ D @ F5 @ $o @ $o @ B6
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > C ) @ ( B > E2 ) @ ( ( A > D ) > $o ) @ ( ( B > F5 ) > $o ) @ ( bNF_rel_fun @ A @ B @ C @ E2 @ C5 @ A3 )
          @ ( bNF_rel_fun @ ( A > D ) @ ( B > F5 ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ D @ F5 @ C5 @ B6 )
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( partial_fun_ord @ C @ D @ A )
        @ ( partial_fun_ord @ E2 @ F5 @ B ) ) ) )).

% fun_ord_parametric
thf(fact_228_pairwise__empty,axiom,(
    ! [A: $tType,P: ( A > A > $o )] :
      ( pairwise @ A @ P @ ( bot_bot @ ( set @ A ) ) ) )).

% pairwise_empty
thf(fact_229_pairwise__insert,axiom,(
    ! [A: $tType,R: ( A > A > $o ),X6: A,S: ( set @ A )] :
      ( ( pairwise @ A @ R @ ( insert @ A @ X6 @ S ) )
      = ( ! [Y6: A] :
            ( ( ( member @ A @ Y6 @ S )
              & ( Y6 != X6 ) )
           => ( ( R @ X6 @ Y6 )
              & ( R @ Y6 @ X6 ) ) )
        & ( pairwise @ A @ R @ S ) ) ) )).

% pairwise_insert
thf(fact_230_process__term_Obi__total__rel,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( ( bi_total @ A @ C @ R1 )
     => ( ( bi_total @ B @ D @ R2 )
       => ( bi_total @ ( proces554692349s_term @ A @ B ) @ ( proces554692349s_term @ C @ D ) @ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 ) ) ) ) )).

% process_term.bi_total_rel
thf(fact_231_process_Obi__total__rel,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ R3 )
     => ( bi_total @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ ( proces749077512rocess @ A @ B @ R3 ) ) ) )).

% process.bi_total_rel
thf(fact_232_pairwise__def,axiom,(
    ! [A: $tType] :
      ( ( pairwise @ A )
      = ( ^ [R5: ( A > A > $o ),S6: ( set @ A )] :
          ! [X3: A] :
            ( ( member @ A @ X3 @ S6 )
           => ! [Y6: A] :
                ( ( member @ A @ Y6 @ S6 )
               => ( ( X3 != Y6 )
                 => ( R5 @ X3 @ Y6 ) ) ) ) ) ) )).

% pairwise_def
thf(fact_233_monotone__parametric,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,A3: ( A > B > $o ),B6: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ ( ( C > C > $o ) > ( A > C ) > $o ) @ ( ( D > D > $o ) > ( B > D ) > $o )
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( bNF_rel_fun @ ( C > C > $o ) @ ( D > D > $o ) @ ( ( A > C ) > $o ) @ ( ( B > D ) > $o )
          @ ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B6
            @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B6
              @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
          @ ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A3 @ B6 )
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( comple1396247847notone @ A @ C )
        @ ( comple1396247847notone @ B @ D ) ) ) )).

% monotone_parametric
thf(fact_234_transfer__forall__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z )
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(1)
thf(fact_235_transfer__forall__transfer_I4_J,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
        @ rev_implies
        @ ( transfer_forall @ A )
        @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(4)
thf(fact_236_transfer__forall__transfer_I5_J,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > $o ) @ ( B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3 @ rev_implies ) @ rev_implies @ ( transfer_forall @ A ) @ ( transfer_forall @ B ) ) ) )).

% transfer_forall_transfer(5)
thf(fact_237_relcompp__transfer,axiom,(
    ! [C: $tType,A: $tType,E2: $tType,F5: $tType,B: $tType,D: $tType,B6: ( A > B > $o ),A3: ( C > D > $o ),C5: ( E2 > F5 > $o )] :
      ( ( bi_total @ A @ B @ B6 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( ( A > E2 > $o ) > C > E2 > $o ) @ ( ( B > F5 > $o ) > D > F5 > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B6
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( bNF_rel_fun @ ( A > E2 > $o ) @ ( B > F5 > $o ) @ ( C > E2 > $o ) @ ( D > F5 > $o )
          @ ( bNF_rel_fun @ A @ B @ ( E2 > $o ) @ ( F5 > $o ) @ B6
            @ ( bNF_rel_fun @ E2 @ F5 @ $o @ $o @ C5
              @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
          @ ( bNF_rel_fun @ C @ D @ ( E2 > $o ) @ ( F5 > $o ) @ A3
            @ ( bNF_rel_fun @ E2 @ F5 @ $o @ $o @ C5
              @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) ) )
        @ ( relcompp @ C @ A @ E2 )
        @ ( relcompp @ D @ B @ F5 ) ) ) )).

% relcompp_transfer
thf(fact_238_Domainp__transfer,axiom,(
    ! [C: $tType,A: $tType,B: $tType,D: $tType,B6: ( A > B > $o ),A3: ( C > D > $o )] :
      ( ( bi_total @ A @ B @ B6 )
     => ( bNF_rel_fun @ ( C > A > $o ) @ ( D > B > $o ) @ ( C > $o ) @ ( D > $o )
        @ ( bNF_rel_fun @ C @ D @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ B6
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ( bNF_rel_fun @ C @ D @ $o @ $o @ A3
          @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) )
        @ ( domainp @ C @ A )
        @ ( domainp @ D @ B ) ) ) )).

% Domainp_transfer
thf(fact_239_relcompp__bot1,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R3: ( C > B > $o )] :
      ( ( relcompp @ A @ C @ B @ ( bot_bot @ ( A > C > $o ) ) @ R3 )
      = ( bot_bot @ ( A > B > $o ) ) ) )).

% relcompp_bot1
thf(fact_240_relcompp__bot2,axiom,(
    ! [C: $tType,B: $tType,A: $tType,R3: ( A > C > $o )] :
      ( ( relcompp @ A @ C @ B @ R3 @ ( bot_bot @ ( C > B > $o ) ) )
      = ( bot_bot @ ( A > B > $o ) ) ) )).

% relcompp_bot2
thf(fact_241_eq__comp__r,axiom,(
    ! [A: $tType,R3: ( A > A > $o )] :
      ( ( relcompp @ A @ A @ A
        @ ^ [Y4: A,Z: A] : ( Y4 = Z )
        @ ( relcompp @ A @ A @ A @ R3
          @ ^ [Y4: A,Z: A] : ( Y4 = Z ) ) )
      = R3 ) )).

% eq_comp_r
thf(fact_242_process__term_ODomainp__rel,axiom,(
    ! [A: $tType,C: $tType,D: $tType,B: $tType,R1: ( A > C > $o ),R2: ( B > D > $o )] :
      ( ( domainp @ ( proces554692349s_term @ A @ B ) @ ( proces554692349s_term @ C @ D ) @ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 ) )
      = ( proces2118920028s_term @ A @ B @ ( domainp @ A @ C @ R1 ) @ ( domainp @ B @ D @ R2 ) ) ) )).

% process_term.Domainp_rel
thf(fact_243_process_ODomainp__rel,axiom,(
    ! [B: $tType,A: $tType,R3: ( A > B > $o )] :
      ( ( domainp @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ ( proces749077512rocess @ A @ B @ R3 ) )
      = ( proces1205983068rocess @ A @ ( domainp @ A @ B @ R3 ) ) ) )).

% process.Domainp_rel
thf(fact_244_process_Orel__compp,axiom,(
    ! [A: $tType,C: $tType,B: $tType,R3: ( A > B > $o ),S4: ( B > C > $o )] :
      ( ( proces749077512rocess @ A @ C @ ( relcompp @ A @ B @ C @ R3 @ S4 ) )
      = ( relcompp @ ( proces634752977rocess @ A ) @ ( proces634752977rocess @ B ) @ ( proces634752977rocess @ C ) @ ( proces749077512rocess @ A @ B @ R3 ) @ ( proces749077512rocess @ B @ C @ S4 ) ) ) )).

% process.rel_compp
thf(fact_245_process__term_Orel__compp,axiom,(
    ! [B: $tType,A: $tType,C: $tType,E2: $tType,F5: $tType,D: $tType,R1: ( A > C > $o ),S1: ( C > E2 > $o ),R2: ( B > D > $o ),S22: ( D > F5 > $o )] :
      ( ( proces2029722208s_term @ A @ E2 @ B @ F5 @ ( relcompp @ A @ C @ E2 @ R1 @ S1 ) @ ( relcompp @ B @ D @ F5 @ R2 @ S22 ) )
      = ( relcompp @ ( proces554692349s_term @ A @ B ) @ ( proces554692349s_term @ C @ D ) @ ( proces554692349s_term @ E2 @ F5 ) @ ( proces2029722208s_term @ A @ C @ B @ D @ R1 @ R2 ) @ ( proces2029722208s_term @ C @ E2 @ D @ F5 @ S1 @ S22 ) ) ) )).

% process_term.rel_compp
thf(fact_246_nchotomy__relcomppE,axiom,(
    ! [C: $tType,B: $tType,A: $tType,D: $tType,F: ( B > A ),R: ( C > A > $o ),S: ( A > D > $o ),A2: C,C3: D] :
      ( ! [Y5: A] :
        ? [X7: B] :
          ( Y5
          = ( F @ X7 ) )
     => ( ( relcompp @ C @ A @ D @ R @ S @ A2 @ C3 )
       => ~ ( ! [B4: B] :
                ( ( R @ A2 @ ( F @ B4 ) )
               => ~ ( S @ ( F @ B4 ) @ C3 ) ) ) ) ) )).

% nchotomy_relcomppE
thf(fact_247_fun_Orel__compp,axiom,(
    ! [A: $tType,D: $tType,C: $tType,B: $tType,R3: ( A > B > $o ),S4: ( B > C > $o )] :
      ( ( bNF_rel_fun @ D @ D @ A @ C
        @ ^ [Y4: D,Z: D] : ( Y4 = Z )
        @ ( relcompp @ A @ B @ C @ R3 @ S4 ) )
      = ( relcompp @ ( D > A ) @ ( D > B ) @ ( D > C )
        @ ( bNF_rel_fun @ D @ D @ A @ B
          @ ^ [Y4: D,Z: D] : ( Y4 = Z )
          @ R3 )
        @ ( bNF_rel_fun @ D @ D @ B @ C
          @ ^ [Y4: D,Z: D] : ( Y4 = Z )
          @ S4 ) ) ) )).

% fun.rel_compp
thf(fact_248_reflp__transfer_I5_J,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ rev_implies
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(5)
thf(fact_249_reflp__transfer_I4_J,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A3 @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3 @ rev_implies ) ) @ rev_implies @ ( reflp @ A ) @ ( reflp @ B ) ) ) )).

% reflp_transfer(4)
thf(fact_250_fun_Orel__reflp,axiom,(
    ! [D: $tType,A: $tType,R3: ( A > A > $o )] :
      ( ( reflp @ A @ R3 )
     => ( reflp @ ( D > A )
        @ ( bNF_rel_fun @ D @ D @ A @ A
          @ ^ [Y4: D,Z: D] : ( Y4 = Z )
          @ R3 ) ) ) )).

% fun.rel_reflp
thf(fact_251_bot2E,axiom,(
    ! [A: $tType,B: $tType,X6: A,Y3: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X6 @ Y3 ) )).

% bot2E
thf(fact_252_process__term_Orel__reflp,axiom,(
    ! [A: $tType,B: $tType,R1: ( A > A > $o ),R2: ( B > B > $o )] :
      ( ( reflp @ A @ R1 )
     => ( ( reflp @ B @ R2 )
       => ( reflp @ ( proces554692349s_term @ A @ B ) @ ( proces2029722208s_term @ A @ A @ B @ B @ R1 @ R2 ) ) ) ) )).

% process_term.rel_reflp
thf(fact_253_process_Orel__reflp,axiom,(
    ! [A: $tType,R3: ( A > A > $o )] :
      ( ( reflp @ A @ R3 )
     => ( reflp @ ( proces634752977rocess @ A ) @ ( proces749077512rocess @ A @ A @ R3 ) ) ) )).

% process.rel_reflp
thf(fact_254_reflp__transfer_I1_J,axiom,(
    ! [A: $tType,B: $tType,A3: ( A > B > $o )] :
      ( ( bi_total @ A @ B @ A3 )
     => ( bNF_rel_fun @ ( A > A > $o ) @ ( B > B > $o ) @ $o @ $o
        @ ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A3
          @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A3
            @ ^ [Y4: $o,Z: $o] : ( Y4 = Z ) ) )
        @ ^ [Y4: $o,Z: $o] : ( Y4 = Z )
        @ ( reflp @ A )
        @ ( reflp @ B ) ) ) )).

% reflp_transfer(1)

%----Type constructors (3)
thf(tcon_fun___Orderings_Obot,axiom,(
    ! [A8: $tType,A9: $tType] :
      ( ( bot @ A9 @ ( type2 @ A9 ) )
     => ( bot @ ( A8 > A9 ) @ ( type2 @ ( A8 > A9 ) ) ) ) )).

thf(tcon_Set_Oset___Orderings_Obot_1,axiom,(
    ! [A8: $tType] :
      ( bot @ ( set @ A8 ) @ ( type2 @ ( set @ A8 ) ) ) )).

thf(tcon_HOL_Obool___Orderings_Obot_2,axiom,
    ( bot @ $o @ ( type2 @ $o ) )).

%----Helper facts (3)
thf(help_If_3_1_T,axiom,(
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) )).

thf(help_If_2_1_T,axiom,(
    ! [A: $tType,X6: A,Y3: A] :
      ( ( if @ A @ $false @ X6 @ Y3 )
      = Y3 ) )).

thf(help_If_1_1_T,axiom,(
    ! [A: $tType,X6: A,Y3: A] :
      ( ( if @ A @ $true @ X6 @ Y3 )
      = X6 ) )).

%----Conjectures (1)
thf(conj_0,conjecture,
    ( ( proces687458811_isACT @ a @ b @ a @ c @ sys @ ( proces1627516585ss_VAR @ a @ c @ x ) )
    = ( proces687458811_isACT @ a @ b @ a @ b @ sys @ ( sys @ x ) ) )).

%------------------------------------------------------------------------------
